// DO NOT EDIT. This file is auto-generated by `amalgamate.py`.

#include "Zydis.h"


//
// Source file: /home/ath/devel/zydis/src/Decoder.c
//

/***************************************************************************************************

  Zyan Disassembler Library (Zydis)

  Original Author : Florian Bernd

 * Permission is hereby granted, free of charge, to any person obtaining a copy
 * of this software and associated documentation files (the "Software"), to deal
 * in the Software without restriction, including without limitation the rights
 * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
 * copies of the Software, and to permit persons to whom the Software is
 * furnished to do so, subject to the following conditions:
 *
 * The above copyright notice and this permission notice shall be included in all
 * copies or substantial portions of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
 * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
 * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
 * SOFTWARE.

***************************************************************************************************/

// ReSharper disable CppClangTidyClangDiagnosticImplicitFallthrough
// ReSharper disable CppClangTidyClangDiagnosticSwitchEnum
// ReSharper disable CppClangTidyClangDiagnosticCoveredSwitchDefault

// Temporarily disabled due to a LLVM issue:
// ReSharper disable CppClangTidyBugproneNarrowingConversions


//
// Header: Zycore/LibC.h
//

/***************************************************************************************************

  Zyan Core Library (Zycore-C)

  Original Author : Florian Bernd, Joel Hoener

 * Permission is hereby granted, free of charge, to any person obtaining a copy
 * of this software and associated documentation files (the "Software"), to deal
 * in the Software without restriction, including without limitation the rights
 * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
 * copies of the Software, and to permit persons to whom the Software is
 * furnished to do so, subject to the following conditions:
 *
 * The above copyright notice and this permission notice shall be included in all
 * copies or substantial portions of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
 * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
 * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
 * SOFTWARE.

***************************************************************************************************/

/**
 * @file
 * Provides a simple LibC abstraction and fallback routines.
 */

#ifndef ZYCORE_LIBC_H
#define ZYCORE_LIBC_H

#ifndef ZYAN_CUSTOM_LIBC

// Include a custom LibC header and define `ZYAN_CUSTOM_LIBC` to provide your own LibC
// replacement functions

#ifndef ZYAN_NO_LIBC

/* ============================================================================================== */
/* LibC is available                                                                              */
/* ============================================================================================== */

/* ---------------------------------------------------------------------------------------------- */
/* errno.h                                                                                        */
/* ---------------------------------------------------------------------------------------------- */

#include <errno.h>

#define ZYAN_ERRNO  errno

/* ---------------------------------------------------------------------------------------------- */
/* stdarg.h                                                                                       */
/* ---------------------------------------------------------------------------------------------- */

#include <stdarg.h>

/**
 * Defines the `ZyanVAList` datatype.
 */
typedef va_list ZyanVAList;

#define ZYAN_VA_START               va_start
#define ZYAN_VA_ARG                 va_arg
#define ZYAN_VA_END                 va_end
#define ZYAN_VA_COPY(dest, source)  va_copy((dest), (source))

/* ---------------------------------------------------------------------------------------------- */
/* stdio.h                                                                                        */
/* ---------------------------------------------------------------------------------------------- */

#include <stdio.h>

#define ZYAN_FPUTS      fputs
#define ZYAN_FPUTC      fputc
#define ZYAN_FPRINTF    fprintf
#define ZYAN_PRINTF     printf
#define ZYAN_PUTC       putc
#define ZYAN_PUTS       puts
#define ZYAN_SCANF      scanf
#define ZYAN_SSCANF     sscanf
#define ZYAN_VSNPRINTF  vsnprintf

/**
 * Defines the `ZyanFile` datatype.
 */
typedef FILE ZyanFile;

#define ZYAN_STDIN      stdin
#define ZYAN_STDOUT     stdout
#define ZYAN_STDERR     stderr

/* ---------------------------------------------------------------------------------------------- */
/* stdlib.h                                                                                       */
/* ---------------------------------------------------------------------------------------------- */

#include <stdlib.h>
#define ZYAN_CALLOC     calloc
#define ZYAN_FREE       free
#define ZYAN_GETENV     getenv
#define ZYAN_MALLOC     malloc
#define ZYAN_REALLOC    realloc

/* ---------------------------------------------------------------------------------------------- */
/* string.h                                                                                       */
/* ---------------------------------------------------------------------------------------------- */

#include <string.h>
#define ZYAN_MEMCHR     memchr
#define ZYAN_MEMCMP     memcmp
#define ZYAN_MEMCPY     memcpy
#define ZYAN_MEMMOVE    memmove
#define ZYAN_MEMSET     memset
#define ZYAN_STRCAT     strcat
#define ZYAN_STRCHR     strchr
#define ZYAN_STRCMP     strcmp
#define ZYAN_STRCOLL    strcoll
#define ZYAN_STRCPY     strcpy
#define ZYAN_STRCSPN    strcspn
#define ZYAN_STRLEN     strlen
#define ZYAN_STRNCAT    strncat
#define ZYAN_STRNCMP    strncmp
#define ZYAN_STRNCPY    strncpy
#define ZYAN_STRPBRK    strpbrk
#define ZYAN_STRRCHR    strrchr
#define ZYAN_STRSPN     strspn
#define ZYAN_STRSTR     strstr
#define ZYAN_STRTOK     strtok
#define ZYAN_STRXFRM    strxfrm

/* ---------------------------------------------------------------------------------------------- */

#else  // if ZYAN_NO_LIBC

/* ============================================================================================== */
/* No LibC available, use our own functions                                                       */
/* ============================================================================================== */


/*
 * These implementations are by no means optimized and will be outperformed by pretty much any
 * libc implementation out there. We do not aim towards providing competetive implementations here,
 * but towards providing a last resort fallback for environments without a working libc.
 */

/* ---------------------------------------------------------------------------------------------- */
/* stdarg.h                                                                                       */
/* ---------------------------------------------------------------------------------------------- */

#if defined(ZYAN_MSVC) || defined(ZYAN_ICC)

/**
 * Defines the `ZyanVAList` datatype.
 */
typedef char* ZyanVAList;

#   define ZYAN_VA_START __crt_va_start
#   define ZYAN_VA_ARG   __crt_va_arg
#   define ZYAN_VA_END   __crt_va_end
#   define ZYAN_VA_COPY(destination, source) ((destination) = (source))

#elif defined(ZYAN_GNUC)

/**
 * Defines the `ZyanVAList` datatype.
 */
typedef __builtin_va_list  ZyanVAList;

#   define ZYAN_VA_START(v, l)  __builtin_va_start(v, l)
#   define ZYAN_VA_END(v)       __builtin_va_end(v)
#   define ZYAN_VA_ARG(v, l)    __builtin_va_arg(v, l)
#   define ZYAN_VA_COPY(d, s)   __builtin_va_copy(d, s)

#else
#   error "Unsupported compiler for no-libc mode."
#endif

/* ---------------------------------------------------------------------------------------------- */
/* stdio.h                                                                                        */
/* ---------------------------------------------------------------------------------------------- */

// ZYAN_INLINE int ZYAN_VSNPRINTF (char* const buffer, ZyanUSize const count,
//     char const* const format, ZyanVAList args)
// {
//      // We cant provide a fallback implementation for this function
//     ZYAN_UNUSED(buffer);
//     ZYAN_UNUSED(count);
//     ZYAN_UNUSED(format);
//     ZYAN_UNUSED(args);
//     return ZYAN_NULL;
// }

/* ---------------------------------------------------------------------------------------------- */
/* stdlib.h                                                                                       */
/* ---------------------------------------------------------------------------------------------- */

// ZYAN_INLINE void* ZYAN_CALLOC(ZyanUSize nitems, ZyanUSize size)
// {
//      // We cant provide a fallback implementation for this function
//     ZYAN_UNUSED(nitems);
//     ZYAN_UNUSED(size);
//     return ZYAN_NULL;
// }
//
// ZYAN_INLINE void ZYAN_FREE(void *p)
// {
//      // We cant provide a fallback implementation for this function
//     ZYAN_UNUSED(p);
// }
//
// ZYAN_INLINE void* ZYAN_MALLOC(ZyanUSize n)
// {
//     // We cant provide a fallback implementation for this function
//     ZYAN_UNUSED(n);
//     return ZYAN_NULL;
// }
//
// ZYAN_INLINE void* ZYAN_REALLOC(void* p, ZyanUSize n)
// {
//      // We cant provide a fallback implementation for this function
//     ZYAN_UNUSED(p);
//     ZYAN_UNUSED(n);
//     return ZYAN_NULL;
// }

/* ---------------------------------------------------------------------------------------------- */
/* string.h                                                                                       */
/* ---------------------------------------------------------------------------------------------- */

ZYAN_INLINE void* ZYAN_MEMCHR(const void* str, int c, ZyanUSize n)
{
    const ZyanU8* p = (ZyanU8*)str;
    while (n--)
    {
        if (*p != (ZyanU8)c)
        {
            p++;
        } else
        {
            return (void*)p;
        }
    }
    return 0;
}

ZYAN_INLINE int ZYAN_MEMCMP(const void* s1, const void* s2, ZyanUSize n)
{
    const ZyanU8* p1 = s1, *p2 = s2;
    while (n--)
    {
        if (*p1 != *p2)
        {
            return *p1 - *p2;
        }
        p1++, p2++;
    }
    return 0;
}

ZYAN_INLINE void* ZYAN_MEMCPY(void* dst, const void* src, ZyanUSize n)
{
    volatile ZyanU8* dp = dst;
    const ZyanU8* sp = src;
    while (n--)
    {
        *dp++ = *sp++;
    }
    return dst;
}

ZYAN_INLINE void* ZYAN_MEMMOVE(void* dst, const void* src, ZyanUSize n)
{
    volatile ZyanU8* pd = dst;
    const ZyanU8* ps = src;
    if (ps < pd)
    {
        for (pd += n, ps += n; n--;)
        {
            *--pd = *--ps;
        }
    } else
    {
        while (n--)
        {
            *pd++ = *ps++;
        }
    }
    return dst;
}

ZYAN_INLINE void* ZYAN_MEMSET(void* dst, int val, ZyanUSize n)
{
    volatile ZyanU8* p = dst;
    while (n--)
    {
        *p++ = (unsigned char)val;
    }
    return dst;
}

ZYAN_INLINE char* ZYAN_STRCAT(char* dest, const char* src)
{
    char* ret = dest;
    while (*dest)
    {
        dest++;
    }
    while ((*dest++ = *src++));
    return ret;
}

ZYAN_INLINE char* ZYAN_STRCHR(const char* s, int c)
{
    while (*s != (char)c)
    {
        if (!*s++)
        {
            return 0;
        }
    }
    return (char*)s;
}

ZYAN_INLINE int ZYAN_STRCMP(const char* s1, const char* s2)
{
    while (*s1 && (*s1 == *s2))
    {
        s1++, s2++;
    }
    return *(const ZyanU8*)s1 - *(const ZyanU8*)s2;
}

ZYAN_INLINE int ZYAN_STRCOLL(const char *s1, const char *s2)
{
    // TODO: Implement

    ZYAN_UNUSED(s1);
    ZYAN_UNUSED(s2);

    return 0;
}

ZYAN_INLINE char* ZYAN_STRCPY(char* dest, const char* src)
{
    char* ret = dest;
    while ((*dest++ = *src++));
    return ret;
}

ZYAN_INLINE ZyanUSize ZYAN_STRCSPN(const char *s1, const char *s2)
{
    ZyanUSize ret = 0;
    while (*s1)
    {
        if (ZYAN_STRCHR(s2, *s1))
        {
            return ret;
        }
        s1++, ret++;
    }
    return ret;
}

ZYAN_INLINE ZyanUSize ZYAN_STRLEN(const char* str)
{
    const char* p = str;
    while (*str)
    {
        ++str;
    }
    return str - p;
}

ZYAN_INLINE char* ZYAN_STRNCAT(char* dest, const char* src, ZyanUSize n)
{
    char* ret = dest;
    while (*dest)
    {
        dest++;
    }
    while (n--)
    {
        if (!(*dest++ = *src++))
        {
            return ret;
        }
    }
    *dest = 0;
    return ret;
}

ZYAN_INLINE int ZYAN_STRNCMP(const char* s1, const char* s2, ZyanUSize n)
{
    while (n--)
    {
        if (*s1++ != *s2++)
        {
            return *(unsigned char*)(s1 - 1) - *(unsigned char*)(s2 - 1);
        }
    }
    return 0;
}

ZYAN_INLINE char* ZYAN_STRNCPY(char* dest, const char* src, ZyanUSize n)
{
    char* ret = dest;
    do
    {
        if (!n--)
        {
            return ret;
        }
    } while ((*dest++ = *src++));
    while (n--)
    {
        *dest++ = 0;
    }
    return ret;
}

ZYAN_INLINE char* ZYAN_STRPBRK(const char* s1, const char* s2)
{
    while (*s1)
    {
        if(ZYAN_STRCHR(s2, *s1++))
        {
            return (char*)--s1;
        }
    }
    return 0;
}

ZYAN_INLINE char* ZYAN_STRRCHR(const char* s, int c)
{
    char* ret = 0;
    do
    {
        if (*s == (char)c)
        {
            ret = (char*)s;
        }
    } while (*s++);
    return ret;
}

ZYAN_INLINE ZyanUSize ZYAN_STRSPN(const char* s1, const char* s2)
{
    ZyanUSize ret = 0;
    while (*s1 && ZYAN_STRCHR(s2, *s1++))
    {
        ret++;
    }
    return ret;
}

ZYAN_INLINE char* ZYAN_STRSTR(const char* s1, const char* s2)
{
    const ZyanUSize n = ZYAN_STRLEN(s2);
    while (*s1)
    {
        if (!ZYAN_MEMCMP(s1++, s2, n))
        {
            return (char*)(s1 - 1);
        }
    }
    return 0;
}

ZYAN_INLINE char* ZYAN_STRTOK(char* str, const char* delim)
{
    static char* p = 0;
    if (str)
    {
        p = str;
    } else
    if (!p)
    {
        return 0;
    }
    str = p + ZYAN_STRSPN(p, delim);
    p = str + ZYAN_STRCSPN(str, delim);
    if (p == str)
    {
        return p = 0;
    }
    p = *p ? *p = 0, p + 1 : 0;
    return str;
}

ZYAN_INLINE ZyanUSize ZYAN_STRXFRM(char* dest, const char* src, ZyanUSize n)
{
    const ZyanUSize n2 = ZYAN_STRLEN(src);
    if (n > n2)
    {
        ZYAN_STRCPY(dest, src);
    }
    return n2;
}

/* ---------------------------------------------------------------------------------------------- */

#endif

#endif

/* ============================================================================================== */

#endif /* ZYCORE_LIBC_H */

//
// Header: Zydis/Internal/DecoderData.h
//

/***************************************************************************************************

  Zyan Disassembler Library (Zydis)

  Original Author : Florian Bernd

 * Permission is hereby granted, free of charge, to any person obtaining a copy
 * of this software and associated documentation files (the "Software"), to deal
 * in the Software without restriction, including without limitation the rights
 * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
 * copies of the Software, and to permit persons to whom the Software is
 * furnished to do so, subject to the following conditions:
 *
 * The above copyright notice and this permission notice shall be included in all
 * copies or substantial portions of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
 * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
 * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
 * SOFTWARE.

***************************************************************************************************/

#ifndef ZYDIS_INTERNAL_DECODERDATA_H
#define ZYDIS_INTERNAL_DECODERDATA_H


#ifdef __cplusplus
extern "C" {
#endif

/* ============================================================================================== */
/* Enums and types                                                                                */
/* ============================================================================================== */

// MSVC does not like types other than (un-)signed int for bit-fields
#ifdef ZYAN_MSVC
#   pragma warning(push)
#   pragma warning(disable:4214)
#endif

#pragma pack(push, 1)

/* ---------------------------------------------------------------------------------------------- */
/* Decoder tree                                                                                   */
/* ---------------------------------------------------------------------------------------------- */

/**
 * Defines the `ZydisDecoderTreeNodeType` data-type.
 */
typedef ZyanU8 ZydisDecoderTreeNodeType;

/**
 * Values that represent zydis decoder tree node types.
 */
enum ZydisDecoderTreeNodeTypes
{
    ZYDIS_NODETYPE_INVALID                  = 0x00,
    /**
     * Reference to an instruction-definition.
     */
    ZYDIS_NODETYPE_DEFINITION_MASK          = 0x80,
    /**
     * Reference to an XOP-map filter.
     */
    ZYDIS_NODETYPE_FILTER_XOP               = 0x01,
    /**
     * Reference to an VEX-map filter.
     */
    ZYDIS_NODETYPE_FILTER_VEX               = 0x02,
    /**
     * Reference to an EVEX/MVEX-map filter.
     */
    ZYDIS_NODETYPE_FILTER_EMVEX             = 0x03,
    /**
     * Reference to an opcode filter.
     */
    ZYDIS_NODETYPE_FILTER_OPCODE            = 0x04,
    /**
     * Reference to an instruction-mode filter.
     */
    ZYDIS_NODETYPE_FILTER_MODE              = 0x05,
    /**
     * Reference to an compacted instruction-mode filter.
     */
    ZYDIS_NODETYPE_FILTER_MODE_COMPACT      = 0x06,
    /**
     * Reference to a ModRM.mod filter.
     */
    ZYDIS_NODETYPE_FILTER_MODRM_MOD         = 0x07,
    /**
     * Reference to a compacted ModRM.mod filter.
     */
    ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT = 0x08,
    /**
     * Reference to a ModRM.reg filter.
     */
    ZYDIS_NODETYPE_FILTER_MODRM_REG         = 0x09,
    /**
     * Reference to a ModRM.rm filter.
     */
    ZYDIS_NODETYPE_FILTER_MODRM_RM          = 0x0A,
    /**
     * Reference to a PrefixGroup1 filter.
     */
    ZYDIS_NODETYPE_FILTER_PREFIX_GROUP1     = 0x0B,
    /**
     * Reference to a mandatory-prefix filter.
     */
    ZYDIS_NODETYPE_FILTER_MANDATORY_PREFIX  = 0x0C,
    /**
     * Reference to an operand-size filter.
     */
    ZYDIS_NODETYPE_FILTER_OPERAND_SIZE      = 0x0D,
    /**
     * Reference to an address-size filter.
     */
    ZYDIS_NODETYPE_FILTER_ADDRESS_SIZE      = 0x0E,
    /**
     * Reference to a vector-length filter.
     */
    ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH     = 0x0F,
    /**
     * Reference to an REX/VEX/EVEX.W filter.
     */
    ZYDIS_NODETYPE_FILTER_REX_W             = 0x10,
    /**
     * Reference to an REX/VEX/EVEX.B filter.
     */
    ZYDIS_NODETYPE_FILTER_REX_B             = 0x11,
    /**
     * Reference to an EVEX.b filter.
     */
    ZYDIS_NODETYPE_FILTER_EVEX_B            = 0x12,
    /**
     * Reference to an MVEX.E filter.
     */
    ZYDIS_NODETYPE_FILTER_MVEX_E            = 0x13,
    /**
     * Reference to a AMD-mode filter.
     */
    ZYDIS_NODETYPE_FILTER_MODE_AMD          = 0x14,
    /**
     * Reference to a KNC-mode filter.
     */
    ZYDIS_NODETYPE_FILTER_MODE_KNC          = 0x15,
    /**
     * Reference to a MPX-mode filter.
     */
    ZYDIS_NODETYPE_FILTER_MODE_MPX          = 0x16,
    /**
     * Reference to a CET-mode filter.
     */
    ZYDIS_NODETYPE_FILTER_MODE_CET          = 0x17,
    /**
     * Reference to a LZCNT-mode filter.
     */
    ZYDIS_NODETYPE_FILTER_MODE_LZCNT        = 0x18,
    /**
     * Reference to a TZCNT-mode filter.
     */
    ZYDIS_NODETYPE_FILTER_MODE_TZCNT        = 0x19,
    /**
     * Reference to a WBNOINVD-mode filter.
     */
    ZYDIS_NODETYPE_FILTER_MODE_WBNOINVD     = 0x1A,
    /**
     * Reference to a CLDEMOTE-mode filter.
     */
    ZYDIS_NODETYPE_FILTER_MODE_CLDEMOTE     = 0x1B,
    /**
     * Reference to a IPREFETCH-mode filter.
     */
    ZYDIS_NODETYPE_FILTER_MODE_IPREFETCH    = 0x1C,
    /**
     * Reference to a UD0_COMPAT-mode filter.
     */
    ZYDIS_NODETYPE_FILTER_MODE_UD0_COMPAT   = 0x1D
};

/* ---------------------------------------------------------------------------------------------- */

/**
 * Defines the `ZydisDecoderTreeNodeValue` data-type.
 */
typedef ZyanU16 ZydisDecoderTreeNodeValue;

/* ---------------------------------------------------------------------------------------------- */

/**
 * Defines the `ZydisDecoderTreeNode` struct.
 */
typedef struct ZydisDecoderTreeNode_
{
    ZydisDecoderTreeNodeType type;
    ZydisDecoderTreeNodeValue value;
} ZydisDecoderTreeNode;

/* ---------------------------------------------------------------------------------------------- */

#pragma pack(pop)

#ifdef ZYAN_MSVC
#   pragma warning(pop)
#endif

/* ---------------------------------------------------------------------------------------------- */
/* Physical instruction encoding info                                                             */
/* ---------------------------------------------------------------------------------------------- */

/**
 * Defines the `ZydisInstructionEncodingFlags` data-type.
 */
typedef ZyanU8 ZydisInstructionEncodingFlags;

/**
 * The instruction has an optional modrm byte.
 */
#define ZYDIS_INSTR_ENC_FLAG_HAS_MODRM      0x01

/**
 * The instruction has an optional displacement value.
 */
#define ZYDIS_INSTR_ENC_FLAG_HAS_DISP       0x02

/**
 * The instruction has an optional immediate value.
 */
#define ZYDIS_INSTR_ENC_FLAG_HAS_IMM0       0x04

/**
 * The instruction has a second optional immediate value.
 */
#define ZYDIS_INSTR_ENC_FLAG_HAS_IMM1       0x08

/**
 * The instruction ignores the value of `modrm.mod` and always assumes `modrm.mod == 3`
 *          ("reg, reg" - form).
 *
 *          Instructions with this flag can't have a SIB byte or a displacement value.
 */
#define ZYDIS_INSTR_ENC_FLAG_FORCE_REG_FORM 0x10

/**
 * Defines the `ZydisInstructionEncodingInfo` struct.
 */
typedef struct ZydisInstructionEncodingInfo_
{
    /**
     * Contains flags with information about the physical instruction-encoding.
     */
    ZydisInstructionEncodingFlags flags;
    /**
     * Displacement info.
     */
    struct
    {
        /**
         * The size of the displacement value.
         */
        ZyanU8 size[3];
    } disp;
    /**
     * Immediate info.
     */
    struct
    {
        /**
         * The size of the immediate value.
         */
        ZyanU8 size[3];
        /**
         * Signals, if the value is signed.
         */
        ZyanBool is_signed;
        /**
         * Signals, if the value is a relative offset.
         */
        ZyanBool is_relative;
    } imm[2];
} ZydisInstructionEncodingInfo;

/* ---------------------------------------------------------------------------------------------- */

/* ============================================================================================== */
/* Functions                                                                                      */
/* ============================================================================================== */

/* ---------------------------------------------------------------------------------------------- */
/* Decoder tree                                                                                   */
/* ---------------------------------------------------------------------------------------------- */

extern const ZydisDecoderTreeNode zydis_decoder_tree_root;

/**
 * Returns the root node of the instruction tree.
 *
 * @return  The root node of the instruction tree.
 */
ZYAN_INLINE const ZydisDecoderTreeNode* ZydisDecoderTreeGetRootNode(void)
{
    return &zydis_decoder_tree_root;
}

/**
 * Returns the child node of `parent` specified by `index`.
 *
 * @param   parent  The parent node.
 * @param   index   The index of the child node to retrieve.
 *
 * @return  The specified child node.
 */
ZYDIS_NO_EXPORT const ZydisDecoderTreeNode* ZydisDecoderTreeGetChildNode(
    const ZydisDecoderTreeNode* parent, ZyanU16 index);

/**
 * Returns information about optional instruction parts (like modrm, displacement or
 * immediates) for the instruction that is linked to the given `node`.
 *
 * @param   node    The instruction definition node.
 * @param   info    A pointer to the `ZydisInstructionParts` struct.
 */
ZYDIS_NO_EXPORT void ZydisGetInstructionEncodingInfo(const ZydisDecoderTreeNode* node,
    const ZydisInstructionEncodingInfo** info);

/* ---------------------------------------------------------------------------------------------- */

/* ============================================================================================== */

#ifdef __cplusplus
}
#endif

#endif /* ZYDIS_INTERNAL_DECODERDATA_H */

//
// Header: Zydis/Internal/SharedData.h
//

/***************************************************************************************************

  Zyan Disassembler Library (Zydis)

  Original Author : Florian Bernd

 * Permission is hereby granted, free of charge, to any person obtaining a copy
 * of this software and associated documentation files (the "Software"), to deal
 * in the Software without restriction, including without limitation the rights
 * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
 * copies of the Software, and to permit persons to whom the Software is
 * furnished to do so, subject to the following conditions:
 *
 * The above copyright notice and this permission notice shall be included in all
 * copies or substantial portions of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
 * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
 * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
 * SOFTWARE.

***************************************************************************************************/

#ifndef ZYDIS_INTERNAL_SHAREDDATA_H
#define ZYDIS_INTERNAL_SHAREDDATA_H


#ifdef __cplusplus
extern "C" {
#endif

/* ============================================================================================== */
/* Enums and types                                                                                */
/* ============================================================================================== */

// MSVC does not like types other than (un-)signed int for bit-fields
#ifdef ZYAN_MSVC
#   pragma warning(push)
#   pragma warning(disable:4214)
#endif

#pragma pack(push, 1)

/* ---------------------------------------------------------------------------------------------- */
/* Operand definition                                                                             */
/* ---------------------------------------------------------------------------------------------- */

/**
 * Defines the `ZydisSemanticOperandType` enum.
 */
typedef enum ZydisSemanticOperandType_
{
    ZYDIS_SEMANTIC_OPTYPE_UNUSED,
    ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG,
    ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_MEM,
    ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_IMM1,
    ZYDIS_SEMANTIC_OPTYPE_GPR8,
    ZYDIS_SEMANTIC_OPTYPE_GPR16,
    ZYDIS_SEMANTIC_OPTYPE_GPR32,
    ZYDIS_SEMANTIC_OPTYPE_GPR64,
    ZYDIS_SEMANTIC_OPTYPE_GPR16_32_64,
    ZYDIS_SEMANTIC_OPTYPE_GPR32_32_64,
    ZYDIS_SEMANTIC_OPTYPE_GPR16_32_32,
    ZYDIS_SEMANTIC_OPTYPE_GPR_ASZ,
    ZYDIS_SEMANTIC_OPTYPE_FPR,
    ZYDIS_SEMANTIC_OPTYPE_MMX,
    ZYDIS_SEMANTIC_OPTYPE_XMM,
    ZYDIS_SEMANTIC_OPTYPE_YMM,
    ZYDIS_SEMANTIC_OPTYPE_ZMM,
    ZYDIS_SEMANTIC_OPTYPE_TMM,
    ZYDIS_SEMANTIC_OPTYPE_BND,
    ZYDIS_SEMANTIC_OPTYPE_SREG,
    ZYDIS_SEMANTIC_OPTYPE_CR,
    ZYDIS_SEMANTIC_OPTYPE_DR,
    ZYDIS_SEMANTIC_OPTYPE_MASK,
    ZYDIS_SEMANTIC_OPTYPE_MEM,
    ZYDIS_SEMANTIC_OPTYPE_MEM_VSIBX,
    ZYDIS_SEMANTIC_OPTYPE_MEM_VSIBY,
    ZYDIS_SEMANTIC_OPTYPE_MEM_VSIBZ,
    ZYDIS_SEMANTIC_OPTYPE_IMM,
    ZYDIS_SEMANTIC_OPTYPE_REL,
    ZYDIS_SEMANTIC_OPTYPE_PTR,
    ZYDIS_SEMANTIC_OPTYPE_AGEN,
    ZYDIS_SEMANTIC_OPTYPE_MOFFS,
    ZYDIS_SEMANTIC_OPTYPE_MIB,

    /**
     * Maximum value of this enum.
     */
    ZYDIS_SEMANTIC_OPTYPE_MAX_VALUE = ZYDIS_SEMANTIC_OPTYPE_MIB,
    /**
     * The minimum number of bits required to represent all values of this enum.
     */
    ZYDIS_SEMANTIC_OPTYPE_REQUIRED_BITS = ZYAN_BITS_TO_REPRESENT(ZYDIS_SEMANTIC_OPTYPE_MAX_VALUE)
} ZydisSemanticOperandType;

/* ---------------------------------------------------------------------------------------------- */

/**
 * Defines the `ZydisInternalElementType` enum.
 */
typedef enum ZydisInternalElementType_
{
    ZYDIS_IELEMENT_TYPE_INVALID,
    ZYDIS_IELEMENT_TYPE_VARIABLE,
    ZYDIS_IELEMENT_TYPE_STRUCT,
    ZYDIS_IELEMENT_TYPE_INT,
    ZYDIS_IELEMENT_TYPE_UINT,
    ZYDIS_IELEMENT_TYPE_INT1,
    ZYDIS_IELEMENT_TYPE_INT8,
    ZYDIS_IELEMENT_TYPE_INT8X4,
    ZYDIS_IELEMENT_TYPE_INT16,
    ZYDIS_IELEMENT_TYPE_INT16X2,
    ZYDIS_IELEMENT_TYPE_INT32,
    ZYDIS_IELEMENT_TYPE_INT64,
    ZYDIS_IELEMENT_TYPE_UINT8,
    ZYDIS_IELEMENT_TYPE_UINT8X4,
    ZYDIS_IELEMENT_TYPE_UINT16,
    ZYDIS_IELEMENT_TYPE_UINT16X2,
    ZYDIS_IELEMENT_TYPE_UINT32,
    ZYDIS_IELEMENT_TYPE_UINT64,
    ZYDIS_IELEMENT_TYPE_UINT128,
    ZYDIS_IELEMENT_TYPE_UINT256,
    ZYDIS_IELEMENT_TYPE_FLOAT16,
    ZYDIS_IELEMENT_TYPE_FLOAT16X2,
    ZYDIS_IELEMENT_TYPE_FLOAT32,
    ZYDIS_IELEMENT_TYPE_FLOAT64,
    ZYDIS_IELEMENT_TYPE_FLOAT80,
    ZYDIS_IELEMENT_TYPE_BFLOAT16X2,
    ZYDIS_IELEMENT_TYPE_BCD80,
    ZYDIS_IELEMENT_TYPE_CC3,
    ZYDIS_IELEMENT_TYPE_CC5,

    /**
     * Maximum value of this enum.
     */
    ZYDIS_IELEMENT_TYPE_MAX_VALUE = ZYDIS_IELEMENT_TYPE_CC5,
    /**
     * The minimum number of bits required to represent all values of this enum.
     */
    ZYDIS_IELEMENT_TYPE_REQUIRED_BITS = ZYAN_BITS_TO_REPRESENT(ZYDIS_IELEMENT_TYPE_MAX_VALUE)
} ZydisInternalElementType;

/* ---------------------------------------------------------------------------------------------- */

/**
 * Defines the `ZydisImplicitRegisterType` enum.
 */
typedef enum ZydisImplicitRegisterType_
{
    // TODO: Rename OSZ|ASZ|SSZ_
    ZYDIS_IMPLREG_TYPE_STATIC,
    ZYDIS_IMPLREG_TYPE_GPR_OSZ,
    ZYDIS_IMPLREG_TYPE_GPR_ASZ,
    ZYDIS_IMPLREG_TYPE_IP_ASZ,
    ZYDIS_IMPLREG_TYPE_IP_SSZ,
    ZYDIS_IMPLREG_TYPE_GPR_SSZ,
    ZYDIS_IMPLREG_TYPE_FLAGS_SSZ,

    /**
     * Maximum value of this enum.
     */
    ZYDIS_IMPLREG_TYPE_MAX_VALUE = ZYDIS_IMPLREG_TYPE_FLAGS_SSZ,
    /**
     * The minimum number of bits required to represent all values of this enum.
     */
    ZYDIS_IMPLREG_TYPE_REQUIRED_BITS = ZYAN_BITS_TO_REPRESENT(ZYDIS_IMPLREG_TYPE_MAX_VALUE)
} ZydisImplicitRegisterType;

/* ---------------------------------------------------------------------------------------------- */

/**
 * Defines the `ZydisImplicitMemBase` enum.
 */
typedef enum ZydisImplicitMemBase_
{
    // TODO: Rename OSZ|ASZ|SSZ_
    ZYDIS_IMPLMEM_BASE_AGPR_REG,
    ZYDIS_IMPLMEM_BASE_AGPR_RM,
    ZYDIS_IMPLMEM_BASE_AAX,
    ZYDIS_IMPLMEM_BASE_ADX,
    ZYDIS_IMPLMEM_BASE_ABX,
    ZYDIS_IMPLMEM_BASE_ASI,
    ZYDIS_IMPLMEM_BASE_ADI,
    ZYDIS_IMPLMEM_BASE_SSP,
    ZYDIS_IMPLMEM_BASE_SBP,

    /**
     * Maximum value of this enum.
     */
    ZYDIS_IMPLMEM_BASE_MAX_VALUE = ZYDIS_IMPLMEM_BASE_SBP,
    /**
     * The minimum number of bits required to represent all values of this enum.
     */
    ZYDIS_IMPLMEM_BASE_REQUIRED_BITS = ZYAN_BITS_TO_REPRESENT(ZYDIS_IMPLMEM_BASE_MAX_VALUE)
} ZydisImplicitMemBase;

/* ---------------------------------------------------------------------------------------------- */

// MSVC does not correctly execute the `pragma pack(1)` compiler-directive, if we use the correct
// enum types
ZYAN_STATIC_ASSERT(ZYDIS_SEMANTIC_OPTYPE_REQUIRED_BITS     <=  8);
ZYAN_STATIC_ASSERT(ZYDIS_OPERAND_VISIBILITY_REQUIRED_BITS  <=  8);
ZYAN_STATIC_ASSERT(ZYDIS_OPERAND_ACTION_REQUIRED_BITS      <=  8);
ZYAN_STATIC_ASSERT(ZYDIS_IELEMENT_TYPE_REQUIRED_BITS       <=  8);
ZYAN_STATIC_ASSERT(ZYDIS_OPERAND_ENCODING_REQUIRED_BITS    <=  8);
ZYAN_STATIC_ASSERT(ZYDIS_IMPLREG_TYPE_REQUIRED_BITS        <=  8);
ZYAN_STATIC_ASSERT(ZYDIS_REGISTER_REQUIRED_BITS            <= 16);
ZYAN_STATIC_ASSERT(ZYDIS_IMPLMEM_BASE_REQUIRED_BITS        <=  8);

/**
 * Defines the `ZydisOperandDefinition` struct.
 */
typedef struct ZydisOperandDefinition_
{
    ZyanU8 type                            ZYAN_BITFIELD(ZYDIS_SEMANTIC_OPTYPE_REQUIRED_BITS);
    ZyanU8 visibility                      ZYAN_BITFIELD(ZYDIS_OPERAND_VISIBILITY_REQUIRED_BITS);
    ZyanU8 actions                         ZYAN_BITFIELD(ZYDIS_OPERAND_ACTION_REQUIRED_BITS);
    ZyanU16 size[3];
    ZyanU8 element_type                    ZYAN_BITFIELD(ZYDIS_IELEMENT_TYPE_REQUIRED_BITS);
    union
    {
        ZyanU8 encoding                    ZYAN_BITFIELD(ZYDIS_OPERAND_ENCODING_REQUIRED_BITS);
        struct
        {
            ZyanU8 type                    ZYAN_BITFIELD(ZYDIS_IMPLREG_TYPE_REQUIRED_BITS);
            union
            {
                ZyanU16 reg                ZYAN_BITFIELD(ZYDIS_REGISTER_REQUIRED_BITS);
                ZyanU8 id                  ZYAN_BITFIELD(6);
            } reg;
        } reg;
        struct
        {
            ZyanU8 seg                     ZYAN_BITFIELD(3);
            ZyanU8 base                    ZYAN_BITFIELD(ZYDIS_IMPLMEM_BASE_REQUIRED_BITS);
        } mem;
    } op;
    ZyanBool is_multisource4               ZYAN_BITFIELD(1);
    ZyanBool ignore_seg_override           ZYAN_BITFIELD(1);
} ZydisOperandDefinition;

/* ---------------------------------------------------------------------------------------------- */
/* Instruction definition                                                                         */
/* ---------------------------------------------------------------------------------------------- */

/**
 * Defines the `ZydisReadWriteAction` enum.
 */
typedef enum ZydisReadWriteAction_
{
    ZYDIS_RW_ACTION_NONE,
    ZYDIS_RW_ACTION_READ,
    ZYDIS_RW_ACTION_WRITE,
    ZYDIS_RW_ACTION_READWRITE,

    /**
     * Maximum value of this enum.
     */
    ZYDIS_RW_ACTION_MAX_VALUE = ZYDIS_RW_ACTION_READWRITE,
    /**
     * The minimum number of bits required to represent all values of this enum.
     */
    ZYDIS_RW_ACTION_REQUIRED_BITS = ZYAN_BITS_TO_REPRESENT(ZYDIS_RW_ACTION_MAX_VALUE)
} ZydisReadWriteAction;

/* ---------------------------------------------------------------------------------------------- */

/**
 * Defines the `ZydisInternalVectorLength` enum.
 */
typedef enum ZydisInternalVectorLength_
{
    ZYDIS_IVECTOR_LENGTH_DEFAULT,
    ZYDIS_IVECTOR_LENGTH_FIXED_128,
    ZYDIS_IVECTOR_LENGTH_FIXED_256,
    ZYDIS_IVECTOR_LENGTH_FIXED_512,

    /**
     * Maximum value of this enum.
     */
    ZYDIS_IVECTOR_LENGTH_MAX_VALUE = ZYDIS_IVECTOR_LENGTH_FIXED_512,
    /**
     * The minimum number of bits required to represent all values of this enum.
     */
    ZYDIS_IVECTOR_LENGTH_REQUIRED_BITS = ZYAN_BITS_TO_REPRESENT(ZYDIS_IVECTOR_LENGTH_MAX_VALUE)
} ZydisInternalVectorLength;

/* ---------------------------------------------------------------------------------------------- */

/**
 * Defines the `ZydisInternalElementSize` enum.
 */
typedef enum ZydisInternalElementSize_
{
    ZYDIS_IELEMENT_SIZE_INVALID,
    ZYDIS_IELEMENT_SIZE_8,
    ZYDIS_IELEMENT_SIZE_16,
    ZYDIS_IELEMENT_SIZE_32,
    ZYDIS_IELEMENT_SIZE_64,
    ZYDIS_IELEMENT_SIZE_128,

    /**
     * Maximum value of this enum.
     */
    ZYDIS_IELEMENT_SIZE_MAX_VALUE = ZYDIS_IELEMENT_SIZE_128,
    /**
     * The minimum number of bits required to represent all values of this enum.
     */
    ZYDIS_IELEMENT_SIZE_REQUIRED_BITS = ZYAN_BITS_TO_REPRESENT(ZYDIS_IELEMENT_SIZE_MAX_VALUE)
} ZydisInternalElementSize;

/* ---------------------------------------------------------------------------------------------- */

/**
 * Defines the `ZydisEVEXFunctionality` enum.
 */
typedef enum ZydisEVEXFunctionality_
{
    ZYDIS_EVEX_FUNC_INVALID,
    /**
     * `EVEX.b` enables broadcast functionality.
     */
    ZYDIS_EVEX_FUNC_BC,
    /**
     * `EVEX.b` enables embedded-rounding functionality.
     */
    ZYDIS_EVEX_FUNC_RC,
    /**
     * `EVEX.b` enables sae functionality.
     */
    ZYDIS_EVEX_FUNC_SAE,

    /**
     * Maximum value of this enum.
     */
    ZYDIS_EVEX_FUNC_MAX_VALUE = ZYDIS_EVEX_FUNC_SAE,
    /**
     * The minimum number of bits required to represent all values of this enum.
     */
    ZYDIS_EVEX_FUNC_REQUIRED_BITS = ZYAN_BITS_TO_REPRESENT(ZYDIS_EVEX_FUNC_MAX_VALUE)
} ZydisEVEXFunctionality;

/* ---------------------------------------------------------------------------------------------- */

/**
 * Defines the `ZydisEVEXTupleType` enum.
 */
typedef enum ZydisEVEXTupleType_
{
    ZYDIS_TUPLETYPE_INVALID,
    /**
     * Full Vector
     */
    ZYDIS_TUPLETYPE_FV,
    /**
     * Half Vector
     */
    ZYDIS_TUPLETYPE_HV,
    /**
     * Full Vector Mem
     */
    ZYDIS_TUPLETYPE_FVM,
    /**
     * Tuple1 Scalar
     */
    ZYDIS_TUPLETYPE_T1S,
    /**
     * Tuple1 Fixed
     */
    ZYDIS_TUPLETYPE_T1F,
    /**
     * Tuple1 4x32
     */
    ZYDIS_TUPLETYPE_T1_4X,
    /**
     * Gather / Scatter
     */
    ZYDIS_TUPLETYPE_GSCAT,
    /**
     * Tuple2
     */
    ZYDIS_TUPLETYPE_T2,
    /**
     * Tuple4
     */
    ZYDIS_TUPLETYPE_T4,
    /**
     * Tuple8
     */
    ZYDIS_TUPLETYPE_T8,
    /**
     * Half Mem
     */
    ZYDIS_TUPLETYPE_HVM,
    /**
     * QuarterMem
     */
    ZYDIS_TUPLETYPE_QVM,
    /**
     * OctMem
     */
    ZYDIS_TUPLETYPE_OVM,
    /**
     * Mem128
     */
    ZYDIS_TUPLETYPE_M128,
    /**
     * MOVDDUP
     */
    ZYDIS_TUPLETYPE_DUP,
    /**
     * Quarter of the vector-length.
     */
    ZYDIS_TUPLETYPE_QUARTER,

    /**
     * Maximum value of this enum.
     */
    ZYDIS_TUPLETYPE_MAX_VALUE = ZYDIS_TUPLETYPE_QUARTER,
    /**
     * The minimum number of bits required to represent all values of this enum.
     */
    ZYDIS_TUPLETYPE_REQUIRED_BITS = ZYAN_BITS_TO_REPRESENT(ZYDIS_TUPLETYPE_MAX_VALUE)
} ZydisEVEXTupleType;

/* ---------------------------------------------------------------------------------------------- */

/**
 * Defines the `ZydisMVEXFunctionality` enum.
 */
typedef enum ZydisMVEXFunctionality_
{
    /**
     * The `MVEX.SSS` value is ignored.
     */
    ZYDIS_MVEX_FUNC_IGNORED,
    /**
     * `MVEX.SSS` must be `000b`.
     */
    ZYDIS_MVEX_FUNC_INVALID,
    /**
     * `MVEX.SSS` controls embedded-rounding functionality.
     */
    ZYDIS_MVEX_FUNC_RC,
    /**
     * `MVEX.SSS` controls sae functionality.
     */
    ZYDIS_MVEX_FUNC_SAE,
    /**
     * No special operation (32bit float elements).
     */
    ZYDIS_MVEX_FUNC_F_32,
    /**
     * No special operation (32bit uint elements).
     */
    ZYDIS_MVEX_FUNC_I_32,
    /**
     * No special operation (64bit float elements).
     */
    ZYDIS_MVEX_FUNC_F_64,
    /**
     * No special operation (64bit uint elements).
     */
    ZYDIS_MVEX_FUNC_I_64,
    /**
     * Sf32(reg) or Si32(reg).
     */
    ZYDIS_MVEX_FUNC_SWIZZLE_32,
    /**
     * Sf64(reg) or Si64(reg).
     */
    ZYDIS_MVEX_FUNC_SWIZZLE_64,
    /**
     * Sf32(mem).
     */
    ZYDIS_MVEX_FUNC_SF_32,
    /**
     * Sf32(mem) broadcast only.
     */
    ZYDIS_MVEX_FUNC_SF_32_BCST,
    /**
     * Sf32(mem) broadcast 4to16 only.
     */
    ZYDIS_MVEX_FUNC_SF_32_BCST_4TO16,
    /**
     * Sf64(mem).
     */
    ZYDIS_MVEX_FUNC_SF_64,
    /**
     * Si32(mem).
     */
    ZYDIS_MVEX_FUNC_SI_32,
    /**
     * Si32(mem) broadcast only.
     */
    ZYDIS_MVEX_FUNC_SI_32_BCST,
    /**
     * Si32(mem) broadcast 4to16 only.
     */
    ZYDIS_MVEX_FUNC_SI_32_BCST_4TO16,
    /**
     * Si64(mem).
     */
    ZYDIS_MVEX_FUNC_SI_64,
    /**
     * Uf32.
     */
    ZYDIS_MVEX_FUNC_UF_32,
    /**
     * Uf64.
     */
    ZYDIS_MVEX_FUNC_UF_64,
    /**
     * Ui32.
     */
    ZYDIS_MVEX_FUNC_UI_32,
    /**
     * Ui64.
     */
    ZYDIS_MVEX_FUNC_UI_64,
    /**
     * Df32.
     */
    ZYDIS_MVEX_FUNC_DF_32,
    /**
     * Df64.
     */
    ZYDIS_MVEX_FUNC_DF_64,
    /**
     * Di32.
     */
    ZYDIS_MVEX_FUNC_DI_32,
    /**
     * Di64.
     */
    ZYDIS_MVEX_FUNC_DI_64,

    /**
     * Maximum value of this enum.
     */
    ZYDIS_MVEX_FUNC_MAX_VALUE = ZYDIS_MVEX_FUNC_DI_64,
    /**
     * The minimum number of bits required to represent all values of this enum.
     */
    ZYDIS_MVEX_FUNC_REQUIRED_BITS = ZYAN_BITS_TO_REPRESENT(ZYDIS_MVEX_FUNC_MAX_VALUE)
} ZydisMVEXFunctionality;

/* ---------------------------------------------------------------------------------------------- */

/**
 * Defines the `ZydisVEXStaticBroadcast` enum.
 */
typedef enum ZydisVEXStaticBroadcast
{
    ZYDIS_VEX_STATIC_BROADCAST_NONE,
    ZYDIS_VEX_STATIC_BROADCAST_1_TO_2,
    ZYDIS_VEX_STATIC_BROADCAST_1_TO_4,
    ZYDIS_VEX_STATIC_BROADCAST_1_TO_8,
    ZYDIS_VEX_STATIC_BROADCAST_1_TO_16,
    ZYDIS_VEX_STATIC_BROADCAST_1_TO_32,
    ZYDIS_VEX_STATIC_BROADCAST_2_TO_4,

    /**
     * Maximum value of this enum.
     */
    ZYDIS_VEX_STATIC_BROADCAST_MAX_VALUE = ZYDIS_VEX_STATIC_BROADCAST_2_TO_4,
    /**
     * The minimum number of bits required to represent all values of this enum.
     */
    ZYDIS_VEX_STATIC_BROADCAST_REQUIRED_BITS =
        ZYAN_BITS_TO_REPRESENT(ZYDIS_VEX_STATIC_BROADCAST_MAX_VALUE)
} ZydisVEXStaticBroadcast;

/* ---------------------------------------------------------------------------------------------- */

/**
 * Defines the `ZydisEVEXStaticBroadcast` enum.
 */
typedef enum ZydisEVEXStaticBroadcast_
{
    ZYDIS_EVEX_STATIC_BROADCAST_NONE,
    ZYDIS_EVEX_STATIC_BROADCAST_1_TO_2,
    ZYDIS_EVEX_STATIC_BROADCAST_1_TO_4,
    ZYDIS_EVEX_STATIC_BROADCAST_1_TO_8,
    ZYDIS_EVEX_STATIC_BROADCAST_1_TO_16,
    ZYDIS_EVEX_STATIC_BROADCAST_1_TO_32,
    ZYDIS_EVEX_STATIC_BROADCAST_1_TO_64,
    ZYDIS_EVEX_STATIC_BROADCAST_2_TO_4,
    ZYDIS_EVEX_STATIC_BROADCAST_2_TO_8,
    ZYDIS_EVEX_STATIC_BROADCAST_2_TO_16,
    ZYDIS_EVEX_STATIC_BROADCAST_4_TO_8,
    ZYDIS_EVEX_STATIC_BROADCAST_4_TO_16,
    ZYDIS_EVEX_STATIC_BROADCAST_8_TO_16,

    /**
     * Maximum value of this enum.
     */
    ZYDIS_EVEX_STATIC_BROADCAST_MAX_VALUE = ZYDIS_EVEX_STATIC_BROADCAST_8_TO_16,
    /**
     * The minimum number of bits required to represent all values of this enum.
     */
    ZYDIS_EVEX_STATIC_BROADCAST_REQUIRED_BITS =
        ZYAN_BITS_TO_REPRESENT(ZYDIS_EVEX_STATIC_BROADCAST_MAX_VALUE)
} ZydisEVEXStaticBroadcast;

/* ---------------------------------------------------------------------------------------------- */

/**
 * Defines the `ZydisMVEXStaticBroadcast` enum.
 */
typedef enum ZydisMVEXStaticBroadcast_
{
    ZYDIS_MVEX_STATIC_BROADCAST_NONE,
    ZYDIS_MVEX_STATIC_BROADCAST_1_TO_8,
    ZYDIS_MVEX_STATIC_BROADCAST_1_TO_16,
    ZYDIS_MVEX_STATIC_BROADCAST_4_TO_8,
    ZYDIS_MVEX_STATIC_BROADCAST_4_TO_16,

    /**
     * Maximum value of this enum.
     */
    ZYDIS_MVEX_STATIC_BROADCAST_MAX_VALUE = ZYDIS_MVEX_STATIC_BROADCAST_4_TO_16,
    /**
     * The minimum number of bits required to represent all values of this enum.
     */
    ZYDIS_MVEX_STATIC_BROADCAST_REQUIRED_BITS =
        ZYAN_BITS_TO_REPRESENT(ZYDIS_MVEX_STATIC_BROADCAST_MAX_VALUE)
} ZydisMVEXStaticBroadcast;

/* ---------------------------------------------------------------------------------------------- */

/**
 * Defines the `ZydisMaskPolicy` enum.
 */
typedef enum ZydisMaskPolicy_
{
    ZYDIS_MASK_POLICY_INVALID,
    /**
     * The instruction accepts mask-registers other than the default-mask (K0), but
     *          does not require them.
     */
    ZYDIS_MASK_POLICY_ALLOWED,
    /**
     * The instruction requires a mask-register other than the default-mask (K0).
     */
    ZYDIS_MASK_POLICY_REQUIRED,
    /**
     * The instruction does not allow a mask-register other than the default-mask (K0).
     */
    ZYDIS_MASK_POLICY_FORBIDDEN,

    /**
     * Maximum value of this enum.
     */
    ZYDIS_MASK_POLICY_MAX_VALUE = ZYDIS_MASK_POLICY_FORBIDDEN,
    /**
     * The minimum number of bits required to represent all values of this enum.
     */
    ZYDIS_MASK_POLICY_REQUIRED_BITS = ZYAN_BITS_TO_REPRESENT(ZYDIS_MASK_POLICY_MAX_VALUE)
} ZydisMaskPolicy;

/* ---------------------------------------------------------------------------------------------- */

/**
 * Defines the `ZydisMaskOverride` enum.
 */
typedef enum ZydisMaskOverride_
{
    ZYDIS_MASK_OVERRIDE_DEFAULT,
    ZYDIS_MASK_OVERRIDE_ZEROING,
    ZYDIS_MASK_OVERRIDE_CONTROL,

    /**
     * Maximum value of this enum.
     */
    ZYDIS_MASK_OVERRIDE_MAX_VALUE = ZYDIS_MASK_OVERRIDE_CONTROL,
    /**
     * The minimum number of bits required to represent all values of this enum.
     */
    ZYDIS_MASK_OVERRIDE_REQUIRED_BITS = ZYAN_BITS_TO_REPRESENT(ZYDIS_MASK_OVERRIDE_MAX_VALUE)
} ZydisMaskOverride;

/* ---------------------------------------------------------------------------------------------- */

#define ZYDIS_OPDEF_REQUIRED_BITS \
    ZYAN_MAX(ZYDIS_REGKIND_REQUIRED_BITS, ZYDIS_MEMOP_TYPE_REQUIRED_BITS + 1) + 1

#define ZYDIS_OPDEF_GET_REG(operand_definition) \
    ((operand_definition) & ((1 << ZYDIS_REGKIND_REQUIRED_BITS   ) - 1))

#define ZYDIS_OPDEF_GET_MEM(operand_definition) \
    ((operand_definition) & ((1 << ZYDIS_MEMOP_TYPE_REQUIRED_BITS) - 1))

#define ZYDIS_OPDEF_GET_REG_HIGH_BIT(operand_definition) \
    (((operand_definition) >> ZYDIS_REGKIND_REQUIRED_BITS   ) & 0x01)

#define ZYDIS_OPDEF_GET_MEM_HIGH_BIT(operand_definition) \
    (((operand_definition) >> ZYDIS_MEMOP_TYPE_REQUIRED_BITS) & 0x01)

// MSVC does not correctly execute the `pragma pack(1)` compiler-directive, if we use the correct
// enum types
ZYAN_STATIC_ASSERT(ZYDIS_MNEMONIC_REQUIRED_BITS        <= 16);
ZYAN_STATIC_ASSERT(ZYDIS_CATEGORY_REQUIRED_BITS        <=  8);
ZYAN_STATIC_ASSERT(ZYDIS_ISA_SET_REQUIRED_BITS         <=  8);
ZYAN_STATIC_ASSERT(ZYDIS_ISA_EXT_REQUIRED_BITS         <=  8);
ZYAN_STATIC_ASSERT(ZYDIS_BRANCH_TYPE_REQUIRED_BITS     <=  8);
ZYAN_STATIC_ASSERT(ZYDIS_EXCEPTION_CLASS_REQUIRED_BITS <=  8);
ZYAN_STATIC_ASSERT(ZYDIS_OPDEF_REQUIRED_BITS           <=  8);
ZYAN_STATIC_ASSERT(ZYDIS_RW_ACTION_REQUIRED_BITS       <=  8);

#ifndef ZYDIS_MINIMAL_MODE
#   define ZYDIS_INSTRUCTION_DEFINITION_BASE \
        ZyanU16 mnemonic                       ZYAN_BITFIELD(ZYDIS_MNEMONIC_REQUIRED_BITS); \
        ZyanU8 operand_count                   ZYAN_BITFIELD( 4); \
        ZyanU8 operand_count_visible           ZYAN_BITFIELD( 3); \
        ZyanU16 operand_reference              ZYAN_BITFIELD(15); \
        ZyanU8 operand_size_map                ZYAN_BITFIELD( 3); \
        ZyanU8 address_size_map                ZYAN_BITFIELD( 2); \
        ZyanU8 flags_reference                 ZYAN_BITFIELD( 7); \
        ZyanBool requires_protected_mode       ZYAN_BITFIELD( 1); \
        ZyanBool no_compat_mode                ZYAN_BITFIELD( 1); \
        ZyanU8 category                        ZYAN_BITFIELD(ZYDIS_CATEGORY_REQUIRED_BITS); \
        ZyanU8 isa_set                         ZYAN_BITFIELD(ZYDIS_ISA_SET_REQUIRED_BITS); \
        ZyanU8 isa_ext                         ZYAN_BITFIELD(ZYDIS_ISA_EXT_REQUIRED_BITS); \
        ZyanU8 branch_type                     ZYAN_BITFIELD(ZYDIS_BRANCH_TYPE_REQUIRED_BITS); \
        ZyanU8 exception_class                 ZYAN_BITFIELD(ZYDIS_EXCEPTION_CLASS_REQUIRED_BITS); \
        ZyanU8 op_reg                          ZYAN_BITFIELD(ZYDIS_OPDEF_REQUIRED_BITS); \
        ZyanU8 op_rm                           ZYAN_BITFIELD(ZYDIS_OPDEF_REQUIRED_BITS); \
        ZyanU8 cpu_state                       ZYAN_BITFIELD(ZYDIS_RW_ACTION_REQUIRED_BITS); \
        ZyanU8 fpu_state                       ZYAN_BITFIELD(ZYDIS_RW_ACTION_REQUIRED_BITS); \
        ZyanU8 xmm_state                       ZYAN_BITFIELD(ZYDIS_RW_ACTION_REQUIRED_BITS); \
        ZyanBool accepts_segment               ZYAN_BITFIELD( 1)
#else
#   define ZYDIS_INSTRUCTION_DEFINITION_BASE \
        ZyanU16 mnemonic                       ZYAN_BITFIELD(ZYDIS_MNEMONIC_REQUIRED_BITS); \
        ZyanU8 operand_size_map                ZYAN_BITFIELD( 3); \
        ZyanU8 address_size_map                ZYAN_BITFIELD( 2); \
        ZyanBool requires_protected_mode       ZYAN_BITFIELD( 1); \
        ZyanBool no_compat_mode                ZYAN_BITFIELD( 1); \
        ZyanU8 op_reg                          ZYAN_BITFIELD(ZYDIS_OPDEF_REQUIRED_BITS); \
        ZyanU8 op_rm                           ZYAN_BITFIELD(ZYDIS_OPDEF_REQUIRED_BITS)
#endif

#define ZYDIS_INSTRUCTION_DEFINITION_BASE_VECTOR \
    ZYDIS_INSTRUCTION_DEFINITION_BASE; \
    ZyanU8 op_ndsndd                       ZYAN_BITFIELD(ZYDIS_OPDEF_REQUIRED_BITS)

#define ZYDIS_INSTRUCTION_DEFINITION_BASE_VECTOR_INTEL \
    ZYDIS_INSTRUCTION_DEFINITION_BASE_VECTOR; \
    ZyanBool is_gather                     ZYAN_BITFIELD( 1); \
    ZyanBool no_source_dest_match          ZYAN_BITFIELD( 1); \
    ZyanBool no_source_source_match        ZYAN_BITFIELD( 1)        // TODO: Could be moved to VEX

/**
 * Defines the `ZydisInstructionDefinition` struct.
 */
typedef struct ZydisInstructionDefinition_
{
    ZYDIS_INSTRUCTION_DEFINITION_BASE;
} ZydisInstructionDefinition;

/**
 * Defines the `ZydisInstructionDefinitionLEGACY` struct.
 */
typedef struct ZydisInstructionDefinitionLEGACY_
{
    ZYDIS_INSTRUCTION_DEFINITION_BASE;
#ifndef ZYDIS_MINIMAL_MODE
    ZyanBool is_privileged                 ZYAN_BITFIELD( 1);
#endif
    ZyanBool accepts_LOCK                  ZYAN_BITFIELD( 1);
#ifndef ZYDIS_MINIMAL_MODE
    ZyanBool accepts_REP                   ZYAN_BITFIELD( 1);
    ZyanBool accepts_REPEREPZ              ZYAN_BITFIELD( 1);
    ZyanBool accepts_REPNEREPNZ            ZYAN_BITFIELD( 1);
    ZyanBool accepts_BOUND                 ZYAN_BITFIELD( 1);
    ZyanBool accepts_XACQUIRE              ZYAN_BITFIELD( 1);
    ZyanBool accepts_XRELEASE              ZYAN_BITFIELD( 1);
    ZyanBool accepts_NOTRACK               ZYAN_BITFIELD( 1);
    ZyanBool accepts_hle_without_lock      ZYAN_BITFIELD( 1);
    ZyanBool accepts_branch_hints          ZYAN_BITFIELD( 1);
#endif
} ZydisInstructionDefinitionLEGACY;

/**
 * Defines the `ZydisInstructionDefinition3DNOW` struct.
 */
typedef struct ZydisInstructionDefinition3DNOW_
{
    ZYDIS_INSTRUCTION_DEFINITION_BASE;
} ZydisInstructionDefinition3DNOW;

/**
 * Defines the `ZydisInstructionDefinitionXOP` struct.
 */
typedef struct ZydisInstructionDefinitionXOP_
{
    ZYDIS_INSTRUCTION_DEFINITION_BASE_VECTOR;
} ZydisInstructionDefinitionXOP;

// MSVC does not correctly execute the `pragma pack(1)` compiler-directive, if we use the correct
// enum types
ZYAN_STATIC_ASSERT(ZYDIS_VEX_STATIC_BROADCAST_REQUIRED_BITS  <=  8);

/**
 * Defines the `ZydisInstructionDefinitionVEX` struct.
 */
typedef struct ZydisInstructionDefinitionVEX_
{
    ZYDIS_INSTRUCTION_DEFINITION_BASE_VECTOR_INTEL;
#ifndef ZYDIS_MINIMAL_MODE
    ZyanU8 broadcast                       ZYAN_BITFIELD(ZYDIS_VEX_STATIC_BROADCAST_REQUIRED_BITS);
#endif
} ZydisInstructionDefinitionVEX;

#ifndef ZYDIS_DISABLE_AVX512

// MSVC does not correctly execute the `pragma pack(1)` compiler-directive, if we use the correct
// enum types
ZYAN_STATIC_ASSERT(ZYDIS_IVECTOR_LENGTH_REQUIRED_BITS        <=  8);
ZYAN_STATIC_ASSERT(ZYDIS_TUPLETYPE_REQUIRED_BITS             <=  8);
ZYAN_STATIC_ASSERT(ZYDIS_IELEMENT_SIZE_REQUIRED_BITS         <=  8);
ZYAN_STATIC_ASSERT(ZYDIS_EVEX_FUNC_REQUIRED_BITS             <=  8);
ZYAN_STATIC_ASSERT(ZYDIS_MASK_POLICY_REQUIRED_BITS           <=  8);
ZYAN_STATIC_ASSERT(ZYDIS_MASK_OVERRIDE_REQUIRED_BITS         <=  8);
ZYAN_STATIC_ASSERT(ZYDIS_EVEX_STATIC_BROADCAST_REQUIRED_BITS <=  8);

/**
 * Defines the `ZydisInstructionDefinitionEVEX` struct.
 */
typedef struct ZydisInstructionDefinitionEVEX_
{
    ZYDIS_INSTRUCTION_DEFINITION_BASE_VECTOR_INTEL;
#ifndef ZYDIS_MINIMAL_MODE
    ZyanU8 vector_length                   ZYAN_BITFIELD(ZYDIS_IVECTOR_LENGTH_REQUIRED_BITS);
    ZyanU8 tuple_type                      ZYAN_BITFIELD(ZYDIS_TUPLETYPE_REQUIRED_BITS);
    ZyanU8 element_size                    ZYAN_BITFIELD(ZYDIS_IELEMENT_SIZE_REQUIRED_BITS);
    ZyanU8 functionality                   ZYAN_BITFIELD(ZYDIS_EVEX_FUNC_REQUIRED_BITS);
#endif
    ZyanU8 mask_policy                     ZYAN_BITFIELD(ZYDIS_MASK_POLICY_REQUIRED_BITS);
    ZyanBool accepts_zero_mask             ZYAN_BITFIELD( 1);
#ifndef ZYDIS_MINIMAL_MODE
    ZyanU8 mask_override                   ZYAN_BITFIELD(ZYDIS_MASK_OVERRIDE_REQUIRED_BITS);
    ZyanU8 broadcast                       ZYAN_BITFIELD(ZYDIS_EVEX_STATIC_BROADCAST_REQUIRED_BITS);
#endif
} ZydisInstructionDefinitionEVEX;
#endif

#ifndef ZYDIS_DISABLE_KNC

// MSVC does not correctly execute the `pragma pack(1)` compiler-directive, if we use the correct
// enum types
ZYAN_STATIC_ASSERT(ZYDIS_MVEX_FUNC_REQUIRED_BITS             <=  8);
ZYAN_STATIC_ASSERT(ZYDIS_MASK_POLICY_REQUIRED_BITS           <=  8);
ZYAN_STATIC_ASSERT(ZYDIS_MVEX_STATIC_BROADCAST_REQUIRED_BITS <=  8);

/**
 * Defines the `ZydisInstructionDefinitionMVEX` struct.
 */
typedef struct ZydisInstructionDefinitionMVEX_
{
    ZYDIS_INSTRUCTION_DEFINITION_BASE_VECTOR_INTEL;
    ZyanU8 functionality                   ZYAN_BITFIELD(ZYDIS_MVEX_FUNC_REQUIRED_BITS);
    ZyanU8 mask_policy                     ZYAN_BITFIELD(ZYDIS_MASK_POLICY_REQUIRED_BITS);
#ifndef ZYDIS_MINIMAL_MODE
    ZyanBool has_element_granularity       ZYAN_BITFIELD( 1);
    ZyanU8 broadcast                       ZYAN_BITFIELD(ZYDIS_MVEX_STATIC_BROADCAST_REQUIRED_BITS);
#endif
} ZydisInstructionDefinitionMVEX;
#endif

/* ---------------------------------------------------------------------------------------------- */

#pragma pack(pop)

#ifdef ZYAN_MSVC
#   pragma warning(pop)
#endif

/* ---------------------------------------------------------------------------------------------- */
/* Accessed CPU/FPU flags                                                                         */
/* ---------------------------------------------------------------------------------------------- */

/*
 * Contains information about the CPU/FPU flags accessed by an instruction.
 *
 * We don't want this struct to be packed! A pointer to the individual members will be used by the
 * `ZydisDecodedInstruction` struct.
 */
typedef struct ZydisDefinitionAccessedFlags_
{
    ZydisAccessedFlags cpu_flags;
    ZydisAccessedFlags fpu_flags;
} ZydisDefinitionAccessedFlags;

/* ---------------------------------------------------------------------------------------------- */

/* ============================================================================================== */
/* Functions                                                                                      */
/* ============================================================================================== */

/* ---------------------------------------------------------------------------------------------- */
/* Instruction definition                                                                         */
/* ---------------------------------------------------------------------------------------------- */

/**
 * Returns the instruction-definition with the given `encoding` and `id`.
 *
 * @param   encoding    The instruction-encoding.
 * @param   id          The definition-id.
 * @param   definition  A pointer to the variable that receives a pointer to the instruction-
 *                      definition.
 */
ZYDIS_NO_EXPORT void ZydisGetInstructionDefinition(ZydisInstructionEncoding encoding,
    ZyanU16 id, const ZydisInstructionDefinition** definition);

/* ---------------------------------------------------------------------------------------------- */
/* Operand definition                                                                             */
/* ---------------------------------------------------------------------------------------------- */

#ifndef ZYDIS_MINIMAL_MODE
/**
 * Returns the the operand-definitions for the given instruction-`definition`.
 *
 * @param   definition  A pointer to the instruction-definition.
 *
 * @return  A pointer to the first operand definition of the instruction, or `ZYAN_NULL`.
 */
ZYDIS_NO_EXPORT const ZydisOperandDefinition* ZydisGetOperandDefinitions(
    const ZydisInstructionDefinition* definition);
#endif

/* ---------------------------------------------------------------------------------------------- */
/* Element info                                                                                   */
/* ---------------------------------------------------------------------------------------------- */

#ifndef ZYDIS_MINIMAL_MODE
/**
 * Returns the actual type and size of an internal element-type.
 *
 * @param   element The internal element type.
 * @param   type    The actual element type.
 * @param   size    The element size.
 */
ZYDIS_NO_EXPORT void ZydisGetElementInfo(ZydisInternalElementType element, ZydisElementType* type,
    ZydisElementSize* size);
#endif

/* ---------------------------------------------------------------------------------------------- */
/* Accessed CPU flags                                                                             */
/* ---------------------------------------------------------------------------------------------- */

#ifndef ZYDIS_MINIMAL_MODE
/**
 * Returns the the operand-definitions for the given instruction-`definition`.
 *
 * @param   definition  A pointer to the instruction-definition.
 * @param   flags       A pointer to the variable that receives the `ZydisDefinitionAccessedFlags`
 *                      struct.
 *
 * @return  `ZYAN_TRUE`, if the instruction accesses any flags, or `ZYAN_FALSE`, if not.
 */
ZYDIS_NO_EXPORT ZyanBool ZydisGetAccessedFlags(const ZydisInstructionDefinition* definition,
    const ZydisDefinitionAccessedFlags** flags);
#endif

/* ---------------------------------------------------------------------------------------------- */

/* ============================================================================================== */

#ifdef __cplusplus
}
#endif

#endif /* ZYDIS_INTERNAL_SHAREDDATA_H */

/* ============================================================================================== */
/* Internal enums and types                                                                       */
/* ============================================================================================== */

/* ---------------------------------------------------------------------------------------------- */
/* Decoder context                                                                                */
/* ---------------------------------------------------------------------------------------------- */

/**
 * Defines the `ZydisDecoderState` struct.
 */
typedef struct ZydisDecoderState_
{
    /**
     * A pointer to the `ZydisDecoder` instance.
     */
    const ZydisDecoder* decoder;
    /**
     * A pointer to the `ZydisDecoderContext` struct.
     */
    ZydisDecoderContext* context;
    /**
     * The input buffer.
     */
    const ZyanU8* buffer;
    /**
     * The input buffer length.
     */
    ZyanUSize buffer_len;
    /**
     * Prefix information.
     */
    struct
    {
        /**
         * Signals, if the instruction has a `LOCK` prefix (`F0`).
         *
         * This prefix originally belongs to group 1, but separating it from the other ones makes
         * parsing easier for us later.
         */
        ZyanBool has_lock;
        /**
         * The effective prefix of group 1 (either `F2` or `F3`).
         */
        ZyanU8 group1;
        /**
         * The effective prefix of group 2 (`2E`, `36`, `3E`, `26`, `64` or `65`).
         */
        ZyanU8 group2;
        /**
         * The effective segment prefix.
         */
        ZyanU8 effective_segment;
        /**
         * The prefix that should be treated as the mandatory-prefix, if the
         * current instruction needs one.
         *
         * The last `F3`/`F2` prefix has precedence over previous ones and
         * `F3`/`F2` in general have precedence over `66`.
         */
        ZyanU8 mandatory_candidate;
        /**
         * The offset of the effective `LOCK` prefix.
         */
        ZyanU8 offset_lock;
        /**
         * The offset of the effective prefix in group 1.
         */
        ZyanU8 offset_group1;
        /**
         * The offset of the effective prefix in group 2.
         */
        ZyanU8 offset_group2;
        /**
         * The offset of the operand-size override prefix (`66`).
         *
         * This is the only prefix in group 3.
         */
        ZyanU8 offset_osz_override;
        /**
         * The offset of the address-size override prefix (`67`).
         *
         * This is the only prefix in group 4.
         */
        ZyanU8 offset_asz_override;
        /**
         * The offset of the effective segment prefix.
         */
        ZyanU8 offset_segment;
        /**
         * The offset of the mandatory-candidate prefix.
         */
        ZyanU8 offset_mandatory;
        /**
         * The offset of a possible `CET` `no-lock` prefix.
         */
        ZyanI8 offset_notrack;
    } prefixes;
} ZydisDecoderState;

/* ---------------------------------------------------------------------------------------------- */
/* Register encoding                                                                              */
/* ---------------------------------------------------------------------------------------------- */

/**
 * Defines the `ZydisRegisterEncoding` enum.
 */
typedef enum ZydisRegisterEncoding_
{
    ZYDIS_REG_ENCODING_INVALID,
    /**
     * The register-id is encoded as part of the opcode (bits [3..0]).
     *
     * Possible extension by:
     * - `REX.B`
     */
    ZYDIS_REG_ENCODING_OPCODE,
    /**
     * The register-id is encoded in `modrm.reg`.
     *
     * Possible extension by:
     * - `.R`
     * - `.R'` (vector only, EVEX/MVEX)
     */
    ZYDIS_REG_ENCODING_REG,
    /**
     * The register-id is encoded in `.vvvv`.
     *
     * Possible extension by:
     * - `.v'` (vector only, EVEX/MVEX).
     */
    ZYDIS_REG_ENCODING_NDSNDD,
    /**
     * The register-id is encoded in `modrm.rm`.
     *
     * Possible extension by:
     * - `.B`
     * - `.X` (vector only, EVEX/MVEX)`
     */
    ZYDIS_REG_ENCODING_RM,
    /**
     * The register-id is encoded in `modrm.rm` or `sib.base` (if `SIB` is present).
     *
     * Possible extension by:
     * - `.B`
     */
    ZYDIS_REG_ENCODING_BASE,
    /**
     * The register-id is encoded in `sib.index`.
     *
     * Possible extension by:
     * - `.X`
     */
    ZYDIS_REG_ENCODING_INDEX,
    /**
     * The register-id is encoded in `sib.index`.
     *
     * Possible extension by:
     * - `.X`
     * - `.V'` (vector only, EVEX/MVEX)
     */
    ZYDIS_REG_ENCODING_VIDX,
    /**
     * The register-id is encoded in an additional 8-bit immediate value.
     *
     * Bits [7:4] in 64-bit mode with possible extension by bit [3] (vector only), bits [7:5] for
     * all other modes.
     */
    ZYDIS_REG_ENCODING_IS4,
    /**
     * The register-id is encoded in `EVEX.aaa/MVEX.kkk`.
     */
    ZYDIS_REG_ENCODING_MASK,

    /**
     * Maximum value of this enum.
     */
    ZYDIS_REG_ENCODING_MAX_VALUE = ZYDIS_REG_ENCODING_MASK,
    /**
     * The minimum number of bits required to represent all values of this enum.
     */
    ZYDIS_REG_ENCODING_REQUIRED_BITS = ZYAN_BITS_TO_REPRESENT(ZYDIS_REG_ENCODING_MAX_VALUE)
} ZydisRegisterEncoding;

/* ---------------------------------------------------------------------------------------------- */

/* ============================================================================================== */
/* Internal functions                                                                             */
/* ============================================================================================== */

/* ---------------------------------------------------------------------------------------------- */
/* Input helper functions                                                                         */
/* ---------------------------------------------------------------------------------------------- */

/**
 * Reads one byte from the current read-position of the input data-source.
 *
 * @param   state       A pointer to the `ZydisDecoderState` struct.
 * @param   instruction A pointer to the `ZydisDecodedInstruction` struct.
 * @param   value       A pointer to the memory that receives the byte from the input data-source.
 *
 * @return  A zyan status code.
 *
 * This function may fail, if the `ZYDIS_MAX_INSTRUCTION_LENGTH` limit got exceeded, or no more
 * data is available.
 */
static ZyanStatus ZydisInputPeek(ZydisDecoderState* state,
    ZydisDecodedInstruction* instruction, ZyanU8* value)
{
    ZYAN_ASSERT(state);
    ZYAN_ASSERT(instruction);
    ZYAN_ASSERT(value);

    if (instruction->length >= ZYDIS_MAX_INSTRUCTION_LENGTH)
    {
        return ZYDIS_STATUS_INSTRUCTION_TOO_LONG;
    }

    if (state->buffer_len > 0)
    {
        *value = state->buffer[0];
        return ZYAN_STATUS_SUCCESS;
    }

    return ZYDIS_STATUS_NO_MORE_DATA;
}

/**
 * Increases the read-position of the input data-source by one byte.
 *
 * @param   state       A pointer to the `ZydisDecoderState` instance
 * @param   instruction A pointer to the `ZydisDecodedInstruction` struct.
 *
 * This function is supposed to get called ONLY after a successful call of `ZydisInputPeek`.
 *
 * This function increases the `length` field of the `ZydisDecodedInstruction` struct by one.
 */
static void ZydisInputSkip(ZydisDecoderState* state, ZydisDecodedInstruction* instruction)
{
    ZYAN_ASSERT(state);
    ZYAN_ASSERT(instruction);
    ZYAN_ASSERT(instruction->length < ZYDIS_MAX_INSTRUCTION_LENGTH);

    ++instruction->length;
    ++state->buffer;
    --state->buffer_len;
}

/**
 * Reads one byte from the current read-position of the input data-source and increases
 *          the read-position by one byte afterwards.
 *
 * @param   state       A pointer to the `ZydisDecoderState` struct.
 * @param   instruction A pointer to the `ZydisDecodedInstruction` struct.
 * @param   value       A pointer to the memory that receives the byte from the input data-source.
 *
 * @return  A zyan status code.
 *
 * This function acts like a subsequent call of `ZydisInputPeek` and `ZydisInputSkip`.
 */
static ZyanStatus ZydisInputNext(ZydisDecoderState* state,
    ZydisDecodedInstruction* instruction, ZyanU8* value)
{
    ZYAN_ASSERT(state);
    ZYAN_ASSERT(instruction);
    ZYAN_ASSERT(value);

    if (instruction->length >= ZYDIS_MAX_INSTRUCTION_LENGTH)
    {
        return ZYDIS_STATUS_INSTRUCTION_TOO_LONG;
    }

    if (state->buffer_len > 0)
    {
        *value = state->buffer++[0];
        ++instruction->length;
        --state->buffer_len;
        return ZYAN_STATUS_SUCCESS;
    }

    return ZYDIS_STATUS_NO_MORE_DATA;
}

/**
 * Reads a variable amount of bytes from the current read-position of the input
 *          data-source and increases the read-position by specified amount of bytes afterwards.
 *
 * @param   state           A pointer to the `ZydisDecoderState` struct.
 * @param   instruction     A pointer to the `ZydisDecodedInstruction` struct.
 * @param   value           A pointer to the memory that receives the byte from the input
 *                          data-source.
 * @param   number_of_bytes The number of bytes to read from the input data-source.
 *
 * @return  A zyan status code.
 *
 * This function acts like a subsequent call of `ZydisInputPeek` and `ZydisInputSkip`.
 */
static ZyanStatus ZydisInputNextBytes(ZydisDecoderState* state,
    ZydisDecodedInstruction* instruction, ZyanU8* value, ZyanU8 number_of_bytes)
{
    ZYAN_ASSERT(state);
    ZYAN_ASSERT(instruction);
    ZYAN_ASSERT(value);

    if (instruction->length + number_of_bytes > ZYDIS_MAX_INSTRUCTION_LENGTH)
    {
        return ZYDIS_STATUS_INSTRUCTION_TOO_LONG;
    }

    if (state->buffer_len >= number_of_bytes)
    {
        instruction->length += number_of_bytes;

        ZYAN_MEMCPY(value, state->buffer, number_of_bytes);
        state->buffer += number_of_bytes;
        state->buffer_len -= number_of_bytes;

        return ZYAN_STATUS_SUCCESS;
    }

    return ZYDIS_STATUS_NO_MORE_DATA;
}

/* ---------------------------------------------------------------------------------------------- */
/* Decode functions                                                                               */
/* ---------------------------------------------------------------------------------------------- */

/**
 * Decodes the `REX`-prefix.
 *
 * @param   context     A pointer to the `ZydisDecoderContext` struct.
 * @param   instruction A pointer to the `ZydisDecodedInstruction` struct.
 * @param   data        The `REX` byte.
 */
static void ZydisDecodeREX(ZydisDecoderContext* context, ZydisDecodedInstruction* instruction,
    ZyanU8 data)
{
    ZYAN_ASSERT(instruction);
    ZYAN_ASSERT((data & 0xF0) == 0x40);

    instruction->attributes |= ZYDIS_ATTRIB_HAS_REX;
    instruction->raw.rex.W   = (data >> 3) & 0x01;
    instruction->raw.rex.R   = (data >> 2) & 0x01;
    instruction->raw.rex.X   = (data >> 1) & 0x01;
    instruction->raw.rex.B   = (data >> 0) & 0x01;

    // Update internal fields
    context->vector_unified.W = instruction->raw.rex.W;
    context->vector_unified.R = instruction->raw.rex.R;
    context->vector_unified.X = instruction->raw.rex.X;
    context->vector_unified.B = instruction->raw.rex.B;
}

/**
 * Decodes the `XOP`-prefix.
 *
 * @param   context     A pointer to the `ZydisDecoderContext` struct.
 * @param   instruction A pointer to the `ZydisDecodedInstruction` struct.
 * @param   data        The `XOP` bytes.
 *
 * @return  A zyan status code.
 */
static ZyanStatus ZydisDecodeXOP(ZydisDecoderContext* context,
    ZydisDecodedInstruction* instruction, const ZyanU8 data[3])
{
    ZYAN_ASSERT(instruction);
    ZYAN_ASSERT(data[0] == 0x8F);
    ZYAN_ASSERT(((data[1] >> 0) & 0x1F) >= 8);
    ZYAN_ASSERT(instruction->raw.xop.offset == instruction->length - 3);

    if (instruction->machine_mode == ZYDIS_MACHINE_MODE_REAL_16)
    {
        // XOP is invalid in 16-bit real mode
        return ZYDIS_STATUS_DECODING_ERROR;
    }

    instruction->attributes |= ZYDIS_ATTRIB_HAS_XOP;
    instruction->raw.xop.R       = (data[1] >> 7) & 0x01;
    instruction->raw.xop.X       = (data[1] >> 6) & 0x01;
    instruction->raw.xop.B       = (data[1] >> 5) & 0x01;
    instruction->raw.xop.m_mmmm  = (data[1] >> 0) & 0x1F;

    if ((instruction->raw.xop.m_mmmm < 0x08) || (instruction->raw.xop.m_mmmm > 0x0A))
    {
        // Invalid according to the AMD documentation
        return ZYDIS_STATUS_INVALID_MAP;
    }

    instruction->raw.xop.W    = (data[2] >> 7) & 0x01;
    instruction->raw.xop.vvvv = (data[2] >> 3) & 0x0F;
    instruction->raw.xop.L    = (data[2] >> 2) & 0x01;
    instruction->raw.xop.pp   = (data[2] >> 0) & 0x03;

    // Update internal fields
    context->vector_unified.W    = instruction->raw.xop.W;
    context->vector_unified.R    = 0x01 & ~instruction->raw.xop.R;
    context->vector_unified.X    = 0x01 & ~instruction->raw.xop.X;
    context->vector_unified.B    = 0x01 & ~instruction->raw.xop.B;
    context->vector_unified.L    = instruction->raw.xop.L;
    context->vector_unified.LL   = instruction->raw.xop.L;
    context->vector_unified.vvvv = (0x0F & ~instruction->raw.xop.vvvv);

    return ZYAN_STATUS_SUCCESS;
}

/**
 * Decodes the `VEX`-prefix.
 *
 * @param   context     A pointer to the `ZydisDecoderContext` struct.
 * @param   instruction A pointer to the `ZydisDecodedInstruction` struct.
 * @param   data        The `VEX` bytes.
 *
 * @return  A zyan status code.
 */
static ZyanStatus ZydisDecodeVEX(ZydisDecoderContext* context,
    ZydisDecodedInstruction* instruction, const ZyanU8 data[3])
{
    ZYAN_ASSERT(instruction);
    ZYAN_ASSERT((data[0] == 0xC4) || (data[0] == 0xC5));

    if (instruction->machine_mode == ZYDIS_MACHINE_MODE_REAL_16)
    {
        // VEX is invalid in 16-bit real mode
        return ZYDIS_STATUS_DECODING_ERROR;
    }

    instruction->attributes |= ZYDIS_ATTRIB_HAS_VEX;
    switch (data[0])
    {
    case 0xC4:
        ZYAN_ASSERT(instruction->raw.vex.offset == instruction->length - 3);
        instruction->raw.vex.size    = 3;
        instruction->raw.vex.R       = (data[1] >> 7) & 0x01;
        instruction->raw.vex.X       = (data[1] >> 6) & 0x01;
        instruction->raw.vex.B       = (data[1] >> 5) & 0x01;
        instruction->raw.vex.m_mmmm  = (data[1] >> 0) & 0x1F;
        instruction->raw.vex.W       = (data[2] >> 7) & 0x01;
        instruction->raw.vex.vvvv    = (data[2] >> 3) & 0x0F;
        instruction->raw.vex.L       = (data[2] >> 2) & 0x01;
        instruction->raw.vex.pp      = (data[2] >> 0) & 0x03;
        break;
    case 0xC5:
        ZYAN_ASSERT(instruction->raw.vex.offset == instruction->length - 2);
        instruction->raw.vex.size    = 2;
        instruction->raw.vex.R       = (data[1] >> 7) & 0x01;
        instruction->raw.vex.X       = 1;
        instruction->raw.vex.B       = 1;
        instruction->raw.vex.m_mmmm  = 1;
        instruction->raw.vex.W       = 0;
        instruction->raw.vex.vvvv    = (data[1] >> 3) & 0x0F;
        instruction->raw.vex.L       = (data[1] >> 2) & 0x01;
        instruction->raw.vex.pp      = (data[1] >> 0) & 0x03;
        break;
    default:
        ZYAN_UNREACHABLE;
    }

    // Map 0 is only valid for some KNC instructions
#ifdef ZYDIS_DISABLE_KNC
    if ((instruction->raw.vex.m_mmmm == 0) || (instruction->raw.vex.m_mmmm > 0x03))
#else
    if (instruction->raw.vex.m_mmmm > 0x03)
#endif
    {
        // Invalid according to the intel documentation
        return ZYDIS_STATUS_INVALID_MAP;
    }

    // Update internal fields
    context->vector_unified.W    = instruction->raw.vex.W;
    context->vector_unified.R    = 0x01 & ~instruction->raw.vex.R;
    context->vector_unified.X    = 0x01 & ~instruction->raw.vex.X;
    context->vector_unified.B    = 0x01 & ~instruction->raw.vex.B;
    context->vector_unified.L    = instruction->raw.vex.L;
    context->vector_unified.LL   = instruction->raw.vex.L;
    context->vector_unified.vvvv = (0x0F & ~instruction->raw.vex.vvvv);

    return ZYAN_STATUS_SUCCESS;
}

#ifndef ZYDIS_DISABLE_AVX512
/**
 * Decodes the `EVEX`-prefix.
 *
 * @param   context     A pointer to the `ZydisDecoderContext` struct.
 * @param   instruction A pointer to the `ZydisDecodedInstruction` struct.
 * @param   data        The `EVEX` bytes.
 *
 * @return  A zyan status code.
 */
static ZyanStatus ZydisDecodeEVEX(ZydisDecoderContext* context,
    ZydisDecodedInstruction* instruction, const ZyanU8 data[4])
{
    ZYAN_ASSERT(instruction);
    ZYAN_ASSERT(data[0] == 0x62);
    ZYAN_ASSERT(instruction->raw.evex.offset == instruction->length - 4);

    if (instruction->machine_mode == ZYDIS_MACHINE_MODE_REAL_16)
    {
        // EVEX is invalid in 16-bit real mode
        return ZYDIS_STATUS_DECODING_ERROR;
    }

    instruction->attributes |= ZYDIS_ATTRIB_HAS_EVEX;
    instruction->raw.evex.R         = (data[1] >> 7) & 0x01;
    instruction->raw.evex.X         = (data[1] >> 6) & 0x01;
    instruction->raw.evex.B         = (data[1] >> 5) & 0x01;
    instruction->raw.evex.R2        = (data[1] >> 4) & 0x01;

    if (data[1] & 0x08)
    {
        // Invalid according to the intel documentation
        return ZYDIS_STATUS_MALFORMED_EVEX;
    }

    instruction->raw.evex.mmm       = (data[1] >> 0) & 0x07;

    if ((instruction->raw.evex.mmm == 0x00) ||
        (instruction->raw.evex.mmm == 0x04) ||
        (instruction->raw.evex.mmm == 0x07))
    {
        // Invalid according to the intel documentation
        return ZYDIS_STATUS_INVALID_MAP;
    }

    instruction->raw.evex.W         = (data[2] >> 7) & 0x01;
    instruction->raw.evex.vvvv      = (data[2] >> 3) & 0x0F;

    ZYAN_ASSERT(((data[2] >> 2) & 0x01) == 0x01);

    instruction->raw.evex.pp        = (data[2] >> 0) & 0x03;
    instruction->raw.evex.z         = (data[3] >> 7) & 0x01;
    instruction->raw.evex.L2        = (data[3] >> 6) & 0x01;
    instruction->raw.evex.L         = (data[3] >> 5) & 0x01;
    instruction->raw.evex.b         = (data[3] >> 4) & 0x01;
    instruction->raw.evex.V2        = (data[3] >> 3) & 0x01;

    if (!instruction->raw.evex.V2 &&
        (instruction->machine_mode != ZYDIS_MACHINE_MODE_LONG_64))
    {
        return ZYDIS_STATUS_MALFORMED_EVEX;
    }

    instruction->raw.evex.aaa       = (data[3] >> 0) & 0x07;

    if (instruction->raw.evex.z && !instruction->raw.evex.aaa)
    {
        return ZYDIS_STATUS_INVALID_MASK; // TODO: Dedicated status code
    }

    // Update internal fields
    context->vector_unified.W    = instruction->raw.evex.W;
    context->vector_unified.R    = 0x01 & ~instruction->raw.evex.R;
    context->vector_unified.X    = 0x01 & ~instruction->raw.evex.X;
    context->vector_unified.B    = 0x01 & ~instruction->raw.evex.B;
    context->vector_unified.LL   = (data[3] >> 5) & 0x03;
    context->vector_unified.R2   = 0x01 & ~instruction->raw.evex.R2;
    context->vector_unified.V2   = 0x01 & ~instruction->raw.evex.V2;
    context->vector_unified.vvvv = 0x0F & ~instruction->raw.evex.vvvv;
    context->vector_unified.mask = instruction->raw.evex.aaa;

    if (!instruction->raw.evex.V2 && (instruction->machine_mode != ZYDIS_MACHINE_MODE_LONG_64))
    {
        return ZYDIS_STATUS_MALFORMED_EVEX;
    }
    if (!instruction->raw.evex.b && (context->vector_unified.LL == 3))
    {
        // LL = 3 is only valid for instructions with embedded rounding control
        return ZYDIS_STATUS_MALFORMED_EVEX;
    }

    return ZYAN_STATUS_SUCCESS;
}
#endif

#ifndef ZYDIS_DISABLE_KNC
/**
 * Decodes the `MVEX`-prefix.
 *
 * @param   context     A pointer to the `ZydisDecoderContext` struct.
 * @param   instruction A pointer to the `ZydisDecodedInstruction` struct.
 * @param   data        The `MVEX` bytes.
 *
 * @return  A zyan status code.
 */
static ZyanStatus ZydisDecodeMVEX(ZydisDecoderContext* context,
    ZydisDecodedInstruction* instruction, const ZyanU8 data[4])
{
    ZYAN_ASSERT(instruction);
    ZYAN_ASSERT(data[0] == 0x62);
    ZYAN_ASSERT(instruction->raw.mvex.offset == instruction->length - 4);

    if (instruction->machine_mode != ZYDIS_MACHINE_MODE_LONG_64)
    {
        // MVEX is only valid in 64-bit mode
        return ZYDIS_STATUS_DECODING_ERROR;
    }

    instruction->attributes |= ZYDIS_ATTRIB_HAS_MVEX;
    instruction->raw.mvex.R    = (data[1] >> 7) & 0x01;
    instruction->raw.mvex.X    = (data[1] >> 6) & 0x01;
    instruction->raw.mvex.B    = (data[1] >> 5) & 0x01;
    instruction->raw.mvex.R2   = (data[1] >> 4) & 0x01;
    instruction->raw.mvex.mmmm = (data[1] >> 0) & 0x0F;

    if (instruction->raw.mvex.mmmm > 0x03)
    {
        // Invalid according to the intel documentation
        return ZYDIS_STATUS_INVALID_MAP;
    }

    instruction->raw.mvex.W    = (data[2] >> 7) & 0x01;
    instruction->raw.mvex.vvvv = (data[2] >> 3) & 0x0F;

    ZYAN_ASSERT(((data[2] >> 2) & 0x01) == 0x00);

    instruction->raw.mvex.pp   = (data[2] >> 0) & 0x03;
    instruction->raw.mvex.E    = (data[3] >> 7) & 0x01;
    instruction->raw.mvex.SSS  = (data[3] >> 4) & 0x07;
    instruction->raw.mvex.V2   = (data[3] >> 3) & 0x01;
    instruction->raw.mvex.kkk  = (data[3] >> 0) & 0x07;

    // Update internal fields
    context->vector_unified.W    = instruction->raw.mvex.W;
    context->vector_unified.R    = 0x01 & ~instruction->raw.mvex.R;
    context->vector_unified.X    = 0x01 & ~instruction->raw.mvex.X;
    context->vector_unified.B    = 0x01 & ~instruction->raw.mvex.B;
    context->vector_unified.R2   = 0x01 & ~instruction->raw.mvex.R2;
    context->vector_unified.V2   = 0x01 & ~instruction->raw.mvex.V2;
    context->vector_unified.LL   = 2;
    context->vector_unified.vvvv = 0x0F & ~instruction->raw.mvex.vvvv;
    context->vector_unified.mask = instruction->raw.mvex.kkk;

    return ZYAN_STATUS_SUCCESS;
}
#endif

/**
 * Decodes the `ModRM`-byte.
 *
 * @param   instruction A pointer to the `ZydisDecodedInstruction` struct.
 * @param   data        The `ModRM` byte.
 */
static void ZydisDecodeModRM(ZydisDecodedInstruction* instruction, ZyanU8 data)
{
    ZYAN_ASSERT(instruction);
    ZYAN_ASSERT(!(instruction->attributes & ZYDIS_ATTRIB_HAS_MODRM));
    ZYAN_ASSERT(instruction->raw.modrm.offset == instruction->length - 1);

    instruction->attributes   |= ZYDIS_ATTRIB_HAS_MODRM;
    instruction->raw.modrm.mod = (data >> 6) & 0x03;
    instruction->raw.modrm.reg = (data >> 3) & 0x07;
    instruction->raw.modrm.rm  = (data >> 0) & 0x07;
}

/**
 * Decodes the `SIB`-byte.
 *
 * @param   instruction A pointer to the `ZydisDecodedInstruction` struct
 * @param   data        The `SIB` byte.
 */
static void ZydisDecodeSIB(ZydisDecodedInstruction* instruction, ZyanU8 data)
{
    ZYAN_ASSERT(instruction);
    ZYAN_ASSERT(instruction->attributes & ZYDIS_ATTRIB_HAS_MODRM);
    ZYAN_ASSERT(instruction->raw.modrm.rm == 4);
    ZYAN_ASSERT(!(instruction->attributes & ZYDIS_ATTRIB_HAS_SIB));
    ZYAN_ASSERT(instruction->raw.sib.offset == instruction->length - 1);

    instruction->attributes    |= ZYDIS_ATTRIB_HAS_SIB;
    instruction->raw.sib.scale = (data >> 6) & 0x03;
    instruction->raw.sib.index = (data >> 3) & 0x07;
    instruction->raw.sib.base  = (data >> 0) & 0x07;
}

/* ---------------------------------------------------------------------------------------------- */

/**
 * Reads a displacement value.
 *
 * @param   state       A pointer to the `ZydisDecoderState` struct.
 * @param   instruction A pointer to the `ZydisDecodedInstruction` struct.
 * @param   size        The physical size of the displacement value.
 *
 * @return  A zyan status code.
 */
static ZyanStatus ZydisReadDisplacement(ZydisDecoderState* state,
    ZydisDecodedInstruction* instruction, ZyanU8 size)
{
    ZYAN_ASSERT(state);
    ZYAN_ASSERT(instruction);
    ZYAN_ASSERT(instruction->raw.disp.size == 0);

    instruction->raw.disp.size = size;
    instruction->raw.disp.offset = instruction->length;

    switch (size)
    {
    case 8:
    {
        ZyanU8 value;
        ZYAN_CHECK(ZydisInputNext(state, instruction, &value));
        instruction->raw.disp.value = *(ZyanI8*)&value;
        break;
    }
    case 16:
    {
        ZyanU16 value;
        ZYAN_CHECK(ZydisInputNextBytes(state, instruction, (ZyanU8*)&value, 2));
        instruction->raw.disp.value = *(ZyanI16*)&value;
        break;
    }
    case 32:
    {
        ZyanU32 value;
        ZYAN_CHECK(ZydisInputNextBytes(state, instruction, (ZyanU8*)&value, 4));
        instruction->raw.disp.value = *(ZyanI32*)&value;
        break;
    }
    case 64:
    {
        ZyanU64 value;
        ZYAN_CHECK(ZydisInputNextBytes(state, instruction, (ZyanU8*)&value, 8));
        instruction->raw.disp.value = *(ZyanI64*)&value;
        break;
    }
    default:
        ZYAN_UNREACHABLE;
    }

    // TODO: Fix endianess on big-endian systems

    return ZYAN_STATUS_SUCCESS;
}

/**
 * Reads an immediate value.
 *
 * @param   state       A pointer to the `ZydisDecoderState` struct.
 * @param   instruction A pointer to the `ZydisDecodedInstruction` struct.
 * @param   id          The immediate id (either `0` or `1`).
 * @param   size        The physical size of the immediate value.
 * @param   is_signed   Signals, if the immediate value is signed.
 * @param   is_relative Signals, if the immediate value is a relative offset.
 *
 * @return  A zyan status code.
 */
static ZyanStatus ZydisReadImmediate(ZydisDecoderState* state,
    ZydisDecodedInstruction* instruction, ZyanU8 id, ZyanU8 size, ZyanBool is_signed,
    ZyanBool is_relative)
{
    ZYAN_ASSERT(state);
    ZYAN_ASSERT(instruction);
    ZYAN_ASSERT((id == 0) || (id == 1));
    ZYAN_ASSERT(is_signed || !is_relative);
    ZYAN_ASSERT(instruction->raw.imm[id].size == 0);

    instruction->raw.imm[id].size = size;
    instruction->raw.imm[id].offset = instruction->length;
    instruction->raw.imm[id].is_signed = is_signed;
    instruction->raw.imm[id].is_relative = is_relative;
    switch (size)
    {
    case 8:
    {
        ZyanU8 value;
        ZYAN_CHECK(ZydisInputNext(state, instruction, &value));
        if (is_signed)
        {
            instruction->raw.imm[id].value.s = (ZyanI8)value;
        } else
        {
            instruction->raw.imm[id].value.u = value;
        }
        break;
    }
    case 16:
    {
        ZyanU16 value;
        ZYAN_CHECK(ZydisInputNextBytes(state, instruction, (ZyanU8*)&value, 2));
        if (is_signed)
        {
            instruction->raw.imm[id].value.s = (ZyanI16)value;
        } else
        {
            instruction->raw.imm[id].value.u = value;
        }
        break;
    }
    case 32:
    {
        ZyanU32 value;
        ZYAN_CHECK(ZydisInputNextBytes(state, instruction, (ZyanU8*)&value, 4));
        if (is_signed)
        {
            instruction->raw.imm[id].value.s = (ZyanI32)value;
        } else
        {
            instruction->raw.imm[id].value.u = value;
        }
        break;
    }
    case 64:
    {
        ZyanU64 value;
        ZYAN_CHECK(ZydisInputNextBytes(state, instruction, (ZyanU8*)&value, 8));
        if (is_signed)
        {
            instruction->raw.imm[id].value.s = (ZyanI64)value;
        } else
        {
            instruction->raw.imm[id].value.u = value;
        }
        break;
    }
    default:
        ZYAN_UNREACHABLE;
    }

    // TODO: Fix endianess on big-endian systems

    return ZYAN_STATUS_SUCCESS;
}

/* ---------------------------------------------------------------------------------------------- */
/* Semantic instruction decoding                                                                  */
/* ---------------------------------------------------------------------------------------------- */

#ifndef ZYDIS_MINIMAL_MODE
/**
 * Calculates the register-id for a specific register-encoding and register-class.
 *
 * @param   context         A pointer to the `ZydisDecoderContext` struct.
 * @param   instruction     A pointer to the ` ZydisDecodedInstruction` struct.
 * @param   encoding        The register-encoding.
 * @param   register_class  The register-class.
 *
 * @return  A zyan status code.
 *
 * This function calculates the register-id by combining different fields and flags of previously
 * decoded structs.
 */
static ZyanU8 ZydisCalcRegisterId(const ZydisDecoderContext* context,
    const ZydisDecodedInstruction* instruction, ZydisRegisterEncoding encoding,
    ZydisRegisterClass register_class)
{
    ZYAN_ASSERT(context);
    ZYAN_ASSERT(instruction);

    // TODO: Combine OPCODE and IS4 in `ZydisPopulateRegisterIds` and get rid of this
    // TODO: function entirely

    switch (encoding)
    {
    case ZYDIS_REG_ENCODING_REG:
        return context->reg_info.id_reg;
    case ZYDIS_REG_ENCODING_NDSNDD:
        return context->reg_info.id_ndsndd;
    case ZYDIS_REG_ENCODING_RM:
        return context->reg_info.id_rm;
    case ZYDIS_REG_ENCODING_BASE:
        return context->reg_info.id_base;
    case ZYDIS_REG_ENCODING_INDEX:
    case ZYDIS_REG_ENCODING_VIDX:
        return context->reg_info.id_index;
    case ZYDIS_REG_ENCODING_OPCODE:
    {
        ZYAN_ASSERT((register_class == ZYDIS_REGCLASS_GPR8) ||
                    (register_class == ZYDIS_REGCLASS_GPR16) ||
                    (register_class == ZYDIS_REGCLASS_GPR32) ||
                    (register_class == ZYDIS_REGCLASS_GPR64));
        ZyanU8 value = (instruction->opcode & 0x0F);
        if (value > 7)
        {
            value = value - 8;
        }
        if (instruction->machine_mode != ZYDIS_MACHINE_MODE_LONG_64)
        {
            return value;
        }
        return value | (context->vector_unified.B << 3);
    }
    case ZYDIS_REG_ENCODING_IS4:
    {
        if (instruction->machine_mode != ZYDIS_MACHINE_MODE_LONG_64)
        {
            return (instruction->raw.imm[0].value.u >> 4) & 0x07;
        }
        ZyanU8 value = (instruction->raw.imm[0].value.u >> 4) & 0x0F;
        // We have to check the instruction-encoding, because the extension by bit [3] is only
        // valid for EVEX and MVEX instructions
        if ((instruction->encoding == ZYDIS_INSTRUCTION_ENCODING_EVEX) ||
            (instruction->encoding == ZYDIS_INSTRUCTION_ENCODING_MVEX))
        {
            switch (register_class)
            {
            case ZYDIS_REGCLASS_XMM:
            case ZYDIS_REGCLASS_YMM:
            case ZYDIS_REGCLASS_ZMM:
                value |= ((instruction->raw.imm[0].value.u & 0x08) << 1);
            default:
                break;
            }
        }
        return value;
    }
    case ZYDIS_REG_ENCODING_MASK:
        return context->vector_unified.mask;
    default:
        ZYAN_UNREACHABLE;
    }
}
#endif

#ifndef ZYDIS_MINIMAL_MODE
/**
 * Sets the operand-size and element-specific information for the given operand.
 *
 * @param   context         A pointer to the `ZydisDecoderContext` struct.
 * @param   instruction     A pointer to the `ZydisDecodedInstruction` struct.
 * @param   operand         A pointer to the `ZydisDecodedOperand` struct.
 * @param   definition      A pointer to the `ZydisOperandDefinition` struct.
 */
static void ZydisSetOperandSizeAndElementInfo(const ZydisDecoderContext* context,
    const ZydisDecodedInstruction* instruction, ZydisDecodedOperand* operand,
    const ZydisOperandDefinition* definition)
{
    ZYAN_ASSERT(context);
    ZYAN_ASSERT(instruction);
    ZYAN_ASSERT(operand);
    ZYAN_ASSERT(definition);

    // Operand size
    switch (operand->type)
    {
    case ZYDIS_OPERAND_TYPE_REGISTER:
    {
        if (definition->size[context->eosz_index])
        {
            operand->size = definition->size[context->eosz_index] * 8;
        } else
        {
            operand->size = ZydisRegisterGetWidth(instruction->machine_mode,
                operand->reg.value);
        }
        operand->element_type = ZYDIS_ELEMENT_TYPE_INT;
        operand->element_size = operand->size;
        break;
    }
    case ZYDIS_OPERAND_TYPE_MEMORY:
        switch (instruction->encoding)
        {
        case ZYDIS_INSTRUCTION_ENCODING_LEGACY:
        case ZYDIS_INSTRUCTION_ENCODING_3DNOW:
        case ZYDIS_INSTRUCTION_ENCODING_XOP:
        case ZYDIS_INSTRUCTION_ENCODING_VEX:
            if (operand->mem.type == ZYDIS_MEMOP_TYPE_AGEN)
            {
                ZYAN_ASSERT(definition->size[context->eosz_index] == 0);
                operand->size = instruction->address_width;
                operand->element_type = ZYDIS_ELEMENT_TYPE_INT;
            } else
            {
                ZYAN_ASSERT(definition->size[context->eosz_index] ||
                    (instruction->meta.category == ZYDIS_CATEGORY_AMX_TILE));
                operand->size = definition->size[context->eosz_index] * 8;
            }
            break;
        case ZYDIS_INSTRUCTION_ENCODING_EVEX:
#ifndef ZYDIS_DISABLE_AVX512
            if (definition->size[context->eosz_index])
            {
                // Operand size is hardcoded
                operand->size = definition->size[context->eosz_index] * 8;
            } else
            {
                // Operand size depends on the tuple-type, the element-size and the number of
                // elements
                ZYAN_ASSERT(instruction->avx.vector_length);
                ZYAN_ASSERT(context->evex.element_size);
                switch (context->evex.tuple_type)
                {
                case ZYDIS_TUPLETYPE_FV:
                    if (instruction->avx.broadcast.mode)
                    {
                        operand->size = context->evex.element_size;
                    } else
                    {
                        operand->size = instruction->avx.vector_length;
                    }
                    break;
                case ZYDIS_TUPLETYPE_HV:
                    if (instruction->avx.broadcast.mode)
                    {
                        operand->size = context->evex.element_size;
                    } else
                    {
                        operand->size = (ZyanU16)instruction->avx.vector_length / 2;
                    }
                    break;
                case ZYDIS_TUPLETYPE_QUARTER:
                    if (instruction->avx.broadcast.mode)
                    {
                        operand->size = context->evex.element_size;
                    }
                    else
                    {
                        operand->size = (ZyanU16)instruction->avx.vector_length / 4;
                    }
                    break;
                default:
                    ZYAN_UNREACHABLE;
                }
            }
            ZYAN_ASSERT(operand->size);
#else
            ZYAN_UNREACHABLE;
#endif
            break;
        case ZYDIS_INSTRUCTION_ENCODING_MVEX:
#ifndef ZYDIS_DISABLE_KNC
            if (definition->size[context->eosz_index])
            {
                // Operand size is hardcoded
                operand->size = definition->size[context->eosz_index] * 8;
            } else
            {
                ZYAN_ASSERT(definition->element_type == ZYDIS_IELEMENT_TYPE_VARIABLE);
                ZYAN_ASSERT(instruction->avx.vector_length == 512);

                switch (instruction->avx.conversion.mode)
                {
                case ZYDIS_CONVERSION_MODE_INVALID:
                    operand->size = 512;
                    switch (context->mvex.functionality)
                    {
                    case ZYDIS_MVEX_FUNC_SF_32:
                    case ZYDIS_MVEX_FUNC_SF_32_BCST_4TO16:
                    case ZYDIS_MVEX_FUNC_UF_32:
                    case ZYDIS_MVEX_FUNC_DF_32:
                        operand->element_type = ZYDIS_ELEMENT_TYPE_FLOAT32;
                        operand->element_size = 32;
                        break;
                    case ZYDIS_MVEX_FUNC_SF_32_BCST:
                        operand->size = 256;
                        operand->element_type = ZYDIS_ELEMENT_TYPE_FLOAT32;
                        operand->element_size = 32;
                        break;
                    case ZYDIS_MVEX_FUNC_SI_32:
                    case ZYDIS_MVEX_FUNC_SI_32_BCST_4TO16:
                    case ZYDIS_MVEX_FUNC_UI_32:
                    case ZYDIS_MVEX_FUNC_DI_32:
                        operand->element_type = ZYDIS_ELEMENT_TYPE_INT;
                        operand->element_size = 32;
                        break;
                    case ZYDIS_MVEX_FUNC_SI_32_BCST:
                        operand->size = 256;
                        operand->element_type = ZYDIS_ELEMENT_TYPE_INT;
                        operand->element_size = 32;
                        break;
                    case ZYDIS_MVEX_FUNC_SF_64:
                    case ZYDIS_MVEX_FUNC_UF_64:
                    case ZYDIS_MVEX_FUNC_DF_64:
                        operand->element_type = ZYDIS_ELEMENT_TYPE_FLOAT64;
                        operand->element_size = 64;
                        break;
                    case ZYDIS_MVEX_FUNC_SI_64:
                    case ZYDIS_MVEX_FUNC_UI_64:
                    case ZYDIS_MVEX_FUNC_DI_64:
                        operand->element_type = ZYDIS_ELEMENT_TYPE_INT;
                        operand->element_size = 64;
                        break;
                    default:
                        ZYAN_UNREACHABLE;
                    }
                    break;
                case ZYDIS_CONVERSION_MODE_FLOAT16:
                    operand->size = 256;
                    operand->element_type = ZYDIS_ELEMENT_TYPE_FLOAT16;
                    operand->element_size = 16;
                    break;
                case ZYDIS_CONVERSION_MODE_SINT16:
                    operand->size = 256;
                    operand->element_type = ZYDIS_ELEMENT_TYPE_INT;
                    operand->element_size = 16;
                    break;
                case ZYDIS_CONVERSION_MODE_UINT16:
                    operand->size = 256;
                    operand->element_type = ZYDIS_ELEMENT_TYPE_UINT;
                    operand->element_size = 16;
                    break;
                case ZYDIS_CONVERSION_MODE_SINT8:
                    operand->size = 128;
                    operand->element_type = ZYDIS_ELEMENT_TYPE_INT;
                    operand->element_size = 8;
                    break;
                case ZYDIS_CONVERSION_MODE_UINT8:
                    operand->size = 128;
                    operand->element_type = ZYDIS_ELEMENT_TYPE_UINT;
                    operand->element_size = 8;
                    break;
                default:
                    ZYAN_UNREACHABLE;
                }

                switch (instruction->avx.broadcast.mode)
                {
                case ZYDIS_BROADCAST_MODE_INVALID:
                    // Nothing to do here
                    break;
                case ZYDIS_BROADCAST_MODE_1_TO_8:
                case ZYDIS_BROADCAST_MODE_1_TO_16:
                    operand->size = operand->element_size;
                    break;
                case ZYDIS_BROADCAST_MODE_4_TO_8:
                case ZYDIS_BROADCAST_MODE_4_TO_16:
                    operand->size = operand->element_size * 4;
                    break;
                default:
                    ZYAN_UNREACHABLE;
                }
            }
#else
            ZYAN_UNREACHABLE;
#endif
            break;
        default:
            ZYAN_UNREACHABLE;
        }
        break;
    case ZYDIS_OPERAND_TYPE_POINTER:
        ZYAN_ASSERT((instruction->raw.imm[0].size == 16) ||
                    (instruction->raw.imm[0].size == 32));
        ZYAN_ASSERT( instruction->raw.imm[1].size == 16);
        operand->size = instruction->raw.imm[0].size + instruction->raw.imm[1].size;
        break;
    case ZYDIS_OPERAND_TYPE_IMMEDIATE:
        operand->size = definition->size[context->eosz_index] * 8;
        break;
    default:
        ZYAN_UNREACHABLE;
    }

    // Element-type and -size
    if (definition->element_type && (definition->element_type != ZYDIS_IELEMENT_TYPE_VARIABLE))
    {
        ZydisGetElementInfo(definition->element_type, &operand->element_type,
            &operand->element_size);
        if (!operand->element_size)
        {
            // The element size is the same as the operand size. This is used for single element
            // scaling operands
            operand->element_size = operand->size;
        }
    }

    // Element count
    if (operand->element_size && operand->size && (operand->element_type != ZYDIS_ELEMENT_TYPE_CC))
    {
        operand->element_count = operand->size / operand->element_size;
    } else
    {
        operand->element_count = 1;
    }
}
#endif

#ifndef ZYDIS_MINIMAL_MODE
/**
 * Decodes an register-operand.
 *
 * @param   instruction      A pointer to the `ZydisDecodedInstruction` struct.
 * @param   operand          A pointer to the `ZydisDecodedOperand` struct.
 * @param   register_class   The register class.
 * @param   register_id      The register id.
 *
 * @return  A zyan status code.
 */
static ZyanStatus ZydisDecodeOperandRegister(const ZydisDecodedInstruction* instruction,
    ZydisDecodedOperand* operand, ZydisRegisterClass register_class, ZyanU8 register_id)
{
    ZYAN_ASSERT(instruction);
    ZYAN_ASSERT(operand);

    operand->type = ZYDIS_OPERAND_TYPE_REGISTER;

    if (register_class == ZYDIS_REGCLASS_GPR8)
    {
        if ((instruction->attributes & ZYDIS_ATTRIB_HAS_REX) && (register_id >= 4))
        {
            operand->reg.value = ZYDIS_REGISTER_SPL + (register_id - 4);
        } else
        {
            operand->reg.value = ZYDIS_REGISTER_AL + register_id;
        }
    } else
    {
        operand->reg.value = ZydisRegisterEncode(register_class, register_id);
        ZYAN_ASSERT(operand->reg.value);
        /*if (!operand->reg.value)
        {
            return ZYAN_STATUS_BAD_REGISTER;
        }*/
    }

    return ZYAN_STATUS_SUCCESS;
}
#endif

#ifndef ZYDIS_MINIMAL_MODE
/**
 * Decodes a memory operand.
 *
 * @param   context             A pointer to the `ZydisDecoderContext` struct.
 * @param   instruction         A pointer to the `ZydisDecodedInstruction` struct.
 * @param   operand             A pointer to the `ZydisDecodedOperand` struct.
 * @param   vidx_register_class The register-class to use as the index register-class for
 *                              instructions with `VSIB` addressing.
 *
 * @return  A zyan status code.
 */
static ZyanStatus ZydisDecodeOperandMemory(const ZydisDecoderContext* context,
    const ZydisDecodedInstruction* instruction, ZydisDecodedOperand* operand,
    ZydisRegisterClass vidx_register_class)
{
    ZYAN_ASSERT(context);
    ZYAN_ASSERT(instruction);
    ZYAN_ASSERT(operand);
    ZYAN_ASSERT(instruction->attributes & ZYDIS_ATTRIB_HAS_MODRM);
    ZYAN_ASSERT(instruction->raw.modrm.mod != 3);
    ZYAN_ASSERT(!vidx_register_class || ((instruction->raw.modrm.rm == 4) &&
        ((instruction->address_width == 32) || (instruction->address_width == 64))));

    operand->type = ZYDIS_OPERAND_TYPE_MEMORY;
    operand->mem.type = ZYDIS_MEMOP_TYPE_MEM;

    const ZyanU8 modrm_rm = instruction->raw.modrm.rm;
    ZyanU8 displacement_size = 0;
    switch (instruction->address_width)
    {
    case 16:
    {
        static const ZydisRegister bases[] =
        {
            ZYDIS_REGISTER_BX,   ZYDIS_REGISTER_BX,   ZYDIS_REGISTER_BP,   ZYDIS_REGISTER_BP,
            ZYDIS_REGISTER_SI,   ZYDIS_REGISTER_DI,   ZYDIS_REGISTER_BP,   ZYDIS_REGISTER_BX
        };
        static const ZydisRegister indices[] =
        {
            ZYDIS_REGISTER_SI,   ZYDIS_REGISTER_DI,   ZYDIS_REGISTER_SI,   ZYDIS_REGISTER_DI,
            ZYDIS_REGISTER_NONE, ZYDIS_REGISTER_NONE, ZYDIS_REGISTER_NONE, ZYDIS_REGISTER_NONE
        };
        operand->mem.base = bases[modrm_rm];
        operand->mem.index = indices[modrm_rm];
        operand->mem.scale = (operand->mem.index == ZYDIS_REGISTER_NONE) ? 0 : 1;
        switch (instruction->raw.modrm.mod)
        {
        case 0:
            if (modrm_rm == 6)
            {
                displacement_size = 16;
                operand->mem.base = ZYDIS_REGISTER_NONE;
            }
            break;
        case 1:
            displacement_size = 8;
            break;
        case 2:
            displacement_size = 16;
            break;
        default:
            ZYAN_UNREACHABLE;
        }
        break;
    }
    case 32:
    {
        operand->mem.base = ZYDIS_REGISTER_EAX + ZydisCalcRegisterId(context, instruction,
            ZYDIS_REG_ENCODING_BASE, ZYDIS_REGCLASS_GPR32);
        switch (instruction->raw.modrm.mod)
        {
        case 0:
            if (modrm_rm == 5)
            {
                if (instruction->machine_mode == ZYDIS_MACHINE_MODE_LONG_64)
                {
                    operand->mem.base = ZYDIS_REGISTER_EIP;
                } else
                {
                    operand->mem.base = ZYDIS_REGISTER_NONE;
                }
                displacement_size = 32;
            }
            break;
        case 1:
            displacement_size = 8;
            break;
        case 2:
            displacement_size = 32;
            break;
        default:
            ZYAN_UNREACHABLE;
        }
        if (modrm_rm == 4)
        {
            ZYAN_ASSERT(instruction->attributes & ZYDIS_ATTRIB_HAS_SIB);
            operand->mem.index =
                ZydisRegisterEncode(vidx_register_class ? vidx_register_class : ZYDIS_REGCLASS_GPR32,
                    ZydisCalcRegisterId(context, instruction,
                        vidx_register_class ? ZYDIS_REG_ENCODING_VIDX : ZYDIS_REG_ENCODING_INDEX,
                        vidx_register_class ? vidx_register_class : ZYDIS_REGCLASS_GPR32));
            operand->mem.scale = (1 << instruction->raw.sib.scale);
            if (operand->mem.index == ZYDIS_REGISTER_ESP)
            {
                operand->mem.index = ZYDIS_REGISTER_NONE;
                operand->mem.scale = 0;
            }
            if (operand->mem.base == ZYDIS_REGISTER_EBP)
            {
                if (instruction->raw.modrm.mod == 0)
                {
                    operand->mem.base = ZYDIS_REGISTER_NONE;
                }
                displacement_size = (instruction->raw.modrm.mod == 1) ? 8 : 32;
            }
        } else
        {
            operand->mem.index = ZYDIS_REGISTER_NONE;
            operand->mem.scale = 0;
        }
        break;
    }
    case 64:
    {
        operand->mem.base = ZYDIS_REGISTER_RAX + ZydisCalcRegisterId(context, instruction,
            ZYDIS_REG_ENCODING_BASE, ZYDIS_REGCLASS_GPR64);
        switch (instruction->raw.modrm.mod)
        {
        case 0:
            if (modrm_rm == 5)
            {
                if (instruction->machine_mode == ZYDIS_MACHINE_MODE_LONG_64)
                {
                    operand->mem.base = ZYDIS_REGISTER_RIP;
                } else
                {
                    operand->mem.base = ZYDIS_REGISTER_NONE;
                }
                displacement_size = 32;
            }
            break;
        case 1:
            displacement_size = 8;
            break;
        case 2:
            displacement_size = 32;
            break;
        default:
            ZYAN_UNREACHABLE;
        }
        if ((modrm_rm & 0x07) == 4)
        {
            ZYAN_ASSERT(instruction->attributes & ZYDIS_ATTRIB_HAS_SIB);
            operand->mem.index =
                ZydisRegisterEncode(vidx_register_class ? vidx_register_class : ZYDIS_REGCLASS_GPR64,
                    ZydisCalcRegisterId(context, instruction,
                        vidx_register_class ? ZYDIS_REG_ENCODING_VIDX : ZYDIS_REG_ENCODING_INDEX,
                        vidx_register_class ? vidx_register_class : ZYDIS_REGCLASS_GPR64));
            operand->mem.scale = (1 << instruction->raw.sib.scale);
            if (operand->mem.index == ZYDIS_REGISTER_RSP)
            {
                operand->mem.index = ZYDIS_REGISTER_NONE;
                operand->mem.scale = 0;
            }
            if ((operand->mem.base == ZYDIS_REGISTER_RBP) ||
                (operand->mem.base == ZYDIS_REGISTER_R13))
            {
                if (instruction->raw.modrm.mod == 0)
                {
                    operand->mem.base = ZYDIS_REGISTER_NONE;
                }
                displacement_size = (instruction->raw.modrm.mod == 1) ? 8 : 32;
            }
        } else
        {
            operand->mem.index = ZYDIS_REGISTER_NONE;
            operand->mem.scale = 0;
        }
        break;
    }
    default:
        ZYAN_UNREACHABLE;
    }
    if (displacement_size)
    {
        ZYAN_ASSERT(instruction->raw.disp.size == displacement_size);
        operand->mem.disp.has_displacement = ZYAN_TRUE;
        operand->mem.disp.value = instruction->raw.disp.value;
    }
    return ZYAN_STATUS_SUCCESS;
}
#endif

#ifndef ZYDIS_MINIMAL_MODE
/**
 * Decodes an implicit register operand.
 *
 * @param   decoder         A pointer to the `ZydisDecoder` instance.
 * @param   context         A pointer to the `ZydisDecoderContext` struct.
 * @param   instruction     A pointer to the `ZydisDecodedInstruction` struct.
 * @param   operand         A pointer to the `ZydisDecodedOperand` struct.
 * @param   definition      A pointer to the `ZydisOperandDefinition` struct.
 */
static void ZydisDecodeOperandImplicitRegister(const ZydisDecoder* decoder,
    const ZydisDecoderContext* context, const ZydisDecodedInstruction* instruction,
    ZydisDecodedOperand* operand, const ZydisOperandDefinition* definition)
{
    ZYAN_ASSERT(context);
    ZYAN_ASSERT(instruction);
    ZYAN_ASSERT(operand);
    ZYAN_ASSERT(definition);

    operand->type = ZYDIS_OPERAND_TYPE_REGISTER;

    switch (definition->op.reg.type)
    {
    case ZYDIS_IMPLREG_TYPE_STATIC:
        operand->reg.value = definition->op.reg.reg.reg;
        break;
    case ZYDIS_IMPLREG_TYPE_GPR_OSZ:
    {
        static const ZydisRegisterClass lookup[3] =
        {
            ZYDIS_REGCLASS_GPR16,
            ZYDIS_REGCLASS_GPR32,
            ZYDIS_REGCLASS_GPR64
        };
        operand->reg.value =
            ZydisRegisterEncode(lookup[context->eosz_index], definition->op.reg.reg.id);
        break;
    }
    case ZYDIS_IMPLREG_TYPE_GPR_ASZ:
        operand->reg.value = ZydisRegisterEncode(
            (instruction->address_width    == 16) ? ZYDIS_REGCLASS_GPR16  :
            (instruction->address_width    == 32) ? ZYDIS_REGCLASS_GPR32  : ZYDIS_REGCLASS_GPR64,
            definition->op.reg.reg.id);
        break;
    case ZYDIS_IMPLREG_TYPE_IP_ASZ:
        operand->reg.value =
            (instruction->address_width    == 16) ? ZYDIS_REGISTER_IP     :
            (instruction->address_width    == 32) ? ZYDIS_REGISTER_EIP    : ZYDIS_REGISTER_RIP;
        break;
    case ZYDIS_IMPLREG_TYPE_GPR_SSZ:
        operand->reg.value = ZydisRegisterEncode(
            (decoder->stack_width == ZYDIS_STACK_WIDTH_16) ? ZYDIS_REGCLASS_GPR16 :
            (decoder->stack_width == ZYDIS_STACK_WIDTH_32) ? ZYDIS_REGCLASS_GPR32 :
                                                             ZYDIS_REGCLASS_GPR64,
            definition->op.reg.reg.id);
        break;
    case ZYDIS_IMPLREG_TYPE_IP_SSZ:
        operand->reg.value =
            (decoder->stack_width == ZYDIS_STACK_WIDTH_16) ? ZYDIS_REGISTER_EIP    :
            (decoder->stack_width == ZYDIS_STACK_WIDTH_32) ? ZYDIS_REGISTER_EIP    :
                                                             ZYDIS_REGISTER_RIP;
        break;
    case ZYDIS_IMPLREG_TYPE_FLAGS_SSZ:
        operand->reg.value =
            (decoder->stack_width == ZYDIS_STACK_WIDTH_16) ? ZYDIS_REGISTER_FLAGS  :
            (decoder->stack_width == ZYDIS_STACK_WIDTH_32) ? ZYDIS_REGISTER_EFLAGS :
                                                             ZYDIS_REGISTER_RFLAGS;
        break;
    default:
        ZYAN_UNREACHABLE;
    }
}
#endif

#ifndef ZYDIS_MINIMAL_MODE
/**
 * Decodes an implicit memory operand.
 *
 * @param   decoder         A pointer to the `ZydisDecoder` instance.
 * @param   context         A pointer to the `ZydisDecoderContext` struct.
 * @param   instruction     A pointer to the `ZydisDecodedInstruction` struct.
 * @param   operand         A pointer to the `ZydisDecodedOperand` struct.
 * @param   definition      A pointer to the `ZydisOperandDefinition` struct.
 */
static void ZydisDecodeOperandImplicitMemory(const ZydisDecoder* decoder,
    const ZydisDecoderContext* context, const ZydisDecodedInstruction* instruction,
    ZydisDecodedOperand* operand, const ZydisOperandDefinition* definition)
{
    ZYAN_ASSERT(context);
    ZYAN_ASSERT(operand);
    ZYAN_ASSERT(definition);

    static const ZydisRegisterClass lookup[3] =
    {
        ZYDIS_REGCLASS_GPR16,
        ZYDIS_REGCLASS_GPR32,
        ZYDIS_REGCLASS_GPR64
    };

    operand->type = ZYDIS_OPERAND_TYPE_MEMORY;
    operand->mem.type = ZYDIS_MEMOP_TYPE_MEM;

    switch (definition->op.mem.base)
    {
    case ZYDIS_IMPLMEM_BASE_AGPR_REG:
        operand->mem.base = ZydisRegisterEncode(lookup[context->easz_index],
            ZydisCalcRegisterId(context, instruction, ZYDIS_REG_ENCODING_REG,
                lookup[context->easz_index]));
        break;
    case ZYDIS_IMPLMEM_BASE_AGPR_RM:
        operand->mem.base = ZydisRegisterEncode(lookup[context->easz_index],
            ZydisCalcRegisterId(context, instruction, ZYDIS_REG_ENCODING_RM,
                lookup[context->easz_index]));
        break;
    case ZYDIS_IMPLMEM_BASE_AAX:
        operand->mem.base = ZydisRegisterEncode(lookup[context->easz_index], 0);
        break;
    case ZYDIS_IMPLMEM_BASE_ADX:
        operand->mem.base = ZydisRegisterEncode(lookup[context->easz_index], 2);
        break;
    case ZYDIS_IMPLMEM_BASE_ABX:
        operand->mem.base = ZydisRegisterEncode(lookup[context->easz_index], 3);
        break;
    case ZYDIS_IMPLMEM_BASE_ASI:
        operand->mem.base = ZydisRegisterEncode(lookup[context->easz_index], 6);
        break;
    case ZYDIS_IMPLMEM_BASE_ADI:
        operand->mem.base = ZydisRegisterEncode(lookup[context->easz_index], 7);
        break;
    case ZYDIS_IMPLMEM_BASE_SSP:
        operand->mem.base = ZydisRegisterEncode(lookup[decoder->stack_width], 4);
        break;
    case ZYDIS_IMPLMEM_BASE_SBP:
        operand->mem.base = ZydisRegisterEncode(lookup[decoder->stack_width], 5);
        break;
    default:
        ZYAN_UNREACHABLE;
    }

    if (definition->op.mem.seg)
    {
        operand->mem.segment =
            ZydisRegisterEncode(ZYDIS_REGCLASS_SEGMENT, definition->op.mem.seg - 1);
        ZYAN_ASSERT(operand->mem.segment);
    }
}
#endif

#ifndef ZYDIS_MINIMAL_MODE
static ZyanStatus ZydisDecodeOperands(const ZydisDecoder* decoder, const ZydisDecoderContext* context,
    const ZydisDecodedInstruction* instruction, ZydisDecodedOperand* operands, ZyanU8 operand_count)
{
    ZYAN_ASSERT(decoder);
    ZYAN_ASSERT(context);
    ZYAN_ASSERT(context->definition);
    ZYAN_ASSERT(instruction);
    ZYAN_ASSERT(operands);
    ZYAN_ASSERT(operand_count);
    ZYAN_ASSERT(operand_count <= instruction->operand_count);

    const ZydisInstructionDefinition* definition = context->definition;
    const ZydisOperandDefinition* operand = ZydisGetOperandDefinitions(definition);

    ZYAN_MEMSET(operands, 0, sizeof(ZydisDecodedOperand) * operand_count);

    ZyanU8 imm_id = 0;
    for (ZyanU8 i = 0; i < operand_count; ++i)
    {
        ZydisRegisterClass register_class = ZYDIS_REGCLASS_INVALID;

        operands[i].id = i;
        operands[i].visibility = operand->visibility;
        operands[i].actions = operand->actions;
        ZYAN_ASSERT(!(operand->actions &
            ZYDIS_OPERAND_ACTION_READ & ZYDIS_OPERAND_ACTION_CONDREAD) ||
            (operand->actions & ZYDIS_OPERAND_ACTION_READ) ^
            (operand->actions & ZYDIS_OPERAND_ACTION_CONDREAD));
        ZYAN_ASSERT(!(operand->actions &
            ZYDIS_OPERAND_ACTION_WRITE & ZYDIS_OPERAND_ACTION_CONDWRITE) ||
            (operand->actions & ZYDIS_OPERAND_ACTION_WRITE) ^
            (operand->actions & ZYDIS_OPERAND_ACTION_CONDWRITE));

        // Implicit operands
        switch (operand->type)
        {
        case ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG:
            ZydisDecodeOperandImplicitRegister(decoder, context, instruction, &operands[i], operand);
            break;
        case ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_MEM:
            ZydisDecodeOperandImplicitMemory(decoder, context, instruction, &operands[i], operand);
            break;
        case ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_IMM1:
            operands[i].type = ZYDIS_OPERAND_TYPE_IMMEDIATE;
            operands[i].size = 8;
            operands[i].imm.value.u = 1;
            operands[i].imm.is_signed = ZYAN_FALSE;
            operands[i].imm.is_relative = ZYAN_FALSE;
            break;
        default:
            break;
        }
        if (operands[i].type)
        {
            goto FinalizeOperand;
        }

        operands[i].encoding = operand->op.encoding;

        // Register operands
        switch (operand->type)
        {
        case ZYDIS_SEMANTIC_OPTYPE_GPR8:
            register_class = ZYDIS_REGCLASS_GPR8;
            break;
        case ZYDIS_SEMANTIC_OPTYPE_GPR16:
            register_class = ZYDIS_REGCLASS_GPR16;
            break;
        case ZYDIS_SEMANTIC_OPTYPE_GPR32:
            register_class = ZYDIS_REGCLASS_GPR32;
            break;
        case ZYDIS_SEMANTIC_OPTYPE_GPR64:
            register_class = ZYDIS_REGCLASS_GPR64;
            break;
        case ZYDIS_SEMANTIC_OPTYPE_GPR16_32_64:
            ZYAN_ASSERT((instruction->operand_width == 16) || (instruction->operand_width == 32) ||
                (instruction->operand_width == 64));
            register_class =
                (instruction->operand_width == 16) ? ZYDIS_REGCLASS_GPR16 : (
                    (instruction->operand_width == 32) ? ZYDIS_REGCLASS_GPR32 : ZYDIS_REGCLASS_GPR64);
            break;
        case ZYDIS_SEMANTIC_OPTYPE_GPR32_32_64:
            ZYAN_ASSERT((instruction->operand_width == 16) || (instruction->operand_width == 32) ||
                (instruction->operand_width == 64));
            register_class =
                (instruction->operand_width == 16) ? ZYDIS_REGCLASS_GPR32 : (
                    (instruction->operand_width == 32) ? ZYDIS_REGCLASS_GPR32 : ZYDIS_REGCLASS_GPR64);
            break;
        case ZYDIS_SEMANTIC_OPTYPE_GPR16_32_32:
            ZYAN_ASSERT((instruction->operand_width == 16) || (instruction->operand_width == 32) ||
                (instruction->operand_width == 64));
            register_class =
                (instruction->operand_width == 16) ? ZYDIS_REGCLASS_GPR16 : ZYDIS_REGCLASS_GPR32;
            break;
        case ZYDIS_SEMANTIC_OPTYPE_GPR_ASZ:
            ZYAN_ASSERT((instruction->address_width == 16) || (instruction->address_width == 32) ||
                (instruction->address_width == 64));
            register_class =
                (instruction->address_width == 16) ? ZYDIS_REGCLASS_GPR16 : (
                    (instruction->address_width == 32) ? ZYDIS_REGCLASS_GPR32 : ZYDIS_REGCLASS_GPR64);
            break;
        case ZYDIS_SEMANTIC_OPTYPE_FPR:
            register_class = ZYDIS_REGCLASS_X87;
            break;
        case ZYDIS_SEMANTIC_OPTYPE_MMX:
            register_class = ZYDIS_REGCLASS_MMX;
            break;
        case ZYDIS_SEMANTIC_OPTYPE_XMM:
            register_class = ZYDIS_REGCLASS_XMM;
            break;
        case ZYDIS_SEMANTIC_OPTYPE_YMM:
            register_class = ZYDIS_REGCLASS_YMM;
            break;
        case ZYDIS_SEMANTIC_OPTYPE_ZMM:
            register_class = ZYDIS_REGCLASS_ZMM;
            break;
        case ZYDIS_SEMANTIC_OPTYPE_TMM:
            register_class = ZYDIS_REGCLASS_TMM;
            break;
        case ZYDIS_SEMANTIC_OPTYPE_BND:
            register_class = ZYDIS_REGCLASS_BOUND;
            break;
        case ZYDIS_SEMANTIC_OPTYPE_SREG:
            register_class = ZYDIS_REGCLASS_SEGMENT;
            break;
        case ZYDIS_SEMANTIC_OPTYPE_CR:
            register_class = ZYDIS_REGCLASS_CONTROL;
            break;
        case ZYDIS_SEMANTIC_OPTYPE_DR:
            register_class = ZYDIS_REGCLASS_DEBUG;
            break;
        case ZYDIS_SEMANTIC_OPTYPE_MASK:
            register_class = ZYDIS_REGCLASS_MASK;
            break;
        default:
            break;
        }
        if (register_class)
        {
            switch (operand->op.encoding)
            {
            case ZYDIS_OPERAND_ENCODING_MODRM_REG:
                ZYAN_CHECK(
                    ZydisDecodeOperandRegister(
                        instruction, &operands[i], register_class,
                        ZydisCalcRegisterId(
                            context, instruction, ZYDIS_REG_ENCODING_REG, register_class)));
                break;
            case ZYDIS_OPERAND_ENCODING_MODRM_RM:
                ZYAN_CHECK(
                    ZydisDecodeOperandRegister(
                        instruction, &operands[i], register_class,
                        ZydisCalcRegisterId(
                            context, instruction, ZYDIS_REG_ENCODING_RM, register_class)));
                break;
            case ZYDIS_OPERAND_ENCODING_OPCODE:
                ZYAN_CHECK(
                    ZydisDecodeOperandRegister(
                        instruction, &operands[i], register_class,
                        ZydisCalcRegisterId(
                            context, instruction, ZYDIS_REG_ENCODING_OPCODE, register_class)));
                break;
            case ZYDIS_OPERAND_ENCODING_NDSNDD:
                ZYAN_CHECK(
                    ZydisDecodeOperandRegister(
                        instruction, &operands[i], register_class,
                        ZydisCalcRegisterId(
                            context, instruction, ZYDIS_REG_ENCODING_NDSNDD, register_class)));
                break;
            case ZYDIS_OPERAND_ENCODING_MASK:
                ZYAN_CHECK(
                    ZydisDecodeOperandRegister(
                        instruction, &operands[i], register_class,
                        ZydisCalcRegisterId(
                            context, instruction, ZYDIS_REG_ENCODING_MASK, register_class)));
                break;
            case ZYDIS_OPERAND_ENCODING_IS4:
                ZYAN_CHECK(
                    ZydisDecodeOperandRegister(
                        instruction, &operands[i], register_class,
                        ZydisCalcRegisterId(
                            context, instruction, ZYDIS_REG_ENCODING_IS4, register_class)));
                break;
            default:
                ZYAN_UNREACHABLE;
            }

            if (operand->is_multisource4)
            {
                operands[i].attributes |= ZYDIS_OATTRIB_IS_MULTISOURCE4;
            }

            goto FinalizeOperand;
        }

        // Memory operands
        switch (operand->type)
        {
        case ZYDIS_SEMANTIC_OPTYPE_MEM:
            ZYAN_CHECK(
                ZydisDecodeOperandMemory(
                    context, instruction, &operands[i], ZYDIS_REGCLASS_INVALID));
            break;
        case ZYDIS_SEMANTIC_OPTYPE_MEM_VSIBX:
            ZYAN_CHECK(
                ZydisDecodeOperandMemory(
                    context, instruction, &operands[i], ZYDIS_REGCLASS_XMM));
            operands[i].mem.type = ZYDIS_MEMOP_TYPE_VSIB;
            break;
        case ZYDIS_SEMANTIC_OPTYPE_MEM_VSIBY:
            ZYAN_CHECK(
                ZydisDecodeOperandMemory(
                    context, instruction, &operands[i], ZYDIS_REGCLASS_YMM));
            operands[i].mem.type = ZYDIS_MEMOP_TYPE_VSIB;
            break;
        case ZYDIS_SEMANTIC_OPTYPE_MEM_VSIBZ:
            ZYAN_CHECK(
                ZydisDecodeOperandMemory(
                    context, instruction, &operands[i], ZYDIS_REGCLASS_ZMM));
            operands[i].mem.type = ZYDIS_MEMOP_TYPE_VSIB;
            break;
        case ZYDIS_SEMANTIC_OPTYPE_PTR:
            ZYAN_ASSERT((instruction->raw.imm[0].size == 16) ||
                (instruction->raw.imm[0].size == 32));
            ZYAN_ASSERT(instruction->raw.imm[1].size == 16);
            operands[i].type = ZYDIS_OPERAND_TYPE_POINTER;
            operands[i].ptr.offset = (ZyanU32)instruction->raw.imm[0].value.u;
            operands[i].ptr.segment = (ZyanU16)instruction->raw.imm[1].value.u;
            break;
        case ZYDIS_SEMANTIC_OPTYPE_AGEN:
            operands[i].actions = 0; // TODO: Remove after generator update
            ZYAN_CHECK(
                ZydisDecodeOperandMemory(
                    context, instruction, &operands[i], ZYDIS_REGCLASS_INVALID));
            operands[i].mem.type = ZYDIS_MEMOP_TYPE_AGEN;
            break;
        case ZYDIS_SEMANTIC_OPTYPE_MOFFS:
            ZYAN_ASSERT(instruction->raw.disp.size);
            operands[i].type = ZYDIS_OPERAND_TYPE_MEMORY;
            operands[i].mem.type = ZYDIS_MEMOP_TYPE_MEM;
            operands[i].mem.disp.has_displacement = ZYAN_TRUE;
            operands[i].mem.disp.value = instruction->raw.disp.value;
            break;
        case ZYDIS_SEMANTIC_OPTYPE_MIB:
            operands[i].actions = 0; // TODO: Remove after generator update
            ZYAN_CHECK(
                ZydisDecodeOperandMemory(
                    context, instruction, &operands[i], ZYDIS_REGCLASS_INVALID));
            operands[i].mem.type = ZYDIS_MEMOP_TYPE_MIB;
            break;
        default:
            break;
        }
        if (operands[i].type)
        {
#if !defined(ZYDIS_DISABLE_AVX512) || !defined(ZYDIS_DISABLE_KNC)
            // Handle compressed 8-bit displacement
            if (((instruction->encoding == ZYDIS_INSTRUCTION_ENCODING_EVEX) ||
                (instruction->encoding == ZYDIS_INSTRUCTION_ENCODING_MVEX)) &&
                (instruction->raw.disp.size == 8))
            {
                operands[i].mem.disp.value *= context->cd8_scale;
            }
#endif

            goto FinalizeOperand;
        }

        // Immediate operands
        switch (operand->type)
        {
        case ZYDIS_SEMANTIC_OPTYPE_REL:
            ZYAN_ASSERT(instruction->raw.imm[imm_id].is_relative);
            ZYAN_FALLTHROUGH;
        case ZYDIS_SEMANTIC_OPTYPE_IMM:
            ZYAN_ASSERT((imm_id == 0) || (imm_id == 1));
            operands[i].type = ZYDIS_OPERAND_TYPE_IMMEDIATE;
            operands[i].size = operand->size[context->eosz_index] * 8;
            if (operand->op.encoding == ZYDIS_OPERAND_ENCODING_IS4)
            {
                // The upper half of the 8-bit immediate is used to encode a register specifier
                ZYAN_ASSERT(instruction->raw.imm[imm_id].size == 8);
                operands[i].imm.value.u = (ZyanU8)instruction->raw.imm[imm_id].value.u & 0x0F;
            }
            else
            {
                operands[i].imm.value.u = instruction->raw.imm[imm_id].value.u;
            }
            operands[i].imm.is_signed = instruction->raw.imm[imm_id].is_signed;
            operands[i].imm.is_relative = instruction->raw.imm[imm_id].is_relative;
            ++imm_id;
            break;
        default:
            break;
        }
        ZYAN_ASSERT(operands[i].type == ZYDIS_OPERAND_TYPE_IMMEDIATE);

    FinalizeOperand:
        // Set segment-register for memory operands
        if (operands[i].type == ZYDIS_OPERAND_TYPE_MEMORY)
        {
            if (!operand->ignore_seg_override &&
                instruction->attributes & ZYDIS_ATTRIB_HAS_SEGMENT_CS)
            {
                operands[i].mem.segment = ZYDIS_REGISTER_CS;
            }
            else
                if (!operand->ignore_seg_override &&
                    instruction->attributes & ZYDIS_ATTRIB_HAS_SEGMENT_SS)
                {
                    operands[i].mem.segment = ZYDIS_REGISTER_SS;
                }
                else
                    if (!operand->ignore_seg_override &&
                        instruction->attributes & ZYDIS_ATTRIB_HAS_SEGMENT_DS)
                    {
                        operands[i].mem.segment = ZYDIS_REGISTER_DS;
                    }
                    else
                        if (!operand->ignore_seg_override &&
                            instruction->attributes & ZYDIS_ATTRIB_HAS_SEGMENT_ES)
                        {
                            operands[i].mem.segment = ZYDIS_REGISTER_ES;
                        }
                        else
                            if (!operand->ignore_seg_override &&
                                instruction->attributes & ZYDIS_ATTRIB_HAS_SEGMENT_FS)
                            {
                                operands[i].mem.segment = ZYDIS_REGISTER_FS;
                            }
                            else
                                if (!operand->ignore_seg_override &&
                                    instruction->attributes & ZYDIS_ATTRIB_HAS_SEGMENT_GS)
                                {
                                    operands[i].mem.segment = ZYDIS_REGISTER_GS;
                                }
                                else
                                {
                                    if (operands[i].mem.segment == ZYDIS_REGISTER_NONE)
                                    {
                                        if ((operands[i].mem.base == ZYDIS_REGISTER_RSP) ||
                                            (operands[i].mem.base == ZYDIS_REGISTER_RBP) ||
                                            (operands[i].mem.base == ZYDIS_REGISTER_ESP) ||
                                            (operands[i].mem.base == ZYDIS_REGISTER_EBP) ||
                                            (operands[i].mem.base == ZYDIS_REGISTER_SP) ||
                                            (operands[i].mem.base == ZYDIS_REGISTER_BP))
                                        {
                                            operands[i].mem.segment = ZYDIS_REGISTER_SS;
                                        }
                                        else
                                        {
                                            operands[i].mem.segment = ZYDIS_REGISTER_DS;
                                        }
                                    }
                                }
        }

        ZydisSetOperandSizeAndElementInfo(context, instruction, &operands[i], operand);
        ++operand;
    }

#if !defined(ZYDIS_DISABLE_AVX512) || !defined(ZYDIS_DISABLE_KNC)
    // Fix operand-action for EVEX/MVEX instructions with merge-mask
    if (instruction->avx.mask.mode == ZYDIS_MASK_MODE_MERGING)
    {
        ZYAN_ASSERT(operand_count >= 1);
        switch (operands[0].actions)
        {
        case ZYDIS_OPERAND_ACTION_WRITE:
            if (operands[0].type == ZYDIS_OPERAND_TYPE_MEMORY)
            {
                operands[0].actions = ZYDIS_OPERAND_ACTION_CONDWRITE;
            }
            else
            {
                operands[0].actions = ZYDIS_OPERAND_ACTION_READ_CONDWRITE;
            }
            break;
        case ZYDIS_OPERAND_ACTION_READWRITE:
            operands[0].actions = ZYDIS_OPERAND_ACTION_READ_CONDWRITE;
            break;
        default:
            break;
        }
    }
#endif

    return ZYAN_STATUS_SUCCESS;
}
#endif

/* ---------------------------------------------------------------------------------------------- */

#ifndef ZYDIS_MINIMAL_MODE
/**
 * Sets attributes for the given instruction.
 *
 * @param   state       A pointer to the `ZydisDecoderState` struct.
 * @param   instruction A pointer to the `ZydisDecodedInstruction` struct.
 * @param   definition  A pointer to the `ZydisInstructionDefinition` struct.
 */
static void ZydisSetAttributes(ZydisDecoderState* state, ZydisDecodedInstruction* instruction,
    const ZydisInstructionDefinition* definition)
{
    ZYAN_ASSERT(state);
    ZYAN_ASSERT(instruction);
    ZYAN_ASSERT(definition);

    if (definition->cpu_state != ZYDIS_RW_ACTION_NONE)
    {
        static const ZydisInstructionAttributes mapping[ZYDIS_RW_ACTION_MAX_VALUE + 1] =
        {
            /* NONE      */ 0,
            /* READ      */ ZYDIS_ATTRIB_CPU_STATE_CR,
            /* WRITE     */ ZYDIS_ATTRIB_CPU_STATE_CW,
            /* READWRITE */ ZYDIS_ATTRIB_CPU_STATE_CR | ZYDIS_ATTRIB_CPU_STATE_CW
        };
        ZYAN_ASSERT(definition->cpu_state < ZYAN_ARRAY_LENGTH(mapping));
        instruction->attributes |= mapping[definition->cpu_state];
    }

    if (definition->fpu_state != ZYDIS_RW_ACTION_NONE)
    {
        static const ZydisInstructionAttributes mapping[ZYDIS_RW_ACTION_MAX_VALUE + 1] =
        {
            /* NONE      */ 0,
            /* READ      */ ZYDIS_ATTRIB_FPU_STATE_CR,
            /* WRITE     */ ZYDIS_ATTRIB_FPU_STATE_CW,
            /* READWRITE */ ZYDIS_ATTRIB_FPU_STATE_CR | ZYDIS_ATTRIB_FPU_STATE_CW
        };
        ZYAN_ASSERT(definition->fpu_state < ZYAN_ARRAY_LENGTH(mapping));
        instruction->attributes |= mapping[definition->fpu_state];
    }

    if (definition->xmm_state != ZYDIS_RW_ACTION_NONE)
    {
        static const ZydisInstructionAttributes mapping[ZYDIS_RW_ACTION_MAX_VALUE + 1] =
        {
            /* NONE      */ 0,
            /* READ      */ ZYDIS_ATTRIB_XMM_STATE_CR,
            /* WRITE     */ ZYDIS_ATTRIB_XMM_STATE_CW,
            /* READWRITE */ ZYDIS_ATTRIB_XMM_STATE_CR | ZYDIS_ATTRIB_XMM_STATE_CW
        };
        ZYAN_ASSERT(definition->xmm_state < ZYAN_ARRAY_LENGTH(mapping));
        instruction->attributes |= mapping[definition->xmm_state];
    }

    switch (instruction->encoding)
    {
    case ZYDIS_INSTRUCTION_ENCODING_LEGACY:
    {
        const ZydisInstructionDefinitionLEGACY* def =
            (const ZydisInstructionDefinitionLEGACY*)definition;

        if (def->is_privileged)
        {
            instruction->attributes |= ZYDIS_ATTRIB_IS_PRIVILEGED;
        }
        if (def->accepts_LOCK)
        {
            instruction->attributes |= ZYDIS_ATTRIB_ACCEPTS_LOCK;
            if (state->prefixes.has_lock)
            {
                instruction->attributes |= ZYDIS_ATTRIB_HAS_LOCK;
                instruction->raw.prefixes[state->prefixes.offset_lock].type =
                    ZYDIS_PREFIX_TYPE_EFFECTIVE;
            }
        }
        if (def->accepts_REP)
        {
            instruction->attributes |= ZYDIS_ATTRIB_ACCEPTS_REP;
        }
        if (def->accepts_REPEREPZ)
        {
            instruction->attributes |= ZYDIS_ATTRIB_ACCEPTS_REPE;
        }
        if (def->accepts_REPNEREPNZ)
        {
            instruction->attributes |= ZYDIS_ATTRIB_ACCEPTS_REPNE;
        }
        if (def->accepts_BOUND)
        {
            instruction->attributes |= ZYDIS_ATTRIB_ACCEPTS_BND;
        }
        if (def->accepts_XACQUIRE)
        {
            instruction->attributes |= ZYDIS_ATTRIB_ACCEPTS_XACQUIRE;
        }
        if (def->accepts_XRELEASE)
        {
            instruction->attributes |= ZYDIS_ATTRIB_ACCEPTS_XRELEASE;
        }
        if (def->accepts_hle_without_lock)
        {
            instruction->attributes |= ZYDIS_ATTRIB_ACCEPTS_HLE_WITHOUT_LOCK;
        }

        switch (state->prefixes.group1)
        {
        case 0xF2:
            if (instruction->attributes & ZYDIS_ATTRIB_ACCEPTS_REPNE)
            {
                instruction->attributes |= ZYDIS_ATTRIB_HAS_REPNE;
                break;
            }
            if (instruction->attributes & ZYDIS_ATTRIB_ACCEPTS_XACQUIRE)
            {
                if ((instruction->attributes & ZYDIS_ATTRIB_HAS_LOCK) ||
                    (def->accepts_hle_without_lock))
                {
                    instruction->attributes |= ZYDIS_ATTRIB_HAS_XACQUIRE;
                    break;
                }
            }
            if ((state->decoder->decoder_mode & (1 << ZYDIS_DECODER_MODE_MPX)) &&
                instruction->attributes & ZYDIS_ATTRIB_ACCEPTS_BND)
            {
                instruction->attributes |= ZYDIS_ATTRIB_HAS_BND;
                break;
            }
            break;
        case 0xF3:
            if (instruction->attributes & ZYDIS_ATTRIB_ACCEPTS_REP)
            {
                instruction->attributes |= ZYDIS_ATTRIB_HAS_REP;
                break;
            }
            if (instruction->attributes & ZYDIS_ATTRIB_ACCEPTS_REPE)
            {
                instruction->attributes |= ZYDIS_ATTRIB_HAS_REPE;
                break;
            }
            if (instruction->attributes & ZYDIS_ATTRIB_ACCEPTS_XRELEASE)
            {
                if ((instruction->attributes & ZYDIS_ATTRIB_HAS_LOCK) ||
                    (def->accepts_hle_without_lock))
                {
                    instruction->attributes |= ZYDIS_ATTRIB_HAS_XRELEASE;
                    break;
                }
            }
            break;
        default:
            break;
        }
        if ((instruction->raw.prefixes[state->prefixes.offset_group1].type ==
             ZYDIS_PREFIX_TYPE_IGNORED) &&
            (instruction->attributes & (
             ZYDIS_ATTRIB_HAS_REP | ZYDIS_ATTRIB_HAS_REPE | ZYDIS_ATTRIB_HAS_REPNE |
             ZYDIS_ATTRIB_HAS_BND | ZYDIS_ATTRIB_HAS_XACQUIRE | ZYDIS_ATTRIB_HAS_XRELEASE)))
        {
            instruction->raw.prefixes[state->prefixes.offset_group1].type =
                ZYDIS_PREFIX_TYPE_EFFECTIVE;
        }

        if (def->accepts_branch_hints)
        {
            instruction->attributes |= ZYDIS_ATTRIB_ACCEPTS_BRANCH_HINTS;
            switch (state->prefixes.group2)
            {
            case 0x2E:
                instruction->attributes |= ZYDIS_ATTRIB_HAS_BRANCH_NOT_TAKEN;
                instruction->raw.prefixes[state->prefixes.offset_group2].type =
                    ZYDIS_PREFIX_TYPE_EFFECTIVE;
                break;
            case 0x3E:
                instruction->attributes |= ZYDIS_ATTRIB_HAS_BRANCH_TAKEN;
                instruction->raw.prefixes[state->prefixes.offset_group2].type =
                    ZYDIS_PREFIX_TYPE_EFFECTIVE;
                break;
            default:
                break;
            }
        }

        if (def->accepts_NOTRACK)
        {
            instruction->attributes |= ZYDIS_ATTRIB_ACCEPTS_NOTRACK;
            if ((state->decoder->decoder_mode & (1 << ZYDIS_DECODER_MODE_CET)) &&
                (state->prefixes.offset_notrack >= 0))
            {
                instruction->attributes |= ZYDIS_ATTRIB_HAS_NOTRACK;
                instruction->raw.prefixes[state->prefixes.offset_notrack].type =
                    ZYDIS_PREFIX_TYPE_EFFECTIVE;
            }
        }

        if (def->accepts_segment && !def->accepts_branch_hints)
        {
            instruction->attributes |= ZYDIS_ATTRIB_ACCEPTS_SEGMENT;
            if (state->prefixes.effective_segment &&
                !(instruction->attributes & ZYDIS_ATTRIB_HAS_NOTRACK))
            {
                switch (state->prefixes.effective_segment)
                {
                case 0x2E:
                    instruction->attributes |= ZYDIS_ATTRIB_HAS_SEGMENT_CS;
                    break;
                case 0x36:
                    instruction->attributes |= ZYDIS_ATTRIB_HAS_SEGMENT_SS;
                    break;
                case 0x3E:
                    instruction->attributes |= ZYDIS_ATTRIB_HAS_SEGMENT_DS;
                    break;
                case 0x26:
                    instruction->attributes |= ZYDIS_ATTRIB_HAS_SEGMENT_ES;
                    break;
                case 0x64:
                    instruction->attributes |= ZYDIS_ATTRIB_HAS_SEGMENT_FS;
                    break;
                case 0x65:
                    instruction->attributes |= ZYDIS_ATTRIB_HAS_SEGMENT_GS;
                    break;
                default:
                    ZYAN_UNREACHABLE;
                }
            }
            if (instruction->attributes & ZYDIS_ATTRIB_HAS_SEGMENT)
            {
                instruction->raw.prefixes[state->prefixes.offset_segment].type =
                    ZYDIS_PREFIX_TYPE_EFFECTIVE;
            }
        }

        break;
    }
    case ZYDIS_INSTRUCTION_ENCODING_3DNOW:
    case ZYDIS_INSTRUCTION_ENCODING_XOP:
    case ZYDIS_INSTRUCTION_ENCODING_VEX:
    case ZYDIS_INSTRUCTION_ENCODING_EVEX:
    case ZYDIS_INSTRUCTION_ENCODING_MVEX:
        if (definition->accepts_segment)
        {
            instruction->attributes |= ZYDIS_ATTRIB_ACCEPTS_SEGMENT;
            if (state->prefixes.effective_segment)
            {
                switch (state->prefixes.effective_segment)
                {
                case 0x2E:
                    instruction->attributes |= ZYDIS_ATTRIB_HAS_SEGMENT_CS;
                    break;
                case 0x36:
                    instruction->attributes |= ZYDIS_ATTRIB_HAS_SEGMENT_SS;
                    break;
                case 0x3E:
                    instruction->attributes |= ZYDIS_ATTRIB_HAS_SEGMENT_DS;
                    break;
                case 0x26:
                    instruction->attributes |= ZYDIS_ATTRIB_HAS_SEGMENT_ES;
                    break;
                case 0x64:
                    instruction->attributes |= ZYDIS_ATTRIB_HAS_SEGMENT_FS;
                    break;
                case 0x65:
                    instruction->attributes |= ZYDIS_ATTRIB_HAS_SEGMENT_GS;
                    break;
                default:
                    ZYAN_UNREACHABLE;
                }
            }
            if (instruction->attributes & ZYDIS_ATTRIB_HAS_SEGMENT)
            {
                instruction->raw.prefixes[state->prefixes.offset_segment].type =
                    ZYDIS_PREFIX_TYPE_EFFECTIVE;
            }
        }
        break;
    default:
        ZYAN_UNREACHABLE;
    }
}
#endif

#ifndef ZYDIS_MINIMAL_MODE
/**
 * Sets AVX-specific information for the given instruction.
 *
 * @param   context     A pointer to the `ZydisDecoderContext` struct.
 * @param   instruction A pointer to the `ZydisDecodedInstruction` struct.
 * @param   definition  A pointer to the `ZydisInstructionDefinition` struct.
 *
 * Information set for `XOP`:
 * - Vector Length
 *
 * Information set for `VEX`:
 * - Vector length
 * - Static broadcast-factor
 *
 * Information set for `EVEX`:
 * - Vector length
 * - Broadcast-factor (static and dynamic)
 * - Rounding-mode and SAE
 * - Mask mode
 * - Compressed 8-bit displacement scale-factor
 *
 * Information set for `MVEX`:
 * - Vector length
 * - Broadcast-factor (static and dynamic)
 * - Rounding-mode and SAE
 * - Swizzle- and conversion-mode
 * - Mask mode
 * - Eviction hint
 * - Compressed 8-bit displacement scale-factor
 */
static void ZydisSetAVXInformation(ZydisDecoderContext* context,
    ZydisDecodedInstruction* instruction, const ZydisInstructionDefinition* definition)
{
    ZYAN_ASSERT(context);
    ZYAN_ASSERT(instruction);
    ZYAN_ASSERT(definition);

    switch (instruction->encoding)
    {
    case ZYDIS_INSTRUCTION_ENCODING_XOP:
    {
        // Vector length
        static const ZyanU16 lookup[2] =
        {
            128,
            256
        };
        ZYAN_ASSERT(context->vector_unified.LL < ZYAN_ARRAY_LENGTH(lookup));
        instruction->avx.vector_length = lookup[context->vector_unified.LL];
        break;
    }
    case ZYDIS_INSTRUCTION_ENCODING_VEX:
    {
        // Vector length
        static const ZyanU16 lookup[2] =
        {
            128,
            256
        };
        ZYAN_ASSERT(context->vector_unified.LL < ZYAN_ARRAY_LENGTH(lookup));
        instruction->avx.vector_length = lookup[context->vector_unified.LL];

        // Static broadcast-factor
        const ZydisInstructionDefinitionVEX* def =
            (const ZydisInstructionDefinitionVEX*)definition;
        if (def->broadcast)
        {
            instruction->avx.broadcast.is_static = ZYAN_TRUE;
            static ZydisBroadcastMode broadcasts[ZYDIS_VEX_STATIC_BROADCAST_MAX_VALUE + 1] =
            {
                ZYDIS_BROADCAST_MODE_INVALID,
                ZYDIS_BROADCAST_MODE_1_TO_2,
                ZYDIS_BROADCAST_MODE_1_TO_4,
                ZYDIS_BROADCAST_MODE_1_TO_8,
                ZYDIS_BROADCAST_MODE_1_TO_16,
                ZYDIS_BROADCAST_MODE_1_TO_32,
                ZYDIS_BROADCAST_MODE_2_TO_4
            };
            instruction->avx.broadcast.mode = broadcasts[def->broadcast];
        }
        break;
    }
    case ZYDIS_INSTRUCTION_ENCODING_EVEX:
    {
#ifndef ZYDIS_DISABLE_AVX512
        const ZydisInstructionDefinitionEVEX* def =
            (const ZydisInstructionDefinitionEVEX*)definition;

        // Vector length
        ZyanU8 vector_length = context->vector_unified.LL;
        if (def->vector_length)
        {
            vector_length = def->vector_length - 1;
        }
        static const ZyanU16 lookup[3] =
        {
            128,
            256,
            512
        };
        ZYAN_ASSERT(vector_length < ZYAN_ARRAY_LENGTH(lookup));
        instruction->avx.vector_length = lookup[vector_length];

        context->evex.tuple_type = def->tuple_type;
        if (def->tuple_type)
        {
            ZYAN_ASSERT(instruction->raw.modrm.mod != 3);
            ZYAN_ASSERT(def->element_size);

            // Element size
            static const ZyanU8 element_sizes[ZYDIS_IELEMENT_SIZE_MAX_VALUE + 1] =
            {
                  0,   8,  16,  32,  64, 128
            };
            ZYAN_ASSERT(def->element_size < ZYAN_ARRAY_LENGTH(element_sizes));
            context->evex.element_size = element_sizes[def->element_size];

            // Compressed disp8 scale and broadcast-factor
            switch (def->tuple_type)
            {
            case ZYDIS_TUPLETYPE_FV:
            {
                const ZyanU8 evex_b = instruction->raw.evex.b;
                ZYAN_ASSERT(evex_b < 2);
                ZYAN_ASSERT(!evex_b || ((!context->vector_unified.W && (context->evex.element_size == 16 ||
                                                                        context->evex.element_size == 32)) ||
                                        ( context->vector_unified.W &&  context->evex.element_size == 64)));
                ZYAN_ASSERT(!evex_b || def->functionality == ZYDIS_EVEX_FUNC_BC);

                static const ZyanU8 scales[2][3][3] =
                {
                    /*B0*/ { /*16*/ { 16, 32, 64 }, /*32*/ { 16, 32, 64 }, /*64*/ { 16, 32, 64 } },
                    /*B1*/ { /*16*/ {  2,  2,  2 }, /*32*/ {  4,  4,  4 }, /*64*/ {  8,  8,  8 } }
                };
                static const ZydisBroadcastMode broadcasts[2][3][3] =
                {
                    /*B0*/
                    {
                        /*16*/
                        {
                            ZYDIS_BROADCAST_MODE_INVALID,
                            ZYDIS_BROADCAST_MODE_INVALID,
                            ZYDIS_BROADCAST_MODE_INVALID
                        },
                        /*32*/
                        {
                            ZYDIS_BROADCAST_MODE_INVALID,
                            ZYDIS_BROADCAST_MODE_INVALID,
                            ZYDIS_BROADCAST_MODE_INVALID
                        },
                        /*64*/
                        {
                            ZYDIS_BROADCAST_MODE_INVALID,
                            ZYDIS_BROADCAST_MODE_INVALID,
                            ZYDIS_BROADCAST_MODE_INVALID
                        }
                    },
                    /*B1*/
                    {
                        /*16*/
                        {
                            ZYDIS_BROADCAST_MODE_1_TO_8,
                            ZYDIS_BROADCAST_MODE_1_TO_16,
                            ZYDIS_BROADCAST_MODE_1_TO_32
                        },
                        /*32*/
                        {
                            ZYDIS_BROADCAST_MODE_1_TO_4,
                            ZYDIS_BROADCAST_MODE_1_TO_8,
                            ZYDIS_BROADCAST_MODE_1_TO_16
                        },
                        /*64*/
                        {
                            ZYDIS_BROADCAST_MODE_1_TO_2,
                            ZYDIS_BROADCAST_MODE_1_TO_4,
                            ZYDIS_BROADCAST_MODE_1_TO_8
                        }
                    }
                };

                const ZyanU8 size_index = context->evex.element_size >> 5;
                ZYAN_ASSERT(size_index < 3);

                context->cd8_scale = scales[evex_b][size_index][vector_length];
                instruction->avx.broadcast.mode = broadcasts[evex_b][size_index][vector_length];
                break;
            }
            case ZYDIS_TUPLETYPE_HV:
            {
                const ZyanU8 evex_b = instruction->raw.evex.b;
                ZYAN_ASSERT(evex_b < 2);
                ZYAN_ASSERT(!context->vector_unified.W);
                ZYAN_ASSERT((context->evex.element_size == 16) ||
                            (context->evex.element_size == 32));
                ZYAN_ASSERT(!evex_b || def->functionality == ZYDIS_EVEX_FUNC_BC);

                static const ZyanU8 scales[2][2][3] =
                {
                    /*B0*/ { /*16*/ {  8, 16, 32 }, /*32*/ {  8, 16, 32 } },
                    /*B1*/ { /*16*/ {  2,  2,  2 }, /*32*/ {  4,  4,  4 } }
                };
                static const ZydisBroadcastMode broadcasts[2][2][3] =
                {
                    /*B0*/
                    {
                        /*16*/
                        {
                            ZYDIS_BROADCAST_MODE_INVALID,
                            ZYDIS_BROADCAST_MODE_INVALID,
                            ZYDIS_BROADCAST_MODE_INVALID
                        },
                        /*32*/
                        {
                            ZYDIS_BROADCAST_MODE_INVALID,
                            ZYDIS_BROADCAST_MODE_INVALID,
                            ZYDIS_BROADCAST_MODE_INVALID
                        }
                    },
                    /*B1*/
                    {
                        /*16*/
                        {
                            ZYDIS_BROADCAST_MODE_1_TO_4,
                            ZYDIS_BROADCAST_MODE_1_TO_8,
                            ZYDIS_BROADCAST_MODE_1_TO_16
                        },
                        /*32*/
                        {
                            ZYDIS_BROADCAST_MODE_1_TO_2,
                            ZYDIS_BROADCAST_MODE_1_TO_4,
                            ZYDIS_BROADCAST_MODE_1_TO_8
                        }
                    }
                };

                const ZyanU8 size_index = context->evex.element_size >> 5;
                ZYAN_ASSERT(size_index < 3);

                context->cd8_scale = scales[evex_b][size_index][vector_length];
                instruction->avx.broadcast.mode = broadcasts[evex_b][size_index][vector_length];
                break;
            }
            case ZYDIS_TUPLETYPE_FVM:
            {
                static const ZyanU8 scales[3] =
                {
                    16, 32, 64
                };
                context->cd8_scale = scales[vector_length];
                break;
            }
            case ZYDIS_TUPLETYPE_GSCAT:
                switch (context->vector_unified.W)
                {
                case 0:
                    ZYAN_ASSERT(context->evex.element_size == 32);
                    break;
                case 1:
                    ZYAN_ASSERT(context->evex.element_size == 64);
                    break;
                default:
                    ZYAN_UNREACHABLE;
                }
                ZYAN_FALLTHROUGH;
            case ZYDIS_TUPLETYPE_T1S:
            {
                static const ZyanU8 scales[6] =
                {
                    /*   */  0,
                    /*  8*/  1,
                    /* 16*/  2,
                    /* 32*/  4,
                    /* 64*/  8,
                    /*128*/ 16,
                };
                ZYAN_ASSERT(def->element_size < ZYAN_ARRAY_LENGTH(scales));
                context->cd8_scale = scales[def->element_size];
                break;
            };
            case ZYDIS_TUPLETYPE_T1F:
            {
                static const ZyanU8 scales[3] =
                {
                    /* 16*/ 2,
                    /* 32*/ 4,
                    /* 64*/ 8
                };

                const ZyanU8 size_index = context->evex.element_size >> 5;
                ZYAN_ASSERT(size_index < 3);

                context->cd8_scale = scales[size_index];
                break;
            }
            case ZYDIS_TUPLETYPE_T1_4X:
                ZYAN_ASSERT(context->evex.element_size == 32);
                ZYAN_ASSERT(context->vector_unified.W == 0);
                context->cd8_scale = 16;
                break;
            case ZYDIS_TUPLETYPE_T2:
                switch (context->vector_unified.W)
                {
                case 0:
                    ZYAN_ASSERT(context->evex.element_size == 32);
                    context->cd8_scale = 8;
                    break;
                case 1:
                    ZYAN_ASSERT(context->evex.element_size == 64);
                    ZYAN_ASSERT((instruction->avx.vector_length == 256) ||
                                (instruction->avx.vector_length == 512));
                    context->cd8_scale = 16;
                    break;
                default:
                    ZYAN_UNREACHABLE;
                }
                break;
            case ZYDIS_TUPLETYPE_T4:
                switch (context->vector_unified.W)
                {
                case 0:
                    ZYAN_ASSERT(context->evex.element_size == 32);
                    ZYAN_ASSERT((instruction->avx.vector_length == 256) ||
                                (instruction->avx.vector_length == 512));
                    context->cd8_scale = 16;
                    break;
                case 1:
                    ZYAN_ASSERT(context->evex.element_size == 64);
                    ZYAN_ASSERT(instruction->avx.vector_length == 512);
                    context->cd8_scale = 32;
                    break;
                default:
                    ZYAN_UNREACHABLE;
                }
                break;
            case ZYDIS_TUPLETYPE_T8:
                ZYAN_ASSERT(!context->vector_unified.W);
                ZYAN_ASSERT(instruction->avx.vector_length == 512);
                ZYAN_ASSERT(context->evex.element_size == 32);
                context->cd8_scale = 32;
                break;
            case ZYDIS_TUPLETYPE_HVM:
            {
                static const ZyanU8 scales[3] =
                {
                     8, 16, 32
                };
                context->cd8_scale = scales[vector_length];
                break;
            }
            case ZYDIS_TUPLETYPE_QVM:
            {
                static const ZyanU8 scales[3] =
                {
                     4,  8, 16
                };
                context->cd8_scale = scales[vector_length];
                break;
            }
            case ZYDIS_TUPLETYPE_OVM:
            {
                static const ZyanU8 scales[3] =
                {
                     2,  4,  8
                };
                context->cd8_scale = scales[vector_length];
                break;
            }
            case ZYDIS_TUPLETYPE_M128:
                context->cd8_scale = 16;
                break;
            case ZYDIS_TUPLETYPE_DUP:
            {
                static const ZyanU8 scales[3] =
                {
                     8, 32, 64
                };
                context->cd8_scale = scales[vector_length];
                break;
            }
            case ZYDIS_TUPLETYPE_QUARTER:
            {
                const ZyanU8 evex_b = instruction->raw.evex.b;
                ZYAN_ASSERT(evex_b < 2);
                ZYAN_ASSERT(!context->vector_unified.W);
                ZYAN_ASSERT(context->evex.element_size == 16);
                ZYAN_ASSERT(!evex_b || def->functionality == ZYDIS_EVEX_FUNC_BC);

                static const ZyanU8 scales[2][3] =
                {
                    /*B0*/ {  4,  8, 16 },
                    /*B1*/ {  2,  2,  2 }
                };
                static const ZydisBroadcastMode broadcasts[2][3] =
                {
                    /*B0*/
                    {
                        ZYDIS_BROADCAST_MODE_INVALID,
                        ZYDIS_BROADCAST_MODE_INVALID,
                        ZYDIS_BROADCAST_MODE_INVALID
                    },
                    /*B1*/
                    {
                        ZYDIS_BROADCAST_MODE_1_TO_2,
                        ZYDIS_BROADCAST_MODE_1_TO_4,
                        ZYDIS_BROADCAST_MODE_1_TO_8
                    }
                };
                context->cd8_scale = scales[evex_b][vector_length];
                instruction->avx.broadcast.mode = broadcasts[evex_b][vector_length];
                break;
            }
            default:
                ZYAN_UNREACHABLE;
            }
        } else
        {
            ZYAN_ASSERT(instruction->raw.modrm.mod == 3);
        }

        // Static broadcast-factor
        if (def->broadcast)
        {
            ZYAN_ASSERT(!instruction->avx.broadcast.mode);
            instruction->avx.broadcast.is_static = ZYAN_TRUE;
            static const ZydisBroadcastMode broadcasts[ZYDIS_EVEX_STATIC_BROADCAST_MAX_VALUE + 1] =
            {
                ZYDIS_BROADCAST_MODE_INVALID,
                ZYDIS_BROADCAST_MODE_1_TO_2,
                ZYDIS_BROADCAST_MODE_1_TO_4,
                ZYDIS_BROADCAST_MODE_1_TO_8,
                ZYDIS_BROADCAST_MODE_1_TO_16,
                ZYDIS_BROADCAST_MODE_1_TO_32,
                ZYDIS_BROADCAST_MODE_1_TO_64,
                ZYDIS_BROADCAST_MODE_2_TO_4,
                ZYDIS_BROADCAST_MODE_2_TO_8,
                ZYDIS_BROADCAST_MODE_2_TO_16,
                ZYDIS_BROADCAST_MODE_4_TO_8,
                ZYDIS_BROADCAST_MODE_4_TO_16,
                ZYDIS_BROADCAST_MODE_8_TO_16
            };
            ZYAN_ASSERT(def->broadcast < ZYAN_ARRAY_LENGTH(broadcasts));
            instruction->avx.broadcast.mode = broadcasts[def->broadcast];
        }

        // Rounding mode and SAE
        if (instruction->raw.evex.b)
        {
            switch (def->functionality)
            {
            case ZYDIS_EVEX_FUNC_INVALID:
            case ZYDIS_EVEX_FUNC_BC:
                // Noting to do here
                break;
            case ZYDIS_EVEX_FUNC_RC:
                instruction->avx.rounding.mode = ZYDIS_ROUNDING_MODE_RN + context->vector_unified.LL;
                ZYAN_FALLTHROUGH;
            case ZYDIS_EVEX_FUNC_SAE:
                instruction->avx.has_sae = ZYAN_TRUE;
                break;
            default:
                ZYAN_UNREACHABLE;
            }
        }

        // Mask
        instruction->avx.mask.reg = ZYDIS_REGISTER_K0 + instruction->raw.evex.aaa;
        switch (def->mask_override)
        {
        case ZYDIS_MASK_OVERRIDE_DEFAULT:
            instruction->avx.mask.mode = ZYDIS_MASK_MODE_MERGING + instruction->raw.evex.z;
            break;
        case ZYDIS_MASK_OVERRIDE_ZEROING:
            instruction->avx.mask.mode = ZYDIS_MASK_MODE_ZEROING;
            break;
        case ZYDIS_MASK_OVERRIDE_CONTROL:
            instruction->avx.mask.mode = ZYDIS_MASK_MODE_CONTROL + instruction->raw.evex.z;
            break;
        default:
            ZYAN_UNREACHABLE;
        }
        if (!instruction->raw.evex.aaa)
        {
            instruction->avx.mask.mode = ZYDIS_MASK_MODE_DISABLED;
        }
#else
        ZYAN_UNREACHABLE;
#endif
        break;
    }
    case ZYDIS_INSTRUCTION_ENCODING_MVEX:
    {
#ifndef ZYDIS_DISABLE_KNC
        // Vector length
        instruction->avx.vector_length = 512;

        const ZydisInstructionDefinitionMVEX* def =
            (const ZydisInstructionDefinitionMVEX*)definition;

        // Static broadcast-factor
        ZyanU8 index = def->has_element_granularity;
        ZYAN_ASSERT(!index || !def->broadcast);
        if (!index && def->broadcast)
        {
            instruction->avx.broadcast.is_static = ZYAN_TRUE;
            switch (def->broadcast)
            {
            case ZYDIS_MVEX_STATIC_BROADCAST_1_TO_8:
                instruction->avx.broadcast.mode = ZYDIS_BROADCAST_MODE_1_TO_8;
                index = 1;
                break;
            case ZYDIS_MVEX_STATIC_BROADCAST_1_TO_16:
                instruction->avx.broadcast.mode = ZYDIS_BROADCAST_MODE_1_TO_16;
                index = 1;
                break;
            case ZYDIS_MVEX_STATIC_BROADCAST_4_TO_8:
                instruction->avx.broadcast.mode = ZYDIS_BROADCAST_MODE_4_TO_8;
                index = 2;
                break;
            case ZYDIS_MVEX_STATIC_BROADCAST_4_TO_16:
                instruction->avx.broadcast.mode = ZYDIS_BROADCAST_MODE_4_TO_16;
                index = 2;
                break;
            default:
                ZYAN_UNREACHABLE;
            }
        }

        // Compressed disp8 scale and broadcast-factor
        switch (def->functionality)
        {
        case ZYDIS_MVEX_FUNC_IGNORED:
        case ZYDIS_MVEX_FUNC_INVALID:
        case ZYDIS_MVEX_FUNC_RC:
        case ZYDIS_MVEX_FUNC_SAE:
        case ZYDIS_MVEX_FUNC_SWIZZLE_32:
        case ZYDIS_MVEX_FUNC_SWIZZLE_64:
            // Nothing to do here
            break;
        case ZYDIS_MVEX_FUNC_F_32:
        case ZYDIS_MVEX_FUNC_I_32:
        case ZYDIS_MVEX_FUNC_F_64:
        case ZYDIS_MVEX_FUNC_I_64:
            context->cd8_scale = 64;
            break;
        case ZYDIS_MVEX_FUNC_SF_32:
        case ZYDIS_MVEX_FUNC_SF_32_BCST:
        case ZYDIS_MVEX_FUNC_SF_32_BCST_4TO16:
        case ZYDIS_MVEX_FUNC_UF_32:
        {
            static const ZyanU8 lookup[3][8] =
            {
                { 64,  4, 16, 32, 16, 16, 32, 32 },
                {  4,  0,  0,  2,  1,  1,  2,  2 },
                { 16,  0,  0,  8,  4,  4,  8,  8 }
            };
            ZYAN_ASSERT(instruction->raw.mvex.SSS < ZYAN_ARRAY_LENGTH(lookup[index]));
            context->cd8_scale = lookup[index][instruction->raw.mvex.SSS];
            break;
        }
        case ZYDIS_MVEX_FUNC_SI_32:
        case ZYDIS_MVEX_FUNC_UI_32:
        case ZYDIS_MVEX_FUNC_SI_32_BCST:
        case ZYDIS_MVEX_FUNC_SI_32_BCST_4TO16:
        {
            static const ZyanU8 lookup[3][8] =
            {
                { 64,  4, 16,  0, 16, 16, 32, 32 },
                {  4,  0,  0,  0,  1,  1,  2,  2 },
                { 16,  0,  0,  0,  4,  4,  8,  8 }
            };
            ZYAN_ASSERT(instruction->raw.mvex.SSS < ZYAN_ARRAY_LENGTH(lookup[index]));
            context->cd8_scale = lookup[index][instruction->raw.mvex.SSS];
            break;
        }
        case ZYDIS_MVEX_FUNC_SF_64:
        case ZYDIS_MVEX_FUNC_UF_64:
        case ZYDIS_MVEX_FUNC_SI_64:
        case ZYDIS_MVEX_FUNC_UI_64:
        {
            static const ZyanU8 lookup[3][3] =
            {
                { 64,  8, 32 },
                {  8,  0,  0 },
                { 32,  0,  0 }
            };
            ZYAN_ASSERT(instruction->raw.mvex.SSS < ZYAN_ARRAY_LENGTH(lookup[index]));
            context->cd8_scale = lookup[index][instruction->raw.mvex.SSS];
            break;
        }
        case ZYDIS_MVEX_FUNC_DF_32:
        case ZYDIS_MVEX_FUNC_DI_32:
        {
            static const ZyanU8 lookup[2][8] =
            {
                { 64,  0,  0, 32, 16, 16, 32, 32 },
                {  4,  0,  0,  2,  1,  1,  2,  2 }
            };
            ZYAN_ASSERT(index < 2);
            ZYAN_ASSERT(instruction->raw.mvex.SSS < ZYAN_ARRAY_LENGTH(lookup[index]));
            context->cd8_scale = lookup[index][instruction->raw.mvex.SSS];
            break;
        }
        case ZYDIS_MVEX_FUNC_DF_64:
        case ZYDIS_MVEX_FUNC_DI_64:
        {
            static const ZyanU8 lookup[2][1] =
            {
                { 64 },
                {  8 }
            };
            ZYAN_ASSERT(index < 2);
            ZYAN_ASSERT(instruction->raw.mvex.SSS < ZYAN_ARRAY_LENGTH(lookup[index]));
            context->cd8_scale = lookup[index][instruction->raw.mvex.SSS];
            break;
        }
        default:
            ZYAN_UNREACHABLE;
        }

        // Rounding mode, sae, swizzle, convert
        context->mvex.functionality = def->functionality;
        switch (def->functionality)
        {
        case ZYDIS_MVEX_FUNC_IGNORED:
        case ZYDIS_MVEX_FUNC_INVALID:
        case ZYDIS_MVEX_FUNC_F_32:
        case ZYDIS_MVEX_FUNC_I_32:
        case ZYDIS_MVEX_FUNC_F_64:
        case ZYDIS_MVEX_FUNC_I_64:
            // Nothing to do here
            break;
        case ZYDIS_MVEX_FUNC_RC:
            instruction->avx.rounding.mode = ZYDIS_ROUNDING_MODE_RN + (instruction->raw.mvex.SSS & 3);
            ZYAN_FALLTHROUGH;
        case ZYDIS_MVEX_FUNC_SAE:
            if (instruction->raw.mvex.SSS >= 4)
            {
                instruction->avx.has_sae = ZYAN_TRUE;
            }
            break;
        case ZYDIS_MVEX_FUNC_SWIZZLE_32:
        case ZYDIS_MVEX_FUNC_SWIZZLE_64:
            instruction->avx.swizzle.mode = ZYDIS_SWIZZLE_MODE_DCBA + instruction->raw.mvex.SSS;
            break;
        case ZYDIS_MVEX_FUNC_SF_32:
        case ZYDIS_MVEX_FUNC_SF_32_BCST:
        case ZYDIS_MVEX_FUNC_SF_32_BCST_4TO16:
            switch (instruction->raw.mvex.SSS)
            {
            case 0:
                break;
            case 1:
                instruction->avx.broadcast.mode = ZYDIS_BROADCAST_MODE_1_TO_16;
                break;
            case 2:
                instruction->avx.broadcast.mode = ZYDIS_BROADCAST_MODE_4_TO_16;
                break;
            case 3:
                instruction->avx.conversion.mode = ZYDIS_CONVERSION_MODE_FLOAT16;
                break;
            case 4:
                instruction->avx.conversion.mode = ZYDIS_CONVERSION_MODE_UINT8;
                break;
            case 5:
                instruction->avx.conversion.mode = ZYDIS_CONVERSION_MODE_SINT8;
                break;
            case 6:
                instruction->avx.conversion.mode = ZYDIS_CONVERSION_MODE_UINT16;
                break;
            case 7:
                instruction->avx.conversion.mode = ZYDIS_CONVERSION_MODE_SINT16;
                break;
            default:
                ZYAN_UNREACHABLE;
            }
            break;
        case ZYDIS_MVEX_FUNC_SI_32:
        case ZYDIS_MVEX_FUNC_SI_32_BCST:
        case ZYDIS_MVEX_FUNC_SI_32_BCST_4TO16:
            switch (instruction->raw.mvex.SSS)
            {
            case 0:
                break;
            case 1:
                instruction->avx.broadcast.mode = ZYDIS_BROADCAST_MODE_1_TO_16;
                break;
            case 2:
                instruction->avx.broadcast.mode = ZYDIS_BROADCAST_MODE_4_TO_16;
                break;
            case 4:
                instruction->avx.conversion.mode = ZYDIS_CONVERSION_MODE_UINT8;
                break;
            case 5:
                instruction->avx.conversion.mode = ZYDIS_CONVERSION_MODE_SINT8;
                break;
            case 6:
                instruction->avx.conversion.mode = ZYDIS_CONVERSION_MODE_UINT16;
                break;
            case 7:
                instruction->avx.conversion.mode = ZYDIS_CONVERSION_MODE_SINT16;
                break;
            default:
                ZYAN_UNREACHABLE;
            }
            break;
        case ZYDIS_MVEX_FUNC_SF_64:
        case ZYDIS_MVEX_FUNC_SI_64:
            switch (instruction->raw.mvex.SSS)
            {
            case 0:
                break;
            case 1:
                instruction->avx.broadcast.mode = ZYDIS_BROADCAST_MODE_1_TO_8;
                break;
            case 2:
                instruction->avx.broadcast.mode = ZYDIS_BROADCAST_MODE_4_TO_8;
                break;
            default:
                ZYAN_UNREACHABLE;
            }
            break;
        case ZYDIS_MVEX_FUNC_UF_32:
        case ZYDIS_MVEX_FUNC_DF_32:
            switch (instruction->raw.mvex.SSS)
            {
            case 0:
                break;
            case 3:
                instruction->avx.conversion.mode = ZYDIS_CONVERSION_MODE_FLOAT16;
                break;
            case 4:
                instruction->avx.conversion.mode = ZYDIS_CONVERSION_MODE_UINT8;
                break;
            case 5:
                instruction->avx.conversion.mode = ZYDIS_CONVERSION_MODE_SINT8;
                break;
            case 6:
                instruction->avx.conversion.mode = ZYDIS_CONVERSION_MODE_UINT16;
                break;
            case 7:
                instruction->avx.conversion.mode = ZYDIS_CONVERSION_MODE_SINT16;
                break;
            default:
                ZYAN_UNREACHABLE;
            }
            break;
        case ZYDIS_MVEX_FUNC_UF_64:
        case ZYDIS_MVEX_FUNC_DF_64:
            break;
        case ZYDIS_MVEX_FUNC_UI_32:
        case ZYDIS_MVEX_FUNC_DI_32:
            switch (instruction->raw.mvex.SSS)
            {
            case 0:
                break;
            case 4:
                instruction->avx.conversion.mode = ZYDIS_CONVERSION_MODE_UINT8;
                break;
            case 5:
                instruction->avx.conversion.mode = ZYDIS_CONVERSION_MODE_SINT8;
                break;
            case 6:
                instruction->avx.conversion.mode = ZYDIS_CONVERSION_MODE_UINT16;
                break;
            case 7:
                instruction->avx.conversion.mode = ZYDIS_CONVERSION_MODE_SINT16;
                break;
            default:
                ZYAN_UNREACHABLE;
            }
            break;
        case ZYDIS_MVEX_FUNC_UI_64:
        case ZYDIS_MVEX_FUNC_DI_64:
            break;
        default:
            ZYAN_UNREACHABLE;
        }

        // Eviction hint
        if ((instruction->raw.modrm.mod != 3) && instruction->raw.mvex.E)
        {
            instruction->avx.has_eviction_hint = ZYAN_TRUE;
        }

        // Mask
        instruction->avx.mask.mode = ZYDIS_MASK_MODE_MERGING;
        instruction->avx.mask.reg = ZYDIS_REGISTER_K0 + instruction->raw.mvex.kkk;
#else
        ZYAN_UNREACHABLE;
#endif
        break;
    }
    default:
        // Nothing to do here
        break;
    }
}
#endif

/* ---------------------------------------------------------------------------------------------- */
/* Physical instruction decoding                                                                  */
/* ---------------------------------------------------------------------------------------------- */

/**
 * Collects optional instruction prefixes.
 *
 * @param   state     A pointer to the `ZydisDecoderState` struct.
 * @param   instruction A pointer to the `ZydisDecodedInstruction` struct.
 *
 * @return  A zyan status code.
 *
 * This function sets the corresponding flag for each prefix and automatically decodes the last
 * `REX`-prefix (if exists).
 */
static ZyanStatus ZydisCollectOptionalPrefixes(ZydisDecoderState* state,
    ZydisDecodedInstruction* instruction)
{
    ZYAN_ASSERT(state);
    ZYAN_ASSERT(instruction);
    ZYAN_ASSERT(instruction->raw.prefix_count == 0);

    ZyanU8 rex = 0x00;
    ZyanU8 offset = 0;
    ZyanBool done = ZYAN_FALSE;
    do
    {
        ZyanU8 prefix_byte;
        ZYAN_CHECK(ZydisInputPeek(state, instruction, &prefix_byte));
        switch (prefix_byte)
        {
        case 0xF0:
            state->prefixes.has_lock = ZYAN_TRUE;
            state->prefixes.offset_lock = offset;
            break;
        case 0xF2:
            ZYAN_FALLTHROUGH;
        case 0xF3:
            state->prefixes.group1 = prefix_byte;
            state->prefixes.mandatory_candidate = prefix_byte;
            state->prefixes.offset_group1 = offset;
            state->prefixes.offset_mandatory = offset;
            break;
        case 0x2E:
            ZYAN_FALLTHROUGH;
        case 0x36:
            ZYAN_FALLTHROUGH;
        case 0x3E:
            ZYAN_FALLTHROUGH;
        case 0x26:
            if (state->decoder->machine_mode == ZYDIS_MACHINE_MODE_LONG_64)
            {
                if ((prefix_byte == 0x3E) &&
                    (state->prefixes.effective_segment != 0x64) &&
                    (state->prefixes.effective_segment != 0x65))
                {
                    state->prefixes.offset_notrack = offset;
                }
                state->prefixes.group2 = prefix_byte;
                state->prefixes.offset_group2 = offset;
                break;
            }
            ZYAN_FALLTHROUGH;
        case 0x64:
            ZYAN_FALLTHROUGH;
        case 0x65:
            state->prefixes.group2 = prefix_byte;
            state->prefixes.offset_group2 = offset;
            state->prefixes.effective_segment = prefix_byte;
            state->prefixes.offset_segment = offset;
            state->prefixes.offset_notrack = -1;
            break;
        case 0x66:
            // context->prefixes.has_osz_override = ZYAN_TRUE;
            state->prefixes.offset_osz_override = offset;
            if (!state->prefixes.mandatory_candidate)
            {
                state->prefixes.mandatory_candidate = 0x66;
                state->prefixes.offset_mandatory = offset;
            }
            instruction->attributes |= ZYDIS_ATTRIB_HAS_OPERANDSIZE;
            break;
        case 0x67:
            // context->prefixes.has_asz_override = ZYAN_TRUE;
            state->prefixes.offset_asz_override = offset;
            instruction->attributes |= ZYDIS_ATTRIB_HAS_ADDRESSSIZE;
            break;
        default:
            if ((state->decoder->machine_mode == ZYDIS_MACHINE_MODE_LONG_64) &&
                (prefix_byte & 0xF0) == 0x40)
            {
                rex = prefix_byte;
                instruction->raw.rex.offset = offset;
            } else
            {
                done = ZYAN_TRUE;
            }
            break;
        }
        if (!done)
        {
            // Invalidate `REX`, if it's not the last legacy prefix
            if (rex && (rex != prefix_byte))
            {
                rex = 0x00;
                instruction->raw.rex.offset = 0;
            }
            instruction->raw.prefixes[instruction->raw.prefix_count++].value = prefix_byte;
            ZydisInputSkip(state, instruction);
            ++offset;
        }
    } while (!done);

    if (instruction->attributes & ZYDIS_ATTRIB_HAS_OPERANDSIZE)
    {
        instruction->raw.prefixes[state->prefixes.offset_osz_override].type =
            ZYDIS_PREFIX_TYPE_EFFECTIVE;
    }
    if (instruction->attributes & ZYDIS_ATTRIB_HAS_ADDRESSSIZE)
    {
        instruction->raw.prefixes[state->prefixes.offset_asz_override].type =
            ZYDIS_PREFIX_TYPE_EFFECTIVE;
    }
    if (rex)
    {
        instruction->raw.prefixes[instruction->raw.rex.offset].type = ZYDIS_PREFIX_TYPE_EFFECTIVE;
        ZydisDecodeREX(state->context, instruction, rex);
    }
    if ((state->decoder->machine_mode != ZYDIS_MACHINE_MODE_LONG_64) &&
        (state->prefixes.group2 == 0x3E))
    {
        state->prefixes.offset_notrack = state->prefixes.offset_group2;
    }

    return ZYAN_STATUS_SUCCESS;
}

/**
 * Decodes optional instruction parts like the ModRM byte, the SIB byte and
 * additional displacements and/or immediate values.
 *
 * @param   state       A pointer to the `ZydisDecoderState` struct.
 * @param   instruction A pointer to the `ZydisDecodedInstruction` struct.
 * @param   info        A pointer to the `ZydisInstructionEncodingInfo` struct.
 *
 * @return  A zyan status code.
 */
static ZyanStatus ZydisDecodeOptionalInstructionParts(ZydisDecoderState* state,
    ZydisDecodedInstruction* instruction, const ZydisInstructionEncodingInfo* info)
{
    ZYAN_ASSERT(state);
    ZYAN_ASSERT(instruction);
    ZYAN_ASSERT(info);

    ZydisDecoderContext* context = state->context;

    if (info->flags & ZYDIS_INSTR_ENC_FLAG_HAS_MODRM)
    {
        if (!instruction->raw.modrm.offset)
        {
            instruction->raw.modrm.offset = instruction->length;
            ZyanU8 modrm_byte;
            ZYAN_CHECK(ZydisInputNext(state, instruction, &modrm_byte));
            ZydisDecodeModRM(instruction, modrm_byte);
        }

        if (!(info->flags & ZYDIS_INSTR_ENC_FLAG_FORCE_REG_FORM))
        {
            ZyanU8 has_sib = 0;
            ZyanU8 displacement_size = 0;
            switch (instruction->address_width)
            {
            case 16:
                switch (instruction->raw.modrm.mod)
                {
                case 0:
                    if (instruction->raw.modrm.rm == 6)
                    {
                        displacement_size = 16;
                    }
                    break;
                case 1:
                    displacement_size = 8;
                    break;
                case 2:
                    displacement_size = 16;
                    break;
                case 3:
                    break;
                default:
                    ZYAN_UNREACHABLE;
                }
                break;
            case 32:
            case 64:
                has_sib =
                    (instruction->raw.modrm.mod != 3) && (instruction->raw.modrm.rm == 4);
                switch (instruction->raw.modrm.mod)
                {
                case 0:
                    if (instruction->raw.modrm.rm == 5)
                    {
                        if (instruction->machine_mode == ZYDIS_MACHINE_MODE_LONG_64)
                        {
                            instruction->attributes |= ZYDIS_ATTRIB_IS_RELATIVE;
                        }
                        displacement_size = 32;
                    }
                    break;
                case 1:
                    displacement_size = 8;
                    break;
                case 2:
                    displacement_size = 32;
                    break;
                case 3:
                    break;
                default:
                    ZYAN_UNREACHABLE;
                }
                break;
            default:
                ZYAN_UNREACHABLE;
            }
            if (has_sib)
            {
                instruction->raw.sib.offset = instruction->length;
                ZyanU8 sib_byte;
                ZYAN_CHECK(ZydisInputNext(state, instruction, &sib_byte));
                ZydisDecodeSIB(instruction, sib_byte);
                if (instruction->raw.sib.base == 5)
                {
                    displacement_size = (instruction->raw.modrm.mod == 1) ? 8 : 32;
                }
            }
            if (displacement_size)
            {
                ZYAN_CHECK(ZydisReadDisplacement(state, instruction, displacement_size));
            }
        }

        context->reg_info.is_mod_reg = (instruction->raw.modrm.mod == 3) ||
                                       (info->flags & ZYDIS_INSTR_ENC_FLAG_FORCE_REG_FORM);
    }

    if (info->flags & ZYDIS_INSTR_ENC_FLAG_HAS_DISP)
    {
        ZYAN_CHECK(ZydisReadDisplacement(
            state, instruction, info->disp.size[context->easz_index]));
    }

    if (info->flags & ZYDIS_INSTR_ENC_FLAG_HAS_IMM0)
    {
        if (info->imm[0].is_relative)
        {
            instruction->attributes |= ZYDIS_ATTRIB_IS_RELATIVE;
        }
        ZYAN_CHECK(ZydisReadImmediate(state, instruction, 0,
            info->imm[0].size[context->eosz_index], info->imm[0].is_signed,
            info->imm[0].is_relative));
    }

    if (info->flags & ZYDIS_INSTR_ENC_FLAG_HAS_IMM1)
    {
        ZYAN_ASSERT(!(info->flags & ZYDIS_INSTR_ENC_FLAG_HAS_DISP));
        ZYAN_CHECK(ZydisReadImmediate(state, instruction, 1,
            info->imm[1].size[context->eosz_index], info->imm[1].is_signed,
            info->imm[1].is_relative));
    }

    return ZYAN_STATUS_SUCCESS;
}

/* ---------------------------------------------------------------------------------------------- */

/**
 * Sets the effective operand size for the given instruction.
 *
 * @param   context     A pointer to the `ZydisDecoderContext` struct
 * @param   instruction A pointer to the `ZydisDecodedInstruction` struct.
 * @param   definition  A pointer to the `ZydisInstructionDefinition` struct.
 */
static void ZydisSetEffectiveOperandWidth(ZydisDecoderContext* context,
    ZydisDecodedInstruction* instruction, const ZydisInstructionDefinition* definition)
{
    ZYAN_ASSERT(context);
    ZYAN_ASSERT(instruction);
    ZYAN_ASSERT(definition);

    static const ZyanU8 operand_size_map[8][8] =
    {
        // Default for most instructions
        {
            16, // 16 __ W0
            32, // 16 66 W0
            32, // 32 __ W0
            16, // 32 66 W0
            32, // 64 __ W0
            16, // 64 66 W0
            64, // 64 __ W1
            64  // 64 66 W1
        },
        // Operand size is forced to 8-bit (this is done later to preserve the `eosz_index`)
        {
            16, // 16 __ W0
            32, // 16 66 W0
            32, // 32 __ W0
            16, // 32 66 W0
            32, // 64 __ W0
            16, // 64 66 W0
            64, // 64 __ W1
            64  // 64 66 W1
        },
        // Operand size override 0x66 is ignored
        {
            16, // 16 __ W0
            16, // 16 66 W0
            32, // 32 __ W0
            32, // 32 66 W0
            32, // 64 __ W0
            32, // 64 66 W0
            64, // 64 __ W1
            64  // 64 66 W1
        },
        // REX.W promotes to 32-bit instead of 64-bit
        {
            16, // 16 __ W0
            32, // 16 66 W0
            32, // 32 __ W0
            16, // 32 66 W0
            32, // 64 __ W0
            16, // 64 66 W0
            32, // 64 __ W1
            32  // 64 66 W1
        },
        // Operand size defaults to 64-bit in 64-bit mode
        {
            16, // 16 __ W0
            32, // 16 66 W0
            32, // 32 __ W0
            16, // 32 66 W0
            64, // 64 __ W0
            16, // 64 66 W0
            64, // 64 __ W1
            64  // 64 66 W1
        },
        // Operand size is forced to 64-bit in 64-bit mode
        {
            16, // 16 __ W0
            32, // 16 66 W0
            32, // 32 __ W0
            16, // 32 66 W0
            64, // 64 __ W0
            64, // 64 66 W0
            64, // 64 __ W1
            64  // 64 66 W1
        },
        // Operand size is forced to 32-bit, if no REX.W is present.
        {
            32, // 16 __ W0
            32, // 16 66 W0
            32, // 32 __ W0
            32, // 32 66 W0
            32, // 64 __ W0
            32, // 64 66 W0
            64, // 64 __ W1
            64  // 64 66 W1
        },
        // Operand size is forced to 64-bit in 64-bit mode and forced to 32-bit in all other modes.
        // This is used for e.g. `mov CR, GPR` and `mov GPR, CR`.
        {
            32, // 16 __ W0
            32, // 16 66 W0
            32, // 32 __ W0
            32, // 32 66 W0
            64, // 64 __ W0
            64, // 64 66 W0
            64, // 64 __ W1
            64  // 64 66 W1
        }
    };

    ZyanU8 index = (instruction->attributes & ZYDIS_ATTRIB_HAS_OPERANDSIZE) ? 1 : 0;
    if ((instruction->machine_mode == ZYDIS_MACHINE_MODE_LONG_COMPAT_32) ||
        (instruction->machine_mode == ZYDIS_MACHINE_MODE_LEGACY_32))
    {
        index += 2;
    }
    else if (instruction->machine_mode == ZYDIS_MACHINE_MODE_LONG_64)
    {
        index += 4;
        index += (context->vector_unified.W & 0x01) << 1;
    }

    ZYAN_ASSERT(definition->operand_size_map < ZYAN_ARRAY_LENGTH(operand_size_map));
    ZYAN_ASSERT(index < ZYAN_ARRAY_LENGTH(operand_size_map[definition->operand_size_map]));

    instruction->operand_width = operand_size_map[definition->operand_size_map][index];
    context->eosz_index = instruction->operand_width >> 5;

    // TODO: Cleanup code and remove hardcoded condition
    if (definition->operand_size_map == 1)
    {
        instruction->operand_width = 8;
    }
}

/**
 * Sets the effective address width for the given instruction.
 *
 * @param   context     A pointer to the `ZydisDecoderContext` struct.
 * @param   instruction A pointer to the `ZydisDecodedInstruction` struct.
 * @param   definition  A pointer to the `ZydisInstructionDefinition` struct.
 */
static void ZydisSetEffectiveAddressWidth(ZydisDecoderContext* context,
    ZydisDecodedInstruction* instruction, const ZydisInstructionDefinition* definition)
{
    ZYAN_ASSERT(context);
    ZYAN_ASSERT(instruction);

    static const ZyanU8 address_size_map[3][8] =
    {
        // Default for most instructions
        {
            16, // 16 __
            32, // 16 67
            32, // 32 __
            16, // 32 67
            64, // 64 __
            32  // 64 67
        },
        // The address-size override is ignored
        {
            16, // 16 __
            16, // 16 67
            32, // 32 __
            32, // 32 67
            64, // 64 __
            64  // 64 67
        },
        // The address-size is forced to 64-bit in 64-bit mode and 32-bit in non 64-bit mode. This
        // is used by e.g. `ENCLS`, `ENCLV`, `ENCLU`.
        {
            32, // 16 __
            32, // 16 67
            32, // 32 __
            32, // 32 67
            64, // 64 __
            64  // 64 67
        }
    };

    ZyanU8 index = (instruction->attributes & ZYDIS_ATTRIB_HAS_ADDRESSSIZE) ? 1 : 0;
    if ((instruction->machine_mode == ZYDIS_MACHINE_MODE_LONG_COMPAT_32) ||
        (instruction->machine_mode == ZYDIS_MACHINE_MODE_LEGACY_32))
    {
        index += 2;
    }
    else if (instruction->machine_mode == ZYDIS_MACHINE_MODE_LONG_64)
    {
        index += 4;
    }

    ZYAN_ASSERT(definition->address_size_map < ZYAN_ARRAY_LENGTH(address_size_map));
    ZYAN_ASSERT(index < ZYAN_ARRAY_LENGTH(address_size_map[definition->address_size_map]));

    instruction->address_width = address_size_map[definition->address_size_map][index];
    context->easz_index = instruction->address_width >> 5;
}

/* ---------------------------------------------------------------------------------------------- */

static ZyanStatus ZydisNodeHandlerXOP(const ZydisDecodedInstruction* instruction, ZyanU16* index)
{
    ZYAN_ASSERT(instruction);
    ZYAN_ASSERT(index);

    switch (instruction->encoding)
    {
    case ZYDIS_INSTRUCTION_ENCODING_LEGACY:
        *index = 0;
        break;
    case ZYDIS_INSTRUCTION_ENCODING_XOP:
        ZYAN_ASSERT(instruction->attributes & ZYDIS_ATTRIB_HAS_XOP);
        *index = (instruction->raw.xop.m_mmmm - 0x08) + (instruction->raw.xop.pp * 3) + 1;
        break;
    default:
        ZYAN_UNREACHABLE;
    }
    return ZYAN_STATUS_SUCCESS;
}

static ZyanStatus ZydisNodeHandlerVEX(const ZydisDecodedInstruction* instruction, ZyanU16* index)
{
    ZYAN_ASSERT(instruction);
    ZYAN_ASSERT(index);

    switch (instruction->encoding)
    {
    case ZYDIS_INSTRUCTION_ENCODING_LEGACY:
        *index = 0;
        break;
    case ZYDIS_INSTRUCTION_ENCODING_VEX:
        ZYAN_ASSERT(instruction->attributes & ZYDIS_ATTRIB_HAS_VEX);
        *index = instruction->raw.vex.m_mmmm + (instruction->raw.vex.pp << 2) + 1;
        break;
    default:
        ZYAN_UNREACHABLE;
    }
    return ZYAN_STATUS_SUCCESS;
}

static ZyanStatus ZydisNodeHandlerEMVEX(const ZydisDecodedInstruction* instruction, ZyanU16* index)
{
    ZYAN_ASSERT(instruction);
    ZYAN_ASSERT(index);

    switch (instruction->encoding)
    {
    case ZYDIS_INSTRUCTION_ENCODING_LEGACY:
        *index = 0;
        break;
    case ZYDIS_INSTRUCTION_ENCODING_EVEX:
        ZYAN_ASSERT(instruction->attributes & ZYDIS_ATTRIB_HAS_EVEX);
        *index = instruction->raw.evex.mmm + (instruction->raw.evex.pp << 3) + 1;
        break;
    case ZYDIS_INSTRUCTION_ENCODING_MVEX:
        ZYAN_ASSERT(instruction->attributes & ZYDIS_ATTRIB_HAS_MVEX);
        *index = instruction->raw.mvex.mmmm + (instruction->raw.mvex.pp << 2) + 33;
        break;
    default:
        ZYAN_UNREACHABLE;
    }
    return ZYAN_STATUS_SUCCESS;
}

static ZyanStatus ZydisNodeHandlerOpcode(ZydisDecoderState* state,
    ZydisDecodedInstruction* instruction, ZyanU16* index)
{
    ZYAN_ASSERT(state);
    ZYAN_ASSERT(instruction);
    ZYAN_ASSERT(index);

    // Handle possible encoding-prefix and opcode-map changes
    switch (instruction->encoding)
    {
    case ZYDIS_INSTRUCTION_ENCODING_LEGACY:
        ZYAN_CHECK(ZydisInputNext(state, instruction, &instruction->opcode));
        switch (instruction->opcode_map)
        {
        case ZYDIS_OPCODE_MAP_DEFAULT:
            switch (instruction->opcode)
            {
            case 0x0F:
                instruction->opcode_map = ZYDIS_OPCODE_MAP_0F;
                break;
            case 0xC4:
            case 0xC5:
            case 0x62:
            {
                ZyanU8 next_input;
                ZYAN_CHECK(ZydisInputPeek(state, instruction, &next_input));
                if (((next_input & 0xF0) >= 0xC0) ||
                    (instruction->machine_mode == ZYDIS_MACHINE_MODE_LONG_64))
                {
                    if (instruction->attributes & ZYDIS_ATTRIB_HAS_REX)
                    {
                        return ZYDIS_STATUS_ILLEGAL_REX;
                    }
                    if (state->prefixes.has_lock)
                    {
                        return ZYDIS_STATUS_ILLEGAL_LOCK;
                    }
                    if (state->prefixes.mandatory_candidate)
                    {
                        return ZYDIS_STATUS_ILLEGAL_LEGACY_PFX;
                    }
                    ZyanU8 prefix_bytes[4] = { 0, 0, 0, 0 };
                    prefix_bytes[0] = instruction->opcode;
                    switch (instruction->opcode)
                    {
                    case 0xC4:
                        instruction->raw.vex.offset = instruction->length - 1;
                        // Read additional 3-byte VEX-prefix data
                        ZYAN_ASSERT(!(instruction->attributes & ZYDIS_ATTRIB_HAS_VEX));
                        ZYAN_CHECK(ZydisInputNextBytes(state, instruction, &prefix_bytes[1], 2));
                        break;
                    case 0xC5:
                        instruction->raw.vex.offset = instruction->length - 1;
                        // Read additional 2-byte VEX-prefix data
                        ZYAN_ASSERT(!(instruction->attributes & ZYDIS_ATTRIB_HAS_VEX));
                        ZYAN_CHECK(ZydisInputNext(state, instruction, &prefix_bytes[1]));
                        break;
                    case 0x62:
#if !defined(ZYDIS_DISABLE_AVX512) || !defined(ZYDIS_DISABLE_KNC)
                        // Read additional EVEX/MVEX-prefix data
                        ZYAN_ASSERT(!(instruction->attributes & ZYDIS_ATTRIB_HAS_EVEX));
                        ZYAN_ASSERT(!(instruction->attributes & ZYDIS_ATTRIB_HAS_MVEX));
                        ZYAN_CHECK(ZydisInputNextBytes(state, instruction, &prefix_bytes[1], 3));
                        break;
#else
                        return ZYDIS_STATUS_DECODING_ERROR;
#endif
                    default:
                        ZYAN_UNREACHABLE;
                    }
                    switch (instruction->opcode)
                    {
                    case 0xC4:
                    case 0xC5:
                        // Decode VEX-prefix
                        instruction->encoding = ZYDIS_INSTRUCTION_ENCODING_VEX;
                        ZYAN_CHECK(ZydisDecodeVEX(state->context, instruction, prefix_bytes));
                        instruction->opcode_map =
                            ZYDIS_OPCODE_MAP_DEFAULT + instruction->raw.vex.m_mmmm;
                        break;
                    case 0x62:
#if defined(ZYDIS_DISABLE_AVX512) && defined(ZYDIS_DISABLE_KNC)
                        return ZYDIS_STATUS_DECODING_ERROR;
#else
                        switch ((prefix_bytes[2] >> 2) & 0x01)
                        {
                        case 0:
#ifndef ZYDIS_DISABLE_KNC
                            instruction->raw.mvex.offset = instruction->length - 4;
                            // `KNC` instructions are only valid in 64-bit mode.
                            // This condition catches the `MVEX` encoded ones to save a bunch of
                            // `mode` filters in the data-tables.
                            // `KNC` instructions with `VEX` encoding still require a `mode` filter.
                            if (state->decoder->machine_mode != ZYDIS_MACHINE_MODE_LONG_64)
                            {
                                return ZYDIS_STATUS_DECODING_ERROR;
                            }
                            // Decode MVEX-prefix
                            instruction->encoding = ZYDIS_INSTRUCTION_ENCODING_MVEX;
                            ZYAN_CHECK(ZydisDecodeMVEX(state->context, instruction, prefix_bytes));
                            instruction->opcode_map =
                                ZYDIS_OPCODE_MAP_DEFAULT + instruction->raw.mvex.mmmm;
                            break;
#else
                            return ZYDIS_STATUS_DECODING_ERROR;
#endif
                        case 1:
#ifndef ZYDIS_DISABLE_AVX512
                            instruction->raw.evex.offset = instruction->length - 4;
                            // Decode EVEX-prefix
                            instruction->encoding = ZYDIS_INSTRUCTION_ENCODING_EVEX;
                            ZYAN_CHECK(ZydisDecodeEVEX(state->context, instruction, prefix_bytes));
                            instruction->opcode_map =
                                ZYDIS_OPCODE_MAP_DEFAULT + instruction->raw.evex.mmm;
                            break;
#else
                            return ZYDIS_STATUS_DECODING_ERROR;
#endif
                        default:
                            ZYAN_UNREACHABLE;
                        }
                        break;
#endif
                    default:
                        ZYAN_UNREACHABLE;
                    }
                }
                break;
            }
            case 0x8F:
            {
                ZyanU8 next_input;
                ZYAN_CHECK(ZydisInputPeek(state, instruction, &next_input));
                if ((next_input & 0x1F) >= 8)
                {
                    if (instruction->attributes & ZYDIS_ATTRIB_HAS_REX)
                    {
                        return ZYDIS_STATUS_ILLEGAL_REX;
                    }
                    if (state->prefixes.has_lock)
                    {
                        return ZYDIS_STATUS_ILLEGAL_LOCK;
                    }
                    if (state->prefixes.mandatory_candidate)
                    {
                        return ZYDIS_STATUS_ILLEGAL_LEGACY_PFX;
                    }
                    instruction->raw.xop.offset = instruction->length - 1;
                    ZyanU8 prefixBytes[3] = { 0x8F, 0x00, 0x00 };
                    // Read additional xop-prefix data
                    ZYAN_CHECK(ZydisInputNextBytes(state, instruction, &prefixBytes[1], 2));
                    // Decode xop-prefix
                    instruction->encoding = ZYDIS_INSTRUCTION_ENCODING_XOP;
                    ZYAN_CHECK(ZydisDecodeXOP(state->context, instruction, prefixBytes));
                    instruction->opcode_map =
                        ZYDIS_OPCODE_MAP_XOP8 + instruction->raw.xop.m_mmmm - 0x08;
                }
                break;
            }
            default:
                break;
            }
            break;
        case ZYDIS_OPCODE_MAP_0F:
            switch (instruction->opcode)
            {
            case 0x0F:
                if (state->prefixes.has_lock)
                {
                    return ZYDIS_STATUS_ILLEGAL_LOCK;
                }
                instruction->encoding = ZYDIS_INSTRUCTION_ENCODING_3DNOW;
                instruction->opcode_map = ZYDIS_OPCODE_MAP_0F0F;
                break;
            case 0x38:
                instruction->opcode_map = ZYDIS_OPCODE_MAP_0F38;
                break;
            case 0x3A:
                instruction->opcode_map = ZYDIS_OPCODE_MAP_0F3A;
                break;
            default:
                break;
            }
            break;
        case ZYDIS_OPCODE_MAP_0F38:
        case ZYDIS_OPCODE_MAP_0F3A:
        case ZYDIS_OPCODE_MAP_XOP8:
        case ZYDIS_OPCODE_MAP_XOP9:
        case ZYDIS_OPCODE_MAP_XOPA:
            // Nothing to do here
            break;
        default:
            ZYAN_UNREACHABLE;
        }
        break;
    case ZYDIS_INSTRUCTION_ENCODING_3DNOW:
        // All 3DNOW (0x0F 0x0F) instructions are using the same operand encoding. We just
        // decode a random (pi2fw) instruction and extract the actual opcode later.
        *index = 0x0C;
        return ZYAN_STATUS_SUCCESS;
    default:
        ZYAN_CHECK(ZydisInputNext(state, instruction, &instruction->opcode));
        break;
    }

    *index = instruction->opcode;
    return ZYAN_STATUS_SUCCESS;
}

static ZyanStatus ZydisNodeHandlerMode(const ZydisDecodedInstruction* instruction, ZyanU16* index)
{
    ZYAN_ASSERT(instruction);
    ZYAN_ASSERT(index);

    switch (instruction->machine_mode)
    {
    case ZYDIS_MACHINE_MODE_LONG_COMPAT_16:
    case ZYDIS_MACHINE_MODE_LEGACY_16:
    case ZYDIS_MACHINE_MODE_REAL_16:
        *index = 0;
        break;
    case ZYDIS_MACHINE_MODE_LONG_COMPAT_32:
    case ZYDIS_MACHINE_MODE_LEGACY_32:
        *index = 1;
        break;
    case ZYDIS_MACHINE_MODE_LONG_64:
        *index = 2;
        break;
    default:
        ZYAN_UNREACHABLE;
    }
    return ZYAN_STATUS_SUCCESS;
}

static ZyanStatus ZydisNodeHandlerModeCompact(const ZydisDecodedInstruction* instruction,
    ZyanU16* index)
{
    ZYAN_ASSERT(instruction);
    ZYAN_ASSERT(index);

    *index = (instruction->machine_mode == ZYDIS_MACHINE_MODE_LONG_64) ? 0 : 1;
    return ZYAN_STATUS_SUCCESS;
}

static ZyanStatus ZydisNodeHandlerModrmMod(ZydisDecoderState* state,
    ZydisDecodedInstruction* instruction, ZyanU16* index)
{
    ZYAN_ASSERT(state);
    ZYAN_ASSERT(instruction);
    ZYAN_ASSERT(index);

    if (!instruction->raw.modrm.offset)
    {
        instruction->raw.modrm.offset = instruction->length;
        ZyanU8 modrm_byte;
        ZYAN_CHECK(ZydisInputNext(state, instruction, &modrm_byte));
        ZydisDecodeModRM(instruction, modrm_byte);
    }
    *index = instruction->raw.modrm.mod;
    return ZYAN_STATUS_SUCCESS;
}

static ZyanStatus ZydisNodeHandlerModrmModCompact(ZydisDecoderState* state,
    ZydisDecodedInstruction* instruction, ZyanU16* index)
{
    ZYAN_CHECK(ZydisNodeHandlerModrmMod(state, instruction, index));
    *index = (*index == 0x3) ? 0 : 1;
    return ZYAN_STATUS_SUCCESS;
}

static ZyanStatus ZydisNodeHandlerModrmReg(ZydisDecoderState* state,
    ZydisDecodedInstruction* instruction, ZyanU16* index)
{
    ZYAN_ASSERT(state);
    ZYAN_ASSERT(instruction);
    ZYAN_ASSERT(index);

    if (!instruction->raw.modrm.offset)
    {
        instruction->raw.modrm.offset = instruction->length;
        ZyanU8 modrm_byte;
        ZYAN_CHECK(ZydisInputNext(state, instruction, &modrm_byte));
        ZydisDecodeModRM(instruction, modrm_byte);
    }
    *index = instruction->raw.modrm.reg;
    return ZYAN_STATUS_SUCCESS;
}

static ZyanStatus ZydisNodeHandlerModrmRm(ZydisDecoderState* state,
    ZydisDecodedInstruction* instruction, ZyanU16* index)
{
    ZYAN_ASSERT(state);
    ZYAN_ASSERT(instruction);
    ZYAN_ASSERT(index);

    if (!instruction->raw.modrm.offset)
    {
        instruction->raw.modrm.offset = instruction->length;
        ZyanU8 modrm_byte;
        ZYAN_CHECK(ZydisInputNext(state, instruction, &modrm_byte));
        ZydisDecodeModRM(instruction, modrm_byte);
    }
    *index = instruction->raw.modrm.rm;
    return ZYAN_STATUS_SUCCESS;
}

static ZyanStatus ZydisNodeHandlerMandatoryPrefix(const ZydisDecoderState* state,
    ZydisDecodedInstruction* instruction, ZyanU16* index)
{
    ZYAN_ASSERT(state);
    ZYAN_ASSERT(instruction);
    ZYAN_ASSERT(index);

    switch (state->prefixes.mandatory_candidate)
    {
    case 0x66:
        instruction->raw.prefixes[state->prefixes.offset_mandatory].type =
            ZYDIS_PREFIX_TYPE_MANDATORY;
        instruction->attributes &= ~ZYDIS_ATTRIB_HAS_OPERANDSIZE;
        *index = 2;
        break;
    case 0xF3:
        instruction->raw.prefixes[state->prefixes.offset_mandatory].type =
            ZYDIS_PREFIX_TYPE_MANDATORY;
        *index = 3;
        break;
    case 0xF2:
        instruction->raw.prefixes[state->prefixes.offset_mandatory].type =
            ZYDIS_PREFIX_TYPE_MANDATORY;
        *index = 4;
        break;
    default:
        *index = 1;
        break;
    }
    // TODO: Consume prefix and make sure it's available again, if we need to fallback

    return ZYAN_STATUS_SUCCESS;
}

static ZyanStatus ZydisNodeHandlerOperandSize(const ZydisDecoderState* state,
    ZydisDecodedInstruction* instruction, ZyanU16* index)
{
    ZYAN_ASSERT(state);
    ZYAN_ASSERT(instruction);
    ZYAN_ASSERT(index);

    if ((instruction->machine_mode == ZYDIS_MACHINE_MODE_LONG_64) &&
        (state->context->vector_unified.W))
    {
        *index = 2;
    } else
    {
        if (instruction->attributes & ZYDIS_ATTRIB_HAS_OPERANDSIZE)
        {
            instruction->raw.prefixes[state->prefixes.offset_osz_override].type =
                ZYDIS_PREFIX_TYPE_EFFECTIVE;
        }
        switch (instruction->machine_mode)
        {
        case ZYDIS_MACHINE_MODE_LONG_COMPAT_16:
        case ZYDIS_MACHINE_MODE_LEGACY_16:
        case ZYDIS_MACHINE_MODE_REAL_16:
            *index = (instruction->attributes & ZYDIS_ATTRIB_HAS_OPERANDSIZE) ? 1 : 0;
            break;
        case ZYDIS_MACHINE_MODE_LONG_COMPAT_32:
        case ZYDIS_MACHINE_MODE_LEGACY_32:
        case ZYDIS_MACHINE_MODE_LONG_64:
            *index = (instruction->attributes & ZYDIS_ATTRIB_HAS_OPERANDSIZE) ? 0 : 1;
            break;
        default:
            ZYAN_UNREACHABLE;
        }
    }

    return ZYAN_STATUS_SUCCESS;
}

static ZyanStatus ZydisNodeHandlerAddressSize(ZydisDecodedInstruction* instruction, ZyanU16* index)
{
    ZYAN_ASSERT(instruction);
    ZYAN_ASSERT(index);

    /*if (instruction->attributes & ZYDIS_ATTRIB_HAS_ADDRESSSIZE)
    {
        instruction->raw.prefixes[context->prefixes.offset_asz_override].type =
            ZYDIS_PREFIX_TYPE_EFFECTIVE;
    }*/
    switch (instruction->machine_mode)
    {
    case ZYDIS_MACHINE_MODE_LONG_COMPAT_16:
    case ZYDIS_MACHINE_MODE_LEGACY_16:
    case ZYDIS_MACHINE_MODE_REAL_16:
        *index = (instruction->attributes & ZYDIS_ATTRIB_HAS_ADDRESSSIZE) ? 1 : 0;
        break;
    case ZYDIS_MACHINE_MODE_LONG_COMPAT_32:
    case ZYDIS_MACHINE_MODE_LEGACY_32:
        *index = (instruction->attributes & ZYDIS_ATTRIB_HAS_ADDRESSSIZE) ? 0 : 1;
        break;
    case ZYDIS_MACHINE_MODE_LONG_64:
        *index = (instruction->attributes & ZYDIS_ATTRIB_HAS_ADDRESSSIZE) ? 1 : 2;
        break;
    default:
        ZYAN_UNREACHABLE;
    }

    return ZYAN_STATUS_SUCCESS;
}

static ZyanStatus ZydisNodeHandlerVectorLength(const ZydisDecoderContext* context,
    const ZydisDecodedInstruction* instruction, ZyanU16* index)
{
    ZYAN_ASSERT(context);
    ZYAN_ASSERT(instruction);
    ZYAN_ASSERT(index);

    switch (instruction->encoding)
    {
    case ZYDIS_INSTRUCTION_ENCODING_XOP:
        ZYAN_ASSERT(instruction->attributes & ZYDIS_ATTRIB_HAS_XOP);
        break;
    case ZYDIS_INSTRUCTION_ENCODING_VEX:
        ZYAN_ASSERT(instruction->attributes & ZYDIS_ATTRIB_HAS_VEX);
        break;
    case ZYDIS_INSTRUCTION_ENCODING_EVEX:
        ZYAN_ASSERT(instruction->attributes & ZYDIS_ATTRIB_HAS_EVEX);
        break;
    case ZYDIS_INSTRUCTION_ENCODING_MVEX:
        ZYAN_ASSERT(instruction->attributes & ZYDIS_ATTRIB_HAS_MVEX);
        break;
    default:
        ZYAN_UNREACHABLE;
    }

    *index = context->vector_unified.LL;
    if (*index == 3)
    {
        return ZYDIS_STATUS_DECODING_ERROR;
    }
    return ZYAN_STATUS_SUCCESS;
}

static ZyanStatus ZydisNodeHandlerRexW(const ZydisDecoderContext* context,
    const ZydisDecodedInstruction* instruction, ZyanU16* index)
{
    ZYAN_ASSERT(context);
    ZYAN_ASSERT(instruction);
    ZYAN_ASSERT(index);

    switch (instruction->encoding)
    {
    case ZYDIS_INSTRUCTION_ENCODING_LEGACY:
        // nothing to do here
        break;
    case ZYDIS_INSTRUCTION_ENCODING_XOP:
        ZYAN_ASSERT(instruction->attributes & ZYDIS_ATTRIB_HAS_XOP);
        break;
    case ZYDIS_INSTRUCTION_ENCODING_VEX:
        ZYAN_ASSERT(instruction->attributes & ZYDIS_ATTRIB_HAS_VEX);
        break;
    case ZYDIS_INSTRUCTION_ENCODING_EVEX:
        ZYAN_ASSERT(instruction->attributes & ZYDIS_ATTRIB_HAS_EVEX);
        break;
    case ZYDIS_INSTRUCTION_ENCODING_MVEX:
        ZYAN_ASSERT(instruction->attributes & ZYDIS_ATTRIB_HAS_MVEX);
        break;
    default:
        ZYAN_UNREACHABLE;
    }
    *index = context->vector_unified.W;
    return ZYAN_STATUS_SUCCESS;
}

static ZyanStatus ZydisNodeHandlerRexB(const ZydisDecoderContext* context,
    const ZydisDecodedInstruction* instruction, ZyanU16* index)
{
    ZYAN_ASSERT(context);
    ZYAN_ASSERT(instruction);
    ZYAN_ASSERT(index);

    switch (instruction->encoding)
    {
    case ZYDIS_INSTRUCTION_ENCODING_LEGACY:
        // nothing to do here
        break;
    case ZYDIS_INSTRUCTION_ENCODING_XOP:
        ZYAN_ASSERT(instruction->attributes & ZYDIS_ATTRIB_HAS_XOP);
        break;
    case ZYDIS_INSTRUCTION_ENCODING_VEX:
        ZYAN_ASSERT(instruction->attributes & ZYDIS_ATTRIB_HAS_VEX);
        break;
    case ZYDIS_INSTRUCTION_ENCODING_EVEX:
        ZYAN_ASSERT(instruction->attributes & ZYDIS_ATTRIB_HAS_EVEX);
        break;
    case ZYDIS_INSTRUCTION_ENCODING_MVEX:
        ZYAN_ASSERT(instruction->attributes & ZYDIS_ATTRIB_HAS_MVEX);
        break;
    default:
        ZYAN_UNREACHABLE;
    }
    *index = context->vector_unified.B;
    return ZYAN_STATUS_SUCCESS;
}

#ifndef ZYDIS_DISABLE_AVX512
static ZyanStatus ZydisNodeHandlerEvexB(const ZydisDecodedInstruction* instruction, ZyanU16* index)
{
    ZYAN_ASSERT(instruction);
    ZYAN_ASSERT(index);

    ZYAN_ASSERT(instruction->encoding == ZYDIS_INSTRUCTION_ENCODING_EVEX);
    ZYAN_ASSERT(instruction->attributes & ZYDIS_ATTRIB_HAS_EVEX);
    *index = instruction->raw.evex.b;
    return ZYAN_STATUS_SUCCESS;
}
#endif

#ifndef ZYDIS_DISABLE_KNC
static ZyanStatus ZydisNodeHandlerMvexE(const ZydisDecodedInstruction* instruction, ZyanU16* index)
{
    ZYAN_ASSERT(instruction);
    ZYAN_ASSERT(index);

    ZYAN_ASSERT(instruction->encoding == ZYDIS_INSTRUCTION_ENCODING_MVEX);
    ZYAN_ASSERT(instruction->attributes & ZYDIS_ATTRIB_HAS_MVEX);
    *index = instruction->raw.mvex.E;
    return ZYAN_STATUS_SUCCESS;
}
#endif

/* ---------------------------------------------------------------------------------------------- */

/**
 * Populates the internal register id fields for `REG`, `RM`, `NDSNDD`, `BASE` and `INDEX`/`VIDX`
 * encoded operands and performs sanity checks.
 *
 * @param   context     A pointer to the `ZydisDecoderContext` struct.
 * @param   instruction A pointer to the `ZydisDecodedInstruction` struct.
 * @param   def_reg     The type definition for the `.reg` encoded operand.
 * @param   def_rm      The type definition for the `.rm` encoded operand.
 * @param   def_ndsndd  The type definition for the `.vvvv` encoded operand.
 *
 * @return  A zyan status code.
 *
 * This function sets all unused register ids to `-1`. This rule does currently not apply to
 * `base` and `index`.
 *
 * Definition encoding:
 * - `def_reg`    -> `ZydisRegisterKind`
 * - `def_ndsndd` -> `ZydisRegisterKind`
 * - `def_rm`     -> `ZydisRegisterKind` (`.mod == 3`) or ZydisMemoryOperandType (`.mod != 3`)
 */
static ZyanStatus ZydisPopulateRegisterIds(ZydisDecoderContext* context,
    const ZydisDecodedInstruction* instruction, ZyanU8 def_reg, ZyanU8 def_rm, ZyanU8 def_ndsndd)
{
    ZYAN_ASSERT(context);
    ZYAN_ASSERT(instruction);

    const ZyanBool is_64_bit = (instruction->machine_mode == ZYDIS_MACHINE_MODE_LONG_64);
    const ZyanBool is_reg    = context->reg_info.is_mod_reg;
    const ZyanBool has_sib   = !is_reg && (instruction->raw.modrm.rm == 4);
    const ZyanBool has_vsib  = has_sib && (def_rm == ZYDIS_MEMOP_TYPE_VSIB);

    ZyanU8 id_reg    = instruction->raw.modrm.reg;
    ZyanU8 id_rm     = instruction->raw.modrm.rm;
    ZyanU8 id_ndsndd = is_64_bit ? context->vector_unified.vvvv : context->vector_unified.vvvv & 0x07;
    ZyanU8 id_base   = has_sib ? instruction->raw.sib.base : instruction->raw.modrm.rm;
    ZyanU8 id_index  = instruction->raw.sib.index;

    if (instruction->machine_mode == ZYDIS_MACHINE_MODE_LONG_64)
    {
        const ZyanBool is_emvex = (instruction->encoding == ZYDIS_INSTRUCTION_ENCODING_EVEX) ||
                                  (instruction->encoding == ZYDIS_INSTRUCTION_ENCODING_MVEX);

        // The `index` extension by `.v'` is only valid for VSIB operands
        const ZyanU8 vsib_v2 = has_vsib ? context->vector_unified.V2 : 0;
        // The `rm` extension by `.X` is only valid for EVEX/MVEX instructions
        const ZyanU8 evex_x  = is_emvex ? context->vector_unified.X  : 0;

        id_reg    |= (context->vector_unified.R2 << 4) | (context->vector_unified.R << 3);
        id_rm     |= (evex_x                     << 4) | (context->vector_unified.B << 3);
        id_ndsndd |= (context->vector_unified.V2 << 4)                                   ;
        id_base   |=                                     (context->vector_unified.B << 3);
        id_index  |= (vsib_v2                    << 4) | (context->vector_unified.X << 3);

        // The masking emulates the actual CPU behavior and does not verify if the resulting ids
        // are actually valid for the given register kind.

        static const ZyanU8 mask_reg[ZYDIS_REGKIND_MAX_VALUE + 1] =
        {
            /* INVALID */ 0,
            /* GPR     */ (1 << 5) - 1,
            /* X87     */ (1 << 3) - 1, // ignore `.R`, ignore `.R'`
            /* MMX     */ (1 << 3) - 1, // ignore `.R`, ignore `.R'`
            /* VR      */ (1 << 5) - 1,
            /* TMM     */ (1 << 5) - 1,
            /* SEGMENT */ (1 << 3) - 1, // ignore `.R`, ignore `.R'`
            /* TEST    */ (1 << 3) - 1, // ignore `.R`, ignore `.R'`
            /* CONTROL */ (1 << 4) - 1, //              ignore `.R'`
            /* DEBUG   */ (1 << 4) - 1, //              ignore `.R'`
            /* MASK    */ (1 << 5) - 1,
            /* BOUND   */ (1 << 4) - 1  //              ignore `.R'`
        };
        id_reg &= mask_reg[def_reg];

        static const ZyanU8 mask_rm[ZYDIS_REGKIND_MAX_VALUE + 1] =
        {
            /* INVALID */ 0,
            /* GPR     */ (1 << 4) - 1, //              ignore `.X`
            /* X87     */ (1 << 3) - 1, // ignore `.B`, ignore `.X`
            /* MMX     */ (1 << 3) - 1, // ignore `.B`, ignore `.X`
            /* VR      */ (1 << 5) - 1,
            /* TMM     */ (1 << 4) - 1, //              ignore `.X`
            /* SEGMENT */ (1 << 3) - 1, // ignore `.B`, ignore `.X`
            /* TEST    */ (1 << 3) - 1, // ignore `.B`, ignore `.X`
            /* CONTROL */ (1 << 4) - 1, //              ignore `.X`
            /* DEBUG   */ (1 << 4) - 1, //              ignore `.X`
            /* MASK    */ (1 << 3) - 1, // ignore `.B`, ignore `.X`
            /* BOUND   */ (1 << 4) - 1  //              ignore `.X`
        };
        id_rm &= (is_reg ? mask_rm[def_rm] : 0xFF);

        // Commented out for future reference. Not required at the moment as it's always either
        // a "take all" or "take nothing" situation.

        //static const ZyanU8 mask_ndsndd[ZYDIS_REGKIND_MAX_VALUE + 1] =
        //{
        //    /* INVALID */ 0,
        //    /* GPR     */ (1 << 5) - 1,
        //    /* X87     */ 0,            // never encoded in `.vvvv`
        //    /* MMX     */ 0,            // never encoded in `.vvvv`
        //    /* VR      */ (1 << 5) - 1,
        //    /* TMM     */ (1 << 5) - 1,
        //    /* SEGMENT */ 0,            // never encoded in `.vvvv`
        //    /* TEST    */ 0,            // never encoded in `.vvvv`
        //    /* CONTROL */ 0,            // never encoded in `.vvvv`
        //    /* DEBUG   */ 0,            // never encoded in `.vvvv`
        //    /* MASK    */ (1 << 5) - 1,
        //    /* BOUND   */ 0             // never encoded in `.vvvv`
        //};
    }

    // Validate

    // `.vvvv` is not allowed, if the instruction does not encode a NDS/NDD operand
    if (!def_ndsndd && context->vector_unified.vvvv)
    {
        return ZYDIS_STATUS_BAD_REGISTER;
    }
    // `.v'` is not allowed, if the instruction does not encode a NDS/NDD or VSIB operand
    if (!def_ndsndd && !has_vsib && context->vector_unified.V2)
    {
        return ZYDIS_STATUS_BAD_REGISTER;
    }

    static const ZyanU8 available_regs[2][ZYDIS_REGKIND_MAX_VALUE + 1] =
    {
        // 16/32 bit mode
        {
            /* INVALID */ 255,
            /* GPR     */   8,
            /* X87     */   8,
            /* MMX     */   8,
            /* VR      */   8,
            /* TMM     */   8,
            /* SEGMENT */   6,
            /* TEST    */   8,
            /* CONTROL */   8,
            /* DEBUG   */   8,
            /* MASK    */   8,
            /* BOUND   */   4
        },
        // 64 bit mode
        {
            /* INVALID */ 255,
            /* GPR     */  16,
            /* X87     */   8,
            /* MMX     */   8,
            /* VR      */  32,
            /* TMM     */   8,
            /* SEGMENT */   6,
            /* TEST    */   8,
            /* CONTROL */  16,
            // Attempts to reference DR8..DR15 result in undefined opcode (#UD) exceptions. DR4 and
            // DR5 are only valid, if the debug extension (DE) flag in CR4 is set. As we can't
            // check this at runtime we just allow them.
            /* DEBUG   */   8,
            /* MASK    */   8,
            /* BOUND   */   4
        }
    };

    if ((id_reg >= available_regs[is_64_bit][def_reg]) ||
        (id_ndsndd >= available_regs[is_64_bit][def_ndsndd]) ||
        (is_reg && (id_rm >= available_regs[is_64_bit][def_rm])))
    {
        return ZYDIS_STATUS_BAD_REGISTER;
    }

    ZyanI8 id_cr = -1;
    if (def_reg == ZYDIS_REGKIND_CONTROL)
    {
        id_cr = id_reg;
    }
    if (is_reg && (def_rm == ZYDIS_REGKIND_CONTROL))
    {
        id_cr = id_rm;
    }
    if (id_cr >= 0)
    {
        // Attempts to reference CR1, CR5, CR6, CR7, and CR9..CR15 result in undefined opcode (#UD)
        // exceptions
        static const ZyanU8 lookup[16] =
        {
            1, 0, 1, 1, 1, 0, 0, 0, 1, 0, 0, 0, 0, 0, 0, 0
        };
        ZYAN_ASSERT((ZyanUSize)id_cr < ZYAN_ARRAY_LENGTH(lookup));
        if (!lookup[id_cr])
        {
            return ZYDIS_STATUS_BAD_REGISTER;
        }
    }

    // Assign to context

    context->reg_info.id_reg    = def_reg          ? id_reg    : -1;
    context->reg_info.id_rm     = def_rm && is_reg ? id_rm     : -1;
    context->reg_info.id_ndsndd = def_ndsndd       ? id_ndsndd : -1;
    context->reg_info.id_base   = id_base;  // TODO: Set unused register to -1 as well
    context->reg_info.id_index  = id_index; // TODO: Set unused register to -1 as well

    return ZYAN_STATUS_SUCCESS;
}

/**
 * Checks for certain post-decode error-conditions.
 *
 * @param   state       A pointer to the `ZydisDecoderState` struct.
 * @param   instruction A pointer to the `ZydisDecodedInstruction` struct.
 * @param   definition  A pointer to the `ZydisInstructionDefinition` struct.
 *
 * @return  A zyan status code.
 *
 * This function is called immediately after a valid instruction-definition was found.
 */
static ZyanStatus ZydisCheckErrorConditions(ZydisDecoderState* state,
    const ZydisDecodedInstruction* instruction, const ZydisInstructionDefinition* definition)
{
    ZYAN_ASSERT(state);
    ZYAN_ASSERT(instruction);
    ZYAN_ASSERT(definition);

    ZyanU8 def_reg                  = definition->op_reg;
    ZyanU8 def_rm                   = definition->op_rm;
    ZyanU8 def_ndsndd               = ZYDIS_REGKIND_INVALID;
    ZyanBool is_gather              = ZYAN_FALSE;
    ZyanBool no_source_dest_match   = ZYAN_FALSE;
    ZyanBool no_source_source_match = ZYAN_FALSE;
#if !defined(ZYDIS_DISABLE_AVX512) || !defined(ZYDIS_DISABLE_KNC)
    ZydisMaskPolicy mask_policy     = ZYDIS_MASK_POLICY_INVALID;
#endif

    switch (instruction->encoding)
    {
    case ZYDIS_INSTRUCTION_ENCODING_LEGACY:
    {
        const ZydisInstructionDefinitionLEGACY* def =
            (const ZydisInstructionDefinitionLEGACY*)definition;

        if (def->requires_protected_mode &&
            (instruction->machine_mode == ZYDIS_MACHINE_MODE_REAL_16))
        {
            return ZYDIS_STATUS_DECODING_ERROR;
        }

        if (def->no_compat_mode &&
            ((instruction->machine_mode == ZYDIS_MACHINE_MODE_LONG_COMPAT_16) ||
             (instruction->machine_mode == ZYDIS_MACHINE_MODE_LONG_COMPAT_32)))
        {
            return ZYDIS_STATUS_DECODING_ERROR;
        }

        if (state->prefixes.has_lock && !def->accepts_LOCK)
        {
            return ZYDIS_STATUS_ILLEGAL_LOCK;
        }
        break;
    }
    case ZYDIS_INSTRUCTION_ENCODING_3DNOW:
    {
        break;
    }
    case ZYDIS_INSTRUCTION_ENCODING_XOP:
    {
        const ZydisInstructionDefinitionXOP* def =
            (const ZydisInstructionDefinitionXOP*)definition;
        def_ndsndd = def->op_ndsndd;
        break;
    }
    case ZYDIS_INSTRUCTION_ENCODING_VEX:
    {
        const ZydisInstructionDefinitionVEX* def =
            (const ZydisInstructionDefinitionVEX*)definition;
        def_ndsndd             = def->op_ndsndd;
        is_gather              = def->is_gather;
        no_source_source_match = def->no_source_source_match;
        break;
    }
    case ZYDIS_INSTRUCTION_ENCODING_EVEX:
    {
#ifndef ZYDIS_DISABLE_AVX512
        const ZydisInstructionDefinitionEVEX* def =
            (const ZydisInstructionDefinitionEVEX*)definition;
        def_ndsndd           = def->op_ndsndd;
        is_gather            = def->is_gather;
        no_source_dest_match = def->no_source_dest_match;
        mask_policy          = def->mask_policy;

        // Check for invalid zero-mask
        if ((instruction->raw.evex.z) && (!def->accepts_zero_mask))
        {
            return ZYDIS_STATUS_INVALID_MASK; // TODO: Dedicated status code
        }
#else
        ZYAN_UNREACHABLE;
#endif
        break;
    }
    case ZYDIS_INSTRUCTION_ENCODING_MVEX:
    {
#ifndef ZYDIS_DISABLE_KNC
        const ZydisInstructionDefinitionMVEX* def =
            (const ZydisInstructionDefinitionMVEX*)definition;
        def_ndsndd  = def->op_ndsndd;
        is_gather   = def->is_gather;
        mask_policy = def->mask_policy;

        // Check for invalid MVEX.SSS values
        static const ZyanU8 lookup[26][8] =
        {
            // ZYDIS_MVEX_FUNC_IGNORED
            { 1, 1, 1, 1, 1, 1, 1, 1 },
            // ZYDIS_MVEX_FUNC_INVALID
            { 1, 0, 0, 0, 0, 0, 0, 0 },
            // ZYDIS_MVEX_FUNC_RC
            { 1, 1, 1, 1, 1, 1, 1, 1 },
            // ZYDIS_MVEX_FUNC_SAE
            { 1, 1, 1, 1, 1, 1, 1, 1 },
            // ZYDIS_MVEX_FUNC_F_32
            { 1, 0, 0, 0, 0, 0, 0, 0 },
            // ZYDIS_MVEX_FUNC_I_32
            { 1, 0, 0, 0, 0, 0, 0, 0 },
            // ZYDIS_MVEX_FUNC_F_64
            { 1, 0, 0, 0, 0, 0, 0, 0 },
            // ZYDIS_MVEX_FUNC_I_64
            { 1, 0, 0, 0, 0, 0, 0, 0 },
            // ZYDIS_MVEX_FUNC_SWIZZLE_32
            { 1, 1, 1, 1, 1, 1, 1, 1 },
            // ZYDIS_MVEX_FUNC_SWIZZLE_64
            { 1, 1, 1, 1, 1, 1, 1, 1 },
            // ZYDIS_MVEX_FUNC_SF_32
            { 1, 1, 1, 1, 1, 0, 1, 1 },
            // ZYDIS_MVEX_FUNC_SF_32_BCST
            { 1, 1, 1, 0, 0, 0, 0, 0 },
            // ZYDIS_MVEX_FUNC_SF_32_BCST_4TO16
            { 1, 0, 1, 0, 0, 0, 0, 0 },
            // ZYDIS_MVEX_FUNC_SF_64
            { 1, 1, 1, 0, 0, 0, 0, 0 },
            // ZYDIS_MVEX_FUNC_SI_32
            { 1, 1, 1, 0, 1, 1, 1, 1 },
            // ZYDIS_MVEX_FUNC_SI_32_BCST
            { 1, 1, 1, 0, 0, 0, 0, 0 },
            // ZYDIS_MVEX_FUNC_SI_32_BCST_4TO16
            { 1, 0, 1, 0, 0, 0, 0, 0 },
            // ZYDIS_MVEX_FUNC_SI_64
            { 1, 1, 1, 0, 0, 0, 0, 0 },
            // ZYDIS_MVEX_FUNC_UF_32
            { 1, 0, 0, 1, 1, 1, 1, 1 },
            // ZYDIS_MVEX_FUNC_UF_64
            { 1, 0, 0, 0, 0, 0, 0, 0 },
            // ZYDIS_MVEX_FUNC_UI_32
            { 1, 0, 0, 0, 1, 1, 1, 1 },
            // ZYDIS_MVEX_FUNC_UI_64
            { 1, 0, 0, 0, 0, 0, 0, 0 },
            // ZYDIS_MVEX_FUNC_DF_32
            { 1, 0, 0, 1, 1, 1, 1, 1 },
            // ZYDIS_MVEX_FUNC_DF_64
            { 1, 0, 0, 0, 0, 0, 0, 0 },
            // ZYDIS_MVEX_FUNC_DI_32
            { 1, 0, 0, 0, 1, 1, 1, 1 },
            // ZYDIS_MVEX_FUNC_DI_64
            { 1, 0, 0, 0, 0, 0, 0, 0 }
        };
        ZYAN_ASSERT(def->functionality < ZYAN_ARRAY_LENGTH(lookup));
        ZYAN_ASSERT(instruction->raw.mvex.SSS < 8);
        if (!lookup[def->functionality][instruction->raw.mvex.SSS])
        {
            return ZYDIS_STATUS_DECODING_ERROR;
        }
#else
        ZYAN_UNREACHABLE;
#endif
        break;
    }
    default:
        ZYAN_UNREACHABLE;
    }

    ZydisDecoderContext* context = state->context;
    const ZyanBool is_reg = context->reg_info.is_mod_reg;

    ZyanU8 no_rip_rel     = ZYAN_FALSE;
    ZyanU8 is_sr_dest_reg = ZYAN_FALSE;
    ZyanU8 is_sr_dest_rm  = ZYAN_FALSE;
    if (def_reg)
    {
        is_sr_dest_reg = ZYDIS_OPDEF_GET_REG_HIGH_BIT(def_reg);
        def_reg = ZYDIS_OPDEF_GET_REG(def_reg);
    }
    if (def_rm)
    {
        if (is_reg)
        {
            is_sr_dest_rm = ZYDIS_OPDEF_GET_REG_HIGH_BIT(def_rm);
            def_rm = ZYDIS_OPDEF_GET_REG(def_rm);
        }
        else
        {
            no_rip_rel = ZYDIS_OPDEF_GET_MEM_HIGH_BIT(def_rm);
            def_rm = ZYDIS_OPDEF_GET_MEM(def_rm);
        }
    }

    // Check RIP-relative memory addressing
    if (no_rip_rel)
    {
        const ZyanBool is_rip_rel =
            (state->decoder->machine_mode == ZYDIS_MACHINE_MODE_LONG_64) &&
            (instruction->raw.modrm.mod == 0) && (instruction->raw.modrm.rm == 5);
        if (is_rip_rel)
        {
            return ZYDIS_STATUS_BAD_REGISTER;
        }
    }

    // Populate- and validate register constraints
    ZYAN_CHECK(ZydisPopulateRegisterIds(context, instruction, def_reg, def_rm, def_ndsndd));

    // `ZYDIS_REGISTER_CS` is not allowed as `MOV` target
    if (is_sr_dest_reg && (context->reg_info.id_reg == 1))
    {
        return ZYDIS_STATUS_BAD_REGISTER;
    }
    if (is_sr_dest_rm && (context->reg_info.id_rm == 1))
    {
        return ZYDIS_STATUS_BAD_REGISTER;
    }

    // Check gather registers
    if (is_gather)
    {
        // ZYAN_ASSERT(has_VSIB);
        ZYAN_ASSERT(instruction->raw.modrm.mod != 3);
        ZYAN_ASSERT(instruction->raw.modrm.rm  == 4);

        const ZyanU8 index = context->reg_info.id_index;
        ZyanU8 dest        = context->reg_info.id_reg;
        ZyanU8 mask        = 0xF0;

        if (instruction->encoding == ZYDIS_INSTRUCTION_ENCODING_VEX)
        {
            ZYAN_ASSERT((def_reg    == ZYDIS_REGKIND_VR) &&
                        (def_rm     == ZYDIS_MEMOP_TYPE_VSIB) &&
                        (def_ndsndd == ZYDIS_REGKIND_VR));
            mask = context->reg_info.id_ndsndd;
        }

        if ((instruction->encoding == ZYDIS_INSTRUCTION_ENCODING_EVEX) ||
            (instruction->encoding == ZYDIS_INSTRUCTION_ENCODING_MVEX))
        {
            ZYAN_ASSERT(((def_reg    == ZYDIS_REGKIND_INVALID) ||
                         (def_reg    == ZYDIS_REGKIND_VR)) &&
                         (def_rm     == ZYDIS_MEMOP_TYPE_VSIB) &&
                         (def_ndsndd == ZYDIS_REGKIND_INVALID));

            // Some gather instructions (like `VGATHERPF0{D|Q}{PS|PD}`) do not have a destination
            // operand
            if (!def_reg)
            {
                dest = 0xF1;
            }
        }

        // If any pair of the index, mask, or destination registers are the same, the instruction
        // results a UD fault
        if ((dest == index) || (dest == mask) || (index == mask))
        {
            return ZYDIS_STATUS_BAD_REGISTER;
        }
    }

    // Check if any source register matches the destination register
    if (no_source_dest_match)
    {
        ZYAN_ASSERT((instruction->encoding == ZYDIS_INSTRUCTION_ENCODING_EVEX) ||
                    (instruction->encoding == ZYDIS_INSTRUCTION_ENCODING_VEX));

        const ZyanU8 dest    = context->reg_info.id_reg;
        const ZyanU8 source1 = context->reg_info.id_ndsndd;
        const ZyanU8 source2 = context->reg_info.id_rm;

        if ((dest == source1) || (is_reg && (dest == source2)))
        {
            return ZYDIS_STATUS_BAD_REGISTER;
        }
    }

    // If any pair of the source or destination registers are the same, the instruction results a
    // UD fault
    if (no_source_source_match) // TODO: Find better name
    {
        ZYAN_ASSERT(instruction->encoding == ZYDIS_INSTRUCTION_ENCODING_VEX);
        ZYAN_ASSERT(is_reg);

        const ZyanU8 dest    = context->reg_info.id_reg;
        const ZyanU8 source1 = context->reg_info.id_ndsndd;
        const ZyanU8 source2 = context->reg_info.id_rm;

        if ((dest == source1) || (dest == source2) || (source1 == source2))
        {
            return ZYDIS_STATUS_BAD_REGISTER;
        }
    }

#if !defined(ZYDIS_DISABLE_AVX512) || !defined(ZYDIS_DISABLE_KNC)
    // Check for invalid MASK registers
    switch (mask_policy)
    {
    case ZYDIS_MASK_POLICY_INVALID:
    case ZYDIS_MASK_POLICY_ALLOWED:
        // Nothing to do here
        break;
    case ZYDIS_MASK_POLICY_REQUIRED:
        if (!context->vector_unified.mask)
        {
            return ZYDIS_STATUS_INVALID_MASK;
        }
        break;
    case ZYDIS_MASK_POLICY_FORBIDDEN:
        if (context->vector_unified.mask)
        {
            return ZYDIS_STATUS_INVALID_MASK;
        }
        break;
    default:
        ZYAN_UNREACHABLE;
    }
#endif

    return ZYAN_STATUS_SUCCESS;
}

/* ---------------------------------------------------------------------------------------------- */

/**
 * Uses the decoder-tree to decode the current instruction.
 *
 * @param   state       A pointer to the `ZydisDecoderState` struct.
 * @param   instruction A pointer to the `ZydisDecodedInstruction` struct.
 *
 * @return  A zyan status code.
 */
static ZyanStatus ZydisDecodeInstruction(ZydisDecoderState* state,
    ZydisDecodedInstruction* instruction)
{
    ZYAN_ASSERT(state);
    ZYAN_ASSERT(instruction);

    // Iterate through the decoder tree
    const ZydisDecoderTreeNode* node = ZydisDecoderTreeGetRootNode();
    const ZydisDecoderTreeNode* temp = ZYAN_NULL;
    ZydisDecoderTreeNodeType node_type;
    do
    {
        node_type = node->type;
        ZyanU16 index = 0;
        ZyanStatus status = 0;
        switch (node_type)
        {
        case ZYDIS_NODETYPE_INVALID:
            if (temp)
            {
                node = temp;
                temp = ZYAN_NULL;
                node_type = ZYDIS_NODETYPE_FILTER_MANDATORY_PREFIX;
                if (state->prefixes.mandatory_candidate != 0x00)
                {
                    instruction->raw.prefixes[state->prefixes.offset_mandatory].type =
                        ZYDIS_PREFIX_TYPE_IGNORED;
                }
                if (state->prefixes.mandatory_candidate == 0x66)
                {
                    if (state->prefixes.offset_osz_override ==
                        state->prefixes.offset_mandatory)
                    {
                        instruction->raw.prefixes[state->prefixes.offset_mandatory].type =
                            ZYDIS_PREFIX_TYPE_EFFECTIVE;
                    }
                    instruction->attributes |= ZYDIS_ATTRIB_HAS_OPERANDSIZE;
                }
                continue;
            }
            return ZYDIS_STATUS_DECODING_ERROR;
        case ZYDIS_NODETYPE_FILTER_XOP:
            status = ZydisNodeHandlerXOP(instruction, &index);
            break;
        case ZYDIS_NODETYPE_FILTER_VEX:
            status = ZydisNodeHandlerVEX(instruction, &index);
            break;
        case ZYDIS_NODETYPE_FILTER_EMVEX:
            status = ZydisNodeHandlerEMVEX(instruction, &index);
            break;
        case ZYDIS_NODETYPE_FILTER_OPCODE:
            status = ZydisNodeHandlerOpcode(state, instruction, &index);
            break;
        case ZYDIS_NODETYPE_FILTER_MODE:
            status = ZydisNodeHandlerMode(instruction, &index);
            break;
        case ZYDIS_NODETYPE_FILTER_MODE_COMPACT:
            status = ZydisNodeHandlerModeCompact(instruction, &index);
            break;
        case ZYDIS_NODETYPE_FILTER_MODRM_MOD:
            status = ZydisNodeHandlerModrmMod(state, instruction, &index);
            break;
        case ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT:
            status = ZydisNodeHandlerModrmModCompact(state, instruction, &index);
            break;
        case ZYDIS_NODETYPE_FILTER_MODRM_REG:
            status = ZydisNodeHandlerModrmReg(state, instruction, &index);
            break;
        case ZYDIS_NODETYPE_FILTER_MODRM_RM:
            status = ZydisNodeHandlerModrmRm(state, instruction, &index);
            break;
        case ZYDIS_NODETYPE_FILTER_PREFIX_GROUP1:
            index = state->prefixes.group1 ? 1 : 0;
            break;
        case ZYDIS_NODETYPE_FILTER_MANDATORY_PREFIX:
            status = ZydisNodeHandlerMandatoryPrefix(state, instruction, &index);
            temp = ZydisDecoderTreeGetChildNode(node, 0);
            // TODO: Return to this point, if index == 0 contains a value and the previous path
            // TODO: was not successful
            // TODO: Restore consumed prefix
            break;
        case ZYDIS_NODETYPE_FILTER_OPERAND_SIZE:
            status = ZydisNodeHandlerOperandSize(state, instruction, &index);
            break;
        case ZYDIS_NODETYPE_FILTER_ADDRESS_SIZE:
            status = ZydisNodeHandlerAddressSize(instruction, &index);
            break;
        case ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH:
            status = ZydisNodeHandlerVectorLength(state->context, instruction, &index);
            break;
        case ZYDIS_NODETYPE_FILTER_REX_W:
            status = ZydisNodeHandlerRexW(state->context, instruction, &index);
            break;
        case ZYDIS_NODETYPE_FILTER_REX_B:
            status = ZydisNodeHandlerRexB(state->context, instruction, &index);
            break;
#ifndef ZYDIS_DISABLE_AVX512
        case ZYDIS_NODETYPE_FILTER_EVEX_B:
            status = ZydisNodeHandlerEvexB(instruction, &index);
            break;
#endif
#ifndef ZYDIS_DISABLE_KNC
        case ZYDIS_NODETYPE_FILTER_MVEX_E:
            status = ZydisNodeHandlerMvexE(instruction, &index);
            break;
#endif
        case ZYDIS_NODETYPE_FILTER_MODE_AMD:
            index = !!(state->decoder->decoder_mode & (1 << ZYDIS_DECODER_MODE_AMD_BRANCHES));
            break;
        case ZYDIS_NODETYPE_FILTER_MODE_KNC:
            index = !!(state->decoder->decoder_mode & (1 << ZYDIS_DECODER_MODE_KNC));
            break;
        case ZYDIS_NODETYPE_FILTER_MODE_MPX:
            index = !!(state->decoder->decoder_mode & (1 << ZYDIS_DECODER_MODE_MPX));
            break;
        case ZYDIS_NODETYPE_FILTER_MODE_CET:
            index = !!(state->decoder->decoder_mode & (1 << ZYDIS_DECODER_MODE_CET));
            break;
        case ZYDIS_NODETYPE_FILTER_MODE_LZCNT:
            index = !!(state->decoder->decoder_mode & (1 << ZYDIS_DECODER_MODE_LZCNT));
            break;
        case ZYDIS_NODETYPE_FILTER_MODE_TZCNT:
            index = !!(state->decoder->decoder_mode & (1 << ZYDIS_DECODER_MODE_TZCNT));
            break;
        case ZYDIS_NODETYPE_FILTER_MODE_WBNOINVD:
            index = !!(state->decoder->decoder_mode & (1 << ZYDIS_DECODER_MODE_WBNOINVD));
            break;
        case ZYDIS_NODETYPE_FILTER_MODE_CLDEMOTE:
            index = !!(state->decoder->decoder_mode & (1 << ZYDIS_DECODER_MODE_CLDEMOTE));
            break;
        case ZYDIS_NODETYPE_FILTER_MODE_IPREFETCH:
            index = !!(state->decoder->decoder_mode & (1 << ZYDIS_DECODER_MODE_IPREFETCH));
            break;
        case ZYDIS_NODETYPE_FILTER_MODE_UD0_COMPAT:
            index = !!(state->decoder->decoder_mode & (1 << ZYDIS_DECODER_MODE_UD0_COMPAT));
            break;
        default:
            if (node_type & ZYDIS_NODETYPE_DEFINITION_MASK)
            {
                const ZydisInstructionDefinition* definition;
                ZydisGetInstructionDefinition(instruction->encoding, node->value, &definition);
                ZydisSetEffectiveOperandWidth(state->context, instruction, definition);
                ZydisSetEffectiveAddressWidth(state->context, instruction, definition);

                const ZydisInstructionEncodingInfo* info;
                ZydisGetInstructionEncodingInfo(node, &info);
                ZYAN_CHECK(ZydisDecodeOptionalInstructionParts(state, instruction, info));
                ZYAN_CHECK(ZydisCheckErrorConditions(state, instruction, definition));

                if (instruction->encoding == ZYDIS_INSTRUCTION_ENCODING_3DNOW)
                {
                    // Get actual 3DNOW opcode and definition
                    ZYAN_CHECK(ZydisInputNext(state, instruction, &instruction->opcode));
                    node = ZydisDecoderTreeGetRootNode();
                    node = ZydisDecoderTreeGetChildNode(node, 0x0F);
                    node = ZydisDecoderTreeGetChildNode(node, 0x0F);
                    node = ZydisDecoderTreeGetChildNode(node, instruction->opcode);
                    if (node->type == ZYDIS_NODETYPE_INVALID)
                    {
                        return ZYDIS_STATUS_DECODING_ERROR;
                    }
                    ZYAN_ASSERT(node->type == ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT);
                    node = ZydisDecoderTreeGetChildNode(
                        node, (instruction->raw.modrm.mod == 0x3) ? 0 : 1);
                    ZYAN_ASSERT(node->type & ZYDIS_NODETYPE_DEFINITION_MASK);
                    ZydisGetInstructionDefinition(instruction->encoding, node->value, &definition);
                }

                instruction->mnemonic = definition->mnemonic;

#ifndef ZYDIS_MINIMAL_MODE

                instruction->operand_count = definition->operand_count;
                instruction->operand_count_visible = definition->operand_count_visible;
                state->context->definition = definition;

                instruction->meta.category = definition->category;
                instruction->meta.isa_set = definition->isa_set;
                instruction->meta.isa_ext = definition->isa_ext;
                instruction->meta.branch_type = definition->branch_type;
                ZYAN_ASSERT((instruction->meta.branch_type == ZYDIS_BRANCH_TYPE_NONE) ||
                        ((instruction->meta.category == ZYDIS_CATEGORY_CALL) ||
                         (instruction->meta.category == ZYDIS_CATEGORY_COND_BR) ||
                         (instruction->meta.category == ZYDIS_CATEGORY_UNCOND_BR) ||
                         (instruction->meta.category == ZYDIS_CATEGORY_RET)));
                instruction->meta.exception_class = definition->exception_class;

                if (!(state->decoder->decoder_mode & (1 << ZYDIS_DECODER_MODE_MINIMAL)))
                {
                    ZydisSetAttributes(state, instruction, definition);
                    switch (instruction->encoding)
                    {
                    case ZYDIS_INSTRUCTION_ENCODING_XOP:
                    case ZYDIS_INSTRUCTION_ENCODING_VEX:
                    case ZYDIS_INSTRUCTION_ENCODING_EVEX:
                    case ZYDIS_INSTRUCTION_ENCODING_MVEX:
                        ZydisSetAVXInformation(state->context, instruction, definition);
                        break;
                    default:
                        break;
                    }

                    const ZydisDefinitionAccessedFlags* flags;
                    if (ZydisGetAccessedFlags(definition, &flags))
                    {
                        instruction->attributes |= ZYDIS_ATTRIB_CPUFLAG_ACCESS;
                    }
                    instruction->cpu_flags = &flags->cpu_flags;
                    instruction->fpu_flags = &flags->fpu_flags;
                }

#endif

                return ZYAN_STATUS_SUCCESS;
            }
            ZYAN_UNREACHABLE;
        }
        ZYAN_CHECK(status);
        node = ZydisDecoderTreeGetChildNode(node, index);
    } while ((node_type != ZYDIS_NODETYPE_INVALID) && !(node_type & ZYDIS_NODETYPE_DEFINITION_MASK));
    return ZYAN_STATUS_SUCCESS;
}

/* ---------------------------------------------------------------------------------------------- */

/* ============================================================================================== */
/* Exported functions                                                                             */
/* ============================================================================================== */

ZyanStatus ZydisDecoderInit(ZydisDecoder* decoder, ZydisMachineMode machine_mode,
    ZydisStackWidth stack_width)
{
    ZYAN_STATIC_ASSERT(ZYDIS_DECODER_MODE_MAX_VALUE <= 32);

    static const ZyanU32 decoder_modes =
#ifdef ZYDIS_MINIMAL_MODE
        (1 << ZYDIS_DECODER_MODE_MINIMAL) |
#endif
        (1 << ZYDIS_DECODER_MODE_MPX) |
        (1 << ZYDIS_DECODER_MODE_CET) |
        (1 << ZYDIS_DECODER_MODE_LZCNT) |
        (1 << ZYDIS_DECODER_MODE_TZCNT) |
        (1 << ZYDIS_DECODER_MODE_CLDEMOTE) |
        (1 << ZYDIS_DECODER_MODE_IPREFETCH);

    if (!decoder)
    {
        return ZYAN_STATUS_INVALID_ARGUMENT;
    }
    switch (machine_mode)
    {
    case ZYDIS_MACHINE_MODE_LONG_64:
        if (stack_width != ZYDIS_STACK_WIDTH_64)
        {
            return ZYAN_STATUS_INVALID_ARGUMENT;
        }
        break;
    case ZYDIS_MACHINE_MODE_LONG_COMPAT_32:
    case ZYDIS_MACHINE_MODE_LONG_COMPAT_16:
    case ZYDIS_MACHINE_MODE_LEGACY_32:
    case ZYDIS_MACHINE_MODE_LEGACY_16:
    case ZYDIS_MACHINE_MODE_REAL_16:
        if ((stack_width != ZYDIS_STACK_WIDTH_16) && (stack_width != ZYDIS_STACK_WIDTH_32))
        {
            return ZYAN_STATUS_INVALID_ARGUMENT;
        }
        break;
    default:
        return ZYAN_STATUS_INVALID_ARGUMENT;
    }

    decoder->machine_mode = machine_mode;
    decoder->stack_width = stack_width;
    decoder->decoder_mode = decoder_modes;

    return ZYAN_STATUS_SUCCESS;
}

ZyanStatus ZydisDecoderEnableMode(ZydisDecoder* decoder, ZydisDecoderMode mode, ZyanBool enabled)
{
    if (!decoder || ((ZyanUSize)mode > ZYDIS_DECODER_MODE_MAX_VALUE))
    {
        return ZYAN_STATUS_INVALID_ARGUMENT;
    }

#ifdef ZYDIS_MINIMAL_MODE
    if ((mode == ZYDIS_DECODER_MODE_MINIMAL) && !enabled)
    {
        return ZYAN_STATUS_INVALID_OPERATION;
    }
#endif

    if (enabled)
    {
        decoder->decoder_mode |= (1 << mode);
    }
    else
    {
        decoder->decoder_mode &= ~(1 << mode);
    }

    return ZYAN_STATUS_SUCCESS;
}

ZyanStatus ZydisDecoderDecodeFull(const ZydisDecoder* decoder,
    const void* buffer, ZyanUSize length, ZydisDecodedInstruction* instruction,
    ZydisDecodedOperand operands[ZYDIS_MAX_OPERAND_COUNT])
{
    if (!decoder || !instruction || !buffer || !operands)
    {
        return ZYAN_STATUS_INVALID_ARGUMENT;
    }
    if (!length)
    {
        return ZYDIS_STATUS_NO_MORE_DATA;
    }
    if (decoder->decoder_mode & (1 << ZYDIS_DECODER_MODE_MINIMAL))
    {
        return ZYAN_STATUS_MISSING_DEPENDENCY; // TODO: Introduce better status code
    }

    ZydisDecoderContext context;
    ZYAN_CHECK(ZydisDecoderDecodeInstruction(decoder, &context, buffer, length, instruction));
    ZYAN_CHECK(ZydisDecoderDecodeOperands(decoder, &context, instruction, operands,
        instruction->operand_count));
    ZYAN_MEMSET(&operands[instruction->operand_count], 0,
        (ZYDIS_MAX_OPERAND_COUNT - instruction->operand_count) * sizeof(operands[0]));

    return ZYAN_STATUS_SUCCESS;
}

ZyanStatus ZydisDecoderDecodeInstruction(const ZydisDecoder* decoder, ZydisDecoderContext* context,
    const void* buffer, ZyanUSize length, ZydisDecodedInstruction* instruction)
{
    if (!decoder || !instruction || !buffer)
    {
        return ZYAN_STATUS_INVALID_ARGUMENT;
    }

    if (!length)
    {
        return ZYDIS_STATUS_NO_MORE_DATA;
    }

    ZydisDecoderState state;
    ZYAN_MEMSET(&state, 0, sizeof(state));
    state.decoder = decoder;
    state.buffer = (const ZyanU8*)buffer;
    state.buffer_len = length;
    state.prefixes.offset_notrack = -1;

    ZydisDecoderContext default_context;
    if (!context)
    {
        // Use a fallback context if no custom one has been provided
        context = &default_context;
    }
    ZYAN_MEMSET(context, 0, sizeof(*context));
    state.context = context;

    ZYAN_MEMSET(instruction, 0, sizeof(*instruction));
    instruction->machine_mode = decoder->machine_mode;
    instruction->stack_width = 16 << decoder->stack_width;

    ZYAN_CHECK(ZydisCollectOptionalPrefixes(&state, instruction));
    ZYAN_CHECK(ZydisDecodeInstruction(&state, instruction));

    instruction->raw.encoding2 = instruction->encoding;

    return ZYAN_STATUS_SUCCESS;
}

ZyanStatus ZydisDecoderDecodeOperands(const ZydisDecoder* decoder,
    const ZydisDecoderContext* context, const ZydisDecodedInstruction* instruction,
    ZydisDecodedOperand* operands, ZyanU8 operand_count)
{
#ifdef ZYDIS_MINIMAL_MODE

    ZYAN_UNUSED(decoder);
    ZYAN_UNUSED(context);
    ZYAN_UNUSED(instruction);
    ZYAN_UNUSED(operands);
    ZYAN_UNUSED(operand_count);

    return ZYAN_STATUS_MISSING_DEPENDENCY; // TODO: Introduce better status code

#else

    if (!decoder || !context || !context->definition || !instruction ||
        (operand_count && !operands) || (operand_count > ZYDIS_MAX_OPERAND_COUNT))
    {
        return ZYAN_STATUS_INVALID_ARGUMENT;
    }

    if (decoder->decoder_mode & (1 << ZYDIS_DECODER_MODE_MINIMAL))
    {
        return ZYAN_STATUS_MISSING_DEPENDENCY; // TODO: Introduce better status code
    }

    operand_count = ZYAN_MIN(operand_count, instruction->operand_count);
    if (!operand_count)
    {
        return ZYAN_STATUS_SUCCESS;
    }

    return ZydisDecodeOperands(decoder, context, instruction, operands, operand_count);

#endif
}

/* ============================================================================================== */

//
// Source file: /home/ath/devel/zydis/src/DecoderData.c
//

/***************************************************************************************************

  Zyan Disassembler Library (Zydis)

  Original Author : Florian Bernd

 * Permission is hereby granted, free of charge, to any person obtaining a copy
 * of this software and associated documentation files (the "Software"), to deal
 * in the Software without restriction, including without limitation the rights
 * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
 * copies of the Software, and to permit persons to whom the Software is
 * furnished to do so, subject to the following conditions:
 *
 * The above copyright notice and this permission notice shall be included in all
 * copies or substantial portions of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
 * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
 * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
 * SOFTWARE.

***************************************************************************************************/


/* ============================================================================================== */
/* Data tables                                                                                    */
/* ============================================================================================== */

/* ---------------------------------------------------------------------------------------------- */
/* Physical instruction encodings                                                                 */
/* ---------------------------------------------------------------------------------------------- */


//
// Header: Generated/InstructionEncodings.inc
//

static const ZydisInstructionEncodingInfo INSTR_ENCODINGS[] =
{
    { 0, { { 0, 0, 0 } }, { { { 0, 0, 0 }, ZYAN_FALSE, ZYAN_FALSE }, { { 0, 0, 0 }, ZYAN_FALSE, ZYAN_FALSE } } },
    { ZYDIS_INSTR_ENC_FLAG_HAS_MODRM, { { 0, 0, 0 } }, { { { 0, 0, 0 }, ZYAN_FALSE, ZYAN_FALSE }, { { 0, 0, 0 }, ZYAN_FALSE, ZYAN_FALSE } } },
    { ZYDIS_INSTR_ENC_FLAG_HAS_DISP, { { 16, 32, 64 } }, { { { 0, 0, 0 }, ZYAN_FALSE, ZYAN_FALSE }, { { 0, 0, 0 }, ZYAN_FALSE, ZYAN_FALSE } } },
    { ZYDIS_INSTR_ENC_FLAG_HAS_IMM0, { { 0, 0, 0 } }, { { { 8, 8, 8 }, ZYAN_FALSE, ZYAN_FALSE }, { { 0, 0, 0 }, ZYAN_FALSE, ZYAN_FALSE } } },
    { ZYDIS_INSTR_ENC_FLAG_HAS_IMM0, { { 0, 0, 0 } }, { { { 16, 16, 16 }, ZYAN_FALSE, ZYAN_FALSE }, { { 0, 0, 0 }, ZYAN_FALSE, ZYAN_FALSE } } },
    { ZYDIS_INSTR_ENC_FLAG_HAS_IMM0, { { 0, 0, 0 } }, { { { 8, 8, 8 }, ZYAN_TRUE, ZYAN_FALSE }, { { 0, 0, 0 }, ZYAN_FALSE, ZYAN_FALSE } } },
    { ZYDIS_INSTR_ENC_FLAG_HAS_IMM0, { { 0, 0, 0 } }, { { { 16, 32, 32 }, ZYAN_TRUE, ZYAN_FALSE }, { { 0, 0, 0 }, ZYAN_FALSE, ZYAN_FALSE } } },
    { ZYDIS_INSTR_ENC_FLAG_HAS_IMM0, { { 0, 0, 0 } }, { { { 16, 32, 64 }, ZYAN_TRUE, ZYAN_FALSE }, { { 0, 0, 0 }, ZYAN_FALSE, ZYAN_FALSE } } },
    { ZYDIS_INSTR_ENC_FLAG_HAS_IMM0, { { 0, 0, 0 } }, { { { 8, 8, 8 }, ZYAN_TRUE, ZYAN_TRUE }, { { 0, 0, 0 }, ZYAN_FALSE, ZYAN_FALSE } } },
    { ZYDIS_INSTR_ENC_FLAG_HAS_IMM0, { { 0, 0, 0 } }, { { { 16, 32, 32 }, ZYAN_TRUE, ZYAN_TRUE }, { { 0, 0, 0 }, ZYAN_FALSE, ZYAN_FALSE } } },
    { ZYDIS_INSTR_ENC_FLAG_HAS_IMM0, { { 0, 0, 0 } }, { { { 32, 32, 32 }, ZYAN_TRUE, ZYAN_TRUE }, { { 0, 0, 0 }, ZYAN_FALSE, ZYAN_FALSE } } },
    { ZYDIS_INSTR_ENC_FLAG_HAS_MODRM | ZYDIS_INSTR_ENC_FLAG_HAS_IMM0, { { 0, 0, 0 } }, { { { 8, 8, 8 }, ZYAN_FALSE, ZYAN_FALSE }, { { 0, 0, 0 }, ZYAN_FALSE, ZYAN_FALSE } } },
    { ZYDIS_INSTR_ENC_FLAG_HAS_MODRM | ZYDIS_INSTR_ENC_FLAG_HAS_IMM0, { { 0, 0, 0 } }, { { { 32, 32, 32 }, ZYAN_FALSE, ZYAN_FALSE }, { { 0, 0, 0 }, ZYAN_FALSE, ZYAN_FALSE } } },
    { ZYDIS_INSTR_ENC_FLAG_HAS_MODRM | ZYDIS_INSTR_ENC_FLAG_HAS_IMM0, { { 0, 0, 0 } }, { { { 8, 8, 8 }, ZYAN_TRUE, ZYAN_FALSE }, { { 0, 0, 0 }, ZYAN_FALSE, ZYAN_FALSE } } },
    { ZYDIS_INSTR_ENC_FLAG_HAS_MODRM | ZYDIS_INSTR_ENC_FLAG_HAS_IMM0, { { 0, 0, 0 } }, { { { 16, 32, 32 }, ZYAN_TRUE, ZYAN_FALSE }, { { 0, 0, 0 }, ZYAN_FALSE, ZYAN_FALSE } } },
    { ZYDIS_INSTR_ENC_FLAG_HAS_MODRM | ZYDIS_INSTR_ENC_FLAG_HAS_IMM0, { { 0, 0, 0 } }, { { { 16, 32, 32 }, ZYAN_TRUE, ZYAN_TRUE }, { { 0, 0, 0 }, ZYAN_FALSE, ZYAN_FALSE } } },
    { ZYDIS_INSTR_ENC_FLAG_HAS_MODRM | ZYDIS_INSTR_ENC_FLAG_FORCE_REG_FORM, { { 0, 0, 0 } }, { { { 0, 0, 0 }, ZYAN_FALSE, ZYAN_FALSE }, { { 0, 0, 0 }, ZYAN_FALSE, ZYAN_FALSE } } },
    { ZYDIS_INSTR_ENC_FLAG_HAS_IMM0 | ZYDIS_INSTR_ENC_FLAG_HAS_IMM1, { { 0, 0, 0 } }, { { { 16, 16, 16 }, ZYAN_FALSE, ZYAN_FALSE }, { { 8, 8, 8 }, ZYAN_FALSE, ZYAN_FALSE } } },
    { ZYDIS_INSTR_ENC_FLAG_HAS_IMM0 | ZYDIS_INSTR_ENC_FLAG_HAS_IMM1, { { 0, 0, 0 } }, { { { 16, 32, 32 }, ZYAN_FALSE, ZYAN_FALSE }, { { 16, 16, 16 }, ZYAN_FALSE, ZYAN_FALSE } } },
    { ZYDIS_INSTR_ENC_FLAG_HAS_MODRM | ZYDIS_INSTR_ENC_FLAG_HAS_IMM0 | ZYDIS_INSTR_ENC_FLAG_HAS_IMM1, { { 0, 0, 0 } }, { { { 8, 8, 8 }, ZYAN_FALSE, ZYAN_FALSE }, { { 8, 8, 8 }, ZYAN_FALSE, ZYAN_FALSE } } }
};

/* ---------------------------------------------------------------------------------------------- */
/* Decoder tree                                                                                   */
/* ---------------------------------------------------------------------------------------------- */

#define ZYDIS_INVALID \
    { ZYDIS_NODETYPE_INVALID, 0x00000000 }
#define ZYDIS_FILTER(type, id) \
    { type, id }
#define ZYDIS_DEFINITION(encoding_id, id) \
    { ZYDIS_NODETYPE_DEFINITION_MASK | encoding_id, id }


//
// Header: Generated/DecoderTables.inc
//

const ZydisDecoderTreeNode FILTERS_XOP[][13] =
{
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x3EE), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_OPCODE, 0x20), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_OPCODE, 0x21), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_OPCODE, 0x22), ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID }
};

const ZydisDecoderTreeNode FILTERS_VEX[][17] =
{
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x43B), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_OPCODE, 0x23), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_OPCODE, 0x24), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_OPCODE, 0x25), ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_OPCODE, 0x26), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_OPCODE, 0x27), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_OPCODE, 0x28), ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_OPCODE, 0x29), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_OPCODE, 0x2A), ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_OPCODE, 0x2B), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_OPCODE, 0x2C), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_OPCODE, 0x2D) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x759), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_OPCODE, 0x23), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_OPCODE, 0x24), ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_OPCODE, 0x26), ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_OPCODE, 0x29), ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_OPCODE, 0x2B), ZYDIS_INVALID, ZYDIS_INVALID }
};

const ZydisDecoderTreeNode FILTERS_EMVEX[][49] =
{
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x159), ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_OPCODE, 0x5), ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_OPCODE, 0x6), ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_OPCODE, 0x7), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_OPCODE, 0x8), ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_OPCODE, 0x9), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_OPCODE, 0xA), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_OPCODE, 0xB), ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_OPCODE, 0xC), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_OPCODE, 0xD), ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_OPCODE, 0xE), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_OPCODE, 0xF), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_OPCODE, 0x10), ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_OPCODE, 0x11), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_OPCODE, 0x12), ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_OPCODE, 0x13), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_OPCODE, 0x14), ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_OPCODE, 0x15), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_OPCODE, 0x16), ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_OPCODE, 0x17), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_OPCODE, 0x18), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_OPCODE, 0x19), ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_OPCODE, 0x1A), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_OPCODE, 0x1B), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_OPCODE, 0x1C), ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_OPCODE, 0x1D), ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_OPCODE, 0x1E), ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_OPCODE, 0x1F) }
};

const ZydisDecoderTreeNode FILTERS_OPCODE[][256] =
{
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x0), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x1), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x2), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x3), ZYDIS_DEFINITION(0x5, 0x26), ZYDIS_DEFINITION(0x6, 0x27), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODE_COMPACT, 0x0), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODE_COMPACT, 0x1), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x4), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x5), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x6), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x7), ZYDIS_DEFINITION(0x5, 0x3F6), ZYDIS_DEFINITION(0x6, 0x3F7), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODE_COMPACT, 0x2), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_OPCODE, 0x1), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x141), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x142), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x143), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x144), ZYDIS_DEFINITION(0x5, 0x10), ZYDIS_DEFINITION(0x6, 0x11), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODE_COMPACT, 0x59), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODE_COMPACT, 0x5A), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x145), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x146), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x147), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x148), ZYDIS_DEFINITION(0x5, 0x64D), ZYDIS_DEFINITION(0x6, 0x64E), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODE_COMPACT, 0x5B), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODE_COMPACT, 0x5C), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x149), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x14A), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x14B), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x14C), ZYDIS_DEFINITION(0x5, 0x5C), ZYDIS_DEFINITION(0x6, 0x5D), ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODE_COMPACT, 0x5D), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x14D), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x14E), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x14F), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x150), ZYDIS_DEFINITION(0x5, 0x6F6), ZYDIS_DEFINITION(0x6, 0x6F7), ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODE_COMPACT, 0x5E), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x151), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x152), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x153), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x154), ZYDIS_DEFINITION(0x5, 0x77C), ZYDIS_DEFINITION(0x6, 0x77D), ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODE_COMPACT, 0x5F), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x155), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x156), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x157), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x158), ZYDIS_DEFINITION(0x5, 0xEF), ZYDIS_DEFINITION(0x6, 0xF0), ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODE_COMPACT, 0x60), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODE_COMPACT, 0x61), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODE_COMPACT, 0x62), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODE_COMPACT, 0x63), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODE_COMPACT, 0x64), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODE_COMPACT, 0x65), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODE_COMPACT, 0x66), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODE_COMPACT, 0x67), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODE_COMPACT, 0x68), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODE_COMPACT, 0x69), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODE_COMPACT, 0x6A), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODE_COMPACT, 0x6B), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODE_COMPACT, 0x6C), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODE_COMPACT, 0x6D), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODE_COMPACT, 0x6E), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODE_COMPACT, 0x6F), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODE_COMPACT, 0x70), ZYDIS_DEFINITION(0x0, 0x5CE), ZYDIS_DEFINITION(0x0, 0x5CE), ZYDIS_DEFINITION(0x0, 0x5CE), ZYDIS_DEFINITION(0x0, 0x5CE), ZYDIS_DEFINITION(0x0, 0x5CE), ZYDIS_DEFINITION(0x0, 0x5CE), ZYDIS_DEFINITION(0x0, 0x5CE), ZYDIS_DEFINITION(0x0, 0x5CE), ZYDIS_DEFINITION(0x0, 0x522), ZYDIS_DEFINITION(0x0, 0x522), ZYDIS_DEFINITION(0x0, 0x522), ZYDIS_DEFINITION(0x0, 0x522), ZYDIS_DEFINITION(0x0, 0x522), ZYDIS_DEFINITION(0x0, 0x522), ZYDIS_DEFINITION(0x0, 0x522), ZYDIS_DEFINITION(0x0, 0x522), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODE_COMPACT, 0x71), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODE_COMPACT, 0x72), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EMVEX, 0x0), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x3DC), ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_DEFINITION(0x6, 0x5CF), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x3DD), ZYDIS_DEFINITION(0x5, 0x5D0), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x3DE), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MANDATORY_PREFIX, 0x1A5), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MANDATORY_PREFIX, 0x1A6), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MANDATORY_PREFIX, 0x1A7), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MANDATORY_PREFIX, 0x1A8), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODE_COMPACT, 0xAF), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODE_COMPACT, 0xB0), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODE_COMPACT, 0xB1), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODE_COMPACT, 0xB2), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODE_COMPACT, 0xB3), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODE_COMPACT, 0xB4), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODE_COMPACT, 0xB5), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODE_COMPACT, 0xB6), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODE_COMPACT, 0xB7), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODE_COMPACT, 0xB8), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODE_COMPACT, 0xB9), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODE_COMPACT, 0xBA), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODE_COMPACT, 0xBB), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODE_COMPACT, 0xBC), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODE_COMPACT, 0xBD), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODE_COMPACT, 0xBE), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x3DF), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x3E0), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x3E1), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x3E2), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x3E3), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x3E4), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x3E5), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x3E6), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x3E7), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x3E8), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x3E9), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x3EA), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x3EB), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x3EC), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x3ED), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_XOP, 0x0), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MANDATORY_PREFIX, 0x1A9), ZYDIS_DEFINITION(0x0, 0x76B), ZYDIS_DEFINITION(0x0, 0x76B), ZYDIS_DEFINITION(0x0, 0x76B), ZYDIS_DEFINITION(0x0, 0x76B), ZYDIS_DEFINITION(0x0, 0x76B), ZYDIS_DEFINITION(0x0, 0x76B), ZYDIS_DEFINITION(0x0, 0x76B), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_OPERAND_SIZE, 0xB), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_OPERAND_SIZE, 0xC), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODE_COMPACT, 0xCF), ZYDIS_DEFINITION(0x0, 0x20F), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODE_COMPACT, 0xD0), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODE_COMPACT, 0xD1), ZYDIS_DEFINITION(0x0, 0x636), ZYDIS_DEFINITION(0x0, 0x2C5), ZYDIS_DEFINITION(0x2, 0x315), ZYDIS_DEFINITION(0x2, 0x316), ZYDIS_DEFINITION(0x2, 0x317), ZYDIS_DEFINITION(0x2, 0x318), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MANDATORY_PREFIX, 0x1AA), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MANDATORY_PREFIX, 0x1AB), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MANDATORY_PREFIX, 0x1AC), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MANDATORY_PREFIX, 0x1AD), ZYDIS_DEFINITION(0x5, 0x718), ZYDIS_DEFINITION(0x6, 0x719), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MANDATORY_PREFIX, 0x1AE), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MANDATORY_PREFIX, 0x1AF), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MANDATORY_PREFIX, 0x1B0), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MANDATORY_PREFIX, 0x1B1), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MANDATORY_PREFIX, 0x1B2), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MANDATORY_PREFIX, 0x1B3), ZYDIS_DEFINITION(0x5, 0x319), ZYDIS_DEFINITION(0x5, 0x319), ZYDIS_DEFINITION(0x5, 0x319), ZYDIS_DEFINITION(0x5, 0x319), ZYDIS_DEFINITION(0x5, 0x319), ZYDIS_DEFINITION(0x5, 0x319), ZYDIS_DEFINITION(0x5, 0x319), ZYDIS_DEFINITION(0x5, 0x319), ZYDIS_DEFINITION(0x7, 0x31A), ZYDIS_DEFINITION(0x7, 0x31A), ZYDIS_DEFINITION(0x7, 0x31A), ZYDIS_DEFINITION(0x7, 0x31A), ZYDIS_DEFINITION(0x7, 0x31A), ZYDIS_DEFINITION(0x7, 0x31A), ZYDIS_DEFINITION(0x7, 0x31A), ZYDIS_DEFINITION(0x7, 0x31A), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x439), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x43A), ZYDIS_DEFINITION(0x4, 0x60A), ZYDIS_DEFINITION(0x0, 0x60B), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VEX, 0x0), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VEX, 0x1), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x75A), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x75B), ZYDIS_DEFINITION(0x11, 0x17C), ZYDIS_DEFINITION(0x0, 0x2CC), ZYDIS_DEFINITION(0x4, 0x60C), ZYDIS_DEFINITION(0x0, 0x60D), ZYDIS_DEFINITION(0x0, 0x259), ZYDIS_DEFINITION(0x3, 0x257), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODE_COMPACT, 0x121), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_OPERAND_SIZE, 0x20), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x75C), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x75D), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x75E), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x75F), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODE_COMPACT, 0x122), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODE_COMPACT, 0x123), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODE_COMPACT, 0x124), ZYDIS_DEFINITION(0x0, 0x773), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x760), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x761), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x762), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x763), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x764), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x765), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x766), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x767), ZYDIS_DEFINITION(0x8, 0x2E8), ZYDIS_DEFINITION(0x8, 0x2E7), ZYDIS_DEFINITION(0x8, 0x2E6), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODE_COMPACT, 0x125), ZYDIS_DEFINITION(0x3, 0x23A), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_OPERAND_SIZE, 0x25), ZYDIS_DEFINITION(0x3, 0x404), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_OPERAND_SIZE, 0x26), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODE_COMPACT, 0x126), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODE_COMPACT, 0x127), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODE_COMPACT, 0x128), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODE_COMPACT, 0x129), ZYDIS_DEFINITION(0x0, 0x23D), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_OPERAND_SIZE, 0x27), ZYDIS_DEFINITION(0x0, 0x407), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_OPERAND_SIZE, 0x28), ZYDIS_INVALID, ZYDIS_DEFINITION(0x0, 0x258), ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_DEFINITION(0x0, 0x226), ZYDIS_DEFINITION(0x0, 0xC6), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x768), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x769), ZYDIS_DEFINITION(0x0, 0xBA), ZYDIS_DEFINITION(0x0, 0x6DA), ZYDIS_DEFINITION(0x0, 0xC0), ZYDIS_DEFINITION(0x0, 0x6DD), ZYDIS_DEFINITION(0x0, 0xBB), ZYDIS_DEFINITION(0x0, 0x6DB), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x76A), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x76B) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x8), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x9), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0xA), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0xB), ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODE_COMPACT, 0x1E), ZYDIS_DEFINITION(0x0, 0xC2), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODE_COMPACT, 0x1F), ZYDIS_DEFINITION(0x0, 0x25B), ZYDIS_DEFINITION(0x0, 0x755), ZYDIS_INVALID, ZYDIS_DEFINITION(0x0, 0x730), ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0xC), ZYDIS_DEFINITION(0x0, 0x1AC), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_OPCODE, 0x2), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x25), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x26), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x27), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x28), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x29), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x2A), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x2B), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x2C), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x2D), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x2E), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODE_MPX, 0x0), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODE_MPX, 0x1), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x33), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x34), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x35), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x36), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODE_COMPACT, 0x2C), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODE_COMPACT, 0x2D), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODE_COMPACT, 0x2E), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODE_COMPACT, 0x2F), ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x37), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x38), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x39), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x3A), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x3B), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x3C), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x3D), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x3E), ZYDIS_DEFINITION(0x0, 0x758), ZYDIS_DEFINITION(0x0, 0x608), ZYDIS_DEFINITION(0x0, 0x5FD), ZYDIS_DEFINITION(0x0, 0x602), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODE_COMPACT, 0x30), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODE_COMPACT, 0x31), ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MANDATORY_PREFIX, 0x25), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_OPCODE, 0x3), ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_OPCODE, 0x4), ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0xA2), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0xA3), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0xA4), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0xA5), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0xA6), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0xA7), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0xA8), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0xA9), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0xAA), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0xAB), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0xAC), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0xAD), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0xAE), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0xAF), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0xB0), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0xB1), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0xB2), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0xB3), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0xB4), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0xB5), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0xB6), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0xB7), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0xB8), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0xB9), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0xBA), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0xBB), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0xBC), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0xBD), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0xBE), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0xBF), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0xC0), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0xC1), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0xC2), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0xC3), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0xC4), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0xC5), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0xC6), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0xC7), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0xC8), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0xC9), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0xCA), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0xCB), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0xCC), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0xCD), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0xCE), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0xCF), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0xD0), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0xD1), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0xD2), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0xD3), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0xD4), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0xD5), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0xD6), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0xD7), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0xD8), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MANDATORY_PREFIX, 0x12A), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0xD9), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0xDA), ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0xDB), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0xDC), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0xDD), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0xDE), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODE_COMPACT, 0x42), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODE_COMPACT, 0x43), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODE_COMPACT, 0x44), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODE_COMPACT, 0x45), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODE_COMPACT, 0x46), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODE_COMPACT, 0x47), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODE_COMPACT, 0x48), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODE_COMPACT, 0x49), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODE_COMPACT, 0x4A), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODE_COMPACT, 0x4B), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODE_COMPACT, 0x4C), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODE_COMPACT, 0x4D), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODE_COMPACT, 0x4E), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODE_COMPACT, 0x4F), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODE_COMPACT, 0x50), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODE_COMPACT, 0x51), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0xDF), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0xE0), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0xE1), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0xE2), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0xE3), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0xE4), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0xE5), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0xE6), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0xE7), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0xE8), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0xE9), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0xEA), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0xEB), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0xEC), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0xED), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0xEE), ZYDIS_DEFINITION(0x0, 0x5D3), ZYDIS_DEFINITION(0x0, 0x525), ZYDIS_DEFINITION(0x0, 0x118), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0xEF), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0xF0), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0xF1), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0xF2), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0xF3), ZYDIS_DEFINITION(0x0, 0x5D4), ZYDIS_DEFINITION(0x0, 0x526), ZYDIS_DEFINITION(0x0, 0x630), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0xF4), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0xF5), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0xF6), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0xF7), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0xF8), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0xF9), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0xFA), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0xFB), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0xFC), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0xFD), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0xFE), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0xFF), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x100), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x101), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x102), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x103), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x104), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x105), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x106), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x107), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x108), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x109), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x10A), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x10B), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x10C), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x10D), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x10E), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x10F), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x110), ZYDIS_DEFINITION(0x0, 0x9E), ZYDIS_DEFINITION(0x0, 0x9E), ZYDIS_DEFINITION(0x0, 0x9E), ZYDIS_DEFINITION(0x0, 0x9E), ZYDIS_DEFINITION(0x0, 0x9E), ZYDIS_DEFINITION(0x0, 0x9E), ZYDIS_DEFINITION(0x0, 0x9E), ZYDIS_DEFINITION(0x0, 0x9E), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x111), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x112), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x113), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x114), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x115), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x116), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x117), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x118), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x119), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x11A), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x11B), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x11C), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x11D), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x11E), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x11F), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x120), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x121), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x122), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x123), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x124), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x125), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x126), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x127), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x128), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x129), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x12A), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x12B), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x12C), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x12D), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x12E), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x12F), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x130), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x131), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x132), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x133), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x134), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x135), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x136), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x137), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x138), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x139), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x13A), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x13B), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x13C), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x13D), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x13E), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x13F), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODE_UD0_COMPAT, 0x0) },
    { ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0xD), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0xE), ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0xF), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x10), ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x11), ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x12), ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x13), ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x14), ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x15), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x16), ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x17), ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x18), ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x19), ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x1A), ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x1B), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x1C), ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x1D), ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x1E), ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x1F), ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x20), ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x21), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x22), ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x23), ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x24), ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x3F), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x40), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x41), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x42), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x43), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x44), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x45), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x46), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x47), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x48), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x49), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x4A), ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x4B), ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x4C), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x4D), ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x4E), ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x4F), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x50), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x51), ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x52), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x53), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x54), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x55), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x56), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x57), ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x58), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x59), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x5A), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x5B), ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x5C), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x5D), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x5E), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x5F), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x60), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x61), ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x62), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x63), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x64), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x65), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x66), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x67), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x68), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x69), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x6A), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x6B), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x6C), ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x6D), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x6E), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x6F), ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x70), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x71), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x72), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x73), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x74), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x75), ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x76), ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x77), ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x78), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x79), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x7A), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x7B), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x7C), ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x7D), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x7E), ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x7F), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x80), ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x81), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x82), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x83), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x84), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x85), ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x86), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x87), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x88), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x89), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x8A), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x8B), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x8C), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x8D), ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x8E), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x8F), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x90), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x91), ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x92), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x93), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x94), ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x95), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x96), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x97), ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x98), ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x99), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x9A), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x9B), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x9C), ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x9D), ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x9E), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x9F), ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0xA0), ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0xA1), ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x15A), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x15B), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x15C), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x15D), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x15E), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x15F), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x160), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x161), ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x162), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x163), ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x164), ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x165), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x166), ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x167), ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x168), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x169), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x16A), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x16B), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x16C), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x16D), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x16E), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x16F), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x170), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x171), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x172), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x173), ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x174), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x175), ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x176), ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x177), ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x178), ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x179), ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x17A), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x17B), ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x17C), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x17D), ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x17E), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x17F), ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x180), ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x181), ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x182), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x183), ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x184), ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x185), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x186), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x187), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x188), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x189), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x18A), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x18B), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x18C), ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x18D), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x18E), ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x18F), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x190), ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x191), ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x192), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x193), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x194), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x195), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x196), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x197), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x198), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x199), ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x19A), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x19B), ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x19C), ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x19D), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x19E), ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x19F), ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x1A0), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x1A1), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x1A2), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x1A3), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x1A4), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x1A5), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x1A6), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x1A7), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x1A8), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x1A9), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x1AA), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x1AB), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x1AC), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x1AD), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x1AE), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x1AF), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x1B0), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x1B1), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x1B2), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x1B3), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x1B4), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x1B5), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x1B6), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x1B7), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x1B8), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x1B9), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x1BA), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x1BB), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x1BC), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x1BD), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x1BE), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x1BF), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x1C0), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x1C1), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x1C2), ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x1C3), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x1C4), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x1C5), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x1C6), ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x1C7), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x1C8), ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x1C9), ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x1CA), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x1CB), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x1CC), ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x1CD), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x1CE), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x1CF), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x1D0), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x1D1), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x1D2), ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x1D3), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x1D4), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x1D5), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x1D6), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x1D7), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x1D8), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x1D9), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x1DA), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x1DB), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x1DC), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x1DD), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x1DE), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x1DF), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x1E0), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x1E1), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x1E2), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x1E3), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x1E4), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x1E5), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x1E6), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x1E7), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x1E8), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x1E9), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x1EA), ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x1EB), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x1EC), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x1ED), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x1EE), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x1EF), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x1F0), ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x1F1), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x1F2), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x1F3), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x1F4), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x1F5), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x1F6), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x1F7), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x1F8), ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x1F9), ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x1FA), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x1FB), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x1FC), ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x1FD), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x1FE), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x1FF), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x200), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x201), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x202), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x203), ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x204), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x205), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x206), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x207), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x208), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x209), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x20A), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x20B), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x20C), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x20D), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x20E), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x20F), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x210), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x211), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x212), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x213), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x214), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x215), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x216), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x217), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x218), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x219), ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x21A), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x21B), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x21C), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x21D), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x21E), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x21F), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x220), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x221), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x222), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x223), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x224), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x225), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x226), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x227), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x228), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x229), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x22A), ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x22B), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x22C), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x22D), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x22E), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x22F), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x230), ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x231), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x232), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x233), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x234), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x235), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x236), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x237), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x238), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x239), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x23A), ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x23B), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x23C), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x23D), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x23E), ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x23F), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x240), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x241), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x242), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x243), ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x244), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x245), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x246), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x247), ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x248), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x249), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x24A), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x24B), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x24C), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x24D), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x24E), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x24F), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x250), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x251), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x252), ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x253), ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x254), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x255), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x256), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x257), ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x258), ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x259), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x25A), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x25B), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x25C), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x25D), ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x25E), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x25F), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x260), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x261), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x262), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x263), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x264), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x265), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x266), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x267), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x268), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x269), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x26A), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x26B), ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x26C), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x26D), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x26E), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x26F), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x270), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x271), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x272), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x273), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x274), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x275), ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x276), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x277), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x278), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x279), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x27A), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x27B), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x27C), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x27D), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x27E), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x27F), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x280), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x281), ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x282), ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x283), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x284), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x285), ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x286), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x287), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x288), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x289), ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x28A), ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x28B), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x28C), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x28D), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x28E), ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x28F), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x290), ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x291), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x292), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x293), ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x294), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x295), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x296), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x297), ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x298), ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x299), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x29A), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x29B), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x29C), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x29D), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x29E), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x29F), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x2A0), ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x2A1), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x2A2), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x2A3), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x2A4), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x2A5), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x2A6), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x2A7), ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x2A8), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x2A9), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x2AA), ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x2AB), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x2AC), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x2AD), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x2AE), ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x2AF), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x2B0), ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x2B1), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x2B2), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x2B3), ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x2B4), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x2B5), ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x2B6), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x2B7), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x2B8), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x2B9), ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x2BA), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x2BB), ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x2BC), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x2BD), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x2BE), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x2BF), ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x2C0), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x2C1), ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x2C2), ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x2C3), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x2C4), ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x2C5), ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x2C6), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x2C7), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x2C8), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x2C9), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x2CA), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x2CB), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x2CC), ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x2CD), ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x2CE), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x2CF), ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x2D0), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x2D1), ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x2D2), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x2D3), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x2D4), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x2D5), ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x2D6), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x2D7), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x2D8), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x2D9), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x2DA), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x2DB), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x2DC), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x2DD), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x2DE), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x2DF), ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x2E0), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x2E1), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x2E2), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x2E3), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x2E4), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x2E5), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x2E6), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x2E7), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x2E8), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x2E9), ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x2EA), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x2EB), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x2EC), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x2ED), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x2EE), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x2EF), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x2F0), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x2F1), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x2F2), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x2F3), ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x2F4), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x2F5), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x2F6), ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x2F7), ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x2F8), ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x2F9), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x2FA), ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x2FB), ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x2FC), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x2FD), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x2FE), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x2FF), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x300), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x301), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x302), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x303), ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x304), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x305), ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x306), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x307), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x308), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x309), ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x30A), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x30B), ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x30C), ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x30D), ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x30E), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x30F), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x310), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x311), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x312), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x313), ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x314), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x315), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x316), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x317), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x318), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x319), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x31A), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x31B), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x31C), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x31D), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x31E), ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x31F), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x320), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x321), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x322), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x323), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x324), ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x325), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x326), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x327), ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x328), ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x329), ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x32A), ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x32B), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x32C), ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x32D), ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x32E), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x32F), ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x330), ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x331), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x332), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x333), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x334), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x335), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x336), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x337), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x338), ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x339), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x33A), ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x33B), ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x33C), ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x33D), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x33E), ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x33F), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x340), ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x341), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x342), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x343), ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x344), ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x345), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x346), ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x347), ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x348), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x349), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x34A), ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x34B), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x34C), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x34D), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x34E), ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x34F), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x350), ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x351), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x352), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x353), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x354), ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x355), ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x356), ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x357), ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x358), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x359), ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x35A), ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x35B), ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x35C), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x35D), ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x35E), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x35F), ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x360), ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x361), ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x362), ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x363), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x364), ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x365), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x366), ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x367), ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x368), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x369), ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x36A), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x36B), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x36C), ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x36D), ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x36E), ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x36F), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x370), ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x371), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x372), ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x373), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x374), ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x375), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x376), ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x377), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x378), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x379), ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x37A), ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x37B), ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x37C), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x37D), ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x37E), ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x37F), ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x380), ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x381), ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x382), ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x383), ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x384), ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x385), ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x386), ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x387), ZYDIS_INVALID },
    { ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x388), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x389), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x38A), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x38B), ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x38C), ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x38D), ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x38E), ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x38F), ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x390), ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x391), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x392), ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x393), ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x394), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x395), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x396), ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x397), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x398), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x399), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x39A), ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x39B), ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x39C), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x39D), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x39E), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x39F), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x3A0), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x3A1), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x3A2), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x3A3), ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x3A4), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x3A5), ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x3A6), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x3A7), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x3A8), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x3A9), ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x3AA), ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x3AB), ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x3AC), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x3AD), ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x3AE), ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x3AF), ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x3B0), ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x3B1), ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x3B2), ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x3B3), ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x3B4), ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x3B5), ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x3B6), ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x3B7), ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x3B8), ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x3B9), ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x3BA), ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x3BB), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x3BC), ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x3BD), ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x3BE), ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x3BF), ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x3C0), ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x3C1), ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x3C2), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x3C3), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x3C4), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x3C5), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x3C6), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x3C7), ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x3C8), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x3C9), ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x3CA), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x3CB), ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x3CC), ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x3CD), ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x3CE), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x3CF), ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x3D0), ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x3D1), ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x3D2), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x3D3), ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x3D4), ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x3D5), ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x3D6), ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x3D7), ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x3D8), ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x3D9), ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x3DA), ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x3DB), ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x448), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x449), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x44A), ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x44B), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x44C), ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x44D), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x44E), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x44F), ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x450), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x451), ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x452), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x453), ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x454), ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x455), ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x456), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x457), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x458), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x459), ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x45A), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x45B), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x45C), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x45D), ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x45E), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x45F), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x460), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x461), ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_REG, 0x43), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_REG, 0x44), ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_REG, 0x45), ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x46D), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x46E), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x46F), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x470), ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x471), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x472), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x473), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x474), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x475), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x476), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x477), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x478), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x479), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x47A), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x47B), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x47C), ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x47D), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x47E), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x47F), ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x480), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x481), ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x482), ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x483), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x484), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x485), ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x486), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x487), ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x488), ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x489), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x48A), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x48B), ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x48C), ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_REG, 0x46), ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x48F), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x490), ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x491), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x492), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x493), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x494), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x495), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x496), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x497), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x498), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_REG, 0x4B), ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x4A1), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x4A2), ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x4A3), ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x456), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x457), ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x4A4), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x4A5), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x4A6), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x4A7), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x4A8), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x4A9), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x4AA), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x4AB), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x4AC), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x4AD), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x4AE), ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x4AF), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x4B0), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x4B1), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x4B2), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x4B3), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x4B4), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x4B5), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x4B6), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x4B7), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x4B8), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x4B9), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x4BA), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x4BB), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x4BC), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x4BD), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x4BE), ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x4BF), ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x4C0), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x4C1), ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x4C2), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x4C3), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x4C4), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x4C5), ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x4C6), ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x4C7), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x4C8), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x4C9), ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_REG, 0x4C), ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x4CC), ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x4CD), ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_REG, 0x4D), ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x4D6), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x4D7), ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x4D8), ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x4D9), ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x4DA), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x4DB), ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x4DC), ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x4DD), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_REG, 0x4E), ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x4E1), ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x4E2), ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x4E3), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x4E4), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x4E5), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x4E6), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x4E7), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x4E8), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x4E9), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x4EA), ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x4EB), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x4EC), ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x4ED), ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x4C9), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x4CA), ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x4EE), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x4EF), ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x4F0), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x4F1), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x4F2), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x4F3), ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x4F4), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x4F5), ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x4F6), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x4F7), ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x4F8), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x4F9), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x4FA), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x4FB), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x4FC), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x4FD), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x4FE), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x4FF), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x500), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x501), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x502), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x503), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x504), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x505), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x506), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x507), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x508), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x509), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x50A), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x50B), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x50C), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x50D), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x50E), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x50F), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x510), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x511), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x512), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x513), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x514), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_REG, 0x4F), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_REG, 0x50), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_REG, 0x51), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x51F), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x520), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x521), ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x522), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x523), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x524), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x525), ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x526), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x527), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x528), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x529), ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x52A), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x52B), ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x52C), ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x52D), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x52E), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x52F), ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x530), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x531), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x532), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x533), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x534), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x535), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x536), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x537), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x538), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x539), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x53A), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x53B), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x53C), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x53D), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x53E), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x53F), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x540), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x541), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x542), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x543), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x544), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x545), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x546), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x547), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x548), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x549), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x54A), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x54B), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x54C), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x54D), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x54E), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x54F), ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x550), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x551), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x552), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x553), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x554), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x555), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x556), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x557), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x558), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x559), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x55A), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x55B), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x55C), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x55D), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x55E), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x55F), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x560), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x561), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x562), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x563), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x564), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x565), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x566), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x567), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x568), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x569), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x56A), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x56B), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x56C), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x56D), ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x56E), ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x56F), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x570), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x571), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x572), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x573), ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x574), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x575), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x576), ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x577), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x578), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x579), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x57A), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x57B), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x57C), ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x57D), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x57E), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x57F), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x580), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x581), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x582), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x583), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x584), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x585), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x586), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x587), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x588), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x589), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x58A), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x58B), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x58C), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x58D), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x58E), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x58F), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x590), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x591), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x592), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x593), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x594), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x595), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x596), ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x597), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x598), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x599), ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_REG, 0x52), ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_RM, 0x35), ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x59C), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x59D), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x59E), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x59F), ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x5A0), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x5A1), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x5A2), ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x5A3), ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x5A4), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x5A5), ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x5A6), ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x5A7), ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_RM, 0x36), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_RM, 0x37), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_RM, 0x38), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_RM, 0x39), ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x5AC), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x5AD), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x5AE), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x632), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x5AF), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x635), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x5B0), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x638), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x5B1), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x63B), ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x5B2), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x5B3), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x5B4), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x642), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x5B5), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x645), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x5B6), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x648), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x5B7), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x64B), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x5B8), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x5B9), ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x5BA), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x5BB), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x5BC), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x5BD), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x5BE), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x65A), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x5BF), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x65D), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x5C0), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x660), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x5C1), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x663), ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x5C2), ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x5C3), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x5C4), ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x5C5), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x5C6), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x5C7), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x5C8), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x5C9), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x5CA), ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x5CB), ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x5CC), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x5CD), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x5CE), ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x5CF), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x5D0), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x5D1), ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x5D2), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x5D3), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x683), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x684), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x5D4), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x5D5), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x5D6), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x5D7), ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x5D8), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x5D9), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x5DA), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x5DB), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x5DC), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x5DD), ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x5DE), ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x5DF), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x5E0), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x5E1), ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x5E2), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x5E3), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x5E4), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x5E5), ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x5E6), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x5E7), ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x5E8), ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x5E9), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x5EA), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x5EB), ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x5EC), ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x5ED), ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x5EE), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x5EF), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x5F0), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x5F1), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x5F2), ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x5F3), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x5F4), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x5F5), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x5F6), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x5F7), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x5F8), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x5F9), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x5FA), ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x5FB), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x5FC), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x6C4), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x6C5), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x5FD), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x5FE), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x6CA), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x6CB), ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x5FF), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x600), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x6D0), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x6D1), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x601), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x602), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x6D6), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x6D7), ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x603), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x604), ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x605), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x606), ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x6DE), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x6DF), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x607), ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x608), ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODE_COMPACT, 0x103), ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODE_COMPACT, 0x104), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODE_COMPACT, 0x105), ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x6EA), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x6EB), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x6EC), ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x6ED), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x6EE), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x6EF), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x609), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x6F2), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x6F3), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x6F4), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x6F5), ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x60A), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x60B), ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x60C), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x60D), ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_REG, 0x53), ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x610), ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x611), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x612), ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x702), ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x613), ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_RM, 0x3A), ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x615), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x616), ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x617), ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x618), ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x619), ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x61A), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x61B), ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x61C), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x61D), ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x61E), ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x61F), ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x620), ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x71C), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x71D), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x621), ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODE_COMPACT, 0x110), ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODE_COMPACT, 0x111), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODE_COMPACT, 0x112), ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x726), ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x727), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x728), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x729), ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x72A), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x72B), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x72C), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x72D), ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x622), ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x623), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x624), ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x625), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x626), ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_REG, 0x54), ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x629), ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x73B), ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x62A), ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x62B), ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x62C), ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_RM, 0x3B), ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_RM, 0x3C), ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x62F), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x630), ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x631), ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x632), ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x633), ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x634), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x635), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x636), ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x637), ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x638), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x639), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x63A), ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x63B), ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID }
};

const ZydisDecoderTreeNode FILTERS_MODE[][3] =
{
    { ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID }
};

const ZydisDecoderTreeNode FILTERS_MODE_COMPACT[][2] =
{
    { ZYDIS_INVALID, ZYDIS_DEFINITION(0x0, 0x5CA) },
    { ZYDIS_INVALID, ZYDIS_DEFINITION(0x0, 0x51F) },
    { ZYDIS_INVALID, ZYDIS_DEFINITION(0x0, 0x5CB) },
    { ZYDIS_DEFINITION(0x1, 0x708), ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0x1, 0x174), ZYDIS_DEFINITION(0x1, 0x175) },
    { ZYDIS_DEFINITION(0x1, 0x495), ZYDIS_DEFINITION(0x1, 0x496) },
    { ZYDIS_DEFINITION(0x1, 0x469), ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0x1, 0x304), ZYDIS_DEFINITION(0x1, 0x305) },
    { ZYDIS_DEFINITION(0x1, 0x3AE), ZYDIS_DEFINITION(0x1, 0x3AF) },
    { ZYDIS_DEFINITION(0x1, 0x170), ZYDIS_DEFINITION(0x1, 0x171) },
    { ZYDIS_DEFINITION(0x1, 0x172), ZYDIS_DEFINITION(0x1, 0x173) },
    { ZYDIS_DEFINITION(0x1, 0x306), ZYDIS_DEFINITION(0x1, 0x307) },
    { ZYDIS_DEFINITION(0x1, 0x3B0), ZYDIS_DEFINITION(0x1, 0x3B1) },
    { ZYDIS_DEFINITION(0x1, 0x712), ZYDIS_DEFINITION(0x1, 0x713) },
    { ZYDIS_DEFINITION(0x1, 0x665), ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0x1, 0x664), ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0x1, 0x663), ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0x1, 0x759), ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0x1, 0x731), ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0x1, 0x722), ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0x1, 0xC3), ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0x1, 0x6ED), ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0x1, 0x60E), ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0x1, 0x56A), ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0x1, 0x5FE), ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0x1, 0x60F), ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0x1, 0x68A), ZYDIS_DEFINITION(0x1, 0x68B) },
    { ZYDIS_DEFINITION(0x1, 0x6CA), ZYDIS_DEFINITION(0x1, 0x6CB) },
    { ZYDIS_DEFINITION(0x1, 0x2D0), ZYDIS_DEFINITION(0x1, 0x2D1) },
    { ZYDIS_DEFINITION(0x1, 0x2D3), ZYDIS_DEFINITION(0x1, 0x2D4) },
    { ZYDIS_DEFINITION(0x0, 0x709), ZYDIS_DEFINITION(0x0, 0x70A) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_OPERAND_SIZE, 0x0), ZYDIS_DEFINITION(0x0, 0x711) },
    { ZYDIS_DEFINITION(0x1, 0x7C), ZYDIS_DEFINITION(0x1, 0x7E) },
    { ZYDIS_DEFINITION(0x1, 0x84), ZYDIS_DEFINITION(0x1, 0x86) },
    { ZYDIS_DEFINITION(0x1, 0x88), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_ADDRESS_SIZE, 0x0) },
    { ZYDIS_DEFINITION(0x1, 0x8D), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_ADDRESS_SIZE, 0x1) },
    { ZYDIS_DEFINITION(0x1, 0x7D), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_ADDRESS_SIZE, 0x2) },
    { ZYDIS_DEFINITION(0x1, 0x85), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_ADDRESS_SIZE, 0x3) },
    { ZYDIS_DEFINITION(0x1, 0x80), ZYDIS_DEFINITION(0x1, 0x82) },
    { ZYDIS_DEFINITION(0x1, 0x92), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_ADDRESS_SIZE, 0x4) },
    { ZYDIS_DEFINITION(0x1, 0x90), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_ADDRESS_SIZE, 0x5) },
    { ZYDIS_DEFINITION(0x1, 0x8A), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_ADDRESS_SIZE, 0x6) },
    { ZYDIS_DEFINITION(0x1, 0x81), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_ADDRESS_SIZE, 0x7) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x0), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x1) },
    { ZYDIS_DEFINITION(0x10, 0x31F), ZYDIS_DEFINITION(0x10, 0x320) },
    { ZYDIS_DEFINITION(0x10, 0x321), ZYDIS_DEFINITION(0x10, 0x322) },
    { ZYDIS_DEFINITION(0x10, 0x323), ZYDIS_DEFINITION(0x10, 0x324) },
    { ZYDIS_DEFINITION(0x10, 0x325), ZYDIS_DEFINITION(0x10, 0x326) },
    { ZYDIS_DEFINITION(0x0, 0x70B), ZYDIS_DEFINITION(0x0, 0x70C) },
    { ZYDIS_DEFINITION(0x0, 0x70D), ZYDIS_DEFINITION(0x0, 0x70E) },
    { ZYDIS_DEFINITION(0x1, 0x25C), ZYDIS_DEFINITION(0x1, 0x25D) },
    { ZYDIS_DEFINITION(0x1, 0x263), ZYDIS_DEFINITION(0x1, 0x264) },
    { ZYDIS_DEFINITION(0x1, 0x261), ZYDIS_DEFINITION(0x1, 0x262) },
    { ZYDIS_DEFINITION(0x1, 0x343), ZYDIS_DEFINITION(0x1, 0x344) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x21), ZYDIS_DEFINITION(0x1, 0x333) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x22), ZYDIS_DEFINITION(0x1, 0x337) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x23), ZYDIS_DEFINITION(0x1, 0x334) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x24), ZYDIS_DEFINITION(0x1, 0x338) },
    { ZYDIS_DEFINITION(0x1, 0x748), ZYDIS_DEFINITION(0x1, 0x74A) },
    { ZYDIS_DEFINITION(0x1, 0x749), ZYDIS_DEFINITION(0x1, 0x74B) },
    { ZYDIS_DEFINITION(0x1, 0x74F), ZYDIS_DEFINITION(0x1, 0x751) },
    { ZYDIS_DEFINITION(0x1, 0x750), ZYDIS_DEFINITION(0x1, 0x752) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x25), ZYDIS_DEFINITION(0x1, 0x33B) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x26), ZYDIS_DEFINITION(0x1, 0x33F) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x27), ZYDIS_DEFINITION(0x1, 0x33C) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x28), ZYDIS_DEFINITION(0x1, 0x340) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODE_AMD, 0x0), ZYDIS_DEFINITION(0x9, 0x2B4) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODE_AMD, 0x1), ZYDIS_DEFINITION(0x9, 0x2A0) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODE_AMD, 0x2), ZYDIS_DEFINITION(0x9, 0x26C) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODE_AMD, 0x3), ZYDIS_DEFINITION(0x9, 0x28C) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODE_AMD, 0x4), ZYDIS_DEFINITION(0x9, 0x2C4) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODE_AMD, 0x5), ZYDIS_DEFINITION(0x9, 0x2AF) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODE_AMD, 0x6), ZYDIS_DEFINITION(0x9, 0x271) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODE_AMD, 0x7), ZYDIS_DEFINITION(0x9, 0x291) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODE_AMD, 0x8), ZYDIS_DEFINITION(0x9, 0x2BF) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODE_AMD, 0x9), ZYDIS_DEFINITION(0x9, 0x2AA) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODE_AMD, 0xA), ZYDIS_DEFINITION(0x9, 0x2B9) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODE_AMD, 0xB), ZYDIS_DEFINITION(0x9, 0x2A5) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODE_AMD, 0xC), ZYDIS_DEFINITION(0x9, 0x279) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODE_AMD, 0xD), ZYDIS_DEFINITION(0x9, 0x296) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODE_AMD, 0xE), ZYDIS_DEFINITION(0x9, 0x27E) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODE_AMD, 0xF), ZYDIS_DEFINITION(0x9, 0x29B) },
    { ZYDIS_DEFINITION(0x1, 0x5FB), ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0x1, 0x5FC), ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0x1, 0x756), ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0x1, 0x757), ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0x1, 0x666), ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0x1, 0x5FF), ZYDIS_DEFINITION(0x1, 0x600) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x2F), ZYDIS_DEFINITION(0x1, 0x113) },
    { ZYDIS_INVALID, ZYDIS_DEFINITION(0x0, 0x5CC) },
    { ZYDIS_INVALID, ZYDIS_DEFINITION(0x0, 0x520) },
    { ZYDIS_INVALID, ZYDIS_DEFINITION(0x0, 0x5CD) },
    { ZYDIS_INVALID, ZYDIS_DEFINITION(0x0, 0x521) },
    { ZYDIS_INVALID, ZYDIS_DEFINITION(0x0, 0x158) },
    { ZYDIS_INVALID, ZYDIS_DEFINITION(0x0, 0x159) },
    { ZYDIS_INVALID, ZYDIS_DEFINITION(0x0, 0x0) },
    { ZYDIS_INVALID, ZYDIS_DEFINITION(0x0, 0x7) },
    { ZYDIS_INVALID, ZYDIS_DEFINITION(0x0, 0x240) },
    { ZYDIS_INVALID, ZYDIS_DEFINITION(0x0, 0x240) },
    { ZYDIS_INVALID, ZYDIS_DEFINITION(0x0, 0x240) },
    { ZYDIS_INVALID, ZYDIS_DEFINITION(0x0, 0x240) },
    { ZYDIS_INVALID, ZYDIS_DEFINITION(0x0, 0x240) },
    { ZYDIS_INVALID, ZYDIS_DEFINITION(0x0, 0x240) },
    { ZYDIS_INVALID, ZYDIS_DEFINITION(0x0, 0x240) },
    { ZYDIS_INVALID, ZYDIS_DEFINITION(0x0, 0x240) },
    { ZYDIS_INVALID, ZYDIS_DEFINITION(0x0, 0x15A) },
    { ZYDIS_INVALID, ZYDIS_DEFINITION(0x0, 0x15A) },
    { ZYDIS_INVALID, ZYDIS_DEFINITION(0x0, 0x15A) },
    { ZYDIS_INVALID, ZYDIS_DEFINITION(0x0, 0x15A) },
    { ZYDIS_INVALID, ZYDIS_DEFINITION(0x0, 0x15A) },
    { ZYDIS_INVALID, ZYDIS_DEFINITION(0x0, 0x15A) },
    { ZYDIS_INVALID, ZYDIS_DEFINITION(0x0, 0x15A) },
    { ZYDIS_INVALID, ZYDIS_DEFINITION(0x0, 0x15A) },
    { ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_OPERAND_SIZE, 0x2) },
    { ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_OPERAND_SIZE, 0x3) },
    { ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_OPERAND_SIZE, 0x4) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x83), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x84) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x86), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x87) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0xAF), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0xB0) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0xB2), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0xB3) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x1C6), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x1C7) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x28A), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x28B) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x28D), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x28E) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x2AC), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x2AD) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x2AF), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x2B0) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x348), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x349) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x34B), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x34C) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x34E), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x34F) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x351), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x352) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x354), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x355) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x357), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x358) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x371), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x372) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x374), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x375) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x377), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x378) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x37A), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x37B) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x37F), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x380) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x382), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x383) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x3CA), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x3CB) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x3CC), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x3CD), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x3CE) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x3CF), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x3D0), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x3D1) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x3D2), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x3D3), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x3D4) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x3D5), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x3D6), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x3D7) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x3D8), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x3D9), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x3DA) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x3DB), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x3ED), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x3EE) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x3EF), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x3F0), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x3F1) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x3F2), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x3F3), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x3F4) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x3F5), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x3F6), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x3F7) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x3F8), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x3F9), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x3FA) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x3FB), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x3FC), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x3FD) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x3FE), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x40C), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x40D) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x40F), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x410) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x412), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x413) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x415), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x416) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x418), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x419) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x41B), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x41C) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x434), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x435) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x437), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x438) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x43A), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x43B) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x43D), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x43E) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x441), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x442) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x444), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x445) },
    { ZYDIS_DEFINITION(0x1, 0x392), ZYDIS_DEFINITION(0x1, 0x70) },
    { ZYDIS_DEFINITION(0x1, 0x393), ZYDIS_DEFINITION(0x1, 0x71) },
    { ZYDIS_DEFINITION(0x8, 0x2B0), ZYDIS_DEFINITION(0x8, 0x2B1) },
    { ZYDIS_DEFINITION(0x8, 0x29C), ZYDIS_DEFINITION(0x8, 0x29D) },
    { ZYDIS_DEFINITION(0x8, 0x268), ZYDIS_DEFINITION(0x8, 0x269) },
    { ZYDIS_DEFINITION(0x8, 0x288), ZYDIS_DEFINITION(0x8, 0x289) },
    { ZYDIS_DEFINITION(0x8, 0x2C0), ZYDIS_DEFINITION(0x8, 0x2C1) },
    { ZYDIS_DEFINITION(0x8, 0x2AB), ZYDIS_DEFINITION(0x8, 0x2AC) },
    { ZYDIS_DEFINITION(0x8, 0x26D), ZYDIS_DEFINITION(0x8, 0x26E) },
    { ZYDIS_DEFINITION(0x8, 0x28D), ZYDIS_DEFINITION(0x8, 0x28E) },
    { ZYDIS_DEFINITION(0x8, 0x2BB), ZYDIS_DEFINITION(0x8, 0x2BC) },
    { ZYDIS_DEFINITION(0x8, 0x2A6), ZYDIS_DEFINITION(0x8, 0x2A7) },
    { ZYDIS_DEFINITION(0x8, 0x2B5), ZYDIS_DEFINITION(0x8, 0x2B6) },
    { ZYDIS_DEFINITION(0x8, 0x2A1), ZYDIS_DEFINITION(0x8, 0x2A2) },
    { ZYDIS_DEFINITION(0x8, 0x275), ZYDIS_DEFINITION(0x8, 0x276) },
    { ZYDIS_DEFINITION(0x8, 0x292), ZYDIS_DEFINITION(0x8, 0x293) },
    { ZYDIS_DEFINITION(0x8, 0x27A), ZYDIS_DEFINITION(0x8, 0x27B) },
    { ZYDIS_DEFINITION(0x8, 0x297), ZYDIS_DEFINITION(0x8, 0x298) },
    { ZYDIS_INVALID, ZYDIS_DEFINITION(0xD, 0x2C) },
    { ZYDIS_INVALID, ZYDIS_DEFINITION(0xD, 0x3FC) },
    { ZYDIS_INVALID, ZYDIS_DEFINITION(0xD, 0x16) },
    { ZYDIS_INVALID, ZYDIS_DEFINITION(0xD, 0x653) },
    { ZYDIS_INVALID, ZYDIS_DEFINITION(0xD, 0x62) },
    { ZYDIS_INVALID, ZYDIS_DEFINITION(0xD, 0x6FC) },
    { ZYDIS_INVALID, ZYDIS_DEFINITION(0xD, 0x782) },
    { ZYDIS_INVALID, ZYDIS_DEFINITION(0xD, 0xF5) },
    { ZYDIS_INVALID, ZYDIS_DEFINITION(0xD, 0x2D) },
    { ZYDIS_INVALID, ZYDIS_DEFINITION(0xD, 0x3FD) },
    { ZYDIS_INVALID, ZYDIS_DEFINITION(0xD, 0x17) },
    { ZYDIS_INVALID, ZYDIS_DEFINITION(0xD, 0x654) },
    { ZYDIS_INVALID, ZYDIS_DEFINITION(0xD, 0x63) },
    { ZYDIS_INVALID, ZYDIS_DEFINITION(0xD, 0x6FD) },
    { ZYDIS_INVALID, ZYDIS_DEFINITION(0xD, 0x783) },
    { ZYDIS_INVALID, ZYDIS_DEFINITION(0xD, 0xF6) },
    { ZYDIS_INVALID, ZYDIS_DEFINITION(0x12, 0xAF) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_OPERAND_SIZE, 0xD), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_OPERAND_SIZE, 0xE) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_OPERAND_SIZE, 0xF), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_OPERAND_SIZE, 0x10) },
    { ZYDIS_INVALID, ZYDIS_DEFINITION(0x1, 0x2CD) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x4F3), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x4F4), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x448), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x449), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x44A), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x44B), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x44C), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x44D), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x44E), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x44F), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x458), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x45A), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x45C), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x45D), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x45E) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x45F), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x461), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x463), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x465), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x466), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x506), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x507), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x489), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x48A) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x48C), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x48D) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x48E), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x48F) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x490), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x491), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x492), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x493) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x49B), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x49C), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x49D), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x49E), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x49F), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x4A0), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x4A1), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x4A2), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x4A7), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x4AF), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x4B0) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x4B4), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x4B5) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x50B), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x50C) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x52F), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x530) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x60C), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x60D), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x61B), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x674), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x675) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x68F), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x690) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x698), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x699) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x6A0), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x6BB), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x6BC) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x6E4), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x6E5) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x6E6), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x6E7) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x6E8), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x6E9) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x6FD), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x6FE), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x6FF), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x700), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x701), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x705), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x70A), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x70B), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x718), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x719) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x71A), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x71B) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x720), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x721) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x722), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x723) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x724), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x725) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x734), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x735) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x736), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x737) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x738), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x739), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x73A), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x742), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x743), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x748), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x749), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x751), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x752) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x753), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x754) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x755), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x756) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x757), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x758) },
    { ZYDIS_INVALID, ZYDIS_DEFINITION(0x1, 0x2CA) },
    { ZYDIS_INVALID, ZYDIS_DEFINITION(0x0, 0x25A) },
    { ZYDIS_INVALID, ZYDIS_DEFINITION(0x3, 0x4) },
    { ZYDIS_INVALID, ZYDIS_DEFINITION(0x3, 0x1) },
    { ZYDIS_INVALID, ZYDIS_DEFINITION(0x0, 0x637) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_ADDRESS_SIZE, 0x38), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_ADDRESS_SIZE, 0x39) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODE_AMD, 0x10), ZYDIS_DEFINITION(0x9, 0xB2) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODE_AMD, 0x11), ZYDIS_DEFINITION(0x9, 0x281) },
    { ZYDIS_INVALID, ZYDIS_DEFINITION(0x12, 0x282) },
    { ZYDIS_DEFINITION(0x8, 0x283), ZYDIS_DEFINITION(0x8, 0x284) }
};

const ZydisDecoderTreeNode FILTERS_PREFIX_GROUP1[][2] =
{
    { ZYDIS_DEFINITION(0x1, 0x32F), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MANDATORY_PREFIX, 0x9E) },
    { ZYDIS_DEFINITION(0x1, 0x330), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MANDATORY_PREFIX, 0xA0) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_REG, 0x1A), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MANDATORY_PREFIX, 0x138) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_REG, 0x25), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MANDATORY_PREFIX, 0x149) }
};

const ZydisDecoderTreeNode FILTERS_MODRM_MOD[][4] =
{
    { ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID }
};

const ZydisDecoderTreeNode FILTERS_MODRM_MOD_COMPACT[][2] =
{
    { ZYDIS_DEFINITION(0x1, 0x1E), ZYDIS_DEFINITION(0x1, 0x1F) },
    { ZYDIS_DEFINITION(0x1, 0x20), ZYDIS_DEFINITION(0x1, 0x21) },
    { ZYDIS_DEFINITION(0x1, 0x22), ZYDIS_DEFINITION(0x1, 0x23) },
    { ZYDIS_DEFINITION(0x1, 0x24), ZYDIS_DEFINITION(0x1, 0x25) },
    { ZYDIS_DEFINITION(0x1, 0x3EE), ZYDIS_DEFINITION(0x1, 0x3EF) },
    { ZYDIS_DEFINITION(0x1, 0x3F0), ZYDIS_DEFINITION(0x1, 0x3F1) },
    { ZYDIS_DEFINITION(0x1, 0x3F2), ZYDIS_DEFINITION(0x1, 0x3F3) },
    { ZYDIS_DEFINITION(0x1, 0x3F4), ZYDIS_DEFINITION(0x1, 0x3F5) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_REG, 0x0), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_REG, 0x1) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MANDATORY_PREFIX, 0x0), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MANDATORY_PREFIX, 0x1) },
    { ZYDIS_DEFINITION(0x1, 0x2C6), ZYDIS_DEFINITION(0x1, 0x2C7) },
    { ZYDIS_DEFINITION(0x1, 0x2E9), ZYDIS_DEFINITION(0x1, 0x2EA) },
    { ZYDIS_DEFINITION(0x1, 0x3B7), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_REG, 0x9) },
    { ZYDIS_DEFINITION(0x1, 0x2A), ZYDIS_DEFINITION(0x1, 0x2B) },
    { ZYDIS_DEFINITION(0x1, 0x28), ZYDIS_DEFINITION(0x1, 0x29) },
    { ZYDIS_DEFINITION(0x1, 0x4), ZYDIS_DEFINITION(0x1, 0x5) },
    { ZYDIS_DEFINITION(0x1, 0x2), ZYDIS_DEFINITION(0x1, 0x3) },
    { ZYDIS_DEFINITION(0x1, 0x18), ZYDIS_DEFINITION(0x1, 0x19) },
    { ZYDIS_DEFINITION(0x1, 0x1A), ZYDIS_DEFINITION(0x1, 0x1B) },
    { ZYDIS_DEFINITION(0x1, 0xC), ZYDIS_DEFINITION(0x1, 0xD) },
    { ZYDIS_DEFINITION(0x1, 0x14), ZYDIS_DEFINITION(0x1, 0x15) },
    { ZYDIS_DEFINITION(0x1, 0x1C), ZYDIS_DEFINITION(0x1, 0x1D) },
    { ZYDIS_DEFINITION(0x1, 0x22), ZYDIS_DEFINITION(0x1, 0x23) },
    { ZYDIS_DEFINITION(0x1, 0x24), ZYDIS_DEFINITION(0x1, 0x25) },
    { ZYDIS_DEFINITION(0x1, 0x8), ZYDIS_DEFINITION(0x1, 0x9) },
    { ZYDIS_DEFINITION(0x1, 0xE), ZYDIS_DEFINITION(0x1, 0xF) },
    { ZYDIS_DEFINITION(0x1, 0x12), ZYDIS_DEFINITION(0x1, 0x13) },
    { ZYDIS_DEFINITION(0x1, 0x10), ZYDIS_DEFINITION(0x1, 0x11) },
    { ZYDIS_DEFINITION(0x1, 0x20), ZYDIS_DEFINITION(0x1, 0x21) },
    { ZYDIS_DEFINITION(0x1, 0x26), ZYDIS_DEFINITION(0x1, 0x27) },
    { ZYDIS_DEFINITION(0x1, 0x6), ZYDIS_DEFINITION(0x1, 0x7) },
    { ZYDIS_DEFINITION(0x1, 0xA), ZYDIS_DEFINITION(0x1, 0xB) },
    { ZYDIS_DEFINITION(0x1, 0x16), ZYDIS_DEFINITION(0x1, 0x17) },
    { ZYDIS_DEFINITION(0x1, 0x1E), ZYDIS_DEFINITION(0x1, 0x1F) },
    { ZYDIS_DEFINITION(0x1, 0x2C), ZYDIS_DEFINITION(0x1, 0x2D) },
    { ZYDIS_DEFINITION(0x1, 0x2E), ZYDIS_DEFINITION(0x1, 0x2F) },
    { ZYDIS_DEFINITION(0x1, 0x0), ZYDIS_DEFINITION(0x1, 0x1) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MANDATORY_PREFIX, 0x2), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MANDATORY_PREFIX, 0x3) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MANDATORY_PREFIX, 0x4), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MANDATORY_PREFIX, 0x5) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MANDATORY_PREFIX, 0x6), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MANDATORY_PREFIX, 0x7) },
    { ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MANDATORY_PREFIX, 0x8) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MANDATORY_PREFIX, 0x9), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MANDATORY_PREFIX, 0xA) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MANDATORY_PREFIX, 0xB), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MANDATORY_PREFIX, 0xC) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MANDATORY_PREFIX, 0xD), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MANDATORY_PREFIX, 0xE) },
    { ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MANDATORY_PREFIX, 0xF) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_REG, 0xA), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_REG, 0xB) },
    { ZYDIS_DEFINITION(0x1, 0x3C4), ZYDIS_DEFINITION(0x1, 0x3C5) },
    { ZYDIS_DEFINITION(0x1, 0x3C6), ZYDIS_DEFINITION(0x1, 0x3C7) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MANDATORY_PREFIX, 0x10), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MANDATORY_PREFIX, 0x11) },
    { ZYDIS_DEFINITION(0x1, 0x3C9), ZYDIS_DEFINITION(0x1, 0x3CA) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MANDATORY_PREFIX, 0x12), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MANDATORY_PREFIX, 0x13) },
    { ZYDIS_DEFINITION(0x1, 0x3CD), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODE_CLDEMOTE, 0x0) },
    { ZYDIS_DEFINITION(0x1, 0x3CF), ZYDIS_DEFINITION(0x1, 0x3D0) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MANDATORY_PREFIX, 0x15), ZYDIS_DEFINITION(0x1, 0x3D1) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_REG, 0xE), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_REG, 0xF) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MANDATORY_PREFIX, 0x16), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MANDATORY_PREFIX, 0x17) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MANDATORY_PREFIX, 0x18), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MANDATORY_PREFIX, 0x19) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MANDATORY_PREFIX, 0x1A), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MANDATORY_PREFIX, 0x1B) },
    { ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MANDATORY_PREFIX, 0x1C) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MANDATORY_PREFIX, 0x1D), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MANDATORY_PREFIX, 0x1E) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MANDATORY_PREFIX, 0x1F), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MANDATORY_PREFIX, 0x20) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MANDATORY_PREFIX, 0x21), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MANDATORY_PREFIX, 0x22) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MANDATORY_PREFIX, 0x23), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MANDATORY_PREFIX, 0x24) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MANDATORY_PREFIX, 0x26), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MANDATORY_PREFIX, 0x27) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MANDATORY_PREFIX, 0x28), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MANDATORY_PREFIX, 0x29) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MANDATORY_PREFIX, 0x2A), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MANDATORY_PREFIX, 0x2B) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MANDATORY_PREFIX, 0x2C), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MANDATORY_PREFIX, 0x2D) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MANDATORY_PREFIX, 0x2E), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MANDATORY_PREFIX, 0x2F) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MANDATORY_PREFIX, 0x30), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MANDATORY_PREFIX, 0x31) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MANDATORY_PREFIX, 0x32), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MANDATORY_PREFIX, 0x33) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MANDATORY_PREFIX, 0x34), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MANDATORY_PREFIX, 0x35) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MANDATORY_PREFIX, 0x36), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MANDATORY_PREFIX, 0x37) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MANDATORY_PREFIX, 0x38), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MANDATORY_PREFIX, 0x39) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MANDATORY_PREFIX, 0x3A), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MANDATORY_PREFIX, 0x3B) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MANDATORY_PREFIX, 0x3C), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MANDATORY_PREFIX, 0x3D) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MANDATORY_PREFIX, 0x3E), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MANDATORY_PREFIX, 0x3F) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MANDATORY_PREFIX, 0x40), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MANDATORY_PREFIX, 0x41) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MANDATORY_PREFIX, 0x42), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MANDATORY_PREFIX, 0x43) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MANDATORY_PREFIX, 0x44), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MANDATORY_PREFIX, 0x45) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MANDATORY_PREFIX, 0x46), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MANDATORY_PREFIX, 0x47) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MANDATORY_PREFIX, 0x48), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MANDATORY_PREFIX, 0x49) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MANDATORY_PREFIX, 0x4A), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MANDATORY_PREFIX, 0x4B) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MANDATORY_PREFIX, 0x4C), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MANDATORY_PREFIX, 0x4D) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MANDATORY_PREFIX, 0x4E), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MANDATORY_PREFIX, 0x4F) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MANDATORY_PREFIX, 0x50), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MANDATORY_PREFIX, 0x51) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MANDATORY_PREFIX, 0x52), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MANDATORY_PREFIX, 0x53) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MANDATORY_PREFIX, 0x54), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MANDATORY_PREFIX, 0x55) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MANDATORY_PREFIX, 0x56), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MANDATORY_PREFIX, 0x57) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MANDATORY_PREFIX, 0x58), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MANDATORY_PREFIX, 0x59) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MANDATORY_PREFIX, 0x5A), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MANDATORY_PREFIX, 0x5B) },
    { ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MANDATORY_PREFIX, 0x5C) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MANDATORY_PREFIX, 0x5D), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MANDATORY_PREFIX, 0x5E) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MANDATORY_PREFIX, 0x5F), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MANDATORY_PREFIX, 0x60) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MANDATORY_PREFIX, 0x61), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MANDATORY_PREFIX, 0x62) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MANDATORY_PREFIX, 0x63), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MANDATORY_PREFIX, 0x64) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MANDATORY_PREFIX, 0x65), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MANDATORY_PREFIX, 0x66) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MANDATORY_PREFIX, 0x67), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MANDATORY_PREFIX, 0x68) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MANDATORY_PREFIX, 0x69), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MANDATORY_PREFIX, 0x6A) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MANDATORY_PREFIX, 0x6B), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MANDATORY_PREFIX, 0x6C) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MANDATORY_PREFIX, 0x6D), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MANDATORY_PREFIX, 0x6E) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MANDATORY_PREFIX, 0x6F), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MANDATORY_PREFIX, 0x70) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MANDATORY_PREFIX, 0x71), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MANDATORY_PREFIX, 0x72) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MANDATORY_PREFIX, 0x73), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MANDATORY_PREFIX, 0x74) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MANDATORY_PREFIX, 0x75), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MANDATORY_PREFIX, 0x76) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MANDATORY_PREFIX, 0x77), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MANDATORY_PREFIX, 0x78) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MANDATORY_PREFIX, 0x79), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MANDATORY_PREFIX, 0x7A) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MANDATORY_PREFIX, 0x7B), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MANDATORY_PREFIX, 0x7C) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MANDATORY_PREFIX, 0x7D), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MANDATORY_PREFIX, 0x7E) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MANDATORY_PREFIX, 0x7F), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MANDATORY_PREFIX, 0x80) },
    { ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MANDATORY_PREFIX, 0x81) },
    { ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MANDATORY_PREFIX, 0x82) },
    { ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MANDATORY_PREFIX, 0x83) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MANDATORY_PREFIX, 0x84), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MANDATORY_PREFIX, 0x85) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MANDATORY_PREFIX, 0x86), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MANDATORY_PREFIX, 0x87) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MANDATORY_PREFIX, 0x88), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MANDATORY_PREFIX, 0x89) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MANDATORY_PREFIX, 0x8A), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MANDATORY_PREFIX, 0x8B) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MANDATORY_PREFIX, 0x8C), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MANDATORY_PREFIX, 0x8D) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MANDATORY_PREFIX, 0x8E), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MANDATORY_PREFIX, 0x8F) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MANDATORY_PREFIX, 0x90), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MANDATORY_PREFIX, 0x91) },
    { ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MANDATORY_PREFIX, 0x92) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MANDATORY_PREFIX, 0x93), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MANDATORY_PREFIX, 0x94) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MANDATORY_PREFIX, 0x95), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MANDATORY_PREFIX, 0x96) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MANDATORY_PREFIX, 0x97), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MANDATORY_PREFIX, 0x98) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MANDATORY_PREFIX, 0x99), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MANDATORY_PREFIX, 0x9A) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MANDATORY_PREFIX, 0x9B), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MANDATORY_PREFIX, 0x9C) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MANDATORY_PREFIX, 0x9D), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_PREFIX_GROUP1, 0x0) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MANDATORY_PREFIX, 0x9F), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_PREFIX_GROUP1, 0x1) },
    { ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MANDATORY_PREFIX, 0xA1) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MANDATORY_PREFIX, 0xA2), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MANDATORY_PREFIX, 0xA3) },
    { ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MANDATORY_PREFIX, 0xA4) },
    { ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MANDATORY_PREFIX, 0xA5) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MANDATORY_PREFIX, 0xA6), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MANDATORY_PREFIX, 0xA7), ZYDIS_INVALID },
    { ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MANDATORY_PREFIX, 0xA8) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MANDATORY_PREFIX, 0xA9), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MANDATORY_PREFIX, 0xAA) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MANDATORY_PREFIX, 0xAB), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MANDATORY_PREFIX, 0xAC) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MANDATORY_PREFIX, 0xAD), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MANDATORY_PREFIX, 0xAE) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MANDATORY_PREFIX, 0xAF), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MANDATORY_PREFIX, 0xB0) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MANDATORY_PREFIX, 0xB1), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MANDATORY_PREFIX, 0xB2) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MANDATORY_PREFIX, 0xB3), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MANDATORY_PREFIX, 0xB4) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MANDATORY_PREFIX, 0xB5), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MANDATORY_PREFIX, 0xB6) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MANDATORY_PREFIX, 0xB7), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MANDATORY_PREFIX, 0xB8) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MANDATORY_PREFIX, 0xB9), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MANDATORY_PREFIX, 0xBA) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MANDATORY_PREFIX, 0xBB), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MANDATORY_PREFIX, 0xBC) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MANDATORY_PREFIX, 0xBD), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MANDATORY_PREFIX, 0xBE) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MANDATORY_PREFIX, 0xBF), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MANDATORY_PREFIX, 0xC0) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MANDATORY_PREFIX, 0xC1), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MANDATORY_PREFIX, 0xC2) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MANDATORY_PREFIX, 0xC3), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MANDATORY_PREFIX, 0xC4) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MANDATORY_PREFIX, 0xC5), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MANDATORY_PREFIX, 0xC6) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MANDATORY_PREFIX, 0xC7), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MANDATORY_PREFIX, 0xC8) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MANDATORY_PREFIX, 0xC9), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MANDATORY_PREFIX, 0xCA) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MANDATORY_PREFIX, 0xCB), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MANDATORY_PREFIX, 0xCC) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MANDATORY_PREFIX, 0xCD), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MANDATORY_PREFIX, 0xCE) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MANDATORY_PREFIX, 0xCF), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MANDATORY_PREFIX, 0xD0) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MANDATORY_PREFIX, 0xD1), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MANDATORY_PREFIX, 0xD2) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MANDATORY_PREFIX, 0xD3), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MANDATORY_PREFIX, 0xD4) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MANDATORY_PREFIX, 0xD5), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MANDATORY_PREFIX, 0xD6) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MANDATORY_PREFIX, 0xD7), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MANDATORY_PREFIX, 0xD8) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MANDATORY_PREFIX, 0xD9), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MANDATORY_PREFIX, 0xDA) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MANDATORY_PREFIX, 0xDB), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MANDATORY_PREFIX, 0xDC) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MANDATORY_PREFIX, 0xDD), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MANDATORY_PREFIX, 0xDE) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MANDATORY_PREFIX, 0xDF), ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0x1, 0xDF), ZYDIS_DEFINITION(0x1, 0xE0) },
    { ZYDIS_DEFINITION(0x1, 0xD7), ZYDIS_DEFINITION(0x1, 0xD8) },
    { ZYDIS_DEFINITION(0x1, 0xC7), ZYDIS_DEFINITION(0x1, 0xC8) },
    { ZYDIS_DEFINITION(0x1, 0xCF), ZYDIS_DEFINITION(0x1, 0xD0) },
    { ZYDIS_DEFINITION(0x1, 0xE5), ZYDIS_DEFINITION(0x1, 0xE6) },
    { ZYDIS_DEFINITION(0x1, 0xDD), ZYDIS_DEFINITION(0x1, 0xDE) },
    { ZYDIS_DEFINITION(0x1, 0xC9), ZYDIS_DEFINITION(0x1, 0xCA) },
    { ZYDIS_DEFINITION(0x1, 0xD1), ZYDIS_DEFINITION(0x1, 0xD2) },
    { ZYDIS_DEFINITION(0x1, 0xE3), ZYDIS_DEFINITION(0x1, 0xE4) },
    { ZYDIS_DEFINITION(0x1, 0xDB), ZYDIS_DEFINITION(0x1, 0xDC) },
    { ZYDIS_DEFINITION(0x1, 0xE1), ZYDIS_DEFINITION(0x1, 0xE2) },
    { ZYDIS_DEFINITION(0x1, 0xD9), ZYDIS_DEFINITION(0x1, 0xDA) },
    { ZYDIS_DEFINITION(0x1, 0xCB), ZYDIS_DEFINITION(0x1, 0xCC) },
    { ZYDIS_DEFINITION(0x1, 0xD3), ZYDIS_DEFINITION(0x1, 0xD4) },
    { ZYDIS_DEFINITION(0x1, 0xCD), ZYDIS_DEFINITION(0x1, 0xCE) },
    { ZYDIS_DEFINITION(0x1, 0xD5), ZYDIS_DEFINITION(0x1, 0xD6) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MANDATORY_PREFIX, 0xE0), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MANDATORY_PREFIX, 0xE1), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MANDATORY_PREFIX, 0xE2) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MANDATORY_PREFIX, 0xE3), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MANDATORY_PREFIX, 0xE4) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MANDATORY_PREFIX, 0xE5), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MANDATORY_PREFIX, 0xE6) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MANDATORY_PREFIX, 0xE7), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MANDATORY_PREFIX, 0xE8) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MANDATORY_PREFIX, 0xE9), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MANDATORY_PREFIX, 0xEA) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MANDATORY_PREFIX, 0xEB), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MANDATORY_PREFIX, 0xEC) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MANDATORY_PREFIX, 0xED), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MANDATORY_PREFIX, 0xEE) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MANDATORY_PREFIX, 0xEF), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MANDATORY_PREFIX, 0xF0) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MANDATORY_PREFIX, 0xF1), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MANDATORY_PREFIX, 0xF2) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MANDATORY_PREFIX, 0xF3), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MANDATORY_PREFIX, 0xF4) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MANDATORY_PREFIX, 0xF5), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MANDATORY_PREFIX, 0xF6) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MANDATORY_PREFIX, 0xF7), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MANDATORY_PREFIX, 0xF8) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MANDATORY_PREFIX, 0xF9), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MANDATORY_PREFIX, 0xFA) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MANDATORY_PREFIX, 0xFB), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MANDATORY_PREFIX, 0xFC) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MANDATORY_PREFIX, 0xFD), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MANDATORY_PREFIX, 0xFE) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MANDATORY_PREFIX, 0xFF), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MANDATORY_PREFIX, 0x100) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MANDATORY_PREFIX, 0x101), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MANDATORY_PREFIX, 0x102) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MANDATORY_PREFIX, 0x103), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MANDATORY_PREFIX, 0x104) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MANDATORY_PREFIX, 0x105), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MANDATORY_PREFIX, 0x106) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MANDATORY_PREFIX, 0x107), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MANDATORY_PREFIX, 0x108) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MANDATORY_PREFIX, 0x109), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MANDATORY_PREFIX, 0x10A) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MANDATORY_PREFIX, 0x10B), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MANDATORY_PREFIX, 0x10C) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MANDATORY_PREFIX, 0x10D), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MANDATORY_PREFIX, 0x10E) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MANDATORY_PREFIX, 0x10F), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MANDATORY_PREFIX, 0x110) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MANDATORY_PREFIX, 0x111), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MANDATORY_PREFIX, 0x112) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MANDATORY_PREFIX, 0x113), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MANDATORY_PREFIX, 0x114) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MANDATORY_PREFIX, 0x115), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MANDATORY_PREFIX, 0x116) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MANDATORY_PREFIX, 0x117), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MANDATORY_PREFIX, 0x118) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MANDATORY_PREFIX, 0x119), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MANDATORY_PREFIX, 0x11A) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MANDATORY_PREFIX, 0x11B), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MANDATORY_PREFIX, 0x11C) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MANDATORY_PREFIX, 0x11D), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MANDATORY_PREFIX, 0x11E) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MANDATORY_PREFIX, 0x11F), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MANDATORY_PREFIX, 0x120) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MANDATORY_PREFIX, 0x121), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MANDATORY_PREFIX, 0x122), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MANDATORY_PREFIX, 0x123), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MANDATORY_PREFIX, 0x124), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MANDATORY_PREFIX, 0x125) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MANDATORY_PREFIX, 0x126), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MANDATORY_PREFIX, 0x127) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MANDATORY_PREFIX, 0x128), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MANDATORY_PREFIX, 0x129) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MANDATORY_PREFIX, 0x12B), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MANDATORY_PREFIX, 0x12C) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MANDATORY_PREFIX, 0x12D), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MANDATORY_PREFIX, 0x12E) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MANDATORY_PREFIX, 0x12F), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MANDATORY_PREFIX, 0x130) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MANDATORY_PREFIX, 0x131), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MANDATORY_PREFIX, 0x132) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MANDATORY_PREFIX, 0x133), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MANDATORY_PREFIX, 0x134) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MANDATORY_PREFIX, 0x135), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MANDATORY_PREFIX, 0x136) },
    { ZYDIS_DEFINITION(0x1, 0x680), ZYDIS_DEFINITION(0x1, 0x681) },
    { ZYDIS_DEFINITION(0x1, 0x678), ZYDIS_DEFINITION(0x1, 0x679) },
    { ZYDIS_DEFINITION(0x1, 0x668), ZYDIS_DEFINITION(0x1, 0x669) },
    { ZYDIS_DEFINITION(0x1, 0x670), ZYDIS_DEFINITION(0x1, 0x671) },
    { ZYDIS_DEFINITION(0x1, 0x687), ZYDIS_DEFINITION(0x1, 0x688) },
    { ZYDIS_DEFINITION(0x1, 0x67E), ZYDIS_DEFINITION(0x1, 0x67F) },
    { ZYDIS_DEFINITION(0x1, 0x66A), ZYDIS_DEFINITION(0x1, 0x66B) },
    { ZYDIS_DEFINITION(0x1, 0x672), ZYDIS_DEFINITION(0x1, 0x673) },
    { ZYDIS_DEFINITION(0x1, 0x684), ZYDIS_DEFINITION(0x1, 0x685) },
    { ZYDIS_DEFINITION(0x1, 0x67C), ZYDIS_DEFINITION(0x1, 0x67D) },
    { ZYDIS_DEFINITION(0x1, 0x682), ZYDIS_DEFINITION(0x1, 0x683) },
    { ZYDIS_DEFINITION(0x1, 0x67A), ZYDIS_DEFINITION(0x1, 0x67B) },
    { ZYDIS_DEFINITION(0x1, 0x66C), ZYDIS_DEFINITION(0x1, 0x66D) },
    { ZYDIS_DEFINITION(0x1, 0x674), ZYDIS_DEFINITION(0x1, 0x675) },
    { ZYDIS_DEFINITION(0x1, 0x66E), ZYDIS_DEFINITION(0x1, 0x66F) },
    { ZYDIS_DEFINITION(0x1, 0x676), ZYDIS_DEFINITION(0x1, 0x677) },
    { ZYDIS_DEFINITION(0x1, 0x9F), ZYDIS_DEFINITION(0x1, 0xA0) },
    { ZYDIS_DEFINITION(0xB, 0x6B2), ZYDIS_DEFINITION(0xB, 0x6B3) },
    { ZYDIS_DEFINITION(0x1, 0x6B4), ZYDIS_DEFINITION(0x1, 0x6B5) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MANDATORY_PREFIX, 0x137), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_PREFIX_GROUP1, 0x2), ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0x1, 0xAB), ZYDIS_DEFINITION(0x1, 0xAC) },
    { ZYDIS_DEFINITION(0xB, 0x6C2), ZYDIS_DEFINITION(0xB, 0x6C3) },
    { ZYDIS_DEFINITION(0x1, 0x6C4), ZYDIS_DEFINITION(0x1, 0x6C5) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MANDATORY_PREFIX, 0x139), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MANDATORY_PREFIX, 0x13A) },
    { ZYDIS_DEFINITION(0x1, 0x238), ZYDIS_DEFINITION(0x1, 0x239) },
    { ZYDIS_DEFINITION(0x1, 0x10D), ZYDIS_DEFINITION(0x1, 0x10E) },
    { ZYDIS_DEFINITION(0x1, 0x10F), ZYDIS_DEFINITION(0x1, 0x110) },
    { ZYDIS_INVALID, ZYDIS_DEFINITION(0x1, 0x2EB) },
    { ZYDIS_DEFINITION(0x1, 0xA7), ZYDIS_DEFINITION(0x1, 0xA8) },
    { ZYDIS_INVALID, ZYDIS_DEFINITION(0x1, 0x2CF) },
    { ZYDIS_INVALID, ZYDIS_DEFINITION(0x1, 0x2D2) },
    { ZYDIS_DEFINITION(0x1, 0x39C), ZYDIS_DEFINITION(0x1, 0x39D) },
    { ZYDIS_DEFINITION(0x1, 0x39E), ZYDIS_DEFINITION(0x1, 0x39F) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MANDATORY_PREFIX, 0x13B), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MANDATORY_PREFIX, 0x13C) },
    { ZYDIS_DEFINITION(0x1, 0x72E), ZYDIS_DEFINITION(0x1, 0x72F) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_REG, 0x23), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_REG, 0x24) },
    { ZYDIS_DEFINITION(0x1, 0xA5), ZYDIS_DEFINITION(0x1, 0xA6) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MANDATORY_PREFIX, 0x13D), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MANDATORY_PREFIX, 0x13E) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MANDATORY_PREFIX, 0x13F), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MANDATORY_PREFIX, 0x140) },
    { ZYDIS_DEFINITION(0x1, 0x38E), ZYDIS_DEFINITION(0x1, 0x38F) },
    { ZYDIS_DEFINITION(0x1, 0x390), ZYDIS_DEFINITION(0x1, 0x391) },
    { ZYDIS_DEFINITION(0x1, 0x761), ZYDIS_DEFINITION(0x1, 0x762) },
    { ZYDIS_DEFINITION(0x1, 0x763), ZYDIS_DEFINITION(0x1, 0x764) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MANDATORY_PREFIX, 0x141), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MANDATORY_PREFIX, 0x142) },
    { ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MANDATORY_PREFIX, 0x143) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MANDATORY_PREFIX, 0x144), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MANDATORY_PREFIX, 0x145) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MANDATORY_PREFIX, 0x146), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MANDATORY_PREFIX, 0x147), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MANDATORY_PREFIX, 0x148) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_PREFIX_GROUP1, 0x3), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MANDATORY_PREFIX, 0x14A) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MANDATORY_PREFIX, 0x14B), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MANDATORY_PREFIX, 0x14C) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MANDATORY_PREFIX, 0x14D), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MANDATORY_PREFIX, 0x14E) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MANDATORY_PREFIX, 0x14F), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MANDATORY_PREFIX, 0x150) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MANDATORY_PREFIX, 0x151), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MANDATORY_PREFIX, 0x152) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MANDATORY_PREFIX, 0x153), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MANDATORY_PREFIX, 0x154) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MANDATORY_PREFIX, 0x155), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MANDATORY_PREFIX, 0x156) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MANDATORY_PREFIX, 0x157), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MANDATORY_PREFIX, 0x158) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MANDATORY_PREFIX, 0x159), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MANDATORY_PREFIX, 0x15A), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MANDATORY_PREFIX, 0x15B) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MANDATORY_PREFIX, 0x15C), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MANDATORY_PREFIX, 0x15D) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MANDATORY_PREFIX, 0x15E), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MANDATORY_PREFIX, 0x15F) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MANDATORY_PREFIX, 0x160), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MANDATORY_PREFIX, 0x161) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MANDATORY_PREFIX, 0x162), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MANDATORY_PREFIX, 0x163) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MANDATORY_PREFIX, 0x164), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MANDATORY_PREFIX, 0x165) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MANDATORY_PREFIX, 0x166), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MANDATORY_PREFIX, 0x167) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MANDATORY_PREFIX, 0x168), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MANDATORY_PREFIX, 0x169) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MANDATORY_PREFIX, 0x16A), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MANDATORY_PREFIX, 0x16B) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MANDATORY_PREFIX, 0x16C), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MANDATORY_PREFIX, 0x16D) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MANDATORY_PREFIX, 0x16E), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MANDATORY_PREFIX, 0x16F) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MANDATORY_PREFIX, 0x170), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MANDATORY_PREFIX, 0x171) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MANDATORY_PREFIX, 0x172), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MANDATORY_PREFIX, 0x173) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MANDATORY_PREFIX, 0x174), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MANDATORY_PREFIX, 0x175) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MANDATORY_PREFIX, 0x176), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MANDATORY_PREFIX, 0x177) },
    { ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MANDATORY_PREFIX, 0x178) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MANDATORY_PREFIX, 0x179), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MANDATORY_PREFIX, 0x17A) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MANDATORY_PREFIX, 0x17B), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MANDATORY_PREFIX, 0x17C) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MANDATORY_PREFIX, 0x17D), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MANDATORY_PREFIX, 0x17E) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MANDATORY_PREFIX, 0x17F), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MANDATORY_PREFIX, 0x180) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MANDATORY_PREFIX, 0x181), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MANDATORY_PREFIX, 0x182) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MANDATORY_PREFIX, 0x183), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MANDATORY_PREFIX, 0x184) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MANDATORY_PREFIX, 0x185), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MANDATORY_PREFIX, 0x186) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MANDATORY_PREFIX, 0x187), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MANDATORY_PREFIX, 0x188) },
    { ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MANDATORY_PREFIX, 0x189) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MANDATORY_PREFIX, 0x18A), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MANDATORY_PREFIX, 0x18B) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MANDATORY_PREFIX, 0x18C), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MANDATORY_PREFIX, 0x18D) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MANDATORY_PREFIX, 0x18E), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MANDATORY_PREFIX, 0x18F) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MANDATORY_PREFIX, 0x190), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MANDATORY_PREFIX, 0x191) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MANDATORY_PREFIX, 0x192), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MANDATORY_PREFIX, 0x193) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MANDATORY_PREFIX, 0x194), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MANDATORY_PREFIX, 0x195) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MANDATORY_PREFIX, 0x196), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MANDATORY_PREFIX, 0x197), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MANDATORY_PREFIX, 0x198) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MANDATORY_PREFIX, 0x199), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MANDATORY_PREFIX, 0x19A) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MANDATORY_PREFIX, 0x19B), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MANDATORY_PREFIX, 0x19C) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MANDATORY_PREFIX, 0x19D), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MANDATORY_PREFIX, 0x19E) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MANDATORY_PREFIX, 0x19F), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MANDATORY_PREFIX, 0x1A0) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MANDATORY_PREFIX, 0x1A1), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MANDATORY_PREFIX, 0x1A2) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MANDATORY_PREFIX, 0x1A3), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MANDATORY_PREFIX, 0x1A4) },
    { ZYDIS_DEFINITION(0x1, 0x72C), ZYDIS_DEFINITION(0x1, 0x72D) },
    { ZYDIS_DEFINITION(0x1, 0x8), ZYDIS_DEFINITION(0x1, 0x9) },
    { ZYDIS_DEFINITION(0x1, 0xA), ZYDIS_DEFINITION(0x1, 0xB) },
    { ZYDIS_DEFINITION(0x1, 0xC), ZYDIS_DEFINITION(0x1, 0xD) },
    { ZYDIS_DEFINITION(0x1, 0xE), ZYDIS_DEFINITION(0x1, 0xF) },
    { ZYDIS_DEFINITION(0x1, 0x645), ZYDIS_DEFINITION(0x1, 0x646) },
    { ZYDIS_DEFINITION(0x1, 0x647), ZYDIS_DEFINITION(0x1, 0x648) },
    { ZYDIS_DEFINITION(0x1, 0x649), ZYDIS_DEFINITION(0x1, 0x64A) },
    { ZYDIS_DEFINITION(0x1, 0x64B), ZYDIS_DEFINITION(0x1, 0x64C) },
    { ZYDIS_DEFINITION(0x1, 0x54), ZYDIS_DEFINITION(0x1, 0x55) },
    { ZYDIS_DEFINITION(0x1, 0x56), ZYDIS_DEFINITION(0x1, 0x57) },
    { ZYDIS_DEFINITION(0x1, 0x58), ZYDIS_DEFINITION(0x1, 0x59) },
    { ZYDIS_DEFINITION(0x1, 0x5A), ZYDIS_DEFINITION(0x1, 0x5B) },
    { ZYDIS_DEFINITION(0x1, 0x6EE), ZYDIS_DEFINITION(0x1, 0x6EF) },
    { ZYDIS_DEFINITION(0x1, 0x6F0), ZYDIS_DEFINITION(0x1, 0x6F1) },
    { ZYDIS_DEFINITION(0x1, 0x6F2), ZYDIS_DEFINITION(0x1, 0x6F3) },
    { ZYDIS_DEFINITION(0x1, 0x6F4), ZYDIS_DEFINITION(0x1, 0x6F5) },
    { ZYDIS_DEFINITION(0x1, 0x774), ZYDIS_DEFINITION(0x1, 0x775) },
    { ZYDIS_DEFINITION(0x1, 0x776), ZYDIS_DEFINITION(0x1, 0x777) },
    { ZYDIS_DEFINITION(0x1, 0x778), ZYDIS_DEFINITION(0x1, 0x779) },
    { ZYDIS_DEFINITION(0x1, 0x77A), ZYDIS_DEFINITION(0x1, 0x77B) },
    { ZYDIS_DEFINITION(0x1, 0xE7), ZYDIS_DEFINITION(0x1, 0xE8) },
    { ZYDIS_DEFINITION(0x1, 0xE9), ZYDIS_DEFINITION(0x1, 0xEA) },
    { ZYDIS_DEFINITION(0x1, 0xEB), ZYDIS_DEFINITION(0x1, 0xEC) },
    { ZYDIS_DEFINITION(0x1, 0xED), ZYDIS_DEFINITION(0x1, 0xEE) },
    { ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODE_COMPACT, 0x73) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x33), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x34) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x35), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x36) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x37), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x38) },
    { ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x39) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x3A), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x3B) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x3C), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x3D) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x3E), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x3F) },
    { ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x40) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x41), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x42) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x43), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x44) },
    { ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x45) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x46), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x47) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x48), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x49) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x4A), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x4B) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x4C), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x4D) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x4E), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x4F) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x50), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x51) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x52), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x53) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x54), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x55) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x56), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x57) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x58), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x59) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x5A), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x5B) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x5C), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x5D) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x5E), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x5F) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x60), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x61) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x62), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x63) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x64), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x65) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x66), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x67) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x68), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x69) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x6A), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x6B) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x6C), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x6D) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x6E), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x6F) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x70), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x71) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x72), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x73) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x74), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x75) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x76), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x77) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x78), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x79) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x7A), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x7B) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x7C), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x7D) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x7E), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x7F) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x80), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x81) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x82), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x83) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x84), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x85) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x86), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x87) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x88), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x89) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x8A), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x8B) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x8C), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x8D) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x8E), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x8F) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x90), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x91) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x92), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x93) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x94), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x95) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x96), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x97) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x98), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x99) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x9A), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x9B) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x9C), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x9D) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x9E), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x9F) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0xA0), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0xA1) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0xA2), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0xA3) },
    { ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0xA4) },
    { ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0xA5) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0xA6), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0xA7) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0xA8), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0xA9) },
    { ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0xAA) },
    { ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0xAB) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0xAC), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0xAD) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0xAE), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0xAF) },
    { ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0xB0) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0xB1), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0xB2) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0xB3), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0xB4) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0xB5), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0xB6) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0xB7), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0xB8) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0xB9), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0xBA) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0xBB), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0xBC) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0xBD), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0xBE) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0xBF), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0xC0) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0xC1), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0xC2) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0xC3), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0xC4) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0xC5), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0xC6) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0xC7), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0xC8) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0xC9), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0xCA) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0xCB), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0xCC) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0xCD), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0xCE) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x6C), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x6D) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x6E), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x6F) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0xCF), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0xD0) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x71), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x72) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x73), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x74) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x75), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x76) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0xD1), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0xD2) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x78), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x79) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x7A), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x7B) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x7C), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x7D) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0xD3), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0xD4) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0xD5), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0xD6) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0xD7), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0xD8) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0xD9), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0xDA) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0xDB), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0xDC) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0xDD), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0xDE) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0xDF), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0xE0) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_REG, 0x2B), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_REG, 0x2C) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_REG, 0x2D), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_REG, 0x2E) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_REG, 0x2F), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_REG, 0x30) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0xA1), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0xA2) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0xA3), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0xA4) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0xEF), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0xF0) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0xF1), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0xF2) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0xF3), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0xF4) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0xF5), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0xF6) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0xF7), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0xF8) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0xF9), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0xFA) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0xFB), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0xFC) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0xFD), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0xFE) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0xB9), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0xBA) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0xBB), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0xFF), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x100) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0xBD), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0xBE) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x101), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x102) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x103), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x104) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x105), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x106) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0xC4), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0xC5) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x107), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x108) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0xC8), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0xC9) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0xCA), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0xCB) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0xCC), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0xCD) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x109), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x10A) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0xD0), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0xD1) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0xD2), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0xD3) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0xD4), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0xD5) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x10B), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x10C) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0xD8), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0xD9) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0xDA), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0xDB) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x10D), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x10E) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0xE0), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0xE1) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0xE2), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0xE3) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0xE4), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0xE5) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x10F), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x110) },
    { ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x111) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0xE8), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0xE9) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0xEA), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0xEB) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0xEC), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0xED) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x112), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x113) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0xF0), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0xF1) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0xF2), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0xF3) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0xF4), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0xF5) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x114), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x115) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0xF8), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0xF9) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x116), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x117) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x118), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x119) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x11A), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x11B) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0xFF), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x100) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x101), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x102) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x103), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x104) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x105), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x106) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x11C), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x11D) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x11E), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x11F) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x109), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x10A) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x10B), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x10C) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x120), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x121) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x10E), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x10F) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x110), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x111) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x112), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x113) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x122), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x123) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x124), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x125) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x126), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x127) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x128), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x129) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x12A), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x12B) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x12C), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x12D) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x12E), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x12F) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x130), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x131) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x132), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x133) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x134), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x135) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x136), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x137) },
    { ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x138) },
    { ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x139) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x12E), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x12F) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x130), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x131) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x13A), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x13B) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x13C), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x13D) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x134), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x135) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x136), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x137) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x138), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x139) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x13A), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x13B) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x13C), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x13D) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x13E), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x13F) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x140), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x141) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x142), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x143) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x144), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x145) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x146), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x147) },
    { ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x148) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x149), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x14A) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x14B), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x14C) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x14D), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x14E) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x150), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x151) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x152), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x153) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x154), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x155) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x156), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x157) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x158), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x159) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x14F), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x150) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x151), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x152) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x153), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x154) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x15F), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x160) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x155), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x156) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x163), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x164) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x157), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x158) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x167), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x168) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x159), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x15A) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x16B), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x16C) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x15B), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x15C) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x15D), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x15E) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x15F), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x160) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x161), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x162) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x163), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x164) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x165), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x166) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x167), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x168) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x169), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x16A) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x16B), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x16C) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x16D), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x16E) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x16F), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x170) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x171), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x172) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x173), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x174) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x175), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x176) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x177), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x178) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x179), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x17A) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x17B), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x17C) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x17D), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x17E) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x17F), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x180) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x181), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x182) },
    { ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x183) },
    { ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x184) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x185), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x186) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x187), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x188) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x189), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x18A) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x18B), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x18C) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x18D), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x18E) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x18F), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x190) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x191), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x192) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x193), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x194) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x195), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x196) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x197), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x198) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x199), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x19A) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x19B), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x19C) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x19D), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x19E) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x19F), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x1A0) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x1A1), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x1A2), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x1A3), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x1A4), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x1A5) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x1A6), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x1A7) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x1A8), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x1A9) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x1AA), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x1AB) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x1AC), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x1AD) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x1AE), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x1AF) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x1B0), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x1B1) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x1B2), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x1B3) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x1B4), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x1B5) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x1B6), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x1B7) },
    { ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_RM, 0x1A) },
    { ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_RM, 0x1B) },
    { ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_RM, 0x1C) },
    { ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_RM, 0x1D) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x1BC), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x1BD) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x1BE), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x1BF) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x1C0), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x1C1) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x1C2), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x1C3) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x1C4), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x1C5) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x1C6), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x1C7) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x1C8), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x1C9) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x1CA), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x1CB) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x1CC), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x1CD) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x1CE), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x1CF) },
    { ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_RM, 0x1E) },
    { ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_RM, 0x1F) },
    { ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_RM, 0x20) },
    { ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_RM, 0x21) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x1D4), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x1D5) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x1D6), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x1D7) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x1D8), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x1D9) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x1DA), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x1DB) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x1DC), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x1DD) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x1DE), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x1DF) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x1E0), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x1E1) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x1E2), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x1E3) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x1E4), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x1E5) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x1E6), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x1E7) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x1E8), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x1E9) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x1EA), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x1EB) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x1EC), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x1ED) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x1EE), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x1EF) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x1F0), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x1F1) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x1F2), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x1F3) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x1F4), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x1F5) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x1F6), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x1F7) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x1F8), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x1F9) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x1FA), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x1FB) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x1FC), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x1FD) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x1FE), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x1FF) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x200), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x201) },
    { ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_REG, 0x31) },
    { ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_REG, 0x32) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x20A), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x20B) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x20C), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x20D) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x20E), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x20F) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x210), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x211) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x212), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x213) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x214), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x215) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x26F), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x270) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x271), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x272) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x273), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x274) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x275), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x276) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x216), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x217) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x218), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x219) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x21A), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x21B) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x21C), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x21D) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x21E), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x21F) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x220), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x221) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x222), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x223) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x224), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x225) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x226), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x227) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x283), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x284) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x285), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x286) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x287), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x288) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x228), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x229) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x28F), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x290) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x22A), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x22B) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x22C), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x22D) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x22E), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x22F) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x230), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x231) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x232), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x233) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x234), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x235) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x236), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x237) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x2A7), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x2A8) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x238), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x239) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x23A), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x23B) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x23C), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x23D) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x23E), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x23F) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x240), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x241) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x242), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x243) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x244), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x245) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x246), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x247) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x248), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x249) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x24A), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x24B) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x24C), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x24D) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x24E), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x24F) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x250), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x251) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x252), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x253) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x2D7), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x2D8) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x254), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x255) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x256), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x257) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x258), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x259) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x25A), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x25B) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x25C), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x25D) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x25E), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x25F) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x260), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x261) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x262), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x263) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x264), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x265) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x266), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x267) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x268), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x269) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x26A), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x26B) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x26C), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x26D) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x26E), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x26F) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x270), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x271) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x272), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x273) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x274), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x275) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x2FE), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x2FF) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x276), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x277) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x278), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x279) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x27A), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x27B) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x27C), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x27D) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x27E), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x27F) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x280), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x281) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x306), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x307) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x282), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x283) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x284), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x285) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x286), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x287) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x288), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x289) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x28A), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x28B) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x28C), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x28D) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x28E), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x28F) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x290), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x291) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x292), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x293) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x294), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x295) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x296), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x297) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x298), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x299) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x29A), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x29B) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x29C), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x29D) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x29E), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x29F) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x2A0), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x2A1) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x2A2), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x2A3) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x2A4), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x2A5) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x2A6), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x2A7) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x2A8), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x2A9) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x2AA), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x2AB) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x2AC), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x2AD) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x2AE), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x2AF) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x2B0), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x2B1) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x2B2), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x2B3) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x2B4), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x2B5) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x2B6), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x2B7) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x2B8), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x2B9) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x2BA), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x2BB) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x2BC), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x2BD) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x2BE), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x2BF) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x2C0), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x2C1) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x2C2), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x2C3) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x2C4), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x2C5) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x2C6), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x2C7) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x2C8), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x2C9) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x2CA), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x2CB) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x2CC), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x2CD) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x2CE), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x2CF) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x2D0), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x2D1) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x2D2), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x2D3) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x2D4), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x2D5) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x2D6), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x2D7) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x2D8), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x2D9) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x2DA), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x2DB) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x2DC), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x2DD) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x2DE), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x2DF) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x2E0), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x2E1) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x2E2), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x2E3) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x2E4), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x2E5) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x2E6), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x2E7) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x2E8), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x2E9) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x2EA), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x2EB) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x2EC), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x2ED) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x2EE), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x2EF) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x2F0), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x2F1) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x36E), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x36F) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x2F2), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x2F3) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x2F4), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x2F5) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x2F6), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x2F7) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x2F8), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x2F9) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x2FA), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x2FB) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x2FC), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x2FD) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x2FE), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x2FF) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x300), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x301) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x302), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x303) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x304), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x305) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x306), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x307) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x308), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x309) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x30A), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x30B) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x30C), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x30D) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x30E), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x30F) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x310), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x311) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x312), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x313) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x314), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x315) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x316), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x317) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x318), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x319) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x31A), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x31B) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x31C), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x31D) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x31E), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x31F), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x320), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x321), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x322) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x323), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x324) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x325), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x326) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x327), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x328) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x329), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x32A) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x32B), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x32C) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x32D), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x32E), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x32F), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x330), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x331) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x332), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x333) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x334), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x335) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x336), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x337) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x338), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x339) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x33A), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x33B) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x33C), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x33D) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x33E), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x33F) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x340), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x341) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x342), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x343) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x344), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x345) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x346), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x347) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x348), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x349) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x34A), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x34B) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x34C), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x34D) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x34E), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x34F) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x350), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x351) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x352), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x353) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x354), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x355) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x356), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x357) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x358), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x359) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x35A), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x35B) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x35C), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x35D) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x35E), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x35F) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x360), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x361) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x362), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x363) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x364), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x365) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x366), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x367) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x368), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x369) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x36A), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x36B) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x36C), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x36D) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x36E), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x36F) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x370), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x371) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x372), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x373) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x374), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x375) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x376), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x377) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x378), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x379) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x37A), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x37B) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x37C), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x37D) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x37E), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x37F) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x431), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x432) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x380), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x381) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x382), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x383) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x384), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x385) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x386), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x387) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x388), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x389) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x38A), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x38B) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x38C), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x38D) },
    { ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x38E) },
    { ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x38F) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x390), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x391) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x392), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x393) },
    { ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x394) },
    { ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x395) },
    { ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x396) },
    { ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x397) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x398), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x399) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x39A), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x39B) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x39C), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x39D) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x39E), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x39F) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x3A0), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x3A1) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x3A2), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x3A3) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x3A4), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x3A5) },
    { ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_REG, 0x33) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x3A6), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x3A7) },
    { ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x3A8) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x3A9), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x3AA) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x3AB), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x3AC) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x3AD), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x3AE) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x3AF), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x3B0) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x3B1), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x3B2) },
    { ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x3B3) },
    { ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x3B4) },
    { ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x3B5) },
    { ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x3B6) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x3B7), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x3B8) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x3B9), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x3BA) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x3BB), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x3BC) },
    { ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x3BD) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x3BE), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x3BF) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x3C0), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x3C1) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x3C2), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x3C3) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x3C4), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x3C5) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x3C6), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x3C7) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x3C8), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x3C9) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x3CA), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x3CB) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_REG, 0x34), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_REG, 0x35) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x3D2), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x3D3) },
    { ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x3D4) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x3D5), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x3D6) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x3D7), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x3D8) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x3D9), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x3DA) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x3DB), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x3DC) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x3DD), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x3DE) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x3DF), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x3E0) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x3E1), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x3E2) },
    { ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x3E3) },
    { ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x3E4) },
    { ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x3E5) },
    { ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x3E6) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x3E7), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x3E8) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x3E9), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x3EA) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x3EB), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x3EC) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x3ED), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x3EE) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x3EF), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x3F0) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x3F1), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x3F2) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x3F3), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x3F4) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x3F5), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x3F6) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x3F7), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x3F8) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x3F9), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x3FA) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x3FB), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x3FC) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x3FD), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x3FE) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x3FF), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x400) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x401), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x402) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x403), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x404) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x405), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x406) },
    { ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x407) },
    { ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x408) },
    { ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x409) },
    { ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x40A) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x40B), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x40C) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x40D), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x40E) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x40F), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x410) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x411), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x412) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x413), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x414) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x415), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x416) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x417), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x418) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x419), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x41A) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x41B), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x41C) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x41D), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x41E) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x41F), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x420) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x421), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x422) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x423), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x424) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x425), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x426) },
    { ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_RM, 0x2A) },
    { ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_RM, 0x2B) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x429), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x42A) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x42B), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x42C) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x42D), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x42E) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x42F), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x430) },
    { ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_RM, 0x2C) },
    { ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_RM, 0x2D) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x433), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x434) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x435), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x436) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x437), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x438) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x439), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x43A) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x43B), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x43C) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x43D), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x43E) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x43F), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x440) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x441), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x442) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x443), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x444) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x445), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x446) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x447), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x448) },
    { ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_REG, 0x36) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x44F), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x450) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x451), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x452) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x453), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x454) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x455), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x456) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x457), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x458) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x459), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x45A) },
    { ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x45B) },
    { ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x45C) },
    { ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x45D) },
    { ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x45E) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x45F), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x460) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x461), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x462) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x463), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x464) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x465), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x466) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x467), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x468) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x469), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x46A) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x46B), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x46C) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x46D), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x46E) },
    { ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x46F) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x470), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x471) },
    { ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_REG, 0x37) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x472), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x473) },
    { ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x474) },
    { ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_REG, 0x38) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x475), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x476) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x477), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x478) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODE_COMPACT, 0xAD), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODE_COMPACT, 0xAE) },
    { ZYDIS_DEFINITION(0xE, 0x230), ZYDIS_DEFINITION(0xE, 0x231) },
    { ZYDIS_DEFINITION(0xD, 0x232), ZYDIS_DEFINITION(0xD, 0x233) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_REG, 0x39), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_REG, 0x3A) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_REG, 0x3B), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_REG, 0x3C) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_REG, 0x3D), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_REG, 0x3E) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_REG, 0x3F), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_REG, 0x40) },
    { ZYDIS_DEFINITION(0x1, 0x714), ZYDIS_DEFINITION(0x1, 0x715) },
    { ZYDIS_DEFINITION(0x1, 0x716), ZYDIS_DEFINITION(0x1, 0x717) },
    { ZYDIS_DEFINITION(0x1, 0x766), ZYDIS_DEFINITION(0x1, 0x767) },
    { ZYDIS_DEFINITION(0x1, 0x768), ZYDIS_DEFINITION(0x1, 0x769) },
    { ZYDIS_DEFINITION(0x1, 0x309), ZYDIS_DEFINITION(0x1, 0x30A) },
    { ZYDIS_DEFINITION(0x1, 0x30B), ZYDIS_DEFINITION(0x1, 0x30C) },
    { ZYDIS_DEFINITION(0x1, 0x30D), ZYDIS_DEFINITION(0x1, 0x30E) },
    { ZYDIS_DEFINITION(0x1, 0x30F), ZYDIS_DEFINITION(0x1, 0x310) },
    { ZYDIS_DEFINITION(0x1, 0x311), ZYDIS_DEFINITION(0x1, 0x312) },
    { ZYDIS_INVALID, ZYDIS_DEFINITION(0x1, 0x2CB) },
    { ZYDIS_DEFINITION(0x1, 0x313), ZYDIS_DEFINITION(0x1, 0x314) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_REG, 0x41), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_REG, 0x42) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x479), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x47A) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x47B), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x47C) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x47D), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x47E) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x47F), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x480) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x481), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x482) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x483), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x484) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x485), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x486) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x487), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x488) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x489), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x48A) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x48B), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x48C) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x48D), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x48E) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x48F), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x490) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x491), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x492) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x493), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x494) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x495), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x496) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x497), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x498) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x499), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x49A) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x49B), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x49C) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x49D), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x49E) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x49F), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x4A0) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x4A1), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x4A2) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x4A3), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x4A4) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x4A5), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x4A6) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x4A7), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x4A8) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x4A9), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x4AA) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x4AB), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x4AC) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x4AD), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x4AE) },
    { ZYDIS_DEFINITION(0x1, 0x2), ZYDIS_DEFINITION(0x1, 0x3) },
    { ZYDIS_DEFINITION(0x1, 0xC), ZYDIS_DEFINITION(0x1, 0xD) },
    { ZYDIS_DEFINITION(0x1, 0xA), ZYDIS_DEFINITION(0x1, 0xB) },
    { ZYDIS_DEFINITION(0x1, 0x18), ZYDIS_DEFINITION(0x1, 0x19) },
    { ZYDIS_DEFINITION(0x1, 0x6), ZYDIS_DEFINITION(0x1, 0x7) },
    { ZYDIS_DEFINITION(0x1, 0xE), ZYDIS_DEFINITION(0x1, 0xF) },
    { ZYDIS_DEFINITION(0x1, 0x16), ZYDIS_DEFINITION(0x1, 0x17) },
    { ZYDIS_DEFINITION(0x1, 0x8), ZYDIS_DEFINITION(0x1, 0x9) },
    { ZYDIS_DEFINITION(0x1, 0x4), ZYDIS_DEFINITION(0x1, 0x5) },
    { ZYDIS_DEFINITION(0x1, 0x10), ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0x1, 0x15), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x4AF), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x4B0) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x4B1), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x4B2) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x4B3), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x4B4) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x4B5), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x4B6) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x4B7), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x4B8) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x4B9), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x4BA) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x4BB), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x4BC) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x4BD), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x4BE) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x4BF), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x4C0) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x4C1), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x4C2) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x4C3), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x4C4) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x4C5), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x4C6) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x4C7), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x4C8) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x4C9), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x4CA) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x4CB), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x4CC) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x4CD), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x4CE) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x4CF), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x4D0) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x4D1), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x4D2) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x4D3), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x4D4) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x4D5), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x4D6) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x4D7), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x4D8) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x4D9), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x4DA) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x4DB), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x4DC) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x4DD), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x4DE) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x4DF), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x4E0) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x4E1), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x4E2) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x4E3), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x4E4) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x4E5), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x4E6) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x4E7), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x4E8) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x4E9), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x4EA) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x4EB), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x4EC) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x4ED), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x4EE) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x4EF), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x4F0) },
    { ZYDIS_DEFINITION(0xC, 0x0), ZYDIS_DEFINITION(0xC, 0x1) },
    { ZYDIS_DEFINITION(0xC, 0x11), ZYDIS_DEFINITION(0xC, 0x12) },
    { ZYDIS_DEFINITION(0xC, 0x13), ZYDIS_DEFINITION(0xC, 0x14) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_REG, 0x47), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_REG, 0x48) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_REG, 0x49), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_REG, 0x4A) },
    { ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODE_COMPACT, 0xD2) },
    { ZYDIS_DEFINITION(0x1, 0x37B), ZYDIS_DEFINITION(0x1, 0x37D) },
    { ZYDIS_DEFINITION(0x1, 0x37C), ZYDIS_DEFINITION(0x1, 0x37E) },
    { ZYDIS_DEFINITION(0x1, 0x37F), ZYDIS_DEFINITION(0x1, 0x381) },
    { ZYDIS_DEFINITION(0x1, 0x380), ZYDIS_DEFINITION(0x1, 0x382) },
    { ZYDIS_DEFINITION(0x1, 0x345), ZYDIS_DEFINITION(0x1, 0x34D) },
    { ZYDIS_INVALID, ZYDIS_DEFINITION(0x1, 0x34E) },
    { ZYDIS_DEFINITION(0x1, 0x690), ZYDIS_DEFINITION(0x1, 0x692) },
    { ZYDIS_DEFINITION(0x1, 0x691), ZYDIS_DEFINITION(0x1, 0x693) },
    { ZYDIS_DEFINITION(0x1, 0x688), ZYDIS_DEFINITION(0x1, 0x68A) },
    { ZYDIS_DEFINITION(0x1, 0x689), ZYDIS_DEFINITION(0x1, 0x68B) },
    { ZYDIS_DEFINITION(0x1, 0x34A), ZYDIS_DEFINITION(0x1, 0x348) },
    { ZYDIS_INVALID, ZYDIS_DEFINITION(0x1, 0x349) },
    { ZYDIS_INVALID, ZYDIS_DEFINITION(0x1, 0x57D) },
    { ZYDIS_INVALID, ZYDIS_DEFINITION(0x1, 0x576) },
    { ZYDIS_INVALID, ZYDIS_DEFINITION(0x1, 0x577) },
    { ZYDIS_INVALID, ZYDIS_DEFINITION(0x1, 0x578) },
    { ZYDIS_INVALID, ZYDIS_DEFINITION(0x1, 0x57C) },
    { ZYDIS_INVALID, ZYDIS_DEFINITION(0x1, 0x579) },
    { ZYDIS_INVALID, ZYDIS_DEFINITION(0x1, 0x57A) },
    { ZYDIS_INVALID, ZYDIS_DEFINITION(0x1, 0x57B) },
    { ZYDIS_DEFINITION(0x1, 0x321), ZYDIS_DEFINITION(0x1, 0x323) },
    { ZYDIS_DEFINITION(0x1, 0x322), ZYDIS_DEFINITION(0x1, 0x324) },
    { ZYDIS_DEFINITION(0x1, 0x325), ZYDIS_DEFINITION(0x1, 0x327) },
    { ZYDIS_DEFINITION(0x1, 0x326), ZYDIS_DEFINITION(0x1, 0x328) },
    { ZYDIS_INVALID, ZYDIS_DEFINITION(0x1, 0x359) },
    { ZYDIS_INVALID, ZYDIS_DEFINITION(0x1, 0x35A) },
    { ZYDIS_DEFINITION(0x1, 0x682), ZYDIS_DEFINITION(0x1, 0x683) },
    { ZYDIS_DEFINITION(0x1, 0x115), ZYDIS_DEFINITION(0x1, 0x116) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x4F5), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x4F6), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x4F7), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x4F8), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x4F9), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x4FA), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x4FB), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x4FC), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x4FD), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x4FE), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x4FF), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x500), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x501), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x502), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x503), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x504), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x505), ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0x1, 0x351), ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0x1, 0x352), ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0x1, 0x663), ZYDIS_DEFINITION(0x1, 0x665) },
    { ZYDIS_DEFINITION(0x1, 0x664), ZYDIS_DEFINITION(0x1, 0x666) },
    { ZYDIS_DEFINITION(0x1, 0x640), ZYDIS_DEFINITION(0x1, 0x642) },
    { ZYDIS_DEFINITION(0x1, 0x641), ZYDIS_DEFINITION(0x1, 0x643) },
    { ZYDIS_DEFINITION(0x1, 0x62E), ZYDIS_DEFINITION(0x1, 0x630) },
    { ZYDIS_DEFINITION(0x1, 0x62F), ZYDIS_DEFINITION(0x1, 0x631) },
    { ZYDIS_DEFINITION(0x1, 0xE7), ZYDIS_DEFINITION(0x1, 0xE9) },
    { ZYDIS_DEFINITION(0x1, 0xE8), ZYDIS_DEFINITION(0x1, 0xEA) },
    { ZYDIS_DEFINITION(0x1, 0xDF), ZYDIS_DEFINITION(0x1, 0xE1) },
    { ZYDIS_DEFINITION(0x1, 0xE0), ZYDIS_DEFINITION(0x1, 0xE2) },
    { ZYDIS_DEFINITION(0x1, 0x397), ZYDIS_DEFINITION(0x1, 0x399) },
    { ZYDIS_DEFINITION(0x1, 0x398), ZYDIS_DEFINITION(0x1, 0x39A) },
    { ZYDIS_DEFINITION(0x1, 0x698), ZYDIS_DEFINITION(0x1, 0x69A) },
    { ZYDIS_DEFINITION(0x1, 0x699), ZYDIS_DEFINITION(0x1, 0x69B) },
    { ZYDIS_DEFINITION(0x1, 0xB7), ZYDIS_DEFINITION(0x1, 0xB9) },
    { ZYDIS_DEFINITION(0x1, 0xB8), ZYDIS_DEFINITION(0x1, 0xBA) },
    { ZYDIS_DEFINITION(0x1, 0x38B), ZYDIS_DEFINITION(0x1, 0x38D) },
    { ZYDIS_DEFINITION(0x1, 0x38C), ZYDIS_DEFINITION(0x1, 0x38E) },
    { ZYDIS_DEFINITION(0x1, 0x13B), ZYDIS_DEFINITION(0x1, 0x13D) },
    { ZYDIS_DEFINITION(0x1, 0x13C), ZYDIS_DEFINITION(0x1, 0x13E) },
    { ZYDIS_DEFINITION(0x1, 0x11B), ZYDIS_DEFINITION(0x1, 0x11D) },
    { ZYDIS_DEFINITION(0x1, 0x11C), ZYDIS_DEFINITION(0x1, 0x11E) },
    { ZYDIS_DEFINITION(0x1, 0x670), ZYDIS_DEFINITION(0x1, 0x672) },
    { ZYDIS_DEFINITION(0x1, 0x671), ZYDIS_DEFINITION(0x1, 0x673) },
    { ZYDIS_DEFINITION(0x1, 0x311), ZYDIS_DEFINITION(0x1, 0x313) },
    { ZYDIS_DEFINITION(0x1, 0x312), ZYDIS_DEFINITION(0x1, 0x314) },
    { ZYDIS_DEFINITION(0x1, 0x177), ZYDIS_DEFINITION(0x1, 0x179) },
    { ZYDIS_DEFINITION(0x1, 0x178), ZYDIS_DEFINITION(0x1, 0x17A) },
    { ZYDIS_DEFINITION(0x1, 0x305), ZYDIS_DEFINITION(0x1, 0x307) },
    { ZYDIS_DEFINITION(0x1, 0x306), ZYDIS_DEFINITION(0x1, 0x308) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x508), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x509) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x50A), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x50B) },
    { ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x50C) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x50D), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x50E), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x50F), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x510), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x511), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x512), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x513), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x514), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x515), ZYDIS_INVALID },
    { ZYDIS_INVALID, ZYDIS_DEFINITION(0x1, 0x2F7) },
    { ZYDIS_INVALID, ZYDIS_DEFINITION(0x1, 0x66B) },
    { ZYDIS_DEFINITION(0xB, 0x10B), ZYDIS_DEFINITION(0xB, 0x10D) },
    { ZYDIS_DEFINITION(0xB, 0x10C), ZYDIS_DEFINITION(0xB, 0x10E) },
    { ZYDIS_DEFINITION(0xB, 0x64D), ZYDIS_DEFINITION(0xB, 0x64F) },
    { ZYDIS_DEFINITION(0xB, 0x64E), ZYDIS_DEFINITION(0xB, 0x650) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x516), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x517) },
    { ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x518) },
    { ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x519) },
    { ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x51A) },
    { ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x51B) },
    { ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x51C) },
    { ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x51D) },
    { ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x51E) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x51F), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x520) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x521), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x522) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x523), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x524) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x525), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x526) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x527), ZYDIS_INVALID },
    { ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x528) },
    { ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x529) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x52A), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x52B) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x52C), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x52D) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x52E), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x52F) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x530), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x531) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x532), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x533) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x534), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x535) },
    { ZYDIS_DEFINITION(0x1, 0x4), ZYDIS_DEFINITION(0x1, 0x5) },
    { ZYDIS_DEFINITION(0x1, 0xC), ZYDIS_DEFINITION(0x1, 0xD) },
    { ZYDIS_DEFINITION(0x1, 0xA), ZYDIS_DEFINITION(0x1, 0xB) },
    { ZYDIS_DEFINITION(0x1, 0x8), ZYDIS_DEFINITION(0x1, 0x9) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x536), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x537) },
    { ZYDIS_DEFINITION(0x1, 0x12), ZYDIS_DEFINITION(0x1, 0x13) },
    { ZYDIS_DEFINITION(0x1, 0x6), ZYDIS_DEFINITION(0x1, 0x7) },
    { ZYDIS_DEFINITION(0x1, 0x373), ZYDIS_DEFINITION(0x1, 0x375) },
    { ZYDIS_DEFINITION(0x1, 0x374), ZYDIS_DEFINITION(0x1, 0x376) },
    { ZYDIS_DEFINITION(0x1, 0x377), ZYDIS_DEFINITION(0x1, 0x379) },
    { ZYDIS_DEFINITION(0x1, 0x378), ZYDIS_DEFINITION(0x1, 0x37A) },
    { ZYDIS_INVALID, ZYDIS_DEFINITION(0x1, 0x34B) },
    { ZYDIS_INVALID, ZYDIS_DEFINITION(0x1, 0x34C) },
    { ZYDIS_DEFINITION(0x1, 0x68C), ZYDIS_DEFINITION(0x1, 0x68E) },
    { ZYDIS_DEFINITION(0x1, 0x68D), ZYDIS_DEFINITION(0x1, 0x68F) },
    { ZYDIS_DEFINITION(0x1, 0x684), ZYDIS_DEFINITION(0x1, 0x686) },
    { ZYDIS_DEFINITION(0x1, 0x685), ZYDIS_DEFINITION(0x1, 0x687) },
    { ZYDIS_INVALID, ZYDIS_DEFINITION(0x1, 0x346) },
    { ZYDIS_INVALID, ZYDIS_DEFINITION(0x1, 0x347) },
    { ZYDIS_DEFINITION(0x1, 0x319), ZYDIS_DEFINITION(0x1, 0x31B) },
    { ZYDIS_DEFINITION(0x1, 0x31A), ZYDIS_DEFINITION(0x1, 0x31C) },
    { ZYDIS_DEFINITION(0x1, 0x31D), ZYDIS_DEFINITION(0x1, 0x31F) },
    { ZYDIS_DEFINITION(0x1, 0x31E), ZYDIS_DEFINITION(0x1, 0x320) },
    { ZYDIS_INVALID, ZYDIS_DEFINITION(0x1, 0x357) },
    { ZYDIS_INVALID, ZYDIS_DEFINITION(0x1, 0x358) },
    { ZYDIS_DEFINITION(0x1, 0x680), ZYDIS_DEFINITION(0x1, 0x681) },
    { ZYDIS_DEFINITION(0x1, 0x113), ZYDIS_DEFINITION(0x1, 0x114) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x538), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x539), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x53A), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x53B), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x53C), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x53D), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x53E), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x53F), ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0x1, 0x34F), ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0x1, 0x350), ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0x1, 0x65F), ZYDIS_DEFINITION(0x1, 0x661) },
    { ZYDIS_DEFINITION(0x1, 0x660), ZYDIS_DEFINITION(0x1, 0x662) },
    { ZYDIS_DEFINITION(0x1, 0xE3), ZYDIS_DEFINITION(0x1, 0xE5) },
    { ZYDIS_DEFINITION(0x1, 0xE4), ZYDIS_DEFINITION(0x1, 0xE6) },
    { ZYDIS_DEFINITION(0x1, 0xDB), ZYDIS_DEFINITION(0x1, 0xDD) },
    { ZYDIS_DEFINITION(0x1, 0xDC), ZYDIS_DEFINITION(0x1, 0xDE) },
    { ZYDIS_DEFINITION(0x1, 0x393), ZYDIS_DEFINITION(0x1, 0x395) },
    { ZYDIS_DEFINITION(0x1, 0x394), ZYDIS_DEFINITION(0x1, 0x396) },
    { ZYDIS_DEFINITION(0x1, 0x694), ZYDIS_DEFINITION(0x1, 0x696) },
    { ZYDIS_DEFINITION(0x1, 0x695), ZYDIS_DEFINITION(0x1, 0x697) },
    { ZYDIS_DEFINITION(0x1, 0xB3), ZYDIS_DEFINITION(0x1, 0xB5) },
    { ZYDIS_DEFINITION(0x1, 0xB4), ZYDIS_DEFINITION(0x1, 0xB6) },
    { ZYDIS_DEFINITION(0x1, 0x387), ZYDIS_DEFINITION(0x1, 0x389) },
    { ZYDIS_DEFINITION(0x1, 0x388), ZYDIS_DEFINITION(0x1, 0x38A) },
    { ZYDIS_DEFINITION(0x1, 0x12F), ZYDIS_DEFINITION(0x1, 0x131) },
    { ZYDIS_DEFINITION(0x1, 0x130), ZYDIS_DEFINITION(0x1, 0x132) },
    { ZYDIS_DEFINITION(0x1, 0x137), ZYDIS_DEFINITION(0x1, 0x139) },
    { ZYDIS_DEFINITION(0x1, 0x138), ZYDIS_DEFINITION(0x1, 0x13A) },
    { ZYDIS_DEFINITION(0x1, 0x66C), ZYDIS_DEFINITION(0x1, 0x66E) },
    { ZYDIS_DEFINITION(0x1, 0x66D), ZYDIS_DEFINITION(0x1, 0x66F) },
    { ZYDIS_DEFINITION(0x1, 0x30D), ZYDIS_DEFINITION(0x1, 0x30F) },
    { ZYDIS_DEFINITION(0x1, 0x30E), ZYDIS_DEFINITION(0x1, 0x310) },
    { ZYDIS_DEFINITION(0x1, 0x173), ZYDIS_DEFINITION(0x1, 0x175) },
    { ZYDIS_DEFINITION(0x1, 0x174), ZYDIS_DEFINITION(0x1, 0x176) },
    { ZYDIS_DEFINITION(0x1, 0x301), ZYDIS_DEFINITION(0x1, 0x303) },
    { ZYDIS_DEFINITION(0x1, 0x302), ZYDIS_DEFINITION(0x1, 0x304) },
    { ZYDIS_DEFINITION(0x1, 0x61A), ZYDIS_DEFINITION(0x1, 0x61C) },
    { ZYDIS_DEFINITION(0x1, 0x61B), ZYDIS_DEFINITION(0x1, 0x61D) },
    { ZYDIS_DEFINITION(0x1, 0x626), ZYDIS_DEFINITION(0x1, 0x628) },
    { ZYDIS_DEFINITION(0x1, 0x627), ZYDIS_DEFINITION(0x1, 0x629) },
    { ZYDIS_DEFINITION(0x1, 0x61E), ZYDIS_DEFINITION(0x1, 0x620) },
    { ZYDIS_DEFINITION(0x1, 0x61F), ZYDIS_DEFINITION(0x1, 0x621) },
    { ZYDIS_DEFINITION(0x1, 0x3AB), ZYDIS_DEFINITION(0x1, 0x3AD) },
    { ZYDIS_DEFINITION(0x1, 0x3AC), ZYDIS_DEFINITION(0x1, 0x3AE) },
    { ZYDIS_DEFINITION(0x1, 0x425), ZYDIS_DEFINITION(0x1, 0x427) },
    { ZYDIS_DEFINITION(0x1, 0x426), ZYDIS_DEFINITION(0x1, 0x428) },
    { ZYDIS_DEFINITION(0x1, 0x431), ZYDIS_DEFINITION(0x1, 0x433) },
    { ZYDIS_DEFINITION(0x1, 0x432), ZYDIS_DEFINITION(0x1, 0x434) },
    { ZYDIS_DEFINITION(0x1, 0x429), ZYDIS_DEFINITION(0x1, 0x42B) },
    { ZYDIS_DEFINITION(0x1, 0x42A), ZYDIS_DEFINITION(0x1, 0x42C) },
    { ZYDIS_DEFINITION(0x1, 0x3B3), ZYDIS_DEFINITION(0x1, 0x3B5) },
    { ZYDIS_DEFINITION(0x1, 0x3B4), ZYDIS_DEFINITION(0x1, 0x3B6) },
    { ZYDIS_DEFINITION(0x1, 0x60A), ZYDIS_DEFINITION(0x1, 0x60C) },
    { ZYDIS_DEFINITION(0x1, 0x60B), ZYDIS_DEFINITION(0x1, 0x60D) },
    { ZYDIS_DEFINITION(0x1, 0x616), ZYDIS_DEFINITION(0x1, 0x618) },
    { ZYDIS_DEFINITION(0x1, 0x617), ZYDIS_DEFINITION(0x1, 0x619) },
    { ZYDIS_DEFINITION(0x1, 0x60E), ZYDIS_DEFINITION(0x1, 0x610) },
    { ZYDIS_DEFINITION(0x1, 0x60F), ZYDIS_DEFINITION(0x1, 0x611) },
    { ZYDIS_DEFINITION(0x1, 0x3A7), ZYDIS_DEFINITION(0x1, 0x3A9) },
    { ZYDIS_DEFINITION(0x1, 0x3A8), ZYDIS_DEFINITION(0x1, 0x3AA) },
    { ZYDIS_DEFINITION(0x1, 0x622), ZYDIS_DEFINITION(0x1, 0x624) },
    { ZYDIS_DEFINITION(0x1, 0x623), ZYDIS_DEFINITION(0x1, 0x625) },
    { ZYDIS_DEFINITION(0x1, 0x612), ZYDIS_DEFINITION(0x1, 0x614) },
    { ZYDIS_DEFINITION(0x1, 0x613), ZYDIS_DEFINITION(0x1, 0x615) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x540), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x541) },
    { ZYDIS_DEFINITION(0x1, 0x32B), ZYDIS_DEFINITION(0x1, 0x32C) },
    { ZYDIS_DEFINITION(0x1, 0x335), ZYDIS_DEFINITION(0x1, 0x337) },
    { ZYDIS_DEFINITION(0x1, 0x336), ZYDIS_DEFINITION(0x1, 0x338) },
    { ZYDIS_DEFINITION(0xB, 0x586), ZYDIS_DEFINITION(0xB, 0x588) },
    { ZYDIS_DEFINITION(0xB, 0x587), ZYDIS_DEFINITION(0xB, 0x589) },
    { ZYDIS_DEFINITION(0xB, 0x5E0), ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0xB, 0x5E1), ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0xB, 0x5C4), ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0xB, 0x5C5), ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0xB, 0x5B4), ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0xB, 0x5B5), ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0xB, 0x5CA), ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0xB, 0x5CB), ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0xB, 0x5BA), ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0xB, 0x5BB), ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0xB, 0x59E), ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0xB, 0x59F), ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0xB, 0x5D2), ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0xB, 0x5D3), ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0xB, 0x5D0), ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0xB, 0x5D1), ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0xB, 0x5A6), ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0xB, 0x5A7), ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0xB, 0x5A4), ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0xB, 0x5A5), ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0x1, 0x40B), ZYDIS_DEFINITION(0x1, 0x40D) },
    { ZYDIS_DEFINITION(0x1, 0x40C), ZYDIS_DEFINITION(0x1, 0x40E) },
    { ZYDIS_DEFINITION(0x1, 0x417), ZYDIS_DEFINITION(0x1, 0x419) },
    { ZYDIS_DEFINITION(0x1, 0x418), ZYDIS_DEFINITION(0x1, 0x41A) },
    { ZYDIS_DEFINITION(0x1, 0x40F), ZYDIS_DEFINITION(0x1, 0x411) },
    { ZYDIS_DEFINITION(0x1, 0x410), ZYDIS_DEFINITION(0x1, 0x412) },
    { ZYDIS_DEFINITION(0x1, 0x2DF), ZYDIS_DEFINITION(0x1, 0x2E1) },
    { ZYDIS_DEFINITION(0x1, 0x2E0), ZYDIS_DEFINITION(0x1, 0x2E2) },
    { ZYDIS_DEFINITION(0x1, 0x2E7), ZYDIS_DEFINITION(0x1, 0x2E9) },
    { ZYDIS_DEFINITION(0x1, 0x2E8), ZYDIS_DEFINITION(0x1, 0x2EA) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x542), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x543) },
    { ZYDIS_DEFINITION(0x1, 0x32F), ZYDIS_DEFINITION(0x1, 0x330) },
    { ZYDIS_DEFINITION(0x1, 0x339), ZYDIS_DEFINITION(0x1, 0x33B) },
    { ZYDIS_DEFINITION(0x1, 0x33A), ZYDIS_DEFINITION(0x1, 0x33C) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x544), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x545) },
    { ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x546) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x547), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x548), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x549), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x54A), ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0xB, 0x107), ZYDIS_DEFINITION(0xB, 0x109) },
    { ZYDIS_DEFINITION(0xB, 0x108), ZYDIS_DEFINITION(0xB, 0x10A) },
    { ZYDIS_DEFINITION(0xB, 0x4DA), ZYDIS_DEFINITION(0xB, 0x4DB) },
    { ZYDIS_DEFINITION(0xB, 0x4AD), ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0xB, 0x649), ZYDIS_DEFINITION(0xB, 0x64B) },
    { ZYDIS_DEFINITION(0xB, 0x64A), ZYDIS_DEFINITION(0xB, 0x64C) },
    { ZYDIS_DEFINITION(0x1, 0xBF), ZYDIS_DEFINITION(0x1, 0xC1) },
    { ZYDIS_DEFINITION(0x1, 0xC0), ZYDIS_DEFINITION(0x1, 0xC2) },
    { ZYDIS_DEFINITION(0x1, 0x5E2), ZYDIS_DEFINITION(0x1, 0x5E4) },
    { ZYDIS_DEFINITION(0x1, 0x5E3), ZYDIS_DEFINITION(0x1, 0x5E5) },
    { ZYDIS_DEFINITION(0x1, 0x5CC), ZYDIS_DEFINITION(0x1, 0x5CE) },
    { ZYDIS_DEFINITION(0x1, 0x5CD), ZYDIS_DEFINITION(0x1, 0x5CF) },
    { ZYDIS_DEFINITION(0x1, 0x5D4), ZYDIS_DEFINITION(0x1, 0x5D6) },
    { ZYDIS_DEFINITION(0x1, 0x5D5), ZYDIS_DEFINITION(0x1, 0x5D7) },
    { ZYDIS_DEFINITION(0x1, 0x3BF), ZYDIS_DEFINITION(0x1, 0x3C1) },
    { ZYDIS_DEFINITION(0x1, 0x3C0), ZYDIS_DEFINITION(0x1, 0x3C2) },
    { ZYDIS_DEFINITION(0x1, 0x56A), ZYDIS_DEFINITION(0x1, 0x56C) },
    { ZYDIS_DEFINITION(0x1, 0x56B), ZYDIS_DEFINITION(0x1, 0x56D) },
    { ZYDIS_DEFINITION(0x1, 0x361), ZYDIS_DEFINITION(0x1, 0x362) },
    { ZYDIS_DEFINITION(0x1, 0x524), ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0x1, 0x525), ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0x1, 0x5FA), ZYDIS_DEFINITION(0x1, 0x5FC) },
    { ZYDIS_DEFINITION(0x1, 0x5FB), ZYDIS_DEFINITION(0x1, 0x5FD) },
    { ZYDIS_DEFINITION(0x1, 0x5FE), ZYDIS_DEFINITION(0x1, 0x600) },
    { ZYDIS_DEFINITION(0x1, 0x5FF), ZYDIS_DEFINITION(0x1, 0x601) },
    { ZYDIS_DEFINITION(0x1, 0x518), ZYDIS_DEFINITION(0x1, 0x51A) },
    { ZYDIS_DEFINITION(0x1, 0x519), ZYDIS_DEFINITION(0x1, 0x51B) },
    { ZYDIS_DEFINITION(0x1, 0x3DB), ZYDIS_DEFINITION(0x1, 0x3DD) },
    { ZYDIS_DEFINITION(0x1, 0x3DC), ZYDIS_DEFINITION(0x1, 0x3DE) },
    { ZYDIS_DEFINITION(0x1, 0x3CB), ZYDIS_DEFINITION(0x1, 0x3CD) },
    { ZYDIS_DEFINITION(0x1, 0x3CC), ZYDIS_DEFINITION(0x1, 0x3CE) },
    { ZYDIS_DEFINITION(0x1, 0x3CF), ZYDIS_DEFINITION(0x1, 0x3D1) },
    { ZYDIS_DEFINITION(0x1, 0x3D0), ZYDIS_DEFINITION(0x1, 0x3D2) },
    { ZYDIS_DEFINITION(0x1, 0x500), ZYDIS_DEFINITION(0x1, 0x502) },
    { ZYDIS_DEFINITION(0x1, 0x501), ZYDIS_DEFINITION(0x1, 0x503) },
    { ZYDIS_DEFINITION(0x1, 0x3DF), ZYDIS_DEFINITION(0x1, 0x3E1) },
    { ZYDIS_DEFINITION(0x1, 0x3E0), ZYDIS_DEFINITION(0x1, 0x3E2) },
    { ZYDIS_DEFINITION(0x1, 0x3E3), ZYDIS_DEFINITION(0x1, 0x3E5) },
    { ZYDIS_DEFINITION(0x1, 0x3E4), ZYDIS_DEFINITION(0x1, 0x3E6) },
    { ZYDIS_DEFINITION(0x1, 0x5C6), ZYDIS_DEFINITION(0x1, 0x5C8) },
    { ZYDIS_DEFINITION(0x1, 0x5C7), ZYDIS_DEFINITION(0x1, 0x5C9) },
    { ZYDIS_DEFINITION(0x1, 0x5BC), ZYDIS_DEFINITION(0x1, 0x5BE) },
    { ZYDIS_DEFINITION(0x1, 0x5BD), ZYDIS_DEFINITION(0x1, 0x5BF) },
    { ZYDIS_DEFINITION(0x1, 0x3E7), ZYDIS_DEFINITION(0x1, 0x3E9) },
    { ZYDIS_DEFINITION(0x1, 0x3E8), ZYDIS_DEFINITION(0x1, 0x3EA) },
    { ZYDIS_DEFINITION(0x1, 0x55E), ZYDIS_DEFINITION(0x1, 0x560) },
    { ZYDIS_DEFINITION(0x1, 0x55F), ZYDIS_DEFINITION(0x1, 0x561) },
    { ZYDIS_DEFINITION(0x1, 0x562), ZYDIS_DEFINITION(0x1, 0x564) },
    { ZYDIS_DEFINITION(0x1, 0x563), ZYDIS_DEFINITION(0x1, 0x565) },
    { ZYDIS_DEFINITION(0x1, 0x15F), ZYDIS_DEFINITION(0x1, 0x161) },
    { ZYDIS_DEFINITION(0x1, 0x160), ZYDIS_DEFINITION(0x1, 0x162) },
    { ZYDIS_INVALID, ZYDIS_DEFINITION(0x1, 0x353) },
    { ZYDIS_INVALID, ZYDIS_DEFINITION(0x1, 0x354) },
    { ZYDIS_DEFINITION(0x1, 0x5F2), ZYDIS_DEFINITION(0x1, 0x5F4) },
    { ZYDIS_DEFINITION(0x1, 0x5F3), ZYDIS_DEFINITION(0x1, 0x5F5) },
    { ZYDIS_DEFINITION(0x1, 0x5F6), ZYDIS_DEFINITION(0x1, 0x5F8) },
    { ZYDIS_DEFINITION(0x1, 0x5F7), ZYDIS_DEFINITION(0x1, 0x5F9) },
    { ZYDIS_DEFINITION(0x1, 0x514), ZYDIS_DEFINITION(0x1, 0x516) },
    { ZYDIS_DEFINITION(0x1, 0x515), ZYDIS_DEFINITION(0x1, 0x517) },
    { ZYDIS_DEFINITION(0x1, 0x572), ZYDIS_DEFINITION(0x1, 0x574) },
    { ZYDIS_DEFINITION(0x1, 0x573), ZYDIS_DEFINITION(0x1, 0x575) },
    { ZYDIS_DEFINITION(0x1, 0x3C3), ZYDIS_DEFINITION(0x1, 0x3C5) },
    { ZYDIS_DEFINITION(0x1, 0x3C4), ZYDIS_DEFINITION(0x1, 0x3C6) },
    { ZYDIS_DEFINITION(0x1, 0x3C7), ZYDIS_DEFINITION(0x1, 0x3C9) },
    { ZYDIS_DEFINITION(0x1, 0x3C8), ZYDIS_DEFINITION(0x1, 0x3CA) },
    { ZYDIS_DEFINITION(0x1, 0x4FC), ZYDIS_DEFINITION(0x1, 0x4FE) },
    { ZYDIS_DEFINITION(0x1, 0x4FD), ZYDIS_DEFINITION(0x1, 0x4FF) },
    { ZYDIS_DEFINITION(0x1, 0x62A), ZYDIS_DEFINITION(0x1, 0x62C) },
    { ZYDIS_DEFINITION(0x1, 0x62B), ZYDIS_DEFINITION(0x1, 0x62D) },
    { ZYDIS_DEFINITION(0x1, 0x5B6), ZYDIS_DEFINITION(0x1, 0x5B8) },
    { ZYDIS_DEFINITION(0x1, 0x5B7), ZYDIS_DEFINITION(0x1, 0x5B9) },
    { ZYDIS_DEFINITION(0x1, 0x5A0), ZYDIS_DEFINITION(0x1, 0x5A2) },
    { ZYDIS_DEFINITION(0x1, 0x5A1), ZYDIS_DEFINITION(0x1, 0x5A3) },
    { ZYDIS_DEFINITION(0x1, 0x5A8), ZYDIS_DEFINITION(0x1, 0x5AA) },
    { ZYDIS_DEFINITION(0x1, 0x5A9), ZYDIS_DEFINITION(0x1, 0x5AB) },
    { ZYDIS_DEFINITION(0x1, 0x56E), ZYDIS_DEFINITION(0x1, 0x570) },
    { ZYDIS_DEFINITION(0x1, 0x56F), ZYDIS_DEFINITION(0x1, 0x571) },
    { ZYDIS_DEFINITION(0x1, 0x4E8), ZYDIS_DEFINITION(0x1, 0x4EA) },
    { ZYDIS_DEFINITION(0x1, 0x4E9), ZYDIS_DEFINITION(0x1, 0x4EB) },
    { ZYDIS_DEFINITION(0x1, 0x57E), ZYDIS_DEFINITION(0x1, 0x580) },
    { ZYDIS_DEFINITION(0x1, 0x57F), ZYDIS_DEFINITION(0x1, 0x581) },
    { ZYDIS_DEFINITION(0x1, 0x2F8), ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0x1, 0x5E6), ZYDIS_DEFINITION(0x1, 0x5E8) },
    { ZYDIS_DEFINITION(0x1, 0x5E7), ZYDIS_DEFINITION(0x1, 0x5E9) },
    { ZYDIS_DEFINITION(0x1, 0x602), ZYDIS_DEFINITION(0x1, 0x604) },
    { ZYDIS_DEFINITION(0x1, 0x603), ZYDIS_DEFINITION(0x1, 0x605) },
    { ZYDIS_DEFINITION(0x1, 0x5EA), ZYDIS_DEFINITION(0x1, 0x5EC) },
    { ZYDIS_DEFINITION(0x1, 0x5EB), ZYDIS_DEFINITION(0x1, 0x5ED) },
    { ZYDIS_DEFINITION(0x1, 0x5EE), ZYDIS_DEFINITION(0x1, 0x5F0) },
    { ZYDIS_DEFINITION(0x1, 0x5EF), ZYDIS_DEFINITION(0x1, 0x5F1) },
    { ZYDIS_DEFINITION(0x1, 0x3B7), ZYDIS_DEFINITION(0x1, 0x3B9) },
    { ZYDIS_DEFINITION(0x1, 0x3B8), ZYDIS_DEFINITION(0x1, 0x3BA) },
    { ZYDIS_DEFINITION(0x1, 0x3D3), ZYDIS_DEFINITION(0x1, 0x3D5) },
    { ZYDIS_DEFINITION(0x1, 0x3D4), ZYDIS_DEFINITION(0x1, 0x3D6) },
    { ZYDIS_DEFINITION(0x1, 0x3BB), ZYDIS_DEFINITION(0x1, 0x3BD) },
    { ZYDIS_DEFINITION(0x1, 0x3BC), ZYDIS_DEFINITION(0x1, 0x3BE) },
    { ZYDIS_DEFINITION(0x1, 0x582), ZYDIS_DEFINITION(0x1, 0x584) },
    { ZYDIS_DEFINITION(0x1, 0x583), ZYDIS_DEFINITION(0x1, 0x585) },
    { ZYDIS_DEFINITION(0x1, 0x4C0), ZYDIS_DEFINITION(0x1, 0x4C2) },
    { ZYDIS_DEFINITION(0x1, 0x4C1), ZYDIS_DEFINITION(0x1, 0x4C3) },
    { ZYDIS_DEFINITION(0x1, 0x4B8), ZYDIS_DEFINITION(0x1, 0x4BA) },
    { ZYDIS_DEFINITION(0x1, 0x4B9), ZYDIS_DEFINITION(0x1, 0x4BB) },
    { ZYDIS_DEFINITION(0x1, 0x4BC), ZYDIS_DEFINITION(0x1, 0x4BE) },
    { ZYDIS_DEFINITION(0x1, 0x4BD), ZYDIS_DEFINITION(0x1, 0x4BF) },
    { ZYDIS_DEFINITION(0x1, 0x4E4), ZYDIS_DEFINITION(0x1, 0x4E6) },
    { ZYDIS_DEFINITION(0x1, 0x4E5), ZYDIS_DEFINITION(0x1, 0x4E7) },
    { ZYDIS_DEFINITION(0x1, 0x4CE), ZYDIS_DEFINITION(0x1, 0x4D0) },
    { ZYDIS_DEFINITION(0x1, 0x4CF), ZYDIS_DEFINITION(0x1, 0x4D1) },
    { ZYDIS_DEFINITION(0x1, 0x4C6), ZYDIS_DEFINITION(0x1, 0x4C8) },
    { ZYDIS_DEFINITION(0x1, 0x4C7), ZYDIS_DEFINITION(0x1, 0x4C9) },
    { ZYDIS_DEFINITION(0x1, 0x4CA), ZYDIS_DEFINITION(0x1, 0x4CC) },
    { ZYDIS_DEFINITION(0x1, 0x4CB), ZYDIS_DEFINITION(0x1, 0x4CD) },
    { ZYDIS_DEFINITION(0x1, 0x592), ZYDIS_DEFINITION(0x1, 0x594) },
    { ZYDIS_DEFINITION(0x1, 0x593), ZYDIS_DEFINITION(0x1, 0x595) },
    { ZYDIS_DEFINITION(0x1, 0x59A), ZYDIS_DEFINITION(0x1, 0x59C) },
    { ZYDIS_DEFINITION(0x1, 0x59B), ZYDIS_DEFINITION(0x1, 0x59D) },
    { ZYDIS_DEFINITION(0x1, 0x596), ZYDIS_DEFINITION(0x1, 0x598) },
    { ZYDIS_DEFINITION(0x1, 0x597), ZYDIS_DEFINITION(0x1, 0x599) },
    { ZYDIS_DEFINITION(0x1, 0x55A), ZYDIS_DEFINITION(0x1, 0x55C) },
    { ZYDIS_DEFINITION(0x1, 0x55B), ZYDIS_DEFINITION(0x1, 0x55D) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x54B), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x54C) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x54D), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x54E) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x54F), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x550) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x551), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x552) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x553), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x554) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x555), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x556) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x557), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x558) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x559), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x55A) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x55B), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x55C) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x55D), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x55E) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x55F), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x560) },
    { ZYDIS_DEFINITION(0x1, 0x606), ZYDIS_DEFINITION(0x1, 0x608) },
    { ZYDIS_DEFINITION(0x1, 0x607), ZYDIS_DEFINITION(0x1, 0x609) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x561), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x562) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x563), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x564) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x565), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x566) },
    { ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x567) },
    { ZYDIS_DEFINITION(0x1, 0x39B), ZYDIS_DEFINITION(0x1, 0x39D) },
    { ZYDIS_DEFINITION(0x1, 0x39C), ZYDIS_DEFINITION(0x1, 0x39E) },
    { ZYDIS_DEFINITION(0x1, 0x3A3), ZYDIS_DEFINITION(0x1, 0x3A5) },
    { ZYDIS_DEFINITION(0x1, 0x3A4), ZYDIS_DEFINITION(0x1, 0x3A6) },
    { ZYDIS_DEFINITION(0x1, 0x39F), ZYDIS_DEFINITION(0x1, 0x3A1) },
    { ZYDIS_DEFINITION(0x1, 0x3A0), ZYDIS_DEFINITION(0x1, 0x3A2) },
    { ZYDIS_DEFINITION(0x1, 0x52E), ZYDIS_DEFINITION(0x1, 0x530) },
    { ZYDIS_DEFINITION(0x1, 0x52F), ZYDIS_DEFINITION(0x1, 0x531) },
    { ZYDIS_DEFINITION(0x1, 0x526), ZYDIS_DEFINITION(0x1, 0x528) },
    { ZYDIS_DEFINITION(0x1, 0x527), ZYDIS_DEFINITION(0x1, 0x529) },
    { ZYDIS_DEFINITION(0x1, 0x52A), ZYDIS_DEFINITION(0x1, 0x52C) },
    { ZYDIS_DEFINITION(0x1, 0x52B), ZYDIS_DEFINITION(0x1, 0x52D) },
    { ZYDIS_DEFINITION(0x1, 0x536), ZYDIS_DEFINITION(0x1, 0x538) },
    { ZYDIS_DEFINITION(0x1, 0x537), ZYDIS_DEFINITION(0x1, 0x539) },
    { ZYDIS_DEFINITION(0x1, 0x53A), ZYDIS_DEFINITION(0x1, 0x53C) },
    { ZYDIS_DEFINITION(0x1, 0x53B), ZYDIS_DEFINITION(0x1, 0x53D) },
    { ZYDIS_DEFINITION(0x1, 0x532), ZYDIS_DEFINITION(0x1, 0x534) },
    { ZYDIS_DEFINITION(0x1, 0x533), ZYDIS_DEFINITION(0x1, 0x535) },
    { ZYDIS_DEFINITION(0x1, 0x556), ZYDIS_DEFINITION(0x1, 0x558) },
    { ZYDIS_DEFINITION(0x1, 0x557), ZYDIS_DEFINITION(0x1, 0x559) },
    { ZYDIS_DEFINITION(0x1, 0x413), ZYDIS_DEFINITION(0x1, 0x415) },
    { ZYDIS_DEFINITION(0x1, 0x414), ZYDIS_DEFINITION(0x1, 0x416) },
    { ZYDIS_INVALID, ZYDIS_DEFINITION(0x1, 0x355) },
    { ZYDIS_INVALID, ZYDIS_DEFINITION(0x1, 0x356) },
    { ZYDIS_DEFINITION(0x1, 0x3AF), ZYDIS_DEFINITION(0x1, 0x3B1) },
    { ZYDIS_DEFINITION(0x1, 0x3B0), ZYDIS_DEFINITION(0x1, 0x3B2) },
    { ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x568) },
    { ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x569) },
    { ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x56A) },
    { ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x56B) },
    { ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x56C) },
    { ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x56D) },
    { ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x56E) },
    { ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x56F) },
    { ZYDIS_DEFINITION(0x1, 0x546), ZYDIS_DEFINITION(0x1, 0x548) },
    { ZYDIS_DEFINITION(0x1, 0x547), ZYDIS_DEFINITION(0x1, 0x549) },
    { ZYDIS_DEFINITION(0x1, 0x53E), ZYDIS_DEFINITION(0x1, 0x540) },
    { ZYDIS_DEFINITION(0x1, 0x53F), ZYDIS_DEFINITION(0x1, 0x541) },
    { ZYDIS_DEFINITION(0x1, 0x542), ZYDIS_DEFINITION(0x1, 0x544) },
    { ZYDIS_DEFINITION(0x1, 0x543), ZYDIS_DEFINITION(0x1, 0x545) },
    { ZYDIS_DEFINITION(0x1, 0x54E), ZYDIS_DEFINITION(0x1, 0x550) },
    { ZYDIS_DEFINITION(0x1, 0x54F), ZYDIS_DEFINITION(0x1, 0x551) },
    { ZYDIS_DEFINITION(0x1, 0x552), ZYDIS_DEFINITION(0x1, 0x554) },
    { ZYDIS_DEFINITION(0x1, 0x553), ZYDIS_DEFINITION(0x1, 0x555) },
    { ZYDIS_DEFINITION(0x1, 0x54A), ZYDIS_DEFINITION(0x1, 0x54C) },
    { ZYDIS_DEFINITION(0x1, 0x54B), ZYDIS_DEFINITION(0x1, 0x54D) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x570), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x571) },
    { ZYDIS_DEFINITION(0x1, 0x42D), ZYDIS_DEFINITION(0x1, 0x42F) },
    { ZYDIS_DEFINITION(0x1, 0x42E), ZYDIS_DEFINITION(0x1, 0x430) },
    { ZYDIS_DEFINITION(0x1, 0x50C), ZYDIS_DEFINITION(0x1, 0x50E) },
    { ZYDIS_DEFINITION(0x1, 0x50D), ZYDIS_DEFINITION(0x1, 0x50F) },
    { ZYDIS_DEFINITION(0x1, 0x510), ZYDIS_DEFINITION(0x1, 0x512) },
    { ZYDIS_DEFINITION(0x1, 0x511), ZYDIS_DEFINITION(0x1, 0x513) },
    { ZYDIS_DEFINITION(0x1, 0x520), ZYDIS_DEFINITION(0x1, 0x522) },
    { ZYDIS_DEFINITION(0x1, 0x521), ZYDIS_DEFINITION(0x1, 0x523) },
    { ZYDIS_DEFINITION(0x1, 0x51C), ZYDIS_DEFINITION(0x1, 0x51E) },
    { ZYDIS_DEFINITION(0x1, 0x51D), ZYDIS_DEFINITION(0x1, 0x51F) },
    { ZYDIS_DEFINITION(0x1, 0x4F4), ZYDIS_DEFINITION(0x1, 0x4F6) },
    { ZYDIS_DEFINITION(0x1, 0x4F5), ZYDIS_DEFINITION(0x1, 0x4F7) },
    { ZYDIS_DEFINITION(0x1, 0x4F8), ZYDIS_DEFINITION(0x1, 0x4FA) },
    { ZYDIS_DEFINITION(0x1, 0x4F9), ZYDIS_DEFINITION(0x1, 0x4FB) },
    { ZYDIS_DEFINITION(0x1, 0x508), ZYDIS_DEFINITION(0x1, 0x50A) },
    { ZYDIS_DEFINITION(0x1, 0x509), ZYDIS_DEFINITION(0x1, 0x50B) },
    { ZYDIS_DEFINITION(0x1, 0x504), ZYDIS_DEFINITION(0x1, 0x506) },
    { ZYDIS_DEFINITION(0x1, 0x505), ZYDIS_DEFINITION(0x1, 0x507) },
    { ZYDIS_DEFINITION(0x1, 0x566), ZYDIS_DEFINITION(0x1, 0x568) },
    { ZYDIS_DEFINITION(0x1, 0x567), ZYDIS_DEFINITION(0x1, 0x569) },
    { ZYDIS_DEFINITION(0x1, 0x4C4), ZYDIS_DEFINITION(0x1, 0x4C5) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x572), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x573) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x574), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x575) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x576), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x577) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x578), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x579) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x57A), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x57B) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x57C), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x57D) },
    { ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x57E) },
    { ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x57F) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x580), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x581) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x582), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x583) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x584), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x585) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x586), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x587) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x588), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x589) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x58A), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x58B) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x58C), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x58D) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x58E), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x58F) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x590), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x591) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x592), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x593) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x594), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x595) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x596), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x597) },
    { ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x598) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x599), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x59A), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x59B) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x59C), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x59D) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x59E), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x59F) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x5A0), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x5A1) },
    { ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x5A2) },
    { ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x5A3) },
    { ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x5A4) },
    { ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x5A5) },
    { ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x5A6) },
    { ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x5A7) },
    { ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x5A8) },
    { ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x5A9) },
    { ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x5AA) },
    { ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x5AB) },
    { ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x5AC) },
    { ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x5AD) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x5AE), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x5AF) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x5B0), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x5B1) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x5B2), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x5B3) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x5B4), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x5B5) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x5B6), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x5B7) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x5B8), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x5B9) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x5BA), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x5BB) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x5BC), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x5BD) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x5BE), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x5BF) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x5C0), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x5C1) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x5C2), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x5C3) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x5C4), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x5C5) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x5C6), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x5C7) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x5C8), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x5C9) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x5CA), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x5CB) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x5CC), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x5CD) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x5CE), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x5CF) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x5D0), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x5D1) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x5D2), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x5D3) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x5D4), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x5D5) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x5D6), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x5D7) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x5D8), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x5D9) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x5DA), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x5DB) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x5DC), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x5DD) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x5DE), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x5DF) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x5E0), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x5E1) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x5E2), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x5E3) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x5E4), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x5E5) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x5E6), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x5E7) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x5E8), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x5E9) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x5EA), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x5EB) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x5EC), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x5ED) },
    { ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x5EE) },
    { ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x5EF) },
    { ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x5F0) },
    { ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x5F1) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x5F2), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x5F3) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x5F4), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x5F5) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x5F6), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x5F7) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x5F8), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x5F9) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x5FA), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x5FB) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x5FC), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x5FD) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x5FE), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x5FF) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x600), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x601) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x602), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x603) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x604), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x605) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x606), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x607) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x608), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x609) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x60A), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x60B) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x60C), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x60D) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x60E), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x60F) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x610), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x611) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x612), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x613) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x614), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x615) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x616), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x617) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x618), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x619) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x61A), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x61B) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x61C), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x61D) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x61E), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x61F) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x620), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x621) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x622), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x623) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x624), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x625) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x626), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x627) },
    { ZYDIS_DEFINITION(0x1, 0xD7), ZYDIS_DEFINITION(0x1, 0xD8) },
    { ZYDIS_DEFINITION(0x1, 0xCF), ZYDIS_DEFINITION(0x1, 0xD1) },
    { ZYDIS_DEFINITION(0x1, 0xD0), ZYDIS_DEFINITION(0x1, 0xD2) },
    { ZYDIS_DEFINITION(0x1, 0xD3), ZYDIS_DEFINITION(0x1, 0xD5) },
    { ZYDIS_DEFINITION(0x1, 0xD4), ZYDIS_DEFINITION(0x1, 0xD6) },
    { ZYDIS_DEFINITION(0x1, 0xC7), ZYDIS_DEFINITION(0x1, 0xC9) },
    { ZYDIS_DEFINITION(0x1, 0xC8), ZYDIS_DEFINITION(0x1, 0xCA) },
    { ZYDIS_DEFINITION(0x1, 0xCB), ZYDIS_DEFINITION(0x1, 0xCD) },
    { ZYDIS_DEFINITION(0x1, 0xCC), ZYDIS_DEFINITION(0x1, 0xCE) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x628), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x629) },
    { ZYDIS_DEFINITION(0x1, 0x99), ZYDIS_DEFINITION(0x1, 0x9A) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x62A), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x62B) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x62C), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x62D) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x62E), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x62F) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x630), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x631) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x632), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x633) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x634), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x635) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x636), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x637) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x638), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x639) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x63A), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x63B) },
    { ZYDIS_DEFINITION(0xB, 0x638), ZYDIS_DEFINITION(0xB, 0x63A) },
    { ZYDIS_DEFINITION(0xB, 0x639), ZYDIS_DEFINITION(0xB, 0x63B) },
    { ZYDIS_DEFINITION(0xB, 0x634), ZYDIS_DEFINITION(0xB, 0x636) },
    { ZYDIS_DEFINITION(0xB, 0x635), ZYDIS_DEFINITION(0xB, 0x637) },
    { ZYDIS_DEFINITION(0xB, 0x63E), ZYDIS_DEFINITION(0xB, 0x63F) },
    { ZYDIS_DEFINITION(0xB, 0x63C), ZYDIS_DEFINITION(0xB, 0x63D) },
    { ZYDIS_DEFINITION(0xB, 0xF3), ZYDIS_DEFINITION(0xB, 0xF5) },
    { ZYDIS_DEFINITION(0xB, 0xF4), ZYDIS_DEFINITION(0xB, 0xF6) },
    { ZYDIS_DEFINITION(0xB, 0xEF), ZYDIS_DEFINITION(0xB, 0xF1) },
    { ZYDIS_DEFINITION(0xB, 0xF0), ZYDIS_DEFINITION(0xB, 0xF2) },
    { ZYDIS_DEFINITION(0xB, 0x3F3), ZYDIS_DEFINITION(0xB, 0x3F5) },
    { ZYDIS_DEFINITION(0xB, 0x3F4), ZYDIS_DEFINITION(0xB, 0x3F6) },
    { ZYDIS_DEFINITION(0xB, 0x3D7), ZYDIS_DEFINITION(0xB, 0x3D9) },
    { ZYDIS_DEFINITION(0xB, 0x3D8), ZYDIS_DEFINITION(0xB, 0x3DA) },
    { ZYDIS_DEFINITION(0xB, 0x4A5), ZYDIS_DEFINITION(0xB, 0x4A6) },
    { ZYDIS_DEFINITION(0xB, 0x4AE), ZYDIS_DEFINITION(0xB, 0x4AF) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x63C), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x63D) },
    { ZYDIS_DEFINITION(0xB, 0x4A9), ZYDIS_DEFINITION(0xB, 0x4AA) },
    { ZYDIS_DEFINITION(0xB, 0x189), ZYDIS_DEFINITION(0xB, 0x18A) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x63E), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x63F) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x640), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x641) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x642), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x643) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x644), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x645) },
    { ZYDIS_DEFINITION(0xB, 0x4D2), ZYDIS_DEFINITION(0xB, 0x4D3) },
    { ZYDIS_DEFINITION(0xB, 0x2F3), ZYDIS_DEFINITION(0xB, 0x2F4) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x646), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x647) },
    { ZYDIS_DEFINITION(0xB, 0x4D6), ZYDIS_DEFINITION(0xB, 0x4D7) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x648), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x649), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x64A), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x64B), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x64C), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x64D) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x64E), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x64F) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x650), ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0xB, 0x181), ZYDIS_DEFINITION(0xB, 0x183) },
    { ZYDIS_DEFINITION(0xB, 0x182), ZYDIS_DEFINITION(0xB, 0x184) },
    { ZYDIS_DEFINITION(0xB, 0x17F), ZYDIS_DEFINITION(0xB, 0x180) },
    { ZYDIS_DEFINITION(0xB, 0x383), ZYDIS_DEFINITION(0xB, 0x385) },
    { ZYDIS_DEFINITION(0xB, 0x384), ZYDIS_DEFINITION(0xB, 0x386) },
    { ZYDIS_DEFINITION(0xB, 0x407), ZYDIS_DEFINITION(0xB, 0x409) },
    { ZYDIS_DEFINITION(0xB, 0x408), ZYDIS_DEFINITION(0xB, 0x40A) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x651), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x652) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x653), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x654) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x655), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x656) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x657), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x658) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x659), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x65A) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x65B), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x65C) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x65D), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x65E) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x65F), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x660) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x661), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x662) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x663), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x664) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x665), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x666) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x667), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x668) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x669), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x66A) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x66B), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x66C) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x66D), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x66E) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x66F), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x670) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x671), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x672) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x673), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x674) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x675), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x676) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x677), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x678) },
    { ZYDIS_DEFINITION(0xB, 0x423), ZYDIS_DEFINITION(0xB, 0x424) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x679), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x67A) },
    { ZYDIS_DEFINITION(0xB, 0x437), ZYDIS_DEFINITION(0xB, 0x438) },
    { ZYDIS_DEFINITION(0xB, 0x435), ZYDIS_DEFINITION(0xB, 0x436) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x67B), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x67C) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x67D), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x67E) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x67F), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x680) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x681), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x682) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x683), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x684) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x685), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x686) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x687), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x688) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x689), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x68A) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x68B), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x68C) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x68D), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x68E) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x68F), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x690) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x691), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x692) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x693), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x694) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x695), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x696) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x697), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x698) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x699), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x69A) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x69B), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x69C) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x69D), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x69E) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x69F), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x6A0) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x6A1), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x6A2) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x6A3), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x6A4) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x6A5), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x6A6) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x6A7), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x6A8) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x6A9), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x6AA) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x6AB), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x6AC) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x6AD), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x6AE) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x6AF), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x6B0) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x6B1), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x6B2) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x6B3), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x6B4) },
    { ZYDIS_DEFINITION(0xB, 0xD9), ZYDIS_DEFINITION(0xB, 0xDA) },
    { ZYDIS_DEFINITION(0x1, 0x36F), ZYDIS_DEFINITION(0x1, 0x370) },
    { ZYDIS_DEFINITION(0x1, 0x371), ZYDIS_DEFINITION(0x1, 0x372) },
    { ZYDIS_DEFINITION(0x1, 0x36B), ZYDIS_DEFINITION(0x1, 0x36D) },
    { ZYDIS_DEFINITION(0x1, 0x36C), ZYDIS_DEFINITION(0x1, 0x36E) },
    { ZYDIS_DEFINITION(0x1, 0x367), ZYDIS_DEFINITION(0x1, 0x369) },
    { ZYDIS_DEFINITION(0x1, 0x368), ZYDIS_DEFINITION(0x1, 0x36A) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x6B5), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x6B6) },
    { ZYDIS_DEFINITION(0x1, 0x155), ZYDIS_DEFINITION(0x1, 0x156) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x6B7), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x6B8) },
    { ZYDIS_DEFINITION(0x1, 0x171), ZYDIS_DEFINITION(0x1, 0x172) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x6B9), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x6BA) },
    { ZYDIS_DEFINITION(0x1, 0x15D), ZYDIS_DEFINITION(0x1, 0x15E) },
    { ZYDIS_DEFINITION(0x1, 0x669), ZYDIS_DEFINITION(0x1, 0x66A) },
    { ZYDIS_DEFINITION(0x1, 0x644), ZYDIS_DEFINITION(0x1, 0x645) },
    { ZYDIS_DEFINITION(0x1, 0x632), ZYDIS_DEFINITION(0x1, 0x633) },
    { ZYDIS_DEFINITION(0x1, 0xBD), ZYDIS_DEFINITION(0x1, 0xBE) },
    { ZYDIS_DEFINITION(0x1, 0x391), ZYDIS_DEFINITION(0x1, 0x392) },
    { ZYDIS_DEFINITION(0x1, 0x157), ZYDIS_DEFINITION(0x1, 0x158) },
    { ZYDIS_DEFINITION(0x1, 0x163), ZYDIS_DEFINITION(0x1, 0x165) },
    { ZYDIS_DEFINITION(0x1, 0x164), ZYDIS_DEFINITION(0x1, 0x166) },
    { ZYDIS_DEFINITION(0x1, 0x676), ZYDIS_DEFINITION(0x1, 0x677) },
    { ZYDIS_DEFINITION(0x1, 0x317), ZYDIS_DEFINITION(0x1, 0x318) },
    { ZYDIS_DEFINITION(0x1, 0x17D), ZYDIS_DEFINITION(0x1, 0x17E) },
    { ZYDIS_DEFINITION(0x1, 0x30B), ZYDIS_DEFINITION(0x1, 0x30C) },
    { ZYDIS_DEFINITION(0x1, 0x33D), ZYDIS_DEFINITION(0x1, 0x33F) },
    { ZYDIS_DEFINITION(0x1, 0x33E), ZYDIS_DEFINITION(0x1, 0x340) },
    { ZYDIS_DEFINITION(0xB, 0x58A), ZYDIS_DEFINITION(0xB, 0x58C) },
    { ZYDIS_DEFINITION(0xB, 0x58B), ZYDIS_DEFINITION(0xB, 0x58D) },
    { ZYDIS_DEFINITION(0x1, 0x35F), ZYDIS_DEFINITION(0x1, 0x360) },
    { ZYDIS_DEFINITION(0x1, 0x341), ZYDIS_DEFINITION(0x1, 0x343) },
    { ZYDIS_DEFINITION(0x1, 0x342), ZYDIS_DEFINITION(0x1, 0x344) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x6BB), ZYDIS_INVALID },
    { ZYDIS_INVALID, ZYDIS_DEFINITION(0x1, 0x15) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x6BC), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x6BD), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x6BE), ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0xB, 0x111), ZYDIS_DEFINITION(0xB, 0x112) },
    { ZYDIS_DEFINITION(0x1, 0x117), ZYDIS_DEFINITION(0x1, 0x119) },
    { ZYDIS_DEFINITION(0x1, 0x118), ZYDIS_DEFINITION(0x1, 0x11A) },
    { ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x6BF) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x6C0), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x6C1) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x6C2), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x6C3) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x6C4), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x6C5) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x6C6), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x6C7) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x6C8), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x6C9), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x6CA), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x6CB) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x6CC), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x6CD) },
    { ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x6CE) },
    { ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x6CF) },
    { ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x6D0) },
    { ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x6D1) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x6D2), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x6D3) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x6D4), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x6D5) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x6D6), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x6D7) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x6D8), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x6D9) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x6DA), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x6DB) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x6DC), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x6DD) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x6DE), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x6DF) },
    { ZYDIS_DEFINITION(0x1, 0x85), ZYDIS_DEFINITION(0x1, 0x86) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x6E0), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x6E1) },
    { ZYDIS_DEFINITION(0x1, 0x93), ZYDIS_DEFINITION(0x1, 0x94) },
    { ZYDIS_DEFINITION(0x1, 0x363), ZYDIS_DEFINITION(0x1, 0x364) },
    { ZYDIS_DEFINITION(0x1, 0x365), ZYDIS_DEFINITION(0x1, 0x366) },
    { ZYDIS_DEFINITION(0x1, 0x331), ZYDIS_DEFINITION(0x1, 0x333) },
    { ZYDIS_DEFINITION(0x1, 0x332), ZYDIS_DEFINITION(0x1, 0x334) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x6E2), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x6E3) },
    { ZYDIS_DEFINITION(0x1, 0x14F), ZYDIS_DEFINITION(0x1, 0x150) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x6E4), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x6E5) },
    { ZYDIS_DEFINITION(0x1, 0x16B), ZYDIS_DEFINITION(0x1, 0x16C) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x6E6), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x6E7) },
    { ZYDIS_DEFINITION(0x1, 0x147), ZYDIS_DEFINITION(0x1, 0x148) },
    { ZYDIS_DEFINITION(0x1, 0x667), ZYDIS_DEFINITION(0x1, 0x668) },
    { ZYDIS_DEFINITION(0x1, 0xBB), ZYDIS_DEFINITION(0x1, 0xBC) },
    { ZYDIS_DEFINITION(0x1, 0x38F), ZYDIS_DEFINITION(0x1, 0x390) },
    { ZYDIS_DEFINITION(0x1, 0x149), ZYDIS_DEFINITION(0x1, 0x14A) },
    { ZYDIS_DEFINITION(0x1, 0x674), ZYDIS_DEFINITION(0x1, 0x675) },
    { ZYDIS_DEFINITION(0x1, 0x315), ZYDIS_DEFINITION(0x1, 0x316) },
    { ZYDIS_DEFINITION(0x1, 0x17B), ZYDIS_DEFINITION(0x1, 0x17C) },
    { ZYDIS_DEFINITION(0x1, 0x309), ZYDIS_DEFINITION(0x1, 0x30A) },
    { ZYDIS_DEFINITION(0xB, 0x58E), ZYDIS_DEFINITION(0xB, 0x590) },
    { ZYDIS_DEFINITION(0xB, 0x58F), ZYDIS_DEFINITION(0xB, 0x591) },
    { ZYDIS_DEFINITION(0x1, 0x2E3), ZYDIS_DEFINITION(0x1, 0x2E5) },
    { ZYDIS_DEFINITION(0x1, 0x2E4), ZYDIS_DEFINITION(0x1, 0x2E6) },
    { ZYDIS_DEFINITION(0x1, 0x2EB), ZYDIS_DEFINITION(0x1, 0x2ED) },
    { ZYDIS_DEFINITION(0x1, 0x2EC), ZYDIS_DEFINITION(0x1, 0x2EE) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x6E8), ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0x1, 0x3C), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x6E9), ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0x1, 0x3E), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x6EA), ZYDIS_INVALID },
    { ZYDIS_INVALID, ZYDIS_DEFINITION(0x1, 0x14) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x6EB), ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0xB, 0x10F), ZYDIS_DEFINITION(0xB, 0x110) },
    { ZYDIS_DEFINITION(0x1, 0xC3), ZYDIS_DEFINITION(0x1, 0xC5) },
    { ZYDIS_DEFINITION(0x1, 0xC4), ZYDIS_DEFINITION(0x1, 0xC6) },
    { ZYDIS_DEFINITION(0x1, 0x12B), ZYDIS_DEFINITION(0x1, 0x12D) },
    { ZYDIS_DEFINITION(0x1, 0x12C), ZYDIS_DEFINITION(0x1, 0x12E) },
    { ZYDIS_INVALID, ZYDIS_DEFINITION(0x1, 0x2F5) },
    { ZYDIS_INVALID, ZYDIS_DEFINITION(0x1, 0x2F6) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x6EC), ZYDIS_INVALID },
    { ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x6ED) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x6EE), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x6EF) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x6F0), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x6F1) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x6F2), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x6F3) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x6F4), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x6F5) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x6F6), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x6F7), ZYDIS_INVALID },
    { ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x6F8) },
    { ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x6F9) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x6FA), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x6FB), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x6FC), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x6FD), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x6FE) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x6FF), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x700) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x701), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x702) },
    { ZYDIS_DEFINITION(0x1, 0x7F), ZYDIS_DEFINITION(0x1, 0x80) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x703), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x704) },
    { ZYDIS_DEFINITION(0x1, 0x79), ZYDIS_DEFINITION(0x1, 0x7A) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x705), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x706) },
    { ZYDIS_DEFINITION(0x1, 0x9F), ZYDIS_DEFINITION(0x1, 0xA0) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x707), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x708) },
    { ZYDIS_DEFINITION(0xB, 0x8D), ZYDIS_DEFINITION(0xB, 0x8E) },
    { ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODE_COMPACT, 0x120) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_REG, 0x55), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_REG, 0x56) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_REG, 0x57), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_REG, 0x58) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_REG, 0x59), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_REG, 0x5A) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_REG, 0x5B), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_REG, 0x5C) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_REG, 0x5D), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_REG, 0x5E) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_REG, 0x5F), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_REG, 0x60) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_REG, 0x61), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_REG, 0x62) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_REG, 0x63), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_REG, 0x64) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_REG, 0x65), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_REG, 0x66) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_REG, 0x67), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_REG, 0x68) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_REG, 0x69), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_REG, 0x6A) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_REG, 0x6B), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_REG, 0x6C) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_REG, 0x6D), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_REG, 0x6E) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_REG, 0x6F), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_REG, 0x70) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_REG, 0x71), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_REG, 0x72) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_REG, 0x73), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_REG, 0x74) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_REG, 0x75), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_REG, 0x76) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_REG, 0x77), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_REG, 0x78) }
};

const ZydisDecoderTreeNode FILTERS_MODRM_REG[][8] =
{
    { ZYDIS_DEFINITION(0x1, 0x6CD), ZYDIS_DEFINITION(0x1, 0x6EB), ZYDIS_DEFINITION(0x1, 0x2D5), ZYDIS_DEFINITION(0x1, 0x2EC), ZYDIS_DEFINITION(0x1, 0x73C), ZYDIS_DEFINITION(0x1, 0x73E), ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0x1, 0x6CE), ZYDIS_DEFINITION(0x1, 0x6EC), ZYDIS_DEFINITION(0x1, 0x2D6), ZYDIS_DEFINITION(0x1, 0x2ED), ZYDIS_DEFINITION(0x1, 0x73D), ZYDIS_DEFINITION(0x1, 0x73F), ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_RM, 0x0), ZYDIS_DEFINITION(0x1, 0x6CF), ZYDIS_INVALID, ZYDIS_DEFINITION(0x1, 0x2D7), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_RM, 0x1) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_RM, 0x2), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_RM, 0x3), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_RM, 0x4), ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_RM, 0x5), ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_RM, 0x6) },
    { ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_RM, 0x7), ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_RM, 0x8), ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_RM, 0x9), ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_RM, 0xA) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_RM, 0xB), ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_RM, 0xC), ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_RM, 0xD) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODE_COMPACT, 0x1A), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODE_COMPACT, 0x1B), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODE_COMPACT, 0x1C), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODE_COMPACT, 0x1D), ZYDIS_DEFINITION(0x1, 0x6D0), ZYDIS_INVALID, ZYDIS_DEFINITION(0x1, 0x2D8), ZYDIS_DEFINITION(0x1, 0x25E) },
    { ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_DEFINITION(0x1, 0x635), ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0x1, 0x532), ZYDIS_DEFINITION(0x1, 0x539), ZYDIS_DEFINITION(0x1, 0x53A), ZYDIS_DEFINITION(0x1, 0x532), ZYDIS_DEFINITION(0x1, 0x532), ZYDIS_DEFINITION(0x1, 0x532), ZYDIS_DEFINITION(0x1, 0x532), ZYDIS_DEFINITION(0x1, 0x532) },
    { ZYDIS_DEFINITION(0x1, 0x3B8), ZYDIS_DEFINITION(0x1, 0x3B9), ZYDIS_DEFINITION(0x1, 0x3BA), ZYDIS_DEFINITION(0x1, 0x3BB), ZYDIS_DEFINITION(0x1, 0x3BC), ZYDIS_DEFINITION(0x1, 0x3BD), ZYDIS_DEFINITION(0x1, 0x3BE), ZYDIS_DEFINITION(0x1, 0x3BF) },
    { ZYDIS_DEFINITION(0x1, 0x535), ZYDIS_DEFINITION(0x1, 0x536), ZYDIS_DEFINITION(0x1, 0x537), ZYDIS_DEFINITION(0x1, 0x538), ZYDIS_DEFINITION(0x1, 0x3C0), ZYDIS_DEFINITION(0x1, 0x3C1), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODE_IPREFETCH, 0x0), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODE_IPREFETCH, 0x1) },
    { ZYDIS_DEFINITION(0x1, 0xBC), ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0x1, 0x3D5), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODE_COMPACT, 0x2B), ZYDIS_DEFINITION(0x1, 0x3D6), ZYDIS_DEFINITION(0x1, 0x3D7), ZYDIS_DEFINITION(0x1, 0x3D8), ZYDIS_DEFINITION(0x1, 0x3D9), ZYDIS_DEFINITION(0x1, 0x3DA), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_RM, 0xE) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODE_KNC, 0x0), ZYDIS_DEFINITION(0x1, 0x3E6), ZYDIS_DEFINITION(0x1, 0x3E6), ZYDIS_DEFINITION(0x1, 0x3E6), ZYDIS_DEFINITION(0x1, 0x3E6), ZYDIS_DEFINITION(0x1, 0x3E6), ZYDIS_DEFINITION(0x1, 0x3E6), ZYDIS_DEFINITION(0x1, 0x3E6) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODE_KNC, 0x1), ZYDIS_DEFINITION(0x1, 0x3E8), ZYDIS_DEFINITION(0x1, 0x3E8), ZYDIS_DEFINITION(0x1, 0x3E8), ZYDIS_DEFINITION(0x1, 0x3E8), ZYDIS_DEFINITION(0x1, 0x3E8), ZYDIS_DEFINITION(0x1, 0x3E8), ZYDIS_DEFINITION(0x1, 0x3E8) },
    { ZYDIS_DEFINITION(0x1, 0x4E), ZYDIS_DEFINITION(0x1, 0x46), ZYDIS_DEFINITION(0x1, 0x4F), ZYDIS_DEFINITION(0x1, 0x47), ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_RM, 0xF), ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_DEFINITION(0xB, 0x584), ZYDIS_INVALID, ZYDIS_DEFINITION(0xB, 0x571), ZYDIS_INVALID, ZYDIS_DEFINITION(0xB, 0x564), ZYDIS_INVALID },
    { ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_DEFINITION(0xB, 0x585), ZYDIS_INVALID, ZYDIS_DEFINITION(0xB, 0x572), ZYDIS_INVALID, ZYDIS_DEFINITION(0xB, 0x565), ZYDIS_INVALID },
    { ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_DEFINITION(0xB, 0x577), ZYDIS_INVALID, ZYDIS_DEFINITION(0xB, 0x56B), ZYDIS_INVALID, ZYDIS_DEFINITION(0xB, 0x557), ZYDIS_INVALID },
    { ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_DEFINITION(0xB, 0x578), ZYDIS_INVALID, ZYDIS_DEFINITION(0xB, 0x56C), ZYDIS_INVALID, ZYDIS_DEFINITION(0xB, 0x558), ZYDIS_INVALID },
    { ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_DEFINITION(0xB, 0x57E), ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_DEFINITION(0xB, 0x55E), ZYDIS_INVALID },
    { ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_DEFINITION(0xB, 0x57F), ZYDIS_DEFINITION(0xB, 0x57D), ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_DEFINITION(0xB, 0x55F), ZYDIS_DEFINITION(0xB, 0x55D) },
    { ZYDIS_DEFINITION(0x13, 0x17F), ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_RM, 0x10), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_RM, 0x11), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_RM, 0x12), ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_RM, 0x13), ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_RM, 0x14), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_RM, 0x15), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_RM, 0x16), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_RM, 0x17), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_RM, 0x18), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_RM, 0x19), ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_DEFINITION(0x1, 0x2CE), ZYDIS_DEFINITION(0x1, 0x2FB), ZYDIS_DEFINITION(0x1, 0x689) },
    { ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_DEFINITION(0x1, 0x724), ZYDIS_DEFINITION(0x1, 0x494) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODE_COMPACT, 0x52), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODE_COMPACT, 0x53), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODE_COMPACT, 0x54), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODE_COMPACT, 0x55), ZYDIS_DEFINITION(0x1, 0x5AC), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x29), ZYDIS_DEFINITION(0x1, 0x732), ZYDIS_INVALID },
    { ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_DEFINITION(0x1, 0x733), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x2A), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x2B), ZYDIS_DEFINITION(0x1, 0x2C9), ZYDIS_DEFINITION(0x1, 0x6DE), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x2C), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x2D), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x2E), ZYDIS_DEFINITION(0x1, 0xBD) },
    { ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_DEFINITION(0x1, 0xC4), ZYDIS_DEFINITION(0x1, 0xBE) },
    { ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_DEFINITION(0x1, 0x5AD), ZYDIS_INVALID, ZYDIS_DEFINITION(0x1, 0xC1), ZYDIS_INVALID },
    { ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_DEFINITION(0xB, 0xA1), ZYDIS_DEFINITION(0xB, 0xAD), ZYDIS_DEFINITION(0xB, 0xA9), ZYDIS_DEFINITION(0xB, 0xA3) },
    { ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_DEFINITION(0xB, 0xA2), ZYDIS_DEFINITION(0xB, 0xAE), ZYDIS_DEFINITION(0xB, 0xAA), ZYDIS_DEFINITION(0xB, 0xA4) },
    { ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_DEFINITION(0x1, 0x604), ZYDIS_DEFINITION(0x1, 0x605) },
    { ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODE_COMPACT, 0x56), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODE_COMPACT, 0x57) },
    { ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODE_COMPACT, 0x58), ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x30), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x31), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x32), ZYDIS_DEFINITION(0x1, 0x746), ZYDIS_DEFINITION(0x1, 0x747) },
    { ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_DEFINITION(0x1, 0x741), ZYDIS_INVALID },
    { ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_DEFINITION(0x1, 0x754), ZYDIS_INVALID },
    { ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x8D), ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x8E), ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x8F), ZYDIS_INVALID },
    { ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x90), ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x91), ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x92), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0xE1), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0xE2), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0xE3), ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0xE4), ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0xE5), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0xE6), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0xE7), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0xE8), ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0xE9), ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0xEA), ZYDIS_INVALID },
    { ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0xEB), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x9C), ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0xEC), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x9E) },
    { ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0xED), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x9F), ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0xEE), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0xA0) },
    { ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_RM, 0x22), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_RM, 0x23), ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_RM, 0x24), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_RM, 0x25), ZYDIS_INVALID },
    { ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_RM, 0x26), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_RM, 0x27), ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_RM, 0x28), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_RM, 0x29), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x43E), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x43F), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x440), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x441), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x442), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x443), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x444), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x445) },
    { ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x3CC), ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x3CD), ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x3CE), ZYDIS_INVALID },
    { ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x3CF), ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x3D0), ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x3D1), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_RM, 0x2E), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_RM, 0x2F), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_RM, 0x30), ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_RM, 0x31), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_RM, 0x32), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_RM, 0x33), ZYDIS_INVALID },
    { ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x446) },
    { ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x447) },
    { ZYDIS_DEFINITION(0xD, 0x28), ZYDIS_DEFINITION(0xD, 0x3F8), ZYDIS_DEFINITION(0xD, 0x12), ZYDIS_DEFINITION(0xD, 0x64F), ZYDIS_DEFINITION(0xD, 0x5E), ZYDIS_DEFINITION(0xD, 0x6F8), ZYDIS_DEFINITION(0xD, 0x77E), ZYDIS_DEFINITION(0xD, 0xF1) },
    { ZYDIS_DEFINITION(0xD, 0x29), ZYDIS_DEFINITION(0xD, 0x3F9), ZYDIS_DEFINITION(0xD, 0x13), ZYDIS_DEFINITION(0xD, 0x650), ZYDIS_DEFINITION(0xD, 0x5F), ZYDIS_DEFINITION(0xD, 0x6F9), ZYDIS_DEFINITION(0xD, 0x77F), ZYDIS_DEFINITION(0xD, 0xF2) },
    { ZYDIS_DEFINITION(0xE, 0x2A), ZYDIS_DEFINITION(0xE, 0x3FA), ZYDIS_DEFINITION(0xE, 0x14), ZYDIS_DEFINITION(0xE, 0x651), ZYDIS_DEFINITION(0xE, 0x60), ZYDIS_DEFINITION(0xE, 0x6FA), ZYDIS_DEFINITION(0xE, 0x780), ZYDIS_DEFINITION(0xE, 0xF3) },
    { ZYDIS_DEFINITION(0xE, 0x2B), ZYDIS_DEFINITION(0xE, 0x3FB), ZYDIS_DEFINITION(0xE, 0x15), ZYDIS_DEFINITION(0xE, 0x652), ZYDIS_DEFINITION(0xE, 0x61), ZYDIS_DEFINITION(0xE, 0x6FB), ZYDIS_DEFINITION(0xE, 0x781), ZYDIS_DEFINITION(0xE, 0xF4) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODE_COMPACT, 0xBF), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODE_COMPACT, 0xC0), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODE_COMPACT, 0xC1), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODE_COMPACT, 0xC2), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODE_COMPACT, 0xC3), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODE_COMPACT, 0xC4), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODE_COMPACT, 0xC5), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODE_COMPACT, 0xC6) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODE_COMPACT, 0xC7), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODE_COMPACT, 0xC8), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODE_COMPACT, 0xC9), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODE_COMPACT, 0xCA), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODE_COMPACT, 0xCB), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODE_COMPACT, 0xCC), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODE_COMPACT, 0xCD), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODE_COMPACT, 0xCE) },
    { ZYDIS_DEFINITION(0xD, 0x2E), ZYDIS_DEFINITION(0xD, 0x3FE), ZYDIS_DEFINITION(0xD, 0x18), ZYDIS_DEFINITION(0xD, 0x655), ZYDIS_DEFINITION(0xD, 0x64), ZYDIS_DEFINITION(0xD, 0x6FE), ZYDIS_DEFINITION(0xD, 0x784), ZYDIS_DEFINITION(0xD, 0xF7) },
    { ZYDIS_DEFINITION(0xD, 0x2F), ZYDIS_DEFINITION(0xD, 0x3FF), ZYDIS_DEFINITION(0xD, 0x19), ZYDIS_DEFINITION(0xD, 0x656), ZYDIS_DEFINITION(0xD, 0x65), ZYDIS_DEFINITION(0xD, 0x6FF), ZYDIS_DEFINITION(0xD, 0x785), ZYDIS_DEFINITION(0xD, 0xF8) },
    { ZYDIS_DEFINITION(0x1, 0x523), ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0x1, 0x524), ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x462), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x463), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x464), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x465), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x466), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x467), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x468) },
    { ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x469), ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x46A), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x46B), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x46C), ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x48D), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x48E), ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0xB, 0x610), ZYDIS_DEFINITION(0xB, 0x61C), ZYDIS_DEFINITION(0xB, 0x5DF), ZYDIS_DEFINITION(0xB, 0x5EF), ZYDIS_DEFINITION(0xB, 0x69A), ZYDIS_DEFINITION(0xB, 0x6B6), ZYDIS_DEFINITION(0xB, 0x69B), ZYDIS_DEFINITION(0xB, 0x638) },
    { ZYDIS_DEFINITION(0xB, 0x611), ZYDIS_DEFINITION(0xB, 0x61D), ZYDIS_DEFINITION(0xB, 0x5E0), ZYDIS_DEFINITION(0xB, 0x5F0), ZYDIS_DEFINITION(0xB, 0x69C), ZYDIS_DEFINITION(0xB, 0x6B7), ZYDIS_DEFINITION(0xB, 0x69D), ZYDIS_DEFINITION(0xB, 0x639) },
    { ZYDIS_DEFINITION(0xB, 0x612), ZYDIS_DEFINITION(0xB, 0x61E), ZYDIS_DEFINITION(0xB, 0x5E1), ZYDIS_DEFINITION(0xB, 0x5F1), ZYDIS_DEFINITION(0xB, 0x69E), ZYDIS_DEFINITION(0xB, 0x6B8), ZYDIS_DEFINITION(0xB, 0x69F), ZYDIS_DEFINITION(0xB, 0x63A) },
    { ZYDIS_DEFINITION(0xB, 0x613), ZYDIS_DEFINITION(0xB, 0x61F), ZYDIS_DEFINITION(0xB, 0x5E2), ZYDIS_DEFINITION(0xB, 0x5F2), ZYDIS_DEFINITION(0xB, 0x6A0), ZYDIS_DEFINITION(0xB, 0x6B9), ZYDIS_DEFINITION(0xB, 0x6A1), ZYDIS_DEFINITION(0xB, 0x63B) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x499), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x49A), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x49B), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x49C), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x49D), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x49E), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x49F), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x4A0) },
    { ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x4CA), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x4CB), ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_RM, 0x34), ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x4DE), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x4DF), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x4E0), ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x515), ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x516), ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x517), ZYDIS_INVALID },
    { ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x518), ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x519), ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x51A), ZYDIS_INVALID },
    { ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x51B), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x51C), ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x51D), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x51E) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x59A), ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x60E), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x60F) },
    { ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x627), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x628) },
    { ZYDIS_DEFINITION(0xD, 0x31B), ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_RM, 0x3D) },
    { ZYDIS_DEFINITION(0xD, 0x31C), ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0xE, 0x31D), ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_RM, 0x3E) },
    { ZYDIS_DEFINITION(0xE, 0x31E), ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0x1, 0x614), ZYDIS_DEFINITION(0x1, 0x620), ZYDIS_DEFINITION(0x1, 0x5E3), ZYDIS_DEFINITION(0x1, 0x5F3), ZYDIS_DEFINITION(0x1, 0x6A2), ZYDIS_DEFINITION(0x1, 0x6BA), ZYDIS_DEFINITION(0x1, 0x6A3), ZYDIS_DEFINITION(0x1, 0x63C) },
    { ZYDIS_DEFINITION(0x1, 0x615), ZYDIS_DEFINITION(0x1, 0x621), ZYDIS_DEFINITION(0x1, 0x5E4), ZYDIS_DEFINITION(0x1, 0x5F4), ZYDIS_DEFINITION(0x1, 0x6A4), ZYDIS_DEFINITION(0x1, 0x6BB), ZYDIS_DEFINITION(0x1, 0x6A5), ZYDIS_DEFINITION(0x1, 0x63D) },
    { ZYDIS_DEFINITION(0x1, 0x616), ZYDIS_DEFINITION(0x1, 0x622), ZYDIS_DEFINITION(0x1, 0x5E5), ZYDIS_DEFINITION(0x1, 0x5F5), ZYDIS_DEFINITION(0x1, 0x6A6), ZYDIS_DEFINITION(0x1, 0x6BC), ZYDIS_DEFINITION(0x1, 0x6A7), ZYDIS_DEFINITION(0x1, 0x63E) },
    { ZYDIS_DEFINITION(0x1, 0x617), ZYDIS_DEFINITION(0x1, 0x623), ZYDIS_DEFINITION(0x1, 0x5E6), ZYDIS_DEFINITION(0x1, 0x5F6), ZYDIS_DEFINITION(0x1, 0x6A8), ZYDIS_DEFINITION(0x1, 0x6BD), ZYDIS_DEFINITION(0x1, 0x6A9), ZYDIS_DEFINITION(0x1, 0x63F) },
    { ZYDIS_DEFINITION(0x1, 0x618), ZYDIS_DEFINITION(0x1, 0x624), ZYDIS_DEFINITION(0x1, 0x5E7), ZYDIS_DEFINITION(0x1, 0x5F7), ZYDIS_DEFINITION(0x1, 0x6AA), ZYDIS_DEFINITION(0x1, 0x6BE), ZYDIS_DEFINITION(0x1, 0x6AB), ZYDIS_DEFINITION(0x1, 0x640) },
    { ZYDIS_DEFINITION(0x1, 0x619), ZYDIS_DEFINITION(0x1, 0x625), ZYDIS_DEFINITION(0x1, 0x5E8), ZYDIS_DEFINITION(0x1, 0x5F8), ZYDIS_DEFINITION(0x1, 0x6AC), ZYDIS_DEFINITION(0x1, 0x6BF), ZYDIS_DEFINITION(0x1, 0x6AD), ZYDIS_DEFINITION(0x1, 0x641) },
    { ZYDIS_DEFINITION(0x1, 0x61A), ZYDIS_DEFINITION(0x1, 0x626), ZYDIS_DEFINITION(0x1, 0x5E9), ZYDIS_DEFINITION(0x1, 0x5F9), ZYDIS_DEFINITION(0x1, 0x6AE), ZYDIS_DEFINITION(0x1, 0x6C0), ZYDIS_DEFINITION(0x1, 0x6AF), ZYDIS_DEFINITION(0x1, 0x642) },
    { ZYDIS_DEFINITION(0x1, 0x61B), ZYDIS_DEFINITION(0x1, 0x627), ZYDIS_DEFINITION(0x1, 0x5EA), ZYDIS_DEFINITION(0x1, 0x5FA), ZYDIS_DEFINITION(0x1, 0x6B0), ZYDIS_DEFINITION(0x1, 0x6C1), ZYDIS_DEFINITION(0x1, 0x6B1), ZYDIS_DEFINITION(0x1, 0x643) },
    { ZYDIS_DEFINITION(0x1, 0x183), ZYDIS_DEFINITION(0x1, 0x1DA), ZYDIS_DEFINITION(0x1, 0x193), ZYDIS_DEFINITION(0x1, 0x199), ZYDIS_DEFINITION(0x1, 0x1FF), ZYDIS_DEFINITION(0x1, 0x204), ZYDIS_DEFINITION(0x1, 0x1A2), ZYDIS_DEFINITION(0x1, 0x1A7) },
    { ZYDIS_DEFINITION(0x1, 0x184), ZYDIS_DEFINITION(0x1, 0x1DB), ZYDIS_DEFINITION(0x1, 0x194), ZYDIS_DEFINITION(0x1, 0x19A), ZYDIS_DEFINITION(0x1, 0x200), ZYDIS_DEFINITION(0x1, 0x205), ZYDIS_DEFINITION(0x1, 0x1A3), ZYDIS_DEFINITION(0x1, 0x1A8) },
    { ZYDIS_DEFINITION(0x1, 0x1CC), ZYDIS_DEFINITION(0x1, 0x211), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_RM, 0x3F), ZYDIS_DEFINITION(0x1, 0x1FE), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_RM, 0x40), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_RM, 0x41), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_RM, 0x42), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_RM, 0x43) },
    { ZYDIS_DEFINITION(0x1, 0x1CD), ZYDIS_INVALID, ZYDIS_DEFINITION(0x1, 0x1F5), ZYDIS_DEFINITION(0x1, 0x1F8), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_OPERAND_SIZE, 0x21), ZYDIS_DEFINITION(0x1, 0x1D1), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_OPERAND_SIZE, 0x22), ZYDIS_DEFINITION(0x1, 0x1E4) },
    { ZYDIS_DEFINITION(0x1, 0x18B), ZYDIS_DEFINITION(0x1, 0x18D), ZYDIS_DEFINITION(0x1, 0x18C), ZYDIS_DEFINITION(0x1, 0x192), ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_RM, 0x44), ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0x1, 0x1B0), ZYDIS_DEFINITION(0x1, 0x1BD), ZYDIS_DEFINITION(0x1, 0x1B2), ZYDIS_DEFINITION(0x1, 0x1B4), ZYDIS_DEFINITION(0x1, 0x1C8), ZYDIS_DEFINITION(0x1, 0x1CA), ZYDIS_DEFINITION(0x1, 0x1B6), ZYDIS_DEFINITION(0x1, 0x1B8) },
    { ZYDIS_DEFINITION(0x1, 0x18E), ZYDIS_DEFINITION(0x1, 0x190), ZYDIS_DEFINITION(0x1, 0x18F), ZYDIS_DEFINITION(0x1, 0x191), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_RM, 0x45), ZYDIS_DEFINITION(0x1, 0x20B), ZYDIS_DEFINITION(0x1, 0x197), ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0x1, 0x1BA), ZYDIS_DEFINITION(0x1, 0x1C5), ZYDIS_DEFINITION(0x1, 0x1C0), ZYDIS_DEFINITION(0x1, 0x1C2), ZYDIS_INVALID, ZYDIS_DEFINITION(0x1, 0x1CE), ZYDIS_INVALID, ZYDIS_DEFINITION(0x1, 0x1F9) },
    { ZYDIS_DEFINITION(0x1, 0x185), ZYDIS_DEFINITION(0x1, 0x1DC), ZYDIS_DEFINITION(0x1, 0x195), ZYDIS_DEFINITION(0x1, 0x19B), ZYDIS_DEFINITION(0x1, 0x206), ZYDIS_DEFINITION(0x1, 0x201), ZYDIS_DEFINITION(0x1, 0x1A9), ZYDIS_DEFINITION(0x1, 0x1A4) },
    { ZYDIS_DEFINITION(0x1, 0x186), ZYDIS_DEFINITION(0x1, 0x1DD), ZYDIS_DEFINITION(0x1, 0x196), ZYDIS_DEFINITION(0x1, 0x19C), ZYDIS_DEFINITION(0x1, 0x202), ZYDIS_DEFINITION(0x1, 0x207), ZYDIS_DEFINITION(0x1, 0x1A5), ZYDIS_DEFINITION(0x1, 0x1AA) },
    { ZYDIS_DEFINITION(0x1, 0x1AE), ZYDIS_DEFINITION(0x1, 0x212), ZYDIS_DEFINITION(0x1, 0x1F6), ZYDIS_DEFINITION(0x1, 0x1FA), ZYDIS_DEFINITION(0x1, 0x20A), ZYDIS_DEFINITION(0x1, 0x20D), ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0x1, 0x1CF), ZYDIS_DEFINITION(0x1, 0x1C6), ZYDIS_DEFINITION(0x1, 0x1F7), ZYDIS_DEFINITION(0x1, 0x1FB), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_OPERAND_SIZE, 0x23), ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_OPERAND_SIZE, 0x24), ZYDIS_DEFINITION(0x1, 0x1E7) },
    { ZYDIS_DEFINITION(0x1, 0x187), ZYDIS_DEFINITION(0x1, 0x1DE), ZYDIS_DEFINITION(0x1, 0x19D), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_RM, 0x46), ZYDIS_DEFINITION(0x1, 0x208), ZYDIS_DEFINITION(0x1, 0x203), ZYDIS_DEFINITION(0x1, 0x1AB), ZYDIS_DEFINITION(0x1, 0x1A6) },
    { ZYDIS_DEFINITION(0x1, 0x1B1), ZYDIS_DEFINITION(0x1, 0x1BE), ZYDIS_DEFINITION(0x1, 0x1B3), ZYDIS_DEFINITION(0x1, 0x1B5), ZYDIS_DEFINITION(0x1, 0x1C9), ZYDIS_DEFINITION(0x1, 0x1CB), ZYDIS_DEFINITION(0x1, 0x1B7), ZYDIS_DEFINITION(0x1, 0x1B9) },
    { ZYDIS_DEFINITION(0x1, 0x1AF), ZYDIS_DEFINITION(0x1, 0x213), ZYDIS_DEFINITION(0x1, 0x1FC), ZYDIS_DEFINITION(0x1, 0x1FD), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_RM, 0x47), ZYDIS_DEFINITION(0x1, 0x20C), ZYDIS_DEFINITION(0x1, 0x198), ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0x1, 0x1BB), ZYDIS_DEFINITION(0x1, 0x1C7), ZYDIS_DEFINITION(0x1, 0x1C1), ZYDIS_DEFINITION(0x1, 0x1C3), ZYDIS_DEFINITION(0x1, 0x188), ZYDIS_DEFINITION(0x1, 0x1BC), ZYDIS_DEFINITION(0x1, 0x189), ZYDIS_DEFINITION(0x1, 0x1C4) },
    { ZYDIS_DEFINITION(0xD, 0x71A), ZYDIS_DEFINITION(0xD, 0x71B), ZYDIS_DEFINITION(0x1, 0x3EA), ZYDIS_DEFINITION(0x1, 0x3B2), ZYDIS_DEFINITION(0x1, 0x3A2), ZYDIS_DEFINITION(0x1, 0x234), ZYDIS_DEFINITION(0x1, 0x15F), ZYDIS_DEFINITION(0x1, 0x22C) },
    { ZYDIS_DEFINITION(0xD, 0x71C), ZYDIS_DEFINITION(0xD, 0x71D), ZYDIS_DEFINITION(0x1, 0x3EB), ZYDIS_DEFINITION(0x1, 0x3B3), ZYDIS_DEFINITION(0x1, 0x3A3), ZYDIS_DEFINITION(0x1, 0x235), ZYDIS_DEFINITION(0x1, 0x160), ZYDIS_DEFINITION(0x1, 0x22D) },
    { ZYDIS_DEFINITION(0xE, 0x71E), ZYDIS_DEFINITION(0xE, 0x71F), ZYDIS_DEFINITION(0x1, 0x3EC), ZYDIS_DEFINITION(0x1, 0x3B4), ZYDIS_DEFINITION(0x1, 0x3A4), ZYDIS_DEFINITION(0x1, 0x236), ZYDIS_DEFINITION(0x1, 0x161), ZYDIS_DEFINITION(0x1, 0x22E) },
    { ZYDIS_DEFINITION(0xE, 0x720), ZYDIS_DEFINITION(0xE, 0x721), ZYDIS_DEFINITION(0x1, 0x3ED), ZYDIS_DEFINITION(0x1, 0x3B5), ZYDIS_DEFINITION(0x1, 0x3A5), ZYDIS_DEFINITION(0x1, 0x237), ZYDIS_DEFINITION(0x1, 0x162), ZYDIS_DEFINITION(0x1, 0x22F) },
    { ZYDIS_DEFINITION(0x1, 0x241), ZYDIS_DEFINITION(0x1, 0x15B), ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0x1, 0x242), ZYDIS_DEFINITION(0x1, 0x15C), ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0x1, 0x243), ZYDIS_DEFINITION(0x1, 0x15D), ZYDIS_DEFINITION(0x1, 0xB3), ZYDIS_INVALID, ZYDIS_DEFINITION(0x1, 0x285), ZYDIS_INVALID, ZYDIS_DEFINITION(0x1, 0x5D1), ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0x1, 0x244), ZYDIS_DEFINITION(0x1, 0x15E), ZYDIS_DEFINITION(0x1, 0xB4), ZYDIS_DEFINITION(0x1, 0xB5), ZYDIS_DEFINITION(0x1, 0x286), ZYDIS_DEFINITION(0x1, 0x287), ZYDIS_DEFINITION(0x1, 0x5D2), ZYDIS_INVALID }
};

const ZydisDecoderTreeNode FILTERS_MODRM_RM[][8] =
{
    { ZYDIS_DEFINITION(0x1, 0x74D), ZYDIS_DEFINITION(0x1, 0x745), ZYDIS_DEFINITION(0x1, 0x744), ZYDIS_DEFINITION(0x1, 0x74E), ZYDIS_DEFINITION(0x1, 0x6DC), ZYDIS_DEFINITION(0x1, 0xBF), ZYDIS_DEFINITION(0x1, 0x6CC), ZYDIS_DEFINITION(0x1, 0x25F) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODE_COMPACT, 0x3), ZYDIS_DEFINITION(0x1, 0x609), ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_DEFINITION(0x1, 0xC5), ZYDIS_DEFINITION(0x1, 0x603), ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODE_COMPACT, 0x4), ZYDIS_DEFINITION(0x1, 0x740), ZYDIS_DEFINITION(0x1, 0x743), ZYDIS_DEFINITION(0x1, 0x74C), ZYDIS_DEFINITION(0x1, 0x753), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODE_COMPACT, 0x5), ZYDIS_DEFINITION(0x1, 0x75A), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODE_COMPACT, 0x6) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODE_COMPACT, 0x7), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODE_COMPACT, 0x8), ZYDIS_DEFINITION(0x1, 0xB9), ZYDIS_DEFINITION(0x1, 0x6D9), ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODE_COMPACT, 0x9) },
    { ZYDIS_DEFINITION(0x1, 0x772), ZYDIS_DEFINITION(0x1, 0x797), ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_DEFINITION(0x1, 0x742), ZYDIS_DEFINITION(0x1, 0x771), ZYDIS_DEFINITION(0x1, 0x79D), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODE_COMPACT, 0xA) },
    { ZYDIS_DEFINITION(0x1, 0x667), ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_DEFINITION(0x1, 0x601), ZYDIS_DEFINITION(0x1, 0x75B) },
    { ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODE_COMPACT, 0xB), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODE_COMPACT, 0xC), ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_DEFINITION(0x1, 0x260), ZYDIS_DEFINITION(0x1, 0x723) },
    { ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODE_COMPACT, 0xD), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODE_COMPACT, 0xE), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODE_COMPACT, 0xF), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODE_COMPACT, 0x10) },
    { ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODE_COMPACT, 0x11), ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0x1, 0x686), ZYDIS_INVALID, ZYDIS_DEFINITION(0x1, 0x644), ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODE_COMPACT, 0x12), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODE_COMPACT, 0x13), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODE_COMPACT, 0x14), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODE_COMPACT, 0x15) },
    { ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_DEFINITION(0x1, 0x2FA), ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODE_COMPACT, 0x16), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODE_COMPACT, 0x17) },
    { ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODE_COMPACT, 0x18), ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0x1, 0x79C), ZYDIS_DEFINITION(0x1, 0x78A), ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODE_COMPACT, 0x19), ZYDIS_DEFINITION(0x1, 0x5DA) },
    { ZYDIS_DEFINITION(0x1, 0x3DB), ZYDIS_DEFINITION(0x1, 0x3DC), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODE_CET, 0x3), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODE_CET, 0x4), ZYDIS_DEFINITION(0x1, 0x3DF), ZYDIS_DEFINITION(0x1, 0x3E0), ZYDIS_DEFINITION(0x1, 0x3E1), ZYDIS_DEFINITION(0x1, 0x3E2) },
    { ZYDIS_DEFINITION(0xB, 0x227), ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0x1, 0x308), ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0x1, 0x798), ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0x1, 0x799), ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0x1, 0x79A), ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0x1, 0x79B), ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0x1, 0x76F), ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0x1, 0x76C), ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0x1, 0x76E), ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0x1, 0x76D), ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0x1, 0x770), ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x1B8), ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x1B9), ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x1BA), ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x1BB), ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x1D0), ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x1D1), ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x1D2), ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x1D3), ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x202), ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x203), ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x204), ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x205), ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x206), ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x207), ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x208), ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x209), ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x427), ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x428), ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x431), ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x432), ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x449), ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x44A), ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x44B), ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x44C), ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x44D), ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x44E), ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x4CE), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x4CF), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x4D0), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x4D1), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x4D2), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x4D3), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x4D4), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x4D5) },
    { ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x59B), ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x5A8), ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x5A9), ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x5AA), ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x5AB), ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x614), ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x62D), ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x62E), ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0xB, 0x760), ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0xF, 0x765), ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0x1, 0x1E1), ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0x1, 0x18A), ZYDIS_DEFINITION(0x1, 0x182), ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_DEFINITION(0x1, 0x209), ZYDIS_DEFINITION(0x1, 0x210), ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0x1, 0x1D0), ZYDIS_DEFINITION(0x1, 0x1D5), ZYDIS_DEFINITION(0x1, 0x1D4), ZYDIS_DEFINITION(0x1, 0x1D8), ZYDIS_DEFINITION(0x1, 0x1D6), ZYDIS_DEFINITION(0x1, 0x1D7), ZYDIS_DEFINITION(0x1, 0x1D9), ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0x1, 0x181), ZYDIS_DEFINITION(0x1, 0x219), ZYDIS_DEFINITION(0x1, 0x1EC), ZYDIS_DEFINITION(0x1, 0x1E9), ZYDIS_DEFINITION(0x1, 0x218), ZYDIS_DEFINITION(0x1, 0x1EB), ZYDIS_DEFINITION(0x1, 0x1A0), ZYDIS_DEFINITION(0x1, 0x1BF) },
    { ZYDIS_DEFINITION(0x1, 0x1EA), ZYDIS_DEFINITION(0x1, 0x21A), ZYDIS_DEFINITION(0x1, 0x1F4), ZYDIS_DEFINITION(0x1, 0x1F3), ZYDIS_DEFINITION(0x1, 0x1ED), ZYDIS_DEFINITION(0x1, 0x1F0), ZYDIS_DEFINITION(0x1, 0x1F2), ZYDIS_DEFINITION(0x1, 0x19F) },
    { ZYDIS_INVALID, ZYDIS_DEFINITION(0x1, 0x20E), ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0x1, 0x1AD), ZYDIS_DEFINITION(0x1, 0x1A1), ZYDIS_DEFINITION(0x1, 0x1DF), ZYDIS_DEFINITION(0x1, 0x1E0), ZYDIS_DEFINITION(0x1, 0x1F1), ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_INVALID, ZYDIS_DEFINITION(0x1, 0x19E), ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0x1, 0x1E8), ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID }
};

const ZydisDecoderTreeNode FILTERS_MANDATORY_PREFIX[][5] =
{
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_REG, 0x2), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_REG, 0x3), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_REG, 0x4), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_REG, 0x5), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_REG, 0x6) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_REG, 0x7), ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_REG, 0x8), ZYDIS_INVALID },
    { ZYDIS_INVALID, ZYDIS_DEFINITION(0x1, 0x398), ZYDIS_DEFINITION(0x1, 0x394), ZYDIS_DEFINITION(0x1, 0x387), ZYDIS_DEFINITION(0x1, 0x37C) },
    { ZYDIS_INVALID, ZYDIS_DEFINITION(0x1, 0x399), ZYDIS_DEFINITION(0x1, 0x395), ZYDIS_DEFINITION(0x1, 0x388), ZYDIS_DEFINITION(0x1, 0x37D) },
    { ZYDIS_INVALID, ZYDIS_DEFINITION(0x1, 0x39A), ZYDIS_DEFINITION(0x1, 0x396), ZYDIS_DEFINITION(0x1, 0x389), ZYDIS_DEFINITION(0x1, 0x37E) },
    { ZYDIS_INVALID, ZYDIS_DEFINITION(0x1, 0x39B), ZYDIS_DEFINITION(0x1, 0x397), ZYDIS_DEFINITION(0x1, 0x38A), ZYDIS_DEFINITION(0x1, 0x37F) },
    { ZYDIS_INVALID, ZYDIS_DEFINITION(0x1, 0x350), ZYDIS_INVALID, ZYDIS_DEFINITION(0x1, 0x382), ZYDIS_DEFINITION(0x1, 0x341) },
    { ZYDIS_INVALID, ZYDIS_DEFINITION(0x1, 0x358), ZYDIS_DEFINITION(0x1, 0x356), ZYDIS_DEFINITION(0x1, 0x383), ZYDIS_DEFINITION(0x1, 0x342) },
    { ZYDIS_INVALID, ZYDIS_DEFINITION(0x1, 0x359), ZYDIS_DEFINITION(0x1, 0x357), ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_INVALID, ZYDIS_DEFINITION(0x1, 0x73A), ZYDIS_DEFINITION(0x1, 0x738), ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_INVALID, ZYDIS_DEFINITION(0x1, 0x73B), ZYDIS_DEFINITION(0x1, 0x739), ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_INVALID, ZYDIS_DEFINITION(0x1, 0x736), ZYDIS_DEFINITION(0x1, 0x734), ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_INVALID, ZYDIS_DEFINITION(0x1, 0x737), ZYDIS_DEFINITION(0x1, 0x735), ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_INVALID, ZYDIS_DEFINITION(0x1, 0x355), ZYDIS_INVALID, ZYDIS_DEFINITION(0x1, 0x380), ZYDIS_INVALID },
    { ZYDIS_INVALID, ZYDIS_DEFINITION(0x1, 0x353), ZYDIS_DEFINITION(0x1, 0x351), ZYDIS_DEFINITION(0x1, 0x381), ZYDIS_INVALID },
    { ZYDIS_INVALID, ZYDIS_DEFINITION(0x1, 0x354), ZYDIS_DEFINITION(0x1, 0x352), ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_INVALID, ZYDIS_DEFINITION(0x1, 0x3C8), ZYDIS_DEFINITION(0x1, 0x8C), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODE_COMPACT, 0x20), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODE_COMPACT, 0x21) },
    { ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODE_COMPACT, 0x22), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODE_COMPACT, 0x23), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODE_COMPACT, 0x24), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODE_COMPACT, 0x25) },
    { ZYDIS_INVALID, ZYDIS_DEFINITION(0x1, 0x3CB), ZYDIS_DEFINITION(0x1, 0x8F), ZYDIS_DEFINITION(0x1, 0x3CC), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODE_COMPACT, 0x26) },
    { ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODE_COMPACT, 0x27), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODE_COMPACT, 0x28), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODE_COMPACT, 0x29), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODE_COMPACT, 0x2A) },
    { ZYDIS_DEFINITION(0x1, 0x3CE), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_REG, 0xC), ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0x1, 0x3D2), ZYDIS_DEFINITION(0x1, 0x3D3), ZYDIS_DEFINITION(0x1, 0x3D4), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_REG, 0xD), ZYDIS_DEFINITION(0x1, 0x3E5) },
    { ZYDIS_INVALID, ZYDIS_DEFINITION(0x1, 0x32B), ZYDIS_DEFINITION(0x1, 0x327), ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_INVALID, ZYDIS_DEFINITION(0x1, 0x32C), ZYDIS_DEFINITION(0x1, 0x328), ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_INVALID, ZYDIS_DEFINITION(0x1, 0x32D), ZYDIS_DEFINITION(0x1, 0x329), ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_INVALID, ZYDIS_DEFINITION(0x1, 0x32E), ZYDIS_DEFINITION(0x1, 0x32A), ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_INVALID, ZYDIS_DEFINITION(0x1, 0x12A), ZYDIS_DEFINITION(0x1, 0x128), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x2), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x3) },
    { ZYDIS_INVALID, ZYDIS_DEFINITION(0x1, 0x12B), ZYDIS_DEFINITION(0x1, 0x129), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x4), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x5) },
    { ZYDIS_INVALID, ZYDIS_DEFINITION(0x1, 0x361), ZYDIS_DEFINITION(0x1, 0x360), ZYDIS_DEFINITION(0x1, 0x364), ZYDIS_DEFINITION(0x1, 0x363) },
    { ZYDIS_INVALID, ZYDIS_DEFINITION(0x1, 0x14C), ZYDIS_DEFINITION(0x1, 0x148), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x6), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x7) },
    { ZYDIS_INVALID, ZYDIS_DEFINITION(0x1, 0x14D), ZYDIS_DEFINITION(0x1, 0x149), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x8), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x9) },
    { ZYDIS_INVALID, ZYDIS_DEFINITION(0x1, 0x130), ZYDIS_DEFINITION(0x1, 0x124), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0xA), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0xB) },
    { ZYDIS_INVALID, ZYDIS_DEFINITION(0x1, 0x131), ZYDIS_DEFINITION(0x1, 0x125), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0xC), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0xD) },
    { ZYDIS_INVALID, ZYDIS_DEFINITION(0x1, 0x729), ZYDIS_DEFINITION(0x1, 0x727), ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_INVALID, ZYDIS_DEFINITION(0x1, 0x72A), ZYDIS_DEFINITION(0x1, 0x728), ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_INVALID, ZYDIS_DEFINITION(0x1, 0x116), ZYDIS_DEFINITION(0x1, 0x114), ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_INVALID, ZYDIS_DEFINITION(0x1, 0x117), ZYDIS_DEFINITION(0x1, 0x115), ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_INVALID, ZYDIS_DEFINITION(0x0, 0x21B), ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_INVALID, ZYDIS_DEFINITION(0x1, 0x53F), ZYDIS_DEFINITION(0x1, 0x541), ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_INVALID, ZYDIS_DEFINITION(0x1, 0x540), ZYDIS_DEFINITION(0x1, 0x542), ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_INVALID, ZYDIS_DEFINITION(0x1, 0x4A9), ZYDIS_DEFINITION(0x1, 0x4AB), ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_INVALID, ZYDIS_DEFINITION(0x1, 0x4AA), ZYDIS_DEFINITION(0x1, 0x4AC), ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_INVALID, ZYDIS_DEFINITION(0x1, 0x4A1), ZYDIS_DEFINITION(0x1, 0x4A3), ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_INVALID, ZYDIS_DEFINITION(0x1, 0x4A2), ZYDIS_DEFINITION(0x1, 0x4A4), ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_INVALID, ZYDIS_DEFINITION(0x1, 0x4A5), ZYDIS_DEFINITION(0x1, 0x4A7), ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_INVALID, ZYDIS_DEFINITION(0x1, 0x4A6), ZYDIS_DEFINITION(0x1, 0x4A8), ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_INVALID, ZYDIS_DEFINITION(0x1, 0x4C5), ZYDIS_DEFINITION(0x1, 0x4C7), ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_INVALID, ZYDIS_DEFINITION(0x1, 0x4C6), ZYDIS_DEFINITION(0x1, 0x4C8), ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_INVALID, ZYDIS_DEFINITION(0x1, 0x4B7), ZYDIS_DEFINITION(0x1, 0x4B9), ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_INVALID, ZYDIS_DEFINITION(0x1, 0x4B8), ZYDIS_DEFINITION(0x1, 0x4BA), ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_INVALID, ZYDIS_DEFINITION(0x1, 0x4AF), ZYDIS_DEFINITION(0x1, 0x4B1), ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_INVALID, ZYDIS_DEFINITION(0x1, 0x4B0), ZYDIS_DEFINITION(0x1, 0x4B2), ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_INVALID, ZYDIS_DEFINITION(0x1, 0x4B3), ZYDIS_DEFINITION(0x1, 0x4B5), ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_INVALID, ZYDIS_DEFINITION(0x1, 0x4B4), ZYDIS_DEFINITION(0x1, 0x4B6), ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_INVALID, ZYDIS_DEFINITION(0x1, 0x54B), ZYDIS_DEFINITION(0x1, 0x54D), ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_INVALID, ZYDIS_DEFINITION(0x1, 0x54C), ZYDIS_DEFINITION(0x1, 0x54E), ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_INVALID, ZYDIS_DEFINITION(0x1, 0x553), ZYDIS_DEFINITION(0x1, 0x555), ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_INVALID, ZYDIS_DEFINITION(0x1, 0x554), ZYDIS_DEFINITION(0x1, 0x556), ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_INVALID, ZYDIS_DEFINITION(0x1, 0x54F), ZYDIS_DEFINITION(0x1, 0x551), ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_INVALID, ZYDIS_DEFINITION(0x1, 0x550), ZYDIS_DEFINITION(0x1, 0x552), ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_INVALID, ZYDIS_DEFINITION(0x1, 0x509), ZYDIS_DEFINITION(0x1, 0x50B), ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_INVALID, ZYDIS_DEFINITION(0x1, 0x50A), ZYDIS_DEFINITION(0x1, 0x50C), ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_DEFINITION(0x1, 0x465), ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_DEFINITION(0x1, 0x466), ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_DEFINITION(0x1, 0x7A), ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_DEFINITION(0x1, 0x7B), ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_DEFINITION(0x1, 0x78), ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_DEFINITION(0x1, 0x79), ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_DEFINITION(0x1, 0x5AA), ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_DEFINITION(0x1, 0x5AB), ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_INVALID, ZYDIS_DEFINITION(0x1, 0x416), ZYDIS_DEFINITION(0x1, 0x418), ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_INVALID, ZYDIS_DEFINITION(0x1, 0x417), ZYDIS_DEFINITION(0x1, 0x419), ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_INVALID, ZYDIS_DEFINITION(0x1, 0x41E), ZYDIS_DEFINITION(0x1, 0x420), ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_INVALID, ZYDIS_DEFINITION(0x1, 0x41F), ZYDIS_DEFINITION(0x1, 0x421), ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_INVALID, ZYDIS_DEFINITION(0x1, 0x41A), ZYDIS_DEFINITION(0x1, 0x41C), ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_INVALID, ZYDIS_DEFINITION(0x1, 0x41B), ZYDIS_DEFINITION(0x1, 0x41D), ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_DEFINITION(0x1, 0x4F3), ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_DEFINITION(0x1, 0x4F4), ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_DEFINITION(0x1, 0x4EF), ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_DEFINITION(0x1, 0x4F0), ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_DEFINITION(0x1, 0x4F1), ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_DEFINITION(0x1, 0x4F2), ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_DEFINITION(0x1, 0x4F7), ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_DEFINITION(0x1, 0x4F8), ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_DEFINITION(0x1, 0x4F9), ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_DEFINITION(0x1, 0x4FA), ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_DEFINITION(0x1, 0x4F5), ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_DEFINITION(0x1, 0x4F6), ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_DEFINITION(0x1, 0x507), ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_DEFINITION(0x1, 0x508), ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_DEFINITION(0x1, 0x474), ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_DEFINITION(0x1, 0x475), ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_DEFINITION(0x1, 0x35D), ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_DEFINITION(0x1, 0x42A), ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_DEFINITION(0x1, 0x42B), ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_DEFINITION(0x1, 0x4FF), ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_DEFINITION(0x1, 0x500), ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_DEFINITION(0x1, 0x4FB), ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_DEFINITION(0x1, 0x4FC), ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_DEFINITION(0x1, 0x4FD), ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_DEFINITION(0x1, 0x4FE), ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_DEFINITION(0x1, 0x503), ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_DEFINITION(0x1, 0x504), ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_DEFINITION(0x1, 0x505), ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_DEFINITION(0x1, 0x506), ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_DEFINITION(0x1, 0x501), ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_DEFINITION(0x1, 0x502), ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_DEFINITION(0x1, 0x48A), ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_DEFINITION(0x1, 0x48B), ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_DEFINITION(0x1, 0x4DD), ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_DEFINITION(0x1, 0x4DE), ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_DEFINITION(0x1, 0x4DF), ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_DEFINITION(0x1, 0x4E0), ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_DEFINITION(0x1, 0x4EB), ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_DEFINITION(0x1, 0x4EC), ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_DEFINITION(0x1, 0x4E9), ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_DEFINITION(0x1, 0x4EA), ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_DEFINITION(0x1, 0x4CD), ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_DEFINITION(0x1, 0x4CE), ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_DEFINITION(0x1, 0x4CF), ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_DEFINITION(0x1, 0x4D0), ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_DEFINITION(0x1, 0x4DB), ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_DEFINITION(0x1, 0x4DC), ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_DEFINITION(0x1, 0x4D9), ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_DEFINITION(0x1, 0x4DA), ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_DEFINITION(0x1, 0x515), ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_DEFINITION(0x1, 0x516), ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_DEFINITION(0x1, 0x4AD), ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_DEFINITION(0x1, 0x4AE), ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODE_COMPACT, 0x32), ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODE_COMPACT, 0x33), ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODE_COMPACT, 0x34), ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_INVALID, ZYDIS_DEFINITION(0x1, 0x690), ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_INVALID, ZYDIS_DEFINITION(0x1, 0x691), ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_INVALID, ZYDIS_DEFINITION(0x1, 0x68C), ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_INVALID, ZYDIS_DEFINITION(0x1, 0x68D), ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_INVALID, ZYDIS_DEFINITION(0x1, 0x68E), ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_INVALID, ZYDIS_DEFINITION(0x1, 0x68F), ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_INVALID, ZYDIS_DEFINITION(0x1, 0x698), ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_INVALID, ZYDIS_DEFINITION(0x1, 0x699), ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_INVALID, ZYDIS_DEFINITION(0x1, 0x694), ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_INVALID, ZYDIS_DEFINITION(0x1, 0x695), ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_INVALID, ZYDIS_DEFINITION(0x1, 0x696), ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_INVALID, ZYDIS_DEFINITION(0x1, 0x697), ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_DEFINITION(0x1, 0x220), ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_DEFINITION(0x1, 0x221), ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_REG, 0x10), ZYDIS_INVALID },
    { ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_DEFINITION(0x1, 0x50), ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_DEFINITION(0x1, 0x51), ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_DEFINITION(0x1, 0x48), ZYDIS_DEFINITION(0x1, 0x2D9), ZYDIS_INVALID },
    { ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_DEFINITION(0x1, 0x49), ZYDIS_DEFINITION(0x1, 0x4A), ZYDIS_INVALID },
    { ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_DEFINITION(0x1, 0x4C), ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_DEFINITION(0x1, 0x4D), ZYDIS_DEFINITION(0x1, 0x42), ZYDIS_INVALID },
    { ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_DEFINITION(0x1, 0x40), ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_DEFINITION(0x1, 0x41), ZYDIS_DEFINITION(0x1, 0x4B), ZYDIS_INVALID },
    { ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_DEFINITION(0x1, 0x44), ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_DEFINITION(0x1, 0x45), ZYDIS_DEFINITION(0x1, 0x43), ZYDIS_INVALID },
    { ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_DEFINITION(0x1, 0x11A) },
    { ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_DEFINITION(0x1, 0x11B) },
    { ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_DEFINITION(0x1, 0x11C) },
    { ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_DEFINITION(0x1, 0x11D) },
    { ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0xE), ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0xF), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x10), ZYDIS_INVALID },
    { ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x11), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x12), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x13), ZYDIS_INVALID },
    { ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODE_COMPACT, 0x35), ZYDIS_DEFINITION(0x1, 0x17B), ZYDIS_DEFINITION(0x1, 0x17A) },
    { ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x14), ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_DEFINITION(0x1, 0x176), ZYDIS_INVALID },
    { ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_DEFINITION(0x1, 0x177), ZYDIS_INVALID },
    { ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x15), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x16), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x17), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x18) },
    { ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_DEFINITION(0xB, 0x62A), ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_DEFINITION(0xB, 0x62B), ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_DEFINITION(0xB, 0x628), ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_DEFINITION(0xB, 0x629), ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_DEFINITION(0xB, 0x62E), ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_DEFINITION(0xB, 0x62F), ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_DEFINITION(0xB, 0x62C), ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_DEFINITION(0xB, 0x62D), ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_DEFINITION(0xB, 0x76), ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_DEFINITION(0xB, 0x77), ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_DEFINITION(0xB, 0x74), ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_DEFINITION(0xB, 0x75), ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_DEFINITION(0xB, 0x467), ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_DEFINITION(0xB, 0x468), ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_INVALID, ZYDIS_DEFINITION(0xB, 0x450), ZYDIS_DEFINITION(0xB, 0x452), ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_INVALID, ZYDIS_DEFINITION(0xB, 0x451), ZYDIS_DEFINITION(0xB, 0x453), ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_DEFINITION(0xB, 0x497), ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_DEFINITION(0xB, 0x498), ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_DEFINITION(0xB, 0x49F), ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_DEFINITION(0xB, 0x4A0), ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x19), ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x1A), ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_DEFINITION(0xB, 0x17D), ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_DEFINITION(0xB, 0x17E), ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_DEFINITION(0xB, 0x4BB), ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_DEFINITION(0xB, 0x4BC), ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_DEFINITION(0xB, 0x250), ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_DEFINITION(0xB, 0x251), ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x1B), ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x1C), ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_DEFINITION(0xB, 0x16D), ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_DEFINITION(0xB, 0x16E), ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_DEFINITION(0xB, 0x16B), ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_DEFINITION(0xB, 0x16C), ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_DEFINITION(0xB, 0x3A0), ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_DEFINITION(0xB, 0x3A1), ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_DEFINITION(0xB, 0x46A), ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_DEFINITION(0xB, 0x46B), ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x1D), ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x1E), ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x1F), ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x20), ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_DEFINITION(0xB, 0x492), ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_DEFINITION(0xB, 0x493), ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_DEFINITION(0xB, 0x490), ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_DEFINITION(0xB, 0x491), ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_INVALID, ZYDIS_DEFINITION(0xB, 0x692), ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_INVALID, ZYDIS_DEFINITION(0xB, 0x693), ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_DEFINITION(0xB, 0x21E), ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_DEFINITION(0xB, 0x21F), ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_DEFINITION(0xB, 0x21C), ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_DEFINITION(0xB, 0x21D), ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_DEFINITION(0xB, 0x52), ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_DEFINITION(0xB, 0x53), ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_REG, 0x11), ZYDIS_INVALID },
    { ZYDIS_INVALID, ZYDIS_DEFINITION(0x1, 0x35B), ZYDIS_DEFINITION(0x1, 0x35A), ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_INVALID, ZYDIS_DEFINITION(0x1, 0x6D3), ZYDIS_DEFINITION(0x1, 0x6D1), ZYDIS_DEFINITION(0x1, 0x6D7), ZYDIS_DEFINITION(0x1, 0x6D5) },
    { ZYDIS_INVALID, ZYDIS_DEFINITION(0x1, 0x6D4), ZYDIS_DEFINITION(0x1, 0x6D2), ZYDIS_DEFINITION(0x1, 0x6D8), ZYDIS_DEFINITION(0x1, 0x6D6) },
    { ZYDIS_INVALID, ZYDIS_DEFINITION(0x1, 0x631), ZYDIS_INVALID, ZYDIS_DEFINITION(0x1, 0x633), ZYDIS_INVALID },
    { ZYDIS_INVALID, ZYDIS_DEFINITION(0x1, 0x632), ZYDIS_INVALID, ZYDIS_DEFINITION(0x1, 0x634), ZYDIS_INVALID },
    { ZYDIS_INVALID, ZYDIS_DEFINITION(0x1, 0x5EB), ZYDIS_INVALID, ZYDIS_DEFINITION(0x1, 0x5ED), ZYDIS_INVALID },
    { ZYDIS_INVALID, ZYDIS_DEFINITION(0x1, 0x5EC), ZYDIS_INVALID, ZYDIS_DEFINITION(0x1, 0x5EE), ZYDIS_INVALID },
    { ZYDIS_INVALID, ZYDIS_DEFINITION(0x1, 0x6C), ZYDIS_DEFINITION(0x1, 0x6A), ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_INVALID, ZYDIS_DEFINITION(0x1, 0x6D), ZYDIS_DEFINITION(0x1, 0x6B), ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_INVALID, ZYDIS_DEFINITION(0x1, 0x68), ZYDIS_DEFINITION(0x1, 0x66), ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_INVALID, ZYDIS_DEFINITION(0x1, 0x69), ZYDIS_DEFINITION(0x1, 0x67), ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_INVALID, ZYDIS_DEFINITION(0x1, 0x402), ZYDIS_DEFINITION(0x1, 0x400), ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_INVALID, ZYDIS_DEFINITION(0x1, 0x403), ZYDIS_DEFINITION(0x1, 0x401), ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_INVALID, ZYDIS_DEFINITION(0x1, 0x788), ZYDIS_DEFINITION(0x1, 0x786), ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_INVALID, ZYDIS_DEFINITION(0x1, 0x789), ZYDIS_DEFINITION(0x1, 0x787), ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_INVALID, ZYDIS_DEFINITION(0x1, 0x32), ZYDIS_DEFINITION(0x1, 0x30), ZYDIS_DEFINITION(0x1, 0x36), ZYDIS_DEFINITION(0x1, 0x34) },
    { ZYDIS_INVALID, ZYDIS_DEFINITION(0x1, 0x33), ZYDIS_DEFINITION(0x1, 0x31), ZYDIS_DEFINITION(0x1, 0x37), ZYDIS_DEFINITION(0x1, 0x35) },
    { ZYDIS_INVALID, ZYDIS_DEFINITION(0x1, 0x3A8), ZYDIS_DEFINITION(0x1, 0x3A6), ZYDIS_DEFINITION(0x1, 0x3AC), ZYDIS_DEFINITION(0x1, 0x3AA) },
    { ZYDIS_INVALID, ZYDIS_DEFINITION(0x1, 0x3A9), ZYDIS_DEFINITION(0x1, 0x3A7), ZYDIS_DEFINITION(0x1, 0x3AD), ZYDIS_DEFINITION(0x1, 0x3AB) },
    { ZYDIS_INVALID, ZYDIS_DEFINITION(0x1, 0x12E), ZYDIS_DEFINITION(0x1, 0x126), ZYDIS_DEFINITION(0x1, 0x140), ZYDIS_DEFINITION(0x1, 0x136) },
    { ZYDIS_INVALID, ZYDIS_DEFINITION(0x1, 0x12F), ZYDIS_DEFINITION(0x1, 0x127), ZYDIS_DEFINITION(0x1, 0x141), ZYDIS_DEFINITION(0x1, 0x137) },
    { ZYDIS_INVALID, ZYDIS_DEFINITION(0x1, 0x120), ZYDIS_DEFINITION(0x1, 0x12C), ZYDIS_DEFINITION(0x1, 0x14A), ZYDIS_INVALID },
    { ZYDIS_INVALID, ZYDIS_DEFINITION(0x1, 0x121), ZYDIS_DEFINITION(0x1, 0x12D), ZYDIS_DEFINITION(0x1, 0x14B), ZYDIS_INVALID },
    { ZYDIS_INVALID, ZYDIS_DEFINITION(0x1, 0x702), ZYDIS_DEFINITION(0x1, 0x700), ZYDIS_DEFINITION(0x1, 0x706), ZYDIS_DEFINITION(0x1, 0x704) },
    { ZYDIS_INVALID, ZYDIS_DEFINITION(0x1, 0x703), ZYDIS_DEFINITION(0x1, 0x701), ZYDIS_DEFINITION(0x1, 0x707), ZYDIS_DEFINITION(0x1, 0x705) },
    { ZYDIS_INVALID, ZYDIS_DEFINITION(0x1, 0x2FE), ZYDIS_DEFINITION(0x1, 0x2FC), ZYDIS_DEFINITION(0x1, 0x302), ZYDIS_DEFINITION(0x1, 0x300) },
    { ZYDIS_INVALID, ZYDIS_DEFINITION(0x1, 0x2FF), ZYDIS_DEFINITION(0x1, 0x2FD), ZYDIS_DEFINITION(0x1, 0x303), ZYDIS_DEFINITION(0x1, 0x301) },
    { ZYDIS_INVALID, ZYDIS_DEFINITION(0x1, 0x165), ZYDIS_DEFINITION(0x1, 0x163), ZYDIS_DEFINITION(0x1, 0x169), ZYDIS_DEFINITION(0x1, 0x167) },
    { ZYDIS_INVALID, ZYDIS_DEFINITION(0x1, 0x166), ZYDIS_DEFINITION(0x1, 0x164), ZYDIS_DEFINITION(0x1, 0x16A), ZYDIS_DEFINITION(0x1, 0x168) },
    { ZYDIS_INVALID, ZYDIS_DEFINITION(0x1, 0x2F4), ZYDIS_DEFINITION(0x1, 0x2F2), ZYDIS_DEFINITION(0x1, 0x2F8), ZYDIS_DEFINITION(0x1, 0x2F6) },
    { ZYDIS_INVALID, ZYDIS_DEFINITION(0x1, 0x2F5), ZYDIS_DEFINITION(0x1, 0x2F3), ZYDIS_DEFINITION(0x1, 0x2F9), ZYDIS_DEFINITION(0x1, 0x2F7) },
    { ZYDIS_INVALID, ZYDIS_DEFINITION(0x1, 0x5BC), ZYDIS_DEFINITION(0x1, 0x5BE), ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_INVALID, ZYDIS_DEFINITION(0x1, 0x5BD), ZYDIS_DEFINITION(0x1, 0x5BF), ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_INVALID, ZYDIS_DEFINITION(0x1, 0x5C6), ZYDIS_DEFINITION(0x1, 0x5C8), ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_INVALID, ZYDIS_DEFINITION(0x1, 0x5C7), ZYDIS_DEFINITION(0x1, 0x5C9), ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_INVALID, ZYDIS_DEFINITION(0x1, 0x5C0), ZYDIS_DEFINITION(0x1, 0x5C2), ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_INVALID, ZYDIS_DEFINITION(0x1, 0x5C1), ZYDIS_DEFINITION(0x1, 0x5C3), ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_INVALID, ZYDIS_DEFINITION(0x1, 0x426), ZYDIS_DEFINITION(0x1, 0x428), ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_INVALID, ZYDIS_DEFINITION(0x1, 0x427), ZYDIS_DEFINITION(0x1, 0x429), ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_INVALID, ZYDIS_DEFINITION(0x1, 0x482), ZYDIS_DEFINITION(0x1, 0x484), ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_INVALID, ZYDIS_DEFINITION(0x1, 0x483), ZYDIS_DEFINITION(0x1, 0x485), ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_INVALID, ZYDIS_DEFINITION(0x1, 0x48C), ZYDIS_DEFINITION(0x1, 0x48E), ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_INVALID, ZYDIS_DEFINITION(0x1, 0x48D), ZYDIS_DEFINITION(0x1, 0x48F), ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_INVALID, ZYDIS_DEFINITION(0x1, 0x486), ZYDIS_DEFINITION(0x1, 0x488), ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_INVALID, ZYDIS_DEFINITION(0x1, 0x487), ZYDIS_DEFINITION(0x1, 0x489), ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_INVALID, ZYDIS_DEFINITION(0x1, 0x42C), ZYDIS_DEFINITION(0x1, 0x42E), ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_INVALID, ZYDIS_DEFINITION(0x1, 0x42D), ZYDIS_DEFINITION(0x1, 0x42F), ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_INVALID, ZYDIS_DEFINITION(0x1, 0x5AE), ZYDIS_DEFINITION(0x1, 0x5B0), ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_INVALID, ZYDIS_DEFINITION(0x1, 0x5AF), ZYDIS_DEFINITION(0x1, 0x5B1), ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_INVALID, ZYDIS_DEFINITION(0x1, 0x5B8), ZYDIS_DEFINITION(0x1, 0x5BA), ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_INVALID, ZYDIS_DEFINITION(0x1, 0x5B9), ZYDIS_DEFINITION(0x1, 0x5BB), ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_INVALID, ZYDIS_DEFINITION(0x1, 0x5B2), ZYDIS_DEFINITION(0x1, 0x5B4), ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_INVALID, ZYDIS_DEFINITION(0x1, 0x5B3), ZYDIS_DEFINITION(0x1, 0x5B5), ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_INVALID, ZYDIS_DEFINITION(0x1, 0x422), ZYDIS_DEFINITION(0x1, 0x424), ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_INVALID, ZYDIS_DEFINITION(0x1, 0x423), ZYDIS_DEFINITION(0x1, 0x425), ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_DEFINITION(0x1, 0x5C4), ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_DEFINITION(0x1, 0x5C5), ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_DEFINITION(0x1, 0x5B6), ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_DEFINITION(0x1, 0x5B7), ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODE_COMPACT, 0x36), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODE_COMPACT, 0x37), ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODE_COMPACT, 0x38), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODE_COMPACT, 0x39), ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_INVALID, ZYDIS_DEFINITION(0x1, 0x369), ZYDIS_DEFINITION(0x1, 0x348), ZYDIS_DEFINITION(0x1, 0x34C), ZYDIS_INVALID },
    { ZYDIS_INVALID, ZYDIS_DEFINITION(0x1, 0x36A), ZYDIS_DEFINITION(0x1, 0x349), ZYDIS_DEFINITION(0x1, 0x34D), ZYDIS_INVALID },
    { ZYDIS_INVALID, ZYDIS_DEFINITION(0xB, 0x549), ZYDIS_DEFINITION(0xB, 0x543), ZYDIS_DEFINITION(0xB, 0x545), ZYDIS_DEFINITION(0xB, 0x547) },
    { ZYDIS_INVALID, ZYDIS_DEFINITION(0xB, 0x54A), ZYDIS_DEFINITION(0xB, 0x544), ZYDIS_DEFINITION(0xB, 0x546), ZYDIS_DEFINITION(0xB, 0x548) },
    { ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_REG, 0x12), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_REG, 0x13), ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_REG, 0x14), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_REG, 0x15), ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_REG, 0x16), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_REG, 0x17), ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_INVALID, ZYDIS_DEFINITION(0x1, 0x46C), ZYDIS_DEFINITION(0x1, 0x46E), ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_INVALID, ZYDIS_DEFINITION(0x1, 0x46D), ZYDIS_DEFINITION(0x1, 0x46F), ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_INVALID, ZYDIS_DEFINITION(0x1, 0x476), ZYDIS_DEFINITION(0x1, 0x478), ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_INVALID, ZYDIS_DEFINITION(0x1, 0x477), ZYDIS_DEFINITION(0x1, 0x479), ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_INVALID, ZYDIS_DEFINITION(0x1, 0x470), ZYDIS_DEFINITION(0x1, 0x472), ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_INVALID, ZYDIS_DEFINITION(0x1, 0x471), ZYDIS_DEFINITION(0x1, 0x473), ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_INVALID, ZYDIS_DEFINITION(0x0, 0x16F), ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODE_COMPACT, 0x3A), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_REG, 0x18), ZYDIS_INVALID, ZYDIS_DEFINITION(0x13, 0x252) },
    { ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODE_COMPACT, 0x3B), ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODE_COMPACT, 0x3C), ZYDIS_DEFINITION(0x1, 0x180), ZYDIS_INVALID, ZYDIS_DEFINITION(0x1, 0x253) },
    { ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODE_COMPACT, 0x3D), ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_DEFINITION(0x1, 0x222), ZYDIS_INVALID, ZYDIS_DEFINITION(0x1, 0x224) },
    { ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_DEFINITION(0x1, 0x223), ZYDIS_INVALID, ZYDIS_DEFINITION(0x1, 0x225) },
    { ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_DEFINITION(0x1, 0x228), ZYDIS_INVALID, ZYDIS_DEFINITION(0x1, 0x22A) },
    { ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_DEFINITION(0x1, 0x229), ZYDIS_INVALID, ZYDIS_DEFINITION(0x1, 0x22B) },
    { ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODE_COMPACT, 0x3E), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODE_COMPACT, 0x3F), ZYDIS_DEFINITION(0x1, 0x36F), ZYDIS_INVALID },
    { ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODE_COMPACT, 0x40), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODE_COMPACT, 0x41), ZYDIS_DEFINITION(0x1, 0x370), ZYDIS_INVALID },
    { ZYDIS_INVALID, ZYDIS_DEFINITION(0x1, 0x371), ZYDIS_DEFINITION(0x1, 0x34A), ZYDIS_DEFINITION(0x1, 0x34E), ZYDIS_INVALID },
    { ZYDIS_INVALID, ZYDIS_DEFINITION(0x1, 0x372), ZYDIS_DEFINITION(0x1, 0x34B), ZYDIS_DEFINITION(0x1, 0x34F), ZYDIS_INVALID },
    { ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_REG, 0x19), ZYDIS_INVALID },
    { ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_REG, 0x1B), ZYDIS_INVALID },
    { ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_REG, 0x1C), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_REG, 0x1D), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_REG, 0x1E), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_REG, 0x1F) },
    { ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_REG, 0x20), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_REG, 0x21), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_REG, 0x22), ZYDIS_INVALID },
    { ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_DEFINITION(0x1, 0x529), ZYDIS_INVALID },
    { ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_DEFINITION(0x1, 0x52A), ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0x1, 0x96), ZYDIS_DEFINITION(0x1, 0x98), ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODE_TZCNT, 0x0), ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0x1, 0x97), ZYDIS_DEFINITION(0x1, 0x99), ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODE_TZCNT, 0x1), ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0x1, 0x9A), ZYDIS_DEFINITION(0x1, 0x9C), ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODE_LZCNT, 0x0), ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0x1, 0x9B), ZYDIS_DEFINITION(0x1, 0x9D), ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODE_LZCNT, 0x1), ZYDIS_INVALID },
    { ZYDIS_INVALID, ZYDIS_DEFINITION(0xB, 0xFB), ZYDIS_DEFINITION(0xB, 0xF9), ZYDIS_DEFINITION(0xB, 0x108), ZYDIS_DEFINITION(0xB, 0x103) },
    { ZYDIS_INVALID, ZYDIS_DEFINITION(0xB, 0xFC), ZYDIS_DEFINITION(0xB, 0xFA), ZYDIS_DEFINITION(0xB, 0x109), ZYDIS_DEFINITION(0xB, 0x104) },
    { ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_OPERAND_SIZE, 0x1), ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_INVALID, ZYDIS_DEFINITION(0xB, 0x4C1), ZYDIS_DEFINITION(0xB, 0x4C3), ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_INVALID, ZYDIS_DEFINITION(0xB, 0x4C2), ZYDIS_DEFINITION(0xB, 0x4C4), ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_INVALID, ZYDIS_DEFINITION(0xB, 0x49D), ZYDIS_DEFINITION(0xB, 0x49E), ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_INVALID, ZYDIS_DEFINITION(0xB, 0x6C8), ZYDIS_DEFINITION(0xB, 0x6C6), ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_INVALID, ZYDIS_DEFINITION(0xB, 0x6C9), ZYDIS_DEFINITION(0xB, 0x6C7), ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_REG, 0x26), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_REG, 0x27), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_REG, 0x28), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_REG, 0x29), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_REG, 0x2A), ZYDIS_INVALID },
    { ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_DEFINITION(0x1, 0x38), ZYDIS_INVALID, ZYDIS_DEFINITION(0x1, 0x3A) },
    { ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_DEFINITION(0x1, 0x39), ZYDIS_INVALID, ZYDIS_DEFINITION(0x1, 0x3B) },
    { ZYDIS_INVALID, ZYDIS_DEFINITION(0x1, 0x586), ZYDIS_DEFINITION(0x1, 0x588), ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_INVALID, ZYDIS_DEFINITION(0x1, 0x587), ZYDIS_DEFINITION(0x1, 0x589), ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_INVALID, ZYDIS_DEFINITION(0x1, 0x579), ZYDIS_DEFINITION(0x1, 0x57B), ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_INVALID, ZYDIS_DEFINITION(0x1, 0x57A), ZYDIS_DEFINITION(0x1, 0x57C), ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_INVALID, ZYDIS_DEFINITION(0x1, 0x580), ZYDIS_DEFINITION(0x1, 0x582), ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_INVALID, ZYDIS_DEFINITION(0x1, 0x581), ZYDIS_DEFINITION(0x1, 0x583), ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_INVALID, ZYDIS_DEFINITION(0x1, 0x438), ZYDIS_DEFINITION(0x1, 0x43A), ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_INVALID, ZYDIS_DEFINITION(0x1, 0x439), ZYDIS_DEFINITION(0x1, 0x43B), ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_INVALID, ZYDIS_DEFINITION(0x1, 0x517), ZYDIS_DEFINITION(0x1, 0x519), ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_INVALID, ZYDIS_DEFINITION(0x1, 0x518), ZYDIS_DEFINITION(0x1, 0x51A), ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_DEFINITION(0x1, 0x373), ZYDIS_DEFINITION(0x1, 0x375), ZYDIS_DEFINITION(0x1, 0x347) },
    { ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_DEFINITION(0x1, 0x374), ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_INVALID, ZYDIS_DEFINITION(0x1, 0x4ED), ZYDIS_DEFINITION(0x1, 0x4EE), ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_INVALID, ZYDIS_DEFINITION(0x1, 0x59E), ZYDIS_DEFINITION(0x1, 0x5A0), ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_INVALID, ZYDIS_DEFINITION(0x1, 0x59F), ZYDIS_DEFINITION(0x1, 0x5A1), ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_INVALID, ZYDIS_DEFINITION(0x1, 0x5A2), ZYDIS_DEFINITION(0x1, 0x5A4), ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_INVALID, ZYDIS_DEFINITION(0x1, 0x5A3), ZYDIS_DEFINITION(0x1, 0x5A5), ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_INVALID, ZYDIS_DEFINITION(0x1, 0x4E5), ZYDIS_DEFINITION(0x1, 0x4E7), ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_INVALID, ZYDIS_DEFINITION(0x1, 0x4E6), ZYDIS_DEFINITION(0x1, 0x4E8), ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_INVALID, ZYDIS_DEFINITION(0x1, 0x454), ZYDIS_DEFINITION(0x1, 0x456), ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_INVALID, ZYDIS_DEFINITION(0x1, 0x455), ZYDIS_DEFINITION(0x1, 0x457), ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_INVALID, ZYDIS_DEFINITION(0x1, 0x444), ZYDIS_DEFINITION(0x1, 0x446), ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_INVALID, ZYDIS_DEFINITION(0x1, 0x445), ZYDIS_DEFINITION(0x1, 0x447), ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_INVALID, ZYDIS_DEFINITION(0x1, 0x448), ZYDIS_DEFINITION(0x1, 0x44A), ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_INVALID, ZYDIS_DEFINITION(0x1, 0x449), ZYDIS_DEFINITION(0x1, 0x44B), ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_INVALID, ZYDIS_DEFINITION(0x1, 0x4D5), ZYDIS_DEFINITION(0x1, 0x4D7), ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_INVALID, ZYDIS_DEFINITION(0x1, 0x4D6), ZYDIS_DEFINITION(0x1, 0x4D8), ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_INVALID, ZYDIS_DEFINITION(0x1, 0x458), ZYDIS_DEFINITION(0x1, 0x45A), ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_INVALID, ZYDIS_DEFINITION(0x1, 0x459), ZYDIS_DEFINITION(0x1, 0x45B), ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_INVALID, ZYDIS_DEFINITION(0x1, 0x45D), ZYDIS_DEFINITION(0x1, 0x45F), ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_INVALID, ZYDIS_DEFINITION(0x1, 0x45E), ZYDIS_DEFINITION(0x1, 0x460), ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_INVALID, ZYDIS_DEFINITION(0x1, 0x573), ZYDIS_DEFINITION(0x1, 0x575), ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_INVALID, ZYDIS_DEFINITION(0x1, 0x574), ZYDIS_DEFINITION(0x1, 0x576), ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_INVALID, ZYDIS_DEFINITION(0x1, 0x56D), ZYDIS_DEFINITION(0x1, 0x56F), ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_INVALID, ZYDIS_DEFINITION(0x1, 0x56E), ZYDIS_DEFINITION(0x1, 0x570), ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_INVALID, ZYDIS_DEFINITION(0x1, 0x461), ZYDIS_DEFINITION(0x1, 0x463), ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_INVALID, ZYDIS_DEFINITION(0x1, 0x462), ZYDIS_DEFINITION(0x1, 0x464), ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_INVALID, ZYDIS_DEFINITION(0x1, 0x50D), ZYDIS_DEFINITION(0x1, 0x50F), ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_INVALID, ZYDIS_DEFINITION(0x1, 0x50E), ZYDIS_DEFINITION(0x1, 0x510), ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_INVALID, ZYDIS_DEFINITION(0x1, 0x511), ZYDIS_DEFINITION(0x1, 0x513), ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_INVALID, ZYDIS_DEFINITION(0x1, 0x512), ZYDIS_DEFINITION(0x1, 0x514), ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_DEFINITION(0x1, 0x146), ZYDIS_DEFINITION(0x1, 0x11E), ZYDIS_DEFINITION(0x1, 0x122) },
    { ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_DEFINITION(0x1, 0x147), ZYDIS_DEFINITION(0x1, 0x11F), ZYDIS_DEFINITION(0x1, 0x123) },
    { ZYDIS_INVALID, ZYDIS_DEFINITION(0x1, 0x362), ZYDIS_DEFINITION(0x1, 0x35C), ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_INVALID, ZYDIS_DEFINITION(0x1, 0x596), ZYDIS_DEFINITION(0x1, 0x598), ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_INVALID, ZYDIS_DEFINITION(0x1, 0x597), ZYDIS_DEFINITION(0x1, 0x599), ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_INVALID, ZYDIS_DEFINITION(0x1, 0x59A), ZYDIS_DEFINITION(0x1, 0x59C), ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_INVALID, ZYDIS_DEFINITION(0x1, 0x59B), ZYDIS_DEFINITION(0x1, 0x59D), ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_INVALID, ZYDIS_DEFINITION(0x1, 0x4E1), ZYDIS_DEFINITION(0x1, 0x4E3), ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_INVALID, ZYDIS_DEFINITION(0x1, 0x4E2), ZYDIS_DEFINITION(0x1, 0x4E4), ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_INVALID, ZYDIS_DEFINITION(0x1, 0x52E), ZYDIS_DEFINITION(0x1, 0x530), ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_INVALID, ZYDIS_DEFINITION(0x1, 0x52F), ZYDIS_DEFINITION(0x1, 0x531), ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_INVALID, ZYDIS_DEFINITION(0x1, 0x43C), ZYDIS_DEFINITION(0x1, 0x43E), ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_INVALID, ZYDIS_DEFINITION(0x1, 0x43D), ZYDIS_DEFINITION(0x1, 0x43F), ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_INVALID, ZYDIS_DEFINITION(0x1, 0x440), ZYDIS_DEFINITION(0x1, 0x442), ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_INVALID, ZYDIS_DEFINITION(0x1, 0x441), ZYDIS_DEFINITION(0x1, 0x443), ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_INVALID, ZYDIS_DEFINITION(0x1, 0x4D1), ZYDIS_DEFINITION(0x1, 0x4D3), ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_INVALID, ZYDIS_DEFINITION(0x1, 0x4D2), ZYDIS_DEFINITION(0x1, 0x4D4), ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_INVALID, ZYDIS_DEFINITION(0x1, 0x5DB), ZYDIS_DEFINITION(0x1, 0x5DD), ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_INVALID, ZYDIS_DEFINITION(0x1, 0x5DC), ZYDIS_DEFINITION(0x1, 0x5DE), ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_DEFINITION(0x1, 0x2C8) },
    { ZYDIS_INVALID, ZYDIS_DEFINITION(0x1, 0x566), ZYDIS_DEFINITION(0x1, 0x568), ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_INVALID, ZYDIS_DEFINITION(0x1, 0x567), ZYDIS_DEFINITION(0x1, 0x569), ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_INVALID, ZYDIS_DEFINITION(0x1, 0x559), ZYDIS_DEFINITION(0x1, 0x55B), ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_INVALID, ZYDIS_DEFINITION(0x1, 0x55A), ZYDIS_DEFINITION(0x1, 0x55C), ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_INVALID, ZYDIS_DEFINITION(0x1, 0x560), ZYDIS_DEFINITION(0x1, 0x562), ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_INVALID, ZYDIS_DEFINITION(0x1, 0x561), ZYDIS_DEFINITION(0x1, 0x563), ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_INVALID, ZYDIS_DEFINITION(0x1, 0x51B), ZYDIS_DEFINITION(0x1, 0x51D), ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_INVALID, ZYDIS_DEFINITION(0x1, 0x51C), ZYDIS_DEFINITION(0x1, 0x51E), ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_INVALID, ZYDIS_DEFINITION(0x1, 0x4C9), ZYDIS_DEFINITION(0x1, 0x4CB), ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_INVALID, ZYDIS_DEFINITION(0x1, 0x4CA), ZYDIS_DEFINITION(0x1, 0x4CC), ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_INVALID, ZYDIS_DEFINITION(0x1, 0x53B), ZYDIS_DEFINITION(0x1, 0x53D), ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_INVALID, ZYDIS_DEFINITION(0x1, 0x53C), ZYDIS_DEFINITION(0x1, 0x53E), ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_INVALID, ZYDIS_DEFINITION(0x1, 0x2F1), ZYDIS_DEFINITION(0x1, 0x2F0), ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_INVALID, ZYDIS_DEFINITION(0x1, 0x58A), ZYDIS_DEFINITION(0x1, 0x58C), ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_INVALID, ZYDIS_DEFINITION(0x1, 0x58B), ZYDIS_DEFINITION(0x1, 0x58D), ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_INVALID, ZYDIS_DEFINITION(0x1, 0x5A6), ZYDIS_DEFINITION(0x1, 0x5A8), ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_INVALID, ZYDIS_DEFINITION(0x1, 0x5A7), ZYDIS_DEFINITION(0x1, 0x5A9), ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_INVALID, ZYDIS_DEFINITION(0x1, 0x58E), ZYDIS_DEFINITION(0x1, 0x590), ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_INVALID, ZYDIS_DEFINITION(0x1, 0x58F), ZYDIS_DEFINITION(0x1, 0x591), ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_INVALID, ZYDIS_DEFINITION(0x1, 0x592), ZYDIS_DEFINITION(0x1, 0x594), ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_INVALID, ZYDIS_DEFINITION(0x1, 0x593), ZYDIS_DEFINITION(0x1, 0x595), ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_INVALID, ZYDIS_DEFINITION(0x1, 0x430), ZYDIS_DEFINITION(0x1, 0x432), ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_INVALID, ZYDIS_DEFINITION(0x1, 0x431), ZYDIS_DEFINITION(0x1, 0x433), ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_INVALID, ZYDIS_DEFINITION(0x1, 0x44C), ZYDIS_DEFINITION(0x1, 0x44E), ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_INVALID, ZYDIS_DEFINITION(0x1, 0x44D), ZYDIS_DEFINITION(0x1, 0x44F), ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_INVALID, ZYDIS_DEFINITION(0x1, 0x434), ZYDIS_DEFINITION(0x1, 0x436), ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_INVALID, ZYDIS_DEFINITION(0x1, 0x435), ZYDIS_DEFINITION(0x1, 0x437), ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0x0, 0x247), ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_DEFINITION(0x0, 0x248), ZYDIS_DEFINITION(0x0, 0x249) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_OPERAND_SIZE, 0x5), ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_OPERAND_SIZE, 0x6), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_OPERAND_SIZE, 0x7) },
    { ZYDIS_DEFINITION(0x0, 0x40A), ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_DEFINITION(0x0, 0x40B), ZYDIS_DEFINITION(0x0, 0x40C) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_OPERAND_SIZE, 0x8), ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_OPERAND_SIZE, 0x9), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_OPERAND_SIZE, 0xA) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_B, 0x0), ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_DEFINITION(0x0, 0x45C), ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0x0, 0x376), ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_DEFINITION(0x0, 0x377), ZYDIS_DEFINITION(0x0, 0x378) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_OPERAND_SIZE, 0x11), ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_OPERAND_SIZE, 0x12), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_OPERAND_SIZE, 0x13) },
    { ZYDIS_DEFINITION(0x0, 0xFD), ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_DEFINITION(0x0, 0xFE), ZYDIS_DEFINITION(0x0, 0xFF) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_OPERAND_SIZE, 0x14), ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_OPERAND_SIZE, 0x15), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_OPERAND_SIZE, 0x16) },
    { ZYDIS_DEFINITION(0x0, 0x6DF), ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_DEFINITION(0x0, 0x6E0), ZYDIS_DEFINITION(0x0, 0x6E1) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_OPERAND_SIZE, 0x17), ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_OPERAND_SIZE, 0x18), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_OPERAND_SIZE, 0x19) },
    { ZYDIS_DEFINITION(0x0, 0x2DA), ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_DEFINITION(0x0, 0x2DB), ZYDIS_DEFINITION(0x0, 0x2DC) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_OPERAND_SIZE, 0x1A), ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_OPERAND_SIZE, 0x1B), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_OPERAND_SIZE, 0x1C) },
    { ZYDIS_DEFINITION(0x0, 0x657), ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_DEFINITION(0x0, 0x658), ZYDIS_DEFINITION(0x0, 0x659) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_OPERAND_SIZE, 0x1D), ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_OPERAND_SIZE, 0x1E), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_OPERAND_SIZE, 0x1F) }
};

const ZydisDecoderTreeNode FILTERS_OPERAND_SIZE[][3] =
{
    { ZYDIS_DEFINITION(0x0, 0x710), ZYDIS_DEFINITION(0x0, 0x710), ZYDIS_DEFINITION(0x0, 0x70F) },
    { ZYDIS_DEFINITION(0x1, 0x35F), ZYDIS_DEFINITION(0x1, 0x35F), ZYDIS_DEFINITION(0x1, 0x35E) },
    { ZYDIS_DEFINITION(0x0, 0x5D5), ZYDIS_DEFINITION(0x0, 0x5D6), ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0x0, 0x527), ZYDIS_DEFINITION(0x0, 0x528), ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0x1, 0x94), ZYDIS_DEFINITION(0x1, 0x95), ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0x0, 0x254), ZYDIS_DEFINITION(0x0, 0x24A), ZYDIS_DEFINITION(0x0, 0x24B) },
    { ZYDIS_DEFINITION(0x0, 0x255), ZYDIS_DEFINITION(0x0, 0x24C), ZYDIS_DEFINITION(0x0, 0x24D) },
    { ZYDIS_DEFINITION(0x0, 0x256), ZYDIS_DEFINITION(0x0, 0x24E), ZYDIS_DEFINITION(0x0, 0x24F) },
    { ZYDIS_DEFINITION(0x0, 0x413), ZYDIS_DEFINITION(0x0, 0x40D), ZYDIS_DEFINITION(0x0, 0x40E) },
    { ZYDIS_DEFINITION(0x0, 0x414), ZYDIS_DEFINITION(0x0, 0x40F), ZYDIS_DEFINITION(0x0, 0x410) },
    { ZYDIS_DEFINITION(0x0, 0x415), ZYDIS_DEFINITION(0x0, 0x411), ZYDIS_DEFINITION(0x0, 0x412) },
    { ZYDIS_DEFINITION(0x0, 0xB6), ZYDIS_DEFINITION(0x0, 0x157), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x4F1) },
    { ZYDIS_DEFINITION(0x0, 0x156), ZYDIS_DEFINITION(0x0, 0xB7), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_REX_W, 0x4F2) },
    { ZYDIS_DEFINITION(0x0, 0x5D7), ZYDIS_DEFINITION(0x0, 0x5D9), ZYDIS_DEFINITION(0x0, 0x5D9) },
    { ZYDIS_DEFINITION(0x0, 0x5D7), ZYDIS_DEFINITION(0x0, 0x5D8), ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0x0, 0x52B), ZYDIS_DEFINITION(0x0, 0x52D), ZYDIS_DEFINITION(0x0, 0x52D) },
    { ZYDIS_DEFINITION(0x0, 0x52B), ZYDIS_DEFINITION(0x0, 0x52C), ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0x0, 0x38B), ZYDIS_DEFINITION(0x0, 0x379), ZYDIS_DEFINITION(0x0, 0x384) },
    { ZYDIS_DEFINITION(0x0, 0x38C), ZYDIS_DEFINITION(0x0, 0x37A), ZYDIS_DEFINITION(0x0, 0x385) },
    { ZYDIS_DEFINITION(0x0, 0x38D), ZYDIS_DEFINITION(0x0, 0x37B), ZYDIS_DEFINITION(0x0, 0x386) },
    { ZYDIS_DEFINITION(0x0, 0x10A), ZYDIS_DEFINITION(0x0, 0x100), ZYDIS_DEFINITION(0x0, 0x105) },
    { ZYDIS_DEFINITION(0x0, 0x10B), ZYDIS_DEFINITION(0x0, 0x101), ZYDIS_DEFINITION(0x0, 0x106) },
    { ZYDIS_DEFINITION(0x0, 0x10C), ZYDIS_DEFINITION(0x0, 0x102), ZYDIS_DEFINITION(0x0, 0x107) },
    { ZYDIS_DEFINITION(0x0, 0x6E8), ZYDIS_DEFINITION(0x0, 0x6E2), ZYDIS_DEFINITION(0x0, 0x6E5) },
    { ZYDIS_DEFINITION(0x0, 0x6E9), ZYDIS_DEFINITION(0x0, 0x6E3), ZYDIS_DEFINITION(0x0, 0x6E6) },
    { ZYDIS_DEFINITION(0x0, 0x6EA), ZYDIS_DEFINITION(0x0, 0x6E4), ZYDIS_DEFINITION(0x0, 0x6E7) },
    { ZYDIS_DEFINITION(0x0, 0x2E3), ZYDIS_DEFINITION(0x0, 0x2DD), ZYDIS_DEFINITION(0x0, 0x2E0) },
    { ZYDIS_DEFINITION(0x0, 0x2E4), ZYDIS_DEFINITION(0x0, 0x2DE), ZYDIS_DEFINITION(0x0, 0x2E1) },
    { ZYDIS_DEFINITION(0x0, 0x2E5), ZYDIS_DEFINITION(0x0, 0x2DF), ZYDIS_DEFINITION(0x0, 0x2E2) },
    { ZYDIS_DEFINITION(0x0, 0x660), ZYDIS_DEFINITION(0x0, 0x65A), ZYDIS_DEFINITION(0x0, 0x65D) },
    { ZYDIS_DEFINITION(0x0, 0x661), ZYDIS_DEFINITION(0x0, 0x65B), ZYDIS_DEFINITION(0x0, 0x65E) },
    { ZYDIS_DEFINITION(0x0, 0x662), ZYDIS_DEFINITION(0x0, 0x65C), ZYDIS_DEFINITION(0x0, 0x65F) },
    { ZYDIS_DEFINITION(0x0, 0x265), ZYDIS_DEFINITION(0x0, 0x266), ZYDIS_DEFINITION(0x0, 0x267) },
    { ZYDIS_DEFINITION(0x1, 0x1D2), ZYDIS_DEFINITION(0x1, 0x1D3), ZYDIS_DEFINITION(0x1, 0x1D3) },
    { ZYDIS_DEFINITION(0x1, 0x1E5), ZYDIS_DEFINITION(0x1, 0x1E6), ZYDIS_DEFINITION(0x1, 0x1E6) },
    { ZYDIS_DEFINITION(0x1, 0x1EE), ZYDIS_DEFINITION(0x1, 0x1EF), ZYDIS_DEFINITION(0x1, 0x1EF) },
    { ZYDIS_DEFINITION(0x1, 0x1E2), ZYDIS_DEFINITION(0x1, 0x1E3), ZYDIS_DEFINITION(0x1, 0x1E3) },
    { ZYDIS_DEFINITION(0x3, 0x23B), ZYDIS_DEFINITION(0x3, 0x23C), ZYDIS_DEFINITION(0x3, 0x23C) },
    { ZYDIS_DEFINITION(0x3, 0x405), ZYDIS_DEFINITION(0x3, 0x406), ZYDIS_DEFINITION(0x3, 0x406) },
    { ZYDIS_DEFINITION(0x0, 0x23E), ZYDIS_DEFINITION(0x0, 0x23F), ZYDIS_DEFINITION(0x0, 0x23F) },
    { ZYDIS_DEFINITION(0x0, 0x408), ZYDIS_DEFINITION(0x0, 0x409), ZYDIS_DEFINITION(0x0, 0x409) }
};

const ZydisDecoderTreeNode FILTERS_ADDRESS_SIZE[][3] =
{
    { ZYDIS_INVALID, ZYDIS_DEFINITION(0x1, 0x89), ZYDIS_INVALID },
    { ZYDIS_INVALID, ZYDIS_DEFINITION(0x1, 0x8E), ZYDIS_INVALID },
    { ZYDIS_INVALID, ZYDIS_DEFINITION(0x1, 0x7F), ZYDIS_INVALID },
    { ZYDIS_INVALID, ZYDIS_DEFINITION(0x1, 0x87), ZYDIS_INVALID },
    { ZYDIS_INVALID, ZYDIS_DEFINITION(0x1, 0x93), ZYDIS_INVALID },
    { ZYDIS_INVALID, ZYDIS_DEFINITION(0x1, 0x91), ZYDIS_INVALID },
    { ZYDIS_INVALID, ZYDIS_DEFINITION(0x1, 0x8B), ZYDIS_INVALID },
    { ZYDIS_INVALID, ZYDIS_DEFINITION(0x1, 0x83), ZYDIS_INVALID },
    { ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x1E7), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x1E7) },
    { ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x1E8), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x1E8) },
    { ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x1E9), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x1E9) },
    { ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x1EA), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x1EA) },
    { ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x1EB), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x1EB) },
    { ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x1EC), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x1EC) },
    { ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x1ED), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x1ED) },
    { ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x1EE), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x1EE) },
    { ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x20B), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x20B) },
    { ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x20C), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x20C) },
    { ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x20D), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x20D) },
    { ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x20E), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x20E) },
    { ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x20F), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x20F) },
    { ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x210), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x210) },
    { ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x211), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x211) },
    { ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x212), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x212) },
    { ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x24F), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x24F) },
    { ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x250), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x250) },
    { ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x251), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x251) },
    { ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x252), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x252) },
    { ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x253), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x253) },
    { ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x254), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x254) },
    { ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x255), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x255) },
    { ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x256), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x256) },
    { ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x257), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x257) },
    { ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x258), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x258) },
    { ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x259), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x259) },
    { ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x25A), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x25A) },
    { ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x25B), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x25B) },
    { ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x25C), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x25C) },
    { ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x25D), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x25D) },
    { ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x25E), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x25E) },
    { ZYDIS_INVALID, ZYDIS_DEFINITION(0x1, 0x4B0), ZYDIS_DEFINITION(0x1, 0x4B0) },
    { ZYDIS_INVALID, ZYDIS_DEFINITION(0x1, 0x4B2), ZYDIS_DEFINITION(0x1, 0x4B2) },
    { ZYDIS_INVALID, ZYDIS_DEFINITION(0x1, 0x4B1), ZYDIS_DEFINITION(0x1, 0x4B1) },
    { ZYDIS_INVALID, ZYDIS_DEFINITION(0x1, 0x4B3), ZYDIS_DEFINITION(0x1, 0x4B3) },
    { ZYDIS_INVALID, ZYDIS_DEFINITION(0x1, 0x4B4), ZYDIS_DEFINITION(0x1, 0x4B4) },
    { ZYDIS_INVALID, ZYDIS_DEFINITION(0x1, 0x4B6), ZYDIS_DEFINITION(0x1, 0x4B6) },
    { ZYDIS_INVALID, ZYDIS_DEFINITION(0x1, 0x4B5), ZYDIS_DEFINITION(0x1, 0x4B5) },
    { ZYDIS_INVALID, ZYDIS_DEFINITION(0x1, 0x4B7), ZYDIS_DEFINITION(0x1, 0x4B7) },
    { ZYDIS_INVALID, ZYDIS_DEFINITION(0x1, 0x2CD), ZYDIS_DEFINITION(0x1, 0x2CD) },
    { ZYDIS_INVALID, ZYDIS_DEFINITION(0x1, 0x2CB), ZYDIS_DEFINITION(0x1, 0x2CB) },
    { ZYDIS_INVALID, ZYDIS_DEFINITION(0x1, 0x2CE), ZYDIS_DEFINITION(0x1, 0x2CE) },
    { ZYDIS_INVALID, ZYDIS_DEFINITION(0x1, 0x2CC), ZYDIS_DEFINITION(0x1, 0x2CC) },
    { ZYDIS_INVALID, ZYDIS_DEFINITION(0x1, 0x2D1), ZYDIS_DEFINITION(0x1, 0x2D1) },
    { ZYDIS_INVALID, ZYDIS_DEFINITION(0x1, 0x2CF), ZYDIS_DEFINITION(0x1, 0x2CF) },
    { ZYDIS_INVALID, ZYDIS_DEFINITION(0x1, 0x2D2), ZYDIS_DEFINITION(0x1, 0x2D2) },
    { ZYDIS_INVALID, ZYDIS_DEFINITION(0x1, 0x2D0), ZYDIS_DEFINITION(0x1, 0x2D0) },
    { ZYDIS_INVALID, ZYDIS_DEFINITION(0x8, 0x273), ZYDIS_DEFINITION(0x8, 0x2BA) },
    { ZYDIS_DEFINITION(0x8, 0x272), ZYDIS_DEFINITION(0x8, 0x274), ZYDIS_INVALID }
};

const ZydisDecoderTreeNode FILTERS_VECTOR_LENGTH[][3] =
{
    { ZYDIS_DEFINITION(0x1, 0x6CF), ZYDIS_DEFINITION(0x1, 0x6D0), ZYDIS_DEFINITION(0x1, 0x6D1) },
    { ZYDIS_DEFINITION(0x1, 0x6D2), ZYDIS_DEFINITION(0x1, 0x6D3), ZYDIS_DEFINITION(0x1, 0x6D4) },
    { ZYDIS_DEFINITION(0x1, 0x6D5), ZYDIS_DEFINITION(0x1, 0x6D6), ZYDIS_DEFINITION(0x1, 0x6D7) },
    { ZYDIS_DEFINITION(0x1, 0x6D8), ZYDIS_DEFINITION(0x1, 0x6D9), ZYDIS_DEFINITION(0x1, 0x6DA) },
    { ZYDIS_DEFINITION(0x1, 0x68D), ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0x1, 0x695), ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0x1, 0x696), ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0x1, 0xE2A), ZYDIS_DEFINITION(0x1, 0xE2B), ZYDIS_DEFINITION(0x1, 0xE2C) },
    { ZYDIS_DEFINITION(0x1, 0xE2D), ZYDIS_DEFINITION(0x1, 0xE2E), ZYDIS_DEFINITION(0x1, 0xE2F) },
    { ZYDIS_DEFINITION(0x1, 0xE1E), ZYDIS_DEFINITION(0x1, 0xE1F), ZYDIS_DEFINITION(0x1, 0xE20) },
    { ZYDIS_DEFINITION(0x1, 0xE21), ZYDIS_DEFINITION(0x1, 0xE22), ZYDIS_DEFINITION(0x1, 0xE23) },
    { ZYDIS_DEFINITION(0x1, 0x692), ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0x1, 0x690), ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0x1, 0x691), ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0x1, 0x62B), ZYDIS_DEFINITION(0x1, 0x62C), ZYDIS_DEFINITION(0x1, 0x62D) },
    { ZYDIS_DEFINITION(0x1, 0x62E), ZYDIS_DEFINITION(0x1, 0x62F), ZYDIS_DEFINITION(0x1, 0x630) },
    { ZYDIS_DEFINITION(0x1, 0x631), ZYDIS_DEFINITION(0x1, 0x632), ZYDIS_DEFINITION(0x1, 0x633) },
    { ZYDIS_DEFINITION(0x1, 0x634), ZYDIS_DEFINITION(0x1, 0x635), ZYDIS_DEFINITION(0x1, 0x636) },
    { ZYDIS_DEFINITION(0x1, 0x6A0), ZYDIS_DEFINITION(0x1, 0x6A1), ZYDIS_DEFINITION(0x1, 0x6A2) },
    { ZYDIS_DEFINITION(0x1, 0xDE2), ZYDIS_DEFINITION(0x1, 0xDE3), ZYDIS_DEFINITION(0x1, 0xDE4) },
    { ZYDIS_DEFINITION(0x1, 0xDE5), ZYDIS_DEFINITION(0x1, 0xDE6), ZYDIS_DEFINITION(0x1, 0xDE7) },
    { ZYDIS_DEFINITION(0x1, 0x58), ZYDIS_DEFINITION(0x1, 0x59), ZYDIS_DEFINITION(0x1, 0x5A) },
    { ZYDIS_DEFINITION(0x1, 0x5B), ZYDIS_DEFINITION(0x1, 0x5C), ZYDIS_DEFINITION(0x1, 0x5D) },
    { ZYDIS_DEFINITION(0x1, 0x4C), ZYDIS_DEFINITION(0x1, 0x4D), ZYDIS_DEFINITION(0x1, 0x4E) },
    { ZYDIS_DEFINITION(0x1, 0x4F), ZYDIS_DEFINITION(0x1, 0x50), ZYDIS_DEFINITION(0x1, 0x51) },
    { ZYDIS_DEFINITION(0x1, 0x703), ZYDIS_DEFINITION(0x1, 0x704), ZYDIS_DEFINITION(0x1, 0x705) },
    { ZYDIS_DEFINITION(0x1, 0x706), ZYDIS_DEFINITION(0x1, 0x707), ZYDIS_DEFINITION(0x1, 0x708) },
    { ZYDIS_DEFINITION(0x1, 0xE36), ZYDIS_DEFINITION(0x1, 0xE37), ZYDIS_DEFINITION(0x1, 0xE38) },
    { ZYDIS_DEFINITION(0x1, 0xE39), ZYDIS_DEFINITION(0x1, 0xE3A), ZYDIS_DEFINITION(0x1, 0xE3B) },
    { ZYDIS_DEFINITION(0x1, 0x13), ZYDIS_DEFINITION(0x1, 0x14), ZYDIS_DEFINITION(0x1, 0x15) },
    { ZYDIS_DEFINITION(0x1, 0x16), ZYDIS_DEFINITION(0x1, 0x17), ZYDIS_DEFINITION(0x1, 0x18) },
    { ZYDIS_DEFINITION(0x1, 0x6EE), ZYDIS_DEFINITION(0x1, 0x6EF), ZYDIS_DEFINITION(0x1, 0x6F0) },
    { ZYDIS_DEFINITION(0x1, 0x6F1), ZYDIS_DEFINITION(0x1, 0x6F2), ZYDIS_DEFINITION(0x1, 0x6F3) },
    { ZYDIS_DEFINITION(0x1, 0x14F), ZYDIS_DEFINITION(0x1, 0x150), ZYDIS_DEFINITION(0x1, 0x151) },
    { ZYDIS_DEFINITION(0x1, 0x152), ZYDIS_DEFINITION(0x1, 0x153), ZYDIS_DEFINITION(0x1, 0x154) },
    { ZYDIS_DEFINITION(0x1, 0xCC), ZYDIS_DEFINITION(0x1, 0xCD), ZYDIS_DEFINITION(0x1, 0xCE) },
    { ZYDIS_DEFINITION(0x1, 0x187), ZYDIS_DEFINITION(0x1, 0x188), ZYDIS_DEFINITION(0x1, 0x189) },
    { ZYDIS_DEFINITION(0x1, 0xCF), ZYDIS_DEFINITION(0x1, 0xD0), ZYDIS_DEFINITION(0x1, 0xD1) },
    { ZYDIS_DEFINITION(0x1, 0x18A), ZYDIS_DEFINITION(0x1, 0x18B), ZYDIS_DEFINITION(0x1, 0x18C) },
    { ZYDIS_DEFINITION(0x1, 0xE00), ZYDIS_DEFINITION(0x1, 0xE01), ZYDIS_DEFINITION(0x1, 0xE02) },
    { ZYDIS_DEFINITION(0x1, 0xE03), ZYDIS_DEFINITION(0x1, 0xE04), ZYDIS_DEFINITION(0x1, 0xE05) },
    { ZYDIS_DEFINITION(0x1, 0x610), ZYDIS_DEFINITION(0x1, 0x611), ZYDIS_DEFINITION(0x1, 0x612) },
    { ZYDIS_DEFINITION(0x1, 0x613), ZYDIS_DEFINITION(0x1, 0x614), ZYDIS_DEFINITION(0x1, 0x615) },
    { ZYDIS_DEFINITION(0x1, 0x2EC), ZYDIS_DEFINITION(0x1, 0x2ED), ZYDIS_DEFINITION(0x1, 0x2EE) },
    { ZYDIS_DEFINITION(0x1, 0x2EF), ZYDIS_DEFINITION(0x1, 0x2F0), ZYDIS_DEFINITION(0x1, 0x2F1) },
    { ZYDIS_DEFINITION(0x1, 0x5F2), ZYDIS_DEFINITION(0x1, 0x5F3), ZYDIS_DEFINITION(0x1, 0x5F4) },
    { ZYDIS_DEFINITION(0x1, 0x5F5), ZYDIS_DEFINITION(0x1, 0x5F6), ZYDIS_DEFINITION(0x1, 0x5F7) },
    { ZYDIS_DEFINITION(0x1, 0x243), ZYDIS_DEFINITION(0x1, 0x244), ZYDIS_DEFINITION(0x1, 0x245) },
    { ZYDIS_DEFINITION(0x1, 0x1FD), ZYDIS_DEFINITION(0x1, 0x1FE), ZYDIS_DEFINITION(0x1, 0x1FF) },
    { ZYDIS_DEFINITION(0x1, 0x246), ZYDIS_DEFINITION(0x1, 0x247), ZYDIS_DEFINITION(0x1, 0x248) },
    { ZYDIS_DEFINITION(0x1, 0x200), ZYDIS_DEFINITION(0x1, 0x201), ZYDIS_DEFINITION(0x1, 0x202) },
    { ZYDIS_DEFINITION(0x1, 0x16B), ZYDIS_DEFINITION(0x1, 0x16C), ZYDIS_DEFINITION(0x1, 0x16D) },
    { ZYDIS_DEFINITION(0x1, 0xFB), ZYDIS_DEFINITION(0x1, 0xFC), ZYDIS_DEFINITION(0x1, 0xFD) },
    { ZYDIS_DEFINITION(0x1, 0x16E), ZYDIS_DEFINITION(0x1, 0x16F), ZYDIS_DEFINITION(0x1, 0x170) },
    { ZYDIS_DEFINITION(0x1, 0xFE), ZYDIS_DEFINITION(0x1, 0xFF), ZYDIS_DEFINITION(0x1, 0x100) },
    { ZYDIS_DEFINITION(0xB, 0x99), ZYDIS_DEFINITION(0xB, 0x9A), ZYDIS_DEFINITION(0xB, 0x9B) },
    { ZYDIS_DEFINITION(0xB, 0x9C), ZYDIS_DEFINITION(0xB, 0x9D), ZYDIS_DEFINITION(0xB, 0x9E) },
    { ZYDIS_DEFINITION(0xB, 0xDCD), ZYDIS_DEFINITION(0xB, 0xDCE), ZYDIS_DEFINITION(0xB, 0xDCF) },
    { ZYDIS_DEFINITION(0xB, 0xDD0), ZYDIS_DEFINITION(0xB, 0xDD1), ZYDIS_DEFINITION(0xB, 0xDD2) },
    { ZYDIS_DEFINITION(0xB, 0xD4B), ZYDIS_DEFINITION(0xB, 0xD4C), ZYDIS_DEFINITION(0xB, 0xD4D) },
    { ZYDIS_DEFINITION(0xB, 0xD4E), ZYDIS_DEFINITION(0xB, 0xD4F), ZYDIS_DEFINITION(0xB, 0xD50) },
    { ZYDIS_DEFINITION(0xB, 0x5A1), ZYDIS_DEFINITION(0xB, 0x5A2), ZYDIS_DEFINITION(0xB, 0x5A3) },
    { ZYDIS_DEFINITION(0xB, 0x5A4), ZYDIS_DEFINITION(0xB, 0x5A5), ZYDIS_DEFINITION(0xB, 0x5A6) },
    { ZYDIS_DEFINITION(0xB, 0xD2D), ZYDIS_DEFINITION(0xB, 0xD2E), ZYDIS_DEFINITION(0xB, 0xD2F) },
    { ZYDIS_DEFINITION(0xB, 0xD30), ZYDIS_DEFINITION(0xB, 0xD31), ZYDIS_DEFINITION(0xB, 0xD32) },
    { ZYDIS_DEFINITION(0xB, 0x555), ZYDIS_DEFINITION(0xB, 0x556), ZYDIS_DEFINITION(0xB, 0x557) },
    { ZYDIS_DEFINITION(0xB, 0x558), ZYDIS_DEFINITION(0xB, 0x559), ZYDIS_DEFINITION(0xB, 0x55A) },
    { ZYDIS_DEFINITION(0xB, 0x92), ZYDIS_DEFINITION(0xB, 0x93), ZYDIS_DEFINITION(0xB, 0x94) },
    { ZYDIS_DEFINITION(0xB, 0x95), ZYDIS_DEFINITION(0xB, 0x96), ZYDIS_DEFINITION(0xB, 0x97) },
    { ZYDIS_DEFINITION(0x1, 0xDDB), ZYDIS_DEFINITION(0x1, 0xDDC), ZYDIS_DEFINITION(0x1, 0xDDD) },
    { ZYDIS_DEFINITION(0x1, 0xDDE), ZYDIS_DEFINITION(0x1, 0xDDF), ZYDIS_DEFINITION(0x1, 0xDE0) },
    { ZYDIS_DEFINITION(0x1, 0xC), ZYDIS_DEFINITION(0x1, 0xD), ZYDIS_DEFINITION(0x1, 0xE) },
    { ZYDIS_DEFINITION(0x1, 0xF), ZYDIS_DEFINITION(0x1, 0x10), ZYDIS_DEFINITION(0x1, 0x11) },
    { ZYDIS_DEFINITION(0x1, 0x6E7), ZYDIS_DEFINITION(0x1, 0x6E8), ZYDIS_DEFINITION(0x1, 0x6E9) },
    { ZYDIS_DEFINITION(0x1, 0x6EA), ZYDIS_DEFINITION(0x1, 0x6EB), ZYDIS_DEFINITION(0x1, 0x6EC) },
    { ZYDIS_DEFINITION(0x1, 0x110), ZYDIS_DEFINITION(0x1, 0x111), ZYDIS_DEFINITION(0x1, 0x112) },
    { ZYDIS_DEFINITION(0x1, 0x113), ZYDIS_DEFINITION(0x1, 0x114), ZYDIS_DEFINITION(0x1, 0x115) },
    { ZYDIS_DEFINITION(0x1, 0xC5), ZYDIS_DEFINITION(0x1, 0xC6), ZYDIS_DEFINITION(0x1, 0xC7) },
    { ZYDIS_DEFINITION(0x1, 0x180), ZYDIS_DEFINITION(0x1, 0x181), ZYDIS_DEFINITION(0x1, 0x182) },
    { ZYDIS_DEFINITION(0x1, 0xC8), ZYDIS_DEFINITION(0x1, 0xC9), ZYDIS_DEFINITION(0x1, 0xCA) },
    { ZYDIS_DEFINITION(0x1, 0x183), ZYDIS_DEFINITION(0x1, 0x184), ZYDIS_DEFINITION(0x1, 0x185) },
    { ZYDIS_DEFINITION(0x1, 0xDF9), ZYDIS_DEFINITION(0x1, 0xDFA), ZYDIS_DEFINITION(0x1, 0xDFB) },
    { ZYDIS_DEFINITION(0x1, 0xDFC), ZYDIS_DEFINITION(0x1, 0xDFD), ZYDIS_DEFINITION(0x1, 0xDFE) },
    { ZYDIS_DEFINITION(0x1, 0x609), ZYDIS_DEFINITION(0x1, 0x60A), ZYDIS_DEFINITION(0x1, 0x60B) },
    { ZYDIS_DEFINITION(0x1, 0x60C), ZYDIS_DEFINITION(0x1, 0x60D), ZYDIS_DEFINITION(0x1, 0x60E) },
    { ZYDIS_DEFINITION(0x1, 0x2E5), ZYDIS_DEFINITION(0x1, 0x2E6), ZYDIS_DEFINITION(0x1, 0x2E7) },
    { ZYDIS_DEFINITION(0x1, 0x2E8), ZYDIS_DEFINITION(0x1, 0x2E9), ZYDIS_DEFINITION(0x1, 0x2EA) },
    { ZYDIS_DEFINITION(0x1, 0x5EB), ZYDIS_DEFINITION(0x1, 0x5EC), ZYDIS_DEFINITION(0x1, 0x5ED) },
    { ZYDIS_DEFINITION(0x1, 0x5EE), ZYDIS_DEFINITION(0x1, 0x5EF), ZYDIS_DEFINITION(0x1, 0x5F0) },
    { ZYDIS_DEFINITION(0x1, 0x219), ZYDIS_DEFINITION(0x1, 0x21A), ZYDIS_DEFINITION(0x1, 0x21B) },
    { ZYDIS_DEFINITION(0x1, 0x21C), ZYDIS_DEFINITION(0x1, 0x21D), ZYDIS_DEFINITION(0x1, 0x21E) },
    { ZYDIS_DEFINITION(0x1, 0x12C), ZYDIS_DEFINITION(0x1, 0x12D), ZYDIS_DEFINITION(0x1, 0x12E) },
    { ZYDIS_DEFINITION(0x1, 0x12F), ZYDIS_DEFINITION(0x1, 0x130), ZYDIS_DEFINITION(0x1, 0x131) },
    { ZYDIS_DEFINITION(0x1, 0x227), ZYDIS_DEFINITION(0x1, 0x228), ZYDIS_DEFINITION(0x1, 0x229) },
    { ZYDIS_DEFINITION(0x1, 0x22A), ZYDIS_DEFINITION(0x1, 0x22B), ZYDIS_DEFINITION(0x1, 0x22C) },
    { ZYDIS_DEFINITION(0x1, 0x13A), ZYDIS_DEFINITION(0x1, 0x13B), ZYDIS_DEFINITION(0x1, 0x13C) },
    { ZYDIS_DEFINITION(0x1, 0x13D), ZYDIS_DEFINITION(0x1, 0x13E), ZYDIS_DEFINITION(0x1, 0x13F) },
    { ZYDIS_DEFINITION(0x1, 0x6C3), ZYDIS_DEFINITION(0x1, 0x6C4), ZYDIS_DEFINITION(0x1, 0x6C5) },
    { ZYDIS_DEFINITION(0x1, 0x6C6), ZYDIS_DEFINITION(0x1, 0x6C7), ZYDIS_DEFINITION(0x1, 0x6C8) },
    { ZYDIS_DEFINITION(0x1, 0x6C9), ZYDIS_DEFINITION(0x1, 0x6CA), ZYDIS_DEFINITION(0x1, 0x6CB) },
    { ZYDIS_DEFINITION(0x1, 0x6CC), ZYDIS_DEFINITION(0x1, 0x6CD), ZYDIS_DEFINITION(0x1, 0x6CE) },
    { ZYDIS_DEFINITION(0x1, 0x693), ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0x1, 0x694), ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0x1, 0xE24), ZYDIS_DEFINITION(0x1, 0xE25), ZYDIS_DEFINITION(0x1, 0xE26) },
    { ZYDIS_DEFINITION(0x1, 0xE27), ZYDIS_DEFINITION(0x1, 0xE28), ZYDIS_DEFINITION(0x1, 0xE29) },
    { ZYDIS_DEFINITION(0x1, 0xE18), ZYDIS_DEFINITION(0x1, 0xE19), ZYDIS_DEFINITION(0x1, 0xE1A) },
    { ZYDIS_DEFINITION(0x1, 0xE1B), ZYDIS_DEFINITION(0x1, 0xE1C), ZYDIS_DEFINITION(0x1, 0xE1D) },
    { ZYDIS_DEFINITION(0x1, 0x68E), ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0x1, 0x68F), ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0x1, 0x61F), ZYDIS_DEFINITION(0x1, 0x620), ZYDIS_DEFINITION(0x1, 0x621) },
    { ZYDIS_DEFINITION(0x1, 0x622), ZYDIS_DEFINITION(0x1, 0x623), ZYDIS_DEFINITION(0x1, 0x624) },
    { ZYDIS_DEFINITION(0x1, 0x625), ZYDIS_DEFINITION(0x1, 0x626), ZYDIS_DEFINITION(0x1, 0x627) },
    { ZYDIS_DEFINITION(0x1, 0x628), ZYDIS_DEFINITION(0x1, 0x629), ZYDIS_DEFINITION(0x1, 0x62A) },
    { ZYDIS_DEFINITION(0x1, 0x69D), ZYDIS_DEFINITION(0x1, 0x69E), ZYDIS_DEFINITION(0x1, 0x69F) },
    { ZYDIS_DEFINITION(0x1, 0xDD4), ZYDIS_DEFINITION(0x1, 0xDD5), ZYDIS_DEFINITION(0x1, 0xDD6) },
    { ZYDIS_DEFINITION(0x1, 0xDD7), ZYDIS_DEFINITION(0x1, 0xDD8), ZYDIS_DEFINITION(0x1, 0xDD9) },
    { ZYDIS_DEFINITION(0x1, 0x52), ZYDIS_DEFINITION(0x1, 0x53), ZYDIS_DEFINITION(0x1, 0x54) },
    { ZYDIS_DEFINITION(0x1, 0x55), ZYDIS_DEFINITION(0x1, 0x56), ZYDIS_DEFINITION(0x1, 0x57) },
    { ZYDIS_DEFINITION(0x1, 0x46), ZYDIS_DEFINITION(0x1, 0x47), ZYDIS_DEFINITION(0x1, 0x48) },
    { ZYDIS_DEFINITION(0x1, 0x49), ZYDIS_DEFINITION(0x1, 0x4A), ZYDIS_DEFINITION(0x1, 0x4B) },
    { ZYDIS_DEFINITION(0x1, 0x6FD), ZYDIS_DEFINITION(0x1, 0x6FE), ZYDIS_DEFINITION(0x1, 0x6FF) },
    { ZYDIS_DEFINITION(0x1, 0x700), ZYDIS_DEFINITION(0x1, 0x701), ZYDIS_DEFINITION(0x1, 0x702) },
    { ZYDIS_DEFINITION(0x1, 0xE30), ZYDIS_DEFINITION(0x1, 0xE31), ZYDIS_DEFINITION(0x1, 0xE32) },
    { ZYDIS_DEFINITION(0x1, 0xE33), ZYDIS_DEFINITION(0x1, 0xE34), ZYDIS_DEFINITION(0x1, 0xE35) },
    { ZYDIS_DEFINITION(0x1, 0x5), ZYDIS_DEFINITION(0x1, 0x6), ZYDIS_DEFINITION(0x1, 0x7) },
    { ZYDIS_DEFINITION(0x1, 0x8), ZYDIS_DEFINITION(0x1, 0x9), ZYDIS_DEFINITION(0x1, 0xA) },
    { ZYDIS_DEFINITION(0x1, 0x6E0), ZYDIS_DEFINITION(0x1, 0x6E1), ZYDIS_DEFINITION(0x1, 0x6E2) },
    { ZYDIS_DEFINITION(0x1, 0x6E3), ZYDIS_DEFINITION(0x1, 0x6E4), ZYDIS_DEFINITION(0x1, 0x6E5) },
    { ZYDIS_DEFINITION(0x1, 0xED), ZYDIS_DEFINITION(0x1, 0xEE), ZYDIS_DEFINITION(0x1, 0xEF) },
    { ZYDIS_DEFINITION(0x1, 0xF0), ZYDIS_DEFINITION(0x1, 0xF1), ZYDIS_DEFINITION(0x1, 0xF2) },
    { ZYDIS_DEFINITION(0x1, 0x148), ZYDIS_DEFINITION(0x1, 0x149), ZYDIS_DEFINITION(0x1, 0x14A) },
    { ZYDIS_DEFINITION(0x1, 0x14B), ZYDIS_DEFINITION(0x1, 0x14C), ZYDIS_DEFINITION(0x1, 0x14D) },
    { ZYDIS_DEFINITION(0x1, 0xDF2), ZYDIS_DEFINITION(0x1, 0xDF3), ZYDIS_DEFINITION(0x1, 0xDF4) },
    { ZYDIS_DEFINITION(0x1, 0xDF5), ZYDIS_DEFINITION(0x1, 0xDF6), ZYDIS_DEFINITION(0x1, 0xDF7) },
    { ZYDIS_DEFINITION(0x1, 0x602), ZYDIS_DEFINITION(0x1, 0x603), ZYDIS_DEFINITION(0x1, 0x604) },
    { ZYDIS_DEFINITION(0x1, 0x605), ZYDIS_DEFINITION(0x1, 0x606), ZYDIS_DEFINITION(0x1, 0x607) },
    { ZYDIS_DEFINITION(0x1, 0x2DE), ZYDIS_DEFINITION(0x1, 0x2DF), ZYDIS_DEFINITION(0x1, 0x2E0) },
    { ZYDIS_DEFINITION(0x1, 0x2E1), ZYDIS_DEFINITION(0x1, 0x2E2), ZYDIS_DEFINITION(0x1, 0x2E3) },
    { ZYDIS_DEFINITION(0x1, 0x5E4), ZYDIS_DEFINITION(0x1, 0x5E5), ZYDIS_DEFINITION(0x1, 0x5E6) },
    { ZYDIS_DEFINITION(0x1, 0x5E7), ZYDIS_DEFINITION(0x1, 0x5E8), ZYDIS_DEFINITION(0x1, 0x5E9) },
    { ZYDIS_DEFINITION(0x1, 0xCC9), ZYDIS_DEFINITION(0x1, 0xCCA), ZYDIS_DEFINITION(0x1, 0xCCB) },
    { ZYDIS_DEFINITION(0x1, 0xCCC), ZYDIS_DEFINITION(0x1, 0xCCD), ZYDIS_DEFINITION(0x1, 0xCCE) },
    { ZYDIS_DEFINITION(0x1, 0xCDB), ZYDIS_DEFINITION(0x1, 0xCDC), ZYDIS_DEFINITION(0x1, 0xCDD) },
    { ZYDIS_DEFINITION(0x1, 0xCDE), ZYDIS_DEFINITION(0x1, 0xCDF), ZYDIS_DEFINITION(0x1, 0xCE0) },
    { ZYDIS_DEFINITION(0x1, 0xCCF), ZYDIS_DEFINITION(0x1, 0xCD0), ZYDIS_DEFINITION(0x1, 0xCD1) },
    { ZYDIS_DEFINITION(0x1, 0xCD2), ZYDIS_DEFINITION(0x1, 0xCD3), ZYDIS_DEFINITION(0x1, 0xCD4) },
    { ZYDIS_DEFINITION(0x1, 0x735), ZYDIS_DEFINITION(0x1, 0x736), ZYDIS_DEFINITION(0x1, 0x737) },
    { ZYDIS_DEFINITION(0x1, 0x738), ZYDIS_DEFINITION(0x1, 0x739), ZYDIS_DEFINITION(0x1, 0x73A) },
    { ZYDIS_DEFINITION(0x1, 0x810), ZYDIS_DEFINITION(0x1, 0x811), ZYDIS_DEFINITION(0x1, 0x812) },
    { ZYDIS_DEFINITION(0x1, 0x813), ZYDIS_DEFINITION(0x1, 0x814), ZYDIS_DEFINITION(0x1, 0x815) },
    { ZYDIS_DEFINITION(0x1, 0x822), ZYDIS_DEFINITION(0x1, 0x823), ZYDIS_DEFINITION(0x1, 0x824) },
    { ZYDIS_DEFINITION(0x1, 0x825), ZYDIS_DEFINITION(0x1, 0x826), ZYDIS_DEFINITION(0x1, 0x827) },
    { ZYDIS_DEFINITION(0x1, 0x816), ZYDIS_DEFINITION(0x1, 0x817), ZYDIS_DEFINITION(0x1, 0x818) },
    { ZYDIS_DEFINITION(0x1, 0x819), ZYDIS_DEFINITION(0x1, 0x81A), ZYDIS_DEFINITION(0x1, 0x81B) },
    { ZYDIS_DEFINITION(0x1, 0x741), ZYDIS_DEFINITION(0x1, 0x742), ZYDIS_DEFINITION(0x1, 0x743) },
    { ZYDIS_DEFINITION(0x1, 0x744), ZYDIS_DEFINITION(0x1, 0x745), ZYDIS_DEFINITION(0x1, 0x746) },
    { ZYDIS_DEFINITION(0x1, 0xCB1), ZYDIS_DEFINITION(0x1, 0xCB2), ZYDIS_DEFINITION(0x1, 0xCB3) },
    { ZYDIS_DEFINITION(0x1, 0xCB4), ZYDIS_DEFINITION(0x1, 0xCB5), ZYDIS_DEFINITION(0x1, 0xCB6) },
    { ZYDIS_DEFINITION(0x1, 0xCC3), ZYDIS_DEFINITION(0x1, 0xCC4), ZYDIS_DEFINITION(0x1, 0xCC5) },
    { ZYDIS_DEFINITION(0x1, 0xCC6), ZYDIS_DEFINITION(0x1, 0xCC7), ZYDIS_DEFINITION(0x1, 0xCC8) },
    { ZYDIS_DEFINITION(0x1, 0xCB7), ZYDIS_DEFINITION(0x1, 0xCB8), ZYDIS_DEFINITION(0x1, 0xCB9) },
    { ZYDIS_DEFINITION(0x1, 0xCBA), ZYDIS_DEFINITION(0x1, 0xCBB), ZYDIS_DEFINITION(0x1, 0xCBC) },
    { ZYDIS_DEFINITION(0x1, 0x72F), ZYDIS_DEFINITION(0x1, 0x730), ZYDIS_DEFINITION(0x1, 0x731) },
    { ZYDIS_DEFINITION(0x1, 0x732), ZYDIS_DEFINITION(0x1, 0x733), ZYDIS_DEFINITION(0x1, 0x734) },
    { ZYDIS_DEFINITION(0x1, 0xCD5), ZYDIS_DEFINITION(0x1, 0xCD6), ZYDIS_DEFINITION(0x1, 0xCD7) },
    { ZYDIS_DEFINITION(0x1, 0xCD8), ZYDIS_DEFINITION(0x1, 0xCD9), ZYDIS_DEFINITION(0x1, 0xCDA) },
    { ZYDIS_DEFINITION(0x1, 0xCBD), ZYDIS_DEFINITION(0x1, 0xCBE), ZYDIS_DEFINITION(0x1, 0xCBF) },
    { ZYDIS_DEFINITION(0x1, 0xCC0), ZYDIS_DEFINITION(0x1, 0xCC1), ZYDIS_DEFINITION(0x1, 0xCC2) },
    { ZYDIS_DEFINITION(0x1, 0x637), ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0x1, 0x6A3), ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0x1, 0x639), ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0x1, 0x638), ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0x1, 0x6A4), ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0x1, 0x63A), ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0x1, 0x645), ZYDIS_DEFINITION(0x1, 0x646), ZYDIS_DEFINITION(0x1, 0x647) },
    { ZYDIS_DEFINITION(0x1, 0x651), ZYDIS_DEFINITION(0x1, 0x652), ZYDIS_DEFINITION(0x1, 0x653) },
    { ZYDIS_DEFINITION(0x1, 0x648), ZYDIS_DEFINITION(0x1, 0x649), ZYDIS_DEFINITION(0x1, 0x64A) },
    { ZYDIS_DEFINITION(0x1, 0x654), ZYDIS_DEFINITION(0x1, 0x655), ZYDIS_DEFINITION(0x1, 0x656) },
    { ZYDIS_DEFINITION(0xB, 0xB85), ZYDIS_DEFINITION(0xB, 0xB86), ZYDIS_DEFINITION(0xB, 0xB87) },
    { ZYDIS_DEFINITION(0xB, 0xB88), ZYDIS_DEFINITION(0xB, 0xB89), ZYDIS_DEFINITION(0xB, 0xB8A) },
    { ZYDIS_DEFINITION(0xB, 0xC39), ZYDIS_DEFINITION(0xB, 0xC3A), ZYDIS_DEFINITION(0xB, 0xC3B) },
    { ZYDIS_DEFINITION(0xB, 0xBFD), ZYDIS_DEFINITION(0xB, 0xBFE), ZYDIS_DEFINITION(0xB, 0xBFF) },
    { ZYDIS_DEFINITION(0xB, 0xBC7), ZYDIS_DEFINITION(0xB, 0xBC8), ZYDIS_DEFINITION(0xB, 0xBC9) },
    { ZYDIS_DEFINITION(0xB, 0xC3C), ZYDIS_DEFINITION(0xB, 0xC3D), ZYDIS_DEFINITION(0xB, 0xC3E) },
    { ZYDIS_DEFINITION(0xB, 0xC00), ZYDIS_DEFINITION(0xB, 0xC01), ZYDIS_DEFINITION(0xB, 0xC02) },
    { ZYDIS_DEFINITION(0xB, 0xBCA), ZYDIS_DEFINITION(0xB, 0xBCB), ZYDIS_DEFINITION(0xB, 0xBCC) },
    { ZYDIS_DEFINITION(0xB, 0xB07), ZYDIS_DEFINITION(0xB, 0xB08), ZYDIS_DEFINITION(0xB, 0xB09) },
    { ZYDIS_DEFINITION(0xB, 0xB0D), ZYDIS_DEFINITION(0xB, 0xB0E), ZYDIS_DEFINITION(0xB, 0xB0F) },
    { ZYDIS_DEFINITION(0xB, 0xAEF), ZYDIS_DEFINITION(0xB, 0xAF0), ZYDIS_DEFINITION(0xB, 0xAF1) },
    { ZYDIS_DEFINITION(0xB, 0xAF5), ZYDIS_DEFINITION(0xB, 0xAF6), ZYDIS_DEFINITION(0xB, 0xAF7) },
    { ZYDIS_DEFINITION(0xB, 0xC09), ZYDIS_DEFINITION(0xB, 0xC0A), ZYDIS_DEFINITION(0xB, 0xC0B) },
    { ZYDIS_DEFINITION(0xB, 0xBD3), ZYDIS_DEFINITION(0xB, 0xBD4), ZYDIS_DEFINITION(0xB, 0xBD5) },
    { ZYDIS_DEFINITION(0xB, 0xBDF), ZYDIS_DEFINITION(0xB, 0xBE0), ZYDIS_DEFINITION(0xB, 0xBE1) },
    { ZYDIS_DEFINITION(0xB, 0xB97), ZYDIS_DEFINITION(0xB, 0xB98), ZYDIS_DEFINITION(0xB, 0xB99) },
    { ZYDIS_DEFINITION(0xB, 0xB0A), ZYDIS_DEFINITION(0xB, 0xB0B), ZYDIS_DEFINITION(0xB, 0xB0C) },
    { ZYDIS_DEFINITION(0xB, 0xB10), ZYDIS_DEFINITION(0xB, 0xB11), ZYDIS_DEFINITION(0xB, 0xB12) },
    { ZYDIS_DEFINITION(0xB, 0xAF2), ZYDIS_DEFINITION(0xB, 0xAF3), ZYDIS_DEFINITION(0xB, 0xAF4) },
    { ZYDIS_DEFINITION(0xB, 0xAF8), ZYDIS_DEFINITION(0xB, 0xAF9), ZYDIS_DEFINITION(0xB, 0xAFA) },
    { ZYDIS_DEFINITION(0xB, 0xC0C), ZYDIS_DEFINITION(0xB, 0xC0D), ZYDIS_DEFINITION(0xB, 0xC0E) },
    { ZYDIS_DEFINITION(0xB, 0xBD6), ZYDIS_DEFINITION(0xB, 0xBD7), ZYDIS_DEFINITION(0xB, 0xBD8) },
    { ZYDIS_DEFINITION(0xB, 0xBE2), ZYDIS_DEFINITION(0xB, 0xBE3), ZYDIS_DEFINITION(0xB, 0xBE4) },
    { ZYDIS_DEFINITION(0xB, 0xB9A), ZYDIS_DEFINITION(0xB, 0xB9B), ZYDIS_DEFINITION(0xB, 0xB9C) },
    { ZYDIS_DEFINITION(0xB, 0xC1B), ZYDIS_DEFINITION(0xB, 0xC1C), ZYDIS_DEFINITION(0xB, 0xC1D) },
    { ZYDIS_DEFINITION(0xB, 0xC15), ZYDIS_DEFINITION(0xB, 0xC16), ZYDIS_DEFINITION(0xB, 0xC17) },
    { ZYDIS_DEFINITION(0xB, 0xBA9), ZYDIS_DEFINITION(0xB, 0xBAA), ZYDIS_DEFINITION(0xB, 0xBAB) },
    { ZYDIS_DEFINITION(0xB, 0xBA3), ZYDIS_DEFINITION(0xB, 0xBA4), ZYDIS_DEFINITION(0xB, 0xBA5) },
    { ZYDIS_DEFINITION(0xB, 0xC1E), ZYDIS_DEFINITION(0xB, 0xC1F), ZYDIS_DEFINITION(0xB, 0xC20) },
    { ZYDIS_DEFINITION(0xB, 0xC18), ZYDIS_DEFINITION(0xB, 0xC19), ZYDIS_DEFINITION(0xB, 0xC1A) },
    { ZYDIS_DEFINITION(0xB, 0xBAC), ZYDIS_DEFINITION(0xB, 0xBAD), ZYDIS_DEFINITION(0xB, 0xBAE) },
    { ZYDIS_DEFINITION(0xB, 0xBA6), ZYDIS_DEFINITION(0xB, 0xBA7), ZYDIS_DEFINITION(0xB, 0xBA8) },
    { ZYDIS_DEFINITION(0x1, 0x7F8), ZYDIS_DEFINITION(0x1, 0x7F9), ZYDIS_DEFINITION(0x1, 0x7FA) },
    { ZYDIS_DEFINITION(0x1, 0x7FB), ZYDIS_DEFINITION(0x1, 0x7FC), ZYDIS_DEFINITION(0x1, 0x7FD) },
    { ZYDIS_DEFINITION(0x1, 0x80A), ZYDIS_DEFINITION(0x1, 0x80B), ZYDIS_DEFINITION(0x1, 0x80C) },
    { ZYDIS_DEFINITION(0x1, 0x80D), ZYDIS_DEFINITION(0x1, 0x80E), ZYDIS_DEFINITION(0x1, 0x80F) },
    { ZYDIS_DEFINITION(0x1, 0x7FE), ZYDIS_DEFINITION(0x1, 0x7FF), ZYDIS_DEFINITION(0x1, 0x800) },
    { ZYDIS_DEFINITION(0x1, 0x801), ZYDIS_DEFINITION(0x1, 0x802), ZYDIS_DEFINITION(0x1, 0x803) },
    { ZYDIS_DEFINITION(0x1, 0x24A), ZYDIS_DEFINITION(0x1, 0x24B), ZYDIS_DEFINITION(0x1, 0x24C) },
    { ZYDIS_DEFINITION(0x1, 0x204), ZYDIS_DEFINITION(0x1, 0x205), ZYDIS_DEFINITION(0x1, 0x206) },
    { ZYDIS_DEFINITION(0x1, 0x24D), ZYDIS_DEFINITION(0x1, 0x24E), ZYDIS_DEFINITION(0x1, 0x24F) },
    { ZYDIS_DEFINITION(0x1, 0x207), ZYDIS_DEFINITION(0x1, 0x208), ZYDIS_DEFINITION(0x1, 0x209) },
    { ZYDIS_DEFINITION(0x1, 0x172), ZYDIS_DEFINITION(0x1, 0x173), ZYDIS_DEFINITION(0x1, 0x174) },
    { ZYDIS_DEFINITION(0x1, 0x102), ZYDIS_DEFINITION(0x1, 0x103), ZYDIS_DEFINITION(0x1, 0x104) },
    { ZYDIS_DEFINITION(0x1, 0x175), ZYDIS_DEFINITION(0x1, 0x176), ZYDIS_DEFINITION(0x1, 0x177) },
    { ZYDIS_DEFINITION(0x1, 0x105), ZYDIS_DEFINITION(0x1, 0x106), ZYDIS_DEFINITION(0x1, 0x107) },
    { ZYDIS_DEFINITION(0x1, 0x23C), ZYDIS_DEFINITION(0x1, 0x23D), ZYDIS_DEFINITION(0x1, 0x23E) },
    { ZYDIS_DEFINITION(0x1, 0x1F6), ZYDIS_DEFINITION(0x1, 0x1F7), ZYDIS_DEFINITION(0x1, 0x1F8) },
    { ZYDIS_DEFINITION(0x1, 0x23F), ZYDIS_DEFINITION(0x1, 0x240), ZYDIS_DEFINITION(0x1, 0x241) },
    { ZYDIS_DEFINITION(0x1, 0x1F9), ZYDIS_DEFINITION(0x1, 0x1FA), ZYDIS_DEFINITION(0x1, 0x1FB) },
    { ZYDIS_DEFINITION(0x1, 0x164), ZYDIS_DEFINITION(0x1, 0x165), ZYDIS_DEFINITION(0x1, 0x166) },
    { ZYDIS_DEFINITION(0x1, 0xF4), ZYDIS_DEFINITION(0x1, 0xF5), ZYDIS_DEFINITION(0x1, 0xF6) },
    { ZYDIS_DEFINITION(0x1, 0x167), ZYDIS_DEFINITION(0x1, 0x168), ZYDIS_DEFINITION(0x1, 0x169) },
    { ZYDIS_DEFINITION(0x1, 0xF7), ZYDIS_DEFINITION(0x1, 0xF8), ZYDIS_DEFINITION(0x1, 0xF9) },
    { ZYDIS_DEFINITION(0x1, 0x63B), ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0x1, 0x6A5), ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0x1, 0x63D), ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0x1, 0x63C), ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0x1, 0x6A6), ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0x1, 0x63E), ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0x1, 0x64B), ZYDIS_DEFINITION(0x1, 0x64C), ZYDIS_DEFINITION(0x1, 0x64D) },
    { ZYDIS_DEFINITION(0x1, 0x657), ZYDIS_DEFINITION(0x1, 0x658), ZYDIS_DEFINITION(0x1, 0x659) },
    { ZYDIS_DEFINITION(0x1, 0x64E), ZYDIS_DEFINITION(0x1, 0x64F), ZYDIS_DEFINITION(0x1, 0x650) },
    { ZYDIS_DEFINITION(0x1, 0x65A), ZYDIS_DEFINITION(0x1, 0x65B), ZYDIS_DEFINITION(0x1, 0x65C) },
    { ZYDIS_DEFINITION(0xB, 0x8B), ZYDIS_DEFINITION(0xB, 0x8C), ZYDIS_DEFINITION(0xB, 0x8D) },
    { ZYDIS_DEFINITION(0xB, 0x8E), ZYDIS_DEFINITION(0xB, 0x8F), ZYDIS_DEFINITION(0xB, 0x90) },
    { ZYDIS_DEFINITION(0xB, 0x943), ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0xB, 0x944), ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0xB, 0x92C), ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0xB, 0xDC7), ZYDIS_DEFINITION(0xB, 0xDC8), ZYDIS_DEFINITION(0xB, 0xDC9) },
    { ZYDIS_DEFINITION(0xB, 0xDCA), ZYDIS_DEFINITION(0xB, 0xDCB), ZYDIS_DEFINITION(0xB, 0xDCC) },
    { ZYDIS_DEFINITION(0x1, 0xC3F), ZYDIS_DEFINITION(0x1, 0xC40), ZYDIS_DEFINITION(0x1, 0xC41) },
    { ZYDIS_DEFINITION(0x1, 0xC42), ZYDIS_DEFINITION(0x1, 0xC43), ZYDIS_DEFINITION(0x1, 0xC44) },
    { ZYDIS_DEFINITION(0x1, 0xC0F), ZYDIS_DEFINITION(0x1, 0xC10), ZYDIS_DEFINITION(0x1, 0xC11) },
    { ZYDIS_DEFINITION(0x1, 0xC12), ZYDIS_DEFINITION(0x1, 0xC13), ZYDIS_DEFINITION(0x1, 0xC14) },
    { ZYDIS_DEFINITION(0x1, 0xC21), ZYDIS_DEFINITION(0x1, 0xC22), ZYDIS_DEFINITION(0x1, 0xC23) },
    { ZYDIS_DEFINITION(0x1, 0xC24), ZYDIS_DEFINITION(0x1, 0xC25), ZYDIS_DEFINITION(0x1, 0xC26) },
    { ZYDIS_DEFINITION(0x1, 0x753), ZYDIS_DEFINITION(0x1, 0x754), ZYDIS_DEFINITION(0x1, 0x755) },
    { ZYDIS_DEFINITION(0x1, 0x756), ZYDIS_DEFINITION(0x1, 0x757), ZYDIS_DEFINITION(0x1, 0x758) },
    { ZYDIS_DEFINITION(0x1, 0xAB9), ZYDIS_DEFINITION(0x1, 0xABA), ZYDIS_DEFINITION(0x1, 0xABB) },
    { ZYDIS_DEFINITION(0x1, 0xABC), ZYDIS_DEFINITION(0x1, 0xABD), ZYDIS_DEFINITION(0x1, 0xABE) },
    { ZYDIS_DEFINITION(0x1, 0x6A9), ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0x1, 0x6AA), ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0x1, 0xC63), ZYDIS_DEFINITION(0x1, 0xC64), ZYDIS_DEFINITION(0x1, 0xC65) },
    { ZYDIS_DEFINITION(0x1, 0xC66), ZYDIS_DEFINITION(0x1, 0xC67), ZYDIS_DEFINITION(0x1, 0xC68) },
    { ZYDIS_DEFINITION(0x1, 0xC69), ZYDIS_DEFINITION(0x1, 0xC6A), ZYDIS_DEFINITION(0x1, 0xC6B) },
    { ZYDIS_DEFINITION(0x1, 0xC6C), ZYDIS_DEFINITION(0x1, 0xC6D), ZYDIS_DEFINITION(0x1, 0xC6E) },
    { ZYDIS_DEFINITION(0x1, 0x9B1), ZYDIS_DEFINITION(0x1, 0x9B2), ZYDIS_DEFINITION(0x1, 0x9B3) },
    { ZYDIS_DEFINITION(0x1, 0x9B4), ZYDIS_DEFINITION(0x1, 0x9B5), ZYDIS_DEFINITION(0x1, 0x9B6) },
    { ZYDIS_DEFINITION(0x1, 0x77D), ZYDIS_DEFINITION(0x1, 0x77E), ZYDIS_DEFINITION(0x1, 0x77F) },
    { ZYDIS_DEFINITION(0x1, 0x78F), ZYDIS_DEFINITION(0x1, 0x790), ZYDIS_DEFINITION(0x1, 0x791) },
    { ZYDIS_DEFINITION(0x1, 0x780), ZYDIS_DEFINITION(0x1, 0x781), ZYDIS_DEFINITION(0x1, 0x782) },
    { ZYDIS_DEFINITION(0x1, 0x792), ZYDIS_DEFINITION(0x1, 0x793), ZYDIS_DEFINITION(0x1, 0x794) },
    { ZYDIS_DEFINITION(0x1, 0x765), ZYDIS_DEFINITION(0x1, 0x766), ZYDIS_DEFINITION(0x1, 0x767) },
    { ZYDIS_DEFINITION(0x1, 0x768), ZYDIS_DEFINITION(0x1, 0x769), ZYDIS_DEFINITION(0x1, 0x76A) },
    { ZYDIS_DEFINITION(0x1, 0x76B), ZYDIS_DEFINITION(0x1, 0x76C), ZYDIS_DEFINITION(0x1, 0x76D) },
    { ZYDIS_DEFINITION(0x1, 0x76E), ZYDIS_DEFINITION(0x1, 0x76F), ZYDIS_DEFINITION(0x1, 0x770) },
    { ZYDIS_DEFINITION(0x1, 0x981), ZYDIS_DEFINITION(0x1, 0x982), ZYDIS_DEFINITION(0x1, 0x983) },
    { ZYDIS_DEFINITION(0x1, 0x984), ZYDIS_DEFINITION(0x1, 0x985), ZYDIS_DEFINITION(0x1, 0x986) },
    { ZYDIS_DEFINITION(0x1, 0x783), ZYDIS_DEFINITION(0x1, 0x784), ZYDIS_DEFINITION(0x1, 0x785) },
    { ZYDIS_DEFINITION(0x1, 0x789), ZYDIS_DEFINITION(0x1, 0x78A), ZYDIS_DEFINITION(0x1, 0x78B) },
    { ZYDIS_DEFINITION(0x1, 0x786), ZYDIS_DEFINITION(0x1, 0x787), ZYDIS_DEFINITION(0x1, 0x788) },
    { ZYDIS_DEFINITION(0x1, 0x78C), ZYDIS_DEFINITION(0x1, 0x78D), ZYDIS_DEFINITION(0x1, 0x78E) },
    { ZYDIS_DEFINITION(0x1, 0x795), ZYDIS_DEFINITION(0x1, 0x796), ZYDIS_DEFINITION(0x1, 0x797) },
    { ZYDIS_DEFINITION(0x1, 0x798), ZYDIS_DEFINITION(0x1, 0x799), ZYDIS_DEFINITION(0x1, 0x79A) },
    { ZYDIS_DEFINITION(0x1, 0xC03), ZYDIS_DEFINITION(0x1, 0xC04), ZYDIS_DEFINITION(0x1, 0xC05) },
    { ZYDIS_DEFINITION(0x1, 0xC06), ZYDIS_DEFINITION(0x1, 0xC07), ZYDIS_DEFINITION(0x1, 0xC08) },
    { ZYDIS_DEFINITION(0x1, 0xBD9), ZYDIS_DEFINITION(0x1, 0xBDA), ZYDIS_DEFINITION(0x1, 0xBDB) },
    { ZYDIS_DEFINITION(0x1, 0xBE5), ZYDIS_DEFINITION(0x1, 0xBE6), ZYDIS_DEFINITION(0x1, 0xBE7) },
    { ZYDIS_DEFINITION(0x1, 0xBDC), ZYDIS_DEFINITION(0x1, 0xBDD), ZYDIS_DEFINITION(0x1, 0xBDE) },
    { ZYDIS_DEFINITION(0x1, 0xBE8), ZYDIS_DEFINITION(0x1, 0xBE9), ZYDIS_DEFINITION(0x1, 0xBEA) },
    { ZYDIS_DEFINITION(0x1, 0x79B), ZYDIS_DEFINITION(0x1, 0x79C), ZYDIS_DEFINITION(0x1, 0x79D) },
    { ZYDIS_DEFINITION(0x1, 0x79E), ZYDIS_DEFINITION(0x1, 0x79F), ZYDIS_DEFINITION(0x1, 0x7A0) },
    { ZYDIS_DEFINITION(0x1, 0xAA1), ZYDIS_DEFINITION(0x1, 0xAA2), ZYDIS_DEFINITION(0x1, 0xAA3) },
    { ZYDIS_DEFINITION(0x1, 0xAA4), ZYDIS_DEFINITION(0x1, 0xAA5), ZYDIS_DEFINITION(0x1, 0xAA6) },
    { ZYDIS_DEFINITION(0x1, 0xAA7), ZYDIS_DEFINITION(0x1, 0xAA8), ZYDIS_DEFINITION(0x1, 0xAA9) },
    { ZYDIS_DEFINITION(0x1, 0xAAA), ZYDIS_DEFINITION(0x1, 0xAAB), ZYDIS_DEFINITION(0x1, 0xAAC) },
    { ZYDIS_DEFINITION(0x1, 0x1EF), ZYDIS_DEFINITION(0x1, 0x1F0), ZYDIS_DEFINITION(0x1, 0x1F1) },
    { ZYDIS_DEFINITION(0x1, 0x1F2), ZYDIS_DEFINITION(0x1, 0x1F3), ZYDIS_DEFINITION(0x1, 0x1F4) },
    { ZYDIS_DEFINITION(0x1, 0x697), ZYDIS_DEFINITION(0x1, 0x698), ZYDIS_DEFINITION(0x1, 0x699) },
    { ZYDIS_DEFINITION(0x1, 0xC57), ZYDIS_DEFINITION(0x1, 0xC58), ZYDIS_DEFINITION(0x1, 0xC59) },
    { ZYDIS_DEFINITION(0x1, 0xC5A), ZYDIS_DEFINITION(0x1, 0xC5B), ZYDIS_DEFINITION(0x1, 0xC5C) },
    { ZYDIS_DEFINITION(0x1, 0xC5D), ZYDIS_DEFINITION(0x1, 0xC5E), ZYDIS_DEFINITION(0x1, 0xC5F) },
    { ZYDIS_DEFINITION(0x1, 0xC60), ZYDIS_DEFINITION(0x1, 0xC61), ZYDIS_DEFINITION(0x1, 0xC62) },
    { ZYDIS_DEFINITION(0x1, 0x9AB), ZYDIS_DEFINITION(0x1, 0x9AC), ZYDIS_DEFINITION(0x1, 0x9AD) },
    { ZYDIS_DEFINITION(0x1, 0x9AE), ZYDIS_DEFINITION(0x1, 0x9AF), ZYDIS_DEFINITION(0x1, 0x9B0) },
    { ZYDIS_DEFINITION(0x1, 0xAE3), ZYDIS_DEFINITION(0x1, 0xAE4), ZYDIS_DEFINITION(0x1, 0xAE5) },
    { ZYDIS_DEFINITION(0x1, 0xAE9), ZYDIS_DEFINITION(0x1, 0xAEA), ZYDIS_DEFINITION(0x1, 0xAEB) },
    { ZYDIS_DEFINITION(0x1, 0xAE6), ZYDIS_DEFINITION(0x1, 0xAE7), ZYDIS_DEFINITION(0x1, 0xAE8) },
    { ZYDIS_DEFINITION(0x1, 0xAEC), ZYDIS_DEFINITION(0x1, 0xAED), ZYDIS_DEFINITION(0x1, 0xAEE) },
    { ZYDIS_DEFINITION(0x1, 0x759), ZYDIS_DEFINITION(0x1, 0x75A), ZYDIS_DEFINITION(0x1, 0x75B) },
    { ZYDIS_DEFINITION(0x1, 0x75C), ZYDIS_DEFINITION(0x1, 0x75D), ZYDIS_DEFINITION(0x1, 0x75E) },
    { ZYDIS_DEFINITION(0x1, 0x75F), ZYDIS_DEFINITION(0x1, 0x760), ZYDIS_DEFINITION(0x1, 0x761) },
    { ZYDIS_DEFINITION(0x1, 0x762), ZYDIS_DEFINITION(0x1, 0x763), ZYDIS_DEFINITION(0x1, 0x764) },
    { ZYDIS_DEFINITION(0x1, 0x97B), ZYDIS_DEFINITION(0x1, 0x97C), ZYDIS_DEFINITION(0x1, 0x97D) },
    { ZYDIS_DEFINITION(0x1, 0x97E), ZYDIS_DEFINITION(0x1, 0x97F), ZYDIS_DEFINITION(0x1, 0x980) },
    { ZYDIS_DEFINITION(0x1, 0xCE1), ZYDIS_DEFINITION(0x1, 0xCE2), ZYDIS_DEFINITION(0x1, 0xCE3) },
    { ZYDIS_DEFINITION(0x1, 0xCE7), ZYDIS_DEFINITION(0x1, 0xCE8), ZYDIS_DEFINITION(0x1, 0xCE9) },
    { ZYDIS_DEFINITION(0x1, 0xCE4), ZYDIS_DEFINITION(0x1, 0xCE5), ZYDIS_DEFINITION(0x1, 0xCE6) },
    { ZYDIS_DEFINITION(0x1, 0xCEA), ZYDIS_DEFINITION(0x1, 0xCEB), ZYDIS_DEFINITION(0x1, 0xCEC) },
    { ZYDIS_DEFINITION(0x1, 0xBCD), ZYDIS_DEFINITION(0x1, 0xBCE), ZYDIS_DEFINITION(0x1, 0xBCF) },
    { ZYDIS_DEFINITION(0x1, 0xBD0), ZYDIS_DEFINITION(0x1, 0xBD1), ZYDIS_DEFINITION(0x1, 0xBD2) },
    { ZYDIS_DEFINITION(0x1, 0xB9D), ZYDIS_DEFINITION(0x1, 0xB9E), ZYDIS_DEFINITION(0x1, 0xB9F) },
    { ZYDIS_DEFINITION(0x1, 0xBA0), ZYDIS_DEFINITION(0x1, 0xBA1), ZYDIS_DEFINITION(0x1, 0xBA2) },
    { ZYDIS_DEFINITION(0x1, 0xBAF), ZYDIS_DEFINITION(0x1, 0xBB0), ZYDIS_DEFINITION(0x1, 0xBB1) },
    { ZYDIS_DEFINITION(0x1, 0xBB2), ZYDIS_DEFINITION(0x1, 0xBB3), ZYDIS_DEFINITION(0x1, 0xBB4) },
    { ZYDIS_DEFINITION(0x1, 0xAC5), ZYDIS_DEFINITION(0x1, 0xAC6), ZYDIS_DEFINITION(0x1, 0xAC7) },
    { ZYDIS_DEFINITION(0x1, 0xAC8), ZYDIS_DEFINITION(0x1, 0xAC9), ZYDIS_DEFINITION(0x1, 0xACA) },
    { ZYDIS_DEFINITION(0x1, 0x963), ZYDIS_DEFINITION(0x1, 0x964), ZYDIS_DEFINITION(0x1, 0x965) },
    { ZYDIS_DEFINITION(0x1, 0x966), ZYDIS_DEFINITION(0x1, 0x967), ZYDIS_DEFINITION(0x1, 0x968) },
    { ZYDIS_DEFINITION(0x1, 0xB1F), ZYDIS_DEFINITION(0x1, 0xB20), ZYDIS_DEFINITION(0x1, 0xB21) },
    { ZYDIS_DEFINITION(0x1, 0xB22), ZYDIS_DEFINITION(0x1, 0xB23), ZYDIS_DEFINITION(0x1, 0xB24) },
    { ZYDIS_DEFINITION(0x1, 0xC45), ZYDIS_DEFINITION(0x1, 0xC46), ZYDIS_DEFINITION(0x1, 0xC47) },
    { ZYDIS_DEFINITION(0x1, 0xC48), ZYDIS_DEFINITION(0x1, 0xC49), ZYDIS_DEFINITION(0x1, 0xC4A) },
    { ZYDIS_DEFINITION(0x1, 0xC6F), ZYDIS_DEFINITION(0x1, 0xC70), ZYDIS_DEFINITION(0x1, 0xC71) },
    { ZYDIS_DEFINITION(0x1, 0xC72), ZYDIS_DEFINITION(0x1, 0xC73), ZYDIS_DEFINITION(0x1, 0xC74) },
    { ZYDIS_DEFINITION(0x1, 0xC4B), ZYDIS_DEFINITION(0x1, 0xC4C), ZYDIS_DEFINITION(0x1, 0xC4D) },
    { ZYDIS_DEFINITION(0x1, 0xC4E), ZYDIS_DEFINITION(0x1, 0xC4F), ZYDIS_DEFINITION(0x1, 0xC50) },
    { ZYDIS_DEFINITION(0x1, 0xC51), ZYDIS_DEFINITION(0x1, 0xC52), ZYDIS_DEFINITION(0x1, 0xC53) },
    { ZYDIS_DEFINITION(0x1, 0xC54), ZYDIS_DEFINITION(0x1, 0xC55), ZYDIS_DEFINITION(0x1, 0xC56) },
    { ZYDIS_DEFINITION(0x1, 0x747), ZYDIS_DEFINITION(0x1, 0x748), ZYDIS_DEFINITION(0x1, 0x749) },
    { ZYDIS_DEFINITION(0x1, 0x74A), ZYDIS_DEFINITION(0x1, 0x74B), ZYDIS_DEFINITION(0x1, 0x74C) },
    { ZYDIS_DEFINITION(0x1, 0x771), ZYDIS_DEFINITION(0x1, 0x772), ZYDIS_DEFINITION(0x1, 0x773) },
    { ZYDIS_DEFINITION(0x1, 0x774), ZYDIS_DEFINITION(0x1, 0x775), ZYDIS_DEFINITION(0x1, 0x776) },
    { ZYDIS_DEFINITION(0x1, 0x74D), ZYDIS_DEFINITION(0x1, 0x74E), ZYDIS_DEFINITION(0x1, 0x74F) },
    { ZYDIS_DEFINITION(0x1, 0x750), ZYDIS_DEFINITION(0x1, 0x751), ZYDIS_DEFINITION(0x1, 0x752) },
    { ZYDIS_DEFINITION(0x1, 0xB79), ZYDIS_DEFINITION(0x1, 0xB7A), ZYDIS_DEFINITION(0x1, 0xB7B) },
    { ZYDIS_DEFINITION(0x1, 0xB7C), ZYDIS_DEFINITION(0x1, 0xB7D), ZYDIS_DEFINITION(0x1, 0xB7E) },
    { ZYDIS_DEFINITION(0x1, 0x95D), ZYDIS_DEFINITION(0x1, 0x95E), ZYDIS_DEFINITION(0x1, 0x95F) },
    { ZYDIS_DEFINITION(0x1, 0x960), ZYDIS_DEFINITION(0x1, 0x961), ZYDIS_DEFINITION(0x1, 0x962) },
    { ZYDIS_DEFINITION(0x1, 0xA9B), ZYDIS_DEFINITION(0x1, 0xA9C), ZYDIS_DEFINITION(0x1, 0xA9D) },
    { ZYDIS_DEFINITION(0x1, 0xA9E), ZYDIS_DEFINITION(0x1, 0xA9F), ZYDIS_DEFINITION(0x1, 0xAA0) },
    { ZYDIS_DEFINITION(0x1, 0x8C2), ZYDIS_DEFINITION(0x1, 0x8C3), ZYDIS_DEFINITION(0x1, 0x8C4) },
    { ZYDIS_DEFINITION(0x1, 0x8C5), ZYDIS_DEFINITION(0x1, 0x8C6), ZYDIS_DEFINITION(0x1, 0x8C7) },
    { ZYDIS_DEFINITION(0x1, 0x8B6), ZYDIS_DEFINITION(0x1, 0x8B7), ZYDIS_DEFINITION(0x1, 0x8B8) },
    { ZYDIS_DEFINITION(0x1, 0x8B9), ZYDIS_DEFINITION(0x1, 0x8BA), ZYDIS_DEFINITION(0x1, 0x8BB) },
    { ZYDIS_DEFINITION(0x1, 0xC33), ZYDIS_DEFINITION(0x1, 0xC34), ZYDIS_DEFINITION(0x1, 0xC35) },
    { ZYDIS_DEFINITION(0x1, 0xC36), ZYDIS_DEFINITION(0x1, 0xC37), ZYDIS_DEFINITION(0x1, 0xC38) },
    { ZYDIS_DEFINITION(0x1, 0xBF7), ZYDIS_DEFINITION(0x1, 0xBF8), ZYDIS_DEFINITION(0x1, 0xBF9) },
    { ZYDIS_DEFINITION(0x1, 0xBFA), ZYDIS_DEFINITION(0x1, 0xBFB), ZYDIS_DEFINITION(0x1, 0xBFC) },
    { ZYDIS_DEFINITION(0x1, 0xBC1), ZYDIS_DEFINITION(0x1, 0xBC2), ZYDIS_DEFINITION(0x1, 0xBC3) },
    { ZYDIS_DEFINITION(0x1, 0xBC4), ZYDIS_DEFINITION(0x1, 0xBC5), ZYDIS_DEFINITION(0x1, 0xBC6) },
    { ZYDIS_DEFINITION(0x1, 0x117), ZYDIS_DEFINITION(0x1, 0x118), ZYDIS_DEFINITION(0x1, 0x119) },
    { ZYDIS_DEFINITION(0x1, 0x11A), ZYDIS_DEFINITION(0x1, 0x11B), ZYDIS_DEFINITION(0x1, 0x11C) },
    { ZYDIS_DEFINITION(0x1, 0xB13), ZYDIS_DEFINITION(0x1, 0xB14), ZYDIS_DEFINITION(0x1, 0xB15) },
    { ZYDIS_DEFINITION(0x1, 0xB19), ZYDIS_DEFINITION(0x1, 0xB1A), ZYDIS_DEFINITION(0x1, 0xB1B) },
    { ZYDIS_DEFINITION(0x1, 0xB16), ZYDIS_DEFINITION(0x1, 0xB17), ZYDIS_DEFINITION(0x1, 0xB18) },
    { ZYDIS_DEFINITION(0x1, 0xB1C), ZYDIS_DEFINITION(0x1, 0xB1D), ZYDIS_DEFINITION(0x1, 0xB1E) },
    { ZYDIS_DEFINITION(0x1, 0xAFB), ZYDIS_DEFINITION(0x1, 0xAFC), ZYDIS_DEFINITION(0x1, 0xAFD) },
    { ZYDIS_DEFINITION(0x1, 0xB01), ZYDIS_DEFINITION(0x1, 0xB02), ZYDIS_DEFINITION(0x1, 0xB03) },
    { ZYDIS_DEFINITION(0x1, 0xAFE), ZYDIS_DEFINITION(0x1, 0xAFF), ZYDIS_DEFINITION(0x1, 0xB00) },
    { ZYDIS_DEFINITION(0x1, 0xB04), ZYDIS_DEFINITION(0x1, 0xB05), ZYDIS_DEFINITION(0x1, 0xB06) },
    { ZYDIS_INVALID, ZYDIS_DEFINITION(0x1, 0x8D6), ZYDIS_DEFINITION(0x1, 0x8D7) },
    { ZYDIS_INVALID, ZYDIS_DEFINITION(0x1, 0x8CE), ZYDIS_DEFINITION(0x1, 0x8CF) },
    { ZYDIS_INVALID, ZYDIS_DEFINITION(0x1, 0x8D8), ZYDIS_DEFINITION(0x1, 0x8D9) },
    { ZYDIS_INVALID, ZYDIS_DEFINITION(0x1, 0x8D0), ZYDIS_DEFINITION(0x1, 0x8D1) },
    { ZYDIS_DEFINITION(0x1, 0x84), ZYDIS_DEFINITION(0x1, 0x85), ZYDIS_DEFINITION(0x1, 0x86) },
    { ZYDIS_DEFINITION(0x1, 0x87), ZYDIS_DEFINITION(0x1, 0x88), ZYDIS_DEFINITION(0x1, 0x89) },
    { ZYDIS_INVALID, ZYDIS_DEFINITION(0x1, 0x6A), ZYDIS_DEFINITION(0x1, 0x6B) },
    { ZYDIS_INVALID, ZYDIS_DEFINITION(0x1, 0x80), ZYDIS_DEFINITION(0x1, 0x81) },
    { ZYDIS_INVALID, ZYDIS_DEFINITION(0x1, 0x6C), ZYDIS_DEFINITION(0x1, 0x6D) },
    { ZYDIS_INVALID, ZYDIS_DEFINITION(0x1, 0x82), ZYDIS_DEFINITION(0x1, 0x83) },
    { ZYDIS_INVALID, ZYDIS_DEFINITION(0x1, 0x6E), ZYDIS_DEFINITION(0x1, 0x6F) },
    { ZYDIS_INVALID, ZYDIS_DEFINITION(0x1, 0x71), ZYDIS_DEFINITION(0x1, 0x72) },
    { ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_DEFINITION(0x1, 0x70) },
    { ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_DEFINITION(0x1, 0x73) },
    { ZYDIS_DEFINITION(0x1, 0x717), ZYDIS_DEFINITION(0x1, 0x718), ZYDIS_DEFINITION(0x1, 0x719) },
    { ZYDIS_DEFINITION(0x1, 0x71A), ZYDIS_DEFINITION(0x1, 0x71B), ZYDIS_DEFINITION(0x1, 0x71C) },
    { ZYDIS_DEFINITION(0x1, 0x729), ZYDIS_DEFINITION(0x1, 0x72A), ZYDIS_DEFINITION(0x1, 0x72B) },
    { ZYDIS_DEFINITION(0x1, 0x72C), ZYDIS_DEFINITION(0x1, 0x72D), ZYDIS_DEFINITION(0x1, 0x72E) },
    { ZYDIS_DEFINITION(0x1, 0x71D), ZYDIS_DEFINITION(0x1, 0x71E), ZYDIS_DEFINITION(0x1, 0x71F) },
    { ZYDIS_DEFINITION(0x1, 0x720), ZYDIS_DEFINITION(0x1, 0x721), ZYDIS_DEFINITION(0x1, 0x722) },
    { ZYDIS_DEFINITION(0x1, 0x723), ZYDIS_DEFINITION(0x1, 0x724), ZYDIS_DEFINITION(0x1, 0x725) },
    { ZYDIS_DEFINITION(0x1, 0x726), ZYDIS_DEFINITION(0x1, 0x727), ZYDIS_DEFINITION(0x1, 0x728) },
    { ZYDIS_DEFINITION(0x1, 0xA2C), ZYDIS_DEFINITION(0x1, 0xA2D), ZYDIS_DEFINITION(0x1, 0xA2E) },
    { ZYDIS_DEFINITION(0x1, 0xA2F), ZYDIS_DEFINITION(0x1, 0xA30), ZYDIS_DEFINITION(0x1, 0xA31) },
    { ZYDIS_DEFINITION(0x1, 0xA20), ZYDIS_DEFINITION(0x1, 0xA21), ZYDIS_DEFINITION(0x1, 0xA22) },
    { ZYDIS_DEFINITION(0x1, 0xA23), ZYDIS_DEFINITION(0x1, 0xA24), ZYDIS_DEFINITION(0x1, 0xA25) },
    { ZYDIS_DEFINITION(0x1, 0xA26), ZYDIS_DEFINITION(0x1, 0xA27), ZYDIS_DEFINITION(0x1, 0xA28) },
    { ZYDIS_DEFINITION(0x1, 0xA29), ZYDIS_DEFINITION(0x1, 0xA2A), ZYDIS_DEFINITION(0x1, 0xA2B) },
    { ZYDIS_DEFINITION(0x1, 0xA38), ZYDIS_DEFINITION(0x1, 0xA39), ZYDIS_DEFINITION(0x1, 0xA3A) },
    { ZYDIS_DEFINITION(0x1, 0xA3B), ZYDIS_DEFINITION(0x1, 0xA3C), ZYDIS_DEFINITION(0x1, 0xA3D) },
    { ZYDIS_DEFINITION(0x1, 0xA3E), ZYDIS_DEFINITION(0x1, 0xA3F), ZYDIS_DEFINITION(0x1, 0xA40) },
    { ZYDIS_DEFINITION(0x1, 0xA41), ZYDIS_DEFINITION(0x1, 0xA42), ZYDIS_DEFINITION(0x1, 0xA43) },
    { ZYDIS_DEFINITION(0x1, 0xA32), ZYDIS_DEFINITION(0x1, 0xA33), ZYDIS_DEFINITION(0x1, 0xA34) },
    { ZYDIS_DEFINITION(0x1, 0xA35), ZYDIS_DEFINITION(0x1, 0xA36), ZYDIS_DEFINITION(0x1, 0xA37) },
    { ZYDIS_DEFINITION(0x1, 0xC81), ZYDIS_DEFINITION(0x1, 0xC82), ZYDIS_DEFINITION(0x1, 0xC83) },
    { ZYDIS_DEFINITION(0x1, 0xC93), ZYDIS_DEFINITION(0x1, 0xC94), ZYDIS_DEFINITION(0x1, 0xC95) },
    { ZYDIS_DEFINITION(0x1, 0xC84), ZYDIS_DEFINITION(0x1, 0xC85), ZYDIS_DEFINITION(0x1, 0xC86) },
    { ZYDIS_DEFINITION(0x1, 0xC96), ZYDIS_DEFINITION(0x1, 0xC97), ZYDIS_DEFINITION(0x1, 0xC98) },
    { ZYDIS_DEFINITION(0x1, 0xC87), ZYDIS_DEFINITION(0x1, 0xC88), ZYDIS_DEFINITION(0x1, 0xC89) },
    { ZYDIS_DEFINITION(0x1, 0xC8D), ZYDIS_DEFINITION(0x1, 0xC8E), ZYDIS_DEFINITION(0x1, 0xC8F) },
    { ZYDIS_DEFINITION(0x1, 0xC8A), ZYDIS_DEFINITION(0x1, 0xC8B), ZYDIS_DEFINITION(0x1, 0xC8C) },
    { ZYDIS_DEFINITION(0x1, 0xC90), ZYDIS_DEFINITION(0x1, 0xC91), ZYDIS_DEFINITION(0x1, 0xC92) },
    { ZYDIS_DEFINITION(0x1, 0xA95), ZYDIS_DEFINITION(0x1, 0xA96), ZYDIS_DEFINITION(0x1, 0xA97) },
    { ZYDIS_DEFINITION(0x1, 0xA98), ZYDIS_DEFINITION(0x1, 0xA99), ZYDIS_DEFINITION(0x1, 0xA9A) },
    { ZYDIS_DEFINITION(0x1, 0x804), ZYDIS_DEFINITION(0x1, 0x805), ZYDIS_DEFINITION(0x1, 0x806) },
    { ZYDIS_DEFINITION(0x1, 0x807), ZYDIS_DEFINITION(0x1, 0x808), ZYDIS_DEFINITION(0x1, 0x809) },
    { ZYDIS_DEFINITION(0x1, 0x69A), ZYDIS_DEFINITION(0x1, 0x69B), ZYDIS_DEFINITION(0x1, 0x69C) },
    { ZYDIS_DEFINITION(0x1, 0x73B), ZYDIS_DEFINITION(0x1, 0x73C), ZYDIS_DEFINITION(0x1, 0x73D) },
    { ZYDIS_DEFINITION(0x1, 0x73E), ZYDIS_DEFINITION(0x1, 0x73F), ZYDIS_DEFINITION(0x1, 0x740) },
    { ZYDIS_DEFINITION(0x1, 0xD94), ZYDIS_DEFINITION(0x1, 0xD95), ZYDIS_DEFINITION(0x1, 0xD96) },
    { ZYDIS_DEFINITION(0x1, 0xD86), ZYDIS_DEFINITION(0x1, 0xD87), ZYDIS_DEFINITION(0x1, 0xD88) },
    { ZYDIS_DEFINITION(0x1, 0xD97), ZYDIS_DEFINITION(0x1, 0xD98), ZYDIS_DEFINITION(0x1, 0xD99) },
    { ZYDIS_DEFINITION(0x1, 0xD89), ZYDIS_DEFINITION(0x1, 0xD8A), ZYDIS_DEFINITION(0x1, 0xD8B) },
    { ZYDIS_DEFINITION(0x1, 0xA7D), ZYDIS_DEFINITION(0x1, 0xA7E), ZYDIS_DEFINITION(0x1, 0xA7F) },
    { ZYDIS_DEFINITION(0x1, 0xA80), ZYDIS_DEFINITION(0x1, 0xA81), ZYDIS_DEFINITION(0x1, 0xA82) },
    { ZYDIS_DEFINITION(0x1, 0xA71), ZYDIS_DEFINITION(0x1, 0xA72), ZYDIS_DEFINITION(0x1, 0xA73) },
    { ZYDIS_DEFINITION(0x1, 0xA74), ZYDIS_DEFINITION(0x1, 0xA75), ZYDIS_DEFINITION(0x1, 0xA76) },
    { ZYDIS_DEFINITION(0x1, 0xA77), ZYDIS_DEFINITION(0x1, 0xA78), ZYDIS_DEFINITION(0x1, 0xA79) },
    { ZYDIS_DEFINITION(0x1, 0xA7A), ZYDIS_DEFINITION(0x1, 0xA7B), ZYDIS_DEFINITION(0x1, 0xA7C) },
    { ZYDIS_DEFINITION(0x1, 0xA89), ZYDIS_DEFINITION(0x1, 0xA8A), ZYDIS_DEFINITION(0x1, 0xA8B) },
    { ZYDIS_DEFINITION(0x1, 0xA8C), ZYDIS_DEFINITION(0x1, 0xA8D), ZYDIS_DEFINITION(0x1, 0xA8E) },
    { ZYDIS_DEFINITION(0x1, 0xA8F), ZYDIS_DEFINITION(0x1, 0xA90), ZYDIS_DEFINITION(0x1, 0xA91) },
    { ZYDIS_DEFINITION(0x1, 0xA92), ZYDIS_DEFINITION(0x1, 0xA93), ZYDIS_DEFINITION(0x1, 0xA94) },
    { ZYDIS_DEFINITION(0x1, 0xA83), ZYDIS_DEFINITION(0x1, 0xA84), ZYDIS_DEFINITION(0x1, 0xA85) },
    { ZYDIS_DEFINITION(0x1, 0xA86), ZYDIS_DEFINITION(0x1, 0xA87), ZYDIS_DEFINITION(0x1, 0xA88) },
    { ZYDIS_INVALID, ZYDIS_DEFINITION(0x1, 0x88E), ZYDIS_DEFINITION(0x1, 0x88F) },
    { ZYDIS_INVALID, ZYDIS_DEFINITION(0x1, 0x8DA), ZYDIS_DEFINITION(0x1, 0x8DB) },
    { ZYDIS_INVALID, ZYDIS_DEFINITION(0x1, 0x890), ZYDIS_DEFINITION(0x1, 0x891) },
    { ZYDIS_INVALID, ZYDIS_DEFINITION(0x1, 0x8DC), ZYDIS_DEFINITION(0x1, 0x8DD) },
    { ZYDIS_DEFINITION(0x1, 0x81C), ZYDIS_DEFINITION(0x1, 0x81D), ZYDIS_DEFINITION(0x1, 0x81E) },
    { ZYDIS_DEFINITION(0x1, 0x81F), ZYDIS_DEFINITION(0x1, 0x820), ZYDIS_DEFINITION(0x1, 0x821) },
    { ZYDIS_DEFINITION(0x1, 0x999), ZYDIS_DEFINITION(0x1, 0x99A), ZYDIS_DEFINITION(0x1, 0x99B) },
    { ZYDIS_DEFINITION(0x1, 0x99C), ZYDIS_DEFINITION(0x1, 0x99D), ZYDIS_DEFINITION(0x1, 0x99E) },
    { ZYDIS_DEFINITION(0x1, 0x99F), ZYDIS_DEFINITION(0x1, 0x9A0), ZYDIS_DEFINITION(0x1, 0x9A1) },
    { ZYDIS_DEFINITION(0x1, 0x9A5), ZYDIS_DEFINITION(0x1, 0x9A6), ZYDIS_DEFINITION(0x1, 0x9A7) },
    { ZYDIS_DEFINITION(0x1, 0x9A2), ZYDIS_DEFINITION(0x1, 0x9A3), ZYDIS_DEFINITION(0x1, 0x9A4) },
    { ZYDIS_DEFINITION(0x1, 0x9A8), ZYDIS_DEFINITION(0x1, 0x9A9), ZYDIS_DEFINITION(0x1, 0x9AA) },
    { ZYDIS_DEFINITION(0x1, 0x9C3), ZYDIS_DEFINITION(0x1, 0x9C4), ZYDIS_DEFINITION(0x1, 0x9C5) },
    { ZYDIS_DEFINITION(0x1, 0x9C6), ZYDIS_DEFINITION(0x1, 0x9C7), ZYDIS_DEFINITION(0x1, 0x9C8) },
    { ZYDIS_DEFINITION(0x1, 0x9B7), ZYDIS_DEFINITION(0x1, 0x9B8), ZYDIS_DEFINITION(0x1, 0x9B9) },
    { ZYDIS_DEFINITION(0x1, 0x9BD), ZYDIS_DEFINITION(0x1, 0x9BE), ZYDIS_DEFINITION(0x1, 0x9BF) },
    { ZYDIS_DEFINITION(0x1, 0x9BA), ZYDIS_DEFINITION(0x1, 0x9BB), ZYDIS_DEFINITION(0x1, 0x9BC) },
    { ZYDIS_DEFINITION(0x1, 0x9C0), ZYDIS_DEFINITION(0x1, 0x9C1), ZYDIS_DEFINITION(0x1, 0x9C2) },
    { ZYDIS_DEFINITION(0x1, 0x969), ZYDIS_DEFINITION(0x1, 0x96A), ZYDIS_DEFINITION(0x1, 0x96B) },
    { ZYDIS_DEFINITION(0x1, 0x96C), ZYDIS_DEFINITION(0x1, 0x96D), ZYDIS_DEFINITION(0x1, 0x96E) },
    { ZYDIS_DEFINITION(0x1, 0x96F), ZYDIS_DEFINITION(0x1, 0x970), ZYDIS_DEFINITION(0x1, 0x971) },
    { ZYDIS_DEFINITION(0x1, 0x975), ZYDIS_DEFINITION(0x1, 0x976), ZYDIS_DEFINITION(0x1, 0x977) },
    { ZYDIS_DEFINITION(0x1, 0x972), ZYDIS_DEFINITION(0x1, 0x973), ZYDIS_DEFINITION(0x1, 0x974) },
    { ZYDIS_DEFINITION(0x1, 0x978), ZYDIS_DEFINITION(0x1, 0x979), ZYDIS_DEFINITION(0x1, 0x97A) },
    { ZYDIS_DEFINITION(0x1, 0x993), ZYDIS_DEFINITION(0x1, 0x994), ZYDIS_DEFINITION(0x1, 0x995) },
    { ZYDIS_DEFINITION(0x1, 0x996), ZYDIS_DEFINITION(0x1, 0x997), ZYDIS_DEFINITION(0x1, 0x998) },
    { ZYDIS_DEFINITION(0x1, 0x987), ZYDIS_DEFINITION(0x1, 0x988), ZYDIS_DEFINITION(0x1, 0x989) },
    { ZYDIS_DEFINITION(0x1, 0x98D), ZYDIS_DEFINITION(0x1, 0x98E), ZYDIS_DEFINITION(0x1, 0x98F) },
    { ZYDIS_DEFINITION(0x1, 0x98A), ZYDIS_DEFINITION(0x1, 0x98B), ZYDIS_DEFINITION(0x1, 0x98C) },
    { ZYDIS_DEFINITION(0x1, 0x990), ZYDIS_DEFINITION(0x1, 0x991), ZYDIS_DEFINITION(0x1, 0x992) },
    { ZYDIS_DEFINITION(0x1, 0xAAD), ZYDIS_DEFINITION(0x1, 0xAAE), ZYDIS_DEFINITION(0x1, 0xAAF) },
    { ZYDIS_DEFINITION(0x1, 0xAB3), ZYDIS_DEFINITION(0x1, 0xAB4), ZYDIS_DEFINITION(0x1, 0xAB5) },
    { ZYDIS_DEFINITION(0x1, 0xAB0), ZYDIS_DEFINITION(0x1, 0xAB1), ZYDIS_DEFINITION(0x1, 0xAB2) },
    { ZYDIS_DEFINITION(0x1, 0xAB6), ZYDIS_DEFINITION(0x1, 0xAB7), ZYDIS_DEFINITION(0x1, 0xAB8) },
    { ZYDIS_DEFINITION(0x1, 0x58A), ZYDIS_DEFINITION(0x1, 0x58B), ZYDIS_DEFINITION(0x1, 0x58C) },
    { ZYDIS_DEFINITION(0x1, 0x57C), ZYDIS_DEFINITION(0x1, 0x57D), ZYDIS_DEFINITION(0x1, 0x57E) },
    { ZYDIS_DEFINITION(0x1, 0x58D), ZYDIS_DEFINITION(0x1, 0x58E), ZYDIS_DEFINITION(0x1, 0x58F) },
    { ZYDIS_DEFINITION(0x1, 0x57F), ZYDIS_DEFINITION(0x1, 0x580), ZYDIS_DEFINITION(0x1, 0x581) },
    { ZYDIS_DEFINITION(0x1, 0x945), ZYDIS_DEFINITION(0x1, 0x946), ZYDIS_DEFINITION(0x1, 0x947) },
    { ZYDIS_DEFINITION(0x1, 0x94B), ZYDIS_DEFINITION(0x1, 0x94C), ZYDIS_DEFINITION(0x1, 0x94D) },
    { ZYDIS_DEFINITION(0x1, 0x948), ZYDIS_DEFINITION(0x1, 0x949), ZYDIS_DEFINITION(0x1, 0x94A) },
    { ZYDIS_DEFINITION(0x1, 0x94E), ZYDIS_DEFINITION(0x1, 0x94F), ZYDIS_DEFINITION(0x1, 0x950) },
    { ZYDIS_DEFINITION(0x1, 0xC27), ZYDIS_DEFINITION(0x1, 0xC28), ZYDIS_DEFINITION(0x1, 0xC29) },
    { ZYDIS_DEFINITION(0x1, 0xC2D), ZYDIS_DEFINITION(0x1, 0xC2E), ZYDIS_DEFINITION(0x1, 0xC2F) },
    { ZYDIS_DEFINITION(0x1, 0xC2A), ZYDIS_DEFINITION(0x1, 0xC2B), ZYDIS_DEFINITION(0x1, 0xC2C) },
    { ZYDIS_DEFINITION(0x1, 0xC30), ZYDIS_DEFINITION(0x1, 0xC31), ZYDIS_DEFINITION(0x1, 0xC32) },
    { ZYDIS_DEFINITION(0x1, 0xBEB), ZYDIS_DEFINITION(0x1, 0xBEC), ZYDIS_DEFINITION(0x1, 0xBED) },
    { ZYDIS_DEFINITION(0x1, 0xBF1), ZYDIS_DEFINITION(0x1, 0xBF2), ZYDIS_DEFINITION(0x1, 0xBF3) },
    { ZYDIS_DEFINITION(0x1, 0xBEE), ZYDIS_DEFINITION(0x1, 0xBEF), ZYDIS_DEFINITION(0x1, 0xBF0) },
    { ZYDIS_DEFINITION(0x1, 0xBF4), ZYDIS_DEFINITION(0x1, 0xBF5), ZYDIS_DEFINITION(0x1, 0xBF6) },
    { ZYDIS_DEFINITION(0x1, 0xBB5), ZYDIS_DEFINITION(0x1, 0xBB6), ZYDIS_DEFINITION(0x1, 0xBB7) },
    { ZYDIS_DEFINITION(0x1, 0xBBB), ZYDIS_DEFINITION(0x1, 0xBBC), ZYDIS_DEFINITION(0x1, 0xBBD) },
    { ZYDIS_DEFINITION(0x1, 0xBB8), ZYDIS_DEFINITION(0x1, 0xBB9), ZYDIS_DEFINITION(0x1, 0xBBA) },
    { ZYDIS_DEFINITION(0x1, 0xBBE), ZYDIS_DEFINITION(0x1, 0xBBF), ZYDIS_DEFINITION(0x1, 0xBC0) },
    { ZYDIS_DEFINITION(0x1, 0xD07), ZYDIS_DEFINITION(0x1, 0xD08), ZYDIS_DEFINITION(0x1, 0xD09) },
    { ZYDIS_DEFINITION(0x1, 0xD01), ZYDIS_DEFINITION(0x1, 0xD02), ZYDIS_DEFINITION(0x1, 0xD03) },
    { ZYDIS_DEFINITION(0x1, 0xD0A), ZYDIS_DEFINITION(0x1, 0xD0B), ZYDIS_DEFINITION(0x1, 0xD0C) },
    { ZYDIS_DEFINITION(0x1, 0xD04), ZYDIS_DEFINITION(0x1, 0xD05), ZYDIS_DEFINITION(0x1, 0xD06) },
    { ZYDIS_DEFINITION(0x1, 0xD67), ZYDIS_DEFINITION(0x1, 0xD68), ZYDIS_DEFINITION(0x1, 0xD69) },
    { ZYDIS_DEFINITION(0x1, 0xD61), ZYDIS_DEFINITION(0x1, 0xD62), ZYDIS_DEFINITION(0x1, 0xD63) },
    { ZYDIS_DEFINITION(0x1, 0xD6A), ZYDIS_DEFINITION(0x1, 0xD6B), ZYDIS_DEFINITION(0x1, 0xD6C) },
    { ZYDIS_DEFINITION(0x1, 0xD64), ZYDIS_DEFINITION(0x1, 0xD65), ZYDIS_DEFINITION(0x1, 0xD66) },
    { ZYDIS_DEFINITION(0x1, 0x870), ZYDIS_DEFINITION(0x1, 0x871), ZYDIS_DEFINITION(0x1, 0x872) },
    { ZYDIS_DEFINITION(0x1, 0x873), ZYDIS_DEFINITION(0x1, 0x874), ZYDIS_DEFINITION(0x1, 0x875) },
    { ZYDIS_DEFINITION(0x1, 0x876), ZYDIS_DEFINITION(0x1, 0x877), ZYDIS_DEFINITION(0x1, 0x878) },
    { ZYDIS_DEFINITION(0x1, 0x879), ZYDIS_DEFINITION(0x1, 0x87A), ZYDIS_DEFINITION(0x1, 0x87B) },
    { ZYDIS_DEFINITION(0x1, 0x87C), ZYDIS_DEFINITION(0x1, 0x87D), ZYDIS_DEFINITION(0x1, 0x87E) },
    { ZYDIS_DEFINITION(0x1, 0x87F), ZYDIS_DEFINITION(0x1, 0x880), ZYDIS_DEFINITION(0x1, 0x881) },
    { ZYDIS_DEFINITION(0x1, 0x882), ZYDIS_DEFINITION(0x1, 0x883), ZYDIS_DEFINITION(0x1, 0x884) },
    { ZYDIS_DEFINITION(0x1, 0x885), ZYDIS_DEFINITION(0x1, 0x886), ZYDIS_DEFINITION(0x1, 0x887) },
    { ZYDIS_DEFINITION(0x1, 0xACB), ZYDIS_DEFINITION(0x1, 0xACC), ZYDIS_DEFINITION(0x1, 0xACD) },
    { ZYDIS_DEFINITION(0x1, 0xADD), ZYDIS_DEFINITION(0x1, 0xADE), ZYDIS_DEFINITION(0x1, 0xADF) },
    { ZYDIS_DEFINITION(0x1, 0xACE), ZYDIS_DEFINITION(0x1, 0xACF), ZYDIS_DEFINITION(0x1, 0xAD0) },
    { ZYDIS_DEFINITION(0x1, 0xAE0), ZYDIS_DEFINITION(0x1, 0xAE1), ZYDIS_DEFINITION(0x1, 0xAE2) },
    { ZYDIS_DEFINITION(0x1, 0xAD1), ZYDIS_DEFINITION(0x1, 0xAD2), ZYDIS_DEFINITION(0x1, 0xAD3) },
    { ZYDIS_DEFINITION(0x1, 0xAD7), ZYDIS_DEFINITION(0x1, 0xAD8), ZYDIS_DEFINITION(0x1, 0xAD9) },
    { ZYDIS_DEFINITION(0x1, 0xAD4), ZYDIS_DEFINITION(0x1, 0xAD5), ZYDIS_DEFINITION(0x1, 0xAD6) },
    { ZYDIS_DEFINITION(0x1, 0xADA), ZYDIS_DEFINITION(0x1, 0xADB), ZYDIS_DEFINITION(0x1, 0xADC) },
    { ZYDIS_DEFINITION(0x1, 0x7C2), ZYDIS_DEFINITION(0x1, 0x7C3), ZYDIS_DEFINITION(0x1, 0x7C4) },
    { ZYDIS_DEFINITION(0x1, 0x7C5), ZYDIS_DEFINITION(0x1, 0x7C6), ZYDIS_DEFINITION(0x1, 0x7C7) },
    { ZYDIS_DEFINITION(0x1, 0x74), ZYDIS_DEFINITION(0x1, 0x75), ZYDIS_DEFINITION(0x1, 0x76) },
    { ZYDIS_DEFINITION(0x1, 0x7D4), ZYDIS_DEFINITION(0x1, 0x7D5), ZYDIS_DEFINITION(0x1, 0x7D6) },
    { ZYDIS_DEFINITION(0x1, 0x77), ZYDIS_DEFINITION(0x1, 0x78), ZYDIS_DEFINITION(0x1, 0x79) },
    { ZYDIS_DEFINITION(0x1, 0x7D7), ZYDIS_DEFINITION(0x1, 0x7D8), ZYDIS_DEFINITION(0x1, 0x7D9) },
    { ZYDIS_INVALID, ZYDIS_DEFINITION(0x1, 0x7A), ZYDIS_DEFINITION(0x1, 0x7B) },
    { ZYDIS_INVALID, ZYDIS_DEFINITION(0x1, 0x7D), ZYDIS_DEFINITION(0x1, 0x7E) },
    { ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_DEFINITION(0x1, 0x7C) },
    { ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_DEFINITION(0x1, 0x7F) },
    { ZYDIS_DEFINITION(0x1, 0x90C), ZYDIS_DEFINITION(0x1, 0x90D), ZYDIS_DEFINITION(0x1, 0x90E) },
    { ZYDIS_DEFINITION(0x1, 0x91E), ZYDIS_DEFINITION(0x1, 0x91F), ZYDIS_DEFINITION(0x1, 0x920) },
    { ZYDIS_DEFINITION(0x1, 0x90F), ZYDIS_DEFINITION(0x1, 0x910), ZYDIS_DEFINITION(0x1, 0x911) },
    { ZYDIS_DEFINITION(0x1, 0x921), ZYDIS_DEFINITION(0x1, 0x922), ZYDIS_DEFINITION(0x1, 0x923) },
    { ZYDIS_DEFINITION(0x1, 0x84C), ZYDIS_DEFINITION(0x1, 0x84D), ZYDIS_DEFINITION(0x1, 0x84E) },
    { ZYDIS_DEFINITION(0x1, 0x85E), ZYDIS_DEFINITION(0x1, 0x85F), ZYDIS_DEFINITION(0x1, 0x860) },
    { ZYDIS_DEFINITION(0x1, 0x84F), ZYDIS_DEFINITION(0x1, 0x850), ZYDIS_DEFINITION(0x1, 0x851) },
    { ZYDIS_DEFINITION(0x1, 0x861), ZYDIS_DEFINITION(0x1, 0x862), ZYDIS_DEFINITION(0x1, 0x863) },
    { ZYDIS_DEFINITION(0x1, 0x7A7), ZYDIS_DEFINITION(0x1, 0x7A8), ZYDIS_DEFINITION(0x1, 0x7A9) },
    { ZYDIS_DEFINITION(0x1, 0x7AD), ZYDIS_DEFINITION(0x1, 0x7AE), ZYDIS_DEFINITION(0x1, 0x7AF) },
    { ZYDIS_DEFINITION(0x1, 0x7AA), ZYDIS_DEFINITION(0x1, 0x7AB), ZYDIS_DEFINITION(0x1, 0x7AC) },
    { ZYDIS_DEFINITION(0x1, 0x7B0), ZYDIS_DEFINITION(0x1, 0x7B1), ZYDIS_DEFINITION(0x1, 0x7B2) },
    { ZYDIS_DEFINITION(0x1, 0x64), ZYDIS_DEFINITION(0x1, 0x65), ZYDIS_DEFINITION(0x1, 0x66) },
    { ZYDIS_DEFINITION(0x1, 0x5E), ZYDIS_DEFINITION(0x1, 0x5F), ZYDIS_DEFINITION(0x1, 0x60) },
    { ZYDIS_DEFINITION(0x1, 0x67), ZYDIS_DEFINITION(0x1, 0x68), ZYDIS_DEFINITION(0x1, 0x69) },
    { ZYDIS_DEFINITION(0x1, 0x61), ZYDIS_DEFINITION(0x1, 0x62), ZYDIS_DEFINITION(0x1, 0x63) },
    { ZYDIS_DEFINITION(0x1, 0x7A1), ZYDIS_DEFINITION(0x1, 0x7A2), ZYDIS_DEFINITION(0x1, 0x7A3) },
    { ZYDIS_DEFINITION(0x1, 0x7B3), ZYDIS_DEFINITION(0x1, 0x7B4), ZYDIS_DEFINITION(0x1, 0x7B5) },
    { ZYDIS_DEFINITION(0x1, 0x7A4), ZYDIS_DEFINITION(0x1, 0x7A5), ZYDIS_DEFINITION(0x1, 0x7A6) },
    { ZYDIS_DEFINITION(0x1, 0x7B6), ZYDIS_DEFINITION(0x1, 0x7B7), ZYDIS_DEFINITION(0x1, 0x7B8) },
    { ZYDIS_DEFINITION(0x1, 0xB49), ZYDIS_DEFINITION(0x1, 0xB4A), ZYDIS_DEFINITION(0x1, 0xB4B) },
    { ZYDIS_DEFINITION(0x1, 0xB4C), ZYDIS_DEFINITION(0x1, 0xB4D), ZYDIS_DEFINITION(0x1, 0xB4E) },
    { ZYDIS_DEFINITION(0x1, 0xB3D), ZYDIS_DEFINITION(0x1, 0xB3E), ZYDIS_DEFINITION(0x1, 0xB3F) },
    { ZYDIS_DEFINITION(0x1, 0xB43), ZYDIS_DEFINITION(0x1, 0xB44), ZYDIS_DEFINITION(0x1, 0xB45) },
    { ZYDIS_DEFINITION(0x1, 0xB40), ZYDIS_DEFINITION(0x1, 0xB41), ZYDIS_DEFINITION(0x1, 0xB42) },
    { ZYDIS_DEFINITION(0x1, 0xB46), ZYDIS_DEFINITION(0x1, 0xB47), ZYDIS_DEFINITION(0x1, 0xB48) },
    { ZYDIS_DEFINITION(0x1, 0xB6D), ZYDIS_DEFINITION(0x1, 0xB6E), ZYDIS_DEFINITION(0x1, 0xB6F) },
    { ZYDIS_DEFINITION(0x1, 0xB70), ZYDIS_DEFINITION(0x1, 0xB71), ZYDIS_DEFINITION(0x1, 0xB72) },
    { ZYDIS_DEFINITION(0x1, 0xB61), ZYDIS_DEFINITION(0x1, 0xB62), ZYDIS_DEFINITION(0x1, 0xB63) },
    { ZYDIS_DEFINITION(0x1, 0xB67), ZYDIS_DEFINITION(0x1, 0xB68), ZYDIS_DEFINITION(0x1, 0xB69) },
    { ZYDIS_DEFINITION(0x1, 0xB64), ZYDIS_DEFINITION(0x1, 0xB65), ZYDIS_DEFINITION(0x1, 0xB66) },
    { ZYDIS_DEFINITION(0x1, 0xB6A), ZYDIS_DEFINITION(0x1, 0xB6B), ZYDIS_DEFINITION(0x1, 0xB6C) },
    { ZYDIS_DEFINITION(0x1, 0x892), ZYDIS_DEFINITION(0x1, 0x893), ZYDIS_DEFINITION(0x1, 0x894) },
    { ZYDIS_DEFINITION(0x1, 0x8B0), ZYDIS_DEFINITION(0x1, 0x8B1), ZYDIS_DEFINITION(0x1, 0x8B2) },
    { ZYDIS_DEFINITION(0x1, 0x895), ZYDIS_DEFINITION(0x1, 0x896), ZYDIS_DEFINITION(0x1, 0x897) },
    { ZYDIS_DEFINITION(0x1, 0x8B3), ZYDIS_DEFINITION(0x1, 0x8B4), ZYDIS_DEFINITION(0x1, 0x8B5) },
    { ZYDIS_DEFINITION(0x1, 0x898), ZYDIS_DEFINITION(0x1, 0x899), ZYDIS_DEFINITION(0x1, 0x89A) },
    { ZYDIS_DEFINITION(0x1, 0x8AA), ZYDIS_DEFINITION(0x1, 0x8AB), ZYDIS_DEFINITION(0x1, 0x8AC) },
    { ZYDIS_DEFINITION(0x1, 0x89B), ZYDIS_DEFINITION(0x1, 0x89C), ZYDIS_DEFINITION(0x1, 0x89D) },
    { ZYDIS_DEFINITION(0x1, 0x8AD), ZYDIS_DEFINITION(0x1, 0x8AE), ZYDIS_DEFINITION(0x1, 0x8AF) },
    { ZYDIS_DEFINITION(0x1, 0x8A4), ZYDIS_DEFINITION(0x1, 0x8A5), ZYDIS_DEFINITION(0x1, 0x8A6) },
    { ZYDIS_DEFINITION(0x1, 0x89E), ZYDIS_DEFINITION(0x1, 0x89F), ZYDIS_DEFINITION(0x1, 0x8A0) },
    { ZYDIS_DEFINITION(0x1, 0x8A7), ZYDIS_DEFINITION(0x1, 0x8A8), ZYDIS_DEFINITION(0x1, 0x8A9) },
    { ZYDIS_DEFINITION(0x1, 0x8A1), ZYDIS_DEFINITION(0x1, 0x8A2), ZYDIS_DEFINITION(0x1, 0x8A3) },
    { ZYDIS_DEFINITION(0x1, 0x7B9), ZYDIS_DEFINITION(0x1, 0x7BA), ZYDIS_DEFINITION(0x1, 0x7BB) },
    { ZYDIS_DEFINITION(0x1, 0x7BC), ZYDIS_DEFINITION(0x1, 0x7BD), ZYDIS_DEFINITION(0x1, 0x7BE) },
    { ZYDIS_DEFINITION(0x1, 0x7DD), ZYDIS_DEFINITION(0x1, 0x7DE), ZYDIS_DEFINITION(0x1, 0x7DF) },
    { ZYDIS_DEFINITION(0x1, 0x7E0), ZYDIS_DEFINITION(0x1, 0x7E1), ZYDIS_DEFINITION(0x1, 0x7E2) },
    { ZYDIS_DEFINITION(0x1, 0x7BF), ZYDIS_DEFINITION(0x1, 0x7C0), ZYDIS_DEFINITION(0x1, 0x7C1) },
    { ZYDIS_DEFINITION(0x1, 0x7E3), ZYDIS_DEFINITION(0x1, 0x7E4), ZYDIS_DEFINITION(0x1, 0x7E5) },
    { ZYDIS_DEFINITION(0x1, 0x7C8), ZYDIS_DEFINITION(0x1, 0x7C9), ZYDIS_DEFINITION(0x1, 0x7CA) },
    { ZYDIS_DEFINITION(0x1, 0x7DA), ZYDIS_DEFINITION(0x1, 0x7DB), ZYDIS_DEFINITION(0x1, 0x7DC) },
    { ZYDIS_DEFINITION(0x1, 0x7CB), ZYDIS_DEFINITION(0x1, 0x7CC), ZYDIS_DEFINITION(0x1, 0x7CD) },
    { ZYDIS_DEFINITION(0x1, 0x8E2), ZYDIS_DEFINITION(0x1, 0x8E3), ZYDIS_DEFINITION(0x1, 0x8E4) },
    { ZYDIS_DEFINITION(0x1, 0x900), ZYDIS_DEFINITION(0x1, 0x901), ZYDIS_DEFINITION(0x1, 0x902) },
    { ZYDIS_DEFINITION(0x1, 0x8E5), ZYDIS_DEFINITION(0x1, 0x8E6), ZYDIS_DEFINITION(0x1, 0x8E7) },
    { ZYDIS_DEFINITION(0x1, 0x903), ZYDIS_DEFINITION(0x1, 0x904), ZYDIS_DEFINITION(0x1, 0x905) },
    { ZYDIS_DEFINITION(0x1, 0x8E8), ZYDIS_DEFINITION(0x1, 0x8E9), ZYDIS_DEFINITION(0x1, 0x8EA) },
    { ZYDIS_DEFINITION(0x1, 0x8FA), ZYDIS_DEFINITION(0x1, 0x8FB), ZYDIS_DEFINITION(0x1, 0x8FC) },
    { ZYDIS_DEFINITION(0x1, 0x8EB), ZYDIS_DEFINITION(0x1, 0x8EC), ZYDIS_DEFINITION(0x1, 0x8ED) },
    { ZYDIS_DEFINITION(0x1, 0x8FD), ZYDIS_DEFINITION(0x1, 0x8FE), ZYDIS_DEFINITION(0x1, 0x8FF) },
    { ZYDIS_DEFINITION(0x1, 0x8F4), ZYDIS_DEFINITION(0x1, 0x8F5), ZYDIS_DEFINITION(0x1, 0x8F6) },
    { ZYDIS_DEFINITION(0x1, 0x8EE), ZYDIS_DEFINITION(0x1, 0x8EF), ZYDIS_DEFINITION(0x1, 0x8F0) },
    { ZYDIS_DEFINITION(0x1, 0x8F7), ZYDIS_DEFINITION(0x1, 0x8F8), ZYDIS_DEFINITION(0x1, 0x8F9) },
    { ZYDIS_DEFINITION(0x1, 0x8F1), ZYDIS_DEFINITION(0x1, 0x8F2), ZYDIS_DEFINITION(0x1, 0x8F3) },
    { ZYDIS_DEFINITION(0x1, 0xABF), ZYDIS_DEFINITION(0x1, 0xAC0), ZYDIS_DEFINITION(0x1, 0xAC1) },
    { ZYDIS_DEFINITION(0x1, 0xAC2), ZYDIS_DEFINITION(0x1, 0xAC3), ZYDIS_DEFINITION(0x1, 0xAC4) },
    { ZYDIS_DEFINITION(0x1, 0x30D), ZYDIS_DEFINITION(0x1, 0x30E), ZYDIS_DEFINITION(0x1, 0x30F) },
    { ZYDIS_DEFINITION(0x1, 0x307), ZYDIS_DEFINITION(0x1, 0x308), ZYDIS_DEFINITION(0x1, 0x309) },
    { ZYDIS_DEFINITION(0x1, 0x310), ZYDIS_DEFINITION(0x1, 0x311), ZYDIS_DEFINITION(0x1, 0x312) },
    { ZYDIS_DEFINITION(0x1, 0x30A), ZYDIS_DEFINITION(0x1, 0x30B), ZYDIS_DEFINITION(0x1, 0x30C) },
    { ZYDIS_DEFINITION(0x1, 0x912), ZYDIS_DEFINITION(0x1, 0x913), ZYDIS_DEFINITION(0x1, 0x914) },
    { ZYDIS_DEFINITION(0x1, 0x918), ZYDIS_DEFINITION(0x1, 0x919), ZYDIS_DEFINITION(0x1, 0x91A) },
    { ZYDIS_DEFINITION(0x1, 0x915), ZYDIS_DEFINITION(0x1, 0x916), ZYDIS_DEFINITION(0x1, 0x917) },
    { ZYDIS_DEFINITION(0x1, 0x91B), ZYDIS_DEFINITION(0x1, 0x91C), ZYDIS_DEFINITION(0x1, 0x91D) },
    { ZYDIS_DEFINITION(0x1, 0xB7), ZYDIS_DEFINITION(0x1, 0xB8), ZYDIS_DEFINITION(0x1, 0xB9) },
    { ZYDIS_DEFINITION(0x1, 0xB1), ZYDIS_DEFINITION(0x1, 0xB2), ZYDIS_DEFINITION(0x1, 0xB3) },
    { ZYDIS_DEFINITION(0x1, 0xBA), ZYDIS_DEFINITION(0x1, 0xBB), ZYDIS_DEFINITION(0x1, 0xBC) },
    { ZYDIS_DEFINITION(0x1, 0xB4), ZYDIS_DEFINITION(0x1, 0xB5), ZYDIS_DEFINITION(0x1, 0xB6) },
    { ZYDIS_DEFINITION(0x1, 0x852), ZYDIS_DEFINITION(0x1, 0x853), ZYDIS_DEFINITION(0x1, 0x854) },
    { ZYDIS_DEFINITION(0x1, 0x858), ZYDIS_DEFINITION(0x1, 0x859), ZYDIS_DEFINITION(0x1, 0x85A) },
    { ZYDIS_DEFINITION(0x1, 0x855), ZYDIS_DEFINITION(0x1, 0x856), ZYDIS_DEFINITION(0x1, 0x857) },
    { ZYDIS_DEFINITION(0x1, 0x85B), ZYDIS_DEFINITION(0x1, 0x85C), ZYDIS_DEFINITION(0x1, 0x85D) },
    { ZYDIS_DEFINITION(0x1, 0x888), ZYDIS_DEFINITION(0x1, 0x889), ZYDIS_DEFINITION(0x1, 0x88A) },
    { ZYDIS_DEFINITION(0x1, 0x906), ZYDIS_DEFINITION(0x1, 0x907), ZYDIS_DEFINITION(0x1, 0x908) },
    { ZYDIS_DEFINITION(0x1, 0x88B), ZYDIS_DEFINITION(0x1, 0x88C), ZYDIS_DEFINITION(0x1, 0x88D) },
    { ZYDIS_DEFINITION(0x1, 0x909), ZYDIS_DEFINITION(0x1, 0x90A), ZYDIS_DEFINITION(0x1, 0x90B) },
    { ZYDIS_DEFINITION(0x1, 0xB7F), ZYDIS_DEFINITION(0x1, 0xB80), ZYDIS_DEFINITION(0x1, 0xB81) },
    { ZYDIS_DEFINITION(0x1, 0xB82), ZYDIS_DEFINITION(0x1, 0xB83), ZYDIS_DEFINITION(0x1, 0xB84) },
    { ZYDIS_DEFINITION(0x1, 0x92F), ZYDIS_DEFINITION(0x1, 0x930), ZYDIS_DEFINITION(0x1, 0x931) },
    { ZYDIS_DEFINITION(0x1, 0x932), ZYDIS_DEFINITION(0x1, 0x933), ZYDIS_DEFINITION(0x1, 0x934) },
    { ZYDIS_DEFINITION(0x1, 0x935), ZYDIS_DEFINITION(0x1, 0x936), ZYDIS_DEFINITION(0x1, 0x937) },
    { ZYDIS_DEFINITION(0x1, 0x938), ZYDIS_DEFINITION(0x1, 0x939), ZYDIS_DEFINITION(0x1, 0x93A) },
    { ZYDIS_DEFINITION(0x1, 0x56A), ZYDIS_DEFINITION(0x1, 0x56B), ZYDIS_DEFINITION(0x1, 0x56C) },
    { ZYDIS_DEFINITION(0x1, 0x567), ZYDIS_DEFINITION(0x1, 0x568), ZYDIS_DEFINITION(0x1, 0x569) },
    { ZYDIS_DEFINITION(0x1, 0x578), ZYDIS_DEFINITION(0x1, 0x579), ZYDIS_DEFINITION(0x1, 0x57A) },
    { ZYDIS_DEFINITION(0x1, 0x575), ZYDIS_DEFINITION(0x1, 0x576), ZYDIS_DEFINITION(0x1, 0x577) },
    { ZYDIS_DEFINITION(0x1, 0x3C8), ZYDIS_DEFINITION(0x1, 0x3C9), ZYDIS_DEFINITION(0x1, 0x3CA) },
    { ZYDIS_DEFINITION(0x1, 0x3BA), ZYDIS_DEFINITION(0x1, 0x3BB), ZYDIS_DEFINITION(0x1, 0x3BC) },
    { ZYDIS_DEFINITION(0x1, 0x3CB), ZYDIS_DEFINITION(0x1, 0x3CC), ZYDIS_DEFINITION(0x1, 0x3CD) },
    { ZYDIS_DEFINITION(0x1, 0x3BD), ZYDIS_DEFINITION(0x1, 0x3BE), ZYDIS_DEFINITION(0x1, 0x3BF) },
    { ZYDIS_DEFINITION(0x1, 0x461), ZYDIS_DEFINITION(0x1, 0x462), ZYDIS_DEFINITION(0x1, 0x463) },
    { ZYDIS_DEFINITION(0x1, 0x453), ZYDIS_DEFINITION(0x1, 0x454), ZYDIS_DEFINITION(0x1, 0x455) },
    { ZYDIS_DEFINITION(0x1, 0x464), ZYDIS_DEFINITION(0x1, 0x465), ZYDIS_DEFINITION(0x1, 0x466) },
    { ZYDIS_DEFINITION(0x1, 0x456), ZYDIS_DEFINITION(0x1, 0x457), ZYDIS_DEFINITION(0x1, 0x458) },
    { ZYDIS_DEFINITION(0x1, 0x364), ZYDIS_DEFINITION(0x1, 0x365), ZYDIS_DEFINITION(0x1, 0x366) },
    { ZYDIS_DEFINITION(0x1, 0x356), ZYDIS_DEFINITION(0x1, 0x357), ZYDIS_DEFINITION(0x1, 0x358) },
    { ZYDIS_DEFINITION(0x1, 0x367), ZYDIS_DEFINITION(0x1, 0x368), ZYDIS_DEFINITION(0x1, 0x369) },
    { ZYDIS_DEFINITION(0x1, 0x359), ZYDIS_DEFINITION(0x1, 0x35A), ZYDIS_DEFINITION(0x1, 0x35B) },
    { ZYDIS_DEFINITION(0x1, 0x407), ZYDIS_DEFINITION(0x1, 0x408), ZYDIS_DEFINITION(0x1, 0x409) },
    { ZYDIS_DEFINITION(0x1, 0x3F9), ZYDIS_DEFINITION(0x1, 0x3FA), ZYDIS_DEFINITION(0x1, 0x3FB) },
    { ZYDIS_DEFINITION(0x1, 0x40A), ZYDIS_DEFINITION(0x1, 0x40B), ZYDIS_DEFINITION(0x1, 0x40C) },
    { ZYDIS_DEFINITION(0x1, 0x3FC), ZYDIS_DEFINITION(0x1, 0x3FD), ZYDIS_DEFINITION(0x1, 0x3FE) },
    { ZYDIS_DEFINITION(0x1, 0x4AA), ZYDIS_DEFINITION(0x1, 0x4AB), ZYDIS_DEFINITION(0x1, 0x4AC) },
    { ZYDIS_DEFINITION(0x1, 0x49C), ZYDIS_DEFINITION(0x1, 0x49D), ZYDIS_DEFINITION(0x1, 0x49E) },
    { ZYDIS_DEFINITION(0x1, 0x4AD), ZYDIS_DEFINITION(0x1, 0x4AE), ZYDIS_DEFINITION(0x1, 0x4AF) },
    { ZYDIS_DEFINITION(0x1, 0x49F), ZYDIS_DEFINITION(0x1, 0x4A0), ZYDIS_DEFINITION(0x1, 0x4A1) },
    { ZYDIS_DEFINITION(0x1, 0x504), ZYDIS_DEFINITION(0x1, 0x505), ZYDIS_DEFINITION(0x1, 0x506) },
    { ZYDIS_DEFINITION(0x1, 0x4F6), ZYDIS_DEFINITION(0x1, 0x4F7), ZYDIS_DEFINITION(0x1, 0x4F8) },
    { ZYDIS_DEFINITION(0x1, 0x507), ZYDIS_DEFINITION(0x1, 0x508), ZYDIS_DEFINITION(0x1, 0x509) },
    { ZYDIS_DEFINITION(0x1, 0x4F9), ZYDIS_DEFINITION(0x1, 0x4FA), ZYDIS_DEFINITION(0x1, 0x4FB) },
    { ZYDIS_DEFINITION(0x1, 0xB25), ZYDIS_DEFINITION(0x1, 0xB26), ZYDIS_DEFINITION(0x1, 0xB27) },
    { ZYDIS_DEFINITION(0x1, 0xB28), ZYDIS_DEFINITION(0x1, 0xB29), ZYDIS_DEFINITION(0x1, 0xB2A) },
    { ZYDIS_DEFINITION(0x1, 0xB2B), ZYDIS_DEFINITION(0x1, 0xB2C), ZYDIS_DEFINITION(0x1, 0xB2D) },
    { ZYDIS_DEFINITION(0x1, 0xB2E), ZYDIS_DEFINITION(0x1, 0xB2F), ZYDIS_DEFINITION(0x1, 0xB30) },
    { ZYDIS_DEFINITION(0x1, 0xDA6), ZYDIS_DEFINITION(0x1, 0xDA7), ZYDIS_DEFINITION(0x1, 0xDA8) },
    { ZYDIS_DEFINITION(0x1, 0xDA3), ZYDIS_DEFINITION(0x1, 0xDA4), ZYDIS_DEFINITION(0x1, 0xDA5) },
    { ZYDIS_DEFINITION(0x1, 0xDB4), ZYDIS_DEFINITION(0x1, 0xDB5), ZYDIS_DEFINITION(0x1, 0xDB6) },
    { ZYDIS_DEFINITION(0x1, 0xDB1), ZYDIS_DEFINITION(0x1, 0xDB2), ZYDIS_DEFINITION(0x1, 0xDB3) },
    { ZYDIS_DEFINITION(0x1, 0x3DD), ZYDIS_DEFINITION(0x1, 0x3DE), ZYDIS_DEFINITION(0x1, 0x3DF) },
    { ZYDIS_DEFINITION(0x1, 0x3CF), ZYDIS_DEFINITION(0x1, 0x3D0), ZYDIS_DEFINITION(0x1, 0x3D1) },
    { ZYDIS_DEFINITION(0x1, 0x3E0), ZYDIS_DEFINITION(0x1, 0x3E1), ZYDIS_DEFINITION(0x1, 0x3E2) },
    { ZYDIS_DEFINITION(0x1, 0x3D2), ZYDIS_DEFINITION(0x1, 0x3D3), ZYDIS_DEFINITION(0x1, 0x3D4) },
    { ZYDIS_DEFINITION(0x1, 0x476), ZYDIS_DEFINITION(0x1, 0x477), ZYDIS_DEFINITION(0x1, 0x478) },
    { ZYDIS_DEFINITION(0x1, 0x468), ZYDIS_DEFINITION(0x1, 0x469), ZYDIS_DEFINITION(0x1, 0x46A) },
    { ZYDIS_DEFINITION(0x1, 0x479), ZYDIS_DEFINITION(0x1, 0x47A), ZYDIS_DEFINITION(0x1, 0x47B) },
    { ZYDIS_DEFINITION(0x1, 0x46B), ZYDIS_DEFINITION(0x1, 0x46C), ZYDIS_DEFINITION(0x1, 0x46D) },
    { ZYDIS_DEFINITION(0x1, 0x382), ZYDIS_DEFINITION(0x1, 0x383), ZYDIS_DEFINITION(0x1, 0x384) },
    { ZYDIS_DEFINITION(0x1, 0x374), ZYDIS_DEFINITION(0x1, 0x375), ZYDIS_DEFINITION(0x1, 0x376) },
    { ZYDIS_DEFINITION(0x1, 0x385), ZYDIS_DEFINITION(0x1, 0x386), ZYDIS_DEFINITION(0x1, 0x387) },
    { ZYDIS_DEFINITION(0x1, 0x377), ZYDIS_DEFINITION(0x1, 0x378), ZYDIS_DEFINITION(0x1, 0x379) },
    { ZYDIS_DEFINITION(0x1, 0x425), ZYDIS_DEFINITION(0x1, 0x426), ZYDIS_DEFINITION(0x1, 0x427) },
    { ZYDIS_DEFINITION(0x1, 0x417), ZYDIS_DEFINITION(0x1, 0x418), ZYDIS_DEFINITION(0x1, 0x419) },
    { ZYDIS_DEFINITION(0x1, 0x428), ZYDIS_DEFINITION(0x1, 0x429), ZYDIS_DEFINITION(0x1, 0x42A) },
    { ZYDIS_DEFINITION(0x1, 0x41A), ZYDIS_DEFINITION(0x1, 0x41B), ZYDIS_DEFINITION(0x1, 0x41C) },
    { ZYDIS_DEFINITION(0x1, 0x4C8), ZYDIS_DEFINITION(0x1, 0x4C9), ZYDIS_DEFINITION(0x1, 0x4CA) },
    { ZYDIS_DEFINITION(0x1, 0x4BA), ZYDIS_DEFINITION(0x1, 0x4BB), ZYDIS_DEFINITION(0x1, 0x4BC) },
    { ZYDIS_DEFINITION(0x1, 0x4CB), ZYDIS_DEFINITION(0x1, 0x4CC), ZYDIS_DEFINITION(0x1, 0x4CD) },
    { ZYDIS_DEFINITION(0x1, 0x4BD), ZYDIS_DEFINITION(0x1, 0x4BE), ZYDIS_DEFINITION(0x1, 0x4BF) },
    { ZYDIS_DEFINITION(0x1, 0x522), ZYDIS_DEFINITION(0x1, 0x523), ZYDIS_DEFINITION(0x1, 0x524) },
    { ZYDIS_DEFINITION(0x1, 0x514), ZYDIS_DEFINITION(0x1, 0x515), ZYDIS_DEFINITION(0x1, 0x516) },
    { ZYDIS_DEFINITION(0x1, 0x525), ZYDIS_DEFINITION(0x1, 0x526), ZYDIS_DEFINITION(0x1, 0x527) },
    { ZYDIS_DEFINITION(0x1, 0x517), ZYDIS_DEFINITION(0x1, 0x518), ZYDIS_DEFINITION(0x1, 0x519) },
    { ZYDIS_DEFINITION(0x1, 0x957), ZYDIS_DEFINITION(0x1, 0x958), ZYDIS_DEFINITION(0x1, 0x959) },
    { ZYDIS_DEFINITION(0x1, 0x95A), ZYDIS_DEFINITION(0x1, 0x95B), ZYDIS_DEFINITION(0x1, 0x95C) },
    { ZYDIS_DEFINITION(0x1, 0x951), ZYDIS_DEFINITION(0x1, 0x952), ZYDIS_DEFINITION(0x1, 0x953) },
    { ZYDIS_DEFINITION(0x1, 0x954), ZYDIS_DEFINITION(0x1, 0x955), ZYDIS_DEFINITION(0x1, 0x956) },
    { ZYDIS_DEFINITION(0x1, 0x3F2), ZYDIS_DEFINITION(0x1, 0x3F3), ZYDIS_DEFINITION(0x1, 0x3F4) },
    { ZYDIS_DEFINITION(0x1, 0x3E4), ZYDIS_DEFINITION(0x1, 0x3E5), ZYDIS_DEFINITION(0x1, 0x3E6) },
    { ZYDIS_DEFINITION(0x1, 0x3F5), ZYDIS_DEFINITION(0x1, 0x3F6), ZYDIS_DEFINITION(0x1, 0x3F7) },
    { ZYDIS_DEFINITION(0x1, 0x3E7), ZYDIS_DEFINITION(0x1, 0x3E8), ZYDIS_DEFINITION(0x1, 0x3E9) },
    { ZYDIS_DEFINITION(0x1, 0x48B), ZYDIS_DEFINITION(0x1, 0x48C), ZYDIS_DEFINITION(0x1, 0x48D) },
    { ZYDIS_DEFINITION(0x1, 0x47D), ZYDIS_DEFINITION(0x1, 0x47E), ZYDIS_DEFINITION(0x1, 0x47F) },
    { ZYDIS_DEFINITION(0x1, 0x48E), ZYDIS_DEFINITION(0x1, 0x48F), ZYDIS_DEFINITION(0x1, 0x490) },
    { ZYDIS_DEFINITION(0x1, 0x480), ZYDIS_DEFINITION(0x1, 0x481), ZYDIS_DEFINITION(0x1, 0x482) },
    { ZYDIS_DEFINITION(0x1, 0x3A0), ZYDIS_DEFINITION(0x1, 0x3A1), ZYDIS_DEFINITION(0x1, 0x3A2) },
    { ZYDIS_DEFINITION(0x1, 0x392), ZYDIS_DEFINITION(0x1, 0x393), ZYDIS_DEFINITION(0x1, 0x394) },
    { ZYDIS_DEFINITION(0x1, 0x3A3), ZYDIS_DEFINITION(0x1, 0x3A4), ZYDIS_DEFINITION(0x1, 0x3A5) },
    { ZYDIS_DEFINITION(0x1, 0x395), ZYDIS_DEFINITION(0x1, 0x396), ZYDIS_DEFINITION(0x1, 0x397) },
    { ZYDIS_DEFINITION(0x1, 0x443), ZYDIS_DEFINITION(0x1, 0x444), ZYDIS_DEFINITION(0x1, 0x445) },
    { ZYDIS_DEFINITION(0x1, 0x435), ZYDIS_DEFINITION(0x1, 0x436), ZYDIS_DEFINITION(0x1, 0x437) },
    { ZYDIS_DEFINITION(0x1, 0x446), ZYDIS_DEFINITION(0x1, 0x447), ZYDIS_DEFINITION(0x1, 0x448) },
    { ZYDIS_DEFINITION(0x1, 0x438), ZYDIS_DEFINITION(0x1, 0x439), ZYDIS_DEFINITION(0x1, 0x43A) },
    { ZYDIS_DEFINITION(0x1, 0x4E6), ZYDIS_DEFINITION(0x1, 0x4E7), ZYDIS_DEFINITION(0x1, 0x4E8) },
    { ZYDIS_DEFINITION(0x1, 0x4D8), ZYDIS_DEFINITION(0x1, 0x4D9), ZYDIS_DEFINITION(0x1, 0x4DA) },
    { ZYDIS_DEFINITION(0x1, 0x4E9), ZYDIS_DEFINITION(0x1, 0x4EA), ZYDIS_DEFINITION(0x1, 0x4EB) },
    { ZYDIS_DEFINITION(0x1, 0x4DB), ZYDIS_DEFINITION(0x1, 0x4DC), ZYDIS_DEFINITION(0x1, 0x4DD) },
    { ZYDIS_DEFINITION(0x1, 0x540), ZYDIS_DEFINITION(0x1, 0x541), ZYDIS_DEFINITION(0x1, 0x542) },
    { ZYDIS_DEFINITION(0x1, 0x532), ZYDIS_DEFINITION(0x1, 0x533), ZYDIS_DEFINITION(0x1, 0x534) },
    { ZYDIS_DEFINITION(0x1, 0x543), ZYDIS_DEFINITION(0x1, 0x544), ZYDIS_DEFINITION(0x1, 0x545) },
    { ZYDIS_DEFINITION(0x1, 0x535), ZYDIS_DEFINITION(0x1, 0x536), ZYDIS_DEFINITION(0x1, 0x537) },
    { ZYDIS_DEFINITION(0x1, 0x864), ZYDIS_DEFINITION(0x1, 0x865), ZYDIS_DEFINITION(0x1, 0x866) },
    { ZYDIS_DEFINITION(0x1, 0x86A), ZYDIS_DEFINITION(0x1, 0x86B), ZYDIS_DEFINITION(0x1, 0x86C) },
    { ZYDIS_DEFINITION(0x1, 0x867), ZYDIS_DEFINITION(0x1, 0x868), ZYDIS_DEFINITION(0x1, 0x869) },
    { ZYDIS_DEFINITION(0x1, 0x86D), ZYDIS_DEFINITION(0x1, 0x86E), ZYDIS_DEFINITION(0x1, 0x86F) },
    { ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_DEFINITION(0x1, 0x56E) },
    { ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_DEFINITION(0x1, 0x56D) },
    { ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_DEFINITION(0x1, 0x572) },
    { ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_DEFINITION(0x1, 0x571) },
    { ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_DEFINITION(0x1, 0xDAA) },
    { ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_DEFINITION(0x1, 0xDA9) },
    { ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_DEFINITION(0x1, 0xDAE) },
    { ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_DEFINITION(0x1, 0xDAD) },
    { ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_DEFINITION(0x1, 0x570) },
    { ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_DEFINITION(0x1, 0x56F) },
    { ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_DEFINITION(0x1, 0x574) },
    { ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_DEFINITION(0x1, 0x573) },
    { ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_DEFINITION(0x1, 0xDAC) },
    { ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_DEFINITION(0x1, 0xDAB) },
    { ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_DEFINITION(0x1, 0xDB0) },
    { ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_DEFINITION(0x1, 0xDAF) },
    { ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_DEFINITION(0x1, 0x305) },
    { ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_DEFINITION(0x1, 0x302) },
    { ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_DEFINITION(0x1, 0x306) },
    { ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_DEFINITION(0x1, 0x303) },
    { ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_DEFINITION(0x1, 0xD15) },
    { ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_DEFINITION(0x1, 0xD12) },
    { ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_DEFINITION(0x1, 0xD16) },
    { ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_DEFINITION(0x1, 0xD13) },
    { ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_DEFINITION(0x1, 0xD75) },
    { ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_DEFINITION(0x1, 0xD72) },
    { ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_DEFINITION(0x1, 0xD76) },
    { ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_DEFINITION(0x1, 0xD73) },
    { ZYDIS_DEFINITION(0x1, 0x5C3), ZYDIS_DEFINITION(0x1, 0x5C4), ZYDIS_DEFINITION(0x1, 0x5C5) },
    { ZYDIS_DEFINITION(0x1, 0x5C6), ZYDIS_DEFINITION(0x1, 0x5C7), ZYDIS_DEFINITION(0x1, 0x5C8) },
    { ZYDIS_DEFINITION(0x1, 0x2E), ZYDIS_DEFINITION(0x1, 0x2F), ZYDIS_DEFINITION(0x1, 0x30) },
    { ZYDIS_DEFINITION(0x1, 0x31), ZYDIS_DEFINITION(0x1, 0x32), ZYDIS_DEFINITION(0x1, 0x33) },
    { ZYDIS_DEFINITION(0x1, 0x34), ZYDIS_DEFINITION(0x1, 0x35), ZYDIS_DEFINITION(0x1, 0x36) },
    { ZYDIS_DEFINITION(0x1, 0x37), ZYDIS_DEFINITION(0x1, 0x38), ZYDIS_DEFINITION(0x1, 0x39) },
    { ZYDIS_DEFINITION(0x1, 0x22), ZYDIS_DEFINITION(0x1, 0x23), ZYDIS_DEFINITION(0x1, 0x24) },
    { ZYDIS_DEFINITION(0x1, 0x25), ZYDIS_DEFINITION(0x1, 0x26), ZYDIS_DEFINITION(0x1, 0x27) },
    { ZYDIS_DEFINITION(0x1, 0x28), ZYDIS_DEFINITION(0x1, 0x29), ZYDIS_DEFINITION(0x1, 0x2A) },
    { ZYDIS_DEFINITION(0x1, 0x2B), ZYDIS_DEFINITION(0x1, 0x2C), ZYDIS_DEFINITION(0x1, 0x2D) },
    { ZYDIS_INVALID, ZYDIS_DEFINITION(0xB, 0x8DE), ZYDIS_DEFINITION(0xB, 0x8DF) },
    { ZYDIS_INVALID, ZYDIS_DEFINITION(0xB, 0x8E0), ZYDIS_DEFINITION(0xB, 0x8E1) },
    { ZYDIS_INVALID, ZYDIS_DEFINITION(0xB, 0x8D2), ZYDIS_DEFINITION(0xB, 0x8D3) },
    { ZYDIS_INVALID, ZYDIS_DEFINITION(0xB, 0x8D4), ZYDIS_DEFINITION(0xB, 0x8D5) },
    { ZYDIS_DEFINITION(0xB, 0x3A), ZYDIS_DEFINITION(0xB, 0x3B), ZYDIS_DEFINITION(0xB, 0x3C) },
    { ZYDIS_DEFINITION(0xB, 0x40), ZYDIS_DEFINITION(0xB, 0x41), ZYDIS_DEFINITION(0xB, 0x42) },
    { ZYDIS_DEFINITION(0xB, 0x3D), ZYDIS_DEFINITION(0xB, 0x3E), ZYDIS_DEFINITION(0xB, 0x3F) },
    { ZYDIS_DEFINITION(0xB, 0x43), ZYDIS_DEFINITION(0xB, 0x44), ZYDIS_DEFINITION(0xB, 0x45) },
    { ZYDIS_DEFINITION(0xB, 0x8C8), ZYDIS_DEFINITION(0xB, 0x8C9), ZYDIS_DEFINITION(0xB, 0x8CA) },
    { ZYDIS_DEFINITION(0xB, 0x8CB), ZYDIS_DEFINITION(0xB, 0x8CC), ZYDIS_DEFINITION(0xB, 0x8CD) },
    { ZYDIS_DEFINITION(0xB, 0x8BC), ZYDIS_DEFINITION(0xB, 0x8BD), ZYDIS_DEFINITION(0xB, 0x8BE) },
    { ZYDIS_DEFINITION(0xB, 0x8BF), ZYDIS_DEFINITION(0xB, 0x8C0), ZYDIS_DEFINITION(0xB, 0x8C1) },
    { ZYDIS_DEFINITION(0xB, 0xD52), ZYDIS_DEFINITION(0xB, 0xD53), ZYDIS_DEFINITION(0xB, 0xD54) },
    { ZYDIS_DEFINITION(0xB, 0xD55), ZYDIS_DEFINITION(0xB, 0xD56), ZYDIS_DEFINITION(0xB, 0xD57) },
    { ZYDIS_DEFINITION(0xB, 0xD44), ZYDIS_DEFINITION(0xB, 0xD45), ZYDIS_DEFINITION(0xB, 0xD46) },
    { ZYDIS_DEFINITION(0xB, 0xD47), ZYDIS_DEFINITION(0xB, 0xD48), ZYDIS_DEFINITION(0xB, 0xD49) },
    { ZYDIS_DEFINITION(0xB, 0x777), ZYDIS_DEFINITION(0xB, 0x778), ZYDIS_DEFINITION(0xB, 0x779) },
    { ZYDIS_DEFINITION(0xB, 0x77A), ZYDIS_DEFINITION(0xB, 0x77B), ZYDIS_DEFINITION(0xB, 0x77C) },
    { ZYDIS_DEFINITION(0xB, 0x924), ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0xB, 0x925), ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0xB, 0x92D), ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0xB, 0x92E), ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0xB, 0x926), ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0xB, 0x92A), ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0xB, 0x928), ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0xB, 0x927), ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0xB, 0x92B), ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0xB, 0x929), ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0xB, 0x32B), ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0xB, 0x32C), ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_INVALID, ZYDIS_DEFINITION(0xB, 0x5C9), ZYDIS_DEFINITION(0xB, 0x5CA) },
    { ZYDIS_INVALID, ZYDIS_DEFINITION(0xB, 0x5CF), ZYDIS_DEFINITION(0xB, 0x5D0) },
    { ZYDIS_INVALID, ZYDIS_DEFINITION(0xB, 0x5CB), ZYDIS_DEFINITION(0xB, 0x5CC) },
    { ZYDIS_INVALID, ZYDIS_DEFINITION(0xB, 0x5D1), ZYDIS_DEFINITION(0xB, 0x5D2) },
    { ZYDIS_INVALID, ZYDIS_DEFINITION(0xB, 0x313), ZYDIS_DEFINITION(0xB, 0x314) },
    { ZYDIS_INVALID, ZYDIS_DEFINITION(0xB, 0x319), ZYDIS_DEFINITION(0xB, 0x31A) },
    { ZYDIS_INVALID, ZYDIS_DEFINITION(0xB, 0x315), ZYDIS_DEFINITION(0xB, 0x316) },
    { ZYDIS_INVALID, ZYDIS_DEFINITION(0xB, 0x31B), ZYDIS_DEFINITION(0xB, 0x31C) },
    { ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_DEFINITION(0xB, 0x5CD) },
    { ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_DEFINITION(0xB, 0x5D3) },
    { ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_DEFINITION(0xB, 0x5CE) },
    { ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_DEFINITION(0xB, 0x5D4) },
    { ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_DEFINITION(0xB, 0x317) },
    { ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_DEFINITION(0xB, 0x31D) },
    { ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_DEFINITION(0xB, 0x318) },
    { ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_DEFINITION(0xB, 0x31E) },
    { ZYDIS_DEFINITION(0xB, 0x156), ZYDIS_DEFINITION(0xB, 0x157), ZYDIS_DEFINITION(0xB, 0x158) },
    { ZYDIS_DEFINITION(0xB, 0x159), ZYDIS_DEFINITION(0xB, 0x15A), ZYDIS_DEFINITION(0xB, 0x15B) },
    { ZYDIS_DEFINITION(0xB, 0x834), ZYDIS_DEFINITION(0xB, 0x835), ZYDIS_DEFINITION(0xB, 0x836) },
    { ZYDIS_DEFINITION(0xB, 0x83A), ZYDIS_DEFINITION(0xB, 0x83B), ZYDIS_DEFINITION(0xB, 0x83C) },
    { ZYDIS_DEFINITION(0xB, 0x837), ZYDIS_DEFINITION(0xB, 0x838), ZYDIS_DEFINITION(0xB, 0x839) },
    { ZYDIS_DEFINITION(0xB, 0x83D), ZYDIS_DEFINITION(0xB, 0x83E), ZYDIS_DEFINITION(0xB, 0x83F) },
    { ZYDIS_DEFINITION(0xB, 0x7F2), ZYDIS_DEFINITION(0xB, 0x7F3), ZYDIS_DEFINITION(0xB, 0x7F4) },
    { ZYDIS_DEFINITION(0xB, 0x828), ZYDIS_DEFINITION(0xB, 0x829), ZYDIS_DEFINITION(0xB, 0x82A) },
    { ZYDIS_DEFINITION(0xB, 0x7F5), ZYDIS_DEFINITION(0xB, 0x7F6), ZYDIS_DEFINITION(0xB, 0x7F7) },
    { ZYDIS_DEFINITION(0xB, 0x82B), ZYDIS_DEFINITION(0xB, 0x82C), ZYDIS_DEFINITION(0xB, 0x82D) },
    { ZYDIS_DEFINITION(0xB, 0x93B), ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0xB, 0x93C), ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0xB, 0x5E1), ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0xB, 0x5E2), ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0xB, 0x93D), ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0xB, 0x941), ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0xB, 0x93F), ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0xB, 0x93E), ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0xB, 0x942), ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0xB, 0x940), ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_INVALID, ZYDIS_DEFINITION(0xB, 0xDB7), ZYDIS_DEFINITION(0xB, 0xDB8) },
    { ZYDIS_INVALID, ZYDIS_DEFINITION(0xB, 0xDBB), ZYDIS_DEFINITION(0xB, 0xDBC) },
    { ZYDIS_INVALID, ZYDIS_DEFINITION(0xB, 0xDB9), ZYDIS_DEFINITION(0xB, 0xDBA) },
    { ZYDIS_INVALID, ZYDIS_DEFINITION(0xB, 0xDBD), ZYDIS_DEFINITION(0xB, 0xDBE) },
    { ZYDIS_DEFINITION(0xB, 0xC75), ZYDIS_DEFINITION(0xB, 0xC76), ZYDIS_DEFINITION(0xB, 0xC77) },
    { ZYDIS_DEFINITION(0xB, 0xC7B), ZYDIS_DEFINITION(0xB, 0xC7C), ZYDIS_DEFINITION(0xB, 0xC7D) },
    { ZYDIS_DEFINITION(0xB, 0xC78), ZYDIS_DEFINITION(0xB, 0xC79), ZYDIS_DEFINITION(0xB, 0xC7A) },
    { ZYDIS_DEFINITION(0xB, 0xC7E), ZYDIS_DEFINITION(0xB, 0xC7F), ZYDIS_DEFINITION(0xB, 0xC80) },
    { ZYDIS_DEFINITION(0xB, 0x5A8), ZYDIS_DEFINITION(0xB, 0x5A9), ZYDIS_DEFINITION(0xB, 0x5AA) },
    { ZYDIS_DEFINITION(0xB, 0x59A), ZYDIS_DEFINITION(0xB, 0x59B), ZYDIS_DEFINITION(0xB, 0x59C) },
    { ZYDIS_DEFINITION(0xB, 0x5AB), ZYDIS_DEFINITION(0xB, 0x5AC), ZYDIS_DEFINITION(0xB, 0x5AD) },
    { ZYDIS_DEFINITION(0xB, 0x59D), ZYDIS_DEFINITION(0xB, 0x59E), ZYDIS_DEFINITION(0xB, 0x59F) },
    { ZYDIS_INVALID, ZYDIS_DEFINITION(0xB, 0x5D5), ZYDIS_DEFINITION(0xB, 0x5D6) },
    { ZYDIS_INVALID, ZYDIS_DEFINITION(0xB, 0x5DB), ZYDIS_DEFINITION(0xB, 0x5DC) },
    { ZYDIS_INVALID, ZYDIS_DEFINITION(0xB, 0x5D7), ZYDIS_DEFINITION(0xB, 0x5D8) },
    { ZYDIS_INVALID, ZYDIS_DEFINITION(0xB, 0x5DD), ZYDIS_DEFINITION(0xB, 0x5DE) },
    { ZYDIS_INVALID, ZYDIS_DEFINITION(0xB, 0x31F), ZYDIS_DEFINITION(0xB, 0x320) },
    { ZYDIS_INVALID, ZYDIS_DEFINITION(0xB, 0x325), ZYDIS_DEFINITION(0xB, 0x326) },
    { ZYDIS_INVALID, ZYDIS_DEFINITION(0xB, 0x321), ZYDIS_DEFINITION(0xB, 0x322) },
    { ZYDIS_INVALID, ZYDIS_DEFINITION(0xB, 0x327), ZYDIS_DEFINITION(0xB, 0x328) },
    { ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_DEFINITION(0xB, 0x5D9) },
    { ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_DEFINITION(0xB, 0x5DF) },
    { ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_DEFINITION(0xB, 0x5DA) },
    { ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_DEFINITION(0xB, 0x5E0) },
    { ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_DEFINITION(0xB, 0x323) },
    { ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_DEFINITION(0xB, 0x329) },
    { ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_DEFINITION(0xB, 0x324) },
    { ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_DEFINITION(0xB, 0x32A) },
    { ZYDIS_DEFINITION(0xB, 0x82E), ZYDIS_DEFINITION(0xB, 0x82F), ZYDIS_DEFINITION(0xB, 0x830) },
    { ZYDIS_DEFINITION(0xB, 0x840), ZYDIS_DEFINITION(0xB, 0x841), ZYDIS_DEFINITION(0xB, 0x842) },
    { ZYDIS_DEFINITION(0xB, 0x831), ZYDIS_DEFINITION(0xB, 0x832), ZYDIS_DEFINITION(0xB, 0x833) },
    { ZYDIS_DEFINITION(0xB, 0x843), ZYDIS_DEFINITION(0xB, 0x844), ZYDIS_DEFINITION(0xB, 0x845) },
    { ZYDIS_DEFINITION(0xB, 0x7EC), ZYDIS_DEFINITION(0xB, 0x7ED), ZYDIS_DEFINITION(0xB, 0x7EE) },
    { ZYDIS_DEFINITION(0xB, 0x846), ZYDIS_DEFINITION(0xB, 0x847), ZYDIS_DEFINITION(0xB, 0x848) },
    { ZYDIS_DEFINITION(0xB, 0x7EF), ZYDIS_DEFINITION(0xB, 0x7F0), ZYDIS_DEFINITION(0xB, 0x7F1) },
    { ZYDIS_DEFINITION(0xB, 0x849), ZYDIS_DEFINITION(0xB, 0x84A), ZYDIS_DEFINITION(0xB, 0x84B) },
    { ZYDIS_DEFINITION(0xB, 0x2D7), ZYDIS_DEFINITION(0xB, 0x2D8), ZYDIS_DEFINITION(0xB, 0x2D9) },
    { ZYDIS_DEFINITION(0xB, 0x2DA), ZYDIS_DEFINITION(0xB, 0x2DB), ZYDIS_DEFINITION(0xB, 0x2DC) },
    { ZYDIS_INVALID, ZYDIS_DEFINITION(0xB, 0xDBF), ZYDIS_DEFINITION(0xB, 0xDC0) },
    { ZYDIS_INVALID, ZYDIS_DEFINITION(0xB, 0xDC3), ZYDIS_DEFINITION(0xB, 0xDC4) },
    { ZYDIS_INVALID, ZYDIS_DEFINITION(0xB, 0xDC1), ZYDIS_DEFINITION(0xB, 0xDC2) },
    { ZYDIS_INVALID, ZYDIS_DEFINITION(0xB, 0xDC5), ZYDIS_DEFINITION(0xB, 0xDC6) },
    { ZYDIS_DEFINITION(0xB, 0x7E6), ZYDIS_DEFINITION(0xB, 0x7E7), ZYDIS_DEFINITION(0xB, 0x7E8) },
    { ZYDIS_DEFINITION(0xB, 0x7E9), ZYDIS_DEFINITION(0xB, 0x7EA), ZYDIS_DEFINITION(0xB, 0x7EB) },
    { ZYDIS_DEFINITION(0xB, 0xCF5), ZYDIS_DEFINITION(0xB, 0xCF6), ZYDIS_DEFINITION(0xB, 0xCF7) },
    { ZYDIS_DEFINITION(0xB, 0xCEE), ZYDIS_DEFINITION(0xB, 0xCEF), ZYDIS_DEFINITION(0xB, 0xCF0) },
    { ZYDIS_DEFINITION(0xB, 0xCF8), ZYDIS_DEFINITION(0xB, 0xCF9), ZYDIS_DEFINITION(0xB, 0xCFA) },
    { ZYDIS_DEFINITION(0xB, 0xCF1), ZYDIS_DEFINITION(0xB, 0xCF2), ZYDIS_DEFINITION(0xB, 0xCF3) },
    { ZYDIS_DEFINITION(0xB, 0x349), ZYDIS_DEFINITION(0xB, 0x34A), ZYDIS_DEFINITION(0xB, 0x34B) },
    { ZYDIS_DEFINITION(0xB, 0x342), ZYDIS_DEFINITION(0xB, 0x343), ZYDIS_DEFINITION(0xB, 0x344) },
    { ZYDIS_DEFINITION(0xB, 0x34C), ZYDIS_DEFINITION(0xB, 0x34D), ZYDIS_DEFINITION(0xB, 0x34E) },
    { ZYDIS_DEFINITION(0xB, 0x345), ZYDIS_DEFINITION(0xB, 0x346), ZYDIS_DEFINITION(0xB, 0x347) },
    { ZYDIS_DEFINITION(0xB, 0xD34), ZYDIS_DEFINITION(0xB, 0xD35), ZYDIS_DEFINITION(0xB, 0xD36) },
    { ZYDIS_DEFINITION(0xB, 0xD26), ZYDIS_DEFINITION(0xB, 0xD27), ZYDIS_DEFINITION(0xB, 0xD28) },
    { ZYDIS_DEFINITION(0xB, 0xD37), ZYDIS_DEFINITION(0xB, 0xD38), ZYDIS_DEFINITION(0xB, 0xD39) },
    { ZYDIS_DEFINITION(0xB, 0xD29), ZYDIS_DEFINITION(0xB, 0xD2A), ZYDIS_DEFINITION(0xB, 0xD2B) },
    { ZYDIS_DEFINITION(0xB, 0x55B), ZYDIS_DEFINITION(0xB, 0x55C), ZYDIS_DEFINITION(0xB, 0x55D) },
    { ZYDIS_DEFINITION(0xB, 0x54F), ZYDIS_DEFINITION(0xB, 0x550), ZYDIS_DEFINITION(0xB, 0x551) },
    { ZYDIS_DEFINITION(0xB, 0x55E), ZYDIS_DEFINITION(0xB, 0x55F), ZYDIS_DEFINITION(0xB, 0x560) },
    { ZYDIS_DEFINITION(0xB, 0x552), ZYDIS_DEFINITION(0xB, 0x553), ZYDIS_DEFINITION(0xB, 0x554) },
    { ZYDIS_DEFINITION(0xB, 0xB4F), ZYDIS_DEFINITION(0xB, 0xB50), ZYDIS_DEFINITION(0xB, 0xB51) },
    { ZYDIS_DEFINITION(0xB, 0xB52), ZYDIS_DEFINITION(0xB, 0xB53), ZYDIS_DEFINITION(0xB, 0xB54) },
    { ZYDIS_DEFINITION(0xB, 0xB31), ZYDIS_DEFINITION(0xB, 0xB32), ZYDIS_DEFINITION(0xB, 0xB33) },
    { ZYDIS_DEFINITION(0xB, 0xB37), ZYDIS_DEFINITION(0xB, 0xB38), ZYDIS_DEFINITION(0xB, 0xB39) },
    { ZYDIS_DEFINITION(0xB, 0xB34), ZYDIS_DEFINITION(0xB, 0xB35), ZYDIS_DEFINITION(0xB, 0xB36) },
    { ZYDIS_DEFINITION(0xB, 0xB3A), ZYDIS_DEFINITION(0xB, 0xB3B), ZYDIS_DEFINITION(0xB, 0xB3C) },
    { ZYDIS_DEFINITION(0xB, 0xB73), ZYDIS_DEFINITION(0xB, 0xB74), ZYDIS_DEFINITION(0xB, 0xB75) },
    { ZYDIS_DEFINITION(0xB, 0xB76), ZYDIS_DEFINITION(0xB, 0xB77), ZYDIS_DEFINITION(0xB, 0xB78) },
    { ZYDIS_DEFINITION(0xB, 0xB55), ZYDIS_DEFINITION(0xB, 0xB56), ZYDIS_DEFINITION(0xB, 0xB57) },
    { ZYDIS_DEFINITION(0xB, 0xB5B), ZYDIS_DEFINITION(0xB, 0xB5C), ZYDIS_DEFINITION(0xB, 0xB5D) },
    { ZYDIS_DEFINITION(0xB, 0xB58), ZYDIS_DEFINITION(0xB, 0xB59), ZYDIS_DEFINITION(0xB, 0xB5A) },
    { ZYDIS_DEFINITION(0xB, 0xB5E), ZYDIS_DEFINITION(0xB, 0xB5F), ZYDIS_DEFINITION(0xB, 0xB60) },
    { ZYDIS_DEFINITION(0xB, 0x5BD), ZYDIS_DEFINITION(0xB, 0x5BE), ZYDIS_DEFINITION(0xB, 0x5BF) },
    { ZYDIS_DEFINITION(0xB, 0x5C0), ZYDIS_DEFINITION(0xB, 0x5C1), ZYDIS_DEFINITION(0xB, 0x5C2) },
    { ZYDIS_DEFINITION(0xB, 0x5B7), ZYDIS_DEFINITION(0xB, 0x5B8), ZYDIS_DEFINITION(0xB, 0x5B9) },
    { ZYDIS_DEFINITION(0xB, 0x5BA), ZYDIS_DEFINITION(0xB, 0x5BB), ZYDIS_DEFINITION(0xB, 0x5BC) },
    { ZYDIS_DEFINITION(0x1, 0x15D), ZYDIS_DEFINITION(0x1, 0x15E), ZYDIS_DEFINITION(0x1, 0x15F) },
    { ZYDIS_DEFINITION(0x1, 0x160), ZYDIS_DEFINITION(0x1, 0x161), ZYDIS_DEFINITION(0x1, 0x162) },
    { ZYDIS_DEFINITION(0x1, 0xE6), ZYDIS_DEFINITION(0x1, 0xE7), ZYDIS_DEFINITION(0x1, 0xE8) },
    { ZYDIS_DEFINITION(0x1, 0xE9), ZYDIS_DEFINITION(0x1, 0xEA), ZYDIS_DEFINITION(0x1, 0xEB) },
    { ZYDIS_DEFINITION(0x1, 0x109), ZYDIS_DEFINITION(0x1, 0x10A), ZYDIS_DEFINITION(0x1, 0x10B) },
    { ZYDIS_DEFINITION(0x1, 0x10C), ZYDIS_DEFINITION(0x1, 0x10D), ZYDIS_DEFINITION(0x1, 0x10E) },
    { ZYDIS_DEFINITION(0x1, 0x6DB), ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0x1, 0x6DC), ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0x1, 0x220), ZYDIS_DEFINITION(0x1, 0x221), ZYDIS_DEFINITION(0x1, 0x222) },
    { ZYDIS_DEFINITION(0x1, 0x223), ZYDIS_DEFINITION(0x1, 0x224), ZYDIS_DEFINITION(0x1, 0x225) },
    { ZYDIS_DEFINITION(0x1, 0x133), ZYDIS_DEFINITION(0x1, 0x134), ZYDIS_DEFINITION(0x1, 0x135) },
    { ZYDIS_DEFINITION(0x1, 0x136), ZYDIS_DEFINITION(0x1, 0x137), ZYDIS_DEFINITION(0x1, 0x138) },
    { ZYDIS_DEFINITION(0x1, 0x212), ZYDIS_DEFINITION(0x1, 0x213), ZYDIS_DEFINITION(0x1, 0x214) },
    { ZYDIS_DEFINITION(0x1, 0x215), ZYDIS_DEFINITION(0x1, 0x216), ZYDIS_DEFINITION(0x1, 0x217) },
    { ZYDIS_DEFINITION(0x1, 0x125), ZYDIS_DEFINITION(0x1, 0x126), ZYDIS_DEFINITION(0x1, 0x127) },
    { ZYDIS_DEFINITION(0x1, 0x128), ZYDIS_DEFINITION(0x1, 0x129), ZYDIS_DEFINITION(0x1, 0x12A) },
    { ZYDIS_DEFINITION(0x1, 0x22E), ZYDIS_DEFINITION(0x1, 0x22F), ZYDIS_DEFINITION(0x1, 0x230) },
    { ZYDIS_DEFINITION(0x1, 0x231), ZYDIS_DEFINITION(0x1, 0x232), ZYDIS_DEFINITION(0x1, 0x233) },
    { ZYDIS_DEFINITION(0x1, 0x141), ZYDIS_DEFINITION(0x1, 0x142), ZYDIS_DEFINITION(0x1, 0x143) },
    { ZYDIS_DEFINITION(0x1, 0x144), ZYDIS_DEFINITION(0x1, 0x145), ZYDIS_DEFINITION(0x1, 0x146) },
    { ZYDIS_DEFINITION(0x1, 0x6DD), ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0x1, 0x6DE), ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0x1, 0x11E), ZYDIS_DEFINITION(0x1, 0x11F), ZYDIS_DEFINITION(0x1, 0x120) },
    { ZYDIS_DEFINITION(0x1, 0x121), ZYDIS_DEFINITION(0x1, 0x122), ZYDIS_DEFINITION(0x1, 0x123) },
    { ZYDIS_DEFINITION(0x1, 0xD8D), ZYDIS_DEFINITION(0x1, 0xD8E), ZYDIS_DEFINITION(0x1, 0xD8F) },
    { ZYDIS_DEFINITION(0x1, 0xD90), ZYDIS_DEFINITION(0x1, 0xD91), ZYDIS_DEFINITION(0x1, 0xD92) },
    { ZYDIS_DEFINITION(0x1, 0x583), ZYDIS_DEFINITION(0x1, 0x584), ZYDIS_DEFINITION(0x1, 0x585) },
    { ZYDIS_DEFINITION(0x1, 0x586), ZYDIS_DEFINITION(0x1, 0x587), ZYDIS_DEFINITION(0x1, 0x588) },
    { ZYDIS_DEFINITION(0x1, 0xD1D), ZYDIS_DEFINITION(0x1, 0xD1E), ZYDIS_DEFINITION(0x1, 0xD1F) },
    { ZYDIS_DEFINITION(0x1, 0xD20), ZYDIS_DEFINITION(0x1, 0xD21), ZYDIS_DEFINITION(0x1, 0xD22) },
    { ZYDIS_DEFINITION(0x1, 0xD7D), ZYDIS_DEFINITION(0x1, 0xD7E), ZYDIS_DEFINITION(0x1, 0xD7F) },
    { ZYDIS_DEFINITION(0x1, 0xD80), ZYDIS_DEFINITION(0x1, 0xD81), ZYDIS_DEFINITION(0x1, 0xD82) },
    { ZYDIS_DEFINITION(0x1, 0x3C1), ZYDIS_DEFINITION(0x1, 0x3C2), ZYDIS_DEFINITION(0x1, 0x3C3) },
    { ZYDIS_DEFINITION(0x1, 0x3C4), ZYDIS_DEFINITION(0x1, 0x3C5), ZYDIS_DEFINITION(0x1, 0x3C6) },
    { ZYDIS_DEFINITION(0x1, 0x45A), ZYDIS_DEFINITION(0x1, 0x45B), ZYDIS_DEFINITION(0x1, 0x45C) },
    { ZYDIS_DEFINITION(0x1, 0x45D), ZYDIS_DEFINITION(0x1, 0x45E), ZYDIS_DEFINITION(0x1, 0x45F) },
    { ZYDIS_DEFINITION(0x1, 0x35D), ZYDIS_DEFINITION(0x1, 0x35E), ZYDIS_DEFINITION(0x1, 0x35F) },
    { ZYDIS_DEFINITION(0x1, 0x360), ZYDIS_DEFINITION(0x1, 0x361), ZYDIS_DEFINITION(0x1, 0x362) },
    { ZYDIS_DEFINITION(0x1, 0x400), ZYDIS_DEFINITION(0x1, 0x401), ZYDIS_DEFINITION(0x1, 0x402) },
    { ZYDIS_DEFINITION(0x1, 0x403), ZYDIS_DEFINITION(0x1, 0x404), ZYDIS_DEFINITION(0x1, 0x405) },
    { ZYDIS_DEFINITION(0x1, 0x4A3), ZYDIS_DEFINITION(0x1, 0x4A4), ZYDIS_DEFINITION(0x1, 0x4A5) },
    { ZYDIS_DEFINITION(0x1, 0x4A6), ZYDIS_DEFINITION(0x1, 0x4A7), ZYDIS_DEFINITION(0x1, 0x4A8) },
    { ZYDIS_DEFINITION(0x1, 0x4FD), ZYDIS_DEFINITION(0x1, 0x4FE), ZYDIS_DEFINITION(0x1, 0x4FF) },
    { ZYDIS_DEFINITION(0x1, 0x500), ZYDIS_DEFINITION(0x1, 0x501), ZYDIS_DEFINITION(0x1, 0x502) },
    { ZYDIS_DEFINITION(0x1, 0x3D6), ZYDIS_DEFINITION(0x1, 0x3D7), ZYDIS_DEFINITION(0x1, 0x3D8) },
    { ZYDIS_DEFINITION(0x1, 0x3D9), ZYDIS_DEFINITION(0x1, 0x3DA), ZYDIS_DEFINITION(0x1, 0x3DB) },
    { ZYDIS_DEFINITION(0x1, 0x46F), ZYDIS_DEFINITION(0x1, 0x470), ZYDIS_DEFINITION(0x1, 0x471) },
    { ZYDIS_DEFINITION(0x1, 0x472), ZYDIS_DEFINITION(0x1, 0x473), ZYDIS_DEFINITION(0x1, 0x474) },
    { ZYDIS_DEFINITION(0x1, 0x37B), ZYDIS_DEFINITION(0x1, 0x37C), ZYDIS_DEFINITION(0x1, 0x37D) },
    { ZYDIS_DEFINITION(0x1, 0x37E), ZYDIS_DEFINITION(0x1, 0x37F), ZYDIS_DEFINITION(0x1, 0x380) },
    { ZYDIS_DEFINITION(0x1, 0x41E), ZYDIS_DEFINITION(0x1, 0x41F), ZYDIS_DEFINITION(0x1, 0x420) },
    { ZYDIS_DEFINITION(0x1, 0x421), ZYDIS_DEFINITION(0x1, 0x422), ZYDIS_DEFINITION(0x1, 0x423) },
    { ZYDIS_DEFINITION(0x1, 0x4C1), ZYDIS_DEFINITION(0x1, 0x4C2), ZYDIS_DEFINITION(0x1, 0x4C3) },
    { ZYDIS_DEFINITION(0x1, 0x4C4), ZYDIS_DEFINITION(0x1, 0x4C5), ZYDIS_DEFINITION(0x1, 0x4C6) },
    { ZYDIS_DEFINITION(0x1, 0x51B), ZYDIS_DEFINITION(0x1, 0x51C), ZYDIS_DEFINITION(0x1, 0x51D) },
    { ZYDIS_DEFINITION(0x1, 0x51E), ZYDIS_DEFINITION(0x1, 0x51F), ZYDIS_DEFINITION(0x1, 0x520) },
    { ZYDIS_DEFINITION(0x1, 0x3EB), ZYDIS_DEFINITION(0x1, 0x3EC), ZYDIS_DEFINITION(0x1, 0x3ED) },
    { ZYDIS_DEFINITION(0x1, 0x3EE), ZYDIS_DEFINITION(0x1, 0x3EF), ZYDIS_DEFINITION(0x1, 0x3F0) },
    { ZYDIS_DEFINITION(0x1, 0x484), ZYDIS_DEFINITION(0x1, 0x485), ZYDIS_DEFINITION(0x1, 0x486) },
    { ZYDIS_DEFINITION(0x1, 0x487), ZYDIS_DEFINITION(0x1, 0x488), ZYDIS_DEFINITION(0x1, 0x489) },
    { ZYDIS_DEFINITION(0x1, 0x399), ZYDIS_DEFINITION(0x1, 0x39A), ZYDIS_DEFINITION(0x1, 0x39B) },
    { ZYDIS_DEFINITION(0x1, 0x39C), ZYDIS_DEFINITION(0x1, 0x39D), ZYDIS_DEFINITION(0x1, 0x39E) },
    { ZYDIS_DEFINITION(0x1, 0x43C), ZYDIS_DEFINITION(0x1, 0x43D), ZYDIS_DEFINITION(0x1, 0x43E) },
    { ZYDIS_DEFINITION(0x1, 0x43F), ZYDIS_DEFINITION(0x1, 0x440), ZYDIS_DEFINITION(0x1, 0x441) },
    { ZYDIS_DEFINITION(0x1, 0x4DF), ZYDIS_DEFINITION(0x1, 0x4E0), ZYDIS_DEFINITION(0x1, 0x4E1) },
    { ZYDIS_DEFINITION(0x1, 0x4E2), ZYDIS_DEFINITION(0x1, 0x4E3), ZYDIS_DEFINITION(0x1, 0x4E4) },
    { ZYDIS_DEFINITION(0x1, 0x539), ZYDIS_DEFINITION(0x1, 0x53A), ZYDIS_DEFINITION(0x1, 0x53B) },
    { ZYDIS_DEFINITION(0x1, 0x53C), ZYDIS_DEFINITION(0x1, 0x53D), ZYDIS_DEFINITION(0x1, 0x53E) },
    { ZYDIS_DEFINITION(0x1, 0x6B9), ZYDIS_DEFINITION(0x1, 0x6BA), ZYDIS_DEFINITION(0x1, 0x6BB) },
    { ZYDIS_DEFINITION(0x1, 0x6BC), ZYDIS_DEFINITION(0x1, 0x6BD), ZYDIS_DEFINITION(0x1, 0x6BE) },
    { ZYDIS_DEFINITION(0x1, 0x6B3), ZYDIS_DEFINITION(0x1, 0x6B4), ZYDIS_DEFINITION(0x1, 0x6B5) },
    { ZYDIS_DEFINITION(0x1, 0x6B6), ZYDIS_DEFINITION(0x1, 0x6B7), ZYDIS_DEFINITION(0x1, 0x6B8) },
    { ZYDIS_DEFINITION(0x1, 0x235), ZYDIS_DEFINITION(0x1, 0x236), ZYDIS_DEFINITION(0x1, 0x237) },
    { ZYDIS_DEFINITION(0x1, 0x238), ZYDIS_DEFINITION(0x1, 0x239), ZYDIS_DEFINITION(0x1, 0x23A) },
    { ZYDIS_DEFINITION(0x1, 0x669), ZYDIS_DEFINITION(0x1, 0x66A), ZYDIS_DEFINITION(0x1, 0x66B) },
    { ZYDIS_DEFINITION(0x1, 0x675), ZYDIS_DEFINITION(0x1, 0x676), ZYDIS_DEFINITION(0x1, 0x677) },
    { ZYDIS_DEFINITION(0x1, 0x66C), ZYDIS_DEFINITION(0x1, 0x66D), ZYDIS_DEFINITION(0x1, 0x66E) },
    { ZYDIS_DEFINITION(0x1, 0x678), ZYDIS_DEFINITION(0x1, 0x679), ZYDIS_DEFINITION(0x1, 0x67A) },
    { ZYDIS_DEFINITION(0xB, 0xB8B), ZYDIS_DEFINITION(0xB, 0xB8C), ZYDIS_DEFINITION(0xB, 0xB8D) },
    { ZYDIS_DEFINITION(0xB, 0xB8E), ZYDIS_DEFINITION(0xB, 0xB8F), ZYDIS_DEFINITION(0xB, 0xB90) },
    { ZYDIS_DEFINITION(0x1, 0x287), ZYDIS_DEFINITION(0x1, 0x288), ZYDIS_DEFINITION(0x1, 0x289) },
    { ZYDIS_DEFINITION(0x1, 0x29C), ZYDIS_DEFINITION(0x1, 0x29D), ZYDIS_DEFINITION(0x1, 0x29E) },
    { ZYDIS_DEFINITION(0x1, 0x28A), ZYDIS_DEFINITION(0x1, 0x28B), ZYDIS_DEFINITION(0x1, 0x28C) },
    { ZYDIS_DEFINITION(0x1, 0x29F), ZYDIS_DEFINITION(0x1, 0x2A0), ZYDIS_DEFINITION(0x1, 0x2A1) },
    { ZYDIS_DEFINITION(0x1, 0x6A7), ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0x1, 0x6A8), ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0x1, 0x66F), ZYDIS_DEFINITION(0x1, 0x670), ZYDIS_DEFINITION(0x1, 0x671) },
    { ZYDIS_DEFINITION(0x1, 0x67B), ZYDIS_DEFINITION(0x1, 0x67C), ZYDIS_DEFINITION(0x1, 0x67D) },
    { ZYDIS_DEFINITION(0x1, 0x672), ZYDIS_DEFINITION(0x1, 0x673), ZYDIS_DEFINITION(0x1, 0x674) },
    { ZYDIS_DEFINITION(0x1, 0x67E), ZYDIS_DEFINITION(0x1, 0x67F), ZYDIS_DEFINITION(0x1, 0x680) },
    { ZYDIS_DEFINITION(0x1, 0xBE), ZYDIS_DEFINITION(0x1, 0xBF), ZYDIS_DEFINITION(0x1, 0xC0) },
    { ZYDIS_DEFINITION(0x1, 0x179), ZYDIS_DEFINITION(0x1, 0x17A), ZYDIS_DEFINITION(0x1, 0x17B) },
    { ZYDIS_DEFINITION(0x1, 0xC1), ZYDIS_DEFINITION(0x1, 0xC2), ZYDIS_DEFINITION(0x1, 0xC3) },
    { ZYDIS_DEFINITION(0x1, 0x17C), ZYDIS_DEFINITION(0x1, 0x17D), ZYDIS_DEFINITION(0x1, 0x17E) },
    { ZYDIS_DEFINITION(0x1, 0xA62), ZYDIS_DEFINITION(0x1, 0xA63), ZYDIS_DEFINITION(0x1, 0xA64) },
    { ZYDIS_DEFINITION(0x1, 0xA65), ZYDIS_DEFINITION(0x1, 0xA66), ZYDIS_DEFINITION(0x1, 0xA67) },
    { ZYDIS_DEFINITION(0x1, 0xA44), ZYDIS_DEFINITION(0x1, 0xA45), ZYDIS_DEFINITION(0x1, 0xA46) },
    { ZYDIS_DEFINITION(0x1, 0xA47), ZYDIS_DEFINITION(0x1, 0xA48), ZYDIS_DEFINITION(0x1, 0xA49) },
    { ZYDIS_DEFINITION(0x1, 0xA50), ZYDIS_DEFINITION(0x1, 0xA51), ZYDIS_DEFINITION(0x1, 0xA52) },
    { ZYDIS_DEFINITION(0x1, 0xA53), ZYDIS_DEFINITION(0x1, 0xA54), ZYDIS_DEFINITION(0x1, 0xA55) },
    { ZYDIS_DEFINITION(0x1, 0xA4A), ZYDIS_DEFINITION(0x1, 0xA4B), ZYDIS_DEFINITION(0x1, 0xA4C) },
    { ZYDIS_DEFINITION(0x1, 0xA4D), ZYDIS_DEFINITION(0x1, 0xA4E), ZYDIS_DEFINITION(0x1, 0xA4F) },
    { ZYDIS_DEFINITION(0x1, 0xA5C), ZYDIS_DEFINITION(0x1, 0xA5D), ZYDIS_DEFINITION(0x1, 0xA5E) },
    { ZYDIS_DEFINITION(0x1, 0xA5F), ZYDIS_DEFINITION(0x1, 0xA60), ZYDIS_DEFINITION(0x1, 0xA61) },
    { ZYDIS_DEFINITION(0x1, 0xA56), ZYDIS_DEFINITION(0x1, 0xA57), ZYDIS_DEFINITION(0x1, 0xA58) },
    { ZYDIS_DEFINITION(0x1, 0xA59), ZYDIS_DEFINITION(0x1, 0xA5A), ZYDIS_DEFINITION(0x1, 0xA5B) },
    { ZYDIS_DEFINITION(0x1, 0xA1A), ZYDIS_DEFINITION(0x1, 0xA1B), ZYDIS_DEFINITION(0x1, 0xA1C) },
    { ZYDIS_DEFINITION(0x1, 0xA1D), ZYDIS_DEFINITION(0x1, 0xA1E), ZYDIS_DEFINITION(0x1, 0xA1F) },
    { ZYDIS_DEFINITION(0x1, 0x9FC), ZYDIS_DEFINITION(0x1, 0x9FD), ZYDIS_DEFINITION(0x1, 0x9FE) },
    { ZYDIS_DEFINITION(0x1, 0x9FF), ZYDIS_DEFINITION(0x1, 0xA00), ZYDIS_DEFINITION(0x1, 0xA01) },
    { ZYDIS_DEFINITION(0x1, 0xA08), ZYDIS_DEFINITION(0x1, 0xA09), ZYDIS_DEFINITION(0x1, 0xA0A) },
    { ZYDIS_DEFINITION(0x1, 0xA0B), ZYDIS_DEFINITION(0x1, 0xA0C), ZYDIS_DEFINITION(0x1, 0xA0D) },
    { ZYDIS_DEFINITION(0x1, 0xA02), ZYDIS_DEFINITION(0x1, 0xA03), ZYDIS_DEFINITION(0x1, 0xA04) },
    { ZYDIS_DEFINITION(0x1, 0xA05), ZYDIS_DEFINITION(0x1, 0xA06), ZYDIS_DEFINITION(0x1, 0xA07) },
    { ZYDIS_DEFINITION(0x1, 0xA14), ZYDIS_DEFINITION(0x1, 0xA15), ZYDIS_DEFINITION(0x1, 0xA16) },
    { ZYDIS_DEFINITION(0x1, 0xA17), ZYDIS_DEFINITION(0x1, 0xA18), ZYDIS_DEFINITION(0x1, 0xA19) },
    { ZYDIS_DEFINITION(0x1, 0xA0E), ZYDIS_DEFINITION(0x1, 0xA0F), ZYDIS_DEFINITION(0x1, 0xA10) },
    { ZYDIS_DEFINITION(0x1, 0xA11), ZYDIS_DEFINITION(0x1, 0xA12), ZYDIS_DEFINITION(0x1, 0xA13) },
    { ZYDIS_DEFINITION(0x1, 0xC99), ZYDIS_DEFINITION(0x1, 0xC9A), ZYDIS_DEFINITION(0x1, 0xC9B) },
    { ZYDIS_DEFINITION(0x1, 0xCAB), ZYDIS_DEFINITION(0x1, 0xCAC), ZYDIS_DEFINITION(0x1, 0xCAD) },
    { ZYDIS_DEFINITION(0x1, 0xC9C), ZYDIS_DEFINITION(0x1, 0xC9D), ZYDIS_DEFINITION(0x1, 0xC9E) },
    { ZYDIS_DEFINITION(0x1, 0xCAE), ZYDIS_DEFINITION(0x1, 0xCAF), ZYDIS_DEFINITION(0x1, 0xCB0) },
    { ZYDIS_DEFINITION(0x1, 0xC9F), ZYDIS_DEFINITION(0x1, 0xCA0), ZYDIS_DEFINITION(0x1, 0xCA1) },
    { ZYDIS_DEFINITION(0x1, 0xCA5), ZYDIS_DEFINITION(0x1, 0xCA6), ZYDIS_DEFINITION(0x1, 0xCA7) },
    { ZYDIS_DEFINITION(0x1, 0xCA2), ZYDIS_DEFINITION(0x1, 0xCA3), ZYDIS_DEFINITION(0x1, 0xCA4) },
    { ZYDIS_DEFINITION(0x1, 0xCA8), ZYDIS_DEFINITION(0x1, 0xCA9), ZYDIS_DEFINITION(0x1, 0xCAA) },
    { ZYDIS_DEFINITION(0x1, 0x9DB), ZYDIS_DEFINITION(0x1, 0x9DC), ZYDIS_DEFINITION(0x1, 0x9DD) },
    { ZYDIS_DEFINITION(0x1, 0x9E4), ZYDIS_DEFINITION(0x1, 0x9E5), ZYDIS_DEFINITION(0x1, 0x9E6) },
    { ZYDIS_DEFINITION(0x1, 0x9C9), ZYDIS_DEFINITION(0x1, 0x9CA), ZYDIS_DEFINITION(0x1, 0x9CB) },
    { ZYDIS_DEFINITION(0x1, 0xA68), ZYDIS_DEFINITION(0x1, 0xA69), ZYDIS_DEFINITION(0x1, 0xA6A) },
    { ZYDIS_DEFINITION(0x1, 0x7CE), ZYDIS_DEFINITION(0x1, 0x7CF), ZYDIS_DEFINITION(0x1, 0x7D0) },
    { ZYDIS_DEFINITION(0x1, 0xA6B), ZYDIS_DEFINITION(0x1, 0xA6C), ZYDIS_DEFINITION(0x1, 0xA6D) },
    { ZYDIS_DEFINITION(0x1, 0xA6E), ZYDIS_DEFINITION(0x1, 0xA6F), ZYDIS_DEFINITION(0x1, 0xA70) },
    { ZYDIS_DEFINITION(0x1, 0x9CF), ZYDIS_DEFINITION(0x1, 0x9D0), ZYDIS_DEFINITION(0x1, 0x9D1) },
    { ZYDIS_DEFINITION(0x1, 0x9D2), ZYDIS_DEFINITION(0x1, 0x9D3), ZYDIS_DEFINITION(0x1, 0x9D4) },
    { ZYDIS_DEFINITION(0x1, 0x9EA), ZYDIS_DEFINITION(0x1, 0x9EB), ZYDIS_DEFINITION(0x1, 0x9EC) },
    { ZYDIS_DEFINITION(0x1, 0x9ED), ZYDIS_DEFINITION(0x1, 0x9EE), ZYDIS_DEFINITION(0x1, 0x9EF) },
    { ZYDIS_DEFINITION(0x1, 0x9D5), ZYDIS_DEFINITION(0x1, 0x9D6), ZYDIS_DEFINITION(0x1, 0x9D7) },
    { ZYDIS_DEFINITION(0x1, 0x9D8), ZYDIS_DEFINITION(0x1, 0x9D9), ZYDIS_DEFINITION(0x1, 0x9DA) },
    { ZYDIS_DEFINITION(0x1, 0x9F6), ZYDIS_DEFINITION(0x1, 0x9F7), ZYDIS_DEFINITION(0x1, 0x9F8) },
    { ZYDIS_DEFINITION(0x1, 0x9F9), ZYDIS_DEFINITION(0x1, 0x9FA), ZYDIS_DEFINITION(0x1, 0x9FB) },
    { ZYDIS_DEFINITION(0x1, 0x9F0), ZYDIS_DEFINITION(0x1, 0x9F1), ZYDIS_DEFINITION(0x1, 0x9F2) },
    { ZYDIS_DEFINITION(0x1, 0x9F3), ZYDIS_DEFINITION(0x1, 0x9F4), ZYDIS_DEFINITION(0x1, 0x9F5) },
    { ZYDIS_DEFINITION(0x1, 0x9DE), ZYDIS_DEFINITION(0x1, 0x9DF), ZYDIS_DEFINITION(0x1, 0x9E0) },
    { ZYDIS_DEFINITION(0x1, 0x9E1), ZYDIS_DEFINITION(0x1, 0x9E2), ZYDIS_DEFINITION(0x1, 0x9E3) },
    { ZYDIS_DEFINITION(0x1, 0x9CC), ZYDIS_DEFINITION(0x1, 0x9CD), ZYDIS_DEFINITION(0x1, 0x9CE) },
    { ZYDIS_DEFINITION(0x1, 0x9E7), ZYDIS_DEFINITION(0x1, 0x9E8), ZYDIS_DEFINITION(0x1, 0x9E9) },
    { ZYDIS_DEFINITION(0x1, 0x7D1), ZYDIS_DEFINITION(0x1, 0x7D2), ZYDIS_DEFINITION(0x1, 0x7D3) },
    { ZYDIS_DEFINITION(0x1, 0x2FB), ZYDIS_DEFINITION(0x1, 0x2FC), ZYDIS_DEFINITION(0x1, 0x2FD) },
    { ZYDIS_DEFINITION(0x1, 0x2FE), ZYDIS_DEFINITION(0x1, 0x2FF), ZYDIS_DEFINITION(0x1, 0x300) },
    { ZYDIS_DEFINITION(0x1, 0xD8), ZYDIS_DEFINITION(0x1, 0xD9), ZYDIS_DEFINITION(0x1, 0xDA) },
    { ZYDIS_DEFINITION(0x1, 0xDB), ZYDIS_DEFINITION(0x1, 0xDC), ZYDIS_DEFINITION(0x1, 0xDD) },
    { ZYDIS_DEFINITION(0x1, 0x20B), ZYDIS_DEFINITION(0x1, 0x20C), ZYDIS_DEFINITION(0x1, 0x20D) },
    { ZYDIS_DEFINITION(0x1, 0x20E), ZYDIS_DEFINITION(0x1, 0x20F), ZYDIS_DEFINITION(0x1, 0x210) },
    { ZYDIS_DEFINITION(0x1, 0x2D1), ZYDIS_DEFINITION(0x1, 0x2D2), ZYDIS_DEFINITION(0x1, 0x2D3) },
    { ZYDIS_DEFINITION(0x1, 0x2D4), ZYDIS_DEFINITION(0x1, 0x2D5), ZYDIS_DEFINITION(0x1, 0x2D6) },
    { ZYDIS_DEFINITION(0x1, 0x3B0), ZYDIS_DEFINITION(0x1, 0x3B1), ZYDIS_DEFINITION(0x1, 0x3B2) },
    { ZYDIS_DEFINITION(0x1, 0x3B3), ZYDIS_DEFINITION(0x1, 0x3B4), ZYDIS_DEFINITION(0x1, 0x3B5) },
    { ZYDIS_DEFINITION(0x1, 0x492), ZYDIS_DEFINITION(0x1, 0x493), ZYDIS_DEFINITION(0x1, 0x494) },
    { ZYDIS_DEFINITION(0x1, 0x495), ZYDIS_DEFINITION(0x1, 0x496), ZYDIS_DEFINITION(0x1, 0x497) },
    { ZYDIS_DEFINITION(0x1, 0x63F), ZYDIS_DEFINITION(0x1, 0x640), ZYDIS_DEFINITION(0x1, 0x641) },
    { ZYDIS_DEFINITION(0x1, 0x642), ZYDIS_DEFINITION(0x1, 0x643), ZYDIS_DEFINITION(0x1, 0x644) },
    { ZYDIS_DEFINITION(0x1, 0x681), ZYDIS_DEFINITION(0x1, 0x682), ZYDIS_DEFINITION(0x1, 0x683) },
    { ZYDIS_DEFINITION(0x1, 0x65D), ZYDIS_DEFINITION(0x1, 0x65E), ZYDIS_DEFINITION(0x1, 0x65F) },
    { ZYDIS_DEFINITION(0x1, 0x684), ZYDIS_DEFINITION(0x1, 0x685), ZYDIS_DEFINITION(0x1, 0x686) },
    { ZYDIS_DEFINITION(0x1, 0x660), ZYDIS_DEFINITION(0x1, 0x661), ZYDIS_DEFINITION(0x1, 0x662) },
    { ZYDIS_DEFINITION(0xB, 0xB91), ZYDIS_DEFINITION(0xB, 0xB92), ZYDIS_DEFINITION(0xB, 0xB93) },
    { ZYDIS_DEFINITION(0xB, 0xB94), ZYDIS_DEFINITION(0xB, 0xB95), ZYDIS_DEFINITION(0xB, 0xB96) },
    { ZYDIS_DEFINITION(0x1, 0x295), ZYDIS_DEFINITION(0x1, 0x296), ZYDIS_DEFINITION(0x1, 0x297) },
    { ZYDIS_DEFINITION(0x1, 0x2AA), ZYDIS_DEFINITION(0x1, 0x2AB), ZYDIS_DEFINITION(0x1, 0x2AC) },
    { ZYDIS_DEFINITION(0x1, 0x298), ZYDIS_DEFINITION(0x1, 0x299), ZYDIS_DEFINITION(0x1, 0x29A) },
    { ZYDIS_DEFINITION(0x1, 0x2AD), ZYDIS_DEFINITION(0x1, 0x2AE), ZYDIS_DEFINITION(0x1, 0x2AF) },
    { ZYDIS_DEFINITION(0x1, 0x687), ZYDIS_DEFINITION(0x1, 0x688), ZYDIS_DEFINITION(0x1, 0x689) },
    { ZYDIS_DEFINITION(0x1, 0x663), ZYDIS_DEFINITION(0x1, 0x664), ZYDIS_DEFINITION(0x1, 0x665) },
    { ZYDIS_DEFINITION(0x1, 0x68A), ZYDIS_DEFINITION(0x1, 0x68B), ZYDIS_DEFINITION(0x1, 0x68C) },
    { ZYDIS_DEFINITION(0x1, 0x666), ZYDIS_DEFINITION(0x1, 0x667), ZYDIS_DEFINITION(0x1, 0x668) },
    { ZYDIS_DEFINITION(0x1, 0xDF), ZYDIS_DEFINITION(0x1, 0xE0), ZYDIS_DEFINITION(0x1, 0xE1) },
    { ZYDIS_DEFINITION(0x1, 0xE2), ZYDIS_DEFINITION(0x1, 0xE3), ZYDIS_DEFINITION(0x1, 0xE4) },
    { ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_DEFINITION(0x1, 0x715) },
    { ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_DEFINITION(0x1, 0x716) },
    { ZYDIS_DEFINITION(0x1, 0x709), ZYDIS_DEFINITION(0x1, 0x70A), ZYDIS_DEFINITION(0x1, 0x70B) },
    { ZYDIS_DEFINITION(0x1, 0x70F), ZYDIS_DEFINITION(0x1, 0x710), ZYDIS_DEFINITION(0x1, 0x711) },
    { ZYDIS_DEFINITION(0x1, 0x70C), ZYDIS_DEFINITION(0x1, 0x70D), ZYDIS_DEFINITION(0x1, 0x70E) },
    { ZYDIS_DEFINITION(0x1, 0x712), ZYDIS_DEFINITION(0x1, 0x713), ZYDIS_DEFINITION(0x1, 0x714) },
    { ZYDIS_DEFINITION(0x1, 0xD2), ZYDIS_DEFINITION(0x1, 0xD3), ZYDIS_DEFINITION(0x1, 0xD4) },
    { ZYDIS_DEFINITION(0x1, 0xD5), ZYDIS_DEFINITION(0x1, 0xD6), ZYDIS_DEFINITION(0x1, 0xD7) },
    { ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_DEFINITION(0x1, 0x0) },
    { ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_DEFINITION(0x1, 0x2) },
    { ZYDIS_DEFINITION(0x1, 0x28E), ZYDIS_DEFINITION(0x1, 0x28F), ZYDIS_DEFINITION(0x1, 0x290) },
    { ZYDIS_DEFINITION(0x1, 0x2A3), ZYDIS_DEFINITION(0x1, 0x2A4), ZYDIS_DEFINITION(0x1, 0x2A5) },
    { ZYDIS_DEFINITION(0x1, 0x291), ZYDIS_DEFINITION(0x1, 0x292), ZYDIS_DEFINITION(0x1, 0x293) },
    { ZYDIS_DEFINITION(0x1, 0x2A6), ZYDIS_DEFINITION(0x1, 0x2A7), ZYDIS_DEFINITION(0x1, 0x2A8) },
    { ZYDIS_DEFINITION(0x1, 0x2CA), ZYDIS_DEFINITION(0x1, 0x2CB), ZYDIS_DEFINITION(0x1, 0x2CC) },
    { ZYDIS_DEFINITION(0x1, 0x2CD), ZYDIS_DEFINITION(0x1, 0x2CE), ZYDIS_DEFINITION(0x1, 0x2CF) },
    { ZYDIS_DEFINITION(0x1, 0x32E), ZYDIS_DEFINITION(0x1, 0x32F), ZYDIS_DEFINITION(0x1, 0x330) },
    { ZYDIS_DEFINITION(0x1, 0x331), ZYDIS_DEFINITION(0x1, 0x332), ZYDIS_DEFINITION(0x1, 0x333) },
    { ZYDIS_DEFINITION(0x1, 0x338), ZYDIS_DEFINITION(0x1, 0x339), ZYDIS_DEFINITION(0x1, 0x33A) },
    { ZYDIS_DEFINITION(0x1, 0x33B), ZYDIS_DEFINITION(0x1, 0x33C), ZYDIS_DEFINITION(0x1, 0x33D) },
    { ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_DEFINITION(0x1, 0x143) },
    { ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_DEFINITION(0x1, 0x13C) },
    { ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_DEFINITION(0x1, 0x13D) },
    { ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_DEFINITION(0x1, 0x13E) },
    { ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_DEFINITION(0x1, 0x142) },
    { ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_DEFINITION(0x1, 0x13F) },
    { ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_DEFINITION(0x1, 0x140) },
    { ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_DEFINITION(0x1, 0x141) },
    { ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_DEFINITION(0x1, 0x1) },
    { ZYDIS_INVALID, ZYDIS_INVALID, ZYDIS_DEFINITION(0x1, 0x0) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x3EF), ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x3F0), ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x3F1), ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x3F2), ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x3F3), ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x3F4), ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x3F5), ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x3F6), ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x3F7), ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x3F8), ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x3F9), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x3FA), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x3FB), ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x3FC), ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x3FD), ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x3FE), ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x3FF), ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x400), ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x401), ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x402), ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x403), ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x404), ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x405), ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x406), ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x407), ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x408), ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x409), ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x40A), ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x40B), ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x40C), ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x40D), ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x40E), ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x40F), ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x410), ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x411), ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x412), ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x413), ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x414), ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x415), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x416), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x417), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x418), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x419), ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x41A), ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x41B), ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x41C), ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x41D), ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x41E), ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x41F), ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x420), ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x421), ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x422), ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x423), ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x424), ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x425), ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x426), ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x427), ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x428), ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x429), ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x42A), ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x42B), ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x42C), ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x42D), ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x42E), ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x42F), ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x430), ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x431), ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x432), ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x433), ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x434), ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x435), ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x436), ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x437), ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x438), ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODE_COMPACT, 0xD3), ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODE_COMPACT, 0xD4), ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x43C), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x43D), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x43E), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x43F), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x440), ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x441), ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x442), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x443), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x444), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x445), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x446), ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x447), ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODE_COMPACT, 0xD5), ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODE_COMPACT, 0xD6), ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODE_COMPACT, 0xD7), ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODE_COMPACT, 0xD8), ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODE_COMPACT, 0xD9), ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODE_COMPACT, 0xDA), ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODE_COMPACT, 0xDB), ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODE_COMPACT, 0xDC), ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x450), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x451), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x452), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x453), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x454), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x455), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODE_COMPACT, 0xDD), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x459), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODE_COMPACT, 0xDE), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x45B), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODE_COMPACT, 0xDF), ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODE_COMPACT, 0xE0), ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODE_COMPACT, 0xE1), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x460), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODE_COMPACT, 0xE2), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x462), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODE_COMPACT, 0xE3), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x464), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODE_COMPACT, 0xE4), ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODE_COMPACT, 0xE5), ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x467), ZYDIS_INVALID },
    { ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x468), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x469), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x46A), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x46B), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x46C), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x46D), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x46E), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x46F), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x470), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x471), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x472), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x473), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x474), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x475), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x476), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x477), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x478), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x479), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x47A), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x47B), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x47C), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x47D), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x47E), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x47F), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x480), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x481), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x482), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x483), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x484), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x485), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x486), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x487), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x488), ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0x0, 0x69D), ZYDIS_DEFINITION(0x0, 0x69C), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODE_COMPACT, 0xE6), ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODE_COMPACT, 0xE7), ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODE_COMPACT, 0xE8), ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x48B), ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODE_COMPACT, 0xE9), ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODE_COMPACT, 0xEA), ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODE_COMPACT, 0xEB), ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODE_COMPACT, 0xEC), ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODE_COMPACT, 0xED), ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x494), ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x495), ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x496), ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x497), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x498), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x499), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x49A), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODE_COMPACT, 0xEE), ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODE_COMPACT, 0xEF), ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODE_COMPACT, 0xF0), ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODE_COMPACT, 0xF1), ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODE_COMPACT, 0xF2), ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODE_COMPACT, 0xF3), ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODE_COMPACT, 0xF4), ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODE_COMPACT, 0xF5), ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x4A3), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x4A4), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x4A5), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x4A6), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODE_COMPACT, 0xF6), ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x4A8), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x4A9), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x4AA), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x4AB), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x4AC), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x4AD), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x4AE), ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODE_COMPACT, 0xF7), ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x4B1), ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x4B2), ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x4B3), ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODE_COMPACT, 0xF8), ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x4B6), ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x4B7), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x4B8), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x4B9), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x4BA), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x4BB), ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x4BC), ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x4BD), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x4BE), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x4BF), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x4C0), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x4C1), ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x4C2), ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x4C3), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x4C4), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x4C5), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x4C6), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x4C7), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x4C8), ZYDIS_INVALID },
    { ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x4CB), ZYDIS_INVALID },
    { ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x4CC), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x4CD), ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x4CE), ZYDIS_INVALID },
    { ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x4CF), ZYDIS_INVALID },
    { ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x4D0), ZYDIS_INVALID },
    { ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x4D1), ZYDIS_INVALID },
    { ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x4D2), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x4D3), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x4D4), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x4D5), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x4D6), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x4D7), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x4D8), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x4D9), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x4DA), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x4DB), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x4DC), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x4DD), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x4DE), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x4DF), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x4E0), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x4E1), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x4E2), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x4E3), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x4E4), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x4E5), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x4E6), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x4E7), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x4E8), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x4E9), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x4EA), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x4EB), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x4EC), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x4ED), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x4EE), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x4EF), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x4F0), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x4F1), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x4F2), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x4F3), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x4F4), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x4F5), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x4F6), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x4F7), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x4F8), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x4F9), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x4FA), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x4FB), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x4FC), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x4FD), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x4FE), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x4FF), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x500), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x501), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x502), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x503), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x504), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x505), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x506), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x507), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x508), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x509), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x50A), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODE_COMPACT, 0xF9), ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x50D), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x50E), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x50F), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x510), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x511), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x512), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x513), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x514), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x515), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x516), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x517), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x518), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x519), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x51A), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x51B), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x51C), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x51D), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x51E), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x51F), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x520), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x521), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x522), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x523), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x524), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x525), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x526), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x527), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x528), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x529), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x52A), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x52B), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x52C), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x52D), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x52E), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODE_COMPACT, 0xFA), ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x531), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x532), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x533), ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x534), ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x535), ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x536), ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x537), ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x538), ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x539), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x53A), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x53B), ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x53C), ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x53D), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x53E), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x53F), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x540), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x541), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x542), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x543), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x544), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x545), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x546), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x547), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x548), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x549), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x54A), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x54B), ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x54C), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x54D), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x54E), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x54F), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x550), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x551), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x552), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x553), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x554), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x555), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x556), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x557), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x558), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x559), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x55A), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x55B), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x55C), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x55D), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x55E), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x55F), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x560), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x561), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x562), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x563), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x564), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x565), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x566), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x567), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x568), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x569), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x56A), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x56B), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x56C), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x56D), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x56E), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x56F), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x570), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x571), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x572), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x573), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x574), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x575), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x576), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x577), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x578), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x579), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x57A), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x57B), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x57C), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x57D), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x57E), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x57F), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x580), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x581), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x582), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x583), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x584), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x585), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x586), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x587), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x588), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x589), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x58A), ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x58B), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x58C), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x58D), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x58E), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x58F), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x590), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x591), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x592), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x593), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x594), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x595), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x596), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x597), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x598), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x599), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x59A), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x59B), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x59C), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x59D), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x59E), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x59F), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x5A0), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x5A1), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x5A2), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x5A3), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x5A4), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x5A5), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x5A6), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x5A7), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x5A8), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x5A9), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x5AA), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x5AB), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x5AC), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x5AD), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x5AE), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x5AF), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x5B0), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x5B1), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x5B2), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x5B3), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x5B4), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x5B5), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x5B6), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x5B7), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x5B8), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x5B9), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x5BA), ZYDIS_INVALID },
    { ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x5BB), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x5BC), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x5BD), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x5BE), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x5BF), ZYDIS_INVALID },
    { ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x5C0), ZYDIS_INVALID },
    { ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x5C1), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x5C2), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x5C3), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x5C4), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x5C5), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x5C6), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x5C7), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x5C8), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x5C9), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x5CA), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x5CB), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x5CC), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x5CD), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x5CE), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x5CF), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x5D0), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x5D1), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x5D2), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x5D3), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x5D4), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x5D5), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x5D6), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x5D7), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x5D8), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x5D9), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x5DA), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x5DB), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x5DC), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x5DD), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x5DE), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x5DF), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x5E0), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x5E1), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x5E2), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x5E3), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x5E4), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x5E5), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x5E6), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x5E7), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x5E8), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x5E9), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x5EA), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x5EB), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x5EC), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x5ED), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x5EE), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x5EF), ZYDIS_INVALID },
    { ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x5F0), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x5F1), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x5F2), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x5F3), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x5F4), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x5F5), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x5F6), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x5F7), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x5F8), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x5F9), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x5FA), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x5FB), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x5FC), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x5FD), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x5FE), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x5FF), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x600), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x601), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x602), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x603), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x604), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x605), ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x606), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x607), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x608), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x609), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x60A), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x60B), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODE_COMPACT, 0xFB), ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODE_COMPACT, 0xFC), ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x60E), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x60F), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x610), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x611), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x612), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x613), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x614), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x615), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x616), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x617), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x618), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x619), ZYDIS_INVALID },
    { ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x61A), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODE_COMPACT, 0xFD), ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x61C), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x61D), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x61E), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x61F), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x620), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x621), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x622), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x623), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x624), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x625), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x626), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x627), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x628), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x629), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x62A), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x62B), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x62C), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x62D), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x62E), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x62F), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x630), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x631), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x633), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x634), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x636), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x637), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x639), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x63A), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x63C), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x63D), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x63E), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x63F), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x640), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x641), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x643), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x644), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x646), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x647), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x649), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x64A), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x64C), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x64D), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x64E), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x64F), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x650), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x651), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x652), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x653), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x654), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x655), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x656), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x657), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x658), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x659), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x65B), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x65C), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x65E), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x65F), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x661), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x662), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x664), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x665), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x666), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x667), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x668), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x669), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x66A), ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x66B), ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x66C), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x66D), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x66E), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x66F), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x670), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x671), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x672), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x673), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODE_COMPACT, 0xFE), ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x676), ZYDIS_INVALID },
    { ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x677), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x678), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x679), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x67A), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x67B), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x67C), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x67D), ZYDIS_INVALID },
    { ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x67E), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x67F), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x680), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x681), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x682), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x685), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x686), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x687), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x688), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x689), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x68A), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x68B), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x68C), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x68D), ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x68E), ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODE_COMPACT, 0xFF), ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x691), ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x692), ZYDIS_INVALID },
    { ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x693), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x694), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x695), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x696), ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x697), ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODE_COMPACT, 0x100), ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x69A), ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x69B), ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x69C), ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x69D), ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x69E), ZYDIS_INVALID },
    { ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x69F), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODE_COMPACT, 0x101), ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x6A1), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x6A2), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x6A3), ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x6A4), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x6A5), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x6A6), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x6A7), ZYDIS_INVALID },
    { ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x6A8), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x6A9), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x6AA), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x6AB), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x6AC), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x6AD), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x6AE), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x6AF), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x6B0), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x6B1), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x6B2), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x6B3), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x6B4), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x6B5), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x6B6), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x6B7), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x6B8), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x6B9), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x6BA), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODE_COMPACT, 0x102), ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x6BD), ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x6BE), ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x6BF), ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x6C0), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x6C1), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x6C2), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x6C3), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x6C6), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x6C7), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x6C8), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x6C9), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x6CC), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x6CD), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x6CE), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x6CF), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x6D2), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x6D3), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x6D4), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x6D5), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x6D8), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x6D9), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x6DA), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x6DB), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x6DC), ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x6DD), ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x6E0), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x6E1), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x6E2), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x6E3), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x6F0), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x6F1), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x6F6), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x6F7), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x6F8), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x6F9), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x6FA), ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x6FB), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x6FC), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODE_COMPACT, 0x106), ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODE_COMPACT, 0x107), ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODE_COMPACT, 0x108), ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODE_COMPACT, 0x109), ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODE_COMPACT, 0x10A), ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x703), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x704), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODE_COMPACT, 0x10B), ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x706), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x707), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x708), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x709), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODE_COMPACT, 0x10C), ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODE_COMPACT, 0x10D), ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x70C), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x70D), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x70E), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x70F), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x710), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x711), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x712), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x713), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x714), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x715), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x716), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x717), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODE_COMPACT, 0x10E), ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODE_COMPACT, 0x10F), ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x71E), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x71F), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x72E), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x72F), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x730), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x731), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x732), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x733), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODE_COMPACT, 0x113), ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODE_COMPACT, 0x114), ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODE_COMPACT, 0x115), ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODE_COMPACT, 0x116), ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODE_COMPACT, 0x117), ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x73C), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x73D), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x73E), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x73F), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x740), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x741), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODE_COMPACT, 0x118), ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODE_COMPACT, 0x119), ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x744), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x745), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x746), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x747), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODE_COMPACT, 0x11A), ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODE_COMPACT, 0x11B), ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x74A), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x74B), ZYDIS_INVALID },
    { ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x74C), ZYDIS_INVALID },
    { ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x74D), ZYDIS_INVALID },
    { ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x74E), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x74F), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x750), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODE_COMPACT, 0x11C), ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODE_COMPACT, 0x11D), ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODE_COMPACT, 0x11E), ZYDIS_INVALID, ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODE_COMPACT, 0x11F), ZYDIS_INVALID, ZYDIS_INVALID }
};

const ZydisDecoderTreeNode FILTERS_REX_W[][2] =
{
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODE_CET, 0x0), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODE_CET, 0x1) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODE_CET, 0x2), ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0x1, 0x13C), ZYDIS_DEFINITION(0x1, 0x13D) },
    { ZYDIS_DEFINITION(0x1, 0x138), ZYDIS_DEFINITION(0x1, 0x139) },
    { ZYDIS_DEFINITION(0x1, 0x13E), ZYDIS_DEFINITION(0x1, 0x13F) },
    { ZYDIS_DEFINITION(0x1, 0x13A), ZYDIS_DEFINITION(0x1, 0x13B) },
    { ZYDIS_DEFINITION(0x1, 0x152), ZYDIS_DEFINITION(0x1, 0x153) },
    { ZYDIS_DEFINITION(0x1, 0x14E), ZYDIS_DEFINITION(0x1, 0x14F) },
    { ZYDIS_DEFINITION(0x1, 0x154), ZYDIS_DEFINITION(0x1, 0x155) },
    { ZYDIS_DEFINITION(0x1, 0x150), ZYDIS_DEFINITION(0x1, 0x151) },
    { ZYDIS_DEFINITION(0x1, 0x142), ZYDIS_DEFINITION(0x1, 0x143) },
    { ZYDIS_DEFINITION(0x1, 0x132), ZYDIS_DEFINITION(0x1, 0x133) },
    { ZYDIS_DEFINITION(0x1, 0x144), ZYDIS_DEFINITION(0x1, 0x145) },
    { ZYDIS_DEFINITION(0x1, 0x134), ZYDIS_DEFINITION(0x1, 0x135) },
    { ZYDIS_DEFINITION(0x1, 0x75E), ZYDIS_DEFINITION(0x1, 0x75F) },
    { ZYDIS_DEFINITION(0x1, 0x1A), ZYDIS_DEFINITION(0x1, 0x1B) },
    { ZYDIS_DEFINITION(0x1, 0x3C), ZYDIS_DEFINITION(0x1, 0x3D) },
    { ZYDIS_DEFINITION(0x1, 0x75C), ZYDIS_DEFINITION(0x1, 0x75D) },
    { ZYDIS_DEFINITION(0x1, 0x1C), ZYDIS_DEFINITION(0x1, 0x1D) },
    { ZYDIS_DEFINITION(0x1, 0x3E), ZYDIS_DEFINITION(0x1, 0x3F) },
    { ZYDIS_DEFINITION(0x1, 0x345), ZYDIS_DEFINITION(0x1, 0x346) },
    { ZYDIS_DEFINITION(0x1, 0x2), ZYDIS_DEFINITION(0x1, 0x3) },
    { ZYDIS_DEFINITION(0x1, 0x5), ZYDIS_DEFINITION(0x1, 0x6) },
    { ZYDIS_DEFINITION(0x1, 0x72), ZYDIS_DEFINITION(0x1, 0x73) },
    { ZYDIS_DEFINITION(0x1, 0x6E), ZYDIS_DEFINITION(0x1, 0x6F) },
    { ZYDIS_DEFINITION(0xB, 0x499), ZYDIS_DEFINITION(0xB, 0x49B) },
    { ZYDIS_DEFINITION(0xB, 0x49A), ZYDIS_DEFINITION(0xB, 0x49C) },
    { ZYDIS_DEFINITION(0xB, 0x4BD), ZYDIS_DEFINITION(0xB, 0x4BF) },
    { ZYDIS_DEFINITION(0xB, 0x4BE), ZYDIS_DEFINITION(0xB, 0x4C0) },
    { ZYDIS_DEFINITION(0xB, 0x47E), ZYDIS_DEFINITION(0xB, 0x47F) },
    { ZYDIS_DEFINITION(0xB, 0x480), ZYDIS_DEFINITION(0xB, 0x481) },
    { ZYDIS_DEFINITION(0xB, 0x47A), ZYDIS_DEFINITION(0xB, 0x47B) },
    { ZYDIS_DEFINITION(0xB, 0x47C), ZYDIS_DEFINITION(0xB, 0x47D) },
    { ZYDIS_DEFINITION(0x1, 0x331), ZYDIS_DEFINITION(0x1, 0x365) },
    { ZYDIS_DEFINITION(0x1, 0x335), ZYDIS_DEFINITION(0x1, 0x367) },
    { ZYDIS_DEFINITION(0x1, 0x332), ZYDIS_DEFINITION(0x1, 0x366) },
    { ZYDIS_DEFINITION(0x1, 0x336), ZYDIS_DEFINITION(0x1, 0x368) },
    { ZYDIS_DEFINITION(0x1, 0x339), ZYDIS_DEFINITION(0x1, 0x36B) },
    { ZYDIS_DEFINITION(0x1, 0x33D), ZYDIS_DEFINITION(0x1, 0x36D) },
    { ZYDIS_DEFINITION(0x1, 0x33A), ZYDIS_DEFINITION(0x1, 0x36C) },
    { ZYDIS_DEFINITION(0x1, 0x33E), ZYDIS_DEFINITION(0x1, 0x36E) },
    { ZYDIS_DEFINITION(0x1, 0x245), ZYDIS_DEFINITION(0x1, 0x246) },
    { ZYDIS_DEFINITION(0x1, 0x216), ZYDIS_DEFINITION(0x1, 0x217) },
    { ZYDIS_DEFINITION(0x1, 0x214), ZYDIS_DEFINITION(0x1, 0x215) },
    { ZYDIS_DEFINITION(0x1, 0x78F), ZYDIS_DEFINITION(0x1, 0x790) },
    { ZYDIS_DEFINITION(0x1, 0x78B), ZYDIS_DEFINITION(0x1, 0x78C) },
    { ZYDIS_DEFINITION(0x1, 0x793), ZYDIS_DEFINITION(0x1, 0x794) },
    { ZYDIS_DEFINITION(0x1, 0x112), ZYDIS_DEFINITION(0x1, 0x111) },
    { ZYDIS_DEFINITION(0x1, 0x78D), ZYDIS_DEFINITION(0x1, 0x78E) },
    { ZYDIS_DEFINITION(0x1, 0x791), ZYDIS_DEFINITION(0x1, 0x792) },
    { ZYDIS_DEFINITION(0x1, 0x795), ZYDIS_DEFINITION(0x1, 0x796) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x0), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x1), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x2), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x3), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x4), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x5), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x6), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x7), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x8), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x8), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0xA), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x9), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0xA), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0xB), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0xC), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0xD), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0xE), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0xF), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x10), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x11), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x12), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x13), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x14), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x15), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x14), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x16), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x16), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x17), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x18), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x18), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x1A), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x19), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x1C), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x1A), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x1E), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x1B), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x20), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x1C), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x22), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x1D), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x1E) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x25), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x26) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x1F), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x28), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x20), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x2A), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x21), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x2C), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x22), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x2E), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x23), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x24) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x31), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x32) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x25), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x26) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x35), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x36) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x27), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x38), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x28), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x3A), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x29), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x3C), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x2A), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x2B), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x2C), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x3E), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x2D), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x2E), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x2F), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x40), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x30), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x31), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x32), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x42), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x33), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x34), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x35), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x44), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x36), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x37), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x38), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x39), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x3A), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x3B), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x3C), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x46), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x3D), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x48), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x3E), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x4A), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x3F), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x4C), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x40), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x41) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x4F), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x50) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x42), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x52), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x43), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x54), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x44), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x56), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x45), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x58), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x46), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x5A), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x47), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x5C), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x48), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x5E), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x49), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x60), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x4A), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x4B), ZYDIS_INVALID },
    { ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x4C) },
    { ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x4D) },
    { ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x4E) },
    { ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x4F) },
    { ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x50) },
    { ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x51) },
    { ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x52) },
    { ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x68) },
    { ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x53) },
    { ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x6A) },
    { ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x54) },
    { ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x55) },
    { ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x56) },
    { ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x57) },
    { ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x58) },
    { ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x59) },
    { ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x5A) },
    { ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x5B) },
    { ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x5C) },
    { ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x5D) },
    { ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x5E) },
    { ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x5F) },
    { ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x73) },
    { ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x60) },
    { ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x75) },
    { ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x61) },
    { ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x77) },
    { ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x62) },
    { ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x79) },
    { ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x63) },
    { ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x7B) },
    { ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x64) },
    { ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x7D) },
    { ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x65) },
    { ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x7F) },
    { ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x66) },
    { ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x81) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x67), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x83), ZYDIS_INVALID },
    { ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x68) },
    { ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x85) },
    { ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x69) },
    { ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x87) },
    { ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x6A) },
    { ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x89) },
    { ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x6B) },
    { ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x8B) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x70), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x91), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x77), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x99), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x7E), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0xA1), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x7F), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0xA3), ZYDIS_INVALID },
    { ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x80) },
    { ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0xA5) },
    { ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x81) },
    { ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0xA7) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x82), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODE_COMPACT, 0x74) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x85), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODE_COMPACT, 0x75) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x88), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x89) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x8A), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x8B) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x8C), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0xB3), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x93), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x94) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x95), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x96) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x97), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x98), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x99) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x9A), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0xC2), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0xC3) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0xC4), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0xC5) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0xC6), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0xC7), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0xC8) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0xC9), ZYDIS_INVALID },
    { ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x9B) },
    { ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x9D) },
    { ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0xCE) },
    { ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0xD0) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0xA5), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0xD7), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0xA6), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0xA7) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0xDA), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0xDB) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0xA8), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0xA9) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0xDE), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0xDF) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0xAA), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0xAB) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0xE2), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0xE3) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0xAC), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0xAD) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0xE6), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0xE7) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0xAE), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODE_COMPACT, 0x76) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0xB1), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODE_COMPACT, 0x77) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0xB4), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0xB5) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0xB6), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0xB7) },
    { ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0xB8) },
    { ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0xF3) },
    { ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0xBC) },
    { ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0xF8) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0xBF), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0xC0), ZYDIS_INVALID },
    { ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0xC1) },
    { ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0xC2) },
    { ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0xC3) },
    { ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x100) },
    { ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0xC6) },
    { ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0xC7) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0xCE), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0xCF) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x10D), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x10E) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0xD6), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0xD7) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x117), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x118) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0xDC), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0xDD) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0xDE), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0xDF) },
    { ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0xE6) },
    { ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x128) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0xE7), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0xEE), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0xEF) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x132), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x133) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0xF6), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0xF7) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x13C), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x13D) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0xFA), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0xFB), ZYDIS_INVALID },
    { ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0xFC) },
    { ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0xFD) },
    { ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0xFE) },
    { ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x145) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x107), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x14F), ZYDIS_INVALID },
    { ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x108) },
    { ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x151) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x10D), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x157), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x114), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x15F), ZYDIS_INVALID },
    { ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x115) },
    { ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x161) },
    { ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x116) },
    { ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x117) },
    { ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x118) },
    { ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x119) },
    { ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x11A) },
    { ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x11B) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x11C), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x11D), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x11E), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x11F) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x16C), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x16D) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x120), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x121) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x170), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x171) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x122), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x123) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x174), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x175) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x124), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x125), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x126), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x127) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x128), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x129) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x12A), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x12B) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x12C), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x12D) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x132), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x185), ZYDIS_INVALID },
    { ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x133) },
    { ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x187) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x13E), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x13F), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x140), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x141) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x142), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x143) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x144), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x145) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x19A), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x19B) },
    { ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x146) },
    { ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x19D) },
    { ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x147) },
    { ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x19F) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x148), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x149), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x1A2), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x14A), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x14B) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x1A5), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x1A6) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x14C), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x14D) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x14E), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x14F) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x15A), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x15B), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x15C), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x15D) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x1B5), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x1B6) },
    { ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x15E) },
    { ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x1B8) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x161), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x162) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x1BD), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x1BE) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x165), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x166) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x1C3), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x1C4) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x169), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x16A) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x1C9), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x1CA) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x16D), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x16E) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x1CF), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x1D0) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x16F), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x170) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x1D3), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x1D4) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x171), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x172) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x1D7), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x1D8) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x173), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x174) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x175), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x176) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x177), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x178) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x1DB), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x1DC) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x179), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x17A) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x1DF), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x1E0) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x17B), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x17C) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x1E3), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x1E4) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x17D), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x17E) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x1E7), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x1E8) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x17F), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x180) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x1EB), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x1EC) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x181), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x182) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x183), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x184) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x185), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x186) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x1EF), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x1F0) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x187), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x188) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x189), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x18A) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x18B), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x1F2), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x18C), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x1F4), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x18D), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x1F6), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x18E), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x1F8), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x18F), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x190) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x191), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x192) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x193), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x194) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x1FF), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x200) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x195), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x196), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x197), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x198) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x199), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x19A) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x19B), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x19C) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x19D), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x19E) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x19F), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x1A0) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x1A1), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x1A2) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x1A3), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x1A4) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x1A5), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x1A6) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x1A7), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x1A8) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x215), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x216) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x1A9), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x1AA) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x219), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x21A) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x1AB), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x1AC) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x1AD), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x1AE) },
    { ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x1AF) },
    { ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x1B0) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x1B1), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x1B2) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x223), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x224) },
    { ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x1B3) },
    { ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x1B4) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x1B5), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x1B6) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x229), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x22A) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x1B7), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x1B8) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x1B9), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x1BA) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x1BB), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x1BC) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x231), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x232) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x1BD), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x1BE) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x235), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x236) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x1BF), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x1C0), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x1C1), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x1C2), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x1C3), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x1C4), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x1C5), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODE_COMPACT, 0x78) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x1C8), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x1C9) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x1CA), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x1CB) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x1CC), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x1CD) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x246), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x247) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x1CE), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x1CF) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x24A), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x24B) },
    { ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x1D0) },
    { ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x24D) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x1D1), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x1D2) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x1D3), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x1D4) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x1D5), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x1D6) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x1D7), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x1D8) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x1D9), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x1DA) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x1DB), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x1DC) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x1DD), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x1DE) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x1DF), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x1E0) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x1E1), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x1E2) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x1E3), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x1E4) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x1E5), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x1E6), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_ADDRESS_SIZE, 0x8), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_ADDRESS_SIZE, 0x9) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_ADDRESS_SIZE, 0xA), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_ADDRESS_SIZE, 0xB) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_ADDRESS_SIZE, 0xC), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_ADDRESS_SIZE, 0xD) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_ADDRESS_SIZE, 0xE), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_ADDRESS_SIZE, 0xF) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x1EF), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x1F0) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x26E), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x26F) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x1F1), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x1F2) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x272), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x273) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x1F3), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x1F4) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x276), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x277) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x1F5), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x1F6) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x1F7), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x1F8) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x1F9), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x1FA) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x27A), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x27B) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x1FB), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x1FC) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x1FD), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x1FE) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x1FF), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x200) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x27E), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x27F) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x201), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x202) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x203), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x204) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x205), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x206) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x282), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x283) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x207), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x208) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x209), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x20A) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_ADDRESS_SIZE, 0x10), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_ADDRESS_SIZE, 0x11) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_ADDRESS_SIZE, 0x12), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_ADDRESS_SIZE, 0x13) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_ADDRESS_SIZE, 0x14), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_ADDRESS_SIZE, 0x15) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_ADDRESS_SIZE, 0x16), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_ADDRESS_SIZE, 0x17) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x213), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x214) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x28E), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x28F) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x215), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x216) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x292), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x293) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x217), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x218) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x296), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x297) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x219), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x21A) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x21B), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x21C) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x21D), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x21E) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x29A), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x29B) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x21F), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x220) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x221), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x222) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x223), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x224) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x29E), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x29F) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x225), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x226) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x227), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x228) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x229), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x22A) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x2A2), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x2A3) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x22B), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x22C) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x22D), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x22E) },
    { ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x22F) },
    { ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x2A5) },
    { ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x230) },
    { ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x2A7) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x231), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x232) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x2AA), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x2AB) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x233), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x234) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x2AE), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x2AF) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x235), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x236) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x2B2), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x2B3) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x237), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x238) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x239), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x23A) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x23B), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x23C) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x2B6), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x2B7) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x23D), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x23E) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x23F), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x240) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x241), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x242) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x2BA), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x2BB) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x243), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x244) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x245), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x246) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x247), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x248) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x2BE), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x2BF) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x249), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x24A) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x24B), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x24C) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x24D), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x24E) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x2C2), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x2C3) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_ADDRESS_SIZE, 0x18), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_ADDRESS_SIZE, 0x19) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_ADDRESS_SIZE, 0x1A), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_ADDRESS_SIZE, 0x1B) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_ADDRESS_SIZE, 0x1C), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_ADDRESS_SIZE, 0x1D) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_ADDRESS_SIZE, 0x1E), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_ADDRESS_SIZE, 0x1F) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_ADDRESS_SIZE, 0x20), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_ADDRESS_SIZE, 0x21) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_ADDRESS_SIZE, 0x22), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_ADDRESS_SIZE, 0x23) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_ADDRESS_SIZE, 0x24), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_ADDRESS_SIZE, 0x25) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_ADDRESS_SIZE, 0x26), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_ADDRESS_SIZE, 0x27) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x25F), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x260) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x2D6), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x2D7) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x261), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x262) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x2DA), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x2DB) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x263), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x264) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x265), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x266) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x267), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x268) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x2DE), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x2DF) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x269), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x26A) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x26B), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x26C) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x26D), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x26E), ZYDIS_INVALID },
    { ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x277) },
    { ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x2EB) },
    { ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x278) },
    { ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x2ED) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x279), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x27A) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x2F0), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x2F1) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x27B), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x2F3), ZYDIS_INVALID },
    { ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x27C) },
    { ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x2F5) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x27D), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x2F7), ZYDIS_INVALID },
    { ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x27E) },
    { ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x2F9) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x27F), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x280), ZYDIS_INVALID },
    { ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x281) },
    { ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x282) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x289), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODE_COMPACT, 0x79) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x28C), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODE_COMPACT, 0x7A) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x291), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x292) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x293), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x294) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x295), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x296) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x297), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x298) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x299), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x29A) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x29B), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x29C) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x29D), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x29E) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x29F), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x2A0) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x2A1), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x2A2), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x2A3), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x2A4) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x31C), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x31D) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x2A5), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x2A6) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x320), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x321) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x2A9), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x2AA), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x2AB), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODE_COMPACT, 0x7B) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x2AE), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODE_COMPACT, 0x7C) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x2B1), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x2B2) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x32E), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x32F) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x2B3), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x2B4) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x332), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x333) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x2B5), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x2B6) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x336), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x337) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x2B7), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x2B8) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x2B9), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x2BA) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x2BB), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x2BC) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x2BD), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x2BE) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x2BF), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x2C0) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x2C1), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x2C2) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x2C3), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x2C4) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x2C5), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x2C6) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x2C7), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x2C8) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x2C9), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x2CA) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x2CB), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x2CC) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x2CD), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x2CE) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x2CF), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x2D0) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x2D1), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x2D2) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x2D3), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x2D4), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x2D5), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x2D6) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x354), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x355) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x2D9), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x2DA) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x35A), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x35B) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x2DB), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x2DC) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x2DD), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x2DE) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x2DF), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x2E0) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x35E), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x35F) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x2E1), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x2E2) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x2E3), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x2E4) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x2E5), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x2E6) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x362), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x363) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x2E7), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x2E8) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x2E9), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x2EA) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x2EB), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x2EC) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x366), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x367) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x2ED), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x2EE) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x2EF), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x2F0) },
    { ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x2F1) },
    { ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x2F2) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x2F3), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x2F4) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x36C), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x36D) },
    { ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x2F5) },
    { ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x2F6) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x2F7), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x2F8) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x372), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x373) },
    { ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x2F9) },
    { ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x375) },
    { ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x2FA) },
    { ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x377) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x2FB), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x379), ZYDIS_INVALID },
    { ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x2FC) },
    { ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x37B) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x2FD), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x37D), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x300), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x381), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x301), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x383), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x302), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x385), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x303), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x387), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x304), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x389), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x305), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x38B), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x308), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x38F), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x309), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x391), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x30A), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x30B), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x30C), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x393), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x30D), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x30E), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x30F), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x395), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x310), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x311), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x312), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x397), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x313), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x314), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x315), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x399), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x316), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x39B), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x317), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x39D), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x318), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x319), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x31A), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x39F), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x31B), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x31C), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x31D), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x3A1), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x31E), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x31F), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x320), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x3A3), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x321), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x322), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x323), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x3A5), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x324), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x3A7), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x325), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x3A9), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x326), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x327), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x328), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x3AB), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x329), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x32A), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x32B), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x3AD), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x32C), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x32D), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x32E), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x3AF), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x32F), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x330), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x331), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x3B1), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x332), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x3B3), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x333), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x3B5), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x334), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x335), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x336), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x3B7), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x337), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x338), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x339), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x3B9), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x33A), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x33B), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x33C), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x3BB), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x33D), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x33E), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x33F), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x340), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x341), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x342), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x343), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x344), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x345), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x346), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x347), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODE_COMPACT, 0x7D) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x34A), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODE_COMPACT, 0x7E) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x34D), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODE_COMPACT, 0x7F) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x350), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODE_COMPACT, 0x80) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x353), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODE_COMPACT, 0x81) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x356), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODE_COMPACT, 0x82) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x359), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x35A), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x35B), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x35C), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x35D), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x35E), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x35F), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x360), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x361), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x3C1), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x362), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x363), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x364), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x365), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x366), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x367), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x368), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x369), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x36A), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x36B) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x36C), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x36D) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x370), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODE_COMPACT, 0x83) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x373), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODE_COMPACT, 0x84) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x376), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODE_COMPACT, 0x85) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x379), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODE_COMPACT, 0x86) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x37C), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x37D) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x3CA), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x3CB) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x37E), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODE_COMPACT, 0x87) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x381), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODE_COMPACT, 0x88) },
    { ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x384) },
    { ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x385) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x386), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x387) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x388), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x389) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x38A), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x38B), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x38C), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x38D) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x3D4), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x3D5) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x38E), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x38F), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x390), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x391), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x392), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x393), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x394), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x395), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x396), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x397), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x398), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x399), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x39A), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x39B), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x39C), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x39D), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x39E), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x39F), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x3A0), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x3A1), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x3A2), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x3A3), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x3A4), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x3A5), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x3A6), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x3A7) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x3A8), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x3A9) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x3AA), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x3AB) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x3F4), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x3F5) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x3AC), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x3AD) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x3AE), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x3AF) },
    { ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x3B0) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x3B1), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x3B2), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x3B3), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x3B4), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x3B5), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x3B6), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x3B7), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x3B8), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x3B9), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x3BA), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x3BB), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x3BC), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x3BD), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x3BE) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x3BF), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x3C0) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x3C1), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x3C2), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x40D), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x3C3), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x40F), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x3C4), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x3C5), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x3C6), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x3C7), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x3C8), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x3C9), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODE_COMPACT, 0x89), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODE_COMPACT, 0x8A) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODE_COMPACT, 0x8B), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODE_COMPACT, 0x8C) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODE_COMPACT, 0x8D), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODE_COMPACT, 0x8E) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODE_COMPACT, 0x8F), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODE_COMPACT, 0x90) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODE_COMPACT, 0x91), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODE_COMPACT, 0x92) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODE_COMPACT, 0x93), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODE_COMPACT, 0x94) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x3DC), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x3DD), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x3DE), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x3DF), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x3E0), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x3E1), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x3E2), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x3E3), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x3E4), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x411), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x3E5), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x3E6), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x3E7), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x3E8), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x3E9), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x3EA), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x3EB), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x3EC), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODE_COMPACT, 0x95), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODE_COMPACT, 0x96) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODE_COMPACT, 0x97), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODE_COMPACT, 0x98) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODE_COMPACT, 0x99), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODE_COMPACT, 0x9A) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODE_COMPACT, 0x9B), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODE_COMPACT, 0x9C) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODE_COMPACT, 0x9D), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODE_COMPACT, 0x9E) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODE_COMPACT, 0x9F), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODE_COMPACT, 0xA0) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x3FF), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x413), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x400), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x415), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x401), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x402), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x403), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x417), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x404), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x405), ZYDIS_INVALID },
    { ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x406) },
    { ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x407) },
    { ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x408) },
    { ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x409) },
    { ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x40A) },
    { ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x40B) },
    { ZYDIS_DEFINITION(0x1, 0x1BD), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODE_COMPACT, 0xA1) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x40E), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODE_COMPACT, 0xA2) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x411), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODE_COMPACT, 0xA3) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x414), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODE_COMPACT, 0xA4) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x417), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODE_COMPACT, 0xA5) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x41A), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODE_COMPACT, 0xA6) },
    { ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x41D) },
    { ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x41E) },
    { ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x41F) },
    { ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x420) },
    { ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x421) },
    { ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x422) },
    { ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x423) },
    { ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x424) },
    { ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x425) },
    { ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x426) },
    { ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x427) },
    { ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x428) },
    { ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x429) },
    { ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x42A) },
    { ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x42B) },
    { ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x42C) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x42D), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x42E) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x42F), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x430) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x433), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODE_COMPACT, 0xA7) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x436), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODE_COMPACT, 0xA8) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x439), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODE_COMPACT, 0xA9) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x43C), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODE_COMPACT, 0xAA) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x43F), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x440) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x422), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x423) },
    { ZYDIS_DEFINITION(0x1, 0x2B0), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODE_COMPACT, 0xAB) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x443), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODE_COMPACT, 0xAC) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x446), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x447) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x448), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x449) },
    { ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x44A) },
    { ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x44B) },
    { ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x44C) },
    { ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x429) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x44D), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x44E), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x44F), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x450) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x42E), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x42F) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x451), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x431), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x452), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x453), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x454), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x455), ZYDIS_INVALID },
    { ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x456) },
    { ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x457) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x458), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x459) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x436), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x437) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x45A), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x439), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x45B), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x43B), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x45C), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x45D), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x45E), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x43D), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x45F), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_EVEX_B, 0x460), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MVEX_E, 0x0), ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0x1, 0xC9), ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0x1, 0xCA), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MVEX_E, 0x1), ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0x1, 0xD), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MVEX_E, 0x2), ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0x1, 0xDC), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MVEX_E, 0x3), ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0x1, 0x3F), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MVEX_E, 0x4), ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0x1, 0x190), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MVEX_E, 0x5), ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0xB, 0x24), ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0x1, 0xBC), ZYDIS_DEFINITION(0x1, 0xBF) },
    { ZYDIS_DEFINITION(0x1, 0xBE), ZYDIS_DEFINITION(0x1, 0xBD) },
    { ZYDIS_DEFINITION(0x1, 0xB8), ZYDIS_DEFINITION(0x1, 0xBB) },
    { ZYDIS_DEFINITION(0x1, 0xBA), ZYDIS_DEFINITION(0x1, 0xB9) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MVEX_E, 0x6), ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0xB, 0x39), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MVEX_E, 0x7), ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0xB, 0x2A), ZYDIS_INVALID },
    { ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MVEX_E, 0x8) },
    { ZYDIS_INVALID, ZYDIS_DEFINITION(0x1, 0xC5) },
    { ZYDIS_INVALID, ZYDIS_DEFINITION(0x1, 0xC6) },
    { ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MVEX_E, 0x9) },
    { ZYDIS_INVALID, ZYDIS_DEFINITION(0x1, 0xA) },
    { ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MVEX_E, 0xA) },
    { ZYDIS_INVALID, ZYDIS_DEFINITION(0x1, 0xD9) },
    { ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MVEX_E, 0xB) },
    { ZYDIS_INVALID, ZYDIS_DEFINITION(0x1, 0x3C) },
    { ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MVEX_E, 0xC) },
    { ZYDIS_INVALID, ZYDIS_DEFINITION(0x1, 0x18D) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MVEX_E, 0xD), ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0x1, 0x10D), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MVEX_E, 0xE), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MVEX_E, 0xF) },
    { ZYDIS_DEFINITION(0x1, 0xCD), ZYDIS_DEFINITION(0x1, 0xD1) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MVEX_E, 0x10), ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0xB, 0x14E), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MVEX_E, 0x11), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MVEX_E, 0x12), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MVEX_E, 0x13), ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0xB, 0x15D), ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0xB, 0x157), ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0xB, 0x151), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MVEX_E, 0x14), ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0x1, 0x10A), ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0x1, 0xCE), ZYDIS_DEFINITION(0x1, 0xD2) },
    { ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MVEX_E, 0x15) },
    { ZYDIS_INVALID, ZYDIS_DEFINITION(0xB, 0x21) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MVEX_E, 0x16), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MVEX_E, 0x17) },
    { ZYDIS_DEFINITION(0x1, 0xF3), ZYDIS_DEFINITION(0x1, 0xFC) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MVEX_E, 0x18), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MVEX_E, 0x19) },
    { ZYDIS_DEFINITION(0x1, 0xF6), ZYDIS_DEFINITION(0x1, 0xF9) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MVEX_E, 0x1A), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MVEX_E, 0x1B) },
    { ZYDIS_DEFINITION(0x1, 0x138), ZYDIS_DEFINITION(0x1, 0x13B) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MVEX_E, 0x1C), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MVEX_E, 0x1D) },
    { ZYDIS_DEFINITION(0x1, 0x172), ZYDIS_DEFINITION(0x1, 0x175) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MVEX_E, 0x1E), ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0x1, 0x163), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MVEX_E, 0x1F), ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0x1, 0xEA), ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0x1, 0x1E), ZYDIS_INVALID },
    { ZYDIS_INVALID, ZYDIS_DEFINITION(0x1, 0x1D) },
    { ZYDIS_DEFINITION(0x1, 0x19), ZYDIS_INVALID },
    { ZYDIS_INVALID, ZYDIS_DEFINITION(0x1, 0x1A) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MVEX_E, 0x20), ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0x1, 0x16F), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MVEX_E, 0x21), ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0x1, 0x115), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MVEX_E, 0x22), ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0x1, 0x129), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MVEX_E, 0x23), ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0x1, 0x12C), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MVEX_E, 0x24), ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0x1, 0x123), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MVEX_E, 0x25), ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0x1, 0x126), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MVEX_E, 0x26), ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0x1, 0x135), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MVEX_E, 0x27), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MVEX_E, 0x28) },
    { ZYDIS_DEFINITION(0x1, 0xA2), ZYDIS_DEFINITION(0x1, 0x9F) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MVEX_E, 0x29), ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0x1, 0x160), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MVEX_E, 0x2A), ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0x1, 0x15A), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MVEX_E, 0x2B), ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0x1, 0x154), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MVEX_E, 0x2C), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MVEX_E, 0x2D) },
    { ZYDIS_DEFINITION(0x1, 0x7), ZYDIS_DEFINITION(0x1, 0x4) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MVEX_E, 0x2E), ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0x1, 0xAB), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MVEX_E, 0x2F), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MVEX_E, 0x30) },
    { ZYDIS_DEFINITION(0x1, 0xB7), ZYDIS_DEFINITION(0x1, 0xB4) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MVEX_E, 0x31), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MVEX_E, 0x32) },
    { ZYDIS_DEFINITION(0x1, 0xB1), ZYDIS_DEFINITION(0x1, 0xAE) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MVEX_E, 0x33), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MVEX_E, 0x34) },
    { ZYDIS_DEFINITION(0x1, 0x4B), ZYDIS_DEFINITION(0x1, 0x48) },
    { ZYDIS_DEFINITION(0x1, 0x103), ZYDIS_INVALID },
    { ZYDIS_INVALID, ZYDIS_DEFINITION(0x1, 0x104) },
    { ZYDIS_DEFINITION(0x1, 0x1B), ZYDIS_INVALID },
    { ZYDIS_INVALID, ZYDIS_DEFINITION(0x1, 0x1C) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MVEX_E, 0x35), ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0x1, 0xE7), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MVEX_E, 0x36), ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0x1, 0xED), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MVEX_E, 0x37), ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0x1, 0x146), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MVEX_E, 0x38), ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0x1, 0x16C), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MVEX_E, 0x39), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MVEX_E, 0x3A) },
    { ZYDIS_DEFINITION(0x1, 0xFF), ZYDIS_DEFINITION(0x1, 0x102) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MVEX_E, 0x3B), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MVEX_E, 0x3C) },
    { ZYDIS_DEFINITION(0x1, 0x18), ZYDIS_DEFINITION(0x1, 0x15) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MVEX_E, 0x3D), ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0x1, 0x166), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MVEX_E, 0x3E), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MVEX_E, 0x3F) },
    { ZYDIS_DEFINITION(0x1, 0x196), ZYDIS_DEFINITION(0x1, 0x193) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MVEX_E, 0x40), ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0x1, 0x149), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MVEX_E, 0x41), ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0x1, 0x169), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MVEX_E, 0x42), ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0x1, 0x110), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MVEX_E, 0x43), ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0x1, 0x184), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MVEX_E, 0x44), ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0x1, 0x132), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MVEX_E, 0x45), ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0x1, 0x12F), ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0x1, 0x119), ZYDIS_DEFINITION(0x1, 0x11A) },
    { ZYDIS_DEFINITION(0x1, 0x98), ZYDIS_DEFINITION(0x1, 0x97) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MVEX_E, 0x46), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MVEX_E, 0x47) },
    { ZYDIS_DEFINITION(0x1, 0x51), ZYDIS_DEFINITION(0x1, 0x4E) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MVEX_E, 0x48), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MVEX_E, 0x49) },
    { ZYDIS_DEFINITION(0x1, 0x66), ZYDIS_DEFINITION(0x1, 0x63) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MVEX_E, 0x4A), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MVEX_E, 0x4B) },
    { ZYDIS_DEFINITION(0x1, 0x78), ZYDIS_DEFINITION(0x1, 0x75) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MVEX_E, 0x4C), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MVEX_E, 0x4D) },
    { ZYDIS_DEFINITION(0x1, 0x8A), ZYDIS_DEFINITION(0x1, 0x87) },
    { ZYDIS_DEFINITION(0x1, 0x14A), ZYDIS_DEFINITION(0x1, 0x14B) },
    { ZYDIS_DEFINITION(0x1, 0x186), ZYDIS_DEFINITION(0x1, 0x185) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MVEX_E, 0x4E), ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0x1, 0x60), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MVEX_E, 0x4F), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MVEX_E, 0x50) },
    { ZYDIS_DEFINITION(0x1, 0x57), ZYDIS_DEFINITION(0x1, 0x54) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MVEX_E, 0x51), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MVEX_E, 0x52) },
    { ZYDIS_DEFINITION(0x1, 0x6C), ZYDIS_DEFINITION(0x1, 0x69) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MVEX_E, 0x53), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MVEX_E, 0x54) },
    { ZYDIS_DEFINITION(0x1, 0x7E), ZYDIS_DEFINITION(0x1, 0x7B) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MVEX_E, 0x55), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MVEX_E, 0x56) },
    { ZYDIS_DEFINITION(0x1, 0x90), ZYDIS_DEFINITION(0x1, 0x8D) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MVEX_E, 0x57), ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0x1, 0x120), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MVEX_E, 0x58), ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0x1, 0x11D), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MVEX_E, 0x59), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MVEX_E, 0x5A) },
    { ZYDIS_DEFINITION(0x1, 0x5D), ZYDIS_DEFINITION(0x1, 0x5A) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MVEX_E, 0x5B), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MVEX_E, 0x5C) },
    { ZYDIS_DEFINITION(0x1, 0x72), ZYDIS_DEFINITION(0x1, 0x6F) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MVEX_E, 0x5D), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MVEX_E, 0x5E) },
    { ZYDIS_DEFINITION(0x1, 0x84), ZYDIS_DEFINITION(0x1, 0x81) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MVEX_E, 0x5F), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MVEX_E, 0x60) },
    { ZYDIS_DEFINITION(0x1, 0x96), ZYDIS_DEFINITION(0x1, 0x93) },
    { ZYDIS_DEFINITION(0x1, 0x9B), ZYDIS_DEFINITION(0x1, 0x9A) },
    { ZYDIS_DEFINITION(0x1, 0x99), ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0x1, 0x9C), ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0x1, 0x189), ZYDIS_DEFINITION(0x1, 0x188) },
    { ZYDIS_DEFINITION(0x1, 0x187), ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0x1, 0x18A), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MVEX_E, 0x61), ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0x1, 0x45), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MVEX_E, 0x62), ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0x1, 0xC2), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MVEX_E, 0x63), ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0x1, 0x178), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MVEX_E, 0x64), ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0x1, 0x181), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MVEX_E, 0x65), ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0x1, 0x10), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MVEX_E, 0x66), ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0x1, 0xF0), ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0x1, 0xE1), ZYDIS_DEFINITION(0x1, 0xE4) },
    { ZYDIS_DEFINITION(0x1, 0xE3), ZYDIS_DEFINITION(0x1, 0xE2) },
    { ZYDIS_DEFINITION(0x1, 0xDD), ZYDIS_DEFINITION(0x1, 0xE0) },
    { ZYDIS_DEFINITION(0x1, 0xDF), ZYDIS_DEFINITION(0x1, 0xDE) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MVEX_E, 0x67), ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0xB, 0x12), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MVEX_E, 0x68), ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0xB, 0x118), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MVEX_E, 0x69), ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0xB, 0x113), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MVEX_E, 0x6A), ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0xB, 0x107), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MVEX_E, 0x6B), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MVEX_E, 0x6C) },
    { ZYDIS_DEFINITION(0xB, 0xA8), ZYDIS_DEFINITION(0xB, 0xA5) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MVEX_E, 0x6D), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MVEX_E, 0x6E) },
    { ZYDIS_DEFINITION(0xB, 0x17E), ZYDIS_DEFINITION(0xB, 0x17B) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MVEX_E, 0x6F), ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0xB, 0x36), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MVEX_E, 0x70), ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0xB, 0x33), ZYDIS_INVALID },
    { ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MVEX_E, 0x71) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MVEX_E, 0x72), ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0x1, 0x42), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MVEX_E, 0x73), ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0x1, 0x27), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MVEX_E, 0x74), ZYDIS_INVALID },
    { ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MVEX_E, 0x75) },
    { ZYDIS_INVALID, ZYDIS_DEFINITION(0xB, 0x30) },
    { ZYDIS_INVALID, ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MVEX_E, 0x76) },
    { ZYDIS_INVALID, ZYDIS_DEFINITION(0xB, 0x2D) },
    { ZYDIS_DEFINITION(0xB, 0x6A), ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0xB, 0x6B), ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0xB, 0x68), ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0xB, 0x69), ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0xB, 0x66), ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0xB, 0x67), ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0xB, 0x62), ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0xB, 0x63), ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0xB, 0x64), ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0xB, 0x65), ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0xB, 0x6E), ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0xB, 0x6F), ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0xB, 0x6C), ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0xB, 0x6D), ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0xB, 0x60), ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0xB, 0x61), ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0xB, 0x5C), ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0xB, 0x5D), ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0xB, 0x5E), ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0xB, 0x5F), ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0xB, 0x26), ZYDIS_DEFINITION(0xB, 0x27) },
    { ZYDIS_DEFINITION(0xB, 0x2A), ZYDIS_DEFINITION(0xB, 0x2B) },
    { ZYDIS_DEFINITION(0xB, 0x28), ZYDIS_DEFINITION(0xB, 0x29) },
    { ZYDIS_DEFINITION(0xB, 0x2C), ZYDIS_DEFINITION(0xB, 0x2D) },
    { ZYDIS_DEFINITION(0xB, 0x74), ZYDIS_DEFINITION(0xB, 0x75) },
    { ZYDIS_DEFINITION(0xB, 0x76), ZYDIS_DEFINITION(0xB, 0x77) },
    { ZYDIS_DEFINITION(0xB, 0x70), ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0xB, 0x71), ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0xB, 0x72), ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0xB, 0x73), ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0xB, 0x78), ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0xB, 0x79), ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0xB, 0x8A), ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0xB, 0x8B), ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0xB, 0x7E), ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0xB, 0x7F), ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0xB, 0x84), ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0xB, 0x85), ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0xB, 0x2E), ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0xB, 0x2F), ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0xB, 0x3C), ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0xB, 0x3D), ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0xB, 0x30), ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0xB, 0x31), ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0xB, 0x32), ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0xB, 0x33), ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0xB, 0x34), ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0xB, 0x35), ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0xB, 0x3A), ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0xB, 0x3B), ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0xB, 0x36), ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0xB, 0x37), ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0xB, 0x38), ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0xB, 0x39), ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0x1, 0x1E), ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0x1, 0x20), ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0x1, 0x1F), ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0x1, 0x21), ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0x1, 0x1A), ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0x1, 0x1C), ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0x1, 0x1B), ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0x1, 0x1D), ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0x1, 0x24), ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0x1, 0x25), ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0x1, 0x22), ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0x1, 0x23), ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0x1, 0x7A), ZYDIS_DEFINITION(0x1, 0x7B) },
    { ZYDIS_DEFINITION(0x1, 0x7C), ZYDIS_DEFINITION(0x1, 0x7D) },
    { ZYDIS_DEFINITION(0x1, 0x8C), ZYDIS_DEFINITION(0x1, 0x8D) },
    { ZYDIS_DEFINITION(0x1, 0x8E), ZYDIS_DEFINITION(0x1, 0x8F) },
    { ZYDIS_DEFINITION(0x1, 0x80), ZYDIS_DEFINITION(0x1, 0x81) },
    { ZYDIS_DEFINITION(0x1, 0x82), ZYDIS_DEFINITION(0x1, 0x83) },
    { ZYDIS_DEFINITION(0x1, 0x86), ZYDIS_DEFINITION(0x1, 0x87) },
    { ZYDIS_DEFINITION(0x1, 0x88), ZYDIS_DEFINITION(0x1, 0x89) },
    { ZYDIS_DEFINITION(0x1, 0xA0), ZYDIS_DEFINITION(0x1, 0xA1) },
    { ZYDIS_DEFINITION(0x1, 0xA2), ZYDIS_DEFINITION(0x1, 0xA3) },
    { ZYDIS_DEFINITION(0x1, 0xAC), ZYDIS_DEFINITION(0x1, 0xAD) },
    { ZYDIS_DEFINITION(0x1, 0xAE), ZYDIS_DEFINITION(0x1, 0xAF) },
    { ZYDIS_DEFINITION(0x1, 0xA4), ZYDIS_DEFINITION(0x1, 0xA5) },
    { ZYDIS_DEFINITION(0x1, 0xA6), ZYDIS_DEFINITION(0x1, 0xA7) },
    { ZYDIS_DEFINITION(0x1, 0xA8), ZYDIS_DEFINITION(0x1, 0xA9) },
    { ZYDIS_DEFINITION(0x1, 0xAA), ZYDIS_DEFINITION(0x1, 0xAB) },
    { ZYDIS_DEFINITION(0x1, 0x90), ZYDIS_DEFINITION(0x1, 0x91) },
    { ZYDIS_DEFINITION(0x1, 0x92), ZYDIS_DEFINITION(0x1, 0x93) },
    { ZYDIS_DEFINITION(0x1, 0x9C), ZYDIS_DEFINITION(0x1, 0x9D) },
    { ZYDIS_DEFINITION(0x1, 0x9E), ZYDIS_DEFINITION(0x1, 0x9F) },
    { ZYDIS_DEFINITION(0x1, 0x94), ZYDIS_DEFINITION(0x1, 0x95) },
    { ZYDIS_DEFINITION(0x1, 0x96), ZYDIS_DEFINITION(0x1, 0x97) },
    { ZYDIS_DEFINITION(0x1, 0x98), ZYDIS_DEFINITION(0x1, 0x99) },
    { ZYDIS_DEFINITION(0x1, 0x9A), ZYDIS_DEFINITION(0x1, 0x9B) },
    { ZYDIS_DEFINITION(0x1, 0x42), ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0x1, 0x43), ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0x1, 0x3E), ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0x1, 0x3F), ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0x1, 0x40), ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0x1, 0x41), ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0x1, 0x52), ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0x1, 0x53), ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0x1, 0x54), ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0x1, 0x55), ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0x1, 0x44), ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0x1, 0x45), ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0x1, 0x4A), ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0x1, 0x4B), ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0x1, 0x46), ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0x1, 0x47), ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0x1, 0x48), ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0x1, 0x49), ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0x1, 0x4E), ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0x1, 0x4F), ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0x1, 0x50), ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0x1, 0x51), ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0x1, 0x4C), ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0x1, 0x4D), ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0x1, 0x56), ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0x1, 0x57), ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0x1, 0x5A), ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0x1, 0x5B), ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0x1, 0x58), ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0x1, 0x59), ZYDIS_INVALID },
    { ZYDIS_INVALID, ZYDIS_DEFINITION(0x0, 0xB8) },
    { ZYDIS_INVALID, ZYDIS_DEFINITION(0x0, 0x119) },
    { ZYDIS_DEFINITION(0x8, 0x1A), ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0x8, 0x18), ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0x1, 0x20), ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0x1, 0x2A), ZYDIS_DEFINITION(0x1, 0x29) },
    { ZYDIS_DEFINITION(0x1, 0x23), ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0x1, 0x28), ZYDIS_DEFINITION(0x1, 0x26) },
    { ZYDIS_DEFINITION(0x1, 0x27), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODE_KNC, 0x2), ZYDIS_DEFINITION(0x1, 0x4C) },
    { ZYDIS_DEFINITION(0x1, 0x4D), ZYDIS_DEFINITION(0x1, 0x4C) },
    { ZYDIS_DEFINITION(0x1, 0x4E), ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0x1, 0x57), ZYDIS_DEFINITION(0x1, 0x51) },
    { ZYDIS_DEFINITION(0x1, 0x67), ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0x1, 0x6B), ZYDIS_DEFINITION(0x1, 0x6A) },
    { ZYDIS_DEFINITION(0x1, 0x6C), ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0x1, 0x70), ZYDIS_DEFINITION(0x1, 0x6F) },
    { ZYDIS_DEFINITION(0x1, 0x2E), ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0x1, 0x2F), ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0x1, 0x1F), ZYDIS_DEFINITION(0x1, 0x1E) },
    { ZYDIS_DEFINITION(0x1, 0x66), ZYDIS_DEFINITION(0x1, 0x65) },
    { ZYDIS_DEFINITION(0xA, 0x1B), ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0xA, 0x19), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODE_KNC, 0x3), ZYDIS_DEFINITION(0x1, 0x3F) },
    { ZYDIS_DEFINITION(0x1, 0x45), ZYDIS_DEFINITION(0x1, 0x40) },
    { ZYDIS_DEFINITION(0x1, 0x44), ZYDIS_DEFINITION(0x1, 0x3F) },
    { ZYDIS_DEFINITION(0x1, 0x45), ZYDIS_DEFINITION(0x1, 0x40) },
    { ZYDIS_DEFINITION(0x1, 0x46), ZYDIS_DEFINITION(0x1, 0x41) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODE_KNC, 0x4), ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0x1, 0x47), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODE_KNC, 0x5), ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0x1, 0x48), ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0x1, 0x2B), ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0x1, 0x2C), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODE_KNC, 0x6), ZYDIS_DEFINITION(0x1, 0x55) },
    { ZYDIS_DEFINITION(0x1, 0x56), ZYDIS_DEFINITION(0x1, 0x55) },
    { ZYDIS_DEFINITION(0x1, 0x63), ZYDIS_DEFINITION(0x1, 0x62) },
    { ZYDIS_DEFINITION(0x1, 0xAC), ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0x1, 0x71), ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0x1, 0x71), ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0x1, 0x71), ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0x1, 0x71), ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0x1, 0x71), ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0x1, 0x71), ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0x1, 0x72), ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0x1, 0x71), ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0x1, 0x451), ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0x1, 0x453), ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0x1, 0x452), ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0x1, 0x454), ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0x1, 0x455), ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0x1, 0x457), ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0x1, 0x456), ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0x1, 0x458), ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0x1, 0xA8), ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0x1, 0x125), ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0x1, 0x126), ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0x1, 0x471), ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0x1, 0x473), ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0x1, 0x472), ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0x1, 0x474), ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0x1, 0x475), ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0x1, 0x477), ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0x1, 0x476), ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0x1, 0x478), ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0x1, 0x651), ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0x1, 0x652), ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0x1, 0x0), ZYDIS_DEFINITION(0x1, 0x1) },
    { ZYDIS_DEFINITION(0x1, 0x2), ZYDIS_DEFINITION(0x1, 0x3) },
    { ZYDIS_DEFINITION(0x1, 0xE), ZYDIS_DEFINITION(0x1, 0xF) },
    { ZYDIS_DEFINITION(0x1, 0x10), ZYDIS_DEFINITION(0x1, 0x11) },
    { ZYDIS_DEFINITION(0x1, 0x21), ZYDIS_DEFINITION(0x1, 0x22) },
    { ZYDIS_DEFINITION(0x1, 0x24), ZYDIS_DEFINITION(0x1, 0x25) },
    { ZYDIS_DEFINITION(0x1, 0x4A), ZYDIS_DEFINITION(0x1, 0x4B) },
    { ZYDIS_DEFINITION(0x1, 0x4F), ZYDIS_DEFINITION(0x1, 0x50) },
    { ZYDIS_DEFINITION(0x1, 0x68), ZYDIS_DEFINITION(0x1, 0x69) },
    { ZYDIS_DEFINITION(0x1, 0x6D), ZYDIS_DEFINITION(0x1, 0x6E) },
    { ZYDIS_DEFINITION(0x1, 0x1C), ZYDIS_DEFINITION(0x1, 0x1D) },
    { ZYDIS_DEFINITION(0x1, 0x64), ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0x1, 0x329), ZYDIS_DEFINITION(0x1, 0x35B) },
    { ZYDIS_DEFINITION(0x1, 0x32A), ZYDIS_DEFINITION(0x1, 0x35C) },
    { ZYDIS_DEFINITION(0x1, 0x32D), ZYDIS_DEFINITION(0x1, 0x35D) },
    { ZYDIS_DEFINITION(0x1, 0x32E), ZYDIS_DEFINITION(0x1, 0x35E) },
    { ZYDIS_DEFINITION(0x1, 0x33), ZYDIS_DEFINITION(0x1, 0x38) },
    { ZYDIS_DEFINITION(0x1, 0x34), ZYDIS_DEFINITION(0x1, 0x39) },
    { ZYDIS_DEFINITION(0x1, 0x35), ZYDIS_DEFINITION(0x1, 0x3A) },
    { ZYDIS_DEFINITION(0x1, 0x36), ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0x1, 0x37), ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0x1, 0x53), ZYDIS_DEFINITION(0x1, 0x54) },
    { ZYDIS_DEFINITION(0x1, 0x60), ZYDIS_DEFINITION(0x1, 0x61) },
    { ZYDIS_DEFINITION(0x1, 0x497), ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0x1, 0x499), ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0x1, 0x498), ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0x1, 0x49A), ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0x1, 0x48F), ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0x1, 0x491), ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0x1, 0x490), ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0x1, 0x492), ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0x1, 0x67C), ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0x1, 0x67E), ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0x1, 0x67D), ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0x1, 0x67F), ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0x1, 0x678), ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0x1, 0x67A), ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0x1, 0x679), ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0x1, 0x67B), ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0x1, 0x133), ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0x1, 0x135), ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0x1, 0x134), ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0x1, 0x136), ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0x1, 0x4A1), ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0x1, 0x4A2), ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0x1, 0x103), ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0x1, 0x105), ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0x1, 0x104), ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0x1, 0x106), ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0x1, 0x101), ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0x1, 0x102), ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0x1, 0xFF), ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0x1, 0x2FD), ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0x1, 0x2FE), ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0x1, 0x2F9), ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0x1, 0x2FA), ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0x1, 0x2FF), ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0x1, 0x300), ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0x1, 0x2FB), ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0x1, 0x2FC), ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0x1, 0x47D), ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0x1, 0x47E), ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0x1, 0x5D8), ZYDIS_DEFINITION(0x1, 0x5DC) },
    { ZYDIS_DEFINITION(0x1, 0x5DA), ZYDIS_DEFINITION(0x1, 0x5DE) },
    { ZYDIS_DEFINITION(0x1, 0x5D9), ZYDIS_DEFINITION(0x1, 0x5DD) },
    { ZYDIS_DEFINITION(0x1, 0x5DB), ZYDIS_DEFINITION(0x1, 0x5DF) },
    { ZYDIS_DEFINITION(0x1, 0x5C0), ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0x1, 0x5C2), ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0x1, 0x5C1), ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0x1, 0x5C3), ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0x1, 0x5AC), ZYDIS_DEFINITION(0x1, 0x5B0) },
    { ZYDIS_DEFINITION(0x1, 0x5AE), ZYDIS_DEFINITION(0x1, 0x5B2) },
    { ZYDIS_DEFINITION(0x1, 0x5AD), ZYDIS_DEFINITION(0x1, 0x5B1) },
    { ZYDIS_DEFINITION(0x1, 0x5AF), ZYDIS_DEFINITION(0x1, 0x5B3) },
    { ZYDIS_DEFINITION(0x1, 0xA3), ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0x1, 0xAB), ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0x1, 0x449), ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0x1, 0x44B), ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0x1, 0x44A), ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0x1, 0x44C), ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0x1, 0x44D), ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0x1, 0x44F), ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0x1, 0x44E), ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0x1, 0x450), ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0x1, 0x459), ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0x1, 0x45B), ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0x1, 0x45A), ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0x1, 0x45C), ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0x1, 0x45D), ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0x1, 0x45F), ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0x1, 0x45E), ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0x1, 0x460), ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0x1, 0x3FB), ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0x1, 0x3FD), ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0x1, 0x3FC), ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0x1, 0x3FE), ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0x1, 0x3FF), ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0x1, 0x401), ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0x1, 0x400), ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0x1, 0x402), ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0x1, 0x100), ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0x1, 0xA7), ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0x1, 0x3F7), ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0x1, 0x3F9), ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0x1, 0x3F8), ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0x1, 0x3FA), ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0x1, 0x403), ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0x1, 0x405), ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0x1, 0x404), ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0x1, 0x406), ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0x1, 0x4EC), ZYDIS_DEFINITION(0x1, 0x4F0) },
    { ZYDIS_DEFINITION(0x1, 0x4ED), ZYDIS_DEFINITION(0x1, 0x4F1) },
    { ZYDIS_DEFINITION(0x1, 0x4EE), ZYDIS_DEFINITION(0x1, 0x4F2) },
    { ZYDIS_DEFINITION(0x1, 0x4EF), ZYDIS_DEFINITION(0x1, 0x4F3) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_ADDRESS_SIZE, 0x28), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_ADDRESS_SIZE, 0x29) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_ADDRESS_SIZE, 0x2A), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_ADDRESS_SIZE, 0x2B) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_ADDRESS_SIZE, 0x2C), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_ADDRESS_SIZE, 0x2D) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_ADDRESS_SIZE, 0x2E), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_ADDRESS_SIZE, 0x2F) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_ADDRESS_SIZE, 0x30), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_ADDRESS_SIZE, 0x31) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_ADDRESS_SIZE, 0x32), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_ADDRESS_SIZE, 0x33) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_ADDRESS_SIZE, 0x34), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_ADDRESS_SIZE, 0x35) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_ADDRESS_SIZE, 0x36), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_ADDRESS_SIZE, 0x37) },
    { ZYDIS_DEFINITION(0x1, 0x1CB), ZYDIS_DEFINITION(0x1, 0x1C7) },
    { ZYDIS_DEFINITION(0x1, 0x1CD), ZYDIS_DEFINITION(0x1, 0x1C9) },
    { ZYDIS_DEFINITION(0x1, 0x1CC), ZYDIS_DEFINITION(0x1, 0x1C8) },
    { ZYDIS_DEFINITION(0x1, 0x1CE), ZYDIS_DEFINITION(0x1, 0x1CA) },
    { ZYDIS_DEFINITION(0x1, 0x217), ZYDIS_DEFINITION(0x1, 0x213) },
    { ZYDIS_DEFINITION(0x1, 0x219), ZYDIS_DEFINITION(0x1, 0x215) },
    { ZYDIS_DEFINITION(0x1, 0x218), ZYDIS_DEFINITION(0x1, 0x214) },
    { ZYDIS_DEFINITION(0x1, 0x21A), ZYDIS_DEFINITION(0x1, 0x216) },
    { ZYDIS_DEFINITION(0x1, 0x18F), ZYDIS_DEFINITION(0x1, 0x18B) },
    { ZYDIS_DEFINITION(0x1, 0x191), ZYDIS_DEFINITION(0x1, 0x18D) },
    { ZYDIS_DEFINITION(0x1, 0x190), ZYDIS_DEFINITION(0x1, 0x18C) },
    { ZYDIS_DEFINITION(0x1, 0x192), ZYDIS_DEFINITION(0x1, 0x18E) },
    { ZYDIS_DEFINITION(0x1, 0x195), ZYDIS_DEFINITION(0x1, 0x193) },
    { ZYDIS_DEFINITION(0x1, 0x196), ZYDIS_DEFINITION(0x1, 0x194) },
    { ZYDIS_DEFINITION(0x1, 0x1F3), ZYDIS_DEFINITION(0x1, 0x1EF) },
    { ZYDIS_DEFINITION(0x1, 0x1F5), ZYDIS_DEFINITION(0x1, 0x1F1) },
    { ZYDIS_DEFINITION(0x1, 0x1F4), ZYDIS_DEFINITION(0x1, 0x1F0) },
    { ZYDIS_DEFINITION(0x1, 0x1F6), ZYDIS_DEFINITION(0x1, 0x1F2) },
    { ZYDIS_DEFINITION(0x1, 0x1F9), ZYDIS_DEFINITION(0x1, 0x1F7) },
    { ZYDIS_DEFINITION(0x1, 0x1FA), ZYDIS_DEFINITION(0x1, 0x1F8) },
    { ZYDIS_DEFINITION(0x1, 0x257), ZYDIS_DEFINITION(0x1, 0x253) },
    { ZYDIS_DEFINITION(0x1, 0x259), ZYDIS_DEFINITION(0x1, 0x255) },
    { ZYDIS_DEFINITION(0x1, 0x258), ZYDIS_DEFINITION(0x1, 0x254) },
    { ZYDIS_DEFINITION(0x1, 0x25A), ZYDIS_DEFINITION(0x1, 0x256) },
    { ZYDIS_DEFINITION(0x1, 0x25D), ZYDIS_DEFINITION(0x1, 0x25B) },
    { ZYDIS_DEFINITION(0x1, 0x25E), ZYDIS_DEFINITION(0x1, 0x25C) },
    { ZYDIS_DEFINITION(0x1, 0x293), ZYDIS_DEFINITION(0x1, 0x28F) },
    { ZYDIS_DEFINITION(0x1, 0x295), ZYDIS_DEFINITION(0x1, 0x291) },
    { ZYDIS_DEFINITION(0x1, 0x294), ZYDIS_DEFINITION(0x1, 0x290) },
    { ZYDIS_DEFINITION(0x1, 0x296), ZYDIS_DEFINITION(0x1, 0x292) },
    { ZYDIS_DEFINITION(0x1, 0x299), ZYDIS_DEFINITION(0x1, 0x297) },
    { ZYDIS_DEFINITION(0x1, 0x29A), ZYDIS_DEFINITION(0x1, 0x298) },
    { ZYDIS_DEFINITION(0x1, 0x1D3), ZYDIS_DEFINITION(0x1, 0x1CF) },
    { ZYDIS_DEFINITION(0x1, 0x1D5), ZYDIS_DEFINITION(0x1, 0x1D1) },
    { ZYDIS_DEFINITION(0x1, 0x1D4), ZYDIS_DEFINITION(0x1, 0x1D0) },
    { ZYDIS_DEFINITION(0x1, 0x1D6), ZYDIS_DEFINITION(0x1, 0x1D2) },
    { ZYDIS_DEFINITION(0x1, 0x21F), ZYDIS_DEFINITION(0x1, 0x21B) },
    { ZYDIS_DEFINITION(0x1, 0x221), ZYDIS_DEFINITION(0x1, 0x21D) },
    { ZYDIS_DEFINITION(0x1, 0x220), ZYDIS_DEFINITION(0x1, 0x21C) },
    { ZYDIS_DEFINITION(0x1, 0x222), ZYDIS_DEFINITION(0x1, 0x21E) },
    { ZYDIS_DEFINITION(0x1, 0x19B), ZYDIS_DEFINITION(0x1, 0x197) },
    { ZYDIS_DEFINITION(0x1, 0x19D), ZYDIS_DEFINITION(0x1, 0x199) },
    { ZYDIS_DEFINITION(0x1, 0x19C), ZYDIS_DEFINITION(0x1, 0x198) },
    { ZYDIS_DEFINITION(0x1, 0x19E), ZYDIS_DEFINITION(0x1, 0x19A) },
    { ZYDIS_DEFINITION(0x1, 0x1A1), ZYDIS_DEFINITION(0x1, 0x19F) },
    { ZYDIS_DEFINITION(0x1, 0x1A2), ZYDIS_DEFINITION(0x1, 0x1A0) },
    { ZYDIS_DEFINITION(0x1, 0x1FF), ZYDIS_DEFINITION(0x1, 0x1FB) },
    { ZYDIS_DEFINITION(0x1, 0x201), ZYDIS_DEFINITION(0x1, 0x1FD) },
    { ZYDIS_DEFINITION(0x1, 0x200), ZYDIS_DEFINITION(0x1, 0x1FC) },
    { ZYDIS_DEFINITION(0x1, 0x202), ZYDIS_DEFINITION(0x1, 0x1FE) },
    { ZYDIS_DEFINITION(0x1, 0x205), ZYDIS_DEFINITION(0x1, 0x203) },
    { ZYDIS_DEFINITION(0x1, 0x206), ZYDIS_DEFINITION(0x1, 0x204) },
    { ZYDIS_DEFINITION(0x1, 0x263), ZYDIS_DEFINITION(0x1, 0x25F) },
    { ZYDIS_DEFINITION(0x1, 0x265), ZYDIS_DEFINITION(0x1, 0x261) },
    { ZYDIS_DEFINITION(0x1, 0x264), ZYDIS_DEFINITION(0x1, 0x260) },
    { ZYDIS_DEFINITION(0x1, 0x266), ZYDIS_DEFINITION(0x1, 0x262) },
    { ZYDIS_DEFINITION(0x1, 0x269), ZYDIS_DEFINITION(0x1, 0x267) },
    { ZYDIS_DEFINITION(0x1, 0x26A), ZYDIS_DEFINITION(0x1, 0x268) },
    { ZYDIS_DEFINITION(0x1, 0x29F), ZYDIS_DEFINITION(0x1, 0x29B) },
    { ZYDIS_DEFINITION(0x1, 0x2A1), ZYDIS_DEFINITION(0x1, 0x29D) },
    { ZYDIS_DEFINITION(0x1, 0x2A0), ZYDIS_DEFINITION(0x1, 0x29C) },
    { ZYDIS_DEFINITION(0x1, 0x2A2), ZYDIS_DEFINITION(0x1, 0x29E) },
    { ZYDIS_DEFINITION(0x1, 0x2A5), ZYDIS_DEFINITION(0x1, 0x2A3) },
    { ZYDIS_DEFINITION(0x1, 0x2A6), ZYDIS_DEFINITION(0x1, 0x2A4) },
    { ZYDIS_DEFINITION(0x1, 0x121), ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0x1, 0x122), ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0x1, 0xED), ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0x1, 0xEE), ZYDIS_INVALID },
    { ZYDIS_INVALID, ZYDIS_DEFINITION(0x1, 0x4E0) },
    { ZYDIS_INVALID, ZYDIS_DEFINITION(0x1, 0x4E2) },
    { ZYDIS_INVALID, ZYDIS_DEFINITION(0x1, 0x4E1) },
    { ZYDIS_INVALID, ZYDIS_DEFINITION(0x1, 0x4E3) },
    { ZYDIS_INVALID, ZYDIS_DEFINITION(0x1, 0x4DC) },
    { ZYDIS_INVALID, ZYDIS_DEFINITION(0x1, 0x4DE) },
    { ZYDIS_INVALID, ZYDIS_DEFINITION(0x1, 0x4DD) },
    { ZYDIS_INVALID, ZYDIS_DEFINITION(0x1, 0x4DF) },
    { ZYDIS_DEFINITION(0x1, 0x1DB), ZYDIS_DEFINITION(0x1, 0x1D7) },
    { ZYDIS_DEFINITION(0x1, 0x1DD), ZYDIS_DEFINITION(0x1, 0x1D9) },
    { ZYDIS_DEFINITION(0x1, 0x1DC), ZYDIS_DEFINITION(0x1, 0x1D8) },
    { ZYDIS_DEFINITION(0x1, 0x1DE), ZYDIS_DEFINITION(0x1, 0x1DA) },
    { ZYDIS_DEFINITION(0x1, 0x227), ZYDIS_DEFINITION(0x1, 0x223) },
    { ZYDIS_DEFINITION(0x1, 0x229), ZYDIS_DEFINITION(0x1, 0x225) },
    { ZYDIS_DEFINITION(0x1, 0x228), ZYDIS_DEFINITION(0x1, 0x224) },
    { ZYDIS_DEFINITION(0x1, 0x22A), ZYDIS_DEFINITION(0x1, 0x226) },
    { ZYDIS_DEFINITION(0x1, 0x1A7), ZYDIS_DEFINITION(0x1, 0x1A3) },
    { ZYDIS_DEFINITION(0x1, 0x1A9), ZYDIS_DEFINITION(0x1, 0x1A5) },
    { ZYDIS_DEFINITION(0x1, 0x1A8), ZYDIS_DEFINITION(0x1, 0x1A4) },
    { ZYDIS_DEFINITION(0x1, 0x1AA), ZYDIS_DEFINITION(0x1, 0x1A6) },
    { ZYDIS_DEFINITION(0x1, 0x1AD), ZYDIS_DEFINITION(0x1, 0x1AB) },
    { ZYDIS_DEFINITION(0x1, 0x1AE), ZYDIS_DEFINITION(0x1, 0x1AC) },
    { ZYDIS_DEFINITION(0x1, 0x20B), ZYDIS_DEFINITION(0x1, 0x207) },
    { ZYDIS_DEFINITION(0x1, 0x20D), ZYDIS_DEFINITION(0x1, 0x209) },
    { ZYDIS_DEFINITION(0x1, 0x20C), ZYDIS_DEFINITION(0x1, 0x208) },
    { ZYDIS_DEFINITION(0x1, 0x20E), ZYDIS_DEFINITION(0x1, 0x20A) },
    { ZYDIS_DEFINITION(0x1, 0x211), ZYDIS_DEFINITION(0x1, 0x20F) },
    { ZYDIS_DEFINITION(0x1, 0x212), ZYDIS_DEFINITION(0x1, 0x210) },
    { ZYDIS_DEFINITION(0x1, 0x26F), ZYDIS_DEFINITION(0x1, 0x26B) },
    { ZYDIS_DEFINITION(0x1, 0x271), ZYDIS_DEFINITION(0x1, 0x26D) },
    { ZYDIS_DEFINITION(0x1, 0x270), ZYDIS_DEFINITION(0x1, 0x26C) },
    { ZYDIS_DEFINITION(0x1, 0x272), ZYDIS_DEFINITION(0x1, 0x26E) },
    { ZYDIS_DEFINITION(0x1, 0x275), ZYDIS_DEFINITION(0x1, 0x273) },
    { ZYDIS_DEFINITION(0x1, 0x276), ZYDIS_DEFINITION(0x1, 0x274) },
    { ZYDIS_DEFINITION(0x1, 0x2AB), ZYDIS_DEFINITION(0x1, 0x2A7) },
    { ZYDIS_DEFINITION(0x1, 0x2AD), ZYDIS_DEFINITION(0x1, 0x2A9) },
    { ZYDIS_DEFINITION(0x1, 0x2AC), ZYDIS_DEFINITION(0x1, 0x2A8) },
    { ZYDIS_DEFINITION(0x1, 0x2AE), ZYDIS_DEFINITION(0x1, 0x2AA) },
    { ZYDIS_DEFINITION(0x1, 0x2B1), ZYDIS_DEFINITION(0x1, 0x2AF) },
    { ZYDIS_DEFINITION(0x1, 0x2B2), ZYDIS_DEFINITION(0x1, 0x2B0) },
    { ZYDIS_DEFINITION(0x1, 0x2DB), ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0x1, 0x2DD), ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0x1, 0x2DC), ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0x1, 0x2DE), ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0x1, 0x469), ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0x1, 0x46B), ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0x1, 0x46A), ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0x1, 0x46C), ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0x1, 0x46D), ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0x1, 0x46F), ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0x1, 0x46E), ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0x1, 0x470), ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0x1, 0x653), ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0x1, 0x654), ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0x1, 0x95), ZYDIS_DEFINITION(0x1, 0x96) },
    { ZYDIS_DEFINITION(0x1, 0x97), ZYDIS_DEFINITION(0x1, 0x98) },
    { ZYDIS_INVALID, ZYDIS_DEFINITION(0xB, 0x4A3) },
    { ZYDIS_INVALID, ZYDIS_DEFINITION(0xB, 0x4A4) },
    { ZYDIS_INVALID, ZYDIS_DEFINITION(0xB, 0x49F) },
    { ZYDIS_INVALID, ZYDIS_DEFINITION(0xB, 0x4A0) },
    { ZYDIS_DEFINITION(0xB, 0x3EB), ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0xB, 0x3ED), ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0xB, 0x3EC), ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0xB, 0x3EE), ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0xB, 0x49B), ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0xB, 0x49D), ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0xB, 0x49C), ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0xB, 0x49E), ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0xB, 0x493), ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0xB, 0x495), ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0xB, 0x494), ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0xB, 0x496), ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0xB, 0x479), ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0xB, 0x47A), ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0xB, 0x4A7), ZYDIS_DEFINITION(0xB, 0x4AB) },
    { ZYDIS_DEFINITION(0xB, 0x4A8), ZYDIS_DEFINITION(0xB, 0x4AC) },
    { ZYDIS_DEFINITION(0xB, 0x2EF), ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0xB, 0x2F0), ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0xB, 0x185), ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0xB, 0x186), ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0xB, 0x13F), ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0xB, 0x141), ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0xB, 0x140), ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0xB, 0x142), ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0xB, 0x4D4), ZYDIS_DEFINITION(0xB, 0x4D8) },
    { ZYDIS_DEFINITION(0xB, 0x4D5), ZYDIS_DEFINITION(0xB, 0x4D9) },
    { ZYDIS_DEFINITION(0xB, 0x5C), ZYDIS_DEFINITION(0xB, 0x5F) },
    { ZYDIS_DEFINITION(0xB, 0x5D), ZYDIS_DEFINITION(0xB, 0x5E) },
    { ZYDIS_DEFINITION(0xB, 0x58), ZYDIS_DEFINITION(0xB, 0x5B) },
    { ZYDIS_DEFINITION(0xB, 0x59), ZYDIS_DEFINITION(0xB, 0x5A) },
    { ZYDIS_DEFINITION(0xB, 0x2F1), ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0xB, 0x2F2), ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0xB, 0x187), ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0xB, 0x188), ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0xB, 0x2D), ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0xB, 0x47B), ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0xB, 0x47C), ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0xB, 0x487), ZYDIS_DEFINITION(0xB, 0x488) },
    { ZYDIS_DEFINITION(0xB, 0x48B), ZYDIS_DEFINITION(0xB, 0x48C) },
    { ZYDIS_DEFINITION(0xB, 0x489), ZYDIS_DEFINITION(0xB, 0x48A) },
    { ZYDIS_DEFINITION(0xB, 0x48D), ZYDIS_DEFINITION(0xB, 0x48E) },
    { ZYDIS_DEFINITION(0xB, 0x47F), ZYDIS_DEFINITION(0xB, 0x480) },
    { ZYDIS_DEFINITION(0xB, 0x483), ZYDIS_DEFINITION(0xB, 0x484) },
    { ZYDIS_DEFINITION(0xB, 0x481), ZYDIS_DEFINITION(0xB, 0x482) },
    { ZYDIS_DEFINITION(0xB, 0x485), ZYDIS_DEFINITION(0xB, 0x486) },
    { ZYDIS_DEFINITION(0xB, 0xFB), ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0xB, 0xFD), ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0xB, 0xFC), ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0xB, 0xFE), ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0xB, 0xF7), ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0xB, 0xF9), ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0xB, 0xF8), ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0xB, 0xFA), ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0xB, 0x3EF), ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0xB, 0x3F1), ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0xB, 0x3F0), ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0xB, 0x3F2), ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0xB, 0x1E7), ZYDIS_DEFINITION(0xB, 0x1E8) },
    { ZYDIS_DEFINITION(0xB, 0x1EB), ZYDIS_DEFINITION(0xB, 0x1EC) },
    { ZYDIS_DEFINITION(0xB, 0x1E9), ZYDIS_DEFINITION(0xB, 0x1EA) },
    { ZYDIS_DEFINITION(0xB, 0x1ED), ZYDIS_DEFINITION(0xB, 0x1EE) },
    { ZYDIS_DEFINITION(0xB, 0x1DF), ZYDIS_DEFINITION(0xB, 0x1E0) },
    { ZYDIS_DEFINITION(0xB, 0x1E3), ZYDIS_DEFINITION(0xB, 0x1E4) },
    { ZYDIS_DEFINITION(0xB, 0x1E1), ZYDIS_DEFINITION(0xB, 0x1E2) },
    { ZYDIS_DEFINITION(0xB, 0x1E5), ZYDIS_DEFINITION(0xB, 0x1E6) },
    { ZYDIS_DEFINITION(0xB, 0x233), ZYDIS_DEFINITION(0xB, 0x234) },
    { ZYDIS_DEFINITION(0xB, 0x237), ZYDIS_DEFINITION(0xB, 0x238) },
    { ZYDIS_DEFINITION(0xB, 0x235), ZYDIS_DEFINITION(0xB, 0x236) },
    { ZYDIS_DEFINITION(0xB, 0x239), ZYDIS_DEFINITION(0xB, 0x23A) },
    { ZYDIS_DEFINITION(0xB, 0x22B), ZYDIS_DEFINITION(0xB, 0x22C) },
    { ZYDIS_DEFINITION(0xB, 0x22F), ZYDIS_DEFINITION(0xB, 0x230) },
    { ZYDIS_DEFINITION(0xB, 0x22D), ZYDIS_DEFINITION(0xB, 0x22E) },
    { ZYDIS_DEFINITION(0xB, 0x231), ZYDIS_DEFINITION(0xB, 0x232) },
    { ZYDIS_DEFINITION(0xB, 0x41F), ZYDIS_DEFINITION(0xB, 0x420) },
    { ZYDIS_DEFINITION(0xB, 0x421), ZYDIS_DEFINITION(0xB, 0x422) },
    { ZYDIS_DEFINITION(0xB, 0x41B), ZYDIS_DEFINITION(0xB, 0x41C) },
    { ZYDIS_DEFINITION(0xB, 0x41D), ZYDIS_DEFINITION(0xB, 0x41E) },
    { ZYDIS_DEFINITION(0xB, 0x1B7), ZYDIS_DEFINITION(0xB, 0x1B8) },
    { ZYDIS_DEFINITION(0xB, 0x1BB), ZYDIS_DEFINITION(0xB, 0x1BC) },
    { ZYDIS_DEFINITION(0xB, 0x1B9), ZYDIS_DEFINITION(0xB, 0x1BA) },
    { ZYDIS_DEFINITION(0xB, 0x1BD), ZYDIS_DEFINITION(0xB, 0x1BE) },
    { ZYDIS_DEFINITION(0xB, 0x1AF), ZYDIS_DEFINITION(0xB, 0x1B0) },
    { ZYDIS_DEFINITION(0xB, 0x1B3), ZYDIS_DEFINITION(0xB, 0x1B4) },
    { ZYDIS_DEFINITION(0xB, 0x1B1), ZYDIS_DEFINITION(0xB, 0x1B2) },
    { ZYDIS_DEFINITION(0xB, 0x1B5), ZYDIS_DEFINITION(0xB, 0x1B6) },
    { ZYDIS_DEFINITION(0xB, 0x1C3), ZYDIS_DEFINITION(0xB, 0x1C4) },
    { ZYDIS_DEFINITION(0xB, 0x1C5), ZYDIS_DEFINITION(0xB, 0x1C6) },
    { ZYDIS_DEFINITION(0xB, 0x1BF), ZYDIS_DEFINITION(0xB, 0x1C0) },
    { ZYDIS_DEFINITION(0xB, 0x1C1), ZYDIS_DEFINITION(0xB, 0x1C2) },
    { ZYDIS_DEFINITION(0xB, 0x243), ZYDIS_DEFINITION(0xB, 0x244) },
    { ZYDIS_DEFINITION(0xB, 0x247), ZYDIS_DEFINITION(0xB, 0x248) },
    { ZYDIS_DEFINITION(0xB, 0x245), ZYDIS_DEFINITION(0xB, 0x246) },
    { ZYDIS_DEFINITION(0xB, 0x249), ZYDIS_DEFINITION(0xB, 0x24A) },
    { ZYDIS_DEFINITION(0xB, 0x23B), ZYDIS_DEFINITION(0xB, 0x23C) },
    { ZYDIS_DEFINITION(0xB, 0x23F), ZYDIS_DEFINITION(0xB, 0x240) },
    { ZYDIS_DEFINITION(0xB, 0x23D), ZYDIS_DEFINITION(0xB, 0x23E) },
    { ZYDIS_DEFINITION(0xB, 0x241), ZYDIS_DEFINITION(0xB, 0x242) },
    { ZYDIS_DEFINITION(0xB, 0x24F), ZYDIS_DEFINITION(0xB, 0x250) },
    { ZYDIS_DEFINITION(0xB, 0x251), ZYDIS_DEFINITION(0xB, 0x252) },
    { ZYDIS_DEFINITION(0xB, 0x24B), ZYDIS_DEFINITION(0xB, 0x24C) },
    { ZYDIS_DEFINITION(0xB, 0x24D), ZYDIS_DEFINITION(0xB, 0x24E) },
    { ZYDIS_DEFINITION(0xB, 0x27F), ZYDIS_DEFINITION(0xB, 0x280) },
    { ZYDIS_DEFINITION(0xB, 0x283), ZYDIS_DEFINITION(0xB, 0x284) },
    { ZYDIS_DEFINITION(0xB, 0x281), ZYDIS_DEFINITION(0xB, 0x282) },
    { ZYDIS_DEFINITION(0xB, 0x285), ZYDIS_DEFINITION(0xB, 0x286) },
    { ZYDIS_DEFINITION(0xB, 0x277), ZYDIS_DEFINITION(0xB, 0x278) },
    { ZYDIS_DEFINITION(0xB, 0x27B), ZYDIS_DEFINITION(0xB, 0x27C) },
    { ZYDIS_DEFINITION(0xB, 0x279), ZYDIS_DEFINITION(0xB, 0x27A) },
    { ZYDIS_DEFINITION(0xB, 0x27D), ZYDIS_DEFINITION(0xB, 0x27E) },
    { ZYDIS_DEFINITION(0xB, 0x28B), ZYDIS_DEFINITION(0xB, 0x28C) },
    { ZYDIS_DEFINITION(0xB, 0x28D), ZYDIS_DEFINITION(0xB, 0x28E) },
    { ZYDIS_DEFINITION(0xB, 0x287), ZYDIS_DEFINITION(0xB, 0x288) },
    { ZYDIS_DEFINITION(0xB, 0x289), ZYDIS_DEFINITION(0xB, 0x28A) },
    { ZYDIS_DEFINITION(0xB, 0x2BB), ZYDIS_DEFINITION(0xB, 0x2BC) },
    { ZYDIS_DEFINITION(0xB, 0x2BF), ZYDIS_DEFINITION(0xB, 0x2C0) },
    { ZYDIS_DEFINITION(0xB, 0x2BD), ZYDIS_DEFINITION(0xB, 0x2BE) },
    { ZYDIS_DEFINITION(0xB, 0x2C1), ZYDIS_DEFINITION(0xB, 0x2C2) },
    { ZYDIS_DEFINITION(0xB, 0x2B3), ZYDIS_DEFINITION(0xB, 0x2B4) },
    { ZYDIS_DEFINITION(0xB, 0x2B7), ZYDIS_DEFINITION(0xB, 0x2B8) },
    { ZYDIS_DEFINITION(0xB, 0x2B5), ZYDIS_DEFINITION(0xB, 0x2B6) },
    { ZYDIS_DEFINITION(0xB, 0x2B9), ZYDIS_DEFINITION(0xB, 0x2BA) },
    { ZYDIS_DEFINITION(0xB, 0x2C7), ZYDIS_DEFINITION(0xB, 0x2C8) },
    { ZYDIS_DEFINITION(0xB, 0x2C9), ZYDIS_DEFINITION(0xB, 0x2CA) },
    { ZYDIS_DEFINITION(0xB, 0x2C3), ZYDIS_DEFINITION(0xB, 0x2C4) },
    { ZYDIS_DEFINITION(0xB, 0x2C5), ZYDIS_DEFINITION(0xB, 0x2C6) },
    { ZYDIS_INVALID, ZYDIS_DEFINITION(0xB, 0x2D7) },
    { ZYDIS_INVALID, ZYDIS_DEFINITION(0xB, 0x2D9) },
    { ZYDIS_INVALID, ZYDIS_DEFINITION(0xB, 0x2D8) },
    { ZYDIS_INVALID, ZYDIS_DEFINITION(0xB, 0x2DA) },
    { ZYDIS_INVALID, ZYDIS_DEFINITION(0xB, 0x2D3) },
    { ZYDIS_INVALID, ZYDIS_DEFINITION(0xB, 0x2D5) },
    { ZYDIS_INVALID, ZYDIS_DEFINITION(0xB, 0x2D4) },
    { ZYDIS_INVALID, ZYDIS_DEFINITION(0xB, 0x2D6) },
    { ZYDIS_DEFINITION(0xB, 0x655), ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0xB, 0x656), ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0x1, 0x151), ZYDIS_DEFINITION(0x1, 0x152) },
    { ZYDIS_DEFINITION(0x1, 0x153), ZYDIS_DEFINITION(0x1, 0x154) },
    { ZYDIS_DEFINITION(0x1, 0x16D), ZYDIS_DEFINITION(0x1, 0x16E) },
    { ZYDIS_DEFINITION(0x1, 0x16F), ZYDIS_DEFINITION(0x1, 0x170) },
    { ZYDIS_DEFINITION(0x1, 0x159), ZYDIS_DEFINITION(0x1, 0x15A) },
    { ZYDIS_DEFINITION(0x1, 0x15B), ZYDIS_DEFINITION(0x1, 0x15C) },
    { ZYDIS_DEFINITION(0x1, 0x16), ZYDIS_DEFINITION(0x1, 0x17) },
    { ZYDIS_DEFINITION(0x1, 0x87), ZYDIS_DEFINITION(0x1, 0x88) },
    { ZYDIS_DEFINITION(0x1, 0xAF), ZYDIS_DEFINITION(0x1, 0xB0) },
    { ZYDIS_DEFINITION(0x1, 0x73), ZYDIS_DEFINITION(0x1, 0x74) },
    { ZYDIS_DEFINITION(0x1, 0xAD), ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0x1, 0x441), ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0x1, 0x443), ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0x1, 0x442), ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0x1, 0x444), ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0x1, 0x445), ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0x1, 0x447), ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0x1, 0x446), ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0x1, 0x448), ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0x1, 0xA4), ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0x1, 0xA6), ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0x1, 0x127), ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0x1, 0x129), ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0x1, 0x128), ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0x1, 0x12A), ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0x1, 0x11F), ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0x1, 0x120), ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0x1, 0xEB), ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0x1, 0xEC), ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0x1, 0x461), ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0x1, 0x463), ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0x1, 0x462), ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0x1, 0x464), ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0x1, 0x465), ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0x1, 0x467), ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0x1, 0x466), ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0x1, 0x468), ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0x1, 0x657), ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0x1, 0x659), ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0x1, 0x658), ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0x1, 0x65A), ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0x1, 0x81), ZYDIS_DEFINITION(0x1, 0x82) },
    { ZYDIS_DEFINITION(0x1, 0x83), ZYDIS_DEFINITION(0x1, 0x84) },
    { ZYDIS_DEFINITION(0x1, 0x8F), ZYDIS_DEFINITION(0x1, 0x90) },
    { ZYDIS_DEFINITION(0x1, 0x91), ZYDIS_DEFINITION(0x1, 0x92) },
    { ZYDIS_DEFINITION(0x1, 0x14B), ZYDIS_DEFINITION(0x1, 0x14C) },
    { ZYDIS_DEFINITION(0x1, 0x14D), ZYDIS_DEFINITION(0x1, 0x14E) },
    { ZYDIS_DEFINITION(0x1, 0x167), ZYDIS_DEFINITION(0x1, 0x168) },
    { ZYDIS_DEFINITION(0x1, 0x169), ZYDIS_DEFINITION(0x1, 0x16A) },
    { ZYDIS_DEFINITION(0x1, 0x143), ZYDIS_DEFINITION(0x1, 0x144) },
    { ZYDIS_DEFINITION(0x1, 0x145), ZYDIS_DEFINITION(0x1, 0x146) },
    { ZYDIS_DEFINITION(0x1, 0x3B), ZYDIS_DEFINITION(0x1, 0x42) },
    { ZYDIS_DEFINITION(0x1, 0x3D), ZYDIS_DEFINITION(0x1, 0x43) },
    { ZYDIS_DEFINITION(0x1, 0xA1), ZYDIS_DEFINITION(0x1, 0xA2) },
    { ZYDIS_DEFINITION(0x1, 0xB1), ZYDIS_DEFINITION(0x1, 0xB2) },
    { ZYDIS_DEFINITION(0x1, 0xAE), ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0x1, 0xAA), ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0x1, 0x439), ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0x1, 0x43B), ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0x1, 0x43A), ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0x1, 0x43C), ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0x1, 0x43D), ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0x1, 0x43F), ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0x1, 0x43E), ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0x1, 0x440), ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0x1, 0xA9), ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0x1, 0xA5), ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0x1, 0x123), ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0x1, 0x124), ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0x1, 0x648), ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0x1, 0x646), ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0x1, 0x647), ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0x1, 0x65B), ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0x1, 0x65D), ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0x1, 0x65C), ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0x1, 0x65E), ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0x1, 0x7B), ZYDIS_DEFINITION(0x1, 0x7C) },
    { ZYDIS_DEFINITION(0x1, 0x7D), ZYDIS_DEFINITION(0x1, 0x7E) },
    { ZYDIS_DEFINITION(0x1, 0x75), ZYDIS_DEFINITION(0x1, 0x76) },
    { ZYDIS_DEFINITION(0x1, 0x77), ZYDIS_DEFINITION(0x1, 0x78) },
    { ZYDIS_DEFINITION(0x1, 0x9B), ZYDIS_DEFINITION(0x1, 0x9C) },
    { ZYDIS_DEFINITION(0x1, 0x9D), ZYDIS_DEFINITION(0x1, 0x9E) },
    { ZYDIS_DEFINITION(0xB, 0x89), ZYDIS_DEFINITION(0xB, 0x8A) },
    { ZYDIS_DEFINITION(0xB, 0x8B), ZYDIS_DEFINITION(0xB, 0x8C) }
};

const ZydisDecoderTreeNode FILTERS_REX_B[][2] =
{
    { ZYDIS_DEFINITION(0x0, 0x3B6), ZYDIS_DEFINITION(0x0, 0x76A) }
};

#ifndef ZYDIS_DISABLE_AVX512
const ZydisDecoderTreeNode FILTERS_EVEX_B[][2] =
{
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x0), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x1), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x2), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x3), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x4), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x5), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x6), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x7), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x9), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0xB), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0xC), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0xD), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0xE), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0xF), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x10), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x11), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x12), ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0x1, 0xE15), ZYDIS_DEFINITION(0x1, 0xE16) },
    { ZYDIS_DEFINITION(0x1, 0xE17), ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0x1, 0xAE), ZYDIS_DEFINITION(0x1, 0xAF) },
    { ZYDIS_DEFINITION(0x1, 0xB0), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x13), ZYDIS_DEFINITION(0x1, 0xDE1) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x15), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x17), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x19), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x1B), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x1D), ZYDIS_DEFINITION(0x1, 0x12) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x1F), ZYDIS_DEFINITION(0x1, 0x6ED) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x21), ZYDIS_DEFINITION(0x1, 0x14E) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x23), ZYDIS_DEFINITION(0x1, 0xCB) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x24), ZYDIS_DEFINITION(0x1, 0x186) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x27), ZYDIS_DEFINITION(0x1, 0xDFF) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x29), ZYDIS_DEFINITION(0x1, 0x60F) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x2B), ZYDIS_DEFINITION(0x1, 0x2EB) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x2D), ZYDIS_DEFINITION(0x1, 0x5F1) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x2F), ZYDIS_DEFINITION(0x1, 0x242) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x30), ZYDIS_DEFINITION(0x1, 0x1FC) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x33), ZYDIS_DEFINITION(0x1, 0x16A) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x34), ZYDIS_DEFINITION(0x1, 0xFA) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x37), ZYDIS_DEFINITION(0xB, 0x98) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x39), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x3B), ZYDIS_DEFINITION(0xB, 0xD4A) },
    { ZYDIS_DEFINITION(0xB, 0xD5B), ZYDIS_DEFINITION(0xB, 0xD5C) },
    { ZYDIS_DEFINITION(0xB, 0xD5D), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x3D), ZYDIS_DEFINITION(0xB, 0x5A0) },
    { ZYDIS_DEFINITION(0xB, 0x5B1), ZYDIS_DEFINITION(0xB, 0x5B2) },
    { ZYDIS_DEFINITION(0xB, 0x5B3), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x3F), ZYDIS_DEFINITION(0xB, 0xD2C) },
    { ZYDIS_DEFINITION(0xB, 0xD3D), ZYDIS_DEFINITION(0xB, 0xD3E) },
    { ZYDIS_DEFINITION(0xB, 0xD3F), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x41), ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0xB, 0x563), ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0xB, 0x564), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x43), ZYDIS_DEFINITION(0xB, 0x91) },
    { ZYDIS_DEFINITION(0x1, 0x1D9), ZYDIS_DEFINITION(0x1, 0x1DA) },
    { ZYDIS_DEFINITION(0x1, 0x1DB), ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0x1, 0xE12), ZYDIS_DEFINITION(0x1, 0xE13) },
    { ZYDIS_DEFINITION(0x1, 0xE14), ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0x1, 0xAB), ZYDIS_DEFINITION(0x1, 0xAC) },
    { ZYDIS_DEFINITION(0x1, 0xAD), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x45), ZYDIS_DEFINITION(0x1, 0xDDA) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x47), ZYDIS_DEFINITION(0x1, 0xB) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x49), ZYDIS_DEFINITION(0x1, 0x6E6) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x4B), ZYDIS_DEFINITION(0x1, 0x10F) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x4D), ZYDIS_DEFINITION(0x1, 0xC4) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x4E), ZYDIS_DEFINITION(0x1, 0x17F) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x51), ZYDIS_DEFINITION(0x1, 0xDF8) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x53), ZYDIS_DEFINITION(0x1, 0x608) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x55), ZYDIS_DEFINITION(0x1, 0x2E4) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x57), ZYDIS_DEFINITION(0x1, 0x5EA) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x59), ZYDIS_DEFINITION(0x1, 0x218) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x5B), ZYDIS_DEFINITION(0x1, 0x12B) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x5D), ZYDIS_DEFINITION(0x1, 0x226) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x5F), ZYDIS_DEFINITION(0x1, 0x139) },
    { ZYDIS_DEFINITION(0x1, 0x1B1), ZYDIS_DEFINITION(0x1, 0x1B2) },
    { ZYDIS_DEFINITION(0x1, 0x1B3), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x61), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x62), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x63), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x64), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x65), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x66), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x67), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x69), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x6B), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x6C), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x6D), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x6E), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x6F), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x70), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x71), ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0x1, 0xE0F), ZYDIS_DEFINITION(0x1, 0xE10) },
    { ZYDIS_DEFINITION(0x1, 0xE11), ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0x1, 0xA8), ZYDIS_DEFINITION(0x1, 0xA9) },
    { ZYDIS_DEFINITION(0x1, 0xAA), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x72), ZYDIS_DEFINITION(0x1, 0xDD3) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x74), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x76), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x78), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x7A), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x7C), ZYDIS_DEFINITION(0x1, 0x4) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x7E), ZYDIS_DEFINITION(0x1, 0x6DF) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x80), ZYDIS_DEFINITION(0x1, 0xEC) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x82), ZYDIS_DEFINITION(0x1, 0x147) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x84), ZYDIS_DEFINITION(0x1, 0xDF1) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x86), ZYDIS_DEFINITION(0x1, 0x601) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x88), ZYDIS_DEFINITION(0x1, 0x2DD) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x8A), ZYDIS_DEFINITION(0x1, 0x5E3) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x8C), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x8D), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x8E), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x8F), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x90), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x92), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x93), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x94), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x95), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x96), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x97), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x98), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x9A), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x9B), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x9C), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x9D), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x9E), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x9F), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0xA0), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0xA2), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0xA4), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0xA6), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0xA8), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0xA9), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0xAA), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0xAB), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0xAC), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0xAD), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0xAE), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0xAF), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0xB0), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0xB1), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0xB2), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0xB4), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0xB5), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0xB6), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0xB7), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0xB8), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0xB9), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0xBA), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0xBB), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0xBC), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0xBD), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0xBE), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0xBF), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0xC0), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0xC1), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0xCA), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0xCB), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0xCC), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0xCD), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0xCF), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0xD1), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0xD2), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0xD3), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0xD4), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0xD5), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0xD6), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0xD8), ZYDIS_DEFINITION(0x1, 0x249) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0xD9), ZYDIS_DEFINITION(0x1, 0x203) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0xDC), ZYDIS_DEFINITION(0x1, 0x171) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0xDD), ZYDIS_DEFINITION(0x1, 0x101) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0xE0), ZYDIS_DEFINITION(0x1, 0x23B) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0xE1), ZYDIS_DEFINITION(0x1, 0x1F5) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0xE4), ZYDIS_DEFINITION(0x1, 0x163) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0xE5), ZYDIS_DEFINITION(0x1, 0xF3) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0xE8), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0xE9), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0xEA), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0xEB), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0xEC), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0xED), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0xEE), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0xEF), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0xF0), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0xF1), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0xF2), ZYDIS_DEFINITION(0xB, 0x8A) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0xF4), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0xF5), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0xF6), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0xF7), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0xF9), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0xFA), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0xFB), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0xFC), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0xFD), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0xFE), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0xFF), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x101), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x102), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x103), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x104), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x105), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x106), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x107), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x108), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x109), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x10A), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x10B), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x10C), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x10F), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x110), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x111), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x112), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x113), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x114), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x115), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x116), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x119), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x11A), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x11B), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x11C), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x11D), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x11E), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x11F), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x120), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x121), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x122), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x123), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x124), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x125), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x126), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x127), ZYDIS_DEFINITION(0x1, 0x1EE) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x129), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x12A), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x12B), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x12C), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x12D), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x12E), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x12F), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x130), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x131), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x134), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x135), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x136), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x137), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x138), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x139), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x13A), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x13B), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x13E), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x13F), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x140), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x141), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x142), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x143), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x144), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x146), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x147), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x148), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x149), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x14A), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x14B), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x14C), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x14D), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x14E), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x150), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x152), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x153), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x154), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x155), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x156), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x158), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x159), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x15A), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x15B), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x15C), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x15D), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x15E), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x160), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x162), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x163), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x164), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x165), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x166), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x167), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x168), ZYDIS_DEFINITION(0x1, 0x116) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x169), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x16A), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x16B), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x16E), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x16F), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x172), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x173), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x176), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x177), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x178), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x179), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x17A), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x17B), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x17C), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x17D), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x17E), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x17F), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x180), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x181), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x182), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x183), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x184), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x186), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x188), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x189), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x18A), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x18B), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x18C), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x18D), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x18E), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x18F), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x190), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x191), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x192), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x193), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x194), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x195), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x196), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x197), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x198), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x199), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x19C), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x19E), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x1A0), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x1A1), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x1A3), ZYDIS_DEFINITION(0x1, 0xD93) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x1A4), ZYDIS_DEFINITION(0x1, 0xD85) },
    { ZYDIS_DEFINITION(0x1, 0xDA0), ZYDIS_DEFINITION(0x1, 0xDA1) },
    { ZYDIS_DEFINITION(0x1, 0xD9A), ZYDIS_DEFINITION(0x1, 0xD9B) },
    { ZYDIS_DEFINITION(0x1, 0xDA2), ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0x1, 0xD9C), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x1A7), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x1A8), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x1A9), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x1AA), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x1AB), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x1AC), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x1AD), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x1AE), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x1AF), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x1B0), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x1B1), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x1B2), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x1B3), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x1B4), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x1B7), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x1B9), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x1BA), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x1BB), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x1BC), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x1BF), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x1C0), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x1C1), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x1C2), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x1C5), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x1C6), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x1C7), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x1C8), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x1CB), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x1CC), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x1CD), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x1CE), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x1D1), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x1D2), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x1D5), ZYDIS_DEFINITION(0x1, 0x589) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x1D6), ZYDIS_DEFINITION(0x1, 0x57B) },
    { ZYDIS_DEFINITION(0x1, 0x596), ZYDIS_DEFINITION(0x1, 0x597) },
    { ZYDIS_DEFINITION(0x1, 0x590), ZYDIS_DEFINITION(0x1, 0x591) },
    { ZYDIS_DEFINITION(0x1, 0x598), ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0x1, 0x592), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x1D9), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x1DA), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x1DD), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x1DE), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x1E1), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x1E2), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x1E5), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x1E6), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x1E9), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x1EA), ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0x1, 0xD0F), ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0x1, 0xD0D), ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0x1, 0xD10), ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0x1, 0xD0E), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x1ED), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x1EE), ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0x1, 0xD6F), ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0x1, 0xD6D), ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0x1, 0xD70), ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0x1, 0xD6E), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x1F1), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x1F3), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x1F5), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x1F7), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x1F9), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x1FA), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x1FB), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x1FC), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x1FD), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x1FE), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x201), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x202), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x203), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x204), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x205), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x206), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x207), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x208), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x209), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x20A), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x20B), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x20C), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x20D), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x20E), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x20F), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x210), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x211), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x212), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x213), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x214), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x217), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x218), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x21B), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x21C), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x21D), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x21E), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x21F), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x220), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x221), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x222), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x225), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x226), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x227), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x228), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x22B), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x22C), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x22D), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x22E), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x22F), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x230), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x233), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x234), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x237), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x238), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x239), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x23A), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x23B), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x23C), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x23D), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x23E), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x23F), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x240), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x241), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x242), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x243), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x244), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x245), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x248), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x249), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x24C), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x24E), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x24F), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x250), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x251), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x252), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x253), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x254), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x255), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x256), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x257), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x258), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x259), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x25A), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x25B), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x25C), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x25D), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x25E), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x25F), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x260), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x261), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x262), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x263), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x264), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x265), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x266), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x267), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x268), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x269), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x26A), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x26B), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x26C), ZYDIS_DEFINITION(0x1, 0x3C7) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x26D), ZYDIS_DEFINITION(0x1, 0x3B9) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x270), ZYDIS_DEFINITION(0x1, 0x460) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x271), ZYDIS_DEFINITION(0x1, 0x452) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x274), ZYDIS_DEFINITION(0x1, 0x363) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x275), ZYDIS_DEFINITION(0x1, 0x355) },
    { ZYDIS_DEFINITION(0x1, 0x370), ZYDIS_DEFINITION(0x1, 0x371) },
    { ZYDIS_DEFINITION(0x1, 0x36A), ZYDIS_DEFINITION(0x1, 0x36B) },
    { ZYDIS_DEFINITION(0x1, 0x372), ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0x1, 0x36C), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x278), ZYDIS_DEFINITION(0x1, 0x406) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x279), ZYDIS_DEFINITION(0x1, 0x3F8) },
    { ZYDIS_DEFINITION(0x1, 0x413), ZYDIS_DEFINITION(0x1, 0x414) },
    { ZYDIS_DEFINITION(0x1, 0x40D), ZYDIS_DEFINITION(0x1, 0x40E) },
    { ZYDIS_DEFINITION(0x1, 0x415), ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0x1, 0x40F), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x27C), ZYDIS_DEFINITION(0x1, 0x4A9) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x27D), ZYDIS_DEFINITION(0x1, 0x49B) },
    { ZYDIS_DEFINITION(0x1, 0x4B6), ZYDIS_DEFINITION(0x1, 0x4B7) },
    { ZYDIS_DEFINITION(0x1, 0x4B0), ZYDIS_DEFINITION(0x1, 0x4B1) },
    { ZYDIS_DEFINITION(0x1, 0x4B8), ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0x1, 0x4B2), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x280), ZYDIS_DEFINITION(0x1, 0x503) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x281), ZYDIS_DEFINITION(0x1, 0x4F5) },
    { ZYDIS_DEFINITION(0x1, 0x510), ZYDIS_DEFINITION(0x1, 0x511) },
    { ZYDIS_DEFINITION(0x1, 0x50A), ZYDIS_DEFINITION(0x1, 0x50B) },
    { ZYDIS_DEFINITION(0x1, 0x512), ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0x1, 0x50C), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x284), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x285), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x286), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x287), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x288), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x289), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x28A), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x28B), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x28C), ZYDIS_DEFINITION(0x1, 0x3DC) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x28D), ZYDIS_DEFINITION(0x1, 0x3CE) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x290), ZYDIS_DEFINITION(0x1, 0x475) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x291), ZYDIS_DEFINITION(0x1, 0x467) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x294), ZYDIS_DEFINITION(0x1, 0x381) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x295), ZYDIS_DEFINITION(0x1, 0x373) },
    { ZYDIS_DEFINITION(0x1, 0x38E), ZYDIS_DEFINITION(0x1, 0x38F) },
    { ZYDIS_DEFINITION(0x1, 0x388), ZYDIS_DEFINITION(0x1, 0x389) },
    { ZYDIS_DEFINITION(0x1, 0x390), ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0x1, 0x38A), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x298), ZYDIS_DEFINITION(0x1, 0x424) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x299), ZYDIS_DEFINITION(0x1, 0x416) },
    { ZYDIS_DEFINITION(0x1, 0x431), ZYDIS_DEFINITION(0x1, 0x432) },
    { ZYDIS_DEFINITION(0x1, 0x42B), ZYDIS_DEFINITION(0x1, 0x42C) },
    { ZYDIS_DEFINITION(0x1, 0x433), ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0x1, 0x42D), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x29C), ZYDIS_DEFINITION(0x1, 0x4C7) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x29D), ZYDIS_DEFINITION(0x1, 0x4B9) },
    { ZYDIS_DEFINITION(0x1, 0x4D4), ZYDIS_DEFINITION(0x1, 0x4D5) },
    { ZYDIS_DEFINITION(0x1, 0x4CE), ZYDIS_DEFINITION(0x1, 0x4CF) },
    { ZYDIS_DEFINITION(0x1, 0x4D6), ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0x1, 0x4D0), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x2A0), ZYDIS_DEFINITION(0x1, 0x521) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x2A1), ZYDIS_DEFINITION(0x1, 0x513) },
    { ZYDIS_DEFINITION(0x1, 0x52E), ZYDIS_DEFINITION(0x1, 0x52F) },
    { ZYDIS_DEFINITION(0x1, 0x528), ZYDIS_DEFINITION(0x1, 0x529) },
    { ZYDIS_DEFINITION(0x1, 0x530), ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0x1, 0x52A), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x2A4), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x2A6), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x2A8), ZYDIS_DEFINITION(0x1, 0x3F1) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x2A9), ZYDIS_DEFINITION(0x1, 0x3E3) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x2AC), ZYDIS_DEFINITION(0x1, 0x48A) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x2AD), ZYDIS_DEFINITION(0x1, 0x47C) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x2B0), ZYDIS_DEFINITION(0x1, 0x39F) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x2B1), ZYDIS_DEFINITION(0x1, 0x391) },
    { ZYDIS_DEFINITION(0x1, 0x3AC), ZYDIS_DEFINITION(0x1, 0x3AD) },
    { ZYDIS_DEFINITION(0x1, 0x3A6), ZYDIS_DEFINITION(0x1, 0x3A7) },
    { ZYDIS_DEFINITION(0x1, 0x3AE), ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0x1, 0x3A8), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x2B4), ZYDIS_DEFINITION(0x1, 0x442) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x2B5), ZYDIS_DEFINITION(0x1, 0x434) },
    { ZYDIS_DEFINITION(0x1, 0x44F), ZYDIS_DEFINITION(0x1, 0x450) },
    { ZYDIS_DEFINITION(0x1, 0x449), ZYDIS_DEFINITION(0x1, 0x44A) },
    { ZYDIS_DEFINITION(0x1, 0x451), ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0x1, 0x44B), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x2B8), ZYDIS_DEFINITION(0x1, 0x4E5) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x2B9), ZYDIS_DEFINITION(0x1, 0x4D7) },
    { ZYDIS_DEFINITION(0x1, 0x4F2), ZYDIS_DEFINITION(0x1, 0x4F3) },
    { ZYDIS_DEFINITION(0x1, 0x4EC), ZYDIS_DEFINITION(0x1, 0x4ED) },
    { ZYDIS_DEFINITION(0x1, 0x4F4), ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0x1, 0x4EE), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x2BC), ZYDIS_DEFINITION(0x1, 0x53F) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x2BD), ZYDIS_DEFINITION(0x1, 0x531) },
    { ZYDIS_DEFINITION(0x1, 0x54C), ZYDIS_DEFINITION(0x1, 0x54D) },
    { ZYDIS_DEFINITION(0x1, 0x546), ZYDIS_DEFINITION(0x1, 0x547) },
    { ZYDIS_DEFINITION(0x1, 0x54E), ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0x1, 0x548), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x2C0), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x2C1), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x2C4), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x2C5), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x2C6), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x2C7), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x2C8), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x2C9), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x2CA), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x2CB), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x2CC), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x2CD), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x2CE), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x2CF), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x2D0), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x2D1), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x2D2), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x2D3), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x2D4), ZYDIS_DEFINITION(0x1, 0x304) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x2D5), ZYDIS_DEFINITION(0x1, 0x301) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x2D8), ZYDIS_DEFINITION(0x1, 0xD14) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x2D9), ZYDIS_DEFINITION(0x1, 0xD11) },
    { ZYDIS_DEFINITION(0x1, 0xD1A), ZYDIS_DEFINITION(0x1, 0xD1B) },
    { ZYDIS_DEFINITION(0x1, 0xD17), ZYDIS_DEFINITION(0x1, 0xD18) },
    { ZYDIS_DEFINITION(0x1, 0xD1C), ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0x1, 0xD19), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x2DC), ZYDIS_DEFINITION(0x1, 0xD74) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x2DD), ZYDIS_DEFINITION(0x1, 0xD71) },
    { ZYDIS_DEFINITION(0x1, 0xD7A), ZYDIS_DEFINITION(0x1, 0xD7B) },
    { ZYDIS_DEFINITION(0x1, 0xD77), ZYDIS_DEFINITION(0x1, 0xD78) },
    { ZYDIS_DEFINITION(0x1, 0xD7C), ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0x1, 0xD79), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x2E0), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x2E1), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x2E2), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x2E3), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x2E4), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x2E5), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x2E6), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x2E7), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x2E8), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x2E9), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x2EA), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x2EC), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x2EE), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x2EF), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x2F2), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x2F4), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x2F6), ZYDIS_DEFINITION(0xB, 0xD51) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x2F8), ZYDIS_DEFINITION(0xB, 0xD43) },
    { ZYDIS_DEFINITION(0xB, 0xD5E), ZYDIS_DEFINITION(0xB, 0xD5F) },
    { ZYDIS_DEFINITION(0xB, 0xD60), ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0xB, 0xD58), ZYDIS_DEFINITION(0xB, 0xD59) },
    { ZYDIS_DEFINITION(0xB, 0xD5A), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x2FA), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x2FB), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x2FC), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x2FD), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x2FE), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x2FF), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x300), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x301), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x302), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x303), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x304), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x305), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x306), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x307), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x308), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x309), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x30A), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x30B), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x30C), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x30D), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x30E), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x30F), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x310), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x311), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x312), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x313), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x314), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x315), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x316), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x317), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x318), ZYDIS_DEFINITION(0xB, 0x155) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x319), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x31A), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x31B), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x31E), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x31F), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x322), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x323), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x324), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x325), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x326), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x327), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x328), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x329), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x32A), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x32B), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x32C), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x32D), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x330), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x331), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x334), ZYDIS_DEFINITION(0xB, 0x5A7) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x335), ZYDIS_DEFINITION(0xB, 0x599) },
    { ZYDIS_DEFINITION(0xB, 0x5B4), ZYDIS_DEFINITION(0xB, 0x5B5) },
    { ZYDIS_DEFINITION(0xB, 0x5AE), ZYDIS_DEFINITION(0xB, 0x5AF) },
    { ZYDIS_DEFINITION(0xB, 0x5B6), ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0xB, 0x5B0), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x338), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x339), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x33A), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x33B), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x33C), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x33D), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x33E), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x33F), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x340), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x341), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x342), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x343), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x344), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x345), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x346), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x347), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x348), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x349), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x34A), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x34B), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x34C), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x34D), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x34E), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x34F), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x350), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x351), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x352), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x353), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x356), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x357), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x358), ZYDIS_DEFINITION(0xB, 0xCF4) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x359), ZYDIS_DEFINITION(0xB, 0xCED) },
    { ZYDIS_DEFINITION(0xB, 0xCFE), ZYDIS_DEFINITION(0xB, 0xCFF) },
    { ZYDIS_DEFINITION(0xB, 0xCFB), ZYDIS_DEFINITION(0xB, 0xCFC) },
    { ZYDIS_DEFINITION(0xB, 0xD00), ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0xB, 0xCFD), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x35C), ZYDIS_DEFINITION(0xB, 0x348) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x35D), ZYDIS_DEFINITION(0xB, 0x341) },
    { ZYDIS_DEFINITION(0xB, 0x352), ZYDIS_DEFINITION(0xB, 0x353) },
    { ZYDIS_DEFINITION(0xB, 0x34F), ZYDIS_DEFINITION(0xB, 0x350) },
    { ZYDIS_DEFINITION(0xB, 0x354), ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0xB, 0x351), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x360), ZYDIS_DEFINITION(0xB, 0xD33) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x361), ZYDIS_DEFINITION(0xB, 0xD25) },
    { ZYDIS_DEFINITION(0xB, 0xD40), ZYDIS_DEFINITION(0xB, 0xD41) },
    { ZYDIS_DEFINITION(0xB, 0xD3A), ZYDIS_DEFINITION(0xB, 0xD3B) },
    { ZYDIS_DEFINITION(0xB, 0xD42), ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0xB, 0xD3C), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x364), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x365), ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0xB, 0x565), ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0xB, 0x561), ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0xB, 0x566), ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0xB, 0x562), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x368), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x369), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x36A), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x36B), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x36E), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x36F), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x370), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x371), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x374), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x376), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x378), ZYDIS_DEFINITION(0x1, 0x15C) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x37A), ZYDIS_DEFINITION(0x1, 0xE5) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x37C), ZYDIS_DEFINITION(0x1, 0x108) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x37E), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x37F), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x380), ZYDIS_DEFINITION(0x1, 0x21F) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x382), ZYDIS_DEFINITION(0x1, 0x132) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x384), ZYDIS_DEFINITION(0x1, 0x211) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x386), ZYDIS_DEFINITION(0x1, 0x124) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x388), ZYDIS_DEFINITION(0x1, 0x22D) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x38A), ZYDIS_DEFINITION(0x1, 0x140) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x38C), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x38D), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x38E), ZYDIS_DEFINITION(0x1, 0x11D) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x390), ZYDIS_DEFINITION(0x1, 0xD8C) },
    { ZYDIS_DEFINITION(0x1, 0xD9D), ZYDIS_DEFINITION(0x1, 0xD9E) },
    { ZYDIS_DEFINITION(0x1, 0xD9F), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x392), ZYDIS_DEFINITION(0x1, 0x582) },
    { ZYDIS_DEFINITION(0x1, 0x593), ZYDIS_DEFINITION(0x1, 0x594) },
    { ZYDIS_DEFINITION(0x1, 0x595), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x394), ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0x1, 0xD23), ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0x1, 0xD24), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x396), ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0x1, 0xD83), ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0x1, 0xD84), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x398), ZYDIS_DEFINITION(0x1, 0x3C0) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x39A), ZYDIS_DEFINITION(0x1, 0x459) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x39C), ZYDIS_DEFINITION(0x1, 0x35C) },
    { ZYDIS_DEFINITION(0x1, 0x36D), ZYDIS_DEFINITION(0x1, 0x36E) },
    { ZYDIS_DEFINITION(0x1, 0x36F), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x39E), ZYDIS_DEFINITION(0x1, 0x3FF) },
    { ZYDIS_DEFINITION(0x1, 0x410), ZYDIS_DEFINITION(0x1, 0x411) },
    { ZYDIS_DEFINITION(0x1, 0x412), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x3A0), ZYDIS_DEFINITION(0x1, 0x4A2) },
    { ZYDIS_DEFINITION(0x1, 0x4B3), ZYDIS_DEFINITION(0x1, 0x4B4) },
    { ZYDIS_DEFINITION(0x1, 0x4B5), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x3A2), ZYDIS_DEFINITION(0x1, 0x4FC) },
    { ZYDIS_DEFINITION(0x1, 0x50D), ZYDIS_DEFINITION(0x1, 0x50E) },
    { ZYDIS_DEFINITION(0x1, 0x50F), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x3A4), ZYDIS_DEFINITION(0x1, 0x3D5) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x3A6), ZYDIS_DEFINITION(0x1, 0x46E) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x3A8), ZYDIS_DEFINITION(0x1, 0x37A) },
    { ZYDIS_DEFINITION(0x1, 0x38B), ZYDIS_DEFINITION(0x1, 0x38C) },
    { ZYDIS_DEFINITION(0x1, 0x38D), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x3AA), ZYDIS_DEFINITION(0x1, 0x41D) },
    { ZYDIS_DEFINITION(0x1, 0x42E), ZYDIS_DEFINITION(0x1, 0x42F) },
    { ZYDIS_DEFINITION(0x1, 0x430), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x3AC), ZYDIS_DEFINITION(0x1, 0x4C0) },
    { ZYDIS_DEFINITION(0x1, 0x4D1), ZYDIS_DEFINITION(0x1, 0x4D2) },
    { ZYDIS_DEFINITION(0x1, 0x4D3), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x3AE), ZYDIS_DEFINITION(0x1, 0x51A) },
    { ZYDIS_DEFINITION(0x1, 0x52B), ZYDIS_DEFINITION(0x1, 0x52C) },
    { ZYDIS_DEFINITION(0x1, 0x52D), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x3B0), ZYDIS_DEFINITION(0x1, 0x3EA) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x3B2), ZYDIS_DEFINITION(0x1, 0x483) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x3B4), ZYDIS_DEFINITION(0x1, 0x398) },
    { ZYDIS_DEFINITION(0x1, 0x3A9), ZYDIS_DEFINITION(0x1, 0x3AA) },
    { ZYDIS_DEFINITION(0x1, 0x3AB), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x3B6), ZYDIS_DEFINITION(0x1, 0x43B) },
    { ZYDIS_DEFINITION(0x1, 0x44C), ZYDIS_DEFINITION(0x1, 0x44D) },
    { ZYDIS_DEFINITION(0x1, 0x44E), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x3B8), ZYDIS_DEFINITION(0x1, 0x4DE) },
    { ZYDIS_DEFINITION(0x1, 0x4EF), ZYDIS_DEFINITION(0x1, 0x4F0) },
    { ZYDIS_DEFINITION(0x1, 0x4F1), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x3BA), ZYDIS_DEFINITION(0x1, 0x538) },
    { ZYDIS_DEFINITION(0x1, 0x549), ZYDIS_DEFINITION(0x1, 0x54A) },
    { ZYDIS_DEFINITION(0x1, 0x54B), ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0x1, 0x6BF), ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0x1, 0x6C0), ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0x1, 0x6C1), ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0x1, 0x6C2), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x3BC), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x3BD), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x3BE), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x3BF), ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0x1, 0x1CD), ZYDIS_DEFINITION(0x1, 0x1CE) },
    { ZYDIS_DEFINITION(0x1, 0x1D0), ZYDIS_DEFINITION(0x1, 0x1D1) },
    { ZYDIS_DEFINITION(0x1, 0x1D3), ZYDIS_DEFINITION(0x1, 0x1D4) },
    { ZYDIS_DEFINITION(0x1, 0x1CF), ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0x1, 0x1D2), ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0x1, 0x1D5), ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0x1, 0x274), ZYDIS_DEFINITION(0x1, 0x275) },
    { ZYDIS_DEFINITION(0x1, 0x277), ZYDIS_DEFINITION(0x1, 0x278) },
    { ZYDIS_DEFINITION(0x1, 0x27A), ZYDIS_DEFINITION(0x1, 0x27B) },
    { ZYDIS_DEFINITION(0x1, 0x276), ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0x1, 0x279), ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0x1, 0x27C), ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0x1, 0x1DC), ZYDIS_DEFINITION(0x1, 0x1DD) },
    { ZYDIS_DEFINITION(0x1, 0x1DF), ZYDIS_DEFINITION(0x1, 0x1E0) },
    { ZYDIS_DEFINITION(0x1, 0x1E2), ZYDIS_DEFINITION(0x1, 0x1E3) },
    { ZYDIS_DEFINITION(0x1, 0x1DE), ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0x1, 0x1E1), ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0x1, 0x1E4), ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0x1, 0xDEE), ZYDIS_DEFINITION(0x1, 0xDEF) },
    { ZYDIS_DEFINITION(0x1, 0xDF0), ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0x1, 0x1F), ZYDIS_DEFINITION(0x1, 0x20) },
    { ZYDIS_DEFINITION(0x1, 0x21), ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0x1, 0x6FA), ZYDIS_DEFINITION(0x1, 0x6FB) },
    { ZYDIS_DEFINITION(0x1, 0x6FC), ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0x1, 0x1D6), ZYDIS_DEFINITION(0x1, 0x1D7) },
    { ZYDIS_DEFINITION(0x1, 0x1D8), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x3C0), ZYDIS_DEFINITION(0x1, 0x234) },
    { ZYDIS_DEFINITION(0x1, 0xE0C), ZYDIS_DEFINITION(0x1, 0xE0D) },
    { ZYDIS_DEFINITION(0x1, 0xE0E), ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0x1, 0x61C), ZYDIS_DEFINITION(0x1, 0x61D) },
    { ZYDIS_DEFINITION(0x1, 0x61E), ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0x1, 0x2F8), ZYDIS_DEFINITION(0x1, 0x2F9) },
    { ZYDIS_DEFINITION(0x1, 0x2FA), ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0x1, 0x5FE), ZYDIS_DEFINITION(0x1, 0x5FF) },
    { ZYDIS_DEFINITION(0x1, 0x600), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x3C2), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x3C3), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x3C4), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x3C5), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x3C6), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x3C7), ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0x1, 0x27D), ZYDIS_DEFINITION(0x1, 0x27E) },
    { ZYDIS_DEFINITION(0x1, 0x280), ZYDIS_DEFINITION(0x1, 0x281) },
    { ZYDIS_DEFINITION(0x1, 0x283), ZYDIS_DEFINITION(0x1, 0x284) },
    { ZYDIS_DEFINITION(0x1, 0x27F), ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0x1, 0x282), ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0x1, 0x285), ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0x1, 0x1E5), ZYDIS_DEFINITION(0x1, 0x1E6) },
    { ZYDIS_DEFINITION(0x1, 0x1E8), ZYDIS_DEFINITION(0x1, 0x1E9) },
    { ZYDIS_DEFINITION(0x1, 0x1EB), ZYDIS_DEFINITION(0x1, 0x1EC) },
    { ZYDIS_DEFINITION(0x1, 0x1E7), ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0x1, 0x1EA), ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0x1, 0x1ED), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x3C8), ZYDIS_DEFINITION(0x1, 0x286) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x3C9), ZYDIS_DEFINITION(0x1, 0x29B) },
    { ZYDIS_DEFINITION(0x1, 0x2C0), ZYDIS_DEFINITION(0x1, 0x2C1) },
    { ZYDIS_DEFINITION(0x1, 0x2C3), ZYDIS_DEFINITION(0x1, 0x2C4) },
    { ZYDIS_DEFINITION(0x1, 0x2C6), ZYDIS_DEFINITION(0x1, 0x2C7) },
    { ZYDIS_DEFINITION(0x1, 0x2C2), ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0x1, 0x2C5), ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0x1, 0x2C8), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x3CC), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x3CD), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x3CE), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x3CF), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x3D0), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x3D1), ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0xB, 0xA5), ZYDIS_DEFINITION(0xB, 0xA6) },
    { ZYDIS_DEFINITION(0xB, 0xA7), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x3D2), ZYDIS_DEFINITION(0x1, 0xBD) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x3D3), ZYDIS_DEFINITION(0x1, 0x178) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x3D6), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x3D7), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x3D8), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x3D9), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x3DA), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x3DB), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x3DC), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x3DD), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x3DE), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x3DF), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x3E0), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x3E1), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x3E2), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x3E3), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x3E4), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x3E5), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x3E6), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x3E7), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x3E8), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x3E9), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x3EA), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x3EB), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x3EC), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x3ED), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x3EE), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x3EF), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x3F0), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x3F1), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x3F2), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x3F3), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x3F6), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x3F7), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x3F8), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x3F9), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x3FA), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x3FB), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x3FC), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x3FD), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x3FE), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x3FF), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x400), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x401), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x402), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x403), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x404), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x405), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x406), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x407), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x408), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x409), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x40A), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x40B), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x40C), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x40E), ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0xB, 0xA2), ZYDIS_DEFINITION(0xB, 0xA3) },
    { ZYDIS_DEFINITION(0xB, 0xA4), ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0x1, 0x6AF), ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0x1, 0x6B0), ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0x1, 0x6B1), ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0x1, 0x6B2), ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0x1, 0x1C4), ZYDIS_DEFINITION(0x1, 0x1C5) },
    { ZYDIS_DEFINITION(0x1, 0x1CA), ZYDIS_DEFINITION(0x1, 0x1CB) },
    { ZYDIS_DEFINITION(0x1, 0x1C6), ZYDIS_DEFINITION(0x1, 0x1C7) },
    { ZYDIS_DEFINITION(0x1, 0x1C8), ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0x1, 0x1CC), ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0x1, 0x1C9), ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0x1, 0x262), ZYDIS_DEFINITION(0x1, 0x263) },
    { ZYDIS_DEFINITION(0x1, 0x268), ZYDIS_DEFINITION(0x1, 0x269) },
    { ZYDIS_DEFINITION(0x1, 0x264), ZYDIS_DEFINITION(0x1, 0x265) },
    { ZYDIS_DEFINITION(0x1, 0x266), ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0x1, 0x26A), ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0x1, 0x267), ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0x1, 0x1A8), ZYDIS_DEFINITION(0x1, 0x1A9) },
    { ZYDIS_DEFINITION(0x1, 0x1AE), ZYDIS_DEFINITION(0x1, 0x1AF) },
    { ZYDIS_DEFINITION(0x1, 0x1AA), ZYDIS_DEFINITION(0x1, 0x1AB) },
    { ZYDIS_DEFINITION(0x1, 0x1AC), ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0x1, 0x1B0), ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0x1, 0x1AD), ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0x1, 0xDEB), ZYDIS_DEFINITION(0x1, 0xDEC) },
    { ZYDIS_DEFINITION(0x1, 0xDED), ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0x1, 0x1C), ZYDIS_DEFINITION(0x1, 0x1D) },
    { ZYDIS_DEFINITION(0x1, 0x1E), ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0x1, 0x6F7), ZYDIS_DEFINITION(0x1, 0x6F8) },
    { ZYDIS_DEFINITION(0x1, 0x6F9), ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0x1, 0x1A5), ZYDIS_DEFINITION(0x1, 0x1A6) },
    { ZYDIS_DEFINITION(0x1, 0x1A7), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x410), ZYDIS_DEFINITION(0x1, 0x20A) },
    { ZYDIS_DEFINITION(0x1, 0xE09), ZYDIS_DEFINITION(0x1, 0xE0A) },
    { ZYDIS_DEFINITION(0x1, 0xE0B), ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0x1, 0x619), ZYDIS_DEFINITION(0x1, 0x61A) },
    { ZYDIS_DEFINITION(0x1, 0x61B), ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0x1, 0x2F5), ZYDIS_DEFINITION(0x1, 0x2F6) },
    { ZYDIS_DEFINITION(0x1, 0x2F7), ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0x1, 0x5FB), ZYDIS_DEFINITION(0x1, 0x5FC) },
    { ZYDIS_DEFINITION(0x1, 0x5FD), ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0x1, 0x26B), ZYDIS_DEFINITION(0x1, 0x26C) },
    { ZYDIS_DEFINITION(0x1, 0x271), ZYDIS_DEFINITION(0x1, 0x272) },
    { ZYDIS_DEFINITION(0x1, 0x26D), ZYDIS_DEFINITION(0x1, 0x26E) },
    { ZYDIS_DEFINITION(0x1, 0x26F), ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0x1, 0x273), ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0x1, 0x270), ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0x1, 0x1B4), ZYDIS_DEFINITION(0x1, 0x1B5) },
    { ZYDIS_DEFINITION(0x1, 0x1BA), ZYDIS_DEFINITION(0x1, 0x1BB) },
    { ZYDIS_DEFINITION(0x1, 0x1B6), ZYDIS_DEFINITION(0x1, 0x1B7) },
    { ZYDIS_DEFINITION(0x1, 0x1B8), ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0x1, 0x1BC), ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0x1, 0x1B9), ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0x1, 0x2B7), ZYDIS_DEFINITION(0x1, 0x2B8) },
    { ZYDIS_DEFINITION(0x1, 0x2BD), ZYDIS_DEFINITION(0x1, 0x2BE) },
    { ZYDIS_DEFINITION(0x1, 0x2B9), ZYDIS_DEFINITION(0x1, 0x2BA) },
    { ZYDIS_DEFINITION(0x1, 0x2BB), ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0x1, 0x2BF), ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0x1, 0x2BC), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x412), ZYDIS_DEFINITION(0x1, 0x2D0) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x414), ZYDIS_DEFINITION(0x1, 0x3AF) },
    { ZYDIS_DEFINITION(0x1, 0x3B6), ZYDIS_DEFINITION(0x1, 0x3B7) },
    { ZYDIS_DEFINITION(0x1, 0x3B8), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x416), ZYDIS_DEFINITION(0x1, 0x491) },
    { ZYDIS_DEFINITION(0x1, 0x498), ZYDIS_DEFINITION(0x1, 0x499) },
    { ZYDIS_DEFINITION(0x1, 0x49A), ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0x1, 0x6AB), ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0x1, 0x6AC), ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0x1, 0x6AD), ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0x1, 0x6AE), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x418), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x419), ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0x1, 0x1BF), ZYDIS_DEFINITION(0x1, 0x1C0) },
    { ZYDIS_DEFINITION(0x1, 0x1C2), ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0x1, 0x1BE), ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0x1, 0x1C1), ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0x1, 0x1C3), ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0x1, 0x250), ZYDIS_DEFINITION(0x1, 0x251) },
    { ZYDIS_DEFINITION(0x1, 0x253), ZYDIS_DEFINITION(0x1, 0x254) },
    { ZYDIS_DEFINITION(0x1, 0x256), ZYDIS_DEFINITION(0x1, 0x257) },
    { ZYDIS_DEFINITION(0x1, 0x252), ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0x1, 0x255), ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0x1, 0x258), ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0x1, 0x190), ZYDIS_DEFINITION(0x1, 0x191) },
    { ZYDIS_DEFINITION(0x1, 0x193), ZYDIS_DEFINITION(0x1, 0x194) },
    { ZYDIS_DEFINITION(0x1, 0x196), ZYDIS_DEFINITION(0x1, 0x197) },
    { ZYDIS_DEFINITION(0x1, 0x192), ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0x1, 0x195), ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0x1, 0x198), ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0x1, 0xDE8), ZYDIS_DEFINITION(0x1, 0xDE9) },
    { ZYDIS_DEFINITION(0x1, 0xDEA), ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0x1, 0x19), ZYDIS_DEFINITION(0x1, 0x1A) },
    { ZYDIS_DEFINITION(0x1, 0x1B), ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0x1, 0x6F4), ZYDIS_DEFINITION(0x1, 0x6F5) },
    { ZYDIS_DEFINITION(0x1, 0x6F6), ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0x1, 0x199), ZYDIS_DEFINITION(0x1, 0x19A) },
    { ZYDIS_DEFINITION(0x1, 0x19B), ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0x1, 0xE06), ZYDIS_DEFINITION(0x1, 0xE07) },
    { ZYDIS_DEFINITION(0x1, 0xE08), ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0x1, 0x616), ZYDIS_DEFINITION(0x1, 0x617) },
    { ZYDIS_DEFINITION(0x1, 0x618), ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0x1, 0x2F2), ZYDIS_DEFINITION(0x1, 0x2F3) },
    { ZYDIS_DEFINITION(0x1, 0x2F4), ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0x1, 0x5F8), ZYDIS_DEFINITION(0x1, 0x5F9) },
    { ZYDIS_DEFINITION(0x1, 0x5FA), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x41A), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x41B), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x41C), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x41D), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x41E), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x41F), ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0x1, 0x259), ZYDIS_DEFINITION(0x1, 0x25A) },
    { ZYDIS_DEFINITION(0x1, 0x25C), ZYDIS_DEFINITION(0x1, 0x25D) },
    { ZYDIS_DEFINITION(0x1, 0x25F), ZYDIS_DEFINITION(0x1, 0x260) },
    { ZYDIS_DEFINITION(0x1, 0x25B), ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0x1, 0x25E), ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0x1, 0x261), ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0x1, 0x19C), ZYDIS_DEFINITION(0x1, 0x19D) },
    { ZYDIS_DEFINITION(0x1, 0x19F), ZYDIS_DEFINITION(0x1, 0x1A0) },
    { ZYDIS_DEFINITION(0x1, 0x1A2), ZYDIS_DEFINITION(0x1, 0x1A3) },
    { ZYDIS_DEFINITION(0x1, 0x19E), ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0x1, 0x1A1), ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0x1, 0x1A4), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x420), ZYDIS_DEFINITION(0x1, 0x294) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x421), ZYDIS_DEFINITION(0x1, 0x2A9) },
    { ZYDIS_DEFINITION(0x1, 0x2B2), ZYDIS_DEFINITION(0x1, 0x2B3) },
    { ZYDIS_DEFINITION(0x1, 0x2B5), ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0x1, 0x2B1), ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0x1, 0x2B4), ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0x1, 0x2B6), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x424), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x425), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x426), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x427), ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0xB, 0x9F), ZYDIS_DEFINITION(0xB, 0xA0) },
    { ZYDIS_DEFINITION(0xB, 0xA1), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x428), ZYDIS_DEFINITION(0x1, 0xDE) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x42A), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x42B), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x42C), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x42D), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x430), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x432), ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0x1, 0x1), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x433), ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0x1, 0x3), ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0x1, 0x18D), ZYDIS_DEFINITION(0x1, 0x18E) },
    { ZYDIS_DEFINITION(0x1, 0x18F), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x434), ZYDIS_DEFINITION(0x1, 0x28D) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x435), ZYDIS_DEFINITION(0x1, 0x2A2) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x438), ZYDIS_DEFINITION(0x1, 0x2C9) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x43A), ZYDIS_DEFINITION(0x1, 0x32D) },
    { ZYDIS_DEFINITION(0x1, 0x334), ZYDIS_DEFINITION(0x1, 0x335) },
    { ZYDIS_DEFINITION(0x1, 0x336), ZYDIS_INVALID },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH, 0x43C), ZYDIS_DEFINITION(0x1, 0x337) },
    { ZYDIS_DEFINITION(0x1, 0x33E), ZYDIS_DEFINITION(0x1, 0x33F) },
    { ZYDIS_DEFINITION(0x1, 0x340), ZYDIS_INVALID }
};
#endif

#ifndef ZYDIS_DISABLE_KNC
const ZydisDecoderTreeNode FILTERS_MVEX_E[][2] =
{
    { ZYDIS_DEFINITION(0x1, 0xC7), ZYDIS_DEFINITION(0x1, 0xC8) },
    { ZYDIS_DEFINITION(0x1, 0xB), ZYDIS_DEFINITION(0x1, 0xC) },
    { ZYDIS_DEFINITION(0x1, 0xDA), ZYDIS_DEFINITION(0x1, 0xDB) },
    { ZYDIS_DEFINITION(0x1, 0x3D), ZYDIS_DEFINITION(0x1, 0x3E) },
    { ZYDIS_DEFINITION(0x1, 0x18E), ZYDIS_DEFINITION(0x1, 0x18F) },
    { ZYDIS_DEFINITION(0xB, 0x22), ZYDIS_DEFINITION(0xB, 0x23) },
    { ZYDIS_DEFINITION(0xB, 0x37), ZYDIS_DEFINITION(0xB, 0x38) },
    { ZYDIS_DEFINITION(0xB, 0x28), ZYDIS_DEFINITION(0xB, 0x29) },
    { ZYDIS_DEFINITION(0x1, 0xC3), ZYDIS_DEFINITION(0x1, 0xC4) },
    { ZYDIS_DEFINITION(0x1, 0x8), ZYDIS_DEFINITION(0x1, 0x9) },
    { ZYDIS_DEFINITION(0x1, 0xD7), ZYDIS_DEFINITION(0x1, 0xD8) },
    { ZYDIS_DEFINITION(0x1, 0x3A), ZYDIS_DEFINITION(0x1, 0x3B) },
    { ZYDIS_DEFINITION(0x1, 0x18B), ZYDIS_DEFINITION(0x1, 0x18C) },
    { ZYDIS_DEFINITION(0x1, 0x10B), ZYDIS_DEFINITION(0x1, 0x10C) },
    { ZYDIS_DEFINITION(0x1, 0xCB), ZYDIS_DEFINITION(0x1, 0xCC) },
    { ZYDIS_DEFINITION(0x1, 0xCF), ZYDIS_DEFINITION(0x1, 0xD0) },
    { ZYDIS_DEFINITION(0xB, 0x14C), ZYDIS_DEFINITION(0xB, 0x14D) },
    { ZYDIS_DEFINITION(0xB, 0x15B), ZYDIS_DEFINITION(0xB, 0x15C) },
    { ZYDIS_DEFINITION(0xB, 0x155), ZYDIS_DEFINITION(0xB, 0x156) },
    { ZYDIS_DEFINITION(0xB, 0x14F), ZYDIS_DEFINITION(0xB, 0x150) },
    { ZYDIS_DEFINITION(0x1, 0x108), ZYDIS_DEFINITION(0x1, 0x109) },
    { ZYDIS_DEFINITION(0xB, 0x1F), ZYDIS_DEFINITION(0xB, 0x20) },
    { ZYDIS_DEFINITION(0x1, 0xF1), ZYDIS_DEFINITION(0x1, 0xF2) },
    { ZYDIS_DEFINITION(0x1, 0xFA), ZYDIS_DEFINITION(0x1, 0xFB) },
    { ZYDIS_DEFINITION(0x1, 0xF4), ZYDIS_DEFINITION(0x1, 0xF5) },
    { ZYDIS_DEFINITION(0x1, 0xF7), ZYDIS_DEFINITION(0x1, 0xF8) },
    { ZYDIS_DEFINITION(0x1, 0x136), ZYDIS_DEFINITION(0x1, 0x137) },
    { ZYDIS_DEFINITION(0x1, 0x139), ZYDIS_DEFINITION(0x1, 0x13A) },
    { ZYDIS_DEFINITION(0x1, 0x170), ZYDIS_DEFINITION(0x1, 0x171) },
    { ZYDIS_DEFINITION(0x1, 0x173), ZYDIS_DEFINITION(0x1, 0x174) },
    { ZYDIS_DEFINITION(0x1, 0x161), ZYDIS_DEFINITION(0x1, 0x162) },
    { ZYDIS_DEFINITION(0x1, 0xE8), ZYDIS_DEFINITION(0x1, 0xE9) },
    { ZYDIS_DEFINITION(0x1, 0x16D), ZYDIS_DEFINITION(0x1, 0x16E) },
    { ZYDIS_DEFINITION(0x1, 0x114), ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0x1, 0x127), ZYDIS_DEFINITION(0x1, 0x128) },
    { ZYDIS_DEFINITION(0x1, 0x12A), ZYDIS_DEFINITION(0x1, 0x12B) },
    { ZYDIS_DEFINITION(0x1, 0x121), ZYDIS_DEFINITION(0x1, 0x122) },
    { ZYDIS_DEFINITION(0x1, 0x124), ZYDIS_DEFINITION(0x1, 0x125) },
    { ZYDIS_DEFINITION(0x1, 0x133), ZYDIS_DEFINITION(0x1, 0x134) },
    { ZYDIS_DEFINITION(0x1, 0xA0), ZYDIS_DEFINITION(0x1, 0xA1) },
    { ZYDIS_DEFINITION(0x1, 0x9D), ZYDIS_DEFINITION(0x1, 0x9E) },
    { ZYDIS_DEFINITION(0x1, 0x15E), ZYDIS_DEFINITION(0x1, 0x15F) },
    { ZYDIS_DEFINITION(0x1, 0x158), ZYDIS_DEFINITION(0x1, 0x159) },
    { ZYDIS_DEFINITION(0x1, 0x152), ZYDIS_DEFINITION(0x1, 0x153) },
    { ZYDIS_DEFINITION(0x1, 0x5), ZYDIS_DEFINITION(0x1, 0x6) },
    { ZYDIS_DEFINITION(0x1, 0x2), ZYDIS_DEFINITION(0x1, 0x3) },
    { ZYDIS_DEFINITION(0x1, 0xA9), ZYDIS_DEFINITION(0x1, 0xAA) },
    { ZYDIS_DEFINITION(0x1, 0xB5), ZYDIS_DEFINITION(0x1, 0xB6) },
    { ZYDIS_DEFINITION(0x1, 0xB2), ZYDIS_DEFINITION(0x1, 0xB3) },
    { ZYDIS_DEFINITION(0x1, 0xAF), ZYDIS_DEFINITION(0x1, 0xB0) },
    { ZYDIS_DEFINITION(0x1, 0xAC), ZYDIS_DEFINITION(0x1, 0xAD) },
    { ZYDIS_DEFINITION(0x1, 0x49), ZYDIS_DEFINITION(0x1, 0x4A) },
    { ZYDIS_DEFINITION(0x1, 0x46), ZYDIS_DEFINITION(0x1, 0x47) },
    { ZYDIS_DEFINITION(0x1, 0xE5), ZYDIS_DEFINITION(0x1, 0xE6) },
    { ZYDIS_DEFINITION(0x1, 0xEB), ZYDIS_DEFINITION(0x1, 0xEC) },
    { ZYDIS_DEFINITION(0x1, 0x144), ZYDIS_DEFINITION(0x1, 0x145) },
    { ZYDIS_DEFINITION(0x1, 0x16A), ZYDIS_DEFINITION(0x1, 0x16B) },
    { ZYDIS_DEFINITION(0x1, 0xFD), ZYDIS_DEFINITION(0x1, 0xFE) },
    { ZYDIS_DEFINITION(0x1, 0x100), ZYDIS_DEFINITION(0x1, 0x101) },
    { ZYDIS_DEFINITION(0x1, 0x16), ZYDIS_DEFINITION(0x1, 0x17) },
    { ZYDIS_DEFINITION(0x1, 0x13), ZYDIS_DEFINITION(0x1, 0x14) },
    { ZYDIS_DEFINITION(0x1, 0x164), ZYDIS_DEFINITION(0x1, 0x165) },
    { ZYDIS_DEFINITION(0x1, 0x194), ZYDIS_DEFINITION(0x1, 0x195) },
    { ZYDIS_DEFINITION(0x1, 0x191), ZYDIS_DEFINITION(0x1, 0x192) },
    { ZYDIS_DEFINITION(0x1, 0x147), ZYDIS_DEFINITION(0x1, 0x148) },
    { ZYDIS_DEFINITION(0x1, 0x167), ZYDIS_DEFINITION(0x1, 0x168) },
    { ZYDIS_DEFINITION(0x1, 0x10E), ZYDIS_DEFINITION(0x1, 0x10F) },
    { ZYDIS_DEFINITION(0x1, 0x182), ZYDIS_DEFINITION(0x1, 0x183) },
    { ZYDIS_DEFINITION(0x1, 0x130), ZYDIS_DEFINITION(0x1, 0x131) },
    { ZYDIS_DEFINITION(0x1, 0x12D), ZYDIS_DEFINITION(0x1, 0x12E) },
    { ZYDIS_DEFINITION(0x1, 0x4F), ZYDIS_DEFINITION(0x1, 0x50) },
    { ZYDIS_DEFINITION(0x1, 0x4C), ZYDIS_DEFINITION(0x1, 0x4D) },
    { ZYDIS_DEFINITION(0x1, 0x64), ZYDIS_DEFINITION(0x1, 0x65) },
    { ZYDIS_DEFINITION(0x1, 0x61), ZYDIS_DEFINITION(0x1, 0x62) },
    { ZYDIS_DEFINITION(0x1, 0x76), ZYDIS_DEFINITION(0x1, 0x77) },
    { ZYDIS_DEFINITION(0x1, 0x73), ZYDIS_DEFINITION(0x1, 0x74) },
    { ZYDIS_DEFINITION(0x1, 0x88), ZYDIS_DEFINITION(0x1, 0x89) },
    { ZYDIS_DEFINITION(0x1, 0x85), ZYDIS_DEFINITION(0x1, 0x86) },
    { ZYDIS_DEFINITION(0x1, 0x5E), ZYDIS_DEFINITION(0x1, 0x5F) },
    { ZYDIS_DEFINITION(0x1, 0x55), ZYDIS_DEFINITION(0x1, 0x56) },
    { ZYDIS_DEFINITION(0x1, 0x52), ZYDIS_DEFINITION(0x1, 0x53) },
    { ZYDIS_DEFINITION(0x1, 0x6A), ZYDIS_DEFINITION(0x1, 0x6B) },
    { ZYDIS_DEFINITION(0x1, 0x67), ZYDIS_DEFINITION(0x1, 0x68) },
    { ZYDIS_DEFINITION(0x1, 0x7C), ZYDIS_DEFINITION(0x1, 0x7D) },
    { ZYDIS_DEFINITION(0x1, 0x79), ZYDIS_DEFINITION(0x1, 0x7A) },
    { ZYDIS_DEFINITION(0x1, 0x8E), ZYDIS_DEFINITION(0x1, 0x8F) },
    { ZYDIS_DEFINITION(0x1, 0x8B), ZYDIS_DEFINITION(0x1, 0x8C) },
    { ZYDIS_DEFINITION(0x1, 0x11E), ZYDIS_DEFINITION(0x1, 0x11F) },
    { ZYDIS_DEFINITION(0x1, 0x11B), ZYDIS_DEFINITION(0x1, 0x11C) },
    { ZYDIS_DEFINITION(0x1, 0x5B), ZYDIS_DEFINITION(0x1, 0x5C) },
    { ZYDIS_DEFINITION(0x1, 0x58), ZYDIS_DEFINITION(0x1, 0x59) },
    { ZYDIS_DEFINITION(0x1, 0x70), ZYDIS_DEFINITION(0x1, 0x71) },
    { ZYDIS_DEFINITION(0x1, 0x6D), ZYDIS_DEFINITION(0x1, 0x6E) },
    { ZYDIS_DEFINITION(0x1, 0x82), ZYDIS_DEFINITION(0x1, 0x83) },
    { ZYDIS_DEFINITION(0x1, 0x7F), ZYDIS_DEFINITION(0x1, 0x80) },
    { ZYDIS_DEFINITION(0x1, 0x94), ZYDIS_DEFINITION(0x1, 0x95) },
    { ZYDIS_DEFINITION(0x1, 0x91), ZYDIS_DEFINITION(0x1, 0x92) },
    { ZYDIS_DEFINITION(0x1, 0x43), ZYDIS_DEFINITION(0x1, 0x44) },
    { ZYDIS_DEFINITION(0x1, 0xC0), ZYDIS_DEFINITION(0x1, 0xC1) },
    { ZYDIS_DEFINITION(0x1, 0x176), ZYDIS_DEFINITION(0x1, 0x177) },
    { ZYDIS_DEFINITION(0x1, 0x17F), ZYDIS_DEFINITION(0x1, 0x180) },
    { ZYDIS_DEFINITION(0x1, 0xE), ZYDIS_DEFINITION(0x1, 0xF) },
    { ZYDIS_DEFINITION(0x1, 0xEE), ZYDIS_DEFINITION(0x1, 0xEF) },
    { ZYDIS_DEFINITION(0xB, 0x11), ZYDIS_INVALID },
    { ZYDIS_DEFINITION(0xB, 0x116), ZYDIS_DEFINITION(0xB, 0x117) },
    { ZYDIS_DEFINITION(0xB, 0x111), ZYDIS_DEFINITION(0xB, 0x112) },
    { ZYDIS_DEFINITION(0xB, 0x105), ZYDIS_DEFINITION(0xB, 0x106) },
    { ZYDIS_DEFINITION(0xB, 0xA6), ZYDIS_DEFINITION(0xB, 0xA7) },
    { ZYDIS_DEFINITION(0xB, 0xA3), ZYDIS_DEFINITION(0xB, 0xA4) },
    { ZYDIS_DEFINITION(0xB, 0x17C), ZYDIS_DEFINITION(0xB, 0x17D) },
    { ZYDIS_DEFINITION(0xB, 0x179), ZYDIS_DEFINITION(0xB, 0x17A) },
    { ZYDIS_DEFINITION(0xB, 0x34), ZYDIS_DEFINITION(0xB, 0x35) },
    { ZYDIS_DEFINITION(0xB, 0x31), ZYDIS_DEFINITION(0xB, 0x32) },
    { ZYDIS_DEFINITION(0x1, 0xD3), ZYDIS_DEFINITION(0x1, 0xD5) },
    { ZYDIS_DEFINITION(0x1, 0x40), ZYDIS_DEFINITION(0x1, 0x41) },
    { ZYDIS_DEFINITION(0x1, 0x25), ZYDIS_DEFINITION(0x1, 0x26) },
    { ZYDIS_DEFINITION(0x1, 0xD4), ZYDIS_DEFINITION(0x1, 0xD6) },
    { ZYDIS_DEFINITION(0xB, 0x2E), ZYDIS_DEFINITION(0xB, 0x2F) },
    { ZYDIS_DEFINITION(0xB, 0x2B), ZYDIS_DEFINITION(0xB, 0x2C) }
};
#endif

const ZydisDecoderTreeNode FILTERS_MODE_AMD[][2] =
{
    { ZYDIS_DEFINITION(0xA, 0x2B2), ZYDIS_DEFINITION(0x9, 0x2B3) },
    { ZYDIS_DEFINITION(0xA, 0x29E), ZYDIS_DEFINITION(0x9, 0x29F) },
    { ZYDIS_DEFINITION(0xA, 0x26A), ZYDIS_DEFINITION(0x9, 0x26B) },
    { ZYDIS_DEFINITION(0xA, 0x28A), ZYDIS_DEFINITION(0x9, 0x28B) },
    { ZYDIS_DEFINITION(0xA, 0x2C2), ZYDIS_DEFINITION(0x9, 0x2C3) },
    { ZYDIS_DEFINITION(0xA, 0x2AD), ZYDIS_DEFINITION(0x9, 0x2AE) },
    { ZYDIS_DEFINITION(0xA, 0x26F), ZYDIS_DEFINITION(0x9, 0x270) },
    { ZYDIS_DEFINITION(0xA, 0x28F), ZYDIS_DEFINITION(0x9, 0x290) },
    { ZYDIS_DEFINITION(0xA, 0x2BD), ZYDIS_DEFINITION(0x9, 0x2BE) },
    { ZYDIS_DEFINITION(0xA, 0x2A8), ZYDIS_DEFINITION(0x9, 0x2A9) },
    { ZYDIS_DEFINITION(0xA, 0x2B7), ZYDIS_DEFINITION(0x9, 0x2B8) },
    { ZYDIS_DEFINITION(0xA, 0x2A3), ZYDIS_DEFINITION(0x9, 0x2A4) },
    { ZYDIS_DEFINITION(0xA, 0x277), ZYDIS_DEFINITION(0x9, 0x278) },
    { ZYDIS_DEFINITION(0xA, 0x294), ZYDIS_DEFINITION(0x9, 0x295) },
    { ZYDIS_DEFINITION(0xA, 0x27C), ZYDIS_DEFINITION(0x9, 0x27D) },
    { ZYDIS_DEFINITION(0xA, 0x299), ZYDIS_DEFINITION(0x9, 0x29A) },
    { ZYDIS_DEFINITION(0xA, 0xB0), ZYDIS_DEFINITION(0x9, 0xB1) },
    { ZYDIS_DEFINITION(0xA, 0x27F), ZYDIS_DEFINITION(0x9, 0x280) }
};

const ZydisDecoderTreeNode FILTERS_MODE_KNC[][2] =
{
    { ZYDIS_DEFINITION(0x1, 0x3E6), ZYDIS_DEFINITION(0x1, 0x3E7) },
    { ZYDIS_DEFINITION(0x1, 0x3E8), ZYDIS_DEFINITION(0x1, 0x3E9) },
    { ZYDIS_DEFINITION(0x1, 0x4D), ZYDIS_DEFINITION(0x1, 0x49) },
    { ZYDIS_DEFINITION(0x1, 0x44), ZYDIS_DEFINITION(0x1, 0x30) },
    { ZYDIS_DEFINITION(0x1, 0x47), ZYDIS_DEFINITION(0x1, 0x31) },
    { ZYDIS_DEFINITION(0x1, 0x48), ZYDIS_DEFINITION(0x1, 0x32) },
    { ZYDIS_DEFINITION(0x1, 0x56), ZYDIS_DEFINITION(0x1, 0x52) }
};

const ZydisDecoderTreeNode FILTERS_MODE_MPX[][2] =
{
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x2F), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x30) },
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x31), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x32) }
};

const ZydisDecoderTreeNode FILTERS_MODE_CET[][2] =
{
    { ZYDIS_DEFINITION(0x1, 0x3E3), ZYDIS_DEFINITION(0x1, 0x606) },
    { ZYDIS_DEFINITION(0x1, 0x3E3), ZYDIS_DEFINITION(0x1, 0x607) },
    { ZYDIS_DEFINITION(0x1, 0x3E4), ZYDIS_DEFINITION(0x1, 0x606) },
    { ZYDIS_DEFINITION(0x1, 0x3DD), ZYDIS_DEFINITION(0x1, 0x179) },
    { ZYDIS_DEFINITION(0x1, 0x3DE), ZYDIS_DEFINITION(0x1, 0x178) }
};

const ZydisDecoderTreeNode FILTERS_MODE_LZCNT[][2] =
{
    { ZYDIS_INVALID, ZYDIS_DEFINITION(0x1, 0x2EE) },
    { ZYDIS_INVALID, ZYDIS_DEFINITION(0x1, 0x2EF) }
};

const ZydisDecoderTreeNode FILTERS_MODE_TZCNT[][2] =
{
    { ZYDIS_INVALID, ZYDIS_DEFINITION(0x1, 0x725) },
    { ZYDIS_INVALID, ZYDIS_DEFINITION(0x1, 0x726) }
};

const ZydisDecoderTreeNode FILTERS_MODE_WBNOINVD[][2] =
{
    { ZYDIS_INVALID, ZYDIS_INVALID }
};

const ZydisDecoderTreeNode FILTERS_MODE_CLDEMOTE[][2] =
{
    { ZYDIS_DEFINITION(0x1, 0x3CE), ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MANDATORY_PREFIX, 0x14) }
};

const ZydisDecoderTreeNode FILTERS_MODE_CENTAUR[][2] =
{
    { ZYDIS_INVALID, ZYDIS_INVALID }
};

const ZydisDecoderTreeNode FILTERS_MODE_IPREFETCH[][2] =
{
    { ZYDIS_DEFINITION(0x1, 0x3C2), ZYDIS_DEFINITION(0x1, 0x534) },
    { ZYDIS_DEFINITION(0x1, 0x3C3), ZYDIS_DEFINITION(0x1, 0x533) }
};

const ZydisDecoderTreeNode FILTERS_MODE_UD0_COMPAT[][2] =
{
    { ZYDIS_FILTER(ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT, 0x140), ZYDIS_DEFINITION(0x0, 0x72B) }
};

#undef ZYDIS_INVALID
#undef ZYDIS_FILTER
#undef ZYDIS_DEFINITION

/* ---------------------------------------------------------------------------------------------- */

/* ============================================================================================== */
/* Functions                                                                                      */
/* ============================================================================================== */

/* ---------------------------------------------------------------------------------------------- */
/* Decoder tree                                                                                   */
/* ---------------------------------------------------------------------------------------------- */

const ZydisDecoderTreeNode zydis_decoder_tree_root = { ZYDIS_NODETYPE_FILTER_OPCODE, 0x0000 };

const ZydisDecoderTreeNode* ZydisDecoderTreeGetChildNode(const ZydisDecoderTreeNode* parent,
    ZyanU16 index)
{
    switch (parent->type)
    {
    case ZYDIS_NODETYPE_FILTER_XOP:
        ZYAN_ASSERT(index <  13);
        return &FILTERS_XOP[parent->value][index];
    case ZYDIS_NODETYPE_FILTER_VEX:
        ZYAN_ASSERT(index <  17);
        return &FILTERS_VEX[parent->value][index];
    case ZYDIS_NODETYPE_FILTER_EMVEX:
        ZYAN_ASSERT(index <  49);
        return &FILTERS_EMVEX[parent->value][index];
    case ZYDIS_NODETYPE_FILTER_OPCODE:
        ZYAN_ASSERT(index < 256);
        return &FILTERS_OPCODE[parent->value][index];
    case ZYDIS_NODETYPE_FILTER_MODE:
        ZYAN_ASSERT(index <   4);
        return &FILTERS_MODE[parent->value][index];
    case ZYDIS_NODETYPE_FILTER_MODE_COMPACT:
        ZYAN_ASSERT(index <   3);
        return &FILTERS_MODE_COMPACT[parent->value][index];
    case ZYDIS_NODETYPE_FILTER_MODRM_MOD:
        ZYAN_ASSERT(index <   4);
        return &FILTERS_MODRM_MOD[parent->value][index];
    case ZYDIS_NODETYPE_FILTER_MODRM_MOD_COMPACT:
        ZYAN_ASSERT(index <   2);
        return &FILTERS_MODRM_MOD_COMPACT[parent->value][index];
    case ZYDIS_NODETYPE_FILTER_MODRM_REG:
        ZYAN_ASSERT(index <   8);
        return &FILTERS_MODRM_REG[parent->value][index];
    case ZYDIS_NODETYPE_FILTER_MODRM_RM:
        ZYAN_ASSERT(index <   8);
        return &FILTERS_MODRM_RM[parent->value][index];
    case ZYDIS_NODETYPE_FILTER_PREFIX_GROUP1:
        ZYAN_ASSERT(index < 2);
        return &FILTERS_PREFIX_GROUP1[parent->value][index];
    case ZYDIS_NODETYPE_FILTER_MANDATORY_PREFIX:
        ZYAN_ASSERT(index <   5);
        return &FILTERS_MANDATORY_PREFIX[parent->value][index];
    case ZYDIS_NODETYPE_FILTER_OPERAND_SIZE:
        ZYAN_ASSERT(index <   3);
        return &FILTERS_OPERAND_SIZE[parent->value][index];
    case ZYDIS_NODETYPE_FILTER_ADDRESS_SIZE:
        ZYAN_ASSERT(index <   3);
        return &FILTERS_ADDRESS_SIZE[parent->value][index];
    case ZYDIS_NODETYPE_FILTER_VECTOR_LENGTH:
        ZYAN_ASSERT(index <   3);
        return &FILTERS_VECTOR_LENGTH[parent->value][index];
    case ZYDIS_NODETYPE_FILTER_REX_W:
        ZYAN_ASSERT(index <   2);
        return &FILTERS_REX_W[parent->value][index];
    case ZYDIS_NODETYPE_FILTER_REX_B:
        ZYAN_ASSERT(index <   2);
        return &FILTERS_REX_B[parent->value][index];
#ifndef ZYDIS_DISABLE_AVX512
    case ZYDIS_NODETYPE_FILTER_EVEX_B:
        ZYAN_ASSERT(index <   2);
        return &FILTERS_EVEX_B[parent->value][index];
#endif
#ifndef ZYDIS_DISABLE_KNC
    case ZYDIS_NODETYPE_FILTER_MVEX_E:
        ZYAN_ASSERT(index <   2);
        return &FILTERS_MVEX_E[parent->value][index];
#endif
    case ZYDIS_NODETYPE_FILTER_MODE_AMD:
        ZYAN_ASSERT(index <   2);
        return &FILTERS_MODE_AMD[parent->value][index];
    case ZYDIS_NODETYPE_FILTER_MODE_KNC:
        ZYAN_ASSERT(index <   2);
        return &FILTERS_MODE_KNC[parent->value][index];
    case ZYDIS_NODETYPE_FILTER_MODE_MPX:
        ZYAN_ASSERT(index <   2);
        return &FILTERS_MODE_MPX[parent->value][index];
    case ZYDIS_NODETYPE_FILTER_MODE_CET:
        ZYAN_ASSERT(index <   2);
        return &FILTERS_MODE_CET[parent->value][index];
    case ZYDIS_NODETYPE_FILTER_MODE_LZCNT:
        ZYAN_ASSERT(index <   2);
        return &FILTERS_MODE_LZCNT[parent->value][index];
    case ZYDIS_NODETYPE_FILTER_MODE_TZCNT:
        ZYAN_ASSERT(index <   2);
        return &FILTERS_MODE_TZCNT[parent->value][index];
    case ZYDIS_NODETYPE_FILTER_MODE_WBNOINVD:
        ZYAN_ASSERT(index <   2);
        return &FILTERS_MODE_WBNOINVD[parent->value][index];
    case ZYDIS_NODETYPE_FILTER_MODE_CLDEMOTE:
        ZYAN_ASSERT(index <   2);
        return &FILTERS_MODE_CLDEMOTE[parent->value][index];
    case ZYDIS_NODETYPE_FILTER_MODE_IPREFETCH:
        ZYAN_ASSERT(index <   2);
        return &FILTERS_MODE_IPREFETCH[parent->value][index];
    case ZYDIS_NODETYPE_FILTER_MODE_UD0_COMPAT:
        ZYAN_ASSERT(index <   2);
        return &FILTERS_MODE_UD0_COMPAT[parent->value][index];
    default:
        ZYAN_UNREACHABLE;
    }
}

void ZydisGetInstructionEncodingInfo(const ZydisDecoderTreeNode* node,
    const ZydisInstructionEncodingInfo** info)
{
    ZYAN_ASSERT(node->type & ZYDIS_NODETYPE_DEFINITION_MASK);
    const ZyanU8 class = (node->type) & 0x7F;
    ZYAN_ASSERT(class < ZYAN_ARRAY_LENGTH(INSTR_ENCODINGS));
    *info = &INSTR_ENCODINGS[class];
}

/* ---------------------------------------------------------------------------------------------- */

/* ============================================================================================== */

//
// Source file: /home/ath/devel/zydis/src/Disassembler.c
//

/***************************************************************************************************

  Zyan Disassembler Library (Zydis)

  Original Author : Joel Hoener

 * Permission is hereby granted, free of charge, to any person obtaining a copy
 * of this software and associated documentation files (the "Software"), to deal
 * in the Software without restriction, including without limitation the rights
 * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
 * copies of the Software, and to permit persons to whom the Software is
 * furnished to do so, subject to the following conditions:
 *
 * The above copyright notice and this permission notice shall be included in all
 * copies or substantial portions of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
 * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
 * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
 * SOFTWARE.

***************************************************************************************************/


/* ============================================================================================== */
/* Internal helpers                                                                               */
/* ============================================================================================== */

static ZyanStatus ZydisDisassemble(ZydisMachineMode machine_mode,
    ZyanU64 runtime_address, const void* buffer, ZyanUSize length,
    ZydisDisassembledInstruction *instruction, ZydisFormatterStyle style)
{
    if (!buffer || !instruction)
    {
        return ZYAN_STATUS_INVALID_ARGUMENT;
    }

    *instruction = (ZydisDisassembledInstruction)
    {
      .runtime_address = runtime_address
    };

    // Derive the stack width from the address width.
    ZydisStackWidth stack_width;
    switch (machine_mode)
    {
    case ZYDIS_MACHINE_MODE_LONG_64:
        stack_width = ZYDIS_STACK_WIDTH_64;
        break;
    case ZYDIS_MACHINE_MODE_LONG_COMPAT_32:
    case ZYDIS_MACHINE_MODE_LEGACY_32:
        stack_width = ZYDIS_STACK_WIDTH_32;
        break;
    case ZYDIS_MACHINE_MODE_LONG_COMPAT_16:
    case ZYDIS_MACHINE_MODE_LEGACY_16:
    case ZYDIS_MACHINE_MODE_REAL_16:
        stack_width = ZYDIS_STACK_WIDTH_16;
        break;
    default:
        return ZYAN_STATUS_INVALID_ARGUMENT;
    }

    ZydisDecoder decoder;
    ZYAN_CHECK(ZydisDecoderInit(&decoder, machine_mode, stack_width));

    ZydisDecoderContext ctx;
    ZYAN_CHECK(ZydisDecoderDecodeInstruction(&decoder, &ctx, buffer, length, &instruction->info));
    ZYAN_CHECK(ZydisDecoderDecodeOperands(&decoder, &ctx, &instruction->info,
        instruction->operands, instruction->info.operand_count));

    ZydisFormatter formatter;
    ZYAN_CHECK(ZydisFormatterInit(&formatter, style));
    ZYAN_CHECK(ZydisFormatterFormatInstruction(&formatter, &instruction->info,
        instruction->operands, instruction->info.operand_count_visible, instruction->text,
        sizeof(instruction->text), runtime_address, ZYAN_NULL));

    return ZYAN_STATUS_SUCCESS;
}

/* ============================================================================================== */
/* Public functions                                                                               */
/* ============================================================================================== */

ZyanStatus ZydisDisassembleIntel(ZydisMachineMode machine_mode,
    ZyanU64 runtime_address, const void* buffer, ZyanUSize length,
    ZydisDisassembledInstruction *instruction)
{
    return ZydisDisassemble(machine_mode, runtime_address, buffer, length, instruction,
        ZYDIS_FORMATTER_STYLE_INTEL);
}

ZyanStatus ZydisDisassembleATT(ZydisMachineMode machine_mode,
    ZyanU64 runtime_address, const void* buffer, ZyanUSize length,
    ZydisDisassembledInstruction *instruction)
{
    return ZydisDisassemble(machine_mode, runtime_address, buffer, length, instruction,
        ZYDIS_FORMATTER_STYLE_ATT);
}

/* ============================================================================================== */

//
// Source file: /home/ath/devel/zydis/src/Encoder.c
//

/***************************************************************************************************

  Zyan Disassembler Library (Zydis)

  Original Author : Mappa

 * Permission is hereby granted, free of charge, to any person obtaining a copy
 * of this software and associated documentation files (the "Software"), to deal
 * in the Software without restriction, including without limitation the rights
 * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
 * copies of the Software, and to permit persons to whom the Software is
 * furnished to do so, subject to the following conditions:
 *
 * The above copyright notice and this permission notice shall be included in all
 * copies or substantial portions of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
 * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
 * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
 * SOFTWARE.

***************************************************************************************************/

// ReSharper disable CppClangTidyClangDiagnosticSwitchEnum
// ReSharper disable CppClangTidyClangDiagnosticCoveredSwitchDefault
// ReSharper disable CppClangTidyClangDiagnosticImplicitFallthrough


//
// Header: Zydis/Internal/EncoderData.h
//

/***************************************************************************************************

  Zyan Disassembler Library (Zydis)

  Original Author : Mappa

 * Permission is hereby granted, free of charge, to any person obtaining a copy
 * of this software and associated documentation files (the "Software"), to deal
 * in the Software without restriction, including without limitation the rights
 * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
 * copies of the Software, and to permit persons to whom the Software is
 * furnished to do so, subject to the following conditions:
 *
 * The above copyright notice and this permission notice shall be included in all
 * copies or substantial portions of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
 * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
 * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
 * SOFTWARE.

***************************************************************************************************/

#ifndef ZYDIS_INTERNAL_ENCODERDATA_H
#define ZYDIS_INTERNAL_ENCODERDATA_H


/**
 * Used in encoder's table to represent standard ISA sizes in form of bit flags.
 */
typedef enum ZydisWidthFlag_
{
    ZYDIS_WIDTH_INVALID = 0x00,
    ZYDIS_WIDTH_16      = 0x01,
    ZYDIS_WIDTH_32      = 0x02,
    ZYDIS_WIDTH_64      = 0x04,

    /**
     * Maximum value of this enum.
     */
    ZYDIS_WIDTH_MAX_VALUE = (ZYDIS_WIDTH_64 | (ZYDIS_WIDTH_64 - 1)),
    /**
     * The minimum number of bits required to represent all values of this enum.
     */
    ZYDIS_WIDTH_REQUIRED_BITS = ZYAN_BITS_TO_REPRESENT(ZYDIS_WIDTH_MAX_VALUE)
} ZydisWidthFlag;

/**
 * Used in encoder's table to represent mandatory instruction prefix. Using this enum instead of
 * actual prefix value saves space.
 */
typedef enum ZydisMandatoryPrefix_
{
    ZYDIS_MANDATORY_PREFIX_NONE,
    ZYDIS_MANDATORY_PREFIX_66,
    ZYDIS_MANDATORY_PREFIX_F2,
    ZYDIS_MANDATORY_PREFIX_F3,

    /**
     * Maximum value of this enum.
     */
    ZYDIS_MANDATORY_PREFIX_MAX_VALUE = ZYDIS_MANDATORY_PREFIX_F3,
    /**
     * The minimum number of bits required to represent all values of this enum.
     */
    ZYDIS_MANDATORY_PREFIX_REQUIRED_BITS = ZYAN_BITS_TO_REPRESENT(ZYDIS_MANDATORY_PREFIX_MAX_VALUE)
} ZydisMandatoryPrefix;

/**
 * Used in encoder's table to represent vector size supported by instruction definition.
 */
typedef enum ZydisVectorLength_
{
    ZYDIS_VECTOR_LENGTH_INVALID,
    ZYDIS_VECTOR_LENGTH_128,
    ZYDIS_VECTOR_LENGTH_256,
    ZYDIS_VECTOR_LENGTH_512,

    /**
     * Maximum value of this enum.
     */
    ZYDIS_VECTOR_LENGTH_MAX_VALUE = ZYDIS_VECTOR_LENGTH_512,
    /**
     * The minimum number of bits required to represent all values of this enum.
     */
    ZYDIS_VECTOR_LENGTH_REQUIRED_BITS = ZYAN_BITS_TO_REPRESENT(ZYDIS_VECTOR_LENGTH_MAX_VALUE)
} ZydisVectorLength;

/**
 * Used in encoder's table to represent hint type supported by instruction definition.
 */
typedef enum ZydisSizeHint_
{
    ZYDIS_SIZE_HINT_NONE,
    ZYDIS_SIZE_HINT_ASZ,
    ZYDIS_SIZE_HINT_OSZ,

    /**
     * Maximum value of this enum.
     */
    ZYDIS_SIZE_HINT_MAX_VALUE = ZYDIS_SIZE_HINT_OSZ,
    /**
     * The minimum number of bits required to represent all values of this enum.
     */
    ZYDIS_SIZE_HINT_REQUIRED_BITS = ZYAN_BITS_TO_REPRESENT(ZYDIS_SIZE_HINT_MAX_VALUE)
} ZydisSizeHint;

/**
 * Used in encoder's primary lookup table which allows to access a set of instruction definitions
 * for specified mnemonic in constant time.
 */
typedef struct ZydisEncoderLookupEntry_
{
    /**
     * Index to main array of `ZydisEncodableInstruction`.
     */
    ZyanU16 encoder_reference;
    /**
     * The number of entries.
     */
    ZyanU8 instruction_count;
} ZydisEncoderLookupEntry;

#pragma pack(push, 1)

/**
 * This structure is encoder's internal representation of encodable instruction definition.
 */
typedef struct ZydisEncodableInstruction_
{
    /**
     * Index to one of decoder's instruction definition arrays.
     */
    ZyanU16 instruction_reference;
    /**
     * Compressed information about operand count and types. Operand count is stored in lowest bits.
     * Types of subsequent operands are stored in higher bits.
     */
    ZyanU16 operand_mask;
    /**
     * The instruction-opcode.
     */
    ZyanU8 opcode;
    /**
     * The mandatory ModR/M value.
     */
    ZyanU8 modrm;
    /**
     * The instruction-encoding.
     */
    ZyanU8 encoding                 ZYAN_BITFIELD(ZYDIS_INSTRUCTION_ENCODING_REQUIRED_BITS);
    /**
     * The opcode map.
     */
    ZyanU8 opcode_map               ZYAN_BITFIELD(ZYDIS_OPCODE_MAP_REQUIRED_BITS);
    /**
     * The combination of allowed processor modes.
     */
    ZyanU8 modes                    ZYAN_BITFIELD(ZYDIS_WIDTH_REQUIRED_BITS);
    /**
     * The combination of allowed address sizes.
     */
    ZyanU8 address_sizes            ZYAN_BITFIELD(ZYDIS_WIDTH_REQUIRED_BITS);
    /**
     * The combination of allowed operand sizes.
     */
    ZyanU8 operand_sizes            ZYAN_BITFIELD(ZYDIS_WIDTH_REQUIRED_BITS);
    /**
     * The mandatory prefix.
     */
    ZyanU8 mandatory_prefix         ZYAN_BITFIELD(ZYDIS_MANDATORY_PREFIX_REQUIRED_BITS);
    /**
     * True if `REX.W` is required for this definition.
     */
    ZyanU8 rex_w                    ZYAN_BITFIELD(1);
    /**
     * The vector length.
     */
    ZyanU8 vector_length            ZYAN_BITFIELD(ZYDIS_MANDATORY_PREFIX_REQUIRED_BITS);
    /**
     * The accepted sizing hint.
     */
    ZyanU8 accepts_hint             ZYAN_BITFIELD(ZYDIS_SIZE_HINT_REQUIRED_BITS);
    /**
     * Indicates that next instruction definition can be safely used instead of current one. This
     * is used with some `VEX` instructions to take advantage of 2-byte `VEX` prefix when possible.
     * 2-byte `VEX` allows to use high registers only when operand is encoded in `modrm_reg`
     * (high bit in `REX.R`). Encoder uses swappable definitions to take advantage of this
     * optimization opportunity.
     *
     * Second use of this field is to handle special case for `mov` instruction. This particular
     * conflict is described in detail inside `ZydisHandleSwappableDefinition`.
     */
    ZyanU8 swappable                ZYAN_BITFIELD(1);
} ZydisEncodableInstruction;

#pragma pack(pop)

/**
 * Contains information used by instruction size prediction algorithm inside
 * `ZydisEncoderEncodeInstructionAbsolute`.
 */
typedef struct ZydisEncoderRelInfo_
{
    /**
     * Sizes of instruction variants. First index is effective address size. Second index is
     * desired immediate size (8, 16 and 32 bits respectively).
     */
    ZyanU8 size[3][3];
    /**
     * See `ZydisSizeHint`.
     */
    ZyanU8 accepts_scaling_hints;
    /**
     * True if instruction accepts branch hint prefixes.
     */
    ZyanBool accepts_branch_hints;
    /**
     * True if instruction accepts bound (`BND`) prefix.
     */
    ZyanBool accepts_bound;
} ZydisEncoderRelInfo;

/**
 * Fetches array of `ZydisEncodableInstruction` structures and its size for given instruction
 * mnemonic.
 *
 * @param   mnemonic    Instruction mnemonic.
 * @param   instruction This variable will receive a pointer to the array of
 *                      `ZydisEncodableInstruction` structures.
 *
 * @return  Entry count (0 if function failed).
 */
ZyanU8 ZydisGetEncodableInstructions(ZydisMnemonic mnemonic,
    const ZydisEncodableInstruction **instruction);

/**
 * Fetches `ZydisEncoderRelInfo` record for given instruction mnemonic.
 *
 * @param   mnemonic    Instruction mnemonic.
 *
 * @return  Pointer to `ZydisEncoderRelInfo` structure or `ZYAN_NULL` if instruction doesn't have
 *          relative operands.
 */
const ZydisEncoderRelInfo *ZydisGetRelInfo(ZydisMnemonic mnemonic);

#endif /* ZYDIS_INTERNAL_ENCODERDATA_H */

/* ============================================================================================== */
/* Macros                                                                                         */
/* ============================================================================================== */

/* ---------------------------------------------------------------------------------------------- */
/* Constants                                                                                      */
/* ---------------------------------------------------------------------------------------------- */

#define ZYDIS_OPSIZE_MAP_BYTEOP                 1
#define ZYDIS_OPSIZE_MAP_DEFAULT64              4
#define ZYDIS_OPSIZE_MAP_FORCE64                5
#define ZYDIS_ADSIZE_MAP_IGNORED                1
#define ZYDIS_LEGACY_SEGMENTS                   (ZYDIS_ATTRIB_HAS_SEGMENT_CS | \
                                                 ZYDIS_ATTRIB_HAS_SEGMENT_SS | \
                                                 ZYDIS_ATTRIB_HAS_SEGMENT_DS | \
                                                 ZYDIS_ATTRIB_HAS_SEGMENT_ES)
#define ZYDIS_ENCODABLE_PREFIXES_NO_SEGMENTS    (ZYDIS_ENCODABLE_PREFIXES ^ \
                                                 ZYDIS_ATTRIB_HAS_SEGMENT)

/* ---------------------------------------------------------------------------------------------- */

/* ============================================================================================== */
/* Internal enums and types                                                                       */
/* ============================================================================================== */

/**
 * Usage of `REX.W` prefix makes it impossible to use some byte-sized registers. Values of this
 * enum are used to track and facilitate enforcement of these restrictions.
 */
typedef enum ZydisEncoderRexType_
{
    ZYDIS_REX_TYPE_UNKNOWN,
    ZYDIS_REX_TYPE_REQUIRED,
    ZYDIS_REX_TYPE_FORBIDDEN,

    /**
     * Maximum value of this enum.
     */
    ZYDIS_REX_TYPE_MAX_VALUE = ZYDIS_REX_TYPE_FORBIDDEN,
    /**
     * The minimum number of bits required to represent all values of this enum.
     */
    ZYDIS_REX_TYPE_REQUIRED_BITS = ZYAN_BITS_TO_REPRESENT(ZYDIS_REX_TYPE_MAX_VALUE)
} ZydisEncoderRexType;

/**
 * Primary structure used during instruction matching phase. Once filled it contains information
 * about matched instruction definition and some values deduced from encoder request. It gets
 * converted to `ZydisEncoderInstruction` during instruction building phase.
 */
typedef struct ZydisEncoderInstructionMatch_
{
    /**
     * A pointer to the `ZydisEncoderRequest` instance.
     */
    const ZydisEncoderRequest *request;
    /**
     * A pointer to the `ZydisEncodableInstruction` instance.
     */
    const ZydisEncodableInstruction *definition;
    /**
     * A pointer to the `ZydisInstructionDefinition` instance.
     */
    const ZydisInstructionDefinition *base_definition;
    /**
     * A pointer to the `ZydisOperandDefinition` array.
     */
    const ZydisOperandDefinition *operands;
    /**
     * Encodable attributes for this instruction.
     */
    ZydisInstructionAttributes attributes;
    /**
     * Effective operand size attribute.
     */
    ZyanU8 eosz;
    /**
     * Effective address size attribute.
     */
    ZyanU8 easz;
    /**
     * Effective displacement size.
     */
    ZyanU8 disp_size;
    /**
     * Effective immediate size.
     */
    ZyanU8 imm_size;
    /**
     * Exponent of compressed displacement scale factor (2^cd8_scale)
     */
    ZyanU8 cd8_scale;
    /**
     * `REX` prefix constraints.
     */
    ZydisEncoderRexType rex_type;
    /**
     * True for special cases where operand size attribute must be lower than 64 bits.
     */
    ZyanBool eosz64_forbidden;
    /**
     * True when instruction definition has relative operand (used for branching instructions).
     */
    ZyanBool has_rel_operand;
} ZydisEncoderInstructionMatch;

/**
 * Encapsulates information about writable buffer.
 */
typedef struct ZydisEncoderBuffer_
{
    /**
     * A pointer to actual data buffer.
     */
    ZyanU8 *buffer;
    /**
     * Size of this buffer.
     */
    ZyanUSize size;
    /**
     * Current write offset.
     */
    ZyanUSize offset;
} ZydisEncoderBuffer;

/**
 * Low-level instruction representation. Once filled this structure contains all information
 * required for final instruction emission phase.
 */
typedef struct ZydisEncoderInstruction_
{
    /**
     * Encodable attributes for this instruction.
     */
    ZydisInstructionAttributes attributes;
    /**
     * The instruction encoding.
     */
    ZydisInstructionEncoding encoding;
    /**
     * The opcode map.
     */
    ZydisOpcodeMap opcode_map;
    /**
     * The opcode.
     */
    ZyanU8 opcode;
    /**
     * The `vvvv` field (`VEX`, `EVEX`, `MVEX`, `XOP`).
     */
    ZyanU8 vvvv;
    /**
     * The `sss` field (`MVEX`).
     */
    ZyanU8 sss;
    /**
     * The mask register ID.
     */
    ZyanU8 mask;
    /**
     * The vector length.
     */
    ZyanU8 vector_length;
    /**
     * The `mod` component of Mod/RM byte.
     */
    ZyanU8 mod;
    /**
     * The `reg` component of Mod/RM byte.
     */
    ZyanU8 reg;
    /**
     * The `rm` component of Mod/RM byte.
     */
    ZyanU8 rm;
    /**
     * The scale component of SIB byte.
     */
    ZyanU8 scale;
    /**
     * The index component of SIB byte.
     */
    ZyanU8 index;
    /**
     * The base component of SIB byte.
     */
    ZyanU8 base;
    /**
     * The `REX.W` bit.
     */
    ZyanBool rex_w;
    /**
     * True if using zeroing mask (`EVEX`).
     */
    ZyanBool zeroing;
    /**
     * True if using eviction hint (`MVEX`).
     */
    ZyanBool eviction_hint;
    /**
     * Size of displacement value.
     */
    ZyanU8 disp_size;
    /**
     * Size of immediate value.
     */
    ZyanU8 imm_size;
    /**
     * The displacement value.
     */
    ZyanU64 disp;
    /**
     * The immediate value.
     */
    ZyanU64 imm;
} ZydisEncoderInstruction;

/* ============================================================================================== */
/* Internal functions                                                                             */
/* ============================================================================================== */

/**
 * Converts `ZydisInstructionEncoding` to `ZydisEncodableEncoding`.
 *
 * @param   encoding `ZydisInstructionEncoding` value to convert.
 *
 * @return  Equivalent `ZydisEncodableEncoding` value.
 */
static ZydisEncodableEncoding ZydisGetEncodableEncoding(ZydisInstructionEncoding encoding)
{
    static const ZydisEncodableEncoding encoding_lookup[6] =
    {
        ZYDIS_ENCODABLE_ENCODING_LEGACY,
        ZYDIS_ENCODABLE_ENCODING_3DNOW,
        ZYDIS_ENCODABLE_ENCODING_XOP,
        ZYDIS_ENCODABLE_ENCODING_VEX,
        ZYDIS_ENCODABLE_ENCODING_EVEX,
        ZYDIS_ENCODABLE_ENCODING_MVEX,
    };
    ZYAN_ASSERT((ZyanUSize)encoding <= ZYDIS_INSTRUCTION_ENCODING_MAX_VALUE);
    return encoding_lookup[encoding];
}

/**
 * Converts `ZydisMachineMode` to default stack width value expressed in bits.
 *
 * @param   machine_mode `ZydisMachineMode` value to convert.
 *
 * @return  Stack width for requested machine mode.
 */
static ZyanU8 ZydisGetMachineModeWidth(ZydisMachineMode machine_mode)
{
    ZYAN_ASSERT((ZyanUSize)machine_mode <= ZYDIS_MACHINE_MODE_MAX_VALUE);
    static const ZyanU8 lookup[6] =
    {
        /* ZYDIS_MACHINE_MODE_LONG_64 */            64,
        /* ZYDIS_MACHINE_MODE_LONG_COMPAT_32 */     32,
        /* ZYDIS_MACHINE_MODE_LONG_COMPAT_16 */     16,
        /* ZYDIS_MACHINE_MODE_LEGACY_32 */          32,
        /* ZYDIS_MACHINE_MODE_LEGACY_16 */          16,
        /* ZYDIS_MACHINE_MODE_REAL_16 */            16,
    };
    return lookup[machine_mode];
}

/**
 * Converts `ZydisAddressSizeHint` to address size expressed in bits.
 *
 * @param   hint Address size hint.
 *
 * @return  Address size in bits.
 */
static ZyanU8 ZydisGetAszFromHint(ZydisAddressSizeHint hint)
{
    ZYAN_ASSERT((ZyanUSize)hint <= ZYDIS_ADDRESS_SIZE_HINT_MAX_VALUE);
    static const ZyanU8 lookup[ZYDIS_ADDRESS_SIZE_HINT_MAX_VALUE + 1] = { 0, 16, 32, 64 };
    return lookup[hint];
}

/**
 * Converts `ZydisOperandSizeHint` to operand size expressed in bits.
 *
 * @param   hint Operand size hint.
 *
 * @return  Operand size in bits.
 */
static ZyanU8 ZydisGetOszFromHint(ZydisOperandSizeHint hint)
{
    ZYAN_ASSERT((ZyanUSize)hint <= ZYDIS_OPERAND_SIZE_HINT_MAX_VALUE);
    static const ZyanU8 lookup[ZYDIS_OPERAND_SIZE_HINT_MAX_VALUE + 1] = { 0, 8, 16, 32, 64 };
    return lookup[hint];
}

/**
 * Calculates maximum size of absolute address value based on address size hint.
 *
 * @param   request A pointer to `ZydisEncoderRequest` struct.
 *
 * @return  Maximum address size in bits.
 */
static ZyanU8 ZydisGetMaxAddressSize(const ZydisEncoderRequest *request)
{
    ZyanU8 addr_size = ZydisGetAszFromHint(request->address_size_hint);
    if (addr_size == 0)
    {
        addr_size = ZydisGetMachineModeWidth(request->machine_mode);
    }
    return addr_size;
}

/**
 * Calculates effective operand size.
 *
 * @param   match            A pointer to `ZydisEncoderInstructionMatch` struct.
 * @param   size_table       Array of possible size values for different operand sizes.
 * @param   desired_size     Operand size requested by caller.
 * @param   exact_match_mode True if desired_size must be matched exactly, false when
 *                           "not lower than" matching is desired.
 *
 * @return  Effective operand size in bits.
 */
static ZyanU8 ZydisGetOperandSizeFromElementSize(ZydisEncoderInstructionMatch *match,
    const ZyanU16 *size_table, ZyanU16 desired_size, ZyanBool exact_match_mode)
{
    if ((match->base_definition->operand_size_map == ZYDIS_OPSIZE_MAP_DEFAULT64) &&
        (match->request->machine_mode == ZYDIS_MACHINE_MODE_LONG_64))
    {
        if ((exact_match_mode && (size_table[2] == desired_size)) ||
            (!exact_match_mode && (size_table[2] >= desired_size)))
        {
            return 64;
        }
        else if (size_table[0] == desired_size)
        {
            return 16;
        }
    }
    else if ((match->base_definition->operand_size_map == ZYDIS_OPSIZE_MAP_FORCE64) &&
             (match->request->machine_mode == ZYDIS_MACHINE_MODE_LONG_64))
    {
        if (size_table[2] == desired_size)
        {
            return 64;
        }
    }
    else
    {
        static const ZyanI8 eosz_priority_lookup[4][3] =
        {
            {  0,  1, -1 },
            {  1,  0, -1 },
            {  1,  2,  0 },
        };
        const ZyanU8 eosz_index = ZydisGetMachineModeWidth(match->request->machine_mode) >> 5;
        for (int i = 0; i < 3; ++i)
        {
            const ZyanI8 eosz_candidate = eosz_priority_lookup[eosz_index][i];
            if ((eosz_candidate == -1) ||
                !(match->definition->operand_sizes & (1 << eosz_candidate)))
            {
                continue;
            }
            if ((exact_match_mode && (size_table[eosz_candidate] == desired_size)) ||
                (!exact_match_mode && (size_table[eosz_candidate] >= desired_size)))
            {
                return 16 << eosz_candidate;
            }
        }
    }

    return 0;
}

/**
 * Calculates effective immediate size.
 *
 * @param   match        A pointer to `ZydisEncoderInstructionMatch` struct.
 * @param   size_table   Array of possible size values for different operand sizes.
 * @param   min_imm_size Minimum immediate size.
 *
 * @return  Effective operand size in bits.
 */
static ZyanU8 ZydisGetScaledImmSize(ZydisEncoderInstructionMatch *match, const ZyanU16 *size_table,
    ZyanU8 min_imm_size)
{
    if (match->eosz == 0)
    {
        match->eosz = ZydisGetOperandSizeFromElementSize(match, size_table, min_imm_size,
            ZYAN_FALSE);
        return match->eosz != 0 ? (ZyanU8)size_table[match->eosz >> 5] : 0;
    }

    const ZyanU8 index = match->eosz >> 5;
    return size_table[index] >= min_imm_size ? (ZyanU8)size_table[index] : 0;
}

/**
 * Calculates size of smallest integral type able to represent provided signed value.
 *
 * @param   imm Immediate to be represented.
 *
 * @return  Size of smallest integral type able to represent provided signed value.
 */
static ZyanU8 ZydisGetSignedImmSize(ZyanI64 imm)
{
    if (imm >= ZYAN_INT8_MIN && imm <= ZYAN_INT8_MAX)
    {
        return 8;
    }
    if (imm >= ZYAN_INT16_MIN && imm <= ZYAN_INT16_MAX)
    {
        return 16;
    }
    if (imm >= ZYAN_INT32_MIN && imm <= ZYAN_INT32_MAX)
    {
        return 32;
    }

    return 64;
}

/**
 * Calculates size of smallest integral type able to represent provided unsigned value.
 *
 * @param   imm Immediate to be represented.
 *
 * @return  Size of smallest integral type able to represent provided unsigned value.
 */
static ZyanU8 ZydisGetUnsignedImmSize(ZyanU64 imm)
{
    if (imm <= ZYAN_UINT8_MAX)
    {
        return 8;
    }
    if (imm <= ZYAN_UINT16_MAX)
    {
        return 16;
    }
    if (imm <= ZYAN_UINT32_MAX)
    {
        return 32;
    }

    return 64;
}

/**
 * Checks if operand encoding encodes a signed immediate value.
 *
 * @param   encoding Operand encoding for immediate value.
 *
 * @return  True for encodings that represent signed values, false otherwise.
 */
static ZyanBool ZydisIsImmSigned(ZydisOperandEncoding encoding)
{
    switch (encoding)
    {
    case ZYDIS_OPERAND_ENCODING_SIMM8:
    case ZYDIS_OPERAND_ENCODING_SIMM16:
    case ZYDIS_OPERAND_ENCODING_SIMM32:
    case ZYDIS_OPERAND_ENCODING_SIMM64:
    case ZYDIS_OPERAND_ENCODING_SIMM16_32_64:
    case ZYDIS_OPERAND_ENCODING_SIMM32_32_64:
    case ZYDIS_OPERAND_ENCODING_SIMM16_32_32:
    case ZYDIS_OPERAND_ENCODING_JIMM8:
    case ZYDIS_OPERAND_ENCODING_JIMM16:
    case ZYDIS_OPERAND_ENCODING_JIMM32:
    case ZYDIS_OPERAND_ENCODING_JIMM64:
    case ZYDIS_OPERAND_ENCODING_JIMM16_32_64:
    case ZYDIS_OPERAND_ENCODING_JIMM32_32_64:
    case ZYDIS_OPERAND_ENCODING_JIMM16_32_32:
    case ZYDIS_OPERAND_ENCODING_DISP8:
    case ZYDIS_OPERAND_ENCODING_DISP16:
    case ZYDIS_OPERAND_ENCODING_DISP32:
    case ZYDIS_OPERAND_ENCODING_DISP64:
    case ZYDIS_OPERAND_ENCODING_DISP16_32_64:
    case ZYDIS_OPERAND_ENCODING_DISP32_32_64:
    case ZYDIS_OPERAND_ENCODING_DISP16_32_32:
        return ZYAN_TRUE;
    case ZYDIS_OPERAND_ENCODING_UIMM8:
    case ZYDIS_OPERAND_ENCODING_UIMM16:
    case ZYDIS_OPERAND_ENCODING_UIMM32:
    case ZYDIS_OPERAND_ENCODING_UIMM64:
    case ZYDIS_OPERAND_ENCODING_UIMM16_32_64:
    case ZYDIS_OPERAND_ENCODING_UIMM32_32_64:
    case ZYDIS_OPERAND_ENCODING_UIMM16_32_32:
    case ZYDIS_OPERAND_ENCODING_IS4:
        return ZYAN_FALSE;
    default:
        ZYAN_UNREACHABLE;
    }
}

/**
 * Calculates effective immediate size.
 *
 * @param   match   A pointer to `ZydisEncoderInstructionMatch` struct.
 * @param   imm     Immediate value to encode.
 * @param   def_op  Operand definition for immediate operand.
 *
 * @return  Effective operand size in bits (0 if function failed).
 */
static ZyanU8 ZydisGetEffectiveImmSize(ZydisEncoderInstructionMatch *match, ZyanI64 imm,
    const ZydisOperandDefinition *def_op)
{
    ZyanU8 eisz = 0;
    ZyanU8 min_size = ZydisIsImmSigned((ZydisOperandEncoding)def_op->op.encoding)
        ? ZydisGetSignedImmSize(imm)
        : ZydisGetUnsignedImmSize((ZyanU64)imm);

    switch (def_op->op.encoding)
    {
    case ZYDIS_OPERAND_ENCODING_UIMM8:
    case ZYDIS_OPERAND_ENCODING_SIMM8:
        eisz = 8;
        break;
    case ZYDIS_OPERAND_ENCODING_IS4:
        ZYAN_ASSERT(def_op->element_type == ZYDIS_IELEMENT_TYPE_UINT8);
        eisz = ((ZyanU64)imm <= 15) ? 8 : 0;
        break;
    case ZYDIS_OPERAND_ENCODING_UIMM16:
    case ZYDIS_OPERAND_ENCODING_SIMM16:
        eisz = 16;
        break;
    case ZYDIS_OPERAND_ENCODING_UIMM32:
    case ZYDIS_OPERAND_ENCODING_SIMM32:
        eisz = 32;
        break;
    case ZYDIS_OPERAND_ENCODING_UIMM64:
    case ZYDIS_OPERAND_ENCODING_SIMM64:
        eisz = 64;
        break;
    case ZYDIS_OPERAND_ENCODING_UIMM16_32_64:
    case ZYDIS_OPERAND_ENCODING_SIMM16_32_64:
    {
        static const ZyanU16 simm16_32_64_sizes[3] = { 16, 32, 64 };
        return ZydisGetScaledImmSize(match, simm16_32_64_sizes, min_size);
    }
    case ZYDIS_OPERAND_ENCODING_UIMM32_32_64:
    case ZYDIS_OPERAND_ENCODING_SIMM32_32_64:
    {
        static const ZyanU16 simm32_32_64_sizes[3] = { 32, 32, 64 };
        return ZydisGetScaledImmSize(match, simm32_32_64_sizes, min_size);
    }
    case ZYDIS_OPERAND_ENCODING_UIMM16_32_32:
    case ZYDIS_OPERAND_ENCODING_SIMM16_32_32:
    {
        static const ZyanU16 simm16_32_32_sizes[3] = { 16, 32, 32 };
        return ZydisGetScaledImmSize(match, simm16_32_32_sizes, min_size);
    }
    case ZYDIS_OPERAND_ENCODING_DISP16_32_64:
    {
        ZYAN_ASSERT(match->easz == 0);
        const ZyanU8 addr_size = ZydisGetMaxAddressSize(match->request);
        const ZyanU64 uimm = imm & (~(0xFFFFFFFFFFFFFFFFULL << (addr_size - 1) << 1));
        if (min_size < addr_size && ZydisGetUnsignedImmSize(uimm) > min_size)
        {
            min_size = addr_size;
        }
        if (match->request->machine_mode == ZYDIS_MACHINE_MODE_LONG_64)
        {
            if (min_size < 32)
            {
                min_size = 32;
            }
            match->easz = eisz = min_size;
        }
        else
        {
            if (min_size < 16)
            {
                min_size = 16;
            }
            if (min_size == 16 || min_size == 32)
            {
                match->easz = eisz = min_size;
            }
        }
        break;
    }
    case ZYDIS_OPERAND_ENCODING_JIMM8:
    case ZYDIS_OPERAND_ENCODING_JIMM16:
    case ZYDIS_OPERAND_ENCODING_JIMM32:
    case ZYDIS_OPERAND_ENCODING_JIMM64:
    {
        ZyanU8 jimm_index = def_op->op.encoding - ZYDIS_OPERAND_ENCODING_JIMM8;
        if ((match->request->branch_width != ZYDIS_BRANCH_WIDTH_NONE) &&
            (match->request->branch_width != (ZydisBranchWidth)(ZYDIS_BRANCH_WIDTH_8 + jimm_index)))
        {
            return 0;
        }
        eisz = 8 << jimm_index;
        break;
    }
    case ZYDIS_OPERAND_ENCODING_JIMM16_32_32:
        switch (match->request->branch_width)
        {
        case ZYDIS_BRANCH_WIDTH_NONE:
        {
            static const ZyanU16 jimm16_32_32_sizes[3] = { 16, 32, 32 };
            return ZydisGetScaledImmSize(match, jimm16_32_32_sizes, min_size);
        }
        case ZYDIS_BRANCH_WIDTH_16:
            eisz = 16;
            break;
        case ZYDIS_BRANCH_WIDTH_32:
            eisz = 32;
            break;
        case ZYDIS_BRANCH_WIDTH_8:
        case ZYDIS_BRANCH_WIDTH_64:
            return 0;
        default:
            ZYAN_UNREACHABLE;
        }
        break;
    default:
        ZYAN_UNREACHABLE;
    }

    return eisz >= min_size ? eisz : 0;
}

/**
 * Checks if register width is compatible with effective operand size.
 *
 * @param   match       A pointer to `ZydisEncoderInstructionMatch` struct.
 * @param   reg_width   Register width in bits.
 *
 * @return  True if width is compatible, false otherwise.
 */
static ZyanBool ZydisCheckOsz(ZydisEncoderInstructionMatch *match, ZydisRegisterWidth reg_width)
{
    ZYAN_ASSERT(reg_width <= ZYAN_UINT8_MAX);
    if (match->eosz == 0)
    {
        if (reg_width == 8)
        {
            return ZYAN_FALSE;
        }
        match->eosz = (ZyanU8)reg_width;
        return ZYAN_TRUE;
    }

    return match->eosz == (ZyanU8)reg_width ? ZYAN_TRUE : ZYAN_FALSE;
}

/**
 * Checks if register width is compatible with effective address size.
 *
 * @param   match       A pointer to `ZydisEncoderInstructionMatch` struct.
 * @param   reg_width   Register width in bits.
 *
 * @return  True if width is compatible, false otherwise.
 */
static ZyanBool ZydisCheckAsz(ZydisEncoderInstructionMatch *match, ZydisRegisterWidth reg_width)
{
    ZYAN_ASSERT(reg_width <= ZYAN_UINT8_MAX);
    if (match->easz == 0)
    {
        if ((match->request->machine_mode == ZYDIS_MACHINE_MODE_LONG_64) &&
            (reg_width == 16))
        {
            return ZYAN_FALSE;
        }
        match->easz = (ZyanU8)reg_width;
        return ZYAN_TRUE;
    }

    return match->easz == (ZyanU8)reg_width ? ZYAN_TRUE : ZYAN_FALSE;
}

/**
 * Checks if specified register is valid for provided register class, encoding and machine mode.
 *
 * @param   match       A pointer to `ZydisEncoderInstructionMatch` struct.
 * @param   reg         `ZydisRegister` value.
 * @param   reg_class   Register class.
 *
 * @return  True if register value is allowed, false otherwise.
 */
static ZyanBool ZydisIsRegisterAllowed(ZydisEncoderInstructionMatch *match, ZydisRegister reg,
    ZydisRegisterClass reg_class)
{
    const ZyanI8 reg_id = ZydisRegisterGetId(reg);
    ZYAN_ASSERT(reg_id >= 0 && reg_id <= 31);
    if (match->request->machine_mode == ZYDIS_MACHINE_MODE_LONG_64)
    {
        if ((match->definition->encoding != ZYDIS_INSTRUCTION_ENCODING_EVEX) &&
            (match->definition->encoding != ZYDIS_INSTRUCTION_ENCODING_MVEX) &&
            (reg_class != ZYDIS_REGCLASS_GPR8) &&
            (reg_id >= 16))
        {
            return ZYAN_FALSE;
        }
    }
    else
    {
        if (reg_class == ZYDIS_REGCLASS_GPR64)
        {
            return ZYAN_FALSE;
        }
        if (reg_id >= 8)
        {
            return ZYAN_FALSE;
        }
    }

    return ZYAN_TRUE;
}

/**
 * Checks if specified scale value is valid for use with SIB addressing.
 *
 * @param   scale Scale value.
 *
 * @return  True if value is valid, false otherwise.
 */
static ZyanBool ZydisIsScaleValid(ZyanU8 scale)
{
    switch (scale)
    {
    case 0:
    case 1:
    case 2:
    case 4:
    case 8:
        return ZYAN_TRUE;
    default:
        return ZYAN_FALSE;
    }
}

/**
 * Enforces register usage constraints associated with usage of `REX` prefix.
 *
 * @param   match               A pointer to `ZydisEncoderInstructionMatch` struct.
 * @param   reg                 `ZydisRegister` value.
 * @param   addressing_mode     True if checked address is used for address calculations. This
 *                              implies more permissive checks.
 *
 * @return  True if register usage is allowed, false otherwise.
 */
static ZyanBool ZydisValidateRexType(ZydisEncoderInstructionMatch *match, ZydisRegister reg,
    ZyanBool addressing_mode)
{
    switch (reg)
    {
    case ZYDIS_REGISTER_AL:
    case ZYDIS_REGISTER_CL:
    case ZYDIS_REGISTER_DL:
    case ZYDIS_REGISTER_BL:
        return ZYAN_TRUE;
    case ZYDIS_REGISTER_AH:
    case ZYDIS_REGISTER_CH:
    case ZYDIS_REGISTER_DH:
    case ZYDIS_REGISTER_BH:
        if (match->rex_type == ZYDIS_REX_TYPE_UNKNOWN)
        {
            match->rex_type = ZYDIS_REX_TYPE_FORBIDDEN;
        }
        else if (match->rex_type == ZYDIS_REX_TYPE_REQUIRED)
        {
            return ZYAN_FALSE;
        }
        break;
    case ZYDIS_REGISTER_SPL:
    case ZYDIS_REGISTER_BPL:
    case ZYDIS_REGISTER_SIL:
    case ZYDIS_REGISTER_DIL:
    case ZYDIS_REGISTER_R8B:
    case ZYDIS_REGISTER_R9B:
    case ZYDIS_REGISTER_R10B:
    case ZYDIS_REGISTER_R11B:
    case ZYDIS_REGISTER_R12B:
    case ZYDIS_REGISTER_R13B:
    case ZYDIS_REGISTER_R14B:
    case ZYDIS_REGISTER_R15B:
        if (match->rex_type == ZYDIS_REX_TYPE_UNKNOWN)
        {
            match->rex_type = ZYDIS_REX_TYPE_REQUIRED;
        }
        else if (match->rex_type == ZYDIS_REX_TYPE_FORBIDDEN)
        {
            return ZYAN_FALSE;
        }
        break;
    default:
        if ((ZydisRegisterGetId(reg) > 7) ||
            (!addressing_mode && (ZydisRegisterGetClass(reg) == ZYDIS_REGCLASS_GPR64)))
        {
            if (match->rex_type == ZYDIS_REX_TYPE_UNKNOWN)
            {
                match->rex_type = ZYDIS_REX_TYPE_REQUIRED;
            }
            else if (match->rex_type == ZYDIS_REX_TYPE_FORBIDDEN)
            {
                return ZYAN_FALSE;
            }
        }
        break;
    }

    return ZYAN_TRUE;
}

/**
 * Checks if specified register is valid for use with SIB addressing.
 *
 * @param   match          A pointer to `ZydisEncoderInstructionMatch` struct.
 * @param   reg_class      Register class.
 * @param   reg            `ZydisRegister` value.
 *
 * @return  True if register value is allowed, false otherwise.
 */
static ZyanBool ZydisIsValidAddressingClass(ZydisEncoderInstructionMatch *match,
    ZydisRegisterClass reg_class, ZydisRegister reg)
{
    ZyanBool result;
    const ZyanBool is_64 = (match->request->machine_mode == ZYDIS_MACHINE_MODE_LONG_64);
    switch (reg_class)
    {
    case ZYDIS_REGCLASS_INVALID:
        return ZYAN_TRUE;
    case ZYDIS_REGCLASS_GPR16:
        result = !is_64;
        break;
    case ZYDIS_REGCLASS_GPR32:
        result = is_64 || ZydisRegisterGetId(reg) < 8;
        break;
    case ZYDIS_REGCLASS_GPR64:
        result = is_64;
        break;
    default:
        return ZYAN_FALSE;
    }

    return result && ZydisValidateRexType(match, reg, ZYAN_TRUE);
}

/**
 * Helper function that determines correct `ModR/M.RM` value for 16-bit addressing mode.
 *
 * @param   base   `ZydisRegister` used as `SIB.base`.
 * @param   index  `ZydisRegister` used as `SIB.index`.
 *
 * @return  `ModR/M.RM` value (-1 if function failed).
 */
static ZyanI8 ZydisGetRm16(ZydisRegister base, ZydisRegister index)
{
    static const ZydisRegister modrm16_lookup[8][2] =
    {
        { ZYDIS_REGISTER_BX, ZYDIS_REGISTER_SI },
        { ZYDIS_REGISTER_BX, ZYDIS_REGISTER_DI },
        { ZYDIS_REGISTER_BP, ZYDIS_REGISTER_SI },
        { ZYDIS_REGISTER_BP, ZYDIS_REGISTER_DI },
        { ZYDIS_REGISTER_SI, ZYDIS_REGISTER_NONE },
        { ZYDIS_REGISTER_DI, ZYDIS_REGISTER_NONE },
        { ZYDIS_REGISTER_BP, ZYDIS_REGISTER_NONE },
        { ZYDIS_REGISTER_BX, ZYDIS_REGISTER_NONE },
    };
    for (ZyanI8 i = 0; i < (ZyanI8)ZYAN_ARRAY_LENGTH(modrm16_lookup); ++i)
    {
        if ((modrm16_lookup[i][0] == base) &&
            (modrm16_lookup[i][1] == index))
        {
            return i;
        }
    }

    return -1;
}

/**
 * Encodes `MVEX.sss` field for specified broadcast mode.
 *
 * @param   broadcast Broadcast mode.
 *
 * @return  Corresponding `MVEX.sss` value.
 */
static ZyanU8 ZydisEncodeMvexBroadcastMode(ZydisBroadcastMode broadcast)
{
    switch (broadcast)
    {
    case ZYDIS_BROADCAST_MODE_INVALID:
        return 0;
    case ZYDIS_BROADCAST_MODE_1_TO_16:
    case ZYDIS_BROADCAST_MODE_1_TO_8:
        return 1;
    case ZYDIS_BROADCAST_MODE_4_TO_16:
    case ZYDIS_BROADCAST_MODE_4_TO_8:
        return 2;
    default:
        ZYAN_UNREACHABLE;
    }
}

/**
 * Encodes `MVEX.sss` field for specified conversion mode.
 *
 * @param   conversion Conversion mode.
 *
 * @return  Corresponding `MVEX.sss` value.
 */
static ZyanU8 ZydisEncodeMvexConversionMode(ZydisConversionMode conversion)
{
    switch (conversion)
    {
    case ZYDIS_CONVERSION_MODE_INVALID:
        return 0;
    case ZYDIS_CONVERSION_MODE_FLOAT16:
        return 3;
    case ZYDIS_CONVERSION_MODE_UINT8:
        return 4;
    case ZYDIS_CONVERSION_MODE_SINT8:
        return 5;
    case ZYDIS_CONVERSION_MODE_UINT16:
        return 6;
    case ZYDIS_CONVERSION_MODE_SINT16:
        return 7;
    default:
        ZYAN_UNREACHABLE;
    }
}

/**
 * Determines scale factor for compressed 8-bit displacement (`EVEX` instructions only).
 *
 * @param   match   A pointer to `ZydisEncoderInstructionMatch` struct.
 *
 * @return  log2(scale factor)
 */
static ZyanU8 ZydisGetCompDispScaleEvex(const ZydisEncoderInstructionMatch *match)
{
    const ZydisInstructionDefinitionEVEX *evex_def =
        (const ZydisInstructionDefinitionEVEX *)match->base_definition;

    ZYAN_ASSERT(match->definition->encoding == ZYDIS_INSTRUCTION_ENCODING_EVEX);
    ZYAN_ASSERT(evex_def->tuple_type);
    ZYAN_ASSERT(evex_def->element_size);
    const ZyanU8 vector_length = match->definition->vector_length - ZYDIS_VECTOR_LENGTH_128;
    static const ZyanU8 size_indexes[ZYDIS_IELEMENT_SIZE_MAX_VALUE + 1] =
    {
        0, 0, 0, 1, 2, 4
    };
    ZYAN_ASSERT(evex_def->element_size < ZYAN_ARRAY_LENGTH(size_indexes));
    const ZyanU8 size_index = size_indexes[evex_def->element_size];
    switch (evex_def->tuple_type)
    {
    case ZYDIS_TUPLETYPE_FV:
    {
        static const ZyanU8 scales[2][3][3] =
        {
            /*B0*/ { /*16*/ { 4, 5, 6 }, /*32*/ { 4, 5, 6 }, /*64*/ { 4, 5, 6 } },
            /*B1*/ { /*16*/ { 1, 1, 1 }, /*32*/ { 2, 2, 2 }, /*64*/ { 3, 3, 3 } }
        };
        const ZyanU8 broadcast = match->request->evex.broadcast ? 1 : 0;
        ZYAN_ASSERT(size_index < 3);
        return scales[broadcast][size_index][vector_length];
    }
    case ZYDIS_TUPLETYPE_HV:
    {
        static const ZyanU8 scales[2][2][3] =
        {
            /*B0*/ { /*16*/ {  3, 4, 5 }, /*32*/ {  3, 4, 5 } },
            /*B1*/ { /*16*/ {  1, 1, 1 }, /*32*/ {  2, 2, 2 } }
        };
        const ZyanU8 broadcast = match->request->evex.broadcast ? 1 : 0;
        ZYAN_ASSERT(size_index < 3);
        return scales[broadcast][size_index][vector_length];
    }
    case ZYDIS_TUPLETYPE_FVM:
    {
        static const ZyanU8 scales[3] =
        {
            4, 5, 6
        };
        return scales[vector_length];
    }
    case ZYDIS_TUPLETYPE_GSCAT:
    case ZYDIS_TUPLETYPE_T1S:
    {
        static const ZyanU8 scales[6] =
        {
            /*   */ 0,
            /*  8*/ 0,
            /* 16*/ 1,
            /* 32*/ 2,
            /* 64*/ 3,
            /*128*/ 4
        };
        ZYAN_ASSERT(evex_def->element_size < ZYAN_ARRAY_LENGTH(scales));
        return scales[evex_def->element_size];
    }
    case ZYDIS_TUPLETYPE_T1F:
    {
        static const ZyanU8 scales[3] =
        {
            /* 16*/ 1,
            /* 32*/ 2,
            /* 64*/ 3
        };
        ZYAN_ASSERT(size_index < 3);
        return scales[size_index];
    }
    case ZYDIS_TUPLETYPE_T1_4X:
        return 4;
    case ZYDIS_TUPLETYPE_T2:
        return match->definition->rex_w ? 4 : 3;
    case ZYDIS_TUPLETYPE_T4:
        return match->definition->rex_w ? 5 : 4;
    case ZYDIS_TUPLETYPE_T8:
        return 5;
    case ZYDIS_TUPLETYPE_HVM:
    {
        static const ZyanU8 scales[3] =
        {
            3, 4, 5
        };
        return scales[vector_length];
    }
    case ZYDIS_TUPLETYPE_QVM:
    {
        static const ZyanU8 scales[3] =
        {
            2, 3, 4
        };
        return scales[vector_length];
    }
    case ZYDIS_TUPLETYPE_OVM:
    {
        static const ZyanU8 scales[3] =
        {
            1, 2, 3
        };
        return scales[vector_length];
    }
    case ZYDIS_TUPLETYPE_M128:
        return 4;
    case ZYDIS_TUPLETYPE_DUP:
    {
        static const ZyanU8 scales[3] =
        {
            3, 5, 6
        };
        return scales[vector_length];
    }
    case ZYDIS_TUPLETYPE_QUARTER:
    {
        static const ZyanU8 scales[2][3] =
        {
            /*B0*/ { 2, 3, 4 },
            /*B1*/ { 1, 1, 1 }
        };
        const ZyanU8 broadcast = match->request->evex.broadcast ? 1 : 0;
        return scales[broadcast][vector_length];
    }
    default:
        ZYAN_UNREACHABLE;
    }
}

/**
 * Determines scale factor for compressed 8-bit displacement (`MVEX` instructions only).
 *
 * @param   match   A pointer to `ZydisEncoderInstructionMatch` struct.
 *
 * @return  log2(scale factor)
 */
static ZyanU8 ZydisGetCompDispScaleMvex(const ZydisEncoderInstructionMatch *match)
{
    const ZydisInstructionDefinitionMVEX *mvex_def =
        (const ZydisInstructionDefinitionMVEX *)match->base_definition;

    ZyanU8 index = mvex_def->has_element_granularity;
    ZYAN_ASSERT(!index || !mvex_def->broadcast);
    if (!index && mvex_def->broadcast)
    {
        switch (mvex_def->broadcast)
        {
        case ZYDIS_MVEX_STATIC_BROADCAST_1_TO_8:
        case ZYDIS_MVEX_STATIC_BROADCAST_1_TO_16:
            index = 1;
            break;
        case ZYDIS_MVEX_STATIC_BROADCAST_4_TO_8:
        case ZYDIS_MVEX_STATIC_BROADCAST_4_TO_16:
            index = 2;
            break;
        default:
            ZYAN_UNREACHABLE;
        }
    }

    const ZyanU8 sss = ZydisEncodeMvexBroadcastMode(match->request->mvex.broadcast) |
                       ZydisEncodeMvexConversionMode(match->request->mvex.conversion);
    switch (mvex_def->functionality)
    {
    case ZYDIS_MVEX_FUNC_IGNORED:
    case ZYDIS_MVEX_FUNC_INVALID:
    case ZYDIS_MVEX_FUNC_RC:
    case ZYDIS_MVEX_FUNC_SAE:
    case ZYDIS_MVEX_FUNC_SWIZZLE_32:
    case ZYDIS_MVEX_FUNC_SWIZZLE_64:
        return 0;
    case ZYDIS_MVEX_FUNC_F_32:
    case ZYDIS_MVEX_FUNC_I_32:
    case ZYDIS_MVEX_FUNC_F_64:
    case ZYDIS_MVEX_FUNC_I_64:
        return 6;
    case ZYDIS_MVEX_FUNC_SF_32:
    case ZYDIS_MVEX_FUNC_SF_32_BCST:
    case ZYDIS_MVEX_FUNC_SF_32_BCST_4TO16:
    case ZYDIS_MVEX_FUNC_UF_32:
    {
        static const ZyanU8 lookup[3][8] =
        {
            { 6, 2, 4, 5, 4, 4, 5, 5 },
            { 2, 0, 0, 1, 0, 0, 1, 1 },
            { 4, 0, 0, 3, 2, 2, 3, 3 }
        };
        ZYAN_ASSERT(sss < ZYAN_ARRAY_LENGTH(lookup[index]));
        return lookup[index][sss];
    }
    case ZYDIS_MVEX_FUNC_SI_32:
    case ZYDIS_MVEX_FUNC_UI_32:
    case ZYDIS_MVEX_FUNC_SI_32_BCST:
    case ZYDIS_MVEX_FUNC_SI_32_BCST_4TO16:
    {
        static const ZyanU8 lookup[3][8] =
        {
            { 6, 2, 4, 0, 4, 4, 5, 5 },
            { 2, 0, 0, 0, 0, 0, 1, 1 },
            { 4, 0, 0, 0, 2, 2, 3, 3 }
        };
        ZYAN_ASSERT(sss < ZYAN_ARRAY_LENGTH(lookup[index]));
        return lookup[index][sss];
    }
    case ZYDIS_MVEX_FUNC_SF_64:
    case ZYDIS_MVEX_FUNC_UF_64:
    case ZYDIS_MVEX_FUNC_SI_64:
    case ZYDIS_MVEX_FUNC_UI_64:
    {
        static const ZyanU8 lookup[3][3] =
        {
            { 6, 3, 5 },
            { 3, 0, 0 },
            { 5, 0, 0 }
        };
        ZYAN_ASSERT(sss < ZYAN_ARRAY_LENGTH(lookup[index]));
        return lookup[index][sss];
    }
    case ZYDIS_MVEX_FUNC_DF_32:
    case ZYDIS_MVEX_FUNC_DI_32:
    {
        static const ZyanU8 lookup[2][8] =
        {
            { 6, 0, 0, 5, 4, 4, 5, 5 },
            { 2, 0, 0, 1, 0, 0, 1, 1 }
        };
        ZYAN_ASSERT(index < 2);
        ZYAN_ASSERT(sss < ZYAN_ARRAY_LENGTH(lookup[index]));
        return lookup[index][sss];
    }
    case ZYDIS_MVEX_FUNC_DF_64:
    case ZYDIS_MVEX_FUNC_DI_64:
        ZYAN_ASSERT(index < 2);
        return index == 0 ? 6 : 3;
    default:
        ZYAN_UNREACHABLE;
    }
}

/**
 * Determines scale factor for compressed 8-bit displacement.
 *
 * @param   match A pointer to `ZydisEncoderInstructionMatch` struct.
 *
 * @return  log2(scale factor)
 */
static ZyanU8 ZydisGetCompDispScale(const ZydisEncoderInstructionMatch *match)
{
    switch (match->definition->encoding)
    {
    case ZYDIS_INSTRUCTION_ENCODING_LEGACY:
    case ZYDIS_INSTRUCTION_ENCODING_3DNOW:
    case ZYDIS_INSTRUCTION_ENCODING_XOP:
    case ZYDIS_INSTRUCTION_ENCODING_VEX:
        return 0;
    case ZYDIS_INSTRUCTION_ENCODING_EVEX:
        return ZydisGetCompDispScaleEvex(match);
    case ZYDIS_INSTRUCTION_ENCODING_MVEX:
        return ZydisGetCompDispScaleMvex(match);
    default:
        ZYAN_UNREACHABLE;
    }
}

/**
 * Checks if requested operand matches register operand from instruction definition.
 *
 * @param   match       A pointer to `ZydisEncoderInstructionMatch` struct.
 * @param   user_op     Operand definition from `ZydisEncoderRequest` structure.
 * @param   def_op      Decoder's operand definition from current instruction definition.
 *
 * @return  True if operands match, false otherwise.
 */
static ZyanBool ZydisIsRegisterOperandCompatible(ZydisEncoderInstructionMatch *match,
    const ZydisEncoderOperand *user_op, const ZydisOperandDefinition *def_op)
{
    const ZydisRegisterClass reg_class = ZydisRegisterGetClass(user_op->reg.value);
    const ZydisRegisterWidth reg_width = ZydisRegisterClassGetWidth(match->request->machine_mode,
        reg_class);
    if (reg_width == 0)
    {
        return ZYAN_FALSE;
    }

    ZyanBool is4_expected_value = ZYAN_FALSE;
    switch (def_op->type)
    {
    case ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG:
        switch (def_op->op.reg.type)
        {
        case ZYDIS_IMPLREG_TYPE_STATIC:
            if (def_op->op.reg.reg.reg != user_op->reg.value)
            {
                return ZYAN_FALSE;
            }
            break;
        case ZYDIS_IMPLREG_TYPE_GPR_OSZ:
            if ((reg_class != ZYDIS_REGCLASS_GPR8) &&
                (reg_class != ZYDIS_REGCLASS_GPR16) &&
                (reg_class != ZYDIS_REGCLASS_GPR32) &&
                (reg_class != ZYDIS_REGCLASS_GPR64))
            {
                return ZYAN_FALSE;
            }
            if (def_op->op.reg.reg.id != ZydisRegisterGetId(user_op->reg.value))
            {
                return ZYAN_FALSE;
            }
            if (!ZydisCheckOsz(match, reg_width))
            {
                return ZYAN_FALSE;
            }
            break;
        case ZYDIS_IMPLREG_TYPE_GPR_ASZ:
            if ((reg_class != ZYDIS_REGCLASS_GPR8) &&
                (reg_class != ZYDIS_REGCLASS_GPR16) &&
                (reg_class != ZYDIS_REGCLASS_GPR32) &&
                (reg_class != ZYDIS_REGCLASS_GPR64))
            {
                return ZYAN_FALSE;
            }
            if (def_op->op.reg.reg.id != ZydisRegisterGetId(user_op->reg.value))
            {
                return ZYAN_FALSE;
            }
            if (!ZydisCheckAsz(match, reg_width))
            {
                return ZYAN_FALSE;
            }
            break;
        default:
            ZYAN_UNREACHABLE;
        }
        break;
    case ZYDIS_SEMANTIC_OPTYPE_GPR8:
        if (reg_class != ZYDIS_REGCLASS_GPR8)
        {
            return ZYAN_FALSE;
        }
        if (!ZydisIsRegisterAllowed(match, user_op->reg.value, reg_class))
        {
            return ZYAN_FALSE;
        }
        if (!ZydisValidateRexType(match, user_op->reg.value, ZYAN_FALSE))
        {
            return ZYAN_FALSE;
        }
        break;
    case ZYDIS_SEMANTIC_OPTYPE_GPR16:
        if (reg_class != ZYDIS_REGCLASS_GPR16)
        {
            return ZYAN_FALSE;
        }
        if (!ZydisIsRegisterAllowed(match, user_op->reg.value, reg_class))
        {
            return ZYAN_FALSE;
        }
        break;
    case ZYDIS_SEMANTIC_OPTYPE_GPR32:
        if (reg_class != ZYDIS_REGCLASS_GPR32)
        {
            return ZYAN_FALSE;
        }
        if (!ZydisIsRegisterAllowed(match, user_op->reg.value, reg_class))
        {
            return ZYAN_FALSE;
        }
        break;
    case ZYDIS_SEMANTIC_OPTYPE_GPR64:
        if (reg_class != ZYDIS_REGCLASS_GPR64)
        {
            return ZYAN_FALSE;
        }
        break;
    case ZYDIS_SEMANTIC_OPTYPE_GPR16_32_64:
        if ((reg_class != ZYDIS_REGCLASS_GPR16) &&
            (reg_class != ZYDIS_REGCLASS_GPR32) &&
            (reg_class != ZYDIS_REGCLASS_GPR64))
        {
            return ZYAN_FALSE;
        }
        if (!ZydisCheckOsz(match, reg_width))
        {
            return ZYAN_FALSE;
        }
        if (!ZydisIsRegisterAllowed(match, user_op->reg.value, reg_class))
        {
            return ZYAN_FALSE;
        }
        if (!ZydisValidateRexType(match, user_op->reg.value, ZYAN_FALSE))
        {
            return ZYAN_FALSE;
        }
        break;
    case ZYDIS_SEMANTIC_OPTYPE_GPR32_32_64:
        if ((reg_class != ZYDIS_REGCLASS_GPR32) &&
            (reg_class != ZYDIS_REGCLASS_GPR64))
        {
            return ZYAN_FALSE;
        }
        if (match->eosz == 0)
        {
            if (reg_class == ZYDIS_REGCLASS_GPR64)
            {
                match->eosz = 64;
            }
            else
            {
                match->eosz64_forbidden = ZYAN_TRUE;
            }
        }
        else if (match->eosz != (ZyanU8)reg_width)
        {
            return ZYAN_FALSE;
        }
        if (!ZydisIsRegisterAllowed(match, user_op->reg.value, reg_class))
        {
            return ZYAN_FALSE;
        }
        if (!ZydisValidateRexType(match, user_op->reg.value, ZYAN_FALSE))
        {
            return ZYAN_FALSE;
        }
        break;
    case ZYDIS_SEMANTIC_OPTYPE_GPR16_32_32:
        if ((reg_class != ZYDIS_REGCLASS_GPR16) &&
            (reg_class != ZYDIS_REGCLASS_GPR32))
        {
            return ZYAN_FALSE;
        }
        if (!ZydisCheckOsz(match, reg_width))
        {
            if (match->eosz != 64 || reg_class != ZYDIS_REGCLASS_GPR32)
            {
                return ZYAN_FALSE;
            }
        }
        if (!ZydisIsRegisterAllowed(match, user_op->reg.value, reg_class))
        {
            return ZYAN_FALSE;
        }
        break;
    case ZYDIS_SEMANTIC_OPTYPE_GPR_ASZ:
        if ((reg_class != ZYDIS_REGCLASS_GPR16) &&
            (reg_class != ZYDIS_REGCLASS_GPR32) &&
            (reg_class != ZYDIS_REGCLASS_GPR64))
        {
            return ZYAN_FALSE;
        }
        if (!ZydisCheckAsz(match, reg_width))
        {
            return ZYAN_FALSE;
        }
        if (!ZydisIsRegisterAllowed(match, user_op->reg.value, reg_class))
        {
            return ZYAN_FALSE;
        }
        break;
    case ZYDIS_SEMANTIC_OPTYPE_FPR:
        if (reg_class != ZYDIS_REGCLASS_X87)
        {
            return ZYAN_FALSE;
        }
        break;
    case ZYDIS_SEMANTIC_OPTYPE_MMX:
        if (reg_class != ZYDIS_REGCLASS_MMX)
        {
            return ZYAN_FALSE;
        }
        break;
    case ZYDIS_SEMANTIC_OPTYPE_XMM:
        if (reg_class != ZYDIS_REGCLASS_XMM)
        {
            return ZYAN_FALSE;
        }
        if (!ZydisIsRegisterAllowed(match, user_op->reg.value, reg_class))
        {
            return ZYAN_FALSE;
        }
        is4_expected_value = def_op->op.encoding == ZYDIS_OPERAND_ENCODING_IS4;
        break;
    case ZYDIS_SEMANTIC_OPTYPE_YMM:
        if (reg_class != ZYDIS_REGCLASS_YMM)
        {
            return ZYAN_FALSE;
        }
        if (!ZydisIsRegisterAllowed(match, user_op->reg.value, reg_class))
        {
            return ZYAN_FALSE;
        }
        is4_expected_value = def_op->op.encoding == ZYDIS_OPERAND_ENCODING_IS4;
        break;
    case ZYDIS_SEMANTIC_OPTYPE_ZMM:
        if (reg_class != ZYDIS_REGCLASS_ZMM)
        {
            return ZYAN_FALSE;
        }
        if (!ZydisIsRegisterAllowed(match, user_op->reg.value, reg_class))
        {
            return ZYAN_FALSE;
        }
        break;
    case ZYDIS_SEMANTIC_OPTYPE_TMM:
        if (reg_class != ZYDIS_REGCLASS_TMM)
        {
            return ZYAN_FALSE;
        }
        break;
    case ZYDIS_SEMANTIC_OPTYPE_BND:
        if (reg_class != ZYDIS_REGCLASS_BOUND)
        {
            return ZYAN_FALSE;
        }
        break;
    case ZYDIS_SEMANTIC_OPTYPE_SREG:
        if (reg_class != ZYDIS_REGCLASS_SEGMENT)
        {
            return ZYAN_FALSE;
        }
        if ((def_op->actions & ZYDIS_OPERAND_ACTION_MASK_WRITE) &&
            (user_op->reg.value == ZYDIS_REGISTER_CS))
        {
            return ZYAN_FALSE;
        }
        break;
    case ZYDIS_SEMANTIC_OPTYPE_CR:
    {
        if (reg_class != ZYDIS_REGCLASS_CONTROL)
        {
            return ZYAN_FALSE;
        }
        static const ZyanU8 cr_lookup[16] =
        {
            1, 0, 1, 1, 1, 0, 0, 0, 1, 0, 0, 0, 0, 0, 0, 0
        };
        const ZyanI8 reg_id = ZydisRegisterGetId(user_op->reg.value);
        if ((match->request->machine_mode != ZYDIS_MACHINE_MODE_LONG_64) &&
            (reg_id == 8))
        {
            return ZYAN_FALSE;
        }
        if (!cr_lookup[reg_id])
        {
            return ZYAN_FALSE;
        }
        break;
    }
    case ZYDIS_SEMANTIC_OPTYPE_DR:
        if (reg_class != ZYDIS_REGCLASS_DEBUG)
        {
            return ZYAN_FALSE;
        }
        if (user_op->reg.value >= ZYDIS_REGISTER_DR8)
        {
            return ZYAN_FALSE;
        }
        break;
    case ZYDIS_SEMANTIC_OPTYPE_MASK:
        if (reg_class != ZYDIS_REGCLASS_MASK)
        {
            return ZYAN_FALSE;
        }

        // MVEX does not require similar policy check
        if ((match->definition->encoding == ZYDIS_INSTRUCTION_ENCODING_EVEX) &&
            (def_op->op.encoding == ZYDIS_OPERAND_ENCODING_MASK))
        {
            const ZydisInstructionDefinitionEVEX *evex_def =
                (const ZydisInstructionDefinitionEVEX *)match->base_definition;
            ZYAN_ASSERT((evex_def->mask_policy != ZYDIS_MASK_POLICY_INVALID) &&
                        (evex_def->mask_policy != ZYDIS_MASK_POLICY_FORBIDDEN));
            if ((evex_def->mask_policy == ZYDIS_MASK_POLICY_REQUIRED) &&
                (user_op->reg.value == ZYDIS_REGISTER_K0))
            {
                return ZYAN_FALSE;
            }
            if ((evex_def->mask_policy == ZYDIS_MASK_POLICY_ALLOWED) &&
                (match->request->evex.zeroing_mask) &&
                (user_op->reg.value == ZYDIS_REGISTER_K0))
            {
                return ZYAN_FALSE;
            }
        }
        break;
    default:
        ZYAN_UNREACHABLE;
    }

    if (user_op->reg.is4 != is4_expected_value)
    {
        return ZYAN_FALSE;
    }

    return ZYAN_TRUE;
}

/**
 * Checks if requested operand matches memory operand from instruction definition.
 *
 * @param   match       A pointer to `ZydisEncoderInstructionMatch` struct.
 * @param   user_op     Operand definition from `ZydisEncoderRequest` structure.
 * @param   def_op      Decoder's operand definition from current instruction definition.
 *
 * @return  True if operands match, false otherwise.
 */
static ZyanBool ZydisIsMemoryOperandCompatible(ZydisEncoderInstructionMatch *match,
    const ZydisEncoderOperand *user_op, const ZydisOperandDefinition *def_op)
{
    switch (def_op->type)
    {
    case ZYDIS_SEMANTIC_OPTYPE_MEM:
    case ZYDIS_SEMANTIC_OPTYPE_AGEN:
    case ZYDIS_SEMANTIC_OPTYPE_MIB:
    case ZYDIS_SEMANTIC_OPTYPE_MEM_VSIBX:
    case ZYDIS_SEMANTIC_OPTYPE_MEM_VSIBY:
    case ZYDIS_SEMANTIC_OPTYPE_MEM_VSIBZ:
    {
        if ((def_op->type == ZYDIS_SEMANTIC_OPTYPE_MIB) &&
            (user_op->mem.scale != 0))
        {
            return ZYAN_FALSE;
        }
        const ZyanI64 displacement = user_op->mem.displacement;
        ZyanU8 disp_size = 0;
        if (displacement)
        {
            disp_size = ZydisGetSignedImmSize(displacement);
            if (disp_size > 32)
            {
                return ZYAN_FALSE;
            }

            match->cd8_scale = ZydisGetCompDispScale(match);
            if (match->cd8_scale)
            {
                const ZyanI64 mask = (1 << match->cd8_scale) - 1;
                if (!(displacement & mask))
                {
                    if (ZydisGetSignedImmSize(displacement >> match->cd8_scale) == 8)
                    {
                        disp_size = 8;
                    }
                }
                else if (disp_size == 8)
                {
                    disp_size = 16;
                }
            }
        }

        if (def_op->type != ZYDIS_SEMANTIC_OPTYPE_AGEN)
        {
            if (match->eosz != 0)
            {
                const ZyanU8 eosz_index = match->eosz >> 5;
                if (def_op->size[eosz_index] != user_op->mem.size)
                {
                    return ZYAN_FALSE;
                }
            }
            else if ((match->definition->vector_length != ZYDIS_VECTOR_LENGTH_INVALID) ||
                     (match->definition->encoding == ZYDIS_INSTRUCTION_ENCODING_MVEX))
            {
                ZyanU8 eosz_index = ZydisGetMachineModeWidth(match->request->machine_mode) >> 5;
                if (match->eosz64_forbidden && (eosz_index == 2))
                {
                    eosz_index = 1;
                }
                ZyanU16 allowed_mem_size = def_op->size[eosz_index];
                if ((!allowed_mem_size) &&
                    (match->definition->encoding != ZYDIS_INSTRUCTION_ENCODING_VEX))
                {
                    ZYAN_ASSERT((match->definition->encoding == ZYDIS_INSTRUCTION_ENCODING_EVEX) ||
                                (match->definition->encoding == ZYDIS_INSTRUCTION_ENCODING_MVEX));
                    switch (match->definition->vector_length)
                    {
                    case ZYDIS_VECTOR_LENGTH_128:
                        allowed_mem_size = 16;
                        break;
                    case ZYDIS_VECTOR_LENGTH_256:
                        allowed_mem_size = 32;
                        break;
                    case ZYDIS_VECTOR_LENGTH_INVALID:
                        ZYAN_ASSERT(match->definition->encoding == ZYDIS_INSTRUCTION_ENCODING_MVEX);
                        ZYAN_FALLTHROUGH;
                    case ZYDIS_VECTOR_LENGTH_512:
                        allowed_mem_size = 64;
                        break;
                    default:
                        ZYAN_UNREACHABLE;
                    }
                    if (match->definition->encoding == ZYDIS_INSTRUCTION_ENCODING_EVEX)
                    {
                        const ZydisInstructionDefinitionEVEX *evex_def =
                            (const ZydisInstructionDefinitionEVEX *)match->base_definition;
                        static const ZyanU8 element_sizes[ZYDIS_IELEMENT_SIZE_MAX_VALUE + 1] =
                        {
                              0, 1, 2, 4, 8, 16
                        };
                        ZYAN_ASSERT(evex_def->element_size < ZYAN_ARRAY_LENGTH(element_sizes));
                        const ZyanU8 element_size = element_sizes[evex_def->element_size];
                        if (match->request->evex.broadcast || evex_def->broadcast)
                        {
                            allowed_mem_size = element_size;
                        }
                        else
                        {
                            switch (evex_def->tuple_type)
                            {
                            case ZYDIS_TUPLETYPE_FV:
                                break;
                            case ZYDIS_TUPLETYPE_HV:
                                allowed_mem_size /= 2;
                                break;
                            case ZYDIS_TUPLETYPE_QUARTER:
                                allowed_mem_size /= 4;
                                break;
                            default:
                                ZYAN_UNREACHABLE;
                            }
                        }
                    }
                    else
                    {
                        const ZydisInstructionDefinitionMVEX *mvex_def =
                            (const ZydisInstructionDefinitionMVEX *)match->base_definition;
                        ZyanU16 element_size;
                        switch (match->request->mvex.conversion)
                        {
                        case ZYDIS_CONVERSION_MODE_INVALID:

                            switch (mvex_def->functionality)
                            {
                            case ZYDIS_MVEX_FUNC_SF_32:
                            case ZYDIS_MVEX_FUNC_SF_32_BCST_4TO16:
                            case ZYDIS_MVEX_FUNC_UF_32:
                            case ZYDIS_MVEX_FUNC_DF_32:
                            case ZYDIS_MVEX_FUNC_SI_32:
                            case ZYDIS_MVEX_FUNC_SI_32_BCST_4TO16:
                            case ZYDIS_MVEX_FUNC_UI_32:
                            case ZYDIS_MVEX_FUNC_DI_32:
                                allowed_mem_size = 64;
                                element_size = 4;
                                break;
                            case ZYDIS_MVEX_FUNC_SF_64:
                            case ZYDIS_MVEX_FUNC_UF_64:
                            case ZYDIS_MVEX_FUNC_DF_64:
                            case ZYDIS_MVEX_FUNC_SI_64:
                            case ZYDIS_MVEX_FUNC_UI_64:
                            case ZYDIS_MVEX_FUNC_DI_64:
                                allowed_mem_size = 64;
                                element_size = 8;
                                break;
                            case ZYDIS_MVEX_FUNC_SF_32_BCST:
                            case ZYDIS_MVEX_FUNC_SI_32_BCST:
                                allowed_mem_size = 32;
                                element_size = 4;
                                break;
                            default:
                                ZYAN_UNREACHABLE;
                            }
                            break;
                        case ZYDIS_CONVERSION_MODE_FLOAT16:
                        case ZYDIS_CONVERSION_MODE_SINT16:
                        case ZYDIS_CONVERSION_MODE_UINT16:
                            allowed_mem_size = 32;
                            element_size = 2;
                            break;
                        case ZYDIS_CONVERSION_MODE_SINT8:
                        case ZYDIS_CONVERSION_MODE_UINT8:
                            allowed_mem_size = 16;
                            element_size = 1;
                            break;
                        default:
                            ZYAN_UNREACHABLE;
                        }
                        ZYAN_ASSERT(!mvex_def->broadcast || !match->request->mvex.broadcast);
                        switch (mvex_def->broadcast)
                        {
                        case ZYDIS_MVEX_STATIC_BROADCAST_NONE:
                            break;
                        case ZYDIS_MVEX_STATIC_BROADCAST_1_TO_8:
                        case ZYDIS_MVEX_STATIC_BROADCAST_1_TO_16:
                            allowed_mem_size = element_size;
                            break;
                        case ZYDIS_MVEX_STATIC_BROADCAST_4_TO_8:
                        case ZYDIS_MVEX_STATIC_BROADCAST_4_TO_16:
                            allowed_mem_size = element_size * 4;
                            break;
                        default:
                            ZYAN_UNREACHABLE;
                        }
                        switch (match->request->mvex.broadcast)
                        {
                        case ZYDIS_BROADCAST_MODE_INVALID:
                            break;
                        case ZYDIS_BROADCAST_MODE_1_TO_8:
                        case ZYDIS_BROADCAST_MODE_1_TO_16:
                            allowed_mem_size = element_size;
                            break;
                        case ZYDIS_BROADCAST_MODE_4_TO_8:
                        case ZYDIS_BROADCAST_MODE_4_TO_16:
                            allowed_mem_size = element_size * 4;
                            break;
                        default:
                            ZYAN_UNREACHABLE;
                        }
                    }
                }
                if (user_op->mem.size != allowed_mem_size)
                {
                    return ZYAN_FALSE;
                }
            }
            else if (match->definition->rex_w)
            {
                match->eosz = 64;
            }
            else if (match->definition->vector_length == ZYDIS_VECTOR_LENGTH_INVALID)
            {
                match->eosz = ZydisGetOperandSizeFromElementSize(match, def_op->size,
                    user_op->mem.size, ZYAN_TRUE);
                if (match->eosz == 0)
                {
                    return ZYAN_FALSE;
                }
            }
            else
            {
                ZYAN_UNREACHABLE;
            }
        }
        else
        {
            if (match->easz != 0)
            {
                if (match->easz != user_op->mem.size)
                {
                    return ZYAN_FALSE;
                }
            }
            else
            {
                switch (user_op->mem.size)
                {
                case 2:
                case 4:
                case 8:
                    match->easz = (ZyanU8)user_op->mem.size << 3;
                    break;
                default:
                    return ZYAN_FALSE;
                }
            }
        }

        ZydisRegisterClass vsib_index_class = ZYDIS_REGCLASS_INVALID;
        ZyanBool is_vsib = ZYAN_TRUE;
        switch (def_op->type)
        {
        case ZYDIS_SEMANTIC_OPTYPE_MEM_VSIBX:
            vsib_index_class = ZYDIS_REGCLASS_XMM;
            break;
        case ZYDIS_SEMANTIC_OPTYPE_MEM_VSIBY:
            vsib_index_class = ZYDIS_REGCLASS_YMM;
            break;
        case ZYDIS_SEMANTIC_OPTYPE_MEM_VSIBZ:
            vsib_index_class = ZYDIS_REGCLASS_ZMM;
            break;
        default:
            is_vsib = ZYAN_FALSE;
            break;
        }
        const ZyanBool is_rip_relative = (user_op->mem.base == ZYDIS_REGISTER_RIP) ||
                                         (user_op->mem.base == ZYDIS_REGISTER_EIP);
        if (is_rip_relative)
        {
            const ZyanBool no_rip_rel = ZYDIS_OPDEF_GET_MEM_HIGH_BIT(match->base_definition->op_rm);
            if (no_rip_rel || ((match->definition->modrm & 7) == 4))
            {
                return ZYAN_FALSE;
            }
        }
        const ZydisRegisterClass reg_base_class = ZydisRegisterGetClass(user_op->mem.base);
        if ((reg_base_class == ZYDIS_REGCLASS_INVALID) &&
            (user_op->mem.base != ZYDIS_REGISTER_NONE))
        {
            return ZYAN_FALSE;
        }
        const ZydisRegisterClass reg_index_class = ZydisRegisterGetClass(user_op->mem.index);
        if ((reg_index_class == ZYDIS_REGCLASS_INVALID) &&
            (user_op->mem.index != ZYDIS_REGISTER_NONE))
        {
            return ZYAN_FALSE;
        }
        if (is_vsib)
        {
            const ZyanU8 mode_width = ZydisGetMachineModeWidth(match->request->machine_mode);
            const ZyanI8 reg_index_id = ZydisRegisterGetId(user_op->mem.index);
            if (((match->request->machine_mode != ZYDIS_MACHINE_MODE_LONG_64) ||
                 (reg_base_class != ZYDIS_REGCLASS_GPR64)) &&
                 (reg_base_class != ZYDIS_REGCLASS_GPR32) &&
                 (reg_base_class != ZYDIS_REGCLASS_INVALID))
            {
                return ZYAN_FALSE;
            }
            if ((reg_base_class == ZYDIS_REGCLASS_GPR32) &&
                (mode_width != 64) &&
                (ZydisRegisterGetId(user_op->mem.base) > 7))
            {
                return ZYAN_FALSE;
            }
            ZyanU8 max_reg_id = 7;
            if (mode_width == 64)
            {
                max_reg_id = match->definition->encoding != ZYDIS_INSTRUCTION_ENCODING_VEX ?
                    31 : 15;
            }
            if ((reg_index_class != vsib_index_class) ||
                (reg_index_id > max_reg_id))
            {
                return ZYAN_FALSE;
            }
        }
        else
        {
            if (!ZydisIsValidAddressingClass(match, reg_base_class, user_op->mem.base))
            {
                if (!is_rip_relative || match->request->machine_mode != ZYDIS_MACHINE_MODE_LONG_64)
                {
                    return ZYAN_FALSE;
                }
            }
            if (!ZydisIsValidAddressingClass(match, reg_index_class, user_op->mem.index))
            {
                return ZYAN_FALSE;
            }
            if (reg_base_class != ZYDIS_REGCLASS_INVALID &&
                reg_index_class != ZYDIS_REGCLASS_INVALID &&
                reg_base_class != reg_index_class)
            {
                return ZYAN_FALSE;
            }
            if (user_op->mem.index == ZYDIS_REGISTER_ESP ||
                user_op->mem.index == ZYDIS_REGISTER_RSP)
            {
                return ZYAN_FALSE;
            }
        }
        if (reg_index_class != ZYDIS_REGCLASS_INVALID &&
            user_op->mem.scale == 0 &&
            def_op->type != ZYDIS_SEMANTIC_OPTYPE_MIB)
        {
            return ZYAN_FALSE;
        }
        if (reg_index_class == ZYDIS_REGCLASS_INVALID &&
            user_op->mem.scale != 0)
        {
            return ZYAN_FALSE;
        }
        ZyanU8 candidate_easz = 0;
        ZyanBool disp_only = ZYAN_FALSE;
        if (reg_base_class != ZYDIS_REGCLASS_INVALID)
        {
            if (is_rip_relative)
            {
                candidate_easz = user_op->mem.base == ZYDIS_REGISTER_RIP ? 64 : 32;
            }
            else
            {
                candidate_easz = (ZyanU8)ZydisRegisterClassGetWidth(match->request->machine_mode,
                    reg_base_class);
            }
        }
        else if (reg_index_class != ZYDIS_REGCLASS_INVALID)
        {
            if (is_vsib)
            {
                candidate_easz = ZydisGetMachineModeWidth(match->request->machine_mode);
            }
            else
            {
                candidate_easz = (ZyanU8)ZydisRegisterClassGetWidth(match->request->machine_mode,
                    reg_index_class);
            }
        }
        else if (disp_size != 8 || !match->cd8_scale)
        {
            const ZyanU8 addr_size = ZydisGetMaxAddressSize(match->request);
            if (disp_size > addr_size)
            {
                return ZYAN_FALSE;
            }
            ZyanU8 min_disp_size = match->easz ? match->easz : 16;
            if (((min_disp_size == 16) && !(match->definition->address_sizes & ZYDIS_WIDTH_16)) ||
                 (min_disp_size == 64) ||
                 (match->request->machine_mode == ZYDIS_MACHINE_MODE_LONG_64))
            {
                min_disp_size = 32;
            }
            if (disp_size < min_disp_size)
            {
                disp_size = min_disp_size;
            }
            const ZyanI64 disp = user_op->mem.displacement;
            if (match->request->machine_mode == ZYDIS_MACHINE_MODE_LONG_64)
            {
                candidate_easz = addr_size;
                if (addr_size == 32 && disp >= 0 && match->easz != 32)
                {
                    candidate_easz = 64;
                }
            }
            else
            {
                const ZyanU64 uimm = disp & (~(0xFFFFFFFFFFFFFFFFULL << (addr_size - 1) << 1));
                if (disp_size < addr_size && ZydisGetUnsignedImmSize(uimm) > disp_size)
                {
                    disp_size = addr_size;
                }
                candidate_easz = disp_size;
            }
            disp_only = ZYAN_TRUE;
        }
        if (match->request->machine_mode == ZYDIS_MACHINE_MODE_LONG_64)
        {
            if (is_rip_relative && reg_index_class != ZYDIS_REGCLASS_INVALID)
            {
                return ZYAN_FALSE;
            }
        }
        else
        {
            if (candidate_easz == 16 && !disp_only)
            {
                if (disp_size > 16)
                {
                    return ZYAN_FALSE;
                }
                const ZyanI8 rm16 = ZydisGetRm16(user_op->mem.base, user_op->mem.index);
                if (rm16 == -1)
                {
                    return ZYAN_FALSE;
                }
                const ZyanU8 allowed_scale = rm16 < 4 ? 1 : 0;
                if (user_op->mem.scale != allowed_scale)
                {
                    return ZYAN_FALSE;
                }
            }
        }
        if (match->easz != 0)
        {
            if (match->easz != candidate_easz)
            {
                return ZYAN_FALSE;
            }
        }
        else
        {
            match->easz = candidate_easz;
        }
        if ((match->base_definition->address_size_map == ZYDIS_ADSIZE_MAP_IGNORED) &&
            (match->easz != ZydisGetMachineModeWidth(match->request->machine_mode)))
        {
            return ZYAN_FALSE;
        }
        match->disp_size = disp_size;
        break;
    }
    case ZYDIS_SEMANTIC_OPTYPE_MOFFS:
    {
        if (user_op->mem.base != ZYDIS_REGISTER_NONE ||
            user_op->mem.index != ZYDIS_REGISTER_NONE ||
            user_op->mem.scale != 0)
        {
            return ZYAN_FALSE;
        }
        const ZyanU8 min_disp_size = ZydisGetSignedImmSize(user_op->mem.displacement);
        if (min_disp_size > ZydisGetMaxAddressSize(match->request))
        {
            return ZYAN_FALSE;
        }
        if (match->eosz != 0)
        {
            const ZyanU8 eosz_index = match->eosz >> 5;
            if (def_op->size[eosz_index] != user_op->mem.size)
            {
                return ZYAN_FALSE;
            }
        }
        else
        {
            match->eosz = ZydisGetOperandSizeFromElementSize(match, def_op->size,
                user_op->mem.size, ZYAN_TRUE);
            if (match->eosz == 0)
            {
                return ZYAN_FALSE;
            }
        }
        match->disp_size = ZydisGetEffectiveImmSize(match, user_op->mem.displacement, def_op);
        if (match->disp_size == 0)
        {
            return ZYAN_FALSE;
        }
        // This is not a standard rejection. It's a special case for `mov` instructions (`moffs`
        // variants only). In 64-bit mode it's possible to get a shorter encoding for addresses
        // that can fit into 32-bit displacements.
        if (match->disp_size == 64 && min_disp_size < match->disp_size)
        {
            return ZYAN_FALSE;
        }
        break;
    }
    default:
        ZYAN_UNREACHABLE;
    }

    return ZYAN_TRUE;
}

/**
 * Checks if requested operand matches pointer operand from instruction definition.
 *
 * @param   match       A pointer to `ZydisEncoderInstructionMatch` struct.
 * @param   user_op     Operand definition from `ZydisEncoderRequest` structure.
 *
 * @return  True if operands match, false otherwise.
 */
static ZyanBool ZydisIsPointerOperandCompatible(ZydisEncoderInstructionMatch *match,
    const ZydisEncoderOperand *user_op)
{
    ZYAN_ASSERT(match->eosz == 0);
    ZYAN_ASSERT(match->request->machine_mode != ZYDIS_MACHINE_MODE_LONG_64);
    ZYAN_ASSERT((match->request->branch_type == ZYDIS_BRANCH_TYPE_NONE) ||
                (match->request->branch_type == ZYDIS_BRANCH_TYPE_FAR));
    const ZyanU8 min_disp_size = ZydisGetUnsignedImmSize(user_op->ptr.offset);
    const ZyanU8 desired_disp_size = (match->request->branch_width == ZYDIS_BRANCH_WIDTH_NONE)
        ? ZydisGetMachineModeWidth(match->request->machine_mode)
        : (4 << match->request->branch_width);
    if (min_disp_size > desired_disp_size)
    {
        return ZYAN_FALSE;
    }
    match->eosz = match->disp_size = desired_disp_size;
    match->imm_size = 16;
    return ZYAN_TRUE;
}

/**
 * Checks if requested operand matches immediate operand from instruction definition.
 *
 * @param   match       A pointer to `ZydisEncoderInstructionMatch` struct.
 * @param   user_op     Operand definition from `ZydisEncoderRequest` structure.
 * @param   def_op      Decoder's operand definition from current instruction definition.
 *
 * @return  True if operands match, false otherwise.
 */
static ZyanBool ZydisIsImmediateOperandCompabile(ZydisEncoderInstructionMatch *match,
    const ZydisEncoderOperand *user_op, const ZydisOperandDefinition *def_op)
{
    switch (def_op->type)
    {
    case ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_IMM1:
        if (user_op->imm.u != 1)
        {
            return ZYAN_FALSE;
        }
        break;
    case ZYDIS_SEMANTIC_OPTYPE_IMM:
    case ZYDIS_SEMANTIC_OPTYPE_REL:
    {
        const ZyanU8 imm_size = ZydisGetEffectiveImmSize(match, user_op->imm.s, def_op);
        if (def_op->op.encoding != ZYDIS_OPERAND_ENCODING_IS4)
        {
            if (imm_size == 0)
            {
                return ZYAN_FALSE;
            }
            if (match->imm_size)
            {
                ZYAN_ASSERT(match->disp_size == 0);
                match->disp_size = match->imm_size;
            }
        }
        else
        {
            ZYAN_ASSERT(match->imm_size == 0);
            if (imm_size != 8)
            {
                return ZYAN_FALSE;
            }
        }
        match->imm_size = imm_size;
        match->has_rel_operand = (def_op->type == ZYDIS_SEMANTIC_OPTYPE_REL);
        break;
    }
    default:
        ZYAN_UNREACHABLE;
    }

    return ZYAN_TRUE;
}

/**
 * Checks if requested boardcast mode is compatible with instruction definition.
 *
 * @param   evex_def       Definition for `EVEX`-encoded instruction.
 * @param   vector_length  Vector length.
 * @param   broadcast      Requested broadcast mode.
 *
 * @return  True if broadcast mode is compatible, false otherwise.
 */
static ZyanBool ZydisIsBroadcastModeCompatible(const ZydisInstructionDefinitionEVEX *evex_def,
    ZydisVectorLength vector_length, ZydisBroadcastMode broadcast)
{
    if (broadcast == ZYDIS_BROADCAST_MODE_INVALID)
    {
        return ZYAN_TRUE;
    }

    ZyanU8 vector_size = 0;
    ZYAN_ASSERT(vector_length != ZYDIS_VECTOR_LENGTH_INVALID);
    switch (vector_length)
    {
    case ZYDIS_VECTOR_LENGTH_128:
        vector_size = 16;
        break;
    case ZYDIS_VECTOR_LENGTH_256:
        vector_size = 32;
        break;
    case ZYDIS_VECTOR_LENGTH_512:
        vector_size = 64;
        break;
    default:
        ZYAN_UNREACHABLE;
    }
    switch (evex_def->tuple_type)
    {
    case ZYDIS_TUPLETYPE_FV:
        break;
    case ZYDIS_TUPLETYPE_HV:
        vector_size /= 2;
        break;
    case ZYDIS_TUPLETYPE_QUARTER:
        vector_size /= 4;
        break;
    default:
        ZYAN_UNREACHABLE;
    }

    ZyanU8 element_size;
    switch (evex_def->element_size)
    {
    case ZYDIS_IELEMENT_SIZE_16:
        element_size = 2;
        break;
    case ZYDIS_IELEMENT_SIZE_32:
        element_size = 4;
        break;
    case ZYDIS_IELEMENT_SIZE_64:
        element_size = 8;
        break;
    default:
        ZYAN_UNREACHABLE;
    }

    ZydisBroadcastMode allowed_mode;
    const ZyanU8 element_count = vector_size / element_size;
    switch (element_count)
    {
    case 2:
        allowed_mode = ZYDIS_BROADCAST_MODE_1_TO_2;
        break;
    case 4:
        allowed_mode = ZYDIS_BROADCAST_MODE_1_TO_4;
        break;
    case 8:
        allowed_mode = ZYDIS_BROADCAST_MODE_1_TO_8;
        break;
    case 16:
        allowed_mode = ZYDIS_BROADCAST_MODE_1_TO_16;
        break;
    case 32:
        allowed_mode = ZYDIS_BROADCAST_MODE_1_TO_32;
        break;
    default:
        ZYAN_UNREACHABLE;
    }

    if (broadcast != allowed_mode)
    {
        return ZYAN_FALSE;
    }

    return ZYAN_TRUE;
}

/**
 * Checks if requested `EVEX`-specific features are compatible with instruction definition.
 *
 * @param   match       A pointer to `ZydisEncoderInstructionMatch` struct.
 * @param   request     A pointer to `ZydisEncoderRequest` struct.
 *
 * @return  True if features are compatible, false otherwise.
 */
static ZyanBool ZydisAreEvexFeaturesCompatible(const ZydisEncoderInstructionMatch *match,
    const ZydisEncoderRequest *request)
{
    if (match->definition->encoding != ZYDIS_INSTRUCTION_ENCODING_EVEX)
    {
        return ZYAN_TRUE;
    }

    const ZydisInstructionDefinitionEVEX *evex_def =
        (const ZydisInstructionDefinitionEVEX *)match->base_definition;
    if ((!evex_def->accepts_zero_mask) &&
        (evex_def->mask_override != ZYDIS_MASK_OVERRIDE_ZEROING) &&
        (request->evex.zeroing_mask))
    {
        return ZYAN_FALSE;
    }

    switch (evex_def->functionality)
    {
    case ZYDIS_EVEX_FUNC_INVALID:
        if ((request->evex.sae) ||
            (request->evex.broadcast != ZYDIS_BROADCAST_MODE_INVALID) ||
            (request->evex.rounding != ZYDIS_ROUNDING_MODE_INVALID))
        {
            return ZYAN_FALSE;
        }
        break;
    case ZYDIS_EVEX_FUNC_BC:
        if ((request->evex.sae) ||
            (request->evex.rounding != ZYDIS_ROUNDING_MODE_INVALID))
        {
            return ZYAN_FALSE;
        }
        if (!ZydisIsBroadcastModeCompatible(evex_def, match->definition->vector_length,
            request->evex.broadcast))
        {
            return ZYAN_FALSE;
        }
        break;
    case ZYDIS_EVEX_FUNC_RC:
        if (request->evex.broadcast != ZYDIS_BROADCAST_MODE_INVALID)
        {
            return ZYAN_FALSE;
        }
        if (request->evex.rounding == ZYDIS_ROUNDING_MODE_INVALID)
        {
            if (request->evex.sae)
            {
                return ZYAN_FALSE;
            }
        }
        else
        {
            if (!request->evex.sae)
            {
                return ZYAN_FALSE;
            }
        }
        break;
    case ZYDIS_EVEX_FUNC_SAE:
        if ((request->evex.broadcast != ZYDIS_BROADCAST_MODE_INVALID) ||
            (request->evex.rounding != ZYDIS_ROUNDING_MODE_INVALID))
        {
            return ZYAN_FALSE;
        }
        break;
    default:
        ZYAN_UNREACHABLE;
    }

    return ZYAN_TRUE;
}

/**
 * Checks if requested `MVEX`-specific features are compatible with instruction definition.
 *
 * @param   match       A pointer to `ZydisEncoderInstructionMatch` struct.
 * @param   request     A pointer to `ZydisEncoderRequest` struct.
 *
 * @return  True if features are compatible, false otherwise.
 */
static ZyanBool ZydisAreMvexFeaturesCompatible(const ZydisEncoderInstructionMatch *match,
    const ZydisEncoderRequest *request)
{
    if (match->definition->encoding != ZYDIS_INSTRUCTION_ENCODING_MVEX)
    {
        return ZYAN_TRUE;
    }
    if (((match->definition->modrm >> 6) == 3) &&
        (request->mvex.eviction_hint))
    {
        return ZYAN_FALSE;
    }

    const ZydisInstructionDefinitionMVEX *mvex_def =
        (const ZydisInstructionDefinitionMVEX *)match->base_definition;
    switch (mvex_def->functionality)
    {
    case ZYDIS_MVEX_FUNC_IGNORED:
    case ZYDIS_MVEX_FUNC_INVALID:
    case ZYDIS_MVEX_FUNC_F_32:
    case ZYDIS_MVEX_FUNC_I_32:
    case ZYDIS_MVEX_FUNC_F_64:
    case ZYDIS_MVEX_FUNC_I_64:
    case ZYDIS_MVEX_FUNC_UF_64:
    case ZYDIS_MVEX_FUNC_UI_64:
    case ZYDIS_MVEX_FUNC_DF_64:
    case ZYDIS_MVEX_FUNC_DI_64:
        if ((request->mvex.broadcast != ZYDIS_BROADCAST_MODE_INVALID) ||
            (request->mvex.conversion != ZYDIS_CONVERSION_MODE_INVALID) ||
            (request->mvex.rounding != ZYDIS_ROUNDING_MODE_INVALID) ||
            (request->mvex.swizzle != ZYDIS_SWIZZLE_MODE_INVALID) ||
            (request->mvex.sae))
        {
            return ZYAN_FALSE;
        }
        break;
    case ZYDIS_MVEX_FUNC_RC:
        if ((request->mvex.broadcast != ZYDIS_BROADCAST_MODE_INVALID) ||
            (request->mvex.conversion != ZYDIS_CONVERSION_MODE_INVALID) ||
            (request->mvex.swizzle != ZYDIS_SWIZZLE_MODE_INVALID) ||
            (request->mvex.eviction_hint))
        {
            return ZYAN_FALSE;
        }
        break;
    case ZYDIS_MVEX_FUNC_SAE:
        if ((request->mvex.broadcast != ZYDIS_BROADCAST_MODE_INVALID) ||
            (request->mvex.conversion != ZYDIS_CONVERSION_MODE_INVALID) ||
            (request->mvex.rounding != ZYDIS_ROUNDING_MODE_INVALID) ||
            (request->mvex.swizzle != ZYDIS_SWIZZLE_MODE_INVALID) ||
            (request->mvex.eviction_hint))
        {
            return ZYAN_FALSE;
        }
        break;
    case ZYDIS_MVEX_FUNC_SWIZZLE_32:
    case ZYDIS_MVEX_FUNC_SWIZZLE_64:
        if ((request->mvex.broadcast != ZYDIS_BROADCAST_MODE_INVALID) ||
            (request->mvex.conversion != ZYDIS_CONVERSION_MODE_INVALID) ||
            (request->mvex.rounding != ZYDIS_ROUNDING_MODE_INVALID) ||
            (request->mvex.sae))
        {
            return ZYAN_FALSE;
        }
        break;
    case ZYDIS_MVEX_FUNC_SF_32:
        if ((request->mvex.rounding != ZYDIS_ROUNDING_MODE_INVALID) ||
            (request->mvex.swizzle != ZYDIS_SWIZZLE_MODE_INVALID) ||
            (request->mvex.sae))
        {
            return ZYAN_FALSE;
        }
        if ((request->mvex.broadcast != ZYDIS_BROADCAST_MODE_INVALID) &&
            (request->mvex.broadcast != ZYDIS_BROADCAST_MODE_1_TO_16) &&
            (request->mvex.broadcast != ZYDIS_BROADCAST_MODE_4_TO_16))
        {
            return ZYAN_FALSE;
        }
        if ((request->mvex.conversion != ZYDIS_CONVERSION_MODE_INVALID) &&
            (request->mvex.conversion != ZYDIS_CONVERSION_MODE_FLOAT16) &&
            (request->mvex.conversion != ZYDIS_CONVERSION_MODE_UINT8) &&
            (request->mvex.conversion != ZYDIS_CONVERSION_MODE_UINT16) &&
            (request->mvex.conversion != ZYDIS_CONVERSION_MODE_SINT16))
        {
            return ZYAN_FALSE;
        }
        if ((request->mvex.broadcast != ZYDIS_BROADCAST_MODE_INVALID) &&
            (request->mvex.conversion != ZYDIS_CONVERSION_MODE_INVALID))
        {
            return ZYAN_FALSE;
        }
        break;
    case ZYDIS_MVEX_FUNC_SI_32:
        if ((request->mvex.rounding != ZYDIS_ROUNDING_MODE_INVALID) ||
            (request->mvex.swizzle != ZYDIS_SWIZZLE_MODE_INVALID) ||
            (request->mvex.sae))
        {
            return ZYAN_FALSE;
        }
        if ((request->mvex.broadcast != ZYDIS_BROADCAST_MODE_INVALID) &&
            (request->mvex.broadcast != ZYDIS_BROADCAST_MODE_1_TO_16) &&
            (request->mvex.broadcast != ZYDIS_BROADCAST_MODE_4_TO_16))
        {
            return ZYAN_FALSE;
        }
        if ((request->mvex.conversion != ZYDIS_CONVERSION_MODE_INVALID) &&
            (request->mvex.conversion != ZYDIS_CONVERSION_MODE_UINT8) &&
            (request->mvex.conversion != ZYDIS_CONVERSION_MODE_SINT8) &&
            (request->mvex.conversion != ZYDIS_CONVERSION_MODE_UINT16) &&
            (request->mvex.conversion != ZYDIS_CONVERSION_MODE_SINT16))
        {
            return ZYAN_FALSE;
        }
        if ((request->mvex.broadcast != ZYDIS_BROADCAST_MODE_INVALID) &&
            (request->mvex.conversion != ZYDIS_CONVERSION_MODE_INVALID))
        {
            return ZYAN_FALSE;
        }
        break;
    case ZYDIS_MVEX_FUNC_SF_32_BCST:
    case ZYDIS_MVEX_FUNC_SI_32_BCST:
        if ((request->mvex.conversion != ZYDIS_CONVERSION_MODE_INVALID) ||
            (request->mvex.rounding != ZYDIS_ROUNDING_MODE_INVALID) ||
            (request->mvex.swizzle != ZYDIS_SWIZZLE_MODE_INVALID) ||
            (request->mvex.sae))
        {
            return ZYAN_FALSE;
        }
        if ((request->mvex.broadcast != ZYDIS_BROADCAST_MODE_INVALID) &&
            (request->mvex.broadcast != ZYDIS_BROADCAST_MODE_1_TO_16) &&
            (request->mvex.broadcast != ZYDIS_BROADCAST_MODE_4_TO_16))
        {
            return ZYAN_FALSE;
        }
        break;
    case ZYDIS_MVEX_FUNC_SF_32_BCST_4TO16:
    case ZYDIS_MVEX_FUNC_SI_32_BCST_4TO16:
        if ((request->mvex.conversion != ZYDIS_CONVERSION_MODE_INVALID) ||
            (request->mvex.rounding != ZYDIS_ROUNDING_MODE_INVALID) ||
            (request->mvex.swizzle != ZYDIS_SWIZZLE_MODE_INVALID) ||
            (request->mvex.sae))
        {
            return ZYAN_FALSE;
        }
        if ((request->mvex.broadcast != ZYDIS_BROADCAST_MODE_INVALID) &&
            (request->mvex.broadcast != ZYDIS_BROADCAST_MODE_4_TO_16))
        {
            return ZYAN_FALSE;
        }
        break;
    case ZYDIS_MVEX_FUNC_SF_64:
    case ZYDIS_MVEX_FUNC_SI_64:
        if ((request->mvex.conversion != ZYDIS_CONVERSION_MODE_INVALID) ||
            (request->mvex.rounding != ZYDIS_ROUNDING_MODE_INVALID) ||
            (request->mvex.swizzle != ZYDIS_SWIZZLE_MODE_INVALID) ||
            (request->mvex.sae))
        {
            return ZYAN_FALSE;
        }
        if ((request->mvex.broadcast != ZYDIS_BROADCAST_MODE_INVALID) &&
            (request->mvex.broadcast != ZYDIS_BROADCAST_MODE_1_TO_8) &&
            (request->mvex.broadcast != ZYDIS_BROADCAST_MODE_4_TO_8))
        {
            return ZYAN_FALSE;
        }
        break;
    case ZYDIS_MVEX_FUNC_UF_32:
    case ZYDIS_MVEX_FUNC_DF_32:
        if ((request->mvex.broadcast != ZYDIS_BROADCAST_MODE_INVALID) ||
            (request->mvex.rounding != ZYDIS_ROUNDING_MODE_INVALID) ||
            (request->mvex.swizzle != ZYDIS_SWIZZLE_MODE_INVALID) ||
            (request->mvex.sae))
        {
            return ZYAN_FALSE;
        }
        break;
    case ZYDIS_MVEX_FUNC_UI_32:
    case ZYDIS_MVEX_FUNC_DI_32:
        if ((request->mvex.broadcast != ZYDIS_BROADCAST_MODE_INVALID) ||
            (request->mvex.rounding != ZYDIS_ROUNDING_MODE_INVALID) ||
            (request->mvex.swizzle != ZYDIS_SWIZZLE_MODE_INVALID) ||
            (request->mvex.sae))
        {
            return ZYAN_FALSE;
        }
        if ((request->mvex.conversion != ZYDIS_CONVERSION_MODE_INVALID) &&
            (request->mvex.conversion != ZYDIS_CONVERSION_MODE_UINT8) &&
            (request->mvex.conversion != ZYDIS_CONVERSION_MODE_SINT8) &&
            (request->mvex.conversion != ZYDIS_CONVERSION_MODE_UINT16) &&
            (request->mvex.conversion != ZYDIS_CONVERSION_MODE_SINT16))
        {
            return ZYAN_FALSE;
        }
        break;
    default:
        ZYAN_UNREACHABLE;
    }

    return ZYAN_TRUE;
}

/**
 * Checks if operands specified in encoder request satisfy additional constraints mandated by
 * matched instruction definition.
 *
 * @param   match   A pointer to `ZydisEncoderInstructionMatch` struct.
 *
 * @return  True if operands passed the checks, false otherwise.
 */
static ZyanBool ZydisCheckConstraints(const ZydisEncoderInstructionMatch *match)
{
    const ZydisEncoderOperand *operands = match->request->operands;
    ZyanBool is_gather = ZYAN_FALSE;
    switch (match->definition->encoding)
    {
    case ZYDIS_INSTRUCTION_ENCODING_VEX:
    {
        const ZydisInstructionDefinitionVEX *vex_def =
            (const ZydisInstructionDefinitionVEX *)match->base_definition;
        if (vex_def->is_gather)
        {
            ZYAN_ASSERT(match->request->operand_count == 3);
            ZYAN_ASSERT(operands[0].type == ZYDIS_OPERAND_TYPE_REGISTER);
            ZYAN_ASSERT(operands[1].type == ZYDIS_OPERAND_TYPE_MEMORY);
            ZYAN_ASSERT(operands[2].type == ZYDIS_OPERAND_TYPE_REGISTER);
            const ZyanI8 dest = ZydisRegisterGetId(operands[0].reg.value);
            const ZyanI8 index = ZydisRegisterGetId(operands[1].mem.index);
            const ZyanI8 mask = ZydisRegisterGetId(operands[2].reg.value);
            // If any pair of the index, mask, or destination registers are the same, the
            // instruction results a UD fault.
            if ((dest == index) || (dest == mask) || (index == mask))
            {
                return ZYAN_FALSE;
            }
        }

        if (vex_def->no_source_source_match)
        {
            ZYAN_ASSERT(match->request->operand_count == 3);
            ZYAN_ASSERT(operands[0].type == ZYDIS_OPERAND_TYPE_REGISTER);
            ZYAN_ASSERT(operands[1].type == ZYDIS_OPERAND_TYPE_REGISTER);
            ZYAN_ASSERT(operands[2].type == ZYDIS_OPERAND_TYPE_REGISTER);
            const ZydisRegister dest = operands[0].reg.value;
            const ZydisRegister source1 = operands[1].reg.value;
            const ZydisRegister source2 = operands[2].reg.value;
            // AMX-E4: #UD if srcdest == src1 OR src1 == src2 OR srcdest == src2.
            if ((dest == source1) || (source1 == source2) || (dest == source2))
            {
                return ZYAN_FALSE;
            }
        }

        return ZYAN_TRUE;
    }
    case ZYDIS_INSTRUCTION_ENCODING_EVEX:
    {
        const ZydisInstructionDefinitionEVEX *evex_def =
            (const ZydisInstructionDefinitionEVEX *)match->base_definition;
        is_gather = evex_def->is_gather;
        if (evex_def->no_source_dest_match)
        {
            ZYAN_ASSERT(operands[0].type == ZYDIS_OPERAND_TYPE_REGISTER);
            ZYAN_ASSERT(operands[2].type == ZYDIS_OPERAND_TYPE_REGISTER);
            ZYAN_ASSERT((operands[3].type == ZYDIS_OPERAND_TYPE_REGISTER) ||
                        (operands[3].type == ZYDIS_OPERAND_TYPE_MEMORY));
            const ZydisRegister dest = operands[0].reg.value;
            const ZydisRegister source1 = operands[2].reg.value;
            const ZydisRegister source2 = (operands[3].type == ZYDIS_OPERAND_TYPE_REGISTER)
                ? operands[3].reg.value
                : ZYDIS_REGISTER_NONE;

            if ((dest == source1) || (dest == source2))
            {
                return ZYAN_FALSE;
            }
        }
        break;
    }
    case ZYDIS_INSTRUCTION_ENCODING_MVEX:
    {
        const ZydisInstructionDefinitionMVEX *mvex_def =
            (const ZydisInstructionDefinitionMVEX *)match->base_definition;
        is_gather = mvex_def->is_gather;
        break;
    }
    default:
        return ZYAN_TRUE;
    }

    if ((is_gather) && (operands[0].type == ZYDIS_OPERAND_TYPE_REGISTER))
    {
        ZYAN_ASSERT(match->request->operand_count == 3);
        ZYAN_ASSERT(operands[0].type == ZYDIS_OPERAND_TYPE_REGISTER);
        ZYAN_ASSERT(operands[2].type == ZYDIS_OPERAND_TYPE_MEMORY);
        const ZyanI8 dest = ZydisRegisterGetId(operands[0].reg.value);
        const ZyanI8 index = ZydisRegisterGetId(operands[2].mem.index);
        // EVEX: The instruction will #UD fault if the destination vector zmm1 is the same as
        // index vector VINDEX.
        // MVEX: The KNC GATHER instructions forbid using the same vector register for destination
        // and for the index. (https://github.com/intelxed/xed/issues/281#issuecomment-970074554)
        if (dest == index)
        {
            return ZYAN_FALSE;
        }
    }

    return ZYAN_TRUE;
}

/**
 * Checks if operands and encoding-specific features from `ZydisEncoderRequest` match
 * encoder's instruction definition.
 *
 * @param   match       A pointer to `ZydisEncoderInstructionMatch` struct.
 * @param   request     A pointer to `ZydisEncoderRequest` struct.
 *
 * @return  True if definition is compatible, false otherwise.
 */
static ZyanBool ZydisIsDefinitionCompatible(ZydisEncoderInstructionMatch *match,
    const ZydisEncoderRequest *request)
{
    ZYAN_ASSERT(request->operand_count == match->base_definition->operand_count_visible);
    match->operands = ZydisGetOperandDefinitions(match->base_definition);

    if (!ZydisAreEvexFeaturesCompatible(match, request))
    {
        return ZYAN_FALSE;
    }
    if (!ZydisAreMvexFeaturesCompatible(match, request))
    {
        return ZYAN_FALSE;
    }

    for (ZyanU8 i = 0; i < request->operand_count; ++i)
    {
        const ZydisEncoderOperand *user_op = &request->operands[i];
        const ZydisOperandDefinition *def_op = &match->operands[i];
        ZYAN_ASSERT(def_op->visibility != ZYDIS_OPERAND_VISIBILITY_HIDDEN);
        ZyanBool is_compatible = ZYAN_FALSE;
        switch (user_op->type)
        {
        case ZYDIS_OPERAND_TYPE_REGISTER:
            is_compatible = ZydisIsRegisterOperandCompatible(match, user_op, def_op);
            break;
        case ZYDIS_OPERAND_TYPE_MEMORY:
            is_compatible = ZydisIsMemoryOperandCompatible(match, user_op, def_op);
            break;
        case ZYDIS_OPERAND_TYPE_POINTER:
            is_compatible = ZydisIsPointerOperandCompatible(match, user_op);
            break;
        case ZYDIS_OPERAND_TYPE_IMMEDIATE:
            is_compatible = ZydisIsImmediateOperandCompabile(match, user_op, def_op);
            break;
        default:
            ZYAN_UNREACHABLE;
        }

        if (!is_compatible)
        {
            return ZYAN_FALSE;
        }
    }

    ZyanU8 eosz = 0;
    if (match->base_definition->branch_type != ZYDIS_BRANCH_TYPE_NONE)
    {
        switch (request->branch_width)
        {
        case ZYDIS_BRANCH_WIDTH_NONE:
            break;
        case ZYDIS_BRANCH_WIDTH_8:
            if ((!match->has_rel_operand) ||
                (match->base_definition->branch_type != ZYDIS_BRANCH_TYPE_SHORT))
            {
                return ZYAN_FALSE;
            }
            break;
        case ZYDIS_BRANCH_WIDTH_16:
            eosz = 16;
            break;
        case ZYDIS_BRANCH_WIDTH_32:
            eosz = ((match->has_rel_operand) &&
                    (match->request->machine_mode == ZYDIS_MACHINE_MODE_LONG_64) &&
                    (match->base_definition->operand_size_map == ZYDIS_OPSIZE_MAP_FORCE64))
                ? 64
                : 32;
            break;
        case ZYDIS_BRANCH_WIDTH_64:
            if (match->has_rel_operand)
            {
                return ZYAN_FALSE;
            }
            eosz = 64;
            break;
        default:
            ZYAN_UNREACHABLE;
        }
    }
    if (eosz)
    {
        if (match->eosz != 0)
        {
            if (match->eosz != eosz)
            {
                return ZYAN_FALSE;
            }
        }
        else
        {
            match->eosz = eosz;
        }
    }

    if (!ZydisCheckConstraints(match))
    {
        return ZYAN_FALSE;
    }

    return ZYAN_TRUE;
}

/**
 * Checks if requested set of prefixes is compatible with instruction definition.
 *
 * @param   match A pointer to `ZydisEncoderInstructionMatch` struct.
 *
 * @return  A zyan status code.
 */
static ZyanBool ZydisArePrefixesCompatible(const ZydisEncoderInstructionMatch *match)
{
    // Early-exit optimization for when no prefixes are requested at all.
    if (!(match->attributes & ZYDIS_ENCODABLE_PREFIXES))
    {
        return ZYAN_TRUE;
    }

    if ((!match->base_definition->accepts_segment) &&
        (match->attributes & ZYDIS_ATTRIB_HAS_SEGMENT))
    {
        return ZYAN_FALSE;
    }
    if (match->definition->encoding != ZYDIS_INSTRUCTION_ENCODING_LEGACY)
    {
        return !(match->attributes & ZYDIS_ENCODABLE_PREFIXES_NO_SEGMENTS);
    }

    const ZydisInstructionDefinitionLEGACY *legacy_def =
        (const ZydisInstructionDefinitionLEGACY *)match->base_definition;
    if ((!legacy_def->accepts_LOCK) &&
        (match->attributes & ZYDIS_ATTRIB_HAS_LOCK))
    {
        return ZYAN_FALSE;
    }
    if ((!legacy_def->accepts_REP) &&
        (match->attributes & ZYDIS_ATTRIB_HAS_REP))
    {
        return ZYAN_FALSE;
    }
    if ((!legacy_def->accepts_REPEREPZ) &&
        (match->attributes & ZYDIS_ATTRIB_HAS_REPE))
    {
        return ZYAN_FALSE;
    }
    if ((!legacy_def->accepts_REPNEREPNZ) &&
        (match->attributes & ZYDIS_ATTRIB_HAS_REPNE))
    {
        return ZYAN_FALSE;
    }
    if ((!legacy_def->accepts_BOUND) &&
        (match->attributes & ZYDIS_ATTRIB_HAS_BND))
    {
        return ZYAN_FALSE;
    }
    if ((!legacy_def->accepts_XACQUIRE) &&
        (match->attributes & ZYDIS_ATTRIB_HAS_XACQUIRE))
    {
        return ZYAN_FALSE;
    }
    if ((!legacy_def->accepts_XRELEASE) &&
        (match->attributes & ZYDIS_ATTRIB_HAS_XRELEASE))
    {
        return ZYAN_FALSE;
    }
    if ((!legacy_def->accepts_branch_hints) &&
        (match->attributes & (ZYDIS_ATTRIB_HAS_BRANCH_NOT_TAKEN |
                              ZYDIS_ATTRIB_HAS_BRANCH_TAKEN)))
    {
        return ZYAN_FALSE;
    }
    if ((!legacy_def->accepts_NOTRACK) &&
        (match->attributes & ZYDIS_ATTRIB_HAS_NOTRACK))
    {
        return ZYAN_FALSE;
    }
    if ((!legacy_def->accepts_hle_without_lock) &&
        (match->attributes & (ZYDIS_ATTRIB_HAS_XACQUIRE |
                              ZYDIS_ATTRIB_HAS_XRELEASE)) &&
        !(match->attributes & ZYDIS_ATTRIB_HAS_LOCK))
    {
        return ZYAN_FALSE;
    }

    return ZYAN_TRUE;
}

/**
 * Returns operand mask containing information about operand count and types in a compressed form.
 *
 * @param   request     A pointer to `ZydisEncoderRequest` struct.
 *
 * @return  Operand mask.
 */
static ZyanU16 ZydisGetOperandMask(const ZydisEncoderRequest *request)
{
    ZyanU16 operand_mask = request->operand_count;
    ZyanU8 bit_offset = ZYAN_BITS_TO_REPRESENT(ZYDIS_ENCODER_MAX_OPERANDS);
    for (ZyanU8 i = 0; i < request->operand_count; ++i)
    {
        operand_mask |= (request->operands[i].type - ZYDIS_OPERAND_TYPE_REGISTER) << bit_offset;
        bit_offset += ZYAN_BITS_TO_REPRESENT(
            ZYDIS_OPERAND_TYPE_MAX_VALUE - ZYDIS_OPERAND_TYPE_REGISTER);
    }

    return operand_mask;
}

/**
 * Handles optimization opportunities indicated by `swappable` field in instruction definition
 * structure. See `ZydisEncodableInstruction` for more information.
 *
 * @param   match       A pointer to `ZydisEncoderInstructionMatch` struct.
 *
 * @return  True if definition has been swapped, false otherwise.
 */
static ZyanBool ZydisHandleSwappableDefinition(ZydisEncoderInstructionMatch *match)
{
    if (!match->definition->swappable)
    {
        return ZYAN_FALSE;
    }

    // Special case for ISA-wide unique conflict between two `mov` variants
    // mov gpr16_32_64(encoding=opcode), imm(encoding=simm16_32_64,scale_factor=osz)
    // mov gpr16_32_64(encoding=modrm_rm), imm(encoding=simm16_32_32,scale_factor=osz)
    if (match->request->mnemonic == ZYDIS_MNEMONIC_MOV)
    {
        const ZyanU8 imm_size = ZydisGetSignedImmSize(match->request->operands[1].imm.s);
        if ((match->request->machine_mode == ZYDIS_MACHINE_MODE_LONG_64) &&
            (match->eosz == 64) &&
            (imm_size < 64))
        {
            return ZYAN_TRUE;
        }
    }

    ZYAN_ASSERT((match->request->operand_count == 2) || (match->request->operand_count == 3));
    const ZyanU8 src_index = (match->request->operand_count == 3) ? 2 : 1;
    const ZyanI8 dest_id = ZydisRegisterGetId(match->request->operands[0].reg.value);
    const ZyanI8 src_id = ZydisRegisterGetId(match->request->operands[src_index].reg.value);
    if ((dest_id <= 7) && (src_id > 7))
    {
        ++match->definition;
        ZydisGetInstructionDefinition(match->definition->encoding,
            match->definition->instruction_reference, &match->base_definition);
        match->operands = ZydisGetOperandDefinitions(match->base_definition);
        return ZYAN_TRUE;
    }

    return ZYAN_FALSE;
}

/**
 * This function attempts to find a matching instruction definition for provided encoder request.
 *
 * @param   request     A pointer to `ZydisEncoderRequest` struct.
 * @param   match       A pointer to `ZydisEncoderInstructionMatch` struct.
 *
 * @return  A zyan status code.
 */
static ZyanStatus ZydisFindMatchingDefinition(const ZydisEncoderRequest *request,
    ZydisEncoderInstructionMatch *match)
{
    ZYAN_MEMSET(match, 0, sizeof(ZydisEncoderInstructionMatch));
    match->request = request;
    match->attributes = request->prefixes;

    const ZydisEncodableInstruction *definition = ZYAN_NULL;
    const ZyanU8 definition_count = ZydisGetEncodableInstructions(request->mnemonic, &definition);
    ZYAN_ASSERT(definition && definition_count);
    const ZydisWidthFlag mode_width = ZydisGetMachineModeWidth(request->machine_mode) >> 4;
    const ZyanBool is_compat =
        (request->machine_mode == ZYDIS_MACHINE_MODE_LONG_COMPAT_16) ||
        (request->machine_mode == ZYDIS_MACHINE_MODE_LONG_COMPAT_32);
    const ZyanU8 default_asz = ZydisGetAszFromHint(request->address_size_hint);
    const ZyanU8 default_osz = ZydisGetOszFromHint(request->operand_size_hint);
    const ZyanU16 operand_mask = ZydisGetOperandMask(request);

    for (ZyanU8 i = 0; i < definition_count; ++i, ++definition)
    {
        if (definition->operand_mask != operand_mask)
        {
            continue;
        }
        const ZydisInstructionDefinition *base_definition = ZYAN_NULL;
        ZydisGetInstructionDefinition(definition->encoding, definition->instruction_reference,
            &base_definition);
        if (!(definition->modes & mode_width))
        {
            continue;
        }
        if ((request->allowed_encodings != ZYDIS_ENCODABLE_ENCODING_DEFAULT) &&
            !(ZydisGetEncodableEncoding(definition->encoding) & request->allowed_encodings))
        {
            continue;
        }
        if (request->machine_mode == ZYDIS_MACHINE_MODE_REAL_16)
        {
            if (base_definition->requires_protected_mode)
            {
                continue;
            }
            switch (definition->encoding)
            {
            case ZYDIS_INSTRUCTION_ENCODING_XOP:
            case ZYDIS_INSTRUCTION_ENCODING_VEX:
            case ZYDIS_INSTRUCTION_ENCODING_EVEX:
            case ZYDIS_INSTRUCTION_ENCODING_MVEX:
                continue;
            default:
                break;
            }
        }
        else if ((request->machine_mode != ZYDIS_MACHINE_MODE_LONG_64) &&
                 (definition->encoding == ZYDIS_INSTRUCTION_ENCODING_MVEX))
        {
            continue;
        }
        if (is_compat && base_definition->no_compat_mode)
        {
            continue;
        }
        if ((request->branch_type != ZYDIS_BRANCH_TYPE_NONE) &&
            (request->branch_type != base_definition->branch_type))
        {
            continue;
        }
        if ((base_definition->branch_type == ZYDIS_BRANCH_TYPE_NONE) &&
            (request->branch_width != ZYDIS_BRANCH_WIDTH_NONE))
        {
            continue;
        }

        match->definition = definition;
        match->base_definition = base_definition;
        match->operands = ZYAN_NULL;
        match->easz = definition->accepts_hint == ZYDIS_SIZE_HINT_ASZ ? default_asz : 0;
        match->eosz = definition->accepts_hint == ZYDIS_SIZE_HINT_OSZ ? default_osz : 0;
        match->disp_size = match->imm_size = match->cd8_scale = 0;
        match->rex_type = ZYDIS_REX_TYPE_UNKNOWN;
        match->eosz64_forbidden = ZYAN_FALSE;
        match->has_rel_operand = ZYAN_FALSE;
        if ((base_definition->operand_size_map != ZYDIS_OPSIZE_MAP_BYTEOP) &&
            (match->eosz == 8))
        {
            continue;
        }
        if (!ZydisArePrefixesCompatible(match))
        {
            continue;
        }
        if (!ZydisIsDefinitionCompatible(match, request))
        {
            continue;
        }
        if (ZydisHandleSwappableDefinition(match))
        {
            if (definition == match->definition)
            {
                continue;
            }
            ++i;
            definition = match->definition;
            base_definition = match->base_definition;
        }

        if (match->easz == 0)
        {
            if (definition->address_sizes & mode_width)
            {
                match->easz = (ZyanU8)(mode_width << 4);
            }
            else if (mode_width == ZYDIS_WIDTH_16)
            {
                match->easz = 32;
            }
            else if (mode_width == ZYDIS_WIDTH_32)
            {
                match->easz = 16;
            }
            else
            {
                match->easz = 32;
            }
            ZYAN_ASSERT(definition->address_sizes & (match->easz >> 4));
        }
        else if (!(definition->address_sizes & (match->easz >> 4)))
        {
            continue;
        }

        if (mode_width == ZYDIS_WIDTH_64)
        {
            if (base_definition->operand_size_map == ZYDIS_OPSIZE_MAP_DEFAULT64)
            {
                if (match->eosz == 0)
                {
                    ZYAN_ASSERT(definition->operand_sizes & (ZYDIS_WIDTH_16 | ZYDIS_WIDTH_64));
                    if (definition->operand_sizes & ZYDIS_WIDTH_64)
                    {
                        match->eosz = 64;
                    }
                    else
                    {
                        match->eosz = 16;
                    }
                }
                else if (match->eosz == 32)
                {
                    continue;
                }
            }
            else if (base_definition->operand_size_map == ZYDIS_OPSIZE_MAP_FORCE64)
            {
                if (match->eosz == 0)
                {
                    match->eosz = 64;
                }
                else if (match->eosz != 64)
                {
                    continue;
                }
            }
        }
        if (match->eosz == 0)
        {
            const ZydisWidthFlag default_width = (mode_width == ZYDIS_WIDTH_64)
                ? ZYDIS_WIDTH_32
                : mode_width;
            if (definition->operand_sizes & default_width)
            {
                match->eosz = (ZyanU8)(default_width << 4);
            }
            else if (definition->operand_sizes & ZYDIS_WIDTH_16)
            {
                match->eosz = 16;
            }
            else if (definition->operand_sizes & ZYDIS_WIDTH_32)
            {
                match->eosz = 32;
            }
            else
            {
                match->eosz = 64;
            }
        }
        else if (match->eosz64_forbidden && match->eosz == 64)
        {
            continue;
        }
        else if (!(definition->operand_sizes & (match->eosz >> 4)))
        {
            continue;
        }

        return ZYAN_STATUS_SUCCESS;
    }

    return ZYDIS_STATUS_IMPOSSIBLE_INSTRUCTION;
}

/**
 * Emits unsigned integer value.
 *
 * @param   data    Value to emit.
 * @param   size    Value size in bytes.
 * @param   buffer  A pointer to `ZydisEncoderBuffer` struct.
 *
 * @return  A zyan status code.
 */
static ZyanStatus ZydisEmitUInt(ZyanU64 data, ZyanU8 size, ZydisEncoderBuffer *buffer)
{
    ZYAN_ASSERT(size == 1 || size == 2 || size == 4 || size == 8);

    const ZyanUSize new_offset = buffer->offset + size;
    if (new_offset > buffer->size)
    {
        return ZYAN_STATUS_INSUFFICIENT_BUFFER_SIZE;
    }

    // TODO: fix for big-endian systems
    // The size variable is not passed on purpose to allow the compiler
    // to generate better code with a known size at compile time.
    if (size == 1)
    {
        ZYAN_MEMCPY(buffer->buffer + buffer->offset, &data, 1);
    }
    else if (size == 2)
    {
        ZYAN_MEMCPY(buffer->buffer + buffer->offset, &data, 2);
    }
    else if (size == 4)
    {
        ZYAN_MEMCPY(buffer->buffer + buffer->offset, &data, 4);
    }
    else if (size == 8)
    {
        ZYAN_MEMCPY(buffer->buffer + buffer->offset, &data, 8);
    }
    else
    {
        ZYAN_UNREACHABLE;
    }

    buffer->offset = new_offset;
    return ZYAN_STATUS_SUCCESS;
}

/**
 * Emits a single byte.
 *
 * @param   byte    Value to emit.
 * @param   buffer  A pointer to `ZydisEncoderBuffer` struct.
 *
 * @return  A zyan status code.
 */
static ZyanStatus ZydisEmitByte(ZyanU8 byte, ZydisEncoderBuffer *buffer)
{
    return ZydisEmitUInt(byte, 1, buffer);
}

/**
 * Emits legact prefixes.
 *
 * @param   instruction     A pointer to `ZydisEncoderInstruction` struct.
 * @param   buffer          A pointer to `ZydisEncoderBuffer` struct.
 *
 * @return  A zyan status code.
 */
static ZyanStatus ZydisEmitLegacyPrefixes(const ZydisEncoderInstruction *instruction,
    ZydisEncoderBuffer *buffer)
{
    ZyanBool compressed_prefixes = ZYAN_FALSE;
    switch (instruction->encoding)
    {
    case ZYDIS_INSTRUCTION_ENCODING_XOP:
    case ZYDIS_INSTRUCTION_ENCODING_VEX:
    case ZYDIS_INSTRUCTION_ENCODING_EVEX:
    case ZYDIS_INSTRUCTION_ENCODING_MVEX:
        compressed_prefixes = ZYAN_TRUE;
        break;
    default:
        break;
    }

    // Group 1
    if (instruction->attributes & ZYDIS_ATTRIB_HAS_LOCK)
    {
        ZYAN_CHECK(ZydisEmitByte(0xF0, buffer));
    }
    if (!compressed_prefixes)
    {
        if (instruction->attributes & (ZYDIS_ATTRIB_HAS_REPNE |
                                       ZYDIS_ATTRIB_HAS_BND |
                                       ZYDIS_ATTRIB_HAS_XACQUIRE))
        {
            ZYAN_CHECK(ZydisEmitByte(0xF2, buffer));
        }
        if (instruction->attributes & (ZYDIS_ATTRIB_HAS_REP |
                                       ZYDIS_ATTRIB_HAS_REPE |
                                       ZYDIS_ATTRIB_HAS_XRELEASE))
        {
            ZYAN_CHECK(ZydisEmitByte(0xF3, buffer));
        }
    }

    // Group 2
    if (instruction->attributes & (ZYDIS_ATTRIB_HAS_SEGMENT_CS |
                                   ZYDIS_ATTRIB_HAS_BRANCH_NOT_TAKEN))
    {
        ZYAN_CHECK(ZydisEmitByte(0x2E, buffer));
    }
    if (instruction->attributes & ZYDIS_ATTRIB_HAS_SEGMENT_SS)
    {
        ZYAN_CHECK(ZydisEmitByte(0x36, buffer));
    }
    if (instruction->attributes & (ZYDIS_ATTRIB_HAS_SEGMENT_DS |
                                   ZYDIS_ATTRIB_HAS_BRANCH_TAKEN))
    {
        ZYAN_CHECK(ZydisEmitByte(0x3E, buffer));
    }
    if (instruction->attributes & ZYDIS_ATTRIB_HAS_SEGMENT_ES)
    {
        ZYAN_CHECK(ZydisEmitByte(0x26, buffer));
    }
    if (instruction->attributes & ZYDIS_ATTRIB_HAS_SEGMENT_FS)
    {
        ZYAN_CHECK(ZydisEmitByte(0x64, buffer));
    }
    if (instruction->attributes & ZYDIS_ATTRIB_HAS_SEGMENT_GS)
    {
        ZYAN_CHECK(ZydisEmitByte(0x65, buffer));
    }
    if (instruction->attributes & ZYDIS_ATTRIB_HAS_NOTRACK)
    {
        ZYAN_CHECK(ZydisEmitByte(0x3E, buffer));
    }

    // Group 3
    if (!compressed_prefixes)
    {
        if (instruction->attributes & ZYDIS_ATTRIB_HAS_OPERANDSIZE)
        {
            ZYAN_CHECK(ZydisEmitByte(0x66, buffer));
        }
    }

    // Group 4
    if (instruction->attributes & ZYDIS_ATTRIB_HAS_ADDRESSSIZE)
    {
        ZYAN_CHECK(ZydisEmitByte(0x67, buffer));
    }

    return ZYAN_STATUS_SUCCESS;
}

/**
 * Encodes low nibble of `REX` prefix.
 *
 * @param   instruction     A pointer to `ZydisEncoderInstruction` struct.
 * @param   high_r          A pointer to `ZyanBool` variable that will be set to true when the
 *                          highest `ModR/M.reg` bit cannot be encoded using `REX` prefix.
 *
 * @return  A zyan status code.
 */
static ZyanU8 ZydisEncodeRexLowNibble(const ZydisEncoderInstruction *instruction, ZyanBool *high_r)
{
    if (high_r)
    {
        *high_r = ZYAN_FALSE;
    }

    ZyanU8 rex = 0;
    if ((instruction->attributes & ZYDIS_ATTRIB_HAS_MODRM) &&
        (instruction->attributes & ZYDIS_ATTRIB_HAS_SIB))
    {
        if (instruction->base & 0x08)
        {
            rex |= 1;
        }
        if (instruction->index & 0x08)
        {
            rex |= 2;
        }
        if (instruction->reg & 0x08)
        {
            rex |= 4;
        }
        if (high_r && (instruction->reg & 0x10))
        {
            *high_r = ZYAN_TRUE;
        }
    }
    else if (instruction->attributes & ZYDIS_ATTRIB_HAS_MODRM)
    {
        if (instruction->rm & 0x08)
        {
            rex |= 1;
        }
        if (instruction->rm & 0x10)
        {
            rex |= 2;
        }
        if (instruction->reg & 0x08)
        {
            rex |= 4;
        }
        if (high_r && (instruction->reg & 0x10))
        {
            *high_r = ZYAN_TRUE;
        }
    }
    else
    {
        if (instruction->rm & 0x08)
        {
            rex |= 1;
        }
    }

    if (instruction->rex_w)
    {
        rex |= 8;
    }

    return rex;
}

/**
 * Emits `REX` prefix.
 *
 * @param   instruction     A pointer to `ZydisEncoderInstruction` struct.
 * @param   buffer          A pointer to `ZydisEncoderBuffer` struct.
 *
 * @return  A zyan status code.
 */
static ZyanStatus ZydisEmitRex(const ZydisEncoderInstruction *instruction,
    ZydisEncoderBuffer *buffer)
{
    const ZyanU8 rex = ZydisEncodeRexLowNibble(instruction, ZYAN_NULL);
    if (rex || (instruction->attributes & ZYDIS_ATTRIB_HAS_REX))
    {
        ZYAN_CHECK(ZydisEmitByte(0x40 | rex, buffer));
    }

    return ZYAN_STATUS_SUCCESS;
}

/**
 * Encodes common parts of `VEX` prefix.
 *
 * @param   instruction     A pointer to `ZydisEncoderInstruction` struct.
 * @param   mmmmm           A pointer to `ZyanU8` variable that will receive `VEX.mmmmm`
 * @param   pp              A pointer to `ZyanU8` variable that will receive `VEX.pp`
 * @param   vvvv            A pointer to `ZyanU8` variable that will receive `VEX.vvvv`
 * @param   rex             A pointer to `ZyanU8` variable that will receive 'REX`
 * @param   high_r          A pointer to `ZyanBool` variable that will be set to true when the
 *                          highest `ModR/M.reg` bit cannot be encoded using `REX` prefix.
 */
static void ZydisEncodeVexCommons(ZydisEncoderInstruction *instruction, ZyanU8 *mmmmm, ZyanU8 *pp,
    ZyanU8 *vvvv, ZyanU8 *rex, ZyanBool *high_r)
{
    switch (instruction->opcode_map)
    {
    case ZYDIS_OPCODE_MAP_DEFAULT:
    case ZYDIS_OPCODE_MAP_0F:
    case ZYDIS_OPCODE_MAP_0F38:
    case ZYDIS_OPCODE_MAP_0F3A:
    case ZYDIS_OPCODE_MAP_MAP5:
    case ZYDIS_OPCODE_MAP_MAP6:
        *mmmmm = (ZyanU8)instruction->opcode_map;
        break;
    case ZYDIS_OPCODE_MAP_XOP8:
    case ZYDIS_OPCODE_MAP_XOP9:
    case ZYDIS_OPCODE_MAP_XOPA:
        *mmmmm = 8 + ((ZyanU8)instruction->opcode_map - ZYDIS_OPCODE_MAP_XOP8);
        break;
    default:
        ZYAN_UNREACHABLE;
    }
    instruction->opcode_map = ZYDIS_OPCODE_MAP_DEFAULT;

    *pp = 0;
    if (instruction->attributes & ZYDIS_ATTRIB_HAS_OPERANDSIZE)
    {
        *pp = 1;
    }
    else if (instruction->attributes & ZYDIS_ATTRIB_HAS_REP)
    {
        *pp = 2;
    }
    else if (instruction->attributes & ZYDIS_ATTRIB_HAS_REPNE)
    {
        *pp = 3;
    }

    *vvvv = ~instruction->vvvv;
    *rex = ZydisEncodeRexLowNibble(instruction, high_r);
}

/**
 * Emits `XOP` prefix.
 *
 * @param   instruction     A pointer to `ZydisEncoderInstruction` struct.
 * @param   buffer          A pointer to `ZydisEncoderBuffer` struct.
 *
 * @return  A zyan status code.
 */
static ZyanStatus ZydisEmitXop(ZydisEncoderInstruction *instruction, ZydisEncoderBuffer *buffer)
{
    ZyanU8 mmmmm, pp, vvvv, rex;
    ZydisEncodeVexCommons(instruction, &mmmmm, &pp, &vvvv, &rex, ZYAN_NULL);
    ZYAN_ASSERT(instruction->vector_length <= 1);
    const ZyanU8 b1 = (((~rex) & 0x07) << 5) | mmmmm;
    const ZyanU8 b2 = ((rex & 0x08) << 4) | ((vvvv & 0xF) << 3) | (instruction->vector_length << 2) | pp;
    ZYAN_CHECK(ZydisEmitByte(0x8F, buffer));
    ZYAN_CHECK(ZydisEmitByte(b1, buffer));
    ZYAN_CHECK(ZydisEmitByte(b2, buffer));
    return ZYAN_STATUS_SUCCESS;
}

/**
 * Emits `VEX` prefix.
 *
 * @param   instruction     A pointer to `ZydisEncoderInstruction` struct.
 * @param   buffer          A pointer to `ZydisEncoderBuffer` struct.
 *
 * @return  A zyan status code.
 */
static ZyanStatus ZydisEmitVex(ZydisEncoderInstruction *instruction, ZydisEncoderBuffer *buffer)
{
    ZyanU8 mmmmm, pp, vvvv, rex;
    ZydisEncodeVexCommons(instruction, &mmmmm, &pp, &vvvv, &rex, ZYAN_NULL);
    ZYAN_ASSERT(instruction->vector_length <= 1);
    if (mmmmm != 1 || (rex & 0x0B))
    {
        const ZyanU8 b1 = (((~rex) & 0x07) << 5) | mmmmm;
        const ZyanU8 b2 = ((rex & 0x08) << 4) |
                          ((vvvv & 0xF) << 3) |
                          (instruction->vector_length << 2) |
                          pp;
        ZYAN_CHECK(ZydisEmitByte(0xC4, buffer));
        ZYAN_CHECK(ZydisEmitByte(b1, buffer));
        ZYAN_CHECK(ZydisEmitByte(b2, buffer));
    }
    else
    {
        const ZyanU8 b1 = (((~rex) & 0x04) << 5) |
                          ((vvvv & 0xF) << 3) |
                          (instruction->vector_length << 2) |
                          pp;
        ZYAN_CHECK(ZydisEmitByte(0xC5, buffer));
        ZYAN_CHECK(ZydisEmitByte(b1, buffer));
    }

    return ZYAN_STATUS_SUCCESS;
}

/**
 * Encodes common parts of `EVEX` prefix.
 *
 * @param   instruction A pointer to `ZydisEncoderInstruction` struct.
 * @param   p0          A pointer to `ZyanU8` variable that will receive 2nd byte of `EVEX` prefix.
 * @param   p1          A pointer to `ZyanU8` variable that will receive 3rd byte of `EVEX` prefix.
 * @param   vvvvv       A pointer to `ZyanU8` variable that will receive `EVEX.vvvvv`.
 */
static void ZydisEncodeEvexCommons(ZydisEncoderInstruction *instruction, ZyanU8 *p0, ZyanU8 *p1,
    ZyanU8 *vvvvv)
{
    ZyanBool high_r;
    ZyanU8 mmmmm, pp, rex;
    ZydisEncodeVexCommons(instruction, &mmmmm, &pp, vvvvv, &rex, &high_r);
    *p0 = (((~rex) & 0x07) << 5) | mmmmm;
    if (!high_r)
    {
        *p0 |= 0x10;
    }
    *p1 = ((rex & 0x08) << 4) | ((*vvvvv & 0x0F) << 3) | 0x04 | pp;
}

/**
 * Emits `EVEX` prefix.
 *
 * @param   instruction     A pointer to `ZydisEncoderInstruction` struct.
 * @param   buffer          A pointer to `ZydisEncoderBuffer` struct.
 *
 * @return  A zyan status code.
 */
static ZyanStatus ZydisEmitEvex(ZydisEncoderInstruction *instruction, ZydisEncoderBuffer *buffer)
{
    ZyanU8 p0, p1, vvvvv;
    ZydisEncodeEvexCommons(instruction, &p0, &p1, &vvvvv);
    ZyanU8 p2 = (instruction->vector_length << 5) | ((vvvvv & 0x10) >> 1) | instruction->mask;
    if (instruction->zeroing)
    {
        p2 |= 0x80;
    }
    if (instruction->attributes & ZYDIS_ATTRIB_HAS_EVEX_B)
    {
        p2 |= 0x10;
    }
    if (instruction->index & 0x10)
    {
        p2 &= 0xF7;
    }

    ZYAN_CHECK(ZydisEmitByte(0x62, buffer));
    ZYAN_CHECK(ZydisEmitByte(p0, buffer));
    ZYAN_CHECK(ZydisEmitByte(p1, buffer));
    ZYAN_CHECK(ZydisEmitByte(p2, buffer));
    return ZYAN_STATUS_SUCCESS;
}

/**
 * Emits `MVEX` prefix.
 *
 * @param   instruction     A pointer to `ZydisEncoderInstruction` struct.
 * @param   buffer          A pointer to `ZydisEncoderBuffer` struct.
 *
 * @return  A zyan status code.
 */
static ZyanStatus ZydisEmitMvex(ZydisEncoderInstruction *instruction, ZydisEncoderBuffer *buffer)
{
    ZyanU8 p0, p1, vvvvv;
    ZydisEncodeEvexCommons(instruction, &p0, &p1, &vvvvv);
    ZyanU8 p2 = (instruction->sss << 4) | ((vvvvv & 0x10) >> 1) | instruction->mask;
    if (instruction->eviction_hint)
    {
        p2 |= 0x80;
    }
    if (instruction->index & 0x10)
    {
        p2 &= 0xF7;
    }

    ZYAN_CHECK(ZydisEmitByte(0x62, buffer));
    ZYAN_CHECK(ZydisEmitByte(p0, buffer));
    ZYAN_CHECK(ZydisEmitByte(p1 & 0xFB, buffer));
    ZYAN_CHECK(ZydisEmitByte(p2, buffer));
    return ZYAN_STATUS_SUCCESS;
}

/**
 * Emits instruction as stream of bytes.
 *
 * @param   instruction     A pointer to `ZydisEncoderInstruction` struct.
 * @param   buffer          A pointer to `ZydisEncoderBuffer` struct.
 *
 * @return  A zyan status code.
 */
static ZyanStatus ZydisEmitInstruction(ZydisEncoderInstruction *instruction,
    ZydisEncoderBuffer *buffer)
{
    ZYAN_CHECK(ZydisEmitLegacyPrefixes(instruction, buffer));

    switch (instruction->encoding)
    {
    case ZYDIS_INSTRUCTION_ENCODING_LEGACY:
    case ZYDIS_INSTRUCTION_ENCODING_3DNOW:
        ZYAN_CHECK(ZydisEmitRex(instruction, buffer));
        break;
    case ZYDIS_INSTRUCTION_ENCODING_XOP:
        ZYAN_CHECK(ZydisEmitXop(instruction, buffer));
        break;
    case ZYDIS_INSTRUCTION_ENCODING_VEX:
        ZYAN_CHECK(ZydisEmitVex(instruction, buffer));
        break;
    case ZYDIS_INSTRUCTION_ENCODING_EVEX:
        ZYAN_CHECK(ZydisEmitEvex(instruction, buffer));
        break;
    case ZYDIS_INSTRUCTION_ENCODING_MVEX:
        ZYAN_CHECK(ZydisEmitMvex(instruction, buffer));
        break;
    default:
        ZYAN_UNREACHABLE;
    }

    switch (instruction->opcode_map)
    {
    case ZYDIS_OPCODE_MAP_DEFAULT:
        break;
    case ZYDIS_OPCODE_MAP_0F:
        ZYAN_CHECK(ZydisEmitByte(0x0F, buffer));
        break;
    case ZYDIS_OPCODE_MAP_0F38:
        ZYAN_CHECK(ZydisEmitByte(0x0F, buffer));
        ZYAN_CHECK(ZydisEmitByte(0x38, buffer));
        break;
    case ZYDIS_OPCODE_MAP_0F3A:
        ZYAN_CHECK(ZydisEmitByte(0x0F, buffer));
        ZYAN_CHECK(ZydisEmitByte(0x3A, buffer));
        break;
    case ZYDIS_OPCODE_MAP_0F0F:
        ZYAN_CHECK(ZydisEmitByte(0x0F, buffer));
        ZYAN_CHECK(ZydisEmitByte(0x0F, buffer));
        break;
    default:
        ZYAN_UNREACHABLE;
    }
    if (instruction->encoding != ZYDIS_INSTRUCTION_ENCODING_3DNOW)
    {
        ZYAN_CHECK(ZydisEmitByte(instruction->opcode, buffer));
    }

    if (instruction->attributes & ZYDIS_ATTRIB_HAS_MODRM)
    {
        const ZyanU8 modrm = (instruction->mod << 6) |
                             ((instruction->reg & 7) << 3) |
                             (instruction->rm & 7);
        ZYAN_CHECK(ZydisEmitByte(modrm, buffer));
    }
    if (instruction->attributes & ZYDIS_ATTRIB_HAS_SIB)
    {
        const ZyanU8 sib = (instruction->scale << 6) |
                           ((instruction->index & 7) << 3) |
                           (instruction->base & 7);
        ZYAN_CHECK(ZydisEmitByte(sib, buffer));
    }
    if (instruction->disp_size)
    {
        ZYAN_CHECK(ZydisEmitUInt(instruction->disp, instruction->disp_size / 8, buffer));
    }
    if (instruction->imm_size)
    {
        ZYAN_CHECK(ZydisEmitUInt(instruction->imm, instruction->imm_size / 8, buffer));
    }
    if (instruction->encoding == ZYDIS_INSTRUCTION_ENCODING_3DNOW)
    {
        ZYAN_CHECK(ZydisEmitByte(instruction->opcode, buffer));
    }

    return ZYAN_STATUS_SUCCESS;
}

/**
 * Encodes register operand as fields inside `ZydisEncoderInstruction` structure.
 *
 * @param   user_op     Validated operand definition from `ZydisEncoderRequest` structure.
 * @param   def_op      Decoder's operand definition from instruction definition.
 * @param   instruction A pointer to `ZydisEncoderInstruction` struct.
 */
static void ZydisBuildRegisterOperand(const ZydisEncoderOperand *user_op,
    const ZydisOperandDefinition *def_op, ZydisEncoderInstruction *instruction)
{
    if (def_op->type == ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG)
    {
        return;
    }

    ZyanU8 reg_id = 0;
    if (ZydisRegisterGetClass(user_op->reg.value) != ZYDIS_REGCLASS_GPR8)
    {
        reg_id = (ZyanU8)ZydisRegisterGetId(user_op->reg.value);
    }
    else
    {
        static const ZyanU8 reg8_lookup[] = {
            0, 1, 2, 3,                     // AL, CL, DL, BL
            4, 5, 6, 7,                     // AH, CH, DH, BH
            4, 5, 6, 7,                     // SPL, BPL, SIL, DIL
            8, 9, 10, 11, 12, 13, 14, 15,   // R8B-R15B
        };
        ZYAN_ASSERT(
            ((ZyanUSize)user_op->reg.value - ZYDIS_REGISTER_AL) < ZYAN_ARRAY_LENGTH(reg8_lookup));
        reg_id = reg8_lookup[user_op->reg.value - ZYDIS_REGISTER_AL];
        if (user_op->reg.value >= ZYDIS_REGISTER_SPL && user_op->reg.value <= ZYDIS_REGISTER_DIL)
        {
            instruction->attributes |= ZYDIS_ATTRIB_HAS_REX;
        }
    }

    switch (def_op->op.encoding)
    {
    case ZYDIS_OPERAND_ENCODING_MODRM_REG:
        instruction->attributes |= ZYDIS_ATTRIB_HAS_MODRM;
        instruction->reg = reg_id;
        break;
    case ZYDIS_OPERAND_ENCODING_MODRM_RM:
        instruction->attributes |= ZYDIS_ATTRIB_HAS_MODRM;
        instruction->rm = reg_id;
        break;
    case ZYDIS_OPERAND_ENCODING_OPCODE:
        instruction->opcode += reg_id & 7;
        instruction->rm = reg_id;
        break;
    case ZYDIS_OPERAND_ENCODING_NDSNDD:
        instruction->vvvv = reg_id;
        break;
    case ZYDIS_OPERAND_ENCODING_IS4:
        instruction->imm_size = 8;
        instruction->imm = reg_id << 4;
        break;
    case ZYDIS_OPERAND_ENCODING_MASK:
        instruction->mask = reg_id;
        break;
    default:
        ZYAN_UNREACHABLE;
    }
}

/**
 * Encodes memory operand as fields inside `ZydisEncoderInstruction` structure.
 *
 * @param   match       A pointer to `ZydisEncoderInstructionMatch` struct.
 * @param   user_op     Decoder's operand definition from instruction definition.
 * @param   instruction A pointer to `ZydisEncoderInstruction` struct.
 */
static void ZydisBuildMemoryOperand(ZydisEncoderInstructionMatch *match,
    const ZydisEncoderOperand *user_op, ZydisEncoderInstruction *instruction)
{
    instruction->attributes |= ZYDIS_ATTRIB_HAS_MODRM;
    instruction->disp = (ZyanU64)user_op->mem.displacement;
    if (match->easz == 16)
    {
        const ZyanI8 rm = ZydisGetRm16(user_op->mem.base, user_op->mem.index);
        if (rm != -1)
        {
            instruction->rm = (ZyanU8)rm;
            instruction->disp_size = match->disp_size;
            switch (instruction->disp_size)
            {
            case 0:
                if (rm == 6)
                {
                    instruction->disp_size = 8;
                    instruction->mod = 1;
                }
                break;
            case 8:
                instruction->mod = 1;
                break;
            case 16:
                instruction->mod = 2;
                break;
            default:
                ZYAN_UNREACHABLE;
            }
        }
        else
        {
            instruction->rm = 6;
            instruction->disp_size = 16;
        }
        return;
    }

    if (user_op->mem.index == ZYDIS_REGISTER_NONE)
    {
        if (user_op->mem.base == ZYDIS_REGISTER_NONE)
        {
            if (match->request->machine_mode == ZYDIS_MACHINE_MODE_LONG_64)
            {
                instruction->rm = 4;
                instruction->attributes |= ZYDIS_ATTRIB_HAS_SIB;
                instruction->base = 5;
                instruction->index = 4;
            }
            else
            {
                instruction->rm = 5;
            }
            instruction->disp_size = 32;
            return;
        }
        else if ((user_op->mem.base == ZYDIS_REGISTER_RIP) ||
                 (user_op->mem.base == ZYDIS_REGISTER_EIP))
        {
            instruction->rm = 5;
            instruction->disp_size = 32;
            return;
        }
    }

    const ZyanU8 reg_base_id = (ZyanU8)ZydisRegisterGetId(user_op->mem.base);
    const ZyanU8 reg_index_id = (ZyanU8)ZydisRegisterGetId(user_op->mem.index);
    instruction->disp_size = match->disp_size;
    switch (instruction->disp_size)
    {
    case 0:
        if (reg_base_id == 5 || reg_base_id == 13)
        {
            instruction->disp_size = 8;
            instruction->disp = 0;
            instruction->mod = 1;
        }
        break;
    case 8:
        instruction->mod = 1;
        break;
    case 16:
        instruction->disp_size = 32;
        ZYAN_FALLTHROUGH;
    case 32:
        instruction->mod = 2;
        break;
    default:
        ZYAN_UNREACHABLE;
    }
    if ((user_op->mem.index == ZYDIS_REGISTER_NONE) &&
        (reg_base_id != 4) &&
        (reg_base_id != 12) &&
        ((match->definition->modrm & 7) != 4))
    {
        instruction->rm = reg_base_id;
        return;
    }
    instruction->rm = 4;
    instruction->attributes |= ZYDIS_ATTRIB_HAS_SIB;
    if (reg_base_id != 0xFF)
    {
        instruction->base = reg_base_id;
    }
    else
    {
        instruction->base = 5;
        instruction->mod = 0;
        instruction->disp_size = 32;
    }
    if (reg_index_id != 0xFF)
    {
        instruction->index = reg_index_id;
    }
    else
    {
        instruction->index = 4;
    }
    switch (user_op->mem.scale)
    {
    case 0:
    case 1:
        break;
    case 2:
        instruction->scale = 1;
        break;
    case 4:
        instruction->scale = 2;
        break;
    case 8:
        instruction->scale = 3;
        break;
    default:
        ZYAN_UNREACHABLE;
    }
}

/**
 * Encodes instruction as emittable `ZydisEncoderInstruction` struct.
 *
 * @param   match       A pointer to `ZydisEncoderInstructionMatch` struct.
 * @param   instruction A pointer to `ZydisEncoderInstruction` struct.
 *
 * @return  A zyan status code.
 */
static ZyanStatus ZydisBuildInstruction(ZydisEncoderInstructionMatch *match,
    ZydisEncoderInstruction *instruction)
{
    ZYAN_MEMSET(instruction, 0, sizeof(ZydisEncoderInstruction));
    instruction->attributes = match->attributes;
    instruction->encoding = match->definition->encoding;
    instruction->opcode_map = match->definition->opcode_map;
    instruction->opcode = match->definition->opcode;
    instruction->rex_w = match->definition->rex_w;
    instruction->mod = (match->definition->modrm >> 6) & 3;
    instruction->reg = (match->definition->modrm >> 3) & 7;
    instruction->rm = match->definition->modrm & 7;
    if (match->definition->modrm)
    {
        instruction->attributes |= ZYDIS_ATTRIB_HAS_MODRM;
    }

    switch (match->definition->vector_length)
    {
    case ZYDIS_VECTOR_LENGTH_INVALID:
    case ZYDIS_VECTOR_LENGTH_128:
        instruction->vector_length = 0;
        break;
    case ZYDIS_VECTOR_LENGTH_256:
        instruction->vector_length = 1;
        break;
    case ZYDIS_VECTOR_LENGTH_512:
        instruction->vector_length = 2;
        break;
    default:
        ZYAN_UNREACHABLE;
    }

    if (match->definition->encoding == ZYDIS_INSTRUCTION_ENCODING_EVEX)
    {
        const ZydisInstructionDefinitionEVEX *evex_def =
            (const ZydisInstructionDefinitionEVEX *)match->base_definition;
        if (evex_def->mask_override != ZYDIS_MASK_OVERRIDE_ZEROING)
        {
            instruction->zeroing = match->request->evex.zeroing_mask;
        }
        if ((match->request->evex.sae) ||
            (match->request->evex.broadcast != ZYDIS_BROADCAST_MODE_INVALID))
        {
            instruction->attributes |= ZYDIS_ATTRIB_HAS_EVEX_B;
        }
        if (match->request->evex.rounding != ZYDIS_ROUNDING_MODE_INVALID)
        {
            instruction->attributes |= ZYDIS_ATTRIB_HAS_EVEX_B;
            switch (match->request->evex.rounding)
            {
            case ZYDIS_ROUNDING_MODE_RN:
                instruction->vector_length = 0;
                break;
            case ZYDIS_ROUNDING_MODE_RD:
                instruction->vector_length = 1;
                break;
            case ZYDIS_ROUNDING_MODE_RU:
                instruction->vector_length = 2;
                break;
            case ZYDIS_ROUNDING_MODE_RZ:
                instruction->vector_length = 3;
                break;
            default:
                ZYAN_UNREACHABLE;
            }
        }
    }
    else if (match->definition->encoding == ZYDIS_INSTRUCTION_ENCODING_MVEX)
    {
        instruction->sss |= ZydisEncodeMvexBroadcastMode(match->request->mvex.broadcast);
        instruction->sss |= ZydisEncodeMvexConversionMode(match->request->mvex.conversion);

        switch (match->request->mvex.rounding)
        {
        case ZYDIS_ROUNDING_MODE_INVALID:
            break;
        case ZYDIS_ROUNDING_MODE_RN:
        case ZYDIS_ROUNDING_MODE_RD:
        case ZYDIS_ROUNDING_MODE_RU:
        case ZYDIS_ROUNDING_MODE_RZ:
            instruction->sss |= match->request->mvex.rounding - ZYDIS_ROUNDING_MODE_RN;
            break;
        default:
            ZYAN_UNREACHABLE;
        }

        switch (match->request->mvex.swizzle)
        {
        case ZYDIS_SWIZZLE_MODE_INVALID:
            break;
        case ZYDIS_SWIZZLE_MODE_DCBA:
        case ZYDIS_SWIZZLE_MODE_CDAB:
        case ZYDIS_SWIZZLE_MODE_BADC:
        case ZYDIS_SWIZZLE_MODE_DACB:
        case ZYDIS_SWIZZLE_MODE_AAAA:
        case ZYDIS_SWIZZLE_MODE_BBBB:
        case ZYDIS_SWIZZLE_MODE_CCCC:
        case ZYDIS_SWIZZLE_MODE_DDDD:
            instruction->sss |= match->request->mvex.swizzle - ZYDIS_SWIZZLE_MODE_DCBA;
            break;
        default:
            ZYAN_UNREACHABLE;
        }

        if ((match->request->mvex.sae) ||
            (match->request->mvex.eviction_hint) ||
            (match->request->mvex.rounding != ZYDIS_ROUNDING_MODE_INVALID))
        {
            instruction->eviction_hint = ZYAN_TRUE;
        }
        if (match->request->mvex.sae)
        {
            instruction->sss |= 4;
        }

        // Following instructions violate general `MVEX.EH` handling rules. In all other cases this
        // bit is used either as eviction hint (memory operands present) or to encode MVEX-specific
        // functionality (register forms). Instructions listed below use `MVEX.EH` to identify
        // different instructions with memory operands and don't treat it as eviction hint.
        switch (match->request->mnemonic)
        {
        case ZYDIS_MNEMONIC_VMOVNRAPD:
        case ZYDIS_MNEMONIC_VMOVNRAPS:
            instruction->eviction_hint = ZYAN_FALSE;
            break;
        case ZYDIS_MNEMONIC_VMOVNRNGOAPD:
        case ZYDIS_MNEMONIC_VMOVNRNGOAPS:
            instruction->eviction_hint = ZYAN_TRUE;
            break;
        default:
            break;
        }
    }

    switch (match->definition->mandatory_prefix)
    {
    case ZYDIS_MANDATORY_PREFIX_NONE:
        break;
    case ZYDIS_MANDATORY_PREFIX_66:
        instruction->attributes |= ZYDIS_ATTRIB_HAS_OPERANDSIZE;
        break;
    case ZYDIS_MANDATORY_PREFIX_F2:
        instruction->attributes |= ZYDIS_ATTRIB_HAS_REPNE;
        break;
    case ZYDIS_MANDATORY_PREFIX_F3:
        instruction->attributes |= ZYDIS_ATTRIB_HAS_REP;
        break;
    default:
        ZYAN_UNREACHABLE;
    }

    const ZyanU8 mode_width = ZydisGetMachineModeWidth(match->request->machine_mode);
    if (match->easz != mode_width)
    {
        instruction->attributes |= ZYDIS_ATTRIB_HAS_ADDRESSSIZE;
    }
    if ((match->request->machine_mode == ZYDIS_MACHINE_MODE_LONG_64) &&
        (match->base_definition->operand_size_map != ZYDIS_OPSIZE_MAP_FORCE64))
    {
        switch (match->eosz)
        {
        case 16:
            instruction->attributes |= ZYDIS_ATTRIB_HAS_OPERANDSIZE;
            break;
        case 32:
            break;
        case 64:
            instruction->rex_w =
                match->base_definition->operand_size_map != ZYDIS_OPSIZE_MAP_DEFAULT64;
            break;
        default:
            ZYAN_UNREACHABLE;
        }
    }
    else
    {
        if (match->eosz != mode_width)
        {
            instruction->attributes |= ZYDIS_ATTRIB_HAS_OPERANDSIZE;
        }
    }

    for (ZyanU8 i = 0; i < match->request->operand_count; ++i)
    {
        const ZydisEncoderOperand *user_op = &match->request->operands[i];
        const ZydisOperandDefinition *def_op = &match->operands[i];
        switch (user_op->type)
        {
        case ZYDIS_OPERAND_TYPE_REGISTER:
            ZydisBuildRegisterOperand(user_op, def_op, instruction);
            break;
        case ZYDIS_OPERAND_TYPE_MEMORY:
            if (def_op->type != ZYDIS_SEMANTIC_OPTYPE_MOFFS)
            {
                ZydisBuildMemoryOperand(match, user_op, instruction);
                if ((match->cd8_scale) &&
                    (instruction->disp_size == 8))
                {
                    instruction->disp >>= match->cd8_scale;
                }
            }
            else
            {
                instruction->disp_size = match->disp_size;
                instruction->disp = (ZyanU64)user_op->mem.displacement;
            }
            break;
        case ZYDIS_OPERAND_TYPE_POINTER:
            instruction->disp_size = match->disp_size;
            instruction->disp = user_op->ptr.offset;
            instruction->imm_size = match->imm_size;
            instruction->imm = user_op->ptr.segment;
            break;
        case ZYDIS_OPERAND_TYPE_IMMEDIATE:
            if (def_op->type == ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_IMM1)
            {
                break;
            }
            if (def_op->op.encoding != ZYDIS_OPERAND_ENCODING_IS4)
            {
                if (instruction->imm_size)
                {
                    ZYAN_ASSERT(instruction->disp_size == 0);
                    instruction->disp_size = match->disp_size;
                    instruction->disp = instruction->imm;
                }
                instruction->imm_size = match->imm_size;
                instruction->imm = user_op->imm.u;
            }
            else
            {
                ZYAN_ASSERT(instruction->imm_size == 8);
                instruction->imm |= user_op->imm.u;
            }
            break;
        default:
            ZYAN_UNREACHABLE;
        }
    }

    return ZYAN_STATUS_SUCCESS;
}

/**
 * Performs a set of sanity checks that must be satisfied for every valid encoder request.
 *
 * @param   request A pointer to `ZydisEncoderRequest` struct.
 *
 * @return  A zyan status code.
 */
static ZyanStatus ZydisEncoderCheckRequestSanity(const ZydisEncoderRequest *request)
{
    if (((ZyanUSize)request->machine_mode > ZYDIS_MACHINE_MODE_MAX_VALUE) ||
        ((ZyanUSize)request->allowed_encodings > ZYDIS_ENCODABLE_ENCODING_MAX_VALUE) ||
        ((ZyanUSize)request->mnemonic > ZYDIS_MNEMONIC_MAX_VALUE) ||
        ((ZyanUSize)request->branch_type > ZYDIS_BRANCH_TYPE_MAX_VALUE) ||
        ((ZyanUSize)request->branch_width > ZYDIS_BRANCH_WIDTH_MAX_VALUE) ||
        ((ZyanUSize)request->address_size_hint > ZYDIS_ADDRESS_SIZE_HINT_MAX_VALUE) ||
        ((ZyanUSize)request->operand_size_hint > ZYDIS_OPERAND_SIZE_HINT_MAX_VALUE) ||
        ((ZyanUSize)request->evex.broadcast > ZYDIS_BROADCAST_MODE_MAX_VALUE) ||
        ((ZyanUSize)request->evex.rounding > ZYDIS_ROUNDING_MODE_MAX_VALUE) ||
        ((ZyanUSize)request->mvex.broadcast > ZYDIS_BROADCAST_MODE_MAX_VALUE) ||
        ((ZyanUSize)request->mvex.conversion > ZYDIS_CONVERSION_MODE_MAX_VALUE) ||
        ((ZyanUSize)request->mvex.rounding > ZYDIS_ROUNDING_MODE_MAX_VALUE) ||
        ((ZyanUSize)request->mvex.swizzle > ZYDIS_SWIZZLE_MODE_MAX_VALUE) ||
        (request->operand_count > ZYDIS_ENCODER_MAX_OPERANDS) ||
        (request->mnemonic == ZYDIS_MNEMONIC_INVALID) ||
        (request->prefixes & ~ZYDIS_ENCODABLE_PREFIXES))
    {
        return ZYAN_STATUS_INVALID_ARGUMENT;
    }

    if (request->prefixes & ZYDIS_ATTRIB_HAS_SEGMENT)
    {
        if ((request->machine_mode == ZYDIS_MACHINE_MODE_LONG_64) &&
            (request->prefixes & ZYDIS_LEGACY_SEGMENTS))
        {
            return ZYAN_STATUS_INVALID_ARGUMENT;
        }

        ZyanU8 seg_override_count = 0;
        if (request->prefixes & ZYDIS_ATTRIB_HAS_SEGMENT_CS)
        {
            ++seg_override_count;
        }
        if (request->prefixes & ZYDIS_ATTRIB_HAS_SEGMENT_SS)
        {
            ++seg_override_count;
        }
        if (request->prefixes & ZYDIS_ATTRIB_HAS_SEGMENT_DS)
        {
            ++seg_override_count;
        }
        if (request->prefixes & ZYDIS_ATTRIB_HAS_SEGMENT_ES)
        {
            ++seg_override_count;
        }
        if (request->prefixes & ZYDIS_ATTRIB_HAS_SEGMENT_FS)
        {
            ++seg_override_count;
        }
        if (request->prefixes & ZYDIS_ATTRIB_HAS_SEGMENT_GS)
        {
            ++seg_override_count;
        }
        if (seg_override_count != 1)
        {
            return ZYAN_STATUS_INVALID_ARGUMENT;
        }
    }
    ZyanU8 rep_family_count = 0;
    if (request->prefixes & ZYDIS_ATTRIB_HAS_REP)
    {
        ++rep_family_count;
    }
    if (request->prefixes & ZYDIS_ATTRIB_HAS_REPE)
    {
        ++rep_family_count;
    }
    if (request->prefixes & ZYDIS_ATTRIB_HAS_REPNE)
    {
        ++rep_family_count;
    }
    if (rep_family_count > 1)
    {
        return ZYAN_STATUS_INVALID_ARGUMENT;
    }
    if ((request->prefixes & ZYDIS_ATTRIB_HAS_XACQUIRE) &&
        (request->prefixes & ZYDIS_ATTRIB_HAS_XRELEASE))
    {
        return ZYAN_STATUS_INVALID_ARGUMENT;
    }
    if ((request->prefixes & ZYDIS_ATTRIB_HAS_BRANCH_NOT_TAKEN) &&
        (request->prefixes & ZYDIS_ATTRIB_HAS_BRANCH_TAKEN))
    {
        return ZYAN_STATUS_INVALID_ARGUMENT;
    }
    if ((request->prefixes & ZYDIS_ATTRIB_HAS_NOTRACK) &&
        (request->prefixes & ZYDIS_ATTRIB_HAS_SEGMENT))
    {
        return ZYAN_STATUS_INVALID_ARGUMENT;
    }

    static const ZyanBool branch_lookup
        [ZYDIS_BRANCH_WIDTH_MAX_VALUE + 1][ZYDIS_BRANCH_TYPE_MAX_VALUE + 1] =
    {
        /* NONE */ { ZYAN_TRUE,  ZYAN_TRUE,  ZYAN_TRUE,  ZYAN_TRUE  },
        /* 8    */ { ZYAN_TRUE,  ZYAN_TRUE,  ZYAN_FALSE, ZYAN_FALSE },
        /* 16   */ { ZYAN_TRUE,  ZYAN_FALSE, ZYAN_TRUE,  ZYAN_TRUE  },
        /* 32   */ { ZYAN_TRUE,  ZYAN_FALSE, ZYAN_TRUE,  ZYAN_TRUE  },
        /* 64   */ { ZYAN_TRUE,  ZYAN_FALSE, ZYAN_TRUE,  ZYAN_TRUE  },
    };
    if (!branch_lookup[request->branch_width][request->branch_type])
    {
        return ZYAN_STATUS_INVALID_ARGUMENT;
    }

    if (request->machine_mode == ZYDIS_MACHINE_MODE_LONG_64)
    {
        if (request->address_size_hint == ZYDIS_ADDRESS_SIZE_HINT_16)
        {
            return ZYAN_STATUS_INVALID_ARGUMENT;
        }
    }
    else
    {
        if ((request->branch_width == ZYDIS_BRANCH_WIDTH_64) ||
            (request->address_size_hint == ZYDIS_ADDRESS_SIZE_HINT_64) ||
            (request->operand_size_hint == ZYDIS_OPERAND_SIZE_HINT_64))
        {
            return ZYAN_STATUS_INVALID_ARGUMENT;
        }
    }

    for (ZyanU8 i = 0; i < request->operand_count; ++i)
    {
        const ZydisEncoderOperand *op = &request->operands[i];
        if ((op->type == ZYDIS_OPERAND_TYPE_UNUSED) ||
            ((ZyanUSize)op->type > ZYDIS_OPERAND_TYPE_MAX_VALUE))
        {
            return ZYAN_STATUS_INVALID_ARGUMENT;
        }

        switch (op->type)
        {
        case ZYDIS_OPERAND_TYPE_REGISTER:
            if (op->reg.value > ZYDIS_REGISTER_MAX_VALUE)
            {
                return ZYAN_STATUS_INVALID_ARGUMENT;
            }
            break;
        case ZYDIS_OPERAND_TYPE_MEMORY:
            if (((ZyanUSize)op->mem.base > ZYDIS_REGISTER_MAX_VALUE) ||
                ((ZyanUSize)op->mem.index > ZYDIS_REGISTER_MAX_VALUE) ||
                !ZydisIsScaleValid(op->mem.scale))
            {
                return ZYAN_STATUS_INVALID_ARGUMENT;
            }
            break;
        case ZYDIS_OPERAND_TYPE_POINTER:
        case ZYDIS_OPERAND_TYPE_IMMEDIATE:
            break;
        default:
            return ZYAN_STATUS_INVALID_ARGUMENT;
        }
    }

    return ZYAN_STATUS_SUCCESS;
}

/**
 * Encodes instruction with semantics specified in encoder request structure.
 *
 * @param   request     A pointer to the `ZydisEncoderRequest` struct. Must be validated before
 *                      calling this function.
 * @param   buffer      A pointer to the output buffer receiving encoded instruction.
 * @param   length      A pointer to the variable containing length of the output buffer. Upon
 *                      successful return this variable receives length of the encoded instruction.
 * @param   instruction Internal state of the encoder.
 *
 * @return  A zyan status code.
 */
static ZyanStatus ZydisEncoderEncodeInstructionInternal(const ZydisEncoderRequest *request,
    void *buffer, ZyanUSize *length, ZydisEncoderInstruction *instruction)
{
    ZydisEncoderInstructionMatch match;
    ZYAN_CHECK(ZydisFindMatchingDefinition(request, &match));
    ZydisEncoderBuffer output;
    output.buffer = (ZyanU8 *)buffer;
    output.size = *length;
    output.offset = 0;
    ZYAN_CHECK(ZydisBuildInstruction(&match, instruction));
    ZYAN_CHECK(ZydisEmitInstruction(instruction, &output));
    *length = output.offset;
    return ZYAN_STATUS_SUCCESS;
}

/* ============================================================================================== */
/* Exported functions                                                                             */
/* ============================================================================================== */

ZYDIS_EXPORT ZyanStatus ZydisEncoderEncodeInstruction(const ZydisEncoderRequest *request,
    void *buffer, ZyanUSize *length)
{
    if (!request || !buffer || !length)
    {
        return ZYAN_STATUS_INVALID_ARGUMENT;
    }
    ZYAN_CHECK(ZydisEncoderCheckRequestSanity(request));

    ZydisEncoderInstruction instruction;
    return ZydisEncoderEncodeInstructionInternal(request, buffer, length, &instruction);
}

ZYDIS_EXPORT ZyanStatus ZydisEncoderEncodeInstructionAbsolute(ZydisEncoderRequest *request,
    void *buffer, ZyanUSize *length, ZyanU64 runtime_address)
{
    if (!request || !buffer || !length)
    {
        return ZYAN_STATUS_INVALID_ARGUMENT;
    }
    ZYAN_CHECK(ZydisEncoderCheckRequestSanity(request));

    const ZydisEncoderRelInfo *rel_info = ZydisGetRelInfo(request->mnemonic);
    ZydisEncoderOperand *op_rip_rel = ZYAN_NULL;
    ZyanBool adjusted_rel = ZYAN_FALSE;
    ZyanU64 absolute_address = 0;
    ZyanU8 mode_index = ZydisGetMachineModeWidth(request->machine_mode) >> 5;
    for (ZyanU8 i = 0; i < request->operand_count; ++i)
    {
        ZydisEncoderOperand *op = &request->operands[i];
        if ((op->type == ZYDIS_OPERAND_TYPE_IMMEDIATE) && rel_info)
        {
            if (adjusted_rel)
            {
                return ZYAN_STATUS_INVALID_ARGUMENT;
            }

            switch (rel_info->accepts_scaling_hints)
            {
            case ZYDIS_SIZE_HINT_NONE:
            case ZYDIS_SIZE_HINT_OSZ:
            {
                static const ZyanI8 asz_priority[3][3] =
                {
                    { 0, 1, 2 },
                    { 0, 2, 1 },
                    { 0, 2, -1 },
                };
                static const ZyanI8 osz_priority[3][3] =
                {
                    { 0, 1, 2 },
                    { 0, 2, 1 },
                    { 0, 2, 1 },
                };
                ZyanI8 forced_priority_row[3] = { -1, -1, -1 };
                ZyanI8 *priority_row = ZYAN_NULL;
                ZyanU8 extra_length = 0;
                ZyanU8 start_offset = 0;
                if (rel_info->accepts_scaling_hints == ZYDIS_SIZE_HINT_NONE)
                {
                    if ((request->branch_type == ZYDIS_BRANCH_TYPE_FAR) ||
                        (request->branch_width == ZYDIS_BRANCH_WIDTH_64))
                    {
                        return ZYAN_STATUS_INVALID_ARGUMENT;
                    }
                    if ((rel_info->accepts_branch_hints) &&
                        (request->prefixes & (ZYDIS_ATTRIB_HAS_BRANCH_NOT_TAKEN |
                                              ZYDIS_ATTRIB_HAS_BRANCH_TAKEN)))
                    {
                        extra_length += 1;
                    }
                    if ((rel_info->accepts_bound) && (request->prefixes & ZYDIS_ATTRIB_HAS_BND))
                    {
                        extra_length += 1;
                        // `BND` prefix is not accepted for short `JMP` (Intel SDM Vol. 1)
                        if ((request->mnemonic == ZYDIS_MNEMONIC_JMP) &&
                            (request->branch_type == ZYDIS_BRANCH_TYPE_NONE) &&
                            (request->branch_width == ZYDIS_BRANCH_WIDTH_NONE))
                        {
                            start_offset = 1;
                        }
                    }
                    if (request->branch_width == ZYDIS_BRANCH_WIDTH_NONE)
                    {
                        if (request->branch_type == ZYDIS_BRANCH_TYPE_NEAR)
                        {
                            start_offset = 1;
                        }
                        priority_row = (ZyanI8 *)&asz_priority[mode_index];
                    }
                    else
                    {
                        forced_priority_row[0] = (ZyanI8)(request->branch_width - 1);
                        priority_row = (ZyanI8 *)&forced_priority_row;
                    }
                }
                else
                {
                    if (request->operand_size_hint == ZYDIS_OPERAND_SIZE_HINT_NONE)
                    {
                        priority_row = (ZyanI8 *)&osz_priority[mode_index];
                    }
                    else
                    {
                        if (request->operand_size_hint == ZYDIS_OPERAND_SIZE_HINT_64)
                        {
                            extra_length = 1;
                            forced_priority_row[0] = 2;
                        }
                        else
                        {
                            forced_priority_row[0] = (ZyanI8)(request->operand_size_hint - 1);
                        }
                        priority_row = (ZyanI8 *)&forced_priority_row;
                    }
                }
                ZYAN_ASSERT(ZYAN_ARRAY_LENGTH(asz_priority[0]) ==
                            ZYAN_ARRAY_LENGTH(osz_priority[0]));
                for (ZyanU8 j = start_offset; j < ZYAN_ARRAY_LENGTH(asz_priority[0]); ++j)
                {
                    ZyanI8 size_index = priority_row[j];
                    if (size_index < 0)
                    {
                        break;
                    }
                    ZyanU8 base_size = rel_info->size[mode_index][size_index];
                    if (base_size == 0)
                    {
                        continue;
                    }
                    ZyanU8 predicted_size = base_size + extra_length;
                    if (runtime_address > ZYAN_UINT64_MAX - predicted_size + 1)
                    {
                        continue;
                    }
                    ZyanI64 rel = (ZyanI64)(op->imm.u - (runtime_address + predicted_size));
                    ZyanU8 rel_size = ZydisGetSignedImmSize(rel);
                    if (rel_size > (8 << size_index))
                    {
                        continue;
                    }
                    op->imm.s = rel;
                    adjusted_rel = ZYAN_TRUE;
                    if (rel_info->accepts_scaling_hints == ZYDIS_SIZE_HINT_NONE)
                    {
                        if (request->branch_width == ZYDIS_BRANCH_WIDTH_NONE)
                        {
                            request->branch_width =
                                (ZydisBranchWidth)(ZYDIS_BRANCH_WIDTH_8 + size_index);
                        }
                    }
                    else
                    {
                        if (request->operand_size_hint == ZYDIS_OPERAND_SIZE_HINT_NONE)
                        {
                            request->operand_size_hint =
                                (ZydisOperandSizeHint)(ZYDIS_OPERAND_SIZE_HINT_8 + size_index);
                        }
                    }
                    break;
                }
                break;
            }
            case ZYDIS_SIZE_HINT_ASZ:
            {
                static const ZyanI8 asz_prefix_lookup[3][ZYDIS_ADDRESS_SIZE_HINT_MAX_VALUE + 1] =
                {
                    { 0, 0, 1, -1 },
                    { 0, 1, 0, -1 },
                    { 0, -1, 1, 0 },
                };
                ZyanI8 extra_length = asz_prefix_lookup[mode_index][request->address_size_hint];
                if (extra_length < 0)
                {
                    return ZYAN_STATUS_INVALID_ARGUMENT;
                }
                ZyanU8 asz_index = (request->address_size_hint == ZYDIS_ADDRESS_SIZE_HINT_NONE)
                    ? mode_index
                    : ZydisGetAszFromHint(request->address_size_hint) >> 5;
                ZYAN_ASSERT((rel_info->size[asz_index][0] != 0) &&
                            (rel_info->size[asz_index][1] == 0) &&
                            (rel_info->size[asz_index][2] == 0) &&
                            !rel_info->accepts_branch_hints);
                ZyanU8 predicted_size = rel_info->size[asz_index][0] + extra_length;
                if (runtime_address > ZYAN_UINT64_MAX - predicted_size + 1)
                {
                    return ZYAN_STATUS_INVALID_ARGUMENT;
                }
                ZyanI64 rel = (ZyanI64)(op->imm.u - (runtime_address + predicted_size));
                ZyanU8 rel_size = ZydisGetSignedImmSize(rel);
                if (rel_size > 8)
                {
                    return ZYAN_STATUS_INVALID_ARGUMENT;
                }
                op->imm.s = rel;
                adjusted_rel = ZYAN_TRUE;
                break;
            }
            default:
                ZYAN_UNREACHABLE;
            }
            if (!adjusted_rel)
            {
                return ZYAN_STATUS_INVALID_ARGUMENT;
            }
        }
        else if ((op->type == ZYDIS_OPERAND_TYPE_MEMORY) &&
                 ((op->mem.base == ZYDIS_REGISTER_EIP) ||
                  (op->mem.base == ZYDIS_REGISTER_RIP)))
        {
            if (op_rip_rel)
            {
                return ZYAN_STATUS_INVALID_ARGUMENT;
            }

            absolute_address = op->mem.displacement;
            op->mem.displacement = 0;
            op_rip_rel = op;
        }
    }

    ZydisEncoderInstruction instruction;
    ZYAN_CHECK(ZydisEncoderEncodeInstructionInternal(request, buffer, length, &instruction));
    if (op_rip_rel)
    {
        ZyanUSize instruction_size = *length;
        if (runtime_address > ZYAN_UINT64_MAX - instruction_size + 1)
        {
            return ZYAN_STATUS_INVALID_ARGUMENT;
        }
        ZyanI64 rip_rel = (ZyanI64)(absolute_address - (runtime_address + instruction_size));
        if (ZydisGetSignedImmSize(rip_rel) > 32)
        {
            return ZYAN_STATUS_INVALID_ARGUMENT;
        }
        ZYAN_ASSERT(instruction.disp_size != 0);
        ZyanU8 disp_offset = (instruction.disp_size >> 3) + (instruction.imm_size >> 3);
        if (instruction.encoding == ZYDIS_INSTRUCTION_ENCODING_3DNOW)
        {
            disp_offset += 1;
        }
        ZYAN_ASSERT(instruction_size > disp_offset);
        ZYAN_MEMCPY((ZyanU8 *)buffer + instruction_size - disp_offset, &rip_rel, sizeof(ZyanI32));
        op_rip_rel->mem.displacement = rip_rel;
    }

    return ZYAN_STATUS_SUCCESS;
}

ZYDIS_EXPORT ZyanStatus ZydisEncoderDecodedInstructionToEncoderRequest(
    const ZydisDecodedInstruction *instruction, const ZydisDecodedOperand* operands,
    ZyanU8 operand_count, ZydisEncoderRequest *request)
{
    if (!instruction || !request || (operand_count && !operands))
    {
        return ZYAN_STATUS_INVALID_ARGUMENT;
    }

    ZYAN_MEMSET(request, 0, sizeof(ZydisEncoderRequest));
    request->machine_mode = instruction->machine_mode;
    request->mnemonic = instruction->mnemonic;
    request->prefixes = instruction->attributes & ZYDIS_ENCODABLE_PREFIXES;
    request->branch_type = instruction->meta.branch_type;
    if (!(instruction->attributes & ZYDIS_ATTRIB_ACCEPTS_SEGMENT))
    {
        request->prefixes &= ~ZYDIS_ATTRIB_HAS_SEGMENT;
    }

    switch (instruction->address_width)
    {
    case 16:
        request->address_size_hint = ZYDIS_ADDRESS_SIZE_HINT_16;
        break;
    case 32:
        request->address_size_hint = ZYDIS_ADDRESS_SIZE_HINT_32;
        break;
    case 64:
        request->address_size_hint = ZYDIS_ADDRESS_SIZE_HINT_64;
        break;
    default:
        return ZYAN_STATUS_INVALID_ARGUMENT;
    }

    switch (instruction->operand_width)
    {
    case 8:
        request->operand_size_hint = ZYDIS_OPERAND_SIZE_HINT_8;
        break;
    case 16:
        request->operand_size_hint = ZYDIS_OPERAND_SIZE_HINT_16;
        break;
    case 32:
        request->operand_size_hint = ZYDIS_OPERAND_SIZE_HINT_32;
        break;
    case 64:
        request->operand_size_hint = ZYDIS_OPERAND_SIZE_HINT_64;
        break;
    default:
        return ZYAN_STATUS_INVALID_ARGUMENT;
    }

    switch (request->branch_type)
    {
    case ZYDIS_BRANCH_TYPE_NONE:
        request->branch_width = ZYDIS_BRANCH_WIDTH_NONE;
        break;
    case ZYDIS_BRANCH_TYPE_SHORT:
        request->branch_width = ZYDIS_BRANCH_WIDTH_8;
        break;
    case ZYDIS_BRANCH_TYPE_NEAR:
    case ZYDIS_BRANCH_TYPE_FAR:
        switch (instruction->operand_width)
        {
        case 16:
            request->branch_width = ZYDIS_BRANCH_WIDTH_16;
            break;
        case 32:
            request->branch_width = ZYDIS_BRANCH_WIDTH_32;
            break;
        case 64:
            request->branch_width = ZYDIS_BRANCH_WIDTH_64;
            break;
        default:
            ZYAN_UNREACHABLE;
        }
        break;
    default:
        return ZYAN_STATUS_INVALID_ARGUMENT;
    }

    switch (instruction->encoding)
    {
    case ZYDIS_INSTRUCTION_ENCODING_LEGACY:
    case ZYDIS_INSTRUCTION_ENCODING_3DNOW:
    case ZYDIS_INSTRUCTION_ENCODING_XOP:
    case ZYDIS_INSTRUCTION_ENCODING_VEX:
        break;
    case ZYDIS_INSTRUCTION_ENCODING_EVEX:
        request->evex.broadcast = !instruction->avx.broadcast.is_static ?
            instruction->avx.broadcast.mode : ZYDIS_BROADCAST_MODE_INVALID;
        request->evex.rounding = instruction->avx.rounding.mode;
        request->evex.sae = instruction->avx.has_sae;
        request->evex.zeroing_mask = (instruction->avx.mask.mode == ZYDIS_MASK_MODE_ZEROING ||
            instruction->avx.mask.mode == ZYDIS_MASK_MODE_CONTROL_ZEROING) &&
            (instruction->raw.evex.z) ? ZYAN_TRUE : ZYAN_FALSE;
        break;
    case ZYDIS_INSTRUCTION_ENCODING_MVEX:
        request->mvex.broadcast = !instruction->avx.broadcast.is_static ?
            instruction->avx.broadcast.mode : ZYDIS_BROADCAST_MODE_INVALID;
        request->mvex.conversion = instruction->avx.conversion.mode;
        request->mvex.rounding = instruction->avx.rounding.mode;
        request->mvex.swizzle = instruction->avx.swizzle.mode;
        request->mvex.sae = instruction->avx.has_sae;
        request->mvex.eviction_hint = instruction->avx.has_eviction_hint;
        break;
    default:
        return ZYAN_STATUS_INVALID_ARGUMENT;
    }
    request->allowed_encodings = 1 << instruction->encoding;

    if ((operand_count > ZYDIS_ENCODER_MAX_OPERANDS) ||
        (operand_count > instruction->operand_count_visible))
    {
        return ZYAN_STATUS_INVALID_ARGUMENT;
    }
    request->operand_count = operand_count;
    for (ZyanU8 i = 0; i < operand_count; ++i)
    {
        const ZydisDecodedOperand *dec_op = &operands[i];
        ZydisEncoderOperand *enc_op = &request->operands[i];

        enc_op->type = dec_op->type;
        switch (dec_op->type)
        {
        case ZYDIS_OPERAND_TYPE_REGISTER:
            enc_op->reg.value = dec_op->reg.value;
            enc_op->reg.is4 = dec_op->encoding == ZYDIS_OPERAND_ENCODING_IS4;
            break;
        case ZYDIS_OPERAND_TYPE_MEMORY:
            enc_op->mem.base = dec_op->mem.base;
            enc_op->mem.index = dec_op->mem.index;
            enc_op->mem.scale = dec_op->mem.type != ZYDIS_MEMOP_TYPE_MIB ? dec_op->mem.scale : 0;
            if (dec_op->mem.disp.has_displacement)
            {
                enc_op->mem.displacement = dec_op->mem.disp.value;
            }
            enc_op->mem.size = dec_op->size / 8;
            break;
        case ZYDIS_OPERAND_TYPE_POINTER:
            enc_op->ptr.segment = dec_op->ptr.segment;
            enc_op->ptr.offset = dec_op->ptr.offset;
            break;
        case ZYDIS_OPERAND_TYPE_IMMEDIATE:
            enc_op->imm.u = dec_op->imm.value.u;
            // `XBEGIN` is an ISA-wide unique instruction because it's not a branching instruction
            // but it has a relative operand which behaves differently from all other relatives
            // (no truncating behavior in 16-bit mode). Encoder treats it as non-branching
            // instruction that scales with hidden operand size.
            if ((dec_op->imm.is_relative) &&
                (instruction->mnemonic != ZYDIS_MNEMONIC_XBEGIN))
            {
                switch (instruction->raw.imm->size)
                {
                case 8:
                    request->branch_width = ZYDIS_BRANCH_WIDTH_8;
                    break;
                case 16:
                    request->branch_width = ZYDIS_BRANCH_WIDTH_16;
                    break;
                case 32:
                    request->branch_width = ZYDIS_BRANCH_WIDTH_32;
                    break;
                default:
                    return ZYAN_STATUS_INVALID_ARGUMENT;
                }
            }
            break;
        default:
            return ZYAN_STATUS_INVALID_ARGUMENT;
        }
    }

    return ZYAN_STATUS_SUCCESS;
}

ZYDIS_EXPORT ZyanStatus ZydisEncoderNopFill(void *buffer, ZyanUSize length)
{
    if (!buffer)
    {
        return ZYAN_STATUS_INVALID_ARGUMENT;
    }

    // Intel SDM Vol. 2B "Recommended Multi-Byte Sequence of NOP Instruction"
    static const ZyanU8 nops[9][9] =
    {
        { 0x90 },
        { 0x66, 0x90 },
        { 0x0F, 0x1F, 0x00 },
        { 0x0F, 0x1F, 0x40, 0x00 },
        { 0x0F, 0x1F, 0x44, 0x00, 0x00 },
        { 0x66, 0x0F, 0x1F, 0x44, 0x00, 0x00 },
        { 0x0F, 0x1F, 0x80, 0x00, 0x00, 0x00, 0x00 },
        { 0x0F, 0x1F, 0x84, 0x00, 0x00, 0x00, 0x00, 0x00 },
        { 0x66, 0x0F, 0x1F, 0x84, 0x00, 0x00, 0x00, 0x00, 0x00 },
    };

    ZyanU8 *output = (ZyanU8 *)buffer;
    while (length)
    {
        ZyanUSize nop_size = (length > 9) ? 9 : length;
        ZYAN_MEMCPY(output, nops[nop_size - 1], nop_size);
        output += nop_size;
        length -= nop_size;
    }

    return ZYAN_STATUS_SUCCESS;
}

/* ============================================================================================== */

//
// Source file: /home/ath/devel/zydis/src/EncoderData.c
//

/***************************************************************************************************

  Zyan Disassembler Library (Zydis)

  Original Author : Mappa

 * Permission is hereby granted, free of charge, to any person obtaining a copy
 * of this software and associated documentation files (the "Software"), to deal
 * in the Software without restriction, including without limitation the rights
 * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
 * copies of the Software, and to permit persons to whom the Software is
 * furnished to do so, subject to the following conditions:
 *
 * The above copyright notice and this permission notice shall be included in all
 * copies or substantial portions of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
 * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
 * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
 * SOFTWARE.

***************************************************************************************************/



//
// Header: Generated/EncoderTables.inc
//

const ZydisEncoderLookupEntry encoder_instruction_lookup[] =
{
    { 0x0000, 0 },
    { 0x0000, 1 },
    { 0x0001, 1 },
    { 0x0002, 2 },
    { 0x0004, 1 },
    { 0x0005, 2 },
    { 0x0007, 1 },
    { 0x0008, 18 },
    { 0x001A, 4 },
    { 0x001E, 18 },
    { 0x0030, 2 },
    { 0x0032, 2 },
    { 0x0034, 2 },
    { 0x0036, 2 },
    { 0x0038, 2 },
    { 0x003A, 2 },
    { 0x003C, 4 },
    { 0x0040, 2 },
    { 0x0042, 1 },
    { 0x0043, 1 },
    { 0x0044, 2 },
    { 0x0046, 1 },
    { 0x0047, 1 },
    { 0x0048, 2 },
    { 0x004A, 1 },
    { 0x004B, 1 },
    { 0x004C, 2 },
    { 0x004E, 1 },
    { 0x004F, 1 },
    { 0x0050, 2 },
    { 0x0052, 2 },
    { 0x0054, 18 },
    { 0x0066, 6 },
    { 0x006C, 2 },
    { 0x006E, 2 },
    { 0x0070, 2 },
    { 0x0072, 2 },
    { 0x0074, 2 },
    { 0x0076, 2 },
    { 0x0078, 2 },
    { 0x007A, 4 },
    { 0x007E, 2 },
    { 0x0080, 2 },
    { 0x0082, 2 },
    { 0x0084, 2 },
    { 0x0086, 2 },
    { 0x0088, 2 },
    { 0x008A, 2 },
    { 0x008C, 2 },
    { 0x008E, 2 },
    { 0x0090, 2 },
    { 0x0092, 2 },
    { 0x0094, 2 },
    { 0x0096, 2 },
    { 0x0098, 2 },
    { 0x009A, 4 },
    { 0x009E, 4 },
    { 0x00A2, 4 },
    { 0x00A6, 2 },
    { 0x00A8, 2 },
    { 0x00AA, 6 },
    { 0x00B0, 2 },
    { 0x00B2, 2 },
    { 0x00B4, 2 },
    { 0x00B6, 2 },
    { 0x00B8, 1 },
    { 0x00B9, 4 },
    { 0x00BD, 4 },
    { 0x00C1, 4 },
    { 0x00C5, 4 },
    { 0x00C9, 6 },
    { 0x00CF, 6 },
    { 0x00D5, 1 },
    { 0x00D6, 1 },
    { 0x00D7, 1 },
    { 0x00D8, 1 },
    { 0x00D9, 1 },
    { 0x00DA, 1 },
    { 0x00DB, 1 },
    { 0x00DC, 2 },
    { 0x00DE, 2 },
    { 0x00E0, 1 },
    { 0x00E1, 1 },
    { 0x00E2, 1 },
    { 0x00E3, 1 },
    { 0x00E4, 1 },
    { 0x00E5, 1 },
    { 0x00E6, 1 },
    { 0x00E7, 1 },
    { 0x00E8, 1 },
    { 0x00E9, 1 },
    { 0x00EA, 2 },
    { 0x00EC, 2 },
    { 0x00EE, 2 },
    { 0x00F0, 2 },
    { 0x00F2, 2 },
    { 0x00F4, 2 },
    { 0x00F6, 2 },
    { 0x00F8, 2 },
    { 0x00FA, 2 },
    { 0x00FC, 2 },
    { 0x00FE, 2 },
    { 0x0100, 2 },
    { 0x0102, 2 },
    { 0x0104, 2 },
    { 0x0106, 2 },
    { 0x0108, 2 },
    { 0x010A, 18 },
    { 0x011C, 2 },
    { 0x011E, 2 },
    { 0x0120, 1 },
    { 0x0121, 3 },
    { 0x0124, 1 },
    { 0x0125, 2 },
    { 0x0127, 1 },
    { 0x0128, 4 },
    { 0x012C, 1 },
    { 0x012D, 2 },
    { 0x012F, 2 },
    { 0x0131, 2 },
    { 0x0133, 1 },
    { 0x0134, 1 },
    { 0x0135, 4 },
    { 0x0139, 2 },
    { 0x013B, 2 },
    { 0x013D, 2 },
    { 0x013F, 2 },
    { 0x0141, 2 },
    { 0x0143, 2 },
    { 0x0145, 2 },
    { 0x0147, 2 },
    { 0x0149, 2 },
    { 0x014B, 2 },
    { 0x014D, 4 },
    { 0x0151, 2 },
    { 0x0153, 4 },
    { 0x0157, 4 },
    { 0x015B, 2 },
    { 0x015D, 4 },
    { 0x0161, 2 },
    { 0x0163, 2 },
    { 0x0165, 2 },
    { 0x0167, 2 },
    { 0x0169, 4 },
    { 0x016D, 4 },
    { 0x0171, 1 },
    { 0x0172, 1 },
    { 0x0173, 1 },
    { 0x0174, 1 },
    { 0x0175, 5 },
    { 0x017A, 2 },
    { 0x017C, 4 },
    { 0x0180, 2 },
    { 0x0182, 2 },
    { 0x0184, 2 },
    { 0x0186, 2 },
    { 0x0188, 2 },
    { 0x018A, 2 },
    { 0x018C, 1 },
    { 0x018D, 2 },
    { 0x018F, 2 },
    { 0x0191, 2 },
    { 0x0193, 1 },
    { 0x0194, 1 },
    { 0x0195, 1 },
    { 0x0196, 1 },
    { 0x0197, 1 },
    { 0x0198, 1 },
    { 0x0199, 1 },
    { 0x019A, 2 },
    { 0x019C, 2 },
    { 0x019E, 1 },
    { 0x019F, 1 },
    { 0x01A0, 4 },
    { 0x01A4, 1 },
    { 0x01A5, 1 },
    { 0x01A6, 1 },
    { 0x01A7, 1 },
    { 0x01A8, 1 },
    { 0x01A9, 1 },
    { 0x01AA, 1 },
    { 0x01AB, 1 },
    { 0x01AC, 1 },
    { 0x01AD, 1 },
    { 0x01AE, 1 },
    { 0x01AF, 1 },
    { 0x01B0, 3 },
    { 0x01B3, 1 },
    { 0x01B4, 1 },
    { 0x01B5, 4 },
    { 0x01B9, 1 },
    { 0x01BA, 1 },
    { 0x01BB, 1 },
    { 0x01BC, 1 },
    { 0x01BD, 4 },
    { 0x01C1, 1 },
    { 0x01C2, 4 },
    { 0x01C6, 1 },
    { 0x01C7, 1 },
    { 0x01C8, 1 },
    { 0x01C9, 1 },
    { 0x01CA, 1 },
    { 0x01CB, 2 },
    { 0x01CD, 2 },
    { 0x01CF, 2 },
    { 0x01D1, 2 },
    { 0x01D3, 2 },
    { 0x01D5, 3 },
    { 0x01D8, 2 },
    { 0x01DA, 1 },
    { 0x01DB, 2 },
    { 0x01DD, 3 },
    { 0x01E0, 3 },
    { 0x01E3, 2 },
    { 0x01E5, 2 },
    { 0x01E7, 4 },
    { 0x01EB, 1 },
    { 0x01EC, 1 },
    { 0x01ED, 2 },
    { 0x01EF, 1 },
    { 0x01F0, 1 },
    { 0x01F1, 1 },
    { 0x01F2, 1 },
    { 0x01F3, 1 },
    { 0x01F4, 1 },
    { 0x01F5, 4 },
    { 0x01F9, 1 },
    { 0x01FA, 1 },
    { 0x01FB, 1 },
    { 0x01FC, 1 },
    { 0x01FD, 2 },
    { 0x01FF, 1 },
    { 0x0200, 2 },
    { 0x0202, 2 },
    { 0x0204, 1 },
    { 0x0205, 1 },
    { 0x0206, 1 },
    { 0x0207, 1 },
    { 0x0208, 1 },
    { 0x0209, 2 },
    { 0x020B, 1 },
    { 0x020C, 1 },
    { 0x020D, 1 },
    { 0x020E, 1 },
    { 0x020F, 1 },
    { 0x0210, 3 },
    { 0x0213, 5 },
    { 0x0218, 1 },
    { 0x0219, 4 },
    { 0x021D, 1 },
    { 0x021E, 4 },
    { 0x0222, 1 },
    { 0x0223, 1 },
    { 0x0224, 1 },
    { 0x0225, 1 },
    { 0x0226, 1 },
    { 0x0227, 1 },
    { 0x0228, 1 },
    { 0x0229, 1 },
    { 0x022A, 1 },
    { 0x022B, 1 },
    { 0x022C, 1 },
    { 0x022D, 1 },
    { 0x022E, 1 },
    { 0x022F, 1 },
    { 0x0230, 1 },
    { 0x0231, 1 },
    { 0x0232, 1 },
    { 0x0233, 1 },
    { 0x0234, 2 },
    { 0x0236, 2 },
    { 0x0238, 2 },
    { 0x023A, 2 },
    { 0x023C, 2 },
    { 0x023E, 1 },
    { 0x023F, 1 },
    { 0x0240, 2 },
    { 0x0242, 2 },
    { 0x0244, 4 },
    { 0x0248, 10 },
    { 0x0252, 6 },
    { 0x0258, 5 },
    { 0x025D, 1 },
    { 0x025E, 1 },
    { 0x025F, 1 },
    { 0x0260, 1 },
    { 0x0261, 2 },
    { 0x0263, 2 },
    { 0x0265, 1 },
    { 0x0266, 1 },
    { 0x0267, 1 },
    { 0x0268, 1 },
    { 0x0269, 1 },
    { 0x026A, 1 },
    { 0x026B, 2 },
    { 0x026D, 1 },
    { 0x026E, 1 },
    { 0x026F, 1 },
    { 0x0270, 2 },
    { 0x0272, 2 },
    { 0x0274, 1 },
    { 0x0275, 1 },
    { 0x0276, 1 },
    { 0x0277, 4 },
    { 0x027B, 4 },
    { 0x027F, 1 },
    { 0x0280, 2 },
    { 0x0282, 2 },
    { 0x0284, 2 },
    { 0x0286, 4 },
    { 0x028A, 4 },
    { 0x028E, 8 },
    { 0x0296, 4 },
    { 0x029A, 4 },
    { 0x029E, 4 },
    { 0x02A2, 4 },
    { 0x02A6, 4 },
    { 0x02AA, 4 },
    { 0x02AE, 4 },
    { 0x02B2, 4 },
    { 0x02B6, 4 },
    { 0x02BA, 4 },
    { 0x02BE, 1 },
    { 0x02BF, 4 },
    { 0x02C3, 4 },
    { 0x02C7, 1 },
    { 0x02C8, 1 },
    { 0x02C9, 1 },
    { 0x02CA, 1 },
    { 0x02CB, 1 },
    { 0x02CC, 1 },
    { 0x02CD, 1 },
    { 0x02CE, 1 },
    { 0x02CF, 1 },
    { 0x02D0, 1 },
    { 0x02D1, 1 },
    { 0x02D2, 1 },
    { 0x02D3, 1 },
    { 0x02D4, 1 },
    { 0x02D5, 1 },
    { 0x02D6, 1 },
    { 0x02D7, 1 },
    { 0x02D8, 1 },
    { 0x02D9, 1 },
    { 0x02DA, 1 },
    { 0x02DB, 3 },
    { 0x02DE, 5 },
    { 0x02E3, 7 },
    { 0x02EA, 5 },
    { 0x02EF, 5 },
    { 0x02F4, 1 },
    { 0x02F5, 1 },
    { 0x02F6, 1 },
    { 0x02F7, 1 },
    { 0x02F8, 1 },
    { 0x02F9, 1 },
    { 0x02FA, 1 },
    { 0x02FB, 1 },
    { 0x02FC, 1 },
    { 0x02FD, 1 },
    { 0x02FE, 1 },
    { 0x02FF, 1 },
    { 0x0300, 1 },
    { 0x0301, 1 },
    { 0x0302, 1 },
    { 0x0303, 1 },
    { 0x0304, 1 },
    { 0x0305, 1 },
    { 0x0306, 1 },
    { 0x0307, 1 },
    { 0x0308, 1 },
    { 0x0309, 1 },
    { 0x030A, 1 },
    { 0x030B, 1 },
    { 0x030C, 1 },
    { 0x030D, 1 },
    { 0x030E, 1 },
    { 0x030F, 1 },
    { 0x0310, 1 },
    { 0x0311, 1 },
    { 0x0312, 1 },
    { 0x0313, 1 },
    { 0x0314, 1 },
    { 0x0315, 1 },
    { 0x0316, 1 },
    { 0x0317, 1 },
    { 0x0318, 1 },
    { 0x0319, 1 },
    { 0x031A, 1 },
    { 0x031B, 1 },
    { 0x031C, 1 },
    { 0x031D, 2 },
    { 0x031F, 1 },
    { 0x0320, 1 },
    { 0x0321, 1 },
    { 0x0322, 2 },
    { 0x0324, 1 },
    { 0x0325, 1 },
    { 0x0326, 1 },
    { 0x0327, 1 },
    { 0x0328, 1 },
    { 0x0329, 2 },
    { 0x032B, 1 },
    { 0x032C, 2 },
    { 0x032E, 2 },
    { 0x0330, 1 },
    { 0x0331, 2 },
    { 0x0333, 1 },
    { 0x0334, 1 },
    { 0x0335, 1 },
    { 0x0336, 1 },
    { 0x0337, 1 },
    { 0x0338, 1 },
    { 0x0339, 1 },
    { 0x033A, 1 },
    { 0x033B, 2 },
    { 0x033D, 1 },
    { 0x033E, 2 },
    { 0x0340, 2 },
    { 0x0342, 2 },
    { 0x0344, 4 },
    { 0x0348, 1 },
    { 0x0349, 1 },
    { 0x034A, 2 },
    { 0x034C, 2 },
    { 0x034E, 2 },
    { 0x0350, 2 },
    { 0x0352, 1 },
    { 0x0353, 1 },
    { 0x0354, 2 },
    { 0x0356, 2 },
    { 0x0358, 2 },
    { 0x035A, 2 },
    { 0x035C, 2 },
    { 0x035E, 2 },
    { 0x0360, 1 },
    { 0x0361, 30 },
    { 0x037F, 4 },
    { 0x0383, 4 },
    { 0x0387, 2 },
    { 0x0389, 16 },
    { 0x0399, 2 },
    { 0x039B, 2 },
    { 0x039D, 2 },
    { 0x039F, 1 },
    { 0x03A0, 4 },
    { 0x03A4, 4 },
    { 0x03A8, 1 },
    { 0x03A9, 2 },
    { 0x03AB, 2 },
    { 0x03AD, 1 },
    { 0x03AE, 2 },
    { 0x03B0, 2 },
    { 0x03B2, 1 },
    { 0x03B3, 1 },
    { 0x03B4, 1 },
    { 0x03B5, 1 },
    { 0x03B6, 2 },
    { 0x03B8, 1 },
    { 0x03B9, 1 },
    { 0x03BA, 1 },
    { 0x03BB, 1 },
    { 0x03BC, 1 },
    { 0x03BD, 16 },
    { 0x03CD, 1 },
    { 0x03CE, 1 },
    { 0x03CF, 5 },
    { 0x03D4, 2 },
    { 0x03D6, 2 },
    { 0x03D8, 1 },
    { 0x03D9, 4 },
    { 0x03DD, 1 },
    { 0x03DE, 4 },
    { 0x03E2, 2 },
    { 0x03E4, 4 },
    { 0x03E8, 4 },
    { 0x03EC, 4 },
    { 0x03F0, 2 },
    { 0x03F2, 4 },
    { 0x03F6, 2 },
    { 0x03F8, 2 },
    { 0x03FA, 2 },
    { 0x03FC, 2 },
    { 0x03FE, 6 },
    { 0x0404, 2 },
    { 0x0406, 2 },
    { 0x0408, 4 },
    { 0x040C, 36 },
    { 0x0430, 4 },
    { 0x0434, 18 },
    { 0x0446, 2 },
    { 0x0448, 2 },
    { 0x044A, 6 },
    { 0x0450, 1 },
    { 0x0451, 1 },
    { 0x0452, 1 },
    { 0x0453, 4 },
    { 0x0457, 4 },
    { 0x045B, 4 },
    { 0x045F, 4 },
    { 0x0463, 4 },
    { 0x0467, 2 },
    { 0x0469, 4 },
    { 0x046D, 4 },
    { 0x0471, 4 },
    { 0x0475, 4 },
    { 0x0479, 4 },
    { 0x047D, 4 },
    { 0x0481, 4 },
    { 0x0485, 4 },
    { 0x0489, 4 },
    { 0x048D, 4 },
    { 0x0491, 4 },
    { 0x0495, 4 },
    { 0x0499, 1 },
    { 0x049A, 4 },
    { 0x049E, 2 },
    { 0x04A0, 4 },
    { 0x04A4, 2 },
    { 0x04A6, 2 },
    { 0x04A8, 1 },
    { 0x04A9, 2 },
    { 0x04AB, 4 },
    { 0x04AF, 4 },
    { 0x04B3, 2 },
    { 0x04B5, 4 },
    { 0x04B9, 2 },
    { 0x04BB, 2 },
    { 0x04BD, 4 },
    { 0x04C1, 4 },
    { 0x04C5, 2 },
    { 0x04C7, 4 },
    { 0x04CB, 2 },
    { 0x04CD, 2 },
    { 0x04CF, 1 },
    { 0x04D0, 2 },
    { 0x04D2, 6 },
    { 0x04D8, 6 },
    { 0x04DE, 2 },
    { 0x04E0, 2 },
    { 0x04E2, 2 },
    { 0x04E4, 4 },
    { 0x04E8, 2 },
    { 0x04EA, 2 },
    { 0x04EC, 2 },
    { 0x04EE, 2 },
    { 0x04F0, 2 },
    { 0x04F2, 2 },
    { 0x04F4, 2 },
    { 0x04F6, 2 },
    { 0x04F8, 2 },
    { 0x04FA, 2 },
    { 0x04FC, 2 },
    { 0x04FE, 2 },
    { 0x0500, 2 },
    { 0x0502, 2 },
    { 0x0504, 2 },
    { 0x0506, 2 },
    { 0x0508, 2 },
    { 0x050A, 2 },
    { 0x050C, 2 },
    { 0x050E, 4 },
    { 0x0512, 4 },
    { 0x0516, 4 },
    { 0x051A, 2 },
    { 0x051C, 4 },
    { 0x0520, 4 },
    { 0x0524, 4 },
    { 0x0528, 2 },
    { 0x052A, 2 },
    { 0x052C, 2 },
    { 0x052E, 2 },
    { 0x0530, 2 },
    { 0x0532, 4 },
    { 0x0536, 4 },
    { 0x053A, 4 },
    { 0x053E, 2 },
    { 0x0540, 2 },
    { 0x0542, 4 },
    { 0x0546, 4 },
    { 0x054A, 2 },
    { 0x054C, 2 },
    { 0x054E, 2 },
    { 0x0550, 2 },
    { 0x0552, 4 },
    { 0x0556, 4 },
    { 0x055A, 2 },
    { 0x055C, 2 },
    { 0x055E, 2 },
    { 0x0560, 2 },
    { 0x0562, 2 },
    { 0x0564, 2 },
    { 0x0566, 2 },
    { 0x0568, 2 },
    { 0x056A, 2 },
    { 0x056C, 2 },
    { 0x056E, 2 },
    { 0x0570, 2 },
    { 0x0572, 2 },
    { 0x0574, 2 },
    { 0x0576, 2 },
    { 0x0578, 2 },
    { 0x057A, 4 },
    { 0x057E, 2 },
    { 0x0580, 4 },
    { 0x0584, 4 },
    { 0x0588, 2 },
    { 0x058A, 4 },
    { 0x058E, 4 },
    { 0x0592, 8 },
    { 0x059A, 1 },
    { 0x059B, 1 },
    { 0x059C, 4 },
    { 0x05A0, 1 },
    { 0x05A1, 1 },
    { 0x05A2, 1 },
    { 0x05A3, 4 },
    { 0x05A7, 1 },
    { 0x05A8, 1 },
    { 0x05A9, 1 },
    { 0x05AA, 1 },
    { 0x05AB, 1 },
    { 0x05AC, 1 },
    { 0x05AD, 1 },
    { 0x05AE, 1 },
    { 0x05AF, 1 },
    { 0x05B0, 4 },
    { 0x05B4, 4 },
    { 0x05B8, 2 },
    { 0x05BA, 2 },
    { 0x05BC, 2 },
    { 0x05BE, 2 },
    { 0x05C0, 4 },
    { 0x05C4, 4 },
    { 0x05C8, 4 },
    { 0x05CC, 6 },
    { 0x05D2, 1 },
    { 0x05D3, 6 },
    { 0x05D9, 6 },
    { 0x05DF, 1 },
    { 0x05E0, 6 },
    { 0x05E6, 6 },
    { 0x05EC, 6 },
    { 0x05F2, 1 },
    { 0x05F3, 6 },
    { 0x05F9, 6 },
    { 0x05FF, 4 },
    { 0x0603, 4 },
    { 0x0607, 4 },
    { 0x060B, 4 },
    { 0x060F, 4 },
    { 0x0613, 4 },
    { 0x0617, 4 },
    { 0x061B, 4 },
    { 0x061F, 2 },
    { 0x0621, 2 },
    { 0x0623, 2 },
    { 0x0625, 4 },
    { 0x0629, 4 },
    { 0x062D, 2 },
    { 0x062F, 4 },
    { 0x0633, 4 },
    { 0x0637, 4 },
    { 0x063B, 2 },
    { 0x063D, 4 },
    { 0x0641, 11 },
    { 0x064C, 1 },
    { 0x064D, 1 },
    { 0x064E, 1 },
    { 0x064F, 1 },
    { 0x0650, 1 },
    { 0x0651, 1 },
    { 0x0652, 4 },
    { 0x0656, 12 },
    { 0x0662, 2 },
    { 0x0664, 2 },
    { 0x0666, 12 },
    { 0x0672, 1 },
    { 0x0673, 1 },
    { 0x0674, 1 },
    { 0x0675, 1 },
    { 0x0676, 2 },
    { 0x0678, 1 },
    { 0x0679, 1 },
    { 0x067A, 1 },
    { 0x067B, 1 },
    { 0x067C, 1 },
    { 0x067D, 1 },
    { 0x067E, 1 },
    { 0x067F, 1 },
    { 0x0680, 1 },
    { 0x0681, 4 },
    { 0x0685, 1 },
    { 0x0686, 1 },
    { 0x0687, 12 },
    { 0x0693, 12 },
    { 0x069F, 6 },
    { 0x06A5, 2 },
    { 0x06A7, 2 },
    { 0x06A9, 2 },
    { 0x06AB, 2 },
    { 0x06AD, 1 },
    { 0x06AE, 2 },
    { 0x06B0, 2 },
    { 0x06B2, 1 },
    { 0x06B3, 1 },
    { 0x06B4, 1 },
    { 0x06B5, 12 },
    { 0x06C1, 6 },
    { 0x06C7, 1 },
    { 0x06C8, 18 },
    { 0x06DA, 1 },
    { 0x06DB, 1 },
    { 0x06DC, 1 },
    { 0x06DD, 1 },
    { 0x06DE, 1 },
    { 0x06DF, 1 },
    { 0x06E0, 1 },
    { 0x06E1, 1 },
    { 0x06E2, 1 },
    { 0x06E3, 2 },
    { 0x06E5, 2 },
    { 0x06E7, 2 },
    { 0x06E9, 2 },
    { 0x06EB, 2 },
    { 0x06ED, 2 },
    { 0x06EF, 2 },
    { 0x06F1, 2 },
    { 0x06F3, 2 },
    { 0x06F5, 2 },
    { 0x06F7, 2 },
    { 0x06F9, 2 },
    { 0x06FB, 2 },
    { 0x06FD, 2 },
    { 0x06FF, 2 },
    { 0x0701, 1 },
    { 0x0702, 2 },
    { 0x0704, 1 },
    { 0x0705, 2 },
    { 0x0707, 2 },
    { 0x0709, 2 },
    { 0x070B, 2 },
    { 0x070D, 2 },
    { 0x070F, 2 },
    { 0x0711, 2 },
    { 0x0713, 2 },
    { 0x0715, 24 },
    { 0x072D, 4 },
    { 0x0731, 6 },
    { 0x0737, 12 },
    { 0x0743, 4 },
    { 0x0747, 6 },
    { 0x074D, 2 },
    { 0x074F, 2 },
    { 0x0751, 2 },
    { 0x0753, 1 },
    { 0x0754, 2 },
    { 0x0756, 1 },
    { 0x0757, 2 },
    { 0x0759, 2 },
    { 0x075B, 2 },
    { 0x075D, 2 },
    { 0x075F, 2 },
    { 0x0761, 2 },
    { 0x0763, 1 },
    { 0x0764, 1 },
    { 0x0765, 1 },
    { 0x0766, 1 },
    { 0x0767, 1 },
    { 0x0768, 1 },
    { 0x0769, 1 },
    { 0x076A, 1 },
    { 0x076B, 1 },
    { 0x076C, 1 },
    { 0x076D, 2 },
    { 0x076F, 1 },
    { 0x0770, 1 },
    { 0x0771, 18 },
    { 0x0783, 2 },
    { 0x0785, 2 },
    { 0x0787, 2 },
    { 0x0789, 2 },
    { 0x078B, 1 },
    { 0x078C, 2 },
    { 0x078E, 2 },
    { 0x0790, 2 },
    { 0x0792, 2 },
    { 0x0794, 2 },
    { 0x0796, 2 },
    { 0x0798, 1 },
    { 0x0799, 1 },
    { 0x079A, 1 },
    { 0x079B, 1 },
    { 0x079C, 1 },
    { 0x079D, 1 },
    { 0x079E, 14 },
    { 0x07AC, 1 },
    { 0x07AD, 1 },
    { 0x07AE, 1 },
    { 0x07AF, 1 },
    { 0x07B0, 1 },
    { 0x07B1, 1 },
    { 0x07B2, 1 },
    { 0x07B3, 1 },
    { 0x07B4, 4 },
    { 0x07B8, 2 },
    { 0x07BA, 2 },
    { 0x07BC, 2 },
    { 0x07BE, 2 },
    { 0x07C0, 3 },
    { 0x07C3, 2 },
    { 0x07C5, 1 },
    { 0x07C6, 1 },
    { 0x07C7, 1 },
    { 0x07C8, 1 },
    { 0x07C9, 2 },
    { 0x07CB, 2 },
    { 0x07CD, 2 },
    { 0x07CF, 2 },
    { 0x07D1, 1 },
    { 0x07D2, 1 },
    { 0x07D3, 1 },
    { 0x07D4, 1 },
    { 0x07D5, 3 },
    { 0x07D8, 3 },
    { 0x07DB, 14 },
    { 0x07E9, 7 },
    { 0x07F0, 14 },
    { 0x07FE, 5 },
    { 0x0803, 3 },
    { 0x0806, 3 },
    { 0x0809, 5 },
    { 0x080E, 4 },
    { 0x0812, 4 },
    { 0x0816, 10 },
    { 0x0820, 10 },
    { 0x082A, 10 },
    { 0x0834, 10 },
    { 0x083E, 2 },
    { 0x0840, 2 },
    { 0x0842, 8 },
    { 0x084A, 6 },
    { 0x0850, 10 },
    { 0x085A, 10 },
    { 0x0864, 10 },
    { 0x086E, 10 },
    { 0x0878, 2 },
    { 0x087A, 2 },
    { 0x087C, 9 },
    { 0x0885, 9 },
    { 0x088E, 4 },
    { 0x0892, 4 },
    { 0x0896, 4 },
    { 0x089A, 4 },
    { 0x089E, 1 },
    { 0x089F, 4 },
    { 0x08A3, 3 },
    { 0x08A6, 1 },
    { 0x08A7, 2 },
    { 0x08A9, 2 },
    { 0x08AB, 1 },
    { 0x08AC, 6 },
    { 0x08B2, 3 },
    { 0x08B5, 1 },
    { 0x08B6, 2 },
    { 0x08B8, 2 },
    { 0x08BA, 7 },
    { 0x08C1, 11 },
    { 0x08CC, 14 },
    { 0x08DA, 7 },
    { 0x08E1, 14 },
    { 0x08EF, 5 },
    { 0x08F4, 3 },
    { 0x08F7, 5 },
    { 0x08FC, 5 },
    { 0x0901, 3 },
    { 0x0904, 5 },
    { 0x0909, 6 },
    { 0x090F, 6 },
    { 0x0915, 14 },
    { 0x0923, 7 },
    { 0x092A, 11 },
    { 0x0935, 3 },
    { 0x0938, 3 },
    { 0x093B, 3 },
    { 0x093E, 3 },
    { 0x0941, 3 },
    { 0x0944, 3 },
    { 0x0947, 6 },
    { 0x094D, 2 },
    { 0x094F, 2 },
    { 0x0951, 2 },
    { 0x0953, 2 },
    { 0x0955, 10 },
    { 0x095F, 11 },
    { 0x096A, 7 },
    { 0x0971, 14 },
    { 0x097F, 7 },
    { 0x0986, 7 },
    { 0x098D, 7 },
    { 0x0994, 7 },
    { 0x099B, 7 },
    { 0x09A2, 11 },
    { 0x09AD, 7 },
    { 0x09B4, 7 },
    { 0x09BB, 7 },
    { 0x09C2, 7 },
    { 0x09C9, 7 },
    { 0x09D0, 7 },
    { 0x09D7, 11 },
    { 0x09E2, 14 },
    { 0x09F0, 11 },
    { 0x09FB, 7 },
    { 0x0A02, 7 },
    { 0x0A09, 7 },
    { 0x0A10, 7 },
    { 0x0A17, 7 },
    { 0x0A1E, 7 },
    { 0x0A25, 7 },
    { 0x0A2C, 3 },
    { 0x0A2F, 15 },
    { 0x0A3E, 5 },
    { 0x0A43, 9 },
    { 0x0A4C, 3 },
    { 0x0A4F, 9 },
    { 0x0A58, 3 },
    { 0x0A5B, 9 },
    { 0x0A64, 13 },
    { 0x0A71, 9 },
    { 0x0A7A, 15 },
    { 0x0A89, 5 },
    { 0x0A8E, 3 },
    { 0x0A91, 15 },
    { 0x0AA0, 9 },
    { 0x0AA9, 11 },
    { 0x0AB4, 7 },
    { 0x0ABB, 7 },
    { 0x0AC2, 7 },
    { 0x0AC9, 7 },
    { 0x0AD0, 7 },
    { 0x0AD7, 7 },
    { 0x0ADE, 7 },
    { 0x0AE5, 7 },
    { 0x0AEC, 7 },
    { 0x0AF3, 11 },
    { 0x0AFE, 7 },
    { 0x0B05, 7 },
    { 0x0B0C, 7 },
    { 0x0B13, 15 },
    { 0x0B22, 9 },
    { 0x0B2B, 9 },
    { 0x0B34, 9 },
    { 0x0B3D, 15 },
    { 0x0B4C, 9 },
    { 0x0B55, 10 },
    { 0x0B5F, 7 },
    { 0x0B66, 7 },
    { 0x0B6D, 7 },
    { 0x0B74, 7 },
    { 0x0B7B, 7 },
    { 0x0B82, 7 },
    { 0x0B89, 9 },
    { 0x0B92, 9 },
    { 0x0B9B, 7 },
    { 0x0BA2, 7 },
    { 0x0BA9, 6 },
    { 0x0BAF, 11 },
    { 0x0BBA, 7 },
    { 0x0BC1, 11 },
    { 0x0BCC, 5 },
    { 0x0BD1, 3 },
    { 0x0BD4, 5 },
    { 0x0BD9, 6 },
    { 0x0BDF, 2 },
    { 0x0BE1, 4 },
    { 0x0BE5, 2 },
    { 0x0BE7, 2 },
    { 0x0BE9, 3 },
    { 0x0BEC, 3 },
    { 0x0BEF, 3 },
    { 0x0BF2, 6 },
    { 0x0BF8, 6 },
    { 0x0BFE, 2 },
    { 0x0C00, 4 },
    { 0x0C04, 2 },
    { 0x0C06, 4 },
    { 0x0C0A, 2 },
    { 0x0C0C, 2 },
    { 0x0C0E, 4 },
    { 0x0C12, 2 },
    { 0x0C14, 4 },
    { 0x0C18, 2 },
    { 0x0C1A, 4 },
    { 0x0C1E, 7 },
    { 0x0C25, 3 },
    { 0x0C28, 7 },
    { 0x0C2F, 3 },
    { 0x0C32, 7 },
    { 0x0C39, 7 },
    { 0x0C40, 3 },
    { 0x0C43, 3 },
    { 0x0C46, 3 },
    { 0x0C49, 3 },
    { 0x0C4C, 14 },
    { 0x0C5A, 7 },
    { 0x0C61, 14 },
    { 0x0C6F, 5 },
    { 0x0C74, 3 },
    { 0x0C77, 5 },
    { 0x0C7C, 14 },
    { 0x0C8A, 7 },
    { 0x0C91, 14 },
    { 0x0C9F, 5 },
    { 0x0CA4, 3 },
    { 0x0CA7, 5 },
    { 0x0CAC, 14 },
    { 0x0CBA, 7 },
    { 0x0CC1, 14 },
    { 0x0CCF, 5 },
    { 0x0CD4, 3 },
    { 0x0CD7, 5 },
    { 0x0CDC, 3 },
    { 0x0CDF, 7 },
    { 0x0CE6, 3 },
    { 0x0CE9, 8 },
    { 0x0CF1, 8 },
    { 0x0CF9, 4 },
    { 0x0CFD, 4 },
    { 0x0D01, 11 },
    { 0x0D0C, 7 },
    { 0x0D13, 11 },
    { 0x0D1E, 11 },
    { 0x0D29, 7 },
    { 0x0D30, 11 },
    { 0x0D3B, 11 },
    { 0x0D46, 7 },
    { 0x0D4D, 11 },
    { 0x0D58, 8 },
    { 0x0D60, 8 },
    { 0x0D68, 14 },
    { 0x0D76, 7 },
    { 0x0D7D, 14 },
    { 0x0D8B, 5 },
    { 0x0D90, 3 },
    { 0x0D93, 5 },
    { 0x0D98, 14 },
    { 0x0DA6, 7 },
    { 0x0DAD, 14 },
    { 0x0DBB, 5 },
    { 0x0DC0, 3 },
    { 0x0DC3, 5 },
    { 0x0DC8, 14 },
    { 0x0DD6, 7 },
    { 0x0DDD, 14 },
    { 0x0DEB, 5 },
    { 0x0DF0, 3 },
    { 0x0DF3, 5 },
    { 0x0DF8, 11 },
    { 0x0E03, 7 },
    { 0x0E0A, 11 },
    { 0x0E15, 11 },
    { 0x0E20, 7 },
    { 0x0E27, 11 },
    { 0x0E32, 11 },
    { 0x0E3D, 7 },
    { 0x0E44, 11 },
    { 0x0E4F, 8 },
    { 0x0E57, 8 },
    { 0x0E5F, 8 },
    { 0x0E67, 8 },
    { 0x0E6F, 4 },
    { 0x0E73, 4 },
    { 0x0E77, 7 },
    { 0x0E7E, 3 },
    { 0x0E81, 14 },
    { 0x0E8F, 7 },
    { 0x0E96, 14 },
    { 0x0EA4, 5 },
    { 0x0EA9, 3 },
    { 0x0EAC, 5 },
    { 0x0EB1, 14 },
    { 0x0EBF, 7 },
    { 0x0EC6, 14 },
    { 0x0ED4, 5 },
    { 0x0ED9, 3 },
    { 0x0EDC, 5 },
    { 0x0EE1, 14 },
    { 0x0EEF, 7 },
    { 0x0EF6, 14 },
    { 0x0F04, 5 },
    { 0x0F09, 3 },
    { 0x0F0C, 5 },
    { 0x0F11, 8 },
    { 0x0F19, 8 },
    { 0x0F21, 4 },
    { 0x0F25, 4 },
    { 0x0F29, 14 },
    { 0x0F37, 7 },
    { 0x0F3E, 14 },
    { 0x0F4C, 5 },
    { 0x0F51, 3 },
    { 0x0F54, 5 },
    { 0x0F59, 14 },
    { 0x0F67, 7 },
    { 0x0F6E, 14 },
    { 0x0F7C, 5 },
    { 0x0F81, 3 },
    { 0x0F84, 5 },
    { 0x0F89, 14 },
    { 0x0F97, 7 },
    { 0x0F9E, 14 },
    { 0x0FAC, 5 },
    { 0x0FB1, 3 },
    { 0x0FB4, 5 },
    { 0x0FB9, 8 },
    { 0x0FC1, 8 },
    { 0x0FC9, 4 },
    { 0x0FCD, 4 },
    { 0x0FD1, 6 },
    { 0x0FD7, 6 },
    { 0x0FDD, 6 },
    { 0x0FE3, 2 },
    { 0x0FE5, 2 },
    { 0x0FE7, 2 },
    { 0x0FE9, 4 },
    { 0x0FED, 4 },
    { 0x0FF1, 2 },
    { 0x0FF3, 2 },
    { 0x0FF5, 6 },
    { 0x0FFB, 6 },
    { 0x1001, 1 },
    { 0x1002, 2 },
    { 0x1004, 1 },
    { 0x1005, 1 },
    { 0x1006, 1 },
    { 0x1007, 1 },
    { 0x1008, 1 },
    { 0x1009, 2 },
    { 0x100B, 1 },
    { 0x100C, 1 },
    { 0x100D, 5 },
    { 0x1012, 5 },
    { 0x1017, 10 },
    { 0x1021, 7 },
    { 0x1028, 10 },
    { 0x1032, 3 },
    { 0x1035, 3 },
    { 0x1038, 3 },
    { 0x103B, 10 },
    { 0x1045, 7 },
    { 0x104C, 10 },
    { 0x1056, 3 },
    { 0x1059, 3 },
    { 0x105C, 3 },
    { 0x105F, 10 },
    { 0x1069, 10 },
    { 0x1073, 10 },
    { 0x107D, 3 },
    { 0x1080, 3 },
    { 0x1083, 3 },
    { 0x1086, 3 },
    { 0x1089, 3 },
    { 0x108C, 4 },
    { 0x1090, 4 },
    { 0x1094, 4 },
    { 0x1098, 4 },
    { 0x109C, 2 },
    { 0x109E, 4 },
    { 0x10A2, 2 },
    { 0x10A4, 4 },
    { 0x10A8, 2 },
    { 0x10AA, 2 },
    { 0x10AC, 4 },
    { 0x10B0, 2 },
    { 0x10B2, 4 },
    { 0x10B6, 2 },
    { 0x10B8, 4 },
    { 0x10BC, 2 },
    { 0x10BE, 1 },
    { 0x10BF, 1 },
    { 0x10C0, 1 },
    { 0x10C1, 1 },
    { 0x10C2, 1 },
    { 0x10C3, 1 },
    { 0x10C4, 1 },
    { 0x10C5, 1 },
    { 0x10C6, 1 },
    { 0x10C7, 3 },
    { 0x10CA, 1 },
    { 0x10CB, 4 },
    { 0x10CF, 4 },
    { 0x10D3, 11 },
    { 0x10DE, 7 },
    { 0x10E5, 11 },
    { 0x10F0, 5 },
    { 0x10F5, 3 },
    { 0x10F8, 5 },
    { 0x10FD, 1 },
    { 0x10FE, 1 },
    { 0x10FF, 1 },
    { 0x1100, 11 },
    { 0x110B, 7 },
    { 0x1112, 11 },
    { 0x111D, 5 },
    { 0x1122, 3 },
    { 0x1125, 5 },
    { 0x112A, 1 },
    { 0x112B, 1 },
    { 0x112C, 1 },
    { 0x112D, 24 },
    { 0x1145, 24 },
    { 0x115D, 16 },
    { 0x116D, 10 },
    { 0x1177, 8 },
    { 0x117F, 16 },
    { 0x118F, 16 },
    { 0x119F, 8 },
    { 0x11A7, 12 },
    { 0x11B3, 12 },
    { 0x11BF, 12 },
    { 0x11CB, 12 },
    { 0x11D7, 2 },
    { 0x11D9, 4 },
    { 0x11DD, 4 },
    { 0x11E1, 2 },
    { 0x11E3, 4 },
    { 0x11E7, 4 },
    { 0x11EB, 2 },
    { 0x11ED, 2 },
    { 0x11EF, 1 },
    { 0x11F0, 1 },
    { 0x11F1, 1 },
    { 0x11F2, 1 },
    { 0x11F3, 5 },
    { 0x11F8, 5 },
    { 0x11FD, 5 },
    { 0x1202, 5 },
    { 0x1207, 16 },
    { 0x1217, 8 },
    { 0x121F, 4 },
    { 0x1223, 10 },
    { 0x122D, 10 },
    { 0x1237, 8 },
    { 0x123F, 20 },
    { 0x1253, 20 },
    { 0x1267, 4 },
    { 0x126B, 4 },
    { 0x126F, 1 },
    { 0x1270, 1 },
    { 0x1271, 4 },
    { 0x1275, 1 },
    { 0x1276, 1 },
    { 0x1277, 1 },
    { 0x1278, 14 },
    { 0x1286, 7 },
    { 0x128D, 14 },
    { 0x129B, 5 },
    { 0x12A0, 3 },
    { 0x12A3, 5 },
    { 0x12A8, 4 },
    { 0x12AC, 1 },
    { 0x12AD, 1 },
    { 0x12AE, 10 },
    { 0x12B8, 10 },
    { 0x12C2, 6 },
    { 0x12C8, 6 },
    { 0x12CE, 1 },
    { 0x12CF, 1 },
    { 0x12D0, 10 },
    { 0x12DA, 10 },
    { 0x12E4, 6 },
    { 0x12EA, 10 },
    { 0x12F4, 10 },
    { 0x12FE, 10 },
    { 0x1308, 1 },
    { 0x1309, 1 },
    { 0x130A, 1 },
    { 0x130B, 1 },
    { 0x130C, 1 },
    { 0x130D, 1 },
    { 0x130E, 1 },
    { 0x130F, 1 },
    { 0x1310, 10 },
    { 0x131A, 10 },
    { 0x1324, 3 },
    { 0x1327, 10 },
    { 0x1331, 13 },
    { 0x133E, 10 },
    { 0x1348, 10 },
    { 0x1352, 3 },
    { 0x1355, 3 },
    { 0x1358, 10 },
    { 0x1362, 10 },
    { 0x136C, 10 },
    { 0x1376, 10 },
    { 0x1380, 10 },
    { 0x138A, 4 },
    { 0x138E, 9 },
    { 0x1397, 4 },
    { 0x139B, 9 },
    { 0x13A4, 9 },
    { 0x13AD, 9 },
    { 0x13B6, 10 },
    { 0x13C0, 10 },
    { 0x13CA, 4 },
    { 0x13CE, 6 },
    { 0x13D4, 9 },
    { 0x13DD, 9 },
    { 0x13E6, 6 },
    { 0x13EC, 4 },
    { 0x13F0, 4 },
    { 0x13F4, 13 },
    { 0x1401, 17 },
    { 0x1412, 3 },
    { 0x1415, 3 },
    { 0x1418, 14 },
    { 0x1426, 13 },
    { 0x1433, 10 },
    { 0x143D, 8 },
    { 0x1445, 6 },
    { 0x144B, 9 },
    { 0x1454, 10 },
    { 0x145E, 13 },
    { 0x146B, 10 },
    { 0x1475, 10 },
    { 0x147F, 2 },
    { 0x1481, 4 },
    { 0x1485, 10 },
    { 0x148F, 13 },
    { 0x149C, 10 },
    { 0x14A6, 10 },
    { 0x14B0, 2 },
    { 0x14B2, 2 },
    { 0x14B4, 3 },
    { 0x14B7, 6 },
    { 0x14BD, 6 },
    { 0x14C3, 9 },
    { 0x14CC, 6 },
    { 0x14D2, 6 },
    { 0x14D8, 6 },
    { 0x14DE, 2 },
    { 0x14E0, 2 },
    { 0x14E2, 6 },
    { 0x14E8, 6 },
    { 0x14EE, 6 },
    { 0x14F4, 6 },
    { 0x14FA, 2 },
    { 0x14FC, 2 },
    { 0x14FE, 2 },
    { 0x1500, 2 },
    { 0x1502, 2 },
    { 0x1504, 2 },
    { 0x1506, 6 },
    { 0x150C, 6 },
    { 0x1512, 4 },
    { 0x1516, 4 },
    { 0x151A, 4 },
    { 0x151E, 4 },
    { 0x1522, 10 },
    { 0x152C, 10 },
    { 0x1536, 4 },
    { 0x153A, 4 },
    { 0x153E, 10 },
    { 0x1548, 10 },
    { 0x1552, 4 },
    { 0x1556, 4 },
    { 0x155A, 4 },
    { 0x155E, 4 },
    { 0x1562, 4 },
    { 0x1566, 4 },
    { 0x156A, 2 },
    { 0x156C, 2 },
    { 0x156E, 6 },
    { 0x1574, 8 },
    { 0x157C, 3 },
    { 0x157F, 6 },
    { 0x1585, 6 },
    { 0x158B, 6 },
    { 0x1591, 6 },
    { 0x1597, 6 },
    { 0x159D, 6 },
    { 0x15A3, 8 },
    { 0x15AB, 8 },
    { 0x15B3, 20 },
    { 0x15C7, 20 },
    { 0x15DB, 10 },
    { 0x15E5, 6 },
    { 0x15EB, 10 },
    { 0x15F5, 6 },
    { 0x15FB, 6 },
    { 0x1601, 6 },
    { 0x1607, 6 },
    { 0x160D, 6 },
    { 0x1613, 6 },
    { 0x1619, 6 },
    { 0x161F, 6 },
    { 0x1625, 6 },
    { 0x162B, 6 },
    { 0x1631, 6 },
    { 0x1637, 4 },
    { 0x163B, 8 },
    { 0x1643, 4 },
    { 0x1647, 6 },
    { 0x164D, 6 },
    { 0x1653, 6 },
    { 0x1659, 5 },
    { 0x165E, 5 },
    { 0x1663, 2 },
    { 0x1665, 2 },
    { 0x1667, 2 },
    { 0x1669, 4 },
    { 0x166D, 2 },
    { 0x166F, 4 },
    { 0x1673, 2 },
    { 0x1675, 2 },
    { 0x1677, 2 },
    { 0x1679, 2 },
    { 0x167B, 2 },
    { 0x167D, 2 },
    { 0x167F, 4 },
    { 0x1683, 2 },
    { 0x1685, 2 },
    { 0x1687, 2 },
    { 0x1689, 2 },
    { 0x168B, 4 },
    { 0x168F, 2 },
    { 0x1691, 4 },
    { 0x1695, 4 },
    { 0x1699, 2 },
    { 0x169B, 4 },
    { 0x169F, 8 },
    { 0x16A7, 4 },
    { 0x16AB, 4 },
    { 0x16AF, 6 },
    { 0x16B5, 6 },
    { 0x16BB, 2 },
    { 0x16BD, 2 },
    { 0x16BF, 2 },
    { 0x16C1, 2 },
    { 0x16C3, 2 },
    { 0x16C5, 2 },
    { 0x16C7, 2 },
    { 0x16C9, 2 },
    { 0x16CB, 2 },
    { 0x16CD, 2 },
    { 0x16CF, 2 },
    { 0x16D1, 2 },
    { 0x16D3, 3 },
    { 0x16D6, 3 },
    { 0x16D9, 10 },
    { 0x16E3, 10 },
    { 0x16ED, 10 },
    { 0x16F7, 10 },
    { 0x1701, 4 },
    { 0x1705, 4 },
    { 0x1709, 10 },
    { 0x1713, 13 },
    { 0x1720, 6 },
    { 0x1726, 10 },
    { 0x1730, 10 },
    { 0x173A, 13 },
    { 0x1747, 6 },
    { 0x174D, 10 },
    { 0x1757, 10 },
    { 0x1761, 13 },
    { 0x176E, 6 },
    { 0x1774, 10 },
    { 0x177E, 10 },
    { 0x1788, 13 },
    { 0x1795, 6 },
    { 0x179B, 10 },
    { 0x17A5, 3 },
    { 0x17A8, 3 },
    { 0x17AB, 6 },
    { 0x17B1, 6 },
    { 0x17B7, 3 },
    { 0x17BA, 3 },
    { 0x17BD, 3 },
    { 0x17C0, 3 },
    { 0x17C3, 2 },
    { 0x17C5, 3 },
    { 0x17C8, 6 },
    { 0x17CE, 6 },
    { 0x17D4, 6 },
    { 0x17DA, 6 },
    { 0x17E0, 6 },
    { 0x17E6, 6 },
    { 0x17EC, 6 },
    { 0x17F2, 6 },
    { 0x17F8, 6 },
    { 0x17FE, 10 },
    { 0x1808, 10 },
    { 0x1812, 10 },
    { 0x181C, 10 },
    { 0x1826, 10 },
    { 0x1830, 10 },
    { 0x183A, 6 },
    { 0x1840, 6 },
    { 0x1846, 6 },
    { 0x184C, 6 },
    { 0x1852, 6 },
    { 0x1858, 6 },
    { 0x185E, 3 },
    { 0x1861, 6 },
    { 0x1867, 10 },
    { 0x1871, 10 },
    { 0x187B, 10 },
    { 0x1885, 10 },
    { 0x188F, 10 },
    { 0x1899, 10 },
    { 0x18A3, 10 },
    { 0x18AD, 3 },
    { 0x18B0, 10 },
    { 0x18BA, 3 },
    { 0x18BD, 10 },
    { 0x18C7, 10 },
    { 0x18D1, 13 },
    { 0x18DE, 6 },
    { 0x18E4, 10 },
    { 0x18EE, 6 },
    { 0x18F4, 10 },
    { 0x18FE, 6 },
    { 0x1904, 6 },
    { 0x190A, 6 },
    { 0x1910, 6 },
    { 0x1916, 4 },
    { 0x191A, 9 },
    { 0x1923, 9 },
    { 0x192C, 4 },
    { 0x1930, 2 },
    { 0x1932, 2 },
    { 0x1934, 2 },
    { 0x1936, 2 },
    { 0x1938, 2 },
    { 0x193A, 2 },
    { 0x193C, 2 },
    { 0x193E, 2 },
    { 0x1940, 6 },
    { 0x1946, 6 },
    { 0x194C, 6 },
    { 0x1952, 6 },
    { 0x1958, 6 },
    { 0x195E, 6 },
    { 0x1964, 6 },
    { 0x196A, 6 },
    { 0x1970, 6 },
    { 0x1976, 6 },
    { 0x197C, 6 },
    { 0x1982, 6 },
    { 0x1988, 10 },
    { 0x1992, 3 },
    { 0x1995, 3 },
    { 0x1998, 4 },
    { 0x199C, 4 },
    { 0x19A0, 3 },
    { 0x19A3, 3 },
    { 0x19A6, 4 },
    { 0x19AA, 4 },
    { 0x19AE, 4 },
    { 0x19B2, 4 },
    { 0x19B6, 4 },
    { 0x19BA, 4 },
    { 0x19BE, 6 },
    { 0x19C4, 6 },
    { 0x19CA, 6 },
    { 0x19D0, 6 },
    { 0x19D6, 6 },
    { 0x19DC, 6 },
    { 0x19E2, 4 },
    { 0x19E6, 4 },
    { 0x19EA, 6 },
    { 0x19F0, 6 },
    { 0x19F6, 6 },
    { 0x19FC, 6 },
    { 0x1A02, 6 },
    { 0x1A08, 6 },
    { 0x1A0E, 10 },
    { 0x1A18, 6 },
    { 0x1A1E, 13 },
    { 0x1A2B, 10 },
    { 0x1A35, 10 },
    { 0x1A3F, 4 },
    { 0x1A43, 4 },
    { 0x1A47, 4 },
    { 0x1A4B, 21 },
    { 0x1A60, 8 },
    { 0x1A68, 18 },
    { 0x1A7A, 13 },
    { 0x1A87, 10 },
    { 0x1A91, 6 },
    { 0x1A97, 18 },
    { 0x1AA9, 21 },
    { 0x1ABE, 12 },
    { 0x1ACA, 13 },
    { 0x1AD7, 6 },
    { 0x1ADD, 6 },
    { 0x1AE3, 18 },
    { 0x1AF5, 21 },
    { 0x1B0A, 8 },
    { 0x1B12, 18 },
    { 0x1B24, 13 },
    { 0x1B31, 10 },
    { 0x1B3B, 6 },
    { 0x1B41, 18 },
    { 0x1B53, 10 },
    { 0x1B5D, 13 },
    { 0x1B6A, 10 },
    { 0x1B74, 3 },
    { 0x1B77, 3 },
    { 0x1B7A, 10 },
    { 0x1B84, 3 },
    { 0x1B87, 10 },
    { 0x1B91, 10 },
    { 0x1B9B, 10 },
    { 0x1BA5, 10 },
    { 0x1BAF, 6 },
    { 0x1BB5, 6 },
    { 0x1BBB, 4 },
    { 0x1BBF, 6 },
    { 0x1BC5, 9 },
    { 0x1BCE, 6 },
    { 0x1BD4, 6 },
    { 0x1BDA, 6 },
    { 0x1BE0, 6 },
    { 0x1BE6, 6 },
    { 0x1BEC, 6 },
    { 0x1BF2, 10 },
    { 0x1BFC, 10 },
    { 0x1C06, 10 },
    { 0x1C10, 10 },
    { 0x1C1A, 10 },
    { 0x1C24, 10 },
    { 0x1C2E, 10 },
    { 0x1C38, 10 },
    { 0x1C42, 4 },
    { 0x1C46, 9 },
    { 0x1C4F, 9 },
    { 0x1C58, 7 },
    { 0x1C5F, 7 },
    { 0x1C66, 3 },
    { 0x1C69, 3 },
    { 0x1C6C, 6 },
    { 0x1C72, 6 },
    { 0x1C78, 2 },
    { 0x1C7A, 2 },
    { 0x1C7C, 3 },
    { 0x1C7F, 3 },
    { 0x1C82, 3 },
    { 0x1C85, 3 },
    { 0x1C88, 3 },
    { 0x1C8B, 6 },
    { 0x1C91, 4 },
    { 0x1C95, 2 },
    { 0x1C97, 2 },
    { 0x1C99, 7 },
    { 0x1CA0, 7 },
    { 0x1CA7, 7 },
    { 0x1CAE, 3 },
    { 0x1CB1, 3 },
    { 0x1CB4, 3 },
    { 0x1CB7, 3 },
    { 0x1CBA, 3 },
    { 0x1CBD, 7 },
    { 0x1CC4, 7 },
    { 0x1CCB, 7 },
    { 0x1CD2, 3 },
    { 0x1CD5, 3 },
    { 0x1CD8, 3 },
    { 0x1CDB, 4 },
    { 0x1CDF, 4 },
    { 0x1CE3, 2 },
    { 0x1CE5, 2 },
    { 0x1CE7, 6 },
    { 0x1CED, 6 },
    { 0x1CF3, 2 },
    { 0x1CF5, 2 },
    { 0x1CF7, 3 },
    { 0x1CFA, 3 },
    { 0x1CFD, 3 },
    { 0x1D00, 3 },
    { 0x1D03, 3 },
    { 0x1D06, 6 },
    { 0x1D0C, 4 },
    { 0x1D10, 2 },
    { 0x1D12, 2 },
    { 0x1D14, 7 },
    { 0x1D1B, 7 },
    { 0x1D22, 7 },
    { 0x1D29, 3 },
    { 0x1D2C, 3 },
    { 0x1D2F, 3 },
    { 0x1D32, 3 },
    { 0x1D35, 4 },
    { 0x1D39, 4 },
    { 0x1D3D, 1 },
    { 0x1D3E, 2 },
    { 0x1D40, 1 },
    { 0x1D41, 1 },
    { 0x1D42, 1 },
    { 0x1D43, 1 },
    { 0x1D44, 1 },
    { 0x1D45, 2 },
    { 0x1D47, 1 },
    { 0x1D48, 1 },
    { 0x1D49, 3 },
    { 0x1D4C, 3 },
    { 0x1D4F, 1 },
    { 0x1D50, 1 },
    { 0x1D51, 1 },
    { 0x1D52, 4 },
    { 0x1D56, 4 },
    { 0x1D5A, 4 },
    { 0x1D5E, 4 },
    { 0x1D62, 10 },
    { 0x1D6C, 10 },
    { 0x1D76, 2 },
    { 0x1D78, 2 },
    { 0x1D7A, 2 },
    { 0x1D7C, 4 },
    { 0x1D80, 4 },
    { 0x1D84, 11 },
    { 0x1D8F, 7 },
    { 0x1D96, 11 },
    { 0x1DA1, 5 },
    { 0x1DA6, 3 },
    { 0x1DA9, 5 },
    { 0x1DAE, 1 },
    { 0x1DAF, 14 },
    { 0x1DBD, 7 },
    { 0x1DC4, 14 },
    { 0x1DD2, 3 },
    { 0x1DD5, 3 },
    { 0x1DD8, 5 },
    { 0x1DDD, 3 },
    { 0x1DE0, 5 },
    { 0x1DE5, 4 },
    { 0x1DE9, 4 },
    { 0x1DED, 5 },
    { 0x1DF2, 3 },
    { 0x1DF5, 5 },
    { 0x1DFA, 10 },
    { 0x1E04, 10 },
    { 0x1E0E, 10 },
    { 0x1E18, 10 },
    { 0x1E22, 10 },
    { 0x1E2C, 10 },
    { 0x1E36, 1 },
    { 0x1E37, 1 },
    { 0x1E38, 1 },
    { 0x1E39, 1 },
    { 0x1E3A, 1 },
    { 0x1E3B, 1 },
    { 0x1E3C, 1 },
    { 0x1E3D, 1 },
    { 0x1E3E, 1 },
    { 0x1E3F, 1 },
    { 0x1E40, 1 },
    { 0x1E41, 1 },
    { 0x1E42, 1 },
    { 0x1E43, 1 },
    { 0x1E44, 4 },
    { 0x1E48, 1 },
    { 0x1E49, 6 },
    { 0x1E4F, 1 },
    { 0x1E50, 1 },
    { 0x1E51, 1 },
    { 0x1E52, 1 },
    { 0x1E53, 1 },
    { 0x1E54, 1 },
    { 0x1E55, 1 },
    { 0x1E56, 1 },
    { 0x1E57, 18 },
    { 0x1E69, 2 },
    { 0x1E6B, 2 },
    { 0x1E6D, 1 },
    { 0x1E6E, 1 },
    { 0x1E6F, 1 },
    { 0x1E70, 1 },
    { 0x1E71, 1 },
    { 0x1E72, 1 },
    { 0x1E73, 1 },
    { 0x1E74, 1 },
    { 0x1E75, 1 },
    { 0x1E76, 1 },
    { 0x1E77, 1 },
    { 0x1E78, 1 },
    { 0x1E79, 1 },
    { 0x1E7A, 1 },
    { 0x1E7B, 1 },
    { 0x1E7C, 1 },
    { 0x1E7D, 2 },
    { 0x1E7F, 1 },
    { 0x1E80, 1 },
};

const ZydisEncodableInstruction encoder_instructions[] =
{
    { 0x0000, 0x0000, 0x37, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_DEFAULT, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0001, 0x0019, 0xD5, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_DEFAULT, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0002, 0x000A, 0xFC, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0003, 0x000A, 0xFC, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_64, ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0004, 0x0019, 0xD4, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_DEFAULT, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0005, 0x000A, 0xFC, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0006, 0x000A, 0xFC, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_64, ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0007, 0x0000, 0x3F, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_DEFAULT, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0008, 0x0002, 0x10, 0xC0, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_DEFAULT, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0009, 0x000A, 0x10, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_DEFAULT, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x000A, 0x0002, 0x11, 0xC0, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_DEFAULT, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x000B, 0x000A, 0x11, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_DEFAULT, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x000C, 0x0002, 0x12, 0xC0, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_DEFAULT, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x000D, 0x0022, 0x12, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_DEFAULT, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x000E, 0x0002, 0x13, 0xC0, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_DEFAULT, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x000F, 0x0022, 0x13, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_DEFAULT, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0010, 0x0062, 0x14, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_DEFAULT, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0012, 0x0062, 0x80, 0xD0, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_DEFAULT, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0013, 0x006A, 0x80, 0x10, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_DEFAULT, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0016, 0x0062, 0x82, 0xD0, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_DEFAULT, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0017, 0x006A, 0x82, 0x10, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_DEFAULT, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0018, 0x0062, 0x83, 0xD0, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_DEFAULT, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0019, 0x006A, 0x83, 0x10, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_DEFAULT, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0011, 0x0062, 0x15, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_DEFAULT, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0014, 0x0062, 0x81, 0xD0, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_DEFAULT, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0015, 0x006A, 0x81, 0x10, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_DEFAULT, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x001A, 0x0002, 0xF6, 0xC0, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x001C, 0x0022, 0xF6, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x001B, 0x0002, 0xF6, 0xC0, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_64, ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x001D, 0x0022, 0xF6, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_64, ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x001E, 0x0002, 0x00, 0xC0, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_DEFAULT, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x001F, 0x000A, 0x00, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_DEFAULT, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0020, 0x0002, 0x01, 0xC0, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_DEFAULT, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0021, 0x000A, 0x01, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_DEFAULT, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0022, 0x0002, 0x02, 0xC0, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_DEFAULT, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0023, 0x0022, 0x02, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_DEFAULT, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0024, 0x0002, 0x03, 0xC0, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_DEFAULT, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0025, 0x0022, 0x03, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_DEFAULT, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0026, 0x0062, 0x04, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_DEFAULT, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0028, 0x0062, 0x80, 0xC0, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_DEFAULT, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0029, 0x006A, 0x80, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_DEFAULT, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x002C, 0x0062, 0x82, 0xC0, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_DEFAULT, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x002D, 0x006A, 0x82, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_DEFAULT, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x002E, 0x0062, 0x83, 0xC0, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_DEFAULT, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x002F, 0x006A, 0x83, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_DEFAULT, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0027, 0x0062, 0x05, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_DEFAULT, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x002A, 0x0062, 0x81, 0xC0, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_DEFAULT, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x002B, 0x006A, 0x81, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_DEFAULT, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0030, 0x0002, 0x58, 0xC0, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0031, 0x0022, 0x58, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0032, 0x0002, 0x58, 0xC0, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0033, 0x0022, 0x58, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0034, 0x0002, 0x58, 0xC0, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F2, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0035, 0x0022, 0x58, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F2, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0036, 0x0002, 0x58, 0xC0, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0037, 0x0022, 0x58, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0038, 0x0002, 0xD0, 0xC0, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0039, 0x0022, 0xD0, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x003A, 0x0002, 0xD0, 0xC0, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F2, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x003B, 0x0022, 0xD0, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F2, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x003C, 0x0002, 0xF6, 0xC0, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x003E, 0x0022, 0xF6, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x003D, 0x0002, 0xF6, 0xC0, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_64, ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x003F, 0x0022, 0xF6, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_64, ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0040, 0x0002, 0xDE, 0xC0, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0041, 0x0022, 0xDE, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0042, 0x0022, 0xDD, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0043, 0x0022, 0xDF, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0044, 0x0002, 0xDF, 0xC0, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0045, 0x0022, 0xDF, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0046, 0x0009, 0xD8, 0x08, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0047, 0x0009, 0xD8, 0x18, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0048, 0x0002, 0xDC, 0xC0, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0049, 0x0022, 0xDC, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x004A, 0x0022, 0xDC, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x004B, 0x0022, 0xDE, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x004C, 0x0002, 0xDD, 0xC0, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x004D, 0x0022, 0xDD, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x004E, 0x0009, 0xD8, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x004F, 0x0009, 0xD8, 0x10, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0050, 0x0002, 0xDB, 0xC0, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0051, 0x0022, 0xDB, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0052, 0x0183, 0xDF, 0xC0, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0053, 0x01A3, 0xDF, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0054, 0x0002, 0x20, 0xC0, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_DEFAULT, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0055, 0x000A, 0x20, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_DEFAULT, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0056, 0x0002, 0x21, 0xC0, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_DEFAULT, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0057, 0x000A, 0x21, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_DEFAULT, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0058, 0x0002, 0x22, 0xC0, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_DEFAULT, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0059, 0x0022, 0x22, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_DEFAULT, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x005A, 0x0002, 0x23, 0xC0, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_DEFAULT, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x005B, 0x0022, 0x23, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_DEFAULT, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x005C, 0x0062, 0x24, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_DEFAULT, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x005E, 0x0062, 0x80, 0xE0, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_DEFAULT, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x005F, 0x006A, 0x80, 0x20, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_DEFAULT, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0062, 0x0062, 0x82, 0xE0, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_DEFAULT, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0063, 0x006A, 0x82, 0x20, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_DEFAULT, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0064, 0x0062, 0x83, 0xE0, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_DEFAULT, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0065, 0x006A, 0x83, 0x20, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_DEFAULT, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x005D, 0x0062, 0x25, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_DEFAULT, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0060, 0x0062, 0x81, 0xE0, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_DEFAULT, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0061, 0x006A, 0x81, 0x20, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_DEFAULT, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0000, 0x0003, 0xF2, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_64, ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0001, 0x0003, 0xF2, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_64, ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0002, 0x0083, 0xF2, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_64, ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0003, 0x0083, 0xF2, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_64, ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0004, 0x0003, 0xF2, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0005, 0x0083, 0xF2, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0066, 0x0002, 0x55, 0xC0, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0067, 0x0022, 0x55, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0068, 0x0002, 0x55, 0xC0, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0069, 0x0022, 0x55, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x006A, 0x0002, 0x54, 0xC0, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x006B, 0x0022, 0x54, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x006C, 0x0002, 0x54, 0xC0, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x006D, 0x0022, 0x54, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x006E, 0x000A, 0xFC, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F2, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x006F, 0x000A, 0xFC, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_64, ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F2, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0070, 0x0002, 0x63, 0xC0, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_DEFAULT, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0071, 0x000A, 0x63, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_DEFAULT, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0072, 0x000A, 0xFC, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0073, 0x000A, 0xFC, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_64, ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0006, 0x0003, 0xF7, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0007, 0x0023, 0xF7, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0000, 0x0183, 0x10, 0xC0, ZYDIS_INSTRUCTION_ENCODING_XOP, ZYDIS_OPCODE_MAP_XOPA, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0001, 0x01A3, 0x10, 0x00, ZYDIS_INSTRUCTION_ENCODING_XOP, ZYDIS_OPCODE_MAP_XOPA, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0002, 0x0002, 0x01, 0xC8, ZYDIS_INSTRUCTION_ENCODING_XOP, ZYDIS_OPCODE_MAP_XOP9, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0003, 0x0022, 0x01, 0x08, ZYDIS_INSTRUCTION_ENCODING_XOP, ZYDIS_OPCODE_MAP_XOP9, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0004, 0x0002, 0x02, 0xF0, ZYDIS_INSTRUCTION_ENCODING_XOP, ZYDIS_OPCODE_MAP_XOP9, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0005, 0x0022, 0x02, 0x30, ZYDIS_INSTRUCTION_ENCODING_XOP, ZYDIS_OPCODE_MAP_XOP9, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0006, 0x0002, 0x01, 0xE8, ZYDIS_INSTRUCTION_ENCODING_XOP, ZYDIS_OPCODE_MAP_XOP9, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0007, 0x0022, 0x01, 0x28, ZYDIS_INSTRUCTION_ENCODING_XOP, ZYDIS_OPCODE_MAP_XOP9, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0008, 0x0002, 0x02, 0xC8, ZYDIS_INSTRUCTION_ENCODING_XOP, ZYDIS_OPCODE_MAP_XOP9, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0009, 0x0022, 0x02, 0x08, ZYDIS_INSTRUCTION_ENCODING_XOP, ZYDIS_OPCODE_MAP_XOP9, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x000A, 0x0002, 0x01, 0xD8, ZYDIS_INSTRUCTION_ENCODING_XOP, ZYDIS_OPCODE_MAP_XOP9, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x000B, 0x0022, 0x01, 0x18, ZYDIS_INSTRUCTION_ENCODING_XOP, ZYDIS_OPCODE_MAP_XOP9, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0074, 0x0183, 0x0D, 0xC0, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0075, 0x01A3, 0x0D, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0076, 0x0183, 0x0C, 0xC0, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0077, 0x01A3, 0x0C, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0078, 0x0002, 0x15, 0xC0, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0079, 0x0022, 0x15, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x007A, 0x0002, 0x14, 0xC0, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x007B, 0x0022, 0x14, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x000C, 0x0002, 0x01, 0xD0, ZYDIS_INSTRUCTION_ENCODING_XOP, ZYDIS_OPCODE_MAP_XOP9, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x000D, 0x0022, 0x01, 0x10, ZYDIS_INSTRUCTION_ENCODING_XOP, ZYDIS_OPCODE_MAP_XOP9, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0008, 0x0002, 0xF3, 0xD8, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0009, 0x0022, 0xF3, 0x18, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x000E, 0x0002, 0x01, 0xF0, ZYDIS_INSTRUCTION_ENCODING_XOP, ZYDIS_OPCODE_MAP_XOP9, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x000F, 0x0022, 0x01, 0x30, ZYDIS_INSTRUCTION_ENCODING_XOP, ZYDIS_OPCODE_MAP_XOP9, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x000A, 0x0002, 0xF3, 0xD0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x000B, 0x0022, 0xF3, 0x10, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x000C, 0x0002, 0xF3, 0xC8, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x000D, 0x0022, 0xF3, 0x08, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x007C, 0x0002, 0x1A, 0xC0, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_64, ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x007D, 0x0022, 0x1A, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_64, ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x007E, 0x0002, 0x1A, 0xC0, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x007F, 0x0022, 0x1A, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32, ZYDIS_WIDTH_32, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0080, 0x0002, 0x1B, 0xC0, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_64, ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F2, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0081, 0x0022, 0x1B, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_64, ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F2, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0082, 0x0002, 0x1B, 0xC0, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F2, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0083, 0x0022, 0x1B, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32, ZYDIS_WIDTH_32, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F2, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0084, 0x0002, 0x1A, 0xC0, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_64, ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F2, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0085, 0x0022, 0x1A, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_64, ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F2, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0086, 0x0002, 0x1A, 0xC0, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F2, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0087, 0x0022, 0x1A, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32, ZYDIS_WIDTH_32, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F2, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0088, 0x0022, 0x1A, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_64, ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0089, 0x0022, 0x1A, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32, ZYDIS_WIDTH_32, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x008A, 0x0022, 0x1B, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_64, ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x008B, 0x0022, 0x1B, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32, ZYDIS_WIDTH_32, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x008C, 0x0002, 0x1A, 0xC0, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x008D, 0x0022, 0x1A, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_64, ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x008E, 0x0022, 0x1A, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32, ZYDIS_WIDTH_32, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x008F, 0x0002, 0x1B, 0xC0, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0090, 0x000A, 0x1B, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_64, ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0091, 0x000A, 0x1B, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32, ZYDIS_WIDTH_32, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0092, 0x000A, 0x1B, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_64, ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0093, 0x000A, 0x1B, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32, ZYDIS_WIDTH_32, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0094, 0x0022, 0x62, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_DEFAULT, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32, ZYDIS_WIDTH_16, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0095, 0x0022, 0x62, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_DEFAULT, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32, ZYDIS_WIDTH_32, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0096, 0x0002, 0xBC, 0xC0, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0097, 0x0022, 0xBC, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x009A, 0x0002, 0xBD, 0xC0, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x009B, 0x0022, 0xBD, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x009E, 0x0001, 0xC8, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x009F, 0x0002, 0xA3, 0xC0, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x00A0, 0x000A, 0xA3, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x00A1, 0x0062, 0xBA, 0xE0, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x00A2, 0x006A, 0xBA, 0x20, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x00A5, 0x0002, 0xBB, 0xC0, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x00A6, 0x000A, 0xBB, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x00A3, 0x0062, 0xBA, 0xF8, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x00A4, 0x006A, 0xBA, 0x38, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x00A7, 0x0002, 0xB3, 0xC0, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x00A8, 0x000A, 0xB3, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x00A9, 0x0062, 0xBA, 0xF0, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x00AA, 0x006A, 0xBA, 0x30, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x00AB, 0x0002, 0xAB, 0xC0, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x00AC, 0x000A, 0xAB, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x00AD, 0x0062, 0xBA, 0xE8, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x00AE, 0x006A, 0xBA, 0x28, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x000E, 0x0003, 0xF5, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_64, ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x000F, 0x0003, 0xF5, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_64, ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0010, 0x0023, 0xF5, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_64, ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0011, 0x0023, 0xF5, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_64, ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0012, 0x0003, 0xF5, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0013, 0x0023, 0xF5, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x00AF, 0x0011, 0x9A, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_DEFAULT, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x00B3, 0x0001, 0xFF, 0xD0, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_DEFAULT, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x00B4, 0x0009, 0xFF, 0x10, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_DEFAULT, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x00B5, 0x0009, 0xFF, 0x18, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_DEFAULT, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x00B2, 0x0019, 0xE8, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_DEFAULT, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x00B0, 0x0019, 0xE8, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_DEFAULT, ZYDIS_WIDTH_64, ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x00B6, 0x0000, 0x98, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_DEFAULT, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x00B7, 0x0000, 0x99, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_DEFAULT, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_32, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x00B8, 0x0000, 0x98, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_DEFAULT, ZYDIS_WIDTH_64, ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x00B9, 0x0000, 0x01, 0xCA, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x00BA, 0x0000, 0xF8, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_DEFAULT, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x00BB, 0x0000, 0xFC, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_DEFAULT, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x00BC, 0x0009, 0x1C, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0014, 0x0009, 0xAE, 0x38, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_64, ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F2, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0000, 0x0009, 0xAE, 0x38, ZYDIS_INSTRUCTION_ENCODING_MVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F2, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0015, 0x0009, 0xAE, 0x38, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_64, ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0001, 0x0009, 0xAE, 0x38, ZYDIS_INSTRUCTION_ENCODING_MVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x00BD, 0x0009, 0xAE, 0x38, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x00BE, 0x0009, 0xAE, 0x38, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x00BF, 0x0000, 0x01, 0xDD, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x00C0, 0x0000, 0xFA, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_DEFAULT, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x00C1, 0x0009, 0xAE, 0x30, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x00C2, 0x0000, 0x06, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x00C3, 0x0000, 0x01, 0xEE, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_64, ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x00C4, 0x0009, 0xAE, 0x30, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x00C5, 0x0001, 0x01, 0xFC, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x00C6, 0x0000, 0xF5, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_DEFAULT, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x00C7, 0x0002, 0x42, 0xC0, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x00C8, 0x0022, 0x42, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x00C9, 0x0002, 0x46, 0xC0, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x00CA, 0x0022, 0x46, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x00CB, 0x0002, 0x4C, 0xC0, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x00CC, 0x0022, 0x4C, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x00CD, 0x0002, 0x4E, 0xC0, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x00CE, 0x0022, 0x4E, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x00CF, 0x0002, 0x43, 0xC0, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x00D0, 0x0022, 0x43, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x00D1, 0x0002, 0x47, 0xC0, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x00D2, 0x0022, 0x47, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x00D3, 0x0002, 0x4D, 0xC0, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x00D4, 0x0022, 0x4D, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x00D5, 0x0002, 0x4F, 0xC0, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x00D6, 0x0022, 0x4F, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x00D7, 0x0002, 0x41, 0xC0, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x00D8, 0x0022, 0x41, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x00D9, 0x0002, 0x4B, 0xC0, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x00DA, 0x0022, 0x4B, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x00DB, 0x0002, 0x49, 0xC0, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x00DC, 0x0022, 0x49, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x00DD, 0x0002, 0x45, 0xC0, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x00DE, 0x0022, 0x45, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x00DF, 0x0002, 0x40, 0xC0, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x00E0, 0x0022, 0x40, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x00E1, 0x0002, 0x4A, 0xC0, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x00E2, 0x0022, 0x4A, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x00E3, 0x0002, 0x48, 0xC0, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x00E4, 0x0022, 0x48, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x00E5, 0x0002, 0x44, 0xC0, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x00E6, 0x0022, 0x44, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x00E7, 0x0002, 0x38, 0xC0, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_DEFAULT, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x00E8, 0x000A, 0x38, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_DEFAULT, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x00E9, 0x0002, 0x39, 0xC0, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_DEFAULT, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x00EA, 0x000A, 0x39, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_DEFAULT, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x00EB, 0x0002, 0x3A, 0xC0, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_DEFAULT, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x00EC, 0x0022, 0x3A, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_DEFAULT, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x00ED, 0x0002, 0x3B, 0xC0, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_DEFAULT, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x00EE, 0x0022, 0x3B, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_DEFAULT, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x00EF, 0x0062, 0x3C, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_DEFAULT, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x00F1, 0x0062, 0x80, 0xF8, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_DEFAULT, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x00F2, 0x006A, 0x80, 0x38, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_DEFAULT, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x00F5, 0x0062, 0x82, 0xF8, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_DEFAULT, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x00F6, 0x006A, 0x82, 0x38, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_DEFAULT, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x00F7, 0x0062, 0x83, 0xF8, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_DEFAULT, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x00F8, 0x006A, 0x83, 0x38, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_DEFAULT, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x00F0, 0x0062, 0x3D, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_DEFAULT, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x00F3, 0x0062, 0x81, 0xF8, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_DEFAULT, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x00F4, 0x006A, 0x81, 0x38, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_DEFAULT, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x00F9, 0x0183, 0xC2, 0xC0, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x00FA, 0x01A3, 0xC2, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x00FB, 0x0183, 0xC2, 0xC0, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x00FC, 0x01A3, 0xC2, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x00FD, 0x0000, 0xA6, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_DEFAULT, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_ASZ, ZYAN_FALSE },
    { 0x0100, 0x0000, 0xA7, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_DEFAULT, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_32, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_ASZ, ZYAN_FALSE },
    { 0x0103, 0x0183, 0xC2, 0xC0, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F2, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0104, 0x01A3, 0xC2, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F2, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0105, 0x0000, 0xA7, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_DEFAULT, ZYDIS_WIDTH_64, ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_ASZ, ZYAN_FALSE },
    { 0x0108, 0x0183, 0xC2, 0xC0, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0109, 0x01A3, 0xC2, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x010A, 0x0000, 0xA7, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_DEFAULT, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_ASZ, ZYAN_FALSE },
    { 0x010D, 0x0002, 0xB0, 0xC0, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x010E, 0x000A, 0xB0, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x010F, 0x0002, 0xB1, 0xC0, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0110, 0x000A, 0xB1, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0111, 0x0009, 0xC7, 0x08, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_64, ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0112, 0x0009, 0xC7, 0x08, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_64, ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0113, 0x0009, 0xC7, 0x08, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0114, 0x0002, 0x2F, 0xC0, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0115, 0x0022, 0x2F, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0116, 0x0002, 0x2F, 0xC0, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0117, 0x0022, 0x2F, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0118, 0x0000, 0xA2, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0119, 0x0000, 0x99, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_DEFAULT, ZYDIS_WIDTH_64, ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x011A, 0x0002, 0xF0, 0xC0, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F2, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x011B, 0x0022, 0xF0, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F2, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x011C, 0x0002, 0xF1, 0xC0, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F2, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x011D, 0x0022, 0xF1, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F2, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x011E, 0x0002, 0xE6, 0xC0, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x011F, 0x0022, 0xE6, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0120, 0x0002, 0x5B, 0xC0, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0121, 0x0022, 0x5B, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0122, 0x0002, 0xE6, 0xC0, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F2, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0123, 0x0022, 0xE6, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F2, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0124, 0x0002, 0x2D, 0xC0, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0125, 0x0022, 0x2D, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0126, 0x0002, 0x5A, 0xC0, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0127, 0x0022, 0x5A, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0128, 0x0002, 0x2A, 0xC0, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0129, 0x0022, 0x2A, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x012A, 0x0002, 0x2A, 0xC0, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x012B, 0x0022, 0x2A, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x012C, 0x0002, 0x5B, 0xC0, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x012D, 0x0022, 0x5B, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x012E, 0x0002, 0x5A, 0xC0, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x012F, 0x0022, 0x5A, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0130, 0x0002, 0x2D, 0xC0, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0131, 0x0022, 0x2D, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0132, 0x0002, 0x2D, 0xC0, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F2, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0134, 0x0022, 0x2D, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F2, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0133, 0x0002, 0x2D, 0xC0, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_64, ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F2, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0135, 0x0022, 0x2D, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_64, ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F2, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0136, 0x0002, 0x5A, 0xC0, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F2, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0137, 0x0022, 0x5A, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F2, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0138, 0x0002, 0x2A, 0xC0, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F2, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x013A, 0x0022, 0x2A, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F2, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0139, 0x0002, 0x2A, 0xC0, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_64, ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F2, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x013B, 0x0022, 0x2A, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_64, ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F2, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x013C, 0x0002, 0x2A, 0xC0, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x013E, 0x0022, 0x2A, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x013D, 0x0002, 0x2A, 0xC0, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_64, ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x013F, 0x0022, 0x2A, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_64, ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0140, 0x0002, 0x5A, 0xC0, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0141, 0x0022, 0x5A, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0142, 0x0002, 0x2D, 0xC0, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0144, 0x0022, 0x2D, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0143, 0x0002, 0x2D, 0xC0, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_64, ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0145, 0x0022, 0x2D, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_64, ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0146, 0x0002, 0xE6, 0xC0, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0147, 0x0022, 0xE6, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0148, 0x0002, 0x2C, 0xC0, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0149, 0x0022, 0x2C, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x014A, 0x0002, 0x5B, 0xC0, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x014B, 0x0022, 0x5B, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x014C, 0x0002, 0x2C, 0xC0, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x014D, 0x0022, 0x2C, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x014E, 0x0002, 0x2C, 0xC0, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F2, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0150, 0x0022, 0x2C, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F2, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x014F, 0x0002, 0x2C, 0xC0, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_64, ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F2, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0151, 0x0022, 0x2C, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_64, ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F2, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0152, 0x0002, 0x2C, 0xC0, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0154, 0x0022, 0x2C, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0153, 0x0002, 0x2C, 0xC0, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_64, ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0155, 0x0022, 0x2C, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_64, ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0156, 0x0000, 0x99, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_DEFAULT, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0157, 0x0000, 0x98, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_DEFAULT, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_32, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0158, 0x0000, 0x27, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_DEFAULT, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0159, 0x0000, 0x2F, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_DEFAULT, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x015A, 0x0001, 0x48, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_DEFAULT, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x015B, 0x0001, 0xFE, 0xC8, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_DEFAULT, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x015C, 0x0009, 0xFE, 0x08, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_DEFAULT, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x015D, 0x0001, 0xFF, 0xC8, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_DEFAULT, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x015E, 0x0009, 0xFF, 0x08, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_DEFAULT, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0016, 0x0001, 0xAE, 0xF0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_64, ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0017, 0x0001, 0xAE, 0xF0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_64, ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x015F, 0x0001, 0xF6, 0xF0, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_DEFAULT, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0160, 0x0009, 0xF6, 0x30, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_DEFAULT, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0161, 0x0001, 0xF7, 0xF0, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_DEFAULT, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0162, 0x0009, 0xF7, 0x30, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_DEFAULT, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0163, 0x0002, 0x5E, 0xC0, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0164, 0x0022, 0x5E, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0165, 0x0002, 0x5E, 0xC0, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0166, 0x0022, 0x5E, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0167, 0x0002, 0x5E, 0xC0, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F2, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0168, 0x0022, 0x5E, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F2, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0169, 0x0002, 0x5E, 0xC0, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x016A, 0x0022, 0x5E, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x016B, 0x0183, 0x41, 0xC0, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x016C, 0x01A3, 0x41, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x016D, 0x0183, 0x40, 0xC0, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x016E, 0x01A3, 0x40, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x016F, 0x0000, 0x77, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0170, 0x0000, 0x01, 0xCF, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_64, ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0171, 0x0000, 0x01, 0xCF, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0172, 0x0000, 0x01, 0xD7, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_64, ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0173, 0x0000, 0x01, 0xD7, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0174, 0x0000, 0x01, 0xC0, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_64, ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0175, 0x0000, 0x01, 0xC0, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0176, 0x0002, 0xFA, 0xC0, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0177, 0x0002, 0xFB, 0xC0, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0178, 0x0000, 0x1E, 0xFB, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0179, 0x0000, 0x1E, 0xFA, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x017A, 0x0022, 0xF8, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F2, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x017B, 0x0022, 0xF8, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x017C, 0x007A, 0xC8, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_DEFAULT, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_OSZ, ZYAN_FALSE },
    { 0x017D, 0x0183, 0x17, 0xC0, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x017E, 0x018B, 0x17, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0180, 0x0002, 0x79, 0xC0, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x017F, 0x01E3, 0x78, 0xC0, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0181, 0x0000, 0xD9, 0xF0, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_DEFAULT, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0182, 0x0000, 0xD9, 0xE1, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_DEFAULT, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0183, 0x0002, 0xD8, 0xC0, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_DEFAULT, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0184, 0x0009, 0xD8, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_DEFAULT, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0185, 0x0002, 0xDC, 0xC0, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_DEFAULT, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0186, 0x0009, 0xDC, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_DEFAULT, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0187, 0x0002, 0xDE, 0xC0, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_DEFAULT, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0188, 0x0009, 0xDF, 0x20, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_DEFAULT, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0189, 0x0009, 0xDF, 0x30, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_DEFAULT, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x018A, 0x0000, 0xD9, 0xE0, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_DEFAULT, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x018B, 0x0002, 0xDA, 0xC0, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_DEFAULT, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x018C, 0x0002, 0xDA, 0xD0, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_DEFAULT, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x018D, 0x0002, 0xDA, 0xC8, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_DEFAULT, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x018E, 0x0002, 0xDB, 0xC0, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_DEFAULT, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x018F, 0x0002, 0xDB, 0xD0, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_DEFAULT, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0190, 0x0002, 0xDB, 0xC8, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_DEFAULT, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0191, 0x0002, 0xDB, 0xD8, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_DEFAULT, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0192, 0x0002, 0xDA, 0xD8, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_DEFAULT, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0193, 0x0001, 0xD8, 0xD0, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_DEFAULT, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0194, 0x0009, 0xD8, 0x10, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_DEFAULT, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0196, 0x0009, 0xDC, 0x10, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_DEFAULT, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0197, 0x0002, 0xDB, 0xF0, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_DEFAULT, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0198, 0x0002, 0xDF, 0xF0, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_DEFAULT, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0199, 0x0001, 0xD8, 0xD8, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_DEFAULT, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x019A, 0x0009, 0xD8, 0x18, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_DEFAULT, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x019C, 0x0009, 0xDC, 0x18, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_DEFAULT, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x019D, 0x0001, 0xDE, 0xD0, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_DEFAULT, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x019E, 0x0000, 0xDE, 0xD9, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_DEFAULT, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x019F, 0x0000, 0xD9, 0xFF, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_DEFAULT, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x01A0, 0x0000, 0xD9, 0xF6, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_DEFAULT, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x01A1, 0x0000, 0xDB, 0xE1, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_DEFAULT, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x01A2, 0x0002, 0xD8, 0xF0, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_DEFAULT, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x01A3, 0x0009, 0xD8, 0x30, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_DEFAULT, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x01A4, 0x0002, 0xDC, 0xF8, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_DEFAULT, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x01A5, 0x0009, 0xDC, 0x30, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_DEFAULT, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x01A6, 0x0002, 0xDE, 0xF8, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_DEFAULT, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x01A7, 0x0002, 0xD8, 0xF8, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_DEFAULT, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x01A8, 0x0009, 0xD8, 0x38, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_DEFAULT, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x01A9, 0x0002, 0xDC, 0xF0, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_DEFAULT, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x01AA, 0x0009, 0xDC, 0x38, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_DEFAULT, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x01AB, 0x0002, 0xDE, 0xF0, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_DEFAULT, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x01AC, 0x0000, 0x0E, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x01AD, 0x0000, 0xDB, 0xE0, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_DEFAULT, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x01AE, 0x0001, 0xDD, 0xC0, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_DEFAULT, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x01AF, 0x0001, 0xDF, 0xC0, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_DEFAULT, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x01B0, 0x0009, 0xDA, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_DEFAULT, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x01B1, 0x0009, 0xDE, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_DEFAULT, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x01B2, 0x0009, 0xDA, 0x10, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_DEFAULT, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x01B3, 0x0009, 0xDE, 0x10, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_DEFAULT, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x01B4, 0x0009, 0xDA, 0x18, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_DEFAULT, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x01B5, 0x0009, 0xDE, 0x18, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_DEFAULT, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x01B6, 0x0009, 0xDA, 0x30, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_DEFAULT, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x01B7, 0x0009, 0xDE, 0x30, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_DEFAULT, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x01B8, 0x0009, 0xDA, 0x38, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_DEFAULT, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x01B9, 0x0009, 0xDE, 0x38, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_DEFAULT, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x01BA, 0x0009, 0xDB, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_DEFAULT, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x01BB, 0x0009, 0xDF, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_DEFAULT, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x01BC, 0x0009, 0xDF, 0x28, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_DEFAULT, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x01BD, 0x0009, 0xDA, 0x08, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_DEFAULT, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x01BE, 0x0009, 0xDE, 0x08, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_DEFAULT, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x01BF, 0x0000, 0xD9, 0xF7, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_DEFAULT, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x01C0, 0x0009, 0xDB, 0x10, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_DEFAULT, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x01C1, 0x0009, 0xDF, 0x10, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_DEFAULT, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x01C2, 0x0009, 0xDB, 0x18, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_DEFAULT, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x01C3, 0x0009, 0xDF, 0x18, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_DEFAULT, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x01C4, 0x0009, 0xDF, 0x38, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_DEFAULT, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x01C5, 0x0009, 0xDB, 0x08, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_DEFAULT, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x01C6, 0x0009, 0xDD, 0x08, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_DEFAULT, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x01C7, 0x0009, 0xDF, 0x08, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_DEFAULT, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x01C8, 0x0009, 0xDA, 0x20, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_DEFAULT, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x01C9, 0x0009, 0xDE, 0x20, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_DEFAULT, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x01CA, 0x0009, 0xDA, 0x28, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_DEFAULT, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x01CB, 0x0009, 0xDE, 0x28, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_DEFAULT, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x01CC, 0x0001, 0xD9, 0xC0, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_DEFAULT, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x01CD, 0x0009, 0xD9, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_DEFAULT, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x01CE, 0x0009, 0xDB, 0x28, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_DEFAULT, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x01CF, 0x0009, 0xDD, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_DEFAULT, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x01D0, 0x0000, 0xD9, 0xE8, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_DEFAULT, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x01D1, 0x0009, 0xD9, 0x28, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_DEFAULT, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x01D2, 0x0009, 0xD9, 0x20, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_DEFAULT, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x01D3, 0x0009, 0xD9, 0x20, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_DEFAULT, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x01D4, 0x0000, 0xD9, 0xEA, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_DEFAULT, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x01D5, 0x0000, 0xD9, 0xE9, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_DEFAULT, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x01D6, 0x0000, 0xD9, 0xEC, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_DEFAULT, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x01D7, 0x0000, 0xD9, 0xED, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_DEFAULT, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x01D8, 0x0000, 0xD9, 0xEB, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_DEFAULT, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x01D9, 0x0000, 0xD9, 0xEE, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_DEFAULT, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x01DA, 0x0002, 0xD8, 0xC8, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_DEFAULT, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x01DB, 0x0009, 0xD8, 0x08, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_DEFAULT, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x01DC, 0x0002, 0xDC, 0xC8, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_DEFAULT, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x01DD, 0x0009, 0xDC, 0x08, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_DEFAULT, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x01DE, 0x0002, 0xDE, 0xC8, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_DEFAULT, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x01DF, 0x0000, 0xDB, 0xE2, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_DEFAULT, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x01E0, 0x0000, 0xDB, 0xE3, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_DEFAULT, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x01E1, 0x0000, 0xD9, 0xD0, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_DEFAULT, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x01E2, 0x0009, 0xDD, 0x30, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_DEFAULT, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x01E3, 0x0009, 0xDD, 0x30, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_DEFAULT, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x01E4, 0x0009, 0xD9, 0x38, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_DEFAULT, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x01E5, 0x0009, 0xD9, 0x30, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_DEFAULT, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x01E6, 0x0009, 0xD9, 0x30, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_DEFAULT, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x01E7, 0x0009, 0xDD, 0x38, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_DEFAULT, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x01E8, 0x0001, 0xDF, 0xE0, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_DEFAULT, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x01E9, 0x0000, 0xD9, 0xF3, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_DEFAULT, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x01EA, 0x0000, 0xD9, 0xF8, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_DEFAULT, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x01EB, 0x0000, 0xD9, 0xF5, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_DEFAULT, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x01EC, 0x0000, 0xD9, 0xF2, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_DEFAULT, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x01ED, 0x0000, 0xD9, 0xFC, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_DEFAULT, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x01EE, 0x0009, 0xDD, 0x20, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_DEFAULT, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x01EF, 0x0009, 0xDD, 0x20, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_DEFAULT, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x01F0, 0x0000, 0xD9, 0xFD, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_DEFAULT, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x01F1, 0x0000, 0xDB, 0xE4, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_DEFAULT, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x01F2, 0x0000, 0xD9, 0xFE, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_DEFAULT, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x01F3, 0x0000, 0xD9, 0xFB, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_DEFAULT, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x01F4, 0x0000, 0xD9, 0xFA, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_DEFAULT, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x01F5, 0x0009, 0xD9, 0x10, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_DEFAULT, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x01F6, 0x0001, 0xDD, 0xD0, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_DEFAULT, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x01F7, 0x0009, 0xDD, 0x10, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_DEFAULT, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x01F8, 0x0009, 0xD9, 0x18, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_DEFAULT, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x01F9, 0x0009, 0xDB, 0x38, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_DEFAULT, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x01FA, 0x0001, 0xDD, 0xD8, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_DEFAULT, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x01FB, 0x0009, 0xDD, 0x18, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_DEFAULT, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x01FC, 0x0001, 0xDF, 0xD0, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_DEFAULT, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x01FE, 0x0001, 0xD9, 0xD8, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_DEFAULT, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x01FF, 0x0002, 0xD8, 0xE0, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_DEFAULT, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0200, 0x0009, 0xD8, 0x20, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_DEFAULT, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0201, 0x0002, 0xDC, 0xE8, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_DEFAULT, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0202, 0x0009, 0xDC, 0x20, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_DEFAULT, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0203, 0x0002, 0xDE, 0xE8, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_DEFAULT, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0204, 0x0002, 0xD8, 0xE8, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_DEFAULT, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0205, 0x0009, 0xD8, 0x28, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_DEFAULT, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0206, 0x0002, 0xDC, 0xE0, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_DEFAULT, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0207, 0x0009, 0xDC, 0x28, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_DEFAULT, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0208, 0x0002, 0xDE, 0xE0, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_DEFAULT, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0209, 0x0000, 0xD9, 0xE4, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_DEFAULT, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x020A, 0x0001, 0xDD, 0xE0, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_DEFAULT, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x020B, 0x0002, 0xDB, 0xE8, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_DEFAULT, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x020C, 0x0002, 0xDF, 0xE8, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_DEFAULT, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x020D, 0x0002, 0xDD, 0xE8, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_DEFAULT, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x020E, 0x0000, 0xDA, 0xE9, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_DEFAULT, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x020F, 0x0000, 0x9B, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_DEFAULT, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0210, 0x0000, 0xD9, 0xE5, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_DEFAULT, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0211, 0x0001, 0xD9, 0xC8, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_DEFAULT, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0214, 0x0009, 0xAE, 0x08, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0215, 0x0009, 0xAE, 0x08, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_64, ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0216, 0x0009, 0xAE, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0217, 0x0009, 0xAE, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_64, ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0218, 0x0000, 0xD9, 0xF4, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_DEFAULT, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0219, 0x0000, 0xD9, 0xF1, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_DEFAULT, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x021A, 0x0000, 0xD9, 0xF9, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_DEFAULT, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x021B, 0x0000, 0x37, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x021C, 0x0183, 0xCF, 0xC0, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x021D, 0x01A3, 0xCF, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x021E, 0x0183, 0xCE, 0xC0, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x021F, 0x01A3, 0xCE, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0220, 0x0002, 0xCF, 0xC0, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0221, 0x0022, 0xCF, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0222, 0x0002, 0x7C, 0xC0, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0223, 0x0022, 0x7C, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0224, 0x0002, 0x7C, 0xC0, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F2, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0225, 0x0022, 0x7C, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F2, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0226, 0x0000, 0xF4, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_DEFAULT, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0227, 0x0019, 0xF0, 0xC0, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0228, 0x0002, 0x7D, 0xC0, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0229, 0x0022, 0x7D, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x022A, 0x0002, 0x7D, 0xC0, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F2, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x022B, 0x0022, 0x7D, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F2, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x022C, 0x0001, 0xF6, 0xF8, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_DEFAULT, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x022D, 0x0009, 0xF6, 0x38, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_DEFAULT, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x022E, 0x0001, 0xF7, 0xF8, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_DEFAULT, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x022F, 0x0009, 0xF7, 0x38, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_DEFAULT, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0234, 0x0001, 0xF6, 0xE8, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_DEFAULT, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0235, 0x0009, 0xF6, 0x28, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_DEFAULT, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0236, 0x0001, 0xF7, 0xE8, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_DEFAULT, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0237, 0x0009, 0xF7, 0x28, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_DEFAULT, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0232, 0x0183, 0x6B, 0xC0, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_DEFAULT, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0233, 0x01A3, 0x6B, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_DEFAULT, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0238, 0x0002, 0xAF, 0xC0, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0239, 0x0022, 0xAF, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0230, 0x0183, 0x69, 0xC0, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_DEFAULT, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0231, 0x01A3, 0x69, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_DEFAULT, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x023D, 0x0002, 0xEC, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_DEFAULT, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x023E, 0x0002, 0xED, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_DEFAULT, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x023F, 0x0002, 0xED, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_DEFAULT, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x023A, 0x0062, 0xE4, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_DEFAULT, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x023B, 0x0062, 0xE5, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_DEFAULT, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x023C, 0x0062, 0xE5, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_DEFAULT, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0240, 0x0001, 0x40, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_DEFAULT, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0241, 0x0001, 0xFE, 0xC0, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_DEFAULT, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0242, 0x0009, 0xFE, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_DEFAULT, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0243, 0x0001, 0xFF, 0xC0, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_DEFAULT, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0244, 0x0009, 0xFF, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_DEFAULT, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0245, 0x0001, 0xAE, 0xE8, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0246, 0x0001, 0xAE, 0xE8, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_64, ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0247, 0x0000, 0x6C, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_DEFAULT, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_ASZ, ZYAN_FALSE },
    { 0x024A, 0x0000, 0x6D, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_DEFAULT, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_ASZ, ZYAN_FALSE },
    { 0x0250, 0x0183, 0x21, 0xC0, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0251, 0x01A3, 0x21, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0253, 0x0002, 0x79, 0xC0, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F2, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0252, 0x0784, 0x78, 0xC0, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F2, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0254, 0x0000, 0x6D, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_DEFAULT, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_ASZ, ZYAN_FALSE },
    { 0x0257, 0x0019, 0xCD, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_DEFAULT, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0258, 0x0000, 0xF1, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_DEFAULT, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0259, 0x0000, 0xCC, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_DEFAULT, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x025A, 0x0000, 0xCE, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_DEFAULT, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x025B, 0x0000, 0x08, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x025C, 0x0022, 0x80, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_64, ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x025D, 0x0022, 0x80, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x025E, 0x0009, 0x01, 0x38, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x025F, 0x0002, 0x01, 0xDF, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0260, 0x0003, 0x01, 0xFE, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0261, 0x0022, 0x82, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_64, ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0262, 0x0022, 0x82, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0263, 0x0022, 0x81, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_64, ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0264, 0x0022, 0x81, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0265, 0x0000, 0xCF, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_DEFAULT, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0266, 0x0000, 0xCF, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_DEFAULT, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_32, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0267, 0x0000, 0xCF, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_DEFAULT, ZYDIS_WIDTH_64, ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0268, 0x0019, 0x72, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_DEFAULT, ZYDIS_WIDTH_64, ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0269, 0x0019, 0x72, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_DEFAULT, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x026C, 0x0019, 0x82, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x026A, 0x0019, 0x82, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_64, ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x026D, 0x0019, 0x76, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_DEFAULT, ZYDIS_WIDTH_64, ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x026E, 0x0019, 0x76, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_DEFAULT, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0271, 0x0019, 0x86, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x026F, 0x0019, 0x86, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_64, ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0272, 0x0019, 0xE3, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_DEFAULT, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32, ZYDIS_WIDTH_16, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0273, 0x0019, 0xE3, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_DEFAULT, ZYDIS_WIDTH_64, ZYDIS_WIDTH_32, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0274, 0x0019, 0xE3, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_DEFAULT, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32, ZYDIS_WIDTH_32, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0018, 0x0062, 0x75, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_DEFAULT, ZYDIS_WIDTH_64, ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0019, 0x0062, 0x85, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_64, ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x001A, 0x0062, 0x74, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_DEFAULT, ZYDIS_WIDTH_64, ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x001B, 0x0062, 0x84, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_64, ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0275, 0x0019, 0x7C, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_DEFAULT, ZYDIS_WIDTH_64, ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0276, 0x0019, 0x7C, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_DEFAULT, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0279, 0x0019, 0x8C, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0277, 0x0019, 0x8C, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_64, ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x027A, 0x0019, 0x7E, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_DEFAULT, ZYDIS_WIDTH_64, ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x027B, 0x0019, 0x7E, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_DEFAULT, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x027E, 0x0019, 0x8E, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x027C, 0x0019, 0x8E, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_64, ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0282, 0x0011, 0xEA, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_DEFAULT, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0283, 0x0019, 0xEB, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_DEFAULT, ZYDIS_WIDTH_64, ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0284, 0x0019, 0xEB, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_DEFAULT, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0285, 0x0001, 0xFF, 0xE0, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_DEFAULT, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0286, 0x0009, 0xFF, 0x20, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_DEFAULT, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0287, 0x0009, 0xFF, 0x28, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_DEFAULT, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0281, 0x0019, 0xE9, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_DEFAULT, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x027F, 0x0019, 0xE9, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_DEFAULT, ZYDIS_WIDTH_64, ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0288, 0x0019, 0x73, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_DEFAULT, ZYDIS_WIDTH_64, ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0289, 0x0019, 0x73, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_DEFAULT, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x028C, 0x0019, 0x83, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x028A, 0x0019, 0x83, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_64, ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x028D, 0x0019, 0x77, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_DEFAULT, ZYDIS_WIDTH_64, ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x028E, 0x0019, 0x77, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_DEFAULT, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0291, 0x0019, 0x87, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x028F, 0x0019, 0x87, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_64, ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0292, 0x0019, 0x7D, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_DEFAULT, ZYDIS_WIDTH_64, ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0293, 0x0019, 0x7D, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_DEFAULT, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0296, 0x0019, 0x8D, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0294, 0x0019, 0x8D, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_64, ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0297, 0x0019, 0x7F, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_DEFAULT, ZYDIS_WIDTH_64, ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0298, 0x0019, 0x7F, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_DEFAULT, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x029B, 0x0019, 0x8F, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0299, 0x0019, 0x8F, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_64, ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x029C, 0x0019, 0x71, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_DEFAULT, ZYDIS_WIDTH_64, ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x029D, 0x0019, 0x71, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_DEFAULT, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x02A0, 0x0019, 0x81, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x029E, 0x0019, 0x81, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_64, ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x02A1, 0x0019, 0x7B, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_DEFAULT, ZYDIS_WIDTH_64, ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x02A2, 0x0019, 0x7B, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_DEFAULT, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x02A5, 0x0019, 0x8B, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x02A3, 0x0019, 0x8B, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_64, ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x02A6, 0x0019, 0x79, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_DEFAULT, ZYDIS_WIDTH_64, ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x02A7, 0x0019, 0x79, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_DEFAULT, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x02AA, 0x0019, 0x89, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x02A8, 0x0019, 0x89, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_64, ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x02AB, 0x0019, 0x75, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_DEFAULT, ZYDIS_WIDTH_64, ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x02AC, 0x0019, 0x75, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_DEFAULT, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x02AF, 0x0019, 0x85, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x02AD, 0x0019, 0x85, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_64, ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x02B0, 0x0019, 0x70, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_DEFAULT, ZYDIS_WIDTH_64, ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x02B1, 0x0019, 0x70, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_DEFAULT, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x02B4, 0x0019, 0x80, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x02B2, 0x0019, 0x80, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_64, ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x02B5, 0x0019, 0x7A, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_DEFAULT, ZYDIS_WIDTH_64, ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x02B6, 0x0019, 0x7A, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_DEFAULT, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x02B9, 0x0019, 0x8A, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x02B7, 0x0019, 0x8A, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_64, ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x02BA, 0x0019, 0xE3, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_DEFAULT, ZYDIS_WIDTH_64, ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x02BB, 0x0019, 0x78, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_DEFAULT, ZYDIS_WIDTH_64, ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x02BC, 0x0019, 0x78, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_DEFAULT, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x02BF, 0x0019, 0x88, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x02BD, 0x0019, 0x88, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_64, ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x02C0, 0x0019, 0x74, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_DEFAULT, ZYDIS_WIDTH_64, ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x02C1, 0x0019, 0x74, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_DEFAULT, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x02C4, 0x0019, 0x84, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x02C2, 0x0019, 0x84, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_64, ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x001C, 0x0003, 0x4A, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x001D, 0x0003, 0x4A, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x001E, 0x0003, 0x4A, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x001F, 0x0003, 0x4A, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0020, 0x0002, 0x41, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_64, ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0021, 0x0003, 0x41, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0022, 0x0003, 0x41, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0023, 0x0002, 0x42, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_64, ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0024, 0x0003, 0x42, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0025, 0x0003, 0x42, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0026, 0x0003, 0x42, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0027, 0x0002, 0x43, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_64, ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0028, 0x0003, 0x42, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0029, 0x0003, 0x41, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x002A, 0x0003, 0x41, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x002B, 0x0003, 0x95, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_64, ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x002C, 0x0003, 0x97, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_64, ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x002D, 0x0183, 0x3E, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_64, ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x002E, 0x0002, 0x48, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_64, ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x002F, 0x0002, 0x49, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_64, ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0030, 0x0002, 0x90, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_64, ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0031, 0x0002, 0x92, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_64, ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0032, 0x0002, 0x93, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_64, ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0033, 0x0002, 0x90, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0034, 0x0022, 0x90, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0035, 0x000A, 0x91, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0036, 0x0002, 0x92, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0037, 0x0002, 0x93, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x003B, 0x0002, 0x92, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_64, ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F2, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x003C, 0x0002, 0x92, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F2, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x003D, 0x0002, 0x93, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_64, ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F2, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x003E, 0x0002, 0x93, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F2, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0038, 0x0002, 0x90, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0039, 0x0022, 0x90, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x003A, 0x000A, 0x91, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x003F, 0x0002, 0x90, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0040, 0x0022, 0x90, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0041, 0x000A, 0x91, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0042, 0x0002, 0x92, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_64, ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F2, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0043, 0x0002, 0x93, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_64, ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F2, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0044, 0x0002, 0x90, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0045, 0x0022, 0x90, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0046, 0x000A, 0x91, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0047, 0x0002, 0x92, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0048, 0x0002, 0x93, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0049, 0x0002, 0x44, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_64, ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x004A, 0x0002, 0x44, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x004B, 0x0002, 0x44, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x004C, 0x0002, 0x44, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x004D, 0x0002, 0x44, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x004E, 0x0002, 0x45, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_64, ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x004F, 0x0003, 0x45, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0050, 0x0003, 0x45, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0051, 0x0003, 0x45, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0052, 0x0002, 0x98, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_64, ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0053, 0x0002, 0x98, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0054, 0x0002, 0x98, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0055, 0x0002, 0x98, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0056, 0x0002, 0x98, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0057, 0x0003, 0x45, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0058, 0x0183, 0x32, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0059, 0x0183, 0x33, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x005A, 0x0183, 0x33, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x005B, 0x0183, 0x32, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x005C, 0x0183, 0x30, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x005D, 0x0183, 0x31, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x005E, 0x0183, 0x31, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x005F, 0x0183, 0x30, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0060, 0x0002, 0x99, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0061, 0x0002, 0x99, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0062, 0x0002, 0x99, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0063, 0x0002, 0x99, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0064, 0x0003, 0x4B, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0065, 0x0003, 0x4B, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0066, 0x0003, 0x4B, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0067, 0x0002, 0x46, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_64, ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0068, 0x0003, 0x46, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0069, 0x0003, 0x46, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x006A, 0x0003, 0x46, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x006B, 0x0003, 0x46, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x006C, 0x0002, 0x47, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_64, ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x006D, 0x0003, 0x47, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x006E, 0x0003, 0x47, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x006F, 0x0003, 0x47, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0070, 0x0003, 0x47, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x02C5, 0x0000, 0x9F, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_DEFAULT, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x02C6, 0x0002, 0x02, 0xC0, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x02C7, 0x0022, 0x02, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x02C8, 0x0022, 0xF0, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F2, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x02C9, 0x0009, 0xAE, 0x10, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x02CA, 0x0022, 0xC5, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_DEFAULT, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0071, 0x0009, 0x49, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_64, ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0072, 0x0009, 0x49, 0x06, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_64, ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x02CB, 0x0022, 0x8D, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_DEFAULT, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x02CC, 0x0000, 0xC9, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_DEFAULT, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_OSZ, ZYAN_FALSE },
    { 0x02CD, 0x0022, 0xC4, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_DEFAULT, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x02CE, 0x0000, 0xAE, 0xE8, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x02CF, 0x0022, 0xB4, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x02D0, 0x0009, 0x01, 0x10, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_64, ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x02D1, 0x0009, 0x01, 0x10, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x02D2, 0x0022, 0xB5, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x02D3, 0x0009, 0x01, 0x18, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_64, ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x02D4, 0x0009, 0x01, 0x18, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x02D5, 0x0001, 0x00, 0xD0, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x02D6, 0x0009, 0x00, 0x10, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0010, 0x0001, 0x12, 0xC0, ZYDIS_INSTRUCTION_ENCODING_XOP, ZYDIS_OPCODE_MAP_XOP9, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x02D7, 0x0001, 0x01, 0xF0, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x02D8, 0x0009, 0x01, 0x30, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x02D9, 0x0002, 0xDC, 0xC0, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x02DA, 0x0000, 0xAC, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_DEFAULT, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_ASZ, ZYAN_FALSE },
    { 0x02DD, 0x0000, 0xAD, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_DEFAULT, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_32, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_ASZ, ZYAN_FALSE },
    { 0x02E0, 0x0000, 0xAD, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_DEFAULT, ZYDIS_WIDTH_64, ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_ASZ, ZYAN_FALSE },
    { 0x02E3, 0x0000, 0xAD, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_DEFAULT, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_ASZ, ZYAN_FALSE },
    { 0x02E6, 0x0019, 0xE2, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_DEFAULT, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_ASZ, ZYAN_FALSE },
    { 0x02E7, 0x0019, 0xE1, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_DEFAULT, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_ASZ, ZYAN_FALSE },
    { 0x02E8, 0x0019, 0xE0, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_DEFAULT, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_ASZ, ZYAN_FALSE },
    { 0x02E9, 0x0002, 0x03, 0xC0, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x02EA, 0x0022, 0x03, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x02EB, 0x0022, 0xB2, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x02EC, 0x0001, 0x00, 0xD8, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x02ED, 0x0009, 0x00, 0x18, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0011, 0x0183, 0x12, 0xC0, ZYDIS_INSTRUCTION_ENCODING_XOP, ZYDIS_OPCODE_MAP_XOPA, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0012, 0x01A3, 0x12, 0x00, ZYDIS_INSTRUCTION_ENCODING_XOP, ZYDIS_OPCODE_MAP_XOPA, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0013, 0x0183, 0x12, 0xC8, ZYDIS_INSTRUCTION_ENCODING_XOP, ZYDIS_OPCODE_MAP_XOPA, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0014, 0x01A3, 0x12, 0x08, ZYDIS_INSTRUCTION_ENCODING_XOP, ZYDIS_OPCODE_MAP_XOPA, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x02EE, 0x0002, 0xBD, 0xC0, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x02EF, 0x0022, 0xBD, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0073, 0x0002, 0xBD, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_64, ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0074, 0x0002, 0xBD, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_64, ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x02F0, 0x0002, 0xF7, 0xC0, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_ASZ, ZYAN_FALSE },
    { 0x02F1, 0x0002, 0xF7, 0xC0, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_ASZ, ZYAN_FALSE },
    { 0x02F2, 0x0002, 0x5F, 0xC0, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x02F3, 0x0022, 0x5F, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x02F4, 0x0002, 0x5F, 0xC0, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x02F5, 0x0022, 0x5F, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x02F6, 0x0002, 0x5F, 0xC0, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F2, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x02F7, 0x0022, 0x5F, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F2, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x02F8, 0x0002, 0x5F, 0xC0, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x02F9, 0x0022, 0x5F, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x02FA, 0x0000, 0x01, 0xFA, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x02FB, 0x0000, 0xAE, 0xF0, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x02FC, 0x0002, 0x5D, 0xC0, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x02FD, 0x0022, 0x5D, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x02FE, 0x0002, 0x5D, 0xC0, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x02FF, 0x0022, 0x5D, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0300, 0x0002, 0x5D, 0xC0, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F2, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0301, 0x0022, 0x5D, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F2, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0302, 0x0002, 0x5D, 0xC0, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0303, 0x0022, 0x5D, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0304, 0x0000, 0x01, 0xC8, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_64, ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_ASZ, ZYAN_FALSE },
    { 0x0305, 0x0000, 0x01, 0xC8, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_ASZ, ZYAN_FALSE },
    { 0x0306, 0x0000, 0x01, 0xFA, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_64, ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_ASZ, ZYAN_FALSE },
    { 0x0307, 0x0000, 0x01, 0xFA, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_ASZ, ZYAN_FALSE },
    { 0x0308, 0x0000, 0xA6, 0xC0, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_ASZ, ZYAN_FALSE },
    { 0x0315, 0x0022, 0xA0, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_DEFAULT, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0316, 0x0022, 0xA1, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_DEFAULT, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0317, 0x000A, 0xA2, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_DEFAULT, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0318, 0x000A, 0xA3, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_DEFAULT, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0309, 0x0002, 0x88, 0xC0, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_DEFAULT, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x030A, 0x000A, 0x88, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_DEFAULT, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x030B, 0x0002, 0x89, 0xC0, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_DEFAULT, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x030C, 0x000A, 0x89, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_DEFAULT, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x030D, 0x0002, 0x8A, 0xC0, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_DEFAULT, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x030E, 0x0022, 0x8A, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_DEFAULT, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x030F, 0x0002, 0x8B, 0xC0, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_DEFAULT, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0310, 0x0022, 0x8B, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_DEFAULT, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0311, 0x0002, 0x8C, 0xC0, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_DEFAULT, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0312, 0x000A, 0x8C, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_DEFAULT, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0313, 0x0002, 0x8E, 0xC0, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_DEFAULT, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0314, 0x0022, 0x8E, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_DEFAULT, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0319, 0x0062, 0xB0, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_DEFAULT, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x031B, 0x0062, 0xC6, 0xC0, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_DEFAULT, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x031C, 0x006A, 0xC6, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_DEFAULT, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x031F, 0x0002, 0x20, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_64, ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0320, 0x0002, 0x20, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0321, 0x0002, 0x21, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_64, ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0322, 0x0002, 0x21, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0323, 0x0002, 0x22, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_64, ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0324, 0x0002, 0x22, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0325, 0x0002, 0x23, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_64, ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0326, 0x0002, 0x23, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x031A, 0x0062, 0xB8, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_DEFAULT, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_TRUE },
    { 0x031D, 0x0062, 0xC7, 0xC0, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_DEFAULT, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x031E, 0x006A, 0xC7, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_DEFAULT, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0327, 0x0002, 0x28, 0xC0, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0328, 0x0022, 0x28, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0329, 0x0002, 0x29, 0xC0, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x032A, 0x000A, 0x29, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x032B, 0x0002, 0x28, 0xC0, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x032C, 0x0022, 0x28, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x032D, 0x0002, 0x29, 0xC0, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x032E, 0x000A, 0x29, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x032F, 0x0022, 0xF0, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0330, 0x000A, 0xF1, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0331, 0x0002, 0x6E, 0xC0, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_64, ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0332, 0x0022, 0x6E, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_64, ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0333, 0x0002, 0x6E, 0xC0, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0334, 0x0022, 0x6E, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0339, 0x0002, 0x7E, 0xC0, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_64, ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x033A, 0x000A, 0x7E, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_64, ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x033B, 0x0002, 0x7E, 0xC0, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x033C, 0x000A, 0x7E, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0335, 0x0002, 0x6E, 0xC0, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_64, ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0336, 0x0022, 0x6E, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_64, ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0337, 0x0002, 0x6E, 0xC0, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0338, 0x0022, 0x6E, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x033D, 0x0002, 0x7E, 0xC0, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_64, ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x033E, 0x000A, 0x7E, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_64, ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x033F, 0x0002, 0x7E, 0xC0, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0340, 0x000A, 0x7E, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0341, 0x0002, 0x12, 0xC0, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F2, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0342, 0x0022, 0x12, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F2, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0343, 0x0022, 0xF8, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_64, ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0344, 0x0022, 0xF8, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0345, 0x000A, 0xF9, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0346, 0x000A, 0xF9, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_64, ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0347, 0x0002, 0xD6, 0xC0, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F2, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0348, 0x0002, 0x6F, 0xC0, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0349, 0x0022, 0x6F, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x034A, 0x0002, 0x7F, 0xC0, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x034B, 0x000A, 0x7F, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x034C, 0x0002, 0x6F, 0xC0, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x034D, 0x0022, 0x6F, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x034E, 0x0002, 0x7F, 0xC0, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x034F, 0x000A, 0x7F, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0350, 0x0002, 0x12, 0xC0, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0351, 0x0022, 0x16, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0352, 0x000A, 0x17, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0353, 0x0022, 0x16, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0354, 0x000A, 0x17, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0355, 0x0002, 0x16, 0xC0, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0356, 0x0022, 0x12, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0357, 0x000A, 0x13, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0358, 0x0022, 0x12, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0359, 0x000A, 0x13, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x035A, 0x0002, 0x50, 0xC0, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x035B, 0x0002, 0x50, 0xC0, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x035C, 0x000A, 0xE7, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x035D, 0x0022, 0x2A, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x035E, 0x000A, 0xC3, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_64, ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x035F, 0x000A, 0xC3, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0360, 0x000A, 0x2B, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0361, 0x000A, 0x2B, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0362, 0x000A, 0xE7, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0363, 0x000A, 0x2B, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F2, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0364, 0x000A, 0x2B, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0369, 0x0002, 0x6F, 0xC0, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x036A, 0x0022, 0x6F, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0371, 0x0002, 0x7F, 0xC0, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0372, 0x000A, 0x7F, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0365, 0x0002, 0x6E, 0xC0, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_64, ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0366, 0x0022, 0x6E, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_64, ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x036B, 0x0002, 0x7E, 0xC0, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_64, ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x036C, 0x000A, 0x7E, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_64, ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x036F, 0x0002, 0x7E, 0xC0, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0370, 0x0022, 0x7E, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0373, 0x0002, 0xD6, 0xC0, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0374, 0x000A, 0xD6, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0367, 0x0002, 0x6E, 0xC0, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_64, ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0368, 0x0022, 0x6E, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_64, ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x036D, 0x0002, 0x7E, 0xC0, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_64, ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x036E, 0x000A, 0x7E, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_64, ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0375, 0x0002, 0xD6, 0xC0, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0376, 0x0000, 0xA4, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_DEFAULT, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_ASZ, ZYAN_FALSE },
    { 0x0379, 0x0000, 0xA5, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_DEFAULT, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_32, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_ASZ, ZYAN_FALSE },
    { 0x037C, 0x0002, 0x10, 0xC0, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F2, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x037D, 0x0022, 0x10, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F2, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x037E, 0x0002, 0x11, 0xC0, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F2, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x037F, 0x000A, 0x11, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F2, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0380, 0x0002, 0x16, 0xC0, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0381, 0x0022, 0x16, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0382, 0x0002, 0x12, 0xC0, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0383, 0x0022, 0x12, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0384, 0x0000, 0xA5, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_DEFAULT, ZYDIS_WIDTH_64, ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_ASZ, ZYAN_FALSE },
    { 0x0387, 0x0002, 0x10, 0xC0, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0388, 0x0022, 0x10, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0389, 0x0002, 0x11, 0xC0, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x038A, 0x000A, 0x11, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x038B, 0x0000, 0xA5, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_DEFAULT, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_ASZ, ZYAN_FALSE },
    { 0x038E, 0x0002, 0xBE, 0xC0, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x038F, 0x0022, 0xBE, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0390, 0x0002, 0xBF, 0xC0, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0391, 0x0022, 0xBF, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0392, 0x0002, 0x63, 0xC0, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_DEFAULT, ZYDIS_WIDTH_64, ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0393, 0x0022, 0x63, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_DEFAULT, ZYDIS_WIDTH_64, ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0394, 0x0002, 0x10, 0xC0, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0395, 0x0022, 0x10, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0396, 0x0002, 0x11, 0xC0, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0397, 0x000A, 0x11, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0398, 0x0002, 0x10, 0xC0, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0399, 0x0022, 0x10, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x039A, 0x0002, 0x11, 0xC0, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x039B, 0x000A, 0x11, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x039C, 0x0002, 0xB6, 0xC0, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x039D, 0x0022, 0xB6, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x039E, 0x0002, 0xB7, 0xC0, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x039F, 0x0022, 0xB7, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x03A0, 0x0183, 0x42, 0xC0, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x03A1, 0x01A3, 0x42, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x03A2, 0x0001, 0xF6, 0xE0, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_DEFAULT, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x03A3, 0x0009, 0xF6, 0x20, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_DEFAULT, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x03A4, 0x0001, 0xF7, 0xE0, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_DEFAULT, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x03A5, 0x0009, 0xF7, 0x20, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_DEFAULT, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x03A6, 0x0002, 0x59, 0xC0, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x03A7, 0x0022, 0x59, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x03A8, 0x0002, 0x59, 0xC0, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x03A9, 0x0022, 0x59, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x03AA, 0x0002, 0x59, 0xC0, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F2, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x03AB, 0x0022, 0x59, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F2, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x03AC, 0x0002, 0x59, 0xC0, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x03AD, 0x0022, 0x59, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0075, 0x0003, 0xF6, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_64, ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F2, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0076, 0x0003, 0xF6, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_64, ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F2, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0077, 0x0083, 0xF6, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_64, ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F2, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0078, 0x0083, 0xF6, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_64, ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F2, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0079, 0x0003, 0xF6, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F2, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x007A, 0x0083, 0xF6, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F2, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x03AE, 0x0000, 0x01, 0xC9, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_64, ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x03AF, 0x0000, 0x01, 0xC9, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x03B0, 0x0000, 0x01, 0xFB, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_64, ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x03B1, 0x0000, 0x01, 0xFB, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x03B2, 0x0001, 0xF6, 0xD8, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_DEFAULT, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x03B3, 0x0009, 0xF6, 0x18, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_DEFAULT, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x03B4, 0x0001, 0xF7, 0xD8, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_DEFAULT, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x03B5, 0x0009, 0xF7, 0x18, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_DEFAULT, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x03B6, 0x0000, 0x90, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_DEFAULT, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x03B7, 0x0002, 0x0D, 0xC0, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x03B8, 0x0001, 0x18, 0xC0, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x03B9, 0x0001, 0x18, 0xC8, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x03BA, 0x0001, 0x18, 0xD0, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x03BB, 0x0001, 0x18, 0xD8, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x03BC, 0x0001, 0x18, 0xE0, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x03BD, 0x0001, 0x18, 0xE8, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x03BE, 0x0001, 0x18, 0xF0, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x03BF, 0x0001, 0x18, 0xF8, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x03C0, 0x0009, 0x18, 0x20, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x03C1, 0x0009, 0x18, 0x28, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x03C2, 0x0009, 0x18, 0x30, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x03C3, 0x0009, 0x18, 0x38, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x03C4, 0x0002, 0x19, 0xC0, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x03C5, 0x000A, 0x19, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x03C8, 0x0001, 0x1A, 0xC0, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x03D1, 0x000A, 0x1E, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x03D3, 0x0002, 0x1E, 0xC0, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x03E7, 0x0001, 0x1F, 0xC0, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x03E9, 0x0009, 0x1F, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x03CC, 0x0001, 0x1B, 0xC0, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x03D4, 0x0002, 0x1E, 0xC0, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x03D5, 0x0002, 0x1E, 0xC0, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x03D6, 0x0002, 0x1E, 0xD0, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x03D7, 0x0002, 0x1E, 0xD8, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x03D8, 0x0002, 0x1E, 0xE0, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x03D9, 0x0002, 0x1E, 0xE8, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x03DA, 0x0002, 0x1E, 0xF0, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x03DB, 0x0002, 0x1E, 0xF8, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x03DC, 0x0002, 0x1E, 0xF9, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x03DF, 0x0002, 0x1E, 0xFC, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x03E0, 0x0002, 0x1E, 0xFD, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x03E1, 0x0002, 0x1E, 0xFE, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x03E2, 0x0002, 0x1E, 0xFF, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x03E5, 0x0002, 0x1E, 0xC0, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F2, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x03EA, 0x0001, 0xF6, 0xD0, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_DEFAULT, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x03EB, 0x0009, 0xF6, 0x10, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_DEFAULT, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x03EC, 0x0001, 0xF7, 0xD0, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_DEFAULT, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x03ED, 0x0009, 0xF7, 0x10, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_DEFAULT, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x03EE, 0x0002, 0x08, 0xC0, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_DEFAULT, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x03EF, 0x000A, 0x08, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_DEFAULT, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x03F0, 0x0002, 0x09, 0xC0, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_DEFAULT, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x03F1, 0x000A, 0x09, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_DEFAULT, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x03F2, 0x0002, 0x0A, 0xC0, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_DEFAULT, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x03F3, 0x0022, 0x0A, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_DEFAULT, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x03F4, 0x0002, 0x0B, 0xC0, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_DEFAULT, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x03F5, 0x0022, 0x0B, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_DEFAULT, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x03F6, 0x0062, 0x0C, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_DEFAULT, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x03F8, 0x0062, 0x80, 0xC8, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_DEFAULT, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x03F9, 0x006A, 0x80, 0x08, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_DEFAULT, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x03FC, 0x0062, 0x82, 0xC8, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_DEFAULT, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x03FD, 0x006A, 0x82, 0x08, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_DEFAULT, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x03FE, 0x0062, 0x83, 0xC8, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_DEFAULT, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x03FF, 0x006A, 0x83, 0x08, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_DEFAULT, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x03F7, 0x0062, 0x0D, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_DEFAULT, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x03FA, 0x0062, 0x81, 0xC8, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_DEFAULT, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x03FB, 0x006A, 0x81, 0x08, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_DEFAULT, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0400, 0x0002, 0x56, 0xC0, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0401, 0x0022, 0x56, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0402, 0x0002, 0x56, 0xC0, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0403, 0x0022, 0x56, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0407, 0x0002, 0xEE, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_DEFAULT, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0408, 0x0002, 0xEF, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_DEFAULT, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0409, 0x0002, 0xEF, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_DEFAULT, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0404, 0x001A, 0xE6, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_DEFAULT, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0405, 0x001A, 0xE7, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_DEFAULT, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0406, 0x001A, 0xE7, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_DEFAULT, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x040A, 0x0000, 0x6E, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_DEFAULT, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_ASZ, ZYAN_FALSE },
    { 0x040D, 0x0000, 0x6F, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_DEFAULT, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_ASZ, ZYAN_FALSE },
    { 0x0413, 0x0000, 0x6F, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_DEFAULT, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_ASZ, ZYAN_FALSE },
    { 0x0416, 0x0002, 0x1C, 0xC0, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0417, 0x0022, 0x1C, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0418, 0x0002, 0x1C, 0xC0, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0419, 0x0022, 0x1C, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x041A, 0x0002, 0x1E, 0xC0, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x041B, 0x0022, 0x1E, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x041C, 0x0002, 0x1E, 0xC0, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x041D, 0x0022, 0x1E, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x041E, 0x0002, 0x1D, 0xC0, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x041F, 0x0022, 0x1D, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0420, 0x0002, 0x1D, 0xC0, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0421, 0x0022, 0x1D, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0422, 0x0002, 0x6B, 0xC0, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0423, 0x0022, 0x6B, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0424, 0x0002, 0x6B, 0xC0, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0425, 0x0022, 0x6B, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0426, 0x0002, 0x63, 0xC0, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0427, 0x0022, 0x63, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0428, 0x0002, 0x63, 0xC0, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0429, 0x0022, 0x63, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x042A, 0x0002, 0x2B, 0xC0, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x042B, 0x0022, 0x2B, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x042C, 0x0002, 0x67, 0xC0, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x042D, 0x0022, 0x67, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x042E, 0x0002, 0x67, 0xC0, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x042F, 0x0022, 0x67, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0430, 0x0002, 0xFC, 0xC0, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0431, 0x0022, 0xFC, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0432, 0x0002, 0xFC, 0xC0, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0433, 0x0022, 0xFC, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0434, 0x0002, 0xFE, 0xC0, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0435, 0x0022, 0xFE, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0436, 0x0002, 0xFE, 0xC0, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0437, 0x0022, 0xFE, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0438, 0x0002, 0xD4, 0xC0, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0439, 0x0022, 0xD4, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x043A, 0x0002, 0xD4, 0xC0, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x043B, 0x0022, 0xD4, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x043C, 0x0002, 0xEC, 0xC0, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x043D, 0x0022, 0xEC, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x043E, 0x0002, 0xEC, 0xC0, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x043F, 0x0022, 0xEC, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0440, 0x0002, 0xED, 0xC0, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0441, 0x0022, 0xED, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0442, 0x0002, 0xED, 0xC0, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0443, 0x0022, 0xED, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0444, 0x0002, 0xDC, 0xC0, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0445, 0x0022, 0xDC, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0446, 0x0002, 0xDC, 0xC0, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0447, 0x0022, 0xDC, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0448, 0x0002, 0xDD, 0xC0, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0449, 0x0022, 0xDD, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x044A, 0x0002, 0xDD, 0xC0, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x044B, 0x0022, 0xDD, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x044C, 0x0002, 0xFD, 0xC0, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x044D, 0x0022, 0xFD, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x044E, 0x0002, 0xFD, 0xC0, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x044F, 0x0022, 0xFD, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0450, 0x0183, 0x0F, 0xC0, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0451, 0x01A3, 0x0F, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0452, 0x0183, 0x0F, 0xC0, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0453, 0x01A3, 0x0F, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0454, 0x0002, 0xDB, 0xC0, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0455, 0x0022, 0xDB, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0456, 0x0002, 0xDB, 0xC0, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0457, 0x0022, 0xDB, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0458, 0x0002, 0xDF, 0xC0, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0459, 0x0022, 0xDF, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x045A, 0x0002, 0xDF, 0xC0, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x045B, 0x0022, 0xDF, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x045C, 0x0000, 0x90, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_DEFAULT, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x045D, 0x0002, 0xE0, 0xC0, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x045E, 0x0022, 0xE0, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x045F, 0x0002, 0xE0, 0xC0, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0460, 0x0022, 0xE0, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0000, 0x0002, 0xBF, 0xC0, ZYDIS_INSTRUCTION_ENCODING_3DNOW, ZYDIS_OPCODE_MAP_0F0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0001, 0x0022, 0xBF, 0x00, ZYDIS_INSTRUCTION_ENCODING_3DNOW, ZYDIS_OPCODE_MAP_0F0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0461, 0x0002, 0xE3, 0xC0, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0462, 0x0022, 0xE3, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0463, 0x0002, 0xE3, 0xC0, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0464, 0x0022, 0xE3, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0465, 0x0002, 0x10, 0xC0, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0466, 0x0022, 0x10, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0467, 0x0183, 0x0E, 0xC0, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0468, 0x01A3, 0x0E, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0469, 0x0000, 0x01, 0xC7, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_64, ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x046A, 0x0183, 0x44, 0xC0, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x046B, 0x01A3, 0x44, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x046C, 0x0002, 0x74, 0xC0, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x046D, 0x0022, 0x74, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x046E, 0x0002, 0x74, 0xC0, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x046F, 0x0022, 0x74, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0470, 0x0002, 0x76, 0xC0, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0471, 0x0022, 0x76, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0472, 0x0002, 0x76, 0xC0, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0473, 0x0022, 0x76, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0474, 0x0002, 0x29, 0xC0, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0475, 0x0022, 0x29, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0476, 0x0002, 0x75, 0xC0, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0477, 0x0022, 0x75, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0478, 0x0002, 0x75, 0xC0, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0479, 0x0022, 0x75, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x047A, 0x0183, 0x61, 0xC0, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_OSZ, ZYAN_FALSE },
    { 0x047C, 0x01A3, 0x61, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_OSZ, ZYAN_FALSE },
    { 0x047E, 0x0183, 0x60, 0xC0, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_OSZ, ZYAN_FALSE },
    { 0x0480, 0x01A3, 0x60, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_OSZ, ZYAN_FALSE },
    { 0x0482, 0x0002, 0x64, 0xC0, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0483, 0x0022, 0x64, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0484, 0x0002, 0x64, 0xC0, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0485, 0x0022, 0x64, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0486, 0x0002, 0x66, 0xC0, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0487, 0x0022, 0x66, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0488, 0x0002, 0x66, 0xC0, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0489, 0x0022, 0x66, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x048A, 0x0002, 0x37, 0xC0, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x048B, 0x0022, 0x37, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x048C, 0x0002, 0x65, 0xC0, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x048D, 0x0022, 0x65, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x048E, 0x0002, 0x65, 0xC0, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x048F, 0x0022, 0x65, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0490, 0x0183, 0x63, 0xC0, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0491, 0x01A3, 0x63, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0492, 0x0183, 0x62, 0xC0, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0493, 0x01A3, 0x62, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0494, 0x0000, 0xAE, 0xF8, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0495, 0x0000, 0x01, 0xC5, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_64, ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0496, 0x0000, 0x01, 0xC5, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x007B, 0x0003, 0xF5, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_64, ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F2, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x007C, 0x0003, 0xF5, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_64, ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F2, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x007D, 0x0083, 0xF5, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_64, ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F2, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x007E, 0x0083, 0xF5, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_64, ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F2, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x007F, 0x0003, 0xF5, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F2, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0080, 0x0083, 0xF5, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F2, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0081, 0x0003, 0xF5, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_64, ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0082, 0x0003, 0xF5, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_64, ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0083, 0x0083, 0xF5, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_64, ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0084, 0x0083, 0xF5, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_64, ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0085, 0x0003, 0xF5, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0086, 0x0083, 0xF5, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0497, 0x0183, 0x14, 0xC0, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0498, 0x018B, 0x14, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0499, 0x0183, 0x16, 0xC0, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x049A, 0x018B, 0x16, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x049B, 0x0183, 0x16, 0xC0, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_64, ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x049C, 0x018B, 0x16, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_64, ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x049D, 0x0183, 0xC5, 0xC0, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x049E, 0x0183, 0xC5, 0xC0, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x049F, 0x0183, 0x15, 0xC0, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x04A0, 0x018B, 0x15, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0002, 0x0002, 0x1D, 0xC0, ZYDIS_INSTRUCTION_ENCODING_3DNOW, ZYDIS_OPCODE_MAP_0F0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0003, 0x0022, 0x1D, 0x00, ZYDIS_INSTRUCTION_ENCODING_3DNOW, ZYDIS_OPCODE_MAP_0F0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0004, 0x0002, 0x1C, 0xC0, ZYDIS_INSTRUCTION_ENCODING_3DNOW, ZYDIS_OPCODE_MAP_0F0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0005, 0x0022, 0x1C, 0x00, ZYDIS_INSTRUCTION_ENCODING_3DNOW, ZYDIS_OPCODE_MAP_0F0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0006, 0x0002, 0xAE, 0xC0, ZYDIS_INSTRUCTION_ENCODING_3DNOW, ZYDIS_OPCODE_MAP_0F0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0007, 0x0022, 0xAE, 0x00, ZYDIS_INSTRUCTION_ENCODING_3DNOW, ZYDIS_OPCODE_MAP_0F0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0008, 0x0002, 0x9E, 0xC0, ZYDIS_INSTRUCTION_ENCODING_3DNOW, ZYDIS_OPCODE_MAP_0F0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0009, 0x0022, 0x9E, 0x00, ZYDIS_INSTRUCTION_ENCODING_3DNOW, ZYDIS_OPCODE_MAP_0F0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x000A, 0x0002, 0xB0, 0xC0, ZYDIS_INSTRUCTION_ENCODING_3DNOW, ZYDIS_OPCODE_MAP_0F0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x000B, 0x0022, 0xB0, 0x00, ZYDIS_INSTRUCTION_ENCODING_3DNOW, ZYDIS_OPCODE_MAP_0F0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x000C, 0x0002, 0x90, 0xC0, ZYDIS_INSTRUCTION_ENCODING_3DNOW, ZYDIS_OPCODE_MAP_0F0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x000D, 0x0022, 0x90, 0x00, ZYDIS_INSTRUCTION_ENCODING_3DNOW, ZYDIS_OPCODE_MAP_0F0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x000E, 0x0002, 0xA0, 0xC0, ZYDIS_INSTRUCTION_ENCODING_3DNOW, ZYDIS_OPCODE_MAP_0F0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x000F, 0x0022, 0xA0, 0x00, ZYDIS_INSTRUCTION_ENCODING_3DNOW, ZYDIS_OPCODE_MAP_0F0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0010, 0x0002, 0xA6, 0xC0, ZYDIS_INSTRUCTION_ENCODING_3DNOW, ZYDIS_OPCODE_MAP_0F0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0011, 0x0022, 0xA6, 0x00, ZYDIS_INSTRUCTION_ENCODING_3DNOW, ZYDIS_OPCODE_MAP_0F0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0012, 0x0002, 0xA4, 0xC0, ZYDIS_INSTRUCTION_ENCODING_3DNOW, ZYDIS_OPCODE_MAP_0F0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0013, 0x0022, 0xA4, 0x00, ZYDIS_INSTRUCTION_ENCODING_3DNOW, ZYDIS_OPCODE_MAP_0F0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0014, 0x0002, 0x94, 0xC0, ZYDIS_INSTRUCTION_ENCODING_3DNOW, ZYDIS_OPCODE_MAP_0F0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0015, 0x0022, 0x94, 0x00, ZYDIS_INSTRUCTION_ENCODING_3DNOW, ZYDIS_OPCODE_MAP_0F0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0016, 0x0002, 0xB4, 0xC0, ZYDIS_INSTRUCTION_ENCODING_3DNOW, ZYDIS_OPCODE_MAP_0F0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0017, 0x0022, 0xB4, 0x00, ZYDIS_INSTRUCTION_ENCODING_3DNOW, ZYDIS_OPCODE_MAP_0F0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0018, 0x0002, 0x8A, 0xC0, ZYDIS_INSTRUCTION_ENCODING_3DNOW, ZYDIS_OPCODE_MAP_0F0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0019, 0x0022, 0x8A, 0x00, ZYDIS_INSTRUCTION_ENCODING_3DNOW, ZYDIS_OPCODE_MAP_0F0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x001A, 0x0002, 0x8E, 0xC0, ZYDIS_INSTRUCTION_ENCODING_3DNOW, ZYDIS_OPCODE_MAP_0F0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x001B, 0x0022, 0x8E, 0x00, ZYDIS_INSTRUCTION_ENCODING_3DNOW, ZYDIS_OPCODE_MAP_0F0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x001C, 0x0002, 0x96, 0xC0, ZYDIS_INSTRUCTION_ENCODING_3DNOW, ZYDIS_OPCODE_MAP_0F0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x001D, 0x0022, 0x96, 0x00, ZYDIS_INSTRUCTION_ENCODING_3DNOW, ZYDIS_OPCODE_MAP_0F0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x001E, 0x0002, 0xB6, 0xC0, ZYDIS_INSTRUCTION_ENCODING_3DNOW, ZYDIS_OPCODE_MAP_0F0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x001F, 0x0022, 0xB6, 0x00, ZYDIS_INSTRUCTION_ENCODING_3DNOW, ZYDIS_OPCODE_MAP_0F0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0020, 0x0002, 0xA7, 0xC0, ZYDIS_INSTRUCTION_ENCODING_3DNOW, ZYDIS_OPCODE_MAP_0F0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0021, 0x0022, 0xA7, 0x00, ZYDIS_INSTRUCTION_ENCODING_3DNOW, ZYDIS_OPCODE_MAP_0F0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0022, 0x0002, 0x97, 0xC0, ZYDIS_INSTRUCTION_ENCODING_3DNOW, ZYDIS_OPCODE_MAP_0F0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0023, 0x0022, 0x97, 0x00, ZYDIS_INSTRUCTION_ENCODING_3DNOW, ZYDIS_OPCODE_MAP_0F0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0024, 0x0002, 0x9A, 0xC0, ZYDIS_INSTRUCTION_ENCODING_3DNOW, ZYDIS_OPCODE_MAP_0F0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0025, 0x0022, 0x9A, 0x00, ZYDIS_INSTRUCTION_ENCODING_3DNOW, ZYDIS_OPCODE_MAP_0F0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0026, 0x0002, 0xAA, 0xC0, ZYDIS_INSTRUCTION_ENCODING_3DNOW, ZYDIS_OPCODE_MAP_0F0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0027, 0x0022, 0xAA, 0x00, ZYDIS_INSTRUCTION_ENCODING_3DNOW, ZYDIS_OPCODE_MAP_0F0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x04A1, 0x0002, 0x02, 0xC0, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x04A2, 0x0022, 0x02, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x04A3, 0x0002, 0x02, 0xC0, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x04A4, 0x0022, 0x02, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x04A5, 0x0002, 0x03, 0xC0, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x04A6, 0x0022, 0x03, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x04A7, 0x0002, 0x03, 0xC0, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x04A8, 0x0022, 0x03, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x04A9, 0x0002, 0x01, 0xC0, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x04AA, 0x0022, 0x01, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x04AB, 0x0002, 0x01, 0xC0, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x04AC, 0x0022, 0x01, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x04AD, 0x0002, 0x41, 0xC0, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x04AE, 0x0022, 0x41, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x04AF, 0x0002, 0x06, 0xC0, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x04B0, 0x0022, 0x06, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x04B1, 0x0002, 0x06, 0xC0, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x04B2, 0x0022, 0x06, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x04B3, 0x0002, 0x07, 0xC0, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x04B4, 0x0022, 0x07, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x04B5, 0x0002, 0x07, 0xC0, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x04B6, 0x0022, 0x07, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x04B7, 0x0002, 0x05, 0xC0, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x04B8, 0x0022, 0x05, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x04B9, 0x0002, 0x05, 0xC0, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x04BA, 0x0022, 0x05, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0028, 0x0002, 0x0D, 0xC0, ZYDIS_INSTRUCTION_ENCODING_3DNOW, ZYDIS_OPCODE_MAP_0F0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0029, 0x0022, 0x0D, 0x00, ZYDIS_INSTRUCTION_ENCODING_3DNOW, ZYDIS_OPCODE_MAP_0F0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x002A, 0x0002, 0x0C, 0xC0, ZYDIS_INSTRUCTION_ENCODING_3DNOW, ZYDIS_OPCODE_MAP_0F0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x002B, 0x0022, 0x0C, 0x00, ZYDIS_INSTRUCTION_ENCODING_3DNOW, ZYDIS_OPCODE_MAP_0F0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x04BB, 0x0183, 0x20, 0xC0, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x04BC, 0x01A3, 0x20, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x04BD, 0x0183, 0x22, 0xC0, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x04BE, 0x01A3, 0x22, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x04BF, 0x0183, 0x22, 0xC0, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_64, ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x04C0, 0x01A3, 0x22, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_64, ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x04C1, 0x0183, 0xC4, 0xC0, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x04C2, 0x01A3, 0xC4, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x04C3, 0x0183, 0xC4, 0xC0, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x04C4, 0x01A3, 0xC4, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x04C5, 0x0002, 0x04, 0xC0, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x04C6, 0x0022, 0x04, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x04C7, 0x0002, 0x04, 0xC0, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x04C8, 0x0022, 0x04, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x04C9, 0x0002, 0xF5, 0xC0, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x04CA, 0x0022, 0xF5, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x04CB, 0x0002, 0xF5, 0xC0, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x04CC, 0x0022, 0xF5, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x04CD, 0x0002, 0x3C, 0xC0, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x04CE, 0x0022, 0x3C, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x04CF, 0x0002, 0x3D, 0xC0, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x04D0, 0x0022, 0x3D, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x04D1, 0x0002, 0xEE, 0xC0, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x04D2, 0x0022, 0xEE, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x04D3, 0x0002, 0xEE, 0xC0, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x04D4, 0x0022, 0xEE, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x04D5, 0x0002, 0xDE, 0xC0, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x04D6, 0x0022, 0xDE, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x04D7, 0x0002, 0xDE, 0xC0, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x04D8, 0x0022, 0xDE, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x04D9, 0x0002, 0x3F, 0xC0, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x04DA, 0x0022, 0x3F, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x04DB, 0x0002, 0x3E, 0xC0, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x04DC, 0x0022, 0x3E, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x04DD, 0x0002, 0x38, 0xC0, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x04DE, 0x0022, 0x38, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x04DF, 0x0002, 0x39, 0xC0, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x04E0, 0x0022, 0x39, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x04E1, 0x0002, 0xEA, 0xC0, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x04E2, 0x0022, 0xEA, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x04E3, 0x0002, 0xEA, 0xC0, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x04E4, 0x0022, 0xEA, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x04E5, 0x0002, 0xDA, 0xC0, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x04E6, 0x0022, 0xDA, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x04E7, 0x0002, 0xDA, 0xC0, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x04E8, 0x0022, 0xDA, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x04E9, 0x0002, 0x3B, 0xC0, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x04EA, 0x0022, 0x3B, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x04EB, 0x0002, 0x3A, 0xC0, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x04EC, 0x0022, 0x3A, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x04ED, 0x0002, 0xD7, 0xC0, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x04EE, 0x0002, 0xD7, 0xC0, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x04EF, 0x0002, 0x21, 0xC0, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x04F0, 0x0022, 0x21, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x04F1, 0x0002, 0x22, 0xC0, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x04F2, 0x0022, 0x22, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x04F3, 0x0002, 0x20, 0xC0, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x04F4, 0x0022, 0x20, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x04F5, 0x0002, 0x25, 0xC0, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x04F6, 0x0022, 0x25, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x04F7, 0x0002, 0x23, 0xC0, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x04F8, 0x0022, 0x23, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x04F9, 0x0002, 0x24, 0xC0, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x04FA, 0x0022, 0x24, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x04FB, 0x0002, 0x31, 0xC0, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x04FC, 0x0022, 0x31, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x04FD, 0x0002, 0x32, 0xC0, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x04FE, 0x0022, 0x32, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x04FF, 0x0002, 0x30, 0xC0, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0500, 0x0022, 0x30, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0501, 0x0002, 0x35, 0xC0, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0502, 0x0022, 0x35, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0503, 0x0002, 0x33, 0xC0, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0504, 0x0022, 0x33, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0505, 0x0002, 0x34, 0xC0, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0506, 0x0022, 0x34, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0507, 0x0002, 0x28, 0xC0, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0508, 0x0022, 0x28, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0509, 0x0002, 0x0B, 0xC0, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x050A, 0x0022, 0x0B, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x050B, 0x0002, 0x0B, 0xC0, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x050C, 0x0022, 0x0B, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x002C, 0x0002, 0xB7, 0xC0, ZYDIS_INSTRUCTION_ENCODING_3DNOW, ZYDIS_OPCODE_MAP_0F0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x002D, 0x0022, 0xB7, 0x00, ZYDIS_INSTRUCTION_ENCODING_3DNOW, ZYDIS_OPCODE_MAP_0F0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x050D, 0x0002, 0xE4, 0xC0, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x050E, 0x0022, 0xE4, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x050F, 0x0002, 0xE4, 0xC0, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0510, 0x0022, 0xE4, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0511, 0x0002, 0xE5, 0xC0, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0512, 0x0022, 0xE5, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0513, 0x0002, 0xE5, 0xC0, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0514, 0x0022, 0xE5, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0515, 0x0002, 0x40, 0xC0, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0516, 0x0022, 0x40, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0517, 0x0002, 0xD5, 0xC0, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0518, 0x0022, 0xD5, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0519, 0x0002, 0xD5, 0xC0, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x051A, 0x0022, 0xD5, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x051B, 0x0002, 0xF4, 0xC0, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x051C, 0x0022, 0xF4, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x051D, 0x0002, 0xF4, 0xC0, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x051E, 0x0022, 0xF4, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x051F, 0x0001, 0x07, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_DEFAULT, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_OSZ, ZYAN_FALSE },
    { 0x0520, 0x0001, 0x17, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_DEFAULT, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_OSZ, ZYAN_FALSE },
    { 0x0521, 0x0001, 0x1F, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_DEFAULT, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_OSZ, ZYAN_FALSE },
    { 0x0522, 0x0001, 0x58, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_DEFAULT, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0523, 0x0001, 0x8F, 0xC0, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_DEFAULT, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0524, 0x0009, 0x8F, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_DEFAULT, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0525, 0x0001, 0xA1, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_OSZ, ZYAN_FALSE },
    { 0x0526, 0x0001, 0xA9, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_OSZ, ZYAN_FALSE },
    { 0x0527, 0x0000, 0x61, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_DEFAULT, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32, ZYDIS_WIDTH_16, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0528, 0x0000, 0x61, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_DEFAULT, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32, ZYDIS_WIDTH_32, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0529, 0x0002, 0xB8, 0xC0, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x052A, 0x0022, 0xB8, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0087, 0x0002, 0xB8, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_64, ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0088, 0x0002, 0xB8, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_64, ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x052B, 0x0000, 0x9D, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_DEFAULT, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x052C, 0x0000, 0x9D, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_DEFAULT, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32, ZYDIS_WIDTH_32, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x052D, 0x0000, 0x9D, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_DEFAULT, ZYDIS_WIDTH_64, ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x052E, 0x0002, 0xEB, 0xC0, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x052F, 0x0022, 0xEB, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0530, 0x0002, 0xEB, 0xC0, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0531, 0x0022, 0xEB, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0532, 0x0009, 0x0D, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0533, 0x0009, 0x18, 0x38, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0534, 0x0009, 0x18, 0x30, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0535, 0x0009, 0x18, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0536, 0x0009, 0x18, 0x08, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0537, 0x0009, 0x18, 0x10, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0538, 0x0009, 0x18, 0x18, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0539, 0x0009, 0x0D, 0x08, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x053A, 0x0009, 0x0D, 0x10, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x053B, 0x0002, 0xF6, 0xC0, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x053C, 0x0022, 0xF6, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x053D, 0x0002, 0xF6, 0xC0, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x053E, 0x0022, 0xF6, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x053F, 0x0002, 0x00, 0xC0, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0540, 0x0022, 0x00, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0541, 0x0002, 0x00, 0xC0, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0542, 0x0022, 0x00, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0543, 0x0183, 0x70, 0xC0, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0544, 0x01A3, 0x70, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0545, 0x0183, 0x70, 0xC0, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0546, 0x01A3, 0x70, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0547, 0x0183, 0x70, 0xC0, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F2, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0548, 0x01A3, 0x70, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F2, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0549, 0x0183, 0x70, 0xC0, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x054A, 0x01A3, 0x70, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x054B, 0x0002, 0x08, 0xC0, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x054C, 0x0022, 0x08, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x054D, 0x0002, 0x08, 0xC0, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x054E, 0x0022, 0x08, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x054F, 0x0002, 0x0A, 0xC0, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0550, 0x0022, 0x0A, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0551, 0x0002, 0x0A, 0xC0, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0552, 0x0022, 0x0A, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0553, 0x0002, 0x09, 0xC0, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0554, 0x0022, 0x09, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0555, 0x0002, 0x09, 0xC0, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0556, 0x0022, 0x09, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0559, 0x0002, 0xF2, 0xC0, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x055A, 0x0022, 0xF2, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0557, 0x0062, 0x72, 0xF0, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x055B, 0x0002, 0xF2, 0xC0, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x055C, 0x0022, 0xF2, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0558, 0x0062, 0x72, 0xF0, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x055D, 0x0062, 0x73, 0xF8, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0560, 0x0002, 0xF3, 0xC0, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0561, 0x0022, 0xF3, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x055E, 0x0062, 0x73, 0xF0, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0562, 0x0002, 0xF3, 0xC0, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0563, 0x0022, 0xF3, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x055F, 0x0062, 0x73, 0xF0, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0566, 0x0002, 0xF1, 0xC0, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0567, 0x0022, 0xF1, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0564, 0x0062, 0x71, 0xF0, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0568, 0x0002, 0xF1, 0xC0, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0569, 0x0022, 0xF1, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0565, 0x0062, 0x71, 0xF0, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x056A, 0x0001, 0x01, 0xFF, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_64, ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x056D, 0x0002, 0xE2, 0xC0, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x056E, 0x0022, 0xE2, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x056B, 0x0062, 0x72, 0xE0, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x056F, 0x0002, 0xE2, 0xC0, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0570, 0x0022, 0xE2, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x056C, 0x0062, 0x72, 0xE0, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0573, 0x0002, 0xE1, 0xC0, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0574, 0x0022, 0xE1, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0571, 0x0062, 0x71, 0xE0, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0575, 0x0002, 0xE1, 0xC0, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0576, 0x0022, 0xE1, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0572, 0x0062, 0x71, 0xE0, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0579, 0x0002, 0xD2, 0xC0, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x057A, 0x0022, 0xD2, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0577, 0x0062, 0x72, 0xD0, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x057B, 0x0002, 0xD2, 0xC0, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x057C, 0x0022, 0xD2, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0578, 0x0062, 0x72, 0xD0, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x057D, 0x0062, 0x73, 0xD8, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0580, 0x0002, 0xD3, 0xC0, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0581, 0x0022, 0xD3, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x057E, 0x0062, 0x73, 0xD0, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0582, 0x0002, 0xD3, 0xC0, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0583, 0x0022, 0xD3, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x057F, 0x0062, 0x73, 0xD0, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0586, 0x0002, 0xD1, 0xC0, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0587, 0x0022, 0xD1, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0584, 0x0062, 0x71, 0xD0, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0588, 0x0002, 0xD1, 0xC0, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0589, 0x0022, 0xD1, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0585, 0x0062, 0x71, 0xD0, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x058A, 0x0002, 0xF8, 0xC0, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x058B, 0x0022, 0xF8, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x058C, 0x0002, 0xF8, 0xC0, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x058D, 0x0022, 0xF8, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x058E, 0x0002, 0xFA, 0xC0, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x058F, 0x0022, 0xFA, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0590, 0x0002, 0xFA, 0xC0, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0591, 0x0022, 0xFA, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0592, 0x0002, 0xFB, 0xC0, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0593, 0x0022, 0xFB, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0594, 0x0002, 0xFB, 0xC0, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0595, 0x0022, 0xFB, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0596, 0x0002, 0xE8, 0xC0, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0597, 0x0022, 0xE8, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0598, 0x0002, 0xE8, 0xC0, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0599, 0x0022, 0xE8, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x059A, 0x0002, 0xE9, 0xC0, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x059B, 0x0022, 0xE9, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x059C, 0x0002, 0xE9, 0xC0, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x059D, 0x0022, 0xE9, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x059E, 0x0002, 0xD8, 0xC0, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x059F, 0x0022, 0xD8, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x05A0, 0x0002, 0xD8, 0xC0, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x05A1, 0x0022, 0xD8, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x05A2, 0x0002, 0xD9, 0xC0, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x05A3, 0x0022, 0xD9, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x05A4, 0x0002, 0xD9, 0xC0, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x05A5, 0x0022, 0xD9, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x05A6, 0x0002, 0xF9, 0xC0, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x05A7, 0x0022, 0xF9, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x05A8, 0x0002, 0xF9, 0xC0, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x05A9, 0x0022, 0xF9, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x002E, 0x0002, 0xBB, 0xC0, ZYDIS_INSTRUCTION_ENCODING_3DNOW, ZYDIS_OPCODE_MAP_0F0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x002F, 0x0022, 0xBB, 0x00, ZYDIS_INSTRUCTION_ENCODING_3DNOW, ZYDIS_OPCODE_MAP_0F0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x05AA, 0x0002, 0x17, 0xC0, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x05AB, 0x0022, 0x17, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x05AC, 0x0001, 0xAE, 0xE0, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x05AD, 0x0009, 0xAE, 0x20, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x05AE, 0x0002, 0x68, 0xC0, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x05AF, 0x0022, 0x68, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x05B0, 0x0002, 0x68, 0xC0, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x05B1, 0x0022, 0x68, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x05B2, 0x0002, 0x6A, 0xC0, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x05B3, 0x0022, 0x6A, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x05B4, 0x0002, 0x6A, 0xC0, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x05B5, 0x0022, 0x6A, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x05B6, 0x0002, 0x6D, 0xC0, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x05B7, 0x0022, 0x6D, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x05B8, 0x0002, 0x69, 0xC0, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x05B9, 0x0022, 0x69, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x05BA, 0x0002, 0x69, 0xC0, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x05BB, 0x0022, 0x69, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x05BC, 0x0002, 0x60, 0xC0, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x05BD, 0x0022, 0x60, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x05BE, 0x0002, 0x60, 0xC0, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x05BF, 0x0022, 0x60, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x05C0, 0x0002, 0x62, 0xC0, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x05C1, 0x0022, 0x62, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x05C2, 0x0002, 0x62, 0xC0, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x05C3, 0x0022, 0x62, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x05C4, 0x0002, 0x6C, 0xC0, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x05C5, 0x0022, 0x6C, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x05C6, 0x0002, 0x61, 0xC0, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x05C7, 0x0022, 0x61, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x05C8, 0x0002, 0x61, 0xC0, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x05C9, 0x0022, 0x61, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x05CA, 0x0001, 0x06, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_DEFAULT, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_OSZ, ZYAN_FALSE },
    { 0x05CB, 0x0001, 0x0E, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_DEFAULT, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_OSZ, ZYAN_FALSE },
    { 0x05CC, 0x0001, 0x16, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_DEFAULT, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_OSZ, ZYAN_FALSE },
    { 0x05CD, 0x0001, 0x1E, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_DEFAULT, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_OSZ, ZYAN_FALSE },
    { 0x05CE, 0x0001, 0x50, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_DEFAULT, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x05D0, 0x0019, 0x6A, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_DEFAULT, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_OSZ, ZYAN_FALSE },
    { 0x05D1, 0x0001, 0xFF, 0xF0, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_DEFAULT, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x05D2, 0x0009, 0xFF, 0x30, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_DEFAULT, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x05D3, 0x0001, 0xA0, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_OSZ, ZYAN_FALSE },
    { 0x05D4, 0x0001, 0xA8, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_OSZ, ZYAN_FALSE },
    { 0x05CF, 0x0019, 0x68, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_DEFAULT, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_OSZ, ZYAN_FALSE },
    { 0x05D5, 0x0000, 0x60, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_DEFAULT, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32, ZYDIS_WIDTH_16, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x05D6, 0x0000, 0x60, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_DEFAULT, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32, ZYDIS_WIDTH_32, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x05D7, 0x0000, 0x9C, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_DEFAULT, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x05D8, 0x0000, 0x9C, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_DEFAULT, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32, ZYDIS_WIDTH_32, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x05D9, 0x0000, 0x9C, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_DEFAULT, ZYDIS_WIDTH_64, ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x05DA, 0x0003, 0x01, 0xFF, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F2, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x05DB, 0x0002, 0xEF, 0xC0, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x05DC, 0x0022, 0xEF, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x05DD, 0x0002, 0xEF, 0xC0, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x05DE, 0x0022, 0xEF, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x05E3, 0x0062, 0xD0, 0xD0, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_DEFAULT, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x05E4, 0x006A, 0xD0, 0x10, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_DEFAULT, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x05E5, 0x0062, 0xD1, 0xD0, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_DEFAULT, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x05E6, 0x006A, 0xD1, 0x10, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_DEFAULT, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x05E7, 0x0002, 0xD2, 0xD0, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_DEFAULT, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x05E8, 0x000A, 0xD2, 0x10, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_DEFAULT, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x05E9, 0x0002, 0xD3, 0xD0, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_DEFAULT, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x05EA, 0x000A, 0xD3, 0x10, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_DEFAULT, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x05DF, 0x0062, 0xC0, 0xD0, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_DEFAULT, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x05E0, 0x006A, 0xC0, 0x10, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_DEFAULT, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x05E1, 0x0062, 0xC1, 0xD0, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_DEFAULT, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x05E2, 0x006A, 0xC1, 0x10, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_DEFAULT, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x05EB, 0x0002, 0x53, 0xC0, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x05EC, 0x0022, 0x53, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x05ED, 0x0002, 0x53, 0xC0, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x05EE, 0x0022, 0x53, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x05F3, 0x0062, 0xD0, 0xD8, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_DEFAULT, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x05F4, 0x006A, 0xD0, 0x18, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_DEFAULT, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x05F5, 0x0062, 0xD1, 0xD8, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_DEFAULT, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x05F6, 0x006A, 0xD1, 0x18, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_DEFAULT, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x05F7, 0x0002, 0xD2, 0xD8, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_DEFAULT, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x05F8, 0x000A, 0xD2, 0x18, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_DEFAULT, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x05F9, 0x0002, 0xD3, 0xD8, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_DEFAULT, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x05FA, 0x000A, 0xD3, 0x18, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_DEFAULT, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x05EF, 0x0062, 0xC0, 0xD8, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_DEFAULT, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x05F0, 0x006A, 0xC0, 0x18, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_DEFAULT, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x05F1, 0x0062, 0xC1, 0xD8, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_DEFAULT, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x05F2, 0x006A, 0xC1, 0x18, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_DEFAULT, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x05FB, 0x0001, 0xAE, 0xC0, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_64, ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x05FC, 0x0001, 0xAE, 0xC8, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_64, ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x05FD, 0x0000, 0x32, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x05FE, 0x0000, 0x01, 0xC6, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_64, ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F2, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x05FF, 0x0001, 0xC7, 0xF8, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_64, ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0600, 0x0001, 0xC7, 0xF8, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0601, 0x0000, 0x01, 0xEE, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0602, 0x0000, 0x33, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0603, 0x0000, 0x01, 0xFD, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0604, 0x0001, 0xC7, 0xF0, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0605, 0x0001, 0xC7, 0xF8, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0606, 0x0001, 0x1E, 0xC8, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0607, 0x0001, 0x1E, 0xC8, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_64, ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0608, 0x0000, 0x31, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0609, 0x0000, 0x01, 0xF9, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x060B, 0x0000, 0xC3, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_DEFAULT, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x060D, 0x0000, 0xCB, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_DEFAULT, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x060A, 0x0019, 0xC2, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_DEFAULT, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x060C, 0x0019, 0xCA, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_DEFAULT, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x060E, 0x0003, 0x01, 0xFE, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_64, ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x060F, 0x0002, 0x01, 0xFE, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_64, ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F2, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0614, 0x0062, 0xD0, 0xC0, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_DEFAULT, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0615, 0x006A, 0xD0, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_DEFAULT, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0616, 0x0062, 0xD1, 0xC0, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_DEFAULT, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0617, 0x006A, 0xD1, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_DEFAULT, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0618, 0x0002, 0xD2, 0xC0, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_DEFAULT, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0619, 0x000A, 0xD2, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_DEFAULT, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x061A, 0x0002, 0xD3, 0xC0, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_DEFAULT, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x061B, 0x000A, 0xD3, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_DEFAULT, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0610, 0x0062, 0xC0, 0xC0, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_DEFAULT, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0611, 0x006A, 0xC0, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_DEFAULT, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0612, 0x0062, 0xC1, 0xC0, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_DEFAULT, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0613, 0x006A, 0xC1, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_DEFAULT, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0620, 0x0062, 0xD0, 0xC8, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_DEFAULT, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0621, 0x006A, 0xD0, 0x08, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_DEFAULT, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0622, 0x0062, 0xD1, 0xC8, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_DEFAULT, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0623, 0x006A, 0xD1, 0x08, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_DEFAULT, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0624, 0x0002, 0xD2, 0xC8, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_DEFAULT, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0625, 0x000A, 0xD2, 0x08, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_DEFAULT, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0626, 0x0002, 0xD3, 0xC8, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_DEFAULT, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0627, 0x000A, 0xD3, 0x08, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_DEFAULT, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x061C, 0x0062, 0xC0, 0xC8, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_DEFAULT, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x061D, 0x006A, 0xC0, 0x08, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_DEFAULT, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x061E, 0x0062, 0xC1, 0xC8, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_DEFAULT, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x061F, 0x006A, 0xC1, 0x08, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_DEFAULT, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0089, 0x0183, 0xF0, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_64, ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F2, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x008A, 0x0183, 0xF0, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_64, ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F2, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x008B, 0x01A3, 0xF0, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_64, ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F2, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x008C, 0x01A3, 0xF0, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_64, ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F2, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x008D, 0x0183, 0xF0, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F2, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x008E, 0x01A3, 0xF0, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F2, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0628, 0x0183, 0x09, 0xC0, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0629, 0x01A3, 0x09, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x062A, 0x0183, 0x08, 0xC0, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x062B, 0x01A3, 0x08, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x062C, 0x0183, 0x0B, 0xC0, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x062D, 0x01A3, 0x0B, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x062E, 0x0183, 0x0A, 0xC0, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x062F, 0x01A3, 0x0A, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0630, 0x0000, 0xAA, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0631, 0x0002, 0x52, 0xC0, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0632, 0x0022, 0x52, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0633, 0x0002, 0x52, 0xC0, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0634, 0x0022, 0x52, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0635, 0x0009, 0x01, 0x28, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0636, 0x0000, 0x9E, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_DEFAULT, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0637, 0x0000, 0xD6, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_DEFAULT, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x063C, 0x0062, 0xD0, 0xF8, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_DEFAULT, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x063D, 0x006A, 0xD0, 0x38, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_DEFAULT, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x063E, 0x0062, 0xD1, 0xF8, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_DEFAULT, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x063F, 0x006A, 0xD1, 0x38, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_DEFAULT, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0640, 0x0002, 0xD2, 0xF8, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_DEFAULT, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0641, 0x000A, 0xD2, 0x38, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_DEFAULT, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0642, 0x0002, 0xD3, 0xF8, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_DEFAULT, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0643, 0x000A, 0xD3, 0x38, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_DEFAULT, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0638, 0x0062, 0xC0, 0xF8, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_DEFAULT, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0639, 0x006A, 0xC0, 0x38, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_DEFAULT, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x063A, 0x0062, 0xC1, 0xF8, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_DEFAULT, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x063B, 0x006A, 0xC1, 0x38, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_DEFAULT, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x008F, 0x0003, 0xF7, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_64, ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0090, 0x0003, 0xF7, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_64, ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0091, 0x0023, 0xF7, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_64, ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0092, 0x0023, 0xF7, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_64, ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0093, 0x0003, 0xF7, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0094, 0x0023, 0xF7, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0644, 0x0000, 0x01, 0xEA, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0645, 0x0002, 0x18, 0xC0, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_DEFAULT, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0646, 0x000A, 0x18, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_DEFAULT, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0647, 0x0002, 0x19, 0xC0, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_DEFAULT, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0648, 0x000A, 0x19, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_DEFAULT, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0649, 0x0002, 0x1A, 0xC0, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_DEFAULT, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x064A, 0x0022, 0x1A, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_DEFAULT, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x064B, 0x0002, 0x1B, 0xC0, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_DEFAULT, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x064C, 0x0022, 0x1B, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_DEFAULT, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x064D, 0x0062, 0x1C, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_DEFAULT, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x064F, 0x0062, 0x80, 0xD8, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_DEFAULT, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0650, 0x006A, 0x80, 0x18, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_DEFAULT, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0653, 0x0062, 0x82, 0xD8, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_DEFAULT, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0654, 0x006A, 0x82, 0x18, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_DEFAULT, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0655, 0x0062, 0x83, 0xD8, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_DEFAULT, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0656, 0x006A, 0x83, 0x18, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_DEFAULT, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x064E, 0x0062, 0x1D, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_DEFAULT, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0651, 0x0062, 0x81, 0xD8, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_DEFAULT, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0652, 0x006A, 0x81, 0x18, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_DEFAULT, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0657, 0x0000, 0xAE, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_DEFAULT, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_ASZ, ZYAN_FALSE },
    { 0x065A, 0x0000, 0xAF, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_DEFAULT, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_32, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_ASZ, ZYAN_FALSE },
    { 0x065D, 0x0000, 0xAF, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_DEFAULT, ZYDIS_WIDTH_64, ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_ASZ, ZYAN_FALSE },
    { 0x0660, 0x0000, 0xAF, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_DEFAULT, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_ASZ, ZYAN_FALSE },
    { 0x0663, 0x0000, 0x01, 0xCF, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_64, ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0664, 0x0000, 0x01, 0xCE, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_64, ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0665, 0x0000, 0x01, 0xCD, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_64, ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0666, 0x0001, 0xC7, 0xF0, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_64, ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0667, 0x0000, 0x01, 0xE8, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0668, 0x0001, 0x92, 0xC0, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0669, 0x0009, 0x92, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x066A, 0x0001, 0x96, 0xC0, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x066B, 0x0009, 0x96, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x066C, 0x0001, 0x9C, 0xC0, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x066D, 0x0009, 0x9C, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x066E, 0x0001, 0x9E, 0xC0, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x066F, 0x0009, 0x9E, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0670, 0x0001, 0x93, 0xC0, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0671, 0x0009, 0x93, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0672, 0x0001, 0x97, 0xC0, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0673, 0x0009, 0x97, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0674, 0x0001, 0x9D, 0xC0, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0675, 0x0009, 0x9D, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0676, 0x0001, 0x9F, 0xC0, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0677, 0x0009, 0x9F, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0678, 0x0001, 0x91, 0xC0, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0679, 0x0009, 0x91, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x067A, 0x0001, 0x9B, 0xC0, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x067B, 0x0009, 0x9B, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x067C, 0x0001, 0x99, 0xC0, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x067D, 0x0009, 0x99, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x067E, 0x0001, 0x95, 0xC0, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x067F, 0x0009, 0x95, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0680, 0x0001, 0x90, 0xC0, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0681, 0x0009, 0x90, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0682, 0x0001, 0x9A, 0xC0, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0683, 0x0009, 0x9A, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0684, 0x0001, 0x98, 0xC0, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0685, 0x0009, 0x98, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0686, 0x0000, 0x01, 0xE8, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0687, 0x0001, 0x94, 0xC0, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0688, 0x0009, 0x94, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0689, 0x0000, 0xAE, 0xF8, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x068A, 0x0009, 0x01, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_64, ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x068B, 0x0009, 0x01, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x068C, 0x0002, 0xC9, 0xC0, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x068D, 0x0022, 0xC9, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x068E, 0x0002, 0xCA, 0xC0, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x068F, 0x0022, 0xCA, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0690, 0x0002, 0xC8, 0xC0, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0691, 0x0022, 0xC8, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0692, 0x0183, 0xCC, 0xC0, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0693, 0x01A3, 0xCC, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0694, 0x0002, 0xCC, 0xC0, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0695, 0x0022, 0xCC, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0696, 0x0002, 0xCD, 0xC0, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0697, 0x0022, 0xCD, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0698, 0x0002, 0xCB, 0xC0, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0699, 0x0022, 0xCB, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x06A2, 0x0062, 0xD0, 0xE0, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_DEFAULT, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x06A3, 0x0062, 0xD0, 0xF0, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_DEFAULT, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x06A4, 0x006A, 0xD0, 0x20, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_DEFAULT, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x06A5, 0x006A, 0xD0, 0x30, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_DEFAULT, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x06A6, 0x0062, 0xD1, 0xE0, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_DEFAULT, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x06A7, 0x0062, 0xD1, 0xF0, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_DEFAULT, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x06A8, 0x006A, 0xD1, 0x20, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_DEFAULT, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x06A9, 0x006A, 0xD1, 0x30, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_DEFAULT, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x06AA, 0x0002, 0xD2, 0xE0, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_DEFAULT, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x06AB, 0x0002, 0xD2, 0xF0, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_DEFAULT, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x06AC, 0x000A, 0xD2, 0x20, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_DEFAULT, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x06AD, 0x000A, 0xD2, 0x30, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_DEFAULT, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x06AE, 0x0002, 0xD3, 0xE0, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_DEFAULT, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x06AF, 0x0002, 0xD3, 0xF0, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_DEFAULT, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x06B0, 0x000A, 0xD3, 0x20, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_DEFAULT, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x06B1, 0x000A, 0xD3, 0x30, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_DEFAULT, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x069A, 0x0062, 0xC0, 0xE0, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_DEFAULT, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x069B, 0x0062, 0xC0, 0xF0, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_DEFAULT, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x069C, 0x006A, 0xC0, 0x20, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_DEFAULT, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x069D, 0x006A, 0xC0, 0x30, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_DEFAULT, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x069E, 0x0062, 0xC1, 0xE0, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_DEFAULT, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x069F, 0x0062, 0xC1, 0xF0, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_DEFAULT, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x06A0, 0x006A, 0xC1, 0x20, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_DEFAULT, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x06A1, 0x006A, 0xC1, 0x30, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_DEFAULT, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x06B4, 0x0003, 0xA5, 0xC0, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x06B5, 0x000B, 0xA5, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x06B2, 0x0183, 0xA4, 0xC0, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x06B3, 0x018B, 0xA4, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0095, 0x0003, 0xF7, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_64, ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0096, 0x0003, 0xF7, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_64, ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0097, 0x0023, 0xF7, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_64, ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0098, 0x0023, 0xF7, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_64, ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0099, 0x0003, 0xF7, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x009A, 0x0023, 0xF7, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x06BA, 0x0062, 0xD0, 0xE8, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_DEFAULT, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x06BB, 0x006A, 0xD0, 0x28, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_DEFAULT, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x06BC, 0x0062, 0xD1, 0xE8, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_DEFAULT, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x06BD, 0x006A, 0xD1, 0x28, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_DEFAULT, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x06BE, 0x0002, 0xD2, 0xE8, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_DEFAULT, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x06BF, 0x000A, 0xD2, 0x28, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_DEFAULT, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x06C0, 0x0002, 0xD3, 0xE8, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_DEFAULT, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x06C1, 0x000A, 0xD3, 0x28, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_DEFAULT, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x06B6, 0x0062, 0xC0, 0xE8, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_DEFAULT, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x06B7, 0x006A, 0xC0, 0x28, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_DEFAULT, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x06B8, 0x0062, 0xC1, 0xE8, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_DEFAULT, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x06B9, 0x006A, 0xC1, 0x28, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_DEFAULT, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x06C4, 0x0003, 0xAD, 0xC0, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x06C5, 0x000B, 0xAD, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x06C2, 0x0183, 0xAC, 0xC0, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x06C3, 0x018B, 0xAC, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x009B, 0x0003, 0xF7, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_64, ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F2, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x009C, 0x0003, 0xF7, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_64, ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F2, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x009D, 0x0023, 0xF7, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_64, ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F2, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x009E, 0x0023, 0xF7, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_64, ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F2, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x009F, 0x0003, 0xF7, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F2, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x00A0, 0x0023, 0xF7, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F2, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x06C6, 0x0183, 0xC6, 0xC0, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x06C7, 0x01A3, 0xC6, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x06C8, 0x0183, 0xC6, 0xC0, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x06C9, 0x01A3, 0xC6, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x06CA, 0x0009, 0x01, 0x08, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_64, ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x06CB, 0x0009, 0x01, 0x08, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x06CC, 0x0001, 0x01, 0xDE, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x06CD, 0x0001, 0x00, 0xC0, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x06CE, 0x0009, 0x00, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0015, 0x0001, 0x12, 0xC8, ZYDIS_INSTRUCTION_ENCODING_XOP, ZYDIS_OPCODE_MAP_XOP9, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x06CF, 0x0001, 0x01, 0xE0, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x06D0, 0x0009, 0x01, 0x20, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x00A1, 0x0001, 0xAE, 0xF0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_64, ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F2, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x00A2, 0x0001, 0xAE, 0xF0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_64, ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F2, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x06D1, 0x0002, 0x51, 0xC0, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x06D2, 0x0022, 0x51, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x06D3, 0x0002, 0x51, 0xC0, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x06D4, 0x0022, 0x51, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x06D5, 0x0002, 0x51, 0xC0, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F2, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x06D6, 0x0022, 0x51, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F2, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x06D7, 0x0002, 0x51, 0xC0, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x06D8, 0x0022, 0x51, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x06D9, 0x0000, 0x01, 0xCB, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x06DA, 0x0000, 0xF9, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_DEFAULT, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x06DB, 0x0000, 0xFD, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_DEFAULT, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x06DC, 0x0000, 0x01, 0xDC, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x06DD, 0x0000, 0xFB, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_DEFAULT, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x06DE, 0x0009, 0xAE, 0x18, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x06DF, 0x0000, 0xAA, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_DEFAULT, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_ASZ, ZYAN_FALSE },
    { 0x06E2, 0x0000, 0xAB, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_DEFAULT, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_32, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_ASZ, ZYAN_FALSE },
    { 0x06E5, 0x0000, 0xAB, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_DEFAULT, ZYDIS_WIDTH_64, ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_ASZ, ZYAN_FALSE },
    { 0x06E8, 0x0000, 0xAB, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_DEFAULT, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_ASZ, ZYAN_FALSE },
    { 0x06EB, 0x0001, 0x00, 0xC8, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x06EC, 0x0009, 0x00, 0x08, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x00A3, 0x0009, 0x49, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_64, ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x06ED, 0x0000, 0x01, 0xEF, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_64, ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x06EE, 0x0002, 0x28, 0xC0, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_DEFAULT, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x06EF, 0x000A, 0x28, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_DEFAULT, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x06F0, 0x0002, 0x29, 0xC0, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_DEFAULT, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x06F1, 0x000A, 0x29, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_DEFAULT, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x06F2, 0x0002, 0x2A, 0xC0, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_DEFAULT, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x06F3, 0x0022, 0x2A, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_DEFAULT, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x06F4, 0x0002, 0x2B, 0xC0, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_DEFAULT, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x06F5, 0x0022, 0x2B, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_DEFAULT, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x06F6, 0x0062, 0x2C, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_DEFAULT, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x06F8, 0x0062, 0x80, 0xE8, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_DEFAULT, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x06F9, 0x006A, 0x80, 0x28, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_DEFAULT, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x06FC, 0x0062, 0x82, 0xE8, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_DEFAULT, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x06FD, 0x006A, 0x82, 0x28, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_DEFAULT, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x06FE, 0x0062, 0x83, 0xE8, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_DEFAULT, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x06FF, 0x006A, 0x83, 0x28, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_DEFAULT, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x06F7, 0x0062, 0x2D, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_DEFAULT, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x06FA, 0x0062, 0x81, 0xE8, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_DEFAULT, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x06FB, 0x006A, 0x81, 0x28, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_DEFAULT, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0700, 0x0002, 0x5C, 0xC0, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0701, 0x0022, 0x5C, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0702, 0x0002, 0x5C, 0xC0, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0703, 0x0022, 0x5C, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0704, 0x0002, 0x5C, 0xC0, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F2, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0705, 0x0022, 0x5C, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F2, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0706, 0x0002, 0x5C, 0xC0, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0707, 0x0022, 0x5C, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0708, 0x0000, 0x01, 0xF8, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_64, ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0709, 0x0000, 0x05, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_64, ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x070A, 0x0000, 0x05, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x070B, 0x0000, 0x34, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_64, ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x070C, 0x0000, 0x34, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x070D, 0x0000, 0x35, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_64, ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x070E, 0x0000, 0x35, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x070F, 0x0000, 0x07, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_64, ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_OSZ, ZYAN_FALSE },
    { 0x0711, 0x0000, 0x07, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0016, 0x0002, 0x01, 0xF8, ZYDIS_INSTRUCTION_ENCODING_XOP, ZYDIS_OPCODE_MAP_XOP9, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0017, 0x0022, 0x01, 0x38, ZYDIS_INSTRUCTION_ENCODING_XOP, ZYDIS_OPCODE_MAP_XOP9, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0712, 0x0000, 0x01, 0xCC, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_64, ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0713, 0x0000, 0x01, 0xCC, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x00A4, 0x0003, 0x5C, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_64, ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x00A5, 0x0003, 0x5E, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_64, ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F2, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x00A6, 0x0003, 0x5E, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_64, ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x00A7, 0x0003, 0x5E, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_64, ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x00A8, 0x0003, 0x5E, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_64, ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x00A9, 0x0003, 0x5C, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_64, ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F2, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0714, 0x0002, 0x84, 0xC0, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_DEFAULT, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0715, 0x000A, 0x84, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_DEFAULT, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0716, 0x0002, 0x85, 0xC0, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_DEFAULT, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0717, 0x000A, 0x85, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_DEFAULT, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0718, 0x0062, 0xA8, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_DEFAULT, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x071A, 0x0062, 0xF6, 0xC0, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_DEFAULT, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x071B, 0x0062, 0xF6, 0xC8, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_DEFAULT, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x071C, 0x006A, 0xF6, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_DEFAULT, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x071D, 0x006A, 0xF6, 0x08, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_DEFAULT, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0719, 0x0062, 0xA9, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_DEFAULT, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x071E, 0x0062, 0xF7, 0xC0, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_DEFAULT, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x071F, 0x0062, 0xF7, 0xC8, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_DEFAULT, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0720, 0x006A, 0xF7, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_DEFAULT, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0721, 0x006A, 0xF7, 0x08, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_DEFAULT, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0722, 0x0000, 0x01, 0xED, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_64, ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x00AA, 0x0022, 0x4B, 0x04, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_64, ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F2, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x00AB, 0x0022, 0x4B, 0x04, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_64, ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x00AC, 0x0000, 0x49, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_64, ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x00AD, 0x000A, 0x4B, 0x04, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_64, ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x00AE, 0x0001, 0x49, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_64, ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F2, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0723, 0x0000, 0x01, 0xFF, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0724, 0x0001, 0xAE, 0xF0, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0725, 0x0002, 0xBC, 0xC0, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0726, 0x0022, 0xBC, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x00AF, 0x0002, 0xBC, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_64, ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x00B0, 0x0002, 0xBC, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_64, ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x00B1, 0x0002, 0xBC, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_64, ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F2, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x00B2, 0x0002, 0xBC, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_64, ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F2, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0018, 0x0002, 0x01, 0xE0, ZYDIS_INSTRUCTION_ENCODING_XOP, ZYDIS_OPCODE_MAP_XOP9, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0019, 0x0022, 0x01, 0x20, ZYDIS_INSTRUCTION_ENCODING_XOP, ZYDIS_OPCODE_MAP_XOP9, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0727, 0x0002, 0x2E, 0xC0, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0728, 0x0022, 0x2E, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0729, 0x0002, 0x2E, 0xC0, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x072A, 0x0022, 0x2E, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x072B, 0x0000, 0xFF, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x072C, 0x0002, 0xFF, 0xC0, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x072D, 0x0022, 0xFF, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x072E, 0x0002, 0xB9, 0xC0, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x072F, 0x0022, 0xB9, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0730, 0x0000, 0x0B, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0731, 0x0000, 0x01, 0xEC, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_64, ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0732, 0x0001, 0xAE, 0xF0, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0733, 0x0001, 0xAE, 0xF0, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F2, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0734, 0x0002, 0x15, 0xC0, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0735, 0x0022, 0x15, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0736, 0x0002, 0x15, 0xC0, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0737, 0x0022, 0x15, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0738, 0x0002, 0x14, 0xC0, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0739, 0x0022, 0x14, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x073A, 0x0002, 0x14, 0xC0, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x073B, 0x0022, 0x14, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0000, 0x0204, 0x9A, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F2, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0001, 0x0204, 0x9B, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F2, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0002, 0x0204, 0xAA, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F2, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0003, 0x0204, 0xAB, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F2, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0002, 0x0004, 0x50, 0xC0, ZYDIS_INSTRUCTION_ENCODING_MVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_64, ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0003, 0x0004, 0x50, 0xC0, ZYDIS_INSTRUCTION_ENCODING_MVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_64, ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0004, 0x0204, 0x50, 0x00, ZYDIS_INSTRUCTION_ENCODING_MVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_64, ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0005, 0x0004, 0x50, 0xC0, ZYDIS_INSTRUCTION_ENCODING_MVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0006, 0x0004, 0x50, 0xC0, ZYDIS_INSTRUCTION_ENCODING_MVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0007, 0x0204, 0x50, 0x00, ZYDIS_INSTRUCTION_ENCODING_MVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x00B3, 0x0003, 0x58, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x00B4, 0x0003, 0x58, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x00B5, 0x0083, 0x58, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x00B6, 0x0083, 0x58, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0004, 0x0004, 0x58, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0005, 0x0004, 0x58, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0006, 0x0004, 0x58, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0007, 0x0004, 0x58, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0008, 0x0204, 0x58, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0009, 0x0204, 0x58, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x000A, 0x0204, 0x58, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0008, 0x0004, 0x58, 0xC0, ZYDIS_INSTRUCTION_ENCODING_MVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_64, ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0009, 0x0004, 0x58, 0xC0, ZYDIS_INSTRUCTION_ENCODING_MVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_64, ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x000A, 0x0204, 0x58, 0x00, ZYDIS_INSTRUCTION_ENCODING_MVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_64, ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x000B, 0x0004, 0x58, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_MAP5, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x000C, 0x0004, 0x58, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_MAP5, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x000D, 0x0004, 0x58, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_MAP5, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x000E, 0x0004, 0x58, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_MAP5, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x000F, 0x0204, 0x58, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_MAP5, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0010, 0x0204, 0x58, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_MAP5, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0011, 0x0204, 0x58, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_MAP5, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x00B7, 0x0003, 0x58, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x00B8, 0x0003, 0x58, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x00B9, 0x0083, 0x58, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x00BA, 0x0083, 0x58, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0012, 0x0004, 0x58, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0013, 0x0004, 0x58, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0014, 0x0004, 0x58, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0015, 0x0004, 0x58, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0016, 0x0204, 0x58, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0017, 0x0204, 0x58, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0018, 0x0204, 0x58, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x000B, 0x0004, 0x58, 0xC0, ZYDIS_INSTRUCTION_ENCODING_MVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x000C, 0x0004, 0x58, 0xC0, ZYDIS_INSTRUCTION_ENCODING_MVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x000D, 0x0204, 0x58, 0x00, ZYDIS_INSTRUCTION_ENCODING_MVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x00BB, 0x0003, 0x58, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F2, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x00BC, 0x0083, 0x58, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F2, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0019, 0x0004, 0x58, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F2, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x001A, 0x0004, 0x58, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F2, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x001B, 0x0204, 0x58, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F2, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x000E, 0x0004, 0xCC, 0xC0, ZYDIS_INSTRUCTION_ENCODING_MVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x000F, 0x0004, 0xCC, 0xC0, ZYDIS_INSTRUCTION_ENCODING_MVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0010, 0x0204, 0xCC, 0x00, ZYDIS_INSTRUCTION_ENCODING_MVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x001C, 0x0004, 0x58, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_MAP5, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x001D, 0x0004, 0x58, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_MAP5, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x001E, 0x0204, 0x58, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_MAP5, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x00BD, 0x0003, 0x58, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x00BE, 0x0083, 0x58, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x001F, 0x0004, 0x58, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0020, 0x0004, 0x58, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0021, 0x0204, 0x58, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x00BF, 0x0003, 0xD0, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x00C0, 0x0003, 0xD0, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x00C1, 0x0083, 0xD0, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x00C2, 0x0083, 0xD0, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x00C3, 0x0003, 0xD0, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F2, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x00C4, 0x0003, 0xD0, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F2, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x00C5, 0x0083, 0xD0, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F2, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x00C6, 0x0083, 0xD0, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F2, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x00C7, 0x0003, 0xDE, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x00C8, 0x0003, 0xDE, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x00C9, 0x0083, 0xDE, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x00CA, 0x0083, 0xDE, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0022, 0x0003, 0xDE, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0023, 0x0003, 0xDE, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0024, 0x0003, 0xDE, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0025, 0x0083, 0xDE, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0026, 0x0083, 0xDE, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0027, 0x0083, 0xDE, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x00CB, 0x0003, 0xDF, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x00CC, 0x0003, 0xDF, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x00CD, 0x0083, 0xDF, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x00CE, 0x0083, 0xDF, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0028, 0x0003, 0xDF, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0029, 0x0003, 0xDF, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x002A, 0x0003, 0xDF, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x002B, 0x0083, 0xDF, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x002C, 0x0083, 0xDF, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x002D, 0x0083, 0xDF, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x00CF, 0x0003, 0xDC, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x00D0, 0x0003, 0xDC, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x00D1, 0x0083, 0xDC, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x00D2, 0x0083, 0xDC, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x002E, 0x0003, 0xDC, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x002F, 0x0003, 0xDC, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0030, 0x0003, 0xDC, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0031, 0x0083, 0xDC, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0032, 0x0083, 0xDC, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0033, 0x0083, 0xDC, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x00D3, 0x0003, 0xDD, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x00D4, 0x0003, 0xDD, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x00D5, 0x0083, 0xDD, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x00D6, 0x0083, 0xDD, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0034, 0x0003, 0xDD, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0035, 0x0003, 0xDD, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0036, 0x0003, 0xDD, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0037, 0x0083, 0xDD, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0038, 0x0083, 0xDD, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0039, 0x0083, 0xDD, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x00D7, 0x0002, 0xDB, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x00D8, 0x0022, 0xDB, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x00D9, 0x0183, 0xDF, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x00DA, 0x01A3, 0xDF, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x003A, 0x1805, 0x03, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x003B, 0x1805, 0x03, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x003C, 0x1805, 0x03, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x003D, 0x1A05, 0x03, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x003E, 0x1A05, 0x03, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x003F, 0x1A05, 0x03, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0011, 0x1805, 0x03, 0xC0, ZYDIS_INSTRUCTION_ENCODING_MVEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0012, 0x1A05, 0x03, 0x00, ZYDIS_INSTRUCTION_ENCODING_MVEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0040, 0x1805, 0x03, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0041, 0x1805, 0x03, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0042, 0x1805, 0x03, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0043, 0x1A05, 0x03, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0044, 0x1A05, 0x03, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0045, 0x1A05, 0x03, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x00DB, 0x0003, 0x55, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x00DC, 0x0003, 0x55, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x00DD, 0x0083, 0x55, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x00DE, 0x0083, 0x55, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0046, 0x0004, 0x55, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0047, 0x0004, 0x55, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0048, 0x0004, 0x55, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0049, 0x0204, 0x55, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x004A, 0x0204, 0x55, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x004B, 0x0204, 0x55, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x00DF, 0x0003, 0x55, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x00E0, 0x0003, 0x55, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x00E1, 0x0083, 0x55, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x00E2, 0x0083, 0x55, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x004C, 0x0004, 0x55, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x004D, 0x0004, 0x55, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x004E, 0x0004, 0x55, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x004F, 0x0204, 0x55, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0050, 0x0204, 0x55, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0051, 0x0204, 0x55, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x00E3, 0x0003, 0x54, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x00E4, 0x0003, 0x54, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x00E5, 0x0083, 0x54, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x00E6, 0x0083, 0x54, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0052, 0x0004, 0x54, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0053, 0x0004, 0x54, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0054, 0x0004, 0x54, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0055, 0x0204, 0x54, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0056, 0x0204, 0x54, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0057, 0x0204, 0x54, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x00E7, 0x0003, 0x54, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x00E8, 0x0003, 0x54, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x00E9, 0x0083, 0x54, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x00EA, 0x0083, 0x54, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0058, 0x0004, 0x54, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0059, 0x0004, 0x54, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x005A, 0x0004, 0x54, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x005B, 0x0204, 0x54, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x005C, 0x0204, 0x54, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x005D, 0x0204, 0x54, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x00EB, 0x0022, 0xB1, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x00EC, 0x0022, 0xB1, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x00ED, 0x0022, 0xB1, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x00EE, 0x0022, 0xB1, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x005E, 0x0004, 0x65, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x005F, 0x0004, 0x65, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0060, 0x0004, 0x65, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0061, 0x0204, 0x65, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0062, 0x0204, 0x65, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0063, 0x0204, 0x65, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0013, 0x0004, 0x65, 0xC0, ZYDIS_INSTRUCTION_ENCODING_MVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_64, ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0014, 0x0004, 0x65, 0xC0, ZYDIS_INSTRUCTION_ENCODING_MVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_64, ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0015, 0x0204, 0x65, 0x00, ZYDIS_INSTRUCTION_ENCODING_MVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_64, ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0064, 0x0004, 0x65, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0065, 0x0004, 0x65, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0066, 0x0004, 0x65, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0067, 0x0204, 0x65, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0068, 0x0204, 0x65, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0069, 0x0204, 0x65, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0016, 0x0004, 0x65, 0xC0, ZYDIS_INSTRUCTION_ENCODING_MVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0017, 0x0004, 0x65, 0xC0, ZYDIS_INSTRUCTION_ENCODING_MVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0018, 0x0204, 0x65, 0x00, ZYDIS_INSTRUCTION_ENCODING_MVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x00EF, 0x0604, 0x0D, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x00F0, 0x0604, 0x0D, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x00F1, 0x0684, 0x0D, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x00F2, 0x0684, 0x0D, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x00F3, 0x0604, 0x0C, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x00F4, 0x0604, 0x0C, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x00F5, 0x0684, 0x0C, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x00F6, 0x0684, 0x0C, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x00F7, 0x0004, 0x4B, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x00F8, 0x0004, 0x4B, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x00F9, 0x0084, 0x4B, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x00FA, 0x0084, 0x4B, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x00FB, 0x0004, 0x4A, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x00FC, 0x0004, 0x4A, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x00FD, 0x0084, 0x4A, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x00FE, 0x0084, 0x4A, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x00FF, 0x0022, 0x1A, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x006A, 0x0003, 0x19, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x006B, 0x0003, 0x19, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x006C, 0x0083, 0x19, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x006D, 0x0083, 0x19, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x006E, 0x0083, 0x1A, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x006F, 0x0083, 0x1A, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0019, 0x0083, 0x1A, 0x00, ZYDIS_INSTRUCTION_ENCODING_MVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0070, 0x0083, 0x1B, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0071, 0x0083, 0x1A, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0072, 0x0083, 0x1A, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0073, 0x0083, 0x1B, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x001A, 0x0083, 0x1B, 0x00, ZYDIS_INSTRUCTION_ENCODING_MVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_64, ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0100, 0x0022, 0x5A, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0074, 0x0003, 0x59, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0075, 0x0003, 0x59, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0076, 0x0003, 0x59, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0077, 0x0083, 0x59, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0078, 0x0083, 0x59, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0079, 0x0083, 0x59, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x007A, 0x0083, 0x5A, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x007B, 0x0083, 0x5A, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x001B, 0x0083, 0x5A, 0x00, ZYDIS_INSTRUCTION_ENCODING_MVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x007C, 0x0083, 0x5B, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x007D, 0x0083, 0x5A, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x007E, 0x0083, 0x5A, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x007F, 0x0083, 0x5B, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x001C, 0x0083, 0x5B, 0x00, ZYDIS_INSTRUCTION_ENCODING_MVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_64, ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0101, 0x0002, 0x19, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0102, 0x0022, 0x19, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0080, 0x0003, 0x19, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0081, 0x0003, 0x19, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0082, 0x0083, 0x19, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0083, 0x0083, 0x19, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x001D, 0x0083, 0x19, 0x00, ZYDIS_INSTRUCTION_ENCODING_MVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_64, ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0103, 0x0002, 0x18, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0104, 0x0002, 0x18, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0105, 0x0022, 0x18, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0106, 0x0022, 0x18, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0084, 0x0003, 0x18, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0085, 0x0003, 0x18, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0086, 0x0003, 0x18, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0087, 0x0083, 0x18, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0088, 0x0083, 0x18, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0089, 0x0083, 0x18, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x001E, 0x0083, 0x18, 0x00, ZYDIS_INSTRUCTION_ENCODING_MVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0107, 0x0604, 0xC2, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0108, 0x0604, 0xC2, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0109, 0x0684, 0xC2, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x010A, 0x0684, 0xC2, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x008A, 0x1805, 0xC2, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x008B, 0x1805, 0xC2, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x008C, 0x1805, 0xC2, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x008D, 0x1805, 0xC2, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x008E, 0x1A05, 0xC2, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x008F, 0x1A05, 0xC2, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0090, 0x1A05, 0xC2, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x001F, 0x1805, 0xC2, 0xC0, ZYDIS_INSTRUCTION_ENCODING_MVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_64, ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0020, 0x1805, 0xC2, 0xC0, ZYDIS_INSTRUCTION_ENCODING_MVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_64, ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0021, 0x1A05, 0xC2, 0x00, ZYDIS_INSTRUCTION_ENCODING_MVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_64, ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0091, 0x1805, 0xC2, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0092, 0x1805, 0xC2, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0093, 0x1805, 0xC2, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0094, 0x1805, 0xC2, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0095, 0x1A05, 0xC2, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0096, 0x1A05, 0xC2, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0097, 0x1A05, 0xC2, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x010B, 0x0604, 0xC2, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x010C, 0x0604, 0xC2, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x010D, 0x0684, 0xC2, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x010E, 0x0684, 0xC2, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0098, 0x1805, 0xC2, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0099, 0x1805, 0xC2, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x009A, 0x1805, 0xC2, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x009B, 0x1805, 0xC2, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x009C, 0x1A05, 0xC2, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x009D, 0x1A05, 0xC2, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x009E, 0x1A05, 0xC2, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0022, 0x1805, 0xC2, 0xC0, ZYDIS_INSTRUCTION_ENCODING_MVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0023, 0x1805, 0xC2, 0xC0, ZYDIS_INSTRUCTION_ENCODING_MVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0024, 0x1A05, 0xC2, 0x00, ZYDIS_INSTRUCTION_ENCODING_MVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x010F, 0x0604, 0xC2, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F2, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0110, 0x0684, 0xC2, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F2, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x009F, 0x1805, 0xC2, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F2, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x00A0, 0x1805, 0xC2, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F2, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x00A1, 0x1A05, 0xC2, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F2, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x00A2, 0x1805, 0xC2, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x00A3, 0x1805, 0xC2, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x00A4, 0x1A05, 0xC2, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0111, 0x0604, 0xC2, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0112, 0x0684, 0xC2, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x00A5, 0x1805, 0xC2, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x00A6, 0x1805, 0xC2, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x00A7, 0x1A05, 0xC2, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0113, 0x0002, 0x2F, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0114, 0x0022, 0x2F, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x00A8, 0x0002, 0x2F, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x00A9, 0x0002, 0x2F, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x00AA, 0x0022, 0x2F, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x00AB, 0x0002, 0x2F, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_MAP5, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x00AC, 0x0002, 0x2F, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_MAP5, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x00AD, 0x0022, 0x2F, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_MAP5, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0115, 0x0002, 0x2F, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0116, 0x0022, 0x2F, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x00AE, 0x0002, 0x2F, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x00AF, 0x0002, 0x2F, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x00B0, 0x0022, 0x2F, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x00B1, 0x0003, 0x8A, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x00B2, 0x0003, 0x8A, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x00B3, 0x0003, 0x8A, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x00B4, 0x000B, 0x8A, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x00B5, 0x000B, 0x8A, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x00B6, 0x000B, 0x8A, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x00B7, 0x0003, 0x8A, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x00B8, 0x0003, 0x8A, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x00B9, 0x0003, 0x8A, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x00BA, 0x000B, 0x8A, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x00BB, 0x000B, 0x8A, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x00BC, 0x000B, 0x8A, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0117, 0x0002, 0xE6, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0118, 0x0002, 0xE6, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0119, 0x0022, 0xE6, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x011A, 0x0022, 0xE6, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x00BD, 0x0003, 0xE6, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x00BE, 0x0003, 0xE6, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x00BF, 0x0003, 0xE6, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x00C0, 0x0003, 0xE6, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x00C1, 0x0083, 0xE6, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x00C2, 0x0083, 0xE6, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x00C3, 0x0083, 0xE6, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0025, 0x0003, 0xE6, 0xC0, ZYDIS_INSTRUCTION_ENCODING_MVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0026, 0x0003, 0xE6, 0xC0, ZYDIS_INSTRUCTION_ENCODING_MVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0027, 0x0083, 0xE6, 0x00, ZYDIS_INSTRUCTION_ENCODING_MVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x00C4, 0x0003, 0x5B, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_MAP5, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x00C5, 0x0003, 0x5B, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_MAP5, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x00C6, 0x0003, 0x5B, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_MAP5, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x00C7, 0x0003, 0x5B, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_MAP5, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x00C8, 0x0083, 0x5B, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_MAP5, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x00C9, 0x0083, 0x5B, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_MAP5, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x00CA, 0x0083, 0x5B, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_MAP5, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x011B, 0x0002, 0x5B, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x011C, 0x0002, 0x5B, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x011D, 0x0022, 0x5B, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x011E, 0x0022, 0x5B, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x00CB, 0x0003, 0x5B, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x00CC, 0x0003, 0x5B, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x00CD, 0x0003, 0x5B, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x00CE, 0x0003, 0x5B, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x00CF, 0x0083, 0x5B, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x00D0, 0x0083, 0x5B, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x00D1, 0x0083, 0x5B, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0028, 0x0604, 0xCB, 0xC0, ZYDIS_INSTRUCTION_ENCODING_MVEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0029, 0x0604, 0xCB, 0xC0, ZYDIS_INSTRUCTION_ENCODING_MVEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x002A, 0x0684, 0xCB, 0x00, ZYDIS_INSTRUCTION_ENCODING_MVEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x002B, 0x0604, 0xE6, 0xC0, ZYDIS_INSTRUCTION_ENCODING_MVEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_64, ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F2, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x002C, 0x0604, 0xE6, 0xC0, ZYDIS_INSTRUCTION_ENCODING_MVEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_64, ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F2, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x002D, 0x0684, 0xE6, 0x00, ZYDIS_INSTRUCTION_ENCODING_MVEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_64, ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F2, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x002E, 0x0604, 0xCA, 0xC0, ZYDIS_INSTRUCTION_ENCODING_MVEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_64, ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F2, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x002F, 0x0604, 0xCA, 0xC0, ZYDIS_INSTRUCTION_ENCODING_MVEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_64, ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F2, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0030, 0x0684, 0xCA, 0x00, ZYDIS_INSTRUCTION_ENCODING_MVEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_64, ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F2, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0031, 0x0604, 0xCB, 0xC0, ZYDIS_INSTRUCTION_ENCODING_MVEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0032, 0x0604, 0xCB, 0xC0, ZYDIS_INSTRUCTION_ENCODING_MVEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0033, 0x0684, 0xCB, 0x00, ZYDIS_INSTRUCTION_ENCODING_MVEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0034, 0x0604, 0xCA, 0xC0, ZYDIS_INSTRUCTION_ENCODING_MVEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0035, 0x0604, 0xCA, 0xC0, ZYDIS_INSTRUCTION_ENCODING_MVEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0036, 0x0684, 0xCA, 0x00, ZYDIS_INSTRUCTION_ENCODING_MVEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0037, 0x0604, 0xCA, 0xC0, ZYDIS_INSTRUCTION_ENCODING_MVEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0038, 0x0604, 0xCA, 0xC0, ZYDIS_INSTRUCTION_ENCODING_MVEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0039, 0x0684, 0xCA, 0x00, ZYDIS_INSTRUCTION_ENCODING_MVEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x00D2, 0x0004, 0x72, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F2, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x00D3, 0x0004, 0x72, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F2, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x00D4, 0x0004, 0x72, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F2, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x00D5, 0x0204, 0x72, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F2, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x00D6, 0x0204, 0x72, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F2, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x00D7, 0x0204, 0x72, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F2, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x011F, 0x0022, 0xB0, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0120, 0x0022, 0xB0, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0121, 0x0022, 0xB0, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0122, 0x0022, 0xB0, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0123, 0x0022, 0xB0, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F2, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0124, 0x0022, 0xB0, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F2, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0125, 0x0022, 0xB0, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0126, 0x0022, 0xB0, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0127, 0x0002, 0x72, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0128, 0x0002, 0x72, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0129, 0x0022, 0x72, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x012A, 0x0022, 0x72, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x00D8, 0x0003, 0x72, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x00D9, 0x0003, 0x72, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x00DA, 0x0003, 0x72, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x00DB, 0x0083, 0x72, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x00DC, 0x0083, 0x72, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x00DD, 0x0083, 0x72, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x012B, 0x0002, 0xE6, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F2, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x012C, 0x0002, 0xE6, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F2, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x012D, 0x0022, 0xE6, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F2, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x012E, 0x0022, 0xE6, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F2, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x00DE, 0x0003, 0xE6, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F2, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x00DF, 0x0003, 0xE6, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F2, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x00E0, 0x0003, 0xE6, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F2, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x00E1, 0x0003, 0xE6, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F2, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x00E2, 0x0083, 0xE6, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F2, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x00E3, 0x0083, 0xE6, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F2, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x00E4, 0x0083, 0xE6, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F2, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x00E5, 0x0003, 0x5A, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_MAP5, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x00E6, 0x0003, 0x5A, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_MAP5, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x00E7, 0x0003, 0x5A, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_MAP5, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x00E8, 0x0003, 0x5A, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_MAP5, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x00E9, 0x0083, 0x5A, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_MAP5, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x00EA, 0x0083, 0x5A, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_MAP5, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x00EB, 0x0083, 0x5A, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_MAP5, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x012F, 0x0002, 0x5A, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0130, 0x0002, 0x5A, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0131, 0x0022, 0x5A, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0132, 0x0022, 0x5A, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x00EC, 0x0003, 0x5A, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x00ED, 0x0003, 0x5A, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x00EE, 0x0003, 0x5A, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x00EF, 0x0003, 0x5A, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x00F0, 0x0083, 0x5A, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x00F1, 0x0083, 0x5A, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x00F2, 0x0083, 0x5A, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x003A, 0x0003, 0x5A, 0xC0, ZYDIS_INSTRUCTION_ENCODING_MVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_64, ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x003B, 0x0003, 0x5A, 0xC0, ZYDIS_INSTRUCTION_ENCODING_MVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_64, ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x003C, 0x0083, 0x5A, 0x00, ZYDIS_INSTRUCTION_ENCODING_MVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_64, ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x00F3, 0x0003, 0x7B, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x00F4, 0x0003, 0x7B, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x00F5, 0x0003, 0x7B, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x00F6, 0x0003, 0x7B, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x00F7, 0x0083, 0x7B, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x00F8, 0x0083, 0x7B, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x00F9, 0x0083, 0x7B, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x00FA, 0x0003, 0x79, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x00FB, 0x0003, 0x79, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x00FC, 0x0003, 0x79, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x00FD, 0x0003, 0x79, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x00FE, 0x0083, 0x79, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x00FF, 0x0083, 0x79, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0100, 0x0083, 0x79, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0101, 0x0003, 0x79, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0102, 0x0003, 0x79, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0103, 0x0003, 0x79, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0104, 0x0003, 0x79, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0105, 0x0083, 0x79, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0106, 0x0083, 0x79, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0107, 0x0083, 0x79, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0108, 0x0003, 0x5B, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_MAP5, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0109, 0x0003, 0x5B, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_MAP5, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x010A, 0x0003, 0x5B, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_MAP5, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x010B, 0x0003, 0x5B, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_MAP5, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x010C, 0x0083, 0x5B, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_MAP5, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x010D, 0x0083, 0x5B, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_MAP5, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x010E, 0x0083, 0x5B, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_MAP5, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x010F, 0x0003, 0x5A, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_MAP5, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0110, 0x0003, 0x5A, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_MAP5, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0111, 0x0003, 0x5A, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_MAP5, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0112, 0x0003, 0x5A, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_MAP5, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0113, 0x0083, 0x5A, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_MAP5, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0114, 0x0083, 0x5A, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_MAP5, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0115, 0x0083, 0x5A, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_MAP5, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0133, 0x0002, 0x13, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0134, 0x0002, 0x13, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0135, 0x0022, 0x13, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0136, 0x0022, 0x13, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0116, 0x0003, 0x13, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0117, 0x0003, 0x13, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0118, 0x0003, 0x13, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0119, 0x0003, 0x13, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x011A, 0x0083, 0x13, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x011B, 0x0083, 0x13, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x011C, 0x0083, 0x13, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x011D, 0x0003, 0x13, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_MAP6, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x011E, 0x0003, 0x13, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_MAP6, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x011F, 0x0003, 0x13, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_MAP6, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0120, 0x0003, 0x13, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_MAP6, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0121, 0x0083, 0x13, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_MAP6, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0122, 0x0083, 0x13, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_MAP6, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0123, 0x0083, 0x13, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_MAP6, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0124, 0x0003, 0x7B, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_MAP5, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0125, 0x0003, 0x7B, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_MAP5, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0126, 0x0003, 0x7B, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_MAP5, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0127, 0x0003, 0x7B, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_MAP5, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0128, 0x0083, 0x7B, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_MAP5, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0129, 0x0083, 0x7B, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_MAP5, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x012A, 0x0083, 0x7B, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_MAP5, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x012B, 0x0003, 0x79, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_MAP5, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x012C, 0x0003, 0x79, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_MAP5, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x012D, 0x0003, 0x79, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_MAP5, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x012E, 0x0003, 0x79, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_MAP5, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x012F, 0x0083, 0x79, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_MAP5, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0130, 0x0083, 0x79, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_MAP5, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0131, 0x0083, 0x79, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_MAP5, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0132, 0x0003, 0x79, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_MAP5, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0133, 0x0003, 0x79, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_MAP5, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0134, 0x0003, 0x79, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_MAP5, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0135, 0x0003, 0x79, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_MAP5, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0136, 0x0083, 0x79, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_MAP5, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0137, 0x0083, 0x79, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_MAP5, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0138, 0x0083, 0x79, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_MAP5, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0139, 0x0003, 0x7D, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_MAP5, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x013A, 0x0003, 0x7D, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_MAP5, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x013B, 0x0003, 0x7D, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_MAP5, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x013C, 0x0003, 0x7D, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_MAP5, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x013D, 0x0083, 0x7D, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_MAP5, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x013E, 0x0083, 0x7D, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_MAP5, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x013F, 0x0083, 0x7D, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_MAP5, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0140, 0x0003, 0x7D, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_MAP5, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0141, 0x0003, 0x7D, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_MAP5, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0142, 0x0003, 0x7D, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_MAP5, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0143, 0x0003, 0x7D, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_MAP5, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0144, 0x0083, 0x7D, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_MAP5, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0145, 0x0083, 0x7D, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_MAP5, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0146, 0x0083, 0x7D, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_MAP5, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0137, 0x0002, 0x5B, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0138, 0x0002, 0x5B, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0139, 0x0022, 0x5B, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x013A, 0x0022, 0x5B, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0147, 0x0003, 0x5B, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0148, 0x0003, 0x5B, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0149, 0x0003, 0x5B, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x014A, 0x0003, 0x5B, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x014B, 0x0083, 0x5B, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x014C, 0x0083, 0x5B, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x014D, 0x0083, 0x5B, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x013B, 0x0002, 0x5A, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x013C, 0x0002, 0x5A, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x013D, 0x0022, 0x5A, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x013E, 0x0022, 0x5A, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x014E, 0x0003, 0x5A, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x014F, 0x0003, 0x5A, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0150, 0x0003, 0x5A, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0151, 0x0003, 0x5A, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0152, 0x0083, 0x5A, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0153, 0x0083, 0x5A, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0154, 0x0083, 0x5A, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x003D, 0x0003, 0x5A, 0xC0, ZYDIS_INSTRUCTION_ENCODING_MVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x003E, 0x0003, 0x5A, 0xC0, ZYDIS_INSTRUCTION_ENCODING_MVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x003F, 0x0083, 0x5A, 0x00, ZYDIS_INSTRUCTION_ENCODING_MVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x013F, 0x0183, 0x1D, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0140, 0x0183, 0x1D, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0141, 0x018B, 0x1D, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0142, 0x018B, 0x1D, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0155, 0x0604, 0x1D, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0156, 0x0604, 0x1D, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0157, 0x0604, 0x1D, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0158, 0x0604, 0x1D, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0159, 0x060C, 0x1D, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x015A, 0x060C, 0x1D, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x015B, 0x060C, 0x1D, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x015C, 0x0003, 0x1D, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_MAP5, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x015D, 0x0003, 0x1D, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_MAP5, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x015E, 0x0003, 0x1D, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_MAP5, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x015F, 0x0003, 0x1D, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_MAP5, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0160, 0x0083, 0x1D, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_MAP5, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0161, 0x0083, 0x1D, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_MAP5, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0162, 0x0083, 0x1D, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_MAP5, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0163, 0x0003, 0x7B, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0164, 0x0003, 0x7B, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0165, 0x0003, 0x7B, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0166, 0x0003, 0x7B, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0167, 0x0083, 0x7B, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0168, 0x0083, 0x7B, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0169, 0x0083, 0x7B, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x016A, 0x0003, 0x79, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x016B, 0x0003, 0x79, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x016C, 0x0003, 0x79, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x016D, 0x0003, 0x79, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x016E, 0x0083, 0x79, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x016F, 0x0083, 0x79, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0170, 0x0083, 0x79, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0171, 0x0003, 0x79, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0172, 0x0003, 0x79, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0173, 0x0003, 0x79, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0174, 0x0003, 0x79, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0175, 0x0083, 0x79, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0176, 0x0083, 0x79, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0177, 0x0083, 0x79, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0178, 0x0003, 0xE6, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0179, 0x0003, 0xE6, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x017A, 0x0003, 0xE6, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x017B, 0x0003, 0xE6, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x017C, 0x0083, 0xE6, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x017D, 0x0083, 0xE6, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x017E, 0x0083, 0xE6, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x017F, 0x0003, 0x5B, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_MAP5, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0180, 0x0003, 0x5B, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_MAP5, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0181, 0x0003, 0x5B, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_MAP5, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0182, 0x0003, 0x5B, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_MAP5, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0183, 0x0083, 0x5B, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_MAP5, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0184, 0x0083, 0x5B, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_MAP5, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0185, 0x0083, 0x5B, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_MAP5, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0186, 0x0003, 0x5B, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0187, 0x0003, 0x5B, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0188, 0x0003, 0x5B, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0189, 0x0003, 0x5B, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x018A, 0x0083, 0x5B, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x018B, 0x0083, 0x5B, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x018C, 0x0083, 0x5B, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x018D, 0x0004, 0x5A, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_MAP5, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F2, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x018E, 0x0004, 0x5A, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_MAP5, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F2, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x018F, 0x0204, 0x5A, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_MAP5, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F2, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0143, 0x0002, 0x2D, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_64, ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F2, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0145, 0x0022, 0x2D, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_64, ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F2, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0147, 0x0002, 0x2D, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F2, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0148, 0x0022, 0x2D, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F2, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0144, 0x0002, 0x2D, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_64, ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F2, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0146, 0x0022, 0x2D, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_64, ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F2, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0190, 0x0002, 0x2D, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F2, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0191, 0x0002, 0x2D, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F2, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0192, 0x0022, 0x2D, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F2, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0193, 0x0002, 0x2D, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_64, ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F2, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0194, 0x0002, 0x2D, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_64, ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F2, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0195, 0x0022, 0x2D, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_64, ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F2, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0196, 0x0002, 0x2D, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F2, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0197, 0x0002, 0x2D, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F2, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0198, 0x0022, 0x2D, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F2, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0149, 0x0003, 0x5A, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F2, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x014A, 0x0083, 0x5A, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F2, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0199, 0x0004, 0x5A, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F2, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x019A, 0x0004, 0x5A, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F2, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x019B, 0x0204, 0x5A, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F2, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x019C, 0x0002, 0x79, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F2, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x019D, 0x0002, 0x79, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F2, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x019E, 0x0022, 0x79, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F2, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x019F, 0x0002, 0x79, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_64, ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F2, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x01A0, 0x0002, 0x79, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_64, ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F2, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x01A1, 0x0022, 0x79, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_64, ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F2, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x01A2, 0x0002, 0x79, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F2, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x01A3, 0x0002, 0x79, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F2, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x01A4, 0x0022, 0x79, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F2, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x01A5, 0x0004, 0x5A, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_MAP5, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x01A6, 0x0004, 0x5A, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_MAP5, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x01A7, 0x0204, 0x5A, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_MAP5, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x01A8, 0x0002, 0x2D, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_MAP5, ZYDIS_WIDTH_64, ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x01A9, 0x0002, 0x2D, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_MAP5, ZYDIS_WIDTH_64, ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x01AA, 0x0002, 0x2D, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_MAP5, ZYDIS_WIDTH_64, ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x01AB, 0x0002, 0x2D, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_MAP5, ZYDIS_WIDTH_64, ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x01AC, 0x0022, 0x2D, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_MAP5, ZYDIS_WIDTH_64, ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x01AD, 0x0022, 0x2D, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_MAP5, ZYDIS_WIDTH_64, ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x01AE, 0x0002, 0x2D, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_MAP5, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x01AF, 0x0002, 0x2D, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_MAP5, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x01B0, 0x0022, 0x2D, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_MAP5, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x01B1, 0x0004, 0x13, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_MAP6, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x01B2, 0x0004, 0x13, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_MAP6, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x01B3, 0x0204, 0x13, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_MAP6, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x01B4, 0x0002, 0x79, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_MAP5, ZYDIS_WIDTH_64, ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x01B5, 0x0002, 0x79, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_MAP5, ZYDIS_WIDTH_64, ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x01B6, 0x0002, 0x79, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_MAP5, ZYDIS_WIDTH_64, ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x01B7, 0x0002, 0x79, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_MAP5, ZYDIS_WIDTH_64, ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x01B8, 0x0022, 0x79, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_MAP5, ZYDIS_WIDTH_64, ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x01B9, 0x0022, 0x79, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_MAP5, ZYDIS_WIDTH_64, ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x01BA, 0x0002, 0x79, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_MAP5, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x01BB, 0x0002, 0x79, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_MAP5, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x01BC, 0x0022, 0x79, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_MAP5, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x014B, 0x0003, 0x2A, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_64, ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F2, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x014D, 0x0083, 0x2A, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_64, ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F2, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x014F, 0x0003, 0x2A, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F2, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0150, 0x0083, 0x2A, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F2, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x014C, 0x0003, 0x2A, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_64, ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F2, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x014E, 0x0083, 0x2A, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_64, ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F2, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x01BD, 0x0003, 0x2A, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F2, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x01BE, 0x0083, 0x2A, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F2, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x01BF, 0x0003, 0x2A, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_64, ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F2, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x01C0, 0x0003, 0x2A, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_64, ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F2, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x01C1, 0x0083, 0x2A, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_64, ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F2, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x01C2, 0x0003, 0x2A, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F2, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x01C3, 0x0083, 0x2A, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F2, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x01C4, 0x0003, 0x2A, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_MAP5, ZYDIS_WIDTH_64, ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x01C5, 0x0003, 0x2A, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_MAP5, ZYDIS_WIDTH_64, ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x01C6, 0x0003, 0x2A, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_MAP5, ZYDIS_WIDTH_64, ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x01C7, 0x0003, 0x2A, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_MAP5, ZYDIS_WIDTH_64, ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x01C8, 0x0083, 0x2A, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_MAP5, ZYDIS_WIDTH_64, ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x01C9, 0x0083, 0x2A, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_MAP5, ZYDIS_WIDTH_64, ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x01CA, 0x0003, 0x2A, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_MAP5, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x01CB, 0x0003, 0x2A, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_MAP5, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x01CC, 0x0083, 0x2A, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_MAP5, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0151, 0x0003, 0x2A, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_64, ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0153, 0x0083, 0x2A, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_64, ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0155, 0x0003, 0x2A, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0156, 0x0083, 0x2A, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0152, 0x0003, 0x2A, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_64, ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0154, 0x0083, 0x2A, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_64, ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x01CD, 0x0003, 0x2A, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x01CE, 0x0003, 0x2A, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x01CF, 0x0083, 0x2A, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x01D0, 0x0003, 0x2A, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_64, ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x01D1, 0x0003, 0x2A, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_64, ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x01D2, 0x0083, 0x2A, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_64, ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x01D3, 0x0003, 0x2A, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x01D4, 0x0003, 0x2A, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x01D5, 0x0083, 0x2A, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0157, 0x0003, 0x5A, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0158, 0x0083, 0x5A, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x01D6, 0x0004, 0x5A, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x01D7, 0x0004, 0x5A, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x01D8, 0x0204, 0x5A, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x01D9, 0x0004, 0x1D, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_MAP5, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x01DA, 0x0004, 0x1D, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_MAP5, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x01DB, 0x0204, 0x1D, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_MAP5, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0159, 0x0002, 0x2D, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_64, ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x015B, 0x0022, 0x2D, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_64, ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x015D, 0x0002, 0x2D, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x015E, 0x0022, 0x2D, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x015A, 0x0002, 0x2D, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_64, ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x015C, 0x0022, 0x2D, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_64, ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x01DC, 0x0002, 0x2D, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x01DD, 0x0002, 0x2D, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x01DE, 0x0022, 0x2D, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x01DF, 0x0002, 0x2D, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_64, ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x01E0, 0x0002, 0x2D, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_64, ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x01E1, 0x0022, 0x2D, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_64, ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x01E2, 0x0002, 0x2D, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x01E3, 0x0002, 0x2D, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x01E4, 0x0022, 0x2D, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x01E5, 0x0002, 0x79, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x01E6, 0x0002, 0x79, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x01E7, 0x0022, 0x79, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x01E8, 0x0002, 0x79, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_64, ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x01E9, 0x0002, 0x79, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_64, ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x01EA, 0x0022, 0x79, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_64, ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x01EB, 0x0002, 0x79, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x01EC, 0x0002, 0x79, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x01ED, 0x0022, 0x79, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x015F, 0x0002, 0xE6, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0160, 0x0002, 0xE6, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0161, 0x0022, 0xE6, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0162, 0x0022, 0xE6, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x01EE, 0x0003, 0xE6, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x01EF, 0x0003, 0xE6, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x01F0, 0x0003, 0xE6, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x01F1, 0x0003, 0xE6, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x01F2, 0x0083, 0xE6, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x01F3, 0x0083, 0xE6, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x01F4, 0x0083, 0xE6, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x01F5, 0x0003, 0x7A, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x01F6, 0x0003, 0x7A, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x01F7, 0x0003, 0x7A, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x01F8, 0x0003, 0x7A, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x01F9, 0x0083, 0x7A, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x01FA, 0x0083, 0x7A, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x01FB, 0x0083, 0x7A, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x01FC, 0x0003, 0x78, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x01FD, 0x0003, 0x78, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x01FE, 0x0003, 0x78, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x01FF, 0x0003, 0x78, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0200, 0x0083, 0x78, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0201, 0x0083, 0x78, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0202, 0x0083, 0x78, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0203, 0x0003, 0x78, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0204, 0x0003, 0x78, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0205, 0x0003, 0x78, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0206, 0x0003, 0x78, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0207, 0x0083, 0x78, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0208, 0x0083, 0x78, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0209, 0x0083, 0x78, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x020A, 0x0003, 0x5B, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_MAP5, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x020B, 0x0003, 0x5B, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_MAP5, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x020C, 0x0003, 0x5B, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_MAP5, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x020D, 0x0003, 0x5B, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_MAP5, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x020E, 0x0083, 0x5B, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_MAP5, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x020F, 0x0083, 0x5B, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_MAP5, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0210, 0x0083, 0x5B, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_MAP5, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0211, 0x0003, 0x7A, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_MAP5, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0212, 0x0003, 0x7A, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_MAP5, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0213, 0x0003, 0x7A, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_MAP5, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0214, 0x0003, 0x7A, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_MAP5, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0215, 0x0083, 0x7A, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_MAP5, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0216, 0x0083, 0x7A, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_MAP5, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0217, 0x0083, 0x7A, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_MAP5, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0218, 0x0003, 0x78, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_MAP5, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0219, 0x0003, 0x78, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_MAP5, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x021A, 0x0003, 0x78, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_MAP5, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x021B, 0x0003, 0x78, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_MAP5, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x021C, 0x0083, 0x78, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_MAP5, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x021D, 0x0083, 0x78, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_MAP5, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x021E, 0x0083, 0x78, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_MAP5, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x021F, 0x0003, 0x78, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_MAP5, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0220, 0x0003, 0x78, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_MAP5, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0221, 0x0003, 0x78, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_MAP5, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0222, 0x0003, 0x78, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_MAP5, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0223, 0x0083, 0x78, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_MAP5, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0224, 0x0083, 0x78, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_MAP5, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0225, 0x0083, 0x78, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_MAP5, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0226, 0x0003, 0x7C, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_MAP5, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0227, 0x0003, 0x7C, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_MAP5, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0228, 0x0003, 0x7C, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_MAP5, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0229, 0x0003, 0x7C, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_MAP5, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x022A, 0x0083, 0x7C, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_MAP5, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x022B, 0x0083, 0x7C, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_MAP5, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x022C, 0x0083, 0x7C, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_MAP5, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x022D, 0x0003, 0x7C, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_MAP5, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x022E, 0x0003, 0x7C, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_MAP5, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x022F, 0x0003, 0x7C, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_MAP5, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0230, 0x0003, 0x7C, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_MAP5, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0231, 0x0083, 0x7C, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_MAP5, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0232, 0x0083, 0x7C, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_MAP5, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0233, 0x0083, 0x7C, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_MAP5, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0163, 0x0002, 0x5B, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0164, 0x0002, 0x5B, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0165, 0x0022, 0x5B, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0166, 0x0022, 0x5B, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0234, 0x0003, 0x5B, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0235, 0x0003, 0x5B, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0236, 0x0003, 0x5B, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0237, 0x0003, 0x5B, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0238, 0x0083, 0x5B, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0239, 0x0083, 0x5B, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x023A, 0x0083, 0x5B, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x023B, 0x0003, 0x7A, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x023C, 0x0003, 0x7A, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x023D, 0x0003, 0x7A, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x023E, 0x0003, 0x7A, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x023F, 0x0083, 0x7A, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0240, 0x0083, 0x7A, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0241, 0x0083, 0x7A, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0242, 0x0003, 0x78, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0243, 0x0003, 0x78, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0244, 0x0003, 0x78, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0245, 0x0003, 0x78, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0246, 0x0083, 0x78, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0247, 0x0083, 0x78, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0248, 0x0083, 0x78, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0249, 0x0003, 0x78, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x024A, 0x0003, 0x78, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x024B, 0x0003, 0x78, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x024C, 0x0003, 0x78, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x024D, 0x0083, 0x78, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x024E, 0x0083, 0x78, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x024F, 0x0083, 0x78, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0167, 0x0002, 0x2C, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_64, ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F2, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0169, 0x0022, 0x2C, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_64, ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F2, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x016B, 0x0002, 0x2C, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F2, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x016C, 0x0022, 0x2C, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F2, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0168, 0x0002, 0x2C, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_64, ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F2, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x016A, 0x0022, 0x2C, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_64, ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F2, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0250, 0x0002, 0x2C, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F2, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0251, 0x0002, 0x2C, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F2, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0252, 0x0022, 0x2C, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F2, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0253, 0x0002, 0x2C, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_64, ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F2, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0254, 0x0002, 0x2C, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_64, ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F2, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0255, 0x0022, 0x2C, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_64, ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F2, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0256, 0x0002, 0x2C, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F2, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0257, 0x0002, 0x2C, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F2, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0258, 0x0022, 0x2C, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F2, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0259, 0x0002, 0x78, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F2, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x025A, 0x0002, 0x78, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F2, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x025B, 0x0022, 0x78, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F2, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x025C, 0x0002, 0x78, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_64, ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F2, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x025D, 0x0002, 0x78, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_64, ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F2, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x025E, 0x0022, 0x78, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_64, ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F2, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x025F, 0x0002, 0x78, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F2, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0260, 0x0002, 0x78, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F2, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0261, 0x0022, 0x78, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F2, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0262, 0x0002, 0x2C, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_MAP5, ZYDIS_WIDTH_64, ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0263, 0x0002, 0x2C, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_MAP5, ZYDIS_WIDTH_64, ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0264, 0x0002, 0x2C, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_MAP5, ZYDIS_WIDTH_64, ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0265, 0x0002, 0x2C, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_MAP5, ZYDIS_WIDTH_64, ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0266, 0x0022, 0x2C, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_MAP5, ZYDIS_WIDTH_64, ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0267, 0x0022, 0x2C, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_MAP5, ZYDIS_WIDTH_64, ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0268, 0x0002, 0x2C, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_MAP5, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0269, 0x0002, 0x2C, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_MAP5, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x026A, 0x0022, 0x2C, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_MAP5, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x026B, 0x0002, 0x78, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_MAP5, ZYDIS_WIDTH_64, ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x026C, 0x0002, 0x78, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_MAP5, ZYDIS_WIDTH_64, ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x026D, 0x0002, 0x78, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_MAP5, ZYDIS_WIDTH_64, ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x026E, 0x0002, 0x78, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_MAP5, ZYDIS_WIDTH_64, ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x026F, 0x0022, 0x78, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_MAP5, ZYDIS_WIDTH_64, ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0270, 0x0022, 0x78, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_MAP5, ZYDIS_WIDTH_64, ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0271, 0x0002, 0x78, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_MAP5, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0272, 0x0002, 0x78, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_MAP5, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0273, 0x0022, 0x78, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_MAP5, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x016D, 0x0002, 0x2C, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_64, ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x016F, 0x0022, 0x2C, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_64, ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0171, 0x0002, 0x2C, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0172, 0x0022, 0x2C, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x016E, 0x0002, 0x2C, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_64, ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0170, 0x0022, 0x2C, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_64, ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0274, 0x0002, 0x2C, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0275, 0x0002, 0x2C, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0276, 0x0022, 0x2C, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0277, 0x0002, 0x2C, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_64, ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0278, 0x0002, 0x2C, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_64, ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0279, 0x0022, 0x2C, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_64, ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x027A, 0x0002, 0x2C, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x027B, 0x0002, 0x2C, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x027C, 0x0022, 0x2C, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x027D, 0x0002, 0x78, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x027E, 0x0002, 0x78, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x027F, 0x0022, 0x78, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0280, 0x0002, 0x78, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_64, ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0281, 0x0002, 0x78, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_64, ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0282, 0x0022, 0x78, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_64, ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0283, 0x0002, 0x78, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0284, 0x0002, 0x78, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0285, 0x0022, 0x78, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0286, 0x0003, 0x7A, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0287, 0x0003, 0x7A, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0288, 0x0003, 0x7A, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0289, 0x0003, 0x7A, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x028A, 0x0083, 0x7A, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x028B, 0x0083, 0x7A, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x028C, 0x0083, 0x7A, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0040, 0x0003, 0x7A, 0xC0, ZYDIS_INSTRUCTION_ENCODING_MVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0041, 0x0003, 0x7A, 0xC0, ZYDIS_INSTRUCTION_ENCODING_MVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0042, 0x0083, 0x7A, 0x00, ZYDIS_INSTRUCTION_ENCODING_MVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x028D, 0x0003, 0x7A, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_MAP5, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F2, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x028E, 0x0003, 0x7A, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_MAP5, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F2, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x028F, 0x0003, 0x7A, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_MAP5, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F2, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0290, 0x0003, 0x7A, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_MAP5, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F2, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0291, 0x0083, 0x7A, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_MAP5, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F2, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0292, 0x0083, 0x7A, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_MAP5, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F2, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0293, 0x0083, 0x7A, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_MAP5, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F2, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0294, 0x0003, 0x7A, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F2, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0295, 0x0003, 0x7A, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F2, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0296, 0x0003, 0x7A, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F2, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0297, 0x0003, 0x7A, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F2, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0298, 0x0083, 0x7A, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F2, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0299, 0x0083, 0x7A, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F2, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x029A, 0x0083, 0x7A, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F2, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x029B, 0x0003, 0x7A, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x029C, 0x0003, 0x7A, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x029D, 0x0003, 0x7A, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x029E, 0x0003, 0x7A, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x029F, 0x0083, 0x7A, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x02A0, 0x0083, 0x7A, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x02A1, 0x0083, 0x7A, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x02A2, 0x0003, 0x7A, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_MAP5, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F2, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x02A3, 0x0003, 0x7A, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_MAP5, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F2, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x02A4, 0x0003, 0x7A, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_MAP5, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F2, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x02A5, 0x0003, 0x7A, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_MAP5, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F2, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x02A6, 0x0083, 0x7A, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_MAP5, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F2, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x02A7, 0x0083, 0x7A, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_MAP5, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F2, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x02A8, 0x0083, 0x7A, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_MAP5, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F2, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x02A9, 0x0003, 0x7A, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F2, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x02AA, 0x0003, 0x7A, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F2, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x02AB, 0x0003, 0x7A, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F2, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x02AC, 0x0003, 0x7A, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F2, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x02AD, 0x0083, 0x7A, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F2, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x02AE, 0x0083, 0x7A, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F2, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x02AF, 0x0083, 0x7A, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F2, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x02B0, 0x0003, 0x7B, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F2, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x02B1, 0x0083, 0x7B, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F2, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x02B2, 0x0003, 0x7B, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_64, ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F2, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x02B3, 0x0003, 0x7B, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_64, ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F2, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x02B4, 0x0083, 0x7B, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_64, ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F2, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x02B5, 0x0003, 0x7B, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F2, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x02B6, 0x0083, 0x7B, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F2, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x02B7, 0x0003, 0x7B, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_MAP5, ZYDIS_WIDTH_64, ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x02B8, 0x0003, 0x7B, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_MAP5, ZYDIS_WIDTH_64, ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x02B9, 0x0003, 0x7B, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_MAP5, ZYDIS_WIDTH_64, ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x02BA, 0x0003, 0x7B, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_MAP5, ZYDIS_WIDTH_64, ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x02BB, 0x0083, 0x7B, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_MAP5, ZYDIS_WIDTH_64, ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x02BC, 0x0083, 0x7B, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_MAP5, ZYDIS_WIDTH_64, ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x02BD, 0x0003, 0x7B, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_MAP5, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x02BE, 0x0003, 0x7B, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_MAP5, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x02BF, 0x0083, 0x7B, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_MAP5, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x02C0, 0x0003, 0x7B, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x02C1, 0x0003, 0x7B, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x02C2, 0x0083, 0x7B, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x02C3, 0x0003, 0x7B, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_64, ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x02C4, 0x0003, 0x7B, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_64, ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x02C5, 0x0083, 0x7B, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_64, ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x02C6, 0x0003, 0x7B, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x02C7, 0x0003, 0x7B, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x02C8, 0x0083, 0x7B, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x02C9, 0x0003, 0x7D, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_MAP5, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F2, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x02CA, 0x0003, 0x7D, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_MAP5, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F2, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x02CB, 0x0003, 0x7D, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_MAP5, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F2, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x02CC, 0x0003, 0x7D, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_MAP5, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F2, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x02CD, 0x0083, 0x7D, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_MAP5, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F2, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x02CE, 0x0083, 0x7D, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_MAP5, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F2, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x02CF, 0x0083, 0x7D, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_MAP5, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F2, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x02D0, 0x0003, 0x7D, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_MAP5, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x02D1, 0x0003, 0x7D, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_MAP5, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x02D2, 0x0003, 0x7D, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_MAP5, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x02D3, 0x0003, 0x7D, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_MAP5, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x02D4, 0x0083, 0x7D, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_MAP5, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x02D5, 0x0083, 0x7D, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_MAP5, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x02D6, 0x0083, 0x7D, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_MAP5, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x02D7, 0x1805, 0x42, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x02D8, 0x1805, 0x42, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x02D9, 0x1805, 0x42, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x02DA, 0x1A05, 0x42, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x02DB, 0x1A05, 0x42, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x02DC, 0x1A05, 0x42, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0173, 0x0003, 0x5E, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0174, 0x0003, 0x5E, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0175, 0x0083, 0x5E, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0176, 0x0083, 0x5E, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x02DD, 0x0004, 0x5E, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x02DE, 0x0004, 0x5E, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x02DF, 0x0004, 0x5E, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x02E0, 0x0004, 0x5E, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x02E1, 0x0204, 0x5E, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x02E2, 0x0204, 0x5E, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x02E3, 0x0204, 0x5E, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x02E4, 0x0004, 0x5E, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_MAP5, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x02E5, 0x0004, 0x5E, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_MAP5, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x02E6, 0x0004, 0x5E, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_MAP5, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x02E7, 0x0004, 0x5E, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_MAP5, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x02E8, 0x0204, 0x5E, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_MAP5, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x02E9, 0x0204, 0x5E, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_MAP5, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x02EA, 0x0204, 0x5E, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_MAP5, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0177, 0x0003, 0x5E, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0178, 0x0003, 0x5E, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0179, 0x0083, 0x5E, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x017A, 0x0083, 0x5E, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x02EB, 0x0004, 0x5E, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x02EC, 0x0004, 0x5E, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x02ED, 0x0004, 0x5E, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x02EE, 0x0004, 0x5E, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x02EF, 0x0204, 0x5E, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x02F0, 0x0204, 0x5E, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x02F1, 0x0204, 0x5E, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x017B, 0x0003, 0x5E, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F2, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x017C, 0x0083, 0x5E, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F2, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x02F2, 0x0004, 0x5E, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F2, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x02F3, 0x0004, 0x5E, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F2, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x02F4, 0x0204, 0x5E, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F2, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x02F5, 0x0004, 0x5E, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_MAP5, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x02F6, 0x0004, 0x5E, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_MAP5, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x02F7, 0x0204, 0x5E, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_MAP5, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x017D, 0x0003, 0x5E, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x017E, 0x0083, 0x5E, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x02F8, 0x0004, 0x5E, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x02F9, 0x0004, 0x5E, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x02FA, 0x0204, 0x5E, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x02FB, 0x0004, 0x52, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x02FC, 0x0004, 0x52, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x02FD, 0x0004, 0x52, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x02FE, 0x0204, 0x52, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x02FF, 0x0204, 0x52, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0300, 0x0204, 0x52, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x017F, 0x0604, 0x41, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0180, 0x0684, 0x41, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0181, 0x0604, 0x40, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0182, 0x0604, 0x40, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0183, 0x0684, 0x40, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0184, 0x0684, 0x40, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x073C, 0x0001, 0x00, 0xE0, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x073D, 0x0009, 0x00, 0x20, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x073E, 0x0001, 0x00, 0xE8, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x073F, 0x0009, 0x00, 0x28, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0043, 0x0003, 0xC8, 0xC0, ZYDIS_INSTRUCTION_ENCODING_MVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0044, 0x0003, 0xC8, 0xC0, ZYDIS_INSTRUCTION_ENCODING_MVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0045, 0x0083, 0xC8, 0x00, ZYDIS_INSTRUCTION_ENCODING_MVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0301, 0x0003, 0xC8, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0302, 0x0003, 0xC8, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0303, 0x0083, 0xC8, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0304, 0x0003, 0xC8, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0305, 0x0003, 0xC8, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0306, 0x0083, 0xC8, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0307, 0x0003, 0x88, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0308, 0x0003, 0x88, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0309, 0x0003, 0x88, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x030A, 0x0083, 0x88, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x030B, 0x0083, 0x88, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x030C, 0x0083, 0x88, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x030D, 0x0003, 0x88, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x030E, 0x0003, 0x88, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x030F, 0x0003, 0x88, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0310, 0x0083, 0x88, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0311, 0x0083, 0x88, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0312, 0x0083, 0x88, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0185, 0x0183, 0x19, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0186, 0x018B, 0x19, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0313, 0x0604, 0x19, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0314, 0x0604, 0x19, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0315, 0x060C, 0x19, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0316, 0x060C, 0x19, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0317, 0x0604, 0x1B, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0318, 0x060C, 0x1B, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0319, 0x0604, 0x19, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x031A, 0x0604, 0x19, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x031B, 0x060C, 0x19, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x031C, 0x060C, 0x19, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x031D, 0x0604, 0x1B, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x031E, 0x060C, 0x1B, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0187, 0x0183, 0x39, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0188, 0x018B, 0x39, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x031F, 0x0604, 0x39, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0320, 0x0604, 0x39, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0321, 0x060C, 0x39, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0322, 0x060C, 0x39, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0323, 0x0604, 0x3B, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0324, 0x060C, 0x3B, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0325, 0x0604, 0x39, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0326, 0x0604, 0x39, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0327, 0x060C, 0x39, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0328, 0x060C, 0x39, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0329, 0x0604, 0x3B, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x032A, 0x060C, 0x3B, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0189, 0x0183, 0x17, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x018A, 0x018B, 0x17, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x032B, 0x0183, 0x17, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x032C, 0x018B, 0x17, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x032D, 0x0004, 0x56, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_MAP6, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F2, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x032E, 0x0004, 0x56, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_MAP6, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F2, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x032F, 0x0004, 0x56, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_MAP6, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F2, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0330, 0x0004, 0x56, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_MAP6, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F2, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0331, 0x0204, 0x56, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_MAP6, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F2, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0332, 0x0204, 0x56, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_MAP6, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F2, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0333, 0x0204, 0x56, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_MAP6, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F2, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0334, 0x0004, 0x57, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_MAP6, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F2, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0335, 0x0004, 0x57, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_MAP6, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F2, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0336, 0x0204, 0x57, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_MAP6, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F2, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0337, 0x0004, 0xD6, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_MAP6, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F2, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0338, 0x0004, 0xD6, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_MAP6, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F2, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0339, 0x0004, 0xD6, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_MAP6, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F2, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x033A, 0x0004, 0xD6, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_MAP6, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F2, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x033B, 0x0204, 0xD6, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_MAP6, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F2, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x033C, 0x0204, 0xD6, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_MAP6, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F2, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x033D, 0x0204, 0xD6, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_MAP6, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F2, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x033E, 0x0004, 0xD7, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_MAP6, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F2, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x033F, 0x0004, 0xD7, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_MAP6, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F2, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0340, 0x0204, 0xD7, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_MAP6, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F2, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0341, 0x1805, 0x54, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0342, 0x1805, 0x54, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0343, 0x1805, 0x54, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0344, 0x1805, 0x54, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0345, 0x1A05, 0x54, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0346, 0x1A05, 0x54, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0347, 0x1A05, 0x54, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0348, 0x1805, 0x54, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0349, 0x1805, 0x54, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x034A, 0x1805, 0x54, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x034B, 0x1805, 0x54, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x034C, 0x1A05, 0x54, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x034D, 0x1A05, 0x54, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x034E, 0x1A05, 0x54, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x034F, 0x1805, 0x55, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0350, 0x1805, 0x55, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0351, 0x1A05, 0x55, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0352, 0x1805, 0x55, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0353, 0x1805, 0x55, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0354, 0x1A05, 0x55, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0046, 0x0004, 0x55, 0xC0, ZYDIS_INSTRUCTION_ENCODING_MVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_64, ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0047, 0x0004, 0x55, 0xC0, ZYDIS_INSTRUCTION_ENCODING_MVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_64, ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0048, 0x0204, 0x55, 0x00, ZYDIS_INSTRUCTION_ENCODING_MVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_64, ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0049, 0x0004, 0x55, 0xC0, ZYDIS_INSTRUCTION_ENCODING_MVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x004A, 0x0004, 0x55, 0xC0, ZYDIS_INSTRUCTION_ENCODING_MVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x004B, 0x0204, 0x55, 0x00, ZYDIS_INSTRUCTION_ENCODING_MVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x018B, 0x0003, 0x98, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x018C, 0x0003, 0x98, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x018D, 0x0083, 0x98, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x018E, 0x0083, 0x98, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0355, 0x0004, 0x98, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0356, 0x0004, 0x98, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0357, 0x0004, 0x98, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0358, 0x0004, 0x98, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0359, 0x0204, 0x98, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x035A, 0x0204, 0x98, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x035B, 0x0204, 0x98, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x004C, 0x0004, 0x98, 0xC0, ZYDIS_INSTRUCTION_ENCODING_MVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_64, ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x004D, 0x0004, 0x98, 0xC0, ZYDIS_INSTRUCTION_ENCODING_MVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_64, ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x004E, 0x0204, 0x98, 0x00, ZYDIS_INSTRUCTION_ENCODING_MVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_64, ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x035C, 0x0004, 0x98, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_MAP6, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x035D, 0x0004, 0x98, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_MAP6, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x035E, 0x0004, 0x98, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_MAP6, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x035F, 0x0004, 0x98, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_MAP6, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0360, 0x0204, 0x98, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_MAP6, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0361, 0x0204, 0x98, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_MAP6, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0362, 0x0204, 0x98, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_MAP6, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x018F, 0x0003, 0x98, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0190, 0x0003, 0x98, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0191, 0x0083, 0x98, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0192, 0x0083, 0x98, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0363, 0x0004, 0x98, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0364, 0x0004, 0x98, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0365, 0x0004, 0x98, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0366, 0x0004, 0x98, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0367, 0x0204, 0x98, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0368, 0x0204, 0x98, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0369, 0x0204, 0x98, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x004F, 0x0004, 0x98, 0xC0, ZYDIS_INSTRUCTION_ENCODING_MVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0050, 0x0004, 0x98, 0xC0, ZYDIS_INSTRUCTION_ENCODING_MVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0051, 0x0204, 0x98, 0x00, ZYDIS_INSTRUCTION_ENCODING_MVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0193, 0x0003, 0x99, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0194, 0x0083, 0x99, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x036A, 0x0004, 0x99, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x036B, 0x0004, 0x99, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x036C, 0x0204, 0x99, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x036D, 0x0004, 0x99, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_MAP6, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x036E, 0x0004, 0x99, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_MAP6, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x036F, 0x0204, 0x99, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_MAP6, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0195, 0x0003, 0x99, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0196, 0x0083, 0x99, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0370, 0x0004, 0x99, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0371, 0x0004, 0x99, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0372, 0x0204, 0x99, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0197, 0x0003, 0xA8, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0198, 0x0003, 0xA8, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0199, 0x0083, 0xA8, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x019A, 0x0083, 0xA8, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0373, 0x0004, 0xA8, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0374, 0x0004, 0xA8, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0375, 0x0004, 0xA8, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0376, 0x0004, 0xA8, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0377, 0x0204, 0xA8, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0378, 0x0204, 0xA8, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0379, 0x0204, 0xA8, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0052, 0x0004, 0xA8, 0xC0, ZYDIS_INSTRUCTION_ENCODING_MVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_64, ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0053, 0x0004, 0xA8, 0xC0, ZYDIS_INSTRUCTION_ENCODING_MVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_64, ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0054, 0x0204, 0xA8, 0x00, ZYDIS_INSTRUCTION_ENCODING_MVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_64, ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x037A, 0x0004, 0xA8, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_MAP6, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x037B, 0x0004, 0xA8, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_MAP6, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x037C, 0x0004, 0xA8, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_MAP6, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x037D, 0x0004, 0xA8, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_MAP6, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x037E, 0x0204, 0xA8, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_MAP6, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x037F, 0x0204, 0xA8, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_MAP6, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0380, 0x0204, 0xA8, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_MAP6, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x019B, 0x0003, 0xA8, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x019C, 0x0003, 0xA8, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x019D, 0x0083, 0xA8, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x019E, 0x0083, 0xA8, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0381, 0x0004, 0xA8, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0382, 0x0004, 0xA8, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0383, 0x0004, 0xA8, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0384, 0x0004, 0xA8, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0385, 0x0204, 0xA8, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0386, 0x0204, 0xA8, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0387, 0x0204, 0xA8, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0055, 0x0004, 0xA8, 0xC0, ZYDIS_INSTRUCTION_ENCODING_MVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0056, 0x0004, 0xA8, 0xC0, ZYDIS_INSTRUCTION_ENCODING_MVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0057, 0x0204, 0xA8, 0x00, ZYDIS_INSTRUCTION_ENCODING_MVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x019F, 0x0003, 0xA9, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x01A0, 0x0083, 0xA9, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0388, 0x0004, 0xA9, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0389, 0x0004, 0xA9, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x038A, 0x0204, 0xA9, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x038B, 0x0004, 0xA9, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_MAP6, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x038C, 0x0004, 0xA9, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_MAP6, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x038D, 0x0204, 0xA9, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_MAP6, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x01A1, 0x0003, 0xA9, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x01A2, 0x0083, 0xA9, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x038E, 0x0004, 0xA9, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x038F, 0x0004, 0xA9, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0390, 0x0204, 0xA9, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x01A3, 0x0003, 0xB8, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x01A4, 0x0003, 0xB8, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x01A5, 0x0083, 0xB8, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x01A6, 0x0083, 0xB8, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0391, 0x0004, 0xB8, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0392, 0x0004, 0xB8, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0393, 0x0004, 0xB8, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0394, 0x0004, 0xB8, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0395, 0x0204, 0xB8, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0396, 0x0204, 0xB8, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0397, 0x0204, 0xB8, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0058, 0x0004, 0xB8, 0xC0, ZYDIS_INSTRUCTION_ENCODING_MVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_64, ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0059, 0x0004, 0xB8, 0xC0, ZYDIS_INSTRUCTION_ENCODING_MVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_64, ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x005A, 0x0204, 0xB8, 0x00, ZYDIS_INSTRUCTION_ENCODING_MVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_64, ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0398, 0x0004, 0xB8, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_MAP6, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0399, 0x0004, 0xB8, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_MAP6, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x039A, 0x0004, 0xB8, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_MAP6, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x039B, 0x0004, 0xB8, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_MAP6, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x039C, 0x0204, 0xB8, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_MAP6, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x039D, 0x0204, 0xB8, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_MAP6, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x039E, 0x0204, 0xB8, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_MAP6, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x01A7, 0x0003, 0xB8, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x01A8, 0x0003, 0xB8, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x01A9, 0x0083, 0xB8, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x01AA, 0x0083, 0xB8, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x039F, 0x0004, 0xB8, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x03A0, 0x0004, 0xB8, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x03A1, 0x0004, 0xB8, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x03A2, 0x0004, 0xB8, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x03A3, 0x0204, 0xB8, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x03A4, 0x0204, 0xB8, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x03A5, 0x0204, 0xB8, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x005B, 0x0004, 0xB8, 0xC0, ZYDIS_INSTRUCTION_ENCODING_MVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x005C, 0x0004, 0xB8, 0xC0, ZYDIS_INSTRUCTION_ENCODING_MVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x005D, 0x0204, 0xB8, 0x00, ZYDIS_INSTRUCTION_ENCODING_MVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x01AB, 0x0003, 0xB9, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x01AC, 0x0083, 0xB9, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x03A6, 0x0004, 0xB9, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x03A7, 0x0004, 0xB9, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x03A8, 0x0204, 0xB9, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x03A9, 0x0004, 0xB9, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_MAP6, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x03AA, 0x0004, 0xB9, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_MAP6, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x03AB, 0x0204, 0xB9, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_MAP6, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x01AD, 0x0003, 0xB9, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x01AE, 0x0083, 0xB9, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x03AC, 0x0004, 0xB9, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x03AD, 0x0004, 0xB9, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x03AE, 0x0204, 0xB9, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x005E, 0x0004, 0xA4, 0xC0, ZYDIS_INSTRUCTION_ENCODING_MVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x005F, 0x0004, 0xA4, 0xC0, ZYDIS_INSTRUCTION_ENCODING_MVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0060, 0x0204, 0xA4, 0x00, ZYDIS_INSTRUCTION_ENCODING_MVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x03AF, 0x0004, 0x56, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_MAP6, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x03B0, 0x0004, 0x56, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_MAP6, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x03B1, 0x0004, 0x56, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_MAP6, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x03B2, 0x0004, 0x56, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_MAP6, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x03B3, 0x0204, 0x56, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_MAP6, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x03B4, 0x0204, 0x56, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_MAP6, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x03B5, 0x0204, 0x56, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_MAP6, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x03B6, 0x0004, 0x57, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_MAP6, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x03B7, 0x0004, 0x57, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_MAP6, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x03B8, 0x0204, 0x57, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_MAP6, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x01AF, 0x0004, 0x69, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x01B0, 0x0004, 0x69, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x01B1, 0x0004, 0x69, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x01B2, 0x0004, 0x69, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x01B3, 0x0084, 0x69, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x01B4, 0x0204, 0x69, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x01B5, 0x0084, 0x69, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x01B6, 0x0204, 0x69, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x01B7, 0x0004, 0x68, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x01B8, 0x0004, 0x68, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x01B9, 0x0004, 0x68, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x01BA, 0x0004, 0x68, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x01BB, 0x0084, 0x68, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x01BC, 0x0204, 0x68, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x01BD, 0x0084, 0x68, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x01BE, 0x0204, 0x68, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x01BF, 0x0004, 0x6B, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x01C0, 0x0004, 0x6B, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x01C1, 0x0084, 0x6B, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x01C2, 0x0204, 0x6B, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x01C3, 0x0004, 0x6A, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x01C4, 0x0004, 0x6A, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x01C5, 0x0084, 0x6A, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x01C6, 0x0204, 0x6A, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x01C7, 0x0003, 0x96, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x01C8, 0x0003, 0x96, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x01C9, 0x0083, 0x96, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x01CA, 0x0083, 0x96, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x03B9, 0x0004, 0x96, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x03BA, 0x0004, 0x96, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x03BB, 0x0004, 0x96, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x03BC, 0x0004, 0x96, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x03BD, 0x0204, 0x96, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x03BE, 0x0204, 0x96, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x03BF, 0x0204, 0x96, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x03C0, 0x0004, 0x96, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_MAP6, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x03C1, 0x0004, 0x96, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_MAP6, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x03C2, 0x0004, 0x96, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_MAP6, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x03C3, 0x0004, 0x96, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_MAP6, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x03C4, 0x0204, 0x96, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_MAP6, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x03C5, 0x0204, 0x96, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_MAP6, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x03C6, 0x0204, 0x96, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_MAP6, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x01CB, 0x0003, 0x96, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x01CC, 0x0003, 0x96, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x01CD, 0x0083, 0x96, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x01CE, 0x0083, 0x96, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x03C7, 0x0004, 0x96, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x03C8, 0x0004, 0x96, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x03C9, 0x0004, 0x96, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x03CA, 0x0004, 0x96, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x03CB, 0x0204, 0x96, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x03CC, 0x0204, 0x96, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x03CD, 0x0204, 0x96, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x01CF, 0x0003, 0xA6, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x01D0, 0x0003, 0xA6, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x01D1, 0x0083, 0xA6, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x01D2, 0x0083, 0xA6, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x03CE, 0x0004, 0xA6, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x03CF, 0x0004, 0xA6, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x03D0, 0x0004, 0xA6, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x03D1, 0x0004, 0xA6, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x03D2, 0x0204, 0xA6, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x03D3, 0x0204, 0xA6, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x03D4, 0x0204, 0xA6, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x03D5, 0x0004, 0xA6, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_MAP6, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x03D6, 0x0004, 0xA6, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_MAP6, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x03D7, 0x0004, 0xA6, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_MAP6, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x03D8, 0x0004, 0xA6, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_MAP6, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x03D9, 0x0204, 0xA6, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_MAP6, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x03DA, 0x0204, 0xA6, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_MAP6, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x03DB, 0x0204, 0xA6, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_MAP6, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x01D3, 0x0003, 0xA6, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x01D4, 0x0003, 0xA6, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x01D5, 0x0083, 0xA6, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x01D6, 0x0083, 0xA6, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x03DC, 0x0004, 0xA6, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x03DD, 0x0004, 0xA6, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x03DE, 0x0004, 0xA6, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x03DF, 0x0004, 0xA6, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x03E0, 0x0204, 0xA6, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x03E1, 0x0204, 0xA6, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x03E2, 0x0204, 0xA6, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x01D7, 0x0003, 0xB6, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x01D8, 0x0003, 0xB6, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x01D9, 0x0083, 0xB6, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x01DA, 0x0083, 0xB6, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x03E3, 0x0004, 0xB6, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x03E4, 0x0004, 0xB6, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x03E5, 0x0004, 0xB6, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x03E6, 0x0004, 0xB6, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x03E7, 0x0204, 0xB6, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x03E8, 0x0204, 0xB6, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x03E9, 0x0204, 0xB6, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x03EA, 0x0004, 0xB6, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_MAP6, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x03EB, 0x0004, 0xB6, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_MAP6, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x03EC, 0x0004, 0xB6, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_MAP6, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x03ED, 0x0004, 0xB6, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_MAP6, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x03EE, 0x0204, 0xB6, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_MAP6, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x03EF, 0x0204, 0xB6, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_MAP6, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x03F0, 0x0204, 0xB6, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_MAP6, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x01DB, 0x0003, 0xB6, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x01DC, 0x0003, 0xB6, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x01DD, 0x0083, 0xB6, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x01DE, 0x0083, 0xB6, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x03F1, 0x0004, 0xB6, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x03F2, 0x0004, 0xB6, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x03F3, 0x0004, 0xB6, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x03F4, 0x0004, 0xB6, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x03F5, 0x0204, 0xB6, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x03F6, 0x0204, 0xB6, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x03F7, 0x0204, 0xB6, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x01DF, 0x0004, 0x5D, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x01E0, 0x0004, 0x5D, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x01E1, 0x0004, 0x5D, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x01E2, 0x0004, 0x5D, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x01E3, 0x0084, 0x5D, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x01E4, 0x0204, 0x5D, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x01E5, 0x0084, 0x5D, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x01E6, 0x0204, 0x5D, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x01E7, 0x0004, 0x5C, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x01E8, 0x0004, 0x5C, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x01E9, 0x0004, 0x5C, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x01EA, 0x0004, 0x5C, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x01EB, 0x0084, 0x5C, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x01EC, 0x0204, 0x5C, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x01ED, 0x0084, 0x5C, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x01EE, 0x0204, 0x5C, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x01EF, 0x0003, 0x9A, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x01F0, 0x0003, 0x9A, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x01F1, 0x0083, 0x9A, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x01F2, 0x0083, 0x9A, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x03F8, 0x0004, 0x9A, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x03F9, 0x0004, 0x9A, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x03FA, 0x0004, 0x9A, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x03FB, 0x0004, 0x9A, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x03FC, 0x0204, 0x9A, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x03FD, 0x0204, 0x9A, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x03FE, 0x0204, 0x9A, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0061, 0x0004, 0x9A, 0xC0, ZYDIS_INSTRUCTION_ENCODING_MVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_64, ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0062, 0x0004, 0x9A, 0xC0, ZYDIS_INSTRUCTION_ENCODING_MVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_64, ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0063, 0x0204, 0x9A, 0x00, ZYDIS_INSTRUCTION_ENCODING_MVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_64, ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x03FF, 0x0004, 0x9A, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_MAP6, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0400, 0x0004, 0x9A, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_MAP6, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0401, 0x0004, 0x9A, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_MAP6, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0402, 0x0004, 0x9A, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_MAP6, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0403, 0x0204, 0x9A, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_MAP6, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0404, 0x0204, 0x9A, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_MAP6, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0405, 0x0204, 0x9A, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_MAP6, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x01F3, 0x0003, 0x9A, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x01F4, 0x0003, 0x9A, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x01F5, 0x0083, 0x9A, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x01F6, 0x0083, 0x9A, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0406, 0x0004, 0x9A, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0407, 0x0004, 0x9A, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0408, 0x0004, 0x9A, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0409, 0x0004, 0x9A, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x040A, 0x0204, 0x9A, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x040B, 0x0204, 0x9A, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x040C, 0x0204, 0x9A, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0064, 0x0004, 0x9A, 0xC0, ZYDIS_INSTRUCTION_ENCODING_MVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0065, 0x0004, 0x9A, 0xC0, ZYDIS_INSTRUCTION_ENCODING_MVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0066, 0x0204, 0x9A, 0x00, ZYDIS_INSTRUCTION_ENCODING_MVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x01F7, 0x0003, 0x9B, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x01F8, 0x0083, 0x9B, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x040D, 0x0004, 0x9B, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x040E, 0x0004, 0x9B, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x040F, 0x0204, 0x9B, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0410, 0x0004, 0x9B, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_MAP6, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0411, 0x0004, 0x9B, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_MAP6, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0412, 0x0204, 0x9B, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_MAP6, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x01F9, 0x0003, 0x9B, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x01FA, 0x0083, 0x9B, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0413, 0x0004, 0x9B, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0414, 0x0004, 0x9B, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0415, 0x0204, 0x9B, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x01FB, 0x0003, 0xAA, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x01FC, 0x0003, 0xAA, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x01FD, 0x0083, 0xAA, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x01FE, 0x0083, 0xAA, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0416, 0x0004, 0xAA, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0417, 0x0004, 0xAA, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0418, 0x0004, 0xAA, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0419, 0x0004, 0xAA, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x041A, 0x0204, 0xAA, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x041B, 0x0204, 0xAA, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x041C, 0x0204, 0xAA, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0067, 0x0004, 0xAA, 0xC0, ZYDIS_INSTRUCTION_ENCODING_MVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_64, ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0068, 0x0004, 0xAA, 0xC0, ZYDIS_INSTRUCTION_ENCODING_MVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_64, ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0069, 0x0204, 0xAA, 0x00, ZYDIS_INSTRUCTION_ENCODING_MVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_64, ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x041D, 0x0004, 0xAA, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_MAP6, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x041E, 0x0004, 0xAA, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_MAP6, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x041F, 0x0004, 0xAA, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_MAP6, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0420, 0x0004, 0xAA, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_MAP6, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0421, 0x0204, 0xAA, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_MAP6, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0422, 0x0204, 0xAA, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_MAP6, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0423, 0x0204, 0xAA, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_MAP6, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x01FF, 0x0003, 0xAA, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0200, 0x0003, 0xAA, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0201, 0x0083, 0xAA, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0202, 0x0083, 0xAA, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0424, 0x0004, 0xAA, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0425, 0x0004, 0xAA, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0426, 0x0004, 0xAA, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0427, 0x0004, 0xAA, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0428, 0x0204, 0xAA, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0429, 0x0204, 0xAA, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x042A, 0x0204, 0xAA, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x006A, 0x0004, 0xAA, 0xC0, ZYDIS_INSTRUCTION_ENCODING_MVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x006B, 0x0004, 0xAA, 0xC0, ZYDIS_INSTRUCTION_ENCODING_MVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x006C, 0x0204, 0xAA, 0x00, ZYDIS_INSTRUCTION_ENCODING_MVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0203, 0x0003, 0xAB, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0204, 0x0083, 0xAB, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x042B, 0x0004, 0xAB, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x042C, 0x0004, 0xAB, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x042D, 0x0204, 0xAB, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x042E, 0x0004, 0xAB, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_MAP6, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x042F, 0x0004, 0xAB, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_MAP6, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0430, 0x0204, 0xAB, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_MAP6, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0205, 0x0003, 0xAB, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0206, 0x0083, 0xAB, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0431, 0x0004, 0xAB, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0432, 0x0004, 0xAB, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0433, 0x0204, 0xAB, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0207, 0x0003, 0xBA, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0208, 0x0003, 0xBA, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0209, 0x0083, 0xBA, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x020A, 0x0083, 0xBA, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0434, 0x0004, 0xBA, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0435, 0x0004, 0xBA, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0436, 0x0004, 0xBA, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0437, 0x0004, 0xBA, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0438, 0x0204, 0xBA, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0439, 0x0204, 0xBA, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x043A, 0x0204, 0xBA, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x006D, 0x0004, 0xBA, 0xC0, ZYDIS_INSTRUCTION_ENCODING_MVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_64, ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x006E, 0x0004, 0xBA, 0xC0, ZYDIS_INSTRUCTION_ENCODING_MVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_64, ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x006F, 0x0204, 0xBA, 0x00, ZYDIS_INSTRUCTION_ENCODING_MVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_64, ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x043B, 0x0004, 0xBA, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_MAP6, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x043C, 0x0004, 0xBA, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_MAP6, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x043D, 0x0004, 0xBA, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_MAP6, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x043E, 0x0004, 0xBA, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_MAP6, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x043F, 0x0204, 0xBA, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_MAP6, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0440, 0x0204, 0xBA, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_MAP6, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0441, 0x0204, 0xBA, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_MAP6, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x020B, 0x0003, 0xBA, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x020C, 0x0003, 0xBA, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x020D, 0x0083, 0xBA, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x020E, 0x0083, 0xBA, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0442, 0x0004, 0xBA, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0443, 0x0004, 0xBA, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0444, 0x0004, 0xBA, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0445, 0x0004, 0xBA, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0446, 0x0204, 0xBA, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0447, 0x0204, 0xBA, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0448, 0x0204, 0xBA, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0070, 0x0004, 0xBA, 0xC0, ZYDIS_INSTRUCTION_ENCODING_MVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0071, 0x0004, 0xBA, 0xC0, ZYDIS_INSTRUCTION_ENCODING_MVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0072, 0x0204, 0xBA, 0x00, ZYDIS_INSTRUCTION_ENCODING_MVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x020F, 0x0003, 0xBB, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0210, 0x0083, 0xBB, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0449, 0x0004, 0xBB, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x044A, 0x0004, 0xBB, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x044B, 0x0204, 0xBB, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x044C, 0x0004, 0xBB, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_MAP6, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x044D, 0x0004, 0xBB, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_MAP6, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x044E, 0x0204, 0xBB, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_MAP6, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0211, 0x0003, 0xBB, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0212, 0x0083, 0xBB, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x044F, 0x0004, 0xBB, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0450, 0x0004, 0xBB, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0451, 0x0204, 0xBB, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0213, 0x0003, 0x97, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0214, 0x0003, 0x97, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0215, 0x0083, 0x97, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0216, 0x0083, 0x97, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0452, 0x0004, 0x97, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0453, 0x0004, 0x97, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0454, 0x0004, 0x97, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0455, 0x0004, 0x97, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0456, 0x0204, 0x97, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0457, 0x0204, 0x97, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0458, 0x0204, 0x97, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0459, 0x0004, 0x97, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_MAP6, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x045A, 0x0004, 0x97, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_MAP6, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x045B, 0x0004, 0x97, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_MAP6, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x045C, 0x0004, 0x97, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_MAP6, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x045D, 0x0204, 0x97, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_MAP6, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x045E, 0x0204, 0x97, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_MAP6, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x045F, 0x0204, 0x97, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_MAP6, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0217, 0x0003, 0x97, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0218, 0x0003, 0x97, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0219, 0x0083, 0x97, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x021A, 0x0083, 0x97, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0460, 0x0004, 0x97, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0461, 0x0004, 0x97, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0462, 0x0004, 0x97, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0463, 0x0004, 0x97, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0464, 0x0204, 0x97, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0465, 0x0204, 0x97, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0466, 0x0204, 0x97, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x021B, 0x0003, 0xA7, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x021C, 0x0003, 0xA7, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x021D, 0x0083, 0xA7, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x021E, 0x0083, 0xA7, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0467, 0x0004, 0xA7, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0468, 0x0004, 0xA7, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0469, 0x0004, 0xA7, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x046A, 0x0004, 0xA7, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x046B, 0x0204, 0xA7, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x046C, 0x0204, 0xA7, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x046D, 0x0204, 0xA7, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x046E, 0x0004, 0xA7, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_MAP6, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x046F, 0x0004, 0xA7, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_MAP6, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0470, 0x0004, 0xA7, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_MAP6, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0471, 0x0004, 0xA7, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_MAP6, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0472, 0x0204, 0xA7, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_MAP6, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0473, 0x0204, 0xA7, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_MAP6, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0474, 0x0204, 0xA7, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_MAP6, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x021F, 0x0003, 0xA7, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0220, 0x0003, 0xA7, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0221, 0x0083, 0xA7, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0222, 0x0083, 0xA7, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0475, 0x0004, 0xA7, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0476, 0x0004, 0xA7, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0477, 0x0004, 0xA7, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0478, 0x0004, 0xA7, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0479, 0x0204, 0xA7, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x047A, 0x0204, 0xA7, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x047B, 0x0204, 0xA7, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0223, 0x0003, 0xB7, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0224, 0x0003, 0xB7, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0225, 0x0083, 0xB7, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0226, 0x0083, 0xB7, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x047C, 0x0004, 0xB7, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x047D, 0x0004, 0xB7, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x047E, 0x0004, 0xB7, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x047F, 0x0004, 0xB7, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0480, 0x0204, 0xB7, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0481, 0x0204, 0xB7, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0482, 0x0204, 0xB7, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0483, 0x0004, 0xB7, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_MAP6, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0484, 0x0004, 0xB7, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_MAP6, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0485, 0x0004, 0xB7, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_MAP6, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0486, 0x0004, 0xB7, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_MAP6, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0487, 0x0204, 0xB7, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_MAP6, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0488, 0x0204, 0xB7, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_MAP6, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0489, 0x0204, 0xB7, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_MAP6, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0227, 0x0003, 0xB7, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0228, 0x0003, 0xB7, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0229, 0x0083, 0xB7, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x022A, 0x0083, 0xB7, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x048A, 0x0004, 0xB7, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x048B, 0x0004, 0xB7, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x048C, 0x0004, 0xB7, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x048D, 0x0004, 0xB7, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x048E, 0x0204, 0xB7, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x048F, 0x0204, 0xB7, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0490, 0x0204, 0xB7, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x022B, 0x0004, 0x5F, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x022C, 0x0004, 0x5F, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x022D, 0x0004, 0x5F, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x022E, 0x0004, 0x5F, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x022F, 0x0084, 0x5F, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0230, 0x0204, 0x5F, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0231, 0x0084, 0x5F, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0232, 0x0204, 0x5F, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0233, 0x0004, 0x5E, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0234, 0x0004, 0x5E, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0235, 0x0004, 0x5E, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0236, 0x0004, 0x5E, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0237, 0x0084, 0x5E, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0238, 0x0204, 0x5E, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0239, 0x0084, 0x5E, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x023A, 0x0204, 0x5E, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x023B, 0x0004, 0x6D, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x023C, 0x0004, 0x6D, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x023D, 0x0004, 0x6D, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x023E, 0x0004, 0x6D, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x023F, 0x0084, 0x6D, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0240, 0x0204, 0x6D, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0241, 0x0084, 0x6D, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0242, 0x0204, 0x6D, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0243, 0x0004, 0x6C, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0244, 0x0004, 0x6C, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0245, 0x0004, 0x6C, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0246, 0x0004, 0x6C, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0247, 0x0084, 0x6C, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0248, 0x0204, 0x6C, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0249, 0x0084, 0x6C, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x024A, 0x0204, 0x6C, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x024B, 0x0004, 0x6F, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x024C, 0x0004, 0x6F, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x024D, 0x0084, 0x6F, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x024E, 0x0204, 0x6F, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x024F, 0x0004, 0x6E, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0250, 0x0004, 0x6E, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0251, 0x0084, 0x6E, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0252, 0x0204, 0x6E, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0491, 0x0004, 0xD6, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_MAP6, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0492, 0x0004, 0xD6, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_MAP6, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0493, 0x0004, 0xD6, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_MAP6, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0494, 0x0004, 0xD6, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_MAP6, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0495, 0x0204, 0xD6, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_MAP6, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0496, 0x0204, 0xD6, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_MAP6, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0497, 0x0204, 0xD6, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_MAP6, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0498, 0x0004, 0xD7, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_MAP6, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0499, 0x0004, 0xD7, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_MAP6, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x049A, 0x0204, 0xD7, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_MAP6, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0253, 0x0003, 0x9C, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0254, 0x0003, 0x9C, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0255, 0x0083, 0x9C, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0256, 0x0083, 0x9C, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x049B, 0x0004, 0x9C, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x049C, 0x0004, 0x9C, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x049D, 0x0004, 0x9C, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x049E, 0x0004, 0x9C, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x049F, 0x0204, 0x9C, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x04A0, 0x0204, 0x9C, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x04A1, 0x0204, 0x9C, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0073, 0x0004, 0x9C, 0xC0, ZYDIS_INSTRUCTION_ENCODING_MVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_64, ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0074, 0x0004, 0x9C, 0xC0, ZYDIS_INSTRUCTION_ENCODING_MVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_64, ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0075, 0x0204, 0x9C, 0x00, ZYDIS_INSTRUCTION_ENCODING_MVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_64, ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x04A2, 0x0004, 0x9C, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_MAP6, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x04A3, 0x0004, 0x9C, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_MAP6, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x04A4, 0x0004, 0x9C, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_MAP6, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x04A5, 0x0004, 0x9C, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_MAP6, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x04A6, 0x0204, 0x9C, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_MAP6, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x04A7, 0x0204, 0x9C, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_MAP6, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x04A8, 0x0204, 0x9C, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_MAP6, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0257, 0x0003, 0x9C, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0258, 0x0003, 0x9C, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0259, 0x0083, 0x9C, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x025A, 0x0083, 0x9C, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x04A9, 0x0004, 0x9C, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x04AA, 0x0004, 0x9C, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x04AB, 0x0004, 0x9C, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x04AC, 0x0004, 0x9C, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x04AD, 0x0204, 0x9C, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x04AE, 0x0204, 0x9C, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x04AF, 0x0204, 0x9C, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0076, 0x0004, 0x9C, 0xC0, ZYDIS_INSTRUCTION_ENCODING_MVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0077, 0x0004, 0x9C, 0xC0, ZYDIS_INSTRUCTION_ENCODING_MVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0078, 0x0204, 0x9C, 0x00, ZYDIS_INSTRUCTION_ENCODING_MVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x025B, 0x0003, 0x9D, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x025C, 0x0083, 0x9D, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x04B0, 0x0004, 0x9D, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x04B1, 0x0004, 0x9D, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x04B2, 0x0204, 0x9D, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x04B3, 0x0004, 0x9D, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_MAP6, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x04B4, 0x0004, 0x9D, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_MAP6, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x04B5, 0x0204, 0x9D, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_MAP6, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x025D, 0x0003, 0x9D, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x025E, 0x0083, 0x9D, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x04B6, 0x0004, 0x9D, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x04B7, 0x0004, 0x9D, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x04B8, 0x0204, 0x9D, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x025F, 0x0003, 0xAC, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0260, 0x0003, 0xAC, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0261, 0x0083, 0xAC, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0262, 0x0083, 0xAC, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x04B9, 0x0004, 0xAC, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x04BA, 0x0004, 0xAC, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x04BB, 0x0004, 0xAC, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x04BC, 0x0004, 0xAC, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x04BD, 0x0204, 0xAC, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x04BE, 0x0204, 0xAC, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x04BF, 0x0204, 0xAC, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0079, 0x0004, 0xAC, 0xC0, ZYDIS_INSTRUCTION_ENCODING_MVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_64, ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x007A, 0x0004, 0xAC, 0xC0, ZYDIS_INSTRUCTION_ENCODING_MVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_64, ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x007B, 0x0204, 0xAC, 0x00, ZYDIS_INSTRUCTION_ENCODING_MVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_64, ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x04C0, 0x0004, 0xAC, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_MAP6, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x04C1, 0x0004, 0xAC, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_MAP6, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x04C2, 0x0004, 0xAC, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_MAP6, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x04C3, 0x0004, 0xAC, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_MAP6, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x04C4, 0x0204, 0xAC, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_MAP6, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x04C5, 0x0204, 0xAC, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_MAP6, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x04C6, 0x0204, 0xAC, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_MAP6, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0263, 0x0003, 0xAC, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0264, 0x0003, 0xAC, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0265, 0x0083, 0xAC, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0266, 0x0083, 0xAC, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x04C7, 0x0004, 0xAC, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x04C8, 0x0004, 0xAC, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x04C9, 0x0004, 0xAC, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x04CA, 0x0004, 0xAC, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x04CB, 0x0204, 0xAC, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x04CC, 0x0204, 0xAC, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x04CD, 0x0204, 0xAC, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x007C, 0x0004, 0xAC, 0xC0, ZYDIS_INSTRUCTION_ENCODING_MVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x007D, 0x0004, 0xAC, 0xC0, ZYDIS_INSTRUCTION_ENCODING_MVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x007E, 0x0204, 0xAC, 0x00, ZYDIS_INSTRUCTION_ENCODING_MVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0267, 0x0003, 0xAD, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0268, 0x0083, 0xAD, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x04CE, 0x0004, 0xAD, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x04CF, 0x0004, 0xAD, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x04D0, 0x0204, 0xAD, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x04D1, 0x0004, 0xAD, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_MAP6, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x04D2, 0x0004, 0xAD, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_MAP6, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x04D3, 0x0204, 0xAD, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_MAP6, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0269, 0x0003, 0xAD, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x026A, 0x0083, 0xAD, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x04D4, 0x0004, 0xAD, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x04D5, 0x0004, 0xAD, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x04D6, 0x0204, 0xAD, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x026B, 0x0003, 0xBC, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x026C, 0x0003, 0xBC, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x026D, 0x0083, 0xBC, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x026E, 0x0083, 0xBC, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x04D7, 0x0004, 0xBC, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x04D8, 0x0004, 0xBC, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x04D9, 0x0004, 0xBC, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x04DA, 0x0004, 0xBC, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x04DB, 0x0204, 0xBC, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x04DC, 0x0204, 0xBC, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x04DD, 0x0204, 0xBC, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x007F, 0x0004, 0xBC, 0xC0, ZYDIS_INSTRUCTION_ENCODING_MVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_64, ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0080, 0x0004, 0xBC, 0xC0, ZYDIS_INSTRUCTION_ENCODING_MVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_64, ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0081, 0x0204, 0xBC, 0x00, ZYDIS_INSTRUCTION_ENCODING_MVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_64, ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x04DE, 0x0004, 0xBC, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_MAP6, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x04DF, 0x0004, 0xBC, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_MAP6, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x04E0, 0x0004, 0xBC, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_MAP6, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x04E1, 0x0004, 0xBC, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_MAP6, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x04E2, 0x0204, 0xBC, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_MAP6, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x04E3, 0x0204, 0xBC, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_MAP6, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x04E4, 0x0204, 0xBC, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_MAP6, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x026F, 0x0003, 0xBC, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0270, 0x0003, 0xBC, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0271, 0x0083, 0xBC, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0272, 0x0083, 0xBC, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x04E5, 0x0004, 0xBC, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x04E6, 0x0004, 0xBC, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x04E7, 0x0004, 0xBC, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x04E8, 0x0004, 0xBC, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x04E9, 0x0204, 0xBC, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x04EA, 0x0204, 0xBC, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x04EB, 0x0204, 0xBC, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0082, 0x0004, 0xBC, 0xC0, ZYDIS_INSTRUCTION_ENCODING_MVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0083, 0x0004, 0xBC, 0xC0, ZYDIS_INSTRUCTION_ENCODING_MVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0084, 0x0204, 0xBC, 0x00, ZYDIS_INSTRUCTION_ENCODING_MVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0273, 0x0003, 0xBD, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0274, 0x0083, 0xBD, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x04EC, 0x0004, 0xBD, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x04ED, 0x0004, 0xBD, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x04EE, 0x0204, 0xBD, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x04EF, 0x0004, 0xBD, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_MAP6, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x04F0, 0x0004, 0xBD, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_MAP6, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x04F1, 0x0204, 0xBD, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_MAP6, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0275, 0x0003, 0xBD, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0276, 0x0083, 0xBD, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x04F2, 0x0004, 0xBD, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x04F3, 0x0004, 0xBD, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x04F4, 0x0204, 0xBD, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0277, 0x0004, 0x79, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0278, 0x0004, 0x79, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0279, 0x0004, 0x79, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x027A, 0x0004, 0x79, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x027B, 0x0084, 0x79, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x027C, 0x0204, 0x79, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x027D, 0x0084, 0x79, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x027E, 0x0204, 0x79, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x027F, 0x0004, 0x78, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0280, 0x0004, 0x78, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0281, 0x0004, 0x78, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0282, 0x0004, 0x78, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0283, 0x0084, 0x78, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0284, 0x0204, 0x78, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0285, 0x0084, 0x78, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0286, 0x0204, 0x78, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0287, 0x0004, 0x7B, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0288, 0x0004, 0x7B, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0289, 0x0084, 0x7B, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x028A, 0x0204, 0x7B, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x028B, 0x0004, 0x7A, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x028C, 0x0004, 0x7A, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x028D, 0x0084, 0x7A, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x028E, 0x0204, 0x7A, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x028F, 0x0003, 0x9E, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0290, 0x0003, 0x9E, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0291, 0x0083, 0x9E, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0292, 0x0083, 0x9E, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x04F5, 0x0004, 0x9E, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x04F6, 0x0004, 0x9E, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x04F7, 0x0004, 0x9E, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x04F8, 0x0004, 0x9E, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x04F9, 0x0204, 0x9E, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x04FA, 0x0204, 0x9E, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x04FB, 0x0204, 0x9E, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0085, 0x0004, 0x9E, 0xC0, ZYDIS_INSTRUCTION_ENCODING_MVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_64, ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0086, 0x0004, 0x9E, 0xC0, ZYDIS_INSTRUCTION_ENCODING_MVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_64, ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0087, 0x0204, 0x9E, 0x00, ZYDIS_INSTRUCTION_ENCODING_MVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_64, ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x04FC, 0x0004, 0x9E, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_MAP6, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x04FD, 0x0004, 0x9E, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_MAP6, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x04FE, 0x0004, 0x9E, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_MAP6, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x04FF, 0x0004, 0x9E, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_MAP6, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0500, 0x0204, 0x9E, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_MAP6, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0501, 0x0204, 0x9E, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_MAP6, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0502, 0x0204, 0x9E, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_MAP6, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0293, 0x0003, 0x9E, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0294, 0x0003, 0x9E, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0295, 0x0083, 0x9E, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0296, 0x0083, 0x9E, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0503, 0x0004, 0x9E, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0504, 0x0004, 0x9E, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0505, 0x0004, 0x9E, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0506, 0x0004, 0x9E, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0507, 0x0204, 0x9E, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0508, 0x0204, 0x9E, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0509, 0x0204, 0x9E, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0088, 0x0004, 0x9E, 0xC0, ZYDIS_INSTRUCTION_ENCODING_MVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0089, 0x0004, 0x9E, 0xC0, ZYDIS_INSTRUCTION_ENCODING_MVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x008A, 0x0204, 0x9E, 0x00, ZYDIS_INSTRUCTION_ENCODING_MVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0297, 0x0003, 0x9F, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0298, 0x0083, 0x9F, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x050A, 0x0004, 0x9F, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x050B, 0x0004, 0x9F, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x050C, 0x0204, 0x9F, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x050D, 0x0004, 0x9F, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_MAP6, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x050E, 0x0004, 0x9F, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_MAP6, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x050F, 0x0204, 0x9F, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_MAP6, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0299, 0x0003, 0x9F, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x029A, 0x0083, 0x9F, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0510, 0x0004, 0x9F, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0511, 0x0004, 0x9F, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0512, 0x0204, 0x9F, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x029B, 0x0003, 0xAE, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x029C, 0x0003, 0xAE, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x029D, 0x0083, 0xAE, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x029E, 0x0083, 0xAE, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0513, 0x0004, 0xAE, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0514, 0x0004, 0xAE, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0515, 0x0004, 0xAE, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0516, 0x0004, 0xAE, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0517, 0x0204, 0xAE, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0518, 0x0204, 0xAE, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0519, 0x0204, 0xAE, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x008B, 0x0004, 0xAE, 0xC0, ZYDIS_INSTRUCTION_ENCODING_MVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_64, ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x008C, 0x0004, 0xAE, 0xC0, ZYDIS_INSTRUCTION_ENCODING_MVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_64, ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x008D, 0x0204, 0xAE, 0x00, ZYDIS_INSTRUCTION_ENCODING_MVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_64, ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x051A, 0x0004, 0xAE, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_MAP6, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x051B, 0x0004, 0xAE, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_MAP6, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x051C, 0x0004, 0xAE, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_MAP6, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x051D, 0x0004, 0xAE, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_MAP6, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x051E, 0x0204, 0xAE, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_MAP6, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x051F, 0x0204, 0xAE, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_MAP6, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0520, 0x0204, 0xAE, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_MAP6, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x029F, 0x0003, 0xAE, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x02A0, 0x0003, 0xAE, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x02A1, 0x0083, 0xAE, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x02A2, 0x0083, 0xAE, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0521, 0x0004, 0xAE, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0522, 0x0004, 0xAE, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0523, 0x0004, 0xAE, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0524, 0x0004, 0xAE, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0525, 0x0204, 0xAE, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0526, 0x0204, 0xAE, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0527, 0x0204, 0xAE, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x008E, 0x0004, 0xAE, 0xC0, ZYDIS_INSTRUCTION_ENCODING_MVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x008F, 0x0004, 0xAE, 0xC0, ZYDIS_INSTRUCTION_ENCODING_MVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0090, 0x0204, 0xAE, 0x00, ZYDIS_INSTRUCTION_ENCODING_MVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x02A3, 0x0003, 0xAF, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x02A4, 0x0083, 0xAF, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0528, 0x0004, 0xAF, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0529, 0x0004, 0xAF, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x052A, 0x0204, 0xAF, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x052B, 0x0004, 0xAF, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_MAP6, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x052C, 0x0004, 0xAF, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_MAP6, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x052D, 0x0204, 0xAF, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_MAP6, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x02A5, 0x0003, 0xAF, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x02A6, 0x0083, 0xAF, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x052E, 0x0004, 0xAF, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x052F, 0x0004, 0xAF, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0530, 0x0204, 0xAF, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x02A7, 0x0003, 0xBE, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x02A8, 0x0003, 0xBE, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x02A9, 0x0083, 0xBE, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x02AA, 0x0083, 0xBE, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0531, 0x0004, 0xBE, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0532, 0x0004, 0xBE, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0533, 0x0004, 0xBE, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0534, 0x0004, 0xBE, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0535, 0x0204, 0xBE, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0536, 0x0204, 0xBE, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0537, 0x0204, 0xBE, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0091, 0x0004, 0xBE, 0xC0, ZYDIS_INSTRUCTION_ENCODING_MVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_64, ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0092, 0x0004, 0xBE, 0xC0, ZYDIS_INSTRUCTION_ENCODING_MVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_64, ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0093, 0x0204, 0xBE, 0x00, ZYDIS_INSTRUCTION_ENCODING_MVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_64, ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0538, 0x0004, 0xBE, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_MAP6, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0539, 0x0004, 0xBE, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_MAP6, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x053A, 0x0004, 0xBE, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_MAP6, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x053B, 0x0004, 0xBE, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_MAP6, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x053C, 0x0204, 0xBE, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_MAP6, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x053D, 0x0204, 0xBE, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_MAP6, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x053E, 0x0204, 0xBE, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_MAP6, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x02AB, 0x0003, 0xBE, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x02AC, 0x0003, 0xBE, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x02AD, 0x0083, 0xBE, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x02AE, 0x0083, 0xBE, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x053F, 0x0004, 0xBE, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0540, 0x0004, 0xBE, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0541, 0x0004, 0xBE, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0542, 0x0004, 0xBE, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0543, 0x0204, 0xBE, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0544, 0x0204, 0xBE, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0545, 0x0204, 0xBE, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0094, 0x0004, 0xBE, 0xC0, ZYDIS_INSTRUCTION_ENCODING_MVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0095, 0x0004, 0xBE, 0xC0, ZYDIS_INSTRUCTION_ENCODING_MVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0096, 0x0204, 0xBE, 0x00, ZYDIS_INSTRUCTION_ENCODING_MVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x02AF, 0x0003, 0xBF, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x02B0, 0x0083, 0xBF, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0546, 0x0004, 0xBF, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0547, 0x0004, 0xBF, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0548, 0x0204, 0xBF, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0549, 0x0004, 0xBF, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_MAP6, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x054A, 0x0004, 0xBF, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_MAP6, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x054B, 0x0204, 0xBF, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_MAP6, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x02B1, 0x0003, 0xBF, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x02B2, 0x0083, 0xBF, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x054C, 0x0004, 0xBF, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x054D, 0x0004, 0xBF, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x054E, 0x0204, 0xBF, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x02B3, 0x0004, 0x7D, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x02B4, 0x0004, 0x7D, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x02B5, 0x0004, 0x7D, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x02B6, 0x0004, 0x7D, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x02B7, 0x0084, 0x7D, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x02B8, 0x0204, 0x7D, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x02B9, 0x0084, 0x7D, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x02BA, 0x0204, 0x7D, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x02BB, 0x0004, 0x7C, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x02BC, 0x0004, 0x7C, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x02BD, 0x0004, 0x7C, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x02BE, 0x0004, 0x7C, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x02BF, 0x0084, 0x7C, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x02C0, 0x0204, 0x7C, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x02C1, 0x0084, 0x7C, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x02C2, 0x0204, 0x7C, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x02C3, 0x0004, 0x7F, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x02C4, 0x0004, 0x7F, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x02C5, 0x0084, 0x7F, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x02C6, 0x0204, 0x7F, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x02C7, 0x0004, 0x7E, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x02C8, 0x0004, 0x7E, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x02C9, 0x0084, 0x7E, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x02CA, 0x0204, 0x7E, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x054F, 0x0604, 0x66, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0550, 0x0604, 0x66, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0551, 0x0604, 0x66, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0552, 0x0684, 0x66, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0553, 0x0684, 0x66, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0554, 0x0684, 0x66, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0555, 0x0604, 0x66, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0556, 0x0604, 0x66, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0557, 0x0604, 0x66, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0558, 0x0684, 0x66, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0559, 0x0684, 0x66, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x055A, 0x0684, 0x66, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x055B, 0x0604, 0x66, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x055C, 0x0604, 0x66, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x055D, 0x0604, 0x66, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x055E, 0x0684, 0x66, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x055F, 0x0684, 0x66, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0560, 0x0684, 0x66, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0561, 0x0604, 0x67, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0562, 0x0684, 0x67, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0563, 0x0604, 0x67, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0564, 0x0684, 0x67, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0565, 0x0604, 0x67, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0566, 0x0684, 0x67, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x001A, 0x0002, 0x81, 0xC0, ZYDIS_INSTRUCTION_ENCODING_XOP, ZYDIS_OPCODE_MAP_XOP9, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x001B, 0x0002, 0x81, 0xC0, ZYDIS_INSTRUCTION_ENCODING_XOP, ZYDIS_OPCODE_MAP_XOP9, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x001C, 0x0022, 0x81, 0x00, ZYDIS_INSTRUCTION_ENCODING_XOP, ZYDIS_OPCODE_MAP_XOP9, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x001D, 0x0022, 0x81, 0x00, ZYDIS_INSTRUCTION_ENCODING_XOP, ZYDIS_OPCODE_MAP_XOP9, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x001E, 0x0002, 0x80, 0xC0, ZYDIS_INSTRUCTION_ENCODING_XOP, ZYDIS_OPCODE_MAP_XOP9, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x001F, 0x0002, 0x80, 0xC0, ZYDIS_INSTRUCTION_ENCODING_XOP, ZYDIS_OPCODE_MAP_XOP9, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0020, 0x0022, 0x80, 0x00, ZYDIS_INSTRUCTION_ENCODING_XOP, ZYDIS_OPCODE_MAP_XOP9, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0021, 0x0022, 0x80, 0x00, ZYDIS_INSTRUCTION_ENCODING_XOP, ZYDIS_OPCODE_MAP_XOP9, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0022, 0x0002, 0x83, 0xC0, ZYDIS_INSTRUCTION_ENCODING_XOP, ZYDIS_OPCODE_MAP_XOP9, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0023, 0x0022, 0x83, 0x00, ZYDIS_INSTRUCTION_ENCODING_XOP, ZYDIS_OPCODE_MAP_XOP9, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0024, 0x0002, 0x82, 0xC0, ZYDIS_INSTRUCTION_ENCODING_XOP, ZYDIS_OPCODE_MAP_XOP9, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0025, 0x0022, 0x82, 0x00, ZYDIS_INSTRUCTION_ENCODING_XOP, ZYDIS_OPCODE_MAP_XOP9, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x02CB, 0x0023, 0x92, 0x04, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x02CC, 0x0023, 0x92, 0x04, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0567, 0x0083, 0x92, 0x04, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0568, 0x0083, 0x92, 0x04, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0569, 0x0083, 0x92, 0x04, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0097, 0x0083, 0x92, 0x04, ZYDIS_INSTRUCTION_ENCODING_MVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_64, ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x02CD, 0x0023, 0x92, 0x04, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x02CE, 0x0023, 0x92, 0x04, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x056A, 0x0083, 0x92, 0x04, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x056B, 0x0083, 0x92, 0x04, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x056C, 0x0083, 0x92, 0x04, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0098, 0x0083, 0x92, 0x04, ZYDIS_INSTRUCTION_ENCODING_MVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x056D, 0x000A, 0xC6, 0x0C, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x056E, 0x000A, 0xC6, 0x0C, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0099, 0x000A, 0xC6, 0x0C, ZYDIS_INSTRUCTION_ENCODING_MVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x009A, 0x000A, 0xC6, 0x04, ZYDIS_INSTRUCTION_ENCODING_MVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_64, ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x009B, 0x000A, 0xC6, 0x04, ZYDIS_INSTRUCTION_ENCODING_MVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x056F, 0x000A, 0xC7, 0x0C, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0570, 0x000A, 0xC7, 0x0C, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0571, 0x000A, 0xC6, 0x14, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0572, 0x000A, 0xC6, 0x14, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x009C, 0x000A, 0xC6, 0x14, ZYDIS_INSTRUCTION_ENCODING_MVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0573, 0x000A, 0xC7, 0x14, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0574, 0x000A, 0xC7, 0x14, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x02CF, 0x0023, 0x93, 0x04, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x02D0, 0x0023, 0x93, 0x04, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0575, 0x0083, 0x93, 0x04, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0576, 0x0083, 0x93, 0x04, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0577, 0x0083, 0x93, 0x04, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x02D1, 0x0023, 0x93, 0x04, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x02D2, 0x0023, 0x93, 0x04, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0578, 0x0083, 0x93, 0x04, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0579, 0x0083, 0x93, 0x04, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x057A, 0x0083, 0x93, 0x04, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x057B, 0x0003, 0x42, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x057C, 0x0003, 0x42, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x057D, 0x0003, 0x42, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x057E, 0x0003, 0x42, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x057F, 0x0083, 0x42, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0580, 0x0083, 0x42, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0581, 0x0083, 0x42, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x009D, 0x0003, 0x42, 0xC0, ZYDIS_INSTRUCTION_ENCODING_MVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_64, ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x009E, 0x0003, 0x42, 0xC0, ZYDIS_INSTRUCTION_ENCODING_MVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_64, ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x009F, 0x0083, 0x42, 0x00, ZYDIS_INSTRUCTION_ENCODING_MVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_64, ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0582, 0x0003, 0x42, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_MAP6, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0583, 0x0003, 0x42, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_MAP6, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0584, 0x0003, 0x42, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_MAP6, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0585, 0x0003, 0x42, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_MAP6, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0586, 0x0083, 0x42, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_MAP6, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0587, 0x0083, 0x42, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_MAP6, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0588, 0x0083, 0x42, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_MAP6, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0589, 0x0003, 0x42, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x058A, 0x0003, 0x42, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x058B, 0x0003, 0x42, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x058C, 0x0003, 0x42, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x058D, 0x0083, 0x42, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x058E, 0x0083, 0x42, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x058F, 0x0083, 0x42, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x00A0, 0x0003, 0x42, 0xC0, ZYDIS_INSTRUCTION_ENCODING_MVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x00A1, 0x0003, 0x42, 0xC0, ZYDIS_INSTRUCTION_ENCODING_MVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x00A2, 0x0083, 0x42, 0x00, ZYDIS_INSTRUCTION_ENCODING_MVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0590, 0x0004, 0x43, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0591, 0x0004, 0x43, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0592, 0x0204, 0x43, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0593, 0x0004, 0x43, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_MAP6, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0594, 0x0004, 0x43, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_MAP6, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0595, 0x0204, 0x43, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_MAP6, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0596, 0x0004, 0x43, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0597, 0x0004, 0x43, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0598, 0x0204, 0x43, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0599, 0x0604, 0x26, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x059A, 0x0604, 0x26, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x059B, 0x0604, 0x26, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x059C, 0x0604, 0x26, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x059D, 0x0684, 0x26, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x059E, 0x0684, 0x26, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x059F, 0x0684, 0x26, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x00A3, 0x0604, 0x26, 0xC0, ZYDIS_INSTRUCTION_ENCODING_MVEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_64, ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x00A4, 0x0604, 0x26, 0xC0, ZYDIS_INSTRUCTION_ENCODING_MVEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_64, ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x00A5, 0x0684, 0x26, 0x00, ZYDIS_INSTRUCTION_ENCODING_MVEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_64, ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x05A0, 0x0604, 0x26, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x05A1, 0x0604, 0x26, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x05A2, 0x0604, 0x26, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x05A3, 0x0604, 0x26, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x05A4, 0x0684, 0x26, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x05A5, 0x0684, 0x26, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x05A6, 0x0684, 0x26, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x05A7, 0x0604, 0x26, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x05A8, 0x0604, 0x26, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x05A9, 0x0604, 0x26, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x05AA, 0x0604, 0x26, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x05AB, 0x0684, 0x26, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x05AC, 0x0684, 0x26, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x05AD, 0x0684, 0x26, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x00A6, 0x0604, 0x26, 0xC0, ZYDIS_INSTRUCTION_ENCODING_MVEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x00A7, 0x0604, 0x26, 0xC0, ZYDIS_INSTRUCTION_ENCODING_MVEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x00A8, 0x0684, 0x26, 0x00, ZYDIS_INSTRUCTION_ENCODING_MVEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x05AE, 0x1805, 0x27, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x05AF, 0x1805, 0x27, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x05B0, 0x1A05, 0x27, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x05B1, 0x1805, 0x27, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x05B2, 0x1805, 0x27, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x05B3, 0x1A05, 0x27, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x05B4, 0x1805, 0x27, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x05B5, 0x1805, 0x27, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x05B6, 0x1A05, 0x27, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x02D3, 0x0604, 0xCF, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x02D4, 0x0604, 0xCF, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x02D5, 0x0684, 0xCF, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x02D6, 0x0684, 0xCF, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x05B7, 0x1805, 0xCF, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x05B8, 0x1805, 0xCF, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x05B9, 0x1805, 0xCF, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x05BA, 0x1A05, 0xCF, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x05BB, 0x1A05, 0xCF, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x05BC, 0x1A05, 0xCF, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x02D7, 0x0604, 0xCE, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x02D8, 0x0604, 0xCE, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x02D9, 0x0684, 0xCE, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x02DA, 0x0684, 0xCE, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x05BD, 0x1805, 0xCE, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x05BE, 0x1805, 0xCE, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x05BF, 0x1805, 0xCE, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x05C0, 0x1A05, 0xCE, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x05C1, 0x1A05, 0xCE, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x05C2, 0x1A05, 0xCE, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x02DB, 0x0003, 0xCF, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x02DC, 0x0003, 0xCF, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x02DD, 0x0083, 0xCF, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x02DE, 0x0083, 0xCF, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x05C3, 0x0004, 0xCF, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x05C4, 0x0004, 0xCF, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x05C5, 0x0004, 0xCF, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x05C6, 0x0204, 0xCF, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x05C7, 0x0204, 0xCF, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x05C8, 0x0204, 0xCF, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x00A9, 0x0004, 0x51, 0xC0, ZYDIS_INSTRUCTION_ENCODING_MVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x00AA, 0x0004, 0x51, 0xC0, ZYDIS_INSTRUCTION_ENCODING_MVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x00AB, 0x0204, 0x51, 0x00, ZYDIS_INSTRUCTION_ENCODING_MVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x00AC, 0x0004, 0x53, 0xC0, ZYDIS_INSTRUCTION_ENCODING_MVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_64, ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x00AD, 0x0004, 0x53, 0xC0, ZYDIS_INSTRUCTION_ENCODING_MVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_64, ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x00AE, 0x0204, 0x53, 0x00, ZYDIS_INSTRUCTION_ENCODING_MVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_64, ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x00AF, 0x0004, 0x53, 0xC0, ZYDIS_INSTRUCTION_ENCODING_MVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x00B0, 0x0004, 0x53, 0xC0, ZYDIS_INSTRUCTION_ENCODING_MVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x00B1, 0x0204, 0x53, 0x00, ZYDIS_INSTRUCTION_ENCODING_MVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x00B2, 0x0004, 0x52, 0xC0, ZYDIS_INSTRUCTION_ENCODING_MVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_64, ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x00B3, 0x0004, 0x52, 0xC0, ZYDIS_INSTRUCTION_ENCODING_MVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_64, ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x00B4, 0x0204, 0x52, 0x00, ZYDIS_INSTRUCTION_ENCODING_MVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_64, ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x00B5, 0x0004, 0x52, 0xC0, ZYDIS_INSTRUCTION_ENCODING_MVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x00B6, 0x0004, 0x52, 0xC0, ZYDIS_INSTRUCTION_ENCODING_MVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x00B7, 0x0204, 0x52, 0x00, ZYDIS_INSTRUCTION_ENCODING_MVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x02DF, 0x0003, 0x7C, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x02E0, 0x0003, 0x7C, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x02E1, 0x0083, 0x7C, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x02E2, 0x0083, 0x7C, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x02E3, 0x0003, 0x7C, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F2, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x02E4, 0x0003, 0x7C, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F2, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x02E5, 0x0083, 0x7C, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F2, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x02E6, 0x0083, 0x7C, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F2, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x02E7, 0x0003, 0x7D, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x02E8, 0x0003, 0x7D, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x02E9, 0x0083, 0x7D, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x02EA, 0x0083, 0x7D, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x02EB, 0x0003, 0x7D, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F2, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x02EC, 0x0003, 0x7D, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F2, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x02ED, 0x0083, 0x7D, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F2, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x02EE, 0x0083, 0x7D, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F2, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x02EF, 0x0604, 0x18, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x02F0, 0x0684, 0x18, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x05C9, 0x1805, 0x18, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x05CA, 0x1805, 0x18, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x05CB, 0x1A05, 0x18, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x05CC, 0x1A05, 0x18, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x05CD, 0x1805, 0x1A, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x05CE, 0x1A05, 0x1A, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x05CF, 0x1805, 0x18, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x05D0, 0x1805, 0x18, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x05D1, 0x1A05, 0x18, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x05D2, 0x1A05, 0x18, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x05D3, 0x1805, 0x1A, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x05D4, 0x1A05, 0x1A, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x02F1, 0x0604, 0x38, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x02F2, 0x0684, 0x38, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x05D5, 0x1805, 0x38, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x05D6, 0x1805, 0x38, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x05D7, 0x1A05, 0x38, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x05D8, 0x1A05, 0x38, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x05D9, 0x1805, 0x3A, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x05DA, 0x1A05, 0x3A, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x05DB, 0x1805, 0x38, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x05DC, 0x1805, 0x38, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x05DD, 0x1A05, 0x38, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x05DE, 0x1A05, 0x38, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x05DF, 0x1805, 0x3A, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x05E0, 0x1A05, 0x3A, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x02F3, 0x0604, 0x21, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x02F4, 0x0684, 0x21, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x05E1, 0x0604, 0x21, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x05E2, 0x0684, 0x21, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x02F5, 0x0022, 0xF0, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F2, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x02F6, 0x0022, 0xF0, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F2, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x02F7, 0x0009, 0xAE, 0x10, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x00B8, 0x0083, 0xD4, 0x00, ZYDIS_INSTRUCTION_ENCODING_MVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x00B9, 0x0083, 0xD5, 0x00, ZYDIS_INSTRUCTION_ENCODING_MVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_64, ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x00BA, 0x0083, 0xD5, 0x00, ZYDIS_INSTRUCTION_ENCODING_MVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x00BB, 0x0083, 0xD4, 0x00, ZYDIS_INSTRUCTION_ENCODING_MVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_64, ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x00BC, 0x0083, 0xD0, 0x00, ZYDIS_INSTRUCTION_ENCODING_MVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x00BD, 0x0083, 0xD1, 0x00, ZYDIS_INSTRUCTION_ENCODING_MVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_64, ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x00BE, 0x0083, 0xD1, 0x00, ZYDIS_INSTRUCTION_ENCODING_MVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x00BF, 0x0083, 0xD0, 0x00, ZYDIS_INSTRUCTION_ENCODING_MVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_64, ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x00C0, 0x0003, 0xC9, 0xC0, ZYDIS_INSTRUCTION_ENCODING_MVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x00C1, 0x0003, 0xC9, 0xC0, ZYDIS_INSTRUCTION_ENCODING_MVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x00C2, 0x0083, 0xC9, 0x00, ZYDIS_INSTRUCTION_ENCODING_MVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x02F8, 0x0002, 0xF7, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_ASZ, ZYAN_FALSE },
    { 0x02F9, 0x0083, 0x2D, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x02FA, 0x0083, 0x2D, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x02FB, 0x000B, 0x2F, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x02FC, 0x000B, 0x2F, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x02FD, 0x0083, 0x2C, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x02FE, 0x0083, 0x2C, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x02FF, 0x000B, 0x2E, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0300, 0x000B, 0x2E, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0301, 0x0003, 0x5F, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0302, 0x0003, 0x5F, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0303, 0x0083, 0x5F, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0304, 0x0083, 0x5F, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x05E3, 0x0004, 0x5F, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x05E4, 0x0004, 0x5F, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x05E5, 0x0004, 0x5F, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x05E6, 0x0004, 0x5F, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x05E7, 0x0204, 0x5F, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x05E8, 0x0204, 0x5F, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x05E9, 0x0204, 0x5F, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x05EA, 0x0004, 0x5F, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_MAP5, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x05EB, 0x0004, 0x5F, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_MAP5, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x05EC, 0x0004, 0x5F, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_MAP5, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x05ED, 0x0004, 0x5F, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_MAP5, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x05EE, 0x0204, 0x5F, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_MAP5, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x05EF, 0x0204, 0x5F, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_MAP5, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x05F0, 0x0204, 0x5F, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_MAP5, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0305, 0x0003, 0x5F, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0306, 0x0003, 0x5F, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0307, 0x0083, 0x5F, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0308, 0x0083, 0x5F, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x05F1, 0x0004, 0x5F, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x05F2, 0x0004, 0x5F, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x05F3, 0x0004, 0x5F, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x05F4, 0x0004, 0x5F, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x05F5, 0x0204, 0x5F, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x05F6, 0x0204, 0x5F, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x05F7, 0x0204, 0x5F, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0309, 0x0003, 0x5F, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F2, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x030A, 0x0083, 0x5F, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F2, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x05F8, 0x0004, 0x5F, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F2, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x05F9, 0x0004, 0x5F, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F2, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x05FA, 0x0204, 0x5F, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F2, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x05FB, 0x0004, 0x5F, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_MAP5, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x05FC, 0x0004, 0x5F, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_MAP5, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x05FD, 0x0204, 0x5F, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_MAP5, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x030B, 0x0003, 0x5F, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x030C, 0x0083, 0x5F, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x05FE, 0x0004, 0x5F, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x05FF, 0x0004, 0x5F, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0600, 0x0204, 0x5F, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0740, 0x0000, 0x01, 0xC1, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0741, 0x0009, 0xC7, 0x30, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0742, 0x0000, 0x01, 0xD4, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x030D, 0x0003, 0x5D, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x030E, 0x0003, 0x5D, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x030F, 0x0083, 0x5D, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0310, 0x0083, 0x5D, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0601, 0x0004, 0x5D, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0602, 0x0004, 0x5D, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0603, 0x0004, 0x5D, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0604, 0x0004, 0x5D, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0605, 0x0204, 0x5D, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0606, 0x0204, 0x5D, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0607, 0x0204, 0x5D, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0608, 0x0004, 0x5D, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_MAP5, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0609, 0x0004, 0x5D, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_MAP5, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x060A, 0x0004, 0x5D, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_MAP5, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x060B, 0x0004, 0x5D, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_MAP5, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x060C, 0x0204, 0x5D, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_MAP5, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x060D, 0x0204, 0x5D, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_MAP5, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x060E, 0x0204, 0x5D, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_MAP5, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0311, 0x0003, 0x5D, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0312, 0x0003, 0x5D, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0313, 0x0083, 0x5D, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0314, 0x0083, 0x5D, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x060F, 0x0004, 0x5D, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0610, 0x0004, 0x5D, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0611, 0x0004, 0x5D, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0612, 0x0004, 0x5D, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0613, 0x0204, 0x5D, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0614, 0x0204, 0x5D, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0615, 0x0204, 0x5D, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0315, 0x0003, 0x5D, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F2, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0316, 0x0083, 0x5D, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F2, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0616, 0x0004, 0x5D, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F2, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0617, 0x0004, 0x5D, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F2, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0618, 0x0204, 0x5D, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F2, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0619, 0x0004, 0x5D, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_MAP5, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x061A, 0x0004, 0x5D, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_MAP5, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x061B, 0x0204, 0x5D, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_MAP5, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0317, 0x0003, 0x5D, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0318, 0x0083, 0x5D, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x061C, 0x0004, 0x5D, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x061D, 0x0004, 0x5D, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x061E, 0x0204, 0x5D, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0743, 0x0000, 0x01, 0xC2, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0744, 0x0001, 0x01, 0xDA, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0745, 0x0000, 0x01, 0xD9, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x031B, 0x0022, 0x28, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x031C, 0x0022, 0x28, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x031F, 0x000A, 0x29, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0320, 0x000A, 0x29, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0319, 0x0002, 0x28, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_TRUE },
    { 0x031D, 0x0002, 0x29, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x031A, 0x0002, 0x28, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_TRUE },
    { 0x031E, 0x0002, 0x29, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x061F, 0x0003, 0x28, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0620, 0x0003, 0x28, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0621, 0x0003, 0x28, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0622, 0x0083, 0x28, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0623, 0x0083, 0x28, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0624, 0x0083, 0x28, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0625, 0x0003, 0x29, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0626, 0x0003, 0x29, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0627, 0x0003, 0x29, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0628, 0x000B, 0x29, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0629, 0x000B, 0x29, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x062A, 0x000B, 0x29, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x00C3, 0x0003, 0x28, 0xC0, ZYDIS_INSTRUCTION_ENCODING_MVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_64, ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x00C4, 0x0003, 0x28, 0xC0, ZYDIS_INSTRUCTION_ENCODING_MVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_64, ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x00C5, 0x0083, 0x28, 0x00, ZYDIS_INSTRUCTION_ENCODING_MVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_64, ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x00C6, 0x000B, 0x29, 0x00, ZYDIS_INSTRUCTION_ENCODING_MVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_64, ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0323, 0x0022, 0x28, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0324, 0x0022, 0x28, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0327, 0x000A, 0x29, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0328, 0x000A, 0x29, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0321, 0x0002, 0x28, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_TRUE },
    { 0x0325, 0x0002, 0x29, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0322, 0x0002, 0x28, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_TRUE },
    { 0x0326, 0x0002, 0x29, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x062B, 0x0003, 0x28, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x062C, 0x0003, 0x28, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x062D, 0x0003, 0x28, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x062E, 0x0083, 0x28, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x062F, 0x0083, 0x28, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0630, 0x0083, 0x28, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0631, 0x0003, 0x29, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0632, 0x0003, 0x29, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0633, 0x0003, 0x29, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0634, 0x000B, 0x29, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0635, 0x000B, 0x29, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0636, 0x000B, 0x29, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x00C7, 0x0003, 0x28, 0xC0, ZYDIS_INSTRUCTION_ENCODING_MVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x00C8, 0x0003, 0x28, 0xC0, ZYDIS_INSTRUCTION_ENCODING_MVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x00C9, 0x0083, 0x28, 0x00, ZYDIS_INSTRUCTION_ENCODING_MVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x00CA, 0x000B, 0x29, 0x00, ZYDIS_INSTRUCTION_ENCODING_MVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0329, 0x0002, 0x6E, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_64, ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x032A, 0x0022, 0x6E, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_64, ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x032B, 0x0002, 0x6E, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x032C, 0x0022, 0x6E, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x032D, 0x0002, 0x7E, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_64, ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x032E, 0x000A, 0x7E, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_64, ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x032F, 0x0002, 0x7E, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0330, 0x000A, 0x7E, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0637, 0x0002, 0x6E, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0638, 0x0022, 0x6E, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0639, 0x0002, 0x6E, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x063A, 0x0022, 0x6E, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x063B, 0x0002, 0x7E, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x063C, 0x000A, 0x7E, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x063D, 0x0002, 0x7E, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x063E, 0x000A, 0x7E, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0331, 0x0002, 0x12, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F2, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0332, 0x0002, 0x12, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F2, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0333, 0x0022, 0x12, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F2, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0334, 0x0022, 0x12, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F2, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x063F, 0x0003, 0x12, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F2, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0640, 0x0003, 0x12, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F2, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0641, 0x0003, 0x12, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F2, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0642, 0x0083, 0x12, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F2, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0643, 0x0083, 0x12, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F2, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0644, 0x0083, 0x12, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F2, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0337, 0x0022, 0x6F, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0338, 0x0022, 0x6F, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x033B, 0x000A, 0x7F, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x033C, 0x000A, 0x7F, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0335, 0x0002, 0x6F, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_TRUE },
    { 0x0339, 0x0002, 0x7F, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0336, 0x0002, 0x6F, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_TRUE },
    { 0x033A, 0x0002, 0x7F, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0645, 0x0003, 0x6F, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0646, 0x0003, 0x6F, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0647, 0x0003, 0x6F, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0648, 0x0083, 0x6F, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0649, 0x0083, 0x6F, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x064A, 0x0083, 0x6F, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x064B, 0x0003, 0x7F, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x064C, 0x0003, 0x7F, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x064D, 0x0003, 0x7F, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x064E, 0x000B, 0x7F, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x064F, 0x000B, 0x7F, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0650, 0x000B, 0x7F, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x00CB, 0x0003, 0x6F, 0xC0, ZYDIS_INSTRUCTION_ENCODING_MVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x00CC, 0x0003, 0x6F, 0xC0, ZYDIS_INSTRUCTION_ENCODING_MVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x00CD, 0x0083, 0x6F, 0x00, ZYDIS_INSTRUCTION_ENCODING_MVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x00CE, 0x000B, 0x7F, 0x00, ZYDIS_INSTRUCTION_ENCODING_MVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0651, 0x0003, 0x6F, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0652, 0x0003, 0x6F, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0653, 0x0003, 0x6F, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0654, 0x0083, 0x6F, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0655, 0x0083, 0x6F, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0656, 0x0083, 0x6F, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0657, 0x0003, 0x7F, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0658, 0x0003, 0x7F, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0659, 0x0003, 0x7F, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x065A, 0x000B, 0x7F, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x065B, 0x000B, 0x7F, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x065C, 0x000B, 0x7F, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x00CF, 0x0003, 0x6F, 0xC0, ZYDIS_INSTRUCTION_ENCODING_MVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_64, ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x00D0, 0x0003, 0x6F, 0xC0, ZYDIS_INSTRUCTION_ENCODING_MVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_64, ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x00D1, 0x0083, 0x6F, 0x00, ZYDIS_INSTRUCTION_ENCODING_MVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_64, ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x00D2, 0x000B, 0x7F, 0x00, ZYDIS_INSTRUCTION_ENCODING_MVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_64, ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x033F, 0x0022, 0x6F, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0340, 0x0022, 0x6F, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0343, 0x000A, 0x7F, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0344, 0x000A, 0x7F, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x033D, 0x0002, 0x6F, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_TRUE },
    { 0x0341, 0x0002, 0x7F, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x033E, 0x0002, 0x6F, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_TRUE },
    { 0x0342, 0x0002, 0x7F, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x065D, 0x0003, 0x6F, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F2, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x065E, 0x0003, 0x6F, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F2, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x065F, 0x0003, 0x6F, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F2, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0660, 0x0083, 0x6F, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F2, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0661, 0x0083, 0x6F, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F2, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0662, 0x0083, 0x6F, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F2, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0663, 0x0003, 0x7F, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F2, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0664, 0x0003, 0x7F, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F2, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0665, 0x0003, 0x7F, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F2, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0666, 0x000B, 0x7F, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F2, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0667, 0x000B, 0x7F, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F2, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0668, 0x000B, 0x7F, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F2, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0669, 0x0003, 0x6F, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x066A, 0x0003, 0x6F, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x066B, 0x0003, 0x6F, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x066C, 0x0083, 0x6F, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x066D, 0x0083, 0x6F, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x066E, 0x0083, 0x6F, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x066F, 0x0003, 0x7F, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0670, 0x0003, 0x7F, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0671, 0x0003, 0x7F, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0672, 0x000B, 0x7F, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0673, 0x000B, 0x7F, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0674, 0x000B, 0x7F, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0675, 0x0003, 0x6F, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0676, 0x0003, 0x6F, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0677, 0x0003, 0x6F, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0678, 0x0083, 0x6F, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0679, 0x0083, 0x6F, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x067A, 0x0083, 0x6F, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x067B, 0x0003, 0x7F, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x067C, 0x0003, 0x7F, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x067D, 0x0003, 0x7F, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x067E, 0x000B, 0x7F, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x067F, 0x000B, 0x7F, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0680, 0x000B, 0x7F, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0681, 0x0003, 0x6F, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F2, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0682, 0x0003, 0x6F, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F2, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0683, 0x0003, 0x6F, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F2, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0684, 0x0083, 0x6F, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F2, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0685, 0x0083, 0x6F, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F2, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0686, 0x0083, 0x6F, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F2, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0687, 0x0003, 0x7F, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F2, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0688, 0x0003, 0x7F, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F2, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0689, 0x0003, 0x7F, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F2, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x068A, 0x000B, 0x7F, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F2, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x068B, 0x000B, 0x7F, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F2, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x068C, 0x000B, 0x7F, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F2, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0345, 0x0003, 0x12, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x068D, 0x0003, 0x12, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0346, 0x0083, 0x16, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0347, 0x000A, 0x17, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x068E, 0x0083, 0x16, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x068F, 0x000A, 0x17, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0348, 0x0083, 0x16, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0349, 0x000A, 0x17, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0690, 0x0083, 0x16, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0691, 0x000A, 0x17, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x034A, 0x0003, 0x16, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0692, 0x0003, 0x16, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x034B, 0x0083, 0x12, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x034C, 0x000A, 0x13, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0693, 0x0083, 0x12, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0694, 0x000A, 0x13, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x034D, 0x0083, 0x12, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x034E, 0x000A, 0x13, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0695, 0x0083, 0x12, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0696, 0x000A, 0x13, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x034F, 0x0002, 0x50, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0350, 0x0002, 0x50, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0351, 0x0002, 0x50, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0352, 0x0002, 0x50, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x00D3, 0x000B, 0x29, 0x00, ZYDIS_INSTRUCTION_ENCODING_MVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_64, ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x00D4, 0x000B, 0x29, 0x00, ZYDIS_INSTRUCTION_ENCODING_MVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F2, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x00D5, 0x000B, 0x29, 0x00, ZYDIS_INSTRUCTION_ENCODING_MVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_64, ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x00D6, 0x000B, 0x29, 0x00, ZYDIS_INSTRUCTION_ENCODING_MVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F2, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0353, 0x000A, 0xE7, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0354, 0x000A, 0xE7, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0697, 0x000A, 0xE7, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0698, 0x000A, 0xE7, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0699, 0x000A, 0xE7, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0355, 0x0022, 0x2A, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0356, 0x0022, 0x2A, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x069A, 0x0022, 0x2A, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x069B, 0x0022, 0x2A, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x069C, 0x0022, 0x2A, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0357, 0x000A, 0x2B, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0358, 0x000A, 0x2B, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x069D, 0x000A, 0x2B, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x069E, 0x000A, 0x2B, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x069F, 0x000A, 0x2B, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0359, 0x000A, 0x2B, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x035A, 0x000A, 0x2B, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x06A0, 0x000A, 0x2B, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x06A1, 0x000A, 0x2B, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x06A2, 0x000A, 0x2B, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0360, 0x0022, 0x7E, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0362, 0x000A, 0xD6, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x035F, 0x0002, 0x7E, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_TRUE },
    { 0x0361, 0x0002, 0xD6, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x035B, 0x0002, 0x6E, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_64, ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x035C, 0x0022, 0x6E, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_64, ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x035D, 0x0002, 0x7E, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_64, ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x035E, 0x000A, 0x7E, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_64, ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x06A3, 0x0002, 0x6E, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_64, ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x06A4, 0x0022, 0x6E, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_64, ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x06A5, 0x0002, 0x7E, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_64, ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x06A6, 0x000A, 0x7E, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_64, ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x06A7, 0x0002, 0x7E, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x06A8, 0x0022, 0x7E, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x06A9, 0x0002, 0xD6, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x06AA, 0x000A, 0xD6, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0364, 0x0022, 0x10, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F2, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0366, 0x000A, 0x11, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F2, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0363, 0x0003, 0x10, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F2, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_TRUE },
    { 0x0365, 0x0003, 0x11, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F2, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x06AB, 0x0004, 0x10, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F2, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x06AC, 0x0083, 0x10, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F2, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x06AD, 0x0004, 0x11, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F2, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x06AE, 0x000B, 0x11, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F2, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x06AF, 0x0004, 0x10, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_MAP5, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x06B0, 0x0083, 0x10, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_MAP5, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x06B1, 0x0004, 0x11, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_MAP5, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x06B2, 0x000B, 0x11, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_MAP5, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0367, 0x0002, 0x16, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0368, 0x0002, 0x16, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0369, 0x0022, 0x16, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x036A, 0x0022, 0x16, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x06B3, 0x0003, 0x16, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x06B4, 0x0003, 0x16, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x06B5, 0x0003, 0x16, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x06B6, 0x0083, 0x16, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x06B7, 0x0083, 0x16, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x06B8, 0x0083, 0x16, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x036B, 0x0002, 0x12, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x036C, 0x0002, 0x12, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x036D, 0x0022, 0x12, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x036E, 0x0022, 0x12, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x06B9, 0x0003, 0x12, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x06BA, 0x0003, 0x12, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x06BB, 0x0003, 0x12, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x06BC, 0x0083, 0x12, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x06BD, 0x0083, 0x12, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x06BE, 0x0083, 0x12, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0370, 0x0022, 0x10, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0372, 0x000A, 0x11, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x036F, 0x0003, 0x10, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_TRUE },
    { 0x0371, 0x0003, 0x11, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x06BF, 0x0004, 0x10, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x06C0, 0x0083, 0x10, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x06C1, 0x0004, 0x11, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x06C2, 0x000B, 0x11, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0375, 0x0022, 0x10, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0376, 0x0022, 0x10, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0379, 0x000A, 0x11, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x037A, 0x000A, 0x11, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0373, 0x0002, 0x10, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_TRUE },
    { 0x0377, 0x0002, 0x11, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0374, 0x0002, 0x10, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_TRUE },
    { 0x0378, 0x0002, 0x11, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x06C3, 0x0003, 0x10, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x06C4, 0x0003, 0x10, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x06C5, 0x0003, 0x10, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x06C6, 0x0083, 0x10, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x06C7, 0x0083, 0x10, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x06C8, 0x0083, 0x10, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x06C9, 0x0003, 0x11, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x06CA, 0x0003, 0x11, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x06CB, 0x0003, 0x11, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x06CC, 0x000B, 0x11, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x06CD, 0x000B, 0x11, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x06CE, 0x000B, 0x11, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x037D, 0x0022, 0x10, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x037E, 0x0022, 0x10, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0381, 0x000A, 0x11, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0382, 0x000A, 0x11, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x037B, 0x0002, 0x10, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_TRUE },
    { 0x037F, 0x0002, 0x11, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x037C, 0x0002, 0x10, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_TRUE },
    { 0x0380, 0x0002, 0x11, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x06CF, 0x0003, 0x10, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x06D0, 0x0003, 0x10, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x06D1, 0x0003, 0x10, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x06D2, 0x0083, 0x10, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x06D3, 0x0083, 0x10, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x06D4, 0x0083, 0x10, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x06D5, 0x0003, 0x11, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x06D6, 0x0003, 0x11, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x06D7, 0x0003, 0x11, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x06D8, 0x000B, 0x11, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x06D9, 0x000B, 0x11, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x06DA, 0x000B, 0x11, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x06DB, 0x0002, 0x6E, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_MAP5, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x06DC, 0x0022, 0x6E, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_MAP5, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x06DD, 0x0002, 0x7E, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_MAP5, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x06DE, 0x000A, 0x7E, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_MAP5, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0383, 0x0604, 0x42, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0384, 0x0604, 0x42, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0385, 0x0684, 0x42, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0386, 0x0684, 0x42, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0746, 0x0009, 0xC7, 0x30, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0747, 0x0009, 0xC7, 0x38, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0748, 0x0002, 0x78, 0xC0, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_64, ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0749, 0x000A, 0x78, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_64, ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x074A, 0x0002, 0x78, 0xC0, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x074B, 0x000A, 0x78, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x074C, 0x0000, 0x01, 0xC3, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x074D, 0x0001, 0x01, 0xD8, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x074E, 0x0001, 0x01, 0xDB, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0387, 0x0003, 0x59, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0388, 0x0003, 0x59, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0389, 0x0083, 0x59, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x038A, 0x0083, 0x59, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x06DF, 0x0004, 0x59, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x06E0, 0x0004, 0x59, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x06E1, 0x0004, 0x59, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x06E2, 0x0004, 0x59, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x06E3, 0x0204, 0x59, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x06E4, 0x0204, 0x59, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x06E5, 0x0204, 0x59, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x00D7, 0x0004, 0x59, 0xC0, ZYDIS_INSTRUCTION_ENCODING_MVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_64, ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x00D8, 0x0004, 0x59, 0xC0, ZYDIS_INSTRUCTION_ENCODING_MVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_64, ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x00D9, 0x0204, 0x59, 0x00, ZYDIS_INSTRUCTION_ENCODING_MVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_64, ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x06E6, 0x0004, 0x59, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_MAP5, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x06E7, 0x0004, 0x59, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_MAP5, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x06E8, 0x0004, 0x59, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_MAP5, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x06E9, 0x0004, 0x59, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_MAP5, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x06EA, 0x0204, 0x59, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_MAP5, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x06EB, 0x0204, 0x59, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_MAP5, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x06EC, 0x0204, 0x59, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_MAP5, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x038B, 0x0003, 0x59, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x038C, 0x0003, 0x59, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x038D, 0x0083, 0x59, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x038E, 0x0083, 0x59, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x06ED, 0x0004, 0x59, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x06EE, 0x0004, 0x59, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x06EF, 0x0004, 0x59, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x06F0, 0x0004, 0x59, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x06F1, 0x0204, 0x59, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x06F2, 0x0204, 0x59, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x06F3, 0x0204, 0x59, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x00DA, 0x0004, 0x59, 0xC0, ZYDIS_INSTRUCTION_ENCODING_MVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x00DB, 0x0004, 0x59, 0xC0, ZYDIS_INSTRUCTION_ENCODING_MVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x00DC, 0x0204, 0x59, 0x00, ZYDIS_INSTRUCTION_ENCODING_MVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x038F, 0x0003, 0x59, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F2, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0390, 0x0083, 0x59, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F2, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x06F4, 0x0004, 0x59, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F2, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x06F5, 0x0004, 0x59, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F2, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x06F6, 0x0204, 0x59, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F2, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x06F7, 0x0004, 0x59, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_MAP5, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x06F8, 0x0004, 0x59, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_MAP5, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x06F9, 0x0204, 0x59, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_MAP5, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0391, 0x0003, 0x59, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0392, 0x0083, 0x59, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x06FA, 0x0004, 0x59, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x06FB, 0x0004, 0x59, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x06FC, 0x0204, 0x59, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x074F, 0x0002, 0x79, 0xC0, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_64, ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0750, 0x0022, 0x79, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_64, ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0751, 0x0002, 0x79, 0xC0, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0752, 0x0022, 0x79, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0753, 0x0000, 0x01, 0xC4, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0754, 0x0009, 0xC7, 0x30, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0393, 0x0003, 0x56, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0394, 0x0003, 0x56, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0395, 0x0083, 0x56, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0396, 0x0083, 0x56, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x06FD, 0x0004, 0x56, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x06FE, 0x0004, 0x56, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x06FF, 0x0004, 0x56, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0700, 0x0204, 0x56, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0701, 0x0204, 0x56, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0702, 0x0204, 0x56, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0397, 0x0003, 0x56, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0398, 0x0003, 0x56, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0399, 0x0083, 0x56, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x039A, 0x0083, 0x56, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0703, 0x0004, 0x56, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0704, 0x0004, 0x56, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0705, 0x0004, 0x56, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0706, 0x0204, 0x56, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0707, 0x0204, 0x56, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0708, 0x0204, 0x56, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0709, 0x0003, 0x68, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F2, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x070A, 0x0003, 0x68, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F2, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x070B, 0x0003, 0x68, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F2, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x070C, 0x0083, 0x68, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F2, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x070D, 0x0083, 0x68, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F2, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x070E, 0x0083, 0x68, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F2, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x070F, 0x0003, 0x68, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F2, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0710, 0x0003, 0x68, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F2, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0711, 0x0003, 0x68, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F2, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0712, 0x0083, 0x68, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F2, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0713, 0x0083, 0x68, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F2, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0714, 0x0083, 0x68, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F2, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0715, 0x0204, 0x52, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F2, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0716, 0x0204, 0x53, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F2, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x039B, 0x0002, 0x1C, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x039C, 0x0002, 0x1C, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x039D, 0x0022, 0x1C, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x039E, 0x0022, 0x1C, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0717, 0x0003, 0x1C, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0718, 0x0003, 0x1C, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0719, 0x0003, 0x1C, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x071A, 0x0083, 0x1C, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x071B, 0x0083, 0x1C, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x071C, 0x0083, 0x1C, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x039F, 0x0002, 0x1E, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x03A0, 0x0002, 0x1E, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x03A1, 0x0022, 0x1E, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x03A2, 0x0022, 0x1E, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x071D, 0x0003, 0x1E, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x071E, 0x0003, 0x1E, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x071F, 0x0003, 0x1E, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0720, 0x0083, 0x1E, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0721, 0x0083, 0x1E, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0722, 0x0083, 0x1E, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0723, 0x0003, 0x1F, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0724, 0x0003, 0x1F, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0725, 0x0003, 0x1F, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0726, 0x0083, 0x1F, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0727, 0x0083, 0x1F, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0728, 0x0083, 0x1F, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x03A3, 0x0002, 0x1D, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x03A4, 0x0002, 0x1D, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x03A5, 0x0022, 0x1D, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x03A6, 0x0022, 0x1D, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0729, 0x0003, 0x1D, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x072A, 0x0003, 0x1D, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x072B, 0x0003, 0x1D, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x072C, 0x0083, 0x1D, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x072D, 0x0083, 0x1D, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x072E, 0x0083, 0x1D, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x03A7, 0x0003, 0x6B, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x03A8, 0x0003, 0x6B, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x03A9, 0x0083, 0x6B, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x03AA, 0x0083, 0x6B, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x072F, 0x0004, 0x6B, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0730, 0x0004, 0x6B, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0731, 0x0004, 0x6B, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0732, 0x0204, 0x6B, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0733, 0x0204, 0x6B, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0734, 0x0204, 0x6B, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x03AB, 0x0003, 0x63, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x03AC, 0x0003, 0x63, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x03AD, 0x0083, 0x63, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x03AE, 0x0083, 0x63, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0735, 0x0004, 0x63, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0736, 0x0004, 0x63, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0737, 0x0004, 0x63, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0738, 0x0204, 0x63, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0739, 0x0204, 0x63, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x073A, 0x0204, 0x63, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x00DD, 0x000B, 0xD4, 0x00, ZYDIS_INSTRUCTION_ENCODING_MVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x00DE, 0x000B, 0xD5, 0x00, ZYDIS_INSTRUCTION_ENCODING_MVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_64, ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x00DF, 0x000B, 0xD5, 0x00, ZYDIS_INSTRUCTION_ENCODING_MVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x00E0, 0x000B, 0xD4, 0x00, ZYDIS_INSTRUCTION_ENCODING_MVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_64, ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x00E1, 0x000B, 0xD0, 0x00, ZYDIS_INSTRUCTION_ENCODING_MVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x00E2, 0x000B, 0xD1, 0x00, ZYDIS_INSTRUCTION_ENCODING_MVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_64, ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x00E3, 0x000B, 0xD1, 0x00, ZYDIS_INSTRUCTION_ENCODING_MVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x00E4, 0x000B, 0xD0, 0x00, ZYDIS_INSTRUCTION_ENCODING_MVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_64, ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x03AF, 0x0003, 0x2B, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x03B0, 0x0003, 0x2B, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x03B1, 0x0083, 0x2B, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x03B2, 0x0083, 0x2B, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x073B, 0x0004, 0x2B, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x073C, 0x0004, 0x2B, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x073D, 0x0004, 0x2B, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x073E, 0x0204, 0x2B, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x073F, 0x0204, 0x2B, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0740, 0x0204, 0x2B, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x03B3, 0x0003, 0x67, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x03B4, 0x0003, 0x67, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x03B5, 0x0083, 0x67, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x03B6, 0x0083, 0x67, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0741, 0x0004, 0x67, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0742, 0x0004, 0x67, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0743, 0x0004, 0x67, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0744, 0x0204, 0x67, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0745, 0x0204, 0x67, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0746, 0x0204, 0x67, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x00E5, 0x0004, 0x5C, 0xC0, ZYDIS_INSTRUCTION_ENCODING_MVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x00E6, 0x0004, 0x5C, 0xC0, ZYDIS_INSTRUCTION_ENCODING_MVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x00E7, 0x0204, 0x5C, 0x00, ZYDIS_INSTRUCTION_ENCODING_MVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x03B7, 0x0003, 0xFC, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x03B8, 0x0003, 0xFC, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x03B9, 0x0083, 0xFC, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x03BA, 0x0083, 0xFC, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0747, 0x0004, 0xFC, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0748, 0x0004, 0xFC, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0749, 0x0004, 0xFC, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x074A, 0x0204, 0xFC, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x074B, 0x0204, 0xFC, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x074C, 0x0204, 0xFC, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x03BB, 0x0003, 0xFE, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x03BC, 0x0003, 0xFE, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x03BD, 0x0083, 0xFE, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x03BE, 0x0083, 0xFE, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x074D, 0x0004, 0xFE, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x074E, 0x0004, 0xFE, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x074F, 0x0004, 0xFE, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0750, 0x0204, 0xFE, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0751, 0x0204, 0xFE, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0752, 0x0204, 0xFE, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x00E8, 0x0004, 0xFE, 0xC0, ZYDIS_INSTRUCTION_ENCODING_MVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x00E9, 0x0004, 0xFE, 0xC0, ZYDIS_INSTRUCTION_ENCODING_MVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x00EA, 0x0204, 0xFE, 0x00, ZYDIS_INSTRUCTION_ENCODING_MVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x03BF, 0x0003, 0xD4, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x03C0, 0x0003, 0xD4, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x03C1, 0x0083, 0xD4, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x03C2, 0x0083, 0xD4, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0753, 0x0004, 0xD4, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0754, 0x0004, 0xD4, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0755, 0x0004, 0xD4, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0756, 0x0204, 0xD4, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0757, 0x0204, 0xD4, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0758, 0x0204, 0xD4, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x03C3, 0x0003, 0xEC, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x03C4, 0x0003, 0xEC, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x03C5, 0x0083, 0xEC, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x03C6, 0x0083, 0xEC, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0759, 0x0004, 0xEC, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x075A, 0x0004, 0xEC, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x075B, 0x0004, 0xEC, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x075C, 0x0204, 0xEC, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x075D, 0x0204, 0xEC, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x075E, 0x0204, 0xEC, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x00EB, 0x0004, 0x5D, 0xC0, ZYDIS_INSTRUCTION_ENCODING_MVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x00EC, 0x0004, 0x5D, 0xC0, ZYDIS_INSTRUCTION_ENCODING_MVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x00ED, 0x0204, 0x5D, 0x00, ZYDIS_INSTRUCTION_ENCODING_MVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x00EE, 0x0004, 0xCD, 0xC0, ZYDIS_INSTRUCTION_ENCODING_MVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x00EF, 0x0004, 0xCD, 0xC0, ZYDIS_INSTRUCTION_ENCODING_MVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x00F0, 0x0204, 0xCD, 0x00, ZYDIS_INSTRUCTION_ENCODING_MVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x03C7, 0x0003, 0xED, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x03C8, 0x0003, 0xED, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x03C9, 0x0083, 0xED, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x03CA, 0x0083, 0xED, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x075F, 0x0004, 0xED, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0760, 0x0004, 0xED, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0761, 0x0004, 0xED, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0762, 0x0204, 0xED, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0763, 0x0204, 0xED, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0764, 0x0204, 0xED, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x03CB, 0x0003, 0xDC, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x03CC, 0x0003, 0xDC, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x03CD, 0x0083, 0xDC, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x03CE, 0x0083, 0xDC, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0765, 0x0004, 0xDC, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0766, 0x0004, 0xDC, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0767, 0x0004, 0xDC, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0768, 0x0204, 0xDC, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0769, 0x0204, 0xDC, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x076A, 0x0204, 0xDC, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x03CF, 0x0003, 0xDD, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x03D0, 0x0003, 0xDD, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x03D1, 0x0083, 0xDD, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x03D2, 0x0083, 0xDD, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x076B, 0x0004, 0xDD, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x076C, 0x0004, 0xDD, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x076D, 0x0004, 0xDD, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x076E, 0x0204, 0xDD, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x076F, 0x0204, 0xDD, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0770, 0x0204, 0xDD, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x03D3, 0x0003, 0xFD, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x03D4, 0x0003, 0xFD, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x03D5, 0x0083, 0xFD, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x03D6, 0x0083, 0xFD, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0771, 0x0004, 0xFD, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0772, 0x0004, 0xFD, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0773, 0x0004, 0xFD, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0774, 0x0204, 0xFD, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0775, 0x0204, 0xFD, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0776, 0x0204, 0xFD, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x03D7, 0x0604, 0x0F, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x03D8, 0x0604, 0x0F, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x03D9, 0x0684, 0x0F, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x03DA, 0x0684, 0x0F, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0777, 0x1805, 0x0F, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0778, 0x1805, 0x0F, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0779, 0x1805, 0x0F, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x077A, 0x1A05, 0x0F, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x077B, 0x1A05, 0x0F, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x077C, 0x1A05, 0x0F, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x03DB, 0x0003, 0xDB, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x03DC, 0x0003, 0xDB, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x03DD, 0x0083, 0xDB, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x03DE, 0x0083, 0xDB, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x077D, 0x0004, 0xDB, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x077E, 0x0004, 0xDB, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x077F, 0x0004, 0xDB, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0780, 0x0204, 0xDB, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0781, 0x0204, 0xDB, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0782, 0x0204, 0xDB, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x00F1, 0x0004, 0xDB, 0xC0, ZYDIS_INSTRUCTION_ENCODING_MVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x00F2, 0x0004, 0xDB, 0xC0, ZYDIS_INSTRUCTION_ENCODING_MVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x00F3, 0x0204, 0xDB, 0x00, ZYDIS_INSTRUCTION_ENCODING_MVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x03DF, 0x0003, 0xDF, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x03E0, 0x0003, 0xDF, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x03E1, 0x0083, 0xDF, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x03E2, 0x0083, 0xDF, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0783, 0x0004, 0xDF, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0784, 0x0004, 0xDF, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0785, 0x0004, 0xDF, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0786, 0x0204, 0xDF, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0787, 0x0204, 0xDF, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0788, 0x0204, 0xDF, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x00F4, 0x0004, 0xDF, 0xC0, ZYDIS_INSTRUCTION_ENCODING_MVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x00F5, 0x0004, 0xDF, 0xC0, ZYDIS_INSTRUCTION_ENCODING_MVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x00F6, 0x0204, 0xDF, 0x00, ZYDIS_INSTRUCTION_ENCODING_MVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0789, 0x0004, 0xDF, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x078A, 0x0004, 0xDF, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x078B, 0x0004, 0xDF, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x078C, 0x0204, 0xDF, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x078D, 0x0204, 0xDF, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x078E, 0x0204, 0xDF, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x00F7, 0x0004, 0xDF, 0xC0, ZYDIS_INSTRUCTION_ENCODING_MVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_64, ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x00F8, 0x0004, 0xDF, 0xC0, ZYDIS_INSTRUCTION_ENCODING_MVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_64, ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x00F9, 0x0204, 0xDF, 0x00, ZYDIS_INSTRUCTION_ENCODING_MVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_64, ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x078F, 0x0004, 0xDB, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0790, 0x0004, 0xDB, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0791, 0x0004, 0xDB, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0792, 0x0204, 0xDB, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0793, 0x0204, 0xDB, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0794, 0x0204, 0xDB, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x00FA, 0x0004, 0xDB, 0xC0, ZYDIS_INSTRUCTION_ENCODING_MVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_64, ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x00FB, 0x0004, 0xDB, 0xC0, ZYDIS_INSTRUCTION_ENCODING_MVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_64, ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x00FC, 0x0204, 0xDB, 0x00, ZYDIS_INSTRUCTION_ENCODING_MVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_64, ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x03E3, 0x0003, 0xE0, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x03E4, 0x0003, 0xE0, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x03E5, 0x0083, 0xE0, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x03E6, 0x0083, 0xE0, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0795, 0x0004, 0xE0, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0796, 0x0004, 0xE0, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0797, 0x0004, 0xE0, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0798, 0x0204, 0xE0, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0799, 0x0204, 0xE0, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x079A, 0x0204, 0xE0, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x03E7, 0x0003, 0xE3, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x03E8, 0x0003, 0xE3, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x03E9, 0x0083, 0xE3, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x03EA, 0x0083, 0xE3, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x079B, 0x0004, 0xE3, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x079C, 0x0004, 0xE3, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x079D, 0x0004, 0xE3, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x079E, 0x0204, 0xE3, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x079F, 0x0204, 0xE3, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x07A0, 0x0204, 0xE3, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x03EB, 0x0604, 0x02, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x03EC, 0x0604, 0x02, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x03ED, 0x0684, 0x02, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x03EE, 0x0684, 0x02, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x07A1, 0x0004, 0x66, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x07A2, 0x0004, 0x66, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x07A3, 0x0004, 0x66, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x07A4, 0x0204, 0x66, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x07A5, 0x0204, 0x66, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x07A6, 0x0204, 0x66, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x07A7, 0x0004, 0x64, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x07A8, 0x0004, 0x64, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x07A9, 0x0004, 0x64, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x07AA, 0x0204, 0x64, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x07AB, 0x0204, 0x64, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x07AC, 0x0204, 0x64, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x00FD, 0x0004, 0x64, 0xC0, ZYDIS_INSTRUCTION_ENCODING_MVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x00FE, 0x0004, 0x64, 0xC0, ZYDIS_INSTRUCTION_ENCODING_MVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x00FF, 0x0204, 0x64, 0x00, ZYDIS_INSTRUCTION_ENCODING_MVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x07AD, 0x0004, 0x64, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x07AE, 0x0004, 0x64, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x07AF, 0x0004, 0x64, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x07B0, 0x0204, 0x64, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x07B1, 0x0204, 0x64, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x07B2, 0x0204, 0x64, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0100, 0x0004, 0x64, 0xC0, ZYDIS_INSTRUCTION_ENCODING_MVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_64, ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0101, 0x0004, 0x64, 0xC0, ZYDIS_INSTRUCTION_ENCODING_MVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_64, ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0102, 0x0204, 0x64, 0x00, ZYDIS_INSTRUCTION_ENCODING_MVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_64, ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x07B3, 0x0004, 0x66, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x07B4, 0x0004, 0x66, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x07B5, 0x0004, 0x66, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x07B6, 0x0204, 0x66, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x07B7, 0x0204, 0x66, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x07B8, 0x0204, 0x66, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x03EF, 0x0004, 0x4C, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x03F0, 0x0004, 0x4C, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x03F1, 0x0084, 0x4C, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x03F2, 0x0084, 0x4C, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x03F3, 0x0604, 0x0E, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x03F4, 0x0604, 0x0E, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x03F5, 0x0684, 0x0E, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x03F6, 0x0684, 0x0E, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x03F7, 0x0002, 0x78, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x03F8, 0x0002, 0x78, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x03F9, 0x0022, 0x78, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x03FA, 0x0022, 0x78, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x07B9, 0x0003, 0x78, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x07BA, 0x0003, 0x78, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x07BB, 0x0003, 0x78, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x07BC, 0x0083, 0x78, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x07BD, 0x0083, 0x78, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x07BE, 0x0083, 0x78, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x07BF, 0x0003, 0x7A, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x07C0, 0x0003, 0x7A, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x07C1, 0x0003, 0x7A, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x03FB, 0x0002, 0x58, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x03FC, 0x0002, 0x58, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x03FD, 0x0022, 0x58, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x03FE, 0x0022, 0x58, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x07C2, 0x0003, 0x58, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x07C3, 0x0003, 0x58, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x07C4, 0x0003, 0x58, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x07C5, 0x0083, 0x58, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x07C6, 0x0083, 0x58, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x07C7, 0x0083, 0x58, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x07C8, 0x0003, 0x7C, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x07C9, 0x0003, 0x7C, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x07CA, 0x0003, 0x7C, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x07CB, 0x0003, 0x7C, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x07CC, 0x0003, 0x7C, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x07CD, 0x0003, 0x7C, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0103, 0x0083, 0x58, 0x00, ZYDIS_INSTRUCTION_ENCODING_MVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x07CE, 0x0002, 0x2A, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x07CF, 0x0002, 0x2A, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x07D0, 0x0002, 0x2A, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x07D1, 0x0002, 0x3A, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x07D2, 0x0002, 0x3A, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x07D3, 0x0002, 0x3A, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x03FF, 0x0002, 0x59, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0400, 0x0002, 0x59, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0401, 0x0022, 0x59, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0402, 0x0022, 0x59, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x07D4, 0x0003, 0x59, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x07D5, 0x0003, 0x59, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x07D6, 0x0003, 0x59, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x07D7, 0x0083, 0x59, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x07D8, 0x0083, 0x59, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x07D9, 0x0083, 0x59, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x07DA, 0x0003, 0x7C, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_64, ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x07DB, 0x0003, 0x7C, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_64, ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x07DC, 0x0003, 0x7C, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_64, ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0104, 0x0083, 0x59, 0x00, ZYDIS_INSTRUCTION_ENCODING_MVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_64, ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0403, 0x0002, 0x79, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0404, 0x0002, 0x79, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0405, 0x0022, 0x79, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0406, 0x0022, 0x79, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x07DD, 0x0003, 0x79, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x07DE, 0x0003, 0x79, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x07DF, 0x0003, 0x79, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x07E0, 0x0083, 0x79, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x07E1, 0x0083, 0x79, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x07E2, 0x0083, 0x79, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x07E3, 0x0003, 0x7B, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x07E4, 0x0003, 0x7B, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x07E5, 0x0003, 0x7B, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0407, 0x0604, 0x44, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0408, 0x0604, 0x44, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0409, 0x0684, 0x44, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x040A, 0x0684, 0x44, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x07E6, 0x0604, 0x44, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x07E7, 0x0604, 0x44, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x07E8, 0x0604, 0x44, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x07E9, 0x0684, 0x44, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x07EA, 0x0684, 0x44, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x07EB, 0x0684, 0x44, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0026, 0x0004, 0xA2, 0xC0, ZYDIS_INSTRUCTION_ENCODING_XOP, ZYDIS_OPCODE_MAP_XOP8, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0027, 0x0004, 0xA2, 0xC0, ZYDIS_INSTRUCTION_ENCODING_XOP, ZYDIS_OPCODE_MAP_XOP8, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0028, 0x0004, 0xA2, 0xC0, ZYDIS_INSTRUCTION_ENCODING_XOP, ZYDIS_OPCODE_MAP_XOP8, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0029, 0x0004, 0xA2, 0xC0, ZYDIS_INSTRUCTION_ENCODING_XOP, ZYDIS_OPCODE_MAP_XOP8, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x002A, 0x0084, 0xA2, 0x00, ZYDIS_INSTRUCTION_ENCODING_XOP, ZYDIS_OPCODE_MAP_XOP8, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x002B, 0x0204, 0xA2, 0x00, ZYDIS_INSTRUCTION_ENCODING_XOP, ZYDIS_OPCODE_MAP_XOP8, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x002C, 0x0084, 0xA2, 0x00, ZYDIS_INSTRUCTION_ENCODING_XOP, ZYDIS_OPCODE_MAP_XOP8, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x002D, 0x0204, 0xA2, 0x00, ZYDIS_INSTRUCTION_ENCODING_XOP, ZYDIS_OPCODE_MAP_XOP8, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x07EC, 0x1805, 0x3F, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x07ED, 0x1805, 0x3F, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x07EE, 0x1805, 0x3F, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x07EF, 0x1A05, 0x3F, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x07F0, 0x1A05, 0x3F, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x07F1, 0x1A05, 0x3F, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x07F2, 0x1805, 0x1F, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x07F3, 0x1805, 0x1F, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x07F4, 0x1805, 0x1F, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x07F5, 0x1A05, 0x1F, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x07F6, 0x1A05, 0x1F, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x07F7, 0x1A05, 0x1F, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0105, 0x1805, 0x1F, 0xC0, ZYDIS_INSTRUCTION_ENCODING_MVEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0106, 0x1805, 0x1F, 0xC0, ZYDIS_INSTRUCTION_ENCODING_MVEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0107, 0x1A05, 0x1F, 0x00, ZYDIS_INSTRUCTION_ENCODING_MVEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x040B, 0x0003, 0x74, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x040C, 0x0003, 0x74, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x040D, 0x0083, 0x74, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x040E, 0x0083, 0x74, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x07F8, 0x0004, 0x74, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x07F9, 0x0004, 0x74, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x07FA, 0x0004, 0x74, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x07FB, 0x0204, 0x74, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x07FC, 0x0204, 0x74, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x07FD, 0x0204, 0x74, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x040F, 0x0003, 0x76, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0410, 0x0003, 0x76, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0411, 0x0083, 0x76, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0412, 0x0083, 0x76, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x07FE, 0x0004, 0x76, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x07FF, 0x0004, 0x76, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0800, 0x0004, 0x76, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0801, 0x0204, 0x76, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0802, 0x0204, 0x76, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0803, 0x0204, 0x76, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0108, 0x0004, 0x76, 0xC0, ZYDIS_INSTRUCTION_ENCODING_MVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0109, 0x0004, 0x76, 0xC0, ZYDIS_INSTRUCTION_ENCODING_MVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x010A, 0x0204, 0x76, 0x00, ZYDIS_INSTRUCTION_ENCODING_MVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0413, 0x0003, 0x29, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0414, 0x0003, 0x29, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0415, 0x0083, 0x29, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0416, 0x0083, 0x29, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0804, 0x0004, 0x29, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0805, 0x0004, 0x29, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0806, 0x0004, 0x29, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0807, 0x0204, 0x29, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0808, 0x0204, 0x29, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0809, 0x0204, 0x29, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0417, 0x0003, 0x75, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0418, 0x0003, 0x75, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0419, 0x0083, 0x75, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x041A, 0x0083, 0x75, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x080A, 0x0004, 0x75, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x080B, 0x0004, 0x75, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x080C, 0x0004, 0x75, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x080D, 0x0204, 0x75, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x080E, 0x0204, 0x75, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x080F, 0x0204, 0x75, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x041B, 0x0183, 0x61, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_OSZ, ZYAN_FALSE },
    { 0x041D, 0x01A3, 0x61, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_OSZ, ZYAN_FALSE },
    { 0x041F, 0x0183, 0x60, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_64, ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_OSZ, ZYAN_FALSE },
    { 0x0421, 0x01A3, 0x60, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_64, ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_OSZ, ZYAN_FALSE },
    { 0x0423, 0x0183, 0x60, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0424, 0x01A3, 0x60, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0425, 0x0003, 0x64, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0426, 0x0003, 0x64, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0427, 0x0083, 0x64, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0428, 0x0083, 0x64, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0810, 0x0004, 0x64, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0811, 0x0004, 0x64, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0812, 0x0004, 0x64, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0813, 0x0204, 0x64, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0814, 0x0204, 0x64, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0815, 0x0204, 0x64, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0429, 0x0003, 0x66, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x042A, 0x0003, 0x66, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x042B, 0x0083, 0x66, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x042C, 0x0083, 0x66, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0816, 0x0004, 0x66, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0817, 0x0004, 0x66, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0818, 0x0004, 0x66, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0819, 0x0204, 0x66, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x081A, 0x0204, 0x66, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x081B, 0x0204, 0x66, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x010B, 0x0004, 0x66, 0xC0, ZYDIS_INSTRUCTION_ENCODING_MVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x010C, 0x0004, 0x66, 0xC0, ZYDIS_INSTRUCTION_ENCODING_MVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x010D, 0x0204, 0x66, 0x00, ZYDIS_INSTRUCTION_ENCODING_MVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x042D, 0x0003, 0x37, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x042E, 0x0003, 0x37, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x042F, 0x0083, 0x37, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0430, 0x0083, 0x37, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x081C, 0x0004, 0x37, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x081D, 0x0004, 0x37, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x081E, 0x0004, 0x37, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x081F, 0x0204, 0x37, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0820, 0x0204, 0x37, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0821, 0x0204, 0x37, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0431, 0x0003, 0x65, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0432, 0x0003, 0x65, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0433, 0x0083, 0x65, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0434, 0x0083, 0x65, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0822, 0x0004, 0x65, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0823, 0x0004, 0x65, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0824, 0x0004, 0x65, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0825, 0x0204, 0x65, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0826, 0x0204, 0x65, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0827, 0x0204, 0x65, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0435, 0x0183, 0x63, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0436, 0x01A3, 0x63, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0437, 0x0183, 0x62, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0438, 0x01A3, 0x62, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x010E, 0x0004, 0x74, 0xC0, ZYDIS_INSTRUCTION_ENCODING_MVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x010F, 0x0004, 0x74, 0xC0, ZYDIS_INSTRUCTION_ENCODING_MVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0110, 0x0204, 0x74, 0x00, ZYDIS_INSTRUCTION_ENCODING_MVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0828, 0x1805, 0x1F, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0829, 0x1805, 0x1F, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x082A, 0x1805, 0x1F, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x082B, 0x1A05, 0x1F, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x082C, 0x1A05, 0x1F, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x082D, 0x1A05, 0x1F, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x082E, 0x1805, 0x3E, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x082F, 0x1805, 0x3E, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0830, 0x1805, 0x3E, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0831, 0x1A05, 0x3E, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0832, 0x1A05, 0x3E, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0833, 0x1A05, 0x3E, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0834, 0x1805, 0x1E, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0835, 0x1805, 0x1E, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0836, 0x1805, 0x1E, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0837, 0x1A05, 0x1E, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0838, 0x1A05, 0x1E, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0839, 0x1A05, 0x1E, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0111, 0x1805, 0x1E, 0xC0, ZYDIS_INSTRUCTION_ENCODING_MVEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0112, 0x1805, 0x1E, 0xC0, ZYDIS_INSTRUCTION_ENCODING_MVEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0113, 0x1A05, 0x1E, 0x00, ZYDIS_INSTRUCTION_ENCODING_MVEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x083A, 0x1805, 0x1E, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x083B, 0x1805, 0x1E, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x083C, 0x1805, 0x1E, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x083D, 0x1A05, 0x1E, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x083E, 0x1A05, 0x1E, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x083F, 0x1A05, 0x1E, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0840, 0x1805, 0x3E, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0841, 0x1805, 0x3E, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0842, 0x1805, 0x3E, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0843, 0x1A05, 0x3E, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0844, 0x1A05, 0x3E, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0845, 0x1A05, 0x3E, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0846, 0x1805, 0x3F, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0847, 0x1805, 0x3F, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0848, 0x1805, 0x3F, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0849, 0x1A05, 0x3F, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x084A, 0x1A05, 0x3F, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x084B, 0x1A05, 0x3F, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x002E, 0x0604, 0xCC, 0xC0, ZYDIS_INSTRUCTION_ENCODING_XOP, ZYDIS_OPCODE_MAP_XOP8, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x002F, 0x0684, 0xCC, 0x00, ZYDIS_INSTRUCTION_ENCODING_XOP, ZYDIS_OPCODE_MAP_XOP8, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0030, 0x0604, 0xCE, 0xC0, ZYDIS_INSTRUCTION_ENCODING_XOP, ZYDIS_OPCODE_MAP_XOP8, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0031, 0x0684, 0xCE, 0x00, ZYDIS_INSTRUCTION_ENCODING_XOP, ZYDIS_OPCODE_MAP_XOP8, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x084C, 0x0003, 0x63, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x084D, 0x0003, 0x63, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x084E, 0x0003, 0x63, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x084F, 0x000B, 0x63, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0850, 0x000B, 0x63, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0851, 0x000B, 0x63, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0852, 0x0003, 0x8B, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0853, 0x0003, 0x8B, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0854, 0x0003, 0x8B, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0855, 0x000B, 0x8B, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0856, 0x000B, 0x8B, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0857, 0x000B, 0x8B, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0858, 0x0003, 0x8B, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0859, 0x0003, 0x8B, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x085A, 0x0003, 0x8B, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x085B, 0x000B, 0x8B, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x085C, 0x000B, 0x8B, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x085D, 0x000B, 0x8B, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x085E, 0x0003, 0x63, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x085F, 0x0003, 0x63, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0860, 0x0003, 0x63, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0861, 0x000B, 0x63, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0862, 0x000B, 0x63, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0863, 0x000B, 0x63, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0032, 0x0604, 0xCF, 0xC0, ZYDIS_INSTRUCTION_ENCODING_XOP, ZYDIS_OPCODE_MAP_XOP8, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0033, 0x0684, 0xCF, 0x00, ZYDIS_INSTRUCTION_ENCODING_XOP, ZYDIS_OPCODE_MAP_XOP8, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0034, 0x0604, 0xEC, 0xC0, ZYDIS_INSTRUCTION_ENCODING_XOP, ZYDIS_OPCODE_MAP_XOP8, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0035, 0x0684, 0xEC, 0x00, ZYDIS_INSTRUCTION_ENCODING_XOP, ZYDIS_OPCODE_MAP_XOP8, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0036, 0x0604, 0xEE, 0xC0, ZYDIS_INSTRUCTION_ENCODING_XOP, ZYDIS_OPCODE_MAP_XOP8, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0037, 0x0684, 0xEE, 0x00, ZYDIS_INSTRUCTION_ENCODING_XOP, ZYDIS_OPCODE_MAP_XOP8, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0038, 0x0604, 0xEF, 0xC0, ZYDIS_INSTRUCTION_ENCODING_XOP, ZYDIS_OPCODE_MAP_XOP8, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0039, 0x0684, 0xEF, 0x00, ZYDIS_INSTRUCTION_ENCODING_XOP, ZYDIS_OPCODE_MAP_XOP8, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x003A, 0x0604, 0xED, 0xC0, ZYDIS_INSTRUCTION_ENCODING_XOP, ZYDIS_OPCODE_MAP_XOP8, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x003B, 0x0684, 0xED, 0x00, ZYDIS_INSTRUCTION_ENCODING_XOP, ZYDIS_OPCODE_MAP_XOP8, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x003C, 0x0604, 0xCD, 0xC0, ZYDIS_INSTRUCTION_ENCODING_XOP, ZYDIS_OPCODE_MAP_XOP8, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x003D, 0x0684, 0xCD, 0x00, ZYDIS_INSTRUCTION_ENCODING_XOP, ZYDIS_OPCODE_MAP_XOP8, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0864, 0x0003, 0xC4, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0865, 0x0003, 0xC4, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0866, 0x0003, 0xC4, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0867, 0x0083, 0xC4, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0868, 0x0083, 0xC4, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0869, 0x0083, 0xC4, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x086A, 0x0003, 0xC4, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x086B, 0x0003, 0xC4, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x086C, 0x0003, 0xC4, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x086D, 0x0083, 0xC4, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x086E, 0x0083, 0xC4, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x086F, 0x0083, 0xC4, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0439, 0x0003, 0x50, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F2, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x043A, 0x0003, 0x50, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F2, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x043B, 0x0083, 0x50, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F2, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x043C, 0x0083, 0x50, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F2, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x043D, 0x0003, 0x51, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F2, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x043E, 0x0003, 0x51, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F2, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x043F, 0x0083, 0x51, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F2, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0440, 0x0083, 0x51, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F2, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0441, 0x0003, 0x50, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0442, 0x0003, 0x50, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0443, 0x0083, 0x50, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0444, 0x0083, 0x50, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0445, 0x0003, 0x51, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0446, 0x0003, 0x51, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0447, 0x0083, 0x51, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0448, 0x0083, 0x51, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0449, 0x0003, 0x50, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x044A, 0x0003, 0x50, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x044B, 0x0083, 0x50, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x044C, 0x0083, 0x50, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0870, 0x0004, 0x50, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0871, 0x0004, 0x50, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0872, 0x0004, 0x50, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0873, 0x0204, 0x50, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0874, 0x0204, 0x50, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0875, 0x0204, 0x50, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x044D, 0x0003, 0x51, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x044E, 0x0003, 0x51, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x044F, 0x0083, 0x51, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0450, 0x0083, 0x51, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0876, 0x0004, 0x51, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0877, 0x0004, 0x51, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0878, 0x0004, 0x51, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0879, 0x0204, 0x51, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x087A, 0x0204, 0x51, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x087B, 0x0204, 0x51, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0451, 0x0003, 0x50, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0452, 0x0003, 0x50, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0453, 0x0083, 0x50, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0454, 0x0083, 0x50, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0455, 0x0003, 0x51, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0456, 0x0003, 0x51, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0457, 0x0083, 0x51, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0458, 0x0083, 0x51, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0459, 0x0003, 0x52, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x045A, 0x0003, 0x52, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x045B, 0x0083, 0x52, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x045C, 0x0083, 0x52, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x087C, 0x0004, 0x52, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x087D, 0x0004, 0x52, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x087E, 0x0004, 0x52, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x087F, 0x0204, 0x52, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0880, 0x0204, 0x52, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0881, 0x0204, 0x52, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x045D, 0x0003, 0x53, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x045E, 0x0003, 0x53, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x045F, 0x0083, 0x53, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0460, 0x0083, 0x53, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0882, 0x0004, 0x53, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0883, 0x0004, 0x53, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0884, 0x0004, 0x53, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0885, 0x0204, 0x53, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0886, 0x0204, 0x53, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0887, 0x0204, 0x53, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0461, 0x0003, 0xD2, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0462, 0x0003, 0xD2, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0463, 0x0083, 0xD2, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0464, 0x0083, 0xD2, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0465, 0x0003, 0xD3, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0466, 0x0003, 0xD3, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0467, 0x0083, 0xD3, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0468, 0x0083, 0xD3, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0469, 0x0003, 0xD2, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x046A, 0x0003, 0xD2, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x046B, 0x0083, 0xD2, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x046C, 0x0083, 0xD2, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x046D, 0x0003, 0xD3, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x046E, 0x0003, 0xD3, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x046F, 0x0083, 0xD3, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0470, 0x0083, 0xD3, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0471, 0x0003, 0xD2, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0472, 0x0003, 0xD2, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0473, 0x0083, 0xD2, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0474, 0x0083, 0xD2, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0475, 0x0003, 0xD3, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0476, 0x0003, 0xD3, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0477, 0x0083, 0xD3, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0478, 0x0083, 0xD3, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0479, 0x0604, 0x06, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x047A, 0x0684, 0x06, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x047B, 0x0604, 0x46, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x047C, 0x0684, 0x46, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0888, 0x0004, 0x8D, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0889, 0x0004, 0x8D, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x088A, 0x0004, 0x8D, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x088B, 0x0204, 0x8D, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x088C, 0x0204, 0x8D, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x088D, 0x0204, 0x8D, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x047D, 0x0003, 0x36, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x047E, 0x0083, 0x36, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x088E, 0x0004, 0x36, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x088F, 0x0004, 0x36, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0890, 0x0204, 0x36, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0891, 0x0204, 0x36, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0114, 0x0004, 0x36, 0xC0, ZYDIS_INSTRUCTION_ENCODING_MVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0115, 0x0204, 0x36, 0x00, ZYDIS_INSTRUCTION_ENCODING_MVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0116, 0x0604, 0x07, 0xC0, ZYDIS_INSTRUCTION_ENCODING_MVEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0117, 0x0604, 0x07, 0xC0, ZYDIS_INSTRUCTION_ENCODING_MVEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0118, 0x0684, 0x07, 0x00, ZYDIS_INSTRUCTION_ENCODING_MVEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0892, 0x0004, 0x75, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0893, 0x0004, 0x75, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0894, 0x0004, 0x75, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0895, 0x0204, 0x75, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0896, 0x0204, 0x75, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0897, 0x0204, 0x75, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0898, 0x0004, 0x76, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0899, 0x0004, 0x76, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x089A, 0x0004, 0x76, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x089B, 0x0204, 0x76, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x089C, 0x0204, 0x76, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x089D, 0x0204, 0x76, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x089E, 0x0004, 0x77, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x089F, 0x0004, 0x77, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x08A0, 0x0004, 0x77, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x08A1, 0x0204, 0x77, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x08A2, 0x0204, 0x77, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x08A3, 0x0204, 0x77, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x08A4, 0x0004, 0x77, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x08A5, 0x0004, 0x77, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x08A6, 0x0004, 0x77, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x08A7, 0x0204, 0x77, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x08A8, 0x0204, 0x77, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x08A9, 0x0204, 0x77, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x08AA, 0x0004, 0x76, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x08AB, 0x0004, 0x76, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x08AC, 0x0004, 0x76, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x08AD, 0x0204, 0x76, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x08AE, 0x0204, 0x76, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x08AF, 0x0204, 0x76, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x08B0, 0x0004, 0x75, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x08B1, 0x0004, 0x75, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x08B2, 0x0004, 0x75, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x08B3, 0x0204, 0x75, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x08B4, 0x0204, 0x75, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x08B5, 0x0204, 0x75, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x047F, 0x1805, 0x49, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0480, 0x1805, 0x49, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0481, 0x1805, 0x49, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0482, 0x1805, 0x49, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0483, 0x1885, 0x49, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0484, 0x1A05, 0x49, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0485, 0x1885, 0x49, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0486, 0x1A05, 0x49, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0487, 0x1805, 0x48, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0488, 0x1805, 0x48, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0489, 0x1805, 0x48, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x048A, 0x1805, 0x48, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x048B, 0x1885, 0x48, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x048C, 0x1A05, 0x48, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x048D, 0x1885, 0x48, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x048E, 0x1A05, 0x48, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x048F, 0x0003, 0x0D, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0490, 0x0003, 0x0D, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0491, 0x0083, 0x0D, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0492, 0x0083, 0x0D, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0493, 0x0183, 0x05, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0494, 0x0183, 0x05, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0495, 0x01A3, 0x05, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0496, 0x01A3, 0x05, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x08B6, 0x0004, 0x0D, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x08B7, 0x0004, 0x0D, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x08B8, 0x0004, 0x0D, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x08B9, 0x0204, 0x0D, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x08BA, 0x0204, 0x0D, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x08BB, 0x0204, 0x0D, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x08BC, 0x0604, 0x05, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x08BD, 0x0604, 0x05, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x08BE, 0x0604, 0x05, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x08BF, 0x0684, 0x05, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x08C0, 0x0684, 0x05, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x08C1, 0x0684, 0x05, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0497, 0x0003, 0x0C, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0498, 0x0003, 0x0C, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0499, 0x0083, 0x0C, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x049A, 0x0083, 0x0C, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x049B, 0x0183, 0x04, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x049C, 0x0183, 0x04, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x049D, 0x01A3, 0x04, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x049E, 0x01A3, 0x04, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x08C2, 0x0004, 0x0C, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x08C3, 0x0004, 0x0C, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x08C4, 0x0004, 0x0C, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x08C5, 0x0204, 0x0C, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x08C6, 0x0204, 0x0C, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x08C7, 0x0204, 0x0C, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x08C8, 0x0604, 0x04, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x08C9, 0x0604, 0x04, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x08CA, 0x0604, 0x04, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x08CB, 0x0684, 0x04, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x08CC, 0x0684, 0x04, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x08CD, 0x0684, 0x04, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x049F, 0x0183, 0x01, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x04A0, 0x01A3, 0x01, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x08CE, 0x0004, 0x16, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x08CF, 0x0004, 0x16, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x08D0, 0x0204, 0x16, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x08D1, 0x0204, 0x16, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x08D2, 0x0604, 0x01, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x08D3, 0x0604, 0x01, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x08D4, 0x0684, 0x01, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x08D5, 0x0684, 0x01, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x04A1, 0x0003, 0x16, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x04A2, 0x0083, 0x16, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x08D6, 0x0004, 0x16, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x08D7, 0x0004, 0x16, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x08D8, 0x0204, 0x16, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x08D9, 0x0204, 0x16, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x04A3, 0x0183, 0x00, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x04A4, 0x01A3, 0x00, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x08DA, 0x0004, 0x36, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x08DB, 0x0004, 0x36, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x08DC, 0x0204, 0x36, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x08DD, 0x0204, 0x36, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x08DE, 0x0604, 0x00, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x08DF, 0x0604, 0x00, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x08E0, 0x0684, 0x00, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x08E1, 0x0684, 0x00, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x08E2, 0x0004, 0x7D, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x08E3, 0x0004, 0x7D, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x08E4, 0x0004, 0x7D, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x08E5, 0x0204, 0x7D, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x08E6, 0x0204, 0x7D, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x08E7, 0x0204, 0x7D, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x08E8, 0x0004, 0x7E, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x08E9, 0x0004, 0x7E, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x08EA, 0x0004, 0x7E, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x08EB, 0x0204, 0x7E, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x08EC, 0x0204, 0x7E, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x08ED, 0x0204, 0x7E, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x08EE, 0x0004, 0x7F, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x08EF, 0x0004, 0x7F, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x08F0, 0x0004, 0x7F, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x08F1, 0x0204, 0x7F, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x08F2, 0x0204, 0x7F, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x08F3, 0x0204, 0x7F, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x08F4, 0x0004, 0x7F, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x08F5, 0x0004, 0x7F, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x08F6, 0x0004, 0x7F, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x08F7, 0x0204, 0x7F, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x08F8, 0x0204, 0x7F, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x08F9, 0x0204, 0x7F, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x08FA, 0x0004, 0x7E, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x08FB, 0x0004, 0x7E, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x08FC, 0x0004, 0x7E, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x08FD, 0x0204, 0x7E, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x08FE, 0x0204, 0x7E, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x08FF, 0x0204, 0x7E, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0900, 0x0004, 0x7D, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0901, 0x0004, 0x7D, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0902, 0x0004, 0x7D, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0903, 0x0204, 0x7D, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0904, 0x0204, 0x7D, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0905, 0x0204, 0x7D, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0906, 0x0004, 0x8D, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0907, 0x0004, 0x8D, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0908, 0x0004, 0x8D, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0909, 0x0204, 0x8D, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x090A, 0x0204, 0x8D, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x090B, 0x0204, 0x8D, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x090C, 0x0003, 0x62, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x090D, 0x0003, 0x62, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x090E, 0x0003, 0x62, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x090F, 0x0083, 0x62, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0910, 0x0083, 0x62, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0911, 0x0083, 0x62, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0912, 0x0003, 0x89, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0913, 0x0003, 0x89, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0914, 0x0003, 0x89, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0915, 0x0083, 0x89, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0916, 0x0083, 0x89, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0917, 0x0083, 0x89, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0918, 0x0003, 0x89, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0919, 0x0003, 0x89, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x091A, 0x0003, 0x89, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x091B, 0x0083, 0x89, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x091C, 0x0083, 0x89, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x091D, 0x0083, 0x89, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x091E, 0x0003, 0x62, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x091F, 0x0003, 0x62, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0920, 0x0003, 0x62, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0921, 0x0083, 0x62, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0922, 0x0083, 0x62, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0923, 0x0083, 0x62, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x04A5, 0x0183, 0x14, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x04A6, 0x018B, 0x14, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0924, 0x0183, 0x14, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0925, 0x018B, 0x14, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x04A7, 0x0183, 0x16, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_64, ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x04A8, 0x018B, 0x16, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_64, ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x04A9, 0x0183, 0x16, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x04AA, 0x018B, 0x16, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0926, 0x0183, 0x16, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0927, 0x018B, 0x16, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0928, 0x0183, 0x16, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0929, 0x018B, 0x16, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x04AB, 0x0183, 0x16, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_64, ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x04AC, 0x018B, 0x16, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_64, ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x092A, 0x0183, 0x16, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_64, ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x092B, 0x018B, 0x16, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_64, ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x04AD, 0x0183, 0xC5, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x04AE, 0x0183, 0x15, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x04AF, 0x018B, 0x15, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x092C, 0x0183, 0xC5, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x092D, 0x0183, 0x15, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x092E, 0x018B, 0x15, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x04B0, 0x0023, 0x90, 0x04, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x04B1, 0x0023, 0x90, 0x04, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x092F, 0x0083, 0x90, 0x04, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0930, 0x0083, 0x90, 0x04, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0931, 0x0083, 0x90, 0x04, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0119, 0x0083, 0x90, 0x04, ZYDIS_INSTRUCTION_ENCODING_MVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x04B2, 0x0023, 0x90, 0x04, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x04B3, 0x0023, 0x90, 0x04, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0932, 0x0083, 0x90, 0x04, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0933, 0x0083, 0x90, 0x04, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0934, 0x0083, 0x90, 0x04, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x011A, 0x0083, 0x90, 0x04, ZYDIS_INSTRUCTION_ENCODING_MVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_64, ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x04B4, 0x0023, 0x91, 0x04, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x04B5, 0x0023, 0x91, 0x04, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0935, 0x0083, 0x91, 0x04, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0936, 0x0083, 0x91, 0x04, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0937, 0x0083, 0x91, 0x04, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x04B6, 0x0023, 0x91, 0x04, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x04B7, 0x0023, 0x91, 0x04, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0938, 0x0083, 0x91, 0x04, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0939, 0x0083, 0x91, 0x04, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x093A, 0x0083, 0x91, 0x04, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x003E, 0x0002, 0xC2, 0xC0, ZYDIS_INSTRUCTION_ENCODING_XOP, ZYDIS_OPCODE_MAP_XOP9, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x003F, 0x0022, 0xC2, 0x00, ZYDIS_INSTRUCTION_ENCODING_XOP, ZYDIS_OPCODE_MAP_XOP9, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0040, 0x0002, 0xC3, 0xC0, ZYDIS_INSTRUCTION_ENCODING_XOP, ZYDIS_OPCODE_MAP_XOP9, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0041, 0x0022, 0xC3, 0x00, ZYDIS_INSTRUCTION_ENCODING_XOP, ZYDIS_OPCODE_MAP_XOP9, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0042, 0x0002, 0xC1, 0xC0, ZYDIS_INSTRUCTION_ENCODING_XOP, ZYDIS_OPCODE_MAP_XOP9, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0043, 0x0022, 0xC1, 0x00, ZYDIS_INSTRUCTION_ENCODING_XOP, ZYDIS_OPCODE_MAP_XOP9, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x04B8, 0x0003, 0x02, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x04B9, 0x0003, 0x02, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x04BA, 0x0083, 0x02, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x04BB, 0x0083, 0x02, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0044, 0x0002, 0xCB, 0xC0, ZYDIS_INSTRUCTION_ENCODING_XOP, ZYDIS_OPCODE_MAP_XOP9, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0045, 0x0022, 0xCB, 0x00, ZYDIS_INSTRUCTION_ENCODING_XOP, ZYDIS_OPCODE_MAP_XOP9, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x04BC, 0x0003, 0x03, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x04BD, 0x0003, 0x03, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x04BE, 0x0083, 0x03, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x04BF, 0x0083, 0x03, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0046, 0x0002, 0xD2, 0xC0, ZYDIS_INSTRUCTION_ENCODING_XOP, ZYDIS_OPCODE_MAP_XOP9, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0047, 0x0022, 0xD2, 0x00, ZYDIS_INSTRUCTION_ENCODING_XOP, ZYDIS_OPCODE_MAP_XOP9, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0048, 0x0002, 0xD3, 0xC0, ZYDIS_INSTRUCTION_ENCODING_XOP, ZYDIS_OPCODE_MAP_XOP9, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0049, 0x0022, 0xD3, 0x00, ZYDIS_INSTRUCTION_ENCODING_XOP, ZYDIS_OPCODE_MAP_XOP9, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x004A, 0x0002, 0xD1, 0xC0, ZYDIS_INSTRUCTION_ENCODING_XOP, ZYDIS_OPCODE_MAP_XOP9, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x004B, 0x0022, 0xD1, 0x00, ZYDIS_INSTRUCTION_ENCODING_XOP, ZYDIS_OPCODE_MAP_XOP9, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x004C, 0x0002, 0xDB, 0xC0, ZYDIS_INSTRUCTION_ENCODING_XOP, ZYDIS_OPCODE_MAP_XOP9, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x004D, 0x0022, 0xDB, 0x00, ZYDIS_INSTRUCTION_ENCODING_XOP, ZYDIS_OPCODE_MAP_XOP9, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x004E, 0x0002, 0xD6, 0xC0, ZYDIS_INSTRUCTION_ENCODING_XOP, ZYDIS_OPCODE_MAP_XOP9, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x004F, 0x0022, 0xD6, 0x00, ZYDIS_INSTRUCTION_ENCODING_XOP, ZYDIS_OPCODE_MAP_XOP9, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0050, 0x0002, 0xD7, 0xC0, ZYDIS_INSTRUCTION_ENCODING_XOP, ZYDIS_OPCODE_MAP_XOP9, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0051, 0x0022, 0xD7, 0x00, ZYDIS_INSTRUCTION_ENCODING_XOP, ZYDIS_OPCODE_MAP_XOP9, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x04C0, 0x0003, 0x01, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x04C1, 0x0003, 0x01, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x04C2, 0x0083, 0x01, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x04C3, 0x0083, 0x01, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0052, 0x0002, 0xC6, 0xC0, ZYDIS_INSTRUCTION_ENCODING_XOP, ZYDIS_OPCODE_MAP_XOP9, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0053, 0x0022, 0xC6, 0x00, ZYDIS_INSTRUCTION_ENCODING_XOP, ZYDIS_OPCODE_MAP_XOP9, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0054, 0x0002, 0xC7, 0xC0, ZYDIS_INSTRUCTION_ENCODING_XOP, ZYDIS_OPCODE_MAP_XOP9, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0055, 0x0022, 0xC7, 0x00, ZYDIS_INSTRUCTION_ENCODING_XOP, ZYDIS_OPCODE_MAP_XOP9, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x04C4, 0x0002, 0x41, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x04C5, 0x0022, 0x41, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0056, 0x0002, 0xE1, 0xC0, ZYDIS_INSTRUCTION_ENCODING_XOP, ZYDIS_OPCODE_MAP_XOP9, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0057, 0x0022, 0xE1, 0x00, ZYDIS_INSTRUCTION_ENCODING_XOP, ZYDIS_OPCODE_MAP_XOP9, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x04C6, 0x0003, 0x06, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x04C7, 0x0003, 0x06, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x04C8, 0x0083, 0x06, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x04C9, 0x0083, 0x06, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0058, 0x0002, 0xE3, 0xC0, ZYDIS_INSTRUCTION_ENCODING_XOP, ZYDIS_OPCODE_MAP_XOP9, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0059, 0x0022, 0xE3, 0x00, ZYDIS_INSTRUCTION_ENCODING_XOP, ZYDIS_OPCODE_MAP_XOP9, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x04CA, 0x0003, 0x07, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x04CB, 0x0003, 0x07, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x04CC, 0x0083, 0x07, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x04CD, 0x0083, 0x07, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x04CE, 0x0003, 0x05, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x04CF, 0x0003, 0x05, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x04D0, 0x0083, 0x05, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x04D1, 0x0083, 0x05, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x005A, 0x0002, 0xE2, 0xC0, ZYDIS_INSTRUCTION_ENCODING_XOP, ZYDIS_OPCODE_MAP_XOP9, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x005B, 0x0022, 0xE2, 0x00, ZYDIS_INSTRUCTION_ENCODING_XOP, ZYDIS_OPCODE_MAP_XOP9, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x04D2, 0x0604, 0x20, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x04D3, 0x0684, 0x20, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x093B, 0x0604, 0x20, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x093C, 0x0684, 0x20, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x04D4, 0x0604, 0x22, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_64, ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x04D5, 0x0684, 0x22, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_64, ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x04D6, 0x0604, 0x22, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x04D7, 0x0684, 0x22, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x093D, 0x0604, 0x22, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x093E, 0x0684, 0x22, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x093F, 0x0604, 0x22, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0940, 0x0684, 0x22, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x04D8, 0x0604, 0x22, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_64, ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x04D9, 0x0684, 0x22, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_64, ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0941, 0x0604, 0x22, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_64, ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0942, 0x0684, 0x22, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_64, ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x04DA, 0x0604, 0xC4, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x04DB, 0x0684, 0xC4, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0943, 0x0604, 0xC4, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0944, 0x0684, 0xC4, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0945, 0x0003, 0x44, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0946, 0x0003, 0x44, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0947, 0x0003, 0x44, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0948, 0x0083, 0x44, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0949, 0x0083, 0x44, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x094A, 0x0083, 0x44, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x094B, 0x0003, 0x44, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x094C, 0x0003, 0x44, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x094D, 0x0003, 0x44, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x094E, 0x0083, 0x44, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x094F, 0x0083, 0x44, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0950, 0x0083, 0x44, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x005C, 0x0004, 0x9E, 0xC0, ZYDIS_INSTRUCTION_ENCODING_XOP, ZYDIS_OPCODE_MAP_XOP8, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x005D, 0x0084, 0x9E, 0x00, ZYDIS_INSTRUCTION_ENCODING_XOP, ZYDIS_OPCODE_MAP_XOP8, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x005E, 0x0004, 0x9F, 0xC0, ZYDIS_INSTRUCTION_ENCODING_XOP, ZYDIS_OPCODE_MAP_XOP8, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x005F, 0x0084, 0x9F, 0x00, ZYDIS_INSTRUCTION_ENCODING_XOP, ZYDIS_OPCODE_MAP_XOP8, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0060, 0x0004, 0x97, 0xC0, ZYDIS_INSTRUCTION_ENCODING_XOP, ZYDIS_OPCODE_MAP_XOP8, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0061, 0x0084, 0x97, 0x00, ZYDIS_INSTRUCTION_ENCODING_XOP, ZYDIS_OPCODE_MAP_XOP8, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0062, 0x0004, 0x8E, 0xC0, ZYDIS_INSTRUCTION_ENCODING_XOP, ZYDIS_OPCODE_MAP_XOP8, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0063, 0x0084, 0x8E, 0x00, ZYDIS_INSTRUCTION_ENCODING_XOP, ZYDIS_OPCODE_MAP_XOP8, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0064, 0x0004, 0x8F, 0xC0, ZYDIS_INSTRUCTION_ENCODING_XOP, ZYDIS_OPCODE_MAP_XOP8, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0065, 0x0084, 0x8F, 0x00, ZYDIS_INSTRUCTION_ENCODING_XOP, ZYDIS_OPCODE_MAP_XOP8, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0066, 0x0004, 0x87, 0xC0, ZYDIS_INSTRUCTION_ENCODING_XOP, ZYDIS_OPCODE_MAP_XOP8, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0067, 0x0084, 0x87, 0x00, ZYDIS_INSTRUCTION_ENCODING_XOP, ZYDIS_OPCODE_MAP_XOP8, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0068, 0x0004, 0x86, 0xC0, ZYDIS_INSTRUCTION_ENCODING_XOP, ZYDIS_OPCODE_MAP_XOP8, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0069, 0x0084, 0x86, 0x00, ZYDIS_INSTRUCTION_ENCODING_XOP, ZYDIS_OPCODE_MAP_XOP8, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x006A, 0x0004, 0x85, 0xC0, ZYDIS_INSTRUCTION_ENCODING_XOP, ZYDIS_OPCODE_MAP_XOP8, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x006B, 0x0084, 0x85, 0x00, ZYDIS_INSTRUCTION_ENCODING_XOP, ZYDIS_OPCODE_MAP_XOP8, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x006C, 0x0004, 0x96, 0xC0, ZYDIS_INSTRUCTION_ENCODING_XOP, ZYDIS_OPCODE_MAP_XOP8, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x006D, 0x0084, 0x96, 0x00, ZYDIS_INSTRUCTION_ENCODING_XOP, ZYDIS_OPCODE_MAP_XOP8, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x006E, 0x0004, 0x95, 0xC0, ZYDIS_INSTRUCTION_ENCODING_XOP, ZYDIS_OPCODE_MAP_XOP8, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x006F, 0x0084, 0x95, 0x00, ZYDIS_INSTRUCTION_ENCODING_XOP, ZYDIS_OPCODE_MAP_XOP8, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0070, 0x0004, 0xA6, 0xC0, ZYDIS_INSTRUCTION_ENCODING_XOP, ZYDIS_OPCODE_MAP_XOP8, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0071, 0x0084, 0xA6, 0x00, ZYDIS_INSTRUCTION_ENCODING_XOP, ZYDIS_OPCODE_MAP_XOP8, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0072, 0x0004, 0xB6, 0xC0, ZYDIS_INSTRUCTION_ENCODING_XOP, ZYDIS_OPCODE_MAP_XOP8, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0073, 0x0084, 0xB6, 0x00, ZYDIS_INSTRUCTION_ENCODING_XOP, ZYDIS_OPCODE_MAP_XOP8, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x011B, 0x0004, 0xB5, 0xC0, ZYDIS_INSTRUCTION_ENCODING_MVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x011C, 0x0004, 0xB5, 0xC0, ZYDIS_INSTRUCTION_ENCODING_MVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x011D, 0x0204, 0xB5, 0x00, ZYDIS_INSTRUCTION_ENCODING_MVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x011E, 0x0004, 0xB4, 0xC0, ZYDIS_INSTRUCTION_ENCODING_MVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x011F, 0x0004, 0xB4, 0xC0, ZYDIS_INSTRUCTION_ENCODING_MVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0120, 0x0204, 0xB4, 0x00, ZYDIS_INSTRUCTION_ENCODING_MVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x04DC, 0x0003, 0xB5, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x04DD, 0x0003, 0xB5, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x04DE, 0x0083, 0xB5, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x04DF, 0x0083, 0xB5, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0951, 0x0004, 0xB5, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0952, 0x0004, 0xB5, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0953, 0x0004, 0xB5, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0954, 0x0204, 0xB5, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0955, 0x0204, 0xB5, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0956, 0x0204, 0xB5, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x04E0, 0x0003, 0xB4, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x04E1, 0x0003, 0xB4, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x04E2, 0x0083, 0xB4, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x04E3, 0x0083, 0xB4, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0957, 0x0004, 0xB4, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0958, 0x0004, 0xB4, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0959, 0x0004, 0xB4, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x095A, 0x0204, 0xB4, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x095B, 0x0204, 0xB4, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x095C, 0x0204, 0xB4, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x04E4, 0x0003, 0x04, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x04E5, 0x0003, 0x04, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x04E6, 0x0083, 0x04, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x04E7, 0x0083, 0x04, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x095D, 0x0004, 0x04, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x095E, 0x0004, 0x04, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x095F, 0x0004, 0x04, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0960, 0x0204, 0x04, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0961, 0x0204, 0x04, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0962, 0x0204, 0x04, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x04E8, 0x0003, 0xF5, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x04E9, 0x0003, 0xF5, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x04EA, 0x0083, 0xF5, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x04EB, 0x0083, 0xF5, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0963, 0x0004, 0xF5, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0964, 0x0004, 0xF5, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0965, 0x0004, 0xF5, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0966, 0x0204, 0xF5, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0967, 0x0204, 0xF5, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0968, 0x0204, 0xF5, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x04EC, 0x0083, 0x8C, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x04ED, 0x0083, 0x8C, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x04EE, 0x000B, 0x8E, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x04EF, 0x000B, 0x8E, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x04F0, 0x0083, 0x8C, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x04F1, 0x0083, 0x8C, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x04F2, 0x000B, 0x8E, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x04F3, 0x000B, 0x8E, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x04F4, 0x0003, 0x3C, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x04F5, 0x0003, 0x3C, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x04F6, 0x0083, 0x3C, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x04F7, 0x0083, 0x3C, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0969, 0x0004, 0x3C, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x096A, 0x0004, 0x3C, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x096B, 0x0004, 0x3C, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x096C, 0x0204, 0x3C, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x096D, 0x0204, 0x3C, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x096E, 0x0204, 0x3C, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x04F8, 0x0003, 0x3D, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x04F9, 0x0003, 0x3D, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x04FA, 0x0083, 0x3D, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x04FB, 0x0083, 0x3D, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x096F, 0x0004, 0x3D, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0970, 0x0004, 0x3D, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0971, 0x0004, 0x3D, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0972, 0x0204, 0x3D, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0973, 0x0204, 0x3D, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0974, 0x0204, 0x3D, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0121, 0x0004, 0x3D, 0xC0, ZYDIS_INSTRUCTION_ENCODING_MVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0122, 0x0004, 0x3D, 0xC0, ZYDIS_INSTRUCTION_ENCODING_MVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0123, 0x0204, 0x3D, 0x00, ZYDIS_INSTRUCTION_ENCODING_MVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0975, 0x0004, 0x3D, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0976, 0x0004, 0x3D, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0977, 0x0004, 0x3D, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0978, 0x0204, 0x3D, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0979, 0x0204, 0x3D, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x097A, 0x0204, 0x3D, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x04FC, 0x0003, 0xEE, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x04FD, 0x0003, 0xEE, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x04FE, 0x0083, 0xEE, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x04FF, 0x0083, 0xEE, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x097B, 0x0004, 0xEE, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x097C, 0x0004, 0xEE, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x097D, 0x0004, 0xEE, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x097E, 0x0204, 0xEE, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x097F, 0x0204, 0xEE, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0980, 0x0204, 0xEE, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0500, 0x0003, 0xDE, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0501, 0x0003, 0xDE, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0502, 0x0083, 0xDE, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0503, 0x0083, 0xDE, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0981, 0x0004, 0xDE, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0982, 0x0004, 0xDE, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0983, 0x0004, 0xDE, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0984, 0x0204, 0xDE, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0985, 0x0204, 0xDE, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0986, 0x0204, 0xDE, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0504, 0x0003, 0x3F, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0505, 0x0003, 0x3F, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0506, 0x0083, 0x3F, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0507, 0x0083, 0x3F, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0987, 0x0004, 0x3F, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0988, 0x0004, 0x3F, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0989, 0x0004, 0x3F, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x098A, 0x0204, 0x3F, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x098B, 0x0204, 0x3F, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x098C, 0x0204, 0x3F, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0124, 0x0004, 0x3F, 0xC0, ZYDIS_INSTRUCTION_ENCODING_MVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0125, 0x0004, 0x3F, 0xC0, ZYDIS_INSTRUCTION_ENCODING_MVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0126, 0x0204, 0x3F, 0x00, ZYDIS_INSTRUCTION_ENCODING_MVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x098D, 0x0004, 0x3F, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x098E, 0x0004, 0x3F, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x098F, 0x0004, 0x3F, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0990, 0x0204, 0x3F, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0991, 0x0204, 0x3F, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0992, 0x0204, 0x3F, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0508, 0x0003, 0x3E, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0509, 0x0003, 0x3E, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x050A, 0x0083, 0x3E, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x050B, 0x0083, 0x3E, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0993, 0x0004, 0x3E, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0994, 0x0004, 0x3E, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0995, 0x0004, 0x3E, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0996, 0x0204, 0x3E, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0997, 0x0204, 0x3E, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0998, 0x0204, 0x3E, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x050C, 0x0003, 0x38, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x050D, 0x0003, 0x38, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x050E, 0x0083, 0x38, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x050F, 0x0083, 0x38, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0999, 0x0004, 0x38, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x099A, 0x0004, 0x38, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x099B, 0x0004, 0x38, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x099C, 0x0204, 0x38, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x099D, 0x0204, 0x38, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x099E, 0x0204, 0x38, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0510, 0x0003, 0x39, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0511, 0x0003, 0x39, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0512, 0x0083, 0x39, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0513, 0x0083, 0x39, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x099F, 0x0004, 0x39, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x09A0, 0x0004, 0x39, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x09A1, 0x0004, 0x39, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x09A2, 0x0204, 0x39, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x09A3, 0x0204, 0x39, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x09A4, 0x0204, 0x39, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0127, 0x0004, 0x39, 0xC0, ZYDIS_INSTRUCTION_ENCODING_MVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0128, 0x0004, 0x39, 0xC0, ZYDIS_INSTRUCTION_ENCODING_MVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0129, 0x0204, 0x39, 0x00, ZYDIS_INSTRUCTION_ENCODING_MVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x09A5, 0x0004, 0x39, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x09A6, 0x0004, 0x39, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x09A7, 0x0004, 0x39, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x09A8, 0x0204, 0x39, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x09A9, 0x0204, 0x39, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x09AA, 0x0204, 0x39, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0514, 0x0003, 0xEA, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0515, 0x0003, 0xEA, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0516, 0x0083, 0xEA, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0517, 0x0083, 0xEA, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x09AB, 0x0004, 0xEA, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x09AC, 0x0004, 0xEA, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x09AD, 0x0004, 0xEA, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x09AE, 0x0204, 0xEA, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x09AF, 0x0204, 0xEA, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x09B0, 0x0204, 0xEA, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0518, 0x0003, 0xDA, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0519, 0x0003, 0xDA, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x051A, 0x0083, 0xDA, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x051B, 0x0083, 0xDA, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x09B1, 0x0004, 0xDA, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x09B2, 0x0004, 0xDA, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x09B3, 0x0004, 0xDA, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x09B4, 0x0204, 0xDA, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x09B5, 0x0204, 0xDA, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x09B6, 0x0204, 0xDA, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x051C, 0x0003, 0x3B, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x051D, 0x0003, 0x3B, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x051E, 0x0083, 0x3B, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x051F, 0x0083, 0x3B, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x09B7, 0x0004, 0x3B, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x09B8, 0x0004, 0x3B, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x09B9, 0x0004, 0x3B, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x09BA, 0x0204, 0x3B, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x09BB, 0x0204, 0x3B, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x09BC, 0x0204, 0x3B, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x012A, 0x0004, 0x3B, 0xC0, ZYDIS_INSTRUCTION_ENCODING_MVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x012B, 0x0004, 0x3B, 0xC0, ZYDIS_INSTRUCTION_ENCODING_MVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x012C, 0x0204, 0x3B, 0x00, ZYDIS_INSTRUCTION_ENCODING_MVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x09BD, 0x0004, 0x3B, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x09BE, 0x0004, 0x3B, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x09BF, 0x0004, 0x3B, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x09C0, 0x0204, 0x3B, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x09C1, 0x0204, 0x3B, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x09C2, 0x0204, 0x3B, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0520, 0x0003, 0x3A, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0521, 0x0003, 0x3A, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0522, 0x0083, 0x3A, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0523, 0x0083, 0x3A, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x09C3, 0x0004, 0x3A, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x09C4, 0x0004, 0x3A, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x09C5, 0x0004, 0x3A, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x09C6, 0x0204, 0x3A, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x09C7, 0x0204, 0x3A, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x09C8, 0x0204, 0x3A, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x09C9, 0x0002, 0x29, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x09CA, 0x0002, 0x29, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x09CB, 0x0002, 0x29, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x09CC, 0x0002, 0x39, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x09CD, 0x0002, 0x39, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x09CE, 0x0002, 0x39, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x09CF, 0x0003, 0x31, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x09D0, 0x0003, 0x31, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x09D1, 0x0003, 0x31, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x09D2, 0x000B, 0x31, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x09D3, 0x000B, 0x31, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x09D4, 0x000B, 0x31, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x09D5, 0x0003, 0x33, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x09D6, 0x0003, 0x33, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x09D7, 0x0003, 0x33, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x09D8, 0x000B, 0x33, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x09D9, 0x000B, 0x33, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x09DA, 0x000B, 0x33, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x09DB, 0x0002, 0x28, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x09DC, 0x0002, 0x28, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x09DD, 0x0002, 0x28, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x09DE, 0x0002, 0x38, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x09DF, 0x0002, 0x38, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x09E0, 0x0002, 0x38, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x09E1, 0x0002, 0x38, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x09E2, 0x0002, 0x38, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x09E3, 0x0002, 0x38, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x09E4, 0x0002, 0x28, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x09E5, 0x0002, 0x28, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x09E6, 0x0002, 0x28, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0524, 0x0002, 0xD7, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0525, 0x0002, 0xD7, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x09E7, 0x0002, 0x39, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x09E8, 0x0002, 0x39, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x09E9, 0x0002, 0x39, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x09EA, 0x0003, 0x32, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x09EB, 0x0003, 0x32, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x09EC, 0x0003, 0x32, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x09ED, 0x000B, 0x32, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x09EE, 0x000B, 0x32, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x09EF, 0x000B, 0x32, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x09F0, 0x0003, 0x35, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x09F1, 0x0003, 0x35, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x09F2, 0x0003, 0x35, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x09F3, 0x000B, 0x35, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x09F4, 0x000B, 0x35, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x09F5, 0x000B, 0x35, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x09F6, 0x0003, 0x34, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x09F7, 0x0003, 0x34, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x09F8, 0x0003, 0x34, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x09F9, 0x000B, 0x34, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x09FA, 0x000B, 0x34, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x09FB, 0x000B, 0x34, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x09FC, 0x0003, 0x21, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x09FD, 0x0003, 0x21, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x09FE, 0x0003, 0x21, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x09FF, 0x000B, 0x21, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0A00, 0x000B, 0x21, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0A01, 0x000B, 0x21, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0A02, 0x0003, 0x23, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0A03, 0x0003, 0x23, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0A04, 0x0003, 0x23, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0A05, 0x000B, 0x23, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0A06, 0x000B, 0x23, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0A07, 0x000B, 0x23, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0A08, 0x0003, 0x22, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0A09, 0x0003, 0x22, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0A0A, 0x0003, 0x22, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0A0B, 0x000B, 0x22, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0A0C, 0x000B, 0x22, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0A0D, 0x000B, 0x22, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0A0E, 0x0003, 0x25, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0A0F, 0x0003, 0x25, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0A10, 0x0003, 0x25, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0A11, 0x000B, 0x25, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0A12, 0x000B, 0x25, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0A13, 0x000B, 0x25, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0A14, 0x0003, 0x24, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0A15, 0x0003, 0x24, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0A16, 0x0003, 0x24, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0A17, 0x000B, 0x24, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0A18, 0x000B, 0x24, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0A19, 0x000B, 0x24, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0A1A, 0x0003, 0x20, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0A1B, 0x0003, 0x20, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0A1C, 0x0003, 0x20, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0A1D, 0x000B, 0x20, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0A1E, 0x000B, 0x20, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0A1F, 0x000B, 0x20, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0526, 0x0002, 0x21, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0527, 0x0002, 0x21, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0528, 0x0022, 0x21, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0529, 0x0022, 0x21, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0A20, 0x0003, 0x21, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0A21, 0x0003, 0x21, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0A22, 0x0003, 0x21, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0A23, 0x0083, 0x21, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0A24, 0x0083, 0x21, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0A25, 0x0083, 0x21, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x052A, 0x0002, 0x22, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x052B, 0x0002, 0x22, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x052C, 0x0022, 0x22, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x052D, 0x0022, 0x22, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0A26, 0x0003, 0x22, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0A27, 0x0003, 0x22, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0A28, 0x0003, 0x22, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0A29, 0x0083, 0x22, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0A2A, 0x0083, 0x22, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0A2B, 0x0083, 0x22, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x052E, 0x0002, 0x20, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x052F, 0x0002, 0x20, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0530, 0x0022, 0x20, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0531, 0x0022, 0x20, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0A2C, 0x0003, 0x20, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0A2D, 0x0003, 0x20, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0A2E, 0x0003, 0x20, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0A2F, 0x0083, 0x20, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0A30, 0x0083, 0x20, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0A31, 0x0083, 0x20, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0532, 0x0002, 0x25, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0533, 0x0002, 0x25, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0534, 0x0022, 0x25, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0535, 0x0022, 0x25, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0A32, 0x0003, 0x25, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0A33, 0x0003, 0x25, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0A34, 0x0003, 0x25, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0A35, 0x0083, 0x25, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0A36, 0x0083, 0x25, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0A37, 0x0083, 0x25, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0536, 0x0002, 0x23, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0537, 0x0002, 0x23, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0538, 0x0022, 0x23, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0539, 0x0022, 0x23, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0A38, 0x0003, 0x23, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0A39, 0x0003, 0x23, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0A3A, 0x0003, 0x23, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0A3B, 0x0083, 0x23, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0A3C, 0x0083, 0x23, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0A3D, 0x0083, 0x23, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x053A, 0x0002, 0x24, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x053B, 0x0002, 0x24, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x053C, 0x0022, 0x24, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x053D, 0x0022, 0x24, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0A3E, 0x0003, 0x24, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0A3F, 0x0003, 0x24, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0A40, 0x0003, 0x24, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0A41, 0x0083, 0x24, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0A42, 0x0083, 0x24, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0A43, 0x0083, 0x24, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0A44, 0x0003, 0x11, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0A45, 0x0003, 0x11, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0A46, 0x0003, 0x11, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0A47, 0x000B, 0x11, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0A48, 0x000B, 0x11, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0A49, 0x000B, 0x11, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0A4A, 0x0003, 0x13, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0A4B, 0x0003, 0x13, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0A4C, 0x0003, 0x13, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0A4D, 0x000B, 0x13, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0A4E, 0x000B, 0x13, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0A4F, 0x000B, 0x13, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0A50, 0x0003, 0x12, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0A51, 0x0003, 0x12, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0A52, 0x0003, 0x12, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0A53, 0x000B, 0x12, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0A54, 0x000B, 0x12, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0A55, 0x000B, 0x12, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0A56, 0x0003, 0x15, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0A57, 0x0003, 0x15, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0A58, 0x0003, 0x15, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0A59, 0x000B, 0x15, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0A5A, 0x000B, 0x15, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0A5B, 0x000B, 0x15, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0A5C, 0x0003, 0x14, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0A5D, 0x0003, 0x14, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0A5E, 0x0003, 0x14, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0A5F, 0x000B, 0x14, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0A60, 0x000B, 0x14, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0A61, 0x000B, 0x14, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0A62, 0x0003, 0x10, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0A63, 0x0003, 0x10, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0A64, 0x0003, 0x10, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0A65, 0x000B, 0x10, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0A66, 0x000B, 0x10, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0A67, 0x000B, 0x10, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0A68, 0x0002, 0x29, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0A69, 0x0002, 0x29, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0A6A, 0x0002, 0x29, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0A6B, 0x0003, 0x30, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0A6C, 0x0003, 0x30, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0A6D, 0x0003, 0x30, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0A6E, 0x000B, 0x30, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0A6F, 0x000B, 0x30, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0A70, 0x000B, 0x30, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x053E, 0x0002, 0x31, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x053F, 0x0002, 0x31, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0540, 0x0022, 0x31, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0541, 0x0022, 0x31, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0A71, 0x0003, 0x31, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0A72, 0x0003, 0x31, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0A73, 0x0003, 0x31, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0A74, 0x0083, 0x31, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0A75, 0x0083, 0x31, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0A76, 0x0083, 0x31, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0542, 0x0002, 0x32, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0543, 0x0002, 0x32, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0544, 0x0022, 0x32, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0545, 0x0022, 0x32, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0A77, 0x0003, 0x32, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0A78, 0x0003, 0x32, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0A79, 0x0003, 0x32, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0A7A, 0x0083, 0x32, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0A7B, 0x0083, 0x32, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0A7C, 0x0083, 0x32, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0546, 0x0002, 0x30, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0547, 0x0002, 0x30, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0548, 0x0022, 0x30, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0549, 0x0022, 0x30, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0A7D, 0x0003, 0x30, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0A7E, 0x0003, 0x30, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0A7F, 0x0003, 0x30, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0A80, 0x0083, 0x30, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0A81, 0x0083, 0x30, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0A82, 0x0083, 0x30, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x054A, 0x0002, 0x35, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x054B, 0x0002, 0x35, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x054C, 0x0022, 0x35, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x054D, 0x0022, 0x35, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0A83, 0x0003, 0x35, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0A84, 0x0003, 0x35, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0A85, 0x0003, 0x35, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0A86, 0x0083, 0x35, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0A87, 0x0083, 0x35, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0A88, 0x0083, 0x35, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x054E, 0x0002, 0x33, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x054F, 0x0002, 0x33, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0550, 0x0022, 0x33, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0551, 0x0022, 0x33, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0A89, 0x0003, 0x33, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0A8A, 0x0003, 0x33, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0A8B, 0x0003, 0x33, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0A8C, 0x0083, 0x33, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0A8D, 0x0083, 0x33, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0A8E, 0x0083, 0x33, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0552, 0x0002, 0x34, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0553, 0x0002, 0x34, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0554, 0x0022, 0x34, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0555, 0x0022, 0x34, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0A8F, 0x0003, 0x34, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0A90, 0x0003, 0x34, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0A91, 0x0003, 0x34, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0A92, 0x0083, 0x34, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0A93, 0x0083, 0x34, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0A94, 0x0083, 0x34, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0556, 0x0003, 0x28, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0557, 0x0003, 0x28, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0558, 0x0083, 0x28, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0559, 0x0083, 0x28, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0A95, 0x0004, 0x28, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0A96, 0x0004, 0x28, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0A97, 0x0004, 0x28, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0A98, 0x0204, 0x28, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0A99, 0x0204, 0x28, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0A9A, 0x0204, 0x28, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x012D, 0x0004, 0x87, 0xC0, ZYDIS_INSTRUCTION_ENCODING_MVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x012E, 0x0004, 0x87, 0xC0, ZYDIS_INSTRUCTION_ENCODING_MVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x012F, 0x0204, 0x87, 0x00, ZYDIS_INSTRUCTION_ENCODING_MVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x055A, 0x0003, 0x0B, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x055B, 0x0003, 0x0B, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x055C, 0x0083, 0x0B, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x055D, 0x0083, 0x0B, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0A9B, 0x0004, 0x0B, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0A9C, 0x0004, 0x0B, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0A9D, 0x0004, 0x0B, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0A9E, 0x0204, 0x0B, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0A9F, 0x0204, 0x0B, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0AA0, 0x0204, 0x0B, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0130, 0x0004, 0x86, 0xC0, ZYDIS_INSTRUCTION_ENCODING_MVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0131, 0x0004, 0x86, 0xC0, ZYDIS_INSTRUCTION_ENCODING_MVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0132, 0x0204, 0x86, 0x00, ZYDIS_INSTRUCTION_ENCODING_MVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x055E, 0x0003, 0xE4, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x055F, 0x0003, 0xE4, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0560, 0x0083, 0xE4, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0561, 0x0083, 0xE4, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0AA1, 0x0004, 0xE4, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0AA2, 0x0004, 0xE4, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0AA3, 0x0004, 0xE4, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0AA4, 0x0204, 0xE4, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0AA5, 0x0204, 0xE4, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0AA6, 0x0204, 0xE4, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0562, 0x0003, 0xE5, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0563, 0x0003, 0xE5, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0564, 0x0083, 0xE5, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0565, 0x0083, 0xE5, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0AA7, 0x0004, 0xE5, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0AA8, 0x0004, 0xE5, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0AA9, 0x0004, 0xE5, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0AAA, 0x0204, 0xE5, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0AAB, 0x0204, 0xE5, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0AAC, 0x0204, 0xE5, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0566, 0x0003, 0x40, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0567, 0x0003, 0x40, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0568, 0x0083, 0x40, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0569, 0x0083, 0x40, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0AAD, 0x0004, 0x40, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0AAE, 0x0004, 0x40, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0AAF, 0x0004, 0x40, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0AB0, 0x0204, 0x40, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0AB1, 0x0204, 0x40, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0AB2, 0x0204, 0x40, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0133, 0x0004, 0x40, 0xC0, ZYDIS_INSTRUCTION_ENCODING_MVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0134, 0x0004, 0x40, 0xC0, ZYDIS_INSTRUCTION_ENCODING_MVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0135, 0x0204, 0x40, 0x00, ZYDIS_INSTRUCTION_ENCODING_MVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0AB3, 0x0004, 0x40, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0AB4, 0x0004, 0x40, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0AB5, 0x0004, 0x40, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0AB6, 0x0204, 0x40, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0AB7, 0x0204, 0x40, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0AB8, 0x0204, 0x40, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x056A, 0x0003, 0xD5, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x056B, 0x0003, 0xD5, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x056C, 0x0083, 0xD5, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x056D, 0x0083, 0xD5, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0AB9, 0x0004, 0xD5, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0ABA, 0x0004, 0xD5, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0ABB, 0x0004, 0xD5, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0ABC, 0x0204, 0xD5, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0ABD, 0x0204, 0xD5, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0ABE, 0x0204, 0xD5, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0ABF, 0x0004, 0x83, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0AC0, 0x0004, 0x83, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0AC1, 0x0004, 0x83, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0AC2, 0x0204, 0x83, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0AC3, 0x0204, 0x83, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0AC4, 0x0204, 0x83, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x056E, 0x0003, 0xF4, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x056F, 0x0003, 0xF4, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0570, 0x0083, 0xF4, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0571, 0x0083, 0xF4, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0AC5, 0x0004, 0xF4, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0AC6, 0x0004, 0xF4, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0AC7, 0x0004, 0xF4, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0AC8, 0x0204, 0xF4, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0AC9, 0x0204, 0xF4, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0ACA, 0x0204, 0xF4, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0ACB, 0x0003, 0x54, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0ACC, 0x0003, 0x54, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0ACD, 0x0003, 0x54, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0ACE, 0x0083, 0x54, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0ACF, 0x0083, 0x54, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0AD0, 0x0083, 0x54, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0AD1, 0x0003, 0x55, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0AD2, 0x0003, 0x55, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0AD3, 0x0003, 0x55, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0AD4, 0x0083, 0x55, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0AD5, 0x0083, 0x55, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0AD6, 0x0083, 0x55, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0AD7, 0x0003, 0x55, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0AD8, 0x0003, 0x55, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0AD9, 0x0003, 0x55, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0ADA, 0x0083, 0x55, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0ADB, 0x0083, 0x55, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0ADC, 0x0083, 0x55, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0ADD, 0x0003, 0x54, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0ADE, 0x0003, 0x54, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0ADF, 0x0003, 0x54, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0AE0, 0x0083, 0x54, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0AE1, 0x0083, 0x54, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0AE2, 0x0083, 0x54, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0572, 0x0003, 0xEB, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0573, 0x0003, 0xEB, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0574, 0x0083, 0xEB, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0575, 0x0083, 0xEB, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0AE3, 0x0004, 0xEB, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0AE4, 0x0004, 0xEB, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0AE5, 0x0004, 0xEB, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0AE6, 0x0204, 0xEB, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0AE7, 0x0204, 0xEB, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0AE8, 0x0204, 0xEB, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0136, 0x0004, 0xEB, 0xC0, ZYDIS_INSTRUCTION_ENCODING_MVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0137, 0x0004, 0xEB, 0xC0, ZYDIS_INSTRUCTION_ENCODING_MVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0138, 0x0204, 0xEB, 0x00, ZYDIS_INSTRUCTION_ENCODING_MVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0AE9, 0x0004, 0xEB, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0AEA, 0x0004, 0xEB, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0AEB, 0x0004, 0xEB, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0AEC, 0x0204, 0xEB, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0AED, 0x0204, 0xEB, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0AEE, 0x0204, 0xEB, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0139, 0x0004, 0xEB, 0xC0, ZYDIS_INSTRUCTION_ENCODING_MVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_64, ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x013A, 0x0004, 0xEB, 0xC0, ZYDIS_INSTRUCTION_ENCODING_MVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_64, ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x013B, 0x0204, 0xEB, 0x00, ZYDIS_INSTRUCTION_ENCODING_MVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_64, ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0074, 0x0004, 0xA3, 0xC0, ZYDIS_INSTRUCTION_ENCODING_XOP, ZYDIS_OPCODE_MAP_XOP8, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0075, 0x0004, 0xA3, 0xC0, ZYDIS_INSTRUCTION_ENCODING_XOP, ZYDIS_OPCODE_MAP_XOP8, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0076, 0x0084, 0xA3, 0x00, ZYDIS_INSTRUCTION_ENCODING_XOP, ZYDIS_OPCODE_MAP_XOP8, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0077, 0x0204, 0xA3, 0x00, ZYDIS_INSTRUCTION_ENCODING_XOP, ZYDIS_OPCODE_MAP_XOP8, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0576, 0x0009, 0x18, 0x08, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_64, ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x013C, 0x0009, 0x18, 0x08, ZYDIS_INSTRUCTION_ENCODING_MVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0577, 0x0009, 0x18, 0x10, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_64, ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x013D, 0x0009, 0x18, 0x10, ZYDIS_INSTRUCTION_ENCODING_MVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0578, 0x0009, 0x18, 0x18, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_64, ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x013E, 0x0009, 0x18, 0x18, ZYDIS_INSTRUCTION_ENCODING_MVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0579, 0x0009, 0x18, 0x28, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_64, ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x013F, 0x0009, 0x18, 0x28, ZYDIS_INSTRUCTION_ENCODING_MVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x057A, 0x0009, 0x18, 0x30, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_64, ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0140, 0x0009, 0x18, 0x30, ZYDIS_INSTRUCTION_ENCODING_MVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x057B, 0x0009, 0x18, 0x38, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_64, ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0141, 0x0009, 0x18, 0x38, ZYDIS_INSTRUCTION_ENCODING_MVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x057C, 0x0009, 0x18, 0x20, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_64, ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0142, 0x0009, 0x18, 0x20, ZYDIS_INSTRUCTION_ENCODING_MVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x057D, 0x0009, 0x18, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_64, ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0143, 0x0009, 0x18, 0x00, ZYDIS_INSTRUCTION_ENCODING_MVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0AEF, 0x0604, 0x72, 0xC8, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0AF0, 0x0604, 0x72, 0xC8, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0AF1, 0x0604, 0x72, 0xC8, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0AF2, 0x0684, 0x72, 0x08, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0AF3, 0x0684, 0x72, 0x08, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0AF4, 0x0684, 0x72, 0x08, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0AF5, 0x0604, 0x72, 0xC8, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0AF6, 0x0604, 0x72, 0xC8, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0AF7, 0x0604, 0x72, 0xC8, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0AF8, 0x0684, 0x72, 0x08, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0AF9, 0x0684, 0x72, 0x08, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0AFA, 0x0684, 0x72, 0x08, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0AFB, 0x0004, 0x15, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0AFC, 0x0004, 0x15, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0AFD, 0x0004, 0x15, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0AFE, 0x0204, 0x15, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0AFF, 0x0204, 0x15, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0B00, 0x0204, 0x15, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0B01, 0x0004, 0x15, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0B02, 0x0004, 0x15, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0B03, 0x0004, 0x15, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0B04, 0x0204, 0x15, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0B05, 0x0204, 0x15, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0B06, 0x0204, 0x15, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0B07, 0x0604, 0x72, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0B08, 0x0604, 0x72, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0B09, 0x0604, 0x72, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0B0A, 0x0684, 0x72, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0B0B, 0x0684, 0x72, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0B0C, 0x0684, 0x72, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0B0D, 0x0604, 0x72, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0B0E, 0x0604, 0x72, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0B0F, 0x0604, 0x72, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0B10, 0x0684, 0x72, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0B11, 0x0684, 0x72, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0B12, 0x0684, 0x72, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0B13, 0x0004, 0x14, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0B14, 0x0004, 0x14, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0B15, 0x0004, 0x14, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0B16, 0x0204, 0x14, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0B17, 0x0204, 0x14, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0B18, 0x0204, 0x14, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0B19, 0x0004, 0x14, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0B1A, 0x0004, 0x14, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0B1B, 0x0004, 0x14, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0B1C, 0x0204, 0x14, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0B1D, 0x0204, 0x14, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0B1E, 0x0204, 0x14, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x007A, 0x0003, 0x90, 0xC0, ZYDIS_INSTRUCTION_ENCODING_XOP, ZYDIS_OPCODE_MAP_XOP9, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x007B, 0x0003, 0x90, 0xC0, ZYDIS_INSTRUCTION_ENCODING_XOP, ZYDIS_OPCODE_MAP_XOP9, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x007C, 0x0023, 0x90, 0x00, ZYDIS_INSTRUCTION_ENCODING_XOP, ZYDIS_OPCODE_MAP_XOP9, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x007D, 0x0083, 0x90, 0x00, ZYDIS_INSTRUCTION_ENCODING_XOP, ZYDIS_OPCODE_MAP_XOP9, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0078, 0x0183, 0xC0, 0xC0, ZYDIS_INSTRUCTION_ENCODING_XOP, ZYDIS_OPCODE_MAP_XOP8, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0079, 0x01A3, 0xC0, 0x00, ZYDIS_INSTRUCTION_ENCODING_XOP, ZYDIS_OPCODE_MAP_XOP8, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0080, 0x0003, 0x92, 0xC0, ZYDIS_INSTRUCTION_ENCODING_XOP, ZYDIS_OPCODE_MAP_XOP9, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0081, 0x0003, 0x92, 0xC0, ZYDIS_INSTRUCTION_ENCODING_XOP, ZYDIS_OPCODE_MAP_XOP9, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0082, 0x0023, 0x92, 0x00, ZYDIS_INSTRUCTION_ENCODING_XOP, ZYDIS_OPCODE_MAP_XOP9, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0083, 0x0083, 0x92, 0x00, ZYDIS_INSTRUCTION_ENCODING_XOP, ZYDIS_OPCODE_MAP_XOP9, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x007E, 0x0183, 0xC2, 0xC0, ZYDIS_INSTRUCTION_ENCODING_XOP, ZYDIS_OPCODE_MAP_XOP8, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x007F, 0x01A3, 0xC2, 0x00, ZYDIS_INSTRUCTION_ENCODING_XOP, ZYDIS_OPCODE_MAP_XOP8, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0086, 0x0003, 0x93, 0xC0, ZYDIS_INSTRUCTION_ENCODING_XOP, ZYDIS_OPCODE_MAP_XOP9, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0087, 0x0003, 0x93, 0xC0, ZYDIS_INSTRUCTION_ENCODING_XOP, ZYDIS_OPCODE_MAP_XOP9, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0088, 0x0023, 0x93, 0x00, ZYDIS_INSTRUCTION_ENCODING_XOP, ZYDIS_OPCODE_MAP_XOP9, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0089, 0x0083, 0x93, 0x00, ZYDIS_INSTRUCTION_ENCODING_XOP, ZYDIS_OPCODE_MAP_XOP9, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0084, 0x0183, 0xC3, 0xC0, ZYDIS_INSTRUCTION_ENCODING_XOP, ZYDIS_OPCODE_MAP_XOP8, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0085, 0x01A3, 0xC3, 0x00, ZYDIS_INSTRUCTION_ENCODING_XOP, ZYDIS_OPCODE_MAP_XOP8, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x008C, 0x0003, 0x91, 0xC0, ZYDIS_INSTRUCTION_ENCODING_XOP, ZYDIS_OPCODE_MAP_XOP9, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x008D, 0x0003, 0x91, 0xC0, ZYDIS_INSTRUCTION_ENCODING_XOP, ZYDIS_OPCODE_MAP_XOP9, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x008E, 0x0023, 0x91, 0x00, ZYDIS_INSTRUCTION_ENCODING_XOP, ZYDIS_OPCODE_MAP_XOP9, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x008F, 0x0083, 0x91, 0x00, ZYDIS_INSTRUCTION_ENCODING_XOP, ZYDIS_OPCODE_MAP_XOP9, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x008A, 0x0183, 0xC1, 0xC0, ZYDIS_INSTRUCTION_ENCODING_XOP, ZYDIS_OPCODE_MAP_XOP8, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x008B, 0x01A3, 0xC1, 0x00, ZYDIS_INSTRUCTION_ENCODING_XOP, ZYDIS_OPCODE_MAP_XOP8, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x057E, 0x0003, 0xF6, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x057F, 0x0003, 0xF6, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0580, 0x0083, 0xF6, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0581, 0x0083, 0xF6, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0B1F, 0x0003, 0xF6, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0B20, 0x0003, 0xF6, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0B21, 0x0003, 0xF6, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0B22, 0x0083, 0xF6, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0B23, 0x0083, 0xF6, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0B24, 0x0083, 0xF6, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0144, 0x0004, 0x5E, 0xC0, ZYDIS_INSTRUCTION_ENCODING_MVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0145, 0x0004, 0x5E, 0xC0, ZYDIS_INSTRUCTION_ENCODING_MVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0146, 0x0204, 0x5E, 0x00, ZYDIS_INSTRUCTION_ENCODING_MVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0147, 0x0004, 0x6E, 0xC0, ZYDIS_INSTRUCTION_ENCODING_MVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0148, 0x0004, 0x6E, 0xC0, ZYDIS_INSTRUCTION_ENCODING_MVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0149, 0x0204, 0x6E, 0x00, ZYDIS_INSTRUCTION_ENCODING_MVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0B25, 0x000B, 0xA0, 0x04, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0B26, 0x000B, 0xA0, 0x04, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0B27, 0x000B, 0xA0, 0x04, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x014A, 0x000B, 0xA0, 0x04, ZYDIS_INSTRUCTION_ENCODING_MVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0B28, 0x000B, 0xA0, 0x04, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0B29, 0x000B, 0xA0, 0x04, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0B2A, 0x000B, 0xA0, 0x04, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x014B, 0x000B, 0xA0, 0x04, ZYDIS_INSTRUCTION_ENCODING_MVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_64, ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0B2B, 0x000B, 0xA1, 0x04, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0B2C, 0x000B, 0xA1, 0x04, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0B2D, 0x000B, 0xA1, 0x04, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0B2E, 0x000B, 0xA1, 0x04, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0B2F, 0x000B, 0xA1, 0x04, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0B30, 0x000B, 0xA1, 0x04, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0090, 0x0003, 0x98, 0xC0, ZYDIS_INSTRUCTION_ENCODING_XOP, ZYDIS_OPCODE_MAP_XOP9, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0091, 0x0003, 0x98, 0xC0, ZYDIS_INSTRUCTION_ENCODING_XOP, ZYDIS_OPCODE_MAP_XOP9, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0092, 0x0023, 0x98, 0x00, ZYDIS_INSTRUCTION_ENCODING_XOP, ZYDIS_OPCODE_MAP_XOP9, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0093, 0x0083, 0x98, 0x00, ZYDIS_INSTRUCTION_ENCODING_XOP, ZYDIS_OPCODE_MAP_XOP9, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0094, 0x0003, 0x9A, 0xC0, ZYDIS_INSTRUCTION_ENCODING_XOP, ZYDIS_OPCODE_MAP_XOP9, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0095, 0x0003, 0x9A, 0xC0, ZYDIS_INSTRUCTION_ENCODING_XOP, ZYDIS_OPCODE_MAP_XOP9, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0096, 0x0023, 0x9A, 0x00, ZYDIS_INSTRUCTION_ENCODING_XOP, ZYDIS_OPCODE_MAP_XOP9, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0097, 0x0083, 0x9A, 0x00, ZYDIS_INSTRUCTION_ENCODING_XOP, ZYDIS_OPCODE_MAP_XOP9, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0098, 0x0003, 0x9B, 0xC0, ZYDIS_INSTRUCTION_ENCODING_XOP, ZYDIS_OPCODE_MAP_XOP9, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0099, 0x0003, 0x9B, 0xC0, ZYDIS_INSTRUCTION_ENCODING_XOP, ZYDIS_OPCODE_MAP_XOP9, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x009A, 0x0023, 0x9B, 0x00, ZYDIS_INSTRUCTION_ENCODING_XOP, ZYDIS_OPCODE_MAP_XOP9, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x009B, 0x0083, 0x9B, 0x00, ZYDIS_INSTRUCTION_ENCODING_XOP, ZYDIS_OPCODE_MAP_XOP9, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x009C, 0x0003, 0x99, 0xC0, ZYDIS_INSTRUCTION_ENCODING_XOP, ZYDIS_OPCODE_MAP_XOP9, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x009D, 0x0003, 0x99, 0xC0, ZYDIS_INSTRUCTION_ENCODING_XOP, ZYDIS_OPCODE_MAP_XOP9, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x009E, 0x0023, 0x99, 0x00, ZYDIS_INSTRUCTION_ENCODING_XOP, ZYDIS_OPCODE_MAP_XOP9, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x009F, 0x0083, 0x99, 0x00, ZYDIS_INSTRUCTION_ENCODING_XOP, ZYDIS_OPCODE_MAP_XOP9, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x00A0, 0x0003, 0x94, 0xC0, ZYDIS_INSTRUCTION_ENCODING_XOP, ZYDIS_OPCODE_MAP_XOP9, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x00A1, 0x0003, 0x94, 0xC0, ZYDIS_INSTRUCTION_ENCODING_XOP, ZYDIS_OPCODE_MAP_XOP9, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x00A2, 0x0023, 0x94, 0x00, ZYDIS_INSTRUCTION_ENCODING_XOP, ZYDIS_OPCODE_MAP_XOP9, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x00A3, 0x0083, 0x94, 0x00, ZYDIS_INSTRUCTION_ENCODING_XOP, ZYDIS_OPCODE_MAP_XOP9, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x00A4, 0x0003, 0x96, 0xC0, ZYDIS_INSTRUCTION_ENCODING_XOP, ZYDIS_OPCODE_MAP_XOP9, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x00A5, 0x0003, 0x96, 0xC0, ZYDIS_INSTRUCTION_ENCODING_XOP, ZYDIS_OPCODE_MAP_XOP9, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x00A6, 0x0023, 0x96, 0x00, ZYDIS_INSTRUCTION_ENCODING_XOP, ZYDIS_OPCODE_MAP_XOP9, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x00A7, 0x0083, 0x96, 0x00, ZYDIS_INSTRUCTION_ENCODING_XOP, ZYDIS_OPCODE_MAP_XOP9, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0B31, 0x1805, 0x71, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0B32, 0x1805, 0x71, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0B33, 0x1805, 0x71, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0B34, 0x1A05, 0x71, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0B35, 0x1A05, 0x71, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0B36, 0x1A05, 0x71, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0B37, 0x1805, 0x71, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0B38, 0x1805, 0x71, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0B39, 0x1805, 0x71, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0B3A, 0x1A05, 0x71, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0B3B, 0x1A05, 0x71, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0B3C, 0x1A05, 0x71, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0B3D, 0x0004, 0x71, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0B3E, 0x0004, 0x71, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0B3F, 0x0004, 0x71, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0B40, 0x0204, 0x71, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0B41, 0x0204, 0x71, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0B42, 0x0204, 0x71, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0B43, 0x0004, 0x71, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0B44, 0x0004, 0x71, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0B45, 0x0004, 0x71, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0B46, 0x0204, 0x71, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0B47, 0x0204, 0x71, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0B48, 0x0204, 0x71, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0B49, 0x0004, 0x70, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0B4A, 0x0004, 0x70, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0B4B, 0x0004, 0x70, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0B4C, 0x0204, 0x70, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0B4D, 0x0204, 0x70, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0B4E, 0x0204, 0x70, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0B4F, 0x1805, 0x70, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0B50, 0x1805, 0x70, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0B51, 0x1805, 0x70, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0B52, 0x1A05, 0x70, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0B53, 0x1A05, 0x70, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0B54, 0x1A05, 0x70, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x00A8, 0x0003, 0x97, 0xC0, ZYDIS_INSTRUCTION_ENCODING_XOP, ZYDIS_OPCODE_MAP_XOP9, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x00A9, 0x0003, 0x97, 0xC0, ZYDIS_INSTRUCTION_ENCODING_XOP, ZYDIS_OPCODE_MAP_XOP9, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x00AA, 0x0023, 0x97, 0x00, ZYDIS_INSTRUCTION_ENCODING_XOP, ZYDIS_OPCODE_MAP_XOP9, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x00AB, 0x0083, 0x97, 0x00, ZYDIS_INSTRUCTION_ENCODING_XOP, ZYDIS_OPCODE_MAP_XOP9, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x00AC, 0x0003, 0x95, 0xC0, ZYDIS_INSTRUCTION_ENCODING_XOP, ZYDIS_OPCODE_MAP_XOP9, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x00AD, 0x0003, 0x95, 0xC0, ZYDIS_INSTRUCTION_ENCODING_XOP, ZYDIS_OPCODE_MAP_XOP9, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x00AE, 0x0023, 0x95, 0x00, ZYDIS_INSTRUCTION_ENCODING_XOP, ZYDIS_OPCODE_MAP_XOP9, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x00AF, 0x0083, 0x95, 0x00, ZYDIS_INSTRUCTION_ENCODING_XOP, ZYDIS_OPCODE_MAP_XOP9, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0B55, 0x1805, 0x73, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0B56, 0x1805, 0x73, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0B57, 0x1805, 0x73, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0B58, 0x1A05, 0x73, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0B59, 0x1A05, 0x73, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0B5A, 0x1A05, 0x73, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0B5B, 0x1805, 0x73, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0B5C, 0x1805, 0x73, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0B5D, 0x1805, 0x73, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0B5E, 0x1A05, 0x73, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0B5F, 0x1A05, 0x73, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0B60, 0x1A05, 0x73, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0B61, 0x0004, 0x73, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0B62, 0x0004, 0x73, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0B63, 0x0004, 0x73, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0B64, 0x0204, 0x73, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0B65, 0x0204, 0x73, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0B66, 0x0204, 0x73, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0B67, 0x0004, 0x73, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0B68, 0x0004, 0x73, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0B69, 0x0004, 0x73, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0B6A, 0x0204, 0x73, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0B6B, 0x0204, 0x73, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0B6C, 0x0204, 0x73, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0B6D, 0x0004, 0x72, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0B6E, 0x0004, 0x72, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0B6F, 0x0004, 0x72, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0B70, 0x0204, 0x72, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0B71, 0x0204, 0x72, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0B72, 0x0204, 0x72, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0B73, 0x1805, 0x72, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0B74, 0x1805, 0x72, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0B75, 0x1805, 0x72, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0B76, 0x1A05, 0x72, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0B77, 0x1A05, 0x72, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0B78, 0x1A05, 0x72, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0582, 0x0003, 0x00, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0583, 0x0003, 0x00, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0584, 0x0083, 0x00, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0585, 0x0083, 0x00, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0B79, 0x0004, 0x00, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0B7A, 0x0004, 0x00, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0B7B, 0x0004, 0x00, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0B7C, 0x0204, 0x00, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0B7D, 0x0204, 0x00, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0B7E, 0x0204, 0x00, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0B7F, 0x0004, 0x8F, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0B80, 0x0004, 0x8F, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0B81, 0x0004, 0x8F, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0B82, 0x0204, 0x8F, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0B83, 0x0204, 0x8F, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0B84, 0x0204, 0x8F, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0586, 0x0183, 0x70, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0587, 0x0183, 0x70, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0588, 0x01A3, 0x70, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0589, 0x01A3, 0x70, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0B85, 0x0604, 0x70, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0B86, 0x0604, 0x70, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0B87, 0x0604, 0x70, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0B88, 0x0684, 0x70, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0B89, 0x0684, 0x70, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0B8A, 0x0684, 0x70, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x014C, 0x0604, 0x70, 0xC0, ZYDIS_INSTRUCTION_ENCODING_MVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x014D, 0x0604, 0x70, 0xC0, ZYDIS_INSTRUCTION_ENCODING_MVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x014E, 0x0684, 0x70, 0x00, ZYDIS_INSTRUCTION_ENCODING_MVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x058A, 0x0183, 0x70, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x058B, 0x0183, 0x70, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x058C, 0x01A3, 0x70, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x058D, 0x01A3, 0x70, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0B8B, 0x0604, 0x70, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0B8C, 0x0604, 0x70, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0B8D, 0x0604, 0x70, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0B8E, 0x0684, 0x70, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0B8F, 0x0684, 0x70, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0B90, 0x0684, 0x70, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x058E, 0x0183, 0x70, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F2, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x058F, 0x0183, 0x70, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F2, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0590, 0x01A3, 0x70, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F2, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0591, 0x01A3, 0x70, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F2, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0B91, 0x0604, 0x70, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F2, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0B92, 0x0604, 0x70, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F2, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0B93, 0x0604, 0x70, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F2, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0B94, 0x0684, 0x70, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F2, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0B95, 0x0684, 0x70, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F2, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0B96, 0x0684, 0x70, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F2, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0592, 0x0003, 0x08, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0593, 0x0003, 0x08, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0594, 0x0083, 0x08, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0595, 0x0083, 0x08, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0596, 0x0003, 0x0A, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0597, 0x0003, 0x0A, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0598, 0x0083, 0x0A, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0599, 0x0083, 0x0A, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x059A, 0x0003, 0x09, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x059B, 0x0003, 0x09, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x059C, 0x0083, 0x09, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x059D, 0x0083, 0x09, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x05A0, 0x0003, 0xF2, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x05A1, 0x0003, 0xF2, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x05A2, 0x0083, 0xF2, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x05A3, 0x0083, 0xF2, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x059E, 0x0183, 0x72, 0xF0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x059F, 0x0183, 0x72, 0xF0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0B9D, 0x0004, 0xF2, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0B9E, 0x0004, 0xF2, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0B9F, 0x0004, 0xF2, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0BA0, 0x0204, 0xF2, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0BA1, 0x0204, 0xF2, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0BA2, 0x0204, 0xF2, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0B97, 0x0604, 0x72, 0xF0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0B98, 0x0604, 0x72, 0xF0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0B99, 0x0604, 0x72, 0xF0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0B9A, 0x0684, 0x72, 0x30, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0B9B, 0x0684, 0x72, 0x30, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0B9C, 0x0684, 0x72, 0x30, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x014F, 0x0604, 0x72, 0xF0, ZYDIS_INSTRUCTION_ENCODING_MVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0150, 0x0604, 0x72, 0xF0, ZYDIS_INSTRUCTION_ENCODING_MVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0151, 0x0684, 0x72, 0x30, ZYDIS_INSTRUCTION_ENCODING_MVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x05A4, 0x0183, 0x73, 0xF8, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x05A5, 0x0183, 0x73, 0xF8, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0BA3, 0x0183, 0x73, 0xF8, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0BA4, 0x0183, 0x73, 0xF8, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0BA5, 0x0183, 0x73, 0xF8, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0BA6, 0x01A3, 0x73, 0x38, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0BA7, 0x01A3, 0x73, 0x38, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0BA8, 0x01A3, 0x73, 0x38, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x05A8, 0x0003, 0xF3, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x05A9, 0x0003, 0xF3, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x05AA, 0x0083, 0xF3, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x05AB, 0x0083, 0xF3, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x05A6, 0x0183, 0x73, 0xF0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x05A7, 0x0183, 0x73, 0xF0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0BAF, 0x0004, 0xF3, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0BB0, 0x0004, 0xF3, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0BB1, 0x0004, 0xF3, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0BB2, 0x0204, 0xF3, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0BB3, 0x0204, 0xF3, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0BB4, 0x0204, 0xF3, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0BA9, 0x0604, 0x73, 0xF0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0BAA, 0x0604, 0x73, 0xF0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0BAB, 0x0604, 0x73, 0xF0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0BAC, 0x0684, 0x73, 0x30, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0BAD, 0x0684, 0x73, 0x30, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0BAE, 0x0684, 0x73, 0x30, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x05AC, 0x0003, 0x47, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x05AD, 0x0003, 0x47, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x05AE, 0x0083, 0x47, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x05AF, 0x0083, 0x47, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0BB5, 0x0004, 0x47, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0BB6, 0x0004, 0x47, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0BB7, 0x0004, 0x47, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0BB8, 0x0204, 0x47, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0BB9, 0x0204, 0x47, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0BBA, 0x0204, 0x47, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0152, 0x0004, 0x47, 0xC0, ZYDIS_INSTRUCTION_ENCODING_MVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0153, 0x0004, 0x47, 0xC0, ZYDIS_INSTRUCTION_ENCODING_MVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0154, 0x0204, 0x47, 0x00, ZYDIS_INSTRUCTION_ENCODING_MVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x05B0, 0x0003, 0x47, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x05B1, 0x0003, 0x47, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x05B2, 0x0083, 0x47, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x05B3, 0x0083, 0x47, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0BBB, 0x0004, 0x47, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0BBC, 0x0004, 0x47, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0BBD, 0x0004, 0x47, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0BBE, 0x0204, 0x47, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0BBF, 0x0204, 0x47, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0BC0, 0x0204, 0x47, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0BC1, 0x0004, 0x12, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0BC2, 0x0004, 0x12, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0BC3, 0x0004, 0x12, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0BC4, 0x0204, 0x12, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0BC5, 0x0204, 0x12, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0BC6, 0x0204, 0x12, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x05B6, 0x0003, 0xF1, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x05B7, 0x0003, 0xF1, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x05B8, 0x0083, 0xF1, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x05B9, 0x0083, 0xF1, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x05B4, 0x0183, 0x71, 0xF0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x05B5, 0x0183, 0x71, 0xF0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0BCD, 0x0004, 0xF1, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0BCE, 0x0004, 0xF1, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0BCF, 0x0004, 0xF1, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0BD0, 0x0204, 0xF1, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0BD1, 0x0204, 0xF1, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0BD2, 0x0204, 0xF1, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0BC7, 0x0604, 0x71, 0xF0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0BC8, 0x0604, 0x71, 0xF0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0BC9, 0x0604, 0x71, 0xF0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0BCA, 0x0684, 0x71, 0x30, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0BCB, 0x0684, 0x71, 0x30, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0BCC, 0x0684, 0x71, 0x30, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x05BC, 0x0003, 0xE2, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x05BD, 0x0003, 0xE2, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x05BE, 0x0083, 0xE2, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x05BF, 0x0083, 0xE2, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x05BA, 0x0183, 0x72, 0xE0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x05BB, 0x0183, 0x72, 0xE0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0BD9, 0x0004, 0xE2, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0BDA, 0x0004, 0xE2, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0BDB, 0x0004, 0xE2, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0BDC, 0x0204, 0xE2, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0BDD, 0x0204, 0xE2, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0BDE, 0x0204, 0xE2, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0BD3, 0x0604, 0x72, 0xE0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0BD4, 0x0604, 0x72, 0xE0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0BD5, 0x0604, 0x72, 0xE0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0BD6, 0x0684, 0x72, 0x20, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0BD7, 0x0684, 0x72, 0x20, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0BD8, 0x0684, 0x72, 0x20, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0155, 0x0604, 0x72, 0xE0, ZYDIS_INSTRUCTION_ENCODING_MVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0156, 0x0604, 0x72, 0xE0, ZYDIS_INSTRUCTION_ENCODING_MVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0157, 0x0684, 0x72, 0x20, ZYDIS_INSTRUCTION_ENCODING_MVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0BE5, 0x0004, 0xE2, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0BE6, 0x0004, 0xE2, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0BE7, 0x0004, 0xE2, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0BE8, 0x0204, 0xE2, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0BE9, 0x0204, 0xE2, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0BEA, 0x0204, 0xE2, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0BDF, 0x0604, 0x72, 0xE0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0BE0, 0x0604, 0x72, 0xE0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0BE1, 0x0604, 0x72, 0xE0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0BE2, 0x0684, 0x72, 0x20, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0BE3, 0x0684, 0x72, 0x20, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0BE4, 0x0684, 0x72, 0x20, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x05C0, 0x0003, 0x46, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x05C1, 0x0003, 0x46, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x05C2, 0x0083, 0x46, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x05C3, 0x0083, 0x46, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0BEB, 0x0004, 0x46, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0BEC, 0x0004, 0x46, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0BED, 0x0004, 0x46, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0BEE, 0x0204, 0x46, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0BEF, 0x0204, 0x46, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0BF0, 0x0204, 0x46, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0158, 0x0004, 0x46, 0xC0, ZYDIS_INSTRUCTION_ENCODING_MVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0159, 0x0004, 0x46, 0xC0, ZYDIS_INSTRUCTION_ENCODING_MVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x015A, 0x0204, 0x46, 0x00, ZYDIS_INSTRUCTION_ENCODING_MVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0BF1, 0x0004, 0x46, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0BF2, 0x0004, 0x46, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0BF3, 0x0004, 0x46, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0BF4, 0x0204, 0x46, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0BF5, 0x0204, 0x46, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0BF6, 0x0204, 0x46, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0BF7, 0x0004, 0x11, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0BF8, 0x0004, 0x11, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0BF9, 0x0004, 0x11, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0BFA, 0x0204, 0x11, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0BFB, 0x0204, 0x11, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0BFC, 0x0204, 0x11, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x05C6, 0x0003, 0xE1, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x05C7, 0x0003, 0xE1, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x05C8, 0x0083, 0xE1, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x05C9, 0x0083, 0xE1, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x05C4, 0x0183, 0x71, 0xE0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x05C5, 0x0183, 0x71, 0xE0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0C03, 0x0004, 0xE1, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0C04, 0x0004, 0xE1, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0C05, 0x0004, 0xE1, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0C06, 0x0204, 0xE1, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0C07, 0x0204, 0xE1, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0C08, 0x0204, 0xE1, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0BFD, 0x0604, 0x71, 0xE0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0BFE, 0x0604, 0x71, 0xE0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0BFF, 0x0604, 0x71, 0xE0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0C00, 0x0684, 0x71, 0x20, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0C01, 0x0684, 0x71, 0x20, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0C02, 0x0684, 0x71, 0x20, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x05CC, 0x0003, 0xD2, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x05CD, 0x0003, 0xD2, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x05CE, 0x0083, 0xD2, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x05CF, 0x0083, 0xD2, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x05CA, 0x0183, 0x72, 0xD0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x05CB, 0x0183, 0x72, 0xD0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0C0F, 0x0004, 0xD2, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0C10, 0x0004, 0xD2, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0C11, 0x0004, 0xD2, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0C12, 0x0204, 0xD2, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0C13, 0x0204, 0xD2, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0C14, 0x0204, 0xD2, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0C09, 0x0604, 0x72, 0xD0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0C0A, 0x0604, 0x72, 0xD0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0C0B, 0x0604, 0x72, 0xD0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0C0C, 0x0684, 0x72, 0x10, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0C0D, 0x0684, 0x72, 0x10, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0C0E, 0x0684, 0x72, 0x10, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x015B, 0x0604, 0x72, 0xD0, ZYDIS_INSTRUCTION_ENCODING_MVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x015C, 0x0604, 0x72, 0xD0, ZYDIS_INSTRUCTION_ENCODING_MVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x015D, 0x0684, 0x72, 0x10, ZYDIS_INSTRUCTION_ENCODING_MVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x05D0, 0x0183, 0x73, 0xD8, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x05D1, 0x0183, 0x73, 0xD8, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0C15, 0x0183, 0x73, 0xD8, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0C16, 0x0183, 0x73, 0xD8, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0C17, 0x0183, 0x73, 0xD8, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0C18, 0x01A3, 0x73, 0x18, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0C19, 0x01A3, 0x73, 0x18, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0C1A, 0x01A3, 0x73, 0x18, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x05D4, 0x0003, 0xD3, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x05D5, 0x0003, 0xD3, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x05D6, 0x0083, 0xD3, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x05D7, 0x0083, 0xD3, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x05D2, 0x0183, 0x73, 0xD0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x05D3, 0x0183, 0x73, 0xD0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0C21, 0x0004, 0xD3, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0C22, 0x0004, 0xD3, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0C23, 0x0004, 0xD3, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0C24, 0x0204, 0xD3, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0C25, 0x0204, 0xD3, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0C26, 0x0204, 0xD3, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0C1B, 0x0604, 0x73, 0xD0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0C1C, 0x0604, 0x73, 0xD0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0C1D, 0x0604, 0x73, 0xD0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0C1E, 0x0684, 0x73, 0x10, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0C1F, 0x0684, 0x73, 0x10, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0C20, 0x0684, 0x73, 0x10, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x05D8, 0x0003, 0x45, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x05D9, 0x0003, 0x45, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x05DA, 0x0083, 0x45, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x05DB, 0x0083, 0x45, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0C27, 0x0004, 0x45, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0C28, 0x0004, 0x45, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0C29, 0x0004, 0x45, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0C2A, 0x0204, 0x45, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0C2B, 0x0204, 0x45, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0C2C, 0x0204, 0x45, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x015E, 0x0004, 0x45, 0xC0, ZYDIS_INSTRUCTION_ENCODING_MVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x015F, 0x0004, 0x45, 0xC0, ZYDIS_INSTRUCTION_ENCODING_MVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0160, 0x0204, 0x45, 0x00, ZYDIS_INSTRUCTION_ENCODING_MVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x05DC, 0x0003, 0x45, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x05DD, 0x0003, 0x45, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x05DE, 0x0083, 0x45, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x05DF, 0x0083, 0x45, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0C2D, 0x0004, 0x45, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0C2E, 0x0004, 0x45, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0C2F, 0x0004, 0x45, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0C30, 0x0204, 0x45, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0C31, 0x0204, 0x45, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0C32, 0x0204, 0x45, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0C33, 0x0004, 0x10, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0C34, 0x0004, 0x10, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0C35, 0x0004, 0x10, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0C36, 0x0204, 0x10, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0C37, 0x0204, 0x10, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0C38, 0x0204, 0x10, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x05E2, 0x0003, 0xD1, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x05E3, 0x0003, 0xD1, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x05E4, 0x0083, 0xD1, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x05E5, 0x0083, 0xD1, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x05E0, 0x0183, 0x71, 0xD0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x05E1, 0x0183, 0x71, 0xD0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0C3F, 0x0004, 0xD1, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0C40, 0x0004, 0xD1, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0C41, 0x0004, 0xD1, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0C42, 0x0204, 0xD1, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0C43, 0x0204, 0xD1, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0C44, 0x0204, 0xD1, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0C39, 0x0604, 0x71, 0xD0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0C3A, 0x0604, 0x71, 0xD0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0C3B, 0x0604, 0x71, 0xD0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0C3C, 0x0684, 0x71, 0x10, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0C3D, 0x0684, 0x71, 0x10, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0C3E, 0x0684, 0x71, 0x10, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x05E6, 0x0003, 0xF8, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x05E7, 0x0003, 0xF8, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x05E8, 0x0083, 0xF8, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x05E9, 0x0083, 0xF8, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0C45, 0x0004, 0xF8, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0C46, 0x0004, 0xF8, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0C47, 0x0004, 0xF8, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0C48, 0x0204, 0xF8, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0C49, 0x0204, 0xF8, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0C4A, 0x0204, 0xF8, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x05EA, 0x0003, 0xFA, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x05EB, 0x0003, 0xFA, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x05EC, 0x0083, 0xFA, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x05ED, 0x0083, 0xFA, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0C4B, 0x0004, 0xFA, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0C4C, 0x0004, 0xFA, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0C4D, 0x0004, 0xFA, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0C4E, 0x0204, 0xFA, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0C4F, 0x0204, 0xFA, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0C50, 0x0204, 0xFA, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0161, 0x0004, 0xFA, 0xC0, ZYDIS_INSTRUCTION_ENCODING_MVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0162, 0x0004, 0xFA, 0xC0, ZYDIS_INSTRUCTION_ENCODING_MVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0163, 0x0204, 0xFA, 0x00, ZYDIS_INSTRUCTION_ENCODING_MVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x05EE, 0x0003, 0xFB, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x05EF, 0x0003, 0xFB, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x05F0, 0x0083, 0xFB, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x05F1, 0x0083, 0xFB, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0C51, 0x0004, 0xFB, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0C52, 0x0004, 0xFB, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0C53, 0x0004, 0xFB, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0C54, 0x0204, 0xFB, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0C55, 0x0204, 0xFB, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0C56, 0x0204, 0xFB, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0164, 0x0004, 0x6C, 0xC0, ZYDIS_INSTRUCTION_ENCODING_MVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0165, 0x0004, 0x6C, 0xC0, ZYDIS_INSTRUCTION_ENCODING_MVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0166, 0x0204, 0x6C, 0x00, ZYDIS_INSTRUCTION_ENCODING_MVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0167, 0x0004, 0x6F, 0xC0, ZYDIS_INSTRUCTION_ENCODING_MVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0168, 0x0004, 0x6F, 0xC0, ZYDIS_INSTRUCTION_ENCODING_MVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0169, 0x0204, 0x6F, 0x00, ZYDIS_INSTRUCTION_ENCODING_MVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x05F2, 0x0003, 0xE8, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x05F3, 0x0003, 0xE8, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x05F4, 0x0083, 0xE8, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x05F5, 0x0083, 0xE8, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0C57, 0x0004, 0xE8, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0C58, 0x0004, 0xE8, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0C59, 0x0004, 0xE8, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0C5A, 0x0204, 0xE8, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0C5B, 0x0204, 0xE8, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0C5C, 0x0204, 0xE8, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x016A, 0x0004, 0x5F, 0xC0, ZYDIS_INSTRUCTION_ENCODING_MVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x016B, 0x0004, 0x5F, 0xC0, ZYDIS_INSTRUCTION_ENCODING_MVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x016C, 0x0204, 0x5F, 0x00, ZYDIS_INSTRUCTION_ENCODING_MVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x05F6, 0x0003, 0xE9, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x05F7, 0x0003, 0xE9, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x05F8, 0x0083, 0xE9, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x05F9, 0x0083, 0xE9, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0C5D, 0x0004, 0xE9, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0C5E, 0x0004, 0xE9, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0C5F, 0x0004, 0xE9, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0C60, 0x0204, 0xE9, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0C61, 0x0204, 0xE9, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0C62, 0x0204, 0xE9, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x05FA, 0x0003, 0xD8, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x05FB, 0x0003, 0xD8, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x05FC, 0x0083, 0xD8, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x05FD, 0x0083, 0xD8, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0C63, 0x0004, 0xD8, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0C64, 0x0004, 0xD8, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0C65, 0x0004, 0xD8, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0C66, 0x0204, 0xD8, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0C67, 0x0204, 0xD8, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0C68, 0x0204, 0xD8, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x05FE, 0x0003, 0xD9, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x05FF, 0x0003, 0xD9, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0600, 0x0083, 0xD9, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0601, 0x0083, 0xD9, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0C69, 0x0004, 0xD9, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0C6A, 0x0004, 0xD9, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0C6B, 0x0004, 0xD9, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0C6C, 0x0204, 0xD9, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0C6D, 0x0204, 0xD9, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0C6E, 0x0204, 0xD9, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0602, 0x0003, 0xF9, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0603, 0x0003, 0xF9, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0604, 0x0083, 0xF9, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0605, 0x0083, 0xF9, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0C6F, 0x0004, 0xF9, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0C70, 0x0004, 0xF9, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0C71, 0x0004, 0xF9, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0C72, 0x0204, 0xF9, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0C73, 0x0204, 0xF9, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0C74, 0x0204, 0xF9, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0C75, 0x1805, 0x25, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0C76, 0x1805, 0x25, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0C77, 0x1805, 0x25, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0C78, 0x1A05, 0x25, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0C79, 0x1A05, 0x25, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0C7A, 0x1A05, 0x25, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0C7B, 0x1805, 0x25, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0C7C, 0x1805, 0x25, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0C7D, 0x1805, 0x25, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0C7E, 0x1A05, 0x25, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0C7F, 0x1A05, 0x25, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0C80, 0x1A05, 0x25, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0606, 0x0002, 0x17, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0607, 0x0002, 0x17, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0608, 0x0022, 0x17, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0609, 0x0022, 0x17, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0C81, 0x0004, 0x26, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0C82, 0x0004, 0x26, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0C83, 0x0004, 0x26, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0C84, 0x0204, 0x26, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0C85, 0x0204, 0x26, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0C86, 0x0204, 0x26, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0C87, 0x0004, 0x27, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0C88, 0x0004, 0x27, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0C89, 0x0004, 0x27, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0C8A, 0x0204, 0x27, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0C8B, 0x0204, 0x27, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0C8C, 0x0204, 0x27, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x016D, 0x0004, 0x27, 0xC0, ZYDIS_INSTRUCTION_ENCODING_MVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x016E, 0x0004, 0x27, 0xC0, ZYDIS_INSTRUCTION_ENCODING_MVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x016F, 0x0204, 0x27, 0x00, ZYDIS_INSTRUCTION_ENCODING_MVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0C8D, 0x0004, 0x27, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0C8E, 0x0004, 0x27, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0C8F, 0x0004, 0x27, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0C90, 0x0204, 0x27, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0C91, 0x0204, 0x27, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0C92, 0x0204, 0x27, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0C93, 0x0004, 0x26, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0C94, 0x0004, 0x26, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0C95, 0x0004, 0x26, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0C96, 0x0204, 0x26, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0C97, 0x0204, 0x26, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0C98, 0x0204, 0x26, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0C99, 0x0004, 0x26, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0C9A, 0x0004, 0x26, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0C9B, 0x0004, 0x26, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0C9C, 0x0204, 0x26, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0C9D, 0x0204, 0x26, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0C9E, 0x0204, 0x26, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0C9F, 0x0004, 0x27, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0CA0, 0x0004, 0x27, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0CA1, 0x0004, 0x27, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0CA2, 0x0204, 0x27, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0CA3, 0x0204, 0x27, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0CA4, 0x0204, 0x27, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0CA5, 0x0004, 0x27, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0CA6, 0x0004, 0x27, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0CA7, 0x0004, 0x27, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0CA8, 0x0204, 0x27, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0CA9, 0x0204, 0x27, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0CAA, 0x0204, 0x27, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0CAB, 0x0004, 0x26, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0CAC, 0x0004, 0x26, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0CAD, 0x0004, 0x26, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0CAE, 0x0204, 0x26, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0CAF, 0x0204, 0x26, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0CB0, 0x0204, 0x26, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x060A, 0x0003, 0x68, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x060B, 0x0003, 0x68, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x060C, 0x0083, 0x68, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x060D, 0x0083, 0x68, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0CB1, 0x0004, 0x68, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0CB2, 0x0004, 0x68, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0CB3, 0x0004, 0x68, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0CB4, 0x0204, 0x68, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0CB5, 0x0204, 0x68, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0CB6, 0x0204, 0x68, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x060E, 0x0003, 0x6A, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x060F, 0x0003, 0x6A, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0610, 0x0083, 0x6A, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0611, 0x0083, 0x6A, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0CB7, 0x0004, 0x6A, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0CB8, 0x0004, 0x6A, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0CB9, 0x0004, 0x6A, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0CBA, 0x0204, 0x6A, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0CBB, 0x0204, 0x6A, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0CBC, 0x0204, 0x6A, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0612, 0x0003, 0x6D, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0613, 0x0003, 0x6D, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0614, 0x0083, 0x6D, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0615, 0x0083, 0x6D, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0CBD, 0x0004, 0x6D, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0CBE, 0x0004, 0x6D, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0CBF, 0x0004, 0x6D, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0CC0, 0x0204, 0x6D, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0CC1, 0x0204, 0x6D, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0CC2, 0x0204, 0x6D, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0616, 0x0003, 0x69, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0617, 0x0003, 0x69, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0618, 0x0083, 0x69, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0619, 0x0083, 0x69, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0CC3, 0x0004, 0x69, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0CC4, 0x0004, 0x69, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0CC5, 0x0004, 0x69, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0CC6, 0x0204, 0x69, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0CC7, 0x0204, 0x69, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0CC8, 0x0204, 0x69, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x061A, 0x0003, 0x60, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x061B, 0x0003, 0x60, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x061C, 0x0083, 0x60, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x061D, 0x0083, 0x60, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0CC9, 0x0004, 0x60, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0CCA, 0x0004, 0x60, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0CCB, 0x0004, 0x60, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0CCC, 0x0204, 0x60, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0CCD, 0x0204, 0x60, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0CCE, 0x0204, 0x60, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x061E, 0x0003, 0x62, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x061F, 0x0003, 0x62, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0620, 0x0083, 0x62, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0621, 0x0083, 0x62, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0CCF, 0x0004, 0x62, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0CD0, 0x0004, 0x62, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0CD1, 0x0004, 0x62, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0CD2, 0x0204, 0x62, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0CD3, 0x0204, 0x62, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0CD4, 0x0204, 0x62, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0622, 0x0003, 0x6C, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0623, 0x0003, 0x6C, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0624, 0x0083, 0x6C, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0625, 0x0083, 0x6C, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0CD5, 0x0004, 0x6C, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0CD6, 0x0004, 0x6C, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0CD7, 0x0004, 0x6C, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0CD8, 0x0204, 0x6C, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0CD9, 0x0204, 0x6C, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0CDA, 0x0204, 0x6C, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0626, 0x0003, 0x61, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0627, 0x0003, 0x61, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0628, 0x0083, 0x61, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0629, 0x0083, 0x61, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0CDB, 0x0004, 0x61, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0CDC, 0x0004, 0x61, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0CDD, 0x0004, 0x61, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0CDE, 0x0204, 0x61, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0CDF, 0x0204, 0x61, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0CE0, 0x0204, 0x61, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x062A, 0x0003, 0xEF, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x062B, 0x0003, 0xEF, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x062C, 0x0083, 0xEF, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x062D, 0x0083, 0xEF, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0CE1, 0x0004, 0xEF, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0CE2, 0x0004, 0xEF, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0CE3, 0x0004, 0xEF, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0CE4, 0x0204, 0xEF, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0CE5, 0x0204, 0xEF, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0CE6, 0x0204, 0xEF, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0170, 0x0004, 0xEF, 0xC0, ZYDIS_INSTRUCTION_ENCODING_MVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0171, 0x0004, 0xEF, 0xC0, ZYDIS_INSTRUCTION_ENCODING_MVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0172, 0x0204, 0xEF, 0x00, ZYDIS_INSTRUCTION_ENCODING_MVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0CE7, 0x0004, 0xEF, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0CE8, 0x0004, 0xEF, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0CE9, 0x0004, 0xEF, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0CEA, 0x0204, 0xEF, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0CEB, 0x0204, 0xEF, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0CEC, 0x0204, 0xEF, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0173, 0x0004, 0xEF, 0xC0, ZYDIS_INSTRUCTION_ENCODING_MVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_64, ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0174, 0x0004, 0xEF, 0xC0, ZYDIS_INSTRUCTION_ENCODING_MVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_64, ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0175, 0x0204, 0xEF, 0x00, ZYDIS_INSTRUCTION_ENCODING_MVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_64, ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0CED, 0x1805, 0x50, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0CEE, 0x1805, 0x50, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0CEF, 0x1805, 0x50, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0CF0, 0x1805, 0x50, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0CF1, 0x1A05, 0x50, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0CF2, 0x1A05, 0x50, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0CF3, 0x1A05, 0x50, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0CF4, 0x1805, 0x50, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0CF5, 0x1805, 0x50, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0CF6, 0x1805, 0x50, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0CF7, 0x1805, 0x50, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0CF8, 0x1A05, 0x50, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0CF9, 0x1A05, 0x50, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0CFA, 0x1A05, 0x50, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0CFB, 0x1805, 0x51, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0CFC, 0x1805, 0x51, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0CFD, 0x1A05, 0x51, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0CFE, 0x1805, 0x51, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0CFF, 0x1805, 0x51, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0D00, 0x1A05, 0x51, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0D01, 0x0003, 0x4C, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0D02, 0x0003, 0x4C, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0D03, 0x0003, 0x4C, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0D04, 0x0083, 0x4C, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0D05, 0x0083, 0x4C, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0D06, 0x0083, 0x4C, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0D07, 0x0003, 0x4C, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0D08, 0x0003, 0x4C, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0D09, 0x0003, 0x4C, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0D0A, 0x0083, 0x4C, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0D0B, 0x0083, 0x4C, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0D0C, 0x0083, 0x4C, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0D0D, 0x0004, 0x4D, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0D0E, 0x0204, 0x4D, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0D0F, 0x0004, 0x4D, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0D10, 0x0204, 0x4D, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0176, 0x0003, 0xCA, 0xC0, ZYDIS_INSTRUCTION_ENCODING_MVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0177, 0x0003, 0xCA, 0xC0, ZYDIS_INSTRUCTION_ENCODING_MVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0178, 0x0083, 0xCA, 0x00, ZYDIS_INSTRUCTION_ENCODING_MVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0D11, 0x0003, 0xCA, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0D12, 0x0003, 0xCA, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0D13, 0x0083, 0xCA, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0D14, 0x0003, 0xCA, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0D15, 0x0003, 0xCA, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0D16, 0x0083, 0xCA, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0D17, 0x0004, 0xCB, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0D18, 0x0004, 0xCB, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0D19, 0x0204, 0xCB, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0D1A, 0x0004, 0xCB, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0D1B, 0x0004, 0xCB, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0D1C, 0x0204, 0xCB, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0D1D, 0x0003, 0x4C, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_MAP6, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0D1E, 0x0003, 0x4C, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_MAP6, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0D1F, 0x0003, 0x4C, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_MAP6, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0D20, 0x0083, 0x4C, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_MAP6, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0D21, 0x0083, 0x4C, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_MAP6, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0D22, 0x0083, 0x4C, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_MAP6, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x062E, 0x0002, 0x53, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x062F, 0x0002, 0x53, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0630, 0x0022, 0x53, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0631, 0x0022, 0x53, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0D23, 0x0004, 0x4D, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_MAP6, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0D24, 0x0204, 0x4D, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_MAP6, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0632, 0x0003, 0x53, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0633, 0x0083, 0x53, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0D25, 0x0604, 0x56, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0D26, 0x0604, 0x56, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0D27, 0x0604, 0x56, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0D28, 0x0604, 0x56, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0D29, 0x0684, 0x56, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0D2A, 0x0684, 0x56, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0D2B, 0x0684, 0x56, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0D2C, 0x0604, 0x56, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0D2D, 0x0604, 0x56, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0D2E, 0x0604, 0x56, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0D2F, 0x0604, 0x56, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0D30, 0x0684, 0x56, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0D31, 0x0684, 0x56, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0D32, 0x0684, 0x56, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0D33, 0x0604, 0x56, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0D34, 0x0604, 0x56, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0D35, 0x0604, 0x56, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0D36, 0x0604, 0x56, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0D37, 0x0684, 0x56, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0D38, 0x0684, 0x56, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0D39, 0x0684, 0x56, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0D3A, 0x1805, 0x57, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0D3B, 0x1805, 0x57, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0D3C, 0x1A05, 0x57, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0D3D, 0x1805, 0x57, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0D3E, 0x1805, 0x57, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0D3F, 0x1A05, 0x57, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0D40, 0x1805, 0x57, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0D41, 0x1805, 0x57, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0D42, 0x1A05, 0x57, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0179, 0x0604, 0x52, 0xC0, ZYDIS_INSTRUCTION_ENCODING_MVEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_64, ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x017A, 0x0604, 0x52, 0xC0, ZYDIS_INSTRUCTION_ENCODING_MVEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_64, ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x017B, 0x0684, 0x52, 0x00, ZYDIS_INSTRUCTION_ENCODING_MVEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_64, ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x017C, 0x0604, 0x52, 0xC0, ZYDIS_INSTRUCTION_ENCODING_MVEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x017D, 0x0604, 0x52, 0xC0, ZYDIS_INSTRUCTION_ENCODING_MVEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x017E, 0x0684, 0x52, 0x00, ZYDIS_INSTRUCTION_ENCODING_MVEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0D43, 0x0604, 0x09, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0D44, 0x0604, 0x09, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0D45, 0x0604, 0x09, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0D46, 0x0604, 0x09, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0D47, 0x0684, 0x09, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0D48, 0x0684, 0x09, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0D49, 0x0684, 0x09, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0D4A, 0x0604, 0x08, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0D4B, 0x0604, 0x08, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0D4C, 0x0604, 0x08, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0D4D, 0x0604, 0x08, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0D4E, 0x0684, 0x08, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0D4F, 0x0684, 0x08, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0D50, 0x0684, 0x08, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0D51, 0x0604, 0x08, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0D52, 0x0604, 0x08, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0D53, 0x0604, 0x08, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0D54, 0x0604, 0x08, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0D55, 0x0684, 0x08, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0D56, 0x0684, 0x08, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0D57, 0x0684, 0x08, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0D58, 0x1805, 0x0B, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0D59, 0x1805, 0x0B, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0D5A, 0x1A05, 0x0B, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0D5B, 0x1805, 0x0A, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0D5C, 0x1805, 0x0A, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0D5D, 0x1A05, 0x0A, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0D5E, 0x1805, 0x0A, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0D5F, 0x1805, 0x0A, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0D60, 0x1A05, 0x0A, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0634, 0x0183, 0x09, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0635, 0x0183, 0x09, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0636, 0x01A3, 0x09, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0637, 0x01A3, 0x09, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0638, 0x0183, 0x08, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0639, 0x0183, 0x08, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x063A, 0x01A3, 0x08, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x063B, 0x01A3, 0x08, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x063C, 0x0604, 0x0B, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x063D, 0x0684, 0x0B, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x063E, 0x0604, 0x0A, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x063F, 0x0684, 0x0A, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0D61, 0x0003, 0x4E, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0D62, 0x0003, 0x4E, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0D63, 0x0003, 0x4E, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0D64, 0x0083, 0x4E, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0D65, 0x0083, 0x4E, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0D66, 0x0083, 0x4E, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0D67, 0x0003, 0x4E, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0D68, 0x0003, 0x4E, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0D69, 0x0003, 0x4E, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0D6A, 0x0083, 0x4E, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0D6B, 0x0083, 0x4E, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0D6C, 0x0083, 0x4E, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0D6D, 0x0004, 0x4F, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0D6E, 0x0204, 0x4F, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0D6F, 0x0004, 0x4F, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0D70, 0x0204, 0x4F, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x017F, 0x0003, 0xCB, 0xC0, ZYDIS_INSTRUCTION_ENCODING_MVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0180, 0x0003, 0xCB, 0xC0, ZYDIS_INSTRUCTION_ENCODING_MVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0181, 0x0083, 0xCB, 0x00, ZYDIS_INSTRUCTION_ENCODING_MVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0D71, 0x0003, 0xCC, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0D72, 0x0003, 0xCC, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0D73, 0x0083, 0xCC, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0D74, 0x0003, 0xCC, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0D75, 0x0003, 0xCC, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0D76, 0x0083, 0xCC, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0D77, 0x0004, 0xCD, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0D78, 0x0004, 0xCD, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0D79, 0x0204, 0xCD, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0D7A, 0x0004, 0xCD, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0D7B, 0x0004, 0xCD, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0D7C, 0x0204, 0xCD, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0D7D, 0x0003, 0x4E, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_MAP6, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0D7E, 0x0003, 0x4E, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_MAP6, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0D7F, 0x0003, 0x4E, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_MAP6, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0D80, 0x0083, 0x4E, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_MAP6, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0D81, 0x0083, 0x4E, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_MAP6, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0D82, 0x0083, 0x4E, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_MAP6, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0640, 0x0002, 0x52, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0641, 0x0002, 0x52, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0642, 0x0022, 0x52, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0643, 0x0022, 0x52, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0D83, 0x0004, 0x4F, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_MAP6, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0D84, 0x0204, 0x4F, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_MAP6, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0644, 0x0003, 0x52, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0645, 0x0083, 0x52, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0D85, 0x0004, 0x2C, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0D86, 0x0004, 0x2C, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0D87, 0x0004, 0x2C, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0D88, 0x0004, 0x2C, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0D89, 0x0204, 0x2C, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0D8A, 0x0204, 0x2C, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0D8B, 0x0204, 0x2C, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0D8C, 0x0004, 0x2C, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_MAP6, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0D8D, 0x0004, 0x2C, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_MAP6, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0D8E, 0x0004, 0x2C, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_MAP6, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0D8F, 0x0004, 0x2C, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_MAP6, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0D90, 0x0204, 0x2C, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_MAP6, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0D91, 0x0204, 0x2C, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_MAP6, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0D92, 0x0204, 0x2C, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_MAP6, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0D93, 0x0004, 0x2C, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0D94, 0x0004, 0x2C, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0D95, 0x0004, 0x2C, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0D96, 0x0004, 0x2C, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0D97, 0x0204, 0x2C, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0D98, 0x0204, 0x2C, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0D99, 0x0204, 0x2C, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0D9A, 0x0004, 0x2D, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0D9B, 0x0004, 0x2D, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0D9C, 0x0204, 0x2D, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0D9D, 0x0004, 0x2D, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_MAP6, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0D9E, 0x0004, 0x2D, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_MAP6, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0D9F, 0x0204, 0x2D, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_MAP6, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0DA0, 0x0004, 0x2D, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0DA1, 0x0004, 0x2D, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0DA2, 0x0204, 0x2D, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0182, 0x0004, 0x84, 0xC0, ZYDIS_INSTRUCTION_ENCODING_MVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0183, 0x0004, 0x84, 0xC0, ZYDIS_INSTRUCTION_ENCODING_MVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0184, 0x0204, 0x84, 0x00, ZYDIS_INSTRUCTION_ENCODING_MVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0DA3, 0x000B, 0xA2, 0x04, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0DA4, 0x000B, 0xA2, 0x04, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0DA5, 0x000B, 0xA2, 0x04, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0185, 0x000B, 0xA2, 0x04, ZYDIS_INSTRUCTION_ENCODING_MVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_64, ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0DA6, 0x000B, 0xA2, 0x04, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0DA7, 0x000B, 0xA2, 0x04, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0DA8, 0x000B, 0xA2, 0x04, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0186, 0x000B, 0xA2, 0x04, ZYDIS_INSTRUCTION_ENCODING_MVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0DA9, 0x000A, 0xC6, 0x2C, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0DAA, 0x000A, 0xC6, 0x2C, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0187, 0x000A, 0xC6, 0x2C, ZYDIS_INSTRUCTION_ENCODING_MVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0188, 0x000A, 0xC6, 0x24, ZYDIS_INSTRUCTION_ENCODING_MVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_64, ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0189, 0x000A, 0xC6, 0x24, ZYDIS_INSTRUCTION_ENCODING_MVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0DAB, 0x000A, 0xC7, 0x2C, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0DAC, 0x000A, 0xC7, 0x2C, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0DAD, 0x000A, 0xC6, 0x34, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0DAE, 0x000A, 0xC6, 0x34, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x018A, 0x000A, 0xC6, 0x34, ZYDIS_INSTRUCTION_ENCODING_MVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0DAF, 0x000A, 0xC7, 0x34, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0DB0, 0x000A, 0xC7, 0x34, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0DB1, 0x000B, 0xA3, 0x04, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0DB2, 0x000B, 0xA3, 0x04, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0DB3, 0x000B, 0xA3, 0x04, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0DB4, 0x000B, 0xA3, 0x04, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0DB5, 0x000B, 0xA3, 0x04, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0DB6, 0x000B, 0xA3, 0x04, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0646, 0x0002, 0xCC, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F2, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0647, 0x0002, 0xCD, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F2, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0648, 0x0003, 0xCB, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F2, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0DB7, 0x1805, 0x23, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0DB8, 0x1805, 0x23, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0DB9, 0x1A05, 0x23, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0DBA, 0x1A05, 0x23, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0DBB, 0x1805, 0x23, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0DBC, 0x1805, 0x23, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0DBD, 0x1A05, 0x23, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0DBE, 0x1A05, 0x23, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0DBF, 0x1805, 0x43, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0DC0, 0x1805, 0x43, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0DC1, 0x1A05, 0x43, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0DC2, 0x1A05, 0x43, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0DC3, 0x1805, 0x43, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0DC4, 0x1805, 0x43, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0DC5, 0x1A05, 0x43, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0DC6, 0x1A05, 0x43, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0649, 0x0604, 0xC6, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x064A, 0x0604, 0xC6, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x064B, 0x0684, 0xC6, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x064C, 0x0684, 0xC6, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0DC7, 0x1805, 0xC6, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0DC8, 0x1805, 0xC6, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0DC9, 0x1805, 0xC6, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0DCA, 0x1A05, 0xC6, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0DCB, 0x1A05, 0xC6, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0DCC, 0x1A05, 0xC6, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x064D, 0x0604, 0xC6, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x064E, 0x0604, 0xC6, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x064F, 0x0684, 0xC6, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0650, 0x0684, 0xC6, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0DCD, 0x1805, 0xC6, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0DCE, 0x1805, 0xC6, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0DCF, 0x1805, 0xC6, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0DD0, 0x1A05, 0xC6, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0DD1, 0x1A05, 0xC6, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0DD2, 0x1A05, 0xC6, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0651, 0x0003, 0xDA, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0652, 0x0083, 0xDA, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0653, 0x0003, 0xDA, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0654, 0x0083, 0xDA, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0655, 0x0604, 0xDE, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0656, 0x0684, 0xDE, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F3A, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0657, 0x0003, 0xDA, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0658, 0x0003, 0xDA, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0659, 0x0083, 0xDA, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x065A, 0x0083, 0xDA, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x065B, 0x0003, 0xDA, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F2, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x065C, 0x0003, 0xDA, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F2, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x065D, 0x0083, 0xDA, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F2, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x065E, 0x0083, 0xDA, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F2, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x065F, 0x0002, 0x51, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0660, 0x0002, 0x51, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0661, 0x0022, 0x51, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0662, 0x0022, 0x51, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0DD3, 0x0003, 0x51, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0DD4, 0x0003, 0x51, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0DD5, 0x0003, 0x51, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0DD6, 0x0003, 0x51, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0DD7, 0x0083, 0x51, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0DD8, 0x0083, 0x51, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0DD9, 0x0083, 0x51, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0DDA, 0x0003, 0x51, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_MAP5, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0DDB, 0x0003, 0x51, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_MAP5, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0DDC, 0x0003, 0x51, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_MAP5, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0DDD, 0x0003, 0x51, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_MAP5, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0DDE, 0x0083, 0x51, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_MAP5, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0DDF, 0x0083, 0x51, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_MAP5, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0DE0, 0x0083, 0x51, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_MAP5, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0663, 0x0002, 0x51, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0664, 0x0002, 0x51, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0665, 0x0022, 0x51, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0666, 0x0022, 0x51, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0DE1, 0x0003, 0x51, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0DE2, 0x0003, 0x51, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0DE3, 0x0003, 0x51, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0DE4, 0x0003, 0x51, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0DE5, 0x0083, 0x51, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0DE6, 0x0083, 0x51, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0DE7, 0x0083, 0x51, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0667, 0x0003, 0x51, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F2, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0668, 0x0083, 0x51, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F2, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0DE8, 0x0004, 0x51, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F2, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0DE9, 0x0004, 0x51, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F2, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0DEA, 0x0204, 0x51, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F2, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0DEB, 0x0004, 0x51, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_MAP5, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0DEC, 0x0004, 0x51, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_MAP5, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0DED, 0x0204, 0x51, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_MAP5, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0669, 0x0003, 0x51, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x066A, 0x0083, 0x51, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0DEE, 0x0004, 0x51, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0DEF, 0x0004, 0x51, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0DF0, 0x0204, 0x51, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x066B, 0x0009, 0xAE, 0x18, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x066C, 0x0003, 0x5C, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x066D, 0x0003, 0x5C, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x066E, 0x0083, 0x5C, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x066F, 0x0083, 0x5C, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0DF1, 0x0004, 0x5C, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0DF2, 0x0004, 0x5C, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0DF3, 0x0004, 0x5C, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0DF4, 0x0004, 0x5C, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0DF5, 0x0204, 0x5C, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0DF6, 0x0204, 0x5C, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0DF7, 0x0204, 0x5C, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x018B, 0x0004, 0x5C, 0xC0, ZYDIS_INSTRUCTION_ENCODING_MVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_64, ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x018C, 0x0004, 0x5C, 0xC0, ZYDIS_INSTRUCTION_ENCODING_MVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_64, ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x018D, 0x0204, 0x5C, 0x00, ZYDIS_INSTRUCTION_ENCODING_MVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_64, ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0DF8, 0x0004, 0x5C, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_MAP5, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0DF9, 0x0004, 0x5C, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_MAP5, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0DFA, 0x0004, 0x5C, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_MAP5, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0DFB, 0x0004, 0x5C, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_MAP5, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0DFC, 0x0204, 0x5C, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_MAP5, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0DFD, 0x0204, 0x5C, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_MAP5, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0DFE, 0x0204, 0x5C, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_MAP5, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0670, 0x0003, 0x5C, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0671, 0x0003, 0x5C, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0672, 0x0083, 0x5C, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0673, 0x0083, 0x5C, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0DFF, 0x0004, 0x5C, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0E00, 0x0004, 0x5C, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0E01, 0x0004, 0x5C, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0E02, 0x0004, 0x5C, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0E03, 0x0204, 0x5C, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0E04, 0x0204, 0x5C, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0E05, 0x0204, 0x5C, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x018E, 0x0004, 0x5C, 0xC0, ZYDIS_INSTRUCTION_ENCODING_MVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x018F, 0x0004, 0x5C, 0xC0, ZYDIS_INSTRUCTION_ENCODING_MVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0190, 0x0204, 0x5C, 0x00, ZYDIS_INSTRUCTION_ENCODING_MVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0191, 0x0004, 0x6D, 0xC0, ZYDIS_INSTRUCTION_ENCODING_MVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_64, ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0192, 0x0004, 0x6D, 0xC0, ZYDIS_INSTRUCTION_ENCODING_MVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_64, ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0193, 0x0204, 0x6D, 0x00, ZYDIS_INSTRUCTION_ENCODING_MVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_64, ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0194, 0x0004, 0x6D, 0xC0, ZYDIS_INSTRUCTION_ENCODING_MVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0195, 0x0004, 0x6D, 0xC0, ZYDIS_INSTRUCTION_ENCODING_MVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0196, 0x0204, 0x6D, 0x00, ZYDIS_INSTRUCTION_ENCODING_MVEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0674, 0x0003, 0x5C, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F2, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0675, 0x0083, 0x5C, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F2, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0E06, 0x0004, 0x5C, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F2, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0E07, 0x0004, 0x5C, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F2, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0E08, 0x0204, 0x5C, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F2, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0E09, 0x0004, 0x5C, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_MAP5, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0E0A, 0x0004, 0x5C, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_MAP5, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0E0B, 0x0204, 0x5C, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_MAP5, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0676, 0x0003, 0x5C, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0677, 0x0083, 0x5C, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0E0C, 0x0004, 0x5C, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0E0D, 0x0004, 0x5C, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0E0E, 0x0204, 0x5C, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0678, 0x0002, 0x0F, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0679, 0x0002, 0x0F, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x067A, 0x0022, 0x0F, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x067B, 0x0022, 0x0F, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x067C, 0x0002, 0x0E, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x067D, 0x0002, 0x0E, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x067E, 0x0022, 0x0E, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x067F, 0x0022, 0x0E, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0680, 0x0002, 0x2E, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0681, 0x0022, 0x2E, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0E0F, 0x0002, 0x2E, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0E10, 0x0002, 0x2E, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0E11, 0x0022, 0x2E, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0E12, 0x0002, 0x2E, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_MAP5, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0E13, 0x0002, 0x2E, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_MAP5, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0E14, 0x0022, 0x2E, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_MAP5, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0682, 0x0002, 0x2E, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0683, 0x0022, 0x2E, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0E15, 0x0002, 0x2E, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0E16, 0x0002, 0x2E, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0E17, 0x0022, 0x2E, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0684, 0x0003, 0x15, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0685, 0x0003, 0x15, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0686, 0x0083, 0x15, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0687, 0x0083, 0x15, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0E18, 0x0004, 0x15, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0E19, 0x0004, 0x15, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0E1A, 0x0004, 0x15, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0E1B, 0x0204, 0x15, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0E1C, 0x0204, 0x15, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0E1D, 0x0204, 0x15, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0688, 0x0003, 0x15, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0689, 0x0003, 0x15, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x068A, 0x0083, 0x15, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x068B, 0x0083, 0x15, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0E1E, 0x0004, 0x15, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0E1F, 0x0004, 0x15, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0E20, 0x0004, 0x15, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0E21, 0x0204, 0x15, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0E22, 0x0204, 0x15, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0E23, 0x0204, 0x15, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x068C, 0x0003, 0x14, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x068D, 0x0003, 0x14, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x068E, 0x0083, 0x14, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x068F, 0x0083, 0x14, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0E24, 0x0004, 0x14, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0E25, 0x0004, 0x14, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0E26, 0x0004, 0x14, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0E27, 0x0204, 0x14, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0E28, 0x0204, 0x14, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0E29, 0x0204, 0x14, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0690, 0x0003, 0x14, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0691, 0x0003, 0x14, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0692, 0x0083, 0x14, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0693, 0x0083, 0x14, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0E2A, 0x0004, 0x14, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0E2B, 0x0004, 0x14, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0E2C, 0x0004, 0x14, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0E2D, 0x0204, 0x14, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0E2E, 0x0204, 0x14, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0E2F, 0x0204, 0x14, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0694, 0x0003, 0x57, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0695, 0x0003, 0x57, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0696, 0x0083, 0x57, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0697, 0x0083, 0x57, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0E30, 0x0004, 0x57, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0E31, 0x0004, 0x57, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0E32, 0x0004, 0x57, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0E33, 0x0204, 0x57, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0E34, 0x0204, 0x57, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0E35, 0x0204, 0x57, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0698, 0x0003, 0x57, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0699, 0x0003, 0x57, 0xC0, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x069A, 0x0083, 0x57, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x069B, 0x0083, 0x57, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0E36, 0x0004, 0x57, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0E37, 0x0004, 0x57, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0E38, 0x0004, 0x57, 0xC0, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0E39, 0x0204, 0x57, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0E3A, 0x0204, 0x57, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0E3B, 0x0204, 0x57, 0x00, ZYDIS_INSTRUCTION_ENCODING_EVEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_512, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x069C, 0x0000, 0x77, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_256, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x069D, 0x0000, 0x77, 0x00, ZYDIS_INSTRUCTION_ENCODING_VEX, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_128, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0755, 0x0000, 0x09, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0756, 0x0001, 0xAE, 0xD0, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_64, ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0757, 0x0001, 0xAE, 0xD8, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_64, ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0758, 0x0000, 0x30, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0759, 0x0000, 0x01, 0xC6, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_64, ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x075A, 0x0000, 0x01, 0xC6, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x075B, 0x0000, 0x01, 0xEF, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x075C, 0x000A, 0xF6, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x075D, 0x000A, 0xF6, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_64, ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x075E, 0x000A, 0xF5, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x075F, 0x000A, 0xF5, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F38, ZYDIS_WIDTH_64, ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0760, 0x0019, 0xC6, 0xF8, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_DEFAULT, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0761, 0x0002, 0xC0, 0xC0, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0762, 0x000A, 0xC0, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0763, 0x0002, 0xC1, 0xC0, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0764, 0x000A, 0xC1, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0765, 0x0019, 0xC7, 0xF8, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_DEFAULT, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_OSZ, ZYAN_FALSE },
    { 0x076A, 0x0002, 0x90, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_DEFAULT, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x076B, 0x0002, 0x91, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_DEFAULT, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0766, 0x0002, 0x86, 0xC0, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_DEFAULT, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0767, 0x000A, 0x86, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_DEFAULT, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0768, 0x0002, 0x87, 0xC0, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_DEFAULT, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0769, 0x000A, 0x87, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_DEFAULT, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x076C, 0x0000, 0xA7, 0xD0, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_ASZ, ZYAN_FALSE },
    { 0x076D, 0x0000, 0xA7, 0xE0, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_ASZ, ZYAN_FALSE },
    { 0x076E, 0x0000, 0xA7, 0xD8, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_ASZ, ZYAN_FALSE },
    { 0x076F, 0x0000, 0xA7, 0xC8, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_ASZ, ZYAN_FALSE },
    { 0x0770, 0x0000, 0xA7, 0xE8, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_ASZ, ZYAN_FALSE },
    { 0x0771, 0x0000, 0x01, 0xD5, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0772, 0x0000, 0x01, 0xD0, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0773, 0x0000, 0xD7, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_DEFAULT, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_ASZ, ZYAN_FALSE },
    { 0x0774, 0x0002, 0x30, 0xC0, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_DEFAULT, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0775, 0x000A, 0x30, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_DEFAULT, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0776, 0x0002, 0x31, 0xC0, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_DEFAULT, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0777, 0x000A, 0x31, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_DEFAULT, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0778, 0x0002, 0x32, 0xC0, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_DEFAULT, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0779, 0x0022, 0x32, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_DEFAULT, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x077A, 0x0002, 0x33, 0xC0, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_DEFAULT, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x077B, 0x0022, 0x33, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_DEFAULT, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x077C, 0x0062, 0x34, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_DEFAULT, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x077E, 0x0062, 0x80, 0xF0, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_DEFAULT, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x077F, 0x006A, 0x80, 0x30, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_DEFAULT, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0782, 0x0062, 0x82, 0xF0, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_DEFAULT, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0783, 0x006A, 0x82, 0x30, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_DEFAULT, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0784, 0x0062, 0x83, 0xF0, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_DEFAULT, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0785, 0x006A, 0x83, 0x30, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_DEFAULT, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x077D, 0x0062, 0x35, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_DEFAULT, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0780, 0x0062, 0x81, 0xF0, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_DEFAULT, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0781, 0x006A, 0x81, 0x30, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_DEFAULT, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0786, 0x0002, 0x57, 0xC0, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0787, 0x0022, 0x57, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_66, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0788, 0x0002, 0x57, 0xC0, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0789, 0x0022, 0x57, 0x00, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x078A, 0x0000, 0x01, 0xE9, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F2, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x078B, 0x0009, 0xAE, 0x28, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x078C, 0x0009, 0xAE, 0x28, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_64, ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x078D, 0x0009, 0xC7, 0x18, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x078E, 0x0009, 0xC7, 0x18, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_64, ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x078F, 0x0009, 0xAE, 0x20, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0790, 0x0009, 0xAE, 0x20, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_64, ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0791, 0x0009, 0xC7, 0x20, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0792, 0x0009, 0xC7, 0x20, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_64, ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0793, 0x0009, 0xAE, 0x30, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0794, 0x0009, 0xAE, 0x30, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_64, ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0795, 0x0009, 0xC7, 0x28, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0796, 0x0009, 0xC7, 0x28, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_64, ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_TRUE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0797, 0x0000, 0x01, 0xD1, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x0798, 0x0000, 0xA6, 0xC8, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_ASZ, ZYAN_FALSE },
    { 0x0799, 0x0000, 0xA6, 0xD0, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_ASZ, ZYAN_FALSE },
    { 0x079A, 0x0000, 0xA7, 0xC0, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_ASZ, ZYAN_FALSE },
    { 0x079B, 0x0000, 0xA7, 0xC0, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F3, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_ASZ, ZYAN_FALSE },
    { 0x079C, 0x0000, 0x01, 0xE8, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_F2, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
    { 0x079D, 0x0000, 0x01, 0xD6, ZYDIS_INSTRUCTION_ENCODING_LEGACY, ZYDIS_OPCODE_MAP_0F, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_WIDTH_16 | ZYDIS_WIDTH_32 | ZYDIS_WIDTH_64, ZYDIS_MANDATORY_PREFIX_NONE, ZYAN_FALSE, ZYDIS_VECTOR_LENGTH_INVALID, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE },
};


//
// Header: Generated/GetRelInfo.inc
//

const ZydisEncoderRelInfo *ZydisGetRelInfo(ZydisMnemonic mnemonic)
{
    static const ZydisEncoderRelInfo info_lookup[9] =
    {
        { { { 0, 3, 6 }, { 0, 4, 5 }, { 0, 0, 5 } }, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE, ZYAN_TRUE },
        { { { 2, 4, 7 }, { 2, 5, 6 }, { 2, 0, 6 } }, ZYDIS_SIZE_HINT_NONE, ZYAN_TRUE, ZYAN_TRUE },
        { { { 2, 0, 0 }, { 3, 0, 0 }, { 0, 0, 0 } }, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE, ZYAN_FALSE },
        { { { 3, 0, 0 }, { 2, 0, 0 }, { 3, 0, 0 } }, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE, ZYAN_FALSE },
        { { { 0, 0, 0 }, { 0, 0, 0 }, { 5, 0, 7 } }, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE, ZYAN_FALSE },
        { { { 2, 3, 6 }, { 2, 4, 5 }, { 2, 0, 5 } }, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE, ZYAN_TRUE },
        { { { 0, 0, 0 }, { 0, 0, 0 }, { 2, 0, 0 } }, ZYDIS_SIZE_HINT_NONE, ZYAN_FALSE, ZYAN_FALSE },
        { { { 2, 0, 0 }, { 2, 0, 0 }, { 2, 0, 0 } }, ZYDIS_SIZE_HINT_ASZ, ZYAN_FALSE, ZYAN_FALSE },
        { { { 0, 4, 7 }, { 0, 5, 6 }, { 0, 5, 6 } }, ZYDIS_SIZE_HINT_OSZ, ZYAN_FALSE, ZYAN_FALSE },
    };

    switch (mnemonic)
    {
    case ZYDIS_MNEMONIC_CALL:
        return &info_lookup[0];
    case ZYDIS_MNEMONIC_JB:
    case ZYDIS_MNEMONIC_JBE:
    case ZYDIS_MNEMONIC_JL:
    case ZYDIS_MNEMONIC_JLE:
    case ZYDIS_MNEMONIC_JNB:
    case ZYDIS_MNEMONIC_JNBE:
    case ZYDIS_MNEMONIC_JNL:
    case ZYDIS_MNEMONIC_JNLE:
    case ZYDIS_MNEMONIC_JNO:
    case ZYDIS_MNEMONIC_JNP:
    case ZYDIS_MNEMONIC_JNS:
    case ZYDIS_MNEMONIC_JNZ:
    case ZYDIS_MNEMONIC_JO:
    case ZYDIS_MNEMONIC_JP:
    case ZYDIS_MNEMONIC_JS:
    case ZYDIS_MNEMONIC_JZ:
        return &info_lookup[1];
    case ZYDIS_MNEMONIC_JCXZ:
        return &info_lookup[2];
    case ZYDIS_MNEMONIC_JECXZ:
        return &info_lookup[3];
    case ZYDIS_MNEMONIC_JKNZD:
    case ZYDIS_MNEMONIC_JKZD:
        return &info_lookup[4];
    case ZYDIS_MNEMONIC_JMP:
        return &info_lookup[5];
    case ZYDIS_MNEMONIC_JRCXZ:
        return &info_lookup[6];
    case ZYDIS_MNEMONIC_LOOP:
    case ZYDIS_MNEMONIC_LOOPE:
    case ZYDIS_MNEMONIC_LOOPNE:
        return &info_lookup[7];
    case ZYDIS_MNEMONIC_XBEGIN:
        return &info_lookup[8];
    default:
        return ZYAN_NULL;
    }
}


ZyanU8 ZydisGetEncodableInstructions(ZydisMnemonic mnemonic,
    const ZydisEncodableInstruction **instruction)
{
    if (mnemonic <= ZYDIS_MNEMONIC_INVALID || mnemonic > ZYDIS_MNEMONIC_MAX_VALUE)
    {
        *instruction = ZYAN_NULL;
        return 0;
    }
    ZydisEncoderLookupEntry lookup_entry = encoder_instruction_lookup[mnemonic];
    *instruction = &encoder_instructions[lookup_entry.encoder_reference];
    return lookup_entry.instruction_count;
}

//
// Source file: /home/ath/devel/zydis/src/Formatter.c
//

/***************************************************************************************************

  Zyan Disassembler Library (Zydis)

  Original Author : Florian Bernd, Joel Hoener

 * Permission is hereby granted, free of charge, to any person obtaining a copy
 * of this software and associated documentation files (the "Software"), to deal
 * in the Software without restriction, including without limitation the rights
 * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
 * copies of the Software, and to permit persons to whom the Software is
 * furnished to do so, subject to the following conditions:
 *
 * The above copyright notice and this permission notice shall be included in all
 * copies or substantial portions of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
 * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
 * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
 * SOFTWARE.

***************************************************************************************************/


//
// Header: Zydis/Internal/FormatterATT.h
//

/***************************************************************************************************

  Zyan Disassembler Library (Zydis)

  Original Author : Florian Bernd, Joel Hoener

 * Permission is hereby granted, free of charge, to any person obtaining a copy
 * of this software and associated documentation files (the "Software"), to deal
 * in the Software without restriction, including without limitation the rights
 * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
 * copies of the Software, and to permit persons to whom the Software is
 * furnished to do so, subject to the following conditions:
 *
 * The above copyright notice and this permission notice shall be included in all
 * copies or substantial portions of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
 * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
 * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
 * SOFTWARE.

***************************************************************************************************/

/**
 * @file
 * Implements the `AT&T` style instruction-formatter.
 */

#ifndef ZYDIS_FORMATTER_ATT_H
#define ZYDIS_FORMATTER_ATT_H


//
// Header: Zydis/Internal/FormatterBase.h
//
// Include stack:
//   - Zydis/Internal/FormatterATT.h
//

/***************************************************************************************************

  Zyan Disassembler Library (Zydis)

  Original Author : Florian Bernd, Joel Hoener

 * Permission is hereby granted, free of charge, to any person obtaining a copy
 * of this software and associated documentation files (the "Software"), to deal
 * in the Software without restriction, including without limitation the rights
 * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
 * copies of the Software, and to permit persons to whom the Software is
 * furnished to do so, subject to the following conditions:
 *
 * The above copyright notice and this permission notice shall be included in all
 * copies or substantial portions of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
 * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
 * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
 * SOFTWARE.

***************************************************************************************************/

/**
 * @file
 * Provides formatter functions that are shared between the different formatters.
 */

#ifndef ZYDIS_FORMATTER_BASE_H
#define ZYDIS_FORMATTER_BASE_H


//
// Header: Zydis/Internal/String.h
//
// Include stack:
//   - Zydis/Internal/FormatterATT.h
//   - Zydis/Internal/FormatterBase.h
//

/***************************************************************************************************

  Zyan Disassembler Library (Zydis)

  Original Author : Florian Bernd, Joel Hoener

 * Permission is hereby granted, free of charge, to any person obtaining a copy
 * of this software and associated documentation files (the "Software"), to deal
 * in the Software without restriction, including without limitation the rights
 * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
 * copies of the Software, and to permit persons to whom the Software is
 * furnished to do so, subject to the following conditions:
 *
 * The above copyright notice and this permission notice shall be included in all
 * copies or substantial portions of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
 * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
 * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
 * SOFTWARE.

***************************************************************************************************/

/**
 * @file
 * Provides some internal, more performant, but unsafe helper functions for the `ZyanString`
 * data-type.
 *
 * Most of these functions are very similar to the ones in `Zycore/String.h`, but inlined and
 * without optional overhead like parameter-validation checks, etc ...
 *
 * The `ZyanString` data-type is able to dynamically allocate memory on the heap, but as `Zydis` is
 * designed to be a non-'malloc'ing library, all functions in this file assume that the instances
 * they are operating on are created with a user-defined static-buffer.
 */

#ifndef ZYDIS_INTERNAL_STRING_H
#define ZYDIS_INTERNAL_STRING_H


//
// Header: Zycore/Format.h
//
// Include stack:
//   - Zydis/Internal/FormatterATT.h
//   - Zydis/Internal/FormatterBase.h
//   - Zydis/Internal/String.h
//

/***************************************************************************************************

  Zyan Core Library (Zycore-C)

  Original Author : Florian Bernd

 * Permission is hereby granted, free of charge, to any person obtaining a copy
 * of this software and associated documentation files (the "Software"), to deal
 * in the Software without restriction, including without limitation the rights
 * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
 * copies of the Software, and to permit persons to whom the Software is
 * furnished to do so, subject to the following conditions:
 *
 * The above copyright notice and this permission notice shall be included in all
 * copies or substantial portions of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
 * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
 * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
 * SOFTWARE.

***************************************************************************************************/

/**
 * @file
 * Provides helper functions for performant number to string conversion.
 */

#ifndef ZYCORE_FORMAT_H
#define ZYCORE_FORMAT_H


#ifdef __cplusplus
extern "C" {
#endif

/* ============================================================================================== */
/* Exported functions                                                                             */
/* ============================================================================================== */

/* ---------------------------------------------------------------------------------------------- */
/* Helpers                                                                                        */
/* ---------------------------------------------------------------------------------------------- */

/**
 * Get the absolute value of a 64 bit int.
 *
 * @param x The value to process.
 * @return  The absolute, unsigned value.
 *
 * This gracefully deals with the special case of `x` being `INT_MAX`.
 */
ZYAN_INLINE ZyanU64 ZyanAbsI64(ZyanI64 x)
{
    // INT_MIN special case. Can't use the value directly because GCC thinks
    // it's too big for an INT64 literal, however is perfectly happy to accept
    // this expression. This is also hit INT64_MIN is defined in `stdint.h`.
    if (x == (-0x7fffffffffffffff - 1))
    {
        return 0x8000000000000000u;
    }

    return (ZyanU64)(x < 0 ? -x : x);
}

/* ---------------------------------------------------------------------------------------------- */
/* Insertion                                                                                      */
/* ---------------------------------------------------------------------------------------------- */

/**
 * Inserts formatted text in the destination string at the given `index`.
 *
 * @param   string  The destination string.
 * @param   index   The insert index.
 * @param   format  The format string.
 * @param   ...     The format arguments.
 *
 * @return  A zyan status code.
 *
 * This function will fail, if the `ZYAN_STRING_IS_IMMUTABLE` flag is set for the specified
 * `ZyanString` instance.
 */
ZYAN_PRINTF_ATTR(3, 4)
ZYCORE_EXPORT ZyanStatus ZyanStringInsertFormat(ZyanString* string, ZyanUSize index,
    const char* format, ...);

/* ---------------------------------------------------------------------------------------------- */

/**
 * Formats the given unsigned ordinal `value` to its decimal text-representation and
 * inserts it to the `string`.
 *
 * @param   string          A pointer to the `ZyanString` instance.
 * @param   index           The insert index.
 * @param   value           The value.
 * @param   padding_length  Padds the converted value with leading zeros, if the number of chars is
 *                          less than the `padding_length`.
 *
 * @return  A zyan status code.
 *
 * This function will fail, if the `ZYAN_STRING_IS_IMMUTABLE` flag is set for the specified
 * `ZyanString` instance.
 */
ZYCORE_EXPORT ZyanStatus ZyanStringInsertDecU(ZyanString* string, ZyanUSize index, ZyanU64 value,
    ZyanU8 padding_length);

/**
 * Formats the given signed ordinal `value` to its decimal text-representation and
 * inserts it to the `string`.
 *
 * @param   string          A pointer to the `ZyanString` instance.
 * @param   index           The insert index.
 * @param   value           The value.
 * @param   padding_length  Padds the converted value with leading zeros, if the number of chars is
 *                          less than the `padding_length`.
 * @param   force_sign      Set `ZYAN_TRUE`, to force printing of the `+` sign for positive numbers.
 * @param   prefix          The string to use as prefix or `ZYAN_NULL`, if not needed.
 *
 * @return  A zyan status code.
 *
 * This function will fail, if the `ZYAN_STRING_IS_IMMUTABLE` flag is set for the specified
 * `ZyanString` instance.
 */
ZYCORE_EXPORT ZyanStatus ZyanStringInsertDecS(ZyanString* string, ZyanUSize index, ZyanI64 value,
    ZyanU8 padding_length, ZyanBool force_sign, const ZyanString* prefix);

/**
 * Formats the given unsigned ordinal `value` to its hexadecimal text-representation and
 * inserts it to the `string`.
 *
 * @param   string          A pointer to the `ZyanString` instance.
 * @param   index           The insert index.
 * @param   value           The value.
 * @param   padding_length  Padds the converted value with leading zeros, if the number of chars is
 *                          less than the `padding_length`.
 * @param   uppercase       Set `ZYAN_TRUE` to use uppercase letters ('A'-'F') instead of lowercase
 *                          ones ('a'-'f').
 *
 * @return  A zyan status code.
 *
 * This function will fail, if the `ZYAN_STRING_IS_IMMUTABLE` flag is set for the specified
 * `ZyanString` instance.
 */
ZYCORE_EXPORT ZyanStatus ZyanStringInsertHexU(ZyanString* string, ZyanUSize index, ZyanU64 value,
    ZyanU8 padding_length, ZyanBool uppercase);

/**
 * Formats the given signed ordinal `value` to its hexadecimal text-representation and
 * inserts it to the `string`.
 *
 * @param   string          A pointer to the `ZyanString` instance.
 * @param   index           The insert index.
 * @param   value           The value.
 * @param   padding_length  Padds the converted value with leading zeros, if the number of chars is
 *                          less than the `padding_length`.
 * @param   uppercase       Set `ZYAN_TRUE` to use uppercase letters ('A'-'F') instead of lowercase
 *                          ones ('a'-'f').
 * @param   force_sign      Set `ZYAN_TRUE`, to force printing of the `+` sign for positive numbers.
 * @param   prefix          The string to use as prefix or `ZYAN_NULL`, if not needed.
 *
 * @return  A zyan status code.
 *
 * This function will fail, if the `ZYAN_STRING_IS_IMMUTABLE` flag is set for the specified
 * `ZyanString` instance.
 */
ZYCORE_EXPORT ZyanStatus ZyanStringInsertHexS(ZyanString* string, ZyanUSize index, ZyanI64 value,
    ZyanU8 padding_length, ZyanBool uppercase, ZyanBool force_sign, const ZyanString* prefix);

/* ---------------------------------------------------------------------------------------------- */
/* Appending                                                                                      */
/* ---------------------------------------------------------------------------------------------- */

#ifndef ZYAN_NO_LIBC

/**
 * Appends formatted text to the destination string.
 *
 * @param   string  The destination string.
 * @param   format  The format string.
 * @param   ...     The format arguments.
 *
 * @return  A zyan status code.
 *
 * This function will fail, if the `ZYAN_STRING_IS_IMMUTABLE` flag is set for the specified
 * `ZyanString` instance.
 */
ZYAN_PRINTF_ATTR(2, 3)
ZYCORE_EXPORT ZYAN_REQUIRES_LIBC ZyanStatus ZyanStringAppendFormat(
    ZyanString* string, const char* format, ...);

#endif // ZYAN_NO_LIBC

/* ---------------------------------------------------------------------------------------------- */

/**
 * Formats the given unsigned ordinal `value` to its decimal text-representation and
 * appends it to the `string`.
 *
 * @param   string          A pointer to the `ZyanString` instance.
 * @param   value           The value.
 * @param   padding_length  Padds the converted value with leading zeros, if the number of chars is
 *                          less than the `padding_length`.
 *
 * @return  A zyan status code.
 *
 * This function will fail, if the `ZYAN_STRING_IS_IMMUTABLE` flag is set for the specified
 * `ZyanString` instance.
 */
ZYCORE_EXPORT ZyanStatus ZyanStringAppendDecU(ZyanString* string, ZyanU64 value,
    ZyanU8 padding_length);

/**
 * Formats the given signed ordinal `value` to its decimal text-representation and
 * appends it to the `string`.
 *
 * @param   string          A pointer to the `ZyanString` instance.
 * @param   value           The value.
 * @param   padding_length  Padds the converted value with leading zeros, if the number of chars is
 *                          less than the `padding_length`.
 * @param   force_sign      Set `ZYAN_TRUE`, to force printing of the `+` sign for positive numbers.
 * @param   prefix          The string to use as prefix or `ZYAN_NULL`, if not needed.
 *
 * @return  A zyan status code.
 *
 * This function will fail, if the `ZYAN_STRING_IS_IMMUTABLE` flag is set for the specified
 * `ZyanString` instance.
 */
ZYCORE_EXPORT ZyanStatus ZyanStringAppendDecS(ZyanString* string, ZyanI64 value,
    ZyanU8 padding_length, ZyanBool force_sign, const ZyanStringView* prefix);

/**
 * Formats the given unsigned ordinal `value` to its hexadecimal text-representation and
 * appends it to the `string`.
 *
 * @param   string          A pointer to the `ZyanString` instance.
 * @param   value           The value.
 * @param   padding_length  Padds the converted value with leading zeros, if the number of chars is
 *                          less than the `padding_length`.
 * @param   uppercase       Set `ZYAN_TRUE` to use uppercase letters ('A'-'F') instead of lowercase
 *                          ones ('a'-'f').
 *
 * @return  A zyan status code.
 *
 * This function will fail, if the `ZYAN_STRING_IS_IMMUTABLE` flag is set for the specified
 * `ZyanString` instance.
 */
ZYCORE_EXPORT ZyanStatus ZyanStringAppendHexU(ZyanString* string, ZyanU64 value,
    ZyanU8 padding_length, ZyanBool uppercase);

/**
 * Formats the given signed ordinal `value` to its hexadecimal text-representation and
 * appends it to the `string`.
 *
 * @param   string          A pointer to the `ZyanString` instance.
 * @param   value           The value.
 * @param   padding_length  Padds the converted value with leading zeros, if the number of chars is
 *                          less than the `padding_length`.
 * @param   uppercase       Set `ZYAN_TRUE` to use uppercase letters ('A'-'F') instead of lowercase
 *                          ones ('a'-'f').
 * @param   force_sign      Set `ZYAN_TRUE`, to force printing of the `+` sign for positive numbers.
 * @param   prefix          The string to use as prefix or `ZYAN_NULL`, if not needed.
 *
 * @return  A zyan status code.
 *
 * This function will fail, if the `ZYAN_STRING_IS_IMMUTABLE` flag is set for the specified
 * `ZyanString` instance.
 */
ZYCORE_EXPORT ZyanStatus ZyanStringAppendHexS(ZyanString* string, ZyanI64 value,
    ZyanU8 padding_length, ZyanBool uppercase, ZyanBool force_sign, const ZyanStringView* prefix);

/* ---------------------------------------------------------------------------------------------- */

/* ============================================================================================== */

#ifdef __cplusplus
}
#endif

#endif // ZYCORE_FORMAT_H

#ifdef __cplusplus
extern "C" {
#endif

/* ============================================================================================== */
/* Enums and types                                                                                */
/* ============================================================================================== */

/* ---------------------------------------------------------------------------------------------- */
/* Letter Case                                                                                    */
/* ---------------------------------------------------------------------------------------------- */

/**
 * Defines the `ZydisLetterCase` enum.
 */
typedef enum ZydisLetterCase_
{
    /**
     * Uses the given text "as is".
     */
    ZYDIS_LETTER_CASE_DEFAULT,
    /**
     * Converts the given text to lowercase letters.
     */
    ZYDIS_LETTER_CASE_LOWER,
    /**
     * Converts the given text to uppercase letters.
     */
    ZYDIS_LETTER_CASE_UPPER,

    /**
     * Maximum value of this enum.
     */
    ZYDIS_LETTER_CASE_MAX_VALUE = ZYDIS_LETTER_CASE_UPPER,
    /**
     * The minimum number of bits required to represent all values of this enum.
     */
    ZYDIS_LETTER_CASE_REQUIRED_BITS = ZYAN_BITS_TO_REPRESENT(ZYDIS_LETTER_CASE_MAX_VALUE)
} ZydisLetterCase;

/* ---------------------------------------------------------------------------------------------- */

/* ============================================================================================== */
/* Macros                                                                                         */
/* ============================================================================================== */

/* ---------------------------------------------------------------------------------------------- */
/* Internal macros                                                                                */
/* ---------------------------------------------------------------------------------------------- */

/**
 * Checks for a terminating '\0' character at the end of the string data.
 */
#define ZYDIS_STRING_ASSERT_NULLTERMINATION(string) \
      ZYAN_ASSERT(*(char*)((ZyanU8*)(string)->vector.data + (string)->vector.size - 1) == '\0');

/**
 * Writes a terminating '\0' character at the end of the string data.
 */
#define ZYDIS_STRING_NULLTERMINATE(string) \
      *(char*)((ZyanU8*)(string)->vector.data + (string)->vector.size - 1) = '\0';

/* ---------------------------------------------------------------------------------------------- */

/* ============================================================================================== */
/* Internal Functions                                                                             */
/* ============================================================================================== */

/* ---------------------------------------------------------------------------------------------- */
/* Appending                                                                                      */
/* ---------------------------------------------------------------------------------------------- */

/**
 * Appends the content of the source string to the end of the destination string.
 *
 * @param   destination The destination string.
 * @param   source      The source string.
 *
 * @return  A zyan status code.
 */
ZYAN_INLINE ZyanStatus ZydisStringAppend(ZyanString* destination, const ZyanStringView* source)
{
    ZYAN_ASSERT(destination && source);
    ZYAN_ASSERT(!destination->vector.allocator);
    ZYAN_ASSERT(destination->vector.size && source->string.vector.size);

    if (destination->vector.size + source->string.vector.size - 1 > destination->vector.capacity)
    {
        return ZYAN_STATUS_INSUFFICIENT_BUFFER_SIZE;
    }

    ZYAN_MEMCPY((char*)destination->vector.data + destination->vector.size - 1,
        source->string.vector.data, source->string.vector.size - 1);

    destination->vector.size += source->string.vector.size - 1;
    ZYDIS_STRING_NULLTERMINATE(destination);

    return ZYAN_STATUS_SUCCESS;
}

/**
 * Appends the content of the source string to the end of the destination
 * string, converting the characters to the specified letter-case.
 *
 * @param   destination The destination string.
 * @param   source      The source string.
 * @param   letter_case The desired letter-case.
 *
 * @return  A zyan status code.
 */
ZYAN_INLINE ZyanStatus ZydisStringAppendCase(ZyanString* destination, const ZyanStringView* source,
    ZydisLetterCase letter_case)
{
    ZYAN_ASSERT(destination && source);
    ZYAN_ASSERT(!destination->vector.allocator);
    ZYAN_ASSERT(destination->vector.size && source->string.vector.size);

    if (destination->vector.size + source->string.vector.size - 1 > destination->vector.capacity)
    {
        return ZYAN_STATUS_INSUFFICIENT_BUFFER_SIZE;
    }

    ZYAN_MEMCPY((char*)destination->vector.data + destination->vector.size - 1,
        source->string.vector.data, source->string.vector.size - 1);

    switch (letter_case)
    {
    case ZYDIS_LETTER_CASE_DEFAULT:
        break;
    case ZYDIS_LETTER_CASE_LOWER:
    {
        const ZyanUSize index = destination->vector.size - 1;
        const ZyanUSize count = source->string.vector.size - 1;
        char* s = (char*)destination->vector.data + index;
        for (ZyanUSize i = index; i < index + count; ++i)
        {
            const char c = *s;
            if ((c >= 'A') && (c <= 'Z'))
            {
                *s = c | 32;
            }
            ++s;
        }
        break;
    }
    case ZYDIS_LETTER_CASE_UPPER:
    {
        const ZyanUSize index = destination->vector.size - 1;
        const ZyanUSize count = source->string.vector.size - 1;
        char* s = (char*)destination->vector.data + index;
        for (ZyanUSize i = index; i < index + count; ++i)
        {
            const char c = *s;
            if ((c >= 'a') && (c <= 'z'))
            {
                *s = c & ~32;
            }
            ++s;
        }
        break;
    }
    default:
        ZYAN_UNREACHABLE;
    }

    destination->vector.size += source->string.vector.size - 1;
    ZYDIS_STRING_NULLTERMINATE(destination);

    return ZYAN_STATUS_SUCCESS;
}

/**
 * Appends the content of the source short-string to the end of the destination string.
 *
 * @param   destination The destination string.
 * @param   source      The source string.
 *
 * @return  A zyan status code.
 */
ZYAN_INLINE ZyanStatus ZydisStringAppendShort(ZyanString* destination,
    const ZydisShortString* source)
{
    ZYAN_ASSERT(destination && source);
    ZYAN_ASSERT(!destination->vector.allocator);
    ZYAN_ASSERT(destination->vector.size && source->size);

    if (destination->vector.size + source->size > destination->vector.capacity)
    {
        return ZYAN_STATUS_INSUFFICIENT_BUFFER_SIZE;
    }

    ZYAN_MEMCPY((char*)destination->vector.data + destination->vector.size - 1, source->data,
        (ZyanUSize)source->size + 1);

    destination->vector.size += source->size;
    ZYDIS_STRING_ASSERT_NULLTERMINATION(destination);

    return ZYAN_STATUS_SUCCESS;
}

/**
 * Appends the content of the source short-string to the end of the destination string,
 * converting the characters to the specified letter-case.
 *
 * @param   destination The destination string.
 * @param   source      The source string.
 * @param   letter_case The desired letter-case.
 *
 * @return  A zyan status code.
 */
ZYAN_INLINE ZyanStatus ZydisStringAppendShortCase(ZyanString* destination,
    const ZydisShortString* source, ZydisLetterCase letter_case)
{
    ZYAN_ASSERT(destination && source);
    ZYAN_ASSERT(!destination->vector.allocator);
    ZYAN_ASSERT(destination->vector.size && source->size);

    if (destination->vector.size + source->size > destination->vector.capacity)
    {
        return ZYAN_STATUS_INSUFFICIENT_BUFFER_SIZE;
    }

    ZYAN_MEMCPY((char*)destination->vector.data + destination->vector.size - 1, source->data,
        (ZyanUSize)source->size + 1);

    switch (letter_case)
    {
    case ZYDIS_LETTER_CASE_DEFAULT:
        break;
    case ZYDIS_LETTER_CASE_LOWER:
    {
        const ZyanUSize index = destination->vector.size - 1;
        const ZyanUSize count = source->size;
        char* s = (char*)destination->vector.data + index;
        for (ZyanUSize i = index; i < index + count; ++i)
        {
            const char c = *s;
            if ((c >= 'A') && (c <= 'Z'))
            {
                *s = c | 32;
            }
            ++s;
        }
        break;
    }
    case ZYDIS_LETTER_CASE_UPPER:
    {
        const ZyanUSize index = destination->vector.size - 1;
        const ZyanUSize count = source->size;
        char* s = (char*)destination->vector.data + index;
        for (ZyanUSize i = index; i < index + count; ++i)
        {
            const char c = *s;
            if ((c >= 'a') && (c <= 'z'))
            {
                *s = c & ~32;
            }
            ++s;
        }
        break;
    }
    default:
        ZYAN_UNREACHABLE;
    }

    destination->vector.size += source->size;
    ZYDIS_STRING_ASSERT_NULLTERMINATION(destination);

    return ZYAN_STATUS_SUCCESS;
}

/* ---------------------------------------------------------------------------------------------- */
/* Formatting                                                                                     */
/* ---------------------------------------------------------------------------------------------- */

/**
 * Formats the given unsigned ordinal `value` to its decimal text-representation and
 * appends it to the `string`.
 *
 * @param   string          A pointer to the `ZyanString` instance.
 * @param   value           The value to append.
 * @param   padding_length  Padds the converted value with leading zeros, if the number of chars is
 *                          less than the `padding_length`.
 * @param   prefix          The string to use as prefix or `ZYAN_NULL`, if not needed.
 * @param   suffix          The string to use as suffix or `ZYAN_NULL`, if not needed.
 *
 * @return  A zyan status code.
 *
 * This function will fail, if the `ZYAN_STRING_IS_IMMUTABLE` flag is set for the specified
 * `ZyanString` instance.
 */
ZyanStatus ZydisStringAppendDecU(ZyanString* string, ZyanU64 value, ZyanU8 padding_length,
    const ZyanStringView* prefix, const ZyanStringView* suffix);

/**
 * Formats the given signed ordinal `value` to its decimal text-representation and
 * appends it to the `string`.
 *
 * @param   string          A pointer to the `ZyanString` instance.
 * @param   value           The value to append.
 * @param   padding_length  Padds the converted value with leading zeros, if the number of chars is
 *                          less than the `padding_length`.
 * @param   force_sign      Enable this option to print the `+` sign for positive numbers.
 * @param   prefix          The string to use as prefix or `ZYAN_NULL`, if not needed.
 * @param   suffix          The string to use as suffix or `ZYAN_NULL`, if not needed.
 *
 * @return  A zyan status code.
 *
 * This function will fail, if the `ZYAN_STRING_IS_IMMUTABLE` flag is set for the specified
 * `ZyanString` instance.
 */
ZYAN_INLINE ZyanStatus ZydisStringAppendDecS(ZyanString* string, ZyanI64 value,
    ZyanU8 padding_length, ZyanBool force_sign, const ZyanStringView* prefix,
    const ZyanStringView* suffix)
{
    static const ZydisShortString str_add = ZYDIS_MAKE_SHORTSTRING("+");
    static const ZydisShortString str_sub = ZYDIS_MAKE_SHORTSTRING("-");

    if (value < 0)
    {
        ZYAN_CHECK(ZydisStringAppendShort(string, &str_sub));
        if (prefix)
        {
            ZYAN_CHECK(ZydisStringAppend(string, prefix));
        }
        return ZydisStringAppendDecU(string, ZyanAbsI64(value), padding_length,
            (const ZyanStringView*)ZYAN_NULL, suffix);
    }

    if (force_sign)
    {
        ZYAN_ASSERT(value >= 0);
        ZYAN_CHECK(ZydisStringAppendShort(string, &str_add));
    }
    return ZydisStringAppendDecU(string, value, padding_length, prefix, suffix);
}

/**
 * Formats the given unsigned ordinal `value` to its hexadecimal text-representation and
 * appends it to the `string`.
 *
 * @param   string                  A pointer to the `ZyanString` instance.
 * @param   value                   The value to append.
 * @param   padding_length          Pads the converted value with leading zeros if the number of
 *                                  chars is less than the `padding_length`.
 * @param   force_leading_number    Enable this option to prepend a leading `0` if the first
 *                                  character is non-numeric.
 * @param   uppercase               Enable this option to use uppercase letters ('A'-'F') instead
 *                                  of lowercase ones ('a'-'f').
 * @param   prefix                  The string to use as prefix or `ZYAN_NULL`, if not needed.
 * @param   suffix                  The string to use as suffix or `ZYAN_NULL`, if not needed.
 *
 * @return  A zyan status code.
 *
 * This function will fail, if the `ZYAN_STRING_IS_IMMUTABLE` flag is set for the specified
 * `ZyanString` instance.
 */
ZyanStatus ZydisStringAppendHexU(ZyanString* string, ZyanU64 value, ZyanU8 padding_length,
    ZyanBool force_leading_number, ZyanBool uppercase, const ZyanStringView* prefix,
    const ZyanStringView* suffix);

/**
 * Formats the given signed ordinal `value` to its hexadecimal text-representation and
 * appends it to the `string`.
 *
 * @param   string                  A pointer to the `ZyanString` instance.
 * @param   value                   The value to append.
 * @param   padding_length          Padds the converted value with leading zeros, if the number of
 *                                  chars is less than the `padding_length` (the sign char does not
 *                                  count).
 * @param   force_leading_number    Enable this option to prepend a leading `0`, if the first
 *                                  character is non-numeric.
 * @param   uppercase               Enable this option to use uppercase letters ('A'-'F') instead
 *                                  of lowercase ones ('a'-'f').
 * @param   force_sign              Enable this option to print the `+` sign for positive numbers.
 * @param   prefix                  The string to use as prefix or `ZYAN_NULL`, if not needed.
 * @param   suffix                  The string to use as suffix or `ZYAN_NULL`, if not needed.
 *
 * @return  A zyan status code.
 *
 * This function will fail if the `ZYAN_STRING_IS_IMMUTABLE` flag is set for the specified
 * `ZyanString` instance.
 */
ZYAN_INLINE ZyanStatus ZydisStringAppendHexS(ZyanString* string, ZyanI64 value,
    ZyanU8 padding_length, ZyanBool force_leading_number, ZyanBool uppercase, ZyanBool force_sign,
    const ZyanStringView* prefix, const ZyanStringView* suffix)
{
    static const ZydisShortString str_add = ZYDIS_MAKE_SHORTSTRING("+");
    static const ZydisShortString str_sub = ZYDIS_MAKE_SHORTSTRING("-");

    if (value < 0)
    {
        ZYAN_CHECK(ZydisStringAppendShort(string, &str_sub));
        if (prefix)
        {
            ZYAN_CHECK(ZydisStringAppend(string, prefix));
        }
        return ZydisStringAppendHexU(string, ZyanAbsI64(value), padding_length,
            force_leading_number, uppercase, (const ZyanStringView*)ZYAN_NULL, suffix);
    }

    if (force_sign)
    {
        ZYAN_ASSERT(value >= 0);
        ZYAN_CHECK(ZydisStringAppendShort(string, &str_add));
    }
    return ZydisStringAppendHexU(string, value, padding_length, force_leading_number, uppercase,
        prefix, suffix);
}

/* ---------------------------------------------------------------------------------------------- */

/* ============================================================================================== */

#ifdef __cplusplus
}
#endif

#endif // ZYDIS_INTERNAL_STRING_H

#ifdef __cplusplus
extern "C" {
#endif

/* ============================================================================================== */
/* Macros                                                                                         */
/* ============================================================================================== */

/* ---------------------------------------------------------------------------------------------- */
/* String                                                                                         */
/* ---------------------------------------------------------------------------------------------- */

/**
 * Appends an unsigned numeric value to the given string.
 *
 * @param   formatter               A pointer to the `ZydisFormatter` instance.
 * @param   base                    The numeric base.
 * @param   str                     The destination string.
 * @param   value                   The value to append.
 * @param   padding_length          The padding length.
 * @param   force_leading_number    Enable this option to prepend a leading `0` if the first
 *                                  character is non-numeric.
 */
#define ZYDIS_STRING_APPEND_NUM_U(formatter, base, str, value, padding_length, \
    force_leading_number) \
    switch (base) \
    { \
    case ZYDIS_NUMERIC_BASE_DEC: \
        ZYAN_CHECK(ZydisStringAppendDecU(str, value, padding_length, \
            (formatter)->number_format[base][0].string, \
            (formatter)->number_format[base][1].string)); \
        break; \
    case ZYDIS_NUMERIC_BASE_HEX: \
        ZYAN_CHECK(ZydisStringAppendHexU(str, value, padding_length, force_leading_number, \
            (formatter)->hex_uppercase, \
            (formatter)->number_format[base][0].string, \
            (formatter)->number_format[base][1].string)); \
        break; \
    default: \
        return ZYAN_STATUS_INVALID_ARGUMENT; \
    }

/**
 * Appends a signed numeric value to the given string.
 *
 * @param   formatter               A pointer to the `ZydisFormatter` instance.
 * @param   base                    The numeric base.
 * @param   str                     The destination string.
 * @param   value                   The value to append.
 * @param   padding_length          The padding length.
 * @param   force_leading_number    Enable this option to prepend a leading `0`, if the first
 *                                  character is non-numeric.
 * @param   force_sign              Enable to print the '+' sign for positive numbers.
 */
#define ZYDIS_STRING_APPEND_NUM_S(formatter, base, str, value, padding_length, \
    force_leading_number, force_sign) \
    switch (base) \
    { \
    case ZYDIS_NUMERIC_BASE_DEC: \
        ZYAN_CHECK(ZydisStringAppendDecS(str, value, padding_length, force_sign, \
            (formatter)->number_format[base][0].string, \
            (formatter)->number_format[base][1].string)); \
        break; \
    case ZYDIS_NUMERIC_BASE_HEX: \
        ZYAN_CHECK(ZydisStringAppendHexS(str, value, padding_length, force_leading_number,  \
            (formatter)->hex_uppercase, force_sign, \
            (formatter)->number_format[base][0].string, \
            (formatter)->number_format[base][1].string)); \
        break; \
    default: \
        return ZYAN_STATUS_INVALID_ARGUMENT; \
    }

/* ---------------------------------------------------------------------------------------------- */
/* Buffer                                                                                         */
/* ---------------------------------------------------------------------------------------------- */

/**
 * Invokes the `ZydisFormatterBufferAppend` routine, if tokenization is enabled for the
 * current pass.
 *
 * @param   buffer  A pointer to the `ZydisFormatterBuffer` struct.
 * @param   type    The token type.
 *
 * Using this macro instead of direct calls to `ZydisFormatterBufferAppend` greatly improves the
 * performance for non-tokenizing passes.
 */
#define ZYDIS_BUFFER_APPEND_TOKEN(buffer, type) \
    if ((buffer)->is_token_list) \
    { \
        ZYAN_CHECK(ZydisFormatterBufferAppend(buffer, type)); \
    }

/**
 * Returns a snapshot of the buffer-state.
 *
 * @param   buffer  A pointer to the `ZydisFormatterBuffer` struct.
 * @param   state   Receives a snapshot of the buffer-state.
 *
 * Using this macro instead of direct calls to `ZydisFormatterBufferRemember` improves the
 * performance for non-tokenizing passes.
 */
#define ZYDIS_BUFFER_REMEMBER(buffer, state) \
    if ((buffer)->is_token_list) \
    { \
        (state) = (ZyanUPointer)(buffer)->string.vector.data; \
    } else \
    { \
        (state) = (ZyanUPointer)(buffer)->string.vector.size; \
    }

/**
 * Appends a string (`STR_`-prefix) or a predefined token-list (`TOK_`-prefix).
 *
 * @param   buffer  A pointer to the `ZydisFormatterBuffer` struct.
 * @param   name    The base name (without prefix) of the string- or token.
 */
#define ZYDIS_BUFFER_APPEND(buffer, name) \
    if ((buffer)->is_token_list) \
    { \
        ZYAN_CHECK(ZydisFormatterBufferAppendPredefined(buffer, TOK_ ## name)); \
    } else \
    { \
        ZYAN_CHECK(ZydisStringAppendShort(&buffer->string, &STR_ ## name)); \
    }

// TODO: Implement `letter_case` for predefined tokens

/**
 * Appends a string (`STR_`-prefix) or a predefined token-list (`TOK_`-prefix).
 *
 * @param   buffer      A pointer to the `ZydisFormatterBuffer` struct.
 * @param   name        The base name (without prefix) of the string- or token.
 * @param   letter_case The desired letter-case.
 */
#define ZYDIS_BUFFER_APPEND_CASE(buffer, name, letter_case) \
    if ((buffer)->is_token_list) \
    { \
        ZYAN_CHECK(ZydisFormatterBufferAppendPredefined(buffer, TOK_ ## name)); \
    } else \
    { \
        ZYAN_CHECK(ZydisStringAppendShortCase(&buffer->string, &STR_ ## name, letter_case)); \
    }

/* ---------------------------------------------------------------------------------------------- */

/* ============================================================================================== */
/* Helper functions                                                                               */
/* ============================================================================================== */

/* ---------------------------------------------------------------------------------------------- */
/* Buffer                                                                                         */
/* ---------------------------------------------------------------------------------------------- */

// MSVC does not like the C99 flexible-array extension
#ifdef ZYAN_MSVC
#   pragma warning(push)
#   pragma warning(disable:4200)
#endif

#pragma pack(push, 1)

typedef struct ZydisPredefinedToken_
{
    ZyanU8 size;
    ZyanU8 next;
    ZyanU8 data[];
} ZydisPredefinedToken;

#pragma pack(pop)

#ifdef ZYAN_MSVC
#   pragma warning(pop)
#endif

/**
 * Appends a predefined token-list to the `buffer`.
 *
 * @param   buffer  A pointer to the `ZydisFormatterBuffer` struct.
 * @param   data    A pointer to the `ZydisPredefinedToken` struct.
 *
 * @return  A zycore status code.
 *
 * This function is internally used to improve performance while adding static strings or multiple
 * tokens at once.
 */
ZYAN_INLINE ZyanStatus ZydisFormatterBufferAppendPredefined(ZydisFormatterBuffer* buffer,
    const ZydisPredefinedToken* data)
{
    ZYAN_ASSERT(buffer);
    ZYAN_ASSERT(data);

    const ZyanUSize len = buffer->string.vector.size;
    ZYAN_ASSERT((len > 0) && (len < 256));
    if (buffer->capacity <= len + data->size)
    {
        return ZYAN_STATUS_INSUFFICIENT_BUFFER_SIZE;
    }

    ZydisFormatterToken* const last = (ZydisFormatterToken*)buffer->string.vector.data - 1;
    last->next = (ZyanU8)len;

    ZYAN_MEMCPY((ZyanU8*)buffer->string.vector.data + len, &data->data[0], data->size);

    const ZyanUSize delta = len + data->next;
    buffer->capacity -= delta;
    buffer->string.vector.data = (ZyanU8*)buffer->string.vector.data + delta;
    buffer->string.vector.size = data->size - data->next;
    buffer->string.vector.capacity = ZYAN_MIN(buffer->capacity, 255);

    return ZYAN_STATUS_SUCCESS;
}

/* ---------------------------------------------------------------------------------------------- */
/* General                                                                                        */
/* ---------------------------------------------------------------------------------------------- */

/**
 * Returns the size to be used as explicit size suffix (`AT&T`) or explicit typecast
 * (`INTEL`), if required.
 *
 * @param   formatter   A pointer to the `ZydisFormatter` instance.
 * @param   context     A pointer to the `ZydisFormatterContext` struct.
 * @param   operand     The instructions first memory operand.
 *
 * @return  Returns the explicit size, if required, or `0`, if not needed.
 *
 * This function always returns a size different to `0`, if the `ZYDIS_FORMATTER_PROP_FORCE_SIZE`
 * is set to `ZYAN_TRUE`.
 */
ZyanU32 ZydisFormatterHelperGetExplicitSize(const ZydisFormatter* formatter,
    ZydisFormatterContext* context, const ZydisDecodedOperand* operand);

/* ---------------------------------------------------------------------------------------------- */

/* ============================================================================================== */
/* Formatter functions                                                                            */
/* ============================================================================================== */

/* ---------------------------------------------------------------------------------------------- */
/* Operands                                                                                       */
/* ---------------------------------------------------------------------------------------------- */

ZyanStatus ZydisFormatterBaseFormatOperandREG(const ZydisFormatter* formatter,
    ZydisFormatterBuffer* buffer, ZydisFormatterContext* context);

ZyanStatus ZydisFormatterBaseFormatOperandPTR(const ZydisFormatter* formatter,
    ZydisFormatterBuffer* buffer, ZydisFormatterContext* context);

ZyanStatus ZydisFormatterBaseFormatOperandIMM(const ZydisFormatter* formatter,
    ZydisFormatterBuffer* buffer, ZydisFormatterContext* context);

/* ---------------------------------------------------------------------------------------------- */
/* Elemental tokens                                                                               */
/* ---------------------------------------------------------------------------------------------- */

ZyanStatus ZydisFormatterBasePrintAddressABS(const ZydisFormatter* formatter,
    ZydisFormatterBuffer* buffer, ZydisFormatterContext* context);

ZyanStatus ZydisFormatterBasePrintAddressREL(const ZydisFormatter* formatter,
    ZydisFormatterBuffer* buffer, ZydisFormatterContext* context);

ZyanStatus ZydisFormatterBasePrintIMM(const ZydisFormatter* formatter,
    ZydisFormatterBuffer* buffer, ZydisFormatterContext* context);

/* ---------------------------------------------------------------------------------------------- */
/* Optional tokens                                                                                */
/* ---------------------------------------------------------------------------------------------- */

ZyanStatus ZydisFormatterBasePrintSegment(const ZydisFormatter* formatter,
    ZydisFormatterBuffer* buffer, ZydisFormatterContext* context);

ZyanStatus ZydisFormatterBasePrintPrefixes(const ZydisFormatter* formatter,
    ZydisFormatterBuffer* buffer, ZydisFormatterContext* context);

ZyanStatus ZydisFormatterBasePrintDecorator(const ZydisFormatter* formatter,
    ZydisFormatterBuffer* buffer, ZydisFormatterContext* context, ZydisDecorator decorator);

/* ---------------------------------------------------------------------------------------------- */

/* ============================================================================================== */

#ifdef __cplusplus
}
#endif

#endif // ZYDIS_FORMATTER_BASE_H

#ifdef __cplusplus
extern "C" {
#endif

/* ============================================================================================== */
/* Formatter functions                                                                            */
/* ============================================================================================== */

/* ---------------------------------------------------------------------------------------------- */
/* Instruction                                                                                    */
/* ---------------------------------------------------------------------------------------------- */

ZyanStatus ZydisFormatterATTFormatInstruction(const ZydisFormatter* formatter,
    ZydisFormatterBuffer* buffer, ZydisFormatterContext* context);

/* ---------------------------------------------------------------------------------------------- */
/* Operands                                                                                       */
/* ---------------------------------------------------------------------------------------------- */

ZyanStatus ZydisFormatterATTFormatOperandMEM(const ZydisFormatter* formatter,
    ZydisFormatterBuffer* buffer, ZydisFormatterContext* context);

/* ---------------------------------------------------------------------------------------------- */
/* Elemental tokens                                                                               */
/* ---------------------------------------------------------------------------------------------- */

ZyanStatus ZydisFormatterATTPrintMnemonic(const ZydisFormatter* formatter,
    ZydisFormatterBuffer* buffer, ZydisFormatterContext* context);

ZyanStatus ZydisFormatterATTPrintRegister(const ZydisFormatter* formatter,
    ZydisFormatterBuffer* buffer, ZydisFormatterContext* context, ZydisRegister reg);

ZyanStatus ZydisFormatterATTPrintAddressABS(const ZydisFormatter* formatter,
    ZydisFormatterBuffer* buffer, ZydisFormatterContext* context);

ZyanStatus ZydisFormatterATTPrintDISP(const ZydisFormatter* formatter,
    ZydisFormatterBuffer* buffer, ZydisFormatterContext* context);

ZyanStatus ZydisFormatterATTPrintIMM(const ZydisFormatter* formatter,
    ZydisFormatterBuffer* buffer, ZydisFormatterContext* context);

/* ---------------------------------------------------------------------------------------------- */

/* ============================================================================================== */
/* Fomatter presets                                                                               */
/* ============================================================================================== */

/* ---------------------------------------------------------------------------------------------- */
/* AT&T                                                                                           */
/* ---------------------------------------------------------------------------------------------- */

/**
 * The default formatter configuration for `AT&T` style disassembly.
 */
static const ZydisFormatter FORMATTER_ATT =
{
    /* style                    */ ZYDIS_FORMATTER_STYLE_ATT,
    /* force_memory_size        */ ZYAN_FALSE,
    /* force_memory_seg         */ ZYAN_FALSE,
    /* force_memory_scale       */ ZYAN_TRUE,
    /* force_relative_branches  */ ZYAN_FALSE,
    /* force_relative_riprel    */ ZYAN_FALSE,
    /* print_branch_size        */ ZYAN_FALSE,
    /* detailed_prefixes        */ ZYAN_FALSE,
    /* addr_base                */ ZYDIS_NUMERIC_BASE_HEX,
    /* addr_signedness          */ ZYDIS_SIGNEDNESS_SIGNED,
    /* addr_padding_absolute    */ ZYDIS_PADDING_AUTO,
    /* addr_padding_relative    */ 2,
    /* disp_base                */ ZYDIS_NUMERIC_BASE_HEX,
    /* disp_signedness          */ ZYDIS_SIGNEDNESS_SIGNED,
    /* disp_padding             */ 2,
    /* imm_base                 */ ZYDIS_NUMERIC_BASE_HEX,
    /* imm_signedness           */ ZYDIS_SIGNEDNESS_AUTO,
    /* imm_padding              */ 2,
    /* case_prefixes            */ ZYDIS_LETTER_CASE_DEFAULT,
    /* case_mnemonic            */ ZYDIS_LETTER_CASE_DEFAULT,
    /* case_registers           */ ZYDIS_LETTER_CASE_DEFAULT,
    /* case_typecasts           */ ZYDIS_LETTER_CASE_DEFAULT,
    /* case_decorators          */ ZYDIS_LETTER_CASE_DEFAULT,
    /* hex_uppercase            */ ZYAN_TRUE,
    /* hex_force_leading_number */ ZYAN_FALSE,
    /* number_format            */
    {
        // ZYDIS_NUMERIC_BASE_DEC
        {
            // Prefix
            {
                /* string       */ ZYAN_NULL,
                /* string_data  */ ZYAN_DEFINE_STRING_VIEW(""),
                /* buffer       */ { 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0 },
            },
            // Suffix
            {
                /* string       */ ZYAN_NULL,
                /* string_data  */ ZYAN_DEFINE_STRING_VIEW(""),
                /* buffer       */ { 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0 },
            }
        },
        // ZYDIS_NUMERIC_BASE_HEX
        {
            // Prefix
            {
                /* string       */ &FORMATTER_ATT.number_format[
                                     ZYDIS_NUMERIC_BASE_HEX][0].string_data,
                /* string_data  */ ZYAN_DEFINE_STRING_VIEW("0x"),
                /* buffer       */ { 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0 },
            },
            // Suffix
            {
                /* string       */ ZYAN_NULL,
                /* string_data  */ ZYAN_DEFINE_STRING_VIEW(""),
                /* buffer       */ { 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0 },
            }
        }
    },
    /* func_pre_instruction     */ ZYAN_NULL,
    /* func_post_instruction    */ ZYAN_NULL,
    /* func_format_instruction  */ &ZydisFormatterATTFormatInstruction,
    /* func_pre_operand         */ ZYAN_NULL,
    /* func_post_operand        */ ZYAN_NULL,
    /* func_format_operand_reg  */ &ZydisFormatterBaseFormatOperandREG,
    /* func_format_operand_mem  */ &ZydisFormatterATTFormatOperandMEM,
    /* func_format_operand_ptr  */ &ZydisFormatterBaseFormatOperandPTR,
    /* func_format_operand_imm  */ &ZydisFormatterBaseFormatOperandIMM,
    /* func_print_mnemonic      */ &ZydisFormatterATTPrintMnemonic,
    /* func_print_register      */ &ZydisFormatterATTPrintRegister,
    /* func_print_address_abs   */ &ZydisFormatterATTPrintAddressABS,
    /* func_print_address_rel   */ &ZydisFormatterBasePrintAddressREL,
    /* func_print_disp          */ &ZydisFormatterATTPrintDISP,
    /* func_print_imm           */ &ZydisFormatterATTPrintIMM,
    /* func_print_typecast      */ ZYAN_NULL,
    /* func_print_segment       */ &ZydisFormatterBasePrintSegment,
    /* func_print_prefixes      */ &ZydisFormatterBasePrintPrefixes,
    /* func_print_decorator     */ &ZydisFormatterBasePrintDecorator
};

/* ---------------------------------------------------------------------------------------------- */

/* ============================================================================================== */

#ifdef __cplusplus
}
#endif

#endif // ZYDIS_FORMATTER_ATT_H

//
// Header: Zydis/Internal/FormatterIntel.h
//

/***************************************************************************************************

  Zyan Disassembler Library (Zydis)

  Original Author : Florian Bernd, Joel Hoener

 * Permission is hereby granted, free of charge, to any person obtaining a copy
 * of this software and associated documentation files (the "Software"), to deal
 * in the Software without restriction, including without limitation the rights
 * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
 * copies of the Software, and to permit persons to whom the Software is
 * furnished to do so, subject to the following conditions:
 *
 * The above copyright notice and this permission notice shall be included in all
 * copies or substantial portions of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
 * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
 * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
 * SOFTWARE.

***************************************************************************************************/

/**
 * @file
 * Implements the `INTEL` style instruction-formatter.
 */

#ifndef ZYDIS_FORMATTER_INTEL_H
#define ZYDIS_FORMATTER_INTEL_H


#ifdef __cplusplus
extern "C" {
#endif

/* ============================================================================================== */
/* Formatter functions                                                                            */
/* ============================================================================================== */

/* ---------------------------------------------------------------------------------------------- */
/* Intel                                                                                          */
/* ---------------------------------------------------------------------------------------------- */

ZyanStatus ZydisFormatterIntelFormatInstruction(const ZydisFormatter* formatter,
    ZydisFormatterBuffer* buffer, ZydisFormatterContext* context);

ZyanStatus ZydisFormatterIntelFormatOperandMEM(const ZydisFormatter* formatter,
    ZydisFormatterBuffer* buffer, ZydisFormatterContext* context);

ZyanStatus ZydisFormatterIntelPrintMnemonic(const ZydisFormatter* formatter,
    ZydisFormatterBuffer* buffer, ZydisFormatterContext* context);

ZyanStatus ZydisFormatterIntelPrintRegister(const ZydisFormatter* formatter,
    ZydisFormatterBuffer* buffer, ZydisFormatterContext* context, ZydisRegister reg);

ZyanStatus ZydisFormatterIntelPrintDISP(const ZydisFormatter* formatter,
    ZydisFormatterBuffer* buffer, ZydisFormatterContext* context);

ZyanStatus ZydisFormatterIntelPrintTypecast(const ZydisFormatter* formatter,
    ZydisFormatterBuffer* buffer, ZydisFormatterContext* context);

/* ---------------------------------------------------------------------------------------------- */
/* MASM                                                                                           */
/* ---------------------------------------------------------------------------------------------- */

ZyanStatus ZydisFormatterIntelFormatInstructionMASM(const ZydisFormatter* formatter,
    ZydisFormatterBuffer* buffer, ZydisFormatterContext* context);

ZyanStatus ZydisFormatterIntelPrintAddressMASM(const ZydisFormatter* formatter,
    ZydisFormatterBuffer* buffer, ZydisFormatterContext* context);

/* ---------------------------------------------------------------------------------------------- */

/* ============================================================================================== */
/* Fomatter presets                                                                               */
/* ============================================================================================== */

/* ---------------------------------------------------------------------------------------------- */
/* INTEL                                                                                          */
/* ---------------------------------------------------------------------------------------------- */

/**
 * The default formatter configuration for `INTEL` style disassembly.
 */
static const ZydisFormatter FORMATTER_INTEL =
{
    /* style                    */ ZYDIS_FORMATTER_STYLE_INTEL,
    /* force_memory_size        */ ZYAN_FALSE,
    /* force_memory_seg         */ ZYAN_FALSE,
    /* force_memory_scale       */ ZYAN_TRUE,
    /* force_relative_branches  */ ZYAN_FALSE,
    /* force_relative_riprel    */ ZYAN_FALSE,
    /* print_branch_size        */ ZYAN_FALSE,
    /* detailed_prefixes        */ ZYAN_FALSE,
    /* addr_base                */ ZYDIS_NUMERIC_BASE_HEX,
    /* addr_signedness          */ ZYDIS_SIGNEDNESS_SIGNED,
    /* addr_padding_absolute    */ ZYDIS_PADDING_AUTO,
    /* addr_padding_relative    */ 2,
    /* disp_base                */ ZYDIS_NUMERIC_BASE_HEX,
    /* disp_signedness          */ ZYDIS_SIGNEDNESS_SIGNED,
    /* disp_padding             */ 2,
    /* imm_base                 */ ZYDIS_NUMERIC_BASE_HEX,
    /* imm_signedness           */ ZYDIS_SIGNEDNESS_UNSIGNED,
    /* imm_padding              */ 2,
    /* case_prefixes            */ ZYDIS_LETTER_CASE_DEFAULT,
    /* case_mnemonic            */ ZYDIS_LETTER_CASE_DEFAULT,
    /* case_registers           */ ZYDIS_LETTER_CASE_DEFAULT,
    /* case_typecasts           */ ZYDIS_LETTER_CASE_DEFAULT,
    /* case_decorators          */ ZYDIS_LETTER_CASE_DEFAULT,
    /* hex_uppercase            */ ZYAN_TRUE,
    /* hex_force_leading_number */ ZYAN_FALSE,
    /* number_format            */
    {
        // ZYDIS_NUMERIC_BASE_DEC
        {
            // Prefix
            {
                /* string       */ ZYAN_NULL,
                /* string_data  */ ZYAN_DEFINE_STRING_VIEW(""),
                /* buffer       */ { 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0 },
            },
            // Suffix
            {
                /* string       */ ZYAN_NULL,
                /* string_data  */ ZYAN_DEFINE_STRING_VIEW(""),
                /* buffer       */ { 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0 },
            }
        },
        // ZYDIS_NUMERIC_BASE_HEX
        {
            // Prefix
            {
                /* string       */ &FORMATTER_INTEL.number_format[
                                       ZYDIS_NUMERIC_BASE_HEX][0].string_data,
                /* string_data  */ ZYAN_DEFINE_STRING_VIEW("0x"),
                /* buffer       */ { 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0 },
            },
            // Suffix
            {
                /* string       */ ZYAN_NULL,
                /* string_data  */ ZYAN_DEFINE_STRING_VIEW(""),
                /* buffer       */ { 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0 },
            }
        }
    },
    /* func_pre_instruction     */ ZYAN_NULL,
    /* func_post_instruction    */ ZYAN_NULL,
    /* func_format_instruction  */ &ZydisFormatterIntelFormatInstruction,
    /* func_pre_operand         */ ZYAN_NULL,
    /* func_post_operand        */ ZYAN_NULL,
    /* func_format_operand_reg  */ &ZydisFormatterBaseFormatOperandREG,
    /* func_format_operand_mem  */ &ZydisFormatterIntelFormatOperandMEM,
    /* func_format_operand_ptr  */ &ZydisFormatterBaseFormatOperandPTR,
    /* func_format_operand_imm  */ &ZydisFormatterBaseFormatOperandIMM,
    /* func_print_mnemonic      */ &ZydisFormatterIntelPrintMnemonic,
    /* func_print_register      */ &ZydisFormatterIntelPrintRegister,
    /* func_print_address_abs   */ &ZydisFormatterBasePrintAddressABS,
    /* func_print_address_rel   */ &ZydisFormatterBasePrintAddressREL,
    /* func_print_disp          */ &ZydisFormatterIntelPrintDISP,
    /* func_print_imm           */ &ZydisFormatterBasePrintIMM,
    /* func_print_typecast      */ &ZydisFormatterIntelPrintTypecast,
    /* func_print_segment       */ &ZydisFormatterBasePrintSegment,
    /* func_print_prefixes      */ &ZydisFormatterBasePrintPrefixes,
    /* func_print_decorator     */ &ZydisFormatterBasePrintDecorator
};

/* ---------------------------------------------------------------------------------------------- */
/* MASM                                                                                           */
/* ---------------------------------------------------------------------------------------------- */

/**
 * The default formatter configuration for `MASM` style disassembly.
 */
static const ZydisFormatter FORMATTER_INTEL_MASM =
{
    /* style                    */ ZYDIS_FORMATTER_STYLE_INTEL_MASM,
    /* force_memory_size        */ ZYAN_TRUE,
    /* force_memory_seg         */ ZYAN_FALSE,
    /* force_memory_scale       */ ZYAN_TRUE,
    /* force_relative_branches  */ ZYAN_FALSE,
    /* force_relative_riprel    */ ZYAN_FALSE,
    /* print_branch_size        */ ZYAN_FALSE,
    /* detailed_prefixes        */ ZYAN_FALSE,
    /* addr_base                */ ZYDIS_NUMERIC_BASE_HEX,
    /* addr_signedness          */ ZYDIS_SIGNEDNESS_SIGNED,
    /* addr_padding_absolute    */ ZYDIS_PADDING_DISABLED,
    /* addr_padding_relative    */ ZYDIS_PADDING_DISABLED,
    /* disp_base                */ ZYDIS_NUMERIC_BASE_HEX,
    /* disp_signedness          */ ZYDIS_SIGNEDNESS_SIGNED,
    /* disp_padding             */ ZYDIS_PADDING_DISABLED,
    /* imm_base                 */ ZYDIS_NUMERIC_BASE_HEX,
    /* imm_signedness           */ ZYDIS_SIGNEDNESS_AUTO,
    /* imm_padding              */ ZYDIS_PADDING_DISABLED,
    /* case_prefixes            */ ZYDIS_LETTER_CASE_DEFAULT,
    /* case_mnemonic            */ ZYDIS_LETTER_CASE_DEFAULT,
    /* case_registers           */ ZYDIS_LETTER_CASE_DEFAULT,
    /* case_typecasts           */ ZYDIS_LETTER_CASE_DEFAULT,
    /* case_decorators          */ ZYDIS_LETTER_CASE_DEFAULT,
    /* hex_uppercase            */ ZYAN_TRUE,
    /* hex_force_leading_number */ ZYAN_TRUE,
    /* number_format            */
    {
        // ZYDIS_NUMERIC_BASE_DEC
        {
            // Prefix
            {
                /* string       */ ZYAN_NULL,
                /* string_data  */ ZYAN_DEFINE_STRING_VIEW(""),
                /* buffer       */ { 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0 },
            },
            // Suffix
            {
                /* string       */ ZYAN_NULL,
                /* string_data  */ ZYAN_DEFINE_STRING_VIEW(""),
                /* buffer       */ { 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0 },
            }
        },
        // ZYDIS_NUMERIC_BASE_HEX
        {
            // Prefix
            {
                /* string       */ ZYAN_NULL,
                /* string_data  */ ZYAN_DEFINE_STRING_VIEW(""),
                /* buffer       */ { 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0 },
            },
            // Suffix
            {
                /* string       */ &FORMATTER_INTEL_MASM.number_format[
                                       ZYDIS_NUMERIC_BASE_HEX][1].string_data,
                /* string_data  */ ZYAN_DEFINE_STRING_VIEW("h"),
                /* buffer       */ { 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0 },
            }
        }
    },
    /* func_pre_instruction     */ ZYAN_NULL,
    /* func_post_instruction    */ ZYAN_NULL,
    /* func_format_instruction  */ &ZydisFormatterIntelFormatInstructionMASM,
    /* func_pre_operand         */ ZYAN_NULL,
    /* func_post_operand        */ ZYAN_NULL,
    /* func_format_operand_reg  */ &ZydisFormatterBaseFormatOperandREG,
    /* func_format_operand_mem  */ &ZydisFormatterIntelFormatOperandMEM,
    /* func_format_operand_ptr  */ &ZydisFormatterBaseFormatOperandPTR,
    /* func_format_operand_imm  */ &ZydisFormatterBaseFormatOperandIMM,
    /* func_print_mnemonic      */ &ZydisFormatterIntelPrintMnemonic,
    /* func_print_register      */ &ZydisFormatterIntelPrintRegister,
    /* func_print_address_abs   */ &ZydisFormatterIntelPrintAddressMASM,
    /* func_print_address_rel   */ &ZydisFormatterIntelPrintAddressMASM,
    /* func_print_disp          */ &ZydisFormatterIntelPrintDISP,
    /* func_print_imm           */ &ZydisFormatterBasePrintIMM,
    /* func_print_typecast      */ &ZydisFormatterIntelPrintTypecast,
    /* func_print_segment       */ &ZydisFormatterBasePrintSegment,
    /* func_print_prefixes      */ &ZydisFormatterBasePrintPrefixes,
    /* func_print_decorator     */ &ZydisFormatterBasePrintDecorator
};

/* ---------------------------------------------------------------------------------------------- */

/* ============================================================================================== */

#ifdef __cplusplus
}
#endif

#endif // ZYDIS_FORMATTER_INTEL_H

/* ============================================================================================== */
/* Constants                                                                                      */
/* ============================================================================================== */

/* ---------------------------------------------------------------------------------------------- */
/* Formatter presets                                                                              */
/* ---------------------------------------------------------------------------------------------- */

static const ZydisFormatter* const FORMATTER_PRESETS[ZYDIS_FORMATTER_STYLE_MAX_VALUE + 1] =
{
    &FORMATTER_ATT,
    &FORMATTER_INTEL,
    &FORMATTER_INTEL_MASM
};

/* ---------------------------------------------------------------------------------------------- */

/* ============================================================================================== */
/* Internal functions                                                                             */
/* ============================================================================================== */

/* ---------------------------------------------------------------------------------------------- */
/* Helper functions                                                                               */
/* ---------------------------------------------------------------------------------------------- */

static void ZydisFormatterBufferInit(ZydisFormatterBuffer* buffer, char* user_buffer,
    ZyanUSize length)
{
    ZYAN_ASSERT(buffer);
    ZYAN_ASSERT(user_buffer);
    ZYAN_ASSERT(length);

    buffer->is_token_list                   = ZYAN_FALSE;
    buffer->capacity                        = 0;
    buffer->string.flags                    = ZYAN_STRING_HAS_FIXED_CAPACITY;
    buffer->string.vector.allocator         = ZYAN_NULL;
    buffer->string.vector.growth_factor     = 1;
    buffer->string.vector.shrink_threshold  = 0;
    buffer->string.vector.destructor        = ZYAN_NULL;
    buffer->string.vector.element_size      = sizeof(char);
    buffer->string.vector.size              = 1;
    buffer->string.vector.capacity          = length;
    buffer->string.vector.data              = user_buffer;

    *user_buffer = '\0';
}

static void ZydisFormatterBufferInitTokenized(ZydisFormatterBuffer* buffer,
    ZydisFormatterToken** first_token, void* user_buffer, ZyanUSize length)
{
    ZYAN_ASSERT(buffer);
    ZYAN_ASSERT(first_token);
    ZYAN_ASSERT(user_buffer);
    ZYAN_ASSERT(length);

    *first_token = user_buffer;
    (*first_token)->type = ZYDIS_TOKEN_INVALID;
    (*first_token)->next = 0;

    user_buffer = (ZyanU8*)user_buffer + sizeof(ZydisFormatterToken);
    length -= sizeof(ZydisFormatterToken);

    buffer->is_token_list                  = ZYAN_TRUE;
    buffer->capacity                       = length;
    buffer->string.flags                   = ZYAN_STRING_HAS_FIXED_CAPACITY;
    buffer->string.vector.allocator        = ZYAN_NULL;
    buffer->string.vector.growth_factor    = 1;
    buffer->string.vector.shrink_threshold = 0;
    buffer->string.vector.destructor       = ZYAN_NULL;
    buffer->string.vector.element_size     = sizeof(char);
    buffer->string.vector.size             = 1;
    buffer->string.vector.capacity         = length;
    buffer->string.vector.data             = user_buffer;

    *(char*)user_buffer = '\0';
}

/* ---------------------------------------------------------------------------------------------- */

/* ============================================================================================== */
/* Exported functions                                                                             */
/* ============================================================================================== */

/* ---------------------------------------------------------------------------------------------- */
/* Initialization                                                                                 */
/* ---------------------------------------------------------------------------------------------- */

ZyanStatus ZydisFormatterInit(ZydisFormatter* formatter, ZydisFormatterStyle style)
{
    if (!formatter || ((ZyanUSize)style > ZYDIS_FORMATTER_STYLE_MAX_VALUE))
    {
        return ZYAN_STATUS_INVALID_ARGUMENT;
    }

    ZYAN_MEMCPY(formatter, FORMATTER_PRESETS[style], sizeof(*formatter));

    return ZYAN_STATUS_SUCCESS;
}

/* ---------------------------------------------------------------------------------------------- */
/* Setter                                                                                         */
/* ---------------------------------------------------------------------------------------------- */

ZyanStatus ZydisFormatterSetProperty(ZydisFormatter* formatter, ZydisFormatterProperty property,
    ZyanUPointer value)
{
    if (!formatter)
    {
        return ZYAN_STATUS_INVALID_ARGUMENT;
    }

    ZydisNumericBase base = (ZydisNumericBase)(-1);
    ZyanU8 index = 0xFF;

    switch (property)
    {
    case ZYDIS_FORMATTER_PROP_FORCE_SIZE:
    {
        formatter->force_memory_size = (value) ? ZYAN_TRUE : ZYAN_FALSE;
        break;
    }
    case ZYDIS_FORMATTER_PROP_FORCE_SEGMENT:
    {
        formatter->force_memory_segment = (value) ? ZYAN_TRUE : ZYAN_FALSE;
        break;
    }
    case ZYDIS_FORMATTER_PROP_FORCE_SCALE_ONE:
    {
        formatter->force_memory_scale = (value) ? ZYAN_TRUE : ZYAN_FALSE;
        break;
    }
    case ZYDIS_FORMATTER_PROP_FORCE_RELATIVE_BRANCHES:
    {
        formatter->force_relative_branches = (value) ? ZYAN_TRUE : ZYAN_FALSE;
        break;
    }
    case ZYDIS_FORMATTER_PROP_FORCE_RELATIVE_RIPREL:
    {
        formatter->force_relative_riprel = (value) ? ZYAN_TRUE : ZYAN_FALSE;
        break;
    }
    case ZYDIS_FORMATTER_PROP_PRINT_BRANCH_SIZE:
    {
        formatter->print_branch_size = (value) ? ZYAN_TRUE : ZYAN_FALSE;
        break;
    }
    case ZYDIS_FORMATTER_PROP_DETAILED_PREFIXES:
    {
        formatter->detailed_prefixes = (value) ? ZYAN_TRUE : ZYAN_FALSE;
        break;
    }
    case ZYDIS_FORMATTER_PROP_ADDR_BASE:
    {
        if (value > ZYDIS_NUMERIC_BASE_MAX_VALUE)
        {
            return ZYAN_STATUS_INVALID_ARGUMENT;
        }
        formatter->addr_base = (ZydisNumericBase)value;
        break;
    }
    case ZYDIS_FORMATTER_PROP_ADDR_SIGNEDNESS:
    {
        if (value > ZYDIS_SIGNEDNESS_MAX_VALUE)
        {
            return ZYAN_STATUS_INVALID_ARGUMENT;
        }
        formatter->addr_signedness = (ZydisSignedness)value;
        break;
    }
    case ZYDIS_FORMATTER_PROP_ADDR_PADDING_ABSOLUTE:
    {
        if (((ZydisPadding)value != ZYDIS_PADDING_AUTO) &&
            (value > 0xFF))
        {
            return ZYAN_STATUS_INVALID_ARGUMENT;
        }
        formatter->addr_padding_absolute = (ZydisPadding)value;
        break;
    }
    case ZYDIS_FORMATTER_PROP_ADDR_PADDING_RELATIVE:
    {
        if (((ZydisPadding)value != ZYDIS_PADDING_AUTO) &&
            (value > 0xFF))
        {
            return ZYAN_STATUS_INVALID_ARGUMENT;
        }
        formatter->addr_padding_relative = (ZydisPadding)value;
        break;
    }
    case ZYDIS_FORMATTER_PROP_DISP_BASE:
    {
        if (value > ZYDIS_NUMERIC_BASE_MAX_VALUE)
        {
            return ZYAN_STATUS_INVALID_ARGUMENT;
        }
        formatter->disp_base = (ZydisNumericBase)value;
        break;
    }
    case ZYDIS_FORMATTER_PROP_DISP_SIGNEDNESS:
    {
        if (value > ZYDIS_SIGNEDNESS_MAX_VALUE)
        {
            return ZYAN_STATUS_INVALID_ARGUMENT;
        }
        formatter->disp_signedness = (ZydisSignedness)value;
        break;
    }
    case ZYDIS_FORMATTER_PROP_DISP_PADDING:
    {
        if ((ZydisPadding)value == ZYDIS_PADDING_AUTO)
        {
            if ((ZyanUSize)formatter->style > ZYDIS_FORMATTER_STYLE_MAX_VALUE)
            {
                return ZYAN_STATUS_INVALID_ARGUMENT;
            }
            formatter->disp_padding = FORMATTER_PRESETS[formatter->style]->disp_padding;
        }
        else if (value > 0xFF)
        {
            return ZYAN_STATUS_INVALID_ARGUMENT;
        }
        formatter->disp_padding = (ZydisPadding)value;
        break;
    }
    case ZYDIS_FORMATTER_PROP_IMM_BASE:
    {
        if (value > ZYDIS_NUMERIC_BASE_MAX_VALUE)
        {
            return ZYAN_STATUS_INVALID_ARGUMENT;
        }
        formatter->imm_base = (ZydisNumericBase)value;
        break;
    }
    case ZYDIS_FORMATTER_PROP_IMM_SIGNEDNESS:
    {
        if (value > ZYDIS_SIGNEDNESS_MAX_VALUE)
        {
            return ZYAN_STATUS_INVALID_ARGUMENT;
        }
        formatter->imm_signedness  = (ZydisSignedness)value;
        break;
    }
    case ZYDIS_FORMATTER_PROP_IMM_PADDING:
    {
        if ((ZydisPadding)value == ZYDIS_PADDING_AUTO)
        {
            if ((ZyanUSize)formatter->style > ZYDIS_FORMATTER_STYLE_MAX_VALUE)
            {
                return ZYAN_STATUS_INVALID_ARGUMENT;
            }
            formatter->imm_padding = FORMATTER_PRESETS[formatter->style]->imm_padding;
        }
        else if (value > 0xFF)
        {
            return ZYAN_STATUS_INVALID_ARGUMENT;
        }
        formatter->imm_padding = (ZydisPadding)value;
        break;
    }
    case ZYDIS_FORMATTER_PROP_UPPERCASE_PREFIXES:
    {
        formatter->case_prefixes = (value) ? ZYDIS_LETTER_CASE_UPPER : ZYDIS_LETTER_CASE_DEFAULT;
        break;
    }
    case ZYDIS_FORMATTER_PROP_UPPERCASE_MNEMONIC:
    {
        formatter->case_mnemonic = (value) ? ZYDIS_LETTER_CASE_UPPER : ZYDIS_LETTER_CASE_DEFAULT;
        break;
    }
    case ZYDIS_FORMATTER_PROP_UPPERCASE_REGISTERS:
    {
        formatter->case_registers = (value) ? ZYDIS_LETTER_CASE_UPPER : ZYDIS_LETTER_CASE_DEFAULT;
        break;
    }
    case ZYDIS_FORMATTER_PROP_UPPERCASE_TYPECASTS:
    {
        formatter->case_typecasts = (value) ? ZYDIS_LETTER_CASE_UPPER : ZYDIS_LETTER_CASE_DEFAULT;
        break;
    }
    case ZYDIS_FORMATTER_PROP_UPPERCASE_DECORATORS:
    {
        formatter->case_decorators = (value) ? ZYDIS_LETTER_CASE_UPPER : ZYDIS_LETTER_CASE_DEFAULT;
        break;
    }
    case ZYDIS_FORMATTER_PROP_DEC_PREFIX:
    {
        base  = ZYDIS_NUMERIC_BASE_DEC;
        index = 0;
        break;
    }
    case ZYDIS_FORMATTER_PROP_DEC_SUFFIX:
    {
        base  = ZYDIS_NUMERIC_BASE_DEC;
        index = 1;
        break;
    }
    case ZYDIS_FORMATTER_PROP_HEX_UPPERCASE:
    {
        formatter->hex_uppercase = (value) ? ZYAN_TRUE : ZYAN_FALSE;
        break;
    }
    case ZYDIS_FORMATTER_PROP_HEX_FORCE_LEADING_NUMBER:
    {
        formatter->hex_force_leading_number = (value) ? ZYAN_TRUE : ZYAN_FALSE;
        break;
    }
    case ZYDIS_FORMATTER_PROP_HEX_PREFIX:
    {
        base  = ZYDIS_NUMERIC_BASE_HEX;
        index = 0;
        break;
    }
    case ZYDIS_FORMATTER_PROP_HEX_SUFFIX:
    {
        base  = ZYDIS_NUMERIC_BASE_HEX;
        index = 1;
        break;
    }
    default:
        return ZYAN_STATUS_INVALID_ARGUMENT;
    }

    // Set prefix or suffix
    if (base != (ZydisNumericBase)(-1))
    {
        if (value)
        {
            const ZyanUSize len = ZYAN_STRLEN((char*)value);
            if (len > 10)
            {
                return ZYAN_STATUS_INVALID_ARGUMENT;
            }
            ZYAN_MEMCPY(formatter->number_format[base][index].buffer, (void*)value, len);
            formatter->number_format[base][index].buffer[len] = '\0';
            formatter->number_format[base][index].string_data.string.vector.data =
                formatter->number_format[base][index].buffer;
            formatter->number_format[base][index].string_data.string.vector.size = len + 1;
            formatter->number_format[base][index].string =
                &formatter->number_format[base][index].string_data;
        } else
        {
            formatter->number_format[base][index].string = ZYAN_NULL;
        }
    }

    return ZYAN_STATUS_SUCCESS;
}

ZyanStatus ZydisFormatterSetHook(ZydisFormatter* formatter, ZydisFormatterFunction type,
    const void** callback)
{
    if (!formatter || !callback || ((ZyanUSize)type > ZYDIS_FORMATTER_FUNC_MAX_VALUE))
    {
        return ZYAN_STATUS_INVALID_ARGUMENT;
    }

    const void* const temp = *callback;

    // The following code relies on the order of the enum values and the function fields inside
    // the `ZydisFormatter` struct

#ifdef ZYAN_DEBUG
    const ZyanUPointer* test = (ZyanUPointer*)(&formatter->func_pre_instruction + type);
    switch (type)
    {
    case ZYDIS_FORMATTER_FUNC_PRE_INSTRUCTION:
        ZYAN_ASSERT(test == (ZyanUPointer*)&formatter->func_pre_instruction   ); break;
    case ZYDIS_FORMATTER_FUNC_POST_INSTRUCTION:
        ZYAN_ASSERT(test == (ZyanUPointer*)&formatter->func_post_instruction  ); break;
    case ZYDIS_FORMATTER_FUNC_FORMAT_INSTRUCTION:
        ZYAN_ASSERT(test == (ZyanUPointer*)&formatter->func_format_instruction); break;
    case ZYDIS_FORMATTER_FUNC_PRE_OPERAND:
        ZYAN_ASSERT(test == (ZyanUPointer*)&formatter->func_pre_operand       ); break;
    case ZYDIS_FORMATTER_FUNC_POST_OPERAND:
        ZYAN_ASSERT(test == (ZyanUPointer*)&formatter->func_post_operand      ); break;
    case ZYDIS_FORMATTER_FUNC_FORMAT_OPERAND_REG:
        ZYAN_ASSERT(test == (ZyanUPointer*)&formatter->func_format_operand_reg); break;
    case ZYDIS_FORMATTER_FUNC_FORMAT_OPERAND_MEM:
        ZYAN_ASSERT(test == (ZyanUPointer*)&formatter->func_format_operand_mem); break;
    case ZYDIS_FORMATTER_FUNC_FORMAT_OPERAND_PTR:
        ZYAN_ASSERT(test == (ZyanUPointer*)&formatter->func_format_operand_ptr); break;
    case ZYDIS_FORMATTER_FUNC_FORMAT_OPERAND_IMM:
        ZYAN_ASSERT(test == (ZyanUPointer*)&formatter->func_format_operand_imm); break;
    case ZYDIS_FORMATTER_FUNC_PRINT_MNEMONIC:
        ZYAN_ASSERT(test == (ZyanUPointer*)&formatter->func_print_mnemonic    ); break;
    case ZYDIS_FORMATTER_FUNC_PRINT_REGISTER:
        ZYAN_ASSERT(test == (ZyanUPointer*)&formatter->func_print_register    ); break;
    case ZYDIS_FORMATTER_FUNC_PRINT_ADDRESS_ABS:
        ZYAN_ASSERT(test == (ZyanUPointer*)&formatter->func_print_address_abs ); break;
    case ZYDIS_FORMATTER_FUNC_PRINT_ADDRESS_REL:
        ZYAN_ASSERT(test == (ZyanUPointer*)&formatter->func_print_address_rel ); break;
    case ZYDIS_FORMATTER_FUNC_PRINT_DISP:
        ZYAN_ASSERT(test == (ZyanUPointer*)&formatter->func_print_disp        ); break;
    case ZYDIS_FORMATTER_FUNC_PRINT_IMM:
        ZYAN_ASSERT(test == (ZyanUPointer*)&formatter->func_print_imm         ); break;
    case ZYDIS_FORMATTER_FUNC_PRINT_TYPECAST:
        ZYAN_ASSERT(test == (ZyanUPointer*)&formatter->func_print_typecast    ); break;
    case ZYDIS_FORMATTER_FUNC_PRINT_SEGMENT:
        ZYAN_ASSERT(test == (ZyanUPointer*)&formatter->func_print_segment     ); break;
    case ZYDIS_FORMATTER_FUNC_PRINT_PREFIXES:
        ZYAN_ASSERT(test == (ZyanUPointer*)&formatter->func_print_prefixes    ); break;
    case ZYDIS_FORMATTER_FUNC_PRINT_DECORATOR:
        ZYAN_ASSERT(test == (ZyanUPointer*)&formatter->func_print_decorator   ); break;
    default:
        ZYAN_UNREACHABLE;
    }
#endif

    *callback = *(const void**)(&formatter->func_pre_instruction + type);
    if (!temp)
    {
        return ZYAN_STATUS_SUCCESS;
    }
    ZYAN_MEMCPY(&formatter->func_pre_instruction + type, &temp, sizeof(ZyanUPointer));

    return ZYAN_STATUS_SUCCESS;
}

/* ---------------------------------------------------------------------------------------------- */
/* Formatting                                                                                     */
/* ---------------------------------------------------------------------------------------------- */

ZyanStatus ZydisFormatterFormatInstruction(const ZydisFormatter* formatter,
    const ZydisDecodedInstruction* instruction, const ZydisDecodedOperand* operands,
    ZyanU8 operand_count, char* buffer, ZyanUSize length, ZyanU64 runtime_address, void* user_data)
{
    if (!formatter || !instruction || (operand_count && !operands) ||
        (operand_count > ZYDIS_MAX_OPERAND_COUNT) ||
        (operand_count < instruction->operand_count_visible) || !buffer || (length == 0))
    {
        return ZYAN_STATUS_INVALID_ARGUMENT;
    }

    ZydisFormatterBuffer formatter_buffer;
    ZydisFormatterBufferInit(&formatter_buffer, buffer, length);

    ZydisFormatterContext context;
    context.instruction     = instruction;
    context.operands        = operands;
    context.runtime_address = runtime_address;
    context.operand         = ZYAN_NULL;
    context.user_data       = user_data;

    if (formatter->func_pre_instruction)
    {
        ZYAN_CHECK(formatter->func_pre_instruction(formatter, &formatter_buffer, &context));
    }

    ZYAN_CHECK(formatter->func_format_instruction(formatter, &formatter_buffer, &context));

    if (formatter->func_post_instruction)
    {
        ZYAN_CHECK(formatter->func_post_instruction(formatter, &formatter_buffer, &context));
    }

    return ZYAN_STATUS_SUCCESS;
}

ZyanStatus ZydisFormatterFormatOperand(const ZydisFormatter* formatter,
    const ZydisDecodedInstruction* instruction, const ZydisDecodedOperand* operand,
    char* buffer, ZyanUSize length, ZyanU64 runtime_address, void* user_data)
{
    if (!formatter || !instruction || !operand || !buffer || (length == 0))
    {
        return ZYAN_STATUS_INVALID_ARGUMENT;
    }

    ZydisFormatterBuffer formatter_buffer;
    ZydisFormatterBufferInit(&formatter_buffer, buffer, length);

    ZydisFormatterContext context;
    context.instruction     = instruction;
    context.operands        = ZYAN_NULL;
    context.runtime_address = runtime_address;
    context.operand         = operand;
    context.user_data       = user_data;

    // We ignore `ZYDIS_STATUS_SKIP_TOKEN` for all operand-functions as it does not make any sense
    // to skip the only operand printed by this function

    if (formatter->func_pre_operand)
    {
        ZYAN_CHECK(formatter->func_pre_operand(formatter, &formatter_buffer, &context));
    }

    switch (context.operand->type)
    {
    case ZYDIS_OPERAND_TYPE_REGISTER:
        ZYAN_CHECK(formatter->func_format_operand_reg(formatter, &formatter_buffer, &context));
        break;
    case ZYDIS_OPERAND_TYPE_MEMORY:
        ZYAN_CHECK(formatter->func_format_operand_mem(formatter, &formatter_buffer, &context));
        break;
    case ZYDIS_OPERAND_TYPE_IMMEDIATE:
        ZYAN_CHECK(formatter->func_format_operand_imm(formatter, &formatter_buffer, &context));
        break;
    case ZYDIS_OPERAND_TYPE_POINTER:
        ZYAN_CHECK(formatter->func_format_operand_ptr(formatter, &formatter_buffer, &context));
        break;
    default:
        return ZYAN_STATUS_INVALID_ARGUMENT;
    }

    if (formatter->func_post_operand)
    {
        ZYAN_CHECK(formatter->func_post_operand(formatter, &formatter_buffer, &context));
    }

    return ZYAN_STATUS_SUCCESS;
}

/* ---------------------------------------------------------------------------------------------- */
/* Tokenizing                                                                                     */
/* ---------------------------------------------------------------------------------------------- */

ZyanStatus ZydisFormatterTokenizeInstruction(const ZydisFormatter* formatter,
    const ZydisDecodedInstruction* instruction, const ZydisDecodedOperand* operands,
    ZyanU8 operand_count, void* buffer, ZyanUSize length, ZyanU64 runtime_address,
    ZydisFormatterTokenConst** token, void* user_data)
{
    if (!formatter || !instruction || (operand_count && !operands) ||
        (operand_count > ZYDIS_MAX_OPERAND_COUNT) ||
        (operand_count < instruction->operand_count_visible) || !buffer ||
        (length <= sizeof(ZydisFormatterToken)) || !token)
    {
        return ZYAN_STATUS_INVALID_ARGUMENT;
    }

    ZydisFormatterBuffer formatter_buffer;
    ZydisFormatterToken* first_token;
    ZydisFormatterBufferInitTokenized(&formatter_buffer, &first_token, buffer, length);

    ZydisFormatterContext context;
    context.instruction     = instruction;
    context.operands        = operands;
    context.runtime_address = runtime_address;
    context.operand         = ZYAN_NULL;
    context.user_data       = user_data;

    if (formatter->func_pre_instruction)
    {
        ZYAN_CHECK(formatter->func_pre_instruction(formatter, &formatter_buffer, &context));
    }

    ZYAN_CHECK(formatter->func_format_instruction(formatter, &formatter_buffer, &context));

    if (formatter->func_post_instruction)
    {
        ZYAN_CHECK(formatter->func_post_instruction(formatter, &formatter_buffer, &context));
    }

    if (first_token->next)
    {
        *token = (ZydisFormatterTokenConst*)((ZyanU8*)first_token + sizeof(ZydisFormatterToken) +
            first_token->next);
        return ZYAN_STATUS_SUCCESS;
    }

    *token = first_token;
    return ZYAN_STATUS_SUCCESS;
}

ZyanStatus ZydisFormatterTokenizeOperand(const ZydisFormatter* formatter,
    const ZydisDecodedInstruction* instruction, const ZydisDecodedOperand* operand,
    void* buffer, ZyanUSize length, ZyanU64 runtime_address, ZydisFormatterTokenConst** token,
    void* user_data)
{
    if (!formatter || !instruction || !operand || !buffer ||
        (length <= sizeof(ZydisFormatterToken)) || !token)
    {
        return ZYAN_STATUS_INVALID_ARGUMENT;
    }

    ZydisFormatterToken* first_token;
    ZydisFormatterBuffer formatter_buffer;
    ZydisFormatterBufferInitTokenized(&formatter_buffer, &first_token, buffer, length);

    ZydisFormatterContext context;
    context.instruction     = instruction;
    context.operands        = ZYAN_NULL;
    context.runtime_address = runtime_address;
    context.operand         = operand;
    context.user_data       = user_data;

    // We ignore `ZYDIS_STATUS_SKIP_TOKEN` for all operand-functions as it does not make any sense
    // to skip the only operand printed by this function

    if (formatter->func_pre_operand)
    {
        ZYAN_CHECK(formatter->func_pre_operand(formatter, &formatter_buffer, &context));
    }

    switch (context.operand->type)
    {
    case ZYDIS_OPERAND_TYPE_REGISTER:
        ZYAN_CHECK(formatter->func_format_operand_reg(formatter, &formatter_buffer, &context));
        break;
    case ZYDIS_OPERAND_TYPE_MEMORY:
        ZYAN_CHECK(formatter->func_format_operand_mem(formatter, &formatter_buffer, &context));
        break;
    case ZYDIS_OPERAND_TYPE_IMMEDIATE:
        ZYAN_CHECK(formatter->func_format_operand_imm(formatter, &formatter_buffer, &context));
        break;
    case ZYDIS_OPERAND_TYPE_POINTER:
        ZYAN_CHECK(formatter->func_format_operand_ptr(formatter, &formatter_buffer, &context));
        break;
    default:
        return ZYAN_STATUS_INVALID_ARGUMENT;
    }

    if (formatter->func_post_operand)
    {
        ZYAN_CHECK(formatter->func_post_operand(formatter, &formatter_buffer, &context));
    }

    if (first_token->next)
    {
        *token = (ZydisFormatterTokenConst*)((ZyanU8*)first_token + sizeof(ZydisFormatterToken) +
            first_token->next);
        return ZYAN_STATUS_SUCCESS;
    }

    *token = first_token;
    return ZYAN_STATUS_SUCCESS;
}

/* ============================================================================================== */

/* ============================================================================================== */

//
// Source file: /home/ath/devel/zydis/src/FormatterATT.c
//

/***************************************************************************************************

  Zyan Disassembler Library (Zydis)

  Original Author : Florian Bernd, Joel Hoener

 * Permission is hereby granted, free of charge, to any person obtaining a copy
 * of this software and associated documentation files (the "Software"), to deal
 * in the Software without restriction, including without limitation the rights
 * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
 * copies of the Software, and to permit persons to whom the Software is
 * furnished to do so, subject to the following conditions:
 *
 * The above copyright notice and this permission notice shall be included in all
 * copies or substantial portions of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
 * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
 * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
 * SOFTWARE.

***************************************************************************************************/


/* ============================================================================================== */
/* Constants                                                                                      */
/* ============================================================================================== */


//
// Header: Generated/FormatterStrings.inc
//

#pragma pack(push, 1)

static const ZydisShortString STR_ADD = ZYDIS_MAKE_SHORTSTRING("+");
static const struct ZydisPredefinedTokenADD_
{
  ZyanU8 size;
  ZyanU8 next;
  ZyanU8 data[4];
} TOK_DATA_ADD = { 4, 2, { ZYDIS_TOKEN_DELIMITER, 0, '+', '\0' } };
static const ZydisPredefinedToken* const TOK_ADD = (const ZydisPredefinedToken* const)&TOK_DATA_ADD;

static const ZydisShortString STR_ADDR_RELATIVE = ZYDIS_MAKE_SHORTSTRING("$");
static const struct ZydisPredefinedTokenADDR_RELATIVE_
{
  ZyanU8 size;
  ZyanU8 next;
  ZyanU8 data[4];
} TOK_DATA_ADDR_RELATIVE = { 4, 2, { ZYDIS_TOKEN_ADDRESS_REL, 0, '$', '\0' } };
static const ZydisPredefinedToken* const TOK_ADDR_RELATIVE = (const ZydisPredefinedToken* const)&TOK_DATA_ADDR_RELATIVE;

static const ZydisShortString STR_DECO_1TO2 = ZYDIS_MAKE_SHORTSTRING(" {1to2}");
static const struct ZydisPredefinedTokenDECO_1TO2_
{
  ZyanU8 size;
  ZyanU8 next;
  ZyanU8 data[19];
} TOK_DATA_DECO_1TO2 = { 19, 17, { ZYDIS_TOKEN_WHITESPACE, 2, ' ', '\0', ZYDIS_TOKEN_PARENTHESIS_OPEN, 2, '{', '\0', ZYDIS_TOKEN_DECORATOR, 5, '1', 't', 'o', '2', '\0', ZYDIS_TOKEN_PARENTHESIS_CLOSE, 0, '}', '\0' } };
static const ZydisPredefinedToken* const TOK_DECO_1TO2 = (const ZydisPredefinedToken* const)&TOK_DATA_DECO_1TO2;

static const ZydisShortString STR_DECO_1TO4 = ZYDIS_MAKE_SHORTSTRING(" {1to4}");
static const struct ZydisPredefinedTokenDECO_1TO4_
{
  ZyanU8 size;
  ZyanU8 next;
  ZyanU8 data[19];
} TOK_DATA_DECO_1TO4 = { 19, 17, { ZYDIS_TOKEN_WHITESPACE, 2, ' ', '\0', ZYDIS_TOKEN_PARENTHESIS_OPEN, 2, '{', '\0', ZYDIS_TOKEN_DECORATOR, 5, '1', 't', 'o', '4', '\0', ZYDIS_TOKEN_PARENTHESIS_CLOSE, 0, '}', '\0' } };
static const ZydisPredefinedToken* const TOK_DECO_1TO4 = (const ZydisPredefinedToken* const)&TOK_DATA_DECO_1TO4;

static const ZydisShortString STR_DECO_1TO8 = ZYDIS_MAKE_SHORTSTRING(" {1to8}");
static const struct ZydisPredefinedTokenDECO_1TO8_
{
  ZyanU8 size;
  ZyanU8 next;
  ZyanU8 data[19];
} TOK_DATA_DECO_1TO8 = { 19, 17, { ZYDIS_TOKEN_WHITESPACE, 2, ' ', '\0', ZYDIS_TOKEN_PARENTHESIS_OPEN, 2, '{', '\0', ZYDIS_TOKEN_DECORATOR, 5, '1', 't', 'o', '8', '\0', ZYDIS_TOKEN_PARENTHESIS_CLOSE, 0, '}', '\0' } };
static const ZydisPredefinedToken* const TOK_DECO_1TO8 = (const ZydisPredefinedToken* const)&TOK_DATA_DECO_1TO8;

static const ZydisShortString STR_DECO_1TO16 = ZYDIS_MAKE_SHORTSTRING(" {1to16}");
static const struct ZydisPredefinedTokenDECO_1TO16_
{
  ZyanU8 size;
  ZyanU8 next;
  ZyanU8 data[20];
} TOK_DATA_DECO_1TO16 = { 20, 18, { ZYDIS_TOKEN_WHITESPACE, 2, ' ', '\0', ZYDIS_TOKEN_PARENTHESIS_OPEN, 2, '{', '\0', ZYDIS_TOKEN_DECORATOR, 6, '1', 't', 'o', '1', '6', '\0', ZYDIS_TOKEN_PARENTHESIS_CLOSE, 0, '}', '\0' } };
static const ZydisPredefinedToken* const TOK_DECO_1TO16 = (const ZydisPredefinedToken* const)&TOK_DATA_DECO_1TO16;

static const ZydisShortString STR_DECO_1TO32 = ZYDIS_MAKE_SHORTSTRING(" {1to32}");
static const struct ZydisPredefinedTokenDECO_1TO32_
{
  ZyanU8 size;
  ZyanU8 next;
  ZyanU8 data[20];
} TOK_DATA_DECO_1TO32 = { 20, 18, { ZYDIS_TOKEN_WHITESPACE, 2, ' ', '\0', ZYDIS_TOKEN_PARENTHESIS_OPEN, 2, '{', '\0', ZYDIS_TOKEN_DECORATOR, 6, '1', 't', 'o', '3', '2', '\0', ZYDIS_TOKEN_PARENTHESIS_CLOSE, 0, '}', '\0' } };
static const ZydisPredefinedToken* const TOK_DECO_1TO32 = (const ZydisPredefinedToken* const)&TOK_DATA_DECO_1TO32;

static const ZydisShortString STR_DECO_1TO64 = ZYDIS_MAKE_SHORTSTRING(" {1to64}");
static const struct ZydisPredefinedTokenDECO_1TO64_
{
  ZyanU8 size;
  ZyanU8 next;
  ZyanU8 data[20];
} TOK_DATA_DECO_1TO64 = { 20, 18, { ZYDIS_TOKEN_WHITESPACE, 2, ' ', '\0', ZYDIS_TOKEN_PARENTHESIS_OPEN, 2, '{', '\0', ZYDIS_TOKEN_DECORATOR, 6, '1', 't', 'o', '6', '4', '\0', ZYDIS_TOKEN_PARENTHESIS_CLOSE, 0, '}', '\0' } };
static const ZydisPredefinedToken* const TOK_DECO_1TO64 = (const ZydisPredefinedToken* const)&TOK_DATA_DECO_1TO64;

static const ZydisShortString STR_DECO_4TO8 = ZYDIS_MAKE_SHORTSTRING(" {4to8}");
static const struct ZydisPredefinedTokenDECO_4TO8_
{
  ZyanU8 size;
  ZyanU8 next;
  ZyanU8 data[19];
} TOK_DATA_DECO_4TO8 = { 19, 17, { ZYDIS_TOKEN_WHITESPACE, 2, ' ', '\0', ZYDIS_TOKEN_PARENTHESIS_OPEN, 2, '{', '\0', ZYDIS_TOKEN_DECORATOR, 5, '4', 't', 'o', '8', '\0', ZYDIS_TOKEN_PARENTHESIS_CLOSE, 0, '}', '\0' } };
static const ZydisPredefinedToken* const TOK_DECO_4TO8 = (const ZydisPredefinedToken* const)&TOK_DATA_DECO_4TO8;

static const ZydisShortString STR_DECO_4TO16 = ZYDIS_MAKE_SHORTSTRING(" {4to16}");
static const struct ZydisPredefinedTokenDECO_4TO16_
{
  ZyanU8 size;
  ZyanU8 next;
  ZyanU8 data[20];
} TOK_DATA_DECO_4TO16 = { 20, 18, { ZYDIS_TOKEN_WHITESPACE, 2, ' ', '\0', ZYDIS_TOKEN_PARENTHESIS_OPEN, 2, '{', '\0', ZYDIS_TOKEN_DECORATOR, 6, '4', 't', 'o', '1', '6', '\0', ZYDIS_TOKEN_PARENTHESIS_CLOSE, 0, '}', '\0' } };
static const ZydisPredefinedToken* const TOK_DECO_4TO16 = (const ZydisPredefinedToken* const)&TOK_DATA_DECO_4TO16;

static const ZydisShortString STR_DECO_8TO16 = ZYDIS_MAKE_SHORTSTRING(" {8to16}");
static const struct ZydisPredefinedTokenDECO_8TO16_
{
  ZyanU8 size;
  ZyanU8 next;
  ZyanU8 data[20];
} TOK_DATA_DECO_8TO16 = { 20, 18, { ZYDIS_TOKEN_WHITESPACE, 2, ' ', '\0', ZYDIS_TOKEN_PARENTHESIS_OPEN, 2, '{', '\0', ZYDIS_TOKEN_DECORATOR, 6, '8', 't', 'o', '1', '6', '\0', ZYDIS_TOKEN_PARENTHESIS_CLOSE, 0, '}', '\0' } };
static const ZydisPredefinedToken* const TOK_DECO_8TO16 = (const ZydisPredefinedToken* const)&TOK_DATA_DECO_8TO16;

static const ZydisShortString STR_DECO_AAAA = ZYDIS_MAKE_SHORTSTRING(" {aaaa}");
static const struct ZydisPredefinedTokenDECO_AAAA_
{
  ZyanU8 size;
  ZyanU8 next;
  ZyanU8 data[19];
} TOK_DATA_DECO_AAAA = { 19, 17, { ZYDIS_TOKEN_WHITESPACE, 2, ' ', '\0', ZYDIS_TOKEN_PARENTHESIS_OPEN, 2, '{', '\0', ZYDIS_TOKEN_DECORATOR, 5, 'a', 'a', 'a', 'a', '\0', ZYDIS_TOKEN_PARENTHESIS_CLOSE, 0, '}', '\0' } };
static const ZydisPredefinedToken* const TOK_DECO_AAAA = (const ZydisPredefinedToken* const)&TOK_DATA_DECO_AAAA;

static const ZydisShortString STR_DECO_BADC = ZYDIS_MAKE_SHORTSTRING(" {badc}");
static const struct ZydisPredefinedTokenDECO_BADC_
{
  ZyanU8 size;
  ZyanU8 next;
  ZyanU8 data[19];
} TOK_DATA_DECO_BADC = { 19, 17, { ZYDIS_TOKEN_WHITESPACE, 2, ' ', '\0', ZYDIS_TOKEN_PARENTHESIS_OPEN, 2, '{', '\0', ZYDIS_TOKEN_DECORATOR, 5, 'b', 'a', 'd', 'c', '\0', ZYDIS_TOKEN_PARENTHESIS_CLOSE, 0, '}', '\0' } };
static const ZydisPredefinedToken* const TOK_DECO_BADC = (const ZydisPredefinedToken* const)&TOK_DATA_DECO_BADC;

static const ZydisShortString STR_DECO_BBBB = ZYDIS_MAKE_SHORTSTRING(" {bbbb}");
static const struct ZydisPredefinedTokenDECO_BBBB_
{
  ZyanU8 size;
  ZyanU8 next;
  ZyanU8 data[19];
} TOK_DATA_DECO_BBBB = { 19, 17, { ZYDIS_TOKEN_WHITESPACE, 2, ' ', '\0', ZYDIS_TOKEN_PARENTHESIS_OPEN, 2, '{', '\0', ZYDIS_TOKEN_DECORATOR, 5, 'b', 'b', 'b', 'b', '\0', ZYDIS_TOKEN_PARENTHESIS_CLOSE, 0, '}', '\0' } };
static const ZydisPredefinedToken* const TOK_DECO_BBBB = (const ZydisPredefinedToken* const)&TOK_DATA_DECO_BBBB;

static const ZydisShortString STR_DECO_BEGIN = ZYDIS_MAKE_SHORTSTRING(" {");
static const struct ZydisPredefinedTokenDECO_BEGIN_
{
  ZyanU8 size;
  ZyanU8 next;
  ZyanU8 data[8];
} TOK_DATA_DECO_BEGIN = { 8, 6, { ZYDIS_TOKEN_WHITESPACE, 2, ' ', '\0', ZYDIS_TOKEN_PARENTHESIS_OPEN, 0, '{', '\0' } };
static const ZydisPredefinedToken* const TOK_DECO_BEGIN = (const ZydisPredefinedToken* const)&TOK_DATA_DECO_BEGIN;

static const ZydisShortString STR_DECO_CCCC = ZYDIS_MAKE_SHORTSTRING(" {cccc}");
static const struct ZydisPredefinedTokenDECO_CCCC_
{
  ZyanU8 size;
  ZyanU8 next;
  ZyanU8 data[19];
} TOK_DATA_DECO_CCCC = { 19, 17, { ZYDIS_TOKEN_WHITESPACE, 2, ' ', '\0', ZYDIS_TOKEN_PARENTHESIS_OPEN, 2, '{', '\0', ZYDIS_TOKEN_DECORATOR, 5, 'c', 'c', 'c', 'c', '\0', ZYDIS_TOKEN_PARENTHESIS_CLOSE, 0, '}', '\0' } };
static const ZydisPredefinedToken* const TOK_DECO_CCCC = (const ZydisPredefinedToken* const)&TOK_DATA_DECO_CCCC;

static const ZydisShortString STR_DECO_CDAB = ZYDIS_MAKE_SHORTSTRING(" {cdab}");
static const struct ZydisPredefinedTokenDECO_CDAB_
{
  ZyanU8 size;
  ZyanU8 next;
  ZyanU8 data[19];
} TOK_DATA_DECO_CDAB = { 19, 17, { ZYDIS_TOKEN_WHITESPACE, 2, ' ', '\0', ZYDIS_TOKEN_PARENTHESIS_OPEN, 2, '{', '\0', ZYDIS_TOKEN_DECORATOR, 5, 'c', 'd', 'a', 'b', '\0', ZYDIS_TOKEN_PARENTHESIS_CLOSE, 0, '}', '\0' } };
static const ZydisPredefinedToken* const TOK_DECO_CDAB = (const ZydisPredefinedToken* const)&TOK_DATA_DECO_CDAB;

static const ZydisShortString STR_DECO_DACB = ZYDIS_MAKE_SHORTSTRING(" {dacb}");
static const struct ZydisPredefinedTokenDECO_DACB_
{
  ZyanU8 size;
  ZyanU8 next;
  ZyanU8 data[19];
} TOK_DATA_DECO_DACB = { 19, 17, { ZYDIS_TOKEN_WHITESPACE, 2, ' ', '\0', ZYDIS_TOKEN_PARENTHESIS_OPEN, 2, '{', '\0', ZYDIS_TOKEN_DECORATOR, 5, 'd', 'a', 'c', 'b', '\0', ZYDIS_TOKEN_PARENTHESIS_CLOSE, 0, '}', '\0' } };
static const ZydisPredefinedToken* const TOK_DECO_DACB = (const ZydisPredefinedToken* const)&TOK_DATA_DECO_DACB;

static const ZydisShortString STR_DECO_DDDD = ZYDIS_MAKE_SHORTSTRING(" {dddd}");
static const struct ZydisPredefinedTokenDECO_DDDD_
{
  ZyanU8 size;
  ZyanU8 next;
  ZyanU8 data[19];
} TOK_DATA_DECO_DDDD = { 19, 17, { ZYDIS_TOKEN_WHITESPACE, 2, ' ', '\0', ZYDIS_TOKEN_PARENTHESIS_OPEN, 2, '{', '\0', ZYDIS_TOKEN_DECORATOR, 5, 'd', 'd', 'd', 'd', '\0', ZYDIS_TOKEN_PARENTHESIS_CLOSE, 0, '}', '\0' } };
static const ZydisPredefinedToken* const TOK_DECO_DDDD = (const ZydisPredefinedToken* const)&TOK_DATA_DECO_DDDD;

static const ZydisShortString STR_DECO_EH = ZYDIS_MAKE_SHORTSTRING(" {eh}");
static const struct ZydisPredefinedTokenDECO_EH_
{
  ZyanU8 size;
  ZyanU8 next;
  ZyanU8 data[17];
} TOK_DATA_DECO_EH = { 17, 15, { ZYDIS_TOKEN_WHITESPACE, 2, ' ', '\0', ZYDIS_TOKEN_PARENTHESIS_OPEN, 2, '{', '\0', ZYDIS_TOKEN_DECORATOR, 3, 'e', 'h', '\0', ZYDIS_TOKEN_PARENTHESIS_CLOSE, 0, '}', '\0' } };
static const ZydisPredefinedToken* const TOK_DECO_EH = (const ZydisPredefinedToken* const)&TOK_DATA_DECO_EH;

static const ZydisShortString STR_DECO_END = ZYDIS_MAKE_SHORTSTRING("}");
static const struct ZydisPredefinedTokenDECO_END_
{
  ZyanU8 size;
  ZyanU8 next;
  ZyanU8 data[4];
} TOK_DATA_DECO_END = { 4, 2, { ZYDIS_TOKEN_PARENTHESIS_CLOSE, 0, '}', '\0' } };
static const ZydisPredefinedToken* const TOK_DECO_END = (const ZydisPredefinedToken* const)&TOK_DATA_DECO_END;

static const ZydisShortString STR_DECO_FLOAT16 = ZYDIS_MAKE_SHORTSTRING(" {float16}");
static const struct ZydisPredefinedTokenDECO_FLOAT16_
{
  ZyanU8 size;
  ZyanU8 next;
  ZyanU8 data[22];
} TOK_DATA_DECO_FLOAT16 = { 22, 20, { ZYDIS_TOKEN_WHITESPACE, 2, ' ', '\0', ZYDIS_TOKEN_PARENTHESIS_OPEN, 2, '{', '\0', ZYDIS_TOKEN_DECORATOR, 8, 'f', 'l', 'o', 'a', 't', '1', '6', '\0', ZYDIS_TOKEN_PARENTHESIS_CLOSE, 0, '}', '\0' } };
static const ZydisPredefinedToken* const TOK_DECO_FLOAT16 = (const ZydisPredefinedToken* const)&TOK_DATA_DECO_FLOAT16;

static const ZydisShortString STR_DECO_RD = ZYDIS_MAKE_SHORTSTRING(" {rd}");
static const struct ZydisPredefinedTokenDECO_RD_
{
  ZyanU8 size;
  ZyanU8 next;
  ZyanU8 data[17];
} TOK_DATA_DECO_RD = { 17, 15, { ZYDIS_TOKEN_WHITESPACE, 2, ' ', '\0', ZYDIS_TOKEN_PARENTHESIS_OPEN, 2, '{', '\0', ZYDIS_TOKEN_DECORATOR, 3, 'r', 'd', '\0', ZYDIS_TOKEN_PARENTHESIS_CLOSE, 0, '}', '\0' } };
static const ZydisPredefinedToken* const TOK_DECO_RD = (const ZydisPredefinedToken* const)&TOK_DATA_DECO_RD;

static const ZydisShortString STR_DECO_RD_SAE = ZYDIS_MAKE_SHORTSTRING(" {rd-sae}");
static const struct ZydisPredefinedTokenDECO_RD_SAE_
{
  ZyanU8 size;
  ZyanU8 next;
  ZyanU8 data[21];
} TOK_DATA_DECO_RD_SAE = { 21, 19, { ZYDIS_TOKEN_WHITESPACE, 2, ' ', '\0', ZYDIS_TOKEN_PARENTHESIS_OPEN, 2, '{', '\0', ZYDIS_TOKEN_DECORATOR, 7, 'r', 'd', '-', 's', 'a', 'e', '\0', ZYDIS_TOKEN_PARENTHESIS_CLOSE, 0, '}', '\0' } };
static const ZydisPredefinedToken* const TOK_DECO_RD_SAE = (const ZydisPredefinedToken* const)&TOK_DATA_DECO_RD_SAE;

static const ZydisShortString STR_DECO_RN = ZYDIS_MAKE_SHORTSTRING(" {rn}");
static const struct ZydisPredefinedTokenDECO_RN_
{
  ZyanU8 size;
  ZyanU8 next;
  ZyanU8 data[17];
} TOK_DATA_DECO_RN = { 17, 15, { ZYDIS_TOKEN_WHITESPACE, 2, ' ', '\0', ZYDIS_TOKEN_PARENTHESIS_OPEN, 2, '{', '\0', ZYDIS_TOKEN_DECORATOR, 3, 'r', 'n', '\0', ZYDIS_TOKEN_PARENTHESIS_CLOSE, 0, '}', '\0' } };
static const ZydisPredefinedToken* const TOK_DECO_RN = (const ZydisPredefinedToken* const)&TOK_DATA_DECO_RN;

static const ZydisShortString STR_DECO_RN_SAE = ZYDIS_MAKE_SHORTSTRING(" {rn-sae}");
static const struct ZydisPredefinedTokenDECO_RN_SAE_
{
  ZyanU8 size;
  ZyanU8 next;
  ZyanU8 data[21];
} TOK_DATA_DECO_RN_SAE = { 21, 19, { ZYDIS_TOKEN_WHITESPACE, 2, ' ', '\0', ZYDIS_TOKEN_PARENTHESIS_OPEN, 2, '{', '\0', ZYDIS_TOKEN_DECORATOR, 7, 'r', 'n', '-', 's', 'a', 'e', '\0', ZYDIS_TOKEN_PARENTHESIS_CLOSE, 0, '}', '\0' } };
static const ZydisPredefinedToken* const TOK_DECO_RN_SAE = (const ZydisPredefinedToken* const)&TOK_DATA_DECO_RN_SAE;

static const ZydisShortString STR_DECO_RU = ZYDIS_MAKE_SHORTSTRING(" {ru}");
static const struct ZydisPredefinedTokenDECO_RU_
{
  ZyanU8 size;
  ZyanU8 next;
  ZyanU8 data[17];
} TOK_DATA_DECO_RU = { 17, 15, { ZYDIS_TOKEN_WHITESPACE, 2, ' ', '\0', ZYDIS_TOKEN_PARENTHESIS_OPEN, 2, '{', '\0', ZYDIS_TOKEN_DECORATOR, 3, 'r', 'u', '\0', ZYDIS_TOKEN_PARENTHESIS_CLOSE, 0, '}', '\0' } };
static const ZydisPredefinedToken* const TOK_DECO_RU = (const ZydisPredefinedToken* const)&TOK_DATA_DECO_RU;

static const ZydisShortString STR_DECO_RU_SAE = ZYDIS_MAKE_SHORTSTRING(" {ru-sae}");
static const struct ZydisPredefinedTokenDECO_RU_SAE_
{
  ZyanU8 size;
  ZyanU8 next;
  ZyanU8 data[21];
} TOK_DATA_DECO_RU_SAE = { 21, 19, { ZYDIS_TOKEN_WHITESPACE, 2, ' ', '\0', ZYDIS_TOKEN_PARENTHESIS_OPEN, 2, '{', '\0', ZYDIS_TOKEN_DECORATOR, 7, 'r', 'u', '-', 's', 'a', 'e', '\0', ZYDIS_TOKEN_PARENTHESIS_CLOSE, 0, '}', '\0' } };
static const ZydisPredefinedToken* const TOK_DECO_RU_SAE = (const ZydisPredefinedToken* const)&TOK_DATA_DECO_RU_SAE;

static const ZydisShortString STR_DECO_RZ = ZYDIS_MAKE_SHORTSTRING(" {rz}");
static const struct ZydisPredefinedTokenDECO_RZ_
{
  ZyanU8 size;
  ZyanU8 next;
  ZyanU8 data[17];
} TOK_DATA_DECO_RZ = { 17, 15, { ZYDIS_TOKEN_WHITESPACE, 2, ' ', '\0', ZYDIS_TOKEN_PARENTHESIS_OPEN, 2, '{', '\0', ZYDIS_TOKEN_DECORATOR, 3, 'r', 'z', '\0', ZYDIS_TOKEN_PARENTHESIS_CLOSE, 0, '}', '\0' } };
static const ZydisPredefinedToken* const TOK_DECO_RZ = (const ZydisPredefinedToken* const)&TOK_DATA_DECO_RZ;

static const ZydisShortString STR_DECO_RZ_SAE = ZYDIS_MAKE_SHORTSTRING(" {rz-sae}");
static const struct ZydisPredefinedTokenDECO_RZ_SAE_
{
  ZyanU8 size;
  ZyanU8 next;
  ZyanU8 data[21];
} TOK_DATA_DECO_RZ_SAE = { 21, 19, { ZYDIS_TOKEN_WHITESPACE, 2, ' ', '\0', ZYDIS_TOKEN_PARENTHESIS_OPEN, 2, '{', '\0', ZYDIS_TOKEN_DECORATOR, 7, 'r', 'z', '-', 's', 'a', 'e', '\0', ZYDIS_TOKEN_PARENTHESIS_CLOSE, 0, '}', '\0' } };
static const ZydisPredefinedToken* const TOK_DECO_RZ_SAE = (const ZydisPredefinedToken* const)&TOK_DATA_DECO_RZ_SAE;

static const ZydisShortString STR_DECO_SAE = ZYDIS_MAKE_SHORTSTRING(" {sae}");
static const struct ZydisPredefinedTokenDECO_SAE_
{
  ZyanU8 size;
  ZyanU8 next;
  ZyanU8 data[18];
} TOK_DATA_DECO_SAE = { 18, 16, { ZYDIS_TOKEN_WHITESPACE, 2, ' ', '\0', ZYDIS_TOKEN_PARENTHESIS_OPEN, 2, '{', '\0', ZYDIS_TOKEN_DECORATOR, 4, 's', 'a', 'e', '\0', ZYDIS_TOKEN_PARENTHESIS_CLOSE, 0, '}', '\0' } };
static const ZydisPredefinedToken* const TOK_DECO_SAE = (const ZydisPredefinedToken* const)&TOK_DATA_DECO_SAE;

static const ZydisShortString STR_DECO_SINT8 = ZYDIS_MAKE_SHORTSTRING(" {sint8}");
static const struct ZydisPredefinedTokenDECO_SINT8_
{
  ZyanU8 size;
  ZyanU8 next;
  ZyanU8 data[20];
} TOK_DATA_DECO_SINT8 = { 20, 18, { ZYDIS_TOKEN_WHITESPACE, 2, ' ', '\0', ZYDIS_TOKEN_PARENTHESIS_OPEN, 2, '{', '\0', ZYDIS_TOKEN_DECORATOR, 6, 's', 'i', 'n', 't', '8', '\0', ZYDIS_TOKEN_PARENTHESIS_CLOSE, 0, '}', '\0' } };
static const ZydisPredefinedToken* const TOK_DECO_SINT8 = (const ZydisPredefinedToken* const)&TOK_DATA_DECO_SINT8;

static const ZydisShortString STR_DECO_SINT16 = ZYDIS_MAKE_SHORTSTRING(" {sint16}");
static const struct ZydisPredefinedTokenDECO_SINT16_
{
  ZyanU8 size;
  ZyanU8 next;
  ZyanU8 data[21];
} TOK_DATA_DECO_SINT16 = { 21, 19, { ZYDIS_TOKEN_WHITESPACE, 2, ' ', '\0', ZYDIS_TOKEN_PARENTHESIS_OPEN, 2, '{', '\0', ZYDIS_TOKEN_DECORATOR, 7, 's', 'i', 'n', 't', '1', '6', '\0', ZYDIS_TOKEN_PARENTHESIS_CLOSE, 0, '}', '\0' } };
static const ZydisPredefinedToken* const TOK_DECO_SINT16 = (const ZydisPredefinedToken* const)&TOK_DATA_DECO_SINT16;

static const ZydisShortString STR_DECO_UINT8 = ZYDIS_MAKE_SHORTSTRING(" {uint8}");
static const struct ZydisPredefinedTokenDECO_UINT8_
{
  ZyanU8 size;
  ZyanU8 next;
  ZyanU8 data[20];
} TOK_DATA_DECO_UINT8 = { 20, 18, { ZYDIS_TOKEN_WHITESPACE, 2, ' ', '\0', ZYDIS_TOKEN_PARENTHESIS_OPEN, 2, '{', '\0', ZYDIS_TOKEN_DECORATOR, 6, 'u', 'i', 'n', 't', '8', '\0', ZYDIS_TOKEN_PARENTHESIS_CLOSE, 0, '}', '\0' } };
static const ZydisPredefinedToken* const TOK_DECO_UINT8 = (const ZydisPredefinedToken* const)&TOK_DATA_DECO_UINT8;

static const ZydisShortString STR_DECO_UINT16 = ZYDIS_MAKE_SHORTSTRING(" {uint16}");
static const struct ZydisPredefinedTokenDECO_UINT16_
{
  ZyanU8 size;
  ZyanU8 next;
  ZyanU8 data[21];
} TOK_DATA_DECO_UINT16 = { 21, 19, { ZYDIS_TOKEN_WHITESPACE, 2, ' ', '\0', ZYDIS_TOKEN_PARENTHESIS_OPEN, 2, '{', '\0', ZYDIS_TOKEN_DECORATOR, 7, 'u', 'i', 'n', 't', '1', '6', '\0', ZYDIS_TOKEN_PARENTHESIS_CLOSE, 0, '}', '\0' } };
static const ZydisPredefinedToken* const TOK_DECO_UINT16 = (const ZydisPredefinedToken* const)&TOK_DATA_DECO_UINT16;

static const ZydisShortString STR_DECO_ZERO = ZYDIS_MAKE_SHORTSTRING(" {z}");
static const struct ZydisPredefinedTokenDECO_ZERO_
{
  ZyanU8 size;
  ZyanU8 next;
  ZyanU8 data[16];
} TOK_DATA_DECO_ZERO = { 16, 14, { ZYDIS_TOKEN_WHITESPACE, 2, ' ', '\0', ZYDIS_TOKEN_PARENTHESIS_OPEN, 2, '{', '\0', ZYDIS_TOKEN_DECORATOR, 2, 'z', '\0', ZYDIS_TOKEN_PARENTHESIS_CLOSE, 0, '}', '\0' } };
static const ZydisPredefinedToken* const TOK_DECO_ZERO = (const ZydisPredefinedToken* const)&TOK_DATA_DECO_ZERO;

static const ZydisShortString STR_DELIM_MEMORY = ZYDIS_MAKE_SHORTSTRING(",");
static const struct ZydisPredefinedTokenDELIM_MEMORY_
{
  ZyanU8 size;
  ZyanU8 next;
  ZyanU8 data[4];
} TOK_DATA_DELIM_MEMORY = { 4, 2, { ZYDIS_TOKEN_DELIMITER, 0, ',', '\0' } };
static const ZydisPredefinedToken* const TOK_DELIM_MEMORY = (const ZydisPredefinedToken* const)&TOK_DATA_DELIM_MEMORY;

static const ZydisShortString STR_DELIM_MNEMONIC = ZYDIS_MAKE_SHORTSTRING(" ");
static const struct ZydisPredefinedTokenDELIM_MNEMONIC_
{
  ZyanU8 size;
  ZyanU8 next;
  ZyanU8 data[4];
} TOK_DATA_DELIM_MNEMONIC = { 4, 2, { ZYDIS_TOKEN_WHITESPACE, 0, ' ', '\0' } };
static const ZydisPredefinedToken* const TOK_DELIM_MNEMONIC = (const ZydisPredefinedToken* const)&TOK_DATA_DELIM_MNEMONIC;

static const ZydisShortString STR_DELIM_OPERAND = ZYDIS_MAKE_SHORTSTRING(", ");
static const struct ZydisPredefinedTokenDELIM_OPERAND_
{
  ZyanU8 size;
  ZyanU8 next;
  ZyanU8 data[8];
} TOK_DATA_DELIM_OPERAND = { 8, 6, { ZYDIS_TOKEN_DELIMITER, 2, ',', '\0', ZYDIS_TOKEN_WHITESPACE, 0, ' ', '\0' } };
static const ZydisPredefinedToken* const TOK_DELIM_OPERAND = (const ZydisPredefinedToken* const)&TOK_DATA_DELIM_OPERAND;

static const ZydisShortString STR_DELIM_SEGMENT = ZYDIS_MAKE_SHORTSTRING(":");
static const struct ZydisPredefinedTokenDELIM_SEGMENT_
{
  ZyanU8 size;
  ZyanU8 next;
  ZyanU8 data[4];
} TOK_DATA_DELIM_SEGMENT = { 4, 2, { ZYDIS_TOKEN_DELIMITER, 0, ':', '\0' } };
static const ZydisPredefinedToken* const TOK_DELIM_SEGMENT = (const ZydisPredefinedToken* const)&TOK_DATA_DELIM_SEGMENT;

static const ZydisShortString STR_FAR = ZYDIS_MAKE_SHORTSTRING(" far");
static const ZydisShortString STR_FAR_ATT = ZYDIS_MAKE_SHORTSTRING("l");
static const ZydisShortString STR_IMMEDIATE = ZYDIS_MAKE_SHORTSTRING("$");
static const struct ZydisPredefinedTokenIMMEDIATE_
{
  ZyanU8 size;
  ZyanU8 next;
  ZyanU8 data[4];
} TOK_DATA_IMMEDIATE = { 4, 2, { ZYDIS_TOKEN_IMMEDIATE, 0, '$', '\0' } };
static const ZydisPredefinedToken* const TOK_IMMEDIATE = (const ZydisPredefinedToken* const)&TOK_DATA_IMMEDIATE;

static const ZydisShortString STR_INVALID_MNEMONIC = ZYDIS_MAKE_SHORTSTRING("invalid");
static const struct ZydisPredefinedTokenINVALID_MNEMONIC_
{
  ZyanU8 size;
  ZyanU8 next;
  ZyanU8 data[10];
} TOK_DATA_INVALID_MNEMONIC = { 10, 2, { ZYDIS_TOKEN_MNEMONIC, 0, 'i', 'n', 'v', 'a', 'l', 'i', 'd', '\0' } };
static const ZydisPredefinedToken* const TOK_INVALID_MNEMONIC = (const ZydisPredefinedToken* const)&TOK_DATA_INVALID_MNEMONIC;

static const ZydisShortString STR_INVALID_REG = ZYDIS_MAKE_SHORTSTRING("invalid");
static const struct ZydisPredefinedTokenINVALID_REG_
{
  ZyanU8 size;
  ZyanU8 next;
  ZyanU8 data[10];
} TOK_DATA_INVALID_REG = { 10, 2, { ZYDIS_TOKEN_REGISTER, 0, 'i', 'n', 'v', 'a', 'l', 'i', 'd', '\0' } };
static const ZydisPredefinedToken* const TOK_INVALID_REG = (const ZydisPredefinedToken* const)&TOK_DATA_INVALID_REG;

static const ZydisShortString STR_MEMORY_BEGIN_ATT = ZYDIS_MAKE_SHORTSTRING("(");
static const struct ZydisPredefinedTokenMEMORY_BEGIN_ATT_
{
  ZyanU8 size;
  ZyanU8 next;
  ZyanU8 data[4];
} TOK_DATA_MEMORY_BEGIN_ATT = { 4, 2, { ZYDIS_TOKEN_PARENTHESIS_OPEN, 0, '(', '\0' } };
static const ZydisPredefinedToken* const TOK_MEMORY_BEGIN_ATT = (const ZydisPredefinedToken* const)&TOK_DATA_MEMORY_BEGIN_ATT;

static const ZydisShortString STR_MEMORY_BEGIN_INTEL = ZYDIS_MAKE_SHORTSTRING("[");
static const struct ZydisPredefinedTokenMEMORY_BEGIN_INTEL_
{
  ZyanU8 size;
  ZyanU8 next;
  ZyanU8 data[4];
} TOK_DATA_MEMORY_BEGIN_INTEL = { 4, 2, { ZYDIS_TOKEN_PARENTHESIS_OPEN, 0, '[', '\0' } };
static const ZydisPredefinedToken* const TOK_MEMORY_BEGIN_INTEL = (const ZydisPredefinedToken* const)&TOK_DATA_MEMORY_BEGIN_INTEL;

static const ZydisShortString STR_MEMORY_END_ATT = ZYDIS_MAKE_SHORTSTRING(")");
static const struct ZydisPredefinedTokenMEMORY_END_ATT_
{
  ZyanU8 size;
  ZyanU8 next;
  ZyanU8 data[4];
} TOK_DATA_MEMORY_END_ATT = { 4, 2, { ZYDIS_TOKEN_PARENTHESIS_CLOSE, 0, ')', '\0' } };
static const ZydisPredefinedToken* const TOK_MEMORY_END_ATT = (const ZydisPredefinedToken* const)&TOK_DATA_MEMORY_END_ATT;

static const ZydisShortString STR_MEMORY_END_INTEL = ZYDIS_MAKE_SHORTSTRING("]");
static const struct ZydisPredefinedTokenMEMORY_END_INTEL_
{
  ZyanU8 size;
  ZyanU8 next;
  ZyanU8 data[4];
} TOK_DATA_MEMORY_END_INTEL = { 4, 2, { ZYDIS_TOKEN_PARENTHESIS_CLOSE, 0, ']', '\0' } };
static const ZydisPredefinedToken* const TOK_MEMORY_END_INTEL = (const ZydisPredefinedToken* const)&TOK_DATA_MEMORY_END_INTEL;

static const ZydisShortString STR_MUL = ZYDIS_MAKE_SHORTSTRING("*");
static const struct ZydisPredefinedTokenMUL_
{
  ZyanU8 size;
  ZyanU8 next;
  ZyanU8 data[4];
} TOK_DATA_MUL = { 4, 2, { ZYDIS_TOKEN_DELIMITER, 0, '*', '\0' } };
static const ZydisPredefinedToken* const TOK_MUL = (const ZydisPredefinedToken* const)&TOK_DATA_MUL;

static const ZydisShortString STR_NEAR = ZYDIS_MAKE_SHORTSTRING(" near");
static const ZydisShortString STR_PREF_BND = ZYDIS_MAKE_SHORTSTRING("bnd ");
static const struct ZydisPredefinedTokenPREF_BND_
{
  ZyanU8 size;
  ZyanU8 next;
  ZyanU8 data[10];
} TOK_DATA_PREF_BND = { 10, 8, { ZYDIS_TOKEN_PREFIX, 4, 'b', 'n', 'd', '\0', ZYDIS_TOKEN_WHITESPACE, 0, ' ', '\0' } };
static const ZydisPredefinedToken* const TOK_PREF_BND = (const ZydisPredefinedToken* const)&TOK_DATA_PREF_BND;

static const ZydisShortString STR_PREF_LOCK = ZYDIS_MAKE_SHORTSTRING("lock ");
static const struct ZydisPredefinedTokenPREF_LOCK_
{
  ZyanU8 size;
  ZyanU8 next;
  ZyanU8 data[11];
} TOK_DATA_PREF_LOCK = { 11, 9, { ZYDIS_TOKEN_PREFIX, 5, 'l', 'o', 'c', 'k', '\0', ZYDIS_TOKEN_WHITESPACE, 0, ' ', '\0' } };
static const ZydisPredefinedToken* const TOK_PREF_LOCK = (const ZydisPredefinedToken* const)&TOK_DATA_PREF_LOCK;

static const ZydisShortString STR_PREF_REP = ZYDIS_MAKE_SHORTSTRING("rep ");
static const struct ZydisPredefinedTokenPREF_REP_
{
  ZyanU8 size;
  ZyanU8 next;
  ZyanU8 data[10];
} TOK_DATA_PREF_REP = { 10, 8, { ZYDIS_TOKEN_PREFIX, 4, 'r', 'e', 'p', '\0', ZYDIS_TOKEN_WHITESPACE, 0, ' ', '\0' } };
static const ZydisPredefinedToken* const TOK_PREF_REP = (const ZydisPredefinedToken* const)&TOK_DATA_PREF_REP;

static const ZydisShortString STR_PREF_REPE = ZYDIS_MAKE_SHORTSTRING("repe ");
static const struct ZydisPredefinedTokenPREF_REPE_
{
  ZyanU8 size;
  ZyanU8 next;
  ZyanU8 data[11];
} TOK_DATA_PREF_REPE = { 11, 9, { ZYDIS_TOKEN_PREFIX, 5, 'r', 'e', 'p', 'e', '\0', ZYDIS_TOKEN_WHITESPACE, 0, ' ', '\0' } };
static const ZydisPredefinedToken* const TOK_PREF_REPE = (const ZydisPredefinedToken* const)&TOK_DATA_PREF_REPE;

static const ZydisShortString STR_PREF_REPNE = ZYDIS_MAKE_SHORTSTRING("repne ");
static const struct ZydisPredefinedTokenPREF_REPNE_
{
  ZyanU8 size;
  ZyanU8 next;
  ZyanU8 data[12];
} TOK_DATA_PREF_REPNE = { 12, 10, { ZYDIS_TOKEN_PREFIX, 6, 'r', 'e', 'p', 'n', 'e', '\0', ZYDIS_TOKEN_WHITESPACE, 0, ' ', '\0' } };
static const ZydisPredefinedToken* const TOK_PREF_REPNE = (const ZydisPredefinedToken* const)&TOK_DATA_PREF_REPNE;

static const ZydisShortString STR_PREF_REX_4A = ZYDIS_MAKE_SHORTSTRING("rex.wx ");
static const struct ZydisPredefinedTokenPREF_REX_4A_
{
  ZyanU8 size;
  ZyanU8 next;
  ZyanU8 data[13];
} TOK_DATA_PREF_REX_4A = { 13, 11, { ZYDIS_TOKEN_PREFIX, 7, 'r', 'e', 'x', '.', 'w', 'x', '\0', ZYDIS_TOKEN_WHITESPACE, 0, ' ', '\0' } };
static const ZydisPredefinedToken* const TOK_PREF_REX_4A = (const ZydisPredefinedToken* const)&TOK_DATA_PREF_REX_4A;

static const ZydisShortString STR_PREF_REX_4B = ZYDIS_MAKE_SHORTSTRING("rex.wxb ");
static const struct ZydisPredefinedTokenPREF_REX_4B_
{
  ZyanU8 size;
  ZyanU8 next;
  ZyanU8 data[14];
} TOK_DATA_PREF_REX_4B = { 14, 12, { ZYDIS_TOKEN_PREFIX, 8, 'r', 'e', 'x', '.', 'w', 'x', 'b', '\0', ZYDIS_TOKEN_WHITESPACE, 0, ' ', '\0' } };
static const ZydisPredefinedToken* const TOK_PREF_REX_4B = (const ZydisPredefinedToken* const)&TOK_DATA_PREF_REX_4B;

static const ZydisShortString STR_PREF_REX_4C = ZYDIS_MAKE_SHORTSTRING("rex.wr ");
static const struct ZydisPredefinedTokenPREF_REX_4C_
{
  ZyanU8 size;
  ZyanU8 next;
  ZyanU8 data[13];
} TOK_DATA_PREF_REX_4C = { 13, 11, { ZYDIS_TOKEN_PREFIX, 7, 'r', 'e', 'x', '.', 'w', 'r', '\0', ZYDIS_TOKEN_WHITESPACE, 0, ' ', '\0' } };
static const ZydisPredefinedToken* const TOK_PREF_REX_4C = (const ZydisPredefinedToken* const)&TOK_DATA_PREF_REX_4C;

static const ZydisShortString STR_PREF_REX_4D = ZYDIS_MAKE_SHORTSTRING("rex.wrb ");
static const struct ZydisPredefinedTokenPREF_REX_4D_
{
  ZyanU8 size;
  ZyanU8 next;
  ZyanU8 data[14];
} TOK_DATA_PREF_REX_4D = { 14, 12, { ZYDIS_TOKEN_PREFIX, 8, 'r', 'e', 'x', '.', 'w', 'r', 'b', '\0', ZYDIS_TOKEN_WHITESPACE, 0, ' ', '\0' } };
static const ZydisPredefinedToken* const TOK_PREF_REX_4D = (const ZydisPredefinedToken* const)&TOK_DATA_PREF_REX_4D;

static const ZydisShortString STR_PREF_REX_4E = ZYDIS_MAKE_SHORTSTRING("rex.wrx ");
static const struct ZydisPredefinedTokenPREF_REX_4E_
{
  ZyanU8 size;
  ZyanU8 next;
  ZyanU8 data[14];
} TOK_DATA_PREF_REX_4E = { 14, 12, { ZYDIS_TOKEN_PREFIX, 8, 'r', 'e', 'x', '.', 'w', 'r', 'x', '\0', ZYDIS_TOKEN_WHITESPACE, 0, ' ', '\0' } };
static const ZydisPredefinedToken* const TOK_PREF_REX_4E = (const ZydisPredefinedToken* const)&TOK_DATA_PREF_REX_4E;

static const ZydisShortString STR_PREF_REX_4F = ZYDIS_MAKE_SHORTSTRING("rex.wrxb ");
static const struct ZydisPredefinedTokenPREF_REX_4F_
{
  ZyanU8 size;
  ZyanU8 next;
  ZyanU8 data[15];
} TOK_DATA_PREF_REX_4F = { 15, 13, { ZYDIS_TOKEN_PREFIX, 9, 'r', 'e', 'x', '.', 'w', 'r', 'x', 'b', '\0', ZYDIS_TOKEN_WHITESPACE, 0, ' ', '\0' } };
static const ZydisPredefinedToken* const TOK_PREF_REX_4F = (const ZydisPredefinedToken* const)&TOK_DATA_PREF_REX_4F;

static const ZydisShortString STR_PREF_REX_40 = ZYDIS_MAKE_SHORTSTRING("rex ");
static const struct ZydisPredefinedTokenPREF_REX_40_
{
  ZyanU8 size;
  ZyanU8 next;
  ZyanU8 data[10];
} TOK_DATA_PREF_REX_40 = { 10, 8, { ZYDIS_TOKEN_PREFIX, 4, 'r', 'e', 'x', '\0', ZYDIS_TOKEN_WHITESPACE, 0, ' ', '\0' } };
static const ZydisPredefinedToken* const TOK_PREF_REX_40 = (const ZydisPredefinedToken* const)&TOK_DATA_PREF_REX_40;

static const ZydisShortString STR_PREF_REX_41 = ZYDIS_MAKE_SHORTSTRING("rex.b ");
static const struct ZydisPredefinedTokenPREF_REX_41_
{
  ZyanU8 size;
  ZyanU8 next;
  ZyanU8 data[12];
} TOK_DATA_PREF_REX_41 = { 12, 10, { ZYDIS_TOKEN_PREFIX, 6, 'r', 'e', 'x', '.', 'b', '\0', ZYDIS_TOKEN_WHITESPACE, 0, ' ', '\0' } };
static const ZydisPredefinedToken* const TOK_PREF_REX_41 = (const ZydisPredefinedToken* const)&TOK_DATA_PREF_REX_41;

static const ZydisShortString STR_PREF_REX_42 = ZYDIS_MAKE_SHORTSTRING("rex.x ");
static const struct ZydisPredefinedTokenPREF_REX_42_
{
  ZyanU8 size;
  ZyanU8 next;
  ZyanU8 data[12];
} TOK_DATA_PREF_REX_42 = { 12, 10, { ZYDIS_TOKEN_PREFIX, 6, 'r', 'e', 'x', '.', 'x', '\0', ZYDIS_TOKEN_WHITESPACE, 0, ' ', '\0' } };
static const ZydisPredefinedToken* const TOK_PREF_REX_42 = (const ZydisPredefinedToken* const)&TOK_DATA_PREF_REX_42;

static const ZydisShortString STR_PREF_REX_43 = ZYDIS_MAKE_SHORTSTRING("rex.xb ");
static const struct ZydisPredefinedTokenPREF_REX_43_
{
  ZyanU8 size;
  ZyanU8 next;
  ZyanU8 data[13];
} TOK_DATA_PREF_REX_43 = { 13, 11, { ZYDIS_TOKEN_PREFIX, 7, 'r', 'e', 'x', '.', 'x', 'b', '\0', ZYDIS_TOKEN_WHITESPACE, 0, ' ', '\0' } };
static const ZydisPredefinedToken* const TOK_PREF_REX_43 = (const ZydisPredefinedToken* const)&TOK_DATA_PREF_REX_43;

static const ZydisShortString STR_PREF_REX_44 = ZYDIS_MAKE_SHORTSTRING("rex.r ");
static const struct ZydisPredefinedTokenPREF_REX_44_
{
  ZyanU8 size;
  ZyanU8 next;
  ZyanU8 data[12];
} TOK_DATA_PREF_REX_44 = { 12, 10, { ZYDIS_TOKEN_PREFIX, 6, 'r', 'e', 'x', '.', 'r', '\0', ZYDIS_TOKEN_WHITESPACE, 0, ' ', '\0' } };
static const ZydisPredefinedToken* const TOK_PREF_REX_44 = (const ZydisPredefinedToken* const)&TOK_DATA_PREF_REX_44;

static const ZydisShortString STR_PREF_REX_45 = ZYDIS_MAKE_SHORTSTRING("rex.rb ");
static const struct ZydisPredefinedTokenPREF_REX_45_
{
  ZyanU8 size;
  ZyanU8 next;
  ZyanU8 data[13];
} TOK_DATA_PREF_REX_45 = { 13, 11, { ZYDIS_TOKEN_PREFIX, 7, 'r', 'e', 'x', '.', 'r', 'b', '\0', ZYDIS_TOKEN_WHITESPACE, 0, ' ', '\0' } };
static const ZydisPredefinedToken* const TOK_PREF_REX_45 = (const ZydisPredefinedToken* const)&TOK_DATA_PREF_REX_45;

static const ZydisShortString STR_PREF_REX_46 = ZYDIS_MAKE_SHORTSTRING("rex.rx ");
static const struct ZydisPredefinedTokenPREF_REX_46_
{
  ZyanU8 size;
  ZyanU8 next;
  ZyanU8 data[13];
} TOK_DATA_PREF_REX_46 = { 13, 11, { ZYDIS_TOKEN_PREFIX, 7, 'r', 'e', 'x', '.', 'r', 'x', '\0', ZYDIS_TOKEN_WHITESPACE, 0, ' ', '\0' } };
static const ZydisPredefinedToken* const TOK_PREF_REX_46 = (const ZydisPredefinedToken* const)&TOK_DATA_PREF_REX_46;

static const ZydisShortString STR_PREF_REX_47 = ZYDIS_MAKE_SHORTSTRING("rex.rxb ");
static const struct ZydisPredefinedTokenPREF_REX_47_
{
  ZyanU8 size;
  ZyanU8 next;
  ZyanU8 data[14];
} TOK_DATA_PREF_REX_47 = { 14, 12, { ZYDIS_TOKEN_PREFIX, 8, 'r', 'e', 'x', '.', 'r', 'x', 'b', '\0', ZYDIS_TOKEN_WHITESPACE, 0, ' ', '\0' } };
static const ZydisPredefinedToken* const TOK_PREF_REX_47 = (const ZydisPredefinedToken* const)&TOK_DATA_PREF_REX_47;

static const ZydisShortString STR_PREF_REX_48 = ZYDIS_MAKE_SHORTSTRING("rex.w ");
static const struct ZydisPredefinedTokenPREF_REX_48_
{
  ZyanU8 size;
  ZyanU8 next;
  ZyanU8 data[12];
} TOK_DATA_PREF_REX_48 = { 12, 10, { ZYDIS_TOKEN_PREFIX, 6, 'r', 'e', 'x', '.', 'w', '\0', ZYDIS_TOKEN_WHITESPACE, 0, ' ', '\0' } };
static const ZydisPredefinedToken* const TOK_PREF_REX_48 = (const ZydisPredefinedToken* const)&TOK_DATA_PREF_REX_48;

static const ZydisShortString STR_PREF_REX_49 = ZYDIS_MAKE_SHORTSTRING("rex.wb ");
static const struct ZydisPredefinedTokenPREF_REX_49_
{
  ZyanU8 size;
  ZyanU8 next;
  ZyanU8 data[13];
} TOK_DATA_PREF_REX_49 = { 13, 11, { ZYDIS_TOKEN_PREFIX, 7, 'r', 'e', 'x', '.', 'w', 'b', '\0', ZYDIS_TOKEN_WHITESPACE, 0, ' ', '\0' } };
static const ZydisPredefinedToken* const TOK_PREF_REX_49 = (const ZydisPredefinedToken* const)&TOK_DATA_PREF_REX_49;

static const ZydisShortString STR_PREF_SEG_CS = ZYDIS_MAKE_SHORTSTRING("cs ");
static const struct ZydisPredefinedTokenPREF_SEG_CS_
{
  ZyanU8 size;
  ZyanU8 next;
  ZyanU8 data[9];
} TOK_DATA_PREF_SEG_CS = { 9, 7, { ZYDIS_TOKEN_PREFIX, 3, 'c', 's', '\0', ZYDIS_TOKEN_WHITESPACE, 0, ' ', '\0' } };
static const ZydisPredefinedToken* const TOK_PREF_SEG_CS = (const ZydisPredefinedToken* const)&TOK_DATA_PREF_SEG_CS;

static const ZydisShortString STR_PREF_SEG_DS = ZYDIS_MAKE_SHORTSTRING("ds ");
static const struct ZydisPredefinedTokenPREF_SEG_DS_
{
  ZyanU8 size;
  ZyanU8 next;
  ZyanU8 data[9];
} TOK_DATA_PREF_SEG_DS = { 9, 7, { ZYDIS_TOKEN_PREFIX, 3, 'd', 's', '\0', ZYDIS_TOKEN_WHITESPACE, 0, ' ', '\0' } };
static const ZydisPredefinedToken* const TOK_PREF_SEG_DS = (const ZydisPredefinedToken* const)&TOK_DATA_PREF_SEG_DS;

static const ZydisShortString STR_PREF_SEG_ES = ZYDIS_MAKE_SHORTSTRING("es ");
static const struct ZydisPredefinedTokenPREF_SEG_ES_
{
  ZyanU8 size;
  ZyanU8 next;
  ZyanU8 data[9];
} TOK_DATA_PREF_SEG_ES = { 9, 7, { ZYDIS_TOKEN_PREFIX, 3, 'e', 's', '\0', ZYDIS_TOKEN_WHITESPACE, 0, ' ', '\0' } };
static const ZydisPredefinedToken* const TOK_PREF_SEG_ES = (const ZydisPredefinedToken* const)&TOK_DATA_PREF_SEG_ES;

static const ZydisShortString STR_PREF_SEG_FS = ZYDIS_MAKE_SHORTSTRING("fs ");
static const struct ZydisPredefinedTokenPREF_SEG_FS_
{
  ZyanU8 size;
  ZyanU8 next;
  ZyanU8 data[9];
} TOK_DATA_PREF_SEG_FS = { 9, 7, { ZYDIS_TOKEN_PREFIX, 3, 'f', 's', '\0', ZYDIS_TOKEN_WHITESPACE, 0, ' ', '\0' } };
static const ZydisPredefinedToken* const TOK_PREF_SEG_FS = (const ZydisPredefinedToken* const)&TOK_DATA_PREF_SEG_FS;

static const ZydisShortString STR_PREF_SEG_GS = ZYDIS_MAKE_SHORTSTRING("gs ");
static const struct ZydisPredefinedTokenPREF_SEG_GS_
{
  ZyanU8 size;
  ZyanU8 next;
  ZyanU8 data[9];
} TOK_DATA_PREF_SEG_GS = { 9, 7, { ZYDIS_TOKEN_PREFIX, 3, 'g', 's', '\0', ZYDIS_TOKEN_WHITESPACE, 0, ' ', '\0' } };
static const ZydisPredefinedToken* const TOK_PREF_SEG_GS = (const ZydisPredefinedToken* const)&TOK_DATA_PREF_SEG_GS;

static const ZydisShortString STR_PREF_SEG_SS = ZYDIS_MAKE_SHORTSTRING("ss ");
static const struct ZydisPredefinedTokenPREF_SEG_SS_
{
  ZyanU8 size;
  ZyanU8 next;
  ZyanU8 data[9];
} TOK_DATA_PREF_SEG_SS = { 9, 7, { ZYDIS_TOKEN_PREFIX, 3, 's', 's', '\0', ZYDIS_TOKEN_WHITESPACE, 0, ' ', '\0' } };
static const ZydisPredefinedToken* const TOK_PREF_SEG_SS = (const ZydisPredefinedToken* const)&TOK_DATA_PREF_SEG_SS;

static const ZydisShortString STR_PREF_XACQUIRE = ZYDIS_MAKE_SHORTSTRING("xacquire ");
static const struct ZydisPredefinedTokenPREF_XACQUIRE_
{
  ZyanU8 size;
  ZyanU8 next;
  ZyanU8 data[15];
} TOK_DATA_PREF_XACQUIRE = { 15, 13, { ZYDIS_TOKEN_PREFIX, 9, 'x', 'a', 'c', 'q', 'u', 'i', 'r', 'e', '\0', ZYDIS_TOKEN_WHITESPACE, 0, ' ', '\0' } };
static const ZydisPredefinedToken* const TOK_PREF_XACQUIRE = (const ZydisPredefinedToken* const)&TOK_DATA_PREF_XACQUIRE;

static const ZydisShortString STR_PREF_XRELEASE = ZYDIS_MAKE_SHORTSTRING("xrelease ");
static const struct ZydisPredefinedTokenPREF_XRELEASE_
{
  ZyanU8 size;
  ZyanU8 next;
  ZyanU8 data[15];
} TOK_DATA_PREF_XRELEASE = { 15, 13, { ZYDIS_TOKEN_PREFIX, 9, 'x', 'r', 'e', 'l', 'e', 'a', 's', 'e', '\0', ZYDIS_TOKEN_WHITESPACE, 0, ' ', '\0' } };
static const ZydisPredefinedToken* const TOK_PREF_XRELEASE = (const ZydisPredefinedToken* const)&TOK_DATA_PREF_XRELEASE;

static const ZydisShortString STR_PREF_NOTRACK = ZYDIS_MAKE_SHORTSTRING("notrack ");
static const struct ZydisPredefinedTokenPREF_NOTRACK_
{
  ZyanU8 size;
  ZyanU8 next;
  ZyanU8 data[14];
} TOK_DATA_PREF_NOTRACK = { 14, 12, { ZYDIS_TOKEN_PREFIX, 8, 'n', 'o', 't', 'r', 'a', 'c', 'k', '\0', ZYDIS_TOKEN_WHITESPACE, 0, ' ', '\0' } };
static const ZydisPredefinedToken* const TOK_PREF_NOTRACK = (const ZydisPredefinedToken* const)&TOK_DATA_PREF_NOTRACK;

static const ZydisShortString STR_REGISTER = ZYDIS_MAKE_SHORTSTRING("%");
static const struct ZydisPredefinedTokenREGISTER_
{
  ZyanU8 size;
  ZyanU8 next;
  ZyanU8 data[4];
} TOK_DATA_REGISTER = { 4, 2, { ZYDIS_TOKEN_REGISTER, 0, '%', '\0' } };
static const ZydisPredefinedToken* const TOK_REGISTER = (const ZydisPredefinedToken* const)&TOK_DATA_REGISTER;

static const ZydisShortString STR_SHORT = ZYDIS_MAKE_SHORTSTRING(" short");
static const ZydisShortString STR_SIZE_8_ATT = ZYDIS_MAKE_SHORTSTRING("b");
static const ZydisShortString STR_SIZE_8_INTEL = ZYDIS_MAKE_SHORTSTRING("byte ptr ");
static const struct ZydisPredefinedTokenSIZE_8_INTEL_
{
  ZyanU8 size;
  ZyanU8 next;
  ZyanU8 data[15];
} TOK_DATA_SIZE_8_INTEL = { 15, 13, { ZYDIS_TOKEN_TYPECAST, 9, 'b', 'y', 't', 'e', ' ', 'p', 't', 'r', '\0', ZYDIS_TOKEN_WHITESPACE, 0, ' ', '\0' } };
static const ZydisPredefinedToken* const TOK_SIZE_8_INTEL = (const ZydisPredefinedToken* const)&TOK_DATA_SIZE_8_INTEL;

static const ZydisShortString STR_SIZE_16_ATT = ZYDIS_MAKE_SHORTSTRING("w");
static const ZydisShortString STR_SIZE_16_INTEL = ZYDIS_MAKE_SHORTSTRING("word ptr ");
static const struct ZydisPredefinedTokenSIZE_16_INTEL_
{
  ZyanU8 size;
  ZyanU8 next;
  ZyanU8 data[15];
} TOK_DATA_SIZE_16_INTEL = { 15, 13, { ZYDIS_TOKEN_TYPECAST, 9, 'w', 'o', 'r', 'd', ' ', 'p', 't', 'r', '\0', ZYDIS_TOKEN_WHITESPACE, 0, ' ', '\0' } };
static const ZydisPredefinedToken* const TOK_SIZE_16_INTEL = (const ZydisPredefinedToken* const)&TOK_DATA_SIZE_16_INTEL;

static const ZydisShortString STR_SIZE_32_ATT = ZYDIS_MAKE_SHORTSTRING("l");
static const ZydisShortString STR_SIZE_32_INTEL = ZYDIS_MAKE_SHORTSTRING("dword ptr ");
static const struct ZydisPredefinedTokenSIZE_32_INTEL_
{
  ZyanU8 size;
  ZyanU8 next;
  ZyanU8 data[16];
} TOK_DATA_SIZE_32_INTEL = { 16, 14, { ZYDIS_TOKEN_TYPECAST, 10, 'd', 'w', 'o', 'r', 'd', ' ', 'p', 't', 'r', '\0', ZYDIS_TOKEN_WHITESPACE, 0, ' ', '\0' } };
static const ZydisPredefinedToken* const TOK_SIZE_32_INTEL = (const ZydisPredefinedToken* const)&TOK_DATA_SIZE_32_INTEL;

static const ZydisShortString STR_SIZE_48 = ZYDIS_MAKE_SHORTSTRING("fword ptr ");
static const struct ZydisPredefinedTokenSIZE_48_
{
  ZyanU8 size;
  ZyanU8 next;
  ZyanU8 data[16];
} TOK_DATA_SIZE_48 = { 16, 14, { ZYDIS_TOKEN_TYPECAST, 10, 'f', 'w', 'o', 'r', 'd', ' ', 'p', 't', 'r', '\0', ZYDIS_TOKEN_WHITESPACE, 0, ' ', '\0' } };
static const ZydisPredefinedToken* const TOK_SIZE_48 = (const ZydisPredefinedToken* const)&TOK_DATA_SIZE_48;

static const ZydisShortString STR_SIZE_64_ATT = ZYDIS_MAKE_SHORTSTRING("q");
static const ZydisShortString STR_SIZE_64_INTEL = ZYDIS_MAKE_SHORTSTRING("qword ptr ");
static const struct ZydisPredefinedTokenSIZE_64_INTEL_
{
  ZyanU8 size;
  ZyanU8 next;
  ZyanU8 data[16];
} TOK_DATA_SIZE_64_INTEL = { 16, 14, { ZYDIS_TOKEN_TYPECAST, 10, 'q', 'w', 'o', 'r', 'd', ' ', 'p', 't', 'r', '\0', ZYDIS_TOKEN_WHITESPACE, 0, ' ', '\0' } };
static const ZydisPredefinedToken* const TOK_SIZE_64_INTEL = (const ZydisPredefinedToken* const)&TOK_DATA_SIZE_64_INTEL;

static const ZydisShortString STR_SIZE_80 = ZYDIS_MAKE_SHORTSTRING("tbyte ptr ");
static const struct ZydisPredefinedTokenSIZE_80_
{
  ZyanU8 size;
  ZyanU8 next;
  ZyanU8 data[16];
} TOK_DATA_SIZE_80 = { 16, 14, { ZYDIS_TOKEN_TYPECAST, 10, 't', 'b', 'y', 't', 'e', ' ', 'p', 't', 'r', '\0', ZYDIS_TOKEN_WHITESPACE, 0, ' ', '\0' } };
static const ZydisPredefinedToken* const TOK_SIZE_80 = (const ZydisPredefinedToken* const)&TOK_DATA_SIZE_80;

static const ZydisShortString STR_SIZE_128_ATT = ZYDIS_MAKE_SHORTSTRING("x");
static const ZydisShortString STR_SIZE_128_INTEL = ZYDIS_MAKE_SHORTSTRING("xmmword ptr ");
static const struct ZydisPredefinedTokenSIZE_128_INTEL_
{
  ZyanU8 size;
  ZyanU8 next;
  ZyanU8 data[18];
} TOK_DATA_SIZE_128_INTEL = { 18, 16, { ZYDIS_TOKEN_TYPECAST, 12, 'x', 'm', 'm', 'w', 'o', 'r', 'd', ' ', 'p', 't', 'r', '\0', ZYDIS_TOKEN_WHITESPACE, 0, ' ', '\0' } };
static const ZydisPredefinedToken* const TOK_SIZE_128_INTEL = (const ZydisPredefinedToken* const)&TOK_DATA_SIZE_128_INTEL;

static const ZydisShortString STR_SIZE_256_ATT = ZYDIS_MAKE_SHORTSTRING("y");
static const ZydisShortString STR_SIZE_256_INTEL = ZYDIS_MAKE_SHORTSTRING("ymmword ptr ");
static const struct ZydisPredefinedTokenSIZE_256_INTEL_
{
  ZyanU8 size;
  ZyanU8 next;
  ZyanU8 data[18];
} TOK_DATA_SIZE_256_INTEL = { 18, 16, { ZYDIS_TOKEN_TYPECAST, 12, 'y', 'm', 'm', 'w', 'o', 'r', 'd', ' ', 'p', 't', 'r', '\0', ZYDIS_TOKEN_WHITESPACE, 0, ' ', '\0' } };
static const ZydisPredefinedToken* const TOK_SIZE_256_INTEL = (const ZydisPredefinedToken* const)&TOK_DATA_SIZE_256_INTEL;

static const ZydisShortString STR_SIZE_512_ATT = ZYDIS_MAKE_SHORTSTRING("z");
static const ZydisShortString STR_SIZE_512_INTEL = ZYDIS_MAKE_SHORTSTRING("zmmword ptr ");
static const struct ZydisPredefinedTokenSIZE_512_INTEL_
{
  ZyanU8 size;
  ZyanU8 next;
  ZyanU8 data[18];
} TOK_DATA_SIZE_512_INTEL = { 18, 16, { ZYDIS_TOKEN_TYPECAST, 12, 'z', 'm', 'm', 'w', 'o', 'r', 'd', ' ', 'p', 't', 'r', '\0', ZYDIS_TOKEN_WHITESPACE, 0, ' ', '\0' } };
static const ZydisPredefinedToken* const TOK_SIZE_512_INTEL = (const ZydisPredefinedToken* const)&TOK_DATA_SIZE_512_INTEL;

static const ZydisShortString STR_SUB = ZYDIS_MAKE_SHORTSTRING("-");
static const struct ZydisPredefinedTokenSUB_
{
  ZyanU8 size;
  ZyanU8 next;
  ZyanU8 data[4];
} TOK_DATA_SUB = { 4, 2, { ZYDIS_TOKEN_DELIMITER, 0, '-', '\0' } };
static const ZydisPredefinedToken* const TOK_SUB = (const ZydisPredefinedToken* const)&TOK_DATA_SUB;

static const ZydisShortString STR_WHITESPACE = ZYDIS_MAKE_SHORTSTRING(" ");
#pragma pack(pop)

/* ============================================================================================== */
/* Formatter functions                                                                            */
/* ============================================================================================== */

/* ---------------------------------------------------------------------------------------------- */
/* Instruction                                                                                    */
/* ---------------------------------------------------------------------------------------------- */

ZyanStatus ZydisFormatterATTFormatInstruction(const ZydisFormatter* formatter,
    ZydisFormatterBuffer* buffer, ZydisFormatterContext* context)
{
    ZYAN_ASSERT(formatter);
    ZYAN_ASSERT(buffer);
    ZYAN_ASSERT(context);
    ZYAN_ASSERT(context->instruction);
    ZYAN_ASSERT(context->operands);

    ZYAN_CHECK(formatter->func_print_prefixes(formatter, buffer, context));
    ZYAN_CHECK(formatter->func_print_mnemonic(formatter, buffer, context));

    ZyanUPointer state_mnemonic;
    ZYDIS_BUFFER_REMEMBER(buffer, state_mnemonic);

    const ZyanI8 c = (ZyanI8)context->instruction->operand_count_visible - 1;
    for (ZyanI8 i = c; i >= 0; --i)
    {
        const ZydisDecodedOperand* const operand = &context->operands[i];

        // Print embedded-mask registers as decorator instead of a regular operand
        if ((i == 1) && (operand->type == ZYDIS_OPERAND_TYPE_REGISTER) &&
            (operand->encoding == ZYDIS_OPERAND_ENCODING_MASK))
        {
            continue;
        }

        ZyanUPointer buffer_state;
        ZYDIS_BUFFER_REMEMBER(buffer, buffer_state);

        if (buffer_state != state_mnemonic)
        {
            ZYDIS_BUFFER_APPEND(buffer, DELIM_OPERAND);
        } else
        {
            ZYDIS_BUFFER_APPEND(buffer, DELIM_MNEMONIC);
        }

        // Set current operand
        context->operand = operand;

        ZyanStatus status;
        if (formatter->func_pre_operand)
        {
            status = formatter->func_pre_operand(formatter, buffer, context);
            if (status == ZYDIS_STATUS_SKIP_TOKEN)
            {
                ZYAN_CHECK(ZydisFormatterBufferRestore(buffer, buffer_state));
                continue;
            }
            if (!ZYAN_SUCCESS(status))
            {
                return status;
            }
        }

        switch (operand->type)
        {
        case ZYDIS_OPERAND_TYPE_REGISTER:
            status = formatter->func_format_operand_reg(formatter, buffer, context);
            break;
        case ZYDIS_OPERAND_TYPE_MEMORY:
            status = formatter->func_format_operand_mem(formatter, buffer, context);
            break;
        case ZYDIS_OPERAND_TYPE_POINTER:
            status = formatter->func_format_operand_ptr(formatter, buffer, context);
            break;
        case ZYDIS_OPERAND_TYPE_IMMEDIATE:
            status = formatter->func_format_operand_imm(formatter, buffer, context);
            break;
        default:
            return ZYAN_STATUS_INVALID_ARGUMENT;
        }
        if (status == ZYDIS_STATUS_SKIP_TOKEN)
        {
            ZYAN_CHECK(ZydisFormatterBufferRestore(buffer, buffer_state));
            continue;
        }
        if (!ZYAN_SUCCESS(status))
        {
            return status;
        }

        if (formatter->func_post_operand)
        {
            status = formatter->func_post_operand(formatter, buffer, context);
            if (status == ZYDIS_STATUS_SKIP_TOKEN)
            {
                ZYAN_CHECK(ZydisFormatterBufferRestore(buffer, buffer_state));
                continue;
            }
            if (ZYAN_SUCCESS(status))
            {
                return status;
            }
        }

#if !defined(ZYDIS_DISABLE_AVX512) || !defined(ZYDIS_DISABLE_KNC)
        if ((context->instruction->encoding == ZYDIS_INSTRUCTION_ENCODING_EVEX) ||
            (context->instruction->encoding == ZYDIS_INSTRUCTION_ENCODING_MVEX))
        {
            if  ((i == 0) &&
                (context->instruction->operand_count_visible > 1) &&
                (context->operands[1].encoding == ZYDIS_OPERAND_ENCODING_MASK))
            {
                ZYAN_CHECK(formatter->func_print_decorator(formatter, buffer, context,
                    ZYDIS_DECORATOR_MASK));
            }
            if (operand->type == ZYDIS_OPERAND_TYPE_MEMORY)
            {
                ZYAN_CHECK(formatter->func_print_decorator(formatter, buffer, context,
                    ZYDIS_DECORATOR_BC));
                if (context->instruction->encoding == ZYDIS_INSTRUCTION_ENCODING_MVEX)
                {
                    ZYAN_CHECK(formatter->func_print_decorator(formatter, buffer, context,
                        ZYDIS_DECORATOR_CONVERSION));
                    ZYAN_CHECK(formatter->func_print_decorator(formatter, buffer, context,
                        ZYDIS_DECORATOR_EH));
                }
            } else
            {
                ZyanBool decorate_operand;
                if (i == (context->instruction->operand_count_visible - 1))
                {
                    decorate_operand = operand->type != ZYDIS_OPERAND_TYPE_IMMEDIATE;
                }
                else
                {
                    decorate_operand =
                        (context->instruction->operand_count_visible > (i + 1)) &&
                        ((context->operands[i + 1].type == ZYDIS_OPERAND_TYPE_IMMEDIATE) ||
                        (context->operands[i + 1].visibility == ZYDIS_OPERAND_VISIBILITY_HIDDEN));
                }
                if (decorate_operand)
                {
                    if (context->instruction->encoding == ZYDIS_INSTRUCTION_ENCODING_MVEX)
                    {
                        ZYAN_CHECK(formatter->func_print_decorator(formatter, buffer, context,
                            ZYDIS_DECORATOR_SWIZZLE));
                    }
                    ZYAN_CHECK(formatter->func_print_decorator(formatter, buffer, context,
                        ZYDIS_DECORATOR_RC));
                    ZYAN_CHECK(formatter->func_print_decorator(formatter, buffer, context,
                        ZYDIS_DECORATOR_SAE));
                }
            }
        }
#endif
    }

    return ZYAN_STATUS_SUCCESS;
}

/* ---------------------------------------------------------------------------------------------- */
/* Operands                                                                                       */
/* ---------------------------------------------------------------------------------------------- */

ZyanStatus ZydisFormatterATTFormatOperandMEM(const ZydisFormatter* formatter,
    ZydisFormatterBuffer* buffer, ZydisFormatterContext* context)
{
    ZYAN_ASSERT(formatter);
    ZYAN_ASSERT(buffer);
    ZYAN_ASSERT(context);

    ZYAN_CHECK(formatter->func_print_segment(formatter, buffer, context));

    const ZyanBool absolute = !formatter->force_relative_riprel &&
        (context->runtime_address != ZYDIS_RUNTIME_ADDRESS_NONE);
    if (absolute && context->operand->mem.disp.has_displacement &&
        (context->operand->mem.index == ZYDIS_REGISTER_NONE) &&
       ((context->operand->mem.base  == ZYDIS_REGISTER_NONE) ||
        (context->operand->mem.base  == ZYDIS_REGISTER_EIP ) ||
        (context->operand->mem.base  == ZYDIS_REGISTER_RIP )))
    {
        // EIP/RIP-relative or absolute-displacement address operand
        ZYAN_CHECK(formatter->func_print_address_abs(formatter, buffer, context));
    } else
    {
        const ZyanBool should_print_reg = context->operand->mem.base != ZYDIS_REGISTER_NONE;
        const ZyanBool should_print_idx = context->operand->mem.index != ZYDIS_REGISTER_NONE;
        const ZyanBool neither_reg_nor_idx = !should_print_reg && !should_print_idx;

        // Regular memory operand
        if (neither_reg_nor_idx)
        {
            ZYAN_CHECK(formatter->func_print_address_abs(formatter, buffer, context));
        } else if (context->operand->mem.disp.has_displacement && context->operand->mem.disp.value)
        {
            ZYAN_CHECK(formatter->func_print_disp(formatter, buffer, context));
        }

        if (neither_reg_nor_idx)
        {
            return ZYAN_STATUS_SUCCESS;
        }

        ZYDIS_BUFFER_APPEND(buffer, MEMORY_BEGIN_ATT);

        if (should_print_reg)
        {
            ZYAN_CHECK(formatter->func_print_register(formatter, buffer, context,
                context->operand->mem.base));
        }
        if (should_print_idx)
        {
            ZYDIS_BUFFER_APPEND(buffer, DELIM_MEMORY);
            ZYAN_CHECK(formatter->func_print_register(formatter, buffer, context,
                context->operand->mem.index));
            if (context->operand->mem.scale &&
                (context->operand->mem.type != ZYDIS_MEMOP_TYPE_MIB) &&
                ((context->operand->mem.scale > 1) || formatter->force_memory_scale))
            {
                ZYDIS_BUFFER_APPEND_TOKEN(buffer, ZYDIS_TOKEN_DELIMITER);
                ZYDIS_BUFFER_APPEND(buffer, DELIM_MEMORY);
                ZYDIS_BUFFER_APPEND_TOKEN(buffer, ZYDIS_TOKEN_IMMEDIATE);
                ZYAN_CHECK(ZydisStringAppendDecU(&buffer->string, context->operand->mem.scale, 0,
                    ZYAN_NULL, ZYAN_NULL));
            }
        }

        ZYDIS_BUFFER_APPEND(buffer, MEMORY_END_ATT);
        return ZYAN_STATUS_SUCCESS;
    }

    return ZYAN_STATUS_SUCCESS;
}

/* ---------------------------------------------------------------------------------------------- */
/* Elemental tokens                                                                               */
/* ---------------------------------------------------------------------------------------------- */

ZyanStatus ZydisFormatterATTPrintMnemonic(const ZydisFormatter* formatter,
    ZydisFormatterBuffer* buffer, ZydisFormatterContext* context)
{
    ZYAN_ASSERT(formatter);
    ZYAN_ASSERT(buffer);
    ZYAN_ASSERT(context);
    ZYAN_ASSERT(context->instruction);
    ZYAN_ASSERT(context->operands);

    const ZydisShortString* mnemonic = ZydisMnemonicGetStringWrapped(
        context->instruction->mnemonic);
    if (!mnemonic)
    {
        ZYDIS_BUFFER_APPEND_CASE(buffer, INVALID_MNEMONIC, formatter->case_mnemonic);
        return ZYAN_STATUS_SUCCESS;
    }

    ZYDIS_BUFFER_APPEND_TOKEN(buffer, ZYDIS_TOKEN_MNEMONIC);
    if (context->instruction->meta.branch_type == ZYDIS_BRANCH_TYPE_FAR)
    {
        ZYAN_CHECK(ZydisStringAppendShortCase(&buffer->string, &STR_FAR_ATT,
            formatter->case_mnemonic));
    }
    ZYAN_CHECK(ZydisStringAppendShortCase(&buffer->string, mnemonic, formatter->case_mnemonic));

    // Append operand-size suffix
    ZyanU32 size = 0;
    for (ZyanU8 i = 0; i < context->instruction->operand_count_visible; ++i)
    {
        const ZydisDecodedOperand* const operand = &context->operands[i];
        if ((operand->type == ZYDIS_OPERAND_TYPE_MEMORY) &&
            ((operand->mem.type == ZYDIS_MEMOP_TYPE_MEM) ||
             (operand->mem.type == ZYDIS_MEMOP_TYPE_VSIB)))
        {
            size = ZydisFormatterHelperGetExplicitSize(formatter, context, operand);
            break;
        }
    }

    switch (size)
    {
    case   8: ZydisStringAppendShort(&buffer->string, &STR_SIZE_8_ATT  ); break;
    case  16: ZydisStringAppendShort(&buffer->string, &STR_SIZE_16_ATT ); break;
    case  32: ZydisStringAppendShort(&buffer->string, &STR_SIZE_32_ATT ); break;
    case  64: ZydisStringAppendShort(&buffer->string, &STR_SIZE_64_ATT ); break;
    case 128: ZydisStringAppendShort(&buffer->string, &STR_SIZE_128_ATT); break;
    case 256: ZydisStringAppendShort(&buffer->string, &STR_SIZE_256_ATT); break;
    case 512: ZydisStringAppendShort(&buffer->string, &STR_SIZE_512_ATT); break;
    default:
        break;
    }

    if (formatter->print_branch_size)
    {
        switch (context->instruction->meta.branch_type)
        {
        case ZYDIS_BRANCH_TYPE_NONE:
            break;
        case ZYDIS_BRANCH_TYPE_SHORT:
            return ZydisStringAppendShortCase(&buffer->string, &STR_SHORT,
                formatter->case_mnemonic);
        case ZYDIS_BRANCH_TYPE_NEAR:
            return ZydisStringAppendShortCase(&buffer->string, &STR_NEAR,
                formatter->case_mnemonic);
        default:
            return ZYAN_STATUS_INVALID_ARGUMENT;
        }
    }

    return ZYAN_STATUS_SUCCESS;
}

ZyanStatus ZydisFormatterATTPrintRegister(const ZydisFormatter* formatter,
    ZydisFormatterBuffer* buffer, ZydisFormatterContext* context, ZydisRegister reg)
{
    ZYAN_UNUSED(context);

    ZYAN_ASSERT(formatter);
    ZYAN_ASSERT(buffer);
    ZYAN_ASSERT(context);

    ZYDIS_BUFFER_APPEND(buffer, REGISTER);
    const ZydisShortString* str = ZydisRegisterGetStringWrapped(reg);
    if (!str)
    {
        return ZydisStringAppendShortCase(&buffer->string, &STR_INVALID_REG,
            formatter->case_registers);
    }
    return ZydisStringAppendShortCase(&buffer->string, str, formatter->case_registers);
}

ZyanStatus ZydisFormatterATTPrintAddressABS(const ZydisFormatter* formatter,
    ZydisFormatterBuffer* buffer, ZydisFormatterContext* context)
{
    ZYAN_ASSERT(formatter);
    ZYAN_ASSERT(buffer);
    ZYAN_ASSERT(context);

    if ((context->instruction->meta.branch_type != ZYDIS_BRANCH_TYPE_NONE) &&
        (context->operand->type == ZYDIS_OPERAND_TYPE_MEMORY))
    {
        ZYDIS_BUFFER_APPEND(buffer, MUL);
    }

    return ZydisFormatterBasePrintAddressABS(formatter, buffer, context);
}

ZyanStatus ZydisFormatterATTPrintDISP(const ZydisFormatter* formatter,
    ZydisFormatterBuffer* buffer, ZydisFormatterContext* context)
{
    ZYAN_ASSERT(formatter);
    ZYAN_ASSERT(buffer);
    ZYAN_ASSERT(context);

    ZYDIS_BUFFER_APPEND_TOKEN(buffer, ZYDIS_TOKEN_DISPLACEMENT);
    switch (formatter->disp_signedness)
    {
    case ZYDIS_SIGNEDNESS_AUTO:
    case ZYDIS_SIGNEDNESS_SIGNED:
        ZYDIS_STRING_APPEND_NUM_S(formatter, formatter->disp_base, &buffer->string,
            context->operand->mem.disp.value, formatter->disp_padding,
            formatter->hex_force_leading_number, ZYAN_FALSE);
        break;
    case ZYDIS_SIGNEDNESS_UNSIGNED:
        ZYDIS_STRING_APPEND_NUM_U(formatter, formatter->disp_base, &buffer->string,
            context->operand->mem.disp.value, formatter->disp_padding,
            formatter->hex_force_leading_number);
        break;
    default:
        return ZYAN_STATUS_INVALID_ARGUMENT;
    }

    return ZYAN_STATUS_SUCCESS;
}

ZyanStatus ZydisFormatterATTPrintIMM(const ZydisFormatter* formatter,
    ZydisFormatterBuffer* buffer, ZydisFormatterContext* context)
{
    ZYAN_ASSERT(formatter);
    ZYAN_ASSERT(buffer);
    ZYAN_ASSERT(context);

    ZYDIS_BUFFER_APPEND(buffer, IMMEDIATE);
    return ZydisFormatterBasePrintIMM(formatter, buffer, context);
}

/* ---------------------------------------------------------------------------------------------- */

/* ============================================================================================== */

//
// Source file: /home/ath/devel/zydis/src/FormatterBase.c
//

/***************************************************************************************************

  Zyan Disassembler Library (Zydis)

  Original Author : Florian Bernd, Joel Hoener

 * Permission is hereby granted, free of charge, to any person obtaining a copy
 * of this software and associated documentation files (the "Software"), to deal
 * in the Software without restriction, including without limitation the rights
 * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
 * copies of the Software, and to permit persons to whom the Software is
 * furnished to do so, subject to the following conditions:
 *
 * The above copyright notice and this permission notice shall be included in all
 * copies or substantial portions of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
 * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
 * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
 * SOFTWARE.

***************************************************************************************************/


/* ============================================================================================== */
/* Constants                                                                                      */
/* ============================================================================================== */


static const ZydisShortString* const STR_PREF_REX[16] =
{
    &STR_PREF_REX_40,
    &STR_PREF_REX_41,
    &STR_PREF_REX_42,
    &STR_PREF_REX_43,
    &STR_PREF_REX_44,
    &STR_PREF_REX_45,
    &STR_PREF_REX_46,
    &STR_PREF_REX_47,
    &STR_PREF_REX_48,
    &STR_PREF_REX_49,
    &STR_PREF_REX_4A,
    &STR_PREF_REX_4B,
    &STR_PREF_REX_4C,
    &STR_PREF_REX_4D,
    &STR_PREF_REX_4E,
    &STR_PREF_REX_4F
};

static const ZydisPredefinedToken* const TOK_PREF_REX[16] =
{
    (const ZydisPredefinedToken* const)&TOK_DATA_PREF_REX_40,
    (const ZydisPredefinedToken* const)&TOK_DATA_PREF_REX_41,
    (const ZydisPredefinedToken* const)&TOK_DATA_PREF_REX_42,
    (const ZydisPredefinedToken* const)&TOK_DATA_PREF_REX_43,
    (const ZydisPredefinedToken* const)&TOK_DATA_PREF_REX_44,
    (const ZydisPredefinedToken* const)&TOK_DATA_PREF_REX_45,
    (const ZydisPredefinedToken* const)&TOK_DATA_PREF_REX_46,
    (const ZydisPredefinedToken* const)&TOK_DATA_PREF_REX_47,
    (const ZydisPredefinedToken* const)&TOK_DATA_PREF_REX_48,
    (const ZydisPredefinedToken* const)&TOK_DATA_PREF_REX_49,
    (const ZydisPredefinedToken* const)&TOK_DATA_PREF_REX_4A,
    (const ZydisPredefinedToken* const)&TOK_DATA_PREF_REX_4B,
    (const ZydisPredefinedToken* const)&TOK_DATA_PREF_REX_4C,
    (const ZydisPredefinedToken* const)&TOK_DATA_PREF_REX_4D,
    (const ZydisPredefinedToken* const)&TOK_DATA_PREF_REX_4E,
    (const ZydisPredefinedToken* const)&TOK_DATA_PREF_REX_4F
};

/* ============================================================================================== */
/* Helper functions                                                                               */
/* ============================================================================================== */

ZyanU32 ZydisFormatterHelperGetExplicitSize(const ZydisFormatter* formatter,
    ZydisFormatterContext* context, const ZydisDecodedOperand* operand)
{
    ZYAN_ASSERT(formatter);
    ZYAN_ASSERT(context);
    ZYAN_ASSERT(operand);

    ZYAN_ASSERT(operand->type == ZYDIS_OPERAND_TYPE_MEMORY);
    ZYAN_ASSERT((operand->mem.type == ZYDIS_MEMOP_TYPE_MEM) ||
                (operand->mem.type == ZYDIS_MEMOP_TYPE_AGEN) ||
                (operand->mem.type == ZYDIS_MEMOP_TYPE_VSIB));

    if (formatter->force_memory_size)
    {
        return operand->size;
    }
    else if (operand->mem.type == ZYDIS_MEMOP_TYPE_AGEN)
    {
        return 0;
    }

    if (!context->operands)
    {
        // Single operand formatting. We can not derive the explicit size by using the other
        // operands.
        return 0;
    }

    switch (operand->id)
    {
    case 0:
        if (context->instruction->operand_count_visible < 2)
        {
            return 0;
        }
        if ((context->operands[1].type == ZYDIS_OPERAND_TYPE_UNUSED) ||
            (context->operands[1].type == ZYDIS_OPERAND_TYPE_IMMEDIATE))
        {
            return context->operands[0].size;
        }
        if (context->operands[0].size != context->operands[1].size)
        {
            return context->operands[0].size;
        }
        if ((context->operands[1].type == ZYDIS_OPERAND_TYPE_REGISTER) &&
            (context->operands[1].visibility == ZYDIS_OPERAND_VISIBILITY_IMPLICIT) &&
            (context->operands[1].reg.value == ZYDIS_REGISTER_CL))
        {
            return context->operands[0].size;
        }
        break;
    case 1:
    case 2:
        if (context->operands[operand->id - 1].size !=
            context->operands[operand->id].size)
        {
            return context->operands[operand->id].size;
        }
        break;
    default:
        break;
    }

    return 0;
}

/* ============================================================================================== */
/* Formatter functions                                                                            */
/* ============================================================================================== */

/* ---------------------------------------------------------------------------------------------- */
/* Operands                                                                                       */
/* ---------------------------------------------------------------------------------------------- */

ZyanStatus ZydisFormatterBaseFormatOperandREG(const ZydisFormatter* formatter,
    ZydisFormatterBuffer* buffer, ZydisFormatterContext* context)
{
    ZYAN_ASSERT(formatter);
    ZYAN_ASSERT(buffer);
    ZYAN_ASSERT(context);

    return formatter->func_print_register(formatter, buffer, context, context->operand->reg.value);
}

ZyanStatus ZydisFormatterBaseFormatOperandPTR(const ZydisFormatter* formatter,
    ZydisFormatterBuffer* buffer, ZydisFormatterContext* context)
{
    ZYAN_ASSERT(formatter);
    ZYAN_ASSERT(buffer);
    ZYAN_ASSERT(context);

    ZYDIS_BUFFER_APPEND_TOKEN(buffer, ZYDIS_TOKEN_IMMEDIATE);
    ZYDIS_STRING_APPEND_NUM_U(formatter, formatter->addr_base, &buffer->string,
        context->operand->ptr.segment, 4, formatter->hex_force_leading_number);
    ZYDIS_BUFFER_APPEND(buffer, DELIM_SEGMENT);

    ZyanU8 padding;
    switch (context->instruction->operand_width)
    {
    case 16:
        padding = 4;
        break;
    case 32:
        padding = 8;
        break;
    default:
        return ZYAN_STATUS_INVALID_ARGUMENT;
    }

    ZYDIS_BUFFER_APPEND_TOKEN(buffer, ZYDIS_TOKEN_IMMEDIATE);
    ZYDIS_STRING_APPEND_NUM_U(formatter, formatter->addr_base, &buffer->string,
        context->operand->ptr.offset , padding, formatter->hex_force_leading_number);

    return ZYAN_STATUS_SUCCESS;
}

ZyanStatus ZydisFormatterBaseFormatOperandIMM(const ZydisFormatter* formatter,
    ZydisFormatterBuffer* buffer, ZydisFormatterContext* context)
{
    ZYAN_ASSERT(formatter);
    ZYAN_ASSERT(buffer);
    ZYAN_ASSERT(context);

    // The immediate operand contains an address
    if (context->operand->imm.is_relative)
    {
        const ZyanBool absolute = !formatter->force_relative_branches &&
            (context->runtime_address != ZYDIS_RUNTIME_ADDRESS_NONE);
        if (absolute)
        {
            return formatter->func_print_address_abs(formatter, buffer, context);
        }
        return formatter->func_print_address_rel(formatter, buffer, context);
    }

    // The immediate operand contains an actual ordinal value
    return formatter->func_print_imm(formatter, buffer, context);
}

/* ---------------------------------------------------------------------------------------------- */
/* Elemental tokens                                                                               */
/* ---------------------------------------------------------------------------------------------- */

ZyanStatus ZydisFormatterBasePrintAddressABS(const ZydisFormatter* formatter,
    ZydisFormatterBuffer* buffer, ZydisFormatterContext* context)
{
    ZYAN_ASSERT(formatter);
    ZYAN_ASSERT(buffer);
    ZYAN_ASSERT(context);

    ZyanU64 address;
    ZYAN_CHECK(ZydisCalcAbsoluteAddress(context->instruction, context->operand,
        context->runtime_address, &address));
    ZyanU8 padding = (formatter->addr_padding_absolute ==
        ZYDIS_PADDING_AUTO) ? 0 : (ZyanU8)formatter->addr_padding_absolute;
    if ((formatter->addr_padding_absolute == ZYDIS_PADDING_AUTO) &&
        (formatter->addr_base == ZYDIS_NUMERIC_BASE_HEX))
    {
        switch (context->instruction->address_width)
        {
        case 16:
            padding =  4;
            address = (ZyanU16)address;
            break;
        case 32:
            padding =  8;
            address = (ZyanU32)address;
            break;
        case 64:
            padding = 16;
            break;
        default:
            return ZYAN_STATUS_INVALID_ARGUMENT;
        }
    }

    ZYDIS_BUFFER_APPEND_TOKEN(buffer, ZYDIS_TOKEN_ADDRESS_ABS);
    ZYDIS_STRING_APPEND_NUM_U(formatter, formatter->addr_base, &buffer->string, address, padding,
        formatter->hex_force_leading_number);

    return ZYAN_STATUS_SUCCESS;
}

ZyanStatus ZydisFormatterBasePrintAddressREL(const ZydisFormatter* formatter,
    ZydisFormatterBuffer* buffer, ZydisFormatterContext* context)
{
    ZYAN_ASSERT(formatter);
    ZYAN_ASSERT(buffer);
    ZYAN_ASSERT(context);

    ZyanU64 address;
    ZYAN_CHECK(ZydisCalcAbsoluteAddress(context->instruction, context->operand, 0, &address));

    ZyanU8 padding = (formatter->addr_padding_relative ==
        ZYDIS_PADDING_AUTO) ? 0 : (ZyanU8)formatter->addr_padding_relative;
    if ((formatter->addr_padding_relative == ZYDIS_PADDING_AUTO) &&
        (formatter->addr_base == ZYDIS_NUMERIC_BASE_HEX))
    {
        switch (context->instruction->address_width)
        {
        case 16:
            padding =  4;
            address = (ZyanU16)address;
            break;
        case 32:
            padding =  8;
            address = (ZyanU32)address;
            break;
        case 64:
            padding = 16;
            break;
        default:
            return ZYAN_STATUS_INVALID_ARGUMENT;
        }
    }

    ZYDIS_BUFFER_APPEND_TOKEN(buffer, ZYDIS_TOKEN_ADDRESS_REL);
    switch (formatter->addr_signedness)
    {
    case ZYDIS_SIGNEDNESS_AUTO:
    case ZYDIS_SIGNEDNESS_SIGNED:
        ZYDIS_STRING_APPEND_NUM_S(formatter, formatter->addr_base, &buffer->string, address,
            padding, formatter->hex_force_leading_number, ZYAN_TRUE);
        break;
    case ZYDIS_SIGNEDNESS_UNSIGNED:
        ZYAN_CHECK(ZydisStringAppendShort(&buffer->string, &STR_ADD));
        ZYDIS_STRING_APPEND_NUM_U(formatter, formatter->addr_base, &buffer->string, address,
            padding, formatter->hex_force_leading_number);
        break;
    default:
        return ZYAN_STATUS_INVALID_ARGUMENT;
    }

    return ZYAN_STATUS_SUCCESS;
}

ZyanStatus ZydisFormatterBasePrintIMM(const ZydisFormatter* formatter,
    ZydisFormatterBuffer* buffer, ZydisFormatterContext* context)
{
    ZYAN_ASSERT(formatter);
    ZYAN_ASSERT(buffer);
    ZYAN_ASSERT(context);

    ZYDIS_BUFFER_APPEND_TOKEN(buffer, ZYDIS_TOKEN_IMMEDIATE);

    const ZyanBool is_signed =
        (formatter->imm_signedness == ZYDIS_SIGNEDNESS_SIGNED) ||
        (formatter->imm_signedness == ZYDIS_SIGNEDNESS_AUTO && (context->operand->imm.is_signed));
    if (is_signed && (context->operand->imm.value.s < 0))
    {
        ZYDIS_STRING_APPEND_NUM_S(formatter, formatter->imm_base, &buffer->string,
            context->operand->imm.value.s, formatter->imm_padding,
            formatter->hex_force_leading_number, ZYAN_FALSE);
        return ZYAN_STATUS_SUCCESS;
    }
    ZyanU64 value;
    ZyanU8 padding = (formatter->imm_padding ==
        ZYDIS_PADDING_AUTO) ? 0 : (ZyanU8)formatter->imm_padding;
    switch (context->instruction->operand_width)
    {
    case 8:
        if (formatter->imm_padding == ZYDIS_PADDING_AUTO)
        {
            padding =  2;
        }
        value = (ZyanU8 )context->operand->imm.value.u;
        break;
    case 16:
        if (formatter->imm_padding == ZYDIS_PADDING_AUTO)
        {
            padding =  4;
        }
        value = (ZyanU16)context->operand->imm.value.u;
        break;
    case 32:
        if (formatter->imm_padding == ZYDIS_PADDING_AUTO)
        {
            padding =  8;
        }
        value = (ZyanU32)context->operand->imm.value.u;
        break;
    case 64:
        if (formatter->imm_padding == ZYDIS_PADDING_AUTO)
        {
            padding = 16;
        }
        value = (ZyanU64)context->operand->imm.value.u;
        break;
    default:
        return ZYAN_STATUS_INVALID_ARGUMENT;
    }
    ZYDIS_STRING_APPEND_NUM_U(formatter, formatter->imm_base, &buffer->string, value, padding,
        formatter->hex_force_leading_number);

    return ZYAN_STATUS_SUCCESS;
}

/* ---------------------------------------------------------------------------------------------- */
/* Optional tokens                                                                                */
/* ---------------------------------------------------------------------------------------------- */

ZyanStatus ZydisFormatterBasePrintSegment(const ZydisFormatter* formatter,
    ZydisFormatterBuffer* buffer, ZydisFormatterContext* context)
{
    ZYAN_ASSERT(formatter);
    ZYAN_ASSERT(buffer);
    ZYAN_ASSERT(context);

    ZyanBool printed_segment = ZYAN_FALSE;
    switch (context->operand->mem.segment)
    {
    case ZYDIS_REGISTER_ES:
    case ZYDIS_REGISTER_CS:
    case ZYDIS_REGISTER_FS:
    case ZYDIS_REGISTER_GS:
        ZYAN_CHECK(formatter->func_print_register(formatter, buffer, context,
            context->operand->mem.segment));
        printed_segment = ZYAN_TRUE;
        break;
    case ZYDIS_REGISTER_SS:
        if ((formatter->force_memory_segment) ||
            (context->instruction->attributes & ZYDIS_ATTRIB_HAS_SEGMENT_SS))
        {
            ZYAN_CHECK(formatter->func_print_register(formatter, buffer, context,
                context->operand->mem.segment));
            printed_segment = ZYAN_TRUE;
        }
        break;
    case ZYDIS_REGISTER_DS:
        if ((formatter->force_memory_segment) ||
            (context->instruction->attributes & ZYDIS_ATTRIB_HAS_SEGMENT_DS))
        {
            ZYAN_CHECK(formatter->func_print_register(formatter, buffer, context,
                context->operand->mem.segment));
            printed_segment = ZYAN_TRUE;
        }
        break;
    default:
        break;
    }
    if (printed_segment)
    {
        ZYDIS_BUFFER_APPEND(buffer, DELIM_SEGMENT);
    }

    return ZYAN_STATUS_SUCCESS;
}

ZyanStatus ZydisFormatterBasePrintPrefixes(const ZydisFormatter* formatter,
    ZydisFormatterBuffer* buffer, ZydisFormatterContext* context)
{
    ZYAN_ASSERT(formatter);
    ZYAN_ASSERT(buffer);
    ZYAN_ASSERT(context);

    if (formatter->detailed_prefixes)
    {
        for (ZyanU8 i = 0; i < context->instruction->raw.prefix_count; ++i)
        {
            const ZyanU8 value = context->instruction->raw.prefixes[i].value;
            switch (context->instruction->raw.prefixes[i].type)
            {
            case ZYDIS_PREFIX_TYPE_IGNORED:
            case ZYDIS_PREFIX_TYPE_MANDATORY:
            {
                if ((value & 0xF0) == 0x40)
                {
                    if (buffer->is_token_list)
                    {
                        // TODO: Case
                        ZYAN_CHECK(ZydisFormatterBufferAppendPredefined(buffer,
                            TOK_PREF_REX[value & 0x0F]));
                    } else
                    {
                        ZYAN_CHECK(ZydisStringAppendShortCase(&buffer->string,
                            STR_PREF_REX[value & 0x0F], formatter->case_prefixes));
                    }
                } else
                {
                    switch (value)
                    {
                    case 0xF0:
                        ZYDIS_BUFFER_APPEND_CASE(buffer, PREF_LOCK, formatter->case_prefixes);
                        break;
                    case 0x2E:
                        ZYDIS_BUFFER_APPEND_CASE(buffer, PREF_SEG_CS, formatter->case_prefixes);
                        break;
                    case 0x36:
                        ZYDIS_BUFFER_APPEND_CASE(buffer, PREF_SEG_SS, formatter->case_prefixes);
                        break;
                    case 0x3E:
                        ZYDIS_BUFFER_APPEND_CASE(buffer, PREF_SEG_DS, formatter->case_prefixes);
                        break;
                    case 0x26:
                        ZYDIS_BUFFER_APPEND_CASE(buffer, PREF_SEG_ES, formatter->case_prefixes);
                        break;
                    case 0x64:
                        ZYDIS_BUFFER_APPEND_CASE(buffer, PREF_SEG_FS, formatter->case_prefixes);
                        break;
                    case 0x65:
                        ZYDIS_BUFFER_APPEND_CASE(buffer, PREF_SEG_GS, formatter->case_prefixes);
                        break;
                    default:
                        ZYDIS_BUFFER_APPEND_TOKEN(buffer, ZYDIS_TOKEN_PREFIX);
                        ZYAN_CHECK(ZydisStringAppendHexU(&buffer->string, value, 0,
                            formatter->hex_force_leading_number, formatter->hex_uppercase,
                            ZYAN_NULL, ZYAN_NULL));
                        ZYDIS_BUFFER_APPEND_TOKEN(buffer, ZYDIS_TOKEN_WHITESPACE);
                        ZYAN_CHECK(ZydisStringAppendShort(&buffer->string, &STR_WHITESPACE));
                        break;
                    }
                }
                break;
            }
            case ZYDIS_PREFIX_TYPE_EFFECTIVE:
                switch (value)
                {
                case 0xF0:
                    ZYDIS_BUFFER_APPEND_CASE(buffer, PREF_LOCK, formatter->case_prefixes);
                    break;
                case 0xF2:
                    if (context->instruction->attributes & ZYDIS_ATTRIB_HAS_XACQUIRE)
                    {
                        ZYDIS_BUFFER_APPEND_CASE(buffer, PREF_XACQUIRE, formatter->case_prefixes);
                    }
                    if (context->instruction->attributes & ZYDIS_ATTRIB_HAS_REPNE)
                    {
                        ZYDIS_BUFFER_APPEND_CASE(buffer, PREF_REPNE, formatter->case_prefixes);
                    }

                    if (context->instruction->attributes & ZYDIS_ATTRIB_HAS_BND)
                    {
                        ZYDIS_BUFFER_APPEND_CASE(buffer, PREF_BND, formatter->case_prefixes);
                    }
                    break;
                case 0xF3:
                    if (context->instruction->attributes & ZYDIS_ATTRIB_HAS_XRELEASE)
                    {
                        ZYDIS_BUFFER_APPEND_CASE(buffer, PREF_XRELEASE, formatter->case_prefixes);
                    }
                    if (context->instruction->attributes & ZYDIS_ATTRIB_HAS_REP)
                    {
                        ZYDIS_BUFFER_APPEND_CASE(buffer, PREF_REP, formatter->case_prefixes);
                    }
                    if (context->instruction->attributes & ZYDIS_ATTRIB_HAS_REPE)
                    {
                        ZYDIS_BUFFER_APPEND_CASE(buffer, PREF_REPE, formatter->case_prefixes);
                    }
                    break;
                default:
                    break;
                }
                break;
            default:
                return ZYAN_STATUS_INVALID_ARGUMENT;
            }
        }
        return ZYAN_STATUS_SUCCESS;
    }

    if (context->instruction->attributes & ZYDIS_ATTRIB_HAS_XACQUIRE)
    {
        ZYDIS_BUFFER_APPEND_CASE(buffer, PREF_XACQUIRE, formatter->case_prefixes);
    }
    if (context->instruction->attributes & ZYDIS_ATTRIB_HAS_XRELEASE)
    {
        ZYDIS_BUFFER_APPEND_CASE(buffer, PREF_XRELEASE, formatter->case_prefixes);
    }

    if (context->instruction->attributes & ZYDIS_ATTRIB_HAS_LOCK)
    {
        ZYDIS_BUFFER_APPEND_CASE(buffer, PREF_LOCK, formatter->case_prefixes);
    }

    if (context->instruction->attributes & ZYDIS_ATTRIB_HAS_BND)
    {
        ZYDIS_BUFFER_APPEND_CASE(buffer, PREF_BND, formatter->case_prefixes);
    }

    if (context->instruction->attributes & ZYDIS_ATTRIB_HAS_NOTRACK)
    {
        ZYDIS_BUFFER_APPEND_CASE(buffer, PREF_NOTRACK, formatter->case_prefixes);
    }

    if (context->instruction->attributes & ZYDIS_ATTRIB_HAS_REP)
    {
        ZYDIS_BUFFER_APPEND_CASE(buffer, PREF_REP, formatter->case_prefixes);
        return ZYAN_STATUS_SUCCESS;
    }
    if (context->instruction->attributes & ZYDIS_ATTRIB_HAS_REPE)
    {
        ZYDIS_BUFFER_APPEND_CASE(buffer, PREF_REPE, formatter->case_prefixes);
        return ZYAN_STATUS_SUCCESS;
    }
    if (context->instruction->attributes & ZYDIS_ATTRIB_HAS_REPNE)
    {
        ZYDIS_BUFFER_APPEND_CASE(buffer, PREF_REPNE, formatter->case_prefixes);
        return ZYAN_STATUS_SUCCESS;
    }

    return ZYAN_STATUS_SUCCESS;
}

ZyanStatus ZydisFormatterBasePrintDecorator(const ZydisFormatter* formatter,
    ZydisFormatterBuffer* buffer, ZydisFormatterContext* context, ZydisDecorator decorator)
{
    ZYAN_ASSERT(formatter);
    ZYAN_ASSERT(buffer);
    ZYAN_ASSERT(context);

#if defined(ZYDIS_DISABLE_AVX512) && defined(ZYDIS_DISABLE_KNC)
    ZYAN_UNUSED(formatter);
    ZYAN_UNUSED(buffer);
    ZYAN_UNUSED(context);
#endif

    switch (decorator)
    {
    case ZYDIS_DECORATOR_MASK:
    {
#if !defined(ZYDIS_DISABLE_AVX512) || !defined(ZYDIS_DISABLE_KNC)
        if (context->instruction->avx.mask.reg != ZYDIS_REGISTER_K0)
        {
            if (buffer->is_token_list)
            {
                ZYDIS_BUFFER_APPEND(buffer, DECO_BEGIN);
                ZYAN_CHECK(formatter->func_print_register(formatter, buffer, context,
                    context->instruction->avx.mask.reg));
                ZYDIS_BUFFER_APPEND(buffer, DECO_END);
            } else
            {
                ZYAN_CHECK(ZydisStringAppendShort(&buffer->string, &STR_DECO_BEGIN));
                ZYAN_CHECK(formatter->func_print_register(formatter, buffer, context,
                    context->instruction->avx.mask.reg));
                ZYAN_CHECK(ZydisStringAppendShort(&buffer->string, &STR_DECO_END));
            }

            // Only print the zeroing decorator, if the instruction is not a "zeroing masking only"
            // instruction (e.g. `vcmpsd`)
            if ((context->instruction->avx.mask.mode == ZYDIS_MASK_MODE_ZEROING ||
                 context->instruction->avx.mask.mode == ZYDIS_MASK_MODE_CONTROL_ZEROING) &&
                (context->instruction->raw.evex.z))
            {
                ZYDIS_BUFFER_APPEND_CASE(buffer, DECO_ZERO, formatter->case_decorators);
            }
        }
#endif
        break;
    }
    case ZYDIS_DECORATOR_BC:
#if !defined(ZYDIS_DISABLE_AVX512)
        if (!context->instruction->avx.broadcast.is_static)
        {
            switch (context->instruction->avx.broadcast.mode)
            {
            case ZYDIS_BROADCAST_MODE_INVALID:
                break;
            case ZYDIS_BROADCAST_MODE_1_TO_2:
                ZYDIS_BUFFER_APPEND_CASE(buffer, DECO_1TO2, formatter->case_decorators);
                break;
            case ZYDIS_BROADCAST_MODE_1_TO_4:
                ZYDIS_BUFFER_APPEND_CASE(buffer, DECO_1TO4, formatter->case_decorators);
                break;
            case ZYDIS_BROADCAST_MODE_1_TO_8:
                ZYDIS_BUFFER_APPEND_CASE(buffer, DECO_1TO8, formatter->case_decorators);
                break;
            case ZYDIS_BROADCAST_MODE_1_TO_16:
                ZYDIS_BUFFER_APPEND_CASE(buffer, DECO_1TO16, formatter->case_decorators);
                break;
            case ZYDIS_BROADCAST_MODE_1_TO_32:
                ZYDIS_BUFFER_APPEND_CASE(buffer, DECO_1TO32, formatter->case_decorators);
                break;
            case ZYDIS_BROADCAST_MODE_1_TO_64:
                ZYDIS_BUFFER_APPEND_CASE(buffer, DECO_1TO64, formatter->case_decorators);
                break;
            case ZYDIS_BROADCAST_MODE_4_TO_8:
                ZYDIS_BUFFER_APPEND_CASE(buffer, DECO_4TO8, formatter->case_decorators);
                break;
            case ZYDIS_BROADCAST_MODE_4_TO_16:
                ZYDIS_BUFFER_APPEND_CASE(buffer, DECO_4TO16, formatter->case_decorators);
                break;
            case ZYDIS_BROADCAST_MODE_8_TO_16:
                ZYDIS_BUFFER_APPEND_CASE(buffer, DECO_8TO16, formatter->case_decorators);
                break;
            default:
                return ZYAN_STATUS_INVALID_ARGUMENT;
            }
        }
#endif
        break;
    case ZYDIS_DECORATOR_RC:
#if !defined(ZYDIS_DISABLE_AVX512)
        if (context->instruction->avx.has_sae)
        {
            switch (context->instruction->avx.rounding.mode)
            {
            case ZYDIS_ROUNDING_MODE_INVALID:
                break;
            case ZYDIS_ROUNDING_MODE_RN:
                ZYDIS_BUFFER_APPEND_CASE(buffer, DECO_RN_SAE, formatter->case_decorators);
                break;
            case ZYDIS_ROUNDING_MODE_RD:
                ZYDIS_BUFFER_APPEND_CASE(buffer, DECO_RD_SAE, formatter->case_decorators);
                break;
            case ZYDIS_ROUNDING_MODE_RU:
                ZYDIS_BUFFER_APPEND_CASE(buffer, DECO_RU_SAE, formatter->case_decorators);
                break;
            case ZYDIS_ROUNDING_MODE_RZ:
                ZYDIS_BUFFER_APPEND_CASE(buffer, DECO_RZ_SAE, formatter->case_decorators);
                break;
            default:
                return ZYAN_STATUS_INVALID_ARGUMENT;
            }
        } else
        {
            switch (context->instruction->avx.rounding.mode)
            {
            case ZYDIS_ROUNDING_MODE_INVALID:
                break;
            case ZYDIS_ROUNDING_MODE_RN:
                ZYDIS_BUFFER_APPEND_CASE(buffer, DECO_RN, formatter->case_decorators);
                break;
            case ZYDIS_ROUNDING_MODE_RD:
                ZYDIS_BUFFER_APPEND_CASE(buffer, DECO_RD, formatter->case_decorators);
                break;
            case ZYDIS_ROUNDING_MODE_RU:
                ZYDIS_BUFFER_APPEND_CASE(buffer, DECO_RU, formatter->case_decorators);
                break;
            case ZYDIS_ROUNDING_MODE_RZ:
                ZYDIS_BUFFER_APPEND_CASE(buffer, DECO_RZ, formatter->case_decorators);
                break;
            default:
                return ZYAN_STATUS_INVALID_ARGUMENT;
            }
        }
#endif
        break;
    case ZYDIS_DECORATOR_SAE:
#if !defined(ZYDIS_DISABLE_AVX512)
        if (context->instruction->avx.has_sae && !context->instruction->avx.rounding.mode)
        {
            ZYDIS_BUFFER_APPEND_CASE(buffer, DECO_SAE, formatter->case_decorators);
        }
#endif
        break;
    case ZYDIS_DECORATOR_SWIZZLE:
#if !defined(ZYDIS_DISABLE_KNC)
        switch (context->instruction->avx.swizzle.mode)
        {
        case ZYDIS_SWIZZLE_MODE_INVALID:
        case ZYDIS_SWIZZLE_MODE_DCBA:
            // Nothing to do here
            break;
        case ZYDIS_SWIZZLE_MODE_CDAB:
            ZYDIS_BUFFER_APPEND_CASE(buffer, DECO_CDAB, formatter->case_decorators);
            break;
        case ZYDIS_SWIZZLE_MODE_BADC:
            ZYDIS_BUFFER_APPEND_CASE(buffer, DECO_BADC, formatter->case_decorators);
            break;
        case ZYDIS_SWIZZLE_MODE_DACB:
            ZYDIS_BUFFER_APPEND_CASE(buffer, DECO_DACB, formatter->case_decorators);
            break;
        case ZYDIS_SWIZZLE_MODE_AAAA:
            ZYDIS_BUFFER_APPEND_CASE(buffer, DECO_AAAA, formatter->case_decorators);
            break;
        case ZYDIS_SWIZZLE_MODE_BBBB:
            ZYDIS_BUFFER_APPEND_CASE(buffer, DECO_BBBB, formatter->case_decorators);
            break;
        case ZYDIS_SWIZZLE_MODE_CCCC:
            ZYDIS_BUFFER_APPEND_CASE(buffer, DECO_CCCC, formatter->case_decorators);
            break;
        case ZYDIS_SWIZZLE_MODE_DDDD:
            ZYDIS_BUFFER_APPEND_CASE(buffer, DECO_DDDD, formatter->case_decorators);
            break;
        default:
            return ZYAN_STATUS_INVALID_ARGUMENT;
        }
#endif
        break;
    case ZYDIS_DECORATOR_CONVERSION:
#if !defined(ZYDIS_DISABLE_KNC)
        switch (context->instruction->avx.conversion.mode)
        {
        case ZYDIS_CONVERSION_MODE_INVALID:
            break;
        case ZYDIS_CONVERSION_MODE_FLOAT16:
            ZYDIS_BUFFER_APPEND_CASE(buffer, DECO_FLOAT16, formatter->case_decorators);
            break;
        case ZYDIS_CONVERSION_MODE_SINT8:
            ZYDIS_BUFFER_APPEND_CASE(buffer, DECO_SINT8, formatter->case_decorators);
            break;
        case ZYDIS_CONVERSION_MODE_UINT8:
            ZYDIS_BUFFER_APPEND_CASE(buffer, DECO_UINT8, formatter->case_decorators);
            break;
        case ZYDIS_CONVERSION_MODE_SINT16:
            ZYDIS_BUFFER_APPEND_CASE(buffer, DECO_SINT16, formatter->case_decorators);
            break;
        case ZYDIS_CONVERSION_MODE_UINT16:
            ZYDIS_BUFFER_APPEND_CASE(buffer, DECO_UINT16, formatter->case_decorators);
            break;
        default:
            return ZYAN_STATUS_INVALID_ARGUMENT;
        }
#endif
        break;
    case ZYDIS_DECORATOR_EH:
#if !defined(ZYDIS_DISABLE_KNC)
        if (context->instruction->avx.has_eviction_hint)
        {
            ZYDIS_BUFFER_APPEND_CASE(buffer, DECO_EH, formatter->case_decorators);
        }
#endif
        break;
    default:
        return ZYAN_STATUS_INVALID_ARGUMENT;
    }

    return ZYAN_STATUS_SUCCESS;
}

/* ---------------------------------------------------------------------------------------------- */

/* ============================================================================================== */

//
// Source file: /home/ath/devel/zydis/src/FormatterBuffer.c
//

/***************************************************************************************************

  Zyan Disassembler Library (Zydis)

  Original Author : Florian Bernd

 * Permission is hereby granted, free of charge, to any person obtaining a copy
 * of this software and associated documentation files (the "Software"), to deal
 * in the Software without restriction, including without limitation the rights
 * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
 * copies of the Software, and to permit persons to whom the Software is
 * furnished to do so, subject to the following conditions:
 *
 * The above copyright notice and this permission notice shall be included in all
 * copies or substantial portions of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
 * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
 * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
 * SOFTWARE.

***************************************************************************************************/


/* ============================================================================================== */
/* Exported functions                                                                             */
/* ============================================================================================== */

/* ---------------------------------------------------------------------------------------------- */
/* Token                                                                                          */
/* ---------------------------------------------------------------------------------------------- */

ZyanStatus ZydisFormatterTokenGetValue(const ZydisFormatterToken* token,
    ZydisTokenType* type, ZyanConstCharPointer* value)
{
    if (!token || !type || !value)
    {
        return ZYAN_STATUS_INVALID_ARGUMENT;
    }

    *type = token->type;
    *value = (ZyanConstCharPointer)((ZyanU8*)token + sizeof(ZydisFormatterToken));

    return ZYAN_STATUS_SUCCESS;
}

ZyanStatus ZydisFormatterTokenNext(ZydisFormatterTokenConst** token)
{
    if (!token || !*token)
    {
        return ZYAN_STATUS_INVALID_ARGUMENT;
    }

    const ZyanU8 next = (*token)->next;
    if (!next)
    {
        return ZYAN_STATUS_OUT_OF_RANGE;
    }
    *token = (ZydisFormatterTokenConst*)((ZyanU8*)*token + sizeof(ZydisFormatterToken) + next);

    return ZYAN_STATUS_SUCCESS;
}

/* ---------------------------------------------------------------------------------------------- */
/* Buffer                                                                                         */
/* ---------------------------------------------------------------------------------------------- */

ZyanStatus ZydisFormatterBufferGetToken(const ZydisFormatterBuffer* buffer,
    ZydisFormatterTokenConst** token)
{
    if (!buffer || !token)
    {
        return ZYAN_STATUS_INVALID_ARGUMENT;
    }

    *token = ((ZydisFormatterTokenConst*)buffer->string.vector.data - 1);
    if ((*token)->type == ZYDIS_TOKEN_INVALID)
    {
        return ZYAN_STATUS_INVALID_OPERATION;
    }

    return ZYAN_STATUS_SUCCESS;
}

ZyanStatus ZydisFormatterBufferGetString(ZydisFormatterBuffer* buffer, ZyanString** string)
{
    if (!buffer || !string)
    {
        return ZYAN_STATUS_INVALID_ARGUMENT;
    }

    if (buffer->is_token_list &&
        ((ZydisFormatterTokenConst*)buffer->string.vector.data - 1)->type == ZYDIS_TOKEN_INVALID)
    {
        return ZYAN_STATUS_INVALID_OPERATION;
    }

    ZYAN_ASSERT(buffer->string.vector.data);
    ZYAN_ASSERT(buffer->string.vector.size);

    *string = &buffer->string;

    return ZYAN_STATUS_SUCCESS;
}

ZyanStatus ZydisFormatterBufferAppend(ZydisFormatterBuffer* buffer, ZydisTokenType type)
{
    if (!buffer)
    {
        return ZYAN_STATUS_INVALID_ARGUMENT;
    }

    if (!buffer->is_token_list)
    {
        return ZYAN_STATUS_SUCCESS;
    }

    const ZyanUSize len = buffer->string.vector.size;
    ZYAN_ASSERT((len > 0) && (len < 256));
    if (buffer->capacity <= len + sizeof(ZydisFormatterToken))
    {
        return ZYAN_STATUS_INSUFFICIENT_BUFFER_SIZE;
    }

    ZydisFormatterToken* const last  = (ZydisFormatterToken*)buffer->string.vector.data - 1;
    last->next = (ZyanU8)len;

    const ZyanUSize delta = len + sizeof(ZydisFormatterToken);
    buffer->capacity -= delta;
    buffer->string.vector.data = (ZyanU8*)buffer->string.vector.data + delta;
    buffer->string.vector.size = 1;
    buffer->string.vector.capacity = ZYAN_MIN(buffer->capacity, 255);
    *(char*)buffer->string.vector.data = '\0';

    ZydisFormatterToken* const token = (ZydisFormatterToken*)buffer->string.vector.data - 1;
    token->type = type;
    token->next = 0;

    return ZYAN_STATUS_SUCCESS;
}

ZyanStatus ZydisFormatterBufferRemember(const ZydisFormatterBuffer* buffer, ZyanUPointer* state)
{
    if (!buffer || !state)
    {
        return ZYAN_STATUS_INVALID_ARGUMENT;
    }

    if (buffer->is_token_list)
    {
        *state = (ZyanUPointer)buffer->string.vector.data;
    } else
    {
        *state = (ZyanUPointer)buffer->string.vector.size;
    }

    return ZYAN_STATUS_SUCCESS;
}

ZyanStatus ZydisFormatterBufferRestore(ZydisFormatterBuffer* buffer, ZyanUPointer state)
{
    if (!buffer)
    {
        return ZYAN_STATUS_INVALID_ARGUMENT;
    }

    if (buffer->is_token_list)
    {
        const ZyanUSize delta = (ZyanUPointer)buffer->string.vector.data - state;
        buffer->capacity += delta;
        buffer->string.vector.data = (void*)state;
        buffer->string.vector.size = 1; // TODO: Restore size?
        buffer->string.vector.capacity = ZYAN_MIN(buffer->capacity, 255);
        *(char*)buffer->string.vector.data = '\0';
    } else
    {
        buffer->string.vector.size = (ZyanUSize)state;
        ZYDIS_STRING_NULLTERMINATE(&buffer->string);
    }

    return ZYAN_STATUS_SUCCESS;
}

/* ---------------------------------------------------------------------------------------------- */

/* ============================================================================================== */

//
// Source file: /home/ath/devel/zydis/src/FormatterIntel.c
//

/***************************************************************************************************

  Zyan Disassembler Library (Zydis)

  Original Author : Florian Bernd, Joel Hoener

 * Permission is hereby granted, free of charge, to any person obtaining a copy
 * of this software and associated documentation files (the "Software"), to deal
 * in the Software without restriction, including without limitation the rights
 * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
 * copies of the Software, and to permit persons to whom the Software is
 * furnished to do so, subject to the following conditions:
 *
 * The above copyright notice and this permission notice shall be included in all
 * copies or substantial portions of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
 * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
 * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
 * SOFTWARE.

***************************************************************************************************/


/* ============================================================================================== */
/* Constants                                                                                      */
/* ============================================================================================== */


/* ============================================================================================== */
/* Formatter functions                                                                            */
/* ============================================================================================== */

/* ---------------------------------------------------------------------------------------------- */
/* Intel                                                                                          */
/* ---------------------------------------------------------------------------------------------- */

ZyanStatus ZydisFormatterIntelFormatInstruction(const ZydisFormatter* formatter,
    ZydisFormatterBuffer* buffer, ZydisFormatterContext* context)
{
    ZYAN_ASSERT(formatter);
    ZYAN_ASSERT(buffer);
    ZYAN_ASSERT(context);
    ZYAN_ASSERT(context->instruction);
    ZYAN_ASSERT(context->operands);

    ZYAN_CHECK(formatter->func_print_prefixes(formatter, buffer, context));
    ZYAN_CHECK(formatter->func_print_mnemonic(formatter, buffer, context));

    ZyanUPointer state_mnemonic;
    ZYDIS_BUFFER_REMEMBER(buffer, state_mnemonic);
    for (ZyanU8 i = 0; i < context->instruction->operand_count_visible; ++i)
    {
        const ZydisDecodedOperand* const operand = &context->operands[i];

        // Print embedded-mask registers as decorator instead of a regular operand
        if ((i == 1) && (operand->type == ZYDIS_OPERAND_TYPE_REGISTER) &&
            (operand->encoding == ZYDIS_OPERAND_ENCODING_MASK))
        {
            continue;
        }

        ZyanUPointer buffer_state;
        ZYDIS_BUFFER_REMEMBER(buffer, buffer_state);

        if (buffer_state != state_mnemonic)
        {
            ZYDIS_BUFFER_APPEND(buffer, DELIM_OPERAND);
        } else
        {
            ZYDIS_BUFFER_APPEND(buffer, DELIM_MNEMONIC);
        }

        // Set current operand
        context->operand = operand;

        ZyanStatus status;
        if (formatter->func_pre_operand)
        {
            status = formatter->func_pre_operand(formatter, buffer, context);
            if (status == ZYDIS_STATUS_SKIP_TOKEN)
            {
                ZYAN_CHECK(ZydisFormatterBufferRestore(buffer, buffer_state));
                continue;
            }
            if (!ZYAN_SUCCESS(status))
            {
                return status;
            }
        }

        switch (operand->type)
        {
        case ZYDIS_OPERAND_TYPE_REGISTER:
            status = formatter->func_format_operand_reg(formatter, buffer, context);
            break;
        case ZYDIS_OPERAND_TYPE_MEMORY:
            status = formatter->func_format_operand_mem(formatter, buffer, context);
            break;
        case ZYDIS_OPERAND_TYPE_POINTER:
            status = formatter->func_format_operand_ptr(formatter, buffer, context);
            break;
        case ZYDIS_OPERAND_TYPE_IMMEDIATE:
            status = formatter->func_format_operand_imm(formatter, buffer, context);
            break;
        default:
            return ZYAN_STATUS_INVALID_ARGUMENT;
        }
        if (status == ZYDIS_STATUS_SKIP_TOKEN)
        {
            ZYAN_CHECK(ZydisFormatterBufferRestore(buffer, buffer_state));
            continue;
        }
        if (!ZYAN_SUCCESS(status))
        {
            return status;
        }

        if (formatter->func_post_operand)
        {
            status = formatter->func_post_operand(formatter, buffer, context);
            if (status == ZYDIS_STATUS_SKIP_TOKEN)
            {
                ZYAN_CHECK(ZydisFormatterBufferRestore(buffer, buffer_state));
                continue;
            }
            if (ZYAN_SUCCESS(status))
            {
                return status;
            }
        }

#if !defined(ZYDIS_DISABLE_AVX512) || !defined(ZYDIS_DISABLE_KNC)
        if ((context->instruction->encoding == ZYDIS_INSTRUCTION_ENCODING_EVEX) ||
            (context->instruction->encoding == ZYDIS_INSTRUCTION_ENCODING_MVEX))
        {
            if  ((i == 0) &&
                 (context->instruction->operand_count_visible > 1) &&
                 (context->operands[i + 1].encoding == ZYDIS_OPERAND_ENCODING_MASK))
            {
                ZYAN_CHECK(formatter->func_print_decorator(formatter, buffer, context,
                    ZYDIS_DECORATOR_MASK));
            }
            if (operand->type == ZYDIS_OPERAND_TYPE_MEMORY)
            {
                ZYAN_CHECK(formatter->func_print_decorator(formatter, buffer, context,
                    ZYDIS_DECORATOR_BC));
                if (context->instruction->encoding == ZYDIS_INSTRUCTION_ENCODING_MVEX)
                {
                    ZYAN_CHECK(formatter->func_print_decorator(formatter, buffer, context,
                        ZYDIS_DECORATOR_CONVERSION));
                    ZYAN_CHECK(formatter->func_print_decorator(formatter, buffer, context,
                        ZYDIS_DECORATOR_EH));
                }
            } else
            {
                ZyanBool decorate_operand;
                if (i == (context->instruction->operand_count_visible - 1))
                {
                    decorate_operand = operand->type != ZYDIS_OPERAND_TYPE_IMMEDIATE;
                }
                else
                {
                    decorate_operand =
                        (context->instruction->operand_count_visible > (i + 1)) &&
                        ((context->operands[i + 1].type == ZYDIS_OPERAND_TYPE_IMMEDIATE) ||
                        (context->operands[i + 1].visibility == ZYDIS_OPERAND_VISIBILITY_HIDDEN));
                }
                if (decorate_operand)
                {
                    if (context->instruction->encoding == ZYDIS_INSTRUCTION_ENCODING_MVEX)
                    {
                        ZYAN_CHECK(formatter->func_print_decorator(formatter, buffer, context,
                            ZYDIS_DECORATOR_SWIZZLE));
                    }
                    ZYAN_CHECK(formatter->func_print_decorator(formatter, buffer, context,
                        ZYDIS_DECORATOR_RC));
                    ZYAN_CHECK(formatter->func_print_decorator(formatter, buffer, context,
                        ZYDIS_DECORATOR_SAE));
                }
            }
        }
#endif
    }

    return ZYAN_STATUS_SUCCESS;
}

ZyanStatus ZydisFormatterIntelFormatOperandMEM(const ZydisFormatter* formatter,
    ZydisFormatterBuffer* buffer, ZydisFormatterContext* context)
{
    ZYAN_ASSERT(formatter);
    ZYAN_ASSERT(buffer);
    ZYAN_ASSERT(context);

    if ((context->operand->mem.type == ZYDIS_MEMOP_TYPE_MEM) ||
        (context->operand->mem.type == ZYDIS_MEMOP_TYPE_AGEN) ||
        (context->operand->mem.type == ZYDIS_MEMOP_TYPE_VSIB))
    {
        ZYAN_CHECK(formatter->func_print_typecast(formatter, buffer, context));
    }
    ZYAN_CHECK(formatter->func_print_segment(formatter, buffer, context));

    ZYDIS_BUFFER_APPEND(buffer, MEMORY_BEGIN_INTEL);

    const ZyanBool absolute = !formatter->force_relative_riprel &&
        (context->runtime_address != ZYDIS_RUNTIME_ADDRESS_NONE);
    if (absolute && context->operand->mem.disp.has_displacement &&
        (context->operand->mem.index == ZYDIS_REGISTER_NONE) &&
       ((context->operand->mem.base  == ZYDIS_REGISTER_NONE) ||
        (context->operand->mem.base  == ZYDIS_REGISTER_EIP ) ||
        (context->operand->mem.base  == ZYDIS_REGISTER_RIP )))
    {
        // EIP/RIP-relative or absolute-displacement address operand
        ZYAN_CHECK(formatter->func_print_address_abs(formatter, buffer, context));
    } else
    {
        const ZyanBool should_print_reg = context->operand->mem.base != ZYDIS_REGISTER_NONE;
        const ZyanBool should_print_idx = context->operand->mem.index != ZYDIS_REGISTER_NONE;
        const ZyanBool neither_reg_nor_idx = !should_print_reg && !should_print_idx;

        // Regular memory operand
        if (should_print_reg)
        {
            ZYAN_CHECK(formatter->func_print_register(formatter, buffer, context,
                context->operand->mem.base));
        }
        if (should_print_idx)
        {
            if (context->operand->mem.base != ZYDIS_REGISTER_NONE)
            {
                ZYDIS_BUFFER_APPEND(buffer, ADD);
            }
            ZYAN_CHECK(formatter->func_print_register(formatter, buffer, context,
                context->operand->mem.index));
            if (context->operand->mem.scale &&
                (context->operand->mem.type != ZYDIS_MEMOP_TYPE_MIB) &&
                ((context->operand->mem.scale > 1) || formatter->force_memory_scale))
            {
                ZYDIS_BUFFER_APPEND(buffer, MUL);
                ZYDIS_BUFFER_APPEND_TOKEN(buffer, ZYDIS_TOKEN_IMMEDIATE);
                ZYAN_CHECK(ZydisStringAppendDecU(&buffer->string, context->operand->mem.scale, 0,
                    ZYAN_NULL, ZYAN_NULL));
            }
        }
        if (neither_reg_nor_idx)
        {
            ZYAN_CHECK(formatter->func_print_address_abs(formatter, buffer, context));
        } else if (context->operand->mem.disp.has_displacement && context->operand->mem.disp.value)
        {
            ZYAN_CHECK(formatter->func_print_disp(formatter, buffer, context));
        }
    }

    ZYDIS_BUFFER_APPEND(buffer, MEMORY_END_INTEL);
    return ZYAN_STATUS_SUCCESS;
}

ZyanStatus ZydisFormatterIntelPrintMnemonic(const ZydisFormatter* formatter,
    ZydisFormatterBuffer* buffer, ZydisFormatterContext* context)
{
    ZYAN_ASSERT(formatter);
    ZYAN_ASSERT(buffer);
    ZYAN_ASSERT(context);

    const ZydisShortString* mnemonic = ZydisMnemonicGetStringWrapped(
        context->instruction->mnemonic);
    if (!mnemonic)
    {
        ZYDIS_BUFFER_APPEND_CASE(buffer, INVALID_MNEMONIC, formatter->case_mnemonic);
        return ZYAN_STATUS_SUCCESS;
    }

    ZYDIS_BUFFER_APPEND_TOKEN(buffer, ZYDIS_TOKEN_MNEMONIC);
    ZYAN_CHECK(ZydisStringAppendShortCase(&buffer->string, mnemonic, formatter->case_mnemonic));
    if (context->instruction->meta.branch_type == ZYDIS_BRANCH_TYPE_FAR)
    {
        return ZydisStringAppendShortCase(&buffer->string, &STR_FAR, formatter->case_mnemonic);
    }
    if (formatter->print_branch_size)
    {
        switch (context->instruction->meta.branch_type)
        {
        case ZYDIS_BRANCH_TYPE_NONE:
            break;
        case ZYDIS_BRANCH_TYPE_SHORT:
            return ZydisStringAppendShortCase(&buffer->string, &STR_SHORT,
                formatter->case_mnemonic);
        case ZYDIS_BRANCH_TYPE_NEAR:
            return ZydisStringAppendShortCase(&buffer->string, &STR_NEAR,
                formatter->case_mnemonic);
        default:
            return ZYAN_STATUS_INVALID_ARGUMENT;
        }
    }

    return ZYAN_STATUS_SUCCESS;
}

ZyanStatus ZydisFormatterIntelPrintRegister(const ZydisFormatter* formatter,
    ZydisFormatterBuffer* buffer, ZydisFormatterContext* context, ZydisRegister reg)
{
    ZYAN_UNUSED(context);

    ZYAN_ASSERT(formatter);
    ZYAN_ASSERT(buffer);
    ZYAN_ASSERT(context);

    const ZydisShortString* str = ZydisRegisterGetStringWrapped(reg);
    if (!str)
    {
        ZYDIS_BUFFER_APPEND_CASE(buffer, INVALID_REG, formatter->case_registers);
        return ZYAN_STATUS_SUCCESS;
    }

    ZYDIS_BUFFER_APPEND_TOKEN(buffer, ZYDIS_TOKEN_REGISTER);
    return ZydisStringAppendShortCase(&buffer->string, str, formatter->case_registers);
}

ZyanStatus ZydisFormatterIntelPrintDISP(const ZydisFormatter* formatter,
    ZydisFormatterBuffer* buffer, ZydisFormatterContext* context)
{
    ZYAN_ASSERT(formatter);
    ZYAN_ASSERT(buffer);
    ZYAN_ASSERT(context);

    switch (formatter->disp_signedness)
    {
    case ZYDIS_SIGNEDNESS_AUTO:
    case ZYDIS_SIGNEDNESS_SIGNED:
        if (context->operand->mem.disp.value < 0)
        {
            if ((context->operand->mem.base  != ZYDIS_REGISTER_NONE) ||
                (context->operand->mem.index != ZYDIS_REGISTER_NONE))
            {
                ZYDIS_BUFFER_APPEND(buffer, SUB);
            }
            ZYDIS_BUFFER_APPEND_TOKEN(buffer, ZYDIS_TOKEN_DISPLACEMENT);
            ZYDIS_STRING_APPEND_NUM_U(formatter, formatter->disp_base, &buffer->string,
                ZyanAbsI64(context->operand->mem.disp.value), formatter->disp_padding,
                formatter->hex_force_leading_number);
            break;
        }
        ZYAN_FALLTHROUGH;
    case ZYDIS_SIGNEDNESS_UNSIGNED:
        if ((context->operand->mem.base  != ZYDIS_REGISTER_NONE) ||
            (context->operand->mem.index != ZYDIS_REGISTER_NONE))
        {
            ZYDIS_BUFFER_APPEND(buffer, ADD);
        }
        ZYDIS_BUFFER_APPEND_TOKEN(buffer, ZYDIS_TOKEN_DISPLACEMENT);
        ZYDIS_STRING_APPEND_NUM_U(formatter, formatter->disp_base, &buffer->string,
            context->operand->mem.disp.value, formatter->disp_padding,
            formatter->hex_force_leading_number);
        break;
    default:
        return ZYAN_STATUS_INVALID_ARGUMENT;
    }

    return ZYAN_STATUS_SUCCESS;
}

ZyanStatus ZydisFormatterIntelPrintTypecast(const ZydisFormatter* formatter,
    ZydisFormatterBuffer* buffer, ZydisFormatterContext* context)
{
    ZYAN_ASSERT(formatter);
    ZYAN_ASSERT(buffer);
    ZYAN_ASSERT(context);

    switch (ZydisFormatterHelperGetExplicitSize(formatter, context, context->operand))
    {
    case   8: ZYDIS_BUFFER_APPEND(buffer, SIZE_8_INTEL  ); break;
    case  16: ZYDIS_BUFFER_APPEND(buffer, SIZE_16_INTEL ); break;
    case  32: ZYDIS_BUFFER_APPEND(buffer, SIZE_32_INTEL ); break;
    case  48: ZYDIS_BUFFER_APPEND(buffer, SIZE_48       ); break;
    case  64: ZYDIS_BUFFER_APPEND(buffer, SIZE_64_INTEL ); break;
    case  80: ZYDIS_BUFFER_APPEND(buffer, SIZE_80       ); break;
    case 128: ZYDIS_BUFFER_APPEND(buffer, SIZE_128_INTEL); break;
    case 256: ZYDIS_BUFFER_APPEND(buffer, SIZE_256_INTEL); break;
    case 512: ZYDIS_BUFFER_APPEND(buffer, SIZE_512_INTEL); break;
    default:
        break;
    }

    return ZYAN_STATUS_SUCCESS;
}

/* ---------------------------------------------------------------------------------------------- */
/* MASM                                                                                           */
/* ---------------------------------------------------------------------------------------------- */

ZyanStatus ZydisFormatterIntelFormatInstructionMASM(const ZydisFormatter* formatter,
    ZydisFormatterBuffer* buffer, ZydisFormatterContext* context)
{
    ZYAN_ASSERT(formatter);
    ZYAN_ASSERT(buffer);
    ZYAN_ASSERT(context);

    // Force the formatter to always call our MASM `ZYDIS_FORMATTER_PRINT_ADDRESS_ABS` function.
    // This implicitly omits printing of the `RIP`/`EIP` registers for `RIP`/`EIP`-relative
    // memory operands
    context->runtime_address = 0;

    return ZydisFormatterIntelFormatInstruction(formatter, buffer, context);
}

ZyanStatus ZydisFormatterIntelPrintAddressMASM(const ZydisFormatter* formatter,
    ZydisFormatterBuffer* buffer, ZydisFormatterContext* context)
{
    ZYAN_ASSERT(formatter);
    ZYAN_ASSERT(buffer);
    ZYAN_ASSERT(context);

    ZyanU64 address;
    ZYAN_CHECK(ZydisCalcAbsoluteAddress(context->instruction, context->operand, 0, &address));

    ZyanU8 padding = (formatter->addr_padding_relative ==
        ZYDIS_PADDING_AUTO) ? 0 : (ZyanU8)formatter->addr_padding_relative;
    if ((formatter->addr_padding_relative == ZYDIS_PADDING_AUTO) &&
        (formatter->addr_base == ZYDIS_NUMERIC_BASE_HEX))
    {
        switch (context->instruction->address_width)
        {
        case 16:
            padding =  4;
            address = (ZyanU16)address;
            break;
        case 32:
            padding =  8;
            address = (ZyanU32)address;
            break;
        case 64:
            padding = 16;
            break;
        default:
            return ZYAN_STATUS_INVALID_ARGUMENT;
        }
    }

    ZYDIS_BUFFER_APPEND(buffer, ADDR_RELATIVE);
    ZYDIS_STRING_APPEND_NUM_S(formatter, formatter->addr_base, &buffer->string, address, padding,
        formatter->hex_force_leading_number, ZYAN_TRUE);

    return ZYAN_STATUS_SUCCESS;
}

/* ---------------------------------------------------------------------------------------------- */

/* ============================================================================================== */

//
// Source file: /home/ath/devel/zydis/src/MetaInfo.c
//

/***************************************************************************************************

  Zyan Disassembler Library (Zydis)

  Original Author : Florian Bernd

 * Permission is hereby granted, free of charge, to any person obtaining a copy
 * of this software and associated documentation files (the "Software"), to deal
 * in the Software without restriction, including without limitation the rights
 * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
 * copies of the Software, and to permit persons to whom the Software is
 * furnished to do so, subject to the following conditions:
 *
 * The above copyright notice and this permission notice shall be included in all
 * copies or substantial portions of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
 * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
 * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
 * SOFTWARE.

***************************************************************************************************/


/* ============================================================================================== */
/* Enum strings                                                                                   */
/* ============================================================================================== */


//
// Header: Generated/EnumInstructionCategory.inc
//

static const char* STR_INSTRUCTIONCATEGORY[] =
{
    "INVALID",
    "ADOX_ADCX",
    "AES",
    "AMD3DNOW",
    "AMX_TILE",
    "AVX",
    "AVX2",
    "AVX2GATHER",
    "AVX512",
    "AVX512_4FMAPS",
    "AVX512_4VNNIW",
    "AVX512_BITALG",
    "AVX512_VBMI",
    "AVX512_VP2INTERSECT",
    "AVX_IFMA",
    "BINARY",
    "BITBYTE",
    "BLEND",
    "BMI1",
    "BMI2",
    "BROADCAST",
    "CALL",
    "CET",
    "CLDEMOTE",
    "CLFLUSHOPT",
    "CLWB",
    "CLZERO",
    "CMOV",
    "COMPRESS",
    "COND_BR",
    "CONFLICT",
    "CONVERT",
    "DATAXFER",
    "DECIMAL",
    "ENQCMD",
    "EXPAND",
    "FCMOV",
    "FLAGOP",
    "FMA4",
    "FP16",
    "GATHER",
    "GFNI",
    "HRESET",
    "IFMA",
    "INTERRUPT",
    "IO",
    "IOSTRINGOP",
    "KEYLOCKER",
    "KEYLOCKER_WIDE",
    "KMASK",
    "KNC",
    "KNCMASK",
    "KNCSCALAR",
    "LEGACY",
    "LOGICAL",
    "LOGICAL_FP",
    "LZCNT",
    "MISC",
    "MMX",
    "MOVDIR",
    "MPX",
    "MSRLIST",
    "NOP",
    "PADLOCK",
    "PBNDKB",
    "PCLMULQDQ",
    "PCOMMIT",
    "PCONFIG",
    "PKU",
    "POP",
    "PREFETCH",
    "PREFETCHWT1",
    "PT",
    "PUSH",
    "RDPID",
    "RDPRU",
    "RDRAND",
    "RDSEED",
    "RDWRFSGS",
    "RET",
    "ROTATE",
    "SCATTER",
    "SEGOP",
    "SEMAPHORE",
    "SERIALIZE",
    "SETCC",
    "SGX",
    "SHA",
    "SHA512",
    "SHIFT",
    "SMAP",
    "SSE",
    "STRINGOP",
    "STTNI",
    "SYSCALL",
    "SYSRET",
    "SYSTEM",
    "TBM",
    "TSX_LDTRK",
    "UFMA",
    "UINTR",
    "UNCOND_BR",
    "VAES",
    "VBMI2",
    "VEX",
    "VFMA",
    "VPCLMULQDQ",
    "VTX",
    "WAITPKG",
    "WIDENOP",
    "WRMSRNS",
    "X87_ALU",
    "XOP",
    "XSAVE",
    "XSAVEOPT"
};

//
// Header: Generated/EnumISASet.inc
//

static const char* STR_ISASET[] =
{
    "INVALID",
    "ADOX_ADCX",
    "AES",
    "AMD",
    "AMD3DNOW",
    "AMD_INVLPGB",
    "AMX_BF16",
    "AMX_FP16",
    "AMX_INT8",
    "AMX_TILE",
    "AVX",
    "AVX2",
    "AVX2GATHER",
    "AVX512BW_128",
    "AVX512BW_128N",
    "AVX512BW_256",
    "AVX512BW_512",
    "AVX512BW_KOP",
    "AVX512CD_128",
    "AVX512CD_256",
    "AVX512CD_512",
    "AVX512DQ_128",
    "AVX512DQ_128N",
    "AVX512DQ_256",
    "AVX512DQ_512",
    "AVX512DQ_KOP",
    "AVX512DQ_SCALAR",
    "AVX512ER_512",
    "AVX512ER_SCALAR",
    "AVX512F_128",
    "AVX512F_128N",
    "AVX512F_256",
    "AVX512F_512",
    "AVX512F_KOP",
    "AVX512F_SCALAR",
    "AVX512PF_512",
    "AVX512_4FMAPS_512",
    "AVX512_4FMAPS_SCALAR",
    "AVX512_4VNNIW_512",
    "AVX512_BF16_128",
    "AVX512_BF16_256",
    "AVX512_BF16_512",
    "AVX512_BITALG_128",
    "AVX512_BITALG_256",
    "AVX512_BITALG_512",
    "AVX512_FP16_128",
    "AVX512_FP16_128N",
    "AVX512_FP16_256",
    "AVX512_FP16_512",
    "AVX512_FP16_SCALAR",
    "AVX512_GFNI_128",
    "AVX512_GFNI_256",
    "AVX512_GFNI_512",
    "AVX512_IFMA_128",
    "AVX512_IFMA_256",
    "AVX512_IFMA_512",
    "AVX512_VAES_128",
    "AVX512_VAES_256",
    "AVX512_VAES_512",
    "AVX512_VBMI2_128",
    "AVX512_VBMI2_256",
    "AVX512_VBMI2_512",
    "AVX512_VBMI_128",
    "AVX512_VBMI_256",
    "AVX512_VBMI_512",
    "AVX512_VNNI_128",
    "AVX512_VNNI_256",
    "AVX512_VNNI_512",
    "AVX512_VP2INTERSECT_128",
    "AVX512_VP2INTERSECT_256",
    "AVX512_VP2INTERSECT_512",
    "AVX512_VPCLMULQDQ_128",
    "AVX512_VPCLMULQDQ_256",
    "AVX512_VPCLMULQDQ_512",
    "AVX512_VPOPCNTDQ_128",
    "AVX512_VPOPCNTDQ_256",
    "AVX512_VPOPCNTDQ_512",
    "AVXAES",
    "AVX_GFNI",
    "AVX_IFMA",
    "AVX_NE_CONVERT",
    "AVX_VNNI",
    "AVX_VNNI_INT16",
    "AVX_VNNI_INT8",
    "BMI1",
    "BMI2",
    "CET",
    "CLDEMOTE",
    "CLFLUSHOPT",
    "CLFSH",
    "CLWB",
    "CLZERO",
    "CMOV",
    "CMPXCHG16B",
    "ENQCMD",
    "F16C",
    "FAT_NOP",
    "FCMOV",
    "FCOMI",
    "FMA",
    "FMA4",
    "FXSAVE",
    "FXSAVE64",
    "GFNI",
    "HRESET",
    "I186",
    "I286PROTECTED",
    "I286REAL",
    "I386",
    "I486",
    "I486REAL",
    "I86",
    "ICACHE_PREFETCH",
    "INVPCID",
    "KEYLOCKER",
    "KEYLOCKER_WIDE",
    "KNCE",
    "KNCJKBR",
    "KNCSTREAM",
    "KNCV",
    "KNC_MISC",
    "KNC_PF_HINT",
    "LAHF",
    "LONGMODE",
    "LWP",
    "LZCNT",
    "MCOMMIT",
    "MONITOR",
    "MONITORX",
    "MOVBE",
    "MOVDIR",
    "MPX",
    "MSRLIST",
    "PADLOCK_ACE",
    "PADLOCK_PHE",
    "PADLOCK_PMM",
    "PADLOCK_RNG",
    "PAUSE",
    "PBNDKB",
    "PCLMULQDQ",
    "PCOMMIT",
    "PCONFIG",
    "PENTIUMMMX",
    "PENTIUMREAL",
    "PKU",
    "POPCNT",
    "PPRO",
    "PREFETCHWT1",
    "PREFETCH_NOP",
    "PT",
    "RAO_INT",
    "RDPID",
    "RDPMC",
    "RDPRU",
    "RDRAND",
    "RDSEED",
    "RDTSCP",
    "RDWRFSGS",
    "RTM",
    "SERIALIZE",
    "SGX",
    "SGX_ENCLV",
    "SHA",
    "SHA512",
    "SM3",
    "SM4",
    "SMAP",
    "SMX",
    "SNP",
    "SSE",
    "SSE2",
    "SSE2MMX",
    "SSE3",
    "SSE3X87",
    "SSE4",
    "SSE42",
    "SSE4A",
    "SSEMXCSR",
    "SSE_PREFETCH",
    "SSSE3",
    "SSSE3MMX",
    "SVM",
    "TBM",
    "TDX",
    "TSX_LDTRK",
    "UINTR",
    "VAES",
    "VMFUNC",
    "VPCLMULQDQ",
    "VTX",
    "WAITPKG",
    "WRMSRNS",
    "X87",
    "XOP",
    "XSAVE",
    "XSAVEC",
    "XSAVEOPT",
    "XSAVES"
};

//
// Header: Generated/EnumISAExt.inc
//

static const char* STR_ISAEXT[] =
{
    "INVALID",
    "ADOX_ADCX",
    "AES",
    "AMD3DNOW",
    "AMD3DNOW_PREFETCH",
    "AMD_INVLPGB",
    "AMX_BF16",
    "AMX_FP16",
    "AMX_INT8",
    "AMX_TILE",
    "AVX",
    "AVX2",
    "AVX2GATHER",
    "AVX512EVEX",
    "AVX512VEX",
    "AVXAES",
    "AVX_IFMA",
    "AVX_NE_CONVERT",
    "AVX_VNNI",
    "AVX_VNNI_INT16",
    "AVX_VNNI_INT8",
    "BASE",
    "BMI1",
    "BMI2",
    "CET",
    "CLDEMOTE",
    "CLFLUSHOPT",
    "CLFSH",
    "CLWB",
    "CLZERO",
    "ENQCMD",
    "F16C",
    "FMA",
    "FMA4",
    "GFNI",
    "HRESET",
    "ICACHE_PREFETCH",
    "INVPCID",
    "KEYLOCKER",
    "KEYLOCKER_WIDE",
    "KNC",
    "KNCE",
    "KNCV",
    "LONGMODE",
    "LZCNT",
    "MCOMMIT",
    "MMX",
    "MONITOR",
    "MONITORX",
    "MOVBE",
    "MOVDIR",
    "MPX",
    "MSRLIST",
    "PADLOCK",
    "PAUSE",
    "PBNDKB",
    "PCLMULQDQ",
    "PCOMMIT",
    "PCONFIG",
    "PKU",
    "PREFETCHWT1",
    "PT",
    "RAO_INT",
    "RDPID",
    "RDPRU",
    "RDRAND",
    "RDSEED",
    "RDTSCP",
    "RDWRFSGS",
    "RTM",
    "SERIALIZE",
    "SGX",
    "SGX_ENCLV",
    "SHA",
    "SHA512",
    "SM3",
    "SM4",
    "SMAP",
    "SMX",
    "SNP",
    "SSE",
    "SSE2",
    "SSE3",
    "SSE4",
    "SSE4A",
    "SSSE3",
    "SVM",
    "TBM",
    "TDX",
    "TSX_LDTRK",
    "UINTR",
    "VAES",
    "VMFUNC",
    "VPCLMULQDQ",
    "VTX",
    "WAITPKG",
    "WRMSRNS",
    "X87",
    "XOP",
    "XSAVE",
    "XSAVEC",
    "XSAVEOPT",
    "XSAVES"
};

/* ============================================================================================== */
/* Exported functions                                                                             */
/* ============================================================================================== */

const char* ZydisCategoryGetString(ZydisInstructionCategory category)
{
    if ((ZyanUSize)category >= ZYAN_ARRAY_LENGTH(STR_INSTRUCTIONCATEGORY))
    {
        return ZYAN_NULL;
    }
    return STR_INSTRUCTIONCATEGORY[category];
}

const char* ZydisISASetGetString(ZydisISASet isa_set)
{
    if ((ZyanUSize)isa_set >= ZYAN_ARRAY_LENGTH(STR_ISASET))
    {
        return ZYAN_NULL;
    }
    return STR_ISASET[isa_set];
}

const char* ZydisISAExtGetString(ZydisISAExt isa_ext)
{
    if ((ZyanUSize)isa_ext >= ZYAN_ARRAY_LENGTH(STR_ISAEXT))
    {
        return ZYAN_NULL;
    }
    return STR_ISAEXT[isa_ext];
}

/* ============================================================================================== */

//
// Source file: /home/ath/devel/zydis/src/Mnemonic.c
//

/***************************************************************************************************

  Zyan Disassembler Library (Zydis)

  Original Author : Florian Bernd

 * Permission is hereby granted, free of charge, to any person obtaining a copy
 * of this software and associated documentation files (the "Software"), to deal
 * in the Software without restriction, including without limitation the rights
 * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
 * copies of the Software, and to permit persons to whom the Software is
 * furnished to do so, subject to the following conditions:
 *
 * The above copyright notice and this permission notice shall be included in all
 * copies or substantial portions of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
 * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
 * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
 * SOFTWARE.

***************************************************************************************************/


//
// Header: Generated/EnumMnemonic.inc
//

static const ZydisShortString STR_MNEMONIC[] =
{
    ZYDIS_MAKE_SHORTSTRING("invalid"),
    ZYDIS_MAKE_SHORTSTRING("aaa"),
    ZYDIS_MAKE_SHORTSTRING("aad"),
    ZYDIS_MAKE_SHORTSTRING("aadd"),
    ZYDIS_MAKE_SHORTSTRING("aam"),
    ZYDIS_MAKE_SHORTSTRING("aand"),
    ZYDIS_MAKE_SHORTSTRING("aas"),
    ZYDIS_MAKE_SHORTSTRING("adc"),
    ZYDIS_MAKE_SHORTSTRING("adcx"),
    ZYDIS_MAKE_SHORTSTRING("add"),
    ZYDIS_MAKE_SHORTSTRING("addpd"),
    ZYDIS_MAKE_SHORTSTRING("addps"),
    ZYDIS_MAKE_SHORTSTRING("addsd"),
    ZYDIS_MAKE_SHORTSTRING("addss"),
    ZYDIS_MAKE_SHORTSTRING("addsubpd"),
    ZYDIS_MAKE_SHORTSTRING("addsubps"),
    ZYDIS_MAKE_SHORTSTRING("adox"),
    ZYDIS_MAKE_SHORTSTRING("aesdec"),
    ZYDIS_MAKE_SHORTSTRING("aesdec128kl"),
    ZYDIS_MAKE_SHORTSTRING("aesdec256kl"),
    ZYDIS_MAKE_SHORTSTRING("aesdeclast"),
    ZYDIS_MAKE_SHORTSTRING("aesdecwide128kl"),
    ZYDIS_MAKE_SHORTSTRING("aesdecwide256kl"),
    ZYDIS_MAKE_SHORTSTRING("aesenc"),
    ZYDIS_MAKE_SHORTSTRING("aesenc128kl"),
    ZYDIS_MAKE_SHORTSTRING("aesenc256kl"),
    ZYDIS_MAKE_SHORTSTRING("aesenclast"),
    ZYDIS_MAKE_SHORTSTRING("aesencwide128kl"),
    ZYDIS_MAKE_SHORTSTRING("aesencwide256kl"),
    ZYDIS_MAKE_SHORTSTRING("aesimc"),
    ZYDIS_MAKE_SHORTSTRING("aeskeygenassist"),
    ZYDIS_MAKE_SHORTSTRING("and"),
    ZYDIS_MAKE_SHORTSTRING("andn"),
    ZYDIS_MAKE_SHORTSTRING("andnpd"),
    ZYDIS_MAKE_SHORTSTRING("andnps"),
    ZYDIS_MAKE_SHORTSTRING("andpd"),
    ZYDIS_MAKE_SHORTSTRING("andps"),
    ZYDIS_MAKE_SHORTSTRING("aor"),
    ZYDIS_MAKE_SHORTSTRING("arpl"),
    ZYDIS_MAKE_SHORTSTRING("axor"),
    ZYDIS_MAKE_SHORTSTRING("bextr"),
    ZYDIS_MAKE_SHORTSTRING("blcfill"),
    ZYDIS_MAKE_SHORTSTRING("blci"),
    ZYDIS_MAKE_SHORTSTRING("blcic"),
    ZYDIS_MAKE_SHORTSTRING("blcmsk"),
    ZYDIS_MAKE_SHORTSTRING("blcs"),
    ZYDIS_MAKE_SHORTSTRING("blendpd"),
    ZYDIS_MAKE_SHORTSTRING("blendps"),
    ZYDIS_MAKE_SHORTSTRING("blendvpd"),
    ZYDIS_MAKE_SHORTSTRING("blendvps"),
    ZYDIS_MAKE_SHORTSTRING("blsfill"),
    ZYDIS_MAKE_SHORTSTRING("blsi"),
    ZYDIS_MAKE_SHORTSTRING("blsic"),
    ZYDIS_MAKE_SHORTSTRING("blsmsk"),
    ZYDIS_MAKE_SHORTSTRING("blsr"),
    ZYDIS_MAKE_SHORTSTRING("bndcl"),
    ZYDIS_MAKE_SHORTSTRING("bndcn"),
    ZYDIS_MAKE_SHORTSTRING("bndcu"),
    ZYDIS_MAKE_SHORTSTRING("bndldx"),
    ZYDIS_MAKE_SHORTSTRING("bndmk"),
    ZYDIS_MAKE_SHORTSTRING("bndmov"),
    ZYDIS_MAKE_SHORTSTRING("bndstx"),
    ZYDIS_MAKE_SHORTSTRING("bound"),
    ZYDIS_MAKE_SHORTSTRING("bsf"),
    ZYDIS_MAKE_SHORTSTRING("bsr"),
    ZYDIS_MAKE_SHORTSTRING("bswap"),
    ZYDIS_MAKE_SHORTSTRING("bt"),
    ZYDIS_MAKE_SHORTSTRING("btc"),
    ZYDIS_MAKE_SHORTSTRING("btr"),
    ZYDIS_MAKE_SHORTSTRING("bts"),
    ZYDIS_MAKE_SHORTSTRING("bzhi"),
    ZYDIS_MAKE_SHORTSTRING("call"),
    ZYDIS_MAKE_SHORTSTRING("cbw"),
    ZYDIS_MAKE_SHORTSTRING("cdq"),
    ZYDIS_MAKE_SHORTSTRING("cdqe"),
    ZYDIS_MAKE_SHORTSTRING("clac"),
    ZYDIS_MAKE_SHORTSTRING("clc"),
    ZYDIS_MAKE_SHORTSTRING("cld"),
    ZYDIS_MAKE_SHORTSTRING("cldemote"),
    ZYDIS_MAKE_SHORTSTRING("clevict0"),
    ZYDIS_MAKE_SHORTSTRING("clevict1"),
    ZYDIS_MAKE_SHORTSTRING("clflush"),
    ZYDIS_MAKE_SHORTSTRING("clflushopt"),
    ZYDIS_MAKE_SHORTSTRING("clgi"),
    ZYDIS_MAKE_SHORTSTRING("cli"),
    ZYDIS_MAKE_SHORTSTRING("clrssbsy"),
    ZYDIS_MAKE_SHORTSTRING("clts"),
    ZYDIS_MAKE_SHORTSTRING("clui"),
    ZYDIS_MAKE_SHORTSTRING("clwb"),
    ZYDIS_MAKE_SHORTSTRING("clzero"),
    ZYDIS_MAKE_SHORTSTRING("cmc"),
    ZYDIS_MAKE_SHORTSTRING("cmovb"),
    ZYDIS_MAKE_SHORTSTRING("cmovbe"),
    ZYDIS_MAKE_SHORTSTRING("cmovl"),
    ZYDIS_MAKE_SHORTSTRING("cmovle"),
    ZYDIS_MAKE_SHORTSTRING("cmovnb"),
    ZYDIS_MAKE_SHORTSTRING("cmovnbe"),
    ZYDIS_MAKE_SHORTSTRING("cmovnl"),
    ZYDIS_MAKE_SHORTSTRING("cmovnle"),
    ZYDIS_MAKE_SHORTSTRING("cmovno"),
    ZYDIS_MAKE_SHORTSTRING("cmovnp"),
    ZYDIS_MAKE_SHORTSTRING("cmovns"),
    ZYDIS_MAKE_SHORTSTRING("cmovnz"),
    ZYDIS_MAKE_SHORTSTRING("cmovo"),
    ZYDIS_MAKE_SHORTSTRING("cmovp"),
    ZYDIS_MAKE_SHORTSTRING("cmovs"),
    ZYDIS_MAKE_SHORTSTRING("cmovz"),
    ZYDIS_MAKE_SHORTSTRING("cmp"),
    ZYDIS_MAKE_SHORTSTRING("cmppd"),
    ZYDIS_MAKE_SHORTSTRING("cmpps"),
    ZYDIS_MAKE_SHORTSTRING("cmpsb"),
    ZYDIS_MAKE_SHORTSTRING("cmpsd"),
    ZYDIS_MAKE_SHORTSTRING("cmpsq"),
    ZYDIS_MAKE_SHORTSTRING("cmpss"),
    ZYDIS_MAKE_SHORTSTRING("cmpsw"),
    ZYDIS_MAKE_SHORTSTRING("cmpxchg"),
    ZYDIS_MAKE_SHORTSTRING("cmpxchg16b"),
    ZYDIS_MAKE_SHORTSTRING("cmpxchg8b"),
    ZYDIS_MAKE_SHORTSTRING("comisd"),
    ZYDIS_MAKE_SHORTSTRING("comiss"),
    ZYDIS_MAKE_SHORTSTRING("cpuid"),
    ZYDIS_MAKE_SHORTSTRING("cqo"),
    ZYDIS_MAKE_SHORTSTRING("crc32"),
    ZYDIS_MAKE_SHORTSTRING("cvtdq2pd"),
    ZYDIS_MAKE_SHORTSTRING("cvtdq2ps"),
    ZYDIS_MAKE_SHORTSTRING("cvtpd2dq"),
    ZYDIS_MAKE_SHORTSTRING("cvtpd2pi"),
    ZYDIS_MAKE_SHORTSTRING("cvtpd2ps"),
    ZYDIS_MAKE_SHORTSTRING("cvtpi2pd"),
    ZYDIS_MAKE_SHORTSTRING("cvtpi2ps"),
    ZYDIS_MAKE_SHORTSTRING("cvtps2dq"),
    ZYDIS_MAKE_SHORTSTRING("cvtps2pd"),
    ZYDIS_MAKE_SHORTSTRING("cvtps2pi"),
    ZYDIS_MAKE_SHORTSTRING("cvtsd2si"),
    ZYDIS_MAKE_SHORTSTRING("cvtsd2ss"),
    ZYDIS_MAKE_SHORTSTRING("cvtsi2sd"),
    ZYDIS_MAKE_SHORTSTRING("cvtsi2ss"),
    ZYDIS_MAKE_SHORTSTRING("cvtss2sd"),
    ZYDIS_MAKE_SHORTSTRING("cvtss2si"),
    ZYDIS_MAKE_SHORTSTRING("cvttpd2dq"),
    ZYDIS_MAKE_SHORTSTRING("cvttpd2pi"),
    ZYDIS_MAKE_SHORTSTRING("cvttps2dq"),
    ZYDIS_MAKE_SHORTSTRING("cvttps2pi"),
    ZYDIS_MAKE_SHORTSTRING("cvttsd2si"),
    ZYDIS_MAKE_SHORTSTRING("cvttss2si"),
    ZYDIS_MAKE_SHORTSTRING("cwd"),
    ZYDIS_MAKE_SHORTSTRING("cwde"),
    ZYDIS_MAKE_SHORTSTRING("daa"),
    ZYDIS_MAKE_SHORTSTRING("das"),
    ZYDIS_MAKE_SHORTSTRING("dec"),
    ZYDIS_MAKE_SHORTSTRING("delay"),
    ZYDIS_MAKE_SHORTSTRING("div"),
    ZYDIS_MAKE_SHORTSTRING("divpd"),
    ZYDIS_MAKE_SHORTSTRING("divps"),
    ZYDIS_MAKE_SHORTSTRING("divsd"),
    ZYDIS_MAKE_SHORTSTRING("divss"),
    ZYDIS_MAKE_SHORTSTRING("dppd"),
    ZYDIS_MAKE_SHORTSTRING("dpps"),
    ZYDIS_MAKE_SHORTSTRING("emms"),
    ZYDIS_MAKE_SHORTSTRING("encls"),
    ZYDIS_MAKE_SHORTSTRING("enclu"),
    ZYDIS_MAKE_SHORTSTRING("enclv"),
    ZYDIS_MAKE_SHORTSTRING("encodekey128"),
    ZYDIS_MAKE_SHORTSTRING("encodekey256"),
    ZYDIS_MAKE_SHORTSTRING("endbr32"),
    ZYDIS_MAKE_SHORTSTRING("endbr64"),
    ZYDIS_MAKE_SHORTSTRING("enqcmd"),
    ZYDIS_MAKE_SHORTSTRING("enqcmds"),
    ZYDIS_MAKE_SHORTSTRING("enter"),
    ZYDIS_MAKE_SHORTSTRING("extractps"),
    ZYDIS_MAKE_SHORTSTRING("extrq"),
    ZYDIS_MAKE_SHORTSTRING("f2xm1"),
    ZYDIS_MAKE_SHORTSTRING("fabs"),
    ZYDIS_MAKE_SHORTSTRING("fadd"),
    ZYDIS_MAKE_SHORTSTRING("faddp"),
    ZYDIS_MAKE_SHORTSTRING("fbld"),
    ZYDIS_MAKE_SHORTSTRING("fbstp"),
    ZYDIS_MAKE_SHORTSTRING("fchs"),
    ZYDIS_MAKE_SHORTSTRING("fcmovb"),
    ZYDIS_MAKE_SHORTSTRING("fcmovbe"),
    ZYDIS_MAKE_SHORTSTRING("fcmove"),
    ZYDIS_MAKE_SHORTSTRING("fcmovnb"),
    ZYDIS_MAKE_SHORTSTRING("fcmovnbe"),
    ZYDIS_MAKE_SHORTSTRING("fcmovne"),
    ZYDIS_MAKE_SHORTSTRING("fcmovnu"),
    ZYDIS_MAKE_SHORTSTRING("fcmovu"),
    ZYDIS_MAKE_SHORTSTRING("fcom"),
    ZYDIS_MAKE_SHORTSTRING("fcomi"),
    ZYDIS_MAKE_SHORTSTRING("fcomip"),
    ZYDIS_MAKE_SHORTSTRING("fcomp"),
    ZYDIS_MAKE_SHORTSTRING("fcompp"),
    ZYDIS_MAKE_SHORTSTRING("fcos"),
    ZYDIS_MAKE_SHORTSTRING("fdecstp"),
    ZYDIS_MAKE_SHORTSTRING("fdisi8087_nop"),
    ZYDIS_MAKE_SHORTSTRING("fdiv"),
    ZYDIS_MAKE_SHORTSTRING("fdivp"),
    ZYDIS_MAKE_SHORTSTRING("fdivr"),
    ZYDIS_MAKE_SHORTSTRING("fdivrp"),
    ZYDIS_MAKE_SHORTSTRING("femms"),
    ZYDIS_MAKE_SHORTSTRING("feni8087_nop"),
    ZYDIS_MAKE_SHORTSTRING("ffree"),
    ZYDIS_MAKE_SHORTSTRING("ffreep"),
    ZYDIS_MAKE_SHORTSTRING("fiadd"),
    ZYDIS_MAKE_SHORTSTRING("ficom"),
    ZYDIS_MAKE_SHORTSTRING("ficomp"),
    ZYDIS_MAKE_SHORTSTRING("fidiv"),
    ZYDIS_MAKE_SHORTSTRING("fidivr"),
    ZYDIS_MAKE_SHORTSTRING("fild"),
    ZYDIS_MAKE_SHORTSTRING("fimul"),
    ZYDIS_MAKE_SHORTSTRING("fincstp"),
    ZYDIS_MAKE_SHORTSTRING("fist"),
    ZYDIS_MAKE_SHORTSTRING("fistp"),
    ZYDIS_MAKE_SHORTSTRING("fisttp"),
    ZYDIS_MAKE_SHORTSTRING("fisub"),
    ZYDIS_MAKE_SHORTSTRING("fisubr"),
    ZYDIS_MAKE_SHORTSTRING("fld"),
    ZYDIS_MAKE_SHORTSTRING("fld1"),
    ZYDIS_MAKE_SHORTSTRING("fldcw"),
    ZYDIS_MAKE_SHORTSTRING("fldenv"),
    ZYDIS_MAKE_SHORTSTRING("fldl2e"),
    ZYDIS_MAKE_SHORTSTRING("fldl2t"),
    ZYDIS_MAKE_SHORTSTRING("fldlg2"),
    ZYDIS_MAKE_SHORTSTRING("fldln2"),
    ZYDIS_MAKE_SHORTSTRING("fldpi"),
    ZYDIS_MAKE_SHORTSTRING("fldz"),
    ZYDIS_MAKE_SHORTSTRING("fmul"),
    ZYDIS_MAKE_SHORTSTRING("fmulp"),
    ZYDIS_MAKE_SHORTSTRING("fnclex"),
    ZYDIS_MAKE_SHORTSTRING("fninit"),
    ZYDIS_MAKE_SHORTSTRING("fnop"),
    ZYDIS_MAKE_SHORTSTRING("fnsave"),
    ZYDIS_MAKE_SHORTSTRING("fnstcw"),
    ZYDIS_MAKE_SHORTSTRING("fnstenv"),
    ZYDIS_MAKE_SHORTSTRING("fnstsw"),
    ZYDIS_MAKE_SHORTSTRING("fpatan"),
    ZYDIS_MAKE_SHORTSTRING("fprem"),
    ZYDIS_MAKE_SHORTSTRING("fprem1"),
    ZYDIS_MAKE_SHORTSTRING("fptan"),
    ZYDIS_MAKE_SHORTSTRING("frndint"),
    ZYDIS_MAKE_SHORTSTRING("frstor"),
    ZYDIS_MAKE_SHORTSTRING("fscale"),
    ZYDIS_MAKE_SHORTSTRING("fsetpm287_nop"),
    ZYDIS_MAKE_SHORTSTRING("fsin"),
    ZYDIS_MAKE_SHORTSTRING("fsincos"),
    ZYDIS_MAKE_SHORTSTRING("fsqrt"),
    ZYDIS_MAKE_SHORTSTRING("fst"),
    ZYDIS_MAKE_SHORTSTRING("fstp"),
    ZYDIS_MAKE_SHORTSTRING("fstpnce"),
    ZYDIS_MAKE_SHORTSTRING("fsub"),
    ZYDIS_MAKE_SHORTSTRING("fsubp"),
    ZYDIS_MAKE_SHORTSTRING("fsubr"),
    ZYDIS_MAKE_SHORTSTRING("fsubrp"),
    ZYDIS_MAKE_SHORTSTRING("ftst"),
    ZYDIS_MAKE_SHORTSTRING("fucom"),
    ZYDIS_MAKE_SHORTSTRING("fucomi"),
    ZYDIS_MAKE_SHORTSTRING("fucomip"),
    ZYDIS_MAKE_SHORTSTRING("fucomp"),
    ZYDIS_MAKE_SHORTSTRING("fucompp"),
    ZYDIS_MAKE_SHORTSTRING("fwait"),
    ZYDIS_MAKE_SHORTSTRING("fxam"),
    ZYDIS_MAKE_SHORTSTRING("fxch"),
    ZYDIS_MAKE_SHORTSTRING("fxrstor"),
    ZYDIS_MAKE_SHORTSTRING("fxrstor64"),
    ZYDIS_MAKE_SHORTSTRING("fxsave"),
    ZYDIS_MAKE_SHORTSTRING("fxsave64"),
    ZYDIS_MAKE_SHORTSTRING("fxtract"),
    ZYDIS_MAKE_SHORTSTRING("fyl2x"),
    ZYDIS_MAKE_SHORTSTRING("fyl2xp1"),
    ZYDIS_MAKE_SHORTSTRING("getsec"),
    ZYDIS_MAKE_SHORTSTRING("gf2p8affineinvqb"),
    ZYDIS_MAKE_SHORTSTRING("gf2p8affineqb"),
    ZYDIS_MAKE_SHORTSTRING("gf2p8mulb"),
    ZYDIS_MAKE_SHORTSTRING("haddpd"),
    ZYDIS_MAKE_SHORTSTRING("haddps"),
    ZYDIS_MAKE_SHORTSTRING("hlt"),
    ZYDIS_MAKE_SHORTSTRING("hreset"),
    ZYDIS_MAKE_SHORTSTRING("hsubpd"),
    ZYDIS_MAKE_SHORTSTRING("hsubps"),
    ZYDIS_MAKE_SHORTSTRING("idiv"),
    ZYDIS_MAKE_SHORTSTRING("imul"),
    ZYDIS_MAKE_SHORTSTRING("in"),
    ZYDIS_MAKE_SHORTSTRING("inc"),
    ZYDIS_MAKE_SHORTSTRING("incsspd"),
    ZYDIS_MAKE_SHORTSTRING("incsspq"),
    ZYDIS_MAKE_SHORTSTRING("insb"),
    ZYDIS_MAKE_SHORTSTRING("insd"),
    ZYDIS_MAKE_SHORTSTRING("insertps"),
    ZYDIS_MAKE_SHORTSTRING("insertq"),
    ZYDIS_MAKE_SHORTSTRING("insw"),
    ZYDIS_MAKE_SHORTSTRING("int"),
    ZYDIS_MAKE_SHORTSTRING("int1"),
    ZYDIS_MAKE_SHORTSTRING("int3"),
    ZYDIS_MAKE_SHORTSTRING("into"),
    ZYDIS_MAKE_SHORTSTRING("invd"),
    ZYDIS_MAKE_SHORTSTRING("invept"),
    ZYDIS_MAKE_SHORTSTRING("invlpg"),
    ZYDIS_MAKE_SHORTSTRING("invlpga"),
    ZYDIS_MAKE_SHORTSTRING("invlpgb"),
    ZYDIS_MAKE_SHORTSTRING("invpcid"),
    ZYDIS_MAKE_SHORTSTRING("invvpid"),
    ZYDIS_MAKE_SHORTSTRING("iret"),
    ZYDIS_MAKE_SHORTSTRING("iretd"),
    ZYDIS_MAKE_SHORTSTRING("iretq"),
    ZYDIS_MAKE_SHORTSTRING("jb"),
    ZYDIS_MAKE_SHORTSTRING("jbe"),
    ZYDIS_MAKE_SHORTSTRING("jcxz"),
    ZYDIS_MAKE_SHORTSTRING("jecxz"),
    ZYDIS_MAKE_SHORTSTRING("jknzd"),
    ZYDIS_MAKE_SHORTSTRING("jkzd"),
    ZYDIS_MAKE_SHORTSTRING("jl"),
    ZYDIS_MAKE_SHORTSTRING("jle"),
    ZYDIS_MAKE_SHORTSTRING("jmp"),
    ZYDIS_MAKE_SHORTSTRING("jnb"),
    ZYDIS_MAKE_SHORTSTRING("jnbe"),
    ZYDIS_MAKE_SHORTSTRING("jnl"),
    ZYDIS_MAKE_SHORTSTRING("jnle"),
    ZYDIS_MAKE_SHORTSTRING("jno"),
    ZYDIS_MAKE_SHORTSTRING("jnp"),
    ZYDIS_MAKE_SHORTSTRING("jns"),
    ZYDIS_MAKE_SHORTSTRING("jnz"),
    ZYDIS_MAKE_SHORTSTRING("jo"),
    ZYDIS_MAKE_SHORTSTRING("jp"),
    ZYDIS_MAKE_SHORTSTRING("jrcxz"),
    ZYDIS_MAKE_SHORTSTRING("js"),
    ZYDIS_MAKE_SHORTSTRING("jz"),
    ZYDIS_MAKE_SHORTSTRING("kaddb"),
    ZYDIS_MAKE_SHORTSTRING("kaddd"),
    ZYDIS_MAKE_SHORTSTRING("kaddq"),
    ZYDIS_MAKE_SHORTSTRING("kaddw"),
    ZYDIS_MAKE_SHORTSTRING("kand"),
    ZYDIS_MAKE_SHORTSTRING("kandb"),
    ZYDIS_MAKE_SHORTSTRING("kandd"),
    ZYDIS_MAKE_SHORTSTRING("kandn"),
    ZYDIS_MAKE_SHORTSTRING("kandnb"),
    ZYDIS_MAKE_SHORTSTRING("kandnd"),
    ZYDIS_MAKE_SHORTSTRING("kandnq"),
    ZYDIS_MAKE_SHORTSTRING("kandnr"),
    ZYDIS_MAKE_SHORTSTRING("kandnw"),
    ZYDIS_MAKE_SHORTSTRING("kandq"),
    ZYDIS_MAKE_SHORTSTRING("kandw"),
    ZYDIS_MAKE_SHORTSTRING("kconcath"),
    ZYDIS_MAKE_SHORTSTRING("kconcatl"),
    ZYDIS_MAKE_SHORTSTRING("kextract"),
    ZYDIS_MAKE_SHORTSTRING("kmerge2l1h"),
    ZYDIS_MAKE_SHORTSTRING("kmerge2l1l"),
    ZYDIS_MAKE_SHORTSTRING("kmov"),
    ZYDIS_MAKE_SHORTSTRING("kmovb"),
    ZYDIS_MAKE_SHORTSTRING("kmovd"),
    ZYDIS_MAKE_SHORTSTRING("kmovq"),
    ZYDIS_MAKE_SHORTSTRING("kmovw"),
    ZYDIS_MAKE_SHORTSTRING("knot"),
    ZYDIS_MAKE_SHORTSTRING("knotb"),
    ZYDIS_MAKE_SHORTSTRING("knotd"),
    ZYDIS_MAKE_SHORTSTRING("knotq"),
    ZYDIS_MAKE_SHORTSTRING("knotw"),
    ZYDIS_MAKE_SHORTSTRING("kor"),
    ZYDIS_MAKE_SHORTSTRING("korb"),
    ZYDIS_MAKE_SHORTSTRING("kord"),
    ZYDIS_MAKE_SHORTSTRING("korq"),
    ZYDIS_MAKE_SHORTSTRING("kortest"),
    ZYDIS_MAKE_SHORTSTRING("kortestb"),
    ZYDIS_MAKE_SHORTSTRING("kortestd"),
    ZYDIS_MAKE_SHORTSTRING("kortestq"),
    ZYDIS_MAKE_SHORTSTRING("kortestw"),
    ZYDIS_MAKE_SHORTSTRING("korw"),
    ZYDIS_MAKE_SHORTSTRING("kshiftlb"),
    ZYDIS_MAKE_SHORTSTRING("kshiftld"),
    ZYDIS_MAKE_SHORTSTRING("kshiftlq"),
    ZYDIS_MAKE_SHORTSTRING("kshiftlw"),
    ZYDIS_MAKE_SHORTSTRING("kshiftrb"),
    ZYDIS_MAKE_SHORTSTRING("kshiftrd"),
    ZYDIS_MAKE_SHORTSTRING("kshiftrq"),
    ZYDIS_MAKE_SHORTSTRING("kshiftrw"),
    ZYDIS_MAKE_SHORTSTRING("ktestb"),
    ZYDIS_MAKE_SHORTSTRING("ktestd"),
    ZYDIS_MAKE_SHORTSTRING("ktestq"),
    ZYDIS_MAKE_SHORTSTRING("ktestw"),
    ZYDIS_MAKE_SHORTSTRING("kunpckbw"),
    ZYDIS_MAKE_SHORTSTRING("kunpckdq"),
    ZYDIS_MAKE_SHORTSTRING("kunpckwd"),
    ZYDIS_MAKE_SHORTSTRING("kxnor"),
    ZYDIS_MAKE_SHORTSTRING("kxnorb"),
    ZYDIS_MAKE_SHORTSTRING("kxnord"),
    ZYDIS_MAKE_SHORTSTRING("kxnorq"),
    ZYDIS_MAKE_SHORTSTRING("kxnorw"),
    ZYDIS_MAKE_SHORTSTRING("kxor"),
    ZYDIS_MAKE_SHORTSTRING("kxorb"),
    ZYDIS_MAKE_SHORTSTRING("kxord"),
    ZYDIS_MAKE_SHORTSTRING("kxorq"),
    ZYDIS_MAKE_SHORTSTRING("kxorw"),
    ZYDIS_MAKE_SHORTSTRING("lahf"),
    ZYDIS_MAKE_SHORTSTRING("lar"),
    ZYDIS_MAKE_SHORTSTRING("lddqu"),
    ZYDIS_MAKE_SHORTSTRING("ldmxcsr"),
    ZYDIS_MAKE_SHORTSTRING("lds"),
    ZYDIS_MAKE_SHORTSTRING("ldtilecfg"),
    ZYDIS_MAKE_SHORTSTRING("lea"),
    ZYDIS_MAKE_SHORTSTRING("leave"),
    ZYDIS_MAKE_SHORTSTRING("les"),
    ZYDIS_MAKE_SHORTSTRING("lfence"),
    ZYDIS_MAKE_SHORTSTRING("lfs"),
    ZYDIS_MAKE_SHORTSTRING("lgdt"),
    ZYDIS_MAKE_SHORTSTRING("lgs"),
    ZYDIS_MAKE_SHORTSTRING("lidt"),
    ZYDIS_MAKE_SHORTSTRING("lldt"),
    ZYDIS_MAKE_SHORTSTRING("llwpcb"),
    ZYDIS_MAKE_SHORTSTRING("lmsw"),
    ZYDIS_MAKE_SHORTSTRING("loadiwkey"),
    ZYDIS_MAKE_SHORTSTRING("lodsb"),
    ZYDIS_MAKE_SHORTSTRING("lodsd"),
    ZYDIS_MAKE_SHORTSTRING("lodsq"),
    ZYDIS_MAKE_SHORTSTRING("lodsw"),
    ZYDIS_MAKE_SHORTSTRING("loop"),
    ZYDIS_MAKE_SHORTSTRING("loope"),
    ZYDIS_MAKE_SHORTSTRING("loopne"),
    ZYDIS_MAKE_SHORTSTRING("lsl"),
    ZYDIS_MAKE_SHORTSTRING("lss"),
    ZYDIS_MAKE_SHORTSTRING("ltr"),
    ZYDIS_MAKE_SHORTSTRING("lwpins"),
    ZYDIS_MAKE_SHORTSTRING("lwpval"),
    ZYDIS_MAKE_SHORTSTRING("lzcnt"),
    ZYDIS_MAKE_SHORTSTRING("maskmovdqu"),
    ZYDIS_MAKE_SHORTSTRING("maskmovq"),
    ZYDIS_MAKE_SHORTSTRING("maxpd"),
    ZYDIS_MAKE_SHORTSTRING("maxps"),
    ZYDIS_MAKE_SHORTSTRING("maxsd"),
    ZYDIS_MAKE_SHORTSTRING("maxss"),
    ZYDIS_MAKE_SHORTSTRING("mcommit"),
    ZYDIS_MAKE_SHORTSTRING("mfence"),
    ZYDIS_MAKE_SHORTSTRING("minpd"),
    ZYDIS_MAKE_SHORTSTRING("minps"),
    ZYDIS_MAKE_SHORTSTRING("minsd"),
    ZYDIS_MAKE_SHORTSTRING("minss"),
    ZYDIS_MAKE_SHORTSTRING("monitor"),
    ZYDIS_MAKE_SHORTSTRING("monitorx"),
    ZYDIS_MAKE_SHORTSTRING("montmul"),
    ZYDIS_MAKE_SHORTSTRING("mov"),
    ZYDIS_MAKE_SHORTSTRING("movapd"),
    ZYDIS_MAKE_SHORTSTRING("movaps"),
    ZYDIS_MAKE_SHORTSTRING("movbe"),
    ZYDIS_MAKE_SHORTSTRING("movd"),
    ZYDIS_MAKE_SHORTSTRING("movddup"),
    ZYDIS_MAKE_SHORTSTRING("movdir64b"),
    ZYDIS_MAKE_SHORTSTRING("movdiri"),
    ZYDIS_MAKE_SHORTSTRING("movdq2q"),
    ZYDIS_MAKE_SHORTSTRING("movdqa"),
    ZYDIS_MAKE_SHORTSTRING("movdqu"),
    ZYDIS_MAKE_SHORTSTRING("movhlps"),
    ZYDIS_MAKE_SHORTSTRING("movhpd"),
    ZYDIS_MAKE_SHORTSTRING("movhps"),
    ZYDIS_MAKE_SHORTSTRING("movlhps"),
    ZYDIS_MAKE_SHORTSTRING("movlpd"),
    ZYDIS_MAKE_SHORTSTRING("movlps"),
    ZYDIS_MAKE_SHORTSTRING("movmskpd"),
    ZYDIS_MAKE_SHORTSTRING("movmskps"),
    ZYDIS_MAKE_SHORTSTRING("movntdq"),
    ZYDIS_MAKE_SHORTSTRING("movntdqa"),
    ZYDIS_MAKE_SHORTSTRING("movnti"),
    ZYDIS_MAKE_SHORTSTRING("movntpd"),
    ZYDIS_MAKE_SHORTSTRING("movntps"),
    ZYDIS_MAKE_SHORTSTRING("movntq"),
    ZYDIS_MAKE_SHORTSTRING("movntsd"),
    ZYDIS_MAKE_SHORTSTRING("movntss"),
    ZYDIS_MAKE_SHORTSTRING("movq"),
    ZYDIS_MAKE_SHORTSTRING("movq2dq"),
    ZYDIS_MAKE_SHORTSTRING("movsb"),
    ZYDIS_MAKE_SHORTSTRING("movsd"),
    ZYDIS_MAKE_SHORTSTRING("movshdup"),
    ZYDIS_MAKE_SHORTSTRING("movsldup"),
    ZYDIS_MAKE_SHORTSTRING("movsq"),
    ZYDIS_MAKE_SHORTSTRING("movss"),
    ZYDIS_MAKE_SHORTSTRING("movsw"),
    ZYDIS_MAKE_SHORTSTRING("movsx"),
    ZYDIS_MAKE_SHORTSTRING("movsxd"),
    ZYDIS_MAKE_SHORTSTRING("movupd"),
    ZYDIS_MAKE_SHORTSTRING("movups"),
    ZYDIS_MAKE_SHORTSTRING("movzx"),
    ZYDIS_MAKE_SHORTSTRING("mpsadbw"),
    ZYDIS_MAKE_SHORTSTRING("mul"),
    ZYDIS_MAKE_SHORTSTRING("mulpd"),
    ZYDIS_MAKE_SHORTSTRING("mulps"),
    ZYDIS_MAKE_SHORTSTRING("mulsd"),
    ZYDIS_MAKE_SHORTSTRING("mulss"),
    ZYDIS_MAKE_SHORTSTRING("mulx"),
    ZYDIS_MAKE_SHORTSTRING("mwait"),
    ZYDIS_MAKE_SHORTSTRING("mwaitx"),
    ZYDIS_MAKE_SHORTSTRING("neg"),
    ZYDIS_MAKE_SHORTSTRING("nop"),
    ZYDIS_MAKE_SHORTSTRING("not"),
    ZYDIS_MAKE_SHORTSTRING("or"),
    ZYDIS_MAKE_SHORTSTRING("orpd"),
    ZYDIS_MAKE_SHORTSTRING("orps"),
    ZYDIS_MAKE_SHORTSTRING("out"),
    ZYDIS_MAKE_SHORTSTRING("outsb"),
    ZYDIS_MAKE_SHORTSTRING("outsd"),
    ZYDIS_MAKE_SHORTSTRING("outsw"),
    ZYDIS_MAKE_SHORTSTRING("pabsb"),
    ZYDIS_MAKE_SHORTSTRING("pabsd"),
    ZYDIS_MAKE_SHORTSTRING("pabsw"),
    ZYDIS_MAKE_SHORTSTRING("packssdw"),
    ZYDIS_MAKE_SHORTSTRING("packsswb"),
    ZYDIS_MAKE_SHORTSTRING("packusdw"),
    ZYDIS_MAKE_SHORTSTRING("packuswb"),
    ZYDIS_MAKE_SHORTSTRING("paddb"),
    ZYDIS_MAKE_SHORTSTRING("paddd"),
    ZYDIS_MAKE_SHORTSTRING("paddq"),
    ZYDIS_MAKE_SHORTSTRING("paddsb"),
    ZYDIS_MAKE_SHORTSTRING("paddsw"),
    ZYDIS_MAKE_SHORTSTRING("paddusb"),
    ZYDIS_MAKE_SHORTSTRING("paddusw"),
    ZYDIS_MAKE_SHORTSTRING("paddw"),
    ZYDIS_MAKE_SHORTSTRING("palignr"),
    ZYDIS_MAKE_SHORTSTRING("pand"),
    ZYDIS_MAKE_SHORTSTRING("pandn"),
    ZYDIS_MAKE_SHORTSTRING("pause"),
    ZYDIS_MAKE_SHORTSTRING("pavgb"),
    ZYDIS_MAKE_SHORTSTRING("pavgusb"),
    ZYDIS_MAKE_SHORTSTRING("pavgw"),
    ZYDIS_MAKE_SHORTSTRING("pblendvb"),
    ZYDIS_MAKE_SHORTSTRING("pblendw"),
    ZYDIS_MAKE_SHORTSTRING("pbndkb"),
    ZYDIS_MAKE_SHORTSTRING("pclmulqdq"),
    ZYDIS_MAKE_SHORTSTRING("pcmpeqb"),
    ZYDIS_MAKE_SHORTSTRING("pcmpeqd"),
    ZYDIS_MAKE_SHORTSTRING("pcmpeqq"),
    ZYDIS_MAKE_SHORTSTRING("pcmpeqw"),
    ZYDIS_MAKE_SHORTSTRING("pcmpestri"),
    ZYDIS_MAKE_SHORTSTRING("pcmpestrm"),
    ZYDIS_MAKE_SHORTSTRING("pcmpgtb"),
    ZYDIS_MAKE_SHORTSTRING("pcmpgtd"),
    ZYDIS_MAKE_SHORTSTRING("pcmpgtq"),
    ZYDIS_MAKE_SHORTSTRING("pcmpgtw"),
    ZYDIS_MAKE_SHORTSTRING("pcmpistri"),
    ZYDIS_MAKE_SHORTSTRING("pcmpistrm"),
    ZYDIS_MAKE_SHORTSTRING("pcommit"),
    ZYDIS_MAKE_SHORTSTRING("pconfig"),
    ZYDIS_MAKE_SHORTSTRING("pdep"),
    ZYDIS_MAKE_SHORTSTRING("pext"),
    ZYDIS_MAKE_SHORTSTRING("pextrb"),
    ZYDIS_MAKE_SHORTSTRING("pextrd"),
    ZYDIS_MAKE_SHORTSTRING("pextrq"),
    ZYDIS_MAKE_SHORTSTRING("pextrw"),
    ZYDIS_MAKE_SHORTSTRING("pf2id"),
    ZYDIS_MAKE_SHORTSTRING("pf2iw"),
    ZYDIS_MAKE_SHORTSTRING("pfacc"),
    ZYDIS_MAKE_SHORTSTRING("pfadd"),
    ZYDIS_MAKE_SHORTSTRING("pfcmpeq"),
    ZYDIS_MAKE_SHORTSTRING("pfcmpge"),
    ZYDIS_MAKE_SHORTSTRING("pfcmpgt"),
    ZYDIS_MAKE_SHORTSTRING("pfcpit1"),
    ZYDIS_MAKE_SHORTSTRING("pfmax"),
    ZYDIS_MAKE_SHORTSTRING("pfmin"),
    ZYDIS_MAKE_SHORTSTRING("pfmul"),
    ZYDIS_MAKE_SHORTSTRING("pfnacc"),
    ZYDIS_MAKE_SHORTSTRING("pfpnacc"),
    ZYDIS_MAKE_SHORTSTRING("pfrcp"),
    ZYDIS_MAKE_SHORTSTRING("pfrcpit2"),
    ZYDIS_MAKE_SHORTSTRING("pfrsqit1"),
    ZYDIS_MAKE_SHORTSTRING("pfsqrt"),
    ZYDIS_MAKE_SHORTSTRING("pfsub"),
    ZYDIS_MAKE_SHORTSTRING("pfsubr"),
    ZYDIS_MAKE_SHORTSTRING("phaddd"),
    ZYDIS_MAKE_SHORTSTRING("phaddsw"),
    ZYDIS_MAKE_SHORTSTRING("phaddw"),
    ZYDIS_MAKE_SHORTSTRING("phminposuw"),
    ZYDIS_MAKE_SHORTSTRING("phsubd"),
    ZYDIS_MAKE_SHORTSTRING("phsubsw"),
    ZYDIS_MAKE_SHORTSTRING("phsubw"),
    ZYDIS_MAKE_SHORTSTRING("pi2fd"),
    ZYDIS_MAKE_SHORTSTRING("pi2fw"),
    ZYDIS_MAKE_SHORTSTRING("pinsrb"),
    ZYDIS_MAKE_SHORTSTRING("pinsrd"),
    ZYDIS_MAKE_SHORTSTRING("pinsrq"),
    ZYDIS_MAKE_SHORTSTRING("pinsrw"),
    ZYDIS_MAKE_SHORTSTRING("pmaddubsw"),
    ZYDIS_MAKE_SHORTSTRING("pmaddwd"),
    ZYDIS_MAKE_SHORTSTRING("pmaxsb"),
    ZYDIS_MAKE_SHORTSTRING("pmaxsd"),
    ZYDIS_MAKE_SHORTSTRING("pmaxsw"),
    ZYDIS_MAKE_SHORTSTRING("pmaxub"),
    ZYDIS_MAKE_SHORTSTRING("pmaxud"),
    ZYDIS_MAKE_SHORTSTRING("pmaxuw"),
    ZYDIS_MAKE_SHORTSTRING("pminsb"),
    ZYDIS_MAKE_SHORTSTRING("pminsd"),
    ZYDIS_MAKE_SHORTSTRING("pminsw"),
    ZYDIS_MAKE_SHORTSTRING("pminub"),
    ZYDIS_MAKE_SHORTSTRING("pminud"),
    ZYDIS_MAKE_SHORTSTRING("pminuw"),
    ZYDIS_MAKE_SHORTSTRING("pmovmskb"),
    ZYDIS_MAKE_SHORTSTRING("pmovsxbd"),
    ZYDIS_MAKE_SHORTSTRING("pmovsxbq"),
    ZYDIS_MAKE_SHORTSTRING("pmovsxbw"),
    ZYDIS_MAKE_SHORTSTRING("pmovsxdq"),
    ZYDIS_MAKE_SHORTSTRING("pmovsxwd"),
    ZYDIS_MAKE_SHORTSTRING("pmovsxwq"),
    ZYDIS_MAKE_SHORTSTRING("pmovzxbd"),
    ZYDIS_MAKE_SHORTSTRING("pmovzxbq"),
    ZYDIS_MAKE_SHORTSTRING("pmovzxbw"),
    ZYDIS_MAKE_SHORTSTRING("pmovzxdq"),
    ZYDIS_MAKE_SHORTSTRING("pmovzxwd"),
    ZYDIS_MAKE_SHORTSTRING("pmovzxwq"),
    ZYDIS_MAKE_SHORTSTRING("pmuldq"),
    ZYDIS_MAKE_SHORTSTRING("pmulhrsw"),
    ZYDIS_MAKE_SHORTSTRING("pmulhrw"),
    ZYDIS_MAKE_SHORTSTRING("pmulhuw"),
    ZYDIS_MAKE_SHORTSTRING("pmulhw"),
    ZYDIS_MAKE_SHORTSTRING("pmulld"),
    ZYDIS_MAKE_SHORTSTRING("pmullw"),
    ZYDIS_MAKE_SHORTSTRING("pmuludq"),
    ZYDIS_MAKE_SHORTSTRING("pop"),
    ZYDIS_MAKE_SHORTSTRING("popa"),
    ZYDIS_MAKE_SHORTSTRING("popad"),
    ZYDIS_MAKE_SHORTSTRING("popcnt"),
    ZYDIS_MAKE_SHORTSTRING("popf"),
    ZYDIS_MAKE_SHORTSTRING("popfd"),
    ZYDIS_MAKE_SHORTSTRING("popfq"),
    ZYDIS_MAKE_SHORTSTRING("por"),
    ZYDIS_MAKE_SHORTSTRING("prefetch"),
    ZYDIS_MAKE_SHORTSTRING("prefetchit0"),
    ZYDIS_MAKE_SHORTSTRING("prefetchit1"),
    ZYDIS_MAKE_SHORTSTRING("prefetchnta"),
    ZYDIS_MAKE_SHORTSTRING("prefetcht0"),
    ZYDIS_MAKE_SHORTSTRING("prefetcht1"),
    ZYDIS_MAKE_SHORTSTRING("prefetcht2"),
    ZYDIS_MAKE_SHORTSTRING("prefetchw"),
    ZYDIS_MAKE_SHORTSTRING("prefetchwt1"),
    ZYDIS_MAKE_SHORTSTRING("psadbw"),
    ZYDIS_MAKE_SHORTSTRING("pshufb"),
    ZYDIS_MAKE_SHORTSTRING("pshufd"),
    ZYDIS_MAKE_SHORTSTRING("pshufhw"),
    ZYDIS_MAKE_SHORTSTRING("pshuflw"),
    ZYDIS_MAKE_SHORTSTRING("pshufw"),
    ZYDIS_MAKE_SHORTSTRING("psignb"),
    ZYDIS_MAKE_SHORTSTRING("psignd"),
    ZYDIS_MAKE_SHORTSTRING("psignw"),
    ZYDIS_MAKE_SHORTSTRING("pslld"),
    ZYDIS_MAKE_SHORTSTRING("pslldq"),
    ZYDIS_MAKE_SHORTSTRING("psllq"),
    ZYDIS_MAKE_SHORTSTRING("psllw"),
    ZYDIS_MAKE_SHORTSTRING("psmash"),
    ZYDIS_MAKE_SHORTSTRING("psrad"),
    ZYDIS_MAKE_SHORTSTRING("psraw"),
    ZYDIS_MAKE_SHORTSTRING("psrld"),
    ZYDIS_MAKE_SHORTSTRING("psrldq"),
    ZYDIS_MAKE_SHORTSTRING("psrlq"),
    ZYDIS_MAKE_SHORTSTRING("psrlw"),
    ZYDIS_MAKE_SHORTSTRING("psubb"),
    ZYDIS_MAKE_SHORTSTRING("psubd"),
    ZYDIS_MAKE_SHORTSTRING("psubq"),
    ZYDIS_MAKE_SHORTSTRING("psubsb"),
    ZYDIS_MAKE_SHORTSTRING("psubsw"),
    ZYDIS_MAKE_SHORTSTRING("psubusb"),
    ZYDIS_MAKE_SHORTSTRING("psubusw"),
    ZYDIS_MAKE_SHORTSTRING("psubw"),
    ZYDIS_MAKE_SHORTSTRING("pswapd"),
    ZYDIS_MAKE_SHORTSTRING("ptest"),
    ZYDIS_MAKE_SHORTSTRING("ptwrite"),
    ZYDIS_MAKE_SHORTSTRING("punpckhbw"),
    ZYDIS_MAKE_SHORTSTRING("punpckhdq"),
    ZYDIS_MAKE_SHORTSTRING("punpckhqdq"),
    ZYDIS_MAKE_SHORTSTRING("punpckhwd"),
    ZYDIS_MAKE_SHORTSTRING("punpcklbw"),
    ZYDIS_MAKE_SHORTSTRING("punpckldq"),
    ZYDIS_MAKE_SHORTSTRING("punpcklqdq"),
    ZYDIS_MAKE_SHORTSTRING("punpcklwd"),
    ZYDIS_MAKE_SHORTSTRING("push"),
    ZYDIS_MAKE_SHORTSTRING("pusha"),
    ZYDIS_MAKE_SHORTSTRING("pushad"),
    ZYDIS_MAKE_SHORTSTRING("pushf"),
    ZYDIS_MAKE_SHORTSTRING("pushfd"),
    ZYDIS_MAKE_SHORTSTRING("pushfq"),
    ZYDIS_MAKE_SHORTSTRING("pvalidate"),
    ZYDIS_MAKE_SHORTSTRING("pxor"),
    ZYDIS_MAKE_SHORTSTRING("rcl"),
    ZYDIS_MAKE_SHORTSTRING("rcpps"),
    ZYDIS_MAKE_SHORTSTRING("rcpss"),
    ZYDIS_MAKE_SHORTSTRING("rcr"),
    ZYDIS_MAKE_SHORTSTRING("rdfsbase"),
    ZYDIS_MAKE_SHORTSTRING("rdgsbase"),
    ZYDIS_MAKE_SHORTSTRING("rdmsr"),
    ZYDIS_MAKE_SHORTSTRING("rdmsrlist"),
    ZYDIS_MAKE_SHORTSTRING("rdpid"),
    ZYDIS_MAKE_SHORTSTRING("rdpkru"),
    ZYDIS_MAKE_SHORTSTRING("rdpmc"),
    ZYDIS_MAKE_SHORTSTRING("rdpru"),
    ZYDIS_MAKE_SHORTSTRING("rdrand"),
    ZYDIS_MAKE_SHORTSTRING("rdseed"),
    ZYDIS_MAKE_SHORTSTRING("rdsspd"),
    ZYDIS_MAKE_SHORTSTRING("rdsspq"),
    ZYDIS_MAKE_SHORTSTRING("rdtsc"),
    ZYDIS_MAKE_SHORTSTRING("rdtscp"),
    ZYDIS_MAKE_SHORTSTRING("ret"),
    ZYDIS_MAKE_SHORTSTRING("rmpadjust"),
    ZYDIS_MAKE_SHORTSTRING("rmpupdate"),
    ZYDIS_MAKE_SHORTSTRING("rol"),
    ZYDIS_MAKE_SHORTSTRING("ror"),
    ZYDIS_MAKE_SHORTSTRING("rorx"),
    ZYDIS_MAKE_SHORTSTRING("roundpd"),
    ZYDIS_MAKE_SHORTSTRING("roundps"),
    ZYDIS_MAKE_SHORTSTRING("roundsd"),
    ZYDIS_MAKE_SHORTSTRING("roundss"),
    ZYDIS_MAKE_SHORTSTRING("rsm"),
    ZYDIS_MAKE_SHORTSTRING("rsqrtps"),
    ZYDIS_MAKE_SHORTSTRING("rsqrtss"),
    ZYDIS_MAKE_SHORTSTRING("rstorssp"),
    ZYDIS_MAKE_SHORTSTRING("sahf"),
    ZYDIS_MAKE_SHORTSTRING("salc"),
    ZYDIS_MAKE_SHORTSTRING("sar"),
    ZYDIS_MAKE_SHORTSTRING("sarx"),
    ZYDIS_MAKE_SHORTSTRING("saveprevssp"),
    ZYDIS_MAKE_SHORTSTRING("sbb"),
    ZYDIS_MAKE_SHORTSTRING("scasb"),
    ZYDIS_MAKE_SHORTSTRING("scasd"),
    ZYDIS_MAKE_SHORTSTRING("scasq"),
    ZYDIS_MAKE_SHORTSTRING("scasw"),
    ZYDIS_MAKE_SHORTSTRING("seamcall"),
    ZYDIS_MAKE_SHORTSTRING("seamops"),
    ZYDIS_MAKE_SHORTSTRING("seamret"),
    ZYDIS_MAKE_SHORTSTRING("senduipi"),
    ZYDIS_MAKE_SHORTSTRING("serialize"),
    ZYDIS_MAKE_SHORTSTRING("setb"),
    ZYDIS_MAKE_SHORTSTRING("setbe"),
    ZYDIS_MAKE_SHORTSTRING("setl"),
    ZYDIS_MAKE_SHORTSTRING("setle"),
    ZYDIS_MAKE_SHORTSTRING("setnb"),
    ZYDIS_MAKE_SHORTSTRING("setnbe"),
    ZYDIS_MAKE_SHORTSTRING("setnl"),
    ZYDIS_MAKE_SHORTSTRING("setnle"),
    ZYDIS_MAKE_SHORTSTRING("setno"),
    ZYDIS_MAKE_SHORTSTRING("setnp"),
    ZYDIS_MAKE_SHORTSTRING("setns"),
    ZYDIS_MAKE_SHORTSTRING("setnz"),
    ZYDIS_MAKE_SHORTSTRING("seto"),
    ZYDIS_MAKE_SHORTSTRING("setp"),
    ZYDIS_MAKE_SHORTSTRING("sets"),
    ZYDIS_MAKE_SHORTSTRING("setssbsy"),
    ZYDIS_MAKE_SHORTSTRING("setz"),
    ZYDIS_MAKE_SHORTSTRING("sfence"),
    ZYDIS_MAKE_SHORTSTRING("sgdt"),
    ZYDIS_MAKE_SHORTSTRING("sha1msg1"),
    ZYDIS_MAKE_SHORTSTRING("sha1msg2"),
    ZYDIS_MAKE_SHORTSTRING("sha1nexte"),
    ZYDIS_MAKE_SHORTSTRING("sha1rnds4"),
    ZYDIS_MAKE_SHORTSTRING("sha256msg1"),
    ZYDIS_MAKE_SHORTSTRING("sha256msg2"),
    ZYDIS_MAKE_SHORTSTRING("sha256rnds2"),
    ZYDIS_MAKE_SHORTSTRING("shl"),
    ZYDIS_MAKE_SHORTSTRING("shld"),
    ZYDIS_MAKE_SHORTSTRING("shlx"),
    ZYDIS_MAKE_SHORTSTRING("shr"),
    ZYDIS_MAKE_SHORTSTRING("shrd"),
    ZYDIS_MAKE_SHORTSTRING("shrx"),
    ZYDIS_MAKE_SHORTSTRING("shufpd"),
    ZYDIS_MAKE_SHORTSTRING("shufps"),
    ZYDIS_MAKE_SHORTSTRING("sidt"),
    ZYDIS_MAKE_SHORTSTRING("skinit"),
    ZYDIS_MAKE_SHORTSTRING("sldt"),
    ZYDIS_MAKE_SHORTSTRING("slwpcb"),
    ZYDIS_MAKE_SHORTSTRING("smsw"),
    ZYDIS_MAKE_SHORTSTRING("spflt"),
    ZYDIS_MAKE_SHORTSTRING("sqrtpd"),
    ZYDIS_MAKE_SHORTSTRING("sqrtps"),
    ZYDIS_MAKE_SHORTSTRING("sqrtsd"),
    ZYDIS_MAKE_SHORTSTRING("sqrtss"),
    ZYDIS_MAKE_SHORTSTRING("stac"),
    ZYDIS_MAKE_SHORTSTRING("stc"),
    ZYDIS_MAKE_SHORTSTRING("std"),
    ZYDIS_MAKE_SHORTSTRING("stgi"),
    ZYDIS_MAKE_SHORTSTRING("sti"),
    ZYDIS_MAKE_SHORTSTRING("stmxcsr"),
    ZYDIS_MAKE_SHORTSTRING("stosb"),
    ZYDIS_MAKE_SHORTSTRING("stosd"),
    ZYDIS_MAKE_SHORTSTRING("stosq"),
    ZYDIS_MAKE_SHORTSTRING("stosw"),
    ZYDIS_MAKE_SHORTSTRING("str"),
    ZYDIS_MAKE_SHORTSTRING("sttilecfg"),
    ZYDIS_MAKE_SHORTSTRING("stui"),
    ZYDIS_MAKE_SHORTSTRING("sub"),
    ZYDIS_MAKE_SHORTSTRING("subpd"),
    ZYDIS_MAKE_SHORTSTRING("subps"),
    ZYDIS_MAKE_SHORTSTRING("subsd"),
    ZYDIS_MAKE_SHORTSTRING("subss"),
    ZYDIS_MAKE_SHORTSTRING("swapgs"),
    ZYDIS_MAKE_SHORTSTRING("syscall"),
    ZYDIS_MAKE_SHORTSTRING("sysenter"),
    ZYDIS_MAKE_SHORTSTRING("sysexit"),
    ZYDIS_MAKE_SHORTSTRING("sysret"),
    ZYDIS_MAKE_SHORTSTRING("t1mskc"),
    ZYDIS_MAKE_SHORTSTRING("tdcall"),
    ZYDIS_MAKE_SHORTSTRING("tdpbf16ps"),
    ZYDIS_MAKE_SHORTSTRING("tdpbssd"),
    ZYDIS_MAKE_SHORTSTRING("tdpbsud"),
    ZYDIS_MAKE_SHORTSTRING("tdpbusd"),
    ZYDIS_MAKE_SHORTSTRING("tdpbuud"),
    ZYDIS_MAKE_SHORTSTRING("tdpfp16ps"),
    ZYDIS_MAKE_SHORTSTRING("test"),
    ZYDIS_MAKE_SHORTSTRING("testui"),
    ZYDIS_MAKE_SHORTSTRING("tileloadd"),
    ZYDIS_MAKE_SHORTSTRING("tileloaddt1"),
    ZYDIS_MAKE_SHORTSTRING("tilerelease"),
    ZYDIS_MAKE_SHORTSTRING("tilestored"),
    ZYDIS_MAKE_SHORTSTRING("tilezero"),
    ZYDIS_MAKE_SHORTSTRING("tlbsync"),
    ZYDIS_MAKE_SHORTSTRING("tpause"),
    ZYDIS_MAKE_SHORTSTRING("tzcnt"),
    ZYDIS_MAKE_SHORTSTRING("tzcnti"),
    ZYDIS_MAKE_SHORTSTRING("tzmsk"),
    ZYDIS_MAKE_SHORTSTRING("ucomisd"),
    ZYDIS_MAKE_SHORTSTRING("ucomiss"),
    ZYDIS_MAKE_SHORTSTRING("ud0"),
    ZYDIS_MAKE_SHORTSTRING("ud1"),
    ZYDIS_MAKE_SHORTSTRING("ud2"),
    ZYDIS_MAKE_SHORTSTRING("uiret"),
    ZYDIS_MAKE_SHORTSTRING("umonitor"),
    ZYDIS_MAKE_SHORTSTRING("umwait"),
    ZYDIS_MAKE_SHORTSTRING("unpckhpd"),
    ZYDIS_MAKE_SHORTSTRING("unpckhps"),
    ZYDIS_MAKE_SHORTSTRING("unpcklpd"),
    ZYDIS_MAKE_SHORTSTRING("unpcklps"),
    ZYDIS_MAKE_SHORTSTRING("v4fmaddps"),
    ZYDIS_MAKE_SHORTSTRING("v4fmaddss"),
    ZYDIS_MAKE_SHORTSTRING("v4fnmaddps"),
    ZYDIS_MAKE_SHORTSTRING("v4fnmaddss"),
    ZYDIS_MAKE_SHORTSTRING("vaddnpd"),
    ZYDIS_MAKE_SHORTSTRING("vaddnps"),
    ZYDIS_MAKE_SHORTSTRING("vaddpd"),
    ZYDIS_MAKE_SHORTSTRING("vaddph"),
    ZYDIS_MAKE_SHORTSTRING("vaddps"),
    ZYDIS_MAKE_SHORTSTRING("vaddsd"),
    ZYDIS_MAKE_SHORTSTRING("vaddsetsps"),
    ZYDIS_MAKE_SHORTSTRING("vaddsh"),
    ZYDIS_MAKE_SHORTSTRING("vaddss"),
    ZYDIS_MAKE_SHORTSTRING("vaddsubpd"),
    ZYDIS_MAKE_SHORTSTRING("vaddsubps"),
    ZYDIS_MAKE_SHORTSTRING("vaesdec"),
    ZYDIS_MAKE_SHORTSTRING("vaesdeclast"),
    ZYDIS_MAKE_SHORTSTRING("vaesenc"),
    ZYDIS_MAKE_SHORTSTRING("vaesenclast"),
    ZYDIS_MAKE_SHORTSTRING("vaesimc"),
    ZYDIS_MAKE_SHORTSTRING("vaeskeygenassist"),
    ZYDIS_MAKE_SHORTSTRING("valignd"),
    ZYDIS_MAKE_SHORTSTRING("valignq"),
    ZYDIS_MAKE_SHORTSTRING("vandnpd"),
    ZYDIS_MAKE_SHORTSTRING("vandnps"),
    ZYDIS_MAKE_SHORTSTRING("vandpd"),
    ZYDIS_MAKE_SHORTSTRING("vandps"),
    ZYDIS_MAKE_SHORTSTRING("vbcstnebf162ps"),
    ZYDIS_MAKE_SHORTSTRING("vbcstnesh2ps"),
    ZYDIS_MAKE_SHORTSTRING("vblendmpd"),
    ZYDIS_MAKE_SHORTSTRING("vblendmps"),
    ZYDIS_MAKE_SHORTSTRING("vblendpd"),
    ZYDIS_MAKE_SHORTSTRING("vblendps"),
    ZYDIS_MAKE_SHORTSTRING("vblendvpd"),
    ZYDIS_MAKE_SHORTSTRING("vblendvps"),
    ZYDIS_MAKE_SHORTSTRING("vbroadcastf128"),
    ZYDIS_MAKE_SHORTSTRING("vbroadcastf32x2"),
    ZYDIS_MAKE_SHORTSTRING("vbroadcastf32x4"),
    ZYDIS_MAKE_SHORTSTRING("vbroadcastf32x8"),
    ZYDIS_MAKE_SHORTSTRING("vbroadcastf64x2"),
    ZYDIS_MAKE_SHORTSTRING("vbroadcastf64x4"),
    ZYDIS_MAKE_SHORTSTRING("vbroadcasti128"),
    ZYDIS_MAKE_SHORTSTRING("vbroadcasti32x2"),
    ZYDIS_MAKE_SHORTSTRING("vbroadcasti32x4"),
    ZYDIS_MAKE_SHORTSTRING("vbroadcasti32x8"),
    ZYDIS_MAKE_SHORTSTRING("vbroadcasti64x2"),
    ZYDIS_MAKE_SHORTSTRING("vbroadcasti64x4"),
    ZYDIS_MAKE_SHORTSTRING("vbroadcastsd"),
    ZYDIS_MAKE_SHORTSTRING("vbroadcastss"),
    ZYDIS_MAKE_SHORTSTRING("vcmppd"),
    ZYDIS_MAKE_SHORTSTRING("vcmpph"),
    ZYDIS_MAKE_SHORTSTRING("vcmpps"),
    ZYDIS_MAKE_SHORTSTRING("vcmpsd"),
    ZYDIS_MAKE_SHORTSTRING("vcmpsh"),
    ZYDIS_MAKE_SHORTSTRING("vcmpss"),
    ZYDIS_MAKE_SHORTSTRING("vcomisd"),
    ZYDIS_MAKE_SHORTSTRING("vcomish"),
    ZYDIS_MAKE_SHORTSTRING("vcomiss"),
    ZYDIS_MAKE_SHORTSTRING("vcompresspd"),
    ZYDIS_MAKE_SHORTSTRING("vcompressps"),
    ZYDIS_MAKE_SHORTSTRING("vcvtdq2pd"),
    ZYDIS_MAKE_SHORTSTRING("vcvtdq2ph"),
    ZYDIS_MAKE_SHORTSTRING("vcvtdq2ps"),
    ZYDIS_MAKE_SHORTSTRING("vcvtfxpntdq2ps"),
    ZYDIS_MAKE_SHORTSTRING("vcvtfxpntpd2dq"),
    ZYDIS_MAKE_SHORTSTRING("vcvtfxpntpd2udq"),
    ZYDIS_MAKE_SHORTSTRING("vcvtfxpntps2dq"),
    ZYDIS_MAKE_SHORTSTRING("vcvtfxpntps2udq"),
    ZYDIS_MAKE_SHORTSTRING("vcvtfxpntudq2ps"),
    ZYDIS_MAKE_SHORTSTRING("vcvtne2ps2bf16"),
    ZYDIS_MAKE_SHORTSTRING("vcvtneebf162ps"),
    ZYDIS_MAKE_SHORTSTRING("vcvtneeph2ps"),
    ZYDIS_MAKE_SHORTSTRING("vcvtneobf162ps"),
    ZYDIS_MAKE_SHORTSTRING("vcvtneoph2ps"),
    ZYDIS_MAKE_SHORTSTRING("vcvtneps2bf16"),
    ZYDIS_MAKE_SHORTSTRING("vcvtpd2dq"),
    ZYDIS_MAKE_SHORTSTRING("vcvtpd2ph"),
    ZYDIS_MAKE_SHORTSTRING("vcvtpd2ps"),
    ZYDIS_MAKE_SHORTSTRING("vcvtpd2qq"),
    ZYDIS_MAKE_SHORTSTRING("vcvtpd2udq"),
    ZYDIS_MAKE_SHORTSTRING("vcvtpd2uqq"),
    ZYDIS_MAKE_SHORTSTRING("vcvtph2dq"),
    ZYDIS_MAKE_SHORTSTRING("vcvtph2pd"),
    ZYDIS_MAKE_SHORTSTRING("vcvtph2ps"),
    ZYDIS_MAKE_SHORTSTRING("vcvtph2psx"),
    ZYDIS_MAKE_SHORTSTRING("vcvtph2qq"),
    ZYDIS_MAKE_SHORTSTRING("vcvtph2udq"),
    ZYDIS_MAKE_SHORTSTRING("vcvtph2uqq"),
    ZYDIS_MAKE_SHORTSTRING("vcvtph2uw"),
    ZYDIS_MAKE_SHORTSTRING("vcvtph2w"),
    ZYDIS_MAKE_SHORTSTRING("vcvtps2dq"),
    ZYDIS_MAKE_SHORTSTRING("vcvtps2pd"),
    ZYDIS_MAKE_SHORTSTRING("vcvtps2ph"),
    ZYDIS_MAKE_SHORTSTRING("vcvtps2phx"),
    ZYDIS_MAKE_SHORTSTRING("vcvtps2qq"),
    ZYDIS_MAKE_SHORTSTRING("vcvtps2udq"),
    ZYDIS_MAKE_SHORTSTRING("vcvtps2uqq"),
    ZYDIS_MAKE_SHORTSTRING("vcvtqq2pd"),
    ZYDIS_MAKE_SHORTSTRING("vcvtqq2ph"),
    ZYDIS_MAKE_SHORTSTRING("vcvtqq2ps"),
    ZYDIS_MAKE_SHORTSTRING("vcvtsd2sh"),
    ZYDIS_MAKE_SHORTSTRING("vcvtsd2si"),
    ZYDIS_MAKE_SHORTSTRING("vcvtsd2ss"),
    ZYDIS_MAKE_SHORTSTRING("vcvtsd2usi"),
    ZYDIS_MAKE_SHORTSTRING("vcvtsh2sd"),
    ZYDIS_MAKE_SHORTSTRING("vcvtsh2si"),
    ZYDIS_MAKE_SHORTSTRING("vcvtsh2ss"),
    ZYDIS_MAKE_SHORTSTRING("vcvtsh2usi"),
    ZYDIS_MAKE_SHORTSTRING("vcvtsi2sd"),
    ZYDIS_MAKE_SHORTSTRING("vcvtsi2sh"),
    ZYDIS_MAKE_SHORTSTRING("vcvtsi2ss"),
    ZYDIS_MAKE_SHORTSTRING("vcvtss2sd"),
    ZYDIS_MAKE_SHORTSTRING("vcvtss2sh"),
    ZYDIS_MAKE_SHORTSTRING("vcvtss2si"),
    ZYDIS_MAKE_SHORTSTRING("vcvtss2usi"),
    ZYDIS_MAKE_SHORTSTRING("vcvttpd2dq"),
    ZYDIS_MAKE_SHORTSTRING("vcvttpd2qq"),
    ZYDIS_MAKE_SHORTSTRING("vcvttpd2udq"),
    ZYDIS_MAKE_SHORTSTRING("vcvttpd2uqq"),
    ZYDIS_MAKE_SHORTSTRING("vcvttph2dq"),
    ZYDIS_MAKE_SHORTSTRING("vcvttph2qq"),
    ZYDIS_MAKE_SHORTSTRING("vcvttph2udq"),
    ZYDIS_MAKE_SHORTSTRING("vcvttph2uqq"),
    ZYDIS_MAKE_SHORTSTRING("vcvttph2uw"),
    ZYDIS_MAKE_SHORTSTRING("vcvttph2w"),
    ZYDIS_MAKE_SHORTSTRING("vcvttps2dq"),
    ZYDIS_MAKE_SHORTSTRING("vcvttps2qq"),
    ZYDIS_MAKE_SHORTSTRING("vcvttps2udq"),
    ZYDIS_MAKE_SHORTSTRING("vcvttps2uqq"),
    ZYDIS_MAKE_SHORTSTRING("vcvttsd2si"),
    ZYDIS_MAKE_SHORTSTRING("vcvttsd2usi"),
    ZYDIS_MAKE_SHORTSTRING("vcvttsh2si"),
    ZYDIS_MAKE_SHORTSTRING("vcvttsh2usi"),
    ZYDIS_MAKE_SHORTSTRING("vcvttss2si"),
    ZYDIS_MAKE_SHORTSTRING("vcvttss2usi"),
    ZYDIS_MAKE_SHORTSTRING("vcvtudq2pd"),
    ZYDIS_MAKE_SHORTSTRING("vcvtudq2ph"),
    ZYDIS_MAKE_SHORTSTRING("vcvtudq2ps"),
    ZYDIS_MAKE_SHORTSTRING("vcvtuqq2pd"),
    ZYDIS_MAKE_SHORTSTRING("vcvtuqq2ph"),
    ZYDIS_MAKE_SHORTSTRING("vcvtuqq2ps"),
    ZYDIS_MAKE_SHORTSTRING("vcvtusi2sd"),
    ZYDIS_MAKE_SHORTSTRING("vcvtusi2sh"),
    ZYDIS_MAKE_SHORTSTRING("vcvtusi2ss"),
    ZYDIS_MAKE_SHORTSTRING("vcvtuw2ph"),
    ZYDIS_MAKE_SHORTSTRING("vcvtw2ph"),
    ZYDIS_MAKE_SHORTSTRING("vdbpsadbw"),
    ZYDIS_MAKE_SHORTSTRING("vdivpd"),
    ZYDIS_MAKE_SHORTSTRING("vdivph"),
    ZYDIS_MAKE_SHORTSTRING("vdivps"),
    ZYDIS_MAKE_SHORTSTRING("vdivsd"),
    ZYDIS_MAKE_SHORTSTRING("vdivsh"),
    ZYDIS_MAKE_SHORTSTRING("vdivss"),
    ZYDIS_MAKE_SHORTSTRING("vdpbf16ps"),
    ZYDIS_MAKE_SHORTSTRING("vdppd"),
    ZYDIS_MAKE_SHORTSTRING("vdpps"),
    ZYDIS_MAKE_SHORTSTRING("verr"),
    ZYDIS_MAKE_SHORTSTRING("verw"),
    ZYDIS_MAKE_SHORTSTRING("vexp223ps"),
    ZYDIS_MAKE_SHORTSTRING("vexp2pd"),
    ZYDIS_MAKE_SHORTSTRING("vexp2ps"),
    ZYDIS_MAKE_SHORTSTRING("vexpandpd"),
    ZYDIS_MAKE_SHORTSTRING("vexpandps"),
    ZYDIS_MAKE_SHORTSTRING("vextractf128"),
    ZYDIS_MAKE_SHORTSTRING("vextractf32x4"),
    ZYDIS_MAKE_SHORTSTRING("vextractf32x8"),
    ZYDIS_MAKE_SHORTSTRING("vextractf64x2"),
    ZYDIS_MAKE_SHORTSTRING("vextractf64x4"),
    ZYDIS_MAKE_SHORTSTRING("vextracti128"),
    ZYDIS_MAKE_SHORTSTRING("vextracti32x4"),
    ZYDIS_MAKE_SHORTSTRING("vextracti32x8"),
    ZYDIS_MAKE_SHORTSTRING("vextracti64x2"),
    ZYDIS_MAKE_SHORTSTRING("vextracti64x4"),
    ZYDIS_MAKE_SHORTSTRING("vextractps"),
    ZYDIS_MAKE_SHORTSTRING("vfcmaddcph"),
    ZYDIS_MAKE_SHORTSTRING("vfcmaddcsh"),
    ZYDIS_MAKE_SHORTSTRING("vfcmulcph"),
    ZYDIS_MAKE_SHORTSTRING("vfcmulcsh"),
    ZYDIS_MAKE_SHORTSTRING("vfixupimmpd"),
    ZYDIS_MAKE_SHORTSTRING("vfixupimmps"),
    ZYDIS_MAKE_SHORTSTRING("vfixupimmsd"),
    ZYDIS_MAKE_SHORTSTRING("vfixupimmss"),
    ZYDIS_MAKE_SHORTSTRING("vfixupnanpd"),
    ZYDIS_MAKE_SHORTSTRING("vfixupnanps"),
    ZYDIS_MAKE_SHORTSTRING("vfmadd132pd"),
    ZYDIS_MAKE_SHORTSTRING("vfmadd132ph"),
    ZYDIS_MAKE_SHORTSTRING("vfmadd132ps"),
    ZYDIS_MAKE_SHORTSTRING("vfmadd132sd"),
    ZYDIS_MAKE_SHORTSTRING("vfmadd132sh"),
    ZYDIS_MAKE_SHORTSTRING("vfmadd132ss"),
    ZYDIS_MAKE_SHORTSTRING("vfmadd213pd"),
    ZYDIS_MAKE_SHORTSTRING("vfmadd213ph"),
    ZYDIS_MAKE_SHORTSTRING("vfmadd213ps"),
    ZYDIS_MAKE_SHORTSTRING("vfmadd213sd"),
    ZYDIS_MAKE_SHORTSTRING("vfmadd213sh"),
    ZYDIS_MAKE_SHORTSTRING("vfmadd213ss"),
    ZYDIS_MAKE_SHORTSTRING("vfmadd231pd"),
    ZYDIS_MAKE_SHORTSTRING("vfmadd231ph"),
    ZYDIS_MAKE_SHORTSTRING("vfmadd231ps"),
    ZYDIS_MAKE_SHORTSTRING("vfmadd231sd"),
    ZYDIS_MAKE_SHORTSTRING("vfmadd231sh"),
    ZYDIS_MAKE_SHORTSTRING("vfmadd231ss"),
    ZYDIS_MAKE_SHORTSTRING("vfmadd233ps"),
    ZYDIS_MAKE_SHORTSTRING("vfmaddcph"),
    ZYDIS_MAKE_SHORTSTRING("vfmaddcsh"),
    ZYDIS_MAKE_SHORTSTRING("vfmaddpd"),
    ZYDIS_MAKE_SHORTSTRING("vfmaddps"),
    ZYDIS_MAKE_SHORTSTRING("vfmaddsd"),
    ZYDIS_MAKE_SHORTSTRING("vfmaddss"),
    ZYDIS_MAKE_SHORTSTRING("vfmaddsub132pd"),
    ZYDIS_MAKE_SHORTSTRING("vfmaddsub132ph"),
    ZYDIS_MAKE_SHORTSTRING("vfmaddsub132ps"),
    ZYDIS_MAKE_SHORTSTRING("vfmaddsub213pd"),
    ZYDIS_MAKE_SHORTSTRING("vfmaddsub213ph"),
    ZYDIS_MAKE_SHORTSTRING("vfmaddsub213ps"),
    ZYDIS_MAKE_SHORTSTRING("vfmaddsub231pd"),
    ZYDIS_MAKE_SHORTSTRING("vfmaddsub231ph"),
    ZYDIS_MAKE_SHORTSTRING("vfmaddsub231ps"),
    ZYDIS_MAKE_SHORTSTRING("vfmaddsubpd"),
    ZYDIS_MAKE_SHORTSTRING("vfmaddsubps"),
    ZYDIS_MAKE_SHORTSTRING("vfmsub132pd"),
    ZYDIS_MAKE_SHORTSTRING("vfmsub132ph"),
    ZYDIS_MAKE_SHORTSTRING("vfmsub132ps"),
    ZYDIS_MAKE_SHORTSTRING("vfmsub132sd"),
    ZYDIS_MAKE_SHORTSTRING("vfmsub132sh"),
    ZYDIS_MAKE_SHORTSTRING("vfmsub132ss"),
    ZYDIS_MAKE_SHORTSTRING("vfmsub213pd"),
    ZYDIS_MAKE_SHORTSTRING("vfmsub213ph"),
    ZYDIS_MAKE_SHORTSTRING("vfmsub213ps"),
    ZYDIS_MAKE_SHORTSTRING("vfmsub213sd"),
    ZYDIS_MAKE_SHORTSTRING("vfmsub213sh"),
    ZYDIS_MAKE_SHORTSTRING("vfmsub213ss"),
    ZYDIS_MAKE_SHORTSTRING("vfmsub231pd"),
    ZYDIS_MAKE_SHORTSTRING("vfmsub231ph"),
    ZYDIS_MAKE_SHORTSTRING("vfmsub231ps"),
    ZYDIS_MAKE_SHORTSTRING("vfmsub231sd"),
    ZYDIS_MAKE_SHORTSTRING("vfmsub231sh"),
    ZYDIS_MAKE_SHORTSTRING("vfmsub231ss"),
    ZYDIS_MAKE_SHORTSTRING("vfmsubadd132pd"),
    ZYDIS_MAKE_SHORTSTRING("vfmsubadd132ph"),
    ZYDIS_MAKE_SHORTSTRING("vfmsubadd132ps"),
    ZYDIS_MAKE_SHORTSTRING("vfmsubadd213pd"),
    ZYDIS_MAKE_SHORTSTRING("vfmsubadd213ph"),
    ZYDIS_MAKE_SHORTSTRING("vfmsubadd213ps"),
    ZYDIS_MAKE_SHORTSTRING("vfmsubadd231pd"),
    ZYDIS_MAKE_SHORTSTRING("vfmsubadd231ph"),
    ZYDIS_MAKE_SHORTSTRING("vfmsubadd231ps"),
    ZYDIS_MAKE_SHORTSTRING("vfmsubaddpd"),
    ZYDIS_MAKE_SHORTSTRING("vfmsubaddps"),
    ZYDIS_MAKE_SHORTSTRING("vfmsubpd"),
    ZYDIS_MAKE_SHORTSTRING("vfmsubps"),
    ZYDIS_MAKE_SHORTSTRING("vfmsubsd"),
    ZYDIS_MAKE_SHORTSTRING("vfmsubss"),
    ZYDIS_MAKE_SHORTSTRING("vfmulcph"),
    ZYDIS_MAKE_SHORTSTRING("vfmulcsh"),
    ZYDIS_MAKE_SHORTSTRING("vfnmadd132pd"),
    ZYDIS_MAKE_SHORTSTRING("vfnmadd132ph"),
    ZYDIS_MAKE_SHORTSTRING("vfnmadd132ps"),
    ZYDIS_MAKE_SHORTSTRING("vfnmadd132sd"),
    ZYDIS_MAKE_SHORTSTRING("vfnmadd132sh"),
    ZYDIS_MAKE_SHORTSTRING("vfnmadd132ss"),
    ZYDIS_MAKE_SHORTSTRING("vfnmadd213pd"),
    ZYDIS_MAKE_SHORTSTRING("vfnmadd213ph"),
    ZYDIS_MAKE_SHORTSTRING("vfnmadd213ps"),
    ZYDIS_MAKE_SHORTSTRING("vfnmadd213sd"),
    ZYDIS_MAKE_SHORTSTRING("vfnmadd213sh"),
    ZYDIS_MAKE_SHORTSTRING("vfnmadd213ss"),
    ZYDIS_MAKE_SHORTSTRING("vfnmadd231pd"),
    ZYDIS_MAKE_SHORTSTRING("vfnmadd231ph"),
    ZYDIS_MAKE_SHORTSTRING("vfnmadd231ps"),
    ZYDIS_MAKE_SHORTSTRING("vfnmadd231sd"),
    ZYDIS_MAKE_SHORTSTRING("vfnmadd231sh"),
    ZYDIS_MAKE_SHORTSTRING("vfnmadd231ss"),
    ZYDIS_MAKE_SHORTSTRING("vfnmaddpd"),
    ZYDIS_MAKE_SHORTSTRING("vfnmaddps"),
    ZYDIS_MAKE_SHORTSTRING("vfnmaddsd"),
    ZYDIS_MAKE_SHORTSTRING("vfnmaddss"),
    ZYDIS_MAKE_SHORTSTRING("vfnmsub132pd"),
    ZYDIS_MAKE_SHORTSTRING("vfnmsub132ph"),
    ZYDIS_MAKE_SHORTSTRING("vfnmsub132ps"),
    ZYDIS_MAKE_SHORTSTRING("vfnmsub132sd"),
    ZYDIS_MAKE_SHORTSTRING("vfnmsub132sh"),
    ZYDIS_MAKE_SHORTSTRING("vfnmsub132ss"),
    ZYDIS_MAKE_SHORTSTRING("vfnmsub213pd"),
    ZYDIS_MAKE_SHORTSTRING("vfnmsub213ph"),
    ZYDIS_MAKE_SHORTSTRING("vfnmsub213ps"),
    ZYDIS_MAKE_SHORTSTRING("vfnmsub213sd"),
    ZYDIS_MAKE_SHORTSTRING("vfnmsub213sh"),
    ZYDIS_MAKE_SHORTSTRING("vfnmsub213ss"),
    ZYDIS_MAKE_SHORTSTRING("vfnmsub231pd"),
    ZYDIS_MAKE_SHORTSTRING("vfnmsub231ph"),
    ZYDIS_MAKE_SHORTSTRING("vfnmsub231ps"),
    ZYDIS_MAKE_SHORTSTRING("vfnmsub231sd"),
    ZYDIS_MAKE_SHORTSTRING("vfnmsub231sh"),
    ZYDIS_MAKE_SHORTSTRING("vfnmsub231ss"),
    ZYDIS_MAKE_SHORTSTRING("vfnmsubpd"),
    ZYDIS_MAKE_SHORTSTRING("vfnmsubps"),
    ZYDIS_MAKE_SHORTSTRING("vfnmsubsd"),
    ZYDIS_MAKE_SHORTSTRING("vfnmsubss"),
    ZYDIS_MAKE_SHORTSTRING("vfpclasspd"),
    ZYDIS_MAKE_SHORTSTRING("vfpclassph"),
    ZYDIS_MAKE_SHORTSTRING("vfpclassps"),
    ZYDIS_MAKE_SHORTSTRING("vfpclasssd"),
    ZYDIS_MAKE_SHORTSTRING("vfpclasssh"),
    ZYDIS_MAKE_SHORTSTRING("vfpclassss"),
    ZYDIS_MAKE_SHORTSTRING("vfrczpd"),
    ZYDIS_MAKE_SHORTSTRING("vfrczps"),
    ZYDIS_MAKE_SHORTSTRING("vfrczsd"),
    ZYDIS_MAKE_SHORTSTRING("vfrczss"),
    ZYDIS_MAKE_SHORTSTRING("vgatherdpd"),
    ZYDIS_MAKE_SHORTSTRING("vgatherdps"),
    ZYDIS_MAKE_SHORTSTRING("vgatherpf0dpd"),
    ZYDIS_MAKE_SHORTSTRING("vgatherpf0dps"),
    ZYDIS_MAKE_SHORTSTRING("vgatherpf0hintdpd"),
    ZYDIS_MAKE_SHORTSTRING("vgatherpf0hintdps"),
    ZYDIS_MAKE_SHORTSTRING("vgatherpf0qpd"),
    ZYDIS_MAKE_SHORTSTRING("vgatherpf0qps"),
    ZYDIS_MAKE_SHORTSTRING("vgatherpf1dpd"),
    ZYDIS_MAKE_SHORTSTRING("vgatherpf1dps"),
    ZYDIS_MAKE_SHORTSTRING("vgatherpf1qpd"),
    ZYDIS_MAKE_SHORTSTRING("vgatherpf1qps"),
    ZYDIS_MAKE_SHORTSTRING("vgatherqpd"),
    ZYDIS_MAKE_SHORTSTRING("vgatherqps"),
    ZYDIS_MAKE_SHORTSTRING("vgetexppd"),
    ZYDIS_MAKE_SHORTSTRING("vgetexpph"),
    ZYDIS_MAKE_SHORTSTRING("vgetexpps"),
    ZYDIS_MAKE_SHORTSTRING("vgetexpsd"),
    ZYDIS_MAKE_SHORTSTRING("vgetexpsh"),
    ZYDIS_MAKE_SHORTSTRING("vgetexpss"),
    ZYDIS_MAKE_SHORTSTRING("vgetmantpd"),
    ZYDIS_MAKE_SHORTSTRING("vgetmantph"),
    ZYDIS_MAKE_SHORTSTRING("vgetmantps"),
    ZYDIS_MAKE_SHORTSTRING("vgetmantsd"),
    ZYDIS_MAKE_SHORTSTRING("vgetmantsh"),
    ZYDIS_MAKE_SHORTSTRING("vgetmantss"),
    ZYDIS_MAKE_SHORTSTRING("vgf2p8affineinvqb"),
    ZYDIS_MAKE_SHORTSTRING("vgf2p8affineqb"),
    ZYDIS_MAKE_SHORTSTRING("vgf2p8mulb"),
    ZYDIS_MAKE_SHORTSTRING("vgmaxabsps"),
    ZYDIS_MAKE_SHORTSTRING("vgmaxpd"),
    ZYDIS_MAKE_SHORTSTRING("vgmaxps"),
    ZYDIS_MAKE_SHORTSTRING("vgminpd"),
    ZYDIS_MAKE_SHORTSTRING("vgminps"),
    ZYDIS_MAKE_SHORTSTRING("vhaddpd"),
    ZYDIS_MAKE_SHORTSTRING("vhaddps"),
    ZYDIS_MAKE_SHORTSTRING("vhsubpd"),
    ZYDIS_MAKE_SHORTSTRING("vhsubps"),
    ZYDIS_MAKE_SHORTSTRING("vinsertf128"),
    ZYDIS_MAKE_SHORTSTRING("vinsertf32x4"),
    ZYDIS_MAKE_SHORTSTRING("vinsertf32x8"),
    ZYDIS_MAKE_SHORTSTRING("vinsertf64x2"),
    ZYDIS_MAKE_SHORTSTRING("vinsertf64x4"),
    ZYDIS_MAKE_SHORTSTRING("vinserti128"),
    ZYDIS_MAKE_SHORTSTRING("vinserti32x4"),
    ZYDIS_MAKE_SHORTSTRING("vinserti32x8"),
    ZYDIS_MAKE_SHORTSTRING("vinserti64x2"),
    ZYDIS_MAKE_SHORTSTRING("vinserti64x4"),
    ZYDIS_MAKE_SHORTSTRING("vinsertps"),
    ZYDIS_MAKE_SHORTSTRING("vlddqu"),
    ZYDIS_MAKE_SHORTSTRING("vldmxcsr"),
    ZYDIS_MAKE_SHORTSTRING("vloadunpackhd"),
    ZYDIS_MAKE_SHORTSTRING("vloadunpackhpd"),
    ZYDIS_MAKE_SHORTSTRING("vloadunpackhps"),
    ZYDIS_MAKE_SHORTSTRING("vloadunpackhq"),
    ZYDIS_MAKE_SHORTSTRING("vloadunpackld"),
    ZYDIS_MAKE_SHORTSTRING("vloadunpacklpd"),
    ZYDIS_MAKE_SHORTSTRING("vloadunpacklps"),
    ZYDIS_MAKE_SHORTSTRING("vloadunpacklq"),
    ZYDIS_MAKE_SHORTSTRING("vlog2ps"),
    ZYDIS_MAKE_SHORTSTRING("vmaskmovdqu"),
    ZYDIS_MAKE_SHORTSTRING("vmaskmovpd"),
    ZYDIS_MAKE_SHORTSTRING("vmaskmovps"),
    ZYDIS_MAKE_SHORTSTRING("vmaxpd"),
    ZYDIS_MAKE_SHORTSTRING("vmaxph"),
    ZYDIS_MAKE_SHORTSTRING("vmaxps"),
    ZYDIS_MAKE_SHORTSTRING("vmaxsd"),
    ZYDIS_MAKE_SHORTSTRING("vmaxsh"),
    ZYDIS_MAKE_SHORTSTRING("vmaxss"),
    ZYDIS_MAKE_SHORTSTRING("vmcall"),
    ZYDIS_MAKE_SHORTSTRING("vmclear"),
    ZYDIS_MAKE_SHORTSTRING("vmfunc"),
    ZYDIS_MAKE_SHORTSTRING("vminpd"),
    ZYDIS_MAKE_SHORTSTRING("vminph"),
    ZYDIS_MAKE_SHORTSTRING("vminps"),
    ZYDIS_MAKE_SHORTSTRING("vminsd"),
    ZYDIS_MAKE_SHORTSTRING("vminsh"),
    ZYDIS_MAKE_SHORTSTRING("vminss"),
    ZYDIS_MAKE_SHORTSTRING("vmlaunch"),
    ZYDIS_MAKE_SHORTSTRING("vmload"),
    ZYDIS_MAKE_SHORTSTRING("vmmcall"),
    ZYDIS_MAKE_SHORTSTRING("vmovapd"),
    ZYDIS_MAKE_SHORTSTRING("vmovaps"),
    ZYDIS_MAKE_SHORTSTRING("vmovd"),
    ZYDIS_MAKE_SHORTSTRING("vmovddup"),
    ZYDIS_MAKE_SHORTSTRING("vmovdqa"),
    ZYDIS_MAKE_SHORTSTRING("vmovdqa32"),
    ZYDIS_MAKE_SHORTSTRING("vmovdqa64"),
    ZYDIS_MAKE_SHORTSTRING("vmovdqu"),
    ZYDIS_MAKE_SHORTSTRING("vmovdqu16"),
    ZYDIS_MAKE_SHORTSTRING("vmovdqu32"),
    ZYDIS_MAKE_SHORTSTRING("vmovdqu64"),
    ZYDIS_MAKE_SHORTSTRING("vmovdqu8"),
    ZYDIS_MAKE_SHORTSTRING("vmovhlps"),
    ZYDIS_MAKE_SHORTSTRING("vmovhpd"),
    ZYDIS_MAKE_SHORTSTRING("vmovhps"),
    ZYDIS_MAKE_SHORTSTRING("vmovlhps"),
    ZYDIS_MAKE_SHORTSTRING("vmovlpd"),
    ZYDIS_MAKE_SHORTSTRING("vmovlps"),
    ZYDIS_MAKE_SHORTSTRING("vmovmskpd"),
    ZYDIS_MAKE_SHORTSTRING("vmovmskps"),
    ZYDIS_MAKE_SHORTSTRING("vmovnrapd"),
    ZYDIS_MAKE_SHORTSTRING("vmovnraps"),
    ZYDIS_MAKE_SHORTSTRING("vmovnrngoapd"),
    ZYDIS_MAKE_SHORTSTRING("vmovnrngoaps"),
    ZYDIS_MAKE_SHORTSTRING("vmovntdq"),
    ZYDIS_MAKE_SHORTSTRING("vmovntdqa"),
    ZYDIS_MAKE_SHORTSTRING("vmovntpd"),
    ZYDIS_MAKE_SHORTSTRING("vmovntps"),
    ZYDIS_MAKE_SHORTSTRING("vmovq"),
    ZYDIS_MAKE_SHORTSTRING("vmovsd"),
    ZYDIS_MAKE_SHORTSTRING("vmovsh"),
    ZYDIS_MAKE_SHORTSTRING("vmovshdup"),
    ZYDIS_MAKE_SHORTSTRING("vmovsldup"),
    ZYDIS_MAKE_SHORTSTRING("vmovss"),
    ZYDIS_MAKE_SHORTSTRING("vmovupd"),
    ZYDIS_MAKE_SHORTSTRING("vmovups"),
    ZYDIS_MAKE_SHORTSTRING("vmovw"),
    ZYDIS_MAKE_SHORTSTRING("vmpsadbw"),
    ZYDIS_MAKE_SHORTSTRING("vmptrld"),
    ZYDIS_MAKE_SHORTSTRING("vmptrst"),
    ZYDIS_MAKE_SHORTSTRING("vmread"),
    ZYDIS_MAKE_SHORTSTRING("vmresume"),
    ZYDIS_MAKE_SHORTSTRING("vmrun"),
    ZYDIS_MAKE_SHORTSTRING("vmsave"),
    ZYDIS_MAKE_SHORTSTRING("vmulpd"),
    ZYDIS_MAKE_SHORTSTRING("vmulph"),
    ZYDIS_MAKE_SHORTSTRING("vmulps"),
    ZYDIS_MAKE_SHORTSTRING("vmulsd"),
    ZYDIS_MAKE_SHORTSTRING("vmulsh"),
    ZYDIS_MAKE_SHORTSTRING("vmulss"),
    ZYDIS_MAKE_SHORTSTRING("vmwrite"),
    ZYDIS_MAKE_SHORTSTRING("vmxoff"),
    ZYDIS_MAKE_SHORTSTRING("vmxon"),
    ZYDIS_MAKE_SHORTSTRING("vorpd"),
    ZYDIS_MAKE_SHORTSTRING("vorps"),
    ZYDIS_MAKE_SHORTSTRING("vp2intersectd"),
    ZYDIS_MAKE_SHORTSTRING("vp2intersectq"),
    ZYDIS_MAKE_SHORTSTRING("vp4dpwssd"),
    ZYDIS_MAKE_SHORTSTRING("vp4dpwssds"),
    ZYDIS_MAKE_SHORTSTRING("vpabsb"),
    ZYDIS_MAKE_SHORTSTRING("vpabsd"),
    ZYDIS_MAKE_SHORTSTRING("vpabsq"),
    ZYDIS_MAKE_SHORTSTRING("vpabsw"),
    ZYDIS_MAKE_SHORTSTRING("vpackssdw"),
    ZYDIS_MAKE_SHORTSTRING("vpacksswb"),
    ZYDIS_MAKE_SHORTSTRING("vpackstorehd"),
    ZYDIS_MAKE_SHORTSTRING("vpackstorehpd"),
    ZYDIS_MAKE_SHORTSTRING("vpackstorehps"),
    ZYDIS_MAKE_SHORTSTRING("vpackstorehq"),
    ZYDIS_MAKE_SHORTSTRING("vpackstoreld"),
    ZYDIS_MAKE_SHORTSTRING("vpackstorelpd"),
    ZYDIS_MAKE_SHORTSTRING("vpackstorelps"),
    ZYDIS_MAKE_SHORTSTRING("vpackstorelq"),
    ZYDIS_MAKE_SHORTSTRING("vpackusdw"),
    ZYDIS_MAKE_SHORTSTRING("vpackuswb"),
    ZYDIS_MAKE_SHORTSTRING("vpadcd"),
    ZYDIS_MAKE_SHORTSTRING("vpaddb"),
    ZYDIS_MAKE_SHORTSTRING("vpaddd"),
    ZYDIS_MAKE_SHORTSTRING("vpaddq"),
    ZYDIS_MAKE_SHORTSTRING("vpaddsb"),
    ZYDIS_MAKE_SHORTSTRING("vpaddsetcd"),
    ZYDIS_MAKE_SHORTSTRING("vpaddsetsd"),
    ZYDIS_MAKE_SHORTSTRING("vpaddsw"),
    ZYDIS_MAKE_SHORTSTRING("vpaddusb"),
    ZYDIS_MAKE_SHORTSTRING("vpaddusw"),
    ZYDIS_MAKE_SHORTSTRING("vpaddw"),
    ZYDIS_MAKE_SHORTSTRING("vpalignr"),
    ZYDIS_MAKE_SHORTSTRING("vpand"),
    ZYDIS_MAKE_SHORTSTRING("vpandd"),
    ZYDIS_MAKE_SHORTSTRING("vpandn"),
    ZYDIS_MAKE_SHORTSTRING("vpandnd"),
    ZYDIS_MAKE_SHORTSTRING("vpandnq"),
    ZYDIS_MAKE_SHORTSTRING("vpandq"),
    ZYDIS_MAKE_SHORTSTRING("vpavgb"),
    ZYDIS_MAKE_SHORTSTRING("vpavgw"),
    ZYDIS_MAKE_SHORTSTRING("vpblendd"),
    ZYDIS_MAKE_SHORTSTRING("vpblendmb"),
    ZYDIS_MAKE_SHORTSTRING("vpblendmd"),
    ZYDIS_MAKE_SHORTSTRING("vpblendmq"),
    ZYDIS_MAKE_SHORTSTRING("vpblendmw"),
    ZYDIS_MAKE_SHORTSTRING("vpblendvb"),
    ZYDIS_MAKE_SHORTSTRING("vpblendw"),
    ZYDIS_MAKE_SHORTSTRING("vpbroadcastb"),
    ZYDIS_MAKE_SHORTSTRING("vpbroadcastd"),
    ZYDIS_MAKE_SHORTSTRING("vpbroadcastmb2q"),
    ZYDIS_MAKE_SHORTSTRING("vpbroadcastmw2d"),
    ZYDIS_MAKE_SHORTSTRING("vpbroadcastq"),
    ZYDIS_MAKE_SHORTSTRING("vpbroadcastw"),
    ZYDIS_MAKE_SHORTSTRING("vpclmulqdq"),
    ZYDIS_MAKE_SHORTSTRING("vpcmov"),
    ZYDIS_MAKE_SHORTSTRING("vpcmpb"),
    ZYDIS_MAKE_SHORTSTRING("vpcmpd"),
    ZYDIS_MAKE_SHORTSTRING("vpcmpeqb"),
    ZYDIS_MAKE_SHORTSTRING("vpcmpeqd"),
    ZYDIS_MAKE_SHORTSTRING("vpcmpeqq"),
    ZYDIS_MAKE_SHORTSTRING("vpcmpeqw"),
    ZYDIS_MAKE_SHORTSTRING("vpcmpestri"),
    ZYDIS_MAKE_SHORTSTRING("vpcmpestrm"),
    ZYDIS_MAKE_SHORTSTRING("vpcmpgtb"),
    ZYDIS_MAKE_SHORTSTRING("vpcmpgtd"),
    ZYDIS_MAKE_SHORTSTRING("vpcmpgtq"),
    ZYDIS_MAKE_SHORTSTRING("vpcmpgtw"),
    ZYDIS_MAKE_SHORTSTRING("vpcmpistri"),
    ZYDIS_MAKE_SHORTSTRING("vpcmpistrm"),
    ZYDIS_MAKE_SHORTSTRING("vpcmpltd"),
    ZYDIS_MAKE_SHORTSTRING("vpcmpq"),
    ZYDIS_MAKE_SHORTSTRING("vpcmpub"),
    ZYDIS_MAKE_SHORTSTRING("vpcmpud"),
    ZYDIS_MAKE_SHORTSTRING("vpcmpuq"),
    ZYDIS_MAKE_SHORTSTRING("vpcmpuw"),
    ZYDIS_MAKE_SHORTSTRING("vpcmpw"),
    ZYDIS_MAKE_SHORTSTRING("vpcomb"),
    ZYDIS_MAKE_SHORTSTRING("vpcomd"),
    ZYDIS_MAKE_SHORTSTRING("vpcompressb"),
    ZYDIS_MAKE_SHORTSTRING("vpcompressd"),
    ZYDIS_MAKE_SHORTSTRING("vpcompressq"),
    ZYDIS_MAKE_SHORTSTRING("vpcompressw"),
    ZYDIS_MAKE_SHORTSTRING("vpcomq"),
    ZYDIS_MAKE_SHORTSTRING("vpcomub"),
    ZYDIS_MAKE_SHORTSTRING("vpcomud"),
    ZYDIS_MAKE_SHORTSTRING("vpcomuq"),
    ZYDIS_MAKE_SHORTSTRING("vpcomuw"),
    ZYDIS_MAKE_SHORTSTRING("vpcomw"),
    ZYDIS_MAKE_SHORTSTRING("vpconflictd"),
    ZYDIS_MAKE_SHORTSTRING("vpconflictq"),
    ZYDIS_MAKE_SHORTSTRING("vpdpbssd"),
    ZYDIS_MAKE_SHORTSTRING("vpdpbssds"),
    ZYDIS_MAKE_SHORTSTRING("vpdpbsud"),
    ZYDIS_MAKE_SHORTSTRING("vpdpbsuds"),
    ZYDIS_MAKE_SHORTSTRING("vpdpbusd"),
    ZYDIS_MAKE_SHORTSTRING("vpdpbusds"),
    ZYDIS_MAKE_SHORTSTRING("vpdpbuud"),
    ZYDIS_MAKE_SHORTSTRING("vpdpbuuds"),
    ZYDIS_MAKE_SHORTSTRING("vpdpwssd"),
    ZYDIS_MAKE_SHORTSTRING("vpdpwssds"),
    ZYDIS_MAKE_SHORTSTRING("vpdpwsud"),
    ZYDIS_MAKE_SHORTSTRING("vpdpwsuds"),
    ZYDIS_MAKE_SHORTSTRING("vpdpwusd"),
    ZYDIS_MAKE_SHORTSTRING("vpdpwusds"),
    ZYDIS_MAKE_SHORTSTRING("vpdpwuud"),
    ZYDIS_MAKE_SHORTSTRING("vpdpwuuds"),
    ZYDIS_MAKE_SHORTSTRING("vperm2f128"),
    ZYDIS_MAKE_SHORTSTRING("vperm2i128"),
    ZYDIS_MAKE_SHORTSTRING("vpermb"),
    ZYDIS_MAKE_SHORTSTRING("vpermd"),
    ZYDIS_MAKE_SHORTSTRING("vpermf32x4"),
    ZYDIS_MAKE_SHORTSTRING("vpermi2b"),
    ZYDIS_MAKE_SHORTSTRING("vpermi2d"),
    ZYDIS_MAKE_SHORTSTRING("vpermi2pd"),
    ZYDIS_MAKE_SHORTSTRING("vpermi2ps"),
    ZYDIS_MAKE_SHORTSTRING("vpermi2q"),
    ZYDIS_MAKE_SHORTSTRING("vpermi2w"),
    ZYDIS_MAKE_SHORTSTRING("vpermil2pd"),
    ZYDIS_MAKE_SHORTSTRING("vpermil2ps"),
    ZYDIS_MAKE_SHORTSTRING("vpermilpd"),
    ZYDIS_MAKE_SHORTSTRING("vpermilps"),
    ZYDIS_MAKE_SHORTSTRING("vpermpd"),
    ZYDIS_MAKE_SHORTSTRING("vpermps"),
    ZYDIS_MAKE_SHORTSTRING("vpermq"),
    ZYDIS_MAKE_SHORTSTRING("vpermt2b"),
    ZYDIS_MAKE_SHORTSTRING("vpermt2d"),
    ZYDIS_MAKE_SHORTSTRING("vpermt2pd"),
    ZYDIS_MAKE_SHORTSTRING("vpermt2ps"),
    ZYDIS_MAKE_SHORTSTRING("vpermt2q"),
    ZYDIS_MAKE_SHORTSTRING("vpermt2w"),
    ZYDIS_MAKE_SHORTSTRING("vpermw"),
    ZYDIS_MAKE_SHORTSTRING("vpexpandb"),
    ZYDIS_MAKE_SHORTSTRING("vpexpandd"),
    ZYDIS_MAKE_SHORTSTRING("vpexpandq"),
    ZYDIS_MAKE_SHORTSTRING("vpexpandw"),
    ZYDIS_MAKE_SHORTSTRING("vpextrb"),
    ZYDIS_MAKE_SHORTSTRING("vpextrd"),
    ZYDIS_MAKE_SHORTSTRING("vpextrq"),
    ZYDIS_MAKE_SHORTSTRING("vpextrw"),
    ZYDIS_MAKE_SHORTSTRING("vpgatherdd"),
    ZYDIS_MAKE_SHORTSTRING("vpgatherdq"),
    ZYDIS_MAKE_SHORTSTRING("vpgatherqd"),
    ZYDIS_MAKE_SHORTSTRING("vpgatherqq"),
    ZYDIS_MAKE_SHORTSTRING("vphaddbd"),
    ZYDIS_MAKE_SHORTSTRING("vphaddbq"),
    ZYDIS_MAKE_SHORTSTRING("vphaddbw"),
    ZYDIS_MAKE_SHORTSTRING("vphaddd"),
    ZYDIS_MAKE_SHORTSTRING("vphadddq"),
    ZYDIS_MAKE_SHORTSTRING("vphaddsw"),
    ZYDIS_MAKE_SHORTSTRING("vphaddubd"),
    ZYDIS_MAKE_SHORTSTRING("vphaddubq"),
    ZYDIS_MAKE_SHORTSTRING("vphaddubw"),
    ZYDIS_MAKE_SHORTSTRING("vphaddudq"),
    ZYDIS_MAKE_SHORTSTRING("vphadduwd"),
    ZYDIS_MAKE_SHORTSTRING("vphadduwq"),
    ZYDIS_MAKE_SHORTSTRING("vphaddw"),
    ZYDIS_MAKE_SHORTSTRING("vphaddwd"),
    ZYDIS_MAKE_SHORTSTRING("vphaddwq"),
    ZYDIS_MAKE_SHORTSTRING("vphminposuw"),
    ZYDIS_MAKE_SHORTSTRING("vphsubbw"),
    ZYDIS_MAKE_SHORTSTRING("vphsubd"),
    ZYDIS_MAKE_SHORTSTRING("vphsubdq"),
    ZYDIS_MAKE_SHORTSTRING("vphsubsw"),
    ZYDIS_MAKE_SHORTSTRING("vphsubw"),
    ZYDIS_MAKE_SHORTSTRING("vphsubwd"),
    ZYDIS_MAKE_SHORTSTRING("vpinsrb"),
    ZYDIS_MAKE_SHORTSTRING("vpinsrd"),
    ZYDIS_MAKE_SHORTSTRING("vpinsrq"),
    ZYDIS_MAKE_SHORTSTRING("vpinsrw"),
    ZYDIS_MAKE_SHORTSTRING("vplzcntd"),
    ZYDIS_MAKE_SHORTSTRING("vplzcntq"),
    ZYDIS_MAKE_SHORTSTRING("vpmacsdd"),
    ZYDIS_MAKE_SHORTSTRING("vpmacsdqh"),
    ZYDIS_MAKE_SHORTSTRING("vpmacsdql"),
    ZYDIS_MAKE_SHORTSTRING("vpmacssdd"),
    ZYDIS_MAKE_SHORTSTRING("vpmacssdqh"),
    ZYDIS_MAKE_SHORTSTRING("vpmacssdql"),
    ZYDIS_MAKE_SHORTSTRING("vpmacsswd"),
    ZYDIS_MAKE_SHORTSTRING("vpmacssww"),
    ZYDIS_MAKE_SHORTSTRING("vpmacswd"),
    ZYDIS_MAKE_SHORTSTRING("vpmacsww"),
    ZYDIS_MAKE_SHORTSTRING("vpmadcsswd"),
    ZYDIS_MAKE_SHORTSTRING("vpmadcswd"),
    ZYDIS_MAKE_SHORTSTRING("vpmadd231d"),
    ZYDIS_MAKE_SHORTSTRING("vpmadd233d"),
    ZYDIS_MAKE_SHORTSTRING("vpmadd52huq"),
    ZYDIS_MAKE_SHORTSTRING("vpmadd52luq"),
    ZYDIS_MAKE_SHORTSTRING("vpmaddubsw"),
    ZYDIS_MAKE_SHORTSTRING("vpmaddwd"),
    ZYDIS_MAKE_SHORTSTRING("vpmaskmovd"),
    ZYDIS_MAKE_SHORTSTRING("vpmaskmovq"),
    ZYDIS_MAKE_SHORTSTRING("vpmaxsb"),
    ZYDIS_MAKE_SHORTSTRING("vpmaxsd"),
    ZYDIS_MAKE_SHORTSTRING("vpmaxsq"),
    ZYDIS_MAKE_SHORTSTRING("vpmaxsw"),
    ZYDIS_MAKE_SHORTSTRING("vpmaxub"),
    ZYDIS_MAKE_SHORTSTRING("vpmaxud"),
    ZYDIS_MAKE_SHORTSTRING("vpmaxuq"),
    ZYDIS_MAKE_SHORTSTRING("vpmaxuw"),
    ZYDIS_MAKE_SHORTSTRING("vpminsb"),
    ZYDIS_MAKE_SHORTSTRING("vpminsd"),
    ZYDIS_MAKE_SHORTSTRING("vpminsq"),
    ZYDIS_MAKE_SHORTSTRING("vpminsw"),
    ZYDIS_MAKE_SHORTSTRING("vpminub"),
    ZYDIS_MAKE_SHORTSTRING("vpminud"),
    ZYDIS_MAKE_SHORTSTRING("vpminuq"),
    ZYDIS_MAKE_SHORTSTRING("vpminuw"),
    ZYDIS_MAKE_SHORTSTRING("vpmovb2m"),
    ZYDIS_MAKE_SHORTSTRING("vpmovd2m"),
    ZYDIS_MAKE_SHORTSTRING("vpmovdb"),
    ZYDIS_MAKE_SHORTSTRING("vpmovdw"),
    ZYDIS_MAKE_SHORTSTRING("vpmovm2b"),
    ZYDIS_MAKE_SHORTSTRING("vpmovm2d"),
    ZYDIS_MAKE_SHORTSTRING("vpmovm2q"),
    ZYDIS_MAKE_SHORTSTRING("vpmovm2w"),
    ZYDIS_MAKE_SHORTSTRING("vpmovmskb"),
    ZYDIS_MAKE_SHORTSTRING("vpmovq2m"),
    ZYDIS_MAKE_SHORTSTRING("vpmovqb"),
    ZYDIS_MAKE_SHORTSTRING("vpmovqd"),
    ZYDIS_MAKE_SHORTSTRING("vpmovqw"),
    ZYDIS_MAKE_SHORTSTRING("vpmovsdb"),
    ZYDIS_MAKE_SHORTSTRING("vpmovsdw"),
    ZYDIS_MAKE_SHORTSTRING("vpmovsqb"),
    ZYDIS_MAKE_SHORTSTRING("vpmovsqd"),
    ZYDIS_MAKE_SHORTSTRING("vpmovsqw"),
    ZYDIS_MAKE_SHORTSTRING("vpmovswb"),
    ZYDIS_MAKE_SHORTSTRING("vpmovsxbd"),
    ZYDIS_MAKE_SHORTSTRING("vpmovsxbq"),
    ZYDIS_MAKE_SHORTSTRING("vpmovsxbw"),
    ZYDIS_MAKE_SHORTSTRING("vpmovsxdq"),
    ZYDIS_MAKE_SHORTSTRING("vpmovsxwd"),
    ZYDIS_MAKE_SHORTSTRING("vpmovsxwq"),
    ZYDIS_MAKE_SHORTSTRING("vpmovusdb"),
    ZYDIS_MAKE_SHORTSTRING("vpmovusdw"),
    ZYDIS_MAKE_SHORTSTRING("vpmovusqb"),
    ZYDIS_MAKE_SHORTSTRING("vpmovusqd"),
    ZYDIS_MAKE_SHORTSTRING("vpmovusqw"),
    ZYDIS_MAKE_SHORTSTRING("vpmovuswb"),
    ZYDIS_MAKE_SHORTSTRING("vpmovw2m"),
    ZYDIS_MAKE_SHORTSTRING("vpmovwb"),
    ZYDIS_MAKE_SHORTSTRING("vpmovzxbd"),
    ZYDIS_MAKE_SHORTSTRING("vpmovzxbq"),
    ZYDIS_MAKE_SHORTSTRING("vpmovzxbw"),
    ZYDIS_MAKE_SHORTSTRING("vpmovzxdq"),
    ZYDIS_MAKE_SHORTSTRING("vpmovzxwd"),
    ZYDIS_MAKE_SHORTSTRING("vpmovzxwq"),
    ZYDIS_MAKE_SHORTSTRING("vpmuldq"),
    ZYDIS_MAKE_SHORTSTRING("vpmulhd"),
    ZYDIS_MAKE_SHORTSTRING("vpmulhrsw"),
    ZYDIS_MAKE_SHORTSTRING("vpmulhud"),
    ZYDIS_MAKE_SHORTSTRING("vpmulhuw"),
    ZYDIS_MAKE_SHORTSTRING("vpmulhw"),
    ZYDIS_MAKE_SHORTSTRING("vpmulld"),
    ZYDIS_MAKE_SHORTSTRING("vpmullq"),
    ZYDIS_MAKE_SHORTSTRING("vpmullw"),
    ZYDIS_MAKE_SHORTSTRING("vpmultishiftqb"),
    ZYDIS_MAKE_SHORTSTRING("vpmuludq"),
    ZYDIS_MAKE_SHORTSTRING("vpopcntb"),
    ZYDIS_MAKE_SHORTSTRING("vpopcntd"),
    ZYDIS_MAKE_SHORTSTRING("vpopcntq"),
    ZYDIS_MAKE_SHORTSTRING("vpopcntw"),
    ZYDIS_MAKE_SHORTSTRING("vpor"),
    ZYDIS_MAKE_SHORTSTRING("vpord"),
    ZYDIS_MAKE_SHORTSTRING("vporq"),
    ZYDIS_MAKE_SHORTSTRING("vpperm"),
    ZYDIS_MAKE_SHORTSTRING("vprefetch0"),
    ZYDIS_MAKE_SHORTSTRING("vprefetch1"),
    ZYDIS_MAKE_SHORTSTRING("vprefetch2"),
    ZYDIS_MAKE_SHORTSTRING("vprefetche0"),
    ZYDIS_MAKE_SHORTSTRING("vprefetche1"),
    ZYDIS_MAKE_SHORTSTRING("vprefetche2"),
    ZYDIS_MAKE_SHORTSTRING("vprefetchenta"),
    ZYDIS_MAKE_SHORTSTRING("vprefetchnta"),
    ZYDIS_MAKE_SHORTSTRING("vprold"),
    ZYDIS_MAKE_SHORTSTRING("vprolq"),
    ZYDIS_MAKE_SHORTSTRING("vprolvd"),
    ZYDIS_MAKE_SHORTSTRING("vprolvq"),
    ZYDIS_MAKE_SHORTSTRING("vprord"),
    ZYDIS_MAKE_SHORTSTRING("vprorq"),
    ZYDIS_MAKE_SHORTSTRING("vprorvd"),
    ZYDIS_MAKE_SHORTSTRING("vprorvq"),
    ZYDIS_MAKE_SHORTSTRING("vprotb"),
    ZYDIS_MAKE_SHORTSTRING("vprotd"),
    ZYDIS_MAKE_SHORTSTRING("vprotq"),
    ZYDIS_MAKE_SHORTSTRING("vprotw"),
    ZYDIS_MAKE_SHORTSTRING("vpsadbw"),
    ZYDIS_MAKE_SHORTSTRING("vpsbbd"),
    ZYDIS_MAKE_SHORTSTRING("vpsbbrd"),
    ZYDIS_MAKE_SHORTSTRING("vpscatterdd"),
    ZYDIS_MAKE_SHORTSTRING("vpscatterdq"),
    ZYDIS_MAKE_SHORTSTRING("vpscatterqd"),
    ZYDIS_MAKE_SHORTSTRING("vpscatterqq"),
    ZYDIS_MAKE_SHORTSTRING("vpshab"),
    ZYDIS_MAKE_SHORTSTRING("vpshad"),
    ZYDIS_MAKE_SHORTSTRING("vpshaq"),
    ZYDIS_MAKE_SHORTSTRING("vpshaw"),
    ZYDIS_MAKE_SHORTSTRING("vpshlb"),
    ZYDIS_MAKE_SHORTSTRING("vpshld"),
    ZYDIS_MAKE_SHORTSTRING("vpshldd"),
    ZYDIS_MAKE_SHORTSTRING("vpshldq"),
    ZYDIS_MAKE_SHORTSTRING("vpshldvd"),
    ZYDIS_MAKE_SHORTSTRING("vpshldvq"),
    ZYDIS_MAKE_SHORTSTRING("vpshldvw"),
    ZYDIS_MAKE_SHORTSTRING("vpshldw"),
    ZYDIS_MAKE_SHORTSTRING("vpshlq"),
    ZYDIS_MAKE_SHORTSTRING("vpshlw"),
    ZYDIS_MAKE_SHORTSTRING("vpshrdd"),
    ZYDIS_MAKE_SHORTSTRING("vpshrdq"),
    ZYDIS_MAKE_SHORTSTRING("vpshrdvd"),
    ZYDIS_MAKE_SHORTSTRING("vpshrdvq"),
    ZYDIS_MAKE_SHORTSTRING("vpshrdvw"),
    ZYDIS_MAKE_SHORTSTRING("vpshrdw"),
    ZYDIS_MAKE_SHORTSTRING("vpshufb"),
    ZYDIS_MAKE_SHORTSTRING("vpshufbitqmb"),
    ZYDIS_MAKE_SHORTSTRING("vpshufd"),
    ZYDIS_MAKE_SHORTSTRING("vpshufhw"),
    ZYDIS_MAKE_SHORTSTRING("vpshuflw"),
    ZYDIS_MAKE_SHORTSTRING("vpsignb"),
    ZYDIS_MAKE_SHORTSTRING("vpsignd"),
    ZYDIS_MAKE_SHORTSTRING("vpsignw"),
    ZYDIS_MAKE_SHORTSTRING("vpslld"),
    ZYDIS_MAKE_SHORTSTRING("vpslldq"),
    ZYDIS_MAKE_SHORTSTRING("vpsllq"),
    ZYDIS_MAKE_SHORTSTRING("vpsllvd"),
    ZYDIS_MAKE_SHORTSTRING("vpsllvq"),
    ZYDIS_MAKE_SHORTSTRING("vpsllvw"),
    ZYDIS_MAKE_SHORTSTRING("vpsllw"),
    ZYDIS_MAKE_SHORTSTRING("vpsrad"),
    ZYDIS_MAKE_SHORTSTRING("vpsraq"),
    ZYDIS_MAKE_SHORTSTRING("vpsravd"),
    ZYDIS_MAKE_SHORTSTRING("vpsravq"),
    ZYDIS_MAKE_SHORTSTRING("vpsravw"),
    ZYDIS_MAKE_SHORTSTRING("vpsraw"),
    ZYDIS_MAKE_SHORTSTRING("vpsrld"),
    ZYDIS_MAKE_SHORTSTRING("vpsrldq"),
    ZYDIS_MAKE_SHORTSTRING("vpsrlq"),
    ZYDIS_MAKE_SHORTSTRING("vpsrlvd"),
    ZYDIS_MAKE_SHORTSTRING("vpsrlvq"),
    ZYDIS_MAKE_SHORTSTRING("vpsrlvw"),
    ZYDIS_MAKE_SHORTSTRING("vpsrlw"),
    ZYDIS_MAKE_SHORTSTRING("vpsubb"),
    ZYDIS_MAKE_SHORTSTRING("vpsubd"),
    ZYDIS_MAKE_SHORTSTRING("vpsubq"),
    ZYDIS_MAKE_SHORTSTRING("vpsubrd"),
    ZYDIS_MAKE_SHORTSTRING("vpsubrsetbd"),
    ZYDIS_MAKE_SHORTSTRING("vpsubsb"),
    ZYDIS_MAKE_SHORTSTRING("vpsubsetbd"),
    ZYDIS_MAKE_SHORTSTRING("vpsubsw"),
    ZYDIS_MAKE_SHORTSTRING("vpsubusb"),
    ZYDIS_MAKE_SHORTSTRING("vpsubusw"),
    ZYDIS_MAKE_SHORTSTRING("vpsubw"),
    ZYDIS_MAKE_SHORTSTRING("vpternlogd"),
    ZYDIS_MAKE_SHORTSTRING("vpternlogq"),
    ZYDIS_MAKE_SHORTSTRING("vptest"),
    ZYDIS_MAKE_SHORTSTRING("vptestmb"),
    ZYDIS_MAKE_SHORTSTRING("vptestmd"),
    ZYDIS_MAKE_SHORTSTRING("vptestmq"),
    ZYDIS_MAKE_SHORTSTRING("vptestmw"),
    ZYDIS_MAKE_SHORTSTRING("vptestnmb"),
    ZYDIS_MAKE_SHORTSTRING("vptestnmd"),
    ZYDIS_MAKE_SHORTSTRING("vptestnmq"),
    ZYDIS_MAKE_SHORTSTRING("vptestnmw"),
    ZYDIS_MAKE_SHORTSTRING("vpunpckhbw"),
    ZYDIS_MAKE_SHORTSTRING("vpunpckhdq"),
    ZYDIS_MAKE_SHORTSTRING("vpunpckhqdq"),
    ZYDIS_MAKE_SHORTSTRING("vpunpckhwd"),
    ZYDIS_MAKE_SHORTSTRING("vpunpcklbw"),
    ZYDIS_MAKE_SHORTSTRING("vpunpckldq"),
    ZYDIS_MAKE_SHORTSTRING("vpunpcklqdq"),
    ZYDIS_MAKE_SHORTSTRING("vpunpcklwd"),
    ZYDIS_MAKE_SHORTSTRING("vpxor"),
    ZYDIS_MAKE_SHORTSTRING("vpxord"),
    ZYDIS_MAKE_SHORTSTRING("vpxorq"),
    ZYDIS_MAKE_SHORTSTRING("vrangepd"),
    ZYDIS_MAKE_SHORTSTRING("vrangeps"),
    ZYDIS_MAKE_SHORTSTRING("vrangesd"),
    ZYDIS_MAKE_SHORTSTRING("vrangess"),
    ZYDIS_MAKE_SHORTSTRING("vrcp14pd"),
    ZYDIS_MAKE_SHORTSTRING("vrcp14ps"),
    ZYDIS_MAKE_SHORTSTRING("vrcp14sd"),
    ZYDIS_MAKE_SHORTSTRING("vrcp14ss"),
    ZYDIS_MAKE_SHORTSTRING("vrcp23ps"),
    ZYDIS_MAKE_SHORTSTRING("vrcp28pd"),
    ZYDIS_MAKE_SHORTSTRING("vrcp28ps"),
    ZYDIS_MAKE_SHORTSTRING("vrcp28sd"),
    ZYDIS_MAKE_SHORTSTRING("vrcp28ss"),
    ZYDIS_MAKE_SHORTSTRING("vrcpph"),
    ZYDIS_MAKE_SHORTSTRING("vrcpps"),
    ZYDIS_MAKE_SHORTSTRING("vrcpsh"),
    ZYDIS_MAKE_SHORTSTRING("vrcpss"),
    ZYDIS_MAKE_SHORTSTRING("vreducepd"),
    ZYDIS_MAKE_SHORTSTRING("vreduceph"),
    ZYDIS_MAKE_SHORTSTRING("vreduceps"),
    ZYDIS_MAKE_SHORTSTRING("vreducesd"),
    ZYDIS_MAKE_SHORTSTRING("vreducesh"),
    ZYDIS_MAKE_SHORTSTRING("vreducess"),
    ZYDIS_MAKE_SHORTSTRING("vrndfxpntpd"),
    ZYDIS_MAKE_SHORTSTRING("vrndfxpntps"),
    ZYDIS_MAKE_SHORTSTRING("vrndscalepd"),
    ZYDIS_MAKE_SHORTSTRING("vrndscaleph"),
    ZYDIS_MAKE_SHORTSTRING("vrndscaleps"),
    ZYDIS_MAKE_SHORTSTRING("vrndscalesd"),
    ZYDIS_MAKE_SHORTSTRING("vrndscalesh"),
    ZYDIS_MAKE_SHORTSTRING("vrndscaless"),
    ZYDIS_MAKE_SHORTSTRING("vroundpd"),
    ZYDIS_MAKE_SHORTSTRING("vroundps"),
    ZYDIS_MAKE_SHORTSTRING("vroundsd"),
    ZYDIS_MAKE_SHORTSTRING("vroundss"),
    ZYDIS_MAKE_SHORTSTRING("vrsqrt14pd"),
    ZYDIS_MAKE_SHORTSTRING("vrsqrt14ps"),
    ZYDIS_MAKE_SHORTSTRING("vrsqrt14sd"),
    ZYDIS_MAKE_SHORTSTRING("vrsqrt14ss"),
    ZYDIS_MAKE_SHORTSTRING("vrsqrt23ps"),
    ZYDIS_MAKE_SHORTSTRING("vrsqrt28pd"),
    ZYDIS_MAKE_SHORTSTRING("vrsqrt28ps"),
    ZYDIS_MAKE_SHORTSTRING("vrsqrt28sd"),
    ZYDIS_MAKE_SHORTSTRING("vrsqrt28ss"),
    ZYDIS_MAKE_SHORTSTRING("vrsqrtph"),
    ZYDIS_MAKE_SHORTSTRING("vrsqrtps"),
    ZYDIS_MAKE_SHORTSTRING("vrsqrtsh"),
    ZYDIS_MAKE_SHORTSTRING("vrsqrtss"),
    ZYDIS_MAKE_SHORTSTRING("vscalefpd"),
    ZYDIS_MAKE_SHORTSTRING("vscalefph"),
    ZYDIS_MAKE_SHORTSTRING("vscalefps"),
    ZYDIS_MAKE_SHORTSTRING("vscalefsd"),
    ZYDIS_MAKE_SHORTSTRING("vscalefsh"),
    ZYDIS_MAKE_SHORTSTRING("vscalefss"),
    ZYDIS_MAKE_SHORTSTRING("vscaleps"),
    ZYDIS_MAKE_SHORTSTRING("vscatterdpd"),
    ZYDIS_MAKE_SHORTSTRING("vscatterdps"),
    ZYDIS_MAKE_SHORTSTRING("vscatterpf0dpd"),
    ZYDIS_MAKE_SHORTSTRING("vscatterpf0dps"),
    ZYDIS_MAKE_SHORTSTRING("vscatterpf0hintdpd"),
    ZYDIS_MAKE_SHORTSTRING("vscatterpf0hintdps"),
    ZYDIS_MAKE_SHORTSTRING("vscatterpf0qpd"),
    ZYDIS_MAKE_SHORTSTRING("vscatterpf0qps"),
    ZYDIS_MAKE_SHORTSTRING("vscatterpf1dpd"),
    ZYDIS_MAKE_SHORTSTRING("vscatterpf1dps"),
    ZYDIS_MAKE_SHORTSTRING("vscatterpf1qpd"),
    ZYDIS_MAKE_SHORTSTRING("vscatterpf1qps"),
    ZYDIS_MAKE_SHORTSTRING("vscatterqpd"),
    ZYDIS_MAKE_SHORTSTRING("vscatterqps"),
    ZYDIS_MAKE_SHORTSTRING("vsha512msg1"),
    ZYDIS_MAKE_SHORTSTRING("vsha512msg2"),
    ZYDIS_MAKE_SHORTSTRING("vsha512rnds2"),
    ZYDIS_MAKE_SHORTSTRING("vshuff32x4"),
    ZYDIS_MAKE_SHORTSTRING("vshuff64x2"),
    ZYDIS_MAKE_SHORTSTRING("vshufi32x4"),
    ZYDIS_MAKE_SHORTSTRING("vshufi64x2"),
    ZYDIS_MAKE_SHORTSTRING("vshufpd"),
    ZYDIS_MAKE_SHORTSTRING("vshufps"),
    ZYDIS_MAKE_SHORTSTRING("vsm3msg1"),
    ZYDIS_MAKE_SHORTSTRING("vsm3msg2"),
    ZYDIS_MAKE_SHORTSTRING("vsm3rnds2"),
    ZYDIS_MAKE_SHORTSTRING("vsm4key4"),
    ZYDIS_MAKE_SHORTSTRING("vsm4rnds4"),
    ZYDIS_MAKE_SHORTSTRING("vsqrtpd"),
    ZYDIS_MAKE_SHORTSTRING("vsqrtph"),
    ZYDIS_MAKE_SHORTSTRING("vsqrtps"),
    ZYDIS_MAKE_SHORTSTRING("vsqrtsd"),
    ZYDIS_MAKE_SHORTSTRING("vsqrtsh"),
    ZYDIS_MAKE_SHORTSTRING("vsqrtss"),
    ZYDIS_MAKE_SHORTSTRING("vstmxcsr"),
    ZYDIS_MAKE_SHORTSTRING("vsubpd"),
    ZYDIS_MAKE_SHORTSTRING("vsubph"),
    ZYDIS_MAKE_SHORTSTRING("vsubps"),
    ZYDIS_MAKE_SHORTSTRING("vsubrpd"),
    ZYDIS_MAKE_SHORTSTRING("vsubrps"),
    ZYDIS_MAKE_SHORTSTRING("vsubsd"),
    ZYDIS_MAKE_SHORTSTRING("vsubsh"),
    ZYDIS_MAKE_SHORTSTRING("vsubss"),
    ZYDIS_MAKE_SHORTSTRING("vtestpd"),
    ZYDIS_MAKE_SHORTSTRING("vtestps"),
    ZYDIS_MAKE_SHORTSTRING("vucomisd"),
    ZYDIS_MAKE_SHORTSTRING("vucomish"),
    ZYDIS_MAKE_SHORTSTRING("vucomiss"),
    ZYDIS_MAKE_SHORTSTRING("vunpckhpd"),
    ZYDIS_MAKE_SHORTSTRING("vunpckhps"),
    ZYDIS_MAKE_SHORTSTRING("vunpcklpd"),
    ZYDIS_MAKE_SHORTSTRING("vunpcklps"),
    ZYDIS_MAKE_SHORTSTRING("vxorpd"),
    ZYDIS_MAKE_SHORTSTRING("vxorps"),
    ZYDIS_MAKE_SHORTSTRING("vzeroall"),
    ZYDIS_MAKE_SHORTSTRING("vzeroupper"),
    ZYDIS_MAKE_SHORTSTRING("wbinvd"),
    ZYDIS_MAKE_SHORTSTRING("wrfsbase"),
    ZYDIS_MAKE_SHORTSTRING("wrgsbase"),
    ZYDIS_MAKE_SHORTSTRING("wrmsr"),
    ZYDIS_MAKE_SHORTSTRING("wrmsrlist"),
    ZYDIS_MAKE_SHORTSTRING("wrmsrns"),
    ZYDIS_MAKE_SHORTSTRING("wrpkru"),
    ZYDIS_MAKE_SHORTSTRING("wrssd"),
    ZYDIS_MAKE_SHORTSTRING("wrssq"),
    ZYDIS_MAKE_SHORTSTRING("wrussd"),
    ZYDIS_MAKE_SHORTSTRING("wrussq"),
    ZYDIS_MAKE_SHORTSTRING("xabort"),
    ZYDIS_MAKE_SHORTSTRING("xadd"),
    ZYDIS_MAKE_SHORTSTRING("xbegin"),
    ZYDIS_MAKE_SHORTSTRING("xchg"),
    ZYDIS_MAKE_SHORTSTRING("xcrypt_cbc"),
    ZYDIS_MAKE_SHORTSTRING("xcrypt_cfb"),
    ZYDIS_MAKE_SHORTSTRING("xcrypt_ctr"),
    ZYDIS_MAKE_SHORTSTRING("xcrypt_ecb"),
    ZYDIS_MAKE_SHORTSTRING("xcrypt_ofb"),
    ZYDIS_MAKE_SHORTSTRING("xend"),
    ZYDIS_MAKE_SHORTSTRING("xgetbv"),
    ZYDIS_MAKE_SHORTSTRING("xlat"),
    ZYDIS_MAKE_SHORTSTRING("xor"),
    ZYDIS_MAKE_SHORTSTRING("xorpd"),
    ZYDIS_MAKE_SHORTSTRING("xorps"),
    ZYDIS_MAKE_SHORTSTRING("xresldtrk"),
    ZYDIS_MAKE_SHORTSTRING("xrstor"),
    ZYDIS_MAKE_SHORTSTRING("xrstor64"),
    ZYDIS_MAKE_SHORTSTRING("xrstors"),
    ZYDIS_MAKE_SHORTSTRING("xrstors64"),
    ZYDIS_MAKE_SHORTSTRING("xsave"),
    ZYDIS_MAKE_SHORTSTRING("xsave64"),
    ZYDIS_MAKE_SHORTSTRING("xsavec"),
    ZYDIS_MAKE_SHORTSTRING("xsavec64"),
    ZYDIS_MAKE_SHORTSTRING("xsaveopt"),
    ZYDIS_MAKE_SHORTSTRING("xsaveopt64"),
    ZYDIS_MAKE_SHORTSTRING("xsaves"),
    ZYDIS_MAKE_SHORTSTRING("xsaves64"),
    ZYDIS_MAKE_SHORTSTRING("xsetbv"),
    ZYDIS_MAKE_SHORTSTRING("xsha1"),
    ZYDIS_MAKE_SHORTSTRING("xsha256"),
    ZYDIS_MAKE_SHORTSTRING("xstore"),
    ZYDIS_MAKE_SHORTSTRING("xsusldtrk"),
    ZYDIS_MAKE_SHORTSTRING("xtest")
};

/* ============================================================================================== */
/* Exported functions                                                                             */
/* ============================================================================================== */

const char* ZydisMnemonicGetString(ZydisMnemonic mnemonic)
{
    if ((ZyanUSize)mnemonic >= ZYAN_ARRAY_LENGTH(STR_MNEMONIC))
    {
        return ZYAN_NULL;
    }
    return (const char*)STR_MNEMONIC[mnemonic].data;
}

const ZydisShortString* ZydisMnemonicGetStringWrapped(ZydisMnemonic mnemonic)
{
    if ((ZyanUSize)mnemonic >= ZYAN_ARRAY_LENGTH(STR_MNEMONIC))
    {
        return ZYAN_NULL;
    }
    return &STR_MNEMONIC[mnemonic];
}

/* ============================================================================================== */

//
// Source file: /home/ath/devel/zydis/src/Register.c
//

/***************************************************************************************************

  Zyan Disassembler Library (Zydis)

  Original Author : Florian Bernd

 * Permission is hereby granted, free of charge, to any person obtaining a copy
 * of this software and associated documentation files (the "Software"), to deal
 * in the Software without restriction, including without limitation the rights
 * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
 * copies of the Software, and to permit persons to whom the Software is
 * furnished to do so, subject to the following conditions:
 *
 * The above copyright notice and this permission notice shall be included in all
 * copies or substantial portions of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
 * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
 * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
 * SOFTWARE.

***************************************************************************************************/


/* ============================================================================================== */
/* Register strings                                                                               */
/* ============================================================================================== */


//
// Header: Generated/EnumRegister.inc
//

static const ZydisShortString STR_REGISTERS[] =
{
    ZYDIS_MAKE_SHORTSTRING("none"),
    // General purpose registers  8-bit
    ZYDIS_MAKE_SHORTSTRING("al"),
    ZYDIS_MAKE_SHORTSTRING("cl"),
    ZYDIS_MAKE_SHORTSTRING("dl"),
    ZYDIS_MAKE_SHORTSTRING("bl"),
    ZYDIS_MAKE_SHORTSTRING("ah"),
    ZYDIS_MAKE_SHORTSTRING("ch"),
    ZYDIS_MAKE_SHORTSTRING("dh"),
    ZYDIS_MAKE_SHORTSTRING("bh"),
    ZYDIS_MAKE_SHORTSTRING("spl"),
    ZYDIS_MAKE_SHORTSTRING("bpl"),
    ZYDIS_MAKE_SHORTSTRING("sil"),
    ZYDIS_MAKE_SHORTSTRING("dil"),
    ZYDIS_MAKE_SHORTSTRING("r8b"),
    ZYDIS_MAKE_SHORTSTRING("r9b"),
    ZYDIS_MAKE_SHORTSTRING("r10b"),
    ZYDIS_MAKE_SHORTSTRING("r11b"),
    ZYDIS_MAKE_SHORTSTRING("r12b"),
    ZYDIS_MAKE_SHORTSTRING("r13b"),
    ZYDIS_MAKE_SHORTSTRING("r14b"),
    ZYDIS_MAKE_SHORTSTRING("r15b"),
    // General purpose registers 16-bit
    ZYDIS_MAKE_SHORTSTRING("ax"),
    ZYDIS_MAKE_SHORTSTRING("cx"),
    ZYDIS_MAKE_SHORTSTRING("dx"),
    ZYDIS_MAKE_SHORTSTRING("bx"),
    ZYDIS_MAKE_SHORTSTRING("sp"),
    ZYDIS_MAKE_SHORTSTRING("bp"),
    ZYDIS_MAKE_SHORTSTRING("si"),
    ZYDIS_MAKE_SHORTSTRING("di"),
    ZYDIS_MAKE_SHORTSTRING("r8w"),
    ZYDIS_MAKE_SHORTSTRING("r9w"),
    ZYDIS_MAKE_SHORTSTRING("r10w"),
    ZYDIS_MAKE_SHORTSTRING("r11w"),
    ZYDIS_MAKE_SHORTSTRING("r12w"),
    ZYDIS_MAKE_SHORTSTRING("r13w"),
    ZYDIS_MAKE_SHORTSTRING("r14w"),
    ZYDIS_MAKE_SHORTSTRING("r15w"),
    // General purpose registers 32-bit
    ZYDIS_MAKE_SHORTSTRING("eax"),
    ZYDIS_MAKE_SHORTSTRING("ecx"),
    ZYDIS_MAKE_SHORTSTRING("edx"),
    ZYDIS_MAKE_SHORTSTRING("ebx"),
    ZYDIS_MAKE_SHORTSTRING("esp"),
    ZYDIS_MAKE_SHORTSTRING("ebp"),
    ZYDIS_MAKE_SHORTSTRING("esi"),
    ZYDIS_MAKE_SHORTSTRING("edi"),
    ZYDIS_MAKE_SHORTSTRING("r8d"),
    ZYDIS_MAKE_SHORTSTRING("r9d"),
    ZYDIS_MAKE_SHORTSTRING("r10d"),
    ZYDIS_MAKE_SHORTSTRING("r11d"),
    ZYDIS_MAKE_SHORTSTRING("r12d"),
    ZYDIS_MAKE_SHORTSTRING("r13d"),
    ZYDIS_MAKE_SHORTSTRING("r14d"),
    ZYDIS_MAKE_SHORTSTRING("r15d"),
    // General purpose registers 64-bit
    ZYDIS_MAKE_SHORTSTRING("rax"),
    ZYDIS_MAKE_SHORTSTRING("rcx"),
    ZYDIS_MAKE_SHORTSTRING("rdx"),
    ZYDIS_MAKE_SHORTSTRING("rbx"),
    ZYDIS_MAKE_SHORTSTRING("rsp"),
    ZYDIS_MAKE_SHORTSTRING("rbp"),
    ZYDIS_MAKE_SHORTSTRING("rsi"),
    ZYDIS_MAKE_SHORTSTRING("rdi"),
    ZYDIS_MAKE_SHORTSTRING("r8"),
    ZYDIS_MAKE_SHORTSTRING("r9"),
    ZYDIS_MAKE_SHORTSTRING("r10"),
    ZYDIS_MAKE_SHORTSTRING("r11"),
    ZYDIS_MAKE_SHORTSTRING("r12"),
    ZYDIS_MAKE_SHORTSTRING("r13"),
    ZYDIS_MAKE_SHORTSTRING("r14"),
    ZYDIS_MAKE_SHORTSTRING("r15"),
    // Floating point legacy registers
    ZYDIS_MAKE_SHORTSTRING("st0"),
    ZYDIS_MAKE_SHORTSTRING("st1"),
    ZYDIS_MAKE_SHORTSTRING("st2"),
    ZYDIS_MAKE_SHORTSTRING("st3"),
    ZYDIS_MAKE_SHORTSTRING("st4"),
    ZYDIS_MAKE_SHORTSTRING("st5"),
    ZYDIS_MAKE_SHORTSTRING("st6"),
    ZYDIS_MAKE_SHORTSTRING("st7"),
    ZYDIS_MAKE_SHORTSTRING("x87control"),
    ZYDIS_MAKE_SHORTSTRING("x87status"),
    ZYDIS_MAKE_SHORTSTRING("x87tag"),
    // Floating point multimedia registers
    ZYDIS_MAKE_SHORTSTRING("mm0"),
    ZYDIS_MAKE_SHORTSTRING("mm1"),
    ZYDIS_MAKE_SHORTSTRING("mm2"),
    ZYDIS_MAKE_SHORTSTRING("mm3"),
    ZYDIS_MAKE_SHORTSTRING("mm4"),
    ZYDIS_MAKE_SHORTSTRING("mm5"),
    ZYDIS_MAKE_SHORTSTRING("mm6"),
    ZYDIS_MAKE_SHORTSTRING("mm7"),
    // Floating point vector registers 128-bit
    ZYDIS_MAKE_SHORTSTRING("xmm0"),
    ZYDIS_MAKE_SHORTSTRING("xmm1"),
    ZYDIS_MAKE_SHORTSTRING("xmm2"),
    ZYDIS_MAKE_SHORTSTRING("xmm3"),
    ZYDIS_MAKE_SHORTSTRING("xmm4"),
    ZYDIS_MAKE_SHORTSTRING("xmm5"),
    ZYDIS_MAKE_SHORTSTRING("xmm6"),
    ZYDIS_MAKE_SHORTSTRING("xmm7"),
    ZYDIS_MAKE_SHORTSTRING("xmm8"),
    ZYDIS_MAKE_SHORTSTRING("xmm9"),
    ZYDIS_MAKE_SHORTSTRING("xmm10"),
    ZYDIS_MAKE_SHORTSTRING("xmm11"),
    ZYDIS_MAKE_SHORTSTRING("xmm12"),
    ZYDIS_MAKE_SHORTSTRING("xmm13"),
    ZYDIS_MAKE_SHORTSTRING("xmm14"),
    ZYDIS_MAKE_SHORTSTRING("xmm15"),
    ZYDIS_MAKE_SHORTSTRING("xmm16"),
    ZYDIS_MAKE_SHORTSTRING("xmm17"),
    ZYDIS_MAKE_SHORTSTRING("xmm18"),
    ZYDIS_MAKE_SHORTSTRING("xmm19"),
    ZYDIS_MAKE_SHORTSTRING("xmm20"),
    ZYDIS_MAKE_SHORTSTRING("xmm21"),
    ZYDIS_MAKE_SHORTSTRING("xmm22"),
    ZYDIS_MAKE_SHORTSTRING("xmm23"),
    ZYDIS_MAKE_SHORTSTRING("xmm24"),
    ZYDIS_MAKE_SHORTSTRING("xmm25"),
    ZYDIS_MAKE_SHORTSTRING("xmm26"),
    ZYDIS_MAKE_SHORTSTRING("xmm27"),
    ZYDIS_MAKE_SHORTSTRING("xmm28"),
    ZYDIS_MAKE_SHORTSTRING("xmm29"),
    ZYDIS_MAKE_SHORTSTRING("xmm30"),
    ZYDIS_MAKE_SHORTSTRING("xmm31"),
    // Floating point vector registers 256-bit
    ZYDIS_MAKE_SHORTSTRING("ymm0"),
    ZYDIS_MAKE_SHORTSTRING("ymm1"),
    ZYDIS_MAKE_SHORTSTRING("ymm2"),
    ZYDIS_MAKE_SHORTSTRING("ymm3"),
    ZYDIS_MAKE_SHORTSTRING("ymm4"),
    ZYDIS_MAKE_SHORTSTRING("ymm5"),
    ZYDIS_MAKE_SHORTSTRING("ymm6"),
    ZYDIS_MAKE_SHORTSTRING("ymm7"),
    ZYDIS_MAKE_SHORTSTRING("ymm8"),
    ZYDIS_MAKE_SHORTSTRING("ymm9"),
    ZYDIS_MAKE_SHORTSTRING("ymm10"),
    ZYDIS_MAKE_SHORTSTRING("ymm11"),
    ZYDIS_MAKE_SHORTSTRING("ymm12"),
    ZYDIS_MAKE_SHORTSTRING("ymm13"),
    ZYDIS_MAKE_SHORTSTRING("ymm14"),
    ZYDIS_MAKE_SHORTSTRING("ymm15"),
    ZYDIS_MAKE_SHORTSTRING("ymm16"),
    ZYDIS_MAKE_SHORTSTRING("ymm17"),
    ZYDIS_MAKE_SHORTSTRING("ymm18"),
    ZYDIS_MAKE_SHORTSTRING("ymm19"),
    ZYDIS_MAKE_SHORTSTRING("ymm20"),
    ZYDIS_MAKE_SHORTSTRING("ymm21"),
    ZYDIS_MAKE_SHORTSTRING("ymm22"),
    ZYDIS_MAKE_SHORTSTRING("ymm23"),
    ZYDIS_MAKE_SHORTSTRING("ymm24"),
    ZYDIS_MAKE_SHORTSTRING("ymm25"),
    ZYDIS_MAKE_SHORTSTRING("ymm26"),
    ZYDIS_MAKE_SHORTSTRING("ymm27"),
    ZYDIS_MAKE_SHORTSTRING("ymm28"),
    ZYDIS_MAKE_SHORTSTRING("ymm29"),
    ZYDIS_MAKE_SHORTSTRING("ymm30"),
    ZYDIS_MAKE_SHORTSTRING("ymm31"),
    // Floating point vector registers 512-bit
    ZYDIS_MAKE_SHORTSTRING("zmm0"),
    ZYDIS_MAKE_SHORTSTRING("zmm1"),
    ZYDIS_MAKE_SHORTSTRING("zmm2"),
    ZYDIS_MAKE_SHORTSTRING("zmm3"),
    ZYDIS_MAKE_SHORTSTRING("zmm4"),
    ZYDIS_MAKE_SHORTSTRING("zmm5"),
    ZYDIS_MAKE_SHORTSTRING("zmm6"),
    ZYDIS_MAKE_SHORTSTRING("zmm7"),
    ZYDIS_MAKE_SHORTSTRING("zmm8"),
    ZYDIS_MAKE_SHORTSTRING("zmm9"),
    ZYDIS_MAKE_SHORTSTRING("zmm10"),
    ZYDIS_MAKE_SHORTSTRING("zmm11"),
    ZYDIS_MAKE_SHORTSTRING("zmm12"),
    ZYDIS_MAKE_SHORTSTRING("zmm13"),
    ZYDIS_MAKE_SHORTSTRING("zmm14"),
    ZYDIS_MAKE_SHORTSTRING("zmm15"),
    ZYDIS_MAKE_SHORTSTRING("zmm16"),
    ZYDIS_MAKE_SHORTSTRING("zmm17"),
    ZYDIS_MAKE_SHORTSTRING("zmm18"),
    ZYDIS_MAKE_SHORTSTRING("zmm19"),
    ZYDIS_MAKE_SHORTSTRING("zmm20"),
    ZYDIS_MAKE_SHORTSTRING("zmm21"),
    ZYDIS_MAKE_SHORTSTRING("zmm22"),
    ZYDIS_MAKE_SHORTSTRING("zmm23"),
    ZYDIS_MAKE_SHORTSTRING("zmm24"),
    ZYDIS_MAKE_SHORTSTRING("zmm25"),
    ZYDIS_MAKE_SHORTSTRING("zmm26"),
    ZYDIS_MAKE_SHORTSTRING("zmm27"),
    ZYDIS_MAKE_SHORTSTRING("zmm28"),
    ZYDIS_MAKE_SHORTSTRING("zmm29"),
    ZYDIS_MAKE_SHORTSTRING("zmm30"),
    ZYDIS_MAKE_SHORTSTRING("zmm31"),
    // Matrix registers
    ZYDIS_MAKE_SHORTSTRING("tmm0"),
    ZYDIS_MAKE_SHORTSTRING("tmm1"),
    ZYDIS_MAKE_SHORTSTRING("tmm2"),
    ZYDIS_MAKE_SHORTSTRING("tmm3"),
    ZYDIS_MAKE_SHORTSTRING("tmm4"),
    ZYDIS_MAKE_SHORTSTRING("tmm5"),
    ZYDIS_MAKE_SHORTSTRING("tmm6"),
    ZYDIS_MAKE_SHORTSTRING("tmm7"),
    // Flags registers
    ZYDIS_MAKE_SHORTSTRING("flags"),
    ZYDIS_MAKE_SHORTSTRING("eflags"),
    ZYDIS_MAKE_SHORTSTRING("rflags"),
    // Instruction-pointer registers
    ZYDIS_MAKE_SHORTSTRING("ip"),
    ZYDIS_MAKE_SHORTSTRING("eip"),
    ZYDIS_MAKE_SHORTSTRING("rip"),
    // Segment registers
    ZYDIS_MAKE_SHORTSTRING("es"),
    ZYDIS_MAKE_SHORTSTRING("cs"),
    ZYDIS_MAKE_SHORTSTRING("ss"),
    ZYDIS_MAKE_SHORTSTRING("ds"),
    ZYDIS_MAKE_SHORTSTRING("fs"),
    ZYDIS_MAKE_SHORTSTRING("gs"),
    // Table registers
    ZYDIS_MAKE_SHORTSTRING("gdtr"),
    ZYDIS_MAKE_SHORTSTRING("ldtr"),
    ZYDIS_MAKE_SHORTSTRING("idtr"),
    ZYDIS_MAKE_SHORTSTRING("tr"),
    // Test registers
    ZYDIS_MAKE_SHORTSTRING("tr0"),
    ZYDIS_MAKE_SHORTSTRING("tr1"),
    ZYDIS_MAKE_SHORTSTRING("tr2"),
    ZYDIS_MAKE_SHORTSTRING("tr3"),
    ZYDIS_MAKE_SHORTSTRING("tr4"),
    ZYDIS_MAKE_SHORTSTRING("tr5"),
    ZYDIS_MAKE_SHORTSTRING("tr6"),
    ZYDIS_MAKE_SHORTSTRING("tr7"),
    // Control registers
    ZYDIS_MAKE_SHORTSTRING("cr0"),
    ZYDIS_MAKE_SHORTSTRING("cr1"),
    ZYDIS_MAKE_SHORTSTRING("cr2"),
    ZYDIS_MAKE_SHORTSTRING("cr3"),
    ZYDIS_MAKE_SHORTSTRING("cr4"),
    ZYDIS_MAKE_SHORTSTRING("cr5"),
    ZYDIS_MAKE_SHORTSTRING("cr6"),
    ZYDIS_MAKE_SHORTSTRING("cr7"),
    ZYDIS_MAKE_SHORTSTRING("cr8"),
    ZYDIS_MAKE_SHORTSTRING("cr9"),
    ZYDIS_MAKE_SHORTSTRING("cr10"),
    ZYDIS_MAKE_SHORTSTRING("cr11"),
    ZYDIS_MAKE_SHORTSTRING("cr12"),
    ZYDIS_MAKE_SHORTSTRING("cr13"),
    ZYDIS_MAKE_SHORTSTRING("cr14"),
    ZYDIS_MAKE_SHORTSTRING("cr15"),
    // Debug registers
    ZYDIS_MAKE_SHORTSTRING("dr0"),
    ZYDIS_MAKE_SHORTSTRING("dr1"),
    ZYDIS_MAKE_SHORTSTRING("dr2"),
    ZYDIS_MAKE_SHORTSTRING("dr3"),
    ZYDIS_MAKE_SHORTSTRING("dr4"),
    ZYDIS_MAKE_SHORTSTRING("dr5"),
    ZYDIS_MAKE_SHORTSTRING("dr6"),
    ZYDIS_MAKE_SHORTSTRING("dr7"),
    ZYDIS_MAKE_SHORTSTRING("dr8"),
    ZYDIS_MAKE_SHORTSTRING("dr9"),
    ZYDIS_MAKE_SHORTSTRING("dr10"),
    ZYDIS_MAKE_SHORTSTRING("dr11"),
    ZYDIS_MAKE_SHORTSTRING("dr12"),
    ZYDIS_MAKE_SHORTSTRING("dr13"),
    ZYDIS_MAKE_SHORTSTRING("dr14"),
    ZYDIS_MAKE_SHORTSTRING("dr15"),
    // Mask registers
    ZYDIS_MAKE_SHORTSTRING("k0"),
    ZYDIS_MAKE_SHORTSTRING("k1"),
    ZYDIS_MAKE_SHORTSTRING("k2"),
    ZYDIS_MAKE_SHORTSTRING("k3"),
    ZYDIS_MAKE_SHORTSTRING("k4"),
    ZYDIS_MAKE_SHORTSTRING("k5"),
    ZYDIS_MAKE_SHORTSTRING("k6"),
    ZYDIS_MAKE_SHORTSTRING("k7"),
    // Bound registers
    ZYDIS_MAKE_SHORTSTRING("bnd0"),
    ZYDIS_MAKE_SHORTSTRING("bnd1"),
    ZYDIS_MAKE_SHORTSTRING("bnd2"),
    ZYDIS_MAKE_SHORTSTRING("bnd3"),
    ZYDIS_MAKE_SHORTSTRING("bndcfg"),
    ZYDIS_MAKE_SHORTSTRING("bndstatus"),
    // Uncategorized
    ZYDIS_MAKE_SHORTSTRING("mxcsr"),
    ZYDIS_MAKE_SHORTSTRING("pkru"),
    ZYDIS_MAKE_SHORTSTRING("xcr0"),
    ZYDIS_MAKE_SHORTSTRING("uif")
};

/* ============================================================================================== */
/* Register-class mapping                                                                         */
/* ============================================================================================== */

/**
 * Defines the `ZydisRegisterMapItem` struct.
 */
typedef struct ZydisRegisterLookupItem
{
    /**
     * The register class.
     */
    ZydisRegisterClass class;
    /**
     * The register id.
     */
    ZyanI8 id;
    /**
     * The width of register 16- and 32-bit mode.
     */
    ZydisRegisterWidth width;
    /**
     * The width of register in 64-bit mode.
     */
    ZydisRegisterWidth width64;
} ZydisRegisterLookupItem;


//
// Header: Generated/RegisterLookup.inc
//

static const ZydisRegisterLookupItem REG_LOOKUP[] =
{
    /* NONE       */ { ZYDIS_REGCLASS_INVALID, -1, 0, 0 },
    /* AL         */ { ZYDIS_REGCLASS_GPR8, 0, 8, 8 },
    /* CL         */ { ZYDIS_REGCLASS_GPR8, 1, 8, 8 },
    /* DL         */ { ZYDIS_REGCLASS_GPR8, 2, 8, 8 },
    /* BL         */ { ZYDIS_REGCLASS_GPR8, 3, 8, 8 },
    /* AH         */ { ZYDIS_REGCLASS_GPR8, 4, 8, 8 },
    /* CH         */ { ZYDIS_REGCLASS_GPR8, 5, 8, 8 },
    /* DH         */ { ZYDIS_REGCLASS_GPR8, 6, 8, 8 },
    /* BH         */ { ZYDIS_REGCLASS_GPR8, 7, 8, 8 },
    /* SPL        */ { ZYDIS_REGCLASS_GPR8, 8, 8, 8 },
    /* BPL        */ { ZYDIS_REGCLASS_GPR8, 9, 8, 8 },
    /* SIL        */ { ZYDIS_REGCLASS_GPR8, 10, 8, 8 },
    /* DIL        */ { ZYDIS_REGCLASS_GPR8, 11, 8, 8 },
    /* R8B        */ { ZYDIS_REGCLASS_GPR8, 12, 8, 8 },
    /* R9B        */ { ZYDIS_REGCLASS_GPR8, 13, 8, 8 },
    /* R10B       */ { ZYDIS_REGCLASS_GPR8, 14, 8, 8 },
    /* R11B       */ { ZYDIS_REGCLASS_GPR8, 15, 8, 8 },
    /* R12B       */ { ZYDIS_REGCLASS_GPR8, 16, 8, 8 },
    /* R13B       */ { ZYDIS_REGCLASS_GPR8, 17, 8, 8 },
    /* R14B       */ { ZYDIS_REGCLASS_GPR8, 18, 8, 8 },
    /* R15B       */ { ZYDIS_REGCLASS_GPR8, 19, 8, 8 },
    /* AX         */ { ZYDIS_REGCLASS_GPR16, 0, 16, 16 },
    /* CX         */ { ZYDIS_REGCLASS_GPR16, 1, 16, 16 },
    /* DX         */ { ZYDIS_REGCLASS_GPR16, 2, 16, 16 },
    /* BX         */ { ZYDIS_REGCLASS_GPR16, 3, 16, 16 },
    /* SP         */ { ZYDIS_REGCLASS_GPR16, 4, 16, 16 },
    /* BP         */ { ZYDIS_REGCLASS_GPR16, 5, 16, 16 },
    /* SI         */ { ZYDIS_REGCLASS_GPR16, 6, 16, 16 },
    /* DI         */ { ZYDIS_REGCLASS_GPR16, 7, 16, 16 },
    /* R8W        */ { ZYDIS_REGCLASS_GPR16, 8, 16, 16 },
    /* R9W        */ { ZYDIS_REGCLASS_GPR16, 9, 16, 16 },
    /* R10W       */ { ZYDIS_REGCLASS_GPR16, 10, 16, 16 },
    /* R11W       */ { ZYDIS_REGCLASS_GPR16, 11, 16, 16 },
    /* R12W       */ { ZYDIS_REGCLASS_GPR16, 12, 16, 16 },
    /* R13W       */ { ZYDIS_REGCLASS_GPR16, 13, 16, 16 },
    /* R14W       */ { ZYDIS_REGCLASS_GPR16, 14, 16, 16 },
    /* R15W       */ { ZYDIS_REGCLASS_GPR16, 15, 16, 16 },
    /* EAX        */ { ZYDIS_REGCLASS_GPR32, 0, 32, 32 },
    /* ECX        */ { ZYDIS_REGCLASS_GPR32, 1, 32, 32 },
    /* EDX        */ { ZYDIS_REGCLASS_GPR32, 2, 32, 32 },
    /* EBX        */ { ZYDIS_REGCLASS_GPR32, 3, 32, 32 },
    /* ESP        */ { ZYDIS_REGCLASS_GPR32, 4, 32, 32 },
    /* EBP        */ { ZYDIS_REGCLASS_GPR32, 5, 32, 32 },
    /* ESI        */ { ZYDIS_REGCLASS_GPR32, 6, 32, 32 },
    /* EDI        */ { ZYDIS_REGCLASS_GPR32, 7, 32, 32 },
    /* R8D        */ { ZYDIS_REGCLASS_GPR32, 8, 32, 32 },
    /* R9D        */ { ZYDIS_REGCLASS_GPR32, 9, 32, 32 },
    /* R10D       */ { ZYDIS_REGCLASS_GPR32, 10, 32, 32 },
    /* R11D       */ { ZYDIS_REGCLASS_GPR32, 11, 32, 32 },
    /* R12D       */ { ZYDIS_REGCLASS_GPR32, 12, 32, 32 },
    /* R13D       */ { ZYDIS_REGCLASS_GPR32, 13, 32, 32 },
    /* R14D       */ { ZYDIS_REGCLASS_GPR32, 14, 32, 32 },
    /* R15D       */ { ZYDIS_REGCLASS_GPR32, 15, 32, 32 },
    /* RAX        */ { ZYDIS_REGCLASS_GPR64, 0, 0, 64 },
    /* RCX        */ { ZYDIS_REGCLASS_GPR64, 1, 0, 64 },
    /* RDX        */ { ZYDIS_REGCLASS_GPR64, 2, 0, 64 },
    /* RBX        */ { ZYDIS_REGCLASS_GPR64, 3, 0, 64 },
    /* RSP        */ { ZYDIS_REGCLASS_GPR64, 4, 0, 64 },
    /* RBP        */ { ZYDIS_REGCLASS_GPR64, 5, 0, 64 },
    /* RSI        */ { ZYDIS_REGCLASS_GPR64, 6, 0, 64 },
    /* RDI        */ { ZYDIS_REGCLASS_GPR64, 7, 0, 64 },
    /* R8         */ { ZYDIS_REGCLASS_GPR64, 8, 0, 64 },
    /* R9         */ { ZYDIS_REGCLASS_GPR64, 9, 0, 64 },
    /* R10        */ { ZYDIS_REGCLASS_GPR64, 10, 0, 64 },
    /* R11        */ { ZYDIS_REGCLASS_GPR64, 11, 0, 64 },
    /* R12        */ { ZYDIS_REGCLASS_GPR64, 12, 0, 64 },
    /* R13        */ { ZYDIS_REGCLASS_GPR64, 13, 0, 64 },
    /* R14        */ { ZYDIS_REGCLASS_GPR64, 14, 0, 64 },
    /* R15        */ { ZYDIS_REGCLASS_GPR64, 15, 0, 64 },
    /* ST0        */ { ZYDIS_REGCLASS_X87, 0, 80, 80 },
    /* ST1        */ { ZYDIS_REGCLASS_X87, 1, 80, 80 },
    /* ST2        */ { ZYDIS_REGCLASS_X87, 2, 80, 80 },
    /* ST3        */ { ZYDIS_REGCLASS_X87, 3, 80, 80 },
    /* ST4        */ { ZYDIS_REGCLASS_X87, 4, 80, 80 },
    /* ST5        */ { ZYDIS_REGCLASS_X87, 5, 80, 80 },
    /* ST6        */ { ZYDIS_REGCLASS_X87, 6, 80, 80 },
    /* ST7        */ { ZYDIS_REGCLASS_X87, 7, 80, 80 },
    /* X87CONTROL */ { ZYDIS_REGCLASS_INVALID, -1, 16, 16 },
    /* X87STATUS  */ { ZYDIS_REGCLASS_INVALID, -1, 16, 16 },
    /* X87TAG     */ { ZYDIS_REGCLASS_INVALID, -1, 16, 16 },
    /* MM0        */ { ZYDIS_REGCLASS_MMX, 0, 64, 64 },
    /* MM1        */ { ZYDIS_REGCLASS_MMX, 1, 64, 64 },
    /* MM2        */ { ZYDIS_REGCLASS_MMX, 2, 64, 64 },
    /* MM3        */ { ZYDIS_REGCLASS_MMX, 3, 64, 64 },
    /* MM4        */ { ZYDIS_REGCLASS_MMX, 4, 64, 64 },
    /* MM5        */ { ZYDIS_REGCLASS_MMX, 5, 64, 64 },
    /* MM6        */ { ZYDIS_REGCLASS_MMX, 6, 64, 64 },
    /* MM7        */ { ZYDIS_REGCLASS_MMX, 7, 64, 64 },
    /* XMM0       */ { ZYDIS_REGCLASS_XMM, 0, 128, 128 },
    /* XMM1       */ { ZYDIS_REGCLASS_XMM, 1, 128, 128 },
    /* XMM2       */ { ZYDIS_REGCLASS_XMM, 2, 128, 128 },
    /* XMM3       */ { ZYDIS_REGCLASS_XMM, 3, 128, 128 },
    /* XMM4       */ { ZYDIS_REGCLASS_XMM, 4, 128, 128 },
    /* XMM5       */ { ZYDIS_REGCLASS_XMM, 5, 128, 128 },
    /* XMM6       */ { ZYDIS_REGCLASS_XMM, 6, 128, 128 },
    /* XMM7       */ { ZYDIS_REGCLASS_XMM, 7, 128, 128 },
    /* XMM8       */ { ZYDIS_REGCLASS_XMM, 8, 128, 128 },
    /* XMM9       */ { ZYDIS_REGCLASS_XMM, 9, 128, 128 },
    /* XMM10      */ { ZYDIS_REGCLASS_XMM, 10, 128, 128 },
    /* XMM11      */ { ZYDIS_REGCLASS_XMM, 11, 128, 128 },
    /* XMM12      */ { ZYDIS_REGCLASS_XMM, 12, 128, 128 },
    /* XMM13      */ { ZYDIS_REGCLASS_XMM, 13, 128, 128 },
    /* XMM14      */ { ZYDIS_REGCLASS_XMM, 14, 128, 128 },
    /* XMM15      */ { ZYDIS_REGCLASS_XMM, 15, 128, 128 },
    /* XMM16      */ { ZYDIS_REGCLASS_XMM, 16, 128, 128 },
    /* XMM17      */ { ZYDIS_REGCLASS_XMM, 17, 128, 128 },
    /* XMM18      */ { ZYDIS_REGCLASS_XMM, 18, 128, 128 },
    /* XMM19      */ { ZYDIS_REGCLASS_XMM, 19, 128, 128 },
    /* XMM20      */ { ZYDIS_REGCLASS_XMM, 20, 128, 128 },
    /* XMM21      */ { ZYDIS_REGCLASS_XMM, 21, 128, 128 },
    /* XMM22      */ { ZYDIS_REGCLASS_XMM, 22, 128, 128 },
    /* XMM23      */ { ZYDIS_REGCLASS_XMM, 23, 128, 128 },
    /* XMM24      */ { ZYDIS_REGCLASS_XMM, 24, 128, 128 },
    /* XMM25      */ { ZYDIS_REGCLASS_XMM, 25, 128, 128 },
    /* XMM26      */ { ZYDIS_REGCLASS_XMM, 26, 128, 128 },
    /* XMM27      */ { ZYDIS_REGCLASS_XMM, 27, 128, 128 },
    /* XMM28      */ { ZYDIS_REGCLASS_XMM, 28, 128, 128 },
    /* XMM29      */ { ZYDIS_REGCLASS_XMM, 29, 128, 128 },
    /* XMM30      */ { ZYDIS_REGCLASS_XMM, 30, 128, 128 },
    /* XMM31      */ { ZYDIS_REGCLASS_XMM, 31, 128, 128 },
    /* YMM0       */ { ZYDIS_REGCLASS_YMM, 0, 256, 256 },
    /* YMM1       */ { ZYDIS_REGCLASS_YMM, 1, 256, 256 },
    /* YMM2       */ { ZYDIS_REGCLASS_YMM, 2, 256, 256 },
    /* YMM3       */ { ZYDIS_REGCLASS_YMM, 3, 256, 256 },
    /* YMM4       */ { ZYDIS_REGCLASS_YMM, 4, 256, 256 },
    /* YMM5       */ { ZYDIS_REGCLASS_YMM, 5, 256, 256 },
    /* YMM6       */ { ZYDIS_REGCLASS_YMM, 6, 256, 256 },
    /* YMM7       */ { ZYDIS_REGCLASS_YMM, 7, 256, 256 },
    /* YMM8       */ { ZYDIS_REGCLASS_YMM, 8, 256, 256 },
    /* YMM9       */ { ZYDIS_REGCLASS_YMM, 9, 256, 256 },
    /* YMM10      */ { ZYDIS_REGCLASS_YMM, 10, 256, 256 },
    /* YMM11      */ { ZYDIS_REGCLASS_YMM, 11, 256, 256 },
    /* YMM12      */ { ZYDIS_REGCLASS_YMM, 12, 256, 256 },
    /* YMM13      */ { ZYDIS_REGCLASS_YMM, 13, 256, 256 },
    /* YMM14      */ { ZYDIS_REGCLASS_YMM, 14, 256, 256 },
    /* YMM15      */ { ZYDIS_REGCLASS_YMM, 15, 256, 256 },
    /* YMM16      */ { ZYDIS_REGCLASS_YMM, 16, 256, 256 },
    /* YMM17      */ { ZYDIS_REGCLASS_YMM, 17, 256, 256 },
    /* YMM18      */ { ZYDIS_REGCLASS_YMM, 18, 256, 256 },
    /* YMM19      */ { ZYDIS_REGCLASS_YMM, 19, 256, 256 },
    /* YMM20      */ { ZYDIS_REGCLASS_YMM, 20, 256, 256 },
    /* YMM21      */ { ZYDIS_REGCLASS_YMM, 21, 256, 256 },
    /* YMM22      */ { ZYDIS_REGCLASS_YMM, 22, 256, 256 },
    /* YMM23      */ { ZYDIS_REGCLASS_YMM, 23, 256, 256 },
    /* YMM24      */ { ZYDIS_REGCLASS_YMM, 24, 256, 256 },
    /* YMM25      */ { ZYDIS_REGCLASS_YMM, 25, 256, 256 },
    /* YMM26      */ { ZYDIS_REGCLASS_YMM, 26, 256, 256 },
    /* YMM27      */ { ZYDIS_REGCLASS_YMM, 27, 256, 256 },
    /* YMM28      */ { ZYDIS_REGCLASS_YMM, 28, 256, 256 },
    /* YMM29      */ { ZYDIS_REGCLASS_YMM, 29, 256, 256 },
    /* YMM30      */ { ZYDIS_REGCLASS_YMM, 30, 256, 256 },
    /* YMM31      */ { ZYDIS_REGCLASS_YMM, 31, 256, 256 },
    /* ZMM0       */ { ZYDIS_REGCLASS_ZMM, 0, 512, 512 },
    /* ZMM1       */ { ZYDIS_REGCLASS_ZMM, 1, 512, 512 },
    /* ZMM2       */ { ZYDIS_REGCLASS_ZMM, 2, 512, 512 },
    /* ZMM3       */ { ZYDIS_REGCLASS_ZMM, 3, 512, 512 },
    /* ZMM4       */ { ZYDIS_REGCLASS_ZMM, 4, 512, 512 },
    /* ZMM5       */ { ZYDIS_REGCLASS_ZMM, 5, 512, 512 },
    /* ZMM6       */ { ZYDIS_REGCLASS_ZMM, 6, 512, 512 },
    /* ZMM7       */ { ZYDIS_REGCLASS_ZMM, 7, 512, 512 },
    /* ZMM8       */ { ZYDIS_REGCLASS_ZMM, 8, 512, 512 },
    /* ZMM9       */ { ZYDIS_REGCLASS_ZMM, 9, 512, 512 },
    /* ZMM10      */ { ZYDIS_REGCLASS_ZMM, 10, 512, 512 },
    /* ZMM11      */ { ZYDIS_REGCLASS_ZMM, 11, 512, 512 },
    /* ZMM12      */ { ZYDIS_REGCLASS_ZMM, 12, 512, 512 },
    /* ZMM13      */ { ZYDIS_REGCLASS_ZMM, 13, 512, 512 },
    /* ZMM14      */ { ZYDIS_REGCLASS_ZMM, 14, 512, 512 },
    /* ZMM15      */ { ZYDIS_REGCLASS_ZMM, 15, 512, 512 },
    /* ZMM16      */ { ZYDIS_REGCLASS_ZMM, 16, 512, 512 },
    /* ZMM17      */ { ZYDIS_REGCLASS_ZMM, 17, 512, 512 },
    /* ZMM18      */ { ZYDIS_REGCLASS_ZMM, 18, 512, 512 },
    /* ZMM19      */ { ZYDIS_REGCLASS_ZMM, 19, 512, 512 },
    /* ZMM20      */ { ZYDIS_REGCLASS_ZMM, 20, 512, 512 },
    /* ZMM21      */ { ZYDIS_REGCLASS_ZMM, 21, 512, 512 },
    /* ZMM22      */ { ZYDIS_REGCLASS_ZMM, 22, 512, 512 },
    /* ZMM23      */ { ZYDIS_REGCLASS_ZMM, 23, 512, 512 },
    /* ZMM24      */ { ZYDIS_REGCLASS_ZMM, 24, 512, 512 },
    /* ZMM25      */ { ZYDIS_REGCLASS_ZMM, 25, 512, 512 },
    /* ZMM26      */ { ZYDIS_REGCLASS_ZMM, 26, 512, 512 },
    /* ZMM27      */ { ZYDIS_REGCLASS_ZMM, 27, 512, 512 },
    /* ZMM28      */ { ZYDIS_REGCLASS_ZMM, 28, 512, 512 },
    /* ZMM29      */ { ZYDIS_REGCLASS_ZMM, 29, 512, 512 },
    /* ZMM30      */ { ZYDIS_REGCLASS_ZMM, 30, 512, 512 },
    /* ZMM31      */ { ZYDIS_REGCLASS_ZMM, 31, 512, 512 },
    /* TMM0       */ { ZYDIS_REGCLASS_TMM, 0, 8192, 8192 },
    /* TMM1       */ { ZYDIS_REGCLASS_TMM, 1, 8192, 8192 },
    /* TMM2       */ { ZYDIS_REGCLASS_TMM, 2, 8192, 8192 },
    /* TMM3       */ { ZYDIS_REGCLASS_TMM, 3, 8192, 8192 },
    /* TMM4       */ { ZYDIS_REGCLASS_TMM, 4, 8192, 8192 },
    /* TMM5       */ { ZYDIS_REGCLASS_TMM, 5, 8192, 8192 },
    /* TMM6       */ { ZYDIS_REGCLASS_TMM, 6, 8192, 8192 },
    /* TMM7       */ { ZYDIS_REGCLASS_TMM, 7, 8192, 8192 },
    /* FLAGS      */ { ZYDIS_REGCLASS_FLAGS, -1, 16, 16 },
    /* EFLAGS     */ { ZYDIS_REGCLASS_FLAGS, -1, 32, 32 },
    /* RFLAGS     */ { ZYDIS_REGCLASS_FLAGS, -1, 0, 64 },
    /* IP         */ { ZYDIS_REGCLASS_IP, -1, 16, 16 },
    /* EIP        */ { ZYDIS_REGCLASS_IP, -1, 32, 32 },
    /* RIP        */ { ZYDIS_REGCLASS_IP, -1, 0, 64 },
    /* ES         */ { ZYDIS_REGCLASS_SEGMENT, 0, 16, 16 },
    /* CS         */ { ZYDIS_REGCLASS_SEGMENT, 1, 16, 16 },
    /* SS         */ { ZYDIS_REGCLASS_SEGMENT, 2, 16, 16 },
    /* DS         */ { ZYDIS_REGCLASS_SEGMENT, 3, 16, 16 },
    /* FS         */ { ZYDIS_REGCLASS_SEGMENT, 4, 16, 16 },
    /* GS         */ { ZYDIS_REGCLASS_SEGMENT, 5, 16, 16 },
    /* GDTR       */ { ZYDIS_REGCLASS_TABLE, -1, 0, 0 },
    /* LDTR       */ { ZYDIS_REGCLASS_TABLE, -1, 0, 0 },
    /* IDTR       */ { ZYDIS_REGCLASS_TABLE, -1, 0, 0 },
    /* TR         */ { ZYDIS_REGCLASS_TABLE, -1, 0, 0 },
    /* TR0        */ { ZYDIS_REGCLASS_TEST, 0, 32, 32 },
    /* TR1        */ { ZYDIS_REGCLASS_TEST, 1, 32, 32 },
    /* TR2        */ { ZYDIS_REGCLASS_TEST, 2, 32, 32 },
    /* TR3        */ { ZYDIS_REGCLASS_TEST, 3, 32, 32 },
    /* TR4        */ { ZYDIS_REGCLASS_TEST, 4, 32, 32 },
    /* TR5        */ { ZYDIS_REGCLASS_TEST, 5, 32, 32 },
    /* TR6        */ { ZYDIS_REGCLASS_TEST, 6, 32, 32 },
    /* TR7        */ { ZYDIS_REGCLASS_TEST, 7, 32, 32 },
    /* CR0        */ { ZYDIS_REGCLASS_CONTROL, 0, 32, 64 },
    /* CR1        */ { ZYDIS_REGCLASS_CONTROL, 1, 32, 64 },
    /* CR2        */ { ZYDIS_REGCLASS_CONTROL, 2, 32, 64 },
    /* CR3        */ { ZYDIS_REGCLASS_CONTROL, 3, 32, 64 },
    /* CR4        */ { ZYDIS_REGCLASS_CONTROL, 4, 32, 64 },
    /* CR5        */ { ZYDIS_REGCLASS_CONTROL, 5, 32, 64 },
    /* CR6        */ { ZYDIS_REGCLASS_CONTROL, 6, 32, 64 },
    /* CR7        */ { ZYDIS_REGCLASS_CONTROL, 7, 32, 64 },
    /* CR8        */ { ZYDIS_REGCLASS_CONTROL, 8, 32, 64 },
    /* CR9        */ { ZYDIS_REGCLASS_CONTROL, 9, 32, 64 },
    /* CR10       */ { ZYDIS_REGCLASS_CONTROL, 10, 32, 64 },
    /* CR11       */ { ZYDIS_REGCLASS_CONTROL, 11, 32, 64 },
    /* CR12       */ { ZYDIS_REGCLASS_CONTROL, 12, 32, 64 },
    /* CR13       */ { ZYDIS_REGCLASS_CONTROL, 13, 32, 64 },
    /* CR14       */ { ZYDIS_REGCLASS_CONTROL, 14, 32, 64 },
    /* CR15       */ { ZYDIS_REGCLASS_CONTROL, 15, 32, 64 },
    /* DR0        */ { ZYDIS_REGCLASS_DEBUG, 0, 32, 64 },
    /* DR1        */ { ZYDIS_REGCLASS_DEBUG, 1, 32, 64 },
    /* DR2        */ { ZYDIS_REGCLASS_DEBUG, 2, 32, 64 },
    /* DR3        */ { ZYDIS_REGCLASS_DEBUG, 3, 32, 64 },
    /* DR4        */ { ZYDIS_REGCLASS_DEBUG, 4, 32, 64 },
    /* DR5        */ { ZYDIS_REGCLASS_DEBUG, 5, 32, 64 },
    /* DR6        */ { ZYDIS_REGCLASS_DEBUG, 6, 32, 64 },
    /* DR7        */ { ZYDIS_REGCLASS_DEBUG, 7, 32, 64 },
    /* DR8        */ { ZYDIS_REGCLASS_DEBUG, 8, 32, 64 },
    /* DR9        */ { ZYDIS_REGCLASS_DEBUG, 9, 32, 64 },
    /* DR10       */ { ZYDIS_REGCLASS_DEBUG, 10, 32, 64 },
    /* DR11       */ { ZYDIS_REGCLASS_DEBUG, 11, 32, 64 },
    /* DR12       */ { ZYDIS_REGCLASS_DEBUG, 12, 32, 64 },
    /* DR13       */ { ZYDIS_REGCLASS_DEBUG, 13, 32, 64 },
    /* DR14       */ { ZYDIS_REGCLASS_DEBUG, 14, 32, 64 },
    /* DR15       */ { ZYDIS_REGCLASS_DEBUG, 15, 32, 64 },
    /* K0         */ { ZYDIS_REGCLASS_MASK, 0, 64, 64 },
    /* K1         */ { ZYDIS_REGCLASS_MASK, 1, 64, 64 },
    /* K2         */ { ZYDIS_REGCLASS_MASK, 2, 64, 64 },
    /* K3         */ { ZYDIS_REGCLASS_MASK, 3, 64, 64 },
    /* K4         */ { ZYDIS_REGCLASS_MASK, 4, 64, 64 },
    /* K5         */ { ZYDIS_REGCLASS_MASK, 5, 64, 64 },
    /* K6         */ { ZYDIS_REGCLASS_MASK, 6, 64, 64 },
    /* K7         */ { ZYDIS_REGCLASS_MASK, 7, 64, 64 },
    /* BND0       */ { ZYDIS_REGCLASS_BOUND, 0, 128, 128 },
    /* BND1       */ { ZYDIS_REGCLASS_BOUND, 1, 128, 128 },
    /* BND2       */ { ZYDIS_REGCLASS_BOUND, 2, 128, 128 },
    /* BND3       */ { ZYDIS_REGCLASS_BOUND, 3, 128, 128 },
    /* BNDCFG     */ { ZYDIS_REGCLASS_INVALID, -1, 64, 64 },
    /* BNDSTATUS  */ { ZYDIS_REGCLASS_INVALID, -1, 64, 64 },
    /* MXCSR      */ { ZYDIS_REGCLASS_INVALID, -1, 32, 32 },
    /* PKRU       */ { ZYDIS_REGCLASS_INVALID, -1, 32, 32 },
    /* XCR0       */ { ZYDIS_REGCLASS_INVALID, -1, 64, 64 },
    /* UIF        */ { ZYDIS_REGCLASS_INVALID, -1, 1, 1 }
};

/**
 * Defines the `ZydisRegisterClassLookupItem` struct.
 */
typedef struct ZydisRegisterClassLookupItem_
{
    /**
     * The lowest register of the current class.
     */
    ZydisRegister lo;
    /**
     * The highest register of the current class.
     */
    ZydisRegister hi;
    /**
     * The width of registers of the current class in 16- and 32-bit mode.
     */
    ZydisRegisterWidth width;
    /**
     * The width of registers of the current class in 64-bit mode.
     */
    ZydisRegisterWidth width64;
} ZydisRegisterClassLookupItem;


//
// Header: Generated/RegisterClassLookup.inc
//

static const ZydisRegisterClassLookupItem REG_CLASS_LOOKUP[] =
{
    /* INVALID */ { ZYDIS_REGISTER_NONE, ZYDIS_REGISTER_NONE, 0, 0 },
    /* GPR8    */ { ZYDIS_REGISTER_AL, ZYDIS_REGISTER_R15B, 8, 8 },
    /* GPR16   */ { ZYDIS_REGISTER_AX, ZYDIS_REGISTER_R15W, 16, 16 },
    /* GPR32   */ { ZYDIS_REGISTER_EAX, ZYDIS_REGISTER_R15D, 32, 32 },
    /* GPR64   */ { ZYDIS_REGISTER_RAX, ZYDIS_REGISTER_R15, 0, 64 },
    /* X87     */ { ZYDIS_REGISTER_ST0, ZYDIS_REGISTER_ST7, 80, 80 },
    /* MMX     */ { ZYDIS_REGISTER_MM0, ZYDIS_REGISTER_MM7, 64, 64 },
    /* XMM     */ { ZYDIS_REGISTER_XMM0, ZYDIS_REGISTER_XMM31, 128, 128 },
    /* YMM     */ { ZYDIS_REGISTER_YMM0, ZYDIS_REGISTER_YMM31, 256, 256 },
    /* ZMM     */ { ZYDIS_REGISTER_ZMM0, ZYDIS_REGISTER_ZMM31, 512, 512 },
    /* TMM     */ { ZYDIS_REGISTER_TMM0, ZYDIS_REGISTER_TMM7, 8192, 8192 },
    /* FLAGS   */ { ZYDIS_REGISTER_NONE, ZYDIS_REGISTER_NONE, 0, 0 },
    /* IP      */ { ZYDIS_REGISTER_NONE, ZYDIS_REGISTER_NONE, 0, 0 },
    /* SEGMENT */ { ZYDIS_REGISTER_ES, ZYDIS_REGISTER_GS, 16, 16 },
    /* TABLE   */ { ZYDIS_REGISTER_NONE, ZYDIS_REGISTER_NONE, 0, 0 },
    /* TEST    */ { ZYDIS_REGISTER_TR0, ZYDIS_REGISTER_TR7, 32, 32 },
    /* CONTROL */ { ZYDIS_REGISTER_CR0, ZYDIS_REGISTER_CR15, 32, 64 },
    /* DEBUG   */ { ZYDIS_REGISTER_DR0, ZYDIS_REGISTER_DR15, 32, 64 },
    /* MASK    */ { ZYDIS_REGISTER_K0, ZYDIS_REGISTER_K7, 64, 64 },
    /* BOUND   */ { ZYDIS_REGISTER_BND0, ZYDIS_REGISTER_BND3, 128, 128 }
};

/* ============================================================================================== */
/* Exported functions                                                                             */
/* ============================================================================================== */

/* ---------------------------------------------------------------------------------------------- */
/* Register                                                                                       */
/* ---------------------------------------------------------------------------------------------- */

ZydisRegister ZydisRegisterEncode(ZydisRegisterClass register_class, ZyanU8 id)
{
    if ((register_class == ZYDIS_REGCLASS_INVALID) ||
        (register_class == ZYDIS_REGCLASS_FLAGS) ||
        (register_class == ZYDIS_REGCLASS_IP))
    {
        return ZYDIS_REGISTER_NONE;
    }

    if ((ZyanUSize)register_class >= ZYAN_ARRAY_LENGTH(REG_CLASS_LOOKUP))
    {
        return ZYDIS_REGISTER_NONE;
    }

    const ZydisRegisterClassLookupItem* item = &REG_CLASS_LOOKUP[register_class];
    if (id <= (item->hi - item->lo))
    {
        return item->lo + id;
    }

    return ZYDIS_REGISTER_NONE;
}

ZyanI8 ZydisRegisterGetId(ZydisRegister reg)
{
    if ((ZyanUSize)reg >= ZYAN_ARRAY_LENGTH(REG_LOOKUP))
    {
        return -1;
    }

    return REG_LOOKUP[reg].id;
}

ZydisRegisterClass ZydisRegisterGetClass(ZydisRegister reg)
{
    if ((ZyanUSize)reg >= ZYAN_ARRAY_LENGTH(REG_LOOKUP))
    {
        return ZYDIS_REGCLASS_INVALID;
    }

    return REG_LOOKUP[reg].class;
}

ZydisRegisterWidth ZydisRegisterGetWidth(ZydisMachineMode mode, ZydisRegister reg)
{
    if ((ZyanUSize)reg >= ZYAN_ARRAY_LENGTH(REG_LOOKUP))
    {
        return 0;
    }

    return (mode == ZYDIS_MACHINE_MODE_LONG_64)
        ? REG_LOOKUP[reg].width64
        : REG_LOOKUP[reg].width;
}

ZydisRegister ZydisRegisterGetLargestEnclosing(ZydisMachineMode mode, ZydisRegister reg)
{
    if ((ZyanUSize)reg >= ZYAN_ARRAY_LENGTH(REG_LOOKUP))
    {
        return ZYDIS_REGISTER_NONE;
    }

    if (mode > ZYDIS_MACHINE_MODE_MAX_VALUE)
    {
        return ZYDIS_REGISTER_NONE;
    }

    const ZydisRegisterClass reg_class = REG_LOOKUP[reg].class;

    if ((reg_class == ZYDIS_REGCLASS_INVALID) ||
        ((reg_class == ZYDIS_REGCLASS_GPR64) && (mode != ZYDIS_MACHINE_MODE_LONG_64)))
    {
        return ZYDIS_REGISTER_NONE;
    }

    static const ZydisRegister STATIC_MAPPING[ZYDIS_REGCLASS_MAX_VALUE + 1][3] =
    {
                                 /* 16              */ /* 32               */ /* 64                  */
        [ZYDIS_REGCLASS_FLAGS] = { ZYDIS_REGISTER_FLAGS, ZYDIS_REGISTER_EFLAGS, ZYDIS_REGISTER_RFLAGS },
        [ZYDIS_REGCLASS_IP   ] = { ZYDIS_REGISTER_IP   , ZYDIS_REGISTER_EIP   , ZYDIS_REGISTER_RIP    },
    };
    ZYAN_ASSERT(reg_class < ZYAN_ARRAY_LENGTH(STATIC_MAPPING));

    ZyanU8 mode_bits;
    switch (mode)
    {
    case ZYDIS_MACHINE_MODE_LONG_64:
        mode_bits = 2;
        break;
    case ZYDIS_MACHINE_MODE_LONG_COMPAT_32:
    case ZYDIS_MACHINE_MODE_LEGACY_32:
        mode_bits = 1;
        break;
    case ZYDIS_MACHINE_MODE_LONG_COMPAT_16:
    case ZYDIS_MACHINE_MODE_LEGACY_16:
    case ZYDIS_MACHINE_MODE_REAL_16:
        mode_bits = 0;
        break;
    default:
        ZYAN_UNREACHABLE;
    }

    const ZydisRegister static_reg = STATIC_MAPPING[reg_class][mode_bits];
    if (static_reg != ZYDIS_REGISTER_NONE)
    {
        return static_reg;
    }

    static const ZyanU8 GPR8_MAPPING[20] =
    {
        /* AL   */  0,
        /* CL   */  1,
        /* DL   */  2,
        /* BL   */  3,
        /* AH   */  0,
        /* CH   */  1,
        /* DH   */  2,
        /* BH   */  3,
        /* SPL  */  4,
        /* BPL  */  5,
        /* SIL  */  6,
        /* DIL  */  7,
        /* R8B  */  8,
        /* R9B  */  9,
        /* R10B */ 10,
        /* R11B */ 11,
        /* R12B */ 12,
        /* R13B */ 13,
        /* R14B */ 14,
        /* R15B */ 15
    };

    ZyanU8 reg_id = REG_LOOKUP[reg].id;
    switch (reg_class)
    {
    case ZYDIS_REGCLASS_GPR8:
        reg_id = GPR8_MAPPING[reg_id];
        ZYAN_FALLTHROUGH;
    case ZYDIS_REGCLASS_GPR16:
    case ZYDIS_REGCLASS_GPR32:
    case ZYDIS_REGCLASS_GPR64:
        switch (mode_bits)
        {
        case 2:
            return REG_CLASS_LOOKUP[ZYDIS_REGCLASS_GPR64].lo + reg_id;
        case 1:
            return REG_CLASS_LOOKUP[ZYDIS_REGCLASS_GPR32].lo + reg_id;
        case 0:
            return REG_CLASS_LOOKUP[ZYDIS_REGCLASS_GPR16].lo + reg_id;
        default:
            ZYAN_UNREACHABLE;
        }
    case ZYDIS_REGCLASS_XMM:
    case ZYDIS_REGCLASS_YMM:
    case ZYDIS_REGCLASS_ZMM:
#if defined(ZYDIS_DISABLE_AVX512) && defined(ZYDIS_DISABLE_KNC)
        return REG_CLASS_LOOKUP[ZYDIS_REGCLASS_YMM].lo + reg_id;
#else
        return REG_CLASS_LOOKUP[ZYDIS_REGCLASS_ZMM].lo + reg_id;
#endif
    default:
        return ZYDIS_REGISTER_NONE;
    }
}

const char* ZydisRegisterGetString(ZydisRegister reg)
{
    if ((ZyanUSize)reg >= ZYAN_ARRAY_LENGTH(STR_REGISTERS))
    {
        return ZYAN_NULL;
    }

    return STR_REGISTERS[reg].data;
}

const ZydisShortString* ZydisRegisterGetStringWrapped(ZydisRegister reg)
{
    if ((ZyanUSize)reg >= ZYAN_ARRAY_LENGTH(STR_REGISTERS))
    {
        return ZYAN_NULL;
    }

    return &STR_REGISTERS[reg];
}

/* ---------------------------------------------------------------------------------------------- */
/* Register class                                                                                 */
/* ---------------------------------------------------------------------------------------------- */

ZydisRegisterWidth ZydisRegisterClassGetWidth(ZydisMachineMode mode,
    ZydisRegisterClass register_class)
{
    if ((ZyanUSize)register_class >= ZYAN_ARRAY_LENGTH(REG_CLASS_LOOKUP))
    {
        return 0;
    }

    return (mode == ZYDIS_MACHINE_MODE_LONG_64)
        ? REG_CLASS_LOOKUP[register_class].width64
        : REG_CLASS_LOOKUP[register_class].width;
}

/* ---------------------------------------------------------------------------------------------- */

/* ============================================================================================== */

//
// Source file: /home/ath/devel/zydis/src/Segment.c
//

/***************************************************************************************************

  Zyan Disassembler Library (Zydis)

  Original Author : Florian Bernd

 * Permission is hereby granted, free of charge, to any person obtaining a copy
 * of this software and associated documentation files (the "Software"), to deal
 * in the Software without restriction, including without limitation the rights
 * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
 * copies of the Software, and to permit persons to whom the Software is
 * furnished to do so, subject to the following conditions:
 *
 * The above copyright notice and this permission notice shall be included in all
 * copies or substantial portions of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
 * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
 * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
 * SOFTWARE.

***************************************************************************************************/


/* ============================================================================================== */
/* Exported functions                                                                             */
/* ============================================================================================== */

ZyanStatus ZydisGetInstructionSegments(const ZydisDecodedInstruction* instruction,
    ZydisInstructionSegments* segments)
{
    if (!instruction || !segments)
    {
        return ZYAN_STATUS_INVALID_ARGUMENT;
    }

    ZYAN_MEMSET(segments, 0, sizeof(*segments));

    // Legacy prefixes and `REX`
    if (instruction->raw.prefix_count)
    {
        const ZyanU8 rex_offset = (instruction->attributes & ZYDIS_ATTRIB_HAS_REX) ? 1 : 0;
        if (!rex_offset || (instruction->raw.prefix_count > 1))
        {
            segments->segments[segments->count  ].type   = ZYDIS_INSTR_SEGMENT_PREFIXES;
            segments->segments[segments->count  ].offset = 0;
            segments->segments[segments->count++].size   =
                instruction->raw.prefix_count - rex_offset;
        }
        if (rex_offset)
        {
            segments->segments[segments->count  ].type   = ZYDIS_INSTR_SEGMENT_REX;
            segments->segments[segments->count  ].offset =
                instruction->raw.prefix_count - rex_offset;
            segments->segments[segments->count++].size   = 1;
        }
    }

    // Encoding prefixes
    ZydisInstructionSegment segment_type = ZYDIS_INSTR_SEGMENT_NONE;
    ZyanU8 segment_offset = 0;
    ZyanU8 segment_size = 0;
    switch (instruction->encoding)
    {
    case ZYDIS_INSTRUCTION_ENCODING_XOP:
        segment_type = ZYDIS_INSTR_SEGMENT_XOP;
        segment_offset = instruction->raw.xop.offset;
        segment_size = 3;
        break;
    case ZYDIS_INSTRUCTION_ENCODING_VEX:
        segment_type = ZYDIS_INSTR_SEGMENT_VEX;
        segment_offset = instruction->raw.vex.offset;
        segment_size = instruction->raw.vex.size;
        break;
    case ZYDIS_INSTRUCTION_ENCODING_EVEX:
        segment_type = ZYDIS_INSTR_SEGMENT_EVEX;
        segment_offset = instruction->raw.evex.offset;
        segment_size = 4;
        break;
    case ZYDIS_INSTRUCTION_ENCODING_MVEX:
        segment_type = ZYDIS_INSTR_SEGMENT_MVEX;
        segment_offset = instruction->raw.mvex.offset;
        segment_size = 4;
        break;
    default:
        break;
    }
    if (segment_type)
    {
        segments->segments[segments->count  ].type   = segment_type;
        segments->segments[segments->count  ].offset = segment_offset;
        segments->segments[segments->count++].size   = segment_size;
    }

    // Opcode
    segment_size = 1;
    if ((instruction->encoding == ZYDIS_INSTRUCTION_ENCODING_LEGACY) ||
        (instruction->encoding == ZYDIS_INSTRUCTION_ENCODING_3DNOW))
    {
        switch (instruction->opcode_map)
        {
        case ZYDIS_OPCODE_MAP_DEFAULT:
            break;
        case ZYDIS_OPCODE_MAP_0F:
            ZYAN_FALLTHROUGH;
        case ZYDIS_OPCODE_MAP_0F0F:
            segment_size = 2;
            break;
        case ZYDIS_OPCODE_MAP_0F38:
            ZYAN_FALLTHROUGH;
        case ZYDIS_OPCODE_MAP_0F3A:
            segment_size = 3;
            break;
        default:
        ZYAN_UNREACHABLE;
        }
    }
    segments->segments[segments->count  ].type = ZYDIS_INSTR_SEGMENT_OPCODE;
    if (segments->count)
    {
        segments->segments[segments->count].offset =
                segments->segments[segments->count - 1].offset +
                segments->segments[segments->count - 1].size;
    } else
    {
        segments->segments[segments->count].offset = 0;
    }
    segments->segments[segments->count++].size = segment_size;

    // ModRM
    if (instruction->attributes & ZYDIS_ATTRIB_HAS_MODRM)
    {
        segments->segments[segments->count  ].type = ZYDIS_INSTR_SEGMENT_MODRM;
        segments->segments[segments->count  ].offset = instruction->raw.modrm.offset;
        segments->segments[segments->count++].size = 1;
    }

    // SIB
    if (instruction->attributes & ZYDIS_ATTRIB_HAS_SIB)
    {
        segments->segments[segments->count  ].type = ZYDIS_INSTR_SEGMENT_SIB;
        segments->segments[segments->count  ].offset = instruction->raw.sib.offset;
        segments->segments[segments->count++].size = 1;
    }

    // Displacement
    if (instruction->raw.disp.size)
    {
        segments->segments[segments->count  ].type = ZYDIS_INSTR_SEGMENT_DISPLACEMENT;
        segments->segments[segments->count  ].offset = instruction->raw.disp.offset;
        segments->segments[segments->count++].size = instruction->raw.disp.size / 8;
    }

    // Immediates
    for (ZyanU8 i = 0; i < 2; ++i)
    {
        if (instruction->raw.imm[i].size)
        {
            segments->segments[segments->count  ].type = ZYDIS_INSTR_SEGMENT_IMMEDIATE;
            segments->segments[segments->count  ].offset = instruction->raw.imm[i].offset;
            segments->segments[segments->count++].size = instruction->raw.imm[i].size / 8;
        }
    }

    if (instruction->encoding == ZYDIS_INSTRUCTION_ENCODING_3DNOW)
    {
        segments->segments[segments->count].type = ZYDIS_INSTR_SEGMENT_OPCODE;
        segments->segments[segments->count].offset = instruction->length -1;
        segments->segments[segments->count++].size = 1;
    }

    return ZYAN_STATUS_SUCCESS;
}

/* ---------------------------------------------------------------------------------------------- */

/* ============================================================================================== */

//
// Source file: /home/ath/devel/zydis/src/SharedData.c
//

/***************************************************************************************************

  Zyan Disassembler Library (Zydis)

  Original Author : Florian Bernd

 * Permission is hereby granted, free of charge, to any person obtaining a copy
 * of this software and associated documentation files (the "Software"), to deal
 * in the Software without restriction, including without limitation the rights
 * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
 * copies of the Software, and to permit persons to whom the Software is
 * furnished to do so, subject to the following conditions:
 *
 * The above copyright notice and this permission notice shall be included in all
 * copies or substantial portions of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
 * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
 * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
 * SOFTWARE.

***************************************************************************************************/


/* ============================================================================================== */
/* Data tables                                                                                    */
/* ============================================================================================== */

/* ---------------------------------------------------------------------------------------------- */
/* Instruction definitions                                                                        */
/* ---------------------------------------------------------------------------------------------- */

#ifdef ZYDIS_MINIMAL_MODE
#   define ZYDIS_NOTMIN(x)
#else
#   define ZYDIS_NOTMIN(x) , x
#endif


//
// Header: Generated/InstructionDefinitions.inc
//

const ZydisInstructionDefinitionLEGACY ISTR_DEFINITIONS_LEGACY[] =
{
    { ZYDIS_MNEMONIC_AAA ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0) ZYDIS_NOTMIN(0xD38), 0, 0 ZYDIS_NOTMIN(0x39), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DECIMAL) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I86) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, 0 ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_AAD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(1) ZYDIS_NOTMIN(0x52C), 0, 0 ZYDIS_NOTMIN(0x46), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DECIMAL) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I86) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, 0 ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_AADD ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1AE5), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_LEGACY) ZYDIS_NOTMIN(ZYDIS_ISA_SET_RAO_INT) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_RAO_INT) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_GPR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_AADD ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1AE7), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_LEGACY) ZYDIS_NOTMIN(ZYDIS_ISA_SET_RAO_INT) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_RAO_INT) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_GPR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_AAM ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(1) ZYDIS_NOTMIN(0x530), 0, 0 ZYDIS_NOTMIN(0x46), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DECIMAL) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I86) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, 0 ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_AAND ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1AE5), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_LEGACY) ZYDIS_NOTMIN(ZYDIS_ISA_SET_RAO_INT) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_RAO_INT) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_GPR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_AAND ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1AE7), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_LEGACY) ZYDIS_NOTMIN(ZYDIS_ISA_SET_RAO_INT) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_RAO_INT) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_GPR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_AAS ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0) ZYDIS_NOTMIN(0xD38), 0, 0 ZYDIS_NOTMIN(0x39), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DECIMAL) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I86) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, 0 ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_ADC ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xD3B), 1, 0 ZYDIS_NOTMIN(0x24), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_BINARY) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I86) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_GPR, ZYDIS_REGKIND_GPR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_ADC ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xD3E), 1, 0 ZYDIS_NOTMIN(0x24), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_BINARY) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I86) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_GPR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_TRUE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_ADC ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xD41), 0, 0 ZYDIS_NOTMIN(0x24), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_BINARY) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I86) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_GPR, ZYDIS_REGKIND_GPR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_ADC ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xD44), 0, 0 ZYDIS_NOTMIN(0x24), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_BINARY) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I86) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_GPR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_TRUE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_ADC ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xD47), 1, 0 ZYDIS_NOTMIN(0x24), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_BINARY) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I86) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_GPR, ZYDIS_REGKIND_GPR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_ADC ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xD4A), 1, 0 ZYDIS_NOTMIN(0x24), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_BINARY) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I86) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_GPR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_ADC ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xD4D), 0, 0 ZYDIS_NOTMIN(0x24), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_BINARY) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I86) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_GPR, ZYDIS_REGKIND_GPR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_ADC ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xD50), 0, 0 ZYDIS_NOTMIN(0x24), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_BINARY) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I86) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_GPR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_ADC ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xD53), 1, 0 ZYDIS_NOTMIN(0x24), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_BINARY) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I86) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, 0 ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_ADC ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xD56), 0, 0 ZYDIS_NOTMIN(0x24), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_BINARY) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I86) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, 0 ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_ADC ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xD59), 1, 0 ZYDIS_NOTMIN(0x24), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_BINARY) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I86) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, ZYDIS_REGKIND_GPR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_ADC ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xD5C), 1, 0 ZYDIS_NOTMIN(0x24), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_BINARY) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I86) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_TRUE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_ADC ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xD5F), 0, 0 ZYDIS_NOTMIN(0x24), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_BINARY) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I86) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, ZYDIS_REGKIND_GPR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_ADC ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xD62), 0, 0 ZYDIS_NOTMIN(0x24), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_BINARY) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I86) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_TRUE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_ADC ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xD59), 1, 0 ZYDIS_NOTMIN(0x24), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_BINARY) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I86) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, ZYDIS_REGKIND_GPR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_ADC ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xD5C), 1, 0 ZYDIS_NOTMIN(0x24), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_BINARY) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I86) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_TRUE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_ADC ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xD65), 0, 0 ZYDIS_NOTMIN(0x24), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_BINARY) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I86) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, ZYDIS_REGKIND_GPR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_ADC ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xD68), 0, 0 ZYDIS_NOTMIN(0x24), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_BINARY) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I86) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_TRUE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_ADCX ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xD6B), 6, 0 ZYDIS_NOTMIN(0x21), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_ADOX_ADCX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_ADOX_ADCX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_ADOX_ADCX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_GPR, ZYDIS_REGKIND_GPR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_ADCX ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xD6E), 6, 0 ZYDIS_NOTMIN(0x21), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_ADOX_ADCX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_ADOX_ADCX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_ADOX_ADCX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_GPR, ZYDIS_REGKIND_GPR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_ADCX ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xD71), 6, 0 ZYDIS_NOTMIN(0x21), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_ADOX_ADCX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_ADOX_ADCX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_ADOX_ADCX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_GPR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_ADCX ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xD74), 6, 0 ZYDIS_NOTMIN(0x21), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_ADOX_ADCX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_ADOX_ADCX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_ADOX_ADCX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_GPR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_ADD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xD77), 1, 0 ZYDIS_NOTMIN(0x2B), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_BINARY) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I86) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_GPR, ZYDIS_REGKIND_GPR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_ADD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xD7A), 1, 0 ZYDIS_NOTMIN(0x2B), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_BINARY) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I86) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_GPR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_TRUE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_ADD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xD7D), 0, 0 ZYDIS_NOTMIN(0x2B), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_BINARY) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I86) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_GPR, ZYDIS_REGKIND_GPR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_ADD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xD80), 0, 0 ZYDIS_NOTMIN(0x2B), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_BINARY) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I86) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_GPR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_TRUE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_ADD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xD83), 1, 0 ZYDIS_NOTMIN(0x2B), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_BINARY) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I86) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_GPR, ZYDIS_REGKIND_GPR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_ADD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xD86), 1, 0 ZYDIS_NOTMIN(0x2B), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_BINARY) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I86) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_GPR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_ADD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xD89), 0, 0 ZYDIS_NOTMIN(0x2B), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_BINARY) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I86) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_GPR, ZYDIS_REGKIND_GPR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_ADD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xD8C), 0, 0 ZYDIS_NOTMIN(0x2B), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_BINARY) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I86) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_GPR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_ADD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xD8F), 1, 0 ZYDIS_NOTMIN(0x2B), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_BINARY) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I86) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, 0 ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_ADD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xD92), 0, 0 ZYDIS_NOTMIN(0x2B), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_BINARY) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I86) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, 0 ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_ADD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xD95), 1, 0 ZYDIS_NOTMIN(0x2B), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_BINARY) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I86) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, ZYDIS_REGKIND_GPR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_ADD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xD98), 1, 0 ZYDIS_NOTMIN(0x2B), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_BINARY) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I86) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_TRUE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_ADD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xD9B), 0, 0 ZYDIS_NOTMIN(0x2B), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_BINARY) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I86) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, ZYDIS_REGKIND_GPR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_ADD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xD9E), 0, 0 ZYDIS_NOTMIN(0x2B), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_BINARY) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I86) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_TRUE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_ADD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xD95), 1, 0 ZYDIS_NOTMIN(0x2B), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_BINARY) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I86) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, ZYDIS_REGKIND_GPR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_ADD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xD98), 1, 0 ZYDIS_NOTMIN(0x2B), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_BINARY) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I86) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_TRUE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_ADD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xDA1), 0, 0 ZYDIS_NOTMIN(0x2B), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_BINARY) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I86) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, ZYDIS_REGKIND_GPR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_ADD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xDA4), 0, 0 ZYDIS_NOTMIN(0x2B), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_BINARY) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I86) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_TRUE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_ADDPD ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xDB9), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_SSE) ZYDIS_NOTMIN(ZYDIS_ISA_SET_SSE2) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_SSE2) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_SSE2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_ADDPD ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xDBC), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_SSE) ZYDIS_NOTMIN(ZYDIS_ISA_SET_SSE2) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_SSE2) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_SSE2), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_ADDPS ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xDBF), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_SSE) ZYDIS_NOTMIN(ZYDIS_ISA_SET_SSE) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_SSE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_SSE2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_ADDPS ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xDC2), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_SSE) ZYDIS_NOTMIN(ZYDIS_ISA_SET_SSE) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_SSE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_SSE2), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_ADDSD ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xE1F), 2, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_SSE) ZYDIS_NOTMIN(ZYDIS_ISA_SET_SSE2) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_SSE2) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_SSE3), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_ADDSD ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xE22), 2, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_SSE) ZYDIS_NOTMIN(ZYDIS_ISA_SET_SSE2) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_SSE2) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_SSE3), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_ADDSS ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xE28), 2, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_SSE) ZYDIS_NOTMIN(ZYDIS_ISA_SET_SSE) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_SSE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_SSE3), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_ADDSS ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xE2B), 2, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_SSE) ZYDIS_NOTMIN(ZYDIS_ISA_SET_SSE) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_SSE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_SSE3), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_ADDSUBPD ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xDB9), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_SSE) ZYDIS_NOTMIN(ZYDIS_ISA_SET_SSE3) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_SSE3) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_SSE2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_ADDSUBPD ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xDBC), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_SSE) ZYDIS_NOTMIN(ZYDIS_ISA_SET_SSE3) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_SSE3) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_SSE2), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_ADDSUBPS ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xDBF), 2, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_SSE) ZYDIS_NOTMIN(ZYDIS_ISA_SET_SSE3) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_SSE3) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_SSE2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_ADDSUBPS ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xDC2), 2, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_SSE) ZYDIS_NOTMIN(ZYDIS_ISA_SET_SSE3) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_SSE3) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_SSE2), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_ADOX ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xD6B), 6, 0 ZYDIS_NOTMIN(0x9), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_ADOX_ADCX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_ADOX_ADCX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_ADOX_ADCX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_GPR, ZYDIS_REGKIND_GPR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_ADOX ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xD6E), 6, 0 ZYDIS_NOTMIN(0x9), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_ADOX_ADCX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_ADOX_ADCX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_ADOX_ADCX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_GPR, ZYDIS_REGKIND_GPR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_ADOX ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xD71), 6, 0 ZYDIS_NOTMIN(0x9), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_ADOX_ADCX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_ADOX_ADCX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_ADOX_ADCX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_GPR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_ADOX ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xD74), 6, 0 ZYDIS_NOTMIN(0x9), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_ADOX_ADCX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_ADOX_ADCX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_ADOX_ADCX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_GPR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_AESDEC ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xF60), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AES) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AES) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AES) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_SSE4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_AESDEC ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xF63), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AES) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AES) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AES) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_SSE4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_AESDEC128KL ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xDA7), 0, 0 ZYDIS_NOTMIN(0x41), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_KEYLOCKER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_KEYLOCKER) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_KEYLOCKER) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_AESDEC256KL ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xDAA), 0, 0 ZYDIS_NOTMIN(0x41), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_KEYLOCKER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_KEYLOCKER) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_KEYLOCKER) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_AESDECLAST ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xF60), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AES) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AES) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AES) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_SSE4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_AESDECLAST ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xF63), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AES) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AES) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AES) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_SSE4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_AESDECWIDE128KL ZYDIS_NOTMIN(10) ZYDIS_NOTMIN(1) ZYDIS_NOTMIN(0x0), 0, 0 ZYDIS_NOTMIN(0x41), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_KEYLOCKER_WIDE) ZYDIS_NOTMIN(ZYDIS_ISA_SET_KEYLOCKER_WIDE) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_KEYLOCKER_WIDE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_AESDECWIDE256KL ZYDIS_NOTMIN(10) ZYDIS_NOTMIN(1) ZYDIS_NOTMIN(0xA), 0, 0 ZYDIS_NOTMIN(0x41), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_KEYLOCKER_WIDE) ZYDIS_NOTMIN(ZYDIS_ISA_SET_KEYLOCKER_WIDE) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_KEYLOCKER_WIDE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_AESENC ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xF60), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AES) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AES) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AES) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_SSE4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_AESENC ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xF63), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AES) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AES) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AES) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_SSE4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_AESENC128KL ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xDA7), 0, 0 ZYDIS_NOTMIN(0x41), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_KEYLOCKER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_KEYLOCKER) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_KEYLOCKER) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_AESENC256KL ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xDAA), 0, 0 ZYDIS_NOTMIN(0x41), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_KEYLOCKER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_KEYLOCKER) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_KEYLOCKER) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_AESENCLAST ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xF60), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AES) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AES) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AES) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_SSE4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_AESENCLAST ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xF63), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AES) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AES) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AES) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_SSE4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_AESENCWIDE128KL ZYDIS_NOTMIN(10) ZYDIS_NOTMIN(1) ZYDIS_NOTMIN(0x0), 0, 0 ZYDIS_NOTMIN(0x41), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_KEYLOCKER_WIDE) ZYDIS_NOTMIN(ZYDIS_ISA_SET_KEYLOCKER_WIDE) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_KEYLOCKER_WIDE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_AESENCWIDE256KL ZYDIS_NOTMIN(10) ZYDIS_NOTMIN(1) ZYDIS_NOTMIN(0xA), 0, 0 ZYDIS_NOTMIN(0x41), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_KEYLOCKER_WIDE) ZYDIS_NOTMIN(ZYDIS_ISA_SET_KEYLOCKER_WIDE) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_KEYLOCKER_WIDE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_AESIMC ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xDAD), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AES) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AES) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AES) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_SSE4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_AESIMC ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xDB0), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AES) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AES) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AES) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_SSE4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_AESKEYGENASSIST ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0xDAD), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AES) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AES) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AES) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_SSE4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_AESKEYGENASSIST ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0xDB0), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AES) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AES) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AES) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_SSE4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_AND ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xD77), 1, 0 ZYDIS_NOTMIN(0x40), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_LOGICAL) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I86) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_GPR, ZYDIS_REGKIND_GPR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_AND ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xD7A), 1, 0 ZYDIS_NOTMIN(0x40), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_LOGICAL) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I86) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_GPR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_TRUE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_AND ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xD7D), 0, 0 ZYDIS_NOTMIN(0x40), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_LOGICAL) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I86) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_GPR, ZYDIS_REGKIND_GPR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_AND ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xD80), 0, 0 ZYDIS_NOTMIN(0x40), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_LOGICAL) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I86) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_GPR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_TRUE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_AND ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xD83), 1, 0 ZYDIS_NOTMIN(0x40), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_LOGICAL) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I86) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_GPR, ZYDIS_REGKIND_GPR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_AND ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xD86), 1, 0 ZYDIS_NOTMIN(0x40), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_LOGICAL) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I86) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_GPR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_AND ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xD89), 0, 0 ZYDIS_NOTMIN(0x40), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_LOGICAL) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I86) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_GPR, ZYDIS_REGKIND_GPR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_AND ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xD8C), 0, 0 ZYDIS_NOTMIN(0x40), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_LOGICAL) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I86) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_GPR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_AND ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xD8F), 1, 0 ZYDIS_NOTMIN(0x40), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_LOGICAL) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I86) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, 0 ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_AND ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xD92), 0, 0 ZYDIS_NOTMIN(0x40), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_LOGICAL) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I86) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, 0 ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_AND ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xD95), 1, 0 ZYDIS_NOTMIN(0x40), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_LOGICAL) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I86) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, ZYDIS_REGKIND_GPR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_AND ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xD98), 1, 0 ZYDIS_NOTMIN(0x40), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_LOGICAL) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I86) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_TRUE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_AND ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xD9B), 0, 0 ZYDIS_NOTMIN(0x40), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_LOGICAL) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I86) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, ZYDIS_REGKIND_GPR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_AND ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xD9E), 0, 0 ZYDIS_NOTMIN(0x40), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_LOGICAL) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I86) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_TRUE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_AND ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xD95), 1, 0 ZYDIS_NOTMIN(0x40), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_LOGICAL) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I86) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, ZYDIS_REGKIND_GPR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_AND ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xD98), 1, 0 ZYDIS_NOTMIN(0x40), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_LOGICAL) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I86) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_TRUE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_AND ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xDA1), 0, 0 ZYDIS_NOTMIN(0x40), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_LOGICAL) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I86) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, ZYDIS_REGKIND_GPR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_AND ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xDA4), 0, 0 ZYDIS_NOTMIN(0x40), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_LOGICAL) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I86) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_TRUE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_ANDNPD ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xDB9), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_LOGICAL_FP) ZYDIS_NOTMIN(ZYDIS_ISA_SET_SSE2) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_SSE2) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_SSE4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_ANDNPD ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xDBC), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_LOGICAL_FP) ZYDIS_NOTMIN(ZYDIS_ISA_SET_SSE2) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_SSE2) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_SSE4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_ANDNPS ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xDBF), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_LOGICAL_FP) ZYDIS_NOTMIN(ZYDIS_ISA_SET_SSE) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_SSE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_SSE4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_ANDNPS ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xDC2), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_LOGICAL_FP) ZYDIS_NOTMIN(ZYDIS_ISA_SET_SSE) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_SSE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_SSE4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_ANDPD ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xDB9), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_LOGICAL_FP) ZYDIS_NOTMIN(ZYDIS_ISA_SET_SSE2) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_SSE2) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_SSE4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_ANDPD ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xDBC), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_LOGICAL_FP) ZYDIS_NOTMIN(ZYDIS_ISA_SET_SSE2) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_SSE2) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_SSE4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_ANDPS ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xDBF), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_LOGICAL_FP) ZYDIS_NOTMIN(ZYDIS_ISA_SET_SSE) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_SSE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_SSE4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_ANDPS ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xDC2), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_LOGICAL_FP) ZYDIS_NOTMIN(ZYDIS_ISA_SET_SSE) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_SSE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_SSE4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_AOR ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1AE5), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_LEGACY) ZYDIS_NOTMIN(ZYDIS_ISA_SET_RAO_INT) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_RAO_INT) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_GPR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_AOR ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1AE7), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_LEGACY) ZYDIS_NOTMIN(ZYDIS_ISA_SET_RAO_INT) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_RAO_INT) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_GPR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_ARPL ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xDB3), 0, 0 ZYDIS_NOTMIN(0x17), ZYAN_TRUE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_SYSTEM) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I286PROTECTED) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_GPR, ZYDIS_REGKIND_GPR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_ARPL ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xDB6), 0, 0 ZYDIS_NOTMIN(0x17), ZYAN_TRUE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_SYSTEM) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I286PROTECTED) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_GPR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_AXOR ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1AE5), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_LEGACY) ZYDIS_NOTMIN(ZYDIS_ISA_SET_RAO_INT) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_RAO_INT) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_GPR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_AXOR ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1AE7), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_LEGACY) ZYDIS_NOTMIN(ZYDIS_ISA_SET_RAO_INT) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_RAO_INT) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_GPR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_BLENDPD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0xDB9), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_SSE) ZYDIS_NOTMIN(ZYDIS_ISA_SET_SSE4) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_SSE4) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_SSE4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_BLENDPD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0xDBC), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_SSE) ZYDIS_NOTMIN(ZYDIS_ISA_SET_SSE4) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_SSE4) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_SSE4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_BLENDPS ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0xDBF), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_SSE) ZYDIS_NOTMIN(ZYDIS_ISA_SET_SSE4) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_SSE4) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_SSE4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_BLENDPS ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0xDC2), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_SSE) ZYDIS_NOTMIN(ZYDIS_ISA_SET_SSE4) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_SSE4) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_SSE4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_BLENDVPD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xDC5), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_SSE) ZYDIS_NOTMIN(ZYDIS_ISA_SET_SSE4) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_SSE4) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_SSE4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_BLENDVPD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xDC8), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_SSE) ZYDIS_NOTMIN(ZYDIS_ISA_SET_SSE4) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_SSE4) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_SSE4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_BLENDVPS ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xDCB), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_SSE) ZYDIS_NOTMIN(ZYDIS_ISA_SET_SSE4) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_SSE4) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_SSE4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_BLENDVPS ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xDCE), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_SSE) ZYDIS_NOTMIN(ZYDIS_ISA_SET_SSE4) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_SSE4) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_SSE4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_BNDCL ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1AE9), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_MPX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_MPX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_MPX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_BOUND, ZYDIS_REGKIND_GPR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_BNDCL ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1AEB), 0, 1 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_MPX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_MPX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_MPX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_BOUND, ZYDIS_MEMOP_TYPE_AGEN ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_BNDCL ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1AED), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_MPX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_MPX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_MPX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_BOUND, ZYDIS_REGKIND_GPR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_BNDCL ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1AEB), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_MPX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_MPX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_MPX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_BOUND, ZYDIS_MEMOP_TYPE_AGEN ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_BNDCN ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1AE9), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_MPX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_MPX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_MPX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_BOUND, ZYDIS_REGKIND_GPR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_BNDCN ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1AEB), 0, 1 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_MPX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_MPX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_MPX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_BOUND, ZYDIS_MEMOP_TYPE_AGEN ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_BNDCN ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1AED), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_MPX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_MPX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_MPX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_BOUND, ZYDIS_REGKIND_GPR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_BNDCN ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1AEB), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_MPX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_MPX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_MPX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_BOUND, ZYDIS_MEMOP_TYPE_AGEN ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_BNDCU ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1AE9), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_MPX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_MPX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_MPX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_BOUND, ZYDIS_REGKIND_GPR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_BNDCU ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1AEB), 0, 1 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_MPX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_MPX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_MPX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_BOUND, ZYDIS_MEMOP_TYPE_AGEN ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_BNDCU ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1AED), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_MPX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_MPX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_MPX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_BOUND, ZYDIS_REGKIND_GPR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_BNDCU ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1AEB), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_MPX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_MPX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_MPX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_BOUND, ZYDIS_MEMOP_TYPE_AGEN ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_BNDLDX ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1AEF), 0, 1 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_MPX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_MPX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_MPX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_BOUND, ZYDIS_MEMOP_TYPE_MIB | (1 << 3) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_BNDLDX ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1AF1), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_MPX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_MPX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_MPX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_BOUND, ZYDIS_MEMOP_TYPE_MIB | (1 << 3) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_BNDMK ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1AF3), 0, 1 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_MPX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_MPX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_MPX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_BOUND, ZYDIS_MEMOP_TYPE_AGEN | (1 << 3) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_BNDMK ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1AF3), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_MPX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_MPX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_MPX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_BOUND, ZYDIS_MEMOP_TYPE_AGEN | (1 << 3) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_BNDMOV ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1AF5), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_MPX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_MPX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_MPX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_BOUND, ZYDIS_REGKIND_BOUND ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_BNDMOV ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1AF7), 0, 1 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_MPX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_MPX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_MPX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_BOUND, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_BNDMOV ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1AF9), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_MPX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_MPX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_MPX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_BOUND, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_BNDMOV ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1AFB), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_MPX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_MPX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_MPX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_BOUND, ZYDIS_REGKIND_BOUND ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_BNDMOV ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1AFD), 0, 1 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_MPX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_MPX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_MPX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_BOUND, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_BNDMOV ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1AFF), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_MPX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_MPX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_MPX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_BOUND, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_BNDSTX ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1B01), 0, 1 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_MPX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_MPX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_MPX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_BOUND, ZYDIS_MEMOP_TYPE_MIB | (1 << 3) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_BNDSTX ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1B03), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_MPX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_MPX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_MPX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_BOUND, ZYDIS_MEMOP_TYPE_MIB | (1 << 3) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_BOUND ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1B05), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_INTERRUPT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I186) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_GPR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_BOUND ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1B07), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_INTERRUPT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I186) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_GPR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_BSF ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xDD1), 0, 0 ZYDIS_NOTMIN(0x47), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_BITBYTE) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I386) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_GPR, ZYDIS_REGKIND_GPR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_BSF ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xDD4), 0, 0 ZYDIS_NOTMIN(0x47), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_BITBYTE) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I386) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_GPR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_BSF ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xDD1), 0, 0 ZYDIS_NOTMIN(0x47), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_BITBYTE) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I386) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_GPR, ZYDIS_REGKIND_GPR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_BSF ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xDD4), 0, 0 ZYDIS_NOTMIN(0x47), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_BITBYTE) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I386) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_GPR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_BSR ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xDD1), 0, 0 ZYDIS_NOTMIN(0x47), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_BITBYTE) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I386) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_GPR, ZYDIS_REGKIND_GPR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_BSR ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xDD4), 0, 0 ZYDIS_NOTMIN(0x47), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_BITBYTE) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I386) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_GPR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_BSR ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xDD1), 0, 0 ZYDIS_NOTMIN(0x47), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_BITBYTE) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I386) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_GPR, ZYDIS_REGKIND_GPR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_BSR ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xDD4), 0, 0 ZYDIS_NOTMIN(0x47), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_BITBYTE) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I386) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_GPR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_BSWAP ZYDIS_NOTMIN(1) ZYDIS_NOTMIN(1) ZYDIS_NOTMIN(0x1B71), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I486REAL) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, 0 ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_BT ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xDD7), 0, 0 ZYDIS_NOTMIN(0x3A), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_BITBYTE) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I386) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_GPR, ZYDIS_REGKIND_GPR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_BT ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xDDA), 0, 0 ZYDIS_NOTMIN(0x3A), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_BITBYTE) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I386) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_GPR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_BT ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xDDD), 0, 0 ZYDIS_NOTMIN(0x3A), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_BITBYTE) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I386) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, ZYDIS_REGKIND_GPR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_BT ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xDE0), 0, 0 ZYDIS_NOTMIN(0x3A), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_BITBYTE) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I386) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_BTC ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xDE3), 0, 0 ZYDIS_NOTMIN(0x3A), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_BITBYTE) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I386) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, ZYDIS_REGKIND_GPR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_BTC ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xDE6), 0, 0 ZYDIS_NOTMIN(0x3A), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_BITBYTE) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I386) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_TRUE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_BTC ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xD7D), 0, 0 ZYDIS_NOTMIN(0x3A), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_BITBYTE) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I386) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_GPR, ZYDIS_REGKIND_GPR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_BTC ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xD80), 0, 0 ZYDIS_NOTMIN(0x3A), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_BITBYTE) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I386) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_GPR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_TRUE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_BTR ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xD7D), 0, 0 ZYDIS_NOTMIN(0x3A), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_BITBYTE) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I386) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_GPR, ZYDIS_REGKIND_GPR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_BTR ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xD80), 0, 0 ZYDIS_NOTMIN(0x3A), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_BITBYTE) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I386) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_GPR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_TRUE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_BTR ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xDE3), 0, 0 ZYDIS_NOTMIN(0x3A), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_BITBYTE) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I386) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, ZYDIS_REGKIND_GPR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_BTR ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xDE6), 0, 0 ZYDIS_NOTMIN(0x3A), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_BITBYTE) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I386) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_TRUE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_BTS ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xD7D), 0, 0 ZYDIS_NOTMIN(0x3A), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_BITBYTE) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I386) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_GPR, ZYDIS_REGKIND_GPR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_BTS ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xD80), 0, 0 ZYDIS_NOTMIN(0x3A), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_BITBYTE) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I386) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_GPR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_TRUE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_BTS ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xDE3), 0, 0 ZYDIS_NOTMIN(0x3A), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_BITBYTE) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I386) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, ZYDIS_REGKIND_GPR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_BTS ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xDE6), 0, 0 ZYDIS_NOTMIN(0x3A), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_BITBYTE) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I386) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_TRUE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_CALL ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(1) ZYDIS_NOTMIN(0x534), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CALL) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I86) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_FAR) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, 0 ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_CALL ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(1) ZYDIS_NOTMIN(0x538), 5, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CALL) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I86) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NEAR) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, 0 ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_CALL ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(1) ZYDIS_NOTMIN(0x53C), 4, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CALL) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I86) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NEAR) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, 0 ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_CALL ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(1) ZYDIS_NOTMIN(0x540), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CALL) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I86) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NEAR) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, 0 ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_CALL ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(1) ZYDIS_NOTMIN(0x544), 5, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CALL) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I86) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NEAR) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, ZYDIS_REGKIND_GPR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_CALL ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(1) ZYDIS_NOTMIN(0x548), 5, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CALL) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I86) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NEAR) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_CALL ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(1) ZYDIS_NOTMIN(0x54C), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CALL) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I86) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_FAR) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_CBW ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0) ZYDIS_NOTMIN(0x1B09), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I86) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, 0 ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_CDQ ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0) ZYDIS_NOTMIN(0x1B0B), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I386) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, 0 ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_CDQE ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0) ZYDIS_NOTMIN(0x1B0D), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_LONGMODE) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_LONGMODE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, 0 ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_CLAC ZYDIS_NOTMIN(1) ZYDIS_NOTMIN(0) ZYDIS_NOTMIN(0x9), 0, 0 ZYDIS_NOTMIN(0x5), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_SMAP) ZYDIS_NOTMIN(ZYDIS_ISA_SET_SMAP) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_SMAP) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, 0 ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_CLC ZYDIS_NOTMIN(1) ZYDIS_NOTMIN(0) ZYDIS_NOTMIN(0x9), 0, 0 ZYDIS_NOTMIN(0x3F), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_FLAGOP) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I86) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, 0 ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_CLD ZYDIS_NOTMIN(1) ZYDIS_NOTMIN(0) ZYDIS_NOTMIN(0x9), 0, 0 ZYDIS_NOTMIN(0xC), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_FLAGOP) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I86) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, 0 ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_CLDEMOTE ZYDIS_NOTMIN(1) ZYDIS_NOTMIN(1) ZYDIS_NOTMIN(0x5EC), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CLDEMOTE) ZYDIS_NOTMIN(ZYDIS_ISA_SET_CLDEMOTE) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_CLDEMOTE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_CLFLUSH ZYDIS_NOTMIN(1) ZYDIS_NOTMIN(1) ZYDIS_NOTMIN(0x1724), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_MISC) ZYDIS_NOTMIN(ZYDIS_ISA_SET_CLFSH) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_CLFSH) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_CLFLUSHOPT ZYDIS_NOTMIN(1) ZYDIS_NOTMIN(1) ZYDIS_NOTMIN(0x1724), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CLFLUSHOPT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_CLFLUSHOPT) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_CLFLUSHOPT) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_CLGI ZYDIS_NOTMIN(0) ZYDIS_NOTMIN(0) ZYDIS_NOTMIN(0x0), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_TRUE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_SYSTEM) ZYDIS_NOTMIN(ZYDIS_ISA_SET_SVM) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_SVM) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, 0 ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_CLI ZYDIS_NOTMIN(1) ZYDIS_NOTMIN(0) ZYDIS_NOTMIN(0x5CF), 0, 0 ZYDIS_NOTMIN(0xE), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_FLAGOP) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I86) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, 0 ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_CLRSSBSY ZYDIS_NOTMIN(1) ZYDIS_NOTMIN(1) ZYDIS_NOTMIN(0x1EFD), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_TRUE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CET) ZYDIS_NOTMIN(ZYDIS_ISA_SET_CET) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_CET) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_CLTS ZYDIS_NOTMIN(0) ZYDIS_NOTMIN(0) ZYDIS_NOTMIN(0x0), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_SYSTEM) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I286REAL) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, 0 ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_CLUI ZYDIS_NOTMIN(1) ZYDIS_NOTMIN(0) ZYDIS_NOTMIN(0x1EFE), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_UINTR) ZYDIS_NOTMIN(ZYDIS_ISA_SET_UINTR) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_UINTR) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, 0 ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_CLWB ZYDIS_NOTMIN(1) ZYDIS_NOTMIN(1) ZYDIS_NOTMIN(0x1724), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CLWB) ZYDIS_NOTMIN(ZYDIS_ISA_SET_CLWB) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_CLWB) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_CLZERO ZYDIS_NOTMIN(1) ZYDIS_NOTMIN(1) ZYDIS_NOTMIN(0xEE5), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CLZERO) ZYDIS_NOTMIN(ZYDIS_ISA_SET_CLZERO) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_CLZERO) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, 0 ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_CMC ZYDIS_NOTMIN(1) ZYDIS_NOTMIN(0) ZYDIS_NOTMIN(0xAE), 0, 0 ZYDIS_NOTMIN(0x21), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_FLAGOP) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I86) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, 0 ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_CMOVB ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xDE9), 0, 0 ZYDIS_NOTMIN(0x1B), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CMOV) ZYDIS_NOTMIN(ZYDIS_ISA_SET_CMOV) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_GPR, ZYDIS_REGKIND_GPR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_CMOVB ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xDEC), 0, 0 ZYDIS_NOTMIN(0x1B), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CMOV) ZYDIS_NOTMIN(ZYDIS_ISA_SET_CMOV) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_GPR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_CMOVBE ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xDE9), 0, 0 ZYDIS_NOTMIN(0x1D), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CMOV) ZYDIS_NOTMIN(ZYDIS_ISA_SET_CMOV) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_GPR, ZYDIS_REGKIND_GPR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_CMOVBE ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xDEC), 0, 0 ZYDIS_NOTMIN(0x1D), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CMOV) ZYDIS_NOTMIN(ZYDIS_ISA_SET_CMOV) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_GPR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_CMOVL ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xDE9), 0, 0 ZYDIS_NOTMIN(0x13), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CMOV) ZYDIS_NOTMIN(ZYDIS_ISA_SET_CMOV) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_GPR, ZYDIS_REGKIND_GPR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_CMOVL ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xDEC), 0, 0 ZYDIS_NOTMIN(0x13), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CMOV) ZYDIS_NOTMIN(ZYDIS_ISA_SET_CMOV) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_GPR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_CMOVLE ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xDE9), 0, 0 ZYDIS_NOTMIN(0x16), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CMOV) ZYDIS_NOTMIN(ZYDIS_ISA_SET_CMOV) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_GPR, ZYDIS_REGKIND_GPR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_CMOVLE ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xDEC), 0, 0 ZYDIS_NOTMIN(0x16), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CMOV) ZYDIS_NOTMIN(ZYDIS_ISA_SET_CMOV) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_GPR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_CMOVNB ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xDE9), 0, 0 ZYDIS_NOTMIN(0x1B), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CMOV) ZYDIS_NOTMIN(ZYDIS_ISA_SET_CMOV) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_GPR, ZYDIS_REGKIND_GPR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_CMOVNB ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xDEC), 0, 0 ZYDIS_NOTMIN(0x1B), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CMOV) ZYDIS_NOTMIN(ZYDIS_ISA_SET_CMOV) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_GPR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_CMOVNBE ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xDE9), 0, 0 ZYDIS_NOTMIN(0x1D), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CMOV) ZYDIS_NOTMIN(ZYDIS_ISA_SET_CMOV) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_GPR, ZYDIS_REGKIND_GPR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_CMOVNBE ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xDEC), 0, 0 ZYDIS_NOTMIN(0x1D), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CMOV) ZYDIS_NOTMIN(ZYDIS_ISA_SET_CMOV) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_GPR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_CMOVNL ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xDE9), 0, 0 ZYDIS_NOTMIN(0x13), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CMOV) ZYDIS_NOTMIN(ZYDIS_ISA_SET_CMOV) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_GPR, ZYDIS_REGKIND_GPR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_CMOVNL ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xDEC), 0, 0 ZYDIS_NOTMIN(0x13), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CMOV) ZYDIS_NOTMIN(ZYDIS_ISA_SET_CMOV) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_GPR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_CMOVNLE ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xDE9), 0, 0 ZYDIS_NOTMIN(0x16), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CMOV) ZYDIS_NOTMIN(ZYDIS_ISA_SET_CMOV) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_GPR, ZYDIS_REGKIND_GPR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_CMOVNLE ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xDEC), 0, 0 ZYDIS_NOTMIN(0x16), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CMOV) ZYDIS_NOTMIN(ZYDIS_ISA_SET_CMOV) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_GPR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_CMOVNO ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xDE9), 0, 0 ZYDIS_NOTMIN(0x8), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CMOV) ZYDIS_NOTMIN(ZYDIS_ISA_SET_CMOV) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_GPR, ZYDIS_REGKIND_GPR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_CMOVNO ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xDEC), 0, 0 ZYDIS_NOTMIN(0x8), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CMOV) ZYDIS_NOTMIN(ZYDIS_ISA_SET_CMOV) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_GPR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_CMOVNP ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xDE9), 0, 0 ZYDIS_NOTMIN(0x18), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CMOV) ZYDIS_NOTMIN(ZYDIS_ISA_SET_CMOV) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_GPR, ZYDIS_REGKIND_GPR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_CMOVNP ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xDEC), 0, 0 ZYDIS_NOTMIN(0x18), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CMOV) ZYDIS_NOTMIN(ZYDIS_ISA_SET_CMOV) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_GPR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_CMOVNS ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xDE9), 0, 0 ZYDIS_NOTMIN(0x12), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CMOV) ZYDIS_NOTMIN(ZYDIS_ISA_SET_CMOV) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_GPR, ZYDIS_REGKIND_GPR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_CMOVNS ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xDEC), 0, 0 ZYDIS_NOTMIN(0x12), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CMOV) ZYDIS_NOTMIN(ZYDIS_ISA_SET_CMOV) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_GPR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_CMOVNZ ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xDE9), 0, 0 ZYDIS_NOTMIN(0x14), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CMOV) ZYDIS_NOTMIN(ZYDIS_ISA_SET_CMOV) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_GPR, ZYDIS_REGKIND_GPR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_CMOVNZ ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xDEC), 0, 0 ZYDIS_NOTMIN(0x14), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CMOV) ZYDIS_NOTMIN(ZYDIS_ISA_SET_CMOV) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_GPR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_CMOVO ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xDE9), 0, 0 ZYDIS_NOTMIN(0x8), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CMOV) ZYDIS_NOTMIN(ZYDIS_ISA_SET_CMOV) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_GPR, ZYDIS_REGKIND_GPR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_CMOVO ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xDEC), 0, 0 ZYDIS_NOTMIN(0x8), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CMOV) ZYDIS_NOTMIN(ZYDIS_ISA_SET_CMOV) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_GPR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_CMOVP ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xDE9), 0, 0 ZYDIS_NOTMIN(0x18), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CMOV) ZYDIS_NOTMIN(ZYDIS_ISA_SET_CMOV) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_GPR, ZYDIS_REGKIND_GPR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_CMOVP ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xDEC), 0, 0 ZYDIS_NOTMIN(0x18), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CMOV) ZYDIS_NOTMIN(ZYDIS_ISA_SET_CMOV) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_GPR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_CMOVS ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xDE9), 0, 0 ZYDIS_NOTMIN(0x12), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CMOV) ZYDIS_NOTMIN(ZYDIS_ISA_SET_CMOV) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_GPR, ZYDIS_REGKIND_GPR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_CMOVS ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xDEC), 0, 0 ZYDIS_NOTMIN(0x12), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CMOV) ZYDIS_NOTMIN(ZYDIS_ISA_SET_CMOV) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_GPR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_CMOVZ ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xDE9), 0, 0 ZYDIS_NOTMIN(0x14), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CMOV) ZYDIS_NOTMIN(ZYDIS_ISA_SET_CMOV) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_GPR, ZYDIS_REGKIND_GPR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_CMOVZ ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xDEC), 0, 0 ZYDIS_NOTMIN(0x14), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CMOV) ZYDIS_NOTMIN(ZYDIS_ISA_SET_CMOV) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_GPR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_CMP ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xDEF), 1, 0 ZYDIS_NOTMIN(0x2B), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_BINARY) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I86) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_GPR, ZYDIS_REGKIND_GPR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_CMP ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xDF2), 1, 0 ZYDIS_NOTMIN(0x2B), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_BINARY) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I86) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_GPR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_CMP ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xDD7), 0, 0 ZYDIS_NOTMIN(0x2B), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_BINARY) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I86) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_GPR, ZYDIS_REGKIND_GPR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_CMP ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xDDA), 0, 0 ZYDIS_NOTMIN(0x2B), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_BINARY) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I86) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_GPR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_CMP ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xDF5), 1, 0 ZYDIS_NOTMIN(0x2B), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_BINARY) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I86) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_GPR, ZYDIS_REGKIND_GPR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_CMP ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xDF8), 1, 0 ZYDIS_NOTMIN(0x2B), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_BINARY) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I86) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_GPR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_CMP ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xDFB), 0, 0 ZYDIS_NOTMIN(0x2B), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_BINARY) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I86) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_GPR, ZYDIS_REGKIND_GPR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_CMP ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xDFE), 0, 0 ZYDIS_NOTMIN(0x2B), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_BINARY) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I86) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_GPR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_CMP ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xE01), 1, 0 ZYDIS_NOTMIN(0x2B), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_BINARY) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I86) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, 0 ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_CMP ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xE04), 0, 0 ZYDIS_NOTMIN(0x2B), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_BINARY) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I86) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, 0 ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_CMP ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xE07), 1, 0 ZYDIS_NOTMIN(0x2B), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_BINARY) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I86) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, ZYDIS_REGKIND_GPR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_CMP ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xE0A), 1, 0 ZYDIS_NOTMIN(0x2B), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_BINARY) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I86) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_CMP ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x59D), 0, 0 ZYDIS_NOTMIN(0x2B), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_BINARY) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I86) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, ZYDIS_REGKIND_GPR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_CMP ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x5A1), 0, 0 ZYDIS_NOTMIN(0x2B), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_BINARY) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I86) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_CMP ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xE07), 1, 0 ZYDIS_NOTMIN(0x2B), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_BINARY) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I86) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, ZYDIS_REGKIND_GPR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_CMP ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xE0A), 1, 0 ZYDIS_NOTMIN(0x2B), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_BINARY) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I86) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_CMP ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x5A5), 0, 0 ZYDIS_NOTMIN(0x2B), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_BINARY) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I86) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, ZYDIS_REGKIND_GPR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_CMP ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x5A9), 0, 0 ZYDIS_NOTMIN(0x2B), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_BINARY) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I86) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_CMPPD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0xE0D), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_SSE) ZYDIS_NOTMIN(ZYDIS_ISA_SET_SSE2) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_SSE2) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_SSE2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_CMPPD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0xE10), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_SSE) ZYDIS_NOTMIN(ZYDIS_ISA_SET_SSE2) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_SSE2) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_SSE2), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_CMPPS ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0xE13), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_SSE) ZYDIS_NOTMIN(ZYDIS_ISA_SET_SSE) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_SSE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_SSE2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_CMPPS ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0xE16), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_SSE) ZYDIS_NOTMIN(ZYDIS_ISA_SET_SSE) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_SSE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_SSE2), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_CMPSB ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0) ZYDIS_NOTMIN(0xE19), 1, 0 ZYDIS_NOTMIN(0x2C), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_STRINGOP) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I86) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, 0 ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_CMPSB ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0) ZYDIS_NOTMIN(0x550), 1, 0 ZYDIS_NOTMIN(0x29), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_STRINGOP) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I86) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, 0 ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_CMPSB ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0) ZYDIS_NOTMIN(0x550), 1, 0 ZYDIS_NOTMIN(0x29), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_STRINGOP) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I86) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, 0 ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_CMPSD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0) ZYDIS_NOTMIN(0xE1C), 0, 0 ZYDIS_NOTMIN(0x2C), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_STRINGOP) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I386) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, 0 ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_CMPSD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0) ZYDIS_NOTMIN(0x554), 0, 0 ZYDIS_NOTMIN(0x29), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_STRINGOP) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I386) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, 0 ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_CMPSD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0) ZYDIS_NOTMIN(0x554), 0, 0 ZYDIS_NOTMIN(0x29), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_STRINGOP) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I386) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, 0 ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_CMPSD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0xE1F), 2, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_SSE) ZYDIS_NOTMIN(ZYDIS_ISA_SET_SSE2) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_SSE2) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_SSE3), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_CMPSD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0xE22), 2, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_SSE) ZYDIS_NOTMIN(ZYDIS_ISA_SET_SSE2) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_SSE2) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_SSE3), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_CMPSQ ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0) ZYDIS_NOTMIN(0xE25), 0, 0 ZYDIS_NOTMIN(0x2C), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_STRINGOP) ZYDIS_NOTMIN(ZYDIS_ISA_SET_LONGMODE) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_LONGMODE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, 0 ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_CMPSQ ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0) ZYDIS_NOTMIN(0x558), 0, 0 ZYDIS_NOTMIN(0x29), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_STRINGOP) ZYDIS_NOTMIN(ZYDIS_ISA_SET_LONGMODE) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_LONGMODE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, 0 ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_CMPSQ ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0) ZYDIS_NOTMIN(0x558), 0, 0 ZYDIS_NOTMIN(0x29), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_STRINGOP) ZYDIS_NOTMIN(ZYDIS_ISA_SET_LONGMODE) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_LONGMODE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, 0 ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_CMPSS ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0xE28), 2, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_SSE) ZYDIS_NOTMIN(ZYDIS_ISA_SET_SSE) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_SSE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_SSE3), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_CMPSS ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0xE2B), 2, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_SSE) ZYDIS_NOTMIN(ZYDIS_ISA_SET_SSE) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_SSE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_SSE3), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_CMPSW ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0) ZYDIS_NOTMIN(0xE2E), 0, 0 ZYDIS_NOTMIN(0x2C), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_STRINGOP) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I86) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, 0 ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_CMPSW ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0) ZYDIS_NOTMIN(0x55C), 0, 0 ZYDIS_NOTMIN(0x29), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_STRINGOP) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I86) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, 0 ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_CMPSW ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0) ZYDIS_NOTMIN(0x55C), 0, 0 ZYDIS_NOTMIN(0x29), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_STRINGOP) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I86) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, 0 ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_CMPXCHG ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x560), 1, 0 ZYDIS_NOTMIN(0x2B), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_SEMAPHORE) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I486REAL) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_GPR, ZYDIS_REGKIND_GPR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_CMPXCHG ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x564), 1, 0 ZYDIS_NOTMIN(0x2B), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_SEMAPHORE) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I486REAL) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_GPR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_TRUE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_CMPXCHG ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x568), 0, 0 ZYDIS_NOTMIN(0x2B), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_SEMAPHORE) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I486REAL) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_GPR, ZYDIS_REGKIND_GPR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_CMPXCHG ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x56C), 0, 0 ZYDIS_NOTMIN(0x2B), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_SEMAPHORE) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I486REAL) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_GPR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_TRUE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_CMPXCHG16B ZYDIS_NOTMIN(6) ZYDIS_NOTMIN(1) ZYDIS_NOTMIN(0x9D), 6, 0 ZYDIS_NOTMIN(0x17), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_SEMAPHORE) ZYDIS_NOTMIN(ZYDIS_ISA_SET_CMPXCHG16B) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_LONGMODE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_TRUE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_CMPXCHG8B ZYDIS_NOTMIN(6) ZYDIS_NOTMIN(1) ZYDIS_NOTMIN(0xA3), 6, 0 ZYDIS_NOTMIN(0x17), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_SEMAPHORE) ZYDIS_NOTMIN(ZYDIS_ISA_SET_PENTIUMREAL) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_TRUE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_CMPXCHG8B ZYDIS_NOTMIN(6) ZYDIS_NOTMIN(1) ZYDIS_NOTMIN(0xA3), 6, 0 ZYDIS_NOTMIN(0x17), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_SEMAPHORE) ZYDIS_NOTMIN(ZYDIS_ISA_SET_PENTIUMREAL) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_TRUE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_COMISD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xE31), 0, 0 ZYDIS_NOTMIN(0x33), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_SSE) ZYDIS_NOTMIN(ZYDIS_ISA_SET_SSE2) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_SSE2) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_SSE3), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_COMISD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xE34), 0, 0 ZYDIS_NOTMIN(0x33), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_SSE) ZYDIS_NOTMIN(ZYDIS_ISA_SET_SSE2) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_SSE2) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_SSE3), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_COMISS ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xE37), 0, 0 ZYDIS_NOTMIN(0x33), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_SSE) ZYDIS_NOTMIN(ZYDIS_ISA_SET_SSE) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_SSE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_SSE3), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_COMISS ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xE3A), 0, 0 ZYDIS_NOTMIN(0x33), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_SSE) ZYDIS_NOTMIN(ZYDIS_ISA_SET_SSE) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_SSE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_SSE3), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_CPUID ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0) ZYDIS_NOTMIN(0x570), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_MISC) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I486REAL) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, 0 ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_CQO ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0) ZYDIS_NOTMIN(0x1B0F), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_LONGMODE) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_LONGMODE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, 0 ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_CRC32 ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1B11), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_SSE) ZYDIS_NOTMIN(ZYDIS_ISA_SET_SSE42) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_SSE4) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_GPR, ZYDIS_REGKIND_GPR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_CRC32 ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1B13), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_SSE) ZYDIS_NOTMIN(ZYDIS_ISA_SET_SSE42) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_SSE4) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_GPR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_CRC32 ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1B15), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_SSE) ZYDIS_NOTMIN(ZYDIS_ISA_SET_SSE42) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_SSE4) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_GPR, ZYDIS_REGKIND_GPR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_CRC32 ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1B17), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_SSE) ZYDIS_NOTMIN(ZYDIS_ISA_SET_SSE42) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_SSE4) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_GPR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_CVTDQ2PD ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1B19), 2, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_SSE2) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_SSE2) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_SSE5), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_CVTDQ2PD ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1B1B), 2, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_SSE2) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_SSE2) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_SSE5), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_CVTDQ2PS ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1B1D), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_SSE2) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_SSE2) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_SSE2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_CVTDQ2PS ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1B1F), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_SSE2) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_SSE2) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_SSE2), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_CVTPD2DQ ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1B21), 2, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_SSE2) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_SSE2) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_SSE2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_CVTPD2DQ ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1B23), 2, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_SSE2) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_SSE2) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_SSE2), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_CVTPD2PI ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1B25), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_SSE2) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_SSE2) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_MMX, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_CVTPD2PI ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1B27), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_SSE2) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_SSE2) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_MMX, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_CVTPD2PS ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1B29), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_SSE2) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_SSE2) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_SSE2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_CVTPD2PS ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1B2B), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_SSE2) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_SSE2) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_SSE2), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_CVTPI2PD ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1B2D), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_SSE2) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_SSE2) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_MMX ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_CVTPI2PD ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1B1B), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_SSE2) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_SSE2) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_CVTPI2PS ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1B2F), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_SSE) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_SSE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_MMX ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_CVTPI2PS ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1B31), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_SSE) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_SSE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_CVTPS2DQ ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1B33), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_SSE2) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_SSE2) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_SSE2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_CVTPS2DQ ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1B35), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_SSE2) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_SSE2) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_SSE2), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_CVTPS2PD ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1B37), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_SSE2) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_SSE2) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_SSE3), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_CVTPS2PD ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1B39), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_SSE2) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_SSE2) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_SSE3), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_CVTPS2PI ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1B3B), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_SSE) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_SSE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_MMX, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_CVTPS2PI ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1B3D), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_SSE) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_SSE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_MMX, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_CVTSD2SI ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1B3F), 2, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_SSE2) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_SSE2) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_SSE3), ZYDIS_REGKIND_GPR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_CVTSD2SI ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1B41), 2, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_SSE2) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_SSE2) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_SSE3), ZYDIS_REGKIND_GPR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_CVTSD2SI ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1B43), 2, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_SSE2) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_SSE2) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_SSE3), ZYDIS_REGKIND_GPR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_CVTSD2SI ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1B45), 2, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_SSE2) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_SSE2) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_SSE3), ZYDIS_REGKIND_GPR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_CVTSD2SS ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1B47), 2, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_SSE2) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_SSE2) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_SSE3), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_CVTSD2SS ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1B49), 2, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_SSE2) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_SSE2) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_SSE3), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_CVTSI2SD ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1B4B), 2, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_SSE2) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_SSE2) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_SSE3), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_GPR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_CVTSI2SD ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1B4D), 2, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_SSE2) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_SSE2) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_SSE3), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_GPR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_CVTSI2SD ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1B4F), 2, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_SSE2) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_SSE2) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_SSE3), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_CVTSI2SD ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1B51), 2, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_SSE2) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_SSE2) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_SSE3), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_CVTSI2SS ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1B53), 2, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_SSE) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_SSE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_SSE3), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_GPR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_CVTSI2SS ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1B55), 2, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_SSE) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_SSE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_SSE3), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_GPR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_CVTSI2SS ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1B57), 2, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_SSE) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_SSE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_SSE3), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_CVTSI2SS ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1B59), 2, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_SSE) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_SSE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_SSE3), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_CVTSS2SD ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1B5B), 2, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_SSE2) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_SSE2) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_SSE3), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_CVTSS2SD ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1B5D), 2, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_SSE2) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_SSE2) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_SSE3), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_CVTSS2SI ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1B5F), 2, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_SSE) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_SSE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_SSE3), ZYDIS_REGKIND_GPR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_CVTSS2SI ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1B61), 2, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_SSE) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_SSE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_SSE3), ZYDIS_REGKIND_GPR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_CVTSS2SI ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1B63), 2, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_SSE) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_SSE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_SSE3), ZYDIS_REGKIND_GPR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_CVTSS2SI ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1B65), 2, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_SSE) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_SSE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_SSE3), ZYDIS_REGKIND_GPR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_CVTTPD2DQ ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1B21), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_SSE2) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_SSE2) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_SSE2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_CVTTPD2DQ ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1B23), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_SSE2) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_SSE2) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_SSE2), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_CVTTPD2PI ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1B25), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_SSE2) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_SSE2) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_MMX, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_CVTTPD2PI ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1B27), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_SSE2) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_SSE2) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_MMX, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_CVTTPS2DQ ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1B33), 2, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_SSE2) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_SSE2) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_SSE2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_CVTTPS2DQ ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1B35), 2, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_SSE2) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_SSE2) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_SSE2), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_CVTTPS2PI ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1B67), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_SSE) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_SSE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_MMX, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_CVTTPS2PI ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1B69), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_SSE) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_SSE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_MMX, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_CVTTSD2SI ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1B3F), 2, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_SSE2) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_SSE2) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_SSE3), ZYDIS_REGKIND_GPR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_CVTTSD2SI ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1B41), 2, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_SSE2) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_SSE2) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_SSE3), ZYDIS_REGKIND_GPR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_CVTTSD2SI ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1B43), 2, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_SSE2) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_SSE2) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_SSE3), ZYDIS_REGKIND_GPR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_CVTTSD2SI ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1B45), 2, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_SSE2) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_SSE2) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_SSE3), ZYDIS_REGKIND_GPR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_CVTTSS2SI ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1B5F), 2, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_SSE) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_SSE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_SSE3), ZYDIS_REGKIND_GPR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_CVTTSS2SI ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1B61), 2, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_SSE) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_SSE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_SSE3), ZYDIS_REGKIND_GPR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_CVTTSS2SI ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1B63), 2, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_SSE) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_SSE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_SSE3), ZYDIS_REGKIND_GPR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_CVTTSS2SI ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1B65), 2, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_SSE) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_SSE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_SSE3), ZYDIS_REGKIND_GPR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_CWD ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0) ZYDIS_NOTMIN(0x1B6B), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I86) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, 0 ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_CWDE ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0) ZYDIS_NOTMIN(0x1B6D), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I386) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, 0 ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_DAA ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0) ZYDIS_NOTMIN(0x1B6F), 0, 0 ZYDIS_NOTMIN(0x23), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DECIMAL) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I86) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, 0 ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_DAS ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0) ZYDIS_NOTMIN(0x1B6F), 0, 0 ZYDIS_NOTMIN(0x23), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DECIMAL) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I86) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, 0 ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_DEC ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(1) ZYDIS_NOTMIN(0x1B71), 0, 0 ZYDIS_NOTMIN(0x1A), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_BINARY) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I86) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, 0 ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_DEC ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(1) ZYDIS_NOTMIN(0x1B73), 1, 0 ZYDIS_NOTMIN(0x1A), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_BINARY) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I86) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, ZYDIS_REGKIND_GPR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_DEC ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(1) ZYDIS_NOTMIN(0x1B75), 1, 0 ZYDIS_NOTMIN(0x1A), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_BINARY) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I86) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_TRUE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_DEC ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(1) ZYDIS_NOTMIN(0x1B77), 0, 0 ZYDIS_NOTMIN(0x1A), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_BINARY) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I86) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, ZYDIS_REGKIND_GPR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_DEC ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(1) ZYDIS_NOTMIN(0x1B79), 0, 0 ZYDIS_NOTMIN(0x1A), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_BINARY) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I86) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_TRUE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_DIV ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(1) ZYDIS_NOTMIN(0xE3D), 1, 0 ZYDIS_NOTMIN(0x48), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_BINARY) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I86) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, ZYDIS_REGKIND_GPR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_DIV ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(1) ZYDIS_NOTMIN(0xE40), 1, 0 ZYDIS_NOTMIN(0x48), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_BINARY) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I86) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_DIV ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(1) ZYDIS_NOTMIN(0x574), 0, 0 ZYDIS_NOTMIN(0x48), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_BINARY) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I86) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, ZYDIS_REGKIND_GPR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_DIV ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(1) ZYDIS_NOTMIN(0x578), 0, 0 ZYDIS_NOTMIN(0x48), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_BINARY) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I86) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_DIVPD ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xDB9), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_SSE) ZYDIS_NOTMIN(ZYDIS_ISA_SET_SSE2) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_SSE2) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_SSE2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_DIVPD ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xDBC), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_SSE) ZYDIS_NOTMIN(ZYDIS_ISA_SET_SSE2) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_SSE2) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_SSE2), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_DIVPS ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xDBF), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_SSE) ZYDIS_NOTMIN(ZYDIS_ISA_SET_SSE) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_SSE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_SSE2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_DIVPS ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xDC2), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_SSE) ZYDIS_NOTMIN(ZYDIS_ISA_SET_SSE) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_SSE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_SSE2), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_DIVSD ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xE1F), 2, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_SSE) ZYDIS_NOTMIN(ZYDIS_ISA_SET_SSE2) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_SSE2) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_SSE3), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_DIVSD ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xE22), 2, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_SSE) ZYDIS_NOTMIN(ZYDIS_ISA_SET_SSE2) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_SSE2) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_SSE3), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_DIVSS ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xE28), 2, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_SSE) ZYDIS_NOTMIN(ZYDIS_ISA_SET_SSE) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_SSE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_SSE3), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_DIVSS ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xE2B), 2, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_SSE) ZYDIS_NOTMIN(ZYDIS_ISA_SET_SSE) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_SSE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_SSE3), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_DPPD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0xDB9), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_SSE) ZYDIS_NOTMIN(ZYDIS_ISA_SET_SSE4) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_SSE4) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_SSE2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_DPPD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0xDBC), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_SSE) ZYDIS_NOTMIN(ZYDIS_ISA_SET_SSE4) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_SSE4) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_SSE2), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_DPPS ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0xDBF), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_SSE) ZYDIS_NOTMIN(ZYDIS_ISA_SET_SSE4) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_SSE4) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_SSE2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_DPPS ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0xDC2), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_SSE) ZYDIS_NOTMIN(ZYDIS_ISA_SET_SSE4) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_SSE4) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_SSE2), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_EMMS ZYDIS_NOTMIN(0) ZYDIS_NOTMIN(0) ZYDIS_NOTMIN(0x0), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_MMX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_PENTIUMMMX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_MMX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, 0 ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_WRITE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_ENCLS ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0) ZYDIS_NOTMIN(0x57C), 7, 2 ZYDIS_NOTMIN(0x0), ZYAN_TRUE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_SGX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_SGX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_SGX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, 0 ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_ENCLS ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0) ZYDIS_NOTMIN(0x580), 7, 2 ZYDIS_NOTMIN(0x0), ZYAN_TRUE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_SGX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_SGX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_SGX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, 0 ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_ENCLU ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0) ZYDIS_NOTMIN(0x57C), 7, 2 ZYDIS_NOTMIN(0x0), ZYAN_TRUE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_SGX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_SGX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_SGX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, 0 ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_ENCLU ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0) ZYDIS_NOTMIN(0x580), 7, 2 ZYDIS_NOTMIN(0x0), ZYAN_TRUE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_SGX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_SGX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_SGX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, 0 ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_ENCLV ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0) ZYDIS_NOTMIN(0x584), 7, 2 ZYDIS_NOTMIN(0x0), ZYAN_TRUE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_SGX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_SGX_ENCLV) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_SGX_ENCLV) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, 0 ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_ENCLV ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0) ZYDIS_NOTMIN(0x588), 7, 2 ZYDIS_NOTMIN(0x0), ZYAN_TRUE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_SGX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_SGX_ENCLV) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_SGX_ENCLV) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, 0 ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_ENCODEKEY128 ZYDIS_NOTMIN(9) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x32), 0, 0 ZYDIS_NOTMIN(0x42), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_KEYLOCKER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_KEYLOCKER) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_KEYLOCKER) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_GPR, ZYDIS_REGKIND_GPR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_ENCODEKEY256 ZYDIS_NOTMIN(10) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x14), 0, 0 ZYDIS_NOTMIN(0x42), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_KEYLOCKER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_KEYLOCKER) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_KEYLOCKER) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_GPR, ZYDIS_REGKIND_GPR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_ENDBR32 ZYDIS_NOTMIN(0) ZYDIS_NOTMIN(0) ZYDIS_NOTMIN(0x0), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CET) ZYDIS_NOTMIN(ZYDIS_ISA_SET_CET) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_CET) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, 0 ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_ENDBR64 ZYDIS_NOTMIN(0) ZYDIS_NOTMIN(0) ZYDIS_NOTMIN(0x0), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CET) ZYDIS_NOTMIN(ZYDIS_ISA_SET_CET) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_CET) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, 0 ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_ENQCMD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xE43), 0, 0 ZYDIS_NOTMIN(0x41), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_ENQCMD) ZYDIS_NOTMIN(ZYDIS_ISA_SET_ENQCMD) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_ENQCMD) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_GPR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_ENQCMDS ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xE43), 0, 0 ZYDIS_NOTMIN(0x41), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_ENQCMD) ZYDIS_NOTMIN(ZYDIS_ISA_SET_ENQCMD) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_ENQCMD) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_GPR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_ENTER ZYDIS_NOTMIN(5) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xE5), 4, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_MISC) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I186) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, 0 ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_EXTRACTPS ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0xE46), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_SSE) ZYDIS_NOTMIN(ZYDIS_ISA_SET_SSE4) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_SSE4) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_SSE5), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_GPR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_EXTRACTPS ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0xE49), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_SSE) ZYDIS_NOTMIN(ZYDIS_ISA_SET_SSE4) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_SSE4) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_SSE5), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_EXTRQ ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0xE4C), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_BITBYTE) ZYDIS_NOTMIN(ZYDIS_ISA_SET_SSE4A) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_SSE4A) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_EXTRQ ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1B7B), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_BITBYTE) ZYDIS_NOTMIN(ZYDIS_ISA_SET_SSE4A) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_SSE4A) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_F2XM1 ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0) ZYDIS_NOTMIN(0xE53), 0, 0 ZYDIS_NOTMIN(0x3), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_X87_ALU) ZYDIS_NOTMIN(ZYDIS_ISA_SET_X87) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_X87) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, 0 ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_FABS ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0) ZYDIS_NOTMIN(0xE53), 0, 0 ZYDIS_NOTMIN(0x3), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_X87_ALU) ZYDIS_NOTMIN(ZYDIS_ISA_SET_X87) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_X87) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, 0 ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_FADD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xE4F), 0, 0 ZYDIS_NOTMIN(0x3), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_X87_ALU) ZYDIS_NOTMIN(ZYDIS_ISA_SET_X87) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_X87) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, ZYDIS_REGKIND_X87 ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_FADD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(1) ZYDIS_NOTMIN(0xE52), 0, 0 ZYDIS_NOTMIN(0x3), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_X87_ALU) ZYDIS_NOTMIN(ZYDIS_ISA_SET_X87) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_X87) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_FADD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xE55), 0, 0 ZYDIS_NOTMIN(0x3), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_X87_ALU) ZYDIS_NOTMIN(ZYDIS_ISA_SET_X87) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_X87) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, ZYDIS_REGKIND_X87 ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_FADD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(1) ZYDIS_NOTMIN(0xE58), 0, 0 ZYDIS_NOTMIN(0x3), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_X87_ALU) ZYDIS_NOTMIN(ZYDIS_ISA_SET_X87) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_X87) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_FADDP ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xE55), 0, 0 ZYDIS_NOTMIN(0x3), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_X87_ALU) ZYDIS_NOTMIN(ZYDIS_ISA_SET_X87) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_X87) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, ZYDIS_REGKIND_X87 ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_FBLD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(1) ZYDIS_NOTMIN(0xE5B), 0, 0 ZYDIS_NOTMIN(0x3), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_X87_ALU) ZYDIS_NOTMIN(ZYDIS_ISA_SET_X87) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_X87) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_FBSTP ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(1) ZYDIS_NOTMIN(0xE5E), 0, 0 ZYDIS_NOTMIN(0x3), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_X87_ALU) ZYDIS_NOTMIN(ZYDIS_ISA_SET_X87) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_X87) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_FCHS ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0) ZYDIS_NOTMIN(0xE53), 0, 0 ZYDIS_NOTMIN(0x3), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_X87_ALU) ZYDIS_NOTMIN(ZYDIS_ISA_SET_X87) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_X87) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, 0 ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_FCMOVB ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x58C), 0, 0 ZYDIS_NOTMIN(0x1C), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_FCMOV) ZYDIS_NOTMIN(ZYDIS_ISA_SET_FCMOV) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_X87) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, ZYDIS_REGKIND_X87 ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_FCMOVBE ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x58C), 0, 0 ZYDIS_NOTMIN(0x1E), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_FCMOV) ZYDIS_NOTMIN(ZYDIS_ISA_SET_FCMOV) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_X87) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, ZYDIS_REGKIND_X87 ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_FCMOVE ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x58C), 0, 0 ZYDIS_NOTMIN(0x15), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_FCMOV) ZYDIS_NOTMIN(ZYDIS_ISA_SET_FCMOV) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_X87) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, ZYDIS_REGKIND_X87 ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_FCMOVNB ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x58C), 0, 0 ZYDIS_NOTMIN(0x1C), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_FCMOV) ZYDIS_NOTMIN(ZYDIS_ISA_SET_FCMOV) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_X87) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, ZYDIS_REGKIND_X87 ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_FCMOVNBE ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x58C), 0, 0 ZYDIS_NOTMIN(0x1E), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_FCMOV) ZYDIS_NOTMIN(ZYDIS_ISA_SET_FCMOV) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_X87) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, ZYDIS_REGKIND_X87 ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_FCMOVNE ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x58C), 0, 0 ZYDIS_NOTMIN(0x15), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_FCMOV) ZYDIS_NOTMIN(ZYDIS_ISA_SET_FCMOV) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_X87) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, ZYDIS_REGKIND_X87 ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_FCMOVNU ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x58C), 0, 0 ZYDIS_NOTMIN(0x19), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_FCMOV) ZYDIS_NOTMIN(ZYDIS_ISA_SET_FCMOV) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_X87) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, ZYDIS_REGKIND_X87 ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_FCMOVU ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x58C), 0, 0 ZYDIS_NOTMIN(0x19), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_FCMOV) ZYDIS_NOTMIN(ZYDIS_ISA_SET_FCMOV) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_X87) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, ZYDIS_REGKIND_X87 ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_FCOM ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(1) ZYDIS_NOTMIN(0xE61), 0, 0 ZYDIS_NOTMIN(0x1), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_X87_ALU) ZYDIS_NOTMIN(ZYDIS_ISA_SET_X87) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_X87) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, ZYDIS_REGKIND_X87 ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_FCOM ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(1) ZYDIS_NOTMIN(0xE64), 0, 0 ZYDIS_NOTMIN(0x1), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_X87_ALU) ZYDIS_NOTMIN(ZYDIS_ISA_SET_X87) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_X87) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_FCOM ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(1) ZYDIS_NOTMIN(0xE61), 0, 0 ZYDIS_NOTMIN(0x1), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_X87_ALU) ZYDIS_NOTMIN(ZYDIS_ISA_SET_X87) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_X87) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, ZYDIS_REGKIND_X87 ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_FCOM ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(1) ZYDIS_NOTMIN(0xE67), 0, 0 ZYDIS_NOTMIN(0x1), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_X87_ALU) ZYDIS_NOTMIN(ZYDIS_ISA_SET_X87) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_X87) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_FCOMI ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x590), 0, 0 ZYDIS_NOTMIN(0x34), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_X87_ALU) ZYDIS_NOTMIN(ZYDIS_ISA_SET_FCOMI) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_X87) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, ZYDIS_REGKIND_X87 ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_FCOMIP ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x590), 0, 0 ZYDIS_NOTMIN(0x34), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_X87_ALU) ZYDIS_NOTMIN(ZYDIS_ISA_SET_FCOMI) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_X87) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, ZYDIS_REGKIND_X87 ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_FCOMP ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(1) ZYDIS_NOTMIN(0xE61), 0, 0 ZYDIS_NOTMIN(0x1), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_X87_ALU) ZYDIS_NOTMIN(ZYDIS_ISA_SET_X87) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_X87) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, ZYDIS_REGKIND_X87 ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_FCOMP ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(1) ZYDIS_NOTMIN(0xE64), 0, 0 ZYDIS_NOTMIN(0x1), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_X87_ALU) ZYDIS_NOTMIN(ZYDIS_ISA_SET_X87) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_X87) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_FCOMP ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(1) ZYDIS_NOTMIN(0xE61), 0, 0 ZYDIS_NOTMIN(0x1), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_X87_ALU) ZYDIS_NOTMIN(ZYDIS_ISA_SET_X87) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_X87) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, ZYDIS_REGKIND_X87 ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_FCOMP ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(1) ZYDIS_NOTMIN(0xE67), 0, 0 ZYDIS_NOTMIN(0x1), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_X87_ALU) ZYDIS_NOTMIN(ZYDIS_ISA_SET_X87) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_X87) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_FCOMP ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(1) ZYDIS_NOTMIN(0xE61), 0, 0 ZYDIS_NOTMIN(0x1), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_X87_ALU) ZYDIS_NOTMIN(ZYDIS_ISA_SET_X87) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_X87) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, ZYDIS_REGKIND_X87 ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_FCOMPP ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0) ZYDIS_NOTMIN(0xE6A), 0, 0 ZYDIS_NOTMIN(0x1), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_X87_ALU) ZYDIS_NOTMIN(ZYDIS_ISA_SET_X87) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_X87) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, 0 ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_FCOS ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0) ZYDIS_NOTMIN(0xE53), 0, 0 ZYDIS_NOTMIN(0x2), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_X87_ALU) ZYDIS_NOTMIN(ZYDIS_ISA_SET_X87) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_X87) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, 0 ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_FDECSTP ZYDIS_NOTMIN(1) ZYDIS_NOTMIN(0) ZYDIS_NOTMIN(0x58F), 0, 0 ZYDIS_NOTMIN(0x3), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_X87_ALU) ZYDIS_NOTMIN(ZYDIS_ISA_SET_X87) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_X87) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, 0 ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_FDISI8087_NOP ZYDIS_NOTMIN(0) ZYDIS_NOTMIN(0) ZYDIS_NOTMIN(0x0), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_X87_ALU) ZYDIS_NOTMIN(ZYDIS_ISA_SET_X87) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_X87) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, 0 ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_FDIV ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xE4F), 0, 0 ZYDIS_NOTMIN(0x3), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_X87_ALU) ZYDIS_NOTMIN(ZYDIS_ISA_SET_X87) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_X87) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, ZYDIS_REGKIND_X87 ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_FDIV ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(1) ZYDIS_NOTMIN(0xE52), 0, 0 ZYDIS_NOTMIN(0x3), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_X87_ALU) ZYDIS_NOTMIN(ZYDIS_ISA_SET_X87) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_X87) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_FDIV ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xE55), 0, 0 ZYDIS_NOTMIN(0x3), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_X87_ALU) ZYDIS_NOTMIN(ZYDIS_ISA_SET_X87) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_X87) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, ZYDIS_REGKIND_X87 ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_FDIV ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(1) ZYDIS_NOTMIN(0xE58), 0, 0 ZYDIS_NOTMIN(0x3), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_X87_ALU) ZYDIS_NOTMIN(ZYDIS_ISA_SET_X87) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_X87) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_FDIVP ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xE55), 0, 0 ZYDIS_NOTMIN(0x3), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_X87_ALU) ZYDIS_NOTMIN(ZYDIS_ISA_SET_X87) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_X87) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, ZYDIS_REGKIND_X87 ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_FDIVR ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xE4F), 0, 0 ZYDIS_NOTMIN(0x3), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_X87_ALU) ZYDIS_NOTMIN(ZYDIS_ISA_SET_X87) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_X87) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, ZYDIS_REGKIND_X87 ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_FDIVR ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(1) ZYDIS_NOTMIN(0xE52), 0, 0 ZYDIS_NOTMIN(0x3), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_X87_ALU) ZYDIS_NOTMIN(ZYDIS_ISA_SET_X87) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_X87) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_FDIVR ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xE55), 0, 0 ZYDIS_NOTMIN(0x3), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_X87_ALU) ZYDIS_NOTMIN(ZYDIS_ISA_SET_X87) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_X87) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, ZYDIS_REGKIND_X87 ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_FDIVR ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(1) ZYDIS_NOTMIN(0xE58), 0, 0 ZYDIS_NOTMIN(0x3), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_X87_ALU) ZYDIS_NOTMIN(ZYDIS_ISA_SET_X87) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_X87) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_FDIVRP ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xE55), 0, 0 ZYDIS_NOTMIN(0x3), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_X87_ALU) ZYDIS_NOTMIN(ZYDIS_ISA_SET_X87) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_X87) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, ZYDIS_REGKIND_X87 ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_FEMMS ZYDIS_NOTMIN(0) ZYDIS_NOTMIN(0) ZYDIS_NOTMIN(0x0), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_MMX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AMD3DNOW) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AMD3DNOW) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, 0 ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_WRITE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_FENI8087_NOP ZYDIS_NOTMIN(0) ZYDIS_NOTMIN(0) ZYDIS_NOTMIN(0x0), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_X87_ALU) ZYDIS_NOTMIN(ZYDIS_ISA_SET_X87) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_X87) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, 0 ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_FFREE ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(1) ZYDIS_NOTMIN(0xE50), 0, 0 ZYDIS_NOTMIN(0x4), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_X87_ALU) ZYDIS_NOTMIN(ZYDIS_ISA_SET_X87) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_X87) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, ZYDIS_REGKIND_X87 ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_FFREEP ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(1) ZYDIS_NOTMIN(0xE50), 0, 0 ZYDIS_NOTMIN(0x4), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_X87_ALU) ZYDIS_NOTMIN(ZYDIS_ISA_SET_X87) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_X87) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, ZYDIS_REGKIND_X87 ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_FIADD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(1) ZYDIS_NOTMIN(0xE6D), 0, 0 ZYDIS_NOTMIN(0x3), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_X87_ALU) ZYDIS_NOTMIN(ZYDIS_ISA_SET_X87) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_X87) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_FIADD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(1) ZYDIS_NOTMIN(0xE70), 0, 0 ZYDIS_NOTMIN(0x3), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_X87_ALU) ZYDIS_NOTMIN(ZYDIS_ISA_SET_X87) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_X87) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_FICOM ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(1) ZYDIS_NOTMIN(0xE73), 0, 0 ZYDIS_NOTMIN(0x1), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_X87_ALU) ZYDIS_NOTMIN(ZYDIS_ISA_SET_X87) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_X87) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_FICOM ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(1) ZYDIS_NOTMIN(0xE76), 0, 0 ZYDIS_NOTMIN(0x1), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_X87_ALU) ZYDIS_NOTMIN(ZYDIS_ISA_SET_X87) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_X87) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_FICOMP ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(1) ZYDIS_NOTMIN(0xE73), 0, 0 ZYDIS_NOTMIN(0x1), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_X87_ALU) ZYDIS_NOTMIN(ZYDIS_ISA_SET_X87) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_X87) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_FICOMP ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(1) ZYDIS_NOTMIN(0xE76), 0, 0 ZYDIS_NOTMIN(0x1), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_X87_ALU) ZYDIS_NOTMIN(ZYDIS_ISA_SET_X87) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_X87) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_FIDIV ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(1) ZYDIS_NOTMIN(0xE6D), 0, 0 ZYDIS_NOTMIN(0x3), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_X87_ALU) ZYDIS_NOTMIN(ZYDIS_ISA_SET_X87) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_X87) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_FIDIV ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(1) ZYDIS_NOTMIN(0xE70), 0, 0 ZYDIS_NOTMIN(0x3), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_X87_ALU) ZYDIS_NOTMIN(ZYDIS_ISA_SET_X87) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_X87) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_FIDIVR ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(1) ZYDIS_NOTMIN(0xE6D), 0, 0 ZYDIS_NOTMIN(0x3), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_X87_ALU) ZYDIS_NOTMIN(ZYDIS_ISA_SET_X87) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_X87) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_FIDIVR ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(1) ZYDIS_NOTMIN(0xE70), 0, 0 ZYDIS_NOTMIN(0x3), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_X87_ALU) ZYDIS_NOTMIN(ZYDIS_ISA_SET_X87) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_X87) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_FILD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(1) ZYDIS_NOTMIN(0xE79), 0, 0 ZYDIS_NOTMIN(0x3), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_X87_ALU) ZYDIS_NOTMIN(ZYDIS_ISA_SET_X87) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_X87) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_FILD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(1) ZYDIS_NOTMIN(0xE7C), 0, 0 ZYDIS_NOTMIN(0x3), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_X87_ALU) ZYDIS_NOTMIN(ZYDIS_ISA_SET_X87) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_X87) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_FILD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(1) ZYDIS_NOTMIN(0xE7F), 0, 0 ZYDIS_NOTMIN(0x3), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_X87_ALU) ZYDIS_NOTMIN(ZYDIS_ISA_SET_X87) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_X87) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_FIMUL ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(1) ZYDIS_NOTMIN(0xE6D), 0, 0 ZYDIS_NOTMIN(0x3), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_X87_ALU) ZYDIS_NOTMIN(ZYDIS_ISA_SET_X87) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_X87) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_FIMUL ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(1) ZYDIS_NOTMIN(0xE70), 0, 0 ZYDIS_NOTMIN(0x3), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_X87_ALU) ZYDIS_NOTMIN(ZYDIS_ISA_SET_X87) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_X87) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_FINCSTP ZYDIS_NOTMIN(1) ZYDIS_NOTMIN(0) ZYDIS_NOTMIN(0x58F), 0, 0 ZYDIS_NOTMIN(0x3), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_X87_ALU) ZYDIS_NOTMIN(ZYDIS_ISA_SET_X87) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_X87) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, 0 ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_FIST ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(1) ZYDIS_NOTMIN(0xE82), 0, 0 ZYDIS_NOTMIN(0x3), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_X87_ALU) ZYDIS_NOTMIN(ZYDIS_ISA_SET_X87) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_X87) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_FIST ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(1) ZYDIS_NOTMIN(0xE85), 0, 0 ZYDIS_NOTMIN(0x3), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_X87_ALU) ZYDIS_NOTMIN(ZYDIS_ISA_SET_X87) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_X87) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_FISTP ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(1) ZYDIS_NOTMIN(0xE82), 0, 0 ZYDIS_NOTMIN(0x3), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_X87_ALU) ZYDIS_NOTMIN(ZYDIS_ISA_SET_X87) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_X87) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_FISTP ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(1) ZYDIS_NOTMIN(0xE85), 0, 0 ZYDIS_NOTMIN(0x3), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_X87_ALU) ZYDIS_NOTMIN(ZYDIS_ISA_SET_X87) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_X87) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_FISTP ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(1) ZYDIS_NOTMIN(0xE88), 0, 0 ZYDIS_NOTMIN(0x3), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_X87_ALU) ZYDIS_NOTMIN(ZYDIS_ISA_SET_X87) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_X87) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_FISTTP ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(1) ZYDIS_NOTMIN(0xE82), 0, 0 ZYDIS_NOTMIN(0x3), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_X87_ALU) ZYDIS_NOTMIN(ZYDIS_ISA_SET_SSE3) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_SSE3) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_FISTTP ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(1) ZYDIS_NOTMIN(0xE88), 0, 0 ZYDIS_NOTMIN(0x3), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_X87_ALU) ZYDIS_NOTMIN(ZYDIS_ISA_SET_SSE3X87) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_SSE3) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_FISTTP ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(1) ZYDIS_NOTMIN(0xE85), 0, 0 ZYDIS_NOTMIN(0x3), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_X87_ALU) ZYDIS_NOTMIN(ZYDIS_ISA_SET_SSE3X87) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_SSE3) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_FISUB ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(1) ZYDIS_NOTMIN(0xE6D), 0, 0 ZYDIS_NOTMIN(0x3), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_X87_ALU) ZYDIS_NOTMIN(ZYDIS_ISA_SET_X87) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_X87) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_FISUB ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(1) ZYDIS_NOTMIN(0xE70), 0, 0 ZYDIS_NOTMIN(0x3), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_X87_ALU) ZYDIS_NOTMIN(ZYDIS_ISA_SET_X87) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_X87) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_FISUBR ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(1) ZYDIS_NOTMIN(0xE6D), 0, 0 ZYDIS_NOTMIN(0x3), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_X87_ALU) ZYDIS_NOTMIN(ZYDIS_ISA_SET_X87) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_X87) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_FISUBR ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(1) ZYDIS_NOTMIN(0xE70), 0, 0 ZYDIS_NOTMIN(0x3), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_X87_ALU) ZYDIS_NOTMIN(ZYDIS_ISA_SET_X87) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_X87) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_FLD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(1) ZYDIS_NOTMIN(0xE8B), 0, 0 ZYDIS_NOTMIN(0x3), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_X87_ALU) ZYDIS_NOTMIN(ZYDIS_ISA_SET_X87) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_X87) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, ZYDIS_REGKIND_X87 ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_FLD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(1) ZYDIS_NOTMIN(0xE8E), 0, 0 ZYDIS_NOTMIN(0x3), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_X87_ALU) ZYDIS_NOTMIN(ZYDIS_ISA_SET_X87) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_X87) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_FLD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(1) ZYDIS_NOTMIN(0xE91), 0, 0 ZYDIS_NOTMIN(0x3), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_X87_ALU) ZYDIS_NOTMIN(ZYDIS_ISA_SET_X87) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_X87) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_FLD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(1) ZYDIS_NOTMIN(0xE94), 0, 0 ZYDIS_NOTMIN(0x3), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_X87_ALU) ZYDIS_NOTMIN(ZYDIS_ISA_SET_X87) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_X87) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_FLD1 ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0) ZYDIS_NOTMIN(0xE5C), 0, 0 ZYDIS_NOTMIN(0x3), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_X87_ALU) ZYDIS_NOTMIN(ZYDIS_ISA_SET_X87) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_X87) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, 0 ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_FLDCW ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(1) ZYDIS_NOTMIN(0x1B7D), 0, 0 ZYDIS_NOTMIN(0x4), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_X87_ALU) ZYDIS_NOTMIN(ZYDIS_ISA_SET_X87) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_X87) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_FLDENV ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(1) ZYDIS_NOTMIN(0x1B7F), 0, 0 ZYDIS_NOTMIN(0x1), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_X87_ALU) ZYDIS_NOTMIN(ZYDIS_ISA_SET_X87) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_X87) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_FLDENV ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(1) ZYDIS_NOTMIN(0x1B81), 0, 0 ZYDIS_NOTMIN(0x1), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_X87_ALU) ZYDIS_NOTMIN(ZYDIS_ISA_SET_X87) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_X87) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_FLDL2E ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0) ZYDIS_NOTMIN(0xE5C), 0, 0 ZYDIS_NOTMIN(0x3), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_X87_ALU) ZYDIS_NOTMIN(ZYDIS_ISA_SET_X87) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_X87) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, 0 ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_FLDL2T ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0) ZYDIS_NOTMIN(0xE5C), 0, 0 ZYDIS_NOTMIN(0x3), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_X87_ALU) ZYDIS_NOTMIN(ZYDIS_ISA_SET_X87) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_X87) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, 0 ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_FLDLG2 ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0) ZYDIS_NOTMIN(0xE5C), 0, 0 ZYDIS_NOTMIN(0x3), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_X87_ALU) ZYDIS_NOTMIN(ZYDIS_ISA_SET_X87) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_X87) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, 0 ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_FLDLN2 ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0) ZYDIS_NOTMIN(0xE5C), 0, 0 ZYDIS_NOTMIN(0x3), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_X87_ALU) ZYDIS_NOTMIN(ZYDIS_ISA_SET_X87) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_X87) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, 0 ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_FLDPI ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0) ZYDIS_NOTMIN(0xE5C), 0, 0 ZYDIS_NOTMIN(0x3), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_X87_ALU) ZYDIS_NOTMIN(ZYDIS_ISA_SET_X87) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_X87) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, 0 ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_FLDZ ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0) ZYDIS_NOTMIN(0xE5C), 0, 0 ZYDIS_NOTMIN(0x3), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_X87_ALU) ZYDIS_NOTMIN(ZYDIS_ISA_SET_X87) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_X87) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, 0 ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_FMUL ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xE4F), 0, 0 ZYDIS_NOTMIN(0x3), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_X87_ALU) ZYDIS_NOTMIN(ZYDIS_ISA_SET_X87) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_X87) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, ZYDIS_REGKIND_X87 ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_FMUL ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(1) ZYDIS_NOTMIN(0xE52), 0, 0 ZYDIS_NOTMIN(0x3), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_X87_ALU) ZYDIS_NOTMIN(ZYDIS_ISA_SET_X87) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_X87) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_FMUL ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xE55), 0, 0 ZYDIS_NOTMIN(0x3), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_X87_ALU) ZYDIS_NOTMIN(ZYDIS_ISA_SET_X87) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_X87) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, ZYDIS_REGKIND_X87 ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_FMUL ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(1) ZYDIS_NOTMIN(0xE58), 0, 0 ZYDIS_NOTMIN(0x3), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_X87_ALU) ZYDIS_NOTMIN(ZYDIS_ISA_SET_X87) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_X87) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_FMULP ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xE55), 0, 0 ZYDIS_NOTMIN(0x3), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_X87_ALU) ZYDIS_NOTMIN(ZYDIS_ISA_SET_X87) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_X87) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, ZYDIS_REGKIND_X87 ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_FNCLEX ZYDIS_NOTMIN(1) ZYDIS_NOTMIN(0) ZYDIS_NOTMIN(0x58F), 0, 0 ZYDIS_NOTMIN(0x4), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_X87_ALU) ZYDIS_NOTMIN(ZYDIS_ISA_SET_X87) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_X87) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, 0 ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_FNINIT ZYDIS_NOTMIN(1) ZYDIS_NOTMIN(0) ZYDIS_NOTMIN(0x58F), 0, 0 ZYDIS_NOTMIN(0x1), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_X87_ALU) ZYDIS_NOTMIN(ZYDIS_ISA_SET_X87) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_X87) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, 0 ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_WRITE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_FNOP ZYDIS_NOTMIN(0) ZYDIS_NOTMIN(0) ZYDIS_NOTMIN(0x0), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_X87_ALU) ZYDIS_NOTMIN(ZYDIS_ISA_SET_X87) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_X87) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, 0 ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_FNSAVE ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(1) ZYDIS_NOTMIN(0x1B83), 0, 0 ZYDIS_NOTMIN(0x1), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_X87_ALU) ZYDIS_NOTMIN(ZYDIS_ISA_SET_X87) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_X87) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_READWRITE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_FNSAVE ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(1) ZYDIS_NOTMIN(0x1B85), 0, 0 ZYDIS_NOTMIN(0x1), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_X87_ALU) ZYDIS_NOTMIN(ZYDIS_ISA_SET_X87) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_X87) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_READWRITE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_FNSTCW ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(1) ZYDIS_NOTMIN(0x1B87), 0, 0 ZYDIS_NOTMIN(0x4), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_X87_ALU) ZYDIS_NOTMIN(ZYDIS_ISA_SET_X87) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_X87) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_FNSTENV ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(1) ZYDIS_NOTMIN(0x1B89), 0, 0 ZYDIS_NOTMIN(0x4), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_X87_ALU) ZYDIS_NOTMIN(ZYDIS_ISA_SET_X87) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_X87) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_FNSTENV ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(1) ZYDIS_NOTMIN(0x1B8B), 0, 0 ZYDIS_NOTMIN(0x4), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_X87_ALU) ZYDIS_NOTMIN(ZYDIS_ISA_SET_X87) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_X87) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_FNSTSW ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(1) ZYDIS_NOTMIN(0x1B87), 0, 0 ZYDIS_NOTMIN(0x4), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_X87_ALU) ZYDIS_NOTMIN(ZYDIS_ISA_SET_X87) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_X87) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_FNSTSW ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(1) ZYDIS_NOTMIN(0x1B8D), 0, 0 ZYDIS_NOTMIN(0x4), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_X87_ALU) ZYDIS_NOTMIN(ZYDIS_ISA_SET_X87) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_X87) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, 0 ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_FPATAN ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0) ZYDIS_NOTMIN(0xE97), 0, 0 ZYDIS_NOTMIN(0x3), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_X87_ALU) ZYDIS_NOTMIN(ZYDIS_ISA_SET_X87) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_X87) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, 0 ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_FPREM ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0) ZYDIS_NOTMIN(0xE9A), 0, 0 ZYDIS_NOTMIN(0x1), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_X87_ALU) ZYDIS_NOTMIN(ZYDIS_ISA_SET_X87) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_X87) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, 0 ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_FPREM1 ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0) ZYDIS_NOTMIN(0xE9A), 0, 0 ZYDIS_NOTMIN(0x1), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_X87_ALU) ZYDIS_NOTMIN(ZYDIS_ISA_SET_X87) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_X87) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, 0 ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_FPTAN ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0) ZYDIS_NOTMIN(0xE9D), 0, 0 ZYDIS_NOTMIN(0x2), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_X87_ALU) ZYDIS_NOTMIN(ZYDIS_ISA_SET_X87) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_X87) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, 0 ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_FRNDINT ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0) ZYDIS_NOTMIN(0xE53), 0, 0 ZYDIS_NOTMIN(0x3), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_X87_ALU) ZYDIS_NOTMIN(ZYDIS_ISA_SET_X87) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_X87) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, 0 ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_FRSTOR ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(1) ZYDIS_NOTMIN(0x1B8F), 0, 0 ZYDIS_NOTMIN(0x1), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_X87_ALU) ZYDIS_NOTMIN(ZYDIS_ISA_SET_X87) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_X87) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_WRITE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_FRSTOR ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(1) ZYDIS_NOTMIN(0x1B91), 0, 0 ZYDIS_NOTMIN(0x1), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_X87_ALU) ZYDIS_NOTMIN(ZYDIS_ISA_SET_X87) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_X87) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_WRITE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_FSCALE ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0) ZYDIS_NOTMIN(0xE9A), 0, 0 ZYDIS_NOTMIN(0x3), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_X87_ALU) ZYDIS_NOTMIN(ZYDIS_ISA_SET_X87) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_X87) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, 0 ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_FSETPM287_NOP ZYDIS_NOTMIN(0) ZYDIS_NOTMIN(0) ZYDIS_NOTMIN(0x0), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_X87_ALU) ZYDIS_NOTMIN(ZYDIS_ISA_SET_X87) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_X87) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, 0 ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_FSIN ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0) ZYDIS_NOTMIN(0xE53), 0, 0 ZYDIS_NOTMIN(0x2), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_X87_ALU) ZYDIS_NOTMIN(ZYDIS_ISA_SET_X87) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_X87) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, 0 ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_FSINCOS ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0) ZYDIS_NOTMIN(0xE9D), 0, 0 ZYDIS_NOTMIN(0x2), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_X87_ALU) ZYDIS_NOTMIN(ZYDIS_ISA_SET_X87) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_X87) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, 0 ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_FSQRT ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0) ZYDIS_NOTMIN(0xE53), 0, 0 ZYDIS_NOTMIN(0x3), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_X87_ALU) ZYDIS_NOTMIN(ZYDIS_ISA_SET_X87) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_X87) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, 0 ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_FST ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(1) ZYDIS_NOTMIN(0xEA0), 0, 0 ZYDIS_NOTMIN(0x3), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_X87_ALU) ZYDIS_NOTMIN(ZYDIS_ISA_SET_X87) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_X87) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_FST ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(1) ZYDIS_NOTMIN(0xEA3), 0, 0 ZYDIS_NOTMIN(0x3), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_X87_ALU) ZYDIS_NOTMIN(ZYDIS_ISA_SET_X87) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_X87) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, ZYDIS_REGKIND_X87 ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_FST ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(1) ZYDIS_NOTMIN(0xEA6), 0, 0 ZYDIS_NOTMIN(0x3), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_X87_ALU) ZYDIS_NOTMIN(ZYDIS_ISA_SET_X87) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_X87) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_FSTP ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(1) ZYDIS_NOTMIN(0xEA0), 0, 0 ZYDIS_NOTMIN(0x3), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_X87_ALU) ZYDIS_NOTMIN(ZYDIS_ISA_SET_X87) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_X87) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_FSTP ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(1) ZYDIS_NOTMIN(0xEA9), 0, 0 ZYDIS_NOTMIN(0x3), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_X87_ALU) ZYDIS_NOTMIN(ZYDIS_ISA_SET_X87) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_X87) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_FSTP ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(1) ZYDIS_NOTMIN(0xEA3), 0, 0 ZYDIS_NOTMIN(0x3), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_X87_ALU) ZYDIS_NOTMIN(ZYDIS_ISA_SET_X87) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_X87) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, ZYDIS_REGKIND_X87 ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_FSTP ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(1) ZYDIS_NOTMIN(0xEA6), 0, 0 ZYDIS_NOTMIN(0x3), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_X87_ALU) ZYDIS_NOTMIN(ZYDIS_ISA_SET_X87) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_X87) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_FSTP ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(1) ZYDIS_NOTMIN(0xEA3), 0, 0 ZYDIS_NOTMIN(0x3), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_X87_ALU) ZYDIS_NOTMIN(ZYDIS_ISA_SET_X87) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_X87) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, ZYDIS_REGKIND_X87 ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_FSTP ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(1) ZYDIS_NOTMIN(0xEA3), 0, 0 ZYDIS_NOTMIN(0x3), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_X87_ALU) ZYDIS_NOTMIN(ZYDIS_ISA_SET_X87) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_X87) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, ZYDIS_REGKIND_X87 ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_FSTPNCE ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(1) ZYDIS_NOTMIN(0xEA3), 0, 0 ZYDIS_NOTMIN(0x3), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_X87_ALU) ZYDIS_NOTMIN(ZYDIS_ISA_SET_X87) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_X87) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, ZYDIS_REGKIND_X87 ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_FSUB ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xE4F), 0, 0 ZYDIS_NOTMIN(0x3), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_X87_ALU) ZYDIS_NOTMIN(ZYDIS_ISA_SET_X87) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_X87) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, ZYDIS_REGKIND_X87 ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_FSUB ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(1) ZYDIS_NOTMIN(0xE52), 0, 0 ZYDIS_NOTMIN(0x3), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_X87_ALU) ZYDIS_NOTMIN(ZYDIS_ISA_SET_X87) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_X87) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_FSUB ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xE55), 0, 0 ZYDIS_NOTMIN(0x3), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_X87_ALU) ZYDIS_NOTMIN(ZYDIS_ISA_SET_X87) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_X87) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, ZYDIS_REGKIND_X87 ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_FSUB ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(1) ZYDIS_NOTMIN(0xE58), 0, 0 ZYDIS_NOTMIN(0x3), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_X87_ALU) ZYDIS_NOTMIN(ZYDIS_ISA_SET_X87) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_X87) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_FSUBP ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xE55), 0, 0 ZYDIS_NOTMIN(0x3), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_X87_ALU) ZYDIS_NOTMIN(ZYDIS_ISA_SET_X87) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_X87) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, ZYDIS_REGKIND_X87 ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_FSUBR ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xE4F), 0, 0 ZYDIS_NOTMIN(0x3), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_X87_ALU) ZYDIS_NOTMIN(ZYDIS_ISA_SET_X87) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_X87) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, ZYDIS_REGKIND_X87 ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_FSUBR ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(1) ZYDIS_NOTMIN(0xE52), 0, 0 ZYDIS_NOTMIN(0x3), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_X87_ALU) ZYDIS_NOTMIN(ZYDIS_ISA_SET_X87) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_X87) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_FSUBR ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xE55), 0, 0 ZYDIS_NOTMIN(0x3), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_X87_ALU) ZYDIS_NOTMIN(ZYDIS_ISA_SET_X87) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_X87) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, ZYDIS_REGKIND_X87 ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_FSUBR ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(1) ZYDIS_NOTMIN(0xE58), 0, 0 ZYDIS_NOTMIN(0x3), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_X87_ALU) ZYDIS_NOTMIN(ZYDIS_ISA_SET_X87) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_X87) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_FSUBRP ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xE55), 0, 0 ZYDIS_NOTMIN(0x3), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_X87_ALU) ZYDIS_NOTMIN(ZYDIS_ISA_SET_X87) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_X87) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, ZYDIS_REGKIND_X87 ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_FTST ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0) ZYDIS_NOTMIN(0xE53), 0, 0 ZYDIS_NOTMIN(0x1), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_X87_ALU) ZYDIS_NOTMIN(ZYDIS_ISA_SET_X87) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_X87) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, 0 ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_FUCOM ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(1) ZYDIS_NOTMIN(0xE61), 0, 0 ZYDIS_NOTMIN(0x1), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_X87_ALU) ZYDIS_NOTMIN(ZYDIS_ISA_SET_X87) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_X87) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, ZYDIS_REGKIND_X87 ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_FUCOMI ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x590), 0, 0 ZYDIS_NOTMIN(0x34), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_X87_ALU) ZYDIS_NOTMIN(ZYDIS_ISA_SET_FCOMI) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_X87) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, ZYDIS_REGKIND_X87 ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_FUCOMIP ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x590), 0, 0 ZYDIS_NOTMIN(0x34), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_X87_ALU) ZYDIS_NOTMIN(ZYDIS_ISA_SET_FCOMI) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_X87) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, ZYDIS_REGKIND_X87 ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_FUCOMP ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xEAC), 0, 0 ZYDIS_NOTMIN(0x1), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_X87_ALU) ZYDIS_NOTMIN(ZYDIS_ISA_SET_X87) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_X87) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, ZYDIS_REGKIND_X87 ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_FUCOMPP ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0) ZYDIS_NOTMIN(0xE6A), 0, 0 ZYDIS_NOTMIN(0x1), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_X87_ALU) ZYDIS_NOTMIN(ZYDIS_ISA_SET_X87) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_X87) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, 0 ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_FWAIT ZYDIS_NOTMIN(0) ZYDIS_NOTMIN(0) ZYDIS_NOTMIN(0x0), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_X87_ALU) ZYDIS_NOTMIN(ZYDIS_ISA_SET_X87) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_X87) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, 0 ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_FXAM ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0) ZYDIS_NOTMIN(0xE53), 0, 0 ZYDIS_NOTMIN(0x1), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_X87_ALU) ZYDIS_NOTMIN(ZYDIS_ISA_SET_X87) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_X87) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, 0 ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_FXCH ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(1) ZYDIS_NOTMIN(0xEAF), 0, 0 ZYDIS_NOTMIN(0x3), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_X87_ALU) ZYDIS_NOTMIN(ZYDIS_ISA_SET_X87) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_X87) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, ZYDIS_REGKIND_X87 ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_FXCH ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(1) ZYDIS_NOTMIN(0xEAF), 0, 0 ZYDIS_NOTMIN(0x3), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_X87_ALU) ZYDIS_NOTMIN(ZYDIS_ISA_SET_X87) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_X87) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, ZYDIS_REGKIND_X87 ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_FXCH ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(1) ZYDIS_NOTMIN(0xEAF), 0, 0 ZYDIS_NOTMIN(0x3), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_X87_ALU) ZYDIS_NOTMIN(ZYDIS_ISA_SET_X87) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_X87) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, ZYDIS_REGKIND_X87 ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_FXRSTOR ZYDIS_NOTMIN(1) ZYDIS_NOTMIN(1) ZYDIS_NOTMIN(0x1EFF), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_SSE) ZYDIS_NOTMIN(ZYDIS_ISA_SET_FXSAVE) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_SSE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_WRITE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_WRITE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_FXRSTOR64 ZYDIS_NOTMIN(1) ZYDIS_NOTMIN(1) ZYDIS_NOTMIN(0x1EFF), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_SSE) ZYDIS_NOTMIN(ZYDIS_ISA_SET_FXSAVE64) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_SSE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_WRITE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_WRITE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_FXSAVE ZYDIS_NOTMIN(1) ZYDIS_NOTMIN(1) ZYDIS_NOTMIN(0x1F00), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_SSE) ZYDIS_NOTMIN(ZYDIS_ISA_SET_FXSAVE) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_SSE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_READ) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_READ) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_FXSAVE64 ZYDIS_NOTMIN(1) ZYDIS_NOTMIN(1) ZYDIS_NOTMIN(0x1F00), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_SSE) ZYDIS_NOTMIN(ZYDIS_ISA_SET_FXSAVE64) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_SSE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_READ) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_READ) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_FXTRACT ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0) ZYDIS_NOTMIN(0xE9D), 0, 0 ZYDIS_NOTMIN(0x3), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_X87_ALU) ZYDIS_NOTMIN(ZYDIS_ISA_SET_X87) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_X87) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, 0 ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_FYL2X ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0) ZYDIS_NOTMIN(0xE97), 0, 0 ZYDIS_NOTMIN(0x3), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_X87_ALU) ZYDIS_NOTMIN(ZYDIS_ISA_SET_X87) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_X87) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, 0 ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_FYL2XP1 ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0) ZYDIS_NOTMIN(0xE97), 0, 0 ZYDIS_NOTMIN(0x3), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_X87_ALU) ZYDIS_NOTMIN(ZYDIS_ISA_SET_X87) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_X87) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, 0 ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_GETSEC ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0) ZYDIS_NOTMIN(0x1B93), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_TRUE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_SYSTEM) ZYDIS_NOTMIN(ZYDIS_ISA_SET_SMX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_SMX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, 0 ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_GF2P8AFFINEINVQB ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0xEB2), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_GFNI) ZYDIS_NOTMIN(ZYDIS_ISA_SET_GFNI) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_GFNI) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_SSE4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_GF2P8AFFINEINVQB ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0xEB5), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_GFNI) ZYDIS_NOTMIN(ZYDIS_ISA_SET_GFNI) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_GFNI) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_SSE4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_GF2P8AFFINEQB ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0xEB2), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_GFNI) ZYDIS_NOTMIN(ZYDIS_ISA_SET_GFNI) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_GFNI) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_SSE4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_GF2P8AFFINEQB ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0xEB5), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_GFNI) ZYDIS_NOTMIN(ZYDIS_ISA_SET_GFNI) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_GFNI) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_SSE4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_GF2P8MULB ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xF39), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_GFNI) ZYDIS_NOTMIN(ZYDIS_ISA_SET_GFNI) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_GFNI) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_SSE4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_GF2P8MULB ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xF3C), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_GFNI) ZYDIS_NOTMIN(ZYDIS_ISA_SET_GFNI) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_GFNI) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_SSE4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_HADDPD ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xDB9), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_SSE) ZYDIS_NOTMIN(ZYDIS_ISA_SET_SSE3) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_SSE3) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_SSE2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_HADDPD ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xDBC), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_SSE) ZYDIS_NOTMIN(ZYDIS_ISA_SET_SSE3) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_SSE3) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_SSE2), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_HADDPS ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xDBF), 2, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_SSE) ZYDIS_NOTMIN(ZYDIS_ISA_SET_SSE3) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_SSE3) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_SSE2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_HADDPS ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xDC2), 2, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_SSE) ZYDIS_NOTMIN(ZYDIS_ISA_SET_SSE3) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_SSE3) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_SSE2), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_HLT ZYDIS_NOTMIN(0) ZYDIS_NOTMIN(0) ZYDIS_NOTMIN(0x0), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_SYSTEM) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I86) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, 0 ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_HRESET ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(1) ZYDIS_NOTMIN(0x1B95), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_HRESET) ZYDIS_NOTMIN(ZYDIS_ISA_SET_HRESET) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_HRESET) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, 0 ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_HSUBPD ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xDB9), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_SSE) ZYDIS_NOTMIN(ZYDIS_ISA_SET_SSE3) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_SSE3) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_SSE2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_HSUBPD ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xDBC), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_SSE) ZYDIS_NOTMIN(ZYDIS_ISA_SET_SSE3) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_SSE3) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_SSE2), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_HSUBPS ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xDBF), 2, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_SSE) ZYDIS_NOTMIN(ZYDIS_ISA_SET_SSE3) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_SSE3) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_SSE2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_HSUBPS ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xDC2), 2, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_SSE) ZYDIS_NOTMIN(ZYDIS_ISA_SET_SSE3) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_SSE3) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_SSE2), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_IDIV ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(1) ZYDIS_NOTMIN(0xEB8), 1, 0 ZYDIS_NOTMIN(0x48), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_BINARY) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I86) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, ZYDIS_REGKIND_GPR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_IDIV ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(1) ZYDIS_NOTMIN(0xEBB), 1, 0 ZYDIS_NOTMIN(0x48), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_BINARY) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I86) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_IDIV ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(1) ZYDIS_NOTMIN(0x594), 0, 0 ZYDIS_NOTMIN(0x48), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_BINARY) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I86) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, ZYDIS_REGKIND_GPR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_IDIV ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(1) ZYDIS_NOTMIN(0x598), 0, 0 ZYDIS_NOTMIN(0x48), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_BINARY) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I86) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_IMUL ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x59C), 0, 0 ZYDIS_NOTMIN(0x3E), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_BINARY) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I186) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_GPR, ZYDIS_REGKIND_GPR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_IMUL ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x5A0), 0, 0 ZYDIS_NOTMIN(0x3E), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_BINARY) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I186) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_GPR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_IMUL ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x5A4), 0, 0 ZYDIS_NOTMIN(0x3E), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_BINARY) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I186) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_GPR, ZYDIS_REGKIND_GPR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_IMUL ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x5A8), 0, 0 ZYDIS_NOTMIN(0x3E), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_BINARY) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I186) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_GPR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_IMUL ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(1) ZYDIS_NOTMIN(0x5AC), 1, 0 ZYDIS_NOTMIN(0x3E), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_BINARY) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I86) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, ZYDIS_REGKIND_GPR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_IMUL ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(1) ZYDIS_NOTMIN(0x5B0), 1, 0 ZYDIS_NOTMIN(0x3E), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_BINARY) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I86) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_IMUL ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(1) ZYDIS_NOTMIN(0x5B4), 0, 0 ZYDIS_NOTMIN(0x3E), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_BINARY) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I86) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, ZYDIS_REGKIND_GPR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_IMUL ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(1) ZYDIS_NOTMIN(0x5B8), 0, 0 ZYDIS_NOTMIN(0x3E), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_BINARY) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I86) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_IMUL ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xD89), 0, 0 ZYDIS_NOTMIN(0x3E), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_BINARY) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I86) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_GPR, ZYDIS_REGKIND_GPR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_IMUL ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xD8C), 0, 0 ZYDIS_NOTMIN(0x3E), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_BINARY) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I86) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_GPR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_IN ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xEBE), 1, 0 ZYDIS_NOTMIN(0x7), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_IO) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I86) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, 0 ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_IN ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xEC1), 3, 0 ZYDIS_NOTMIN(0x7), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_IO) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I86) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, 0 ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_IN ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xEC4), 3, 0 ZYDIS_NOTMIN(0x7), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_IO) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I86) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, 0 ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_IN ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xEC7), 1, 0 ZYDIS_NOTMIN(0x7), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_IO) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I86) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, 0 ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_IN ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xECA), 3, 0 ZYDIS_NOTMIN(0x7), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_IO) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I86) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, 0 ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_IN ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xECD), 3, 0 ZYDIS_NOTMIN(0x7), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_IO) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I86) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, 0 ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_INC ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(1) ZYDIS_NOTMIN(0x1B71), 0, 0 ZYDIS_NOTMIN(0x1A), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_BINARY) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I86) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, 0 ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_INC ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(1) ZYDIS_NOTMIN(0x1B73), 1, 0 ZYDIS_NOTMIN(0x1A), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_BINARY) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I86) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, ZYDIS_REGKIND_GPR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_INC ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(1) ZYDIS_NOTMIN(0x1B75), 1, 0 ZYDIS_NOTMIN(0x1A), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_BINARY) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I86) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_TRUE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_INC ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(1) ZYDIS_NOTMIN(0x1B77), 0, 0 ZYDIS_NOTMIN(0x1A), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_BINARY) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I86) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, ZYDIS_REGKIND_GPR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_INC ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(1) ZYDIS_NOTMIN(0x1B79), 0, 0 ZYDIS_NOTMIN(0x1A), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_BINARY) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I86) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_TRUE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_INCSSPD ZYDIS_NOTMIN(1) ZYDIS_NOTMIN(1) ZYDIS_NOTMIN(0x15), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_TRUE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CET) ZYDIS_NOTMIN(ZYDIS_ISA_SET_CET) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_CET) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, ZYDIS_REGKIND_GPR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_INCSSPQ ZYDIS_NOTMIN(1) ZYDIS_NOTMIN(1) ZYDIS_NOTMIN(0x1F01), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CET) ZYDIS_NOTMIN(ZYDIS_ISA_SET_CET) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_CET) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, ZYDIS_REGKIND_GPR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_INSB ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0) ZYDIS_NOTMIN(0xED0), 1, 0 ZYDIS_NOTMIN(0xB), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_IOSTRINGOP) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I186) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, 0 ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_INSB ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0) ZYDIS_NOTMIN(0x5BC), 1, 0 ZYDIS_NOTMIN(0xB), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_IOSTRINGOP) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I186) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, 0 ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_INSB ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0) ZYDIS_NOTMIN(0x5BC), 1, 0 ZYDIS_NOTMIN(0xB), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_IOSTRINGOP) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I186) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, 0 ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_INSD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0) ZYDIS_NOTMIN(0xED3), 0, 0 ZYDIS_NOTMIN(0xB), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_IOSTRINGOP) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I386) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, 0 ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_INSD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0) ZYDIS_NOTMIN(0xED3), 0, 0 ZYDIS_NOTMIN(0xB), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_IOSTRINGOP) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I386) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, 0 ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_INSD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0) ZYDIS_NOTMIN(0x5C0), 0, 0 ZYDIS_NOTMIN(0xB), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_IOSTRINGOP) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I386) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, 0 ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_INSD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0) ZYDIS_NOTMIN(0x5C0), 0, 0 ZYDIS_NOTMIN(0xB), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_IOSTRINGOP) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I386) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, 0 ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_INSD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0) ZYDIS_NOTMIN(0x5C0), 0, 0 ZYDIS_NOTMIN(0xB), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_IOSTRINGOP) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I386) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, 0 ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_INSD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0) ZYDIS_NOTMIN(0x5C0), 0, 0 ZYDIS_NOTMIN(0xB), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_IOSTRINGOP) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I386) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, 0 ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_INSERTPS ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0xDBF), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_SSE) ZYDIS_NOTMIN(ZYDIS_ISA_SET_SSE4) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_SSE4) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_SSE5), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_INSERTPS ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0xED6), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_SSE) ZYDIS_NOTMIN(ZYDIS_ISA_SET_SSE4) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_SSE4) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_SSE5), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_INSERTQ ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x5C4), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_BITBYTE) ZYDIS_NOTMIN(ZYDIS_ISA_SET_SSE4A) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_SSE4A) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_INSERTQ ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1B7B), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_BITBYTE) ZYDIS_NOTMIN(ZYDIS_ISA_SET_SSE4A) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_SSE4A) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_INSW ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0) ZYDIS_NOTMIN(0xED9), 0, 0 ZYDIS_NOTMIN(0xB), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_IOSTRINGOP) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I186) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, 0 ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_INSW ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0) ZYDIS_NOTMIN(0x5C8), 0, 0 ZYDIS_NOTMIN(0xB), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_IOSTRINGOP) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I186) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, 0 ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_INSW ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0) ZYDIS_NOTMIN(0x5C8), 0, 0 ZYDIS_NOTMIN(0xB), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_IOSTRINGOP) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I186) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, 0 ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_INT ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(1) ZYDIS_NOTMIN(0xEDC), 0, 0 ZYDIS_NOTMIN(0x11), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_INTERRUPT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I86) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, 0 ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_INT1 ZYDIS_NOTMIN(1) ZYDIS_NOTMIN(0) ZYDIS_NOTMIN(0xC7), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_INTERRUPT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I86) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, 0 ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_INT3 ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0) ZYDIS_NOTMIN(0xEDD), 0, 0 ZYDIS_NOTMIN(0x11), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_INTERRUPT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I86) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, 0 ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_INTO ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0) ZYDIS_NOTMIN(0x1B97), 0, 0 ZYDIS_NOTMIN(0x10), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_INTERRUPT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I86) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, 0 ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_INVD ZYDIS_NOTMIN(0) ZYDIS_NOTMIN(0) ZYDIS_NOTMIN(0x0), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_SYSTEM) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I486REAL) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, 0 ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_INVEPT ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xEDF), 7, 0 ZYDIS_NOTMIN(0x37), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VTX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_VTX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_VTX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_GPR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_INVEPT ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xEE2), 7, 0 ZYDIS_NOTMIN(0x37), ZYAN_TRUE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VTX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_VTX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_VTX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_GPR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_INVLPG ZYDIS_NOTMIN(1) ZYDIS_NOTMIN(1) ZYDIS_NOTMIN(0x5EC), 1, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_SYSTEM) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I486REAL) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_INVLPGA ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1B99), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_TRUE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_SYSTEM) ZYDIS_NOTMIN(ZYDIS_ISA_SET_SVM) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_SVM) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, 0 ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_INVLPGB ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0xEE5), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_SYSTEM) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AMD_INVLPGB) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AMD_INVLPGB) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, 0 ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_INVPCID ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xEDF), 7, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_MISC) ZYDIS_NOTMIN(ZYDIS_ISA_SET_INVPCID) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_INVPCID) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_GPR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_INVPCID ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xEE2), 7, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_MISC) ZYDIS_NOTMIN(ZYDIS_ISA_SET_INVPCID) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_INVPCID) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_GPR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_INVVPID ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xEDF), 7, 0 ZYDIS_NOTMIN(0x37), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VTX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_VTX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_VTX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_GPR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_INVVPID ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xEE2), 7, 0 ZYDIS_NOTMIN(0x37), ZYAN_TRUE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VTX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_VTX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_VTX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_GPR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_IRET ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0) ZYDIS_NOTMIN(0x5CC), 0, 0 ZYDIS_NOTMIN(0x2D), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_RET) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I86) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, 0 ZYDIS_NOTMIN(ZYDIS_RW_ACTION_READWRITE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_IRETD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0) ZYDIS_NOTMIN(0x5CC), 0, 0 ZYDIS_NOTMIN(0x2D), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_RET) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I386) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, 0 ZYDIS_NOTMIN(ZYDIS_RW_ACTION_READWRITE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_IRETQ ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0) ZYDIS_NOTMIN(0x5D0), 0, 0 ZYDIS_NOTMIN(0x2D), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_RET) ZYDIS_NOTMIN(ZYDIS_ISA_SET_LONGMODE) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_LONGMODE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, 0 ZYDIS_NOTMIN(ZYDIS_RW_ACTION_READWRITE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_JB ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(1) ZYDIS_NOTMIN(0xEE8), 5, 0 ZYDIS_NOTMIN(0x1B), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_COND_BR) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I86) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_SHORT) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, 0 ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_TRUE) },
    { ZYDIS_MNEMONIC_JB ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(1) ZYDIS_NOTMIN(0xEEB), 0, 0 ZYDIS_NOTMIN(0x1B), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_COND_BR) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I86) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_SHORT) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, 0 ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_TRUE) },
    { ZYDIS_MNEMONIC_JB ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(1) ZYDIS_NOTMIN(0xEEE), 5, 0 ZYDIS_NOTMIN(0x1B), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_COND_BR) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I86) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NEAR) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, 0 ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_TRUE) },
    { ZYDIS_MNEMONIC_JB ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(1) ZYDIS_NOTMIN(0xEF1), 4, 0 ZYDIS_NOTMIN(0x1B), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_COND_BR) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I86) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NEAR) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, 0 ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_TRUE) },
    { ZYDIS_MNEMONIC_JB ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(1) ZYDIS_NOTMIN(0xEF4), 0, 0 ZYDIS_NOTMIN(0x1B), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_COND_BR) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I86) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NEAR) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, 0 ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_TRUE) },
    { ZYDIS_MNEMONIC_JBE ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(1) ZYDIS_NOTMIN(0xEE8), 5, 0 ZYDIS_NOTMIN(0x1D), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_COND_BR) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I86) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_SHORT) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, 0 ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_TRUE) },
    { ZYDIS_MNEMONIC_JBE ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(1) ZYDIS_NOTMIN(0xEEB), 0, 0 ZYDIS_NOTMIN(0x1D), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_COND_BR) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I86) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_SHORT) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, 0 ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_TRUE) },
    { ZYDIS_MNEMONIC_JBE ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(1) ZYDIS_NOTMIN(0xEEE), 5, 0 ZYDIS_NOTMIN(0x1D), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_COND_BR) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I86) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NEAR) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, 0 ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_TRUE) },
    { ZYDIS_MNEMONIC_JBE ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(1) ZYDIS_NOTMIN(0xEF1), 4, 0 ZYDIS_NOTMIN(0x1D), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_COND_BR) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I86) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NEAR) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, 0 ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_TRUE) },
    { ZYDIS_MNEMONIC_JBE ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(1) ZYDIS_NOTMIN(0xEF4), 0, 0 ZYDIS_NOTMIN(0x1D), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_COND_BR) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I86) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NEAR) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, 0 ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_TRUE) },
    { ZYDIS_MNEMONIC_JCXZ ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(1) ZYDIS_NOTMIN(0xEF7), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_COND_BR) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I386) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_SHORT) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, 0 ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_JECXZ ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(1) ZYDIS_NOTMIN(0xEFA), 5, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_COND_BR) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I386) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_SHORT) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, 0 ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_JECXZ ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(1) ZYDIS_NOTMIN(0xEFD), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_COND_BR) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I386) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_SHORT) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, 0 ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_JL ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(1) ZYDIS_NOTMIN(0xEE8), 5, 0 ZYDIS_NOTMIN(0x13), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_COND_BR) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I86) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_SHORT) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, 0 ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_TRUE) },
    { ZYDIS_MNEMONIC_JL ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(1) ZYDIS_NOTMIN(0xEEB), 0, 0 ZYDIS_NOTMIN(0x13), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_COND_BR) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I86) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_SHORT) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, 0 ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_TRUE) },
    { ZYDIS_MNEMONIC_JL ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(1) ZYDIS_NOTMIN(0xEEE), 5, 0 ZYDIS_NOTMIN(0x13), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_COND_BR) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I86) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NEAR) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, 0 ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_TRUE) },
    { ZYDIS_MNEMONIC_JL ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(1) ZYDIS_NOTMIN(0xEF1), 4, 0 ZYDIS_NOTMIN(0x13), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_COND_BR) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I86) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NEAR) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, 0 ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_TRUE) },
    { ZYDIS_MNEMONIC_JL ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(1) ZYDIS_NOTMIN(0xEF4), 0, 0 ZYDIS_NOTMIN(0x13), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_COND_BR) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I86) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NEAR) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, 0 ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_TRUE) },
    { ZYDIS_MNEMONIC_JLE ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(1) ZYDIS_NOTMIN(0xEE8), 5, 0 ZYDIS_NOTMIN(0x16), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_COND_BR) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I86) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_SHORT) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, 0 ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_TRUE) },
    { ZYDIS_MNEMONIC_JLE ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(1) ZYDIS_NOTMIN(0xEEB), 0, 0 ZYDIS_NOTMIN(0x16), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_COND_BR) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I86) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_SHORT) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, 0 ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_TRUE) },
    { ZYDIS_MNEMONIC_JLE ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(1) ZYDIS_NOTMIN(0xEEE), 5, 0 ZYDIS_NOTMIN(0x16), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_COND_BR) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I86) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NEAR) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, 0 ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_TRUE) },
    { ZYDIS_MNEMONIC_JLE ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(1) ZYDIS_NOTMIN(0xEF1), 4, 0 ZYDIS_NOTMIN(0x16), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_COND_BR) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I86) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NEAR) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, 0 ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_TRUE) },
    { ZYDIS_MNEMONIC_JLE ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(1) ZYDIS_NOTMIN(0xEF4), 0, 0 ZYDIS_NOTMIN(0x16), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_COND_BR) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I86) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NEAR) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, 0 ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_TRUE) },
    { ZYDIS_MNEMONIC_JMP ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(1) ZYDIS_NOTMIN(0x538), 5, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_UNCOND_BR) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I86) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NEAR) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, 0 ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_JMP ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(1) ZYDIS_NOTMIN(0x53C), 4, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_UNCOND_BR) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I86) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NEAR) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, 0 ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_JMP ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(1) ZYDIS_NOTMIN(0x540), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_UNCOND_BR) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I86) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NEAR) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, 0 ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_JMP ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(1) ZYDIS_NOTMIN(0x534), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_UNCOND_BR) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I86) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_FAR) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, 0 ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_JMP ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(1) ZYDIS_NOTMIN(0xEE8), 5, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_UNCOND_BR) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I86) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_SHORT) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, 0 ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_JMP ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(1) ZYDIS_NOTMIN(0xEEB), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_UNCOND_BR) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I86) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_SHORT) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, 0 ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_JMP ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(1) ZYDIS_NOTMIN(0x1B9B), 5, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_UNCOND_BR) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I86) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NEAR) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, ZYDIS_REGKIND_GPR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_JMP ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(1) ZYDIS_NOTMIN(0x1B9D), 5, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_UNCOND_BR) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I86) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NEAR) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_JMP ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(1) ZYDIS_NOTMIN(0x54C), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_UNCOND_BR) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I86) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_FAR) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_JNB ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(1) ZYDIS_NOTMIN(0xEE8), 5, 0 ZYDIS_NOTMIN(0x1B), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_COND_BR) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I86) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_SHORT) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, 0 ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_TRUE) },
    { ZYDIS_MNEMONIC_JNB ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(1) ZYDIS_NOTMIN(0xEEB), 0, 0 ZYDIS_NOTMIN(0x1B), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_COND_BR) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I86) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_SHORT) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, 0 ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_TRUE) },
    { ZYDIS_MNEMONIC_JNB ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(1) ZYDIS_NOTMIN(0xEEE), 5, 0 ZYDIS_NOTMIN(0x1B), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_COND_BR) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I86) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NEAR) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, 0 ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_TRUE) },
    { ZYDIS_MNEMONIC_JNB ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(1) ZYDIS_NOTMIN(0xEF1), 4, 0 ZYDIS_NOTMIN(0x1B), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_COND_BR) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I86) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NEAR) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, 0 ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_TRUE) },
    { ZYDIS_MNEMONIC_JNB ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(1) ZYDIS_NOTMIN(0xEF4), 0, 0 ZYDIS_NOTMIN(0x1B), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_COND_BR) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I86) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NEAR) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, 0 ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_TRUE) },
    { ZYDIS_MNEMONIC_JNBE ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(1) ZYDIS_NOTMIN(0xEE8), 5, 0 ZYDIS_NOTMIN(0x1D), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_COND_BR) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I86) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_SHORT) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, 0 ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_TRUE) },
    { ZYDIS_MNEMONIC_JNBE ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(1) ZYDIS_NOTMIN(0xEEB), 0, 0 ZYDIS_NOTMIN(0x1D), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_COND_BR) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I86) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_SHORT) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, 0 ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_TRUE) },
    { ZYDIS_MNEMONIC_JNBE ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(1) ZYDIS_NOTMIN(0xEEE), 5, 0 ZYDIS_NOTMIN(0x1D), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_COND_BR) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I86) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NEAR) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, 0 ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_TRUE) },
    { ZYDIS_MNEMONIC_JNBE ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(1) ZYDIS_NOTMIN(0xEF1), 4, 0 ZYDIS_NOTMIN(0x1D), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_COND_BR) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I86) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NEAR) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, 0 ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_TRUE) },
    { ZYDIS_MNEMONIC_JNBE ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(1) ZYDIS_NOTMIN(0xEF4), 0, 0 ZYDIS_NOTMIN(0x1D), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_COND_BR) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I86) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NEAR) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, 0 ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_TRUE) },
    { ZYDIS_MNEMONIC_JNL ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(1) ZYDIS_NOTMIN(0xEE8), 5, 0 ZYDIS_NOTMIN(0x13), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_COND_BR) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I86) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_SHORT) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, 0 ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_TRUE) },
    { ZYDIS_MNEMONIC_JNL ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(1) ZYDIS_NOTMIN(0xEEB), 0, 0 ZYDIS_NOTMIN(0x13), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_COND_BR) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I86) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_SHORT) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, 0 ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_TRUE) },
    { ZYDIS_MNEMONIC_JNL ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(1) ZYDIS_NOTMIN(0xEEE), 5, 0 ZYDIS_NOTMIN(0x13), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_COND_BR) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I86) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NEAR) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, 0 ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_TRUE) },
    { ZYDIS_MNEMONIC_JNL ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(1) ZYDIS_NOTMIN(0xEF1), 4, 0 ZYDIS_NOTMIN(0x13), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_COND_BR) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I86) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NEAR) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, 0 ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_TRUE) },
    { ZYDIS_MNEMONIC_JNL ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(1) ZYDIS_NOTMIN(0xEF4), 0, 0 ZYDIS_NOTMIN(0x13), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_COND_BR) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I86) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NEAR) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, 0 ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_TRUE) },
    { ZYDIS_MNEMONIC_JNLE ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(1) ZYDIS_NOTMIN(0xEE8), 5, 0 ZYDIS_NOTMIN(0x16), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_COND_BR) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I86) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_SHORT) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, 0 ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_TRUE) },
    { ZYDIS_MNEMONIC_JNLE ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(1) ZYDIS_NOTMIN(0xEEB), 0, 0 ZYDIS_NOTMIN(0x16), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_COND_BR) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I86) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_SHORT) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, 0 ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_TRUE) },
    { ZYDIS_MNEMONIC_JNLE ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(1) ZYDIS_NOTMIN(0xEEE), 5, 0 ZYDIS_NOTMIN(0x16), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_COND_BR) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I86) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NEAR) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, 0 ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_TRUE) },
    { ZYDIS_MNEMONIC_JNLE ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(1) ZYDIS_NOTMIN(0xEF1), 4, 0 ZYDIS_NOTMIN(0x16), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_COND_BR) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I86) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NEAR) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, 0 ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_TRUE) },
    { ZYDIS_MNEMONIC_JNLE ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(1) ZYDIS_NOTMIN(0xEF4), 0, 0 ZYDIS_NOTMIN(0x16), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_COND_BR) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I86) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NEAR) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, 0 ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_TRUE) },
    { ZYDIS_MNEMONIC_JNO ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(1) ZYDIS_NOTMIN(0xEE8), 5, 0 ZYDIS_NOTMIN(0x8), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_COND_BR) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I86) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_SHORT) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, 0 ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_TRUE) },
    { ZYDIS_MNEMONIC_JNO ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(1) ZYDIS_NOTMIN(0xEEB), 0, 0 ZYDIS_NOTMIN(0x8), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_COND_BR) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I86) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_SHORT) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, 0 ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_TRUE) },
    { ZYDIS_MNEMONIC_JNO ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(1) ZYDIS_NOTMIN(0xEEE), 5, 0 ZYDIS_NOTMIN(0x8), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_COND_BR) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I86) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NEAR) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, 0 ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_TRUE) },
    { ZYDIS_MNEMONIC_JNO ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(1) ZYDIS_NOTMIN(0xEF1), 4, 0 ZYDIS_NOTMIN(0x8), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_COND_BR) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I86) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NEAR) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, 0 ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_TRUE) },
    { ZYDIS_MNEMONIC_JNO ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(1) ZYDIS_NOTMIN(0xEF4), 0, 0 ZYDIS_NOTMIN(0x8), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_COND_BR) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I86) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NEAR) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, 0 ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_TRUE) },
    { ZYDIS_MNEMONIC_JNP ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(1) ZYDIS_NOTMIN(0xEE8), 5, 0 ZYDIS_NOTMIN(0x18), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_COND_BR) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I86) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_SHORT) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, 0 ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_TRUE) },
    { ZYDIS_MNEMONIC_JNP ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(1) ZYDIS_NOTMIN(0xEEB), 0, 0 ZYDIS_NOTMIN(0x18), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_COND_BR) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I86) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_SHORT) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, 0 ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_TRUE) },
    { ZYDIS_MNEMONIC_JNP ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(1) ZYDIS_NOTMIN(0xEEE), 5, 0 ZYDIS_NOTMIN(0x18), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_COND_BR) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I86) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NEAR) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, 0 ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_TRUE) },
    { ZYDIS_MNEMONIC_JNP ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(1) ZYDIS_NOTMIN(0xEF1), 4, 0 ZYDIS_NOTMIN(0x18), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_COND_BR) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I86) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NEAR) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, 0 ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_TRUE) },
    { ZYDIS_MNEMONIC_JNP ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(1) ZYDIS_NOTMIN(0xEF4), 0, 0 ZYDIS_NOTMIN(0x18), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_COND_BR) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I86) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NEAR) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, 0 ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_TRUE) },
    { ZYDIS_MNEMONIC_JNS ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(1) ZYDIS_NOTMIN(0xEE8), 5, 0 ZYDIS_NOTMIN(0x12), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_COND_BR) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I86) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_SHORT) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, 0 ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_TRUE) },
    { ZYDIS_MNEMONIC_JNS ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(1) ZYDIS_NOTMIN(0xEEB), 0, 0 ZYDIS_NOTMIN(0x12), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_COND_BR) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I86) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_SHORT) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, 0 ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_TRUE) },
    { ZYDIS_MNEMONIC_JNS ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(1) ZYDIS_NOTMIN(0xEEE), 5, 0 ZYDIS_NOTMIN(0x12), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_COND_BR) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I86) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NEAR) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, 0 ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_TRUE) },
    { ZYDIS_MNEMONIC_JNS ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(1) ZYDIS_NOTMIN(0xEF1), 4, 0 ZYDIS_NOTMIN(0x12), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_COND_BR) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I86) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NEAR) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, 0 ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_TRUE) },
    { ZYDIS_MNEMONIC_JNS ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(1) ZYDIS_NOTMIN(0xEF4), 0, 0 ZYDIS_NOTMIN(0x12), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_COND_BR) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I86) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NEAR) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, 0 ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_TRUE) },
    { ZYDIS_MNEMONIC_JNZ ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(1) ZYDIS_NOTMIN(0xEE8), 5, 0 ZYDIS_NOTMIN(0x14), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_COND_BR) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I86) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_SHORT) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, 0 ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_TRUE) },
    { ZYDIS_MNEMONIC_JNZ ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(1) ZYDIS_NOTMIN(0xEEB), 0, 0 ZYDIS_NOTMIN(0x14), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_COND_BR) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I86) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_SHORT) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, 0 ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_TRUE) },
    { ZYDIS_MNEMONIC_JNZ ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(1) ZYDIS_NOTMIN(0xEEE), 5, 0 ZYDIS_NOTMIN(0x14), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_COND_BR) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I86) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NEAR) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, 0 ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_TRUE) },
    { ZYDIS_MNEMONIC_JNZ ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(1) ZYDIS_NOTMIN(0xEF1), 4, 0 ZYDIS_NOTMIN(0x14), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_COND_BR) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I86) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NEAR) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, 0 ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_TRUE) },
    { ZYDIS_MNEMONIC_JNZ ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(1) ZYDIS_NOTMIN(0xEF4), 0, 0 ZYDIS_NOTMIN(0x14), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_COND_BR) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I86) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NEAR) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, 0 ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_TRUE) },
    { ZYDIS_MNEMONIC_JO ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(1) ZYDIS_NOTMIN(0xEE8), 5, 0 ZYDIS_NOTMIN(0x8), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_COND_BR) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I86) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_SHORT) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, 0 ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_TRUE) },
    { ZYDIS_MNEMONIC_JO ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(1) ZYDIS_NOTMIN(0xEEB), 0, 0 ZYDIS_NOTMIN(0x8), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_COND_BR) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I86) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_SHORT) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, 0 ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_TRUE) },
    { ZYDIS_MNEMONIC_JO ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(1) ZYDIS_NOTMIN(0xEEE), 5, 0 ZYDIS_NOTMIN(0x8), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_COND_BR) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I86) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NEAR) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, 0 ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_TRUE) },
    { ZYDIS_MNEMONIC_JO ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(1) ZYDIS_NOTMIN(0xEF1), 4, 0 ZYDIS_NOTMIN(0x8), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_COND_BR) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I86) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NEAR) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, 0 ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_TRUE) },
    { ZYDIS_MNEMONIC_JO ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(1) ZYDIS_NOTMIN(0xEF4), 0, 0 ZYDIS_NOTMIN(0x8), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_COND_BR) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I86) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NEAR) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, 0 ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_TRUE) },
    { ZYDIS_MNEMONIC_JP ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(1) ZYDIS_NOTMIN(0xEE8), 5, 0 ZYDIS_NOTMIN(0x18), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_COND_BR) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I86) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_SHORT) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, 0 ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_TRUE) },
    { ZYDIS_MNEMONIC_JP ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(1) ZYDIS_NOTMIN(0xEEB), 0, 0 ZYDIS_NOTMIN(0x18), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_COND_BR) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I86) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_SHORT) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, 0 ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_TRUE) },
    { ZYDIS_MNEMONIC_JP ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(1) ZYDIS_NOTMIN(0xEEE), 5, 0 ZYDIS_NOTMIN(0x18), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_COND_BR) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I86) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NEAR) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, 0 ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_TRUE) },
    { ZYDIS_MNEMONIC_JP ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(1) ZYDIS_NOTMIN(0xEF1), 4, 0 ZYDIS_NOTMIN(0x18), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_COND_BR) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I86) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NEAR) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, 0 ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_TRUE) },
    { ZYDIS_MNEMONIC_JP ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(1) ZYDIS_NOTMIN(0xEF4), 0, 0 ZYDIS_NOTMIN(0x18), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_COND_BR) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I86) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NEAR) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, 0 ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_TRUE) },
    { ZYDIS_MNEMONIC_JRCXZ ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(1) ZYDIS_NOTMIN(0xF00), 5, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_COND_BR) ZYDIS_NOTMIN(ZYDIS_ISA_SET_LONGMODE) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_SHORT) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, 0 ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_JS ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(1) ZYDIS_NOTMIN(0xEE8), 5, 0 ZYDIS_NOTMIN(0x12), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_COND_BR) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I86) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_SHORT) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, 0 ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_TRUE) },
    { ZYDIS_MNEMONIC_JS ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(1) ZYDIS_NOTMIN(0xEEB), 0, 0 ZYDIS_NOTMIN(0x12), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_COND_BR) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I86) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_SHORT) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, 0 ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_TRUE) },
    { ZYDIS_MNEMONIC_JS ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(1) ZYDIS_NOTMIN(0xEEE), 5, 0 ZYDIS_NOTMIN(0x12), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_COND_BR) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I86) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NEAR) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, 0 ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_TRUE) },
    { ZYDIS_MNEMONIC_JS ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(1) ZYDIS_NOTMIN(0xEF1), 4, 0 ZYDIS_NOTMIN(0x12), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_COND_BR) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I86) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NEAR) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, 0 ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_TRUE) },
    { ZYDIS_MNEMONIC_JS ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(1) ZYDIS_NOTMIN(0xEF4), 0, 0 ZYDIS_NOTMIN(0x12), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_COND_BR) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I86) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NEAR) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, 0 ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_TRUE) },
    { ZYDIS_MNEMONIC_JZ ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(1) ZYDIS_NOTMIN(0xEE8), 5, 0 ZYDIS_NOTMIN(0x14), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_COND_BR) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I86) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_SHORT) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, 0 ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_TRUE) },
    { ZYDIS_MNEMONIC_JZ ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(1) ZYDIS_NOTMIN(0xEEB), 0, 0 ZYDIS_NOTMIN(0x14), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_COND_BR) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I86) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_SHORT) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, 0 ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_TRUE) },
    { ZYDIS_MNEMONIC_JZ ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(1) ZYDIS_NOTMIN(0xEEE), 5, 0 ZYDIS_NOTMIN(0x14), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_COND_BR) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I86) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NEAR) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, 0 ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_TRUE) },
    { ZYDIS_MNEMONIC_JZ ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(1) ZYDIS_NOTMIN(0xEF1), 4, 0 ZYDIS_NOTMIN(0x14), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_COND_BR) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I86) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NEAR) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, 0 ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_TRUE) },
    { ZYDIS_MNEMONIC_JZ ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(1) ZYDIS_NOTMIN(0xEF4), 0, 0 ZYDIS_NOTMIN(0x14), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_COND_BR) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I86) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NEAR) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, 0 ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_TRUE) },
    { ZYDIS_MNEMONIC_LAHF ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0) ZYDIS_NOTMIN(0x1B9F), 0, 0 ZYDIS_NOTMIN(0x1F), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_FLAGOP) ZYDIS_NOTMIN(ZYDIS_ISA_SET_LAHF) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, 0 ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_LAR ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xF03), 0, 0 ZYDIS_NOTMIN(0x17), ZYAN_TRUE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_SYSTEM) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I286PROTECTED) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_GPR, ZYDIS_REGKIND_GPR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_LAR ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xF06), 0, 0 ZYDIS_NOTMIN(0x17), ZYAN_TRUE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_SYSTEM) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I286PROTECTED) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_GPR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_LDDQU ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1BA1), 2, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_SSE) ZYDIS_NOTMIN(ZYDIS_ISA_SET_SSE3) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_SSE3) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_SSE4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_LDMXCSR ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(1) ZYDIS_NOTMIN(0x1BA3), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_SSE) ZYDIS_NOTMIN(ZYDIS_ISA_SET_SSEMXCSR) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_SSE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_SSE5), 0, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_LDS ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xF09), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_SEGOP) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I86) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_GPR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_LEA ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1BA5), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_MISC) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I86) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_GPR, ZYDIS_MEMOP_TYPE_AGEN ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_LEAVE ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0) ZYDIS_NOTMIN(0xF0C), 4, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_MISC) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I186) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, 0 ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_LES ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xF0F), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_SEGOP) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I86) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_GPR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_LFENCE ZYDIS_NOTMIN(0) ZYDIS_NOTMIN(0) ZYDIS_NOTMIN(0x0), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_MISC) ZYDIS_NOTMIN(ZYDIS_ISA_SET_SSE2) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_SSE2) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, 0 ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_LFS ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xF12), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_SEGOP) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I386) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_GPR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_LGDT ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(1) ZYDIS_NOTMIN(0x1BA7), 5, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_SYSTEM) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I286REAL) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_LGDT ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(1) ZYDIS_NOTMIN(0x1BA9), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_SYSTEM) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I286REAL) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_LGS ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xF15), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_SEGOP) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I386) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_GPR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_LIDT ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(1) ZYDIS_NOTMIN(0x1BAB), 5, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_SYSTEM) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I286REAL) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_LIDT ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(1) ZYDIS_NOTMIN(0x1BAD), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_SYSTEM) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I286REAL) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_LLDT ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(1) ZYDIS_NOTMIN(0x1BAF), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_TRUE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_SYSTEM) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I286PROTECTED) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, ZYDIS_REGKIND_GPR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_LLDT ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(1) ZYDIS_NOTMIN(0x1BB1), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_TRUE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_SYSTEM) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I286PROTECTED) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_LMSW ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(1) ZYDIS_NOTMIN(0x1BB3), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_SYSTEM) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I286REAL) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, ZYDIS_REGKIND_GPR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_LMSW ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(1) ZYDIS_NOTMIN(0x1BB5), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_SYSTEM) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I286REAL) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_LOADIWKEY ZYDIS_NOTMIN(5) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xEA), 0, 0 ZYDIS_NOTMIN(0x41), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_KEYLOCKER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_KEYLOCKER) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_KEYLOCKER) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_LODSB ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0) ZYDIS_NOTMIN(0x5D4), 1, 0 ZYDIS_NOTMIN(0xA), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_STRINGOP) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I86) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, 0 ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_LODSB ZYDIS_NOTMIN(5) ZYDIS_NOTMIN(0) ZYDIS_NOTMIN(0xEF), 1, 0 ZYDIS_NOTMIN(0xA), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_STRINGOP) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I86) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, 0 ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_LODSB ZYDIS_NOTMIN(5) ZYDIS_NOTMIN(0) ZYDIS_NOTMIN(0xEF), 1, 0 ZYDIS_NOTMIN(0xA), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_STRINGOP) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I86) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, 0 ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_LODSD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0) ZYDIS_NOTMIN(0x5D8), 0, 0 ZYDIS_NOTMIN(0xA), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_STRINGOP) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I386) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, 0 ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_LODSD ZYDIS_NOTMIN(5) ZYDIS_NOTMIN(0) ZYDIS_NOTMIN(0xF4), 0, 0 ZYDIS_NOTMIN(0xA), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_STRINGOP) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I386) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, 0 ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_LODSD ZYDIS_NOTMIN(5) ZYDIS_NOTMIN(0) ZYDIS_NOTMIN(0xF4), 0, 0 ZYDIS_NOTMIN(0xA), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_STRINGOP) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I386) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, 0 ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_LODSQ ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0) ZYDIS_NOTMIN(0x5DC), 0, 0 ZYDIS_NOTMIN(0xA), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_STRINGOP) ZYDIS_NOTMIN(ZYDIS_ISA_SET_LONGMODE) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_LONGMODE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, 0 ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_LODSQ ZYDIS_NOTMIN(5) ZYDIS_NOTMIN(0) ZYDIS_NOTMIN(0xF9), 0, 0 ZYDIS_NOTMIN(0xA), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_STRINGOP) ZYDIS_NOTMIN(ZYDIS_ISA_SET_LONGMODE) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_LONGMODE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, 0 ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_LODSQ ZYDIS_NOTMIN(5) ZYDIS_NOTMIN(0) ZYDIS_NOTMIN(0xF9), 0, 0 ZYDIS_NOTMIN(0xA), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_STRINGOP) ZYDIS_NOTMIN(ZYDIS_ISA_SET_LONGMODE) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_LONGMODE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, 0 ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_LODSW ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0) ZYDIS_NOTMIN(0x5E0), 0, 0 ZYDIS_NOTMIN(0xA), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_STRINGOP) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I86) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, 0 ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_LODSW ZYDIS_NOTMIN(5) ZYDIS_NOTMIN(0) ZYDIS_NOTMIN(0xFE), 0, 0 ZYDIS_NOTMIN(0xA), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_STRINGOP) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I86) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, 0 ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_LODSW ZYDIS_NOTMIN(5) ZYDIS_NOTMIN(0) ZYDIS_NOTMIN(0xFE), 0, 0 ZYDIS_NOTMIN(0xA), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_STRINGOP) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I86) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, 0 ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_LOOP ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(1) ZYDIS_NOTMIN(0x5E4), 5, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_COND_BR) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I86) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_SHORT) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, 0 ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_LOOPE ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(1) ZYDIS_NOTMIN(0x5E4), 5, 0 ZYDIS_NOTMIN(0x14), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_COND_BR) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I86) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_SHORT) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, 0 ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_LOOPNE ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(1) ZYDIS_NOTMIN(0x5E4), 5, 0 ZYDIS_NOTMIN(0x14), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_COND_BR) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I86) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_SHORT) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, 0 ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_LSL ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xF18), 0, 0 ZYDIS_NOTMIN(0x17), ZYAN_TRUE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_SYSTEM) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I286PROTECTED) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_GPR, ZYDIS_REGKIND_GPR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_LSL ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xF1B), 0, 0 ZYDIS_NOTMIN(0x17), ZYAN_TRUE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_SYSTEM) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I286PROTECTED) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_GPR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_LSS ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xF1E), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_SEGOP) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I386) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_GPR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_LTR ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(1) ZYDIS_NOTMIN(0x1BB7), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_TRUE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_SYSTEM) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I286PROTECTED) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, ZYDIS_REGKIND_GPR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_LTR ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(1) ZYDIS_NOTMIN(0x1BB9), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_TRUE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_SYSTEM) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I286PROTECTED) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_LZCNT ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xF21), 0, 0 ZYDIS_NOTMIN(0x3C), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_LZCNT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_LZCNT) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_LZCNT) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_GPR, ZYDIS_REGKIND_GPR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_LZCNT ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xF24), 0, 0 ZYDIS_NOTMIN(0x3C), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_LZCNT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_LZCNT) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_LZCNT) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_GPR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_MASKMOVDQU ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xF27), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_SSE2) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_SSE2) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_SSE4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_MASKMOVQ ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xF2A), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_PENTIUMMMX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_MMX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_MMX, ZYDIS_REGKIND_MMX ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_MAXPD ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xDB9), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_SSE) ZYDIS_NOTMIN(ZYDIS_ISA_SET_SSE2) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_SSE2) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_SSE2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_MAXPD ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xDBC), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_SSE) ZYDIS_NOTMIN(ZYDIS_ISA_SET_SSE2) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_SSE2) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_SSE2), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_MAXPS ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xDBF), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_SSE) ZYDIS_NOTMIN(ZYDIS_ISA_SET_SSE) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_SSE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_SSE2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_MAXPS ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xDC2), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_SSE) ZYDIS_NOTMIN(ZYDIS_ISA_SET_SSE) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_SSE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_SSE2), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_MAXSD ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xE1F), 2, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_SSE) ZYDIS_NOTMIN(ZYDIS_ISA_SET_SSE2) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_SSE2) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_SSE3), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_MAXSD ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xE22), 2, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_SSE) ZYDIS_NOTMIN(ZYDIS_ISA_SET_SSE2) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_SSE2) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_SSE3), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_MAXSS ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xE28), 2, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_SSE) ZYDIS_NOTMIN(ZYDIS_ISA_SET_SSE) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_SSE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_SSE3), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_MAXSS ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xE2B), 2, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_SSE) ZYDIS_NOTMIN(ZYDIS_ISA_SET_SSE) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_SSE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_SSE3), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_MCOMMIT ZYDIS_NOTMIN(1) ZYDIS_NOTMIN(0) ZYDIS_NOTMIN(0x9), 0, 0 ZYDIS_NOTMIN(0x26), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_MISC) ZYDIS_NOTMIN(ZYDIS_ISA_SET_MCOMMIT) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_MCOMMIT) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, 0 ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_MFENCE ZYDIS_NOTMIN(0) ZYDIS_NOTMIN(0) ZYDIS_NOTMIN(0x0), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_MISC) ZYDIS_NOTMIN(ZYDIS_ISA_SET_SSE2) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_SSE2) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, 0 ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_MINPD ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xDB9), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_SSE) ZYDIS_NOTMIN(ZYDIS_ISA_SET_SSE2) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_SSE2) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_SSE2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_MINPD ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xDBC), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_SSE) ZYDIS_NOTMIN(ZYDIS_ISA_SET_SSE2) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_SSE2) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_SSE2), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_MINPS ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xDBF), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_SSE) ZYDIS_NOTMIN(ZYDIS_ISA_SET_SSE) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_SSE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_SSE2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_MINPS ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xDC2), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_SSE) ZYDIS_NOTMIN(ZYDIS_ISA_SET_SSE) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_SSE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_SSE2), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_MINSD ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xE1F), 2, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_SSE) ZYDIS_NOTMIN(ZYDIS_ISA_SET_SSE2) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_SSE2) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_SSE3), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_MINSD ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xE22), 2, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_SSE) ZYDIS_NOTMIN(ZYDIS_ISA_SET_SSE2) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_SSE2) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_SSE3), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_MINSS ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xE28), 2, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_SSE) ZYDIS_NOTMIN(ZYDIS_ISA_SET_SSE) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_SSE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_SSE3), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_MINSS ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xE2B), 2, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_SSE) ZYDIS_NOTMIN(ZYDIS_ISA_SET_SSE) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_SSE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_SSE3), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_MONITOR ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0) ZYDIS_NOTMIN(0xF2D), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_MISC) ZYDIS_NOTMIN(ZYDIS_ISA_SET_MONITOR) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_MONITOR) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, 0 ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_MONITOR ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0) ZYDIS_NOTMIN(0xF30), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_MISC) ZYDIS_NOTMIN(ZYDIS_ISA_SET_MONITOR) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_MONITOR) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, 0 ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_MONITORX ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0) ZYDIS_NOTMIN(0xF2D), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_MISC) ZYDIS_NOTMIN(ZYDIS_ISA_SET_MONITORX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_MONITORX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, 0 ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_MONITORX ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0) ZYDIS_NOTMIN(0xF30), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_MISC) ZYDIS_NOTMIN(ZYDIS_ISA_SET_MONITORX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_MONITORX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, 0 ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_MONTMUL ZYDIS_NOTMIN(5) ZYDIS_NOTMIN(0) ZYDIS_NOTMIN(0x103), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_PADLOCK) ZYDIS_NOTMIN(ZYDIS_ISA_SET_PADLOCK_PMM) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_PADLOCK) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, 0 ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_MOV ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1BBB), 1, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I86) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_GPR, ZYDIS_REGKIND_GPR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_MOV ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1BBD), 1, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I86) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_GPR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_MOV ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1BBF), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I86) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_GPR, ZYDIS_REGKIND_GPR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_MOV ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1BC1), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I86) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_GPR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_MOV ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1BC3), 1, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I86) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_GPR, ZYDIS_REGKIND_GPR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_MOV ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1BC5), 1, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I86) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_GPR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_MOV ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x59C), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I86) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_GPR, ZYDIS_REGKIND_GPR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_MOV ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x5A0), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I86) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_GPR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_MOV ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1BC7), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I86) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_SEGMENT, ZYDIS_REGKIND_GPR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_MOV ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1BC9), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I86) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_SEGMENT, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_MOV ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1BCB), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I86) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_SEGMENT | (1 << 4), ZYDIS_REGKIND_GPR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_MOV ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1BCD), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I86) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_SEGMENT | (1 << 4), ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_MOV ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1BCF), 1, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I86) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, 0 ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_MOV ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1BD1), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I86) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, 0 ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_MOV ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1BD3), 1, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I86) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, 0 ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_MOV ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1BD5), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I86) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, 0 ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_MOV ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1BD7), 1, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I86) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, 0 ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_MOV ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1BD9), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I86) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, 0 ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_MOV ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1BDB), 1, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I86) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, ZYDIS_REGKIND_GPR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_MOV ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1BDD), 1, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I86) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_MOV ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1BDF), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I86) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, ZYDIS_REGKIND_GPR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_MOV ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1BE1), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I86) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_MOV ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1BE3), 7, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I86) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_CONTROL, ZYDIS_REGKIND_GPR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_MOV ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1BE5), 7, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I86) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_CONTROL, ZYDIS_REGKIND_GPR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_MOV ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1BE7), 7, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I86) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_DEBUG, ZYDIS_REGKIND_GPR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_MOV ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1BE9), 7, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I86) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_DEBUG, ZYDIS_REGKIND_GPR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_MOV ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1BEB), 7, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I86) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_CONTROL, ZYDIS_REGKIND_GPR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_MOV ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1BED), 7, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I86) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_CONTROL, ZYDIS_REGKIND_GPR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_MOV ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1BEF), 7, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I86) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_DEBUG, ZYDIS_REGKIND_GPR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_MOV ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1BF1), 7, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I86) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_DEBUG, ZYDIS_REGKIND_GPR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_MOVAPD ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1056), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_SSE2) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_SSE2) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_SSE1), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_MOVAPD ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1059), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_SSE2) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_SSE2) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_SSE1), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_MOVAPD ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1BF3), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_SSE2) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_SSE2) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_SSE1), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_MOVAPD ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1BF5), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_SSE2) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_SSE2) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_SSE1), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_MOVAPS ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x105C), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_SSE) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_SSE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_SSE1), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_MOVAPS ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x105F), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_SSE) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_SSE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_SSE1), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_MOVAPS ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1BF7), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_SSE) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_SSE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_SSE1), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_MOVAPS ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1BF9), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_SSE) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_SSE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_SSE1), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_MOVBE ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x5A0), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_MOVBE) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_MOVBE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_GPR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_MOVBE ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1BC1), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_MOVBE) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_MOVBE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_GPR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_MOVD ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1BFB), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_PENTIUMMMX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_MMX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_MMX, ZYDIS_REGKIND_GPR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_MOVD ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1BFD), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_PENTIUMMMX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_MMX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_MMX, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_MOVD ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1BFB), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_PENTIUMMMX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_MMX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_MMX, ZYDIS_REGKIND_GPR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_MOVD ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1BFD), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_PENTIUMMMX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_MMX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_MMX, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_MOVD ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1BFF), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_SSE2) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_SSE2) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_SSE5), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_GPR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_MOVD ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1C01), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_SSE2) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_SSE2) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_SSE5), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_MOVD ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1BFF), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_SSE2) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_SSE2) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_SSE5), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_GPR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_MOVD ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1C01), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_SSE2) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_SSE2) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_SSE5), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_MOVD ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1C03), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_PENTIUMMMX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_MMX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_MMX, ZYDIS_REGKIND_GPR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_MOVD ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1C05), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_PENTIUMMMX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_MMX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_MMX, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_MOVD ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1C03), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_PENTIUMMMX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_MMX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_MMX, ZYDIS_REGKIND_GPR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_MOVD ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1C05), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_PENTIUMMMX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_MMX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_MMX, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_MOVD ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1C07), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_SSE2) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_SSE2) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_SSE5), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_GPR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_MOVD ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1C09), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_SSE2) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_SSE2) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_SSE5), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_MOVD ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1C07), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_SSE2) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_SSE2) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_SSE5), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_GPR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_MOVD ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1C09), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_SSE2) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_SSE2) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_SSE5), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_MOVDDUP ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1C0B), 2, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_SSE3) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_SSE3) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_SSE5), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_MOVDDUP ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1C0D), 2, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_SSE3) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_SSE3) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_SSE5), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_MOVDIR64B ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xF33), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_MOVDIR) ZYDIS_NOTMIN(ZYDIS_ISA_SET_MOVDIR) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_MOVDIR) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_GPR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_MOVDIR64B ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xF36), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_MOVDIR) ZYDIS_NOTMIN(ZYDIS_ISA_SET_MOVDIR) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_MOVDIR) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_GPR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_MOVDIRI ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1C0F), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_MOVDIR) ZYDIS_NOTMIN(ZYDIS_ISA_SET_MOVDIR) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_MOVDIR) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_GPR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_MOVDIRI ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1C11), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_MOVDIR) ZYDIS_NOTMIN(ZYDIS_ISA_SET_MOVDIR) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_MOVDIR) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_GPR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_MOVDQ2Q ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1C13), 2, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_SSE2) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_SSE2) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_MMX, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_MOVDQA ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xDAD), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_SSE2) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_SSE2) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_SSE1), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_MOVDQA ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xDB0), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_SSE2) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_SSE2) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_SSE1), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_MOVDQA ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1C15), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_SSE2) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_SSE2) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_SSE1), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_MOVDQA ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1C17), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_SSE2) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_SSE2) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_SSE1), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_MOVDQU ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xDAD), 2, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_SSE2) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_SSE2) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_SSE4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_MOVDQU ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xDB0), 2, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_SSE2) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_SSE2) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_SSE4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_MOVDQU ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1C15), 2, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_SSE2) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_SSE2) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_SSE4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_MOVDQU ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1C17), 2, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_SSE2) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_SSE2) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_SSE4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_MOVHLPS ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1C19), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_SSE) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_SSE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_SSE7), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_MOVHPD ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1B51), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_SSE2) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_SSE2) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_SSE5), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_MOVHPD ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1C1B), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_SSE2) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_SSE2) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_SSE5), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_MOVHPS ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1C1D), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_SSE) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_SSE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_SSE5), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_MOVHPS ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1C1F), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_SSE) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_SSE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_SSE5), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_MOVLHPS ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1C19), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_SSE) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_SSE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_SSE7), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_MOVLPD ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1B51), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_SSE2) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_SSE2) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_SSE5), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_MOVLPD ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1C1B), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_SSE2) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_SSE2) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_SSE5), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_MOVLPS ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1C1D), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_SSE) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_SSE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_SSE5), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_MOVLPS ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1C21), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_SSE) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_SSE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_SSE5), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_MOVMSKPD ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1C23), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_SSE2) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_SSE2) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_SSE7), ZYDIS_REGKIND_GPR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_MOVMSKPS ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1C25), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_SSE) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_SSE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_SSE7), ZYDIS_REGKIND_GPR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_MOVNTDQ ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1C17), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_SSE2) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_SSE2) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_SSE1), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_MOVNTDQA ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xDB0), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_SSE) ZYDIS_NOTMIN(ZYDIS_ISA_SET_SSE4) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_SSE4) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_SSE1), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_MOVNTI ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x10AD), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_SSE2) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_SSE2) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_GPR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_MOVNTI ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x10B3), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_SSE2) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_SSE2) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_GPR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_MOVNTPD ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1C27), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_SSE2) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_SSE2) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_SSE1), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_MOVNTPS ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1C29), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_SSE) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_SSE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_SSE1), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_MOVNTQ ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1C2B), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_PENTIUMMMX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_MMX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_MMX, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_MOVNTSD ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1C2D), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_SSE4A) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_SSE4A) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_MOVNTSS ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1C09), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_SSE4A) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_SSE4A) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_MOVQ ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1C2F), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_PENTIUMMMX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_MMX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_MMX, ZYDIS_REGKIND_GPR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_MOVQ ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1C31), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_PENTIUMMMX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_MMX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_MMX, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_MOVQ ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1C33), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_SSE2) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_SSE2) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_SSE5), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_GPR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_MOVQ ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1C0D), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_SSE2) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_SSE2) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_SSE5), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_MOVQ ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1C35), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_PENTIUMMMX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_MMX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_MMX, ZYDIS_REGKIND_MMX ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_MOVQ ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1C31), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_PENTIUMMMX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_MMX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_MMX, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_MOVQ ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1C37), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_PENTIUMMMX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_MMX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_MMX, ZYDIS_REGKIND_GPR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_MOVQ ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1C2B), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_PENTIUMMMX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_MMX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_MMX, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_MOVQ ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1C39), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_SSE2) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_SSE2) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_SSE5), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_GPR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_MOVQ ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1C2D), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_SSE2) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_SSE2) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_SSE5), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_MOVQ ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1C0B), 2, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_SSE2) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_SSE2) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_SSE5), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_MOVQ ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1C0D), 2, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_SSE2) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_SSE2) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_SSE5), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_MOVQ ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1C3B), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_PENTIUMMMX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_MMX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_MMX, ZYDIS_REGKIND_MMX ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_MOVQ ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1C2B), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_PENTIUMMMX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_MMX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_MMX, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_MOVQ ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1C3D), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_SSE2) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_SSE2) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_SSE5), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_MOVQ ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1C2D), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_SSE2) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_SSE2) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_SSE5), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_MOVQ2DQ ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1C3F), 2, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_SSE2) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_SSE2) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_MMX ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_MOVSB ZYDIS_NOTMIN(5) ZYDIS_NOTMIN(0) ZYDIS_NOTMIN(0x108), 1, 0 ZYDIS_NOTMIN(0xA), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_STRINGOP) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I86) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, 0 ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_MOVSB ZYDIS_NOTMIN(6) ZYDIS_NOTMIN(0) ZYDIS_NOTMIN(0xA9), 1, 0 ZYDIS_NOTMIN(0xA), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_STRINGOP) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I86) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, 0 ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_MOVSB ZYDIS_NOTMIN(6) ZYDIS_NOTMIN(0) ZYDIS_NOTMIN(0xA9), 1, 0 ZYDIS_NOTMIN(0xA), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_STRINGOP) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I86) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, 0 ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_MOVSD ZYDIS_NOTMIN(5) ZYDIS_NOTMIN(0) ZYDIS_NOTMIN(0x10D), 0, 0 ZYDIS_NOTMIN(0xA), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_STRINGOP) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I386) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, 0 ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_MOVSD ZYDIS_NOTMIN(6) ZYDIS_NOTMIN(0) ZYDIS_NOTMIN(0xAF), 0, 0 ZYDIS_NOTMIN(0xA), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_STRINGOP) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I386) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, 0 ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_MOVSD ZYDIS_NOTMIN(6) ZYDIS_NOTMIN(0) ZYDIS_NOTMIN(0xAF), 0, 0 ZYDIS_NOTMIN(0xA), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_STRINGOP) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I386) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, 0 ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_MOVSD ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1C41), 2, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_SSE2) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_SSE2) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_SSE5), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_MOVSD ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1C43), 2, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_SSE2) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_SSE2) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_SSE5), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_MOVSD ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1C45), 2, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_SSE2) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_SSE2) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_SSE5), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_MOVSD ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1C47), 2, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_SSE2) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_SSE2) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_SSE5), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_MOVSHDUP ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x105C), 2, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_SSE3) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_SSE3) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_SSE4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_MOVSHDUP ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x105F), 2, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_SSE3) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_SSE3) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_SSE4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_MOVSLDUP ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x105C), 2, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_SSE3) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_SSE3) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_SSE4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_MOVSLDUP ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x105F), 2, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_SSE3) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_SSE3) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_SSE4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_MOVSQ ZYDIS_NOTMIN(5) ZYDIS_NOTMIN(0) ZYDIS_NOTMIN(0x112), 0, 0 ZYDIS_NOTMIN(0xA), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_STRINGOP) ZYDIS_NOTMIN(ZYDIS_ISA_SET_LONGMODE) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_LONGMODE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, 0 ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_MOVSQ ZYDIS_NOTMIN(6) ZYDIS_NOTMIN(0) ZYDIS_NOTMIN(0xB5), 0, 0 ZYDIS_NOTMIN(0xA), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_STRINGOP) ZYDIS_NOTMIN(ZYDIS_ISA_SET_LONGMODE) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_LONGMODE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, 0 ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_MOVSQ ZYDIS_NOTMIN(6) ZYDIS_NOTMIN(0) ZYDIS_NOTMIN(0xB5), 0, 0 ZYDIS_NOTMIN(0xA), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_STRINGOP) ZYDIS_NOTMIN(ZYDIS_ISA_SET_LONGMODE) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_LONGMODE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, 0 ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_MOVSS ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1C49), 2, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_SSE) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_SSE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_SSE5), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_MOVSS ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1C4B), 2, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_SSE) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_SSE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_SSE5), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_MOVSS ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1C4D), 2, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_SSE) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_SSE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_SSE5), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_MOVSS ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1C4F), 2, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_SSE) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_SSE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_SSE5), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_MOVSW ZYDIS_NOTMIN(5) ZYDIS_NOTMIN(0) ZYDIS_NOTMIN(0x117), 0, 0 ZYDIS_NOTMIN(0xA), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_STRINGOP) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I86) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, 0 ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_MOVSW ZYDIS_NOTMIN(6) ZYDIS_NOTMIN(0) ZYDIS_NOTMIN(0xBB), 0, 0 ZYDIS_NOTMIN(0xA), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_STRINGOP) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I86) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, 0 ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_MOVSW ZYDIS_NOTMIN(6) ZYDIS_NOTMIN(0) ZYDIS_NOTMIN(0xBB), 0, 0 ZYDIS_NOTMIN(0xA), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_STRINGOP) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I86) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, 0 ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_MOVSX ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1C51), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I386) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_GPR, ZYDIS_REGKIND_GPR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_MOVSX ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1C53), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I386) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_GPR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_MOVSX ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1C55), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I386) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_GPR, ZYDIS_REGKIND_GPR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_MOVSX ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1C57), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I386) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_GPR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_MOVSXD ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1C59), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_LONGMODE) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_LONGMODE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_GPR, ZYDIS_REGKIND_GPR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_MOVSXD ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1C5B), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_LONGMODE) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_LONGMODE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_GPR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_MOVUPD ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1056), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_SSE2) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_SSE2) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_SSE4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_MOVUPD ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1059), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_SSE2) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_SSE2) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_SSE4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_MOVUPD ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1BF3), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_SSE2) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_SSE2) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_SSE4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_MOVUPD ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1BF5), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_SSE2) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_SSE2) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_SSE4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_MOVUPS ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x105C), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_SSE) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_SSE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_SSE4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_MOVUPS ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x105F), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_SSE) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_SSE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_SSE4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_MOVUPS ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1BF7), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_SSE) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_SSE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_SSE4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_MOVUPS ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1BF9), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_SSE) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_SSE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_SSE4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_MOVZX ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1C5D), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I386) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_GPR, ZYDIS_REGKIND_GPR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_MOVZX ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1C5F), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I386) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_GPR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_MOVZX ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1C61), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I386) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_GPR, ZYDIS_REGKIND_GPR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_MOVZX ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1C63), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I386) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_GPR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_MPSADBW ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0xF39), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_SSE) ZYDIS_NOTMIN(ZYDIS_ISA_SET_SSE4) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_SSE4) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_SSE4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_MPSADBW ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0xF3C), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_SSE) ZYDIS_NOTMIN(ZYDIS_ISA_SET_SSE4) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_SSE4) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_SSE4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_MUL ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(1) ZYDIS_NOTMIN(0x5E8), 1, 0 ZYDIS_NOTMIN(0x3E), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_BINARY) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I86) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, ZYDIS_REGKIND_GPR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_MUL ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(1) ZYDIS_NOTMIN(0x5EC), 1, 0 ZYDIS_NOTMIN(0x3E), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_BINARY) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I86) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_MUL ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(1) ZYDIS_NOTMIN(0x5F0), 0, 0 ZYDIS_NOTMIN(0x3E), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_BINARY) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I86) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, ZYDIS_REGKIND_GPR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_MUL ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(1) ZYDIS_NOTMIN(0x5F4), 0, 0 ZYDIS_NOTMIN(0x3E), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_BINARY) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I86) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_MULPD ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xDB9), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_SSE) ZYDIS_NOTMIN(ZYDIS_ISA_SET_SSE2) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_SSE2) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_SSE2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_MULPD ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xDBC), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_SSE) ZYDIS_NOTMIN(ZYDIS_ISA_SET_SSE2) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_SSE2) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_SSE2), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_MULPS ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xDBF), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_SSE) ZYDIS_NOTMIN(ZYDIS_ISA_SET_SSE) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_SSE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_SSE2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_MULPS ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xDC2), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_SSE) ZYDIS_NOTMIN(ZYDIS_ISA_SET_SSE) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_SSE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_SSE2), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_MULSD ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xE1F), 2, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_SSE) ZYDIS_NOTMIN(ZYDIS_ISA_SET_SSE2) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_SSE2) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_SSE3), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_MULSD ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xE22), 2, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_SSE) ZYDIS_NOTMIN(ZYDIS_ISA_SET_SSE2) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_SSE2) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_SSE3), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_MULSS ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xE28), 2, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_SSE) ZYDIS_NOTMIN(ZYDIS_ISA_SET_SSE) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_SSE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_SSE3), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_MULSS ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xE2B), 2, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_SSE) ZYDIS_NOTMIN(ZYDIS_ISA_SET_SSE) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_SSE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_SSE3), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_MWAIT ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0) ZYDIS_NOTMIN(0x1C65), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_MISC) ZYDIS_NOTMIN(ZYDIS_ISA_SET_MONITOR) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_MONITOR) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, 0 ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_MWAIT ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0) ZYDIS_NOTMIN(0x28), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_MISC) ZYDIS_NOTMIN(ZYDIS_ISA_SET_MONITOR) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_MONITOR) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, 0 ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_MWAITX ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0) ZYDIS_NOTMIN(0x1C65), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_MISC) ZYDIS_NOTMIN(ZYDIS_ISA_SET_MONITORX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_MONITORX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, 0 ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_MWAITX ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0) ZYDIS_NOTMIN(0x28), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_MISC) ZYDIS_NOTMIN(ZYDIS_ISA_SET_MONITORX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_MONITORX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, 0 ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_NEG ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(1) ZYDIS_NOTMIN(0x1B73), 1, 0 ZYDIS_NOTMIN(0x2B), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_BINARY) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I86) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, ZYDIS_REGKIND_GPR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_NEG ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(1) ZYDIS_NOTMIN(0x1B75), 1, 0 ZYDIS_NOTMIN(0x2B), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_BINARY) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I86) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_TRUE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_NEG ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(1) ZYDIS_NOTMIN(0x1B77), 0, 0 ZYDIS_NOTMIN(0x2B), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_BINARY) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I86) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, ZYDIS_REGKIND_GPR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_NEG ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(1) ZYDIS_NOTMIN(0x1B79), 0, 0 ZYDIS_NOTMIN(0x2B), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_BINARY) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I86) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_TRUE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_NOP ZYDIS_NOTMIN(0) ZYDIS_NOTMIN(0) ZYDIS_NOTMIN(0x0), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_NOP) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I86) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, 0 ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_NOP ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xDD7), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_WIDENOP) ZYDIS_NOTMIN(ZYDIS_ISA_SET_PREFETCH_NOP) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_GPR, ZYDIS_REGKIND_GPR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_NOP ZYDIS_NOTMIN(1) ZYDIS_NOTMIN(1) ZYDIS_NOTMIN(0x544), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_WIDENOP) ZYDIS_NOTMIN(ZYDIS_ISA_SET_FAT_NOP) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, ZYDIS_REGKIND_GPR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_NOP ZYDIS_NOTMIN(1) ZYDIS_NOTMIN(1) ZYDIS_NOTMIN(0x544), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_WIDENOP) ZYDIS_NOTMIN(ZYDIS_ISA_SET_FAT_NOP) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, ZYDIS_REGKIND_GPR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_NOP ZYDIS_NOTMIN(1) ZYDIS_NOTMIN(1) ZYDIS_NOTMIN(0x544), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_WIDENOP) ZYDIS_NOTMIN(ZYDIS_ISA_SET_FAT_NOP) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, ZYDIS_REGKIND_GPR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_NOP ZYDIS_NOTMIN(1) ZYDIS_NOTMIN(1) ZYDIS_NOTMIN(0x544), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_WIDENOP) ZYDIS_NOTMIN(ZYDIS_ISA_SET_FAT_NOP) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, ZYDIS_REGKIND_GPR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_NOP ZYDIS_NOTMIN(1) ZYDIS_NOTMIN(1) ZYDIS_NOTMIN(0x544), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_WIDENOP) ZYDIS_NOTMIN(ZYDIS_ISA_SET_FAT_NOP) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, ZYDIS_REGKIND_GPR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_NOP ZYDIS_NOTMIN(1) ZYDIS_NOTMIN(1) ZYDIS_NOTMIN(0x544), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_WIDENOP) ZYDIS_NOTMIN(ZYDIS_ISA_SET_FAT_NOP) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, ZYDIS_REGKIND_GPR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_NOP ZYDIS_NOTMIN(1) ZYDIS_NOTMIN(1) ZYDIS_NOTMIN(0x544), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_WIDENOP) ZYDIS_NOTMIN(ZYDIS_ISA_SET_FAT_NOP) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, ZYDIS_REGKIND_GPR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_NOP ZYDIS_NOTMIN(1) ZYDIS_NOTMIN(1) ZYDIS_NOTMIN(0x544), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_WIDENOP) ZYDIS_NOTMIN(ZYDIS_ISA_SET_FAT_NOP) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, ZYDIS_REGKIND_GPR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_NOP ZYDIS_NOTMIN(1) ZYDIS_NOTMIN(1) ZYDIS_NOTMIN(0x548), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_WIDENOP) ZYDIS_NOTMIN(ZYDIS_ISA_SET_FAT_NOP) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_NOP ZYDIS_NOTMIN(1) ZYDIS_NOTMIN(1) ZYDIS_NOTMIN(0x548), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_WIDENOP) ZYDIS_NOTMIN(ZYDIS_ISA_SET_FAT_NOP) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_NOP ZYDIS_NOTMIN(1) ZYDIS_NOTMIN(1) ZYDIS_NOTMIN(0x548), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_WIDENOP) ZYDIS_NOTMIN(ZYDIS_ISA_SET_FAT_NOP) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_NOP ZYDIS_NOTMIN(1) ZYDIS_NOTMIN(1) ZYDIS_NOTMIN(0x548), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_WIDENOP) ZYDIS_NOTMIN(ZYDIS_ISA_SET_FAT_NOP) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_NOP ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xDD7), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_WIDENOP) ZYDIS_NOTMIN(ZYDIS_ISA_SET_FAT_NOP) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_GPR, ZYDIS_REGKIND_GPR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_NOP ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xDDA), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_WIDENOP) ZYDIS_NOTMIN(ZYDIS_ISA_SET_FAT_NOP) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_GPR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_NOP ZYDIS_NOTMIN(1) ZYDIS_NOTMIN(1) ZYDIS_NOTMIN(0x569), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_WIDENOP) ZYDIS_NOTMIN(ZYDIS_ISA_SET_PPRO) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_GPR, 0 ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_NOP ZYDIS_NOTMIN(1) ZYDIS_NOTMIN(1) ZYDIS_NOTMIN(0x548), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_WIDENOP) ZYDIS_NOTMIN(ZYDIS_ISA_SET_PPRO) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_NOP ZYDIS_NOTMIN(1) ZYDIS_NOTMIN(1) ZYDIS_NOTMIN(0x569), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_WIDENOP) ZYDIS_NOTMIN(ZYDIS_ISA_SET_PPRO) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_GPR, 0 ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_NOP ZYDIS_NOTMIN(1) ZYDIS_NOTMIN(1) ZYDIS_NOTMIN(0x569), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_WIDENOP) ZYDIS_NOTMIN(ZYDIS_ISA_SET_PPRO) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_GPR, 0 ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_NOP ZYDIS_NOTMIN(1) ZYDIS_NOTMIN(1) ZYDIS_NOTMIN(0x548), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_WIDENOP) ZYDIS_NOTMIN(ZYDIS_ISA_SET_PPRO) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_NOP ZYDIS_NOTMIN(1) ZYDIS_NOTMIN(1) ZYDIS_NOTMIN(0x569), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_WIDENOP) ZYDIS_NOTMIN(ZYDIS_ISA_SET_PPRO) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_GPR, 0 ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_NOP ZYDIS_NOTMIN(1) ZYDIS_NOTMIN(1) ZYDIS_NOTMIN(0x569), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_WIDENOP) ZYDIS_NOTMIN(ZYDIS_ISA_SET_PPRO) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_GPR, 0 ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_NOP ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xDD7), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_WIDENOP) ZYDIS_NOTMIN(ZYDIS_ISA_SET_FAT_NOP) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_GPR, ZYDIS_REGKIND_GPR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_NOP ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xDDA), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_WIDENOP) ZYDIS_NOTMIN(ZYDIS_ISA_SET_FAT_NOP) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_GPR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_NOP ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xDD7), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_WIDENOP) ZYDIS_NOTMIN(ZYDIS_ISA_SET_FAT_NOP) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_GPR, ZYDIS_REGKIND_GPR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_NOP ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xDDA), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_WIDENOP) ZYDIS_NOTMIN(ZYDIS_ISA_SET_FAT_NOP) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_GPR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_NOP ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xDDA), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_WIDENOP) ZYDIS_NOTMIN(ZYDIS_ISA_SET_PPRO) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_GPR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_NOP ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xDD7), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_WIDENOP) ZYDIS_NOTMIN(ZYDIS_ISA_SET_FAT_NOP) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_GPR, ZYDIS_REGKIND_GPR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_NOP ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xDD7), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_WIDENOP) ZYDIS_NOTMIN(ZYDIS_ISA_SET_PPRO) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_GPR, ZYDIS_REGKIND_GPR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_NOP ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xDD7), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_WIDENOP) ZYDIS_NOTMIN(ZYDIS_ISA_SET_PPRO) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_GPR, ZYDIS_REGKIND_GPR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_NOP ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xDD7), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_WIDENOP) ZYDIS_NOTMIN(ZYDIS_ISA_SET_PPRO) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_GPR, ZYDIS_REGKIND_GPR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_NOP ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xDD7), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_WIDENOP) ZYDIS_NOTMIN(ZYDIS_ISA_SET_PPRO) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_GPR, ZYDIS_REGKIND_GPR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_NOP ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xDD7), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_WIDENOP) ZYDIS_NOTMIN(ZYDIS_ISA_SET_PPRO) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_GPR, ZYDIS_REGKIND_GPR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_NOP ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xDD7), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_WIDENOP) ZYDIS_NOTMIN(ZYDIS_ISA_SET_PPRO) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_GPR, ZYDIS_REGKIND_GPR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_NOP ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xDD7), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_WIDENOP) ZYDIS_NOTMIN(ZYDIS_ISA_SET_PPRO) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_GPR, ZYDIS_REGKIND_GPR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_NOP ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xDD7), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_WIDENOP) ZYDIS_NOTMIN(ZYDIS_ISA_SET_PPRO) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_GPR, ZYDIS_REGKIND_GPR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_NOP ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xDD7), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_WIDENOP) ZYDIS_NOTMIN(ZYDIS_ISA_SET_PPRO) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_GPR, ZYDIS_REGKIND_GPR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_NOP ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xDD7), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_WIDENOP) ZYDIS_NOTMIN(ZYDIS_ISA_SET_PPRO) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_GPR, ZYDIS_REGKIND_GPR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_NOP ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xDD7), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_WIDENOP) ZYDIS_NOTMIN(ZYDIS_ISA_SET_PPRO) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_GPR, ZYDIS_REGKIND_GPR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_NOP ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xDD7), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_WIDENOP) ZYDIS_NOTMIN(ZYDIS_ISA_SET_PPRO) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_GPR, ZYDIS_REGKIND_GPR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_NOP ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xDD7), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_WIDENOP) ZYDIS_NOTMIN(ZYDIS_ISA_SET_PPRO) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_GPR, ZYDIS_REGKIND_GPR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_NOP ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xDD7), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_WIDENOP) ZYDIS_NOTMIN(ZYDIS_ISA_SET_PPRO) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_GPR, ZYDIS_REGKIND_GPR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_NOP ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xDD7), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_WIDENOP) ZYDIS_NOTMIN(ZYDIS_ISA_SET_PPRO) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_GPR, ZYDIS_REGKIND_GPR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_NOP ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xDD7), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_WIDENOP) ZYDIS_NOTMIN(ZYDIS_ISA_SET_PPRO) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_GPR, ZYDIS_REGKIND_GPR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_NOP ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xDD7), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_WIDENOP) ZYDIS_NOTMIN(ZYDIS_ISA_SET_PPRO) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_GPR, ZYDIS_REGKIND_GPR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_NOP ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xDD7), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_WIDENOP) ZYDIS_NOTMIN(ZYDIS_ISA_SET_PPRO) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_GPR, ZYDIS_REGKIND_GPR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_NOP ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xDD7), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_WIDENOP) ZYDIS_NOTMIN(ZYDIS_ISA_SET_PPRO) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_GPR, ZYDIS_REGKIND_GPR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_NOP ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xDD7), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_WIDENOP) ZYDIS_NOTMIN(ZYDIS_ISA_SET_FAT_NOP) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_GPR, ZYDIS_REGKIND_GPR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_NOP ZYDIS_NOTMIN(1) ZYDIS_NOTMIN(1) ZYDIS_NOTMIN(0x544), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_WIDENOP) ZYDIS_NOTMIN(ZYDIS_ISA_SET_KNC_MISC) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, ZYDIS_REGKIND_GPR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_NOP ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xDDA), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_WIDENOP) ZYDIS_NOTMIN(ZYDIS_ISA_SET_FAT_NOP) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_GPR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_NOP ZYDIS_NOTMIN(1) ZYDIS_NOTMIN(1) ZYDIS_NOTMIN(0x548), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_WIDENOP) ZYDIS_NOTMIN(ZYDIS_ISA_SET_KNC_MISC) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_NOT ZYDIS_NOTMIN(1) ZYDIS_NOTMIN(1) ZYDIS_NOTMIN(0xD3B), 1, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_LOGICAL) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I86) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, ZYDIS_REGKIND_GPR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_NOT ZYDIS_NOTMIN(1) ZYDIS_NOTMIN(1) ZYDIS_NOTMIN(0xD3E), 1, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_LOGICAL) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I86) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_TRUE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_NOT ZYDIS_NOTMIN(1) ZYDIS_NOTMIN(1) ZYDIS_NOTMIN(0xD41), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_LOGICAL) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I86) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, ZYDIS_REGKIND_GPR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_NOT ZYDIS_NOTMIN(1) ZYDIS_NOTMIN(1) ZYDIS_NOTMIN(0xD44), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_LOGICAL) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I86) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_TRUE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_OR ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xD77), 1, 0 ZYDIS_NOTMIN(0x40), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_LOGICAL) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I86) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_GPR, ZYDIS_REGKIND_GPR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_OR ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xD7A), 1, 0 ZYDIS_NOTMIN(0x40), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_LOGICAL) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I86) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_GPR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_TRUE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_OR ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xD7D), 0, 0 ZYDIS_NOTMIN(0x40), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_LOGICAL) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I86) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_GPR, ZYDIS_REGKIND_GPR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_OR ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xD80), 0, 0 ZYDIS_NOTMIN(0x40), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_LOGICAL) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I86) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_GPR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_TRUE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_OR ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xD83), 1, 0 ZYDIS_NOTMIN(0x40), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_LOGICAL) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I86) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_GPR, ZYDIS_REGKIND_GPR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_OR ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xD86), 1, 0 ZYDIS_NOTMIN(0x40), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_LOGICAL) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I86) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_GPR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_OR ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xD89), 0, 0 ZYDIS_NOTMIN(0x40), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_LOGICAL) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I86) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_GPR, ZYDIS_REGKIND_GPR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_OR ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xD8C), 0, 0 ZYDIS_NOTMIN(0x40), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_LOGICAL) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I86) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_GPR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_OR ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xD8F), 1, 0 ZYDIS_NOTMIN(0x40), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_LOGICAL) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I86) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, 0 ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_OR ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xD92), 0, 0 ZYDIS_NOTMIN(0x40), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_LOGICAL) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I86) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, 0 ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_OR ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xD95), 1, 0 ZYDIS_NOTMIN(0x40), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_LOGICAL) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I86) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, ZYDIS_REGKIND_GPR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_OR ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xD98), 1, 0 ZYDIS_NOTMIN(0x40), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_LOGICAL) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I86) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_TRUE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_OR ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xD9B), 0, 0 ZYDIS_NOTMIN(0x40), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_LOGICAL) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I86) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, ZYDIS_REGKIND_GPR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_OR ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xD9E), 0, 0 ZYDIS_NOTMIN(0x40), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_LOGICAL) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I86) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_TRUE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_OR ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xD95), 1, 0 ZYDIS_NOTMIN(0x40), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_LOGICAL) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I86) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, ZYDIS_REGKIND_GPR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_OR ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xD98), 1, 0 ZYDIS_NOTMIN(0x40), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_LOGICAL) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I86) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_TRUE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_OR ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xDA1), 0, 0 ZYDIS_NOTMIN(0x40), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_LOGICAL) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I86) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, ZYDIS_REGKIND_GPR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_OR ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xDA4), 0, 0 ZYDIS_NOTMIN(0x40), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_LOGICAL) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I86) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_TRUE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_ORPD ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xDB9), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_LOGICAL_FP) ZYDIS_NOTMIN(ZYDIS_ISA_SET_SSE2) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_SSE2) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_SSE4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_ORPD ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xDBC), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_LOGICAL_FP) ZYDIS_NOTMIN(ZYDIS_ISA_SET_SSE2) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_SSE2) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_SSE4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_ORPS ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xDBF), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_LOGICAL_FP) ZYDIS_NOTMIN(ZYDIS_ISA_SET_SSE) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_SSE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_SSE4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_ORPS ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xDC2), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_LOGICAL_FP) ZYDIS_NOTMIN(ZYDIS_ISA_SET_SSE) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_SSE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_SSE4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_OUT ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xF3F), 1, 0 ZYDIS_NOTMIN(0x7), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_IO) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I86) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, 0 ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_OUT ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xF42), 3, 0 ZYDIS_NOTMIN(0x7), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_IO) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I86) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, 0 ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_OUT ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xF45), 3, 0 ZYDIS_NOTMIN(0x7), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_IO) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I86) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, 0 ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_OUT ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xF48), 1, 0 ZYDIS_NOTMIN(0x7), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_IO) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I86) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, 0 ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_OUT ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xF4B), 3, 0 ZYDIS_NOTMIN(0x7), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_IO) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I86) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, 0 ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_OUT ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xF4E), 3, 0 ZYDIS_NOTMIN(0x7), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_IO) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I86) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, 0 ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_OUTSB ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0) ZYDIS_NOTMIN(0xF51), 1, 0 ZYDIS_NOTMIN(0xB), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_IOSTRINGOP) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I186) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, 0 ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_OUTSB ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0) ZYDIS_NOTMIN(0x5F8), 1, 0 ZYDIS_NOTMIN(0xB), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_IOSTRINGOP) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I186) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, 0 ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_OUTSB ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0) ZYDIS_NOTMIN(0x5F8), 1, 0 ZYDIS_NOTMIN(0xB), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_IOSTRINGOP) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I186) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, 0 ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_OUTSD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0) ZYDIS_NOTMIN(0xF54), 0, 0 ZYDIS_NOTMIN(0xB), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_IOSTRINGOP) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I386) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, 0 ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_OUTSD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0) ZYDIS_NOTMIN(0xF54), 0, 0 ZYDIS_NOTMIN(0xB), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_IOSTRINGOP) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I386) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, 0 ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_OUTSD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0) ZYDIS_NOTMIN(0x5FC), 0, 0 ZYDIS_NOTMIN(0xB), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_IOSTRINGOP) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I386) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, 0 ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_OUTSD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0) ZYDIS_NOTMIN(0x5FC), 0, 0 ZYDIS_NOTMIN(0xB), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_IOSTRINGOP) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I386) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, 0 ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_OUTSD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0) ZYDIS_NOTMIN(0x5FC), 0, 0 ZYDIS_NOTMIN(0xB), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_IOSTRINGOP) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I386) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, 0 ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_OUTSD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0) ZYDIS_NOTMIN(0x5FC), 0, 0 ZYDIS_NOTMIN(0xB), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_IOSTRINGOP) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I386) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, 0 ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_OUTSW ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0) ZYDIS_NOTMIN(0xF57), 0, 0 ZYDIS_NOTMIN(0xB), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_IOSTRINGOP) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I186) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, 0 ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_OUTSW ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0) ZYDIS_NOTMIN(0x600), 0, 0 ZYDIS_NOTMIN(0xB), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_IOSTRINGOP) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I186) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, 0 ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_OUTSW ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0) ZYDIS_NOTMIN(0x600), 0, 0 ZYDIS_NOTMIN(0xB), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_IOSTRINGOP) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I186) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, 0 ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_PABSB ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1C35), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_MMX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_SSSE3MMX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_SSSE3) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_MMX, ZYDIS_REGKIND_MMX ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_PABSB ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1C31), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_MMX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_SSSE3MMX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_SSSE3) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_MMX, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_PABSB ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xDAD), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_SSE) ZYDIS_NOTMIN(ZYDIS_ISA_SET_SSSE3) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_SSSE3) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_SSE4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_PABSB ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xDB0), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_SSE) ZYDIS_NOTMIN(ZYDIS_ISA_SET_SSSE3) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_SSSE3) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_SSE4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_PABSD ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1C35), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_MMX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_SSSE3MMX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_SSSE3) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_MMX, ZYDIS_REGKIND_MMX ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_PABSD ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1C31), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_MMX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_SSSE3MMX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_SSSE3) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_MMX, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_PABSD ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xDAD), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_SSE) ZYDIS_NOTMIN(ZYDIS_ISA_SET_SSSE3) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_SSSE3) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_SSE4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_PABSD ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xDB0), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_SSE) ZYDIS_NOTMIN(ZYDIS_ISA_SET_SSSE3) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_SSSE3) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_SSE4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_PABSW ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1C35), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_MMX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_SSSE3MMX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_SSSE3) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_MMX, ZYDIS_REGKIND_MMX ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_PABSW ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1C31), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_MMX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_SSSE3MMX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_SSSE3) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_MMX, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_PABSW ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xDAD), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_SSE) ZYDIS_NOTMIN(ZYDIS_ISA_SET_SSSE3) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_SSSE3) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_SSE4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_PABSW ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xDB0), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_SSE) ZYDIS_NOTMIN(ZYDIS_ISA_SET_SSSE3) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_SSSE3) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_SSE4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_PACKSSDW ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1C67), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_MMX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_PENTIUMMMX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_MMX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_MMX, ZYDIS_REGKIND_MMX ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_PACKSSDW ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1C69), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_MMX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_PENTIUMMMX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_MMX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_MMX, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_PACKSSDW ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xF60), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_SSE) ZYDIS_NOTMIN(ZYDIS_ISA_SET_SSE2) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_SSE2) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_SSE4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_PACKSSDW ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xF63), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_SSE) ZYDIS_NOTMIN(ZYDIS_ISA_SET_SSE2) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_SSE2) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_SSE4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_PACKSSWB ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1C6B), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_MMX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_PENTIUMMMX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_MMX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_MMX, ZYDIS_REGKIND_MMX ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_PACKSSWB ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1C6D), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_MMX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_PENTIUMMMX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_MMX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_MMX, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_PACKSSWB ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1C6F), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_SSE) ZYDIS_NOTMIN(ZYDIS_ISA_SET_SSE2) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_SSE2) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_SSE4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_PACKSSWB ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1C71), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_SSE) ZYDIS_NOTMIN(ZYDIS_ISA_SET_SSE2) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_SSE2) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_SSE4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_PACKUSDW ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xF60), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_SSE) ZYDIS_NOTMIN(ZYDIS_ISA_SET_SSE4) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_SSE4) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_SSE4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_PACKUSDW ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xF63), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_SSE) ZYDIS_NOTMIN(ZYDIS_ISA_SET_SSE4) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_SSE4) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_SSE4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_PACKUSWB ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1C6B), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_MMX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_PENTIUMMMX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_MMX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_MMX, ZYDIS_REGKIND_MMX ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_PACKUSWB ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1C6D), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_MMX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_PENTIUMMMX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_MMX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_MMX, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_PACKUSWB ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1C6F), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_SSE) ZYDIS_NOTMIN(ZYDIS_ISA_SET_SSE2) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_SSE2) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_SSE4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_PACKUSWB ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1C71), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_SSE) ZYDIS_NOTMIN(ZYDIS_ISA_SET_SSE2) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_SSE2) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_SSE4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_PADDB ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xF5A), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_MMX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_PENTIUMMMX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_MMX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_MMX, ZYDIS_REGKIND_MMX ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_PADDB ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xF5D), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_MMX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_PENTIUMMMX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_MMX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_MMX, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_PADDB ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xF60), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_SSE) ZYDIS_NOTMIN(ZYDIS_ISA_SET_SSE2) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_SSE2) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_SSE4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_PADDB ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xF63), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_SSE) ZYDIS_NOTMIN(ZYDIS_ISA_SET_SSE2) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_SSE2) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_SSE4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_PADDD ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xF5A), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_MMX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_PENTIUMMMX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_MMX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_MMX, ZYDIS_REGKIND_MMX ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_PADDD ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xF5D), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_MMX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_PENTIUMMMX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_MMX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_MMX, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_PADDD ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xF60), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_SSE) ZYDIS_NOTMIN(ZYDIS_ISA_SET_SSE2) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_SSE2) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_SSE4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_PADDD ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xF63), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_SSE) ZYDIS_NOTMIN(ZYDIS_ISA_SET_SSE2) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_SSE2) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_SSE4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_PADDQ ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xF5A), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_MMX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_SSE2MMX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_SSE2) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_MMX, ZYDIS_REGKIND_MMX ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_PADDQ ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xF5D), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_MMX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_SSE2MMX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_SSE2) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_MMX, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_PADDQ ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xF60), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_SSE) ZYDIS_NOTMIN(ZYDIS_ISA_SET_SSE2) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_SSE2) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_SSE4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_PADDQ ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xF63), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_SSE) ZYDIS_NOTMIN(ZYDIS_ISA_SET_SSE2) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_SSE2) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_SSE4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_PADDSB ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xF5A), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_MMX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_PENTIUMMMX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_MMX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_MMX, ZYDIS_REGKIND_MMX ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_PADDSB ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xF5D), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_MMX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_PENTIUMMMX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_MMX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_MMX, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_PADDSB ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xF60), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_SSE) ZYDIS_NOTMIN(ZYDIS_ISA_SET_SSE2) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_SSE2) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_SSE4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_PADDSB ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xF63), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_SSE) ZYDIS_NOTMIN(ZYDIS_ISA_SET_SSE2) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_SSE2) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_SSE4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_PADDSW ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xF5A), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_MMX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_PENTIUMMMX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_MMX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_MMX, ZYDIS_REGKIND_MMX ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_PADDSW ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xF5D), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_MMX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_PENTIUMMMX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_MMX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_MMX, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_PADDSW ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xF60), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_SSE) ZYDIS_NOTMIN(ZYDIS_ISA_SET_SSE2) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_SSE2) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_SSE4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_PADDSW ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xF63), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_SSE) ZYDIS_NOTMIN(ZYDIS_ISA_SET_SSE2) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_SSE2) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_SSE4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_PADDUSB ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xF5A), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_MMX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_PENTIUMMMX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_MMX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_MMX, ZYDIS_REGKIND_MMX ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_PADDUSB ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xF5D), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_MMX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_PENTIUMMMX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_MMX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_MMX, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_PADDUSB ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xF60), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_SSE) ZYDIS_NOTMIN(ZYDIS_ISA_SET_SSE2) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_SSE2) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_SSE4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_PADDUSB ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xF63), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_SSE) ZYDIS_NOTMIN(ZYDIS_ISA_SET_SSE2) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_SSE2) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_SSE4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_PADDUSW ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xF5A), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_MMX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_PENTIUMMMX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_MMX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_MMX, ZYDIS_REGKIND_MMX ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_PADDUSW ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xF5D), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_MMX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_PENTIUMMMX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_MMX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_MMX, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_PADDUSW ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xF60), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_SSE) ZYDIS_NOTMIN(ZYDIS_ISA_SET_SSE2) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_SSE2) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_SSE4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_PADDUSW ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xF63), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_SSE) ZYDIS_NOTMIN(ZYDIS_ISA_SET_SSE2) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_SSE2) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_SSE4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_PADDW ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xF5A), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_MMX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_PENTIUMMMX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_MMX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_MMX, ZYDIS_REGKIND_MMX ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_PADDW ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xF5D), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_MMX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_PENTIUMMMX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_MMX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_MMX, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_PADDW ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1C6F), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_SSE) ZYDIS_NOTMIN(ZYDIS_ISA_SET_SSE2) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_SSE2) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_SSE4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_PADDW ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1C71), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_SSE) ZYDIS_NOTMIN(ZYDIS_ISA_SET_SSE2) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_SSE2) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_SSE4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_PALIGNR ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0xF5A), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_MMX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_SSSE3MMX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_SSSE3) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_MMX, ZYDIS_REGKIND_MMX ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_PALIGNR ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0xF5D), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_MMX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_SSSE3MMX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_SSSE3) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_MMX, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_PALIGNR ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0xF60), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_SSE) ZYDIS_NOTMIN(ZYDIS_ISA_SET_SSSE3) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_SSSE3) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_SSE4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_PALIGNR ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0xF63), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_SSE) ZYDIS_NOTMIN(ZYDIS_ISA_SET_SSSE3) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_SSSE3) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_SSE4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_PAND ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xF5A), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_LOGICAL) ZYDIS_NOTMIN(ZYDIS_ISA_SET_PENTIUMMMX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_MMX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_MMX, ZYDIS_REGKIND_MMX ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_PAND ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xF5D), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_LOGICAL) ZYDIS_NOTMIN(ZYDIS_ISA_SET_PENTIUMMMX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_MMX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_MMX, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_PAND ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xF60), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_LOGICAL) ZYDIS_NOTMIN(ZYDIS_ISA_SET_SSE2) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_SSE2) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_SSE4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_PAND ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xF63), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_LOGICAL) ZYDIS_NOTMIN(ZYDIS_ISA_SET_SSE2) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_SSE2) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_SSE4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_PANDN ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xF5A), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_LOGICAL) ZYDIS_NOTMIN(ZYDIS_ISA_SET_PENTIUMMMX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_MMX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_MMX, ZYDIS_REGKIND_MMX ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_PANDN ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xF5D), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_LOGICAL) ZYDIS_NOTMIN(ZYDIS_ISA_SET_PENTIUMMMX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_MMX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_MMX, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_PANDN ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xF60), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_LOGICAL) ZYDIS_NOTMIN(ZYDIS_ISA_SET_SSE2) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_SSE2) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_SSE4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_PANDN ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xF63), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_LOGICAL) ZYDIS_NOTMIN(ZYDIS_ISA_SET_SSE2) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_SSE2) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_SSE4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_PAUSE ZYDIS_NOTMIN(0) ZYDIS_NOTMIN(0) ZYDIS_NOTMIN(0x0), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_MISC) ZYDIS_NOTMIN(ZYDIS_ISA_SET_PAUSE) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_PAUSE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, 0 ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_PAVGB ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1C73), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_MMX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_PENTIUMMMX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_MMX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_MMX, ZYDIS_REGKIND_MMX ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_PAVGB ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1C75), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_MMX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_PENTIUMMMX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_MMX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_MMX, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_PAVGB ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xF39), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_SSE) ZYDIS_NOTMIN(ZYDIS_ISA_SET_SSE2) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_SSE2) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_SSE4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_PAVGB ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xF3C), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_SSE) ZYDIS_NOTMIN(ZYDIS_ISA_SET_SSE2) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_SSE2) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_SSE4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_PAVGW ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1C77), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_MMX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_PENTIUMMMX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_MMX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_MMX, ZYDIS_REGKIND_MMX ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_PAVGW ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1C79), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_MMX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_PENTIUMMMX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_MMX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_MMX, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_PAVGW ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1C7B), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_SSE) ZYDIS_NOTMIN(ZYDIS_ISA_SET_SSE2) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_SSE2) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_SSE4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_PAVGW ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1C7D), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_SSE) ZYDIS_NOTMIN(ZYDIS_ISA_SET_SSE2) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_SSE2) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_SSE4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_PBLENDVB ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xF66), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_SSE) ZYDIS_NOTMIN(ZYDIS_ISA_SET_SSE4) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_SSE4) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_SSE4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_PBLENDVB ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xF69), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_SSE) ZYDIS_NOTMIN(ZYDIS_ISA_SET_SSE4) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_SSE4) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_SSE4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_PBLENDW ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0xF60), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_SSE) ZYDIS_NOTMIN(ZYDIS_ISA_SET_SSE4) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_SSE4) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_SSE4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_PBLENDW ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0xF63), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_SSE) ZYDIS_NOTMIN(ZYDIS_ISA_SET_SSE4) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_SSE4) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_SSE4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_PBNDKB ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0) ZYDIS_NOTMIN(0x604), 0, 0 ZYDIS_NOTMIN(0x41), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_PBNDKB) ZYDIS_NOTMIN(ZYDIS_ISA_SET_PBNDKB) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_PBNDKB) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, 0 ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_PCLMULQDQ ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0xF60), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_PCLMULQDQ) ZYDIS_NOTMIN(ZYDIS_ISA_SET_PCLMULQDQ) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_PCLMULQDQ) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_SSE4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_PCLMULQDQ ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0xF63), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_PCLMULQDQ) ZYDIS_NOTMIN(ZYDIS_ISA_SET_PCLMULQDQ) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_PCLMULQDQ) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_SSE4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_PCMPEQB ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1C7F), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_MMX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_PENTIUMMMX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_MMX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_MMX, ZYDIS_REGKIND_MMX ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_PCMPEQB ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1C81), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_MMX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_PENTIUMMMX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_MMX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_MMX, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_PCMPEQB ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1C83), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_SSE) ZYDIS_NOTMIN(ZYDIS_ISA_SET_SSE2) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_SSE2) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_SSE4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_PCMPEQB ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1C85), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_SSE) ZYDIS_NOTMIN(ZYDIS_ISA_SET_SSE2) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_SSE2) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_SSE4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_PCMPEQD ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1C67), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_MMX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_PENTIUMMMX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_MMX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_MMX, ZYDIS_REGKIND_MMX ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_PCMPEQD ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1C69), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_MMX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_PENTIUMMMX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_MMX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_MMX, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_PCMPEQD ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xF60), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_SSE) ZYDIS_NOTMIN(ZYDIS_ISA_SET_SSE2) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_SSE2) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_SSE4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_PCMPEQD ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xF63), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_SSE) ZYDIS_NOTMIN(ZYDIS_ISA_SET_SSE2) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_SSE2) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_SSE4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_PCMPEQQ ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xF60), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_SSE) ZYDIS_NOTMIN(ZYDIS_ISA_SET_SSE4) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_SSE4) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_SSE4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_PCMPEQQ ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xF63), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_SSE) ZYDIS_NOTMIN(ZYDIS_ISA_SET_SSE4) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_SSE4) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_SSE4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_PCMPEQW ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1C6B), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_MMX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_PENTIUMMMX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_MMX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_MMX, ZYDIS_REGKIND_MMX ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_PCMPEQW ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1C6D), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_MMX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_PENTIUMMMX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_MMX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_MMX, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_PCMPEQW ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1C6F), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_SSE) ZYDIS_NOTMIN(ZYDIS_ISA_SET_SSE2) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_SSE2) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_SSE4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_PCMPEQW ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1C71), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_SSE) ZYDIS_NOTMIN(ZYDIS_ISA_SET_SSE2) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_SSE2) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_SSE4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_PCMPESTRI ZYDIS_NOTMIN(7) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x5E), 6, 0 ZYDIS_NOTMIN(0x36), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_SSE) ZYDIS_NOTMIN(ZYDIS_ISA_SET_SSE42) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_SSE4) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_SSE4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_PCMPESTRI ZYDIS_NOTMIN(7) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x65), 6, 0 ZYDIS_NOTMIN(0x36), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_SSE) ZYDIS_NOTMIN(ZYDIS_ISA_SET_SSE42) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_SSE4) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_SSE4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_PCMPESTRI ZYDIS_NOTMIN(7) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x6C), 6, 0 ZYDIS_NOTMIN(0x36), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_SSE) ZYDIS_NOTMIN(ZYDIS_ISA_SET_SSE42) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_SSE4) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_SSE4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_PCMPESTRI ZYDIS_NOTMIN(7) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x73), 6, 0 ZYDIS_NOTMIN(0x36), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_SSE) ZYDIS_NOTMIN(ZYDIS_ISA_SET_SSE42) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_SSE4) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_SSE4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_PCMPESTRM ZYDIS_NOTMIN(7) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x7A), 6, 0 ZYDIS_NOTMIN(0x36), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_SSE) ZYDIS_NOTMIN(ZYDIS_ISA_SET_SSE42) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_SSE4) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_SSE4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_PCMPESTRM ZYDIS_NOTMIN(7) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x81), 6, 0 ZYDIS_NOTMIN(0x36), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_SSE) ZYDIS_NOTMIN(ZYDIS_ISA_SET_SSE42) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_SSE4) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_SSE4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_PCMPESTRM ZYDIS_NOTMIN(7) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x88), 6, 0 ZYDIS_NOTMIN(0x36), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_SSE) ZYDIS_NOTMIN(ZYDIS_ISA_SET_SSE42) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_SSE4) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_SSE4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_PCMPESTRM ZYDIS_NOTMIN(7) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x8F), 6, 0 ZYDIS_NOTMIN(0x36), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_SSE) ZYDIS_NOTMIN(ZYDIS_ISA_SET_SSE42) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_SSE4) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_SSE4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_PCMPGTB ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1C7F), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_MMX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_PENTIUMMMX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_MMX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_MMX, ZYDIS_REGKIND_MMX ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_PCMPGTB ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1C81), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_MMX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_PENTIUMMMX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_MMX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_MMX, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_PCMPGTB ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1C83), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_SSE) ZYDIS_NOTMIN(ZYDIS_ISA_SET_SSE2) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_SSE2) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_SSE4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_PCMPGTB ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1C85), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_SSE) ZYDIS_NOTMIN(ZYDIS_ISA_SET_SSE2) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_SSE2) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_SSE4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_PCMPGTD ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1C67), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_MMX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_PENTIUMMMX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_MMX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_MMX, ZYDIS_REGKIND_MMX ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_PCMPGTD ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1C69), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_MMX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_PENTIUMMMX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_MMX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_MMX, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_PCMPGTD ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xF60), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_SSE) ZYDIS_NOTMIN(ZYDIS_ISA_SET_SSE2) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_SSE2) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_SSE4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_PCMPGTD ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xF63), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_SSE) ZYDIS_NOTMIN(ZYDIS_ISA_SET_SSE2) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_SSE2) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_SSE4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_PCMPGTQ ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xF60), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_SSE) ZYDIS_NOTMIN(ZYDIS_ISA_SET_SSE42) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_SSE4) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_SSE4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_PCMPGTQ ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xF63), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_SSE) ZYDIS_NOTMIN(ZYDIS_ISA_SET_SSE42) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_SSE4) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_SSE4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_PCMPGTW ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1C6B), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_MMX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_PENTIUMMMX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_MMX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_MMX, ZYDIS_REGKIND_MMX ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_PCMPGTW ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1C6D), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_MMX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_PENTIUMMMX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_MMX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_MMX, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_PCMPGTW ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1C6F), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_SSE) ZYDIS_NOTMIN(ZYDIS_ISA_SET_SSE2) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_SSE2) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_SSE4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_PCMPGTW ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1C71), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_SSE) ZYDIS_NOTMIN(ZYDIS_ISA_SET_SSE2) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_SSE2) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_SSE4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_PCMPISTRI ZYDIS_NOTMIN(5) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x11C), 6, 0 ZYDIS_NOTMIN(0x36), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_SSE) ZYDIS_NOTMIN(ZYDIS_ISA_SET_SSE42) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_SSE4) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_SSE4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_PCMPISTRI ZYDIS_NOTMIN(5) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x121), 6, 0 ZYDIS_NOTMIN(0x36), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_SSE) ZYDIS_NOTMIN(ZYDIS_ISA_SET_SSE42) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_SSE4) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_SSE4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_PCMPISTRM ZYDIS_NOTMIN(5) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x126), 6, 0 ZYDIS_NOTMIN(0x36), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_SSE) ZYDIS_NOTMIN(ZYDIS_ISA_SET_SSE42) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_SSE4) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_SSE4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_PCMPISTRM ZYDIS_NOTMIN(5) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x12B), 6, 0 ZYDIS_NOTMIN(0x36), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_SSE) ZYDIS_NOTMIN(ZYDIS_ISA_SET_SSE42) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_SSE4) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_SSE4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_PCOMMIT ZYDIS_NOTMIN(0) ZYDIS_NOTMIN(0) ZYDIS_NOTMIN(0x0), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_PCOMMIT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_PCOMMIT) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_PCOMMIT) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, 0 ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_PCONFIG ZYDIS_NOTMIN(5) ZYDIS_NOTMIN(0) ZYDIS_NOTMIN(0x130), 0, 0 ZYDIS_NOTMIN(0x41), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_PCONFIG) ZYDIS_NOTMIN(ZYDIS_ISA_SET_PCONFIG) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_PCONFIG) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, 0 ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_PCONFIG ZYDIS_NOTMIN(5) ZYDIS_NOTMIN(0) ZYDIS_NOTMIN(0x135), 0, 0 ZYDIS_NOTMIN(0x41), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_PCONFIG) ZYDIS_NOTMIN(ZYDIS_ISA_SET_PCONFIG) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_PCONFIG) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, 0 ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_PEXTRB ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0xF6C), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_SSE) ZYDIS_NOTMIN(ZYDIS_ISA_SET_SSE4) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_SSE4) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_SSE5), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_GPR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_PEXTRB ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0xF6F), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_SSE) ZYDIS_NOTMIN(ZYDIS_ISA_SET_SSE4) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_SSE4) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_SSE5), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_PEXTRD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0xE46), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_SSE) ZYDIS_NOTMIN(ZYDIS_ISA_SET_SSE4) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_SSE4) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_SSE5), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_GPR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_PEXTRD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0xF72), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_SSE) ZYDIS_NOTMIN(ZYDIS_ISA_SET_SSE4) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_SSE4) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_SSE5), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_PEXTRQ ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0xF75), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_SSE) ZYDIS_NOTMIN(ZYDIS_ISA_SET_SSE4) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_SSE4) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_SSE5), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_GPR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_PEXTRQ ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0xF78), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_SSE) ZYDIS_NOTMIN(ZYDIS_ISA_SET_SSE4) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_SSE4) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_SSE5), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_PEXTRW ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0xF7B), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_MMX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_PENTIUMMMX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_MMX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_GPR, ZYDIS_REGKIND_MMX ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_PEXTRW ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0xF7E), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_SSE) ZYDIS_NOTMIN(ZYDIS_ISA_SET_SSE2) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_SSE2) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_SSE5), ZYDIS_REGKIND_GPR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_PEXTRW ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0xF81), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_SSE) ZYDIS_NOTMIN(ZYDIS_ISA_SET_SSE4) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_SSE4) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_SSE5), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_GPR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_PEXTRW ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0xF84), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_SSE) ZYDIS_NOTMIN(ZYDIS_ISA_SET_SSE4) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_SSE4) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_SSE5), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_PHADDD ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xF5A), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_MMX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_SSSE3MMX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_SSSE3) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_MMX, ZYDIS_REGKIND_MMX ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_PHADDD ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xF5D), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_MMX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_SSSE3MMX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_SSSE3) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_MMX, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_PHADDD ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xF60), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_SSE) ZYDIS_NOTMIN(ZYDIS_ISA_SET_SSSE3) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_SSSE3) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_SSE4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_PHADDD ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xF63), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_SSE) ZYDIS_NOTMIN(ZYDIS_ISA_SET_SSSE3) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_SSSE3) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_SSE4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_PHADDSW ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xF5A), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_MMX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_SSSE3MMX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_SSSE3) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_MMX, ZYDIS_REGKIND_MMX ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_PHADDSW ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xF5D), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_MMX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_SSSE3MMX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_SSSE3) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_MMX, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_PHADDSW ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xF60), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_SSE) ZYDIS_NOTMIN(ZYDIS_ISA_SET_SSSE3) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_SSSE3) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_SSE4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_PHADDSW ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xF63), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_SSE) ZYDIS_NOTMIN(ZYDIS_ISA_SET_SSSE3) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_SSSE3) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_SSE4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_PHADDW ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xF5A), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_MMX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_SSSE3MMX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_SSSE3) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_MMX, ZYDIS_REGKIND_MMX ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_PHADDW ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xF5D), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_MMX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_SSSE3MMX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_SSSE3) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_MMX, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_PHADDW ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xF60), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_SSE) ZYDIS_NOTMIN(ZYDIS_ISA_SET_SSSE3) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_SSSE3) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_SSE4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_PHADDW ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xF63), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_SSE) ZYDIS_NOTMIN(ZYDIS_ISA_SET_SSSE3) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_SSSE3) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_SSE4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_PHMINPOSUW ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xDAD), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_SSE) ZYDIS_NOTMIN(ZYDIS_ISA_SET_SSE4) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_SSE4) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_SSE4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_PHMINPOSUW ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xDB0), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_SSE) ZYDIS_NOTMIN(ZYDIS_ISA_SET_SSE4) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_SSE4) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_SSE4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_PHSUBD ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xF5A), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_MMX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_SSSE3MMX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_SSSE3) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_MMX, ZYDIS_REGKIND_MMX ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_PHSUBD ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xF5D), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_MMX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_SSSE3MMX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_SSSE3) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_MMX, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_PHSUBD ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xF60), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_SSE) ZYDIS_NOTMIN(ZYDIS_ISA_SET_SSSE3) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_SSSE3) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_SSE4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_PHSUBD ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xF63), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_SSE) ZYDIS_NOTMIN(ZYDIS_ISA_SET_SSSE3) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_SSSE3) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_SSE4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_PHSUBSW ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xF5A), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_MMX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_SSSE3MMX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_SSSE3) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_MMX, ZYDIS_REGKIND_MMX ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_PHSUBSW ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xF5D), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_MMX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_SSSE3MMX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_SSSE3) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_MMX, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_PHSUBSW ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xF60), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_SSE) ZYDIS_NOTMIN(ZYDIS_ISA_SET_SSSE3) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_SSSE3) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_SSE4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_PHSUBSW ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xF63), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_SSE) ZYDIS_NOTMIN(ZYDIS_ISA_SET_SSSE3) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_SSSE3) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_SSE4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_PHSUBW ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xF5A), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_MMX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_SSSE3MMX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_SSSE3) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_MMX, ZYDIS_REGKIND_MMX ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_PHSUBW ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xF5D), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_MMX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_SSSE3MMX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_SSSE3) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_MMX, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_PHSUBW ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xF60), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_SSE) ZYDIS_NOTMIN(ZYDIS_ISA_SET_SSSE3) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_SSSE3) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_SSE4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_PHSUBW ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xF63), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_SSE) ZYDIS_NOTMIN(ZYDIS_ISA_SET_SSSE3) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_SSSE3) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_SSE4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_PINSRB ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0xF87), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_SSE) ZYDIS_NOTMIN(ZYDIS_ISA_SET_SSE4) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_SSE4) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_SSE5), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_GPR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_PINSRB ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0xF8A), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_SSE) ZYDIS_NOTMIN(ZYDIS_ISA_SET_SSE4) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_SSE4) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_SSE5), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_PINSRD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0xF87), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_SSE) ZYDIS_NOTMIN(ZYDIS_ISA_SET_SSE4) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_SSE4) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_SSE5), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_GPR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_PINSRD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0xF8D), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_SSE) ZYDIS_NOTMIN(ZYDIS_ISA_SET_SSE4) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_SSE4) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_SSE5), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_PINSRQ ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0xF90), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_SSE) ZYDIS_NOTMIN(ZYDIS_ISA_SET_SSE4) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_SSE4) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_SSE5), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_GPR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_PINSRQ ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0xF93), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_SSE) ZYDIS_NOTMIN(ZYDIS_ISA_SET_SSE4) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_SSE4) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_SSE5), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_PINSRW ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0xF96), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_MMX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_PENTIUMMMX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_MMX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_MMX, ZYDIS_REGKIND_GPR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_PINSRW ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0xF99), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_MMX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_PENTIUMMMX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_MMX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_MMX, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_PINSRW ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0xF9C), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_SSE) ZYDIS_NOTMIN(ZYDIS_ISA_SET_SSE2) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_SSE2) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_SSE5), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_GPR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_PINSRW ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0xF9F), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_SSE) ZYDIS_NOTMIN(ZYDIS_ISA_SET_SSE2) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_SSE2) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_SSE5), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_PMADDUBSW ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1C7F), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_MMX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_SSSE3MMX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_SSSE3) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_MMX, ZYDIS_REGKIND_MMX ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_PMADDUBSW ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1C81), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_MMX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_SSSE3MMX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_SSSE3) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_MMX, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_PMADDUBSW ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1C83), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_SSE) ZYDIS_NOTMIN(ZYDIS_ISA_SET_SSSE3) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_SSSE3) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_SSE4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_PMADDUBSW ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1C85), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_SSE) ZYDIS_NOTMIN(ZYDIS_ISA_SET_SSSE3) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_SSSE3) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_SSE4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_PMADDWD ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1C6B), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_MMX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_PENTIUMMMX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_MMX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_MMX, ZYDIS_REGKIND_MMX ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_PMADDWD ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1C6D), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_MMX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_PENTIUMMMX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_MMX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_MMX, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_PMADDWD ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1C6F), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_SSE) ZYDIS_NOTMIN(ZYDIS_ISA_SET_SSE2) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_SSE2) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_SSE4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_PMADDWD ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1C71), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_SSE) ZYDIS_NOTMIN(ZYDIS_ISA_SET_SSE2) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_SSE2) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_SSE4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_PMAXSB ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xF60), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_SSE) ZYDIS_NOTMIN(ZYDIS_ISA_SET_SSE4) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_SSE4) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_SSE4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_PMAXSB ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xF63), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_SSE) ZYDIS_NOTMIN(ZYDIS_ISA_SET_SSE4) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_SSE4) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_SSE4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_PMAXSD ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xF60), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_SSE) ZYDIS_NOTMIN(ZYDIS_ISA_SET_SSE4) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_SSE4) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_SSE4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_PMAXSD ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xF63), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_SSE) ZYDIS_NOTMIN(ZYDIS_ISA_SET_SSE4) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_SSE4) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_SSE4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_PMAXSW ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xF5A), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_MMX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_PENTIUMMMX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_MMX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_MMX, ZYDIS_REGKIND_MMX ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_PMAXSW ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xF5D), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_MMX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_PENTIUMMMX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_MMX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_MMX, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_PMAXSW ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xF60), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_SSE) ZYDIS_NOTMIN(ZYDIS_ISA_SET_SSE2) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_SSE2) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_SSE4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_PMAXSW ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xF63), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_SSE) ZYDIS_NOTMIN(ZYDIS_ISA_SET_SSE2) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_SSE2) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_SSE4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_PMAXUB ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xF5A), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_MMX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_PENTIUMMMX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_MMX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_MMX, ZYDIS_REGKIND_MMX ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_PMAXUB ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xF5D), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_MMX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_PENTIUMMMX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_MMX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_MMX, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_PMAXUB ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xF60), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_SSE) ZYDIS_NOTMIN(ZYDIS_ISA_SET_SSE2) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_SSE2) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_SSE4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_PMAXUB ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xF63), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_SSE) ZYDIS_NOTMIN(ZYDIS_ISA_SET_SSE2) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_SSE2) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_SSE4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_PMAXUD ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xF60), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_SSE) ZYDIS_NOTMIN(ZYDIS_ISA_SET_SSE4) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_SSE4) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_SSE4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_PMAXUD ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xF63), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_SSE) ZYDIS_NOTMIN(ZYDIS_ISA_SET_SSE4) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_SSE4) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_SSE4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_PMAXUW ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xF60), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_SSE) ZYDIS_NOTMIN(ZYDIS_ISA_SET_SSE4) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_SSE4) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_SSE4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_PMAXUW ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xF63), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_SSE) ZYDIS_NOTMIN(ZYDIS_ISA_SET_SSE4) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_SSE4) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_SSE4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_PMINSB ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xF60), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_SSE) ZYDIS_NOTMIN(ZYDIS_ISA_SET_SSE4) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_SSE4) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_SSE4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_PMINSB ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xF63), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_SSE) ZYDIS_NOTMIN(ZYDIS_ISA_SET_SSE4) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_SSE4) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_SSE4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_PMINSD ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xF60), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_SSE) ZYDIS_NOTMIN(ZYDIS_ISA_SET_SSE4) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_SSE4) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_SSE4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_PMINSD ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xF63), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_SSE) ZYDIS_NOTMIN(ZYDIS_ISA_SET_SSE4) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_SSE4) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_SSE4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_PMINSW ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xF5A), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_MMX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_PENTIUMMMX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_MMX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_MMX, ZYDIS_REGKIND_MMX ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_PMINSW ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xF5D), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_MMX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_PENTIUMMMX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_MMX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_MMX, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_PMINSW ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xF60), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_SSE) ZYDIS_NOTMIN(ZYDIS_ISA_SET_SSE2) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_SSE2) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_SSE4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_PMINSW ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xF63), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_SSE) ZYDIS_NOTMIN(ZYDIS_ISA_SET_SSE2) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_SSE2) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_SSE4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_PMINUB ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xF5A), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_MMX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_PENTIUMMMX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_MMX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_MMX, ZYDIS_REGKIND_MMX ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_PMINUB ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xF5D), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_MMX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_PENTIUMMMX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_MMX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_MMX, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_PMINUB ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xF60), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_SSE) ZYDIS_NOTMIN(ZYDIS_ISA_SET_SSE2) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_SSE2) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_SSE4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_PMINUB ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xF63), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_SSE) ZYDIS_NOTMIN(ZYDIS_ISA_SET_SSE2) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_SSE2) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_SSE4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_PMINUD ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xF60), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_SSE) ZYDIS_NOTMIN(ZYDIS_ISA_SET_SSE4) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_SSE4) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_SSE4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_PMINUD ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xF63), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_SSE) ZYDIS_NOTMIN(ZYDIS_ISA_SET_SSE4) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_SSE4) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_SSE4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_PMINUW ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xF60), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_SSE) ZYDIS_NOTMIN(ZYDIS_ISA_SET_SSE4) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_SSE4) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_SSE4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_PMINUW ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xF63), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_SSE) ZYDIS_NOTMIN(ZYDIS_ISA_SET_SSE4) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_SSE4) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_SSE4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_PMOVMSKB ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1C87), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_MMX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_SSE) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_MMX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_GPR, ZYDIS_REGKIND_MMX ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_PMOVMSKB ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1C89), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_SSE) ZYDIS_NOTMIN(ZYDIS_ISA_SET_SSE2) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_SSE2) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_SSE7), ZYDIS_REGKIND_GPR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_PMOVSXBD ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1C8B), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_SSE) ZYDIS_NOTMIN(ZYDIS_ISA_SET_SSE4) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_SSE4) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_SSE5), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_PMOVSXBD ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1C8D), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_SSE) ZYDIS_NOTMIN(ZYDIS_ISA_SET_SSE4) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_SSE4) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_SSE5), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_PMOVSXBQ ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1C8F), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_SSE) ZYDIS_NOTMIN(ZYDIS_ISA_SET_SSE4) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_SSE4) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_SSE5), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_PMOVSXBQ ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1C91), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_SSE) ZYDIS_NOTMIN(ZYDIS_ISA_SET_SSE4) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_SSE4) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_SSE5), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_PMOVSXBW ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1C93), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_SSE) ZYDIS_NOTMIN(ZYDIS_ISA_SET_SSE4) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_SSE4) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_SSE5), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_PMOVSXBW ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1C95), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_SSE) ZYDIS_NOTMIN(ZYDIS_ISA_SET_SSE4) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_SSE4) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_SSE5), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_PMOVSXDQ ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1C97), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_SSE) ZYDIS_NOTMIN(ZYDIS_ISA_SET_SSE4) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_SSE4) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_SSE5), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_PMOVSXDQ ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1C99), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_SSE) ZYDIS_NOTMIN(ZYDIS_ISA_SET_SSE4) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_SSE4) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_SSE5), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_PMOVSXWD ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1C9B), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_SSE) ZYDIS_NOTMIN(ZYDIS_ISA_SET_SSE4) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_SSE4) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_SSE5), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_PMOVSXWD ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1C9D), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_SSE) ZYDIS_NOTMIN(ZYDIS_ISA_SET_SSE4) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_SSE4) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_SSE5), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_PMOVSXWQ ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1C9F), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_SSE) ZYDIS_NOTMIN(ZYDIS_ISA_SET_SSE4) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_SSE4) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_SSE5), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_PMOVSXWQ ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1CA1), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_SSE) ZYDIS_NOTMIN(ZYDIS_ISA_SET_SSE4) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_SSE4) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_SSE5), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_PMOVZXBD ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1CA3), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_SSE) ZYDIS_NOTMIN(ZYDIS_ISA_SET_SSE4) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_SSE4) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_SSE5), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_PMOVZXBD ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1CA5), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_SSE) ZYDIS_NOTMIN(ZYDIS_ISA_SET_SSE4) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_SSE4) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_SSE5), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_PMOVZXBQ ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1CA7), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_SSE) ZYDIS_NOTMIN(ZYDIS_ISA_SET_SSE4) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_SSE4) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_SSE5), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_PMOVZXBQ ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1CA9), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_SSE) ZYDIS_NOTMIN(ZYDIS_ISA_SET_SSE4) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_SSE4) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_SSE5), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_PMOVZXBW ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1CAB), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_SSE) ZYDIS_NOTMIN(ZYDIS_ISA_SET_SSE4) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_SSE4) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_SSE5), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_PMOVZXBW ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1CAD), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_SSE) ZYDIS_NOTMIN(ZYDIS_ISA_SET_SSE4) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_SSE4) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_SSE5), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_PMOVZXDQ ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1CAF), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_SSE) ZYDIS_NOTMIN(ZYDIS_ISA_SET_SSE4) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_SSE4) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_SSE5), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_PMOVZXDQ ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1CB1), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_SSE) ZYDIS_NOTMIN(ZYDIS_ISA_SET_SSE4) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_SSE4) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_SSE5), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_PMOVZXWD ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1CB3), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_SSE) ZYDIS_NOTMIN(ZYDIS_ISA_SET_SSE4) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_SSE4) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_SSE5), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_PMOVZXWD ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1CB5), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_SSE) ZYDIS_NOTMIN(ZYDIS_ISA_SET_SSE4) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_SSE4) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_SSE5), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_PMOVZXWQ ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1CB7), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_SSE) ZYDIS_NOTMIN(ZYDIS_ISA_SET_SSE4) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_SSE4) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_SSE5), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_PMOVZXWQ ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1CB9), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_SSE) ZYDIS_NOTMIN(ZYDIS_ISA_SET_SSE4) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_SSE4) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_SSE5), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_PMULDQ ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xF60), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_SSE) ZYDIS_NOTMIN(ZYDIS_ISA_SET_SSE4) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_SSE4) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_SSE4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_PMULDQ ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xF63), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_SSE) ZYDIS_NOTMIN(ZYDIS_ISA_SET_SSE4) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_SSE4) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_SSE4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_PMULHRSW ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xF5A), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_MMX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_SSSE3MMX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_SSSE3) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_MMX, ZYDIS_REGKIND_MMX ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_PMULHRSW ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xF5D), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_MMX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_SSSE3MMX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_SSSE3) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_MMX, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_PMULHRSW ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xF60), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_SSE) ZYDIS_NOTMIN(ZYDIS_ISA_SET_SSSE3) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_SSSE3) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_SSE4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_PMULHRSW ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xF63), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_SSE) ZYDIS_NOTMIN(ZYDIS_ISA_SET_SSSE3) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_SSSE3) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_SSE4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_PMULHUW ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1C77), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_MMX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_PENTIUMMMX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_MMX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_MMX, ZYDIS_REGKIND_MMX ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_PMULHUW ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1C79), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_MMX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_PENTIUMMMX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_MMX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_MMX, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_PMULHUW ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1C7B), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_SSE) ZYDIS_NOTMIN(ZYDIS_ISA_SET_SSE2) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_SSE2) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_SSE4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_PMULHUW ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1C7D), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_SSE) ZYDIS_NOTMIN(ZYDIS_ISA_SET_SSE2) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_SSE2) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_SSE4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_PMULHW ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1C6B), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_MMX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_PENTIUMMMX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_MMX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_MMX, ZYDIS_REGKIND_MMX ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_PMULHW ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1C6D), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_MMX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_PENTIUMMMX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_MMX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_MMX, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_PMULHW ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1C6F), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_SSE) ZYDIS_NOTMIN(ZYDIS_ISA_SET_SSE2) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_SSE2) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_SSE4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_PMULHW ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1C71), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_SSE) ZYDIS_NOTMIN(ZYDIS_ISA_SET_SSE2) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_SSE2) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_SSE4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_PMULLD ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xF60), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_SSE) ZYDIS_NOTMIN(ZYDIS_ISA_SET_SSE4) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_SSE4) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_SSE4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_PMULLD ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xF63), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_SSE) ZYDIS_NOTMIN(ZYDIS_ISA_SET_SSE4) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_SSE4) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_SSE4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_PMULLW ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1C6B), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_MMX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_PENTIUMMMX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_MMX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_MMX, ZYDIS_REGKIND_MMX ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_PMULLW ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1C6D), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_MMX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_PENTIUMMMX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_MMX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_MMX, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_PMULLW ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xF60), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_SSE) ZYDIS_NOTMIN(ZYDIS_ISA_SET_SSE2) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_SSE2) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_SSE4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_PMULLW ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xF63), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_SSE) ZYDIS_NOTMIN(ZYDIS_ISA_SET_SSE2) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_SSE2) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_SSE4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_PMULUDQ ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1CBB), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_MMX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_SSE2MMX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_SSE2) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_MMX, ZYDIS_REGKIND_MMX ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_PMULUDQ ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1CBD), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_MMX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_SSE2MMX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_SSE2) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_MMX, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_PMULUDQ ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1CBF), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_SSE) ZYDIS_NOTMIN(ZYDIS_ISA_SET_SSE2) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_SSE2) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_SSE4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_PMULUDQ ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1CC1), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_SSE) ZYDIS_NOTMIN(ZYDIS_ISA_SET_SSE2) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_SSE2) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_SSE4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_POP ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(1) ZYDIS_NOTMIN(0xFA2), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_POP) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I86) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, 0 ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_POP ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(1) ZYDIS_NOTMIN(0xFA5), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_POP) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I86) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, 0 ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_POP ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(1) ZYDIS_NOTMIN(0xFA8), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_POP) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I86) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, 0 ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_POP ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(1) ZYDIS_NOTMIN(0xFAB), 4, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_POP) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I86) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, 0 ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_POP ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(1) ZYDIS_NOTMIN(0xFAE), 4, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_POP) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I86) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, ZYDIS_REGKIND_GPR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_POP ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(1) ZYDIS_NOTMIN(0xFB1), 4, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_POP) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I86) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_POP ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(1) ZYDIS_NOTMIN(0xFB4), 4, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_POP) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I86) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, 0 ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_POP ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(1) ZYDIS_NOTMIN(0xFB7), 4, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_POP) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I86) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, 0 ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_POPA ZYDIS_NOTMIN(9) ZYDIS_NOTMIN(0) ZYDIS_NOTMIN(0x3B), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_POP) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I186) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, 0 ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_POPAD ZYDIS_NOTMIN(9) ZYDIS_NOTMIN(0) ZYDIS_NOTMIN(0x44), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_POP) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I386) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, 0 ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_POPCNT ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xF21), 0, 0 ZYDIS_NOTMIN(0x41), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_SSE) ZYDIS_NOTMIN(ZYDIS_ISA_SET_POPCNT) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_SSE4) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_GPR, ZYDIS_REGKIND_GPR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_POPCNT ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xF24), 0, 0 ZYDIS_NOTMIN(0x41), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_SSE) ZYDIS_NOTMIN(ZYDIS_ISA_SET_POPCNT) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_SSE4) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_GPR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_POPF ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0) ZYDIS_NOTMIN(0xFBA), 4, 0 ZYDIS_NOTMIN(0x2F), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_POP) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I86) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, 0 ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_POPFD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0) ZYDIS_NOTMIN(0xFBD), 4, 0 ZYDIS_NOTMIN(0x2F), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_POP) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I386) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, 0 ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_POPFQ ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0) ZYDIS_NOTMIN(0xFC0), 4, 0 ZYDIS_NOTMIN(0x2F), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_POP) ZYDIS_NOTMIN(ZYDIS_ISA_SET_LONGMODE) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_LONGMODE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, 0 ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_POR ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xF5A), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_LOGICAL) ZYDIS_NOTMIN(ZYDIS_ISA_SET_PENTIUMMMX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_MMX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_MMX, ZYDIS_REGKIND_MMX ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_POR ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xF5D), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_LOGICAL) ZYDIS_NOTMIN(ZYDIS_ISA_SET_PENTIUMMMX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_MMX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_MMX, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_POR ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xF60), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_LOGICAL) ZYDIS_NOTMIN(ZYDIS_ISA_SET_SSE2) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_SSE2) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_SSE4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_POR ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xF63), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_LOGICAL) ZYDIS_NOTMIN(ZYDIS_ISA_SET_SSE2) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_SSE2) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_SSE4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_PREFETCH ZYDIS_NOTMIN(1) ZYDIS_NOTMIN(1) ZYDIS_NOTMIN(0x1F02), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_PREFETCH) ZYDIS_NOTMIN(ZYDIS_ISA_SET_PREFETCH_NOP) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AMD3DNOW_PREFETCH) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_PREFETCHIT0 ZYDIS_NOTMIN(1) ZYDIS_NOTMIN(1) ZYDIS_NOTMIN(0x5EC), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_PREFETCH) ZYDIS_NOTMIN(ZYDIS_ISA_SET_ICACHE_PREFETCH) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_ICACHE_PREFETCH) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_PREFETCHIT1 ZYDIS_NOTMIN(1) ZYDIS_NOTMIN(1) ZYDIS_NOTMIN(0x5EC), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_PREFETCH) ZYDIS_NOTMIN(ZYDIS_ISA_SET_ICACHE_PREFETCH) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_ICACHE_PREFETCH) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_PREFETCHNTA ZYDIS_NOTMIN(1) ZYDIS_NOTMIN(1) ZYDIS_NOTMIN(0x1F02), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_PREFETCH) ZYDIS_NOTMIN(ZYDIS_ISA_SET_SSE_PREFETCH) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_SSE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_PREFETCHT0 ZYDIS_NOTMIN(1) ZYDIS_NOTMIN(1) ZYDIS_NOTMIN(0x1F02), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_PREFETCH) ZYDIS_NOTMIN(ZYDIS_ISA_SET_SSE_PREFETCH) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_SSE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_PREFETCHT1 ZYDIS_NOTMIN(1) ZYDIS_NOTMIN(1) ZYDIS_NOTMIN(0x1F02), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_PREFETCH) ZYDIS_NOTMIN(ZYDIS_ISA_SET_SSE_PREFETCH) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_SSE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_PREFETCHT2 ZYDIS_NOTMIN(1) ZYDIS_NOTMIN(1) ZYDIS_NOTMIN(0x1F02), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_PREFETCH) ZYDIS_NOTMIN(ZYDIS_ISA_SET_SSE_PREFETCH) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_SSE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_PREFETCHW ZYDIS_NOTMIN(1) ZYDIS_NOTMIN(1) ZYDIS_NOTMIN(0x1F02), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_PREFETCH) ZYDIS_NOTMIN(ZYDIS_ISA_SET_PREFETCH_NOP) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AMD3DNOW_PREFETCH) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_PREFETCHWT1 ZYDIS_NOTMIN(1) ZYDIS_NOTMIN(1) ZYDIS_NOTMIN(0x5EC), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_PREFETCHWT1) ZYDIS_NOTMIN(ZYDIS_ISA_SET_PREFETCHWT1) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_PREFETCHWT1) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_PSADBW ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xF5A), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_MMX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_PENTIUMMMX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_MMX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_MMX, ZYDIS_REGKIND_MMX ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_PSADBW ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xF5D), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_MMX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_PENTIUMMMX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_MMX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_MMX, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_PSADBW ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xF60), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_SSE) ZYDIS_NOTMIN(ZYDIS_ISA_SET_SSE2) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_SSE2) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_SSE4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_PSADBW ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xF63), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_SSE) ZYDIS_NOTMIN(ZYDIS_ISA_SET_SSE2) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_SSE2) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_SSE4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_PSHUFB ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xF5A), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_MMX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_SSSE3MMX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_SSSE3) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_MMX, ZYDIS_REGKIND_MMX ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_PSHUFB ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xF5D), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_MMX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_SSSE3MMX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_SSSE3) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_MMX, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_PSHUFB ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xF60), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_SSE) ZYDIS_NOTMIN(ZYDIS_ISA_SET_SSSE3) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_SSSE3) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_SSE4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_PSHUFB ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xF63), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_SSE) ZYDIS_NOTMIN(ZYDIS_ISA_SET_SSSE3) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_SSSE3) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_SSE4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_PSHUFD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0xFC3), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_SSE) ZYDIS_NOTMIN(ZYDIS_ISA_SET_SSE2) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_SSE2) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_SSE4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_PSHUFD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0xFC6), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_SSE) ZYDIS_NOTMIN(ZYDIS_ISA_SET_SSE2) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_SSE2) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_SSE4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_PSHUFHW ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0xFC9), 2, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_SSE) ZYDIS_NOTMIN(ZYDIS_ISA_SET_SSE2) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_SSE2) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_SSE4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_PSHUFHW ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0xFCC), 2, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_SSE) ZYDIS_NOTMIN(ZYDIS_ISA_SET_SSE2) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_SSE2) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_SSE4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_PSHUFLW ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0xFC9), 2, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_SSE) ZYDIS_NOTMIN(ZYDIS_ISA_SET_SSE2) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_SSE2) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_SSE4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_PSHUFLW ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0xFCC), 2, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_SSE) ZYDIS_NOTMIN(ZYDIS_ISA_SET_SSE2) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_SSE2) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_SSE4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_PSHUFW ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0xFCF), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_MMX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_PENTIUMMMX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_MMX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_MMX, ZYDIS_REGKIND_MMX ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_PSHUFW ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0xFD2), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_MMX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_PENTIUMMMX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_MMX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_MMX, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_PSIGNB ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xF5A), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_MMX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_SSSE3MMX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_SSSE3) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_MMX, ZYDIS_REGKIND_MMX ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_PSIGNB ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xF5D), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_MMX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_SSSE3MMX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_SSSE3) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_MMX, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_PSIGNB ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xF60), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_SSE) ZYDIS_NOTMIN(ZYDIS_ISA_SET_SSSE3) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_SSSE3) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_SSE4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_PSIGNB ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xF63), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_SSE) ZYDIS_NOTMIN(ZYDIS_ISA_SET_SSSE3) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_SSSE3) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_SSE4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_PSIGND ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xF5A), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_MMX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_SSSE3MMX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_SSSE3) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_MMX, ZYDIS_REGKIND_MMX ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_PSIGND ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xF5D), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_MMX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_SSSE3MMX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_SSSE3) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_MMX, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_PSIGND ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xF60), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_SSE) ZYDIS_NOTMIN(ZYDIS_ISA_SET_SSSE3) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_SSSE3) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_SSE4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_PSIGND ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xF63), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_SSE) ZYDIS_NOTMIN(ZYDIS_ISA_SET_SSSE3) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_SSSE3) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_SSE4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_PSIGNW ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xF5A), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_MMX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_SSSE3MMX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_SSSE3) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_MMX, ZYDIS_REGKIND_MMX ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_PSIGNW ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xF5D), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_MMX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_SSSE3MMX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_SSSE3) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_MMX, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_PSIGNW ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xF60), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_SSE) ZYDIS_NOTMIN(ZYDIS_ISA_SET_SSSE3) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_SSSE3) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_SSE4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_PSIGNW ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xF63), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_SSE) ZYDIS_NOTMIN(ZYDIS_ISA_SET_SSSE3) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_SSSE3) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_SSE4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_PSLLD ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1CC3), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_MMX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_PENTIUMMMX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_MMX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, ZYDIS_REGKIND_MMX ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_PSLLD ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1CC5), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_SSE) ZYDIS_NOTMIN(ZYDIS_ISA_SET_SSE2) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_SSE2) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_SSE7), 0, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_PSLLD ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1CC7), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_MMX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_PENTIUMMMX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_MMX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_MMX, ZYDIS_REGKIND_MMX ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_PSLLD ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1CC9), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_MMX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_PENTIUMMMX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_MMX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_MMX, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_PSLLD ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1CBF), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_SSE) ZYDIS_NOTMIN(ZYDIS_ISA_SET_SSE2) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_SSE2) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_SSE7), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_PSLLD ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1CC1), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_SSE) ZYDIS_NOTMIN(ZYDIS_ISA_SET_SSE2) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_SSE2) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_SSE4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_PSLLDQ ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1CCB), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_SSE) ZYDIS_NOTMIN(ZYDIS_ISA_SET_SSE2) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_SSE2) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_SSE7), 0, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_PSLLQ ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1CCD), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_MMX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_PENTIUMMMX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_MMX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, ZYDIS_REGKIND_MMX ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_PSLLQ ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1CCF), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_SSE) ZYDIS_NOTMIN(ZYDIS_ISA_SET_SSE2) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_SSE2) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_SSE7), 0, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_PSLLQ ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1CD1), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_MMX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_PENTIUMMMX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_MMX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_MMX, ZYDIS_REGKIND_MMX ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_PSLLQ ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1C75), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_MMX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_PENTIUMMMX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_MMX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_MMX, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_PSLLQ ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1CD3), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_SSE) ZYDIS_NOTMIN(ZYDIS_ISA_SET_SSE2) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_SSE2) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_SSE7), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_PSLLQ ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1CD5), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_SSE) ZYDIS_NOTMIN(ZYDIS_ISA_SET_SSE2) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_SSE2) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_SSE4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_PSLLW ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1CD7), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_MMX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_PENTIUMMMX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_MMX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, ZYDIS_REGKIND_MMX ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_PSLLW ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1CD9), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_SSE) ZYDIS_NOTMIN(ZYDIS_ISA_SET_SSE2) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_SSE2) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_SSE7), 0, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_PSLLW ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1CDB), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_MMX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_PENTIUMMMX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_MMX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_MMX, ZYDIS_REGKIND_MMX ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_PSLLW ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1CDD), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_MMX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_PENTIUMMMX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_MMX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_MMX, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_PSLLW ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1CDF), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_SSE) ZYDIS_NOTMIN(ZYDIS_ISA_SET_SSE2) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_SSE2) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_SSE7), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_PSLLW ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1CE1), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_SSE) ZYDIS_NOTMIN(ZYDIS_ISA_SET_SSE2) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_SSE2) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_SSE4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_PSMASH ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(1) ZYDIS_NOTMIN(0x1CE3), 0, 0 ZYDIS_NOTMIN(0x1A), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_SYSTEM) ZYDIS_NOTMIN(ZYDIS_ISA_SET_SNP) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_SNP) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, 0 ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_PSRAD ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1CE5), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_MMX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_PENTIUMMMX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_MMX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, ZYDIS_REGKIND_MMX ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_PSRAD ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1CE7), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_SSE) ZYDIS_NOTMIN(ZYDIS_ISA_SET_SSE2) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_SSE2) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_SSE7), 0, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_PSRAD ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1CE9), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_MMX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_PENTIUMMMX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_MMX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_MMX, ZYDIS_REGKIND_MMX ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_PSRAD ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1CEB), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_MMX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_PENTIUMMMX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_MMX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_MMX, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_PSRAD ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1CED), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_SSE) ZYDIS_NOTMIN(ZYDIS_ISA_SET_SSE2) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_SSE2) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_SSE7), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_PSRAD ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1CEF), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_SSE) ZYDIS_NOTMIN(ZYDIS_ISA_SET_SSE2) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_SSE2) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_SSE4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_PSRAW ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1CF1), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_MMX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_PENTIUMMMX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_MMX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, ZYDIS_REGKIND_MMX ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_PSRAW ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1CF3), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_SSE) ZYDIS_NOTMIN(ZYDIS_ISA_SET_SSE2) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_SSE2) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_SSE7), 0, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_PSRAW ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1CF5), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_MMX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_PENTIUMMMX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_MMX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_MMX, ZYDIS_REGKIND_MMX ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_PSRAW ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1CF7), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_MMX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_PENTIUMMMX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_MMX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_MMX, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_PSRAW ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1CF9), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_SSE) ZYDIS_NOTMIN(ZYDIS_ISA_SET_SSE2) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_SSE2) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_SSE7), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_PSRAW ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1CFB), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_SSE) ZYDIS_NOTMIN(ZYDIS_ISA_SET_SSE2) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_SSE2) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_SSE4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_PSRLD ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1CC3), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_MMX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_PENTIUMMMX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_MMX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, ZYDIS_REGKIND_MMX ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_PSRLD ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1CC5), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_SSE) ZYDIS_NOTMIN(ZYDIS_ISA_SET_SSE2) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_SSE2) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_SSE7), 0, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_PSRLD ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1CC7), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_MMX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_PENTIUMMMX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_MMX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_MMX, ZYDIS_REGKIND_MMX ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_PSRLD ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1CC9), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_MMX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_PENTIUMMMX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_MMX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_MMX, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_PSRLD ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1CBF), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_SSE) ZYDIS_NOTMIN(ZYDIS_ISA_SET_SSE2) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_SSE2) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_SSE7), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_PSRLD ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1CC1), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_SSE) ZYDIS_NOTMIN(ZYDIS_ISA_SET_SSE2) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_SSE2) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_SSE4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_PSRLDQ ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1CCB), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_SSE) ZYDIS_NOTMIN(ZYDIS_ISA_SET_SSE2) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_SSE2) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_SSE7), 0, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_PSRLQ ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1CCD), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_MMX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_PENTIUMMMX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_MMX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, ZYDIS_REGKIND_MMX ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_PSRLQ ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1CCF), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_SSE) ZYDIS_NOTMIN(ZYDIS_ISA_SET_SSE2) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_SSE2) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_SSE7), 0, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_PSRLQ ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1CD1), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_MMX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_PENTIUMMMX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_MMX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_MMX, ZYDIS_REGKIND_MMX ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_PSRLQ ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1C75), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_MMX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_PENTIUMMMX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_MMX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_MMX, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_PSRLQ ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1CBF), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_SSE) ZYDIS_NOTMIN(ZYDIS_ISA_SET_SSE2) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_SSE2) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_SSE7), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_PSRLQ ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1CC1), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_SSE) ZYDIS_NOTMIN(ZYDIS_ISA_SET_SSE2) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_SSE2) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_SSE4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_PSRLW ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1CD7), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_MMX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_PENTIUMMMX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_MMX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, ZYDIS_REGKIND_MMX ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_PSRLW ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1CD9), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_SSE) ZYDIS_NOTMIN(ZYDIS_ISA_SET_SSE2) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_SSE2) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_SSE7), 0, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_PSRLW ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1CDB), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_MMX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_PENTIUMMMX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_MMX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_MMX, ZYDIS_REGKIND_MMX ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_PSRLW ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1CDD), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_MMX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_PENTIUMMMX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_MMX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_MMX, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_PSRLW ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1CBF), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_SSE) ZYDIS_NOTMIN(ZYDIS_ISA_SET_SSE2) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_SSE2) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_SSE7), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_PSRLW ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1CC1), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_SSE) ZYDIS_NOTMIN(ZYDIS_ISA_SET_SSE2) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_SSE2) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_SSE4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_PSUBB ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xF5A), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_MMX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_PENTIUMMMX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_MMX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_MMX, ZYDIS_REGKIND_MMX ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_PSUBB ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xF5D), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_MMX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_PENTIUMMMX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_MMX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_MMX, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_PSUBB ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xF60), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_SSE) ZYDIS_NOTMIN(ZYDIS_ISA_SET_SSE2) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_SSE2) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_SSE4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_PSUBB ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xF63), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_SSE) ZYDIS_NOTMIN(ZYDIS_ISA_SET_SSE2) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_SSE2) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_SSE4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_PSUBD ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xF5A), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_MMX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_PENTIUMMMX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_MMX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_MMX, ZYDIS_REGKIND_MMX ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_PSUBD ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xF5D), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_MMX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_PENTIUMMMX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_MMX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_MMX, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_PSUBD ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xF60), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_SSE) ZYDIS_NOTMIN(ZYDIS_ISA_SET_SSE2) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_SSE2) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_SSE4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_PSUBD ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xF63), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_SSE) ZYDIS_NOTMIN(ZYDIS_ISA_SET_SSE2) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_SSE2) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_SSE4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_PSUBQ ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xF5A), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_MMX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_SSE2MMX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_SSE2) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_MMX, ZYDIS_REGKIND_MMX ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_PSUBQ ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xF5D), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_MMX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_SSE2MMX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_SSE2) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_MMX, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_PSUBQ ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xF60), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_SSE) ZYDIS_NOTMIN(ZYDIS_ISA_SET_SSE2) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_SSE2) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_SSE4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_PSUBQ ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xF63), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_SSE) ZYDIS_NOTMIN(ZYDIS_ISA_SET_SSE2) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_SSE2) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_SSE4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_PSUBSB ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xF5A), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_MMX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_PENTIUMMMX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_MMX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_MMX, ZYDIS_REGKIND_MMX ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_PSUBSB ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xF5D), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_MMX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_PENTIUMMMX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_MMX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_MMX, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_PSUBSB ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xF60), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_SSE) ZYDIS_NOTMIN(ZYDIS_ISA_SET_SSE2) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_SSE2) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_SSE4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_PSUBSB ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xF63), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_SSE) ZYDIS_NOTMIN(ZYDIS_ISA_SET_SSE2) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_SSE2) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_SSE4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_PSUBSW ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xF5A), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_MMX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_PENTIUMMMX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_MMX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_MMX, ZYDIS_REGKIND_MMX ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_PSUBSW ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xF5D), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_MMX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_PENTIUMMMX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_MMX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_MMX, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_PSUBSW ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xF60), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_SSE) ZYDIS_NOTMIN(ZYDIS_ISA_SET_SSE2) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_SSE2) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_SSE4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_PSUBSW ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xF63), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_SSE) ZYDIS_NOTMIN(ZYDIS_ISA_SET_SSE2) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_SSE2) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_SSE4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_PSUBUSB ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xF5A), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_MMX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_PENTIUMMMX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_MMX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_MMX, ZYDIS_REGKIND_MMX ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_PSUBUSB ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xF5D), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_MMX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_PENTIUMMMX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_MMX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_MMX, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_PSUBUSB ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xF60), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_SSE) ZYDIS_NOTMIN(ZYDIS_ISA_SET_SSE2) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_SSE2) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_SSE4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_PSUBUSB ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xF63), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_SSE) ZYDIS_NOTMIN(ZYDIS_ISA_SET_SSE2) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_SSE2) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_SSE4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_PSUBUSW ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xF5A), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_MMX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_PENTIUMMMX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_MMX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_MMX, ZYDIS_REGKIND_MMX ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_PSUBUSW ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xF5D), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_MMX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_PENTIUMMMX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_MMX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_MMX, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_PSUBUSW ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xF60), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_SSE) ZYDIS_NOTMIN(ZYDIS_ISA_SET_SSE2) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_SSE2) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_SSE4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_PSUBUSW ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xF63), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_SSE) ZYDIS_NOTMIN(ZYDIS_ISA_SET_SSE2) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_SSE2) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_SSE4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_PSUBW ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xF5A), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_MMX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_PENTIUMMMX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_MMX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_MMX, ZYDIS_REGKIND_MMX ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_PSUBW ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xF5D), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_MMX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_PENTIUMMMX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_MMX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_MMX, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_PSUBW ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xF60), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_SSE) ZYDIS_NOTMIN(ZYDIS_ISA_SET_SSE2) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_SSE2) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_SSE4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_PSUBW ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xF63), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_SSE) ZYDIS_NOTMIN(ZYDIS_ISA_SET_SSE2) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_SSE2) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_SSE4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_PTEST ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xFD5), 0, 0 ZYDIS_NOTMIN(0x37), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_LOGICAL) ZYDIS_NOTMIN(ZYDIS_ISA_SET_SSE4) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_SSE4) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_SSE4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_PTEST ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xFD8), 0, 0 ZYDIS_NOTMIN(0x37), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_LOGICAL) ZYDIS_NOTMIN(ZYDIS_ISA_SET_SSE4) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_SSE4) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_SSE4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_PTWRITE ZYDIS_NOTMIN(1) ZYDIS_NOTMIN(1) ZYDIS_NOTMIN(0x1F03), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_PT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_PT) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_PT) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, ZYDIS_REGKIND_GPR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_PTWRITE ZYDIS_NOTMIN(1) ZYDIS_NOTMIN(1) ZYDIS_NOTMIN(0x679), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_PT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_PT) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_PT) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_PUNPCKHBW ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1CFD), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_MMX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_PENTIUMMMX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_MMX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_MMX, ZYDIS_REGKIND_MMX ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_PUNPCKHBW ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xF5D), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_MMX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_PENTIUMMMX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_MMX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_MMX, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_PUNPCKHBW ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1CFF), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_SSE) ZYDIS_NOTMIN(ZYDIS_ISA_SET_SSE2) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_SSE2) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_SSE4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_PUNPCKHBW ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xF63), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_SSE) ZYDIS_NOTMIN(ZYDIS_ISA_SET_SSE2) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_SSE2) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_SSE4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_PUNPCKHDQ ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1CFD), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_MMX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_PENTIUMMMX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_MMX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_MMX, ZYDIS_REGKIND_MMX ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_PUNPCKHDQ ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xF5D), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_MMX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_PENTIUMMMX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_MMX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_MMX, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_PUNPCKHDQ ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1CFF), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_SSE) ZYDIS_NOTMIN(ZYDIS_ISA_SET_SSE2) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_SSE2) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_SSE4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_PUNPCKHDQ ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xF63), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_SSE) ZYDIS_NOTMIN(ZYDIS_ISA_SET_SSE2) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_SSE2) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_SSE4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_PUNPCKHQDQ ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1CFF), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_SSE) ZYDIS_NOTMIN(ZYDIS_ISA_SET_SSE2) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_SSE2) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_SSE4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_PUNPCKHQDQ ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xF63), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_SSE) ZYDIS_NOTMIN(ZYDIS_ISA_SET_SSE2) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_SSE2) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_SSE4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_PUNPCKHWD ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1CFD), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_MMX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_PENTIUMMMX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_MMX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_MMX, ZYDIS_REGKIND_MMX ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_PUNPCKHWD ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xF5D), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_MMX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_PENTIUMMMX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_MMX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_MMX, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_PUNPCKHWD ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1CFF), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_SSE) ZYDIS_NOTMIN(ZYDIS_ISA_SET_SSE2) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_SSE2) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_SSE4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_PUNPCKHWD ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xF63), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_SSE) ZYDIS_NOTMIN(ZYDIS_ISA_SET_SSE2) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_SSE2) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_SSE4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_PUNPCKLBW ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1D01), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_MMX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_PENTIUMMMX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_MMX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_MMX, ZYDIS_REGKIND_MMX ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_PUNPCKLBW ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1D03), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_MMX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_PENTIUMMMX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_MMX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_MMX, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_PUNPCKLBW ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1CFF), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_SSE) ZYDIS_NOTMIN(ZYDIS_ISA_SET_SSE2) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_SSE2) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_SSE4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_PUNPCKLBW ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xF63), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_SSE) ZYDIS_NOTMIN(ZYDIS_ISA_SET_SSE2) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_SSE2) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_SSE4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_PUNPCKLDQ ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1D05), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_MMX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_PENTIUMMMX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_MMX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_MMX, ZYDIS_REGKIND_MMX ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_PUNPCKLDQ ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1D07), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_MMX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_PENTIUMMMX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_MMX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_MMX, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_PUNPCKLDQ ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1CFF), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_SSE) ZYDIS_NOTMIN(ZYDIS_ISA_SET_SSE2) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_SSE2) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_SSE4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_PUNPCKLDQ ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xF63), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_SSE) ZYDIS_NOTMIN(ZYDIS_ISA_SET_SSE2) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_SSE2) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_SSE4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_PUNPCKLQDQ ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1CFF), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_SSE) ZYDIS_NOTMIN(ZYDIS_ISA_SET_SSE2) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_SSE2) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_SSE4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_PUNPCKLQDQ ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xF63), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_SSE) ZYDIS_NOTMIN(ZYDIS_ISA_SET_SSE2) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_SSE2) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_SSE4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_PUNPCKLWD ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1D09), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_MMX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_PENTIUMMMX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_MMX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_MMX, ZYDIS_REGKIND_MMX ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_PUNPCKLWD ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1D0B), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_MMX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_PENTIUMMMX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_MMX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_MMX, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_PUNPCKLWD ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1CFF), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_SSE) ZYDIS_NOTMIN(ZYDIS_ISA_SET_SSE2) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_SSE2) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_SSE4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_PUNPCKLWD ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xF63), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_SSE) ZYDIS_NOTMIN(ZYDIS_ISA_SET_SSE2) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_SSE2) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_SSE4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_PUSH ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(1) ZYDIS_NOTMIN(0xFDB), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_PUSH) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I86) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, 0 ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_PUSH ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(1) ZYDIS_NOTMIN(0xFDE), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_PUSH) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I86) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, 0 ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_PUSH ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(1) ZYDIS_NOTMIN(0xFE1), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_PUSH) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I86) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, 0 ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_PUSH ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(1) ZYDIS_NOTMIN(0xFE4), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_PUSH) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I86) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, 0 ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_PUSH ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(1) ZYDIS_NOTMIN(0xFE7), 4, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_PUSH) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I86) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, 0 ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_PUSH ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(1) ZYDIS_NOTMIN(0xFEA), 4, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_PUSH) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I186) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, 0 ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_PUSH ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(1) ZYDIS_NOTMIN(0xFED), 4, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_PUSH) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I186) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, 0 ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_PUSH ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(1) ZYDIS_NOTMIN(0xFF0), 4, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_PUSH) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I86) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, ZYDIS_REGKIND_GPR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_PUSH ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(1) ZYDIS_NOTMIN(0xFF3), 4, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_PUSH) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I86) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_PUSH ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(1) ZYDIS_NOTMIN(0xFF6), 4, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_PUSH) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I86) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, 0 ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_PUSH ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(1) ZYDIS_NOTMIN(0xFF9), 4, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_PUSH) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I86) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, 0 ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_PUSHA ZYDIS_NOTMIN(10) ZYDIS_NOTMIN(0) ZYDIS_NOTMIN(0x1E), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_PUSH) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I186) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, 0 ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_PUSHAD ZYDIS_NOTMIN(10) ZYDIS_NOTMIN(0) ZYDIS_NOTMIN(0x28), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_PUSH) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I386) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, 0 ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_PUSHF ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0) ZYDIS_NOTMIN(0xFFC), 4, 0 ZYDIS_NOTMIN(0x20), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_PUSH) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I86) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, 0 ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_PUSHFD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0) ZYDIS_NOTMIN(0xFFF), 4, 0 ZYDIS_NOTMIN(0x20), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_PUSH) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I386) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, 0 ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_PUSHFQ ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0) ZYDIS_NOTMIN(0x1002), 4, 0 ZYDIS_NOTMIN(0x20), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_PUSH) ZYDIS_NOTMIN(ZYDIS_ISA_SET_LONGMODE) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_LONGMODE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, 0 ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_PVALIDATE ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x608), 0, 0 ZYDIS_NOTMIN(0x2B), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_SYSTEM) ZYDIS_NOTMIN(ZYDIS_ISA_SET_SNP) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_SNP) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, 0 ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_PXOR ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xF5A), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_LOGICAL) ZYDIS_NOTMIN(ZYDIS_ISA_SET_PENTIUMMMX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_MMX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_MMX, ZYDIS_REGKIND_MMX ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_PXOR ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xF5D), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_LOGICAL) ZYDIS_NOTMIN(ZYDIS_ISA_SET_PENTIUMMMX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_MMX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_MMX, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_PXOR ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xF60), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_LOGICAL) ZYDIS_NOTMIN(ZYDIS_ISA_SET_SSE2) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_SSE2) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_SSE4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_PXOR ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xF63), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_LOGICAL) ZYDIS_NOTMIN(ZYDIS_ISA_SET_SSE2) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_SSE2) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_SSE4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_RCL ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1005), 1, 0 ZYDIS_NOTMIN(0x22), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_ROTATE) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I186) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, ZYDIS_REGKIND_GPR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_RCL ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1008), 1, 0 ZYDIS_NOTMIN(0x22), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_ROTATE) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I186) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_RCL ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x100B), 0, 0 ZYDIS_NOTMIN(0x22), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_ROTATE) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I186) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, ZYDIS_REGKIND_GPR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_RCL ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x100E), 0, 0 ZYDIS_NOTMIN(0x22), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_ROTATE) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I186) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_RCL ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1011), 1, 0 ZYDIS_NOTMIN(0x22), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_ROTATE) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I86) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, ZYDIS_REGKIND_GPR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_RCL ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1014), 1, 0 ZYDIS_NOTMIN(0x22), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_ROTATE) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I86) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_RCL ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1017), 0, 0 ZYDIS_NOTMIN(0x22), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_ROTATE) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I86) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, ZYDIS_REGKIND_GPR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_RCL ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x101A), 0, 0 ZYDIS_NOTMIN(0x22), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_ROTATE) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I86) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_RCL ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x101D), 1, 0 ZYDIS_NOTMIN(0x22), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_ROTATE) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I86) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, ZYDIS_REGKIND_GPR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_RCL ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1020), 1, 0 ZYDIS_NOTMIN(0x22), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_ROTATE) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I86) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_RCL ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1023), 0, 0 ZYDIS_NOTMIN(0x22), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_ROTATE) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I86) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, ZYDIS_REGKIND_GPR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_RCL ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1026), 0, 0 ZYDIS_NOTMIN(0x22), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_ROTATE) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I86) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_RCPPS ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x105C), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_SSE) ZYDIS_NOTMIN(ZYDIS_ISA_SET_SSE) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_SSE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_SSE4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_RCPPS ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x105F), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_SSE) ZYDIS_NOTMIN(ZYDIS_ISA_SET_SSE) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_SSE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_SSE4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_RCPSS ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xE28), 2, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_SSE) ZYDIS_NOTMIN(ZYDIS_ISA_SET_SSE) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_SSE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_SSE5), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_RCPSS ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xE2B), 2, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_SSE) ZYDIS_NOTMIN(ZYDIS_ISA_SET_SSE) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_SSE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_SSE5), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_RCR ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1005), 1, 0 ZYDIS_NOTMIN(0x22), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_ROTATE) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I186) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, ZYDIS_REGKIND_GPR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_RCR ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1008), 1, 0 ZYDIS_NOTMIN(0x22), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_ROTATE) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I186) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_RCR ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x100B), 0, 0 ZYDIS_NOTMIN(0x22), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_ROTATE) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I186) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, ZYDIS_REGKIND_GPR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_RCR ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x100E), 0, 0 ZYDIS_NOTMIN(0x22), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_ROTATE) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I186) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_RCR ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1011), 1, 0 ZYDIS_NOTMIN(0x22), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_ROTATE) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I86) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, ZYDIS_REGKIND_GPR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_RCR ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1014), 1, 0 ZYDIS_NOTMIN(0x22), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_ROTATE) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I86) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_RCR ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1017), 0, 0 ZYDIS_NOTMIN(0x22), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_ROTATE) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I86) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, ZYDIS_REGKIND_GPR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_RCR ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x101A), 0, 0 ZYDIS_NOTMIN(0x22), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_ROTATE) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I86) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_RCR ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x101D), 1, 0 ZYDIS_NOTMIN(0x22), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_ROTATE) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I86) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, ZYDIS_REGKIND_GPR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_RCR ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1020), 1, 0 ZYDIS_NOTMIN(0x22), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_ROTATE) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I86) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_RCR ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1023), 0, 0 ZYDIS_NOTMIN(0x22), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_ROTATE) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I86) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, ZYDIS_REGKIND_GPR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_RCR ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1026), 0, 0 ZYDIS_NOTMIN(0x22), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_ROTATE) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I86) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_RDFSBASE ZYDIS_NOTMIN(1) ZYDIS_NOTMIN(1) ZYDIS_NOTMIN(0x1F04), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_RDWRFSGS) ZYDIS_NOTMIN(ZYDIS_ISA_SET_RDWRFSGS) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_RDWRFSGS) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, ZYDIS_REGKIND_GPR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_RDGSBASE ZYDIS_NOTMIN(1) ZYDIS_NOTMIN(1) ZYDIS_NOTMIN(0x1F04), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_RDWRFSGS) ZYDIS_NOTMIN(ZYDIS_ISA_SET_RDWRFSGS) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_RDWRFSGS) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, ZYDIS_REGKIND_GPR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_RDMSR ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0) ZYDIS_NOTMIN(0x1029), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_SYSTEM) ZYDIS_NOTMIN(ZYDIS_ISA_SET_PENTIUMREAL) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, 0 ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_RDMSRLIST ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0) ZYDIS_NOTMIN(0x102C), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_MSRLIST) ZYDIS_NOTMIN(ZYDIS_ISA_SET_MSRLIST) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_MSRLIST) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, 0 ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_RDPID ZYDIS_NOTMIN(1) ZYDIS_NOTMIN(1) ZYDIS_NOTMIN(0x12E1), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_RDPID) ZYDIS_NOTMIN(ZYDIS_ISA_SET_RDPID) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_RDPID) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, ZYDIS_REGKIND_GPR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_RDPID ZYDIS_NOTMIN(1) ZYDIS_NOTMIN(1) ZYDIS_NOTMIN(0xF6C), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_RDPID) ZYDIS_NOTMIN(ZYDIS_ISA_SET_RDPID) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_RDPID) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, ZYDIS_REGKIND_GPR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_RDPKRU ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0) ZYDIS_NOTMIN(0x60C), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_PKU) ZYDIS_NOTMIN(ZYDIS_ISA_SET_PKU) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_PKU) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, 0 ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_RDPMC ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0) ZYDIS_NOTMIN(0x1029), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_SYSTEM) ZYDIS_NOTMIN(ZYDIS_ISA_SET_RDPMC) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, 0 ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_RDPRU ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0) ZYDIS_NOTMIN(0x102F), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_RDPRU) ZYDIS_NOTMIN(ZYDIS_ISA_SET_RDPRU) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_RDPRU) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, 0 ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_RDRAND ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(1) ZYDIS_NOTMIN(0x1D0D), 0, 0 ZYDIS_NOTMIN(0x38), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_RDRAND) ZYDIS_NOTMIN(ZYDIS_ISA_SET_RDRAND) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_RDRAND) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, ZYDIS_REGKIND_GPR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_RDSEED ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(1) ZYDIS_NOTMIN(0x1D0D), 0, 0 ZYDIS_NOTMIN(0x38), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_RDSEED) ZYDIS_NOTMIN(ZYDIS_ISA_SET_RDSEED) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_RDSEED) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, ZYDIS_REGKIND_GPR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_RDSSPD ZYDIS_NOTMIN(1) ZYDIS_NOTMIN(1) ZYDIS_NOTMIN(0xF6C), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CET) ZYDIS_NOTMIN(ZYDIS_ISA_SET_CET) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_CET) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, ZYDIS_REGKIND_GPR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_RDSSPQ ZYDIS_NOTMIN(1) ZYDIS_NOTMIN(1) ZYDIS_NOTMIN(0x12E1), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CET) ZYDIS_NOTMIN(ZYDIS_ISA_SET_CET) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_CET) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, ZYDIS_REGKIND_GPR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_RDTSC ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0) ZYDIS_NOTMIN(0x1029), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_SYSTEM) ZYDIS_NOTMIN(ZYDIS_ISA_SET_PENTIUMREAL) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, 0 ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_RDTSCP ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0) ZYDIS_NOTMIN(0x1032), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_SYSTEM) ZYDIS_NOTMIN(ZYDIS_ISA_SET_RDTSCP) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_RDTSCP) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, 0 ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_RET ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(1) ZYDIS_NOTMIN(0x610), 5, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_RET) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I86) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NEAR) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, 0 ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_RET ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0) ZYDIS_NOTMIN(0x611), 5, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_RET) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I86) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NEAR) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, 0 ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_RET ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(1) ZYDIS_NOTMIN(0x614), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_RET) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I86) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_FAR) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, 0 ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_RET ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0) ZYDIS_NOTMIN(0x615), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_RET) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I86) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_FAR) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, 0 ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_RMPADJUST ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x618), 0, 0 ZYDIS_NOTMIN(0x1A), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_SYSTEM) ZYDIS_NOTMIN(ZYDIS_ISA_SET_SNP) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_SNP) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, 0 ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_RMPUPDATE ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1035), 0, 0 ZYDIS_NOTMIN(0x1A), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_SYSTEM) ZYDIS_NOTMIN(ZYDIS_ISA_SET_SNP) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_SNP) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, 0 ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_ROL ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1038), 1, 0 ZYDIS_NOTMIN(0x27), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_ROTATE) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I186) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, ZYDIS_REGKIND_GPR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_ROL ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x103B), 1, 0 ZYDIS_NOTMIN(0x27), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_ROTATE) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I186) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_ROL ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xDE3), 0, 0 ZYDIS_NOTMIN(0x27), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_ROTATE) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I186) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, ZYDIS_REGKIND_GPR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_ROL ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xDE6), 0, 0 ZYDIS_NOTMIN(0x27), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_ROTATE) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I186) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_ROL ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x103E), 1, 0 ZYDIS_NOTMIN(0x27), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_ROTATE) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I86) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, ZYDIS_REGKIND_GPR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_ROL ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1041), 1, 0 ZYDIS_NOTMIN(0x27), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_ROTATE) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I86) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_ROL ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1044), 0, 0 ZYDIS_NOTMIN(0x27), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_ROTATE) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I86) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, ZYDIS_REGKIND_GPR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_ROL ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1047), 0, 0 ZYDIS_NOTMIN(0x27), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_ROTATE) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I86) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_ROL ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x104A), 1, 0 ZYDIS_NOTMIN(0x27), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_ROTATE) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I86) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, ZYDIS_REGKIND_GPR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_ROL ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x104D), 1, 0 ZYDIS_NOTMIN(0x27), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_ROTATE) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I86) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_ROL ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1050), 0, 0 ZYDIS_NOTMIN(0x27), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_ROTATE) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I86) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, ZYDIS_REGKIND_GPR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_ROL ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1053), 0, 0 ZYDIS_NOTMIN(0x27), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_ROTATE) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I86) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_ROR ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1038), 1, 0 ZYDIS_NOTMIN(0x27), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_ROTATE) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I186) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, ZYDIS_REGKIND_GPR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_ROR ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x103B), 1, 0 ZYDIS_NOTMIN(0x27), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_ROTATE) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I186) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_ROR ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xDE3), 0, 0 ZYDIS_NOTMIN(0x27), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_ROTATE) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I186) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, ZYDIS_REGKIND_GPR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_ROR ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xDE6), 0, 0 ZYDIS_NOTMIN(0x27), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_ROTATE) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I186) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_ROR ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x103E), 1, 0 ZYDIS_NOTMIN(0x27), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_ROTATE) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I86) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, ZYDIS_REGKIND_GPR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_ROR ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1041), 1, 0 ZYDIS_NOTMIN(0x27), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_ROTATE) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I86) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_ROR ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1044), 0, 0 ZYDIS_NOTMIN(0x27), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_ROTATE) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I86) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, ZYDIS_REGKIND_GPR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_ROR ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1047), 0, 0 ZYDIS_NOTMIN(0x27), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_ROTATE) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I86) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_ROR ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x104A), 1, 0 ZYDIS_NOTMIN(0x27), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_ROTATE) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I86) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, ZYDIS_REGKIND_GPR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_ROR ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x104D), 1, 0 ZYDIS_NOTMIN(0x27), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_ROTATE) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I86) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_ROR ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1050), 0, 0 ZYDIS_NOTMIN(0x27), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_ROTATE) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I86) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, ZYDIS_REGKIND_GPR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_ROR ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1053), 0, 0 ZYDIS_NOTMIN(0x27), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_ROTATE) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I86) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_ROUNDPD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1056), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_SSE) ZYDIS_NOTMIN(ZYDIS_ISA_SET_SSE4) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_SSE4) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_SSE2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_ROUNDPD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1059), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_SSE) ZYDIS_NOTMIN(ZYDIS_ISA_SET_SSE4) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_SSE4) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_SSE2), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_ROUNDPS ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x105C), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_SSE) ZYDIS_NOTMIN(ZYDIS_ISA_SET_SSE4) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_SSE4) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_SSE2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_ROUNDPS ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x105F), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_SSE) ZYDIS_NOTMIN(ZYDIS_ISA_SET_SSE4) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_SSE4) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_SSE2), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_ROUNDSD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1062), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_SSE) ZYDIS_NOTMIN(ZYDIS_ISA_SET_SSE4) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_SSE4) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_SSE3), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_ROUNDSD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1065), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_SSE) ZYDIS_NOTMIN(ZYDIS_ISA_SET_SSE4) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_SSE4) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_SSE3), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_ROUNDSS ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1068), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_SSE) ZYDIS_NOTMIN(ZYDIS_ISA_SET_SSE4) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_SSE4) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_SSE3), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_ROUNDSS ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x106B), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_SSE) ZYDIS_NOTMIN(ZYDIS_ISA_SET_SSE4) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_SSE4) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_SSE3), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_RSM ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0) ZYDIS_NOTMIN(0x1D0F), 0, 0 ZYDIS_NOTMIN(0x30), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_SYSRET) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I486) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, 0 ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_RSQRTPS ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x105C), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_SSE) ZYDIS_NOTMIN(ZYDIS_ISA_SET_SSE) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_SSE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_SSE4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_RSQRTPS ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x105F), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_SSE) ZYDIS_NOTMIN(ZYDIS_ISA_SET_SSE) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_SSE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_SSE4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_RSQRTSS ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xE28), 2, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_SSE) ZYDIS_NOTMIN(ZYDIS_ISA_SET_SSE) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_SSE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_SSE5), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_RSQRTSS ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xE2B), 2, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_SSE) ZYDIS_NOTMIN(ZYDIS_ISA_SET_SSE) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_SSE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_SSE5), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_RSTORSSP ZYDIS_NOTMIN(1) ZYDIS_NOTMIN(1) ZYDIS_NOTMIN(0x1EFD), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_TRUE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CET) ZYDIS_NOTMIN(ZYDIS_ISA_SET_CET) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_CET) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_SAHF ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0) ZYDIS_NOTMIN(0x1D11), 0, 0 ZYDIS_NOTMIN(0x2A), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_FLAGOP) ZYDIS_NOTMIN(ZYDIS_ISA_SET_LAHF) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, 0 ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_SALC ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0) ZYDIS_NOTMIN(0x1D13), 0, 0 ZYDIS_NOTMIN(0x1B), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_FLAGOP) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I86) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, 0 ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_SAR ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1038), 1, 0 ZYDIS_NOTMIN(0x35), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_SHIFT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I186) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, ZYDIS_REGKIND_GPR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_SAR ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x103B), 1, 0 ZYDIS_NOTMIN(0x35), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_SHIFT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I186) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_SAR ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xDE3), 0, 0 ZYDIS_NOTMIN(0x35), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_SHIFT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I186) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, ZYDIS_REGKIND_GPR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_SAR ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xDE6), 0, 0 ZYDIS_NOTMIN(0x35), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_SHIFT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I186) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_SAR ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x103E), 1, 0 ZYDIS_NOTMIN(0x35), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_SHIFT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I86) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, ZYDIS_REGKIND_GPR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_SAR ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1041), 1, 0 ZYDIS_NOTMIN(0x35), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_SHIFT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I86) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_SAR ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1044), 0, 0 ZYDIS_NOTMIN(0x35), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_SHIFT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I86) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, ZYDIS_REGKIND_GPR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_SAR ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1047), 0, 0 ZYDIS_NOTMIN(0x35), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_SHIFT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I86) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_SAR ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x104A), 1, 0 ZYDIS_NOTMIN(0x35), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_SHIFT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I86) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, ZYDIS_REGKIND_GPR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_SAR ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x104D), 1, 0 ZYDIS_NOTMIN(0x35), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_SHIFT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I86) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_SAR ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1050), 0, 0 ZYDIS_NOTMIN(0x35), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_SHIFT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I86) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, ZYDIS_REGKIND_GPR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_SAR ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1053), 0, 0 ZYDIS_NOTMIN(0x35), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_SHIFT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I86) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_SAVEPREVSSP ZYDIS_NOTMIN(0) ZYDIS_NOTMIN(0) ZYDIS_NOTMIN(0x0), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_TRUE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CET) ZYDIS_NOTMIN(ZYDIS_ISA_SET_CET) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_CET) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, 0 ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_SBB ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xD3B), 1, 0 ZYDIS_NOTMIN(0x25), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_BINARY) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I86) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_GPR, ZYDIS_REGKIND_GPR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_SBB ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xD3E), 1, 0 ZYDIS_NOTMIN(0x25), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_BINARY) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I86) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_GPR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_TRUE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_SBB ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xD41), 0, 0 ZYDIS_NOTMIN(0x25), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_BINARY) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I86) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_GPR, ZYDIS_REGKIND_GPR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_SBB ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xD44), 0, 0 ZYDIS_NOTMIN(0x25), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_BINARY) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I86) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_GPR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_TRUE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_SBB ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xD47), 1, 0 ZYDIS_NOTMIN(0x25), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_BINARY) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I86) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_GPR, ZYDIS_REGKIND_GPR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_SBB ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xD4A), 1, 0 ZYDIS_NOTMIN(0x25), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_BINARY) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I86) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_GPR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_SBB ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xD4D), 0, 0 ZYDIS_NOTMIN(0x25), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_BINARY) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I86) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_GPR, ZYDIS_REGKIND_GPR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_SBB ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xD50), 0, 0 ZYDIS_NOTMIN(0x25), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_BINARY) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I86) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_GPR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_SBB ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xD53), 1, 0 ZYDIS_NOTMIN(0x25), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_BINARY) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I86) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, 0 ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_SBB ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xD56), 0, 0 ZYDIS_NOTMIN(0x25), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_BINARY) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I86) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, 0 ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_SBB ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xD59), 1, 0 ZYDIS_NOTMIN(0x25), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_BINARY) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I86) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, ZYDIS_REGKIND_GPR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_SBB ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xD5C), 1, 0 ZYDIS_NOTMIN(0x25), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_BINARY) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I86) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_TRUE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_SBB ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xD5F), 0, 0 ZYDIS_NOTMIN(0x25), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_BINARY) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I86) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, ZYDIS_REGKIND_GPR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_SBB ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xD62), 0, 0 ZYDIS_NOTMIN(0x25), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_BINARY) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I86) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_TRUE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_SBB ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xD59), 1, 0 ZYDIS_NOTMIN(0x25), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_BINARY) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I86) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, ZYDIS_REGKIND_GPR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_SBB ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xD5C), 1, 0 ZYDIS_NOTMIN(0x25), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_BINARY) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I86) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_TRUE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_SBB ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xD65), 0, 0 ZYDIS_NOTMIN(0x25), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_BINARY) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I86) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, ZYDIS_REGKIND_GPR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_SBB ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xD68), 0, 0 ZYDIS_NOTMIN(0x25), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_BINARY) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I86) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_TRUE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_SCASB ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0) ZYDIS_NOTMIN(0x106E), 1, 0 ZYDIS_NOTMIN(0x2C), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_STRINGOP) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I86) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, 0 ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_SCASB ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0) ZYDIS_NOTMIN(0x61C), 1, 0 ZYDIS_NOTMIN(0x29), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_STRINGOP) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I86) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, 0 ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_SCASB ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0) ZYDIS_NOTMIN(0x61C), 1, 0 ZYDIS_NOTMIN(0x29), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_STRINGOP) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I86) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, 0 ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_SCASD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0) ZYDIS_NOTMIN(0x1071), 0, 0 ZYDIS_NOTMIN(0x2C), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_STRINGOP) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I386) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, 0 ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_SCASD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0) ZYDIS_NOTMIN(0x620), 0, 0 ZYDIS_NOTMIN(0x29), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_STRINGOP) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I386) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, 0 ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_SCASD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0) ZYDIS_NOTMIN(0x620), 0, 0 ZYDIS_NOTMIN(0x29), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_STRINGOP) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I386) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, 0 ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_SCASQ ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0) ZYDIS_NOTMIN(0x1074), 0, 0 ZYDIS_NOTMIN(0x2C), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_STRINGOP) ZYDIS_NOTMIN(ZYDIS_ISA_SET_LONGMODE) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_LONGMODE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, 0 ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_SCASQ ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0) ZYDIS_NOTMIN(0x624), 0, 0 ZYDIS_NOTMIN(0x29), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_STRINGOP) ZYDIS_NOTMIN(ZYDIS_ISA_SET_LONGMODE) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_LONGMODE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, 0 ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_SCASQ ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0) ZYDIS_NOTMIN(0x624), 0, 0 ZYDIS_NOTMIN(0x29), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_STRINGOP) ZYDIS_NOTMIN(ZYDIS_ISA_SET_LONGMODE) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_LONGMODE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, 0 ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_SCASW ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0) ZYDIS_NOTMIN(0x1077), 0, 0 ZYDIS_NOTMIN(0x2C), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_STRINGOP) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I86) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, 0 ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_SCASW ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0) ZYDIS_NOTMIN(0x628), 0, 0 ZYDIS_NOTMIN(0x29), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_STRINGOP) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I86) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, 0 ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_SCASW ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0) ZYDIS_NOTMIN(0x628), 0, 0 ZYDIS_NOTMIN(0x29), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_STRINGOP) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I86) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, 0 ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_SEAMCALL ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0) ZYDIS_NOTMIN(0x1D15), 0, 0 ZYDIS_NOTMIN(0x37), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_LEGACY) ZYDIS_NOTMIN(ZYDIS_ISA_SET_TDX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_TDX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, 0 ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_SEAMOPS ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0) ZYDIS_NOTMIN(0x1D15), 0, 0 ZYDIS_NOTMIN(0x37), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_LEGACY) ZYDIS_NOTMIN(ZYDIS_ISA_SET_TDX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_TDX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, 0 ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_SEAMRET ZYDIS_NOTMIN(1) ZYDIS_NOTMIN(0) ZYDIS_NOTMIN(0x9), 0, 0 ZYDIS_NOTMIN(0x37), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_LEGACY) ZYDIS_NOTMIN(ZYDIS_ISA_SET_TDX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_TDX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, 0 ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_SENDUIPI ZYDIS_NOTMIN(1) ZYDIS_NOTMIN(1) ZYDIS_NOTMIN(0x654), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_UINTR) ZYDIS_NOTMIN(ZYDIS_ISA_SET_UINTR) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_UINTR) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, ZYDIS_REGKIND_GPR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_SERIALIZE ZYDIS_NOTMIN(0) ZYDIS_NOTMIN(0) ZYDIS_NOTMIN(0x0), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_SERIALIZE) ZYDIS_NOTMIN(ZYDIS_ISA_SET_SERIALIZE) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_SERIALIZE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, 0 ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_SETB ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(1) ZYDIS_NOTMIN(0x1D17), 1, 0 ZYDIS_NOTMIN(0x1B), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_SETCC) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I386) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, ZYDIS_REGKIND_GPR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_SETB ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(1) ZYDIS_NOTMIN(0x1D19), 1, 0 ZYDIS_NOTMIN(0x1B), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_SETCC) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I386) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_SETBE ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(1) ZYDIS_NOTMIN(0x1D17), 1, 0 ZYDIS_NOTMIN(0x1D), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_SETCC) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I386) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, ZYDIS_REGKIND_GPR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_SETBE ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(1) ZYDIS_NOTMIN(0x1D19), 1, 0 ZYDIS_NOTMIN(0x1D), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_SETCC) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I386) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_SETL ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(1) ZYDIS_NOTMIN(0x1D17), 1, 0 ZYDIS_NOTMIN(0x13), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_SETCC) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I386) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, ZYDIS_REGKIND_GPR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_SETL ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(1) ZYDIS_NOTMIN(0x1D19), 1, 0 ZYDIS_NOTMIN(0x13), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_SETCC) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I386) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_SETLE ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(1) ZYDIS_NOTMIN(0x1D17), 1, 0 ZYDIS_NOTMIN(0x16), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_SETCC) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I386) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, ZYDIS_REGKIND_GPR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_SETLE ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(1) ZYDIS_NOTMIN(0x1D19), 1, 0 ZYDIS_NOTMIN(0x16), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_SETCC) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I386) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_SETNB ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(1) ZYDIS_NOTMIN(0x1D17), 1, 0 ZYDIS_NOTMIN(0x1B), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_SETCC) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I386) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, ZYDIS_REGKIND_GPR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_SETNB ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(1) ZYDIS_NOTMIN(0x1D19), 1, 0 ZYDIS_NOTMIN(0x1B), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_SETCC) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I386) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_SETNBE ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(1) ZYDIS_NOTMIN(0x1D17), 1, 0 ZYDIS_NOTMIN(0x1D), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_SETCC) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I386) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, ZYDIS_REGKIND_GPR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_SETNBE ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(1) ZYDIS_NOTMIN(0x1D19), 1, 0 ZYDIS_NOTMIN(0x1D), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_SETCC) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I386) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_SETNL ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(1) ZYDIS_NOTMIN(0x1D17), 1, 0 ZYDIS_NOTMIN(0x13), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_SETCC) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I386) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, ZYDIS_REGKIND_GPR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_SETNL ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(1) ZYDIS_NOTMIN(0x1D19), 1, 0 ZYDIS_NOTMIN(0x13), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_SETCC) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I386) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_SETNLE ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(1) ZYDIS_NOTMIN(0x1D17), 1, 0 ZYDIS_NOTMIN(0x16), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_SETCC) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I386) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, ZYDIS_REGKIND_GPR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_SETNLE ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(1) ZYDIS_NOTMIN(0x1D19), 1, 0 ZYDIS_NOTMIN(0x16), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_SETCC) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I386) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_SETNO ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(1) ZYDIS_NOTMIN(0x1D17), 1, 0 ZYDIS_NOTMIN(0x8), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_SETCC) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I386) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, ZYDIS_REGKIND_GPR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_SETNO ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(1) ZYDIS_NOTMIN(0x1D19), 1, 0 ZYDIS_NOTMIN(0x8), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_SETCC) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I386) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_SETNP ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(1) ZYDIS_NOTMIN(0x1D17), 1, 0 ZYDIS_NOTMIN(0x18), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_SETCC) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I386) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, ZYDIS_REGKIND_GPR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_SETNP ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(1) ZYDIS_NOTMIN(0x1D19), 1, 0 ZYDIS_NOTMIN(0x18), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_SETCC) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I386) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_SETNS ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(1) ZYDIS_NOTMIN(0x1D17), 1, 0 ZYDIS_NOTMIN(0x12), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_SETCC) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I386) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, ZYDIS_REGKIND_GPR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_SETNS ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(1) ZYDIS_NOTMIN(0x1D19), 1, 0 ZYDIS_NOTMIN(0x12), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_SETCC) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I386) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_SETNZ ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(1) ZYDIS_NOTMIN(0x1D17), 1, 0 ZYDIS_NOTMIN(0x14), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_SETCC) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I386) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, ZYDIS_REGKIND_GPR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_SETNZ ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(1) ZYDIS_NOTMIN(0x1D19), 1, 0 ZYDIS_NOTMIN(0x14), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_SETCC) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I386) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_SETO ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(1) ZYDIS_NOTMIN(0x1D17), 1, 0 ZYDIS_NOTMIN(0x8), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_SETCC) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I386) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, ZYDIS_REGKIND_GPR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_SETO ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(1) ZYDIS_NOTMIN(0x1D19), 1, 0 ZYDIS_NOTMIN(0x8), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_SETCC) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I386) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_SETP ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(1) ZYDIS_NOTMIN(0x1D17), 1, 0 ZYDIS_NOTMIN(0x18), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_SETCC) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I386) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, ZYDIS_REGKIND_GPR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_SETP ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(1) ZYDIS_NOTMIN(0x1D19), 1, 0 ZYDIS_NOTMIN(0x18), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_SETCC) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I386) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_SETS ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(1) ZYDIS_NOTMIN(0x1D17), 1, 0 ZYDIS_NOTMIN(0x12), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_SETCC) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I386) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, ZYDIS_REGKIND_GPR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_SETS ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(1) ZYDIS_NOTMIN(0x1D19), 1, 0 ZYDIS_NOTMIN(0x12), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_SETCC) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I386) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_SETSSBSY ZYDIS_NOTMIN(0) ZYDIS_NOTMIN(0) ZYDIS_NOTMIN(0x0), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_TRUE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CET) ZYDIS_NOTMIN(ZYDIS_ISA_SET_CET) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_CET) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, 0 ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_SETZ ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(1) ZYDIS_NOTMIN(0x1D17), 1, 0 ZYDIS_NOTMIN(0x14), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_SETCC) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I386) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, ZYDIS_REGKIND_GPR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_SETZ ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(1) ZYDIS_NOTMIN(0x1D19), 1, 0 ZYDIS_NOTMIN(0x14), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_SETCC) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I386) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_SFENCE ZYDIS_NOTMIN(0) ZYDIS_NOTMIN(0) ZYDIS_NOTMIN(0x0), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_MISC) ZYDIS_NOTMIN(ZYDIS_ISA_SET_SSE) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_SSE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, 0 ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_SGDT ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(1) ZYDIS_NOTMIN(0x1D1B), 5, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_SYSTEM) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I286REAL) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_SGDT ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(1) ZYDIS_NOTMIN(0x1D1D), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_SYSTEM) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I286REAL) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_SHA1MSG1 ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xF60), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_SHA) ZYDIS_NOTMIN(ZYDIS_ISA_SET_SHA) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_SHA) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_SSE4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_SHA1MSG1 ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xF63), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_SHA) ZYDIS_NOTMIN(ZYDIS_ISA_SET_SHA) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_SHA) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_SSE4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_SHA1MSG2 ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xF60), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_SHA) ZYDIS_NOTMIN(ZYDIS_ISA_SET_SHA) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_SHA) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_SSE4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_SHA1MSG2 ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xF63), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_SHA) ZYDIS_NOTMIN(ZYDIS_ISA_SET_SHA) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_SHA) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_SSE4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_SHA1NEXTE ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xF60), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_SHA) ZYDIS_NOTMIN(ZYDIS_ISA_SET_SHA) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_SHA) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_SSE4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_SHA1NEXTE ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xF63), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_SHA) ZYDIS_NOTMIN(ZYDIS_ISA_SET_SHA) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_SHA) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_SSE4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_SHA1RNDS4 ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0xF60), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_SHA) ZYDIS_NOTMIN(ZYDIS_ISA_SET_SHA) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_SHA) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_SSE4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_SHA1RNDS4 ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0xF63), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_SHA) ZYDIS_NOTMIN(ZYDIS_ISA_SET_SHA) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_SHA) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_SSE4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_SHA256MSG1 ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xF60), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_SHA) ZYDIS_NOTMIN(ZYDIS_ISA_SET_SHA) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_SHA) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_SSE4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_SHA256MSG1 ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xF63), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_SHA) ZYDIS_NOTMIN(ZYDIS_ISA_SET_SHA) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_SHA) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_SSE4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_SHA256MSG2 ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xF60), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_SHA) ZYDIS_NOTMIN(ZYDIS_ISA_SET_SHA) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_SHA) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_SSE4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_SHA256MSG2 ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xF63), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_SHA) ZYDIS_NOTMIN(ZYDIS_ISA_SET_SHA) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_SHA) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_SSE4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_SHA256RNDS2 ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x107A), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_SHA) ZYDIS_NOTMIN(ZYDIS_ISA_SET_SHA) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_SHA) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_SSE4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_SHA256RNDS2 ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x107D), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_SHA) ZYDIS_NOTMIN(ZYDIS_ISA_SET_SHA) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_SHA) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_SSE4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_SHL ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1080), 1, 0 ZYDIS_NOTMIN(0x35), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_SHIFT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I186) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, ZYDIS_REGKIND_GPR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_SHL ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1080), 1, 0 ZYDIS_NOTMIN(0x35), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_SHIFT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I186) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, ZYDIS_REGKIND_GPR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_SHL ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1083), 1, 0 ZYDIS_NOTMIN(0x35), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_SHIFT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I186) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_SHL ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1083), 1, 0 ZYDIS_NOTMIN(0x35), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_SHIFT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I186) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_SHL ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1086), 0, 0 ZYDIS_NOTMIN(0x35), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_SHIFT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I186) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, ZYDIS_REGKIND_GPR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_SHL ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1086), 0, 0 ZYDIS_NOTMIN(0x35), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_SHIFT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I186) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, ZYDIS_REGKIND_GPR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_SHL ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1089), 0, 0 ZYDIS_NOTMIN(0x35), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_SHIFT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I186) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_SHL ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1089), 0, 0 ZYDIS_NOTMIN(0x35), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_SHIFT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I186) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_SHL ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x108C), 1, 0 ZYDIS_NOTMIN(0x35), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_SHIFT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I86) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, ZYDIS_REGKIND_GPR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_SHL ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x108C), 1, 0 ZYDIS_NOTMIN(0x35), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_SHIFT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I86) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, ZYDIS_REGKIND_GPR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_SHL ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x108F), 1, 0 ZYDIS_NOTMIN(0x35), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_SHIFT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I86) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_SHL ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x108F), 1, 0 ZYDIS_NOTMIN(0x35), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_SHIFT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I86) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_SHL ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1092), 0, 0 ZYDIS_NOTMIN(0x35), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_SHIFT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I86) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, ZYDIS_REGKIND_GPR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_SHL ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1092), 0, 0 ZYDIS_NOTMIN(0x35), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_SHIFT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I86) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, ZYDIS_REGKIND_GPR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_SHL ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1095), 0, 0 ZYDIS_NOTMIN(0x35), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_SHIFT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I86) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_SHL ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1095), 0, 0 ZYDIS_NOTMIN(0x35), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_SHIFT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I86) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_SHL ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1098), 1, 0 ZYDIS_NOTMIN(0x35), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_SHIFT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I86) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, ZYDIS_REGKIND_GPR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_SHL ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1098), 1, 0 ZYDIS_NOTMIN(0x35), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_SHIFT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I86) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, ZYDIS_REGKIND_GPR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_SHL ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x109B), 1, 0 ZYDIS_NOTMIN(0x35), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_SHIFT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I86) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_SHL ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x109B), 1, 0 ZYDIS_NOTMIN(0x35), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_SHIFT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I86) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_SHL ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x109E), 0, 0 ZYDIS_NOTMIN(0x35), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_SHIFT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I86) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, ZYDIS_REGKIND_GPR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_SHL ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x109E), 0, 0 ZYDIS_NOTMIN(0x35), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_SHIFT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I86) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, ZYDIS_REGKIND_GPR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_SHL ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x10A1), 0, 0 ZYDIS_NOTMIN(0x35), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_SHIFT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I86) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_SHL ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x10A1), 0, 0 ZYDIS_NOTMIN(0x35), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_SHIFT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I86) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_SHLD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x62C), 0, 0 ZYDIS_NOTMIN(0x35), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_SHIFT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I386) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_GPR, ZYDIS_REGKIND_GPR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_SHLD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x630), 0, 0 ZYDIS_NOTMIN(0x35), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_SHIFT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I386) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_GPR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_SHLD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x634), 0, 0 ZYDIS_NOTMIN(0x35), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_SHIFT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I386) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_GPR, ZYDIS_REGKIND_GPR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_SHLD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x638), 0, 0 ZYDIS_NOTMIN(0x35), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_SHIFT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I386) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_GPR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_SHR ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1080), 1, 0 ZYDIS_NOTMIN(0x35), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_SHIFT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I186) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, ZYDIS_REGKIND_GPR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_SHR ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1083), 1, 0 ZYDIS_NOTMIN(0x35), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_SHIFT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I186) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_SHR ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1086), 0, 0 ZYDIS_NOTMIN(0x35), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_SHIFT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I186) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, ZYDIS_REGKIND_GPR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_SHR ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1089), 0, 0 ZYDIS_NOTMIN(0x35), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_SHIFT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I186) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_SHR ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x108C), 1, 0 ZYDIS_NOTMIN(0x35), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_SHIFT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I86) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, ZYDIS_REGKIND_GPR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_SHR ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x108F), 1, 0 ZYDIS_NOTMIN(0x35), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_SHIFT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I86) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_SHR ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1092), 0, 0 ZYDIS_NOTMIN(0x35), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_SHIFT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I86) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, ZYDIS_REGKIND_GPR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_SHR ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1095), 0, 0 ZYDIS_NOTMIN(0x35), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_SHIFT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I86) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_SHR ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1098), 1, 0 ZYDIS_NOTMIN(0x35), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_SHIFT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I86) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, ZYDIS_REGKIND_GPR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_SHR ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x109B), 1, 0 ZYDIS_NOTMIN(0x35), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_SHIFT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I86) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_SHR ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x109E), 0, 0 ZYDIS_NOTMIN(0x35), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_SHIFT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I86) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, ZYDIS_REGKIND_GPR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_SHR ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x10A1), 0, 0 ZYDIS_NOTMIN(0x35), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_SHIFT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I86) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_SHRD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x62C), 0, 0 ZYDIS_NOTMIN(0x35), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_SHIFT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I386) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_GPR, ZYDIS_REGKIND_GPR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_SHRD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x630), 0, 0 ZYDIS_NOTMIN(0x35), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_SHIFT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I386) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_GPR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_SHRD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x634), 0, 0 ZYDIS_NOTMIN(0x35), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_SHIFT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I386) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_GPR, ZYDIS_REGKIND_GPR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_SHRD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x638), 0, 0 ZYDIS_NOTMIN(0x35), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_SHIFT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I386) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_GPR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_SHUFPD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0xDB9), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_SSE) ZYDIS_NOTMIN(ZYDIS_ISA_SET_SSE2) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_SSE2) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_SSE4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_SHUFPD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0xDBC), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_SSE) ZYDIS_NOTMIN(ZYDIS_ISA_SET_SSE2) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_SSE2) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_SSE4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_SHUFPS ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0xDBF), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_SSE) ZYDIS_NOTMIN(ZYDIS_ISA_SET_SSE) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_SSE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_SSE4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_SHUFPS ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0xDC2), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_SSE) ZYDIS_NOTMIN(ZYDIS_ISA_SET_SSE) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_SSE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_SSE4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_SIDT ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(1) ZYDIS_NOTMIN(0x1D1F), 5, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_SYSTEM) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I286REAL) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_SIDT ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(1) ZYDIS_NOTMIN(0x1D21), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_SYSTEM) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I286REAL) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_SKINIT ZYDIS_NOTMIN(1) ZYDIS_NOTMIN(1) ZYDIS_NOTMIN(0xF46), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_TRUE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_SYSTEM) ZYDIS_NOTMIN(ZYDIS_ISA_SET_SVM) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_SVM) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, 0 ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_SLDT ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(1) ZYDIS_NOTMIN(0x1D23), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_TRUE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_SYSTEM) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I286PROTECTED) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, ZYDIS_REGKIND_GPR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_SLDT ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(1) ZYDIS_NOTMIN(0x1D25), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_TRUE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_SYSTEM) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I286PROTECTED) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_SMSW ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(1) ZYDIS_NOTMIN(0x1D27), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_SYSTEM) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I286REAL) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, ZYDIS_REGKIND_GPR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_SMSW ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(1) ZYDIS_NOTMIN(0x1D29), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_SYSTEM) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I286REAL) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_SQRTPD ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1056), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_SSE) ZYDIS_NOTMIN(ZYDIS_ISA_SET_SSE2) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_SSE2) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_SSE2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_SQRTPD ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1059), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_SSE) ZYDIS_NOTMIN(ZYDIS_ISA_SET_SSE2) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_SSE2) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_SSE2), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_SQRTPS ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x105C), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_SSE) ZYDIS_NOTMIN(ZYDIS_ISA_SET_SSE) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_SSE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_SSE2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_SQRTPS ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x105F), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_SSE) ZYDIS_NOTMIN(ZYDIS_ISA_SET_SSE) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_SSE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_SSE2), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_SQRTSD ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xE1F), 2, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_SSE) ZYDIS_NOTMIN(ZYDIS_ISA_SET_SSE2) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_SSE2) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_SSE3), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_SQRTSD ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xE22), 2, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_SSE) ZYDIS_NOTMIN(ZYDIS_ISA_SET_SSE2) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_SSE2) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_SSE3), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_SQRTSS ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xE28), 2, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_SSE) ZYDIS_NOTMIN(ZYDIS_ISA_SET_SSE) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_SSE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_SSE3), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_SQRTSS ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xE2B), 2, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_SSE) ZYDIS_NOTMIN(ZYDIS_ISA_SET_SSE) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_SSE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_SSE3), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_STAC ZYDIS_NOTMIN(1) ZYDIS_NOTMIN(0) ZYDIS_NOTMIN(0x9), 0, 0 ZYDIS_NOTMIN(0x6), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_SMAP) ZYDIS_NOTMIN(ZYDIS_ISA_SET_SMAP) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_SMAP) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, 0 ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_STC ZYDIS_NOTMIN(1) ZYDIS_NOTMIN(0) ZYDIS_NOTMIN(0x9), 0, 0 ZYDIS_NOTMIN(0x45), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_FLAGOP) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I86) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, 0 ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_STD ZYDIS_NOTMIN(1) ZYDIS_NOTMIN(0) ZYDIS_NOTMIN(0x9), 0, 0 ZYDIS_NOTMIN(0xD), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_FLAGOP) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I86) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, 0 ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_STGI ZYDIS_NOTMIN(0) ZYDIS_NOTMIN(0) ZYDIS_NOTMIN(0x0), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_TRUE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_SYSTEM) ZYDIS_NOTMIN(ZYDIS_ISA_SET_SVM) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_SVM) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, 0 ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_STI ZYDIS_NOTMIN(1) ZYDIS_NOTMIN(0) ZYDIS_NOTMIN(0x5CF), 0, 0 ZYDIS_NOTMIN(0xE), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_FLAGOP) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I86) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, 0 ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_STMXCSR ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(1) ZYDIS_NOTMIN(0x1D2B), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_SSE) ZYDIS_NOTMIN(ZYDIS_ISA_SET_SSEMXCSR) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_SSE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_SSE5), 0, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_STOSB ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0) ZYDIS_NOTMIN(0x63C), 1, 0 ZYDIS_NOTMIN(0xA), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_STRINGOP) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I86) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, 0 ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_STOSB ZYDIS_NOTMIN(5) ZYDIS_NOTMIN(0) ZYDIS_NOTMIN(0x13A), 1, 0 ZYDIS_NOTMIN(0xA), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_STRINGOP) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I86) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, 0 ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_STOSB ZYDIS_NOTMIN(5) ZYDIS_NOTMIN(0) ZYDIS_NOTMIN(0x13A), 1, 0 ZYDIS_NOTMIN(0xA), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_STRINGOP) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I86) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, 0 ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_STOSD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0) ZYDIS_NOTMIN(0x640), 0, 0 ZYDIS_NOTMIN(0xA), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_STRINGOP) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I386) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, 0 ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_STOSD ZYDIS_NOTMIN(5) ZYDIS_NOTMIN(0) ZYDIS_NOTMIN(0x13F), 0, 0 ZYDIS_NOTMIN(0xA), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_STRINGOP) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I386) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, 0 ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_STOSD ZYDIS_NOTMIN(5) ZYDIS_NOTMIN(0) ZYDIS_NOTMIN(0x13F), 0, 0 ZYDIS_NOTMIN(0xA), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_STRINGOP) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I386) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, 0 ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_STOSQ ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0) ZYDIS_NOTMIN(0x644), 0, 0 ZYDIS_NOTMIN(0xA), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_STRINGOP) ZYDIS_NOTMIN(ZYDIS_ISA_SET_LONGMODE) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_LONGMODE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, 0 ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_STOSQ ZYDIS_NOTMIN(5) ZYDIS_NOTMIN(0) ZYDIS_NOTMIN(0x144), 0, 0 ZYDIS_NOTMIN(0xA), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_STRINGOP) ZYDIS_NOTMIN(ZYDIS_ISA_SET_LONGMODE) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_LONGMODE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, 0 ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_STOSQ ZYDIS_NOTMIN(5) ZYDIS_NOTMIN(0) ZYDIS_NOTMIN(0x144), 0, 0 ZYDIS_NOTMIN(0xA), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_STRINGOP) ZYDIS_NOTMIN(ZYDIS_ISA_SET_LONGMODE) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_LONGMODE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, 0 ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_STOSW ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0) ZYDIS_NOTMIN(0x648), 0, 0 ZYDIS_NOTMIN(0xA), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_STRINGOP) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I86) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, 0 ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_STOSW ZYDIS_NOTMIN(5) ZYDIS_NOTMIN(0) ZYDIS_NOTMIN(0x149), 0, 0 ZYDIS_NOTMIN(0xA), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_STRINGOP) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I86) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, 0 ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_STOSW ZYDIS_NOTMIN(5) ZYDIS_NOTMIN(0) ZYDIS_NOTMIN(0x149), 0, 0 ZYDIS_NOTMIN(0xA), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_STRINGOP) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I86) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, 0 ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_STR ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(1) ZYDIS_NOTMIN(0x1D2D), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_TRUE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_SYSTEM) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I286PROTECTED) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, ZYDIS_REGKIND_GPR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_STR ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(1) ZYDIS_NOTMIN(0x1D2F), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_TRUE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_SYSTEM) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I286PROTECTED) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_STUI ZYDIS_NOTMIN(1) ZYDIS_NOTMIN(0) ZYDIS_NOTMIN(0x1EFE), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_UINTR) ZYDIS_NOTMIN(ZYDIS_ISA_SET_UINTR) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_UINTR) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, 0 ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_SUB ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xD77), 1, 0 ZYDIS_NOTMIN(0x2B), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_BINARY) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I86) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_GPR, ZYDIS_REGKIND_GPR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_SUB ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xD7A), 1, 0 ZYDIS_NOTMIN(0x2B), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_BINARY) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I86) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_GPR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_TRUE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_SUB ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xD7D), 0, 0 ZYDIS_NOTMIN(0x2B), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_BINARY) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I86) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_GPR, ZYDIS_REGKIND_GPR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_SUB ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xD80), 0, 0 ZYDIS_NOTMIN(0x2B), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_BINARY) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I86) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_GPR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_TRUE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_SUB ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xD83), 1, 0 ZYDIS_NOTMIN(0x2B), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_BINARY) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I86) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_GPR, ZYDIS_REGKIND_GPR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_SUB ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xD86), 1, 0 ZYDIS_NOTMIN(0x2B), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_BINARY) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I86) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_GPR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_SUB ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xD89), 0, 0 ZYDIS_NOTMIN(0x2B), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_BINARY) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I86) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_GPR, ZYDIS_REGKIND_GPR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_SUB ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xD8C), 0, 0 ZYDIS_NOTMIN(0x2B), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_BINARY) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I86) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_GPR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_SUB ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xD8F), 1, 0 ZYDIS_NOTMIN(0x2B), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_BINARY) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I86) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, 0 ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_SUB ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xD92), 0, 0 ZYDIS_NOTMIN(0x2B), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_BINARY) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I86) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, 0 ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_SUB ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xD95), 1, 0 ZYDIS_NOTMIN(0x2B), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_BINARY) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I86) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, ZYDIS_REGKIND_GPR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_SUB ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xD98), 1, 0 ZYDIS_NOTMIN(0x2B), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_BINARY) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I86) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_TRUE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_SUB ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xD9B), 0, 0 ZYDIS_NOTMIN(0x2B), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_BINARY) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I86) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, ZYDIS_REGKIND_GPR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_SUB ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xD9E), 0, 0 ZYDIS_NOTMIN(0x2B), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_BINARY) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I86) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_TRUE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_SUB ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xD95), 1, 0 ZYDIS_NOTMIN(0x2B), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_BINARY) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I86) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, ZYDIS_REGKIND_GPR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_SUB ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xD98), 1, 0 ZYDIS_NOTMIN(0x2B), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_BINARY) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I86) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_TRUE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_SUB ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xDA1), 0, 0 ZYDIS_NOTMIN(0x2B), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_BINARY) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I86) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, ZYDIS_REGKIND_GPR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_SUB ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xDA4), 0, 0 ZYDIS_NOTMIN(0x2B), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_BINARY) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I86) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_TRUE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_SUBPD ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xDB9), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_SSE) ZYDIS_NOTMIN(ZYDIS_ISA_SET_SSE2) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_SSE2) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_SSE2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_SUBPD ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xDBC), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_SSE) ZYDIS_NOTMIN(ZYDIS_ISA_SET_SSE2) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_SSE2) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_SSE2), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_SUBPS ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xDBF), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_SSE) ZYDIS_NOTMIN(ZYDIS_ISA_SET_SSE) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_SSE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_SSE2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_SUBPS ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xDC2), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_SSE) ZYDIS_NOTMIN(ZYDIS_ISA_SET_SSE) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_SSE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_SSE2), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_SUBSD ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xE1F), 2, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_SSE) ZYDIS_NOTMIN(ZYDIS_ISA_SET_SSE2) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_SSE2) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_SSE3), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_SUBSD ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xE22), 2, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_SSE) ZYDIS_NOTMIN(ZYDIS_ISA_SET_SSE2) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_SSE2) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_SSE3), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_SUBSS ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xE28), 2, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_SSE) ZYDIS_NOTMIN(ZYDIS_ISA_SET_SSE) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_SSE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_SSE3), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_SUBSS ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xE2B), 2, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_SSE) ZYDIS_NOTMIN(ZYDIS_ISA_SET_SSE) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_SSE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_SSE3), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_SWAPGS ZYDIS_NOTMIN(1) ZYDIS_NOTMIN(0) ZYDIS_NOTMIN(0x1F05), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_SYSTEM) ZYDIS_NOTMIN(ZYDIS_ISA_SET_LONGMODE) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_LONGMODE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, 0 ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_SYSCALL ZYDIS_NOTMIN(6) ZYDIS_NOTMIN(0) ZYDIS_NOTMIN(0xC1), 5, 0 ZYDIS_NOTMIN(0x32), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_SYSCALL) ZYDIS_NOTMIN(ZYDIS_ISA_SET_LONGMODE) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_LONGMODE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, 0 ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_SYSCALL ZYDIS_NOTMIN(6) ZYDIS_NOTMIN(0) ZYDIS_NOTMIN(0xC7), 2, 0 ZYDIS_NOTMIN(0x32), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_SYSCALL) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AMD) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, 0 ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_SYSENTER ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0) ZYDIS_NOTMIN(0x10A4), 0, 0 ZYDIS_NOTMIN(0xF), ZYAN_TRUE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_SYSCALL) ZYDIS_NOTMIN(ZYDIS_ISA_SET_PPRO) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, 0 ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_SYSENTER ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0) ZYDIS_NOTMIN(0x10A7), 0, 0 ZYDIS_NOTMIN(0xF), ZYAN_TRUE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_SYSCALL) ZYDIS_NOTMIN(ZYDIS_ISA_SET_PPRO) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, 0 ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_SYSEXIT ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0) ZYDIS_NOTMIN(0x64C), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_TRUE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_SYSRET) ZYDIS_NOTMIN(ZYDIS_ISA_SET_PPRO) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, 0 ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_SYSEXIT ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0) ZYDIS_NOTMIN(0x650), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_TRUE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_SYSRET) ZYDIS_NOTMIN(ZYDIS_ISA_SET_PPRO) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, 0 ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_SYSRET ZYDIS_NOTMIN(6) ZYDIS_NOTMIN(0) ZYDIS_NOTMIN(0xCD), 0, 0 ZYDIS_NOTMIN(0x31), ZYAN_TRUE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_SYSRET) ZYDIS_NOTMIN(ZYDIS_ISA_SET_LONGMODE) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_LONGMODE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, 0 ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_SYSRET ZYDIS_NOTMIN(6) ZYDIS_NOTMIN(0) ZYDIS_NOTMIN(0xD3), 0, 0 ZYDIS_NOTMIN(0x31), ZYAN_TRUE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_SYSRET) ZYDIS_NOTMIN(ZYDIS_ISA_SET_LONGMODE) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_LONGMODE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, 0 ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_SYSRET ZYDIS_NOTMIN(6) ZYDIS_NOTMIN(0) ZYDIS_NOTMIN(0xD9), 0, 0 ZYDIS_NOTMIN(0x31), ZYAN_TRUE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_SYSRET) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AMD) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, 0 ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_TDCALL ZYDIS_NOTMIN(1) ZYDIS_NOTMIN(0) ZYDIS_NOTMIN(0x606), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_LEGACY) ZYDIS_NOTMIN(ZYDIS_ISA_SET_TDX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_TDX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, 0 ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_TDCALL ZYDIS_NOTMIN(1) ZYDIS_NOTMIN(0) ZYDIS_NOTMIN(0x10C7), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_LEGACY) ZYDIS_NOTMIN(ZYDIS_ISA_SET_TDX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_TDX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, 0 ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_TEST ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xDEF), 1, 0 ZYDIS_NOTMIN(0x40), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_LOGICAL) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I86) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_GPR, ZYDIS_REGKIND_GPR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_TEST ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xDF2), 1, 0 ZYDIS_NOTMIN(0x40), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_LOGICAL) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I86) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_GPR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_TEST ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xDD7), 0, 0 ZYDIS_NOTMIN(0x40), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_LOGICAL) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I86) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_GPR, ZYDIS_REGKIND_GPR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_TEST ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xDDA), 0, 0 ZYDIS_NOTMIN(0x40), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_LOGICAL) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I86) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_GPR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_TEST ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xE01), 1, 0 ZYDIS_NOTMIN(0x40), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_LOGICAL) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I86) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, 0 ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_TEST ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xE04), 0, 0 ZYDIS_NOTMIN(0x40), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_LOGICAL) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I86) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, 0 ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_TEST ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xE07), 1, 0 ZYDIS_NOTMIN(0x40), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_LOGICAL) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I86) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, ZYDIS_REGKIND_GPR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_TEST ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xE07), 1, 0 ZYDIS_NOTMIN(0x40), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_LOGICAL) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I86) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, ZYDIS_REGKIND_GPR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_TEST ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xE0A), 1, 0 ZYDIS_NOTMIN(0x40), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_LOGICAL) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I86) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_TEST ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xE0A), 1, 0 ZYDIS_NOTMIN(0x40), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_LOGICAL) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I86) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_TEST ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x59D), 0, 0 ZYDIS_NOTMIN(0x40), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_LOGICAL) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I86) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, ZYDIS_REGKIND_GPR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_TEST ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x59D), 0, 0 ZYDIS_NOTMIN(0x40), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_LOGICAL) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I86) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, ZYDIS_REGKIND_GPR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_TEST ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x5A1), 0, 0 ZYDIS_NOTMIN(0x40), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_LOGICAL) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I86) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_TEST ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x5A1), 0, 0 ZYDIS_NOTMIN(0x40), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_LOGICAL) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I86) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_TESTUI ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0) ZYDIS_NOTMIN(0x1D31), 0, 0 ZYDIS_NOTMIN(0x26), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_UINTR) ZYDIS_NOTMIN(ZYDIS_ISA_SET_UINTR) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_UINTR) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, 0 ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_TLBSYNC ZYDIS_NOTMIN(0) ZYDIS_NOTMIN(0) ZYDIS_NOTMIN(0x0), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_SYSTEM) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AMD_INVLPGB) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AMD_INVLPGB) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, 0 ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_TPAUSE ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(1) ZYDIS_NOTMIN(0x654), 0, 0 ZYDIS_NOTMIN(0x38), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_WAITPKG) ZYDIS_NOTMIN(ZYDIS_ISA_SET_WAITPKG) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_WAITPKG) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, ZYDIS_REGKIND_GPR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_TZCNT ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xDD1), 0, 0 ZYDIS_NOTMIN(0x3C), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_BMI1) ZYDIS_NOTMIN(ZYDIS_ISA_SET_BMI1) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BMI1) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_GPR, ZYDIS_REGKIND_GPR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_TZCNT ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xDD4), 0, 0 ZYDIS_NOTMIN(0x3C), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_BMI1) ZYDIS_NOTMIN(ZYDIS_ISA_SET_BMI1) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BMI1) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_GPR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_UCOMISD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xE31), 0, 0 ZYDIS_NOTMIN(0x33), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_SSE) ZYDIS_NOTMIN(ZYDIS_ISA_SET_SSE2) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_SSE2) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_SSE3), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_UCOMISD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xE34), 0, 0 ZYDIS_NOTMIN(0x33), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_SSE) ZYDIS_NOTMIN(ZYDIS_ISA_SET_SSE2) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_SSE2) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_SSE3), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_UCOMISS ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xE37), 0, 0 ZYDIS_NOTMIN(0x33), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_SSE) ZYDIS_NOTMIN(ZYDIS_ISA_SET_SSE) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_SSE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_SSE3), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_UCOMISS ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xE3A), 0, 0 ZYDIS_NOTMIN(0x33), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_SSE) ZYDIS_NOTMIN(ZYDIS_ISA_SET_SSE) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_SSE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_SSE3), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_UD0 ZYDIS_NOTMIN(0) ZYDIS_NOTMIN(0) ZYDIS_NOTMIN(0x0), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_MISC) ZYDIS_NOTMIN(ZYDIS_ISA_SET_PPRO) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, 0 ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_UD0 ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x10BC), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_MISC) ZYDIS_NOTMIN(ZYDIS_ISA_SET_PPRO) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_GPR, ZYDIS_REGKIND_GPR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_UD0 ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x10BF), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_MISC) ZYDIS_NOTMIN(ZYDIS_ISA_SET_PPRO) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_GPR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_UD1 ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x10BC), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_MISC) ZYDIS_NOTMIN(ZYDIS_ISA_SET_PPRO) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_GPR, ZYDIS_REGKIND_GPR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_UD1 ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x10BF), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_MISC) ZYDIS_NOTMIN(ZYDIS_ISA_SET_PPRO) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_GPR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_UD2 ZYDIS_NOTMIN(0) ZYDIS_NOTMIN(0) ZYDIS_NOTMIN(0x0), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_MISC) ZYDIS_NOTMIN(ZYDIS_ISA_SET_PPRO) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, 0 ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_UIRET ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0) ZYDIS_NOTMIN(0x1D0F), 0, 0 ZYDIS_NOTMIN(0x2B), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_UINTR) ZYDIS_NOTMIN(ZYDIS_ISA_SET_UINTR) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_UINTR) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, 0 ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_UMONITOR ZYDIS_NOTMIN(1) ZYDIS_NOTMIN(1) ZYDIS_NOTMIN(0x1F06), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_WAITPKG) ZYDIS_NOTMIN(ZYDIS_ISA_SET_WAITPKG) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_WAITPKG) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, ZYDIS_REGKIND_GPR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_UMWAIT ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(1) ZYDIS_NOTMIN(0x654), 0, 0 ZYDIS_NOTMIN(0x38), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_WAITPKG) ZYDIS_NOTMIN(ZYDIS_ISA_SET_WAITPKG) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_WAITPKG) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, ZYDIS_REGKIND_GPR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_UNPCKHPD ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1D33), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_SSE) ZYDIS_NOTMIN(ZYDIS_ISA_SET_SSE2) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_SSE2) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_SSE4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_UNPCKHPD ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1D35), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_SSE) ZYDIS_NOTMIN(ZYDIS_ISA_SET_SSE2) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_SSE2) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_SSE4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_UNPCKHPS ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1D37), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_SSE) ZYDIS_NOTMIN(ZYDIS_ISA_SET_SSE) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_SSE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_SSE4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_UNPCKHPS ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1D39), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_SSE) ZYDIS_NOTMIN(ZYDIS_ISA_SET_SSE) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_SSE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_SSE4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_UNPCKLPD ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1D33), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_SSE) ZYDIS_NOTMIN(ZYDIS_ISA_SET_SSE2) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_SSE2) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_SSE4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_UNPCKLPD ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1D35), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_SSE) ZYDIS_NOTMIN(ZYDIS_ISA_SET_SSE2) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_SSE2) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_SSE4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_UNPCKLPS ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1D3B), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_SSE) ZYDIS_NOTMIN(ZYDIS_ISA_SET_SSE) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_SSE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_SSE4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_UNPCKLPS ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1D39), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_SSE) ZYDIS_NOTMIN(ZYDIS_ISA_SET_SSE) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_SSE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_SSE4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_VERR ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(1) ZYDIS_NOTMIN(0x1D3D), 0, 0 ZYDIS_NOTMIN(0x17), ZYAN_TRUE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_SYSTEM) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I286PROTECTED) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, ZYDIS_REGKIND_GPR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_VERR ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(1) ZYDIS_NOTMIN(0xF07), 0, 0 ZYDIS_NOTMIN(0x17), ZYAN_TRUE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_SYSTEM) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I286PROTECTED) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_VERW ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(1) ZYDIS_NOTMIN(0x1D3D), 0, 0 ZYDIS_NOTMIN(0x17), ZYAN_TRUE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_SYSTEM) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I286PROTECTED) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, ZYDIS_REGKIND_GPR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_VERW ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(1) ZYDIS_NOTMIN(0xF07), 0, 0 ZYDIS_NOTMIN(0x17), ZYAN_TRUE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_SYSTEM) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I286PROTECTED) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_VMCALL ZYDIS_NOTMIN(1) ZYDIS_NOTMIN(0) ZYDIS_NOTMIN(0x553), 0, 0 ZYDIS_NOTMIN(0x2E), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VTX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_VTX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_VTX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, 0 ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_VMCLEAR ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(1) ZYDIS_NOTMIN(0x71A), 0, 0 ZYDIS_NOTMIN(0x37), ZYAN_TRUE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VTX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_VTX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_VTX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_VMFUNC ZYDIS_NOTMIN(1) ZYDIS_NOTMIN(0) ZYDIS_NOTMIN(0x28), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VTX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_VMFUNC) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_VMFUNC) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, 0 ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_VMLAUNCH ZYDIS_NOTMIN(1) ZYDIS_NOTMIN(0) ZYDIS_NOTMIN(0x553), 0, 0 ZYDIS_NOTMIN(0x2E), ZYAN_TRUE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VTX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_VTX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_VTX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, 0 ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_VMLOAD ZYDIS_NOTMIN(1) ZYDIS_NOTMIN(1) ZYDIS_NOTMIN(0xEE5), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_TRUE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_SYSTEM) ZYDIS_NOTMIN(ZYDIS_ISA_SET_SVM) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_SVM) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, 0 ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_VMMCALL ZYDIS_NOTMIN(0) ZYDIS_NOTMIN(0) ZYDIS_NOTMIN(0x0), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_SYSTEM) ZYDIS_NOTMIN(ZYDIS_ISA_SET_SVM) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_SVM) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, 0 ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_VMPTRLD ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(1) ZYDIS_NOTMIN(0x71A), 0, 0 ZYDIS_NOTMIN(0x37), ZYAN_TRUE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VTX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_VTX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_VTX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_VMPTRST ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(1) ZYDIS_NOTMIN(0x1D3F), 0, 0 ZYDIS_NOTMIN(0x37), ZYAN_TRUE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VTX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_VTX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_VTX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_VMREAD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x10AA), 7, 0 ZYDIS_NOTMIN(0x37), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VTX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_VTX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_VTX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_GPR, ZYDIS_REGKIND_GPR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_VMREAD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x10AD), 7, 0 ZYDIS_NOTMIN(0x37), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VTX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_VTX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_VTX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_GPR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_VMREAD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x10B0), 7, 0 ZYDIS_NOTMIN(0x37), ZYAN_TRUE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VTX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_VTX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_VTX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_GPR, ZYDIS_REGKIND_GPR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_VMREAD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x10B3), 7, 0 ZYDIS_NOTMIN(0x37), ZYAN_TRUE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VTX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_VTX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_VTX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_GPR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_VMRESUME ZYDIS_NOTMIN(1) ZYDIS_NOTMIN(0) ZYDIS_NOTMIN(0x553), 0, 0 ZYDIS_NOTMIN(0x2E), ZYAN_TRUE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VTX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_VTX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_VTX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, 0 ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_VMRUN ZYDIS_NOTMIN(1) ZYDIS_NOTMIN(1) ZYDIS_NOTMIN(0xEE5), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_TRUE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_SYSTEM) ZYDIS_NOTMIN(ZYDIS_ISA_SET_SVM) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_SVM) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, 0 ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_VMSAVE ZYDIS_NOTMIN(1) ZYDIS_NOTMIN(1) ZYDIS_NOTMIN(0xEE5), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_TRUE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_SYSTEM) ZYDIS_NOTMIN(ZYDIS_ISA_SET_SVM) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_SVM) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, 0 ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_VMWRITE ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x10B6), 7, 0 ZYDIS_NOTMIN(0x37), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VTX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_VTX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_VTX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_GPR, ZYDIS_REGKIND_GPR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_VMWRITE ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x10B9), 7, 0 ZYDIS_NOTMIN(0x37), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VTX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_VTX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_VTX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_GPR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_VMWRITE ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x10BC), 7, 0 ZYDIS_NOTMIN(0x37), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VTX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_VTX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_VTX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_GPR, ZYDIS_REGKIND_GPR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_VMWRITE ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x10BF), 7, 0 ZYDIS_NOTMIN(0x37), ZYAN_TRUE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VTX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_VTX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_VTX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_GPR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_VMXOFF ZYDIS_NOTMIN(1) ZYDIS_NOTMIN(0) ZYDIS_NOTMIN(0x9), 0, 0 ZYDIS_NOTMIN(0x2B), ZYAN_TRUE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VTX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_VTX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_VTX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, 0 ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_VMXON ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(1) ZYDIS_NOTMIN(0x71A), 2, 0 ZYDIS_NOTMIN(0x37), ZYAN_TRUE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VTX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_VTX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_VTX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_WBINVD ZYDIS_NOTMIN(0) ZYDIS_NOTMIN(0) ZYDIS_NOTMIN(0x0), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_SYSTEM) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I486REAL) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, 0 ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_WRFSBASE ZYDIS_NOTMIN(1) ZYDIS_NOTMIN(1) ZYDIS_NOTMIN(0x1F03), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_RDWRFSGS) ZYDIS_NOTMIN(ZYDIS_ISA_SET_RDWRFSGS) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_RDWRFSGS) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, ZYDIS_REGKIND_GPR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_WRGSBASE ZYDIS_NOTMIN(1) ZYDIS_NOTMIN(1) ZYDIS_NOTMIN(0x1F03), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_RDWRFSGS) ZYDIS_NOTMIN(ZYDIS_ISA_SET_RDWRFSGS) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_RDWRFSGS) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, ZYDIS_REGKIND_GPR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_WRMSR ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0) ZYDIS_NOTMIN(0x10C2), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_SYSTEM) ZYDIS_NOTMIN(ZYDIS_ISA_SET_PENTIUMREAL) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, 0 ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_WRMSRLIST ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0) ZYDIS_NOTMIN(0x102C), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_MSRLIST) ZYDIS_NOTMIN(ZYDIS_ISA_SET_MSRLIST) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_MSRLIST) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, 0 ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_WRMSRNS ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0) ZYDIS_NOTMIN(0x10C5), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_WRMSRNS) ZYDIS_NOTMIN(ZYDIS_ISA_SET_WRMSRNS) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_WRMSRNS) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, 0 ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_WRPKRU ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0) ZYDIS_NOTMIN(0x658), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_PKU) ZYDIS_NOTMIN(ZYDIS_ISA_SET_PKU) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_PKU) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, 0 ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_WRSSD ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1C0F), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_TRUE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CET) ZYDIS_NOTMIN(ZYDIS_ISA_SET_CET) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_CET) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_GPR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_WRSSQ ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1C11), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CET) ZYDIS_NOTMIN(ZYDIS_ISA_SET_CET) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_CET) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_GPR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_WRUSSD ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1C0F), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_TRUE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CET) ZYDIS_NOTMIN(ZYDIS_ISA_SET_CET) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_CET) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_GPR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_WRUSSQ ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1C11), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CET) ZYDIS_NOTMIN(ZYDIS_ISA_SET_CET) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_CET) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_GPR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_XABORT ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(1) ZYDIS_NOTMIN(0x1D41), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_UNCOND_BR) ZYDIS_NOTMIN(ZYDIS_ISA_SET_RTM) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_RTM) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, 0 ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_XADD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x10C8), 1, 0 ZYDIS_NOTMIN(0x2B), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_SEMAPHORE) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I486REAL) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_GPR, ZYDIS_REGKIND_GPR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_XADD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x10CB), 1, 0 ZYDIS_NOTMIN(0x2B), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_SEMAPHORE) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I486REAL) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_GPR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_TRUE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_XADD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x10CE), 0, 0 ZYDIS_NOTMIN(0x2B), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_SEMAPHORE) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I486REAL) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_GPR, ZYDIS_REGKIND_GPR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_XADD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x10D1), 0, 0 ZYDIS_NOTMIN(0x2B), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_SEMAPHORE) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I486REAL) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_GPR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_TRUE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_XBEGIN ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(1) ZYDIS_NOTMIN(0x10D4), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_COND_BR) ZYDIS_NOTMIN(ZYDIS_ISA_SET_RTM) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_RTM) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, 0 ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_XCHG ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x10C8), 1, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I86) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_GPR, ZYDIS_REGKIND_GPR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_XCHG ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x10CB), 1, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I86) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_GPR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_TRUE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_XCHG ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x10CE), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I86) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_GPR, ZYDIS_REGKIND_GPR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_XCHG ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x10D1), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I86) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_GPR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_TRUE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_XCHG ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1D43), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I86) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, 0 ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_XCHG ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1D43), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I86) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, 0 ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_XCRYPT_CBC ZYDIS_NOTMIN(8) ZYDIS_NOTMIN(0) ZYDIS_NOTMIN(0x56), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_PADLOCK) ZYDIS_NOTMIN(ZYDIS_ISA_SET_PADLOCK_ACE) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_PADLOCK) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, 0 ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_XCRYPT_CFB ZYDIS_NOTMIN(8) ZYDIS_NOTMIN(0) ZYDIS_NOTMIN(0x56), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_PADLOCK) ZYDIS_NOTMIN(ZYDIS_ISA_SET_PADLOCK_ACE) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_PADLOCK) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, 0 ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_XCRYPT_CTR ZYDIS_NOTMIN(9) ZYDIS_NOTMIN(0) ZYDIS_NOTMIN(0x4D), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_PADLOCK) ZYDIS_NOTMIN(ZYDIS_ISA_SET_PADLOCK_ACE) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_PADLOCK) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, 0 ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_XCRYPT_ECB ZYDIS_NOTMIN(7) ZYDIS_NOTMIN(0) ZYDIS_NOTMIN(0x96), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_PADLOCK) ZYDIS_NOTMIN(ZYDIS_ISA_SET_PADLOCK_ACE) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_PADLOCK) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, 0 ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_XCRYPT_OFB ZYDIS_NOTMIN(9) ZYDIS_NOTMIN(0) ZYDIS_NOTMIN(0x4D), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_PADLOCK) ZYDIS_NOTMIN(ZYDIS_ISA_SET_PADLOCK_ACE) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_PADLOCK) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, 0 ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_XEND ZYDIS_NOTMIN(0) ZYDIS_NOTMIN(0) ZYDIS_NOTMIN(0x0), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_COND_BR) ZYDIS_NOTMIN(ZYDIS_ISA_SET_RTM) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_RTM) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, 0 ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_XGETBV ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0) ZYDIS_NOTMIN(0x65C), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_XSAVE) ZYDIS_NOTMIN(ZYDIS_ISA_SET_XSAVE) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_XSAVE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, 0 ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_XLAT ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0) ZYDIS_NOTMIN(0x1D45), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_MISC) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I86) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, 0 ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_XOR ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xD77), 1, 0 ZYDIS_NOTMIN(0x40), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_LOGICAL) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I86) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_GPR, ZYDIS_REGKIND_GPR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_XOR ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xD7A), 1, 0 ZYDIS_NOTMIN(0x40), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_LOGICAL) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I86) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_GPR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_TRUE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_XOR ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xD7D), 0, 0 ZYDIS_NOTMIN(0x40), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_LOGICAL) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I86) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_GPR, ZYDIS_REGKIND_GPR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_XOR ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xD80), 0, 0 ZYDIS_NOTMIN(0x40), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_LOGICAL) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I86) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_GPR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_TRUE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_XOR ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xD83), 1, 0 ZYDIS_NOTMIN(0x40), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_LOGICAL) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I86) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_GPR, ZYDIS_REGKIND_GPR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_XOR ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xD86), 1, 0 ZYDIS_NOTMIN(0x40), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_LOGICAL) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I86) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_GPR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_XOR ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xD89), 0, 0 ZYDIS_NOTMIN(0x40), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_LOGICAL) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I86) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_GPR, ZYDIS_REGKIND_GPR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_XOR ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xD8C), 0, 0 ZYDIS_NOTMIN(0x40), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_LOGICAL) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I86) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_GPR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_XOR ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xD8F), 1, 0 ZYDIS_NOTMIN(0x40), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_LOGICAL) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I86) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, 0 ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_XOR ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xD92), 0, 0 ZYDIS_NOTMIN(0x40), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_LOGICAL) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I86) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, 0 ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_XOR ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xD95), 1, 0 ZYDIS_NOTMIN(0x40), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_LOGICAL) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I86) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, ZYDIS_REGKIND_GPR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_XOR ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xD98), 1, 0 ZYDIS_NOTMIN(0x40), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_LOGICAL) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I86) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_TRUE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_XOR ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xD9B), 0, 0 ZYDIS_NOTMIN(0x40), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_LOGICAL) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I86) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, ZYDIS_REGKIND_GPR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_XOR ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xD9E), 0, 0 ZYDIS_NOTMIN(0x40), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_LOGICAL) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I86) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_TRUE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_XOR ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xD95), 1, 0 ZYDIS_NOTMIN(0x40), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_LOGICAL) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I86) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, ZYDIS_REGKIND_GPR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_XOR ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xD98), 1, 0 ZYDIS_NOTMIN(0x40), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_LOGICAL) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I86) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_TRUE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_XOR ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xDA1), 0, 0 ZYDIS_NOTMIN(0x40), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_LOGICAL) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I86) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, ZYDIS_REGKIND_GPR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_XOR ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xDA4), 0, 0 ZYDIS_NOTMIN(0x40), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_LOGICAL) ZYDIS_NOTMIN(ZYDIS_ISA_SET_I86) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BASE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_TRUE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_XORPD ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xDB9), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_LOGICAL_FP) ZYDIS_NOTMIN(ZYDIS_ISA_SET_SSE2) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_SSE2) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_SSE4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_XORPD ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xDBC), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_LOGICAL_FP) ZYDIS_NOTMIN(ZYDIS_ISA_SET_SSE2) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_SSE2) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_SSE4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_XORPS ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xDBF), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_LOGICAL_FP) ZYDIS_NOTMIN(ZYDIS_ISA_SET_SSE) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_SSE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_SSE4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_XORPS ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xDC2), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_LOGICAL_FP) ZYDIS_NOTMIN(ZYDIS_ISA_SET_SSE) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_SSE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_SSE4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_XRESLDTRK ZYDIS_NOTMIN(0) ZYDIS_NOTMIN(0) ZYDIS_NOTMIN(0x0), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_TSX_LDTRK) ZYDIS_NOTMIN(ZYDIS_ISA_SET_TSX_LDTRK) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_TSX_LDTRK) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, 0 ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_XRSTOR ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(1) ZYDIS_NOTMIN(0x660), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_XSAVE) ZYDIS_NOTMIN(ZYDIS_ISA_SET_XSAVE) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_XSAVE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_WRITE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_WRITE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_XRSTOR64 ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(1) ZYDIS_NOTMIN(0x660), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_XSAVE) ZYDIS_NOTMIN(ZYDIS_ISA_SET_XSAVE) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_XSAVE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_WRITE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_WRITE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_XRSTORS ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(1) ZYDIS_NOTMIN(0x660), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_XSAVE) ZYDIS_NOTMIN(ZYDIS_ISA_SET_XSAVES) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_XSAVES) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_WRITE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_WRITE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_XRSTORS64 ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(1) ZYDIS_NOTMIN(0x660), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_XSAVE) ZYDIS_NOTMIN(ZYDIS_ISA_SET_XSAVES) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_XSAVES) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_WRITE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_WRITE) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_XSAVE ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(1) ZYDIS_NOTMIN(0x664), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_XSAVE) ZYDIS_NOTMIN(ZYDIS_ISA_SET_XSAVE) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_XSAVE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_READ) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_READ) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_XSAVE64 ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(1) ZYDIS_NOTMIN(0x664), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_XSAVE) ZYDIS_NOTMIN(ZYDIS_ISA_SET_XSAVE) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_XSAVE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_READ) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_READ) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_XSAVEC ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(1) ZYDIS_NOTMIN(0x668), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_XSAVE) ZYDIS_NOTMIN(ZYDIS_ISA_SET_XSAVEC) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_XSAVEC) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_READ) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_READ) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_XSAVEC64 ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(1) ZYDIS_NOTMIN(0x668), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_XSAVE) ZYDIS_NOTMIN(ZYDIS_ISA_SET_XSAVEC) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_XSAVEC) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_READ) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_READ) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_XSAVEOPT ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(1) ZYDIS_NOTMIN(0x664), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_XSAVEOPT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_XSAVEOPT) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_XSAVEOPT) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_READ) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_READ) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_XSAVEOPT64 ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(1) ZYDIS_NOTMIN(0x664), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_XSAVEOPT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_XSAVEOPT) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_XSAVEOPT) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_READ) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_READ) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_XSAVES ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(1) ZYDIS_NOTMIN(0x668), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_XSAVE) ZYDIS_NOTMIN(ZYDIS_ISA_SET_XSAVES) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_XSAVES) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_READ) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_READ) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_XSAVES64 ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(1) ZYDIS_NOTMIN(0x668), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_XSAVE) ZYDIS_NOTMIN(ZYDIS_ISA_SET_XSAVES) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_XSAVES) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_READ) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_READ) ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_XSETBV ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0) ZYDIS_NOTMIN(0x66C), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_XSAVE) ZYDIS_NOTMIN(ZYDIS_ISA_SET_XSAVE) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_XSAVE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, 0 ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_XSHA1 ZYDIS_NOTMIN(6) ZYDIS_NOTMIN(0) ZYDIS_NOTMIN(0xDF), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_PADLOCK) ZYDIS_NOTMIN(ZYDIS_ISA_SET_PADLOCK_PHE) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_PADLOCK) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, 0 ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_XSHA256 ZYDIS_NOTMIN(6) ZYDIS_NOTMIN(0) ZYDIS_NOTMIN(0xDF), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_PADLOCK) ZYDIS_NOTMIN(ZYDIS_ISA_SET_PADLOCK_PHE) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_PADLOCK) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, 0 ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_XSTORE ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0) ZYDIS_NOTMIN(0x670), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_PADLOCK) ZYDIS_NOTMIN(ZYDIS_ISA_SET_PADLOCK_RNG) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_PADLOCK) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, 0 ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_XSTORE ZYDIS_NOTMIN(5) ZYDIS_NOTMIN(0) ZYDIS_NOTMIN(0x14E), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_PADLOCK) ZYDIS_NOTMIN(ZYDIS_ISA_SET_PADLOCK_RNG) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_PADLOCK) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, 0 ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_XSUSLDTRK ZYDIS_NOTMIN(0) ZYDIS_NOTMIN(0) ZYDIS_NOTMIN(0x0), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_TSX_LDTRK) ZYDIS_NOTMIN(ZYDIS_ISA_SET_TSX_LDTRK) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_TSX_LDTRK) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, 0 ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_XTEST ZYDIS_NOTMIN(1) ZYDIS_NOTMIN(0) ZYDIS_NOTMIN(0x9), 0, 0 ZYDIS_NOTMIN(0x41), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_LOGICAL) ZYDIS_NOTMIN(ZYDIS_ISA_SET_RTM) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_RTM) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, 0 ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYAN_FALSE ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYAN_FALSE) }
};

const ZydisInstructionDefinition3DNOW ISTR_DEFINITIONS_3DNOW[] =
{
    { ZYDIS_MNEMONIC_PAVGUSB ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xF5A), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AMD3DNOW) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AMD3DNOW) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AMD3DNOW) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_MMX, ZYDIS_REGKIND_MMX ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_PAVGUSB ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xF5D), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AMD3DNOW) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AMD3DNOW) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AMD3DNOW) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_MMX, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) },
    { ZYDIS_MNEMONIC_PF2ID ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xF5A), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AMD3DNOW) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AMD3DNOW) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AMD3DNOW) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_MMX, ZYDIS_REGKIND_MMX ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_PF2ID ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xF5D), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AMD3DNOW) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AMD3DNOW) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AMD3DNOW) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_MMX, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) },
    { ZYDIS_MNEMONIC_PF2IW ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xF5A), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AMD3DNOW) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AMD3DNOW) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AMD3DNOW) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_MMX, ZYDIS_REGKIND_MMX ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_PF2IW ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xF5D), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AMD3DNOW) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AMD3DNOW) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AMD3DNOW) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_MMX, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) },
    { ZYDIS_MNEMONIC_PFACC ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xF5A), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AMD3DNOW) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AMD3DNOW) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AMD3DNOW) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_MMX, ZYDIS_REGKIND_MMX ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_PFACC ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xF5D), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AMD3DNOW) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AMD3DNOW) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AMD3DNOW) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_MMX, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) },
    { ZYDIS_MNEMONIC_PFADD ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xF5A), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AMD3DNOW) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AMD3DNOW) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AMD3DNOW) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_MMX, ZYDIS_REGKIND_MMX ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_PFADD ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xF5D), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AMD3DNOW) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AMD3DNOW) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AMD3DNOW) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_MMX, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) },
    { ZYDIS_MNEMONIC_PFCMPEQ ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xF5A), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AMD3DNOW) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AMD3DNOW) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AMD3DNOW) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_MMX, ZYDIS_REGKIND_MMX ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_PFCMPEQ ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xF5D), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AMD3DNOW) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AMD3DNOW) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AMD3DNOW) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_MMX, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) },
    { ZYDIS_MNEMONIC_PFCMPGE ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xF5A), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AMD3DNOW) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AMD3DNOW) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AMD3DNOW) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_MMX, ZYDIS_REGKIND_MMX ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_PFCMPGE ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xF5D), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AMD3DNOW) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AMD3DNOW) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AMD3DNOW) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_MMX, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) },
    { ZYDIS_MNEMONIC_PFCMPGT ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xF5A), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AMD3DNOW) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AMD3DNOW) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AMD3DNOW) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_MMX, ZYDIS_REGKIND_MMX ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_PFCMPGT ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xF5D), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AMD3DNOW) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AMD3DNOW) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AMD3DNOW) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_MMX, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) },
    { ZYDIS_MNEMONIC_PFCPIT1 ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xF5A), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AMD3DNOW) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AMD3DNOW) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AMD3DNOW) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_MMX, ZYDIS_REGKIND_MMX ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_PFCPIT1 ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xF5D), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AMD3DNOW) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AMD3DNOW) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AMD3DNOW) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_MMX, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) },
    { ZYDIS_MNEMONIC_PFMAX ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xF5A), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AMD3DNOW) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AMD3DNOW) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AMD3DNOW) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_MMX, ZYDIS_REGKIND_MMX ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_PFMAX ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xF5D), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AMD3DNOW) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AMD3DNOW) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AMD3DNOW) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_MMX, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) },
    { ZYDIS_MNEMONIC_PFMIN ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xF5A), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AMD3DNOW) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AMD3DNOW) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AMD3DNOW) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_MMX, ZYDIS_REGKIND_MMX ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_PFMIN ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xF5D), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AMD3DNOW) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AMD3DNOW) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AMD3DNOW) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_MMX, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) },
    { ZYDIS_MNEMONIC_PFMUL ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xF5A), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AMD3DNOW) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AMD3DNOW) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AMD3DNOW) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_MMX, ZYDIS_REGKIND_MMX ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_PFMUL ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xF5D), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AMD3DNOW) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AMD3DNOW) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AMD3DNOW) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_MMX, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) },
    { ZYDIS_MNEMONIC_PFNACC ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xF5A), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AMD3DNOW) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AMD3DNOW) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AMD3DNOW) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_MMX, ZYDIS_REGKIND_MMX ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_PFNACC ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xF5D), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AMD3DNOW) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AMD3DNOW) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AMD3DNOW) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_MMX, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) },
    { ZYDIS_MNEMONIC_PFPNACC ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xF5A), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AMD3DNOW) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AMD3DNOW) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AMD3DNOW) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_MMX, ZYDIS_REGKIND_MMX ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_PFPNACC ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xF5D), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AMD3DNOW) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AMD3DNOW) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AMD3DNOW) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_MMX, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) },
    { ZYDIS_MNEMONIC_PFRCP ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xF5A), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AMD3DNOW) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AMD3DNOW) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AMD3DNOW) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_MMX, ZYDIS_REGKIND_MMX ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_PFRCP ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xF5D), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AMD3DNOW) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AMD3DNOW) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AMD3DNOW) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_MMX, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) },
    { ZYDIS_MNEMONIC_PFRCPIT2 ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xF5A), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AMD3DNOW) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AMD3DNOW) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AMD3DNOW) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_MMX, ZYDIS_REGKIND_MMX ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_PFRCPIT2 ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xF5D), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AMD3DNOW) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AMD3DNOW) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AMD3DNOW) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_MMX, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) },
    { ZYDIS_MNEMONIC_PFRSQIT1 ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xF5A), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AMD3DNOW) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AMD3DNOW) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AMD3DNOW) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_MMX, ZYDIS_REGKIND_MMX ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_PFRSQIT1 ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xF5D), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AMD3DNOW) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AMD3DNOW) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AMD3DNOW) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_MMX, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) },
    { ZYDIS_MNEMONIC_PFSQRT ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xF5A), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AMD3DNOW) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AMD3DNOW) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AMD3DNOW) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_MMX, ZYDIS_REGKIND_MMX ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_PFSQRT ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xF5D), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AMD3DNOW) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AMD3DNOW) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AMD3DNOW) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_MMX, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) },
    { ZYDIS_MNEMONIC_PFSUB ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xF5A), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AMD3DNOW) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AMD3DNOW) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AMD3DNOW) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_MMX, ZYDIS_REGKIND_MMX ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_PFSUB ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xF5D), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AMD3DNOW) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AMD3DNOW) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AMD3DNOW) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_MMX, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) },
    { ZYDIS_MNEMONIC_PFSUBR ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xF5A), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AMD3DNOW) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AMD3DNOW) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AMD3DNOW) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_MMX, ZYDIS_REGKIND_MMX ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_PFSUBR ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xF5D), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AMD3DNOW) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AMD3DNOW) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AMD3DNOW) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_MMX, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) },
    { ZYDIS_MNEMONIC_PI2FD ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xF5A), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AMD3DNOW) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AMD3DNOW) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AMD3DNOW) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_MMX, ZYDIS_REGKIND_MMX ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_PI2FD ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xF5D), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AMD3DNOW) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AMD3DNOW) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AMD3DNOW) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_MMX, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) },
    { ZYDIS_MNEMONIC_PI2FW ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xF5A), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AMD3DNOW) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AMD3DNOW) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AMD3DNOW) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_MMX, ZYDIS_REGKIND_MMX ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_PI2FW ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xF5D), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AMD3DNOW) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AMD3DNOW) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AMD3DNOW) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_MMX, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) },
    { ZYDIS_MNEMONIC_PMULHRW ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xF5A), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AMD3DNOW) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AMD3DNOW) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AMD3DNOW) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_MMX, ZYDIS_REGKIND_MMX ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_PMULHRW ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xF5D), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AMD3DNOW) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AMD3DNOW) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AMD3DNOW) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_MMX, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) },
    { ZYDIS_MNEMONIC_PSWAPD ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xF5A), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AMD3DNOW) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AMD3DNOW) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AMD3DNOW) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_MMX, ZYDIS_REGKIND_MMX ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE) },
    { ZYDIS_MNEMONIC_PSWAPD ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xF5D), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AMD3DNOW) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AMD3DNOW) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AMD3DNOW) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_MMX, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE) }
};

const ZydisInstructionDefinitionXOP ISTR_DEFINITIONS_XOP[] =
{
    { ZYDIS_MNEMONIC_BEXTR ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x674), 0, 0 ZYDIS_NOTMIN(0x44), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_TBM) ZYDIS_NOTMIN(ZYDIS_ISA_SET_TBM) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_TBM) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_GPR, ZYDIS_REGKIND_GPR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0 },
    { ZYDIS_MNEMONIC_BEXTR ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x678), 0, 0 ZYDIS_NOTMIN(0x44), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_TBM) ZYDIS_NOTMIN(ZYDIS_ISA_SET_TBM) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_TBM) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_GPR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0 },
    { ZYDIS_MNEMONIC_BLCFILL ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x10D7), 0, 0 ZYDIS_NOTMIN(0x3B), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_TBM) ZYDIS_NOTMIN(ZYDIS_ISA_SET_TBM) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_TBM) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, ZYDIS_REGKIND_GPR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_GPR },
    { ZYDIS_MNEMONIC_BLCFILL ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x10DA), 0, 0 ZYDIS_NOTMIN(0x3B), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_TBM) ZYDIS_NOTMIN(ZYDIS_ISA_SET_TBM) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_TBM) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_GPR },
    { ZYDIS_MNEMONIC_BLCI ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x10D7), 0, 0 ZYDIS_NOTMIN(0x3B), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_TBM) ZYDIS_NOTMIN(ZYDIS_ISA_SET_TBM) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_TBM) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, ZYDIS_REGKIND_GPR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_GPR },
    { ZYDIS_MNEMONIC_BLCI ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x10DA), 0, 0 ZYDIS_NOTMIN(0x3B), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_TBM) ZYDIS_NOTMIN(ZYDIS_ISA_SET_TBM) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_TBM) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_GPR },
    { ZYDIS_MNEMONIC_BLCIC ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x10D7), 0, 0 ZYDIS_NOTMIN(0x3B), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_TBM) ZYDIS_NOTMIN(ZYDIS_ISA_SET_TBM) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_TBM) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, ZYDIS_REGKIND_GPR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_GPR },
    { ZYDIS_MNEMONIC_BLCIC ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x10DA), 0, 0 ZYDIS_NOTMIN(0x3B), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_TBM) ZYDIS_NOTMIN(ZYDIS_ISA_SET_TBM) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_TBM) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_GPR },
    { ZYDIS_MNEMONIC_BLCMSK ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x10D7), 0, 0 ZYDIS_NOTMIN(0x3B), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_TBM) ZYDIS_NOTMIN(ZYDIS_ISA_SET_TBM) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_TBM) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, ZYDIS_REGKIND_GPR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_GPR },
    { ZYDIS_MNEMONIC_BLCMSK ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x10DA), 0, 0 ZYDIS_NOTMIN(0x3B), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_TBM) ZYDIS_NOTMIN(ZYDIS_ISA_SET_TBM) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_TBM) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_GPR },
    { ZYDIS_MNEMONIC_BLCS ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x10D7), 0, 0 ZYDIS_NOTMIN(0x3B), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_TBM) ZYDIS_NOTMIN(ZYDIS_ISA_SET_TBM) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_TBM) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, ZYDIS_REGKIND_GPR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_GPR },
    { ZYDIS_MNEMONIC_BLCS ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x10DA), 0, 0 ZYDIS_NOTMIN(0x3B), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_TBM) ZYDIS_NOTMIN(ZYDIS_ISA_SET_TBM) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_TBM) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_GPR },
    { ZYDIS_MNEMONIC_BLSFILL ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x10D7), 0, 0 ZYDIS_NOTMIN(0x3B), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_TBM) ZYDIS_NOTMIN(ZYDIS_ISA_SET_TBM) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_TBM) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, ZYDIS_REGKIND_GPR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_GPR },
    { ZYDIS_MNEMONIC_BLSFILL ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x10DA), 0, 0 ZYDIS_NOTMIN(0x3B), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_TBM) ZYDIS_NOTMIN(ZYDIS_ISA_SET_TBM) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_TBM) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_GPR },
    { ZYDIS_MNEMONIC_BLSIC ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x10D7), 0, 0 ZYDIS_NOTMIN(0x3B), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_TBM) ZYDIS_NOTMIN(ZYDIS_ISA_SET_TBM) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_TBM) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, ZYDIS_REGKIND_GPR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_GPR },
    { ZYDIS_MNEMONIC_BLSIC ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x10DA), 0, 0 ZYDIS_NOTMIN(0x3B), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_TBM) ZYDIS_NOTMIN(ZYDIS_ISA_SET_TBM) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_TBM) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_GPR },
    { ZYDIS_MNEMONIC_LLWPCB ZYDIS_NOTMIN(1) ZYDIS_NOTMIN(1) ZYDIS_NOTMIN(0x1F07), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_XOP) ZYDIS_NOTMIN(ZYDIS_ISA_SET_LWP) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_XOP) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, ZYDIS_REGKIND_GPR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0 },
    { ZYDIS_MNEMONIC_LWPINS ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x67C), 0, 0 ZYDIS_NOTMIN(0x26), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_XOP) ZYDIS_NOTMIN(ZYDIS_ISA_SET_LWP) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_XOP) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, ZYDIS_REGKIND_GPR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_GPR },
    { ZYDIS_MNEMONIC_LWPINS ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x680), 0, 0 ZYDIS_NOTMIN(0x26), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_XOP) ZYDIS_NOTMIN(ZYDIS_ISA_SET_LWP) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_XOP) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_GPR },
    { ZYDIS_MNEMONIC_LWPVAL ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x67C), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_XOP) ZYDIS_NOTMIN(ZYDIS_ISA_SET_LWP) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_XOP) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, ZYDIS_REGKIND_GPR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_GPR },
    { ZYDIS_MNEMONIC_LWPVAL ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x680), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_XOP) ZYDIS_NOTMIN(ZYDIS_ISA_SET_LWP) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_XOP) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_GPR },
    { ZYDIS_MNEMONIC_SLWPCB ZYDIS_NOTMIN(1) ZYDIS_NOTMIN(1) ZYDIS_NOTMIN(0x1F07), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_XOP) ZYDIS_NOTMIN(ZYDIS_ISA_SET_LWP) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_XOP) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, ZYDIS_REGKIND_GPR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0 },
    { ZYDIS_MNEMONIC_T1MSKC ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x10D7), 0, 0 ZYDIS_NOTMIN(0x3B), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_TBM) ZYDIS_NOTMIN(ZYDIS_ISA_SET_TBM) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_TBM) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, ZYDIS_REGKIND_GPR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_GPR },
    { ZYDIS_MNEMONIC_T1MSKC ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x10DA), 0, 0 ZYDIS_NOTMIN(0x3B), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_TBM) ZYDIS_NOTMIN(ZYDIS_ISA_SET_TBM) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_TBM) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_GPR },
    { ZYDIS_MNEMONIC_TZMSK ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x10D7), 0, 0 ZYDIS_NOTMIN(0x3B), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_TBM) ZYDIS_NOTMIN(ZYDIS_ISA_SET_TBM) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_TBM) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, ZYDIS_REGKIND_GPR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_GPR },
    { ZYDIS_MNEMONIC_TZMSK ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x10DA), 0, 0 ZYDIS_NOTMIN(0x3B), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_TBM) ZYDIS_NOTMIN(ZYDIS_ISA_SET_TBM) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_TBM) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_GPR },
    { ZYDIS_MNEMONIC_VFRCZPD ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1056), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_XOP) ZYDIS_NOTMIN(ZYDIS_ISA_SET_XOP) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_XOP) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0 },
    { ZYDIS_MNEMONIC_VFRCZPD ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x12BA), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_XOP) ZYDIS_NOTMIN(ZYDIS_ISA_SET_XOP) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_XOP) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0 },
    { ZYDIS_MNEMONIC_VFRCZPD ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1059), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_XOP) ZYDIS_NOTMIN(ZYDIS_ISA_SET_XOP) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_XOP) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0 },
    { ZYDIS_MNEMONIC_VFRCZPD ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x12BD), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_XOP) ZYDIS_NOTMIN(ZYDIS_ISA_SET_XOP) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_XOP) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0 },
    { ZYDIS_MNEMONIC_VFRCZPS ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x105C), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_XOP) ZYDIS_NOTMIN(ZYDIS_ISA_SET_XOP) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_XOP) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0 },
    { ZYDIS_MNEMONIC_VFRCZPS ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x12CC), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_XOP) ZYDIS_NOTMIN(ZYDIS_ISA_SET_XOP) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_XOP) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0 },
    { ZYDIS_MNEMONIC_VFRCZPS ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x105F), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_XOP) ZYDIS_NOTMIN(ZYDIS_ISA_SET_XOP) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_XOP) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0 },
    { ZYDIS_MNEMONIC_VFRCZPS ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x12CF), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_XOP) ZYDIS_NOTMIN(ZYDIS_ISA_SET_XOP) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_XOP) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0 },
    { ZYDIS_MNEMONIC_VFRCZSD ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1D47), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_XOP) ZYDIS_NOTMIN(ZYDIS_ISA_SET_XOP) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_XOP) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0 },
    { ZYDIS_MNEMONIC_VFRCZSD ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1C43), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_XOP) ZYDIS_NOTMIN(ZYDIS_ISA_SET_XOP) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_XOP) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0 },
    { ZYDIS_MNEMONIC_VFRCZSS ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1D49), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_XOP) ZYDIS_NOTMIN(ZYDIS_ISA_SET_XOP) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_XOP) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0 },
    { ZYDIS_MNEMONIC_VFRCZSS ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1C4B), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_XOP) ZYDIS_NOTMIN(ZYDIS_ISA_SET_XOP) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_XOP) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0 },
    { ZYDIS_MNEMONIC_VPCMOV ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x684), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_XOP) ZYDIS_NOTMIN(ZYDIS_ISA_SET_XOP) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_XOP) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR },
    { ZYDIS_MNEMONIC_VPCMOV ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x688), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_XOP) ZYDIS_NOTMIN(ZYDIS_ISA_SET_XOP) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_XOP) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR },
    { ZYDIS_MNEMONIC_VPCMOV ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x68C), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_XOP) ZYDIS_NOTMIN(ZYDIS_ISA_SET_XOP) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_XOP) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR },
    { ZYDIS_MNEMONIC_VPCMOV ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x690), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_XOP) ZYDIS_NOTMIN(ZYDIS_ISA_SET_XOP) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_XOP) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR },
    { ZYDIS_MNEMONIC_VPCMOV ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x694), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_XOP) ZYDIS_NOTMIN(ZYDIS_ISA_SET_XOP) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_XOP) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR },
    { ZYDIS_MNEMONIC_VPCMOV ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x698), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_XOP) ZYDIS_NOTMIN(ZYDIS_ISA_SET_XOP) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_XOP) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR },
    { ZYDIS_MNEMONIC_VPCMOV ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x69C), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_XOP) ZYDIS_NOTMIN(ZYDIS_ISA_SET_XOP) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_XOP) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR },
    { ZYDIS_MNEMONIC_VPCMOV ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x6A0), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_XOP) ZYDIS_NOTMIN(ZYDIS_ISA_SET_XOP) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_XOP) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR },
    { ZYDIS_MNEMONIC_VPCOMB ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x6A4), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_XOP) ZYDIS_NOTMIN(ZYDIS_ISA_SET_XOP) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_XOP) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR },
    { ZYDIS_MNEMONIC_VPCOMB ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x6A8), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_XOP) ZYDIS_NOTMIN(ZYDIS_ISA_SET_XOP) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_XOP) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR },
    { ZYDIS_MNEMONIC_VPCOMD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x6AC), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_XOP) ZYDIS_NOTMIN(ZYDIS_ISA_SET_XOP) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_XOP) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR },
    { ZYDIS_MNEMONIC_VPCOMD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x6B0), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_XOP) ZYDIS_NOTMIN(ZYDIS_ISA_SET_XOP) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_XOP) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR },
    { ZYDIS_MNEMONIC_VPCOMQ ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x6B4), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_XOP) ZYDIS_NOTMIN(ZYDIS_ISA_SET_XOP) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_XOP) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR },
    { ZYDIS_MNEMONIC_VPCOMQ ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x6B8), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_XOP) ZYDIS_NOTMIN(ZYDIS_ISA_SET_XOP) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_XOP) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR },
    { ZYDIS_MNEMONIC_VPCOMUB ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x6BC), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_XOP) ZYDIS_NOTMIN(ZYDIS_ISA_SET_XOP) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_XOP) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR },
    { ZYDIS_MNEMONIC_VPCOMUB ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x6C0), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_XOP) ZYDIS_NOTMIN(ZYDIS_ISA_SET_XOP) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_XOP) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR },
    { ZYDIS_MNEMONIC_VPCOMUD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x6C4), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_XOP) ZYDIS_NOTMIN(ZYDIS_ISA_SET_XOP) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_XOP) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR },
    { ZYDIS_MNEMONIC_VPCOMUD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x6C8), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_XOP) ZYDIS_NOTMIN(ZYDIS_ISA_SET_XOP) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_XOP) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR },
    { ZYDIS_MNEMONIC_VPCOMUQ ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x6CC), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_XOP) ZYDIS_NOTMIN(ZYDIS_ISA_SET_XOP) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_XOP) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR },
    { ZYDIS_MNEMONIC_VPCOMUQ ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x6D0), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_XOP) ZYDIS_NOTMIN(ZYDIS_ISA_SET_XOP) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_XOP) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR },
    { ZYDIS_MNEMONIC_VPCOMUW ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x6D4), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_XOP) ZYDIS_NOTMIN(ZYDIS_ISA_SET_XOP) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_XOP) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR },
    { ZYDIS_MNEMONIC_VPCOMUW ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x6D8), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_XOP) ZYDIS_NOTMIN(ZYDIS_ISA_SET_XOP) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_XOP) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR },
    { ZYDIS_MNEMONIC_VPCOMW ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x6DC), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_XOP) ZYDIS_NOTMIN(ZYDIS_ISA_SET_XOP) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_XOP) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR },
    { ZYDIS_MNEMONIC_VPCOMW ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x6E0), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_XOP) ZYDIS_NOTMIN(ZYDIS_ISA_SET_XOP) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_XOP) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR },
    { ZYDIS_MNEMONIC_VPHADDBD ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1D4B), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_XOP) ZYDIS_NOTMIN(ZYDIS_ISA_SET_XOP) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_XOP) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0 },
    { ZYDIS_MNEMONIC_VPHADDBD ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1D4D), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_XOP) ZYDIS_NOTMIN(ZYDIS_ISA_SET_XOP) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_XOP) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0 },
    { ZYDIS_MNEMONIC_VPHADDBQ ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1D4F), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_XOP) ZYDIS_NOTMIN(ZYDIS_ISA_SET_XOP) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_XOP) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0 },
    { ZYDIS_MNEMONIC_VPHADDBQ ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1D51), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_XOP) ZYDIS_NOTMIN(ZYDIS_ISA_SET_XOP) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_XOP) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0 },
    { ZYDIS_MNEMONIC_VPHADDBW ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1101), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_XOP) ZYDIS_NOTMIN(ZYDIS_ISA_SET_XOP) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_XOP) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0 },
    { ZYDIS_MNEMONIC_VPHADDBW ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1104), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_XOP) ZYDIS_NOTMIN(ZYDIS_ISA_SET_XOP) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_XOP) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0 },
    { ZYDIS_MNEMONIC_VPHADDDQ ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1D53), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_XOP) ZYDIS_NOTMIN(ZYDIS_ISA_SET_XOP) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_XOP) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0 },
    { ZYDIS_MNEMONIC_VPHADDDQ ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1D55), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_XOP) ZYDIS_NOTMIN(ZYDIS_ISA_SET_XOP) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_XOP) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0 },
    { ZYDIS_MNEMONIC_VPHADDUBD ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1D57), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_XOP) ZYDIS_NOTMIN(ZYDIS_ISA_SET_XOP) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_XOP) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0 },
    { ZYDIS_MNEMONIC_VPHADDUBD ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1D59), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_XOP) ZYDIS_NOTMIN(ZYDIS_ISA_SET_XOP) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_XOP) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0 },
    { ZYDIS_MNEMONIC_VPHADDUBQ ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1D5B), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_XOP) ZYDIS_NOTMIN(ZYDIS_ISA_SET_XOP) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_XOP) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0 },
    { ZYDIS_MNEMONIC_VPHADDUBQ ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1D5D), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_XOP) ZYDIS_NOTMIN(ZYDIS_ISA_SET_XOP) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_XOP) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0 },
    { ZYDIS_MNEMONIC_VPHADDUBW ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1D5F), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_XOP) ZYDIS_NOTMIN(ZYDIS_ISA_SET_XOP) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_XOP) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0 },
    { ZYDIS_MNEMONIC_VPHADDUBW ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1D61), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_XOP) ZYDIS_NOTMIN(ZYDIS_ISA_SET_XOP) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_XOP) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0 },
    { ZYDIS_MNEMONIC_VPHADDUDQ ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1D63), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_XOP) ZYDIS_NOTMIN(ZYDIS_ISA_SET_XOP) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_XOP) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0 },
    { ZYDIS_MNEMONIC_VPHADDUDQ ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1D65), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_XOP) ZYDIS_NOTMIN(ZYDIS_ISA_SET_XOP) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_XOP) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0 },
    { ZYDIS_MNEMONIC_VPHADDUWD ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1D67), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_XOP) ZYDIS_NOTMIN(ZYDIS_ISA_SET_XOP) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_XOP) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0 },
    { ZYDIS_MNEMONIC_VPHADDUWD ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1D69), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_XOP) ZYDIS_NOTMIN(ZYDIS_ISA_SET_XOP) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_XOP) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0 },
    { ZYDIS_MNEMONIC_VPHADDUWQ ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1D6B), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_XOP) ZYDIS_NOTMIN(ZYDIS_ISA_SET_XOP) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_XOP) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0 },
    { ZYDIS_MNEMONIC_VPHADDUWQ ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1D6D), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_XOP) ZYDIS_NOTMIN(ZYDIS_ISA_SET_XOP) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_XOP) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0 },
    { ZYDIS_MNEMONIC_VPHADDWD ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1D6F), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_XOP) ZYDIS_NOTMIN(ZYDIS_ISA_SET_XOP) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_XOP) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0 },
    { ZYDIS_MNEMONIC_VPHADDWD ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1D71), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_XOP) ZYDIS_NOTMIN(ZYDIS_ISA_SET_XOP) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_XOP) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0 },
    { ZYDIS_MNEMONIC_VPHADDWQ ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1D73), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_XOP) ZYDIS_NOTMIN(ZYDIS_ISA_SET_XOP) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_XOP) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0 },
    { ZYDIS_MNEMONIC_VPHADDWQ ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1D75), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_XOP) ZYDIS_NOTMIN(ZYDIS_ISA_SET_XOP) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_XOP) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0 },
    { ZYDIS_MNEMONIC_VPHSUBBW ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1D77), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_XOP) ZYDIS_NOTMIN(ZYDIS_ISA_SET_XOP) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_XOP) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0 },
    { ZYDIS_MNEMONIC_VPHSUBBW ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1D79), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_XOP) ZYDIS_NOTMIN(ZYDIS_ISA_SET_XOP) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_XOP) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0 },
    { ZYDIS_MNEMONIC_VPHSUBDQ ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1D53), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_XOP) ZYDIS_NOTMIN(ZYDIS_ISA_SET_XOP) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_XOP) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0 },
    { ZYDIS_MNEMONIC_VPHSUBDQ ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1D55), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_XOP) ZYDIS_NOTMIN(ZYDIS_ISA_SET_XOP) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_XOP) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0 },
    { ZYDIS_MNEMONIC_VPHSUBWD ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1D6F), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_XOP) ZYDIS_NOTMIN(ZYDIS_ISA_SET_XOP) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_XOP) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0 },
    { ZYDIS_MNEMONIC_VPHSUBWD ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1D71), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_XOP) ZYDIS_NOTMIN(ZYDIS_ISA_SET_XOP) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_XOP) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0 },
    { ZYDIS_MNEMONIC_VPMACSDD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x6E4), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_XOP) ZYDIS_NOTMIN(ZYDIS_ISA_SET_XOP) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_XOP) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR },
    { ZYDIS_MNEMONIC_VPMACSDD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x6E8), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_XOP) ZYDIS_NOTMIN(ZYDIS_ISA_SET_XOP) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_XOP) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR },
    { ZYDIS_MNEMONIC_VPMACSDQH ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x6EC), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_XOP) ZYDIS_NOTMIN(ZYDIS_ISA_SET_XOP) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_XOP) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR },
    { ZYDIS_MNEMONIC_VPMACSDQH ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x6F0), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_XOP) ZYDIS_NOTMIN(ZYDIS_ISA_SET_XOP) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_XOP) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR },
    { ZYDIS_MNEMONIC_VPMACSDQL ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x6EC), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_XOP) ZYDIS_NOTMIN(ZYDIS_ISA_SET_XOP) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_XOP) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR },
    { ZYDIS_MNEMONIC_VPMACSDQL ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x6F0), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_XOP) ZYDIS_NOTMIN(ZYDIS_ISA_SET_XOP) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_XOP) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR },
    { ZYDIS_MNEMONIC_VPMACSSDD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x6E4), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_XOP) ZYDIS_NOTMIN(ZYDIS_ISA_SET_XOP) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_XOP) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR },
    { ZYDIS_MNEMONIC_VPMACSSDD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x6E8), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_XOP) ZYDIS_NOTMIN(ZYDIS_ISA_SET_XOP) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_XOP) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR },
    { ZYDIS_MNEMONIC_VPMACSSDQH ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x6EC), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_XOP) ZYDIS_NOTMIN(ZYDIS_ISA_SET_XOP) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_XOP) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR },
    { ZYDIS_MNEMONIC_VPMACSSDQH ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x6F0), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_XOP) ZYDIS_NOTMIN(ZYDIS_ISA_SET_XOP) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_XOP) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR },
    { ZYDIS_MNEMONIC_VPMACSSDQL ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x6EC), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_XOP) ZYDIS_NOTMIN(ZYDIS_ISA_SET_XOP) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_XOP) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR },
    { ZYDIS_MNEMONIC_VPMACSSDQL ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x6F0), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_XOP) ZYDIS_NOTMIN(ZYDIS_ISA_SET_XOP) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_XOP) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR },
    { ZYDIS_MNEMONIC_VPMACSSWD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x6F4), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_XOP) ZYDIS_NOTMIN(ZYDIS_ISA_SET_XOP) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_XOP) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR },
    { ZYDIS_MNEMONIC_VPMACSSWD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x6F8), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_XOP) ZYDIS_NOTMIN(ZYDIS_ISA_SET_XOP) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_XOP) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR },
    { ZYDIS_MNEMONIC_VPMACSSWW ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x6FC), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_XOP) ZYDIS_NOTMIN(ZYDIS_ISA_SET_XOP) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_XOP) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR },
    { ZYDIS_MNEMONIC_VPMACSSWW ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x700), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_XOP) ZYDIS_NOTMIN(ZYDIS_ISA_SET_XOP) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_XOP) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR },
    { ZYDIS_MNEMONIC_VPMACSWD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x6F4), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_XOP) ZYDIS_NOTMIN(ZYDIS_ISA_SET_XOP) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_XOP) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR },
    { ZYDIS_MNEMONIC_VPMACSWD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x6F8), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_XOP) ZYDIS_NOTMIN(ZYDIS_ISA_SET_XOP) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_XOP) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR },
    { ZYDIS_MNEMONIC_VPMACSWW ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x6FC), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_XOP) ZYDIS_NOTMIN(ZYDIS_ISA_SET_XOP) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_XOP) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR },
    { ZYDIS_MNEMONIC_VPMACSWW ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x700), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_XOP) ZYDIS_NOTMIN(ZYDIS_ISA_SET_XOP) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_XOP) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR },
    { ZYDIS_MNEMONIC_VPMADCSSWD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x6F4), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_XOP) ZYDIS_NOTMIN(ZYDIS_ISA_SET_XOP) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_XOP) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR },
    { ZYDIS_MNEMONIC_VPMADCSSWD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x6F8), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_XOP) ZYDIS_NOTMIN(ZYDIS_ISA_SET_XOP) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_XOP) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR },
    { ZYDIS_MNEMONIC_VPMADCSWD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x6F4), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_XOP) ZYDIS_NOTMIN(ZYDIS_ISA_SET_XOP) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_XOP) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR },
    { ZYDIS_MNEMONIC_VPMADCSWD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x6F8), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_XOP) ZYDIS_NOTMIN(ZYDIS_ISA_SET_XOP) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_XOP) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR },
    { ZYDIS_MNEMONIC_VPPERM ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x6FC), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_XOP) ZYDIS_NOTMIN(ZYDIS_ISA_SET_XOP) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_XOP) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR },
    { ZYDIS_MNEMONIC_VPPERM ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x704), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_XOP) ZYDIS_NOTMIN(ZYDIS_ISA_SET_XOP) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_XOP) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR },
    { ZYDIS_MNEMONIC_VPPERM ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x700), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_XOP) ZYDIS_NOTMIN(ZYDIS_ISA_SET_XOP) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_XOP) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR },
    { ZYDIS_MNEMONIC_VPPERM ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x708), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_XOP) ZYDIS_NOTMIN(ZYDIS_ISA_SET_XOP) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_XOP) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR },
    { ZYDIS_MNEMONIC_VPROTB ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x10DD), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_XOP) ZYDIS_NOTMIN(ZYDIS_ISA_SET_XOP) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_XOP) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0 },
    { ZYDIS_MNEMONIC_VPROTB ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x10E0), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_XOP) ZYDIS_NOTMIN(ZYDIS_ISA_SET_XOP) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_XOP) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0 },
    { ZYDIS_MNEMONIC_VPROTB ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x10E3), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_XOP) ZYDIS_NOTMIN(ZYDIS_ISA_SET_XOP) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_XOP) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR },
    { ZYDIS_MNEMONIC_VPROTB ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x6BC), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_XOP) ZYDIS_NOTMIN(ZYDIS_ISA_SET_XOP) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_XOP) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR },
    { ZYDIS_MNEMONIC_VPROTB ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x10E6), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_XOP) ZYDIS_NOTMIN(ZYDIS_ISA_SET_XOP) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_XOP) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR },
    { ZYDIS_MNEMONIC_VPROTB ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x6C0), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_XOP) ZYDIS_NOTMIN(ZYDIS_ISA_SET_XOP) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_XOP) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR },
    { ZYDIS_MNEMONIC_VPROTD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0xFC3), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_XOP) ZYDIS_NOTMIN(ZYDIS_ISA_SET_XOP) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_XOP) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0 },
    { ZYDIS_MNEMONIC_VPROTD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0xFC6), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_XOP) ZYDIS_NOTMIN(ZYDIS_ISA_SET_XOP) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_XOP) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0 },
    { ZYDIS_MNEMONIC_VPROTD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x10E9), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_XOP) ZYDIS_NOTMIN(ZYDIS_ISA_SET_XOP) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_XOP) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR },
    { ZYDIS_MNEMONIC_VPROTD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x6C4), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_XOP) ZYDIS_NOTMIN(ZYDIS_ISA_SET_XOP) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_XOP) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR },
    { ZYDIS_MNEMONIC_VPROTD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x10EC), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_XOP) ZYDIS_NOTMIN(ZYDIS_ISA_SET_XOP) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_XOP) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR },
    { ZYDIS_MNEMONIC_VPROTD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x6C8), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_XOP) ZYDIS_NOTMIN(ZYDIS_ISA_SET_XOP) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_XOP) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR },
    { ZYDIS_MNEMONIC_VPROTQ ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x10EF), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_XOP) ZYDIS_NOTMIN(ZYDIS_ISA_SET_XOP) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_XOP) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0 },
    { ZYDIS_MNEMONIC_VPROTQ ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x10F2), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_XOP) ZYDIS_NOTMIN(ZYDIS_ISA_SET_XOP) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_XOP) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0 },
    { ZYDIS_MNEMONIC_VPROTQ ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x10F5), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_XOP) ZYDIS_NOTMIN(ZYDIS_ISA_SET_XOP) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_XOP) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR },
    { ZYDIS_MNEMONIC_VPROTQ ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x6CC), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_XOP) ZYDIS_NOTMIN(ZYDIS_ISA_SET_XOP) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_XOP) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR },
    { ZYDIS_MNEMONIC_VPROTQ ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x10F8), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_XOP) ZYDIS_NOTMIN(ZYDIS_ISA_SET_XOP) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_XOP) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR },
    { ZYDIS_MNEMONIC_VPROTQ ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x6D0), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_XOP) ZYDIS_NOTMIN(ZYDIS_ISA_SET_XOP) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_XOP) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR },
    { ZYDIS_MNEMONIC_VPROTW ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0xFC9), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_XOP) ZYDIS_NOTMIN(ZYDIS_ISA_SET_XOP) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_XOP) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0 },
    { ZYDIS_MNEMONIC_VPROTW ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0xFCC), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_XOP) ZYDIS_NOTMIN(ZYDIS_ISA_SET_XOP) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_XOP) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0 },
    { ZYDIS_MNEMONIC_VPROTW ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x10FB), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_XOP) ZYDIS_NOTMIN(ZYDIS_ISA_SET_XOP) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_XOP) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR },
    { ZYDIS_MNEMONIC_VPROTW ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x6D4), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_XOP) ZYDIS_NOTMIN(ZYDIS_ISA_SET_XOP) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_XOP) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR },
    { ZYDIS_MNEMONIC_VPROTW ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x10FE), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_XOP) ZYDIS_NOTMIN(ZYDIS_ISA_SET_XOP) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_XOP) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR },
    { ZYDIS_MNEMONIC_VPROTW ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x6D8), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_XOP) ZYDIS_NOTMIN(ZYDIS_ISA_SET_XOP) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_XOP) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR },
    { ZYDIS_MNEMONIC_VPSHAB ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1101), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_XOP) ZYDIS_NOTMIN(ZYDIS_ISA_SET_XOP) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_XOP) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR },
    { ZYDIS_MNEMONIC_VPSHAB ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x6A4), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_XOP) ZYDIS_NOTMIN(ZYDIS_ISA_SET_XOP) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_XOP) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR },
    { ZYDIS_MNEMONIC_VPSHAB ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1104), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_XOP) ZYDIS_NOTMIN(ZYDIS_ISA_SET_XOP) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_XOP) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR },
    { ZYDIS_MNEMONIC_VPSHAB ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x6A8), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_XOP) ZYDIS_NOTMIN(ZYDIS_ISA_SET_XOP) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_XOP) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR },
    { ZYDIS_MNEMONIC_VPSHAD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1107), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_XOP) ZYDIS_NOTMIN(ZYDIS_ISA_SET_XOP) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_XOP) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR },
    { ZYDIS_MNEMONIC_VPSHAD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x6AC), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_XOP) ZYDIS_NOTMIN(ZYDIS_ISA_SET_XOP) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_XOP) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR },
    { ZYDIS_MNEMONIC_VPSHAD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x110A), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_XOP) ZYDIS_NOTMIN(ZYDIS_ISA_SET_XOP) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_XOP) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR },
    { ZYDIS_MNEMONIC_VPSHAD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x6B0), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_XOP) ZYDIS_NOTMIN(ZYDIS_ISA_SET_XOP) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_XOP) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR },
    { ZYDIS_MNEMONIC_VPSHAQ ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x110D), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_XOP) ZYDIS_NOTMIN(ZYDIS_ISA_SET_XOP) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_XOP) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR },
    { ZYDIS_MNEMONIC_VPSHAQ ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x6B4), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_XOP) ZYDIS_NOTMIN(ZYDIS_ISA_SET_XOP) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_XOP) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR },
    { ZYDIS_MNEMONIC_VPSHAQ ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1110), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_XOP) ZYDIS_NOTMIN(ZYDIS_ISA_SET_XOP) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_XOP) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR },
    { ZYDIS_MNEMONIC_VPSHAQ ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x6B8), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_XOP) ZYDIS_NOTMIN(ZYDIS_ISA_SET_XOP) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_XOP) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR },
    { ZYDIS_MNEMONIC_VPSHAW ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1113), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_XOP) ZYDIS_NOTMIN(ZYDIS_ISA_SET_XOP) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_XOP) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR },
    { ZYDIS_MNEMONIC_VPSHAW ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x6DC), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_XOP) ZYDIS_NOTMIN(ZYDIS_ISA_SET_XOP) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_XOP) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR },
    { ZYDIS_MNEMONIC_VPSHAW ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1116), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_XOP) ZYDIS_NOTMIN(ZYDIS_ISA_SET_XOP) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_XOP) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR },
    { ZYDIS_MNEMONIC_VPSHAW ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x6E0), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_XOP) ZYDIS_NOTMIN(ZYDIS_ISA_SET_XOP) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_XOP) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR },
    { ZYDIS_MNEMONIC_VPSHLB ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x10E3), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_XOP) ZYDIS_NOTMIN(ZYDIS_ISA_SET_XOP) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_XOP) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR },
    { ZYDIS_MNEMONIC_VPSHLB ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x6BC), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_XOP) ZYDIS_NOTMIN(ZYDIS_ISA_SET_XOP) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_XOP) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR },
    { ZYDIS_MNEMONIC_VPSHLB ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x10E6), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_XOP) ZYDIS_NOTMIN(ZYDIS_ISA_SET_XOP) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_XOP) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR },
    { ZYDIS_MNEMONIC_VPSHLB ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x6C0), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_XOP) ZYDIS_NOTMIN(ZYDIS_ISA_SET_XOP) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_XOP) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR },
    { ZYDIS_MNEMONIC_VPSHLD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x10E9), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_XOP) ZYDIS_NOTMIN(ZYDIS_ISA_SET_XOP) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_XOP) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR },
    { ZYDIS_MNEMONIC_VPSHLD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x6C4), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_XOP) ZYDIS_NOTMIN(ZYDIS_ISA_SET_XOP) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_XOP) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR },
    { ZYDIS_MNEMONIC_VPSHLD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x10EC), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_XOP) ZYDIS_NOTMIN(ZYDIS_ISA_SET_XOP) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_XOP) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR },
    { ZYDIS_MNEMONIC_VPSHLD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x6C8), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_XOP) ZYDIS_NOTMIN(ZYDIS_ISA_SET_XOP) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_XOP) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR },
    { ZYDIS_MNEMONIC_VPSHLQ ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x10F5), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_XOP) ZYDIS_NOTMIN(ZYDIS_ISA_SET_XOP) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_XOP) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR },
    { ZYDIS_MNEMONIC_VPSHLQ ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x6CC), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_XOP) ZYDIS_NOTMIN(ZYDIS_ISA_SET_XOP) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_XOP) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR },
    { ZYDIS_MNEMONIC_VPSHLQ ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x10F8), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_XOP) ZYDIS_NOTMIN(ZYDIS_ISA_SET_XOP) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_XOP) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR },
    { ZYDIS_MNEMONIC_VPSHLQ ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x6D0), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_XOP) ZYDIS_NOTMIN(ZYDIS_ISA_SET_XOP) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_XOP) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR },
    { ZYDIS_MNEMONIC_VPSHLW ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x10FB), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_XOP) ZYDIS_NOTMIN(ZYDIS_ISA_SET_XOP) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_XOP) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR },
    { ZYDIS_MNEMONIC_VPSHLW ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x6D4), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_XOP) ZYDIS_NOTMIN(ZYDIS_ISA_SET_XOP) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_XOP) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR },
    { ZYDIS_MNEMONIC_VPSHLW ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x10FE), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_XOP) ZYDIS_NOTMIN(ZYDIS_ISA_SET_XOP) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_XOP) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR },
    { ZYDIS_MNEMONIC_VPSHLW ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x6D8), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_XOP) ZYDIS_NOTMIN(ZYDIS_ISA_SET_XOP) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_XOP) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR }
};

const ZydisInstructionDefinitionVEX ISTR_DEFINITIONS_VEX[] =
{
    { ZYDIS_MNEMONIC_ANDN ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x70C), 0, 0 ZYDIS_NOTMIN(0x43), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_BMI1) ZYDIS_NOTMIN(ZYDIS_ISA_SET_BMI1) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BMI1) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_GPR, ZYDIS_REGKIND_GPR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_GPR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_ANDN ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x710), 0, 0 ZYDIS_NOTMIN(0x43), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_BMI1) ZYDIS_NOTMIN(ZYDIS_ISA_SET_BMI1) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BMI1) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_GPR, ZYDIS_REGKIND_GPR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_GPR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_ANDN ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x714), 0, 0 ZYDIS_NOTMIN(0x43), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_BMI1) ZYDIS_NOTMIN(ZYDIS_ISA_SET_BMI1) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BMI1) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_GPR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_GPR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_ANDN ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x718), 0, 0 ZYDIS_NOTMIN(0x43), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_BMI1) ZYDIS_NOTMIN(ZYDIS_ISA_SET_BMI1) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BMI1) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_GPR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_GPR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_ANDN ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x70C), 0, 0 ZYDIS_NOTMIN(0x43), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_BMI1) ZYDIS_NOTMIN(ZYDIS_ISA_SET_BMI1) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BMI1) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_GPR, ZYDIS_REGKIND_GPR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_GPR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_ANDN ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x714), 0, 0 ZYDIS_NOTMIN(0x43), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_BMI1) ZYDIS_NOTMIN(ZYDIS_ISA_SET_BMI1) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BMI1) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_GPR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_GPR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_BEXTR ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x71C), 0, 0 ZYDIS_NOTMIN(0x47), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_BMI1) ZYDIS_NOTMIN(ZYDIS_ISA_SET_BMI1) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BMI1) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_GPR, ZYDIS_REGKIND_GPR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_GPR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_BEXTR ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x720), 0, 0 ZYDIS_NOTMIN(0x47), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_BMI1) ZYDIS_NOTMIN(ZYDIS_ISA_SET_BMI1) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BMI1) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_GPR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_GPR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_BLSI ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x10D7), 0, 0 ZYDIS_NOTMIN(0x43), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_BMI1) ZYDIS_NOTMIN(ZYDIS_ISA_SET_BMI1) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BMI1) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, ZYDIS_REGKIND_GPR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_GPR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_BLSI ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x10DA), 0, 0 ZYDIS_NOTMIN(0x43), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_BMI1) ZYDIS_NOTMIN(ZYDIS_ISA_SET_BMI1) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BMI1) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_GPR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_BLSMSK ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x10D7), 0, 0 ZYDIS_NOTMIN(0x3D), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_BMI1) ZYDIS_NOTMIN(ZYDIS_ISA_SET_BMI1) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BMI1) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, ZYDIS_REGKIND_GPR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_GPR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_BLSMSK ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x10DA), 0, 0 ZYDIS_NOTMIN(0x3D), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_BMI1) ZYDIS_NOTMIN(ZYDIS_ISA_SET_BMI1) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BMI1) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_GPR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_BLSR ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x10D7), 0, 0 ZYDIS_NOTMIN(0x3B), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_BMI1) ZYDIS_NOTMIN(ZYDIS_ISA_SET_BMI1) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BMI1) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, ZYDIS_REGKIND_GPR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_GPR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_BLSR ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x10DA), 0, 0 ZYDIS_NOTMIN(0x3B), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_BMI1) ZYDIS_NOTMIN(ZYDIS_ISA_SET_BMI1) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BMI1) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_GPR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_BZHI ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x724), 0, 0 ZYDIS_NOTMIN(0x3B), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_BMI2) ZYDIS_NOTMIN(ZYDIS_ISA_SET_BMI2) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BMI2) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_GPR, ZYDIS_REGKIND_GPR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_GPR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_BZHI ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x728), 0, 0 ZYDIS_NOTMIN(0x3B), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_BMI2) ZYDIS_NOTMIN(ZYDIS_ISA_SET_BMI2) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BMI2) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_GPR, ZYDIS_REGKIND_GPR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_GPR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_BZHI ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x72C), 0, 0 ZYDIS_NOTMIN(0x3B), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_BMI2) ZYDIS_NOTMIN(ZYDIS_ISA_SET_BMI2) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BMI2) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_GPR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_GPR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_BZHI ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x730), 0, 0 ZYDIS_NOTMIN(0x3B), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_BMI2) ZYDIS_NOTMIN(ZYDIS_ISA_SET_BMI2) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BMI2) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_GPR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_GPR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_BZHI ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x724), 0, 0 ZYDIS_NOTMIN(0x3B), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_BMI2) ZYDIS_NOTMIN(ZYDIS_ISA_SET_BMI2) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BMI2) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_GPR, ZYDIS_REGKIND_GPR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_GPR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_BZHI ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x72C), 0, 0 ZYDIS_NOTMIN(0x3B), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_BMI2) ZYDIS_NOTMIN(ZYDIS_ISA_SET_BMI2) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BMI2) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_GPR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_GPR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_CLEVICT0 ZYDIS_NOTMIN(1) ZYDIS_NOTMIN(1) ZYDIS_NOTMIN(0x1F02), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_PREFETCH) ZYDIS_NOTMIN(ZYDIS_ISA_SET_KNCV) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_KNC) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_CLEVICT1 ZYDIS_NOTMIN(1) ZYDIS_NOTMIN(1) ZYDIS_NOTMIN(0x1F02), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_PREFETCH) ZYDIS_NOTMIN(ZYDIS_ISA_SET_KNCV) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_KNC) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_DELAY ZYDIS_NOTMIN(1) ZYDIS_NOTMIN(1) ZYDIS_NOTMIN(0x67D), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_KNCSCALAR) ZYDIS_NOTMIN(ZYDIS_ISA_SET_KNCV) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_KNC) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, ZYDIS_REGKIND_GPR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_DELAY ZYDIS_NOTMIN(1) ZYDIS_NOTMIN(1) ZYDIS_NOTMIN(0x712), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_KNCSCALAR) ZYDIS_NOTMIN(ZYDIS_ISA_SET_KNCV) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_KNC) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, ZYDIS_REGKIND_GPR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_JKNZD ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1D7B), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_COND_BR) ZYDIS_NOTMIN(ZYDIS_ISA_SET_KNCJKBR) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_KNCV) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_SHORT) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, 0 ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_MASK, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_JKNZD ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1D7D), 5, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_COND_BR) ZYDIS_NOTMIN(ZYDIS_ISA_SET_KNCJKBR) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_KNCV) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NEAR) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, 0 ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_MASK, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_JKZD ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1D7B), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_COND_BR) ZYDIS_NOTMIN(ZYDIS_ISA_SET_KNCJKBR) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_KNCV) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_SHORT) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, 0 ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_MASK, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_JKZD ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1D7D), 5, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_COND_BR) ZYDIS_NOTMIN(ZYDIS_ISA_SET_KNCJKBR) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_KNCV) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NEAR) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, 0 ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_MASK, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_KADDB ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1119), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_KMASK) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512DQ_KOP) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512VEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_K20), ZYDIS_REGKIND_MASK, ZYDIS_REGKIND_MASK ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_MASK, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_KADDD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1119), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_KMASK) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512BW_KOP) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512VEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_K20), ZYDIS_REGKIND_MASK, ZYDIS_REGKIND_MASK ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_MASK, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_KADDQ ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1119), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_KMASK) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512BW_KOP) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512VEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_K20), ZYDIS_REGKIND_MASK, ZYDIS_REGKIND_MASK ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_MASK, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_KADDW ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1119), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_KMASK) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512DQ_KOP) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512VEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_K20), ZYDIS_REGKIND_MASK, ZYDIS_REGKIND_MASK ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_MASK, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_KAND ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1D7F), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_KNCMASK) ZYDIS_NOTMIN(ZYDIS_ISA_SET_KNCV) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_KNC) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_MASK, ZYDIS_REGKIND_MASK ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_KANDB ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1119), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_KMASK) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512DQ_KOP) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512VEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_K20), ZYDIS_REGKIND_MASK, ZYDIS_REGKIND_MASK ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_MASK, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_KANDD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1119), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_KMASK) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512BW_KOP) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512VEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_K20), ZYDIS_REGKIND_MASK, ZYDIS_REGKIND_MASK ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_MASK, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_KANDN ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1D7F), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_KNCMASK) ZYDIS_NOTMIN(ZYDIS_ISA_SET_KNCV) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_KNC) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_MASK, ZYDIS_REGKIND_MASK ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_KANDNB ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1119), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_KMASK) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512DQ_KOP) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512VEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_K20), ZYDIS_REGKIND_MASK, ZYDIS_REGKIND_MASK ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_MASK, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_KANDND ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1119), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_KMASK) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512BW_KOP) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512VEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_K20), ZYDIS_REGKIND_MASK, ZYDIS_REGKIND_MASK ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_MASK, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_KANDNQ ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1119), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_KMASK) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512BW_KOP) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512VEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_K20), ZYDIS_REGKIND_MASK, ZYDIS_REGKIND_MASK ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_MASK, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_KANDNR ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1D7F), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_KNCMASK) ZYDIS_NOTMIN(ZYDIS_ISA_SET_KNCV) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_KNC) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_MASK, ZYDIS_REGKIND_MASK ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_KANDNW ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1119), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_KMASK) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_KOP) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512VEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_K20), ZYDIS_REGKIND_MASK, ZYDIS_REGKIND_MASK ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_MASK, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_KANDQ ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1119), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_KMASK) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512BW_KOP) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512VEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_K20), ZYDIS_REGKIND_MASK, ZYDIS_REGKIND_MASK ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_MASK, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_KANDW ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1119), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_KMASK) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_KOP) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512VEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_K20), ZYDIS_REGKIND_MASK, ZYDIS_REGKIND_MASK ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_MASK, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_KCONCATH ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x111C), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_KNCMASK) ZYDIS_NOTMIN(ZYDIS_ISA_SET_KNCV) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_KNC) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_GPR, ZYDIS_REGKIND_MASK ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_MASK, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_KCONCATL ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x111C), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_KNCMASK) ZYDIS_NOTMIN(ZYDIS_ISA_SET_KNCV) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_KNC) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_GPR, ZYDIS_REGKIND_MASK ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_MASK, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_KEXTRACT ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x111F), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_KNCMASK) ZYDIS_NOTMIN(ZYDIS_ISA_SET_KNCV) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_KNC) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_MASK, ZYDIS_REGKIND_GPR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_KMERGE2L1H ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1D7F), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_KNCMASK) ZYDIS_NOTMIN(ZYDIS_ISA_SET_KNCV) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_KNC) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_MASK, ZYDIS_REGKIND_MASK ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_KMERGE2L1L ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1D7F), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_KNCMASK) ZYDIS_NOTMIN(ZYDIS_ISA_SET_KNCV) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_KNC) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_MASK, ZYDIS_REGKIND_MASK ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_KMOV ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1D7F), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_KNCMASK) ZYDIS_NOTMIN(ZYDIS_ISA_SET_KNCV) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_KNC) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_MASK, ZYDIS_REGKIND_MASK ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_KMOV ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1D81), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_KNCMASK) ZYDIS_NOTMIN(ZYDIS_ISA_SET_KNCV) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_KNC) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_MASK, ZYDIS_REGKIND_GPR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_KMOV ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1D83), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_KNCMASK) ZYDIS_NOTMIN(ZYDIS_ISA_SET_KNCV) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_KNC) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_GPR, ZYDIS_REGKIND_MASK ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_KMOVB ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1D85), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_KMASK) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512DQ_KOP) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512VEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_K21), ZYDIS_REGKIND_MASK, ZYDIS_REGKIND_MASK ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_KMOVB ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1D87), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_KMASK) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512DQ_KOP) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512VEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_K21), ZYDIS_REGKIND_MASK, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_KMOVB ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1D89), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_KMASK) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512DQ_KOP) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512VEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_K21), ZYDIS_REGKIND_MASK, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_KMOVB ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1D8B), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_KMASK) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512DQ_KOP) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512VEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_K20), ZYDIS_REGKIND_MASK, ZYDIS_REGKIND_GPR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_KMOVB ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1D8D), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_KMASK) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512DQ_KOP) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512VEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_K20), ZYDIS_REGKIND_GPR, ZYDIS_REGKIND_MASK ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_KMOVD ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1D8F), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_KMASK) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512BW_KOP) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512VEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_K21), ZYDIS_REGKIND_MASK, ZYDIS_REGKIND_MASK ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_KMOVD ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1D91), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_KMASK) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512BW_KOP) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512VEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_K21), ZYDIS_REGKIND_MASK, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_KMOVD ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1D93), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_KMASK) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512BW_KOP) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512VEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_K21), ZYDIS_REGKIND_MASK, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_KMOVD ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1D8B), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_KMASK) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512BW_KOP) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512VEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_K20), ZYDIS_REGKIND_MASK, ZYDIS_REGKIND_GPR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_KMOVD ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1D8B), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_KMASK) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512BW_KOP) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512VEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_K20), ZYDIS_REGKIND_MASK, ZYDIS_REGKIND_GPR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_KMOVD ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1D8D), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_KMASK) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512BW_KOP) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512VEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_K20), ZYDIS_REGKIND_GPR, ZYDIS_REGKIND_MASK ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_KMOVD ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1D8D), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_KMASK) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512BW_KOP) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512VEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_K20), ZYDIS_REGKIND_GPR, ZYDIS_REGKIND_MASK ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_KMOVQ ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1D95), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_KMASK) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512BW_KOP) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512VEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_K21), ZYDIS_REGKIND_MASK, ZYDIS_REGKIND_MASK ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_KMOVQ ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1D97), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_KMASK) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512BW_KOP) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512VEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_K21), ZYDIS_REGKIND_MASK, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_KMOVQ ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1D99), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_KMASK) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512BW_KOP) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512VEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_K21), ZYDIS_REGKIND_MASK, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_KMOVQ ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1D9B), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_KMASK) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512BW_KOP) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512VEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_K20), ZYDIS_REGKIND_MASK, ZYDIS_REGKIND_GPR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_KMOVQ ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1D9D), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_KMASK) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512BW_KOP) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512VEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_K20), ZYDIS_REGKIND_GPR, ZYDIS_REGKIND_MASK ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_KMOVW ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1D9F), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_KMASK) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_KOP) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512VEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_K21), ZYDIS_REGKIND_MASK, ZYDIS_REGKIND_MASK ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_KMOVW ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1DA1), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_KMASK) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_KOP) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512VEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_K21), ZYDIS_REGKIND_MASK, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_KMOVW ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1DA3), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_KMASK) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_KOP) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512VEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_K21), ZYDIS_REGKIND_MASK, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_KMOVW ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1D8B), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_KMASK) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_KOP) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512VEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_K21), ZYDIS_REGKIND_MASK, ZYDIS_REGKIND_GPR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_KMOVW ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1D8D), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_KMASK) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_KOP) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512VEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_K20), ZYDIS_REGKIND_GPR, ZYDIS_REGKIND_MASK ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_KNOT ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1D7F), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_KNCMASK) ZYDIS_NOTMIN(ZYDIS_ISA_SET_KNCV) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_KNC) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_MASK, ZYDIS_REGKIND_MASK ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_KNOTB ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1128), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_KMASK) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512DQ_KOP) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512VEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_K20), ZYDIS_REGKIND_MASK, ZYDIS_REGKIND_MASK ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_KNOTD ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1128), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_KMASK) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512BW_KOP) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512VEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_K20), ZYDIS_REGKIND_MASK, ZYDIS_REGKIND_MASK ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_KNOTQ ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1128), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_KMASK) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512BW_KOP) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512VEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_K20), ZYDIS_REGKIND_MASK, ZYDIS_REGKIND_MASK ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_KNOTW ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1128), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_KMASK) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_KOP) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512VEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_K20), ZYDIS_REGKIND_MASK, ZYDIS_REGKIND_MASK ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_KOR ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1D7F), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_KNCMASK) ZYDIS_NOTMIN(ZYDIS_ISA_SET_KNCV) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_KNC) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_MASK, ZYDIS_REGKIND_MASK ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_KORB ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1119), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_KMASK) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512DQ_KOP) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512VEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_K20), ZYDIS_REGKIND_MASK, ZYDIS_REGKIND_MASK ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_MASK, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_KORD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1119), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_KMASK) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512BW_KOP) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512VEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_K20), ZYDIS_REGKIND_MASK, ZYDIS_REGKIND_MASK ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_MASK, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_KORQ ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1119), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_KMASK) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512BW_KOP) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512VEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_K20), ZYDIS_REGKIND_MASK, ZYDIS_REGKIND_MASK ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_MASK, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_KORTEST ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1122), 0, 0 ZYDIS_NOTMIN(0x37), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_KNCMASK) ZYDIS_NOTMIN(ZYDIS_ISA_SET_KNCV) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_KNC) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_MASK, ZYDIS_REGKIND_MASK ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_KORTESTB ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1125), 0, 0 ZYDIS_NOTMIN(0x37), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_KMASK) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512DQ_KOP) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512VEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_K20), ZYDIS_REGKIND_MASK, ZYDIS_REGKIND_MASK ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_KORTESTD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1125), 0, 0 ZYDIS_NOTMIN(0x37), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_KMASK) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512BW_KOP) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512VEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_K20), ZYDIS_REGKIND_MASK, ZYDIS_REGKIND_MASK ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_KORTESTQ ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1125), 0, 0 ZYDIS_NOTMIN(0x37), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_KMASK) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512BW_KOP) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512VEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_K20), ZYDIS_REGKIND_MASK, ZYDIS_REGKIND_MASK ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_KORTESTW ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1125), 0, 0 ZYDIS_NOTMIN(0x37), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_KMASK) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_KOP) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512VEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_K20), ZYDIS_REGKIND_MASK, ZYDIS_REGKIND_MASK ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_KORW ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1119), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_KMASK) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_KOP) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512VEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_K20), ZYDIS_REGKIND_MASK, ZYDIS_REGKIND_MASK ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_MASK, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_KSHIFTLB ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1128), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_KMASK) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512DQ_KOP) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512VEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_K20), ZYDIS_REGKIND_MASK, ZYDIS_REGKIND_MASK ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_KSHIFTLD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1128), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_KMASK) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512BW_KOP) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512VEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_K20), ZYDIS_REGKIND_MASK, ZYDIS_REGKIND_MASK ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_KSHIFTLQ ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1128), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_KMASK) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512BW_KOP) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512VEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_K20), ZYDIS_REGKIND_MASK, ZYDIS_REGKIND_MASK ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_KSHIFTLW ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1128), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_KMASK) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_KOP) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512VEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_K20), ZYDIS_REGKIND_MASK, ZYDIS_REGKIND_MASK ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_KSHIFTRB ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1128), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_KMASK) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512DQ_KOP) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512VEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_K20), ZYDIS_REGKIND_MASK, ZYDIS_REGKIND_MASK ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_KSHIFTRD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1128), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_KMASK) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512BW_KOP) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512VEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_K20), ZYDIS_REGKIND_MASK, ZYDIS_REGKIND_MASK ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_KSHIFTRQ ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1128), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_KMASK) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512BW_KOP) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512VEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_K20), ZYDIS_REGKIND_MASK, ZYDIS_REGKIND_MASK ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_KSHIFTRW ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1128), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_KMASK) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_KOP) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512VEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_K20), ZYDIS_REGKIND_MASK, ZYDIS_REGKIND_MASK ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_KTESTB ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1125), 0, 0 ZYDIS_NOTMIN(0x37), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_KMASK) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512DQ_KOP) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512VEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_K20), ZYDIS_REGKIND_MASK, ZYDIS_REGKIND_MASK ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_KTESTD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1125), 0, 0 ZYDIS_NOTMIN(0x37), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_KMASK) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512BW_KOP) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512VEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_K20), ZYDIS_REGKIND_MASK, ZYDIS_REGKIND_MASK ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_KTESTQ ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1125), 0, 0 ZYDIS_NOTMIN(0x37), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_KMASK) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512BW_KOP) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512VEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_K20), ZYDIS_REGKIND_MASK, ZYDIS_REGKIND_MASK ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_KTESTW ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1125), 0, 0 ZYDIS_NOTMIN(0x37), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_KMASK) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512DQ_KOP) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512VEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_K20), ZYDIS_REGKIND_MASK, ZYDIS_REGKIND_MASK ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_KUNPCKBW ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1119), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_KMASK) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_KOP) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512VEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_K20), ZYDIS_REGKIND_MASK, ZYDIS_REGKIND_MASK ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_MASK, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_KUNPCKDQ ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1119), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_KMASK) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512BW_KOP) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512VEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_K20), ZYDIS_REGKIND_MASK, ZYDIS_REGKIND_MASK ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_MASK, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_KUNPCKWD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1119), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_KMASK) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512BW_KOP) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512VEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_K20), ZYDIS_REGKIND_MASK, ZYDIS_REGKIND_MASK ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_MASK, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_KXNOR ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1D7F), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_KNCMASK) ZYDIS_NOTMIN(ZYDIS_ISA_SET_KNCV) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_KNC) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_MASK, ZYDIS_REGKIND_MASK ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_KXNORB ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1119), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_KMASK) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512DQ_KOP) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512VEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_K20), ZYDIS_REGKIND_MASK, ZYDIS_REGKIND_MASK ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_MASK, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_KXNORD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1119), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_KMASK) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512BW_KOP) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512VEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_K20), ZYDIS_REGKIND_MASK, ZYDIS_REGKIND_MASK ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_MASK, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_KXNORQ ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1119), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_KMASK) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512BW_KOP) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512VEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_K20), ZYDIS_REGKIND_MASK, ZYDIS_REGKIND_MASK ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_MASK, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_KXNORW ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1119), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_KMASK) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_KOP) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512VEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_K20), ZYDIS_REGKIND_MASK, ZYDIS_REGKIND_MASK ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_MASK, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_KXOR ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1D7F), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_KNCMASK) ZYDIS_NOTMIN(ZYDIS_ISA_SET_KNCV) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_KNC) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_MASK, ZYDIS_REGKIND_MASK ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_KXORB ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1119), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_KMASK) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512DQ_KOP) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512VEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_K20), ZYDIS_REGKIND_MASK, ZYDIS_REGKIND_MASK ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_MASK, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_KXORD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1119), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_KMASK) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512BW_KOP) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512VEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_K20), ZYDIS_REGKIND_MASK, ZYDIS_REGKIND_MASK ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_MASK, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_KXORQ ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1119), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_KMASK) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512BW_KOP) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512VEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_K20), ZYDIS_REGKIND_MASK, ZYDIS_REGKIND_MASK ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_MASK, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_KXORW ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1119), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_KMASK) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_KOP) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512VEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_K20), ZYDIS_REGKIND_MASK, ZYDIS_REGKIND_MASK ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_MASK, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_LDTILECFG ZYDIS_NOTMIN(1) ZYDIS_NOTMIN(1) ZYDIS_NOTMIN(0x1F08), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AMX_TILE) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AMX_TILE) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AMX_TILE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AMXE1), 0, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_LDTILECFG ZYDIS_NOTMIN(1) ZYDIS_NOTMIN(1) ZYDIS_NOTMIN(0x1F09), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AMX_TILE) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AMX_TILE) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AMX_TILE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AMXE1), 0, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_LZCNT ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x112B), 0, 0 ZYDIS_NOTMIN(0x37), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_KNCSCALAR) ZYDIS_NOTMIN(ZYDIS_ISA_SET_KNCV) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_KNC) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_GPR, ZYDIS_REGKIND_GPR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_LZCNT ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x112E), 0, 0 ZYDIS_NOTMIN(0x37), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_KNCSCALAR) ZYDIS_NOTMIN(ZYDIS_ISA_SET_KNCV) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_KNC) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_GPR, ZYDIS_REGKIND_GPR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_MULX ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x734), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_BMI2) ZYDIS_NOTMIN(ZYDIS_ISA_SET_BMI2) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BMI2) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_GPR, ZYDIS_REGKIND_GPR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_GPR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_MULX ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x738), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_BMI2) ZYDIS_NOTMIN(ZYDIS_ISA_SET_BMI2) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BMI2) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_GPR, ZYDIS_REGKIND_GPR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_GPR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_MULX ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x73C), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_BMI2) ZYDIS_NOTMIN(ZYDIS_ISA_SET_BMI2) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BMI2) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_GPR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_GPR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_MULX ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x740), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_BMI2) ZYDIS_NOTMIN(ZYDIS_ISA_SET_BMI2) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BMI2) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_GPR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_GPR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_MULX ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x734), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_BMI2) ZYDIS_NOTMIN(ZYDIS_ISA_SET_BMI2) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BMI2) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_GPR, ZYDIS_REGKIND_GPR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_GPR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_MULX ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x73C), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_BMI2) ZYDIS_NOTMIN(ZYDIS_ISA_SET_BMI2) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BMI2) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_GPR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_GPR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_PDEP ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x70C), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_BMI2) ZYDIS_NOTMIN(ZYDIS_ISA_SET_BMI2) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BMI2) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_GPR, ZYDIS_REGKIND_GPR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_GPR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_PDEP ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x710), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_BMI2) ZYDIS_NOTMIN(ZYDIS_ISA_SET_BMI2) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BMI2) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_GPR, ZYDIS_REGKIND_GPR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_GPR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_PDEP ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x714), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_BMI2) ZYDIS_NOTMIN(ZYDIS_ISA_SET_BMI2) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BMI2) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_GPR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_GPR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_PDEP ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x718), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_BMI2) ZYDIS_NOTMIN(ZYDIS_ISA_SET_BMI2) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BMI2) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_GPR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_GPR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_PDEP ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x70C), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_BMI2) ZYDIS_NOTMIN(ZYDIS_ISA_SET_BMI2) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BMI2) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_GPR, ZYDIS_REGKIND_GPR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_GPR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_PDEP ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x714), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_BMI2) ZYDIS_NOTMIN(ZYDIS_ISA_SET_BMI2) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BMI2) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_GPR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_GPR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_PEXT ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x70C), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_BMI2) ZYDIS_NOTMIN(ZYDIS_ISA_SET_BMI2) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BMI2) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_GPR, ZYDIS_REGKIND_GPR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_GPR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_PEXT ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x710), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_BMI2) ZYDIS_NOTMIN(ZYDIS_ISA_SET_BMI2) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BMI2) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_GPR, ZYDIS_REGKIND_GPR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_GPR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_PEXT ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x714), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_BMI2) ZYDIS_NOTMIN(ZYDIS_ISA_SET_BMI2) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BMI2) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_GPR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_GPR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_PEXT ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x718), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_BMI2) ZYDIS_NOTMIN(ZYDIS_ISA_SET_BMI2) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BMI2) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_GPR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_GPR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_PEXT ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x70C), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_BMI2) ZYDIS_NOTMIN(ZYDIS_ISA_SET_BMI2) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BMI2) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_GPR, ZYDIS_REGKIND_GPR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_GPR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_PEXT ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x714), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_BMI2) ZYDIS_NOTMIN(ZYDIS_ISA_SET_BMI2) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BMI2) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_GPR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_GPR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_POPCNT ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x112B), 0, 0 ZYDIS_NOTMIN(0x41), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_KNCSCALAR) ZYDIS_NOTMIN(ZYDIS_ISA_SET_KNCV) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_KNC) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_GPR, ZYDIS_REGKIND_GPR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_POPCNT ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x112E), 0, 0 ZYDIS_NOTMIN(0x41), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_KNCSCALAR) ZYDIS_NOTMIN(ZYDIS_ISA_SET_KNCV) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_KNC) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_GPR, ZYDIS_REGKIND_GPR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_RORX ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1131), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_BMI2) ZYDIS_NOTMIN(ZYDIS_ISA_SET_BMI2) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BMI2) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_GPR, ZYDIS_REGKIND_GPR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_RORX ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1134), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_BMI2) ZYDIS_NOTMIN(ZYDIS_ISA_SET_BMI2) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BMI2) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_GPR, ZYDIS_REGKIND_GPR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_RORX ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1137), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_BMI2) ZYDIS_NOTMIN(ZYDIS_ISA_SET_BMI2) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BMI2) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_GPR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_RORX ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x113A), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_BMI2) ZYDIS_NOTMIN(ZYDIS_ISA_SET_BMI2) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BMI2) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_GPR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_RORX ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1131), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_BMI2) ZYDIS_NOTMIN(ZYDIS_ISA_SET_BMI2) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BMI2) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_GPR, ZYDIS_REGKIND_GPR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_RORX ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1137), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_BMI2) ZYDIS_NOTMIN(ZYDIS_ISA_SET_BMI2) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BMI2) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_GPR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_SARX ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x724), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_BMI2) ZYDIS_NOTMIN(ZYDIS_ISA_SET_BMI2) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BMI2) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_GPR, ZYDIS_REGKIND_GPR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_GPR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_SARX ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x728), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_BMI2) ZYDIS_NOTMIN(ZYDIS_ISA_SET_BMI2) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BMI2) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_GPR, ZYDIS_REGKIND_GPR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_GPR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_SARX ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x72C), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_BMI2) ZYDIS_NOTMIN(ZYDIS_ISA_SET_BMI2) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BMI2) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_GPR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_GPR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_SARX ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x730), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_BMI2) ZYDIS_NOTMIN(ZYDIS_ISA_SET_BMI2) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BMI2) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_GPR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_GPR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_SARX ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x724), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_BMI2) ZYDIS_NOTMIN(ZYDIS_ISA_SET_BMI2) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BMI2) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_GPR, ZYDIS_REGKIND_GPR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_GPR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_SARX ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x72C), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_BMI2) ZYDIS_NOTMIN(ZYDIS_ISA_SET_BMI2) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BMI2) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_GPR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_GPR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_SHLX ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x724), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_BMI2) ZYDIS_NOTMIN(ZYDIS_ISA_SET_BMI2) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BMI2) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_GPR, ZYDIS_REGKIND_GPR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_GPR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_SHLX ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x728), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_BMI2) ZYDIS_NOTMIN(ZYDIS_ISA_SET_BMI2) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BMI2) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_GPR, ZYDIS_REGKIND_GPR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_GPR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_SHLX ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x72C), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_BMI2) ZYDIS_NOTMIN(ZYDIS_ISA_SET_BMI2) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BMI2) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_GPR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_GPR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_SHLX ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x730), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_BMI2) ZYDIS_NOTMIN(ZYDIS_ISA_SET_BMI2) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BMI2) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_GPR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_GPR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_SHLX ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x724), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_BMI2) ZYDIS_NOTMIN(ZYDIS_ISA_SET_BMI2) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BMI2) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_GPR, ZYDIS_REGKIND_GPR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_GPR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_SHLX ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x72C), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_BMI2) ZYDIS_NOTMIN(ZYDIS_ISA_SET_BMI2) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BMI2) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_GPR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_GPR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_SHRX ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x724), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_BMI2) ZYDIS_NOTMIN(ZYDIS_ISA_SET_BMI2) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BMI2) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_GPR, ZYDIS_REGKIND_GPR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_GPR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_SHRX ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x728), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_BMI2) ZYDIS_NOTMIN(ZYDIS_ISA_SET_BMI2) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BMI2) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_GPR, ZYDIS_REGKIND_GPR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_GPR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_SHRX ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x72C), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_BMI2) ZYDIS_NOTMIN(ZYDIS_ISA_SET_BMI2) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BMI2) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_GPR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_GPR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_SHRX ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x730), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_BMI2) ZYDIS_NOTMIN(ZYDIS_ISA_SET_BMI2) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BMI2) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_GPR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_GPR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_SHRX ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x724), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_BMI2) ZYDIS_NOTMIN(ZYDIS_ISA_SET_BMI2) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BMI2) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_GPR, ZYDIS_REGKIND_GPR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_GPR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_SHRX ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x72C), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_BMI2) ZYDIS_NOTMIN(ZYDIS_ISA_SET_BMI2) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_BMI2) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_GPR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_GPR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_SPFLT ZYDIS_NOTMIN(1) ZYDIS_NOTMIN(1) ZYDIS_NOTMIN(0x67D), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_KNCSCALAR) ZYDIS_NOTMIN(ZYDIS_ISA_SET_KNCV) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_KNC) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, ZYDIS_REGKIND_GPR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_SPFLT ZYDIS_NOTMIN(1) ZYDIS_NOTMIN(1) ZYDIS_NOTMIN(0x712), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_KNCSCALAR) ZYDIS_NOTMIN(ZYDIS_ISA_SET_KNCV) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_KNC) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, ZYDIS_REGKIND_GPR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_STTILECFG ZYDIS_NOTMIN(1) ZYDIS_NOTMIN(1) ZYDIS_NOTMIN(0x1F0A), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AMX_TILE) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AMX_TILE) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AMX_TILE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AMXE2), 0, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_TDPBF16PS ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x113D), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AMX_TILE) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AMX_BF16) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AMX_BF16) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AMXE4), ZYDIS_REGKIND_TMM, ZYDIS_REGKIND_TMM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_TMM, ZYAN_FALSE, ZYAN_FALSE, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_TDPBSSD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1140), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AMX_TILE) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AMX_INT8) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AMX_INT8) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AMXE4), ZYDIS_REGKIND_TMM, ZYDIS_REGKIND_TMM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_TMM, ZYAN_FALSE, ZYAN_FALSE, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_TDPBSUD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1140), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AMX_TILE) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AMX_INT8) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AMX_INT8) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AMXE4), ZYDIS_REGKIND_TMM, ZYDIS_REGKIND_TMM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_TMM, ZYAN_FALSE, ZYAN_FALSE, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_TDPBUSD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1140), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AMX_TILE) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AMX_INT8) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AMX_INT8) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AMXE4), ZYDIS_REGKIND_TMM, ZYDIS_REGKIND_TMM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_TMM, ZYAN_FALSE, ZYAN_FALSE, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_TDPBUUD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1143), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AMX_TILE) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AMX_INT8) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AMX_INT8) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AMXE4), ZYDIS_REGKIND_TMM, ZYDIS_REGKIND_TMM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_TMM, ZYAN_FALSE, ZYAN_FALSE, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_TDPFP16PS ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1146), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AMX_TILE) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AMX_FP16) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AMX_FP16) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AMXE4), ZYDIS_REGKIND_TMM, ZYDIS_REGKIND_TMM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_TMM, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_TILELOADD ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1DA5), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AMX_TILE) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AMX_TILE) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AMX_TILE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AMXE3), ZYDIS_REGKIND_TMM, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_TILELOADDT1 ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1DA5), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AMX_TILE) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AMX_TILE) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AMX_TILE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AMXE3), ZYDIS_REGKIND_TMM, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_TILERELEASE ZYDIS_NOTMIN(0) ZYDIS_NOTMIN(0) ZYDIS_NOTMIN(0x0), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AMX_TILE) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AMX_TILE) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AMX_TILE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AMXE6), 0, 0 ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_TILESTORED ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1DA7), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AMX_TILE) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AMX_TILE) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AMX_TILE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AMXE3), ZYDIS_REGKIND_TMM, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_TILEZERO ZYDIS_NOTMIN(1) ZYDIS_NOTMIN(1) ZYDIS_NOTMIN(0x1DA5), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AMX_TILE) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AMX_TILE) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AMX_TILE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AMXE5), ZYDIS_REGKIND_TMM, 0 ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_TZCNT ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x112B), 0, 0 ZYDIS_NOTMIN(0x37), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_KNCSCALAR) ZYDIS_NOTMIN(ZYDIS_ISA_SET_KNCV) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_KNC) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_GPR, ZYDIS_REGKIND_GPR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_TZCNT ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x112E), 0, 0 ZYDIS_NOTMIN(0x37), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_KNCSCALAR) ZYDIS_NOTMIN(ZYDIS_ISA_SET_KNCV) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_KNC) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_GPR, ZYDIS_REGKIND_GPR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_TZCNTI ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1149), 0, 0 ZYDIS_NOTMIN(0x37), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_KNCSCALAR) ZYDIS_NOTMIN(ZYDIS_ISA_SET_KNCV) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_KNC) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_GPR, ZYDIS_REGKIND_GPR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_TZCNTI ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x114C), 0, 0 ZYDIS_NOTMIN(0x37), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_KNCSCALAR) ZYDIS_NOTMIN(ZYDIS_ISA_SET_KNCV) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_KNC) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_GPR, ZYDIS_REGKIND_GPR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VADDPD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x153), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VADDPD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x15D), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VADDPD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x167), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX2), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VADDPD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x171), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX2), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VADDPS ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x17B), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VADDPS ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x185), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VADDPS ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x18F), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX2), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VADDPS ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x199), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX2), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VADDSD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x7A4), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX3), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VADDSD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x7A8), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX3), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VADDSS ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x7AC), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX3), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VADDSS ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x7B0), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX3), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VADDSUBPD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x153), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VADDSUBPD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x15D), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VADDSUBPD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x167), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX2), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VADDSUBPD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x171), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX2), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VADDSUBPS ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x17B), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VADDSUBPS ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x185), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VADDSUBPS ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x18F), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX2), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VADDSUBPS ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x199), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX2), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VAESDEC ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x6C4), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AES) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVXAES) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVXAES) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VAESDEC ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x840), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VAES) ZYDIS_NOTMIN(ZYDIS_ISA_SET_VAES) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_VAES) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VAESDEC ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x6C8), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AES) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVXAES) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVXAES) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VAESDEC ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x844), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VAES) ZYDIS_NOTMIN(ZYDIS_ISA_SET_VAES) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_VAES) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VAESDECLAST ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x6C4), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AES) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVXAES) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVXAES) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VAESDECLAST ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x840), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VAES) ZYDIS_NOTMIN(ZYDIS_ISA_SET_VAES) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_VAES) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VAESDECLAST ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x6C8), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AES) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVXAES) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVXAES) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VAESDECLAST ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x844), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VAES) ZYDIS_NOTMIN(ZYDIS_ISA_SET_VAES) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_VAES) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VAESENC ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x6C4), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AES) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVXAES) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVXAES) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VAESENC ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x840), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VAES) ZYDIS_NOTMIN(ZYDIS_ISA_SET_VAES) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_VAES) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VAESENC ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x6C8), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AES) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVXAES) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVXAES) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VAESENC ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x844), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VAES) ZYDIS_NOTMIN(ZYDIS_ISA_SET_VAES) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_VAES) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VAESENCLAST ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x6C4), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AES) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVXAES) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVXAES) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VAESENCLAST ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x840), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VAES) ZYDIS_NOTMIN(ZYDIS_ISA_SET_VAES) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_VAES) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VAESENCLAST ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x6C8), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AES) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVXAES) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVXAES) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VAESENCLAST ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x844), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VAES) ZYDIS_NOTMIN(ZYDIS_ISA_SET_VAES) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_VAES) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VAESIMC ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xDAD), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AES) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVXAES) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVXAES) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VAESIMC ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xDB0), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AES) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVXAES) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVXAES) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VAESKEYGENASSIST ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0xFC3), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AES) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVXAES) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVXAES) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VAESKEYGENASSIST ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0xFC6), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AES) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVXAES) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVXAES) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VANDNPD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x6CC), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_LOGICAL_FP) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VANDNPD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x114F), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_LOGICAL_FP) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VANDNPD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x6D0), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_LOGICAL_FP) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VANDNPD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1152), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_LOGICAL_FP) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VANDNPS ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x6AC), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_LOGICAL_FP) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VANDNPS ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1155), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_LOGICAL_FP) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VANDNPS ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x6B0), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_LOGICAL_FP) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VANDNPS ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1158), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_LOGICAL_FP) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VANDPD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x6CC), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_LOGICAL_FP) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VANDPD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x114F), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_LOGICAL_FP) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VANDPD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x6D0), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_LOGICAL_FP) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VANDPD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1152), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_LOGICAL_FP) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VANDPS ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x6AC), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_LOGICAL_FP) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VANDPS ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1155), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_LOGICAL_FP) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VANDPS ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x6B0), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_LOGICAL_FP) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VANDPS ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1158), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_LOGICAL_FP) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VBCSTNEBF162PS ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1DA9), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_BROADCAST) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX_NE_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX_NE_CONVERT) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX5), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_1_TO_4) },
    { ZYDIS_MNEMONIC_VBCSTNEBF162PS ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1DAB), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_BROADCAST) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX_NE_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX_NE_CONVERT) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX5), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_1_TO_8) },
    { ZYDIS_MNEMONIC_VBCSTNESH2PS ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1DAD), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_BROADCAST) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX_NE_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX_NE_CONVERT) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX5), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_1_TO_4) },
    { ZYDIS_MNEMONIC_VBCSTNESH2PS ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1DAF), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_BROADCAST) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX_NE_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX_NE_CONVERT) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX5), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_1_TO_8) },
    { ZYDIS_MNEMONIC_VBLENDPD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x744), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VBLENDPD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x748), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VBLENDPD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x74C), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VBLENDPD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x750), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VBLENDPS ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x754), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VBLENDPS ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x758), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VBLENDPS ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x75C), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VBLENDPS ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x760), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VBLENDVPD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x764), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VBLENDVPD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x768), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VBLENDVPD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x76C), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VBLENDVPD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x770), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VBLENDVPS ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x774), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VBLENDVPS ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x778), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VBLENDVPS ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x77C), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VBLENDVPS ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x780), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VBROADCASTF128 ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1DB1), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_BROADCAST) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX6), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_2_TO_4) },
    { ZYDIS_MNEMONIC_VBROADCASTI128 ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1DB3), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_BROADCAST) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX2) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX2) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX6), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_2_TO_4) },
    { ZYDIS_MNEMONIC_VBROADCASTSD ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1DB5), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_BROADCAST) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX2) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX2) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX6), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_1_TO_4) },
    { ZYDIS_MNEMONIC_VBROADCASTSD ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1DB7), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_BROADCAST) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX6), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_1_TO_4) },
    { ZYDIS_MNEMONIC_VBROADCASTSS ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x105C), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_BROADCAST) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX2) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX2) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX6), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_1_TO_4) },
    { ZYDIS_MNEMONIC_VBROADCASTSS ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1DB9), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_BROADCAST) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX2) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX2) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX6), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_1_TO_8) },
    { ZYDIS_MNEMONIC_VBROADCASTSS ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1C4B), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_BROADCAST) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX6), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_1_TO_4) },
    { ZYDIS_MNEMONIC_VBROADCASTSS ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1DBB), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_BROADCAST) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX6), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_1_TO_8) },
    { ZYDIS_MNEMONIC_VCMPPD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x784), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCMPPD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x788), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCMPPD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x78C), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX2), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCMPPD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x790), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX2), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCMPPS ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x794), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCMPPS ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x798), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCMPPS ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x79C), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX2), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCMPPS ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x7A0), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX2), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCMPSD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x7A4), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX3), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCMPSD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x7A8), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX3), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCMPSS ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x7AC), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX3), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCMPSS ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x7B0), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX3), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCOMISD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xE31), 0, 0 ZYDIS_NOTMIN(0x33), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX3), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCOMISD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xE34), 0, 0 ZYDIS_NOTMIN(0x33), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX3), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCOMISS ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xE37), 0, 0 ZYDIS_NOTMIN(0x33), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX3), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCOMISS ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xE3A), 0, 0 ZYDIS_NOTMIN(0x33), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX3), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTDQ2PD ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1B19), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX5), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTDQ2PD ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1DBD), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX5), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTDQ2PD ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1B1B), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX5), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTDQ2PD ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1DBF), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX5), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTDQ2PS ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1B1D), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTDQ2PS ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1DC1), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTDQ2PS ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1B1F), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX2), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTDQ2PS ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1DC3), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX2), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTNEEBF162PS ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1DC5), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX_NE_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX_NE_CONVERT) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTNEEBF162PS ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1DC7), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX_NE_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX_NE_CONVERT) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTNEEPH2PS ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1DC9), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX_NE_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX_NE_CONVERT) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTNEEPH2PS ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1DCB), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX_NE_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX_NE_CONVERT) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTNEOBF162PS ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1DC5), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX_NE_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX_NE_CONVERT) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTNEOBF162PS ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1DC7), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX_NE_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX_NE_CONVERT) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTNEOPH2PS ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1DC9), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX_NE_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX_NE_CONVERT) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTNEOPH2PS ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1DCB), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX_NE_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX_NE_CONVERT) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTNEPS2BF16 ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1DCD), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX_NE_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX_NE_CONVERT) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTNEPS2BF16 ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1DCF), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX_NE_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX_NE_CONVERT) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTNEPS2BF16 ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1DD1), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX_NE_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX_NE_CONVERT) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTNEPS2BF16 ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1DD3), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX_NE_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX_NE_CONVERT) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTPD2DQ ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1B21), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTPD2DQ ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1DD5), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTPD2DQ ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1B23), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX2), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTPD2DQ ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1DD7), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX2), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTPD2PS ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1B29), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTPD2PS ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1DD9), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTPD2PS ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1B2B), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX2), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTPD2PS ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1DDB), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX2), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTPH2PS ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1DDD), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_F16C) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_F16C) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX11), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTPH2PS ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1DDF), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_F16C) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_F16C) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX11), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTPH2PS ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1DE1), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_F16C) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_F16C) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX11), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTPH2PS ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1DE3), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_F16C) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_F16C) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX11), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTPS2DQ ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1B33), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTPS2DQ ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1DE5), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTPS2DQ ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1B35), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX2), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTPS2DQ ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1DE7), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX2), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTPS2PD ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1B37), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX3), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTPS2PD ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1DE9), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX3), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTPS2PD ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1B39), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX3), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTPS2PD ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1DEB), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX3), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTPS2PH ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x115B), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_F16C) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_F16C) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX11), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTPS2PH ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x115E), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_F16C) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_F16C) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX11), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTPS2PH ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1161), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_F16C) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_F16C) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX11), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTPS2PH ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1164), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_F16C) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_F16C) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX11), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTSD2SI ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1B3F), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX3), ZYDIS_REGKIND_GPR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTSD2SI ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1B41), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX3), ZYDIS_REGKIND_GPR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTSD2SI ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1B43), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX3), ZYDIS_REGKIND_GPR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTSD2SI ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1B45), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX3), ZYDIS_REGKIND_GPR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTSD2SI ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1B3F), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX3), ZYDIS_REGKIND_GPR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTSD2SI ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1B43), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX3), ZYDIS_REGKIND_GPR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTSD2SS ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1167), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX3), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTSD2SS ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x116A), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX3), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTSI2SD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x116D), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX3), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_GPR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTSI2SD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1170), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX3), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_GPR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTSI2SD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1173), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX3), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTSI2SD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1176), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX3), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTSI2SD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x116D), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX3), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_GPR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTSI2SD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1173), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX3), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTSI2SS ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1179), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX3), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_GPR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTSI2SS ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x117C), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX3), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_GPR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTSI2SS ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x117F), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX3), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTSI2SS ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1182), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX3), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTSI2SS ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1179), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX3), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_GPR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTSI2SS ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x117F), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX3), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTSS2SD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1185), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX3), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTSS2SD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1188), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX3), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTSS2SI ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1B5F), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX3), ZYDIS_REGKIND_GPR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTSS2SI ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1B61), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX3), ZYDIS_REGKIND_GPR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTSS2SI ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1B63), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX3), ZYDIS_REGKIND_GPR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTSS2SI ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1B65), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX3), ZYDIS_REGKIND_GPR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTSS2SI ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1B5F), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX3), ZYDIS_REGKIND_GPR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTSS2SI ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1B63), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX3), ZYDIS_REGKIND_GPR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTTPD2DQ ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1B21), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTTPD2DQ ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1DD5), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTTPD2DQ ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1B23), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX2), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTTPD2DQ ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1DD7), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX2), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTTPS2DQ ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1B33), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTTPS2DQ ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1DE5), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTTPS2DQ ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1B35), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX2), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTTPS2DQ ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1DE7), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX2), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTTSD2SI ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1B3F), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX3), ZYDIS_REGKIND_GPR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTTSD2SI ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1B41), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX3), ZYDIS_REGKIND_GPR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTTSD2SI ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1B43), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX3), ZYDIS_REGKIND_GPR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTTSD2SI ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1B45), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX3), ZYDIS_REGKIND_GPR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTTSD2SI ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1B3F), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX3), ZYDIS_REGKIND_GPR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTTSD2SI ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1B43), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX3), ZYDIS_REGKIND_GPR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTTSS2SI ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1B5F), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX3), ZYDIS_REGKIND_GPR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTTSS2SI ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1B61), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX3), ZYDIS_REGKIND_GPR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTTSS2SI ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1B63), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX3), ZYDIS_REGKIND_GPR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTTSS2SI ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1B65), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX3), ZYDIS_REGKIND_GPR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTTSS2SI ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1B5F), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX3), ZYDIS_REGKIND_GPR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTTSS2SI ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1B63), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX3), ZYDIS_REGKIND_GPR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VDIVPD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x153), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VDIVPD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x15D), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VDIVPD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x167), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX2), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VDIVPD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x171), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX2), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VDIVPS ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x17B), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VDIVPS ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x185), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VDIVPS ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x18F), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX2), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VDIVPS ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x199), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX2), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VDIVSD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x7A4), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX3), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VDIVSD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x7A8), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX3), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VDIVSS ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x7AC), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX3), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VDIVSS ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x7B0), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX3), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VDPPD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x744), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VDPPD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x74C), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX2), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VDPPS ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x754), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VDPPS ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x758), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VDPPS ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x75C), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX2), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VDPPS ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x760), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX2), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VEXTRACTF128 ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x118B), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX6), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VEXTRACTF128 ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x118E), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX6), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VEXTRACTI128 ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1191), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX2) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX2) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX2) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX6), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VEXTRACTI128 ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1194), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX2) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX2) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX2) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX6), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VEXTRACTPS ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1197), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX5), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_GPR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VEXTRACTPS ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x119A), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX5), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFMADD132PD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x119D), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VFMA) ZYDIS_NOTMIN(ZYDIS_ISA_SET_FMA) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_FMA) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFMADD132PD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x11A0), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VFMA) ZYDIS_NOTMIN(ZYDIS_ISA_SET_FMA) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_FMA) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFMADD132PD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x11A3), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VFMA) ZYDIS_NOTMIN(ZYDIS_ISA_SET_FMA) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_FMA) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX2), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFMADD132PD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x11A6), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VFMA) ZYDIS_NOTMIN(ZYDIS_ISA_SET_FMA) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_FMA) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX2), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFMADD132PS ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x11A9), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VFMA) ZYDIS_NOTMIN(ZYDIS_ISA_SET_FMA) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_FMA) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFMADD132PS ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x11AC), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VFMA) ZYDIS_NOTMIN(ZYDIS_ISA_SET_FMA) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_FMA) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFMADD132PS ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x11AF), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VFMA) ZYDIS_NOTMIN(ZYDIS_ISA_SET_FMA) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_FMA) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX2), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFMADD132PS ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x11B2), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VFMA) ZYDIS_NOTMIN(ZYDIS_ISA_SET_FMA) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_FMA) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX2), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFMADD132SD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x11B5), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VFMA) ZYDIS_NOTMIN(ZYDIS_ISA_SET_FMA) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_FMA) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX3), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFMADD132SD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x11B8), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VFMA) ZYDIS_NOTMIN(ZYDIS_ISA_SET_FMA) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_FMA) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX3), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFMADD132SS ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x11BB), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VFMA) ZYDIS_NOTMIN(ZYDIS_ISA_SET_FMA) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_FMA) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX3), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFMADD132SS ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x11BE), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VFMA) ZYDIS_NOTMIN(ZYDIS_ISA_SET_FMA) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_FMA) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX3), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFMADD213PD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x119D), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VFMA) ZYDIS_NOTMIN(ZYDIS_ISA_SET_FMA) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_FMA) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFMADD213PD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x11A0), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VFMA) ZYDIS_NOTMIN(ZYDIS_ISA_SET_FMA) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_FMA) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFMADD213PD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x11A3), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VFMA) ZYDIS_NOTMIN(ZYDIS_ISA_SET_FMA) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_FMA) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX2), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFMADD213PD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x11A6), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VFMA) ZYDIS_NOTMIN(ZYDIS_ISA_SET_FMA) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_FMA) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX2), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFMADD213PS ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x11A9), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VFMA) ZYDIS_NOTMIN(ZYDIS_ISA_SET_FMA) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_FMA) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFMADD213PS ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x11AC), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VFMA) ZYDIS_NOTMIN(ZYDIS_ISA_SET_FMA) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_FMA) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFMADD213PS ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x11AF), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VFMA) ZYDIS_NOTMIN(ZYDIS_ISA_SET_FMA) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_FMA) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX2), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFMADD213PS ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x11B2), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VFMA) ZYDIS_NOTMIN(ZYDIS_ISA_SET_FMA) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_FMA) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX2), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFMADD213SD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x11B5), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VFMA) ZYDIS_NOTMIN(ZYDIS_ISA_SET_FMA) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_FMA) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX3), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFMADD213SD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x11B8), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VFMA) ZYDIS_NOTMIN(ZYDIS_ISA_SET_FMA) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_FMA) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX3), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFMADD213SS ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x11BB), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VFMA) ZYDIS_NOTMIN(ZYDIS_ISA_SET_FMA) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_FMA) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX3), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFMADD213SS ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x11BE), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VFMA) ZYDIS_NOTMIN(ZYDIS_ISA_SET_FMA) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_FMA) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX3), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFMADD231PD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x119D), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VFMA) ZYDIS_NOTMIN(ZYDIS_ISA_SET_FMA) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_FMA) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFMADD231PD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x11A0), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VFMA) ZYDIS_NOTMIN(ZYDIS_ISA_SET_FMA) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_FMA) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFMADD231PD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x11A3), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VFMA) ZYDIS_NOTMIN(ZYDIS_ISA_SET_FMA) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_FMA) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX2), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFMADD231PD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x11A6), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VFMA) ZYDIS_NOTMIN(ZYDIS_ISA_SET_FMA) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_FMA) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX2), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFMADD231PS ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x11A9), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VFMA) ZYDIS_NOTMIN(ZYDIS_ISA_SET_FMA) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_FMA) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFMADD231PS ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x11AC), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VFMA) ZYDIS_NOTMIN(ZYDIS_ISA_SET_FMA) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_FMA) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFMADD231PS ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x11AF), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VFMA) ZYDIS_NOTMIN(ZYDIS_ISA_SET_FMA) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_FMA) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX2), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFMADD231PS ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x11B2), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VFMA) ZYDIS_NOTMIN(ZYDIS_ISA_SET_FMA) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_FMA) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX2), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFMADD231SD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x11B5), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VFMA) ZYDIS_NOTMIN(ZYDIS_ISA_SET_FMA) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_FMA) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX3), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFMADD231SD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x11B8), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VFMA) ZYDIS_NOTMIN(ZYDIS_ISA_SET_FMA) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_FMA) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX3), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFMADD231SS ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x11BB), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VFMA) ZYDIS_NOTMIN(ZYDIS_ISA_SET_FMA) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_FMA) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX3), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFMADD231SS ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x11BE), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VFMA) ZYDIS_NOTMIN(ZYDIS_ISA_SET_FMA) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_FMA) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX3), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFMADDPD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x153), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_FMA4) ZYDIS_NOTMIN(ZYDIS_ISA_SET_FMA4) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_FMA4) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFMADDPD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x158), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_FMA4) ZYDIS_NOTMIN(ZYDIS_ISA_SET_FMA4) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_FMA4) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFMADDPD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x15D), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_FMA4) ZYDIS_NOTMIN(ZYDIS_ISA_SET_FMA4) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_FMA4) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFMADDPD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x162), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_FMA4) ZYDIS_NOTMIN(ZYDIS_ISA_SET_FMA4) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_FMA4) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFMADDPD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x167), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_FMA4) ZYDIS_NOTMIN(ZYDIS_ISA_SET_FMA4) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_FMA4) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFMADDPD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x16C), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_FMA4) ZYDIS_NOTMIN(ZYDIS_ISA_SET_FMA4) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_FMA4) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFMADDPD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x171), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_FMA4) ZYDIS_NOTMIN(ZYDIS_ISA_SET_FMA4) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_FMA4) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFMADDPD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x176), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_FMA4) ZYDIS_NOTMIN(ZYDIS_ISA_SET_FMA4) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_FMA4) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFMADDPS ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x17B), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_FMA4) ZYDIS_NOTMIN(ZYDIS_ISA_SET_FMA4) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_FMA4) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFMADDPS ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x180), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_FMA4) ZYDIS_NOTMIN(ZYDIS_ISA_SET_FMA4) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_FMA4) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFMADDPS ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x185), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_FMA4) ZYDIS_NOTMIN(ZYDIS_ISA_SET_FMA4) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_FMA4) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFMADDPS ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x18A), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_FMA4) ZYDIS_NOTMIN(ZYDIS_ISA_SET_FMA4) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_FMA4) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFMADDPS ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x18F), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_FMA4) ZYDIS_NOTMIN(ZYDIS_ISA_SET_FMA4) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_FMA4) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFMADDPS ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x194), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_FMA4) ZYDIS_NOTMIN(ZYDIS_ISA_SET_FMA4) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_FMA4) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFMADDPS ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x199), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_FMA4) ZYDIS_NOTMIN(ZYDIS_ISA_SET_FMA4) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_FMA4) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFMADDPS ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x19E), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_FMA4) ZYDIS_NOTMIN(ZYDIS_ISA_SET_FMA4) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_FMA4) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFMADDSD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x7B4), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_FMA4) ZYDIS_NOTMIN(ZYDIS_ISA_SET_FMA4) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_FMA4) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFMADDSD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x7B8), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_FMA4) ZYDIS_NOTMIN(ZYDIS_ISA_SET_FMA4) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_FMA4) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFMADDSD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x7BC), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_FMA4) ZYDIS_NOTMIN(ZYDIS_ISA_SET_FMA4) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_FMA4) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFMADDSD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x7C0), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_FMA4) ZYDIS_NOTMIN(ZYDIS_ISA_SET_FMA4) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_FMA4) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFMADDSS ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x7C4), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_FMA4) ZYDIS_NOTMIN(ZYDIS_ISA_SET_FMA4) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_FMA4) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFMADDSS ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x7C8), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_FMA4) ZYDIS_NOTMIN(ZYDIS_ISA_SET_FMA4) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_FMA4) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFMADDSS ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x7CC), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_FMA4) ZYDIS_NOTMIN(ZYDIS_ISA_SET_FMA4) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_FMA4) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFMADDSS ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x7D0), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_FMA4) ZYDIS_NOTMIN(ZYDIS_ISA_SET_FMA4) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_FMA4) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFMADDSUB132PD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x119D), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VFMA) ZYDIS_NOTMIN(ZYDIS_ISA_SET_FMA) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_FMA) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFMADDSUB132PD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x11A0), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VFMA) ZYDIS_NOTMIN(ZYDIS_ISA_SET_FMA) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_FMA) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFMADDSUB132PD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x11A3), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VFMA) ZYDIS_NOTMIN(ZYDIS_ISA_SET_FMA) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_FMA) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX2), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFMADDSUB132PD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x11A6), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VFMA) ZYDIS_NOTMIN(ZYDIS_ISA_SET_FMA) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_FMA) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX2), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFMADDSUB132PS ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x11A9), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VFMA) ZYDIS_NOTMIN(ZYDIS_ISA_SET_FMA) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_FMA) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFMADDSUB132PS ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x11AC), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VFMA) ZYDIS_NOTMIN(ZYDIS_ISA_SET_FMA) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_FMA) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFMADDSUB132PS ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x11AF), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VFMA) ZYDIS_NOTMIN(ZYDIS_ISA_SET_FMA) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_FMA) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX2), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFMADDSUB132PS ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x11B2), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VFMA) ZYDIS_NOTMIN(ZYDIS_ISA_SET_FMA) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_FMA) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX2), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFMADDSUB213PD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x119D), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VFMA) ZYDIS_NOTMIN(ZYDIS_ISA_SET_FMA) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_FMA) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFMADDSUB213PD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x11A0), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VFMA) ZYDIS_NOTMIN(ZYDIS_ISA_SET_FMA) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_FMA) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFMADDSUB213PD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x11A3), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VFMA) ZYDIS_NOTMIN(ZYDIS_ISA_SET_FMA) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_FMA) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX2), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFMADDSUB213PD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x11A6), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VFMA) ZYDIS_NOTMIN(ZYDIS_ISA_SET_FMA) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_FMA) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX2), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFMADDSUB213PS ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x11A9), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VFMA) ZYDIS_NOTMIN(ZYDIS_ISA_SET_FMA) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_FMA) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFMADDSUB213PS ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x11AC), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VFMA) ZYDIS_NOTMIN(ZYDIS_ISA_SET_FMA) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_FMA) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFMADDSUB213PS ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x11AF), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VFMA) ZYDIS_NOTMIN(ZYDIS_ISA_SET_FMA) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_FMA) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX2), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFMADDSUB213PS ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x11B2), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VFMA) ZYDIS_NOTMIN(ZYDIS_ISA_SET_FMA) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_FMA) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX2), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFMADDSUB231PD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x119D), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VFMA) ZYDIS_NOTMIN(ZYDIS_ISA_SET_FMA) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_FMA) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFMADDSUB231PD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x11A0), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VFMA) ZYDIS_NOTMIN(ZYDIS_ISA_SET_FMA) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_FMA) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFMADDSUB231PD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x11A3), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VFMA) ZYDIS_NOTMIN(ZYDIS_ISA_SET_FMA) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_FMA) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX2), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFMADDSUB231PD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x11A6), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VFMA) ZYDIS_NOTMIN(ZYDIS_ISA_SET_FMA) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_FMA) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX2), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFMADDSUB231PS ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x11A9), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VFMA) ZYDIS_NOTMIN(ZYDIS_ISA_SET_FMA) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_FMA) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFMADDSUB231PS ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x11AC), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VFMA) ZYDIS_NOTMIN(ZYDIS_ISA_SET_FMA) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_FMA) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFMADDSUB231PS ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x11AF), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VFMA) ZYDIS_NOTMIN(ZYDIS_ISA_SET_FMA) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_FMA) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX2), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFMADDSUB231PS ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x11B2), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VFMA) ZYDIS_NOTMIN(ZYDIS_ISA_SET_FMA) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_FMA) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX2), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFMADDSUBPD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x153), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_FMA4) ZYDIS_NOTMIN(ZYDIS_ISA_SET_FMA4) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_FMA4) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFMADDSUBPD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x158), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_FMA4) ZYDIS_NOTMIN(ZYDIS_ISA_SET_FMA4) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_FMA4) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFMADDSUBPD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x15D), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_FMA4) ZYDIS_NOTMIN(ZYDIS_ISA_SET_FMA4) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_FMA4) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFMADDSUBPD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x162), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_FMA4) ZYDIS_NOTMIN(ZYDIS_ISA_SET_FMA4) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_FMA4) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFMADDSUBPD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x167), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_FMA4) ZYDIS_NOTMIN(ZYDIS_ISA_SET_FMA4) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_FMA4) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFMADDSUBPD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x16C), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_FMA4) ZYDIS_NOTMIN(ZYDIS_ISA_SET_FMA4) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_FMA4) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFMADDSUBPD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x171), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_FMA4) ZYDIS_NOTMIN(ZYDIS_ISA_SET_FMA4) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_FMA4) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFMADDSUBPD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x176), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_FMA4) ZYDIS_NOTMIN(ZYDIS_ISA_SET_FMA4) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_FMA4) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFMADDSUBPS ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x17B), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_FMA4) ZYDIS_NOTMIN(ZYDIS_ISA_SET_FMA4) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_FMA4) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFMADDSUBPS ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x180), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_FMA4) ZYDIS_NOTMIN(ZYDIS_ISA_SET_FMA4) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_FMA4) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFMADDSUBPS ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x185), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_FMA4) ZYDIS_NOTMIN(ZYDIS_ISA_SET_FMA4) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_FMA4) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFMADDSUBPS ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x18A), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_FMA4) ZYDIS_NOTMIN(ZYDIS_ISA_SET_FMA4) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_FMA4) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFMADDSUBPS ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x18F), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_FMA4) ZYDIS_NOTMIN(ZYDIS_ISA_SET_FMA4) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_FMA4) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFMADDSUBPS ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x194), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_FMA4) ZYDIS_NOTMIN(ZYDIS_ISA_SET_FMA4) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_FMA4) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFMADDSUBPS ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x199), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_FMA4) ZYDIS_NOTMIN(ZYDIS_ISA_SET_FMA4) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_FMA4) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFMADDSUBPS ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x19E), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_FMA4) ZYDIS_NOTMIN(ZYDIS_ISA_SET_FMA4) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_FMA4) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFMSUB132PD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x119D), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VFMA) ZYDIS_NOTMIN(ZYDIS_ISA_SET_FMA) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_FMA) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFMSUB132PD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x11A0), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VFMA) ZYDIS_NOTMIN(ZYDIS_ISA_SET_FMA) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_FMA) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFMSUB132PD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x11A3), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VFMA) ZYDIS_NOTMIN(ZYDIS_ISA_SET_FMA) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_FMA) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX2), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFMSUB132PD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x11A6), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VFMA) ZYDIS_NOTMIN(ZYDIS_ISA_SET_FMA) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_FMA) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX2), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFMSUB132PS ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x11A9), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VFMA) ZYDIS_NOTMIN(ZYDIS_ISA_SET_FMA) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_FMA) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFMSUB132PS ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x11AC), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VFMA) ZYDIS_NOTMIN(ZYDIS_ISA_SET_FMA) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_FMA) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFMSUB132PS ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x11AF), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VFMA) ZYDIS_NOTMIN(ZYDIS_ISA_SET_FMA) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_FMA) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX2), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFMSUB132PS ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x11B2), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VFMA) ZYDIS_NOTMIN(ZYDIS_ISA_SET_FMA) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_FMA) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX2), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFMSUB132SD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x11B5), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VFMA) ZYDIS_NOTMIN(ZYDIS_ISA_SET_FMA) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_FMA) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX3), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFMSUB132SD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x11B8), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VFMA) ZYDIS_NOTMIN(ZYDIS_ISA_SET_FMA) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_FMA) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX3), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFMSUB132SS ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x11BB), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VFMA) ZYDIS_NOTMIN(ZYDIS_ISA_SET_FMA) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_FMA) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX3), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFMSUB132SS ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x11BE), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VFMA) ZYDIS_NOTMIN(ZYDIS_ISA_SET_FMA) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_FMA) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX3), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFMSUB213PD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x119D), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VFMA) ZYDIS_NOTMIN(ZYDIS_ISA_SET_FMA) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_FMA) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFMSUB213PD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x11A0), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VFMA) ZYDIS_NOTMIN(ZYDIS_ISA_SET_FMA) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_FMA) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFMSUB213PD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x11A3), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VFMA) ZYDIS_NOTMIN(ZYDIS_ISA_SET_FMA) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_FMA) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX2), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFMSUB213PD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x11A6), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VFMA) ZYDIS_NOTMIN(ZYDIS_ISA_SET_FMA) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_FMA) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX2), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFMSUB213PS ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x11A9), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VFMA) ZYDIS_NOTMIN(ZYDIS_ISA_SET_FMA) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_FMA) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFMSUB213PS ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x11AC), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VFMA) ZYDIS_NOTMIN(ZYDIS_ISA_SET_FMA) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_FMA) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFMSUB213PS ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x11AF), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VFMA) ZYDIS_NOTMIN(ZYDIS_ISA_SET_FMA) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_FMA) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX2), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFMSUB213PS ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x11B2), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VFMA) ZYDIS_NOTMIN(ZYDIS_ISA_SET_FMA) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_FMA) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX2), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFMSUB213SD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x11B5), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VFMA) ZYDIS_NOTMIN(ZYDIS_ISA_SET_FMA) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_FMA) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX3), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFMSUB213SD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x11B8), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VFMA) ZYDIS_NOTMIN(ZYDIS_ISA_SET_FMA) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_FMA) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX3), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFMSUB213SS ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x11BB), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VFMA) ZYDIS_NOTMIN(ZYDIS_ISA_SET_FMA) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_FMA) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX3), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFMSUB213SS ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x11BE), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VFMA) ZYDIS_NOTMIN(ZYDIS_ISA_SET_FMA) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_FMA) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX3), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFMSUB231PD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x119D), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VFMA) ZYDIS_NOTMIN(ZYDIS_ISA_SET_FMA) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_FMA) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFMSUB231PD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x11A0), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VFMA) ZYDIS_NOTMIN(ZYDIS_ISA_SET_FMA) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_FMA) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFMSUB231PD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x11A3), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VFMA) ZYDIS_NOTMIN(ZYDIS_ISA_SET_FMA) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_FMA) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX2), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFMSUB231PD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x11A6), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VFMA) ZYDIS_NOTMIN(ZYDIS_ISA_SET_FMA) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_FMA) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX2), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFMSUB231PS ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x11A9), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VFMA) ZYDIS_NOTMIN(ZYDIS_ISA_SET_FMA) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_FMA) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFMSUB231PS ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x11AC), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VFMA) ZYDIS_NOTMIN(ZYDIS_ISA_SET_FMA) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_FMA) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFMSUB231PS ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x11AF), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VFMA) ZYDIS_NOTMIN(ZYDIS_ISA_SET_FMA) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_FMA) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX2), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFMSUB231PS ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x11B2), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VFMA) ZYDIS_NOTMIN(ZYDIS_ISA_SET_FMA) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_FMA) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX2), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFMSUB231SD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x11B5), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VFMA) ZYDIS_NOTMIN(ZYDIS_ISA_SET_FMA) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_FMA) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX3), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFMSUB231SD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x11B8), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VFMA) ZYDIS_NOTMIN(ZYDIS_ISA_SET_FMA) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_FMA) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX3), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFMSUB231SS ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x11BB), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VFMA) ZYDIS_NOTMIN(ZYDIS_ISA_SET_FMA) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_FMA) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX3), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFMSUB231SS ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x11BE), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VFMA) ZYDIS_NOTMIN(ZYDIS_ISA_SET_FMA) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_FMA) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX3), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFMSUBADD132PD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x119D), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VFMA) ZYDIS_NOTMIN(ZYDIS_ISA_SET_FMA) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_FMA) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFMSUBADD132PD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x11A0), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VFMA) ZYDIS_NOTMIN(ZYDIS_ISA_SET_FMA) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_FMA) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFMSUBADD132PD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x11A3), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VFMA) ZYDIS_NOTMIN(ZYDIS_ISA_SET_FMA) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_FMA) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX2), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFMSUBADD132PD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x11A6), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VFMA) ZYDIS_NOTMIN(ZYDIS_ISA_SET_FMA) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_FMA) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX2), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFMSUBADD132PS ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x11A9), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VFMA) ZYDIS_NOTMIN(ZYDIS_ISA_SET_FMA) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_FMA) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFMSUBADD132PS ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x11AC), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VFMA) ZYDIS_NOTMIN(ZYDIS_ISA_SET_FMA) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_FMA) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFMSUBADD132PS ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x11AF), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VFMA) ZYDIS_NOTMIN(ZYDIS_ISA_SET_FMA) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_FMA) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX2), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFMSUBADD132PS ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x11B2), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VFMA) ZYDIS_NOTMIN(ZYDIS_ISA_SET_FMA) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_FMA) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX2), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFMSUBADD213PD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x119D), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VFMA) ZYDIS_NOTMIN(ZYDIS_ISA_SET_FMA) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_FMA) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFMSUBADD213PD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x11A0), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VFMA) ZYDIS_NOTMIN(ZYDIS_ISA_SET_FMA) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_FMA) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFMSUBADD213PD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x11A3), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VFMA) ZYDIS_NOTMIN(ZYDIS_ISA_SET_FMA) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_FMA) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX2), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFMSUBADD213PD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x11A6), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VFMA) ZYDIS_NOTMIN(ZYDIS_ISA_SET_FMA) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_FMA) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX2), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFMSUBADD213PS ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x11A9), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VFMA) ZYDIS_NOTMIN(ZYDIS_ISA_SET_FMA) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_FMA) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFMSUBADD213PS ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x11AC), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VFMA) ZYDIS_NOTMIN(ZYDIS_ISA_SET_FMA) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_FMA) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFMSUBADD213PS ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x11AF), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VFMA) ZYDIS_NOTMIN(ZYDIS_ISA_SET_FMA) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_FMA) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX2), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFMSUBADD213PS ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x11B2), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VFMA) ZYDIS_NOTMIN(ZYDIS_ISA_SET_FMA) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_FMA) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX2), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFMSUBADD231PD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x119D), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VFMA) ZYDIS_NOTMIN(ZYDIS_ISA_SET_FMA) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_FMA) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFMSUBADD231PD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x11A0), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VFMA) ZYDIS_NOTMIN(ZYDIS_ISA_SET_FMA) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_FMA) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFMSUBADD231PD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x11A3), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VFMA) ZYDIS_NOTMIN(ZYDIS_ISA_SET_FMA) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_FMA) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX2), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFMSUBADD231PD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x11A6), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VFMA) ZYDIS_NOTMIN(ZYDIS_ISA_SET_FMA) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_FMA) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX2), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFMSUBADD231PS ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x11A9), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VFMA) ZYDIS_NOTMIN(ZYDIS_ISA_SET_FMA) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_FMA) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFMSUBADD231PS ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x11AC), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VFMA) ZYDIS_NOTMIN(ZYDIS_ISA_SET_FMA) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_FMA) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFMSUBADD231PS ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x11AF), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VFMA) ZYDIS_NOTMIN(ZYDIS_ISA_SET_FMA) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_FMA) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX2), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFMSUBADD231PS ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x11B2), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VFMA) ZYDIS_NOTMIN(ZYDIS_ISA_SET_FMA) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_FMA) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX2), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFMSUBADDPD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x153), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_FMA4) ZYDIS_NOTMIN(ZYDIS_ISA_SET_FMA4) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_FMA4) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFMSUBADDPD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x158), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_FMA4) ZYDIS_NOTMIN(ZYDIS_ISA_SET_FMA4) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_FMA4) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFMSUBADDPD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x15D), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_FMA4) ZYDIS_NOTMIN(ZYDIS_ISA_SET_FMA4) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_FMA4) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFMSUBADDPD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x162), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_FMA4) ZYDIS_NOTMIN(ZYDIS_ISA_SET_FMA4) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_FMA4) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFMSUBADDPD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x167), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_FMA4) ZYDIS_NOTMIN(ZYDIS_ISA_SET_FMA4) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_FMA4) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFMSUBADDPD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x16C), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_FMA4) ZYDIS_NOTMIN(ZYDIS_ISA_SET_FMA4) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_FMA4) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFMSUBADDPD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x171), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_FMA4) ZYDIS_NOTMIN(ZYDIS_ISA_SET_FMA4) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_FMA4) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFMSUBADDPD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x176), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_FMA4) ZYDIS_NOTMIN(ZYDIS_ISA_SET_FMA4) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_FMA4) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFMSUBADDPS ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x17B), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_FMA4) ZYDIS_NOTMIN(ZYDIS_ISA_SET_FMA4) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_FMA4) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFMSUBADDPS ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x180), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_FMA4) ZYDIS_NOTMIN(ZYDIS_ISA_SET_FMA4) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_FMA4) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFMSUBADDPS ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x185), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_FMA4) ZYDIS_NOTMIN(ZYDIS_ISA_SET_FMA4) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_FMA4) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFMSUBADDPS ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x18A), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_FMA4) ZYDIS_NOTMIN(ZYDIS_ISA_SET_FMA4) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_FMA4) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFMSUBADDPS ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x18F), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_FMA4) ZYDIS_NOTMIN(ZYDIS_ISA_SET_FMA4) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_FMA4) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFMSUBADDPS ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x194), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_FMA4) ZYDIS_NOTMIN(ZYDIS_ISA_SET_FMA4) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_FMA4) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFMSUBADDPS ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x199), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_FMA4) ZYDIS_NOTMIN(ZYDIS_ISA_SET_FMA4) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_FMA4) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFMSUBADDPS ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x19E), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_FMA4) ZYDIS_NOTMIN(ZYDIS_ISA_SET_FMA4) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_FMA4) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFMSUBPD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x153), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_FMA4) ZYDIS_NOTMIN(ZYDIS_ISA_SET_FMA4) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_FMA4) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFMSUBPD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x158), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_FMA4) ZYDIS_NOTMIN(ZYDIS_ISA_SET_FMA4) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_FMA4) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFMSUBPD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x15D), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_FMA4) ZYDIS_NOTMIN(ZYDIS_ISA_SET_FMA4) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_FMA4) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFMSUBPD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x162), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_FMA4) ZYDIS_NOTMIN(ZYDIS_ISA_SET_FMA4) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_FMA4) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFMSUBPD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x167), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_FMA4) ZYDIS_NOTMIN(ZYDIS_ISA_SET_FMA4) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_FMA4) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFMSUBPD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x16C), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_FMA4) ZYDIS_NOTMIN(ZYDIS_ISA_SET_FMA4) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_FMA4) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFMSUBPD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x171), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_FMA4) ZYDIS_NOTMIN(ZYDIS_ISA_SET_FMA4) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_FMA4) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFMSUBPD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x176), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_FMA4) ZYDIS_NOTMIN(ZYDIS_ISA_SET_FMA4) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_FMA4) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFMSUBPS ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x17B), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_FMA4) ZYDIS_NOTMIN(ZYDIS_ISA_SET_FMA4) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_FMA4) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFMSUBPS ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x180), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_FMA4) ZYDIS_NOTMIN(ZYDIS_ISA_SET_FMA4) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_FMA4) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFMSUBPS ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x185), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_FMA4) ZYDIS_NOTMIN(ZYDIS_ISA_SET_FMA4) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_FMA4) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFMSUBPS ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x18A), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_FMA4) ZYDIS_NOTMIN(ZYDIS_ISA_SET_FMA4) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_FMA4) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFMSUBPS ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x18F), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_FMA4) ZYDIS_NOTMIN(ZYDIS_ISA_SET_FMA4) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_FMA4) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFMSUBPS ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x194), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_FMA4) ZYDIS_NOTMIN(ZYDIS_ISA_SET_FMA4) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_FMA4) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFMSUBPS ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x199), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_FMA4) ZYDIS_NOTMIN(ZYDIS_ISA_SET_FMA4) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_FMA4) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFMSUBPS ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x19E), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_FMA4) ZYDIS_NOTMIN(ZYDIS_ISA_SET_FMA4) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_FMA4) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFMSUBSD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x7B4), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_FMA4) ZYDIS_NOTMIN(ZYDIS_ISA_SET_FMA4) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_FMA4) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFMSUBSD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x7B8), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_FMA4) ZYDIS_NOTMIN(ZYDIS_ISA_SET_FMA4) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_FMA4) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFMSUBSD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x7BC), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_FMA4) ZYDIS_NOTMIN(ZYDIS_ISA_SET_FMA4) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_FMA4) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFMSUBSD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x7C0), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_FMA4) ZYDIS_NOTMIN(ZYDIS_ISA_SET_FMA4) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_FMA4) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFMSUBSS ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x7C4), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_FMA4) ZYDIS_NOTMIN(ZYDIS_ISA_SET_FMA4) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_FMA4) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFMSUBSS ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x7C8), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_FMA4) ZYDIS_NOTMIN(ZYDIS_ISA_SET_FMA4) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_FMA4) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFMSUBSS ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x7CC), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_FMA4) ZYDIS_NOTMIN(ZYDIS_ISA_SET_FMA4) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_FMA4) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFMSUBSS ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x7D0), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_FMA4) ZYDIS_NOTMIN(ZYDIS_ISA_SET_FMA4) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_FMA4) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFNMADD132PD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x119D), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VFMA) ZYDIS_NOTMIN(ZYDIS_ISA_SET_FMA) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_FMA) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFNMADD132PD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x11A0), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VFMA) ZYDIS_NOTMIN(ZYDIS_ISA_SET_FMA) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_FMA) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFNMADD132PD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x11A3), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VFMA) ZYDIS_NOTMIN(ZYDIS_ISA_SET_FMA) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_FMA) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX2), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFNMADD132PD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x11A6), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VFMA) ZYDIS_NOTMIN(ZYDIS_ISA_SET_FMA) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_FMA) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX2), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFNMADD132PS ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x11A9), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VFMA) ZYDIS_NOTMIN(ZYDIS_ISA_SET_FMA) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_FMA) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFNMADD132PS ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x11AC), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VFMA) ZYDIS_NOTMIN(ZYDIS_ISA_SET_FMA) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_FMA) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFNMADD132PS ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x11AF), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VFMA) ZYDIS_NOTMIN(ZYDIS_ISA_SET_FMA) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_FMA) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX2), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFNMADD132PS ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x11B2), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VFMA) ZYDIS_NOTMIN(ZYDIS_ISA_SET_FMA) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_FMA) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX2), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFNMADD132SD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x11B5), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VFMA) ZYDIS_NOTMIN(ZYDIS_ISA_SET_FMA) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_FMA) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX3), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFNMADD132SD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x11B8), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VFMA) ZYDIS_NOTMIN(ZYDIS_ISA_SET_FMA) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_FMA) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX3), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFNMADD132SS ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x11BB), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VFMA) ZYDIS_NOTMIN(ZYDIS_ISA_SET_FMA) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_FMA) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX3), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFNMADD132SS ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x11BE), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VFMA) ZYDIS_NOTMIN(ZYDIS_ISA_SET_FMA) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_FMA) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX3), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFNMADD213PD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x119D), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VFMA) ZYDIS_NOTMIN(ZYDIS_ISA_SET_FMA) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_FMA) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFNMADD213PD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x11A0), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VFMA) ZYDIS_NOTMIN(ZYDIS_ISA_SET_FMA) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_FMA) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFNMADD213PD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x11A3), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VFMA) ZYDIS_NOTMIN(ZYDIS_ISA_SET_FMA) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_FMA) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX2), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFNMADD213PD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x11A6), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VFMA) ZYDIS_NOTMIN(ZYDIS_ISA_SET_FMA) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_FMA) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX2), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFNMADD213PS ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x11A9), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VFMA) ZYDIS_NOTMIN(ZYDIS_ISA_SET_FMA) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_FMA) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFNMADD213PS ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x11AC), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VFMA) ZYDIS_NOTMIN(ZYDIS_ISA_SET_FMA) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_FMA) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFNMADD213PS ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x11AF), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VFMA) ZYDIS_NOTMIN(ZYDIS_ISA_SET_FMA) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_FMA) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX2), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFNMADD213PS ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x11B2), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VFMA) ZYDIS_NOTMIN(ZYDIS_ISA_SET_FMA) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_FMA) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX2), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFNMADD213SD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x11B5), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VFMA) ZYDIS_NOTMIN(ZYDIS_ISA_SET_FMA) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_FMA) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX3), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFNMADD213SD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x11B8), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VFMA) ZYDIS_NOTMIN(ZYDIS_ISA_SET_FMA) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_FMA) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX3), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFNMADD213SS ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x11BB), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VFMA) ZYDIS_NOTMIN(ZYDIS_ISA_SET_FMA) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_FMA) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX3), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFNMADD213SS ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x11BE), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VFMA) ZYDIS_NOTMIN(ZYDIS_ISA_SET_FMA) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_FMA) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX3), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFNMADD231PD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x119D), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VFMA) ZYDIS_NOTMIN(ZYDIS_ISA_SET_FMA) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_FMA) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFNMADD231PD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x11A0), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VFMA) ZYDIS_NOTMIN(ZYDIS_ISA_SET_FMA) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_FMA) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFNMADD231PD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x11A3), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VFMA) ZYDIS_NOTMIN(ZYDIS_ISA_SET_FMA) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_FMA) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX2), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFNMADD231PD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x11A6), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VFMA) ZYDIS_NOTMIN(ZYDIS_ISA_SET_FMA) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_FMA) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX2), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFNMADD231PS ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x11A9), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VFMA) ZYDIS_NOTMIN(ZYDIS_ISA_SET_FMA) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_FMA) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFNMADD231PS ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x11AC), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VFMA) ZYDIS_NOTMIN(ZYDIS_ISA_SET_FMA) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_FMA) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFNMADD231PS ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x11AF), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VFMA) ZYDIS_NOTMIN(ZYDIS_ISA_SET_FMA) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_FMA) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX2), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFNMADD231PS ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x11B2), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VFMA) ZYDIS_NOTMIN(ZYDIS_ISA_SET_FMA) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_FMA) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX2), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFNMADD231SD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x11B5), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VFMA) ZYDIS_NOTMIN(ZYDIS_ISA_SET_FMA) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_FMA) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX3), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFNMADD231SD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x11B8), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VFMA) ZYDIS_NOTMIN(ZYDIS_ISA_SET_FMA) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_FMA) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX3), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFNMADD231SS ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x11BB), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VFMA) ZYDIS_NOTMIN(ZYDIS_ISA_SET_FMA) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_FMA) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX3), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFNMADD231SS ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x11BE), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VFMA) ZYDIS_NOTMIN(ZYDIS_ISA_SET_FMA) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_FMA) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX3), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFNMADDPD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x153), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_FMA4) ZYDIS_NOTMIN(ZYDIS_ISA_SET_FMA4) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_FMA4) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFNMADDPD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x158), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_FMA4) ZYDIS_NOTMIN(ZYDIS_ISA_SET_FMA4) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_FMA4) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFNMADDPD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x15D), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_FMA4) ZYDIS_NOTMIN(ZYDIS_ISA_SET_FMA4) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_FMA4) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFNMADDPD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x162), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_FMA4) ZYDIS_NOTMIN(ZYDIS_ISA_SET_FMA4) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_FMA4) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFNMADDPD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x167), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_FMA4) ZYDIS_NOTMIN(ZYDIS_ISA_SET_FMA4) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_FMA4) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFNMADDPD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x16C), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_FMA4) ZYDIS_NOTMIN(ZYDIS_ISA_SET_FMA4) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_FMA4) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFNMADDPD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x171), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_FMA4) ZYDIS_NOTMIN(ZYDIS_ISA_SET_FMA4) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_FMA4) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFNMADDPD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x176), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_FMA4) ZYDIS_NOTMIN(ZYDIS_ISA_SET_FMA4) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_FMA4) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFNMADDPS ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x17B), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_FMA4) ZYDIS_NOTMIN(ZYDIS_ISA_SET_FMA4) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_FMA4) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFNMADDPS ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x180), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_FMA4) ZYDIS_NOTMIN(ZYDIS_ISA_SET_FMA4) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_FMA4) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFNMADDPS ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x185), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_FMA4) ZYDIS_NOTMIN(ZYDIS_ISA_SET_FMA4) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_FMA4) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFNMADDPS ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x18A), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_FMA4) ZYDIS_NOTMIN(ZYDIS_ISA_SET_FMA4) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_FMA4) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFNMADDPS ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x18F), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_FMA4) ZYDIS_NOTMIN(ZYDIS_ISA_SET_FMA4) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_FMA4) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFNMADDPS ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x194), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_FMA4) ZYDIS_NOTMIN(ZYDIS_ISA_SET_FMA4) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_FMA4) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFNMADDPS ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x199), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_FMA4) ZYDIS_NOTMIN(ZYDIS_ISA_SET_FMA4) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_FMA4) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFNMADDPS ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x19E), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_FMA4) ZYDIS_NOTMIN(ZYDIS_ISA_SET_FMA4) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_FMA4) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFNMADDSD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x7B4), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_FMA4) ZYDIS_NOTMIN(ZYDIS_ISA_SET_FMA4) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_FMA4) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFNMADDSD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x7B8), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_FMA4) ZYDIS_NOTMIN(ZYDIS_ISA_SET_FMA4) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_FMA4) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFNMADDSD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x7BC), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_FMA4) ZYDIS_NOTMIN(ZYDIS_ISA_SET_FMA4) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_FMA4) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFNMADDSD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x7C0), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_FMA4) ZYDIS_NOTMIN(ZYDIS_ISA_SET_FMA4) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_FMA4) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFNMADDSS ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x7C4), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_FMA4) ZYDIS_NOTMIN(ZYDIS_ISA_SET_FMA4) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_FMA4) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFNMADDSS ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x7C8), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_FMA4) ZYDIS_NOTMIN(ZYDIS_ISA_SET_FMA4) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_FMA4) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFNMADDSS ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x7CC), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_FMA4) ZYDIS_NOTMIN(ZYDIS_ISA_SET_FMA4) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_FMA4) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFNMADDSS ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x7D0), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_FMA4) ZYDIS_NOTMIN(ZYDIS_ISA_SET_FMA4) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_FMA4) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFNMSUB132PD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x119D), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VFMA) ZYDIS_NOTMIN(ZYDIS_ISA_SET_FMA) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_FMA) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFNMSUB132PD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x11A0), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VFMA) ZYDIS_NOTMIN(ZYDIS_ISA_SET_FMA) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_FMA) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFNMSUB132PD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x11A3), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VFMA) ZYDIS_NOTMIN(ZYDIS_ISA_SET_FMA) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_FMA) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX2), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFNMSUB132PD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x11A6), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VFMA) ZYDIS_NOTMIN(ZYDIS_ISA_SET_FMA) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_FMA) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX2), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFNMSUB132PS ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x11A9), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VFMA) ZYDIS_NOTMIN(ZYDIS_ISA_SET_FMA) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_FMA) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFNMSUB132PS ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x11AC), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VFMA) ZYDIS_NOTMIN(ZYDIS_ISA_SET_FMA) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_FMA) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFNMSUB132PS ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x11AF), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VFMA) ZYDIS_NOTMIN(ZYDIS_ISA_SET_FMA) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_FMA) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX2), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFNMSUB132PS ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x11B2), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VFMA) ZYDIS_NOTMIN(ZYDIS_ISA_SET_FMA) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_FMA) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX2), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFNMSUB132SD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x11B5), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VFMA) ZYDIS_NOTMIN(ZYDIS_ISA_SET_FMA) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_FMA) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX3), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFNMSUB132SD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x11B8), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VFMA) ZYDIS_NOTMIN(ZYDIS_ISA_SET_FMA) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_FMA) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX3), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFNMSUB132SS ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x11BB), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VFMA) ZYDIS_NOTMIN(ZYDIS_ISA_SET_FMA) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_FMA) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX3), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFNMSUB132SS ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x11BE), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VFMA) ZYDIS_NOTMIN(ZYDIS_ISA_SET_FMA) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_FMA) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX3), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFNMSUB213PD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x119D), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VFMA) ZYDIS_NOTMIN(ZYDIS_ISA_SET_FMA) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_FMA) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFNMSUB213PD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x11A0), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VFMA) ZYDIS_NOTMIN(ZYDIS_ISA_SET_FMA) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_FMA) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFNMSUB213PD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x11A3), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VFMA) ZYDIS_NOTMIN(ZYDIS_ISA_SET_FMA) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_FMA) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX2), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFNMSUB213PD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x11A6), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VFMA) ZYDIS_NOTMIN(ZYDIS_ISA_SET_FMA) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_FMA) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX2), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFNMSUB213PS ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x11A9), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VFMA) ZYDIS_NOTMIN(ZYDIS_ISA_SET_FMA) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_FMA) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFNMSUB213PS ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x11AC), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VFMA) ZYDIS_NOTMIN(ZYDIS_ISA_SET_FMA) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_FMA) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFNMSUB213PS ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x11AF), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VFMA) ZYDIS_NOTMIN(ZYDIS_ISA_SET_FMA) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_FMA) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX2), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFNMSUB213PS ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x11B2), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VFMA) ZYDIS_NOTMIN(ZYDIS_ISA_SET_FMA) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_FMA) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX2), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFNMSUB213SD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x11B5), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VFMA) ZYDIS_NOTMIN(ZYDIS_ISA_SET_FMA) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_FMA) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX3), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFNMSUB213SD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x11B8), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VFMA) ZYDIS_NOTMIN(ZYDIS_ISA_SET_FMA) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_FMA) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX3), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFNMSUB213SS ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x11BB), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VFMA) ZYDIS_NOTMIN(ZYDIS_ISA_SET_FMA) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_FMA) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX3), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFNMSUB213SS ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x11BE), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VFMA) ZYDIS_NOTMIN(ZYDIS_ISA_SET_FMA) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_FMA) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX3), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFNMSUB231PD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x119D), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VFMA) ZYDIS_NOTMIN(ZYDIS_ISA_SET_FMA) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_FMA) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFNMSUB231PD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x11A0), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VFMA) ZYDIS_NOTMIN(ZYDIS_ISA_SET_FMA) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_FMA) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFNMSUB231PD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x11A3), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VFMA) ZYDIS_NOTMIN(ZYDIS_ISA_SET_FMA) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_FMA) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX2), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFNMSUB231PD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x11A6), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VFMA) ZYDIS_NOTMIN(ZYDIS_ISA_SET_FMA) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_FMA) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX2), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFNMSUB231PS ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x11A9), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VFMA) ZYDIS_NOTMIN(ZYDIS_ISA_SET_FMA) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_FMA) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFNMSUB231PS ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x11AC), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VFMA) ZYDIS_NOTMIN(ZYDIS_ISA_SET_FMA) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_FMA) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFNMSUB231PS ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x11AF), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VFMA) ZYDIS_NOTMIN(ZYDIS_ISA_SET_FMA) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_FMA) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX2), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFNMSUB231PS ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x11B2), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VFMA) ZYDIS_NOTMIN(ZYDIS_ISA_SET_FMA) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_FMA) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX2), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFNMSUB231SD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x11B5), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VFMA) ZYDIS_NOTMIN(ZYDIS_ISA_SET_FMA) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_FMA) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX3), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFNMSUB231SD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x11B8), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VFMA) ZYDIS_NOTMIN(ZYDIS_ISA_SET_FMA) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_FMA) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX3), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFNMSUB231SS ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x11BB), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VFMA) ZYDIS_NOTMIN(ZYDIS_ISA_SET_FMA) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_FMA) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX3), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFNMSUB231SS ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x11BE), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VFMA) ZYDIS_NOTMIN(ZYDIS_ISA_SET_FMA) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_FMA) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX3), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFNMSUBPD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x153), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_FMA4) ZYDIS_NOTMIN(ZYDIS_ISA_SET_FMA4) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_FMA4) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFNMSUBPD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x158), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_FMA4) ZYDIS_NOTMIN(ZYDIS_ISA_SET_FMA4) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_FMA4) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFNMSUBPD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x15D), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_FMA4) ZYDIS_NOTMIN(ZYDIS_ISA_SET_FMA4) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_FMA4) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFNMSUBPD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x162), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_FMA4) ZYDIS_NOTMIN(ZYDIS_ISA_SET_FMA4) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_FMA4) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFNMSUBPD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x167), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_FMA4) ZYDIS_NOTMIN(ZYDIS_ISA_SET_FMA4) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_FMA4) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFNMSUBPD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x16C), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_FMA4) ZYDIS_NOTMIN(ZYDIS_ISA_SET_FMA4) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_FMA4) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFNMSUBPD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x171), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_FMA4) ZYDIS_NOTMIN(ZYDIS_ISA_SET_FMA4) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_FMA4) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFNMSUBPD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x176), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_FMA4) ZYDIS_NOTMIN(ZYDIS_ISA_SET_FMA4) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_FMA4) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFNMSUBPS ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x17B), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_FMA4) ZYDIS_NOTMIN(ZYDIS_ISA_SET_FMA4) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_FMA4) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFNMSUBPS ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x180), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_FMA4) ZYDIS_NOTMIN(ZYDIS_ISA_SET_FMA4) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_FMA4) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFNMSUBPS ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x185), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_FMA4) ZYDIS_NOTMIN(ZYDIS_ISA_SET_FMA4) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_FMA4) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFNMSUBPS ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x18A), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_FMA4) ZYDIS_NOTMIN(ZYDIS_ISA_SET_FMA4) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_FMA4) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFNMSUBPS ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x18F), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_FMA4) ZYDIS_NOTMIN(ZYDIS_ISA_SET_FMA4) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_FMA4) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFNMSUBPS ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x194), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_FMA4) ZYDIS_NOTMIN(ZYDIS_ISA_SET_FMA4) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_FMA4) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFNMSUBPS ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x199), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_FMA4) ZYDIS_NOTMIN(ZYDIS_ISA_SET_FMA4) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_FMA4) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFNMSUBPS ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x19E), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_FMA4) ZYDIS_NOTMIN(ZYDIS_ISA_SET_FMA4) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_FMA4) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFNMSUBSD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x7B4), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_FMA4) ZYDIS_NOTMIN(ZYDIS_ISA_SET_FMA4) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_FMA4) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFNMSUBSD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x7B8), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_FMA4) ZYDIS_NOTMIN(ZYDIS_ISA_SET_FMA4) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_FMA4) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFNMSUBSD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x7BC), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_FMA4) ZYDIS_NOTMIN(ZYDIS_ISA_SET_FMA4) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_FMA4) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFNMSUBSD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x7C0), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_FMA4) ZYDIS_NOTMIN(ZYDIS_ISA_SET_FMA4) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_FMA4) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFNMSUBSS ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x7C4), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_FMA4) ZYDIS_NOTMIN(ZYDIS_ISA_SET_FMA4) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_FMA4) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFNMSUBSS ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x7C8), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_FMA4) ZYDIS_NOTMIN(ZYDIS_ISA_SET_FMA4) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_FMA4) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFNMSUBSS ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x7CC), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_FMA4) ZYDIS_NOTMIN(ZYDIS_ISA_SET_FMA4) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_FMA4) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFNMSUBSS ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x7D0), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_FMA4) ZYDIS_NOTMIN(ZYDIS_ISA_SET_FMA4) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_FMA4) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VGATHERDPD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x11C1), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX2GATHER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX2GATHER) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX2GATHER) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX12), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_VSIB | (1 << 3) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_TRUE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VGATHERDPD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x11C4), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX2GATHER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX2GATHER) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX2GATHER) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX12), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_VSIB | (1 << 3) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_TRUE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VGATHERDPS ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x11C7), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX2GATHER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX2GATHER) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX2GATHER) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX12), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_VSIB | (1 << 3) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_TRUE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VGATHERDPS ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x11CA), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX2GATHER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX2GATHER) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX2GATHER) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX12), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_VSIB | (1 << 3) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_TRUE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VGATHERQPD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x11C1), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX2GATHER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX2GATHER) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX2GATHER) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX12), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_VSIB | (1 << 3) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_TRUE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VGATHERQPD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x11CD), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX2GATHER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX2GATHER) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX2GATHER) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX12), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_VSIB | (1 << 3) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_TRUE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VGATHERQPS ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x11D0), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX2GATHER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX2GATHER) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX2GATHER) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX12), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_VSIB | (1 << 3) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_TRUE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VGATHERQPS ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x11D3), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX2GATHER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX2GATHER) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX2GATHER) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX12), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_VSIB | (1 << 3) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_TRUE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VGF2P8AFFINEINVQB ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x7D4), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_GFNI) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX_GFNI) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_GFNI) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VGF2P8AFFINEINVQB ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x7D8), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_GFNI) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX_GFNI) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_GFNI) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VGF2P8AFFINEINVQB ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x7DC), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_GFNI) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX_GFNI) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_GFNI) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VGF2P8AFFINEINVQB ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x7E0), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_GFNI) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX_GFNI) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_GFNI) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VGF2P8AFFINEQB ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x7D4), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_GFNI) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX_GFNI) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_GFNI) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VGF2P8AFFINEQB ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x7D8), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_GFNI) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX_GFNI) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_GFNI) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VGF2P8AFFINEQB ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x7DC), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_GFNI) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX_GFNI) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_GFNI) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VGF2P8AFFINEQB ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x7E0), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_GFNI) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX_GFNI) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_GFNI) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VGF2P8MULB ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x6BC), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_GFNI) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX_GFNI) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_GFNI) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VGF2P8MULB ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x808), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_GFNI) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX_GFNI) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_GFNI) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VGF2P8MULB ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x6C0), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_GFNI) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX_GFNI) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_GFNI) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VGF2P8MULB ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x80C), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_GFNI) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX_GFNI) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_GFNI) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VHADDPD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x153), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VHADDPD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x15D), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VHADDPD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x167), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX2), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VHADDPD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x171), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX2), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VHADDPS ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x17B), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VHADDPS ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x185), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VHADDPS ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x18F), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX2), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VHADDPS ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x199), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX2), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VHSUBPD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x153), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VHSUBPD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x15D), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VHSUBPD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x167), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX2), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VHSUBPD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x171), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX2), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VHSUBPS ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x17B), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VHSUBPS ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x185), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VHSUBPS ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x18F), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX2), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VHSUBPS ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x199), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX2), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VINSERTF128 ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x7E4), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX6), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_2_TO_4) },
    { ZYDIS_MNEMONIC_VINSERTF128 ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x7E8), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX6), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_2_TO_4) },
    { ZYDIS_MNEMONIC_VINSERTI128 ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x7EC), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX2) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX2) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX2) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX6), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VINSERTI128 ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x7F0), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX2) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX2) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX2) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX6), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VINSERTPS ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x754), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX5), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VINSERTPS ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x7F4), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX5), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VLDDQU ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xDB0), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VLDDQU ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1DED), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VLDMXCSR ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(1) ZYDIS_NOTMIN(0x1BA3), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX5), 0, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VMASKMOVDQU ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xF27), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VMASKMOVPD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x11D6), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX6), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VMASKMOVPD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x11D9), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX6), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VMASKMOVPD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x11DC), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX6), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VMASKMOVPD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x11DF), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX6), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VMASKMOVPS ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x11E2), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX6), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VMASKMOVPS ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x11E5), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX6), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VMASKMOVPS ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x11E8), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX6), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VMASKMOVPS ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x11EB), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX6), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VMAXPD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x153), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VMAXPD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x15D), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VMAXPD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x167), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX2), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VMAXPD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x171), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX2), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VMAXPS ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x17B), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VMAXPS ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x185), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VMAXPS ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x18F), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX2), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VMAXPS ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x199), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX2), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VMAXSD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x7A4), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX3), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VMAXSD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x7A8), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX3), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VMAXSS ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x7AC), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX3), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VMAXSS ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x7B0), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX3), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VMINPD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x153), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VMINPD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x15D), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VMINPD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x167), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX2), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VMINPD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x171), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX2), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VMINPS ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x17B), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VMINPS ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x185), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VMINPS ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x18F), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX2), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VMINPS ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x199), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX2), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VMINSD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x7A4), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX3), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VMINSD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x7A8), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX3), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VMINSS ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x7AC), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX3), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VMINSS ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x7B0), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX3), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VMOVAPD ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1056), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX1), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VMOVAPD ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x12BA), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX1), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VMOVAPD ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1059), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX1), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VMOVAPD ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x12BD), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX1), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VMOVAPD ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1BF3), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX1), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VMOVAPD ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1DEF), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX1), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VMOVAPD ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1BF5), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX1), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VMOVAPD ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1DF1), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX1), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VMOVAPS ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x105C), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX1), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VMOVAPS ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x12CC), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX1), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VMOVAPS ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x105F), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX1), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VMOVAPS ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x12CF), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX1), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VMOVAPS ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1BF7), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX1), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VMOVAPS ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1DF3), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX1), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VMOVAPS ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1BF9), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX1), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VMOVAPS ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1DF5), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX1), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VMOVD ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1DF7), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX5), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_GPR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VMOVD ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1C01), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX5), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VMOVD ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1DF7), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX5), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_GPR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VMOVD ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1C01), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX5), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VMOVD ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1DF9), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX5), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_GPR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VMOVD ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1C09), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX5), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VMOVD ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1DF9), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX5), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_GPR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VMOVD ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1C09), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX5), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VMOVDDUP ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1D47), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX5), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VMOVDDUP ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x12BA), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX5), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VMOVDDUP ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1C43), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX5), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VMOVDDUP ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x12BD), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX5), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VMOVDQA ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xDAD), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX1), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VMOVDQA ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1DFB), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX1), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VMOVDQA ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xDB0), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX1), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VMOVDQA ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1DED), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX1), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VMOVDQA ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1C15), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX1), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VMOVDQA ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1DFD), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX1), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VMOVDQA ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1C17), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX1), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VMOVDQA ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1DFF), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX1), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VMOVDQU ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xDAD), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VMOVDQU ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1DFB), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VMOVDQU ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xDB0), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VMOVDQU ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1DED), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VMOVDQU ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1C15), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VMOVDQU ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1DFD), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VMOVDQU ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1C17), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VMOVDQU ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1DFF), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VMOVHLPS ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x17B), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX7), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VMOVHPD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x11EE), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX5), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VMOVHPD ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1E01), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX5), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VMOVHPS ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x11F1), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX5), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VMOVHPS ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1C1F), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX5), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VMOVLHPS ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x11F4), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX7), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VMOVLPD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x7A8), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX5), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VMOVLPD ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1C47), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX5), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VMOVLPS ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x11F7), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX5), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VMOVLPS ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1C21), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX5), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VMOVMSKPD ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1E03), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX7), ZYDIS_REGKIND_GPR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VMOVMSKPD ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1E05), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX7), ZYDIS_REGKIND_GPR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VMOVMSKPS ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1E07), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX7), ZYDIS_REGKIND_GPR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VMOVMSKPS ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1E09), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX7), ZYDIS_REGKIND_GPR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VMOVNTDQ ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1C17), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX1), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VMOVNTDQ ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1DFF), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX1), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VMOVNTDQA ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xDB0), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX1), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VMOVNTDQA ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1DED), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX2) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX2) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX1), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VMOVNTPD ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1BF5), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX1), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VMOVNTPD ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1DF1), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX1), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VMOVNTPS ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1BF9), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX1), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VMOVNTPS ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1DF5), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX1), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VMOVQ ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1E0B), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX5), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_GPR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VMOVQ ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1C0D), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX5), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VMOVQ ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1E0D), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX5), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_GPR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VMOVQ ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1C2D), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX5), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VMOVQ ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1C0B), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX5), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VMOVQ ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1C0D), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX5), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VMOVQ ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1C3D), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX5), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VMOVQ ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1C2D), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX5), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VMOVSD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x7A4), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX5), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VMOVSD ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1C43), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX5), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VMOVSD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x11FA), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX5), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VMOVSD ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1C47), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX5), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VMOVSHDUP ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x105C), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VMOVSHDUP ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x12CC), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VMOVSHDUP ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x105F), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VMOVSHDUP ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x12CF), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VMOVSLDUP ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x105C), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VMOVSLDUP ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x12CC), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VMOVSLDUP ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x105F), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VMOVSLDUP ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x12CF), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VMOVSS ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x7AC), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX5), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VMOVSS ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1C4B), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX5), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VMOVSS ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x11FD), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX5), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VMOVSS ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1C4F), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX5), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VMOVUPD ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1056), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VMOVUPD ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x12BA), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VMOVUPD ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1059), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VMOVUPD ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x12BD), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VMOVUPD ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1BF3), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VMOVUPD ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1DEF), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VMOVUPD ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1BF5), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VMOVUPD ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1DF1), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VMOVUPS ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x105C), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VMOVUPS ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x12CC), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VMOVUPS ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x105F), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VMOVUPS ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x12CF), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VMOVUPS ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1BF7), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VMOVUPS ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1DF3), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VMOVUPS ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1BF9), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VMOVUPS ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1DF5), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VMPSADBW ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x7F8), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VMPSADBW ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x7FC), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX2) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX2) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX2) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VMPSADBW ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x800), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VMPSADBW ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x804), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX2) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX2) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX2) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VMULPD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x153), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VMULPD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x15D), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VMULPD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x167), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX2), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VMULPD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x171), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX2), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VMULPS ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x17B), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VMULPS ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x185), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VMULPS ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x18F), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX2), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VMULPS ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x199), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX2), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VMULSD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x7A4), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX3), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VMULSD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x7A8), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX3), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VMULSS ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x7AC), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX3), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VMULSS ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x7B0), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX3), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VORPD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x6CC), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_LOGICAL_FP) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VORPD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x114F), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_LOGICAL_FP) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VORPD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x6D0), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_LOGICAL_FP) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VORPD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1152), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_LOGICAL_FP) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VORPS ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x6C4), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_LOGICAL_FP) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VORPS ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x810), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_LOGICAL_FP) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VORPS ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x6C8), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_LOGICAL_FP) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VORPS ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x814), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_LOGICAL_FP) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPABSB ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1E0F), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPABSB ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1E11), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX2) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX2) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX2) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPABSB ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1E13), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPABSB ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1E15), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX2) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX2) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX2) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPABSD ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1E17), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPABSD ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1E19), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX2) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX2) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX2) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPABSD ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1E1B), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPABSD ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1E1D), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX2) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX2) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX2) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPABSW ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1E1F), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPABSW ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1E21), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX2) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX2) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX2) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPABSW ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1E23), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPABSW ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1E25), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX2) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX2) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX2) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPACKSSDW ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1200), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPACKSSDW ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1203), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX2) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX2) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX2) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPACKSSDW ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1206), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPACKSSDW ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1209), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX2) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX2) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX2) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPACKSSWB ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x120C), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPACKSSWB ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x120F), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX2) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX2) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX2) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPACKSSWB ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1212), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPACKSSWB ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1215), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX2) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX2) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX2) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPACKUSDW ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1218), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPACKUSDW ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x121B), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX2) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX2) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX2) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPACKUSDW ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x121E), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPACKUSDW ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1221), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX2) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX2) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX2) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPACKUSWB ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1224), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPACKUSWB ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1227), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX2) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX2) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX2) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPACKUSWB ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x122A), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPACKUSWB ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x122D), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX2) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX2) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX2) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPADDB ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x6A4), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPADDB ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x81C), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX2) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX2) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX2) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPADDB ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x6A8), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPADDB ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x824), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX2) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX2) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX2) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPADDD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x6AC), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPADDD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1155), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX2) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX2) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX2) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPADDD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x6B0), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPADDD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1158), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX2) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX2) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX2) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPADDQ ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x6B4), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPADDQ ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1230), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX2) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX2) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX2) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPADDQ ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x6B8), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPADDQ ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1233), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX2) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX2) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX2) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPADDSB ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x6A4), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPADDSB ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x81C), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX2) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX2) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX2) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPADDSB ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x6A8), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPADDSB ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x824), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX2) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX2) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX2) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPADDSW ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x6DC), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPADDSW ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1236), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX2) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX2) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX2) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPADDSW ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x6E0), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPADDSW ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1239), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX2) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX2) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX2) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPADDUSB ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x6BC), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPADDUSB ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x808), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX2) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX2) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX2) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPADDUSB ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x6C0), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPADDUSB ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x80C), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX2) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX2) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX2) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPADDUSW ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x6D4), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPADDUSW ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x828), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX2) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX2) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX2) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPADDUSW ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x6D8), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPADDUSW ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x82C), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX2) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX2) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX2) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPADDW ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x6DC), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPADDW ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1236), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX2) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX2) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX2) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPADDW ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x6E0), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPADDW ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1239), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX2) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX2) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX2) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPALIGNR ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x6BC), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPALIGNR ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x808), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX2) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX2) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX2) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPALIGNR ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x6C0), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPALIGNR ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x80C), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX2) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX2) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX2) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPAND ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x123C), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_LOGICAL) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPAND ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x123F), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_LOGICAL) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX2) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX2) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPAND ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1242), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_LOGICAL) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPAND ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1245), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_LOGICAL) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX2) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX2) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPANDN ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x123C), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_LOGICAL) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPANDN ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x123F), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_LOGICAL) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX2) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX2) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPANDN ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1242), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_LOGICAL) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPANDN ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1245), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_LOGICAL) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX2) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX2) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPAVGB ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x6BC), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPAVGB ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x808), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX2) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX2) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX2) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPAVGB ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x6C0), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPAVGB ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x80C), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX2) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX2) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX2) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPAVGW ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x6D4), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPAVGW ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x828), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX2) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX2) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX2) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPAVGW ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x6D8), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPAVGW ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x82C), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX2) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX2) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX2) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPBLENDD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x6C4), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX2) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX2) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX2) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPBLENDD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x810), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX2) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX2) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX2) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPBLENDD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x6C8), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX2) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX2) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX2) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPBLENDD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x814), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX2) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX2) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX2) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPBLENDVB ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x818), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPBLENDVB ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x81C), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX2) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX2) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX2) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPBLENDVB ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x820), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPBLENDVB ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x824), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX2) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX2) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX2) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPBLENDW ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x6D4), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPBLENDW ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x828), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX2) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX2) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX2) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPBLENDW ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x6D8), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPBLENDW ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x82C), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX2) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX2) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX2) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPBROADCASTB ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1E27), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_BROADCAST) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX2) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX2) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX6), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_1_TO_16) },
    { ZYDIS_MNEMONIC_VPBROADCASTB ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1E29), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_BROADCAST) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX2) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX2) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX6), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_1_TO_32) },
    { ZYDIS_MNEMONIC_VPBROADCASTB ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1E2B), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_BROADCAST) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX2) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX2) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX6), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_1_TO_16) },
    { ZYDIS_MNEMONIC_VPBROADCASTB ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1E2D), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_BROADCAST) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX2) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX2) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX6), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_1_TO_32) },
    { ZYDIS_MNEMONIC_VPBROADCASTD ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1E2F), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_BROADCAST) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX2) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX2) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX6), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_1_TO_4) },
    { ZYDIS_MNEMONIC_VPBROADCASTD ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1E31), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_BROADCAST) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX2) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX2) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX6), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_1_TO_8) },
    { ZYDIS_MNEMONIC_VPBROADCASTD ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1C01), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_BROADCAST) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX2) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX2) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX6), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_1_TO_4) },
    { ZYDIS_MNEMONIC_VPBROADCASTD ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1E33), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_BROADCAST) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX2) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX2) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX6), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_1_TO_8) },
    { ZYDIS_MNEMONIC_VPBROADCASTQ ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1E35), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_BROADCAST) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX2) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX2) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX6), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_1_TO_2) },
    { ZYDIS_MNEMONIC_VPBROADCASTQ ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1E37), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_BROADCAST) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX2) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX2) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX6), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_1_TO_4) },
    { ZYDIS_MNEMONIC_VPBROADCASTQ ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1E39), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_BROADCAST) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX2) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX2) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX6), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_1_TO_2) },
    { ZYDIS_MNEMONIC_VPBROADCASTQ ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1E3B), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_BROADCAST) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX2) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX2) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX6), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_1_TO_4) },
    { ZYDIS_MNEMONIC_VPBROADCASTW ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1E3D), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_BROADCAST) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX2) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX2) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX6), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_1_TO_8) },
    { ZYDIS_MNEMONIC_VPBROADCASTW ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1E3F), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_BROADCAST) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX2) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX2) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX6), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_1_TO_16) },
    { ZYDIS_MNEMONIC_VPBROADCASTW ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1E41), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_BROADCAST) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX2) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX2) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX6), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_1_TO_8) },
    { ZYDIS_MNEMONIC_VPBROADCASTW ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1E43), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_BROADCAST) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX2) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX2) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX6), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_1_TO_16) },
    { ZYDIS_MNEMONIC_VPCLMULQDQ ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x830), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPCLMULQDQ ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x834), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VPCLMULQDQ) ZYDIS_NOTMIN(ZYDIS_ISA_SET_VPCLMULQDQ) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_VPCLMULQDQ) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPCLMULQDQ ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x838), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPCLMULQDQ ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x83C), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VPCLMULQDQ) ZYDIS_NOTMIN(ZYDIS_ISA_SET_VPCLMULQDQ) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_VPCLMULQDQ) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPCMPEQB ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x6BC), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPCMPEQB ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x808), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX2) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX2) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX2) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPCMPEQB ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x6C0), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPCMPEQB ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x80C), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX2) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX2) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX2) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPCMPEQD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x6AC), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPCMPEQD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1155), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX2) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX2) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX2) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPCMPEQD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x6B0), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPCMPEQD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1158), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX2) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX2) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX2) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPCMPEQQ ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x6CC), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPCMPEQQ ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x114F), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX2) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX2) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX2) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPCMPEQQ ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x6D0), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPCMPEQQ ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1152), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX2) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX2) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX2) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPCMPEQW ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x6D4), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPCMPEQW ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x828), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX2) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX2) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX2) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPCMPEQW ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x6D8), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPCMPEQW ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x82C), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX2) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX2) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX2) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPCMPESTRI ZYDIS_NOTMIN(7) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x5E), 0, 0 ZYDIS_NOTMIN(0x36), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_STTNI) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPCMPESTRI ZYDIS_NOTMIN(7) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x65), 0, 0 ZYDIS_NOTMIN(0x36), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_STTNI) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPCMPESTRI ZYDIS_NOTMIN(7) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x6C), 0, 0 ZYDIS_NOTMIN(0x36), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_STTNI) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPCMPESTRI ZYDIS_NOTMIN(7) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x73), 0, 0 ZYDIS_NOTMIN(0x36), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_STTNI) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPCMPESTRM ZYDIS_NOTMIN(7) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x7A), 0, 0 ZYDIS_NOTMIN(0x36), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_STTNI) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPCMPESTRM ZYDIS_NOTMIN(7) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x81), 0, 0 ZYDIS_NOTMIN(0x36), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_STTNI) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPCMPESTRM ZYDIS_NOTMIN(7) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x88), 0, 0 ZYDIS_NOTMIN(0x36), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_STTNI) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPCMPESTRM ZYDIS_NOTMIN(7) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x8F), 0, 0 ZYDIS_NOTMIN(0x36), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_STTNI) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPCMPESTRM ZYDIS_NOTMIN(7) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x7A), 0, 0 ZYDIS_NOTMIN(0x36), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_STTNI) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPCMPESTRM ZYDIS_NOTMIN(7) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x88), 0, 0 ZYDIS_NOTMIN(0x36), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_STTNI) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPCMPGTB ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x6A4), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPCMPGTB ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x81C), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX2) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX2) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX2) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPCMPGTB ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x6A8), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPCMPGTB ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x824), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX2) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX2) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX2) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPCMPGTD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x6AC), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPCMPGTD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1155), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX2) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX2) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX2) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPCMPGTD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x6B0), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPCMPGTD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1158), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX2) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX2) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX2) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPCMPGTQ ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1248), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPCMPGTQ ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1230), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX2) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX2) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX2) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPCMPGTQ ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x124B), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPCMPGTQ ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1233), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX2) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX2) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX2) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPCMPGTW ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x6DC), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPCMPGTW ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1236), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX2) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX2) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX2) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPCMPGTW ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x6E0), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPCMPGTW ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1239), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX2) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX2) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX2) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPCMPISTRI ZYDIS_NOTMIN(5) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x11C), 0, 0 ZYDIS_NOTMIN(0x36), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_STTNI) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPCMPISTRI ZYDIS_NOTMIN(5) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x121), 0, 0 ZYDIS_NOTMIN(0x36), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_STTNI) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPCMPISTRM ZYDIS_NOTMIN(5) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x126), 0, 0 ZYDIS_NOTMIN(0x36), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_STTNI) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPCMPISTRM ZYDIS_NOTMIN(5) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x12B), 0, 0 ZYDIS_NOTMIN(0x36), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_STTNI) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPDPBSSD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x124E), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VEX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX_VNNI_INT8) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX_VNNI_INT8) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPDPBSSD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1251), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VEX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX_VNNI_INT8) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX_VNNI_INT8) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPDPBSSD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1254), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VEX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX_VNNI_INT8) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX_VNNI_INT8) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPDPBSSD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1257), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VEX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX_VNNI_INT8) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX_VNNI_INT8) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPDPBSSDS ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x124E), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VEX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX_VNNI_INT8) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX_VNNI_INT8) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPDPBSSDS ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1251), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VEX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX_VNNI_INT8) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX_VNNI_INT8) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPDPBSSDS ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1254), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VEX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX_VNNI_INT8) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX_VNNI_INT8) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPDPBSSDS ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1257), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VEX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX_VNNI_INT8) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX_VNNI_INT8) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPDPBSUD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x125A), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VEX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX_VNNI_INT8) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX_VNNI_INT8) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPDPBSUD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x125D), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VEX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX_VNNI_INT8) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX_VNNI_INT8) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPDPBSUD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1260), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VEX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX_VNNI_INT8) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX_VNNI_INT8) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPDPBSUD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1263), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VEX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX_VNNI_INT8) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX_VNNI_INT8) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPDPBSUDS ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x125A), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VEX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX_VNNI_INT8) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX_VNNI_INT8) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPDPBSUDS ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x125D), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VEX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX_VNNI_INT8) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX_VNNI_INT8) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPDPBSUDS ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1260), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VEX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX_VNNI_INT8) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX_VNNI_INT8) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPDPBSUDS ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1263), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VEX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX_VNNI_INT8) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX_VNNI_INT8) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPDPBUSD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1266), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VEX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX_VNNI) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX_VNNI) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPDPBUSD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1269), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VEX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX_VNNI) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX_VNNI) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPDPBUSD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x126C), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VEX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX_VNNI) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX_VNNI) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPDPBUSD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x126F), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VEX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX_VNNI) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX_VNNI) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPDPBUSDS ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1266), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VEX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX_VNNI) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX_VNNI) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPDPBUSDS ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1269), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VEX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX_VNNI) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX_VNNI) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPDPBUSDS ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x126C), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VEX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX_VNNI) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX_VNNI) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPDPBUSDS ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x126F), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VEX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX_VNNI) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX_VNNI) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPDPBUUD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1272), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VEX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX_VNNI_INT8) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX_VNNI_INT8) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPDPBUUD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1275), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VEX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX_VNNI_INT8) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX_VNNI_INT8) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPDPBUUD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1278), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VEX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX_VNNI_INT8) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX_VNNI_INT8) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPDPBUUD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x127B), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VEX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX_VNNI_INT8) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX_VNNI_INT8) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPDPBUUDS ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1272), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VEX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX_VNNI_INT8) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX_VNNI_INT8) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPDPBUUDS ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1275), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VEX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX_VNNI_INT8) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX_VNNI_INT8) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPDPBUUDS ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1278), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VEX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX_VNNI_INT8) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX_VNNI_INT8) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPDPBUUDS ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x127B), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VEX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX_VNNI_INT8) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX_VNNI_INT8) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPDPWSSD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x127E), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VEX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX_VNNI) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX_VNNI) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPDPWSSD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1281), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VEX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX_VNNI) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX_VNNI) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPDPWSSD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1284), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VEX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX_VNNI) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX_VNNI) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPDPWSSD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1287), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VEX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX_VNNI) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX_VNNI) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPDPWSSDS ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x127E), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VEX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX_VNNI) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX_VNNI) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPDPWSSDS ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1281), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VEX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX_VNNI) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX_VNNI) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPDPWSSDS ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1284), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VEX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX_VNNI) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX_VNNI) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPDPWSSDS ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1287), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VEX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX_VNNI) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX_VNNI) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPDPWSUD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x128A), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VEX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX_VNNI_INT16) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX_VNNI_INT16) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPDPWSUD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x128D), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VEX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX_VNNI_INT16) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX_VNNI_INT16) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPDPWSUD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1290), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VEX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX_VNNI_INT16) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX_VNNI_INT16) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPDPWSUD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1293), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VEX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX_VNNI_INT16) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX_VNNI_INT16) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPDPWSUDS ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x128A), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VEX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX_VNNI_INT16) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX_VNNI_INT16) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPDPWSUDS ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x128D), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VEX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX_VNNI_INT16) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX_VNNI_INT16) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPDPWSUDS ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1290), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VEX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX_VNNI_INT16) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX_VNNI_INT16) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPDPWSUDS ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1293), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VEX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX_VNNI_INT16) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX_VNNI_INT16) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPDPWUSD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1296), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VEX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX_VNNI_INT16) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX_VNNI_INT16) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPDPWUSD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1299), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VEX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX_VNNI_INT16) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX_VNNI_INT16) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPDPWUSD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x129C), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VEX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX_VNNI_INT16) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX_VNNI_INT16) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPDPWUSD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x129F), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VEX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX_VNNI_INT16) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX_VNNI_INT16) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPDPWUSDS ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1296), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VEX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX_VNNI_INT16) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX_VNNI_INT16) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPDPWUSDS ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1299), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VEX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX_VNNI_INT16) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX_VNNI_INT16) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPDPWUSDS ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x129C), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VEX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX_VNNI_INT16) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX_VNNI_INT16) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPDPWUSDS ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x129F), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VEX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX_VNNI_INT16) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX_VNNI_INT16) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPDPWUUD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x12A2), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VEX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX_VNNI_INT16) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX_VNNI_INT16) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPDPWUUD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x12A5), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VEX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX_VNNI_INT16) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX_VNNI_INT16) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPDPWUUD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x12A8), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VEX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX_VNNI_INT16) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX_VNNI_INT16) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPDPWUUD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x12AB), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VEX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX_VNNI_INT16) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX_VNNI_INT16) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPDPWUUDS ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x12A2), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VEX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX_VNNI_INT16) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX_VNNI_INT16) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPDPWUUDS ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x12A5), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VEX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX_VNNI_INT16) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX_VNNI_INT16) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPDPWUUDS ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x12A8), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VEX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX_VNNI_INT16) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX_VNNI_INT16) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPDPWUUDS ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x12AB), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VEX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX_VNNI_INT16) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX_VNNI_INT16) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPERM2F128 ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x748), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX6), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPERM2F128 ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x750), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX6), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPERM2I128 ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x840), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX2) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX2) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX2) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX6), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPERM2I128 ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x844), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX2) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX2) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX2) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX6), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPERMD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x810), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX2) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX2) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX2) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPERMD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x814), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX2) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX2) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX2) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPERMIL2PD ZYDIS_NOTMIN(5) ZYDIS_NOTMIN(5) ZYDIS_NOTMIN(0x153), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_XOP) ZYDIS_NOTMIN(ZYDIS_ISA_SET_XOP) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_XOP) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPERMIL2PD ZYDIS_NOTMIN(5) ZYDIS_NOTMIN(5) ZYDIS_NOTMIN(0x158), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_XOP) ZYDIS_NOTMIN(ZYDIS_ISA_SET_XOP) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_XOP) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPERMIL2PD ZYDIS_NOTMIN(5) ZYDIS_NOTMIN(5) ZYDIS_NOTMIN(0x15D), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_XOP) ZYDIS_NOTMIN(ZYDIS_ISA_SET_XOP) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_XOP) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPERMIL2PD ZYDIS_NOTMIN(5) ZYDIS_NOTMIN(5) ZYDIS_NOTMIN(0x162), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_XOP) ZYDIS_NOTMIN(ZYDIS_ISA_SET_XOP) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_XOP) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPERMIL2PD ZYDIS_NOTMIN(5) ZYDIS_NOTMIN(5) ZYDIS_NOTMIN(0x167), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_XOP) ZYDIS_NOTMIN(ZYDIS_ISA_SET_XOP) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_XOP) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPERMIL2PD ZYDIS_NOTMIN(5) ZYDIS_NOTMIN(5) ZYDIS_NOTMIN(0x16C), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_XOP) ZYDIS_NOTMIN(ZYDIS_ISA_SET_XOP) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_XOP) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPERMIL2PD ZYDIS_NOTMIN(5) ZYDIS_NOTMIN(5) ZYDIS_NOTMIN(0x171), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_XOP) ZYDIS_NOTMIN(ZYDIS_ISA_SET_XOP) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_XOP) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPERMIL2PD ZYDIS_NOTMIN(5) ZYDIS_NOTMIN(5) ZYDIS_NOTMIN(0x176), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_XOP) ZYDIS_NOTMIN(ZYDIS_ISA_SET_XOP) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_XOP) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPERMIL2PS ZYDIS_NOTMIN(5) ZYDIS_NOTMIN(5) ZYDIS_NOTMIN(0x17B), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_XOP) ZYDIS_NOTMIN(ZYDIS_ISA_SET_XOP) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_XOP) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPERMIL2PS ZYDIS_NOTMIN(5) ZYDIS_NOTMIN(5) ZYDIS_NOTMIN(0x180), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_XOP) ZYDIS_NOTMIN(ZYDIS_ISA_SET_XOP) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_XOP) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPERMIL2PS ZYDIS_NOTMIN(5) ZYDIS_NOTMIN(5) ZYDIS_NOTMIN(0x185), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_XOP) ZYDIS_NOTMIN(ZYDIS_ISA_SET_XOP) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_XOP) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPERMIL2PS ZYDIS_NOTMIN(5) ZYDIS_NOTMIN(5) ZYDIS_NOTMIN(0x18A), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_XOP) ZYDIS_NOTMIN(ZYDIS_ISA_SET_XOP) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_XOP) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPERMIL2PS ZYDIS_NOTMIN(5) ZYDIS_NOTMIN(5) ZYDIS_NOTMIN(0x18F), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_XOP) ZYDIS_NOTMIN(ZYDIS_ISA_SET_XOP) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_XOP) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPERMIL2PS ZYDIS_NOTMIN(5) ZYDIS_NOTMIN(5) ZYDIS_NOTMIN(0x194), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_XOP) ZYDIS_NOTMIN(ZYDIS_ISA_SET_XOP) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_XOP) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPERMIL2PS ZYDIS_NOTMIN(5) ZYDIS_NOTMIN(5) ZYDIS_NOTMIN(0x199), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_XOP) ZYDIS_NOTMIN(ZYDIS_ISA_SET_XOP) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_XOP) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPERMIL2PS ZYDIS_NOTMIN(5) ZYDIS_NOTMIN(5) ZYDIS_NOTMIN(0x19E), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_XOP) ZYDIS_NOTMIN(ZYDIS_ISA_SET_XOP) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_XOP) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPERMILPD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x12AE), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX6), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPERMILPD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x12B1), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX6), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPERMILPD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x12B4), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX6), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPERMILPD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x12B7), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX6), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPERMILPD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1056), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX6), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPERMILPD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x12BA), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX6), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPERMILPD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1059), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX6), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPERMILPD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x12BD), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX6), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPERMILPS ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x12C0), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX6), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPERMILPS ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x12C3), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX6), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPERMILPS ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x12C6), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX6), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPERMILPS ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x12C9), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX6), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPERMILPS ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x105C), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX6), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPERMILPS ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x12CC), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX6), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPERMILPS ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x105F), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX6), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPERMILPS ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x12CF), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX6), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPERMPD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x12BA), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX2) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX2) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX2) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPERMPD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x12BD), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX2) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX2) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX2) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPERMPS ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x185), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX2) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX2) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX2) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPERMPS ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x199), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX2) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX2) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX2) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPERMQ ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x12D2), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX2) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX2) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX2) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPERMQ ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x12D5), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX2) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX2) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX2) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPEXTRB ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x12D8), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX5), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_GPR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPEXTRB ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x12DB), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX5), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPEXTRD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0xF6C), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX5), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_GPR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPEXTRD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x12DE), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX5), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPEXTRD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0xF6C), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX5), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_GPR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPEXTRD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x12DE), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX5), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPEXTRQ ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x12E1), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX5), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_GPR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPEXTRQ ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x12E4), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX5), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPEXTRW ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x12E7), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX5), ZYDIS_REGKIND_GPR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPEXTRW ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x12EA), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX5), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_GPR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPEXTRW ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x12ED), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX5), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPGATHERDD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x12F0), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX2GATHER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX2GATHER) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX2GATHER) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX12), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_VSIB | (1 << 3) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_TRUE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPGATHERDD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x12F3), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX2GATHER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX2GATHER) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX2GATHER) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX12), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_VSIB | (1 << 3) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_TRUE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPGATHERDQ ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x12F6), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX2GATHER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX2GATHER) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX2GATHER) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX12), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_VSIB | (1 << 3) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_TRUE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPGATHERDQ ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x12F9), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX2GATHER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX2GATHER) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX2GATHER) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX12), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_VSIB | (1 << 3) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_TRUE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPGATHERQD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x12FC), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX2GATHER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX2GATHER) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX2GATHER) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX12), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_VSIB | (1 << 3) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_TRUE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPGATHERQD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x12FF), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX2GATHER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX2GATHER) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX2GATHER) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX12), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_VSIB | (1 << 3) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_TRUE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPGATHERQQ ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x12F6), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX2GATHER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX2GATHER) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX2GATHER) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX12), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_VSIB | (1 << 3) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_TRUE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPGATHERQQ ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1302), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX2GATHER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX2GATHER) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX2GATHER) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX12), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_VSIB | (1 << 3) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_TRUE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPHADDD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x6AC), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPHADDD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1155), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX2) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX2) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX2) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPHADDD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x6B0), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPHADDD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1158), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX2) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX2) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX2) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPHADDSW ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x6DC), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPHADDSW ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1236), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX2) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX2) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX2) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPHADDSW ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x6E0), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPHADDSW ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1239), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX2) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX2) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX2) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPHADDW ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x6DC), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPHADDW ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1236), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX2) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX2) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX2) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPHADDW ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x6E0), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPHADDW ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1239), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX2) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX2) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX2) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPHMINPOSUW ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xFC9), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPHMINPOSUW ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xFCC), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPHSUBD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x6AC), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPHSUBD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1155), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX2) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX2) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX2) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPHSUBD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x6B0), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPHSUBD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1158), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX2) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX2) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX2) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPHSUBSW ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x6DC), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPHSUBSW ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1236), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX2) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX2) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX2) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPHSUBSW ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x6E0), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPHSUBSW ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1239), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX2) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX2) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX2) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPHSUBW ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x6DC), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPHSUBW ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1236), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX2) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX2) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX2) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPHSUBW ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x6E0), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPHSUBW ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1239), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX2) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX2) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX2) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPINSRB ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x848), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX5), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_GPR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPINSRB ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x84C), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX5), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPINSRD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x850), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX5), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_GPR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPINSRD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x854), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX5), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPINSRD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x850), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX5), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_GPR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPINSRD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x854), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX5), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPINSRQ ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x858), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX5), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_GPR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPINSRQ ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x85C), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX5), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPINSRW ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x860), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX5), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_GPR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPINSRW ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x864), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX5), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPMADD52HUQ ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1305), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX_IFMA) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX_IFMA) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX_IFMA) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPMADD52HUQ ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1308), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX_IFMA) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX_IFMA) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX_IFMA) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPMADD52HUQ ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x130B), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX_IFMA) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX_IFMA) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX_IFMA) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPMADD52HUQ ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x130E), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX_IFMA) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX_IFMA) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX_IFMA) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPMADD52LUQ ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1305), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX_IFMA) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX_IFMA) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX_IFMA) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPMADD52LUQ ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1308), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX_IFMA) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX_IFMA) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX_IFMA) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPMADD52LUQ ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x130B), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX_IFMA) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX_IFMA) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX_IFMA) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPMADD52LUQ ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x130E), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX_IFMA) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX_IFMA) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX_IFMA) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPMADDUBSW ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1311), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPMADDUBSW ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1314), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX2) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX2) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX2) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPMADDUBSW ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1317), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPMADDUBSW ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x131A), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX2) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX2) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX2) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPMADDWD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x6F4), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPMADDWD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x131D), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX2) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX2) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX2) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPMADDWD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x6F8), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPMADDWD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1320), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX2) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX2) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX2) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPMASKMOVD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x6C8), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX2) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX2) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX2) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX6), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPMASKMOVD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x814), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX2) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX2) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX2) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX6), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPMASKMOVD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1323), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX2) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX2) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX2) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX6), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPMASKMOVD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1326), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX2) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX2) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX2) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX6), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPMASKMOVQ ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x6D0), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX2) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX2) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX2) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX6), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPMASKMOVQ ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1152), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX2) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX2) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX2) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX6), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPMASKMOVQ ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1329), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX2) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX2) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX2) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX6), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPMASKMOVQ ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x132C), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX2) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX2) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX2) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX6), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPMAXSB ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x6A4), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPMAXSB ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x81C), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX2) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX2) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX2) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPMAXSB ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x6A8), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPMAXSB ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x824), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX2) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX2) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX2) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPMAXSD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x6AC), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPMAXSD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1155), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX2) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX2) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX2) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPMAXSD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x6B0), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPMAXSD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1158), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX2) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX2) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX2) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPMAXSW ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x6DC), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPMAXSW ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1236), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX2) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX2) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX2) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPMAXSW ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x6E0), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPMAXSW ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1239), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX2) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX2) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX2) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPMAXUB ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x6BC), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPMAXUB ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x808), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX2) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX2) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX2) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPMAXUB ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x6C0), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPMAXUB ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x80C), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX2) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX2) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX2) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPMAXUD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x6C4), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPMAXUD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x810), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX2) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX2) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX2) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPMAXUD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x6C8), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPMAXUD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x814), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX2) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX2) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX2) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPMAXUW ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x6D4), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPMAXUW ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x828), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX2) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX2) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX2) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPMAXUW ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x6D8), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPMAXUW ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x82C), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX2) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX2) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX2) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPMINSB ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x6A4), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPMINSB ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x81C), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX2) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX2) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX2) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPMINSB ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x6A8), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPMINSB ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x824), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX2) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX2) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX2) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPMINSD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x6AC), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPMINSD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1155), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX2) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX2) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX2) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPMINSD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x6B0), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPMINSD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1158), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX2) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX2) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX2) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPMINSW ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x6DC), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPMINSW ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1236), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX2) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX2) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX2) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPMINSW ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x6E0), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPMINSW ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1239), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX2) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX2) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX2) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPMINUB ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x6BC), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPMINUB ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x808), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX2) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX2) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX2) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPMINUB ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x6C0), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPMINUB ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x80C), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX2) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX2) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX2) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPMINUD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x6C4), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPMINUD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x810), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX2) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX2) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX2) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPMINUD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x6C8), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPMINUD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x814), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX2) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX2) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX2) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPMINUW ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x6D4), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPMINUW ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x828), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX2) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX2) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX2) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPMINUW ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x6D8), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPMINUW ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x82C), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX2) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX2) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX2) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPMOVMSKB ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1E45), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX7), ZYDIS_REGKIND_GPR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPMOVMSKB ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1E47), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX2) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX2) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX2) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX7), ZYDIS_REGKIND_GPR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPMOVSXBD ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1C8B), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX5), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPMOVSXBD ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1E49), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX2) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX2) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX2) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX5), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPMOVSXBD ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1C8D), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX5), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPMOVSXBD ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1E4B), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX2) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX2) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX2) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX5), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPMOVSXBQ ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1C8F), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX5), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPMOVSXBQ ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1E4D), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX2) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX2) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX2) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX5), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPMOVSXBQ ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1C91), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX5), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPMOVSXBQ ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1E4F), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX2) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX2) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX2) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX5), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPMOVSXBW ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1C93), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX5), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPMOVSXBW ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1E51), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX2) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX2) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX2) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX5), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPMOVSXBW ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1C95), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX5), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPMOVSXBW ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1E53), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX2) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX2) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX2) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX5), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPMOVSXDQ ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1C97), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX5), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPMOVSXDQ ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1E55), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX2) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX2) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX2) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX5), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPMOVSXDQ ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1C99), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX5), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPMOVSXDQ ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1E57), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX2) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX2) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX2) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX5), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPMOVSXWD ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1C9B), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX5), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPMOVSXWD ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1E59), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX2) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX2) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX2) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX5), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPMOVSXWD ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1C9D), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX5), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPMOVSXWD ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1E5B), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX2) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX2) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX2) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX5), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPMOVSXWQ ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1C9F), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX5), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPMOVSXWQ ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1E5D), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX2) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX2) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX2) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX5), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPMOVSXWQ ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1CA1), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX5), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPMOVSXWQ ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1E5F), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX2) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX2) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX2) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX5), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPMOVZXBD ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1CA3), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX5), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPMOVZXBD ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1E61), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX2) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX2) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX2) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX5), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPMOVZXBD ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1CA5), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX5), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPMOVZXBD ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1E63), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX2) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX2) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX2) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX5), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPMOVZXBQ ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1CA7), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX5), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPMOVZXBQ ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1E65), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX2) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX2) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX2) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX5), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPMOVZXBQ ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1CA9), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX5), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPMOVZXBQ ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1E67), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX2) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX2) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX2) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX5), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPMOVZXBW ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1CAB), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX5), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPMOVZXBW ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1E69), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX2) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX2) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX2) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX5), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPMOVZXBW ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1CAD), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX5), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPMOVZXBW ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1E6B), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX2) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX2) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX2) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX5), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPMOVZXDQ ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1CAF), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX5), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPMOVZXDQ ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1E6D), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX2) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX2) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX2) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX5), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPMOVZXDQ ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1CB1), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX5), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPMOVZXDQ ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1E6F), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX2) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX2) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX2) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX5), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPMOVZXWD ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1CB3), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX5), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPMOVZXWD ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1E71), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX2) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX2) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX2) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX5), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPMOVZXWD ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1CB5), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX5), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPMOVZXWD ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1E73), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX2) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX2) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX2) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX5), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPMOVZXWQ ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1CB7), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX5), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPMOVZXWQ ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1E75), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX2) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX2) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX2) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX5), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPMOVZXWQ ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1CB9), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX5), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPMOVZXWQ ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1E77), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX2) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX2) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX2) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX5), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPMULDQ ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x6EC), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPMULDQ ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x132F), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX2) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX2) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX2) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPMULDQ ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x6F0), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPMULDQ ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1332), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX2) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX2) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX2) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPMULHRSW ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x6DC), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPMULHRSW ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1236), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX2) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX2) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX2) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPMULHRSW ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x6E0), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPMULHRSW ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1239), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX2) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX2) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX2) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPMULHUW ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x6D4), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPMULHUW ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x828), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX2) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX2) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX2) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPMULHUW ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x6D8), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPMULHUW ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x82C), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX2) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX2) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX2) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPMULHW ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x6DC), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPMULHW ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1236), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX2) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX2) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX2) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPMULHW ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x6E0), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPMULHW ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1239), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX2) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX2) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX2) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPMULLD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x6AC), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPMULLD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1155), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX2) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX2) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX2) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPMULLD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x6B0), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPMULLD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1158), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX2) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX2) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX2) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPMULLW ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x6DC), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPMULLW ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1236), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX2) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX2) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX2) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPMULLW ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x6E0), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPMULLW ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1239), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX2) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX2) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX2) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPMULUDQ ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1335), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPMULUDQ ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1338), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX2) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX2) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX2) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPMULUDQ ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x133B), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPMULUDQ ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x133E), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX2) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX2) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX2) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPOR ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x123C), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_LOGICAL) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPOR ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x123F), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_LOGICAL) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX2) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX2) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPOR ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1242), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_LOGICAL) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPOR ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1245), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_LOGICAL) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX2) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX2) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPREFETCH0 ZYDIS_NOTMIN(1) ZYDIS_NOTMIN(1) ZYDIS_NOTMIN(0x1F02), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_PREFETCH) ZYDIS_NOTMIN(ZYDIS_ISA_SET_KNCV) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_KNC) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPREFETCH1 ZYDIS_NOTMIN(1) ZYDIS_NOTMIN(1) ZYDIS_NOTMIN(0x1F02), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_PREFETCH) ZYDIS_NOTMIN(ZYDIS_ISA_SET_KNCV) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_KNC) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPREFETCH2 ZYDIS_NOTMIN(1) ZYDIS_NOTMIN(1) ZYDIS_NOTMIN(0x1F02), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_PREFETCH) ZYDIS_NOTMIN(ZYDIS_ISA_SET_KNCV) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_KNC) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPREFETCHE0 ZYDIS_NOTMIN(1) ZYDIS_NOTMIN(1) ZYDIS_NOTMIN(0x1F02), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_PREFETCH) ZYDIS_NOTMIN(ZYDIS_ISA_SET_KNCV) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_KNC) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPREFETCHE1 ZYDIS_NOTMIN(1) ZYDIS_NOTMIN(1) ZYDIS_NOTMIN(0x1F02), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_PREFETCH) ZYDIS_NOTMIN(ZYDIS_ISA_SET_KNCV) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_KNC) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPREFETCHE2 ZYDIS_NOTMIN(1) ZYDIS_NOTMIN(1) ZYDIS_NOTMIN(0x1F02), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_PREFETCH) ZYDIS_NOTMIN(ZYDIS_ISA_SET_KNCV) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_KNC) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPREFETCHENTA ZYDIS_NOTMIN(1) ZYDIS_NOTMIN(1) ZYDIS_NOTMIN(0x1F02), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_PREFETCH) ZYDIS_NOTMIN(ZYDIS_ISA_SET_KNCV) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_KNC) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPREFETCHNTA ZYDIS_NOTMIN(1) ZYDIS_NOTMIN(1) ZYDIS_NOTMIN(0x1F02), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_PREFETCH) ZYDIS_NOTMIN(ZYDIS_ISA_SET_KNCV) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_KNC) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPSADBW ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x7F8), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPSADBW ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x7FC), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX2) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX2) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX2) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPSADBW ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x800), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPSADBW ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x804), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX2) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX2) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX2) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPSHUFB ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x6BC), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPSHUFB ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x808), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX2) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX2) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX2) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPSHUFB ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x6C0), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPSHUFB ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x80C), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX2) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX2) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX2) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPSHUFD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0xFC3), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPSHUFD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1341), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX2) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX2) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX2) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPSHUFD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0xFC6), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPSHUFD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1344), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX2) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX2) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX2) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPSHUFHW ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0xFC3), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPSHUFHW ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1347), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX2) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX2) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX2) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPSHUFHW ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0xFC6), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPSHUFHW ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x134A), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX2) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX2) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX2) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPSHUFLW ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0xFC3), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPSHUFLW ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1347), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX2) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX2) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX2) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPSHUFLW ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0xFC6), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPSHUFLW ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x134A), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX2) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX2) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX2) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPSIGNB ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x6A4), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPSIGNB ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x81C), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX2) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX2) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX2) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPSIGNB ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x6A8), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPSIGNB ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x824), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX2) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX2) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX2) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPSIGND ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x6AC), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPSIGND ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1155), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX2) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX2) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX2) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPSIGND ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x6B0), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPSIGND ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1158), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX2) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX2) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX2) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPSIGNW ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x6DC), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPSIGNW ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1236), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX2) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX2) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX2) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPSIGNW ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x6E0), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPSIGNW ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1239), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX2) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX2) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX2) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPSLLD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x134D), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX7), 0, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPSLLD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1350), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX2) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX2) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX2) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX7), 0, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPSLLD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1353), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX7), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPSLLD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1356), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX2) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX2) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX2) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPSLLD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1359), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX7), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPSLLD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x135C), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX2) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX2) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX2) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPSLLDQ ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x135F), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX7), 0, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPSLLDQ ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1362), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX2) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX2) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX2) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX7), 0, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPSLLQ ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1365), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX7), 0, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPSLLQ ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1368), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX2) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX2) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX2) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX7), 0, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPSLLQ ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x6CC), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX7), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPSLLQ ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x136B), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX2) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX2) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX2) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPSLLQ ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x6D0), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX7), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPSLLQ ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x136E), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX2) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX2) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX2) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPSLLVD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x6C4), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX2) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX2) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX2) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPSLLVD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x810), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX2) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX2) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX2) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPSLLVD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x6C8), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX2) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX2) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX2) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPSLLVD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x814), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX2) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX2) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX2) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPSLLVQ ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x6C4), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX2) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX2) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX2) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPSLLVQ ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x810), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX2) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX2) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX2) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPSLLVQ ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x6C8), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX2) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX2) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX2) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPSLLVQ ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x814), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX2) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX2) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX2) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPSLLW ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1371), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX7), 0, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPSLLW ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1374), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX2) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX2) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX2) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX7), 0, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPSLLW ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1377), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX7), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPSLLW ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x137A), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX2) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX2) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX2) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPSLLW ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x137D), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX7), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPSLLW ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1380), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX2) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX2) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX2) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPSRAD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1383), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX7), 0, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPSRAD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1386), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX2) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX2) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX2) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX7), 0, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPSRAD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1389), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX7), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPSRAD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x138C), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX2) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX2) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX2) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPSRAD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x138F), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX7), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPSRAD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1392), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX2) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX2) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX2) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPSRAVD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1395), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX2) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX2) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX2) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPSRAVD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1398), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX2) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX2) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX2) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPSRAVD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x139B), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX2) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX2) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX2) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPSRAVD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x139E), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX2) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX2) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX2) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPSRAW ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x13A1), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX7), 0, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPSRAW ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x13A4), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX2) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX2) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX2) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX7), 0, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPSRAW ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x13A7), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX7), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPSRAW ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x13AA), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX2) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX2) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX2) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPSRAW ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x13AD), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX7), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPSRAW ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x13B0), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX2) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX2) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX2) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPSRLD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x134D), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX7), 0, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPSRLD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1350), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX2) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX2) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX2) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX7), 0, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPSRLD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1353), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX7), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPSRLD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1356), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX2) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX2) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX2) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPSRLD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1359), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX7), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPSRLD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x135C), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX2) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX2) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX2) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPSRLDQ ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x135F), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX7), 0, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPSRLDQ ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1362), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX2) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX2) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX2) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX7), 0, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPSRLQ ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1365), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX7), 0, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPSRLQ ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1368), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX2) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX2) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX2) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX7), 0, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPSRLQ ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x6CC), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX7), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPSRLQ ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x136B), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX2) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX2) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX2) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPSRLQ ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x6D0), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX7), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPSRLQ ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x136E), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX2) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX2) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX2) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPSRLVD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x6C4), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX2) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX2) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX2) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPSRLVD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x810), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX2) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX2) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX2) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPSRLVD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x6C8), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX2) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX2) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX2) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPSRLVD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x814), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX2) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX2) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX2) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPSRLVQ ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x6C4), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX2) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX2) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX2) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPSRLVQ ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x810), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX2) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX2) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX2) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPSRLVQ ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x6C8), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX2) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX2) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX2) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPSRLVQ ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x814), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX2) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX2) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX2) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPSRLW ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1371), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX7), 0, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPSRLW ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1374), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX2) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX2) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX2) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX7), 0, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPSRLW ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1377), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX7), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPSRLW ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x137A), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX2) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX2) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX2) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPSRLW ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x137D), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX7), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPSRLW ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1380), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX2) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX2) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX2) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPSUBB ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x6A4), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPSUBB ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x81C), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX2) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX2) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX2) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPSUBB ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x6A8), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPSUBB ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x824), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX2) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX2) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX2) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPSUBD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x6AC), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPSUBD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1155), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX2) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX2) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX2) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPSUBD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x6B0), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPSUBD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1158), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX2) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX2) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX2) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPSUBQ ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x6B4), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPSUBQ ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1230), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX2) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX2) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX2) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPSUBQ ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x6B8), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPSUBQ ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1233), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX2) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX2) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX2) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPSUBSB ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x6A4), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPSUBSB ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x81C), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX2) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX2) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX2) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPSUBSB ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x6A8), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPSUBSB ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x824), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX2) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX2) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX2) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPSUBSW ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x6DC), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPSUBSW ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1236), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX2) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX2) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX2) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPSUBSW ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x6E0), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPSUBSW ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1239), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX2) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX2) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX2) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPSUBUSB ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x6BC), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPSUBUSB ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x808), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX2) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX2) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX2) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPSUBUSB ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x6C0), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPSUBUSB ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x80C), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX2) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX2) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX2) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPSUBUSW ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x6D4), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPSUBUSW ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x828), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX2) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX2) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX2) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPSUBUSW ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x6D8), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPSUBUSW ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x82C), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX2) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX2) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX2) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPSUBW ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x6DC), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPSUBW ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1236), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX2) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX2) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX2) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPSUBW ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x6E0), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPSUBW ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1239), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX2) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX2) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX2) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPTEST ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xFD5), 0, 0 ZYDIS_NOTMIN(0x28), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_LOGICAL) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPTEST ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x13B3), 0, 0 ZYDIS_NOTMIN(0x28), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_LOGICAL) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPTEST ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xFD8), 0, 0 ZYDIS_NOTMIN(0x28), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_LOGICAL) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPTEST ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x13B6), 0, 0 ZYDIS_NOTMIN(0x28), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_LOGICAL) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPUNPCKHBW ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x6BC), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPUNPCKHBW ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x808), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX2) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX2) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX2) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPUNPCKHBW ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x6C0), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPUNPCKHBW ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x80C), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX2) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX2) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX2) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPUNPCKHDQ ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x6C4), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPUNPCKHDQ ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x810), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX2) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX2) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX2) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPUNPCKHDQ ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x6C8), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPUNPCKHDQ ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x814), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX2) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX2) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX2) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPUNPCKHQDQ ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x6CC), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPUNPCKHQDQ ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x114F), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX2) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX2) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX2) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPUNPCKHQDQ ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x6D0), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPUNPCKHQDQ ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1152), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX2) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX2) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX2) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPUNPCKHWD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x6D4), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPUNPCKHWD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x828), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX2) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX2) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX2) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPUNPCKHWD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x6D8), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPUNPCKHWD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x82C), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX2) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX2) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX2) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPUNPCKLBW ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x6BC), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPUNPCKLBW ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x808), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX2) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX2) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX2) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPUNPCKLBW ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x6C0), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPUNPCKLBW ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x80C), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX2) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX2) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX2) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPUNPCKLDQ ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x6C4), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPUNPCKLDQ ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x810), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX2) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX2) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX2) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPUNPCKLDQ ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x6C8), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPUNPCKLDQ ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x814), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX2) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX2) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX2) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPUNPCKLQDQ ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x6CC), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPUNPCKLQDQ ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x114F), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX2) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX2) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX2) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPUNPCKLQDQ ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x6D0), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPUNPCKLQDQ ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1152), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX2) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX2) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX2) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPUNPCKLWD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x6D4), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPUNPCKLWD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x828), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX2) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX2) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX2) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPUNPCKLWD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x6D8), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPUNPCKLWD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x82C), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX2) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX2) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX2) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPXOR ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x123C), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_LOGICAL) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPXOR ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x123F), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_LOGICAL) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX2) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX2) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPXOR ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1242), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_LOGICAL) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPXOR ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1245), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_LOGICAL) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX2) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX2) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VRCPPS ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x105C), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VRCPPS ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x12CC), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VRCPPS ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x105F), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VRCPPS ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x12CF), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VRCPSS ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x7AC), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX5), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VRCPSS ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x7B0), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX5), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VROUNDPD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1056), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VROUNDPD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x12BA), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VROUNDPD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1059), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX2), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VROUNDPD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x12BD), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX2), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VROUNDPS ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x105C), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VROUNDPS ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x12CC), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VROUNDPS ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x105F), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX2), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VROUNDPS ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x12CF), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX2), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VROUNDSD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x868), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX3), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VROUNDSD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x86C), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX3), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VROUNDSS ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x870), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX3), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VROUNDSS ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x7F4), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX3), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VRSQRTPS ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x105C), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VRSQRTPS ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x12CC), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VRSQRTPS ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x105F), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VRSQRTPS ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x12CF), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VRSQRTSS ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x7AC), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX5), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VRSQRTSS ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x7B0), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX5), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VSHA512MSG1 ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1E79), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_SHA512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_SHA512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_SHA512) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX6), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VSHA512MSG2 ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1E7B), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_SHA512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_SHA512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_SHA512) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX6), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VSHA512RNDS2 ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x13B9), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_SHA512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_SHA512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_SHA512) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX6), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VSHUFPD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x744), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VSHUFPD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x748), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VSHUFPD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x74C), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VSHUFPD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x750), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VSHUFPS ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x754), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VSHUFPS ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x758), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VSHUFPS ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x75C), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VSHUFPS ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x760), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VSM3MSG1 ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x874), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VEX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_SM3) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_SM3) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VSM3MSG1 ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x878), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VEX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_SM3) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_SM3) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VSM3MSG2 ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x874), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VEX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_SM3) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_SM3) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VSM3MSG2 ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x878), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VEX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_SM3) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_SM3) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VSM3RNDS2 ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x874), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VEX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_SM3) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_SM3) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VSM3RNDS2 ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x878), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VEX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_SM3) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_SM3) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VSM4KEY4 ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x6C4), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VEX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_SM4) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_SM4) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX6), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VSM4KEY4 ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x810), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VEX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_SM4) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_SM4) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX6), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VSM4KEY4 ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x6C8), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VEX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_SM4) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_SM4) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX6), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VSM4KEY4 ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x814), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VEX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_SM4) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_SM4) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX6), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VSM4RNDS4 ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x6C4), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VEX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_SM4) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_SM4) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX6), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VSM4RNDS4 ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x810), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VEX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_SM4) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_SM4) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX6), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VSM4RNDS4 ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x6C8), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VEX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_SM4) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_SM4) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX6), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VSM4RNDS4 ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x814), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VEX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_SM4) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_SM4) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX6), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VSQRTPD ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1056), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VSQRTPD ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x12BA), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VSQRTPD ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1059), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX2), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VSQRTPD ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x12BD), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX2), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VSQRTPS ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x105C), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VSQRTPS ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x12CC), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VSQRTPS ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x105F), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX2), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VSQRTPS ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x12CF), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX2), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VSQRTSD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x7A4), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX3), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VSQRTSD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x7A8), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX3), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VSQRTSS ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x7AC), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX3), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VSQRTSS ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x7B0), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX3), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VSTMXCSR ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(1) ZYDIS_NOTMIN(0x1D2B), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX5), 0, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VSUBPD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x153), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VSUBPD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x15D), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VSUBPD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x167), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX2), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VSUBPD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x171), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX2), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VSUBPS ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x17B), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VSUBPS ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x185), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VSUBPS ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x18F), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX2), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VSUBPS ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x199), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX2), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VSUBSD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x7A4), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX3), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VSUBSD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x7A8), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX3), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VSUBSS ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x7AC), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX3), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VSUBSS ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x7B0), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX3), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VTESTPD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x13BC), 0, 0 ZYDIS_NOTMIN(0x28), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_LOGICAL_FP) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VTESTPD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x13BF), 0, 0 ZYDIS_NOTMIN(0x28), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_LOGICAL_FP) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VTESTPD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x13C2), 0, 0 ZYDIS_NOTMIN(0x28), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_LOGICAL_FP) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VTESTPD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x13C5), 0, 0 ZYDIS_NOTMIN(0x28), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_LOGICAL_FP) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VTESTPS ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x13C8), 0, 0 ZYDIS_NOTMIN(0x28), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_LOGICAL_FP) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VTESTPS ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x13CB), 0, 0 ZYDIS_NOTMIN(0x28), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_LOGICAL_FP) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VTESTPS ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x13CE), 0, 0 ZYDIS_NOTMIN(0x28), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_LOGICAL_FP) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VTESTPS ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x13D1), 0, 0 ZYDIS_NOTMIN(0x28), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_LOGICAL_FP) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VUCOMISD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x13D4), 0, 0 ZYDIS_NOTMIN(0x33), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX3), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VUCOMISD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x13D7), 0, 0 ZYDIS_NOTMIN(0x33), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX3), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VUCOMISS ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x13DA), 0, 0 ZYDIS_NOTMIN(0x33), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX3), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VUCOMISS ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x13DD), 0, 0 ZYDIS_NOTMIN(0x33), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX3), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VUNPCKHPD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x153), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VUNPCKHPD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x15D), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VUNPCKHPD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x167), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VUNPCKHPD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x171), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VUNPCKHPS ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x17B), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VUNPCKHPS ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x185), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VUNPCKHPS ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x18F), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VUNPCKHPS ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x199), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VUNPCKLPD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x153), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VUNPCKLPD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x15D), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VUNPCKLPD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x167), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VUNPCKLPD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x171), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VUNPCKLPS ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x17B), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VUNPCKLPS ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x185), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VUNPCKLPS ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x18F), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VUNPCKLPS ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x199), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VXORPD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x6CC), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_LOGICAL_FP) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VXORPD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x114F), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_LOGICAL_FP) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VXORPD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x6D0), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_LOGICAL_FP) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VXORPD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1152), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_LOGICAL_FP) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VXORPS ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x6AC), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_LOGICAL_FP) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VXORPS ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1155), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_LOGICAL_FP) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VXORPS ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x6B0), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_LOGICAL_FP) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VXORPS ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1158), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_LOGICAL_FP) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VZEROALL ZYDIS_NOTMIN(0) ZYDIS_NOTMIN(0) ZYDIS_NOTMIN(0x0), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX8), 0, 0 ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_WRITE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VZEROUPPER ZYDIS_NOTMIN(0) ZYDIS_NOTMIN(0) ZYDIS_NOTMIN(0x0), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_AVX8), 0, 0 ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_WRITE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_VEX_STATIC_BROADCAST_NONE) }
};

#ifndef ZYDIS_DISABLE_AVX512
const ZydisInstructionDefinitionEVEX ISTR_DEFINITIONS_EVEX[] =
{
    { ZYDIS_MNEMONIC_V4FMADDPS ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x87C), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512_4FMAPS) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_4FMAPS_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_T1_4X) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_32) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_V4FMADDSS ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x880), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512_4FMAPS) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_4FMAPS_SCALAR) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E3), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_FIXED_128) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_T1_4X) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_32) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_V4FNMADDPS ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x87C), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512_4FMAPS) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_4FMAPS_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_T1_4X) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_32) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_V4FNMADDSS ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x880), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512_4FMAPS) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_4FMAPS_SCALAR) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E3), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_FIXED_128) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_T1_4X) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_32) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VADDPD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x4C8), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_FIXED_512) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_RC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VADDPD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x2AC), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VADDPD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x4CD), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VADDPD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x4C8), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VADDPD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x4D2), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_64) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VADDPD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x4D7), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_64) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VADDPD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x4DC), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_64) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VADDPH ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x884), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_FP16) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_FP16_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_FIXED_512) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_RC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VADDPH ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x2B6), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_FP16) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_FP16_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VADDPH ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x888), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_FP16) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_FP16_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VADDPH ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x884), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_FP16) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_FP16_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VADDPH ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x88C), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_FP16) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_FP16_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_16) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VADDPH ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x890), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_FP16) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_FP16_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_16) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VADDPH ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x894), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_FP16) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_FP16_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_16) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VADDPS ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x4E1), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_FIXED_512) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_RC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VADDPS ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x2C0), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VADDPS ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x4E6), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VADDPS ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x4E1), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VADDPS ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x4EB), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_32) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VADDPS ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x4F0), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_32) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VADDPS ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x4F5), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_32) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VADDSD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x2AC), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_SCALAR) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E3), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_FIXED_128) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VADDSD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x2AC), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_SCALAR) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E3), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_FIXED_128) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_RC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VADDSD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x2B1), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_SCALAR) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E3), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_FIXED_128) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_T1S) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_64) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VADDSH ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x2B6), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_FP16) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_FP16_SCALAR) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E3), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_FIXED_128) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VADDSH ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x2B6), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_FP16) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_FP16_SCALAR) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E3), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_FIXED_128) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_RC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VADDSH ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x2BB), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_FP16) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_FP16_SCALAR) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E3), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_FIXED_128) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_T1S) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_16) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VADDSS ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x2C0), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_SCALAR) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E3), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_FIXED_128) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VADDSS ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x2C0), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_SCALAR) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E3), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_FIXED_128) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_RC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VADDSS ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x2C5), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_SCALAR) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E3), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_FIXED_128) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_T1S) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_32) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VAESDEC ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x123C), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VAES) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_VAES_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_FORBIDDEN, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VAESDEC ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x840), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VAES) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_VAES_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_FORBIDDEN, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VAESDEC ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x13E0), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VAES) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_VAES_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_FORBIDDEN, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VAESDEC ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1242), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VAES) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_VAES_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FVM) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_128) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_FORBIDDEN, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VAESDEC ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x844), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VAES) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_VAES_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FVM) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_128) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_FORBIDDEN, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VAESDEC ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x13E3), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VAES) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_VAES_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FVM) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_128) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_FORBIDDEN, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VAESDECLAST ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x123C), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VAES) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_VAES_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_FORBIDDEN, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VAESDECLAST ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x840), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VAES) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_VAES_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_FORBIDDEN, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VAESDECLAST ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x13E0), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VAES) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_VAES_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_FORBIDDEN, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VAESDECLAST ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1242), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VAES) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_VAES_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FVM) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_128) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_FORBIDDEN, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VAESDECLAST ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x844), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VAES) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_VAES_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FVM) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_128) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_FORBIDDEN, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VAESDECLAST ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x13E3), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VAES) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_VAES_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FVM) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_128) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_FORBIDDEN, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VAESENC ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x123C), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VAES) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_VAES_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_FORBIDDEN, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VAESENC ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x840), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VAES) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_VAES_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_FORBIDDEN, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VAESENC ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x13E0), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VAES) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_VAES_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_FORBIDDEN, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VAESENC ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1242), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VAES) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_VAES_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FVM) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_128) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_FORBIDDEN, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VAESENC ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x844), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VAES) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_VAES_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FVM) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_128) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_FORBIDDEN, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VAESENC ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x13E3), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VAES) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_VAES_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FVM) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_128) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_FORBIDDEN, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VAESENCLAST ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x123C), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VAES) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_VAES_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_FORBIDDEN, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VAESENCLAST ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x840), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VAES) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_VAES_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_FORBIDDEN, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VAESENCLAST ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x13E0), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VAES) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_VAES_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_FORBIDDEN, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VAESENCLAST ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1242), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VAES) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_VAES_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FVM) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_128) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_FORBIDDEN, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VAESENCLAST ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x844), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VAES) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_VAES_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FVM) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_128) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_FORBIDDEN, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VAESENCLAST ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x13E3), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VAES) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_VAES_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FVM) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_128) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_FORBIDDEN, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VALIGND ZYDIS_NOTMIN(5) ZYDIS_NOTMIN(5) ZYDIS_NOTMIN(0x1A3), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4NF), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VALIGND ZYDIS_NOTMIN(5) ZYDIS_NOTMIN(5) ZYDIS_NOTMIN(0x1A8), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4NF), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VALIGND ZYDIS_NOTMIN(5) ZYDIS_NOTMIN(5) ZYDIS_NOTMIN(0x1AD), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4NF), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VALIGND ZYDIS_NOTMIN(5) ZYDIS_NOTMIN(5) ZYDIS_NOTMIN(0x1B2), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4NF), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_32) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VALIGND ZYDIS_NOTMIN(5) ZYDIS_NOTMIN(5) ZYDIS_NOTMIN(0x1B7), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4NF), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_32) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VALIGND ZYDIS_NOTMIN(5) ZYDIS_NOTMIN(5) ZYDIS_NOTMIN(0x1BC), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4NF), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_32) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VALIGNQ ZYDIS_NOTMIN(5) ZYDIS_NOTMIN(5) ZYDIS_NOTMIN(0x1C1), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4NF), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VALIGNQ ZYDIS_NOTMIN(5) ZYDIS_NOTMIN(5) ZYDIS_NOTMIN(0x1C6), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4NF), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VALIGNQ ZYDIS_NOTMIN(5) ZYDIS_NOTMIN(5) ZYDIS_NOTMIN(0x1CB), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4NF), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VALIGNQ ZYDIS_NOTMIN(5) ZYDIS_NOTMIN(5) ZYDIS_NOTMIN(0x1D0), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4NF), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_64) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VALIGNQ ZYDIS_NOTMIN(5) ZYDIS_NOTMIN(5) ZYDIS_NOTMIN(0x1D5), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4NF), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_64) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VALIGNQ ZYDIS_NOTMIN(5) ZYDIS_NOTMIN(5) ZYDIS_NOTMIN(0x1DA), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4NF), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_64) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VANDNPD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x2AC), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_LOGICAL_FP) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512DQ_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VANDNPD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x4CD), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_LOGICAL_FP) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512DQ_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VANDNPD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x4C8), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_LOGICAL_FP) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512DQ_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VANDNPD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x4D2), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_LOGICAL_FP) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512DQ_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_64) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VANDNPD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x4D7), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_LOGICAL_FP) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512DQ_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_64) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VANDNPD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x4DC), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_LOGICAL_FP) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512DQ_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_64) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VANDNPS ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x2C0), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_LOGICAL_FP) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512DQ_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VANDNPS ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x4E6), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_LOGICAL_FP) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512DQ_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VANDNPS ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x4E1), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_LOGICAL_FP) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512DQ_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VANDNPS ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x4EB), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_LOGICAL_FP) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512DQ_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_32) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VANDNPS ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x4F0), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_LOGICAL_FP) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512DQ_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_32) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VANDNPS ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x4F5), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_LOGICAL_FP) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512DQ_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_32) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VANDPD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x2AC), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_LOGICAL_FP) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512DQ_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VANDPD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x4CD), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_LOGICAL_FP) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512DQ_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VANDPD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x4C8), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_LOGICAL_FP) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512DQ_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VANDPD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x4D2), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_LOGICAL_FP) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512DQ_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_64) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VANDPD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x4D7), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_LOGICAL_FP) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512DQ_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_64) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VANDPD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x4DC), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_LOGICAL_FP) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512DQ_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_64) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VANDPS ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x2C0), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_LOGICAL_FP) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512DQ_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VANDPS ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x4E6), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_LOGICAL_FP) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512DQ_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VANDPS ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x4E1), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_LOGICAL_FP) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512DQ_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VANDPS ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x4EB), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_LOGICAL_FP) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512DQ_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_32) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VANDPS ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x4F0), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_LOGICAL_FP) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512DQ_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_32) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VANDPS ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x4F5), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_LOGICAL_FP) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512DQ_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_32) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VBLENDMPD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x2AC), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_BLEND) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_CONTROL) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VBLENDMPD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x4CD), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_BLEND) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_CONTROL) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VBLENDMPD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x4C8), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_BLEND) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_CONTROL) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VBLENDMPD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x4D2), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_BLEND) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_64) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_CONTROL) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VBLENDMPD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x4D7), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_BLEND) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_64) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_CONTROL) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VBLENDMPD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x4DC), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_BLEND) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_64) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_CONTROL) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VBLENDMPS ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x2C0), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_BLEND) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_CONTROL) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VBLENDMPS ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x4E6), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_BLEND) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_CONTROL) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VBLENDMPS ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x4E1), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_BLEND) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_CONTROL) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VBLENDMPS ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x4EB), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_BLEND) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_32) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_CONTROL) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VBLENDMPS ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x4F0), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_BLEND) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_32) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_CONTROL) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VBLENDMPS ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x4F5), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_BLEND) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_32) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_CONTROL) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VBROADCASTF32X2 ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x13E6), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_BROADCAST) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512DQ_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E6), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_2_TO_8) },
    { ZYDIS_MNEMONIC_VBROADCASTF32X2 ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x13E9), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_BROADCAST) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512DQ_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E6), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_2_TO_16) },
    { ZYDIS_MNEMONIC_VBROADCASTF32X2 ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x13EC), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_BROADCAST) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512DQ_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E6), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_T2) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_32) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_2_TO_8) },
    { ZYDIS_MNEMONIC_VBROADCASTF32X2 ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x13EF), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_BROADCAST) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512DQ_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E6), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_T2) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_32) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_2_TO_16) },
    { ZYDIS_MNEMONIC_VBROADCASTF32X4 ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x13F2), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_BROADCAST) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E6), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_T4) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_32) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_4_TO_8) },
    { ZYDIS_MNEMONIC_VBROADCASTF32X4 ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x13F5), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_BROADCAST) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E6), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_T4) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_32) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_4_TO_16) },
    { ZYDIS_MNEMONIC_VBROADCASTF32X8 ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x13F8), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_BROADCAST) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512DQ_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E6), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_T8) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_32) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_8_TO_16) },
    { ZYDIS_MNEMONIC_VBROADCASTF64X2 ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x13FB), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_BROADCAST) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512DQ_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E6), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_T2) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_64) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_2_TO_4) },
    { ZYDIS_MNEMONIC_VBROADCASTF64X2 ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x13FE), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_BROADCAST) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512DQ_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E6), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_T2) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_64) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_2_TO_8) },
    { ZYDIS_MNEMONIC_VBROADCASTF64X4 ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1401), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_BROADCAST) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E6), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_T4) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_64) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_4_TO_8) },
    { ZYDIS_MNEMONIC_VBROADCASTI32X2 ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0xBF0), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_BROADCAST) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512DQ_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E6), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_2_TO_4) },
    { ZYDIS_MNEMONIC_VBROADCASTI32X2 ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1404), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_BROADCAST) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512DQ_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E6), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_2_TO_8) },
    { ZYDIS_MNEMONIC_VBROADCASTI32X2 ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1407), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_BROADCAST) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512DQ_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E6), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_2_TO_16) },
    { ZYDIS_MNEMONIC_VBROADCASTI32X2 ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x140A), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_BROADCAST) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512DQ_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E6), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_T2) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_32) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_2_TO_4) },
    { ZYDIS_MNEMONIC_VBROADCASTI32X2 ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x140D), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_BROADCAST) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512DQ_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E6), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_T2) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_32) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_2_TO_8) },
    { ZYDIS_MNEMONIC_VBROADCASTI32X2 ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1410), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_BROADCAST) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512DQ_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E6), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_T2) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_32) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_2_TO_16) },
    { ZYDIS_MNEMONIC_VBROADCASTI32X4 ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1413), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_BROADCAST) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E6), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_T4) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_32) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_4_TO_8) },
    { ZYDIS_MNEMONIC_VBROADCASTI32X4 ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1416), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_BROADCAST) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E6), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_T4) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_32) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_4_TO_16) },
    { ZYDIS_MNEMONIC_VBROADCASTI32X8 ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1419), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_BROADCAST) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512DQ_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E6), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_T8) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_32) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_8_TO_16) },
    { ZYDIS_MNEMONIC_VBROADCASTI64X2 ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x141C), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_BROADCAST) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512DQ_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E6), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_T2) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_64) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_2_TO_4) },
    { ZYDIS_MNEMONIC_VBROADCASTI64X2 ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x141F), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_BROADCAST) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512DQ_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E6), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_T2) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_64) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_2_TO_8) },
    { ZYDIS_MNEMONIC_VBROADCASTI64X4 ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1422), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_BROADCAST) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E6), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_T4) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_64) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_4_TO_8) },
    { ZYDIS_MNEMONIC_VBROADCASTSD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1425), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_BROADCAST) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E6), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_1_TO_4) },
    { ZYDIS_MNEMONIC_VBROADCASTSD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1428), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_BROADCAST) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E6), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_1_TO_8) },
    { ZYDIS_MNEMONIC_VBROADCASTSD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x142B), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_BROADCAST) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E6), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_T1F) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_64) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_1_TO_4) },
    { ZYDIS_MNEMONIC_VBROADCASTSD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x142E), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_BROADCAST) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E6), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_T1F) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_64) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_1_TO_8) },
    { ZYDIS_MNEMONIC_VBROADCASTSS ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0xA34), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_BROADCAST) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E6), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_1_TO_4) },
    { ZYDIS_MNEMONIC_VBROADCASTSS ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x13E6), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_BROADCAST) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E6), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_1_TO_8) },
    { ZYDIS_MNEMONIC_VBROADCASTSS ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x13E9), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_BROADCAST) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E6), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_1_TO_16) },
    { ZYDIS_MNEMONIC_VBROADCASTSS ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1431), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_BROADCAST) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E6), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_T1F) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_32) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_1_TO_4) },
    { ZYDIS_MNEMONIC_VBROADCASTSS ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1434), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_BROADCAST) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E6), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_T1F) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_32) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_1_TO_8) },
    { ZYDIS_MNEMONIC_VBROADCASTSS ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1437), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_BROADCAST) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E6), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_T1F) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_32) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_1_TO_16) },
    { ZYDIS_MNEMONIC_VCMPPD ZYDIS_NOTMIN(5) ZYDIS_NOTMIN(5) ZYDIS_NOTMIN(0x1DF), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_MASK, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_FIXED_512) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_SAE), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_ZEROING) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCMPPD ZYDIS_NOTMIN(5) ZYDIS_NOTMIN(5) ZYDIS_NOTMIN(0x1E4), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_MASK, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_ZEROING) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCMPPD ZYDIS_NOTMIN(5) ZYDIS_NOTMIN(5) ZYDIS_NOTMIN(0x1E9), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_MASK, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_ZEROING) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCMPPD ZYDIS_NOTMIN(5) ZYDIS_NOTMIN(5) ZYDIS_NOTMIN(0x1DF), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_MASK, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_ZEROING) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCMPPD ZYDIS_NOTMIN(5) ZYDIS_NOTMIN(5) ZYDIS_NOTMIN(0x1EE), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_MASK, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_64) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_ZEROING) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCMPPD ZYDIS_NOTMIN(5) ZYDIS_NOTMIN(5) ZYDIS_NOTMIN(0x1F3), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_MASK, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_64) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_ZEROING) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCMPPD ZYDIS_NOTMIN(5) ZYDIS_NOTMIN(5) ZYDIS_NOTMIN(0x1F8), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_MASK, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_64) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_ZEROING) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCMPPH ZYDIS_NOTMIN(5) ZYDIS_NOTMIN(5) ZYDIS_NOTMIN(0x1FD), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_FP16) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_FP16_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_MASK, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_FIXED_512) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_SAE), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCMPPH ZYDIS_NOTMIN(5) ZYDIS_NOTMIN(5) ZYDIS_NOTMIN(0x202), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_FP16) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_FP16_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_MASK, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCMPPH ZYDIS_NOTMIN(5) ZYDIS_NOTMIN(5) ZYDIS_NOTMIN(0x207), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_FP16) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_FP16_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_MASK, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCMPPH ZYDIS_NOTMIN(5) ZYDIS_NOTMIN(5) ZYDIS_NOTMIN(0x1FD), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_FP16) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_FP16_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_MASK, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCMPPH ZYDIS_NOTMIN(5) ZYDIS_NOTMIN(5) ZYDIS_NOTMIN(0x20C), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_FP16) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_FP16_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_MASK, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_16) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCMPPH ZYDIS_NOTMIN(5) ZYDIS_NOTMIN(5) ZYDIS_NOTMIN(0x211), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_FP16) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_FP16_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_MASK, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_16) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCMPPH ZYDIS_NOTMIN(5) ZYDIS_NOTMIN(5) ZYDIS_NOTMIN(0x216), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_FP16) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_FP16_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_MASK, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_16) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCMPPS ZYDIS_NOTMIN(5) ZYDIS_NOTMIN(5) ZYDIS_NOTMIN(0x21B), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_MASK, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_FIXED_512) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_SAE), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_ZEROING) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCMPPS ZYDIS_NOTMIN(5) ZYDIS_NOTMIN(5) ZYDIS_NOTMIN(0x220), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_MASK, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_ZEROING) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCMPPS ZYDIS_NOTMIN(5) ZYDIS_NOTMIN(5) ZYDIS_NOTMIN(0x225), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_MASK, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_ZEROING) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCMPPS ZYDIS_NOTMIN(5) ZYDIS_NOTMIN(5) ZYDIS_NOTMIN(0x21B), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_MASK, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_ZEROING) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCMPPS ZYDIS_NOTMIN(5) ZYDIS_NOTMIN(5) ZYDIS_NOTMIN(0x22A), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_MASK, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_32) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_ZEROING) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCMPPS ZYDIS_NOTMIN(5) ZYDIS_NOTMIN(5) ZYDIS_NOTMIN(0x22F), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_MASK, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_32) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_ZEROING) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCMPPS ZYDIS_NOTMIN(5) ZYDIS_NOTMIN(5) ZYDIS_NOTMIN(0x234), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_MASK, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_32) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_ZEROING) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCMPSD ZYDIS_NOTMIN(5) ZYDIS_NOTMIN(5) ZYDIS_NOTMIN(0x1E4), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_SCALAR) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E3), ZYDIS_REGKIND_MASK, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_FIXED_128) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_ZEROING) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCMPSD ZYDIS_NOTMIN(5) ZYDIS_NOTMIN(5) ZYDIS_NOTMIN(0x1E4), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_SCALAR) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E3), ZYDIS_REGKIND_MASK, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_FIXED_128) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_SAE), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_ZEROING) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCMPSD ZYDIS_NOTMIN(5) ZYDIS_NOTMIN(5) ZYDIS_NOTMIN(0x239), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_SCALAR) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E3), ZYDIS_REGKIND_MASK, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_FIXED_128) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_T1S) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_64) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_ZEROING) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCMPSH ZYDIS_NOTMIN(5) ZYDIS_NOTMIN(5) ZYDIS_NOTMIN(0x202), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_FP16) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_FP16_SCALAR) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E3), ZYDIS_REGKIND_MASK, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_FIXED_128) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCMPSH ZYDIS_NOTMIN(5) ZYDIS_NOTMIN(5) ZYDIS_NOTMIN(0x202), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_FP16) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_FP16_SCALAR) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E3), ZYDIS_REGKIND_MASK, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_FIXED_128) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_SAE), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCMPSH ZYDIS_NOTMIN(5) ZYDIS_NOTMIN(5) ZYDIS_NOTMIN(0x23E), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_FP16) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_FP16_SCALAR) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E3), ZYDIS_REGKIND_MASK, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_FIXED_128) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_T1S) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_16) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCMPSS ZYDIS_NOTMIN(5) ZYDIS_NOTMIN(5) ZYDIS_NOTMIN(0x220), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_SCALAR) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E3), ZYDIS_REGKIND_MASK, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_FIXED_128) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_ZEROING) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCMPSS ZYDIS_NOTMIN(5) ZYDIS_NOTMIN(5) ZYDIS_NOTMIN(0x220), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_SCALAR) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E3), ZYDIS_REGKIND_MASK, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_FIXED_128) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_SAE), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_ZEROING) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCMPSS ZYDIS_NOTMIN(5) ZYDIS_NOTMIN(5) ZYDIS_NOTMIN(0x243), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_SCALAR) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E3), ZYDIS_REGKIND_MASK, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_FIXED_128) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_T1S) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_32) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_ZEROING) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCOMISD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x13BC), 0, 0 ZYDIS_NOTMIN(0x33), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_SCALAR) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E3NF), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_FIXED_128) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_FORBIDDEN, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCOMISD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x13BC), 0, 0 ZYDIS_NOTMIN(0x33), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_SCALAR) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E3NF), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_FIXED_128) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_SAE), ZYDIS_MASK_POLICY_FORBIDDEN, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCOMISD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x13D7), 0, 0 ZYDIS_NOTMIN(0x33), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_SCALAR) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E3NF), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_FIXED_128) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_T1S) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_64) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_FORBIDDEN, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCOMISH ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x143A), 0, 0 ZYDIS_NOTMIN(0x33), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_FP16) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_FP16_SCALAR) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E3NF), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_FIXED_128) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_FORBIDDEN, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCOMISH ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x143A), 0, 0 ZYDIS_NOTMIN(0x33), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_FP16) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_FP16_SCALAR) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E3NF), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_FIXED_128) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_SAE), ZYDIS_MASK_POLICY_FORBIDDEN, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCOMISH ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x143D), 0, 0 ZYDIS_NOTMIN(0x33), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_FP16) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_FP16_SCALAR) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E3NF), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_FIXED_128) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_T1S) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_16) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_FORBIDDEN, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCOMISS ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x13C8), 0, 0 ZYDIS_NOTMIN(0x33), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_SCALAR) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E3NF), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_FIXED_128) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_FORBIDDEN, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCOMISS ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x13C8), 0, 0 ZYDIS_NOTMIN(0x33), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_SCALAR) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E3NF), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_FIXED_128) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_SAE), ZYDIS_MASK_POLICY_FORBIDDEN, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCOMISS ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x13DD), 0, 0 ZYDIS_NOTMIN(0x33), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_SCALAR) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E3NF), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_FIXED_128) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_T1S) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_32) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_FORBIDDEN, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCOMPRESSPD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1440), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_COMPRESS) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCOMPRESSPD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1443), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_COMPRESS) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCOMPRESSPD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1446), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_COMPRESS) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCOMPRESSPD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1449), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_COMPRESS) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_GSCAT) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_64) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCOMPRESSPD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x144C), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_COMPRESS) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_GSCAT) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_64) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCOMPRESSPD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x144F), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_COMPRESS) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_GSCAT) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_64) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCOMPRESSPS ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1452), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_COMPRESS) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCOMPRESSPS ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1455), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_COMPRESS) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCOMPRESSPS ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1458), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_COMPRESS) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCOMPRESSPS ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x145B), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_COMPRESS) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_GSCAT) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_32) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCOMPRESSPS ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x145E), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_COMPRESS) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_GSCAT) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_32) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCOMPRESSPS ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1461), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_COMPRESS) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_GSCAT) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_32) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTDQ2PD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1464), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E5), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_FIXED_512) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTDQ2PD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1467), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E5), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTDQ2PD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x146A), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E5), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTDQ2PD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1464), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E5), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTDQ2PD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x146D), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E5), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_HV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_32) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTDQ2PD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1470), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E5), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_HV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_32) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTDQ2PD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1473), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E5), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_HV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_32) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTDQ2PH ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1476), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_FP16_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_FIXED_512) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_RC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTDQ2PH ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1479), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_FP16_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTDQ2PH ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x147C), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_FP16_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTDQ2PH ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1476), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_FP16_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTDQ2PH ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x147F), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_FP16_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_32) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTDQ2PH ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x147F), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_FP16_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_32) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTDQ2PH ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1482), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_FP16_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_32) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTDQ2PS ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1485), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_FIXED_512) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_RC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTDQ2PS ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1488), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTDQ2PS ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x148B), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTDQ2PS ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1485), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTDQ2PS ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x148E), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_32) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTDQ2PS ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1491), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_32) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTDQ2PS ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1494), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_32) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTNE2PS2BF16 ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x898), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_BF16_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTNE2PS2BF16 ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x89C), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_BF16_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTNE2PS2BF16 ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x8A0), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_BF16_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTNE2PS2BF16 ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x8A4), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_BF16_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_32) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTNE2PS2BF16 ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x8A8), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_BF16_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_32) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTNE2PS2BF16 ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x8AC), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_BF16_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_32) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTNEPS2BF16 ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1497), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_BF16_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTNEPS2BF16 ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x149A), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_BF16_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTNEPS2BF16 ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x149D), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_BF16_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTNEPS2BF16 ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x14A0), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_BF16_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_32) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTNEPS2BF16 ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x14A0), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_BF16_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_32) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTNEPS2BF16 ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x14A3), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_BF16_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_32) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTPD2DQ ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x14A6), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_FIXED_512) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_RC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTPD2DQ ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x14A9), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTPD2DQ ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x14AC), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTPD2DQ ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x14A6), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTPD2DQ ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x14AF), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_64) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTPD2DQ ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x14AF), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_64) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTPD2DQ ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x14B2), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_64) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTPD2PH ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x14B5), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_FP16_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_FIXED_512) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_RC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTPD2PH ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x14B8), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_FP16_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTPD2PH ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x14BB), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_FP16_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTPD2PH ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x14B5), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_FP16_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTPD2PH ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x14BE), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_FP16_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_64) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTPD2PH ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x14BE), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_FP16_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_64) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTPD2PH ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x14BE), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_FP16_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_64) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTPD2PS ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x14C1), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_FIXED_512) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_RC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTPD2PS ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x14C4), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTPD2PS ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x14C7), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTPD2PS ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x14C1), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTPD2PS ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x14CA), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_64) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTPD2PS ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x14CA), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_64) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTPD2PS ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x14CD), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_64) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTPD2QQ ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x14D0), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512DQ_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_FIXED_512) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_RC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTPD2QQ ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x14D3), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512DQ_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTPD2QQ ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x14D6), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512DQ_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTPD2QQ ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x14D0), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512DQ_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTPD2QQ ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x14D9), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512DQ_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_64) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTPD2QQ ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x14DC), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512DQ_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_64) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTPD2QQ ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x14DF), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512DQ_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_64) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTPD2UDQ ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x14E2), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_FIXED_512) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_RC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTPD2UDQ ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x14E5), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTPD2UDQ ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x14E8), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTPD2UDQ ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x14E2), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTPD2UDQ ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x14EB), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_64) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTPD2UDQ ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x14EB), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_64) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTPD2UDQ ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x14EE), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_64) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTPD2UQQ ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x14F1), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512DQ_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_FIXED_512) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_RC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTPD2UQQ ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x14F4), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512DQ_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTPD2UQQ ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x14F7), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512DQ_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTPD2UQQ ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x14F1), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512DQ_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTPD2UQQ ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x14FA), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512DQ_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_64) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTPD2UQQ ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x14FD), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512DQ_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_64) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTPD2UQQ ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1500), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512DQ_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_64) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTPH2DQ ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1503), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_FP16_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_FIXED_512) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_RC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTPH2DQ ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1506), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_FP16_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTPH2DQ ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1509), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_FP16_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTPH2DQ ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1503), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_FP16_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTPH2DQ ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x150C), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_FP16_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_HV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_16) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTPH2DQ ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x150F), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_FP16_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_HV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_16) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTPH2DQ ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1512), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_FP16_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_HV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_16) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTPH2PD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1515), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_FP16_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_FIXED_512) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_SAE), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTPH2PD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1518), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_FP16_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTPH2PD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x151B), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_FP16_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTPH2PD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1515), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_FP16_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTPH2PD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x151E), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_FP16_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_QUARTER) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_16) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTPH2PD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1521), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_FP16_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_QUARTER) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_16) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTPH2PD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1524), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_FP16_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_QUARTER) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_16) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTPH2PS ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1527), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E11), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_FIXED_512) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_SAE), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTPH2PS ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x152A), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E11), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTPH2PS ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x152D), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E11), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTPH2PS ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1527), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E11), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTPH2PS ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1530), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E11), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_HVM) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_16) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTPH2PS ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1533), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E11), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_HVM) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_16) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTPH2PS ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1536), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E11), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_HVM) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_16) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTPH2PSX ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1527), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_FP16_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_FIXED_512) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_SAE), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTPH2PSX ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x152A), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_FP16_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTPH2PSX ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x152D), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_FP16_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTPH2PSX ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1527), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_FP16_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTPH2PSX ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1539), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_FP16_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_HV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_16) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTPH2PSX ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x153C), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_FP16_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_HV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_16) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTPH2PSX ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x153F), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_FP16_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_HV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_16) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTPH2QQ ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1542), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_FP16_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_FIXED_512) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_RC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTPH2QQ ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1545), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_FP16_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTPH2QQ ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1548), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_FP16_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTPH2QQ ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1542), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_FP16_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTPH2QQ ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x154B), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_FP16_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_QUARTER) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_16) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTPH2QQ ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x154E), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_FP16_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_QUARTER) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_16) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTPH2QQ ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1551), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_FP16_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_QUARTER) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_16) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTPH2UDQ ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1554), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_FP16_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_FIXED_512) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_RC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTPH2UDQ ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1557), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_FP16_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTPH2UDQ ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x155A), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_FP16_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTPH2UDQ ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1554), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_FP16_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTPH2UDQ ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x155D), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_FP16_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_HV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_16) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTPH2UDQ ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1560), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_FP16_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_HV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_16) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTPH2UDQ ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1563), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_FP16_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_HV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_16) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTPH2UQQ ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1566), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_FP16_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_FIXED_512) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_RC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTPH2UQQ ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1569), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_FP16_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTPH2UQQ ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x156C), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_FP16_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTPH2UQQ ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1566), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_FP16_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTPH2UQQ ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x156F), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_FP16_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_QUARTER) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_16) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTPH2UQQ ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1572), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_FP16_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_QUARTER) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_16) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTPH2UQQ ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1575), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_FP16_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_QUARTER) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_16) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTPH2UW ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1578), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_FP16_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_FIXED_512) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_RC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTPH2UW ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x157B), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_FP16_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTPH2UW ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x157E), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_FP16_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTPH2UW ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1578), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_FP16_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTPH2UW ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1581), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_FP16_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_16) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTPH2UW ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1584), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_FP16_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_16) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTPH2UW ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1587), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_FP16_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_16) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTPH2W ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x158A), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_FP16_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_FIXED_512) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_RC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTPH2W ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x158D), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_FP16_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTPH2W ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1590), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_FP16_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTPH2W ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x158A), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_FP16_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTPH2W ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1593), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_FP16_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_16) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTPH2W ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1596), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_FP16_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_16) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTPH2W ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1599), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_FP16_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_16) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTPS2DQ ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x159C), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_FIXED_512) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_RC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTPS2DQ ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x159F), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTPS2DQ ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x15A2), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTPS2DQ ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x159C), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTPS2DQ ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x15A5), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_32) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTPS2DQ ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x15A8), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_32) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTPS2DQ ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x15AB), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_32) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTPS2PD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x15AE), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E3), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_FIXED_512) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_SAE), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTPS2PD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x15B1), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E3), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTPS2PD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x15B4), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E3), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTPS2PD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x15AE), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E3), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTPS2PD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x15B7), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E3), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_HV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_32) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTPS2PD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x15BA), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E3), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_HV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_32) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTPS2PD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x15BD), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E3), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_HV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_32) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTPS2PH ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x8B0), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E11), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_FIXED_512) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_SAE), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTPS2PH ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x8B4), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E11), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTPS2PH ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x8B8), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E11), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTPS2PH ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x8B0), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E11), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTPS2PH ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x8BC), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E11), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_HVM) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_16) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTPS2PH ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x8C0), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E11), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_HVM) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_16) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTPS2PH ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x8C4), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E11), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_HVM) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_16) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTPS2PHX ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x15C0), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_FP16_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_FIXED_512) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_RC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTPS2PHX ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x15C3), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_FP16_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTPS2PHX ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x15C6), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_FP16_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTPS2PHX ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x15C0), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_FP16_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTPS2PHX ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x15C9), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_FP16_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_32) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTPS2PHX ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x15C9), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_FP16_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_32) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTPS2PHX ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x15CC), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_FP16_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_32) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTPS2QQ ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x15CF), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512DQ_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E3), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_FIXED_512) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_RC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTPS2QQ ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x15D2), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512DQ_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E3), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTPS2QQ ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x15D5), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512DQ_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E3), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTPS2QQ ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x15CF), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512DQ_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E3), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTPS2QQ ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x15D8), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512DQ_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E3), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_HV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_32) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTPS2QQ ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x15DB), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512DQ_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E3), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_HV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_32) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTPS2QQ ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x15DE), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512DQ_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E3), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_HV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_32) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTPS2UDQ ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x15E1), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_FIXED_512) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_RC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTPS2UDQ ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x15E4), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTPS2UDQ ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x15E7), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTPS2UDQ ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x15E1), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTPS2UDQ ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x15EA), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_32) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTPS2UDQ ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x15ED), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_32) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTPS2UDQ ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x15F0), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_32) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTPS2UQQ ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x15F3), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512DQ_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E3), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_FIXED_512) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_RC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTPS2UQQ ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x15F6), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512DQ_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E3), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTPS2UQQ ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x15F9), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512DQ_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E3), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTPS2UQQ ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x15F3), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512DQ_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E3), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTPS2UQQ ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x15FC), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512DQ_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E3), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_HV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_32) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTPS2UQQ ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x15FF), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512DQ_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E3), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_HV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_32) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTPS2UQQ ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1602), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512DQ_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E3), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_HV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_32) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTQQ2PD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x14D0), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512DQ_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_FIXED_512) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_RC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTQQ2PD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x14D3), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512DQ_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTQQ2PD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x14D6), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512DQ_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTQQ2PD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x14D0), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512DQ_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTQQ2PD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x14D9), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512DQ_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_64) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTQQ2PD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x14DC), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512DQ_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_64) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTQQ2PD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x14DF), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512DQ_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_64) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTQQ2PH ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1605), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_FP16_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_FIXED_512) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_RC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTQQ2PH ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1608), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_FP16_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTQQ2PH ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x160B), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_FP16_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTQQ2PH ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1605), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_FP16_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTQQ2PH ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x160E), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_FP16_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_64) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTQQ2PH ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x160E), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_FP16_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_64) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTQQ2PH ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x160E), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_FP16_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_64) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTQQ2PS ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1611), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512DQ_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_FIXED_512) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_RC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTQQ2PS ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1614), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512DQ_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTQQ2PS ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1617), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512DQ_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTQQ2PS ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1611), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512DQ_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTQQ2PS ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x161A), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512DQ_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_64) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTQQ2PS ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x161A), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512DQ_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_64) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTQQ2PS ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x161D), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512DQ_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_64) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTSD2SH ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x8C8), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_FP16_SCALAR) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E3), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_FIXED_128) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTSD2SH ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x8C8), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_FP16_SCALAR) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E3), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_FIXED_128) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_RC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTSD2SH ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x8CC), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_FP16_SCALAR) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E3), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_FIXED_128) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_T1S) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_64) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTSD2SI ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1E03), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_SCALAR) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E3NF), ZYDIS_REGKIND_GPR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_FIXED_128) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_FORBIDDEN, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTSD2SI ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1E03), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_SCALAR) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E3NF), ZYDIS_REGKIND_GPR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_FIXED_128) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_RC), ZYDIS_MASK_POLICY_FORBIDDEN, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTSD2SI ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1B43), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_SCALAR) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E3NF), ZYDIS_REGKIND_GPR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_FIXED_128) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_T1F) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_64) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_FORBIDDEN, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTSD2SI ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1E7D), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_SCALAR) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E3NF), ZYDIS_REGKIND_GPR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_FIXED_128) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_FORBIDDEN, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTSD2SI ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1E7D), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_SCALAR) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E3NF), ZYDIS_REGKIND_GPR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_FIXED_128) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_RC), ZYDIS_MASK_POLICY_FORBIDDEN, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTSD2SI ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1B45), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_SCALAR) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E3NF), ZYDIS_REGKIND_GPR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_FIXED_128) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_T1F) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_64) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_FORBIDDEN, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTSD2SI ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1E03), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_SCALAR) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E3NF), ZYDIS_REGKIND_GPR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_FIXED_128) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_FORBIDDEN, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTSD2SI ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1E03), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_SCALAR) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E3NF), ZYDIS_REGKIND_GPR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_FIXED_128) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_RC), ZYDIS_MASK_POLICY_FORBIDDEN, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTSD2SI ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1B43), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_SCALAR) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E3NF), ZYDIS_REGKIND_GPR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_FIXED_128) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_T1F) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_64) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_FORBIDDEN, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTSD2SS ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x8D0), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_SCALAR) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E3), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_FIXED_128) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTSD2SS ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x8D0), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_SCALAR) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E3), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_FIXED_128) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_RC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTSD2SS ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x8D4), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_SCALAR) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E3), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_FIXED_128) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_T1S) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_64) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTSD2USI ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1E7F), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_SCALAR) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E3NF), ZYDIS_REGKIND_GPR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_FIXED_128) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_FORBIDDEN, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTSD2USI ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1E7F), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_SCALAR) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E3NF), ZYDIS_REGKIND_GPR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_FIXED_128) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_RC), ZYDIS_MASK_POLICY_FORBIDDEN, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTSD2USI ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1E81), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_SCALAR) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E3NF), ZYDIS_REGKIND_GPR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_FIXED_128) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_T1F) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_64) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_FORBIDDEN, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTSD2USI ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1E83), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_SCALAR) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E3NF), ZYDIS_REGKIND_GPR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_FIXED_128) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_FORBIDDEN, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTSD2USI ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1E83), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_SCALAR) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E3NF), ZYDIS_REGKIND_GPR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_FIXED_128) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_RC), ZYDIS_MASK_POLICY_FORBIDDEN, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTSD2USI ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1E85), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_SCALAR) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E3NF), ZYDIS_REGKIND_GPR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_FIXED_128) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_T1F) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_64) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_FORBIDDEN, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTSD2USI ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1E7F), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_SCALAR) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E3NF), ZYDIS_REGKIND_GPR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_FIXED_128) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_FORBIDDEN, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTSD2USI ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1E7F), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_SCALAR) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E3NF), ZYDIS_REGKIND_GPR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_FIXED_128) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_RC), ZYDIS_MASK_POLICY_FORBIDDEN, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTSD2USI ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1E81), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_SCALAR) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E3NF), ZYDIS_REGKIND_GPR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_FIXED_128) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_T1F) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_64) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_FORBIDDEN, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTSH2SD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x8D8), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_FP16_SCALAR) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E3), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_FIXED_128) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTSH2SD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x8D8), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_FP16_SCALAR) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E3), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_FIXED_128) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_SAE), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTSH2SD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x8DC), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_FP16_SCALAR) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E3), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_FIXED_128) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_T1S) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_16) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTSH2SI ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1E87), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_FP16_SCALAR) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E3NF), ZYDIS_REGKIND_GPR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_FIXED_128) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_FORBIDDEN, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTSH2SI ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1E87), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_FP16_SCALAR) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E3NF), ZYDIS_REGKIND_GPR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_FIXED_128) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_RC), ZYDIS_MASK_POLICY_FORBIDDEN, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTSH2SI ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1E89), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_FP16_SCALAR) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E3NF), ZYDIS_REGKIND_GPR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_FIXED_128) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_FORBIDDEN, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTSH2SI ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1E89), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_FP16_SCALAR) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E3NF), ZYDIS_REGKIND_GPR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_FIXED_128) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_RC), ZYDIS_MASK_POLICY_FORBIDDEN, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTSH2SI ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1E8B), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_FP16_SCALAR) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E3NF), ZYDIS_REGKIND_GPR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_FIXED_128) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_T1F) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_16) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_FORBIDDEN, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTSH2SI ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1E8D), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_FP16_SCALAR) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E3NF), ZYDIS_REGKIND_GPR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_FIXED_128) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_T1F) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_16) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_FORBIDDEN, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTSH2SI ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1E87), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_FP16_SCALAR) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E3NF), ZYDIS_REGKIND_GPR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_FIXED_128) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_FORBIDDEN, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTSH2SI ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1E87), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_FP16_SCALAR) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E3NF), ZYDIS_REGKIND_GPR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_FIXED_128) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_RC), ZYDIS_MASK_POLICY_FORBIDDEN, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTSH2SI ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1E8B), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_FP16_SCALAR) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E3NF), ZYDIS_REGKIND_GPR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_FIXED_128) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_T1F) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_16) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_FORBIDDEN, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTSH2SS ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x8E0), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_FP16_SCALAR) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E3), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_FIXED_128) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTSH2SS ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x8E0), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_FP16_SCALAR) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E3), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_FIXED_128) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_SAE), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTSH2SS ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x8E4), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_FP16_SCALAR) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E3), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_FIXED_128) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_T1S) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_16) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTSH2USI ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1E8F), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_FP16_SCALAR) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E3NF), ZYDIS_REGKIND_GPR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_FIXED_128) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_FORBIDDEN, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTSH2USI ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1E8F), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_FP16_SCALAR) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E3NF), ZYDIS_REGKIND_GPR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_FIXED_128) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_RC), ZYDIS_MASK_POLICY_FORBIDDEN, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTSH2USI ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1E91), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_FP16_SCALAR) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E3NF), ZYDIS_REGKIND_GPR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_FIXED_128) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_FORBIDDEN, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTSH2USI ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1E91), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_FP16_SCALAR) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E3NF), ZYDIS_REGKIND_GPR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_FIXED_128) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_RC), ZYDIS_MASK_POLICY_FORBIDDEN, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTSH2USI ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1E93), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_FP16_SCALAR) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E3NF), ZYDIS_REGKIND_GPR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_FIXED_128) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_T1F) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_16) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_FORBIDDEN, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTSH2USI ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1E95), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_FP16_SCALAR) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E3NF), ZYDIS_REGKIND_GPR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_FIXED_128) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_T1F) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_16) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_FORBIDDEN, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTSH2USI ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1E8F), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_FP16_SCALAR) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E3NF), ZYDIS_REGKIND_GPR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_FIXED_128) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_FORBIDDEN, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTSH2USI ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1E8F), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_FP16_SCALAR) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E3NF), ZYDIS_REGKIND_GPR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_FIXED_128) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_RC), ZYDIS_MASK_POLICY_FORBIDDEN, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTSH2USI ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1E93), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_FP16_SCALAR) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E3NF), ZYDIS_REGKIND_GPR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_FIXED_128) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_T1F) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_16) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_FORBIDDEN, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTSI2SD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x116D), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_SCALAR) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E10NF), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_GPR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_FIXED_128) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_FORBIDDEN, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTSI2SD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1173), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_SCALAR) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E10NF), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_FIXED_128) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_T1S) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_32) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_FORBIDDEN, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTSI2SD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1170), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_SCALAR) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E3NF), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_GPR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_FIXED_128) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_FORBIDDEN, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTSI2SD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1170), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_SCALAR) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E3NF), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_GPR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_FIXED_128) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_RC), ZYDIS_MASK_POLICY_FORBIDDEN, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTSI2SD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1176), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_SCALAR) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E3NF), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_FIXED_128) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_T1S) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_64) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_FORBIDDEN, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTSI2SD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x116D), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_SCALAR) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E10NF), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_GPR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_FIXED_128) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_FORBIDDEN, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTSI2SD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1173), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_SCALAR) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E10NF), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_FIXED_128) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_T1S) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_32) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_FORBIDDEN, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTSI2SH ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1620), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_FP16_SCALAR) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E3NF), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_GPR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_FIXED_128) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_FORBIDDEN, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTSI2SH ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1620), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_FP16_SCALAR) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E3NF), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_GPR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_FIXED_128) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_RC), ZYDIS_MASK_POLICY_FORBIDDEN, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTSI2SH ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1623), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_FP16_SCALAR) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E3NF), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_GPR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_FIXED_128) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_FORBIDDEN, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTSI2SH ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1623), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_FP16_SCALAR) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E3NF), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_GPR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_FIXED_128) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_RC), ZYDIS_MASK_POLICY_FORBIDDEN, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTSI2SH ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1626), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_FP16_SCALAR) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E3NF), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_FIXED_128) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_T1S) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_32) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_FORBIDDEN, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTSI2SH ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1629), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_FP16_SCALAR) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E3NF), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_FIXED_128) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_T1S) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_64) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_FORBIDDEN, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTSI2SH ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1620), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_FP16_SCALAR) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E3NF), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_GPR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_FIXED_128) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_FORBIDDEN, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTSI2SH ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1620), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_FP16_SCALAR) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E3NF), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_GPR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_FIXED_128) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_RC), ZYDIS_MASK_POLICY_FORBIDDEN, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTSI2SH ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1626), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_FP16_SCALAR) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E3NF), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_FIXED_128) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_T1S) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_32) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_FORBIDDEN, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTSI2SS ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1179), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_SCALAR) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E3NF), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_GPR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_FIXED_128) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_FORBIDDEN, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTSI2SS ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1179), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_SCALAR) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E3NF), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_GPR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_FIXED_128) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_RC), ZYDIS_MASK_POLICY_FORBIDDEN, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTSI2SS ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x117F), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_SCALAR) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E3NF), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_FIXED_128) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_T1S) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_32) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_FORBIDDEN, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTSI2SS ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x117C), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_SCALAR) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E3NF), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_GPR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_FIXED_128) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_FORBIDDEN, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTSI2SS ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x117C), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_SCALAR) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E3NF), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_GPR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_FIXED_128) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_RC), ZYDIS_MASK_POLICY_FORBIDDEN, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTSI2SS ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1182), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_SCALAR) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E3NF), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_FIXED_128) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_T1S) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_64) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_FORBIDDEN, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTSI2SS ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1179), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_SCALAR) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E3NF), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_GPR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_FIXED_128) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_FORBIDDEN, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTSI2SS ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1179), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_SCALAR) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E3NF), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_GPR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_FIXED_128) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_RC), ZYDIS_MASK_POLICY_FORBIDDEN, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTSI2SS ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x117F), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_SCALAR) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E3NF), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_FIXED_128) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_T1S) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_32) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_FORBIDDEN, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTSS2SD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x8E8), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_SCALAR) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E3), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_FIXED_128) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTSS2SD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x8E8), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_SCALAR) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E3), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_FIXED_128) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_SAE), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTSS2SD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x8EC), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_SCALAR) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E3), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_FIXED_128) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_T1S) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_32) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTSS2SH ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x8F0), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_FP16_SCALAR) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E3), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_FIXED_128) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTSS2SH ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x8F0), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_FP16_SCALAR) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E3), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_FIXED_128) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_RC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTSS2SH ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x8F4), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_FP16_SCALAR) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E3), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_FIXED_128) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_T1S) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_32) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTSS2SI ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1E07), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_SCALAR) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E3NF), ZYDIS_REGKIND_GPR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_FIXED_128) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_FORBIDDEN, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTSS2SI ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1E07), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_SCALAR) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E3NF), ZYDIS_REGKIND_GPR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_FIXED_128) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_RC), ZYDIS_MASK_POLICY_FORBIDDEN, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTSS2SI ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1B63), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_SCALAR) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E3NF), ZYDIS_REGKIND_GPR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_FIXED_128) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_T1F) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_32) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_FORBIDDEN, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTSS2SI ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1E97), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_SCALAR) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E3NF), ZYDIS_REGKIND_GPR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_FIXED_128) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_FORBIDDEN, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTSS2SI ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1E97), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_SCALAR) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E3NF), ZYDIS_REGKIND_GPR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_FIXED_128) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_RC), ZYDIS_MASK_POLICY_FORBIDDEN, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTSS2SI ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1B65), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_SCALAR) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E3NF), ZYDIS_REGKIND_GPR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_FIXED_128) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_T1F) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_32) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_FORBIDDEN, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTSS2SI ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1E07), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_SCALAR) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E3NF), ZYDIS_REGKIND_GPR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_FIXED_128) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_FORBIDDEN, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTSS2SI ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1E07), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_SCALAR) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E3NF), ZYDIS_REGKIND_GPR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_FIXED_128) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_RC), ZYDIS_MASK_POLICY_FORBIDDEN, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTSS2SI ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1B63), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_SCALAR) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E3NF), ZYDIS_REGKIND_GPR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_FIXED_128) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_T1F) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_32) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_FORBIDDEN, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTSS2USI ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1E99), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_SCALAR) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E3NF), ZYDIS_REGKIND_GPR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_FIXED_128) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_FORBIDDEN, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTSS2USI ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1E99), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_SCALAR) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E3NF), ZYDIS_REGKIND_GPR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_FIXED_128) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_RC), ZYDIS_MASK_POLICY_FORBIDDEN, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTSS2USI ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1E9B), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_SCALAR) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E3NF), ZYDIS_REGKIND_GPR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_FIXED_128) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_T1F) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_32) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_FORBIDDEN, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTSS2USI ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1E9D), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_SCALAR) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E3NF), ZYDIS_REGKIND_GPR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_FIXED_128) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_FORBIDDEN, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTSS2USI ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1E9D), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_SCALAR) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E3NF), ZYDIS_REGKIND_GPR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_FIXED_128) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_RC), ZYDIS_MASK_POLICY_FORBIDDEN, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTSS2USI ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1E9F), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_SCALAR) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E3NF), ZYDIS_REGKIND_GPR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_FIXED_128) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_T1F) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_32) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_FORBIDDEN, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTSS2USI ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1E99), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_SCALAR) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E3NF), ZYDIS_REGKIND_GPR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_FIXED_128) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_FORBIDDEN, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTSS2USI ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1E99), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_SCALAR) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E3NF), ZYDIS_REGKIND_GPR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_FIXED_128) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_RC), ZYDIS_MASK_POLICY_FORBIDDEN, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTSS2USI ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1E9B), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_SCALAR) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E3NF), ZYDIS_REGKIND_GPR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_FIXED_128) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_T1F) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_32) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_FORBIDDEN, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTTPD2DQ ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x14A6), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_FIXED_512) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_SAE), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTTPD2DQ ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x14A9), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTTPD2DQ ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x14AC), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTTPD2DQ ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x14A6), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTTPD2DQ ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x14AF), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_64) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTTPD2DQ ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x14AF), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_64) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTTPD2DQ ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x14B2), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_64) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTTPD2QQ ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x14D0), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512DQ_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_FIXED_512) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_SAE), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTTPD2QQ ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x14D3), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512DQ_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTTPD2QQ ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x14D6), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512DQ_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTTPD2QQ ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x14D0), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512DQ_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTTPD2QQ ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x14D9), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512DQ_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_64) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTTPD2QQ ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x14DC), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512DQ_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_64) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTTPD2QQ ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x14DF), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512DQ_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_64) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTTPD2UDQ ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x14E2), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_FIXED_512) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_SAE), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTTPD2UDQ ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x14E5), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTTPD2UDQ ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x14E8), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTTPD2UDQ ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x14E2), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTTPD2UDQ ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x14EB), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_64) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTTPD2UDQ ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x14EB), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_64) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTTPD2UDQ ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x14EE), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_64) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTTPD2UQQ ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x14F1), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512DQ_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_FIXED_512) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_SAE), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTTPD2UQQ ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x14F4), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512DQ_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTTPD2UQQ ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x14F7), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512DQ_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTTPD2UQQ ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x14F1), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512DQ_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTTPD2UQQ ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x14FA), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512DQ_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_64) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTTPD2UQQ ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x14FD), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512DQ_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_64) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTTPD2UQQ ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1500), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512DQ_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_64) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTTPH2DQ ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1503), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_FP16_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_FIXED_512) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_SAE), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTTPH2DQ ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1506), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_FP16_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTTPH2DQ ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1509), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_FP16_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTTPH2DQ ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1503), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_FP16_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTTPH2DQ ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x150C), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_FP16_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_HV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_16) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTTPH2DQ ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x150F), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_FP16_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_HV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_16) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTTPH2DQ ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1512), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_FP16_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_HV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_16) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTTPH2QQ ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1542), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_FP16_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_FIXED_512) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_SAE), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTTPH2QQ ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1545), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_FP16_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTTPH2QQ ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1548), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_FP16_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTTPH2QQ ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1542), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_FP16_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTTPH2QQ ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x154B), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_FP16_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_QUARTER) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_16) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTTPH2QQ ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x154E), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_FP16_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_QUARTER) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_16) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTTPH2QQ ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1551), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_FP16_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_QUARTER) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_16) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTTPH2UDQ ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1554), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_FP16_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_FIXED_512) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_SAE), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTTPH2UDQ ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1557), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_FP16_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTTPH2UDQ ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x155A), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_FP16_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTTPH2UDQ ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1554), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_FP16_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTTPH2UDQ ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x155D), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_FP16_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_HV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_16) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTTPH2UDQ ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1560), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_FP16_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_HV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_16) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTTPH2UDQ ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1563), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_FP16_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_HV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_16) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTTPH2UQQ ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1566), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_FP16_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_FIXED_512) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_SAE), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTTPH2UQQ ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1569), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_FP16_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTTPH2UQQ ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x156C), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_FP16_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTTPH2UQQ ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1566), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_FP16_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTTPH2UQQ ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x156F), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_FP16_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_QUARTER) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_16) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTTPH2UQQ ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1572), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_FP16_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_QUARTER) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_16) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTTPH2UQQ ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1575), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_FP16_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_QUARTER) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_16) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTTPH2UW ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1578), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_FP16_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_FIXED_512) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_SAE), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTTPH2UW ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x157B), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_FP16_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTTPH2UW ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x157E), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_FP16_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTTPH2UW ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1578), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_FP16_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTTPH2UW ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1581), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_FP16_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_16) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTTPH2UW ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1584), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_FP16_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_16) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTTPH2UW ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1587), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_FP16_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_16) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTTPH2W ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x158A), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_FP16_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_FIXED_512) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_SAE), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTTPH2W ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x158D), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_FP16_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTTPH2W ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1590), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_FP16_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTTPH2W ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x158A), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_FP16_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTTPH2W ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1593), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_FP16_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_16) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTTPH2W ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1596), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_FP16_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_16) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTTPH2W ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1599), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_FP16_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_16) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTTPS2DQ ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x159C), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_FIXED_512) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_SAE), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTTPS2DQ ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x159F), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTTPS2DQ ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x15A2), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTTPS2DQ ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x159C), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTTPS2DQ ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x15A5), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_32) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTTPS2DQ ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x15A8), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_32) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTTPS2DQ ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x15AB), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_32) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTTPS2QQ ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x15CF), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512DQ_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E3), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_FIXED_512) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_SAE), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTTPS2QQ ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x15D2), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512DQ_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E3), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTTPS2QQ ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x15D5), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512DQ_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E3), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTTPS2QQ ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x15CF), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512DQ_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E3), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTTPS2QQ ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x15D8), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512DQ_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E3), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_HV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_32) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTTPS2QQ ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x15DB), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512DQ_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E3), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_HV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_32) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTTPS2QQ ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x15DE), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512DQ_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E3), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_HV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_32) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTTPS2UDQ ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x15E1), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_FIXED_512) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_SAE), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTTPS2UDQ ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x15E4), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTTPS2UDQ ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x15E7), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTTPS2UDQ ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x15E1), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTTPS2UDQ ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x15EA), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_32) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTTPS2UDQ ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x15ED), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_32) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTTPS2UDQ ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x15F0), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_32) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTTPS2UQQ ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x15F3), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512DQ_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E3), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_FIXED_512) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_SAE), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTTPS2UQQ ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x15F6), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512DQ_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E3), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTTPS2UQQ ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x15F9), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512DQ_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E3), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTTPS2UQQ ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x15F3), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512DQ_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E3), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTTPS2UQQ ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x15FC), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512DQ_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E3), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_HV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_32) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTTPS2UQQ ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x15FF), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512DQ_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E3), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_HV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_32) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTTPS2UQQ ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1602), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512DQ_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E3), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_HV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_32) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTTSD2SI ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1E03), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_SCALAR) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E3NF), ZYDIS_REGKIND_GPR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_FIXED_128) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_FORBIDDEN, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTTSD2SI ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1E03), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_SCALAR) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E3NF), ZYDIS_REGKIND_GPR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_FIXED_128) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_SAE), ZYDIS_MASK_POLICY_FORBIDDEN, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTTSD2SI ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1B43), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_SCALAR) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E3NF), ZYDIS_REGKIND_GPR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_FIXED_128) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_T1F) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_64) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_FORBIDDEN, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTTSD2SI ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1E7D), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_SCALAR) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E3NF), ZYDIS_REGKIND_GPR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_FIXED_128) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_FORBIDDEN, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTTSD2SI ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1E7D), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_SCALAR) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E3NF), ZYDIS_REGKIND_GPR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_FIXED_128) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_SAE), ZYDIS_MASK_POLICY_FORBIDDEN, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTTSD2SI ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1B45), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_SCALAR) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E3NF), ZYDIS_REGKIND_GPR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_FIXED_128) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_T1F) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_64) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_FORBIDDEN, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTTSD2SI ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1E03), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_SCALAR) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E3NF), ZYDIS_REGKIND_GPR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_FIXED_128) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_FORBIDDEN, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTTSD2SI ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1E03), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_SCALAR) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E3NF), ZYDIS_REGKIND_GPR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_FIXED_128) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_SAE), ZYDIS_MASK_POLICY_FORBIDDEN, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTTSD2SI ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1B43), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_SCALAR) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E3NF), ZYDIS_REGKIND_GPR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_FIXED_128) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_T1F) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_64) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_FORBIDDEN, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTTSD2USI ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1E7F), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_SCALAR) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E3NF), ZYDIS_REGKIND_GPR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_FIXED_128) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_FORBIDDEN, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTTSD2USI ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1E7F), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_SCALAR) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E3NF), ZYDIS_REGKIND_GPR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_FIXED_128) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_SAE), ZYDIS_MASK_POLICY_FORBIDDEN, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTTSD2USI ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1E81), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_SCALAR) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E3NF), ZYDIS_REGKIND_GPR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_FIXED_128) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_T1F) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_64) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_FORBIDDEN, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTTSD2USI ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1E83), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_SCALAR) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E3NF), ZYDIS_REGKIND_GPR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_FIXED_128) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_FORBIDDEN, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTTSD2USI ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1E83), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_SCALAR) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E3NF), ZYDIS_REGKIND_GPR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_FIXED_128) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_SAE), ZYDIS_MASK_POLICY_FORBIDDEN, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTTSD2USI ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1E85), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_SCALAR) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E3NF), ZYDIS_REGKIND_GPR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_FIXED_128) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_T1F) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_64) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_FORBIDDEN, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTTSD2USI ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1E7F), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_SCALAR) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E3NF), ZYDIS_REGKIND_GPR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_FIXED_128) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_FORBIDDEN, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTTSD2USI ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1E7F), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_SCALAR) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E3NF), ZYDIS_REGKIND_GPR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_FIXED_128) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_SAE), ZYDIS_MASK_POLICY_FORBIDDEN, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTTSD2USI ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1E81), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_SCALAR) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E3NF), ZYDIS_REGKIND_GPR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_FIXED_128) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_T1F) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_64) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_FORBIDDEN, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTTSH2SI ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1E87), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_FP16_SCALAR) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E3NF), ZYDIS_REGKIND_GPR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_FIXED_128) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_FORBIDDEN, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTTSH2SI ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1E87), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_FP16_SCALAR) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E3NF), ZYDIS_REGKIND_GPR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_FIXED_128) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_SAE), ZYDIS_MASK_POLICY_FORBIDDEN, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTTSH2SI ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1E89), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_FP16_SCALAR) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E3NF), ZYDIS_REGKIND_GPR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_FIXED_128) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_FORBIDDEN, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTTSH2SI ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1E89), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_FP16_SCALAR) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E3NF), ZYDIS_REGKIND_GPR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_FIXED_128) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_SAE), ZYDIS_MASK_POLICY_FORBIDDEN, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTTSH2SI ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1E8B), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_FP16_SCALAR) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E3NF), ZYDIS_REGKIND_GPR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_FIXED_128) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_T1F) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_16) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_FORBIDDEN, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTTSH2SI ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1E8D), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_FP16_SCALAR) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E3NF), ZYDIS_REGKIND_GPR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_FIXED_128) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_T1F) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_16) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_FORBIDDEN, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTTSH2SI ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1E87), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_FP16_SCALAR) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E3NF), ZYDIS_REGKIND_GPR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_FIXED_128) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_FORBIDDEN, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTTSH2SI ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1E87), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_FP16_SCALAR) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E3NF), ZYDIS_REGKIND_GPR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_FIXED_128) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_SAE), ZYDIS_MASK_POLICY_FORBIDDEN, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTTSH2SI ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1E8B), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_FP16_SCALAR) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E3NF), ZYDIS_REGKIND_GPR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_FIXED_128) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_T1F) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_16) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_FORBIDDEN, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTTSH2USI ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1E8F), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_FP16_SCALAR) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E3NF), ZYDIS_REGKIND_GPR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_FIXED_128) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_FORBIDDEN, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTTSH2USI ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1E8F), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_FP16_SCALAR) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E3NF), ZYDIS_REGKIND_GPR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_FIXED_128) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_SAE), ZYDIS_MASK_POLICY_FORBIDDEN, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTTSH2USI ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1E91), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_FP16_SCALAR) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E3NF), ZYDIS_REGKIND_GPR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_FIXED_128) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_FORBIDDEN, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTTSH2USI ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1E91), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_FP16_SCALAR) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E3NF), ZYDIS_REGKIND_GPR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_FIXED_128) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_SAE), ZYDIS_MASK_POLICY_FORBIDDEN, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTTSH2USI ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1E93), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_FP16_SCALAR) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E3NF), ZYDIS_REGKIND_GPR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_FIXED_128) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_T1F) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_16) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_FORBIDDEN, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTTSH2USI ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1E95), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_FP16_SCALAR) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E3NF), ZYDIS_REGKIND_GPR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_FIXED_128) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_T1F) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_16) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_FORBIDDEN, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTTSH2USI ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1E8F), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_FP16_SCALAR) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E3NF), ZYDIS_REGKIND_GPR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_FIXED_128) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_FORBIDDEN, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTTSH2USI ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1E8F), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_FP16_SCALAR) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E3NF), ZYDIS_REGKIND_GPR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_FIXED_128) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_SAE), ZYDIS_MASK_POLICY_FORBIDDEN, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTTSH2USI ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1E93), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_FP16_SCALAR) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E3NF), ZYDIS_REGKIND_GPR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_FIXED_128) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_T1F) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_16) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_FORBIDDEN, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTTSS2SI ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1E07), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_SCALAR) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E3NF), ZYDIS_REGKIND_GPR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_FIXED_128) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_FORBIDDEN, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTTSS2SI ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1E07), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_SCALAR) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E3NF), ZYDIS_REGKIND_GPR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_FIXED_128) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_SAE), ZYDIS_MASK_POLICY_FORBIDDEN, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTTSS2SI ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1B63), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_SCALAR) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E3NF), ZYDIS_REGKIND_GPR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_FIXED_128) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_T1F) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_32) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_FORBIDDEN, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTTSS2SI ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1E97), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_SCALAR) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E3NF), ZYDIS_REGKIND_GPR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_FIXED_128) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_FORBIDDEN, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTTSS2SI ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1E97), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_SCALAR) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E3NF), ZYDIS_REGKIND_GPR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_FIXED_128) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_SAE), ZYDIS_MASK_POLICY_FORBIDDEN, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTTSS2SI ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1B65), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_SCALAR) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E3NF), ZYDIS_REGKIND_GPR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_FIXED_128) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_T1F) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_32) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_FORBIDDEN, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTTSS2SI ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1E07), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_SCALAR) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E3NF), ZYDIS_REGKIND_GPR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_FIXED_128) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_FORBIDDEN, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTTSS2SI ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1E07), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_SCALAR) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E3NF), ZYDIS_REGKIND_GPR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_FIXED_128) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_SAE), ZYDIS_MASK_POLICY_FORBIDDEN, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTTSS2SI ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1B63), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_SCALAR) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E3NF), ZYDIS_REGKIND_GPR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_FIXED_128) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_T1F) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_32) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_FORBIDDEN, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTTSS2USI ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1E99), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_SCALAR) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E3NF), ZYDIS_REGKIND_GPR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_FIXED_128) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_FORBIDDEN, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTTSS2USI ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1E99), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_SCALAR) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E3NF), ZYDIS_REGKIND_GPR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_FIXED_128) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_SAE), ZYDIS_MASK_POLICY_FORBIDDEN, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTTSS2USI ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1E9B), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_SCALAR) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E3NF), ZYDIS_REGKIND_GPR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_FIXED_128) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_T1F) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_32) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_FORBIDDEN, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTTSS2USI ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1E9D), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_SCALAR) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E3NF), ZYDIS_REGKIND_GPR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_FIXED_128) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_FORBIDDEN, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTTSS2USI ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1E9D), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_SCALAR) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E3NF), ZYDIS_REGKIND_GPR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_FIXED_128) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_SAE), ZYDIS_MASK_POLICY_FORBIDDEN, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTTSS2USI ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1E9F), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_SCALAR) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E3NF), ZYDIS_REGKIND_GPR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_FIXED_128) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_T1F) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_32) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_FORBIDDEN, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTTSS2USI ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1E99), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_SCALAR) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E3NF), ZYDIS_REGKIND_GPR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_FIXED_128) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_FORBIDDEN, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTTSS2USI ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1E99), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_SCALAR) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E3NF), ZYDIS_REGKIND_GPR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_FIXED_128) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_SAE), ZYDIS_MASK_POLICY_FORBIDDEN, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTTSS2USI ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1E9B), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_SCALAR) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E3NF), ZYDIS_REGKIND_GPR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_FIXED_128) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_T1F) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_32) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_FORBIDDEN, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTUDQ2PD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x162C), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E5), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_FIXED_512) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTUDQ2PD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x162F), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E5), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTUDQ2PD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1632), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E5), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTUDQ2PD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x162C), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E5), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTUDQ2PD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1635), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E5), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_HV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_32) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTUDQ2PD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1638), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E5), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_HV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_32) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTUDQ2PD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x163B), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E5), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_HV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_32) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTUDQ2PH ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x163E), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_FP16_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_FIXED_512) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_RC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTUDQ2PH ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1641), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_FP16_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTUDQ2PH ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1644), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_FP16_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTUDQ2PH ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x163E), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_FP16_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTUDQ2PH ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1647), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_FP16_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_32) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTUDQ2PH ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1647), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_FP16_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_32) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTUDQ2PH ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x164A), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_FP16_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_32) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTUDQ2PS ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x164D), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_FIXED_512) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_RC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTUDQ2PS ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1650), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTUDQ2PS ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1653), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTUDQ2PS ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x164D), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTUDQ2PS ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1656), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_32) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTUDQ2PS ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1659), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_32) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTUDQ2PS ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x165C), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_32) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTUQQ2PD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x165F), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512DQ_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_FIXED_512) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_RC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTUQQ2PD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1662), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512DQ_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTUQQ2PD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1665), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512DQ_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTUQQ2PD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x165F), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512DQ_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTUQQ2PD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1668), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512DQ_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_64) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTUQQ2PD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x166B), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512DQ_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_64) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTUQQ2PD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x166E), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512DQ_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_64) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTUQQ2PH ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1605), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_FP16_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_FIXED_512) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_RC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTUQQ2PH ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1608), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_FP16_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTUQQ2PH ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x160B), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_FP16_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTUQQ2PH ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1605), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_FP16_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTUQQ2PH ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x160E), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_FP16_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_64) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTUQQ2PH ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x160E), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_FP16_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_64) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTUQQ2PH ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x160E), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_FP16_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_64) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTUQQ2PS ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1611), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512DQ_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_FIXED_512) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_RC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTUQQ2PS ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1614), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512DQ_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTUQQ2PS ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1617), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512DQ_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTUQQ2PS ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1611), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512DQ_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTUQQ2PS ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x161A), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512DQ_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_64) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTUQQ2PS ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x161A), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512DQ_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_64) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTUQQ2PS ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x161D), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512DQ_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_64) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTUSI2SD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1671), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_SCALAR) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E10NF), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_GPR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_FIXED_128) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_FORBIDDEN, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTUSI2SD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1674), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_SCALAR) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E10NF), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_FIXED_128) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_T1S) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_32) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_FORBIDDEN, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTUSI2SD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1677), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_SCALAR) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E3NF), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_GPR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_FIXED_128) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_FORBIDDEN, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTUSI2SD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1677), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_SCALAR) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E3NF), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_GPR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_FIXED_128) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_RC), ZYDIS_MASK_POLICY_FORBIDDEN, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTUSI2SD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x167A), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_SCALAR) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E3NF), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_FIXED_128) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_T1S) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_64) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_FORBIDDEN, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTUSI2SD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1671), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_SCALAR) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E10NF), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_GPR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_FIXED_128) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_FORBIDDEN, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTUSI2SD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1674), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_SCALAR) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E10NF), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_FIXED_128) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_T1S) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_32) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_FORBIDDEN, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTUSI2SH ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x167D), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_FP16_SCALAR) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E3NF), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_GPR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_FIXED_128) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_FORBIDDEN, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTUSI2SH ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x167D), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_FP16_SCALAR) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E3NF), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_GPR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_FIXED_128) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_RC), ZYDIS_MASK_POLICY_FORBIDDEN, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTUSI2SH ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1680), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_FP16_SCALAR) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E3NF), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_GPR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_FIXED_128) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_FORBIDDEN, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTUSI2SH ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1680), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_FP16_SCALAR) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E3NF), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_GPR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_FIXED_128) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_RC), ZYDIS_MASK_POLICY_FORBIDDEN, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTUSI2SH ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1683), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_FP16_SCALAR) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E3NF), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_FIXED_128) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_T1S) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_32) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_FORBIDDEN, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTUSI2SH ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1686), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_FP16_SCALAR) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E3NF), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_FIXED_128) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_T1S) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_64) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_FORBIDDEN, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTUSI2SH ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x167D), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_FP16_SCALAR) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E3NF), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_GPR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_FIXED_128) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_FORBIDDEN, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTUSI2SH ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x167D), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_FP16_SCALAR) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E3NF), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_GPR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_FIXED_128) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_RC), ZYDIS_MASK_POLICY_FORBIDDEN, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTUSI2SH ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1683), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_FP16_SCALAR) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E3NF), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_FIXED_128) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_T1S) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_32) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_FORBIDDEN, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTUSI2SS ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1689), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_SCALAR) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E3NF), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_GPR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_FIXED_128) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_FORBIDDEN, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTUSI2SS ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1689), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_SCALAR) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E3NF), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_GPR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_FIXED_128) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_RC), ZYDIS_MASK_POLICY_FORBIDDEN, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTUSI2SS ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x168C), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_SCALAR) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E3NF), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_FIXED_128) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_T1S) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_32) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_FORBIDDEN, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTUSI2SS ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x168F), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_SCALAR) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E3NF), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_GPR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_FIXED_128) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_FORBIDDEN, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTUSI2SS ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x168F), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_SCALAR) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E3NF), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_GPR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_FIXED_128) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_RC), ZYDIS_MASK_POLICY_FORBIDDEN, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTUSI2SS ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1692), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_SCALAR) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E3NF), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_FIXED_128) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_T1S) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_64) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_FORBIDDEN, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTUSI2SS ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1689), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_SCALAR) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E3NF), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_GPR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_FIXED_128) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_FORBIDDEN, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTUSI2SS ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1689), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_SCALAR) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E3NF), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_GPR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_FIXED_128) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_RC), ZYDIS_MASK_POLICY_FORBIDDEN, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTUSI2SS ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x168C), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_SCALAR) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E3NF), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_FIXED_128) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_T1S) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_32) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_FORBIDDEN, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTUW2PH ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1695), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_FP16_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_FIXED_512) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_RC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTUW2PH ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1698), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_FP16_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTUW2PH ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x169B), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_FP16_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTUW2PH ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1695), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_FP16_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTUW2PH ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x169E), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_FP16_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_16) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTUW2PH ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x16A1), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_FP16_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_16) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTUW2PH ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x16A4), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_FP16_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_16) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTW2PH ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x16A7), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_FP16_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_FIXED_512) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_RC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTW2PH ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x16AA), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_FP16_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTW2PH ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x16AD), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_FP16_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTW2PH ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x16A7), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_FP16_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTW2PH ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x16B0), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_FP16_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_16) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTW2PH ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x16B3), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_FP16_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_16) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTW2PH ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x16B6), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_FP16_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_16) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VDBPSADBW ZYDIS_NOTMIN(5) ZYDIS_NOTMIN(5) ZYDIS_NOTMIN(0x248), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512BW_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VDBPSADBW ZYDIS_NOTMIN(5) ZYDIS_NOTMIN(5) ZYDIS_NOTMIN(0x24D), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512BW_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VDBPSADBW ZYDIS_NOTMIN(5) ZYDIS_NOTMIN(5) ZYDIS_NOTMIN(0x252), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512BW_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VDBPSADBW ZYDIS_NOTMIN(5) ZYDIS_NOTMIN(5) ZYDIS_NOTMIN(0x257), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512BW_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FVM) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_16) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VDBPSADBW ZYDIS_NOTMIN(5) ZYDIS_NOTMIN(5) ZYDIS_NOTMIN(0x25C), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512BW_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FVM) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_16) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VDBPSADBW ZYDIS_NOTMIN(5) ZYDIS_NOTMIN(5) ZYDIS_NOTMIN(0x261), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512BW_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FVM) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_16) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VDIVPD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x4C8), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_FIXED_512) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_RC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VDIVPD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x2AC), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VDIVPD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x4CD), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VDIVPD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x4C8), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VDIVPD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x4D2), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_64) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VDIVPD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x4D7), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_64) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VDIVPD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x4DC), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_64) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VDIVPH ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x884), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_FP16) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_FP16_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_FIXED_512) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_RC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VDIVPH ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x2B6), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_FP16) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_FP16_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VDIVPH ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x888), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_FP16) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_FP16_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VDIVPH ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x884), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_FP16) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_FP16_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VDIVPH ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x88C), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_FP16) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_FP16_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_16) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VDIVPH ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x890), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_FP16) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_FP16_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_16) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VDIVPH ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x894), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_FP16) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_FP16_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_16) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VDIVPS ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x4E1), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_FIXED_512) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_RC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VDIVPS ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x2C0), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VDIVPS ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x4E6), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VDIVPS ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x4E1), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VDIVPS ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x4EB), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_32) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VDIVPS ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x4F0), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_32) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VDIVPS ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x4F5), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_32) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VDIVSD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x2AC), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_SCALAR) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E3), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_FIXED_128) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VDIVSD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x2AC), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_SCALAR) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E3), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_FIXED_128) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_RC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VDIVSD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x2B1), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_SCALAR) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E3), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_FIXED_128) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_T1S) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_64) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VDIVSH ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x2B6), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_FP16) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_FP16_SCALAR) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E3), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_FIXED_128) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VDIVSH ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x2B6), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_FP16) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_FP16_SCALAR) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E3), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_FIXED_128) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_RC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VDIVSH ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x2BB), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_FP16) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_FP16_SCALAR) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E3), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_FIXED_128) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_T1S) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_16) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VDIVSS ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x2C0), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_SCALAR) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E3), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_FIXED_128) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VDIVSS ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x2C0), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_SCALAR) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E3), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_FIXED_128) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_RC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VDIVSS ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x2C5), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_SCALAR) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E3), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_FIXED_128) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_T1S) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_32) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VDPBF16PS ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x8F8), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_BF16_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VDPBF16PS ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x8FC), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_BF16_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VDPBF16PS ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x900), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_BF16_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VDPBF16PS ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x904), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_BF16_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_32) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VDPBF16PS ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x908), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_BF16_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_32) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VDPBF16PS ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x90C), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_BF16_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_32) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VEXP2PD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0xA00), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512ER_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_FIXED_512) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_SAE), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VEXP2PD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0xA00), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512ER_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VEXP2PD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0xA14), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512ER_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_64) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VEXP2PS ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0xA30), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512ER_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_FIXED_512) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_SAE), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VEXP2PS ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0xA30), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512ER_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VEXP2PS ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0xA44), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512ER_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_32) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VEXPANDPD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0xA04), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_EXPAND) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VEXPANDPD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0xA08), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_EXPAND) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VEXPANDPD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0xA00), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_EXPAND) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VEXPANDPD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x16B9), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_EXPAND) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_GSCAT) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_64) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VEXPANDPD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x16BC), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_EXPAND) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_GSCAT) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_64) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VEXPANDPD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x16BF), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_EXPAND) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_GSCAT) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_64) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VEXPANDPS ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0xA34), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_EXPAND) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VEXPANDPS ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0xA38), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_EXPAND) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VEXPANDPS ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0xA30), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_EXPAND) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VEXPANDPS ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x16C2), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_EXPAND) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_GSCAT) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_32) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VEXPANDPS ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x16C5), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_EXPAND) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_GSCAT) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_32) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VEXPANDPS ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x16C8), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_EXPAND) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_GSCAT) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_32) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VEXTRACTF32X4 ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x910), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E6NF), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VEXTRACTF32X4 ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x914), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E6NF), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VEXTRACTF32X4 ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x918), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E6NF), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_T4) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_32) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VEXTRACTF32X4 ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x91C), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E6NF), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_T4) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_32) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VEXTRACTF32X8 ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x920), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512DQ_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E6NF), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VEXTRACTF32X8 ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x924), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512DQ_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E6NF), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_T8) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_32) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VEXTRACTF64X2 ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x928), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512DQ_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E6NF), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VEXTRACTF64X2 ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x92C), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512DQ_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E6NF), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VEXTRACTF64X2 ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x930), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512DQ_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E6NF), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_T2) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_64) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VEXTRACTF64X2 ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x934), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512DQ_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E6NF), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_T2) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_64) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VEXTRACTF64X4 ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x938), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E6NF), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VEXTRACTF64X4 ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x93C), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E6NF), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_T4) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_64) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VEXTRACTI32X4 ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x940), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E6NF), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VEXTRACTI32X4 ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x944), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E6NF), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VEXTRACTI32X4 ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x948), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E6NF), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_T4) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_32) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VEXTRACTI32X4 ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x94C), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E6NF), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_T4) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_32) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VEXTRACTI32X8 ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x950), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512DQ_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E6NF), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VEXTRACTI32X8 ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x954), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512DQ_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E6NF), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_T8) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_32) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VEXTRACTI64X2 ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x958), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512DQ_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E6NF), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VEXTRACTI64X2 ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x95C), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512DQ_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E6NF), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VEXTRACTI64X2 ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x960), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512DQ_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E6NF), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_T2) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_64) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VEXTRACTI64X2 ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x964), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512DQ_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E6NF), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_T2) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_64) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VEXTRACTI64X4 ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x968), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E6NF), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VEXTRACTI64X4 ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x96C), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E6NF), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_T4) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_64) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VEXTRACTPS ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x16CB), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_128N) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E9NF), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_GPR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_FORBIDDEN, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VEXTRACTPS ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x119A), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_128N) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E9NF), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_T1S) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_32) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_FORBIDDEN, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFCMADDCPH ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x970), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_FP16) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_FP16_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_TRUE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_FIXED_512) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_RC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFCMADDCPH ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x974), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_FP16) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_FP16_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_TRUE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFCMADDCPH ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x978), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_FP16) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_FP16_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_TRUE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFCMADDCPH ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x970), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_FP16) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_FP16_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_TRUE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFCMADDCPH ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x97C), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_FP16) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_FP16_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_TRUE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_32) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFCMADDCPH ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x980), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_FP16) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_FP16_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_TRUE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_32) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFCMADDCPH ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x984), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_FP16) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_FP16_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_TRUE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_32) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFCMADDCSH ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x974), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_FP16) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_FP16_SCALAR) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E10), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_TRUE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_FIXED_128) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFCMADDCSH ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x974), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_FP16) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_FP16_SCALAR) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E10), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_TRUE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_FIXED_128) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_RC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFCMADDCSH ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x988), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_FP16) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_FP16_SCALAR) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E10), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_TRUE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_FIXED_128) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_T1S) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_32) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFCMULCPH ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x98C), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_FP16) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_FP16_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_TRUE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_FIXED_512) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_RC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFCMULCPH ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x990), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_FP16) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_FP16_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_TRUE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFCMULCPH ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x994), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_FP16) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_FP16_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_TRUE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFCMULCPH ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x98C), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_FP16) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_FP16_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_TRUE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFCMULCPH ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x998), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_FP16) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_FP16_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_TRUE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_32) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFCMULCPH ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x99C), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_FP16) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_FP16_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_TRUE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_32) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFCMULCPH ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x9A0), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_FP16) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_FP16_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_TRUE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_32) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFCMULCSH ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x990), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_FP16) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_FP16_SCALAR) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E10), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_TRUE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_FIXED_128) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFCMULCSH ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x990), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_FP16) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_FP16_SCALAR) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E10), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_TRUE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_FIXED_128) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_RC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFCMULCSH ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x9A4), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_FP16) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_FP16_SCALAR) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E10), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_TRUE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_FIXED_128) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_T1S) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_32) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFIXUPIMMPD ZYDIS_NOTMIN(5) ZYDIS_NOTMIN(5) ZYDIS_NOTMIN(0x266), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_FIXED_512) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_SAE), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFIXUPIMMPD ZYDIS_NOTMIN(5) ZYDIS_NOTMIN(5) ZYDIS_NOTMIN(0x26B), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFIXUPIMMPD ZYDIS_NOTMIN(5) ZYDIS_NOTMIN(5) ZYDIS_NOTMIN(0x270), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFIXUPIMMPD ZYDIS_NOTMIN(5) ZYDIS_NOTMIN(5) ZYDIS_NOTMIN(0x266), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFIXUPIMMPD ZYDIS_NOTMIN(5) ZYDIS_NOTMIN(5) ZYDIS_NOTMIN(0x275), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_64) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFIXUPIMMPD ZYDIS_NOTMIN(5) ZYDIS_NOTMIN(5) ZYDIS_NOTMIN(0x27A), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_64) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFIXUPIMMPD ZYDIS_NOTMIN(5) ZYDIS_NOTMIN(5) ZYDIS_NOTMIN(0x27F), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_64) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFIXUPIMMPS ZYDIS_NOTMIN(5) ZYDIS_NOTMIN(5) ZYDIS_NOTMIN(0x284), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_FIXED_512) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_SAE), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFIXUPIMMPS ZYDIS_NOTMIN(5) ZYDIS_NOTMIN(5) ZYDIS_NOTMIN(0x289), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFIXUPIMMPS ZYDIS_NOTMIN(5) ZYDIS_NOTMIN(5) ZYDIS_NOTMIN(0x28E), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFIXUPIMMPS ZYDIS_NOTMIN(5) ZYDIS_NOTMIN(5) ZYDIS_NOTMIN(0x284), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFIXUPIMMPS ZYDIS_NOTMIN(5) ZYDIS_NOTMIN(5) ZYDIS_NOTMIN(0x293), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_32) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFIXUPIMMPS ZYDIS_NOTMIN(5) ZYDIS_NOTMIN(5) ZYDIS_NOTMIN(0x298), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_32) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFIXUPIMMPS ZYDIS_NOTMIN(5) ZYDIS_NOTMIN(5) ZYDIS_NOTMIN(0x29D), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_32) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFIXUPIMMSD ZYDIS_NOTMIN(5) ZYDIS_NOTMIN(5) ZYDIS_NOTMIN(0x26B), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_SCALAR) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E3), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_FIXED_128) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFIXUPIMMSD ZYDIS_NOTMIN(5) ZYDIS_NOTMIN(5) ZYDIS_NOTMIN(0x26B), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_SCALAR) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E3), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_FIXED_128) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_SAE), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFIXUPIMMSD ZYDIS_NOTMIN(5) ZYDIS_NOTMIN(5) ZYDIS_NOTMIN(0x2A2), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_SCALAR) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E3), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_FIXED_128) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_T1S) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_64) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFIXUPIMMSS ZYDIS_NOTMIN(5) ZYDIS_NOTMIN(5) ZYDIS_NOTMIN(0x289), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_SCALAR) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E3), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_FIXED_128) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFIXUPIMMSS ZYDIS_NOTMIN(5) ZYDIS_NOTMIN(5) ZYDIS_NOTMIN(0x289), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_SCALAR) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E3), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_FIXED_128) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_SAE), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFIXUPIMMSS ZYDIS_NOTMIN(5) ZYDIS_NOTMIN(5) ZYDIS_NOTMIN(0x2A7), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_SCALAR) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E3), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_FIXED_128) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_T1S) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_32) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFMADD132PD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x266), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VFMA) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_FIXED_512) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_RC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFMADD132PD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x26B), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VFMA) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFMADD132PD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x270), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VFMA) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFMADD132PD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x266), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VFMA) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFMADD132PD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x275), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VFMA) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_64) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFMADD132PD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x27A), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VFMA) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_64) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFMADD132PD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x27F), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VFMA) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_64) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFMADD132PH ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x9A8), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_FP16) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_FP16_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_FIXED_512) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_RC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFMADD132PH ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x9AC), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_FP16) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_FP16_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFMADD132PH ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x9B0), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_FP16) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_FP16_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFMADD132PH ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x9A8), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_FP16) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_FP16_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFMADD132PH ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x9B4), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_FP16) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_FP16_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_16) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFMADD132PH ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x9B8), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_FP16) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_FP16_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_16) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFMADD132PH ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x9BC), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_FP16) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_FP16_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_16) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFMADD132PS ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x284), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VFMA) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_FIXED_512) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_RC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFMADD132PS ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x289), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VFMA) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFMADD132PS ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x28E), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VFMA) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFMADD132PS ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x284), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VFMA) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFMADD132PS ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x293), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VFMA) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_32) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFMADD132PS ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x298), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VFMA) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_32) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFMADD132PS ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x29D), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VFMA) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_32) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFMADD132SD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x26B), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VFMA) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_SCALAR) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E3), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_FIXED_128) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFMADD132SD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x26B), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VFMA) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_SCALAR) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E3), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_FIXED_128) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_RC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFMADD132SD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x2A2), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VFMA) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_SCALAR) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E3), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_FIXED_128) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_T1S) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_64) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFMADD132SH ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x9AC), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_FP16) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_FP16_SCALAR) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E3), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_FIXED_128) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFMADD132SH ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x9AC), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_FP16) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_FP16_SCALAR) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E3), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_FIXED_128) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_RC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFMADD132SH ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x9C0), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_FP16) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_FP16_SCALAR) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E3), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_FIXED_128) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_T1S) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_16) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFMADD132SS ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x289), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VFMA) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_SCALAR) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E3), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_FIXED_128) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFMADD132SS ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x289), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VFMA) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_SCALAR) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E3), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_FIXED_128) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_RC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFMADD132SS ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x2A7), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VFMA) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_SCALAR) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E3), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_FIXED_128) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_T1S) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_32) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFMADD213PD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x266), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VFMA) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_FIXED_512) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_RC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFMADD213PD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x26B), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VFMA) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFMADD213PD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x270), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VFMA) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFMADD213PD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x266), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VFMA) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFMADD213PD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x275), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VFMA) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_64) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFMADD213PD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x27A), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VFMA) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_64) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFMADD213PD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x27F), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VFMA) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_64) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFMADD213PH ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x9A8), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_FP16) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_FP16_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_FIXED_512) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_RC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFMADD213PH ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x9AC), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_FP16) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_FP16_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFMADD213PH ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x9B0), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_FP16) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_FP16_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFMADD213PH ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x9A8), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_FP16) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_FP16_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFMADD213PH ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x9B4), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_FP16) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_FP16_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_16) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFMADD213PH ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x9B8), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_FP16) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_FP16_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_16) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFMADD213PH ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x9BC), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_FP16) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_FP16_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_16) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFMADD213PS ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x284), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VFMA) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_FIXED_512) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_RC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFMADD213PS ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x289), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VFMA) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFMADD213PS ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x28E), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VFMA) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFMADD213PS ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x284), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VFMA) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFMADD213PS ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x293), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VFMA) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_32) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFMADD213PS ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x298), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VFMA) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_32) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFMADD213PS ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x29D), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VFMA) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_32) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFMADD213SD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x26B), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VFMA) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_SCALAR) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E3), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_FIXED_128) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFMADD213SD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x26B), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VFMA) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_SCALAR) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E3), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_FIXED_128) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_RC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFMADD213SD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x2A2), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VFMA) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_SCALAR) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E3), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_FIXED_128) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_T1S) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_64) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFMADD213SH ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x9AC), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_FP16) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_FP16_SCALAR) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E3), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_FIXED_128) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFMADD213SH ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x9AC), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_FP16) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_FP16_SCALAR) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E3), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_FIXED_128) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_RC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFMADD213SH ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x9C0), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_FP16) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_FP16_SCALAR) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E3), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_FIXED_128) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_T1S) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_16) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFMADD213SS ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x289), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VFMA) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_SCALAR) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E3), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_FIXED_128) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFMADD213SS ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x289), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VFMA) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_SCALAR) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E3), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_FIXED_128) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_RC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFMADD213SS ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x2A7), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VFMA) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_SCALAR) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E3), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_FIXED_128) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_T1S) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_32) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFMADD231PD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x266), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VFMA) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_FIXED_512) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_RC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFMADD231PD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x26B), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VFMA) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFMADD231PD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x270), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VFMA) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFMADD231PD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x266), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VFMA) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFMADD231PD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x275), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VFMA) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_64) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFMADD231PD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x27A), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VFMA) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_64) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFMADD231PD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x27F), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VFMA) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_64) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFMADD231PH ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x9A8), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_FP16) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_FP16_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_FIXED_512) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_RC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFMADD231PH ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x9AC), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_FP16) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_FP16_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFMADD231PH ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x9B0), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_FP16) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_FP16_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFMADD231PH ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x9A8), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_FP16) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_FP16_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFMADD231PH ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x9B4), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_FP16) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_FP16_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_16) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFMADD231PH ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x9B8), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_FP16) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_FP16_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_16) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFMADD231PH ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x9BC), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_FP16) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_FP16_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_16) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFMADD231PS ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x284), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VFMA) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_FIXED_512) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_RC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFMADD231PS ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x289), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VFMA) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFMADD231PS ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x28E), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VFMA) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFMADD231PS ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x284), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VFMA) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFMADD231PS ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x293), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VFMA) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_32) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFMADD231PS ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x298), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VFMA) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_32) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFMADD231PS ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x29D), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VFMA) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_32) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFMADD231SD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x26B), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VFMA) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_SCALAR) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E3), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_FIXED_128) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFMADD231SD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x26B), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VFMA) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_SCALAR) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E3), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_FIXED_128) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_RC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFMADD231SD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x2A2), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VFMA) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_SCALAR) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E3), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_FIXED_128) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_T1S) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_64) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFMADD231SH ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x9AC), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_FP16) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_FP16_SCALAR) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E3), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_FIXED_128) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFMADD231SH ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x9AC), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_FP16) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_FP16_SCALAR) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E3), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_FIXED_128) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_RC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFMADD231SH ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x9C0), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_FP16) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_FP16_SCALAR) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E3), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_FIXED_128) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_T1S) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_16) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFMADD231SS ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x289), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VFMA) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_SCALAR) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E3), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_FIXED_128) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFMADD231SS ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x289), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VFMA) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_SCALAR) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E3), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_FIXED_128) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_RC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFMADD231SS ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x2A7), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VFMA) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_SCALAR) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E3), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_FIXED_128) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_T1S) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_32) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFMADDCPH ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x970), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_FP16) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_FP16_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_TRUE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_FIXED_512) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_RC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFMADDCPH ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x974), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_FP16) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_FP16_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_TRUE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFMADDCPH ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x978), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_FP16) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_FP16_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_TRUE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFMADDCPH ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x970), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_FP16) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_FP16_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_TRUE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFMADDCPH ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x97C), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_FP16) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_FP16_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_TRUE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_32) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFMADDCPH ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x980), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_FP16) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_FP16_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_TRUE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_32) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFMADDCPH ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x984), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_FP16) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_FP16_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_TRUE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_32) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFMADDCSH ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x974), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_FP16) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_FP16_SCALAR) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E10), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_TRUE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_FIXED_128) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFMADDCSH ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x974), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_FP16) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_FP16_SCALAR) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E10), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_TRUE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_FIXED_128) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_RC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFMADDCSH ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x988), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_FP16) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_FP16_SCALAR) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E10), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_TRUE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_FIXED_128) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_T1S) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_32) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFMADDSUB132PD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x266), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VFMA) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_FIXED_512) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_RC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFMADDSUB132PD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x26B), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VFMA) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFMADDSUB132PD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x270), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VFMA) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFMADDSUB132PD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x266), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VFMA) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFMADDSUB132PD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x275), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VFMA) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_64) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFMADDSUB132PD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x27A), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VFMA) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_64) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFMADDSUB132PD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x27F), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VFMA) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_64) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFMADDSUB132PH ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x9A8), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_FP16) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_FP16_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_FIXED_512) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_RC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFMADDSUB132PH ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x9AC), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_FP16) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_FP16_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFMADDSUB132PH ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x9B0), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_FP16) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_FP16_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFMADDSUB132PH ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x9A8), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_FP16) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_FP16_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFMADDSUB132PH ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x9B4), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_FP16) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_FP16_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_16) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFMADDSUB132PH ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x9B8), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_FP16) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_FP16_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_16) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFMADDSUB132PH ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x9BC), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_FP16) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_FP16_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_16) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFMADDSUB132PS ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x284), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VFMA) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_FIXED_512) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_RC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFMADDSUB132PS ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x289), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VFMA) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFMADDSUB132PS ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x28E), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VFMA) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFMADDSUB132PS ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x284), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VFMA) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFMADDSUB132PS ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x293), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VFMA) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_32) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFMADDSUB132PS ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x298), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VFMA) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_32) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFMADDSUB132PS ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x29D), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VFMA) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_32) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFMADDSUB213PD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x266), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VFMA) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_FIXED_512) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_RC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFMADDSUB213PD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x26B), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VFMA) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFMADDSUB213PD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x270), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VFMA) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFMADDSUB213PD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x266), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VFMA) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFMADDSUB213PD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x275), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VFMA) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_64) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFMADDSUB213PD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x27A), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VFMA) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_64) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFMADDSUB213PD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x27F), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VFMA) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_64) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFMADDSUB213PH ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x9A8), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_FP16) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_FP16_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_FIXED_512) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_RC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFMADDSUB213PH ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x9AC), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_FP16) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_FP16_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFMADDSUB213PH ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x9B0), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_FP16) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_FP16_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFMADDSUB213PH ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x9A8), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_FP16) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_FP16_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFMADDSUB213PH ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x9B4), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_FP16) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_FP16_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_16) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFMADDSUB213PH ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x9B8), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_FP16) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_FP16_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_16) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFMADDSUB213PH ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x9BC), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_FP16) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_FP16_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_16) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFMADDSUB213PS ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x284), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VFMA) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_FIXED_512) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_RC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFMADDSUB213PS ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x289), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VFMA) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFMADDSUB213PS ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x28E), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VFMA) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFMADDSUB213PS ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x284), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VFMA) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFMADDSUB213PS ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x293), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VFMA) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_32) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFMADDSUB213PS ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x298), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VFMA) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_32) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFMADDSUB213PS ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x29D), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VFMA) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_32) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFMADDSUB231PD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x266), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VFMA) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_FIXED_512) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_RC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFMADDSUB231PD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x26B), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VFMA) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFMADDSUB231PD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x270), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VFMA) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFMADDSUB231PD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x266), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VFMA) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFMADDSUB231PD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x275), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VFMA) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_64) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFMADDSUB231PD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x27A), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VFMA) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_64) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFMADDSUB231PD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x27F), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VFMA) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_64) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFMADDSUB231PH ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x9A8), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_FP16) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_FP16_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_FIXED_512) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_RC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFMADDSUB231PH ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x9AC), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_FP16) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_FP16_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFMADDSUB231PH ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x9B0), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_FP16) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_FP16_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFMADDSUB231PH ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x9A8), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_FP16) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_FP16_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFMADDSUB231PH ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x9B4), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_FP16) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_FP16_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_16) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFMADDSUB231PH ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x9B8), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_FP16) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_FP16_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_16) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFMADDSUB231PH ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x9BC), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_FP16) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_FP16_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_16) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFMADDSUB231PS ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x284), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VFMA) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_FIXED_512) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_RC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFMADDSUB231PS ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x289), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VFMA) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFMADDSUB231PS ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x28E), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VFMA) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFMADDSUB231PS ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x284), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VFMA) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFMADDSUB231PS ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x293), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VFMA) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_32) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFMADDSUB231PS ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x298), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VFMA) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_32) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFMADDSUB231PS ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x29D), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VFMA) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_32) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFMSUB132PD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x266), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VFMA) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_FIXED_512) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_RC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFMSUB132PD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x26B), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VFMA) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFMSUB132PD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x270), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VFMA) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFMSUB132PD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x266), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VFMA) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFMSUB132PD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x275), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VFMA) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_64) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFMSUB132PD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x27A), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VFMA) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_64) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFMSUB132PD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x27F), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VFMA) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_64) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFMSUB132PH ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x9A8), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_FP16) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_FP16_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_FIXED_512) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_RC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFMSUB132PH ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x9AC), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_FP16) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_FP16_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFMSUB132PH ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x9B0), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_FP16) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_FP16_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFMSUB132PH ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x9A8), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_FP16) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_FP16_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFMSUB132PH ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x9B4), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_FP16) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_FP16_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_16) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFMSUB132PH ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x9B8), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_FP16) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_FP16_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_16) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFMSUB132PH ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x9BC), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_FP16) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_FP16_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_16) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFMSUB132PS ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x284), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VFMA) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_FIXED_512) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_RC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFMSUB132PS ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x289), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VFMA) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFMSUB132PS ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x28E), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VFMA) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFMSUB132PS ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x284), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VFMA) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFMSUB132PS ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x293), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VFMA) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_32) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFMSUB132PS ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x298), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VFMA) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_32) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFMSUB132PS ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x29D), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VFMA) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_32) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFMSUB132SD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x26B), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VFMA) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_SCALAR) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E3), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_FIXED_128) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFMSUB132SD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x26B), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VFMA) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_SCALAR) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E3), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_FIXED_128) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_RC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFMSUB132SD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x2A2), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VFMA) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_SCALAR) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E3), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_FIXED_128) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_T1S) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_64) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFMSUB132SH ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x9AC), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_FP16) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_FP16_SCALAR) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E3), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_FIXED_128) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFMSUB132SH ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x9AC), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_FP16) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_FP16_SCALAR) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E3), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_FIXED_128) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_RC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFMSUB132SH ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x9C0), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_FP16) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_FP16_SCALAR) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E3), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_FIXED_128) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_T1S) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_16) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFMSUB132SS ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x289), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VFMA) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_SCALAR) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E3), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_FIXED_128) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFMSUB132SS ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x289), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VFMA) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_SCALAR) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E3), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_FIXED_128) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_RC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFMSUB132SS ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x2A7), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VFMA) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_SCALAR) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E3), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_FIXED_128) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_T1S) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_32) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFMSUB213PD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x266), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VFMA) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_FIXED_512) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_RC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFMSUB213PD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x26B), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VFMA) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFMSUB213PD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x270), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VFMA) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFMSUB213PD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x266), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VFMA) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFMSUB213PD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x275), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VFMA) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_64) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFMSUB213PD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x27A), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VFMA) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_64) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFMSUB213PD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x27F), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VFMA) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_64) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFMSUB213PH ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x9A8), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_FP16) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_FP16_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_FIXED_512) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_RC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFMSUB213PH ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x9AC), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_FP16) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_FP16_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFMSUB213PH ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x9B0), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_FP16) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_FP16_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFMSUB213PH ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x9A8), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_FP16) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_FP16_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFMSUB213PH ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x9B4), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_FP16) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_FP16_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_16) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFMSUB213PH ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x9B8), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_FP16) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_FP16_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_16) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFMSUB213PH ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x9BC), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_FP16) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_FP16_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_16) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFMSUB213PS ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x284), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VFMA) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_FIXED_512) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_RC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFMSUB213PS ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x289), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VFMA) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFMSUB213PS ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x28E), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VFMA) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFMSUB213PS ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x284), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VFMA) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFMSUB213PS ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x293), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VFMA) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_32) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFMSUB213PS ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x298), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VFMA) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_32) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFMSUB213PS ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x29D), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VFMA) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_32) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFMSUB213SD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x26B), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VFMA) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_SCALAR) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E3), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_FIXED_128) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFMSUB213SD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x26B), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VFMA) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_SCALAR) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E3), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_FIXED_128) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_RC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFMSUB213SD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x2A2), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VFMA) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_SCALAR) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E3), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_FIXED_128) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_T1S) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_64) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFMSUB213SH ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x9AC), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_FP16) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_FP16_SCALAR) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E3), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_FIXED_128) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFMSUB213SH ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x9AC), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_FP16) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_FP16_SCALAR) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E3), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_FIXED_128) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_RC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFMSUB213SH ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x9C0), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_FP16) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_FP16_SCALAR) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E3), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_FIXED_128) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_T1S) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_16) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFMSUB213SS ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x289), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VFMA) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_SCALAR) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E3), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_FIXED_128) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFMSUB213SS ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x289), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VFMA) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_SCALAR) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E3), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_FIXED_128) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_RC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFMSUB213SS ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x2A7), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VFMA) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_SCALAR) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E3), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_FIXED_128) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_T1S) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_32) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFMSUB231PD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x266), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VFMA) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_FIXED_512) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_RC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFMSUB231PD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x26B), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VFMA) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFMSUB231PD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x270), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VFMA) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFMSUB231PD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x266), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VFMA) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFMSUB231PD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x275), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VFMA) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_64) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFMSUB231PD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x27A), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VFMA) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_64) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFMSUB231PD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x27F), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VFMA) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_64) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFMSUB231PH ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x9A8), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_FP16) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_FP16_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_FIXED_512) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_RC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFMSUB231PH ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x9AC), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_FP16) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_FP16_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFMSUB231PH ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x9B0), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_FP16) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_FP16_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFMSUB231PH ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x9A8), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_FP16) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_FP16_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFMSUB231PH ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x9B4), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_FP16) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_FP16_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_16) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFMSUB231PH ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x9B8), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_FP16) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_FP16_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_16) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFMSUB231PH ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x9BC), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_FP16) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_FP16_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_16) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFMSUB231PS ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x284), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VFMA) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_FIXED_512) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_RC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFMSUB231PS ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x289), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VFMA) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFMSUB231PS ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x28E), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VFMA) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFMSUB231PS ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x284), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VFMA) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFMSUB231PS ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x293), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VFMA) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_32) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFMSUB231PS ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x298), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VFMA) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_32) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFMSUB231PS ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x29D), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VFMA) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_32) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFMSUB231SD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x26B), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VFMA) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_SCALAR) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E3), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_FIXED_128) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFMSUB231SD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x26B), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VFMA) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_SCALAR) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E3), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_FIXED_128) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_RC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFMSUB231SD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x2A2), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VFMA) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_SCALAR) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E3), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_FIXED_128) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_T1S) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_64) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFMSUB231SH ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x9AC), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_FP16) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_FP16_SCALAR) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E3), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_FIXED_128) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFMSUB231SH ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x9AC), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_FP16) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_FP16_SCALAR) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E3), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_FIXED_128) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_RC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFMSUB231SH ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x9C0), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_FP16) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_FP16_SCALAR) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E3), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_FIXED_128) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_T1S) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_16) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFMSUB231SS ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x289), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VFMA) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_SCALAR) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E3), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_FIXED_128) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFMSUB231SS ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x289), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VFMA) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_SCALAR) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E3), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_FIXED_128) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_RC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFMSUB231SS ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x2A7), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VFMA) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_SCALAR) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E3), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_FIXED_128) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_T1S) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_32) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFMSUBADD132PD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x266), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VFMA) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_FIXED_512) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_RC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFMSUBADD132PD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x26B), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VFMA) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFMSUBADD132PD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x270), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VFMA) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFMSUBADD132PD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x266), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VFMA) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFMSUBADD132PD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x275), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VFMA) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_64) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFMSUBADD132PD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x27A), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VFMA) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_64) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFMSUBADD132PD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x27F), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VFMA) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_64) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFMSUBADD132PH ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x9A8), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_FP16) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_FP16_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_FIXED_512) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_RC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFMSUBADD132PH ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x9AC), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_FP16) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_FP16_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFMSUBADD132PH ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x9B0), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_FP16) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_FP16_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFMSUBADD132PH ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x9A8), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_FP16) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_FP16_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFMSUBADD132PH ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x9B4), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_FP16) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_FP16_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_16) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFMSUBADD132PH ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x9B8), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_FP16) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_FP16_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_16) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFMSUBADD132PH ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x9BC), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_FP16) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_FP16_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_16) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFMSUBADD132PS ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x284), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VFMA) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_FIXED_512) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_RC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFMSUBADD132PS ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x289), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VFMA) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFMSUBADD132PS ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x28E), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VFMA) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFMSUBADD132PS ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x284), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VFMA) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFMSUBADD132PS ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x293), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VFMA) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_32) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFMSUBADD132PS ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x298), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VFMA) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_32) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFMSUBADD132PS ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x29D), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VFMA) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_32) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFMSUBADD213PD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x266), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VFMA) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_FIXED_512) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_RC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFMSUBADD213PD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x26B), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VFMA) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFMSUBADD213PD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x270), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VFMA) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFMSUBADD213PD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x266), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VFMA) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFMSUBADD213PD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x275), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VFMA) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_64) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFMSUBADD213PD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x27A), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VFMA) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_64) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFMSUBADD213PD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x27F), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VFMA) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_64) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFMSUBADD213PH ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x9A8), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_FP16) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_FP16_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_FIXED_512) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_RC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFMSUBADD213PH ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x9AC), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_FP16) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_FP16_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFMSUBADD213PH ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x9B0), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_FP16) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_FP16_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFMSUBADD213PH ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x9A8), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_FP16) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_FP16_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFMSUBADD213PH ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x9B4), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_FP16) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_FP16_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_16) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFMSUBADD213PH ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x9B8), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_FP16) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_FP16_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_16) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFMSUBADD213PH ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x9BC), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_FP16) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_FP16_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_16) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFMSUBADD213PS ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x284), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VFMA) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_FIXED_512) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_RC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFMSUBADD213PS ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x289), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VFMA) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFMSUBADD213PS ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x28E), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VFMA) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFMSUBADD213PS ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x284), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VFMA) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFMSUBADD213PS ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x293), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VFMA) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_32) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFMSUBADD213PS ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x298), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VFMA) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_32) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFMSUBADD213PS ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x29D), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VFMA) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_32) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFMSUBADD231PD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x266), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VFMA) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_FIXED_512) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_RC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFMSUBADD231PD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x26B), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VFMA) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFMSUBADD231PD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x270), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VFMA) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFMSUBADD231PD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x266), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VFMA) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFMSUBADD231PD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x275), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VFMA) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_64) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFMSUBADD231PD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x27A), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VFMA) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_64) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFMSUBADD231PD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x27F), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VFMA) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_64) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFMSUBADD231PH ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x9A8), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_FP16) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_FP16_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_FIXED_512) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_RC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFMSUBADD231PH ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x9AC), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_FP16) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_FP16_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFMSUBADD231PH ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x9B0), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_FP16) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_FP16_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFMSUBADD231PH ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x9A8), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_FP16) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_FP16_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFMSUBADD231PH ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x9B4), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_FP16) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_FP16_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_16) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFMSUBADD231PH ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x9B8), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_FP16) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_FP16_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_16) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFMSUBADD231PH ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x9BC), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_FP16) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_FP16_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_16) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFMSUBADD231PS ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x284), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VFMA) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_FIXED_512) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_RC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFMSUBADD231PS ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x289), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VFMA) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFMSUBADD231PS ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x28E), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VFMA) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFMSUBADD231PS ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x284), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VFMA) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFMSUBADD231PS ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x293), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VFMA) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_32) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFMSUBADD231PS ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x298), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VFMA) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_32) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFMSUBADD231PS ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x29D), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VFMA) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_32) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFMULCPH ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x98C), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_FP16) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_FP16_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_TRUE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_FIXED_512) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_RC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFMULCPH ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x990), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_FP16) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_FP16_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_TRUE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFMULCPH ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x994), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_FP16) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_FP16_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_TRUE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFMULCPH ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x98C), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_FP16) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_FP16_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_TRUE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFMULCPH ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x998), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_FP16) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_FP16_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_TRUE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_32) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFMULCPH ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x99C), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_FP16) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_FP16_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_TRUE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_32) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFMULCPH ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x9A0), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_FP16) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_FP16_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_TRUE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_32) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFMULCSH ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x990), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_FP16) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_FP16_SCALAR) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E10), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_TRUE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_FIXED_128) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFMULCSH ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x990), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_FP16) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_FP16_SCALAR) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E10), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_TRUE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_FIXED_128) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_RC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFMULCSH ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x9A4), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_FP16) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_FP16_SCALAR) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E10), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_TRUE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_FIXED_128) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_T1S) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_32) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFNMADD132PD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x266), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VFMA) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_FIXED_512) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_RC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFNMADD132PD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x26B), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VFMA) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFNMADD132PD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x270), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VFMA) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFNMADD132PD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x266), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VFMA) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFNMADD132PD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x275), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VFMA) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_64) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFNMADD132PD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x27A), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VFMA) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_64) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFNMADD132PD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x27F), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VFMA) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_64) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFNMADD132PH ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x9A8), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_FP16) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_FP16_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_FIXED_512) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_RC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFNMADD132PH ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x9AC), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_FP16) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_FP16_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFNMADD132PH ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x9B0), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_FP16) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_FP16_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFNMADD132PH ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x9A8), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_FP16) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_FP16_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFNMADD132PH ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x9B4), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_FP16) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_FP16_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_16) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFNMADD132PH ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x9B8), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_FP16) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_FP16_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_16) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFNMADD132PH ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x9BC), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_FP16) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_FP16_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_16) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFNMADD132PS ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x284), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VFMA) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_FIXED_512) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_RC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFNMADD132PS ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x289), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VFMA) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFNMADD132PS ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x28E), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VFMA) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFNMADD132PS ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x284), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VFMA) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFNMADD132PS ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x293), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VFMA) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_32) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFNMADD132PS ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x298), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VFMA) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_32) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFNMADD132PS ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x29D), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VFMA) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_32) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFNMADD132SD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x26B), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VFMA) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_SCALAR) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E3), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_FIXED_128) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFNMADD132SD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x26B), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VFMA) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_SCALAR) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E3), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_FIXED_128) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_RC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFNMADD132SD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x2A2), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VFMA) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_SCALAR) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E3), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_FIXED_128) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_T1S) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_64) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFNMADD132SH ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x9AC), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_FP16) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_FP16_SCALAR) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E3), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_FIXED_128) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFNMADD132SH ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x9AC), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_FP16) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_FP16_SCALAR) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E3), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_FIXED_128) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_RC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFNMADD132SH ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x9C0), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_FP16) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_FP16_SCALAR) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E3), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_FIXED_128) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_T1S) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_16) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFNMADD132SS ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x289), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VFMA) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_SCALAR) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E3), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_FIXED_128) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFNMADD132SS ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x289), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VFMA) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_SCALAR) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E3), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_FIXED_128) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_RC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFNMADD132SS ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x2A7), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VFMA) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_SCALAR) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E3), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_FIXED_128) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_T1S) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_32) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFNMADD213PD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x266), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VFMA) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_FIXED_512) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_RC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFNMADD213PD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x26B), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VFMA) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFNMADD213PD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x270), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VFMA) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFNMADD213PD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x266), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VFMA) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFNMADD213PD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x275), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VFMA) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_64) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFNMADD213PD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x27A), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VFMA) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_64) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFNMADD213PD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x27F), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VFMA) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_64) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFNMADD213PH ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x9A8), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_FP16) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_FP16_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_FIXED_512) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_RC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFNMADD213PH ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x9AC), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_FP16) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_FP16_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFNMADD213PH ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x9B0), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_FP16) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_FP16_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFNMADD213PH ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x9A8), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_FP16) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_FP16_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFNMADD213PH ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x9B4), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_FP16) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_FP16_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_16) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFNMADD213PH ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x9B8), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_FP16) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_FP16_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_16) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFNMADD213PH ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x9BC), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_FP16) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_FP16_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_16) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFNMADD213PS ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x284), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VFMA) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_FIXED_512) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_RC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFNMADD213PS ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x289), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VFMA) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFNMADD213PS ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x28E), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VFMA) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFNMADD213PS ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x284), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VFMA) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFNMADD213PS ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x293), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VFMA) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_32) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFNMADD213PS ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x298), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VFMA) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_32) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFNMADD213PS ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x29D), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VFMA) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_32) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFNMADD213SD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x26B), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VFMA) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_SCALAR) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E3), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_FIXED_128) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFNMADD213SD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x26B), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VFMA) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_SCALAR) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E3), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_FIXED_128) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_RC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFNMADD213SD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x2A2), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VFMA) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_SCALAR) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E3), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_FIXED_128) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_T1S) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_64) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFNMADD213SH ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x9AC), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_FP16) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_FP16_SCALAR) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E3), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_FIXED_128) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFNMADD213SH ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x9AC), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_FP16) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_FP16_SCALAR) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E3), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_FIXED_128) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_RC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFNMADD213SH ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x9C0), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_FP16) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_FP16_SCALAR) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E3), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_FIXED_128) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_T1S) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_16) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFNMADD213SS ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x289), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VFMA) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_SCALAR) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E3), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_FIXED_128) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFNMADD213SS ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x289), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VFMA) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_SCALAR) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E3), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_FIXED_128) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_RC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFNMADD213SS ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x2A7), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VFMA) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_SCALAR) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E3), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_FIXED_128) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_T1S) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_32) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFNMADD231PD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x266), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VFMA) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_FIXED_512) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_RC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFNMADD231PD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x26B), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VFMA) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFNMADD231PD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x270), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VFMA) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFNMADD231PD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x266), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VFMA) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFNMADD231PD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x275), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VFMA) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_64) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFNMADD231PD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x27A), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VFMA) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_64) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFNMADD231PD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x27F), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VFMA) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_64) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFNMADD231PH ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x9A8), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_FP16) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_FP16_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_FIXED_512) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_RC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFNMADD231PH ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x9AC), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_FP16) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_FP16_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFNMADD231PH ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x9B0), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_FP16) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_FP16_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFNMADD231PH ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x9A8), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_FP16) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_FP16_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFNMADD231PH ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x9B4), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_FP16) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_FP16_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_16) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFNMADD231PH ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x9B8), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_FP16) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_FP16_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_16) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFNMADD231PH ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x9BC), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_FP16) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_FP16_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_16) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFNMADD231PS ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x284), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VFMA) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_FIXED_512) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_RC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFNMADD231PS ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x289), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VFMA) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFNMADD231PS ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x28E), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VFMA) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFNMADD231PS ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x284), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VFMA) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFNMADD231PS ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x293), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VFMA) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_32) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFNMADD231PS ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x298), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VFMA) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_32) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFNMADD231PS ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x29D), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VFMA) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_32) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFNMADD231SD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x26B), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VFMA) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_SCALAR) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E3), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_FIXED_128) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFNMADD231SD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x26B), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VFMA) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_SCALAR) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E3), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_FIXED_128) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_RC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFNMADD231SD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x2A2), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VFMA) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_SCALAR) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E3), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_FIXED_128) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_T1S) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_64) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFNMADD231SH ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x9AC), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_FP16) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_FP16_SCALAR) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E3), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_FIXED_128) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFNMADD231SH ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x9AC), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_FP16) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_FP16_SCALAR) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E3), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_FIXED_128) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_RC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFNMADD231SH ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x9C0), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_FP16) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_FP16_SCALAR) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E3), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_FIXED_128) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_T1S) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_16) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFNMADD231SS ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x289), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VFMA) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_SCALAR) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E3), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_FIXED_128) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFNMADD231SS ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x289), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VFMA) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_SCALAR) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E3), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_FIXED_128) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_RC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFNMADD231SS ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x2A7), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VFMA) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_SCALAR) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E3), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_FIXED_128) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_T1S) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_32) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFNMSUB132PD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x266), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VFMA) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_FIXED_512) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_RC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFNMSUB132PD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x26B), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VFMA) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFNMSUB132PD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x270), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VFMA) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFNMSUB132PD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x266), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VFMA) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFNMSUB132PD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x275), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VFMA) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_64) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFNMSUB132PD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x27A), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VFMA) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_64) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFNMSUB132PD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x27F), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VFMA) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_64) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFNMSUB132PH ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x9A8), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_FP16) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_FP16_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_FIXED_512) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_RC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFNMSUB132PH ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x9AC), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_FP16) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_FP16_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFNMSUB132PH ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x9B0), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_FP16) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_FP16_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFNMSUB132PH ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x9A8), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_FP16) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_FP16_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFNMSUB132PH ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x9B4), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_FP16) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_FP16_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_16) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFNMSUB132PH ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x9B8), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_FP16) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_FP16_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_16) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFNMSUB132PH ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x9BC), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_FP16) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_FP16_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_16) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFNMSUB132PS ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x284), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VFMA) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_FIXED_512) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_RC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFNMSUB132PS ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x289), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VFMA) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFNMSUB132PS ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x28E), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VFMA) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFNMSUB132PS ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x284), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VFMA) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFNMSUB132PS ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x293), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VFMA) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_32) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFNMSUB132PS ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x298), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VFMA) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_32) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFNMSUB132PS ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x29D), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VFMA) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_32) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFNMSUB132SD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x26B), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VFMA) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_SCALAR) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E3), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_FIXED_128) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFNMSUB132SD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x26B), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VFMA) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_SCALAR) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E3), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_FIXED_128) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_RC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFNMSUB132SD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x2A2), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VFMA) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_SCALAR) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E3), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_FIXED_128) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_T1S) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_64) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFNMSUB132SH ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x9AC), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_FP16) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_FP16_SCALAR) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E3), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_FIXED_128) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFNMSUB132SH ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x9AC), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_FP16) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_FP16_SCALAR) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E3), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_FIXED_128) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_RC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFNMSUB132SH ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x9C0), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_FP16) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_FP16_SCALAR) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E3), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_FIXED_128) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_T1S) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_16) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFNMSUB132SS ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x289), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VFMA) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_SCALAR) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E3), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_FIXED_128) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFNMSUB132SS ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x289), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VFMA) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_SCALAR) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E3), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_FIXED_128) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_RC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFNMSUB132SS ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x2A7), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VFMA) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_SCALAR) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E3), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_FIXED_128) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_T1S) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_32) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFNMSUB213PD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x266), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VFMA) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_FIXED_512) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_RC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFNMSUB213PD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x26B), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VFMA) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFNMSUB213PD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x270), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VFMA) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFNMSUB213PD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x266), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VFMA) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFNMSUB213PD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x275), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VFMA) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_64) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFNMSUB213PD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x27A), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VFMA) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_64) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFNMSUB213PD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x27F), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VFMA) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_64) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFNMSUB213PH ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x9A8), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_FP16) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_FP16_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_FIXED_512) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_RC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFNMSUB213PH ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x9AC), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_FP16) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_FP16_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFNMSUB213PH ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x9B0), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_FP16) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_FP16_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFNMSUB213PH ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x9A8), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_FP16) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_FP16_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFNMSUB213PH ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x9B4), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_FP16) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_FP16_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_16) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFNMSUB213PH ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x9B8), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_FP16) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_FP16_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_16) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFNMSUB213PH ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x9BC), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_FP16) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_FP16_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_16) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFNMSUB213PS ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x284), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VFMA) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_FIXED_512) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_RC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFNMSUB213PS ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x289), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VFMA) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFNMSUB213PS ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x28E), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VFMA) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFNMSUB213PS ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x284), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VFMA) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFNMSUB213PS ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x293), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VFMA) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_32) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFNMSUB213PS ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x298), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VFMA) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_32) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFNMSUB213PS ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x29D), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VFMA) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_32) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFNMSUB213SD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x26B), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VFMA) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_SCALAR) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E3), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_FIXED_128) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFNMSUB213SD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x26B), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VFMA) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_SCALAR) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E3), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_FIXED_128) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_RC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFNMSUB213SD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x2A2), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VFMA) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_SCALAR) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E3), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_FIXED_128) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_T1S) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_64) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFNMSUB213SH ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x9AC), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_FP16) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_FP16_SCALAR) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E3), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_FIXED_128) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFNMSUB213SH ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x9AC), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_FP16) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_FP16_SCALAR) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E3), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_FIXED_128) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_RC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFNMSUB213SH ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x9C0), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_FP16) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_FP16_SCALAR) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E3), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_FIXED_128) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_T1S) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_16) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFNMSUB213SS ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x289), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VFMA) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_SCALAR) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E3), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_FIXED_128) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFNMSUB213SS ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x289), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VFMA) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_SCALAR) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E3), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_FIXED_128) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_RC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFNMSUB213SS ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x2A7), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VFMA) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_SCALAR) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E3), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_FIXED_128) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_T1S) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_32) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFNMSUB231PD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x266), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VFMA) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_FIXED_512) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_RC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFNMSUB231PD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x26B), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VFMA) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFNMSUB231PD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x270), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VFMA) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFNMSUB231PD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x266), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VFMA) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFNMSUB231PD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x275), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VFMA) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_64) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFNMSUB231PD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x27A), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VFMA) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_64) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFNMSUB231PD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x27F), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VFMA) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_64) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFNMSUB231PH ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x9A8), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_FP16) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_FP16_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_FIXED_512) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_RC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFNMSUB231PH ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x9AC), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_FP16) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_FP16_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFNMSUB231PH ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x9B0), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_FP16) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_FP16_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFNMSUB231PH ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x9A8), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_FP16) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_FP16_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFNMSUB231PH ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x9B4), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_FP16) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_FP16_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_16) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFNMSUB231PH ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x9B8), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_FP16) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_FP16_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_16) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFNMSUB231PH ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x9BC), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_FP16) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_FP16_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_16) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFNMSUB231PS ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x284), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VFMA) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_FIXED_512) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_RC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFNMSUB231PS ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x289), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VFMA) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFNMSUB231PS ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x28E), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VFMA) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFNMSUB231PS ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x284), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VFMA) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFNMSUB231PS ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x293), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VFMA) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_32) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFNMSUB231PS ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x298), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VFMA) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_32) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFNMSUB231PS ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x29D), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VFMA) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_32) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFNMSUB231SD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x26B), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VFMA) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_SCALAR) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E3), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_FIXED_128) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFNMSUB231SD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x26B), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VFMA) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_SCALAR) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E3), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_FIXED_128) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_RC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFNMSUB231SD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x2A2), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VFMA) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_SCALAR) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E3), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_FIXED_128) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_T1S) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_64) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFNMSUB231SH ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x9AC), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_FP16) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_FP16_SCALAR) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E3), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_FIXED_128) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFNMSUB231SH ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x9AC), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_FP16) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_FP16_SCALAR) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E3), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_FIXED_128) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_RC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFNMSUB231SH ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x9C0), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_FP16) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_FP16_SCALAR) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E3), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_FIXED_128) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_T1S) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_16) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFNMSUB231SS ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x289), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VFMA) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_SCALAR) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E3), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_FIXED_128) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFNMSUB231SS ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x289), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VFMA) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_SCALAR) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E3), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_FIXED_128) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_RC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFNMSUB231SS ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x2A7), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VFMA) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_SCALAR) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E3), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_FIXED_128) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_T1S) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_32) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFPCLASSPD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x9C4), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512DQ_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_MASK, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_ZEROING) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFPCLASSPD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x9C8), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512DQ_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_MASK, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_ZEROING) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFPCLASSPD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x9CC), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512DQ_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_MASK, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_ZEROING) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFPCLASSPD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x9D0), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512DQ_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_MASK, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_64) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_ZEROING) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFPCLASSPD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x9D0), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512DQ_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_MASK, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_64) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_ZEROING) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFPCLASSPD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x9D0), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512DQ_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_MASK, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_64) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_ZEROING) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFPCLASSPH ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x9D4), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_FP16) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_FP16_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_MASK, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFPCLASSPH ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x9D8), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_FP16) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_FP16_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_MASK, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFPCLASSPH ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x9DC), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_FP16) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_FP16_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_MASK, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFPCLASSPH ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x9E0), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_FP16) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_FP16_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_MASK, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_16) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFPCLASSPH ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x9E0), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_FP16) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_FP16_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_MASK, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_16) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFPCLASSPH ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x9E0), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_FP16) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_FP16_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_MASK, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_16) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFPCLASSPS ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x9E4), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512DQ_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_MASK, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_ZEROING) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFPCLASSPS ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x9E8), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512DQ_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_MASK, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_ZEROING) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFPCLASSPS ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x9EC), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512DQ_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_MASK, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_ZEROING) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFPCLASSPS ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x9F0), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512DQ_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_MASK, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_32) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_ZEROING) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFPCLASSPS ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x9F0), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512DQ_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_MASK, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_32) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_ZEROING) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFPCLASSPS ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x9F0), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512DQ_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_MASK, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_32) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_ZEROING) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFPCLASSSD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x9C4), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512DQ_SCALAR) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E6), ZYDIS_REGKIND_MASK, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_FIXED_128) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_ZEROING) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFPCLASSSD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x9F4), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512DQ_SCALAR) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E6), ZYDIS_REGKIND_MASK, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_FIXED_128) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_T1S) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_64) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_ZEROING) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFPCLASSSH ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x9D4), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_FP16) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_FP16_SCALAR) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E10), ZYDIS_REGKIND_MASK, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_FIXED_128) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFPCLASSSH ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x9F8), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_FP16) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_FP16_SCALAR) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E10), ZYDIS_REGKIND_MASK, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_FIXED_128) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_T1S) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_16) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFPCLASSSS ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x9E4), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512DQ_SCALAR) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E6), ZYDIS_REGKIND_MASK, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_FIXED_128) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_ZEROING) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFPCLASSSS ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x9FC), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512DQ_SCALAR) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E6), ZYDIS_REGKIND_MASK, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_FIXED_128) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_T1S) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_32) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_ZEROING) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VGATHERDPD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x16CE), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_GATHER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E12), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_VSIB | (1 << 3) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_TRUE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_GSCAT) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_64) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_REQUIRED, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VGATHERDPD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x16D1), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_GATHER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E12), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_VSIB | (1 << 3) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_TRUE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_GSCAT) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_64) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_REQUIRED, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VGATHERDPD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x16D4), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_GATHER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E12), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_VSIB | (1 << 3) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_TRUE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_GSCAT) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_64) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_REQUIRED, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VGATHERDPS ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x16D7), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_GATHER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E12), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_VSIB | (1 << 3) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_TRUE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_GSCAT) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_32) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_REQUIRED, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VGATHERDPS ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x16DA), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_GATHER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E12), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_VSIB | (1 << 3) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_TRUE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_GSCAT) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_32) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_REQUIRED, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VGATHERDPS ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x16DD), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_GATHER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E12), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_VSIB | (1 << 3) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_TRUE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_GSCAT) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_32) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_REQUIRED, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VGATHERPF0DPD ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1EA1), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_GATHER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512PF_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E12NP), 0, ZYDIS_MEMOP_TYPE_VSIB | (1 << 3) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_TRUE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_GSCAT) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_64) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_REQUIRED, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VGATHERPF0DPS ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1EA3), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_GATHER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512PF_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E12NP), 0, ZYDIS_MEMOP_TYPE_VSIB | (1 << 3) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_TRUE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_GSCAT) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_32) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_REQUIRED, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VGATHERPF0QPD ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1EA5), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_GATHER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512PF_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E12NP), 0, ZYDIS_MEMOP_TYPE_VSIB | (1 << 3) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_TRUE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_GSCAT) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_64) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_REQUIRED, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VGATHERPF0QPS ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1EA3), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_GATHER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512PF_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E12NP), 0, ZYDIS_MEMOP_TYPE_VSIB | (1 << 3) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_TRUE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_GSCAT) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_32) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_REQUIRED, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VGATHERPF1DPD ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1EA1), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_GATHER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512PF_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E12NP), 0, ZYDIS_MEMOP_TYPE_VSIB | (1 << 3) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_TRUE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_GSCAT) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_64) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_REQUIRED, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VGATHERPF1DPS ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1EA3), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_GATHER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512PF_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E12NP), 0, ZYDIS_MEMOP_TYPE_VSIB | (1 << 3) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_TRUE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_GSCAT) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_32) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_REQUIRED, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VGATHERPF1QPD ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1EA5), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_GATHER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512PF_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E12NP), 0, ZYDIS_MEMOP_TYPE_VSIB | (1 << 3) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_TRUE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_GSCAT) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_64) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_REQUIRED, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VGATHERPF1QPS ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1EA3), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_GATHER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512PF_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E12NP), 0, ZYDIS_MEMOP_TYPE_VSIB | (1 << 3) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_TRUE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_GSCAT) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_32) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_REQUIRED, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VGATHERQPD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x16CE), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_GATHER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E12), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_VSIB | (1 << 3) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_TRUE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_GSCAT) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_64) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_REQUIRED, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VGATHERQPD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x16E0), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_GATHER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E12), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_VSIB | (1 << 3) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_TRUE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_GSCAT) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_64) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_REQUIRED, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VGATHERQPD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x16E3), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_GATHER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E12), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_VSIB | (1 << 3) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_TRUE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_GSCAT) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_64) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_REQUIRED, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VGATHERQPS ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x16D7), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_GATHER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E12), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_VSIB | (1 << 3) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_TRUE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_GSCAT) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_32) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_REQUIRED, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VGATHERQPS ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x16E6), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_GATHER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E12), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_VSIB | (1 << 3) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_TRUE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_GSCAT) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_32) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_REQUIRED, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VGATHERQPS ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x16E9), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_GATHER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E12), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_VSIB | (1 << 3) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_TRUE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_GSCAT) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_32) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_REQUIRED, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VGETEXPPD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0xA00), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_FIXED_512) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_SAE), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VGETEXPPD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0xA04), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VGETEXPPD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0xA08), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VGETEXPPD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0xA00), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VGETEXPPD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0xA0C), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_64) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VGETEXPPD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0xA10), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_64) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VGETEXPPD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0xA14), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_64) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VGETEXPPH ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0xA18), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_FP16) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_FP16_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_FIXED_512) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_SAE), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VGETEXPPH ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0xA1C), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_FP16) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_FP16_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VGETEXPPH ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0xA20), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_FP16) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_FP16_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VGETEXPPH ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0xA18), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_FP16) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_FP16_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VGETEXPPH ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0xA24), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_FP16) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_FP16_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_16) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VGETEXPPH ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0xA28), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_FP16) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_FP16_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_16) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VGETEXPPH ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0xA2C), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_FP16) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_FP16_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_16) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VGETEXPPS ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0xA30), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_FIXED_512) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_SAE), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VGETEXPPS ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0xA34), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VGETEXPPS ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0xA38), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VGETEXPPS ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0xA30), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VGETEXPPS ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0xA3C), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_32) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VGETEXPPS ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0xA40), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_32) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VGETEXPPS ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0xA44), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_32) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VGETEXPSD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x2AC), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_SCALAR) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E3), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_FIXED_128) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VGETEXPSD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x2AC), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_SCALAR) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E3), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_FIXED_128) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_SAE), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VGETEXPSD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x2B1), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_SCALAR) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E3), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_FIXED_128) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_T1S) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_64) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VGETEXPSH ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x2B6), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_FP16) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_FP16_SCALAR) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E3), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_FIXED_128) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VGETEXPSH ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x2B6), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_FP16) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_FP16_SCALAR) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E3), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_FIXED_128) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_SAE), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VGETEXPSH ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x2BB), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_FP16) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_FP16_SCALAR) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E3), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_FIXED_128) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_T1S) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_16) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VGETEXPSS ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x2C0), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_SCALAR) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E3), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_FIXED_128) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VGETEXPSS ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x2C0), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_SCALAR) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E3), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_FIXED_128) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_SAE), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VGETEXPSS ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x2C5), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_SCALAR) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E3), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_FIXED_128) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_T1S) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_32) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VGETMANTPD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xA00), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_FIXED_512) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_SAE), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VGETMANTPD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xA04), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VGETMANTPD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xA08), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VGETMANTPD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xA00), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VGETMANTPD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xA0C), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_64) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VGETMANTPD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xA10), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_64) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VGETMANTPD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xA14), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_64) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VGETMANTPH ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xA18), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_FP16) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_FP16_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_FIXED_512) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_SAE), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VGETMANTPH ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xA1C), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_FP16) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_FP16_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VGETMANTPH ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xA20), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_FP16) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_FP16_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VGETMANTPH ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xA18), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_FP16) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_FP16_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VGETMANTPH ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xA24), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_FP16) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_FP16_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_16) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VGETMANTPH ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xA28), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_FP16) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_FP16_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_16) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VGETMANTPH ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xA2C), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_FP16) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_FP16_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_16) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VGETMANTPS ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xA30), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_FIXED_512) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_SAE), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VGETMANTPS ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xA34), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VGETMANTPS ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xA38), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VGETMANTPS ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xA30), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VGETMANTPS ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xA3C), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_32) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VGETMANTPS ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xA40), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_32) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VGETMANTPS ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xA44), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_32) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VGETMANTSD ZYDIS_NOTMIN(5) ZYDIS_NOTMIN(5) ZYDIS_NOTMIN(0x2AC), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_SCALAR) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E3), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_FIXED_128) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VGETMANTSD ZYDIS_NOTMIN(5) ZYDIS_NOTMIN(5) ZYDIS_NOTMIN(0x2AC), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_SCALAR) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E3), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_FIXED_128) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_SAE), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VGETMANTSD ZYDIS_NOTMIN(5) ZYDIS_NOTMIN(5) ZYDIS_NOTMIN(0x2B1), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_SCALAR) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E3), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_FIXED_128) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_T1S) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_64) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VGETMANTSH ZYDIS_NOTMIN(5) ZYDIS_NOTMIN(5) ZYDIS_NOTMIN(0x2B6), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_FP16) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_FP16_SCALAR) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E3), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_FIXED_128) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VGETMANTSH ZYDIS_NOTMIN(5) ZYDIS_NOTMIN(5) ZYDIS_NOTMIN(0x2B6), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_FP16) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_FP16_SCALAR) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E3), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_FIXED_128) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_SAE), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VGETMANTSH ZYDIS_NOTMIN(5) ZYDIS_NOTMIN(5) ZYDIS_NOTMIN(0x2BB), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_FP16) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_FP16_SCALAR) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E3), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_FIXED_128) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_T1S) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_16) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VGETMANTSS ZYDIS_NOTMIN(5) ZYDIS_NOTMIN(5) ZYDIS_NOTMIN(0x2C0), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_SCALAR) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E3), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_FIXED_128) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VGETMANTSS ZYDIS_NOTMIN(5) ZYDIS_NOTMIN(5) ZYDIS_NOTMIN(0x2C0), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_SCALAR) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E3), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_FIXED_128) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_SAE), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VGETMANTSS ZYDIS_NOTMIN(5) ZYDIS_NOTMIN(5) ZYDIS_NOTMIN(0x2C5), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_SCALAR) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E3), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_FIXED_128) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_T1S) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_32) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VGF2P8AFFINEINVQB ZYDIS_NOTMIN(5) ZYDIS_NOTMIN(5) ZYDIS_NOTMIN(0x2CA), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_GFNI) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_GFNI_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VGF2P8AFFINEINVQB ZYDIS_NOTMIN(5) ZYDIS_NOTMIN(5) ZYDIS_NOTMIN(0x2CF), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_GFNI) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_GFNI_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VGF2P8AFFINEINVQB ZYDIS_NOTMIN(5) ZYDIS_NOTMIN(5) ZYDIS_NOTMIN(0x2D4), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_GFNI) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_GFNI_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VGF2P8AFFINEINVQB ZYDIS_NOTMIN(5) ZYDIS_NOTMIN(5) ZYDIS_NOTMIN(0x2D9), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_GFNI) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_GFNI_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_64) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VGF2P8AFFINEINVQB ZYDIS_NOTMIN(5) ZYDIS_NOTMIN(5) ZYDIS_NOTMIN(0x2DE), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_GFNI) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_GFNI_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_64) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VGF2P8AFFINEINVQB ZYDIS_NOTMIN(5) ZYDIS_NOTMIN(5) ZYDIS_NOTMIN(0x2E3), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_GFNI) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_GFNI_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_64) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VGF2P8AFFINEQB ZYDIS_NOTMIN(5) ZYDIS_NOTMIN(5) ZYDIS_NOTMIN(0x2CA), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_GFNI) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_GFNI_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VGF2P8AFFINEQB ZYDIS_NOTMIN(5) ZYDIS_NOTMIN(5) ZYDIS_NOTMIN(0x2CF), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_GFNI) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_GFNI_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VGF2P8AFFINEQB ZYDIS_NOTMIN(5) ZYDIS_NOTMIN(5) ZYDIS_NOTMIN(0x2D4), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_GFNI) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_GFNI_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VGF2P8AFFINEQB ZYDIS_NOTMIN(5) ZYDIS_NOTMIN(5) ZYDIS_NOTMIN(0x2D9), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_GFNI) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_GFNI_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_64) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VGF2P8AFFINEQB ZYDIS_NOTMIN(5) ZYDIS_NOTMIN(5) ZYDIS_NOTMIN(0x2DE), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_GFNI) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_GFNI_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_64) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VGF2P8AFFINEQB ZYDIS_NOTMIN(5) ZYDIS_NOTMIN(5) ZYDIS_NOTMIN(0x2E3), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_GFNI) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_GFNI_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_64) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VGF2P8MULB ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x360), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_GFNI) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_GFNI_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VGF2P8MULB ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x365), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_GFNI) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_GFNI_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VGF2P8MULB ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x36A), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_GFNI) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_GFNI_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VGF2P8MULB ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x36F), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_GFNI) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_GFNI_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FVM) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_8) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VGF2P8MULB ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x374), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_GFNI) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_GFNI_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FVM) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_8) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VGF2P8MULB ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x379), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_GFNI) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_GFNI_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FVM) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_8) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VINSERTF32X4 ZYDIS_NOTMIN(5) ZYDIS_NOTMIN(5) ZYDIS_NOTMIN(0x2E8), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E6NF), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VINSERTF32X4 ZYDIS_NOTMIN(5) ZYDIS_NOTMIN(5) ZYDIS_NOTMIN(0x2ED), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E6NF), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VINSERTF32X4 ZYDIS_NOTMIN(5) ZYDIS_NOTMIN(5) ZYDIS_NOTMIN(0x2F2), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E6NF), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_T4) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_32) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VINSERTF32X4 ZYDIS_NOTMIN(5) ZYDIS_NOTMIN(5) ZYDIS_NOTMIN(0x2F7), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E6NF), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_T4) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_32) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VINSERTF32X8 ZYDIS_NOTMIN(5) ZYDIS_NOTMIN(5) ZYDIS_NOTMIN(0x2FC), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512DQ_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E6NF), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VINSERTF32X8 ZYDIS_NOTMIN(5) ZYDIS_NOTMIN(5) ZYDIS_NOTMIN(0x301), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512DQ_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E6NF), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_T8) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_32) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VINSERTF64X2 ZYDIS_NOTMIN(5) ZYDIS_NOTMIN(5) ZYDIS_NOTMIN(0x306), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512DQ_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E6NF), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VINSERTF64X2 ZYDIS_NOTMIN(5) ZYDIS_NOTMIN(5) ZYDIS_NOTMIN(0x30B), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512DQ_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E6NF), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VINSERTF64X2 ZYDIS_NOTMIN(5) ZYDIS_NOTMIN(5) ZYDIS_NOTMIN(0x310), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512DQ_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E6NF), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_T2) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_64) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VINSERTF64X2 ZYDIS_NOTMIN(5) ZYDIS_NOTMIN(5) ZYDIS_NOTMIN(0x315), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512DQ_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E6NF), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_T2) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_64) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VINSERTF64X4 ZYDIS_NOTMIN(5) ZYDIS_NOTMIN(5) ZYDIS_NOTMIN(0x31A), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E6NF), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VINSERTF64X4 ZYDIS_NOTMIN(5) ZYDIS_NOTMIN(5) ZYDIS_NOTMIN(0x31F), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E6NF), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_T4) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_64) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VINSERTI32X4 ZYDIS_NOTMIN(5) ZYDIS_NOTMIN(5) ZYDIS_NOTMIN(0x324), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E6NF), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VINSERTI32X4 ZYDIS_NOTMIN(5) ZYDIS_NOTMIN(5) ZYDIS_NOTMIN(0x329), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E6NF), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VINSERTI32X4 ZYDIS_NOTMIN(5) ZYDIS_NOTMIN(5) ZYDIS_NOTMIN(0x32E), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E6NF), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_T4) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_32) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VINSERTI32X4 ZYDIS_NOTMIN(5) ZYDIS_NOTMIN(5) ZYDIS_NOTMIN(0x333), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E6NF), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_T4) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_32) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VINSERTI32X8 ZYDIS_NOTMIN(5) ZYDIS_NOTMIN(5) ZYDIS_NOTMIN(0x338), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512DQ_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E6NF), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VINSERTI32X8 ZYDIS_NOTMIN(5) ZYDIS_NOTMIN(5) ZYDIS_NOTMIN(0x33D), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512DQ_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E6NF), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_T8) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_32) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VINSERTI64X2 ZYDIS_NOTMIN(5) ZYDIS_NOTMIN(5) ZYDIS_NOTMIN(0x342), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512DQ_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E6NF), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VINSERTI64X2 ZYDIS_NOTMIN(5) ZYDIS_NOTMIN(5) ZYDIS_NOTMIN(0x347), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512DQ_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E6NF), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VINSERTI64X2 ZYDIS_NOTMIN(5) ZYDIS_NOTMIN(5) ZYDIS_NOTMIN(0x34C), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512DQ_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E6NF), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_T2) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_64) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VINSERTI64X2 ZYDIS_NOTMIN(5) ZYDIS_NOTMIN(5) ZYDIS_NOTMIN(0x351), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512DQ_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E6NF), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_T2) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_64) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VINSERTI64X4 ZYDIS_NOTMIN(5) ZYDIS_NOTMIN(5) ZYDIS_NOTMIN(0x356), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E6NF), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VINSERTI64X4 ZYDIS_NOTMIN(5) ZYDIS_NOTMIN(5) ZYDIS_NOTMIN(0x35B), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E6NF), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_T4) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_64) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VINSERTPS ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x754), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_128N) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E9NF), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_FORBIDDEN, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VINSERTPS ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x7F4), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_128N) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E9NF), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_T1F) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_32) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_FORBIDDEN, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VMAXPD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x4C8), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_FIXED_512) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_SAE), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VMAXPD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x2AC), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VMAXPD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x4CD), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VMAXPD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x4C8), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VMAXPD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x4D2), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_64) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VMAXPD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x4D7), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_64) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VMAXPD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x4DC), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_64) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VMAXPH ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x884), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_FP16) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_FP16_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_FIXED_512) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_SAE), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VMAXPH ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x2B6), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_FP16) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_FP16_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VMAXPH ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x888), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_FP16) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_FP16_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VMAXPH ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x884), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_FP16) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_FP16_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VMAXPH ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x88C), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_FP16) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_FP16_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_16) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VMAXPH ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x890), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_FP16) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_FP16_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_16) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VMAXPH ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x894), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_FP16) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_FP16_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_16) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VMAXPS ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x4E1), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_FIXED_512) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_SAE), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VMAXPS ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x2C0), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VMAXPS ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x4E6), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VMAXPS ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x4E1), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VMAXPS ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x4EB), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_32) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VMAXPS ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x4F0), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_32) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VMAXPS ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x4F5), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_32) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VMAXSD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x2AC), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_SCALAR) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E3), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_FIXED_128) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VMAXSD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x2AC), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_SCALAR) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E3), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_FIXED_128) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_SAE), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VMAXSD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x2B1), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_SCALAR) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E3), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_FIXED_128) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_T1S) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_64) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VMAXSH ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x2B6), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_FP16) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_FP16_SCALAR) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E3), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_FIXED_128) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VMAXSH ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x2B6), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_FP16) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_FP16_SCALAR) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E3), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_FIXED_128) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_SAE), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VMAXSH ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x2BB), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_FP16) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_FP16_SCALAR) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E3), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_FIXED_128) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_T1S) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_16) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VMAXSS ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x2C0), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_SCALAR) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E3), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_FIXED_128) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VMAXSS ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x2C0), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_SCALAR) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E3), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_FIXED_128) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_SAE), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VMAXSS ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x2C5), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_SCALAR) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E3), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_FIXED_128) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_T1S) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_32) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VMINPD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x4C8), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_FIXED_512) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_SAE), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VMINPD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x2AC), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VMINPD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x4CD), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VMINPD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x4C8), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VMINPD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x4D2), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_64) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VMINPD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x4D7), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_64) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VMINPD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x4DC), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_64) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VMINPH ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x884), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_FP16) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_FP16_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_FIXED_512) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_SAE), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VMINPH ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x2B6), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_FP16) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_FP16_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VMINPH ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x888), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_FP16) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_FP16_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VMINPH ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x884), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_FP16) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_FP16_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VMINPH ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x88C), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_FP16) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_FP16_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_16) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VMINPH ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x890), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_FP16) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_FP16_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_16) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VMINPH ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x894), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_FP16) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_FP16_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_16) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VMINPS ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x4E1), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_FIXED_512) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_SAE), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VMINPS ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x2C0), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VMINPS ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x4E6), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VMINPS ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x4E1), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VMINPS ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x4EB), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_32) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VMINPS ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x4F0), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_32) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VMINPS ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x4F5), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_32) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VMINSD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x2AC), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_SCALAR) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E3), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_FIXED_128) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VMINSD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x2AC), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_SCALAR) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E3), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_FIXED_128) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_SAE), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VMINSD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x2B1), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_SCALAR) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E3), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_FIXED_128) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_T1S) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_64) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VMINSH ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x2B6), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_FP16) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_FP16_SCALAR) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E3), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_FIXED_128) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VMINSH ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x2B6), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_FP16) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_FP16_SCALAR) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E3), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_FIXED_128) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_SAE), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VMINSH ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x2BB), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_FP16) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_FP16_SCALAR) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E3), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_FIXED_128) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_T1S) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_16) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VMINSS ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x2C0), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_SCALAR) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E3), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_FIXED_128) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VMINSS ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x2C0), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_SCALAR) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E3), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_FIXED_128) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_SAE), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VMINSS ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x2C5), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_SCALAR) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E3), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_FIXED_128) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_T1S) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_32) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VMOVAPD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0xA04), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E1), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VMOVAPD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0xA08), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E1), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VMOVAPD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0xA00), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E1), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VMOVAPD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x16B9), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E1), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FVM) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_64) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VMOVAPD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x16BC), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E1), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FVM) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_64) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VMOVAPD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x16BF), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E1), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FVM) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_64) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VMOVAPD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1440), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E1), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VMOVAPD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1443), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E1), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VMOVAPD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1446), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E1), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VMOVAPD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1449), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E1), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FVM) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_64) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VMOVAPD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x144C), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E1), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FVM) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_64) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VMOVAPD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x144F), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E1), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FVM) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_64) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VMOVAPS ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0xA34), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E1), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VMOVAPS ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0xA38), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E1), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VMOVAPS ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0xA30), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E1), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VMOVAPS ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x16C2), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E1), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FVM) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_32) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VMOVAPS ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x16C5), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E1), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FVM) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_32) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VMOVAPS ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x16C8), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E1), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FVM) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_32) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VMOVAPS ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1452), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E1), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VMOVAPS ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1455), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E1), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VMOVAPS ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1458), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E1), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VMOVAPS ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x145B), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E1), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FVM) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_32) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VMOVAPS ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x145E), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E1), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FVM) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_32) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VMOVAPS ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1461), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E1), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FVM) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_32) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VMOVD ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1DF7), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_128N) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E9NF), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_GPR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_FORBIDDEN, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VMOVD ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1C01), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_128N) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E9NF), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_T1S) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_32) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_FORBIDDEN, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VMOVD ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1DF7), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_128N) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E9NF), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_GPR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_FORBIDDEN, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VMOVD ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1C01), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_128N) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E9NF), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_T1S) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_32) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_FORBIDDEN, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VMOVD ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xE46), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_128N) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E9NF), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_GPR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_FORBIDDEN, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VMOVD ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xF72), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_128N) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E9NF), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_T1S) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_32) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_FORBIDDEN, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VMOVD ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xE46), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_128N) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E9NF), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_GPR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_FORBIDDEN, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VMOVD ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xF72), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_128N) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E9NF), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_T1S) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_32) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_FORBIDDEN, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VMOVDDUP ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0xA04), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E5NF), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VMOVDDUP ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0xA08), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E5NF), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VMOVDDUP ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0xA00), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E5NF), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VMOVDDUP ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x16EC), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E5NF), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_DUP) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_64) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VMOVDDUP ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x16BC), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E5NF), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_DUP) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_64) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VMOVDDUP ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x16BF), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E5NF), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_DUP) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_64) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VMOVDQA32 ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x16EF), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E1), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VMOVDQA32 ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x16F2), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E1), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VMOVDQA32 ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x16F5), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E1), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VMOVDQA32 ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x16F8), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E1), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FVM) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_32) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VMOVDQA32 ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x16FB), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E1), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FVM) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_32) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VMOVDQA32 ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x16FE), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E1), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FVM) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_32) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VMOVDQA32 ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1701), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E1), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VMOVDQA32 ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1704), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E1), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VMOVDQA32 ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1707), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E1), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VMOVDQA32 ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x170A), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E1), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FVM) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_32) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VMOVDQA32 ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x170D), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E1), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FVM) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_32) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VMOVDQA32 ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1710), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E1), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FVM) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_32) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VMOVDQA64 ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1713), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E1), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VMOVDQA64 ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1716), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E1), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VMOVDQA64 ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1719), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E1), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VMOVDQA64 ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x171C), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E1), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FVM) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_64) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VMOVDQA64 ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x171F), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E1), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FVM) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_64) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VMOVDQA64 ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1722), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E1), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FVM) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_64) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VMOVDQA64 ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1725), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E1), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VMOVDQA64 ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1728), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E1), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VMOVDQA64 ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x172B), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E1), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VMOVDQA64 ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x172E), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E1), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FVM) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_64) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VMOVDQA64 ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1731), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E1), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FVM) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_64) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VMOVDQA64 ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1734), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E1), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FVM) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_64) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VMOVDQU16 ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0xC08), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512BW_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VMOVDQU16 ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0xC0C), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512BW_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VMOVDQU16 ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0xC10), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512BW_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VMOVDQU16 ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0xC14), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512BW_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FVM) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_16) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VMOVDQU16 ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0xC18), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512BW_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FVM) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_16) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VMOVDQU16 ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0xC1C), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512BW_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FVM) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_16) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VMOVDQU16 ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1737), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512BW_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VMOVDQU16 ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x173A), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512BW_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VMOVDQU16 ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x173D), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512BW_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VMOVDQU16 ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1740), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512BW_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FVM) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_16) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VMOVDQU16 ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1743), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512BW_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FVM) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_16) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VMOVDQU16 ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1746), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512BW_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FVM) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_16) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VMOVDQU32 ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0xBF0), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VMOVDQU32 ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0xBF4), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VMOVDQU32 ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0xBF8), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VMOVDQU32 ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1749), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FVM) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_32) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VMOVDQU32 ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x174C), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FVM) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_32) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VMOVDQU32 ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x174F), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FVM) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_32) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VMOVDQU32 ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1752), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VMOVDQU32 ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1755), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VMOVDQU32 ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1758), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VMOVDQU32 ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x175B), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FVM) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_32) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VMOVDQU32 ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x175E), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FVM) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_32) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VMOVDQU32 ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1761), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FVM) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_32) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VMOVDQU64 ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1764), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VMOVDQU64 ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0xB80), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VMOVDQU64 ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0xB84), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VMOVDQU64 ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1767), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FVM) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_64) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VMOVDQU64 ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x176A), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FVM) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_64) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VMOVDQU64 ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x176D), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FVM) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_64) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VMOVDQU64 ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1770), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VMOVDQU64 ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1773), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VMOVDQU64 ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1776), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VMOVDQU64 ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1779), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FVM) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_64) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VMOVDQU64 ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x177C), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FVM) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_64) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VMOVDQU64 ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x177F), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FVM) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_64) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VMOVDQU8 ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1782), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512BW_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VMOVDQU8 ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1785), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512BW_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VMOVDQU8 ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1788), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512BW_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VMOVDQU8 ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x178B), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512BW_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FVM) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_8) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VMOVDQU8 ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x178E), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512BW_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FVM) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_8) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VMOVDQU8 ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1791), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512BW_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FVM) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_8) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VMOVDQU8 ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1794), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512BW_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VMOVDQU8 ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1797), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512BW_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VMOVDQU8 ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x179A), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512BW_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VMOVDQU8 ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x179D), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512BW_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FVM) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_8) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VMOVDQU8 ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x17A0), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512BW_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FVM) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_8) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VMOVDQU8 ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x17A3), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512BW_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FVM) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_8) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VMOVHLPS ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x17B), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_128N) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E7NM128), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_FORBIDDEN, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VMOVHPD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x11EE), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_128N) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E9NF), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_T1S) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_64) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_FORBIDDEN, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VMOVHPD ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1E01), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_128N) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E9NF), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_T1S) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_64) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_FORBIDDEN, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VMOVHPS ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x11F1), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_128N) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E9NF), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_T2) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_32) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_FORBIDDEN, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VMOVHPS ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1C1F), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_128N) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E9NF), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_T2) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_32) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_FORBIDDEN, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VMOVLHPS ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x11F4), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_128N) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E7NM128), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_FORBIDDEN, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VMOVLPD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x7A8), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_128N) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E9NF), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_T1S) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_64) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_FORBIDDEN, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VMOVLPD ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1C47), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_128N) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E9NF), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_T1S) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_64) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_FORBIDDEN, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VMOVLPS ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x11F7), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_128N) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E9NF), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_T2) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_32) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_FORBIDDEN, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VMOVLPS ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1C21), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_128N) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E9NF), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_T2) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_32) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_FORBIDDEN, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VMOVNTDQ ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1C17), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E1NF), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FVM) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_32) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_FORBIDDEN, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VMOVNTDQ ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1DFF), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E1NF), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FVM) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_32) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_FORBIDDEN, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VMOVNTDQ ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1EA7), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E1NF), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FVM) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_32) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_FORBIDDEN, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VMOVNTDQA ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0xDB0), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E1NF), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FVM) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_32) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_FORBIDDEN, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VMOVNTDQA ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1DED), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E1NF), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FVM) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_32) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_FORBIDDEN, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VMOVNTDQA ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1EA9), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E1NF), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FVM) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_32) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_FORBIDDEN, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VMOVNTPD ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1BF5), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E1NF), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FVM) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_64) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_FORBIDDEN, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VMOVNTPD ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1DF1), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E1NF), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FVM) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_64) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_FORBIDDEN, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VMOVNTPD ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1EAB), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E1NF), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FVM) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_64) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_FORBIDDEN, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VMOVNTPS ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1BF9), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E1NF), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FVM) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_32) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_FORBIDDEN, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VMOVNTPS ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1DF5), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E1NF), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FVM) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_32) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_FORBIDDEN, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VMOVNTPS ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1EAD), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E1NF), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FVM) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_32) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_FORBIDDEN, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VMOVQ ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1EAF), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_128N) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E9NF), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_GPR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_FORBIDDEN, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VMOVQ ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1E39), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_128N) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E9NF), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_T1S) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_64) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_FORBIDDEN, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VMOVQ ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1EB1), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_128N) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E9NF), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_GPR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_FORBIDDEN, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VMOVQ ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1EB3), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_128N) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E9NF), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_T1S) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_64) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_FORBIDDEN, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VMOVQ ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x110D), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_128N) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E9NF), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_FORBIDDEN, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VMOVQ ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1E39), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_128N) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E9NF), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_T1S) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_64) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_FORBIDDEN, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VMOVQ ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1EB5), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_128N) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E9NF), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_FORBIDDEN, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VMOVQ ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1EB3), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_128N) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E9NF), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_T1S) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_64) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_FORBIDDEN, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VMOVSD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x2AC), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_SCALAR) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E5), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_FIXED_128) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VMOVSD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x16EC), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_SCALAR) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E5), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_FIXED_128) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_T1S) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_64) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VMOVSD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xA48), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_SCALAR) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E5), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_FIXED_128) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VMOVSD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x17A6), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_SCALAR) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E5), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_FIXED_128) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_T1S) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_64) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VMOVSH ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x2B6), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_FP16_SCALAR) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E5), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_FIXED_128) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VMOVSH ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x17A9), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_FP16_SCALAR) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E5), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_FIXED_128) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_T1S) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_16) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VMOVSH ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xA4C), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_FP16_SCALAR) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E5), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_FIXED_128) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VMOVSH ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x17AC), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_FP16_SCALAR) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E5), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_FIXED_128) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_T1S) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_16) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VMOVSHDUP ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0xA34), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4NF), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VMOVSHDUP ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0xA38), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4NF), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VMOVSHDUP ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0xA30), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4NF), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VMOVSHDUP ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x16C2), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4NF), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FVM) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_32) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VMOVSHDUP ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x16C5), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4NF), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FVM) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_32) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VMOVSHDUP ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x16C8), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4NF), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FVM) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_32) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VMOVSLDUP ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0xA34), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4NF), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VMOVSLDUP ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0xA38), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4NF), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VMOVSLDUP ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0xA30), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4NF), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VMOVSLDUP ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x16C2), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4NF), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FVM) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_32) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VMOVSLDUP ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x16C5), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4NF), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FVM) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_32) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VMOVSLDUP ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x16C8), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4NF), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FVM) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_32) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VMOVSS ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x2C0), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_SCALAR) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E5), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_FIXED_128) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VMOVSS ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1431), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_SCALAR) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E5), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_FIXED_128) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_T1S) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_32) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VMOVSS ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xA50), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_SCALAR) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E5), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_FIXED_128) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VMOVSS ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x17AF), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_SCALAR) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E5), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_FIXED_128) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_T1S) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_32) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VMOVUPD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0xA04), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VMOVUPD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0xA08), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VMOVUPD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0xA00), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VMOVUPD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x16B9), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FVM) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_64) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VMOVUPD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x16BC), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FVM) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_64) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VMOVUPD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x16BF), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FVM) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_64) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VMOVUPD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1440), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VMOVUPD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1443), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VMOVUPD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1446), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VMOVUPD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1449), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FVM) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_64) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VMOVUPD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x144C), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FVM) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_64) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VMOVUPD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x144F), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FVM) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_64) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VMOVUPS ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0xA34), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VMOVUPS ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0xA38), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VMOVUPS ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0xA30), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VMOVUPS ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x16C2), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FVM) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_32) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VMOVUPS ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x16C5), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FVM) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_32) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VMOVUPS ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x16C8), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FVM) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_32) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VMOVUPS ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1452), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VMOVUPS ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1455), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VMOVUPS ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1458), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VMOVUPS ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x145B), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FVM) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_32) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VMOVUPS ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x145E), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FVM) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_32) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VMOVUPS ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1461), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FVM) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_32) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VMOVW ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1EB7), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_FP16_128N) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E9NF), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_GPR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_FORBIDDEN, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VMOVW ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1EB9), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_FP16_128N) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E9NF), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_T1S) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_16) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_FORBIDDEN, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VMOVW ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1EBB), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_FP16_128N) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E9NF), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_GPR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_FORBIDDEN, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VMOVW ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1EBD), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_FP16_128N) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E9NF), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_T1S) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_16) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_FORBIDDEN, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VMULPD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x4C8), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_FIXED_512) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_RC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VMULPD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x2AC), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VMULPD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x4CD), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VMULPD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x4C8), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VMULPD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x4D2), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_64) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VMULPD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x4D7), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_64) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VMULPD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x4DC), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_64) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VMULPH ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x884), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_FP16) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_FP16_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_FIXED_512) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_RC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VMULPH ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x2B6), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_FP16) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_FP16_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VMULPH ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x888), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_FP16) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_FP16_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VMULPH ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x884), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_FP16) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_FP16_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VMULPH ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x88C), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_FP16) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_FP16_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_16) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VMULPH ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x890), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_FP16) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_FP16_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_16) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VMULPH ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x894), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_FP16) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_FP16_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_16) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VMULPS ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x4E1), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_FIXED_512) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_RC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VMULPS ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x2C0), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VMULPS ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x4E6), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VMULPS ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x4E1), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VMULPS ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x4EB), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_32) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VMULPS ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x4F0), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_32) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VMULPS ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x4F5), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_32) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VMULSD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x2AC), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_SCALAR) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E3), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_FIXED_128) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VMULSD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x2AC), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_SCALAR) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E3), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_FIXED_128) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_RC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VMULSD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x2B1), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_SCALAR) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E3), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_FIXED_128) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_T1S) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_64) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VMULSH ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x2B6), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_FP16) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_FP16_SCALAR) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E3), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_FIXED_128) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VMULSH ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x2B6), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_FP16) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_FP16_SCALAR) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E3), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_FIXED_128) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_RC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VMULSH ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x2BB), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_FP16) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_FP16_SCALAR) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E3), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_FIXED_128) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_T1S) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_16) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VMULSS ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x2C0), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_SCALAR) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E3), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_FIXED_128) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VMULSS ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x2C0), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_SCALAR) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E3), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_FIXED_128) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_RC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VMULSS ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x2C5), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_SCALAR) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E3), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_FIXED_128) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_T1S) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_32) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VORPD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x2AC), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_LOGICAL_FP) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512DQ_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VORPD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x4CD), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_LOGICAL_FP) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512DQ_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VORPD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x4C8), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_LOGICAL_FP) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512DQ_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VORPD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x4D2), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_LOGICAL_FP) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512DQ_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_64) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VORPD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x4D7), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_LOGICAL_FP) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512DQ_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_64) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VORPD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x4DC), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_LOGICAL_FP) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512DQ_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_64) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VORPS ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x2C0), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_LOGICAL_FP) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512DQ_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VORPS ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x4E6), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_LOGICAL_FP) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512DQ_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VORPS ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x4E1), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_LOGICAL_FP) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512DQ_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VORPS ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x4EB), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_LOGICAL_FP) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512DQ_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_32) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VORPS ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x4F0), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_LOGICAL_FP) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512DQ_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_32) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VORPS ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x4F5), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_LOGICAL_FP) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512DQ_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_32) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VP2INTERSECTD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x17B2), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512_VP2INTERSECT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_VP2INTERSECT_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_MASK, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_FORBIDDEN, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VP2INTERSECTD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x17B5), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512_VP2INTERSECT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_VP2INTERSECT_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_MASK, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_FORBIDDEN, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VP2INTERSECTD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x17B8), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512_VP2INTERSECT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_VP2INTERSECT_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_MASK, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_FORBIDDEN, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VP2INTERSECTD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x17BB), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512_VP2INTERSECT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_VP2INTERSECT_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_MASK, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_32) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_FORBIDDEN, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VP2INTERSECTD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x17BE), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512_VP2INTERSECT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_VP2INTERSECT_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_MASK, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_32) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_FORBIDDEN, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VP2INTERSECTD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x17C1), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512_VP2INTERSECT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_VP2INTERSECT_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_MASK, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_32) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_FORBIDDEN, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VP2INTERSECTQ ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x17C4), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512_VP2INTERSECT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_VP2INTERSECT_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_MASK, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_FORBIDDEN, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VP2INTERSECTQ ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x17C7), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512_VP2INTERSECT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_VP2INTERSECT_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_MASK, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_FORBIDDEN, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VP2INTERSECTQ ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x17CA), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512_VP2INTERSECT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_VP2INTERSECT_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_MASK, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_FORBIDDEN, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VP2INTERSECTQ ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x17CD), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512_VP2INTERSECT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_VP2INTERSECT_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_MASK, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_64) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_FORBIDDEN, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VP2INTERSECTQ ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x17D0), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512_VP2INTERSECT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_VP2INTERSECT_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_MASK, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_64) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_FORBIDDEN, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VP2INTERSECTQ ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x17D3), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512_VP2INTERSECT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_VP2INTERSECT_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_MASK, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_64) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_FORBIDDEN, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VP4DPWSSD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xA54), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512_4VNNIW) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_4VNNIW_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_T1_4X) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_32) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VP4DPWSSDS ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xA54), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512_4VNNIW) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_4VNNIW_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_T1_4X) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_32) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPABSB ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x17D6), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512BW_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPABSB ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x17D9), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512BW_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPABSB ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x17DC), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512BW_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPABSB ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x17DF), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512BW_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FVM) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_8) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPABSB ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x17E2), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512BW_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FVM) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_8) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPABSB ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x17E5), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512BW_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FVM) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_8) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPABSD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x17E8), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPABSD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x17EB), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPABSD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x17EE), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPABSD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x17F1), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_32) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPABSD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x17F4), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_32) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPABSD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x17F7), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_32) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPABSQ ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1713), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPABSQ ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1716), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPABSQ ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1719), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPABSQ ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x17FA), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_64) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPABSQ ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x17FD), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_64) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPABSQ ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1800), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_64) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPABSW ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1803), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512BW_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPABSW ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1806), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512BW_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPABSW ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1809), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512BW_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPABSW ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x180C), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512BW_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FVM) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_16) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPABSW ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x180F), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512BW_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FVM) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_16) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPABSW ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1812), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512BW_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FVM) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_16) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPACKSSDW ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xA58), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512BW_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4NF), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPACKSSDW ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xA5C), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512BW_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4NF), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPACKSSDW ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xA60), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512BW_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4NF), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPACKSSDW ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xA64), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512BW_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4NF), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_32) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPACKSSDW ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xA68), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512BW_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4NF), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_32) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPACKSSDW ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xA6C), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512BW_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4NF), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_32) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPACKSSWB ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xA70), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512BW_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4NF), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPACKSSWB ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xA74), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512BW_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4NF), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPACKSSWB ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xA78), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512BW_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4NF), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPACKSSWB ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xA7C), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512BW_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4NF), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FVM) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_16) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPACKSSWB ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xA80), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512BW_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4NF), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FVM) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_16) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPACKSSWB ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xA84), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512BW_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4NF), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FVM) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_16) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPACKUSDW ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xA88), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512BW_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4NF), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPACKUSDW ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xA8C), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512BW_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4NF), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPACKUSDW ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xA90), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512BW_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4NF), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPACKUSDW ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xA94), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512BW_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4NF), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_32) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPACKUSDW ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xA98), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512BW_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4NF), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_32) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPACKUSDW ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xA9C), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512BW_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4NF), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_32) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPACKUSWB ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xAA0), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512BW_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4NF), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPACKUSWB ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xAA4), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512BW_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4NF), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPACKUSWB ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xAA8), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512BW_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4NF), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPACKUSWB ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xAAC), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512BW_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4NF), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FVM) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_16) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPACKUSWB ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xAB0), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512BW_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4NF), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FVM) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_16) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPACKUSWB ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xAB4), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512BW_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4NF), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FVM) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_16) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPADDB ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xAB8), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512BW_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPADDB ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xABC), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512BW_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPADDB ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xAC0), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512BW_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPADDB ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xAC4), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512BW_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FVM) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_8) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPADDB ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xAC8), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512BW_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FVM) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_8) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPADDB ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xACC), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512BW_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FVM) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_8) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPADDD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xAD0), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPADDD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xAD4), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPADDD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xAD8), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPADDD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xADC), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_32) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPADDD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xAE0), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_32) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPADDD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xAE4), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_32) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPADDQ ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xAE8), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPADDQ ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xAEC), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPADDQ ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xAF0), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPADDQ ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xAF4), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_64) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPADDQ ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xAF8), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_64) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPADDQ ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xAFC), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_64) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPADDSB ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xAB8), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512BW_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPADDSB ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xABC), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512BW_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPADDSB ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xAC0), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512BW_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPADDSB ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xAC4), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512BW_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FVM) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_8) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPADDSB ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xAC8), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512BW_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FVM) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_8) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPADDSB ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xACC), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512BW_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FVM) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_8) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPADDSW ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xB00), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512BW_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPADDSW ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xB04), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512BW_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPADDSW ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xB08), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512BW_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPADDSW ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xB0C), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512BW_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FVM) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_16) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPADDSW ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xB10), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512BW_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FVM) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_16) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPADDSW ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xB14), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512BW_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FVM) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_16) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPADDUSB ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x360), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512BW_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPADDUSB ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x365), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512BW_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPADDUSB ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x36A), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512BW_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPADDUSB ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x36F), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512BW_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FVM) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_8) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPADDUSB ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x374), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512BW_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FVM) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_8) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPADDUSB ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x379), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512BW_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FVM) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_8) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPADDUSW ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x46E), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512BW_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPADDUSW ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x473), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512BW_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPADDUSW ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x478), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512BW_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPADDUSW ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x47D), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512BW_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FVM) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_16) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPADDUSW ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x482), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512BW_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FVM) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_16) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPADDUSW ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x487), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512BW_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FVM) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_16) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPADDW ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xB00), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512BW_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPADDW ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xB04), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512BW_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPADDW ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xB08), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512BW_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPADDW ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xB0C), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512BW_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FVM) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_16) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPADDW ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xB10), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512BW_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FVM) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_16) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPADDW ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xB14), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512BW_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FVM) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_16) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPALIGNR ZYDIS_NOTMIN(5) ZYDIS_NOTMIN(5) ZYDIS_NOTMIN(0x360), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512BW_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4NF), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPALIGNR ZYDIS_NOTMIN(5) ZYDIS_NOTMIN(5) ZYDIS_NOTMIN(0x365), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512BW_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4NF), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPALIGNR ZYDIS_NOTMIN(5) ZYDIS_NOTMIN(5) ZYDIS_NOTMIN(0x36A), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512BW_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4NF), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPALIGNR ZYDIS_NOTMIN(5) ZYDIS_NOTMIN(5) ZYDIS_NOTMIN(0x36F), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512BW_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4NF), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FVM) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_64) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPALIGNR ZYDIS_NOTMIN(5) ZYDIS_NOTMIN(5) ZYDIS_NOTMIN(0x374), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512BW_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4NF), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FVM) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_64) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPALIGNR ZYDIS_NOTMIN(5) ZYDIS_NOTMIN(5) ZYDIS_NOTMIN(0x379), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512BW_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4NF), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FVM) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_64) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPANDD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x1A3), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_LOGICAL) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPANDD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x1A8), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_LOGICAL) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPANDD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x1AD), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_LOGICAL) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPANDD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x1B2), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_LOGICAL) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_32) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPANDD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x1B7), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_LOGICAL) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_32) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPANDD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x1BC), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_LOGICAL) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_32) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPANDND ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x1A3), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_LOGICAL) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPANDND ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x1A8), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_LOGICAL) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPANDND ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x1AD), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_LOGICAL) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPANDND ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x1B2), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_LOGICAL) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_32) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPANDND ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x1B7), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_LOGICAL) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_32) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPANDND ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x1BC), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_LOGICAL) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_32) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPANDNQ ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x1C1), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_LOGICAL) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPANDNQ ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x1C6), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_LOGICAL) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPANDNQ ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x1CB), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_LOGICAL) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPANDNQ ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x1D0), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_LOGICAL) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_64) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPANDNQ ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x1D5), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_LOGICAL) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_64) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPANDNQ ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x1DA), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_LOGICAL) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_64) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPANDQ ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x1C1), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_LOGICAL) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPANDQ ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x1C6), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_LOGICAL) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPANDQ ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x1CB), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_LOGICAL) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPANDQ ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x1D0), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_LOGICAL) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_64) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPANDQ ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x1D5), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_LOGICAL) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_64) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPANDQ ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x1DA), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_LOGICAL) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_64) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPAVGB ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x360), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512BW_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPAVGB ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x365), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512BW_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPAVGB ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x36A), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512BW_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPAVGB ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x36F), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512BW_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FVM) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_8) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPAVGB ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x374), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512BW_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FVM) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_8) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPAVGB ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x379), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512BW_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FVM) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_8) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPAVGW ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x46E), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512BW_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPAVGW ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x473), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512BW_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPAVGW ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x478), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512BW_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPAVGW ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x47D), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512BW_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FVM) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_16) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPAVGW ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x482), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512BW_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FVM) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_16) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPAVGW ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x487), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512BW_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FVM) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_16) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPBLENDMB ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x360), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_BLEND) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512BW_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_CONTROL) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPBLENDMB ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x365), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_BLEND) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512BW_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_CONTROL) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPBLENDMB ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x36A), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_BLEND) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512BW_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_CONTROL) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPBLENDMB ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x36F), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_BLEND) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512BW_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FVM) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_8) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_CONTROL) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPBLENDMB ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x374), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_BLEND) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512BW_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FVM) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_8) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_CONTROL) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPBLENDMB ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x379), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_BLEND) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512BW_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FVM) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_8) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_CONTROL) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPBLENDMD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x1A3), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_BLEND) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_CONTROL) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPBLENDMD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x1A8), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_BLEND) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_CONTROL) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPBLENDMD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x1AD), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_BLEND) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_CONTROL) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPBLENDMD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x1B2), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_BLEND) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_32) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_CONTROL) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPBLENDMD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x1B7), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_BLEND) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_32) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_CONTROL) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPBLENDMD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x1BC), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_BLEND) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_32) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_CONTROL) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPBLENDMQ ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x1C1), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_BLEND) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_CONTROL) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPBLENDMQ ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x1C6), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_BLEND) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_CONTROL) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPBLENDMQ ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x1CB), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_BLEND) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_CONTROL) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPBLENDMQ ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x1D0), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_BLEND) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_64) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_CONTROL) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPBLENDMQ ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x1D5), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_BLEND) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_64) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_CONTROL) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPBLENDMQ ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x1DA), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_BLEND) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_64) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_CONTROL) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPBLENDMW ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x46E), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_BLEND) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512BW_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_CONTROL) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPBLENDMW ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x473), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_BLEND) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512BW_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_CONTROL) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPBLENDMW ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x478), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_BLEND) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512BW_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_CONTROL) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPBLENDMW ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x47D), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_BLEND) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512BW_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FVM) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_16) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_CONTROL) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPBLENDMW ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x482), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_BLEND) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512BW_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FVM) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_16) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_CONTROL) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPBLENDMW ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x487), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_BLEND) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512BW_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FVM) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_16) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_CONTROL) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPBROADCASTB ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1782), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_BROADCAST) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512BW_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E6), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_1_TO_16) },
    { ZYDIS_MNEMONIC_VPBROADCASTB ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1815), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_BROADCAST) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512BW_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E6), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_1_TO_32) },
    { ZYDIS_MNEMONIC_VPBROADCASTB ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1818), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_BROADCAST) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512BW_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E6), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_1_TO_64) },
    { ZYDIS_MNEMONIC_VPBROADCASTB ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x181B), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_BROADCAST) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512BW_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E6), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_T1S) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_8) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_1_TO_16) },
    { ZYDIS_MNEMONIC_VPBROADCASTB ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x181E), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_BROADCAST) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512BW_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E6), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_T1S) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_8) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_1_TO_32) },
    { ZYDIS_MNEMONIC_VPBROADCASTB ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1821), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_BROADCAST) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512BW_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E6), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_T1S) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_8) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_1_TO_64) },
    { ZYDIS_MNEMONIC_VPBROADCASTB ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1824), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_BROADCAST) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512BW_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E7NM), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_GPR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_1_TO_16) },
    { ZYDIS_MNEMONIC_VPBROADCASTB ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1827), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_BROADCAST) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512BW_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E7NM), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_GPR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_1_TO_32) },
    { ZYDIS_MNEMONIC_VPBROADCASTB ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x182A), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_BROADCAST) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512BW_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E7NM), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_GPR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_1_TO_64) },
    { ZYDIS_MNEMONIC_VPBROADCASTD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x16EF), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_BROADCAST) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E6), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_1_TO_4) },
    { ZYDIS_MNEMONIC_VPBROADCASTD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x182D), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_BROADCAST) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E6), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_1_TO_8) },
    { ZYDIS_MNEMONIC_VPBROADCASTD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1830), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_BROADCAST) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E6), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_1_TO_16) },
    { ZYDIS_MNEMONIC_VPBROADCASTD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1833), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_BROADCAST) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E6), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_T1F) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_32) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_1_TO_4) },
    { ZYDIS_MNEMONIC_VPBROADCASTD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1836), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_BROADCAST) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E6), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_T1F) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_32) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_1_TO_8) },
    { ZYDIS_MNEMONIC_VPBROADCASTD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1839), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_BROADCAST) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E6), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_T1F) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_32) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_1_TO_16) },
    { ZYDIS_MNEMONIC_VPBROADCASTD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x183C), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_BROADCAST) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E7NM), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_GPR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_1_TO_4) },
    { ZYDIS_MNEMONIC_VPBROADCASTD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x183F), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_BROADCAST) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E7NM), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_GPR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_1_TO_8) },
    { ZYDIS_MNEMONIC_VPBROADCASTD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1842), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_BROADCAST) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E7NM), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_GPR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_1_TO_16) },
    { ZYDIS_MNEMONIC_VPBROADCASTD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x183C), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_BROADCAST) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E7NM), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_GPR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_1_TO_4) },
    { ZYDIS_MNEMONIC_VPBROADCASTD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x183F), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_BROADCAST) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E7NM), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_GPR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_1_TO_8) },
    { ZYDIS_MNEMONIC_VPBROADCASTD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1842), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_BROADCAST) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E7NM), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_GPR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_1_TO_16) },
    { ZYDIS_MNEMONIC_VPBROADCASTMB2Q ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1EBF), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_BROADCAST) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512CD_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E6NF), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_MASK ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_FORBIDDEN, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_1_TO_2) },
    { ZYDIS_MNEMONIC_VPBROADCASTMB2Q ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1EC1), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_BROADCAST) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512CD_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E6NF), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_MASK ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_FORBIDDEN, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_1_TO_4) },
    { ZYDIS_MNEMONIC_VPBROADCASTMB2Q ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1EC3), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_BROADCAST) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512CD_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E6NF), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_MASK ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_FORBIDDEN, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_1_TO_8) },
    { ZYDIS_MNEMONIC_VPBROADCASTMW2D ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1EC5), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_BROADCAST) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512CD_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E6NF), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_MASK ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_FORBIDDEN, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_1_TO_4) },
    { ZYDIS_MNEMONIC_VPBROADCASTMW2D ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1EC7), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_BROADCAST) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512CD_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E6NF), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_MASK ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_FORBIDDEN, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_1_TO_8) },
    { ZYDIS_MNEMONIC_VPBROADCASTMW2D ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1EC9), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_BROADCAST) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512CD_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E6NF), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_MASK ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_FORBIDDEN, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_1_TO_16) },
    { ZYDIS_MNEMONIC_VPBROADCASTQ ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1713), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_BROADCAST) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E6), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_1_TO_2) },
    { ZYDIS_MNEMONIC_VPBROADCASTQ ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1845), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_BROADCAST) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E6), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_1_TO_4) },
    { ZYDIS_MNEMONIC_VPBROADCASTQ ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1848), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_BROADCAST) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E6), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_1_TO_8) },
    { ZYDIS_MNEMONIC_VPBROADCASTQ ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x184B), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_BROADCAST) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E6), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_T1F) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_64) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_1_TO_2) },
    { ZYDIS_MNEMONIC_VPBROADCASTQ ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x184E), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_BROADCAST) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E6), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_T1F) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_64) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_1_TO_4) },
    { ZYDIS_MNEMONIC_VPBROADCASTQ ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1851), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_BROADCAST) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E6), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_T1F) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_64) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_1_TO_8) },
    { ZYDIS_MNEMONIC_VPBROADCASTQ ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1854), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_BROADCAST) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E7NM), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_GPR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_1_TO_2) },
    { ZYDIS_MNEMONIC_VPBROADCASTQ ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1857), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_BROADCAST) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E7NM), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_GPR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_1_TO_4) },
    { ZYDIS_MNEMONIC_VPBROADCASTQ ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x185A), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_BROADCAST) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E7NM), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_GPR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_1_TO_8) },
    { ZYDIS_MNEMONIC_VPBROADCASTW ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0xC08), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_BROADCAST) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512BW_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E6), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_1_TO_8) },
    { ZYDIS_MNEMONIC_VPBROADCASTW ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x185D), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_BROADCAST) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512BW_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E6), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_1_TO_16) },
    { ZYDIS_MNEMONIC_VPBROADCASTW ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1860), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_BROADCAST) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512BW_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E6), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_1_TO_32) },
    { ZYDIS_MNEMONIC_VPBROADCASTW ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1863), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_BROADCAST) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512BW_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E6), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_T1S) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_16) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_1_TO_8) },
    { ZYDIS_MNEMONIC_VPBROADCASTW ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1866), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_BROADCAST) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512BW_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E6), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_T1S) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_16) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_1_TO_16) },
    { ZYDIS_MNEMONIC_VPBROADCASTW ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1869), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_BROADCAST) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512BW_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E6), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_T1S) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_16) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_1_TO_32) },
    { ZYDIS_MNEMONIC_VPBROADCASTW ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x186C), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_BROADCAST) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512BW_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E7NM), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_GPR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_1_TO_8) },
    { ZYDIS_MNEMONIC_VPBROADCASTW ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x186F), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_BROADCAST) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512BW_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E7NM), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_GPR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_1_TO_16) },
    { ZYDIS_MNEMONIC_VPBROADCASTW ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1872), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_BROADCAST) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512BW_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E7NM), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_GPR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_1_TO_32) },
    { ZYDIS_MNEMONIC_VPCLMULQDQ ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x830), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VPCLMULQDQ) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_VPCLMULQDQ_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_FORBIDDEN, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPCLMULQDQ ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x834), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VPCLMULQDQ) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_VPCLMULQDQ_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_FORBIDDEN, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPCLMULQDQ ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xB18), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VPCLMULQDQ) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_VPCLMULQDQ_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_FORBIDDEN, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPCLMULQDQ ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x838), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VPCLMULQDQ) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_VPCLMULQDQ_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FVM) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_64) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_FORBIDDEN, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPCLMULQDQ ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x83C), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VPCLMULQDQ) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_VPCLMULQDQ_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FVM) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_64) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_FORBIDDEN, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPCLMULQDQ ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xB1C), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VPCLMULQDQ) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_VPCLMULQDQ_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FVM) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_64) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_FORBIDDEN, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPCMPB ZYDIS_NOTMIN(5) ZYDIS_NOTMIN(5) ZYDIS_NOTMIN(0x37E), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512BW_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_MASK, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_ZEROING) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPCMPB ZYDIS_NOTMIN(5) ZYDIS_NOTMIN(5) ZYDIS_NOTMIN(0x383), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512BW_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_MASK, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_ZEROING) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPCMPB ZYDIS_NOTMIN(5) ZYDIS_NOTMIN(5) ZYDIS_NOTMIN(0x388), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512BW_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_MASK, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_ZEROING) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPCMPB ZYDIS_NOTMIN(5) ZYDIS_NOTMIN(5) ZYDIS_NOTMIN(0x38D), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512BW_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_MASK, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FVM) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_8) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_ZEROING) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPCMPB ZYDIS_NOTMIN(5) ZYDIS_NOTMIN(5) ZYDIS_NOTMIN(0x392), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512BW_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_MASK, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FVM) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_8) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_ZEROING) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPCMPB ZYDIS_NOTMIN(5) ZYDIS_NOTMIN(5) ZYDIS_NOTMIN(0x397), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512BW_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_MASK, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FVM) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_8) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_ZEROING) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPCMPD ZYDIS_NOTMIN(5) ZYDIS_NOTMIN(5) ZYDIS_NOTMIN(0x39C), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_MASK, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_ZEROING) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPCMPD ZYDIS_NOTMIN(5) ZYDIS_NOTMIN(5) ZYDIS_NOTMIN(0x3A1), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_MASK, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_ZEROING) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPCMPD ZYDIS_NOTMIN(5) ZYDIS_NOTMIN(5) ZYDIS_NOTMIN(0x3A6), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_MASK, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_ZEROING) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPCMPD ZYDIS_NOTMIN(5) ZYDIS_NOTMIN(5) ZYDIS_NOTMIN(0x3AB), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_MASK, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_32) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_ZEROING) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPCMPD ZYDIS_NOTMIN(5) ZYDIS_NOTMIN(5) ZYDIS_NOTMIN(0x3B0), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_MASK, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_32) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_ZEROING) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPCMPD ZYDIS_NOTMIN(5) ZYDIS_NOTMIN(5) ZYDIS_NOTMIN(0x3B5), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_MASK, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_32) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_ZEROING) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPCMPEQB ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x3D8), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512BW_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_MASK, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_ZEROING) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPCMPEQB ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x3DD), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512BW_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_MASK, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_ZEROING) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPCMPEQB ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x3E2), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512BW_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_MASK, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_ZEROING) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPCMPEQB ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x3E7), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512BW_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_MASK, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FVM) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_8) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_ZEROING) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPCMPEQB ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x3EC), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512BW_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_MASK, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FVM) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_8) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_ZEROING) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPCMPEQB ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x3F1), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512BW_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_MASK, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FVM) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_8) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_ZEROING) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPCMPEQD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x39C), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_MASK, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_ZEROING) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPCMPEQD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x3A1), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_MASK, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_ZEROING) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPCMPEQD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x3A6), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_MASK, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_ZEROING) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPCMPEQD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x3AB), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_MASK, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_32) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_ZEROING) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPCMPEQD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x3B0), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_MASK, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_32) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_ZEROING) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPCMPEQD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x3B5), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_MASK, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_32) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_ZEROING) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPCMPEQQ ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x414), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_MASK, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_ZEROING) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPCMPEQQ ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x419), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_MASK, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_ZEROING) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPCMPEQQ ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x41E), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_MASK, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_ZEROING) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPCMPEQQ ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x423), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_MASK, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_64) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_ZEROING) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPCMPEQQ ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x428), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_MASK, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_64) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_ZEROING) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPCMPEQQ ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x42D), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_MASK, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_64) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_ZEROING) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPCMPEQW ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x432), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512BW_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_MASK, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_ZEROING) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPCMPEQW ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x437), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512BW_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_MASK, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_ZEROING) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPCMPEQW ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x43C), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512BW_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_MASK, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_ZEROING) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPCMPEQW ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x441), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512BW_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_MASK, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FVM) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_16) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_ZEROING) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPCMPEQW ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x446), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512BW_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_MASK, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FVM) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_16) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_ZEROING) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPCMPEQW ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x44B), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512BW_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_MASK, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FVM) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_16) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_ZEROING) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPCMPGTB ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x37E), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512BW_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_MASK, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_ZEROING) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPCMPGTB ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x383), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512BW_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_MASK, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_ZEROING) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPCMPGTB ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x388), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512BW_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_MASK, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_ZEROING) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPCMPGTB ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x38D), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512BW_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_MASK, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FVM) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_8) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_ZEROING) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPCMPGTB ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x392), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512BW_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_MASK, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FVM) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_8) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_ZEROING) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPCMPGTB ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x397), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512BW_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_MASK, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FVM) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_8) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_ZEROING) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPCMPGTD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x39C), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_MASK, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_ZEROING) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPCMPGTD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x3A1), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_MASK, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_ZEROING) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPCMPGTD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x3A6), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_MASK, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_ZEROING) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPCMPGTD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x3AB), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_MASK, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_32) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_ZEROING) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPCMPGTD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x3B0), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_MASK, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_32) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_ZEROING) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPCMPGTD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x3B5), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_MASK, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_32) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_ZEROING) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPCMPGTQ ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x3BA), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_MASK, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_ZEROING) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPCMPGTQ ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x3BF), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_MASK, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_ZEROING) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPCMPGTQ ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x3C4), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_MASK, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_ZEROING) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPCMPGTQ ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x3C9), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_MASK, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_64) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_ZEROING) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPCMPGTQ ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x3CE), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_MASK, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_64) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_ZEROING) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPCMPGTQ ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x3D3), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_MASK, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_64) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_ZEROING) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPCMPGTW ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x450), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512BW_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_MASK, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_ZEROING) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPCMPGTW ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x455), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512BW_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_MASK, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_ZEROING) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPCMPGTW ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x45A), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512BW_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_MASK, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_ZEROING) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPCMPGTW ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x45F), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512BW_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_MASK, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FVM) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_16) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_ZEROING) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPCMPGTW ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x464), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512BW_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_MASK, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FVM) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_16) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_ZEROING) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPCMPGTW ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x469), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512BW_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_MASK, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FVM) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_16) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_ZEROING) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPCMPQ ZYDIS_NOTMIN(5) ZYDIS_NOTMIN(5) ZYDIS_NOTMIN(0x3BA), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_MASK, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_ZEROING) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPCMPQ ZYDIS_NOTMIN(5) ZYDIS_NOTMIN(5) ZYDIS_NOTMIN(0x3BF), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_MASK, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_ZEROING) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPCMPQ ZYDIS_NOTMIN(5) ZYDIS_NOTMIN(5) ZYDIS_NOTMIN(0x3C4), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_MASK, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_ZEROING) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPCMPQ ZYDIS_NOTMIN(5) ZYDIS_NOTMIN(5) ZYDIS_NOTMIN(0x3C9), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_MASK, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_64) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_ZEROING) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPCMPQ ZYDIS_NOTMIN(5) ZYDIS_NOTMIN(5) ZYDIS_NOTMIN(0x3CE), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_MASK, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_64) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_ZEROING) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPCMPQ ZYDIS_NOTMIN(5) ZYDIS_NOTMIN(5) ZYDIS_NOTMIN(0x3D3), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_MASK, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_64) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_ZEROING) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPCMPUB ZYDIS_NOTMIN(5) ZYDIS_NOTMIN(5) ZYDIS_NOTMIN(0x3D8), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512BW_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_MASK, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_ZEROING) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPCMPUB ZYDIS_NOTMIN(5) ZYDIS_NOTMIN(5) ZYDIS_NOTMIN(0x3DD), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512BW_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_MASK, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_ZEROING) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPCMPUB ZYDIS_NOTMIN(5) ZYDIS_NOTMIN(5) ZYDIS_NOTMIN(0x3E2), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512BW_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_MASK, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_ZEROING) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPCMPUB ZYDIS_NOTMIN(5) ZYDIS_NOTMIN(5) ZYDIS_NOTMIN(0x3E7), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512BW_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_MASK, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FVM) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_8) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_ZEROING) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPCMPUB ZYDIS_NOTMIN(5) ZYDIS_NOTMIN(5) ZYDIS_NOTMIN(0x3EC), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512BW_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_MASK, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FVM) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_8) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_ZEROING) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPCMPUB ZYDIS_NOTMIN(5) ZYDIS_NOTMIN(5) ZYDIS_NOTMIN(0x3F1), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512BW_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_MASK, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FVM) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_8) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_ZEROING) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPCMPUD ZYDIS_NOTMIN(5) ZYDIS_NOTMIN(5) ZYDIS_NOTMIN(0x3F6), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_MASK, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_ZEROING) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPCMPUD ZYDIS_NOTMIN(5) ZYDIS_NOTMIN(5) ZYDIS_NOTMIN(0x3FB), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_MASK, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_ZEROING) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPCMPUD ZYDIS_NOTMIN(5) ZYDIS_NOTMIN(5) ZYDIS_NOTMIN(0x400), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_MASK, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_ZEROING) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPCMPUD ZYDIS_NOTMIN(5) ZYDIS_NOTMIN(5) ZYDIS_NOTMIN(0x405), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_MASK, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_32) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_ZEROING) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPCMPUD ZYDIS_NOTMIN(5) ZYDIS_NOTMIN(5) ZYDIS_NOTMIN(0x40A), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_MASK, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_32) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_ZEROING) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPCMPUD ZYDIS_NOTMIN(5) ZYDIS_NOTMIN(5) ZYDIS_NOTMIN(0x40F), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_MASK, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_32) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_ZEROING) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPCMPUQ ZYDIS_NOTMIN(5) ZYDIS_NOTMIN(5) ZYDIS_NOTMIN(0x414), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_MASK, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_ZEROING) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPCMPUQ ZYDIS_NOTMIN(5) ZYDIS_NOTMIN(5) ZYDIS_NOTMIN(0x419), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_MASK, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_ZEROING) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPCMPUQ ZYDIS_NOTMIN(5) ZYDIS_NOTMIN(5) ZYDIS_NOTMIN(0x41E), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_MASK, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_ZEROING) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPCMPUQ ZYDIS_NOTMIN(5) ZYDIS_NOTMIN(5) ZYDIS_NOTMIN(0x423), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_MASK, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_64) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_ZEROING) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPCMPUQ ZYDIS_NOTMIN(5) ZYDIS_NOTMIN(5) ZYDIS_NOTMIN(0x428), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_MASK, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_64) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_ZEROING) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPCMPUQ ZYDIS_NOTMIN(5) ZYDIS_NOTMIN(5) ZYDIS_NOTMIN(0x42D), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_MASK, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_64) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_ZEROING) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPCMPUW ZYDIS_NOTMIN(5) ZYDIS_NOTMIN(5) ZYDIS_NOTMIN(0x432), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512BW_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_MASK, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_ZEROING) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPCMPUW ZYDIS_NOTMIN(5) ZYDIS_NOTMIN(5) ZYDIS_NOTMIN(0x437), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512BW_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_MASK, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_ZEROING) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPCMPUW ZYDIS_NOTMIN(5) ZYDIS_NOTMIN(5) ZYDIS_NOTMIN(0x43C), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512BW_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_MASK, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_ZEROING) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPCMPUW ZYDIS_NOTMIN(5) ZYDIS_NOTMIN(5) ZYDIS_NOTMIN(0x441), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512BW_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_MASK, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FVM) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_16) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_ZEROING) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPCMPUW ZYDIS_NOTMIN(5) ZYDIS_NOTMIN(5) ZYDIS_NOTMIN(0x446), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512BW_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_MASK, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FVM) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_16) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_ZEROING) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPCMPUW ZYDIS_NOTMIN(5) ZYDIS_NOTMIN(5) ZYDIS_NOTMIN(0x44B), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512BW_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_MASK, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FVM) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_16) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_ZEROING) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPCMPW ZYDIS_NOTMIN(5) ZYDIS_NOTMIN(5) ZYDIS_NOTMIN(0x450), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512BW_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_MASK, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_ZEROING) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPCMPW ZYDIS_NOTMIN(5) ZYDIS_NOTMIN(5) ZYDIS_NOTMIN(0x455), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512BW_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_MASK, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_ZEROING) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPCMPW ZYDIS_NOTMIN(5) ZYDIS_NOTMIN(5) ZYDIS_NOTMIN(0x45A), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512BW_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_MASK, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_ZEROING) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPCMPW ZYDIS_NOTMIN(5) ZYDIS_NOTMIN(5) ZYDIS_NOTMIN(0x45F), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512BW_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_MASK, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FVM) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_16) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_ZEROING) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPCMPW ZYDIS_NOTMIN(5) ZYDIS_NOTMIN(5) ZYDIS_NOTMIN(0x464), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512BW_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_MASK, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FVM) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_16) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_ZEROING) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPCMPW ZYDIS_NOTMIN(5) ZYDIS_NOTMIN(5) ZYDIS_NOTMIN(0x469), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512BW_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_MASK, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FVM) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_16) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_ZEROING) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPCOMPRESSB ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1794), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_COMPRESS) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_VBMI2_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPCOMPRESSB ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1797), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_COMPRESS) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_VBMI2_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPCOMPRESSB ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x179A), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_COMPRESS) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_VBMI2_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPCOMPRESSB ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x179D), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_COMPRESS) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_VBMI2_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_T1S) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_8) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPCOMPRESSB ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x17A0), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_COMPRESS) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_VBMI2_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_T1S) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_8) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPCOMPRESSB ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x17A3), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_COMPRESS) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_VBMI2_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_T1S) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_8) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPCOMPRESSD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1752), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_COMPRESS) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPCOMPRESSD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1755), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_COMPRESS) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPCOMPRESSD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1758), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_COMPRESS) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPCOMPRESSD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x175B), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_COMPRESS) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_GSCAT) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_32) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPCOMPRESSD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x175E), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_COMPRESS) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_GSCAT) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_32) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPCOMPRESSD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1761), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_COMPRESS) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_GSCAT) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_32) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPCOMPRESSQ ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1770), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_COMPRESS) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPCOMPRESSQ ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1773), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_COMPRESS) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPCOMPRESSQ ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1776), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_COMPRESS) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPCOMPRESSQ ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1779), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_COMPRESS) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_GSCAT) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_64) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPCOMPRESSQ ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x177C), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_COMPRESS) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_GSCAT) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_64) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPCOMPRESSQ ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x177F), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_COMPRESS) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_GSCAT) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_64) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPCOMPRESSW ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1737), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_COMPRESS) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_VBMI2_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPCOMPRESSW ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x173A), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_COMPRESS) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_VBMI2_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPCOMPRESSW ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x173D), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_COMPRESS) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_VBMI2_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPCOMPRESSW ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1740), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_COMPRESS) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_VBMI2_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_T1S) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_16) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPCOMPRESSW ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1743), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_COMPRESS) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_VBMI2_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_T1S) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_16) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPCOMPRESSW ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1746), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_COMPRESS) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_VBMI2_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_T1S) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_16) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPCONFLICTD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0xBF0), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONFLICT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512CD_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4NF), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPCONFLICTD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0xBF4), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONFLICT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512CD_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4NF), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPCONFLICTD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0xBF8), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONFLICT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512CD_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4NF), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPCONFLICTD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0xBFC), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONFLICT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512CD_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4NF), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_32) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPCONFLICTD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0xC00), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONFLICT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512CD_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4NF), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_32) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPCONFLICTD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0xC04), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONFLICT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512CD_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4NF), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_32) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPCONFLICTQ ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1764), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONFLICT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512CD_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4NF), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPCONFLICTQ ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0xB80), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONFLICT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512CD_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4NF), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPCONFLICTQ ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0xB84), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONFLICT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512CD_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4NF), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPCONFLICTQ ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1875), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONFLICT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512CD_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4NF), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_64) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPCONFLICTQ ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0xB88), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONFLICT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512CD_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4NF), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_64) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPCONFLICTQ ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0xB8C), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONFLICT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512CD_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4NF), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_64) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPDPBUSD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xB20), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_VNNI_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPDPBUSD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xB24), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_VNNI_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPDPBUSD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xB28), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_VNNI_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPDPBUSD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xB2C), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_VNNI_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_32) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPDPBUSD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xB30), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_VNNI_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_32) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPDPBUSD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xB34), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_VNNI_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_32) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPDPBUSDS ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xB20), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_VNNI_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPDPBUSDS ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xB24), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_VNNI_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPDPBUSDS ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xB28), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_VNNI_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPDPBUSDS ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xB2C), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_VNNI_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_32) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPDPBUSDS ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xB30), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_VNNI_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_32) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPDPBUSDS ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xB34), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_VNNI_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_32) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPDPWSSD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xB38), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_VNNI_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPDPWSSD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xB3C), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_VNNI_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPDPWSSD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xB40), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_VNNI_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPDPWSSD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xB44), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_VNNI_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_32) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPDPWSSD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xB48), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_VNNI_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_32) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPDPWSSD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xB4C), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_VNNI_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_32) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPDPWSSDS ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xB38), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_VNNI_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPDPWSSDS ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xB3C), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_VNNI_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPDPWSSDS ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xB40), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_VNNI_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPDPWSSDS ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xB44), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_VNNI_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_32) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPDPWSSDS ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xB48), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_VNNI_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_32) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPDPWSSDS ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xB4C), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_VNNI_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_32) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPERMB ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x360), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512_VBMI) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_VBMI_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4NF), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPERMB ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x365), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512_VBMI) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_VBMI_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4NF), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPERMB ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x36A), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512_VBMI) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_VBMI_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4NF), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPERMB ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x36F), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512_VBMI) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_VBMI_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4NF), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FVM) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_8) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPERMB ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x374), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512_VBMI) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_VBMI_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4NF), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FVM) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_8) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPERMB ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x379), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512_VBMI) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_VBMI_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4NF), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FVM) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_8) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPERMD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x1A8), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4NF), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPERMD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x1AD), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4NF), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPERMD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x1B7), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4NF), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_32) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPERMD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x1BC), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4NF), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_32) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPERMI2B ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xB50), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512_VBMI) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_VBMI_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4NF), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPERMI2B ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xB54), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512_VBMI) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_VBMI_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4NF), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPERMI2B ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xB58), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512_VBMI) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_VBMI_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4NF), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPERMI2B ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xB5C), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512_VBMI) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_VBMI_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4NF), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FVM) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_8) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPERMI2B ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xB60), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512_VBMI) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_VBMI_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4NF), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FVM) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_8) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPERMI2B ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xB64), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512_VBMI) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_VBMI_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4NF), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FVM) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_8) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPERMI2D ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x48C), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4NF), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPERMI2D ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x491), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4NF), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPERMI2D ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x496), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4NF), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPERMI2D ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x49B), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4NF), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_32) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPERMI2D ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x4A0), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4NF), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_32) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPERMI2D ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x4A5), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4NF), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_32) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPERMI2PD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x26B), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4NF), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPERMI2PD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x270), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4NF), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPERMI2PD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x266), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4NF), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPERMI2PD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x275), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4NF), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_64) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPERMI2PD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x27A), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4NF), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_64) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPERMI2PD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x27F), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4NF), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_64) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPERMI2PS ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x289), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4NF), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPERMI2PS ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x28E), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4NF), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPERMI2PS ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x284), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4NF), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPERMI2PS ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x293), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4NF), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_32) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPERMI2PS ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x298), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4NF), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_32) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPERMI2PS ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x29D), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4NF), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_32) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPERMI2Q ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x4AA), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4NF), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPERMI2Q ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x4AF), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4NF), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPERMI2Q ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x4B4), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4NF), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPERMI2Q ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x4B9), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4NF), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_64) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPERMI2Q ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x4BE), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4NF), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_64) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPERMI2Q ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x4C3), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4NF), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_64) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPERMI2W ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xB68), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512BW_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4NF), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPERMI2W ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xB6C), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512BW_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4NF), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPERMI2W ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xB70), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512BW_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4NF), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPERMI2W ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xB74), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512BW_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4NF), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FVM) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_16) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPERMI2W ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xB78), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512BW_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4NF), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FVM) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_16) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPERMI2W ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xB7C), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512BW_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4NF), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FVM) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_16) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPERMILPD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x2AC), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4NF), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPERMILPD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x4CD), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4NF), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPERMILPD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x4C8), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4NF), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPERMILPD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x4D2), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4NF), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_64) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPERMILPD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x4D7), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4NF), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_64) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPERMILPD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x4DC), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4NF), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_64) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPERMILPD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xA04), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4NF), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPERMILPD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xA08), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4NF), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPERMILPD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xA00), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4NF), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPERMILPD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xA0C), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4NF), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_64) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPERMILPD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xA10), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4NF), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_64) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPERMILPD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xA14), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4NF), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_64) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPERMILPS ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x2C0), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4NF), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPERMILPS ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x4E6), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4NF), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPERMILPS ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x4E1), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4NF), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPERMILPS ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x4EB), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4NF), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_32) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPERMILPS ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x4F0), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4NF), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_32) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPERMILPS ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x4F5), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4NF), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_32) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPERMILPS ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xA34), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4NF), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPERMILPS ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xA38), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4NF), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPERMILPS ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xA30), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4NF), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPERMILPS ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xA3C), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4NF), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_32) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPERMILPS ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xA40), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4NF), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_32) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPERMILPS ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xA44), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4NF), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_32) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPERMPD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x4CD), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4NF), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPERMPD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x4C8), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4NF), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPERMPD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x4D7), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4NF), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_64) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPERMPD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x4DC), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4NF), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_64) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPERMPD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xA08), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4NF), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPERMPD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xA00), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4NF), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPERMPD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xA10), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4NF), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_64) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPERMPD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xA14), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4NF), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_64) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPERMPS ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x4E6), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4NF), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPERMPS ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x4E1), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4NF), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPERMPS ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x4F0), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4NF), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_32) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPERMPS ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x4F5), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4NF), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_32) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPERMQ ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x1C6), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4NF), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPERMQ ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x1CB), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4NF), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPERMQ ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x1D5), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4NF), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_64) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPERMQ ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x1DA), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4NF), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_64) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPERMQ ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xB80), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4NF), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPERMQ ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xB84), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4NF), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPERMQ ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xB88), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4NF), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_64) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPERMQ ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xB8C), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4NF), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_64) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPERMT2B ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xB50), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512_VBMI) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_VBMI_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4NF), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPERMT2B ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xB54), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512_VBMI) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_VBMI_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4NF), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPERMT2B ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xB58), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512_VBMI) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_VBMI_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4NF), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPERMT2B ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xB5C), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512_VBMI) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_VBMI_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4NF), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FVM) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_8) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPERMT2B ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xB60), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512_VBMI) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_VBMI_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4NF), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FVM) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_8) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPERMT2B ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xB64), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512_VBMI) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_VBMI_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4NF), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FVM) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_8) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPERMT2D ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x48C), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4NF), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPERMT2D ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x491), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4NF), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPERMT2D ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x496), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4NF), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPERMT2D ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x49B), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4NF), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_32) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPERMT2D ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x4A0), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4NF), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_32) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPERMT2D ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x4A5), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4NF), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_32) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPERMT2PD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x26B), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4NF), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPERMT2PD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x270), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4NF), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPERMT2PD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x266), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4NF), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPERMT2PD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x275), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4NF), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_64) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPERMT2PD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x27A), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4NF), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_64) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPERMT2PD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x27F), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4NF), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_64) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPERMT2PS ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x289), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4NF), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPERMT2PS ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x28E), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4NF), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPERMT2PS ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x284), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4NF), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPERMT2PS ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x293), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4NF), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_32) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPERMT2PS ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x298), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4NF), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_32) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPERMT2PS ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x29D), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4NF), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_32) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPERMT2Q ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x4AA), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4NF), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPERMT2Q ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x4AF), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4NF), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPERMT2Q ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x4B4), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4NF), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPERMT2Q ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x4B9), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4NF), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_64) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPERMT2Q ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x4BE), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4NF), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_64) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPERMT2Q ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x4C3), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4NF), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_64) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPERMT2W ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xB68), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512BW_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4NF), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPERMT2W ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xB6C), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512BW_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4NF), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPERMT2W ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xB70), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512BW_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4NF), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPERMT2W ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xB74), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512BW_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4NF), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FVM) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_16) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPERMT2W ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xB78), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512BW_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4NF), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FVM) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_16) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPERMT2W ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xB7C), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512BW_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4NF), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FVM) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_16) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPERMW ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x46E), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512BW_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4NF), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPERMW ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x473), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512BW_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4NF), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPERMW ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x478), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512BW_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4NF), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPERMW ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x47D), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512BW_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4NF), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FVM) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_16) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPERMW ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x482), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512BW_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4NF), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FVM) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_16) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPERMW ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x487), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512BW_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4NF), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FVM) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_16) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPEXPANDB ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1782), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_EXPAND) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_VBMI2_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPEXPANDB ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1785), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_EXPAND) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_VBMI2_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPEXPANDB ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1788), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_EXPAND) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_VBMI2_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPEXPANDB ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x178B), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_EXPAND) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_VBMI2_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_T1S) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_8) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPEXPANDB ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x178E), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_EXPAND) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_VBMI2_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_T1S) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_8) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPEXPANDB ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1791), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_EXPAND) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_VBMI2_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_T1S) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_8) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPEXPANDD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0xBF0), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_EXPAND) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPEXPANDD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0xBF4), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_EXPAND) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPEXPANDD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0xBF8), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_EXPAND) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPEXPANDD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1749), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_EXPAND) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_GSCAT) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_32) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPEXPANDD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x174C), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_EXPAND) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_GSCAT) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_32) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPEXPANDD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x174F), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_EXPAND) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_GSCAT) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_32) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPEXPANDQ ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1764), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_EXPAND) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPEXPANDQ ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0xB80), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_EXPAND) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPEXPANDQ ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0xB84), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_EXPAND) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPEXPANDQ ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1767), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_EXPAND) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_GSCAT) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_64) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPEXPANDQ ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x176A), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_EXPAND) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_GSCAT) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_64) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPEXPANDQ ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x176D), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_EXPAND) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_GSCAT) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_64) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPEXPANDW ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0xC08), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_EXPAND) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_VBMI2_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPEXPANDW ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0xC0C), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_EXPAND) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_VBMI2_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPEXPANDW ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0xC10), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_EXPAND) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_VBMI2_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPEXPANDW ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0xC14), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_EXPAND) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_VBMI2_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_T1S) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_16) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPEXPANDW ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0xC18), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_EXPAND) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_VBMI2_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_T1S) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_16) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPEXPANDW ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0xC1C), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_EXPAND) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_VBMI2_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_T1S) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_16) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPEXTRB ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1878), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512BW_128N) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E9NF), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_GPR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_FORBIDDEN, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPEXTRB ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x12DB), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512BW_128N) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E9NF), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_T1S) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_8) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_FORBIDDEN, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPEXTRD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0xF6C), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512DQ_128N) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E9NF), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_GPR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_FORBIDDEN, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPEXTRD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x12DE), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512DQ_128N) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E9NF), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_T1S) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_32) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_FORBIDDEN, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPEXTRD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0xF6C), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512DQ_128N) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E9NF), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_GPR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_FORBIDDEN, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPEXTRD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x12DE), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512DQ_128N) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E9NF), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_T1S) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_32) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_FORBIDDEN, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPEXTRQ ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x12E1), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512DQ_128N) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E9NF), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_GPR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_FORBIDDEN, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPEXTRQ ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x12E4), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512DQ_128N) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E9NF), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_T1S) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_64) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_FORBIDDEN, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPEXTRW ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x187B), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512BW_128N) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E9NF), ZYDIS_REGKIND_GPR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_FORBIDDEN, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPEXTRW ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x187E), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512BW_128N) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E9NF), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_GPR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_FORBIDDEN, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPEXTRW ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x12ED), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512BW_128N) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E9NF), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_T1S) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_16) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_FORBIDDEN, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPGATHERDD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1881), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_GATHER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E12), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_VSIB | (1 << 3) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_TRUE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_GSCAT) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_32) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_REQUIRED, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPGATHERDD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1884), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_GATHER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E12), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_VSIB | (1 << 3) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_TRUE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_GSCAT) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_32) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_REQUIRED, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPGATHERDD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1887), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_GATHER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E12), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_VSIB | (1 << 3) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_TRUE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_GSCAT) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_32) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_REQUIRED, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPGATHERDQ ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x188A), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_GATHER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E12), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_VSIB | (1 << 3) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_TRUE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_GSCAT) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_64) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_REQUIRED, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPGATHERDQ ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x188D), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_GATHER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E12), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_VSIB | (1 << 3) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_TRUE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_GSCAT) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_64) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_REQUIRED, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPGATHERDQ ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1890), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_GATHER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E12), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_VSIB | (1 << 3) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_TRUE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_GSCAT) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_64) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_REQUIRED, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPGATHERQD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1881), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_GATHER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E12), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_VSIB | (1 << 3) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_TRUE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_GSCAT) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_32) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_REQUIRED, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPGATHERQD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1893), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_GATHER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E12), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_VSIB | (1 << 3) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_TRUE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_GSCAT) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_32) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_REQUIRED, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPGATHERQD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1896), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_GATHER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E12), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_VSIB | (1 << 3) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_TRUE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_GSCAT) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_32) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_REQUIRED, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPGATHERQQ ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x188A), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_GATHER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E12), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_VSIB | (1 << 3) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_TRUE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_GSCAT) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_64) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_REQUIRED, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPGATHERQQ ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1899), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_GATHER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E12), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_VSIB | (1 << 3) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_TRUE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_GSCAT) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_64) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_REQUIRED, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPGATHERQQ ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x189C), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_GATHER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E12), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_VSIB | (1 << 3) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_TRUE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_GSCAT) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_64) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_REQUIRED, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPINSRB ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x848), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512BW_128N) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E9NF), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_GPR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_FORBIDDEN, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPINSRB ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x84C), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512BW_128N) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E9NF), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_T1S) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_8) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_FORBIDDEN, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPINSRD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x850), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512DQ_128N) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E9NF), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_GPR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_FORBIDDEN, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPINSRD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x854), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512DQ_128N) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E9NF), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_T1S) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_32) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_FORBIDDEN, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPINSRD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x850), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512DQ_128N) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E9NF), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_GPR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_FORBIDDEN, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPINSRD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x854), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512DQ_128N) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E9NF), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_T1S) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_32) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_FORBIDDEN, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPINSRQ ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x858), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512DQ_128N) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E9NF), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_GPR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_FORBIDDEN, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPINSRQ ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x85C), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512DQ_128N) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E9NF), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_T1S) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_64) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_FORBIDDEN, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPINSRW ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x860), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512BW_128N) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E9NF), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_GPR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_FORBIDDEN, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPINSRW ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x864), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512BW_128N) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E9NF), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_T1S) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_16) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_FORBIDDEN, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPLZCNTD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0xBF0), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONFLICT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512CD_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPLZCNTD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0xBF4), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONFLICT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512CD_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPLZCNTD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0xBF8), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONFLICT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512CD_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPLZCNTD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0xBFC), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONFLICT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512CD_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_32) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPLZCNTD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0xC00), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONFLICT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512CD_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_32) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPLZCNTD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0xC04), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONFLICT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512CD_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_32) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPLZCNTQ ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1764), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONFLICT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512CD_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPLZCNTQ ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0xB80), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONFLICT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512CD_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPLZCNTQ ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0xB84), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONFLICT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512CD_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPLZCNTQ ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1875), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONFLICT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512CD_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_64) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPLZCNTQ ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0xB88), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONFLICT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512CD_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_64) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPLZCNTQ ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0xB8C), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONFLICT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512CD_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_64) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPMADD52HUQ ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x4AA), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_IFMA) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_IFMA_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPMADD52HUQ ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x4AF), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_IFMA) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_IFMA_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPMADD52HUQ ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x4B4), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_IFMA) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_IFMA_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPMADD52HUQ ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x4B9), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_IFMA) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_IFMA_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_64) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPMADD52HUQ ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x4BE), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_IFMA) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_IFMA_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_64) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPMADD52HUQ ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x4C3), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_IFMA) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_IFMA_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_64) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPMADD52LUQ ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x4AA), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_IFMA) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_IFMA_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPMADD52LUQ ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x4AF), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_IFMA) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_IFMA_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPMADD52LUQ ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x4B4), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_IFMA) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_IFMA_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPMADD52LUQ ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x4B9), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_IFMA) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_IFMA_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_64) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPMADD52LUQ ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x4BE), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_IFMA) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_IFMA_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_64) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPMADD52LUQ ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x4C3), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_IFMA) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_IFMA_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_64) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPMADDUBSW ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xB00), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512BW_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4NF), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPMADDUBSW ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xB04), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512BW_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4NF), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPMADDUBSW ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xB08), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512BW_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4NF), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPMADDUBSW ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xB0C), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512BW_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4NF), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FVM) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_16) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPMADDUBSW ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xB10), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512BW_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4NF), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FVM) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_16) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPMADDUBSW ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xB14), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512BW_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4NF), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FVM) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_16) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPMADDWD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xB90), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512BW_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4NF), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPMADDWD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xB94), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512BW_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4NF), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPMADDWD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xB98), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512BW_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4NF), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPMADDWD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xB9C), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512BW_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4NF), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FVM) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_16) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPMADDWD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xBA0), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512BW_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4NF), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FVM) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_16) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPMADDWD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xBA4), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512BW_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4NF), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FVM) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_16) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPMAXSB ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xAB8), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512BW_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPMAXSB ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xABC), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512BW_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPMAXSB ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xAC0), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512BW_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPMAXSB ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xAC4), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512BW_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FVM) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_8) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPMAXSB ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xAC8), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512BW_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FVM) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_8) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPMAXSB ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xACC), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512BW_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FVM) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_8) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPMAXSD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xAD0), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPMAXSD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xAD4), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPMAXSD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xAD8), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPMAXSD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xADC), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_32) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPMAXSD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xAE0), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_32) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPMAXSD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xAE4), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_32) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPMAXSQ ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xAE8), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPMAXSQ ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xAEC), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPMAXSQ ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xAF0), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPMAXSQ ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xAF4), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_64) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPMAXSQ ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xAF8), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_64) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPMAXSQ ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xAFC), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_64) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPMAXSW ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xB00), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512BW_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPMAXSW ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xB04), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512BW_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPMAXSW ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xB08), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512BW_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPMAXSW ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xB0C), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512BW_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FVM) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_16) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPMAXSW ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xB10), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512BW_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FVM) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_16) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPMAXSW ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xB14), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512BW_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FVM) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_16) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPMAXUB ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x360), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512BW_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPMAXUB ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x365), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512BW_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPMAXUB ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x36A), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512BW_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPMAXUB ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x36F), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512BW_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FVM) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_8) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPMAXUB ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x374), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512BW_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FVM) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_8) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPMAXUB ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x379), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512BW_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FVM) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_8) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPMAXUD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x1A3), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPMAXUD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x1A8), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPMAXUD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x1AD), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPMAXUD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x1B2), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_32) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPMAXUD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x1B7), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_32) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPMAXUD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x1BC), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_32) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPMAXUQ ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x1C1), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPMAXUQ ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x1C6), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPMAXUQ ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x1CB), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPMAXUQ ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x1D0), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_64) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPMAXUQ ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x1D5), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_64) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPMAXUQ ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x1DA), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_64) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPMAXUW ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x46E), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512BW_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPMAXUW ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x473), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512BW_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPMAXUW ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x478), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512BW_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPMAXUW ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x47D), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512BW_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FVM) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_16) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPMAXUW ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x482), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512BW_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FVM) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_16) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPMAXUW ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x487), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512BW_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FVM) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_16) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPMINSB ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xAB8), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512BW_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPMINSB ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xABC), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512BW_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPMINSB ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xAC0), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512BW_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPMINSB ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xAC4), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512BW_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FVM) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_8) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPMINSB ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xAC8), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512BW_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FVM) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_8) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPMINSB ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xACC), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512BW_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FVM) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_8) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPMINSD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xAD0), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPMINSD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xAD4), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPMINSD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xAD8), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPMINSD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xADC), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_32) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPMINSD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xAE0), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_32) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPMINSD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xAE4), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_32) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPMINSQ ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xAE8), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPMINSQ ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xAEC), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPMINSQ ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xAF0), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPMINSQ ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xAF4), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_64) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPMINSQ ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xAF8), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_64) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPMINSQ ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xAFC), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_64) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPMINSW ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xB00), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512BW_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPMINSW ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xB04), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512BW_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPMINSW ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xB08), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512BW_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPMINSW ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xB0C), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512BW_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FVM) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_16) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPMINSW ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xB10), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512BW_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FVM) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_16) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPMINSW ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xB14), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512BW_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FVM) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_16) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPMINUB ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x360), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512BW_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPMINUB ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x365), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512BW_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPMINUB ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x36A), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512BW_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPMINUB ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x36F), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512BW_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FVM) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_8) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPMINUB ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x374), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512BW_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FVM) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_8) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPMINUB ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x379), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512BW_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FVM) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_8) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPMINUD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x1A3), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPMINUD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x1A8), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPMINUD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x1AD), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPMINUD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x1B2), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_32) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPMINUD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x1B7), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_32) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPMINUD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x1BC), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_32) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPMINUQ ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x1C1), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPMINUQ ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x1C6), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPMINUQ ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x1CB), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPMINUQ ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x1D0), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_64) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPMINUQ ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x1D5), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_64) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPMINUQ ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x1DA), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_64) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPMINUW ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x46E), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512BW_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPMINUW ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x473), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512BW_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPMINUW ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x478), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512BW_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPMINUW ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x47D), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512BW_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FVM) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_16) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPMINUW ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x482), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512BW_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FVM) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_16) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPMINUW ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x487), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512BW_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FVM) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_16) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPMOVB2M ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1ECB), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512BW_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E7NM), ZYDIS_REGKIND_MASK, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_FORBIDDEN, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPMOVB2M ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1ECD), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512BW_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E7NM), ZYDIS_REGKIND_MASK, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_FORBIDDEN, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPMOVB2M ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1ECF), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512BW_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E7NM), ZYDIS_REGKIND_MASK, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_FORBIDDEN, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPMOVD2M ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1ED1), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512DQ_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E7NM), ZYDIS_REGKIND_MASK, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_FORBIDDEN, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPMOVD2M ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1ED3), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512DQ_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E7NM), ZYDIS_REGKIND_MASK, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_FORBIDDEN, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPMOVD2M ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1ED5), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512DQ_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E7NM), ZYDIS_REGKIND_MASK, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_FORBIDDEN, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPMOVDB ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x189F), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E6NF), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPMOVDB ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x18A2), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E6NF), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPMOVDB ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x18A5), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E6NF), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPMOVDB ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x18A8), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E6), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_QVM) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_8) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPMOVDB ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x18AB), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E6), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_QVM) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_8) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPMOVDB ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x18AE), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E6), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_QVM) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_8) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPMOVDW ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x18B1), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E6NF), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPMOVDW ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x18B4), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E6NF), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPMOVDW ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x18B7), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E6NF), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPMOVDW ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x18BA), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E6), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_HVM) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_16) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPMOVDW ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x18BD), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E6), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_HVM) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_16) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPMOVDW ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x18C0), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E6), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_HVM) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_16) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPMOVM2B ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1ED7), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512BW_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E7NM), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_MASK ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_FORBIDDEN, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPMOVM2B ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1ED9), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512BW_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E7NM), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_MASK ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_FORBIDDEN, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPMOVM2B ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1EDB), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512BW_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E7NM), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_MASK ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_FORBIDDEN, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPMOVM2D ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1EDD), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512DQ_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E7NM), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_MASK ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_FORBIDDEN, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPMOVM2D ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1EDF), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512DQ_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E7NM), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_MASK ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_FORBIDDEN, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPMOVM2D ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1EE1), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512DQ_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E7NM), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_MASK ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_FORBIDDEN, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPMOVM2Q ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1EE3), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512DQ_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E7NM), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_MASK ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_FORBIDDEN, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPMOVM2Q ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1EE5), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512DQ_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E7NM), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_MASK ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_FORBIDDEN, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPMOVM2Q ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1EE7), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512DQ_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E7NM), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_MASK ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_FORBIDDEN, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPMOVM2W ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1EE9), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512BW_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E7NM), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_MASK ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_FORBIDDEN, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPMOVM2W ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1EEB), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512BW_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E7NM), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_MASK ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_FORBIDDEN, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPMOVM2W ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1EED), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512BW_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E7NM), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_MASK ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_FORBIDDEN, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPMOVQ2M ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1EEF), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512DQ_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E7NM), ZYDIS_REGKIND_MASK, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_FORBIDDEN, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPMOVQ2M ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1EF1), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512DQ_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E7NM), ZYDIS_REGKIND_MASK, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_FORBIDDEN, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPMOVQ2M ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1EF3), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512DQ_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E7NM), ZYDIS_REGKIND_MASK, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_FORBIDDEN, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPMOVQB ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x18C3), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E6NF), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPMOVQB ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x18C6), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E6NF), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPMOVQB ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x18C9), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E6NF), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPMOVQB ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x18CC), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E6), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_OVM) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_8) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPMOVQB ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x18CF), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E6), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_OVM) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_8) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPMOVQB ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x18D2), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E6), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_OVM) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_8) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPMOVQD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x18D5), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E6NF), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPMOVQD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x18D8), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E6NF), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPMOVQD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x18DB), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E6NF), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPMOVQD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x18DE), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E6), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_HVM) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_32) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPMOVQD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x18E1), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E6), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_HVM) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_32) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPMOVQD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x18E4), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E6), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_HVM) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_32) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPMOVQW ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x18E7), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E6NF), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPMOVQW ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x18EA), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E6NF), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPMOVQW ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x18ED), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E6NF), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPMOVQW ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x18F0), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E6), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_QVM) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_16) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPMOVQW ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x18F3), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E6), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_QVM) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_16) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPMOVQW ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x18F6), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E6), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_QVM) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_16) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPMOVSDB ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x18F9), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E6NF), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPMOVSDB ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x18FC), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E6NF), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPMOVSDB ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x18FF), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E6NF), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPMOVSDB ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1902), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E6), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_QVM) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_8) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPMOVSDB ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1905), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E6), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_QVM) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_8) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPMOVSDB ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1908), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E6), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_QVM) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_8) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPMOVSDW ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x190B), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E6NF), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPMOVSDW ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x190E), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E6NF), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPMOVSDW ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1911), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E6NF), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPMOVSDW ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1914), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E6), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_HVM) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_16) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPMOVSDW ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1917), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E6), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_HVM) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_16) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPMOVSDW ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x191A), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E6), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_HVM) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_16) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPMOVSQB ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x191D), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E6NF), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPMOVSQB ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1920), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E6NF), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPMOVSQB ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1923), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E6NF), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPMOVSQB ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1926), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E6), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_OVM) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_8) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPMOVSQB ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1929), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E6), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_OVM) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_8) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPMOVSQB ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x192C), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E6), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_OVM) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_8) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPMOVSQD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x192F), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E6NF), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPMOVSQD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1932), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E6NF), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPMOVSQD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1935), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E6NF), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPMOVSQD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1938), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E6), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_HVM) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_32) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPMOVSQD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x193B), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E6), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_HVM) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_32) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPMOVSQD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x193E), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E6), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_HVM) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_32) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPMOVSQW ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1941), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E6NF), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPMOVSQW ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1944), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E6NF), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPMOVSQW ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1947), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E6NF), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPMOVSQW ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x194A), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E6), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_QVM) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_16) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPMOVSQW ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x194D), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E6), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_QVM) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_16) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPMOVSQW ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1950), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E6), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_QVM) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_16) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPMOVSWB ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1953), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512BW_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E6NF), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPMOVSWB ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1956), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512BW_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E6NF), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPMOVSWB ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1959), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512BW_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E6NF), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPMOVSWB ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x195C), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512BW_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E6), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_HVM) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_8) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPMOVSWB ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x195F), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512BW_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E6), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_HVM) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_8) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPMOVSWB ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1962), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512BW_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E6), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_HVM) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_8) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPMOVSXBD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1965), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E5), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPMOVSXBD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1968), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E5), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPMOVSXBD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x196B), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E5), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPMOVSXBD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x196E), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E5), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_QVM) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_8) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPMOVSXBD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1971), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E5), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_QVM) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_8) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPMOVSXBD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1974), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E5), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_QVM) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_8) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPMOVSXBQ ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1977), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E5), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPMOVSXBQ ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x197A), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E5), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPMOVSXBQ ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x197D), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E5), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPMOVSXBQ ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1980), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E5), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_OVM) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_8) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPMOVSXBQ ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1983), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E5), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_OVM) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_8) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPMOVSXBQ ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1986), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E5), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_OVM) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_8) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPMOVSXBW ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1989), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512BW_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E5), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPMOVSXBW ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x198C), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512BW_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E5), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPMOVSXBW ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x198F), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512BW_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E5), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPMOVSXBW ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1992), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512BW_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E5), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_HVM) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_8) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPMOVSXBW ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1995), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512BW_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E5), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_HVM) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_8) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPMOVSXBW ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1998), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512BW_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E5), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_HVM) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_8) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPMOVSXDQ ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x199B), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E5), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPMOVSXDQ ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x199E), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E5), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPMOVSXDQ ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x19A1), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E5), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPMOVSXDQ ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x19A4), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E5), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_HVM) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_32) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPMOVSXDQ ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x19A7), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E5), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_HVM) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_32) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPMOVSXDQ ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x19AA), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E5), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_HVM) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_32) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPMOVSXWD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x19AD), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E5), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPMOVSXWD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x19B0), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E5), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPMOVSXWD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x19B3), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E5), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPMOVSXWD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x19B6), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E5), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_HVM) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_16) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPMOVSXWD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x19B9), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E5), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_HVM) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_16) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPMOVSXWD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x19BC), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E5), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_HVM) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_16) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPMOVSXWQ ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x19BF), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E5), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPMOVSXWQ ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x19C2), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E5), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPMOVSXWQ ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x19C5), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E5), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPMOVSXWQ ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x19C8), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E5), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_QVM) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_16) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPMOVSXWQ ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x19CB), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E5), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_QVM) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_16) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPMOVSXWQ ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x19CE), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E5), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_QVM) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_16) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPMOVUSDB ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x189F), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E6NF), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPMOVUSDB ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x18A2), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E6NF), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPMOVUSDB ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x18A5), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E6NF), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPMOVUSDB ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x18A8), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E6), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_QVM) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_8) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPMOVUSDB ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x18AB), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E6), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_QVM) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_8) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPMOVUSDB ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x18AE), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E6), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_QVM) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_8) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPMOVUSDW ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x18B1), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E6NF), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPMOVUSDW ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x18B4), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E6NF), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPMOVUSDW ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x18B7), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E6NF), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPMOVUSDW ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x18BA), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E6), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_HVM) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_16) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPMOVUSDW ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x18BD), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E6), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_HVM) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_16) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPMOVUSDW ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x18C0), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E6), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_HVM) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_16) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPMOVUSQB ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x18C3), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E6NF), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPMOVUSQB ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x18C6), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E6NF), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPMOVUSQB ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x18C9), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E6NF), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPMOVUSQB ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x18CC), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E6), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_OVM) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_8) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPMOVUSQB ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x18CF), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E6), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_OVM) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_8) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPMOVUSQB ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x18D2), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E6), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_OVM) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_8) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPMOVUSQD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x18D5), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E6NF), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPMOVUSQD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x18D8), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E6NF), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPMOVUSQD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x18DB), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E6NF), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPMOVUSQD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x18DE), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E6), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_HVM) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_32) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPMOVUSQD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x18E1), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E6), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_HVM) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_32) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPMOVUSQD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x18E4), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E6), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_HVM) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_32) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPMOVUSQW ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x18E7), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E6NF), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPMOVUSQW ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x18EA), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E6NF), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPMOVUSQW ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x18ED), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E6NF), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPMOVUSQW ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x18F0), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E6), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_QVM) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_16) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPMOVUSQW ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x18F3), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E6), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_QVM) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_16) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPMOVUSQW ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x18F6), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E6), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_QVM) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_16) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPMOVUSWB ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x19D1), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512BW_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E6NF), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPMOVUSWB ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x19D4), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512BW_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E6NF), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPMOVUSWB ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x19D7), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512BW_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E6NF), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPMOVUSWB ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x19DA), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512BW_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E6), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_HVM) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_8) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPMOVUSWB ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x19DD), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512BW_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E6), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_HVM) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_8) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPMOVUSWB ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x19E0), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512BW_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E6), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_HVM) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_8) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPMOVW2M ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1EF5), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512BW_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E7NM), ZYDIS_REGKIND_MASK, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_FORBIDDEN, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPMOVW2M ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1EF7), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512BW_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E7NM), ZYDIS_REGKIND_MASK, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_FORBIDDEN, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPMOVW2M ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1EF9), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512BW_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E7NM), ZYDIS_REGKIND_MASK, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_FORBIDDEN, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPMOVWB ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x19D1), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512BW_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E6NF), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPMOVWB ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x19D4), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512BW_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E6NF), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPMOVWB ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x19D7), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512BW_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E6NF), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPMOVWB ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x19DA), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512BW_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E6), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_HVM) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_8) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPMOVWB ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x19DD), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512BW_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E6), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_HVM) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_8) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPMOVWB ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x19E0), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512BW_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E6), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_HVM) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_8) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPMOVZXBD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x19E3), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E5), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPMOVZXBD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x19E6), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E5), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPMOVZXBD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x19E9), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E5), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPMOVZXBD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x19EC), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E5), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_QVM) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_8) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPMOVZXBD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x19EF), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E5), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_QVM) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_8) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPMOVZXBD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x19F2), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E5), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_QVM) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_8) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPMOVZXBQ ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x19F5), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E5), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPMOVZXBQ ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x19F8), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E5), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPMOVZXBQ ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x19FB), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E5), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPMOVZXBQ ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x19FE), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E5), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_OVM) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_8) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPMOVZXBQ ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1A01), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E5), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_OVM) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_8) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPMOVZXBQ ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1A04), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E5), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_OVM) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_8) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPMOVZXBW ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1A07), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512BW_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E5), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPMOVZXBW ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1A0A), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512BW_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E5), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPMOVZXBW ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1A0D), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512BW_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E5), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPMOVZXBW ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1A10), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512BW_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E5), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_HVM) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_8) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPMOVZXBW ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1A13), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512BW_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E5), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_HVM) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_8) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPMOVZXBW ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1A16), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512BW_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E5), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_HVM) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_8) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPMOVZXDQ ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1A19), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E5), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPMOVZXDQ ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1A1C), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E5), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPMOVZXDQ ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1A1F), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E5), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPMOVZXDQ ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1A22), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E5), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_HVM) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_32) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPMOVZXDQ ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1A25), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E5), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_HVM) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_32) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPMOVZXDQ ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1A28), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E5), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_HVM) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_32) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPMOVZXWD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1A2B), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E5), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPMOVZXWD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1A2E), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E5), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPMOVZXWD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1A31), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E5), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPMOVZXWD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1A34), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E5), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_HVM) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_16) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPMOVZXWD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1A37), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E5), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_HVM) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_16) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPMOVZXWD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1A3A), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E5), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_HVM) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_16) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPMOVZXWQ ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1A3D), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E5), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPMOVZXWQ ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1A40), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E5), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPMOVZXWQ ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1A43), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E5), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPMOVZXWQ ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1A46), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E5), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_QVM) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_16) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPMOVZXWQ ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1A49), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E5), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_QVM) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_16) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPMOVZXWQ ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1A4C), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E5), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_QVM) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_16) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPMULDQ ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xAE8), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPMULDQ ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xAEC), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPMULDQ ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xAF0), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPMULDQ ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xAF4), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_64) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPMULDQ ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xAF8), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_64) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPMULDQ ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xAFC), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_64) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPMULHRSW ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xB00), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512BW_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPMULHRSW ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xB04), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512BW_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPMULHRSW ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xB08), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512BW_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPMULHRSW ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xB0C), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512BW_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FVM) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_16) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPMULHRSW ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xB10), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512BW_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FVM) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_16) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPMULHRSW ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xB14), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512BW_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FVM) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_16) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPMULHUW ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x46E), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512BW_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPMULHUW ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x473), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512BW_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPMULHUW ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x478), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512BW_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPMULHUW ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x47D), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512BW_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FVM) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_16) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPMULHUW ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x482), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512BW_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FVM) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_16) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPMULHUW ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x487), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512BW_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FVM) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_16) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPMULHW ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xB00), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512BW_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPMULHW ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xB04), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512BW_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPMULHW ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xB08), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512BW_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPMULHW ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xB0C), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512BW_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FVM) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_16) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPMULHW ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xB10), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512BW_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FVM) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_16) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPMULHW ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xB14), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512BW_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FVM) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_16) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPMULLD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xAD0), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPMULLD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xAD4), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPMULLD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xAD8), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPMULLD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xADC), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_32) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPMULLD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xAE0), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_32) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPMULLD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xAE4), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_32) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPMULLQ ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x1C1), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512DQ_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPMULLQ ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x1C6), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512DQ_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPMULLQ ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x1CB), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512DQ_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPMULLQ ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x1D0), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512DQ_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_64) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPMULLQ ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x1D5), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512DQ_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_64) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPMULLQ ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x1DA), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512DQ_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_64) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPMULLW ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xB00), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512BW_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPMULLW ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xB04), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512BW_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPMULLW ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xB08), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512BW_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPMULLW ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xB0C), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512BW_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FVM) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_16) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPMULLW ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xB10), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512BW_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FVM) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_16) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPMULLW ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xB14), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512BW_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FVM) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_16) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPMULTISHIFTQB ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x2CA), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512_VBMI) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_VBMI_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4NF), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPMULTISHIFTQB ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x2CF), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512_VBMI) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_VBMI_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4NF), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPMULTISHIFTQB ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x2D4), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512_VBMI) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_VBMI_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4NF), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPMULTISHIFTQB ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x2D9), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512_VBMI) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_VBMI_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4NF), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_64) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPMULTISHIFTQB ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x2DE), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512_VBMI) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_VBMI_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4NF), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_64) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPMULTISHIFTQB ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x2E3), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512_VBMI) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_VBMI_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4NF), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_64) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPMULUDQ ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x1C1), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPMULUDQ ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x1C6), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPMULUDQ ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x1CB), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPMULUDQ ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x1D0), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_64) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPMULUDQ ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x1D5), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_64) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPMULUDQ ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x1DA), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_64) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPOPCNTB ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1782), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_BITALG_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPOPCNTB ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1785), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_BITALG_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPOPCNTB ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1788), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512_BITALG) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_BITALG_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPOPCNTB ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x178B), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_BITALG_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FVM) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_8) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPOPCNTB ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x178E), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_BITALG_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FVM) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_8) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPOPCNTB ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1791), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512_BITALG) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_BITALG_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FVM) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_8) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPOPCNTD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0xBF0), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_VPOPCNTDQ_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPOPCNTD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0xBF4), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_VPOPCNTDQ_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPOPCNTD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0xBF8), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_VPOPCNTDQ_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPOPCNTD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0xBFC), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_VPOPCNTDQ_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_32) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPOPCNTD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0xC00), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_VPOPCNTDQ_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_32) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPOPCNTD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0xC04), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_VPOPCNTDQ_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_32) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPOPCNTQ ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1764), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_VPOPCNTDQ_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPOPCNTQ ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0xB80), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_VPOPCNTDQ_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPOPCNTQ ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0xB84), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_VPOPCNTDQ_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPOPCNTQ ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1875), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_VPOPCNTDQ_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_64) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPOPCNTQ ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0xB88), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_VPOPCNTDQ_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_64) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPOPCNTQ ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0xB8C), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_VPOPCNTDQ_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_64) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPOPCNTW ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0xC08), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_BITALG_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPOPCNTW ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0xC0C), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_BITALG_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPOPCNTW ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0xC10), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512_BITALG) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_BITALG_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPOPCNTW ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0xC14), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_BITALG_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FVM) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_16) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPOPCNTW ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0xC18), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_BITALG_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FVM) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_16) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPOPCNTW ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0xC1C), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512_BITALG) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_BITALG_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FVM) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_16) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPORD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x1A3), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_LOGICAL) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPORD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x1A8), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_LOGICAL) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPORD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x1AD), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_LOGICAL) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPORD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x1B2), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_LOGICAL) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_32) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPORD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x1B7), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_LOGICAL) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_32) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPORD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x1BC), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_LOGICAL) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_32) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPORQ ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x1C1), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_LOGICAL) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPORQ ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x1C6), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_LOGICAL) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPORQ ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x1CB), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_LOGICAL) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPORQ ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x1D0), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_LOGICAL) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_64) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPORQ ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x1D5), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_LOGICAL) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_64) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPORQ ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x1DA), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_LOGICAL) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_64) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPROLD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xBA8), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), 0, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPROLD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xBAC), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), 0, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPROLD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xBB0), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), 0, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPROLD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xBB4), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), 0, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_32) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPROLD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xBB8), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), 0, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_32) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPROLD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xBBC), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), 0, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_32) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPROLQ ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xBC0), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), 0, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPROLQ ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xBC4), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), 0, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPROLQ ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xBC8), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), 0, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPROLQ ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xBCC), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), 0, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_64) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPROLQ ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xBD0), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), 0, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_64) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPROLQ ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xBD4), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), 0, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_64) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPROLVD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x1A3), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPROLVD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x1A8), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPROLVD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x1AD), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPROLVD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x1B2), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_32) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPROLVD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x1B7), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_32) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPROLVD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x1BC), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_32) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPROLVQ ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x1C1), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPROLVQ ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x1C6), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPROLVQ ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x1CB), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPROLVQ ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x1D0), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_64) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPROLVQ ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x1D5), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_64) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPROLVQ ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x1DA), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_64) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPRORD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xBA8), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), 0, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPRORD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xBAC), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), 0, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPRORD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xBB0), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), 0, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPRORD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xBB4), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), 0, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_32) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPRORD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xBB8), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), 0, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_32) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPRORD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xBBC), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), 0, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_32) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPRORQ ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xBC0), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), 0, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPRORQ ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xBC4), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), 0, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPRORQ ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xBC8), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), 0, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPRORQ ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xBCC), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), 0, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_64) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPRORQ ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xBD0), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), 0, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_64) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPRORQ ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xBD4), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), 0, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_64) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPRORVD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x1A3), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPRORVD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x1A8), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPRORVD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x1AD), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPRORVD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x1B2), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_32) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPRORVD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x1B7), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_32) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPRORVD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x1BC), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_32) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPRORVQ ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x1C1), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPRORVQ ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x1C6), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPRORVQ ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x1CB), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPRORVQ ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x1D0), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_64) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPRORVQ ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x1D5), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_64) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPRORVQ ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x1DA), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_64) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPSADBW ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x7F8), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512BW_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4NF), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_FORBIDDEN, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPSADBW ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x7FC), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512BW_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4NF), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_FORBIDDEN, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPSADBW ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1A4F), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512BW_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4NF), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_FORBIDDEN, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPSADBW ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x800), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512BW_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4NF), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FVM) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_8) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_FORBIDDEN, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPSADBW ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x804), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512BW_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4NF), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FVM) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_8) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_FORBIDDEN, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPSADBW ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1A52), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512BW_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4NF), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FVM) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_8) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_FORBIDDEN, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPSCATTERDD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1A55), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_SCATTER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E12), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_VSIB | (1 << 3) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_GSCAT) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_32) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_REQUIRED, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPSCATTERDD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1A58), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_SCATTER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E12), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_VSIB | (1 << 3) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_GSCAT) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_32) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_REQUIRED, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPSCATTERDD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1A5B), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_SCATTER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E12), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_VSIB | (1 << 3) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_GSCAT) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_32) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_REQUIRED, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPSCATTERDQ ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1A5E), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_SCATTER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E12), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_VSIB | (1 << 3) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_GSCAT) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_64) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_REQUIRED, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPSCATTERDQ ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1A61), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_SCATTER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E12), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_VSIB | (1 << 3) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_GSCAT) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_64) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_REQUIRED, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPSCATTERDQ ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1A64), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_SCATTER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E12), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_VSIB | (1 << 3) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_GSCAT) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_64) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_REQUIRED, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPSCATTERQD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1A67), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_SCATTER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E12), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_VSIB | (1 << 3) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_GSCAT) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_32) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_REQUIRED, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPSCATTERQD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1A6A), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_SCATTER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E12), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_VSIB | (1 << 3) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_GSCAT) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_32) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_REQUIRED, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPSCATTERQD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1A6D), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_SCATTER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E12), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_VSIB | (1 << 3) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_GSCAT) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_32) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_REQUIRED, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPSCATTERQQ ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1A70), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_SCATTER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E12), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_VSIB | (1 << 3) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_GSCAT) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_64) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_REQUIRED, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPSCATTERQQ ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1A73), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_SCATTER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E12), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_VSIB | (1 << 3) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_GSCAT) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_64) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_REQUIRED, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPSCATTERQQ ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1A76), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_SCATTER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E12), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_VSIB | (1 << 3) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_GSCAT) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_64) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_REQUIRED, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPSHLDD ZYDIS_NOTMIN(5) ZYDIS_NOTMIN(5) ZYDIS_NOTMIN(0x1A3), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VBMI2) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_VBMI2_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPSHLDD ZYDIS_NOTMIN(5) ZYDIS_NOTMIN(5) ZYDIS_NOTMIN(0x1A8), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VBMI2) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_VBMI2_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPSHLDD ZYDIS_NOTMIN(5) ZYDIS_NOTMIN(5) ZYDIS_NOTMIN(0x1AD), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VBMI2) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_VBMI2_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPSHLDD ZYDIS_NOTMIN(5) ZYDIS_NOTMIN(5) ZYDIS_NOTMIN(0x1B2), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VBMI2) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_VBMI2_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_32) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPSHLDD ZYDIS_NOTMIN(5) ZYDIS_NOTMIN(5) ZYDIS_NOTMIN(0x1B7), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VBMI2) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_VBMI2_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_32) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPSHLDD ZYDIS_NOTMIN(5) ZYDIS_NOTMIN(5) ZYDIS_NOTMIN(0x1BC), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VBMI2) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_VBMI2_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_32) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPSHLDQ ZYDIS_NOTMIN(5) ZYDIS_NOTMIN(5) ZYDIS_NOTMIN(0x1C1), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VBMI2) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_VBMI2_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPSHLDQ ZYDIS_NOTMIN(5) ZYDIS_NOTMIN(5) ZYDIS_NOTMIN(0x1C6), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VBMI2) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_VBMI2_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPSHLDQ ZYDIS_NOTMIN(5) ZYDIS_NOTMIN(5) ZYDIS_NOTMIN(0x1CB), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VBMI2) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_VBMI2_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPSHLDQ ZYDIS_NOTMIN(5) ZYDIS_NOTMIN(5) ZYDIS_NOTMIN(0x1D0), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VBMI2) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_VBMI2_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_64) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPSHLDQ ZYDIS_NOTMIN(5) ZYDIS_NOTMIN(5) ZYDIS_NOTMIN(0x1D5), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VBMI2) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_VBMI2_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_64) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPSHLDQ ZYDIS_NOTMIN(5) ZYDIS_NOTMIN(5) ZYDIS_NOTMIN(0x1DA), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VBMI2) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_VBMI2_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_64) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPSHLDVD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x48C), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VBMI2) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_VBMI2_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPSHLDVD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x491), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VBMI2) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_VBMI2_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPSHLDVD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x496), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VBMI2) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_VBMI2_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPSHLDVD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x49B), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VBMI2) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_VBMI2_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_32) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPSHLDVD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x4A0), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VBMI2) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_VBMI2_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_32) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPSHLDVD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x4A5), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VBMI2) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_VBMI2_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_32) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPSHLDVQ ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x4AA), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VBMI2) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_VBMI2_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPSHLDVQ ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x4AF), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VBMI2) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_VBMI2_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPSHLDVQ ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x4B4), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VBMI2) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_VBMI2_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPSHLDVQ ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x4B9), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VBMI2) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_VBMI2_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_64) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPSHLDVQ ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x4BE), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VBMI2) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_VBMI2_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_64) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPSHLDVQ ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x4C3), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VBMI2) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_VBMI2_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_64) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPSHLDVW ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xB68), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VBMI2) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_VBMI2_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPSHLDVW ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xB6C), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VBMI2) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_VBMI2_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPSHLDVW ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xB70), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VBMI2) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_VBMI2_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPSHLDVW ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xB74), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VBMI2) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_VBMI2_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FVM) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_16) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPSHLDVW ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xB78), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VBMI2) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_VBMI2_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FVM) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_16) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPSHLDVW ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xB7C), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VBMI2) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_VBMI2_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FVM) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_16) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPSHLDW ZYDIS_NOTMIN(5) ZYDIS_NOTMIN(5) ZYDIS_NOTMIN(0x46E), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VBMI2) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_VBMI2_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPSHLDW ZYDIS_NOTMIN(5) ZYDIS_NOTMIN(5) ZYDIS_NOTMIN(0x473), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VBMI2) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_VBMI2_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPSHLDW ZYDIS_NOTMIN(5) ZYDIS_NOTMIN(5) ZYDIS_NOTMIN(0x478), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VBMI2) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_VBMI2_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPSHLDW ZYDIS_NOTMIN(5) ZYDIS_NOTMIN(5) ZYDIS_NOTMIN(0x47D), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VBMI2) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_VBMI2_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FVM) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_16) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPSHLDW ZYDIS_NOTMIN(5) ZYDIS_NOTMIN(5) ZYDIS_NOTMIN(0x482), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VBMI2) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_VBMI2_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FVM) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_16) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPSHLDW ZYDIS_NOTMIN(5) ZYDIS_NOTMIN(5) ZYDIS_NOTMIN(0x487), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VBMI2) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_VBMI2_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FVM) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_16) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPSHRDD ZYDIS_NOTMIN(5) ZYDIS_NOTMIN(5) ZYDIS_NOTMIN(0x1A3), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VBMI2) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_VBMI2_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPSHRDD ZYDIS_NOTMIN(5) ZYDIS_NOTMIN(5) ZYDIS_NOTMIN(0x1A8), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VBMI2) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_VBMI2_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPSHRDD ZYDIS_NOTMIN(5) ZYDIS_NOTMIN(5) ZYDIS_NOTMIN(0x1AD), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VBMI2) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_VBMI2_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPSHRDD ZYDIS_NOTMIN(5) ZYDIS_NOTMIN(5) ZYDIS_NOTMIN(0x1B2), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VBMI2) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_VBMI2_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_32) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPSHRDD ZYDIS_NOTMIN(5) ZYDIS_NOTMIN(5) ZYDIS_NOTMIN(0x1B7), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VBMI2) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_VBMI2_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_32) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPSHRDD ZYDIS_NOTMIN(5) ZYDIS_NOTMIN(5) ZYDIS_NOTMIN(0x1BC), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VBMI2) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_VBMI2_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_32) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPSHRDQ ZYDIS_NOTMIN(5) ZYDIS_NOTMIN(5) ZYDIS_NOTMIN(0x1C1), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VBMI2) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_VBMI2_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPSHRDQ ZYDIS_NOTMIN(5) ZYDIS_NOTMIN(5) ZYDIS_NOTMIN(0x1C6), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VBMI2) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_VBMI2_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPSHRDQ ZYDIS_NOTMIN(5) ZYDIS_NOTMIN(5) ZYDIS_NOTMIN(0x1CB), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VBMI2) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_VBMI2_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPSHRDQ ZYDIS_NOTMIN(5) ZYDIS_NOTMIN(5) ZYDIS_NOTMIN(0x1D0), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VBMI2) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_VBMI2_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_64) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPSHRDQ ZYDIS_NOTMIN(5) ZYDIS_NOTMIN(5) ZYDIS_NOTMIN(0x1D5), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VBMI2) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_VBMI2_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_64) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPSHRDQ ZYDIS_NOTMIN(5) ZYDIS_NOTMIN(5) ZYDIS_NOTMIN(0x1DA), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VBMI2) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_VBMI2_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_64) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPSHRDVD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x48C), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VBMI2) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_VBMI2_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPSHRDVD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x491), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VBMI2) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_VBMI2_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPSHRDVD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x496), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VBMI2) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_VBMI2_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPSHRDVD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x49B), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VBMI2) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_VBMI2_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_32) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPSHRDVD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x4A0), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VBMI2) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_VBMI2_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_32) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPSHRDVD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x4A5), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VBMI2) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_VBMI2_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_32) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPSHRDVQ ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x4AA), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VBMI2) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_VBMI2_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPSHRDVQ ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x4AF), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VBMI2) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_VBMI2_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPSHRDVQ ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x4B4), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VBMI2) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_VBMI2_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPSHRDVQ ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x4B9), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VBMI2) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_VBMI2_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_64) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPSHRDVQ ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x4BE), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VBMI2) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_VBMI2_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_64) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPSHRDVQ ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x4C3), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VBMI2) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_VBMI2_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_64) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPSHRDVW ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xB68), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VBMI2) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_VBMI2_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPSHRDVW ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xB6C), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VBMI2) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_VBMI2_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPSHRDVW ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xB70), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VBMI2) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_VBMI2_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPSHRDVW ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xB74), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VBMI2) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_VBMI2_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FVM) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_16) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPSHRDVW ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xB78), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VBMI2) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_VBMI2_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FVM) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_16) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPSHRDVW ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xB7C), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VBMI2) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_VBMI2_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FVM) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_16) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPSHRDW ZYDIS_NOTMIN(5) ZYDIS_NOTMIN(5) ZYDIS_NOTMIN(0x46E), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VBMI2) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_VBMI2_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPSHRDW ZYDIS_NOTMIN(5) ZYDIS_NOTMIN(5) ZYDIS_NOTMIN(0x473), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VBMI2) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_VBMI2_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPSHRDW ZYDIS_NOTMIN(5) ZYDIS_NOTMIN(5) ZYDIS_NOTMIN(0x478), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VBMI2) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_VBMI2_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPSHRDW ZYDIS_NOTMIN(5) ZYDIS_NOTMIN(5) ZYDIS_NOTMIN(0x47D), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VBMI2) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_VBMI2_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FVM) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_16) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPSHRDW ZYDIS_NOTMIN(5) ZYDIS_NOTMIN(5) ZYDIS_NOTMIN(0x482), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VBMI2) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_VBMI2_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FVM) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_16) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPSHRDW ZYDIS_NOTMIN(5) ZYDIS_NOTMIN(5) ZYDIS_NOTMIN(0x487), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_VBMI2) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_VBMI2_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FVM) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_16) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPSHUFB ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x360), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512BW_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4NF), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPSHUFB ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x365), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512BW_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4NF), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPSHUFB ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x36A), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512BW_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4NF), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPSHUFB ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x36F), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512BW_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4NF), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FVM) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_8) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPSHUFB ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x374), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512BW_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4NF), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FVM) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_8) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPSHUFB ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x379), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512BW_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4NF), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FVM) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_8) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPSHUFBITQMB ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xBD8), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_BITALG_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_MASK, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_ZEROING) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPSHUFBITQMB ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xBDC), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_BITALG_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_MASK, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_ZEROING) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPSHUFBITQMB ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xBE0), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512_BITALG) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_BITALG_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_MASK, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_ZEROING) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPSHUFBITQMB ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xBE4), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_BITALG_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_MASK, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FVM) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_8) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_ZEROING) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPSHUFBITQMB ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xBE8), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_BITALG_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_MASK, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FVM) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_8) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_ZEROING) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPSHUFBITQMB ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xBEC), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512_BITALG) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_BITALG_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_MASK, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FVM) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_8) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_ZEROING) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPSHUFD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xBF0), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4NF), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPSHUFD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xBF4), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4NF), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPSHUFD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xBF8), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4NF), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPSHUFD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xBFC), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4NF), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_32) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPSHUFD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xC00), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4NF), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_32) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPSHUFD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xC04), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4NF), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_32) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPSHUFHW ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xC08), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512BW_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4NF), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPSHUFHW ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xC0C), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512BW_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4NF), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPSHUFHW ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xC10), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512BW_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4NF), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPSHUFHW ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xC14), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512BW_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4NF), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FVM) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_16) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPSHUFHW ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xC18), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512BW_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4NF), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FVM) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_16) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPSHUFHW ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xC1C), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512BW_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4NF), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FVM) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_16) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPSHUFLW ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xC08), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512BW_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4NF), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPSHUFLW ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xC0C), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512BW_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4NF), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPSHUFLW ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xC10), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512BW_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4NF), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPSHUFLW ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xC14), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512BW_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4NF), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FVM) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_16) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPSHUFLW ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xC18), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512BW_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4NF), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FVM) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_16) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPSHUFLW ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xC1C), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512BW_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4NF), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FVM) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_16) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPSLLD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xBA8), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), 0, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPSLLD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xBAC), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), 0, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPSLLD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xBB0), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), 0, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPSLLD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xBB4), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), 0, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_32) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPSLLD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xBB8), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), 0, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_32) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPSLLD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xBBC), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), 0, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_32) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPSLLD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x1A3), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4NF), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPSLLD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x324), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4NF), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPSLLD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x329), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4NF), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPSLLD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xC20), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4NF), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_M128) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_32) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPSLLD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x32E), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4NF), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_M128) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_32) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPSLLD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x333), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4NF), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_M128) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_32) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPSLLDQ ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1A79), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512BW_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4NF), 0, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_FORBIDDEN, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPSLLDQ ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1A7C), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512BW_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4NF), 0, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_FORBIDDEN, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPSLLDQ ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1A7F), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512BW_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4NF), 0, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_FORBIDDEN, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPSLLDQ ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1A82), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512BW_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4NF), 0, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FVM) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_8) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_FORBIDDEN, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPSLLDQ ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1A85), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512BW_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4NF), 0, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FVM) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_8) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_FORBIDDEN, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPSLLDQ ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1A88), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512BW_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4NF), 0, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FVM) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_8) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_FORBIDDEN, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPSLLQ ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xBC0), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), 0, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPSLLQ ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xBC4), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), 0, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPSLLQ ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xBC8), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), 0, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPSLLQ ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xBCC), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), 0, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_64) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPSLLQ ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xBD0), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), 0, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_64) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPSLLQ ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xBD4), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), 0, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_64) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPSLLQ ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x1C1), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4NF), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPSLLQ ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x342), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4NF), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPSLLQ ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x347), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4NF), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPSLLQ ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xC24), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4NF), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_M128) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_64) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPSLLQ ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x34C), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4NF), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_M128) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_64) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPSLLQ ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x351), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4NF), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_M128) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_64) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPSLLVD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x1A3), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPSLLVD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x1A8), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPSLLVD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x1AD), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPSLLVD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x1B2), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_32) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPSLLVD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x1B7), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_32) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPSLLVD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x1BC), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_32) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPSLLVQ ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x1C1), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPSLLVQ ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x1C6), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPSLLVQ ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x1CB), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPSLLVQ ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x1D0), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_64) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPSLLVQ ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x1D5), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_64) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPSLLVQ ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x1DA), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_64) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPSLLVW ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x46E), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512BW_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPSLLVW ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x473), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512BW_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPSLLVW ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x478), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512BW_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPSLLVW ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x47D), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512BW_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FVM) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_16) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPSLLVW ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x482), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512BW_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FVM) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_16) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPSLLVW ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x487), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512BW_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FVM) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_16) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPSLLW ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xC28), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512BW_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), 0, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPSLLW ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xC2C), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512BW_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), 0, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPSLLW ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xC30), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512BW_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), 0, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPSLLW ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xC34), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512BW_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), 0, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FVM) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_16) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPSLLW ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xC38), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512BW_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), 0, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FVM) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_16) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPSLLW ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xC3C), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512BW_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), 0, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FVM) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_16) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPSLLW ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x46E), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512BW_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4NF), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPSLLW ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xC40), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512BW_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4NF), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPSLLW ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xC44), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512BW_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4NF), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPSLLW ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x47D), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512BW_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4NF), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_M128) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_16) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPSLLW ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xC48), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512BW_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4NF), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_M128) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_16) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPSLLW ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xC4C), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512BW_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4NF), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_M128) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_16) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPSRAD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xC50), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), 0, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPSRAD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xC54), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), 0, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPSRAD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xC58), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), 0, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPSRAD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xC5C), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), 0, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_32) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPSRAD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xC60), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), 0, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_32) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPSRAD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xC64), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), 0, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_32) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPSRAD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xC68), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4NF), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPSRAD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xC6C), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4NF), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPSRAD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xC70), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4NF), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPSRAD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xC74), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4NF), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_M128) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_32) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPSRAD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xC78), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4NF), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_M128) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_32) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPSRAD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xC7C), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4NF), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_M128) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_32) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPSRAQ ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xBC0), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), 0, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPSRAQ ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xBC4), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), 0, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPSRAQ ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xBC8), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), 0, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPSRAQ ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xBCC), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), 0, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_64) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPSRAQ ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xBD0), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), 0, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_64) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPSRAQ ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xBD4), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), 0, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_64) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPSRAQ ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x1C1), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4NF), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPSRAQ ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x342), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4NF), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPSRAQ ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x347), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4NF), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPSRAQ ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xC24), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4NF), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_M128) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_64) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPSRAQ ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x34C), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4NF), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_M128) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_64) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPSRAQ ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x351), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4NF), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_M128) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_64) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPSRAVD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xC68), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPSRAVD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xC80), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPSRAVD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xC84), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPSRAVD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xC88), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_32) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPSRAVD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xC8C), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_32) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPSRAVD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xC90), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_32) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPSRAVQ ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x1C1), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPSRAVQ ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x1C6), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPSRAVQ ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x1CB), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPSRAVQ ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x1D0), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_64) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPSRAVQ ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x1D5), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_64) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPSRAVQ ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x1DA), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_64) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPSRAVW ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x46E), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512BW_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPSRAVW ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x473), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512BW_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPSRAVW ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x478), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512BW_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPSRAVW ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x47D), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512BW_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FVM) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_16) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPSRAVW ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x482), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512BW_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FVM) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_16) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPSRAVW ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x487), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512BW_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FVM) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_16) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPSRAW ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xC94), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512BW_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), 0, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPSRAW ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xC98), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512BW_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), 0, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPSRAW ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xC9C), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512BW_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), 0, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPSRAW ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xCA0), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512BW_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), 0, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FVM) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_16) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPSRAW ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xCA4), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512BW_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), 0, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FVM) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_16) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPSRAW ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xCA8), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512BW_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), 0, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FVM) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_16) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPSRAW ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xCAC), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512BW_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4NF), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPSRAW ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xCB0), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512BW_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4NF), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPSRAW ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xCB4), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512BW_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4NF), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPSRAW ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xCB8), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512BW_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4NF), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_M128) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_16) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPSRAW ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xCBC), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512BW_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4NF), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_M128) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_16) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPSRAW ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xCC0), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512BW_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4NF), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_M128) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_16) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPSRLD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xBA8), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), 0, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPSRLD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xBAC), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), 0, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPSRLD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xBB0), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), 0, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPSRLD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xBB4), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), 0, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_32) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPSRLD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xBB8), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), 0, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_32) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPSRLD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xBBC), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), 0, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_32) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPSRLD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x1A3), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4NF), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPSRLD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x324), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4NF), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPSRLD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x329), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4NF), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPSRLD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xC20), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4NF), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_M128) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_32) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPSRLD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x32E), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4NF), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_M128) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_32) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPSRLD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x333), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4NF), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_M128) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_32) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPSRLDQ ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1A79), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512BW_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4NF), 0, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_FORBIDDEN, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPSRLDQ ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1A7C), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512BW_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4NF), 0, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_FORBIDDEN, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPSRLDQ ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1A7F), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512BW_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4NF), 0, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_FORBIDDEN, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPSRLDQ ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1A82), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512BW_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4NF), 0, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FVM) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_8) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_FORBIDDEN, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPSRLDQ ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1A85), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512BW_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4NF), 0, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FVM) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_8) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_FORBIDDEN, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPSRLDQ ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1A88), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512BW_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4NF), 0, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FVM) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_8) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_FORBIDDEN, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPSRLQ ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xBC0), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), 0, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPSRLQ ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xBC4), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), 0, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPSRLQ ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xBC8), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), 0, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPSRLQ ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xBCC), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), 0, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_64) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPSRLQ ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xBD0), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), 0, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_64) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPSRLQ ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xBD4), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), 0, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_64) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPSRLQ ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x1C1), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4NF), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPSRLQ ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x342), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4NF), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPSRLQ ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x347), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4NF), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPSRLQ ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xC24), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4NF), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_M128) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_64) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPSRLQ ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x34C), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4NF), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_M128) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_64) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPSRLQ ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x351), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4NF), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_M128) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_64) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPSRLVD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x1A3), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPSRLVD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x1A8), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPSRLVD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x1AD), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPSRLVD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x1B2), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_32) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPSRLVD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x1B7), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_32) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPSRLVD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x1BC), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_32) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPSRLVQ ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x1C1), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPSRLVQ ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x1C6), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPSRLVQ ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x1CB), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPSRLVQ ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x1D0), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_64) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPSRLVQ ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x1D5), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_64) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPSRLVQ ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x1DA), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_64) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPSRLVW ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x46E), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512BW_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPSRLVW ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x473), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512BW_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPSRLVW ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x478), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512BW_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPSRLVW ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x47D), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512BW_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FVM) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_16) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPSRLVW ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x482), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512BW_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FVM) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_16) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPSRLVW ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x487), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512BW_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FVM) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_16) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPSRLW ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xC28), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512BW_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), 0, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPSRLW ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xC2C), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512BW_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), 0, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPSRLW ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xC30), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512BW_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), 0, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPSRLW ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xC34), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512BW_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), 0, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FVM) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_16) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPSRLW ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xC38), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512BW_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), 0, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FVM) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_16) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPSRLW ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xC3C), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512BW_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), 0, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FVM) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_16) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPSRLW ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x46E), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512BW_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4NF), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPSRLW ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xC40), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512BW_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4NF), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPSRLW ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xC44), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512BW_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4NF), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPSRLW ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x47D), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512BW_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4NF), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_M128) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_16) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPSRLW ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xC48), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512BW_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4NF), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_M128) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_16) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPSRLW ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xC4C), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512BW_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4NF), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_M128) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_16) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPSUBB ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xAB8), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512BW_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPSUBB ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xABC), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512BW_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPSUBB ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xAC0), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512BW_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPSUBB ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xAC4), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512BW_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FVM) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_8) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPSUBB ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xAC8), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512BW_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FVM) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_8) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPSUBB ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xACC), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512BW_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FVM) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_8) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPSUBD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xAD0), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPSUBD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xAD4), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPSUBD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xAD8), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPSUBD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xADC), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_32) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPSUBD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xAE0), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_32) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPSUBD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xAE4), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_32) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPSUBQ ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xAE8), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPSUBQ ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xAEC), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPSUBQ ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xAF0), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPSUBQ ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xAF4), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_64) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPSUBQ ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xAF8), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_64) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPSUBQ ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xAFC), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_64) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPSUBSB ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xAB8), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512BW_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPSUBSB ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xABC), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512BW_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPSUBSB ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xAC0), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512BW_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPSUBSB ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xAC4), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512BW_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FVM) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_8) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPSUBSB ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xAC8), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512BW_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FVM) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_8) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPSUBSB ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xACC), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512BW_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FVM) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_8) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPSUBSW ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xB00), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512BW_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPSUBSW ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xB04), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512BW_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPSUBSW ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xB08), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512BW_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPSUBSW ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xB0C), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512BW_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FVM) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_16) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPSUBSW ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xB10), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512BW_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FVM) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_16) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPSUBSW ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xB14), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512BW_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FVM) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_16) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPSUBUSB ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x360), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512BW_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPSUBUSB ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x365), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512BW_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPSUBUSB ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x36A), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512BW_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPSUBUSB ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x36F), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512BW_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FVM) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_8) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPSUBUSB ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x374), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512BW_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FVM) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_8) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPSUBUSB ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x379), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512BW_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FVM) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_8) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPSUBUSW ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x46E), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512BW_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPSUBUSW ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x473), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512BW_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPSUBUSW ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x478), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512BW_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPSUBUSW ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x47D), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512BW_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FVM) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_16) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPSUBUSW ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x482), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512BW_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FVM) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_16) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPSUBUSW ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x487), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512BW_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FVM) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_16) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPSUBW ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x46E), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512BW_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPSUBW ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x473), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512BW_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPSUBW ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x478), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512BW_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPSUBW ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x47D), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512BW_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FVM) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_16) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPSUBW ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x482), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512BW_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FVM) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_16) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPSUBW ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x487), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512BW_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FVM) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_16) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPTERNLOGD ZYDIS_NOTMIN(5) ZYDIS_NOTMIN(5) ZYDIS_NOTMIN(0x48C), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_LOGICAL) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPTERNLOGD ZYDIS_NOTMIN(5) ZYDIS_NOTMIN(5) ZYDIS_NOTMIN(0x491), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_LOGICAL) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPTERNLOGD ZYDIS_NOTMIN(5) ZYDIS_NOTMIN(5) ZYDIS_NOTMIN(0x496), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_LOGICAL) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPTERNLOGD ZYDIS_NOTMIN(5) ZYDIS_NOTMIN(5) ZYDIS_NOTMIN(0x49B), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_LOGICAL) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_32) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPTERNLOGD ZYDIS_NOTMIN(5) ZYDIS_NOTMIN(5) ZYDIS_NOTMIN(0x4A0), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_LOGICAL) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_32) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPTERNLOGD ZYDIS_NOTMIN(5) ZYDIS_NOTMIN(5) ZYDIS_NOTMIN(0x4A5), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_LOGICAL) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_32) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPTERNLOGQ ZYDIS_NOTMIN(5) ZYDIS_NOTMIN(5) ZYDIS_NOTMIN(0x4AA), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_LOGICAL) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPTERNLOGQ ZYDIS_NOTMIN(5) ZYDIS_NOTMIN(5) ZYDIS_NOTMIN(0x4AF), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_LOGICAL) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPTERNLOGQ ZYDIS_NOTMIN(5) ZYDIS_NOTMIN(5) ZYDIS_NOTMIN(0x4B4), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_LOGICAL) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPTERNLOGQ ZYDIS_NOTMIN(5) ZYDIS_NOTMIN(5) ZYDIS_NOTMIN(0x4B9), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_LOGICAL) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_64) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPTERNLOGQ ZYDIS_NOTMIN(5) ZYDIS_NOTMIN(5) ZYDIS_NOTMIN(0x4BE), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_LOGICAL) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_64) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPTERNLOGQ ZYDIS_NOTMIN(5) ZYDIS_NOTMIN(5) ZYDIS_NOTMIN(0x4C3), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_LOGICAL) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_64) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPTESTMB ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x3D8), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_LOGICAL) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512BW_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_MASK, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_ZEROING) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPTESTMB ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x3DD), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_LOGICAL) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512BW_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_MASK, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_ZEROING) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPTESTMB ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x3E2), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_LOGICAL) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512BW_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_MASK, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_ZEROING) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPTESTMB ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x3E7), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_LOGICAL) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512BW_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_MASK, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FVM) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_8) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_ZEROING) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPTESTMB ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x3EC), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_LOGICAL) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512BW_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_MASK, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FVM) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_8) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_ZEROING) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPTESTMB ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x3F1), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_LOGICAL) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512BW_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_MASK, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FVM) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_8) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_ZEROING) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPTESTMD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x3F6), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_LOGICAL) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_MASK, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_ZEROING) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPTESTMD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x3FB), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_LOGICAL) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_MASK, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_ZEROING) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPTESTMD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x400), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_LOGICAL) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_MASK, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_ZEROING) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPTESTMD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x405), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_LOGICAL) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_MASK, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_32) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_ZEROING) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPTESTMD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x40A), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_LOGICAL) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_MASK, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_32) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_ZEROING) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPTESTMD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x40F), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_LOGICAL) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_MASK, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_32) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_ZEROING) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPTESTMQ ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x414), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_LOGICAL) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_MASK, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_ZEROING) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPTESTMQ ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x419), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_LOGICAL) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_MASK, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_ZEROING) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPTESTMQ ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x41E), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_LOGICAL) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_MASK, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_ZEROING) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPTESTMQ ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x423), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_LOGICAL) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_MASK, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_64) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_ZEROING) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPTESTMQ ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x428), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_LOGICAL) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_MASK, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_64) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_ZEROING) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPTESTMQ ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x42D), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_LOGICAL) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_MASK, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_64) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_ZEROING) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPTESTMW ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x432), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_LOGICAL) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512BW_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_MASK, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_ZEROING) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPTESTMW ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x437), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_LOGICAL) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512BW_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_MASK, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_ZEROING) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPTESTMW ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x43C), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_LOGICAL) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512BW_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_MASK, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_ZEROING) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPTESTMW ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x441), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_LOGICAL) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512BW_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_MASK, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FVM) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_16) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_ZEROING) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPTESTMW ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x446), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_LOGICAL) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512BW_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_MASK, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FVM) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_16) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_ZEROING) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPTESTMW ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x44B), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_LOGICAL) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512BW_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_MASK, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FVM) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_16) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_ZEROING) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPTESTNMB ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x3D8), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_LOGICAL) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512BW_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_MASK, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_ZEROING) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPTESTNMB ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x3DD), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_LOGICAL) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512BW_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_MASK, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_ZEROING) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPTESTNMB ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x3E2), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_LOGICAL) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512BW_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_MASK, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_ZEROING) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPTESTNMB ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x3E7), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_LOGICAL) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512BW_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_MASK, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FVM) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_8) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_ZEROING) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPTESTNMB ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x3EC), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_LOGICAL) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512BW_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_MASK, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FVM) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_8) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_ZEROING) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPTESTNMB ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x3F1), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_LOGICAL) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512BW_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_MASK, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FVM) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_8) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_ZEROING) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPTESTNMD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x3F6), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_LOGICAL) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_MASK, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_ZEROING) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPTESTNMD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x3FB), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_LOGICAL) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_MASK, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_ZEROING) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPTESTNMD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x400), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_LOGICAL) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_MASK, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_ZEROING) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPTESTNMD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x405), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_LOGICAL) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_MASK, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_32) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_ZEROING) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPTESTNMD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x40A), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_LOGICAL) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_MASK, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_32) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_ZEROING) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPTESTNMD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x40F), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_LOGICAL) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_MASK, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_32) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_ZEROING) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPTESTNMQ ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x414), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_LOGICAL) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_MASK, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_ZEROING) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPTESTNMQ ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x419), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_LOGICAL) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_MASK, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_ZEROING) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPTESTNMQ ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x41E), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_LOGICAL) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_MASK, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_ZEROING) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPTESTNMQ ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x423), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_LOGICAL) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_MASK, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_64) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_ZEROING) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPTESTNMQ ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x428), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_LOGICAL) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_MASK, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_64) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_ZEROING) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPTESTNMQ ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x42D), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_LOGICAL) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_MASK, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_64) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_ZEROING) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPTESTNMW ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x432), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_LOGICAL) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512BW_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_MASK, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_ZEROING) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPTESTNMW ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x437), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_LOGICAL) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512BW_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_MASK, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_ZEROING) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPTESTNMW ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x43C), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_LOGICAL) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512BW_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_MASK, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_ZEROING) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPTESTNMW ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x441), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_LOGICAL) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512BW_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_MASK, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FVM) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_16) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_ZEROING) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPTESTNMW ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x446), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_LOGICAL) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512BW_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_MASK, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FVM) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_16) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_ZEROING) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPTESTNMW ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x44B), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_LOGICAL) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512BW_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_MASK, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FVM) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_16) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_ZEROING) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPUNPCKHBW ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x360), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512BW_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4NF), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPUNPCKHBW ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x365), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512BW_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4NF), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPUNPCKHBW ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x36A), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512BW_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4NF), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPUNPCKHBW ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x36F), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512BW_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4NF), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FVM) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_8) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPUNPCKHBW ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x374), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512BW_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4NF), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FVM) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_8) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPUNPCKHBW ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x379), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512BW_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4NF), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FVM) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_8) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPUNPCKHDQ ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x1A3), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4NF), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPUNPCKHDQ ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x1A8), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4NF), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPUNPCKHDQ ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x1AD), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4NF), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPUNPCKHDQ ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x1B2), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4NF), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_32) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPUNPCKHDQ ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x1B7), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4NF), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_32) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPUNPCKHDQ ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x1BC), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4NF), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_32) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPUNPCKHQDQ ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x1C1), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4NF), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPUNPCKHQDQ ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x1C6), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4NF), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPUNPCKHQDQ ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x1CB), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4NF), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPUNPCKHQDQ ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x1D0), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4NF), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_64) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPUNPCKHQDQ ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x1D5), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4NF), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_64) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPUNPCKHQDQ ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x1DA), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4NF), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_64) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPUNPCKHWD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x46E), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512BW_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4NF), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPUNPCKHWD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x473), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512BW_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4NF), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPUNPCKHWD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x478), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512BW_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4NF), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPUNPCKHWD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x47D), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512BW_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4NF), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FVM) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_16) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPUNPCKHWD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x482), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512BW_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4NF), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FVM) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_16) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPUNPCKHWD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x487), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512BW_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4NF), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FVM) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_16) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPUNPCKLBW ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x360), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512BW_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4NF), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPUNPCKLBW ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x365), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512BW_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4NF), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPUNPCKLBW ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x36A), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512BW_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4NF), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPUNPCKLBW ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x36F), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512BW_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4NF), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FVM) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_8) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPUNPCKLBW ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x374), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512BW_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4NF), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FVM) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_8) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPUNPCKLBW ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x379), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512BW_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4NF), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FVM) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_8) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPUNPCKLDQ ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x1A3), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4NF), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPUNPCKLDQ ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x1A8), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4NF), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPUNPCKLDQ ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x1AD), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4NF), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPUNPCKLDQ ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x1B2), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4NF), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_32) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPUNPCKLDQ ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x1B7), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4NF), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_32) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPUNPCKLDQ ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x1BC), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4NF), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_32) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPUNPCKLQDQ ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x1C1), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4NF), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPUNPCKLQDQ ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x1C6), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4NF), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPUNPCKLQDQ ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x1CB), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4NF), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPUNPCKLQDQ ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x1D0), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4NF), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_64) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPUNPCKLQDQ ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x1D5), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4NF), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_64) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPUNPCKLQDQ ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x1DA), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4NF), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_64) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPUNPCKLWD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x46E), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512BW_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4NF), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPUNPCKLWD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x473), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512BW_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4NF), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPUNPCKLWD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x478), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512BW_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4NF), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPUNPCKLWD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x47D), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512BW_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4NF), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FVM) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_16) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPUNPCKLWD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x482), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512BW_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4NF), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FVM) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_16) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPUNPCKLWD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x487), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512BW_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4NF), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FVM) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_16) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPXORD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x1A3), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_LOGICAL) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPXORD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x1A8), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_LOGICAL) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPXORD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x1AD), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_LOGICAL) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPXORD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x1B2), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_LOGICAL) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_32) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPXORD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x1B7), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_LOGICAL) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_32) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPXORD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x1BC), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_LOGICAL) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_32) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPXORQ ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x1C1), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_LOGICAL) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPXORQ ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x1C6), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_LOGICAL) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPXORQ ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x1CB), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_LOGICAL) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPXORQ ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x1D0), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_LOGICAL) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_64) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPXORQ ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x1D5), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_LOGICAL) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_64) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPXORQ ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x1DA), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_LOGICAL) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_64) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VRANGEPD ZYDIS_NOTMIN(5) ZYDIS_NOTMIN(5) ZYDIS_NOTMIN(0x4C8), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512DQ_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_FIXED_512) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_SAE), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VRANGEPD ZYDIS_NOTMIN(5) ZYDIS_NOTMIN(5) ZYDIS_NOTMIN(0x2AC), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512DQ_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VRANGEPD ZYDIS_NOTMIN(5) ZYDIS_NOTMIN(5) ZYDIS_NOTMIN(0x4CD), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512DQ_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VRANGEPD ZYDIS_NOTMIN(5) ZYDIS_NOTMIN(5) ZYDIS_NOTMIN(0x4C8), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512DQ_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VRANGEPD ZYDIS_NOTMIN(5) ZYDIS_NOTMIN(5) ZYDIS_NOTMIN(0x4D2), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512DQ_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_64) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VRANGEPD ZYDIS_NOTMIN(5) ZYDIS_NOTMIN(5) ZYDIS_NOTMIN(0x4D7), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512DQ_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_64) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VRANGEPD ZYDIS_NOTMIN(5) ZYDIS_NOTMIN(5) ZYDIS_NOTMIN(0x4DC), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512DQ_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_64) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VRANGEPS ZYDIS_NOTMIN(5) ZYDIS_NOTMIN(5) ZYDIS_NOTMIN(0x4E1), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512DQ_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_FIXED_512) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_SAE), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VRANGEPS ZYDIS_NOTMIN(5) ZYDIS_NOTMIN(5) ZYDIS_NOTMIN(0x2C0), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512DQ_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VRANGEPS ZYDIS_NOTMIN(5) ZYDIS_NOTMIN(5) ZYDIS_NOTMIN(0x4E6), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512DQ_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VRANGEPS ZYDIS_NOTMIN(5) ZYDIS_NOTMIN(5) ZYDIS_NOTMIN(0x4E1), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512DQ_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VRANGEPS ZYDIS_NOTMIN(5) ZYDIS_NOTMIN(5) ZYDIS_NOTMIN(0x4EB), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512DQ_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_32) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VRANGEPS ZYDIS_NOTMIN(5) ZYDIS_NOTMIN(5) ZYDIS_NOTMIN(0x4F0), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512DQ_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_32) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VRANGEPS ZYDIS_NOTMIN(5) ZYDIS_NOTMIN(5) ZYDIS_NOTMIN(0x4F5), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512DQ_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_32) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VRANGESD ZYDIS_NOTMIN(5) ZYDIS_NOTMIN(5) ZYDIS_NOTMIN(0x2AC), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512DQ_SCALAR) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E3), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_FIXED_128) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VRANGESD ZYDIS_NOTMIN(5) ZYDIS_NOTMIN(5) ZYDIS_NOTMIN(0x2AC), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512DQ_SCALAR) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E3), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_FIXED_128) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_SAE), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VRANGESD ZYDIS_NOTMIN(5) ZYDIS_NOTMIN(5) ZYDIS_NOTMIN(0x2B1), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512DQ_SCALAR) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E3), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_FIXED_128) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_T1S) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_64) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VRANGESS ZYDIS_NOTMIN(5) ZYDIS_NOTMIN(5) ZYDIS_NOTMIN(0x2C0), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512DQ_SCALAR) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E3), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_FIXED_128) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VRANGESS ZYDIS_NOTMIN(5) ZYDIS_NOTMIN(5) ZYDIS_NOTMIN(0x2C0), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512DQ_SCALAR) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E3), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_FIXED_128) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_SAE), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VRANGESS ZYDIS_NOTMIN(5) ZYDIS_NOTMIN(5) ZYDIS_NOTMIN(0x2C5), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512DQ_SCALAR) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E3), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_FIXED_128) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_T1S) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_32) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VRCP14PD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0xA04), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VRCP14PD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0xA08), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VRCP14PD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0xA00), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VRCP14PD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0xA0C), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_64) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VRCP14PD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0xA10), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_64) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VRCP14PD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0xA14), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_64) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VRCP14PS ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0xA34), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VRCP14PS ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0xA38), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VRCP14PS ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0xA30), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VRCP14PS ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0xA3C), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_32) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VRCP14PS ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0xA40), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_32) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VRCP14PS ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0xA44), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_32) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VRCP14SD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x2AC), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_SCALAR) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E10), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_FIXED_128) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VRCP14SD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x2B1), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_SCALAR) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E10), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_FIXED_128) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_T1S) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_64) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VRCP14SS ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x2C0), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_SCALAR) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E10), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_FIXED_128) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VRCP14SS ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x2C5), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_SCALAR) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E10), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_FIXED_128) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_T1S) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_32) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VRCP28PD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0xA00), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512ER_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_FIXED_512) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_SAE), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VRCP28PD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0xA00), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512ER_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VRCP28PD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0xA14), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512ER_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_64) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VRCP28PS ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0xA30), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512ER_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_FIXED_512) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_SAE), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VRCP28PS ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0xA30), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512ER_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VRCP28PS ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0xA44), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512ER_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_32) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VRCP28SD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x2AC), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512ER_SCALAR) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E3), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_FIXED_128) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VRCP28SD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x2AC), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512ER_SCALAR) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E3), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_FIXED_128) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_SAE), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VRCP28SD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x2B1), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512ER_SCALAR) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E3), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_FIXED_128) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_T1S) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_64) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VRCP28SS ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x2C0), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512ER_SCALAR) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E3), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_FIXED_128) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VRCP28SS ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x2C0), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512ER_SCALAR) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E3), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_FIXED_128) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_SAE), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VRCP28SS ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x2C5), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512ER_SCALAR) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E3), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_FIXED_128) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_T1S) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_32) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VRCPPH ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0xA1C), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_FP16) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_FP16_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VRCPPH ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0xA20), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_FP16) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_FP16_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VRCPPH ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0xA18), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_FP16) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_FP16_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VRCPPH ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0xA24), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_FP16) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_FP16_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_16) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VRCPPH ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0xA28), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_FP16) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_FP16_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_16) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VRCPPH ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0xA2C), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_FP16) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_FP16_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_16) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VRCPSH ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x2B6), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_FP16) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_FP16_SCALAR) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E10), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_FIXED_128) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VRCPSH ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x2BB), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_FP16) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_FP16_SCALAR) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E10), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_FIXED_128) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_T1S) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_16) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VREDUCEPD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xA00), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512DQ_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_FIXED_512) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_SAE), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VREDUCEPD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xA04), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512DQ_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VREDUCEPD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xA08), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512DQ_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VREDUCEPD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xA00), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512DQ_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VREDUCEPD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xA0C), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512DQ_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_64) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VREDUCEPD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xA10), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512DQ_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_64) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VREDUCEPD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xA14), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512DQ_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_64) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VREDUCEPH ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xA18), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_FP16) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_FP16_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_FIXED_512) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_SAE), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VREDUCEPH ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xA1C), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_FP16) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_FP16_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VREDUCEPH ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xA20), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_FP16) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_FP16_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VREDUCEPH ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xA18), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_FP16) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_FP16_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VREDUCEPH ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xA24), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_FP16) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_FP16_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_16) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VREDUCEPH ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xA28), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_FP16) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_FP16_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_16) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VREDUCEPH ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xA2C), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_FP16) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_FP16_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_16) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VREDUCEPS ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xA30), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512DQ_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_FIXED_512) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_SAE), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VREDUCEPS ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xA34), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512DQ_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VREDUCEPS ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xA38), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512DQ_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VREDUCEPS ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xA30), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512DQ_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VREDUCEPS ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xA3C), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512DQ_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_32) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VREDUCEPS ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xA40), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512DQ_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_32) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VREDUCEPS ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xA44), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512DQ_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_32) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VREDUCESD ZYDIS_NOTMIN(5) ZYDIS_NOTMIN(5) ZYDIS_NOTMIN(0x2AC), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512DQ_SCALAR) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E3), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_FIXED_128) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VREDUCESD ZYDIS_NOTMIN(5) ZYDIS_NOTMIN(5) ZYDIS_NOTMIN(0x2AC), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512DQ_SCALAR) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E3), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_FIXED_128) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_SAE), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VREDUCESD ZYDIS_NOTMIN(5) ZYDIS_NOTMIN(5) ZYDIS_NOTMIN(0x2B1), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512DQ_SCALAR) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E3), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_FIXED_128) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_T1S) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_64) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VREDUCESH ZYDIS_NOTMIN(5) ZYDIS_NOTMIN(5) ZYDIS_NOTMIN(0x2B6), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_FP16) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_FP16_SCALAR) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E3), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_FIXED_128) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VREDUCESH ZYDIS_NOTMIN(5) ZYDIS_NOTMIN(5) ZYDIS_NOTMIN(0x2B6), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_FP16) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_FP16_SCALAR) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E3), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_FIXED_128) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_SAE), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VREDUCESH ZYDIS_NOTMIN(5) ZYDIS_NOTMIN(5) ZYDIS_NOTMIN(0x2BB), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_FP16) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_FP16_SCALAR) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E3), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_FIXED_128) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_T1S) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_16) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VREDUCESS ZYDIS_NOTMIN(5) ZYDIS_NOTMIN(5) ZYDIS_NOTMIN(0x2C0), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512DQ_SCALAR) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E3), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_FIXED_128) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VREDUCESS ZYDIS_NOTMIN(5) ZYDIS_NOTMIN(5) ZYDIS_NOTMIN(0x2C0), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512DQ_SCALAR) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E3), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_FIXED_128) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_SAE), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VREDUCESS ZYDIS_NOTMIN(5) ZYDIS_NOTMIN(5) ZYDIS_NOTMIN(0x2C5), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512DQ_SCALAR) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E3), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_FIXED_128) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_T1S) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_32) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VRNDSCALEPD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xA00), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_FIXED_512) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_SAE), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VRNDSCALEPD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xA04), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VRNDSCALEPD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xA08), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VRNDSCALEPD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xA00), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VRNDSCALEPD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xA0C), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_64) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VRNDSCALEPD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xA10), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_64) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VRNDSCALEPD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xA14), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_64) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VRNDSCALEPH ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xA18), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_FP16) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_FP16_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_FIXED_512) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_SAE), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VRNDSCALEPH ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xA1C), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_FP16) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_FP16_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VRNDSCALEPH ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xA20), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_FP16) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_FP16_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VRNDSCALEPH ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xA18), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_FP16) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_FP16_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VRNDSCALEPH ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xA24), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_FP16) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_FP16_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_16) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VRNDSCALEPH ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xA28), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_FP16) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_FP16_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_16) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VRNDSCALEPH ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xA2C), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_FP16) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_FP16_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_16) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VRNDSCALEPS ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xA30), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_FIXED_512) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_SAE), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VRNDSCALEPS ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xA34), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VRNDSCALEPS ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xA38), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VRNDSCALEPS ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xA30), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VRNDSCALEPS ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xA3C), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_32) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VRNDSCALEPS ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xA40), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_32) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VRNDSCALEPS ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xA44), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_32) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VRNDSCALESD ZYDIS_NOTMIN(5) ZYDIS_NOTMIN(5) ZYDIS_NOTMIN(0x2AC), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_SCALAR) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E3), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_FIXED_128) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VRNDSCALESD ZYDIS_NOTMIN(5) ZYDIS_NOTMIN(5) ZYDIS_NOTMIN(0x2AC), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_SCALAR) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E3), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_FIXED_128) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_SAE), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VRNDSCALESD ZYDIS_NOTMIN(5) ZYDIS_NOTMIN(5) ZYDIS_NOTMIN(0x2B1), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_SCALAR) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E3), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_FIXED_128) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_T1S) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_64) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VRNDSCALESH ZYDIS_NOTMIN(5) ZYDIS_NOTMIN(5) ZYDIS_NOTMIN(0x2B6), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_FP16) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_FP16_SCALAR) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E3), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_FIXED_128) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VRNDSCALESH ZYDIS_NOTMIN(5) ZYDIS_NOTMIN(5) ZYDIS_NOTMIN(0x2B6), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_FP16) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_FP16_SCALAR) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E3), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_FIXED_128) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_SAE), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VRNDSCALESH ZYDIS_NOTMIN(5) ZYDIS_NOTMIN(5) ZYDIS_NOTMIN(0x2BB), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_FP16) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_FP16_SCALAR) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E3), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_FIXED_128) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_T1S) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_16) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VRNDSCALESS ZYDIS_NOTMIN(5) ZYDIS_NOTMIN(5) ZYDIS_NOTMIN(0x2C0), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_SCALAR) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E3), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_FIXED_128) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VRNDSCALESS ZYDIS_NOTMIN(5) ZYDIS_NOTMIN(5) ZYDIS_NOTMIN(0x2C0), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_SCALAR) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E3), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_FIXED_128) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_SAE), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VRNDSCALESS ZYDIS_NOTMIN(5) ZYDIS_NOTMIN(5) ZYDIS_NOTMIN(0x2C5), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_SCALAR) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E3), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_FIXED_128) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_T1S) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_32) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VRSQRT14PD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0xA04), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VRSQRT14PD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0xA08), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VRSQRT14PD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0xA00), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VRSQRT14PD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0xA0C), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_64) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VRSQRT14PD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0xA10), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_64) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VRSQRT14PD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0xA14), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_64) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VRSQRT14PS ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0xA34), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VRSQRT14PS ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0xA38), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VRSQRT14PS ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0xA30), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VRSQRT14PS ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0xA3C), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_32) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VRSQRT14PS ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0xA40), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_32) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VRSQRT14PS ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0xA44), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_32) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VRSQRT14SD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x2AC), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_SCALAR) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E10), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_FIXED_128) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VRSQRT14SD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x2B1), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_SCALAR) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E10), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_FIXED_128) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_T1S) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_64) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VRSQRT14SS ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x2C0), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_SCALAR) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E10), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_FIXED_128) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VRSQRT14SS ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x2C5), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_SCALAR) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E10), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_FIXED_128) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_T1S) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_32) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VRSQRT28PD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0xA00), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512ER_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_FIXED_512) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_SAE), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VRSQRT28PD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0xA00), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512ER_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VRSQRT28PD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0xA14), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512ER_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_64) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VRSQRT28PS ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0xA30), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512ER_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_FIXED_512) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_SAE), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VRSQRT28PS ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0xA30), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512ER_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VRSQRT28PS ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0xA44), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512ER_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_32) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VRSQRT28SD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x2AC), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512ER_SCALAR) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E3), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_FIXED_128) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VRSQRT28SD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x2AC), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512ER_SCALAR) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E3), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_FIXED_128) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_SAE), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VRSQRT28SD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x2B1), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512ER_SCALAR) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E3), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_FIXED_128) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_T1S) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_64) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VRSQRT28SS ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x2C0), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512ER_SCALAR) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E3), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_FIXED_128) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VRSQRT28SS ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x2C0), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512ER_SCALAR) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E3), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_FIXED_128) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_SAE), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VRSQRT28SS ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x2C5), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512ER_SCALAR) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E3), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_FIXED_128) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_T1S) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_32) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VRSQRTPH ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0xA1C), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_FP16) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_FP16_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VRSQRTPH ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0xA20), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_FP16) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_FP16_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VRSQRTPH ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0xA18), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_FP16) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_FP16_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VRSQRTPH ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0xA24), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_FP16) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_FP16_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_16) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VRSQRTPH ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0xA28), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_FP16) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_FP16_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_16) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VRSQRTPH ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0xA2C), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_FP16) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_FP16_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_16) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VRSQRTSH ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x2B6), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_FP16) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_FP16_SCALAR) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E10), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_FIXED_128) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VRSQRTSH ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x2BB), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_FP16) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_FP16_SCALAR) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E10), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_FIXED_128) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_T1S) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_16) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VSCALEFPD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x4C8), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_FIXED_512) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_RC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VSCALEFPD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x2AC), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VSCALEFPD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x4CD), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VSCALEFPD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x4C8), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VSCALEFPD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x4D2), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_64) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VSCALEFPD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x4D7), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_64) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VSCALEFPD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x4DC), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_64) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VSCALEFPH ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x884), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_FP16) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_FP16_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_FIXED_512) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_RC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VSCALEFPH ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x2B6), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_FP16) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_FP16_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VSCALEFPH ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x888), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_FP16) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_FP16_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VSCALEFPH ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x884), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_FP16) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_FP16_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VSCALEFPH ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x88C), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_FP16) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_FP16_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_16) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VSCALEFPH ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x890), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_FP16) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_FP16_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_16) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VSCALEFPH ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x894), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_FP16) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_FP16_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_16) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VSCALEFPS ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x4E1), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_FIXED_512) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_RC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VSCALEFPS ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x2C0), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VSCALEFPS ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x4E6), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VSCALEFPS ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x4E1), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VSCALEFPS ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x4EB), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_32) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VSCALEFPS ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x4F0), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_32) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VSCALEFPS ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x4F5), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_32) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VSCALEFSD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x2AC), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_SCALAR) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E3), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_FIXED_128) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VSCALEFSD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x2AC), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_SCALAR) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E3), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_FIXED_128) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_RC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VSCALEFSD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x2B1), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_SCALAR) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E3), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_FIXED_128) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_T1S) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_64) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VSCALEFSH ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x2B6), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_FP16) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_FP16_SCALAR) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E3), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_FIXED_128) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VSCALEFSH ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x2B6), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_FP16) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_FP16_SCALAR) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E3), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_FIXED_128) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_RC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VSCALEFSH ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x2BB), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_FP16) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_FP16_SCALAR) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E3), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_FIXED_128) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_T1S) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_16) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VSCALEFSS ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x2C0), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_SCALAR) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E3), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_FIXED_128) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VSCALEFSS ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x2C0), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_SCALAR) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E3), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_FIXED_128) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_RC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VSCALEFSS ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x2C5), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_SCALAR) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E3), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_FIXED_128) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_T1S) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_32) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VSCATTERDPD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1A8B), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_SCATTER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E12), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_VSIB | (1 << 3) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_GSCAT) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_64) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_REQUIRED, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VSCATTERDPD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1A8E), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_SCATTER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E12), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_VSIB | (1 << 3) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_GSCAT) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_64) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_REQUIRED, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VSCATTERDPD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1A91), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_SCATTER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E12), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_VSIB | (1 << 3) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_GSCAT) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_64) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_REQUIRED, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VSCATTERDPS ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1A94), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_SCATTER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E12), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_VSIB | (1 << 3) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_GSCAT) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_32) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_REQUIRED, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VSCATTERDPS ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1A97), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_SCATTER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E12), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_VSIB | (1 << 3) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_GSCAT) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_32) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_REQUIRED, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VSCATTERDPS ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1A9A), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_SCATTER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E12), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_VSIB | (1 << 3) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_GSCAT) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_32) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_REQUIRED, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VSCATTERPF0DPD ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1EA1), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_SCATTER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512PF_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E12NP), 0, ZYDIS_MEMOP_TYPE_VSIB | (1 << 3) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_GSCAT) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_64) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_REQUIRED, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VSCATTERPF0DPS ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1EA3), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_SCATTER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512PF_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E12NP), 0, ZYDIS_MEMOP_TYPE_VSIB | (1 << 3) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_GSCAT) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_32) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_REQUIRED, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VSCATTERPF0QPD ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1EA5), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_SCATTER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512PF_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E12NP), 0, ZYDIS_MEMOP_TYPE_VSIB | (1 << 3) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_GSCAT) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_64) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_REQUIRED, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VSCATTERPF0QPS ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1EA3), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_SCATTER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512PF_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E12NP), 0, ZYDIS_MEMOP_TYPE_VSIB | (1 << 3) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_GSCAT) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_32) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_REQUIRED, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VSCATTERPF1DPD ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1EA1), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_SCATTER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512PF_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E12NP), 0, ZYDIS_MEMOP_TYPE_VSIB | (1 << 3) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_GSCAT) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_64) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_REQUIRED, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VSCATTERPF1DPS ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1EA3), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_SCATTER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512PF_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E12NP), 0, ZYDIS_MEMOP_TYPE_VSIB | (1 << 3) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_GSCAT) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_32) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_REQUIRED, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VSCATTERPF1QPD ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1EA5), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_SCATTER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512PF_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E12NP), 0, ZYDIS_MEMOP_TYPE_VSIB | (1 << 3) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_GSCAT) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_64) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_REQUIRED, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VSCATTERPF1QPS ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1EA3), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_SCATTER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512PF_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E12NP), 0, ZYDIS_MEMOP_TYPE_VSIB | (1 << 3) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_GSCAT) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_32) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_REQUIRED, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VSCATTERQPD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1A8B), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_SCATTER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E12), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_VSIB | (1 << 3) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_GSCAT) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_64) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_REQUIRED, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VSCATTERQPD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1A9D), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_SCATTER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E12), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_VSIB | (1 << 3) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_GSCAT) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_64) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_REQUIRED, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VSCATTERQPD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1AA0), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_SCATTER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E12), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_VSIB | (1 << 3) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_GSCAT) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_64) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_REQUIRED, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VSCATTERQPS ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1A94), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_SCATTER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E12), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_VSIB | (1 << 3) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_GSCAT) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_32) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_REQUIRED, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VSCATTERQPS ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1AA3), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_SCATTER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E12), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_VSIB | (1 << 3) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_GSCAT) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_32) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_REQUIRED, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VSCATTERQPS ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1AA6), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_SCATTER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E12), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_VSIB | (1 << 3) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_GSCAT) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_32) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_REQUIRED, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VSHUFF32X4 ZYDIS_NOTMIN(5) ZYDIS_NOTMIN(5) ZYDIS_NOTMIN(0x4E6), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4NF), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VSHUFF32X4 ZYDIS_NOTMIN(5) ZYDIS_NOTMIN(5) ZYDIS_NOTMIN(0x4E1), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4NF), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VSHUFF32X4 ZYDIS_NOTMIN(5) ZYDIS_NOTMIN(5) ZYDIS_NOTMIN(0x4F0), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4NF), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_32) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VSHUFF32X4 ZYDIS_NOTMIN(5) ZYDIS_NOTMIN(5) ZYDIS_NOTMIN(0x4F5), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4NF), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_32) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VSHUFF64X2 ZYDIS_NOTMIN(5) ZYDIS_NOTMIN(5) ZYDIS_NOTMIN(0x4CD), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4NF), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VSHUFF64X2 ZYDIS_NOTMIN(5) ZYDIS_NOTMIN(5) ZYDIS_NOTMIN(0x4C8), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4NF), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VSHUFF64X2 ZYDIS_NOTMIN(5) ZYDIS_NOTMIN(5) ZYDIS_NOTMIN(0x4D7), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4NF), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_64) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VSHUFF64X2 ZYDIS_NOTMIN(5) ZYDIS_NOTMIN(5) ZYDIS_NOTMIN(0x4DC), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4NF), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_64) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VSHUFI32X4 ZYDIS_NOTMIN(5) ZYDIS_NOTMIN(5) ZYDIS_NOTMIN(0x1A8), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4NF), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VSHUFI32X4 ZYDIS_NOTMIN(5) ZYDIS_NOTMIN(5) ZYDIS_NOTMIN(0x1AD), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4NF), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VSHUFI32X4 ZYDIS_NOTMIN(5) ZYDIS_NOTMIN(5) ZYDIS_NOTMIN(0x1B7), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4NF), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_32) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VSHUFI32X4 ZYDIS_NOTMIN(5) ZYDIS_NOTMIN(5) ZYDIS_NOTMIN(0x1BC), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4NF), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_32) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VSHUFI64X2 ZYDIS_NOTMIN(5) ZYDIS_NOTMIN(5) ZYDIS_NOTMIN(0x1C6), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4NF), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VSHUFI64X2 ZYDIS_NOTMIN(5) ZYDIS_NOTMIN(5) ZYDIS_NOTMIN(0x1CB), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4NF), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VSHUFI64X2 ZYDIS_NOTMIN(5) ZYDIS_NOTMIN(5) ZYDIS_NOTMIN(0x1D5), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4NF), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_64) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VSHUFI64X2 ZYDIS_NOTMIN(5) ZYDIS_NOTMIN(5) ZYDIS_NOTMIN(0x1DA), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4NF), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_64) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VSHUFPD ZYDIS_NOTMIN(5) ZYDIS_NOTMIN(5) ZYDIS_NOTMIN(0x2AC), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4NF), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VSHUFPD ZYDIS_NOTMIN(5) ZYDIS_NOTMIN(5) ZYDIS_NOTMIN(0x4CD), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4NF), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VSHUFPD ZYDIS_NOTMIN(5) ZYDIS_NOTMIN(5) ZYDIS_NOTMIN(0x4C8), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4NF), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VSHUFPD ZYDIS_NOTMIN(5) ZYDIS_NOTMIN(5) ZYDIS_NOTMIN(0x4D2), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4NF), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_64) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VSHUFPD ZYDIS_NOTMIN(5) ZYDIS_NOTMIN(5) ZYDIS_NOTMIN(0x4D7), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4NF), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_64) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VSHUFPD ZYDIS_NOTMIN(5) ZYDIS_NOTMIN(5) ZYDIS_NOTMIN(0x4DC), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4NF), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_64) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VSHUFPS ZYDIS_NOTMIN(5) ZYDIS_NOTMIN(5) ZYDIS_NOTMIN(0x2C0), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4NF), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VSHUFPS ZYDIS_NOTMIN(5) ZYDIS_NOTMIN(5) ZYDIS_NOTMIN(0x4E6), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4NF), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VSHUFPS ZYDIS_NOTMIN(5) ZYDIS_NOTMIN(5) ZYDIS_NOTMIN(0x4E1), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4NF), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VSHUFPS ZYDIS_NOTMIN(5) ZYDIS_NOTMIN(5) ZYDIS_NOTMIN(0x4EB), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4NF), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_32) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VSHUFPS ZYDIS_NOTMIN(5) ZYDIS_NOTMIN(5) ZYDIS_NOTMIN(0x4F0), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4NF), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_32) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VSHUFPS ZYDIS_NOTMIN(5) ZYDIS_NOTMIN(5) ZYDIS_NOTMIN(0x4F5), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4NF), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_32) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VSQRTPD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0xA00), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_FIXED_512) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_RC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VSQRTPD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0xA04), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VSQRTPD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0xA08), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VSQRTPD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0xA00), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VSQRTPD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0xA0C), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_64) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VSQRTPD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0xA10), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_64) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VSQRTPD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0xA14), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_64) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VSQRTPH ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0xA18), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_FP16) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_FP16_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_FIXED_512) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_RC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VSQRTPH ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0xA1C), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_FP16) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_FP16_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VSQRTPH ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0xA20), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_FP16) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_FP16_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VSQRTPH ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0xA18), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_FP16) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_FP16_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VSQRTPH ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0xA24), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_FP16) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_FP16_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_16) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VSQRTPH ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0xA28), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_FP16) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_FP16_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_16) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VSQRTPH ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0xA2C), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_FP16) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_FP16_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_16) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VSQRTPS ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0xA30), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_FIXED_512) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_RC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VSQRTPS ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0xA34), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VSQRTPS ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0xA38), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VSQRTPS ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0xA30), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VSQRTPS ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0xA3C), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_32) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VSQRTPS ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0xA40), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_32) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VSQRTPS ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0xA44), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_32) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VSQRTSD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x2AC), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_SCALAR) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E3), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_FIXED_128) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VSQRTSD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x2AC), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_SCALAR) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E3), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_FIXED_128) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_RC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VSQRTSD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x2B1), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_SCALAR) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E3), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_FIXED_128) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_T1S) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_64) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VSQRTSH ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x2B6), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_FP16) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_FP16_SCALAR) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E3), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_FIXED_128) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VSQRTSH ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x2B6), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_FP16) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_FP16_SCALAR) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E3), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_FIXED_128) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_RC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VSQRTSH ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x2BB), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_FP16) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_FP16_SCALAR) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E3), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_FIXED_128) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_T1S) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_16) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VSQRTSS ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x2C0), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_SCALAR) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E3), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_FIXED_128) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VSQRTSS ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x2C0), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_SCALAR) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E3), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_FIXED_128) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_RC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VSQRTSS ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x2C5), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_SCALAR) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E3), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_FIXED_128) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_T1S) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_32) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VSUBPD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x4C8), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_FIXED_512) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_RC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VSUBPD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x2AC), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VSUBPD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x4CD), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VSUBPD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x4C8), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VSUBPD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x4D2), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_64) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VSUBPD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x4D7), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_64) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VSUBPD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x4DC), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_64) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VSUBPH ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x884), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_FP16) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_FP16_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_FIXED_512) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_RC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VSUBPH ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x2B6), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_FP16) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_FP16_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VSUBPH ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x888), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_FP16) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_FP16_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VSUBPH ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x884), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_FP16) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_FP16_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VSUBPH ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x88C), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_FP16) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_FP16_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_16) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VSUBPH ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x890), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_FP16) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_FP16_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_16) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VSUBPH ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x894), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_FP16) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_FP16_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_16) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VSUBPS ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x4E1), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_FIXED_512) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_RC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VSUBPS ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x2C0), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VSUBPS ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x4E6), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VSUBPS ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x4E1), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VSUBPS ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x4EB), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_32) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VSUBPS ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x4F0), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_32) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VSUBPS ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x4F5), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E2), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_32) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VSUBSD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x2AC), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_SCALAR) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E3), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_FIXED_128) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VSUBSD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x2AC), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_SCALAR) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E3), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_FIXED_128) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_RC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VSUBSD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x2B1), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_SCALAR) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E3), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_FIXED_128) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_T1S) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_64) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VSUBSH ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x2B6), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_FP16) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_FP16_SCALAR) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E3), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_FIXED_128) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VSUBSH ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x2B6), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_FP16) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_FP16_SCALAR) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E3), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_FIXED_128) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_RC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VSUBSH ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x2BB), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_FP16) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_FP16_SCALAR) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E3), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_FIXED_128) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_T1S) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_16) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VSUBSS ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x2C0), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_SCALAR) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E3), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_FIXED_128) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VSUBSS ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x2C0), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_SCALAR) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E3), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_FIXED_128) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_RC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VSUBSS ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x2C5), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_SCALAR) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E3), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_FIXED_128) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_T1S) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_32) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VUCOMISD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x13BC), 0, 0 ZYDIS_NOTMIN(0x33), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_SCALAR) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E3NF), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_FIXED_128) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_FORBIDDEN, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VUCOMISD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x13BC), 0, 0 ZYDIS_NOTMIN(0x33), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_SCALAR) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E3NF), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_FIXED_128) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_SAE), ZYDIS_MASK_POLICY_FORBIDDEN, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VUCOMISD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x13D7), 0, 0 ZYDIS_NOTMIN(0x33), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_SCALAR) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E3NF), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_FIXED_128) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_T1S) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_64) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_FORBIDDEN, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VUCOMISH ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x143A), 0, 0 ZYDIS_NOTMIN(0x33), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_FP16) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_FP16_SCALAR) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E3NF), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_FIXED_128) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_FORBIDDEN, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VUCOMISH ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x143A), 0, 0 ZYDIS_NOTMIN(0x33), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_FP16) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_FP16_SCALAR) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E3NF), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_FIXED_128) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_SAE), ZYDIS_MASK_POLICY_FORBIDDEN, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VUCOMISH ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x143D), 0, 0 ZYDIS_NOTMIN(0x33), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_FP16) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512_FP16_SCALAR) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E3NF), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_FIXED_128) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_T1S) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_16) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_FORBIDDEN, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VUCOMISS ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x13C8), 0, 0 ZYDIS_NOTMIN(0x33), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_SCALAR) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E3NF), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_FIXED_128) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_FORBIDDEN, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VUCOMISS ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x13C8), 0, 0 ZYDIS_NOTMIN(0x33), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_SCALAR) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E3NF), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_FIXED_128) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_SAE), ZYDIS_MASK_POLICY_FORBIDDEN, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VUCOMISS ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x13DD), 0, 0 ZYDIS_NOTMIN(0x33), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_SCALAR) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E3NF), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_FIXED_128) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_T1S) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_32) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_FORBIDDEN, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VUNPCKHPD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x2AC), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4NF), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VUNPCKHPD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x4CD), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4NF), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VUNPCKHPD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x4C8), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4NF), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VUNPCKHPD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x4D2), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4NF), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_64) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VUNPCKHPD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x4D7), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4NF), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_64) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VUNPCKHPD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x4DC), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4NF), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_64) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VUNPCKHPS ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x2C0), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4NF), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VUNPCKHPS ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x4E6), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4NF), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VUNPCKHPS ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x4E1), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4NF), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VUNPCKHPS ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x4EB), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4NF), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_32) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VUNPCKHPS ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x4F0), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4NF), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_32) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VUNPCKHPS ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x4F5), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4NF), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_32) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VUNPCKLPD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x2AC), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4NF), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VUNPCKLPD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x4CD), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4NF), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VUNPCKLPD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x4C8), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4NF), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VUNPCKLPD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x4D2), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4NF), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_64) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VUNPCKLPD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x4D7), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4NF), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_64) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VUNPCKLPD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x4DC), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4NF), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_64) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VUNPCKLPS ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x2C0), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4NF), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VUNPCKLPS ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x4E6), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4NF), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VUNPCKLPS ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x4E1), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4NF), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VUNPCKLPS ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x4EB), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4NF), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_32) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VUNPCKLPS ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x4F0), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4NF), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_32) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VUNPCKLPS ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x4F5), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_AVX512) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512F_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4NF), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_32) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VXORPD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x2AC), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_LOGICAL_FP) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512DQ_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VXORPD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x4CD), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_LOGICAL_FP) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512DQ_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VXORPD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x4C8), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_LOGICAL_FP) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512DQ_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VXORPD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x4D2), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_LOGICAL_FP) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512DQ_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_64) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VXORPD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x4D7), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_LOGICAL_FP) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512DQ_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_64) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VXORPD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x4DC), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_LOGICAL_FP) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512DQ_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_64) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VXORPS ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x2C0), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_LOGICAL_FP) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512DQ_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VXORPS ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x4E6), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_LOGICAL_FP) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512DQ_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VXORPS ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x4E1), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_LOGICAL_FP) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512DQ_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_INVALID) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_INVALID) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_INVALID), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VXORPS ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x4EB), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_LOGICAL_FP) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512DQ_128) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_32) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VXORPS ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x4F0), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_LOGICAL_FP) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512DQ_256) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_32) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VXORPS ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x4F5), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_LOGICAL_FP) ZYDIS_NOTMIN(ZYDIS_ISA_SET_AVX512DQ_512) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_AVX512EVEX) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_E4), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_IVECTOR_LENGTH_DEFAULT) ZYDIS_NOTMIN(ZYDIS_TUPLETYPE_FV) ZYDIS_NOTMIN(ZYDIS_IELEMENT_SIZE_32) ZYDIS_NOTMIN(ZYDIS_EVEX_FUNC_BC), ZYDIS_MASK_POLICY_ALLOWED, ZYAN_TRUE ZYDIS_NOTMIN(ZYDIS_MASK_OVERRIDE_DEFAULT) ZYDIS_NOTMIN(ZYDIS_EVEX_STATIC_BROADCAST_NONE) }
};
#endif

#ifndef ZYDIS_DISABLE_KNC
const ZydisInstructionDefinitionMVEX ISTR_DEFINITIONS_MVEX[] =
{
    { ZYDIS_MNEMONIC_CLEVICT0 ZYDIS_NOTMIN(1) ZYDIS_NOTMIN(1) ZYDIS_NOTMIN(0x1F02), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_PREFETCH) ZYDIS_NOTMIN(ZYDIS_ISA_SET_KNCE) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_KNCE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE, ZYDIS_MVEX_FUNC_F_64, ZYDIS_MASK_POLICY_INVALID ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYDIS_MVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_CLEVICT1 ZYDIS_NOTMIN(1) ZYDIS_NOTMIN(1) ZYDIS_NOTMIN(0x1F02), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_PREFETCH) ZYDIS_NOTMIN(ZYDIS_ISA_SET_KNCE) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_KNCE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE, ZYDIS_MVEX_FUNC_F_64, ZYDIS_MASK_POLICY_INVALID ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYDIS_MVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VADDNPD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xCC4), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_KNC) ZYDIS_NOTMIN(ZYDIS_ISA_SET_KNCE) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_KNCE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE, ZYDIS_MVEX_FUNC_SWIZZLE_64, ZYDIS_MASK_POLICY_ALLOWED ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYDIS_MVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VADDNPD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xCC4), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_KNC) ZYDIS_NOTMIN(ZYDIS_ISA_SET_KNCE) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_KNCE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE, ZYDIS_MVEX_FUNC_RC, ZYDIS_MASK_POLICY_ALLOWED ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYDIS_MVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VADDNPD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xCC8), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_KNC) ZYDIS_NOTMIN(ZYDIS_ISA_SET_KNCE) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_KNCE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE, ZYDIS_MVEX_FUNC_SF_64, ZYDIS_MASK_POLICY_ALLOWED ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYDIS_MVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VADDNPS ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x4FA), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_KNC) ZYDIS_NOTMIN(ZYDIS_ISA_SET_KNCE) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_KNCE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE, ZYDIS_MVEX_FUNC_SWIZZLE_32, ZYDIS_MASK_POLICY_ALLOWED ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYDIS_MVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VADDNPS ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x4FA), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_KNC) ZYDIS_NOTMIN(ZYDIS_ISA_SET_KNCE) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_KNCE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE, ZYDIS_MVEX_FUNC_RC, ZYDIS_MASK_POLICY_ALLOWED ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYDIS_MVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VADDNPS ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xCCC), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_KNC) ZYDIS_NOTMIN(ZYDIS_ISA_SET_KNCE) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_KNCE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE, ZYDIS_MVEX_FUNC_SF_32, ZYDIS_MASK_POLICY_ALLOWED ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYDIS_MVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VADDPD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xCC4), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_KNC) ZYDIS_NOTMIN(ZYDIS_ISA_SET_KNCE) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_KNCE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE, ZYDIS_MVEX_FUNC_SWIZZLE_64, ZYDIS_MASK_POLICY_ALLOWED ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYDIS_MVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VADDPD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xCC4), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_KNC) ZYDIS_NOTMIN(ZYDIS_ISA_SET_KNCE) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_KNCE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE, ZYDIS_MVEX_FUNC_RC, ZYDIS_MASK_POLICY_ALLOWED ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYDIS_MVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VADDPD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xCC8), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_KNC) ZYDIS_NOTMIN(ZYDIS_ISA_SET_KNCE) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_KNCE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE, ZYDIS_MVEX_FUNC_SF_64, ZYDIS_MASK_POLICY_ALLOWED ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYDIS_MVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VADDPS ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x4FA), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_KNC) ZYDIS_NOTMIN(ZYDIS_ISA_SET_KNCE) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_KNCE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE, ZYDIS_MVEX_FUNC_SWIZZLE_32, ZYDIS_MASK_POLICY_ALLOWED ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYDIS_MVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VADDPS ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x4FA), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_KNC) ZYDIS_NOTMIN(ZYDIS_ISA_SET_KNCE) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_KNCE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE, ZYDIS_MVEX_FUNC_RC, ZYDIS_MASK_POLICY_ALLOWED ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYDIS_MVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VADDPS ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xCCC), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_KNC) ZYDIS_NOTMIN(ZYDIS_ISA_SET_KNCE) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_KNCE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE, ZYDIS_MVEX_FUNC_SF_32, ZYDIS_MASK_POLICY_ALLOWED ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYDIS_MVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VADDSETSPS ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xCD0), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_KNC) ZYDIS_NOTMIN(ZYDIS_ISA_SET_KNCE) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_KNCE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE, ZYDIS_MVEX_FUNC_SWIZZLE_32, ZYDIS_MASK_POLICY_ALLOWED ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYDIS_MVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VADDSETSPS ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xCD0), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_KNC) ZYDIS_NOTMIN(ZYDIS_ISA_SET_KNCE) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_KNCE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE, ZYDIS_MVEX_FUNC_RC, ZYDIS_MASK_POLICY_ALLOWED ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYDIS_MVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VADDSETSPS ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xCD4), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_KNC) ZYDIS_NOTMIN(ZYDIS_ISA_SET_KNCE) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_KNCE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE, ZYDIS_MVEX_FUNC_SF_32, ZYDIS_MASK_POLICY_ALLOWED ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYDIS_MVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VALIGND ZYDIS_NOTMIN(5) ZYDIS_NOTMIN(5) ZYDIS_NOTMIN(0x4FA), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_KNC) ZYDIS_NOTMIN(ZYDIS_ISA_SET_KNCE) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_KNCE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE, ZYDIS_MVEX_FUNC_INVALID, ZYDIS_MASK_POLICY_ALLOWED ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYDIS_MVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VALIGND ZYDIS_NOTMIN(5) ZYDIS_NOTMIN(5) ZYDIS_NOTMIN(0x4FF), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_KNC) ZYDIS_NOTMIN(ZYDIS_ISA_SET_KNCE) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_KNCE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE, ZYDIS_MVEX_FUNC_F_64, ZYDIS_MASK_POLICY_ALLOWED ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYDIS_MVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VBLENDMPD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xCC4), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_BLEND) ZYDIS_NOTMIN(ZYDIS_ISA_SET_KNCE) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_KNCE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE, ZYDIS_MVEX_FUNC_SWIZZLE_64, ZYDIS_MASK_POLICY_ALLOWED ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYDIS_MVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VBLENDMPD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xCC4), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_BLEND) ZYDIS_NOTMIN(ZYDIS_ISA_SET_KNCE) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_KNCE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE, ZYDIS_MVEX_FUNC_RC, ZYDIS_MASK_POLICY_ALLOWED ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYDIS_MVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VBLENDMPD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xCC8), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_BLEND) ZYDIS_NOTMIN(ZYDIS_ISA_SET_KNCE) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_KNCE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE, ZYDIS_MVEX_FUNC_SF_64, ZYDIS_MASK_POLICY_ALLOWED ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYDIS_MVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VBLENDMPS ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x4FA), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_BLEND) ZYDIS_NOTMIN(ZYDIS_ISA_SET_KNCE) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_KNCE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE, ZYDIS_MVEX_FUNC_SWIZZLE_32, ZYDIS_MASK_POLICY_ALLOWED ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYDIS_MVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VBLENDMPS ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x4FA), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_BLEND) ZYDIS_NOTMIN(ZYDIS_ISA_SET_KNCE) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_KNCE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE, ZYDIS_MVEX_FUNC_RC, ZYDIS_MASK_POLICY_ALLOWED ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYDIS_MVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VBLENDMPS ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xCCC), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_BLEND) ZYDIS_NOTMIN(ZYDIS_ISA_SET_KNCE) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_KNCE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE, ZYDIS_MVEX_FUNC_SF_32, ZYDIS_MASK_POLICY_ALLOWED ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYDIS_MVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VBROADCASTF32X4 ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0xCDC), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_BROADCAST) ZYDIS_NOTMIN(ZYDIS_ISA_SET_KNCE) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_KNCE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE, ZYDIS_MVEX_FUNC_UF_32, ZYDIS_MASK_POLICY_ALLOWED ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYDIS_MVEX_STATIC_BROADCAST_4_TO_16) },
    { ZYDIS_MNEMONIC_VBROADCASTF64X4 ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0xD00), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_BROADCAST) ZYDIS_NOTMIN(ZYDIS_ISA_SET_KNCE) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_KNCE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE, ZYDIS_MVEX_FUNC_UF_64, ZYDIS_MASK_POLICY_ALLOWED ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYDIS_MVEX_STATIC_BROADCAST_4_TO_8) },
    { ZYDIS_MNEMONIC_VBROADCASTI32X4 ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0xCE4), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_BROADCAST) ZYDIS_NOTMIN(ZYDIS_ISA_SET_KNCE) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_KNCE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE, ZYDIS_MVEX_FUNC_UI_32, ZYDIS_MASK_POLICY_ALLOWED ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYDIS_MVEX_STATIC_BROADCAST_4_TO_16) },
    { ZYDIS_MNEMONIC_VBROADCASTI64X4 ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1AA9), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_BROADCAST) ZYDIS_NOTMIN(ZYDIS_ISA_SET_KNCE) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_KNCE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE, ZYDIS_MVEX_FUNC_UF_64, ZYDIS_MASK_POLICY_ALLOWED ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYDIS_MVEX_STATIC_BROADCAST_4_TO_8) },
    { ZYDIS_MNEMONIC_VBROADCASTSD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0xD00), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_BROADCAST) ZYDIS_NOTMIN(ZYDIS_ISA_SET_KNCE) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_KNCE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE, ZYDIS_MVEX_FUNC_UF_64, ZYDIS_MASK_POLICY_ALLOWED ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYDIS_MVEX_STATIC_BROADCAST_1_TO_8) },
    { ZYDIS_MNEMONIC_VBROADCASTSS ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0xCDC), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_BROADCAST) ZYDIS_NOTMIN(ZYDIS_ISA_SET_KNCE) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_KNCE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE, ZYDIS_MVEX_FUNC_UF_32, ZYDIS_MASK_POLICY_ALLOWED ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYDIS_MVEX_STATIC_BROADCAST_1_TO_16) },
    { ZYDIS_MNEMONIC_VCMPPD ZYDIS_NOTMIN(5) ZYDIS_NOTMIN(5) ZYDIS_NOTMIN(0x504), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_KNC) ZYDIS_NOTMIN(ZYDIS_ISA_SET_KNCE) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_KNCE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_MASK, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE, ZYDIS_MVEX_FUNC_SWIZZLE_64, ZYDIS_MASK_POLICY_ALLOWED ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYDIS_MVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCMPPD ZYDIS_NOTMIN(5) ZYDIS_NOTMIN(5) ZYDIS_NOTMIN(0x504), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_KNC) ZYDIS_NOTMIN(ZYDIS_ISA_SET_KNCE) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_KNCE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_MASK, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE, ZYDIS_MVEX_FUNC_SAE, ZYDIS_MASK_POLICY_ALLOWED ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYDIS_MVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCMPPD ZYDIS_NOTMIN(5) ZYDIS_NOTMIN(5) ZYDIS_NOTMIN(0x509), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_KNC) ZYDIS_NOTMIN(ZYDIS_ISA_SET_KNCE) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_KNCE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_MASK, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE, ZYDIS_MVEX_FUNC_SF_64, ZYDIS_MASK_POLICY_ALLOWED ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYDIS_MVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCMPPS ZYDIS_NOTMIN(5) ZYDIS_NOTMIN(5) ZYDIS_NOTMIN(0x50E), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_KNC) ZYDIS_NOTMIN(ZYDIS_ISA_SET_KNCE) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_KNCE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_MASK, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE, ZYDIS_MVEX_FUNC_SWIZZLE_64, ZYDIS_MASK_POLICY_ALLOWED ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYDIS_MVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCMPPS ZYDIS_NOTMIN(5) ZYDIS_NOTMIN(5) ZYDIS_NOTMIN(0x50E), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_KNC) ZYDIS_NOTMIN(ZYDIS_ISA_SET_KNCE) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_KNCE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_MASK, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE, ZYDIS_MVEX_FUNC_SAE, ZYDIS_MASK_POLICY_ALLOWED ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYDIS_MVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCMPPS ZYDIS_NOTMIN(5) ZYDIS_NOTMIN(5) ZYDIS_NOTMIN(0x513), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_KNC) ZYDIS_NOTMIN(ZYDIS_ISA_SET_KNCE) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_KNCE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_MASK, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE, ZYDIS_MVEX_FUNC_SF_32, ZYDIS_MASK_POLICY_ALLOWED ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYDIS_MVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTDQ2PD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0xCFC), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_KNCE) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_KNCE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE, ZYDIS_MVEX_FUNC_SWIZZLE_32, ZYDIS_MASK_POLICY_ALLOWED ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYDIS_MVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTDQ2PD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0xCFC), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_KNCE) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_KNCE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE, ZYDIS_MVEX_FUNC_IGNORED, ZYDIS_MASK_POLICY_ALLOWED ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYDIS_MVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTDQ2PD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0xD00), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_KNCE) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_KNCE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE, ZYDIS_MVEX_FUNC_SI_32_BCST, ZYDIS_MASK_POLICY_ALLOWED ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYDIS_MVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTFXPNTDQ2PS ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xCD8), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_KNCE) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_KNCE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE, ZYDIS_MVEX_FUNC_SWIZZLE_32, ZYDIS_MASK_POLICY_ALLOWED ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYDIS_MVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTFXPNTDQ2PS ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xCD8), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_KNCE) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_KNCE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE, ZYDIS_MVEX_FUNC_SAE, ZYDIS_MASK_POLICY_ALLOWED ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYDIS_MVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTFXPNTDQ2PS ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xCDC), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_KNCE) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_KNCE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE, ZYDIS_MVEX_FUNC_SI_32, ZYDIS_MASK_POLICY_ALLOWED ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYDIS_MVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTFXPNTPD2DQ ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xCE0), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_KNCE) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_KNCE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE, ZYDIS_MVEX_FUNC_SWIZZLE_64, ZYDIS_MASK_POLICY_ALLOWED ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYDIS_MVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTFXPNTPD2DQ ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xCE0), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_KNCE) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_KNCE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE, ZYDIS_MVEX_FUNC_SAE, ZYDIS_MASK_POLICY_ALLOWED ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYDIS_MVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTFXPNTPD2DQ ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xCE4), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_KNCE) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_KNCE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE, ZYDIS_MVEX_FUNC_SF_64, ZYDIS_MASK_POLICY_ALLOWED ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYDIS_MVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTFXPNTPD2UDQ ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xCE8), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_KNCE) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_KNCE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE, ZYDIS_MVEX_FUNC_SWIZZLE_64, ZYDIS_MASK_POLICY_ALLOWED ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYDIS_MVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTFXPNTPD2UDQ ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xCE8), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_KNCE) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_KNCE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE, ZYDIS_MVEX_FUNC_SAE, ZYDIS_MASK_POLICY_ALLOWED ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYDIS_MVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTFXPNTPD2UDQ ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xCEC), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_KNCE) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_KNCE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE, ZYDIS_MVEX_FUNC_SF_64, ZYDIS_MASK_POLICY_ALLOWED ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYDIS_MVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTFXPNTPS2DQ ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xCF0), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_KNCE) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_KNCE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE, ZYDIS_MVEX_FUNC_SWIZZLE_32, ZYDIS_MASK_POLICY_ALLOWED ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYDIS_MVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTFXPNTPS2DQ ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xCF0), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_KNCE) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_KNCE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE, ZYDIS_MVEX_FUNC_SAE, ZYDIS_MASK_POLICY_ALLOWED ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYDIS_MVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTFXPNTPS2DQ ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xCE4), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_KNCE) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_KNCE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE, ZYDIS_MVEX_FUNC_SF_32, ZYDIS_MASK_POLICY_ALLOWED ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYDIS_MVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTFXPNTPS2UDQ ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xCF4), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_KNCE) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_KNCE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE, ZYDIS_MVEX_FUNC_SWIZZLE_32, ZYDIS_MASK_POLICY_ALLOWED ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYDIS_MVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTFXPNTPS2UDQ ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xCF4), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_KNCE) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_KNCE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE, ZYDIS_MVEX_FUNC_SAE, ZYDIS_MASK_POLICY_ALLOWED ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYDIS_MVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTFXPNTPS2UDQ ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xCEC), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_KNCE) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_KNCE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE, ZYDIS_MVEX_FUNC_SF_32, ZYDIS_MASK_POLICY_ALLOWED ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYDIS_MVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTFXPNTUDQ2PS ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xCF8), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_KNCE) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_KNCE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE, ZYDIS_MVEX_FUNC_SWIZZLE_32, ZYDIS_MASK_POLICY_ALLOWED ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYDIS_MVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTFXPNTUDQ2PS ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xCF8), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_KNCE) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_KNCE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE, ZYDIS_MVEX_FUNC_SAE, ZYDIS_MASK_POLICY_ALLOWED ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYDIS_MVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTFXPNTUDQ2PS ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xCDC), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_KNCE) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_KNCE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE, ZYDIS_MVEX_FUNC_SI_32, ZYDIS_MASK_POLICY_ALLOWED ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYDIS_MVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTPD2PS ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1AAC), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_KNCE) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_KNCE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE, ZYDIS_MVEX_FUNC_SWIZZLE_64, ZYDIS_MASK_POLICY_ALLOWED ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYDIS_MVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTPD2PS ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1AAC), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_KNCE) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_KNCE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE, ZYDIS_MVEX_FUNC_RC, ZYDIS_MASK_POLICY_ALLOWED ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYDIS_MVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTPD2PS ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0xCDC), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_KNCE) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_KNCE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE, ZYDIS_MVEX_FUNC_SF_64, ZYDIS_MASK_POLICY_ALLOWED ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYDIS_MVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTPS2PD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1AAF), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_KNCE) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_KNCE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE, ZYDIS_MVEX_FUNC_SWIZZLE_32, ZYDIS_MASK_POLICY_ALLOWED ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYDIS_MVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTPS2PD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1AAF), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_KNCE) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_KNCE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE, ZYDIS_MVEX_FUNC_SAE, ZYDIS_MASK_POLICY_ALLOWED ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYDIS_MVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTPS2PD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0xD00), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_KNCE) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_KNCE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE, ZYDIS_MVEX_FUNC_SF_32_BCST, ZYDIS_MASK_POLICY_ALLOWED ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYDIS_MVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTUDQ2PD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0xCFC), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_KNCE) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_KNCE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE, ZYDIS_MVEX_FUNC_SWIZZLE_32, ZYDIS_MASK_POLICY_ALLOWED ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYDIS_MVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTUDQ2PD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0xCFC), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_KNCE) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_KNCE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE, ZYDIS_MVEX_FUNC_IGNORED, ZYDIS_MASK_POLICY_ALLOWED ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYDIS_MVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VCVTUDQ2PD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0xD00), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_KNCE) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_KNCE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE, ZYDIS_MVEX_FUNC_SI_32_BCST, ZYDIS_MASK_POLICY_ALLOWED ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYDIS_MVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VEXP223PS ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0xD10), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_KNC) ZYDIS_NOTMIN(ZYDIS_ISA_SET_KNCE) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_KNCE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE, ZYDIS_MVEX_FUNC_INVALID, ZYDIS_MASK_POLICY_ALLOWED ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYDIS_MVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VEXP223PS ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0xD10), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_KNC) ZYDIS_NOTMIN(ZYDIS_ISA_SET_KNCE) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_KNCE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE, ZYDIS_MVEX_FUNC_SAE, ZYDIS_MASK_POLICY_ALLOWED ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYDIS_MVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VEXP223PS ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0xD14), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_KNC) ZYDIS_NOTMIN(ZYDIS_ISA_SET_KNCE) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_KNCE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE, ZYDIS_MVEX_FUNC_F_32, ZYDIS_MASK_POLICY_ALLOWED ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYDIS_MVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFIXUPNANPD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xCC4), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_KNC) ZYDIS_NOTMIN(ZYDIS_ISA_SET_KNCE) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_KNCE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE, ZYDIS_MVEX_FUNC_SWIZZLE_64, ZYDIS_MASK_POLICY_ALLOWED ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYDIS_MVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFIXUPNANPD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xCC4), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_KNC) ZYDIS_NOTMIN(ZYDIS_ISA_SET_KNCE) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_KNCE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE, ZYDIS_MVEX_FUNC_SAE, ZYDIS_MASK_POLICY_ALLOWED ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYDIS_MVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFIXUPNANPD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xCC8), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_KNC) ZYDIS_NOTMIN(ZYDIS_ISA_SET_KNCE) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_KNCE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE, ZYDIS_MVEX_FUNC_SI_64, ZYDIS_MASK_POLICY_ALLOWED ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYDIS_MVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFIXUPNANPS ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x4FA), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_KNC) ZYDIS_NOTMIN(ZYDIS_ISA_SET_KNCE) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_KNCE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE, ZYDIS_MVEX_FUNC_SWIZZLE_32, ZYDIS_MASK_POLICY_ALLOWED ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYDIS_MVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFIXUPNANPS ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x4FA), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_KNC) ZYDIS_NOTMIN(ZYDIS_ISA_SET_KNCE) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_KNCE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE, ZYDIS_MVEX_FUNC_SAE, ZYDIS_MASK_POLICY_ALLOWED ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYDIS_MVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFIXUPNANPS ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xCCC), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_KNC) ZYDIS_NOTMIN(ZYDIS_ISA_SET_KNCE) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_KNCE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE, ZYDIS_MVEX_FUNC_SI_32, ZYDIS_MASK_POLICY_ALLOWED ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYDIS_MVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFMADD132PD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xCC4), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_UFMA) ZYDIS_NOTMIN(ZYDIS_ISA_SET_KNCE) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_KNCE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE, ZYDIS_MVEX_FUNC_SWIZZLE_64, ZYDIS_MASK_POLICY_ALLOWED ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYDIS_MVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFMADD132PD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xCC4), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_UFMA) ZYDIS_NOTMIN(ZYDIS_ISA_SET_KNCE) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_KNCE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE, ZYDIS_MVEX_FUNC_RC, ZYDIS_MASK_POLICY_ALLOWED ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYDIS_MVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFMADD132PD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xCC8), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_UFMA) ZYDIS_NOTMIN(ZYDIS_ISA_SET_KNCE) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_KNCE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE, ZYDIS_MVEX_FUNC_SF_64, ZYDIS_MASK_POLICY_ALLOWED ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYDIS_MVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFMADD132PS ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x4FA), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_UFMA) ZYDIS_NOTMIN(ZYDIS_ISA_SET_KNCE) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_KNCE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE, ZYDIS_MVEX_FUNC_SWIZZLE_32, ZYDIS_MASK_POLICY_ALLOWED ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYDIS_MVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFMADD132PS ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x4FA), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_UFMA) ZYDIS_NOTMIN(ZYDIS_ISA_SET_KNCE) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_KNCE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE, ZYDIS_MVEX_FUNC_RC, ZYDIS_MASK_POLICY_ALLOWED ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYDIS_MVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFMADD132PS ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xCCC), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_UFMA) ZYDIS_NOTMIN(ZYDIS_ISA_SET_KNCE) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_KNCE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE, ZYDIS_MVEX_FUNC_SF_32, ZYDIS_MASK_POLICY_ALLOWED ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYDIS_MVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFMADD213PD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xCC4), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_UFMA) ZYDIS_NOTMIN(ZYDIS_ISA_SET_KNCE) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_KNCE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE, ZYDIS_MVEX_FUNC_SWIZZLE_64, ZYDIS_MASK_POLICY_ALLOWED ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYDIS_MVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFMADD213PD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xCC4), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_UFMA) ZYDIS_NOTMIN(ZYDIS_ISA_SET_KNCE) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_KNCE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE, ZYDIS_MVEX_FUNC_RC, ZYDIS_MASK_POLICY_ALLOWED ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYDIS_MVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFMADD213PD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xCC8), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_UFMA) ZYDIS_NOTMIN(ZYDIS_ISA_SET_KNCE) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_KNCE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE, ZYDIS_MVEX_FUNC_SF_64, ZYDIS_MASK_POLICY_ALLOWED ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYDIS_MVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFMADD213PS ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x4FA), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_UFMA) ZYDIS_NOTMIN(ZYDIS_ISA_SET_KNCE) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_KNCE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE, ZYDIS_MVEX_FUNC_SWIZZLE_32, ZYDIS_MASK_POLICY_ALLOWED ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYDIS_MVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFMADD213PS ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x4FA), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_UFMA) ZYDIS_NOTMIN(ZYDIS_ISA_SET_KNCE) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_KNCE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE, ZYDIS_MVEX_FUNC_RC, ZYDIS_MASK_POLICY_ALLOWED ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYDIS_MVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFMADD213PS ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xCCC), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_UFMA) ZYDIS_NOTMIN(ZYDIS_ISA_SET_KNCE) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_KNCE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE, ZYDIS_MVEX_FUNC_SF_32, ZYDIS_MASK_POLICY_ALLOWED ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYDIS_MVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFMADD231PD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xCC4), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_UFMA) ZYDIS_NOTMIN(ZYDIS_ISA_SET_KNCE) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_KNCE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE, ZYDIS_MVEX_FUNC_SWIZZLE_64, ZYDIS_MASK_POLICY_ALLOWED ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYDIS_MVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFMADD231PD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xCC4), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_UFMA) ZYDIS_NOTMIN(ZYDIS_ISA_SET_KNCE) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_KNCE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE, ZYDIS_MVEX_FUNC_RC, ZYDIS_MASK_POLICY_ALLOWED ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYDIS_MVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFMADD231PD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xCC8), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_UFMA) ZYDIS_NOTMIN(ZYDIS_ISA_SET_KNCE) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_KNCE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE, ZYDIS_MVEX_FUNC_SF_64, ZYDIS_MASK_POLICY_ALLOWED ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYDIS_MVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFMADD231PS ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x4FA), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_UFMA) ZYDIS_NOTMIN(ZYDIS_ISA_SET_KNCE) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_KNCE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE, ZYDIS_MVEX_FUNC_SWIZZLE_32, ZYDIS_MASK_POLICY_ALLOWED ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYDIS_MVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFMADD231PS ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x4FA), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_UFMA) ZYDIS_NOTMIN(ZYDIS_ISA_SET_KNCE) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_KNCE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE, ZYDIS_MVEX_FUNC_RC, ZYDIS_MASK_POLICY_ALLOWED ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYDIS_MVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFMADD231PS ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xCCC), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_UFMA) ZYDIS_NOTMIN(ZYDIS_ISA_SET_KNCE) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_KNCE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE, ZYDIS_MVEX_FUNC_SF_32, ZYDIS_MASK_POLICY_ALLOWED ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYDIS_MVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFMADD233PS ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x4FA), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_UFMA) ZYDIS_NOTMIN(ZYDIS_ISA_SET_KNCE) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_KNCE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE, ZYDIS_MVEX_FUNC_SWIZZLE_32, ZYDIS_MASK_POLICY_ALLOWED ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYDIS_MVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFMADD233PS ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x4FA), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_UFMA) ZYDIS_NOTMIN(ZYDIS_ISA_SET_KNCE) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_KNCE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE, ZYDIS_MVEX_FUNC_RC, ZYDIS_MASK_POLICY_ALLOWED ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYDIS_MVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFMADD233PS ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xCCC), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_UFMA) ZYDIS_NOTMIN(ZYDIS_ISA_SET_KNCE) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_KNCE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE, ZYDIS_MVEX_FUNC_SF_32_BCST_4TO16, ZYDIS_MASK_POLICY_ALLOWED ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYDIS_MVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFMSUB132PD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xCC4), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_UFMA) ZYDIS_NOTMIN(ZYDIS_ISA_SET_KNCE) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_KNCE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE, ZYDIS_MVEX_FUNC_SWIZZLE_64, ZYDIS_MASK_POLICY_ALLOWED ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYDIS_MVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFMSUB132PD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xCC4), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_UFMA) ZYDIS_NOTMIN(ZYDIS_ISA_SET_KNCE) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_KNCE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE, ZYDIS_MVEX_FUNC_RC, ZYDIS_MASK_POLICY_ALLOWED ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYDIS_MVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFMSUB132PD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xCC8), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_UFMA) ZYDIS_NOTMIN(ZYDIS_ISA_SET_KNCE) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_KNCE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE, ZYDIS_MVEX_FUNC_SF_64, ZYDIS_MASK_POLICY_ALLOWED ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYDIS_MVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFMSUB132PS ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x4FA), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_UFMA) ZYDIS_NOTMIN(ZYDIS_ISA_SET_KNCE) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_KNCE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE, ZYDIS_MVEX_FUNC_SWIZZLE_32, ZYDIS_MASK_POLICY_ALLOWED ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYDIS_MVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFMSUB132PS ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x4FA), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_UFMA) ZYDIS_NOTMIN(ZYDIS_ISA_SET_KNCE) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_KNCE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE, ZYDIS_MVEX_FUNC_RC, ZYDIS_MASK_POLICY_ALLOWED ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYDIS_MVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFMSUB132PS ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xCCC), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_UFMA) ZYDIS_NOTMIN(ZYDIS_ISA_SET_KNCE) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_KNCE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE, ZYDIS_MVEX_FUNC_SF_32, ZYDIS_MASK_POLICY_ALLOWED ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYDIS_MVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFMSUB213PD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xCC4), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_UFMA) ZYDIS_NOTMIN(ZYDIS_ISA_SET_KNCE) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_KNCE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE, ZYDIS_MVEX_FUNC_SWIZZLE_64, ZYDIS_MASK_POLICY_ALLOWED ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYDIS_MVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFMSUB213PD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xCC4), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_UFMA) ZYDIS_NOTMIN(ZYDIS_ISA_SET_KNCE) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_KNCE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE, ZYDIS_MVEX_FUNC_RC, ZYDIS_MASK_POLICY_ALLOWED ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYDIS_MVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFMSUB213PD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xCC8), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_UFMA) ZYDIS_NOTMIN(ZYDIS_ISA_SET_KNCE) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_KNCE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE, ZYDIS_MVEX_FUNC_SF_64, ZYDIS_MASK_POLICY_ALLOWED ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYDIS_MVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFMSUB213PS ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x4FA), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_UFMA) ZYDIS_NOTMIN(ZYDIS_ISA_SET_KNCE) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_KNCE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE, ZYDIS_MVEX_FUNC_SWIZZLE_32, ZYDIS_MASK_POLICY_ALLOWED ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYDIS_MVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFMSUB213PS ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x4FA), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_UFMA) ZYDIS_NOTMIN(ZYDIS_ISA_SET_KNCE) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_KNCE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE, ZYDIS_MVEX_FUNC_RC, ZYDIS_MASK_POLICY_ALLOWED ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYDIS_MVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFMSUB213PS ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xCCC), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_UFMA) ZYDIS_NOTMIN(ZYDIS_ISA_SET_KNCE) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_KNCE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE, ZYDIS_MVEX_FUNC_SF_32, ZYDIS_MASK_POLICY_ALLOWED ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYDIS_MVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFMSUB231PD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xCC4), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_UFMA) ZYDIS_NOTMIN(ZYDIS_ISA_SET_KNCE) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_KNCE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE, ZYDIS_MVEX_FUNC_SWIZZLE_64, ZYDIS_MASK_POLICY_ALLOWED ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYDIS_MVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFMSUB231PD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xCC4), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_UFMA) ZYDIS_NOTMIN(ZYDIS_ISA_SET_KNCE) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_KNCE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE, ZYDIS_MVEX_FUNC_RC, ZYDIS_MASK_POLICY_ALLOWED ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYDIS_MVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFMSUB231PD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xCC8), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_UFMA) ZYDIS_NOTMIN(ZYDIS_ISA_SET_KNCE) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_KNCE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE, ZYDIS_MVEX_FUNC_SF_64, ZYDIS_MASK_POLICY_ALLOWED ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYDIS_MVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFMSUB231PS ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x4FA), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_UFMA) ZYDIS_NOTMIN(ZYDIS_ISA_SET_KNCE) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_KNCE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE, ZYDIS_MVEX_FUNC_SWIZZLE_32, ZYDIS_MASK_POLICY_ALLOWED ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYDIS_MVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFMSUB231PS ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x4FA), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_UFMA) ZYDIS_NOTMIN(ZYDIS_ISA_SET_KNCE) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_KNCE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE, ZYDIS_MVEX_FUNC_RC, ZYDIS_MASK_POLICY_ALLOWED ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYDIS_MVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFMSUB231PS ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xCCC), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_UFMA) ZYDIS_NOTMIN(ZYDIS_ISA_SET_KNCE) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_KNCE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE, ZYDIS_MVEX_FUNC_SF_32, ZYDIS_MASK_POLICY_ALLOWED ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYDIS_MVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFNMADD132PD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xCC4), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_UFMA) ZYDIS_NOTMIN(ZYDIS_ISA_SET_KNCE) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_KNCE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE, ZYDIS_MVEX_FUNC_SWIZZLE_64, ZYDIS_MASK_POLICY_ALLOWED ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYDIS_MVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFNMADD132PD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xCC4), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_UFMA) ZYDIS_NOTMIN(ZYDIS_ISA_SET_KNCE) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_KNCE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE, ZYDIS_MVEX_FUNC_RC, ZYDIS_MASK_POLICY_ALLOWED ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYDIS_MVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFNMADD132PD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xCC8), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_UFMA) ZYDIS_NOTMIN(ZYDIS_ISA_SET_KNCE) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_KNCE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE, ZYDIS_MVEX_FUNC_SF_64, ZYDIS_MASK_POLICY_ALLOWED ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYDIS_MVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFNMADD132PS ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x4FA), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_UFMA) ZYDIS_NOTMIN(ZYDIS_ISA_SET_KNCE) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_KNCE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE, ZYDIS_MVEX_FUNC_SWIZZLE_32, ZYDIS_MASK_POLICY_ALLOWED ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYDIS_MVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFNMADD132PS ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x4FA), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_UFMA) ZYDIS_NOTMIN(ZYDIS_ISA_SET_KNCE) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_KNCE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE, ZYDIS_MVEX_FUNC_RC, ZYDIS_MASK_POLICY_ALLOWED ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYDIS_MVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFNMADD132PS ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xCCC), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_UFMA) ZYDIS_NOTMIN(ZYDIS_ISA_SET_KNCE) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_KNCE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE, ZYDIS_MVEX_FUNC_SF_32, ZYDIS_MASK_POLICY_ALLOWED ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYDIS_MVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFNMADD213PD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xCC4), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_UFMA) ZYDIS_NOTMIN(ZYDIS_ISA_SET_KNCE) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_KNCE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE, ZYDIS_MVEX_FUNC_SWIZZLE_64, ZYDIS_MASK_POLICY_ALLOWED ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYDIS_MVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFNMADD213PD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xCC4), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_UFMA) ZYDIS_NOTMIN(ZYDIS_ISA_SET_KNCE) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_KNCE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE, ZYDIS_MVEX_FUNC_RC, ZYDIS_MASK_POLICY_ALLOWED ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYDIS_MVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFNMADD213PD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xCC8), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_UFMA) ZYDIS_NOTMIN(ZYDIS_ISA_SET_KNCE) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_KNCE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE, ZYDIS_MVEX_FUNC_SF_64, ZYDIS_MASK_POLICY_ALLOWED ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYDIS_MVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFNMADD213PS ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x4FA), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_UFMA) ZYDIS_NOTMIN(ZYDIS_ISA_SET_KNCE) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_KNCE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE, ZYDIS_MVEX_FUNC_SWIZZLE_32, ZYDIS_MASK_POLICY_ALLOWED ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYDIS_MVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFNMADD213PS ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x4FA), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_UFMA) ZYDIS_NOTMIN(ZYDIS_ISA_SET_KNCE) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_KNCE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE, ZYDIS_MVEX_FUNC_RC, ZYDIS_MASK_POLICY_ALLOWED ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYDIS_MVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFNMADD213PS ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xCCC), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_UFMA) ZYDIS_NOTMIN(ZYDIS_ISA_SET_KNCE) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_KNCE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE, ZYDIS_MVEX_FUNC_SF_32, ZYDIS_MASK_POLICY_ALLOWED ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYDIS_MVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFNMADD231PD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xCC4), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_UFMA) ZYDIS_NOTMIN(ZYDIS_ISA_SET_KNCE) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_KNCE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE, ZYDIS_MVEX_FUNC_SWIZZLE_64, ZYDIS_MASK_POLICY_ALLOWED ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYDIS_MVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFNMADD231PD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xCC4), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_UFMA) ZYDIS_NOTMIN(ZYDIS_ISA_SET_KNCE) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_KNCE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE, ZYDIS_MVEX_FUNC_RC, ZYDIS_MASK_POLICY_ALLOWED ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYDIS_MVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFNMADD231PD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xCC8), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_UFMA) ZYDIS_NOTMIN(ZYDIS_ISA_SET_KNCE) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_KNCE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE, ZYDIS_MVEX_FUNC_SF_64, ZYDIS_MASK_POLICY_ALLOWED ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYDIS_MVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFNMADD231PS ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x4FA), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_UFMA) ZYDIS_NOTMIN(ZYDIS_ISA_SET_KNCE) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_KNCE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE, ZYDIS_MVEX_FUNC_SWIZZLE_32, ZYDIS_MASK_POLICY_ALLOWED ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYDIS_MVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFNMADD231PS ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x4FA), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_UFMA) ZYDIS_NOTMIN(ZYDIS_ISA_SET_KNCE) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_KNCE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE, ZYDIS_MVEX_FUNC_RC, ZYDIS_MASK_POLICY_ALLOWED ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYDIS_MVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFNMADD231PS ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xCCC), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_UFMA) ZYDIS_NOTMIN(ZYDIS_ISA_SET_KNCE) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_KNCE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE, ZYDIS_MVEX_FUNC_SF_32, ZYDIS_MASK_POLICY_ALLOWED ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYDIS_MVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFNMSUB132PD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xCC4), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_UFMA) ZYDIS_NOTMIN(ZYDIS_ISA_SET_KNCE) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_KNCE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE, ZYDIS_MVEX_FUNC_SWIZZLE_64, ZYDIS_MASK_POLICY_ALLOWED ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYDIS_MVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFNMSUB132PD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xCC4), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_UFMA) ZYDIS_NOTMIN(ZYDIS_ISA_SET_KNCE) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_KNCE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE, ZYDIS_MVEX_FUNC_RC, ZYDIS_MASK_POLICY_ALLOWED ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYDIS_MVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFNMSUB132PD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xCC8), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_UFMA) ZYDIS_NOTMIN(ZYDIS_ISA_SET_KNCE) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_KNCE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE, ZYDIS_MVEX_FUNC_SF_64, ZYDIS_MASK_POLICY_ALLOWED ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYDIS_MVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFNMSUB132PS ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x4FA), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_UFMA) ZYDIS_NOTMIN(ZYDIS_ISA_SET_KNCE) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_KNCE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE, ZYDIS_MVEX_FUNC_SWIZZLE_32, ZYDIS_MASK_POLICY_ALLOWED ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYDIS_MVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFNMSUB132PS ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x4FA), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_UFMA) ZYDIS_NOTMIN(ZYDIS_ISA_SET_KNCE) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_KNCE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE, ZYDIS_MVEX_FUNC_RC, ZYDIS_MASK_POLICY_ALLOWED ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYDIS_MVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFNMSUB132PS ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xCCC), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_UFMA) ZYDIS_NOTMIN(ZYDIS_ISA_SET_KNCE) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_KNCE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE, ZYDIS_MVEX_FUNC_SF_32, ZYDIS_MASK_POLICY_ALLOWED ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYDIS_MVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFNMSUB213PD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xCC4), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_UFMA) ZYDIS_NOTMIN(ZYDIS_ISA_SET_KNCE) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_KNCE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE, ZYDIS_MVEX_FUNC_SWIZZLE_64, ZYDIS_MASK_POLICY_ALLOWED ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYDIS_MVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFNMSUB213PD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xCC4), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_UFMA) ZYDIS_NOTMIN(ZYDIS_ISA_SET_KNCE) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_KNCE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE, ZYDIS_MVEX_FUNC_RC, ZYDIS_MASK_POLICY_ALLOWED ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYDIS_MVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFNMSUB213PD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xCC8), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_UFMA) ZYDIS_NOTMIN(ZYDIS_ISA_SET_KNCE) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_KNCE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE, ZYDIS_MVEX_FUNC_SF_64, ZYDIS_MASK_POLICY_ALLOWED ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYDIS_MVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFNMSUB213PS ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x4FA), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_UFMA) ZYDIS_NOTMIN(ZYDIS_ISA_SET_KNCE) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_KNCE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE, ZYDIS_MVEX_FUNC_SWIZZLE_32, ZYDIS_MASK_POLICY_ALLOWED ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYDIS_MVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFNMSUB213PS ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x4FA), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_UFMA) ZYDIS_NOTMIN(ZYDIS_ISA_SET_KNCE) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_KNCE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE, ZYDIS_MVEX_FUNC_RC, ZYDIS_MASK_POLICY_ALLOWED ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYDIS_MVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFNMSUB213PS ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xCCC), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_UFMA) ZYDIS_NOTMIN(ZYDIS_ISA_SET_KNCE) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_KNCE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE, ZYDIS_MVEX_FUNC_SF_32, ZYDIS_MASK_POLICY_ALLOWED ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYDIS_MVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFNMSUB231PD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xCC4), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_UFMA) ZYDIS_NOTMIN(ZYDIS_ISA_SET_KNCE) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_KNCE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE, ZYDIS_MVEX_FUNC_SWIZZLE_64, ZYDIS_MASK_POLICY_ALLOWED ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYDIS_MVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFNMSUB231PD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xCC4), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_UFMA) ZYDIS_NOTMIN(ZYDIS_ISA_SET_KNCE) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_KNCE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE, ZYDIS_MVEX_FUNC_RC, ZYDIS_MASK_POLICY_ALLOWED ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYDIS_MVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFNMSUB231PD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xCC8), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_UFMA) ZYDIS_NOTMIN(ZYDIS_ISA_SET_KNCE) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_KNCE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE, ZYDIS_MVEX_FUNC_SF_64, ZYDIS_MASK_POLICY_ALLOWED ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYDIS_MVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFNMSUB231PS ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x4FA), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_UFMA) ZYDIS_NOTMIN(ZYDIS_ISA_SET_KNCE) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_KNCE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE, ZYDIS_MVEX_FUNC_SWIZZLE_32, ZYDIS_MASK_POLICY_ALLOWED ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYDIS_MVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFNMSUB231PS ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x4FA), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_UFMA) ZYDIS_NOTMIN(ZYDIS_ISA_SET_KNCE) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_KNCE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE, ZYDIS_MVEX_FUNC_RC, ZYDIS_MASK_POLICY_ALLOWED ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYDIS_MVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VFNMSUB231PS ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xCCC), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_UFMA) ZYDIS_NOTMIN(ZYDIS_ISA_SET_KNCE) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_KNCE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE, ZYDIS_MVEX_FUNC_SF_32, ZYDIS_MASK_POLICY_ALLOWED ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYDIS_MVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VGATHERDPD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1AB2), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_KNC) ZYDIS_NOTMIN(ZYDIS_ISA_SET_KNCE) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_KNCE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_VSIB | (1 << 3) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_TRUE, ZYAN_FALSE, ZYAN_FALSE, ZYDIS_MVEX_FUNC_UF_64, ZYDIS_MASK_POLICY_ALLOWED ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYDIS_MVEX_STATIC_BROADCAST_1_TO_8) },
    { ZYDIS_MNEMONIC_VGATHERDPS ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1AB5), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_KNC) ZYDIS_NOTMIN(ZYDIS_ISA_SET_KNCE) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_KNCE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_VSIB | (1 << 3) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_TRUE, ZYAN_FALSE, ZYAN_FALSE, ZYDIS_MVEX_FUNC_UF_32, ZYDIS_MASK_POLICY_ALLOWED ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYDIS_MVEX_STATIC_BROADCAST_1_TO_16) },
    { ZYDIS_MNEMONIC_VGATHERPF0DPS ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1EFB), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_PREFETCH) ZYDIS_NOTMIN(ZYDIS_ISA_SET_KNCE) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_KNCE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, ZYDIS_MEMOP_TYPE_VSIB | (1 << 3) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_TRUE, ZYAN_FALSE, ZYAN_FALSE, ZYDIS_MVEX_FUNC_UF_32, ZYDIS_MASK_POLICY_ALLOWED ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYDIS_MVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VGATHERPF0HINTDPD ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1EFB), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_PREFETCH) ZYDIS_NOTMIN(ZYDIS_ISA_SET_KNC_PF_HINT) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_KNCE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, ZYDIS_MEMOP_TYPE_VSIB | (1 << 3) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_TRUE, ZYAN_FALSE, ZYAN_FALSE, ZYDIS_MVEX_FUNC_UF_32, ZYDIS_MASK_POLICY_ALLOWED ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYDIS_MVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VGATHERPF0HINTDPS ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1EFB), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_PREFETCH) ZYDIS_NOTMIN(ZYDIS_ISA_SET_KNC_PF_HINT) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_KNCE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, ZYDIS_MEMOP_TYPE_VSIB | (1 << 3) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_TRUE, ZYAN_FALSE, ZYAN_FALSE, ZYDIS_MVEX_FUNC_UF_32, ZYDIS_MASK_POLICY_ALLOWED ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYDIS_MVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VGATHERPF1DPS ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1EFB), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_PREFETCH) ZYDIS_NOTMIN(ZYDIS_ISA_SET_KNCE) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_KNCE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, ZYDIS_MEMOP_TYPE_VSIB | (1 << 3) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_TRUE, ZYAN_FALSE, ZYAN_FALSE, ZYDIS_MVEX_FUNC_UF_32, ZYDIS_MASK_POLICY_ALLOWED ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYDIS_MVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VGETEXPPD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0xCFC), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_KNC) ZYDIS_NOTMIN(ZYDIS_ISA_SET_KNCE) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_KNCE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE, ZYDIS_MVEX_FUNC_SWIZZLE_64, ZYDIS_MASK_POLICY_ALLOWED ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYDIS_MVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VGETEXPPD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0xCFC), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_KNC) ZYDIS_NOTMIN(ZYDIS_ISA_SET_KNCE) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_KNCE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE, ZYDIS_MVEX_FUNC_SAE, ZYDIS_MASK_POLICY_ALLOWED ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYDIS_MVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VGETEXPPD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0xD00), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_KNC) ZYDIS_NOTMIN(ZYDIS_ISA_SET_KNCE) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_KNCE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE, ZYDIS_MVEX_FUNC_SF_64, ZYDIS_MASK_POLICY_ALLOWED ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYDIS_MVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VGETEXPPS ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1AAF), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_KNC) ZYDIS_NOTMIN(ZYDIS_ISA_SET_KNCE) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_KNCE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE, ZYDIS_MVEX_FUNC_SWIZZLE_32, ZYDIS_MASK_POLICY_ALLOWED ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYDIS_MVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VGETEXPPS ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1AAF), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_KNC) ZYDIS_NOTMIN(ZYDIS_ISA_SET_KNCE) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_KNCE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE, ZYDIS_MVEX_FUNC_SAE, ZYDIS_MASK_POLICY_ALLOWED ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYDIS_MVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VGETEXPPS ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0xD00), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_KNC) ZYDIS_NOTMIN(ZYDIS_ISA_SET_KNCE) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_KNCE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE, ZYDIS_MVEX_FUNC_SF_32, ZYDIS_MASK_POLICY_ALLOWED ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYDIS_MVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VGETMANTPD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xCFC), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_KNC) ZYDIS_NOTMIN(ZYDIS_ISA_SET_KNCE) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_KNCE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE, ZYDIS_MVEX_FUNC_SWIZZLE_64, ZYDIS_MASK_POLICY_ALLOWED ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYDIS_MVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VGETMANTPD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xCFC), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_KNC) ZYDIS_NOTMIN(ZYDIS_ISA_SET_KNCE) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_KNCE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE, ZYDIS_MVEX_FUNC_SAE, ZYDIS_MASK_POLICY_ALLOWED ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYDIS_MVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VGETMANTPD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xD00), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_KNC) ZYDIS_NOTMIN(ZYDIS_ISA_SET_KNCE) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_KNCE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE, ZYDIS_MVEX_FUNC_SF_64, ZYDIS_MASK_POLICY_ALLOWED ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYDIS_MVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VGETMANTPS ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xD04), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_KNC) ZYDIS_NOTMIN(ZYDIS_ISA_SET_KNCE) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_KNCE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE, ZYDIS_MVEX_FUNC_SWIZZLE_32, ZYDIS_MASK_POLICY_ALLOWED ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYDIS_MVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VGETMANTPS ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xD04), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_KNC) ZYDIS_NOTMIN(ZYDIS_ISA_SET_KNCE) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_KNCE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE, ZYDIS_MVEX_FUNC_SAE, ZYDIS_MASK_POLICY_ALLOWED ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYDIS_MVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VGETMANTPS ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xCDC), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_KNC) ZYDIS_NOTMIN(ZYDIS_ISA_SET_KNCE) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_KNCE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE, ZYDIS_MVEX_FUNC_SF_32, ZYDIS_MASK_POLICY_ALLOWED ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYDIS_MVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VGMAXABSPS ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x4FA), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_KNC) ZYDIS_NOTMIN(ZYDIS_ISA_SET_KNCE) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_KNCE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE, ZYDIS_MVEX_FUNC_SWIZZLE_32, ZYDIS_MASK_POLICY_ALLOWED ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYDIS_MVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VGMAXABSPS ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x4FA), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_KNC) ZYDIS_NOTMIN(ZYDIS_ISA_SET_KNCE) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_KNCE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE, ZYDIS_MVEX_FUNC_SAE, ZYDIS_MASK_POLICY_ALLOWED ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYDIS_MVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VGMAXABSPS ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xCCC), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_KNC) ZYDIS_NOTMIN(ZYDIS_ISA_SET_KNCE) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_KNCE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE, ZYDIS_MVEX_FUNC_SF_32, ZYDIS_MASK_POLICY_ALLOWED ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYDIS_MVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VGMAXPD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xCC4), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_KNC) ZYDIS_NOTMIN(ZYDIS_ISA_SET_KNCE) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_KNCE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE, ZYDIS_MVEX_FUNC_SWIZZLE_64, ZYDIS_MASK_POLICY_ALLOWED ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYDIS_MVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VGMAXPD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xCC4), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_KNC) ZYDIS_NOTMIN(ZYDIS_ISA_SET_KNCE) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_KNCE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE, ZYDIS_MVEX_FUNC_SAE, ZYDIS_MASK_POLICY_ALLOWED ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYDIS_MVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VGMAXPD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xCC8), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_KNC) ZYDIS_NOTMIN(ZYDIS_ISA_SET_KNCE) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_KNCE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE, ZYDIS_MVEX_FUNC_SF_64, ZYDIS_MASK_POLICY_ALLOWED ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYDIS_MVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VGMAXPS ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x4FA), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_KNC) ZYDIS_NOTMIN(ZYDIS_ISA_SET_KNCE) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_KNCE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE, ZYDIS_MVEX_FUNC_SWIZZLE_32, ZYDIS_MASK_POLICY_ALLOWED ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYDIS_MVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VGMAXPS ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x4FA), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_KNC) ZYDIS_NOTMIN(ZYDIS_ISA_SET_KNCE) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_KNCE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE, ZYDIS_MVEX_FUNC_RC, ZYDIS_MASK_POLICY_ALLOWED ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYDIS_MVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VGMAXPS ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xCCC), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_KNC) ZYDIS_NOTMIN(ZYDIS_ISA_SET_KNCE) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_KNCE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE, ZYDIS_MVEX_FUNC_SF_32, ZYDIS_MASK_POLICY_ALLOWED ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYDIS_MVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VGMINPD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xCC4), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_KNC) ZYDIS_NOTMIN(ZYDIS_ISA_SET_KNCE) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_KNCE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE, ZYDIS_MVEX_FUNC_SWIZZLE_64, ZYDIS_MASK_POLICY_ALLOWED ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYDIS_MVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VGMINPD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xCC4), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_KNC) ZYDIS_NOTMIN(ZYDIS_ISA_SET_KNCE) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_KNCE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE, ZYDIS_MVEX_FUNC_SAE, ZYDIS_MASK_POLICY_ALLOWED ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYDIS_MVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VGMINPD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xCC8), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_KNC) ZYDIS_NOTMIN(ZYDIS_ISA_SET_KNCE) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_KNCE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE, ZYDIS_MVEX_FUNC_SF_64, ZYDIS_MASK_POLICY_ALLOWED ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYDIS_MVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VGMINPS ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x4FA), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_KNC) ZYDIS_NOTMIN(ZYDIS_ISA_SET_KNCE) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_KNCE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE, ZYDIS_MVEX_FUNC_SWIZZLE_32, ZYDIS_MASK_POLICY_ALLOWED ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYDIS_MVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VGMINPS ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x4FA), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_KNC) ZYDIS_NOTMIN(ZYDIS_ISA_SET_KNCE) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_KNCE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE, ZYDIS_MVEX_FUNC_RC, ZYDIS_MASK_POLICY_ALLOWED ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYDIS_MVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VGMINPS ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xCCC), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_KNC) ZYDIS_NOTMIN(ZYDIS_ISA_SET_KNCE) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_KNCE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE, ZYDIS_MVEX_FUNC_SF_32, ZYDIS_MASK_POLICY_ALLOWED ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYDIS_MVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VLOADUNPACKHD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0xCE4), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_KNCE) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_KNCE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE, ZYDIS_MVEX_FUNC_UI_32, ZYDIS_MASK_POLICY_ALLOWED ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYDIS_MVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VLOADUNPACKHPD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0xD00), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_KNCE) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_KNCE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE, ZYDIS_MVEX_FUNC_UF_64, ZYDIS_MASK_POLICY_ALLOWED ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYDIS_MVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VLOADUNPACKHPS ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0xCDC), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_KNCE) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_KNCE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE, ZYDIS_MVEX_FUNC_UF_32, ZYDIS_MASK_POLICY_ALLOWED ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYDIS_MVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VLOADUNPACKHQ ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1AA9), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_KNCE) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_KNCE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE, ZYDIS_MVEX_FUNC_UI_64, ZYDIS_MASK_POLICY_ALLOWED ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYDIS_MVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VLOADUNPACKLD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0xCE4), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_KNCE) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_KNCE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE, ZYDIS_MVEX_FUNC_UI_32, ZYDIS_MASK_POLICY_ALLOWED ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYDIS_MVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VLOADUNPACKLPD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0xD00), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_KNCE) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_KNCE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE, ZYDIS_MVEX_FUNC_UF_64, ZYDIS_MASK_POLICY_ALLOWED ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYDIS_MVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VLOADUNPACKLPS ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0xCDC), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_KNCE) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_KNCE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE, ZYDIS_MVEX_FUNC_UF_32, ZYDIS_MASK_POLICY_ALLOWED ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYDIS_MVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VLOADUNPACKLQ ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1AA9), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_KNCE) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_KNCE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE, ZYDIS_MVEX_FUNC_UI_64, ZYDIS_MASK_POLICY_ALLOWED ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYDIS_MVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VLOG2PS ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0xD10), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_KNC) ZYDIS_NOTMIN(ZYDIS_ISA_SET_KNCE) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_KNCE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE, ZYDIS_MVEX_FUNC_INVALID, ZYDIS_MASK_POLICY_ALLOWED ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYDIS_MVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VLOG2PS ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0xD10), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_KNC) ZYDIS_NOTMIN(ZYDIS_ISA_SET_KNCE) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_KNCE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE, ZYDIS_MVEX_FUNC_SAE, ZYDIS_MASK_POLICY_ALLOWED ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYDIS_MVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VLOG2PS ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0xD14), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_KNC) ZYDIS_NOTMIN(ZYDIS_ISA_SET_KNCE) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_KNCE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE, ZYDIS_MVEX_FUNC_F_32, ZYDIS_MASK_POLICY_ALLOWED ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYDIS_MVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VMOVAPD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0xCFC), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_KNCE) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_KNCE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE, ZYDIS_MVEX_FUNC_SWIZZLE_64, ZYDIS_MASK_POLICY_ALLOWED ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYDIS_MVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VMOVAPD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0xCFC), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_KNCE) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_KNCE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE, ZYDIS_MVEX_FUNC_INVALID, ZYDIS_MASK_POLICY_ALLOWED ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYDIS_MVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VMOVAPD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0xD00), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_KNCE) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_KNCE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE, ZYDIS_MVEX_FUNC_UF_64, ZYDIS_MASK_POLICY_ALLOWED ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYDIS_MVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VMOVAPD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1AB8), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_KNCE) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_KNCE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE, ZYDIS_MVEX_FUNC_DF_64, ZYDIS_MASK_POLICY_ALLOWED ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYDIS_MVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VMOVAPS ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0xD04), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_KNCE) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_KNCE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE, ZYDIS_MVEX_FUNC_SWIZZLE_32, ZYDIS_MASK_POLICY_ALLOWED ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYDIS_MVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VMOVAPS ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0xD04), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_KNCE) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_KNCE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE, ZYDIS_MVEX_FUNC_INVALID, ZYDIS_MASK_POLICY_ALLOWED ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYDIS_MVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VMOVAPS ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0xCDC), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_KNCE) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_KNCE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE, ZYDIS_MVEX_FUNC_UF_32, ZYDIS_MASK_POLICY_ALLOWED ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYDIS_MVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VMOVAPS ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1ABB), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_KNCE) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_KNCE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE, ZYDIS_MVEX_FUNC_DF_32, ZYDIS_MASK_POLICY_ALLOWED ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYDIS_MVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VMOVDQA32 ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0xD10), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_KNCE) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_KNCE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE, ZYDIS_MVEX_FUNC_SWIZZLE_32, ZYDIS_MASK_POLICY_ALLOWED ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYDIS_MVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VMOVDQA32 ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0xD10), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_KNCE) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_KNCE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE, ZYDIS_MVEX_FUNC_INVALID, ZYDIS_MASK_POLICY_ALLOWED ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYDIS_MVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VMOVDQA32 ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0xCE4), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_KNCE) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_KNCE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE, ZYDIS_MVEX_FUNC_UI_32, ZYDIS_MASK_POLICY_ALLOWED ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYDIS_MVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VMOVDQA32 ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1ABE), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_KNCE) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_KNCE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE, ZYDIS_MVEX_FUNC_DI_32, ZYDIS_MASK_POLICY_ALLOWED ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYDIS_MVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VMOVDQA64 ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1AC1), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_KNCE) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_KNCE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE, ZYDIS_MVEX_FUNC_SWIZZLE_64, ZYDIS_MASK_POLICY_ALLOWED ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYDIS_MVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VMOVDQA64 ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1AC1), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_KNCE) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_KNCE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE, ZYDIS_MVEX_FUNC_INVALID, ZYDIS_MASK_POLICY_ALLOWED ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYDIS_MVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VMOVDQA64 ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1AA9), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_KNCE) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_KNCE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE, ZYDIS_MVEX_FUNC_UI_64, ZYDIS_MASK_POLICY_ALLOWED ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYDIS_MVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VMOVDQA64 ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1AC4), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_KNCE) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_KNCE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE, ZYDIS_MVEX_FUNC_DI_64, ZYDIS_MASK_POLICY_ALLOWED ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYDIS_MVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VMOVNRAPD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1AC7), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_KNCSTREAM) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_KNCE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE, ZYDIS_MVEX_FUNC_DF_64, ZYDIS_MASK_POLICY_ALLOWED ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYDIS_MVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VMOVNRAPS ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1ACA), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_KNCSTREAM) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_KNCE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE, ZYDIS_MVEX_FUNC_DF_32, ZYDIS_MASK_POLICY_ALLOWED ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYDIS_MVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VMOVNRNGOAPD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1AC7), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_KNCSTREAM) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_KNCE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE, ZYDIS_MVEX_FUNC_DF_64, ZYDIS_MASK_POLICY_ALLOWED ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYDIS_MVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VMOVNRNGOAPS ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1ACA), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_KNCSTREAM) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_KNCE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE, ZYDIS_MVEX_FUNC_DF_32, ZYDIS_MASK_POLICY_ALLOWED ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYDIS_MVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VMULPD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xCC4), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_KNC) ZYDIS_NOTMIN(ZYDIS_ISA_SET_KNCE) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_KNCE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE, ZYDIS_MVEX_FUNC_SWIZZLE_64, ZYDIS_MASK_POLICY_ALLOWED ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYDIS_MVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VMULPD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xCC4), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_KNC) ZYDIS_NOTMIN(ZYDIS_ISA_SET_KNCE) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_KNCE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE, ZYDIS_MVEX_FUNC_RC, ZYDIS_MASK_POLICY_ALLOWED ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYDIS_MVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VMULPD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xCC8), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_KNC) ZYDIS_NOTMIN(ZYDIS_ISA_SET_KNCE) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_KNCE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE, ZYDIS_MVEX_FUNC_SF_64, ZYDIS_MASK_POLICY_ALLOWED ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYDIS_MVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VMULPS ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x4FA), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_KNC) ZYDIS_NOTMIN(ZYDIS_ISA_SET_KNCE) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_KNCE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE, ZYDIS_MVEX_FUNC_SWIZZLE_32, ZYDIS_MASK_POLICY_ALLOWED ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYDIS_MVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VMULPS ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x4FA), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_KNC) ZYDIS_NOTMIN(ZYDIS_ISA_SET_KNCE) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_KNCE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE, ZYDIS_MVEX_FUNC_RC, ZYDIS_MASK_POLICY_ALLOWED ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYDIS_MVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VMULPS ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xCCC), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_KNC) ZYDIS_NOTMIN(ZYDIS_ISA_SET_KNCE) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_KNCE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE, ZYDIS_MVEX_FUNC_SF_32, ZYDIS_MASK_POLICY_ALLOWED ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYDIS_MVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPACKSTOREHD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1ABE), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_KNCE) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_KNCE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE, ZYDIS_MVEX_FUNC_DI_32, ZYDIS_MASK_POLICY_ALLOWED ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYDIS_MVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPACKSTOREHPD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1ACD), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_KNCE) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_KNCE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE, ZYDIS_MVEX_FUNC_DF_64, ZYDIS_MASK_POLICY_ALLOWED ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYDIS_MVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPACKSTOREHPS ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1ABB), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_KNCE) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_KNCE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE, ZYDIS_MVEX_FUNC_DF_32, ZYDIS_MASK_POLICY_ALLOWED ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYDIS_MVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPACKSTOREHQ ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1AD0), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_KNCE) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_KNCE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE, ZYDIS_MVEX_FUNC_DI_64, ZYDIS_MASK_POLICY_ALLOWED ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYDIS_MVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPACKSTORELD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1ABE), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_KNCE) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_KNCE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE, ZYDIS_MVEX_FUNC_DI_32, ZYDIS_MASK_POLICY_ALLOWED ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYDIS_MVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPACKSTORELPD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1ACD), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_KNCE) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_KNCE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE, ZYDIS_MVEX_FUNC_DF_64, ZYDIS_MASK_POLICY_ALLOWED ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYDIS_MVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPACKSTORELPS ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1ABB), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_KNCE) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_KNCE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE, ZYDIS_MVEX_FUNC_DF_32, ZYDIS_MASK_POLICY_ALLOWED ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYDIS_MVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPACKSTORELQ ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1AD0), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_DATAXFER) ZYDIS_NOTMIN(ZYDIS_ISA_SET_KNCE) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_KNCE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE, ZYDIS_MVEX_FUNC_DI_64, ZYDIS_MASK_POLICY_ALLOWED ZYDIS_NOTMIN(ZYAN_TRUE) ZYDIS_NOTMIN(ZYDIS_MVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPADCD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xD08), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_KNC) ZYDIS_NOTMIN(ZYDIS_ISA_SET_KNCE) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_KNCE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_MASK, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE, ZYDIS_MVEX_FUNC_SWIZZLE_32, ZYDIS_MASK_POLICY_ALLOWED ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYDIS_MVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPADCD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xD08), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_KNC) ZYDIS_NOTMIN(ZYDIS_ISA_SET_KNCE) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_KNCE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_MASK, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE, ZYDIS_MVEX_FUNC_INVALID, ZYDIS_MASK_POLICY_ALLOWED ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYDIS_MVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPADCD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xD0C), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_KNC) ZYDIS_NOTMIN(ZYDIS_ISA_SET_KNCE) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_KNCE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_MASK, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE, ZYDIS_MVEX_FUNC_SI_32, ZYDIS_MASK_POLICY_ALLOWED ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYDIS_MVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPADDD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x4FA), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_KNC) ZYDIS_NOTMIN(ZYDIS_ISA_SET_KNCE) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_KNCE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE, ZYDIS_MVEX_FUNC_SWIZZLE_32, ZYDIS_MASK_POLICY_ALLOWED ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYDIS_MVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPADDD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x4FA), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_KNC) ZYDIS_NOTMIN(ZYDIS_ISA_SET_KNCE) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_KNCE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE, ZYDIS_MVEX_FUNC_IGNORED, ZYDIS_MASK_POLICY_ALLOWED ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYDIS_MVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPADDD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xCCC), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_KNC) ZYDIS_NOTMIN(ZYDIS_ISA_SET_KNCE) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_KNCE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE, ZYDIS_MVEX_FUNC_SI_32, ZYDIS_MASK_POLICY_ALLOWED ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYDIS_MVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPADDSETCD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xD08), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_KNC) ZYDIS_NOTMIN(ZYDIS_ISA_SET_KNCE) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_KNCE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_MASK, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE, ZYDIS_MVEX_FUNC_SWIZZLE_32, ZYDIS_MASK_POLICY_ALLOWED ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYDIS_MVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPADDSETCD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xD08), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_KNC) ZYDIS_NOTMIN(ZYDIS_ISA_SET_KNCE) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_KNCE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_MASK, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE, ZYDIS_MVEX_FUNC_INVALID, ZYDIS_MASK_POLICY_ALLOWED ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYDIS_MVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPADDSETCD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xD0C), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_KNC) ZYDIS_NOTMIN(ZYDIS_ISA_SET_KNCE) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_KNCE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_MASK, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE, ZYDIS_MVEX_FUNC_SI_32, ZYDIS_MASK_POLICY_ALLOWED ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYDIS_MVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPADDSETSD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xCD0), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_KNC) ZYDIS_NOTMIN(ZYDIS_ISA_SET_KNCE) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_KNCE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE, ZYDIS_MVEX_FUNC_SWIZZLE_32, ZYDIS_MASK_POLICY_ALLOWED ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYDIS_MVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPADDSETSD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xCD0), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_KNC) ZYDIS_NOTMIN(ZYDIS_ISA_SET_KNCE) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_KNCE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE, ZYDIS_MVEX_FUNC_IGNORED, ZYDIS_MASK_POLICY_ALLOWED ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYDIS_MVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPADDSETSD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xCD4), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_KNC) ZYDIS_NOTMIN(ZYDIS_ISA_SET_KNCE) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_KNCE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE, ZYDIS_MVEX_FUNC_SI_32, ZYDIS_MASK_POLICY_ALLOWED ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYDIS_MVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPANDD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x4FA), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_KNC) ZYDIS_NOTMIN(ZYDIS_ISA_SET_KNCE) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_KNCE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE, ZYDIS_MVEX_FUNC_SWIZZLE_32, ZYDIS_MASK_POLICY_ALLOWED ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYDIS_MVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPANDD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x4FA), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_KNC) ZYDIS_NOTMIN(ZYDIS_ISA_SET_KNCE) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_KNCE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE, ZYDIS_MVEX_FUNC_IGNORED, ZYDIS_MASK_POLICY_ALLOWED ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYDIS_MVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPANDD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xCCC), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_KNC) ZYDIS_NOTMIN(ZYDIS_ISA_SET_KNCE) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_KNCE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE, ZYDIS_MVEX_FUNC_SI_32, ZYDIS_MASK_POLICY_ALLOWED ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYDIS_MVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPANDND ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x4FA), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_KNC) ZYDIS_NOTMIN(ZYDIS_ISA_SET_KNCE) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_KNCE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE, ZYDIS_MVEX_FUNC_SWIZZLE_32, ZYDIS_MASK_POLICY_ALLOWED ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYDIS_MVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPANDND ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x4FA), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_KNC) ZYDIS_NOTMIN(ZYDIS_ISA_SET_KNCE) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_KNCE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE, ZYDIS_MVEX_FUNC_IGNORED, ZYDIS_MASK_POLICY_ALLOWED ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYDIS_MVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPANDND ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xCCC), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_KNC) ZYDIS_NOTMIN(ZYDIS_ISA_SET_KNCE) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_KNCE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE, ZYDIS_MVEX_FUNC_SI_32, ZYDIS_MASK_POLICY_ALLOWED ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYDIS_MVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPANDNQ ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xCC4), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_KNC) ZYDIS_NOTMIN(ZYDIS_ISA_SET_KNCE) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_KNCE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE, ZYDIS_MVEX_FUNC_SWIZZLE_64, ZYDIS_MASK_POLICY_ALLOWED ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYDIS_MVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPANDNQ ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xCC4), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_KNC) ZYDIS_NOTMIN(ZYDIS_ISA_SET_KNCE) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_KNCE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE, ZYDIS_MVEX_FUNC_IGNORED, ZYDIS_MASK_POLICY_ALLOWED ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYDIS_MVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPANDNQ ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xCC8), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_KNC) ZYDIS_NOTMIN(ZYDIS_ISA_SET_KNCE) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_KNCE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE, ZYDIS_MVEX_FUNC_SI_64, ZYDIS_MASK_POLICY_ALLOWED ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYDIS_MVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPANDQ ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xCC4), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_KNC) ZYDIS_NOTMIN(ZYDIS_ISA_SET_KNCE) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_KNCE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE, ZYDIS_MVEX_FUNC_SWIZZLE_64, ZYDIS_MASK_POLICY_ALLOWED ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYDIS_MVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPANDQ ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xCC4), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_KNC) ZYDIS_NOTMIN(ZYDIS_ISA_SET_KNCE) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_KNCE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE, ZYDIS_MVEX_FUNC_IGNORED, ZYDIS_MASK_POLICY_ALLOWED ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYDIS_MVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPANDQ ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xCC8), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_KNC) ZYDIS_NOTMIN(ZYDIS_ISA_SET_KNCE) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_KNCE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE, ZYDIS_MVEX_FUNC_SI_64, ZYDIS_MASK_POLICY_ALLOWED ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYDIS_MVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPBLENDMD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x4FA), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_BLEND) ZYDIS_NOTMIN(ZYDIS_ISA_SET_KNCE) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_KNCE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE, ZYDIS_MVEX_FUNC_SWIZZLE_32, ZYDIS_MASK_POLICY_ALLOWED ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYDIS_MVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPBLENDMD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x4FA), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_BLEND) ZYDIS_NOTMIN(ZYDIS_ISA_SET_KNCE) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_KNCE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE, ZYDIS_MVEX_FUNC_IGNORED, ZYDIS_MASK_POLICY_ALLOWED ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYDIS_MVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPBLENDMD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xCCC), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_BLEND) ZYDIS_NOTMIN(ZYDIS_ISA_SET_KNCE) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_KNCE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE, ZYDIS_MVEX_FUNC_SI_32, ZYDIS_MASK_POLICY_ALLOWED ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYDIS_MVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPBLENDMQ ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xCC4), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_BLEND) ZYDIS_NOTMIN(ZYDIS_ISA_SET_KNCE) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_KNCE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE, ZYDIS_MVEX_FUNC_SWIZZLE_64, ZYDIS_MASK_POLICY_ALLOWED ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYDIS_MVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPBLENDMQ ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xCC4), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_BLEND) ZYDIS_NOTMIN(ZYDIS_ISA_SET_KNCE) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_KNCE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE, ZYDIS_MVEX_FUNC_IGNORED, ZYDIS_MASK_POLICY_ALLOWED ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYDIS_MVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPBLENDMQ ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xCC8), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_BLEND) ZYDIS_NOTMIN(ZYDIS_ISA_SET_KNCE) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_KNCE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE, ZYDIS_MVEX_FUNC_SI_64, ZYDIS_MASK_POLICY_ALLOWED ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYDIS_MVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPBROADCASTD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0xCE4), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_BROADCAST) ZYDIS_NOTMIN(ZYDIS_ISA_SET_KNCE) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_KNCE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE, ZYDIS_MVEX_FUNC_UI_32, ZYDIS_MASK_POLICY_ALLOWED ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYDIS_MVEX_STATIC_BROADCAST_1_TO_16) },
    { ZYDIS_MNEMONIC_VPBROADCASTQ ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1AA9), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_BROADCAST) ZYDIS_NOTMIN(ZYDIS_ISA_SET_KNCE) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_KNCE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE, ZYDIS_MVEX_FUNC_UF_64, ZYDIS_MASK_POLICY_ALLOWED ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYDIS_MVEX_STATIC_BROADCAST_1_TO_8) },
    { ZYDIS_MNEMONIC_VPCMPD ZYDIS_NOTMIN(5) ZYDIS_NOTMIN(5) ZYDIS_NOTMIN(0x518), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_KNC) ZYDIS_NOTMIN(ZYDIS_ISA_SET_KNCE) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_KNCE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_MASK, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE, ZYDIS_MVEX_FUNC_SWIZZLE_64, ZYDIS_MASK_POLICY_ALLOWED ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYDIS_MVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPCMPD ZYDIS_NOTMIN(5) ZYDIS_NOTMIN(5) ZYDIS_NOTMIN(0x518), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_KNC) ZYDIS_NOTMIN(ZYDIS_ISA_SET_KNCE) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_KNCE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_MASK, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE, ZYDIS_MVEX_FUNC_INVALID, ZYDIS_MASK_POLICY_ALLOWED ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYDIS_MVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPCMPD ZYDIS_NOTMIN(5) ZYDIS_NOTMIN(5) ZYDIS_NOTMIN(0x51D), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_KNC) ZYDIS_NOTMIN(ZYDIS_ISA_SET_KNCE) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_KNCE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_MASK, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE, ZYDIS_MVEX_FUNC_SI_32, ZYDIS_MASK_POLICY_ALLOWED ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYDIS_MVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPCMPEQD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x518), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_KNC) ZYDIS_NOTMIN(ZYDIS_ISA_SET_KNCE) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_KNCE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_MASK, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE, ZYDIS_MVEX_FUNC_SWIZZLE_64, ZYDIS_MASK_POLICY_ALLOWED ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYDIS_MVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPCMPEQD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x518), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_KNC) ZYDIS_NOTMIN(ZYDIS_ISA_SET_KNCE) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_KNCE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_MASK, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE, ZYDIS_MVEX_FUNC_INVALID, ZYDIS_MASK_POLICY_ALLOWED ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYDIS_MVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPCMPEQD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x51D), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_KNC) ZYDIS_NOTMIN(ZYDIS_ISA_SET_KNCE) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_KNCE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_MASK, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE, ZYDIS_MVEX_FUNC_SI_32, ZYDIS_MASK_POLICY_ALLOWED ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYDIS_MVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPCMPGTD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x518), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_KNC) ZYDIS_NOTMIN(ZYDIS_ISA_SET_KNCE) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_KNCE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_MASK, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE, ZYDIS_MVEX_FUNC_SWIZZLE_64, ZYDIS_MASK_POLICY_ALLOWED ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYDIS_MVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPCMPGTD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x518), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_KNC) ZYDIS_NOTMIN(ZYDIS_ISA_SET_KNCE) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_KNCE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_MASK, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE, ZYDIS_MVEX_FUNC_INVALID, ZYDIS_MASK_POLICY_ALLOWED ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYDIS_MVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPCMPGTD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x51D), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_KNC) ZYDIS_NOTMIN(ZYDIS_ISA_SET_KNCE) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_KNCE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_MASK, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE, ZYDIS_MVEX_FUNC_SI_32, ZYDIS_MASK_POLICY_ALLOWED ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYDIS_MVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPCMPLTD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x518), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_KNC) ZYDIS_NOTMIN(ZYDIS_ISA_SET_KNCE) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_KNCE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_MASK, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE, ZYDIS_MVEX_FUNC_SWIZZLE_64, ZYDIS_MASK_POLICY_ALLOWED ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYDIS_MVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPCMPLTD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x518), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_KNC) ZYDIS_NOTMIN(ZYDIS_ISA_SET_KNCE) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_KNCE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_MASK, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE, ZYDIS_MVEX_FUNC_INVALID, ZYDIS_MASK_POLICY_ALLOWED ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYDIS_MVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPCMPLTD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x51D), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_KNC) ZYDIS_NOTMIN(ZYDIS_ISA_SET_KNCE) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_KNCE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_MASK, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE, ZYDIS_MVEX_FUNC_SI_32, ZYDIS_MASK_POLICY_ALLOWED ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYDIS_MVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPCMPUD ZYDIS_NOTMIN(5) ZYDIS_NOTMIN(5) ZYDIS_NOTMIN(0x522), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_KNC) ZYDIS_NOTMIN(ZYDIS_ISA_SET_KNCE) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_KNCE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_MASK, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE, ZYDIS_MVEX_FUNC_SWIZZLE_64, ZYDIS_MASK_POLICY_ALLOWED ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYDIS_MVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPCMPUD ZYDIS_NOTMIN(5) ZYDIS_NOTMIN(5) ZYDIS_NOTMIN(0x522), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_KNC) ZYDIS_NOTMIN(ZYDIS_ISA_SET_KNCE) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_KNCE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_MASK, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE, ZYDIS_MVEX_FUNC_INVALID, ZYDIS_MASK_POLICY_ALLOWED ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYDIS_MVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPCMPUD ZYDIS_NOTMIN(5) ZYDIS_NOTMIN(5) ZYDIS_NOTMIN(0x527), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_KNC) ZYDIS_NOTMIN(ZYDIS_ISA_SET_KNCE) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_KNCE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_MASK, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE, ZYDIS_MVEX_FUNC_SI_32, ZYDIS_MASK_POLICY_ALLOWED ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYDIS_MVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPERMD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x4FA), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_KNC) ZYDIS_NOTMIN(ZYDIS_ISA_SET_KNCE) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_KNCE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE, ZYDIS_MVEX_FUNC_INVALID, ZYDIS_MASK_POLICY_ALLOWED ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYDIS_MVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPERMD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x4FF), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_KNC) ZYDIS_NOTMIN(ZYDIS_ISA_SET_KNCE) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_KNCE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE, ZYDIS_MVEX_FUNC_F_64, ZYDIS_MASK_POLICY_ALLOWED ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYDIS_MVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPERMF32X4 ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xD10), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_KNC) ZYDIS_NOTMIN(ZYDIS_ISA_SET_KNCE) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_KNCE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE, ZYDIS_MVEX_FUNC_INVALID, ZYDIS_MASK_POLICY_ALLOWED ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYDIS_MVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPERMF32X4 ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xD10), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_KNC) ZYDIS_NOTMIN(ZYDIS_ISA_SET_KNCE) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_KNCE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE, ZYDIS_MVEX_FUNC_INVALID, ZYDIS_MASK_POLICY_ALLOWED ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYDIS_MVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPERMF32X4 ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xD14), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_KNC) ZYDIS_NOTMIN(ZYDIS_ISA_SET_KNCE) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_KNCE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE, ZYDIS_MVEX_FUNC_F_64, ZYDIS_MASK_POLICY_ALLOWED ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYDIS_MVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPGATHERDD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1AD3), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_KNC) ZYDIS_NOTMIN(ZYDIS_ISA_SET_KNCE) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_KNCE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_VSIB | (1 << 3) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_TRUE, ZYAN_FALSE, ZYAN_FALSE, ZYDIS_MVEX_FUNC_UI_32, ZYDIS_MASK_POLICY_ALLOWED ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYDIS_MVEX_STATIC_BROADCAST_1_TO_16) },
    { ZYDIS_MNEMONIC_VPGATHERDQ ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1AD6), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_KNC) ZYDIS_NOTMIN(ZYDIS_ISA_SET_KNCE) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_KNCE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_VSIB | (1 << 3) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_TRUE, ZYAN_FALSE, ZYAN_FALSE, ZYDIS_MVEX_FUNC_UI_64, ZYDIS_MASK_POLICY_ALLOWED ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYDIS_MVEX_STATIC_BROADCAST_1_TO_8) },
    { ZYDIS_MNEMONIC_VPMADD231D ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x4FA), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_KNC) ZYDIS_NOTMIN(ZYDIS_ISA_SET_KNCE) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_KNCE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE, ZYDIS_MVEX_FUNC_SWIZZLE_32, ZYDIS_MASK_POLICY_ALLOWED ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYDIS_MVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPMADD231D ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x4FA), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_KNC) ZYDIS_NOTMIN(ZYDIS_ISA_SET_KNCE) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_KNCE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE, ZYDIS_MVEX_FUNC_IGNORED, ZYDIS_MASK_POLICY_ALLOWED ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYDIS_MVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPMADD231D ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xCCC), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_KNC) ZYDIS_NOTMIN(ZYDIS_ISA_SET_KNCE) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_KNCE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE, ZYDIS_MVEX_FUNC_SI_32, ZYDIS_MASK_POLICY_ALLOWED ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYDIS_MVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPMADD233D ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x4FA), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_KNC) ZYDIS_NOTMIN(ZYDIS_ISA_SET_KNCE) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_KNCE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE, ZYDIS_MVEX_FUNC_SWIZZLE_32, ZYDIS_MASK_POLICY_ALLOWED ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYDIS_MVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPMADD233D ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x4FA), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_KNC) ZYDIS_NOTMIN(ZYDIS_ISA_SET_KNCE) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_KNCE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE, ZYDIS_MVEX_FUNC_IGNORED, ZYDIS_MASK_POLICY_ALLOWED ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYDIS_MVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPMADD233D ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xCCC), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_KNC) ZYDIS_NOTMIN(ZYDIS_ISA_SET_KNCE) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_KNCE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE, ZYDIS_MVEX_FUNC_SI_32_BCST_4TO16, ZYDIS_MASK_POLICY_ALLOWED ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYDIS_MVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPMAXSD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x4FA), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_KNC) ZYDIS_NOTMIN(ZYDIS_ISA_SET_KNCE) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_KNCE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE, ZYDIS_MVEX_FUNC_SWIZZLE_32, ZYDIS_MASK_POLICY_ALLOWED ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYDIS_MVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPMAXSD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x4FA), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_KNC) ZYDIS_NOTMIN(ZYDIS_ISA_SET_KNCE) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_KNCE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE, ZYDIS_MVEX_FUNC_IGNORED, ZYDIS_MASK_POLICY_ALLOWED ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYDIS_MVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPMAXSD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xCCC), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_KNC) ZYDIS_NOTMIN(ZYDIS_ISA_SET_KNCE) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_KNCE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE, ZYDIS_MVEX_FUNC_SI_32, ZYDIS_MASK_POLICY_ALLOWED ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYDIS_MVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPMAXUD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x4FA), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_KNC) ZYDIS_NOTMIN(ZYDIS_ISA_SET_KNCE) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_KNCE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE, ZYDIS_MVEX_FUNC_SWIZZLE_32, ZYDIS_MASK_POLICY_ALLOWED ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYDIS_MVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPMAXUD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x4FA), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_KNC) ZYDIS_NOTMIN(ZYDIS_ISA_SET_KNCE) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_KNCE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE, ZYDIS_MVEX_FUNC_IGNORED, ZYDIS_MASK_POLICY_ALLOWED ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYDIS_MVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPMAXUD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xCCC), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_KNC) ZYDIS_NOTMIN(ZYDIS_ISA_SET_KNCE) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_KNCE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE, ZYDIS_MVEX_FUNC_SI_32, ZYDIS_MASK_POLICY_ALLOWED ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYDIS_MVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPMINSD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x4FA), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_KNC) ZYDIS_NOTMIN(ZYDIS_ISA_SET_KNCE) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_KNCE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE, ZYDIS_MVEX_FUNC_SWIZZLE_32, ZYDIS_MASK_POLICY_ALLOWED ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYDIS_MVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPMINSD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x4FA), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_KNC) ZYDIS_NOTMIN(ZYDIS_ISA_SET_KNCE) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_KNCE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE, ZYDIS_MVEX_FUNC_IGNORED, ZYDIS_MASK_POLICY_ALLOWED ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYDIS_MVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPMINSD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xCCC), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_KNC) ZYDIS_NOTMIN(ZYDIS_ISA_SET_KNCE) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_KNCE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE, ZYDIS_MVEX_FUNC_SI_32, ZYDIS_MASK_POLICY_ALLOWED ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYDIS_MVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPMINUD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x4FA), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_KNC) ZYDIS_NOTMIN(ZYDIS_ISA_SET_KNCE) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_KNCE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE, ZYDIS_MVEX_FUNC_SWIZZLE_32, ZYDIS_MASK_POLICY_ALLOWED ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYDIS_MVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPMINUD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x4FA), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_KNC) ZYDIS_NOTMIN(ZYDIS_ISA_SET_KNCE) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_KNCE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE, ZYDIS_MVEX_FUNC_IGNORED, ZYDIS_MASK_POLICY_ALLOWED ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYDIS_MVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPMINUD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xCCC), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_KNC) ZYDIS_NOTMIN(ZYDIS_ISA_SET_KNCE) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_KNCE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE, ZYDIS_MVEX_FUNC_SI_32, ZYDIS_MASK_POLICY_ALLOWED ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYDIS_MVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPMULHD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x4FA), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_KNC) ZYDIS_NOTMIN(ZYDIS_ISA_SET_KNCE) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_KNCE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE, ZYDIS_MVEX_FUNC_SWIZZLE_32, ZYDIS_MASK_POLICY_ALLOWED ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYDIS_MVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPMULHD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x4FA), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_KNC) ZYDIS_NOTMIN(ZYDIS_ISA_SET_KNCE) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_KNCE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE, ZYDIS_MVEX_FUNC_IGNORED, ZYDIS_MASK_POLICY_ALLOWED ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYDIS_MVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPMULHD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xCCC), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_KNC) ZYDIS_NOTMIN(ZYDIS_ISA_SET_KNCE) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_KNCE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE, ZYDIS_MVEX_FUNC_SI_32, ZYDIS_MASK_POLICY_ALLOWED ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYDIS_MVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPMULHUD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x4FA), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_KNC) ZYDIS_NOTMIN(ZYDIS_ISA_SET_KNCE) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_KNCE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE, ZYDIS_MVEX_FUNC_SWIZZLE_32, ZYDIS_MASK_POLICY_ALLOWED ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYDIS_MVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPMULHUD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x4FA), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_KNC) ZYDIS_NOTMIN(ZYDIS_ISA_SET_KNCE) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_KNCE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE, ZYDIS_MVEX_FUNC_IGNORED, ZYDIS_MASK_POLICY_ALLOWED ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYDIS_MVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPMULHUD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xCCC), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_KNC) ZYDIS_NOTMIN(ZYDIS_ISA_SET_KNCE) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_KNCE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE, ZYDIS_MVEX_FUNC_SI_32, ZYDIS_MASK_POLICY_ALLOWED ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYDIS_MVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPMULLD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x4FA), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_KNC) ZYDIS_NOTMIN(ZYDIS_ISA_SET_KNCE) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_KNCE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE, ZYDIS_MVEX_FUNC_SWIZZLE_32, ZYDIS_MASK_POLICY_ALLOWED ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYDIS_MVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPMULLD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x4FA), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_KNC) ZYDIS_NOTMIN(ZYDIS_ISA_SET_KNCE) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_KNCE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE, ZYDIS_MVEX_FUNC_IGNORED, ZYDIS_MASK_POLICY_ALLOWED ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYDIS_MVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPMULLD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xCCC), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_KNC) ZYDIS_NOTMIN(ZYDIS_ISA_SET_KNCE) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_KNCE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE, ZYDIS_MVEX_FUNC_SI_32, ZYDIS_MASK_POLICY_ALLOWED ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYDIS_MVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPORD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x4FA), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_KNC) ZYDIS_NOTMIN(ZYDIS_ISA_SET_KNCE) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_KNCE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE, ZYDIS_MVEX_FUNC_SWIZZLE_32, ZYDIS_MASK_POLICY_ALLOWED ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYDIS_MVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPORD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x4FA), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_KNC) ZYDIS_NOTMIN(ZYDIS_ISA_SET_KNCE) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_KNCE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE, ZYDIS_MVEX_FUNC_IGNORED, ZYDIS_MASK_POLICY_ALLOWED ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYDIS_MVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPORD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xCCC), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_KNC) ZYDIS_NOTMIN(ZYDIS_ISA_SET_KNCE) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_KNCE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE, ZYDIS_MVEX_FUNC_SI_32, ZYDIS_MASK_POLICY_ALLOWED ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYDIS_MVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPORQ ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xCC4), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_KNC) ZYDIS_NOTMIN(ZYDIS_ISA_SET_KNCE) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_KNCE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE, ZYDIS_MVEX_FUNC_SWIZZLE_64, ZYDIS_MASK_POLICY_ALLOWED ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYDIS_MVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPORQ ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xCC4), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_KNC) ZYDIS_NOTMIN(ZYDIS_ISA_SET_KNCE) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_KNCE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE, ZYDIS_MVEX_FUNC_IGNORED, ZYDIS_MASK_POLICY_ALLOWED ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYDIS_MVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPORQ ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xCC8), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_KNC) ZYDIS_NOTMIN(ZYDIS_ISA_SET_KNCE) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_KNCE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE, ZYDIS_MVEX_FUNC_SI_64, ZYDIS_MASK_POLICY_ALLOWED ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYDIS_MVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPREFETCH0 ZYDIS_NOTMIN(1) ZYDIS_NOTMIN(1) ZYDIS_NOTMIN(0x1F02), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_PREFETCH) ZYDIS_NOTMIN(ZYDIS_ISA_SET_KNCE) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_KNCE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE, ZYDIS_MVEX_FUNC_F_64, ZYDIS_MASK_POLICY_INVALID ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYDIS_MVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPREFETCH1 ZYDIS_NOTMIN(1) ZYDIS_NOTMIN(1) ZYDIS_NOTMIN(0x1F02), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_PREFETCH) ZYDIS_NOTMIN(ZYDIS_ISA_SET_KNCE) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_KNCE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE, ZYDIS_MVEX_FUNC_F_64, ZYDIS_MASK_POLICY_INVALID ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYDIS_MVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPREFETCH2 ZYDIS_NOTMIN(1) ZYDIS_NOTMIN(1) ZYDIS_NOTMIN(0x1F02), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_PREFETCH) ZYDIS_NOTMIN(ZYDIS_ISA_SET_KNCE) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_KNCE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE, ZYDIS_MVEX_FUNC_F_64, ZYDIS_MASK_POLICY_INVALID ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYDIS_MVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPREFETCHE0 ZYDIS_NOTMIN(1) ZYDIS_NOTMIN(1) ZYDIS_NOTMIN(0x1F02), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_PREFETCH) ZYDIS_NOTMIN(ZYDIS_ISA_SET_KNCE) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_KNCE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE, ZYDIS_MVEX_FUNC_F_64, ZYDIS_MASK_POLICY_INVALID ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYDIS_MVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPREFETCHE1 ZYDIS_NOTMIN(1) ZYDIS_NOTMIN(1) ZYDIS_NOTMIN(0x1F02), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_PREFETCH) ZYDIS_NOTMIN(ZYDIS_ISA_SET_KNCE) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_KNCE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE, ZYDIS_MVEX_FUNC_F_64, ZYDIS_MASK_POLICY_INVALID ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYDIS_MVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPREFETCHE2 ZYDIS_NOTMIN(1) ZYDIS_NOTMIN(1) ZYDIS_NOTMIN(0x1F02), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_PREFETCH) ZYDIS_NOTMIN(ZYDIS_ISA_SET_KNCE) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_KNCE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE, ZYDIS_MVEX_FUNC_F_64, ZYDIS_MASK_POLICY_INVALID ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYDIS_MVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPREFETCHENTA ZYDIS_NOTMIN(1) ZYDIS_NOTMIN(1) ZYDIS_NOTMIN(0x1F02), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_PREFETCH) ZYDIS_NOTMIN(ZYDIS_ISA_SET_KNCE) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_KNCE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE, ZYDIS_MVEX_FUNC_F_64, ZYDIS_MASK_POLICY_INVALID ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYDIS_MVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPREFETCHNTA ZYDIS_NOTMIN(1) ZYDIS_NOTMIN(1) ZYDIS_NOTMIN(0x1F02), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_PREFETCH) ZYDIS_NOTMIN(ZYDIS_ISA_SET_KNCE) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_KNCE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE, ZYDIS_MVEX_FUNC_F_64, ZYDIS_MASK_POLICY_INVALID ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYDIS_MVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPSBBD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xD08), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_KNC) ZYDIS_NOTMIN(ZYDIS_ISA_SET_KNCE) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_KNCE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_MASK, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE, ZYDIS_MVEX_FUNC_SWIZZLE_32, ZYDIS_MASK_POLICY_ALLOWED ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYDIS_MVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPSBBD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xD08), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_KNC) ZYDIS_NOTMIN(ZYDIS_ISA_SET_KNCE) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_KNCE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_MASK, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE, ZYDIS_MVEX_FUNC_INVALID, ZYDIS_MASK_POLICY_ALLOWED ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYDIS_MVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPSBBD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xD0C), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_KNC) ZYDIS_NOTMIN(ZYDIS_ISA_SET_KNCE) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_KNCE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_MASK, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE, ZYDIS_MVEX_FUNC_SI_32, ZYDIS_MASK_POLICY_ALLOWED ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYDIS_MVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPSBBRD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xD08), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_KNC) ZYDIS_NOTMIN(ZYDIS_ISA_SET_KNCE) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_KNCE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_MASK, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE, ZYDIS_MVEX_FUNC_SWIZZLE_32, ZYDIS_MASK_POLICY_ALLOWED ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYDIS_MVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPSBBRD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xD08), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_KNC) ZYDIS_NOTMIN(ZYDIS_ISA_SET_KNCE) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_KNCE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_MASK, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE, ZYDIS_MVEX_FUNC_INVALID, ZYDIS_MASK_POLICY_ALLOWED ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYDIS_MVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPSBBRD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xD0C), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_KNC) ZYDIS_NOTMIN(ZYDIS_ISA_SET_KNCE) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_KNCE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_MASK, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE, ZYDIS_MVEX_FUNC_SI_32, ZYDIS_MASK_POLICY_ALLOWED ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYDIS_MVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPSCATTERDD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1AD9), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_KNC) ZYDIS_NOTMIN(ZYDIS_ISA_SET_KNCE) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_KNCE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_VSIB | (1 << 3) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE, ZYDIS_MVEX_FUNC_DI_32, ZYDIS_MASK_POLICY_ALLOWED ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYDIS_MVEX_STATIC_BROADCAST_1_TO_16) },
    { ZYDIS_MNEMONIC_VPSCATTERDQ ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1ADC), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_KNC) ZYDIS_NOTMIN(ZYDIS_ISA_SET_KNCE) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_KNCE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_VSIB | (1 << 3) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE, ZYDIS_MVEX_FUNC_DI_64, ZYDIS_MASK_POLICY_ALLOWED ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYDIS_MVEX_STATIC_BROADCAST_1_TO_8) },
    { ZYDIS_MNEMONIC_VPSHUFD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xD18), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_KNC) ZYDIS_NOTMIN(ZYDIS_ISA_SET_KNCE) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_KNCE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE, ZYDIS_MVEX_FUNC_INVALID, ZYDIS_MASK_POLICY_ALLOWED ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYDIS_MVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPSHUFD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xD18), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_KNC) ZYDIS_NOTMIN(ZYDIS_ISA_SET_KNCE) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_KNCE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE, ZYDIS_MVEX_FUNC_INVALID, ZYDIS_MASK_POLICY_ALLOWED ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYDIS_MVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPSHUFD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xD1C), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_KNC) ZYDIS_NOTMIN(ZYDIS_ISA_SET_KNCE) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_KNCE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE, ZYDIS_MVEX_FUNC_F_64, ZYDIS_MASK_POLICY_ALLOWED ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYDIS_MVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPSLLD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xD20), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_KNC) ZYDIS_NOTMIN(ZYDIS_ISA_SET_KNCE) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_KNCE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE, ZYDIS_MVEX_FUNC_SWIZZLE_32, ZYDIS_MASK_POLICY_ALLOWED ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYDIS_MVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPSLLD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xD20), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_KNC) ZYDIS_NOTMIN(ZYDIS_ISA_SET_KNCE) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_KNCE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE, ZYDIS_MVEX_FUNC_INVALID, ZYDIS_MASK_POLICY_ALLOWED ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYDIS_MVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPSLLD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xD24), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_KNC) ZYDIS_NOTMIN(ZYDIS_ISA_SET_KNCE) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_KNCE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE, ZYDIS_MVEX_FUNC_SI_32, ZYDIS_MASK_POLICY_ALLOWED ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYDIS_MVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPSLLVD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xD28), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_KNC) ZYDIS_NOTMIN(ZYDIS_ISA_SET_KNCE) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_KNCE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE, ZYDIS_MVEX_FUNC_SWIZZLE_32, ZYDIS_MASK_POLICY_ALLOWED ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYDIS_MVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPSLLVD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xD28), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_KNC) ZYDIS_NOTMIN(ZYDIS_ISA_SET_KNCE) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_KNCE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE, ZYDIS_MVEX_FUNC_IGNORED, ZYDIS_MASK_POLICY_ALLOWED ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYDIS_MVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPSLLVD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xD2C), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_KNC) ZYDIS_NOTMIN(ZYDIS_ISA_SET_KNCE) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_KNCE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE, ZYDIS_MVEX_FUNC_SI_32, ZYDIS_MASK_POLICY_ALLOWED ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYDIS_MVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPSRAD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xD20), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_KNC) ZYDIS_NOTMIN(ZYDIS_ISA_SET_KNCE) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_KNCE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE, ZYDIS_MVEX_FUNC_SWIZZLE_32, ZYDIS_MASK_POLICY_ALLOWED ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYDIS_MVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPSRAD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xD20), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_KNC) ZYDIS_NOTMIN(ZYDIS_ISA_SET_KNCE) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_KNCE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE, ZYDIS_MVEX_FUNC_INVALID, ZYDIS_MASK_POLICY_ALLOWED ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYDIS_MVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPSRAD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xD24), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_KNC) ZYDIS_NOTMIN(ZYDIS_ISA_SET_KNCE) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_KNCE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE, ZYDIS_MVEX_FUNC_SI_32, ZYDIS_MASK_POLICY_ALLOWED ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYDIS_MVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPSRAVD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xD30), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_KNC) ZYDIS_NOTMIN(ZYDIS_ISA_SET_KNCE) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_KNCE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE, ZYDIS_MVEX_FUNC_SWIZZLE_32, ZYDIS_MASK_POLICY_ALLOWED ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYDIS_MVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPSRAVD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xD30), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_KNC) ZYDIS_NOTMIN(ZYDIS_ISA_SET_KNCE) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_KNCE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE, ZYDIS_MVEX_FUNC_IGNORED, ZYDIS_MASK_POLICY_ALLOWED ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYDIS_MVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPSRAVD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xD34), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_KNC) ZYDIS_NOTMIN(ZYDIS_ISA_SET_KNCE) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_KNCE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE, ZYDIS_MVEX_FUNC_SI_32, ZYDIS_MASK_POLICY_ALLOWED ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYDIS_MVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPSRLD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xD20), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_KNC) ZYDIS_NOTMIN(ZYDIS_ISA_SET_KNCE) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_KNCE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE, ZYDIS_MVEX_FUNC_SWIZZLE_32, ZYDIS_MASK_POLICY_ALLOWED ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYDIS_MVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPSRLD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xD20), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_KNC) ZYDIS_NOTMIN(ZYDIS_ISA_SET_KNCE) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_KNCE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE, ZYDIS_MVEX_FUNC_INVALID, ZYDIS_MASK_POLICY_ALLOWED ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYDIS_MVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPSRLD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xD24), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_KNC) ZYDIS_NOTMIN(ZYDIS_ISA_SET_KNCE) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_KNCE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE, ZYDIS_MVEX_FUNC_SI_32, ZYDIS_MASK_POLICY_ALLOWED ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYDIS_MVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPSRLVD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xD28), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_KNC) ZYDIS_NOTMIN(ZYDIS_ISA_SET_KNCE) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_KNCE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE, ZYDIS_MVEX_FUNC_SWIZZLE_32, ZYDIS_MASK_POLICY_ALLOWED ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYDIS_MVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPSRLVD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xD28), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_KNC) ZYDIS_NOTMIN(ZYDIS_ISA_SET_KNCE) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_KNCE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE, ZYDIS_MVEX_FUNC_IGNORED, ZYDIS_MASK_POLICY_ALLOWED ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYDIS_MVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPSRLVD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xD2C), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_KNC) ZYDIS_NOTMIN(ZYDIS_ISA_SET_KNCE) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_KNCE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE, ZYDIS_MVEX_FUNC_SI_32, ZYDIS_MASK_POLICY_ALLOWED ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYDIS_MVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPSUBD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x4FA), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_KNC) ZYDIS_NOTMIN(ZYDIS_ISA_SET_KNCE) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_KNCE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE, ZYDIS_MVEX_FUNC_SWIZZLE_32, ZYDIS_MASK_POLICY_ALLOWED ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYDIS_MVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPSUBD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x4FA), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_KNC) ZYDIS_NOTMIN(ZYDIS_ISA_SET_KNCE) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_KNCE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE, ZYDIS_MVEX_FUNC_IGNORED, ZYDIS_MASK_POLICY_ALLOWED ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYDIS_MVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPSUBD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xCCC), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_KNC) ZYDIS_NOTMIN(ZYDIS_ISA_SET_KNCE) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_KNCE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE, ZYDIS_MVEX_FUNC_SI_32, ZYDIS_MASK_POLICY_ALLOWED ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYDIS_MVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPSUBRD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x4FA), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_KNC) ZYDIS_NOTMIN(ZYDIS_ISA_SET_KNCE) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_KNCE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE, ZYDIS_MVEX_FUNC_SWIZZLE_32, ZYDIS_MASK_POLICY_ALLOWED ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYDIS_MVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPSUBRD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x4FA), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_KNC) ZYDIS_NOTMIN(ZYDIS_ISA_SET_KNCE) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_KNCE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE, ZYDIS_MVEX_FUNC_IGNORED, ZYDIS_MASK_POLICY_ALLOWED ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYDIS_MVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPSUBRD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xCCC), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_KNC) ZYDIS_NOTMIN(ZYDIS_ISA_SET_KNCE) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_KNCE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE, ZYDIS_MVEX_FUNC_SI_32, ZYDIS_MASK_POLICY_ALLOWED ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYDIS_MVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPSUBRSETBD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xD08), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_KNC) ZYDIS_NOTMIN(ZYDIS_ISA_SET_KNCE) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_KNCE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_MASK, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE, ZYDIS_MVEX_FUNC_SWIZZLE_32, ZYDIS_MASK_POLICY_ALLOWED ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYDIS_MVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPSUBRSETBD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xD08), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_KNC) ZYDIS_NOTMIN(ZYDIS_ISA_SET_KNCE) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_KNCE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_MASK, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE, ZYDIS_MVEX_FUNC_INVALID, ZYDIS_MASK_POLICY_ALLOWED ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYDIS_MVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPSUBRSETBD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xD0C), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_KNC) ZYDIS_NOTMIN(ZYDIS_ISA_SET_KNCE) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_KNCE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_MASK, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE, ZYDIS_MVEX_FUNC_SI_32, ZYDIS_MASK_POLICY_ALLOWED ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYDIS_MVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPSUBSETBD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xD08), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_KNC) ZYDIS_NOTMIN(ZYDIS_ISA_SET_KNCE) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_KNCE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_MASK, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE, ZYDIS_MVEX_FUNC_SWIZZLE_32, ZYDIS_MASK_POLICY_ALLOWED ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYDIS_MVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPSUBSETBD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xD08), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_KNC) ZYDIS_NOTMIN(ZYDIS_ISA_SET_KNCE) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_KNCE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_MASK, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE, ZYDIS_MVEX_FUNC_INVALID, ZYDIS_MASK_POLICY_ALLOWED ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYDIS_MVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPSUBSETBD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xD0C), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_KNC) ZYDIS_NOTMIN(ZYDIS_ISA_SET_KNCE) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_KNCE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_MASK, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE, ZYDIS_MVEX_FUNC_SI_32, ZYDIS_MASK_POLICY_ALLOWED ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYDIS_MVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPTESTMD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x518), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_KNC) ZYDIS_NOTMIN(ZYDIS_ISA_SET_KNCE) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_KNCE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_MASK, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE, ZYDIS_MVEX_FUNC_SWIZZLE_64, ZYDIS_MASK_POLICY_ALLOWED ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYDIS_MVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPTESTMD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x518), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_KNC) ZYDIS_NOTMIN(ZYDIS_ISA_SET_KNCE) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_KNCE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_MASK, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE, ZYDIS_MVEX_FUNC_INVALID, ZYDIS_MASK_POLICY_ALLOWED ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYDIS_MVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPTESTMD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x51D), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_KNC) ZYDIS_NOTMIN(ZYDIS_ISA_SET_KNCE) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_KNCE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_MASK, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE, ZYDIS_MVEX_FUNC_SI_32, ZYDIS_MASK_POLICY_ALLOWED ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYDIS_MVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPXORD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x4FA), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_KNC) ZYDIS_NOTMIN(ZYDIS_ISA_SET_KNCE) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_KNCE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE, ZYDIS_MVEX_FUNC_SWIZZLE_32, ZYDIS_MASK_POLICY_ALLOWED ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYDIS_MVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPXORD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x4FA), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_KNC) ZYDIS_NOTMIN(ZYDIS_ISA_SET_KNCE) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_KNCE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE, ZYDIS_MVEX_FUNC_IGNORED, ZYDIS_MASK_POLICY_ALLOWED ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYDIS_MVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPXORD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xCCC), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_KNC) ZYDIS_NOTMIN(ZYDIS_ISA_SET_KNCE) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_KNCE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE, ZYDIS_MVEX_FUNC_SI_32, ZYDIS_MASK_POLICY_ALLOWED ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYDIS_MVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPXORQ ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xCC4), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_KNC) ZYDIS_NOTMIN(ZYDIS_ISA_SET_KNCE) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_KNCE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE, ZYDIS_MVEX_FUNC_SWIZZLE_64, ZYDIS_MASK_POLICY_ALLOWED ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYDIS_MVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPXORQ ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xCC4), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_KNC) ZYDIS_NOTMIN(ZYDIS_ISA_SET_KNCE) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_KNCE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE, ZYDIS_MVEX_FUNC_IGNORED, ZYDIS_MASK_POLICY_ALLOWED ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYDIS_MVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VPXORQ ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xCC8), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_KNC) ZYDIS_NOTMIN(ZYDIS_ISA_SET_KNCE) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_KNCE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE, ZYDIS_MVEX_FUNC_SI_64, ZYDIS_MASK_POLICY_ALLOWED ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYDIS_MVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VRCP23PS ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0xD10), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_KNC) ZYDIS_NOTMIN(ZYDIS_ISA_SET_KNCE) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_KNCE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE, ZYDIS_MVEX_FUNC_INVALID, ZYDIS_MASK_POLICY_ALLOWED ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYDIS_MVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VRCP23PS ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0xD10), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_KNC) ZYDIS_NOTMIN(ZYDIS_ISA_SET_KNCE) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_KNCE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE, ZYDIS_MVEX_FUNC_SAE, ZYDIS_MASK_POLICY_ALLOWED ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYDIS_MVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VRCP23PS ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0xD14), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_KNC) ZYDIS_NOTMIN(ZYDIS_ISA_SET_KNCE) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_KNCE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE, ZYDIS_MVEX_FUNC_F_32, ZYDIS_MASK_POLICY_ALLOWED ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYDIS_MVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VRNDFXPNTPD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xCFC), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_KNCE) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_KNCE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE, ZYDIS_MVEX_FUNC_SWIZZLE_64, ZYDIS_MASK_POLICY_ALLOWED ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYDIS_MVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VRNDFXPNTPD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xCFC), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_KNCE) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_KNCE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE, ZYDIS_MVEX_FUNC_SAE, ZYDIS_MASK_POLICY_ALLOWED ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYDIS_MVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VRNDFXPNTPD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xD00), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_CONVERT) ZYDIS_NOTMIN(ZYDIS_ISA_SET_KNCE) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_KNCE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE, ZYDIS_MVEX_FUNC_SF_64, ZYDIS_MASK_POLICY_ALLOWED ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYDIS_MVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VRNDFXPNTPS ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xD04), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_KNC) ZYDIS_NOTMIN(ZYDIS_ISA_SET_KNCE) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_KNCE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE, ZYDIS_MVEX_FUNC_SWIZZLE_32, ZYDIS_MASK_POLICY_ALLOWED ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYDIS_MVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VRNDFXPNTPS ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xD04), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_KNC) ZYDIS_NOTMIN(ZYDIS_ISA_SET_KNCE) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_KNCE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE, ZYDIS_MVEX_FUNC_SAE, ZYDIS_MASK_POLICY_ALLOWED ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYDIS_MVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VRNDFXPNTPS ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xCDC), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_KNC) ZYDIS_NOTMIN(ZYDIS_ISA_SET_KNCE) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_KNCE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE, ZYDIS_MVEX_FUNC_SF_32, ZYDIS_MASK_POLICY_ALLOWED ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYDIS_MVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VRSQRT23PS ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0xD10), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_KNC) ZYDIS_NOTMIN(ZYDIS_ISA_SET_KNCE) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_KNCE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE, ZYDIS_MVEX_FUNC_INVALID, ZYDIS_MASK_POLICY_ALLOWED ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYDIS_MVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VRSQRT23PS ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0xD10), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_KNC) ZYDIS_NOTMIN(ZYDIS_ISA_SET_KNCE) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_KNCE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE, ZYDIS_MVEX_FUNC_SAE, ZYDIS_MASK_POLICY_ALLOWED ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYDIS_MVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VRSQRT23PS ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0xD14), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_KNC) ZYDIS_NOTMIN(ZYDIS_ISA_SET_KNCE) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_KNCE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE, ZYDIS_MVEX_FUNC_F_32, ZYDIS_MASK_POLICY_ALLOWED ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYDIS_MVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VSCALEPS ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x4FA), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_KNC) ZYDIS_NOTMIN(ZYDIS_ISA_SET_KNCE) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_KNCE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE, ZYDIS_MVEX_FUNC_SWIZZLE_32, ZYDIS_MASK_POLICY_ALLOWED ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYDIS_MVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VSCALEPS ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x4FA), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_KNC) ZYDIS_NOTMIN(ZYDIS_ISA_SET_KNCE) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_KNCE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE, ZYDIS_MVEX_FUNC_IGNORED, ZYDIS_MASK_POLICY_ALLOWED ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYDIS_MVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VSCALEPS ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xCCC), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_KNC) ZYDIS_NOTMIN(ZYDIS_ISA_SET_KNCE) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_KNCE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE, ZYDIS_MVEX_FUNC_SI_32, ZYDIS_MASK_POLICY_ALLOWED ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYDIS_MVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VSCATTERDPD ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1ADF), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_KNC) ZYDIS_NOTMIN(ZYDIS_ISA_SET_KNCE) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_KNCE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_VSIB | (1 << 3) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE, ZYDIS_MVEX_FUNC_DF_64, ZYDIS_MASK_POLICY_ALLOWED ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYDIS_MVEX_STATIC_BROADCAST_1_TO_8) },
    { ZYDIS_MNEMONIC_VSCATTERDPS ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(3) ZYDIS_NOTMIN(0x1AE2), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_KNC) ZYDIS_NOTMIN(ZYDIS_ISA_SET_KNCE) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_KNCE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_VSIB | (1 << 3) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE, ZYDIS_MVEX_FUNC_DF_32, ZYDIS_MASK_POLICY_ALLOWED ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYDIS_MVEX_STATIC_BROADCAST_1_TO_16) },
    { ZYDIS_MNEMONIC_VSCATTERPF0DPS ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1AD9), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_PREFETCH) ZYDIS_NOTMIN(ZYDIS_ISA_SET_KNCE) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_KNCE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, ZYDIS_MEMOP_TYPE_VSIB | (1 << 3) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE, ZYDIS_MVEX_FUNC_UF_32, ZYDIS_MASK_POLICY_ALLOWED ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYDIS_MVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VSCATTERPF0HINTDPD ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1AD9), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_PREFETCH) ZYDIS_NOTMIN(ZYDIS_ISA_SET_KNC_PF_HINT) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_KNCE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, ZYDIS_MEMOP_TYPE_VSIB | (1 << 3) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE, ZYDIS_MVEX_FUNC_UF_32, ZYDIS_MASK_POLICY_ALLOWED ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYDIS_MVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VSCATTERPF0HINTDPS ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1AD9), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_PREFETCH) ZYDIS_NOTMIN(ZYDIS_ISA_SET_KNC_PF_HINT) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_KNCE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, ZYDIS_MEMOP_TYPE_VSIB | (1 << 3) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE, ZYDIS_MVEX_FUNC_UF_32, ZYDIS_MASK_POLICY_ALLOWED ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYDIS_MVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VSCATTERPF1DPS ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(2) ZYDIS_NOTMIN(0x1AD9), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_PREFETCH) ZYDIS_NOTMIN(ZYDIS_ISA_SET_KNCE) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_KNCE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), 0, ZYDIS_MEMOP_TYPE_VSIB | (1 << 3) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), 0, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE, ZYDIS_MVEX_FUNC_UF_32, ZYDIS_MASK_POLICY_ALLOWED ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYDIS_MVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VSUBPD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xCC4), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_KNC) ZYDIS_NOTMIN(ZYDIS_ISA_SET_KNCE) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_KNCE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE, ZYDIS_MVEX_FUNC_SWIZZLE_64, ZYDIS_MASK_POLICY_ALLOWED ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYDIS_MVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VSUBPD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xCC4), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_KNC) ZYDIS_NOTMIN(ZYDIS_ISA_SET_KNCE) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_KNCE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE, ZYDIS_MVEX_FUNC_RC, ZYDIS_MASK_POLICY_ALLOWED ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYDIS_MVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VSUBPD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xCC8), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_KNC) ZYDIS_NOTMIN(ZYDIS_ISA_SET_KNCE) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_KNCE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE, ZYDIS_MVEX_FUNC_SF_64, ZYDIS_MASK_POLICY_ALLOWED ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYDIS_MVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VSUBPS ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x4FA), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_KNC) ZYDIS_NOTMIN(ZYDIS_ISA_SET_KNCE) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_KNCE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE, ZYDIS_MVEX_FUNC_SWIZZLE_32, ZYDIS_MASK_POLICY_ALLOWED ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYDIS_MVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VSUBPS ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x4FA), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_KNC) ZYDIS_NOTMIN(ZYDIS_ISA_SET_KNCE) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_KNCE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE, ZYDIS_MVEX_FUNC_RC, ZYDIS_MASK_POLICY_ALLOWED ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYDIS_MVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VSUBPS ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xCCC), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_KNC) ZYDIS_NOTMIN(ZYDIS_ISA_SET_KNCE) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_KNCE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE, ZYDIS_MVEX_FUNC_SF_32, ZYDIS_MASK_POLICY_ALLOWED ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYDIS_MVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VSUBRPD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xCC4), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_KNC) ZYDIS_NOTMIN(ZYDIS_ISA_SET_KNCE) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_KNCE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE, ZYDIS_MVEX_FUNC_SWIZZLE_64, ZYDIS_MASK_POLICY_ALLOWED ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYDIS_MVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VSUBRPD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xCC4), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_KNC) ZYDIS_NOTMIN(ZYDIS_ISA_SET_KNCE) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_KNCE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE, ZYDIS_MVEX_FUNC_RC, ZYDIS_MASK_POLICY_ALLOWED ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYDIS_MVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VSUBRPD ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xCC8), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_KNC) ZYDIS_NOTMIN(ZYDIS_ISA_SET_KNCE) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_KNCE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE, ZYDIS_MVEX_FUNC_SF_64, ZYDIS_MASK_POLICY_ALLOWED ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYDIS_MVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VSUBRPS ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x4FA), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_KNC) ZYDIS_NOTMIN(ZYDIS_ISA_SET_KNCE) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_KNCE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE, ZYDIS_MVEX_FUNC_SWIZZLE_32, ZYDIS_MASK_POLICY_ALLOWED ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYDIS_MVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VSUBRPS ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0x4FA), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_KNC) ZYDIS_NOTMIN(ZYDIS_ISA_SET_KNCE) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_KNCE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_REGKIND_VR ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_FALSE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE, ZYDIS_MVEX_FUNC_RC, ZYDIS_MASK_POLICY_ALLOWED ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYDIS_MVEX_STATIC_BROADCAST_NONE) },
    { ZYDIS_MNEMONIC_VSUBRPS ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(4) ZYDIS_NOTMIN(0xCCC), 0, 0 ZYDIS_NOTMIN(0x0), ZYAN_FALSE, ZYAN_FALSE ZYDIS_NOTMIN(ZYDIS_CATEGORY_KNC) ZYDIS_NOTMIN(ZYDIS_ISA_SET_KNCE) ZYDIS_NOTMIN(ZYDIS_ISA_EXT_KNCE) ZYDIS_NOTMIN(ZYDIS_BRANCH_TYPE_NONE) ZYDIS_NOTMIN(ZYDIS_EXCEPTION_CLASS_NONE), ZYDIS_REGKIND_VR, ZYDIS_MEMOP_TYPE_MEM ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYDIS_RW_ACTION_NONE) ZYDIS_NOTMIN(ZYAN_TRUE), ZYDIS_REGKIND_VR, ZYAN_FALSE, ZYAN_FALSE, ZYAN_FALSE, ZYDIS_MVEX_FUNC_SF_32, ZYDIS_MASK_POLICY_ALLOWED ZYDIS_NOTMIN(ZYAN_FALSE) ZYDIS_NOTMIN(ZYDIS_MVEX_STATIC_BROADCAST_NONE) }
};
#endif

#undef ZYDIS_NOTMIN

/* ---------------------------------------------------------------------------------------------- */
/* Operand definitions                                                                            */
/* ---------------------------------------------------------------------------------------------- */

#define ZYDIS_OPERAND_DEFINITION(type, encoding, access) \
    { type, encoding, access }


//
// Header: Generated/OperandDefinitions.inc
//

#ifndef ZYDIS_MINIMAL_MODE
const ZydisOperandDefinition OPERAND_DEFINITIONS[] =
{
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 48, 48, 48 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_READWRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_UINT8, { .reg = { ZYDIS_IMPLREG_TYPE_STATIC, { .reg = ZYDIS_REGISTER_XMM0 } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_READWRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_UINT8, { .reg = { ZYDIS_IMPLREG_TYPE_STATIC, { .reg = ZYDIS_REGISTER_XMM1 } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_READWRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_UINT8, { .reg = { ZYDIS_IMPLREG_TYPE_STATIC, { .reg = ZYDIS_REGISTER_XMM2 } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_READWRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_UINT8, { .reg = { ZYDIS_IMPLREG_TYPE_STATIC, { .reg = ZYDIS_REGISTER_XMM3 } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_READWRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_UINT8, { .reg = { ZYDIS_IMPLREG_TYPE_STATIC, { .reg = ZYDIS_REGISTER_XMM4 } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_READWRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_UINT8, { .reg = { ZYDIS_IMPLREG_TYPE_STATIC, { .reg = ZYDIS_REGISTER_XMM5 } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_READWRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_UINT8, { .reg = { ZYDIS_IMPLREG_TYPE_STATIC, { .reg = ZYDIS_REGISTER_XMM6 } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_READWRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_UINT8, { .reg = { ZYDIS_IMPLREG_TYPE_STATIC, { .reg = ZYDIS_REGISTER_XMM7 } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_WRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INT1, { .reg = { ZYDIS_IMPLREG_TYPE_FLAGS_SSZ, { .id = 0x3F } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_READWRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_UINT8, { .reg = { ZYDIS_IMPLREG_TYPE_STATIC, { .reg = ZYDIS_REGISTER_XMM0 } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_READWRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_UINT8, { .reg = { ZYDIS_IMPLREG_TYPE_STATIC, { .reg = ZYDIS_REGISTER_XMM1 } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_READWRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_UINT8, { .reg = { ZYDIS_IMPLREG_TYPE_STATIC, { .reg = ZYDIS_REGISTER_XMM2 } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_READWRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_UINT8, { .reg = { ZYDIS_IMPLREG_TYPE_STATIC, { .reg = ZYDIS_REGISTER_XMM3 } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_READWRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_UINT8, { .reg = { ZYDIS_IMPLREG_TYPE_STATIC, { .reg = ZYDIS_REGISTER_XMM4 } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_READWRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_UINT8, { .reg = { ZYDIS_IMPLREG_TYPE_STATIC, { .reg = ZYDIS_REGISTER_XMM5 } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_READWRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_UINT8, { .reg = { ZYDIS_IMPLREG_TYPE_STATIC, { .reg = ZYDIS_REGISTER_XMM6 } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_READWRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_UINT8, { .reg = { ZYDIS_IMPLREG_TYPE_STATIC, { .reg = ZYDIS_REGISTER_XMM7 } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_WRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INT1, { .reg = { ZYDIS_IMPLREG_TYPE_FLAGS_SSZ, { .id = 0x3F } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_GPR32, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 4, 4, 4 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_GPR32, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 4, 4, 4 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_READWRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_UINT8, { .reg = { ZYDIS_IMPLREG_TYPE_STATIC, { .reg = ZYDIS_REGISTER_XMM0 } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_READWRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_UINT8, { .reg = { ZYDIS_IMPLREG_TYPE_STATIC, { .reg = ZYDIS_REGISTER_XMM1 } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_WRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_UINT8, { .reg = { ZYDIS_IMPLREG_TYPE_STATIC, { .reg = ZYDIS_REGISTER_XMM2 } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_WRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_UINT8, { .reg = { ZYDIS_IMPLREG_TYPE_STATIC, { .reg = ZYDIS_REGISTER_XMM3 } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_WRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_UINT8, { .reg = { ZYDIS_IMPLREG_TYPE_STATIC, { .reg = ZYDIS_REGISTER_XMM4 } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_WRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_UINT8, { .reg = { ZYDIS_IMPLREG_TYPE_STATIC, { .reg = ZYDIS_REGISTER_XMM5 } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_WRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_UINT8, { .reg = { ZYDIS_IMPLREG_TYPE_STATIC, { .reg = ZYDIS_REGISTER_XMM6 } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_WRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INT1, { .reg = { ZYDIS_IMPLREG_TYPE_FLAGS_SSZ, { .id = 0x3F } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_READ, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .reg = { ZYDIS_IMPLREG_TYPE_STATIC, { .reg = ZYDIS_REGISTER_AX } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_READ, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .reg = { ZYDIS_IMPLREG_TYPE_STATIC, { .reg = ZYDIS_REGISTER_CX } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_READ, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .reg = { ZYDIS_IMPLREG_TYPE_STATIC, { .reg = ZYDIS_REGISTER_DX } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_READ, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .reg = { ZYDIS_IMPLREG_TYPE_STATIC, { .reg = ZYDIS_REGISTER_BX } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_READ, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .reg = { ZYDIS_IMPLREG_TYPE_STATIC, { .reg = ZYDIS_REGISTER_SP } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_READ, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .reg = { ZYDIS_IMPLREG_TYPE_STATIC, { .reg = ZYDIS_REGISTER_BP } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_READ, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .reg = { ZYDIS_IMPLREG_TYPE_STATIC, { .reg = ZYDIS_REGISTER_SI } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_READ, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .reg = { ZYDIS_IMPLREG_TYPE_STATIC, { .reg = ZYDIS_REGISTER_DI } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_READWRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .reg = { ZYDIS_IMPLREG_TYPE_GPR_SSZ, { .id = 0x4 } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_MEM, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_WRITE, { 16, 32, 0 }, ZYDIS_IELEMENT_TYPE_INT, { .mem = { 0, ZYDIS_IMPLMEM_BASE_SSP } }, ZYAN_FALSE, ZYAN_TRUE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_READ, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .reg = { ZYDIS_IMPLREG_TYPE_STATIC, { .reg = ZYDIS_REGISTER_EAX } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_READ, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .reg = { ZYDIS_IMPLREG_TYPE_STATIC, { .reg = ZYDIS_REGISTER_ECX } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_READ, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .reg = { ZYDIS_IMPLREG_TYPE_STATIC, { .reg = ZYDIS_REGISTER_EDX } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_READ, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .reg = { ZYDIS_IMPLREG_TYPE_STATIC, { .reg = ZYDIS_REGISTER_EBX } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_READ, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .reg = { ZYDIS_IMPLREG_TYPE_STATIC, { .reg = ZYDIS_REGISTER_ESP } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_READ, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .reg = { ZYDIS_IMPLREG_TYPE_STATIC, { .reg = ZYDIS_REGISTER_EBP } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_READ, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .reg = { ZYDIS_IMPLREG_TYPE_STATIC, { .reg = ZYDIS_REGISTER_ESI } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_READ, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .reg = { ZYDIS_IMPLREG_TYPE_STATIC, { .reg = ZYDIS_REGISTER_EDI } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_READWRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .reg = { ZYDIS_IMPLREG_TYPE_GPR_SSZ, { .id = 0x4 } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_MEM, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_WRITE, { 16, 32, 0 }, ZYDIS_IELEMENT_TYPE_INT, { .mem = { 0, ZYDIS_IMPLMEM_BASE_SSP } }, ZYAN_FALSE, ZYAN_TRUE },
    { ZYDIS_SEMANTIC_OPTYPE_GPR32, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 4, 4, 4 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_GPR32, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 4, 4, 4 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_READWRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_UINT8, { .reg = { ZYDIS_IMPLREG_TYPE_STATIC, { .reg = ZYDIS_REGISTER_XMM0 } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_WRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_UINT8, { .reg = { ZYDIS_IMPLREG_TYPE_STATIC, { .reg = ZYDIS_REGISTER_XMM1 } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_WRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_UINT8, { .reg = { ZYDIS_IMPLREG_TYPE_STATIC, { .reg = ZYDIS_REGISTER_XMM2 } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_WRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_UINT8, { .reg = { ZYDIS_IMPLREG_TYPE_STATIC, { .reg = ZYDIS_REGISTER_XMM4 } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_WRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_UINT8, { .reg = { ZYDIS_IMPLREG_TYPE_STATIC, { .reg = ZYDIS_REGISTER_XMM5 } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_WRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_UINT8, { .reg = { ZYDIS_IMPLREG_TYPE_STATIC, { .reg = ZYDIS_REGISTER_XMM6 } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_WRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INT1, { .reg = { ZYDIS_IMPLREG_TYPE_FLAGS_SSZ, { .id = 0x3F } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_WRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .reg = { ZYDIS_IMPLREG_TYPE_STATIC, { .reg = ZYDIS_REGISTER_AX } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_WRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .reg = { ZYDIS_IMPLREG_TYPE_STATIC, { .reg = ZYDIS_REGISTER_CX } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_WRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .reg = { ZYDIS_IMPLREG_TYPE_STATIC, { .reg = ZYDIS_REGISTER_DX } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_WRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .reg = { ZYDIS_IMPLREG_TYPE_STATIC, { .reg = ZYDIS_REGISTER_BX } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_WRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .reg = { ZYDIS_IMPLREG_TYPE_STATIC, { .reg = ZYDIS_REGISTER_BP } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_WRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .reg = { ZYDIS_IMPLREG_TYPE_STATIC, { .reg = ZYDIS_REGISTER_SI } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_WRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .reg = { ZYDIS_IMPLREG_TYPE_STATIC, { .reg = ZYDIS_REGISTER_DI } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_READWRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .reg = { ZYDIS_IMPLREG_TYPE_GPR_SSZ, { .id = 0x4 } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_MEM, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_READ, { 16, 32, 0 }, ZYDIS_IELEMENT_TYPE_INT, { .mem = { 0, ZYDIS_IMPLMEM_BASE_SSP } }, ZYAN_FALSE, ZYAN_TRUE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_WRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .reg = { ZYDIS_IMPLREG_TYPE_STATIC, { .reg = ZYDIS_REGISTER_EAX } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_WRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .reg = { ZYDIS_IMPLREG_TYPE_STATIC, { .reg = ZYDIS_REGISTER_ECX } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_WRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .reg = { ZYDIS_IMPLREG_TYPE_STATIC, { .reg = ZYDIS_REGISTER_EDX } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_WRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .reg = { ZYDIS_IMPLREG_TYPE_STATIC, { .reg = ZYDIS_REGISTER_EBX } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_WRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .reg = { ZYDIS_IMPLREG_TYPE_STATIC, { .reg = ZYDIS_REGISTER_EBP } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_WRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .reg = { ZYDIS_IMPLREG_TYPE_STATIC, { .reg = ZYDIS_REGISTER_ESI } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_WRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .reg = { ZYDIS_IMPLREG_TYPE_STATIC, { .reg = ZYDIS_REGISTER_EDI } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_READWRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .reg = { ZYDIS_IMPLREG_TYPE_GPR_SSZ, { .id = 0x4 } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_MEM, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_READ, { 16, 32, 0 }, ZYDIS_IELEMENT_TYPE_INT, { .mem = { 0, ZYDIS_IMPLMEM_BASE_SSP } }, ZYAN_FALSE, ZYAN_TRUE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_READ_CONDWRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .reg = { ZYDIS_IMPLREG_TYPE_GPR_ASZ, { .id = 0x0 } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_READ_CONDWRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .reg = { ZYDIS_IMPLREG_TYPE_GPR_ASZ, { .id = 0x1 } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_READ_CONDWRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .reg = { ZYDIS_IMPLREG_TYPE_GPR_ASZ, { .id = 0x6 } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_READ_CONDWRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .reg = { ZYDIS_IMPLREG_TYPE_GPR_ASZ, { .id = 0x7 } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_MEM, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_READ_CONDWRITE, { 2, 4, 8 }, ZYDIS_IELEMENT_TYPE_INT, { .mem = { 1, ZYDIS_IMPLMEM_BASE_AAX } }, ZYAN_FALSE, ZYAN_TRUE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_MEM, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_CONDREAD, { 2, 4, 8 }, ZYDIS_IELEMENT_TYPE_STRUCT, { .mem = { 1, ZYDIS_IMPLMEM_BASE_ADX } }, ZYAN_FALSE, ZYAN_TRUE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_MEM, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_CONDREAD, { 2, 4, 8 }, ZYDIS_IELEMENT_TYPE_INT, { .mem = { 1, ZYDIS_IMPLMEM_BASE_ABX } }, ZYAN_FALSE, ZYAN_TRUE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_MEM, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_CONDREAD, { 2, 4, 8 }, ZYDIS_IELEMENT_TYPE_INT, { .mem = { 1, ZYDIS_IMPLMEM_BASE_ASI } }, ZYAN_FALSE, ZYAN_TRUE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_MEM, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_CONDWRITE, { 2, 4, 8 }, ZYDIS_IELEMENT_TYPE_INT, { .mem = { 1, ZYDIS_IMPLMEM_BASE_ADI } }, ZYAN_FALSE, ZYAN_TRUE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_READ_CONDWRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .reg = { ZYDIS_IMPLREG_TYPE_GPR_ASZ, { .id = 0x0 } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_READ_CONDWRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .reg = { ZYDIS_IMPLREG_TYPE_GPR_ASZ, { .id = 0x1 } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_READ_CONDWRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .reg = { ZYDIS_IMPLREG_TYPE_GPR_ASZ, { .id = 0x6 } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_MEM, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_READ_CONDWRITE, { 2, 4, 8 }, ZYDIS_IELEMENT_TYPE_INT, { .mem = { 1, ZYDIS_IMPLMEM_BASE_AAX } }, ZYAN_FALSE, ZYAN_TRUE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_MEM, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_CONDREAD, { 2, 4, 8 }, ZYDIS_IELEMENT_TYPE_STRUCT, { .mem = { 1, ZYDIS_IMPLMEM_BASE_ADX } }, ZYAN_FALSE, ZYAN_TRUE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_MEM, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_CONDREAD, { 2, 4, 8 }, ZYDIS_IELEMENT_TYPE_INT, { .mem = { 1, ZYDIS_IMPLMEM_BASE_ABX } }, ZYAN_FALSE, ZYAN_TRUE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_MEM, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_CONDREAD, { 2, 4, 8 }, ZYDIS_IELEMENT_TYPE_INT, { .mem = { 1, ZYDIS_IMPLMEM_BASE_ASI } }, ZYAN_FALSE, ZYAN_TRUE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_MEM, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_CONDWRITE, { 2, 4, 8 }, ZYDIS_IELEMENT_TYPE_INT, { .mem = { 1, ZYDIS_IMPLMEM_BASE_ADI } }, ZYAN_FALSE, ZYAN_TRUE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_INT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_INT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_UIMM8 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_READ, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .reg = { ZYDIS_IMPLREG_TYPE_STATIC, { .reg = ZYDIS_REGISTER_EAX } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_READ, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .reg = { ZYDIS_IMPLREG_TYPE_STATIC, { .reg = ZYDIS_REGISTER_EDX } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_WRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .reg = { ZYDIS_IMPLREG_TYPE_STATIC, { .reg = ZYDIS_REGISTER_ECX } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_WRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INT1, { .reg = { ZYDIS_IMPLREG_TYPE_FLAGS_SSZ, { .id = 0x3F } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_INT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_INT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_UIMM8 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_READ, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .reg = { ZYDIS_IMPLREG_TYPE_STATIC, { .reg = ZYDIS_REGISTER_RAX } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_READ, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .reg = { ZYDIS_IMPLREG_TYPE_STATIC, { .reg = ZYDIS_REGISTER_RDX } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_WRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .reg = { ZYDIS_IMPLREG_TYPE_STATIC, { .reg = ZYDIS_REGISTER_ECX } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_WRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INT1, { .reg = { ZYDIS_IMPLREG_TYPE_FLAGS_SSZ, { .id = 0x3F } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_INT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_INT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_UIMM8 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_READ, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .reg = { ZYDIS_IMPLREG_TYPE_STATIC, { .reg = ZYDIS_REGISTER_EAX } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_READ, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .reg = { ZYDIS_IMPLREG_TYPE_STATIC, { .reg = ZYDIS_REGISTER_EDX } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_WRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .reg = { ZYDIS_IMPLREG_TYPE_STATIC, { .reg = ZYDIS_REGISTER_ECX } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_WRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INT1, { .reg = { ZYDIS_IMPLREG_TYPE_FLAGS_SSZ, { .id = 0x3F } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_INT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_INT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_UIMM8 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_READ, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .reg = { ZYDIS_IMPLREG_TYPE_STATIC, { .reg = ZYDIS_REGISTER_RAX } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_READ, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .reg = { ZYDIS_IMPLREG_TYPE_STATIC, { .reg = ZYDIS_REGISTER_RDX } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_WRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .reg = { ZYDIS_IMPLREG_TYPE_STATIC, { .reg = ZYDIS_REGISTER_ECX } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_WRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INT1, { .reg = { ZYDIS_IMPLREG_TYPE_FLAGS_SSZ, { .id = 0x3F } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_INT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_INT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_UIMM8 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_READ, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .reg = { ZYDIS_IMPLREG_TYPE_STATIC, { .reg = ZYDIS_REGISTER_EAX } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_READ, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .reg = { ZYDIS_IMPLREG_TYPE_STATIC, { .reg = ZYDIS_REGISTER_EDX } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_WRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_INT32, { .reg = { ZYDIS_IMPLREG_TYPE_STATIC, { .reg = ZYDIS_REGISTER_XMM0 } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_WRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INT1, { .reg = { ZYDIS_IMPLREG_TYPE_FLAGS_SSZ, { .id = 0x3F } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_INT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_INT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_UIMM8 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_READ, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .reg = { ZYDIS_IMPLREG_TYPE_STATIC, { .reg = ZYDIS_REGISTER_RAX } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_READ, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .reg = { ZYDIS_IMPLREG_TYPE_STATIC, { .reg = ZYDIS_REGISTER_RDX } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_WRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_INT32, { .reg = { ZYDIS_IMPLREG_TYPE_STATIC, { .reg = ZYDIS_REGISTER_XMM0 } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_WRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INT1, { .reg = { ZYDIS_IMPLREG_TYPE_FLAGS_SSZ, { .id = 0x3F } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_INT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_INT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_UIMM8 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_READ, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .reg = { ZYDIS_IMPLREG_TYPE_STATIC, { .reg = ZYDIS_REGISTER_EAX } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_READ, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .reg = { ZYDIS_IMPLREG_TYPE_STATIC, { .reg = ZYDIS_REGISTER_EDX } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_WRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_INT32, { .reg = { ZYDIS_IMPLREG_TYPE_STATIC, { .reg = ZYDIS_REGISTER_XMM0 } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_WRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INT1, { .reg = { ZYDIS_IMPLREG_TYPE_FLAGS_SSZ, { .id = 0x3F } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_INT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_INT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_UIMM8 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_READ, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .reg = { ZYDIS_IMPLREG_TYPE_STATIC, { .reg = ZYDIS_REGISTER_RAX } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_READ, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .reg = { ZYDIS_IMPLREG_TYPE_STATIC, { .reg = ZYDIS_REGISTER_RDX } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_WRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_INT32, { .reg = { ZYDIS_IMPLREG_TYPE_STATIC, { .reg = ZYDIS_REGISTER_XMM0 } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_WRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INT1, { .reg = { ZYDIS_IMPLREG_TYPE_FLAGS_SSZ, { .id = 0x3F } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_READ_CONDWRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .reg = { ZYDIS_IMPLREG_TYPE_GPR_ASZ, { .id = 0x1 } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_READ_CONDWRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .reg = { ZYDIS_IMPLREG_TYPE_GPR_ASZ, { .id = 0x6 } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_READ_CONDWRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .reg = { ZYDIS_IMPLREG_TYPE_GPR_ASZ, { .id = 0x7 } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_MEM, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_CONDREAD, { 2, 4, 8 }, ZYDIS_IELEMENT_TYPE_STRUCT, { .mem = { 1, ZYDIS_IMPLMEM_BASE_ADX } }, ZYAN_FALSE, ZYAN_TRUE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_MEM, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_CONDREAD, { 2, 4, 8 }, ZYDIS_IELEMENT_TYPE_INT, { .mem = { 1, ZYDIS_IMPLMEM_BASE_ABX } }, ZYAN_FALSE, ZYAN_TRUE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_MEM, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_CONDREAD, { 2, 4, 8 }, ZYDIS_IELEMENT_TYPE_INT, { .mem = { 1, ZYDIS_IMPLMEM_BASE_ASI } }, ZYAN_FALSE, ZYAN_TRUE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_MEM, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_CONDWRITE, { 2, 4, 8 }, ZYDIS_IELEMENT_TYPE_INT, { .mem = { 1, ZYDIS_IMPLMEM_BASE_ADI } }, ZYAN_FALSE, ZYAN_TRUE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ_CONDWRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_INT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_READ_CONDWRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .reg = { ZYDIS_IMPLREG_TYPE_STATIC, { .reg = ZYDIS_REGISTER_RDX } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_READ_CONDWRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .reg = { ZYDIS_IMPLREG_TYPE_STATIC, { .reg = ZYDIS_REGISTER_RAX } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_READ, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .reg = { ZYDIS_IMPLREG_TYPE_STATIC, { .reg = ZYDIS_REGISTER_RCX } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_READ, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .reg = { ZYDIS_IMPLREG_TYPE_STATIC, { .reg = ZYDIS_REGISTER_RBX } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_WRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INT1, { .reg = { ZYDIS_IMPLREG_TYPE_FLAGS_SSZ, { .id = 0x3F } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ_CONDWRITE, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_READ_CONDWRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .reg = { ZYDIS_IMPLREG_TYPE_STATIC, { .reg = ZYDIS_REGISTER_EDX } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_READ_CONDWRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .reg = { ZYDIS_IMPLREG_TYPE_STATIC, { .reg = ZYDIS_REGISTER_EAX } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_READ, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .reg = { ZYDIS_IMPLREG_TYPE_STATIC, { .reg = ZYDIS_REGISTER_ECX } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_READ, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .reg = { ZYDIS_IMPLREG_TYPE_STATIC, { .reg = ZYDIS_REGISTER_EBX } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_WRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INT1, { .reg = { ZYDIS_IMPLREG_TYPE_FLAGS_SSZ, { .id = 0x3F } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_MEM, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_CONDWRITE, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_UINT8, { .mem = { 1, ZYDIS_IMPLMEM_BASE_ADI } }, ZYAN_FALSE, ZYAN_TRUE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_MEM, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_CONDREAD, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_UINT8, { .mem = { 4, ZYDIS_IMPLMEM_BASE_ASI } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_READ_CONDWRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .reg = { ZYDIS_IMPLREG_TYPE_GPR_ASZ, { .id = 0x1 } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_CONDWRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .reg = { ZYDIS_IMPLREG_TYPE_GPR_ASZ, { .id = 0x7 } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_CONDWRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .reg = { ZYDIS_IMPLREG_TYPE_GPR_ASZ, { .id = 0x6 } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_READ, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INT1, { .reg = { ZYDIS_IMPLREG_TYPE_FLAGS_SSZ, { .id = 0x3F } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_MEM, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_CONDWRITE, { 4, 4, 4 }, ZYDIS_IELEMENT_TYPE_INT32, { .mem = { 1, ZYDIS_IMPLMEM_BASE_ADI } }, ZYAN_FALSE, ZYAN_TRUE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_MEM, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_CONDREAD, { 4, 4, 4 }, ZYDIS_IELEMENT_TYPE_INT32, { .mem = { 4, ZYDIS_IMPLMEM_BASE_ASI } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_READ_CONDWRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .reg = { ZYDIS_IMPLREG_TYPE_GPR_ASZ, { .id = 0x1 } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_CONDWRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .reg = { ZYDIS_IMPLREG_TYPE_GPR_ASZ, { .id = 0x7 } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_CONDWRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .reg = { ZYDIS_IMPLREG_TYPE_GPR_ASZ, { .id = 0x6 } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_READ, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INT1, { .reg = { ZYDIS_IMPLREG_TYPE_FLAGS_SSZ, { .id = 0x3F } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_MEM, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_CONDWRITE, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT64, { .mem = { 1, ZYDIS_IMPLMEM_BASE_ADI } }, ZYAN_FALSE, ZYAN_TRUE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_MEM, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_CONDREAD, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT64, { .mem = { 4, ZYDIS_IMPLMEM_BASE_ASI } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_READ_CONDWRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .reg = { ZYDIS_IMPLREG_TYPE_GPR_ASZ, { .id = 0x1 } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_CONDWRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .reg = { ZYDIS_IMPLREG_TYPE_GPR_ASZ, { .id = 0x7 } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_CONDWRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .reg = { ZYDIS_IMPLREG_TYPE_GPR_ASZ, { .id = 0x6 } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_READ, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INT1, { .reg = { ZYDIS_IMPLREG_TYPE_FLAGS_SSZ, { .id = 0x3F } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_MEM, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_CONDWRITE, { 2, 2, 2 }, ZYDIS_IELEMENT_TYPE_INT16, { .mem = { 1, ZYDIS_IMPLMEM_BASE_ADI } }, ZYAN_FALSE, ZYAN_TRUE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_MEM, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_CONDREAD, { 2, 2, 2 }, ZYDIS_IELEMENT_TYPE_INT16, { .mem = { 4, ZYDIS_IMPLMEM_BASE_ASI } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_READ_CONDWRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .reg = { ZYDIS_IMPLREG_TYPE_GPR_ASZ, { .id = 0x1 } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_CONDWRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .reg = { ZYDIS_IMPLREG_TYPE_GPR_ASZ, { .id = 0x7 } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_CONDWRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .reg = { ZYDIS_IMPLREG_TYPE_GPR_ASZ, { .id = 0x6 } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_READ, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INT1, { .reg = { ZYDIS_IMPLREG_TYPE_FLAGS_SSZ, { .id = 0x3F } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_WRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .reg = { ZYDIS_IMPLREG_TYPE_STATIC, { .reg = ZYDIS_REGISTER_RIP } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_WRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .reg = { ZYDIS_IMPLREG_TYPE_STATIC, { .reg = ZYDIS_REGISTER_RCX } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_WRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .reg = { ZYDIS_IMPLREG_TYPE_STATIC, { .reg = ZYDIS_REGISTER_R11 } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_WRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .reg = { ZYDIS_IMPLREG_TYPE_STATIC, { .reg = ZYDIS_REGISTER_CS } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_WRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .reg = { ZYDIS_IMPLREG_TYPE_STATIC, { .reg = ZYDIS_REGISTER_SS } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_WRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INT1, { .reg = { ZYDIS_IMPLREG_TYPE_FLAGS_SSZ, { .id = 0x3F } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_WRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .reg = { ZYDIS_IMPLREG_TYPE_IP_SSZ, { .id = 0x3F } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_WRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .reg = { ZYDIS_IMPLREG_TYPE_STATIC, { .reg = ZYDIS_REGISTER_RCX } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_WRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .reg = { ZYDIS_IMPLREG_TYPE_STATIC, { .reg = ZYDIS_REGISTER_R11 } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_WRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .reg = { ZYDIS_IMPLREG_TYPE_STATIC, { .reg = ZYDIS_REGISTER_CS } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_WRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .reg = { ZYDIS_IMPLREG_TYPE_STATIC, { .reg = ZYDIS_REGISTER_SS } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_WRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INT1, { .reg = { ZYDIS_IMPLREG_TYPE_FLAGS_SSZ, { .id = 0x3F } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_WRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .reg = { ZYDIS_IMPLREG_TYPE_STATIC, { .reg = ZYDIS_REGISTER_RIP } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_READ, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .reg = { ZYDIS_IMPLREG_TYPE_STATIC, { .reg = ZYDIS_REGISTER_RCX } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_READ, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .reg = { ZYDIS_IMPLREG_TYPE_STATIC, { .reg = ZYDIS_REGISTER_R11 } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_WRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .reg = { ZYDIS_IMPLREG_TYPE_STATIC, { .reg = ZYDIS_REGISTER_CS } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_WRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .reg = { ZYDIS_IMPLREG_TYPE_STATIC, { .reg = ZYDIS_REGISTER_SS } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_WRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INT1, { .reg = { ZYDIS_IMPLREG_TYPE_FLAGS_SSZ, { .id = 0x3F } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_WRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .reg = { ZYDIS_IMPLREG_TYPE_STATIC, { .reg = ZYDIS_REGISTER_EIP } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_READ, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .reg = { ZYDIS_IMPLREG_TYPE_STATIC, { .reg = ZYDIS_REGISTER_ECX } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_READ, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .reg = { ZYDIS_IMPLREG_TYPE_STATIC, { .reg = ZYDIS_REGISTER_R11 } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_WRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .reg = { ZYDIS_IMPLREG_TYPE_STATIC, { .reg = ZYDIS_REGISTER_CS } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_WRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .reg = { ZYDIS_IMPLREG_TYPE_STATIC, { .reg = ZYDIS_REGISTER_SS } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_WRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INT1, { .reg = { ZYDIS_IMPLREG_TYPE_FLAGS_SSZ, { .id = 0x3F } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_WRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .reg = { ZYDIS_IMPLREG_TYPE_STATIC, { .reg = ZYDIS_REGISTER_EIP } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_READ, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .reg = { ZYDIS_IMPLREG_TYPE_STATIC, { .reg = ZYDIS_REGISTER_RCX } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_READ, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .reg = { ZYDIS_IMPLREG_TYPE_STATIC, { .reg = ZYDIS_REGISTER_R11 } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_WRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .reg = { ZYDIS_IMPLREG_TYPE_STATIC, { .reg = ZYDIS_REGISTER_CS } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_WRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .reg = { ZYDIS_IMPLREG_TYPE_STATIC, { .reg = ZYDIS_REGISTER_SS } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_WRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INT1, { .reg = { ZYDIS_IMPLREG_TYPE_FLAGS_SSZ, { .id = 0x3F } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_READ_CONDWRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .reg = { ZYDIS_IMPLREG_TYPE_GPR_SSZ, { .id = 0x0 } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_READ, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .reg = { ZYDIS_IMPLREG_TYPE_GPR_SSZ, { .id = 0x1 } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_READ_CONDWRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .reg = { ZYDIS_IMPLREG_TYPE_GPR_ASZ, { .id = 0x6 } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_CONDREAD, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .reg = { ZYDIS_IMPLREG_TYPE_GPR_ASZ, { .id = 0x7 } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_MEM, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_CONDREAD, { 2, 4, 8 }, ZYDIS_IELEMENT_TYPE_INT, { .mem = { 1, ZYDIS_IMPLMEM_BASE_ASI } }, ZYAN_FALSE, ZYAN_TRUE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_MEM, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_CONDWRITE, { 2, 4, 8 }, ZYDIS_IELEMENT_TYPE_INT, { .mem = { 1, ZYDIS_IMPLMEM_BASE_ADI } }, ZYAN_FALSE, ZYAN_TRUE },
    { ZYDIS_SEMANTIC_OPTYPE_IMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 2, 2, 2 }, ZYDIS_IELEMENT_TYPE_UINT16, { .encoding = ZYDIS_OPERAND_ENCODING_UIMM16 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_UIMM8 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_READWRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .reg = { ZYDIS_IMPLREG_TYPE_GPR_OSZ, { .id = 0x5 } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_READWRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .reg = { ZYDIS_IMPLREG_TYPE_GPR_SSZ, { .id = 0x4 } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_MEM, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_WRITE, { 2, 4, 8 }, ZYDIS_IELEMENT_TYPE_INT, { .mem = { 0, ZYDIS_IMPLMEM_BASE_SSP } }, ZYAN_FALSE, ZYAN_TRUE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_READ, { 4, 4, 4 }, ZYDIS_IELEMENT_TYPE_UINT32, { .reg = { ZYDIS_IMPLREG_TYPE_STATIC, { .reg = ZYDIS_REGISTER_EAX } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_UINT8, { .reg = { ZYDIS_IMPLREG_TYPE_STATIC, { .reg = ZYDIS_REGISTER_XMM0 } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_WRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INT1, { .reg = { ZYDIS_IMPLREG_TYPE_FLAGS_SSZ, { .id = 0x3F } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_CONDWRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .reg = { ZYDIS_IMPLREG_TYPE_STATIC, { .reg = ZYDIS_REGISTER_AL } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_MEM, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_CONDREAD, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_UINT8, { .mem = { 4, ZYDIS_IMPLMEM_BASE_ASI } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_READ_CONDWRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .reg = { ZYDIS_IMPLREG_TYPE_GPR_ASZ, { .id = 0x6 } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_READ_CONDWRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .reg = { ZYDIS_IMPLREG_TYPE_GPR_ASZ, { .id = 0x1 } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_READ, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INT1, { .reg = { ZYDIS_IMPLREG_TYPE_FLAGS_SSZ, { .id = 0x3F } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_CONDWRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .reg = { ZYDIS_IMPLREG_TYPE_STATIC, { .reg = ZYDIS_REGISTER_EAX } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_MEM, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_CONDREAD, { 4, 4, 4 }, ZYDIS_IELEMENT_TYPE_INT32, { .mem = { 4, ZYDIS_IMPLMEM_BASE_ASI } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_READ_CONDWRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .reg = { ZYDIS_IMPLREG_TYPE_GPR_ASZ, { .id = 0x6 } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_READ_CONDWRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .reg = { ZYDIS_IMPLREG_TYPE_GPR_ASZ, { .id = 0x1 } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_READ, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INT1, { .reg = { ZYDIS_IMPLREG_TYPE_FLAGS_SSZ, { .id = 0x3F } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_CONDWRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .reg = { ZYDIS_IMPLREG_TYPE_STATIC, { .reg = ZYDIS_REGISTER_RAX } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_MEM, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_CONDREAD, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT64, { .mem = { 4, ZYDIS_IMPLMEM_BASE_ASI } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_READ_CONDWRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .reg = { ZYDIS_IMPLREG_TYPE_GPR_ASZ, { .id = 0x6 } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_READ_CONDWRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .reg = { ZYDIS_IMPLREG_TYPE_GPR_ASZ, { .id = 0x1 } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_READ, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INT1, { .reg = { ZYDIS_IMPLREG_TYPE_FLAGS_SSZ, { .id = 0x3F } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_CONDWRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .reg = { ZYDIS_IMPLREG_TYPE_STATIC, { .reg = ZYDIS_REGISTER_AX } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_MEM, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_CONDREAD, { 2, 2, 2 }, ZYDIS_IELEMENT_TYPE_INT16, { .mem = { 4, ZYDIS_IMPLMEM_BASE_ASI } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_READ_CONDWRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .reg = { ZYDIS_IMPLREG_TYPE_GPR_ASZ, { .id = 0x6 } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_READ_CONDWRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .reg = { ZYDIS_IMPLREG_TYPE_GPR_ASZ, { .id = 0x1 } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_READ, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INT1, { .reg = { ZYDIS_IMPLREG_TYPE_FLAGS_SSZ, { .id = 0x3F } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_READWRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .reg = { ZYDIS_IMPLREG_TYPE_GPR_SSZ, { .id = 0x0 } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_READWRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .reg = { ZYDIS_IMPLREG_TYPE_GPR_SSZ, { .id = 0x1 } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_WRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .reg = { ZYDIS_IMPLREG_TYPE_STATIC, { .reg = ZYDIS_REGISTER_EDX } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_READ, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .reg = { ZYDIS_IMPLREG_TYPE_GPR_ASZ, { .id = 0x6 } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_MEM, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_READ, { 2, 4, 8 }, ZYDIS_IELEMENT_TYPE_STRUCT, { .mem = { 1, ZYDIS_IMPLMEM_BASE_ASI } }, ZYAN_FALSE, ZYAN_TRUE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_MEM, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_WRITE, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_UINT8, { .mem = { 1, ZYDIS_IMPLMEM_BASE_ADI } }, ZYAN_FALSE, ZYAN_TRUE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_MEM, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_READ, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_UINT8, { .mem = { 4, ZYDIS_IMPLMEM_BASE_ASI } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_READWRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .reg = { ZYDIS_IMPLREG_TYPE_GPR_ASZ, { .id = 0x7 } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_READWRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .reg = { ZYDIS_IMPLREG_TYPE_GPR_ASZ, { .id = 0x6 } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_READ, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INT1, { .reg = { ZYDIS_IMPLREG_TYPE_FLAGS_SSZ, { .id = 0x3F } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_MEM, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_WRITE, { 4, 4, 4 }, ZYDIS_IELEMENT_TYPE_INT32, { .mem = { 1, ZYDIS_IMPLMEM_BASE_ADI } }, ZYAN_FALSE, ZYAN_TRUE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_MEM, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_READ, { 4, 4, 4 }, ZYDIS_IELEMENT_TYPE_INT32, { .mem = { 4, ZYDIS_IMPLMEM_BASE_ASI } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_READWRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .reg = { ZYDIS_IMPLREG_TYPE_GPR_ASZ, { .id = 0x7 } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_READWRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .reg = { ZYDIS_IMPLREG_TYPE_GPR_ASZ, { .id = 0x6 } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_READ, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INT1, { .reg = { ZYDIS_IMPLREG_TYPE_FLAGS_SSZ, { .id = 0x3F } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_MEM, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_WRITE, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT64, { .mem = { 1, ZYDIS_IMPLMEM_BASE_ADI } }, ZYAN_FALSE, ZYAN_TRUE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_MEM, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT64, { .mem = { 4, ZYDIS_IMPLMEM_BASE_ASI } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_READWRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .reg = { ZYDIS_IMPLREG_TYPE_GPR_ASZ, { .id = 0x7 } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_READWRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .reg = { ZYDIS_IMPLREG_TYPE_GPR_ASZ, { .id = 0x6 } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_READ, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INT1, { .reg = { ZYDIS_IMPLREG_TYPE_FLAGS_SSZ, { .id = 0x3F } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_MEM, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_WRITE, { 2, 2, 2 }, ZYDIS_IELEMENT_TYPE_INT16, { .mem = { 1, ZYDIS_IMPLMEM_BASE_ADI } }, ZYAN_FALSE, ZYAN_TRUE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_MEM, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_READ, { 2, 2, 2 }, ZYDIS_IELEMENT_TYPE_INT16, { .mem = { 4, ZYDIS_IMPLMEM_BASE_ASI } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_READWRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .reg = { ZYDIS_IMPLREG_TYPE_GPR_ASZ, { .id = 0x7 } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_READWRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .reg = { ZYDIS_IMPLREG_TYPE_GPR_ASZ, { .id = 0x6 } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_READ, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INT1, { .reg = { ZYDIS_IMPLREG_TYPE_FLAGS_SSZ, { .id = 0x3F } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_INT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_INT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_UIMM8 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_WRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .reg = { ZYDIS_IMPLREG_TYPE_STATIC, { .reg = ZYDIS_REGISTER_ECX } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_WRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INT1, { .reg = { ZYDIS_IMPLREG_TYPE_FLAGS_SSZ, { .id = 0x3F } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_INT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_INT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_UIMM8 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_WRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .reg = { ZYDIS_IMPLREG_TYPE_STATIC, { .reg = ZYDIS_REGISTER_ECX } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_WRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INT1, { .reg = { ZYDIS_IMPLREG_TYPE_FLAGS_SSZ, { .id = 0x3F } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_INT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_INT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_UIMM8 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_WRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_INT32, { .reg = { ZYDIS_IMPLREG_TYPE_STATIC, { .reg = ZYDIS_REGISTER_XMM0 } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_WRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INT1, { .reg = { ZYDIS_IMPLREG_TYPE_FLAGS_SSZ, { .id = 0x3F } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_INT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_INT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_UIMM8 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_WRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_INT32, { .reg = { ZYDIS_IMPLREG_TYPE_STATIC, { .reg = ZYDIS_REGISTER_XMM0 } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_WRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INT1, { .reg = { ZYDIS_IMPLREG_TYPE_FLAGS_SSZ, { .id = 0x3F } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_READWRITE, { 4, 4, 4 }, ZYDIS_IELEMENT_TYPE_UINT32, { .reg = { ZYDIS_IMPLREG_TYPE_STATIC, { .reg = ZYDIS_REGISTER_EAX } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_CONDREAD_WRITE, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_UINT64, { .reg = { ZYDIS_IMPLREG_TYPE_STATIC, { .reg = ZYDIS_REGISTER_RBX } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_CONDREAD_WRITE, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_UINT64, { .reg = { ZYDIS_IMPLREG_TYPE_STATIC, { .reg = ZYDIS_REGISTER_RCX } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_CONDREAD_WRITE, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_UINT64, { .reg = { ZYDIS_IMPLREG_TYPE_STATIC, { .reg = ZYDIS_REGISTER_RDX } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_WRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INT1, { .reg = { ZYDIS_IMPLREG_TYPE_FLAGS_SSZ, { .id = 0x3F } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_READWRITE, { 4, 4, 4 }, ZYDIS_IELEMENT_TYPE_UINT32, { .reg = { ZYDIS_IMPLREG_TYPE_STATIC, { .reg = ZYDIS_REGISTER_EAX } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_CONDREAD_WRITE, { 4, 4, 4 }, ZYDIS_IELEMENT_TYPE_UINT32, { .reg = { ZYDIS_IMPLREG_TYPE_STATIC, { .reg = ZYDIS_REGISTER_EBX } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_CONDREAD_WRITE, { 4, 4, 4 }, ZYDIS_IELEMENT_TYPE_UINT32, { .reg = { ZYDIS_IMPLREG_TYPE_STATIC, { .reg = ZYDIS_REGISTER_ECX } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_CONDREAD_WRITE, { 4, 4, 4 }, ZYDIS_IELEMENT_TYPE_UINT32, { .reg = { ZYDIS_IMPLREG_TYPE_STATIC, { .reg = ZYDIS_REGISTER_EDX } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_WRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INT1, { .reg = { ZYDIS_IMPLREG_TYPE_FLAGS_SSZ, { .id = 0x3F } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_MEM, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_CONDWRITE, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_UINT8, { .mem = { 1, ZYDIS_IMPLMEM_BASE_ADI } }, ZYAN_FALSE, ZYAN_TRUE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_READ, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .reg = { ZYDIS_IMPLREG_TYPE_STATIC, { .reg = ZYDIS_REGISTER_AL } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_CONDWRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .reg = { ZYDIS_IMPLREG_TYPE_GPR_ASZ, { .id = 0x7 } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_READ_CONDWRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .reg = { ZYDIS_IMPLREG_TYPE_GPR_ASZ, { .id = 0x1 } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_READ, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INT1, { .reg = { ZYDIS_IMPLREG_TYPE_FLAGS_SSZ, { .id = 0x3F } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_MEM, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_CONDWRITE, { 4, 4, 4 }, ZYDIS_IELEMENT_TYPE_INT32, { .mem = { 1, ZYDIS_IMPLMEM_BASE_ADI } }, ZYAN_FALSE, ZYAN_TRUE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_READ, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .reg = { ZYDIS_IMPLREG_TYPE_STATIC, { .reg = ZYDIS_REGISTER_EAX } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_CONDWRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .reg = { ZYDIS_IMPLREG_TYPE_GPR_ASZ, { .id = 0x7 } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_READ_CONDWRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .reg = { ZYDIS_IMPLREG_TYPE_GPR_ASZ, { .id = 0x1 } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_READ, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INT1, { .reg = { ZYDIS_IMPLREG_TYPE_FLAGS_SSZ, { .id = 0x3F } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_MEM, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_CONDWRITE, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT64, { .mem = { 1, ZYDIS_IMPLMEM_BASE_ADI } }, ZYAN_FALSE, ZYAN_TRUE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_READ, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .reg = { ZYDIS_IMPLREG_TYPE_STATIC, { .reg = ZYDIS_REGISTER_RAX } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_CONDWRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .reg = { ZYDIS_IMPLREG_TYPE_GPR_ASZ, { .id = 0x7 } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_READ_CONDWRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .reg = { ZYDIS_IMPLREG_TYPE_GPR_ASZ, { .id = 0x1 } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_READ, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INT1, { .reg = { ZYDIS_IMPLREG_TYPE_FLAGS_SSZ, { .id = 0x3F } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_MEM, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_CONDWRITE, { 2, 2, 2 }, ZYDIS_IELEMENT_TYPE_INT16, { .mem = { 1, ZYDIS_IMPLMEM_BASE_ADI } }, ZYAN_FALSE, ZYAN_TRUE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_READ, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .reg = { ZYDIS_IMPLREG_TYPE_STATIC, { .reg = ZYDIS_REGISTER_AX } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_CONDWRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .reg = { ZYDIS_IMPLREG_TYPE_GPR_ASZ, { .id = 0x7 } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_READ_CONDWRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .reg = { ZYDIS_IMPLREG_TYPE_GPR_ASZ, { .id = 0x1 } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_READ, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INT1, { .reg = { ZYDIS_IMPLREG_TYPE_FLAGS_SSZ, { .id = 0x3F } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_CONDWRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .reg = { ZYDIS_IMPLREG_TYPE_STATIC, { .reg = ZYDIS_REGISTER_EAX } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_READ_CONDWRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .reg = { ZYDIS_IMPLREG_TYPE_GPR_ASZ, { .id = 0x1 } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_READ_CONDWRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .reg = { ZYDIS_IMPLREG_TYPE_STATIC, { .reg = ZYDIS_REGISTER_EDX } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_READ_CONDWRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .reg = { ZYDIS_IMPLREG_TYPE_GPR_ASZ, { .id = 0x7 } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_MEM, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_CONDWRITE, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_INT, { .mem = { 1, ZYDIS_IMPLMEM_BASE_ADI } }, ZYAN_FALSE, ZYAN_TRUE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_FLOAT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_FLOAT64, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_FLOAT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_FLOAT64, { .encoding = ZYDIS_OPERAND_ENCODING_IS4 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_IS4 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_FLOAT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_FLOAT64, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_FLOAT64, { .encoding = ZYDIS_OPERAND_ENCODING_IS4 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_FLOAT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_IS4 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_FLOAT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_FLOAT64, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_FLOAT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_FLOAT64, { .encoding = ZYDIS_OPERAND_ENCODING_IS4 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_IS4 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_FLOAT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_FLOAT64, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_FLOAT64, { .encoding = ZYDIS_OPERAND_ENCODING_IS4 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_FLOAT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_IS4 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_FLOAT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_FLOAT64, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_FLOAT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_FLOAT64, { .encoding = ZYDIS_OPERAND_ENCODING_IS4 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_IS4 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_FLOAT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_FLOAT64, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_FLOAT64, { .encoding = ZYDIS_OPERAND_ENCODING_IS4 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_FLOAT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_IS4 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_FLOAT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_FLOAT64, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_FLOAT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_FLOAT64, { .encoding = ZYDIS_OPERAND_ENCODING_IS4 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_IS4 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_FLOAT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_FLOAT64, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_FLOAT64, { .encoding = ZYDIS_OPERAND_ENCODING_IS4 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_FLOAT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_IS4 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_FLOAT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_FLOAT32, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_FLOAT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_FLOAT32, { .encoding = ZYDIS_OPERAND_ENCODING_IS4 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_IS4 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_FLOAT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_FLOAT32, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_FLOAT32, { .encoding = ZYDIS_OPERAND_ENCODING_IS4 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_FLOAT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_IS4 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_FLOAT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_FLOAT32, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_FLOAT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_FLOAT32, { .encoding = ZYDIS_OPERAND_ENCODING_IS4 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_IS4 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_FLOAT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_FLOAT32, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_FLOAT32, { .encoding = ZYDIS_OPERAND_ENCODING_IS4 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_FLOAT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_IS4 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_FLOAT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_FLOAT32, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_FLOAT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_FLOAT32, { .encoding = ZYDIS_OPERAND_ENCODING_IS4 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_IS4 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_FLOAT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_FLOAT32, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_FLOAT32, { .encoding = ZYDIS_OPERAND_ENCODING_IS4 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_FLOAT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_IS4 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_FLOAT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_FLOAT32, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_FLOAT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_FLOAT32, { .encoding = ZYDIS_OPERAND_ENCODING_IS4 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_IS4 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_FLOAT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_FLOAT32, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_FLOAT32, { .encoding = ZYDIS_OPERAND_ENCODING_IS4 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_FLOAT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_IS4 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_UINT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_UINT32, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_UINT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_UIMM8 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_UINT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_UINT32, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_UINT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_UIMM8 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_ZMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_UINT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_ZMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_UINT32, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_ZMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_UINT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_UIMM8 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_UINT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_UINT32, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_UINT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_UIMM8 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_UINT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_UINT32, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_UINT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_UIMM8 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_ZMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_UINT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_ZMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_UINT32, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_UINT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_UIMM8 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_UINT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_UINT64, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_UINT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_UIMM8 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_UINT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_UINT64, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_UINT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_UIMM8 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_ZMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_UINT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_ZMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_UINT64, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_ZMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_UINT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_UIMM8 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_UINT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_UINT64, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_UINT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_UIMM8 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_UINT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_UINT64, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_UINT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_UIMM8 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_ZMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_UINT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_ZMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_UINT64, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_UINT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_UIMM8 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_ZMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_FLOAT64, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_ZMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_FLOAT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_CC5, { .encoding = ZYDIS_OPERAND_ENCODING_UIMM8 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_FLOAT64, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_FLOAT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_CC5, { .encoding = ZYDIS_OPERAND_ENCODING_UIMM8 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_FLOAT64, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_FLOAT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_CC5, { .encoding = ZYDIS_OPERAND_ENCODING_UIMM8 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_FLOAT64, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_FLOAT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_CC5, { .encoding = ZYDIS_OPERAND_ENCODING_UIMM8 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_FLOAT64, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_FLOAT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_CC5, { .encoding = ZYDIS_OPERAND_ENCODING_UIMM8 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_ZMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_FLOAT64, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_FLOAT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_CC5, { .encoding = ZYDIS_OPERAND_ENCODING_UIMM8 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_ZMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_FLOAT16, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_ZMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_FLOAT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_UIMM8 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_FLOAT16, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_FLOAT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_UIMM8 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_FLOAT16, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_FLOAT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_UIMM8 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_FLOAT16, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_FLOAT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_UIMM8 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_FLOAT16, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_FLOAT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_UIMM8 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_ZMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_FLOAT16, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_FLOAT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_UIMM8 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_ZMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_FLOAT32, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_ZMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_FLOAT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_CC5, { .encoding = ZYDIS_OPERAND_ENCODING_UIMM8 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_FLOAT32, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_FLOAT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_CC5, { .encoding = ZYDIS_OPERAND_ENCODING_UIMM8 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_FLOAT32, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_FLOAT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_CC5, { .encoding = ZYDIS_OPERAND_ENCODING_UIMM8 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_FLOAT32, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_FLOAT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_CC5, { .encoding = ZYDIS_OPERAND_ENCODING_UIMM8 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_FLOAT32, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_FLOAT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_CC5, { .encoding = ZYDIS_OPERAND_ENCODING_UIMM8 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_ZMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_FLOAT32, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_FLOAT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_CC5, { .encoding = ZYDIS_OPERAND_ENCODING_UIMM8 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_FLOAT64, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_FLOAT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_CC5, { .encoding = ZYDIS_OPERAND_ENCODING_UIMM8 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_FLOAT16, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 2, 2, 2 }, ZYDIS_IELEMENT_TYPE_FLOAT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_UIMM8 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_FLOAT32, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 4, 4, 4 }, ZYDIS_IELEMENT_TYPE_FLOAT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_CC5, { .encoding = ZYDIS_OPERAND_ENCODING_UIMM8 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_UINT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_UIMM8 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_UINT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_UIMM8 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_ZMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_UINT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_ZMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_ZMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_UIMM8 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_UINT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_UIMM8 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_UINT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_UIMM8 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_ZMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_UINT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_ZMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_UIMM8 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_ZMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READWRITE, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_FLOAT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_ZMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_FLOAT64, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_ZMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_FLOAT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_UIMM8 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READWRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_FLOAT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_FLOAT64, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_FLOAT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_UIMM8 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READWRITE, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_FLOAT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_FLOAT64, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_FLOAT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_UIMM8 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READWRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_FLOAT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_FLOAT64, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_FLOAT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_UIMM8 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READWRITE, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_FLOAT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_FLOAT64, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_FLOAT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_UIMM8 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_ZMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READWRITE, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_FLOAT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_ZMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_FLOAT64, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_FLOAT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_UIMM8 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_ZMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READWRITE, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_FLOAT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_ZMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_FLOAT32, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_ZMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_FLOAT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_UIMM8 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READWRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_FLOAT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_FLOAT32, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_FLOAT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_UIMM8 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READWRITE, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_FLOAT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_FLOAT32, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_FLOAT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_UIMM8 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READWRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_FLOAT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_FLOAT32, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_FLOAT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_UIMM8 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READWRITE, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_FLOAT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_FLOAT32, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_FLOAT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_UIMM8 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_ZMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READWRITE, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_FLOAT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_ZMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_FLOAT32, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_FLOAT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_UIMM8 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READWRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_FLOAT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_FLOAT64, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_FLOAT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_UIMM8 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READWRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_FLOAT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_FLOAT32, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 4, 4, 4 }, ZYDIS_IELEMENT_TYPE_FLOAT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_UIMM8 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_FLOAT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_FLOAT64, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_FLOAT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_UIMM8 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_FLOAT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_FLOAT64, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_FLOAT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_UIMM8 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_FLOAT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_FLOAT16, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_FLOAT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_UIMM8 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_FLOAT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_FLOAT16, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 2, 2, 2 }, ZYDIS_IELEMENT_TYPE_FLOAT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_UIMM8 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_FLOAT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_FLOAT32, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_FLOAT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_UIMM8 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_FLOAT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_FLOAT32, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 4, 4, 4 }, ZYDIS_IELEMENT_TYPE_FLOAT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_UIMM8 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_UINT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_UIMM8 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_UINT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_UIMM8 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_ZMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_ZMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_ZMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_UINT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_UIMM8 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_UINT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_UIMM8 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_UINT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_UIMM8 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_ZMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_ZMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_UINT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_UIMM8 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_FLOAT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_FLOAT32, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_FLOAT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_UIMM8 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_ZMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_FLOAT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_ZMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_FLOAT32, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_FLOAT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_UIMM8 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_FLOAT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_FLOAT32, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_FLOAT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_UIMM8 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_ZMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_FLOAT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_ZMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_FLOAT32, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_FLOAT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_UIMM8 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_ZMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_FLOAT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_ZMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_FLOAT32, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_FLOAT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_UIMM8 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_ZMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_FLOAT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_ZMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_FLOAT32, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_FLOAT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_UIMM8 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_FLOAT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_FLOAT64, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_FLOAT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_UIMM8 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_ZMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_FLOAT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_ZMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_FLOAT64, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_FLOAT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_UIMM8 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_FLOAT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_FLOAT64, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_FLOAT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_UIMM8 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_ZMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_FLOAT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_ZMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_FLOAT64, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_FLOAT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_UIMM8 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_ZMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_FLOAT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_ZMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_FLOAT64, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_FLOAT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_UIMM8 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_ZMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_FLOAT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_ZMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_FLOAT64, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_FLOAT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_UIMM8 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_UINT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_UINT32, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_UINT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_UIMM8 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_ZMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_UINT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_ZMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_UINT32, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_UINT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_UIMM8 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_UINT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_UINT32, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_UINT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_UIMM8 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_ZMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_UINT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_ZMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_UINT32, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_UINT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_UIMM8 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_ZMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_UINT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_ZMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_UINT32, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_UINT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_UIMM8 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_ZMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_UINT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_ZMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_UINT32, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_UINT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_UIMM8 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_UINT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_UINT64, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_UINT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_UIMM8 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_ZMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_UINT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_ZMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_UINT64, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_UINT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_UIMM8 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_UINT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_UINT64, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_UINT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_UIMM8 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_ZMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_UINT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_ZMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_UINT64, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_UINT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_UIMM8 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_ZMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_UINT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_ZMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_UINT64, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_UINT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_UIMM8 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_ZMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_UINT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_ZMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_UINT64, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_UINT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_UIMM8 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_UIMM8 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_UIMM8 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_ZMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_ZMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_ZMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_UIMM8 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_UIMM8 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_UIMM8 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_ZMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_ZMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_UIMM8 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_INT8, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_INT8, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_CC3, { .encoding = ZYDIS_OPERAND_ENCODING_UIMM8 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_INT8, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_INT8, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_CC3, { .encoding = ZYDIS_OPERAND_ENCODING_UIMM8 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_ZMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_INT8, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_ZMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_INT8, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_CC3, { .encoding = ZYDIS_OPERAND_ENCODING_UIMM8 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_INT8, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_INT8, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_CC3, { .encoding = ZYDIS_OPERAND_ENCODING_UIMM8 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_INT8, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_INT8, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_CC3, { .encoding = ZYDIS_OPERAND_ENCODING_UIMM8 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_ZMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_INT8, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_INT8, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_CC3, { .encoding = ZYDIS_OPERAND_ENCODING_UIMM8 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_INT32, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_INT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_CC3, { .encoding = ZYDIS_OPERAND_ENCODING_UIMM8 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_INT32, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_INT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_CC3, { .encoding = ZYDIS_OPERAND_ENCODING_UIMM8 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_ZMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_INT32, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_ZMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_INT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_CC3, { .encoding = ZYDIS_OPERAND_ENCODING_UIMM8 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_INT32, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_CC3, { .encoding = ZYDIS_OPERAND_ENCODING_UIMM8 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_INT32, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_CC3, { .encoding = ZYDIS_OPERAND_ENCODING_UIMM8 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_ZMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_INT32, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_CC3, { .encoding = ZYDIS_OPERAND_ENCODING_UIMM8 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_INT64, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_INT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_CC3, { .encoding = ZYDIS_OPERAND_ENCODING_UIMM8 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_INT64, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_INT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_CC3, { .encoding = ZYDIS_OPERAND_ENCODING_UIMM8 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_ZMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_INT64, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_ZMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_INT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_CC3, { .encoding = ZYDIS_OPERAND_ENCODING_UIMM8 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_INT64, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_CC3, { .encoding = ZYDIS_OPERAND_ENCODING_UIMM8 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_INT64, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_CC3, { .encoding = ZYDIS_OPERAND_ENCODING_UIMM8 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_ZMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_INT64, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_CC3, { .encoding = ZYDIS_OPERAND_ENCODING_UIMM8 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_CC3, { .encoding = ZYDIS_OPERAND_ENCODING_UIMM8 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_CC3, { .encoding = ZYDIS_OPERAND_ENCODING_UIMM8 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_ZMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_ZMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_CC3, { .encoding = ZYDIS_OPERAND_ENCODING_UIMM8 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_CC3, { .encoding = ZYDIS_OPERAND_ENCODING_UIMM8 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_CC3, { .encoding = ZYDIS_OPERAND_ENCODING_UIMM8 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_ZMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_CC3, { .encoding = ZYDIS_OPERAND_ENCODING_UIMM8 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_UINT32, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_UINT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_CC3, { .encoding = ZYDIS_OPERAND_ENCODING_UIMM8 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_UINT32, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_UINT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_CC3, { .encoding = ZYDIS_OPERAND_ENCODING_UIMM8 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_ZMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_UINT32, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_ZMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_UINT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_CC3, { .encoding = ZYDIS_OPERAND_ENCODING_UIMM8 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_UINT32, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_UINT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_CC3, { .encoding = ZYDIS_OPERAND_ENCODING_UIMM8 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_UINT32, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_UINT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_CC3, { .encoding = ZYDIS_OPERAND_ENCODING_UIMM8 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_ZMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_UINT32, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_UINT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_CC3, { .encoding = ZYDIS_OPERAND_ENCODING_UIMM8 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_UINT64, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_UINT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_CC3, { .encoding = ZYDIS_OPERAND_ENCODING_UIMM8 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_UINT64, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_UINT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_CC3, { .encoding = ZYDIS_OPERAND_ENCODING_UIMM8 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_ZMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_UINT64, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_ZMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_UINT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_CC3, { .encoding = ZYDIS_OPERAND_ENCODING_UIMM8 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_UINT64, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_UINT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_CC3, { .encoding = ZYDIS_OPERAND_ENCODING_UIMM8 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_UINT64, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_UINT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_CC3, { .encoding = ZYDIS_OPERAND_ENCODING_UIMM8 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_ZMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_UINT64, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_UINT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_CC3, { .encoding = ZYDIS_OPERAND_ENCODING_UIMM8 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_UINT16, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_UINT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_CC3, { .encoding = ZYDIS_OPERAND_ENCODING_UIMM8 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_UINT16, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_UINT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_CC3, { .encoding = ZYDIS_OPERAND_ENCODING_UIMM8 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_ZMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_UINT16, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_ZMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_UINT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_CC3, { .encoding = ZYDIS_OPERAND_ENCODING_UIMM8 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_UINT16, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_UINT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_CC3, { .encoding = ZYDIS_OPERAND_ENCODING_UIMM8 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_UINT16, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_UINT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_CC3, { .encoding = ZYDIS_OPERAND_ENCODING_UIMM8 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_ZMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_UINT16, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_UINT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_CC3, { .encoding = ZYDIS_OPERAND_ENCODING_UIMM8 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_INT16, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_INT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_CC3, { .encoding = ZYDIS_OPERAND_ENCODING_UIMM8 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_INT16, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_INT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_CC3, { .encoding = ZYDIS_OPERAND_ENCODING_UIMM8 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_ZMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_INT16, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_ZMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_INT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_CC3, { .encoding = ZYDIS_OPERAND_ENCODING_UIMM8 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_INT16, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_INT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_CC3, { .encoding = ZYDIS_OPERAND_ENCODING_UIMM8 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_INT16, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_INT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_CC3, { .encoding = ZYDIS_OPERAND_ENCODING_UIMM8 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_ZMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_INT16, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_INT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_CC3, { .encoding = ZYDIS_OPERAND_ENCODING_UIMM8 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_UINT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_UINT16, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_UINT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_UIMM8 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_UINT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_UINT16, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_UINT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_UIMM8 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_ZMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_UINT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_ZMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_UINT16, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_ZMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_UINT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_UIMM8 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_UINT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_UINT16, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_UINT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_UIMM8 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_UINT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_UINT16, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_UINT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_UIMM8 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_ZMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_UINT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_ZMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_UINT16, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_UINT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_UIMM8 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READWRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_UINT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_UINT32, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_UINT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_UIMM8 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READWRITE, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_UINT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_UINT32, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_UINT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_UIMM8 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_ZMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READWRITE, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_UINT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_ZMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_UINT32, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_ZMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_UINT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_UIMM8 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READWRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_UINT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_UINT32, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_UINT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_UIMM8 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READWRITE, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_UINT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_UINT32, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_UINT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_UIMM8 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_ZMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READWRITE, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_UINT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_ZMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_UINT32, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_UINT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_UIMM8 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READWRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_UINT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_UINT64, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_UINT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_UIMM8 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READWRITE, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_UINT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_UINT64, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_UINT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_UIMM8 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_ZMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READWRITE, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_UINT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_ZMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_UINT64, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_ZMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_UINT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_UIMM8 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READWRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_UINT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_UINT64, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_UINT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_UIMM8 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READWRITE, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_UINT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_UINT64, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_UINT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_UIMM8 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_ZMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READWRITE, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_UINT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_ZMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_UINT64, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_UINT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_UIMM8 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_ZMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_FLOAT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_ZMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_FLOAT64, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_ZMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_FLOAT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_UIMM8 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_FLOAT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_FLOAT64, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_FLOAT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_UIMM8 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_FLOAT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_FLOAT64, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_FLOAT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_UIMM8 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_FLOAT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_FLOAT64, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_FLOAT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_UIMM8 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_ZMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_FLOAT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_ZMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_FLOAT64, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_FLOAT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_UIMM8 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_ZMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_FLOAT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_ZMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_FLOAT32, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_ZMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_FLOAT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_UIMM8 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_FLOAT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_FLOAT32, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_FLOAT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_UIMM8 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_FLOAT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_FLOAT32, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_FLOAT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_UIMM8 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_FLOAT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_FLOAT32, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_FLOAT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_UIMM8 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_ZMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_FLOAT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_ZMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_FLOAT32, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_FLOAT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_UIMM8 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_ZMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READWRITE, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_FLOAT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 2, 2, 2 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_ZMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_FLOAT32, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_ZMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_FLOAT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_UIMM8 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_ZMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READWRITE, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_FLOAT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 2, 2, 2 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_ZMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_FLOAT32, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_FLOAT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_UIMM8 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 2, 2, 2 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 2, 2, 2 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_ZMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_FLOAT64, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_ZMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_FLOAT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_CC5, { .encoding = ZYDIS_OPERAND_ENCODING_UIMM8 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 2, 2, 2 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 2, 2, 2 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_ZMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_FLOAT64, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_VARIABLE, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_CC5, { .encoding = ZYDIS_OPERAND_ENCODING_UIMM8 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 2, 2, 2 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 2, 2, 2 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_ZMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_FLOAT32, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_ZMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_FLOAT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_CC5, { .encoding = ZYDIS_OPERAND_ENCODING_UIMM8 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 2, 2, 2 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 2, 2, 2 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_ZMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_FLOAT32, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_VARIABLE, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_CC5, { .encoding = ZYDIS_OPERAND_ENCODING_UIMM8 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 2, 2, 2 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 2, 2, 2 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_ZMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_INT32, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_ZMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_INT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_CC3, { .encoding = ZYDIS_OPERAND_ENCODING_UIMM8 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 2, 2, 2 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 2, 2, 2 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_ZMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_INT32, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_VARIABLE, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_CC3, { .encoding = ZYDIS_OPERAND_ENCODING_UIMM8 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 2, 2, 2 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 2, 2, 2 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_ZMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_UINT32, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_ZMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_UINT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_CC3, { .encoding = ZYDIS_OPERAND_ENCODING_UIMM8 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 2, 2, 2 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 2, 2, 2 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_ZMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_UINT32, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_VARIABLE, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_CC3, { .encoding = ZYDIS_OPERAND_ENCODING_UIMM8 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_UIMM8 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_READWRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .reg = { ZYDIS_IMPLREG_TYPE_STATIC, { .reg = ZYDIS_REGISTER_AL } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_READWRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .reg = { ZYDIS_IMPLREG_TYPE_STATIC, { .reg = ZYDIS_REGISTER_AH } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_WRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INT1, { .reg = { ZYDIS_IMPLREG_TYPE_FLAGS_SSZ, { .id = 0x3F } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_UIMM8 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_READWRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .reg = { ZYDIS_IMPLREG_TYPE_STATIC, { .reg = ZYDIS_REGISTER_AL } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_WRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .reg = { ZYDIS_IMPLREG_TYPE_STATIC, { .reg = ZYDIS_REGISTER_AH } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_WRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INT1, { .reg = { ZYDIS_IMPLREG_TYPE_FLAGS_SSZ, { .id = 0x3F } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_PTR, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 4, 6, 6 }, ZYDIS_IELEMENT_TYPE_STRUCT, { .encoding = ZYDIS_OPERAND_ENCODING_NONE }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_WRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .reg = { ZYDIS_IMPLREG_TYPE_STATIC, { .reg = ZYDIS_REGISTER_EIP } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_READWRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .reg = { ZYDIS_IMPLREG_TYPE_GPR_SSZ, { .id = 0x4 } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_MEM, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_WRITE, { 4, 8, 16 }, ZYDIS_IELEMENT_TYPE_INT, { .mem = { 0, ZYDIS_IMPLMEM_BASE_SSP } }, ZYAN_FALSE, ZYAN_TRUE },
    { ZYDIS_SEMANTIC_OPTYPE_REL, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 4, 4, 4 }, ZYDIS_IELEMENT_TYPE_INT32, { .encoding = ZYDIS_OPERAND_ENCODING_JIMM32 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_READWRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .reg = { ZYDIS_IMPLREG_TYPE_STATIC, { .reg = ZYDIS_REGISTER_RIP } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_READWRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .reg = { ZYDIS_IMPLREG_TYPE_GPR_SSZ, { .id = 0x4 } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_MEM, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_WRITE, { 2, 4, 8 }, ZYDIS_IELEMENT_TYPE_INT, { .mem = { 0, ZYDIS_IMPLMEM_BASE_SSP } }, ZYAN_FALSE, ZYAN_TRUE },
    { ZYDIS_SEMANTIC_OPTYPE_REL, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 2, 4, 4 }, ZYDIS_IELEMENT_TYPE_INT, { .encoding = ZYDIS_OPERAND_ENCODING_JIMM16_32_32 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_READWRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .reg = { ZYDIS_IMPLREG_TYPE_STATIC, { .reg = ZYDIS_REGISTER_RIP } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_READWRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .reg = { ZYDIS_IMPLREG_TYPE_GPR_SSZ, { .id = 0x4 } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_MEM, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_WRITE, { 2, 4, 8 }, ZYDIS_IELEMENT_TYPE_INT, { .mem = { 0, ZYDIS_IMPLMEM_BASE_SSP } }, ZYAN_FALSE, ZYAN_TRUE },
    { ZYDIS_SEMANTIC_OPTYPE_REL, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 2, 4, 4 }, ZYDIS_IELEMENT_TYPE_INT, { .encoding = ZYDIS_OPERAND_ENCODING_JIMM16_32_32 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_READWRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .reg = { ZYDIS_IMPLREG_TYPE_STATIC, { .reg = ZYDIS_REGISTER_EIP } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_READWRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .reg = { ZYDIS_IMPLREG_TYPE_GPR_SSZ, { .id = 0x4 } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_MEM, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_WRITE, { 2, 4, 8 }, ZYDIS_IELEMENT_TYPE_INT, { .mem = { 0, ZYDIS_IMPLMEM_BASE_SSP } }, ZYAN_FALSE, ZYAN_TRUE },
    { ZYDIS_SEMANTIC_OPTYPE_GPR16_32_64, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_READWRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .reg = { ZYDIS_IMPLREG_TYPE_IP_SSZ, { .id = 0x3F } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_READWRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .reg = { ZYDIS_IMPLREG_TYPE_GPR_SSZ, { .id = 0x4 } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_MEM, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_WRITE, { 2, 4, 8 }, ZYDIS_IELEMENT_TYPE_INT, { .mem = { 0, ZYDIS_IMPLMEM_BASE_SSP } }, ZYAN_FALSE, ZYAN_TRUE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 2, 4, 8 }, ZYDIS_IELEMENT_TYPE_INT, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_READWRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .reg = { ZYDIS_IMPLREG_TYPE_IP_SSZ, { .id = 0x3F } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_READWRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .reg = { ZYDIS_IMPLREG_TYPE_GPR_SSZ, { .id = 0x4 } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_MEM, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_WRITE, { 2, 4, 8 }, ZYDIS_IELEMENT_TYPE_INT, { .mem = { 0, ZYDIS_IMPLMEM_BASE_SSP } }, ZYAN_FALSE, ZYAN_TRUE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 4, 6, 10 }, ZYDIS_IELEMENT_TYPE_STRUCT, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_WRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .reg = { ZYDIS_IMPLREG_TYPE_IP_SSZ, { .id = 0x3F } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_READWRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .reg = { ZYDIS_IMPLREG_TYPE_GPR_SSZ, { .id = 0x4 } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_MEM, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_WRITE, { 4, 8, 16 }, ZYDIS_IELEMENT_TYPE_INT, { .mem = { 0, ZYDIS_IMPLMEM_BASE_SSP } }, ZYAN_FALSE, ZYAN_TRUE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_MEM, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_CONDREAD, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_UINT8, { .mem = { 4, ZYDIS_IMPLMEM_BASE_ASI } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_MEM, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_CONDREAD, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_UINT8, { .mem = { 1, ZYDIS_IMPLMEM_BASE_ADI } }, ZYAN_FALSE, ZYAN_TRUE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_READ_CONDWRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .reg = { ZYDIS_IMPLREG_TYPE_GPR_ASZ, { .id = 0x1 } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_READ_CONDWRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INT1, { .reg = { ZYDIS_IMPLREG_TYPE_FLAGS_SSZ, { .id = 0x3F } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_MEM, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_CONDREAD, { 4, 4, 4 }, ZYDIS_IELEMENT_TYPE_INT32, { .mem = { 4, ZYDIS_IMPLMEM_BASE_ASI } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_MEM, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_CONDREAD, { 4, 4, 4 }, ZYDIS_IELEMENT_TYPE_INT32, { .mem = { 1, ZYDIS_IMPLMEM_BASE_ADI } }, ZYAN_FALSE, ZYAN_TRUE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_READ_CONDWRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .reg = { ZYDIS_IMPLREG_TYPE_GPR_ASZ, { .id = 0x1 } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_READ_CONDWRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INT1, { .reg = { ZYDIS_IMPLREG_TYPE_FLAGS_SSZ, { .id = 0x3F } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_MEM, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_CONDREAD, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT64, { .mem = { 4, ZYDIS_IMPLMEM_BASE_ASI } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_MEM, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_CONDREAD, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT64, { .mem = { 1, ZYDIS_IMPLMEM_BASE_ADI } }, ZYAN_FALSE, ZYAN_TRUE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_READ_CONDWRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .reg = { ZYDIS_IMPLREG_TYPE_GPR_ASZ, { .id = 0x1 } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_READ_CONDWRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INT1, { .reg = { ZYDIS_IMPLREG_TYPE_FLAGS_SSZ, { .id = 0x3F } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_MEM, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_CONDREAD, { 2, 2, 2 }, ZYDIS_IELEMENT_TYPE_INT16, { .mem = { 4, ZYDIS_IMPLMEM_BASE_ASI } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_MEM, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_CONDREAD, { 2, 2, 2 }, ZYDIS_IELEMENT_TYPE_INT16, { .mem = { 1, ZYDIS_IMPLMEM_BASE_ADI } }, ZYAN_FALSE, ZYAN_TRUE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_READ_CONDWRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .reg = { ZYDIS_IMPLREG_TYPE_GPR_ASZ, { .id = 0x1 } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_READ_CONDWRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INT1, { .reg = { ZYDIS_IMPLREG_TYPE_FLAGS_SSZ, { .id = 0x3F } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_GPR8, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ_CONDWRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_GPR8, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_READ_CONDWRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .reg = { ZYDIS_IMPLREG_TYPE_STATIC, { .reg = ZYDIS_REGISTER_AL } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_WRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INT1, { .reg = { ZYDIS_IMPLREG_TYPE_FLAGS_SSZ, { .id = 0x3F } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ_CONDWRITE, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_INT8, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_GPR8, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_READ_CONDWRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .reg = { ZYDIS_IMPLREG_TYPE_STATIC, { .reg = ZYDIS_REGISTER_AL } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_WRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INT1, { .reg = { ZYDIS_IMPLREG_TYPE_FLAGS_SSZ, { .id = 0x3F } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_GPR16_32_64, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ_CONDWRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_GPR16_32_64, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_READ_CONDWRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .reg = { ZYDIS_IMPLREG_TYPE_GPR_OSZ, { .id = 0x0 } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_WRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INT1, { .reg = { ZYDIS_IMPLREG_TYPE_FLAGS_SSZ, { .id = 0x3F } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ_CONDWRITE, { 2, 4, 8 }, ZYDIS_IELEMENT_TYPE_INT, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_GPR16_32_64, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_READ_CONDWRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .reg = { ZYDIS_IMPLREG_TYPE_GPR_OSZ, { .id = 0x0 } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_WRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INT1, { .reg = { ZYDIS_IMPLREG_TYPE_FLAGS_SSZ, { .id = 0x3F } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_READWRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .reg = { ZYDIS_IMPLREG_TYPE_STATIC, { .reg = ZYDIS_REGISTER_EAX } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_WRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .reg = { ZYDIS_IMPLREG_TYPE_STATIC, { .reg = ZYDIS_REGISTER_EBX } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_CONDREAD_WRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .reg = { ZYDIS_IMPLREG_TYPE_STATIC, { .reg = ZYDIS_REGISTER_ECX } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_WRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .reg = { ZYDIS_IMPLREG_TYPE_STATIC, { .reg = ZYDIS_REGISTER_EDX } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_GPR16_32_64, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_UINT, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_READWRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_UINT, { .reg = { ZYDIS_IMPLREG_TYPE_GPR_OSZ, { .id = 0x0 } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_READWRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_UINT, { .reg = { ZYDIS_IMPLREG_TYPE_GPR_OSZ, { .id = 0x2 } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_WRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INT1, { .reg = { ZYDIS_IMPLREG_TYPE_FLAGS_SSZ, { .id = 0x3F } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 2, 4, 8 }, ZYDIS_IELEMENT_TYPE_UINT, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_READWRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_UINT, { .reg = { ZYDIS_IMPLREG_TYPE_GPR_OSZ, { .id = 0x0 } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_READWRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_UINT, { .reg = { ZYDIS_IMPLREG_TYPE_GPR_OSZ, { .id = 0x2 } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_WRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INT1, { .reg = { ZYDIS_IMPLREG_TYPE_FLAGS_SSZ, { .id = 0x3F } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_READ, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .reg = { ZYDIS_IMPLREG_TYPE_STATIC, { .reg = ZYDIS_REGISTER_EAX } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_CONDREAD_WRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .reg = { ZYDIS_IMPLREG_TYPE_STATIC, { .reg = ZYDIS_REGISTER_RBX } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_CONDREAD_WRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .reg = { ZYDIS_IMPLREG_TYPE_STATIC, { .reg = ZYDIS_REGISTER_RCX } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_CONDREAD_WRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .reg = { ZYDIS_IMPLREG_TYPE_STATIC, { .reg = ZYDIS_REGISTER_RDX } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_READ, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .reg = { ZYDIS_IMPLREG_TYPE_STATIC, { .reg = ZYDIS_REGISTER_EAX } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_CONDREAD_WRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .reg = { ZYDIS_IMPLREG_TYPE_STATIC, { .reg = ZYDIS_REGISTER_EBX } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_CONDREAD_WRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .reg = { ZYDIS_IMPLREG_TYPE_STATIC, { .reg = ZYDIS_REGISTER_ECX } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_CONDREAD_WRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .reg = { ZYDIS_IMPLREG_TYPE_STATIC, { .reg = ZYDIS_REGISTER_EDX } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_READ, { 4, 4, 4 }, ZYDIS_IELEMENT_TYPE_UINT32, { .reg = { ZYDIS_IMPLREG_TYPE_STATIC, { .reg = ZYDIS_REGISTER_EAX } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_CONDREAD_WRITE, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_UINT64, { .reg = { ZYDIS_IMPLREG_TYPE_STATIC, { .reg = ZYDIS_REGISTER_RBX } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_CONDREAD_WRITE, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_UINT64, { .reg = { ZYDIS_IMPLREG_TYPE_STATIC, { .reg = ZYDIS_REGISTER_RCX } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_CONDREAD_WRITE, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_UINT64, { .reg = { ZYDIS_IMPLREG_TYPE_STATIC, { .reg = ZYDIS_REGISTER_RDX } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_READ, { 4, 4, 4 }, ZYDIS_IELEMENT_TYPE_UINT32, { .reg = { ZYDIS_IMPLREG_TYPE_STATIC, { .reg = ZYDIS_REGISTER_EAX } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_CONDREAD_WRITE, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_UINT64, { .reg = { ZYDIS_IMPLREG_TYPE_STATIC, { .reg = ZYDIS_REGISTER_EBX } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_CONDREAD_WRITE, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_UINT64, { .reg = { ZYDIS_IMPLREG_TYPE_STATIC, { .reg = ZYDIS_REGISTER_ECX } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_CONDREAD_WRITE, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_UINT64, { .reg = { ZYDIS_IMPLREG_TYPE_STATIC, { .reg = ZYDIS_REGISTER_EDX } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_IMPLICIT, ZYDIS_OPERAND_ACTION_CONDWRITE, { 10, 10, 10 }, ZYDIS_IELEMENT_TYPE_BFLOAT16X2, { .reg = { ZYDIS_IMPLREG_TYPE_STATIC, { .reg = ZYDIS_REGISTER_ST0 } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_FPR, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 10, 10, 10 }, ZYDIS_IELEMENT_TYPE_BFLOAT16X2, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_READ, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INT1, { .reg = { ZYDIS_IMPLREG_TYPE_FLAGS_SSZ, { .id = 0x3F } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_WRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_STRUCT, { .reg = { ZYDIS_IMPLREG_TYPE_STATIC, { .reg = ZYDIS_REGISTER_X87STATUS } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_IMPLICIT, ZYDIS_OPERAND_ACTION_READ, { 10, 10, 10 }, ZYDIS_IELEMENT_TYPE_BFLOAT16X2, { .reg = { ZYDIS_IMPLREG_TYPE_STATIC, { .reg = ZYDIS_REGISTER_ST0 } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_FPR, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 10, 10, 10 }, ZYDIS_IELEMENT_TYPE_BFLOAT16X2, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_WRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INT1, { .reg = { ZYDIS_IMPLREG_TYPE_FLAGS_SSZ, { .id = 0x3F } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_WRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_STRUCT, { .reg = { ZYDIS_IMPLREG_TYPE_STATIC, { .reg = ZYDIS_REGISTER_X87STATUS } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_GPR16_32_64, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_READWRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .reg = { ZYDIS_IMPLREG_TYPE_GPR_OSZ, { .id = 0x0 } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_READWRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .reg = { ZYDIS_IMPLREG_TYPE_GPR_OSZ, { .id = 0x2 } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_WRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INT1, { .reg = { ZYDIS_IMPLREG_TYPE_FLAGS_SSZ, { .id = 0x3F } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 2, 4, 8 }, ZYDIS_IELEMENT_TYPE_INT, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_READWRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .reg = { ZYDIS_IMPLREG_TYPE_GPR_OSZ, { .id = 0x0 } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_READWRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .reg = { ZYDIS_IMPLREG_TYPE_GPR_OSZ, { .id = 0x2 } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_WRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INT1, { .reg = { ZYDIS_IMPLREG_TYPE_FLAGS_SSZ, { .id = 0x3F } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_GPR16_32_64, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_GPR16_32_64, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 2, 4, 4 }, ZYDIS_IELEMENT_TYPE_INT, { .encoding = ZYDIS_OPERAND_ENCODING_SIMM16_32_32 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_WRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INT1, { .reg = { ZYDIS_IMPLREG_TYPE_FLAGS_SSZ, { .id = 0x3F } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_GPR16_32_64, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 2, 4, 8 }, ZYDIS_IELEMENT_TYPE_INT, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 2, 4, 4 }, ZYDIS_IELEMENT_TYPE_INT, { .encoding = ZYDIS_OPERAND_ENCODING_SIMM16_32_32 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_WRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INT1, { .reg = { ZYDIS_IMPLREG_TYPE_FLAGS_SSZ, { .id = 0x3F } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_GPR16_32_64, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_GPR16_32_64, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_INT8, { .encoding = ZYDIS_OPERAND_ENCODING_SIMM8 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_WRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INT1, { .reg = { ZYDIS_IMPLREG_TYPE_FLAGS_SSZ, { .id = 0x3F } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_GPR16_32_64, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 2, 4, 8 }, ZYDIS_IELEMENT_TYPE_INT, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_INT8, { .encoding = ZYDIS_OPERAND_ENCODING_SIMM8 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_WRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INT1, { .reg = { ZYDIS_IMPLREG_TYPE_FLAGS_SSZ, { .id = 0x3F } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_GPR8, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_READ, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .reg = { ZYDIS_IMPLREG_TYPE_STATIC, { .reg = ZYDIS_REGISTER_AL } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_WRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .reg = { ZYDIS_IMPLREG_TYPE_STATIC, { .reg = ZYDIS_REGISTER_AX } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_WRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INT1, { .reg = { ZYDIS_IMPLREG_TYPE_FLAGS_SSZ, { .id = 0x3F } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_INT8, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_READ, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .reg = { ZYDIS_IMPLREG_TYPE_STATIC, { .reg = ZYDIS_REGISTER_AL } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_WRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .reg = { ZYDIS_IMPLREG_TYPE_STATIC, { .reg = ZYDIS_REGISTER_AX } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_WRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INT1, { .reg = { ZYDIS_IMPLREG_TYPE_FLAGS_SSZ, { .id = 0x3F } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_GPR16_32_64, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_READWRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .reg = { ZYDIS_IMPLREG_TYPE_GPR_OSZ, { .id = 0x0 } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_WRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .reg = { ZYDIS_IMPLREG_TYPE_GPR_OSZ, { .id = 0x2 } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_WRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INT1, { .reg = { ZYDIS_IMPLREG_TYPE_FLAGS_SSZ, { .id = 0x3F } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 2, 4, 8 }, ZYDIS_IELEMENT_TYPE_INT, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_READWRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .reg = { ZYDIS_IMPLREG_TYPE_GPR_OSZ, { .id = 0x0 } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_WRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .reg = { ZYDIS_IMPLREG_TYPE_GPR_OSZ, { .id = 0x2 } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_WRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INT1, { .reg = { ZYDIS_IMPLREG_TYPE_FLAGS_SSZ, { .id = 0x3F } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_MEM, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_CONDWRITE, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_UINT8, { .mem = { 1, ZYDIS_IMPLMEM_BASE_ADI } }, ZYAN_FALSE, ZYAN_TRUE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_READ, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .reg = { ZYDIS_IMPLREG_TYPE_STATIC, { .reg = ZYDIS_REGISTER_DX } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_READ_CONDWRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .reg = { ZYDIS_IMPLREG_TYPE_GPR_ASZ, { .id = 0x1 } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_READ, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INT1, { .reg = { ZYDIS_IMPLREG_TYPE_FLAGS_SSZ, { .id = 0x3F } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_MEM, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_CONDWRITE, { 4, 4, 4 }, ZYDIS_IELEMENT_TYPE_INT32, { .mem = { 1, ZYDIS_IMPLMEM_BASE_ADI } }, ZYAN_FALSE, ZYAN_TRUE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_READ, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .reg = { ZYDIS_IMPLREG_TYPE_STATIC, { .reg = ZYDIS_REGISTER_DX } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_READ_CONDWRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .reg = { ZYDIS_IMPLREG_TYPE_GPR_ASZ, { .id = 0x1 } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_READ, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INT1, { .reg = { ZYDIS_IMPLREG_TYPE_FLAGS_SSZ, { .id = 0x3F } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_UIMM8 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_UIMM8 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_MEM, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_CONDWRITE, { 2, 2, 2 }, ZYDIS_IELEMENT_TYPE_INT16, { .mem = { 1, ZYDIS_IMPLMEM_BASE_ADI } }, ZYAN_FALSE, ZYAN_TRUE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_READ, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .reg = { ZYDIS_IMPLREG_TYPE_STATIC, { .reg = ZYDIS_REGISTER_DX } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_READ_CONDWRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .reg = { ZYDIS_IMPLREG_TYPE_GPR_ASZ, { .id = 0x1 } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_READ, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INT1, { .reg = { ZYDIS_IMPLREG_TYPE_FLAGS_SSZ, { .id = 0x3F } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_WRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .reg = { ZYDIS_IMPLREG_TYPE_IP_SSZ, { .id = 0x3F } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_READWRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .reg = { ZYDIS_IMPLREG_TYPE_GPR_SSZ, { .id = 0x4 } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_MEM, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_READ, { 10, 20, 40 }, ZYDIS_IELEMENT_TYPE_INT, { .mem = { 0, ZYDIS_IMPLMEM_BASE_SSP } }, ZYAN_FALSE, ZYAN_TRUE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_READWRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INT1, { .reg = { ZYDIS_IMPLREG_TYPE_FLAGS_SSZ, { .id = 0x3F } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_WRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .reg = { ZYDIS_IMPLREG_TYPE_STATIC, { .reg = ZYDIS_REGISTER_RIP } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_READWRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .reg = { ZYDIS_IMPLREG_TYPE_GPR_SSZ, { .id = 0x4 } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_MEM, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_READ, { 10, 20, 40 }, ZYDIS_IELEMENT_TYPE_INT, { .mem = { 0, ZYDIS_IMPLMEM_BASE_SSP } }, ZYAN_FALSE, ZYAN_TRUE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_READWRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INT1, { .reg = { ZYDIS_IMPLREG_TYPE_FLAGS_SSZ, { .id = 0x3F } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_WRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .reg = { ZYDIS_IMPLREG_TYPE_STATIC, { .reg = ZYDIS_REGISTER_AL } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_MEM, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_READ, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_UINT8, { .mem = { 4, ZYDIS_IMPLMEM_BASE_ASI } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_READ_CONDWRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .reg = { ZYDIS_IMPLREG_TYPE_GPR_ASZ, { .id = 0x6 } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_READ, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INT1, { .reg = { ZYDIS_IMPLREG_TYPE_FLAGS_SSZ, { .id = 0x3F } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_WRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .reg = { ZYDIS_IMPLREG_TYPE_STATIC, { .reg = ZYDIS_REGISTER_EAX } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_MEM, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_READ, { 4, 4, 4 }, ZYDIS_IELEMENT_TYPE_INT32, { .mem = { 4, ZYDIS_IMPLMEM_BASE_ASI } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_READ_CONDWRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .reg = { ZYDIS_IMPLREG_TYPE_GPR_ASZ, { .id = 0x6 } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_READ, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INT1, { .reg = { ZYDIS_IMPLREG_TYPE_FLAGS_SSZ, { .id = 0x3F } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_WRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .reg = { ZYDIS_IMPLREG_TYPE_STATIC, { .reg = ZYDIS_REGISTER_RAX } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_MEM, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT64, { .mem = { 4, ZYDIS_IMPLMEM_BASE_ASI } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_READ_CONDWRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .reg = { ZYDIS_IMPLREG_TYPE_GPR_ASZ, { .id = 0x6 } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_READ, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INT1, { .reg = { ZYDIS_IMPLREG_TYPE_FLAGS_SSZ, { .id = 0x3F } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_WRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .reg = { ZYDIS_IMPLREG_TYPE_STATIC, { .reg = ZYDIS_REGISTER_AX } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_MEM, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_READ, { 2, 2, 2 }, ZYDIS_IELEMENT_TYPE_INT16, { .mem = { 4, ZYDIS_IMPLMEM_BASE_ASI } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_READ_CONDWRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .reg = { ZYDIS_IMPLREG_TYPE_GPR_ASZ, { .id = 0x6 } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_READ, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INT1, { .reg = { ZYDIS_IMPLREG_TYPE_FLAGS_SSZ, { .id = 0x3F } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_REL, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_INT8, { .encoding = ZYDIS_OPERAND_ENCODING_JIMM8 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_READWRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .reg = { ZYDIS_IMPLREG_TYPE_GPR_ASZ, { .id = 0x1 } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_READWRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .reg = { ZYDIS_IMPLREG_TYPE_IP_SSZ, { .id = 0x3F } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_READ, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INT1, { .reg = { ZYDIS_IMPLREG_TYPE_FLAGS_SSZ, { .id = 0x3F } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_GPR8, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_UINT, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_READ, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_UINT, { .reg = { ZYDIS_IMPLREG_TYPE_STATIC, { .reg = ZYDIS_REGISTER_AL } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_WRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_UINT, { .reg = { ZYDIS_IMPLREG_TYPE_STATIC, { .reg = ZYDIS_REGISTER_AX } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_WRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INT1, { .reg = { ZYDIS_IMPLREG_TYPE_FLAGS_SSZ, { .id = 0x3F } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_READ, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_UINT, { .reg = { ZYDIS_IMPLREG_TYPE_STATIC, { .reg = ZYDIS_REGISTER_AL } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_WRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_UINT, { .reg = { ZYDIS_IMPLREG_TYPE_STATIC, { .reg = ZYDIS_REGISTER_AX } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_WRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INT1, { .reg = { ZYDIS_IMPLREG_TYPE_FLAGS_SSZ, { .id = 0x3F } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_GPR16_32_64, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_UINT, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_READWRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_UINT, { .reg = { ZYDIS_IMPLREG_TYPE_GPR_OSZ, { .id = 0x0 } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_WRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_UINT, { .reg = { ZYDIS_IMPLREG_TYPE_GPR_OSZ, { .id = 0x2 } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_WRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INT1, { .reg = { ZYDIS_IMPLREG_TYPE_FLAGS_SSZ, { .id = 0x3F } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 2, 4, 8 }, ZYDIS_IELEMENT_TYPE_UINT, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_READWRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_UINT, { .reg = { ZYDIS_IMPLREG_TYPE_GPR_OSZ, { .id = 0x0 } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_WRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_UINT, { .reg = { ZYDIS_IMPLREG_TYPE_GPR_OSZ, { .id = 0x2 } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_WRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INT1, { .reg = { ZYDIS_IMPLREG_TYPE_FLAGS_SSZ, { .id = 0x3F } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_READ, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .reg = { ZYDIS_IMPLREG_TYPE_STATIC, { .reg = ZYDIS_REGISTER_DX } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_MEM, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_CONDREAD, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_UINT8, { .mem = { 4, ZYDIS_IMPLMEM_BASE_ASI } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_READ_CONDWRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .reg = { ZYDIS_IMPLREG_TYPE_GPR_ASZ, { .id = 0x1 } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_READ, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INT1, { .reg = { ZYDIS_IMPLREG_TYPE_FLAGS_SSZ, { .id = 0x3F } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_READ, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .reg = { ZYDIS_IMPLREG_TYPE_STATIC, { .reg = ZYDIS_REGISTER_DX } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_MEM, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_CONDREAD, { 4, 4, 4 }, ZYDIS_IELEMENT_TYPE_INT32, { .mem = { 4, ZYDIS_IMPLMEM_BASE_ASI } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_READ_CONDWRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .reg = { ZYDIS_IMPLREG_TYPE_GPR_ASZ, { .id = 0x1 } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_READ, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INT1, { .reg = { ZYDIS_IMPLREG_TYPE_FLAGS_SSZ, { .id = 0x3F } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_READ, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .reg = { ZYDIS_IMPLREG_TYPE_STATIC, { .reg = ZYDIS_REGISTER_DX } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_MEM, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_CONDREAD, { 2, 2, 2 }, ZYDIS_IELEMENT_TYPE_INT16, { .mem = { 4, ZYDIS_IMPLMEM_BASE_ASI } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_READ_CONDWRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .reg = { ZYDIS_IMPLREG_TYPE_GPR_ASZ, { .id = 0x1 } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_READ, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INT1, { .reg = { ZYDIS_IMPLREG_TYPE_FLAGS_SSZ, { .id = 0x3F } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_WRITE, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_UINT64, { .reg = { ZYDIS_IMPLREG_TYPE_STATIC, { .reg = ZYDIS_REGISTER_RAX } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_UINT64, { .reg = { ZYDIS_IMPLREG_TYPE_STATIC, { .reg = ZYDIS_REGISTER_RBX } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_UINT64, { .reg = { ZYDIS_IMPLREG_TYPE_STATIC, { .reg = ZYDIS_REGISTER_RCX } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_WRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INT1, { .reg = { ZYDIS_IMPLREG_TYPE_FLAGS_SSZ, { .id = 0x3F } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_IMPLICIT, ZYDIS_OPERAND_ACTION_READWRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .reg = { ZYDIS_IMPLREG_TYPE_GPR_ASZ, { .id = 0x0 } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_IMPLICIT, ZYDIS_OPERAND_ACTION_READ, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .reg = { ZYDIS_IMPLREG_TYPE_STATIC, { .reg = ZYDIS_REGISTER_ECX } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_IMPLICIT, ZYDIS_OPERAND_ACTION_READ, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .reg = { ZYDIS_IMPLREG_TYPE_STATIC, { .reg = ZYDIS_REGISTER_EDX } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_WRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INT1, { .reg = { ZYDIS_IMPLREG_TYPE_FLAGS_SSZ, { .id = 0x3F } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_READ, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_STRUCT, { .reg = { ZYDIS_IMPLREG_TYPE_STATIC, { .reg = ZYDIS_REGISTER_PKRU } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_WRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .reg = { ZYDIS_IMPLREG_TYPE_STATIC, { .reg = ZYDIS_REGISTER_EDX } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_WRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .reg = { ZYDIS_IMPLREG_TYPE_STATIC, { .reg = ZYDIS_REGISTER_EAX } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_READ, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .reg = { ZYDIS_IMPLREG_TYPE_STATIC, { .reg = ZYDIS_REGISTER_ECX } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 2, 2, 2 }, ZYDIS_IELEMENT_TYPE_UINT16, { .encoding = ZYDIS_OPERAND_ENCODING_UIMM16 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_WRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .reg = { ZYDIS_IMPLREG_TYPE_IP_SSZ, { .id = 0x3F } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_READWRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .reg = { ZYDIS_IMPLREG_TYPE_GPR_SSZ, { .id = 0x4 } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_MEM, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_READ, { 2, 4, 8 }, ZYDIS_IELEMENT_TYPE_INT, { .mem = { 0, ZYDIS_IMPLMEM_BASE_SSP } }, ZYAN_FALSE, ZYAN_TRUE },
    { ZYDIS_SEMANTIC_OPTYPE_IMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 2, 2, 2 }, ZYDIS_IELEMENT_TYPE_UINT16, { .encoding = ZYDIS_OPERAND_ENCODING_UIMM16 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_WRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .reg = { ZYDIS_IMPLREG_TYPE_IP_SSZ, { .id = 0x3F } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_READWRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .reg = { ZYDIS_IMPLREG_TYPE_GPR_SSZ, { .id = 0x4 } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_MEM, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_READ, { 4, 8, 16 }, ZYDIS_IELEMENT_TYPE_INT, { .mem = { 0, ZYDIS_IMPLMEM_BASE_SSP } }, ZYAN_FALSE, ZYAN_TRUE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_IMPLICIT, ZYDIS_OPERAND_ACTION_READWRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .reg = { ZYDIS_IMPLREG_TYPE_STATIC, { .reg = ZYDIS_REGISTER_RAX } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_IMPLICIT, ZYDIS_OPERAND_ACTION_READ, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .reg = { ZYDIS_IMPLREG_TYPE_STATIC, { .reg = ZYDIS_REGISTER_RCX } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_IMPLICIT, ZYDIS_OPERAND_ACTION_READ, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .reg = { ZYDIS_IMPLREG_TYPE_STATIC, { .reg = ZYDIS_REGISTER_RDX } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_WRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INT1, { .reg = { ZYDIS_IMPLREG_TYPE_FLAGS_SSZ, { .id = 0x3F } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_READ, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .reg = { ZYDIS_IMPLREG_TYPE_STATIC, { .reg = ZYDIS_REGISTER_AL } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_MEM, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_CONDREAD, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_UINT8, { .mem = { 1, ZYDIS_IMPLMEM_BASE_ADI } }, ZYAN_FALSE, ZYAN_TRUE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_READ_CONDWRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .reg = { ZYDIS_IMPLREG_TYPE_GPR_ASZ, { .id = 0x1 } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_READ_CONDWRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INT1, { .reg = { ZYDIS_IMPLREG_TYPE_FLAGS_SSZ, { .id = 0x3F } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_READ, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .reg = { ZYDIS_IMPLREG_TYPE_STATIC, { .reg = ZYDIS_REGISTER_EAX } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_MEM, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_CONDREAD, { 4, 4, 4 }, ZYDIS_IELEMENT_TYPE_INT32, { .mem = { 1, ZYDIS_IMPLMEM_BASE_ADI } }, ZYAN_FALSE, ZYAN_TRUE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_READ_CONDWRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .reg = { ZYDIS_IMPLREG_TYPE_GPR_ASZ, { .id = 0x1 } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_READ_CONDWRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INT1, { .reg = { ZYDIS_IMPLREG_TYPE_FLAGS_SSZ, { .id = 0x3F } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_READ, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .reg = { ZYDIS_IMPLREG_TYPE_STATIC, { .reg = ZYDIS_REGISTER_RAX } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_MEM, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_CONDREAD, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT64, { .mem = { 1, ZYDIS_IMPLMEM_BASE_ADI } }, ZYAN_FALSE, ZYAN_TRUE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_READ_CONDWRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .reg = { ZYDIS_IMPLREG_TYPE_GPR_ASZ, { .id = 0x1 } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_READ_CONDWRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INT1, { .reg = { ZYDIS_IMPLREG_TYPE_FLAGS_SSZ, { .id = 0x3F } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_READ, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .reg = { ZYDIS_IMPLREG_TYPE_STATIC, { .reg = ZYDIS_REGISTER_AX } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_MEM, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_CONDREAD, { 2, 2, 2 }, ZYDIS_IELEMENT_TYPE_INT16, { .mem = { 1, ZYDIS_IMPLMEM_BASE_ADI } }, ZYAN_FALSE, ZYAN_TRUE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_READ_CONDWRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .reg = { ZYDIS_IMPLREG_TYPE_GPR_ASZ, { .id = 0x1 } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_READ_CONDWRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INT1, { .reg = { ZYDIS_IMPLREG_TYPE_FLAGS_SSZ, { .id = 0x3F } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_GPR16_32_64, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ_CONDWRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_UINT, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_GPR16_32_64, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_UINT, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_UIMM8 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_WRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INT1, { .reg = { ZYDIS_IMPLREG_TYPE_FLAGS_SSZ, { .id = 0x3F } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ_CONDWRITE, { 2, 4, 8 }, ZYDIS_IELEMENT_TYPE_UINT, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_GPR16_32_64, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_UINT, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_UIMM8 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_WRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INT1, { .reg = { ZYDIS_IMPLREG_TYPE_FLAGS_SSZ, { .id = 0x3F } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_GPR16_32_64, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ_CONDWRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_UINT, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_GPR16_32_64, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_UINT, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_IMPLICIT, ZYDIS_OPERAND_ACTION_READ, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_UINT, { .reg = { ZYDIS_IMPLREG_TYPE_STATIC, { .reg = ZYDIS_REGISTER_CL } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_CONDWRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INT1, { .reg = { ZYDIS_IMPLREG_TYPE_FLAGS_SSZ, { .id = 0x3F } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ_CONDWRITE, { 2, 4, 8 }, ZYDIS_IELEMENT_TYPE_UINT, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_GPR16_32_64, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_UINT, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_IMPLICIT, ZYDIS_OPERAND_ACTION_READ, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_UINT, { .reg = { ZYDIS_IMPLREG_TYPE_STATIC, { .reg = ZYDIS_REGISTER_CL } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_CONDWRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INT1, { .reg = { ZYDIS_IMPLREG_TYPE_FLAGS_SSZ, { .id = 0x3F } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_MEM, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_WRITE, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_UINT8, { .mem = { 1, ZYDIS_IMPLMEM_BASE_ADI } }, ZYAN_FALSE, ZYAN_TRUE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_READ, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .reg = { ZYDIS_IMPLREG_TYPE_STATIC, { .reg = ZYDIS_REGISTER_AL } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_READWRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .reg = { ZYDIS_IMPLREG_TYPE_GPR_ASZ, { .id = 0x7 } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_READ, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INT1, { .reg = { ZYDIS_IMPLREG_TYPE_FLAGS_SSZ, { .id = 0x3F } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_MEM, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_WRITE, { 4, 4, 4 }, ZYDIS_IELEMENT_TYPE_INT32, { .mem = { 1, ZYDIS_IMPLMEM_BASE_ADI } }, ZYAN_FALSE, ZYAN_TRUE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_READ, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .reg = { ZYDIS_IMPLREG_TYPE_STATIC, { .reg = ZYDIS_REGISTER_EAX } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_READWRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .reg = { ZYDIS_IMPLREG_TYPE_GPR_ASZ, { .id = 0x7 } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_READ, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INT1, { .reg = { ZYDIS_IMPLREG_TYPE_FLAGS_SSZ, { .id = 0x3F } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_MEM, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_WRITE, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT64, { .mem = { 1, ZYDIS_IMPLMEM_BASE_ADI } }, ZYAN_FALSE, ZYAN_TRUE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_READ, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .reg = { ZYDIS_IMPLREG_TYPE_STATIC, { .reg = ZYDIS_REGISTER_RAX } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_READWRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .reg = { ZYDIS_IMPLREG_TYPE_GPR_ASZ, { .id = 0x7 } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_READ, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INT1, { .reg = { ZYDIS_IMPLREG_TYPE_FLAGS_SSZ, { .id = 0x3F } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_MEM, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_WRITE, { 2, 2, 2 }, ZYDIS_IELEMENT_TYPE_INT16, { .mem = { 1, ZYDIS_IMPLMEM_BASE_ADI } }, ZYAN_FALSE, ZYAN_TRUE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_READ, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .reg = { ZYDIS_IMPLREG_TYPE_STATIC, { .reg = ZYDIS_REGISTER_AX } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_READWRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .reg = { ZYDIS_IMPLREG_TYPE_GPR_ASZ, { .id = 0x7 } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_READ, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INT1, { .reg = { ZYDIS_IMPLREG_TYPE_FLAGS_SSZ, { .id = 0x3F } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_WRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .reg = { ZYDIS_IMPLREG_TYPE_STATIC, { .reg = ZYDIS_REGISTER_RIP } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_WRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .reg = { ZYDIS_IMPLREG_TYPE_STATIC, { .reg = ZYDIS_REGISTER_RSP } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_READ, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .reg = { ZYDIS_IMPLREG_TYPE_STATIC, { .reg = ZYDIS_REGISTER_RCX } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_READ, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .reg = { ZYDIS_IMPLREG_TYPE_STATIC, { .reg = ZYDIS_REGISTER_RDX } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_WRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .reg = { ZYDIS_IMPLREG_TYPE_STATIC, { .reg = ZYDIS_REGISTER_EIP } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_WRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .reg = { ZYDIS_IMPLREG_TYPE_STATIC, { .reg = ZYDIS_REGISTER_ESP } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_READ, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .reg = { ZYDIS_IMPLREG_TYPE_STATIC, { .reg = ZYDIS_REGISTER_ECX } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_READ, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .reg = { ZYDIS_IMPLREG_TYPE_STATIC, { .reg = ZYDIS_REGISTER_EDX } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_GPR32, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 4, 4, 4 }, ZYDIS_IELEMENT_TYPE_UINT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_READ, { 4, 4, 4 }, ZYDIS_IELEMENT_TYPE_UINT32, { .reg = { ZYDIS_IMPLREG_TYPE_STATIC, { .reg = ZYDIS_REGISTER_EDX } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_READ, { 4, 4, 4 }, ZYDIS_IELEMENT_TYPE_UINT32, { .reg = { ZYDIS_IMPLREG_TYPE_STATIC, { .reg = ZYDIS_REGISTER_EAX } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_WRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INT1, { .reg = { ZYDIS_IMPLREG_TYPE_FLAGS_SSZ, { .id = 0x3F } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_WRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_STRUCT, { .reg = { ZYDIS_IMPLREG_TYPE_STATIC, { .reg = ZYDIS_REGISTER_PKRU } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_READ, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .reg = { ZYDIS_IMPLREG_TYPE_STATIC, { .reg = ZYDIS_REGISTER_EDX } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_READ, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .reg = { ZYDIS_IMPLREG_TYPE_STATIC, { .reg = ZYDIS_REGISTER_EAX } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_READ, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .reg = { ZYDIS_IMPLREG_TYPE_STATIC, { .reg = ZYDIS_REGISTER_ECX } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_READ, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .reg = { ZYDIS_IMPLREG_TYPE_STATIC, { .reg = ZYDIS_REGISTER_ECX } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_WRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .reg = { ZYDIS_IMPLREG_TYPE_STATIC, { .reg = ZYDIS_REGISTER_EDX } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_WRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .reg = { ZYDIS_IMPLREG_TYPE_STATIC, { .reg = ZYDIS_REGISTER_EAX } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_READ, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .reg = { ZYDIS_IMPLREG_TYPE_STATIC, { .reg = ZYDIS_REGISTER_XCR0 } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 576, 576, 576 }, ZYDIS_IELEMENT_TYPE_STRUCT, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_READ, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .reg = { ZYDIS_IMPLREG_TYPE_STATIC, { .reg = ZYDIS_REGISTER_EDX } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_READ, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .reg = { ZYDIS_IMPLREG_TYPE_STATIC, { .reg = ZYDIS_REGISTER_EAX } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_READ, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .reg = { ZYDIS_IMPLREG_TYPE_STATIC, { .reg = ZYDIS_REGISTER_XCR0 } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READWRITE, { 576, 576, 576 }, ZYDIS_IELEMENT_TYPE_STRUCT, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_READ, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .reg = { ZYDIS_IMPLREG_TYPE_STATIC, { .reg = ZYDIS_REGISTER_EDX } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_READ, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .reg = { ZYDIS_IMPLREG_TYPE_STATIC, { .reg = ZYDIS_REGISTER_EAX } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_READ, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .reg = { ZYDIS_IMPLREG_TYPE_STATIC, { .reg = ZYDIS_REGISTER_XCR0 } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 576, 576, 576 }, ZYDIS_IELEMENT_TYPE_STRUCT, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_READ, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .reg = { ZYDIS_IMPLREG_TYPE_STATIC, { .reg = ZYDIS_REGISTER_EDX } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_READ, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .reg = { ZYDIS_IMPLREG_TYPE_STATIC, { .reg = ZYDIS_REGISTER_EAX } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_READ, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .reg = { ZYDIS_IMPLREG_TYPE_STATIC, { .reg = ZYDIS_REGISTER_XCR0 } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_READ, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .reg = { ZYDIS_IMPLREG_TYPE_STATIC, { .reg = ZYDIS_REGISTER_ECX } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_READ, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .reg = { ZYDIS_IMPLREG_TYPE_STATIC, { .reg = ZYDIS_REGISTER_EDX } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_READ, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .reg = { ZYDIS_IMPLREG_TYPE_STATIC, { .reg = ZYDIS_REGISTER_EAX } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_WRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .reg = { ZYDIS_IMPLREG_TYPE_STATIC, { .reg = ZYDIS_REGISTER_XCR0 } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_WRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .reg = { ZYDIS_IMPLREG_TYPE_STATIC, { .reg = ZYDIS_REGISTER_EAX } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_READ, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .reg = { ZYDIS_IMPLREG_TYPE_STATIC, { .reg = ZYDIS_REGISTER_EDX } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_READWRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .reg = { ZYDIS_IMPLREG_TYPE_GPR_ASZ, { .id = 0x7 } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_MEM, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_WRITE, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_INT, { .mem = { 1, ZYDIS_IMPLMEM_BASE_ADI } }, ZYAN_FALSE, ZYAN_TRUE },
    { ZYDIS_SEMANTIC_OPTYPE_GPR32_32_64, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INT, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_GPR32_32_64, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INT, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 4, 4, 4 }, ZYDIS_IELEMENT_TYPE_UINT32, { .encoding = ZYDIS_OPERAND_ENCODING_UIMM32 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_WRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INT1, { .reg = { ZYDIS_IMPLREG_TYPE_FLAGS_SSZ, { .id = 0x3F } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_GPR32_32_64, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INT, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 4, 4, 8 }, ZYDIS_IELEMENT_TYPE_INT, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 4, 4, 4 }, ZYDIS_IELEMENT_TYPE_UINT32, { .encoding = ZYDIS_OPERAND_ENCODING_UIMM32 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_WRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INT1, { .reg = { ZYDIS_IMPLREG_TYPE_FLAGS_SSZ, { .id = 0x3F } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_GPR32_32_64, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 4, 4, 8 }, ZYDIS_IELEMENT_TYPE_INT, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_GPR32, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 4, 4, 4 }, ZYDIS_IELEMENT_TYPE_INT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 4, 4, 4 }, ZYDIS_IELEMENT_TYPE_UINT32, { .encoding = ZYDIS_OPERAND_ENCODING_UIMM32 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_WRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INT1, { .reg = { ZYDIS_IMPLREG_TYPE_FLAGS_SSZ, { .id = 0x3F } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_GPR32_32_64, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 4, 4, 8 }, ZYDIS_IELEMENT_TYPE_INT, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 4, 4, 4 }, ZYDIS_IELEMENT_TYPE_INT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 4, 4, 4 }, ZYDIS_IELEMENT_TYPE_UINT32, { .encoding = ZYDIS_OPERAND_ENCODING_UIMM32 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_WRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INT1, { .reg = { ZYDIS_IMPLREG_TYPE_FLAGS_SSZ, { .id = 0x3F } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_IS4 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_IS4 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_IS4 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_IS4 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_IS4 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_IS4 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_IS4 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_IS4 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_INT8, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_INT8, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_INT8, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_UIMM8 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_INT8, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_INT8, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_INT8, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_UIMM8 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_INT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_INT32, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_INT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_UIMM8 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_INT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_INT32, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_INT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_UIMM8 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_INT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_INT64, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_INT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_UIMM8 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_INT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_INT64, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_INT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_UIMM8 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_UIMM8 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_UIMM8 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_UINT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_UINT32, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_UINT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_UIMM8 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_UINT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_UINT32, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_UINT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_UIMM8 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_UINT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_UINT64, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_UINT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_UIMM8 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_UINT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_UINT64, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_UINT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_UIMM8 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_UINT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_UINT16, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_UINT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_UIMM8 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_UINT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_UINT16, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_UINT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_UIMM8 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_INT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_INT16, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_INT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_UIMM8 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_INT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_INT16, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_INT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_UIMM8 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_INT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_INT32, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_INT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_INT32, { .encoding = ZYDIS_OPERAND_ENCODING_IS4 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_INT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_INT32, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_INT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_INT32, { .encoding = ZYDIS_OPERAND_ENCODING_IS4 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_INT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_INT32, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_INT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_INT64, { .encoding = ZYDIS_OPERAND_ENCODING_IS4 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_INT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_INT32, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_INT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_INT64, { .encoding = ZYDIS_OPERAND_ENCODING_IS4 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_INT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_INT16, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_INT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_INT32, { .encoding = ZYDIS_OPERAND_ENCODING_IS4 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_INT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_INT16, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_INT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_INT32, { .encoding = ZYDIS_OPERAND_ENCODING_IS4 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_INT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_INT16, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_INT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_INT16, { .encoding = ZYDIS_OPERAND_ENCODING_IS4 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_INT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_INT16, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_INT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_INT16, { .encoding = ZYDIS_OPERAND_ENCODING_IS4 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_INT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_INT16, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_INT16, { .encoding = ZYDIS_OPERAND_ENCODING_IS4 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_INT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_INT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_INT16, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_INT16, { .encoding = ZYDIS_OPERAND_ENCODING_IS4 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_INT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_GPR32, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 4, 4, 4 }, ZYDIS_IELEMENT_TYPE_INT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_GPR32, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 4, 4, 4 }, ZYDIS_IELEMENT_TYPE_INT32, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_GPR32, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 4, 4, 4 }, ZYDIS_IELEMENT_TYPE_INT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_WRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INT1, { .reg = { ZYDIS_IMPLREG_TYPE_FLAGS_SSZ, { .id = 0x3F } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_GPR64, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_GPR64, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT64, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_GPR64, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_WRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INT1, { .reg = { ZYDIS_IMPLREG_TYPE_FLAGS_SSZ, { .id = 0x3F } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_GPR32, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 4, 4, 4 }, ZYDIS_IELEMENT_TYPE_INT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_GPR32, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 4, 4, 4 }, ZYDIS_IELEMENT_TYPE_INT32, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 4, 4, 4 }, ZYDIS_IELEMENT_TYPE_INT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_WRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INT1, { .reg = { ZYDIS_IMPLREG_TYPE_FLAGS_SSZ, { .id = 0x3F } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_GPR64, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_GPR64, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT64, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_WRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INT1, { .reg = { ZYDIS_IMPLREG_TYPE_FLAGS_SSZ, { .id = 0x3F } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_GPR32_32_64, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INT, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_GPR32_32_64, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INT, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_GPR32_32_64, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INT, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_WRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INT1, { .reg = { ZYDIS_IMPLREG_TYPE_FLAGS_SSZ, { .id = 0x3F } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_GPR32_32_64, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INT, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 4, 4, 8 }, ZYDIS_IELEMENT_TYPE_INT, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_GPR32_32_64, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INT, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_WRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INT1, { .reg = { ZYDIS_IMPLREG_TYPE_FLAGS_SSZ, { .id = 0x3F } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_GPR32, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 4, 4, 4 }, ZYDIS_IELEMENT_TYPE_INT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_GPR32, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 4, 4, 4 }, ZYDIS_IELEMENT_TYPE_INT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_GPR32, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 4, 4, 4 }, ZYDIS_IELEMENT_TYPE_INT32, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_WRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INT1, { .reg = { ZYDIS_IMPLREG_TYPE_FLAGS_SSZ, { .id = 0x3F } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_GPR64, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_GPR64, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_GPR64, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT64, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_WRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INT1, { .reg = { ZYDIS_IMPLREG_TYPE_FLAGS_SSZ, { .id = 0x3F } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_GPR32, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 4, 4, 4 }, ZYDIS_IELEMENT_TYPE_INT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 4, 4, 4 }, ZYDIS_IELEMENT_TYPE_INT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_GPR32, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 4, 4, 4 }, ZYDIS_IELEMENT_TYPE_INT32, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_WRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INT1, { .reg = { ZYDIS_IMPLREG_TYPE_FLAGS_SSZ, { .id = 0x3F } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_GPR64, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_GPR64, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT64, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_WRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INT1, { .reg = { ZYDIS_IMPLREG_TYPE_FLAGS_SSZ, { .id = 0x3F } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_GPR32, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 4, 4, 4 }, ZYDIS_IELEMENT_TYPE_INT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_GPR32, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 4, 4, 4 }, ZYDIS_IELEMENT_TYPE_INT32, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_GPR32, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 4, 4, 4 }, ZYDIS_IELEMENT_TYPE_INT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_READ, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .reg = { ZYDIS_IMPLREG_TYPE_STATIC, { .reg = ZYDIS_REGISTER_EDX } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_GPR64, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_GPR64, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT64, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_GPR64, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_READ, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .reg = { ZYDIS_IMPLREG_TYPE_STATIC, { .reg = ZYDIS_REGISTER_RDX } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_GPR32, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 4, 4, 4 }, ZYDIS_IELEMENT_TYPE_INT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_GPR32, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 4, 4, 4 }, ZYDIS_IELEMENT_TYPE_INT32, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 4, 4, 4 }, ZYDIS_IELEMENT_TYPE_INT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_READ, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .reg = { ZYDIS_IMPLREG_TYPE_STATIC, { .reg = ZYDIS_REGISTER_EDX } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_GPR64, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_GPR64, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT64, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_READ, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .reg = { ZYDIS_IMPLREG_TYPE_STATIC, { .reg = ZYDIS_REGISTER_RDX } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_FLOAT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_FLOAT64, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_FLOAT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_UIMM8 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_FLOAT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_FLOAT64, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_FLOAT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_UIMM8 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_FLOAT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_FLOAT64, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_FLOAT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_UIMM8 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_FLOAT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_FLOAT64, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_FLOAT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_UIMM8 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_FLOAT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_FLOAT32, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_FLOAT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_UIMM8 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_FLOAT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_FLOAT32, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_FLOAT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_UIMM8 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_FLOAT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_FLOAT32, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_FLOAT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_UIMM8 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_FLOAT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_FLOAT32, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_FLOAT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_UIMM8 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_FLOAT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_FLOAT64, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_FLOAT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_UINT64, { .encoding = ZYDIS_OPERAND_ENCODING_IS4 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_FLOAT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_FLOAT64, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_FLOAT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_UINT64, { .encoding = ZYDIS_OPERAND_ENCODING_IS4 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_FLOAT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_FLOAT64, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_FLOAT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_UINT64, { .encoding = ZYDIS_OPERAND_ENCODING_IS4 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_FLOAT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_FLOAT64, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_FLOAT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_UINT64, { .encoding = ZYDIS_OPERAND_ENCODING_IS4 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_FLOAT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_FLOAT32, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_FLOAT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_UINT32, { .encoding = ZYDIS_OPERAND_ENCODING_IS4 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_FLOAT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_FLOAT32, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_FLOAT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_UINT32, { .encoding = ZYDIS_OPERAND_ENCODING_IS4 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_FLOAT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_FLOAT32, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_FLOAT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_UINT32, { .encoding = ZYDIS_OPERAND_ENCODING_IS4 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_FLOAT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_FLOAT32, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_FLOAT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_UINT32, { .encoding = ZYDIS_OPERAND_ENCODING_IS4 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_FLOAT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_FLOAT64, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_FLOAT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_CC5, { .encoding = ZYDIS_OPERAND_ENCODING_UIMM8 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_FLOAT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_FLOAT64, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_FLOAT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_CC5, { .encoding = ZYDIS_OPERAND_ENCODING_UIMM8 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_FLOAT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_FLOAT64, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_FLOAT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_CC5, { .encoding = ZYDIS_OPERAND_ENCODING_UIMM8 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_FLOAT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_FLOAT64, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_FLOAT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_CC5, { .encoding = ZYDIS_OPERAND_ENCODING_UIMM8 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_FLOAT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_FLOAT32, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_FLOAT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_CC5, { .encoding = ZYDIS_OPERAND_ENCODING_UIMM8 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_FLOAT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_FLOAT32, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_FLOAT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_CC5, { .encoding = ZYDIS_OPERAND_ENCODING_UIMM8 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_FLOAT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_FLOAT32, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_FLOAT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_CC5, { .encoding = ZYDIS_OPERAND_ENCODING_UIMM8 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_FLOAT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_FLOAT32, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_FLOAT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_CC5, { .encoding = ZYDIS_OPERAND_ENCODING_UIMM8 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_FLOAT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_FLOAT64, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_FLOAT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_CC5, { .encoding = ZYDIS_OPERAND_ENCODING_UIMM8 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_FLOAT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_FLOAT64, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_FLOAT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_CC5, { .encoding = ZYDIS_OPERAND_ENCODING_UIMM8 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_FLOAT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_FLOAT32, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 4, 4, 4 }, ZYDIS_IELEMENT_TYPE_FLOAT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_CC5, { .encoding = ZYDIS_OPERAND_ENCODING_UIMM8 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_FLOAT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_FLOAT32, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 4, 4, 4 }, ZYDIS_IELEMENT_TYPE_FLOAT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_CC5, { .encoding = ZYDIS_OPERAND_ENCODING_UIMM8 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_FLOAT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_FLOAT64, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_FLOAT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_FLOAT64, { .encoding = ZYDIS_OPERAND_ENCODING_IS4 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_FLOAT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_FLOAT64, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_FLOAT64, { .encoding = ZYDIS_OPERAND_ENCODING_IS4 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_FLOAT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_FLOAT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_FLOAT64, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_FLOAT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_FLOAT64, { .encoding = ZYDIS_OPERAND_ENCODING_IS4 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_FLOAT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_FLOAT64, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_FLOAT64, { .encoding = ZYDIS_OPERAND_ENCODING_IS4 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_FLOAT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_FLOAT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_FLOAT32, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 4, 4, 4 }, ZYDIS_IELEMENT_TYPE_FLOAT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_FLOAT32, { .encoding = ZYDIS_OPERAND_ENCODING_IS4 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_FLOAT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_FLOAT32, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_FLOAT32, { .encoding = ZYDIS_OPERAND_ENCODING_IS4 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 4, 4, 4 }, ZYDIS_IELEMENT_TYPE_FLOAT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_FLOAT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_FLOAT32, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 4, 4, 4 }, ZYDIS_IELEMENT_TYPE_FLOAT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_FLOAT32, { .encoding = ZYDIS_OPERAND_ENCODING_IS4 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_FLOAT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_FLOAT32, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_FLOAT32, { .encoding = ZYDIS_OPERAND_ENCODING_IS4 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 4, 4, 4 }, ZYDIS_IELEMENT_TYPE_FLOAT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_UINT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_UIMM8 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_UINT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_UIMM8 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_UINT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_UIMM8 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_UINT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_UIMM8 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_FLOAT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_FLOAT64, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_FLOAT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_UIMM8 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_FLOAT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_FLOAT64, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_FLOAT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_UIMM8 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_UINT128, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_UINT128, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_UINT128, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_UIMM8 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_UINT128, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_UINT128, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_UINT128, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_UIMM8 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_FLOAT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_FLOAT32, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 4, 4, 4 }, ZYDIS_IELEMENT_TYPE_FLOAT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_UIMM8 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_UINT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_UIMM8 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_UINT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_UIMM8 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_UINT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_UIMM8 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_UINT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_UIMM8 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_UIMM8 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_UIMM8 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_UINT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_UINT32, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_UINT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_UIMM8 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_UINT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_UINT32, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_UINT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_UIMM8 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_INT8, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_INT8, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_INT8, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_INT8, { .encoding = ZYDIS_OPERAND_ENCODING_IS4 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_INT8, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_INT8, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_INT8, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_INT8, { .encoding = ZYDIS_OPERAND_ENCODING_IS4 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_INT8, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_INT8, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_INT8, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_INT8, { .encoding = ZYDIS_OPERAND_ENCODING_IS4 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_INT8, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_INT8, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_INT8, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_INT8, { .encoding = ZYDIS_OPERAND_ENCODING_IS4 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_UINT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_UINT16, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_UINT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_UIMM8 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_UINT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_UINT16, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_UINT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_UIMM8 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_UINT128, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_UINT64, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_UINT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_UIMM8 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_UINT128, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_UINT64, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_UINT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_UIMM8 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_UINT128, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_UINT64, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_UINT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_UIMM8 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_UINT128, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_UINT64, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_UINT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_UIMM8 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_UINT128, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_UINT128, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_UINT128, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_UIMM8 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_UINT128, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_UINT128, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_UINT128, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_UIMM8 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_GPR32, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 4, 4, 4 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_UIMM8 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_UIMM8 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_UINT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_UINT32, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_GPR32, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 4, 4, 4 }, ZYDIS_IELEMENT_TYPE_UINT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_UIMM8 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_UINT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_UINT32, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 4, 4, 4 }, ZYDIS_IELEMENT_TYPE_UINT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_UIMM8 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_UINT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_UINT64, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_GPR64, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_UINT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_UIMM8 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_UINT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_UINT64, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_UINT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_UIMM8 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_UINT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_UINT16, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_GPR32, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 4, 4, 4 }, ZYDIS_IELEMENT_TYPE_UINT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_UIMM8 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_UINT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_UINT16, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 2, 2, 2 }, ZYDIS_IELEMENT_TYPE_UINT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_UIMM8 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_FLOAT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_FLOAT64, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_FLOAT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_UIMM8 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_FLOAT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_FLOAT64, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_FLOAT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_UIMM8 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_FLOAT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_FLOAT32, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 4, 4, 4 }, ZYDIS_IELEMENT_TYPE_FLOAT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_UIMM8 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READWRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_UINT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_UINT32, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_UINT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_UIMM8 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READWRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_UINT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_UINT32, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_UINT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_UIMM8 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_ZMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READWRITE, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_FLOAT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_ZMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_FLOAT32, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_TRUE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_FLOAT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READWRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_FLOAT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_FLOAT32, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_TRUE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_FLOAT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_ZMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_FLOAT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_ZMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_FLOAT16, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_ZMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_FLOAT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_FLOAT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_FLOAT16, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_FLOAT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_FLOAT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_FLOAT16, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_FLOAT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_FLOAT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_FLOAT16, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_FLOAT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_ZMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_FLOAT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_ZMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_FLOAT16, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_FLOAT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_UINT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_FLOAT32, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_FLOAT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_UINT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_FLOAT32, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_FLOAT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_ZMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_UINT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_ZMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_FLOAT32, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_ZMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_FLOAT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_UINT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_FLOAT32, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_FLOAT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_UINT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_FLOAT32, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_FLOAT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_ZMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_UINT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_ZMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_FLOAT32, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_FLOAT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_FLOAT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_ZMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_FLOAT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_UIMM8 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_FLOAT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_FLOAT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_UIMM8 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_FLOAT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_FLOAT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_UIMM8 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_FLOAT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_FLOAT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_UIMM8 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_FLOAT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_FLOAT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_UIMM8 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_FLOAT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_ZMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_FLOAT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_UIMM8 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_FLOAT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_FLOAT64, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_FLOAT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_FLOAT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_FLOAT64, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_FLOAT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_FLOAT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_FLOAT64, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_FLOAT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_FLOAT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_FLOAT64, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_FLOAT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_FLOAT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_FLOAT64, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_FLOAT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_FLOAT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_FLOAT64, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 2, 2, 2 }, ZYDIS_IELEMENT_TYPE_FLOAT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_FLOAT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_FLOAT32, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_FLOAT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_FLOAT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_FLOAT32, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 2, 2, 2 }, ZYDIS_IELEMENT_TYPE_FLOAT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_FLOAT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_FLOAT32, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_FLOAT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_FLOAT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_FLOAT32, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 4, 4, 4 }, ZYDIS_IELEMENT_TYPE_FLOAT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_FLOAT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_FLOAT16, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_FLOAT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_FLOAT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_FLOAT16, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 4, 4, 4 }, ZYDIS_IELEMENT_TYPE_FLOAT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READWRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_FLOAT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_UINT32, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_UINT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READWRITE, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_FLOAT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_UINT32, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_UINT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_ZMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READWRITE, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_FLOAT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_ZMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_UINT32, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_ZMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_UINT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READWRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_FLOAT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_UINT32, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_UINT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READWRITE, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_FLOAT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_UINT32, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_UINT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_ZMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READWRITE, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_FLOAT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_ZMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_UINT32, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_UINT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_FLOAT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_FLOAT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_UIMM8 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_FLOAT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_ZMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_FLOAT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_UIMM8 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_FLOAT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_FLOAT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_UIMM8 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_FLOAT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_ZMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_FLOAT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_UIMM8 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_FLOAT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_ZMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_FLOAT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_UIMM8 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_FLOAT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_ZMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_FLOAT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_UIMM8 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_FLOAT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_FLOAT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_UIMM8 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_FLOAT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_ZMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_FLOAT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_UIMM8 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_FLOAT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_FLOAT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_UIMM8 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_FLOAT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_ZMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_FLOAT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_UIMM8 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_FLOAT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_ZMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_FLOAT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_UIMM8 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_FLOAT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_ZMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_FLOAT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_UIMM8 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_UINT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_UINT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_UIMM8 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_UINT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_ZMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_UINT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_UIMM8 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_UINT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_UINT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_UIMM8 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_UINT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_ZMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_UINT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_UIMM8 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_UINT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_ZMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_UINT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_UIMM8 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_UINT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_ZMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_UINT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_UIMM8 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_UINT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_UINT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_UIMM8 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_UINT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_ZMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_UINT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_UIMM8 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_UINT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_UINT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_UIMM8 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_UINT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_ZMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_UINT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_UIMM8 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_UINT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_ZMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_UINT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_UIMM8 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_UINT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_ZMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_UINT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_UIMM8 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_ZMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READWRITE, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_FLOAT16X2, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_ZMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_FLOAT16X2, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_ZMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_FLOAT16X2, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READWRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_FLOAT16X2, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_FLOAT16X2, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_FLOAT16X2, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READWRITE, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_FLOAT16X2, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_FLOAT16X2, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_FLOAT16X2, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READWRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_FLOAT16X2, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_FLOAT16X2, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_FLOAT16X2, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READWRITE, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_FLOAT16X2, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_FLOAT16X2, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_FLOAT16X2, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_ZMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READWRITE, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_FLOAT16X2, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_ZMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_FLOAT16X2, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_FLOAT16X2, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READWRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_FLOAT16X2, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_FLOAT16X2, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 4, 4, 4 }, ZYDIS_IELEMENT_TYPE_FLOAT16X2, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_ZMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_FLOAT16X2, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_ZMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_FLOAT16X2, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_ZMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_FLOAT16X2, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_FLOAT16X2, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_FLOAT16X2, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_FLOAT16X2, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_FLOAT16X2, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_FLOAT16X2, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_FLOAT16X2, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_FLOAT16X2, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_FLOAT16X2, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_FLOAT16X2, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_FLOAT16X2, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_FLOAT16X2, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_FLOAT16X2, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_ZMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_FLOAT16X2, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_ZMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_FLOAT16X2, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_FLOAT16X2, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_FLOAT16X2, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_FLOAT16X2, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 4, 4, 4 }, ZYDIS_IELEMENT_TYPE_FLOAT16X2, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_ZMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READWRITE, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_FLOAT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_ZMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_FLOAT16, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_ZMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_FLOAT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READWRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_FLOAT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_FLOAT16, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_FLOAT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READWRITE, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_FLOAT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_FLOAT16, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_FLOAT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READWRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_FLOAT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_FLOAT16, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_FLOAT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READWRITE, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_FLOAT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_FLOAT16, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_FLOAT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_ZMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READWRITE, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_FLOAT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_ZMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_FLOAT16, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_FLOAT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READWRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_FLOAT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_FLOAT16, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 2, 2, 2 }, ZYDIS_IELEMENT_TYPE_FLOAT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_FLOAT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_UIMM8 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_FLOAT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_UIMM8 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_ZMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_FLOAT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_UIMM8 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_FLOAT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_UIMM8 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_FLOAT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_UIMM8 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_FLOAT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_UIMM8 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_ZMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_FLOAT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_UIMM8 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_FLOAT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_UIMM8 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_FLOAT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_UIMM8 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_FLOAT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_UIMM8 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_ZMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_FLOAT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_UIMM8 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_FLOAT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_UIMM8 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_FLOAT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_UIMM8 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 2, 2, 2 }, ZYDIS_IELEMENT_TYPE_FLOAT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_UIMM8 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 4, 4, 4 }, ZYDIS_IELEMENT_TYPE_FLOAT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_UIMM8 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_ZMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_FLOAT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_ZMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_FLOAT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_UIMM8 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_FLOAT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_FLOAT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_UIMM8 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_FLOAT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_FLOAT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_UIMM8 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_FLOAT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_FLOAT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_UIMM8 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_FLOAT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_FLOAT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_UIMM8 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_ZMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_FLOAT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_FLOAT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_UIMM8 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_ZMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_FLOAT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_ZMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_FLOAT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_UIMM8 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_FLOAT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_FLOAT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_UIMM8 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_FLOAT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_FLOAT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_UIMM8 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_FLOAT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_FLOAT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_UIMM8 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_FLOAT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_FLOAT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_UIMM8 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_ZMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_FLOAT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_FLOAT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_UIMM8 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_ZMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_FLOAT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_ZMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_FLOAT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_UIMM8 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_FLOAT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_FLOAT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_UIMM8 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_FLOAT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_FLOAT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_UIMM8 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_FLOAT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_FLOAT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_UIMM8 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_FLOAT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_FLOAT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_UIMM8 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_ZMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_FLOAT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_FLOAT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_UIMM8 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_FLOAT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_FLOAT64, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_FLOAT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_FLOAT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_FLOAT16, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_FLOAT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_FLOAT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_FLOAT32, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_FLOAT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_ZMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READWRITE, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_INT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_ZMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_INT16, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_TRUE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_UINT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_INT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_INT32, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_INT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_INT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_INT32, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_INT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_ZMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_INT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_ZMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_INT32, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_ZMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_INT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_INT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_INT32, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_INT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_INT32, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_ZMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_INT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_ZMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_INT32, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_INT8, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_INT16, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_INT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_INT8, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_INT16, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_INT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_ZMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_INT8, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_ZMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_INT16, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_ZMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_INT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_INT8, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_INT16, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_INT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_INT8, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_INT16, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_INT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_ZMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_INT8, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_ZMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_INT16, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_INT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_UINT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_INT32, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_INT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_UINT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_INT32, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_INT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_ZMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_UINT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_ZMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_INT32, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_ZMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_INT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_UINT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_INT32, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_UINT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_INT32, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_ZMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_UINT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_ZMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_INT32, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_INT16, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_INT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_INT16, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_INT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_ZMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_ZMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_INT16, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_ZMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_INT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_INT16, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_INT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_INT16, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_INT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_ZMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_ZMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_INT16, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_INT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_INT8, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_INT8, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_INT8, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_INT8, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_INT8, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_INT8, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_ZMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_INT8, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_ZMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_INT8, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_ZMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_INT8, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_INT8, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_INT8, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_INT8, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_INT8, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_INT8, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_INT8, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_ZMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_INT8, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_ZMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_INT8, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_INT8, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_INT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_INT32, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_INT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_INT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_INT32, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_INT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_ZMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_INT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_ZMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_INT32, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_ZMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_INT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_INT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_INT32, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_INT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_INT32, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_ZMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_INT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_ZMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_INT32, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_INT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_INT64, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_INT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_INT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_INT64, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_INT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_ZMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_INT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_ZMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_INT64, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_ZMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_INT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_INT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_INT64, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_INT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_INT64, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_ZMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_INT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_ZMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_INT64, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_INT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_INT16, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_INT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_INT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_INT16, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_INT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_ZMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_INT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_ZMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_INT16, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_ZMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_INT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_INT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_INT16, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_INT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_INT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_INT16, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_INT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_ZMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_INT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_ZMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_INT16, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_INT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_ZMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_UINT128, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_ZMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_UINT64, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_ZMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_UINT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_UIMM8 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_ZMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_UINT128, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_ZMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_UINT64, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_UINT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_UIMM8 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READWRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_INT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_INT8, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READWRITE, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_INT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_INT8, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_ZMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READWRITE, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_INT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_ZMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_ZMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_INT8, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READWRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_INT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READWRITE, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_INT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_ZMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READWRITE, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_INT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_ZMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READWRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_INT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_INT16, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_INT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READWRITE, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_INT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_INT16, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_INT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_ZMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READWRITE, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_INT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_ZMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_INT16, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_ZMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_INT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READWRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_INT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_INT16, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READWRITE, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_INT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_INT16, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_ZMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READWRITE, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_INT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_ZMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_INT16, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READWRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READWRITE, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_ZMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READWRITE, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_ZMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_ZMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READWRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READWRITE, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_ZMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READWRITE, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_ZMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READWRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_UINT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_UINT16, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_UINT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READWRITE, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_UINT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_UINT16, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_UINT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_ZMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READWRITE, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_UINT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_ZMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_UINT16, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_ZMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_UINT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READWRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_UINT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_UINT16, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_UINT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READWRITE, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_UINT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_UINT16, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_UINT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_ZMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READWRITE, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_UINT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_ZMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_UINT16, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_UINT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_UINT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_UINT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_UIMM8 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_ZMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_UINT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_ZMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_UINT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_UIMM8 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_UINT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_UINT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_UIMM8 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_ZMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_UINT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_UINT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_UIMM8 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_INT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_INT16, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_INT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_INT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_INT16, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_INT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_ZMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_INT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_ZMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_INT16, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_ZMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_INT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_INT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_INT16, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_INT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_INT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_INT16, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_INT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_ZMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_INT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_ZMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_INT16, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_INT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_UINT32, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_UINT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_UIMM8 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_UINT32, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_UINT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_UIMM8 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_ZMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_UINT32, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_ZMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_UINT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_UIMM8 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_UINT32, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_UINT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_UIMM8 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_UINT32, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_UINT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_UIMM8 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_ZMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_UINT32, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_UINT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_UIMM8 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_UINT64, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_UINT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_UIMM8 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_UINT64, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_UINT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_UIMM8 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_ZMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_UINT64, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_ZMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_UINT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_UIMM8 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_UINT64, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_UINT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_UIMM8 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_UINT64, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_UINT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_UIMM8 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_ZMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_UINT64, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_UINT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_UIMM8 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_UINT64, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_UINT64, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_ZMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_UINT64, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_ZMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_UINT64, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_UINT64, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_ZMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_UINT64, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_UINT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_UINT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_UIMM8 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_UINT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_UINT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_UIMM8 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_ZMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_UINT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_ZMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_UINT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_UIMM8 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_UINT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_UINT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_UIMM8 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_UINT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_UINT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_UIMM8 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_ZMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_UINT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_UINT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_UIMM8 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_UINT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_UINT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_UIMM8 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_UINT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_UINT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_UIMM8 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_ZMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_UINT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_ZMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_UINT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_UIMM8 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_UINT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_UINT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_UIMM8 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_UINT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_UINT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_UIMM8 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_ZMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_UINT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_UINT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_UIMM8 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_UINT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_UINT32, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_UINT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_UINT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_UINT64, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_UINT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_UINT16, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_UINT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_UIMM8 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_UINT16, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_UINT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_UIMM8 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_ZMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_UINT16, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_ZMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_UINT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_UIMM8 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_UINT16, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_UINT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_UIMM8 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_UINT16, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_UINT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_UIMM8 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_ZMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_UINT16, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_UINT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_UIMM8 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_UINT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_UINT16, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_UINT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_ZMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_UINT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_ZMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_UINT16, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_UINT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_UINT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_UINT16, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_UINT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_ZMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_UINT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_ZMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_UINT16, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_UINT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_INT32, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_INT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_UIMM8 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_INT32, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_INT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_UIMM8 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_ZMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_INT32, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_ZMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_INT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_UIMM8 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_INT32, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_UIMM8 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_INT32, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_UIMM8 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_ZMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_INT32, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_UIMM8 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_INT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_INT32, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_UINT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_INT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_INT32, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_UINT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_ZMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_INT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_ZMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_INT32, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_UINT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_INT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_INT32, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_UINT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_INT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_INT32, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_UINT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_ZMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_INT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_ZMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_INT32, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_UINT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_INT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_INT32, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_UINT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_ZMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_INT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_ZMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_INT32, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_ZMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_UINT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_INT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_INT32, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_UINT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_INT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_INT32, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_UINT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_ZMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_INT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_ZMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_INT32, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_UINT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_INT16, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_INT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_UIMM8 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_INT16, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_INT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_UIMM8 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_ZMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_INT16, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_ZMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_INT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_UIMM8 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_INT16, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_INT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_UIMM8 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_INT16, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_INT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_UIMM8 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_ZMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_INT16, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_INT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_UIMM8 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_INT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_INT16, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_UINT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_INT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_INT16, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_UINT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_ZMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_INT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_ZMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_INT16, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_UINT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_INT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_INT16, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_UINT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_INT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_INT16, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_UINT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_ZMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_INT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_ZMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_INT16, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_UINT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_ZMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READWRITE, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_FLOAT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 2, 2, 2 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_ZMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_FLOAT64, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_ZMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_FLOAT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_ZMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READWRITE, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_FLOAT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 2, 2, 2 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_ZMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_FLOAT64, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_VARIABLE, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_ZMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READWRITE, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_FLOAT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 2, 2, 2 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_ZMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_FLOAT32, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_VARIABLE, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_ZMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READWRITE, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_FLOAT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READWRITE, { 2, 2, 2 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_ZMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_FLOAT32, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_ZMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_FLOAT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_ZMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READWRITE, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_FLOAT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READWRITE, { 2, 2, 2 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_ZMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_FLOAT32, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_VARIABLE, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_ZMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READWRITE, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_FLOAT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 2, 2, 2 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_ZMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_INT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_UIMM8 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_ZMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READWRITE, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_FLOAT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 2, 2, 2 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_VARIABLE, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_UIMM8 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_ZMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READWRITE, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_INT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 2, 2, 2 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_ZMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_FLOAT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_UIMM8 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_ZMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READWRITE, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_INT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 2, 2, 2 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_VARIABLE, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_UIMM8 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_ZMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READWRITE, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_UINT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 2, 2, 2 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_ZMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_FLOAT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_UIMM8 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_ZMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READWRITE, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_UINT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 2, 2, 2 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_VARIABLE, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_UIMM8 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_ZMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READWRITE, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_INT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 2, 2, 2 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_ZMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_FLOAT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_UIMM8 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_ZMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READWRITE, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_UINT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 2, 2, 2 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_ZMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_FLOAT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_UIMM8 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_ZMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READWRITE, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_FLOAT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 2, 2, 2 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_ZMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_UINT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_UIMM8 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_ZMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READWRITE, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_FLOAT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 2, 2, 2 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_ZMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_FLOAT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_UIMM8 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_ZMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READWRITE, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_FLOAT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 2, 2, 2 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_VARIABLE, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_UIMM8 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_ZMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READWRITE, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_FLOAT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 2, 2, 2 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_ZMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_FLOAT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_UIMM8 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_ZMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READWRITE, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_INT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 2, 2, 2 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 2, 2, 2 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_ZMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_INT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_ZMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READWRITE, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_INT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 2, 2, 2 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 2, 2, 2 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_VARIABLE, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_ZMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READWRITE, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_INT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 2, 2, 2 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_ZMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_INT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_UIMM8 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_ZMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READWRITE, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_INT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 2, 2, 2 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_INT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_UIMM8 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_ZMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READWRITE, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_UINT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 2, 2, 2 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_ZMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_UINT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_UIMM8 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_ZMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READWRITE, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_UINT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 2, 2, 2 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_UINT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_UIMM8 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_ZMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READWRITE, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_FLOAT32, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 2, 2, 2 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_ZMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_FLOAT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_UIMM8 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_ZMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READWRITE, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_FLOAT32, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 2, 2, 2 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_VARIABLE, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_UIMM8 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_ZMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READWRITE, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_UINT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 2, 2, 2 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_ZMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_UINT32, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_ZMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_UINT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_ZMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READWRITE, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_UINT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 2, 2, 2 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_ZMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_UINT32, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_VARIABLE, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_ZMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READWRITE, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_INT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 2, 2, 2 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_ZMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_INT32, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_ZMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_UINT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_ZMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READWRITE, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_INT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 2, 2, 2 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_ZMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_INT32, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_VARIABLE, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_READWRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .reg = { ZYDIS_IMPLREG_TYPE_STATIC, { .reg = ZYDIS_REGISTER_AL } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_READWRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .reg = { ZYDIS_IMPLREG_TYPE_STATIC, { .reg = ZYDIS_REGISTER_AH } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_READWRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INT1, { .reg = { ZYDIS_IMPLREG_TYPE_FLAGS_SSZ, { .id = 0x3F } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_GPR8, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READWRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_GPR8, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_READWRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INT1, { .reg = { ZYDIS_IMPLREG_TYPE_FLAGS_SSZ, { .id = 0x3F } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READWRITE, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_INT8, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_GPR8, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_READWRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INT1, { .reg = { ZYDIS_IMPLREG_TYPE_FLAGS_SSZ, { .id = 0x3F } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_GPR16_32_64, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READWRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_GPR16_32_64, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_READWRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INT1, { .reg = { ZYDIS_IMPLREG_TYPE_FLAGS_SSZ, { .id = 0x3F } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READWRITE, { 2, 4, 8 }, ZYDIS_IELEMENT_TYPE_INT, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_GPR16_32_64, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_READWRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INT1, { .reg = { ZYDIS_IMPLREG_TYPE_FLAGS_SSZ, { .id = 0x3F } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_GPR8, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READWRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_GPR8, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_READWRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INT1, { .reg = { ZYDIS_IMPLREG_TYPE_FLAGS_SSZ, { .id = 0x3F } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_GPR8, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READWRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_INT8, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_READWRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INT1, { .reg = { ZYDIS_IMPLREG_TYPE_FLAGS_SSZ, { .id = 0x3F } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_GPR16_32_64, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READWRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_GPR16_32_64, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_READWRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INT1, { .reg = { ZYDIS_IMPLREG_TYPE_FLAGS_SSZ, { .id = 0x3F } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_GPR16_32_64, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READWRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 2, 4, 8 }, ZYDIS_IELEMENT_TYPE_INT, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_READWRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INT1, { .reg = { ZYDIS_IMPLREG_TYPE_FLAGS_SSZ, { .id = 0x3F } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_IMPLICIT, ZYDIS_OPERAND_ACTION_READWRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .reg = { ZYDIS_IMPLREG_TYPE_STATIC, { .reg = ZYDIS_REGISTER_AL } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_INT8, { .encoding = ZYDIS_OPERAND_ENCODING_SIMM8 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_READWRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INT1, { .reg = { ZYDIS_IMPLREG_TYPE_FLAGS_SSZ, { .id = 0x3F } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_IMPLICIT, ZYDIS_OPERAND_ACTION_READWRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .reg = { ZYDIS_IMPLREG_TYPE_GPR_OSZ, { .id = 0x0 } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 2, 4, 4 }, ZYDIS_IELEMENT_TYPE_INT, { .encoding = ZYDIS_OPERAND_ENCODING_SIMM16_32_32 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_READWRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INT1, { .reg = { ZYDIS_IMPLREG_TYPE_FLAGS_SSZ, { .id = 0x3F } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_GPR8, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READWRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_INT8, { .encoding = ZYDIS_OPERAND_ENCODING_SIMM8 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_READWRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INT1, { .reg = { ZYDIS_IMPLREG_TYPE_FLAGS_SSZ, { .id = 0x3F } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READWRITE, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_INT8, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_INT8, { .encoding = ZYDIS_OPERAND_ENCODING_SIMM8 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_READWRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INT1, { .reg = { ZYDIS_IMPLREG_TYPE_FLAGS_SSZ, { .id = 0x3F } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_GPR16_32_64, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READWRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 2, 4, 4 }, ZYDIS_IELEMENT_TYPE_INT, { .encoding = ZYDIS_OPERAND_ENCODING_SIMM16_32_32 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_READWRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INT1, { .reg = { ZYDIS_IMPLREG_TYPE_FLAGS_SSZ, { .id = 0x3F } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READWRITE, { 2, 4, 8 }, ZYDIS_IELEMENT_TYPE_INT, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 2, 4, 4 }, ZYDIS_IELEMENT_TYPE_INT, { .encoding = ZYDIS_OPERAND_ENCODING_SIMM16_32_32 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_READWRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INT1, { .reg = { ZYDIS_IMPLREG_TYPE_FLAGS_SSZ, { .id = 0x3F } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_GPR16_32_64, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READWRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_INT8, { .encoding = ZYDIS_OPERAND_ENCODING_SIMM8 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_READWRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INT1, { .reg = { ZYDIS_IMPLREG_TYPE_FLAGS_SSZ, { .id = 0x3F } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READWRITE, { 2, 4, 8 }, ZYDIS_IELEMENT_TYPE_INT, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_INT8, { .encoding = ZYDIS_OPERAND_ENCODING_SIMM8 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_READWRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INT1, { .reg = { ZYDIS_IMPLREG_TYPE_FLAGS_SSZ, { .id = 0x3F } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_GPR32, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READWRITE, { 4, 4, 4 }, ZYDIS_IELEMENT_TYPE_INT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_GPR32, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 4, 4, 4 }, ZYDIS_IELEMENT_TYPE_INT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_READ, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INT1, { .reg = { ZYDIS_IMPLREG_TYPE_FLAGS_SSZ, { .id = 0x3F } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_GPR64, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READWRITE, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_GPR64, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_READ, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INT1, { .reg = { ZYDIS_IMPLREG_TYPE_FLAGS_SSZ, { .id = 0x3F } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_GPR32, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READWRITE, { 4, 4, 4 }, ZYDIS_IELEMENT_TYPE_INT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 4, 4, 4 }, ZYDIS_IELEMENT_TYPE_INT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_READ, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INT1, { .reg = { ZYDIS_IMPLREG_TYPE_FLAGS_SSZ, { .id = 0x3F } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_GPR64, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READWRITE, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_READ, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INT1, { .reg = { ZYDIS_IMPLREG_TYPE_FLAGS_SSZ, { .id = 0x3F } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_GPR8, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READWRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_GPR8, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_WRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INT1, { .reg = { ZYDIS_IMPLREG_TYPE_FLAGS_SSZ, { .id = 0x3F } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READWRITE, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_INT8, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_GPR8, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_WRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INT1, { .reg = { ZYDIS_IMPLREG_TYPE_FLAGS_SSZ, { .id = 0x3F } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_GPR16_32_64, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READWRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_GPR16_32_64, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_WRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INT1, { .reg = { ZYDIS_IMPLREG_TYPE_FLAGS_SSZ, { .id = 0x3F } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READWRITE, { 2, 4, 8 }, ZYDIS_IELEMENT_TYPE_INT, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_GPR16_32_64, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_WRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INT1, { .reg = { ZYDIS_IMPLREG_TYPE_FLAGS_SSZ, { .id = 0x3F } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_GPR8, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READWRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_GPR8, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_WRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INT1, { .reg = { ZYDIS_IMPLREG_TYPE_FLAGS_SSZ, { .id = 0x3F } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_GPR8, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READWRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_INT8, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_WRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INT1, { .reg = { ZYDIS_IMPLREG_TYPE_FLAGS_SSZ, { .id = 0x3F } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_GPR16_32_64, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READWRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_GPR16_32_64, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_WRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INT1, { .reg = { ZYDIS_IMPLREG_TYPE_FLAGS_SSZ, { .id = 0x3F } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_GPR16_32_64, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READWRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 2, 4, 8 }, ZYDIS_IELEMENT_TYPE_INT, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_WRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INT1, { .reg = { ZYDIS_IMPLREG_TYPE_FLAGS_SSZ, { .id = 0x3F } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_IMPLICIT, ZYDIS_OPERAND_ACTION_READWRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .reg = { ZYDIS_IMPLREG_TYPE_STATIC, { .reg = ZYDIS_REGISTER_AL } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_INT8, { .encoding = ZYDIS_OPERAND_ENCODING_SIMM8 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_WRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INT1, { .reg = { ZYDIS_IMPLREG_TYPE_FLAGS_SSZ, { .id = 0x3F } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_IMPLICIT, ZYDIS_OPERAND_ACTION_READWRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .reg = { ZYDIS_IMPLREG_TYPE_GPR_OSZ, { .id = 0x0 } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 2, 4, 4 }, ZYDIS_IELEMENT_TYPE_INT, { .encoding = ZYDIS_OPERAND_ENCODING_SIMM16_32_32 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_WRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INT1, { .reg = { ZYDIS_IMPLREG_TYPE_FLAGS_SSZ, { .id = 0x3F } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_GPR8, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READWRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_INT8, { .encoding = ZYDIS_OPERAND_ENCODING_SIMM8 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_WRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INT1, { .reg = { ZYDIS_IMPLREG_TYPE_FLAGS_SSZ, { .id = 0x3F } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READWRITE, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_INT8, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_INT8, { .encoding = ZYDIS_OPERAND_ENCODING_SIMM8 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_WRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INT1, { .reg = { ZYDIS_IMPLREG_TYPE_FLAGS_SSZ, { .id = 0x3F } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_GPR16_32_64, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READWRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 2, 4, 4 }, ZYDIS_IELEMENT_TYPE_INT, { .encoding = ZYDIS_OPERAND_ENCODING_SIMM16_32_32 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_WRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INT1, { .reg = { ZYDIS_IMPLREG_TYPE_FLAGS_SSZ, { .id = 0x3F } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READWRITE, { 2, 4, 8 }, ZYDIS_IELEMENT_TYPE_INT, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 2, 4, 4 }, ZYDIS_IELEMENT_TYPE_INT, { .encoding = ZYDIS_OPERAND_ENCODING_SIMM16_32_32 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_WRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INT1, { .reg = { ZYDIS_IMPLREG_TYPE_FLAGS_SSZ, { .id = 0x3F } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_GPR16_32_64, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READWRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_INT8, { .encoding = ZYDIS_OPERAND_ENCODING_SIMM8 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_WRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INT1, { .reg = { ZYDIS_IMPLREG_TYPE_FLAGS_SSZ, { .id = 0x3F } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READWRITE, { 2, 4, 8 }, ZYDIS_IELEMENT_TYPE_INT, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_INT8, { .encoding = ZYDIS_OPERAND_ENCODING_SIMM8 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_WRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INT1, { .reg = { ZYDIS_IMPLREG_TYPE_FLAGS_SSZ, { .id = 0x3F } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READWRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 48, 48, 48 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_WRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INT1, { .reg = { ZYDIS_IMPLREG_TYPE_FLAGS_SSZ, { .id = 0x3F } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READWRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_WRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INT1, { .reg = { ZYDIS_IMPLREG_TYPE_FLAGS_SSZ, { .id = 0x3F } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_INT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_INT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_UIMM8 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_INT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_INT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_UIMM8 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_GPR16, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READWRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_GPR16, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_WRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INT1, { .reg = { ZYDIS_IMPLREG_TYPE_FLAGS_SSZ, { .id = 0x3F } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READWRITE, { 2, 2, 2 }, ZYDIS_IELEMENT_TYPE_INT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_GPR16, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_WRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INT1, { .reg = { ZYDIS_IMPLREG_TYPE_FLAGS_SSZ, { .id = 0x3F } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READWRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_FLOAT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_FLOAT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_UIMM8 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READWRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_FLOAT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_FLOAT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_UIMM8 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READWRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_FLOAT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_FLOAT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_UIMM8 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READWRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_FLOAT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_FLOAT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_UIMM8 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READWRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_FLOAT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_FLOAT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_UINT64, { .reg = { ZYDIS_IMPLREG_TYPE_STATIC, { .reg = ZYDIS_REGISTER_XMM0 } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READWRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_FLOAT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_FLOAT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_UINT64, { .reg = { ZYDIS_IMPLREG_TYPE_STATIC, { .reg = ZYDIS_REGISTER_XMM0 } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READWRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_FLOAT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_FLOAT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_UINT32, { .reg = { ZYDIS_IMPLREG_TYPE_STATIC, { .reg = ZYDIS_REGISTER_XMM0 } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READWRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_FLOAT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_FLOAT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_UINT32, { .reg = { ZYDIS_IMPLREG_TYPE_STATIC, { .reg = ZYDIS_REGISTER_XMM0 } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_GPR16_32_64, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_GPR16_32_64, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_WRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INT1, { .reg = { ZYDIS_IMPLREG_TYPE_FLAGS_SSZ, { .id = 0x3F } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_GPR16_32_64, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 2, 4, 8 }, ZYDIS_IELEMENT_TYPE_INT, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_WRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INT1, { .reg = { ZYDIS_IMPLREG_TYPE_FLAGS_SSZ, { .id = 0x3F } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_GPR16_32_64, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_GPR16_32_64, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_WRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INT1, { .reg = { ZYDIS_IMPLREG_TYPE_FLAGS_SSZ, { .id = 0x3F } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 2, 4, 8 }, ZYDIS_IELEMENT_TYPE_INT, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_GPR16_32_64, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_WRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INT1, { .reg = { ZYDIS_IMPLREG_TYPE_FLAGS_SSZ, { .id = 0x3F } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_GPR16_32_64, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_UIMM8 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_WRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INT1, { .reg = { ZYDIS_IMPLREG_TYPE_FLAGS_SSZ, { .id = 0x3F } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 2, 4, 8 }, ZYDIS_IELEMENT_TYPE_INT, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_UIMM8 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_WRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INT1, { .reg = { ZYDIS_IMPLREG_TYPE_FLAGS_SSZ, { .id = 0x3F } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_GPR16_32_64, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READWRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_UIMM8 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_WRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INT1, { .reg = { ZYDIS_IMPLREG_TYPE_FLAGS_SSZ, { .id = 0x3F } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READWRITE, { 2, 4, 8 }, ZYDIS_IELEMENT_TYPE_INT, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_UIMM8 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_WRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INT1, { .reg = { ZYDIS_IMPLREG_TYPE_FLAGS_SSZ, { .id = 0x3F } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_GPR16_32_64, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_CONDWRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_GPR16_32_64, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_READ, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INT1, { .reg = { ZYDIS_IMPLREG_TYPE_FLAGS_SSZ, { .id = 0x3F } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_GPR16_32_64, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_CONDWRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 2, 4, 8 }, ZYDIS_IELEMENT_TYPE_INT, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_READ, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INT1, { .reg = { ZYDIS_IMPLREG_TYPE_FLAGS_SSZ, { .id = 0x3F } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_GPR8, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_GPR8, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_WRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INT1, { .reg = { ZYDIS_IMPLREG_TYPE_FLAGS_SSZ, { .id = 0x3F } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_INT8, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_GPR8, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_WRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INT1, { .reg = { ZYDIS_IMPLREG_TYPE_FLAGS_SSZ, { .id = 0x3F } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_GPR8, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_GPR8, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_WRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INT1, { .reg = { ZYDIS_IMPLREG_TYPE_FLAGS_SSZ, { .id = 0x3F } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_GPR8, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_INT8, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_WRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INT1, { .reg = { ZYDIS_IMPLREG_TYPE_FLAGS_SSZ, { .id = 0x3F } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_GPR16_32_64, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_GPR16_32_64, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_WRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INT1, { .reg = { ZYDIS_IMPLREG_TYPE_FLAGS_SSZ, { .id = 0x3F } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_GPR16_32_64, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 2, 4, 8 }, ZYDIS_IELEMENT_TYPE_INT, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_WRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INT1, { .reg = { ZYDIS_IMPLREG_TYPE_FLAGS_SSZ, { .id = 0x3F } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_IMPLICIT, ZYDIS_OPERAND_ACTION_READ, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .reg = { ZYDIS_IMPLREG_TYPE_STATIC, { .reg = ZYDIS_REGISTER_AL } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_INT8, { .encoding = ZYDIS_OPERAND_ENCODING_SIMM8 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_WRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INT1, { .reg = { ZYDIS_IMPLREG_TYPE_FLAGS_SSZ, { .id = 0x3F } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_IMPLICIT, ZYDIS_OPERAND_ACTION_READ, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .reg = { ZYDIS_IMPLREG_TYPE_GPR_OSZ, { .id = 0x0 } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 2, 4, 4 }, ZYDIS_IELEMENT_TYPE_INT, { .encoding = ZYDIS_OPERAND_ENCODING_SIMM16_32_32 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_WRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INT1, { .reg = { ZYDIS_IMPLREG_TYPE_FLAGS_SSZ, { .id = 0x3F } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_GPR8, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_INT8, { .encoding = ZYDIS_OPERAND_ENCODING_SIMM8 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_WRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INT1, { .reg = { ZYDIS_IMPLREG_TYPE_FLAGS_SSZ, { .id = 0x3F } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_INT8, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_INT8, { .encoding = ZYDIS_OPERAND_ENCODING_SIMM8 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_WRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INT1, { .reg = { ZYDIS_IMPLREG_TYPE_FLAGS_SSZ, { .id = 0x3F } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READWRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_FLOAT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_FLOAT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_CC3, { .encoding = ZYDIS_OPERAND_ENCODING_UIMM8 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READWRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_FLOAT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_FLOAT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_CC3, { .encoding = ZYDIS_OPERAND_ENCODING_UIMM8 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READWRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_FLOAT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_FLOAT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_CC3, { .encoding = ZYDIS_OPERAND_ENCODING_UIMM8 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READWRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_FLOAT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_FLOAT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_CC3, { .encoding = ZYDIS_OPERAND_ENCODING_UIMM8 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_MEM, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_READ, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_UINT8, { .mem = { 4, ZYDIS_IMPLMEM_BASE_ASI } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_MEM, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_READ, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_UINT8, { .mem = { 1, ZYDIS_IMPLMEM_BASE_ADI } }, ZYAN_FALSE, ZYAN_TRUE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_READWRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INT1, { .reg = { ZYDIS_IMPLREG_TYPE_FLAGS_SSZ, { .id = 0x3F } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_MEM, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_READ, { 4, 4, 4 }, ZYDIS_IELEMENT_TYPE_INT32, { .mem = { 4, ZYDIS_IMPLMEM_BASE_ASI } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_MEM, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_READ, { 4, 4, 4 }, ZYDIS_IELEMENT_TYPE_INT32, { .mem = { 1, ZYDIS_IMPLMEM_BASE_ADI } }, ZYAN_FALSE, ZYAN_TRUE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_READWRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INT1, { .reg = { ZYDIS_IMPLREG_TYPE_FLAGS_SSZ, { .id = 0x3F } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READWRITE, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_FLOAT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_FLOAT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_CC3, { .encoding = ZYDIS_OPERAND_ENCODING_UIMM8 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READWRITE, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_FLOAT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_FLOAT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_CC3, { .encoding = ZYDIS_OPERAND_ENCODING_UIMM8 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_MEM, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT64, { .mem = { 4, ZYDIS_IMPLMEM_BASE_ASI } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_MEM, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT64, { .mem = { 1, ZYDIS_IMPLMEM_BASE_ADI } }, ZYAN_FALSE, ZYAN_TRUE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_READWRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INT1, { .reg = { ZYDIS_IMPLREG_TYPE_FLAGS_SSZ, { .id = 0x3F } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READWRITE, { 4, 4, 4 }, ZYDIS_IELEMENT_TYPE_FLOAT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 4, 4, 4 }, ZYDIS_IELEMENT_TYPE_FLOAT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_CC3, { .encoding = ZYDIS_OPERAND_ENCODING_UIMM8 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READWRITE, { 4, 4, 4 }, ZYDIS_IELEMENT_TYPE_FLOAT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 4, 4, 4 }, ZYDIS_IELEMENT_TYPE_FLOAT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_CC3, { .encoding = ZYDIS_OPERAND_ENCODING_UIMM8 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_MEM, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_READ, { 2, 2, 2 }, ZYDIS_IELEMENT_TYPE_INT16, { .mem = { 4, ZYDIS_IMPLMEM_BASE_ASI } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_MEM, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_READ, { 2, 2, 2 }, ZYDIS_IELEMENT_TYPE_INT16, { .mem = { 1, ZYDIS_IMPLMEM_BASE_ADI } }, ZYAN_FALSE, ZYAN_TRUE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_READWRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INT1, { .reg = { ZYDIS_IMPLREG_TYPE_FLAGS_SSZ, { .id = 0x3F } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_FLOAT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_FLOAT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_WRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INT1, { .reg = { ZYDIS_IMPLREG_TYPE_FLAGS_SSZ, { .id = 0x3F } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_FLOAT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_FLOAT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_WRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INT1, { .reg = { ZYDIS_IMPLREG_TYPE_FLAGS_SSZ, { .id = 0x3F } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 4, 4, 4 }, ZYDIS_IELEMENT_TYPE_FLOAT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 4, 4, 4 }, ZYDIS_IELEMENT_TYPE_FLOAT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_WRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INT1, { .reg = { ZYDIS_IMPLREG_TYPE_FLAGS_SSZ, { .id = 0x3F } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 4, 4, 4 }, ZYDIS_IELEMENT_TYPE_FLOAT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 4, 4, 4 }, ZYDIS_IELEMENT_TYPE_FLOAT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_WRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INT1, { .reg = { ZYDIS_IMPLREG_TYPE_FLAGS_SSZ, { .id = 0x3F } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_GPR8, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_UINT, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_READWRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_UINT, { .reg = { ZYDIS_IMPLREG_TYPE_STATIC, { .reg = ZYDIS_REGISTER_AX } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_WRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INT1, { .reg = { ZYDIS_IMPLREG_TYPE_FLAGS_SSZ, { .id = 0x3F } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_READWRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_UINT, { .reg = { ZYDIS_IMPLREG_TYPE_STATIC, { .reg = ZYDIS_REGISTER_AX } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_WRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INT1, { .reg = { ZYDIS_IMPLREG_TYPE_FLAGS_SSZ, { .id = 0x3F } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_GPR_ASZ, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_UINT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_WRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INT1, { .reg = { ZYDIS_IMPLREG_TYPE_FLAGS_SSZ, { .id = 0x3F } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_GPR32, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 4, 4, 4 }, ZYDIS_IELEMENT_TYPE_INT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_INT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_UIMM8 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 4, 4, 4 }, ZYDIS_IELEMENT_TYPE_INT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_FLOAT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_UIMM8 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_UIMM8 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_UIMM8 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_IMPLICIT, ZYDIS_OPERAND_ACTION_READWRITE, { 10, 10, 10 }, ZYDIS_IELEMENT_TYPE_BFLOAT16X2, { .reg = { ZYDIS_IMPLREG_TYPE_STATIC, { .reg = ZYDIS_REGISTER_ST0 } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_FPR, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 10, 10, 10 }, ZYDIS_IELEMENT_TYPE_BFLOAT16X2, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_WRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_STRUCT, { .reg = { ZYDIS_IMPLREG_TYPE_STATIC, { .reg = ZYDIS_REGISTER_X87STATUS } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 4, 4, 4 }, ZYDIS_IELEMENT_TYPE_FLOAT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_READWRITE, { 10, 10, 10 }, ZYDIS_IELEMENT_TYPE_BFLOAT16X2, { .reg = { ZYDIS_IMPLREG_TYPE_STATIC, { .reg = ZYDIS_REGISTER_ST0 } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_WRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_STRUCT, { .reg = { ZYDIS_IMPLREG_TYPE_STATIC, { .reg = ZYDIS_REGISTER_X87STATUS } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_FPR, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READWRITE, { 10, 10, 10 }, ZYDIS_IELEMENT_TYPE_BFLOAT16X2, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_IMPLICIT, ZYDIS_OPERAND_ACTION_READ, { 10, 10, 10 }, ZYDIS_IELEMENT_TYPE_BFLOAT16X2, { .reg = { ZYDIS_IMPLREG_TYPE_STATIC, { .reg = ZYDIS_REGISTER_ST0 } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_WRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_STRUCT, { .reg = { ZYDIS_IMPLREG_TYPE_STATIC, { .reg = ZYDIS_REGISTER_X87STATUS } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_FLOAT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_READWRITE, { 10, 10, 10 }, ZYDIS_IELEMENT_TYPE_BFLOAT16X2, { .reg = { ZYDIS_IMPLREG_TYPE_STATIC, { .reg = ZYDIS_REGISTER_ST0 } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_WRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_STRUCT, { .reg = { ZYDIS_IMPLREG_TYPE_STATIC, { .reg = ZYDIS_REGISTER_X87STATUS } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 10, 10, 10 }, ZYDIS_IELEMENT_TYPE_BCD80, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_WRITE, { 10, 10, 10 }, ZYDIS_IELEMENT_TYPE_BFLOAT16X2, { .reg = { ZYDIS_IMPLREG_TYPE_STATIC, { .reg = ZYDIS_REGISTER_ST0 } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_WRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_STRUCT, { .reg = { ZYDIS_IMPLREG_TYPE_STATIC, { .reg = ZYDIS_REGISTER_X87STATUS } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 10, 10, 10 }, ZYDIS_IELEMENT_TYPE_BCD80, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_READ, { 10, 10, 10 }, ZYDIS_IELEMENT_TYPE_BFLOAT16X2, { .reg = { ZYDIS_IMPLREG_TYPE_STATIC, { .reg = ZYDIS_REGISTER_ST0 } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_WRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_STRUCT, { .reg = { ZYDIS_IMPLREG_TYPE_STATIC, { .reg = ZYDIS_REGISTER_X87STATUS } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_FPR, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 10, 10, 10 }, ZYDIS_IELEMENT_TYPE_BFLOAT16X2, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_READ, { 10, 10, 10 }, ZYDIS_IELEMENT_TYPE_BFLOAT16X2, { .reg = { ZYDIS_IMPLREG_TYPE_STATIC, { .reg = ZYDIS_REGISTER_ST0 } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_WRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_STRUCT, { .reg = { ZYDIS_IMPLREG_TYPE_STATIC, { .reg = ZYDIS_REGISTER_X87STATUS } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 4, 4, 4 }, ZYDIS_IELEMENT_TYPE_FLOAT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_READ, { 10, 10, 10 }, ZYDIS_IELEMENT_TYPE_BFLOAT16X2, { .reg = { ZYDIS_IMPLREG_TYPE_STATIC, { .reg = ZYDIS_REGISTER_ST0 } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_WRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_STRUCT, { .reg = { ZYDIS_IMPLREG_TYPE_STATIC, { .reg = ZYDIS_REGISTER_X87STATUS } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_FLOAT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_READ, { 10, 10, 10 }, ZYDIS_IELEMENT_TYPE_BFLOAT16X2, { .reg = { ZYDIS_IMPLREG_TYPE_STATIC, { .reg = ZYDIS_REGISTER_ST0 } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_WRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_STRUCT, { .reg = { ZYDIS_IMPLREG_TYPE_STATIC, { .reg = ZYDIS_REGISTER_X87STATUS } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_READ, { 10, 10, 10 }, ZYDIS_IELEMENT_TYPE_BFLOAT16X2, { .reg = { ZYDIS_IMPLREG_TYPE_STATIC, { .reg = ZYDIS_REGISTER_ST0 } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_READ, { 10, 10, 10 }, ZYDIS_IELEMENT_TYPE_BFLOAT16X2, { .reg = { ZYDIS_IMPLREG_TYPE_STATIC, { .reg = ZYDIS_REGISTER_ST1 } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_WRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_STRUCT, { .reg = { ZYDIS_IMPLREG_TYPE_STATIC, { .reg = ZYDIS_REGISTER_X87STATUS } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 4, 4, 4 }, ZYDIS_IELEMENT_TYPE_INT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_READWRITE, { 10, 10, 10 }, ZYDIS_IELEMENT_TYPE_BFLOAT16X2, { .reg = { ZYDIS_IMPLREG_TYPE_STATIC, { .reg = ZYDIS_REGISTER_ST0 } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_WRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_STRUCT, { .reg = { ZYDIS_IMPLREG_TYPE_STATIC, { .reg = ZYDIS_REGISTER_X87STATUS } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 2, 2, 2 }, ZYDIS_IELEMENT_TYPE_INT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_READWRITE, { 10, 10, 10 }, ZYDIS_IELEMENT_TYPE_BFLOAT16X2, { .reg = { ZYDIS_IMPLREG_TYPE_STATIC, { .reg = ZYDIS_REGISTER_ST0 } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_WRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_STRUCT, { .reg = { ZYDIS_IMPLREG_TYPE_STATIC, { .reg = ZYDIS_REGISTER_X87STATUS } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 4, 4, 4 }, ZYDIS_IELEMENT_TYPE_INT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_READ, { 10, 10, 10 }, ZYDIS_IELEMENT_TYPE_BFLOAT16X2, { .reg = { ZYDIS_IMPLREG_TYPE_STATIC, { .reg = ZYDIS_REGISTER_ST0 } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_WRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_STRUCT, { .reg = { ZYDIS_IMPLREG_TYPE_STATIC, { .reg = ZYDIS_REGISTER_X87STATUS } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 2, 2, 2 }, ZYDIS_IELEMENT_TYPE_INT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_READ, { 10, 10, 10 }, ZYDIS_IELEMENT_TYPE_BFLOAT16X2, { .reg = { ZYDIS_IMPLREG_TYPE_STATIC, { .reg = ZYDIS_REGISTER_ST0 } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_WRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_STRUCT, { .reg = { ZYDIS_IMPLREG_TYPE_STATIC, { .reg = ZYDIS_REGISTER_X87STATUS } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 4, 4, 4 }, ZYDIS_IELEMENT_TYPE_INT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_WRITE, { 10, 10, 10 }, ZYDIS_IELEMENT_TYPE_BFLOAT16X2, { .reg = { ZYDIS_IMPLREG_TYPE_STATIC, { .reg = ZYDIS_REGISTER_ST0 } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_WRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_STRUCT, { .reg = { ZYDIS_IMPLREG_TYPE_STATIC, { .reg = ZYDIS_REGISTER_X87STATUS } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 2, 2, 2 }, ZYDIS_IELEMENT_TYPE_INT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_WRITE, { 10, 10, 10 }, ZYDIS_IELEMENT_TYPE_BFLOAT16X2, { .reg = { ZYDIS_IMPLREG_TYPE_STATIC, { .reg = ZYDIS_REGISTER_ST0 } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_WRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_STRUCT, { .reg = { ZYDIS_IMPLREG_TYPE_STATIC, { .reg = ZYDIS_REGISTER_X87STATUS } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_WRITE, { 10, 10, 10 }, ZYDIS_IELEMENT_TYPE_BFLOAT16X2, { .reg = { ZYDIS_IMPLREG_TYPE_STATIC, { .reg = ZYDIS_REGISTER_ST0 } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_WRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_STRUCT, { .reg = { ZYDIS_IMPLREG_TYPE_STATIC, { .reg = ZYDIS_REGISTER_X87STATUS } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 4, 4, 4 }, ZYDIS_IELEMENT_TYPE_INT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_READ, { 10, 10, 10 }, ZYDIS_IELEMENT_TYPE_BFLOAT16X2, { .reg = { ZYDIS_IMPLREG_TYPE_STATIC, { .reg = ZYDIS_REGISTER_ST0 } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_WRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_STRUCT, { .reg = { ZYDIS_IMPLREG_TYPE_STATIC, { .reg = ZYDIS_REGISTER_X87STATUS } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 2, 2, 2 }, ZYDIS_IELEMENT_TYPE_INT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_READ, { 10, 10, 10 }, ZYDIS_IELEMENT_TYPE_BFLOAT16X2, { .reg = { ZYDIS_IMPLREG_TYPE_STATIC, { .reg = ZYDIS_REGISTER_ST0 } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_WRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_STRUCT, { .reg = { ZYDIS_IMPLREG_TYPE_STATIC, { .reg = ZYDIS_REGISTER_X87STATUS } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_READ, { 10, 10, 10 }, ZYDIS_IELEMENT_TYPE_BFLOAT16X2, { .reg = { ZYDIS_IMPLREG_TYPE_STATIC, { .reg = ZYDIS_REGISTER_ST0 } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_WRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_STRUCT, { .reg = { ZYDIS_IMPLREG_TYPE_STATIC, { .reg = ZYDIS_REGISTER_X87STATUS } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_FPR, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 10, 10, 10 }, ZYDIS_IELEMENT_TYPE_BFLOAT16X2, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_WRITE, { 10, 10, 10 }, ZYDIS_IELEMENT_TYPE_BFLOAT16X2, { .reg = { ZYDIS_IMPLREG_TYPE_STATIC, { .reg = ZYDIS_REGISTER_ST0 } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_WRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_STRUCT, { .reg = { ZYDIS_IMPLREG_TYPE_STATIC, { .reg = ZYDIS_REGISTER_X87STATUS } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 4, 4, 4 }, ZYDIS_IELEMENT_TYPE_FLOAT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_WRITE, { 10, 10, 10 }, ZYDIS_IELEMENT_TYPE_BFLOAT16X2, { .reg = { ZYDIS_IMPLREG_TYPE_STATIC, { .reg = ZYDIS_REGISTER_ST0 } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_WRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_STRUCT, { .reg = { ZYDIS_IMPLREG_TYPE_STATIC, { .reg = ZYDIS_REGISTER_X87STATUS } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 10, 10, 10 }, ZYDIS_IELEMENT_TYPE_BFLOAT16X2, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_WRITE, { 10, 10, 10 }, ZYDIS_IELEMENT_TYPE_BFLOAT16X2, { .reg = { ZYDIS_IMPLREG_TYPE_STATIC, { .reg = ZYDIS_REGISTER_ST0 } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_WRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_STRUCT, { .reg = { ZYDIS_IMPLREG_TYPE_STATIC, { .reg = ZYDIS_REGISTER_X87STATUS } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_FLOAT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_WRITE, { 10, 10, 10 }, ZYDIS_IELEMENT_TYPE_BFLOAT16X2, { .reg = { ZYDIS_IMPLREG_TYPE_STATIC, { .reg = ZYDIS_REGISTER_ST0 } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_WRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_STRUCT, { .reg = { ZYDIS_IMPLREG_TYPE_STATIC, { .reg = ZYDIS_REGISTER_X87STATUS } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_READ, { 10, 10, 10 }, ZYDIS_IELEMENT_TYPE_BFLOAT16X2, { .reg = { ZYDIS_IMPLREG_TYPE_STATIC, { .reg = ZYDIS_REGISTER_ST0 } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_READWRITE, { 10, 10, 10 }, ZYDIS_IELEMENT_TYPE_BFLOAT16X2, { .reg = { ZYDIS_IMPLREG_TYPE_STATIC, { .reg = ZYDIS_REGISTER_ST1 } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_WRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_STRUCT, { .reg = { ZYDIS_IMPLREG_TYPE_STATIC, { .reg = ZYDIS_REGISTER_X87STATUS } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_READWRITE, { 10, 10, 10 }, ZYDIS_IELEMENT_TYPE_BFLOAT16X2, { .reg = { ZYDIS_IMPLREG_TYPE_STATIC, { .reg = ZYDIS_REGISTER_ST0 } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_READ, { 10, 10, 10 }, ZYDIS_IELEMENT_TYPE_BFLOAT16X2, { .reg = { ZYDIS_IMPLREG_TYPE_STATIC, { .reg = ZYDIS_REGISTER_ST1 } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_WRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_STRUCT, { .reg = { ZYDIS_IMPLREG_TYPE_STATIC, { .reg = ZYDIS_REGISTER_X87STATUS } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_READWRITE, { 10, 10, 10 }, ZYDIS_IELEMENT_TYPE_BFLOAT16X2, { .reg = { ZYDIS_IMPLREG_TYPE_STATIC, { .reg = ZYDIS_REGISTER_ST0 } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_WRITE, { 10, 10, 10 }, ZYDIS_IELEMENT_TYPE_BFLOAT16X2, { .reg = { ZYDIS_IMPLREG_TYPE_STATIC, { .reg = ZYDIS_REGISTER_ST1 } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_WRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_STRUCT, { .reg = { ZYDIS_IMPLREG_TYPE_STATIC, { .reg = ZYDIS_REGISTER_X87STATUS } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 4, 4, 4 }, ZYDIS_IELEMENT_TYPE_FLOAT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_READ, { 10, 10, 10 }, ZYDIS_IELEMENT_TYPE_BFLOAT16X2, { .reg = { ZYDIS_IMPLREG_TYPE_STATIC, { .reg = ZYDIS_REGISTER_ST0 } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_WRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_STRUCT, { .reg = { ZYDIS_IMPLREG_TYPE_STATIC, { .reg = ZYDIS_REGISTER_X87STATUS } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_FPR, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 10, 10, 10 }, ZYDIS_IELEMENT_TYPE_BFLOAT16X2, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_READ, { 10, 10, 10 }, ZYDIS_IELEMENT_TYPE_BFLOAT16X2, { .reg = { ZYDIS_IMPLREG_TYPE_STATIC, { .reg = ZYDIS_REGISTER_ST0 } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_WRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_STRUCT, { .reg = { ZYDIS_IMPLREG_TYPE_STATIC, { .reg = ZYDIS_REGISTER_X87STATUS } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_FLOAT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_READ, { 10, 10, 10 }, ZYDIS_IELEMENT_TYPE_BFLOAT16X2, { .reg = { ZYDIS_IMPLREG_TYPE_STATIC, { .reg = ZYDIS_REGISTER_ST0 } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_WRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_STRUCT, { .reg = { ZYDIS_IMPLREG_TYPE_STATIC, { .reg = ZYDIS_REGISTER_X87STATUS } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 10, 10, 10 }, ZYDIS_IELEMENT_TYPE_BFLOAT16X2, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_READ, { 10, 10, 10 }, ZYDIS_IELEMENT_TYPE_BFLOAT16X2, { .reg = { ZYDIS_IMPLREG_TYPE_STATIC, { .reg = ZYDIS_REGISTER_ST0 } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_WRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_STRUCT, { .reg = { ZYDIS_IMPLREG_TYPE_STATIC, { .reg = ZYDIS_REGISTER_X87STATUS } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_IMPLICIT, ZYDIS_OPERAND_ACTION_READ, { 10, 10, 10 }, ZYDIS_IELEMENT_TYPE_BFLOAT16X2, { .reg = { ZYDIS_IMPLREG_TYPE_STATIC, { .reg = ZYDIS_REGISTER_ST0 } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_FPR, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 10, 10, 10 }, ZYDIS_IELEMENT_TYPE_BFLOAT16X2, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_WRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_STRUCT, { .reg = { ZYDIS_IMPLREG_TYPE_STATIC, { .reg = ZYDIS_REGISTER_X87STATUS } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_FPR, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READWRITE, { 10, 10, 10 }, ZYDIS_IELEMENT_TYPE_BFLOAT16X2, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_READWRITE, { 10, 10, 10 }, ZYDIS_IELEMENT_TYPE_BFLOAT16X2, { .reg = { ZYDIS_IMPLREG_TYPE_STATIC, { .reg = ZYDIS_REGISTER_ST0 } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_WRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_STRUCT, { .reg = { ZYDIS_IMPLREG_TYPE_STATIC, { .reg = ZYDIS_REGISTER_X87STATUS } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READWRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_UINT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_UIMM8 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READWRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_UINT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_UIMM8 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_GPR8, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_READWRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .reg = { ZYDIS_IMPLREG_TYPE_STATIC, { .reg = ZYDIS_REGISTER_AX } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_WRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INT1, { .reg = { ZYDIS_IMPLREG_TYPE_FLAGS_SSZ, { .id = 0x3F } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_INT8, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_READWRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .reg = { ZYDIS_IMPLREG_TYPE_STATIC, { .reg = ZYDIS_REGISTER_AX } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_WRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INT1, { .reg = { ZYDIS_IMPLREG_TYPE_FLAGS_SSZ, { .id = 0x3F } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_IMPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .reg = { ZYDIS_IMPLREG_TYPE_STATIC, { .reg = ZYDIS_REGISTER_AL } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_UIMM8 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_READ, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INT1, { .reg = { ZYDIS_IMPLREG_TYPE_FLAGS_SSZ, { .id = 0x3F } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_IMPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .reg = { ZYDIS_IMPLREG_TYPE_STATIC, { .reg = ZYDIS_REGISTER_AX } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_UIMM8 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_READ, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INT1, { .reg = { ZYDIS_IMPLREG_TYPE_FLAGS_SSZ, { .id = 0x3F } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_IMPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .reg = { ZYDIS_IMPLREG_TYPE_STATIC, { .reg = ZYDIS_REGISTER_EAX } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_UIMM8 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_READ, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INT1, { .reg = { ZYDIS_IMPLREG_TYPE_FLAGS_SSZ, { .id = 0x3F } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_IMPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .reg = { ZYDIS_IMPLREG_TYPE_STATIC, { .reg = ZYDIS_REGISTER_AL } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_IMPLICIT, ZYDIS_OPERAND_ACTION_READ, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .reg = { ZYDIS_IMPLREG_TYPE_STATIC, { .reg = ZYDIS_REGISTER_DX } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_READ, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INT1, { .reg = { ZYDIS_IMPLREG_TYPE_FLAGS_SSZ, { .id = 0x3F } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_IMPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .reg = { ZYDIS_IMPLREG_TYPE_STATIC, { .reg = ZYDIS_REGISTER_AX } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_IMPLICIT, ZYDIS_OPERAND_ACTION_READ, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .reg = { ZYDIS_IMPLREG_TYPE_STATIC, { .reg = ZYDIS_REGISTER_DX } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_READ, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INT1, { .reg = { ZYDIS_IMPLREG_TYPE_FLAGS_SSZ, { .id = 0x3F } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_IMPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .reg = { ZYDIS_IMPLREG_TYPE_STATIC, { .reg = ZYDIS_REGISTER_EAX } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_IMPLICIT, ZYDIS_OPERAND_ACTION_READ, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .reg = { ZYDIS_IMPLREG_TYPE_STATIC, { .reg = ZYDIS_REGISTER_DX } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_READ, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INT1, { .reg = { ZYDIS_IMPLREG_TYPE_FLAGS_SSZ, { .id = 0x3F } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_MEM, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_WRITE, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_UINT8, { .mem = { 1, ZYDIS_IMPLMEM_BASE_ADI } }, ZYAN_FALSE, ZYAN_TRUE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_READ, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .reg = { ZYDIS_IMPLREG_TYPE_STATIC, { .reg = ZYDIS_REGISTER_DX } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_READ, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INT1, { .reg = { ZYDIS_IMPLREG_TYPE_FLAGS_SSZ, { .id = 0x3F } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_MEM, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_WRITE, { 4, 4, 4 }, ZYDIS_IELEMENT_TYPE_INT32, { .mem = { 1, ZYDIS_IMPLMEM_BASE_ADI } }, ZYAN_FALSE, ZYAN_TRUE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_READ, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .reg = { ZYDIS_IMPLREG_TYPE_STATIC, { .reg = ZYDIS_REGISTER_DX } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_READ, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INT1, { .reg = { ZYDIS_IMPLREG_TYPE_FLAGS_SSZ, { .id = 0x3F } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READWRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_FLOAT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 4, 4, 4 }, ZYDIS_IELEMENT_TYPE_INT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_UIMM8 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_MEM, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_WRITE, { 2, 2, 2 }, ZYDIS_IELEMENT_TYPE_INT16, { .mem = { 1, ZYDIS_IMPLMEM_BASE_ADI } }, ZYAN_FALSE, ZYAN_TRUE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_READ, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .reg = { ZYDIS_IMPLREG_TYPE_STATIC, { .reg = ZYDIS_REGISTER_DX } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_READ, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INT1, { .reg = { ZYDIS_IMPLREG_TYPE_FLAGS_SSZ, { .id = 0x3F } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_UIMM8 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_WRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .reg = { ZYDIS_IMPLREG_TYPE_IP_SSZ, { .id = 0x3F } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_READWRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INT1, { .reg = { ZYDIS_IMPLREG_TYPE_FLAGS_SSZ, { .id = 0x3F } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_GPR64, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_INT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_WRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INT1, { .reg = { ZYDIS_IMPLREG_TYPE_FLAGS_SSZ, { .id = 0x3F } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_GPR32, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_INT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_WRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INT1, { .reg = { ZYDIS_IMPLREG_TYPE_FLAGS_SSZ, { .id = 0x3F } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_IMPLICIT, ZYDIS_OPERAND_ACTION_READ, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .reg = { ZYDIS_IMPLREG_TYPE_GPR_ASZ, { .id = 0x0 } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_IMPLICIT, ZYDIS_OPERAND_ACTION_READ, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .reg = { ZYDIS_IMPLREG_TYPE_STATIC, { .reg = ZYDIS_REGISTER_EDX } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_IMPLICIT, ZYDIS_OPERAND_ACTION_READ, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .reg = { ZYDIS_IMPLREG_TYPE_STATIC, { .reg = ZYDIS_REGISTER_ECX } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_REL, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_INT8, { .encoding = ZYDIS_OPERAND_ENCODING_JIMM8 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_READWRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .reg = { ZYDIS_IMPLREG_TYPE_STATIC, { .reg = ZYDIS_REGISTER_RIP } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_READ, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INT1, { .reg = { ZYDIS_IMPLREG_TYPE_FLAGS_SSZ, { .id = 0x3F } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_REL, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_INT8, { .encoding = ZYDIS_OPERAND_ENCODING_JIMM8 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_READWRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .reg = { ZYDIS_IMPLREG_TYPE_STATIC, { .reg = ZYDIS_REGISTER_EIP } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_READ, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INT1, { .reg = { ZYDIS_IMPLREG_TYPE_FLAGS_SSZ, { .id = 0x3F } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_REL, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 4, 4, 4 }, ZYDIS_IELEMENT_TYPE_INT32, { .encoding = ZYDIS_OPERAND_ENCODING_JIMM32 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_READWRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .reg = { ZYDIS_IMPLREG_TYPE_STATIC, { .reg = ZYDIS_REGISTER_RIP } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_READ, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INT1, { .reg = { ZYDIS_IMPLREG_TYPE_FLAGS_SSZ, { .id = 0x3F } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_REL, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 2, 4, 4 }, ZYDIS_IELEMENT_TYPE_INT, { .encoding = ZYDIS_OPERAND_ENCODING_JIMM16_32_32 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_READWRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .reg = { ZYDIS_IMPLREG_TYPE_STATIC, { .reg = ZYDIS_REGISTER_RIP } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_READ, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INT1, { .reg = { ZYDIS_IMPLREG_TYPE_FLAGS_SSZ, { .id = 0x3F } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_REL, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 2, 4, 4 }, ZYDIS_IELEMENT_TYPE_INT, { .encoding = ZYDIS_OPERAND_ENCODING_JIMM16_32_32 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_READWRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .reg = { ZYDIS_IMPLREG_TYPE_STATIC, { .reg = ZYDIS_REGISTER_EIP } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_READ, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INT1, { .reg = { ZYDIS_IMPLREG_TYPE_FLAGS_SSZ, { .id = 0x3F } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_REL, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_INT8, { .encoding = ZYDIS_OPERAND_ENCODING_JIMM8 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_READ, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .reg = { ZYDIS_IMPLREG_TYPE_STATIC, { .reg = ZYDIS_REGISTER_CX } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_READWRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .reg = { ZYDIS_IMPLREG_TYPE_STATIC, { .reg = ZYDIS_REGISTER_IP } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_REL, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_INT8, { .encoding = ZYDIS_OPERAND_ENCODING_JIMM8 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_READ, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .reg = { ZYDIS_IMPLREG_TYPE_STATIC, { .reg = ZYDIS_REGISTER_ECX } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_READWRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .reg = { ZYDIS_IMPLREG_TYPE_STATIC, { .reg = ZYDIS_REGISTER_RIP } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_REL, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_INT8, { .encoding = ZYDIS_OPERAND_ENCODING_JIMM8 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_READ, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .reg = { ZYDIS_IMPLREG_TYPE_STATIC, { .reg = ZYDIS_REGISTER_ECX } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_READWRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .reg = { ZYDIS_IMPLREG_TYPE_STATIC, { .reg = ZYDIS_REGISTER_EIP } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_REL, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_INT8, { .encoding = ZYDIS_OPERAND_ENCODING_JIMM8 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_READ, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .reg = { ZYDIS_IMPLREG_TYPE_STATIC, { .reg = ZYDIS_REGISTER_RCX } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_READWRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .reg = { ZYDIS_IMPLREG_TYPE_STATIC, { .reg = ZYDIS_REGISTER_RIP } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_GPR16_32_64, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_CONDWRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_GPR16_32_64, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_WRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INT1, { .reg = { ZYDIS_IMPLREG_TYPE_FLAGS_SSZ, { .id = 0x3F } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_GPR16_32_64, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_CONDWRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 2, 2, 2 }, ZYDIS_IELEMENT_TYPE_INT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_WRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INT1, { .reg = { ZYDIS_IMPLREG_TYPE_FLAGS_SSZ, { .id = 0x3F } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_GPR16_32_32, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 4, 6, 6 }, ZYDIS_IELEMENT_TYPE_STRUCT, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_WRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .reg = { ZYDIS_IMPLREG_TYPE_STATIC, { .reg = ZYDIS_REGISTER_DS } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_MEM, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_READ, { 2, 4, 8 }, ZYDIS_IELEMENT_TYPE_INT, { .mem = { 3, ZYDIS_IMPLMEM_BASE_SBP } }, ZYAN_FALSE, ZYAN_TRUE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_READWRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .reg = { ZYDIS_IMPLREG_TYPE_GPR_OSZ, { .id = 0x5 } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_READWRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .reg = { ZYDIS_IMPLREG_TYPE_GPR_OSZ, { .id = 0x4 } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_GPR16_32_32, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 4, 6, 6 }, ZYDIS_IELEMENT_TYPE_STRUCT, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_WRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .reg = { ZYDIS_IMPLREG_TYPE_STATIC, { .reg = ZYDIS_REGISTER_ES } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_GPR16_32_64, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 4, 6, 10 }, ZYDIS_IELEMENT_TYPE_STRUCT, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_WRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .reg = { ZYDIS_IMPLREG_TYPE_STATIC, { .reg = ZYDIS_REGISTER_FS } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_GPR16_32_64, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 4, 6, 10 }, ZYDIS_IELEMENT_TYPE_STRUCT, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_WRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .reg = { ZYDIS_IMPLREG_TYPE_STATIC, { .reg = ZYDIS_REGISTER_GS } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_GPR16_32_64, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READWRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_GPR16_32_32, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_WRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INT1, { .reg = { ZYDIS_IMPLREG_TYPE_FLAGS_SSZ, { .id = 0x3F } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_GPR16_32_64, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READWRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 2, 2, 2 }, ZYDIS_IELEMENT_TYPE_INT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_WRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INT1, { .reg = { ZYDIS_IMPLREG_TYPE_FLAGS_SSZ, { .id = 0x3F } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_GPR16_32_64, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 4, 6, 10 }, ZYDIS_IELEMENT_TYPE_STRUCT, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_WRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .reg = { ZYDIS_IMPLREG_TYPE_STATIC, { .reg = ZYDIS_REGISTER_SS } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_GPR16_32_64, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 2, 4, 8 }, ZYDIS_IELEMENT_TYPE_INT, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_GPR16_32_64, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 2, 4, 8 }, ZYDIS_IELEMENT_TYPE_INT, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_WRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INT1, { .reg = { ZYDIS_IMPLREG_TYPE_FLAGS_SSZ, { .id = 0x3F } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_GPR16_32_64, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 2, 4, 8 }, ZYDIS_IELEMENT_TYPE_INT, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 2, 4, 8 }, ZYDIS_IELEMENT_TYPE_INT, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_WRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INT1, { .reg = { ZYDIS_IMPLREG_TYPE_FLAGS_SSZ, { .id = 0x3F } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_MEM, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_WRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_UINT8, { .mem = { 4, ZYDIS_IMPLMEM_BASE_ADI } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MMX, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT8, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MMX, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT8, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_MEM, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_WRITE, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT64, { .mem = { 4, ZYDIS_IMPLMEM_BASE_ADI } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_READ, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .reg = { ZYDIS_IMPLREG_TYPE_GPR_ASZ, { .id = 0x0 } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_READ, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .reg = { ZYDIS_IMPLREG_TYPE_STATIC, { .reg = ZYDIS_REGISTER_RCX } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_READ, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .reg = { ZYDIS_IMPLREG_TYPE_STATIC, { .reg = ZYDIS_REGISTER_RDX } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_READ, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .reg = { ZYDIS_IMPLREG_TYPE_GPR_ASZ, { .id = 0x0 } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_READ, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .reg = { ZYDIS_IMPLREG_TYPE_STATIC, { .reg = ZYDIS_REGISTER_ECX } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_READ, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .reg = { ZYDIS_IMPLREG_TYPE_STATIC, { .reg = ZYDIS_REGISTER_EDX } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_GPR_ASZ, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_UINT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_MEM, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_WRITE, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_INT32, { .mem = { 0, ZYDIS_IMPLMEM_BASE_AGPR_REG } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_GPR_ASZ, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_UINT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_MEM, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_WRITE, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_INT32, { .mem = { 1, ZYDIS_IMPLMEM_BASE_AGPR_REG } }, ZYAN_FALSE, ZYAN_TRUE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READWRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_UIMM8 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READWRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_UIMM8 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_UIMM8 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_IMPLICIT, ZYDIS_OPERAND_ACTION_READ, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .reg = { ZYDIS_IMPLREG_TYPE_STATIC, { .reg = ZYDIS_REGISTER_AL } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_READ, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INT1, { .reg = { ZYDIS_IMPLREG_TYPE_FLAGS_SSZ, { .id = 0x3F } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_UIMM8 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_IMPLICIT, ZYDIS_OPERAND_ACTION_READ, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .reg = { ZYDIS_IMPLREG_TYPE_STATIC, { .reg = ZYDIS_REGISTER_AX } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_READ, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INT1, { .reg = { ZYDIS_IMPLREG_TYPE_FLAGS_SSZ, { .id = 0x3F } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_UIMM8 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_IMPLICIT, ZYDIS_OPERAND_ACTION_READ, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .reg = { ZYDIS_IMPLREG_TYPE_STATIC, { .reg = ZYDIS_REGISTER_EAX } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_READ, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INT1, { .reg = { ZYDIS_IMPLREG_TYPE_FLAGS_SSZ, { .id = 0x3F } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_IMPLICIT, ZYDIS_OPERAND_ACTION_READ, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .reg = { ZYDIS_IMPLREG_TYPE_STATIC, { .reg = ZYDIS_REGISTER_DX } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_IMPLICIT, ZYDIS_OPERAND_ACTION_READ, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .reg = { ZYDIS_IMPLREG_TYPE_STATIC, { .reg = ZYDIS_REGISTER_AL } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_READ, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INT1, { .reg = { ZYDIS_IMPLREG_TYPE_FLAGS_SSZ, { .id = 0x3F } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_IMPLICIT, ZYDIS_OPERAND_ACTION_READ, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .reg = { ZYDIS_IMPLREG_TYPE_STATIC, { .reg = ZYDIS_REGISTER_DX } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_IMPLICIT, ZYDIS_OPERAND_ACTION_READ, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .reg = { ZYDIS_IMPLREG_TYPE_STATIC, { .reg = ZYDIS_REGISTER_AX } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_READ, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INT1, { .reg = { ZYDIS_IMPLREG_TYPE_FLAGS_SSZ, { .id = 0x3F } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_IMPLICIT, ZYDIS_OPERAND_ACTION_READ, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .reg = { ZYDIS_IMPLREG_TYPE_STATIC, { .reg = ZYDIS_REGISTER_DX } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_IMPLICIT, ZYDIS_OPERAND_ACTION_READ, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .reg = { ZYDIS_IMPLREG_TYPE_STATIC, { .reg = ZYDIS_REGISTER_EAX } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_READ, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INT1, { .reg = { ZYDIS_IMPLREG_TYPE_FLAGS_SSZ, { .id = 0x3F } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_READ, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .reg = { ZYDIS_IMPLREG_TYPE_STATIC, { .reg = ZYDIS_REGISTER_DX } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_MEM, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_READ, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_UINT8, { .mem = { 4, ZYDIS_IMPLMEM_BASE_ASI } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_READ, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INT1, { .reg = { ZYDIS_IMPLREG_TYPE_FLAGS_SSZ, { .id = 0x3F } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_READ, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .reg = { ZYDIS_IMPLREG_TYPE_STATIC, { .reg = ZYDIS_REGISTER_DX } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_MEM, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_READ, { 4, 4, 4 }, ZYDIS_IELEMENT_TYPE_INT32, { .mem = { 4, ZYDIS_IMPLMEM_BASE_ASI } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_READ, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INT1, { .reg = { ZYDIS_IMPLREG_TYPE_FLAGS_SSZ, { .id = 0x3F } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_READ, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .reg = { ZYDIS_IMPLREG_TYPE_STATIC, { .reg = ZYDIS_REGISTER_DX } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_MEM, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_READ, { 2, 2, 2 }, ZYDIS_IELEMENT_TYPE_INT16, { .mem = { 4, ZYDIS_IMPLMEM_BASE_ASI } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_READ, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INT1, { .reg = { ZYDIS_IMPLREG_TYPE_FLAGS_SSZ, { .id = 0x3F } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MMX, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READWRITE, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MMX, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_UIMM8 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MMX, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READWRITE, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_UIMM8 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READWRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_INT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_INT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_UIMM8 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READWRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_INT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_INT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_UIMM8 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READWRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_INT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_INT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_INT32, { .reg = { ZYDIS_IMPLREG_TYPE_STATIC, { .reg = ZYDIS_REGISTER_XMM0 } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READWRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_INT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_INT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_INT32, { .reg = { ZYDIS_IMPLREG_TYPE_STATIC, { .reg = ZYDIS_REGISTER_XMM0 } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_GPR32, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 4, 4, 4 }, ZYDIS_IELEMENT_TYPE_UINT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_UINT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_UIMM8 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_UINT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_UIMM8 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 4, 4, 4 }, ZYDIS_IELEMENT_TYPE_INT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_INT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_UIMM8 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_GPR64, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_INT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_UIMM8 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_INT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_UIMM8 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_GPR32, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_UINT, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MMX, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_UINT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_UIMM8 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_GPR32, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_UINT, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_UINT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_UIMM8 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_GPR32, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_UINT, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_UINT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_UIMM8 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 2, 2, 2 }, ZYDIS_IELEMENT_TYPE_UINT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_UINT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_UIMM8 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READWRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_UINT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_GPR32, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 4, 4, 4 }, ZYDIS_IELEMENT_TYPE_UINT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_UIMM8 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READWRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_UINT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_UIMM8 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READWRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_UINT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 4, 4, 4 }, ZYDIS_IELEMENT_TYPE_UINT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_UIMM8 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READWRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_UINT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_GPR64, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_UINT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_UIMM8 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READWRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_UINT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_UINT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_UIMM8 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MMX, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READWRITE, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_UINT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_GPR32, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_UINT, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_UIMM8 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MMX, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READWRITE, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_UINT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 2, 2, 2 }, ZYDIS_IELEMENT_TYPE_UINT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_UIMM8 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READWRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_UINT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_GPR32, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_UINT, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_UIMM8 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READWRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_UINT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 2, 2, 2 }, ZYDIS_IELEMENT_TYPE_UINT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_UIMM8 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_IMPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .reg = { ZYDIS_IMPLREG_TYPE_STATIC, { .reg = ZYDIS_REGISTER_ES } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_READWRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .reg = { ZYDIS_IMPLREG_TYPE_GPR_SSZ, { .id = 0x4 } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_MEM, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_READ, { 2, 4, 8 }, ZYDIS_IELEMENT_TYPE_INT, { .mem = { 0, ZYDIS_IMPLMEM_BASE_SSP } }, ZYAN_FALSE, ZYAN_TRUE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_IMPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .reg = { ZYDIS_IMPLREG_TYPE_STATIC, { .reg = ZYDIS_REGISTER_SS } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_READWRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .reg = { ZYDIS_IMPLREG_TYPE_GPR_SSZ, { .id = 0x4 } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_MEM, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_READ, { 2, 4, 8 }, ZYDIS_IELEMENT_TYPE_INT, { .mem = { 0, ZYDIS_IMPLMEM_BASE_SSP } }, ZYAN_FALSE, ZYAN_TRUE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_IMPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .reg = { ZYDIS_IMPLREG_TYPE_STATIC, { .reg = ZYDIS_REGISTER_DS } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_READWRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .reg = { ZYDIS_IMPLREG_TYPE_GPR_SSZ, { .id = 0x4 } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_MEM, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_READ, { 2, 4, 8 }, ZYDIS_IELEMENT_TYPE_INT, { .mem = { 0, ZYDIS_IMPLMEM_BASE_SSP } }, ZYAN_FALSE, ZYAN_TRUE },
    { ZYDIS_SEMANTIC_OPTYPE_GPR16_32_64, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .encoding = ZYDIS_OPERAND_ENCODING_OPCODE }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_READWRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .reg = { ZYDIS_IMPLREG_TYPE_GPR_SSZ, { .id = 0x4 } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_MEM, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_READ, { 2, 4, 8 }, ZYDIS_IELEMENT_TYPE_INT, { .mem = { 0, ZYDIS_IMPLMEM_BASE_SSP } }, ZYAN_FALSE, ZYAN_TRUE },
    { ZYDIS_SEMANTIC_OPTYPE_GPR16_32_64, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_READWRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .reg = { ZYDIS_IMPLREG_TYPE_GPR_SSZ, { .id = 0x4 } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_MEM, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_READ, { 2, 4, 8 }, ZYDIS_IELEMENT_TYPE_INT, { .mem = { 0, ZYDIS_IMPLMEM_BASE_SSP } }, ZYAN_FALSE, ZYAN_TRUE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 2, 4, 8 }, ZYDIS_IELEMENT_TYPE_INT, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_READWRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .reg = { ZYDIS_IMPLREG_TYPE_GPR_SSZ, { .id = 0x4 } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_MEM, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_READ, { 2, 4, 8 }, ZYDIS_IELEMENT_TYPE_INT, { .mem = { 0, ZYDIS_IMPLMEM_BASE_SSP } }, ZYAN_FALSE, ZYAN_TRUE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_IMPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .reg = { ZYDIS_IMPLREG_TYPE_STATIC, { .reg = ZYDIS_REGISTER_FS } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_READWRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .reg = { ZYDIS_IMPLREG_TYPE_GPR_SSZ, { .id = 0x4 } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_MEM, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_READ, { 2, 4, 8 }, ZYDIS_IELEMENT_TYPE_INT, { .mem = { 0, ZYDIS_IMPLMEM_BASE_SSP } }, ZYAN_FALSE, ZYAN_TRUE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_IMPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .reg = { ZYDIS_IMPLREG_TYPE_STATIC, { .reg = ZYDIS_REGISTER_GS } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_READWRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .reg = { ZYDIS_IMPLREG_TYPE_GPR_SSZ, { .id = 0x4 } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_MEM, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_READ, { 2, 4, 8 }, ZYDIS_IELEMENT_TYPE_INT, { .mem = { 0, ZYDIS_IMPLMEM_BASE_SSP } }, ZYAN_FALSE, ZYAN_TRUE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_READWRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .reg = { ZYDIS_IMPLREG_TYPE_GPR_SSZ, { .id = 0x4 } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_MEM, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_READ, { 2, 2, 2 }, ZYDIS_IELEMENT_TYPE_INT, { .mem = { 0, ZYDIS_IMPLMEM_BASE_SSP } }, ZYAN_FALSE, ZYAN_TRUE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_READWRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INT1, { .reg = { ZYDIS_IMPLREG_TYPE_FLAGS_SSZ, { .id = 0x3F } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_READWRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .reg = { ZYDIS_IMPLREG_TYPE_GPR_SSZ, { .id = 0x4 } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_MEM, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_READ, { 4, 4, 4 }, ZYDIS_IELEMENT_TYPE_INT, { .mem = { 0, ZYDIS_IMPLMEM_BASE_SSP } }, ZYAN_FALSE, ZYAN_TRUE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_READWRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INT1, { .reg = { ZYDIS_IMPLREG_TYPE_FLAGS_SSZ, { .id = 0x3F } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_READWRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .reg = { ZYDIS_IMPLREG_TYPE_GPR_SSZ, { .id = 0x4 } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_MEM, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT, { .mem = { 0, ZYDIS_IMPLMEM_BASE_SSP } }, ZYAN_FALSE, ZYAN_TRUE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_READWRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INT1, { .reg = { ZYDIS_IMPLREG_TYPE_FLAGS_SSZ, { .id = 0x3F } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_UINT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_UINT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_UIMM8 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_UINT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_UINT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_UIMM8 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_UINT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_UINT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_UIMM8 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_UINT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_UINT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_UIMM8 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MMX, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_UINT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MMX, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_UINT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_UIMM8 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MMX, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_UINT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_UINT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_UIMM8 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_INT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_INT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_WRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INT1, { .reg = { ZYDIS_IMPLREG_TYPE_FLAGS_SSZ, { .id = 0x3F } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_INT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_INT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_WRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INT1, { .reg = { ZYDIS_IMPLREG_TYPE_FLAGS_SSZ, { .id = 0x3F } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_IMPLICIT, ZYDIS_OPERAND_ACTION_READ, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .reg = { ZYDIS_IMPLREG_TYPE_STATIC, { .reg = ZYDIS_REGISTER_ES } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_READWRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .reg = { ZYDIS_IMPLREG_TYPE_GPR_SSZ, { .id = 0x4 } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_MEM, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_WRITE, { 2, 4, 8 }, ZYDIS_IELEMENT_TYPE_INT, { .mem = { 0, ZYDIS_IMPLMEM_BASE_SSP } }, ZYAN_FALSE, ZYAN_TRUE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_IMPLICIT, ZYDIS_OPERAND_ACTION_READ, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .reg = { ZYDIS_IMPLREG_TYPE_STATIC, { .reg = ZYDIS_REGISTER_CS } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_READWRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .reg = { ZYDIS_IMPLREG_TYPE_GPR_SSZ, { .id = 0x4 } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_MEM, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_WRITE, { 2, 4, 8 }, ZYDIS_IELEMENT_TYPE_INT, { .mem = { 0, ZYDIS_IMPLMEM_BASE_SSP } }, ZYAN_FALSE, ZYAN_TRUE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_IMPLICIT, ZYDIS_OPERAND_ACTION_READ, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .reg = { ZYDIS_IMPLREG_TYPE_STATIC, { .reg = ZYDIS_REGISTER_SS } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_READWRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .reg = { ZYDIS_IMPLREG_TYPE_GPR_SSZ, { .id = 0x4 } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_MEM, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_WRITE, { 2, 4, 8 }, ZYDIS_IELEMENT_TYPE_INT, { .mem = { 0, ZYDIS_IMPLMEM_BASE_SSP } }, ZYAN_FALSE, ZYAN_TRUE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_IMPLICIT, ZYDIS_OPERAND_ACTION_READ, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .reg = { ZYDIS_IMPLREG_TYPE_STATIC, { .reg = ZYDIS_REGISTER_DS } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_READWRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .reg = { ZYDIS_IMPLREG_TYPE_GPR_SSZ, { .id = 0x4 } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_MEM, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_WRITE, { 2, 4, 8 }, ZYDIS_IELEMENT_TYPE_INT, { .mem = { 0, ZYDIS_IMPLMEM_BASE_SSP } }, ZYAN_FALSE, ZYAN_TRUE },
    { ZYDIS_SEMANTIC_OPTYPE_GPR16_32_64, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .encoding = ZYDIS_OPERAND_ENCODING_OPCODE }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_READWRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .reg = { ZYDIS_IMPLREG_TYPE_GPR_SSZ, { .id = 0x4 } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_MEM, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_WRITE, { 2, 4, 8 }, ZYDIS_IELEMENT_TYPE_INT, { .mem = { 0, ZYDIS_IMPLMEM_BASE_SSP } }, ZYAN_FALSE, ZYAN_TRUE },
    { ZYDIS_SEMANTIC_OPTYPE_IMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 2, 4, 4 }, ZYDIS_IELEMENT_TYPE_INT, { .encoding = ZYDIS_OPERAND_ENCODING_SIMM16_32_32 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_READWRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .reg = { ZYDIS_IMPLREG_TYPE_GPR_SSZ, { .id = 0x4 } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_MEM, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_WRITE, { 2, 4, 8 }, ZYDIS_IELEMENT_TYPE_INT, { .mem = { 0, ZYDIS_IMPLMEM_BASE_SSP } }, ZYAN_FALSE, ZYAN_TRUE },
    { ZYDIS_SEMANTIC_OPTYPE_IMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_INT8, { .encoding = ZYDIS_OPERAND_ENCODING_SIMM8 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_READWRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .reg = { ZYDIS_IMPLREG_TYPE_GPR_SSZ, { .id = 0x4 } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_MEM, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_WRITE, { 2, 4, 8 }, ZYDIS_IELEMENT_TYPE_INT, { .mem = { 0, ZYDIS_IMPLMEM_BASE_SSP } }, ZYAN_FALSE, ZYAN_TRUE },
    { ZYDIS_SEMANTIC_OPTYPE_GPR16_32_64, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_READWRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .reg = { ZYDIS_IMPLREG_TYPE_GPR_SSZ, { .id = 0x4 } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_MEM, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_WRITE, { 2, 4, 8 }, ZYDIS_IELEMENT_TYPE_INT, { .mem = { 0, ZYDIS_IMPLMEM_BASE_SSP } }, ZYAN_FALSE, ZYAN_TRUE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 2, 4, 8 }, ZYDIS_IELEMENT_TYPE_INT, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_READWRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .reg = { ZYDIS_IMPLREG_TYPE_GPR_SSZ, { .id = 0x4 } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_MEM, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_WRITE, { 2, 4, 8 }, ZYDIS_IELEMENT_TYPE_INT, { .mem = { 0, ZYDIS_IMPLMEM_BASE_SSP } }, ZYAN_FALSE, ZYAN_TRUE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_IMPLICIT, ZYDIS_OPERAND_ACTION_READ, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .reg = { ZYDIS_IMPLREG_TYPE_STATIC, { .reg = ZYDIS_REGISTER_FS } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_READWRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .reg = { ZYDIS_IMPLREG_TYPE_GPR_SSZ, { .id = 0x4 } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_MEM, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_WRITE, { 2, 4, 8 }, ZYDIS_IELEMENT_TYPE_INT, { .mem = { 0, ZYDIS_IMPLMEM_BASE_SSP } }, ZYAN_FALSE, ZYAN_TRUE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_IMPLICIT, ZYDIS_OPERAND_ACTION_READ, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .reg = { ZYDIS_IMPLREG_TYPE_STATIC, { .reg = ZYDIS_REGISTER_GS } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_READWRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .reg = { ZYDIS_IMPLREG_TYPE_GPR_SSZ, { .id = 0x4 } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_MEM, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_WRITE, { 2, 4, 8 }, ZYDIS_IELEMENT_TYPE_INT, { .mem = { 0, ZYDIS_IMPLMEM_BASE_SSP } }, ZYAN_FALSE, ZYAN_TRUE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_READWRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .reg = { ZYDIS_IMPLREG_TYPE_GPR_SSZ, { .id = 0x4 } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_MEM, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_WRITE, { 2, 2, 2 }, ZYDIS_IELEMENT_TYPE_INT, { .mem = { 0, ZYDIS_IMPLMEM_BASE_SSP } }, ZYAN_FALSE, ZYAN_TRUE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_READ, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INT1, { .reg = { ZYDIS_IMPLREG_TYPE_FLAGS_SSZ, { .id = 0x3F } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_READWRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .reg = { ZYDIS_IMPLREG_TYPE_GPR_SSZ, { .id = 0x4 } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_MEM, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_WRITE, { 4, 4, 4 }, ZYDIS_IELEMENT_TYPE_INT, { .mem = { 0, ZYDIS_IMPLMEM_BASE_SSP } }, ZYAN_FALSE, ZYAN_TRUE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_READ, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INT1, { .reg = { ZYDIS_IMPLREG_TYPE_FLAGS_SSZ, { .id = 0x3F } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_READWRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .reg = { ZYDIS_IMPLREG_TYPE_GPR_SSZ, { .id = 0x4 } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_MEM, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_WRITE, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT, { .mem = { 0, ZYDIS_IMPLMEM_BASE_SSP } }, ZYAN_FALSE, ZYAN_TRUE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_READ, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INT1, { .reg = { ZYDIS_IMPLREG_TYPE_FLAGS_SSZ, { .id = 0x3F } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_GPR8, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READWRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_UIMM8 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_READWRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INT1, { .reg = { ZYDIS_IMPLREG_TYPE_FLAGS_SSZ, { .id = 0x3F } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READWRITE, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_INT8, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_UIMM8 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_READWRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INT1, { .reg = { ZYDIS_IMPLREG_TYPE_FLAGS_SSZ, { .id = 0x3F } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_GPR16_32_64, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READWRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_UIMM8 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_READWRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INT1, { .reg = { ZYDIS_IMPLREG_TYPE_FLAGS_SSZ, { .id = 0x3F } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READWRITE, { 2, 4, 8 }, ZYDIS_IELEMENT_TYPE_INT, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_UIMM8 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_READWRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INT1, { .reg = { ZYDIS_IMPLREG_TYPE_FLAGS_SSZ, { .id = 0x3F } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_GPR8, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READWRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_IMM1, ZYDIS_OPERAND_VISIBILITY_IMPLICIT, ZYDIS_OPERAND_ACTION_READ, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_NONE }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_READWRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INT1, { .reg = { ZYDIS_IMPLREG_TYPE_FLAGS_SSZ, { .id = 0x3F } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READWRITE, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_INT8, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_IMM1, ZYDIS_OPERAND_VISIBILITY_IMPLICIT, ZYDIS_OPERAND_ACTION_READ, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_NONE }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_READWRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INT1, { .reg = { ZYDIS_IMPLREG_TYPE_FLAGS_SSZ, { .id = 0x3F } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_GPR16_32_64, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READWRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_IMM1, ZYDIS_OPERAND_VISIBILITY_IMPLICIT, ZYDIS_OPERAND_ACTION_READ, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_NONE }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_READWRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INT1, { .reg = { ZYDIS_IMPLREG_TYPE_FLAGS_SSZ, { .id = 0x3F } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READWRITE, { 2, 4, 8 }, ZYDIS_IELEMENT_TYPE_INT, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_IMM1, ZYDIS_OPERAND_VISIBILITY_IMPLICIT, ZYDIS_OPERAND_ACTION_READ, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_NONE }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_READWRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INT1, { .reg = { ZYDIS_IMPLREG_TYPE_FLAGS_SSZ, { .id = 0x3F } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_GPR8, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READWRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_IMPLICIT, ZYDIS_OPERAND_ACTION_READ, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_UINT, { .reg = { ZYDIS_IMPLREG_TYPE_STATIC, { .reg = ZYDIS_REGISTER_CL } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_READ_CONDWRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INT1, { .reg = { ZYDIS_IMPLREG_TYPE_FLAGS_SSZ, { .id = 0x3F } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READWRITE, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_INT8, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_IMPLICIT, ZYDIS_OPERAND_ACTION_READ, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_UINT, { .reg = { ZYDIS_IMPLREG_TYPE_STATIC, { .reg = ZYDIS_REGISTER_CL } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_READ_CONDWRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INT1, { .reg = { ZYDIS_IMPLREG_TYPE_FLAGS_SSZ, { .id = 0x3F } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_GPR16_32_64, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READWRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_IMPLICIT, ZYDIS_OPERAND_ACTION_READ, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_UINT, { .reg = { ZYDIS_IMPLREG_TYPE_STATIC, { .reg = ZYDIS_REGISTER_CL } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_READ_CONDWRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INT1, { .reg = { ZYDIS_IMPLREG_TYPE_FLAGS_SSZ, { .id = 0x3F } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READWRITE, { 2, 4, 8 }, ZYDIS_IELEMENT_TYPE_INT, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_IMPLICIT, ZYDIS_OPERAND_ACTION_READ, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_UINT, { .reg = { ZYDIS_IMPLREG_TYPE_STATIC, { .reg = ZYDIS_REGISTER_CL } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_READ_CONDWRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INT1, { .reg = { ZYDIS_IMPLREG_TYPE_FLAGS_SSZ, { .id = 0x3F } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_WRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .reg = { ZYDIS_IMPLREG_TYPE_STATIC, { .reg = ZYDIS_REGISTER_EAX } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_WRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .reg = { ZYDIS_IMPLREG_TYPE_STATIC, { .reg = ZYDIS_REGISTER_EDX } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_READ, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .reg = { ZYDIS_IMPLREG_TYPE_STATIC, { .reg = ZYDIS_REGISTER_ECX } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_UINT64, { .reg = { ZYDIS_IMPLREG_TYPE_STATIC, { .reg = ZYDIS_REGISTER_RSI } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_UINT64, { .reg = { ZYDIS_IMPLREG_TYPE_STATIC, { .reg = ZYDIS_REGISTER_RDI } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_READWRITE, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_UINT64, { .reg = { ZYDIS_IMPLREG_TYPE_STATIC, { .reg = ZYDIS_REGISTER_RCX } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_WRITE, { 4, 4, 4 }, ZYDIS_IELEMENT_TYPE_INT32, { .reg = { ZYDIS_IMPLREG_TYPE_STATIC, { .reg = ZYDIS_REGISTER_EDX } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_WRITE, { 4, 4, 4 }, ZYDIS_IELEMENT_TYPE_INT32, { .reg = { ZYDIS_IMPLREG_TYPE_STATIC, { .reg = ZYDIS_REGISTER_EAX } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_READ, { 4, 4, 4 }, ZYDIS_IELEMENT_TYPE_INT32, { .reg = { ZYDIS_IMPLREG_TYPE_STATIC, { .reg = ZYDIS_REGISTER_ECX } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_WRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .reg = { ZYDIS_IMPLREG_TYPE_STATIC, { .reg = ZYDIS_REGISTER_EAX } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_WRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .reg = { ZYDIS_IMPLREG_TYPE_STATIC, { .reg = ZYDIS_REGISTER_EDX } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_WRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .reg = { ZYDIS_IMPLREG_TYPE_STATIC, { .reg = ZYDIS_REGISTER_ECX } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_IMPLICIT, ZYDIS_OPERAND_ACTION_READWRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .reg = { ZYDIS_IMPLREG_TYPE_STATIC, { .reg = ZYDIS_REGISTER_RAX } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_IMPLICIT, ZYDIS_OPERAND_ACTION_READ, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .reg = { ZYDIS_IMPLREG_TYPE_STATIC, { .reg = ZYDIS_REGISTER_RCX } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_WRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INT1, { .reg = { ZYDIS_IMPLREG_TYPE_FLAGS_SSZ, { .id = 0x3F } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_GPR8, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READWRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_UIMM8 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_WRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INT1, { .reg = { ZYDIS_IMPLREG_TYPE_FLAGS_SSZ, { .id = 0x3F } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READWRITE, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_INT8, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_UIMM8 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_WRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INT1, { .reg = { ZYDIS_IMPLREG_TYPE_FLAGS_SSZ, { .id = 0x3F } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_GPR8, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READWRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_IMM1, ZYDIS_OPERAND_VISIBILITY_IMPLICIT, ZYDIS_OPERAND_ACTION_READ, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_NONE }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_WRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INT1, { .reg = { ZYDIS_IMPLREG_TYPE_FLAGS_SSZ, { .id = 0x3F } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READWRITE, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_INT8, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_IMM1, ZYDIS_OPERAND_VISIBILITY_IMPLICIT, ZYDIS_OPERAND_ACTION_READ, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_NONE }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_WRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INT1, { .reg = { ZYDIS_IMPLREG_TYPE_FLAGS_SSZ, { .id = 0x3F } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_GPR16_32_64, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READWRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_IMM1, ZYDIS_OPERAND_VISIBILITY_IMPLICIT, ZYDIS_OPERAND_ACTION_READ, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_NONE }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_WRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INT1, { .reg = { ZYDIS_IMPLREG_TYPE_FLAGS_SSZ, { .id = 0x3F } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READWRITE, { 2, 4, 8 }, ZYDIS_IELEMENT_TYPE_INT, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_IMM1, ZYDIS_OPERAND_VISIBILITY_IMPLICIT, ZYDIS_OPERAND_ACTION_READ, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_NONE }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_WRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INT1, { .reg = { ZYDIS_IMPLREG_TYPE_FLAGS_SSZ, { .id = 0x3F } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_GPR8, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READWRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_IMPLICIT, ZYDIS_OPERAND_ACTION_READ, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_UINT, { .reg = { ZYDIS_IMPLREG_TYPE_STATIC, { .reg = ZYDIS_REGISTER_CL } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_CONDWRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INT1, { .reg = { ZYDIS_IMPLREG_TYPE_FLAGS_SSZ, { .id = 0x3F } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READWRITE, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_INT8, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_IMPLICIT, ZYDIS_OPERAND_ACTION_READ, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_UINT, { .reg = { ZYDIS_IMPLREG_TYPE_STATIC, { .reg = ZYDIS_REGISTER_CL } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_CONDWRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INT1, { .reg = { ZYDIS_IMPLREG_TYPE_FLAGS_SSZ, { .id = 0x3F } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_GPR16_32_64, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READWRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_IMPLICIT, ZYDIS_OPERAND_ACTION_READ, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_UINT, { .reg = { ZYDIS_IMPLREG_TYPE_STATIC, { .reg = ZYDIS_REGISTER_CL } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_CONDWRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INT1, { .reg = { ZYDIS_IMPLREG_TYPE_FLAGS_SSZ, { .id = 0x3F } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READWRITE, { 2, 4, 8 }, ZYDIS_IELEMENT_TYPE_INT, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_IMPLICIT, ZYDIS_OPERAND_ACTION_READ, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_UINT, { .reg = { ZYDIS_IMPLREG_TYPE_STATIC, { .reg = ZYDIS_REGISTER_CL } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_CONDWRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INT1, { .reg = { ZYDIS_IMPLREG_TYPE_FLAGS_SSZ, { .id = 0x3F } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_FLOAT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_FLOAT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_UIMM8 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_FLOAT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_FLOAT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_UIMM8 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_FLOAT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_FLOAT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_UIMM8 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_FLOAT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_FLOAT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_UIMM8 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READWRITE, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_UIMM8 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READWRITE, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_UIMM8 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READWRITE, { 4, 4, 4 }, ZYDIS_IELEMENT_TYPE_INT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 4, 4, 4 }, ZYDIS_IELEMENT_TYPE_INT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_UIMM8 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READWRITE, { 4, 4, 4 }, ZYDIS_IELEMENT_TYPE_INT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 4, 4, 4 }, ZYDIS_IELEMENT_TYPE_INT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_UIMM8 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_READ, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .reg = { ZYDIS_IMPLREG_TYPE_STATIC, { .reg = ZYDIS_REGISTER_AL } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_MEM, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_READ, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_UINT8, { .mem = { 1, ZYDIS_IMPLMEM_BASE_ADI } }, ZYAN_FALSE, ZYAN_TRUE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_READWRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INT1, { .reg = { ZYDIS_IMPLREG_TYPE_FLAGS_SSZ, { .id = 0x3F } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_READ, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .reg = { ZYDIS_IMPLREG_TYPE_STATIC, { .reg = ZYDIS_REGISTER_EAX } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_MEM, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_READ, { 4, 4, 4 }, ZYDIS_IELEMENT_TYPE_INT32, { .mem = { 1, ZYDIS_IMPLMEM_BASE_ADI } }, ZYAN_FALSE, ZYAN_TRUE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_READWRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INT1, { .reg = { ZYDIS_IMPLREG_TYPE_FLAGS_SSZ, { .id = 0x3F } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_READ, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .reg = { ZYDIS_IMPLREG_TYPE_STATIC, { .reg = ZYDIS_REGISTER_RAX } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_MEM, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT64, { .mem = { 1, ZYDIS_IMPLMEM_BASE_ADI } }, ZYAN_FALSE, ZYAN_TRUE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_READWRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INT1, { .reg = { ZYDIS_IMPLREG_TYPE_FLAGS_SSZ, { .id = 0x3F } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_READ, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .reg = { ZYDIS_IMPLREG_TYPE_STATIC, { .reg = ZYDIS_REGISTER_AX } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_MEM, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_READ, { 2, 2, 2 }, ZYDIS_IELEMENT_TYPE_INT16, { .mem = { 1, ZYDIS_IMPLMEM_BASE_ADI } }, ZYAN_FALSE, ZYAN_TRUE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_READWRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INT1, { .reg = { ZYDIS_IMPLREG_TYPE_FLAGS_SSZ, { .id = 0x3F } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READWRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_INT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_INT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_UINT8, { .reg = { ZYDIS_IMPLREG_TYPE_STATIC, { .reg = ZYDIS_REGISTER_XMM0 } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READWRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_INT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_INT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_UINT8, { .reg = { ZYDIS_IMPLREG_TYPE_STATIC, { .reg = ZYDIS_REGISTER_XMM0 } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_GPR8, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READWRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_UINT, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_UIMM8 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_WRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INT1, { .reg = { ZYDIS_IMPLREG_TYPE_FLAGS_SSZ, { .id = 0x3F } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READWRITE, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_UIMM8 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_WRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INT1, { .reg = { ZYDIS_IMPLREG_TYPE_FLAGS_SSZ, { .id = 0x3F } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_GPR16_32_64, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READWRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_UINT, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_UIMM8 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_WRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INT1, { .reg = { ZYDIS_IMPLREG_TYPE_FLAGS_SSZ, { .id = 0x3F } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READWRITE, { 2, 4, 8 }, ZYDIS_IELEMENT_TYPE_UINT, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_UIMM8 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_WRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INT1, { .reg = { ZYDIS_IMPLREG_TYPE_FLAGS_SSZ, { .id = 0x3F } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_GPR8, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READWRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_UINT, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_IMM1, ZYDIS_OPERAND_VISIBILITY_IMPLICIT, ZYDIS_OPERAND_ACTION_READ, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_NONE }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_WRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INT1, { .reg = { ZYDIS_IMPLREG_TYPE_FLAGS_SSZ, { .id = 0x3F } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READWRITE, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_IMM1, ZYDIS_OPERAND_VISIBILITY_IMPLICIT, ZYDIS_OPERAND_ACTION_READ, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_NONE }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_WRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INT1, { .reg = { ZYDIS_IMPLREG_TYPE_FLAGS_SSZ, { .id = 0x3F } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_GPR16_32_64, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READWRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_UINT, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_IMM1, ZYDIS_OPERAND_VISIBILITY_IMPLICIT, ZYDIS_OPERAND_ACTION_READ, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_NONE }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_WRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INT1, { .reg = { ZYDIS_IMPLREG_TYPE_FLAGS_SSZ, { .id = 0x3F } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READWRITE, { 2, 4, 8 }, ZYDIS_IELEMENT_TYPE_UINT, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_IMM1, ZYDIS_OPERAND_VISIBILITY_IMPLICIT, ZYDIS_OPERAND_ACTION_READ, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_NONE }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_WRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INT1, { .reg = { ZYDIS_IMPLREG_TYPE_FLAGS_SSZ, { .id = 0x3F } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_GPR8, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READWRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_UINT, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_IMPLICIT, ZYDIS_OPERAND_ACTION_READ, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_UINT, { .reg = { ZYDIS_IMPLREG_TYPE_STATIC, { .reg = ZYDIS_REGISTER_CL } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_CONDWRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INT1, { .reg = { ZYDIS_IMPLREG_TYPE_FLAGS_SSZ, { .id = 0x3F } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READWRITE, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_IMPLICIT, ZYDIS_OPERAND_ACTION_READ, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_UINT, { .reg = { ZYDIS_IMPLREG_TYPE_STATIC, { .reg = ZYDIS_REGISTER_CL } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_CONDWRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INT1, { .reg = { ZYDIS_IMPLREG_TYPE_FLAGS_SSZ, { .id = 0x3F } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_GPR16_32_64, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READWRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_UINT, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_IMPLICIT, ZYDIS_OPERAND_ACTION_READ, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_UINT, { .reg = { ZYDIS_IMPLREG_TYPE_STATIC, { .reg = ZYDIS_REGISTER_CL } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_CONDWRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INT1, { .reg = { ZYDIS_IMPLREG_TYPE_FLAGS_SSZ, { .id = 0x3F } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READWRITE, { 2, 4, 8 }, ZYDIS_IELEMENT_TYPE_UINT, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_IMPLICIT, ZYDIS_OPERAND_ACTION_READ, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_UINT, { .reg = { ZYDIS_IMPLREG_TYPE_STATIC, { .reg = ZYDIS_REGISTER_CL } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_CONDWRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INT1, { .reg = { ZYDIS_IMPLREG_TYPE_FLAGS_SSZ, { .id = 0x3F } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_WRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .reg = { ZYDIS_IMPLREG_TYPE_STATIC, { .reg = ZYDIS_REGISTER_RIP } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_WRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .reg = { ZYDIS_IMPLREG_TYPE_STATIC, { .reg = ZYDIS_REGISTER_RSP } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_WRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INT1, { .reg = { ZYDIS_IMPLREG_TYPE_FLAGS_SSZ, { .id = 0x3F } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_WRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .reg = { ZYDIS_IMPLREG_TYPE_STATIC, { .reg = ZYDIS_REGISTER_EIP } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_WRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .reg = { ZYDIS_IMPLREG_TYPE_STATIC, { .reg = ZYDIS_REGISTER_ESP } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_WRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INT1, { .reg = { ZYDIS_IMPLREG_TYPE_FLAGS_SSZ, { .id = 0x3F } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_GPR64, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_GPR64, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_WRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INT1, { .reg = { ZYDIS_IMPLREG_TYPE_FLAGS_SSZ, { .id = 0x3F } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_GPR64, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_WRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INT1, { .reg = { ZYDIS_IMPLREG_TYPE_FLAGS_SSZ, { .id = 0x3F } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_GPR32, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_GPR32, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_WRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INT1, { .reg = { ZYDIS_IMPLREG_TYPE_FLAGS_SSZ, { .id = 0x3F } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 4, 4, 4 }, ZYDIS_IELEMENT_TYPE_INT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_GPR32, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_WRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INT1, { .reg = { ZYDIS_IMPLREG_TYPE_FLAGS_SSZ, { .id = 0x3F } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_GPR64, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_GPR64, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_WRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INT1, { .reg = { ZYDIS_IMPLREG_TYPE_FLAGS_SSZ, { .id = 0x3F } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_GPR64, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_WRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INT1, { .reg = { ZYDIS_IMPLREG_TYPE_FLAGS_SSZ, { .id = 0x3F } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_GPR32, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_GPR32, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_WRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INT1, { .reg = { ZYDIS_IMPLREG_TYPE_FLAGS_SSZ, { .id = 0x3F } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_GPR32, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 4, 4, 4 }, ZYDIS_IELEMENT_TYPE_INT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_WRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INT1, { .reg = { ZYDIS_IMPLREG_TYPE_FLAGS_SSZ, { .id = 0x3F } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_READ, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .reg = { ZYDIS_IMPLREG_TYPE_STATIC, { .reg = ZYDIS_REGISTER_EAX } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_READ, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .reg = { ZYDIS_IMPLREG_TYPE_STATIC, { .reg = ZYDIS_REGISTER_EDX } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_READ, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .reg = { ZYDIS_IMPLREG_TYPE_STATIC, { .reg = ZYDIS_REGISTER_ECX } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_READ, { 4, 4, 4 }, ZYDIS_IELEMENT_TYPE_UINT32, { .reg = { ZYDIS_IMPLREG_TYPE_STATIC, { .reg = ZYDIS_REGISTER_EAX } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_READ, { 4, 4, 4 }, ZYDIS_IELEMENT_TYPE_UINT32, { .reg = { ZYDIS_IMPLREG_TYPE_STATIC, { .reg = ZYDIS_REGISTER_EDX } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_READ, { 4, 4, 4 }, ZYDIS_IELEMENT_TYPE_UINT32, { .reg = { ZYDIS_IMPLREG_TYPE_STATIC, { .reg = ZYDIS_REGISTER_ECX } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_GPR8, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READWRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_GPR8, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READWRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_WRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INT1, { .reg = { ZYDIS_IMPLREG_TYPE_FLAGS_SSZ, { .id = 0x3F } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READWRITE, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_INT8, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_GPR8, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READWRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_WRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INT1, { .reg = { ZYDIS_IMPLREG_TYPE_FLAGS_SSZ, { .id = 0x3F } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_GPR16_32_64, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READWRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_GPR16_32_64, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READWRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_WRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INT1, { .reg = { ZYDIS_IMPLREG_TYPE_FLAGS_SSZ, { .id = 0x3F } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READWRITE, { 2, 4, 8 }, ZYDIS_IELEMENT_TYPE_INT, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_GPR16_32_64, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READWRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_WRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INT1, { .reg = { ZYDIS_IMPLREG_TYPE_FLAGS_SSZ, { .id = 0x3F } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_REL, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 2, 4, 4 }, ZYDIS_IELEMENT_TYPE_INT, { .encoding = ZYDIS_OPERAND_ENCODING_JIMM16_32_32 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_READWRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .reg = { ZYDIS_IMPLREG_TYPE_IP_SSZ, { .id = 0x3F } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_CONDWRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .reg = { ZYDIS_IMPLREG_TYPE_STATIC, { .reg = ZYDIS_REGISTER_EAX } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_GPR32_32_64, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INT, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_GPR32_32_64, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INT, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_WRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INT1, { .reg = { ZYDIS_IMPLREG_TYPE_FLAGS_SSZ, { .id = 0x3F } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_GPR32_32_64, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INT, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 4, 4, 8 }, ZYDIS_IELEMENT_TYPE_INT, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_WRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INT1, { .reg = { ZYDIS_IMPLREG_TYPE_FLAGS_SSZ, { .id = 0x3F } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_UIMM8 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_UIMM8 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_UINT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_UINT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_UINT32, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_UINT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_UINT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_UINT32, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_UINT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_UINT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_UIMM8 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_UINT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_UINT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_UIMM8 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_UINT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_UINT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_UINT64, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_UINT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_UINT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_UINT64, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_UINT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_UINT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_UINT16, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_UINT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_UINT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_UINT16, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_INT8, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_INT8, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_INT8, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_INT8, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_INT8, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_INT8, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_INT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_INT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_INT32, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_INT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_INT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_INT32, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_INT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_INT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_INT64, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_INT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_INT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_INT64, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_INT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_INT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_INT16, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_INT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_INT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_INT16, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_GPR64, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 2, 2, 2 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 2, 2, 2 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 2, 2, 2 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_GPR64, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_UIMM8 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 2, 2, 2 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 2, 2, 2 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_WRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INT1, { .reg = { ZYDIS_IMPLREG_TYPE_FLAGS_SSZ, { .id = 0x3F } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_WRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INT1, { .reg = { ZYDIS_IMPLREG_TYPE_FLAGS_SSZ, { .id = 0x3F } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_UIMM8 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_GPR32, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 4, 4, 4 }, ZYDIS_IELEMENT_TYPE_INT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_GPR32, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 4, 4, 4 }, ZYDIS_IELEMENT_TYPE_INT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_WRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INT1, { .reg = { ZYDIS_IMPLREG_TYPE_FLAGS_SSZ, { .id = 0x3F } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_GPR64, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_GPR64, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_WRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INT1, { .reg = { ZYDIS_IMPLREG_TYPE_FLAGS_SSZ, { .id = 0x3F } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_GPR32, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 4, 4, 4 }, ZYDIS_IELEMENT_TYPE_INT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_GPR32, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 4, 4, 4 }, ZYDIS_IELEMENT_TYPE_INT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_UIMM8 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_GPR64, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_GPR64, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_UIMM8 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_GPR32, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 4, 4, 4 }, ZYDIS_IELEMENT_TYPE_INT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 4, 4, 4 }, ZYDIS_IELEMENT_TYPE_INT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_UIMM8 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_GPR64, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_UIMM8 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_TMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READWRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_FLOAT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_TMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_UINT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_TMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_UINT32, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_TMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READWRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_TMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_UINT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_TMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_UINT32, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_TMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READWRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_UINT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_TMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_UINT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_TMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_UINT32, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_TMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READWRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_FLOAT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_TMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_FLOAT16X2, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_TMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_FLOAT16X2, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_GPR32, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READWRITE, { 4, 4, 4 }, ZYDIS_IELEMENT_TYPE_INT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_GPR32, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 4, 4, 4 }, ZYDIS_IELEMENT_TYPE_INT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_WRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INT1, { .reg = { ZYDIS_IMPLREG_TYPE_FLAGS_SSZ, { .id = 0x3F } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_GPR64, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READWRITE, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_GPR64, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_WRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INT1, { .reg = { ZYDIS_IMPLREG_TYPE_FLAGS_SSZ, { .id = 0x3F } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_UINT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_UINT64, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_UINT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_UINT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_UINT64, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_UINT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_INT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_INT32, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_INT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_INT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_INT32, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_INT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_FLOAT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_FLOAT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_UIMM8 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_FLOAT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_FLOAT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_UIMM8 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_FLOAT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_FLOAT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_UIMM8 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_FLOAT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_FLOAT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_UIMM8 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_FLOAT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_FLOAT32, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_FLOAT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_FLOAT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_FLOAT32, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_FLOAT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_FLOAT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_FLOAT64, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_GPR32, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 4, 4, 4 }, ZYDIS_IELEMENT_TYPE_INT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_FLOAT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_FLOAT64, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_GPR64, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_FLOAT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_FLOAT64, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 4, 4, 4 }, ZYDIS_IELEMENT_TYPE_INT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_FLOAT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_FLOAT64, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_FLOAT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_FLOAT32, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_GPR32, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 4, 4, 4 }, ZYDIS_IELEMENT_TYPE_INT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_FLOAT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_FLOAT32, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_GPR64, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_FLOAT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_FLOAT32, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 4, 4, 4 }, ZYDIS_IELEMENT_TYPE_INT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_FLOAT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_FLOAT32, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_FLOAT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_FLOAT64, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 4, 4, 4 }, ZYDIS_IELEMENT_TYPE_FLOAT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_FLOAT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_FLOAT64, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 4, 4, 4 }, ZYDIS_IELEMENT_TYPE_FLOAT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_FLOAT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_FLOAT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_UIMM8 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_FLOAT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_FLOAT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_UIMM8 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_UINT128, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_UINT128, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_UIMM8 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_UINT128, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_UINT128, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_UIMM8 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_GPR32, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_FLOAT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_UIMM8 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 4, 4, 4 }, ZYDIS_IELEMENT_TYPE_FLOAT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_FLOAT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_UIMM8 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READWRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_FLOAT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_FLOAT64, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_FLOAT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READWRITE, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_FLOAT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_FLOAT64, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_FLOAT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READWRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_FLOAT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_FLOAT64, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_FLOAT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READWRITE, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_FLOAT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_FLOAT64, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_FLOAT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READWRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_FLOAT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_FLOAT32, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_FLOAT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READWRITE, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_FLOAT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_FLOAT32, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_FLOAT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READWRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_FLOAT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_FLOAT32, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_FLOAT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READWRITE, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_FLOAT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_FLOAT32, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_FLOAT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READWRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_FLOAT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_FLOAT64, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_FLOAT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READWRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_FLOAT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_FLOAT64, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_FLOAT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READWRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_FLOAT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 4, 4, 4 }, ZYDIS_IELEMENT_TYPE_FLOAT32, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 4, 4, 4 }, ZYDIS_IELEMENT_TYPE_FLOAT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READWRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_FLOAT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 4, 4, 4 }, ZYDIS_IELEMENT_TYPE_FLOAT32, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 4, 4, 4 }, ZYDIS_IELEMENT_TYPE_FLOAT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_CONDREAD_WRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_FLOAT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM_VSIBX, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_FLOAT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READWRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_INT64, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_CONDREAD_WRITE, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_FLOAT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM_VSIBX, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_FLOAT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READWRITE, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_INT64, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_CONDREAD_WRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_FLOAT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM_VSIBX, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 4, 4, 4 }, ZYDIS_IELEMENT_TYPE_FLOAT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READWRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_INT32, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_CONDREAD_WRITE, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_FLOAT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM_VSIBY, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 4, 4, 4 }, ZYDIS_IELEMENT_TYPE_FLOAT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READWRITE, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_INT32, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_CONDREAD_WRITE, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_FLOAT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM_VSIBY, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_FLOAT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READWRITE, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_INT64, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_CONDREAD_WRITE, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_FLOAT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM_VSIBX, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 4, 4, 4 }, ZYDIS_IELEMENT_TYPE_FLOAT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READWRITE, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT32, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_CONDREAD_WRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_FLOAT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM_VSIBY, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 4, 4, 4 }, ZYDIS_IELEMENT_TYPE_FLOAT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READWRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_INT32, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_FLOAT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_UINT64, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_FLOAT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_FLOAT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_UINT64, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_FLOAT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_FLOAT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_UINT64, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_FLOAT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_FLOAT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_UINT64, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_FLOAT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_FLOAT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_INT32, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_FLOAT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_FLOAT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_INT32, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_FLOAT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_FLOAT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_INT32, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_FLOAT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_FLOAT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_INT32, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_FLOAT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_FLOAT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_FLOAT64, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_FLOAT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_FLOAT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_FLOAT32, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_FLOAT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_FLOAT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_FLOAT32, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_FLOAT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_FLOAT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_FLOAT32, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_FLOAT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_FLOAT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_FLOAT64, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_FLOAT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_FLOAT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_FLOAT32, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 4, 4, 4 }, ZYDIS_IELEMENT_TYPE_FLOAT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_INT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_INT32, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_INT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_INT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_INT32, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_INT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_INT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_INT32, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_INT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_INT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_INT32, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_INT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_INT8, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_INT16, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_INT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_INT8, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_INT16, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_INT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_INT8, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_INT16, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_INT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_INT8, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_INT16, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_INT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_UINT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_INT32, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_INT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_UINT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_INT32, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_INT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_UINT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_INT32, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_INT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_UINT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_INT32, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_INT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_INT16, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_INT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_INT16, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_INT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_INT16, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_INT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_INT16, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_INT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_INT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_INT64, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_INT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_INT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_INT64, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_INT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_INT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_INT16, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_INT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_INT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_INT16, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_INT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_UINT128, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_UINT128, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_UINT128, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_UINT256, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_UINT256, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_UINT256, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_UINT128, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_UINT128, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_UINT128, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_UINT256, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_UINT256, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_UINT256, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_INT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_INT64, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_INT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_INT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_INT64, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_INT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READWRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_INT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_INT8X4, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_INT8X4, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READWRITE, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_INT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_INT8X4, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_INT8X4, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READWRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_INT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_INT8X4, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_INT8X4, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READWRITE, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_INT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_INT8X4, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_INT8X4, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READWRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_INT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_INT8X4, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_UINT8X4, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READWRITE, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_INT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_INT8X4, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_UINT8X4, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READWRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_INT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_INT8X4, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_UINT8X4, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READWRITE, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_INT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_INT8X4, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_UINT8X4, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READWRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_INT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_INT8, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READWRITE, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_INT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_INT8, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READWRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_INT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_INT8, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READWRITE, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_INT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_INT8, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READWRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_INT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_UINT8X4, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_UINT8X4, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READWRITE, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_INT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_UINT8X4, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_UINT8X4, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READWRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_INT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_UINT8X4, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_UINT8X4, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READWRITE, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_INT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_UINT8X4, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_UINT8X4, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READWRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_INT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_INT16, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_INT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READWRITE, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_INT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_INT16, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_INT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READWRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_INT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_INT16, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_INT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READWRITE, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_INT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_INT16, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_INT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READWRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_INT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_INT16X2, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_UINT16X2, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READWRITE, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_INT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_INT16X2, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_UINT16X2, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READWRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_INT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_INT16X2, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_UINT16X2, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READWRITE, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_INT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_INT16X2, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_UINT16X2, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READWRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_INT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_UINT16X2, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_INT16X2, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READWRITE, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_INT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_UINT16X2, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_INT16X2, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READWRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_INT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_UINT16X2, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_INT16X2, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READWRITE, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_INT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_UINT16X2, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_INT16X2, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READWRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_UINT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_UINT16X2, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_UINT16X2, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READWRITE, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_UINT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_UINT16X2, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_UINT16X2, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READWRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_UINT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_UINT16X2, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_UINT16X2, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READWRITE, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_UINT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_UINT16X2, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_UINT16X2, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_FLOAT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_FLOAT64, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_UINT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_FLOAT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_FLOAT64, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_UINT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_FLOAT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_FLOAT64, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_UINT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_FLOAT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_FLOAT64, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_UINT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_FLOAT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_FLOAT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_UIMM8 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_FLOAT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_FLOAT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_UIMM8 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_FLOAT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_FLOAT32, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_UINT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_FLOAT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_FLOAT32, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_UINT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_FLOAT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_FLOAT32, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_UINT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_FLOAT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_FLOAT32, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_UINT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_FLOAT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_FLOAT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_UIMM8 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_FLOAT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_FLOAT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_UIMM8 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_UINT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_UINT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_UIMM8 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_UINT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_UINT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_UIMM8 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_GPR32, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 4, 4, 4 }, ZYDIS_IELEMENT_TYPE_UINT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_UIMM8 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_UIMM8 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 4, 4, 4 }, ZYDIS_IELEMENT_TYPE_UINT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_UINT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_UIMM8 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_GPR64, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_UINT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_UINT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_UIMM8 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_UINT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_UINT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_UIMM8 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_GPR32, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 4, 4, 4 }, ZYDIS_IELEMENT_TYPE_UINT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_UINT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_UIMM8 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_GPR32, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 4, 4, 4 }, ZYDIS_IELEMENT_TYPE_UINT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_UINT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_UIMM8 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 2, 2, 2 }, ZYDIS_IELEMENT_TYPE_UINT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_UINT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_UIMM8 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_CONDREAD_WRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_INT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM_VSIBX, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 4, 4, 4 }, ZYDIS_IELEMENT_TYPE_INT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READWRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_INT32, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_CONDREAD_WRITE, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_INT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM_VSIBY, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 4, 4, 4 }, ZYDIS_IELEMENT_TYPE_INT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READWRITE, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_INT32, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_CONDREAD_WRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_INT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM_VSIBX, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READWRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_INT64, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_CONDREAD_WRITE, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_INT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM_VSIBX, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READWRITE, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_INT64, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_CONDREAD_WRITE, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM_VSIBX, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 4, 4, 4 }, ZYDIS_IELEMENT_TYPE_INT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READWRITE, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT32, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_CONDREAD_WRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_INT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM_VSIBY, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 4, 4, 4 }, ZYDIS_IELEMENT_TYPE_INT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READWRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_INT32, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_CONDREAD_WRITE, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_INT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM_VSIBY, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READWRITE, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_INT64, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READWRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_UINT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_UINT64, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_UINT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READWRITE, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_UINT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_UINT64, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_UINT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READWRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_UINT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_UINT64, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_UINT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READWRITE, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_UINT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_UINT64, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_UINT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_INT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_INT8, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_INT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_INT8, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_INT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_INT8, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_INT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_INT8, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_INT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_INT16, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_INT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_INT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_INT16, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_INT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_UINT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_UINT32, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_UINT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_UINT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_UINT32, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_UINT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_UINT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_UINT64, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_UINT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_UINT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_UINT64, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_UINT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_INT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_INT32, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_INT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_INT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_INT32, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_INT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_UINT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_UINT32, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_UINT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_UINT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_UINT32, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_UINT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_UINT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_UINT32, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_UINT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_UINT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_UINT32, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_UINT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_UINT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_UINT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_UIMM8 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_UINT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_UINT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_UIMM8 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_UINT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_UINT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_UIMM8 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_UINT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_UINT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_UIMM8 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_UINT32, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_UINT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_UIMM8 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_UINT32, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_UINT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_UIMM8 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_UINT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_UINT32, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_UINT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_UINT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_UINT32, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_UINT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_UINT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_UINT32, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_UINT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_UINT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_UINT32, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_UINT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_UINT128, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_UINT128, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_UIMM8 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_UINT128, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_UINT128, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_UIMM8 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_UINT64, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_UINT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_UIMM8 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_UINT64, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_UINT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_UIMM8 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_UINT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_UINT64, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_UINT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_UINT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_UINT64, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_UINT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_UINT16, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_UINT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_UIMM8 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_UINT16, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_UINT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_UIMM8 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_UINT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_UINT16, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_UINT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_UINT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_UINT16, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_UINT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_UINT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_UINT16, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_UINT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_UINT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_UINT16, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_UINT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_INT32, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_INT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_UIMM8 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_INT32, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_INT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_UIMM8 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_INT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_INT32, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_UINT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_INT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_INT32, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_UINT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_INT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_INT32, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_UINT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_INT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_INT32, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_UINT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_INT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_INT32, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_UINT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_INT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_INT32, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_UINT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_INT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_INT32, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_UINT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_INT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_INT32, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_UINT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_INT16, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_INT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_UIMM8 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_INT16, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_INT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_UIMM8 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_INT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_INT16, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_UINT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_INT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_INT16, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_UINT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_INT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_INT16, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_UINT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_INT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_INT16, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_UINT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_INT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_INT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_WRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INT1, { .reg = { ZYDIS_IMPLREG_TYPE_FLAGS_SSZ, { .id = 0x3F } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_INT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_INT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_WRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INT1, { .reg = { ZYDIS_IMPLREG_TYPE_FLAGS_SSZ, { .id = 0x3F } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READWRITE, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_UINT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_UINT64, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_UINT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_FLOAT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_FLOAT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_WRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INT1, { .reg = { ZYDIS_IMPLREG_TYPE_FLAGS_SSZ, { .id = 0x3F } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_FLOAT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_FLOAT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_WRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INT1, { .reg = { ZYDIS_IMPLREG_TYPE_FLAGS_SSZ, { .id = 0x3F } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_FLOAT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_FLOAT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_WRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INT1, { .reg = { ZYDIS_IMPLREG_TYPE_FLAGS_SSZ, { .id = 0x3F } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_FLOAT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_FLOAT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_WRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INT1, { .reg = { ZYDIS_IMPLREG_TYPE_FLAGS_SSZ, { .id = 0x3F } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_FLOAT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_FLOAT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_WRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INT1, { .reg = { ZYDIS_IMPLREG_TYPE_FLAGS_SSZ, { .id = 0x3F } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_FLOAT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_FLOAT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_WRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INT1, { .reg = { ZYDIS_IMPLREG_TYPE_FLAGS_SSZ, { .id = 0x3F } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_FLOAT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_FLOAT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_WRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INT1, { .reg = { ZYDIS_IMPLREG_TYPE_FLAGS_SSZ, { .id = 0x3F } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_FLOAT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_FLOAT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_WRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INT1, { .reg = { ZYDIS_IMPLREG_TYPE_FLAGS_SSZ, { .id = 0x3F } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_FLOAT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_FLOAT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_WRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INT1, { .reg = { ZYDIS_IMPLREG_TYPE_FLAGS_SSZ, { .id = 0x3F } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_FLOAT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_FLOAT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_WRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INT1, { .reg = { ZYDIS_IMPLREG_TYPE_FLAGS_SSZ, { .id = 0x3F } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_FLOAT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 4, 4, 4 }, ZYDIS_IELEMENT_TYPE_FLOAT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_WRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INT1, { .reg = { ZYDIS_IMPLREG_TYPE_FLAGS_SSZ, { .id = 0x3F } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_FLOAT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 4, 4, 4 }, ZYDIS_IELEMENT_TYPE_FLOAT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_WRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INT1, { .reg = { ZYDIS_IMPLREG_TYPE_FLAGS_SSZ, { .id = 0x3F } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_ZMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_UINT128, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_ZMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_UINT128, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_ZMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_UINT128, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_ZMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_UINT128, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_ZMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_UINT128, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_UINT128, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_FLOAT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_FLOAT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_ZMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_FLOAT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_FLOAT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_FLOAT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_FLOAT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_ZMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_FLOAT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_FLOAT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_FLOAT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_FLOAT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_ZMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_FLOAT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_FLOAT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_ZMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_FLOAT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_FLOAT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_FLOAT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_FLOAT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_ZMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_FLOAT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_FLOAT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_ZMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_FLOAT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_FLOAT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_UINT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_UINT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_ZMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_UINT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_UINT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_UINT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_UINT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_UINT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_UINT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_ZMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_UINT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_UINT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_INT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_INT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_ZMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_INT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_INT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_ZMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_UINT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_UINT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_UINT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_UINT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_ZMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_UINT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_UINT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_ZMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_INT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_INT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_FLOAT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_FLOAT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_ZMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_FLOAT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_FLOAT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_FLOAT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_FLOAT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_ZMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_FLOAT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_FLOAT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_FLOAT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 4, 4, 4 }, ZYDIS_IELEMENT_TYPE_FLOAT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_FLOAT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 4, 4, 4 }, ZYDIS_IELEMENT_TYPE_FLOAT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_ZMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_FLOAT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 4, 4, 4 }, ZYDIS_IELEMENT_TYPE_FLOAT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_FLOAT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_FLOAT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_WRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INT1, { .reg = { ZYDIS_IMPLREG_TYPE_FLAGS_SSZ, { .id = 0x3F } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_FLOAT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 2, 2, 2 }, ZYDIS_IELEMENT_TYPE_FLOAT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_WRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INT1, { .reg = { ZYDIS_IMPLREG_TYPE_FLAGS_SSZ, { .id = 0x3F } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_FLOAT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_FLOAT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_FLOAT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_FLOAT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_ZMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_FLOAT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_ZMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_FLOAT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_FLOAT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_FLOAT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_FLOAT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_FLOAT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_FLOAT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_ZMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_FLOAT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_FLOAT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_FLOAT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_FLOAT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_FLOAT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_ZMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_FLOAT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_ZMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_FLOAT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_FLOAT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_FLOAT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_FLOAT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_FLOAT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_FLOAT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_ZMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_FLOAT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_ZMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_FLOAT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_INT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_FLOAT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_INT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_FLOAT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_INT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_FLOAT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_FLOAT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_ZMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_FLOAT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_FLOAT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_ZMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_INT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_FLOAT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_INT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_FLOAT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_INT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_FLOAT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_FLOAT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_ZMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_FLOAT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_ZMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_INT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_FLOAT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_INT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_FLOAT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_INT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_FLOAT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_FLOAT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_ZMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_FLOAT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_UINT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_FLOAT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_UINT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_FLOAT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_UINT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_ZMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_FLOAT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_UINT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_FLOAT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_UINT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_FLOAT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_INT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_ZMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_FLOAT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_INT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_FLOAT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_INT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_FLOAT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_INT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_FLOAT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_INT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_FLOAT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_FLOAT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_ZMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_FLOAT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_FLOAT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_FLOAT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_FLOAT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_FLOAT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_FLOAT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_FLOAT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_FLOAT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_ZMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_FLOAT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_FLOAT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_FLOAT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_FLOAT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_FLOAT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_FLOAT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_FLOAT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_FLOAT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_FLOAT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_ZMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_INT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_ZMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_FLOAT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_INT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_FLOAT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_INT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_FLOAT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_INT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_FLOAT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_INT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_FLOAT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_ZMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_INT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_FLOAT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_UINT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_ZMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_FLOAT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_UINT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_FLOAT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_UINT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_FLOAT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_UINT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_FLOAT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_UINT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_FLOAT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_ZMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_UINT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_ZMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_FLOAT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_UINT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_FLOAT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_UINT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_FLOAT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_UINT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_FLOAT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_UINT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_FLOAT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_ZMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_UINT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_FLOAT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_ZMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_INT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_FLOAT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_INT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_FLOAT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_INT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_FLOAT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_INT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_FLOAT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_INT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_FLOAT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_ZMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_INT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_FLOAT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_ZMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_FLOAT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_FLOAT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_FLOAT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_FLOAT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_FLOAT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_FLOAT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_FLOAT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_FLOAT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_FLOAT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_FLOAT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_ZMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_FLOAT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_FLOAT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_ZMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_FLOAT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_FLOAT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_FLOAT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_FLOAT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_FLOAT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_FLOAT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_FLOAT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_FLOAT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_FLOAT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_FLOAT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_ZMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_FLOAT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_FLOAT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_FLOAT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_FLOAT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_FLOAT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_FLOAT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_ZMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_FLOAT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_FLOAT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_ZMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_INT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_FLOAT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_INT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_FLOAT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_INT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_FLOAT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_INT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_FLOAT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_INT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_FLOAT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_ZMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_INT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_FLOAT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_ZMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_UINT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_FLOAT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_UINT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_FLOAT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_UINT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_FLOAT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_UINT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_FLOAT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_UINT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_FLOAT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_ZMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_UINT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_FLOAT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_ZMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_UINT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_FLOAT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_UINT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_FLOAT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_UINT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_FLOAT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_UINT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_FLOAT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_UINT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_FLOAT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_ZMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_UINT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_FLOAT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_ZMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_UINT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_ZMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_FLOAT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_UINT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_FLOAT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_UINT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_FLOAT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_UINT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_FLOAT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_UINT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_FLOAT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_ZMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_UINT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_FLOAT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_ZMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_INT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_ZMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_FLOAT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_INT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_FLOAT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_INT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_FLOAT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_INT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_FLOAT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_INT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_FLOAT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_ZMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_INT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_FLOAT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_ZMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_INT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_ZMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_FLOAT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_INT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_FLOAT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_INT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_FLOAT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_INT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_FLOAT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_INT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_FLOAT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_ZMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_INT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_FLOAT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_ZMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_FLOAT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_FLOAT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_FLOAT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_FLOAT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_FLOAT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_FLOAT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_FLOAT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_FLOAT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_FLOAT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_FLOAT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_ZMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_FLOAT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_FLOAT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_FLOAT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_ZMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_FLOAT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_FLOAT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_FLOAT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_FLOAT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_FLOAT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_FLOAT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_FLOAT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_FLOAT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_FLOAT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_ZMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_INT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_FLOAT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_INT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_FLOAT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_INT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_FLOAT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_INT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_FLOAT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_INT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_FLOAT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_ZMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_INT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_FLOAT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_ZMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_UINT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_ZMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_FLOAT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_UINT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_FLOAT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_UINT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_FLOAT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_UINT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_FLOAT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_UINT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_FLOAT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_ZMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_UINT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_FLOAT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_ZMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_UINT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_FLOAT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_UINT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_FLOAT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_UINT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_FLOAT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_UINT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_FLOAT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_UINT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_FLOAT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_ZMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_UINT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_FLOAT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_FLOAT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_ZMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_UINT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_FLOAT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_UINT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_FLOAT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_UINT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_FLOAT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_UINT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_FLOAT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_ZMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_UINT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_FLOAT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_UINT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_FLOAT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_UINT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_FLOAT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_UINT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_FLOAT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_UINT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_FLOAT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_FLOAT16, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_GPR32, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 4, 4, 4 }, ZYDIS_IELEMENT_TYPE_INT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_FLOAT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_FLOAT16, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_GPR64, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_FLOAT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_FLOAT16, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 4, 4, 4 }, ZYDIS_IELEMENT_TYPE_INT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_FLOAT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_FLOAT16, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_ZMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_FLOAT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_UINT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_FLOAT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_UINT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_FLOAT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_UINT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_FLOAT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_UINT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_FLOAT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_UINT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_ZMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_FLOAT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_UINT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_FLOAT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_ZMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_UINT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_FLOAT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_UINT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_FLOAT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_UINT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_FLOAT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_UINT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_FLOAT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_UINT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_ZMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_FLOAT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_ZMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_UINT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_FLOAT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_UINT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_FLOAT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_UINT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_FLOAT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_UINT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_FLOAT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_UINT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_ZMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_FLOAT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_UINT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_ZMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_FLOAT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_ZMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_UINT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_FLOAT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_UINT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_FLOAT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_UINT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_FLOAT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_UINT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_FLOAT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_UINT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_ZMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_FLOAT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_UINT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_FLOAT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_FLOAT64, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_GPR32, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 4, 4, 4 }, ZYDIS_IELEMENT_TYPE_UINT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_FLOAT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_FLOAT64, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 4, 4, 4 }, ZYDIS_IELEMENT_TYPE_UINT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_FLOAT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_FLOAT64, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_GPR64, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_UINT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_FLOAT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_FLOAT64, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_UINT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_FLOAT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_FLOAT16, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_GPR32, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 4, 4, 4 }, ZYDIS_IELEMENT_TYPE_UINT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_FLOAT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_FLOAT16, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_GPR64, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_UINT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_FLOAT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_FLOAT16, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 4, 4, 4 }, ZYDIS_IELEMENT_TYPE_UINT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_FLOAT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_FLOAT16, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_UINT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_FLOAT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_FLOAT32, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_GPR32, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 4, 4, 4 }, ZYDIS_IELEMENT_TYPE_UINT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_FLOAT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_FLOAT32, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 4, 4, 4 }, ZYDIS_IELEMENT_TYPE_UINT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_FLOAT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_FLOAT32, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_GPR64, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_UINT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_FLOAT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_FLOAT32, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_UINT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_ZMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_FLOAT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_ZMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_UINT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_FLOAT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_UINT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_FLOAT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_UINT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_FLOAT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_UINT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_FLOAT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_UINT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_ZMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_FLOAT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_UINT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_ZMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_FLOAT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_ZMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_INT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_FLOAT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_INT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_FLOAT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_INT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_FLOAT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_FLOAT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_ZMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_FLOAT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_FLOAT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_FLOAT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_FLOAT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_FLOAT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_ZMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_FLOAT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_FLOAT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_FLOAT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_FLOAT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_FLOAT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_FLOAT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_ZMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_FLOAT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_FLOAT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_GPR32, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 4, 4, 4 }, ZYDIS_IELEMENT_TYPE_FLOAT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_FLOAT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_UIMM8 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_FLOAT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READWRITE, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM_VSIBX, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_FLOAT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_FLOAT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READWRITE, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM_VSIBX, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_FLOAT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_ZMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_FLOAT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READWRITE, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM_VSIBY, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_FLOAT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_FLOAT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READWRITE, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM_VSIBX, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 4, 4, 4 }, ZYDIS_IELEMENT_TYPE_FLOAT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_FLOAT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READWRITE, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM_VSIBY, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 4, 4, 4 }, ZYDIS_IELEMENT_TYPE_FLOAT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_ZMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_FLOAT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READWRITE, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM_VSIBZ, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 4, 4, 4 }, ZYDIS_IELEMENT_TYPE_FLOAT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_FLOAT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READWRITE, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM_VSIBY, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_FLOAT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_ZMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_FLOAT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READWRITE, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM_VSIBZ, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_FLOAT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_FLOAT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READWRITE, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM_VSIBY, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 4, 4, 4 }, ZYDIS_IELEMENT_TYPE_FLOAT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_FLOAT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READWRITE, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM_VSIBZ, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 4, 4, 4 }, ZYDIS_IELEMENT_TYPE_FLOAT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_FLOAT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_FLOAT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_INT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_INT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_INT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_INT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_ZMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_INT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_ZMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_INT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_INT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_INT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_INT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_INT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_ZMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_INT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_INT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_INT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_INT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_INT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_INT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_ZMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_INT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_ZMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_INT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_INT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_INT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_INT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_INT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_INT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_ZMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_INT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_INT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_INT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_INT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_INT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_ZMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_INT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_ZMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_INT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_INT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_INT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_INT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_INT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_ZMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_INT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_INT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_INT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_INT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_INT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_INT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_ZMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_INT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_ZMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_INT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_INT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_INT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_INT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_INT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_INT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_ZMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_INT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_UINT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_UINT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_UINT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_UINT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_ZMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_UINT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_ZMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_UINT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_UINT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_UINT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_UINT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_UINT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_UINT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_ZMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_UINT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_UINT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_UINT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_UINT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_UINT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_ZMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_UINT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_UINT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_UINT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_UINT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_UINT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_UINT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_ZMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_UINT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_ZMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_UINT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_UINT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_UINT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_UINT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_UINT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_UINT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_ZMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_UINT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_UINT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_UINT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_UINT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_UINT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_UINT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_UINT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_ZMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_UINT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_UINT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_UINT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_UINT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_UINT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_UINT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_ZMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_UINT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_ZMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_UINT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_UINT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_UINT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_UINT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_UINT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_UINT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_ZMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_UINT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_ZMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_ZMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_ZMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_ZMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_ZMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_ZMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_FLOAT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_FLOAT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_FLOAT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 2, 2, 2 }, ZYDIS_IELEMENT_TYPE_FLOAT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 2, 2, 2 }, ZYDIS_IELEMENT_TYPE_FLOAT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_FLOAT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 4, 4, 4 }, ZYDIS_IELEMENT_TYPE_FLOAT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_FLOAT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_UINT32, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_UINT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_UINT32, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_UINT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_ZMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_UINT32, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_ZMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_UINT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_UINT32, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_UINT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_UINT32, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_UINT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_ZMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_UINT32, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_UINT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_UINT64, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_UINT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_UINT64, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_UINT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_ZMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_UINT64, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_ZMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_UINT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_UINT64, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_UINT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_UINT64, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_UINT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_ZMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_UINT64, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_UINT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_INT8, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_INT8, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_ZMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_ZMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_INT8, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_INT8, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_INT8, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_ZMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_INT8, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_UINT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_INT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_UINT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_INT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_ZMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_UINT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_ZMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_INT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_UINT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_UINT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_ZMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_UINT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_INT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_INT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_ZMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_INT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_UINT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_INT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_UINT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_INT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_ZMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_UINT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_ZMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_INT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_UINT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_INT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_UINT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_INT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_ZMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_UINT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_INT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_ZMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_ZMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_GPR32, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 4, 4, 4 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_GPR32, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 4, 4, 4 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_ZMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_GPR32, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 4, 4, 4 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_INT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_INT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_ZMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_INT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_INT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_INT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 4, 4, 4 }, ZYDIS_IELEMENT_TYPE_INT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_INT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 4, 4, 4 }, ZYDIS_IELEMENT_TYPE_INT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_ZMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_INT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 4, 4, 4 }, ZYDIS_IELEMENT_TYPE_INT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_INT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_GPR32, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 4, 4, 4 }, ZYDIS_IELEMENT_TYPE_INT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_INT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_GPR32, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 4, 4, 4 }, ZYDIS_IELEMENT_TYPE_INT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_ZMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_INT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_GPR32, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 4, 4, 4 }, ZYDIS_IELEMENT_TYPE_INT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_INT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_INT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_ZMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_INT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_INT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_INT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_INT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_ZMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_INT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_INT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_GPR64, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_INT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_GPR64, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_ZMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_INT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_GPR64, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_UINT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_UINT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_ZMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_UINT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_UINT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_UINT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 2, 2, 2 }, ZYDIS_IELEMENT_TYPE_UINT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_UINT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 2, 2, 2 }, ZYDIS_IELEMENT_TYPE_UINT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_ZMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_UINT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 2, 2, 2 }, ZYDIS_IELEMENT_TYPE_UINT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_UINT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_GPR32, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 4, 4, 4 }, ZYDIS_IELEMENT_TYPE_UINT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_UINT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_GPR32, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 4, 4, 4 }, ZYDIS_IELEMENT_TYPE_UINT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_ZMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_UINT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_GPR32, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 4, 4, 4 }, ZYDIS_IELEMENT_TYPE_UINT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_UINT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_UINT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_GPR32, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 4, 4, 4 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_UIMM8 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_GPR32, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 4, 4, 4 }, ZYDIS_IELEMENT_TYPE_UINT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_UINT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_UIMM8 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_GPR32, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 4, 4, 4 }, ZYDIS_IELEMENT_TYPE_UINT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_UINT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_UIMM8 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_INT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READWRITE, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM_VSIBX, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 4, 4, 4 }, ZYDIS_IELEMENT_TYPE_INT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_INT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READWRITE, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM_VSIBY, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 4, 4, 4 }, ZYDIS_IELEMENT_TYPE_INT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_ZMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_INT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READWRITE, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM_VSIBZ, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 4, 4, 4 }, ZYDIS_IELEMENT_TYPE_INT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_INT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READWRITE, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM_VSIBX, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_INT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READWRITE, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM_VSIBX, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_ZMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_INT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READWRITE, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM_VSIBY, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_INT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READWRITE, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM_VSIBY, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 4, 4, 4 }, ZYDIS_IELEMENT_TYPE_INT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_INT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READWRITE, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM_VSIBZ, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 4, 4, 4 }, ZYDIS_IELEMENT_TYPE_INT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_INT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READWRITE, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM_VSIBY, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_ZMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_INT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READWRITE, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM_VSIBZ, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_UINT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_UINT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_ZMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_UINT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 4, 4, 4 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_UINT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_UINT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_ZMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_UINT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_UINT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_UINT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_UINT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_UINT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_UINT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_ZMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_UINT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_UINT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_UINT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_UINT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_UINT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_UINT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_ZMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_UINT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_UINT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_UINT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_ZMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_UINT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 2, 2, 2 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_UINT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 4, 4, 4 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_UINT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_ZMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_UINT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_UINT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_UINT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_UINT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_UINT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_UINT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_ZMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_UINT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_UINT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_UINT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_UINT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_UINT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_UINT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_ZMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_UINT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_UINT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_UINT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_UINT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_UINT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_UINT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_ZMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_UINT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 4, 4, 4 }, ZYDIS_IELEMENT_TYPE_UINT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_UINT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_UINT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_UINT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_UINT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_ZMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_UINT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_INT8, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_INT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_INT8, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_INT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_INT8, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_ZMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_INT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 4, 4, 4 }, ZYDIS_IELEMENT_TYPE_INT8, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_INT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT8, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_INT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_INT8, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_ZMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_INT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_INT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_INT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_INT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_INT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_INT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_ZMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_INT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_INT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_INT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_INT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_INT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_ZMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_INT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_INT8, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_INT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_INT8, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_INT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_INT8, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_ZMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_INT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 2, 2, 2 }, ZYDIS_IELEMENT_TYPE_INT8, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_INT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 4, 4, 4 }, ZYDIS_IELEMENT_TYPE_INT8, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_INT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT8, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_ZMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_INT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_INT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_INT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_INT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_INT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_INT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_ZMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_INT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_INT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_INT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_INT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_INT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_ZMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_INT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_INT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_INT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_INT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_INT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_INT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_ZMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_INT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 4, 4, 4 }, ZYDIS_IELEMENT_TYPE_INT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_INT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_INT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_INT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_ZMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_INT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_INT8, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_INT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_INT8, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_INT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_INT8, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_ZMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_INT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT8, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_INT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_INT8, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_INT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_INT8, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_ZMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_INT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_INT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_INT8, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_INT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_INT8, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_ZMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_INT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_INT8, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_INT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 4, 4, 4 }, ZYDIS_IELEMENT_TYPE_INT8, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_INT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT8, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_ZMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_INT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_INT8, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_INT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_INT8, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_INT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_INT8, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_ZMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_INT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_INT8, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_INT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 2, 2, 2 }, ZYDIS_IELEMENT_TYPE_INT8, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_INT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 4, 4, 4 }, ZYDIS_IELEMENT_TYPE_INT8, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_ZMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_INT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT8, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_INT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_INT8, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_INT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_INT8, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_ZMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_INT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_INT8, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_INT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT8, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_INT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_INT8, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_ZMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_INT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_INT8, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_INT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_INT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_INT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_INT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_ZMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_INT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_INT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_INT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_INT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_INT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_ZMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_INT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_INT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_INT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_INT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_INT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_INT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_ZMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_INT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_INT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_INT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_INT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_INT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_ZMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_INT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_INT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_INT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_INT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_INT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_INT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_ZMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_INT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_INT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_INT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 4, 4, 4 }, ZYDIS_IELEMENT_TYPE_INT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_INT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_ZMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_INT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_INT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_UINT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_UINT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_ZMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_UINT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_UINT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_UINT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_ZMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_UINT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_UINT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_UINT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_ZMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_UINT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_UINT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 4, 4, 4 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_UINT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_ZMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_UINT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_UINT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_UINT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_ZMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_UINT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_UINT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 2, 2, 2 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_UINT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 4, 4, 4 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_ZMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_UINT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_UINT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_UINT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_ZMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_UINT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_UINT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_UINT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_ZMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_UINT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_UINT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_UINT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_UINT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_UINT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_ZMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_UINT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_UINT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_UINT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_UINT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_UINT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_UINT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_ZMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_UINT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_UINT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_UINT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_UINT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_UINT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_UINT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_ZMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_UINT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_UINT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_UINT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_UINT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_UINT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_UINT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_ZMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_UINT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_UINT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_UINT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_UINT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_UINT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_UINT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_ZMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_UINT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_UINT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_UINT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 4, 4, 4 }, ZYDIS_IELEMENT_TYPE_UINT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_UINT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_UINT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_ZMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_UINT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_UINT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_ZMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_UINT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_ZMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_ZMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_ZMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_UINT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_ZMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM_VSIBX, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 4, 4, 4 }, ZYDIS_IELEMENT_TYPE_INT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READWRITE, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_INT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM_VSIBY, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 4, 4, 4 }, ZYDIS_IELEMENT_TYPE_INT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READWRITE, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_INT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM_VSIBZ, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 4, 4, 4 }, ZYDIS_IELEMENT_TYPE_INT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READWRITE, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_ZMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_INT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM_VSIBX, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READWRITE, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_INT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM_VSIBX, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READWRITE, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_INT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM_VSIBY, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READWRITE, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_ZMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_INT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM_VSIBX, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 4, 4, 4 }, ZYDIS_IELEMENT_TYPE_UINT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READWRITE, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_UINT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM_VSIBY, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 4, 4, 4 }, ZYDIS_IELEMENT_TYPE_UINT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READWRITE, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_UINT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM_VSIBZ, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 4, 4, 4 }, ZYDIS_IELEMENT_TYPE_UINT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READWRITE, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_UINT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM_VSIBX, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_UINT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READWRITE, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_UINT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM_VSIBY, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_UINT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READWRITE, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_UINT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM_VSIBZ, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_UINT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READWRITE, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_ZMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_UINT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_UIMM8 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_UIMM8 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_ZMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_ZMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_UIMM8 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_UIMM8 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_UIMM8 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_ZMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_UIMM8 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM_VSIBX, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_FLOAT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READWRITE, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_FLOAT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM_VSIBX, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_FLOAT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READWRITE, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_FLOAT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM_VSIBY, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_FLOAT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READWRITE, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_ZMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_FLOAT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM_VSIBX, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 4, 4, 4 }, ZYDIS_IELEMENT_TYPE_FLOAT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READWRITE, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_FLOAT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM_VSIBY, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 4, 4, 4 }, ZYDIS_IELEMENT_TYPE_FLOAT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READWRITE, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_FLOAT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM_VSIBZ, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 4, 4, 4 }, ZYDIS_IELEMENT_TYPE_FLOAT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READWRITE, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_ZMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_FLOAT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM_VSIBY, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_FLOAT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READWRITE, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_FLOAT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM_VSIBZ, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_FLOAT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READWRITE, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_ZMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_FLOAT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM_VSIBY, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 4, 4, 4 }, ZYDIS_IELEMENT_TYPE_FLOAT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READWRITE, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_FLOAT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM_VSIBZ, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 4, 4, 4 }, ZYDIS_IELEMENT_TYPE_FLOAT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READWRITE, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_FLOAT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_ZMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READWRITE, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_INT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 2, 2, 2 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_VARIABLE, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_ZMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READWRITE, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_FLOAT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 2, 2, 2 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_ZMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_FLOAT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_ZMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READWRITE, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_FLOAT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 2, 2, 2 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_ZMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_FLOAT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_ZMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READWRITE, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_FLOAT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READWRITE, { 2, 2, 2 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM_VSIBZ, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_VARIABLE, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_ZMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READWRITE, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_FLOAT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READWRITE, { 2, 2, 2 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM_VSIBZ, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_VARIABLE, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_FLOAT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 2, 2, 2 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_ZMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_FLOAT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_VARIABLE, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 2, 2, 2 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_ZMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_FLOAT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_VARIABLE, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 2, 2, 2 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_ZMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_INT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_ZMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READWRITE, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_INT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 2, 2, 2 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_ZMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_INT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_INT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 2, 2, 2 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_ZMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_INT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READWRITE, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_FLOAT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 2, 2, 2 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_ZMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_FLOAT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READWRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_VARIABLE, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 2, 2, 2 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_ZMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_FLOAT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_VARIABLE, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 2, 2, 2 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_ZMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_FLOAT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_VARIABLE, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 2, 2, 2 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_ZMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_INT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_ZMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READWRITE, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_INT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READWRITE, { 2, 2, 2 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM_VSIBZ, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_VARIABLE, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_ZMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READWRITE, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_INT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READWRITE, { 2, 2, 2 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM_VSIBZ, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_VARIABLE, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM_VSIBZ, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_VARIABLE, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READWRITE, { 2, 2, 2 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_ZMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_INT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM_VSIBZ, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_VARIABLE, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READWRITE, { 2, 2, 2 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_ZMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_INT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM_VSIBZ, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_VARIABLE, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READWRITE, { 2, 2, 2 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_ZMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_FLOAT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM_VSIBZ, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_VARIABLE, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READWRITE, { 2, 2, 2 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_ZMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_FLOAT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READWRITE, { 4, 4, 4 }, ZYDIS_IELEMENT_TYPE_INT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_GPR32, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 4, 4, 4 }, ZYDIS_IELEMENT_TYPE_INT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READWRITE, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_GPR64, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_BND, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_GPR64, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_BND, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_AGEN, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_BND, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_GPR32, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_BND, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MIB, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 24, 24, 24 }, ZYDIS_IELEMENT_TYPE_UINT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_BND, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MIB, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 12, 12, 12 }, ZYDIS_IELEMENT_TYPE_UINT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_BND, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_AGEN, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_BND, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_BND, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_BND, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_UINT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_BND, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_UINT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_BND, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_BND, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_UINT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_BND, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_UINT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_BND, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MIB, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 24, 24, 24 }, ZYDIS_IELEMENT_TYPE_UINT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_BND, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MIB, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 12, 12, 12 }, ZYDIS_IELEMENT_TYPE_UINT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_BND, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_GPR16_32_64, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 4, 4, 4 }, ZYDIS_IELEMENT_TYPE_INT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_GPR16_32_64, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_WRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .reg = { ZYDIS_IMPLREG_TYPE_STATIC, { .reg = ZYDIS_REGISTER_AX } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_READ, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .reg = { ZYDIS_IMPLREG_TYPE_STATIC, { .reg = ZYDIS_REGISTER_AL } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_WRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .reg = { ZYDIS_IMPLREG_TYPE_STATIC, { .reg = ZYDIS_REGISTER_EDX } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_READ, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .reg = { ZYDIS_IMPLREG_TYPE_STATIC, { .reg = ZYDIS_REGISTER_EAX } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_WRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .reg = { ZYDIS_IMPLREG_TYPE_STATIC, { .reg = ZYDIS_REGISTER_RAX } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_READ, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .reg = { ZYDIS_IMPLREG_TYPE_STATIC, { .reg = ZYDIS_REGISTER_EAX } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_WRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .reg = { ZYDIS_IMPLREG_TYPE_STATIC, { .reg = ZYDIS_REGISTER_RDX } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_READ, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .reg = { ZYDIS_IMPLREG_TYPE_STATIC, { .reg = ZYDIS_REGISTER_RAX } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_GPR32_32_64, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READWRITE, { 4, 4, 8 }, ZYDIS_IELEMENT_TYPE_INT, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_GPR8, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_INT8, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_GPR32_32_64, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READWRITE, { 4, 4, 8 }, ZYDIS_IELEMENT_TYPE_INT, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_INT8, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_GPR32_32_64, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READWRITE, { 4, 4, 8 }, ZYDIS_IELEMENT_TYPE_INT, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_GPR16_32_64, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 2, 4, 8 }, ZYDIS_IELEMENT_TYPE_INT, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_GPR32_32_64, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READWRITE, { 4, 4, 8 }, ZYDIS_IELEMENT_TYPE_INT, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 2, 4, 8 }, ZYDIS_IELEMENT_TYPE_INT, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_FLOAT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_FLOAT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_FLOAT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_INT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_FLOAT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_INT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_INT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_FLOAT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_INT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_FLOAT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MMX, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_FLOAT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MMX, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_FLOAT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_FLOAT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_FLOAT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_FLOAT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_FLOAT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_FLOAT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MMX, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_FLOAT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MMX, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_FLOAT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_INT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_FLOAT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_INT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_FLOAT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_FLOAT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_FLOAT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_FLOAT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_FLOAT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MMX, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_FLOAT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MMX, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_FLOAT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_GPR32, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 4, 4, 4 }, ZYDIS_IELEMENT_TYPE_INT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_FLOAT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_GPR64, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_FLOAT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_GPR32, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 4, 4, 4 }, ZYDIS_IELEMENT_TYPE_INT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_FLOAT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_GPR64, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_FLOAT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 4, 4, 4 }, ZYDIS_IELEMENT_TYPE_FLOAT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_FLOAT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 4, 4, 4 }, ZYDIS_IELEMENT_TYPE_FLOAT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_FLOAT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READWRITE, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_FLOAT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_GPR32, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 4, 4, 4 }, ZYDIS_IELEMENT_TYPE_INT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READWRITE, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_FLOAT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_GPR64, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READWRITE, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_FLOAT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 4, 4, 4 }, ZYDIS_IELEMENT_TYPE_INT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READWRITE, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_FLOAT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READWRITE, { 4, 4, 4 }, ZYDIS_IELEMENT_TYPE_FLOAT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_GPR32, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 4, 4, 4 }, ZYDIS_IELEMENT_TYPE_INT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READWRITE, { 4, 4, 4 }, ZYDIS_IELEMENT_TYPE_FLOAT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_GPR64, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READWRITE, { 4, 4, 4 }, ZYDIS_IELEMENT_TYPE_FLOAT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 4, 4, 4 }, ZYDIS_IELEMENT_TYPE_INT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READWRITE, { 4, 4, 4 }, ZYDIS_IELEMENT_TYPE_FLOAT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_FLOAT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 4, 4, 4 }, ZYDIS_IELEMENT_TYPE_FLOAT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_FLOAT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 4, 4, 4 }, ZYDIS_IELEMENT_TYPE_FLOAT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_GPR32, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 4, 4, 4 }, ZYDIS_IELEMENT_TYPE_INT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 4, 4, 4 }, ZYDIS_IELEMENT_TYPE_FLOAT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_GPR64, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 4, 4, 4 }, ZYDIS_IELEMENT_TYPE_FLOAT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_GPR32, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 4, 4, 4 }, ZYDIS_IELEMENT_TYPE_INT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 4, 4, 4 }, ZYDIS_IELEMENT_TYPE_FLOAT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_GPR64, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 4, 4, 4 }, ZYDIS_IELEMENT_TYPE_FLOAT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MMX, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_FLOAT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MMX, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_FLOAT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_WRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .reg = { ZYDIS_IMPLREG_TYPE_STATIC, { .reg = ZYDIS_REGISTER_DX } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_READ, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .reg = { ZYDIS_IMPLREG_TYPE_STATIC, { .reg = ZYDIS_REGISTER_AX } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_WRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .reg = { ZYDIS_IMPLREG_TYPE_STATIC, { .reg = ZYDIS_REGISTER_EAX } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_READ, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .reg = { ZYDIS_IMPLREG_TYPE_STATIC, { .reg = ZYDIS_REGISTER_AX } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_READWRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .reg = { ZYDIS_IMPLREG_TYPE_STATIC, { .reg = ZYDIS_REGISTER_AL } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_READWRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INT1, { .reg = { ZYDIS_IMPLREG_TYPE_FLAGS_SSZ, { .id = 0x3F } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_GPR16_32_64, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READWRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .encoding = ZYDIS_OPERAND_ENCODING_OPCODE }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_WRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INT1, { .reg = { ZYDIS_IMPLREG_TYPE_FLAGS_SSZ, { .id = 0x3F } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_GPR8, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READWRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_WRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INT1, { .reg = { ZYDIS_IMPLREG_TYPE_FLAGS_SSZ, { .id = 0x3F } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READWRITE, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_INT8, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_WRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INT1, { .reg = { ZYDIS_IMPLREG_TYPE_FLAGS_SSZ, { .id = 0x3F } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_GPR16_32_64, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READWRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_WRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INT1, { .reg = { ZYDIS_IMPLREG_TYPE_FLAGS_SSZ, { .id = 0x3F } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READWRITE, { 2, 4, 8 }, ZYDIS_IELEMENT_TYPE_INT, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_WRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INT1, { .reg = { ZYDIS_IMPLREG_TYPE_FLAGS_SSZ, { .id = 0x3F } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_INT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 2, 2, 2 }, ZYDIS_IELEMENT_TYPE_STRUCT, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_WRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_STRUCT, { .reg = { ZYDIS_IMPLREG_TYPE_STATIC, { .reg = ZYDIS_REGISTER_X87STATUS } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 14, 14, 14 }, ZYDIS_IELEMENT_TYPE_STRUCT, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_WRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_STRUCT, { .reg = { ZYDIS_IMPLREG_TYPE_STATIC, { .reg = ZYDIS_REGISTER_X87STATUS } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 28, 28, 28 }, ZYDIS_IELEMENT_TYPE_STRUCT, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_WRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_STRUCT, { .reg = { ZYDIS_IMPLREG_TYPE_STATIC, { .reg = ZYDIS_REGISTER_X87STATUS } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 94, 94, 94 }, ZYDIS_IELEMENT_TYPE_STRUCT, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_WRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_STRUCT, { .reg = { ZYDIS_IMPLREG_TYPE_STATIC, { .reg = ZYDIS_REGISTER_X87STATUS } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 108, 108, 108 }, ZYDIS_IELEMENT_TYPE_STRUCT, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_WRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_STRUCT, { .reg = { ZYDIS_IMPLREG_TYPE_STATIC, { .reg = ZYDIS_REGISTER_X87STATUS } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 2, 2, 2 }, ZYDIS_IELEMENT_TYPE_STRUCT, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_WRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_STRUCT, { .reg = { ZYDIS_IMPLREG_TYPE_STATIC, { .reg = ZYDIS_REGISTER_X87STATUS } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 14, 14, 14 }, ZYDIS_IELEMENT_TYPE_STRUCT, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_WRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_STRUCT, { .reg = { ZYDIS_IMPLREG_TYPE_STATIC, { .reg = ZYDIS_REGISTER_X87STATUS } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 28, 28, 28 }, ZYDIS_IELEMENT_TYPE_STRUCT, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_WRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_STRUCT, { .reg = { ZYDIS_IMPLREG_TYPE_STATIC, { .reg = ZYDIS_REGISTER_X87STATUS } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_IMPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .reg = { ZYDIS_IMPLREG_TYPE_STATIC, { .reg = ZYDIS_REGISTER_AX } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_WRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_STRUCT, { .reg = { ZYDIS_IMPLREG_TYPE_STATIC, { .reg = ZYDIS_REGISTER_X87STATUS } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 94, 94, 94 }, ZYDIS_IELEMENT_TYPE_STRUCT, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_WRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_STRUCT, { .reg = { ZYDIS_IMPLREG_TYPE_STATIC, { .reg = ZYDIS_REGISTER_X87STATUS } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 108, 108, 108 }, ZYDIS_IELEMENT_TYPE_STRUCT, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_WRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_STRUCT, { .reg = { ZYDIS_IMPLREG_TYPE_STATIC, { .reg = ZYDIS_REGISTER_X87STATUS } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_READ_CONDWRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .reg = { ZYDIS_IMPLREG_TYPE_STATIC, { .reg = ZYDIS_REGISTER_EAX } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_READ, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .reg = { ZYDIS_IMPLREG_TYPE_STATIC, { .reg = ZYDIS_REGISTER_EBX } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_UIMM8 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_READ, { 4, 4, 4 }, ZYDIS_IELEMENT_TYPE_UINT32, { .reg = { ZYDIS_IMPLREG_TYPE_STATIC, { .reg = ZYDIS_REGISTER_EAX } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_WRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .reg = { ZYDIS_IMPLREG_TYPE_STATIC, { .reg = ZYDIS_REGISTER_EIP } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_READWRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INT1, { .reg = { ZYDIS_IMPLREG_TYPE_FLAGS_SSZ, { .id = 0x3F } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_IMPLICIT, ZYDIS_OPERAND_ACTION_READ, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .reg = { ZYDIS_IMPLREG_TYPE_GPR_ASZ, { .id = 0x0 } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_IMPLICIT, ZYDIS_OPERAND_ACTION_READ, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .reg = { ZYDIS_IMPLREG_TYPE_STATIC, { .reg = ZYDIS_REGISTER_ECX } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_GPR16_32_64, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_WRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .reg = { ZYDIS_IMPLREG_TYPE_IP_SSZ, { .id = 0x3F } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 2, 4, 8 }, ZYDIS_IELEMENT_TYPE_INT, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_WRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .reg = { ZYDIS_IMPLREG_TYPE_IP_SSZ, { .id = 0x3F } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_WRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .reg = { ZYDIS_IMPLREG_TYPE_STATIC, { .reg = ZYDIS_REGISTER_AH } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_READ, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INT1, { .reg = { ZYDIS_IMPLREG_TYPE_FLAGS_SSZ, { .id = 0x3F } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_FLOAT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_INT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 4, 4, 4 }, ZYDIS_IELEMENT_TYPE_INT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_WRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .reg = { ZYDIS_IMPLREG_TYPE_STATIC, { .reg = ZYDIS_REGISTER_MXCSR } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_GPR16_32_64, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_AGEN, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 10, 10, 10 }, ZYDIS_IELEMENT_TYPE_STRUCT, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_WRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .reg = { ZYDIS_IMPLREG_TYPE_STATIC, { .reg = ZYDIS_REGISTER_GDTR } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 6, 6, 10 }, ZYDIS_IELEMENT_TYPE_STRUCT, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_WRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .reg = { ZYDIS_IMPLREG_TYPE_STATIC, { .reg = ZYDIS_REGISTER_GDTR } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 10, 10, 10 }, ZYDIS_IELEMENT_TYPE_STRUCT, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_WRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .reg = { ZYDIS_IMPLREG_TYPE_STATIC, { .reg = ZYDIS_REGISTER_IDTR } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 6, 6, 10 }, ZYDIS_IELEMENT_TYPE_STRUCT, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_WRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .reg = { ZYDIS_IMPLREG_TYPE_STATIC, { .reg = ZYDIS_REGISTER_IDTR } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_GPR16, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_WRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .reg = { ZYDIS_IMPLREG_TYPE_STATIC, { .reg = ZYDIS_REGISTER_LDTR } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 2, 2, 2 }, ZYDIS_IELEMENT_TYPE_INT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_WRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .reg = { ZYDIS_IMPLREG_TYPE_STATIC, { .reg = ZYDIS_REGISTER_LDTR } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_GPR16, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_WRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .reg = { ZYDIS_IMPLREG_TYPE_STATIC, { .reg = ZYDIS_REGISTER_CR0 } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 2, 2, 2 }, ZYDIS_IELEMENT_TYPE_INT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_WRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .reg = { ZYDIS_IMPLREG_TYPE_STATIC, { .reg = ZYDIS_REGISTER_CR0 } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_GPR16, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_WRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .reg = { ZYDIS_IMPLREG_TYPE_STATIC, { .reg = ZYDIS_REGISTER_TR } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 2, 2, 2 }, ZYDIS_IELEMENT_TYPE_INT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_WRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .reg = { ZYDIS_IMPLREG_TYPE_STATIC, { .reg = ZYDIS_REGISTER_TR } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_GPR8, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_GPR8, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_INT8, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_GPR8, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_GPR16_32_64, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_GPR16_32_64, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 2, 4, 8 }, ZYDIS_IELEMENT_TYPE_INT, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_GPR16_32_64, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_GPR8, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_GPR8, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_GPR8, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_INT8, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_GPR16_32_64, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_SREG, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 2, 2, 2 }, ZYDIS_IELEMENT_TYPE_INT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_SREG, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_SREG, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_GPR16, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_SREG, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 2, 2, 2 }, ZYDIS_IELEMENT_TYPE_INT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_IMPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .reg = { ZYDIS_IMPLREG_TYPE_STATIC, { .reg = ZYDIS_REGISTER_AL } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MOFFS, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_INT8, { .encoding = ZYDIS_OPERAND_ENCODING_DISP16_32_64 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_IMPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .reg = { ZYDIS_IMPLREG_TYPE_GPR_OSZ, { .id = 0x0 } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MOFFS, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 2, 4, 8 }, ZYDIS_IELEMENT_TYPE_INT, { .encoding = ZYDIS_OPERAND_ENCODING_DISP16_32_64 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MOFFS, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_INT8, { .encoding = ZYDIS_OPERAND_ENCODING_DISP16_32_64 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_IMPLICIT, ZYDIS_OPERAND_ACTION_READ, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .reg = { ZYDIS_IMPLREG_TYPE_STATIC, { .reg = ZYDIS_REGISTER_AL } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MOFFS, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 2, 4, 8 }, ZYDIS_IELEMENT_TYPE_INT, { .encoding = ZYDIS_OPERAND_ENCODING_DISP16_32_64 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_IMPLICIT, ZYDIS_OPERAND_ACTION_READ, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .reg = { ZYDIS_IMPLREG_TYPE_GPR_OSZ, { .id = 0x0 } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_GPR8, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .encoding = ZYDIS_OPERAND_ENCODING_OPCODE }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_INT8, { .encoding = ZYDIS_OPERAND_ENCODING_SIMM8 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_GPR16_32_64, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .encoding = ZYDIS_OPERAND_ENCODING_OPCODE }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 2, 4, 8 }, ZYDIS_IELEMENT_TYPE_INT, { .encoding = ZYDIS_OPERAND_ENCODING_SIMM16_32_64 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_GPR8, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_INT8, { .encoding = ZYDIS_OPERAND_ENCODING_SIMM8 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_INT8, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_INT8, { .encoding = ZYDIS_OPERAND_ENCODING_SIMM8 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_GPR16_32_64, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 2, 4, 4 }, ZYDIS_IELEMENT_TYPE_INT, { .encoding = ZYDIS_OPERAND_ENCODING_SIMM16_32_32 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 2, 4, 8 }, ZYDIS_IELEMENT_TYPE_INT, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 2, 4, 4 }, ZYDIS_IELEMENT_TYPE_INT, { .encoding = ZYDIS_OPERAND_ENCODING_SIMM16_32_32 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_GPR64, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_CR, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_GPR32, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_CR, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_GPR64, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_DR, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_GPR32, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_DR, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_CR, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_GPR64, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_CR, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_GPR32, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_DR, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_GPR64, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_DR, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_GPR32, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_FLOAT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_FLOAT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_FLOAT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_FLOAT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_FLOAT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_FLOAT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_FLOAT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_FLOAT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MMX, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_GPR32, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MMX, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 4, 4, 4 }, ZYDIS_IELEMENT_TYPE_INT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_INT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_GPR32, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_INT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 4, 4, 4 }, ZYDIS_IELEMENT_TYPE_INT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_GPR32, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MMX, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 4, 4, 4 }, ZYDIS_IELEMENT_TYPE_INT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 4, 4, 4 }, ZYDIS_IELEMENT_TYPE_INT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MMX, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 4, 4, 4 }, ZYDIS_IELEMENT_TYPE_INT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_GPR32, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 4, 4, 4 }, ZYDIS_IELEMENT_TYPE_INT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 4, 4, 4 }, ZYDIS_IELEMENT_TYPE_INT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 4, 4, 4 }, ZYDIS_IELEMENT_TYPE_INT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_INT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_INT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 4, 4, 4 }, ZYDIS_IELEMENT_TYPE_UINT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_GPR32, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 4, 4, 4 }, ZYDIS_IELEMENT_TYPE_UINT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_UINT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_GPR64, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_UINT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MMX, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_UINT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_UINT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_INT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_INT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_INT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_INT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READWRITE, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_FLOAT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_FLOAT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_FLOAT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READWRITE, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_FLOAT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_FLOAT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_FLOAT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_FLOAT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_FLOAT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_FLOAT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_GPR32_32_64, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_FLOAT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_GPR32_32_64, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_FLOAT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_INT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_FLOAT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_INT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_FLOAT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MMX, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MMX, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_GPR64, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MMX, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_INT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_GPR64, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MMX, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MMX, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_GPR64, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MMX, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_GPR64, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MMX, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MMX, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_INT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_UINT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MMX, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_UINT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_FLOAT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_FLOAT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_FLOAT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_FLOAT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_FLOAT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_FLOAT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_FLOAT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_FLOAT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 4, 4, 4 }, ZYDIS_IELEMENT_TYPE_FLOAT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 4, 4, 4 }, ZYDIS_IELEMENT_TYPE_FLOAT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_FLOAT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 4, 4, 4 }, ZYDIS_IELEMENT_TYPE_FLOAT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 4, 4, 4 }, ZYDIS_IELEMENT_TYPE_FLOAT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 4, 4, 4 }, ZYDIS_IELEMENT_TYPE_FLOAT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 4, 4, 4 }, ZYDIS_IELEMENT_TYPE_FLOAT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 4, 4, 4 }, ZYDIS_IELEMENT_TYPE_FLOAT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_GPR16_32_64, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_GPR8, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_GPR16_32_64, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_INT8, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_GPR16_32_64, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_GPR16, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_GPR16_32_64, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 2, 2, 2 }, ZYDIS_IELEMENT_TYPE_INT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_GPR16_32_64, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_GPR16_32_32, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_GPR16_32_64, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 4, 4, 4 }, ZYDIS_IELEMENT_TYPE_INT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_GPR16_32_64, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_UINT, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_GPR8, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_UINT, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_GPR16_32_64, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_UINT, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_GPR16_32_64, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_UINT, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_GPR16, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_UINT, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_GPR16_32_64, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_UINT, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 2, 2, 2 }, ZYDIS_IELEMENT_TYPE_UINT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_READ, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .reg = { ZYDIS_IMPLREG_TYPE_STATIC, { .reg = ZYDIS_REGISTER_RAX } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_READ, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .reg = { ZYDIS_IMPLREG_TYPE_STATIC, { .reg = ZYDIS_REGISTER_RCX } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MMX, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READWRITE, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MMX, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MMX, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READWRITE, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MMX, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READWRITE, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MMX, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MMX, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READWRITE, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READWRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_INT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_INT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READWRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_INT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_INT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MMX, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READWRITE, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MMX, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MMX, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READWRITE, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_UINT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_UINT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MMX, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READWRITE, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_UINT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MMX, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_UINT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MMX, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READWRITE, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_UINT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_UINT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READWRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_UINT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_UINT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READWRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_UINT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_UINT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MMX, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READWRITE, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT8, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MMX, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT8, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MMX, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READWRITE, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT8, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT8, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READWRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_INT8, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_INT8, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READWRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_INT8, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_INT8, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_GPR32, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MMX, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT8, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_GPR32, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_INT8, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_INT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 4, 4, 4 }, ZYDIS_IELEMENT_TYPE_INT8, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_INT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 4, 4, 4 }, ZYDIS_IELEMENT_TYPE_INT8, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_INT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 2, 2, 2 }, ZYDIS_IELEMENT_TYPE_INT8, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_INT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 2, 2, 2 }, ZYDIS_IELEMENT_TYPE_INT8, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_INT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT8, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_INT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT8, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_INT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_INT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_INT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_INT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_INT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 4, 4, 4 }, ZYDIS_IELEMENT_TYPE_INT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_INT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 4, 4, 4 }, ZYDIS_IELEMENT_TYPE_INT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_UINT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 4, 4, 4 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_UINT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 4, 4, 4 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_UINT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 2, 2, 2 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_UINT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 2, 2, 2 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_UINT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_UINT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_UINT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_UINT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_UINT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_UINT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_UINT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_UINT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_UINT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_UINT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_UINT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 4, 4, 4 }, ZYDIS_IELEMENT_TYPE_UINT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_UINT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 4, 4, 4 }, ZYDIS_IELEMENT_TYPE_UINT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MMX, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READWRITE, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_UINT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MMX, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_UINT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MMX, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READWRITE, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_UINT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_UINT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READWRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_UINT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_UINT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READWRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_UINT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_UINT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MMX, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READWRITE, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_UINT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_UIMM8 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READWRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_UINT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_UIMM8 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MMX, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READWRITE, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_UINT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MMX, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_UINT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MMX, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READWRITE, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_UINT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_UINT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READWRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_UINT128, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_UIMM8 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MMX, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READWRITE, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_UINT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_UIMM8 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READWRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_UINT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_UIMM8 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MMX, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READWRITE, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_UINT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MMX, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_UINT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READWRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_UINT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_UINT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READWRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_UINT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_UINT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MMX, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READWRITE, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_UINT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_UIMM8 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READWRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_UINT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_UIMM8 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MMX, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READWRITE, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_UINT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MMX, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_UINT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MMX, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READWRITE, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_UINT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_UINT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READWRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_UINT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_UINT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READWRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_UINT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_UINT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_IMPLICIT, ZYDIS_OPERAND_ACTION_READWRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .reg = { ZYDIS_IMPLREG_TYPE_STATIC, { .reg = ZYDIS_REGISTER_RAX } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_WRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INT1, { .reg = { ZYDIS_IMPLREG_TYPE_FLAGS_SSZ, { .id = 0x3F } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MMX, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READWRITE, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_UIMM8 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READWRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_INT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_UIMM8 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MMX, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READWRITE, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MMX, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_UINT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MMX, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READWRITE, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_UINT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READWRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_INT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_UINT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READWRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_INT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_UINT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MMX, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READWRITE, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_UIMM8 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READWRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_INT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_UIMM8 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MMX, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READWRITE, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MMX, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_UINT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MMX, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READWRITE, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_UINT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READWRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_INT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_UINT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READWRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_INT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_UINT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MMX, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READWRITE, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MMX, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 4, 4, 4 }, ZYDIS_IELEMENT_TYPE_INT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READWRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_INT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MMX, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READWRITE, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT8, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MMX, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 4, 4, 4 }, ZYDIS_IELEMENT_TYPE_INT8, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MMX, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READWRITE, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT8, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 4, 4, 4 }, ZYDIS_IELEMENT_TYPE_INT8, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MMX, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READWRITE, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MMX, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 4, 4, 4 }, ZYDIS_IELEMENT_TYPE_INT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MMX, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READWRITE, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 4, 4, 4 }, ZYDIS_IELEMENT_TYPE_INT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MMX, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READWRITE, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MMX, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 4, 4, 4 }, ZYDIS_IELEMENT_TYPE_INT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MMX, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READWRITE, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 4, 4, 4 }, ZYDIS_IELEMENT_TYPE_INT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_GPR16_32_64, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_WRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INT1, { .reg = { ZYDIS_IMPLREG_TYPE_FLAGS_SSZ, { .id = 0x3F } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_WRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .reg = { ZYDIS_IMPLREG_TYPE_IP_SSZ, { .id = 0x3F } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_WRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INT1, { .reg = { ZYDIS_IMPLREG_TYPE_FLAGS_SSZ, { .id = 0x3F } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_READ, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .reg = { ZYDIS_IMPLREG_TYPE_STATIC, { .reg = ZYDIS_REGISTER_AH } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_WRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INT1, { .reg = { ZYDIS_IMPLREG_TYPE_FLAGS_SSZ, { .id = 0x3F } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_WRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .reg = { ZYDIS_IMPLREG_TYPE_STATIC, { .reg = ZYDIS_REGISTER_AL } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_READ, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INT1, { .reg = { ZYDIS_IMPLREG_TYPE_FLAGS_SSZ, { .id = 0x3F } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_READWRITE, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_UINT64, { .reg = { ZYDIS_IMPLREG_TYPE_STATIC, { .reg = ZYDIS_REGISTER_RAX } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_WRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INT1, { .reg = { ZYDIS_IMPLREG_TYPE_FLAGS_SSZ, { .id = 0x3F } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_GPR8, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_READ, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INT1, { .reg = { ZYDIS_IMPLREG_TYPE_FLAGS_SSZ, { .id = 0x3F } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_READ, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INT1, { .reg = { ZYDIS_IMPLREG_TYPE_FLAGS_SSZ, { .id = 0x3F } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 10, 10, 10 }, ZYDIS_IELEMENT_TYPE_STRUCT, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_READ, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .reg = { ZYDIS_IMPLREG_TYPE_STATIC, { .reg = ZYDIS_REGISTER_GDTR } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 6, 6, 10 }, ZYDIS_IELEMENT_TYPE_STRUCT, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_READ, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .reg = { ZYDIS_IMPLREG_TYPE_STATIC, { .reg = ZYDIS_REGISTER_GDTR } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 10, 10, 10 }, ZYDIS_IELEMENT_TYPE_STRUCT, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_READ, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .reg = { ZYDIS_IMPLREG_TYPE_STATIC, { .reg = ZYDIS_REGISTER_IDTR } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 6, 6, 10 }, ZYDIS_IELEMENT_TYPE_STRUCT, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_READ, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .reg = { ZYDIS_IMPLREG_TYPE_STATIC, { .reg = ZYDIS_REGISTER_IDTR } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_GPR16_32_64, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_READ, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .reg = { ZYDIS_IMPLREG_TYPE_STATIC, { .reg = ZYDIS_REGISTER_LDTR } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 2, 2, 2 }, ZYDIS_IELEMENT_TYPE_INT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_READ, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .reg = { ZYDIS_IMPLREG_TYPE_STATIC, { .reg = ZYDIS_REGISTER_LDTR } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_GPR16_32_64, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_READ, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .reg = { ZYDIS_IMPLREG_TYPE_STATIC, { .reg = ZYDIS_REGISTER_CR0 } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 2, 2, 2 }, ZYDIS_IELEMENT_TYPE_INT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_READ, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .reg = { ZYDIS_IMPLREG_TYPE_STATIC, { .reg = ZYDIS_REGISTER_CR0 } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 4, 4, 4 }, ZYDIS_IELEMENT_TYPE_INT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_READ, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .reg = { ZYDIS_IMPLREG_TYPE_STATIC, { .reg = ZYDIS_REGISTER_MXCSR } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_GPR16_32_64, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_READ, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .reg = { ZYDIS_IMPLREG_TYPE_STATIC, { .reg = ZYDIS_REGISTER_TR } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 2, 2, 2 }, ZYDIS_IELEMENT_TYPE_INT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_READ, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .reg = { ZYDIS_IMPLREG_TYPE_STATIC, { .reg = ZYDIS_REGISTER_TR } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_READ, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INT1, { .reg = { ZYDIS_IMPLREG_TYPE_STATIC, { .reg = ZYDIS_REGISTER_UIF } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_WRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INT1, { .reg = { ZYDIS_IMPLREG_TYPE_FLAGS_SSZ, { .id = 0x3F } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READWRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_FLOAT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READWRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_FLOAT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_INT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READWRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_FLOAT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_INT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READWRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_FLOAT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_INT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READWRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_FLOAT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_GPR16, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_WRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INT1, { .reg = { ZYDIS_IMPLREG_TYPE_FLAGS_SSZ, { .id = 0x3F } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_WRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INT1, { .reg = { ZYDIS_IMPLREG_TYPE_FLAGS_SSZ, { .id = 0x3F } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_UIMM8 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_READ_CONDWRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .reg = { ZYDIS_IMPLREG_TYPE_STATIC, { .reg = ZYDIS_REGISTER_EAX } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_GPR16_32_64, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READWRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .encoding = ZYDIS_OPERAND_ENCODING_OPCODE }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_IMPLICIT, ZYDIS_OPERAND_ACTION_READWRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .reg = { ZYDIS_IMPLREG_TYPE_GPR_OSZ, { .id = 0x0 } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_MEM, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_READ, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_UINT8, { .mem = { 4, ZYDIS_IMPLMEM_BASE_ABX } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_WRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .reg = { ZYDIS_IMPLREG_TYPE_STATIC, { .reg = ZYDIS_REGISTER_AL } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_FLOAT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_FLOAT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_FLOAT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 4, 4, 4 }, ZYDIS_IELEMENT_TYPE_FLOAT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_INT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_INT8, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_INT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_INT8, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_INT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_INT8, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_INT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_INT8, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_INT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_INT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_INT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_INT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_UINT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_UINT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_UINT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_UINT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_UINT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_UINT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_UINT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_UINT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_UINT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_UINT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_UINT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_UINT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_UINT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_UINT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_UINT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_UINT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_UINT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_UINT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_INT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_INT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_INT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_INT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_INT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_INT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_INT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_INT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_INT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_INT8, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_INT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_INT8, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 2, 2, 2 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_REL, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_INT8, { .encoding = ZYDIS_OPERAND_ENCODING_JIMM8 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 2, 2, 2 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_NDSNDD }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_REL, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 2, 4, 4 }, ZYDIS_IELEMENT_TYPE_INT, { .encoding = ZYDIS_OPERAND_ENCODING_JIMM32 }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 2, 2, 2 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 2, 2, 2 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 2, 2, 2 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_GPR32, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_GPR32, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 2, 2, 2 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_GPR32, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 4, 4, 4 }, ZYDIS_IELEMENT_TYPE_UINT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_GPR32, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 4, 4, 4 }, ZYDIS_IELEMENT_TYPE_UINT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_UINT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 4, 4, 4 }, ZYDIS_IELEMENT_TYPE_UINT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 4, 4, 4 }, ZYDIS_IELEMENT_TYPE_UINT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_UINT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_UINT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_UINT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_GPR64, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_UINT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_GPR64, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_UINT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_UINT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 2, 2, 2 }, ZYDIS_IELEMENT_TYPE_UINT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 2, 2, 2 }, ZYDIS_IELEMENT_TYPE_UINT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_TMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_UINT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_UINT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_UINT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_TMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_UINT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_FLOAT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 2, 2, 2 }, ZYDIS_IELEMENT_TYPE_UINT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_FLOAT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 2, 2, 2 }, ZYDIS_IELEMENT_TYPE_UINT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_FLOAT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 2, 2, 2 }, ZYDIS_IELEMENT_TYPE_FLOAT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_FLOAT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 2, 2, 2 }, ZYDIS_IELEMENT_TYPE_FLOAT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_FLOAT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_FLOAT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_UINT128, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_UINT128, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_FLOAT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_FLOAT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_FLOAT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_FLOAT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_FLOAT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_FLOAT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_FLOAT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 4, 4, 4 }, ZYDIS_IELEMENT_TYPE_FLOAT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_FLOAT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_INT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_FLOAT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_INT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_FLOAT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_INT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_FLOAT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_INT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_FLOAT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_BFLOAT16X2, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_FLOAT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_BFLOAT16X2, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_FLOAT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_FLOAT16X2, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_FLOAT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_FLOAT16X2, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_UINT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_FLOAT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_UINT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_FLOAT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_UINT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_FLOAT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_UINT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_FLOAT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_INT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_FLOAT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_INT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_FLOAT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_FLOAT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_FLOAT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_FLOAT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_FLOAT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_FLOAT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_FLOAT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_FLOAT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_FLOAT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_FLOAT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_FLOAT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_FLOAT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_FLOAT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_INT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_FLOAT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_INT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_FLOAT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_FLOAT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_FLOAT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_FLOAT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_FLOAT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_INT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_INT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_FLOAT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_FLOAT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_FLOAT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_FLOAT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_FLOAT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_FLOAT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_FLOAT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_FLOAT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_INT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_GPR32, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 4, 4, 4 }, ZYDIS_IELEMENT_TYPE_INT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_GPR32, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 4, 4, 4 }, ZYDIS_IELEMENT_TYPE_INT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 4, 4, 4 }, ZYDIS_IELEMENT_TYPE_INT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_INT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_INT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_INT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_INT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_INT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_INT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_FLOAT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_FLOAT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_GPR32, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 4, 4, 4 }, ZYDIS_IELEMENT_TYPE_INT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_FLOAT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_GPR32, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 4, 4, 4 }, ZYDIS_IELEMENT_TYPE_INT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_FLOAT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_GPR32, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 4, 4, 4 }, ZYDIS_IELEMENT_TYPE_INT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_FLOAT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_GPR32, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 4, 4, 4 }, ZYDIS_IELEMENT_TYPE_INT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_FLOAT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_INT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_GPR64, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_GPR64, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_INT8, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_INT8, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_INT8, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_INT8, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_UINT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_INT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_UINT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_INT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_UINT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_INT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_UINT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_INT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_UINT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_INT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_UINT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_INT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_UINT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_INT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_UINT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_INT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_INT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 4, 4, 4 }, ZYDIS_IELEMENT_TYPE_INT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_INT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 4, 4, 4 }, ZYDIS_IELEMENT_TYPE_INT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_INT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 4, 4, 4 }, ZYDIS_IELEMENT_TYPE_INT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_INT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_INT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_INT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_INT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_UINT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 2, 2, 2 }, ZYDIS_IELEMENT_TYPE_UINT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_UINT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 2, 2, 2 }, ZYDIS_IELEMENT_TYPE_UINT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_UINT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 2, 2, 2 }, ZYDIS_IELEMENT_TYPE_UINT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_UINT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 2, 2, 2 }, ZYDIS_IELEMENT_TYPE_UINT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_GPR32, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 4, 4, 4 }, ZYDIS_IELEMENT_TYPE_UINT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_INT8, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_GPR32, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 4, 4, 4 }, ZYDIS_IELEMENT_TYPE_UINT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_INT8, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_INT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT8, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_INT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT8, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_INT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 4, 4, 4 }, ZYDIS_IELEMENT_TYPE_INT8, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_INT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 4, 4, 4 }, ZYDIS_IELEMENT_TYPE_INT8, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_INT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_INT8, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_INT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_INT8, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_INT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_INT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_INT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_INT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_INT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_INT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_INT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_INT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_INT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_INT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_UINT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_UINT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_UINT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 4, 4, 4 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_UINT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 4, 4, 4 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_UINT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_UINT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_UINT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_UINT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_UINT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_UINT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_UINT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_UINT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_UINT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_UINT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_UINT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_UINT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_UINT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_UINT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READWRITE, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_UINT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_UINT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READWRITE, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_UINT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_UINT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_GPR64, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_FLOAT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_GPR32, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 4, 4, 4 }, ZYDIS_IELEMENT_TYPE_UINT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_FLOAT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_GPR32, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 4, 4, 4 }, ZYDIS_IELEMENT_TYPE_UINT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_FLOAT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_GPR64, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_UINT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_FLOAT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_GPR64, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_UINT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_FLOAT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_GPR32, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 4, 4, 4 }, ZYDIS_IELEMENT_TYPE_INT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_FLOAT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_GPR64, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_FLOAT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_GPR32, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 4, 4, 4 }, ZYDIS_IELEMENT_TYPE_INT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 2, 2, 2 }, ZYDIS_IELEMENT_TYPE_FLOAT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_GPR64, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 2, 2, 2 }, ZYDIS_IELEMENT_TYPE_FLOAT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_GPR32, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 4, 4, 4 }, ZYDIS_IELEMENT_TYPE_UINT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_FLOAT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_GPR64, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_UINT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_FLOAT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_GPR32, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 4, 4, 4 }, ZYDIS_IELEMENT_TYPE_UINT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 2, 2, 2 }, ZYDIS_IELEMENT_TYPE_FLOAT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_GPR64, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_UINT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 2, 2, 2 }, ZYDIS_IELEMENT_TYPE_FLOAT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_GPR64, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_FLOAT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_GPR32, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 4, 4, 4 }, ZYDIS_IELEMENT_TYPE_UINT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_FLOAT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_GPR32, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 4, 4, 4 }, ZYDIS_IELEMENT_TYPE_UINT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 4, 4, 4 }, ZYDIS_IELEMENT_TYPE_FLOAT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_GPR64, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_UINT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_FLOAT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_GPR64, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_UINT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 4, 4, 4 }, ZYDIS_IELEMENT_TYPE_FLOAT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM_VSIBY, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_FLOAT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READWRITE, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM_VSIBZ, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 4, 4, 4 }, ZYDIS_IELEMENT_TYPE_FLOAT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READWRITE, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM_VSIBZ, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_FLOAT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READWRITE, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_INT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_ZMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_INT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_ZMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_INT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_INT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_FLOAT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_ZMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_FLOAT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_FLOAT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_ZMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_FLOAT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_INT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_GPR64, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_GPR64, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_INT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_INT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_INT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_INT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_FLOAT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_GPR32, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 4, 4, 4 }, ZYDIS_IELEMENT_TYPE_FLOAT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_FLOAT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 2, 2, 2 }, ZYDIS_IELEMENT_TYPE_FLOAT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_GPR32, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 4, 4, 4 }, ZYDIS_IELEMENT_TYPE_FLOAT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_FLOAT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 2, 2, 2 }, ZYDIS_IELEMENT_TYPE_FLOAT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_FLOAT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_UINT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_UINT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_UINT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_UINT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_ZMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_UINT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_UINT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_UINT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_UINT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_UINT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_UINT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_ZMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_UINT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_UINT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_ZMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_UINT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_UINT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_ZMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_UINT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_ZMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_UINT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_UINT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_ZMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_UINT32, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_UINT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_UINT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_ZMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_UINT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_UINT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_UINT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_ZMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_UINT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_UINT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_UINT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_ZMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_UINT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_XMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 16, 16, 16 }, ZYDIS_IELEMENT_TYPE_UINT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_YMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 32, 32, 32 }, ZYDIS_IELEMENT_TYPE_UINT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_REG }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_ZMM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_UINT16, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM_VSIBZ, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_VARIABLE, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MASK, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READWRITE, { 2, 2, 2 }, ZYDIS_IELEMENT_TYPE_INT1, { .encoding = ZYDIS_OPERAND_ENCODING_MASK }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READWRITE, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_UINT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_WRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INT1, { .reg = { ZYDIS_IMPLREG_TYPE_STATIC, { .reg = ZYDIS_REGISTER_UIF } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 512, 512, 512 }, ZYDIS_IELEMENT_TYPE_STRUCT, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 512, 512, 512 }, ZYDIS_IELEMENT_TYPE_STRUCT, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_GPR64, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 8, 8, 8 }, ZYDIS_IELEMENT_TYPE_UINT8, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 1, 1, 1 }, ZYDIS_IELEMENT_TYPE_INT64, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_GPR32_32_64, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_GPR32_32_64, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_IMPLICIT_REG, ZYDIS_OPERAND_VISIBILITY_HIDDEN, ZYDIS_OPERAND_ACTION_READWRITE, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .reg = { ZYDIS_IMPLREG_TYPE_STATIC, { .reg = ZYDIS_REGISTER_GS } } }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_GPR_ASZ, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 0, 0, 0 }, ZYDIS_IELEMENT_TYPE_INVALID, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_GPR32_32_64, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 4, 4, 8 }, ZYDIS_IELEMENT_TYPE_INT, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_STRUCT, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_READ, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_INT, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE },
    { ZYDIS_SEMANTIC_OPTYPE_MEM, ZYDIS_OPERAND_VISIBILITY_EXPLICIT, ZYDIS_OPERAND_ACTION_WRITE, { 64, 64, 64 }, ZYDIS_IELEMENT_TYPE_STRUCT, { .encoding = ZYDIS_OPERAND_ENCODING_MODRM_RM }, ZYAN_FALSE, ZYAN_FALSE }
};
#endif

#undef ZYDIS_OPERAND_DEFINITION

/* ---------------------------------------------------------------------------------------------- */
/* Accessed CPU flags                                                                             */
/* ---------------------------------------------------------------------------------------------- */


//
// Header: Generated/AccessedFlags.inc
//

#ifndef ZYDIS_MINIMAL_MODE
static const ZydisDefinitionAccessedFlags ACCESSED_FLAGS[] =
{
    { { 0x0, 0x0, 0x0, 0x0, 0x0 }, { 0x0, 0x0, 0x0, 0x0, 0x0 } },
    { { 0x0, 0x0, 0x0, 0x0, 0x0 }, { 0x0, 0xF, 0x0, 0x0, 0x0 } },
    { { 0x0, 0x0, 0x0, 0x0, 0x0 }, { 0x0, 0x6, 0x0, 0x0, 0x9 } },
    { { 0x0, 0x0, 0x0, 0x0, 0x0 }, { 0x0, 0x2, 0x0, 0x0, 0xD } },
    { { 0x0, 0x0, 0x0, 0x0, 0x0 }, { 0x0, 0x0, 0x0, 0x0, 0xF } },
    { { 0x0, 0x0, 0x40000, 0x0, 0x0 }, { 0x0, 0x0, 0x0, 0x0, 0x0 } },
    { { 0x0, 0x0, 0x0, 0x40000, 0x0 }, { 0x0, 0x0, 0x0, 0x0, 0x0 } },
    { { 0x1000, 0x0, 0x0, 0x0, 0x0 }, { 0x0, 0x0, 0x0, 0x0, 0x0 } },
    { { 0x800, 0x0, 0x0, 0x0, 0x0 }, { 0x0, 0x0, 0x0, 0x0, 0x0 } },
    { { 0x800, 0x800, 0x0, 0x0, 0x0 }, { 0x0, 0x0, 0x0, 0x0, 0x0 } },
    { { 0x400, 0x0, 0x0, 0x0, 0x0 }, { 0x0, 0x0, 0x0, 0x0, 0x0 } },
    { { 0x1400, 0x0, 0x0, 0x0, 0x0 }, { 0x0, 0x0, 0x0, 0x0, 0x0 } },
    { { 0x0, 0x0, 0x400, 0x0, 0x0 }, { 0x0, 0x0, 0x0, 0x0, 0x0 } },
    { { 0x0, 0x0, 0x0, 0x400, 0x0 }, { 0x0, 0x0, 0x0, 0x0, 0x0 } },
    { { 0x1000, 0x80200, 0x0, 0x0, 0x0 }, { 0x0, 0x0, 0x0, 0x0, 0x0 } },
    { { 0x0, 0x0, 0x30200, 0x0, 0x0 }, { 0x0, 0x0, 0x0, 0x0, 0x0 } },
    { { 0x21800, 0x64300, 0x10000, 0x0, 0x0 }, { 0x0, 0x0, 0x0, 0x0, 0x0 } },
    { { 0x21000, 0xE4200, 0x10100, 0x0, 0x0 }, { 0x0, 0x0, 0x0, 0x0, 0x0 } },
    { { 0x80, 0x0, 0x0, 0x0, 0x0 }, { 0x0, 0x0, 0x0, 0x0, 0x0 } },
    { { 0x880, 0x0, 0x0, 0x0, 0x0 }, { 0x0, 0x0, 0x0, 0x0, 0x0 } },
    { { 0x40, 0x0, 0x0, 0x0, 0x0 }, { 0x0, 0x0, 0x0, 0x0, 0x0 } },
    { { 0x40, 0x0, 0x0, 0x0, 0x0 }, { 0x0, 0x2, 0x0, 0x0, 0xD } },
    { { 0x8C0, 0x0, 0x0, 0x0, 0x0 }, { 0x0, 0x0, 0x0, 0x0, 0x0 } },
    { { 0x0, 0x40, 0x0, 0x0, 0x0 }, { 0x0, 0x0, 0x0, 0x0, 0x0 } },
    { { 0x4, 0x0, 0x0, 0x0, 0x0 }, { 0x0, 0x0, 0x0, 0x0, 0x0 } },
    { { 0x4, 0x0, 0x0, 0x0, 0x0 }, { 0x0, 0x2, 0x0, 0x0, 0xD } },
    { { 0x0, 0x8D4, 0x0, 0x0, 0x0 }, { 0x0, 0x0, 0x0, 0x0, 0x0 } },
    { { 0x1, 0x0, 0x0, 0x0, 0x0 }, { 0x0, 0x0, 0x0, 0x0, 0x0 } },
    { { 0x1, 0x0, 0x0, 0x0, 0x0 }, { 0x0, 0x2, 0x0, 0x0, 0xD } },
    { { 0x41, 0x0, 0x0, 0x0, 0x0 }, { 0x0, 0x0, 0x0, 0x0, 0x0 } },
    { { 0x41, 0x0, 0x0, 0x0, 0x0 }, { 0x0, 0x2, 0x0, 0x0, 0xD } },
    { { 0xD5, 0x0, 0x0, 0x0, 0x0 }, { 0x0, 0x0, 0x0, 0x0, 0x0 } },
    { { 0x3F5FD5, 0x0, 0x0, 0x0, 0x0 }, { 0x0, 0x0, 0x0, 0x0, 0x0 } },
    { { 0x1, 0x1, 0x0, 0x0, 0x0 }, { 0x0, 0x0, 0x0, 0x0, 0x0 } },
    { { 0x1, 0x1, 0x0, 0x0, 0x800 }, { 0x0, 0x0, 0x0, 0x0, 0x0 } },
    { { 0x11, 0xD5, 0x0, 0x0, 0x800 }, { 0x0, 0x0, 0x0, 0x0, 0x0 } },
    { { 0x1, 0x8D5, 0x0, 0x0, 0x0 }, { 0x0, 0x0, 0x0, 0x0, 0x0 } },
    { { 0x1, 0x8C5, 0x0, 0x0, 0x10 }, { 0x0, 0x0, 0x0, 0x0, 0x0 } },
    { { 0x0, 0x1, 0x0, 0x0, 0x0 }, { 0x0, 0x0, 0x0, 0x0, 0x0 } },
    { { 0x0, 0x1, 0x0, 0x0, 0x800 }, { 0x0, 0x0, 0x0, 0x0, 0x0 } },
    { { 0x0, 0x41, 0x0, 0x0, 0x0 }, { 0x0, 0x0, 0x0, 0x0, 0x0 } },
    { { 0x440, 0x8D5, 0x0, 0x0, 0x0 }, { 0x0, 0x0, 0x0, 0x0, 0x0 } },
    { { 0x0, 0xD5, 0x0, 0x0, 0x0 }, { 0x0, 0x0, 0x0, 0x0, 0x0 } },
    { { 0x0, 0x8D5, 0x0, 0x0, 0x0 }, { 0x0, 0x0, 0x0, 0x0, 0x0 } },
    { { 0x400, 0x8D5, 0x0, 0x0, 0x0 }, { 0x0, 0x0, 0x0, 0x0, 0x0 } },
    { { 0x25000, 0x3F5FD5, 0x0, 0x0, 0x0 }, { 0x0, 0x0, 0x0, 0x0, 0x0 } },
    { { 0x21000, 0x3D5FD5, 0x0, 0x0, 0x0 }, { 0x0, 0x0, 0x0, 0x0, 0x0 } },
    { { 0x121000, 0x2C5FD5, 0x10000, 0x0, 0x0 }, { 0x0, 0x0, 0x0, 0x0, 0x0 } },
    { { 0x0, 0x3F5FD5, 0x0, 0x0, 0x0 }, { 0x0, 0x0, 0x0, 0x0, 0x0 } },
    { { 0x0, 0x3C5FD5, 0x10000, 0x0, 0x0 }, { 0x0, 0x0, 0x0, 0x0, 0x0 } },
    { { 0x0, 0x3C5FD5, 0x30000, 0x0, 0x0 }, { 0x0, 0x0, 0x0, 0x0, 0x0 } },
    { { 0x0, 0x45, 0x890, 0x0, 0x0 }, { 0x0, 0x0, 0x0, 0x0, 0x0 } },
    { { 0x0, 0x45, 0x890, 0x0, 0x0 }, { 0x0, 0x2, 0x0, 0x0, 0x0 } },
    { { 0x0, 0xC5, 0x0, 0x0, 0x810 }, { 0x0, 0x0, 0x0, 0x0, 0x0 } },
    { { 0x0, 0x8C1, 0x14, 0x0, 0x0 }, { 0x0, 0x0, 0x0, 0x0, 0x0 } },
    { { 0x0, 0x41, 0x894, 0x0, 0x0 }, { 0x0, 0x0, 0x0, 0x0, 0x0 } },
    { { 0x0, 0x1, 0x8D4, 0x0, 0x0 }, { 0x0, 0x0, 0x0, 0x0, 0x0 } },
    { { 0x10, 0x11, 0x0, 0x0, 0x8C4 }, { 0x0, 0x0, 0x0, 0x0, 0x0 } },
    { { 0x0, 0x1, 0x0, 0x0, 0x894 }, { 0x0, 0x0, 0x0, 0x0, 0x0 } },
    { { 0x0, 0xC1, 0x800, 0x0, 0x14 }, { 0x0, 0x0, 0x0, 0x0, 0x0 } },
    { { 0x0, 0x41, 0x0, 0x0, 0x894 }, { 0x0, 0x0, 0x0, 0x0, 0x0 } },
    { { 0x0, 0x81, 0x840, 0x0, 0x14 }, { 0x0, 0x0, 0x0, 0x0, 0x0 } },
    { { 0x0, 0x801, 0x0, 0x0, 0xD4 }, { 0x0, 0x0, 0x0, 0x0, 0x0 } },
    { { 0x0, 0x0, 0x1, 0x0, 0x0 }, { 0x0, 0x0, 0x0, 0x0, 0x0 } },
    { { 0x0, 0xC4, 0x801, 0x0, 0x10 }, { 0x0, 0x0, 0x0, 0x0, 0x0 } },
    { { 0x0, 0x40, 0x895, 0x0, 0x0 }, { 0x0, 0x0, 0x0, 0x0, 0x0 } },
    { { 0x0, 0x0, 0x8D5, 0x0, 0x0 }, { 0x0, 0x0, 0x0, 0x0, 0x0 } },
    { { 0x0, 0xC0, 0x801, 0x0, 0x14 }, { 0x0, 0x0, 0x0, 0x0, 0x0 } },
    { { 0x0, 0x40, 0x801, 0x0, 0x94 }, { 0x0, 0x0, 0x0, 0x0, 0x0 } },
    { { 0x0, 0x0, 0x0, 0x1, 0x0 }, { 0x0, 0x0, 0x0, 0x0, 0x0 } },
    { { 0x0, 0xC4, 0x0, 0x0, 0x811 }, { 0x0, 0x0, 0x0, 0x0, 0x0 } },
    { { 0x0, 0x40, 0x0, 0x0, 0x895 }, { 0x0, 0x0, 0x0, 0x0, 0x0 } },
    { { 0x0, 0x0, 0x0, 0x0, 0x8D5 }, { 0x0, 0x0, 0x0, 0x0, 0x0 } }
};
#endif

/* ---------------------------------------------------------------------------------------------- */

/* ============================================================================================== */
/* Functions                                                                                      */
/* ============================================================================================== */

/* ---------------------------------------------------------------------------------------------- */
/* Instruction definition                                                                         */
/* ---------------------------------------------------------------------------------------------- */

void ZydisGetInstructionDefinition(ZydisInstructionEncoding encoding, ZyanU16 id,
    const ZydisInstructionDefinition** definition)
{
    switch (encoding)
    {
    case ZYDIS_INSTRUCTION_ENCODING_LEGACY:
        *definition = (ZydisInstructionDefinition*)&ISTR_DEFINITIONS_LEGACY[id];
        break;
    case ZYDIS_INSTRUCTION_ENCODING_3DNOW:
        *definition = (ZydisInstructionDefinition*)&ISTR_DEFINITIONS_3DNOW[id];
        break;
    case ZYDIS_INSTRUCTION_ENCODING_XOP:
        *definition = (ZydisInstructionDefinition*)&ISTR_DEFINITIONS_XOP[id];
        break;
    case ZYDIS_INSTRUCTION_ENCODING_VEX:
        *definition = (ZydisInstructionDefinition*)&ISTR_DEFINITIONS_VEX[id];
        break;
#ifndef ZYDIS_DISABLE_AVX512
    case ZYDIS_INSTRUCTION_ENCODING_EVEX:
        *definition = (ZydisInstructionDefinition*)&ISTR_DEFINITIONS_EVEX[id];
        break;
#endif
#ifndef ZYDIS_DISABLE_KNC
    case ZYDIS_INSTRUCTION_ENCODING_MVEX:
        *definition = (ZydisInstructionDefinition*)&ISTR_DEFINITIONS_MVEX[id];
        break;
#endif
    default:
        ZYAN_UNREACHABLE;
    }
}

/* ---------------------------------------------------------------------------------------------- */
/* Operand definition                                                                             */
/* ---------------------------------------------------------------------------------------------- */

#ifndef ZYDIS_MINIMAL_MODE
const ZydisOperandDefinition* ZydisGetOperandDefinitions(
    const ZydisInstructionDefinition* definition)
{
    if (definition->operand_count == 0)
    {
        return ZYAN_NULL;
    }
    ZYAN_ASSERT(definition->operand_reference != 0xFFFF);
    return &OPERAND_DEFINITIONS[definition->operand_reference];
}
#endif

/* ---------------------------------------------------------------------------------------------- */
/* Element info                                                                                   */
/* ---------------------------------------------------------------------------------------------- */

#ifndef ZYDIS_MINIMAL_MODE
void ZydisGetElementInfo(ZydisInternalElementType element, ZydisElementType* type,
    ZydisElementSize* size)
{
    static const struct
    {
        ZydisElementType type;
        ZydisElementSize size;
    } lookup[ZYDIS_IELEMENT_TYPE_MAX_VALUE + 1] =
    {
        { ZYDIS_ELEMENT_TYPE_INVALID  ,   0 },
        { ZYDIS_ELEMENT_TYPE_INVALID  ,   0 },
        { ZYDIS_ELEMENT_TYPE_STRUCT   ,   0 },
        { ZYDIS_ELEMENT_TYPE_INT      ,   0 },
        { ZYDIS_ELEMENT_TYPE_UINT     ,   0 },
        { ZYDIS_ELEMENT_TYPE_INT      ,   1 },
        { ZYDIS_ELEMENT_TYPE_INT      ,   8 },
        { ZYDIS_ELEMENT_TYPE_INT      ,  32 }, // TODO: Should indicate 4 INT8 elements
        { ZYDIS_ELEMENT_TYPE_INT      ,  16 },
        { ZYDIS_ELEMENT_TYPE_INT      ,  32 }, // TODO: Should indicate 2 INT16 elements
        { ZYDIS_ELEMENT_TYPE_INT      ,  32 },
        { ZYDIS_ELEMENT_TYPE_INT      ,  64 },
        { ZYDIS_ELEMENT_TYPE_UINT     ,   8 },
        { ZYDIS_ELEMENT_TYPE_UINT     ,  32 }, // TODO: Should indicate 4 UINT8 elements
        { ZYDIS_ELEMENT_TYPE_UINT     ,  16 },
        { ZYDIS_ELEMENT_TYPE_UINT     ,  32 }, // TODO: Should indicate 2 UINT16 elements
        { ZYDIS_ELEMENT_TYPE_UINT     ,  32 },
        { ZYDIS_ELEMENT_TYPE_UINT     ,  64 },
        { ZYDIS_ELEMENT_TYPE_UINT     , 128 },
        { ZYDIS_ELEMENT_TYPE_UINT     , 256 },
        { ZYDIS_ELEMENT_TYPE_FLOAT16  ,  16 },
        { ZYDIS_ELEMENT_TYPE_FLOAT16  ,  32 }, // TODO: Should indicate 2 FLOAT16 elements
        { ZYDIS_ELEMENT_TYPE_FLOAT32  ,  32 },
        { ZYDIS_ELEMENT_TYPE_FLOAT64  ,  64 },
        { ZYDIS_ELEMENT_TYPE_BFLOAT16 ,  32 }, // TODO: Should indicate 2 BFLOAT16 elements
        { ZYDIS_ELEMENT_TYPE_FLOAT80  ,  80 },
        { ZYDIS_ELEMENT_TYPE_LONGBCD  ,  80 },
        { ZYDIS_ELEMENT_TYPE_CC       ,   3 },
        { ZYDIS_ELEMENT_TYPE_CC       ,   5 }
    };

    ZYAN_ASSERT((ZyanUSize)element < ZYAN_ARRAY_LENGTH(lookup));

    *type = lookup[element].type;
    *size = lookup[element].size;
}
#endif

/* ---------------------------------------------------------------------------------------------- */
/* Accessed CPU flags                                                                             */
/* ---------------------------------------------------------------------------------------------- */

#ifndef ZYDIS_MINIMAL_MODE
ZyanBool ZydisGetAccessedFlags(const ZydisInstructionDefinition* definition,
    const ZydisDefinitionAccessedFlags** flags)
{
    ZYAN_ASSERT(definition->flags_reference < ZYAN_ARRAY_LENGTH(ACCESSED_FLAGS));
    *flags = &ACCESSED_FLAGS[definition->flags_reference];
    return (definition->flags_reference != 0);
}
#endif

/* ---------------------------------------------------------------------------------------------- */

/* ============================================================================================== */

//
// Source file: /home/ath/devel/zydis/src/String.c
//

/***************************************************************************************************

  Zyan Disassembler Library (Zydis)

  Original Author : Florian Bernd, Joel Hoener

 * Permission is hereby granted, free of charge, to any person obtaining a copy
 * of this software and associated documentation files (the "Software"), to deal
 * in the Software without restriction, including without limitation the rights
 * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
 * copies of the Software, and to permit persons to whom the Software is
 * furnished to do so, subject to the following conditions:
 *
 * The above copyright notice and this permission notice shall be included in all
 * copies or substantial portions of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
 * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
 * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
 * SOFTWARE.

***************************************************************************************************/


/* ============================================================================================== */
/* Constants                                                                                      */
/* ============================================================================================== */

/* ---------------------------------------------------------------------------------------------- */
/* Defines                                                                                        */
/* ---------------------------------------------------------------------------------------------- */

#define ZYDIS_MAXCHARS_DEC_32 10
#define ZYDIS_MAXCHARS_DEC_64 20
#define ZYDIS_MAXCHARS_HEX_32  8
#define ZYDIS_MAXCHARS_HEX_64 16

/* ---------------------------------------------------------------------------------------------- */
/* Lookup Tables                                                                                  */
/* ---------------------------------------------------------------------------------------------- */

static const char* const DECIMAL_LOOKUP =
    "00010203040506070809"
    "10111213141516171819"
    "20212223242526272829"
    "30313233343536373839"
    "40414243444546474849"
    "50515253545556575859"
    "60616263646566676869"
    "70717273747576777879"
    "80818283848586878889"
    "90919293949596979899";

/* ---------------------------------------------------------------------------------------------- */

/* ============================================================================================== */
/* Internal Functions                                                                             */
/* ============================================================================================== */

/* ---------------------------------------------------------------------------------------------- */
/* Decimal                                                                                        */
/* ---------------------------------------------------------------------------------------------- */

#if defined(ZYAN_X86) || defined(ZYAN_ARM) || defined(ZYAN_EMSCRIPTEN) || defined(ZYAN_WASM) || defined(ZYAN_PPC)
static ZyanStatus ZydisStringAppendDecU32(ZyanString* string, ZyanU32 value, ZyanU8 padding_length)
{
    ZYAN_ASSERT(string);
    ZYAN_ASSERT(!string->vector.allocator);

    char buffer[ZYDIS_MAXCHARS_DEC_32];
    char *buffer_end = &buffer[ZYDIS_MAXCHARS_DEC_32];
    char *buffer_write_pointer = buffer_end;
    while (value >= 100)
    {
        const ZyanU32 value_old = value;
        buffer_write_pointer -= 2;
        value /= 100;
        ZYAN_MEMCPY(buffer_write_pointer, &DECIMAL_LOOKUP[(value_old - (value * 100)) * 2], 2);
    }
    buffer_write_pointer -= 2;
    ZYAN_MEMCPY(buffer_write_pointer, &DECIMAL_LOOKUP[value * 2], 2);

    const ZyanUSize offset_odd    = (ZyanUSize)(value < 10);
    const ZyanUSize length_number = buffer_end - buffer_write_pointer - offset_odd;
    const ZyanUSize length_total  = ZYAN_MAX(length_number, padding_length);
    const ZyanUSize length_target = string->vector.size;

    if (string->vector.size + length_total > string->vector.capacity)
    {
        return ZYAN_STATUS_INSUFFICIENT_BUFFER_SIZE;
    }

    ZyanUSize offset_write = 0;
    if (padding_length > length_number)
    {
        offset_write = padding_length - length_number;
        ZYAN_MEMSET((char*)string->vector.data + length_target - 1, '0', offset_write);
    }

    ZYAN_MEMCPY((char*)string->vector.data + length_target + offset_write - 1,
        buffer_write_pointer + offset_odd, length_number);
    string->vector.size = length_target + length_total;
    ZYDIS_STRING_NULLTERMINATE(string);

    return ZYAN_STATUS_SUCCESS;
}
#endif

static ZyanStatus ZydisStringAppendDecU64(ZyanString* string, ZyanU64 value, ZyanU8 padding_length)
{
    ZYAN_ASSERT(string);
    ZYAN_ASSERT(!string->vector.allocator);

    char buffer[ZYDIS_MAXCHARS_DEC_64];
    char *buffer_end = &buffer[ZYDIS_MAXCHARS_DEC_64];
    char *buffer_write_pointer = buffer_end;
    while (value >= 100)
    {
        const ZyanU64 value_old = value;
        buffer_write_pointer -= 2;
        ZYAN_DIV64(value, 100);
        ZYAN_MEMCPY(buffer_write_pointer, &DECIMAL_LOOKUP[(value_old - (value * 100)) * 2], 2);
    }
    buffer_write_pointer -= 2;
    ZYAN_MEMCPY(buffer_write_pointer, &DECIMAL_LOOKUP[value * 2], 2);

    const ZyanUSize offset_odd    = (ZyanUSize)(value < 10);
    const ZyanUSize length_number = buffer_end - buffer_write_pointer - offset_odd;
    const ZyanUSize length_total  = ZYAN_MAX(length_number, padding_length);
    const ZyanUSize length_target = string->vector.size;

    if (string->vector.size + length_total > string->vector.capacity)
    {
        return ZYAN_STATUS_INSUFFICIENT_BUFFER_SIZE;
    }

    ZyanUSize offset_write = 0;
    if (padding_length > length_number)
    {
        offset_write = padding_length - length_number;
        ZYAN_MEMSET((char*)string->vector.data + length_target - 1, '0', offset_write);
    }

    ZYAN_MEMCPY((char*)string->vector.data + length_target + offset_write - 1,
        buffer_write_pointer + offset_odd, length_number);
    string->vector.size = length_target + length_total;
    ZYDIS_STRING_NULLTERMINATE(string);

    return ZYAN_STATUS_SUCCESS;
}

/* ---------------------------------------------------------------------------------------------- */
/* Hexadecimal                                                                                    */
/* ---------------------------------------------------------------------------------------------- */

#if defined(ZYAN_X86) || defined(ZYAN_ARM) || defined(ZYAN_EMSCRIPTEN) || defined(ZYAN_WASM) || defined(ZYAN_PPC)
static ZyanStatus ZydisStringAppendHexU32(ZyanString* string, ZyanU32 value, ZyanU8 padding_length,
    ZyanBool force_leading_number, ZyanBool uppercase)
{
    ZYAN_ASSERT(string);
    ZYAN_ASSERT(!string->vector.allocator);

    const ZyanUSize len = string->vector.size;
    const ZyanUSize remaining = string->vector.capacity - string->vector.size;

    if (remaining < (ZyanUSize)padding_length)
    {
        return ZYAN_STATUS_INSUFFICIENT_BUFFER_SIZE;
    }

    if (!value)
    {
        const ZyanU8 n = (padding_length ? padding_length : 1);

        if (remaining < (ZyanUSize)n)
        {
            return ZYAN_STATUS_INSUFFICIENT_BUFFER_SIZE;
        }

        ZYAN_MEMSET((char*)string->vector.data + len - 1, '0', n);
        string->vector.size = len + n;
        ZYDIS_STRING_NULLTERMINATE(string);

        return ZYAN_STATUS_SUCCESS;
    }

    ZyanU8 n = 0;
    char* buffer = ZYAN_NULL;
    for (ZyanI8 i = ZYDIS_MAXCHARS_HEX_32 - 1; i >= 0; --i)
    {
        const ZyanU8 v = (value >> i * 4) & 0x0F;
        if (!n)
        {
            if (!v)
            {
                continue;
            }
            const ZyanU8 zero = force_leading_number && (v > 9) && (padding_length <= i) ? 1 : 0;
            if (remaining <= (ZyanUSize)i + zero)
            {
                return ZYAN_STATUS_INSUFFICIENT_BUFFER_SIZE;
            }
            buffer = (char*)string->vector.data + len - 1;
            if (zero)
            {
                buffer[n++] = '0';
            }
            if (padding_length > i)
            {
                n = padding_length - i - 1;
                ZYAN_MEMSET(buffer, '0', n);
            }
        }
        ZYAN_ASSERT(buffer);
        if (uppercase)
        {
            buffer[n++] = "0123456789ABCDEF"[v];
        } else
        {
            buffer[n++] = "0123456789abcdef"[v];
        }
    }
    string->vector.size = len + n;
    ZYDIS_STRING_NULLTERMINATE(string);

    return ZYAN_STATUS_SUCCESS;
}
#endif

static ZyanStatus ZydisStringAppendHexU64(ZyanString* string, ZyanU64 value, ZyanU8 padding_length,
    ZyanBool force_leading_number, ZyanBool uppercase)
{
    ZYAN_ASSERT(string);
    ZYAN_ASSERT(!string->vector.allocator);

    const ZyanUSize len = string->vector.size;
    const ZyanUSize remaining = string->vector.capacity - string->vector.size;

    if (remaining < (ZyanUSize)padding_length)
    {
        return ZYAN_STATUS_INSUFFICIENT_BUFFER_SIZE;
    }

    if (!value)
    {
        const ZyanU8 n = (padding_length ? padding_length : 1);

        if (remaining < (ZyanUSize)n)
        {
            return ZYAN_STATUS_INSUFFICIENT_BUFFER_SIZE;
        }

        ZYAN_MEMSET((char*)string->vector.data + len - 1, '0', n);
        string->vector.size = len + n;
        ZYDIS_STRING_NULLTERMINATE(string);

        return ZYAN_STATUS_SUCCESS;
    }

    ZyanU8 n = 0;
    char* buffer = ZYAN_NULL;
    for (ZyanI8 i = ((value & 0xFFFFFFFF00000000) ?
        ZYDIS_MAXCHARS_HEX_64 : ZYDIS_MAXCHARS_HEX_32) - 1; i >= 0; --i)
    {
        const ZyanU8 v = (value >> i * 4) & 0x0F;
        if (!n)
        {
            if (!v)
            {
                continue;
            }
            const ZyanU8 zero = force_leading_number && (v > 9) && (padding_length <= i) ? 1 : 0;
            if (remaining <= (ZyanUSize)i + zero)
            {
                return ZYAN_STATUS_INSUFFICIENT_BUFFER_SIZE;
            }
            buffer = (char*)string->vector.data + len - 1;
            if (zero)
            {
                buffer[n++] = '0';
            }
            if (padding_length > i)
            {
                n = padding_length - i - 1;
                ZYAN_MEMSET(buffer, '0', n);
            }
        }
        ZYAN_ASSERT(buffer);
        if (uppercase)
        {
            buffer[n++] = "0123456789ABCDEF"[v];
        } else
        {
            buffer[n++] = "0123456789abcdef"[v];
        }
    }
    string->vector.size = len + n;
    ZYDIS_STRING_NULLTERMINATE(string);

    return ZYAN_STATUS_SUCCESS;
}

/* ---------------------------------------------------------------------------------------------- */

/* ============================================================================================== */
/* Public Functions                                                                               */
/* ============================================================================================== */

/* ---------------------------------------------------------------------------------------------- */
/* Formatting                                                                                     */
/* ---------------------------------------------------------------------------------------------- */

ZyanStatus ZydisStringAppendDecU(ZyanString* string, ZyanU64 value, ZyanU8 padding_length,
    const ZyanStringView* prefix, const ZyanStringView* suffix)
{
    if (prefix)
    {
        ZYAN_CHECK(ZydisStringAppend(string, prefix));
    }

#if defined(ZYAN_X64) || defined(ZYAN_AARCH64) || defined(ZYAN_PPC64) || defined(ZYAN_RISCV64) || defined(ZYAN_LOONGARCH)
    ZYAN_CHECK(ZydisStringAppendDecU64(string, value, padding_length));
#else
    if (value & 0xFFFFFFFF00000000)
    {
        ZYAN_CHECK(ZydisStringAppendDecU64(string, value, padding_length));
    }
    ZYAN_CHECK(ZydisStringAppendDecU32(string, (ZyanU32)value, padding_length));
#endif

    if (suffix)
    {
        return ZydisStringAppend(string, suffix);
    }
    return ZYAN_STATUS_SUCCESS;
}

ZyanStatus ZydisStringAppendHexU(ZyanString* string, ZyanU64 value, ZyanU8 padding_length,
    ZyanBool force_leading_number, ZyanBool uppercase, const ZyanStringView* prefix,
    const ZyanStringView* suffix)
{
    if (prefix)
    {
        ZYAN_CHECK(ZydisStringAppend(string, prefix));
    }

#if defined(ZYAN_X64) || defined(ZYAN_AARCH64) || defined(ZYAN_PPC64) || defined(ZYAN_RISCV64) || defined(ZYAN_LOONGARCH)
    ZYAN_CHECK(ZydisStringAppendHexU64(string, value, padding_length, force_leading_number,
        uppercase));
#else
    if (value & 0xFFFFFFFF00000000)
    {
        ZYAN_CHECK(ZydisStringAppendHexU64(string, value, padding_length, force_leading_number,
            uppercase));
    }
    else
    {
        ZYAN_CHECK(ZydisStringAppendHexU32(string, (ZyanU32)value, padding_length,
            force_leading_number, uppercase));
    }
#endif

    if (suffix)
    {
        return ZydisStringAppend(string, suffix);
    }
    return ZYAN_STATUS_SUCCESS;
}

/* ---------------------------------------------------------------------------------------------- */

/* ============================================================================================== */

//
// Source file: /home/ath/devel/zydis/src/Utils.c
//

/***************************************************************************************************

  Zyan Disassembler Library (Zydis)

  Original Author : Florian Bernd

 * Permission is hereby granted, free of charge, to any person obtaining a copy
 * of this software and associated documentation files (the "Software"), to deal
 * in the Software without restriction, including without limitation the rights
 * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
 * copies of the Software, and to permit persons to whom the Software is
 * furnished to do so, subject to the following conditions:
 *
 * The above copyright notice and this permission notice shall be included in all
 * copies or substantial portions of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
 * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
 * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
 * SOFTWARE.

***************************************************************************************************/


/* ============================================================================================== */
/* Exported functions                                                                             */
/* ============================================================================================== */

/* ---------------------------------------------------------------------------------------------- */
/* Address calculation                                                                            */
/* ---------------------------------------------------------------------------------------------- */

// Signed integer overflow is expected behavior in this function, for wrapping around the
// instruction pointer on jumps right at the end of the address space.
ZYAN_NO_SANITIZE("signed-integer-overflow")
ZyanStatus ZydisCalcAbsoluteAddress(const ZydisDecodedInstruction* instruction,
    const ZydisDecodedOperand* operand, ZyanU64 runtime_address, ZyanU64* result_address)
{
    if (!instruction || !operand || !result_address)
    {
        return ZYAN_STATUS_INVALID_ARGUMENT;
    }

    switch (operand->type)
    {
    case ZYDIS_OPERAND_TYPE_MEMORY:
        if (!operand->mem.disp.has_displacement)
        {
            return ZYAN_STATUS_INVALID_ARGUMENT;
        }
        if (operand->mem.base == ZYDIS_REGISTER_EIP)
        {
            *result_address = ((ZyanU32)runtime_address + instruction->length +
                (ZyanU32)operand->mem.disp.value);
            return ZYAN_STATUS_SUCCESS;
        }
        if (operand->mem.base == ZYDIS_REGISTER_RIP)
        {
            *result_address = (ZyanU64)(runtime_address + instruction->length +
                operand->mem.disp.value);
            return ZYAN_STATUS_SUCCESS;
        }
        if ((operand->mem.base == ZYDIS_REGISTER_NONE) &&
            (operand->mem.index == ZYDIS_REGISTER_NONE))
        {
            switch (instruction->address_width)
            {
            case 16:
                *result_address = (ZyanU64)operand->mem.disp.value & 0x000000000000FFFF;
                return ZYAN_STATUS_SUCCESS;
            case 32:
                *result_address = (ZyanU64)operand->mem.disp.value & 0x00000000FFFFFFFF;
                return ZYAN_STATUS_SUCCESS;
            case 64:
                *result_address = (ZyanU64)operand->mem.disp.value;
                return ZYAN_STATUS_SUCCESS;
            default:
                return ZYAN_STATUS_INVALID_ARGUMENT;
            }
        }
        break;
    case ZYDIS_OPERAND_TYPE_IMMEDIATE:
        if (operand->imm.is_signed && operand->imm.is_relative)
        {
            *result_address = (ZyanU64)((ZyanI64)runtime_address + instruction->length +
                operand->imm.value.s);
            switch (instruction->machine_mode)
            {
            case ZYDIS_MACHINE_MODE_LONG_COMPAT_16:
            case ZYDIS_MACHINE_MODE_LEGACY_16:
            case ZYDIS_MACHINE_MODE_REAL_16:
            case ZYDIS_MACHINE_MODE_LONG_COMPAT_32:
            case ZYDIS_MACHINE_MODE_LEGACY_32:
                // `XBEGIN` is a special case as it doesn't truncate computed address
                // This behavior is documented by Intel (SDM Vol. 2C):
                // Use of the 16-bit operand size does not cause this address to be truncated to
                // 16 bits, unlike a near jump to a relative offset.
                if ((instruction->operand_width == 16) &&
                    (instruction->mnemonic != ZYDIS_MNEMONIC_XBEGIN))
                {
                    *result_address &= 0xFFFF;
                }
                break;
            case ZYDIS_MACHINE_MODE_LONG_64:
                break;
            default:
                return ZYAN_STATUS_INVALID_ARGUMENT;
            }
            return ZYAN_STATUS_SUCCESS;
        }
        break;
    default:
        break;
    }

    return ZYAN_STATUS_INVALID_ARGUMENT;
}

ZyanStatus ZydisCalcAbsoluteAddressEx(const ZydisDecodedInstruction* instruction,
    const ZydisDecodedOperand* operand, ZyanU64 runtime_address,
    const ZydisRegisterContext* register_context, ZyanU64* result_address)
{
    // TODO: Test this with AGEN/MIB operands
    // TODO: Add support for Gather/Scatter instructions

    if (!instruction || !operand || !register_context || !result_address)
    {
        return ZYAN_STATUS_INVALID_ARGUMENT;
    }

    if ((operand->type != ZYDIS_OPERAND_TYPE_MEMORY) ||
        ((operand->mem.base == ZYDIS_REGISTER_NONE) &&
         (operand->mem.index == ZYDIS_REGISTER_NONE)) ||
        (operand->mem.base == ZYDIS_REGISTER_EIP) ||
        (operand->mem.base == ZYDIS_REGISTER_RIP))
    {
        return ZydisCalcAbsoluteAddress(instruction, operand, runtime_address, result_address);
    }

    ZyanU64 value = operand->mem.disp.value;
    if (operand->mem.base)
    {
        value += register_context->values[operand->mem.base];
    }
    if (operand->mem.index)
    {
        value += register_context->values[operand->mem.index] * operand->mem.scale;
    }

    switch (instruction->address_width)
    {
    case 16:
        *result_address = value & 0x000000000000FFFF;
        return ZYAN_STATUS_SUCCESS;
    case 32:
        *result_address = value & 0x00000000FFFFFFFF;
        return ZYAN_STATUS_SUCCESS;
    case 64:
        *result_address = value;
        return ZYAN_STATUS_SUCCESS;
    default:
        return ZYAN_STATUS_INVALID_ARGUMENT;
    }
}

/* ============================================================================================== */

//
// Source file: /home/ath/devel/zydis/src/Zydis.c
//

/***************************************************************************************************

  Zyan Disassembler Library (Zydis)

  Original Author : Florian Bernd

 * Permission is hereby granted, free of charge, to any person obtaining a copy
 * of this software and associated documentation files (the "Software"), to deal
 * in the Software without restriction, including without limitation the rights
 * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
 * copies of the Software, and to permit persons to whom the Software is
 * furnished to do so, subject to the following conditions:
 *
 * The above copyright notice and this permission notice shall be included in all
 * copies or substantial portions of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
 * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
 * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
 * SOFTWARE.

***************************************************************************************************/


/* ============================================================================================== */
/* Exported functions                                                                             */
/* ============================================================================================== */

ZyanU64 ZydisGetVersion(void)
{
    return ZYDIS_VERSION;
}

ZyanStatus ZydisIsFeatureEnabled(ZydisFeature feature)
{
    switch (feature)
    {
    case ZYDIS_FEATURE_DECODER:
#ifndef ZYDIS_DISABLE_DECODER
        return ZYAN_STATUS_TRUE;
#else
        return ZYAN_STATUS_FALSE;
#endif
    case ZYDIS_FEATURE_ENCODER:
#ifndef ZYDIS_DISABLE_ENCODER
        return ZYAN_STATUS_TRUE;
#else
        return ZYAN_STATUS_FALSE;
#endif
    case ZYDIS_FEATURE_FORMATTER:
#ifndef ZYDIS_DISABLE_FORMATTER
        return ZYAN_STATUS_TRUE;
#else
        return ZYAN_STATUS_FALSE;
#endif
    case ZYDIS_FEATURE_AVX512:
#ifndef ZYDIS_DISABLE_AVX512
        return ZYAN_STATUS_TRUE;
#else
        return ZYAN_STATUS_FALSE;
#endif

    case ZYDIS_FEATURE_KNC:
#ifndef ZYDIS_DISABLE_KNC
        return ZYAN_STATUS_TRUE;
#else
        return ZYAN_STATUS_FALSE;
#endif

    case ZYDIS_FEATURE_SEGMENT:
#ifndef ZYDIS_DISABLE_SEGMENT
        return ZYAN_STATUS_TRUE;
#else
        return ZYAN_STATUS_FALSE;
#endif

    default:
        return ZYAN_STATUS_INVALID_ARGUMENT;
    }
}

/* ============================================================================================== */
